#!/usr/local/bin/scheme --program

; @generated by Idris 0.5.1-b56440256, Chez backend
(import (chezscheme))
(case (machine-type)
  [(i3fb ti3fb a6fb ta6fb) #f]
  [(i3le ti3le a6le ta6le tarm64le) (load-shared-object "libc.so.6")]
  [(i3osx ti3osx a6osx ta6osx tarm64osx) (load-shared-object "libc.dylib")]
  [(i3nt ti3nt a6nt ta6nt) (load-shared-object "msvcrt.dll")]
  [else (load-shared-object "libc.so")])



(let ()
(define (blodwen-os)
  (case (machine-type)
    [(i3le ti3le a6le ta6le) "unix"]  ; GNU/Linux
    [(i3ob ti3ob a6ob ta6ob) "unix"]  ; OpenBSD
    [(i3fb ti3fb a6fb ta6fb) "unix"]  ; FreeBSD
    [(i3nb ti3nb a6nb ta6nb) "unix"]  ; NetBSD
    [(i3osx ti3osx a6osx ta6osx tarm64osx) "darwin"]
    [(i3nt ti3nt a6nt ta6nt) "windows"]
    [else "unknown"]))

(define blodwen-lazy
  (lambda (f)
    (let ([evaluated #f] [res void])
      (lambda ()
        (if (not evaluated)
            (begin (set! evaluated #t)
                   (set! res (f))
                   (set! f void))
            (void))
        res))))

(define blodwen-toSignedInt
  (lambda (x bits)
    (if (logbit? bits x)
        (logor x (ash (- 1) bits))
        (logand x (- (ash 1 bits) 1)))))

(define blodwen-toUnsignedInt
  (lambda (x bits)
    (modulo x (ash 1 bits))))


(define bu+ (lambda (x y bits) (blodwen-toUnsignedInt (+ x y) bits)))
(define bu- (lambda (x y bits) (blodwen-toUnsignedInt (- x y) bits)))
(define bu* (lambda (x y bits) (blodwen-toUnsignedInt (* x y) bits)))
(define bu/ (lambda (x y bits) (blodwen-toUnsignedInt (quotient x y) bits)))

(define bs+ (lambda (x y bits) (blodwen-toSignedInt (+ x y) bits)))
(define bs- (lambda (x y bits) (blodwen-toSignedInt (- x y) bits)))
(define bs* (lambda (x y bits) (blodwen-toSignedInt (* x y) bits)))
(define bs/ (lambda (x y bits) (blodwen-toSignedInt (quotient x y) bits)))

(define b+ (lambda (x y bits) (remainder (+ x y) (ash 1 bits))))
(define b- (lambda (x y bits) (remainder (- x y) (ash 1 bits))))
(define b* (lambda (x y bits) (remainder (* x y) (ash 1 bits))))
(define b/ (lambda (x y bits) (remainder (exact-floor (/ x y)) (ash 1 bits))))

(define integer->bits8 (lambda (x) (modulo x (expt 2 8))))
(define integer->bits16 (lambda (x) (modulo x (expt 2 16))))
(define integer->bits32 (lambda (x) (modulo x (expt 2 32))))
(define integer->bits64 (lambda (x) (modulo x (expt 2 64))))

(define bits16->bits8 (lambda (x) (modulo x (expt 2 8))))
(define bits32->bits8 (lambda (x) (modulo x (expt 2 8))))
(define bits32->bits16 (lambda (x) (modulo x (expt 2 16))))
(define bits64->bits8 (lambda (x) (modulo x (expt 2 8))))
(define bits64->bits16 (lambda (x) (modulo x (expt 2 16))))
(define bits64->bits32 (lambda (x) (modulo x (expt 2 32))))

(define blodwen-bits-shl-signed (lambda (x y bits) (blodwen-toSignedInt (ash x y) bits)))

(define blodwen-bits-shl (lambda (x y bits) (remainder (ash x y) (ash 1 bits))))

(define blodwen-shl (lambda (x y) (ash x y)))
(define blodwen-shr (lambda (x y) (ash x (- y))))
(define blodwen-and (lambda (x y) (logand x y)))
(define blodwen-or (lambda (x y) (logor x y)))
(define blodwen-xor (lambda (x y) (logxor x y)))

(define cast-num
  (lambda (x)
    (if (number? x) x 0)))
(define destroy-prefix
  (lambda (x)
    (cond
      ((equal? x "") "")
      ((equal? (string-ref x 0) #\#) "")
      (else x))))

(define exact-floor
  (lambda (x)
    (inexact->exact (floor x))))

(define exact-truncate
  (lambda (x)
    (inexact->exact (truncate x))))

(define exact-truncate-boundedInt
  (lambda (x y)
    (blodwen-toSignedInt (exact-truncate x) y)))

(define exact-truncate-boundedUInt
  (lambda (x y)
    (blodwen-toUnsignedInt (exact-truncate x) y)))

(define cast-char-boundedInt
  (lambda (x y)
    (blodwen-toSignedInt (char->integer x) y)))

(define cast-char-boundedUInt
  (lambda (x y)
    (blodwen-toUnsignedInt (char->integer x) y)))

(define cast-string-int
  (lambda (x)
    (exact-truncate (cast-num (string->number (destroy-prefix x))))))

(define cast-string-boundedInt
  (lambda (x y)
    (blodwen-toSignedInt (cast-string-int x) y)))

(define cast-string-boundedUInt
  (lambda (x y)
    (blodwen-toUnsignedInt (cast-string-int x) y)))

(define cast-int-char
  (lambda (x)
    (if (or
          (and (>= x 0) (<= x #xd7ff))
          (and (>= x #xe000) (<= x #x10ffff)))
        (integer->char x)
        (integer->char 0))))

(define cast-string-double
  (lambda (x)
    (cast-num (string->number (destroy-prefix x)))))

(define (string-concat xs) (apply string-append xs))
(define (string-unpack s) (string->list s))
(define (string-pack xs) (list->string xs))

(define string-cons (lambda (x y) (string-append (string x) y)))
(define string-reverse (lambda (x)
  (list->string (reverse (string->list x)))))
(define (string-substr off len s)
    (let* ((l (string-length s))
          (b (max 0 off))
          (x (max 0 len))
          (end (min l (+ b x))))
          (if (> b l)
              ""
              (substring s b end))))

(define (blodwen-string-iterator-new s)
  0)

(define (blodwen-string-iterator-to-string _ s ofs f)
  (f (substring s ofs (string-length s))))

(define (blodwen-string-iterator-next s ofs)
  (if (>= ofs (string-length s))
      '() ; EOF
      (cons (string-ref s ofs) (+ ofs 1))))

(define either-left
  (lambda (x)
    (vector 0 x)))

(define either-right
  (lambda (x)
    (vector 1 x)))

(define blodwen-error-quit
  (lambda (msg)
    (display msg)
    (newline)
    (exit 1)))

(define (blodwen-get-line p)
    (if (port? p)
        (let ((str (get-line p)))
            (if (eof-object? str)
                ""
                str))
        void))

(define (blodwen-get-char p)
    (if (port? p)
        (let ((chr (get-char p)))
            (if (eof-object? chr)
                #\nul
                chr))
        void))

;; Buffers

(define (blodwen-new-buffer size)
  (make-bytevector size 0))

(define (blodwen-buffer-size buf)
  (bytevector-length buf))

(define (blodwen-buffer-setbyte buf loc val)
  (bytevector-u8-set! buf loc val))

(define (blodwen-buffer-getbyte buf loc)
  (bytevector-u8-ref buf loc))

(define (blodwen-buffer-setbits16 buf loc val)
  (bytevector-u16-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getbits16 buf loc)
  (bytevector-u16-ref buf loc (native-endianness)))

(define (blodwen-buffer-setbits32 buf loc val)
  (bytevector-u32-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getbits32 buf loc)
  (bytevector-u32-ref buf loc (native-endianness)))

(define (blodwen-buffer-setbits64 buf loc val)
  (bytevector-u64-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getbits64 buf loc)
  (bytevector-u64-ref buf loc (native-endianness)))

(define (blodwen-buffer-setint32 buf loc val)
  (bytevector-s32-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getint32 buf loc)
  (bytevector-s32-ref buf loc (native-endianness)))

(define (blodwen-buffer-setint buf loc val)
  (bytevector-s64-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getint buf loc)
  (bytevector-s64-ref buf loc (native-endianness)))

(define (blodwen-buffer-setdouble buf loc val)
  (bytevector-ieee-double-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getdouble buf loc)
  (bytevector-ieee-double-ref buf loc (native-endianness)))

(define (blodwen-stringbytelen str)
  (bytevector-length (string->utf8 str)))

(define (blodwen-buffer-setstring buf loc val)
  (let* [(strvec (string->utf8 val))
         (len (bytevector-length strvec))]
    (bytevector-copy! strvec 0 buf loc len)))

(define (blodwen-buffer-getstring buf loc len)
  (let [(newvec (make-bytevector len))]
    (bytevector-copy! buf loc newvec 0 len)
    (utf8->string newvec)))

(define (blodwen-buffer-copydata buf start len dest loc)
  (bytevector-copy! buf start dest loc len))

;; Threads

(define-record thread-handle (semaphore))

(define (blodwen-thread proc)
  (let [(sema (blodwen-make-semaphore 0))]
    (fork-thread (lambda () (proc (vector 0)) (blodwen-semaphore-post sema)))
    (make-thread-handle sema)
    ))

(define (blodwen-thread-wait handle)
  (blodwen-semaphore-wait (thread-handle-semaphore handle)))

;; Thread mailboxes

(define blodwen-thread-data
  (make-thread-parameter #f))

(define (blodwen-get-thread-data ty)
  (blodwen-thread-data))

(define (blodwen-set-thread-data ty a)
  (blodwen-thread-data a))

;; Semaphore

(define-record semaphore (box mutex condition))

(define (blodwen-make-semaphore init)
  (make-semaphore (box init) (make-mutex) (make-condition)))

(define (blodwen-semaphore-post sema)
  (with-mutex (semaphore-mutex sema)
    (let [(sema-box (semaphore-box sema))]
      (set-box! sema-box (+ (unbox sema-box) 1))
      (condition-signal (semaphore-condition sema))
    )))

(define (blodwen-semaphore-wait sema)
  (with-mutex (semaphore-mutex sema)
    (let [(sema-box (semaphore-box sema))]
      (when (= (unbox sema-box) 0)
        (condition-wait (semaphore-condition sema) (semaphore-mutex sema)))
      (set-box! sema-box (- (unbox sema-box) 1))
      )))

;; Barrier

(define-record barrier (count-box num-threads mutex cond))

(define (blodwen-make-barrier num-threads)
  (make-barrier (box 0) num-threads (make-mutex) (make-condition)))

(define (blodwen-barrier-wait barrier)
  (let [(count-box (barrier-count-box barrier))
        (num-threads (barrier-num-threads barrier))
        (mutex (barrier-mutex barrier))
        (condition (barrier-cond barrier))]
    (with-mutex mutex
    (let* [(count-old (unbox count-box))
           (count-new (+ count-old 1))]
      (set-box! count-box count-new)
      (if (= count-new num-threads)
          (condition-broadcast condition)
          (condition-wait condition mutex))
      ))))

;; Channel
; With thanks to Alain Zscheile (@zseri) for help with understanding condition
; variables, and figuring out where the problems were and how to solve them.

(define-record channel (read-mut read-cv read-box val-cv val-box))

(define (blodwen-make-channel ty)
  (make-channel
    (make-mutex)
    (make-condition)
    (box #t)
    (make-condition)
    (box '())
    ))

; block on the read status using read-cv until the value has been read
(define (channel-put-while-helper chan)
  (let ([read-mut (channel-read-mut chan)]
        [read-box (channel-read-box chan)]
        [read-cv  (channel-read-cv  chan)]
        )
    (if (unbox read-box)
      (void)    ; val has been read, so everything is fine
      (begin    ; otherwise, block/spin with cv
        (condition-wait read-cv read-mut)
        (channel-put-while-helper chan)
        )
      )))

(define (blodwen-channel-put ty chan val)
  (with-mutex (channel-read-mut chan)
    (channel-put-while-helper chan)
    (let ([read-box (channel-read-box chan)]
          [val-box  (channel-val-box  chan)]
          )
      (set-box! val-box val)
      (set-box! read-box #f)
      ))
  (condition-signal (channel-val-cv chan))
  )

; block on the value until it has been set
(define (channel-get-while-helper chan)
  (let ([read-mut (channel-read-mut chan)]
        [read-box (channel-read-box chan)]
        [val-cv   (channel-val-cv   chan)]
        )
    (if (unbox read-box)
      (begin
        (condition-wait val-cv read-mut)
        (channel-get-while-helper chan)
        )
      (void)
      )))

(define (blodwen-channel-get ty chan)
  (mutex-acquire (channel-read-mut chan))
  (channel-get-while-helper chan)
  (let* ([val-box  (channel-val-box  chan)]
         [read-box (channel-read-box chan)]
         [read-cv  (channel-read-cv  chan)]
         [the-val  (unbox val-box)]
         )
    (set-box! val-box '())
    (set-box! read-box #t)
    (mutex-release (channel-read-mut chan))
    (condition-signal read-cv)
    the-val))

;; Mutex

(define (blodwen-make-mutex)
  (make-mutex))
(define (blodwen-mutex-acquire mutex)
  (mutex-acquire mutex))
(define (blodwen-mutex-release mutex)
  (mutex-release mutex))

;; Condition variable

(define (blodwen-make-condition)
  (make-condition))
(define (blodwen-condition-wait condition mutex)
  (condition-wait condition mutex))
(define (blodwen-condition-wait-timeout condition mutex timeout)
  (let* [(sec (div timeout 1000000))
         (micro (mod timeout 1000000))]
    (condition-wait condition mutex (make-time 'time-duration (* 1000 micro) sec))))
(define (blodwen-condition-signal condition)
  (condition-signal condition))
(define (blodwen-condition-broadcast condition)
  (condition-broadcast condition))

;; Future

(define-record future-internal (result ready mutex signal))
(define (blodwen-make-future work)
  (let ([future (make-future-internal #f #f (make-mutex) (make-condition))])
    (fork-thread (lambda ()
      (let ([result (work)])
        (with-mutex (future-internal-mutex future)
          (set-future-internal-result! future result)
          (set-future-internal-ready! future #t)
          (condition-broadcast (future-internal-signal future))))))
    future))
(define (blodwen-await-future ty future)
  (let ([mutex (future-internal-mutex future)])
    (with-mutex mutex
      (if (not (future-internal-ready future))
          (condition-wait (future-internal-signal future) mutex))
      (future-internal-result future))))

(define (blodwen-sleep s) (sleep (make-time 'time-duration 0 s)))
(define (blodwen-usleep s)
  (let ((sec (div s 1000000))
        (micro (mod s 1000000)))
       (sleep (make-time 'time-duration (* 1000 micro) sec))))

(define (blodwen-clock-time-utc) (current-time 'time-utc))
(define (blodwen-clock-time-monotonic) (current-time 'time-monotonic))
(define (blodwen-clock-time-duration) (current-time 'time-duration))
(define (blodwen-clock-time-process) (current-time 'time-process))
(define (blodwen-clock-time-thread) (current-time 'time-thread))
(define (blodwen-clock-time-gccpu) (current-time 'time-collector-cpu))
(define (blodwen-clock-time-gcreal) (current-time 'time-collector-real))
(define (blodwen-is-time? clk) (if (time? clk) 1 0))
(define (blodwen-clock-second time) (time-second time))
(define (blodwen-clock-nanosecond time) (time-nanosecond time))


(define (blodwen-arg-count)
  (length (command-line)))

(define (blodwen-arg n)
  (if (< n (length (command-line))) (list-ref (command-line) n) ""))

(define (blodwen-hasenv var)
  (if (eq? (getenv var) #f) 0 1))

;; Randoms
(define random-seed-register 0)
(define (initialize-random-seed-once)
  (if (= (virtual-register random-seed-register) 0)
      (let ([seed (time-nanosecond (current-time))])
        (set-virtual-register! random-seed-register seed)
        (random-seed seed))))

(define (blodwen-random-seed seed)
  (set-virtual-register! random-seed-register seed)
  (random-seed seed))
(define blodwen-random
  (case-lambda
    ;; no argument, pick a real value from [0, 1.0)
    [() (begin
          (initialize-random-seed-once)
          (random 1.0))]
    ;; single argument k, pick an integral value from [0, k)
    [(k)
      (begin
        (initialize-random-seed-once)
        (if (> k 0)
              (random k)
              (assertion-violationf 'blodwen-random "invalid range argument ~a" k)))]))

;; For finalisers

(define blodwen-finaliser (make-guardian))
(define (blodwen-register-object obj proc)
  (let [(x (cons obj proc))]
       (blodwen-finaliser x)
       x))
(define blodwen-run-finalisers
  (lambda ()
    (let run ()
      (let ([x (blodwen-finaliser)])
        (when x
          (((cdr x) (car x)) 'erased)
          (run))))))

;; For creating and reading back scheme objects

; read a scheme string and evaluate it, returning 'Just result' on success
; TODO: catch exception!
(define (blodwen-eval-scheme str)
  (guard
     (x [#t '()]) ; Nothing on failure
     (box (eval (read (open-input-string str)))))
  ); box == Just

(define (blodwen-eval-okay obj)
  (if (null? obj)
      0
      1))

(define (blodwen-get-eval-result obj)
  (unbox obj))

(define (blodwen-debug-scheme obj)
  (display obj) (newline))

(define (blodwen-is-number obj)
  (if (number? obj) 1 0))

(define (blodwen-is-integer obj)
  (if (and (number? obj) (exact? obj)) 1 0))

(define (blodwen-is-float obj)
  (if (flonum? obj) 1 0))

(define (blodwen-is-char obj)
  (if (char? obj) 1 0))

(define (blodwen-is-string obj)
  (if (string? obj) 1 0))

(define (blodwen-is-procedure obj)
  (if (procedure? obj) 1 0))

(define (blodwen-is-symbol obj)
  (if (symbol? obj) 1 0))

(define (blodwen-is-vector obj)
  (if (vector? obj) 1 0))

(define (blodwen-is-nil obj)
  (if (null? obj) 1 0))

(define (blodwen-is-pair obj)
  (if (pair? obj) 1 0))

(define (blodwen-is-box obj)
  (if (box? obj) 1 0))

(define (blodwen-make-symbol str)
  (string->symbol str))

; The below rely on checking that the objects are the right type first.

(define (blodwen-vector-ref obj i)
  (vector-ref obj i))

(define (blodwen-vector-length obj)
  (vector-length obj))

(define (blodwen-vector-list obj)
  (vector->list obj))

(define (blodwen-unbox obj)
  (unbox obj))

(define (blodwen-apply obj arg)
  (obj arg))

(define (blodwen-force obj)
  (obj))

(define (blodwen-read-symbol sym)
  (symbol->string sym))

(define (blodwen-id x) x)
(define SystemC-45FileC-45Virtual-prim__stdout (lambda () ((foreign-procedure "idris2_stdout" () void*) )))
(define SystemC-45FileC-45Virtual-prim__stdin (lambda () ((foreign-procedure "idris2_stdin" () void*) )))
(define PreludeC-45Types-fastUnpack (lambda (farg-0) (string-unpack farg-0)))
(define PreludeC-45Types-fastPack (lambda (farg-0) (string-pack farg-0)))
(define PreludeC-45Types-fastConcat (lambda (farg-0) (string-concat farg-0)))
(define PrimIO-prim__nullAnyPtr (lambda (farg-0) ((foreign-procedure "idris2_isNull" (void*) int) farg-0)))
(define PreludeC-45IO-prim__putStr (lambda (farg-0 farg-1) ((foreign-procedure "idris2_putStr" (string) void) farg-0) (vector 0 )))
(define PreludeC-45IO-prim__putChar (lambda (farg-0 farg-1) ((foreign-procedure "putchar" (char) void) farg-0) (vector 0 )))
(define PreludeC-45IO-prim__getString (lambda (farg-0) ((foreign-procedure "idris2_getString" (void*) string) farg-0)))
(define PreludeC-45IO-prim__getStr (lambda (farg-0) ((foreign-procedure "idris2_getStr" () string) )))
(define PreludeC-45IO-prim__getChar (lambda (farg-0) ((foreign-procedure "getchar" () char) )))
(define SystemC-45FileC-45ReadWrite-prim__writeLine (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idris2_writeLine" (void* string) int) farg-0 farg-1)))
(define SystemC-45FileC-45ReadWrite-prim__seekLine (lambda (farg-0 farg-1) ((foreign-procedure "idris2_seekLine" (void*) int) farg-0)))
(define SystemC-45FileC-45ReadWrite-prim__removeFile (lambda (farg-0 farg-1) ((foreign-procedure "idris2_removeFile" (string) int) farg-0)))
(define SystemC-45FileC-45ReadWrite-prim__readLine (lambda (farg-0 farg-1) ((foreign-procedure "idris2_readLine" (void*) void*) farg-0)))
(define SystemC-45FileC-45ReadWrite-prim__readChar (lambda (farg-0 farg-1) ((foreign-procedure "fgetc" (void*) int) farg-0)))
(define SystemC-45FileC-45ReadWrite-prim__eof (lambda (farg-0 farg-1) ((foreign-procedure "idris2_eof" (void*) int) farg-0)))
(define SystemC-45FileC-45Error-prim__fileErrno (lambda (farg-0) ((foreign-procedure "idris2_fileErrno" () int) )))
(define SystemC-45FileC-45Error-prim__error (lambda (farg-0 farg-1) ((foreign-procedure "idris2_fileError" (void*) int) farg-0)))
(define SystemC-45Errno-prim__strerror (lambda (farg-0 farg-1) ((foreign-procedure "idris2_strerror" (int) string) farg-0)))
(define SystemC-45Errno-prim__getErrno (lambda (farg-0) ((foreign-procedure "idris2_getErrno" () int) )))
(define SystemC-45FileC-45Handle-prim__open (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idris2_openFile" (string string) void*) farg-0 farg-1)))
(define SystemC-45FileC-45Handle-prim__close (lambda (farg-0 farg-1) ((foreign-procedure "idris2_closeFile" (void*) void) farg-0) (vector 0 )))
(define SystemC-45FileC-45Process-prim__popen (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idris2_popen" (string string) void*) farg-0 farg-1)))
(define SystemC-45FileC-45Process-prim__pclose (lambda (farg-0 farg-1) ((foreign-procedure "idris2_pclose" (void*) void) farg-0) (vector 0 )))
(define SystemC-45FileC-45Process-prim__flush (lambda (farg-0 farg-1) ((foreign-procedure "fflush" (void*) int) farg-0)))
(define SystemC-45FileC-45Permissions-prim__chmod (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idris2_chmod" (string int) int) farg-0 farg-1)))
(define SystemC-45FileC-45Meta-prim__fileSize (lambda (farg-0 farg-1) ((foreign-procedure "idris2_fileSize" (void*) int) farg-0)))
(define SystemC-45FileC-45Meta-prim__fileModifiedTime (lambda (farg-0 farg-1) ((foreign-procedure "idris2_fileModifiedTime" (void*) int) farg-0)))
(define SystemC-45FileC-45Buffer-prim__writeBufferData (lambda (farg-0 farg-1 farg-2 farg-3 farg-4) ((foreign-procedure "idris2_writeBufferData" (void* u8* int int) int) farg-0 farg-1 farg-2 farg-3)))
(define SystemC-45FileC-45Buffer-prim__readBufferData (lambda (farg-0 farg-1 farg-2 farg-3 farg-4) ((foreign-procedure "idris2_readBufferData" (void* u8* int int) int) farg-0 farg-1 farg-2 farg-3)))
(define DataC-45Buffer-stringByteLength (lambda (farg-0) (blodwen-stringbytelen farg-0)))
(define DataC-45Buffer-prim__setString (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-setstring farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__setInt (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-setint farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__setDouble (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-setdouble farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__setByte (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-setbyte farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__newBuffer (lambda (farg-0 farg-1) (blodwen-new-buffer farg-0)))
(define DataC-45Buffer-prim__getString (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-getstring farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__getInt (lambda (farg-0 farg-1 farg-2) (blodwen-buffer-getint farg-0 farg-1)))
(define DataC-45Buffer-prim__getDouble (lambda (farg-0 farg-1 farg-2) (blodwen-buffer-getdouble farg-0 farg-1)))
(define DataC-45Buffer-prim__getByte (lambda (farg-0 farg-1 farg-2) (blodwen-buffer-getbyte farg-0 farg-1)))
(define DataC-45Buffer-prim__copyData (lambda (farg-0 farg-1 farg-2 farg-3 farg-4 farg-5) (blodwen-buffer-copydata farg-0 farg-1 farg-2 farg-3 farg-4)))
(define DataC-45Buffer-prim__bufferSize (lambda (farg-0) (blodwen-buffer-size farg-0)))
(define SystemC-45Directory-prim__openDir (lambda (farg-0 farg-1) ((foreign-procedure "idris2_openDir" (string) void*) farg-0)))
(define SystemC-45Directory-prim__dirEntry (lambda (farg-0 farg-1) ((foreign-procedure "idris2_nextDirEntry" (void*) void*) farg-0)))
(define SystemC-45Directory-prim__currentDir (lambda (farg-0) ((foreign-procedure "idris2_currentDirectory" () void*) )))
(define SystemC-45Directory-prim__createDir (lambda (farg-0 farg-1) ((foreign-procedure "idris2_createDir" (string) int) farg-0)))
(define SystemC-45Directory-prim__closeDir (lambda (farg-0 farg-1) ((foreign-procedure "idris2_closeDir" (void*) void) farg-0) (vector 0 )))
(define SystemC-45Directory-prim__changeDir (lambda (farg-0 farg-1) ((foreign-procedure "idris2_changeDir" (string) int) farg-0)))
(define System-prim__system (lambda (farg-0 farg-1) ((foreign-procedure "idris2_system" (string) int) farg-0)))
(define System-prim__getEnv (lambda (farg-0 farg-1) ((foreign-procedure "getenv" (string) void*) farg-0)))
(define System-prim__getArgCount (lambda (farg-0) (blodwen-arg-count )))
(define System-prim__getArg (lambda (farg-0 farg-1) (blodwen-arg farg-0)))
(define System-prim__exit (lambda (farg-0 farg-1) ((foreign-procedure "exit" (int) void) farg-0) (vector 0 )))
(define LibrariesC-45UtilsC-45Scheme-unsafeVectorToList (lambda (farg-0) (blodwen-vector-list farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeVectorRef (lambda (farg-0 farg-1) (blodwen-vector-ref farg-0 farg-1)))
(define LibrariesC-45UtilsC-45Scheme-unsafeVectorLength (lambda (farg-0) (blodwen-vector-length farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeUnbox (lambda (farg-0) (blodwen-unbox farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeSnd (lambda (farg-0) (cdr farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeReadSymbol (lambda (farg-0) (blodwen-read-symbol farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeGetString (lambda (farg-0) (blodwen-id farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeGetInteger (lambda (farg-0) (blodwen-id farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeGetFloat (lambda (farg-0) (blodwen-id farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeGetChar (lambda (farg-0) (blodwen-id farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeFst (lambda (farg-0) (car farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeForce (lambda (farg-0) (blodwen-force farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeApply (lambda (farg-0 farg-1) (blodwen-apply farg-0 farg-1)))
(define LibrariesC-45UtilsC-45Scheme-prim_isVector (lambda (farg-0) (blodwen-is-vector farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isSymbol (lambda (farg-0) (blodwen-is-symbol farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isString (lambda (farg-0) (blodwen-is-string farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isProcedure (lambda (farg-0) (blodwen-is-procedure farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isPair (lambda (farg-0) (blodwen-is-pair farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isInteger (lambda (farg-0) (blodwen-is-integer farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isFloat (lambda (farg-0) (blodwen-is-float farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isChar (lambda (farg-0) (blodwen-is-char farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isBox (lambda (farg-0) (blodwen-is-box farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim__evalScheme (lambda (farg-0) (blodwen-eval-scheme farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim__evalResult (lambda (farg-0) (blodwen-get-eval-result farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim__evalOkay (lambda (farg-0) (blodwen-eval-okay farg-0)))
(define LibrariesC-45DataC-45StringC-45Iterator-uncons (lambda (farg-0 farg-1) (blodwen-string-iterator-next farg-0 farg-1)))
(define LibrariesC-45DataC-45StringC-45Iterator-fromString (lambda (farg-0) (blodwen-string-iterator-new farg-0)))
(define SystemC-45Clock-prim__osClockValid (lambda (farg-0 farg-1) (blodwen-is-time? farg-0)))
(define SystemC-45Clock-prim__osClockSecond (lambda (farg-0 farg-1) (blodwen-clock-second farg-0)))
(define SystemC-45Clock-prim__osClockNanosecond (lambda (farg-0 farg-1) (blodwen-clock-nanosecond farg-0)))
(define SystemC-45Clock-prim__clockTimeUtc (lambda (farg-0) (blodwen-clock-time-utc )))
(define SystemC-45Clock-prim__clockTimeThread (lambda (farg-0) (blodwen-clock-time-thread )))
(define SystemC-45Clock-prim__clockTimeProcess (lambda (farg-0) (blodwen-clock-time-process )))
(define SystemC-45Clock-prim__clockTimeMonotonic (lambda (farg-0) (blodwen-clock-time-monotonic )))
(define SystemC-45Clock-prim__clockTimeGcReal (lambda (farg-0) (blodwen-clock-time-gcreal )))
(define SystemC-45Clock-prim__clockTimeGcCpu (lambda (farg-0) (blodwen-clock-time-gccpu )))
(define LibrariesC-45UtilsC-45Term-prim__setupTerm (lambda (farg-0) ((foreign-procedure "idris2_setupTerm" () void) ) (vector 0 )))
(define LibrariesC-45UtilsC-45Term-prim__getTermCols (lambda (farg-0) ((foreign-procedure "idris2_getTermCols" () int) )))
(define SystemC-45FFI-prim__free (lambda (farg-0 farg-1) ((foreign-procedure "idris2_free" (void*) void) farg-0) (vector 0 )))
(define IdrisC-45IDEModeC-45REPL-prim__idrnet_fdopen (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idrnet_fdopen" (int string) void*) farg-0 farg-1)))
(define NetworkC-45SocketC-45Data-prim__idrnet_errno (lambda (farg-0) ((foreign-procedure "idrnet_errno" () int) )))
(define NetworkC-45SocketC-45Data-prim__idrnet_af_unspec (lambda (farg-0) ((foreign-procedure "idrnet_af_unspec" () int) )))
(define NetworkC-45SocketC-45Data-prim__idrnet_af_unix (lambda (farg-0) ((foreign-procedure "idrnet_af_unix" () int) )))
(define NetworkC-45SocketC-45Data-prim__idrnet_af_inet6 (lambda (farg-0) ((foreign-procedure "idrnet_af_inet6" () int) )))
(define NetworkC-45SocketC-45Data-prim__idrnet_af_inet (lambda (farg-0) ((foreign-procedure "idrnet_af_inet" () int) )))
(define NetworkC-45FFI-prim__idrnet_socket (lambda (farg-0 farg-1 farg-2 farg-3) ((foreign-procedure "idrnet_socket" (int int int) int) farg-0 farg-1 farg-2)))
(define NetworkC-45FFI-prim__idrnet_sockaddr_unix (lambda (farg-0 farg-1) ((foreign-procedure "idrnet_sockaddr_unix" (void*) string) farg-0)))
(define NetworkC-45FFI-prim__idrnet_sockaddr_ipv4 (lambda (farg-0 farg-1) ((foreign-procedure "idrnet_sockaddr_ipv4" (void*) string) farg-0)))
(define NetworkC-45FFI-prim__idrnet_sockaddr_family (lambda (farg-0 farg-1) ((foreign-procedure "idrnet_sockaddr_family" (void*) int) farg-0)))
(define NetworkC-45FFI-prim__idrnet_listen (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idrnet_listen" (int int) int) farg-0 farg-1)))
(define NetworkC-45FFI-prim__idrnet_create_sockaddr (lambda (farg-0) ((foreign-procedure "idrnet_create_sockaddr" () void*) )))
(define NetworkC-45FFI-prim__idrnet_bind (lambda (farg-0 farg-1 farg-2 farg-3 farg-4 farg-5) ((foreign-procedure "idrnet_bind" (int int int string int) int) farg-0 farg-1 farg-2 farg-3 farg-4)))
(define NetworkC-45FFI-prim__idrnet_accept (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idrnet_accept" (int void*) int) farg-0 farg-1)))
(define csegen-3302(blodwen-lazy (lambda () (lambda (u--d) (vector 0 (cons u--d '()))))))
(define csegen-1554(blodwen-lazy (lambda () (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (vector 7 ))))))
(define csegen-2374(blodwen-lazy (lambda () (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-name))))))
(define csegen-1879(blodwen-lazy (lambda () (lambda (u--nm) (PreludeC-45TypesC-45String-C-43C-43 " proof " (CoreC-45Name-u--show_Show_Name u--nm))))))
(define csegen-1959(blodwen-lazy (lambda () (lambda (u--x) (PreludeC-45Types-u--C-61C-61_Eq_Nat (Builtin-fst u--x) 0)))))
(define csegen-2154(blodwen-lazy (lambda () (lambda (u--x) (ControlC-45MonadC-45Identity-u--pure_Applicative_Identity (cons u--x u--x))))))
(define csegen-549(blodwen-lazy (lambda () (lambda (_-0) (box (+ 1 _-0))))))
(define csegen-186(blodwen-lazy (lambda () (lambda (__leftTupleSection-0) (lambda (__infixTupleSection-0) (cons __leftTupleSection-0 __infixTupleSection-0))))))
(define csegen-3413(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (IdrisC-45Syntax-applyArgs eta-0 eta-1))))))
(define csegen-551(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (CoreC-45TT-eqTerm eta-0 eta-1))))))
(define csegen-2828(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-lookupCtxtExact eta-0 eta-1))))))
(define csegen-537(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (DataC-45List-mapMaybe eta-0 eta-1))))))
(define csegen-269(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (CoreC-45NameC-45Namespace-mkNestedNamespace eta-0 eta-1))))))
(define csegen-2473(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45TypesC-45List-tailRecAppend eta-0 eta-1))))))
(define csegen-2344(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessBuiltin-termConMatch eta-0 eta-1))))))
(define csegen-3192(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45SortedSet-union eta-0 eta-1))))))
(define csegen-447(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 eta-0 eta-1))))))
(define csegen-363(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45Interfaces-u--C-60C-43C-62_Semigroup_C-40C-124UnitC-44MkUnitC-124C-41 eta-0 eta-1))))))
(define csegen-255(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (DecidableC-45Equality-u--decEq_DecEq_Int eta-0 eta-1))))))
(define csegen-2303(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45Types-u--map_Functor_List eta-0 eta-1))))))
(define csegen-4174(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45Types-u--max_Ord_Nat eta-0 eta-1))))))
(define csegen-188(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (cons eta-0 eta-1))))))
(define csegen-2302(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (cons eta-0 eta-1))))))
(define csegen-113(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (cons eta-0 eta-1))))))
(define csegen-525(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (cons eta-0 eta-1))))))
(define csegen-4204(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (vector 14 eta-0 eta-1))))))
(define csegen-1026(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (bs+ eta-0 eta-1 63))))))
(define csegen-979(blodwen-lazy (lambda () (lambda (eta-0) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45TT-u--show_Show_LazyReason eta-0))))))
(define csegen-2176(blodwen-lazy (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't happen: names don't match in pattern type") eta-0)))))
(define csegen-2611(blodwen-lazy (lambda () (lambda (eta-0) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) (Builtin-snd eta-0))))))
(define csegen-3794(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (cons '() ""))))))
(define csegen-1960(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (vector 1 (vector 0 "__")))))))
(define csegen-2497(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-4 (vector-ref eta-0 3))) e-4)))))
(define csegen-3565(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-1 (vector-ref eta-0 0))) e-1)))))
(define csegen-2327(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-1 (vector-ref eta-0 1))) e-1)))))
(define csegen-2326(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-3 (vector-ref eta-0 3))) e-3)))))
(define csegen-3592(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-0 (vector-ref eta-0 0))) e-0)))))
(define csegen-2829(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-1 (vector-ref eta-0 1))) e-1)))))
(define csegen-879(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-2 (vector-ref eta-0 2))) e-2)))))
(define csegen-2240(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-12 (vector-ref eta-0 12))) e-12)))))
(define csegen-881(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-17 (vector-ref eta-0 17))) e-17)))))
(define csegen-3261(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-2 (vector-ref eta-0 2))) e-2)))))
(define csegen-1949(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-2 (vector-ref eta-0 2))) e-2)))))
(define csegen-2722(blodwen-lazy (lambda () (lambda (eta-0) (let ((e-1 (vector-ref eta-0 1))) e-1)))))
(define csegen-855(blodwen-lazy (lambda () (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) e-3)))))
(define csegen-1224(blodwen-lazy (lambda () (PreludeC-45TypesC-45String-C-43C-43 "idris2-" (LibrariesC-45DataC-45Version-showVersion 0 (IdrisC-45Version-version))))))
(define csegen-2348(blodwen-lazy (lambda () (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") (ParserC-45RuleC-45Source-unqualifiedName)))))
(define csegen-3269(blodwen-lazy (lambda () (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) (vector 2 0) (ParserC-45RuleC-45Source-init)))))
(define csegen-365(blodwen-lazy (lambda () (cons (cons "End of input" '()) '()))))
(define csegen-3580(blodwen-lazy (lambda () (vector 0 (vector 2 ) (vector 2 "_" 0)))))
(define csegen-3591(blodwen-lazy (lambda () (vector 0 (vector 2 ) (vector 2 "lamc" 0)))))
(define csegen-583(blodwen-lazy (lambda () (vector '() '() '() '()))))
(define csegen-2080(blodwen-lazy (lambda () (vector '() 0 '() (vector 0 )))))
(define csegen-2204(blodwen-lazy (lambda () (vector 0 (CoreC-45NameC-45Namespace-builtinNS) (vector 1 (vector 0 "assert_total"))))))
(define csegen-1958(blodwen-lazy (lambda () (vector 0 (CoreC-45NameC-45Namespace-reflectionNS) (vector 1 (vector 0 "Elab"))))))
(define csegen-29(blodwen-lazy (lambda () (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 "prim__integerToNat"))))))
(define csegen-2721(blodwen-lazy (lambda () (vector 0 (vector 2 ) (vector 1 (vector 0 "main"))))))
(define csegen-4186(blodwen-lazy (lambda () (cons 0 (cons 1 '())))))
(define csegen-3907(blodwen-lazy (lambda () (cons "RefC" (cons "C" '())))))
(define csegen-3840(blodwen-lazy (lambda () (cons "libc" (cons "libc 6" '())))))
(define csegen-3786(blodwen-lazy (lambda () (cons "scheme" (cons "C" '())))))
(define csegen-4398(blodwen-lazy (lambda () (vector 1 (vector 0 (vector 27 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))))))))
(define csegen-1777(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-is #\.) (lambda () (ParserC-45LexerC-45Common-identNormal))))))
(define csegen-1758(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-is #\?) (lambda () (ParserC-45LexerC-45Common-identNormal))))))
(define csegen-115(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (eta-0 (eta-1 eta-2))))))))
(define csegen-256(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) eta-0 eta-1))))))
(define csegen-1286(blodwen-lazy (lambda () (lambda (eta-0) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) "Failed") eta-0))) (vector 1 act-24))))))
(define csegen-1250(blodwen-lazy (lambda () (lambda (eta-0) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) "Processing as TTImp") eta-0))) (vector 1 act-24))))))
(define csegen-1256(blodwen-lazy (lambda () (lambda (eta-0) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) "Written TTC") eta-0))) (vector 1 act-24))))))
(define csegen-2331(blodwen-lazy (lambda () (lambda (eta-0) (TTImpC-45ProcessData-hasArgs (+ 1 0) eta-0)))))
(define csegen-2852(blodwen-lazy (lambda () (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-1)) eta-0)))))
(define csegen-2078(blodwen-lazy (lambda () (lambda (eta-0) (box (vector 7 0 (CoreC-45ContextC-45Context-holeInit 0)))))))
(define csegen-413(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-escape (LibrariesC-45TextC-45Lexer-is #\\) (LibrariesC-45TextC-45Lexer-any)) (LibrariesC-45TextC-45Lexer-any)))))
(define csegen-302(blodwen-lazy (lambda () (LibrariesC-45TextC-45Quantity-exactly (+ 1 (+ 1 0))))))
(define csegen-4214(blodwen-lazy (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Package-exactProperty "version")))))
(define csegen-3300(blodwen-lazy (lambda () (vector 0 (csegen-2302)))))
(define csegen-1092(blodwen-lazy (lambda () (vector 0 (CoreC-45FC-emptyFC) '() (+ 1 0)))))
(define csegen-2477(blodwen-lazy (lambda () (vector 1 (cons '() (lambda (eta-0) (vector 1 '())))))))
(define csegen-2108(blodwen-lazy (lambda () (vector 1 (cons (vector 3 (vector 2 "Coverage check")) '())))))
(define csegen-1036(blodwen-lazy (lambda () (vector 1 (vector 22 (vector 1 (vector 0 "Type")) '())))))
(define csegen-1038(blodwen-lazy (lambda () (vector 1 (vector 22 (vector 1 (vector 0 "__")) '())))))
(define csegen-3908(blodwen-lazy (lambda () (lambda (u--a) (PreludeC-45TypesC-45String-C-43C-43 "arglist->args[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat u--a) "]"))))))
(define csegen-2144(blodwen-lazy (lambda () (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (ControlC-45MonadC-45Identity-u--map_Functor_Identity u--func arg-215))))))))
(define csegen-212(blodwen-lazy (lambda () (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (PreludeC-45Types-u--map_Functor_List u--func arg-215))))))))
(define csegen-366(blodwen-lazy (lambda () (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds u--func arg-215))))))))
(define csegen-836(blodwen-lazy (lambda () (lambda (u--n) (PreludeC-45TypesC-45String-C-43C-43 " (newtype by " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat u--n) ")"))))))
(define csegen-1408(blodwen-lazy (lambda () (lambda (u--x) (lambda (u--y) (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS u--x) (CoreC-45Name-dropNS u--y)))))))
(define csegen-2117(blodwen-lazy (lambda () (lambda (u--x) (cons (Builtin-fst u--x) (CoreC-45TT-u--weaken_Weaken_Term (Builtin-snd u--x)))))))
(define csegen-3920(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (LibrariesC-45DataC-45DList-snoc eta-0 eta-1 eta-2)))))))
(define csegen-2317(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 eta-2 eta-3))))))))
(define csegen-257(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (PreludeC-45Types-u--map_Functor_List eta-2 eta-3))))))))
(define csegen-4190(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (DataC-45List1-u--map_Functor_List1 eta-2 eta-3))))))))
(define csegen-73(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (PreludeC-45Types-u--map_Functor_Maybe eta-2 eta-3))))))))
(define csegen-360(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds eta-2 eta-3))))))))
(define csegen-3841(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim eta-0 eta-1 eta-2)))))))
(define csegen-3798(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim eta-0 eta-1 eta-2)))))))
(define csegen-3821(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim eta-0 eta-1 eta-2)))))))
(define csegen-1064(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (CoreC-45TT-fnType '() (CoreC-45FC-emptyFC) eta-0 eta-1))))))
(define csegen-545(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String " -> ") eta-0 eta-1))))))
(define csegen-2296(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (cons eta-1 eta-2))))))))
(define csegen-2476(blodwen-lazy (lambda () (lambda (eta-0) (csegen-2477)))))
(define csegen-2583(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Couldn't parse any alternatives") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))
(define csegen-3743(blodwen-lazy (lambda () (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "{h") (CompilerC-45ESC-45Doc-softColon)) (vector 3 "0}")))))
(define csegen-2368(blodwen-lazy (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 0 (vector 2 ))))))
(define csegen-3325(blodwen-lazy (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-pragma "runElab")))))
(define csegen-65(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40ListC-32C-36aC-41 arg-2 arg-3))) (PreludeC-45Types-u--neutral_Monoid_C-40ListC-32C-36aC-41)))))
(define csegen-4239(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45Interfaces-u--C-60C-43C-62_Semigroup_C-40C-124UnitC-44MkUnitC-124C-41 arg-2 arg-3))) (PreludeC-45Interfaces-u--neutral_Monoid_C-40C-124UnitC-44MkUnitC-124C-41)))))
(define csegen-68(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String arg-2 arg-3))) (PreludeC-45Types-u--neutral_Monoid_String)))))
(define csegen-2874(blodwen-lazy (lambda () (cons (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Int eta-0)) (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Int eta-0))))))
(define csegen-3953(blodwen-lazy (lambda () (cons (lambda (arg-1030) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int arg-1030)) (lambda (arg-1031) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int arg-1031))))))
(define csegen-3951(blodwen-lazy (lambda () (cons (lambda (arg-1030) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String arg-1030)) (lambda (arg-1031) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String arg-1031))))))
(define csegen-1621(blodwen-lazy (lambda () (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 u--ps)))))))
(define csegen-1822(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45Core-traverseC-39 eta-0 eta-1 '() eta-2)))))))
(define csegen-356(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 eta-2 eta-3))))))))
(define csegen-352(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 eta-2 eta-3))))))))
(define csegen-544(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space)) eta-0 eta-1))))))
(define csegen-2335(blodwen-lazy (lambda () (lambda (eta-0) (TTImpC-45ProcessData-hasArgs (+ 1 (+ 1 0)) eta-0)))))
(define csegen-3566(blodwen-lazy (lambda () (lambda (eta-0) (let ((sc0 (PreludeC-45Types-isSpace eta-0))) (cond ((equal? sc0 1) 0) (else 1)))))))
(define csegen-1945(blodwen-lazy (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (CoreC-45Reflect-u--reify_Reify_Int u--c u--vars arg-9108 arg-9109))))))))
(define csegen-1943(blodwen-lazy (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (CoreC-45Reflect-u--reify_Reify_String u--c u--vars arg-9108 arg-9109))))))))
(define csegen-758(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO eta-2 eta-3 eta-4)))))))))
(define csegen-1897(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_Name eta-0 eta-1 eta-2 eta-3))))))))
(define csegen-1911(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_String eta-0 eta-1 eta-2 eta-3))))))))
(define csegen-3962(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 0 eta-0 eta-1 eta-2 eta-3))))))))
(define csegen-2339(blodwen-lazy (lambda () (lambda (eta-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (CoreC-45TT-u--weaken_Weaken_Term eta-2)) eta-1)) eta-0)))))
(define csegen-856(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 0 eta-1 eta-2 eta-3)))))))))
(define csegen-2216(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 '())))))))
(define csegen-20(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 0)))))))
(define csegen-2090(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 "")))))))
(define csegen-2130(blodwen-lazy (lambda () (lambda (eta-0) (let ((sc0 (TTImpC-45ElabC-45App-isBindAllExpPattern (Builtin-fst eta-0)))) (cond ((equal? sc0 1) 0) (else 1)))))))
(define csegen-1055(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Value-u--showPrec_Show_C-40ClosureC-32C-36freeC-41 u--d u--x)))))))
(define csegen-2074(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40VarC-32C-36nsC-41 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40VarC-32C-36nsC-41 u--d u--x)))))))
(define csegen-977(blodwen-lazy (lambda () (cons (lambda (u--x) (CompilerC-45ANF-u--show_Show_ANF u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45ANF-u--showPrec_Show_ANF u--d u--x)))))))
(define csegen-2136(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45LinearCheck-u--show_Show_ArgUsage u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45LinearCheck-u--showPrec_Show_ArgUsage u--d u--x)))))))
(define csegen-783(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Bool u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Bool u--d u--x)))))))
(define csegen-837(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_CFType u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_CFType u--d u--x)))))))
(define csegen-970(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45TT-u--show_Show_Constant u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_Constant u--d u--x)))))))
(define csegen-1034(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_Def u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_Def u--d u--x)))))))
(define csegen-745(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45Core-u--show_Show_Error u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Core-u--showPrec_Show_Error u--d u--x)))))))
(define csegen-751(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45FC-u--show_Show_FC u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45FC-u--showPrec_Show_FC u--d u--x)))))))
(define csegen-246(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Int u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Int u--d u--x)))))))
(define csegen-1262(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45TT-u--show_Show_KindedName u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_KindedName u--d u--x)))))))
(define csegen-737(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45Name-u--show_Show_Name u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Name-u--showPrec_Show_Name u--d u--x)))))))
(define csegen-839(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_NamedCExp u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_NamedCExp u--d u--x)))))))
(define csegen-3209(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45NameC-45Namespace-u--show_Show_Namespace u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45NameC-45Namespace-u--showPrec_Show_Namespace u--d u--x)))))))
(define csegen-775(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Nat u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Nat u--d u--x)))))))
(define csegen-3677(blodwen-lazy (lambda () (cons (lambda (u--x) (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45InterpreterC-45VMCode-u--showPrec_Show_Object u--d u--x)))))))
(define csegen-847(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45CaseC-45CaseTree-u--show_Show_Pat u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CaseC-45CaseTree-u--showPrec_Show_Pat u--d u--x)))))))
(define csegen-576(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_String u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_String u--d u--x)))))))
(define csegen-963(blodwen-lazy (lambda () (cons (lambda (u--x) (CompilerC-45VMCode-u--show_Show_VMInst u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45VMCode-u--showPrec_Show_VMInst u--d u--x)))))))
(define csegen-1503(blodwen-lazy (lambda () (cons (lambda (u--x) (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega u--x)) (lambda (u--d) (lambda (u--x) (AlgebraC-45ZeroOneOmega-u--showPrec_Show_ZeroOneOmega u--d u--x)))))))
(define csegen-834(blodwen-lazy (lambda () (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_C-40TermC-32C-36varsC-41 arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 arg-568 arg-569)))))))
(define csegen-823(blodwen-lazy (lambda () (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_CFType arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType arg-568 arg-569)))))))
(define csegen-821(blodwen-lazy (lambda () (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_Int arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_Int arg-568 arg-569)))))))
(define csegen-817(blodwen-lazy (lambda () (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_Name arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_Name arg-568 arg-569)))))))
(define csegen-825(blodwen-lazy (lambda () (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_NamedCExp arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp arg-568 arg-569)))))))
(define csegen-3837(blodwen-lazy (lambda () (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_NamedDef arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedDef arg-568 arg-569)))))))
(define csegen-819(blodwen-lazy (lambda () (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_Nat arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_Nat arg-568 arg-569)))))))
(define csegen-815(blodwen-lazy (lambda () (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_String arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_String arg-568 arg-569)))))))
(define csegen-12(blodwen-lazy (lambda () (lambda (u--b) (lambda (u--a) (lambda (arg-893) (lambda (arg-894) (lambda (eta-0) (let ((act-24 (arg-893 eta-0))) ((arg-894 act-24) eta-0))))))))))
(define csegen-880(blodwen-lazy (lambda () (lambda (u--g) (cons (let ((e-17 (vector-ref u--g 17))) e-17) (let ((e-2 (vector-ref u--g 2))) e-2))))))
(define csegen-49(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45List-catMaybes e-5)))))))))
(define csegen-3648(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 (CompilerC-45InterpreterC-45VMCode-ioRes (CompilerC-45InterpreterC-45VMCode-unit)))))))))
(define csegen-3579(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (Builtin-snd e-5)))))))))
(define csegen-2341(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CoreC-45ContextC-45Data-toPos e-5)))))))))
(define csegen-1020(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45List-u--unzip_Zippable_List e-5)))))))))
(define csegen-980(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (box e-5)))))))))
(define csegen-2292(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-5)))))))))
(define csegen-300(blodwen-lazy (lambda () (DataC-45Nat-isSucc (let ((sc0 (csegen-302))) (let ((e-0 (car sc0))) e-0))))))
(define csegen-1898(blodwen-lazy (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_ImpClause u--c u--vars arg-9108 arg-9109 eta-0)))))))))
(define csegen-1899(blodwen-lazy (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_ImpDecl u--c u--vars arg-9108 arg-9109 eta-0)))))))))
(define csegen-1896(blodwen-lazy (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_RawImp u--c u--vars arg-9108 arg-9109 eta-0)))))))))
(define csegen-2293(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector eta-1 eta-2 eta-3 eta-4))))))))))
(define csegen-893(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector eta-1 eta-2 eta-3 eta-4))))))))))
(define csegen-862(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector 2 eta-1 eta-2 eta-3 eta-4))))))))))
(define csegen-865(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector 4 eta-1 eta-2 eta-3 eta-4))))))))))
(define csegen-868(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector 5 eta-1 eta-2 eta-3 eta-4))))))))))
(define csegen-2501(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines e-5))))))))))
(define csegen-3437(blodwen-lazy (lambda () (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) e-11)))))))
(define csegen-924(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45Ord-u--C-61C-61_Eq_C-40CConAltC-32C-36varsC-41 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45Ord-u--C-47C-61_Eq_C-40CConAltC-32C-36varsC-41 arg-4 arg-5)))))))
(define csegen-935(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45Ord-u--C-61C-61_Eq_C-40CConstAltC-32C-36varsC-41 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45Ord-u--C-47C-61_Eq_C-40CConstAltC-32C-36varsC-41 arg-4 arg-5)))))))
(define csegen-913(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45Ord-u--C-47C-61_Eq_C-40CExpC-32C-36varsC-41 arg-4 arg-5)))))))
(define csegen-546(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45TT-u--C-47C-61_Eq_C-40TermC-32C-36varsC-41 arg-4 arg-5)))))))
(define csegen-284(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Body arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Body arg-4 arg-5)))))))
(define csegen-1491(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bool arg-4 arg-5)))))))
(define csegen-898(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45Options-u--C-61C-61_Eq_CG arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45Options-u--C-47C-61_Eq_CG arg-4 arg-5)))))))
(define csegen-0(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-4 arg-5)))))))
(define csegen-1204(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45TT-u--C-61C-61_Eq_Constant arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45TT-u--C-47C-61_Eq_Constant arg-4 arg-5)))))))
(define csegen-2323(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (TTImpC-45TTImp-u--C-61C-61_Eq_DataOpt arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (TTImpC-45TTImp-u--C-47C-61_Eq_DataOpt arg-4 arg-5)))))))
(define csegen-1023(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45ContextC-45Context-u--C-61C-61_Eq_DefFlag arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag arg-4 arg-5)))))))
(define csegen-1886(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (TTImpC-45ElabC-45Check-u--C-61C-61_Eq_ElabOpt arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (TTImpC-45ElabC-45Check-u--C-47C-61_Eq_ElabOpt arg-4 arg-5)))))))
(define csegen-2506(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45FC-u--C-61C-61_Eq_FC arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45FC-u--C-47C-61_Eq_FC arg-4 arg-5)))))))
(define csegen-225(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int arg-4 arg-5)))))))
(define csegen-450(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Integer arg-4 arg-5)))))))
(define csegen-1486(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_ModuleIdent arg-4 arg-5)))))))
(define csegen-802(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45Name-u--C-61C-61_Eq_Name arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45Name-u--C-47C-61_Eq_Name arg-4 arg-5)))))))
(define csegen-1494(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_Namespace arg-4 arg-5)))))))
(define csegen-792(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-4 arg-5)))))))
(define csegen-795(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SizeChange arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_SizeChange arg-4 arg-5)))))))
(define csegen-17(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-4 arg-5)))))))
(define csegen-281(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Volume arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Volume arg-4 arg-5)))))))
(define csegen-476(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega arg-4 arg-5)))))))
(define csegen-1276(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 '() u--d u--x)))))))
(define csegen-871(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (CoreC-45Context-u--full_HasNames_C-40NameMapC-32C-36aC-41 arg-4060 arg-4061))) (lambda (arg-4062) (lambda (arg-4063) (CoreC-45Context-u--resolved_HasNames_C-40NameMapC-32C-36aC-41 arg-4062 arg-4063)))))))
(define csegen-76(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-4060 arg-4061))) (lambda (arg-4062) (lambda (arg-4063) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-4062 arg-4063)))))))
(define csegen-2549(blodwen-lazy (lambda () (cons (lambda (u--ann) (lambda (arg-5185) (CoreC-45Name-u--pretty_Pretty_Name arg-5185))) (lambda (u--ann) (lambda (arg-5186) (lambda (arg-5187) (CoreC-45Name-u--prettyPrec_Pretty_Name arg-5186 arg-5187))))))))
(define csegen-41(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-2375 eta-0)))))))
(define csegen-1866(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (TTImpC-45TTImp-u--toBuf_TTC_FnOpt arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (TTImpC-45TTImp-u--fromBuf_TTC_FnOpt arg-2375 eta-0)))))))
(define csegen-483(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-2375 eta-0)))))))
(define csegen-38(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_Name arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_Name arg-2375 eta-0)))))))
(define csegen-467(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-2375 eta-0)))))))
(define csegen-1833(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-2375 eta-0)))))))
(define csegen-479(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-2375 eta-0)))))))
(define csegen-4417(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--foldMap_Foldable_PosMap (csegen-65) eta-0 eta-1))))))
(define csegen-2135(blodwen-lazy (lambda () (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) eta-0)))))
(define csegen-1975(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (lambda (eta-1) (cons e-5 eta-1))))))))))
(define csegen-3703(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (vector 3 "0") e-5)))))))))
(define csegen-3702(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (vector 3 "undefined") e-5)))))))))
(define csegen-3734(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-8 (vector-ref e-5 8))) e-8)))))))))
(define csegen-3657(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-1 (vector-ref e-5 1))) e-1)))))))))
(define csegen-2380(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36 (csegen-352) '() (ParserC-45RuleC-45Source-exactIdent "off")))))
(define csegen-1919(blodwen-lazy (lambda () (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (TTImpC-45Reflect-u--reflect_Reflect_RawImp u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135))))))))))
(define csegen-1920(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_Name eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))))
(define csegen-1951(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (TTImpC-45Reflect-u--reflect_Reflect_RawImp eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))))
(define csegen-4418(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (LibrariesC-45DataC-45PosMap-exactRange (csegen-2852) eta-0 eta-1 eta-2)))))))
(define csegen-973(blodwen-lazy (lambda () (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-65) (lambda (eta-1) (CompilerC-45VMCode-findVars eta-1)) eta-0)))))
(define csegen-859(blodwen-lazy (lambda () (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (vector 1 eta-1 eta-2 eta-3 eta-4 eta-5)))))))))))
(define csegen-2471(blodwen-lazy (lambda () (TTImpC-45InteractiveC-45ExprSearch-initSearchOpts 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))
(define csegen-597(blodwen-lazy (lambda () (vector (lambda (arg-2) (lambda (arg-3) (+ arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (* arg-4 arg-5))) (lambda (arg-6) arg-6)))))
(define csegen-46(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (CoreC-45Context-u--resolved_HasNames_Name arg-4062 arg-4063)))))))
(define csegen-22(blodwen-lazy (lambda () (vector (lambda (arg-371) (lambda (arg-372) (AlgebraC-45ZeroOneOmega-u--C-124C-43C-124_Semiring_ZeroOneOmega arg-371 arg-372))) (AlgebraC-45ZeroOneOmega-u--plusNeutral_Semiring_ZeroOneOmega) (lambda (arg-373) (lambda (arg-374) (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-373 arg-374))) (AlgebraC-45ZeroOneOmega-u--timesNeutral_Semiring_ZeroOneOmega)))))
(define csegen-1245(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124UnitC-44MkUnitC-124C-41 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124UnitC-44MkUnitC-124C-41 arg-2375 eta-0)))))))
(define csegen-30(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_CDef arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_CDef arg-2375 eta-0)))))))
(define csegen-513(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_CFType arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_CFType arg-2375 eta-0)))))))
(define csegen-1425(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_CG arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_CG arg-2375 eta-0)))))))
(define csegen-1873(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (TTImpC-45TTImp-u--toBuf_TTC_DataOpt arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (TTImpC-45TTImp-u--fromBuf_TTC_DataOpt arg-2375 eta-0)))))))
(define csegen-486(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_DefFlag arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_DefFlag arg-2375 eta-0)))))))
(define csegen-1863(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (TTImpC-45TTImp-u--toBuf_TTC_IField arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (TTImpC-45TTImp-u--fromBuf_TTC_IField arg-2375 eta-0)))))))
(define csegen-1842(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (TTImpC-45TTImp-u--toBuf_TTC_IFieldUpdate arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (TTImpC-45TTImp-u--fromBuf_TTC_IFieldUpdate arg-2375 eta-0)))))))
(define csegen-1836(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (TTImpC-45TTImp-u--toBuf_TTC_ImpClause arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (TTImpC-45TTImp-u--fromBuf_TTC_ImpClause arg-2375 eta-0)))))))
(define csegen-1839(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (TTImpC-45TTImp-u--toBuf_TTC_ImpDecl arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (TTImpC-45TTImp-u--fromBuf_TTC_ImpDecl arg-2375 eta-0)))))))
(define csegen-1876(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (TTImpC-45TTImp-u--toBuf_TTC_ImpTy arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (TTImpC-45TTImp-u--fromBuf_TTC_ImpTy arg-2375 eta-0)))))))
(define csegen-2011(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (IdrisC-45Syntax-u--toBuf_TTC_Method arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (IdrisC-45Syntax-u--fromBuf_TTC_Method arg-2375 eta-0)))))))
(define csegen-1439(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_ModuleIdent arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_ModuleIdent arg-2375 eta-0)))))))
(define csegen-1418(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_Namespace arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-2375 eta-0)))))))
(define csegen-1458(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_PairNames arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_PairNames arg-2375 eta-0)))))))
(define csegen-1461(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_RewriteNames arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_RewriteNames arg-2375 eta-0)))))))
(define csegen-489(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_SCCall arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_SCCall arg-2375 eta-0)))))))
(define csegen-3203(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (IdrisC-45Syntax-u--toBuf_TTC_SyntaxInfo arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (IdrisC-45Syntax-u--fromBuf_TTC_SyntaxInfo arg-2375 eta-0)))))))
(define csegen-2008(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_TotalReq arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-2375 eta-0)))))))
(define csegen-507(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-2375 eta-0)))))))
(define csegen-764(blodwen-lazy (lambda () (cons (lambda (u--n) (lambda (u--vars) (lambda (arg-6608) (CoreC-45TT-u--weaken_Weaken_Term arg-6608)))) (lambda (u--vars) (lambda (u--ns) (lambda (arg-6614) (lambda (arg-6616) (CoreC-45TT-u--weakenNs_Weaken_Term arg-6614 arg-6616)))))))))
(define csegen-1796(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentStart 1 eta-0))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentTrailing 1 eta-0)))))))))
(define csegen-2422(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some (ParserC-45RuleC-45Source-name))))))
(define csegen-2387(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 0 eta-0))) (ParserC-45RuleC-45Source-unqualifiedName)))))
(define csegen-21(blodwen-lazy (lambda () (AlgebraC-45Semiring-erased (csegen-22)))))
(define csegen-519(blodwen-lazy (lambda () (AlgebraC-45Semiring-linear (csegen-22)))))
(define csegen-118(blodwen-lazy (lambda () (vector (lambda (arg-2) (lambda (arg-3) (PreludeC-45Types-u--C-43_Num_Nat arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45Types-u--C-42_Num_Nat arg-4 arg-5))) (lambda (arg-6) (PreludeC-45Types-u--fromInteger_Num_Nat arg-6))))))
(define csegen-190(blodwen-lazy (lambda () (vector (lambda (arg-2) (lambda (arg-3) (bs+ arg-2 arg-3 63))) (lambda (arg-4) (lambda (arg-5) (bs* arg-4 arg-5 63))) (lambda (arg-6) (blodwen-toSignedInt arg-6 63))))))
(define csegen-1921(blodwen-lazy (lambda () (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_ImpClause u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))))))
(define csegen-1922(blodwen-lazy (lambda () (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_ImpDecl u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))))))
(define csegen-1948(blodwen-lazy (lambda () (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (CoreC-45Reflect-u--reflect_Reflect_Int u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))))))
(define csegen-1946(blodwen-lazy (lambda () (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (CoreC-45Reflect-u--reflect_Reflect_String u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))))))
(define csegen-1950(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124UnitC-44MkUnitC-124C-41 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))))))
(define csegen-1935(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_String eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))))))
(define csegen-239(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (PreludeC-45Basics-uncurry (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (LibrariesC-45DataC-45NameMap-insert eta-3 eta-4 eta-5)))) eta-2)) eta-0 eta-1))))))
(define csegen-459(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (PreludeC-45Basics-uncurry (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (LibrariesC-45DataC-45SortedMap-insert eta-3 eta-4 eta-5)))) eta-2)) eta-0 eta-1))))))
(define csegen-734(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (PreludeC-45Basics-uncurry (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (LibrariesC-45DataC-45StringMap-insert eta-3 eta-4 eta-5)))) eta-2)) eta-0 eta-1))))))
(define csegen-2487(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-5)))))))))
(define csegen-3489(blodwen-lazy (lambda () (LibrariesC-45TextC-45Parser-option 1 0 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-symbol "!") 1)))))
(define csegen-2389(blodwen-lazy (lambda () (vector 0 (csegen-21)))))
(define csegen-2390(blodwen-lazy (lambda () (vector 0 (csegen-519)))))
(define csegen-3952(blodwen-lazy (lambda () (cons (csegen-3953) (csegen-3953)))))
(define csegen-1885(blodwen-lazy (lambda () (vector 0 (csegen-21)))))
(define csegen-2177(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-4062 arg-4063 eta-0))))))))
(define csegen-1409(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40ListC-32StringC-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40ListC-32StringC-41C-41C-124C-41 arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40ListC-32StringC-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40ListC-32StringC-41C-41C-124C-41 arg-4062 arg-4063 eta-0))))))))
(define csegen-1412(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32TransformC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32TransformC-41C-124C-41 arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32TransformC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32TransformC-41C-124C-41 arg-4062 arg-4063 eta-0))))))))
(define csegen-2112(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Clause arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Clause arg-4062 arg-4063 eta-0))))))))
(define csegen-1050(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Def arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Def arg-4062 arg-4063 eta-0))))))))
(define csegen-2023(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (IdrisC-45Syntax-u--full_HasNames_IFaceInfo arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (IdrisC-45Syntax-u--resolved_HasNames_IFaceInfo arg-4062 arg-4063 eta-0))))))))
(define csegen-2241(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Terminating arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Terminating arg-4062 arg-4063 eta-0))))))))
(define csegen-852(blodwen-lazy (lambda () (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Transform arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Transform arg-4062 arg-4063 eta-0))))))))
(define csegen-517(blodwen-lazy (lambda () (vector 1 (csegen-21)))))
(define csegen-518(blodwen-lazy (lambda () (vector 1 (csegen-519)))))
(define csegen-3315(blodwen-lazy (lambda () (vector 14 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some (vector 14 (ParserC-45RuleC-45Source-postfixProj))))))))
(define csegen-951(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (csegen-363) arg-2 arg-3))) (LibrariesC-45DataC-45IntMap-u--neutral_Monoid_C-40IntMapC-32C-36vC-41 (csegen-363))))))
(define csegen-3310(blodwen-lazy (lambda () (LibrariesC-45TextC-45Parser-optional 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45String-split (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char #\. arg-0)) eta-0)) (ParserC-45RuleC-45Source-simpleStr))))))
(define csegen-2876(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" ""))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "")) (else ""))))))))))
(define csegen-2993(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Primitive value"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive value")) (else "Primitive value"))))))))))
(define csegen-248(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "_"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "_")) (else "_"))))))))))
(define csegen-2510(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "and"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "and")) (else "and"))))))))))
(define csegen-1194(blodwen-lazy (lambda () (vector (csegen-212) (lambda (u--a) (lambda (arg-609) (PreludeC-45Types-u--pure_Applicative_List arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (PreludeC-45Types-u--C-60C-42C-62_Applicative_List arg-610 arg-612)))))))))
(define csegen-271(blodwen-lazy (lambda () (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (PreludeC-45Types-u--map_Functor_Maybe u--func arg-215))))) (lambda (u--a) (lambda (arg-609) (PreludeC-45Types-u--pure_Applicative_Maybe arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe arg-610 arg-612)))))))))
(define csegen-1944(blodwen-lazy (lambda () (cons (csegen-1945) (csegen-1945)))))
(define csegen-750(blodwen-lazy (lambda () (cons (csegen-751) (csegen-737)))))
(define csegen-756(blodwen-lazy (lambda () (cons (csegen-751) (csegen-576)))))
(define csegen-1502(blodwen-lazy (lambda () (cons (csegen-751) (csegen-1503)))))
(define csegen-245(blodwen-lazy (lambda () (cons (csegen-246) (csegen-246)))))
(define csegen-954(blodwen-lazy (lambda () (cons (csegen-246) (csegen-737)))))
(define csegen-3574(blodwen-lazy (lambda () (cons (cons (lambda (u--x) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45NameC-45Namespace-u--showPrec_Show_ModuleIdent u--d u--x)))) (csegen-576)))))
(define csegen-2103(blodwen-lazy (lambda () (cons (csegen-737) (cons (lambda (u--x) (TTImpC-45ElabC-45Check-u--show_Show_C-40ImplBindingC-32C-36varsC-41 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45ElabC-45Check-u--showPrec_Show_C-40ImplBindingC-32C-36varsC-41 u--d u--x))))))))
(define csegen-2140(blodwen-lazy (lambda () (cons (csegen-737) (csegen-2136)))))
(define csegen-3642(blodwen-lazy (lambda () (cons (csegen-737) (csegen-751)))))
(define csegen-1506(blodwen-lazy (lambda () (cons (csegen-737) (csegen-246)))))
(define csegen-2299(blodwen-lazy (lambda () (cons (csegen-737) (csegen-737)))))
(define csegen-2210(blodwen-lazy (lambda () (cons (csegen-737) (csegen-1503)))))
(define csegen-3208(blodwen-lazy (lambda () (cons (csegen-3209) (csegen-246)))))
(define csegen-774(blodwen-lazy (lambda () (cons (csegen-775) (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_SizeChange u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_SizeChange u--d u--x))))))))
(define csegen-2173(blodwen-lazy (lambda () (cons (csegen-576) (csegen-576)))))
(define csegen-93(blodwen-lazy (lambda () (PreludeC-45Types-elem (csegen-17) (SystemC-45Info-os) (cons "windows" (cons "mingw32" (cons "cygwin32" '())))))))
(define csegen-2898(blodwen-lazy (lambda () (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Constructor"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Constructor")) (else "Constructor")))))))))))
(define csegen-2905(blodwen-lazy (lambda () (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Constructors"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Constructors")) (else "Constructors")))))))))))
(define csegen-2977(blodwen-lazy (lambda () (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Hints"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Hints")) (else "Hints")))))))))))
(define csegen-2948(blodwen-lazy (lambda () (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Implementations"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Implementations")) (else "Implementations")))))))))))
(define csegen-2920(blodwen-lazy (lambda () (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Projections"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Projections")) (else "Projections")))))))))))
(define csegen-1892(blodwen-lazy (lambda () (vector (lambda (arg-371) (lambda (arg-372) (AlgebraC-45ZeroOneOmega-u--C-60C-61_Preorder_ZeroOneOmega arg-371 arg-372))) (lambda (u--x) (AlgebraC-45ZeroOneOmega-u--preorderRefl_Preorder_ZeroOneOmega u--x)) (lambda (u--x) (lambda (u--y) (lambda (u--z) (lambda (arg-376) (lambda (arg-380) (AlgebraC-45ZeroOneOmega-u--preorderTrans_Preorder_ZeroOneOmega u--x u--y u--z arg-376 arg-380))))))))))
(define csegen-2875(blodwen-lazy (lambda () (vector 1 (csegen-2876)))))
(define csegen-290(blodwen-lazy (lambda () (cons (cons (lambda (arg-2) (lambda (arg-3) (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_PathTokenKind arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_PathTokenKind arg-4 arg-5)))) (cons (lambda (arg-371) (LibrariesC-45UtilsC-45Path-u--TokType_TokenKind_PathTokenKind arg-371)) (lambda (u--kind) (lambda (arg-372) (LibrariesC-45UtilsC-45Path-u--tokValue_TokenKind_PathTokenKind u--kind arg-372))))))))
(define csegen-2698(blodwen-lazy (lambda () (cons (cons (lambda (arg-2) (lambda (arg-3) (LibrariesC-45DataC-45Version-u--C-61C-61_Eq_VersionTokenKind arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (LibrariesC-45DataC-45Version-u--C-47C-61_Eq_VersionTokenKind arg-4 arg-5)))) (cons (lambda (arg-371) (LibrariesC-45DataC-45Version-u--TokType_TokenKind_VersionTokenKind arg-371)) (lambda (u--kind) (lambda (arg-372) (LibrariesC-45DataC-45Version-u--tokValue_TokenKind_VersionTokenKind u--kind arg-372))))))))
(define csegen-1398(blodwen-lazy (lambda () (cons (csegen-737) (csegen-1276)))))
(define csegen-1385(blodwen-lazy (lambda () (cons (csegen-775) (csegen-1276)))))
(define csegen-1292(blodwen-lazy (lambda () (cons (cons (lambda (u--x) (ParserC-45LexerC-45Source-u--show_Show_Token u--x)) (lambda (u--d) (lambda (u--x) (ParserC-45LexerC-45Source-u--showPrec_Show_Token u--d u--x)))) (cons (lambda (u--ann) (lambda (arg-5185) (ParserC-45LexerC-45Source-u--pretty_Pretty_Token arg-5185))) (lambda (u--ann) (lambda (arg-5186) (lambda (arg-5187) (ParserC-45LexerC-45Source-u--prettyPrec_Pretty_Token arg-5186 arg-5187)))))))))
(define csegen-2801(blodwen-lazy (lambda () (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Can't make lifted definition"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Can't make lifted definition")) (else "Can't make lifted definition"))))))))))))
(define csegen-2809(blodwen-lazy (lambda () (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Invalid literate Idris"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Invalid literate Idris")) (else "Invalid literate Idris"))))))))))))
(define csegen-2776(blodwen-lazy (lambda () (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "No more results"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "No more results")) (else "No more results"))))))))))))
(define csegen-2768(blodwen-lazy (lambda () (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "No search results"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "No search results")) (else "No search results"))))))))))))
(define csegen-2746(blodwen-lazy (lambda () (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Not a searchable hole"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Not a searchable hole")) (else "Not a searchable hole"))))))))))))
(define csegen-2817(blodwen-lazy (lambda () (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Source line not available"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Source line not available")) (else "Source line not available"))))))))))))
(define csegen-2785(blodwen-lazy (lambda () (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Source line not found"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Source line not found")) (else "Source line not found"))))))))))))
(define csegen-2962(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "Fixity Declarations"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Fixity Declarations")) (else "Fixity Declarations")))))))) (vector 3 )))))
(define csegen-975(blodwen-lazy (lambda () (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (lambda (eta-1) (CompilerC-45VMCode-collectUsed eta-1)) eta-0)))))
(define csegen-289(blodwen-lazy (lambda () (LibrariesC-45TextC-45Parser-match (csegen-290) '()))))
(define csegen-2697(blodwen-lazy (lambda () (LibrariesC-45TextC-45Parser-match (csegen-2698) 1))))
(define csegen-2705(blodwen-lazy (lambda () (LibrariesC-45TextC-45Parser-match (csegen-2698) 2))))
(define csegen-3783(blodwen-lazy (lambda () (vector (csegen-597) (lambda (arg-45) (- 0 arg-45)) (lambda (arg-46) (lambda (arg-47) (- arg-46 arg-47)))))))
(define csegen-502(blodwen-lazy (lambda () (cons (csegen-41) (csegen-467)))))
(define csegen-482(blodwen-lazy (lambda () (cons (csegen-483) (csegen-483)))))
(define csegen-1449(blodwen-lazy (lambda () (cons (csegen-38) (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Binary arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Binary arg-2375 eta-0))))))))
(define csegen-37(blodwen-lazy (lambda () (cons (csegen-38) (csegen-41)))))
(define csegen-2006(blodwen-lazy (lambda () (cons (csegen-38) (csegen-479)))))
(define csegen-1990(blodwen-lazy (lambda () (cons (csegen-479) (csegen-467)))))
(define csegen-2034(blodwen-lazy (lambda () (lambda (u--n) (PreludeC-45TypesC-45String-C-43C-43 "." (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-750) u--n))))))
(define csegen-974(blodwen-lazy (lambda () (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (lambda (eta-1) (CompilerC-45VMCode-collectUsed eta-1)) (Builtin-snd eta-0))))))
(define csegen-306(blodwen-lazy (lambda () (LibrariesC-45TextC-45Parser-match (csegen-290) (box #\\)))))
(define csegen-2411(blodwen-lazy (lambda () (vector 14 (vector 11 1 (ParserC-45RuleC-45Source-pragma "builtin") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (ParserC-45RuleC-45Source-builtinType) (lambda () (lambda (u--t) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (cons u--t u--n)))))))))))))))
(define csegen-475(blodwen-lazy (lambda () (cons (csegen-22) (csegen-476)))))
(define csegen-1470(blodwen-lazy (lambda () (cons (csegen-1425) (csegen-479)))))
(define csegen-1982(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (IdrisC-45Syntax-u--toBuf_TTC_Fixity arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (IdrisC-45Syntax-u--fromBuf_TTC_Fixity arg-2375 eta-0)))) (csegen-467)))))
(define csegen-1994(blodwen-lazy (lambda () (cons (csegen-1439) (csegen-479)))))
(define csegen-1417(blodwen-lazy (lambda () (cons (csegen-1418) (csegen-483)))))
(define csegen-1444(blodwen-lazy (lambda () (cons (csegen-41) (csegen-1418)))))
(define csegen-1999(blodwen-lazy (lambda () (cons (csegen-38) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (IdrisC-45Syntax-u--toBuf_TTC_IFaceInfo arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (IdrisC-45Syntax-u--fromBuf_TTC_IFaceInfo arg-2375 eta-0))))))))
(define csegen-1474(blodwen-lazy (lambda () (cons (csegen-38) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_Transform arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_Transform arg-2375 eta-0))))))))
(define csegen-1353(blodwen-lazy (lambda () (cons (csegen-38) (csegen-507)))))
(define csegen-466(blodwen-lazy (lambda () (cons (csegen-467) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_SizeChange arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_SizeChange arg-2375 eta-0))))))))
(define csegen-1340(blodwen-lazy (lambda () (cons (csegen-467) (csegen-507)))))
(define csegen-512(blodwen-lazy (lambda () (cons (csegen-479) (csegen-513)))))
(define csegen-1953(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1920) eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))))
(define csegen-2639(blodwen-lazy (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (u--ann) (lambda (arg-5185) (CoreC-45FC-u--pretty_Pretty_FC arg-5185))) (lambda (u--ann) (lambda (arg-5186) (lambda (arg-5187) (CoreC-45FC-u--prettyPrec_Pretty_FC arg-5186 arg-5187))))) (csegen-2549)) eta-0)))))
(define csegen-5(blodwen-lazy (lambda () (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO u--func arg-215 eta-0)))))) (lambda (u--a) (lambda (arg-609) (lambda (eta-0) arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (lambda (eta-0) (let ((act-17 (arg-610 eta-0))) (let ((act-16 (arg-612 eta-0))) (act-17 act-16))))))))))))
(define csegen-1283(blodwen-lazy (lambda () (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 (csegen-737) u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 (csegen-737) u--d u--x)))))))
(define csegen-2095(blodwen-lazy (lambda () (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 (csegen-737) u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpDeclC-39C-32C-36nmC-41 (csegen-737) u--d u--x)))))))
(define csegen-961(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-963) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-963) u--d u--x)))))))
(define csegen-2072(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-2074) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (csegen-2074) u--d u--x)))))))
(define csegen-742(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-737) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (csegen-737) u--d u--x)))))))
(define csegen-1280(blodwen-lazy (lambda () (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--d u--x)))))))
(define csegen-1201(blodwen-lazy (lambda () (vector (csegen-1194) (lambda (u--a) (PreludeC-45Types-u--empty_Alternative_List)) (lambda (u--a) (lambda (arg-845) (lambda (arg-846) (PreludeC-45Types-u--C-60C-124C-62_Alternative_List arg-845 arg-846))))))))
(define csegen-538(blodwen-lazy (lambda () (vector (csegen-271) (lambda (u--a) (PreludeC-45Types-u--empty_Alternative_Maybe)) (lambda (u--a) (lambda (arg-845) (lambda (arg-846) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe arg-845 arg-846))))))))
(define csegen-1252(blodwen-lazy (lambda () (cons (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (YaffleC-45Main-u--full_HasNames_C-40C-124UnitC-44MkUnitC-124C-41 arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (YaffleC-45Main-u--resolved_HasNames_C-40C-124UnitC-44MkUnitC-124C-41 arg-4062 arg-4063 eta-0))))) (csegen-1245)))))
(define csegen-2142(blodwen-lazy (lambda () (vector (vector (csegen-2144) (lambda (u--a) (lambda (arg-609) (ControlC-45MonadC-45Identity-u--pure_Applicative_Identity arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (ControlC-45MonadC-45Identity-u--C-60C-42C-62_Applicative_Identity arg-610 arg-612)))))) (lambda (u--b) (lambda (u--a) (lambda (arg-893) (lambda (arg-894) (ControlC-45MonadC-45Identity-u--C-62C-62C-61_Monad_Identity arg-893 arg-894))))) (lambda (u--a) (lambda (arg-896) (ControlC-45MonadC-45Identity-u--join_Monad_Identity arg-896)))))))
(define csegen-1193(blodwen-lazy (lambda () (vector (csegen-1194) (lambda (u--b) (lambda (u--a) (lambda (arg-893) (lambda (arg-894) (PreludeC-45Types-u--C-62C-62C-61_Monad_List arg-893 arg-894))))) (lambda (u--a) (lambda (arg-896) (PreludeC-45Types-u--join_Monad_List arg-896)))))))
(define csegen-270(blodwen-lazy (lambda () (vector (csegen-271) (lambda (u--b) (lambda (u--a) (lambda (arg-893) (lambda (arg-894) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe arg-893 arg-894))))) (lambda (u--a) (lambda (arg-896) (PreludeC-45Types-u--join_Monad_Maybe arg-896)))))))
(define csegen-1947(blodwen-lazy (lambda () (cons (csegen-1948) (csegen-1948)))))
(define csegen-2098(blodwen-lazy (lambda () (cons (csegen-1892) (csegen-476)))))
(define csegen-2255(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-225) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45Types-u--C-47C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-225) arg-4 arg-5)))))))
(define csegen-504(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-2375 eta-0)))))))
(define csegen-1431(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-2375 eta-0)))))))
(define csegen-1965(blodwen-lazy (lambda () (cons (lambda (u--vars) (lambda (arg-8425) (lambda (arg-8428) (lambda (arg-8431) (lambda (arg-8432) (lambda (arg-8433) (lambda (arg-8435) (lambda (arg-8438) (CoreC-45Unify-u--unifyD_Unify_NF u--vars arg-8425 arg-8428 arg-8431 arg-8432 arg-8433 arg-8435 arg-8438))))))))) (lambda (u--vars) (lambda (arg-8440) (lambda (arg-8443) (lambda (arg-8446) (lambda (arg-8447) (lambda (arg-8448) (lambda (arg-8450) (lambda (arg-8451) (CoreC-45Unify-u--unifyWithLazyD_Unify_NF u--vars arg-8440 arg-8443 arg-8446 arg-8447 arg-8448 arg-8450 arg-8451)))))))))))))
(define csegen-3992(blodwen-lazy (lambda () (cons (csegen-597) (csegen-3783)))))
(define csegen-741(blodwen-lazy (lambda () (cons (csegen-742) (csegen-745)))))
(define csegen-2133(blodwen-lazy (lambda () (cons (csegen-783) (csegen-1280)))))
(define csegen-969(blodwen-lazy (lambda () (cons (csegen-970) (csegen-961)))))
(define csegen-1316(blodwen-lazy (lambda () (cons (cons (lambda (u--x) (CoreC-45Metadata-u--show_Show_Decoration u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Metadata-u--showPrec_Show_Decoration u--d u--x)))) (csegen-742)))))
(define csegen-2235(blodwen-lazy (lambda () (cons (csegen-737) (csegen-1280)))))
(define csegen-2214(blodwen-lazy (lambda () (cons (csegen-576) (csegen-1280)))))
(define csegen-3609(blodwen-lazy (lambda () (cons (csegen-1503) (csegen-1280)))))
(define csegen-2653(blodwen-lazy (lambda () (vector (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (ControlC-45MonadC-45ST-u--map_Functor_C-40STC-32C-36sC-41 u--func arg-215))))) (lambda (u--a) (lambda (arg-609) (lambda (eta-0) (ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 arg-609 eta-0)))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (lambda (eta-0) (ControlC-45MonadC-45ST-u--C-60C-42C-62_Applicative_C-40STC-32C-36sC-41 arg-610 arg-612 eta-0))))))) (lambda (u--b) (lambda (u--a) (lambda (arg-893) (lambda (arg-894) (lambda (eta-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 arg-893 arg-894 eta-0)))))) (lambda (u--a) (lambda (arg-896) (lambda (eta-0) (ControlC-45MonadC-45ST-u--join_Monad_C-40STC-32C-36sC-41 arg-896 eta-0))))))))
(define csegen-2082(blodwen-lazy (lambda () (cons (lambda (u--vars) (lambda (arg-8425) (lambda (arg-8428) (lambda (arg-8431) (lambda (arg-8432) (lambda (arg-8433) (lambda (arg-8435) (lambda (arg-8438) (lambda (eta-0) (CoreC-45Unify-u--unifyD_Unify_Closure u--vars arg-8425 arg-8428 arg-8431 arg-8432 arg-8433 arg-8435 arg-8438 eta-0)))))))))) (lambda (u--vars) (lambda (arg-8440) (lambda (arg-8443) (lambda (arg-8446) (lambda (arg-8447) (lambda (arg-8448) (lambda (arg-8450) (lambda (arg-8451) (lambda (eta-0) (CoreC-45Unify-u--unifyWithLazyD_Unify_Closure u--vars arg-8440 arg-8443 arg-8446 arg-8447 arg-8448 arg-8450 arg-8451 eta-0))))))))))))))
(define csegen-1962(blodwen-lazy (lambda () (cons (lambda (u--vars) (lambda (arg-8425) (lambda (arg-8428) (lambda (arg-8431) (lambda (arg-8432) (lambda (arg-8433) (lambda (arg-8435) (lambda (arg-8438) (lambda (eta-0) (CoreC-45Unify-u--unifyD_Unify_Term u--vars arg-8425 arg-8428 arg-8431 arg-8432 arg-8433 arg-8435 arg-8438 eta-0)))))))))) (lambda (u--vars) (lambda (arg-8440) (lambda (arg-8443) (lambda (arg-8446) (lambda (arg-8447) (lambda (arg-8448) (lambda (arg-8450) (lambda (arg-8451) (lambda (eta-0) (CoreC-45Unify-u--unifyWithLazyD_Unify_Term u--vars arg-8440 arg-8443 arg-8446 arg-8447 arg-8448 arg-8450 arg-8451 eta-0))))))))))))))
(define csegen-2862(blodwen-lazy (lambda () (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Bad expression, expected") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "B")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "_ -> B")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "A -> B")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String ", where")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "A")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "and") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "B")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "are spines of global names")))))))))))))))
(define csegen-304(blodwen-lazy (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 (csegen-300) (lambda (eta-0) 0) (LibrariesC-45TextC-45Parser-count (csegen-302) (csegen-306))))))
(define csegen-87(blodwen-lazy (lambda () (vector (csegen-5) (csegen-12) (lambda (u--a) (lambda (arg-896) (lambda (eta-0) (let ((act-29 (arg-896 eta-0))) (act-29 eta-0)))))))))
(define csegen-912(blodwen-lazy (lambda () (vector (csegen-913) (lambda (arg-418) (lambda (arg-419) (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (CoreC-45Ord-u--C-60_Ord_C-40CExpC-32C-36varsC-41 arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (CoreC-45Ord-u--C-62_Ord_C-40CExpC-32C-36varsC-41 arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (CoreC-45Ord-u--C-60C-61_Ord_C-40CExpC-32C-36varsC-41 arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (CoreC-45Ord-u--C-62C-61_Ord_C-40CExpC-32C-36varsC-41 arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (CoreC-45Ord-u--max_Ord_C-40CExpC-32C-36varsC-41 arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (CoreC-45Ord-u--min_Ord_C-40CExpC-32C-36varsC-41 arg-430 arg-431)))))))
(define csegen-3237(blodwen-lazy (lambda () (vector (csegen-1491) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_Bool arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_Bool arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_Bool arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_Bool arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_Bool arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_Bool arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_Bool arg-430 arg-431)))))))
(define csegen-3849(blodwen-lazy (lambda () (vector (cons (lambda (arg-2) (lambda (arg-3) (CompilerC-45Separate-u--C-61C-61_Eq_CompilationUnitId arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CompilerC-45Separate-u--C-47C-61_Eq_CompilationUnitId arg-4 arg-5)))) (lambda (arg-418) (lambda (arg-419) (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (CompilerC-45Separate-u--C-60_Ord_CompilationUnitId arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (CompilerC-45Separate-u--C-62_Ord_CompilationUnitId arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (CompilerC-45Separate-u--C-60C-61_Ord_CompilationUnitId arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (CompilerC-45Separate-u--C-62C-61_Ord_CompilationUnitId arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (CompilerC-45Separate-u--max_Ord_CompilationUnitId arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (CompilerC-45Separate-u--min_Ord_CompilationUnitId arg-430 arg-431)))))))
(define csegen-3194(blodwen-lazy (lambda () (vector (csegen-1204) (lambda (arg-418) (lambda (arg-419) (CoreC-45Ord-u--compare_Ord_Constant arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (CoreC-45Ord-u--C-60_Ord_Constant arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (CoreC-45Ord-u--C-62_Ord_Constant arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (CoreC-45Ord-u--C-60C-61_Ord_Constant arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (CoreC-45Ord-u--C-62C-61_Ord_Constant arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (CoreC-45Ord-u--max_Ord_Constant arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (CoreC-45Ord-u--min_Ord_Constant arg-430 arg-431)))))))
(define csegen-224(blodwen-lazy (lambda () (vector (csegen-225) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_Int arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_Int arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_Int arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_Int arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_Int arg-430 arg-431)))))))
(define csegen-989(blodwen-lazy (lambda () (vector (csegen-450) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_Integer arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_Integer arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_Integer arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_Integer arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_Integer arg-430 arg-431)))))))
(define csegen-2026(blodwen-lazy (lambda () (vector (csegen-1486) (lambda (arg-418) (lambda (arg-419) (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (CoreC-45NameC-45Namespace-u--C-60_Ord_ModuleIdent arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (CoreC-45NameC-45Namespace-u--C-62_Ord_ModuleIdent arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (CoreC-45NameC-45Namespace-u--C-60C-61_Ord_ModuleIdent arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (CoreC-45NameC-45Namespace-u--C-62C-61_Ord_ModuleIdent arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (CoreC-45NameC-45Namespace-u--max_Ord_ModuleIdent arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (CoreC-45NameC-45Namespace-u--min_Ord_ModuleIdent arg-430 arg-431)))))))
(define csegen-883(blodwen-lazy (lambda () (vector (csegen-802) (lambda (arg-418) (lambda (arg-419) (CoreC-45Name-u--compare_Ord_Name arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (CoreC-45Name-u--C-60_Ord_Name arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (CoreC-45Name-u--C-62_Ord_Name arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (CoreC-45Name-u--C-60C-61_Ord_Name arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (CoreC-45Name-u--C-62C-61_Ord_Name arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (CoreC-45Name-u--max_Ord_Name arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (CoreC-45Name-u--min_Ord_Name arg-430 arg-431)))))))
(define csegen-3217(blodwen-lazy (lambda () (vector (csegen-1494) (lambda (arg-418) (lambda (arg-419) (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (CoreC-45NameC-45Namespace-u--C-60_Ord_Namespace arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (CoreC-45NameC-45Namespace-u--C-62_Ord_Namespace arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (CoreC-45NameC-45Namespace-u--C-60C-61_Ord_Namespace arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (CoreC-45NameC-45Namespace-u--C-62C-61_Ord_Namespace arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (CoreC-45NameC-45Namespace-u--max_Ord_Namespace arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (CoreC-45NameC-45Namespace-u--min_Ord_Namespace arg-430 arg-431)))))))
(define csegen-2672(blodwen-lazy (lambda () (vector (csegen-792) (lambda (arg-418) (lambda (arg-419) (PreludeC-45Types-u--compare_Ord_Nat arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45Types-u--C-60_Ord_Nat arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45Types-u--C-62_Ord_Nat arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45Types-u--C-62C-61_Ord_Nat arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45Types-u--max_Ord_Nat arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45Types-u--min_Ord_Nat arg-430 arg-431)))))))
(define csegen-261(blodwen-lazy (lambda () (vector (csegen-17) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_String arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_String arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_String arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_String arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_String arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_String arg-430 arg-431)))))))
(define csegen-1871(blodwen-lazy (lambda () (cons (csegen-1431) (csegen-467)))))
(define csegen-1856(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-1833) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-1833) arg-2375 eta-0)))) (csegen-1833)))))
(define csegen-1366(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45Metadata-u--toBuf_TTC_Decoration arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45Metadata-u--fromBuf_TTC_Decoration arg-2375 eta-0)))) (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-2375 eta-0))))))))
(define csegen-1466(blodwen-lazy (lambda () (cons (csegen-38) (csegen-1431)))))
(define csegen-1430(blodwen-lazy (lambda () (cons (csegen-479) (csegen-1431)))))
(define csegen-748(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-750) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-750) u--d u--x)))))))
(define csegen-1309(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-245) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-245) u--d u--x)))))))
(define csegen-2101(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2103) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2103) u--d u--x)))))))
(define csegen-3206(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3208) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3208) u--d u--x)))))))
(define csegen-772(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-774) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-774) u--d u--x)))))))
(define csegen-2171(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2173) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2173) u--d u--x)))))))
(define csegen-3744(blodwen-lazy (lambda () (LibrariesC-45DataC-45SortedMap-empty (csegen-883)))))
(define csegen-3870(blodwen-lazy (lambda () (LibrariesC-45DataC-45SortedMap-empty (csegen-3217)))))
(define csegen-2286(blodwen-lazy (lambda () (LibrariesC-45DataC-45SortedSet-empty (csegen-224)))))
(define csegen-3747(blodwen-lazy (lambda () (LibrariesC-45DataC-45SortedSet-empty (csegen-883)))))
(define csegen-3860(blodwen-lazy (lambda () (LibrariesC-45DataC-45SortedSet-empty (csegen-3217)))))
(define csegen-1006(blodwen-lazy (lambda () (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (DataC-45Vect-u--foldr_Foldable_C-40VectC-32C-36nC-41 u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-1176) (DataC-45Vect-u--null_Foldable_C-40VectC-32C-36nC-41 arg-1176))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (DataC-45Vect-u--foldlM_Foldable_C-40VectC-32C-36nC-41 i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-1180) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-1180))) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-1182) (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 i_con-0 u--f arg-1182))))))))))
(define csegen-3174(blodwen-lazy (lambda () (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (CoreC-45TT-u--foldr_Foldable_Binder u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (CoreC-45TT-u--foldl_Foldable_Binder u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-1176) (CoreC-45TT-u--null_Foldable_Binder arg-1176))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (CoreC-45TT-u--foldlM_Foldable_Binder i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-1180) (CoreC-45TT-u--toList_Foldable_Binder arg-1180))) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-1182) (CoreC-45TT-u--foldMap_Foldable_Binder i_con-0 u--f arg-1182))))))))))
(define csegen-51(blodwen-lazy (lambda () (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldr_Foldable_List u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldl_Foldable_List u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-1176) (PreludeC-45Types-u--null_Foldable_List arg-1176))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldlM_Foldable_List i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-1180) (PreludeC-45Types-u--toList_Foldable_List arg-1180))) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-1182) (PreludeC-45Types-u--foldMap_Foldable_List i_con-0 u--f arg-1182))))))))))
(define csegen-3705(blodwen-lazy (lambda () (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldr_Foldable_Maybe u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldl_Foldable_Maybe u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-1176) (PreludeC-45Types-u--null_Foldable_Maybe arg-1176))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldlM_Foldable_Maybe i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-1180) (PreludeC-45Types-u--toList_Foldable_Maybe arg-1180))) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-1182) (PreludeC-45Types-u--foldMap_Foldable_Maybe i_con-0 u--f arg-1182))))))))))
(define csegen-2310(blodwen-lazy (lambda () (vector 1 (csegen-2286)))))
(define csegen-3(blodwen-lazy (lambda () (cons (vector (csegen-5) (csegen-12) (lambda (u--a) (lambda (arg-896) (lambda (eta-0) (let ((act-51 (arg-896 eta-0))) (act-51 eta-0)))))) (lambda (u--a) (lambda (arg-7039) arg-7039))))))
(define csegen-878(blodwen-lazy (lambda () (SystemC-45Directory-currentDir (csegen-3)))))
(define csegen-1268(blodwen-lazy (lambda () (PreludeC-45IO-getLine (csegen-3)))))
(define csegen-2016(blodwen-lazy (lambda () (cons (csegen-38) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1836) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1836) arg-2375 eta-0))))))))
(define csegen-1383(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1385) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1385) u--d u--x)))))))
(define csegen-2764(blodwen-lazy (lambda () (SystemC-45FileC-45Process-fflush (csegen-3) (SystemC-45FileC-45Virtual-stdout)))))
(define csegen-1230(blodwen-lazy (lambda () (PreludeC-45IO-putStrLn (csegen-3) (IdrisC-45CommandLine-usage)))))
(define csegen-2712(blodwen-lazy (lambda () (PreludeC-45IO-putStrLn (csegen-3) "No such code generator"))))
(define csegen-1214(blodwen-lazy (lambda () (System-exitWith (csegen-3) (cons 1 0)))))
(define csegen-1489(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1491) (csegen-1494) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1491) (csegen-1494) arg-4 arg-5)))))))
(define csegen-527(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) arg-4 arg-5)))))))
(define csegen-3213(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1494) (csegen-225) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1494) (csegen-225) arg-4 arg-5)))))))
(define csegen-790(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-792) (csegen-795) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-792) (csegen-795) arg-4 arg-5)))))))
(define csegen-1819(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-17) (csegen-17) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-17) (csegen-17) arg-4 arg-5)))))))
(define csegen-2124(blodwen-lazy (lambda () (cons (csegen-742) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2074) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-2074) u--d u--x))))))))
(define csegen-3595(blodwen-lazy (lambda () (cons (csegen-742) (csegen-1280)))))
(define csegen-50(blodwen-lazy (lambda () (cons (csegen-51) (csegen-65)))))
(define csegen-3740(blodwen-lazy (lambda () (cons (csegen-51) (cons (lambda (arg-2) (lambda (arg-3) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-2 arg-3))) (CompilerC-45ESC-45Doc-u--neutral_Monoid_Doc))))))
(define csegen-67(blodwen-lazy (lambda () (cons (csegen-51) (csegen-68)))))
(define csegen-3271(blodwen-lazy (lambda () (cons (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (DataC-45List1-u--foldr_Foldable_List1 u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (DataC-45List1-u--foldl_Foldable_List1 u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-1176) (DataC-45List1-u--null_Foldable_List1 arg-1176))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (DataC-45List1-u--foldlM_Foldable_List1 i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-1180) (DataC-45List1-u--toList_Foldable_List1 arg-1180))) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-1182) (DataC-45List1-u--foldMap_Foldable_List1 i_con-0 u--f arg-1182))))))) (csegen-65)))))
(define csegen-307(blodwen-lazy (lambda () (vector 11 1 (LibrariesC-45TextC-45Parser-match (csegen-290) (box #\?)) (lambda () (vector 11 0 (csegen-306) (lambda () (vector 0 0))))))))
(define csegen-2519(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "export"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "export")) (else "export")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "public") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "export"))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "modifier. By default, all names are") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc0 (DataC-45String-isSuffixOf "\xa;" "private"))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "private")) (else "private")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "in namespace blocks.")))))))))
(define csegen-1510(blodwen-lazy (lambda () (cons (csegen-246) (csegen-748)))))
(define csegen-1499(blodwen-lazy (lambda () (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1502) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1502) u--d u--x))))))))
(define csegen-500(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-502) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-502) arg-2375 eta-0)))))))
(define csegen-1333(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-2375 eta-0)))))))
(define csegen-1447(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1449) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1449) arg-2375 eta-0)))))))
(define csegen-35(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-37) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-37) arg-2375 eta-0)))))))
(define csegen-2004(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2006) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2006) arg-2375 eta-0)))))))
(define csegen-1988(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1990) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1990) arg-2375 eta-0)))))))
(define csegen-1269(blodwen-lazy (lambda () (cons (csegen-3) (csegen-745)))))
(define csegen-1393(blodwen-lazy (lambda () (cons (csegen-737) (csegen-1383)))))
(define csegen-1021(blodwen-lazy (lambda () (cons (csegen-51) (csegen-597)))))
(define csegen-288(blodwen-lazy (lambda () (vector 9 1 (csegen-289) (lambda () (lambda (u--server) (vector 11 1 (LibrariesC-45UtilsC-45Path-bodySeparator) (lambda () (vector 9 0 (csegen-289) (lambda () (lambda (u--share) (vector 0 (vector 0 u--server u--share)))))))))))))
(define csegen-2070(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2072) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-2072) u--d u--x)))))))
(define csegen-2225(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1280) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-1280) u--d u--x)))))))
(define csegen-1826(blodwen-lazy (lambda () (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (csegen-1280) u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (csegen-1280) u--d u--x)))))))
(define csegen-1468(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1470) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1470) arg-2375 eta-0)))))))
(define csegen-1992(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1994) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1994) arg-2375 eta-0)))))))
(define csegen-1415(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1417) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1417) arg-2375 eta-0)))))))
(define csegen-1997(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1999) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1999) arg-2375 eta-0)))))))
(define csegen-1472(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1474) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1474) arg-2375 eta-0)))))))
(define csegen-1351(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1353) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1353) arg-2375 eta-0)))))))
(define csegen-464(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-466) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-466) arg-2375 eta-0)))))))
(define csegen-1338(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1340) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1340) arg-2375 eta-0)))))))
(define csegen-510(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-512) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-512) arg-2375 eta-0)))))))
(define csegen-2316(blodwen-lazy (lambda () (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))))
(define csegen-1456(blodwen-lazy (lambda () (cons (csegen-38) (csegen-35)))))
(define csegen-2184(blodwen-lazy (lambda () (cons (csegen-1826) (csegen-737)))))
(define csegen-2466(blodwen-lazy (lambda () (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1283) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-1283) u--d u--x))))))))
(define csegen-3599(blodwen-lazy (lambda () (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2095) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-2095) u--d u--x))))))))
(define csegen-1825(blodwen-lazy (lambda () (cons (csegen-737) (csegen-1826)))))
(define csegen-3630(blodwen-lazy (lambda () (cons (csegen-1503) (csegen-1826)))))
(define csegen-957(blodwen-lazy (lambda () (cons (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (csegen-954) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (csegen-954) u--d u--x)))) (csegen-961)))))
(define csegen-1348(blodwen-lazy (lambda () (cons (csegen-38) (csegen-1338)))))
(define csegen-1979(blodwen-lazy (lambda () (cons (csegen-479) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1982) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1982) arg-2375 eta-0))))))))
(define csegen-2253(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-2255) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45Types-u--C-47C-61_Eq_C-40ListC-32C-36aC-41 (csegen-2255) arg-4 arg-5)))))))
(define csegen-1438(blodwen-lazy (lambda () (cons (csegen-1439) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1444) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1444) arg-2375 eta-0))))))))
(define csegen-1271(blodwen-lazy (lambda () (cons (csegen-3) (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-1262) u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-1262) u--d u--x))))))))
(define csegen-1901(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1897) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (CoreC-45Reflect-u--reify_Reify_RigCount eta-8 eta-9 eta-10 eta-11))))) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-12) (lambda (eta-13) (lambda (eta-14) (lambda (eta-15) (CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (csegen-1896) eta-12 eta-13 eta-14 eta-15))))) (csegen-1896)) eta-8 eta-9 eta-10 eta-11)))))) eta-4 eta-5 eta-6 eta-7)))))) eta-0 eta-1 eta-2 eta-3))))))))
(define csegen-2131(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2133) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2133) u--d u--x)))))))
(define csegen-2233(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2235) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2235) u--d u--x)))))))
(define csegen-2212(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2214) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2214) u--d u--x)))))))
(define csegen-3607(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3609) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3609) u--d u--x)))))))
(define csegen-3606(blodwen-lazy (lambda () (cons (csegen-737) (csegen-3607)))))
(define csegen-2156(blodwen-lazy (lambda () (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--map_Functor_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2144) u--func arg-215 eta-0)))))) (lambda (u--a) (lambda (arg-609) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) arg-609 eta-0)))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-60C-42C-62_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) arg-610 arg-612 eta-0))))))))))
(define csegen-1308(blodwen-lazy (lambda () (cons (csegen-1309) (csegen-1309)))))
(define csegen-219(blodwen-lazy (lambda () (cons (vector (csegen-190) (lambda (arg-157) (lambda (arg-158) (PreludeC-45Num-u--div_Integral_Int arg-157 arg-158))) (lambda (arg-159) (lambda (arg-160) (PreludeC-45Num-u--mod_Integral_Int arg-159 arg-160)))) (cons (csegen-224) (vector (csegen-190) (lambda (arg-45) (bs- 0 arg-45 63)) (lambda (arg-46) (lambda (arg-47) (bs- arg-46 arg-47 63)))))))))
(define csegen-2081(blodwen-lazy (lambda () (cons (csegen-2082) (vector (lambda (u--c) (lambda (u--vars) (lambda (arg-1928) (lambda (arg-1929) (lambda (arg-1931) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure u--c u--vars arg-1928 arg-1929 arg-1931 eta-0))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-1936) (lambda (arg-1937) (lambda (arg-1939) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteLHS_Quote_Closure u--c u--vars arg-1936 arg-1937 arg-1939 eta-0))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-1942) (lambda (arg-1943) (lambda (arg-1944) (lambda (arg-1946) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_Closure u--c u--vars arg-1942 arg-1943 arg-1944 arg-1946 eta-0)))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-1950) (lambda (arg-1953) (lambda (arg-1954) (lambda (arg-1955) (lambda (arg-1957) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure u--c u--vars arg-1950 arg-1953 arg-1954 arg-1955 arg-1957 eta-0))))))))))))))
(define csegen-3749(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-883) arg-2 arg-3))) (LibrariesC-45DataC-45SortedSet-u--neutral_Monoid_C-40SortedSetC-32C-36kC-41 (csegen-883))))))
(define csegen-3862(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-3217) arg-2 arg-3))) (LibrariesC-45DataC-45SortedSet-u--neutral_Monoid_C-40SortedSetC-32C-36kC-41 (csegen-3217))))))
(define csegen-770(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-772) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (csegen-772) u--d u--x)))))))
(define csegen-1869(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1871) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1871) arg-2375 eta-0)))))))
(define csegen-1464(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1466) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1466) arg-2375 eta-0)))))))
(define csegen-3614(blodwen-lazy (lambda () (cons (csegen-742) (csegen-3607)))))
(define csegen-1925(blodwen-lazy (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1920) (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (lambda (eta-13) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-14) (lambda (eta-15) (lambda (eta-16) (lambda (eta-17) (lambda (eta-18) (lambda (eta-19) (CoreC-45Reflect-u--reflect_Reflect_RigCount eta-14 eta-15 eta-16 eta-17 eta-18 eta-19))))))) (lambda (eta-14) (lambda (eta-15) (lambda (eta-16) (lambda (eta-17) (lambda (eta-18) (lambda (eta-19) (lambda (eta-20) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-21) (lambda (eta-22) (lambda (eta-23) (lambda (eta-24) (lambda (eta-25) (lambda (eta-26) (CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (csegen-1919) eta-21 eta-22 eta-23 eta-24 eta-25 eta-26))))))) (csegen-1919)) eta-14 eta-15 eta-16 eta-17 eta-18 eta-19 eta-20))))))))) eta-7 eta-8 eta-9 eta-10 eta-11 eta-12 eta-13))))))))) eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))))))
(define csegen-2014(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2016) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2016) arg-2375 eta-0)))))))
(define csegen-1332(blodwen-lazy (lambda () (cons (csegen-1333) (csegen-1333)))))
(define csegen-1850(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_RigCount arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-2375 eta-0)))) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1856) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1856) arg-2375 eta-0))))))))
(define csegen-1424(blodwen-lazy (lambda () (cons (csegen-1425) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1430) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1430) arg-2375 eta-0))))))))
(define csegen-2121(blodwen-lazy (lambda () (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2124) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2124) u--d u--x))))))))
(define csegen-33(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-35) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-35) arg-2375 eta-0)))))))
(define csegen-462(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-464) arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-464) arg-2375 eta-0)))))))
(define csegen-1484(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1486) (csegen-1489) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1486) (csegen-1489) arg-4 arg-5)))))))
(define csegen-3748(blodwen-lazy (lambda () (cons (csegen-51) (csegen-3749)))))
(define csegen-3861(blodwen-lazy (lambda () (cons (csegen-51) (csegen-3862)))))
(define csegen-3753(blodwen-lazy (lambda () (cons (csegen-3705) (csegen-3749)))))
(define csegen-3866(blodwen-lazy (lambda () (cons (csegen-3705) (csegen-3862)))))
(define csegen-2182(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2184) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2184) u--d u--x)))))))
(define csegen-1454(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1456) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1456) arg-2375 eta-0)))))))
(define csegen-1258(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-62C-62 (csegen-87) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) 0) (PreludeC-45IO-putStrLn (csegen-3) (YaffleC-45Main-usage)) eta-0)) (lambda () (csegen-1214))))))
(define csegen-1977(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1979) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1979) arg-2375 eta-0)))))))
(define csegen-3627(blodwen-lazy (lambda () (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3630) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3630) u--d u--x))))))))
(define csegen-1436(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1438) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1438) arg-2375 eta-0)))))))
(define csegen-2155(blodwen-lazy (lambda () (vector (csegen-2156) (lambda (u--b) (lambda (u--a) (lambda (arg-893) (lambda (arg-894) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) arg-893 arg-894 eta-0)))))) (lambda (u--a) (lambda (arg-896) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--join_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) arg-896 eta-0))))))))
(define csegen-2231(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2233) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-2233) u--d u--x)))))))
(define csegen-2251(blodwen-lazy (lambda () (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-802) (csegen-2253) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-802) (csegen-2253) arg-4 arg-5)))))))
(define csegen-3604(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3606) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3606) u--d u--x)))))))
(define csegen-1303(blodwen-lazy (lambda () (cons (cons (lambda (u--x) (CoreC-45FC-u--show_Show_OriginDesc u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45FC-u--showPrec_Show_OriginDesc u--d u--x)))) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1308) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1308) u--d u--x))))))))
(define csegen-494(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-2375 eta-0)))) (lambda (u--y) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-2371) (lambda (arg-2374) (CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 u--y arg-2371 arg-2374))) (lambda (arg-2375) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 u--y arg-2375 eta-1)))) (cons (lambda (arg-2371) (lambda (arg-2374) (lambda (eta-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-2372) (lambda (arg-2375) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2372 arg-2375))) (lambda (arg-2375) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2375 eta-2)))) (cons (lambda (arg-2372) (lambda (arg-2375) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2372 arg-2375))) (lambda (arg-2375) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2375 eta-2))))) arg-2371 arg-2374 eta-1)))) (lambda (arg-2375) (lambda (eta-1) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-2371) (lambda (arg-2374) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2371 arg-2374))) (lambda (arg-2376) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2376 eta-2)))) (cons (lambda (arg-2371) (lambda (arg-2374) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2371 arg-2374))) (lambda (arg-2376) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2376 eta-2))))) arg-2375 eta-1))))) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 u--y arg-2370 arg-2373))) (lambda (arg-2376) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 u--y arg-2376 eta-1)))) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-2371) (lambda (arg-2374) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2371 arg-2374))) (lambda (arg-2376) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2376 eta-2)))) (cons (lambda (arg-2371) (lambda (arg-2374) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2371 arg-2374))) (lambda (arg-2376) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2376 eta-2))))) arg-2370 arg-2373 eta-1)))) (lambda (arg-2376) (lambda (eta-1) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2370 arg-2373))) (lambda (arg-2377) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2377 eta-2)))) (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2370 arg-2373))) (lambda (arg-2377) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-2377 eta-2))))) arg-2376 eta-1))))) arg-2375 eta-0)))))))))
(define csegen-2230(blodwen-lazy (lambda () (cons (csegen-2225) (csegen-2231)))))
(define csegen-1422(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1424) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1424) arg-2375 eta-0)))))))
(define csegen-1847(blodwen-lazy (lambda () (cons (csegen-38) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1850) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1850) arg-2375 eta-0))))))))
(define csegen-1326(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_OriginDesc arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_OriginDesc arg-2375 eta-0)))) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1332) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1332) arg-2375 eta-0))))))))
(define csegen-2180(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-2182) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (csegen-2182) u--d u--x)))))))
(define csegen-3625(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3627) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3627) u--d u--x)))))))
(define csegen-2266(blodwen-lazy (lambda () (vector (csegen-2255) (lambda (arg-418) (lambda (arg-419) (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45Types-u--C-60_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45Types-u--C-62_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45Types-u--C-60C-61_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45Types-u--C-62C-61_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45Types-u--max_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45Types-u--min_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) arg-430 arg-431)))))))
(define csegen-1301(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1303) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1303) u--d u--x)))))))
(define csegen-1402(blodwen-lazy (lambda () (cons (csegen-1301) (csegen-737)))))
(define csegen-492(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40DPairC-32C-36aC-41C-32C-36pC-41 (csegen-494) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40DPairC-32C-36aC-41C-32C-36pC-41 (csegen-494) arg-2375 eta-0)))))))
(define csegen-1382(blodwen-lazy (lambda () (cons (csegen-1301) (csegen-1383)))))
(define csegen-1300(blodwen-lazy (lambda () (cons (csegen-1301) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1316) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1316) u--d u--x))))))))
(define csegen-1845(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1847) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1847) arg-2375 eta-0)))))))
(define csegen-1324(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1326) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1326) arg-2375 eta-0)))))))
(define csegen-2224(blodwen-lazy (lambda () (cons (csegen-2225) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2230) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2230) u--d u--x))))))))
(define csegen-1358(blodwen-lazy (lambda () (cons (csegen-1324) (csegen-38)))))
(define csegen-1390(blodwen-lazy (lambda () (cons (csegen-1301) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1393) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1393) u--d u--x))))))))
(define csegen-1323(blodwen-lazy (lambda () (cons (csegen-1324) (csegen-1338)))))
(define csegen-1363(blodwen-lazy (lambda () (cons (csegen-1324) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1366) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1366) arg-2375 eta-0))))))))
(define csegen-3622(blodwen-lazy (lambda () (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-3625) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-3625) u--d u--x))))))))
(define csegen-1345(blodwen-lazy (lambda () (cons (csegen-1324) (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1348) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1348) arg-2375 eta-0))))))))
(define csegen-526(blodwen-lazy (lambda () (vector (csegen-527) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-430 arg-431)))))))
(define csegen-3212(blodwen-lazy (lambda () (vector (csegen-3213) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3217) (csegen-224) arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3217) (csegen-224) arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3217) (csegen-224) arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3217) (csegen-224) arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3217) (csegen-224) arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3217) (csegen-224) arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3217) (csegen-224) arg-430 arg-431)))))))
(define csegen-1406(blodwen-lazy (lambda () (cons (csegen-1301) (csegen-1301)))))
(define csegen-1298(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1300) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1300) u--d u--x)))))))
(define csegen-1378(blodwen-lazy (lambda () (cons (csegen-1324) (csegen-1324)))))
(define csegen-1355(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1358) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1358) arg-2375 eta-0)))) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0))))))
(define csegen-1388(blodwen-lazy (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1390) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1390) u--d u--x)))))))
(define csegen-1321(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1323) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1323) arg-2375 eta-0)))))))
(define csegen-1360(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1363) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1363) arg-2375 eta-0)))) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0))))))
(define csegen-1343(blodwen-lazy (lambda () (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1345) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1345) arg-2375 eta-0)))))))
(define csegen-1375(blodwen-lazy (lambda () (cons (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1378) arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1378) arg-2375 eta-0)))) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0))))))
(define csegen-2264(blodwen-lazy (lambda () (vector (csegen-2253) (lambda (arg-418) (lambda (arg-419) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-2266) arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45Types-u--C-60_Ord_C-40ListC-32C-36aC-41 (csegen-2266) arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45Types-u--C-62_Ord_C-40ListC-32C-36aC-41 (csegen-2266) arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45Types-u--C-60C-61_Ord_C-40ListC-32C-36aC-41 (csegen-2266) arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45Types-u--C-62C-61_Ord_C-40ListC-32C-36aC-41 (csegen-2266) arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45Types-u--max_Ord_C-40ListC-32C-36aC-41 (csegen-2266) arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45Types-u--min_Ord_C-40ListC-32C-36aC-41 (csegen-2266) arg-430 arg-431)))))))
(define u--prim__add_Integer (lambda (arg-0 arg-1) (+ arg-0 arg-1)))
(define u--prim__sub_Integer (lambda (arg-0 arg-1) (- arg-0 arg-1)))
(define u--prim__mul_Integer (lambda (arg-0 arg-1) (* arg-0 arg-1)))
(define IdrisC-45Main-main (lambda (ext-0) (IdrisC-45Driver-mainWithCodegens '() ext-0)))
(define CompilerC-45Common-case--castInt-3627 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-6 0) ((25) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (let ((e-1 (vector-ref arg-3 1))) ((e-1 e-9) arg-0))) ((24) (let ((e-10 (vector-ref arg-3 3))) ((e-10 e-9) arg-0))) ((26) (let ((e-5 (vector-ref arg-3 5))) ((e-5 e-9) arg-0)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-3 6))) (((e-8 e-9) e-15) arg-0))))))))))) (let ((e-19 (cdr e-3))) (if (null? e-19) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (let ((e-1 (vector-ref arg-3 1))) ((e-1 e-9) arg-0))) ((24) (let ((e-10 (vector-ref arg-3 3))) ((e-10 e-9) arg-0))) ((26) (let ((e-5 (vector-ref arg-3 5))) ((e-5 e-9) arg-0)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-3 6))) (((e-8 e-9) e-15) arg-0))))))))))) (let ((e-21 (unbox e-19))) (let ((e-0 (vector-ref arg-3 0))) ((e-0 e-21) arg-0))))))) ((24) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (let ((e-1 (vector-ref arg-3 1))) ((e-1 e-9) arg-0))) ((24) (let ((e-10 (vector-ref arg-3 3))) ((e-10 e-9) arg-0))) ((26) (let ((e-5 (vector-ref arg-3 5))) ((e-5 e-9) arg-0)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-3 6))) (((e-8 e-9) e-15) arg-0))))))))))) (let ((e-25 (cdr e-3))) (if (null? e-25) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (let ((e-1 (vector-ref arg-3 1))) ((e-1 e-9) arg-0))) ((24) (let ((e-10 (vector-ref arg-3 3))) ((e-10 e-9) arg-0))) ((26) (let ((e-5 (vector-ref arg-3 5))) ((e-5 e-9) arg-0)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-3 6))) (((e-8 e-9) e-15) arg-0))))))))))) (let ((e-27 (unbox e-25))) (let ((e-10 (vector-ref arg-3 2))) ((e-10 e-27) arg-0))))))) ((26) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (let ((e-1 (vector-ref arg-3 1))) ((e-1 e-9) arg-0))) ((24) (let ((e-10 (vector-ref arg-3 3))) ((e-10 e-9) arg-0))) ((26) (let ((e-5 (vector-ref arg-3 5))) ((e-5 e-9) arg-0)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-3 6))) (((e-8 e-9) e-15) arg-0))))))))))) (let ((e-31 (cdr e-3))) (if (null? e-31) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (let ((e-1 (vector-ref arg-3 1))) ((e-1 e-9) arg-0))) ((24) (let ((e-10 (vector-ref arg-3 3))) ((e-10 e-9) arg-0))) ((26) (let ((e-5 (vector-ref arg-3 5))) ((e-5 e-9) arg-0)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-3 6))) (((e-8 e-9) e-15) arg-0))))))))))) (let ((e-33 (unbox e-31))) (let ((e-4 (vector-ref arg-3 4))) ((e-4 e-33) arg-0)))))))(else (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (let ((e-1 (vector-ref arg-3 1))) ((e-1 e-9) arg-0))) ((24) (let ((e-10 (vector-ref arg-3 3))) ((e-10 e-9) arg-0))) ((26) (let ((e-5 (vector-ref arg-3 5))) ((e-5 e-9) arg-0)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "invalid cast: + " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant arg-2) (PreludeC-45TypesC-45String-C-43C-43 " + ' -> ' + " (CoreC-45TT-u--show_Show_Constant arg-1))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-3 6))) (((e-8 e-9) e-15) arg-0)))))))))))))))))))))
(define CompilerC-45Common-case--getExtraRuntimeC-44getArg-3339 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String (DataC-45String-trim e-2) "extraRuntime"))) (cond ((equal? sc1 1) (box (DataC-45String-trim (PreludeC-45Types-substr (+ 1 0) (PreludeC-45TypesC-45String-length e-3) e-3)))) (else '())))))))
(define CompilerC-45Common-case--locate-3105 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) "" (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (let ((sc2 (PreludeC-45Types-elem (csegen-0) #\. (PreludeC-45Types-fastUnpack e-2)))) (cond ((equal? sc2 1) e-2) (else (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 "." (CompilerC-45Common-dylib_suffix)))))) (let ((e-6 (car e-3))) (CoreC-45Core-cond (cons (cons (lambda () (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CompilerC-45Common-dylib_suffix) "dll")) (lambda () (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 e-6 ".dll"))))) (cons (cons (lambda () (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CompilerC-45Common-dylib_suffix) "dylib")) (lambda () (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 "." (PreludeC-45TypesC-45String-C-43C-43 e-6 ".dylib"))))) '())) (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 "." (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45Common-dylib_suffix) (PreludeC-45TypesC-45String-C-43C-43 "." e-6))))))))))))
(define CompilerC-45Common-case--caseC-32blockC-32inC-32parseCCC-44findTarget-2974 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (cond ((equal? e-3 "") (box (cons (DataC-45String-trim e-2) '())))(else (box (cons (DataC-45String-trim e-2) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (DataC-45String-trim eta-0)) (CompilerC-45Common-n--11760-2848-u--getOpts arg-0 arg-1 arg-2 (DataC-45String-strTail e-3)))))))))))
(define CompilerC-45Common-case--parseCCC-44getOpts-2867 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (cond ((equal? e-3 "") (cons e-2 '()))(else (cons e-2 (CompilerC-45Common-n--11760-2848-u--getOpts arg-0 arg-1 arg-2 (DataC-45String-strTail e-3)))))))))
(define CompilerC-45Common-n--9118-610-u--tag (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-2 0) 0) ((equal? arg-2 1) 1) ((equal? arg-2 2) 2) (else 3))))
(define CompilerC-45Common-n--12290-3326-u--readPath (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) arg-1) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (vector 1 e-2))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 e-6) ext-0))))))))))
(define CompilerC-45Common-n--12290-3325-u--paths (lambda (arg-0) (DataC-45List-nub (csegen-17) (DataC-45List-mapMaybe (lambda (eta-0) (CompilerC-45Common-n--12290-3324-u--getArg arg-0 eta-0)) (PreludeC-45TypesC-45List-reverse arg-0)))))
(define CompilerC-45Common-n--11760-2849-u--hasTarget (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (DataC-45String-span (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-5 #\:)) arg-4))) (let ((e-2 (car sc0))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 arg-3)))))
(define CompilerC-45Common-n--11760-2848-u--getOpts (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-3 "") '())(else (CompilerC-45Common-case--parseCCC-44getOpts-2867 arg-0 arg-1 arg-2 arg-3 (DataC-45String-span (lambda (arg-4) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-4 #\,)) arg-3))))))
(define CompilerC-45Common-n--12290-3324-u--getArg (lambda (arg-0 arg-1) (CompilerC-45Common-case--getExtraRuntimeC-44getArg-3339 arg-0 arg-1 (DataC-45String-break (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 #\=)) arg-1))))
(define CompilerC-45Common-n--9894-1223-u--fullShow (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((4) (let ((e-1 (vector-ref arg-4 2))) (CoreC-45Name-u--show_Show_Name e-1)))(else (CoreC-45Name-u--show_Show_Name arg-4)))))
(define CompilerC-45Common-n--11760-2850-u--findTarget (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (CompilerC-45Common-n--11760-2849-u--hasTarget arg-0 arg-1 arg-2 arg-3 e-2))) (cond ((equal? sc1 1) (CompilerC-45Common-case--caseC-32blockC-32inC-32parseCCC-44findTarget-2974 arg-0 arg-1 arg-2 e-2 e-3 arg-3 (DataC-45String-span (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-5 #\:)) e-2))) (else (CompilerC-45Common-n--11760-2850-u--findTarget arg-0 arg-1 arg-2 arg-3 e-3)))))))))
(define CompilerC-45Common-n--9894-1224-u--dumpDef (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45Common-n--9894-1223-u--fullShow arg-1 arg-2 arg-3 e-2) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-1 (car arg-1))) (e-1 e-3)) "\xa;")))))))
(define CompilerC-45Common-u--max_Ord_UsePhase (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45Common-u--C-62_Ord_UsePhase arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CompilerC-45Common-u--compare_Ord_UsePhase (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Int (CompilerC-45Common-n--9118-610-u--tag arg-1 arg-0 arg-0) (CompilerC-45Common-n--9118-610-u--tag arg-1 arg-0 arg-1))))
(define CompilerC-45Common-u--C-62_Ord_UsePhase (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CompilerC-45Common-u--compare_Ord_UsePhase arg-0 arg-1) 2)))
(define CompilerC-45Common-u--C-62C-61_Ord_UsePhase (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CompilerC-45Common-u--compare_Ord_UsePhase arg-0 arg-1) 0)))
(define CompilerC-45Common-warnIfHole (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((3) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Warning: compiling hole " (CoreC-45Name-u--show_Show_Name arg-0))) ext-0))) (vector 1 act-24)))(else (vector 1 0)))))
(define CompilerC-45Common-replaceEntry (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (lambda (clam-0) (if (null? e-3) (vector 1 0) (let ((e-6 (unbox e-3))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addContextEntry arg-0 e-9 (vector 8 e-2) e-10 eta-0)) clam-0))))))))))
(define CompilerC-45Common-parseCC (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (CompilerC-45Common-n--11760-2850-u--findTarget e-2 e-3 arg-1 e-2 arg-1) (lambda () (CompilerC-45Common-parseCC e-3 arg-1))))))))
(define CompilerC-45Common-nonErased (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 1) (let ((e-1 (unbox e-6))) (vector 1 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (let ((e-7 (vector-ref e-1 7))) e-7) (csegen-21)))))))))))))))
(define CompilerC-45Common-natHackNames(blodwen-lazy (lambda () (cons (vector 1 (vector 0 "prim__add_Integer")) (cons (vector 1 (vector 0 "prim__sub_Integer")) (cons (vector 1 (vector 0 "prim__mul_Integer")) (cons (csegen-29) '())))))))
(define CompilerC-45Common-locate (lambda (arg-0 arg-1) (let ((u--fname (CompilerC-45Common-case--locate-3105 arg-1 arg-0 (DataC-45String-words arg-1)))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (CoreC-45Directory-findLibraryFile arg-0 u--fname eta-1)) (lambda (u--err) (lambda (eta-1) (vector 1 u--fname))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons u--fname e-5))))))))))
(define CompilerC-45Common-incCompile (lambda (arg-0 arg-1 arg-2) (let ((e-2 (vector-ref arg-1 2))) (if (null? e-2) (lambda (eta-0) (vector 1 '())) (let ((e-4 (unbox e-2))) ((e-4 arg-0) arg-2))))))
(define CompilerC-45Common-getNamedDef (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--ndef (CoreC-45CompileExpr-forgetDef e-7))) (lambda (eta-0) (let ((act-24 (CompilerC-45Common-warnIfHole e-2 u--ndef eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 (cons e-2 (cons e-6 u--ndef))))))))))))))
(define CompilerC-45Common-getMinimalDef (lambda (arg-0 ext-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (vector 1 (cons e-0 '())))) (else (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-30) e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-33) e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--refsR (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45DataC-45NameMap-fromList eta-0)) e-7))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_FC e-5 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_RigCount e-5 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45TTC-u--fromBuf_TTC_Name e-5 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--def (vector e-8 e-10 (vector 10 e-8 0) '() '() '() '() e-9 '() 2 (cons (vector 0 ) (vector 0 )) '() '() u--refsR 0 0 1 (vector 0 ) e-6 '() '() '()))) (vector 1 (cons u--def (box (cons e-1 e-2))))))))))))))))))))))))))))))))))))
(define CompilerC-45Common-getIncCompileData (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ns (LibrariesC-45DataC-45NameMap-keys (let ((e-24 (vector-ref e-5 24))) e-24)))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-0 (csegen-46) eta-0 eta-1))) u--ns '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-filterM (lambda (eta-0) (lambda (eta-1) (CompilerC-45Common-nonErased arg-0 eta-0 eta-1))) e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-49) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45Common-compDef arg-0 eta-1 eta-2))) e-7 '() eta-0)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45Common-getNamedDef arg-0 eta-0)) e-8 '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((sc5 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase arg-2 1))) (cond ((equal? sc5 1) (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Lambda lift") (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45LambdaLift-lambdaLift arg-0 arg-1 eta-1)) e-8 '() eta-0)) ext-0)) (else (vector 1 '())))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--lifted (PreludeC-45Interfaces-concat (csegen-50) e-10))) (let ((act-30 (let ((sc6 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase arg-2 2))) (cond ((equal? sc6 1) (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Get ANF") (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-30 (CompilerC-45ANF-toANF e-3 clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (vector 1 (cons e-2 e-11)))))))))) u--lifted '() eta-0)) ext-0)) (else (vector 1 '())))))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((sc7 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase arg-2 3))) (cond ((equal? sc7 1) (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Get VM Code") (lambda (eta-0) (vector 1 (CompilerC-45VMCode-allDefs e-11))) ext-0)) (else (vector 1 '())))))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (vector (vector 13 (CoreC-45FC-emptyFC)) e-9 u--lifted e-11 e-12))))))))))))))))))))))))))))))))))))))
(define CompilerC-45Common-getExtraRuntime (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45Common-n--12290-3326-u--readPath arg-0 eta-0 eta-1))) (CompilerC-45Common-n--12290-3325-u--paths arg-0) '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-67) (DataC-45List-intersperse "\xa;" e-5)))))))))
(define CompilerC-45Common-getCompileData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--phase (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (PreludeC-45Types-maybe (lambda () (lambda (eta-3) eta-3)) (lambda () (lambda (eta-3) (lambda (eta-4) (CompilerC-45Common-u--max_Ord_UsePhase eta-3 eta-4)))) eta-2)) eta-0 eta-1))) arg-2 (cons (PreludeC-45Interfaces-C-60C-36 (csegen-73) 0 (let ((e-12 (vector-ref e-6 12))) e-12)) (cons (PreludeC-45Interfaces-C-60C-36 (csegen-73) 1 (let ((e-13 (vector-ref e-6 13))) e-13)) (cons (PreludeC-45Interfaces-C-60C-36 (csegen-73) 2 (let ((e-14 (vector-ref e-6 14))) e-14)) (cons (PreludeC-45Interfaces-C-60C-36 (csegen-73) 3 (let ((e-15 (vector-ref e-6 15))) e-15)) '()))))))) (let ((u--ns (CoreC-45TT-getRefs (vector 8 -1) arg-3))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) arg-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toResolvedNames arg-0 (csegen-46) eta-0 eta-1))) (CompilerC-45Common-natHackNames) '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-getNextEntry arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((LibrariesC-45DataC-45IOArray-newArray (csegen-3) e-9) ext-0))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Get names") (CompilerC-45Common-getAllDesc arg-0 (PreludeC-45TypesC-45List-tailRecAppend e-8 (LibrariesC-45DataC-45NameMap-keys u--ns)) e-10 e-5) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (let ((act-31 ((LibrariesC-45DataC-45IOArray-toList (csegen-3) e-10) ext-0))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((u--entries (DataC-45List-catMaybes e-12))) (let ((u--allNs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 8 (Builtin-fst eta-0))) u--entries))) (let ((act-32 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-0 (csegen-46) eta-0 eta-1))) u--allNs '() ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Core-filterM (lambda (eta-0) (lambda (eta-1) (CompilerC-45Common-nonErased arg-0 eta-0 eta-1))) e-13 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Merge lambda") (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-mergeLamDef arg-0 eta-1 eta-2))) e-14 eta-0)) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Fix arity") (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-fixArityDef arg-0 eta-1 eta-2))) e-14 eta-0)) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 (let ((act-36 (CompilerC-45CompileExpr-compileExp arg-0 e-7 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) ((CompilerC-45Inline-fixArityExp '() arg-0 e-17) ext-0))))))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ CSE") (lambda (eta-0) (CompilerC-45OptsC-45CSE-cse arg-0 e-14 e-17 eta-0)) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-37 1))) (let ((e-2 (car e-18))) (let ((e-3 (cdr e-18))) (let ((act-38 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Forget names") (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Common-getNamedDef arg-0 eta-1)) e-2 '() eta-0)) ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-38 1))) (let ((u--mainname (vector 2 "__mainExpression" 0))) (let ((act-39 (CompilerC-45LambdaLift-liftBody '() arg-1 u--mainname e-3 ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-39 1))) (let ((e-21 (car e-20))) (let ((e-4 (cdr e-20))) (let ((act-40 (let ((sc18 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase u--phase 1))) (cond ((equal? sc18 1) (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Lambda lift") (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45LambdaLift-lambdaLift arg-0 arg-1 eta-1)) e-2 '() eta-0)) ext-0)) (else (vector 1 '())))))) (case (vector-ref act-40 0) ((0) (let ((e-22 (vector-ref act-40 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-40 1))) (let ((u--lifted (cons (cons u--mainname (vector 0 '() '() e-21)) (PreludeC-45TypesC-45List-tailRecAppend e-4 (PreludeC-45Interfaces-concat (csegen-50) e-22))))) (let ((act-41 (let ((sc19 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase u--phase 2))) (cond ((equal? sc19 1) (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Get ANF") (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-24 (car lamc-0))) (let ((e-23 (cdr lamc-0))) (let ((act-41 (CompilerC-45ANF-toANF e-23 clam-0))) (case (vector-ref act-41 0) ((0) (let ((e-25 (vector-ref act-41 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-41 1))) (vector 1 (cons e-24 e-25)))))))))) u--lifted '() eta-0)) ext-0)) (else (vector 1 '())))))) (case (vector-ref act-41 0) ((0) (let ((e-23 (vector-ref act-41 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-41 1))) (let ((act-42 (let ((sc20 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase u--phase 3))) (cond ((equal? sc20 1) (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Get VM Code") (lambda (eta-0) (vector 1 (CompilerC-45VMCode-allDefs e-23))) ext-0)) (else (vector 1 '())))))) (case (vector-ref act-42 0) ((0) (let ((e-24 (vector-ref act-42 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-42 1))) (let ((act-43 (let ((act-43 (unbox arg-0))) (vector 1 act-43)))) (case (vector-ref act-43 0) ((0) (let ((e-25 (vector-ref act-43 1))) (vector 0 e-25))) (else (let ((act-44 (let ((e-37 (vector-ref e-6 12))) (if (null? e-37) (vector 1 0) (let ((e-48 (unbox e-37))) (let ((act-44 (let ((act-44 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Dumping case trees to " e-48)) ext-0))) (vector 1 act-44)))) (case (vector-ref act-44 0) ((0) (let ((e-49 (vector-ref act-44 1))) (vector 0 e-49))) (else ((CompilerC-45Common-dumpIR (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_NamedDef u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_NamedDef u--d u--x)))) e-48 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-51 (car lamc-0))) (let ((e-50 (cdr lamc-0))) (let ((e-52 (cdr e-50))) (cons e-51 e-52))))) e-19)) ext-0))))))))) (case (vector-ref act-44 0) ((0) (let ((e-26 (vector-ref act-44 1))) (vector 0 e-26))) (else (let ((act-45 (let ((e-37 (vector-ref e-6 13))) (if (null? e-37) (vector 1 0) (let ((e-49 (unbox e-37))) (let ((act-45 (let ((act-45 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Dumping lambda lifted defs to " e-49)) ext-0))) (vector 1 act-45)))) (case (vector-ref act-45 0) ((0) (let ((e-50 (vector-ref act-45 1))) (vector 0 e-50))) (else ((CompilerC-45Common-dumpIR (cons (lambda (u--x) (CompilerC-45LambdaLift-u--show_Show_LiftedDef u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45LambdaLift-u--showPrec_Show_LiftedDef u--d u--x)))) e-49 u--lifted) ext-0))))))))) (case (vector-ref act-45 0) ((0) (let ((e-27 (vector-ref act-45 1))) (vector 0 e-27))) (else (let ((act-46 (let ((e-37 (vector-ref e-6 14))) (if (null? e-37) (vector 1 0) (let ((e-50 (unbox e-37))) (let ((act-46 (let ((act-46 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Dumping ANF defs to " e-50)) ext-0))) (vector 1 act-46)))) (case (vector-ref act-46 0) ((0) (let ((e-51 (vector-ref act-46 1))) (vector 0 e-51))) (else ((CompilerC-45Common-dumpIR (cons (lambda (u--x) (CompilerC-45ANF-u--show_Show_ANFDef u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45ANF-u--showPrec_Show_ANFDef u--d u--x)))) e-50 e-23) ext-0))))))))) (case (vector-ref act-46 0) ((0) (let ((e-28 (vector-ref act-46 1))) (vector 0 e-28))) (else (let ((act-47 (let ((e-37 (vector-ref e-6 15))) (if (null? e-37) (vector 1 0) (let ((e-51 (unbox e-37))) (let ((act-47 (let ((act-47 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Dumping VM defs to " e-51)) ext-0))) (vector 1 act-47)))) (case (vector-ref act-47 0) ((0) (let ((e-52 (vector-ref act-47 1))) (vector 0 e-52))) (else ((CompilerC-45Common-dumpIR (cons (lambda (u--x) (CompilerC-45VMCode-u--show_Show_VMDef u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45VMCode-u--showPrec_Show_VMDef u--d u--x)))) e-51 e-24) ext-0))))))))) (case (vector-ref act-47 0) ((0) (let ((e-29 (vector-ref act-47 1))) (vector 0 e-29))) (else (let ((act-48 (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45Common-replaceEntry arg-0 eta-0)) u--entries ext-0))) (case (vector-ref act-48 0) ((0) (let ((e-30 (vector-ref act-48 1))) (vector 0 e-30))) (else (vector 1 (vector e-3 e-19 u--lifted e-23 e-24)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45Common-getAllDesc (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-1) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-4 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((LibrariesC-45DataC-45IOArray-readArray (csegen-3) arg-2 e-4) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (vector 8 e-4))) (if (null? e-5) (let ((act-25 ((CoreC-45Context-lookupContextEntry u--n (let ((e-0 (vector-ref arg-3 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) ((CompilerC-45Common-getAllDesc arg-0 e-3 arg-2 arg-3) eta-0) (let ((e-7 (unbox e-6))) (let ((e-8 (cdr e-7))) (let ((act-26 (CompilerC-45Common-getMinimalDef e-8 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((e-12 (car e-10))) (let ((e-11 (cdr e-10))) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45Context-addDef arg-0 u--n e-12 eta-1)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((sc10 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (let ((e-28 (vector-ref e-12 7))) e-28) (csegen-21)))) (cond ((equal? sc10 1) (let ((act-28 (let ((act-28 ((LibrariesC-45DataC-45IOArray-writeArray (csegen-3) arg-2 e-4 (cons e-4 e-11)) eta-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((u--refs (CoreC-45ContextC-45Context-refersToRuntime e-12))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toResolvedNames arg-0 (csegen-46) eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys u--refs) '() eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-15 (vector-ref act-29 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-29 1))) ((CompilerC-45Common-getAllDesc arg-0 (PreludeC-45TypesC-45List-tailRecAppend e-15 e-3) arg-2 arg-3) eta-0)))))))))) (else ((CompilerC-45Common-getAllDesc arg-0 e-3 arg-2 arg-3) eta-0)))))))))))))))))))) ((CompilerC-45Common-getAllDesc arg-0 e-3 arg-2 arg-3) eta-0))))))))))(else (CompilerC-45Common-getAllDesc arg-0 e-3 arg-2 arg-3))))))))
(define CompilerC-45Common-exists (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45FileC-45Handle-openFile (csegen-3) arg-0 0) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (SystemC-45FileC-45Handle-closeFile (csegen-3) e-2) (lambda () (lambda (eta-0) 1))) ext-0))) (else 0)))))
(define CompilerC-45Common-execute (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--tmpDir (CoreC-45Options-execBuildDir e-5))) (let ((act-25 (CoreC-45Directory-ensureDirectoryExists u--tmpDir ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((e-1 (vector-ref arg-1 1))) ((((e-1 arg-0) u--tmpDir) arg-2) ext-0)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 0))))))))))))))
(define CompilerC-45Common-dylib_suffix(blodwen-lazy (lambda () (CoreC-45Core-cond (cons (cons (lambda () (csegen-93)) (lambda () "dll")) (cons (cons (lambda () (PreludeC-45EqOrd-u--C-61C-61_Eq_String (SystemC-45Info-os) "darwin")) (lambda () "dylib")) '())) "so"))))
(define CompilerC-45Common-dumpIR (lambda (arg-1 arg-2 arg-3) (let ((u--cstrs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45Common-n--9894-1224-u--dumpDef arg-1 arg-3 arg-2 eta-0)) arg-3))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-2 (DataC-45String-fastAppend u--cstrs)) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (vector 1 0))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 e-6) eta-0))))))))))))
(define CompilerC-45Common-copyLib (lambda (arg-0) (lambda (clam-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 e-3))) (cond ((equal? sc1 1) (vector 1 0)) (else (let ((act-24 (let ((act-24 (LibrariesC-45UtilsC-45Binary-readFromFile e-3 clam-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-4 (vector-ref e-5 1))) (let ((act-25 (let ((act-25 ((LibrariesC-45UtilsC-45Binary-writeToFile e-2 e-4) clam-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (vector 1 0)) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-2 e-7) clam-0)))))))))) (else (vector 1 0)))))))))))))))
(define CompilerC-45Common-compileTerm (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-76) arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45CompileExpr-compileExp arg-0 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45Inline-fixArityExp '() arg-0 e-6) ext-0)))))))))))
(define CompilerC-45Common-compile (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--tmpDir (CoreC-45Options-execBuildDir e-5))) (let ((u--outputDir (CoreC-45Options-outputDirWithDefault e-5))) (let ((act-25 (CoreC-45Directory-ensureDirectoryExists u--tmpDir ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Directory-ensureDirectoryExists u--outputDir ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "+ Code generation overall") (let ((e-0 (vector-ref arg-1 0))) (((((e-0 arg-0) u--tmpDir) u--outputDir) arg-2) arg-3)) ext-0)))))))))))))))
(define CompilerC-45Common-compDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((e-18 (vector-ref e-1 18))) (if (null? e-18) (vector 1 '()) (let ((e-25 (unbox e-18))) (vector 1 (box (cons arg-1 (cons (let ((e-47 (vector-ref e-1 0))) e-47) e-25)))))))))))))))))))
(define CompilerC-45Common-castInt (lambda (arg-0 arg-1 arg-2 arg-3) (CompilerC-45Common-case--castInt-3627 arg-3 arg-2 arg-1 arg-0 (cons (cons arg-1 (CoreC-45TT-intKind arg-1)) (cons arg-2 (CoreC-45TT-intKind arg-2))))))
(define SystemC-45FileC-45Virtual-stdout(blodwen-lazy (lambda () (SystemC-45FileC-45Virtual-prim__stdout))))
(define SystemC-45FileC-45Virtual-stdin(blodwen-lazy (lambda () (SystemC-45FileC-45Virtual-prim__stdin))))
(define PreludeC-45Uninhabited-absurd (lambda (arg-2 arg-3) (display "Error: Executed 'void'")))
(define PreludeC-45Basics-uncurry (lambda (arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) ((arg-3 e-2) e-3)))))
(define PreludeC-45Basics-on (lambda (arg-3 arg-4 ext-0 ext-1) ((arg-3 (arg-4 ext-0)) (arg-4 ext-1))))
(define PreludeC-45Basics-flip (lambda (arg-3 arg-4 arg-5) ((arg-3 arg-5) arg-4)))
(define PreludeC-45Basics-curry (lambda (arg-3 arg-4 arg-5) (arg-3 (cons arg-4 arg-5))))
(define PreludeC-45Basics-cong (lambda (arg-5) (cond (else 0))))
(define Builtin-snd (lambda (arg-2) (let ((e-3 (cdr arg-2))) e-3)))
(define Builtin-idris_crash (lambda (ext-0) (blodwen-error-quit (string-append "ERROR: " ext-0))))
(define Builtin-fst (lambda (arg-2) (let ((e-2 (car arg-2))) e-2)))
(define Builtin-believe_me (lambda (ext-0) ext-0))
(define PreludeC-45Types-case--compare-3913 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 1) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-3 arg-5))(else arg-6))))
(define PreludeC-45Types-n--6057-4912-u--hexChars (lambda (arg-0) (cons #\0 (cons #\1 (cons #\2 (cons #\3 (cons #\4 (cons #\5 (cons #\6 (cons #\7 (cons #\8 (cons #\9 (cons #\A (cons #\B (cons #\C (cons #\D (cons #\E (cons #\F '()))))))))))))))))))
(define PreludeC-45Types-u--traverse_Traversable_Maybe (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) '())) (let ((e-2 (unbox arg-5))) (PreludeC-45Interfaces-C-60C-36C-62 (let ((e-1 (vector-ref arg-3 0))) e-1) (lambda (eta-0) (box eta-0)) (arg-4 e-2))))))
(define PreludeC-45Types-u--traverse_Traversable_List (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) '())) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-4 (vector-ref arg-3 2))) ((((e-4 'erased) 'erased) (let ((e-6 (vector-ref arg-3 2))) ((((e-6 'erased) 'erased) (let ((e-10 (vector-ref arg-3 1))) ((e-10 'erased) (csegen-113)))) (arg-4 e-2)))) (PreludeC-45Types-u--traverse_Traversable_List arg-3 arg-4 e-3))))))))
(define PreludeC-45Types-u--traverse_Traversable_C-40EitherC-32C-36eC-41 (lambda (arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-4 1))) ((e-4 'erased) (vector 0 e-2))))) (else (let ((e-5 (vector-ref arg-6 1))) (PreludeC-45Interfaces-C-60C-36C-62 (let ((e-1 (vector-ref arg-4 0))) e-1) (lambda (eta-0) (vector 1 eta-0)) (arg-5 e-5)))))))
(define PreludeC-45Types-u--toList_Foldable_Maybe (lambda (ext-0) (PreludeC-45Types-u--foldr_Foldable_Maybe (csegen-113) '() ext-0)))
(define PreludeC-45Types-u--toList_Foldable_List (lambda (ext-0) ext-0))
(define PreludeC-45Types-u--toList_Foldable_C-40EitherC-32C-36eC-41 (lambda (ext-0) (PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 (csegen-113) '() ext-0)))
(define PreludeC-45Types-u--rangeFrom_Range_Nat (lambda (arg-0) (PreludeC-45Types-countFrom arg-0 (lambda (eta-0) (+ 1 eta-0)))))
(define PreludeC-45Types-u--rangeFrom_Range_C-36a (lambda (arg-1 arg-2) (PreludeC-45Types-countFrom arg-2 (lambda (arg-0) (let ((sc0 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-1 (vector-ref sc0 0))) (let ((e-6 (vector-ref e-1 0))) ((e-6 (let ((sc0 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-9 (vector-ref sc0 0))) (let ((e-10 (vector-ref e-9 2))) (e-10 1))))) arg-0))))))))
(define PreludeC-45Types-u--rangeFromTo_Range_Nat (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--compare_Ord_Nat arg-0 arg-1))) (cond ((equal? sc0 0) (PreludeC-45Types-takeUntil (lambda (arg-2) (PreludeC-45Types-u--C-62C-61_Ord_Nat arg-2 arg-1)) (PreludeC-45Types-countFrom arg-0 (lambda (eta-0) (+ 1 eta-0))))) ((equal? sc0 1) (PreludeC-45Types-u--pure_Applicative_List arg-0)) (else (PreludeC-45Types-takeUntil (lambda (arg-2) (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-2 arg-1)) (PreludeC-45Types-countFrom arg-0 (lambda (u--n) (PreludeC-45Types-prim__integerToNat (- u--n (+ 1 0)))))))))))
(define PreludeC-45Types-u--rangeFromTo_Range_C-36a (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((sc1 (Builtin-fst (Builtin-snd arg-1)))) (let ((e-2 (vector-ref sc1 1))) ((e-2 arg-2) arg-3))))) (cond ((equal? sc0 0) (PreludeC-45Types-takeUntil (lambda (arg-0) (let ((sc1 (Builtin-fst (Builtin-snd arg-1)))) (let ((e-6 (vector-ref sc1 5))) ((e-6 arg-0) arg-3)))) (PreludeC-45Types-countFrom arg-2 (lambda (arg-0) (let ((sc1 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-1 (vector-ref sc1 0))) (let ((e-6 (vector-ref e-1 0))) ((e-6 arg-0) (let ((sc1 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-9 (vector-ref sc1 0))) (let ((e-10 (vector-ref e-9 2))) (e-10 1)))))))))))) ((equal? sc0 1) (PreludeC-45Types-u--pure_Applicative_List arg-2)) (else (PreludeC-45Types-takeUntil (lambda (arg-0) (let ((sc1 (Builtin-fst (Builtin-snd arg-1)))) (let ((e-5 (vector-ref sc1 4))) ((e-5 arg-0) arg-3)))) (PreludeC-45Types-countFrom arg-2 (lambda (u--x) (let ((sc1 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-3 (vector-ref sc1 2))) ((e-3 u--x) (let ((sc1 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-6 (vector-ref sc1 0))) (let ((e-7 (vector-ref e-6 2))) (e-7 1)))))))))))))))
(define PreludeC-45Types-u--pure_Applicative_Maybe (lambda (ext-0) (box ext-0)))
(define PreludeC-45Types-u--pure_Applicative_List (lambda (arg-1) (cons arg-1 '())))
(define PreludeC-45Types-u--null_Foldable_Maybe (lambda (arg-1) (if (null? arg-1) (lambda () 1) (lambda () 0))))
(define PreludeC-45Types-u--null_Foldable_List (lambda (arg-1) (if (null? arg-1) (lambda () 1) (lambda () 0))))
(define PreludeC-45Types-u--null_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-2) (case (vector-ref arg-2 0) ((0) (lambda () 1)) (else (lambda () 0)))))
(define PreludeC-45Types-u--neutral_Monoid_String(blodwen-lazy (lambda () "")))
(define PreludeC-45Types-u--neutral_Monoid_C-40ListC-32C-36aC-41(blodwen-lazy (lambda () '())))
(define PreludeC-45Types-u--min_Ord_Nat (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--C-60_Ord_Nat arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45Types-u--min_Ord_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-60_Ord_C-40MaybeC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define PreludeC-45Types-u--min_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-60_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define PreludeC-45Types-u--max_Ord_Nat (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--C-62_Ord_Nat arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45Types-u--max_Ord_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-62_Ord_C-40MaybeC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define PreludeC-45Types-u--max_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-62_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define PreludeC-45Types-u--map_Functor_Maybe (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-1 (unbox arg-3))) (box (arg-2 e-1))))))
(define PreludeC-45Types-u--map_Functor_List (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cons (arg-2 e-2) (PreludeC-45Types-u--map_Functor_List arg-2 e-3)))))))
(define PreludeC-45Types-u--join_Monad_Maybe (lambda (arg-1) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe arg-1 (lambda (eta-0) eta-0))))
(define PreludeC-45Types-u--join_Monad_List (lambda (arg-1) (PreludeC-45Types-u--C-62C-62C-61_Monad_List arg-1 (lambda (eta-0) eta-0))))
(define PreludeC-45Types-u--join_Monad_C-40EitherC-32C-36eC-41 (lambda (arg-2) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 arg-2 (lambda (eta-0) eta-0))))
(define PreludeC-45Types-u--fromInteger_Num_Nat (lambda (arg-0) (PreludeC-45Types-prim__integerToNat arg-0)))
(define PreludeC-45Types-u--foldr_Foldable_Maybe (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (unbox arg-4))) ((arg-2 e-2) arg-3)))))
(define PreludeC-45Types-u--foldr_Foldable_List (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) ((arg-2 e-2) (PreludeC-45Types-u--foldr_Foldable_List arg-2 arg-3 e-3)))))))
(define PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) arg-4) (else (let ((e-5 (vector-ref arg-5 1))) ((arg-3 e-5) arg-4))))))
(define PreludeC-45Types-u--foldl_Foldable_Maybe (lambda (arg-2 arg-3 arg-4) ((PreludeC-45Types-u--foldr_Foldable_Maybe (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (csegen-115) (lambda (eta-2) (PreludeC-45Basics-flip arg-2 eta-0 eta-2)) eta-1))) (lambda (eta-0) eta-0) arg-4) arg-3)))
(define PreludeC-45Types-u--foldl_Foldable_List (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-u--foldl_Foldable_List arg-2 ((arg-2 arg-3) e-2) e-3))))))
(define PreludeC-45Types-u--foldl_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-3 arg-4 arg-5) ((PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (csegen-115) (lambda (eta-2) (PreludeC-45Basics-flip arg-3 eta-0 eta-2)) eta-1))) (lambda (eta-0) eta-0) arg-5) arg-4)))
(define PreludeC-45Types-u--foldlM_Foldable_Maybe (lambda (arg-3 arg-4 arg-5 ext-0) (PreludeC-45Types-u--foldl_Foldable_Maybe (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-3 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-4 u--b eta-0)))))) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-5))) ext-0)))
(define PreludeC-45Types-u--foldlM_Foldable_List (lambda (arg-3 arg-4 arg-5 ext-0) (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-3 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-4 u--b eta-0)))))) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-5))) ext-0)))
(define PreludeC-45Types-u--foldlM_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (PreludeC-45Types-u--foldl_Foldable_C-40EitherC-32C-36eC-41 (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-5 u--b eta-0)))))) (let ((e-1 (vector-ref arg-4 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-6))) ext-0)))
(define PreludeC-45Types-u--foldMap_Foldable_Maybe (lambda (arg-2 arg-3 ext-0) (PreludeC-45Types-u--foldr_Foldable_Maybe (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-2))) ((e-1 (arg-3 eta-0)) eta-1)))) (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define PreludeC-45Types-u--foldMap_Foldable_List (lambda (arg-2 arg-3 ext-0) (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--acc) (lambda (u--elem) (let ((e-1 (car arg-2))) ((e-1 u--acc) (arg-3 u--elem))))) (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define PreludeC-45Types-u--foldMap_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-3 arg-4 ext-0) (PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-3))) ((e-1 (arg-4 eta-0)) eta-1)))) (let ((e-2 (cdr arg-3))) e-2) ext-0)))
(define PreludeC-45Types-u--empty_Alternative_Maybe(blodwen-lazy (lambda () '())))
(define PreludeC-45Types-u--empty_Alternative_List(blodwen-lazy (lambda () '())))
(define PreludeC-45Types-u--compare_Ord_Nat (lambda (ext-0 ext-1) (PreludeC-45EqOrd-compareInteger ext-0 ext-1)))
(define PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) 1 0) (let ((e-2 (unbox arg-2))) (if (null? arg-3) 2 (let ((e-8 (unbox arg-3))) (let ((e-10 (vector-ref arg-1 1))) ((e-10 e-2) e-8))))))))
(define PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) 1 0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? arg-3) 2 (let ((e-10 (car arg-3))) (let ((e-11 (cdr arg-3))) (PreludeC-45Types-case--compare-3913 arg-1 e-2 e-3 e-10 e-11 (let ((e-12 (vector-ref arg-1 1))) ((e-12 e-2) e-10)))))))))))
(define PreludeC-45Types-u--C-62_Ord_Nat (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_Nat arg-0 arg-1) 2)))
(define PreludeC-45Types-u--C-62_Ord_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 arg-1 arg-2 arg-3) 2)))
(define PreludeC-45Types-u--C-62_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3) 2)))
(define PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (lambda (arg-2 arg-3) (if (null? arg-2) '() (let ((e-2 (unbox arg-2))) (arg-3 e-2)))))
(define PreludeC-45Types-u--C-62C-62C-61_Monad_List (lambda (arg-2 arg-3) (PreludeC-45Interfaces-concatMap (csegen-50) arg-3 arg-2)))
(define PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (lambda (arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-3 1))) (arg-4 e-5))))))
(define PreludeC-45Types-u--C-62C-61_Ord_Nat (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_Nat arg-0 arg-1) 0)))
(define PreludeC-45Types-u--C-62C-61_Ord_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 arg-1 arg-2 arg-3) 0)))
(define PreludeC-45Types-u--C-62C-61_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3) 0)))
(define PreludeC-45Types-u--C-61C-61_Eq_Nat (lambda (ext-0 ext-1) (or (and (= ext-0 ext-1) 1) 0)))
(define PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) 1 0) (let ((e-2 (unbox arg-2))) (if (null? arg-3) 0 (let ((e-8 (unbox arg-3))) (let ((e-1 (car arg-1))) ((e-1 e-2) e-8))))))))
(define PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) 1 0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? arg-3) 0 (let ((e-6 (car arg-3))) (let ((e-7 (cdr arg-3))) (let ((sc2 (let ((e-1 (car arg-1))) ((e-1 e-2) e-6)))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 arg-1 e-3 e-7)) (else 0)))))))))))
(define PreludeC-45Types-u--C-61C-61_Eq_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((0) (let ((e-8 (vector-ref arg-4 1))) (let ((sc2 (Builtin-fst arg-2))) (let ((e-1 (car sc2))) ((e-1 e-2) e-8)))))(else 0)))) ((1) (let ((e-5 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((1) (let ((e-11 (vector-ref arg-4 1))) (let ((sc2 (Builtin-snd arg-2))) (let ((e-1 (car sc2))) ((e-1 e-5) e-11)))))(else 0))))(else 0))))
(define PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (lambda (arg-1 arg-2) (if (null? arg-1) (arg-2) (let ((e-1 (unbox arg-1))) (box e-1)))))
(define PreludeC-45Types-u--C-60C-124C-62_Alternative_List (lambda (arg-1 arg-2) (PreludeC-45TypesC-45List-tailRecAppend arg-1 (arg-2))))
(define PreludeC-45Types-u--C-60_Ord_Nat (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_Nat arg-0 arg-1) 0)))
(define PreludeC-45Types-u--C-60_Ord_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 arg-1 arg-2 arg-3) 0)))
(define PreludeC-45Types-u--C-60_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3) 0)))
(define PreludeC-45Types-u--C-60C-61_Ord_Nat (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_Nat arg-0 arg-1) 2)))
(define PreludeC-45Types-u--C-60C-61_Ord_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 arg-1 arg-2 arg-3) 2)))
(define PreludeC-45Types-u--C-60C-61_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3) 2)))
(define PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (lambda (ext-0 ext-1) (PreludeC-45TypesC-45String-C-43C-43 ext-0 ext-1)))
(define PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (unbox arg-1))) (box e-2)))))
(define PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40ListC-32C-36aC-41 (lambda (ext-0 ext-1) (PreludeC-45TypesC-45List-tailRecAppend ext-0 ext-1)))
(define PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (lambda (arg-2 arg-3) (if (null? arg-2) '() (let ((e-1 (unbox arg-2))) (if (null? arg-3) '() (let ((e-3 (unbox arg-3))) (box (e-1 e-3))))))))
(define PreludeC-45Types-u--C-60C-42C-62_Applicative_List (lambda (arg-2 arg-3) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (u--f) (PreludeC-45Types-u--map_Functor_List u--f arg-3)) arg-2)))
(define PreludeC-45Types-u--C-47C-61_Eq_Nat (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45Types-u--C-47C-61_Eq_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45Types-u--C-47C-61_Eq_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45Types-u--C-43_Num_Nat (lambda (ext-0 ext-1) (+ ext-0 ext-1)))
(define PreludeC-45Types-u--C-42_Num_Nat (lambda (ext-0 ext-1) (* ext-0 ext-1)))
(define PreludeC-45Types-toUpper (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isLower arg-0))) (cond ((equal? sc0 1) (cast-int-char (bs- (cast-char-boundedInt arg-0 63) 32 63))) (else arg-0)))))
(define PreludeC-45Types-toLower (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isUpper arg-0))) (cond ((equal? sc0 1) (cast-int-char (bs+ (cast-char-boundedInt arg-0 63) 32 63))) (else arg-0)))))
(define PreludeC-45Types-tan (lambda (arg-0) (fltan arg-0)))
(define PreludeC-45Types-takeUntil (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((sc1 (arg-1 e-1))) (cond ((equal? sc1 1) (cons e-1 '())) (else (cons e-1 (PreludeC-45Types-takeUntil arg-1 (e-2))))))))))
(define PreludeC-45Types-take (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cons e-2 (PreludeC-45Types-take e-0 (e-3))))))))))
(define PreludeC-45TypesC-45List-tailRecAppend (lambda (arg-1 arg-2) (PreludeC-45TypesC-45List-reverseOnto arg-2 (PreludeC-45TypesC-45List-reverse arg-1))))
(define PreludeC-45Types-substr (lambda (arg-0 arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-0 (PreludeC-45TypesC-45String-length arg-2)))) (cond ((equal? sc0 1) (string-substr (blodwen-toSignedInt arg-0 63) (blodwen-toSignedInt arg-1 63) arg-2)) (else "")))))
(define PreludeC-45Types-strUncons (lambda (arg-0) (cond ((equal? arg-0 "") '())(else (box (cons (string-ref arg-0 0) (substring arg-0 1 (string-length arg-0))))))))
(define PreludeC-45Types-strCons (lambda (ext-0 ext-1) (string-cons ext-0 ext-1)))
(define PreludeC-45Types-sqrt (lambda (arg-0) (flsqrt arg-0)))
(define PreludeC-45Types-sin (lambda (arg-0) (flsin arg-0)))
(define PreludeC-45TypesC-45List-reverseOnto (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45TypesC-45List-reverseOnto (cons e-2 arg-1) e-3))))))
(define PreludeC-45Types-reverse (lambda (ext-0) (string-reverse ext-0)))
(define PreludeC-45TypesC-45List-reverse (lambda (ext-0) (PreludeC-45TypesC-45List-reverseOnto '() ext-0)))
(define PreludeC-45Types-prim__integerToNat (lambda (arg-0) (let ((sc0 (let ((sc1 (or (and (<= 0 arg-0) 1) 0))) (cond ((equal? sc1 0) 0)(else 1))))) (cond ((equal? sc0 1) (Builtin-believe_me arg-0)) (else 0)))))
(define PreludeC-45Types-pow (lambda (arg-0 arg-1) (PreludeC-45Types-exp (PreludeC-45Num-u--C-42_Num_Double arg-1 (PreludeC-45Types-log arg-0)))))
(define PreludeC-45Types-ord (lambda (ext-0) (cast-char-boundedInt ext-0 63)))
(define PreludeC-45Types-maybe (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (arg-2) (let ((e-2 (unbox arg-4))) ((arg-3) e-2)))))
(define PreludeC-45Types-log (lambda (arg-0) (fllog arg-0)))
(define PreludeC-45TypesC-45String-length (lambda (arg-0) (PreludeC-45Types-u--fromInteger_Num_Nat (string-length arg-0))))
(define PreludeC-45TypesC-45List-length (lambda (arg-1) (if (null? arg-1) 0 (let ((e-3 (cdr arg-1))) (+ 1 (PreludeC-45TypesC-45List-length e-3))))))
(define PreludeC-45Types-isUpper (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-0 #\A))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\Z)) (else 0)))))
(define PreludeC-45Types-isSpace (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 #\ ))) (cond ((equal? sc0 1) 1) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 9)))) (cond ((equal? sc1 1) 1) (else (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 13)))) (cond ((equal? sc2 1) 1) (else (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 10)))) (cond ((equal? sc3 1) 1) (else (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 12)))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 11)))) (cond ((equal? sc5 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 160))))))))))))))))))))))
(define PreludeC-45Types-isOctDigit (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-0 #\0))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\7)) (else 0)))))
(define PreludeC-45Types-isNL (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 13)))) (cond ((equal? sc0 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 10)))))))
(define PreludeC-45Types-isLower (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-0 #\a))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\z)) (else 0)))))
(define PreludeC-45Types-isHexDigit (lambda (arg-0) (PreludeC-45Types-elem (csegen-0) (PreludeC-45Types-toUpper arg-0) (PreludeC-45Types-n--6057-4912-u--hexChars arg-0))))
(define PreludeC-45Types-isDigit (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-0 #\0))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\9)) (else 0)))))
(define PreludeC-45Types-isAlphaNum (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isDigit arg-0))) (cond ((equal? sc0 1) 1) (else (PreludeC-45Types-isAlpha arg-0))))))
(define PreludeC-45Types-isAlpha (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isUpper arg-0))) (cond ((equal? sc0 1) 1) (else (PreludeC-45Types-isLower arg-0))))))
(define PreludeC-45Types-getAt (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) (if (null? arg-2) '() (let ((e-3 (car arg-2))) (box e-3))))(else (let ((e-1 (- arg-1 1))) (if (null? arg-2) '() (let ((e-7 (cdr arg-2))) (PreludeC-45Types-getAt e-1 e-7))))))))
(define PreludeC-45Types-floor (lambda (arg-0) (flfloor arg-0)))
(define PreludeC-45Types-exp (lambda (arg-0) (flexp arg-0)))
(define PreludeC-45Types-elem (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) 0 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (let ((e-1 (car arg-1))) ((e-1 arg-2) e-2)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45Types-elem arg-1 arg-2 e-3)))))))))
(define PreludeC-45Types-either (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) ((arg-3) e-2))) (else (let ((e-5 (vector-ref arg-5 1))) ((arg-4) e-5))))))
(define PreludeC-45Types-countFrom (lambda (arg-1 arg-2) (cons arg-1 (lambda () (PreludeC-45Types-countFrom (arg-2 arg-1) arg-2)))))
(define PreludeC-45Types-count (lambda (arg-2 arg-3 ext-0) (let ((e-6 (vector-ref arg-2 5))) (((((e-6 'erased) 'erased) (cons (lambda (arg-4) (lambda (arg-5) (PreludeC-45InterfacesC-45NumC-45Semigroup-u--C-60C-43C-62_Semigroup_AdditiveC-36a (csegen-118) arg-4 arg-5))) (PreludeC-45InterfacesC-45NumC-45Monoid-u--neutral_Monoid_AdditiveC-36a (csegen-118)))) (lambda (u--x) (let ((sc0 (arg-3 u--x))) (cond ((equal? sc0 1) (+ 1 0)) (else 0))))) ext-0))))
(define PreludeC-45Types-cos (lambda (arg-0) (flcos arg-0)))
(define PreludeC-45Types-chr (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Types-ceiling (lambda (arg-0) (flceiling arg-0)))
(define PreludeC-45Types-atan (lambda (arg-0) (flatan arg-0)))
(define PreludeC-45Types-asin (lambda (arg-0) (flasin arg-0)))
(define PreludeC-45Types-acos (lambda (arg-0) (flacos arg-0)))
(define PreludeC-45TypesC-45String-C-43C-43 (lambda (arg-0 arg-1) (string-append arg-0 arg-1)))
(define PreludeC-45TypesC-45List-C-43C-43 (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons e-2 (PreludeC-45TypesC-45List-C-43C-43 e-3 arg-2)))))))
(define PreludeC-45Num-u--mod_Integral_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-1 0))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:86:3--88:44"))))))
(define PreludeC-45Num-u--mod_Integral_Int8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-1 (blodwen-toSignedInt 0 7)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:151:3--153:41"))))))
(define PreludeC-45Num-u--mod_Integral_Int64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:235:3--237:42"))))))
(define PreludeC-45Num-u--mod_Integral_Int32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-1 (blodwen-toSignedInt 0 31)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:207:3--209:42"))))))
(define PreludeC-45Num-u--mod_Integral_Int16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-1 (blodwen-toSignedInt 0 15)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:179:3--181:42"))))))
(define PreludeC-45Num-u--mod_Integral_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:123:3--125:40"))))))
(define PreludeC-45Num-u--mod_Integral_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-1 (blodwen-toUnsignedInt 0 8)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:263:3--265:42"))))))
(define PreludeC-45Num-u--mod_Integral_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-1 (blodwen-toUnsignedInt 0 64)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:347:3--349:43"))))))
(define PreludeC-45Num-u--mod_Integral_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-1 (blodwen-toUnsignedInt 0 32)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:319:3--321:43"))))))
(define PreludeC-45Num-u--mod_Integral_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-1 (blodwen-toUnsignedInt 0 16)))) (cond ((equal? sc0 0) (remainder arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:291:3--293:43"))))))
(define PreludeC-45Num-u--fromInteger_Num_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Num-u--div_Integral_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-1 0))) (cond ((equal? sc0 0) (quotient arg-0 arg-1))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:83:3--85:44"))))))
(define PreludeC-45Num-u--div_Integral_Int8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-1 (blodwen-toSignedInt 0 7)))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 7))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:148:3--150:41"))))))
(define PreludeC-45Num-u--div_Integral_Int64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 63))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:232:3--234:42"))))))
(define PreludeC-45Num-u--div_Integral_Int32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-1 (blodwen-toSignedInt 0 31)))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 31))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:204:3--206:42"))))))
(define PreludeC-45Num-u--div_Integral_Int16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-1 (blodwen-toSignedInt 0 15)))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 15))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:176:3--178:42"))))))
(define PreludeC-45Num-u--div_Integral_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 63))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:120:3--122:40"))))))
(define PreludeC-45Num-u--div_Integral_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-1 (blodwen-toUnsignedInt 0 8)))) (cond ((equal? sc0 0) (bu/ arg-0 arg-1 8))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:260:3--262:42"))))))
(define PreludeC-45Num-u--div_Integral_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-1 (blodwen-toUnsignedInt 0 64)))) (cond ((equal? sc0 0) (bu/ arg-0 arg-1 64))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:344:3--346:43"))))))
(define PreludeC-45Num-u--div_Integral_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-1 (blodwen-toUnsignedInt 0 32)))) (cond ((equal? sc0 0) (bu/ arg-0 arg-1 32))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:316:3--318:43"))))))
(define PreludeC-45Num-u--div_Integral_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-1 (blodwen-toUnsignedInt 0 16)))) (cond ((equal? sc0 0) (bu/ arg-0 arg-1 16))(else (Builtin-idris_crash "Unhandled input for Prelude.Num.case block in div at Prelude.Num:288:3--290:43"))))))
(define PreludeC-45Num-u--abs_Abs_Integer (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-0 0))) (cond ((equal? sc0 1) (- 0 arg-0)) (else arg-0)))))
(define PreludeC-45Num-u--abs_Abs_Int (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-0 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (bs- 0 arg-0 63)) (else arg-0)))))
(define PreludeC-45Num-u--C-47_Fractional_Double (lambda (ext-0 ext-1) (/ ext-0 ext-1)))
(define PreludeC-45Num-u--C-43_Num_Double (lambda (ext-0 ext-1) (+ ext-0 ext-1)))
(define PreludeC-45Num-u--C-42_Num_Double (lambda (ext-0 ext-1) (* ext-0 ext-1)))
(define PreludeC-45EqOrd-u--min_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_String arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--min_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--min_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--min_Ord_Bool (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bool arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5))) (cond ((equal? sc0 1) arg-4) (else arg-5)))))
(define PreludeC-45EqOrd-u--max_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_String arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--max_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_Integer arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--max_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_Int arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--max_Ord_Bool (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_Bool arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5))) (cond ((equal? sc0 1) arg-4) (else arg-5)))))
(define PreludeC-45EqOrd-u--compare_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_String arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int8 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int64 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int32 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int16 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Double arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Double arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Bool (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1) (else 0))) (else (cond ((equal? arg-1 0) 2) (else 1))))))
(define PreludeC-45EqOrd-u--compare_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bits8 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bits64 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bits32 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bits16 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car arg-5))) (let ((e-7 (cdr arg-5))) (let ((sc2 (let ((e-1 (vector-ref arg-2 0))) (let ((e-13 (cdr e-1))) ((e-13 e-2) e-6))))) (cond ((equal? sc2 1) (let ((e-12 (vector-ref arg-2 1))) ((e-12 e-2) e-6))) (else (let ((e-12 (vector-ref arg-3 1))) ((e-12 e-3) e-7)))))))))))
(define PreludeC-45EqOrd-u--C-62_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string>? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char>? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Bool (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Bool arg-0 arg-1) 2)))
(define PreludeC-45EqOrd-u--C-62_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5) 2)))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string>=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char>=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bool (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Bool arg-0 arg-1) 0)))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5) 0)))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bool (lambda (arg-0 arg-1) (cond ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0)))(else 0))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car arg-5))) (let ((e-7 (cdr arg-5))) (let ((sc2 (let ((e-1 (car arg-2))) ((e-1 e-2) e-6)))) (cond ((equal? sc2 1) (let ((e-1 (car arg-3))) ((e-1 e-3) e-7))) (else 0)))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string<? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char<? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Bool (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Bool arg-0 arg-1) 0)))
(define PreludeC-45EqOrd-u--C-60_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5) 0)))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string<=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char<=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bool (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Bool arg-0 arg-1) 2)))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5) 2)))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_String (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Char (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bool (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45EqOrd-comparing (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (vector-ref arg-2 1))) ((e-2 (arg-3 arg-4)) (arg-3 arg-5)))))
(define PreludeC-45EqOrd-compareInteger (lambda (ext-0 ext-1) (PreludeC-45EqOrd-u--compare_Ord_Integer ext-0 ext-1)))
(define PreludeC-45InterfacesC-45Applicative-u--pure_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (lambda (arg-3 ext-0) (let ((sc0 (Builtin-fst arg-3))) (let ((e-2 (vector-ref sc0 1))) ((e-2 'erased) (let ((sc0 (Builtin-snd arg-3))) (let ((e-5 (vector-ref sc0 1))) ((e-5 'erased) ext-0))))))))
(define PreludeC-45InterfacesC-45BoolC-45Monoid-u--neutral_Monoid_AnyBool(blodwen-lazy (lambda () 0)))
(define PreludeC-45InterfacesC-45BoolC-45Monoid-u--neutral_Monoid_AllBool(blodwen-lazy (lambda () 1)))
(define PreludeC-45InterfacesC-45NumC-45Monoid-u--neutral_Monoid_AdditiveC-36a (lambda (arg-1) (let ((e-3 (vector-ref arg-1 2))) (e-3 0))))
(define PreludeC-45Interfaces-u--neutral_Monoid_C-40C-124UnitC-44MkUnitC-124C-41(blodwen-lazy (lambda () 0)))
(define PreludeC-45InterfacesC-45Functor-u--map_Functor_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (lambda (arg-4 ext-0 ext-1) (((((Builtin-fst arg-4) 'erased) 'erased) (lambda (arg-1) (((((Builtin-snd arg-4) 'erased) 'erased) ext-0) arg-1))) ext-1)))
(define PreludeC-45InterfacesC-45Monad-u--C-62C-62C-61_Monad_ComposeC-40C-40C-46C-32C-36mC-41C-32C-36tC-41 (lambda (arg-4 arg-5 arg-6) (let ((sc0 (Builtin-fst arg-4))) (let ((e-2 (vector-ref sc0 1))) ((((e-2 'erased) 'erased) arg-5) (lambda (eta-0) (let ((sc0 (Builtin-fst arg-4))) (let ((e-6 (vector-ref sc0 0))) (let ((e-9 (vector-ref e-6 0))) ((((e-9 'erased) 'erased) (lambda (clam-0) (let ((sc0 (Builtin-fst (Builtin-snd arg-4)))) (let ((e-10 (vector-ref sc0 2))) ((e-10 'erased) clam-0))))) (let ((sc0 (Builtin-snd (Builtin-snd arg-4)))) (let ((e-10 (vector-ref sc0 2))) ((((((e-10 'erased) 'erased) 'erased) (let ((sc0 (Builtin-fst arg-4))) (let ((e-15 (vector-ref sc0 0))) e-15))) arg-6) eta-0)))))))))))))
(define PreludeC-45InterfacesC-45BoolC-45Semigroup-u--C-60C-43C-62_Semigroup_AnyBool (lambda (arg-0 arg-1) (cond ((equal? arg-0 1) 1) (else arg-1))))
(define PreludeC-45InterfacesC-45BoolC-45Semigroup-u--C-60C-43C-62_Semigroup_AllBool (lambda (arg-0 arg-1) (cond ((equal? arg-0 1) arg-1) (else 0))))
(define PreludeC-45InterfacesC-45NumC-45Semigroup-u--C-60C-43C-62_Semigroup_AdditiveC-36a (lambda (arg-1 ext-0 ext-1) (let ((e-1 (vector-ref arg-1 0))) ((e-1 ext-0) ext-1))))
(define PreludeC-45Interfaces-u--C-60C-43C-62_Semigroup_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1) 0))
(define PreludeC-45InterfacesC-45Applicative-u--C-60C-42C-62_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (lambda (arg-4 arg-5 arg-6) (let ((sc0 (Builtin-fst arg-4))) (let ((e-3 (vector-ref sc0 2))) ((((e-3 'erased) 'erased) (let ((sc0 (Builtin-fst arg-4))) (let ((e-4 (vector-ref sc0 2))) ((((e-4 'erased) 'erased) (let ((sc0 (Builtin-fst arg-4))) (let ((e-8 (vector-ref sc0 1))) ((e-8 'erased) (lambda (clam-0) (lambda (clam-1) (let ((sc0 (Builtin-snd arg-4))) (let ((e-10 (vector-ref sc0 2))) ((((e-10 'erased) 'erased) clam-0) clam-1))))))))) arg-5)))) arg-6)))))
(define PreludeC-45Interfaces-when (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-2 1) (arg-3)) (else (let ((e-2 (vector-ref arg-1 1))) ((e-2 'erased) 0))))))
(define PreludeC-45Interfaces-traverse_ (lambda (arg-4 arg-5 ext-0) (let ((sc0 (Builtin-fst arg-4))) (let ((e-1 (vector-ref sc0 0))) (((((e-1 'erased) 'erased) (lambda (eta-0) (lambda (eta-1) (PreludeC-45Interfaces-C-42C-62 (Builtin-snd arg-4) (arg-5 eta-0) eta-1)))) (let ((sc0 (Builtin-snd arg-4))) (let ((e-8 (vector-ref sc0 1))) ((e-8 'erased) 0)))) ext-0)))))
(define PreludeC-45Interfaces-sum (lambda (arg-2 ext-0) (PreludeC-45Interfaces-concat (cons (Builtin-fst arg-2) (cons (lambda (arg-3) (lambda (arg-4) (PreludeC-45InterfacesC-45NumC-45Semigroup-u--C-60C-43C-62_Semigroup_AdditiveC-36a (Builtin-snd arg-2) arg-3 arg-4))) (PreludeC-45InterfacesC-45NumC-45Monoid-u--neutral_Monoid_AdditiveC-36a (Builtin-snd arg-2)))) ext-0)))
(define PreludeC-45Interfaces-mapHom (lambda (arg-3 arg-4 ext-0) (let ((e-1 (vector-ref arg-3 0))) (((((((e-1 'erased) 'erased) 'erased) 'erased) arg-4) arg-4) ext-0))))
(define PreludeC-45Interfaces-guard (lambda (arg-1 arg-2) (cond ((equal? arg-2 1) (let ((e-1 (vector-ref arg-1 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) 0)))) (else (let ((e-2 (vector-ref arg-1 1))) (e-2 'erased))))))
(define PreludeC-45Interfaces-for_ (lambda (arg-4 ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (PreludeC-45Interfaces-traverse_ arg-4 eta-0 eta-1))) ext-0 ext-1)))
(define PreludeC-45Interfaces-for (lambda (arg-4 ext-0 ext-1) (PreludeC-45Basics-flip (lambda (clam-0) (lambda (clam-1) (let ((sc0 (Builtin-fst arg-4))) (let ((e-3 (vector-ref sc0 2))) ((((((e-3 'erased) 'erased) 'erased) (Builtin-snd arg-4)) clam-0) clam-1))))) ext-0 ext-1)))
(define PreludeC-45Interfaces-concatMap (lambda (arg-3 ext-1 ext-0) (let ((sc0 (Builtin-fst arg-3))) (let ((e-6 (vector-ref sc0 5))) (((((e-6 'erased) 'erased) (Builtin-snd arg-3)) ext-1) ext-0)))))
(define PreludeC-45Interfaces-concat (lambda (arg-2 ext-0) (let ((sc0 (Builtin-fst arg-2))) (let ((e-6 (vector-ref sc0 5))) (((((e-6 'erased) 'erased) (Builtin-snd arg-2)) (lambda (eta-0) eta-0)) ext-0)))))
(define PreludeC-45Interfaces-any (lambda (arg-2 ext-1 ext-0) (let ((e-6 (vector-ref arg-2 5))) (((((e-6 'erased) 'erased) (cons (lambda (arg-3) (lambda (arg-4) (PreludeC-45InterfacesC-45BoolC-45Semigroup-u--C-60C-43C-62_Semigroup_AnyBool arg-3 arg-4))) (PreludeC-45InterfacesC-45BoolC-45Monoid-u--neutral_Monoid_AnyBool))) ext-1) ext-0))))
(define PreludeC-45Interfaces-all (lambda (arg-2 ext-1 ext-0) (let ((e-6 (vector-ref arg-2 5))) (((((e-6 'erased) 'erased) (cons (lambda (arg-3) (lambda (arg-4) (PreludeC-45InterfacesC-45BoolC-45Semigroup-u--C-60C-43C-62_Semigroup_AllBool arg-3 arg-4))) (PreludeC-45InterfacesC-45BoolC-45Monoid-u--neutral_Monoid_AllBool))) ext-1) ext-0))))
(define PreludeC-45Interfaces-C-62C-62 (lambda (arg-2 arg-3 arg-4) (let ((e-2 (vector-ref arg-2 1))) ((((e-2 'erased) 'erased) arg-3) (lambda (_-1029) (arg-4))))))
(define PreludeC-45Interfaces-C-62C-61C-62 (lambda (arg-4 arg-5 arg-6 ext-0) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (arg-5 ext-0)) arg-6))))
(define PreludeC-45Interfaces-C-61C-60C-60 (lambda (arg-3 ext-0 ext-1) (PreludeC-45Basics-flip (lambda (clam-0) (lambda (clam-1) (let ((e-2 (vector-ref arg-3 1))) ((((e-2 'erased) 'erased) clam-0) clam-1)))) ext-0 ext-1)))
(define PreludeC-45Interfaces-C-60C-38C-62 (lambda (arg-3 arg-4 arg-5) ((((arg-3 'erased) 'erased) arg-5) arg-4)))
(define PreludeC-45Interfaces-C-60C-36C-62 (lambda (arg-3 arg-4 arg-5) ((((arg-3 'erased) 'erased) arg-4) arg-5)))
(define PreludeC-45Interfaces-C-60C-36 (lambda (arg-3 arg-4 ext-0) ((((arg-3 'erased) 'erased) (lambda (eta-0) arg-4)) ext-0)))
(define PreludeC-45Interfaces-C-42C-62 (lambda (arg-3 arg-4 arg-5) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (let ((e-6 (vector-ref arg-3 0))) ((((e-6 'erased) 'erased) (lambda (eta-0) (lambda (eta-1) eta-1))) arg-4))) arg-5))))
(define PreludeC-45Interfaces-C-36C-62 (lambda (arg-3 arg-4 arg-5) ((((arg-3 'erased) 'erased) (lambda (eta-0) arg-5)) arg-4)))
(define PrimIO-unsafePerformIO (lambda (arg-1) (PrimIO-unsafeCreateWorld (lambda (u--w) (PrimIO-unsafeDestroyWorld 'erased (arg-1 u--w))))))
(define PrimIO-unsafeDestroyWorld (lambda (arg-1 arg-2) arg-2))
(define PrimIO-unsafeCreateWorld (lambda (arg-1) (arg-1 #f)))
(define PrimIO-prim__forgetPtr (lambda (ext-0) (Builtin-believe_me ext-0)))
(define PreludeC-45Show-n--2480-6782-u--showC-39 (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-3) (PreludeC-45TypesC-45String-C-43C-43 arg-3 (let ((e-1 (car arg-1))) (e-1 e-2))) (PreludeC-45Show-n--2480-6782-u--showC-39 arg-1 arg-2 (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 (let ((e-1 (car arg-1))) (e-1 e-2)) ", ")) e-3)))))))
(define PreludeC-45Show-n--1920-6294-u--asciiTab (lambda (arg-0) (cons "NUL" (cons "SOH" (cons "STX" (cons "ETX" (cons "EOT" (cons "ENQ" (cons "ACK" (cons "BEL" (cons "BS" (cons "HT" (cons "LF" (cons "VT" (cons "FF" (cons "CR" (cons "SO" (cons "SI" (cons "DLE" (cons "DC1" (cons "DC2" (cons "DC3" (cons "DC4" (cons "NAK" (cons "SYN" (cons "ETB" (cons "CAN" (cons "EM" (cons "SUB" (cons "ESC" (cons "FS" (cons "GS" (cons "RS" (cons "US" '()))))))))))))))))))))))))))))))))))
(define PreludeC-45Show-u--show_Show_String (lambda (arg-0) (PreludeC-45Types-strCons #\" ((PreludeC-45Show-showLitString (PreludeC-45Types-fastUnpack arg-0)) "\""))))
(define PreludeC-45Show-u--show_Show_Nat (lambda (arg-0) (PreludeC-45Show-u--show_Show_Integer arg-0)))
(define PreludeC-45Show-u--show_Show_Integer (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Integer (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Int8 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int8 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Int64 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int64 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Int32 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int32 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Int16 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int16 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Int (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Double (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Double (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Char (lambda (arg-0) (cond ((equal? arg-0 #\') "'\\''")(else (PreludeC-45Types-strCons #\' ((PreludeC-45Show-showLitChar arg-0) "'"))))))
(define PreludeC-45Show-u--show_Show_Bool (lambda (arg-0) (cond ((equal? arg-0 1) "True") (else "False"))))
(define PreludeC-45Show-u--show_Show_Bits8 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Bits8 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Bits64 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Bits64 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Bits32 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Bits32 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Bits16 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Bits16 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0) (cond (else "()"))))
(define PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) (e-1 e-2))) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (let ((sc1 (Builtin-snd arg-2))) (let ((e-1 (car sc1))) (e-1 e-3))) ")"))))))))
(define PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 arg-1 (vector 0 ) arg-2)))
(define PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-n--2480-6782-u--showC-39 arg-1 arg-2 "" arg-2) "]"))))
(define PreludeC-45Show-u--show_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (lambda (arg-2 arg-3) (PreludeC-45Show-u--showPrec_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 arg-2 (vector 0 ) arg-3)))
(define PreludeC-45Show-u--showPrec_Show_String (lambda (arg-0 arg-1) (PreludeC-45Show-u--show_Show_String arg-1)))
(define PreludeC-45Show-u--showPrec_Show_Nat (lambda (arg-0 arg-1) (PreludeC-45Show-u--show_Show_Nat arg-1)))
(define PreludeC-45Show-u--showPrec_Show_Integer (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Int8 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Int64 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Int32 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Int16 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Int (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Double (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Bool (lambda (arg-0 arg-1) (PreludeC-45Show-u--show_Show_Bool arg-1)))
(define PreludeC-45Show-u--showPrec_Show_Bits8 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Bits64 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Bits32 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_Bits16 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--showPrec_Show_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1) (PreludeC-45Show-u--show_Show_C-40C-124UnitC-44MkUnitC-124C-41 arg-1)))
(define PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-4)))
(define PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) "Nothing" (let ((e-2 (unbox arg-3))) (PreludeC-45Show-showCon arg-2 "Just" (PreludeC-45Show-showArg arg-1 e-2))))))
(define PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-1 arg-3)))
(define PreludeC-45Show-u--showPrec_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (PreludeC-45Show-showCon arg-3 "Left" (PreludeC-45Show-showArg (Builtin-fst arg-2) e-2)))) (else (let ((e-5 (vector-ref arg-4 1))) (PreludeC-45Show-showCon arg-3 "Right" (PreludeC-45Show-showArg (Builtin-snd arg-2) e-5)))))))
(define PreludeC-45Show-u--compare_Ord_Prec (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((4) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45Types-u--compare_Ord_Nat e-0 e-1)))(else (PreludeC-45EqOrd-u--compare_Ord_Integer (PreludeC-45Show-precCon arg-0) (PreludeC-45Show-precCon arg-1))))))(else (PreludeC-45EqOrd-u--compare_Ord_Integer (PreludeC-45Show-precCon arg-0) (PreludeC-45Show-precCon arg-1))))))
(define PreludeC-45Show-u--C-62_Ord_Prec (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Show-u--compare_Ord_Prec arg-0 arg-1) 2)))
(define PreludeC-45Show-u--C-62C-61_Ord_Prec (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Show-u--compare_Ord_Prec arg-0 arg-1) 0)))
(define PreludeC-45Show-showParens (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1) (else (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))))))
(define PreludeC-45Show-showLitString (lambda (arg-0) (lambda (clam-0) (if (null? arg-0) clam-0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-2 #\") (PreludeC-45TypesC-45String-C-43C-43 "\\\"" ((PreludeC-45Show-showLitString e-3) clam-0)))(else ((PreludeC-45Show-showLitChar e-2) ((PreludeC-45Show-showLitString e-3) clam-0))))))))))
(define PreludeC-45Show-showLitChar (lambda (arg-0) (cond ((equal? arg-0 (integer->char 7)) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\a" arg-1))) ((equal? arg-0 (integer->char 8)) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\b" arg-1))) ((equal? arg-0 (integer->char 12)) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\f" arg-1))) ((equal? arg-0 (integer->char 10)) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\n" arg-1))) ((equal? arg-0 (integer->char 13)) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\r" arg-1))) ((equal? arg-0 (integer->char 9)) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\t" arg-1))) ((equal? arg-0 (integer->char 11)) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\v" arg-1))) ((equal? arg-0 (integer->char 14)) (lambda (eta-0) (PreludeC-45Show-protectEsc (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\H)) "\\SO" eta-0))) ((equal? arg-0 (integer->char 127)) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\DEL" arg-1))) ((equal? arg-0 #\\) (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\\\\" arg-1)))(else (lambda (clam-0) (let ((sc0 (PreludeC-45Types-getAt (PreludeC-45Types-u--fromInteger_Num_Nat (char->integer arg-0)) (PreludeC-45Show-n--1920-6294-u--asciiTab arg-0)))) (if (null? sc0) (let ((sc1 (PreludeC-45EqOrd-u--C-62_Ord_Char arg-0 (integer->char 127)))) (cond ((equal? sc1 1) (PreludeC-45Types-strCons #\\ (PreludeC-45Show-protectEsc (lambda (eta-0) (PreludeC-45Types-isDigit eta-0)) (PreludeC-45Show-u--show_Show_Int (cast-char-boundedInt arg-0 63)) clam-0))) (else (PreludeC-45Types-strCons arg-0 clam-0)))) (let ((e-1 (unbox sc0))) (PreludeC-45Types-strCons #\\ (PreludeC-45TypesC-45String-C-43C-43 e-1 clam-0))))))))))
(define PreludeC-45Show-showCon (lambda (arg-0 arg-1 arg-2) (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-0 (vector 6 )) (PreludeC-45TypesC-45String-C-43C-43 arg-1 arg-2))))
(define PreludeC-45Show-showArg (lambda (arg-1 arg-2) (PreludeC-45TypesC-45String-C-43C-43 " " (let ((e-2 (cdr arg-1))) ((e-2 (vector 6 )) arg-2)))))
(define PreludeC-45Show-protectEsc (lambda (arg-0 arg-1 arg-2) (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 (let ((sc0 (PreludeC-45Show-firstCharIs arg-0 arg-2))) (cond ((equal? sc0 1) "\\&") (else ""))) arg-2))))
(define PreludeC-45Show-primNumShow (lambda (arg-1 arg-2 arg-3) (let ((u--str (arg-1 arg-3))) (PreludeC-45Show-showParens (let ((sc0 (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 5 )))) (cond ((equal? sc0 1) (PreludeC-45Show-firstCharIs (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 #\-)) u--str)) (else 0))) u--str))))
(define PreludeC-45Show-precCon (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 5) (else 6))))
(define PreludeC-45Show-firstCharIs (lambda (arg-0 arg-1) (cond ((equal? arg-1 "") 0)(else (arg-0 (string-ref arg-1 0))))))
(define PreludeC-45IO-u--map_Functor_IO (lambda (arg-2 arg-3 ext-0) (let ((act-5 (arg-3 ext-0))) (arg-2 act-5))))
(define PreludeC-45IO-putStrLn (lambda (arg-1 arg-2) (PreludeC-45IO-putStr arg-1 (string-append arg-2 "\xa;"))))
(define PreludeC-45IO-putStr (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (PreludeC-45IO-prim__putStr arg-2 eta-0))))))
(define PreludeC-45IO-putChar (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (PreludeC-45IO-prim__putChar arg-2 eta-0))))))
(define PreludeC-45IO-printLn (lambda (arg-2 arg-3) (PreludeC-45IO-putStrLn (Builtin-fst arg-2) (let ((sc0 (Builtin-snd arg-2))) (let ((e-1 (car sc0))) (e-1 arg-3))))))
(define PreludeC-45IO-getLine (lambda (arg-1) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (PreludeC-45IO-prim__getStr eta-0))))))
(define PreludeC-45IO-getChar (lambda (arg-1) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (PreludeC-45IO-prim__getChar eta-0))))))
(define PreludeC-45Cast-u--cast_Cast_String_Integer (lambda (ext-0) (cast-string-int ext-0)))
(define PreludeC-45Cast-u--cast_Cast_String_Int (lambda (ext-0) (cast-string-boundedInt ext-0 63)))
(define PreludeC-45Cast-u--cast_Cast_String_Double (lambda (ext-0) (cast-string-double ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Nat_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Nat_Int (lambda (ext-0) (blodwen-toSignedInt ext-0 63)))
(define PreludeC-45Cast-u--cast_Cast_Nat_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Nat_Bits64 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Integer_Bits64 ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Nat (lambda (ext-0) (PreludeC-45Types-prim__integerToNat ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Int8 (lambda (ext-0) (blodwen-toSignedInt ext-0 7)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Int64 (lambda (ext-0) (blodwen-toSignedInt ext-0 63)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Int32 (lambda (ext-0) (blodwen-toSignedInt ext-0 31)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Int16 (lambda (ext-0) (blodwen-toSignedInt ext-0 15)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Int (lambda (ext-0) (blodwen-toSignedInt ext-0 63)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Bits8 (lambda (ext-0) (blodwen-toUnsignedInt ext-0 8)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Bits64 (lambda (ext-0) (blodwen-toUnsignedInt ext-0 64)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Bits32 (lambda (ext-0) (blodwen-toUnsignedInt ext-0 32)))
(define PreludeC-45Cast-u--cast_Cast_Integer_Bits16 (lambda (ext-0) (blodwen-toUnsignedInt ext-0 16)))
(define PreludeC-45Cast-u--cast_Cast_Int_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int_Int8 (lambda (ext-0) (blodwen-toSignedInt ext-0 7)))
(define PreludeC-45Cast-u--cast_Cast_Int_Int32 (lambda (ext-0) (blodwen-toSignedInt ext-0 31)))
(define PreludeC-45Cast-u--cast_Cast_Int_Int16 (lambda (ext-0) (blodwen-toSignedInt ext-0 15)))
(define PreludeC-45Cast-u--cast_Cast_Int_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int_Bits8 (lambda (ext-0) (blodwen-toUnsignedInt ext-0 8)))
(define PreludeC-45Cast-u--cast_Cast_Int_Bits64 (lambda (ext-0) (blodwen-toUnsignedInt ext-0 64)))
(define PreludeC-45Cast-u--cast_Cast_Int_Bits16 (lambda (ext-0) (blodwen-toUnsignedInt ext-0 16)))
(define PreludeC-45Cast-u--cast_Cast_Int8_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int8_Int (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int8_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int8_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int64_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int64_Int (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int64_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int64_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int32_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int32_Int (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int32_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int32_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int16_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int16_Int (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Int16_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Int16_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Double_Integer (lambda (ext-0) (exact-truncate ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Double_Int (lambda (ext-0) (exact-truncate-boundedInt ext-0 63)))
(define PreludeC-45Cast-u--cast_Cast_Char_String (lambda (ext-0) (string ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Char_Integer (lambda (ext-0) (char->integer ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Char_Int (lambda (ext-0) (cast-char-boundedInt ext-0 63)))
(define PreludeC-45Cast-u--cast_Cast_Char_Bits64 (lambda (ext-0) (cast-char-boundedUInt ext-0 64)))
(define PreludeC-45Cast-u--cast_Cast_Bits8_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Bits8_Int (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Bits8_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Bits8_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Bits64_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Bits64_Int (lambda (ext-0) (blodwen-toSignedInt ext-0 63)))
(define PreludeC-45Cast-u--cast_Cast_Bits64_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Bits64_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Bits32_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Bits32_Int (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Bits32_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Bits32_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Bits16_Integer (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Bits16_Int (lambda (ext-0) ext-0))
(define PreludeC-45Cast-u--cast_Cast_Bits16_Double (lambda (ext-0) (exact->inexact ext-0)))
(define PreludeC-45Cast-u--cast_Cast_Bits16_Char (lambda (ext-0) (cast-int-char ext-0)))
(define PreludeC-45Cast-u--cast_Cast_C-36a_C-36a (lambda (ext-0) ext-0))
(define SystemC-45FileC-45Support-ok (lambda (arg-3 arg-4) (let ((e-1 (car arg-3))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (vector 1 arg-4)))))))
(define SystemC-45FileC-45ReadWrite-writeFile (lambda (arg-1 arg-2 arg-3) (SystemC-45FileC-45Handle-withFile arg-1 arg-2 1 (lambda (eta-0) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) eta-0))))) (lambda (eta-0) (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (SystemC-45FileC-45ReadWrite-fPutStr arg-1 eta-1 eta-2))) arg-3 eta-0)))))
(define SystemC-45FileC-45ReadWrite-removeFile (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__removeFile arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Support-ok arg-1 0)) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define SystemC-45FileC-45ReadWrite-readLinesOnto (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (vector 1 (cons 0 (PreludeC-45TypesC-45List-reverse arg-2))))))) (let ((e-0 (unbox arg-4))) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45ReadWrite-fEOF arg-1 arg-5)) (lambda (_-0) (cond ((equal? _-0 0) (cond ((equal? arg-3 0) (PreludeC-45InterfacesC-45Monad-u--C-62C-62C-61_Monad_ComposeC-40C-40C-46C-32C-36mC-41C-32C-36tC-41 (cons (let ((e-7 (car arg-1))) e-7) (cons (vector (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-6 (vector-ref arg-215 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref arg-215 1))) (vector 1 (u--func e-6))))))))) (lambda (u--a) (lambda (arg-609) (vector 1 arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-6 (vector-ref arg-610 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-6 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))) (lambda (u--b) (lambda (u--a) (lambda (arg-893) (lambda (arg-894) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 arg-893 arg-894))))) (lambda (u--a) (lambda (arg-896) (PreludeC-45Types-u--join_Monad_C-40EitherC-32C-36eC-41 arg-896)))) (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-6 (vector-ref arg-215 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref arg-215 1))) (vector 1 (u--func e-6))))))))) (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldl_Foldable_C-40EitherC-32C-36eC-41 u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-1176) (PreludeC-45Types-u--null_Foldable_C-40EitherC-32C-36eC-41 arg-1176))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldlM_Foldable_C-40EitherC-32C-36eC-41 i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-1180) (PreludeC-45Types-u--toList_Foldable_C-40EitherC-32C-36eC-41 arg-1180))) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-1182) (PreludeC-45Types-u--foldMap_Foldable_C-40EitherC-32C-36eC-41 i_con-0 u--f arg-1182))))))) (lambda (u--b) (lambda (u--a) (lambda (u--f) (lambda (i_con-0) (lambda (arg-2624) (lambda (arg-2626) (PreludeC-45Types-u--traverse_Traversable_C-40EitherC-32C-36eC-41 i_con-0 arg-2624 arg-2626)))))))))) (SystemC-45FileC-45ReadWrite-fGetLine arg-1 arg-5) (lambda (u--str) (SystemC-45FileC-45ReadWrite-readLinesOnto arg-1 (cons u--str arg-2) 0 (e-0) arg-5))))(else (let ((e-6 (- arg-3 1))) (PreludeC-45Interfaces-C-42C-62 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (PreludeC-45InterfacesC-45Functor-u--map_Functor_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (cons (let ((sc3 (Builtin-fst (cons (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) e-11)) (vector (lambda (b-0) (lambda (a-0) (lambda (func-0) (lambda (arg-216) (case (vector-ref arg-216 0) ((0) (let ((e-7 (vector-ref arg-216 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-216 1))) (vector 1 (func-0 e-7))))))))) (lambda (a-0) (lambda (arg-609) (vector 1 arg-609))) (lambda (b-0) (lambda (a-0) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-7 (vector-ref arg-610 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-7 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))))))) (let ((e-9 (vector-ref sc3 0))) e-9)) (let ((sc3 (Builtin-snd (cons (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) e-11)) (vector (lambda (b-0) (lambda (a-0) (lambda (func-0) (lambda (arg-216) (case (vector-ref arg-216 0) ((0) (let ((e-7 (vector-ref arg-216 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-216 1))) (vector 1 (func-0 e-7))))))))) (lambda (a-0) (lambda (arg-609) (vector 1 arg-609))) (lambda (b-0) (lambda (a-0) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-7 (vector-ref arg-610 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-7 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))))))) (let ((e-9 (vector-ref sc3 0))) e-9))) u--func arg-215))))) (lambda (u--a) (lambda (arg-609) (PreludeC-45InterfacesC-45Applicative-u--pure_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (cons (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) e-11)) (vector (lambda (u--b) (lambda (a-0) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-7 (vector-ref arg-215 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-215 1))) (vector 1 (u--func e-7))))))))) (lambda (a-0) (lambda (arg-610) (vector 1 arg-610))) (lambda (u--b) (lambda (a-0) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-7 (vector-ref arg-610 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-7 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11))))))))))))) arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (PreludeC-45InterfacesC-45Applicative-u--C-60C-42C-62_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (cons (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) e-11)) (vector (lambda (b-0) (lambda (a-0) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-7 (vector-ref arg-215 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-215 1))) (vector 1 (u--func e-7))))))))) (lambda (a-0) (lambda (arg-609) (vector 1 arg-609))) (lambda (b-0) (lambda (a-0) (lambda (arg-611) (lambda (arg-613) (case (vector-ref arg-611 0) ((0) (let ((e-7 (vector-ref arg-611 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-611 1))) (case (vector-ref arg-613 0) ((1) (let ((e-8 (vector-ref arg-613 1))) (vector 1 (e-7 e-8)))) (else (let ((e-11 (vector-ref arg-613 1))) (vector 0 e-11))))))))))))) arg-610 arg-612)))))) (SystemC-45FileC-45ReadWrite-fSeekLine arg-1 arg-5) (SystemC-45FileC-45ReadWrite-readLinesOnto arg-1 arg-2 e-6 (box e-0) arg-5)))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (cons 1 (PreludeC-45TypesC-45List-reverse arg-2)))))))))))))))))
(define SystemC-45FileC-45ReadWrite-readFilePage (lambda (arg-1 arg-2 arg-3 arg-4) (SystemC-45FileC-45Handle-withFile arg-1 arg-4 0 (lambda (eta-0) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) eta-0))))) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-readLinesOnto arg-1 '() arg-2 arg-3 eta-0)))))
(define SystemC-45FileC-45ReadWrite-readFile (lambda (arg-1 ext-0) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-8 (vector-ref e-5 0))) ((((e-8 'erased) 'erased) (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-9 (vector-ref eta-0 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-fastConcat (Builtin-snd e-9)))))))) (SystemC-45FileC-45ReadWrite-readFilePage arg-1 0 (DataC-45Fuel-forever) ext-0)))))))
(define SystemC-45FileC-45ReadWrite-fSeekLine (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__seekLine arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 0))))))))))
(define SystemC-45FileC-45ReadWrite-fPutStr (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__writeLine arg-2 arg-3 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 0))))))))))
(define SystemC-45FileC-45ReadWrite-fGetLine (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__readLine arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr (PrimIO-prim__forgetPtr u--res)) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 (PreludeC-45IO-prim__getString u--res)))))))))))
(define SystemC-45FileC-45ReadWrite-fGetChar (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__readChar arg-2 eta-0))))) (lambda (u--c) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (SystemC-45FileC-45Error-fileError arg-1 arg-2)) (lambda (u--ferr) (cond ((equal? u--ferr 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 (PreludeC-45Cast-u--cast_Cast_Int_Char u--c))))))))))))))
(define SystemC-45FileC-45ReadWrite-fEOF (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__eof arg-2 eta-0))))) (lambda (u--res) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int u--res (blodwen-toSignedInt 0 63))))))))))))
(define SystemC-45FileC-45Error-u--show_Show_FileError (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (SystemC-45Errno-strerror e-0))) ((1) "File Read Error") ((2) "File Write Error") ((3) "File Not Found") ((4) "Permission Denied") (else "File Exists"))))
(define SystemC-45FileC-45Error-returnError (lambda (arg-2) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Error-prim__fileErrno eta-0))))) (lambda (u--err) (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 0 (cond ((equal? u--err 0) (vector 1 )) ((equal? u--err 1) (vector 2 )) ((equal? u--err 2) (vector 3 )) ((equal? u--err 3) (vector 4 )) ((equal? u--err 4) (vector 5 ))(else (vector 0 (bs- u--err 5 63)))))))))))))))
(define SystemC-45FileC-45Error-fileError (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Error-prim__error arg-2 eta-0))))) (lambda (u--x) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int u--x (blodwen-toSignedInt 0 63))))))))))))
(define SystemC-45Errno-strerror (lambda (arg-0) (PrimIO-unsafePerformIO (lambda (eta-0) (SystemC-45Errno-prim__strerror arg-0 eta-0)))))
(define SystemC-45Errno-getErrno (lambda (arg-1) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45Errno-prim__getErrno eta-0))))))
(define SystemC-45FileC-45Handle-withFile (lambda (arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (car arg-3))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-3 arg-4 arg-5)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-3))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (arg-7 e-6)) (lambda (u--res) (PreludeC-45Interfaces-C-62C-62 (let ((e-13 (car arg-3))) e-13) (SystemC-45FileC-45Handle-closeFile arg-3 e-6) (lambda () (let ((e-13 (car arg-3))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) u--res)))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (PreludeC-45Interfaces-C-60C-36C-62 (let ((e-8 (car arg-3))) (let ((e-11 (vector-ref e-8 0))) (let ((e-14 (vector-ref e-11 0))) e-14))) (lambda (eta-0) (vector 0 eta-0)) (arg-6 e-6)))))))))))
(define SystemC-45FileC-45Handle-openFile (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Handle-prim__open arg-2 (SystemC-45FileC-45Mode-modeStr arg-3) eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--res) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 u--res))))))))))
(define SystemC-45FileC-45Handle-closeFile (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45FileC-45Handle-prim__close arg-2 eta-0))))))
(define SystemC-45FileC-45Mode-modeStr (lambda (arg-0) (cond ((equal? arg-0 0) (let ((sc1 (SystemC-45Info-isWindows))) (cond ((equal? sc1 1) "rb") (else "r")))) ((equal? arg-0 1) (let ((sc1 (SystemC-45Info-isWindows))) (cond ((equal? sc1 1) "wb") (else "w")))) ((equal? arg-0 2) (let ((sc1 (SystemC-45Info-isWindows))) (cond ((equal? sc1 1) "ab") (else "a")))) ((equal? arg-0 3) (let ((sc1 (SystemC-45Info-isWindows))) (cond ((equal? sc1 1) "rb+") (else "r+")))) ((equal? arg-0 4) (let ((sc1 (SystemC-45Info-isWindows))) (cond ((equal? sc1 1) "wb+") (else "w+")))) (else (let ((sc1 (SystemC-45Info-isWindows))) (cond ((equal? sc1 1) "ab+") (else "a+")))))))
(define SystemC-45Info-os(blodwen-lazy (lambda () (blodwen-os))))
(define SystemC-45Info-isWindows(blodwen-lazy (lambda () (csegen-93))))
(define SystemC-45Info-codegen(blodwen-lazy (lambda () "chez")))
(define DataC-45List-n--6115-3513-u--spreadHeads (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? arg-4) (cons (cons e-2 '()) (DataC-45List-n--6115-3513-u--spreadHeads arg-1 arg-2 e-3 '())) (let ((e-6 (car arg-4))) (let ((e-7 (cdr arg-4))) (cons (cons e-2 e-6) (DataC-45List-n--6115-3513-u--spreadHeads arg-1 arg-2 e-3 e-7))))))))))
(define DataC-45List-n--5944-3336-u--splitRec (lambda (arg-1 arg-2 arg-4 arg-5 arg-6) (if (null? arg-4) (cons arg-5 (arg-6 '())) (let ((e-2 (cdr arg-4))) (if (null? e-2) (cons arg-5 (arg-6 '())) (let ((e-5 (cdr e-2))) (if (null? arg-5) (cons arg-5 (arg-6 '())) (let ((e-7 (car arg-5))) (let ((e-8 (cdr arg-5))) (DataC-45List-n--5944-3336-u--splitRec arg-1 arg-2 e-5 e-8 (lambda (eta-0) (arg-6 (cons e-7 eta-0)))))))))))))
(define DataC-45List-n--5944-3337-u--split (lambda (arg-1 arg-2 arg-3) (DataC-45List-n--5944-3336-u--splitRec arg-1 arg-2 arg-3 arg-3 (lambda (eta-0) eta-0))))
(define DataC-45List-n--3919-1352-u--nubByC-39 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (DataC-45List-elemBy arg-2 e-2 arg-1))) (cond ((equal? sc1 1) (DataC-45List-n--3919-1352-u--nubByC-39 arg-1 arg-2 e-3)) (else (cons e-2 (DataC-45List-n--3919-1352-u--nubByC-39 (cons e-2 arg-1) arg-2 e-3))))))))))
(define DataC-45List-u--zip_Zippable_List (lambda (ext-0 ext-1) (DataC-45List-u--zipWith_Zippable_List (csegen-186) ext-0 ext-1)))
(define DataC-45List-u--zipWith_Zippable_List (lambda (arg-3 arg-4 arg-5) (if (null? arg-4) '() (if (null? arg-5) '() (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (let ((e-4 (car arg-5))) (let ((e-5 (cdr arg-5))) (cons ((arg-3 e-1) e-4) (DataC-45List-u--zipWith_Zippable_List arg-3 e-2 e-5))))))))))
(define DataC-45List-u--zipWith3_Zippable_List (lambda (arg-4 arg-5 arg-6 arg-7) (if (null? arg-5) '() (if (null? arg-6) '() (if (null? arg-7) '() (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((e-4 (car arg-6))) (let ((e-5 (cdr arg-6))) (let ((e-7 (car arg-7))) (let ((e-8 (cdr arg-7))) (cons (((arg-4 e-1) e-4) e-7) (DataC-45List-u--zipWith3_Zippable_List arg-4 e-2 e-5 e-8)))))))))))))
(define DataC-45List-u--zip3_Zippable_List (lambda (ext-0 ext-1 ext-2) (DataC-45List-u--zipWith3_Zippable_List (lambda (__leftTupleSection-0) (lambda (__infixTupleSection-0) (lambda (__infixTupleSection-1) (cons __leftTupleSection-0 (cons __infixTupleSection-0 __infixTupleSection-1))))) ext-0 ext-1 ext-2)))
(define DataC-45List-u--unzip_Zippable_List (lambda (ext-0) (DataC-45List-u--unzipWith_Zippable_List (lambda (eta-0) eta-0) ext-0)))
(define DataC-45List-u--unzipWith_Zippable_List (lambda (arg-3 arg-4) (if (null? arg-4) (cons '() '()) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (arg-3 e-2))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (DataC-45List-u--unzipWith_Zippable_List arg-3 e-3))) (let ((e-7 (car sc2))) (let ((e-6 (cdr sc2))) (cons (cons e-5 e-7) (cons e-4 e-6)))))))))))))
(define DataC-45List-u--uninhabited_Uninhabited_C-40C-124C-40C-40C-61C-61C-61C-32NilC-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-44C-40C-40C-126C-61C-126C-32NilC-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-124C-41 (lambda (arg-0) (blodwen-error-quit "No clauses")))
(define DataC-45List-u--uninhabited_Uninhabited_C-40C-124C-40C-40C-61C-61C-61C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-32NilC-41C-44C-40C-40C-126C-61C-126C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-32NilC-41C-124C-41 (lambda (arg-0) (blodwen-error-quit "No clauses")))
(define DataC-45List-unionBy (lambda (arg-1 arg-2 arg-3) (PreludeC-45TypesC-45List-tailRecAppend arg-2 (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (DataC-45List-deleteBy arg-1 eta-2 eta-3))) eta-0 eta-1))) (DataC-45List-nubBy arg-1 arg-3) arg-2))))
(define DataC-45List-union (lambda (arg-1 ext-0 ext-1) (DataC-45List-unionBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define DataC-45List-transpose (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (DataC-45List-n--6115-3513-u--spreadHeads e-2 e-3 e-2 (DataC-45List-transpose e-3)))))))
(define DataC-45List-take (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cons e-2 (DataC-45List-take e-0 e-3))))))))))
(define DataC-45List-tails (lambda (arg-1) (cons arg-1 (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (DataC-45List-tails e-3))))))
(define DataC-45List-tailC-39 (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (box e-3)))))
(define DataC-45List-splitAt (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) (cons '() arg-2))(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) (cons '() '()) (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (let ((sc1 (DataC-45List-splitAt e-0 e-4))) (let ((e-2 (car sc1))) (let ((e-5 (cdr sc1))) (cons (cons e-3 e-2) e-5))))))))))))
(define DataC-45List-split (lambda (arg-1 arg-2) (let ((sc0 (DataC-45List-break arg-1 arg-2))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-3) (DataC-45List1-singleton e-2) (let ((e-7 (cdr e-3))) (cons e-2 (DataC-45List1-forget (DataC-45List-split arg-1 e-7))))))))))
(define DataC-45List-spanBy (lambda (arg-2 arg-3) (if (null? arg-3) (cons '() '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (arg-2 e-2))) (if (null? sc1) (cons '() (cons e-2 e-3)) (let ((e-4 (unbox sc1))) (let ((sc2 (DataC-45List-spanBy arg-2 e-3))) (let ((e-6 (car sc2))) (let ((e-5 (cdr sc2))) (cons (cons e-4 e-6) e-5))))))))))))
(define DataC-45List-span (lambda (arg-1 arg-2) (if (null? arg-2) (cons '() '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (let ((sc2 (DataC-45List-span arg-1 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons (cons e-2 e-5) e-4))))) (else (cons '() (cons e-2 e-3))))))))))
(define DataC-45List-sortBy (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (cons e-2 '()) (let ((sc2 (DataC-45List-n--5944-3337-u--split arg-2 arg-1 arg-2))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (DataC-45List-mergeBy arg-1 (DataC-45List-sortBy arg-1 e-5) (DataC-45List-sortBy arg-1 e-4)))))))))))
(define DataC-45List-sort (lambda (arg-1 ext-0) (DataC-45List-sortBy (lambda (eta-0) (lambda (eta-1) (let ((e-2 (vector-ref arg-1 1))) ((e-2 eta-0) eta-1)))) ext-0)))
(define DataC-45List-snoc (lambda (arg-1 arg-2) (PreludeC-45TypesC-45List-tailRecAppend arg-1 (cons arg-2 '()))))
(define DataC-45List-replicate (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (cons arg-2 (DataC-45List-replicate e-0 arg-2)))))))
(define DataC-45List-replaceWhen (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--map_Functor_List (lambda (u--c) (let ((sc0 (arg-1 u--c))) (cond ((equal? sc0 1) arg-2) (else u--c)))) arg-3)))
(define DataC-45List-replaceOn (lambda (arg-1 arg-2 ext-0 ext-1) (DataC-45List-replaceWhen (lambda (arg-0) (let ((e-1 (car arg-1))) ((e-1 arg-0) arg-2))) ext-0 ext-1)))
(define DataC-45List-partition (lambda (arg-1 arg-2) (if (null? arg-2) (cons '() '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (DataC-45List-partition arg-1 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (arg-1 e-2))) (cond ((equal? sc2 1) (cons (cons e-2 e-5) e-4)) (else (cons e-5 (cons e-2 e-4)))))))))))))
(define DataC-45List-nubBy (lambda (ext-0 ext-1) (DataC-45List-n--3919-1352-u--nubByC-39 '() ext-0 ext-1)))
(define DataC-45List-nub (lambda (arg-1 ext-0) (DataC-45List-nubBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0)))
(define DataC-45List-mergeReplicate (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cons arg-1 (cons e-2 (DataC-45List-mergeReplicate arg-1 e-3))))))))
(define DataC-45List-mergeBy (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (if (null? arg-3) arg-2 (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (let ((sc4 ((arg-1 e-1) e-4))) (cond ((equal? sc4 0) (cons e-1 (DataC-45List-mergeBy arg-1 e-2 (cons e-4 e-5))))(else (cons e-4 (DataC-45List-mergeBy arg-1 (cons e-1 e-2) e-5)))))))))))))
(define DataC-45List-mapMaybe (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (arg-2 e-2))) (if (null? sc1) (DataC-45List-mapMaybe arg-2 e-3) (let ((e-4 (unbox sc1))) (cons e-4 (DataC-45List-mapMaybe arg-2 e-3))))))))))
(define DataC-45List-lookupBy (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 ((arg-2 arg-3) e-6))) (cond ((equal? sc2 1) (box e-7)) (else (DataC-45List-lookupBy arg-2 arg-3 e-3)))))))))))
(define DataC-45List-lookup (lambda (arg-2 ext-0 ext-1) (DataC-45List-lookupBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-2))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define DataC-45List-last (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) e-1 (DataC-45List-last e-2))))))
(define DataC-45List-isSuffixOfBy (lambda (arg-1 arg-2 arg-3) (DataC-45List-isPrefixOfBy arg-1 (PreludeC-45TypesC-45List-reverse arg-2) (PreludeC-45TypesC-45List-reverse arg-3))))
(define DataC-45List-isSuffixOf (lambda (arg-1 ext-0 ext-1) (DataC-45List-isSuffixOfBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define DataC-45List-isPrefixOfBy (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) 1 (if (null? arg-3) 0 (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (let ((sc4 ((arg-1 e-1) e-4))) (cond ((equal? sc4 1) (DataC-45List-isPrefixOfBy arg-1 e-2 e-5)) (else 0)))))))))))
(define DataC-45List-isPrefixOf (lambda (arg-1 ext-0 ext-1) (DataC-45List-isPrefixOfBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define DataC-45List-isNil (lambda (arg-1) (if (null? arg-1) 1 0)))
(define DataC-45List-isInfixOf (lambda (arg-1 arg-2 arg-3) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (DataC-45List-isPrefixOf arg-1 arg-2 eta-0)) (DataC-45List-tails arg-3))))
(define DataC-45List-isCons (lambda (arg-1) (if (null? arg-1) 0 1)))
(define DataC-45List-intersperse (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cons e-2 (DataC-45List-mergeReplicate arg-1 e-3)))))))
(define DataC-45List-intersectAllBy (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (DataC-45List-filter (lambda (u--x) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (DataC-45List-elemBy arg-1 u--x eta-0)) e-3)) e-2))))))
(define DataC-45List-intersectAll (lambda (arg-1 ext-0) (DataC-45List-intersectAllBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0)))
(define DataC-45List-init (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) '() (cons e-1 (DataC-45List-init e-2)))))))
(define DataC-45List-headC-39 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (box e-2)))))
(define DataC-45List-head (lambda (arg-1) (let ((e-1 (car arg-1))) e-1)))
(define DataC-45List-find (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (box e-2)) (else (DataC-45List-find arg-1 e-3)))))))))
(define DataC-45List-filter (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (cons e-2 (DataC-45List-filter arg-1 e-3))) (else (DataC-45List-filter arg-1 e-3)))))))))
(define DataC-45List-elemBy (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) 0 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 ((arg-1 arg-2) e-2))) (cond ((equal? sc1 1) 1) (else (DataC-45List-elemBy arg-1 arg-2 e-3)))))))))
(define DataC-45List-dropWhile (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (DataC-45List-dropWhile arg-1 e-3)) (else (cons e-2 e-3)))))))))
(define DataC-45List-drop (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) arg-2)(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) '() (let ((e-4 (cdr arg-2))) (DataC-45List-drop e-0 e-4))))))))
(define DataC-45List-deleteBy (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 ((arg-1 arg-2) e-2))) (cond ((equal? sc1 1) e-3) (else (cons e-2 (DataC-45List-deleteBy arg-1 arg-2 e-3))))))))))
(define DataC-45List-delete (lambda (arg-1 ext-0 ext-1) (DataC-45List-deleteBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define DataC-45List-consInjective (lambda (arg-6) (cond (else (cons 0 0)))))
(define DataC-45List-catMaybes (lambda (ext-0) (DataC-45List-mapMaybe (lambda (eta-0) eta-0) ext-0)))
(define DataC-45List-break (lambda (arg-1 arg-2) (DataC-45List-span (lambda (eta-0) (let ((sc0 (arg-1 eta-0))) (cond ((equal? sc0 1) 0) (else 1)))) arg-2)))
(define DataC-45List-C-92C-92 (lambda (arg-1 ext-0 ext-1) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (DataC-45List-delete arg-1 eta-2 eta-3))) eta-0 eta-1))) ext-0 ext-1)))
(define DataC-45Nat-succNotLTEzero (lambda (arg-0) (blodwen-error-quit "No clauses")))
(define DataC-45Nat-pred (lambda (arg-0) (cond ((equal? arg-0 0) 0)(else (let ((e-0 (- arg-0 1))) e-0)))))
(define DataC-45Nat-lte (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 1)(else (cond ((equal? arg-1 0) 0)(else (cond ((equal? arg-0 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-0 (- arg-0 1))) (cond ((equal? arg-1 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-1 (- arg-1 1))) (DataC-45Nat-lte e-0 e-1)))))))))))))
(define DataC-45Nat-isSucc (lambda (arg-0) (cond ((equal? arg-0 0) 0)(else 1))))
(define DataC-45Nat-isLTE (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (vector 0 0))(else (let ((e-0 (- arg-0 1))) (cond ((equal? arg-1 0) (vector 1 (lambda (eta-0) (DataC-45Nat-succNotLTEzero eta-0))))(else (let ((e-1 (- arg-1 1))) (let ((sc0 (DataC-45Nat-isLTE e-0 e-1))) (case (vector-ref sc0 0) ((1) (let ((e-2 (vector-ref sc0 1))) (vector 1 (lambda (eta-0) (e-2 (DataC-45Nat-fromLteSucc eta-0)))))) (else (let ((e-3 (vector-ref sc0 1))) (vector 0 (+ 1 e-3))))))))))))))
(define DataC-45Nat-fromLteSucc (lambda (arg-2) (cond ((equal? arg-2 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-2 (- arg-2 1))) e-2)))))
(define DataC-45Nat-divNatNZ (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-0 (- arg-1 1))) (DataC-45Nat-divC-39 arg-0 arg-0 e-0))))))
(define DataC-45Nat-divNat (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (Builtin-idris_crash "Unhandled input for Data.Nat.divNat at Data.Nat:334:1--334:59"))(else (let ((e-0 (- arg-1 1))) (DataC-45Nat-divNatNZ arg-0 (+ 1 e-0)))))))
(define DataC-45Nat-divC-39 (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-0 0) 0)(else (let ((e-0 (- arg-0 1))) (let ((sc0 (DataC-45Nat-lte arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else (+ 1 (DataC-45Nat-divC-39 e-0 (PreludeC-45Types-prim__integerToNat (- arg-1 (+ 1 arg-2))) arg-2))))))))))
(define DataC-45Maybe-toMaybe (lambda (arg-1 arg-2) (cond ((equal? arg-1 1) (box (arg-2))) (else '()))))
(define DataC-45Maybe-isNothing (lambda (arg-1) (if (null? arg-1) 1 0)))
(define DataC-45Maybe-isJust (lambda (arg-1) (if (null? arg-1) 0 1)))
(define DataC-45Maybe-fromMaybe (lambda (arg-1 arg-2) (if (null? arg-2) (arg-1) (let ((e-2 (unbox arg-2))) e-2))))
(define DataC-45List1-n--2534-809-u--loop (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (DataC-45List1-n--2534-809-u--loop arg-1 arg-2 e-2 e-3))))))
(define DataC-45List1-u--traverse_Traversable_List1 (lambda (arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (let ((e-6 (vector-ref arg-3 2))) ((((e-6 'erased) 'erased) (let ((e-10 (vector-ref arg-3 1))) ((e-10 'erased) (csegen-188)))) (arg-4 e-1)))) (PreludeC-45Types-u--traverse_Traversable_List arg-3 arg-4 e-2)))))))
(define DataC-45List1-u--toList_Foldable_List1 (lambda (ext-0) (DataC-45List1-forget ext-0)))
(define DataC-45List1-u--show_Show_C-40List1C-32C-36aC-41 (lambda (arg-1 ext-0) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-1 (DataC-45List1-forget ext-0))))
(define DataC-45List1-u--pure_Applicative_List1 (lambda (arg-1) (DataC-45List1-singleton arg-1)))
(define DataC-45List1-u--null_Foldable_List1 (lambda (arg-1) (lambda () 0)))
(define DataC-45List1-u--map_Functor_List1 (lambda (arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cons (arg-2 e-1) (PreludeC-45Types-u--map_Functor_List arg-2 e-2))))))
(define DataC-45List1-u--foldr_Foldable_List1 (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) ((arg-2 e-1) (PreludeC-45Types-u--foldr_Foldable_List arg-2 arg-3 e-2))))))
(define DataC-45List1-u--foldl_Foldable_List1 (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (PreludeC-45Types-u--foldl_Foldable_List arg-2 ((arg-2 arg-3) e-1) e-2)))))
(define DataC-45List1-u--foldlM_Foldable_List1 (lambda (arg-3 arg-4 arg-5 ext-0) (DataC-45List1-u--foldl_Foldable_List1 (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-3 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-4 u--b eta-0)))))) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-5))) ext-0)))
(define DataC-45List1-u--foldMap_Foldable_List1 (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (let ((e-4 (car arg-2))) ((e-4 (arg-3 e-1)) (PreludeC-45Types-u--foldMap_Foldable_List arg-2 arg-3 e-2)))))))
(define DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 (DataC-45List1-forget arg-2) (DataC-45List1-forget arg-3))))
(define DataC-45List1-u--C-62C-62C-61_Monad_List1 (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (DataC-45List1-appendl (arg-3 e-1) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-2 (lambda (eta-0) (DataC-45List1-forget (arg-3 eta-0)))))))))
(define DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (let ((sc2 (let ((e-6 (car arg-1))) ((e-6 e-1) e-4)))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 arg-1 e-2 e-5)) (else 0)))))))))
(define DataC-45List1-singleton (lambda (arg-1) (cons arg-1 '())))
(define DataC-45List1-reverseOnto (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (DataC-45List1-reverseOnto (cons e-2 (DataC-45List1-forget arg-1)) e-3))))))
(define DataC-45List1-reverse (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (DataC-45List1-reverseOnto (DataC-45List1-singleton e-1) e-2)))))
(define DataC-45List1-last (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (DataC-45List1-n--2534-809-u--loop e-1 e-2 e-1 e-2)))))
(define DataC-45List1-fromList (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (box (cons e-2 e-3)))))))
(define DataC-45List1-forget (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (cons e-1 e-2)))))
(define DataC-45List1-cons (lambda (arg-1 arg-2) (cons arg-1 (DataC-45List1-forget arg-2))))
(define DataC-45List1-appendl (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (cons e-1 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-2))))))
(define DataC-45List1-C-43C-43 (lambda (arg-1 arg-2) (DataC-45List1-appendl arg-1 (DataC-45List1-forget arg-2))))
(define DataC-45Fuel-forever(blodwen-lazy (lambda () (box (lambda () (DataC-45Fuel-forever))))))
(define SystemC-45FileC-45Process-popen (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Process-prim__popen arg-2 (SystemC-45FileC-45Mode-modeStr arg-3) eta-0))))) (lambda (u--ptr) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--ptr) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 u--ptr))))))))))))))
(define SystemC-45FileC-45Process-pclose (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45FileC-45Process-prim__pclose arg-2 eta-0))))))
(define SystemC-45FileC-45Process-fflush (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-8 (vector-ref e-5 0))) ((((e-8 'erased) 'erased) (lambda (eta-0) 0)) (let ((e-9 (cdr arg-1))) ((e-9 'erased) (lambda (eta-0) (SystemC-45FileC-45Process-prim__flush arg-2 eta-0))))))))))
(define SystemC-45FileC-45Permissions-n--2518-423-u--getMs (lambda (arg-0 ext-0) (PreludeC-45Interfaces-sum (cons (csegen-51) (csegen-190)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (SystemC-45FileC-45Permissions-n--2518-422-u--getM arg-0 eta-0)) ext-0))))
(define SystemC-45FileC-45Permissions-n--2518-422-u--getM (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) 4) ((equal? arg-1 1) 2) (else 1))))
(define SystemC-45FileC-45Permissions-mkMode (lambda (arg-0) (bs+ (bs+ (bs* (SystemC-45FileC-45Permissions-n--2518-423-u--getMs arg-0 (let ((e-0 (vector-ref arg-0 0))) e-0)) 64 63) (bs* (SystemC-45FileC-45Permissions-n--2518-423-u--getMs arg-0 (let ((e-1 (vector-ref arg-0 1))) e-1)) 8 63) 63) (SystemC-45FileC-45Permissions-n--2518-423-u--getMs arg-0 (let ((e-2 (vector-ref arg-0 2))) e-2)) 63)))
(define SystemC-45FileC-45Permissions-chmodRaw (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Permissions-prim__chmod arg-2 arg-3 eta-0))))) (lambda (u--ok) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--ok (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 0)))))) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define SystemC-45FileC-45Permissions-chmod (lambda (arg-1 arg-2 arg-3) (SystemC-45FileC-45Permissions-chmodRaw arg-1 arg-2 (SystemC-45FileC-45Permissions-mkMode arg-3))))
(define SystemC-45FileC-45Meta-firstExists (lambda (arg-1 arg-2) (if (null? arg-2) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) '())))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-1 (car arg-1))) (let ((e-6 (vector-ref e-1 1))) ((((e-6 'erased) 'erased) (SystemC-45FileC-45Meta-exists arg-1 e-2)) (lambda (bind-0) (cond ((equal? bind-0 1) (let ((e-9 (car arg-1))) (let ((e-12 (vector-ref e-9 0))) (let ((e-14 (vector-ref e-12 1))) ((e-14 'erased) (box e-2)))))) (else (SystemC-45FileC-45Meta-firstExists arg-1 e-3))))))))))))
(define SystemC-45FileC-45Meta-fileSize (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Meta-prim__fileSize arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Support-ok arg-1 u--res)) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define SystemC-45FileC-45Meta-fileModifiedTime (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Meta-prim__fileModifiedTime arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-62_Ord_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Support-ok arg-1 u--res)) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define SystemC-45FileC-45Meta-exists (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-1 arg-2 0)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (PreludeC-45Interfaces-C-62C-62 (let ((e-8 (car arg-1))) e-8) (SystemC-45FileC-45Handle-closeFile arg-1 e-6) (lambda () (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) 1)))))))) (else (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) 0))))))))))))
(define SystemC-45FileC-45Buffer-writeBufferToFile (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-1 arg-2 1)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (SystemC-45FileC-45Buffer-writeBufferData arg-1 e-6 arg-3 0 arg-4)) (lambda (_-1) (case (vector-ref _-1 0) ((1) (let ((e-12 (vector-ref _-1 1))) (PreludeC-45Interfaces-C-62C-62 (let ((e-14 (car arg-1))) e-14) (SystemC-45FileC-45Handle-closeFile arg-1 e-6) (lambda () (let ((e-14 (car arg-1))) (let ((e-17 (vector-ref e-14 0))) (let ((e-19 (vector-ref e-17 1))) ((e-19 'erased) (vector 1 e-12))))))))) (else (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-17 (vector-ref e-14 0))) (let ((e-19 (vector-ref e-17 1))) ((e-19 'erased) (vector 0 e-12)))))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 e-6))))))))))))))
(define SystemC-45FileC-45Buffer-writeBufferData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Buffer-prim__writeBufferData arg-2 arg-3 arg-4 arg-5 eta-0))))) (lambda (u--written) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int u--written (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 0)))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 0 (vector 2 )))))))))))))))
(define SystemC-45FileC-45Buffer-readBufferData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Buffer-prim__readBufferData arg-2 arg-3 arg-4 arg-5 eta-0))))) (lambda (u--read) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int u--read (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 0)))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 0 (vector 1 )))))))))))))))
(define SystemC-45FileC-45Buffer-createBufferFromFile (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-1 arg-2 0)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (SystemC-45FileC-45Meta-fileSize arg-1 e-6)) (lambda (_-1) (case (vector-ref _-1 0) ((1) (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-16 (vector-ref e-14 1))) ((((e-16 'erased) 'erased) (DataC-45Buffer-newBuffer arg-1 e-12)) (lambda (_-2) (if (null? _-2) (let ((e-19 (car arg-1))) (let ((e-22 (vector-ref e-19 0))) (let ((e-24 (vector-ref e-22 1))) ((e-24 'erased) (vector 0 (vector 1 )))))) (let ((e-18 (unbox _-2))) (let ((e-20 (car arg-1))) (let ((e-22 (vector-ref e-20 1))) ((((e-22 'erased) 'erased) (SystemC-45FileC-45Buffer-readBufferData arg-1 e-6 e-18 0 e-12)) (lambda (_-3) (case (vector-ref _-3 0) ((1) (PreludeC-45Interfaces-C-62C-62 (let ((e-26 (car arg-1))) e-26) (SystemC-45FileC-45Handle-closeFile arg-1 e-6) (lambda () (let ((e-26 (car arg-1))) (let ((e-29 (vector-ref e-26 0))) (let ((e-31 (vector-ref e-29 1))) ((e-31 'erased) (vector 1 e-18)))))))) (else (let ((e-24 (vector-ref _-3 1))) (let ((e-26 (car arg-1))) (let ((e-29 (vector-ref e-26 0))) (let ((e-31 (vector-ref e-29 1))) ((e-31 'erased) (vector 0 e-24)))))))))))))))))))) (else (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-17 (vector-ref e-14 0))) (let ((e-19 (vector-ref e-17 1))) ((e-19 'erased) (vector 0 e-12)))))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 e-6))))))))))))))
(define DataC-45Buffer-resizeBuffer (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (DataC-45Buffer-newBuffer arg-1 arg-3)) (lambda (_-0) (if (null? _-0) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) '())))) (let ((e-6 (unbox _-0))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) (DataC-45Buffer-prim__bufferSize arg-2)))))) (lambda (u--oldsize) (let ((u--len (let ((sc3 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-3 u--oldsize))) (cond ((equal? sc3 1) arg-3) (else u--oldsize))))) (PreludeC-45Interfaces-C-62C-62 (let ((e-13 (car arg-1))) e-13) (DataC-45Buffer-copyData arg-1 arg-2 0 u--len e-6 0) (lambda () (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) (box e-6))))))))))))))))))))
(define DataC-45Buffer-newBuffer (lambda (arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-2 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (DataC-45Buffer-prim__newBuffer arg-2 eta-0))))) (lambda (u--buf) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (box u--buf)))))))))) (else (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) '())))))))))
(define DataC-45Buffer-copyData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (DataC-45Buffer-prim__copyData arg-2 arg-3 arg-4 arg-5 arg-6 eta-0))))))
(define SystemC-45Directory-openDir (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__openDir arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--res) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45Directory-ok arg-1 u--res))))))))))
(define SystemC-45Directory-ok (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (vector 1 arg-3)))))))
(define SystemC-45Directory-nextDirEntry (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__dirEntry arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr (PrimIO-prim__forgetPtr u--res)) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (SystemC-45Errno-getErrno arg-1)) (lambda (bind-0) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int bind-0 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc3 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (let ((e-12 (car arg-1))) (let ((e-15 (vector-ref e-12 0))) (let ((e-17 (vector-ref e-15 1))) ((e-17 'erased) (vector 1 '()))))))))))))) (else (let ((u--n (PreludeC-45IO-prim__getString u--res))) (let ((sc2 (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--n "."))) (cond ((equal? sc3 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--n "..")))))) (cond ((equal? sc2 1) (SystemC-45Directory-nextDirEntry arg-1 arg-2)) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (box u--n)))))))))))))))))))
(define SystemC-45Directory-dirEntry (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45Directory-nextDirEntry arg-1 arg-2)) (lambda (u--r) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (case (vector-ref u--r 0) ((0) (let ((e-14 (vector-ref u--r 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref u--r 1))) (if (null? e-14) (vector 0 (vector 3 )) (let ((e-15 (unbox e-14))) (vector 1 e-15))))))))))))))))
(define SystemC-45Directory-currentDir (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__currentDir eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr (PrimIO-prim__forgetPtr u--res)) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) '()))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (box (PreludeC-45IO-prim__getString u--res)))))))))))))))
(define SystemC-45Directory-createDir (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__createDir arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45Directory-ok arg-1 0)) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define SystemC-45Directory-closeDir (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45Directory-prim__closeDir arg-2 eta-0))))))
(define SystemC-45Directory-changeDir (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__changeDir arg-2 eta-0))))) (lambda (u--ok) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--ok (blodwen-toSignedInt 0 63))))))))))))
(define IdrisC-45Env-idrisGetEnv (lambda (arg-1 arg-2 arg-3) (System-getEnv arg-1 arg-2)))
(define IdrisC-45Env-envs(blodwen-lazy (lambda () (cons (cons "EDITOR" "Editor used in REPL :e command") (cons (cons "IDRIS2_PREFIX" "Idris2 installation prefix") (cons (cons "IDRIS2_PATH" "Places Idris2 looks for import files") (cons (cons "IDRIS2_PACKAGE_PATH" "Places Idris2 looks for packages") (cons (cons "IDRIS2_DATA" "Places Idris2 looks for data files") (cons (cons "IDRIS2_LIBS" "Places Idris2 looks for libraries (for code generation)") (cons (cons "IDRIS2_CG" "Codegen backend") (cons (cons "IDRIS2_INC_CGS" "Code generators to use (comma separated) when compiling modules incrementally") (cons (cons "CHEZ" "chez executable used in Chez codegen") (cons (cons "RACKET" "racket executable used in Racket codegen") (cons (cons "RACKET_RACO" "raco executable used in Racket codegen") (cons (cons "GAMBIT_GSI" "gsi executable used in Gambit codegen") (cons (cons "GAMBIT_GSC" "gsc executable used in Gambit codegen") (cons (cons "GAMBIT_GSC_BACKEND" "gsc executable backend argument") (cons (cons "IDRIS2_CC" "C compiler executable used in RefC codegen") (cons (cons "CC" "C compiler executable used in RefC codegen") (cons (cons "NODE" "node executable used in Node codegen") (cons (cons "PATH" "PATH variable is used to search for executables in certain codegens") '())))))))))))))))))))))
(define System-system (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (System-prim__system arg-2 eta-0))))))
(define System-getEnv (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (System-prim__getEnv arg-2 eta-0))))) (lambda (u--env) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr (PrimIO-prim__forgetPtr u--env)) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) '()))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (box (PreludeC-45IO-prim__getString u--env)))))))))))))))
(define System-getArgs (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (System-prim__getArgCount eta-0))))) (lambda (u--n) (let ((sc1 (PreludeC-45EqOrd-u--C-62_Ord_Int u--n (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (PreludeC-45Interfaces-for (cons (vector (csegen-212) (csegen-51) (lambda (u--b) (lambda (u--a) (lambda (u--f) (lambda (i_con-0) (lambda (arg-2624) (lambda (arg-2626) (PreludeC-45Types-u--traverse_Traversable_List i_con-0 arg-2624 arg-2626)))))))) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) e-10))) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (csegen-219) 0 (bs- u--n 1 63)) (lambda (eta-0) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-1) (System-prim__getArg eta-0 eta-1))))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) '())))))))))))))
(define System-exitWith (lambda (arg-2 arg-3) (if (null? arg-3) (let ((e-2 (cdr arg-2))) ((e-2 'erased) (Builtin-believe_me (lambda (eta-0) (System-prim__exit 0 eta-0))))) (let ((e-0 (car arg-3))) (let ((e-2 (cdr arg-2))) ((e-2 'erased) (Builtin-believe_me (lambda (eta-0) (System-prim__exit e-0 eta-0)))))))))
(define DataC-45String-with--parseIntegerC-44parseIntTrimmed-3056 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 "") (if (null? arg-4) '() (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 #\-))) (cond ((equal? sc3 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--y) (let ((sc4 (Builtin-snd arg-1))) (let ((e-2 (vector-ref sc4 1))) (e-2 (let ((sc4 (Builtin-fst arg-1))) (let ((e-5 (vector-ref sc4 2))) (e-5 u--y))))))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0))) (else (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 #\+))) (cond ((equal? sc4 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((sc5 (Builtin-fst arg-1))) (let ((e-3 (vector-ref sc5 2))) (e-3 eta-0)))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (PreludeC-45Cast-u--cast_Cast_Int_Integer 0)))) (else (let ((sc5 (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-0 #\0))) (cond ((equal? sc6 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-0 #\9)) (else 0))))) (cond ((equal? sc5 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((sc6 (Builtin-fst arg-1))) (let ((e-3 (vector-ref sc6 2))) (e-3 eta-0)))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- (PreludeC-45Types-ord e-0) (PreludeC-45Types-ord #\0) 63))))) (else '())))))))))))))(else (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 #\-))) (cond ((equal? sc1 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--y) (let ((sc2 (Builtin-snd arg-1))) (let ((e-2 (vector-ref sc2 1))) (e-2 (let ((sc2 (Builtin-fst arg-1))) (let ((e-5 (vector-ref sc2 2))) (e-5 u--y))))))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0))) (else (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 #\+))) (cond ((equal? sc2 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((sc3 (Builtin-fst arg-1))) (let ((e-3 (vector-ref sc3 2))) (e-3 eta-0)))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (PreludeC-45Cast-u--cast_Cast_Int_Integer 0)))) (else (let ((sc3 (let ((sc4 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-0 #\0))) (cond ((equal? sc4 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-0 #\9)) (else 0))))) (cond ((equal? sc3 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((sc4 (Builtin-fst arg-1))) (let ((e-3 (vector-ref sc4 2))) (e-3 eta-0)))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- (PreludeC-45Types-ord e-0) (PreludeC-45Types-ord #\0) 63))))) (else '())))))))))))))))
(define DataC-45String-with--parsePositiveC-44parsePosTrimmed-2962 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 "") (if (null? arg-4) '() (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (cond ((equal? e-0 #\+) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0)))(else (let ((sc3 (let ((sc4 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-0 #\0))) (cond ((equal? sc4 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-0 #\9)) (else 0))))) (cond ((equal? sc3 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- (PreludeC-45Types-ord e-0) (PreludeC-45Types-ord #\0) 63))))) (else '())))))))))(else (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (cond ((equal? e-0 #\+) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0)))(else (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-0 #\0))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-0 #\9)) (else 0))))) (cond ((equal? sc1 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- (PreludeC-45Types-ord e-0) (PreludeC-45Types-ord #\0) 63))))) (else '())))))))))))
(define DataC-45String-with--ltrim-2752 (lambda (arg-0 arg-1) (cond ((equal? arg-0 "") (case (vector-ref arg-1 0) ((0) "")(else (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((u--str (PreludeC-45Types-strCons e-0 e-1))) (let ((sc2 (PreludeC-45Types-isSpace e-0))) (cond ((equal? sc2 1) (DataC-45String-with--ltrim-2752 e-1 (e-2))) (else u--str))))))))))(else (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((u--str (PreludeC-45Types-strCons e-0 e-1))) (let ((sc1 (PreludeC-45Types-isSpace e-0))) (cond ((equal? sc1 1) (DataC-45String-with--ltrim-2752 e-1 (e-2))) (else u--str)))))))))))
(define DataC-45String-with--asList-2736 (lambda (arg-0 arg-1) (cond ((equal? arg-0 "") (if (null? arg-1) (vector 0 ) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (vector 1 e-0 e-1 (lambda () (DataC-45String-asList e-1)))))))(else (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (vector 1 e-0 e-1 (lambda () (DataC-45String-asList e-1)))))))))
(define DataC-45String-case--wordsC-39-2566 (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((sc1 (DataC-45List-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) arg-1))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons e-2 (DataC-45String-wordsC-39 e-3))))))))
(define DataC-45String-n--2948-2537-u--unlinesC-39 (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons e-2 (cons "\xa;" (DataC-45String-n--2948-2537-u--unlinesC-39 e-3))))))))
(define DataC-45String-n--3350-2960-u--parsePosTrimmed (lambda (arg-1 arg-2 arg-3) (DataC-45String-with--parsePositiveC-44parsePosTrimmed-2962 'erased arg-1 arg-3 arg-3 (DataC-45String-strM arg-3))))
(define DataC-45String-n--3441-3054-u--parseIntTrimmed (lambda (arg-1 arg-2 arg-3) (DataC-45String-with--parseIntegerC-44parseIntTrimmed-3056 'erased arg-1 arg-3 arg-3 (DataC-45String-strM arg-3))))
(define DataC-45String-n--3009-2601-u--addSpace (lambda (arg-0 arg-1 arg-2) (PreludeC-45TypesC-45List-tailRecAppend arg-1 (cons #\  arg-2))))
(define DataC-45String-wordsC-39 (lambda (arg-0) (DataC-45String-case--wordsC-39-2566 arg-0 (DataC-45List-dropWhile (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) arg-0))))
(define DataC-45String-words (lambda (arg-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45String-wordsC-39 (PreludeC-45Types-fastUnpack arg-0)))))
(define DataC-45String-unwordsC-39 (lambda (arg-0) (if (null? arg-0) '() (DataC-45String-foldr1 (lambda (eta-0) (lambda (eta-1) (DataC-45String-n--3009-2601-u--addSpace arg-0 eta-0 eta-1))) arg-0))))
(define DataC-45String-unwords (lambda (ext-0) (PreludeC-45Types-fastPack (DataC-45String-unwordsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Types-fastUnpack eta-0)) ext-0)))))
(define DataC-45String-trim (lambda (ext-0) (DataC-45String-ltrim (PreludeC-45Types-reverse (DataC-45String-ltrim (PreludeC-45Types-reverse ext-0))))))
(define DataC-45String-toLower (lambda (arg-0) (PreludeC-45Types-fastPack (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Types-toLower eta-0)) (PreludeC-45Types-fastUnpack arg-0)))))
(define DataC-45String-stringToNatOrZ (lambda (ext-0) (PreludeC-45Types-u--fromInteger_Num_Nat (cast-string-int ext-0))))
(define DataC-45String-strTail (lambda (ext-0) (substring ext-0 1 (string-length ext-0))))
(define DataC-45String-strM (lambda (arg-0) (cond ((equal? arg-0 "") '())(else (Builtin-believe_me (cons (string-ref arg-0 0) (substring arg-0 1 (string-length arg-0))))))))
(define DataC-45String-strLength (lambda (ext-0) (string-length ext-0)))
(define DataC-45String-strIndex (lambda (ext-0 ext-1) (string-ref ext-0 ext-1)))
(define DataC-45String-split (lambda (arg-0 arg-1) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45List-split arg-0 (PreludeC-45Types-fastUnpack arg-1)))))
(define DataC-45String-span (lambda (arg-0 arg-1) (let ((sc0 (DataC-45List-span arg-0 (PreludeC-45Types-fastUnpack arg-1)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons (PreludeC-45Types-fastPack e-2) (PreludeC-45Types-fastPack e-3)))))))
(define DataC-45String-singleton (lambda (arg-0) (PreludeC-45Types-strCons arg-0 "")))
(define DataC-45String-parsePositive (lambda (arg-1 arg-2) (DataC-45String-n--3350-2960-u--parsePosTrimmed arg-1 arg-2 (DataC-45String-trim arg-2))))
(define DataC-45String-parseNumWithoutSign (lambda (arg-0 arg-1) (if (null? arg-0) (box arg-1) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-2 #\0))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-2 #\9)) (else 0))))) (cond ((equal? sc1 1) (DataC-45String-parseNumWithoutSign e-3 (+ (* arg-1 10) (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- (PreludeC-45Types-ord e-2) (PreludeC-45Types-ord #\0) 63))))) (else '()))))))))
(define DataC-45String-parseInteger (lambda (arg-1 arg-2) (DataC-45String-n--3441-3054-u--parseIntTrimmed arg-1 arg-2 (DataC-45String-trim arg-2))))
(define DataC-45String-ltrim (lambda (arg-0) (DataC-45String-with--ltrim-2752 arg-0 (DataC-45String-asList arg-0))))
(define DataC-45String-isSuffixOf (lambda (arg-0 arg-1) (DataC-45List-isSuffixOf (csegen-0) (PreludeC-45Types-fastUnpack arg-0) (PreludeC-45Types-fastUnpack arg-1))))
(define DataC-45String-isPrefixOf (lambda (arg-0 arg-1) (DataC-45List-isPrefixOf (csegen-0) (PreludeC-45Types-fastUnpack arg-0) (PreludeC-45Types-fastUnpack arg-1))))
(define DataC-45String-isInfixOf (lambda (arg-0 arg-1) (DataC-45List-isInfixOf (csegen-0) (PreludeC-45Types-fastUnpack arg-0) (PreludeC-45Types-fastUnpack arg-1))))
(define DataC-45String-foldr1 (lambda (arg-1 arg-2) (if (null? arg-2) (Builtin-idris_crash "Unhandled input for Data.String.foldr1 at Data.String:34:1--34:17") (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (if (null? e-2) e-1 ((arg-1 e-1) (DataC-45String-foldr1 arg-1 e-2))))))))
(define DataC-45String-fastUnlines (lambda (ext-0) (PreludeC-45Types-fastConcat (DataC-45String-n--2948-2537-u--unlinesC-39 ext-0))))
(define DataC-45String-fastAppend (lambda (ext-0) (PreludeC-45Types-fastConcat ext-0)))
(define DataC-45String-break (lambda (arg-0 ext-0) (DataC-45String-span (lambda (eta-0) (let ((sc0 (arg-0 eta-0))) (cond ((equal? sc0 1) 0) (else 1)))) ext-0)))
(define DataC-45String-asList (lambda (arg-0) (DataC-45String-with--asList-2736 arg-0 (DataC-45String-strM arg-0))))
(define LibrariesC-45DataC-45NameMap-n--5213-7187-u--treeToListC-39 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (cons (cons e-1 e-2) arg-3)))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 3))) (LibrariesC-45DataC-45NameMap-n--5213-7187-u--treeToListC-39 (LibrariesC-45DataC-45NameMap-n--5213-7187-u--treeToListC-39 arg-3 e-7) e-5)))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 5))) (LibrariesC-45DataC-45NameMap-n--5213-7187-u--treeToListC-39 (LibrariesC-45DataC-45NameMap-n--5213-7187-u--treeToListC-39 (LibrariesC-45DataC-45NameMap-n--5213-7187-u--treeToListC-39 arg-3 e-14) e-12) e-10))))))))
(define LibrariesC-45DataC-45NameMap-n--6096-8061-u--loop (lambda (arg-4 arg-5 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-4 (vector-ref arg-4 1))) ((((e-4 'erased) 'erased) (arg-5 e-1)) (lambda (_-0) (if (null? _-0) (let ((e-8 (vector-ref arg-4 0))) (let ((e-10 (vector-ref e-8 1))) ((e-10 'erased) arg-7))) (let ((e-6 (unbox _-0))) (let ((e-9 (vector-ref arg-4 0))) (let ((e-11 (vector-ref e-9 1))) ((e-11 'erased) (LibrariesC-45DataC-45NameMap-insert e-1 e-6 arg-7))))))))))) ((1) (let ((e-5 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (LibrariesC-45DataC-45NameMap-n--6096-8061-u--loop arg-4 arg-5 arg-7 e-5)) (lambda (u--acc) (LibrariesC-45DataC-45NameMap-n--6096-8061-u--loop arg-4 arg-5 u--acc e-7))))))) (else (let ((e-10 (vector-ref arg-8 1))) (let ((e-12 (vector-ref arg-8 3))) (let ((e-14 (vector-ref arg-8 5))) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (LibrariesC-45DataC-45NameMap-n--6096-8061-u--loop arg-4 arg-5 arg-7 e-10)) (lambda (u--acc) (let ((e-5 (vector-ref arg-4 1))) ((((e-5 'erased) 'erased) (LibrariesC-45DataC-45NameMap-n--6096-8061-u--loop arg-4 arg-5 u--acc e-12)) (lambda (acc-0) (LibrariesC-45DataC-45NameMap-n--6096-8061-u--loop arg-4 arg-5 acc-0 e-14))))))))))))))
(define LibrariesC-45DataC-45NameMap-n--5821-7783-u--loop (lambda (arg-2 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((sc1 (arg-2 e-1))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45NameMap-insert e-1 e-2 arg-4))(else arg-4)))))) ((1) (let ((e-5 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 3))) (LibrariesC-45DataC-45NameMap-n--5821-7783-u--loop arg-2 (LibrariesC-45DataC-45NameMap-n--5821-7783-u--loop arg-2 arg-4 e-5) e-7)))) (else (let ((e-10 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 5))) (LibrariesC-45DataC-45NameMap-n--5821-7783-u--loop arg-2 (LibrariesC-45DataC-45NameMap-n--5821-7783-u--loop arg-2 (LibrariesC-45DataC-45NameMap-n--5821-7783-u--loop arg-2 arg-4 e-10) e-12) e-14))))))))
(define LibrariesC-45DataC-45NameMap-n--5718-7677-u--inserted (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (LibrariesC-45DataC-45NameMap-toList arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-3) (LibrariesC-45DataC-45NameMap-lookup e-2 arg-2)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45NameMap-u--show_Show_C-40NameMapC-32C-36vC-41 (lambda (arg-1 arg-2) (if (null? arg-2) "Empty NameMap" (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45TypesC-45String-C-43C-43 "NameMap M(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-2) (PreludeC-45TypesC-45String-C-43C-43 "):\xa;" (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-1 e-3)))))))))
(define LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "Leaf: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-1) (PreludeC-45TypesC-45String-C-43C-43 " -> " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-4 (car arg-2))) (e-4 e-2)) "\xa;"))))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "Branch2: " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-5) (PreludeC-45TypesC-45String-C-43C-43 "\xa; < " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-7) "\xa;")))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (PreludeC-45TypesC-45String-C-43C-43 "Branch3: " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-10) (PreludeC-45TypesC-45String-C-43C-43 "\xa; < " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-11) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-12) (PreludeC-45TypesC-45String-C-43C-43 "\xa; < " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-13) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-14) "\xa;")))))))))))))))))))
(define LibrariesC-45DataC-45NameMap-u--neutral_Monoid_C-40NameMapC-32C-36vC-41 (lambda (arg-1) (LibrariesC-45DataC-45NameMap-empty)))
(define LibrariesC-45DataC-45NameMap-u--C-60C-43C-62_Semigroup_C-40NameMapC-32C-36vC-41 (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45NameMap-merge arg-1 ext-0 ext-1)))
(define LibrariesC-45DataC-45NameMap-values (lambda (ext-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (LibrariesC-45DataC-45NameMap-toList ext-0))))
(define LibrariesC-45DataC-45NameMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45NameMap-n--5213-7187-u--treeToListC-39 '() ext-0)))
(define LibrariesC-45DataC-45NameMap-treeMapMaybeM (lambda (arg-4 arg-5 ext-0) (LibrariesC-45DataC-45NameMap-n--6096-8061-u--loop arg-4 arg-5 (LibrariesC-45DataC-45NameMap-empty) ext-0)))
(define LibrariesC-45DataC-45NameMap-treeLookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-2 e-1))) (cond ((equal? sc1 1) (box e-2)) (else '())))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-6))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-5)) (else (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-7)))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-11))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-10)) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-13))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-12)) (else (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-14))))))))))))))))
(define LibrariesC-45DataC-45NameMap-treeInsertC-39 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (CoreC-45Name-u--compare_Ord_Name arg-2 e-1))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-2 arg-3) (cons arg-2 (vector 0 e-1 e-2))))) ((equal? sc1 1) (vector 0 (vector 0 arg-2 arg-3))) (else (vector 1 (cons (vector 0 e-1 e-2) (cons e-1 (vector 0 arg-2 arg-3)))))))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-6))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-5))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-6 e-7)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-10 e-12 e-13 e-6 e-7))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-5 e-6 e-2)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-5 e-6 e-10 e-12 e-13))))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-11))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-10))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-11 e-12 e-13 e-14)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-16 e-15) (cons e-11 (vector 1 e-12 e-13 e-14))))))))))))) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-2 e-13 e-14)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-8) (cons e-16 (vector 1 e-15 e-13 e-14))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-14))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-12 e-13 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-12) (cons e-13 (vector 1 e-8 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45NameMap-treeInsert (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45NameMap-treeFilterBy (lambda (arg-2 ext-0) (LibrariesC-45DataC-45NameMap-n--5821-7783-u--loop arg-2 (LibrariesC-45DataC-45NameMap-empty) ext-0)))
(define LibrariesC-45DataC-45NameMap-treeDelete (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-1 0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-2 e-2))) (cond ((equal? sc2 1) (vector 1 0)) (else (vector 0 (vector 0 e-2 e-3))))))))(else (let ((e-0 (- arg-1 1))) (cond ((equal? e-0 0) (case (vector-ref arg-3 0) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-8))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-7))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-2 e-8 e-9)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 1 e-9)))))))) (else (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-9))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-7 e-8 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 1 e-7)))))))))))))) (else (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (let ((e-16 (vector-ref arg-3 5))) (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-2 e-13 e-14 e-15 e-16)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 0 (vector 1 e-14 e-15 e-16))))))))) (else (let ((sc3 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-15))) (cond ((equal? sc3 1) (let ((sc4 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-14))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-12 e-13 e-2 e-15 e-16)))) (else (let ((e-5 (vector-ref sc4 1))) (cond (else (vector 0 (vector 1 e-12 e-13 e-16))))))))) (else (let ((sc4 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-16))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-12 e-13 e-14 e-15 e-2)))) (else (let ((e-5 (vector-ref sc4 1))) (cond (else (vector 0 (vector 1 e-12 e-13 e-14))))))))))))))))))))))(else (let ((e-4 (- e-0 1))) (case (vector-ref arg-3 0) ((1) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-20))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeDelete (+ 1 e-4) arg-2 e-19))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-20 e-21)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-21 0) ((1) (let ((e-2 (vector-ref e-21 1))) (let ((e-3 (vector-ref e-21 2))) (let ((e-6 (vector-ref e-21 3))) (vector 1 (vector 2 e-5 e-20 e-2 e-3 e-6)))))) (else (let ((e-7 (vector-ref e-21 1))) (let ((e-8 (vector-ref e-21 2))) (let ((e-9 (vector-ref e-21 3))) (let ((e-10 (vector-ref e-21 4))) (let ((e-11 (vector-ref e-21 5))) (vector 0 (LibrariesC-45DataC-45NameMap-branch4 e-5 e-20 e-7 e-8 e-9 e-10 e-11)))))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45NameMap-treeDelete (+ 1 e-4) arg-2 e-21))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-19 e-20 e-2)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-19 0) ((1) (let ((e-2 (vector-ref e-19 1))) (let ((e-3 (vector-ref e-19 2))) (let ((e-6 (vector-ref e-19 3))) (vector 1 (vector 2 e-2 e-3 e-6 e-20 e-5)))))) (else (let ((e-7 (vector-ref e-19 1))) (let ((e-8 (vector-ref e-19 2))) (let ((e-9 (vector-ref e-19 3))) (let ((e-10 (vector-ref e-19 4))) (let ((e-11 (vector-ref e-19 5))) (vector 0 (LibrariesC-45DataC-45NameMap-branch4 e-7 e-8 e-9 e-10 e-11 e-20 e-5)))))))))))))))))))) (else (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (let ((e-27 (vector-ref arg-3 4))) (let ((e-28 (vector-ref arg-3 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-25))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeDelete (+ 1 e-4) arg-2 e-24))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-25 e-26 e-27 e-28)))) (else (let ((e-5 (vector-ref sc2 1))) (vector 0 (LibrariesC-45DataC-45NameMap-merge1 e-5 e-25 e-26 e-27 e-28))))))) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-27))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete (+ 1 e-4) arg-2 e-26))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-24 e-25 e-2 e-27 e-28)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45NameMap-merge2 e-24 e-25 e-5 e-27 e-28))))))) (else (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete (+ 1 e-4) arg-2 e-28))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-24 e-25 e-26 e-27 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45NameMap-merge3 e-24 e-25 e-26 e-27 e-5)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45NameMap-toList (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45NameMap-treeToList e-3)))))
(define LibrariesC-45DataC-45NameMap-singleton (lambda (arg-1 arg-2) (cons 0 (vector 0 arg-1 arg-2))))
(define LibrariesC-45DataC-45NameMap-mergeWith (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45NameMap-insertFrom (LibrariesC-45DataC-45NameMap-n--5718-7677-u--inserted arg-3 arg-2 arg-1) arg-2)))
(define LibrariesC-45DataC-45NameMap-merge3 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-4 0) ((1) (let ((e-14 (vector-ref arg-4 1))) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (LibrariesC-45DataC-45NameMap-branch5 e-2 e-3 e-4 arg-3 e-14 e-15 e-16 arg-5 arg-6))))) (else (let ((e-19 (vector-ref arg-4 1))) (let ((e-20 (vector-ref arg-4 2))) (let ((e-21 (vector-ref arg-4 3))) (let ((e-22 (vector-ref arg-4 4))) (let ((e-23 (vector-ref arg-4 5))) (LibrariesC-45DataC-45NameMap-branch6 e-2 e-3 e-4 arg-3 e-19 e-20 e-21 e-22 e-23 arg-5 arg-6)))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((e-11 (vector-ref arg-2 5))) (case (vector-ref arg-4 0) ((1) (let ((e-26 (vector-ref arg-4 1))) (let ((e-27 (vector-ref arg-4 2))) (let ((e-28 (vector-ref arg-4 3))) (LibrariesC-45DataC-45NameMap-branch6 e-7 e-8 e-9 e-10 e-11 arg-3 e-26 e-27 e-28 arg-5 arg-6))))) (else (let ((e-31 (vector-ref arg-4 1))) (let ((e-32 (vector-ref arg-4 2))) (let ((e-33 (vector-ref arg-4 3))) (let ((e-34 (vector-ref arg-4 4))) (let ((e-35 (vector-ref arg-4 5))) (LibrariesC-45DataC-45NameMap-branch7 e-7 e-8 e-9 e-10 e-11 arg-3 e-31 e-32 e-33 e-34 e-35 arg-5 arg-6)))))))))))))))))
(define LibrariesC-45DataC-45NameMap-merge2 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-6 0) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (let ((e-16 (vector-ref arg-6 3))) (LibrariesC-45DataC-45NameMap-branch5 e-2 e-3 e-4 arg-3 arg-4 arg-5 e-14 e-15 e-16))))) (else (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (let ((e-22 (vector-ref arg-6 4))) (let ((e-23 (vector-ref arg-6 5))) (LibrariesC-45DataC-45NameMap-branch6 e-2 e-3 e-4 arg-3 arg-4 arg-5 e-19 e-20 e-21 e-22 e-23)))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((e-11 (vector-ref arg-2 5))) (case (vector-ref arg-6 0) ((1) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (LibrariesC-45DataC-45NameMap-branch6 e-7 e-8 e-9 e-10 e-11 arg-3 arg-4 arg-5 e-26 e-27 e-28))))) (else (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (let ((e-35 (vector-ref arg-6 5))) (LibrariesC-45DataC-45NameMap-branch7 e-7 e-8 e-9 e-10 e-11 arg-3 arg-4 arg-5 e-31 e-32 e-33 e-34 e-35)))))))))))))))))
(define LibrariesC-45DataC-45NameMap-merge1 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-4 0) ((1) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (case (vector-ref arg-6 0) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (let ((e-16 (vector-ref arg-6 3))) (LibrariesC-45DataC-45NameMap-branch5 arg-2 arg-3 e-2 e-3 e-4 arg-5 e-14 e-15 e-16))))) (else (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (let ((e-22 (vector-ref arg-6 4))) (let ((e-23 (vector-ref arg-6 5))) (LibrariesC-45DataC-45NameMap-branch6 arg-2 arg-3 e-2 e-3 e-4 arg-5 e-19 e-20 e-21 e-22 e-23)))))))))))) (else (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (let ((e-10 (vector-ref arg-4 4))) (let ((e-11 (vector-ref arg-4 5))) (case (vector-ref arg-6 0) ((1) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (LibrariesC-45DataC-45NameMap-branch6 arg-2 arg-3 e-7 e-8 e-9 e-10 e-11 arg-5 e-26 e-27 e-28))))) (else (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (let ((e-35 (vector-ref arg-6 5))) (LibrariesC-45DataC-45NameMap-branch7 arg-2 arg-3 e-7 e-8 e-9 e-10 e-11 arg-5 e-31 e-32 e-33 e-34 e-35)))))))))))))))))
(define LibrariesC-45DataC-45NameMap-merge (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45NameMap-mergeWith (lambda (eta-0) (lambda (eta-1) ((arg-1 eta-0) eta-1))) ext-0 ext-1)))
(define LibrariesC-45DataC-45NameMap-mapMaybeM (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) '()))) (let ((e-3 (cdr arg-5))) (LibrariesC-45DataC-45NameMap-treeMapMaybeM arg-3 arg-4 e-3)))))
(define LibrariesC-45DataC-45NameMap-lookup (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45NameMap-treeLookup arg-1 e-3)))))
(define LibrariesC-45DataC-45NameMap-keys (lambda (ext-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (LibrariesC-45DataC-45NameMap-toList ext-0))))
(define LibrariesC-45DataC-45NameMap-insertFrom (lambda (ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (PreludeC-45Types-u--foldl_Foldable_List (csegen-239) eta-0 clam-0))) ext-0 ext-1)))
(define LibrariesC-45DataC-45NameMap-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons 0 (vector 0 arg-1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45NameMap-treeInsert arg-1 arg-2 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (cons e-2 e-4))) (else (let ((e-5 (vector-ref sc1 1))) (cons (+ 1 e-2) e-5))))))))))
(define LibrariesC-45DataC-45NameMap-fromList (lambda (arg-1) (PreludeC-45Types-u--foldl_Foldable_List (csegen-239) (LibrariesC-45DataC-45NameMap-empty) arg-1)))
(define LibrariesC-45DataC-45NameMap-filterBy (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45NameMap-treeFilterBy arg-1 e-3)))))
(define LibrariesC-45DataC-45NameMap-empty(blodwen-lazy (lambda () '())))
(define LibrariesC-45DataC-45NameMap-delete (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 0) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-1 e-3))) (case (vector-ref sc2 0) ((0) (let ((e-4 (vector-ref sc2 1))) (cons 0 e-4))) (else (let ((e-5 (vector-ref sc2 1))) (cond (else '())))))))(else (let ((e-4 (- e-2 1))) (let ((sc1 (LibrariesC-45DataC-45NameMap-treeDelete (+ 1 e-4) arg-1 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-5 (vector-ref sc1 1))) (cons (+ 1 e-4) e-5))) (else (let ((e-5 (vector-ref sc1 1))) (cons e-4 e-5)))))))))))))
(define LibrariesC-45DataC-45NameMap-branch7 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (vector 2 (vector 2 arg-2 arg-3 arg-4 arg-5 arg-6) arg-7 (vector 1 arg-8 arg-9 arg-10) arg-11 (vector 1 arg-12 arg-13 arg-14))))
(define LibrariesC-45DataC-45NameMap-branch6 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 2 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 1 arg-6 arg-7 arg-8) arg-9 (vector 1 arg-10 arg-11 arg-12))))
(define LibrariesC-45DataC-45NameMap-branch5 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (vector 1 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 2 arg-6 arg-7 arg-8 arg-9 arg-10))))
(define LibrariesC-45DataC-45NameMap-branch4 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (vector 1 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 1 arg-6 arg-7 arg-8))))
(define CoreC-45Name-with--nameEq-7025 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (cond (else (box 0))))) (else '()))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-7000 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) '()) (else (let ((e-3 (vector-ref arg-2 1))) (cond (else (box 0))))))))
(define CoreC-45Name-with--nameEq-6981 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((1) '()) (else (let ((e-3 (vector-ref arg-2 1))) (cond (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-7000 arg-4 arg-3 (DecidableC-45Equality-u--decEq_DecEq_Int arg-3 arg-4) arg-0))))))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6956 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) '()) (else (let ((e-3 (vector-ref arg-2 1))) (cond (else (box 0))))))))
(define CoreC-45Name-with--nameEq-6937 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((1) '()) (else (let ((e-3 (vector-ref arg-2 1))) (cond (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6956 arg-4 arg-3 (DecidableC-45Equality-u--decEq_DecEq_Int arg-3 arg-4) arg-0))))))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6917 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) '() (let ((e-2 (unbox arg-2))) (cond (else (box 0)))))))
(define CoreC-45Name-with--nameEq-6895 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((1) '()) (else (let ((e-3 (vector-ref arg-2 1))) (cond (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6917 arg-4 arg-3 (CoreC-45Name-nameEq arg-3 arg-4) arg-0))))))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6864 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) '() (let ((e-1 (unbox arg-2))) (cond (else (box 0)))))))
(define CoreC-45Name-with--nameEq-6853 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (cond (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6864 arg-4 arg-3 (CoreC-45Name-nameEq arg-3 arg-4) arg-0))))) (else '()))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6825 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (cond (else (box 0))))) (else '()))))
(define CoreC-45Name-with--nameEq-6814 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) '() (let ((e-1 (unbox arg-2))) (cond (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6825 arg-4 arg-3 (DecidableC-45Equality-u--decEq_DecEq_Int arg-3 arg-4) arg-0)))))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6789 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (cond (else (box 0))))) (else '()))))
(define CoreC-45Name-with--nameEq-6774 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (cond (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6789 arg-4 arg-3 (DecidableC-45Equality-u--decEq_DecEq_Int arg-3 arg-4) arg-0))))) (else '()))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6738 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) '() (let ((e-2 (unbox arg-2))) (cond (else (box 0)))))))
(define CoreC-45Name-with--nameEq-6727 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (cond (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-6738 arg-4 arg-3 (CoreC-45Name-nameEq arg-3 arg-4) arg-0))))) (else '()))))
(define CoreC-45Name-with--userNameEq-6687 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (box (PreludeC-45Basics-cong e-1)))) (else '()))))
(define CoreC-45Name-with--userNameEq-6662 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (box (PreludeC-45Basics-cong e-1)))) (else '()))))
(define CoreC-45Name-with--mkUserName-4988 (lambda (arg-0 arg-1) (if (null? arg-1) (vector 0 arg-0) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (cond ((equal? e-0 #\.) (vector 1 e-1))(else (vector 0 arg-0))))))))
(define CoreC-45Name-case--isUnsafeBuiltin-5349 (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-3 0) ((1) (let ((e-4 (vector-ref e-3 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (let ((sc3 (let ((sc4 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-2 (CoreC-45NameC-45Namespace-builtinNS)))) (cond ((equal? sc4 1) 1) (else (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-2 (CoreC-45NameC-45Namespace-emptyNS))))))) (cond ((equal? sc3 1) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) eta-0) (cons (DataC-45String-isPrefixOf "assert_" e-5) (cons (PreludeC-45Types-elem (csegen-17) e-5 (cons "prim__believe_me" (cons "believe_me" (cons "prim__crash" (cons "idris_crash" '()))))) '())))) (else 0)))))(else 0))))(else 0)))))))
(define CoreC-45Name-u--show_Show_UserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "." e-1))) (else "_"))))
(define CoreC-45Name-u--show_Show_RawUNUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Basic " e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Field " e-1))) (else "Underscore"))))
(define CoreC-45Name-u--show_Show_RawName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "NS " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_RawName e-1) ")"))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "UN (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_RawUNUserName e-2) ")")))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "MN (" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-3) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45Show-u--show_Show_Int e-4))))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "PV (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_RawName e-5) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45Show-u--show_Show_Int e-6))))))) ((4) (let ((e-7 (vector-ref arg-0 1))) (let ((e-8 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "DN " (PreludeC-45TypesC-45String-C-43C-43 e-7 (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_RawName e-8) ")"))))))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "Nested " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-245) e-9) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_RawName e-10) ")"))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "CaseBlock " (PreludeC-45TypesC-45String-C-43C-43 e-11 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_Int e-12))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "CaseBlock " (PreludeC-45TypesC-45String-C-43C-43 e-13 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_Int e-14))))))) (else (let ((e-15 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Resolved " (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define CoreC-45Name-u--show_Show_Name (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref e-1 0) ((1) (let ((e-16 (vector-ref e-1 1))) (case (vector-ref e-16 0) ((1) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (PreludeC-45TypesC-45String-C-43C-43 ".(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-1) ")"))))(else (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (PreludeC-45TypesC-45String-C-43C-43 "." (CoreC-45Name-u--show_Show_Name e-1)))))))(else (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (PreludeC-45TypesC-45String-C-43C-43 "." (CoreC-45Name-u--show_Show_Name e-1)))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CoreC-45Name-u--show_Show_UserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "{" (PreludeC-45TypesC-45String-C-43C-43 e-3 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-4) "}"))))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "{P:" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-6) "}"))))))) ((4) (let ((e-7 (vector-ref arg-0 1))) e-7)) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (let ((e-20 (car e-9))) (let ((e-21 (cdr e-9))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-20) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-21) (PreludeC-45TypesC-45String-C-43C-43 ":" (CoreC-45Name-u--show_Show_Name e-10)))))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "case block in " e-11))) ((7) (let ((e-13 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "with block in " e-13))) (else (let ((e-15 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "$resolved" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define CoreC-45Name-u--showPrec_Show_Name (lambda (arg-0 arg-1) (CoreC-45Name-u--show_Show_Name arg-1)))
(define CoreC-45Name-u--pretty_Pretty_UserName (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-0))) ((1) (let ((e-1 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ".") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-1)))) (else (csegen-248)))))
(define CoreC-45Name-u--pretty_Pretty_Name (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((1) (let ((e-16 (vector-ref e-1 1))) (case (vector-ref e-16 0) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (CoreC-45Name-u--pretty_Pretty_Name e-1))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (CoreC-45Name-u--pretty_Pretty_Name e-1))))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (CoreC-45Name-u--pretty_Pretty_Name e-1))))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (CoreC-45Name-u--pretty_Pretty_UserName e-2))) ((2) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int e-4)))))) ((3) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\P) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (CoreC-45Name-u--pretty_Pretty_Name e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int e-6)))))) ((4) (let ((e-7 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-7))) ((5) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (let ((e-20 (car e-9))) (let ((e-21 (cdr e-9))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int e-20) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int e-21)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (CoreC-45Name-u--pretty_Pretty_Name e-10))))))) ((6) (let ((e-11 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "case block in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-11)))) ((7) (let ((e-13 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with block in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-13)))) (else (let ((e-15 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "$resolved") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int e-15)))))))
(define CoreC-45Name-u--prettyPrec_Pretty_Name (lambda (arg-1 arg-2) (CoreC-45Name-u--pretty_Pretty_Name arg-2)))
(define CoreC-45Name-u--min_Ord_Name (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-u--C-60_Ord_Name arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45Name-u--max_Ord_Name (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-u--C-62_Ord_Name arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45Name-u--compare_Ord_UserName (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_String e-0 e-2)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-usernameTag arg-0) (CoreC-45Name-usernameTag arg-1)))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-3 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_String e-1 e-3)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-usernameTag arg-0) (CoreC-45Name-usernameTag arg-1)))))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-usernameTag arg-0) (CoreC-45Name-usernameTag arg-1)))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-usernameTag arg-0) (CoreC-45Name-usernameTag arg-1))))))
(define CoreC-45Name-u--compare_Ord_Name (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((0) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45Name-u--compare_Ord_Name e-1 e-17))) (cond ((equal? sc2 1) (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace e-0 e-16)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-18 (vector-ref arg-1 1))) (CoreC-45Name-u--compare_Ord_UserName e-2 e-18)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1)))))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((2) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-4 e-20))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--compare_Ord_String e-3 e-19)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((3) (let ((e-21 (vector-ref arg-1 1))) (let ((e-22 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-6 e-22))) (cond ((equal? sc2 1) (CoreC-45Name-u--compare_Ord_Name e-5 e-21)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((4) (let ((e-8 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((4) (let ((e-24 (vector-ref arg-1 2))) (CoreC-45Name-u--compare_Ord_Name e-8 e-24)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1)))))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((5) (let ((e-25 (vector-ref arg-1 1))) (let ((e-26 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45Name-u--compare_Ord_Name e-10 e-26))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) e-9 e-25)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((6) (let ((e-27 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-12 e-28))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--compare_Ord_String e-11 e-27)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((7) (let ((e-29 (vector-ref arg-1 1))) (let ((e-30 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-14 e-30))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--compare_Ord_String e-13 e-29)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((8) (let ((e-15 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-31 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int e-15 e-31)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))
(define CoreC-45Name-u--C-62_Ord_Name (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_Name arg-0 arg-1) 2)))
(define CoreC-45Name-u--C-62C-61_Ord_Name (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_Name arg-0 arg-1) 0)))
(define CoreC-45Name-u--C-61C-61_Eq_UserName (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-2)))(else 0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-3 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 e-3)))(else 0)))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0)))(else 0))))
(define CoreC-45Name-u--C-61C-61_Eq_Name (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((0) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-17))) (cond ((equal? sc2 1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-0 e-16)) (else 0))))))(else 0))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-18 (vector-ref arg-1 1))) (CoreC-45Name-u--C-61C-61_Eq_UserName e-2 e-18)))(else 0)))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((2) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-4 e-20))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-3 e-19)) (else 0))))))(else 0))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((3) (let ((e-21 (vector-ref arg-1 1))) (let ((e-22 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-21))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 e-22)) (else 0))))))(else 0))))) ((4) (let ((e-8 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((4) (let ((e-24 (vector-ref arg-1 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-24)))(else 0)))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((5) (let ((e-25 (vector-ref arg-1 1))) (let ((e-26 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) e-9 e-25))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-26)) (else 0))))))(else 0))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((6) (let ((e-27 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-12 e-28))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-11 e-27)) (else 0))))))(else 0))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((7) (let ((e-29 (vector-ref arg-1 1))) (let ((e-30 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-14 e-30))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-13 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-15 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-31 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-15 e-31)))(else 0))))(else 0))))
(define CoreC-45Name-u--C-60_Ord_Name (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_Name arg-0 arg-1) 0)))
(define CoreC-45Name-u--C-60C-61_Ord_UserName (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_UserName arg-0 arg-1) 2)))
(define CoreC-45Name-u--C-60C-61_Ord_Name (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_Name arg-0 arg-1) 2)))
(define CoreC-45Name-u--C-47C-61_Eq_Name (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Name-usernameTag (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 2) (else 3))))
(define CoreC-45Name-userNameRoot (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Name-userNameRoot e-1))) ((1) (let ((e-2 (vector-ref arg-0 1))) (box e-2))) ((4) (let ((e-4 (vector-ref arg-0 2))) (CoreC-45Name-userNameRoot e-4)))(else '()))))
(define CoreC-45Name-userNameEq (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (CoreC-45Name-with--userNameEq-6662 e-0 e-2 (DecidableC-45Equality-u--decEq_DecEq_String e-0 e-2))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-3 (vector-ref arg-1 1))) (CoreC-45Name-with--userNameEq-6687 e-1 e-3 (DecidableC-45Equality-u--decEq_DecEq_String e-1 e-3))))(else '())))) ((2) (case (vector-ref arg-1 0) ((2) (box 0))(else '())))(else '()))))
(define CoreC-45Name-splitNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((sc1 (CoreC-45Name-splitNS e-1))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons (CoreC-45NameC-45Namespace-C-60C-46C-62 e-0 e-2) e-3)))))))(else (cons (CoreC-45NameC-45Namespace-emptyNS) arg-0)))))
(define CoreC-45Name-namesEq (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (box 0) '()) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? arg-1) '() (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-nameEq e-2 e-6) (lambda (u--p) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-namesEq e-3 e-7) (lambda (u--ps) (box 0)))))))))))))
(define CoreC-45Name-nameTag (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 6) ((6) 7) ((7) 8) (else 9))))
(define CoreC-45Name-nameRoot (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Name-nameRoot e-1))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CoreC-45Name-displayUserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) e-3)) ((3) (let ((e-5 (vector-ref arg-0 1))) (CoreC-45Name-nameRoot e-5))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CoreC-45Name-nameRoot e-8))) ((5) (let ((e-10 (vector-ref arg-0 2))) (CoreC-45Name-nameRoot e-10))) ((6) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "$" (PreludeC-45Show-u--show_Show_String e-11)))) ((7) (let ((e-13 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "$" (PreludeC-45Show-u--show_Show_String e-13)))) (else (let ((e-15 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "$" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define CoreC-45Name-nameEq (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((0) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-6727 e-0 e-16 (CoreC-45NameC-45Namespace-u--decEq_DecEq_Namespace e-0 e-16) e-1 e-17))))(else '()))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (PreludeC-45Basics-cong eta-0)) (CoreC-45Name-userNameEq e-2 e-18))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((2) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-6774 e-3 e-19 (DecidableC-45Equality-u--decEq_DecEq_String e-3 e-19) e-4 e-20))))(else '()))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((3) (let ((e-21 (vector-ref arg-1 1))) (let ((e-22 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-6814 e-5 e-21 (CoreC-45Name-nameEq e-5 e-21) e-6 e-22))))(else '()))))) ((4) (let ((e-7 (vector-ref arg-0 1))) (let ((e-8 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((4) (let ((e-23 (vector-ref arg-1 1))) (let ((e-24 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-6853 e-7 e-23 (DecidableC-45Equality-u--decEq_DecEq_String e-7 e-23) e-8 e-24))))(else '()))))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((5) (let ((e-25 (vector-ref arg-1 1))) (let ((e-26 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-6895 e-9 e-25 (DecidableC-45Equality-u--decEq_DecEq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-255) (csegen-255)) e-9 e-25) e-10 e-26))))(else '()))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((6) (let ((e-27 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-6937 e-11 e-27 (DecidableC-45Equality-u--decEq_DecEq_String e-11 e-27) e-12 e-28))))(else '()))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((7) (let ((e-29 (vector-ref arg-1 1))) (let ((e-30 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-6981 e-13 e-29 (DecidableC-45Equality-u--decEq_DecEq_String e-13 e-29) e-14 e-30))))(else '()))))) ((8) (let ((e-15 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-31 (vector-ref arg-1 1))) (CoreC-45Name-with--nameEq-7025 e-15 e-31 (DecidableC-45Equality-u--decEq_DecEq_Int e-15 e-31))))(else '()))))(else '()))))
(define CoreC-45Name-mkUserName (lambda (arg-0) (cond ((equal? arg-0 "_") (vector 2 ))(else (CoreC-45Name-with--mkUserName-4988 arg-0 (DataC-45String-strM arg-0))))))
(define CoreC-45Name-mkNamespacedName (lambda (arg-0 arg-1) (if (null? arg-0) (vector 1 arg-1) (let ((e-2 (unbox arg-0))) (vector 0 e-2 (vector 1 arg-1))))))
(define CoreC-45Name-mbApplyNS (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (unbox arg-0))) (vector 0 e-2 arg-1)))))
(define CoreC-45Name-matches (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (CoreC-45NameC-45Namespace-isApproximationOf e-0 e-2)))(else 1))))(else 1))))
(define CoreC-45Name-isUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((3) 0) ((2) 0) ((0) (let ((e-5 (vector-ref arg-0 2))) (CoreC-45Name-isUserName e-5))) ((4) (let ((e-7 (vector-ref arg-0 2))) (CoreC-45Name-isUserName e-7)))(else 1))))
(define CoreC-45Name-isUnsafeBuiltin (lambda (arg-0) (CoreC-45Name-case--isUnsafeBuiltin-5349 arg-0 (CoreC-45Name-splitNS arg-0))))
(define CoreC-45Name-isUnderscoreName (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((2) 1)(else 0)))) ((2) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 "_") 1)(else 0))))(else 0))))
(define CoreC-45Name-isUN (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (box (cons (CoreC-45NameC-45Namespace-emptyNS) e-0)))) ((0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-4 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons (CoreC-45NameC-45Namespace-C-60C-46C-62 e-1 e-4) e-3)))) (CoreC-45Name-isUN e-2)))))(else '()))))
(define CoreC-45Name-isSourceName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Name-isSourceName e-1))) ((1) 1) ((2) 0) ((3) (let ((e-5 (vector-ref arg-0 1))) (CoreC-45Name-isSourceName e-5))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CoreC-45Name-isSourceName e-8))) ((5) (let ((e-10 (vector-ref arg-0 2))) (CoreC-45Name-isSourceName e-10))) ((6) 0) ((7) 0) (else 0))))
(define CoreC-45Name-isRF (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-2 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons (CoreC-45NameC-45Namespace-C-60C-46C-62 e-0 e-2) e-3)))) (CoreC-45Name-isRF e-1))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref e-2 0) ((1) (let ((e-3 (vector-ref e-2 1))) (box (cons (CoreC-45NameC-45Namespace-emptyNS) e-3))))(else '()))))(else '()))))
(define CoreC-45Name-isPatternVariable (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45UtilsC-45String-lowerFirst e-0))) ((1) 0) (else 1))))
(define CoreC-45Name-isBasic (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else '()))))
(define CoreC-45Name-dropNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) e-1))(else arg-0))))
(define CoreC-45Name-dropAllNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Name-dropAllNS e-1)))(else arg-0))))
(define CoreC-45Name-displayUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) e-1)) (else "_"))))
(define CoreC-45Name-displayName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((sc1 (CoreC-45Name-displayName e-1))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons (PreludeC-45Types-u--pure_Applicative_Maybe (PreludeC-45Types-maybe (lambda () e-0) (lambda () (lambda (arg-1) (CoreC-45NameC-45Namespace-C-60C-46C-62 e-0 arg-1))) e-2)) e-3))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (cons '() (CoreC-45Name-displayUserName e-2)))) ((2) (let ((e-3 (vector-ref arg-0 1))) (cons '() e-3))) ((3) (let ((e-5 (vector-ref arg-0 1))) (CoreC-45Name-displayName e-5))) ((4) (let ((e-7 (vector-ref arg-0 1))) (cons '() e-7))) ((5) (let ((e-10 (vector-ref arg-0 2))) (CoreC-45Name-displayName e-10))) ((6) (let ((e-11 (vector-ref arg-0 1))) (cons '() (PreludeC-45TypesC-45String-C-43C-43 "case block in " (PreludeC-45Show-u--show_Show_String e-11))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (cons '() (PreludeC-45TypesC-45String-C-43C-43 "with block in " (PreludeC-45Show-u--show_Show_String e-13))))) (else (let ((e-15 (vector-ref arg-0 1))) (cons '() (PreludeC-45TypesC-45String-C-43C-43 "$resolved" (PreludeC-45Show-u--show_Show_Int e-15))))))))
(define CoreC-45Name-asName (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((4) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (vector 4 e-0 (CoreC-45Name-asName arg-0 arg-1 e-1))))) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector 0 (CoreC-45NameC-45Namespace-replace arg-0 arg-1 e-2) e-3))))(else arg-2))))
(define CoreC-45NameC-45Namespace-with--decEq-4779 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (vector 1 (lambda (eta-0) (e-1 (CoreC-45NameC-45Namespace-mkNSInjective eta-0)))))) (else (let ((e-3 (vector-ref arg-2 1))) (vector 0 (PreludeC-45Basics-cong e-3)))))))
(define CoreC-45NameC-45Namespace-n--4045-4459-u--go (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons (cons e-2 e-3) (CoreC-45NameC-45Namespace-n--4045-4459-u--go arg-0 e-3)))))))
(define CoreC-45NameC-45Namespace-n--3973-4392-u--go (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-17) arg-0 (cons e-2 e-3)))) (cond ((equal? sc1 1) arg-1) (else (cons e-2 (CoreC-45NameC-45Namespace-n--3973-4392-u--go arg-0 arg-1 arg-2 e-3))))))))))
(define CoreC-45NameC-45Namespace-u--show_Show_Namespace (lambda (ext-0) (CoreC-45NameC-45Namespace-showNSWithSep "." ext-0)))
(define CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent (lambda (ext-0) (CoreC-45NameC-45Namespace-showNSWithSep "." (CoreC-45NameC-45Namespace-miAsNamespace ext-0))))
(define CoreC-45NameC-45Namespace-u--showPrec_Show_Namespace (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-u--show_Show_Namespace arg-1)))
(define CoreC-45NameC-45Namespace-u--showPrec_Show_ModuleIdent (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1)))
(define CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace (lambda (arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-256) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (PreludeC-45TypesC-45List-reverse arg-1)))))
(define CoreC-45NameC-45Namespace-u--pretty_Pretty_ModuleIdent (lambda (ext-0) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace (CoreC-45NameC-45Namespace-miAsNamespace ext-0))))
(define CoreC-45NameC-45Namespace-u--prettyPrec_Pretty_Namespace (lambda (arg-1 arg-2) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace arg-2)))
(define CoreC-45NameC-45Namespace-u--prettyPrec_Pretty_ModuleIdent (lambda (arg-1 arg-2) (CoreC-45NameC-45Namespace-u--pretty_Pretty_ModuleIdent arg-2)))
(define CoreC-45NameC-45Namespace-u--min_Ord_Namespace (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-60_Ord_Namespace arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45NameC-45Namespace-u--min_Ord_ModuleIdent (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-60_Ord_ModuleIdent arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45NameC-45Namespace-u--max_Ord_Namespace (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-62_Ord_Namespace arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45NameC-45Namespace-u--max_Ord_ModuleIdent (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-62_Ord_ModuleIdent arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45NameC-45Namespace-u--decEq_DecEq_Namespace (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-with--decEq-4779 arg-0 arg-1 (DecidableC-45Equality-u--decEq_DecEq_C-40ListC-32C-36aC-41 (lambda (eta-0) (lambda (eta-1) (DecidableC-45Equality-u--decEq_DecEq_String eta-0 eta-1))) arg-0 arg-1))))
(define CoreC-45NameC-45Namespace-u--compare_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-261) arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-261) arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-u--C-62_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-0 arg-1) 2)))
(define CoreC-45NameC-45Namespace-u--C-62_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-0 arg-1) 2)))
(define CoreC-45NameC-45Namespace-u--C-62C-61_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-0 arg-1) 0)))
(define CoreC-45NameC-45Namespace-u--C-62C-61_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-0 arg-1) 0)))
(define CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (lambda (arg-0 arg-1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-17) arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-17) arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-u--C-60_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-0 arg-1) 0)))
(define CoreC-45NameC-45Namespace-u--C-60_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-0 arg-1) 0)))
(define CoreC-45NameC-45Namespace-u--C-60C-61_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-0 arg-1) 2)))
(define CoreC-45NameC-45Namespace-u--C-60C-61_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-0 arg-1) 2)))
(define CoreC-45NameC-45Namespace-u--C-47C-61_Eq_Namespace (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45NameC-45Namespace-u--C-47C-61_Eq_ModuleIdent (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45NameC-45Namespace-unsafeUnfoldNamespace (lambda (arg-0) arg-0))
(define CoreC-45NameC-45Namespace-unsafeUnfoldModuleIdent (lambda (arg-0) arg-0))
(define CoreC-45NameC-45Namespace-unsafeFoldNamespace (lambda (ext-0) ext-0))
(define CoreC-45NameC-45Namespace-unsafeFoldModuleIdent (lambda (ext-0) ext-0))
(define CoreC-45NameC-45Namespace-typesNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Prelude.Types"))))
(define CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath (lambda (ext-0) (LibrariesC-45UtilsC-45Path-joinPath (PreludeC-45TypesC-45List-reverse (CoreC-45NameC-45Namespace-unsafeUnfoldModuleIdent ext-0)))))
(define CoreC-45NameC-45Namespace-showSep (lambda (arg-0 arg-1) (if (null? arg-1) "" (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) e-2 (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 arg-0 (CoreC-45NameC-45Namespace-showSep arg-0 e-3)))))))))
(define CoreC-45NameC-45Namespace-showNSWithSep (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-showSep arg-0 (PreludeC-45TypesC-45List-reverse arg-1))))
(define CoreC-45NameC-45Namespace-replace (lambda (arg-0 arg-1 arg-2) (CoreC-45NameC-45Namespace-n--3973-4392-u--go arg-0 arg-1 arg-2 arg-2)))
(define CoreC-45NameC-45Namespace-reflectionTTNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Language.Reflection.TT"))))
(define CoreC-45NameC-45Namespace-reflectionTTImpNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Language.Reflection.TTImp"))))
(define CoreC-45NameC-45Namespace-reflectionNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Language.Reflection"))))
(define CoreC-45NameC-45Namespace-primIONS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "PrimIO"))))
(define CoreC-45NameC-45Namespace-preludeNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Prelude"))))
(define CoreC-45NameC-45Namespace-partialEvalNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "_PE"))))
(define CoreC-45NameC-45Namespace-numNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Prelude.Num"))))
(define CoreC-45NameC-45Namespace-nsAsModuleIdent (lambda (arg-0) arg-0))
(define CoreC-45NameC-45Namespace-mkNestedNamespace (lambda (arg-0 arg-1) (if (null? arg-0) (cons arg-1 '()) (let ((e-2 (unbox arg-0))) (cons arg-1 e-2)))))
(define CoreC-45NameC-45Namespace-mkNamespacedIdent (lambda (arg-0) (let ((u--nns (DataC-45List1-reverse (DataC-45String-split (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\.)) arg-0)))) (let ((u--name (let ((e-1 (car u--nns))) e-1))) (let ((u--ns (let ((e-2 (cdr u--nns))) e-2))) (if (null? u--ns) (cons '() u--name) (cons (box u--ns) u--name)))))))
(define CoreC-45NameC-45Namespace-mkNamespace (lambda (arg-0) (cond ((equal? arg-0 "") '())(else (PreludeC-45Basics-uncurry (csegen-269) (CoreC-45NameC-45Namespace-mkNamespacedIdent arg-0))))))
(define CoreC-45NameC-45Namespace-mkNSInjective (lambda (arg-2) (cond (else 0))))
(define CoreC-45NameC-45Namespace-miAsNamespace (lambda (arg-0) arg-0))
(define CoreC-45NameC-45Namespace-mainNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Main"))))
(define CoreC-45NameC-45Namespace-isParentOf (lambda (arg-0 arg-1) (DataC-45List-isSuffixOf (csegen-17) arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-isInPathOf (lambda (arg-0 arg-1) (PreludeC-45Types-elem (csegen-17) arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-isApproximationOf (lambda (arg-0 arg-1) (DataC-45List-isPrefixOf (csegen-17) arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-ioNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Prelude.IO"))))
(define CoreC-45NameC-45Namespace-eqOrdNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Prelude.EqOrd"))))
(define CoreC-45NameC-45Namespace-emptyNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace ""))))
(define CoreC-45NameC-45Namespace-dpairNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Builtin.DPair"))))
(define CoreC-45NameC-45Namespace-builtinNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Builtin"))))
(define CoreC-45NameC-45Namespace-basicsNS(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-mkNamespace "Prelude.Basics"))))
(define CoreC-45NameC-45Namespace-allParents (lambda (arg-0) (CoreC-45NameC-45Namespace-n--4045-4459-u--go arg-0 arg-0)))
(define CoreC-45NameC-45Namespace-C-60C-46C-62 (lambda (arg-0 arg-1) (PreludeC-45TypesC-45List-tailRecAppend arg-1 arg-0)))
(define LibrariesC-45UtilsC-45Path-case--C-60C-46C-62-4137 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-1 (let ((e-1 (unbox arg-5))) (let ((sc1 (LibrariesC-45UtilsC-45Path-splitFileName e-1))) (let ((e-2 (car sc1))) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (LibrariesC-45UtilsC-45Path-setFileNameC-39 (PreludeC-45TypesC-45String-C-43C-43 e-2 arg-4) arg-2))))))))
(define LibrariesC-45UtilsC-45Path-case--caseC-32blockC-32inC-32dropBase-3924 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (let ((sc0 (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-281) arg-5 e-0))) (cond ((equal? sc1 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool arg-4 e-1)) (else 0))))) (cond ((equal? sc0 1) (box 0)) (else '()))) (lambda () (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Path-n--5628-3864-u--dropBody arg-0 arg-1 arg-3 e-2) (lambda (u--body) (PreludeC-45Types-u--pure_Applicative_Maybe (LibrariesC-45UtilsC-45Path-u--show_Show_Path (vector '() 0 u--body e-3)))))))))))))
(define LibrariesC-45UtilsC-45Path-case--splitFileName-3639 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (cons arg-0 "") (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cond ((equal? e-6 #\.) (if (null? e-7) (cons arg-0 "") (cons (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-7)) (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-2)))))(else (cons (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-7)) (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-2))))))))))))
(define LibrariesC-45UtilsC-45Path-case--splitParentC-39-3520 (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((u--parent (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (vector e-0 e-1 (DataC-45List-init (cons e-2 e-3)) 0))))) (let ((u--child (vector '() 0 (cons (DataC-45List-last (cons e-2 e-3)) '()) (let ((e-4 (vector-ref arg-0 3))) e-4)))) (box (cons u--parent u--child)))))))))
(define LibrariesC-45UtilsC-45Path-n--5173-3428-u--splitRoot (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (if (null? e-0) (cond ((equal? e-1 0) (cons '() arg-1))(else (cons (box (vector e-0 e-1 '() 0)) (vector '() 0 e-2 e-3)))) (cons (box (vector e-0 e-1 '() 0)) (vector '() 0 e-2 e-3)))))))))
(define LibrariesC-45UtilsC-45Path-n--5173-3429-u--iterateBody (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (cons (vector '() 0 (cons e-2 '()) arg-2) '()) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (vector '() 0 (cons e-2 '()) 0) (LibrariesC-45UtilsC-45Path-n--5173-3429-u--iterateBody arg-0 (cons e-6 e-7) arg-2))))))))))
(define LibrariesC-45UtilsC-45Path-n--5346-3591-u--findNormal (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (case (vector-ref e-1 0) ((2) (let ((e-3 (vector-ref e-1 1))) (box e-3))) ((0) (LibrariesC-45UtilsC-45Path-n--5346-3591-u--findNormal arg-0 e-2))(else '())))))))
(define LibrariesC-45UtilsC-45Path-n--5828-4033-u--filter (lambda (arg-0 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (unbox arg-3))) (DataC-45Maybe-toMaybe (arg-2 e-2) (lambda () e-2))))))
(define LibrariesC-45UtilsC-45Path-n--5628-3864-u--dropBody (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) (box arg-3) (if (null? arg-3) '() (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (let ((sc4 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Body e-1 e-4))) (cond ((equal? sc4 1) (LibrariesC-45UtilsC-45Path-n--5628-3864-u--dropBody arg-0 arg-1 e-2 e-5)) (else '())))))))))))
(define LibrariesC-45UtilsC-45Path-u--tokValue_TokenKind_PathTokenKind (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 0)))
(define LibrariesC-45UtilsC-45Path-u--show_Show_Volume (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "\\\\" (PreludeC-45TypesC-45String-C-43C-43 e-0 (PreludeC-45TypesC-45String-C-43C-43 "\\" e-1)))))) (else (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 (DataC-45String-singleton e-2) ":"))))))
(define LibrariesC-45UtilsC-45Path-u--show_Show_Path (lambda (arg-0) (let ((u--sep (DataC-45String-singleton (LibrariesC-45UtilsC-45Path-dirSeparator)))) (let ((u--showVol (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Volume eta-0))) (let ((e-0 (vector-ref arg-0 0))) e-0)))) (let ((u--showRoot (let ((sc0 (let ((e-1 (vector-ref arg-0 1))) e-1))) (cond ((equal? sc0 1) u--sep) (else ""))))) (let ((u--showBody (LibrariesC-45DataC-45StringC-45Extra-join u--sep (csegen-51) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Body eta-0)) (let ((e-2 (vector-ref arg-0 2))) e-2))))) (let ((u--showTrail (let ((sc0 (let ((e-3 (vector-ref arg-0 3))) e-3))) (cond ((equal? sc0 1) u--sep) (else ""))))) (PreludeC-45TypesC-45String-C-43C-43 u--showVol (PreludeC-45TypesC-45String-C-43C-43 u--showRoot (PreludeC-45TypesC-45String-C-43C-43 u--showBody u--showTrail))))))))))
(define LibrariesC-45UtilsC-45Path-u--show_Show_Body (lambda (arg-0) (case (vector-ref arg-0 0) ((0) ".") ((1) "..") (else (let ((e-0 (vector-ref arg-0 1))) e-0)))))
(define LibrariesC-45UtilsC-45Path-u--TokType_TokenKind_PathTokenKind (lambda (arg-0) (if (null? arg-0) (vector "String" ) (vector "Builtin.Unit" ))))
(define LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Volume (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-3))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-3 e-4)) (else 0))))))(else 0)))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-5 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-2 e-5)))(else 0))))(else 0))))
(define LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_PathTokenKind (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) 1 0) (let ((e-0 (unbox arg-0))) (if (null? arg-1) 0 (let ((e-1 (unbox arg-1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 e-1)))))))
(define LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Path (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-1 0))) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-281) e-0 e-4))) (cond ((equal? sc0 1) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool e-1 e-5))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-284) e-2 e-6)) (else 0)))) (else 0)))))))))))
(define LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Body (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (case (vector-ref arg-1 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-1)))(else 0))))(else 0))))
(define LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Volume (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Volume arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_PathTokenKind (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_PathTokenKind arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Body (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Body arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define LibrariesC-45UtilsC-45Path-verbatimUnc(blodwen-lazy (lambda () (vector 11 1 (LibrariesC-45UtilsC-45Path-verbatim) (lambda () (csegen-288))))))
(define LibrariesC-45UtilsC-45Path-verbatimDisk(blodwen-lazy (lambda () (vector 11 1 (LibrariesC-45UtilsC-45Path-verbatim) (lambda () (vector 9 0 (LibrariesC-45UtilsC-45Path-disk) (lambda () (lambda (u--disk) (vector 0 u--disk)))))))))
(define LibrariesC-45UtilsC-45Path-verbatim(blodwen-lazy (lambda () (let ((sc0 (csegen-300))) (cond ((equal? sc0 0) (vector 12 0 1 (csegen-304) (lambda () (csegen-307)))) (else (vector 11 1 (csegen-304) (lambda () (csegen-307)))))))))
(define LibrariesC-45UtilsC-45Path-unc(blodwen-lazy (lambda () (let ((sc0 (csegen-300))) (cond ((equal? sc0 0) (vector 12 0 1 (csegen-304) (lambda () (csegen-288)))) (else (vector 11 1 (csegen-304) (lambda () (csegen-288)))))))))
(define LibrariesC-45UtilsC-45Path-splitPathC-39 (lambda (arg-0) (let ((sc0 (LibrariesC-45UtilsC-45Path-n--5173-3428-u--splitRoot arg-0 arg-0))) (let ((e-2 (car sc0))) (if (null? e-2) (LibrariesC-45UtilsC-45Path-n--5173-3429-u--iterateBody arg-0 (let ((e-5 (vector-ref arg-0 2))) e-5) (let ((e-4 (vector-ref arg-0 3))) e-4)) (let ((e-5 (unbox e-2))) (cons e-5 (LibrariesC-45UtilsC-45Path-n--5173-3429-u--iterateBody arg-0 (let ((e-6 (vector-ref arg-0 2))) e-6) (let ((e-4 (vector-ref arg-0 3))) e-4)))))))))
(define LibrariesC-45UtilsC-45Path-splitPath (lambda (ext-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Path eta-0)) (LibrariesC-45UtilsC-45Path-splitPathC-39 (LibrariesC-45UtilsC-45Path-parse ext-0)))))
(define LibrariesC-45UtilsC-45Path-splitParentC-39 (lambda (arg-0) (LibrariesC-45UtilsC-45Path-case--splitParentC-39-3520 arg-0 (let ((e-2 (vector-ref arg-0 2))) e-2))))
(define LibrariesC-45UtilsC-45Path-splitParent (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Path-splitParentC-39 (LibrariesC-45UtilsC-45Path-parse arg-0)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (LibrariesC-45UtilsC-45Path-u--show_Show_Path e-2) (LibrariesC-45UtilsC-45Path-u--show_Show_Path e-3)))))))))
(define LibrariesC-45UtilsC-45Path-splitFileName (lambda (arg-0) (LibrariesC-45UtilsC-45Path-case--splitFileName-3639 arg-0 (DataC-45List-break (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\.)) (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-fastUnpack arg-0))))))
(define LibrariesC-45UtilsC-45Path-setFileNameC-39 (lambda (arg-0 arg-1) (let ((sc0 (DataC-45Maybe-isJust (LibrariesC-45UtilsC-45Path-fileNameC-39 arg-1)))) (cond ((equal? sc0 1) (LibrariesC-45UtilsC-45Path-appendC-39 (DataC-45Maybe-fromMaybe (lambda () (LibrariesC-45UtilsC-45Path-emptyPath)) (LibrariesC-45UtilsC-45Path-parentC-39 arg-1)) (LibrariesC-45UtilsC-45Path-parse arg-0))) (else (LibrariesC-45UtilsC-45Path-appendC-39 arg-1 (LibrariesC-45UtilsC-45Path-parse arg-0)))))))
(define LibrariesC-45UtilsC-45Path-pathTokenMap(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-toTokenMap (cons (cons (LibrariesC-45TextC-45Lexer-is #\/) (box #\/)) (cons (cons (LibrariesC-45TextC-45Lexer-is #\\) (box #\\)) (cons (cons (LibrariesC-45TextC-45Lexer-is #\:) (box #\:)) (cons (cons (LibrariesC-45TextC-45Lexer-is #\?) (box #\?)) (cons (cons (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45Lexer-non (LibrariesC-45TextC-45Lexer-oneOf "/\\:?"))) '()) '())))))))))
(define LibrariesC-45UtilsC-45Path-pathSeparator(blodwen-lazy (lambda () (let ((sc0 (SystemC-45Info-isWindows))) (cond ((equal? sc0 1) #\;) (else #\:))))))
(define LibrariesC-45UtilsC-45Path-pathLookup (lambda (arg-0 ext-0) (let ((act-24 ((IdrisC-45Env-idrisGetEnv (csegen-3) "PATH" 0) ext-0))) (let ((u--extensions (let ((sc0 (SystemC-45Info-isWindows))) (cond ((equal? sc0 1) (cons ".exe" (cons ".cmd" (cons ".bat" (cons "" '()))))) (else (cons "" '())))))) (let ((u--pathList (DataC-45List1-forget (DataC-45String-split (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 (LibrariesC-45UtilsC-45Path-pathSeparator))) (DataC-45Maybe-fromMaybe (lambda () "/usr/bin:/usr/local/bin") act-24))))) (let ((u--candidates (PreludeC-45Types-u--C-62C-62C-61_Monad_List u--pathList (lambda (u--p) (PreludeC-45Types-u--C-62C-62C-61_Monad_List arg-0 (lambda (u--x) (PreludeC-45Types-u--C-62C-62C-61_Monad_List u--extensions (lambda (u--y) (PreludeC-45Types-u--pure_Applicative_List (PreludeC-45TypesC-45String-C-43C-43 u--p (PreludeC-45TypesC-45String-C-43C-43 "/" (PreludeC-45TypesC-45String-C-43C-43 u--x u--y)))))))))))) ((SystemC-45FileC-45Meta-firstExists (csegen-3) u--candidates) ext-0)))))))
(define LibrariesC-45UtilsC-45Path-parseVolume(blodwen-lazy (lambda () (vector 13 1 1 (LibrariesC-45UtilsC-45Path-verbatimUnc) (lambda () (vector 13 1 1 (LibrariesC-45UtilsC-45Path-verbatimDisk) (lambda () (vector 13 1 1 (LibrariesC-45UtilsC-45Path-unc) (lambda () (LibrariesC-45UtilsC-45Path-disk))))))))))
(define LibrariesC-45UtilsC-45Path-parsePath(blodwen-lazy (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (LibrariesC-45UtilsC-45Path-parseVolume)) (lambda (u--vol) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (LibrariesC-45TextC-45Parser-some (LibrariesC-45UtilsC-45Path-bodySeparator))) (lambda (u--root) (vector 10 0 0 (LibrariesC-45TextC-45Parser-sepBy 1 (LibrariesC-45TextC-45Parser-some (LibrariesC-45UtilsC-45Path-bodySeparator)) (LibrariesC-45UtilsC-45Path-parseBody)) (lambda (u--body) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (LibrariesC-45TextC-45Parser-some (LibrariesC-45UtilsC-45Path-bodySeparator))) (lambda (u--trailSep) (let ((body-0 (DataC-45List-filter (lambda (lcase-0) (case (vector-ref lcase-0 0) ((2) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45EqOrd-u--C-47C-61_Eq_String (DataC-45String-ltrim e-0) "")))(else 1))) u--body))) (let ((body-1 (if (null? body-0) '() (let ((e-2 (car body-0))) (let ((e-3 (cdr body-0))) (cons e-2 (DataC-45List-delete (csegen-284) (vector 0 ) e-3))))))) (vector 0 (vector u--vol (DataC-45Maybe-isJust u--root) body-1 (DataC-45Maybe-isJust u--trailSep))))))))))))))))
(define LibrariesC-45UtilsC-45Path-parseBody(blodwen-lazy (lambda () (vector 9 0 (csegen-289) (lambda () (lambda (u--text) (cond ((equal? u--text "..") (vector 0 (vector 1 ))) ((equal? u--text ".") (vector 0 (vector 0 )))(else (vector 0 (vector 2 u--text))))))))))
(define LibrariesC-45UtilsC-45Path-parse (lambda (arg-0) (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-parse 0 (LibrariesC-45UtilsC-45Path-parsePath) (LibrariesC-45UtilsC-45Path-lexPath arg-0)))) (case (vector-ref sc0 0) ((1) (let ((e-2 (vector-ref sc0 1))) (if (null? e-2) (LibrariesC-45UtilsC-45Path-emptyPath) (let ((e-6 (cdr e-2))) (if (null? e-6) (LibrariesC-45UtilsC-45Path-emptyPath) (let ((e-9 (car e-6))) e-9))))))(else (LibrariesC-45UtilsC-45Path-emptyPath))))))
(define LibrariesC-45UtilsC-45Path-parentC-39 (lambda (ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-fst eta-0)) (LibrariesC-45UtilsC-45Path-splitParentC-39 ext-0))))
(define LibrariesC-45UtilsC-45Path-parent (lambda (ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Path eta-0)) (LibrariesC-45UtilsC-45Path-parentC-39 (LibrariesC-45UtilsC-45Path-parse ext-0)))))
(define LibrariesC-45UtilsC-45Path-lexPath (lambda (arg-0) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Core-lex (LibrariesC-45UtilsC-45Path-pathTokenMap) arg-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-7 (cdr e-3))) e-2))))))
(define LibrariesC-45UtilsC-45Path-joinPath (lambda (arg-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (LibrariesC-45UtilsC-45Path-C-47C-62 eta-0 eta-1))) (LibrariesC-45UtilsC-45Path-parse "") arg-0))))
(define LibrariesC-45UtilsC-45Path-isRelative (lambda (ext-0) (let ((sc0 (LibrariesC-45UtilsC-45Path-isAbsolute ext-0))) (cond ((equal? sc0 1) 0) (else 1)))))
(define LibrariesC-45UtilsC-45Path-isAbsoluteC-39 (lambda (arg-0) (let ((sc0 (SystemC-45Info-isWindows))) (cond ((equal? sc0 1) (let ((e-0 (vector-ref arg-0 0))) (if (null? e-0) 0 (let ((e-4 (unbox e-0))) (case (vector-ref e-4 0) ((0) 1) (else (let ((e-8 (vector-ref arg-0 1))) e-8))))))) (else (let ((e-1 (vector-ref arg-0 1))) e-1))))))
(define LibrariesC-45UtilsC-45Path-isAbsolute (lambda (ext-0) (LibrariesC-45UtilsC-45Path-isAbsoluteC-39 (LibrariesC-45UtilsC-45Path-parse ext-0))))
(define LibrariesC-45UtilsC-45Path-fileNameC-39 (lambda (arg-0) (LibrariesC-45UtilsC-45Path-n--5346-3591-u--findNormal arg-0 (PreludeC-45TypesC-45List-reverse (let ((e-2 (vector-ref arg-0 2))) e-2)))))
(define LibrariesC-45UtilsC-45Path-fileName (lambda (ext-0) (LibrariesC-45UtilsC-45Path-fileNameC-39 (LibrariesC-45UtilsC-45Path-parse ext-0))))
(define LibrariesC-45UtilsC-45Path-extension (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Path-fileName arg-0) (lambda (eta-0) (LibrariesC-45UtilsC-45Path-n--5828-4033-u--filter arg-0 (lambda (arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-1 "")) (box (Builtin-snd (LibrariesC-45UtilsC-45Path-splitFileName eta-0))))))))
(define LibrariesC-45UtilsC-45Path-emptyPath(blodwen-lazy (lambda () (vector '() 0 '() 0))))
(define LibrariesC-45UtilsC-45Path-dropExtension (lambda (arg-0) (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-0 "")))
(define LibrariesC-45UtilsC-45Path-dropBase (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45UtilsC-45Path-parse arg-0))) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-2 (vector-ref sc0 2))) (let ((e-3 (vector-ref sc0 3))) (LibrariesC-45UtilsC-45Path-case--caseC-32blockC-32inC-32dropBase-3924 arg-1 arg-0 e-3 e-2 e-1 e-0 (LibrariesC-45UtilsC-45Path-parse arg-1)))))))))
(define LibrariesC-45UtilsC-45Path-disk(blodwen-lazy (lambda () (vector 9 1 (csegen-289) (lambda () (lambda (u--text) (vector 10 0 1 (let ((sc0 (PreludeC-45Types-fastUnpack u--text))) (if (null? sc0) (vector 4 '() 0 "Expects disk") (let ((e-1 (car sc0))) (vector 0 e-1)))) (lambda (u--disk) (vector 11 0 (LibrariesC-45TextC-45Parser-match (csegen-290) (box #\:)) (lambda () (vector 0 (vector 1 (PreludeC-45Types-toUpper u--disk)))))))))))))
(define LibrariesC-45UtilsC-45Path-dirSeparator(blodwen-lazy (lambda () (let ((sc0 (SystemC-45Info-isWindows))) (cond ((equal? sc0 1) #\\) (else #\/))))))
(define LibrariesC-45UtilsC-45Path-bodySeparator(blodwen-lazy (lambda () (vector 13 1 1 (csegen-306) (lambda () (LibrariesC-45TextC-45Parser-match (csegen-290) (box #\/)))))))
(define LibrariesC-45UtilsC-45Path-appendC-39 (lambda (arg-0 arg-1) (let ((sc0 (let ((sc1 (LibrariesC-45UtilsC-45Path-isAbsoluteC-39 arg-1))) (cond ((equal? sc1 1) 1) (else (DataC-45Maybe-isJust (let ((e-0 (vector-ref arg-1 0))) e-0))))))) (cond ((equal? sc0 1) arg-1) (else (let ((sc1 (let ((e-1 (vector-ref arg-1 1))) e-1))) (cond ((equal? sc1 1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector (let ((e-7 (vector-ref arg-0 0))) e-7) e-1 e-2 e-3))))) (else (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (vector e-0 e-1 (PreludeC-45TypesC-45List-tailRecAppend (let ((e-5 (vector-ref arg-0 2))) e-5) (let ((e-5 (vector-ref arg-1 2))) e-5)) (let ((e-4 (vector-ref arg-1 3))) e-4))))))))))))
(define LibrariesC-45UtilsC-45Path-C-60C-47C-62 (lambda (arg-0 arg-1) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (LibrariesC-45UtilsC-45Path-C-47C-62 (LibrariesC-45UtilsC-45Path-parse arg-0) arg-1))))
(define LibrariesC-45UtilsC-45Path-C-60C-46C-62 (lambda (arg-0 arg-1) (let ((u--pathC-39 (LibrariesC-45UtilsC-45Path-parse arg-0))) (let ((u--ext (PreludeC-45Types-fastPack (DataC-45List-dropWhile (lambda (u--char) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--char #\.))) (cond ((equal? sc0 1) 1) (else (PreludeC-45Types-isSpace u--char))))) (PreludeC-45Types-fastUnpack arg-1))))) (let ((ext-0 (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--ext ""))) (cond ((equal? sc0 1) "") (else (PreludeC-45TypesC-45String-C-43C-43 "." u--ext)))))) (LibrariesC-45UtilsC-45Path-case--C-60C-46C-62-4137 arg-1 arg-0 u--pathC-39 u--ext ext-0 (LibrariesC-45UtilsC-45Path-fileNameC-39 u--pathC-39)))))))
(define LibrariesC-45UtilsC-45Path-C-47C-62 (lambda (arg-0 arg-1) (LibrariesC-45UtilsC-45Path-appendC-39 arg-0 (LibrariesC-45UtilsC-45Path-parse arg-1))))
(define LibrariesC-45TextC-45Quantity-exactly (lambda (arg-0) (cons arg-0 (box arg-0))))
(define LibrariesC-45TextC-45Quantity-between (lambda (arg-0 arg-1) (cons arg-0 (box arg-1))))
(define LibrariesC-45TextC-45Quantity-atMost (lambda (arg-0) (cons 0 (box arg-0))))
(define LibrariesC-45TextC-45Quantity-atLeast (lambda (arg-0) (cons arg-0 '())))
(define LibrariesC-45TextC-45Parser-when (lambda (arg-2 arg-3) (cond ((equal? arg-2 1) (arg-3)) (else (vector 0 0)))))
(define LibrariesC-45TextC-45Parser-some (lambda (arg-3) (vector 9 0 arg-3 (lambda () (lambda (bind-0) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many arg-3) (lambda (bind-1) (vector 0 (cons bind-0 bind-1)))))))))
(define LibrariesC-45TextC-45Parser-sepBy1 (lambda (arg-4 arg-5 arg-6) (vector 10 arg-4 0 (vector 10 0 arg-4 (vector 0 (csegen-188)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 u--f arg-6))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-many (vector 10 1 arg-4 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) arg-5) (lambda (f-0) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 f-0 arg-6)))))))))
(define LibrariesC-45TextC-45Parser-sepBy (lambda (arg-4 arg-5 arg-6) (LibrariesC-45TextC-45Parser-option arg-4 '() (PreludeC-45Interfaces-C-60C-36C-62 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 eta-2 eta-3))))) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 arg-4 arg-5 arg-6)))))
(define LibrariesC-45TextC-45Parser-optional (lambda (arg-3 arg-4) (LibrariesC-45TextC-45Parser-option arg-3 '() (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-3 (lambda (eta-0) (box eta-0)) arg-4))))
(define LibrariesC-45TextC-45Parser-option (lambda (arg-3 arg-4 arg-5) (cond ((equal? arg-3 0) (vector 13 0 0 arg-5 (lambda () (vector 0 arg-4)))) (else (vector 13 1 0 arg-5 (lambda () (vector 0 arg-4)))))))
(define LibrariesC-45TextC-45Parser-match (lambda (arg-2 arg-3) (vector 1 "Unrecognised input" (lambda (u--t) (let ((sc0 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) ((e-1 (let ((e-4 (car u--t))) e-4)) arg-3))))) (cond ((equal? sc0 1) (box (let ((sc1 (Builtin-snd arg-2))) (let ((e-2 (cdr sc1))) ((e-2 arg-3) (let ((e-3 (cdr u--t))) e-3)))))) (else '())))))))
(define LibrariesC-45TextC-45Parser-many (lambda (arg-3) (LibrariesC-45TextC-45Parser-option 1 '() (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some arg-3)))))
(define LibrariesC-45TextC-45Parser-location(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-356) (lambda (eta-0) (LibrariesC-45TextC-45Bounded-startBounds eta-0)) (vector 15 )))))
(define LibrariesC-45TextC-45Parser-count1 (lambda (arg-3 arg-4) (vector 9 (let ((sc0 (DataC-45Nat-isSucc (let ((e-0 (car arg-3))) e-0)))) (cond ((equal? sc0 1) 1) (else 0))) arg-4 (lambda () (lambda (u--x) (vector 10 (DataC-45Nat-isSucc (let ((e-0 (car arg-3))) e-0)) 0 (LibrariesC-45TextC-45Parser-count arg-3 arg-4) (lambda (u--xs) (vector 0 (cons u--x u--xs)))))))))
(define LibrariesC-45TextC-45Parser-count (lambda (arg-3 arg-4) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-0 0) (if (null? e-1) (LibrariesC-45TextC-45Parser-many arg-4) (let ((e-5 (unbox e-1))) (cond ((equal? e-5 0) (vector 0 '()))(else (let ((e-6 (- e-5 1))) (LibrariesC-45TextC-45Parser-option 1 '() (LibrariesC-45TextC-45Parser-count1 (LibrariesC-45TextC-45Quantity-atMost e-6) arg-4))))))))(else (let ((e-2 (- e-0 1))) (if (null? e-1) (LibrariesC-45TextC-45Parser-count1 (LibrariesC-45TextC-45Quantity-atLeast e-2) arg-4) (let ((e-9 (unbox e-1))) (cond ((equal? e-9 0) (vector 4 '() 0 "Quantity out of order"))(else (let ((e-10 (- e-9 1))) (LibrariesC-45TextC-45Parser-count1 (LibrariesC-45TextC-45Quantity-between (+ 1 e-2) e-10) arg-4)))))))))))))
(define LibrariesC-45TextC-45Parser-column(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-356) (lambda (eta-0) (Builtin-snd eta-0)) (LibrariesC-45TextC-45Parser-location)))))
(define LibrariesC-45TextC-45Parser-choiceMap (lambda (arg-5 arg-6 arg-7 arg-8) (let ((e-1 (vector-ref arg-7 0))) (((((e-1 'erased) 'erased) (lambda (u--x) (lambda (u--acc) (vector 13 arg-5 arg-5 (arg-6 u--x) (lambda () u--acc))))) (vector 4 '() 0 "No more options")) arg-8))))
(define LibrariesC-45TextC-45Parser-choice (lambda (arg-4 arg-5 ext-0) (LibrariesC-45TextC-45Parser-choiceMap arg-5 (lambda (eta-0) eta-0) arg-4 ext-0)))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-3937 (lambda (arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-3 (vector-ref arg-11 1))) (let ((e-4 (vector-ref arg-11 2))) (let ((e-5 (vector-ref arg-11 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref arg-11 1))) (let ((e-10 (vector-ref arg-11 2))) (let ((e-11 (vector-ref arg-11 3))) (let ((e-12 (vector-ref arg-11 4))) (let ((e-13 (vector-ref arg-11 5))) (vector 1 e-9 e-10 e-11 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-360) (lambda (eta-0) e-12) e-12) e-13))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-3618 (lambda (arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-3 (vector-ref arg-13 1))) (let ((e-4 (vector-ref arg-13 2))) (let ((e-5 (vector-ref arg-13 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref arg-13 1))) (let ((e-10 (vector-ref arg-13 2))) (let ((e-11 (vector-ref arg-13 3))) (let ((e-12 (vector-ref arg-13 4))) (let ((e-13 (vector-ref arg-13 5))) (LibrariesC-45TextC-45ParserC-45Core-mergeWith e-12 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-3 e-9 e-10 e-11 ((arg-7) (let ((e-1 (vector-ref e-12 0))) e-1)) e-13)))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-3502 (lambda (arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14) (case (vector-ref arg-14 0) ((0) (let ((e-3 (vector-ref arg-14 1))) (let ((e-4 (vector-ref arg-14 2))) (let ((e-5 (vector-ref arg-14 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref arg-14 1))) (let ((e-10 (vector-ref arg-14 2))) (let ((e-11 (vector-ref arg-14 3))) (let ((e-12 (vector-ref arg-14 4))) (let ((e-13 (vector-ref arg-14 5))) (LibrariesC-45TextC-45ParserC-45Core-mergeWith e-12 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-3 e-9 e-10 e-11 (arg-8 (let ((e-1 (vector-ref e-12 0))) e-1)) e-13)))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32doParse-3258 (lambda (arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-16 0) ((0) (let ((e-3 (vector-ref arg-16 1))) (let ((e-4 (vector-ref arg-16 2))) (let ((e-5 (vector-ref arg-16 3))) (let ((sc1 (cond ((equal? e-3 1) 1) (else e-4)))) (cond ((equal? sc1 1) (vector 0 e-3 e-4 e-5)) (else (vector 0 0 0 (DataC-45List1-C-43C-43 arg-12 e-5))))))))) (else (let ((e-9 (vector-ref arg-16 1))) (let ((e-10 (vector-ref arg-16 2))) (let ((e-12 (vector-ref arg-16 4))) (let ((e-13 (vector-ref arg-16 5))) (vector 1 e-9 e-10 arg-9 e-12 e-13)))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-3140 (lambda (arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-3 (vector-ref arg-13 1))) (let ((e-4 (vector-ref arg-13 2))) (let ((e-5 (vector-ref arg-13 3))) (let ((sc1 (cond ((equal? e-3 1) 1) (else e-4)))) (cond ((equal? sc1 1) (vector 0 arg-10 e-4 e-5)) (else (LibrariesC-45TextC-45ParserC-45Core-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32doParse-3258 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5 e-4 e-3 arg-4 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-3 arg-4 arg-11 0 (arg-6) arg-9))))))))) (else (let ((e-9 (vector-ref arg-13 1))) (let ((e-10 (vector-ref arg-13 2))) (let ((e-12 (vector-ref arg-13 4))) (let ((e-13 (vector-ref arg-13 5))) (vector 1 e-9 e-10 arg-10 e-12 e-13)))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-2769 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-3 (vector-ref arg-10 1))) (let ((e-5 (vector-ref arg-10 3))) (vector 0 e-3 1 e-5))))(else arg-10))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-2670 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-3 (vector-ref arg-10 1))) (let ((e-5 (vector-ref arg-10 3))) (vector 0 e-3 0 e-5))))(else arg-10))))
(define LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 (lambda (arg-4 arg-5 arg-6) (cond ((equal? arg-4 0) (case (vector-ref arg-6 0) ((0) (let ((e-65 (vector-ref arg-6 1))) (vector 0 (arg-5 e-65))))(else (case (vector-ref arg-6 0) ((4) (let ((e-49 (vector-ref arg-6 1))) (let ((e-50 (vector-ref arg-6 2))) (let ((e-51 (vector-ref arg-6 3))) (vector 4 e-49 e-50 e-51))))) ((6) (let ((e-56 (vector-ref arg-6 1))) (vector 6 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 arg-5 e-56)))) ((8) (let ((e-61 (vector-ref arg-6 1))) (vector 8 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 arg-5 e-61))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((1) (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (vector 1 e-43 (lambda (eta-0) (PreludeC-45Types-u--map_Functor_Maybe arg-5 (e-44 eta-0)))))))(else (case (vector-ref arg-6 0) ((13) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (vector 13 e-36 e-37 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-36 arg-5 e-38) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-37 arg-5 (e-39)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((9) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 9 e-30 e-31 (lambda () (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-30 arg-5 ((e-32) u--val)))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))))))(else (case (vector-ref arg-6 0) ((13) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (vector 13 e-36 e-37 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-36 arg-5 e-38) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-37 arg-5 (e-39)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((9) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 9 e-30 e-31 (lambda () (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-30 arg-5 ((e-32) u--val)))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))))))))))(else (case (vector-ref arg-6 0) ((4) (let ((e-49 (vector-ref arg-6 1))) (let ((e-50 (vector-ref arg-6 2))) (let ((e-51 (vector-ref arg-6 3))) (vector 4 e-49 e-50 e-51))))) ((6) (let ((e-56 (vector-ref arg-6 1))) (vector 6 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 arg-5 e-56)))) ((8) (let ((e-61 (vector-ref arg-6 1))) (vector 8 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 arg-5 e-61))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((1) (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (vector 1 e-43 (lambda (eta-0) (PreludeC-45Types-u--map_Functor_Maybe arg-5 (e-44 eta-0)))))))(else (case (vector-ref arg-6 0) ((13) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (vector 13 e-36 e-37 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-36 arg-5 e-38) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-37 arg-5 (e-39)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((9) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 9 e-30 e-31 (lambda () (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-30 arg-5 ((e-32) u--val)))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))))))(else (case (vector-ref arg-6 0) ((13) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (vector 13 e-36 e-37 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-36 arg-5 e-38) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-37 arg-5 (e-39)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((9) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 9 e-30 e-31 (lambda () (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-30 arg-5 ((e-32) u--val)))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0))))))))))))))))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-parseWith (lambda (arg-3 arg-4 arg-5 arg-6) (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-doParse (let ((e-1 (car arg-3))) e-1) (let ((e-2 (cdr arg-3))) e-2) '() 0 arg-5 arg-6))) (case (vector-ref sc0 0) ((0) (let ((e-5 (vector-ref sc0 3))) (vector 0 e-5))) (else (let ((e-9 (vector-ref sc0 1))) (let ((e-10 (vector-ref sc0 2))) (let ((e-12 (vector-ref sc0 4))) (let ((e-13 (vector-ref sc0 5))) (vector 1 (cons e-9 (cons e-10 (cons (let ((e-1 (vector-ref e-12 0))) e-1) e-13)))))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-parse (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-doParse (csegen-363) (PreludeC-45Interfaces-u--neutral_Monoid_C-40C-124UnitC-44MkUnitC-124C-41) '() 0 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-5 (vector-ref sc0 3))) (vector 0 e-5))) (else (let ((e-10 (vector-ref sc0 2))) (let ((e-12 (vector-ref sc0 4))) (let ((e-13 (vector-ref sc0 5))) (vector 1 (cons e-10 (cons (let ((e-1 (vector-ref e-12 0))) e-1) e-13)))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause (lambda (arg-3 arg-4 arg-5 arg-6) (vector 13 arg-3 arg-3 arg-6 (lambda () (vector 4 (box arg-4) 1 arg-5)))))
(define LibrariesC-45TextC-45ParserC-45Core-mergeWith (lambda (arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (let ((e-6 (vector-ref arg-5 4))) (let ((e-7 (vector-ref arg-5 5))) (vector 1 e-3 e-4 e-5 (LibrariesC-45TextC-45Bounded-mergeBounds arg-4 e-6) e-7)))))))(else arg-5))))
(define LibrariesC-45TextC-45ParserC-45Core-doParse (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-8 0) ((0) (let ((e-3 (vector-ref arg-8 1))) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds e-3) arg-9))) ((5) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (vector 1 arg-5 (cons (cons e-6 e-7) arg-6) arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds 0) arg-9)))) ((4) (let ((e-12 (vector-ref arg-8 1))) (let ((e-13 (vector-ref arg-8 2))) (let ((e-14 (vector-ref arg-8 3))) (vector 0 arg-7 e-13 (cons (cons e-14 (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe e-12 (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (let ((e-3 (vector-ref eta-0 2))) e-3)) (DataC-45List-headC-39 arg-9))))) '())))))) ((6) (let ((e-19 (vector-ref arg-8 1))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-2670 arg-4 arg-5 e-19 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-19 arg-9)))) ((7) (vector 1 arg-5 arg-6 1 (LibrariesC-45TextC-45Bounded-irrelevantBounds 0) arg-9)) ((8) (let ((e-26 (vector-ref arg-8 1))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-2769 arg-4 arg-5 e-26 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-26 arg-9)))) ((1) (let ((e-30 (vector-ref arg-8 1))) (let ((e-31 (vector-ref arg-8 2))) (if (null? arg-9) (vector 0 arg-7 0 (csegen-365)) (let ((e-85 (car arg-9))) (let ((e-86 (cdr arg-9))) (let ((sc2 (e-31 (let ((e-1 (vector-ref e-85 0))) e-1)))) (if (null? sc2) (vector 0 arg-7 0 (cons (cons e-30 (box (let ((e-3 (vector-ref e-85 2))) e-3))) '())) (let ((e-2 (unbox sc2))) (vector 1 arg-5 arg-6 arg-7 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-360) (lambda (eta-0) e-2) e-85) e-86)))))))))) ((3) (if (null? arg-9) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds 0) '()) (let ((e-89 (car arg-9))) (vector 0 arg-7 0 (cons (cons "Expected end of input" (box (let ((e-3 (vector-ref e-89 2))) e-3))) '()))))) ((2) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (if (null? arg-9) (vector 0 arg-7 0 (csegen-365)) (let ((e-93 (car arg-9))) (let ((e-94 (cdr arg-9))) (let ((sc2 (e-37 (let ((e-1 (vector-ref e-93 0))) e-1)))) (cond ((equal? sc2 1) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-removeIrrelevance e-93) (cons e-93 e-94))) (else (vector 0 arg-7 0 (cons (cons e-36 (box (let ((e-3 (vector-ref e-93 2))) e-3))) '()))))))))))) ((13) (let ((e-41 (vector-ref arg-8 1))) (let ((e-42 (vector-ref arg-8 2))) (let ((e-43 (vector-ref arg-8 3))) (let ((e-44 (vector-ref arg-8 4))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-3140 arg-4 arg-5 e-42 e-44 e-41 e-43 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 0 e-43 arg-9))))))) ((10) (let ((e-49 (vector-ref arg-8 1))) (let ((e-50 (vector-ref arg-8 2))) (let ((e-51 (vector-ref arg-8 3))) (let ((e-52 (vector-ref arg-8 4))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-3502 arg-4 e-49 e-50 arg-5 e-52 e-51 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-51 arg-9))))))) ((9) (let ((e-57 (vector-ref arg-8 1))) (let ((e-58 (vector-ref arg-8 2))) (let ((e-59 (vector-ref arg-8 3))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-3618 arg-4 e-57 arg-5 e-59 e-58 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-58 arg-9)))))) ((12) (let ((e-65 (vector-ref arg-8 3))) (let ((e-66 (vector-ref arg-8 4))) (let ((sc1 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-65 arg-9))) (case (vector-ref sc1 0) ((0) (let ((e-3 (vector-ref sc1 1))) (let ((e-4 (vector-ref sc1 2))) (let ((e-5 (vector-ref sc1 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref sc1 1))) (let ((e-10 (vector-ref sc1 2))) (let ((e-11 (vector-ref sc1 3))) (let ((e-12 (vector-ref sc1 4))) (let ((e-13 (vector-ref sc1 5))) (LibrariesC-45TextC-45ParserC-45Core-mergeWith e-12 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 e-9 e-10 e-11 e-66 e-13))))))))))))) ((11) (let ((e-71 (vector-ref arg-8 2))) (let ((e-72 (vector-ref arg-8 3))) (let ((sc1 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-71 arg-9))) (case (vector-ref sc1 0) ((0) (let ((e-3 (vector-ref sc1 1))) (let ((e-4 (vector-ref sc1 2))) (let ((e-5 (vector-ref sc1 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref sc1 1))) (let ((e-10 (vector-ref sc1 2))) (let ((e-11 (vector-ref sc1 3))) (let ((e-12 (vector-ref sc1 4))) (let ((e-13 (vector-ref sc1 5))) (LibrariesC-45TextC-45ParserC-45Core-mergeWith e-12 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 e-9 e-10 e-11 (e-72) e-13))))))))))))) ((14) (let ((e-77 (vector-ref arg-8 1))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-3937 arg-4 arg-5 e-77 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-77 arg-9)))) ((15) (if (null? arg-9) (vector 0 arg-7 0 (csegen-365)) (let ((e-97 (car arg-9))) (let ((e-98 (cdr arg-9))) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds (let ((e-3 (vector-ref e-97 2))) e-3)) (cons e-97 e-98)))))) (else (let ((e-82 (vector-ref arg-8 1))) (vector 1 ((arg-4 arg-5) e-82) arg-6 arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds 0) arg-9))))))
(define LibrariesC-45TextC-45ParserC-45Core-C-60C-124C-124C-62 (lambda (arg-4 arg-5 arg-6 arg-7) (vector 13 arg-4 arg-5 (PreludeC-45Interfaces-C-60C-36C-62 (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 u--func arg-215))))) (lambda (eta-0) (vector 0 eta-0)) arg-6) (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-5 u--func arg-215))))) (lambda (eta-0) (vector 1 eta-0)) (arg-7))))))
(define LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (vector (arg-2 e-1) e-2 e-3))))))
(define LibrariesC-45TextC-45Bounded-startBounds (lambda (arg-0) (cons (let ((e-0 (vector-ref arg-0 0))) e-0) (let ((e-1 (vector-ref arg-0 1))) e-1))))
(define LibrariesC-45TextC-45Bounded-start (lambda (ext-0) (LibrariesC-45TextC-45Bounded-startBounds (let ((e-3 (vector-ref ext-0 2))) e-3))))
(define LibrariesC-45TextC-45Bounded-removeIrrelevance (lambda (arg-1) (let ((e-1 (vector-ref arg-1 0))) (let ((e-3 (vector-ref arg-1 2))) (vector e-1 1 e-3)))))
(define LibrariesC-45TextC-45Bounded-mergeBounds (lambda (arg-2 arg-3) (let ((e-6 (vector-ref arg-2 1))) (cond ((equal? e-6 1) (let ((e-9 (vector-ref arg-3 0))) (let ((e-10 (vector-ref arg-3 1))) (cond ((equal? e-10 1) (LibrariesC-45TextC-45Bounded-irrelevantBounds e-9))(else arg-3)))))(else (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (cond ((equal? e-2 1) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-366) (lambda (eta-0) e-1) arg-2))(else (let ((sc0 (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) (LibrariesC-45TextC-45Bounded-start arg-2) (LibrariesC-45TextC-45Bounded-start arg-3)))) (let ((e-8 (car sc0))) (let ((e-4 (cdr sc0))) (let ((sc1 (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) (LibrariesC-45TextC-45Bounded-end arg-2) (LibrariesC-45TextC-45Bounded-end arg-3)))) (let ((e-10 (car sc1))) (let ((e-9 (cdr sc1))) (vector (let ((e-13 (vector-ref arg-3 0))) e-13) 0 (vector e-8 e-4 e-10 e-9)))))))))))))))))
(define LibrariesC-45TextC-45Bounded-irrelevantBounds (lambda (arg-1) (vector arg-1 1 (vector -1 -1 -1 -1))))
(define LibrariesC-45TextC-45Bounded-endBounds (lambda (arg-0) (cons (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-3 (vector-ref arg-0 3))) e-3))))
(define LibrariesC-45TextC-45Bounded-end (lambda (ext-0) (LibrariesC-45TextC-45Bounded-endBounds (let ((e-3 (vector-ref ext-0 2))) e-3))))
(define LibrariesC-45TextC-45Lexer-n--3644-737-u--lexStr (lambda (arg-0) (if (null? arg-0) (LibrariesC-45TextC-45LexerC-45Core-fail) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-exact e-2) (LibrariesC-45TextC-45Lexer-n--3644-737-u--lexStr e-3)))))))
(define LibrariesC-45TextC-45Lexer-n--3644-738-u--control(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-n--3644-737-u--lexStr (cons "NUL" (cons "SOH" (cons "STX" (cons "ETX" (cons "EOT" (cons "ENQ" (cons "ACK" (cons "BEL" (cons "BS" (cons "HT" (cons "LF" (cons "VT" (cons "FF" (cons "CR" (cons "SO" (cons "SI" (cons "DLE" (cons "DC1" (cons "DC2" (cons "DC3" (cons "DC4" (cons "NAK" (cons "SYN" (cons "ETB" (cons "CAN" (cons "EM" (cons "SUB" (cons "ESC" (cons "FS" (cons "GS" (cons "RS" (cons "US" (cons "SP" (cons "DEL" '()))))))))))))))))))))))))))))))))))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (LibrariesC-45TextC-45Lexer-is #\x) (lambda () (LibrariesC-45TextC-45Lexer-hexDigits))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (LibrariesC-45TextC-45Lexer-is #\o) (lambda () (LibrariesC-45TextC-45Lexer-octDigits))) (LibrariesC-45TextC-45Lexer-digits)))))))
(define LibrariesC-45TextC-45Lexer-toTokenMap (lambda (ext-0) (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (lambda (eta-0) (cons e-3 eta-0)))))) ext-0)))
(define LibrariesC-45TextC-45Lexer-symbol(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--x) (let ((sc0 (let ((sc1 (PreludeC-45Types-isSpace u--x))) (cond ((equal? sc1 1) 1) (else (PreludeC-45Types-isAlphaNum u--x)))))) (cond ((equal? sc0 1) 0) (else 1))))))))
(define LibrariesC-45TextC-45Lexer-surround (lambda (arg-0 arg-1 arg-2) (vector 4 arg-0 (lambda () (LibrariesC-45TextC-45Lexer-manyThen arg-1 arg-2)))))
(define LibrariesC-45TextC-45Lexer-stringLit(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-quote (LibrariesC-45TextC-45Lexer-is #\") (csegen-413)))))
(define LibrariesC-45TextC-45Lexer-space(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isSpace eta-0))))))
(define LibrariesC-45TextC-45Lexer-someUntil (lambda (arg-1 arg-2) (LibrariesC-45TextC-45Lexer-some (vector 5 (LibrariesC-45TextC-45LexerC-45Core-reject arg-1) arg-2))))
(define LibrariesC-45TextC-45Lexer-some (lambda (arg-0) (vector 4 arg-0 (lambda () (LibrariesC-45TextC-45Lexer-many arg-0)))))
(define LibrariesC-45TextC-45Lexer-quote (lambda (arg-0 arg-1) (LibrariesC-45TextC-45Lexer-surround arg-0 arg-0 arg-1)))
(define LibrariesC-45TextC-45Lexer-opt (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 arg-0 (LibrariesC-45TextC-45LexerC-45Core-empty))))
(define LibrariesC-45TextC-45Lexer-oneOf (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--x) (PreludeC-45Types-elem (csegen-0) u--x (PreludeC-45Types-fastUnpack arg-0))))))
(define LibrariesC-45TextC-45Lexer-octUnderscoredLit(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-octLit) (lambda () (LibrariesC-45TextC-45Lexer-many (vector 4 (LibrariesC-45TextC-45Lexer-is #\_) (lambda () (LibrariesC-45TextC-45Lexer-octDigits)))))))))
(define LibrariesC-45TextC-45Lexer-octLit(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-exact "0o") (lambda () (LibrariesC-45TextC-45Lexer-octDigits))))))
(define LibrariesC-45TextC-45Lexer-octDigits(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45Lexer-octDigit)))))
(define LibrariesC-45TextC-45Lexer-octDigit(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isOctDigit eta-0))))))
(define LibrariesC-45TextC-45Lexer-non (lambda (arg-0) (vector 5 (LibrariesC-45TextC-45LexerC-45Core-reject arg-0) (LibrariesC-45TextC-45Lexer-any))))
(define LibrariesC-45TextC-45Lexer-newline(blodwen-lazy (lambda () (let ((u--crlf "\xd;\xa;")) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-exact u--crlf) (LibrariesC-45TextC-45Lexer-oneOf u--crlf))))))
(define LibrariesC-45TextC-45Lexer-manyUntil (lambda (arg-1 arg-2) (LibrariesC-45TextC-45Lexer-many (vector 5 (LibrariesC-45TextC-45LexerC-45Core-reject arg-1) arg-2))))
(define LibrariesC-45TextC-45Lexer-manyThen (lambda (arg-1 arg-2) (vector 5 (LibrariesC-45TextC-45Lexer-manyUntil arg-1 arg-2) arg-1)))
(define LibrariesC-45TextC-45Lexer-many (lambda (arg-0) (LibrariesC-45TextC-45Lexer-opt (LibrariesC-45TextC-45Lexer-some arg-0))))
(define LibrariesC-45TextC-45Lexer-like (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--y) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char (PreludeC-45Types-toUpper arg-0) (PreludeC-45Types-toUpper u--y))))))
(define LibrariesC-45TextC-45Lexer-isNot (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 arg-0)))))
(define LibrariesC-45TextC-45Lexer-is (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 arg-0)))))
(define LibrariesC-45TextC-45Lexer-intLit(blodwen-lazy (lambda () (vector 5 (LibrariesC-45TextC-45Lexer-opt (LibrariesC-45TextC-45Lexer-is #\-)) (LibrariesC-45TextC-45Lexer-digits)))))
(define LibrariesC-45TextC-45Lexer-hexUnderscoredLit(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-hexLit) (lambda () (LibrariesC-45TextC-45Lexer-many (vector 4 (LibrariesC-45TextC-45Lexer-is #\_) (lambda () (LibrariesC-45TextC-45Lexer-hexDigits)))))))))
(define LibrariesC-45TextC-45Lexer-hexLit(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-approx "0x") (lambda () (LibrariesC-45TextC-45Lexer-hexDigits))))))
(define LibrariesC-45TextC-45Lexer-hexDigits(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45Lexer-hexDigit)))))
(define LibrariesC-45TextC-45Lexer-hexDigit(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isHexDigit eta-0))))))
(define LibrariesC-45TextC-45Lexer-exact (lambda (arg-0) (let ((sc0 (PreludeC-45Types-fastUnpack arg-0))) (if (null? sc0) (LibrariesC-45TextC-45LexerC-45Core-fail) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (LibrariesC-45TextC-45LexerC-45Core-concatMap (lambda (eta-0) (LibrariesC-45TextC-45Lexer-is eta-0)) (cons e-2 e-3))))))))
(define LibrariesC-45TextC-45Lexer-escape (lambda (arg-0 arg-1) (vector 4 arg-0 (lambda () arg-1))))
(define LibrariesC-45TextC-45Lexer-digitsUnderscoredLit(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-digits) (lambda () (LibrariesC-45TextC-45Lexer-many (vector 4 (LibrariesC-45TextC-45Lexer-is #\_) (lambda () (LibrariesC-45TextC-45Lexer-digits)))))))))
(define LibrariesC-45TextC-45Lexer-digits(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45Lexer-digit)))))
(define LibrariesC-45TextC-45Lexer-digit(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isDigit eta-0))))))
(define LibrariesC-45TextC-45Lexer-choiceMap (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-3 0))) (((((e-1 'erased) 'erased) (lambda (u--x) (lambda (u--acc) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (arg-4 u--x) u--acc)))) (LibrariesC-45TextC-45LexerC-45Core-fail)) arg-5))))
(define LibrariesC-45TextC-45Lexer-choice (lambda (arg-1 arg-2 ext-0) (LibrariesC-45TextC-45Lexer-choiceMap arg-1 arg-2 (lambda (eta-0) eta-0) ext-0)))
(define LibrariesC-45TextC-45Lexer-charLit(blodwen-lazy (lambda () (let ((u--q #\')) (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-is u--q) (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-escape (LibrariesC-45TextC-45Lexer-is #\\) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-n--3644-738-u--control) (LibrariesC-45TextC-45Lexer-any))) (LibrariesC-45TextC-45Lexer-isNot u--q)))) (lambda () (LibrariesC-45TextC-45Lexer-is u--q)))))))
(define LibrariesC-45TextC-45Lexer-binUnderscoredLit(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-binLit) (lambda () (LibrariesC-45TextC-45Lexer-many (vector 4 (LibrariesC-45TextC-45Lexer-is #\_) (lambda () (LibrariesC-45TextC-45Lexer-binDigits)))))))))
(define LibrariesC-45TextC-45Lexer-binLit(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-exact "0b") (lambda () (LibrariesC-45TextC-45Lexer-binDigits))))))
(define LibrariesC-45TextC-45Lexer-binDigits(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45Lexer-binDigit)))))
(define LibrariesC-45TextC-45Lexer-binDigit(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--c) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--c #\0))) (cond ((equal? sc0 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--c #\1)))))))))
(define LibrariesC-45TextC-45Lexer-approx (lambda (arg-0) (let ((sc0 (PreludeC-45Types-fastUnpack arg-0))) (if (null? sc0) (LibrariesC-45TextC-45LexerC-45Core-fail) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (LibrariesC-45TextC-45LexerC-45Core-concatMap (lambda (eta-0) (LibrariesC-45TextC-45Lexer-like eta-0)) (cons e-2 e-3))))))))
(define LibrariesC-45TextC-45Lexer-any(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) 1)))))
(define LibrariesC-45TextC-45Lexer-alphaNum(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isAlphaNum eta-0))))))
(define LibrariesC-45TextC-45LexerC-45Core-case--tokenise-1693 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (cons (PreludeC-45TypesC-45List-reverse arg-3) (cons arg-5 (cons arg-4 arg-1))) (let ((e-1 (unbox arg-7))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((sc4 (arg-6 (let ((e-4 (vector-ref e-5 0))) e-4)))) (cond ((equal? sc4 1) (cons (PreludeC-45TypesC-45List-reverse arg-3) (cons arg-5 (cons arg-4 '())))) (else (LibrariesC-45TextC-45LexerC-45Core-tokenise arg-6 e-9 e-13 (cons e-5 arg-3) arg-2 e-14))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Core-case--tokeniseC-44getFirstToken-1607 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (LibrariesC-45TextC-45LexerC-45Core-n--3688-1494-u--getFirstToken arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-10) (let ((e-1 (unbox arg-11))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((u--lineC-39 (bs+ arg-5 (PreludeC-45Cast-u--cast_Cast_Nat_Int (LibrariesC-45TextC-45LexerC-45Core-n--3688-1492-u--countNLs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5)) 63))) (let ((u--colC-39 (LibrariesC-45TextC-45LexerC-45Core-n--3688-1493-u--getCols arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 arg-4))) (box (cons (vector (arg-8 (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-5))) 0 (vector arg-5 arg-4 u--lineC-39 u--colC-39)) (cons u--lineC-39 (cons u--colC-39 e-6))))))))))))
(define LibrariesC-45TextC-45LexerC-45Core-n--3688-1494-u--getFirstToken (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) '() (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45TextC-45LexerC-45Core-case--tokeniseC-44getFirstToken-1607 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6 e-7 e-3 arg-8 (LibrariesC-45TextC-45LexerC-45Core-scan e-6 '() arg-8)))))))))
(define LibrariesC-45TextC-45LexerC-45Core-n--3688-1493-u--getCols (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((sc0 (DataC-45List-span (lambda (arg-0) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-0 (integer->char 10))) (PreludeC-45TypesC-45List-reverse arg-7)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-3) (bs+ arg-8 (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45List-length e-2)) 63) (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45List-length e-2))))))))
(define LibrariesC-45TextC-45LexerC-45Core-n--3688-1492-u--countNLs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (PreludeC-45TypesC-45List-length (DataC-45List-filter (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 10))) arg-7))))
(define LibrariesC-45TextC-45LexerC-45Core-tokenise (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (LibrariesC-45TextC-45LexerC-45Core-case--tokenise-1693 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (LibrariesC-45TextC-45LexerC-45Core-n--3688-1494-u--getFirstToken arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-5 arg-6))))
(define LibrariesC-45TextC-45LexerC-45Core-scan (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-1 0) ((0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons arg-2 arg-3))) ((1) '()) ((2) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool (DataC-45Maybe-isJust (LibrariesC-45TextC-45LexerC-45Core-scan e-3 arg-2 arg-3)) e-2))) (cond ((equal? sc1 1) (PreludeC-45Types-u--pure_Applicative_Maybe (cons arg-2 arg-3))) (else '())))))) ((3) (let ((e-4 (vector-ref arg-1 1))) (if (null? arg-3) '() (let ((e-21 (car arg-3))) (let ((e-22 (cdr arg-3))) (let ((sc2 (e-4 e-21))) (cond ((equal? sc2 1) (box (cons (cons e-21 arg-2) e-22))) (else '())))))))) ((4) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45TextC-45LexerC-45Core-scan e-6 arg-2 arg-3) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (LibrariesC-45TextC-45LexerC-45Core-scan (e-7) e-2 e-3)))))))) ((5) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45TextC-45LexerC-45Core-scan e-10 arg-2 arg-3) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (LibrariesC-45TextC-45LexerC-45Core-scan e-11 e-2 e-3)))))))) ((6) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45TextC-45LexerC-45Core-scan e-13 arg-2 arg-3) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (LibrariesC-45TextC-45LexerC-45Core-scan e-14 e-2 e-3)))))))) (else (let ((e-17 (vector-ref arg-1 1))) (let ((e-18 (vector-ref arg-1 2))) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45LexerC-45Core-scan e-18 arg-2 arg-3)) (lambda () (lambda (eta-0) (box eta-0))) (LibrariesC-45TextC-45LexerC-45Core-scan e-17 arg-2 arg-3))))))))
(define LibrariesC-45TextC-45LexerC-45Core-reject (lambda (ext-0) (vector 2 0 ext-0)))
(define LibrariesC-45TextC-45LexerC-45Core-pred (lambda (ext-0) (vector 3 ext-0)))
(define LibrariesC-45TextC-45LexerC-45Core-lexTo (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Core-tokenise arg-1 0 0 '() arg-2 (PreludeC-45Types-fastUnpack arg-3)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons e-10 (PreludeC-45Types-fastPack e-11)))))))))))))
(define LibrariesC-45TextC-45LexerC-45Core-lex (lambda (arg-1 arg-2) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Core-tokenise (lambda (eta-0) 0) 0 0 '() arg-1 (PreludeC-45Types-fastUnpack arg-2)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons e-10 (PreludeC-45Types-fastPack e-11)))))))))))))
(define LibrariesC-45TextC-45LexerC-45Core-fail(blodwen-lazy (lambda () (vector 1 ))))
(define LibrariesC-45TextC-45LexerC-45Core-expect (lambda (ext-0) (vector 2 1 ext-0)))
(define LibrariesC-45TextC-45LexerC-45Core-empty(blodwen-lazy (lambda () (vector 0 ))))
(define LibrariesC-45TextC-45LexerC-45Core-concatMap (lambda (arg-2 arg-3) (if (null? arg-3) (vector 0 ) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (arg-2 e-2) (vector 6 (arg-2 e-2) (LibrariesC-45TextC-45LexerC-45Core-concatMap arg-2 e-3))))))))
(define LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (lambda (ext-0 ext-1) (vector 7 ext-0 ext-1)))
(define LibrariesC-45DataC-45StringC-45Extra-case--linesC-39-3864 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons e-2 (if (null? e-3) '() (let ((e-4 (cdr e-3))) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-linesC-39 e-4)))))))))
(define LibrariesC-45DataC-45StringC-45Extra-unlinesC-39 (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? e-3) e-2 (PreludeC-45TypesC-45List-tailRecAppend e-2 (cons (integer->char 10) (LibrariesC-45DataC-45StringC-45Extra-unlinesC-39 e-3)))))))))
(define LibrariesC-45DataC-45StringC-45Extra-unlines (lambda (ext-0) (PreludeC-45Types-fastPack (LibrariesC-45DataC-45StringC-45Extra-unlinesC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Types-fastUnpack eta-0)) ext-0)))))
(define LibrariesC-45DataC-45StringC-45Extra-strSnoc (lambda (arg-0 arg-1) (PreludeC-45TypesC-45String-C-43C-43 arg-0 (DataC-45String-singleton arg-1))))
(define LibrariesC-45DataC-45StringC-45Extra-replicate (lambda (arg-0 arg-1) (PreludeC-45Types-fastPack (DataC-45List-replicate arg-0 arg-1))))
(define LibrariesC-45DataC-45StringC-45Extra-linesC-39 (lambda (arg-0) (if (null? arg-0) (DataC-45List1-singleton '()) (LibrariesC-45DataC-45StringC-45Extra-case--linesC-39-3864 arg-0 (DataC-45List-break (lambda (eta-0) (PreludeC-45Types-isNL eta-0)) arg-0)))))
(define LibrariesC-45DataC-45StringC-45Extra-lines (lambda (arg-0) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (LibrariesC-45DataC-45StringC-45Extra-linesC-39 (PreludeC-45Types-fastUnpack arg-0)))))
(define LibrariesC-45DataC-45StringC-45Extra-join (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45StringC-45Extra-drop (PreludeC-45TypesC-45String-length arg-1) (let ((e-2 (vector-ref arg-2 1))) (((((e-2 'erased) 'erased) (lambda (u--acc) (lambda (u--x) (PreludeC-45TypesC-45String-C-43C-43 u--acc (PreludeC-45TypesC-45String-C-43C-43 arg-1 u--x))))) "") arg-3)))))
(define LibrariesC-45DataC-45StringC-45Extra-dropLast (lambda (arg-0 arg-1) (PreludeC-45Types-reverse (LibrariesC-45DataC-45StringC-45Extra-drop arg-0 (PreludeC-45Types-reverse arg-1)))))
(define LibrariesC-45DataC-45StringC-45Extra-drop (lambda (arg-0 arg-1) (PreludeC-45Types-substr arg-0 (PreludeC-45TypesC-45String-length arg-1) arg-1)))
(define LibrariesC-45DataC-45StringC-45Extra-C-43C-62 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45StringC-45Extra-strSnoc ext-0 ext-1)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-case--wordsC-44helper-882 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((sc1 (DataC-45List-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) arg-3))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons e-2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-n--3468-875-u--helper arg-1 e-3))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-n--3468-875-u--helper (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-case--wordsC-44helper-882 arg-1 arg-2 (DataC-45List-dropWhile (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) arg-2))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-words (lambda (arg-1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-n--3468-875-u--helper arg-1 (PreludeC-45Types-fastUnpack arg-1))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-words ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (lambda (ext-0) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate eta-0 eta-1)))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-case--unsafeTextWithoutNewLines-4921 (lambda (arg-1 arg-2) (cond ((equal? arg-1 "") (if (null? arg-2) (vector 0 ) (let ((e-0 (car arg-2))) (let ((e-1 (cdr arg-2))) (let ((u--str (PreludeC-45Types-strCons e-0 e-1))) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 ""))) (cond ((equal? sc3 1) (vector 1 e-0)) (else (vector 2 (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45String-length u--str)) u--str)))))))))(else (let ((e-0 (car arg-2))) (let ((e-1 (cdr arg-2))) (let ((u--str (PreludeC-45Types-strCons e-0 e-1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 ""))) (cond ((equal? sc1 1) (vector 1 e-0)) (else (vector 2 (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45String-length u--str)) u--str)))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-case--changesUponFlattening-4341 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((2) (vector 2 ))(else (case (vector-ref e-3 0) ((2) (vector 2 ))(else (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((0) (let ((e-8 (vector-ref e-3 1))) (vector 0 (vector 5 e-5 e-8)))) (else (vector 0 (vector 5 e-5 arg-1)))))) (else (case (vector-ref e-3 0) ((0) (let ((e-11 (vector-ref e-3 1))) (vector 0 (vector 5 arg-2 e-11)))) (else (vector 1 )))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7676-u--selectNicer (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 ((((arg-3 arg-4) arg-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7675-u--initialIndentation arg-1 arg-2 arg-3 (arg-7))) arg-6))) (cond ((equal? sc0 1) arg-6) (else (arg-7))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7675-u--initialIndentation (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (box e-1))) ((4) (let ((e-5 (vector-ref arg-4 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7675-u--initialIndentation arg-1 arg-2 arg-3 e-5))) ((5) (let ((e-7 (vector-ref arg-4 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7675-u--initialIndentation arg-1 arg-2 arg-3 e-7)))(else '()))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8291-9031-u--go (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (cons (DataC-45SnocList-C-60C-62C-62 arg-3 '()) (DataC-45SnocList-C-60C-62C-62 arg-4 '()))) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8291-9031-u--go arg-1 (+ 1 arg-2) (cons arg-3 (PreludeC-45Cast-u--cast_Cast_Char_String e-14)) arg-4 arg-5 (e-15))))) ((2) (let ((e-17 (vector-ref arg-6 1))) (let ((e-18 (vector-ref arg-6 2))) (let ((e-19 (vector-ref arg-6 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8291-9031-u--go arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer e-17)) arg-2) (cons arg-3 e-18) arg-4 arg-5 (e-19)))))) ((3) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((u--text (PreludeC-45Types-strCons (integer->char 10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces e-21)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8291-9031-u--go arg-1 (PreludeC-45Types-u--C-43_Num_Nat (+ 1 (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer e-21))) arg-2) (cons arg-3 u--text) arg-4 arg-5 e-22))))) ((4) (let ((e-24 (vector-ref arg-6 1))) (let ((e-25 (vector-ref arg-6 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8291-9031-u--go arg-1 arg-2 arg-3 arg-4 (cons (cons arg-2 e-24) arg-5) e-25))))(else (if (null? arg-5) (let ((e-11 (vector-ref arg-6 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8291-9031-u--go arg-1 arg-2 arg-3 arg-4 '() e-11)) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (let ((e-9 (vector-ref arg-6 1))) (let ((u--span (vector e-6 (PreludeC-45Types-prim__integerToNat (- arg-2 e-6)) e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8291-9031-u--go arg-1 arg-2 arg-3 (cons arg-4 u--span) e-2 e-9))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (vector 0 )) ((2) (let ((e-2 (vector-ref arg-6 1))) (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 e-2)))) (else (let ((e-4 (vector-ref arg-6 1))) (let ((e-5 (vector-ref arg-6 2))) (let ((e-6 (vector-ref arg-6 3))) (case (vector-ref e-5 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 e-6)) ((1) (let ((e-9 (vector-ref e-5 1))) (vector 1 e-9 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 (bs+ arg-5 1 63) e-6))))) ((2) (let ((e-11 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (vector 2 e-11 e-12 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 (bs+ arg-5 e-11 63) e-6)))))) ((3) (let ((u--x (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 e-4 e-4 e-6))) (let ((u--iC-39 (case (vector-ref u--x 0) ((0) (blodwen-toSignedInt 0 63)) ((3) (blodwen-toSignedInt 0 63))(else e-4)))) (vector 3 u--iC-39 u--x)))) ((4) (let ((e-15 (vector-ref e-5 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-15) e-6)))) ((5) (let ((e-18 (vector-ref e-5 1))) (let ((e-19 (vector-ref e-5 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 e-18 (vector 1 e-4 e-19 e-6)))))) ((6) (let ((e-21 (vector-ref e-5 1))) (let ((e-22 (vector-ref e-5 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 (bs+ e-4 e-21 63) e-22 e-6))))) ((7) (let ((e-24 (vector-ref e-5 1))) (let ((e-25 (vector-ref e-5 2))) (let ((u--xC-39 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-24) e-6)))) (let ((u--yC-39 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-25) e-6)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7676-u--selectNicer arg-1 arg-2 arg-3 arg-4 arg-5 u--xC-39 (lambda () u--yC-39))))))) ((8) (let ((e-27 (vector-ref e-5 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-27 arg-5) e-6)))) ((9) (let ((e-29 (vector-ref e-5 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-29 arg-2) e-6)))) ((10) (let ((e-31 (vector-ref e-5 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-31 e-4) e-6)))) (else (let ((e-33 (vector-ref e-5 1))) (let ((e-34 (vector-ref e-5 2))) (vector 4 e-33 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 e-34 (vector 2 e-6)))))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--traverse_Traversable_Span (lambda (arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (PreludeC-45Interfaces-C-60C-36C-62 (let ((e-6 (vector-ref arg-3 0))) e-6) (lambda (eta-0) (vector e-1 e-2 eta-0)) (arg-4 e-3)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (lambda (arg-1) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-defaultLayoutOptions) arg-1)) "")))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (lambda (arg-1) (let ((u--strC-39 (let ((sc0 (DataC-45String-isSuffixOf "\xa;" arg-1))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) arg-1)) (else arg-1))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines u--strC-39)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Nat ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Integer (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Integer ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int8 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Int8 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int64 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Int64 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int32 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Int32 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int16 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Int16 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Int ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Double (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Double ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char (lambda (arg-1) (cond ((equal? arg-1 (integer->char 10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))(else (vector 1 arg-1)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bool (lambda (arg-1) (cond ((equal? arg-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "True")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "False")))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bits8 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Bits8 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bits64 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Bits64 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bits32 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Bits32 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bits16 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (PreludeC-45Show-u--show_Show_Bits16 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-tupled (cons (let ((sc1 (Builtin-fst arg-3))) (let ((e-1 (car sc1))) ((e-1 'erased) e-2))) (cons (let ((sc1 (Builtin-snd arg-3))) (let ((e-1 (car sc1))) ((e-1 'erased) e-3))) '())))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_C-40MaybeC-32C-36aC-41 (lambda (arg-2 ext-0) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41)) (lambda () (lambda (clam-0) (let ((e-1 (car arg-2))) ((e-1 'erased) clam-0)))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_C-40ListC-32C-36aC-41 (lambda (arg-2 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-list (PreludeC-45Types-u--map_Functor_List (lambda (clam-0) (let ((e-1 (car arg-2))) ((e-1 'erased) clam-0))) ext-0)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41(blodwen-lazy (lambda () (vector 0 ))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--map_Functor_FlattenResult (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (vector 0 (arg-2 e-1)))) ((1) (vector 1 )) (else (vector 2 )))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (lambda (ext-0 ext-1) (vector 5 ext-0 ext-1)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) u--y))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-lineC-39)) u--y))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (lambda (arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-case--unsafeTextWithoutNewLines-4921 arg-1 (DataC-45String-strM arg-1))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS (lambda (arg-2) (case (vector-ref arg-2 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector 1 e-2 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS (e-3))))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (vector 2 e-5 e-6 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS (e-7)))))))) ((3) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (vector 3 e-9 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS e-10))))) ((4) (let ((e-13 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS e-13))) (else (let ((e-15 (vector-ref arg-2 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS e-15))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-tupled (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-encloseSep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatAlt (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "( ")) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "("))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatAlt (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String " )")) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String ")"))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String ", ") ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces (lambda (arg-0) (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer arg-0)) #\ )))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (lambda (arg-1 arg-2 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-2 arg-1) arg-3)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (lambda (arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (vector 0 )) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 (blodwen-toSignedInt 1 63)))) (cond ((equal? sc1 1) (vector 1 #\ )) (else (vector 2 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces arg-1))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline(blodwen-lazy (lambda () (vector 7 (lambda () (vector 1 #\ )) (lambda () (vector 3 ))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-round (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_Double arg-0 (PreludeC-45Num-u--fromInteger_Num_Double 0)))) (cond ((equal? sc0 1) (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Double (- arg-0 (PreludeC-45Types-floor arg-0)) 0.5))) (cond ((equal? sc1 1) (PreludeC-45Cast-u--cast_Cast_Double_Int (PreludeC-45Types-floor arg-0))) (else (PreludeC-45Cast-u--cast_Cast_Double_Int (PreludeC-45Types-ceiling arg-0)))))) (else (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Double (- (PreludeC-45Types-ceiling arg-0) arg-0) 0.5))) (cond ((equal? sc1 1) (PreludeC-45Cast-u--cast_Cast_Double_Int (PreludeC-45Types-ceiling arg-0))) (else (PreludeC-45Cast-u--cast_Cast_Double_Int (PreludeC-45Types-floor arg-0))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) eta-0)) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (lambda (eta-0) (PreludeC-45Types-strCons e-2 ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow (e-3)) eta-0)))))) ((2) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (lambda (eta-0) (PreludeC-45TypesC-45String-C-43C-43 e-6 ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow (e-7)) eta-0)))))) ((3) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (lambda (eta-0) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-strCons (integer->char 10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces e-9)) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow e-10) eta-0)))))) ((4) (let ((e-13 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow e-13))) (else (let ((e-15 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow e-15))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-remainingWidth (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--columnsLeftInLine (bs- arg-0 arg-3 63))) (let ((u--ribbonWidth (PreludeC-45EqOrd-u--max_Ord_Int (blodwen-toSignedInt 0 63) (PreludeC-45EqOrd-u--min_Ord_Int arg-0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-round (PreludeC-45Num-u--C-42_Num_Double (PreludeC-45Cast-u--cast_Cast_Int_Double arg-0) arg-1)))))) (let ((u--columnsLeftInRibbon (bs- (bs+ arg-2 u--ribbonWidth 63) arg-3 63))) (PreludeC-45EqOrd-u--min_Ord_Int u--columnsLeftInLine u--columnsLeftInRibbon))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (vector 1 e-2 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 (e-3))))))) ((2) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (vector 2 e-5 e-6 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 (e-7)))))))) ((3) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (vector 3 e-9 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 e-10))))) ((4) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (vector 4 (arg-2 e-12) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 e-13))))) (else (let ((e-15 (vector-ref arg-3 1))) (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 e-15)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (arg-2 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations (lambda (eta-0) (PreludeC-45Types-u--pure_Applicative_List (arg-2 eta-0))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (cons e-2 '()) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-2 arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate arg-1 e-3))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nesting (lambda (ext-0) (vector 10 ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) arg-2)(else (vector 6 arg-1 arg-2)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-list (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-encloseSep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatAlt (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "[ ")) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "["))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatAlt (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String " ]")) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "]"))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String ", ") ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-lineC-39(blodwen-lazy (lambda () (vector 4 (lambda () (vector 3 )) (lambda () (vector 0 ))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line(blodwen-lazy (lambda () (vector 4 (lambda () (vector 3 )) (lambda () (vector 1 #\ ))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutWadlerLeijen (lambda (arg-1 arg-2 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--6880-7677-u--best arg-3 arg-2 arg-1 0 0 (vector 1 0 arg-3 (vector 0 )))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutUnbounded (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutWadlerLeijen (lambda (_-7934) (lambda (_-7936) (lambda (_-7938) (lambda (u--sdoc) 1)))) '() ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty (lambda (arg-1 ext-0) (if (null? arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutUnbounded ext-0) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutWadlerLeijen (lambda (u--lineIndent) (lambda (u--currentColumn) (lambda (_-8036) (lambda (u--sdoc) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-remainingWidth e-1 e-2 u--lineIndent u--currentColumn) u--sdoc))))) arg-1 ext-0))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces arg-1) arg-2))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 eta-0 eta-1))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hcat (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-447) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline(blodwen-lazy (lambda () (vector 3 ))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest arg-1 arg-2))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (lambda (arg-1) (case (vector-ref arg-1 0) ((7) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (vector 7 e-1 e-2)))) ((4) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (let ((sc1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening (e-5)))) (case (vector-ref sc1 0) ((0) (let ((e-1 (vector-ref sc1 1))) (vector 7 (lambda () e-1) e-4))) ((1) (vector 7 e-5 e-4)) (else (e-4)))))))(else (let ((sc0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening arg-1))) (case (vector-ref sc0 0) ((0) (let ((e-1 (vector-ref sc0 1))) (vector 7 (lambda () e-1) (lambda () arg-1)))) ((1) arg-1) (else arg-1)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-1 1))) (vector 1 e-2))) ((2) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (vector 2 e-4 e-5)))) ((3) (vector 0 )) ((4) (let ((e-9 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-9)))) ((5) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten e-12))))) ((6) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (vector 6 e-14 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten e-15))))) ((7) (let ((e-17 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-17)))) ((8) (let ((e-20 (vector-ref arg-1 1))) (vector 8 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-20 u--x)))))) ((9) (let ((e-22 (vector-ref arg-1 1))) (vector 9 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-22 u--x)))))) ((10) (let ((e-24 (vector-ref arg-1 1))) (vector 10 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-24 u--x)))))) (else (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (vector 11 e-26 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten e-27))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatAlt (lambda (ext-0 ext-1) (vector 4 ext-0 ext-1)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits (lambda (arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) 0) (else (case (vector-ref arg-2 0) ((0) 1) ((1) (let ((e-3 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits (bs- arg-1 1 63) (e-3)))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits (bs- arg-1 e-5 63) (e-7))))) ((3) 1) ((4) (let ((e-13 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits arg-1 e-13))) (else (let ((e-15 (vector-ref arg-2 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits arg-1 e-15)))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) u--y))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-encloseSep (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 arg-2) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 e-2) arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-cat (DataC-45List-u--zipWith_Zippable_List (csegen-447) (cons arg-1 (DataC-45List-replicate (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-length arg-4) (+ 1 0))) arg-3)) arg-4)) arg-2)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (lambda (arg-1 arg-2 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 arg-3) arg-2)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc(blodwen-lazy (lambda () (vector 0 ))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-displaySpans (lambda (arg-1) (let ((sc0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8291-9031-u--go arg-1 0 '() '() '() arg-1))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons (PreludeC-45Interfaces-concat (csegen-67) e-2) e-3))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-defaultPageWidth(blodwen-lazy (lambda () (cons 80 1.0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-defaultLayoutOptions(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-defaultPageWidth))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (arg-1 arg-2) (if (null? arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45Types-u--foldl_Foldable_List arg-1 e-2 e-3))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-column (lambda (ext-0) (vector 8 ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (vector 1 )) ((1) (vector 1 )) ((2) (vector 1 )) ((3) (vector 2 )) ((4) (let ((e-9 (vector-ref arg-1 2))) (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-9))))) ((5) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-case--changesUponFlattening-4341 e-12 e-11 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening e-12)))))) ((6) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--map_Functor_FlattenResult (lambda (eta-0) (vector 6 e-14 eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening e-15))))) ((7) (let ((e-17 (vector-ref arg-1 1))) (vector 0 (e-17)))) ((8) (let ((e-20 (vector-ref arg-1 1))) (vector 0 (vector 8 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-20 eta-0))))))) ((9) (let ((e-22 (vector-ref arg-1 1))) (vector 0 (vector 9 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-22 eta-0))))))) ((10) (let ((e-24 (vector-ref arg-1 1))) (vector 0 (vector 10 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-24 eta-0))))))) (else (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--map_Functor_FlattenResult (lambda (eta-0) (vector 11 e-26 eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening e-27))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-cat (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (lambda (ext-0 ext-1) (vector 11 ext-0 ext-1)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 e-2))) ((2) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (vector 2 e-4 e-5)))) ((3) (vector 3 )) ((4) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (vector 4 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-8))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-9))))))) ((5) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 e-12))))) ((6) (let ((e-14 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 2))) (vector 6 e-14 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 e-15))))) ((7) (let ((e-17 (vector-ref arg-3 1))) (let ((e-18 (vector-ref arg-3 2))) (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-17))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-18))))))) ((8) (let ((e-20 (vector-ref arg-3 1))) (vector 8 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-20 u--x)))))) ((9) (let ((e-22 (vector-ref arg-3 1))) (vector 9 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-22 u--x)))))) ((10) (let ((e-24 (vector-ref arg-3 1))) (vector 10 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-24 u--x)))))) (else (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (vector 11 eta-0 eta-1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 e-27) (arg-2 e-26))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (lambda (arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-column (lambda (u--k) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nesting (lambda (u--i) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest (bs- u--k u--i 63) arg-1)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 (vector 1 #\ )) arg-2)))
(define DataC-45SnocList-C-60C-62C-62 (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (DataC-45SnocList-C-60C-62C-62 e-2 (cons e-3 arg-2)))))))
(define DataC-45SnocList-C-60C-62C-60 (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (DataC-45SnocList-C-60C-62C-60 (cons arg-1 e-2) e-3))))))
(define DecidableC-45Equality-with--withC-32blockC-32inC-32decEq-1251 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (cond (else (vector 0 0))))) (else (let ((e-3 (vector-ref arg-4 1))) (vector 1 (lambda (eta-0) (e-3 (Builtin-snd (DataC-45List-consInjective eta-0))))))))))
(define DecidableC-45Equality-with--decEq-1201 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-4 0) ((1) (let ((e-1 (vector-ref arg-4 1))) (vector 1 (lambda (eta-0) (e-1 (Builtin-fst (DataC-45List-consInjective eta-0))))))) (else (let ((e-3 (vector-ref arg-4 1))) (cond (else (DecidableC-45Equality-with--withC-32blockC-32inC-32decEq-1251 'erased arg-1 arg-6 arg-5 (DecidableC-45Equality-u--decEq_DecEq_C-40ListC-32C-36aC-41 arg-1 arg-5 arg-6) arg-2))))))))
(define DecidableC-45Equality-with--withC-32blockC-32inC-32decEq-1071 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (cond (else (vector 0 0))))) (else (let ((e-3 (vector-ref arg-5 1))) (vector 1 (lambda (eta-0) (e-3 (Builtin-snd (DecidableC-45Equality-pairInjective eta-0))))))))))
(define DecidableC-45Equality-with--decEq-1012 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-5 0) ((1) (let ((e-1 (vector-ref arg-5 1))) (vector 1 (lambda (eta-0) (e-1 (Builtin-fst (DecidableC-45Equality-pairInjective eta-0))))))) (else (let ((e-3 (vector-ref arg-5 1))) (cond (else (DecidableC-45Equality-with--withC-32blockC-32inC-32decEq-1071 'erased 'erased arg-2 arg-6 arg-7 (((Builtin-snd arg-2) arg-6) arg-7) arg-3))))))))
(define DecidableC-45Equality-n--4244-1446-u--primitiveNotEq (lambda (arg-1 arg-2 arg-3 arg-7) (Builtin-believe_me 0)))
(define DecidableC-45Equality-n--4244-1445-u--primitiveEq (lambda (arg-1 arg-2 arg-3) (Builtin-believe_me 0)))
(define DecidableC-45Equality-u--decEq_DecEq_String (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (csegen-17) ext-0 ext-1)))
(define DecidableC-45Equality-u--decEq_DecEq_Integer (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (csegen-450) ext-0 ext-1)))
(define DecidableC-45Equality-u--decEq_DecEq_Int (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (csegen-225) ext-0 ext-1)))
(define DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((e-1 (car arg-1))) ((e-1 arg-2) arg-3)))) (cond ((equal? sc0 1) (vector 0 (DecidableC-45Equality-n--4244-1445-u--primitiveEq arg-1 arg-2 arg-3))) (else (vector 1 (lambda (eta-0) (DecidableC-45Equality-n--4244-1446-u--primitiveNotEq arg-1 arg-2 arg-3 eta-0))))))))
(define DecidableC-45Equality-u--decEq_DecEq_Char (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (csegen-0) ext-0 ext-1)))
(define DecidableC-45Equality-u--decEq_DecEq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car arg-4))) (let ((e-7 (cdr arg-4))) (DecidableC-45Equality-with--decEq-1012 'erased 'erased arg-2 e-2 e-6 (((Builtin-fst arg-2) e-2) e-6) e-3 e-7)))))))
(define DecidableC-45Equality-u--decEq_DecEq_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) (vector 0 0) (vector 1 (lambda (eta-0) (PreludeC-45Uninhabited-absurd (lambda (eta-1) (DataC-45List-u--uninhabited_Uninhabited_C-40C-124C-40C-40C-61C-61C-61C-32NilC-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-44C-40C-40C-126C-61C-126C-32NilC-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-124C-41 eta-1)) eta-0)))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? arg-3) (vector 1 (lambda (eta-0) (PreludeC-45Uninhabited-absurd (lambda (eta-1) (DataC-45List-u--uninhabited_Uninhabited_C-40C-124C-40C-40C-61C-61C-61C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-32NilC-41C-44C-40C-40C-126C-61C-126C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-32NilC-41C-124C-41 eta-1)) eta-0))) (let ((e-10 (car arg-3))) (let ((e-11 (cdr arg-3))) (DecidableC-45Equality-with--decEq-1201 'erased arg-1 e-2 e-10 ((arg-1 e-2) e-10) e-3 e-11)))))))))
(define DecidableC-45Equality-pairInjective (lambda (arg-6) (cond (else (cons 0 0)))))
(define DataC-45Either-n--2678-872-u--compressRights (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (cons (vector 1 (DataC-45List1-reverse arg-4)) (DataC-45Either-compress arg-5)) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (case (vector-ref e-1 0) ((1) (let ((e-5 (vector-ref e-1 1))) (DataC-45Either-n--2678-872-u--compressRights arg-2 arg-3 (DataC-45List1-cons e-5 arg-4) e-2)))(else (cons (vector 1 (DataC-45List1-reverse arg-4)) (DataC-45Either-compress arg-5)))))))))
(define DataC-45Either-n--2678-841-u--compressLefts (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (cons (vector 0 (DataC-45List1-reverse arg-4)) (DataC-45Either-compress arg-5)) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (case (vector-ref e-1 0) ((0) (let ((e-5 (vector-ref e-1 1))) (DataC-45Either-n--2678-841-u--compressLefts arg-2 arg-3 (DataC-45List1-cons e-5 arg-4) e-2)))(else (cons (vector 0 (DataC-45List1-reverse arg-4)) (DataC-45Either-compress arg-5)))))))))
(define DataC-45Either-rights (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (DataC-45Either-rights e-3)) (else (let ((e-9 (vector-ref e-2 1))) (cons e-9 (DataC-45Either-rights e-3))))))))))
(define DataC-45Either-partitionEithers (lambda (arg-2) (cons (DataC-45Either-lefts arg-2) (DataC-45Either-rights arg-2))))
(define DataC-45Either-maybeToEither (lambda (arg-2 arg-3) (if (null? arg-3) (vector 0 (arg-2)) (let ((e-1 (unbox arg-3))) (vector 1 e-1)))))
(define DataC-45Either-lefts (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (cons e-6 (DataC-45Either-lefts e-3)))) (else (DataC-45Either-lefts e-3))))))))
(define DataC-45Either-getRight (lambda (arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (box e-2)))(else '()))))
(define DataC-45Either-compress (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (DataC-45Either-n--2678-841-u--compressLefts e-6 e-3 (DataC-45List1-singleton e-6) e-3))) (else (let ((e-9 (vector-ref e-2 1))) (DataC-45Either-n--2678-872-u--compressRights e-9 e-3 (DataC-45List1-singleton e-9) e-3)))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squotes (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squote) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squote) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squote(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\'))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\ ))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-slash(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\/))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\;))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rparen(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\]))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbrace(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\}))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rangle(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\>))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\|))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (lambda (arg-1 ext-0) (cond ((equal? arg-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens ext-0)) (else ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lparen) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rparen) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lparen(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\())))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\[))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbrace(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\{))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-langle(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\<))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\=))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquote) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquote) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquote(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\"))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\.))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\,))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\:))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (lambda (arg-1 arg-2 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose arg-1 arg-2 ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbrace) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbrace) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-backslash(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\\))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-langle) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rangle) ext-0)))
(define LibrariesC-45UtilsC-45String-n--2483-418-u--escape (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-elem (csegen-0) arg-2 arg-0))) (cond ((equal? sc0 1) (cons arg-1 (cons arg-2 arg-3))) (else (cons arg-2 arg-3))))))
(define LibrariesC-45UtilsC-45String-stripSurrounds (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-substr arg-0 (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45String-length arg-2) (PreludeC-45Types-u--C-43_Num_Nat arg-0 arg-1))) arg-2)))
(define LibrariesC-45UtilsC-45String-stripQuotes (lambda (ext-0) (LibrariesC-45UtilsC-45String-stripSurrounds (+ 1 0) (+ 1 0) ext-0)))
(define LibrariesC-45UtilsC-45String-lowerFirst (lambda (arg-0) (cond ((equal? arg-0 "") 0)(else (PreludeC-45Types-isLower (string-ref arg-0 0))))))
(define LibrariesC-45UtilsC-45String-escapeStringUnix (lambda (ext-0) (LibrariesC-45UtilsC-45String-escapeGeneric #\\ (cons #\" (cons #\\ '())) ext-0)))
(define LibrariesC-45UtilsC-45String-escapeStringChez (lambda (ext-0) (LibrariesC-45UtilsC-45String-escapeGeneric #\\ (cons #\' (cons #\\ '())) ext-0)))
(define LibrariesC-45UtilsC-45String-escapeGeneric (lambda (arg-0 arg-1 ext-0) (PreludeC-45Types-fastPack (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (LibrariesC-45UtilsC-45String-n--2483-418-u--escape arg-1 arg-0 eta-0 eta-1))) '() (PreludeC-45Types-fastUnpack ext-0)))))
(define LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) "'()") ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "(cons " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-3) ")"))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Integer e-5))) ((3) (let ((e-7 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Double e-7))) ((4) (let ((e-9 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_String e-9))) ((5) (let ((e-11 (vector-ref arg-1 1))) (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (PreludeC-45Cast-u--cast_Cast_Char_Int e-11) (blodwen-toSignedInt 32 63)))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60_Ord_Int (PreludeC-45Cast-u--cast_Cast_Char_Int e-11) (blodwen-toSignedInt 127 63))) (else 0))))) (cond ((equal? sc1 1) (PreludeC-45TypesC-45String-C-43C-43 "#\\" (PreludeC-45Cast-u--cast_Cast_Char_String e-11))) (else (PreludeC-45TypesC-45String-C-43C-43 "(integer->char " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int (PreludeC-45Cast-u--cast_Cast_Char_Int e-11)) ")"))))))) ((6) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "'" e-13))) ((8) (let ((e-15 (vector-ref arg-1 1))) (let ((e-16 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "(vector " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Integer e-15) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-607-u--showSep arg-0 " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 eta-0)) e-16)) ")"))))))) ((7) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "(box " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-18) ")")))) ((10) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "(define (" (PreludeC-45TypesC-45String-C-43C-43 e-19 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-20) ")"))))))) ((11) (let ((e-21 (vector-ref arg-1 1))) e-21)) ((12) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "(lambda (" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-607-u--showSep arg-0 " " e-22) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-23) ")"))))))) ((13) (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 3))) (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 e-24 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-25) (PreludeC-45TypesC-45String-C-43C-43 ")) " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-26) ")")))))))))) ((14) (let ((e-27 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 2))) (let ((e-29 (vector-ref arg-1 3))) (PreludeC-45TypesC-45String-C-43C-43 "(if " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-27) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-28) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-29) ")")))))))))) ((15) (let ((e-30 (vector-ref arg-1 1))) (let ((e-31 (vector-ref arg-1 2))) (let ((e-32 (vector-ref arg-1 3))) (PreludeC-45TypesC-45String-C-43C-43 "(case " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-30) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-607-u--showSep arg-0 " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45UtilsC-45Scheme-n--2686-788-u--showAlt arg-0 e-32 e-31 e-30 eta-0)) e-31)) (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2686-789-u--showDef arg-0 e-32 e-31 e-30 e-32) ")"))))))))) ((16) (let ((e-33 (vector-ref arg-1 1))) (let ((e-34 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "(cond " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-607-u--showSep arg-0 " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45UtilsC-45Scheme-n--2686-836-u--showAlt arg-0 e-34 e-33 eta-0)) e-33)) (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2686-837-u--showDef arg-0 e-34 e-33 e-34) ")")))))) (else (let ((e-35 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-35) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-607-u--showSep arg-0 " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 eta-0)) e-36)) ")"))))))))))
(define LibrariesC-45UtilsC-45Scheme-n--2683-607-u--showSep (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) "" (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) e-2 (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 arg-1 (LibrariesC-45UtilsC-45Scheme-n--2683-607-u--showSep arg-0 arg-1 e-3)))))))))
(define LibrariesC-45UtilsC-45Scheme-n--2686-837-u--showDef (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) "" (let ((e-2 (unbox arg-3))) (PreludeC-45TypesC-45String-C-43C-43 " (else " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-2) ")"))))))
(define LibrariesC-45UtilsC-45Scheme-n--2686-789-u--showDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) "" (let ((e-2 (unbox arg-4))) (PreludeC-45TypesC-45String-C-43C-43 " (else " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-2) ")"))))))
(define LibrariesC-45UtilsC-45Scheme-n--2686-836-u--showAlt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-3) ")"))))))))
(define LibrariesC-45UtilsC-45Scheme-n--2686-788-u--showAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45TypesC-45String-C-43C-43 "((" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-2) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 e-3) ")"))))))))
(define LibrariesC-45UtilsC-45Scheme-n--2985-898-u--readVector (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-1 arg-2))) (cond ((equal? sc0 1) '()) (else (cons (LibrariesC-45UtilsC-45Scheme-decodeObj (LibrariesC-45UtilsC-45Scheme-unsafeVectorRef arg-3 arg-2)) (LibrariesC-45UtilsC-45Scheme-n--2985-898-u--readVector arg-0 arg-1 (+ arg-2 1) arg-3)))))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String (lambda (arg-0) (vector 4 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Integer (lambda (arg-0) (vector 2 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (lambda (arg-0) (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer arg-0))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool (lambda (arg-0) (cond ((equal? arg-0 0) (vector 2 0)) (else (vector 2 1)))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (vector 1 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) (e-1 e-2))) (let ((sc1 (Builtin-snd arg-2))) (let ((e-1 (car sc1))) (e-1 e-3))))))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (if (null? arg-2) (vector 0 ) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (vector 1 (let ((e-1 (car arg-1))) (e-1 e-2)) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40ListC-32C-36aC-41 arg-1 e-3)))))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String (lambda (arg-0) (case (vector-ref arg-0 0) ((4) (let ((e-1 (vector-ref arg-0 1))) (box e-1)))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Integer (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box e-1)))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int8 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Int8 e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int64 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Int64 e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int32 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Int32 e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int16 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Int16 e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Int e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bool (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 0) (box 0)) ((equal? e-1 1) (box 1))(else '()))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits8 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Bits8 e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits64 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Bits64 e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits32 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Bits32 e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits16 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Integer_Bits16 e-1))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((sc1 (Builtin-fst arg-2))) (let ((e-3 (cdr sc1))) (e-3 e-1))) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((sc1 (Builtin-snd arg-2))) (let ((e-3 (cdr sc1))) (e-3 e-2))) (lambda (bind-1) (box (cons bind-0 bind-1)))))))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (box '())) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((e-4 (cdr arg-1))) (e-4 e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40ListC-32C-36aC-41 arg-1 e-3) (lambda (bind-1) (box (cons bind-0 bind-1)))))))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-isVector (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isVector arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isSymbol (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isSymbol arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isString (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isString arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isProcedure (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isProcedure arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isPair (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isPair arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isInteger (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isInteger arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isFloat (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isFloat arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isChar (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isChar arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isBox (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isBox arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-evalSchemeStr (lambda (arg-0) (let ((u--obj (LibrariesC-45UtilsC-45Scheme-prim__evalScheme arg-0))) (lambda (clam-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim__evalOkay u--obj) (blodwen-toSignedInt 1 63)))) (cond ((equal? sc0 1) (box (LibrariesC-45UtilsC-45Scheme-prim__evalResult u--obj))) (else '())))))))
(define LibrariesC-45UtilsC-45Scheme-evalSchemeObj (lambda (arg-0) (let ((u--str (LibrariesC-45UtilsC-45Scheme-n--2683-608-u--toString arg-0 arg-0))) (LibrariesC-45UtilsC-45Scheme-evalSchemeStr u--str))))
(define LibrariesC-45UtilsC-45Scheme-decodeObj (lambda (arg-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isInteger arg-0))) (cond ((equal? sc0 1) (vector 2 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger arg-0))) (else (let ((sc1 (LibrariesC-45UtilsC-45Scheme-isVector arg-0))) (cond ((equal? sc1 1) (vector 8 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger (LibrariesC-45UtilsC-45Scheme-unsafeVectorRef arg-0 0)) (LibrariesC-45UtilsC-45Scheme-n--2985-898-u--readVector arg-0 (LibrariesC-45UtilsC-45Scheme-unsafeVectorLength arg-0) 1 arg-0))) (else (let ((sc2 (LibrariesC-45UtilsC-45Scheme-isPair arg-0))) (cond ((equal? sc2 1) (vector 1 (LibrariesC-45UtilsC-45Scheme-decodeObj (LibrariesC-45UtilsC-45Scheme-unsafeFst arg-0)) (LibrariesC-45UtilsC-45Scheme-decodeObj (LibrariesC-45UtilsC-45Scheme-unsafeSnd arg-0)))) (else (let ((sc3 (LibrariesC-45UtilsC-45Scheme-isFloat arg-0))) (cond ((equal? sc3 1) (vector 3 (LibrariesC-45UtilsC-45Scheme-unsafeGetFloat arg-0))) (else (let ((sc4 (LibrariesC-45UtilsC-45Scheme-isString arg-0))) (cond ((equal? sc4 1) (vector 4 (LibrariesC-45UtilsC-45Scheme-unsafeGetString arg-0))) (else (let ((sc5 (LibrariesC-45UtilsC-45Scheme-isChar arg-0))) (cond ((equal? sc5 1) (vector 5 (LibrariesC-45UtilsC-45Scheme-unsafeGetChar arg-0))) (else (let ((sc6 (LibrariesC-45UtilsC-45Scheme-isSymbol arg-0))) (cond ((equal? sc6 1) (vector 6 (LibrariesC-45UtilsC-45Scheme-unsafeReadSymbol arg-0))) (else (let ((sc7 (LibrariesC-45UtilsC-45Scheme-isProcedure arg-0))) (cond ((equal? sc7 1) (vector 9 arg-0)) (else (let ((sc8 (LibrariesC-45UtilsC-45Scheme-isBox arg-0))) (cond ((equal? sc8 1) (vector 7 (LibrariesC-45UtilsC-45Scheme-decodeObj (LibrariesC-45UtilsC-45Scheme-unsafeUnbox arg-0)))) (else (vector 0 ))))))))))))))))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-n--6037-3549-u--treeToListC-39 (lambda (arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (arg-5 (cons e-3 e-4))))) ((1) (let ((e-9 (vector-ref arg-6 1))) (let ((e-11 (vector-ref arg-6 3))) (LibrariesC-45DataC-45SortedMap-n--6037-3549-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45SortedMap-n--6037-3549-u--treeToListC-39 arg-5 e-11))) e-9)))) (else (let ((e-16 (vector-ref arg-6 1))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-20 (vector-ref arg-6 5))) (LibrariesC-45DataC-45SortedMap-n--6037-3549-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45SortedMap-n--6037-3549-u--treeToListC-39 (lambda (arg-1) (cons arg-1 (LibrariesC-45DataC-45SortedMap-n--6037-3549-u--treeToListC-39 arg-5 e-20))) e-18))) e-16))))))))
(define LibrariesC-45DataC-45SortedMap-n--7261-4795-u--inserted (lambda (arg-2 arg-3 arg-4) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (LibrariesC-45DataC-45SortedMap-toList arg-2) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-4) (LibrariesC-45DataC-45SortedMap-lookup e-2 arg-3)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45SortedMap-u--show_Show_C-40C-40SortedMapC-32C-36kC-41C-32C-36vC-41 (lambda (arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 "fromList " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 u--d u--x)))) (LibrariesC-45DataC-45SortedMap-toList arg-3)))))
(define LibrariesC-45DataC-45SortedMap-u--null_Foldable_C-40SortedMapC-32C-36kC-41 (lambda (arg-2) (case (vector-ref arg-2 0) ((0) (lambda () 1)) (else (lambda () 0)))))
(define LibrariesC-45DataC-45SortedMap-u--map_Functor_C-40SortedMapC-32C-36kC-41 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (vector 1 e-5 e-6 (LibrariesC-45DataC-45SortedMap-treeMap arg-3 e-7)))))))))
(define LibrariesC-45DataC-45SortedMap-values (lambda (ext-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (LibrariesC-45DataC-45SortedMap-toList ext-0))))
(define LibrariesC-45DataC-45SortedMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45SortedMap-n--6037-3549-u--treeToListC-39 (lambda (arg-0) (cons arg-0 '())) ext-0)))
(define LibrariesC-45DataC-45SortedMap-treeMap (lambda (arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (vector 0 e-3 (arg-5 e-4))))) ((1) (let ((e-9 (vector-ref arg-6 1))) (let ((e-10 (vector-ref arg-6 2))) (let ((e-11 (vector-ref arg-6 3))) (vector 1 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-9) e-10 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-11)))))) (else (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (vector 2 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-16) e-17 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-18) e-19 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-20)))))))))))
(define LibrariesC-45DataC-45SortedMap-treeLookup (lambda (arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((sc1 (let ((e-1 (vector-ref arg-4 0))) (let ((e-12 (car e-1))) ((e-12 arg-5) e-3))))) (cond ((equal? sc1 1) (box e-4)) (else '())))))) ((1) (let ((e-9 (vector-ref arg-6 1))) (let ((e-10 (vector-ref arg-6 2))) (let ((e-11 (vector-ref arg-6 3))) (let ((sc1 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-10)))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-9)) (else (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-11)))))))) (else (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (let ((sc1 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-17)))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-16)) (else (let ((sc2 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-19)))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-18)) (else (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-20))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-treeInsertC-39 (lambda (arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (let ((sc1 (let ((e-2 (vector-ref arg-4 1))) ((e-2 arg-5) e-3)))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-5 arg-6) (cons arg-5 (vector 0 e-3 e-4))))) ((equal? sc1 1) (vector 0 (vector 0 arg-5 arg-6))) (else (vector 1 (cons (vector 0 e-3 e-4) (cons e-3 (vector 0 arg-5 arg-6)))))))))) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 3))) (let ((sc1 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-10)))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-9))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-10 e-11)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-12 (cdr e-5))) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (vector 0 (vector 2 e-8 e-14 e-13 e-10 e-11))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-11))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-9 e-10 e-2)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-12 (cdr e-5))) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (vector 0 (vector 2 e-9 e-10 e-8 e-14 e-13))))))))))))))))) (else (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (let ((e-19 (vector-ref arg-7 4))) (let ((e-20 (vector-ref arg-7 5))) (let ((sc1 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-17)))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-16))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-17 e-18 e-19 e-20)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-12 e-13) (cons e-17 (vector 1 e-18 e-19 e-20))))))))))))) (else (let ((sc2 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-19)))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-18))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-16 e-17 e-2 e-19 e-20)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (cons (vector 1 e-16 e-17 e-8) (cons e-12 (vector 1 e-13 e-19 e-20))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-20))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-16 e-17 e-18 e-19 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (cons (vector 1 e-16 e-17 e-18) (cons e-19 (vector 1 e-8 e-12 e-13)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-treeInsert (lambda (arg-4 arg-5 arg-6 arg-7) (let ((sc0 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 arg-7))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45SortedMap-treeDelete (lambda (arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-4 0) (let ((e-4 (vector-ref arg-6 1))) (let ((e-5 (vector-ref arg-6 2))) (let ((sc2 (let ((e-1 (vector-ref arg-3 0))) (let ((e-12 (car e-1))) ((e-12 arg-5) e-4))))) (cond ((equal? sc2 1) (vector 1 0)) (else (vector 0 (vector 0 e-4 e-5))))))))(else (let ((e-0 (- arg-4 1))) (cond ((equal? e-0 0) (case (vector-ref arg-6 0) ((1) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((sc2 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-12)))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-11))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-2 e-12 e-13)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 1 e-13)))))))) (else (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-13))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-11 e-12 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 1 e-11)))))))))))))) (else (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (let ((e-21 (vector-ref arg-6 4))) (let ((e-22 (vector-ref arg-6 5))) (let ((sc2 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-19)))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-18))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-2 e-19 e-20 e-21 e-22)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 0 (vector 1 e-20 e-21 e-22))))))))) (else (let ((sc3 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-21)))) (cond ((equal? sc3 1) (let ((sc4 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-20))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-18 e-19 e-2 e-21 e-22)))) (else (let ((e-5 (vector-ref sc4 1))) (cond (else (vector 0 (vector 1 e-18 e-19 e-22))))))))) (else (let ((sc4 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-22))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-18 e-19 e-20 e-21 e-2)))) (else (let ((e-5 (vector-ref sc4 1))) (cond (else (vector 0 (vector 1 e-18 e-19 e-20))))))))))))))))))))))(else (let ((e-6 (- e-0 1))) (case (vector-ref arg-6 0) ((1) (let ((e-27 (vector-ref arg-6 1))) (let ((e-28 (vector-ref arg-6 2))) (let ((e-29 (vector-ref arg-6 3))) (let ((sc1 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-28)))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ 1 e-6) arg-5 e-27))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-28 e-29)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-29 0) ((1) (let ((e-4 (vector-ref e-29 1))) (let ((e-8 (vector-ref e-29 2))) (let ((e-7 (vector-ref e-29 3))) (vector 1 (vector 2 e-5 e-28 e-4 e-8 e-7)))))) (else (let ((e-11 (vector-ref e-29 1))) (let ((e-12 (vector-ref e-29 2))) (let ((e-13 (vector-ref e-29 3))) (let ((e-14 (vector-ref e-29 4))) (let ((e-15 (vector-ref e-29 5))) (vector 0 (LibrariesC-45DataC-45SortedMap-branch4 e-5 e-28 e-11 e-12 e-13 e-14 e-15)))))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ 1 e-6) arg-5 e-29))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-27 e-28 e-2)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-27 0) ((1) (let ((e-4 (vector-ref e-27 1))) (let ((e-8 (vector-ref e-27 2))) (let ((e-7 (vector-ref e-27 3))) (vector 1 (vector 2 e-4 e-8 e-7 e-28 e-5)))))) (else (let ((e-11 (vector-ref e-27 1))) (let ((e-12 (vector-ref e-27 2))) (let ((e-13 (vector-ref e-27 3))) (let ((e-14 (vector-ref e-27 4))) (let ((e-15 (vector-ref e-27 5))) (vector 0 (LibrariesC-45DataC-45SortedMap-branch4 e-11 e-12 e-13 e-14 e-15 e-28 e-5)))))))))))))))))))) (else (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (let ((e-38 (vector-ref arg-6 5))) (let ((sc1 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-35)))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ 1 e-6) arg-5 e-34))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-35 e-36 e-37 e-38)))) (else (let ((e-5 (vector-ref sc2 1))) (vector 0 (LibrariesC-45DataC-45SortedMap-merge1 e-5 e-35 e-36 e-37 e-38))))))) (else (let ((sc2 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-37)))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ 1 e-6) arg-5 e-36))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-34 e-35 e-2 e-37 e-38)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45SortedMap-merge2 e-34 e-35 e-5 e-37 e-38))))))) (else (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ 1 e-6) arg-5 e-38))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-34 e-35 e-36 e-37 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45SortedMap-merge3 e-34 e-35 e-36 e-37 e-5)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-toList (lambda (arg-2) (case (vector-ref arg-2 0) ((0) '()) (else (let ((e-7 (vector-ref arg-2 3))) (LibrariesC-45DataC-45SortedMap-treeToList e-7))))))
(define LibrariesC-45DataC-45SortedMap-singleton (lambda (arg-2 arg-3 arg-4) (LibrariesC-45DataC-45SortedMap-insert arg-3 arg-4 (LibrariesC-45DataC-45SortedMap-empty arg-2))))
(define LibrariesC-45DataC-45SortedMap-mergeWith (lambda (arg-2 arg-3 arg-4) (LibrariesC-45DataC-45SortedMap-insertFrom (csegen-51) (LibrariesC-45DataC-45SortedMap-n--7261-4795-u--inserted arg-4 arg-3 arg-2) arg-3)))
(define LibrariesC-45DataC-45SortedMap-mergeLeft (lambda (ext-0 ext-1) (LibrariesC-45DataC-45SortedMap-mergeWith (lambda (eta-0) (lambda (eta-1) eta-0)) ext-0 ext-1)))
(define LibrariesC-45DataC-45SortedMap-merge3 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-4 0) ((1) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (case (vector-ref arg-6 0) ((1) (let ((e-20 (vector-ref arg-6 1))) (let ((e-21 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 3))) (LibrariesC-45DataC-45SortedMap-branch5 e-4 e-5 e-6 arg-5 e-20 e-21 e-22 arg-7 arg-8))))) (else (let ((e-27 (vector-ref arg-6 1))) (let ((e-28 (vector-ref arg-6 2))) (let ((e-29 (vector-ref arg-6 3))) (let ((e-30 (vector-ref arg-6 4))) (let ((e-31 (vector-ref arg-6 5))) (LibrariesC-45DataC-45SortedMap-branch6 e-4 e-5 e-6 arg-5 e-27 e-28 e-29 e-30 e-31 arg-7 arg-8)))))))))))) (else (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (let ((e-15 (vector-ref arg-4 5))) (case (vector-ref arg-6 0) ((1) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (LibrariesC-45DataC-45SortedMap-branch6 e-11 e-12 e-13 e-14 e-15 arg-5 e-36 e-37 e-38 arg-7 arg-8))))) (else (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (let ((e-45 (vector-ref arg-6 3))) (let ((e-46 (vector-ref arg-6 4))) (let ((e-47 (vector-ref arg-6 5))) (LibrariesC-45DataC-45SortedMap-branch7 e-11 e-12 e-13 e-14 e-15 arg-5 e-43 e-44 e-45 e-46 e-47 arg-7 arg-8)))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-merge2 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-4 0) ((1) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (case (vector-ref arg-8 0) ((1) (let ((e-20 (vector-ref arg-8 1))) (let ((e-21 (vector-ref arg-8 2))) (let ((e-22 (vector-ref arg-8 3))) (LibrariesC-45DataC-45SortedMap-branch5 e-4 e-5 e-6 arg-5 arg-6 arg-7 e-20 e-21 e-22))))) (else (let ((e-27 (vector-ref arg-8 1))) (let ((e-28 (vector-ref arg-8 2))) (let ((e-29 (vector-ref arg-8 3))) (let ((e-30 (vector-ref arg-8 4))) (let ((e-31 (vector-ref arg-8 5))) (LibrariesC-45DataC-45SortedMap-branch6 e-4 e-5 e-6 arg-5 arg-6 arg-7 e-27 e-28 e-29 e-30 e-31)))))))))))) (else (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (let ((e-15 (vector-ref arg-4 5))) (case (vector-ref arg-8 0) ((1) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (LibrariesC-45DataC-45SortedMap-branch6 e-11 e-12 e-13 e-14 e-15 arg-5 arg-6 arg-7 e-36 e-37 e-38))))) (else (let ((e-43 (vector-ref arg-8 1))) (let ((e-44 (vector-ref arg-8 2))) (let ((e-45 (vector-ref arg-8 3))) (let ((e-46 (vector-ref arg-8 4))) (let ((e-47 (vector-ref arg-8 5))) (LibrariesC-45DataC-45SortedMap-branch7 e-11 e-12 e-13 e-14 e-15 arg-5 arg-6 arg-7 e-43 e-44 e-45 e-46 e-47)))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-merge1 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-6 0) ((1) (let ((e-4 (vector-ref arg-6 1))) (let ((e-5 (vector-ref arg-6 2))) (let ((e-6 (vector-ref arg-6 3))) (case (vector-ref arg-8 0) ((1) (let ((e-20 (vector-ref arg-8 1))) (let ((e-21 (vector-ref arg-8 2))) (let ((e-22 (vector-ref arg-8 3))) (LibrariesC-45DataC-45SortedMap-branch5 arg-4 arg-5 e-4 e-5 e-6 arg-7 e-20 e-21 e-22))))) (else (let ((e-27 (vector-ref arg-8 1))) (let ((e-28 (vector-ref arg-8 2))) (let ((e-29 (vector-ref arg-8 3))) (let ((e-30 (vector-ref arg-8 4))) (let ((e-31 (vector-ref arg-8 5))) (LibrariesC-45DataC-45SortedMap-branch6 arg-4 arg-5 e-4 e-5 e-6 arg-7 e-27 e-28 e-29 e-30 e-31)))))))))))) (else (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (let ((e-15 (vector-ref arg-6 5))) (case (vector-ref arg-8 0) ((1) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (LibrariesC-45DataC-45SortedMap-branch6 arg-4 arg-5 e-11 e-12 e-13 e-14 e-15 arg-7 e-36 e-37 e-38))))) (else (let ((e-43 (vector-ref arg-8 1))) (let ((e-44 (vector-ref arg-8 2))) (let ((e-45 (vector-ref arg-8 3))) (let ((e-46 (vector-ref arg-8 4))) (let ((e-47 (vector-ref arg-8 5))) (LibrariesC-45DataC-45SortedMap-branch7 arg-4 arg-5 e-11 e-12 e-13 e-14 e-15 arg-7 e-43 e-44 e-45 e-46 e-47)))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-lookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) '()) (else (let ((e-5 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 3))) (LibrariesC-45DataC-45SortedMap-treeLookup e-5 arg-2 e-7)))))))
(define LibrariesC-45DataC-45SortedMap-keys (lambda (ext-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (LibrariesC-45DataC-45SortedMap-toList ext-0))))
(define LibrariesC-45DataC-45SortedMap-insertFrom (lambda (arg-3 ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (let ((e-2 (vector-ref arg-3 1))) (((((e-2 'erased) 'erased) (csegen-459)) eta-0) clam-0)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45SortedMap-insert (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (vector 1 e-2 0 (vector 0 arg-2 arg-3)))) (else (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (LibrariesC-45DataC-45SortedMap-treeInsert e-5 arg-2 arg-3 e-7))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (vector 1 e-5 e-6 e-2))) (else (let ((e-8 (vector-ref sc1 1))) (vector 1 e-5 (+ 1 e-6) e-8))))))))))))
(define LibrariesC-45DataC-45SortedMap-fromList (lambda (arg-2 arg-3) (PreludeC-45Types-u--foldl_Foldable_List (csegen-459) (LibrariesC-45DataC-45SortedMap-empty arg-2) arg-3)))
(define LibrariesC-45DataC-45SortedMap-empty (lambda (arg-2) (vector 0 arg-2)))
(define LibrariesC-45DataC-45SortedMap-delete (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (cond ((equal? e-6 0) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeDelete e-5 0 arg-2 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 1 e-5 0 e-2))) (else (let ((e-8 (vector-ref sc2 1))) (cond (else (vector 0 e-5))))))))(else (let ((e-8 (- e-6 1))) (let ((sc1 (LibrariesC-45DataC-45SortedMap-treeDelete e-5 (+ 1 e-8) arg-2 e-7))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (vector 1 e-5 (+ 1 e-8) e-2))) (else (let ((e-9 (vector-ref sc1 1))) (vector 1 e-5 e-8 e-9)))))))))))))))
(define LibrariesC-45DataC-45SortedMap-branch7 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (vector 2 (vector 2 arg-4 arg-5 arg-6 arg-7 arg-8) arg-9 (vector 1 arg-10 arg-11 arg-12) arg-13 (vector 1 arg-14 arg-15 arg-16))))
(define LibrariesC-45DataC-45SortedMap-branch6 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (vector 2 (vector 1 arg-4 arg-5 arg-6) arg-7 (vector 1 arg-8 arg-9 arg-10) arg-11 (vector 1 arg-12 arg-13 arg-14))))
(define LibrariesC-45DataC-45SortedMap-branch5 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 1 (vector 1 arg-4 arg-5 arg-6) arg-7 (vector 2 arg-8 arg-9 arg-10 arg-11 arg-12))))
(define LibrariesC-45DataC-45SortedMap-branch4 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (vector 1 (vector 1 arg-4 arg-5 arg-6) arg-7 (vector 1 arg-8 arg-9 arg-10))))
(define LibrariesC-45DataC-45SortedMap-adjust (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45SortedMap-lookup arg-2 arg-4))) (if (null? sc0) arg-4 (let ((e-2 (unbox sc0))) (LibrariesC-45DataC-45SortedMap-insert arg-2 (arg-3 e-2) arg-4))))))
(define LibrariesC-45DataC-45IOArray-n--3139-1120-u--iter (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-4 arg-5))) (cond ((equal? sc0 1) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (PreludeC-45TypesC-45List-reverse arg-6)))))) (else (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45IOArray-readArray arg-2 arg-3 arg-4)) (lambda (u--el) (LibrariesC-45DataC-45IOArray-n--3139-1120-u--iter arg-2 arg-3 (bs+ arg-4 1 63) arg-5 (cons u--el arg-6)))))))))))
(define LibrariesC-45DataC-45IOArray-n--2969-956-u--copyFrom (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-7 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) 0))))) (else (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (vector-ref arg-5 arg-7))))) (lambda (u--el) (PreludeC-45Interfaces-C-62C-62 (let ((e-7 (car arg-2))) e-7) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (vector-set! arg-6 arg-7 u--el)))) (lambda () (LibrariesC-45DataC-45IOArray-n--2969-956-u--copyFrom arg-2 arg-3 arg-4 arg-5 arg-6 (bs- arg-7 1 63)))))))))))))
(define LibrariesC-45DataC-45IOArray-writeArray (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-4 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-4 (LibrariesC-45DataC-45IOArray-max arg-3))))))) (cond ((equal? sc0 1) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) 0))))) (else (let ((e-2 (cdr arg-2))) ((e-2 'erased) (lambda (eta-0) (vector-set! (let ((e-3 (cdr arg-3))) e-3) arg-4 (box arg-5))))))))))
(define LibrariesC-45DataC-45IOArray-toList (lambda (arg-2 arg-3) (LibrariesC-45DataC-45IOArray-n--3139-1120-u--iter arg-2 arg-3 0 (LibrariesC-45DataC-45IOArray-max arg-3) '())))
(define LibrariesC-45DataC-45IOArray-readArray (lambda (arg-2 arg-3 arg-4) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-4 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-4 (LibrariesC-45DataC-45IOArray-max arg-3))))))) (cond ((equal? sc0 1) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) '()))))) (else (let ((e-2 (cdr arg-2))) ((e-2 'erased) (lambda (eta-0) (vector-ref (let ((e-3 (cdr arg-3))) e-3) arg-4)))))))))
(define LibrariesC-45DataC-45IOArray-newArrayCopy (lambda (arg-2 arg-3 arg-4) (let ((u--newsizeC-39 (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-3 (LibrariesC-45DataC-45IOArray-max arg-4)))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45IOArray-max arg-4)) (else arg-3))))) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45IOArray-newArray arg-2 u--newsizeC-39)) (lambda (u--arrC-39) (PreludeC-45Interfaces-C-62C-62 (let ((e-7 (car arg-2))) e-7) (LibrariesC-45DataC-45IOArray-n--2969-956-u--copyFrom arg-2 arg-4 arg-3 (let ((e-6 (cdr arg-4))) e-6) (let ((e-6 (cdr u--arrC-39))) e-6) (bs- (LibrariesC-45DataC-45IOArray-max arg-4) (blodwen-toSignedInt 1 63) 63)) (lambda () (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) u--arrC-39)))))))))))))
(define LibrariesC-45DataC-45IOArray-newArray (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (make-vector arg-3 '()))))) (lambda (bind-0) (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (cons arg-3 bind-0)))))))))))
(define LibrariesC-45DataC-45IOArray-max (lambda (ext-0) (let ((e-1 (car ext-0))) e-1)))
(define CoreC-45TTC-n--12272-6250-u--fromBuf3 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 18) (vector 1 (vector 23 ))) ((equal? e-5 100) (vector 1 (vector 37 )))(else (CoreC-45BinaryC-45Prims-corrupt "PrimFn 3" ext-0)))))))))
(define CoreC-45TTC-n--12272-6249-u--fromBuf2 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-6))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 e-6))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-6))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-6))))))) ((equal? e-5 6) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 11 e-6))))))) ((equal? e-5 7) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 12 e-6))))))) ((equal? e-5 8) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 13 e-6))))))) ((equal? e-5 9) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 14 e-6))))))) ((equal? e-5 10) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 15 e-6))))))) ((equal? e-5 14) (vector 1 (vector 19 ))) ((equal? e-5 15) (vector 1 (vector 20 ))) ((equal? e-5 16) (vector 1 (vector 21 ))) ((equal? e-5 21) (vector 1 (vector 26 ))) ((equal? e-5 35) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 6 e-6))))))) ((equal? e-5 36) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 7 e-6))))))) ((equal? e-5 37) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 e-6))))))) ((equal? e-5 38) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-6))))))) ((equal? e-5 39) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 10 e-6))))))) ((equal? e-5 101) (vector 1 (vector 38 )))(else (CoreC-45BinaryC-45Prims-corrupt "PrimFn 2" ext-0)))))))))
(define CoreC-45TTC-n--12272-6248-u--fromBuf1 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 5) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-6))))))) ((equal? e-5 11) (vector 1 (vector 16 ))) ((equal? e-5 12) (vector 1 (vector 17 ))) ((equal? e-5 13) (vector 1 (vector 18 ))) ((equal? e-5 17) (vector 1 (vector 22 ))) ((equal? e-5 19) (vector 1 (vector 24 ))) ((equal? e-5 20) (vector 1 (vector 25 ))) ((equal? e-5 22) (vector 1 (vector 27 ))) ((equal? e-5 23) (vector 1 (vector 28 ))) ((equal? e-5 24) (vector 1 (vector 29 ))) ((equal? e-5 25) (vector 1 (vector 30 ))) ((equal? e-5 26) (vector 1 (vector 31 ))) ((equal? e-5 27) (vector 1 (vector 32 ))) ((equal? e-5 32) (vector 1 (vector 33 ))) ((equal? e-5 33) (vector 1 (vector 34 ))) ((equal? e-5 34) (vector 1 (vector 35 ))) ((equal? e-5 99) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 36 e-6 e-7)))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "PrimFn 1" ext-0)))))))))
(define CoreC-45TTC-n--16704-10230-u--cwName (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((6) 1) ((7) 1)(else 0))))
(define CoreC-45TTC-u--toBuf_TTC_Visibility (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_VirtualIdent (lambda (arg-0 arg-1 ext-0) (cond (else (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_UseSide (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_TypeFlags (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-0 (car arg-1))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-1 (cdr arg-1))) e-1)) ext-0))))))
(define CoreC-45TTC-u--toBuf_TTC_Transform (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-0 arg-0 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((act-27 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 e-0 arg-0 e-3) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 e-0 arg-0 e-4) ext-0))))))))))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_Totality (lambda (arg-0 arg-1 ext-0) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((act-24 (CoreC-45TTC-u--toBuf_TTC_Terminating arg-0 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Covering arg-0 e-1 ext-0))))))))
(define CoreC-45TTC-u--toBuf_TTC_TotalReq (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_Terminating (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PartialReason arg-0 e-0 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_SizeChange (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_SCCall (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-0 (car arg-1))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-462) arg-0 (let ((e-1 (cdr arg-1))) e-1) ext-0))))))
(define CoreC-45TTC-u--toBuf_TTC_RigCount (lambda (arg-0 ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) (lambda (eta-0) (CoreC-45BinaryC-45Prims-tag arg-0 0 eta-0)) (lambda (eta-0) (CoreC-45BinaryC-45Prims-tag arg-0 1 eta-0)) (lambda (eta-0) (lambda (eta-1) (CoreC-45BinaryC-45Prims-tag arg-0 2 eta-1))) ext-0)))
(define CoreC-45TTC-u--toBuf_TTC_RewriteNames (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-0 (car arg-1))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-1 (cdr arg-1))) e-1)) ext-0))))))
(define CoreC-45TTC-u--toBuf_TTC_PrimNames (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 (let ((e-3 (vector-ref arg-1 3))) e-3)) ext-0))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_PartialReason (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-0 ext-0)))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-1 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_PairNames (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_PMDefInfo (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45TTC-u--toBuf_TTC_HoleInfo arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_OriginDesc (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_ModuleIdent arg-0 e-0 ext-0)))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-1) ext-0)))))) (else (let ((e-2 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (CoreC-45TTC-u--toBuf_TTC_VirtualIdent arg-0 e-2 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_Namespace (lambda (arg-0 ext-0 ext-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 (CoreC-45NameC-45Namespace-unsafeUnfoldNamespace ext-0) ext-1)))
(define CoreC-45TTC-u--toBuf_TTC_NameType (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((2) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-1) ext-0)))))))))) (else (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-3) ext-0)))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_Name (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_Namespace arg-0 e-0 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-1) clam-0)))))))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-16 (vector-ref e-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-16) clam-0)))))) ((1) (let ((e-17 (vector-ref e-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-17) clam-0)))))) (else (CoreC-45BinaryC-45Prims-tag arg-0 9 clam-0))))) ((2) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-4) clam-0)))))))))) ((3) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-6) clam-0)))))))))) ((4) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-7) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-8) clam-0)))))))))) ((5) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 e-9 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-10) clam-0)))))))))) ((6) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-11) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-12) clam-0)))))))))) ((7) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 8 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-13) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-14) clam-0)))))))))) (else (let ((e-15 (vector-ref arg-1 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't write resolved name " (PreludeC-45Show-u--show_Show_Int e-15))) clam-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_ModuleIdent (lambda (arg-0 ext-0 ext-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 (CoreC-45NameC-45Namespace-unsafeUnfoldModuleIdent ext-0) ext-1)))
(define CoreC-45TTC-u--toBuf_TTC_LazyReason (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_HoleInfo (lambda (arg-0 arg-1 ext-0) (if (null? arg-1) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0) (let ((e-0 (unbox arg-1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-0) ext-0))))))))
(define CoreC-45TTC-u--toBuf_TTC_GlobalDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-30) arg-0 (let ((e-18 (vector-ref arg-1 18))) e-18)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-33) arg-0 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45DataC-45NameMap-toList eta-0)) (let ((e-13 (vector-ref arg-1 13))) e-13))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 (let ((e-22 (vector-ref arg-1 7))) e-22)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-33) arg-0 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45DataC-45NameMap-toList eta-0)) (let ((e-12 (vector-ref arg-1 12))) e-12))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45TTC-u--toBuf_TTC_Def arg-0 (let ((e-17 (vector-ref arg-1 17))) e-17) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((sc7 (let ((sc8 (CoreC-45Name-isUserName (let ((e-1 (vector-ref arg-1 1))) e-1)))) (cond ((equal? sc8 1) 1) (else (CoreC-45TTC-n--16704-10230-u--cwName arg-1 arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1))))))) (cond ((equal? sc7 1) (let ((act-31 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 (let ((e-3 (vector-ref arg-1 3))) e-3) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 (let ((e-4 (vector-ref arg-1 4))) e-4) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 (let ((e-31 (vector-ref arg-1 5))) e-31) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 (let ((e-31 (vector-ref arg-1 6))) e-31) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 (let ((e-30 (vector-ref arg-1 8))) e-30) ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((act-37 (CoreC-45TTC-u--toBuf_TTC_Visibility arg-0 (let ((e-30 (vector-ref arg-1 9))) e-30) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((act-38 (CoreC-45TTC-u--toBuf_TTC_Totality arg-0 (let ((e-30 (vector-ref arg-1 10))) e-30) ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((act-39 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-486) arg-0 (let ((e-30 (vector-ref arg-1 11))) e-30) ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((act-40 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-28 (vector-ref arg-1 14))) e-28)) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((act-41 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-28 (vector-ref arg-1 15))) e-28)) ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-2 (vector-ref act-41 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-489) arg-0 (let ((e-24 (vector-ref arg-1 20))) e-24) ext-0))))))))))))))))))))))))))))))))))) (else (vector 1 0)))))))))))))))))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_FC (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_OriginDesc arg-0 e-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 e-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 e-2 ext-0)))))))))))))) ((1) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_OriginDesc arg-0 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 e-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 e-5 ext-0)))))))))))))) (else (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_DefFlag (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((4) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_TotalReq arg-0 e-0 ext-0)))))) ((5) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) ((6) (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)) ((7) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) ((8) (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)) ((9) (let ((e-2 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 11 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (CoreC-45TTC-u--toBuf_TTC_ConInfo arg-0 e-2 ext-0)))))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 12 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-3) ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_Def (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 5))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_PMDefInfo arg-0 e-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((act-27 (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 e-1 arg-0 e-2 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-492) arg-0 e-4 ext-0)))))))))))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-5) ext-0)))))) ((3) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 e-7 ext-0)))))))))) ((4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Trying to serialise a Builtin") ext-0)) ((5) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (let ((e-12 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-11) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-500) arg-0 e-12) ext-0)))))))))))))) ((6) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((e-15 (vector-ref arg-1 3))) (let ((e-16 (vector-ref arg-1 4))) (let ((e-17 (vector-ref arg-1 5))) (let ((e-18 (vector-ref arg-1 6))) (let ((e-19 (vector-ref arg-1 7))) (let ((e-20 (vector-ref arg-1 8))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-13) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-14) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 e-15 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 e-16 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45TTC-u--toBuf_TTC_TypeFlags arg-0 e-17 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-18 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-19 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-504) arg-0 e-20) ext-0)))))))))))))))))))))))))))))))))) ((7) (let ((e-21 (vector-ref arg-1 1))) (let ((e-22 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-21) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-0 (car e-22))) e-0)) ext-0)))))))))) ((8) (let ((e-23 (vector-ref arg-1 1))) (let ((e-24 (vector-ref arg-1 2))) (let ((e-25 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-23) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-24) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-25) ext-0)))))))))))))) ((9) (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-0 e-26) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-27) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-483) arg-0 e-28 ext-0)))))))))))))) ((10) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_Covering (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-507) arg-0 e-0 ext-0)))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-1 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_Constant (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-0) ext-0)))))) ((5) (let ((e-1 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 e-1 ext-0)))))) ((6) (let ((e-2 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits8 arg-0 e-2) ext-0)))))) ((7) (let ((e-3 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits16 arg-0 e-3) ext-0)))))) ((8) (let ((e-4 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits32 arg-0 e-4) ext-0)))))) ((9) (let ((e-5 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits64 arg-0 e-5) ext-0)))))) ((10) (let ((e-6 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-6) ext-0)))))) ((11) (let ((e-7 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Char arg-0 e-7) ext-0)))))) ((12) (let ((e-8 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Double arg-0 e-8 ext-0)))))) ((13) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) ((14) (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)) ((19) (CoreC-45BinaryC-45Prims-tag arg-0 11 ext-0)) ((20) (CoreC-45BinaryC-45Prims-tag arg-0 12 ext-0)) ((21) (CoreC-45BinaryC-45Prims-tag arg-0 13 ext-0)) ((22) (CoreC-45BinaryC-45Prims-tag arg-0 14 ext-0)) ((23) (CoreC-45BinaryC-45Prims-tag arg-0 15 ext-0)) ((24) (CoreC-45BinaryC-45Prims-tag arg-0 16 ext-0)) ((25) (CoreC-45BinaryC-45Prims-tag arg-0 17 ext-0)) ((26) (CoreC-45BinaryC-45Prims-tag arg-0 18 ext-0)) ((27) (CoreC-45BinaryC-45Prims-tag arg-0 19 ext-0)) ((3) (let ((e-9 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 20 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int32 arg-0 e-9) ext-0)))))) ((4) (let ((e-10 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 21 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int64 arg-0 e-10) ext-0)))))) ((17) (CoreC-45BinaryC-45Prims-tag arg-0 22 ext-0)) ((18) (CoreC-45BinaryC-45Prims-tag arg-0 23 ext-0)) ((1) (let ((e-11 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 24 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int8 arg-0 e-11) ext-0)))))) ((2) (let ((e-12 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 25 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int16 arg-0 e-12) ext-0)))))) ((15) (CoreC-45BinaryC-45Prims-tag arg-0 26 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 27 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_ConInfo (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((equal? arg-1 2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((equal? arg-1 3) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((equal? arg-1 4) (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)) ((equal? arg-1 5) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((equal? arg-1 6) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((equal? arg-1 7) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) ((equal? arg-1 8) (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)) ((equal? arg-1 9) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_CG (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((8) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-0) ext-0)))))) ((4) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((5) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((6) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_CFType (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((7) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((8) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((9) (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)) ((10) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((11) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((12) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) ((13) (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)) ((14) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) ((18) (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)) ((19) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 11 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_CFType arg-0 e-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_CFType arg-0 e-1 ext-0)))))))))) ((20) (let ((e-2 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 12 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (CoreC-45TTC-u--toBuf_TTC_CFType arg-0 e-2 ext-0)))))) ((21) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-510) arg-0 e-4 ext-0)))))))))) ((22) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 14 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-513) arg-0 e-6 ext-0)))))))))) ((15) (CoreC-45BinaryC-45Prims-tag arg-0 15 ext-0)) ((16) (CoreC-45BinaryC-45Prims-tag arg-0 16 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 17 ext-0)) ((4) (CoreC-45BinaryC-45Prims-tag arg-0 18 ext-0)) ((5) (CoreC-45BinaryC-45Prims-tag arg-0 19 ext-0)) ((6) (CoreC-45BinaryC-45Prims-tag arg-0 20 ext-0)) ((17) (CoreC-45BinaryC-45Prims-tag arg-0 21 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 22 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_CDef (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 e-0 arg-0 e-1 ext-0)))))))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-483) arg-0 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-467) arg-0 e-4) ext-0)))))))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-513) arg-0 e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_CFType arg-0 e-7 ext-0)))))))))))))) (else (let ((e-8 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 '() arg-0 e-8 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (lambda (clam-0) (let ((sc1 (PreludeC-45Types-u--C-60_Ord_Nat e-4 (PreludeC-45Types-u--fromInteger_Num_Nat 243)))) (cond ((equal? sc1 1) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 (bs+ 13 (PreludeC-45Cast-u--cast_Cast_Nat_Int e-4) 63) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-41) arg-1 e-3) clam-0))))) (else (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-41) arg-1 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-1 e-4) clam-0)))))))))))))) ((1) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_NameType arg-1 e-8 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-9) eta-0))))))))))) ((2) (let ((e-12 (vector-ref arg-2 2))) (let ((e-14 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-12) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-1)))) arg-1 e-14 eta-0))))))))))) ((3) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 arg-0 arg-1 e-18 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 (cons e-17 arg-0) arg-1 e-19) eta-0))))))))))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (let ((sc1 (CoreC-45TT-getFnArgs (vector 4 e-21 e-22 e-23)))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (lambda (clam-0) (if (null? e-3) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 12 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-3 clam-0))))))) (let ((e-1 (car e-3))) (let ((e-4 (cdr e-3))) (if (null? e-4) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-1) clam-0))))))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 12 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-3 clam-0))))))))))))))))))) ((5) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 5 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-27) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_UseSide arg-1 e-26 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-28) eta-0))))))))))))))) ((6) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 6 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-31 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-32) eta-0))))))))))) ((7) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-35 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-36) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-37) eta-0))))))))))))))) ((8) (let ((e-40 (vector-ref arg-2 2))) (let ((e-41 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 8 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-40 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-41) eta-0))))))))))) ((9) (let ((e-44 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 9 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-44 eta-0))))))) ((10) (lambda (eta-0) (CoreC-45BinaryC-45Prims-tag arg-1 10 eta-0))) (else (lambda (eta-0) (CoreC-45BinaryC-45Prims-tag arg-1 11 eta-0))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40PrimFnC-32C-36nC-41 (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-0 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-0 (- arg-0 1))) (cond ((equal? e-0 0) (lambda (clam-0) (case (vector-ref arg-2 0) ((5) (let ((e-18 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-18 clam-0)))))) ((16) (CoreC-45BinaryC-45Prims-tag arg-1 11 clam-0)) ((17) (CoreC-45BinaryC-45Prims-tag arg-1 12 clam-0)) ((18) (CoreC-45BinaryC-45Prims-tag arg-1 13 clam-0)) ((22) (CoreC-45BinaryC-45Prims-tag arg-1 17 clam-0)) ((24) (CoreC-45BinaryC-45Prims-tag arg-1 19 clam-0)) ((25) (CoreC-45BinaryC-45Prims-tag arg-1 20 clam-0)) ((27) (CoreC-45BinaryC-45Prims-tag arg-1 22 clam-0)) ((28) (CoreC-45BinaryC-45Prims-tag arg-1 23 clam-0)) ((29) (CoreC-45BinaryC-45Prims-tag arg-1 24 clam-0)) ((30) (CoreC-45BinaryC-45Prims-tag arg-1 25 clam-0)) ((31) (CoreC-45BinaryC-45Prims-tag arg-1 26 clam-0)) ((32) (CoreC-45BinaryC-45Prims-tag arg-1 27 clam-0)) ((33) (CoreC-45BinaryC-45Prims-tag arg-1 32 clam-0)) ((34) (CoreC-45BinaryC-45Prims-tag arg-1 33 clam-0)) ((35) (CoreC-45BinaryC-45Prims-tag arg-1 34 clam-0)) (else (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 99 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-19 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-20 clam-0)))))))))))))(else (let ((e-1 (- e-0 1))) (cond ((equal? e-1 0) (lambda (clam-1) (case (vector-ref arg-2 0) ((0) (let ((e-3 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 0 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-3 clam-1)))))) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 1 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-4 clam-1)))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 2 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-5 clam-1)))))) ((3) (let ((e-6 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 3 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-6 clam-1)))))) ((4) (let ((e-7 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 4 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-7 clam-1)))))) ((6) (let ((e-8 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 35 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-8 clam-1)))))) ((7) (let ((e-9 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 36 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-9 clam-1)))))) ((8) (let ((e-10 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 37 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-10 clam-1)))))) ((9) (let ((e-11 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 38 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-11 clam-1)))))) ((10) (let ((e-12 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 39 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-12 clam-1)))))) ((11) (let ((e-13 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 6 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-13 clam-1)))))) ((12) (let ((e-14 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 7 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-14 clam-1)))))) ((13) (let ((e-15 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 8 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-15 clam-1)))))) ((14) (let ((e-16 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 9 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-16 clam-1)))))) ((15) (let ((e-17 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 10 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-17 clam-1)))))) ((19) (CoreC-45BinaryC-45Prims-tag arg-1 14 clam-1)) ((20) (CoreC-45BinaryC-45Prims-tag arg-1 15 clam-1)) ((21) (CoreC-45BinaryC-45Prims-tag arg-1 16 clam-1)) ((26) (CoreC-45BinaryC-45Prims-tag arg-1 21 clam-1)) (else (CoreC-45BinaryC-45Prims-tag arg-1 (blodwen-toSignedInt 101 63) clam-1)))))(else (let ((e-2 (- e-1 1))) (cond ((equal? e-2 0) (lambda (clam-2) (case (vector-ref arg-2 0) ((23) (CoreC-45BinaryC-45Prims-tag arg-1 18 clam-2)) (else (CoreC-45BinaryC-45Prims-tag arg-1 (blodwen-toSignedInt 100 63) clam-2)))))(else (blodwen-error-quit "Nat case not covered"))))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-2 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-2 1 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-2 2 ext-0)) (else (let ((e-4 (vector-ref arg-3 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-2 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-1 (car arg-1))) (((e-1 arg-2) e-4) ext-0))))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-1 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CaseAltC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CaseAltC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-5 ext-0)))))))))))))) ((1) (let ((e-8 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-8) ext-0)))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-1 e-10) ext-0)))))) (else (CoreC-45BinaryC-45Prims-tag arg-1 3 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CaseAltC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-1 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-1 e-3 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-1 e-4 ext-0)))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-7) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (cons e-6 (cons e-7 arg-0)) arg-1 e-8 ext-0)))))))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-10 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 arg-0 arg-1 e-11 ext-0)))))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 arg-0 arg-1 e-13 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-1 e-2) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-7) ext-0)))))))))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-9 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-10) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 (cons e-10 arg-0) arg-1 e-11 ext-0)))))))))))))) ((3) (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((e-15 (vector-ref arg-2 3))) (let ((e-16 (vector-ref arg-2 4))) (let ((e-17 (vector-ref arg-2 5))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-13 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-14) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-1 e-15) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-16 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 (cons e-14 arg-0) arg-1 e-17 ext-0)))))))))))))))))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-19 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-20 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-21 ext-0)))))))))))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-23 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-24) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45TTC-u--toBuf_TTC_ConInfo arg-1 e-25 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-483) arg-1 e-26) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-27 ext-0)))))))))))))))))))))) ((6) (let ((e-29 (vector-ref arg-2 1))) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (let ((e-32 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-30 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-1 e-29) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CoreC-45TTC-u--toBuf_TTC_C-40PrimFnC-32C-36nC-41 e-29 arg-1 e-31) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 e-29 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-32) ext-0)))))))))))))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-34 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-35) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-36 ext-0)))))))))))))) ((8) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-38 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-39 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-40 ext-0)))))))))))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-42 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-43 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-44 ext-0)))))))))))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 10 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-46 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-47 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CConAltC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CConAltC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-48 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-49) ext-0)))))))))))))))))) ((11) (let ((e-51 (vector-ref arg-2 1))) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 11 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-51 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-52 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CConstAltC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CConstAltC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-53 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-54) ext-0)))))))))))))))))) ((12) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 12 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-56 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-57 ext-0)))))))))) ((13) (let ((e-59 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-59 ext-0)))))) (else (let ((e-61 (vector-ref arg-2 1))) (let ((e-62 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 14 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-61 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-1 e-62) ext-0)))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CConstAltC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((act-24 (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-2 ext-0))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CConAltC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-24 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_ConInfo arg-1 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-483) arg-1 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-1 e-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-1 e-5 ext-0))))))))))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-4) ext-0)))))))))))))) ((1) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-8) ext-0)))))))))) ((2) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-12) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-13 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-14) ext-0)))))))))))))) ((3) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-17) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 e-18 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-19) ext-0)))))))))))))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-22) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-23) ext-0)))))))))) (else (let ((e-27 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-1 5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-27) ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-0) (vector 1 0) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (let ((act-24 (CoreC-45TTC-u--toBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 e-3 arg-1 e-8 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-3 arg-1 e-9) clam-0)))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Visibility (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "Visibility" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_VirtualIdent (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0))(else (CoreC-45BinaryC-45Prims-corrupt "VirtualIdent" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_UseSide (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1))(else (CoreC-45BinaryC-45Prims-corrupt "UseSide" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_TypeFlags (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Transform (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-5 arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 e-5 arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 e-5 arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector e-5 e-6 e-7 e-8 e-9))))))))))))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Totality (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_Terminating arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Covering arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_TotalReq (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "TotalReq" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Terminating (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_PartialReason arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "Terminating" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_SizeChange (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "SizeChange" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_SCCall (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-462) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_RigCount (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (csegen-517)) ((equal? e-5 1) (csegen-518)) ((equal? e-5 2) (vector 1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))(else (CoreC-45BinaryC-45Prims-corrupt "RigCount" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_RewriteNames (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_PrimNames (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector e-5 e-6 e-7 e-8))))))))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_PartialReason (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 e-6))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "PartialReason" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_PairNames (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector e-5 e-6 e-7))))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_PMDefInfo (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_HoleInfo arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector e-5 e-6 e-7))))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_OriginDesc (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 0 eta-1)))) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_ModuleIdent arg-0 eta-0)) ext-0)) ((equal? e-5 1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 1 eta-1)))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 eta-0)) ext-0)) ((equal? e-5 2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 2 eta-1)))) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_VirtualIdent arg-0 eta-0)) ext-0))(else (CoreC-45BinaryC-45Prims-corrupt "OriginDesc" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Namespace (lambda (ext-0 ext-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CoreC-45NameC-45Namespace-unsafeFoldNamespace e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) ext-0 eta-0)) ext-1)))
(define CoreC-45TTC-u--fromBuf_TTC_NameType (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 e-6 e-7))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 3 e-6 e-7)))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "NameType" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Name (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 0 e-6 e-7))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 (vector 0 e-6)))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 e-6 e-7))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 3 e-6 e-7))))))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 e-6 e-7))))))))))) ((equal? e-5 5) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 (vector 1 e-6)))))))) ((equal? e-5 6) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 5 e-6 e-7))))))))))) ((equal? e-5 7) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 6 e-6 e-7))))))))))) ((equal? e-5 8) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 7 e-6 e-7))))))))))) ((equal? e-5 9) (vector 1 (vector 1 (vector 2 ))))(else (CoreC-45BinaryC-45Prims-corrupt "Name" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_ModuleIdent (lambda (ext-0 ext-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CoreC-45NameC-45Namespace-unsafeFoldModuleIdent e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) ext-0 eta-0)) ext-1)))
(define CoreC-45TTC-u--fromBuf_TTC_LazyReason (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "LazyReason" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_HoleInfo (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 '())) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "HoleInfo" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_GlobalDef (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-30) arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-33) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--refsR (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45DataC-45NameMap-fromList eta-0)) e-6))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-33) arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--refs (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45DataC-45NameMap-fromList eta-0)) e-10))) (let ((act-30 (CoreC-45TTC-u--fromBuf_TTC_Def arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((sc7 (CoreC-45Name-isUserName e-9))) (cond ((equal? sc7 1) (let ((act-31 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-0 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (let ((act-35 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (let ((act-36 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (CoreC-45TTC-u--fromBuf_TTC_Visibility arg-0 ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-37 1))) (let ((act-38 (CoreC-45TTC-u--fromBuf_TTC_Totality arg-0 ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-38 1))) (let ((act-39 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-486) arg-0 ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-39 1))) (let ((act-40 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-40 1))) (let ((act-41 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-2 (vector-ref act-41 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-41 1))) (let ((act-42 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-489) arg-0 ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-2 (vector-ref act-42 1))) (vector 0 e-2))) (else (let ((e-23 (vector-ref act-42 1))) (vector 1 (vector e-7 e-9 e-12 e-13 e-14 e-15 e-16 e-8 e-17 e-18 e-19 e-20 u--refs u--refsR e-21 e-22 1 e-11 e-5 '() e-23 '()))))))))))))))))))))))))))))))))))))))))))))))))))) (else (vector 1 (vector e-7 e-9 (vector 10 e-7 0) '() '() '() '() e-8 '() 2 (CoreC-45TT-unchecked) '() u--refs u--refsR 0 0 1 e-11 e-5 '() '() '())))))))))))))))))))))))))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_FC (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_OriginDesc arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 0 e-6 e-7 e-8))))))))))))))) ((equal? e-5 1) (vector 1 (vector 2 ))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_OriginDesc arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-482) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 1 e-6 e-7 e-8)))))))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "FC" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_DefFlag (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 2) (vector 1 (vector 0 ))) ((equal? e-5 3) (vector 1 (vector 1 ))) ((equal? e-5 4) (vector 1 (vector 2 ))) ((equal? e-5 5) (vector 1 (vector 3 ))) ((equal? e-5 6) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-6))))))) ((equal? e-5 7) (vector 1 (vector 5 ))) ((equal? e-5 8) (vector 1 (vector 6 ))) ((equal? e-5 9) (vector 1 (vector 7 '()))) ((equal? e-5 10) (vector 1 (vector 8 ))) ((equal? e-5 11) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_ConInfo arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-6))))))) ((equal? e-5 12) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 10 e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "DefFlag" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Def (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_PMDefInfo arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 e-7 arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-492) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 1 e-6 e-7 e-8 (vector 2 "") e-9))))))))))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 3 e-6 e-7))))))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-500) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 5 e-6 e-7 e-8))))))))))))))) ((equal? e-5 5) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-467) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45TTC-u--fromBuf_TTC_TypeFlags arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-504) arg-0 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (vector 1 (vector 6 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13))))))))))))))))))))))))))))))))))) ((equal? e-5 6) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 7 e-6 (CoreC-45ContextC-45Context-holeInit e-7)))))))))))) ((equal? e-5 7) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 8 e-6 e-7 e-8))))))))))))))) ((equal? e-5 8) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-483) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 9 e-6 e-7 e-8))))))))))))))) ((equal? e-5 9) (vector 1 (vector 10 ))) ((equal? e-5 10) (vector 1 (vector 11 )))(else (CoreC-45BinaryC-45Prims-corrupt "Def" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Covering (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-507) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 e-6))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "Covering" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_Constant (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-6))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-6))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits8 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 6 e-6))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits16 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 7 e-6))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits32 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 e-6))))))) ((equal? e-5 5) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits64 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-6))))))) ((equal? e-5 6) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 10 e-6))))))) ((equal? e-5 7) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Char arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 11 e-6))))))) ((equal? e-5 8) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Double arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 12 e-6))))))) ((equal? e-5 9) (vector 1 (vector 13 ))) ((equal? e-5 10) (vector 1 (vector 14 ))) ((equal? e-5 11) (vector 1 (vector 19 ))) ((equal? e-5 12) (vector 1 (vector 20 ))) ((equal? e-5 13) (vector 1 (vector 21 ))) ((equal? e-5 14) (vector 1 (vector 22 ))) ((equal? e-5 15) (vector 1 (vector 23 ))) ((equal? e-5 16) (vector 1 (vector 24 ))) ((equal? e-5 17) (vector 1 (vector 25 ))) ((equal? e-5 18) (vector 1 (vector 26 ))) ((equal? e-5 19) (vector 1 (vector 27 ))) ((equal? e-5 20) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int32 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-6))))))) ((equal? e-5 21) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int64 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-6))))))) ((equal? e-5 22) (vector 1 (vector 17 ))) ((equal? e-5 23) (vector 1 (vector 18 ))) ((equal? e-5 24) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int8 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 e-6))))))) ((equal? e-5 25) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int16 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6))))))) ((equal? e-5 26) (vector 1 (vector 15 ))) ((equal? e-5 27) (vector 1 (vector 16 )))(else (CoreC-45BinaryC-45Prims-corrupt "Constant" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_ConInfo (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2)) ((equal? e-5 3) (vector 1 3)) ((equal? e-5 4) (vector 1 4)) ((equal? e-5 5) (vector 1 5)) ((equal? e-5 6) (vector 1 6)) ((equal? e-5 7) (vector 1 7)) ((equal? e-5 8) (vector 1 8)) ((equal? e-5 9) (vector 1 9)) ((equal? e-5 10) (vector 1 10))(else (CoreC-45BinaryC-45Prims-corrupt "ConInfo" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_CG (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 2 ))) ((equal? e-5 3) (vector 1 (vector 3 ))) ((equal? e-5 4) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 e-6))))))) ((equal? e-5 5) (vector 1 (vector 4 ))) ((equal? e-5 6) (vector 1 (vector 5 ))) ((equal? e-5 7) (vector 1 (vector 6 ))) ((equal? e-5 8) (vector 1 (vector 7 )))(else (CoreC-45BinaryC-45Prims-corrupt "CG" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_CFType (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 7 ))) ((equal? e-5 3) (vector 1 (vector 8 ))) ((equal? e-5 4) (vector 1 (vector 9 ))) ((equal? e-5 5) (vector 1 (vector 10 ))) ((equal? e-5 6) (vector 1 (vector 11 ))) ((equal? e-5 7) (vector 1 (vector 12 ))) ((equal? e-5 8) (vector 1 (vector 13 ))) ((equal? e-5 9) (vector 1 (vector 14 ))) ((equal? e-5 10) (vector 1 (vector 18 ))) ((equal? e-5 11) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_CFType arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_CFType arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 19 e-6 e-7))))))))))) ((equal? e-5 12) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_CFType arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 20 e-6))))))) ((equal? e-5 13) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-510) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 21 e-6 e-7))))))))))) ((equal? e-5 14) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-513) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 22 e-6 e-7))))))))))) ((equal? e-5 15) (vector 1 (vector 15 ))) ((equal? e-5 16) (vector 1 (vector 16 ))) ((equal? e-5 17) (vector 1 (vector 3 ))) ((equal? e-5 18) (vector 1 (vector 4 ))) ((equal? e-5 19) (vector 1 (vector 5 ))) ((equal? e-5 20) (vector 1 (vector 6 ))) ((equal? e-5 21) (vector 1 (vector 17 ))) ((equal? e-5 22) (vector 1 (vector 2 )))(else (CoreC-45BinaryC-45Prims-corrupt "CFType" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_CDef (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 e-6 arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 0 e-6 e-7))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-483) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-467) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 1 e-6 e-7 e-8))))))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-513) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_CFType arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 2 e-6 e-7 e-8))))))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 '() arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "CDef" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-41) arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (CoreC-45BinaryC-45Prims-corrupt "Term" eta-0))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) (CoreC-45TTC-getName e-7 arg-0)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (CoreC-45FC-emptyFC) e-6 e-7)))))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_NameType arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 1 (CoreC-45FC-emptyFC) e-6 e-7))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 (CoreC-45FC-emptyFC) e-6 0 e-7))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 (cons e-6 arg-0) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 3 (CoreC-45FC-emptyFC) e-6 e-7 e-8))))))))))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 (CoreC-45FC-emptyFC) e-6 e-7))))))))))) ((equal? e-5 5) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_UseSide arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 5 (CoreC-45FC-emptyFC) e-7 e-6 e-8))))))))))))))) ((equal? e-5 6) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 6 (CoreC-45FC-emptyFC) e-6 e-7))))))))))) ((equal? e-5 7) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) e-6 e-7 e-8))))))))))))))) ((equal? e-5 8) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 8 (CoreC-45FC-emptyFC) e-6 e-7))))))))))) ((equal? e-5 9) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 (CoreC-45FC-emptyFC) e-6))))))) ((equal? e-5 10) (vector 1 (vector 10 (CoreC-45FC-emptyFC) 0))) ((equal? e-5 11) (vector 1 (vector 11 (CoreC-45FC-emptyFC)))) ((equal? e-5 12) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-apply (CoreC-45FC-emptyFC) e-6 e-7)))))))))))(else (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-41) arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--idx (PreludeC-45Types-u--fromInteger_Num_Nat (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- e-5 13 63))))) (let ((sc2 (CoreC-45TTC-getName u--idx arg-0))) (if (null? sc2) (CoreC-45BinaryC-45Prims-corrupt "Term" ext-0) (vector 1 (vector 0 (CoreC-45FC-emptyFC) e-6 u--idx)))))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40PrimFnC-32C-36nC-41 (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (lambda (eta-0) (CoreC-45BinaryC-45Prims-corrupt "PrimFn" eta-0)))(else (let ((e-0 (- arg-0 1))) (cond ((equal? e-0 0) (lambda (eta-0) (CoreC-45TTC-n--12272-6248-u--fromBuf1 arg-1 arg-0 eta-0)))(else (let ((e-1 (- e-0 1))) (cond ((equal? e-1 0) (lambda (eta-0) (CoreC-45TTC-n--12272-6249-u--fromBuf2 arg-1 arg-0 eta-0)))(else (let ((e-2 (- e-1 1))) (lambda (clam-0) (cond ((equal? e-2 0) (CoreC-45TTC-n--12272-6250-u--fromBuf3 arg-1 arg-0 clam-0))(else (CoreC-45BinaryC-45Prims-corrupt "PrimFn" clam-0)))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 2 ))) ((equal? e-5 3) (let ((act-25 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) ext-0)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "PiInfo" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CaseAltC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CaseAltC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 0 e-6 e-7 (vector 10 (CoreC-45FC-emptyFC) 0) e-8))))))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 0 e-6))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6))))))) ((equal? e-5 3) (vector 1 (vector 3 )))(else (CoreC-45BinaryC-45Prims-corrupt "CaseTree" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CaseAltC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-0) arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 0 e-6 e-7 e-8 e-9))))))))))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (cons e-6 (cons e-7 arg-0)) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 1 e-6 e-7 e-8))))))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 e-6 e-7))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "CaseAlt" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc4 (CoreC-45TTC-getName e-7 arg-0))) (if (null? sc4) (CoreC-45BinaryC-45Prims-corrupt "CExp" ext-0) (vector 1 (vector 0 e-7 e-6))))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 1 e-6 e-7))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 (cons e-7 arg-0) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 2 e-6 e-7 e-8))))))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 (cons e-7 arg-0) arg-1 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (vector 3 e-6 e-7 e-8 e-9 e-10))))))))))))))))))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 4 e-6 e-7 e-8))))))))))))))) ((equal? e-5 5) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_ConInfo arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-483) arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (vector 5 e-6 e-7 e-8 e-9 e-10))))))))))))))))))))))) ((equal? e-5 6) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45TTC-u--fromBuf_TTC_C-40PrimFnC-32C-36nC-41 e-7 arg-1) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 e-7 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 6 e-7 e-6 e-8 e-9))))))))))))))))))) ((equal? e-5 7) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 7 e-6 e-7 e-8))))))))))))))) ((equal? e-5 8) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 8 e-6 e-7 e-8))))))))))))))) ((equal? e-5 9) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 9 e-6 e-7 e-8))))))))))))))) ((equal? e-5 10) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CConAltC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CConAltC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 10 e-6 e-7 e-8 e-9))))))))))))))))))) ((equal? e-5 11) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CConstAltC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CConstAltC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2370 arg-2373 eta-0)))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 11 e-6 e-7 e-8 e-9))))))))))))))))))) ((equal? e-5 12) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 12 e-6 e-7))))))))))) ((equal? e-5 13) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 13 e-6))))))) ((equal? e-5 14) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 14 e-6 e-7)))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "CExp" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CConstAltC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CConAltC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_ConInfo arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-483) arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-0) arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector e-5 e-6 e-7 e-8 e-9))))))))))))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 0 (CoreC-45FC-emptyFC) e-6 e-7 e-8))))))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 1 (CoreC-45FC-emptyFC) e-6 e-7 (vector 10 (CoreC-45FC-emptyFC) 0)))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 2 (CoreC-45FC-emptyFC) e-6 e-7 e-8))))))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-2370) (lambda (arg-2373) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2370 arg-2373))) (lambda (arg-2375) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-2375 eta-0)))) arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 3 (CoreC-45FC-emptyFC) e-6 e-7 e-8))))))))))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 (CoreC-45FC-emptyFC) e-6 e-7 (vector 10 (CoreC-45FC-emptyFC) 0)))))))))))) ((equal? e-5 5) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 (CoreC-45FC-emptyFC) e-6 (vector 10 (CoreC-45FC-emptyFC) 0))))))))(else (CoreC-45BinaryC-45Prims-corrupt "Binder" ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (if (null? arg-0) (vector 1 '()) (let ((e-3 (cdr arg-0))) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 e-3 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-3 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))))
(define CoreC-45TTC-getName (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (if (null? arg-1) '() (let ((e-3 (car arg-1))) (box e-3))))(else (let ((e-1 (- arg-0 1))) (if (null? arg-1) '() (let ((e-7 (cdr arg-1))) (CoreC-45TTC-getName e-1 e-7))))))))
(define CoreC-45Context-decode (lambda (ext-4 ext-1 ext-2 ext-3 ext-0) (case (vector-ref ext-3 0) ((0) (let ((e-0 (vector-ref ext-3 1))) (let ((e-1 (vector-ref ext-3 2))) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_GlobalDef e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--a (CoreC-45Context-getContent ext-4))) (let ((act-26 (let ((act-26 (unbox u--a))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-u--resolved_HasNames_GlobalDef ext-4 (CoreC-45Context-u--restoreNS_StripNamespace_GlobalDef e-0 e-6) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (cond ((equal? ext-2 1) (let ((act-28 ((LibrariesC-45DataC-45IOArray-writeArray (csegen-3) e-7 ext-1 (vector 1 e-8)) ext-0))) (vector 1 act-28))) (else (vector 1 0))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 e-8)))))))))))))))))))))))) (else (let ((e-2 (vector-ref ext-3 1))) (vector 1 e-2))))))
(define LibrariesC-45UtilsC-45Binary-writeToFile (lambda (arg-0 arg-1) (SystemC-45FileC-45Buffer-writeBufferToFile (csegen-3) arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) (let ((e-3 (vector-ref arg-1 3))) e-3))))
(define LibrariesC-45UtilsC-45Binary-toRead (lambda (arg-0) (bs- (let ((e-3 (vector-ref arg-0 3))) e-3) (let ((e-1 (vector-ref arg-0 1))) e-1) 63)))
(define LibrariesC-45UtilsC-45Binary-readFromFile (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45FileC-45Buffer-createBufferFromFile (csegen-3) arg-0) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (let ((act-25 (DataC-45Buffer-prim__bufferSize e-2))) (vector 1 (vector e-2 0 act-25 act-25))))) (else (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5)))))))
(define LibrariesC-45UtilsC-45Binary-newBinary (lambda (arg-0 arg-1) (vector arg-0 0 arg-1 0)))
(define LibrariesC-45UtilsC-45Binary-incLoc (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector e-0 (bs+ e-1 arg-0 63) e-2 e-3)))))))
(define LibrariesC-45UtilsC-45Binary-blockSize(blodwen-lazy (lambda () (blodwen-toSignedInt 655360 63))))
(define LibrariesC-45UtilsC-45Binary-avail (lambda (arg-0) (bs- (bs- (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-1 (vector-ref arg-0 1))) e-1) 63) 1 63)))
(define LibrariesC-45UtilsC-45Binary-appended (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector e-0 (bs+ e-1 arg-0 63) e-2 (bs+ e-3 arg-0 63))))))))
(define DataC-45Vect-case--compare-2082 (lambda (arg-1 arg-3 arg-4 arg-5 arg-6 arg-8) (cond ((equal? arg-8 1) (DataC-45Vect-u--compare_Ord_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 arg-1 arg-4 arg-6))(else arg-8))))
(define DataC-45Vect-n--4418-1435-u--go (lambda (arg-2 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (DataC-45Vect-n--4418-1435-u--go arg-2 (cons e-3 arg-5) e-4))))))
(define DataC-45Vect-u--zipWith_Zippable_C-40VectC-32C-36kC-41 (lambda (arg-4 arg-5 arg-6) (if (null? arg-5) '() (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (let ((e-8 (car arg-6))) (let ((e-9 (cdr arg-6))) (cons ((arg-4 e-3) e-8) (DataC-45Vect-u--zipWith_Zippable_C-40VectC-32C-36kC-41 arg-4 e-4 e-9)))))))))
(define DataC-45Vect-u--unzip_Zippable_C-40VectC-32C-36kC-41 (lambda (ext-0) (DataC-45Vect-u--unzipWith_Zippable_C-40VectC-32C-36kC-41 (lambda (eta-0) eta-0) ext-0)))
(define DataC-45Vect-u--unzipWith_Zippable_C-40VectC-32C-36kC-41 (lambda (arg-4 arg-5) (if (null? arg-5) (cons '() '()) (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (let ((sc1 (arg-4 e-3))) (let ((e-2 (car sc1))) (let ((e-5 (cdr sc1))) (let ((sc2 (DataC-45Vect-u--unzipWith_Zippable_C-40VectC-32C-36kC-41 arg-4 e-4))) (let ((e-7 (car sc2))) (let ((e-6 (cdr sc2))) (cons (cons e-2 e-7) (cons e-5 e-6)))))))))))))
(define DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (lambda (arg-4 arg-5 arg-6) (if (null? arg-6) (let ((e-2 (vector-ref arg-4 1))) ((e-2 'erased) '())) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (let ((e-5 (vector-ref arg-4 2))) ((((e-5 'erased) 'erased) (let ((e-6 (vector-ref arg-4 2))) ((((e-6 'erased) 'erased) (let ((e-10 (vector-ref arg-4 1))) ((e-10 'erased) (csegen-525)))) (arg-5 e-3)))) (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 arg-4 arg-5 e-4))))))))
(define DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 (lambda (ext-0) (DataC-45Vect-u--foldr_Foldable_C-40VectC-32C-36nC-41 (csegen-113) '() ext-0)))
(define DataC-45Vect-u--show_Show_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (lambda (arg-2 ext-0) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-2 (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 ext-0))))
(define DataC-45Vect-u--null_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-2) (if (null? arg-2) (lambda () 1) (lambda () 0))))
(define DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (arg-3 arg-4) (if (null? arg-4) '() (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (cons (arg-3 e-3) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 arg-3 e-4)))))))
(define DataC-45Vect-u--foldr_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-3 arg-4 arg-5) (DataC-45Vect-foldrImpl arg-3 arg-4 (lambda (eta-0) eta-0) arg-5)))
(define DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 arg-3 ((arg-3 arg-4) e-3) e-4))))))
(define DataC-45Vect-u--foldlM_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-5 u--b eta-0)))))) (let ((e-1 (vector-ref arg-4 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-6))) ext-0)))
(define DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-3 arg-4 ext-0) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 (lambda (u--acc) (lambda (u--elem) (let ((e-1 (car arg-3))) ((e-1 u--acc) (arg-4 u--elem))))) (let ((e-2 (cdr arg-3))) e-2) ext-0)))
(define DataC-45Vect-u--compare_Ord_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (lambda (arg-2 arg-3 arg-4) (if (null? arg-3) 1 (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (let ((e-8 (car arg-4))) (let ((e-9 (cdr arg-4))) (DataC-45Vect-case--compare-2082 arg-2 e-3 e-4 e-8 e-9 (let ((e-2 (vector-ref arg-2 1))) ((e-2 e-3) e-8))))))))))
(define DataC-45Vect-u--C-61C-61_Eq_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (lambda (arg-2 arg-3 arg-4) (if (null? arg-3) 1 (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (let ((e-8 (car arg-4))) (let ((e-9 (cdr arg-4))) (let ((sc2 (let ((e-1 (car arg-2))) ((e-1 e-3) e-8)))) (cond ((equal? sc2 1) (DataC-45Vect-u--C-61C-61_Eq_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 arg-2 e-4 e-9)) (else 0))))))))))
(define DataC-45Vect-toVect (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) (if (null? arg-2) (box '()) '()))(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) '() (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-toVect e-0 e-4) (lambda (u--xsC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-3 u--xsC-39))))))))))))
(define DataC-45Vect-tail (lambda (arg-2) (let ((e-3 (cdr arg-2))) e-3)))
(define DataC-45Vect-reverse (lambda (arg-2) (DataC-45Vect-n--4418-1435-u--go arg-2 '() arg-2)))
(define DataC-45Vect-replicate (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (cons arg-2 (DataC-45Vect-replicate e-0 arg-2)))))))
(define DataC-45Vect-replaceAt (lambda (arg-2 arg-3 arg-4) (cond ((equal? arg-2 0) (let ((e-6 (cdr arg-4))) (cons arg-3 e-6)))(else (let ((e-2 (- arg-2 1))) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (cons e-9 (DataC-45Vect-replaceAt e-2 arg-3 e-10)))))))))
(define DataC-45Vect-foldrImpl (lambda (arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (arg-5 arg-4) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (DataC-45Vect-foldrImpl arg-3 arg-4 (lambda (eta-0) (arg-5 ((arg-3 e-3) eta-0))) e-4))))))
(define DataC-45Vect-C-43C-43 (lambda (arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (cons e-3 (DataC-45Vect-C-43C-43 e-4 arg-4)))))))
(define LibrariesC-45DataC-45PosMap-case--merge2-8258 (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45PosMap-split (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-largerC-39 (arg-1 e-2) eta-0)) arg-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (LibrariesC-45DataC-45PosMap-C-43C-43 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) e-5 (LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) e-2 (LibrariesC-45DataC-45PosMap-merge1 arg-1 e-4 e-3)))))))))))
(define LibrariesC-45DataC-45PosMap-case--merge1-8183 (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-2 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45PosMap-split (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-larger (arg-1 e-2) eta-0)) arg-2))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (LibrariesC-45DataC-45PosMap-C-43C-43 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) e-5 (LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) e-2 (LibrariesC-45DataC-45PosMap-merge2 arg-1 e-3 e-4)))))))))))
(define LibrariesC-45DataC-45PosMap-n--4551-2366-u--value (lambda (arg-1 arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-3))) (if (null? sc0) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-4) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2)) (let ((e-0 (unbox sc0))) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-4) e-0) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2)))))))
(define LibrariesC-45DataC-45PosMap-n--10809-8371-u--matches (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((sc0 (LibrariesC-45DataC-45PosMap-viewl arg-1 (LibrariesC-45DataC-45PosMap-dropUntil arg-1 (lambda (eta-0) (LibrariesC-45DataC-45PosMap-atleast arg-4 eta-0)) arg-5)))) (if (null? sc0) '() (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons e-2 (LibrariesC-45DataC-45PosMap-n--10809-8371-u--matches arg-1 arg-2 arg-3 arg-4 e-3))))))))
(define LibrariesC-45DataC-45PosMap-u--toList_Foldable_PosMap (lambda (ext-0) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap (csegen-113) '() ext-0)))
(define LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (lambda (arg-1 arg-2) (LibrariesC-45DataC-45PosMap-u--showPrec_Show_C-40PosMapC-32C-36aC-41 arg-1 (vector 0 ) arg-2)))
(define LibrariesC-45DataC-45PosMap-u--showPrec_Show_C-40PosMapC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45Show-showCon arg-2 "fromList" (PreludeC-45Show-showArg (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 arg-1 u--d u--x)))) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap (csegen-113) '() arg-3)))))
(define LibrariesC-45DataC-45PosMap-u--neutral_Monoid_Interval(blodwen-lazy (lambda () '())))
(define LibrariesC-45DataC-45PosMap-u--measure_Measure_NonEmptyFC (lambda (ext-0) (Builtin-snd ext-0)))
(define LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 (lambda (ext-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_NonEmptyFC (Builtin-fst ext-0))))
(define LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) (else (let ((e-5 (vector-ref arg-1 1))) e-5)))))
(define LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (arg-1 e-1))) ((1) (let ((e-3 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 2))) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 e-3) (arg-1 e-4))))) ((2) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 e-6) (arg-1 e-7)) (arg-1 e-8)))))) (else (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 e-10) (arg-1 e-11)) (arg-1 e-12)) (arg-1 e-13))))))))))
(define LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a (lambda (arg-1 ext-0) (LibrariesC-45DataC-45PosMap-u--cast_Cast_FileRange_RMFileRange (arg-1 ext-0))))
(define LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) arg-3) ((1) (let ((e-2 (vector-ref arg-4 1))) ((arg-2 e-2) arg-3))) (else (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (let ((e-7 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Digit arg-2 (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Node arg-2 eta-2 eta-3))) eta-0 eta-1))) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Digit arg-2 arg-3 e-7) e-6) e-5))))))))
(define LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Node (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) ((arg-2 e-2) ((arg-2 e-3) arg-3))))) (else (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((e-8 (vector-ref arg-4 4))) ((arg-2 e-6) ((arg-2 e-7) ((arg-2 e-8) arg-3))))))))))
(define LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Digit (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) ((arg-2 e-1) arg-3))) ((1) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) ((arg-2 e-3) ((arg-2 e-4) arg-3))))) ((2) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) ((arg-2 e-6) ((arg-2 e-7) ((arg-2 e-8) arg-3))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) ((arg-2 e-10) ((arg-2 e-11) ((arg-2 e-12) ((arg-2 e-13) arg-3))))))))))))
(define LibrariesC-45DataC-45PosMap-u--foldMap_Foldable_PosMap (lambda (arg-2 arg-3 ext-0) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-2))) ((e-1 (arg-3 eta-0)) eta-1)))) (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (lambda (ext-0) (box ext-0)))
(define LibrariesC-45DataC-45PosMap-u--cast_Cast_FileRange_RMFileRange (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons (cons e-2 e-3) e-3)))))
(define LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (lambda (arg-0 arg-1) (let ((e-1 (cdr arg-0))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons e-2 (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) e-1 e-3)))))))
(define LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (if (null? arg-1) arg-0 (let ((e-0 (unbox arg-0))) (let ((e-1 (unbox arg-1))) (box (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange e-0 e-1))))))))
(define LibrariesC-45DataC-45PosMap-C-124C-62 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (vector 1 arg-3)) ((1) (let ((e-2 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 0 e-2) (vector 0 ) (vector 0 arg-3)))) (else (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (case (vector-ref e-7 0) ((0) (let ((e-9 (vector-ref e-7 1))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 1 e-9 arg-3)))) ((1) (let ((e-11 (vector-ref e-7 1))) (let ((e-12 (vector-ref e-7 2))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 2 e-11 e-12 arg-3))))) ((2) (let ((e-14 (vector-ref e-7 1))) (let ((e-15 (vector-ref e-7 2))) (let ((e-16 (vector-ref e-7 3))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 3 e-14 e-15 e-16 arg-3)))))) (else (let ((e-18 (vector-ref e-7 1))) (let ((e-19 (vector-ref e-7 2))) (let ((e-20 (vector-ref e-7 3))) (let ((e-21 (vector-ref e-7 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 (LibrariesC-45DataC-45PosMap-C-124C-62 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) e-6 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-18 e-19 e-20)) (vector 1 e-21 arg-3)))))))))))))))
(define LibrariesC-45DataC-45PosMap-viewr (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) '()) ((1) (let ((e-2 (vector-ref arg-2 1))) (cons (vector 0 ) e-2))) (else (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (case (vector-ref e-7 0) ((0) (let ((e-9 (vector-ref e-7 1))) (cons (LibrariesC-45DataC-45PosMap-rotr arg-1 e-5 e-6) e-9))) ((1) (let ((e-11 (vector-ref e-7 1))) (let ((e-12 (vector-ref e-7 2))) (cons (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 0 e-11)) e-12)))) ((2) (let ((e-14 (vector-ref e-7 1))) (let ((e-15 (vector-ref e-7 2))) (let ((e-16 (vector-ref e-7 3))) (cons (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 1 e-14 e-15)) e-16))))) (else (let ((e-18 (vector-ref e-7 1))) (let ((e-19 (vector-ref e-7 2))) (let ((e-20 (vector-ref e-7 3))) (let ((e-21 (vector-ref e-7 4))) (cons (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 2 e-18 e-19 e-20)) e-21))))))))))))))
(define LibrariesC-45DataC-45PosMap-viewl (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) '()) ((1) (let ((e-2 (vector-ref arg-2 1))) (cons e-2 (vector 0 )))) (else (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (case (vector-ref e-5 0) ((0) (let ((e-9 (vector-ref e-5 1))) (cons e-9 (LibrariesC-45DataC-45PosMap-rotl arg-1 e-6 e-7)))) ((1) (let ((e-11 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (cons e-11 (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 0 e-12) e-6 e-7))))) ((2) (let ((e-14 (vector-ref e-5 1))) (let ((e-15 (vector-ref e-5 2))) (let ((e-16 (vector-ref e-5 3))) (cons e-14 (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 e-15 e-16) e-6 e-7)))))) (else (let ((e-18 (vector-ref e-5 1))) (let ((e-19 (vector-ref e-5 2))) (let ((e-20 (vector-ref e-5 3))) (let ((e-21 (vector-ref e-5 4))) (cons e-18 (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 2 e-19 e-20 e-21) e-6 e-7)))))))))))))))
(define LibrariesC-45DataC-45PosMap-union (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45PosMap-merge1 arg-1 arg-2 arg-3)))
(define LibrariesC-45DataC-45PosMap-takeUntil (lambda (arg-1 arg-2 ext-0) (Builtin-fst (LibrariesC-45DataC-45PosMap-split arg-1 arg-2 ext-0))))
(define LibrariesC-45DataC-45PosMap-split (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (cons (vector 0 ) (vector 0 )))(else (let ((sc0 (LibrariesC-45DataC-45PosMap-searchTree arg-1 (lambda (u--a) (lambda (_-7697) (arg-2 u--a))) (LibrariesC-45DataC-45PosMap-u--neutral_Monoid_Interval) arg-3 (LibrariesC-45DataC-45PosMap-u--neutral_Monoid_Interval)))) (if (null? sc0) (cons arg-3 (vector 0 )) (let ((e-1 (unbox sc0))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (arg-2 (LibrariesC-45DataC-45PosMap-measureTree arg-1 arg-3)))) (cond ((equal? sc3 1) (cons e-5 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-9 e-10))) (else (cons arg-3 (vector 0 ))))))))))))))))
(define LibrariesC-45DataC-45PosMap-searchTree (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) '()) ((1) (let ((e-2 (vector-ref arg-4 1))) (box (cons (vector 0 ) (cons e-2 (vector 0 )))))) (else (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (let ((e-7 (vector-ref arg-4 4))) (let ((u--vm (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) e-6))) (let ((u--vsr (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 e-7)) arg-5))) (let ((u--vmsr (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--vm u--vsr))) (let ((u--vlp (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval arg-3 (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 e-5))))) (let ((u--vlpm (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--vlp u--vm))) (let ((sc1 ((arg-2 u--vlp) u--vmsr))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45PosMap-searchDigit arg-1 arg-2 arg-3 e-5 u--vmsr))) (let ((e-2 (car sc2))) (let ((e-3 (cdr sc2))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (box (cons (PreludeC-45Types-maybe (lambda () (vector 0 )) (lambda () (lambda (eta-0) (LibrariesC-45DataC-45PosMap-digitToTree arg-1 eta-0))) e-2) (cons e-9 (LibrariesC-45DataC-45PosMap-deepl arg-1 e-8 e-6 e-7)))))))))) (else (let ((sc2 ((arg-2 u--vlpm) u--vsr))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45PosMap-searchTree (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 u--vlp e-6 u--vsr) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((sc5 (LibrariesC-45DataC-45PosMap-searchNode arg-1 arg-2 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--vlp (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) e-2)) e-9 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) e-8) u--vsr)))) (let ((e-11 (car sc5))) (let ((e-10 (cdr sc5))) (let ((e-13 (car e-10))) (let ((e-12 (cdr e-10))) (box (cons (LibrariesC-45DataC-45PosMap-deepr arg-1 e-5 e-2 e-11) (cons e-13 (LibrariesC-45DataC-45PosMap-deepl arg-1 e-12 e-8 e-7)))))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45PosMap-searchDigit arg-1 arg-2 u--vlpm e-7 arg-5))) (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (box (cons (LibrariesC-45DataC-45PosMap-deepr arg-1 e-5 e-6 e-2) (cons e-9 (PreludeC-45Types-maybe (lambda () (vector 0 )) (lambda () (lambda (eta-0) (LibrariesC-45DataC-45PosMap-digitToTree arg-1 eta-0))) e-8)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45PosMap-searchPos (lambda (arg-1 arg-2 ext-0) (LibrariesC-45DataC-45PosMap-inRange arg-1 arg-2 arg-2 ext-0)))
(define LibrariesC-45DataC-45PosMap-searchNode (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-searchDigit arg-1 arg-2 arg-3 (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 arg-4) arg-5)))
(define LibrariesC-45DataC-45PosMap-searchDigit (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (cons '() (cons e-1 '())))) ((1) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) (let ((u--va (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval arg-3 (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-3))))) (let ((u--vb (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-4)) arg-5))) (let ((sc1 ((arg-2 u--va) u--vb))) (cond ((equal? sc1 1) (cons '() (cons e-3 (box (vector 0 e-4))))) (else (cons (box (vector 0 e-3)) (cons e-4 '())))))))))) ((2) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (let ((u--va (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval arg-3 (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-6))))) (let ((u--vab (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--va (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-7))))) (let ((u--vc (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-8)) arg-5))) (let ((u--vbc (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-7)) u--vc))) (let ((sc1 ((arg-2 u--va) u--vbc))) (cond ((equal? sc1 1) (cons '() (cons e-6 (box (vector 1 e-7 e-8))))) (else (let ((sc2 ((arg-2 u--vab) u--vc))) (cond ((equal? sc2 1) (cons (box (vector 0 e-6)) (cons e-7 (box (vector 0 e-8))))) (else (cons (box (vector 1 e-6 e-7)) (cons e-8 '())))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((u--va (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval arg-3 (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-10))))) (let ((u--vab (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--va (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-11))))) (let ((u--vabc (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--vab (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-12))))) (let ((u--vd (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-13)) arg-5))) (let ((u--vcd (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-12)) u--vd))) (let ((u--vbcd (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-11)) u--vcd))) (let ((sc1 ((arg-2 u--va) u--vbcd))) (cond ((equal? sc1 1) (cons '() (cons e-10 (box (vector 2 e-11 e-12 e-13))))) (else (let ((sc2 ((arg-2 u--vab) u--vcd))) (cond ((equal? sc2 1) (cons (box (vector 0 e-10)) (cons e-11 (box (vector 1 e-12 e-13))))) (else (let ((sc3 ((arg-2 u--vabc) u--vd))) (cond ((equal? sc3 1) (cons (box (vector 1 e-10 e-11)) (cons e-12 (box (vector 0 e-13))))) (else (cons (box (vector 2 e-10 e-11 e-12)) (cons e-13 '())))))))))))))))))))))))))
(define LibrariesC-45DataC-45PosMap-rotr (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45DataC-45PosMap-viewr (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-3))) (if (null? sc0) (LibrariesC-45DataC-45PosMap-digitToTree arg-1 arg-2) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-3))) (if (null? sc1) (vector 2 (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2) arg-2 e-2 (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 e-3)) (let ((e-0 (unbox sc1))) (vector 2 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2) e-0) arg-2 e-2 (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 e-3)))))))))))
(define LibrariesC-45DataC-45PosMap-rotl (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45DataC-45PosMap-viewl (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2))) (if (null? sc0) (LibrariesC-45DataC-45PosMap-digitToTree arg-1 arg-3) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2))) (if (null? sc1) (vector 2 (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-3) (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 e-2) e-3 arg-3) (let ((e-0 (unbox sc1))) (vector 2 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange e-0 (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-3)) (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 e-2) e-3 arg-3))))))))))
(define LibrariesC-45DataC-45PosMap-nodeToDigit (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 1 e-2 e-3)))) (else (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (vector 2 e-6 e-7 e-8))))))))
(define LibrariesC-45DataC-45PosMap-node3 (lambda (arg-1 arg-2 arg-3 arg-4) (vector 1 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 arg-2) (arg-1 arg-3)) (arg-1 arg-4)) arg-2 arg-3 arg-4)))
(define LibrariesC-45DataC-45PosMap-node2 (lambda (arg-1 arg-2 arg-3) (vector 0 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 arg-2) (arg-1 arg-3)) arg-2 arg-3)))
(define LibrariesC-45DataC-45PosMap-merge2 (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45PosMap-case--merge2-8258 arg-1 arg-3 arg-2 (LibrariesC-45DataC-45PosMap-viewl (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) arg-3))))
(define LibrariesC-45DataC-45PosMap-merge1 (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45PosMap-case--merge1-8183 arg-1 arg-3 arg-2 (LibrariesC-45DataC-45PosMap-viewl (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) arg-2))))
(define LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-u--neutral_Monoid_Interval)) ((1) (let ((e-2 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-2)))) (else (let ((e-4 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval e-4))))))
(define LibrariesC-45DataC-45PosMap-largerC-39 (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-0 (unbox arg-1))) (let ((e-1 (car e-0))) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-526) (csegen-526) e-1 arg-0))))))
(define LibrariesC-45DataC-45PosMap-larger (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-0 (unbox arg-1))) (let ((e-1 (car e-0))) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-526) (csegen-526) e-1 arg-0))))))
(define LibrariesC-45DataC-45PosMap-insert (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45DataC-45PosMap-split (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-larger (arg-1 arg-2) eta-0)) arg-3))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (LibrariesC-45DataC-45PosMap-C-43C-43 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) e-2 (LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-979)) arg-2 e-3)))))))
(define LibrariesC-45DataC-45PosMap-inRange (lambda (arg-1 arg-2 arg-3 arg-4) (LibrariesC-45DataC-45PosMap-n--10809-8371-u--matches arg-1 arg-4 arg-3 arg-2 (LibrariesC-45DataC-45PosMap-takeUntil arg-1 (lambda (eta-0) (LibrariesC-45DataC-45PosMap-greater arg-3 eta-0)) arg-4))))
(define LibrariesC-45DataC-45PosMap-greater (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-0 (unbox arg-1))) (let ((e-1 (car e-0))) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) (Builtin-fst e-1) arg-0))))))
(define LibrariesC-45DataC-45PosMap-fromList (lambda (arg-1 ext-0) (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45PosMap-insert arg-1 eta-0 eta-1))) (LibrariesC-45DataC-45PosMap-empty) ext-0)))
(define LibrariesC-45DataC-45PosMap-exactRange (lambda (arg-1 arg-2 arg-3 arg-4) (PreludeC-45Basics-flip (csegen-537) (LibrariesC-45DataC-45PosMap-inRange arg-1 arg-2 arg-3 arg-4) (lambda (u--a) (let ((sc0 (arg-1 u--a))) (let ((e-0 (car sc0))) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-527) (csegen-527) e-0 (cons arg-2 arg-3))) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe u--a)))))))))
(define LibrariesC-45DataC-45PosMap-empty(blodwen-lazy (lambda () (vector 0 ))))
(define LibrariesC-45DataC-45PosMap-dropUntil (lambda (arg-1 arg-2 ext-0) (Builtin-snd (LibrariesC-45DataC-45PosMap-split arg-1 arg-2 ext-0))))
(define LibrariesC-45DataC-45PosMap-digitToTree (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (vector 1 e-1))) ((1) (let ((e-3 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 2))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 0 e-3) (vector 0 ) (vector 0 e-4))))) ((2) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 e-6 e-7) (vector 0 ) (vector 0 e-8)))))) (else (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 e-10 e-11) (vector 0 ) (vector 1 e-12 e-13))))))))))
(define LibrariesC-45DataC-45PosMap-deepr (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (LibrariesC-45DataC-45PosMap-rotr arg-1 arg-2 arg-3) (let ((e-2 (unbox arg-4))) (LibrariesC-45DataC-45PosMap-deep arg-1 arg-2 arg-3 e-2)))))
(define LibrariesC-45DataC-45PosMap-deepl (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) (LibrariesC-45DataC-45PosMap-rotl arg-1 arg-3 arg-4) (let ((e-2 (unbox arg-2))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 arg-3 arg-4)))))
(define LibrariesC-45DataC-45PosMap-deep (lambda (arg-1 arg-2 arg-3 arg-4) (vector 2 (LibrariesC-45DataC-45PosMap-n--4551-2366-u--value arg-1 arg-4 arg-3 arg-2) arg-2 arg-3 arg-4)))
(define LibrariesC-45DataC-45PosMap-atleast (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-0 (unbox arg-1))) (let ((e-2 (cdr e-0))) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-0 e-2))))))
(define LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-5 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-6 arg-7)))))(else (case (vector-ref arg-7 0) ((0) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) arg-5) arg-6))(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-5 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-6 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 arg-7)))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-11 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) arg-5) arg-6) e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((e-9 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits4 arg-1 e-3 e-4 arg-3 arg-4 arg-5 arg-6 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-5 arg-6))))(else (case (vector-ref arg-6 0) ((0) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) arg-5))(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-5 arg-6))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-11 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) arg-5) e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((e-9 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits3 arg-1 e-3 e-4 arg-3 arg-4 arg-5 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 arg-5)))(else (case (vector-ref arg-5 0) ((0) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4))(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 arg-5)))))(else (case (vector-ref arg-5 0) ((1) (let ((e-11 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (let ((e-9 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits2 arg-1 e-3 e-4 arg-3 arg-4 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 arg-4))(else (case (vector-ref arg-4 0) ((0) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3))(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 arg-4))))(else (case (vector-ref arg-4 0) ((1) (let ((e-11 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (let ((e-9 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits1 arg-1 e-3 e-4 arg-3 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree0 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) arg-3)(else (case (vector-ref arg-3 0) ((0) arg-2)(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 arg-3)))(else (case (vector-ref arg-3 0) ((1) (let ((e-11 (vector-ref arg-3 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits0 arg-1 e-3 e-4 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits4 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-8 0) ((0) (let ((e-15 (vector-ref arg-8 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-15) arg-9))) ((1) (let ((e-17 (vector-ref arg-8 1))) (let ((e-18 (vector-ref arg-8 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-17 e-18) arg-9)))) ((2) (let ((e-20 (vector-ref arg-8 1))) (let ((e-21 (vector-ref arg-8 2))) (let ((e-22 (vector-ref arg-8 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-20) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-21 e-22) arg-9))))) (else (let ((e-24 (vector-ref arg-8 1))) (let ((e-25 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 3))) (let ((e-27 (vector-ref arg-8 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-24) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-25 e-26 e-27) arg-9))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-8 0) ((0) (let ((e-29 (vector-ref arg-8 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-7 e-29) arg-9))) ((1) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-31 e-32) arg-9)))) ((2) (let ((e-34 (vector-ref arg-8 1))) (let ((e-35 (vector-ref arg-8 2))) (let ((e-36 (vector-ref arg-8 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-34 e-35 e-36) arg-9))))) (else (let ((e-38 (vector-ref arg-8 1))) (let ((e-39 (vector-ref arg-8 2))) (let ((e-40 (vector-ref arg-8 3))) (let ((e-41 (vector-ref arg-8 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-38 e-39) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-40 e-41) arg-9)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-8 0) ((0) (let ((e-43 (vector-ref arg-8 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-7 e-43) arg-9))) ((1) (let ((e-45 (vector-ref arg-8 1))) (let ((e-46 (vector-ref arg-8 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-7 e-45 e-46) arg-9)))) ((2) (let ((e-48 (vector-ref arg-8 1))) (let ((e-49 (vector-ref arg-8 2))) (let ((e-50 (vector-ref arg-8 3))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-7 e-48) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-49 e-50) arg-9))))) (else (let ((e-52 (vector-ref arg-8 1))) (let ((e-53 (vector-ref arg-8 2))) (let ((e-54 (vector-ref arg-8 3))) (let ((e-55 (vector-ref arg-8 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-7 e-52 e-53) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-54 e-55) arg-9))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-8 0) ((0) (let ((e-57 (vector-ref arg-8 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-57) arg-9))) ((1) (let ((e-59 (vector-ref arg-8 1))) (let ((e-60 (vector-ref arg-8 2))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-59 e-60) arg-9)))) ((2) (let ((e-62 (vector-ref arg-8 1))) (let ((e-63 (vector-ref arg-8 2))) (let ((e-64 (vector-ref arg-8 3))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-62) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-63 e-64) arg-9))))) (else (let ((e-66 (vector-ref arg-8 1))) (let ((e-67 (vector-ref arg-8 2))) (let ((e-68 (vector-ref arg-8 3))) (let ((e-69 (vector-ref arg-8 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-66) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-67 e-68 e-69) arg-9)))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits3 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-7 0) ((0) (let ((e-15 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-15) arg-8))) ((1) (let ((e-17 (vector-ref arg-7 1))) (let ((e-18 (vector-ref arg-7 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 e-17 e-18) arg-8)))) ((2) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (let ((e-22 (vector-ref arg-7 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-20) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-21 e-22) arg-8))))) (else (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (let ((e-27 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 e-24 e-25) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-26 e-27) arg-8))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-7 0) ((0) (let ((e-29 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 e-29) arg-8))) ((1) (let ((e-31 (vector-ref arg-7 1))) (let ((e-32 (vector-ref arg-7 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-31 e-32) arg-8)))) ((2) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 e-34) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-35 e-36) arg-8))))) (else (let ((e-38 (vector-ref arg-7 1))) (let ((e-39 (vector-ref arg-7 2))) (let ((e-40 (vector-ref arg-7 3))) (let ((e-41 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 e-38) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-39 e-40 e-41) arg-8)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-7 0) ((0) (let ((e-43 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-43) arg-8))) ((1) (let ((e-45 (vector-ref arg-7 1))) (let ((e-46 (vector-ref arg-7 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-45 e-46) arg-8)))) ((2) (let ((e-48 (vector-ref arg-7 1))) (let ((e-49 (vector-ref arg-7 2))) (let ((e-50 (vector-ref arg-7 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-48 e-49 e-50) arg-8))))) (else (let ((e-52 (vector-ref arg-7 1))) (let ((e-53 (vector-ref arg-7 2))) (let ((e-54 (vector-ref arg-7 3))) (let ((e-55 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-52 e-53) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-54 e-55) arg-8))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-7 0) ((0) (let ((e-57 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-57) arg-8))) ((1) (let ((e-59 (vector-ref arg-7 1))) (let ((e-60 (vector-ref arg-7 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 e-59 e-60) arg-8)))) ((2) (let ((e-62 (vector-ref arg-7 1))) (let ((e-63 (vector-ref arg-7 2))) (let ((e-64 (vector-ref arg-7 3))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-62) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-63 e-64) arg-8))))) (else (let ((e-66 (vector-ref arg-7 1))) (let ((e-67 (vector-ref arg-7 2))) (let ((e-68 (vector-ref arg-7 3))) (let ((e-69 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 e-66 e-67) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-68 e-69) arg-8)))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits2 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-6 0) ((0) (let ((e-15 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-1 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 e-15) arg-7))) ((1) (let ((e-17 (vector-ref arg-6 1))) (let ((e-18 (vector-ref arg-6 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-17 e-18) arg-7)))) ((2) (let ((e-20 (vector-ref arg-6 1))) (let ((e-21 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-20 e-21 e-22) arg-7))))) (else (let ((e-24 (vector-ref arg-6 1))) (let ((e-25 (vector-ref arg-6 2))) (let ((e-26 (vector-ref arg-6 3))) (let ((e-27 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-24 e-25) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-26 e-27) arg-7))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-6 0) ((0) (let ((e-29 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 e-29) arg-7))) ((1) (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 e-31 e-32) arg-7)))) ((2) (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 e-34) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-35 e-36) arg-7))))) (else (let ((e-38 (vector-ref arg-6 1))) (let ((e-39 (vector-ref arg-6 2))) (let ((e-40 (vector-ref arg-6 3))) (let ((e-41 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 e-38 e-39) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-40 e-41) arg-7)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-6 0) ((0) (let ((e-43 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 e-43) arg-7))) ((1) (let ((e-45 (vector-ref arg-6 1))) (let ((e-46 (vector-ref arg-6 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-45 e-46) arg-7)))) ((2) (let ((e-48 (vector-ref arg-6 1))) (let ((e-49 (vector-ref arg-6 2))) (let ((e-50 (vector-ref arg-6 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 e-48) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-49 e-50) arg-7))))) (else (let ((e-52 (vector-ref arg-6 1))) (let ((e-53 (vector-ref arg-6 2))) (let ((e-54 (vector-ref arg-6 3))) (let ((e-55 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 e-52) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-53 e-54 e-55) arg-7))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-6 0) ((0) (let ((e-57 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-13 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 e-57) arg-7))) ((1) (let ((e-59 (vector-ref arg-6 1))) (let ((e-60 (vector-ref arg-6 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-59 e-60) arg-7)))) ((2) (let ((e-62 (vector-ref arg-6 1))) (let ((e-63 (vector-ref arg-6 2))) (let ((e-64 (vector-ref arg-6 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-62 e-63 e-64) arg-7))))) (else (let ((e-66 (vector-ref arg-6 1))) (let ((e-67 (vector-ref arg-6 2))) (let ((e-68 (vector-ref arg-6 3))) (let ((e-69 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-66 e-67) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-68 e-69) arg-7)))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits1 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-5 0) ((0) (let ((e-15 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 e-15) arg-6))) ((1) (let ((e-17 (vector-ref arg-5 1))) (let ((e-18 (vector-ref arg-5 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-1 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-17 e-18) arg-6)))) ((2) (let ((e-20 (vector-ref arg-5 1))) (let ((e-21 (vector-ref arg-5 2))) (let ((e-22 (vector-ref arg-5 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 e-20) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-21 e-22) arg-6))))) (else (let ((e-24 (vector-ref arg-5 1))) (let ((e-25 (vector-ref arg-5 2))) (let ((e-26 (vector-ref arg-5 3))) (let ((e-27 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 e-24) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-25 e-26 e-27) arg-6))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-5 0) ((0) (let ((e-29 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-3 e-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 e-29) arg-6))) ((1) (let ((e-31 (vector-ref arg-5 1))) (let ((e-32 (vector-ref arg-5 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-31 e-32) arg-6)))) ((2) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-34 e-35 e-36) arg-6))))) (else (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (let ((e-41 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-38 e-39) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-40 e-41) arg-6)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-5 0) ((0) (let ((e-43 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 e-43) arg-6))) ((1) (let ((e-45 (vector-ref arg-5 1))) (let ((e-46 (vector-ref arg-5 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 e-45 e-46) arg-6)))) ((2) (let ((e-48 (vector-ref arg-5 1))) (let ((e-49 (vector-ref arg-5 2))) (let ((e-50 (vector-ref arg-5 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 e-48) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-49 e-50) arg-6))))) (else (let ((e-52 (vector-ref arg-5 1))) (let ((e-53 (vector-ref arg-5 2))) (let ((e-54 (vector-ref arg-5 3))) (let ((e-55 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 e-52 e-53) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-54 e-55) arg-6))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-5 0) ((0) (let ((e-57 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 e-57) arg-6))) ((1) (let ((e-59 (vector-ref arg-5 1))) (let ((e-60 (vector-ref arg-5 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-13 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-59 e-60) arg-6)))) ((2) (let ((e-62 (vector-ref arg-5 1))) (let ((e-63 (vector-ref arg-5 2))) (let ((e-64 (vector-ref arg-5 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 e-62) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-63 e-64) arg-6))))) (else (let ((e-66 (vector-ref arg-5 1))) (let ((e-67 (vector-ref arg-5 2))) (let ((e-68 (vector-ref arg-5 3))) (let ((e-69 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 e-66) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-67 e-68 e-69) arg-6)))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits0 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((0) (let ((e-15 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-1 e-15) arg-5))) ((1) (let ((e-17 (vector-ref arg-4 1))) (let ((e-18 (vector-ref arg-4 2))) (LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 e-17 e-18) arg-5)))) ((2) (let ((e-20 (vector-ref arg-4 1))) (let ((e-21 (vector-ref arg-4 2))) (let ((e-22 (vector-ref arg-4 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-1 e-20) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-21 e-22) arg-5))))) (else (let ((e-24 (vector-ref arg-4 1))) (let ((e-25 (vector-ref arg-4 2))) (let ((e-26 (vector-ref arg-4 3))) (let ((e-27 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 e-24 e-25) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-26 e-27) arg-5))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((0) (let ((e-29 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 e-29) arg-5))) ((1) (let ((e-31 (vector-ref arg-4 1))) (let ((e-32 (vector-ref arg-4 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-3 e-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-31 e-32) arg-5)))) ((2) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 e-34) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-35 e-36) arg-5))))) (else (let ((e-38 (vector-ref arg-4 1))) (let ((e-39 (vector-ref arg-4 2))) (let ((e-40 (vector-ref arg-4 3))) (let ((e-41 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 e-38) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-39 e-40 e-41) arg-5)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((0) (let ((e-43 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-6 e-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-8 e-43) arg-5))) ((1) (let ((e-45 (vector-ref arg-4 1))) (let ((e-46 (vector-ref arg-4 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-45 e-46) arg-5)))) ((2) (let ((e-48 (vector-ref arg-4 1))) (let ((e-49 (vector-ref arg-4 2))) (let ((e-50 (vector-ref arg-4 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-48 e-49 e-50) arg-5))))) (else (let ((e-52 (vector-ref arg-4 1))) (let ((e-53 (vector-ref arg-4 2))) (let ((e-54 (vector-ref arg-4 3))) (let ((e-55 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-52 e-53) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-54 e-55) arg-5))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((0) (let ((e-57 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-13 e-57) arg-5))) ((1) (let ((e-59 (vector-ref arg-4 1))) (let ((e-60 (vector-ref arg-4 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 e-59 e-60) arg-5)))) ((2) (let ((e-62 (vector-ref arg-4 1))) (let ((e-63 (vector-ref arg-4 2))) (let ((e-64 (vector-ref arg-4 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-13 e-62) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-63 e-64) arg-5))))) (else (let ((e-66 (vector-ref arg-4 1))) (let ((e-67 (vector-ref arg-4 2))) (let ((e-68 (vector-ref arg-4 3))) (let ((e-69 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 e-66 e-67) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-68 e-69) arg-5)))))))))))))))
(define LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 1 arg-2)) ((1) (let ((e-2 (vector-ref arg-3 1))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 0 arg-2) (vector 0 ) (vector 0 e-2)))) (else (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (case (vector-ref e-5 0) ((0) (let ((e-9 (vector-ref e-5 1))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 arg-2 e-9) e-6 e-7))) ((1) (let ((e-11 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 2 arg-2 e-11 e-12) e-6 e-7)))) ((2) (let ((e-14 (vector-ref e-5 1))) (let ((e-15 (vector-ref e-5 2))) (let ((e-16 (vector-ref e-5 3))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 3 arg-2 e-14 e-15 e-16) e-6 e-7))))) (else (let ((e-18 (vector-ref e-5 1))) (let ((e-19 (vector-ref e-5 2))) (let ((e-20 (vector-ref e-5 3))) (let ((e-21 (vector-ref e-5 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 arg-2 e-18) (LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-979) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-979)) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-19 e-20 e-21) e-6) e-7))))))))))))))
(define LibrariesC-45DataC-45PosMap-C-43C-43 (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45PosMap-appendTree0 arg-1 arg-2 arg-3)))
(define CoreC-45FC-u--show_Show_VirtualIdent (lambda (arg-0) (cond (else "(Interactive)"))))
(define CoreC-45FC-u--show_Show_OriginDesc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_String e-1))) (else (let ((e-2 (vector-ref arg-0 1))) (CoreC-45FC-u--show_Show_VirtualIdent e-2))))))
(define CoreC-45FC-u--show_Show_FC (lambda (arg-0) (case (vector-ref arg-0 0) ((2) "EmptyFC") ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_OriginDesc e-0) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-showPos e-1) (PreludeC-45TypesC-45String-C-43C-43 "--" (CoreC-45FC-showPos e-2))))))))) (else (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_OriginDesc e-3) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-showPos e-4) (PreludeC-45TypesC-45String-C-43C-43 "--" (CoreC-45FC-showPos e-5))))))))))))
(define CoreC-45FC-u--showPrec_Show_OriginDesc (lambda (arg-0 arg-1) (CoreC-45FC-u--show_Show_OriginDesc arg-1)))
(define CoreC-45FC-u--showPrec_Show_FC (lambda (arg-0 arg-1) (CoreC-45FC-u--show_Show_FC arg-1)))
(define CoreC-45FC-u--pretty_Pretty_OriginDesc (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45FC-u--show_Show_OriginDesc ext-0))))
(define CoreC-45FC-u--pretty_Pretty_FC (lambda (arg-1) (case (vector-ref arg-1 0) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "EmptyFC")) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45FC-u--pretty_Pretty_OriginDesc e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (CoreC-45FC-prettyPos e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "--")) (CoreC-45FC-prettyPos e-2)))))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45FC-u--pretty_Pretty_OriginDesc e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (CoreC-45FC-prettyPos e-4)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "--")) (CoreC-45FC-prettyPos e-5)))))))))
(define CoreC-45FC-u--prettyPrec_Pretty_FC (lambda (arg-1 arg-2) (CoreC-45FC-u--pretty_Pretty_FC arg-2)))
(define CoreC-45FC-u--C-61C-61_Eq_VirtualIdent (lambda (arg-0 arg-1) (cond (else (cond (else 1))))))
(define CoreC-45FC-u--C-61C-61_Eq_OriginDesc (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 1))) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent e-0 e-3)))(else 0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-4 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 e-4)))(else 0)))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-5 (vector-ref arg-1 1))) (CoreC-45FC-u--C-61C-61_Eq_VirtualIdent e-2 e-5)))(else 0))))(else 0))))
(define CoreC-45FC-u--C-61C-61_Eq_FC (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((0) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_OriginDesc e-0 e-6))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) e-1 e-7))) (cond ((equal? sc3 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) e-2 e-8)) (else 0)))) (else 0)))))))(else 0)))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((1) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (let ((e-11 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_OriginDesc e-3 e-9))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) e-4 e-10))) (cond ((equal? sc3 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) e-5 e-11)) (else 0)))) (else 0)))))))(else 0)))))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0)))(else 0))))
(define CoreC-45FC-u--C-47C-61_Eq_FC (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45FC-u--C-61C-61_Eq_FC arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45FC-within (lambda (arg-0 arg-1) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-7 (cdr arg-1))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) (cons e-2 e-3) e-10))) (cond ((equal? sc3 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) (cons e-2 e-3) e-11)) (else 0))))))))))
(define CoreC-45FC-virtualiseFC (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (vector 1 e-0 e-1 e-2)))))(else arg-0))))
(define CoreC-45FC-toNonEmptyFC (lambda (ext-0) (DataC-45Maybe-fromMaybe (lambda () (CoreC-45FC-defaultFC)) (CoreC-45FC-isNonEmptyFC ext-0))))
(define CoreC-45FC-startPos (lambda (arg-0) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-3))) e-6))))
(define CoreC-45FC-startLine (lambda (ext-0) (Builtin-fst (CoreC-45FC-startPos ext-0))))
(define CoreC-45FC-startCol (lambda (ext-0) (Builtin-snd (CoreC-45FC-startPos ext-0))))
(define CoreC-45FC-showPos (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int (bs+ e-2 1 63)) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45Show-u--show_Show_Int (bs+ e-3 1 63))))))))
(define CoreC-45FC-replFC(blodwen-lazy (lambda () (CoreC-45FC-justFC (CoreC-45FC-defaultFC)))))
(define CoreC-45FC-prettyPos (lambda (arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int (bs+ e-2 1 63)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int (bs+ e-3 1 63)))))))
(define CoreC-45FC-onLine (lambda (arg-0 arg-1) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-0 (Builtin-fst e-6)))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-0 (Builtin-fst e-7))) (else 0))))))))
(define CoreC-45FC-mergeFC (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_OriginDesc e-0 e-3))) (cond ((equal? sc2 1) (box (vector 0 e-0 (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) e-1 e-4) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) e-2 e-5)))) (else '())))))))(else '()))))))(else '()))))
(define CoreC-45FC-justFC (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 e-2 e-6 e-7)))))))
(define CoreC-45FC-isNonEmptyFC (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (box (cons e-0 (cons e-1 e-2))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (box (cons e-3 (cons e-4 e-5))))))) (else '()))))
(define CoreC-45FC-isConcreteFC (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (box (cons e-0 (cons e-1 e-2)))))))(else '()))))
(define CoreC-45FC-emptyFC(blodwen-lazy (lambda () (vector 2 ))))
(define CoreC-45FC-defaultFC(blodwen-lazy (lambda () (cons (vector 2 0) (cons (cons 0 0) (cons 0 0))))))
(define CoreC-45FC-boundToFC (lambda (arg-1 arg-2) (vector 0 arg-1 (LibrariesC-45TextC-45Bounded-start arg-2) (LibrariesC-45TextC-45Bounded-end arg-2))))
(define CoreC-45TTC-45SubstEnv-case--find-10758 (lambda (arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (cond ((equal? arg-5 0) (if (null? arg-8) (CoreC-45TTC-45SubstEnv-findDrop arg-7 arg-6 arg-4 arg-3) (let ((e-3 (unbox arg-8))) (cond ((equal? arg-4 0) (vector 0 arg-7 arg-6 0))(else (let ((e-4 (- arg-4 1))) (CoreC-45TT-u--weaken_Weaken_Term (CoreC-45TTC-45SubstEnv-find arg-7 arg-6 e-3 e-4 arg-3))))))))(else (let ((e-3 (unbox arg-8))) (cond ((equal? arg-4 0) (vector 0 arg-7 arg-6 0))(else (let ((e-4 (- arg-4 1))) (CoreC-45TT-u--weaken_Weaken_Term (CoreC-45TTC-45SubstEnv-find arg-7 arg-6 e-3 e-4 arg-3))))))))))
(define CoreC-45TT-case--weakenNs-8635 (lambda (arg-2 arg-3 arg-4) (cond ((equal? arg-3 0) (if (null? arg-4) arg-2 (let ((e-3 (unbox arg-4))) (CoreC-45TT-u--weaken_Weaken_Var (CoreC-45TT-u--weakenNs_Weaken_Var e-3 arg-2)))))(else (let ((e-3 (unbox arg-4))) (CoreC-45TT-u--weaken_Weaken_Var (CoreC-45TT-u--weakenNs_Weaken_Var e-3 arg-2)))))))
(define CoreC-45TT-case--insertNVarNames-8140 (lambda (arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-6 0) (if (null? arg-7) (CoreC-45TT-weakenNVar arg-5 arg-4) (let ((e-3 (unbox arg-7))) (cond ((equal? arg-4 0) 0)(else (let ((e-4 (- arg-4 1))) (CoreC-45TTC-45NVar-later (CoreC-45TT-insertNVarNames e-3 arg-5 e-4))))))))(else (let ((e-3 (unbox arg-7))) (cond ((equal? arg-4 0) 0)(else (let ((e-4 (- arg-4 1))) (CoreC-45TTC-45NVar-later (CoreC-45TT-insertNVarNames e-3 arg-5 e-4))))))))))
(define CoreC-45TT-case--insertNVar-7738 (lambda (arg-4 arg-5 arg-6) (cond ((equal? arg-5 0) (if (null? arg-6) (CoreC-45TTC-45NVar-later arg-4) (let ((e-3 (unbox arg-6))) (cond ((equal? arg-4 0) 0)(else (let ((e-4 (- arg-4 1))) (CoreC-45TTC-45NVar-later (CoreC-45TT-insertNVar e-3 e-4))))))))(else (let ((e-3 (unbox arg-6))) (cond ((equal? arg-4 0) 0)(else (let ((e-4 (- arg-4 1))) (CoreC-45TTC-45NVar-later (CoreC-45TT-insertNVar e-3 e-4))))))))))
(define CoreC-45TT-case--weakenNVar-7684 (lambda (arg-3 arg-4 arg-5) (cond ((equal? arg-4 0) (if (null? arg-5) arg-3 (let ((e-3 (unbox arg-5))) (CoreC-45TTC-45NVar-later (CoreC-45TT-weakenNVar e-3 arg-3)))))(else (let ((e-3 (unbox arg-5))) (CoreC-45TTC-45NVar-later (CoreC-45TT-weakenNVar e-3 arg-3)))))))
(define CoreC-45TT-n--11679-7541-u--showTot (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((1) (case (vector-ref arg-2 0) ((0) "total")(else (CoreC-45TT-u--show_Show_Covering arg-2))))(else (case (vector-ref arg-2 0) ((0) (CoreC-45TT-u--show_Show_Terminating arg-1))(else (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Covering arg-2) (PreludeC-45TypesC-45String-C-43C-43 "; " (CoreC-45TT-u--show_Show_Terminating arg-1)))))))))
(define CoreC-45TT-n--16258-11550-u--showApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-5 (vector-ref arg-3 3))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (CoreC-45TT-nameAt arg-2 e-5)) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-5) "]"))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((1) (let ((e-10 (vector-ref arg-3 3))) (if (null? arg-4) (CoreC-45Name-u--show_Show_Name e-10) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((2) (let ((e-13 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 4))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 "?" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-13) (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-15)))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))))) ((3) (let ((e-18 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 3))) (let ((e-20 (vector-ref arg-3 4))) (case (vector-ref e-19 0) ((0) (let ((e-56 (vector-ref e-19 2))) (let ((e-57 (vector-ref e-19 3))) (let ((e-58 (vector-ref e-19 4))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 "\\" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-withPiInfo (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-57 (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-56) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-18) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-58))))) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20)))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((1) (let ((e-61 (vector-ref e-19 2))) (let ((e-62 (vector-ref e-19 3))) (let ((e-63 (vector-ref e-19 4))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 "let " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-61) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-18) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-63) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-62) (PreludeC-45TypesC-45String-C-43C-43 " in " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))))))))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((2) (let ((e-66 (vector-ref e-19 2))) (let ((e-67 (vector-ref e-19 3))) (let ((e-68 (vector-ref e-19 4))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-withPiInfo (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-67 (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-66) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-18) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-68))))) (PreludeC-45TypesC-45String-C-43C-43 " -> " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20) ")"))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((3) (let ((e-71 (vector-ref e-19 2))) (let ((e-72 (vector-ref e-19 3))) (let ((e-73 (vector-ref e-19 4))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-withPiInfo (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-72 (PreludeC-45TypesC-45String-C-43C-43 "pat " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-71) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-18) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-73)))))) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((4) (let ((e-76 (vector-ref e-19 2))) (let ((e-77 (vector-ref e-19 3))) (let ((e-78 (vector-ref e-19 4))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 "plet " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-76) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-18) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-78) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-77) (PreludeC-45TypesC-45String-C-43C-43 " in " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))))))))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((5) (let ((e-81 (vector-ref e-19 2))) (let ((e-82 (vector-ref e-19 3))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 "pty " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-81) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-18) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-82) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))))))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))(else (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))))))) ((4) (if (null? arg-4) "[can't happen]" (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))) ((5) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-28) (PreludeC-45TypesC-45String-C-43C-43 "@" (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-29))) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))))) ((6) (let ((e-33 (vector-ref arg-3 3))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 "%Delayed " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-33)) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((7) (let ((e-38 (vector-ref arg-3 4))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 "%Delay " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-38)) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((8) (let ((e-42 (vector-ref arg-3 3))) (if (null? arg-4) (PreludeC-45TypesC-45String-C-43C-43 "%Force " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-42)) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((9) (let ((e-45 (vector-ref arg-3 2))) (if (null? arg-4) (CoreC-45TT-u--show_Show_Constant e-45) (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((10) (if (null? arg-4) "[__]" (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))) ((11) (if (null? arg-4) "Type" (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))(else (if (null? arg-4) "???" (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))
(define CoreC-45TT-n--9933-5927-u--go (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((0) (let ((e-31 (vector-ref arg-4 2))) (let ((e-32 (vector-ref arg-4 3))) (let ((e-33 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-2 e-31))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45TT-eqPiInfoBy arg-2 e-3 e-32))) (cond ((equal? sc3 1) ((arg-2 e-4) e-33)) (else 0)))) (else 0)))))))(else 0)))))) ((1) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((1) (let ((e-36 (vector-ref arg-4 2))) (let ((e-37 (vector-ref arg-4 3))) (let ((e-38 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-7 e-36))) (cond ((equal? sc2 1) (let ((sc3 ((arg-2 e-8) e-37))) (cond ((equal? sc3 1) ((arg-2 e-9) e-38)) (else 0)))) (else 0)))))))(else 0)))))) ((2) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((2) (let ((e-41 (vector-ref arg-4 2))) (let ((e-42 (vector-ref arg-4 3))) (let ((e-43 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-12 e-41))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45TT-eqPiInfoBy arg-2 e-13 e-42))) (cond ((equal? sc3 1) ((arg-2 e-14) e-43)) (else 0)))) (else 0)))))))(else 0)))))) ((3) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((3) (let ((e-46 (vector-ref arg-4 2))) (let ((e-47 (vector-ref arg-4 3))) (let ((e-48 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-17 e-46))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45TT-eqPiInfoBy arg-2 e-18 e-47))) (cond ((equal? sc3 1) ((arg-2 e-19) e-48)) (else 0)))) (else 0)))))))(else 0)))))) ((4) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((4) (let ((e-51 (vector-ref arg-4 2))) (let ((e-52 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-22 e-51))) (cond ((equal? sc2 1) (let ((sc3 ((arg-2 e-23) e-52))) (cond ((equal? sc3 1) ((arg-2 e-24) e-53)) (else 0)))) (else 0)))))))(else 0)))))) ((5) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((5) (let ((e-56 (vector-ref arg-4 2))) (let ((e-57 (vector-ref arg-4 3))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-27 e-56))) (cond ((equal? sc2 1) ((arg-2 e-28) e-57)) (else 0))))))(else 0)))))(else 0))))
(define CoreC-45TT-n--6786-2857-u--go (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (case (vector-ref arg-4 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-4 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-4 0) ((2) 1)(else 0))) ((3) (let ((e-4 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((3) (let ((e-9 (vector-ref arg-4 1))) ((arg-2 e-4) e-9)))(else 0))))(else 0))))
(define CoreC-45TT-n--13118-8795-u--getFA (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((4) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (CoreC-45TT-n--13118-8795-u--getFA arg-1 (cons e-3 arg-2) e-2))))(else (cons arg-3 arg-2)))))
(define CoreC-45TT-n--15969-11300-u--addRefsArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) arg-8 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (CoreC-45TT-n--15969-11300-u--addRefsArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (CoreC-45TT-addRefs arg-7 arg-6 arg-8 e-2) e-3))))))
(define CoreC-45TT-n--15853-11206-u--addMetaArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-6 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (CoreC-45TT-n--15853-11206-u--addMetaArgs arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TT-addMetas arg-6 e-2) e-3))))))
(define CoreC-45TT-u--weaken_Weaken_Var (lambda (ext-0) (CoreC-45TTC-45Var-later ext-0)))
(define CoreC-45TT-u--weaken_Weaken_Term (lambda (ext-0) (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-suc (CoreC-45TTC-45SizeOf-zero)) ext-0)))
(define CoreC-45TT-u--weakenNs_Weaken_Var (lambda (arg-2 arg-3) (CoreC-45TT-case--weakenNs-8635 arg-3 arg-2 (CoreC-45TT-sizedView arg-2))))
(define CoreC-45TT-u--weakenNs_Weaken_Term (lambda (arg-2 arg-3) (CoreC-45TT-insertNames (CoreC-45TTC-45SizeOf-zero) arg-2 arg-3)))
(define CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (case (vector-ref e-3 0) ((0) (let ((e-36 (vector-ref e-3 1))) (let ((e-37 (vector-ref e-3 2))) (let ((u--tm (vector 1 e-1 e-2 (vector 0 e-36 e-37)))) (let ((sc2 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-1 e-36))) (cond ((equal? sc2 1) (vector 1 e-1 e-2 (vector 0 (CoreC-45NameC-45Namespace-unsafeFoldNamespace '()) e-37))) (else u--tm)))))))(else arg-2)))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (vector 2 e-5 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (arg-3) (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-8))))))) ((3) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (vector 3 e-10 e-11 (CoreC-45TT-u--map_Functor_Binder (lambda (arg-3) (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-12) (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-13))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (vector 4 e-15 (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-16) (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-17)))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (vector 5 e-19 e-20 (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-21) (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-22))))))) ((6) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (vector 6 e-24 e-25 (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-26)))))) ((7) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (vector 7 e-28 e-29 (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-30) (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-31))))))) ((8) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((e-35 (vector-ref arg-2 3))) (vector 8 e-33 e-34 (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-35))))))(else arg-2))))
(define CoreC-45TT-u--toList_Foldable_Binder (lambda (ext-0) (CoreC-45TT-u--foldr_Foldable_Binder (csegen-113) '() ext-0)))
(define CoreC-45TT-u--show_Show_Visibility (lambda (arg-0) (cond ((equal? arg-0 0) "private") ((equal? arg-0 1) "export") (else "public export"))))
(define CoreC-45TT-u--show_Show_Totality (lambda (arg-0) (let ((u--t (let ((e-0 (car arg-0))) e-0))) (let ((u--c (let ((e-1 (cdr arg-0))) e-1))) (CoreC-45TT-n--11679-7541-u--showTot arg-0 u--t u--c)))))
(define CoreC-45TT-u--show_Show_TotalReq (lambda (arg-0) (cond ((equal? arg-0 0) "total") ((equal? arg-0 1) "covering") (else "partial"))))
(define CoreC-45TT-u--show_Show_Terminating (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "not yet checked") ((1) "terminating") (else (let ((e-0 (vector-ref arg-0 1))) (CoreC-45TT-u--show_Show_PartialReason e-0))))))
(define CoreC-45TT-u--show_Show_PartialReason (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "not strictly positive") ((1) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) (PreludeC-45TypesC-45String-C-43C-43 "possibly not terminating due to calls to " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-0))) (let ((e-3 (car e-0))) (let ((e-4 (cdr e-0))) (if (null? e-4) (PreludeC-45TypesC-45String-C-43C-43 "possibly not terminating due to call to " (CoreC-45Name-u--show_Show_Name e-3)) (PreludeC-45TypesC-45String-C-43C-43 "possibly not terminating due to calls to " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-0))))))))) (else (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "possibly not terminating due to recursive path " (CoreC-45NameC-45Namespace-showSep " -> " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))))))))
(define CoreC-45TT-u--show_Show_LazyReason (lambda (arg-0) (cond ((equal? arg-0 0) "Inf") ((equal? arg-0 1) "Lazy") (else "Unkown"))))
(define CoreC-45TT-u--show_Show_KindedName (lambda (ext-0) (CoreC-45Name-u--show_Show_Name (let ((e-2 (vector-ref ext-0 2))) e-2))))
(define CoreC-45TT-u--show_Show_Covering (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "covering") ((1) "not covering all cases") (else (let ((e-1 (vector-ref arg-0 1))) (if (null? e-1) (PreludeC-45TypesC-45String-C-43C-43 "not covering due to calls to functions " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))) (let ((e-3 (car e-1))) (let ((e-4 (cdr e-1))) (if (null? e-4) (PreludeC-45TypesC-45String-C-43C-43 "not covering due to call to function " (CoreC-45Name-u--show_Show_Name e-3)) (PreludeC-45TypesC-45String-C-43C-43 "not covering due to calls to functions " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))))))))))))
(define CoreC-45TT-u--show_Show_Constant (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int8 e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int16 e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int32 e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int64 e-4))) ((5) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Integer e-5))) ((6) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits8 e-6))) ((7) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits16 e-7))) ((8) (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits32 e-8))) ((9) (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits64 e-9))) ((10) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_String e-10))) ((11) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Char e-11))) ((12) (let ((e-12 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Double e-12))) ((13) "%MkWorld") ((14) "Int") ((15) "Int8") ((16) "Int16") ((17) "Int32") ((18) "Int64") ((19) "Integer") ((20) "Bits8") ((21) "Bits16") ((22) "Bits32") ((23) "Bits64") ((24) "String") ((25) "Char") ((26) "Double") (else "%World"))))
(define CoreC-45TT-u--show_Show_C-40VarC-32C-36nsC-41 (lambda (arg-1) (PreludeC-45Show-u--show_Show_Nat arg-1)))
(define CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-getFnArgs arg-1))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (CoreC-45TT-n--16258-11550-u--showApp arg-0 arg-1 arg-0 e-2 e-3))))))
(define CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "+" (CoreC-45TT-u--show_Show_Constant e-0)))) ((1) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "-" (CoreC-45TT-u--show_Show_Constant e-1)))) ((2) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "*" (CoreC-45TT-u--show_Show_Constant e-2)))) ((3) (let ((e-3 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "/" (CoreC-45TT-u--show_Show_Constant e-3)))) ((4) (let ((e-4 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "%" (CoreC-45TT-u--show_Show_Constant e-4)))) ((5) (let ((e-5 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "neg " (CoreC-45TT-u--show_Show_Constant e-5)))) ((6) (let ((e-6 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "shl " (CoreC-45TT-u--show_Show_Constant e-6)))) ((7) (let ((e-7 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "shr " (CoreC-45TT-u--show_Show_Constant e-7)))) ((8) (let ((e-8 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "and " (CoreC-45TT-u--show_Show_Constant e-8)))) ((9) (let ((e-9 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "or " (CoreC-45TT-u--show_Show_Constant e-9)))) ((10) (let ((e-10 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "xor " (CoreC-45TT-u--show_Show_Constant e-10)))) ((11) (let ((e-11 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "<" (CoreC-45TT-u--show_Show_Constant e-11)))) ((12) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "<=" (CoreC-45TT-u--show_Show_Constant e-12)))) ((13) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "==" (CoreC-45TT-u--show_Show_Constant e-13)))) ((14) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 ">=" (CoreC-45TT-u--show_Show_Constant e-14)))) ((15) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 ">" (CoreC-45TT-u--show_Show_Constant e-15)))) ((16) "op_strlen") ((17) "op_strhead") ((18) "op_strtail") ((19) "op_strindex") ((20) "op_strcons") ((21) "++") ((22) "op_strrev") ((23) "op_strsubstr") ((24) "op_doubleExp") ((25) "op_doubleLog") ((26) "op_doublePow") ((27) "op_doubleSin") ((28) "op_doubleCos") ((29) "op_doubleTan") ((30) "op_doubleASin") ((31) "op_doubleACos") ((32) "op_doubleATan") ((33) "op_doubleSqrt") ((34) "op_doubleFloor") ((35) "op_doubleCeiling") ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "cast-" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant e-16) (PreludeC-45TypesC-45String-C-43C-43 "-" (CoreC-45TT-u--show_Show_Constant e-17))))))) ((37) "believe_me") (else "crash"))))
(define CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) "Implicit") ((1) "Explicit") ((2) "AutoImplicit") (else (let ((e-4 (vector-ref arg-2 1))) (PreludeC-45TypesC-45String-C-43C-43 "DefImplicit " (let ((e-1 (car arg-1))) (e-1 e-4))))))))
(define CoreC-45TT-u--showPrec_Show_TotalReq (lambda (arg-0 arg-1) (CoreC-45TT-u--show_Show_TotalReq arg-1)))
(define CoreC-45TT-u--showPrec_Show_KindedName (lambda (arg-0 arg-1) (CoreC-45TT-u--show_Show_KindedName arg-1)))
(define CoreC-45TT-u--showPrec_Show_Constant (lambda (arg-0 arg-1) (CoreC-45TT-u--show_Show_Constant arg-1)))
(define CoreC-45TT-u--showPrec_Show_C-40VarC-32C-36nsC-41 (lambda (arg-1 arg-2) (CoreC-45TT-u--show_Show_C-40VarC-32C-36nsC-41 arg-2)))
(define CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-2)))
(define CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 arg-1 arg-3)))
(define CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (case (vector-ref e-3 0) ((0) (let ((e-36 (vector-ref e-3 1))) (let ((e-37 (vector-ref e-3 2))) (let ((u--tm (vector 1 e-1 e-2 (vector 0 e-36 e-37)))) (let ((sc2 (DataC-45List-isNil (CoreC-45NameC-45Namespace-unsafeUnfoldNamespace e-36)))) (cond ((equal? sc2 1) (vector 1 e-1 e-2 (vector 0 arg-1 e-37))) (else u--tm)))))))(else arg-2)))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (vector 2 e-5 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (arg-3) (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-8))))))) ((3) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (vector 3 e-10 e-11 (CoreC-45TT-u--map_Functor_Binder (lambda (arg-3) (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-12) (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-13))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (vector 4 e-15 (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-16) (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-17)))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (vector 5 e-19 e-20 (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-21) (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-22))))))) ((6) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (vector 6 e-24 e-25 (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-26)))))) ((7) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (vector 7 e-28 e-29 (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-30) (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-31))))))) ((8) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((e-35 (vector-ref arg-2 3))) (vector 8 e-33 e-34 (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-35))))))(else arg-2))))
(define CoreC-45TT-u--pretty_Pretty_Visibility (lambda (arg-1) (cond ((equal? arg-1 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "private")) ((equal? arg-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "export")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "public") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "export"))))))
(define CoreC-45TT-u--pretty_Pretty_Totality (lambda (arg-1) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (case (vector-ref e-0 0) ((1) (case (vector-ref e-1 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "total"))(else (CoreC-45TT-u--pretty_Pretty_Covering e-1))))(else (case (vector-ref e-1 0) ((0) (CoreC-45TT-u--pretty_Pretty_Terminating e-0))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45TT-u--pretty_Pretty_Covering e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi)) (CoreC-45TT-u--pretty_Pretty_Terminating e-0))))))))))
(define CoreC-45TT-u--pretty_Pretty_Terminating (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not yet checked")) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "terminating")) (else (let ((e-0 (vector-ref arg-1 1))) (CoreC-45TT-u--pretty_Pretty_PartialReason e-0))))))
(define CoreC-45TT-u--pretty_Pretty_PartialReason (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not strictly positive")) ((1) (let ((e-0 (vector-ref arg-1 1))) (if (null? e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to calls to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) e-0))) (let ((e-3 (car e-0))) (let ((e-4 (cdr e-0))) (if (null? e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to call to") (CoreC-45Name-u--pretty_Pretty_Name e-3)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to calls to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) e-0))))))))) (else (let ((e-1 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to recursive path") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-545) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) e-1))))))))
(define CoreC-45TT-u--pretty_Pretty_Covering (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "covering")) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not covering all cases")) (else (let ((e-1 (vector-ref arg-1 1))) (if (null? e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not covering due to calls to functions") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) e-1))) (let ((e-3 (car e-1))) (let ((e-4 (cdr e-1))) (if (null? e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not covering due to call to function") (CoreC-45Name-u--pretty_Pretty_Name e-3)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not covering due to calls to functions") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) e-1))))))))))))
(define CoreC-45TT-u--pretty_Pretty_Constant (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int e-0))) ((1) (let ((e-1 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int8 e-1))) ((2) (let ((e-2 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int16 e-2))) ((3) (let ((e-3 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int32 e-3))) ((4) (let ((e-4 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int64 e-4))) ((5) (let ((e-5 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Integer e-5))) ((6) (let ((e-6 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bits8 e-6))) ((7) (let ((e-7 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bits16 e-7))) ((8) (let ((e-8 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bits32 e-8))) ((9) (let ((e-9 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bits64 e-9))) ((10) (let ((e-10 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-10)))) ((11) (let ((e-11 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char e-11)))) ((12) (let ((e-12 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Double e-12))) ((13) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "%MkWorld")) ((14) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Int")) ((15) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Int8")) ((16) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Int16")) ((17) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Int32")) ((18) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Int64")) ((19) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Integer")) ((20) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Bits8")) ((21) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Bits16")) ((22) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Bits32")) ((23) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Bits64")) ((24) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "String")) ((25) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Char")) ((26) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Double")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "%World")))))
(define CoreC-45TT-u--pretty_Pretty_C-40TermC-32C-36varsC-41 (lambda (arg-1 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-1 ext-0))))
(define CoreC-45TT-u--null_Foldable_Binder (lambda (ext-0) (CoreC-45TT-u--foldr_Foldable_Binder (lambda (_-4178) (lambda (_-4180) (lambda () 0))) (lambda () 1) ext-0)))
(define CoreC-45TT-u--map_Functor_PiInfo (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (vector 1 )) ((0) (vector 0 )) ((2) (vector 2 )) (else (let ((e-4 (vector-ref arg-3 1))) (vector 3 (arg-2 e-4)))))))
(define CoreC-45TT-u--map_Functor_Binder (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (vector 0 e-1 e-2 (CoreC-45TT-u--map_Functor_PiInfo arg-2 e-3) (arg-2 e-4))))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (vector 1 e-6 e-7 (arg-2 e-8) (arg-2 e-9))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (vector 2 e-11 e-12 (CoreC-45TT-u--map_Functor_PiInfo arg-2 e-13) (arg-2 e-14))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (vector 3 e-16 e-17 (CoreC-45TT-u--map_Functor_PiInfo arg-2 e-18) (arg-2 e-19))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (vector 4 e-21 e-22 (arg-2 e-23) (arg-2 e-24))))))) (else (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (vector 5 e-26 e-27 (arg-2 e-28)))))))))
(define CoreC-45TT-u--foldr_Foldable_PiInfo (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) arg-3) ((1) arg-3) ((2) arg-3) (else (let ((e-4 (vector-ref arg-4 1))) ((arg-2 e-4) arg-3))))))
(define CoreC-45TT-u--foldr_Foldable_Binder (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (CoreC-45TT-u--foldr_Foldable_PiInfo arg-2 ((arg-2 e-4) arg-3) e-3)))) ((1) (let ((e-8 (vector-ref arg-4 3))) (let ((e-9 (vector-ref arg-4 4))) ((arg-2 e-8) ((arg-2 e-9) arg-3))))) ((2) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (CoreC-45TT-u--foldr_Foldable_PiInfo arg-2 ((arg-2 e-14) arg-3) e-13)))) ((3) (let ((e-18 (vector-ref arg-4 3))) (let ((e-19 (vector-ref arg-4 4))) (CoreC-45TT-u--foldr_Foldable_PiInfo arg-2 ((arg-2 e-19) arg-3) e-18)))) ((4) (let ((e-23 (vector-ref arg-4 3))) (let ((e-24 (vector-ref arg-4 4))) ((arg-2 e-23) ((arg-2 e-24) arg-3))))) (else (let ((e-28 (vector-ref arg-4 3))) ((arg-2 e-28) arg-3))))))
(define CoreC-45TT-u--foldl_Foldable_Binder (lambda (arg-2 arg-3 arg-4) ((CoreC-45TT-u--foldr_Foldable_Binder (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (csegen-115) (lambda (eta-2) (PreludeC-45Basics-flip arg-2 eta-0 eta-2)) eta-1))) (lambda (eta-0) eta-0) arg-4) arg-3)))
(define CoreC-45TT-u--foldlM_Foldable_Binder (lambda (arg-3 arg-4 arg-5 ext-0) (CoreC-45TT-u--foldl_Foldable_Binder (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-3 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-4 u--b eta-0)))))) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-5))) ext-0)))
(define CoreC-45TT-u--foldMap_Foldable_Binder (lambda (arg-2 arg-3 ext-0) (CoreC-45TT-u--foldr_Foldable_Binder (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-2))) ((e-1 (arg-3 eta-0)) eta-1)))) (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define CoreC-45TT-u--compare_Ord_Precision (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) 1 2) (let ((e-0 (unbox arg-0))) (if (null? arg-1) 0 (let ((e-1 (unbox arg-1))) (PreludeC-45EqOrd-u--compare_Ord_Int e-0 e-1)))))))
(define CoreC-45TT-u--C-62_Ord_Precision (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45TT-u--compare_Ord_Precision arg-0 arg-1) 2)))
(define CoreC-45TT-u--C-62C-61_Ord_Precision (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45TT-u--compare_Ord_Precision arg-0 arg-1) 0)))
(define CoreC-45TT-u--C-61C-61_Eq_Visibility (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define CoreC-45TT-u--C-61C-61_Eq_TotalReq (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define CoreC-45TT-u--C-61C-61_Eq_LazyReason (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define CoreC-45TT-u--C-61C-61_Eq_Constant (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-0 e-13)))(else 0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 e-1 e-14)))(else 0)))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 e-2 e-15)))(else 0)))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 e-3 e-16)))(else 0)))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 e-4 e-17)))(else 0)))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer e-5 e-18)))(else 0)))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 e-6 e-19)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 e-7 e-20)))(else 0)))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 e-8 e-21)))(else 0)))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 e-9 e-22)))(else 0)))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-10 e-23)))(else 0)))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-11 e-24)))(else 0)))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Double e-12 e-25)))(else 0)))) ((13) (case (vector-ref arg-1 0) ((13) 1)(else 0))) ((14) (case (vector-ref arg-1 0) ((14) 1)(else 0))) ((15) (case (vector-ref arg-1 0) ((15) 1)(else 0))) ((16) (case (vector-ref arg-1 0) ((16) 1)(else 0))) ((17) (case (vector-ref arg-1 0) ((17) 1)(else 0))) ((18) (case (vector-ref arg-1 0) ((18) 1)(else 0))) ((19) (case (vector-ref arg-1 0) ((19) 1)(else 0))) ((20) (case (vector-ref arg-1 0) ((20) 1)(else 0))) ((21) (case (vector-ref arg-1 0) ((21) 1)(else 0))) ((22) (case (vector-ref arg-1 0) ((22) 1)(else 0))) ((23) (case (vector-ref arg-1 0) ((23) 1)(else 0))) ((24) (case (vector-ref arg-1 0) ((24) 1)(else 0))) ((25) (case (vector-ref arg-1 0) ((25) 1)(else 0))) ((26) (case (vector-ref arg-1 0) ((26) 1)(else 0))) ((27) (case (vector-ref arg-1 0) ((27) 1)(else 0)))(else 0))))
(define CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((0) (let ((e-54 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-61C-61_Eq_Nat e-4 e-54)))(else 0)))) ((1) (let ((e-9 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((1) (let ((e-59 (vector-ref arg-2 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-9 e-59)))(else 0)))) ((2) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((2) (let ((e-63 (vector-ref arg-2 3))) (let ((e-64 (vector-ref arg-2 4))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-13 e-63))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-546) e-14 e-64)) (else 0))))))(else 0))))) ((3) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((3) (let ((e-68 (vector-ref arg-2 3))) (let ((e-69 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_C-40BinderC-32C-36aC-41 (csegen-546) e-18 e-68))) (cond ((equal? sc2 1) (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-19 (Builtin-believe_me e-69))) (else 0))))))(else 0))))) ((4) (let ((e-22 (vector-ref arg-1 2))) (let ((e-23 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-72 (vector-ref arg-2 2))) (let ((e-73 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-22 e-72))) (cond ((equal? sc2 1) (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-23 e-73)) (else 0))))))(else 0))))) ((5) (let ((e-27 (vector-ref arg-1 3))) (let ((e-28 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((5) (let ((e-77 (vector-ref arg-2 3))) (let ((e-78 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-27 e-77))) (cond ((equal? sc2 1) (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-28 e-78)) (else 0))))))(else 0))))) ((6) (let ((e-32 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-82 (vector-ref arg-2 3))) (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-32 e-82)))(else 0)))) ((7) (let ((e-36 (vector-ref arg-1 3))) (let ((e-37 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-86 (vector-ref arg-2 3))) (let ((e-87 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-36 e-86))) (cond ((equal? sc2 1) (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-37 e-87)) (else 0))))))(else 0))))) ((8) (let ((e-41 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-91 (vector-ref arg-2 3))) (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 e-41 e-91)))(else 0)))) ((9) (let ((e-44 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-94 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-44 e-94)))(else 0)))) ((10) (let ((e-47 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((10) (let ((e-97 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool e-47 e-97)))(else 0)))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))
(define CoreC-45TT-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 ext-0 ext-1) (CoreC-45TT-eqPiInfoBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define CoreC-45TT-u--C-61C-61_Eq_C-40BinderC-32C-36aC-41 (lambda (arg-1 ext-0 ext-1) (CoreC-45TT-eqBinderBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define CoreC-45TT-u--C-60_Ord_TotalReq (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-u--C-60C-61_Ord_TotalReq arg-0 arg-1))) (cond ((equal? sc0 1) (CoreC-45TT-u--C-47C-61_Eq_TotalReq arg-0 arg-1)) (else 0)))))
(define CoreC-45TT-u--C-60_Ord_Precision (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45TT-u--compare_Ord_Precision arg-0 arg-1) 0)))
(define CoreC-45TT-u--C-60C-61_Ord_TotalReq (lambda (arg-0 arg-1) (cond ((equal? arg-0 2) 1)(else (cond ((equal? arg-1 0) 1)(else (CoreC-45TT-u--C-61C-61_Eq_TotalReq arg-0 arg-1)))))))
(define CoreC-45TT-u--C-60C-61_Ord_Precision (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45TT-u--compare_Ord_Precision arg-0 arg-1) 2)))
(define CoreC-45TT-u--C-47C-61_Eq_Visibility (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-u--C-61C-61_Eq_Visibility arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45TT-u--C-47C-61_Eq_TotalReq (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-u--C-61C-61_Eq_TotalReq arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45TT-u--C-47C-61_Eq_Constant (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-u--C-61C-61_Eq_Constant arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45TT-u--C-47C-61_Eq_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45TTC-45SizeOf-zero(blodwen-lazy (lambda () 0)))
(define CoreC-45TT-withPiInfo (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-3 ")"))) ((0) (PreludeC-45TypesC-45String-C-43C-43 "{" (PreludeC-45TypesC-45String-C-43C-43 arg-3 "}"))) ((2) (PreludeC-45TypesC-45String-C-43C-43 "{auto " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "}"))) (else (let ((e-4 (vector-ref arg-2 1))) (PreludeC-45TypesC-45String-C-43C-43 "{default " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-1 (car arg-1))) (e-1 e-4)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "}")))))))))
(define CoreC-45TT-weakenVar (lambda (arg-2 arg-3) (CoreC-45TT-weakenNVar arg-2 arg-3)))
(define CoreC-45TT-weakenNVar (lambda (arg-3 arg-4) (CoreC-45TT-case--weakenNVar-7684 arg-4 arg-3 (CoreC-45TT-sizedView arg-3))))
(define CoreC-45TT-varIdx (lambda (arg-1) arg-1))
(define CoreC-45TT-varEmbedSub (lambda (arg-3 arg-4) (case (vector-ref arg-3 0) ((0) arg-4) ((1) (let ((e-4 (vector-ref arg-3 1))) (+ 1 (CoreC-45TT-varEmbedSub e-4 arg-4)))) (else (let ((e-8 (vector-ref arg-3 1))) (cond ((equal? arg-4 0) 0)(else (let ((e-9 (- arg-4 1))) (+ 1 (CoreC-45TT-varEmbedSub e-8 e-9))))))))))
(define CoreC-45TT-unchecked(blodwen-lazy (lambda () (cons (vector 0 ) (vector 0 )))))
(define CoreC-45TTC-45SizeOf-take (lambda (arg-1) arg-1))
(define CoreC-45TTC-45SizeOf-sucR (lambda (arg-3) (+ 1 arg-3)))
(define CoreC-45TTC-45SizeOf-suc (lambda (arg-3) (+ 1 arg-3)))
(define CoreC-45TTC-45SubstEnv-substs (lambda (arg-2 arg-3) (CoreC-45TTC-45SubstEnv-substEnv (CoreC-45TTC-45SizeOf-zero) arg-2 arg-3)))
(define CoreC-45TT-substName (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((sc1 (CoreC-45Name-nameEq arg-1 e-3))) (if (null? sc1) (vector 1 e-1 e-2 e-3) (let ((e-4 (unbox sc1))) (cond (else arg-2))))))))) ((2) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (vector 2 e-5 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-substName arg-1 arg-2 eta-0)) e-8))))))) ((3) (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (vector 3 e-10 e-11 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TT-substName arg-1 arg-2 eta-0)) e-12) (CoreC-45TT-substName arg-1 (CoreC-45TT-u--weaken_Weaken_Term arg-2) e-13))))))) ((4) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (vector 4 e-15 (CoreC-45TT-substName arg-1 arg-2 e-16) (CoreC-45TT-substName arg-1 arg-2 e-17)))))) ((5) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (vector 5 e-19 e-20 e-21 (CoreC-45TT-substName arg-1 arg-2 e-22))))))) ((6) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (vector 6 e-24 e-25 (CoreC-45TT-substName arg-1 arg-2 e-26)))))) ((7) (let ((e-28 (vector-ref arg-3 1))) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (let ((e-31 (vector-ref arg-3 4))) (vector 7 e-28 e-29 (CoreC-45TT-substName arg-1 arg-2 e-30) (CoreC-45TT-substName arg-1 arg-2 e-31))))))) ((8) (let ((e-33 (vector-ref arg-3 1))) (let ((e-34 (vector-ref arg-3 2))) (let ((e-35 (vector-ref arg-3 3))) (vector 8 e-33 e-34 (CoreC-45TT-substName arg-1 arg-2 e-35))))))(else arg-3))))
(define CoreC-45TTC-45SubstEnv-substEnv (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (CoreC-45TTC-45SubstEnv-find e-2 e-3 arg-3 e-4 arg-4))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (vector 2 e-11 e-12 e-13 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 eta-0)) e-14))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (vector 3 e-16 e-17 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 eta-0)) e-18) (CoreC-45TTC-45SubstEnv-substEnv (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-19))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (vector 4 e-21 (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 e-22) (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 e-23)))))) ((5) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-27 (vector-ref arg-5 3))) (let ((e-28 (vector-ref arg-5 4))) (vector 5 e-25 e-26 (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 e-27) (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 e-28))))))) ((6) (let ((e-30 (vector-ref arg-5 1))) (let ((e-31 (vector-ref arg-5 2))) (let ((e-32 (vector-ref arg-5 3))) (vector 6 e-30 e-31 (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 e-32)))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (let ((e-37 (vector-ref arg-5 4))) (vector 7 e-34 e-35 (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 e-36) (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 e-37))))))) ((8) (let ((e-39 (vector-ref arg-5 1))) (let ((e-40 (vector-ref arg-5 2))) (let ((e-41 (vector-ref arg-5 3))) (vector 8 e-39 e-40 (CoreC-45TTC-45SubstEnv-substEnv arg-3 arg-4 e-41)))))) ((9) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (vector 10 e-46 e-47)))) (else (let ((e-49 (vector-ref arg-5 1))) (vector 11 e-49))))))
(define CoreC-45TTC-45SubstEnv-subst (lambda (arg-2 arg-3) (CoreC-45TTC-45SubstEnv-substs (cons arg-2 '()) arg-3)))
(define CoreC-45TT-subExtend (lambda (arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-3 (cdr arg-2))) (vector 2 (CoreC-45TT-subExtend e-3 arg-3))))))
(define CoreC-45TT-subElem (lambda (arg-3 arg-5) (case (vector-ref arg-5 0) ((0) (box arg-3))(else (cond ((equal? arg-3 0) (case (vector-ref arg-5 0) ((1) '()) (else (box 0))))(else (let ((e-0 (- arg-3 1))) (case (vector-ref arg-5 0) ((1) (let ((e-12 (vector-ref arg-5 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-subElem e-0 e-12) (lambda (_-0) (box _-0))))) (else (let ((e-16 (vector-ref arg-5 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-subElem e-0 e-16) (csegen-549))))))))))))
(define CoreC-45TT-sizedView (lambda (arg-2) (cond ((equal? arg-2 0) '())(else (let ((e-4 (- arg-2 1))) (box e-4))))))
(define CoreC-45TTC-45Bounds-sizeOf (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (CoreC-45TTC-45SizeOf-zero)) (else (let ((e-3 (vector-ref arg-1 3))) (CoreC-45TTC-45SizeOf-suc (CoreC-45TTC-45Bounds-sizeOf e-3)))))))
(define CoreC-45TT-shrinkTerm (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (lamc-0) (vector 0 e-2 e-3 lamc-0)) (CoreC-45TT-subElem e-4 arg-3)))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (box (vector 1 e-7 e-8 e-9)))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (u--x) (CoreC-45TT-shrinkTerm u--x arg-3)) e-14) (lambda (u--xsC-39) (box (vector 2 e-11 e-12 e-13 u--xsC-39))))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkBinder e-18 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-19 (vector 2 arg-3)) (lambda (bind-1) (box (vector 3 e-16 e-17 bind-0 bind-1))))))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-22 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-23 arg-3) (lambda (bind-1) (box (vector 4 e-21 bind-0 bind-1)))))))))) ((5) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-27 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-28 arg-3) (lambda (bind-1) (box (vector 5 e-25 e-26 bind-0 bind-1))))))))))) ((6) (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-32 arg-3) (lambda (bind-0) (box (vector 6 e-30 e-31 bind-0)))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-36 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-37 arg-3) (lambda (bind-1) (box (vector 7 e-34 e-35 bind-0 bind-1))))))))))) ((8) (let ((e-39 (vector-ref arg-2 1))) (let ((e-40 (vector-ref arg-2 2))) (let ((e-41 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-41 arg-3) (lambda (bind-0) (box (vector 8 e-39 e-40 bind-0)))))))) ((9) (let ((e-43 (vector-ref arg-2 1))) (let ((e-44 (vector-ref arg-2 2))) (box (vector 9 e-43 e-44))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (box (vector 10 e-46 e-47))))) (else (let ((e-49 (vector-ref arg-2 1))) (box (vector 11 e-49)))))))
(define CoreC-45TT-shrinkPi (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 ))) ((0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 ))) ((2) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 ))) (else (let ((e-4 (vector-ref arg-2 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-4 arg-3) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 bind-0)))))))))
(define CoreC-45TT-shrinkBinder (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkPi e-3 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-4 arg-3) (lambda (bind-1) (box (vector 0 e-1 e-2 bind-0 bind-1))))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-8 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-9 arg-3) (lambda (bind-1) (box (vector 1 e-6 e-7 bind-0 bind-1))))))))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkPi e-13 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-14 arg-3) (lambda (bind-1) (box (vector 2 e-11 e-12 bind-0 bind-1))))))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkPi e-18 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-19 arg-3) (lambda (bind-1) (box (vector 3 e-16 e-17 bind-0 bind-1))))))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-23 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-24 arg-3) (lambda (bind-1) (box (vector 4 e-21 e-22 bind-0 bind-1))))))))))) (else (let ((e-26 (vector-ref arg-2 1))) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-28 arg-3) (lambda (bind-0) (box (vector 5 e-26 e-27 bind-0)))))))))))
(define CoreC-45TT-setMultiplicity (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (vector 0 e-1 arg-2 e-3 e-4))))) ((1) (let ((e-6 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 3))) (let ((e-9 (vector-ref arg-1 4))) (vector 1 e-6 arg-2 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (vector 2 e-11 arg-2 e-13 e-14))))) ((3) (let ((e-16 (vector-ref arg-1 1))) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (vector 3 e-16 arg-2 e-18 e-19))))) ((4) (let ((e-21 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 3))) (let ((e-24 (vector-ref arg-1 4))) (vector 4 e-21 arg-2 e-23 e-24))))) (else (let ((e-26 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 3))) (vector 5 e-26 arg-2 e-28)))))))
(define CoreC-45TT-sameVar (lambda (arg-1 arg-2) (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-1 arg-2)))
(define CoreC-45TTC-45SizeOf-reverse (lambda (arg-2) arg-2))
(define CoreC-45TT-resolveRef (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-6 0) ((0) '()) (else (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-8 e-2))) (cond ((equal? sc1 1) (box (vector 0 arg-7 '() (CoreC-45TT-weakenNVar (CoreC-45TTC-45SizeOf-C-43 arg-4 arg-5) 0)))) (else (CoreC-45TT-resolveRef arg-4 (CoreC-45TTC-45SizeOf-sucR arg-5) e-3 arg-7 arg-8))))))))))
(define CoreC-45TT-resolveNames (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref e-2 0) ((0) (let ((sc2 (CoreC-45TT-isNVar e-3 arg-0))) (if (null? sc2) (vector 1 e-1 (vector 0 ) e-3) (let ((e-4 (unbox sc2))) (vector 0 e-1 (box 0) e-4)))))(else arg-1)))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (vector 2 e-5 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-resolveNames arg-0 eta-0)) e-8))))))) ((3) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (let ((e-12 (vector-ref arg-1 3))) (let ((e-13 (vector-ref arg-1 4))) (vector 3 e-10 e-11 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TT-resolveNames arg-0 eta-0)) e-12) (CoreC-45TT-resolveNames (cons e-11 arg-0) e-13))))))) ((4) (let ((e-15 (vector-ref arg-1 1))) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (vector 4 e-15 (CoreC-45TT-resolveNames arg-0 e-16) (CoreC-45TT-resolveNames arg-0 e-17)))))) ((5) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (let ((e-22 (vector-ref arg-1 4))) (vector 5 e-19 e-20 (CoreC-45TT-resolveNames arg-0 e-21) (CoreC-45TT-resolveNames arg-0 e-22))))))) ((6) (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 3))) (vector 6 e-24 e-25 (CoreC-45TT-resolveNames arg-0 e-26)))))) ((7) (let ((e-28 (vector-ref arg-1 1))) (let ((e-29 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 3))) (let ((e-31 (vector-ref arg-1 4))) (vector 7 e-28 e-29 (CoreC-45TT-resolveNames arg-0 e-30) (CoreC-45TT-resolveNames arg-0 e-31))))))) ((8) (let ((e-33 (vector-ref arg-1 1))) (let ((e-34 (vector-ref arg-1 2))) (let ((e-35 (vector-ref arg-1 3))) (vector 8 e-33 e-34 (CoreC-45TT-resolveNames arg-0 e-35))))))(else arg-1))))
(define CoreC-45TT-renameVars (lambda (arg-2 arg-3) (Builtin-believe_me arg-3)))
(define CoreC-45TT-renameTop (lambda (arg-2 arg-3) (CoreC-45TT-renameVars (+ 1 0) arg-3)))
(define CoreC-45TT-refsToLocals (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) arg-3)(else (CoreC-45TT-mkLocals (CoreC-45TTC-45SizeOf-zero) arg-2 arg-3)))))
(define CoreC-45TT-refToLocal (lambda (arg-1 arg-2 arg-3) (CoreC-45TT-refsToLocals (vector 1 arg-2 arg-1 (vector 0 )) arg-3)))
(define CoreC-45TT-piInfo (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 3))) e-3)) ((1) (vector 1 )) ((2) (let ((e-13 (vector-ref arg-1 3))) e-13)) ((3) (let ((e-18 (vector-ref arg-1 3))) e-18)) ((4) (vector 1 )) (else (vector 1 )))))
(define CoreC-45TT-notCovering(blodwen-lazy (lambda () (cons (vector 0 ) (vector 1 '())))))
(define CoreC-45TT-nameAt (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (cond ((equal? arg-2 0) e-1)(else (let ((e-3 (- arg-2 1))) (CoreC-45TT-nameAt e-2 e-3))))))))
(define CoreC-45TT-multiplicity (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) e-2)) ((1) (let ((e-7 (vector-ref arg-1 2))) e-7)) ((2) (let ((e-12 (vector-ref arg-1 2))) e-12)) ((3) (let ((e-17 (vector-ref arg-1 2))) e-17)) ((4) (let ((e-22 (vector-ref arg-1 2))) e-22)) (else (let ((e-27 (vector-ref arg-1 2))) e-27)))))
(define CoreC-45TTC-45SizeOf-mkSizeOf (lambda (arg-1) (PreludeC-45TypesC-45List-length arg-1)))
(define CoreC-45TT-mkLocals (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (vector 0 e-2 e-3 (CoreC-45TT-addVars arg-3 arg-4 e-4)))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (case (vector-ref e-8 0) ((0) (PreludeC-45Types-maybe (lambda () (vector 1 e-7 (vector 0 ) e-9)) (lambda () (lambda (eta-0) eta-0)) (CoreC-45TT-resolveRef arg-3 (CoreC-45TTC-45SizeOf-zero) arg-4 e-7 e-9)))(else (vector 1 e-7 e-8 e-9))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (PreludeC-45Types-maybe (lambda () (vector 2 e-11 e-12 e-13 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-mkLocals arg-3 arg-4 eta-0)) e-14))) (lambda () (lambda (eta-0) eta-0)) (CoreC-45TT-resolveRef arg-3 (CoreC-45TTC-45SizeOf-zero) arg-4 e-11 e-12))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (vector 3 e-16 e-17 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TT-mkLocals arg-3 arg-4 eta-0)) e-18) (CoreC-45TT-mkLocals (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-19))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (vector 4 e-21 (CoreC-45TT-mkLocals arg-3 arg-4 e-22) (CoreC-45TT-mkLocals arg-3 arg-4 e-23)))))) ((5) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-27 (vector-ref arg-5 3))) (let ((e-28 (vector-ref arg-5 4))) (vector 5 e-25 e-26 (CoreC-45TT-mkLocals arg-3 arg-4 e-27) (CoreC-45TT-mkLocals arg-3 arg-4 e-28))))))) ((6) (let ((e-30 (vector-ref arg-5 1))) (let ((e-31 (vector-ref arg-5 2))) (let ((e-32 (vector-ref arg-5 3))) (vector 6 e-30 e-31 (CoreC-45TT-mkLocals arg-3 arg-4 e-32)))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (let ((e-37 (vector-ref arg-5 4))) (vector 7 e-34 e-35 (CoreC-45TT-mkLocals arg-3 arg-4 e-36) (CoreC-45TT-mkLocals arg-3 arg-4 e-37))))))) ((8) (let ((e-39 (vector-ref arg-5 1))) (let ((e-40 (vector-ref arg-5 2))) (let ((e-41 (vector-ref arg-5 3))) (vector 8 e-39 e-40 (CoreC-45TT-mkLocals arg-3 arg-4 e-41)))))) ((9) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (vector 10 e-46 e-47)))) (else (let ((e-49 (vector-ref arg-5 1))) (vector 11 e-49))))))
(define CoreC-45TTC-45SizeOf-map (lambda (arg-4) arg-4))
(define CoreC-45TTC-45Var-later (lambda (arg-2) (+ 1 arg-2)))
(define CoreC-45TTC-45NVar-later (lambda (arg-3) (+ 1 arg-3)))
(define CoreC-45TT-isVar (lambda (arg-0 arg-1) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-isNVar arg-0 arg-1) (lambda (_-0) (PreludeC-45Types-u--pure_Applicative_Maybe _-0)))))
(define CoreC-45TT-isTotal(blodwen-lazy (lambda () (cons (vector 0 ) (vector 0 )))))
(define CoreC-45TT-isPrimType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 0) ((2) 0) ((3) 0) ((4) 0) ((5) 0) ((6) 0) ((7) 0) ((8) 0) ((9) 0) ((10) 0) ((11) 0) ((12) 0) ((13) 0) ((15) 1) ((16) 1) ((17) 1) ((18) 1) ((14) 1) ((19) 1) ((20) 1) ((21) 1) ((22) 1) ((23) 1) ((24) 1) ((25) 1) ((26) 1) (else 1))))
(define CoreC-45TT-isNVar (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (CoreC-45Name-nameEq arg-0 e-2))) (if (null? sc1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45TTC-45NVar-later eta-0)) (CoreC-45TT-isNVar arg-0 e-3)) (let ((e-4 (unbox sc1))) (cond (else (PreludeC-45Types-u--pure_Applicative_Maybe 0)))))))))))
(define CoreC-45TT-isLet (lambda (arg-1) (case (vector-ref arg-1 0) ((1) 1)(else 0))))
(define CoreC-45TT-isImplicit (lambda (arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref e-3 0) ((1) 0)(else 1)))) ((0) (let ((e-8 (vector-ref arg-1 3))) (case (vector-ref e-8 0) ((1) 0)(else 1))))(else 0))))
(define CoreC-45TT-isErased (lambda (arg-1) (case (vector-ref arg-1 0) ((10) 1)(else 0))))
(define CoreC-45TT-isConstantType (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (cond ((equal? e-1 "Int") (box (vector 14 ))) ((equal? e-1 "Int8") (box (vector 15 ))) ((equal? e-1 "Int16") (box (vector 16 ))) ((equal? e-1 "Int32") (box (vector 17 ))) ((equal? e-1 "Int64") (box (vector 18 ))) ((equal? e-1 "Integer") (box (vector 19 ))) ((equal? e-1 "Bits8") (box (vector 20 ))) ((equal? e-1 "Bits16") (box (vector 21 ))) ((equal? e-1 "Bits32") (box (vector 22 ))) ((equal? e-1 "Bits64") (box (vector 23 ))) ((equal? e-1 "String") (box (vector 24 ))) ((equal? e-1 "Char") (box (vector 25 ))) ((equal? e-1 "Double") (box (vector 26 ))) ((equal? e-1 "%World") (box (vector 27 )))(else '()))))(else '()))))(else '()))))
(define CoreC-45TT-isCon (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (box (cons e-0 e-1))))) ((3) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (box (cons e-2 e-3)))))(else '()))))
(define CoreC-45TT-intKind (lambda (arg-0) (case (vector-ref arg-0 0) ((19) (box (vector 0 '()))) ((15) (box (vector 0 (box 8)))) ((16) (box (vector 0 (box 16)))) ((17) (box (vector 0 (box 32)))) ((18) (box (vector 0 (box 64)))) ((14) (box (vector 0 (box 64)))) ((20) (box (vector 1 8))) ((21) (box (vector 1 16))) ((22) (box (vector 1 32))) ((23) (box (vector 1 64)))(else '()))))
(define CoreC-45TT-insertNames (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (vector 0 e-2 e-3 (CoreC-45TT-insertNVarNames arg-3 arg-4 e-4)))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (vector 2 e-11 e-12 e-13 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-insertNames arg-3 arg-4 eta-0)) e-14))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (vector 3 e-16 e-17 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TT-insertNames arg-3 arg-4 eta-0)) e-18) (CoreC-45TT-insertNames (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-19))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (vector 4 e-21 (CoreC-45TT-insertNames arg-3 arg-4 e-22) (CoreC-45TT-insertNames arg-3 arg-4 e-23)))))) ((5) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-27 (vector-ref arg-5 3))) (let ((e-28 (vector-ref arg-5 4))) (vector 5 e-25 e-26 (CoreC-45TT-insertNames arg-3 arg-4 e-27) (CoreC-45TT-insertNames arg-3 arg-4 e-28))))))) ((6) (let ((e-30 (vector-ref arg-5 1))) (let ((e-31 (vector-ref arg-5 2))) (let ((e-32 (vector-ref arg-5 3))) (vector 6 e-30 e-31 (CoreC-45TT-insertNames arg-3 arg-4 e-32)))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (let ((e-37 (vector-ref arg-5 4))) (vector 7 e-34 e-35 (CoreC-45TT-insertNames arg-3 arg-4 e-36) (CoreC-45TT-insertNames arg-3 arg-4 e-37))))))) ((8) (let ((e-39 (vector-ref arg-5 1))) (let ((e-40 (vector-ref arg-5 2))) (let ((e-41 (vector-ref arg-5 3))) (vector 8 e-39 e-40 (CoreC-45TT-insertNames arg-3 arg-4 e-41)))))) ((9) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (vector 10 e-46 e-47)))) (else (let ((e-49 (vector-ref arg-5 1))) (vector 11 e-49))))))
(define CoreC-45TT-insertNVarNames (lambda (arg-4 arg-5 arg-6) (CoreC-45TT-case--insertNVarNames-8140 arg-6 arg-5 arg-4 (CoreC-45TT-sizedView arg-4))))
(define CoreC-45TT-insertNVar (lambda (arg-4 arg-5) (CoreC-45TT-case--insertNVar-7738 arg-5 arg-4 (CoreC-45TT-sizedView arg-4))))
(define CoreC-45TT-getRefs (lambda (arg-1 arg-2) (CoreC-45TT-addRefs 0 arg-1 (LibrariesC-45DataC-45NameMap-empty) arg-2)))
(define CoreC-45TT-getMetas (lambda (arg-1) (CoreC-45TT-addMetas (LibrariesC-45DataC-45NameMap-empty) arg-1)))
(define CoreC-45TT-getLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) e-2)) ((1) (let ((e-7 (vector-ref arg-1 1))) e-7)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-16 (vector-ref arg-1 1))) e-16)) ((4) (let ((e-21 (vector-ref arg-1 1))) e-21)) ((5) (let ((e-25 (vector-ref arg-1 1))) e-25)) ((6) (let ((e-30 (vector-ref arg-1 1))) e-30)) ((7) (let ((e-34 (vector-ref arg-1 1))) e-34)) ((8) (let ((e-39 (vector-ref arg-1 1))) e-39)) ((9) (let ((e-43 (vector-ref arg-1 1))) e-43)) ((10) (let ((e-46 (vector-ref arg-1 1))) e-46)) (else (let ((e-49 (vector-ref arg-1 1))) e-49)))))
(define CoreC-45TT-getFnArgs (lambda (arg-1) (CoreC-45TT-n--13118-8795-u--getFA arg-1 '() arg-1)))
(define CoreC-45TT-getFn (lambda (arg-1) (case (vector-ref arg-1 0) ((4) (let ((e-2 (vector-ref arg-1 2))) (CoreC-45TT-getFn e-2)))(else arg-1))))
(define CoreC-45TT-getArgs (lambda (ext-0) (Builtin-snd (CoreC-45TT-getFnArgs ext-0))))
(define CoreC-45TT-forgetDef (lambda (arg-2) (case (vector-ref arg-2 0) ((1) (vector 1 )) ((0) (vector 0 )) ((2) (vector 2 )) (else (vector 0 )))))
(define CoreC-45TT-fnType (lambda (arg-0 arg-1 arg-2 arg-3) (vector 3 (CoreC-45FC-emptyFC) (vector 2 "_" 0) (vector 2 arg-1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) arg-2) (CoreC-45TT-u--weaken_Weaken_Term arg-3))))
(define CoreC-45TTC-45SubstEnv-findDrop (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (vector 0 arg-2 arg-3 arg-4) (cond ((equal? arg-4 0) (let ((e-8 (car arg-5))) e-8))(else (let ((e-4 (- arg-4 1))) (let ((e-14 (cdr arg-5))) (CoreC-45TTC-45SubstEnv-findDrop arg-2 arg-3 e-4 e-14))))))))
(define CoreC-45TTC-45SubstEnv-find (lambda (arg-3 arg-4 arg-5 arg-6 arg-7) (CoreC-45TTC-45SubstEnv-case--find-10758 arg-7 arg-6 arg-5 arg-4 arg-3 (CoreC-45TT-sizedView arg-5))))
(define CoreC-45TT-eqTerm (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((0) (let ((e-54 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-61C-61_Eq_Nat e-4 e-54)))(else 0)))) ((1) (let ((e-9 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((1) (let ((e-59 (vector-ref arg-3 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-9 e-59)))(else 0)))) ((2) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((2) (let ((e-63 (vector-ref arg-3 3))) (let ((e-64 (vector-ref arg-3 4))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-13 e-63))) (cond ((equal? sc2 1) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (csegen-551) eta-0)) (DataC-45List-u--zip_Zippable_List e-14 e-64))) (else 0))))))(else 0))))) ((3) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((3) (let ((e-68 (vector-ref arg-3 3))) (let ((e-69 (vector-ref arg-3 4))) (let ((sc2 (CoreC-45TT-eqBinderBy (csegen-551) e-18 e-68))) (cond ((equal? sc2 1) (CoreC-45TT-eqTerm e-19 e-69)) (else 0))))))(else 0))))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((4) (let ((e-72 (vector-ref arg-3 2))) (let ((e-73 (vector-ref arg-3 3))) (let ((sc2 (CoreC-45TT-eqTerm e-22 e-72))) (cond ((equal? sc2 1) (CoreC-45TT-eqTerm e-23 e-73)) (else 0))))))(else 0))))) ((5) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((5) (let ((e-77 (vector-ref arg-3 3))) (let ((e-78 (vector-ref arg-3 4))) (let ((sc2 (CoreC-45TT-eqTerm e-27 e-77))) (cond ((equal? sc2 1) (CoreC-45TT-eqTerm e-28 e-78)) (else 0))))))(else 0))))) ((6) (let ((e-32 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((6) (let ((e-82 (vector-ref arg-3 3))) (CoreC-45TT-eqTerm e-32 e-82)))(else 0)))) ((7) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-86 (vector-ref arg-3 3))) (let ((e-87 (vector-ref arg-3 4))) (let ((sc2 (CoreC-45TT-eqTerm e-36 e-86))) (cond ((equal? sc2 1) (CoreC-45TT-eqTerm e-37 e-87)) (else 0))))))(else 0))))) ((8) (let ((e-41 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((8) (let ((e-91 (vector-ref arg-3 3))) (CoreC-45TT-eqTerm e-41 e-91)))(else 0)))) ((9) (let ((e-44 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((9) (let ((e-94 (vector-ref arg-3 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-44 e-94)))(else 0)))) ((10) (let ((e-47 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((10) (let ((e-97 (vector-ref arg-3 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool e-47 e-97)))(else 0)))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))
(define CoreC-45TT-eqPiInfoBy (lambda (arg-2 ext-0 ext-1) (CoreC-45TT-n--6786-2857-u--go arg-2 ext-0 ext-1)))
(define CoreC-45TT-eqBinderBy (lambda (arg-2 ext-0 ext-1) (CoreC-45TT-n--9933-5927-u--go arg-2 ext-0 ext-1)))
(define CoreC-45TT-embedSub (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (vector 0 e-2 e-3 (CoreC-45TT-varEmbedSub arg-2 e-4)))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (vector 2 e-11 e-12 e-13 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-embedSub arg-2 eta-0)) e-14))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (vector 3 e-16 e-17 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TT-embedSub arg-2 eta-0)) e-18) (CoreC-45TT-embedSub (vector 2 arg-2) e-19))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (vector 4 e-21 (CoreC-45TT-embedSub arg-2 e-22) (CoreC-45TT-embedSub arg-2 e-23)))))) ((5) (let ((e-25 (vector-ref arg-3 1))) (let ((e-26 (vector-ref arg-3 2))) (let ((e-27 (vector-ref arg-3 3))) (let ((e-28 (vector-ref arg-3 4))) (vector 5 e-25 e-26 (CoreC-45TT-embedSub arg-2 e-27) (CoreC-45TT-embedSub arg-2 e-28))))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (vector 6 e-30 e-31 (CoreC-45TT-embedSub arg-2 e-32)))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (vector 7 e-34 e-35 (CoreC-45TT-embedSub arg-2 e-36) (CoreC-45TT-embedSub arg-2 e-37))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (let ((e-41 (vector-ref arg-3 3))) (vector 8 e-39 e-40 (CoreC-45TT-embedSub arg-2 e-41)))))) ((9) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (vector 10 e-46 e-47)))) (else (let ((e-49 (vector-ref arg-3 1))) (vector 11 e-49))))))
(define CoreC-45TT-embed (lambda (arg-2) (Builtin-believe_me arg-2)))
(define CoreC-45TT-dropVar (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (cond ((equal? arg-2 0) e-2)(else (let ((e-3 (- arg-2 1))) (cons e-1 (CoreC-45TT-dropVar e-2 e-3)))))))))
(define CoreC-45TT-dropFirst (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 0) (CoreC-45TT-dropFirst e-3))(else (let ((e-8 (- e-2 1))) (cons e-8 (CoreC-45TT-dropFirst e-3))))))))))
(define CoreC-45TT-defaultKindedName (lambda (arg-0) (vector '() arg-0 arg-0)))
(define CoreC-45TT-constantEq (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Int e-0 e-13))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (let ((sc2 (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempI8Int8 e-1 e-14))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (let ((sc2 (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempI16Int16 e-2 e-15))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (let ((sc2 (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempI32Int32 e-3 e-16))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (let ((sc2 (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempI64Int64 e-4 e-17))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((6) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-18 (vector-ref arg-1 1))) (let ((sc2 (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempB8Bits8 e-5 e-18))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((7) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-19 (vector-ref arg-1 1))) (let ((sc2 (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempB16Bits16 e-6 e-19))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((8) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-20 (vector-ref arg-1 1))) (let ((sc2 (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempB32Bits32 e-7 e-20))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((9) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-21 (vector-ref arg-1 1))) (let ((sc2 (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempB64Bits64 e-8 e-21))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((5) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-22 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Integer e-9 e-22))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_String e-10 e-23))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Char e-11 e-24))) (case (vector-ref sc2 0) ((0) (let ((e-1 (vector-ref sc2 1))) (cond (else (box 0))))) (else '())))))(else '())))) ((12) (case (vector-ref arg-1 0) ((12) '())(else '()))) ((13) (case (vector-ref arg-1 0) ((13) (box 0))(else '()))) ((14) (case (vector-ref arg-1 0) ((14) (box 0))(else '()))) ((15) (case (vector-ref arg-1 0) ((15) (box 0))(else '()))) ((16) (case (vector-ref arg-1 0) ((16) (box 0))(else '()))) ((17) (case (vector-ref arg-1 0) ((17) (box 0))(else '()))) ((18) (case (vector-ref arg-1 0) ((18) (box 0))(else '()))) ((19) (case (vector-ref arg-1 0) ((19) (box 0))(else '()))) ((24) (case (vector-ref arg-1 0) ((24) (box 0))(else '()))) ((25) (case (vector-ref arg-1 0) ((25) (box 0))(else '()))) ((26) (case (vector-ref arg-1 0) ((26) (box 0))(else '()))) ((27) (case (vector-ref arg-1 0) ((27) (box 0))(else '())))(else '()))))
(define CoreC-45TT-constTag (lambda (arg-0) (case (vector-ref arg-0 0) ((14) 3) ((19) 4) ((20) 5) ((21) 6) ((22) 7) ((23) 8) ((24) 9) ((25) 10) ((26) 11) ((27) 12) ((15) 13) ((16) 14) ((17) 15) ((18) 16)(else 0))))
(define CoreC-45TT-compatible (lambda (arg-0 arg-1) (cond ((equal? arg-0 2) 1)(else (cond ((equal? arg-1 2) 1)(else (CoreC-45TT-u--C-61C-61_Eq_LazyReason arg-0 arg-1)))))))
(define CoreC-45TT-binderType (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 4))) e-4)) ((1) (let ((e-9 (vector-ref arg-1 4))) e-9)) ((2) (let ((e-14 (vector-ref arg-1 4))) e-14)) ((3) (let ((e-19 (vector-ref arg-1 4))) e-19)) ((4) (let ((e-24 (vector-ref arg-1 4))) e-24)) (else (let ((e-28 (vector-ref arg-1 3))) e-28)))))
(define CoreC-45TT-binderLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-6 (vector-ref arg-1 1))) e-6)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-16 (vector-ref arg-1 1))) e-16)) ((4) (let ((e-21 (vector-ref arg-1 1))) e-21)) (else (let ((e-26 (vector-ref arg-1 1))) e-26)))))
(define CoreC-45TT-applyWithFC (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45TT-applyWithFC (vector 4 e-6 arg-1 e-7) e-3))))))))
(define CoreC-45TT-apply (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) arg-2 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CoreC-45TT-apply arg-1 (vector 4 arg-1 arg-2 e-2) e-3))))))
(define CoreC-45TT-addVars (lambda (arg-4 ext-0 ext-1) (CoreC-45TT-insertNVarNames arg-4 (CoreC-45TTC-45Bounds-sizeOf ext-0) ext-1)))
(define CoreC-45TT-addRefs (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) arg-3) ((1) (let ((e-9 (vector-ref arg-4 3))) (LibrariesC-45DataC-45NameMap-insert e-9 arg-1 arg-3))) ((2) (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (CoreC-45TT-n--15969-11300-u--addRefsArgs e-14 e-13 e-12 e-11 arg-3 arg-2 arg-1 arg-3 e-14)))))) ((3) (let ((e-18 (vector-ref arg-4 3))) (let ((e-19 (vector-ref arg-4 4))) (case (vector-ref e-18 0) ((1) (let ((e-53 (vector-ref e-18 3))) (let ((e-54 (vector-ref e-18 4))) (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-53) e-54) e-19))))(else (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 (CoreC-45TT-binderType e-18)) e-19)))))) ((4) (let ((e-22 (vector-ref arg-4 2))) (let ((e-23 (vector-ref arg-4 3))) (case (vector-ref e-22 0) ((4) (let ((e-57 (vector-ref e-22 2))) (let ((e-58 (vector-ref e-22 3))) (case (vector-ref e-57 0) ((1) (let ((e-62 (vector-ref e-57 3))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-62 arg-2))) (cond ((equal? sc3 1) (CoreC-45TT-addRefs 1 arg-2 (LibrariesC-45DataC-45NameMap-insert e-62 1 arg-3) e-23)) (else (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 (LibrariesC-45DataC-45NameMap-insert e-62 arg-1 arg-3) e-58) e-23))))))(else (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-22) e-23))))))(else (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-22) e-23)))))) ((5) (let ((e-28 (vector-ref arg-4 4))) (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-28))) ((6) (let ((e-32 (vector-ref arg-4 3))) (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-32))) ((7) (let ((e-36 (vector-ref arg-4 3))) (let ((e-37 (vector-ref arg-4 4))) (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-4 3))) (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-41))) ((9) arg-3) ((10) arg-3) (else arg-3))))
(define CoreC-45TT-addMetas (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) arg-1) ((1) arg-1) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (CoreC-45TT-n--15853-11206-u--addMetaArgs e-14 e-13 e-12 e-11 arg-1 (LibrariesC-45DataC-45NameMap-insert e-12 0 arg-1) e-14)))))) ((3) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (case (vector-ref e-18 0) ((1) (let ((e-53 (vector-ref e-18 3))) (let ((e-54 (vector-ref e-18 4))) (CoreC-45TT-addMetas (CoreC-45TT-addMetas (CoreC-45TT-addMetas arg-1 e-53) e-54) e-19))))(else (CoreC-45TT-addMetas (CoreC-45TT-addMetas arg-1 (CoreC-45TT-binderType e-18)) e-19)))))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (CoreC-45TT-addMetas (CoreC-45TT-addMetas arg-1 e-22) e-23)))) ((5) (let ((e-28 (vector-ref arg-2 4))) (CoreC-45TT-addMetas arg-1 e-28))) ((6) (let ((e-32 (vector-ref arg-2 3))) (CoreC-45TT-addMetas arg-1 e-32))) ((7) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (CoreC-45TT-addMetas (CoreC-45TT-addMetas arg-1 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-2 3))) (CoreC-45TT-addMetas arg-1 e-41))) ((9) arg-1) ((10) arg-1) (else arg-1))))
(define CoreC-45TTC-45SizeOf-C-43 (lambda (arg-3 arg-4) (PreludeC-45Types-u--C-43_Num_Nat arg-3 arg-4)))
(define Algebra-showCount (lambda (ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) "0 " "1 " (lambda (eta-0) "") ext-0)))
(define AlgebraC-45Preorder-lub (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((e-1 (vector-ref arg-1 0))) ((e-1 arg-2) arg-3)))) (cond ((equal? sc0 1) arg-3) (else arg-2)))))
(define AlgebraC-45Preorder-glb (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((e-1 (vector-ref arg-1 0))) ((e-1 arg-2) arg-3)))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define AlgebraC-45Preorder-C-60 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((sc1 (Builtin-fst arg-1))) (let ((e-1 (vector-ref sc1 0))) ((e-1 arg-2) arg-3))))) (cond ((equal? sc0 1) (let ((sc1 (Builtin-snd arg-1))) (let ((e-2 (cdr sc1))) ((e-2 arg-2) arg-3)))) (else 0)))))
(define AlgebraC-45Semiring-linear (lambda (arg-1) (let ((e-4 (vector-ref arg-1 3))) e-4)))
(define AlgebraC-45Semiring-isRigOther (lambda (arg-1 ext-0) (AlgebraC-45Semiring-elimSemi arg-1 0 0 (lambda (eta-0) 1) ext-0)))
(define AlgebraC-45Semiring-isLinear (lambda (arg-1 ext-0) (AlgebraC-45Semiring-elimSemi arg-1 0 1 (lambda (eta-0) 0) ext-0)))
(define AlgebraC-45Semiring-isErased (lambda (arg-1 ext-0) (AlgebraC-45Semiring-elimSemi arg-1 1 0 (lambda (eta-0) 0) ext-0)))
(define AlgebraC-45Semiring-erased (lambda (arg-1) (let ((e-2 (vector-ref arg-1 1))) e-2)))
(define AlgebraC-45Semiring-elimSemi (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (let ((sc0 (let ((sc1 (Builtin-snd arg-2))) (let ((e-1 (car sc1))) ((e-1 arg-6) (let ((sc2 (Builtin-fst arg-2))) (let ((e-5 (vector-ref sc2 1))) e-5))))))) (cond ((equal? sc0 1) arg-3) (else (let ((sc1 (let ((sc2 (Builtin-snd arg-2))) (let ((e-1 (car sc2))) ((e-1 arg-6) (let ((sc3 (Builtin-fst arg-2))) (let ((e-4 (vector-ref sc3 3))) e-4))))))) (cond ((equal? sc1 1) arg-4) (else (arg-5 arg-6)))))))))
(define AlgebraC-45Semiring-branchZero (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (AlgebraC-45Semiring-isErased arg-2 arg-5))) (cond ((equal? sc0 1) (arg-3)) (else (arg-4))))))
(define AlgebraC-45Semiring-branchVal (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (AlgebraC-45Semiring-isRigOther arg-2 arg-5))) (cond ((equal? sc0 1) (arg-3)) (else (arg-4))))))
(define AlgebraC-45Semiring-branchOne (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (AlgebraC-45Semiring-isLinear arg-2 arg-5))) (cond ((equal? sc0 1) (arg-3)) (else (arg-4))))))
(define AlgebraC-45ZeroOneOmega-u--C-124C-43C-124_Semiring_ZeroOneOmega (lambda (ext-0 ext-1) (AlgebraC-45ZeroOneOmega-rigPlus ext-0 ext-1)))
(define AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega (lambda (ext-0 ext-1) (AlgebraC-45ZeroOneOmega-rigMult ext-0 ext-1)))
(define AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega(blodwen-lazy (lambda () 2)))
(define AlgebraC-45ZeroOneOmega-u--timesNeutral_Semiring_ZeroOneOmega(blodwen-lazy (lambda () 1)))
(define AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega (lambda (arg-0) (cond ((equal? arg-0 0) "Rig0") ((equal? arg-0 1) "Rig1") (else "RigW"))))
(define AlgebraC-45ZeroOneOmega-u--showPrec_Show_ZeroOneOmega (lambda (arg-0 arg-1) (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega arg-1)))
(define AlgebraC-45ZeroOneOmega-u--preorderTrans_Preorder_ZeroOneOmega (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-0 0) 0) ((equal? arg-0 1) (cond ((equal? arg-1 1) arg-4) (else (cond ((equal? arg-2 1) 0) (else 0))))) (else (cond (else arg-4))))))
(define AlgebraC-45ZeroOneOmega-u--preorderRefl_Preorder_ZeroOneOmega (lambda (arg-0) (cond ((equal? arg-0 0) 0) ((equal? arg-0 1) 0) (else 0))))
(define AlgebraC-45ZeroOneOmega-u--plusNeutral_Semiring_ZeroOneOmega(blodwen-lazy (lambda () 0)))
(define AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define AlgebraC-45ZeroOneOmega-u--C-60C-61_Preorder_ZeroOneOmega (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 1) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else (cond ((equal? arg-1 2) 1)(else 0)))))(else (cond ((equal? arg-1 2) 1)(else 0))))))
(define AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (lambda (arg-0 arg-1) (let ((sc0 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define AlgebraC-45ZeroOneOmega-rigPlus (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1)(else (cond ((equal? arg-1 0) arg-0)(else 2))))))
(define AlgebraC-45ZeroOneOmega-rigMult (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 0)(else (cond ((equal? arg-1 0) 0)(else (cond ((equal? arg-0 1) arg-1)(else (cond ((equal? arg-1 1) arg-0)(else 2))))))))))
(define LibrariesC-45DataC-45Primitives-n--2451-546-u--primitiveNotEq (lambda (arg-1 arg-2 arg-3 arg-7) (Builtin-believe_me 0)))
(define LibrariesC-45DataC-45Primitives-n--2451-545-u--primitiveEq (lambda (arg-1 arg-2 arg-3) (Builtin-believe_me 0)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempI8Int8 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int8 arg-4 arg-5)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempI64Int64 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int64 arg-4 arg-5)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempI32Int32 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int32 arg-4 arg-5)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempI16Int16 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int16 arg-4 arg-5)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempB8Bits8 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bits8 arg-4 arg-5)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempB64Bits64 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bits64 arg-4 arg-5)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempB32Bits32 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bits32 arg-4 arg-5)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_TempB16Bits16 (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bits16 arg-4 arg-5)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45Primitives-u--decEq_DecEq_FromEqC-36a (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((e-1 (car arg-1))) ((e-1 arg-2) arg-3)))) (cond ((equal? sc0 1) (vector 0 (LibrariesC-45DataC-45Primitives-n--2451-545-u--primitiveEq arg-1 arg-2 arg-3))) (else (vector 1 (lambda (eta-0) (LibrariesC-45DataC-45Primitives-n--2451-546-u--primitiveNotEq arg-1 arg-2 arg-3 eta-0))))))))
(define CoreC-45Options-u--show_Show_CG (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "chez") ((1) "chez-sep") ((2) "racket") ((3) "gambit") ((4) "node") ((5) "javascript") ((6) "refc") ((7) "vmcode-interp") (else (let ((e-0 (vector-ref arg-0 1))) e-0)))))
(define CoreC-45Options-u--showPrec_Show_CG (lambda (arg-0 arg-1) (CoreC-45Options-u--show_Show_CG arg-1)))
(define CoreC-45Options-u--C-61C-61_Eq_LangExt (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0)))(else 0))))
(define CoreC-45Options-u--C-61C-61_Eq_CG (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (case (vector-ref arg-1 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-1 0) ((3) 1)(else 0))) ((4) (case (vector-ref arg-1 0) ((4) 1)(else 0))) ((5) (case (vector-ref arg-1 0) ((5) 1)(else 0))) ((6) (case (vector-ref arg-1 0) ((6) 1)(else 0))) ((7) (case (vector-ref arg-1 0) ((7) 1)(else 0))) ((8) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-1)))(else 0))))(else 0))))
(define CoreC-45Options-u--C-47C-61_Eq_LangExt (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Options-u--C-61C-61_Eq_LangExt arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Options-u--C-47C-61_Eq_CG (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Options-u--C-61C-61_Eq_CG arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Options-toString (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (DataC-45String-fastUnlines (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Working Directory      :: " (PreludeC-45Show-u--show_Show_String e-0)) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Source Directory       :: " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-576) e-1)) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Build Directory        :: " (PreludeC-45Show-u--show_Show_String e-2)) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Local Depend Directory :: " (PreludeC-45Show-u--show_Show_String e-3)) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Output Directory       :: " (PreludeC-45Show-u--show_Show_String (CoreC-45Options-outputDirWithDefault arg-0))) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Installation Prefix    :: " (PreludeC-45Show-u--show_Show_String e-5)) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Extra Directories      :: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-6)) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Package Directories    :: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-7)) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ CG Library Directories :: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-8)) (cons (PreludeC-45TypesC-45String-C-43C-43 "+ Data Directories       :: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-9)) '()))))))))))))))))))))))
(define CoreC-45Options-setRewrite (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 e-4 (box (cons arg-0 arg-1)) e-6 e-7 e-8 e-9))))))))))))
(define CoreC-45Options-setPair (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 (box (vector arg-0 arg-1 arg-2)) e-5 e-6 e-7 e-8 e-9))))))))))))
(define CoreC-45Options-setFromString (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 (box arg-0) e-12 e-13) e-7 e-8 e-9))))))))))))))))
(define CoreC-45Options-setFromInteger (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector (box arg-0) e-11 e-12 e-13) e-7 e-8 e-9))))))))))))))))
(define CoreC-45Options-setFromDouble (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 e-11 e-12 (box arg-0)) e-7 e-8 e-9))))))))))))))))
(define CoreC-45Options-setFromChar (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-11 (vector-ref e-6 1))) (let ((e-13 (vector-ref e-6 3))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 e-11 (box arg-0) e-13) e-7 e-8 e-9))))))))))))))))
(define CoreC-45Options-setExtension (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 (cons arg-0 e-7) e-8 e-9)))))))))))))
(define CoreC-45Options-primNamesToList (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (DataC-45List-catMaybes (cons e-0 (cons e-1 (cons e-2 (cons e-3 '())))))))))))
(define CoreC-45Options-outputDirWithDefault (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref arg-0 2))) e-2) "exec")) (let ((e-4 (vector-ref arg-0 4))) e-4))))
(define CoreC-45Options-isExtension (lambda (arg-0 arg-1) (PreludeC-45Types-elem (cons (lambda (arg-2) (lambda (arg-3) (CoreC-45Options-u--C-61C-61_Eq_LangExt arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (CoreC-45Options-u--C-47C-61_Eq_LangExt arg-4 arg-5)))) arg-0 (let ((e-7 (vector-ref arg-1 7))) e-7))))
(define CoreC-45Options-getCG (lambda (arg-0 arg-1) (DataC-45List-lookup (csegen-17) (DataC-45String-toLower arg-1) (CoreC-45Options-availableCGs arg-0))))
(define CoreC-45Options-execBuildDir (lambda (arg-0) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref arg-0 2))) e-2) "exec")))
(define CoreC-45Options-defaults (lambda (ext-0) (vector 1 (vector (CoreC-45Options-defaultDirs) (CoreC-45Options-defaultPPrint) (CoreC-45Options-defaultSession) (CoreC-45Options-defaultElab) '() '() (csegen-583) '() '() '()))))
(define CoreC-45Options-defaultSession(blodwen-lazy (lambda () (vector 0 1 0 0 (vector 0 ) '() 1000 0 0 (CoreC-45OptionsC-45Log-defaultLogLevel) 0 0 '() '() '() '() 0 (+ 1 0) 0 1 0 '() 0 0))))
(define CoreC-45Options-defaultPPrint(blodwen-lazy (lambda () (vector 0 1 0))))
(define CoreC-45Options-defaultElab(blodwen-lazy (lambda () (vector 1 1 1 (+ 1 (+ 1 (+ 1 0))) (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) 1))))
(define CoreC-45Options-defaultDirs(blodwen-lazy (lambda () (vector "." '() "build" "depends" '() "/usr/local" (cons "." '()) '() '() '()))))
(define CoreC-45Options-clearNames (lambda (ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 '() '() (csegen-583) '() e-8 e-9)))))))))
(define CoreC-45Options-availableCGs (lambda (arg-0) (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "chez" (vector 0 )) (cons (cons "chez-sep" (vector 1 )) (cons (cons "racket" (vector 2 )) (cons (cons "node" (vector 4 )) (cons (cons "javascript" (vector 5 )) (cons (cons "refc" (vector 6 )) (cons (cons "gambit" (vector 3 )) (cons (cons "vmcode-interp" (vector 7 )) '())))))))) (let ((e-8 (vector-ref arg-0 8))) e-8))))
(define CoreC-45Options-addCG (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 (cons arg-0 e-8) e-9)))))))))))))
(define CoreC-45OptionsC-45Log-n--5404-2491-u--there (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) 0 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (DataC-45Maybe-fromMaybe (lambda () 0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45These-fromThat arg-3) (lambda (u--assoc) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45StringMap-lookup e-2 u--assoc) (lambda (u--next) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45OptionsC-45Log-n--5393-2485-u--go arg-0 arg-1 arg-2 e-3 u--next))))))))))))
(define CoreC-45OptionsC-45Log-n--5404-2490-u--here (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (DataC-45These-fromThis arg-3))) (if (null? sc0) 0 (let ((e-2 (unbox sc0))) (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-0 e-2))))))
(define CoreC-45OptionsC-45Log-n--5084-2177-u--helpTopic (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((u--title (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "+") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-2)))) (let ((u--blurb (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow eta-0)) '()))) e-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons u--title u--blurb))))))))
(define CoreC-45OptionsC-45Log-n--5393-2485-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (CoreC-45OptionsC-45Log-n--5404-2490-u--here arg-0 arg-1 arg-2 arg-4 arg-3))) (cond ((equal? sc0 1) 1) (else (CoreC-45OptionsC-45Log-n--5404-2491-u--there arg-0 arg-1 arg-2 arg-4 arg-3))))))
(define CoreC-45OptionsC-45Log-u--show_Show_LogLevel (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (if (null? e-0) (PreludeC-45Show-u--show_Show_Nat e-1) (PreludeC-45TypesC-45String-C-43C-43 (DataC-45String-fastAppend (DataC-45List-intersperse "." e-0)) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45Show-u--show_Show_Nat e-1))))))))
(define CoreC-45OptionsC-45Log-u--showPrec_Show_LogLevel (lambda (arg-0 arg-1) (CoreC-45OptionsC-45Log-u--show_Show_LogLevel arg-1)))
(define CoreC-45OptionsC-45Log-u--pretty_Pretty_LogLevel (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45OptionsC-45Log-u--show_Show_LogLevel ext-0))))
(define CoreC-45OptionsC-45Log-verbosity (lambda (arg-0) (let ((e-1 (cdr arg-0))) e-1)))
(define CoreC-45OptionsC-45Log-unsafeMkLogLevel (lambda (ext-0 ext-1) (cons ext-0 ext-1)))
(define CoreC-45OptionsC-45Log-topics (lambda (arg-0) (let ((e-0 (car arg-0))) e-0)))
(define CoreC-45OptionsC-45Log-parseLogLevel (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((u--nns (DataC-45String-split (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\:)) arg-0))) (let ((u--n (let ((e-1 (car u--nns))) e-1))) (let ((u--ns (let ((e-2 (cdr u--nns))) e-2))) (if (null? u--ns) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (lambda (eta-0) (cons '() eta-0)) u--n)) (let ((e-2 (car u--ns))) (let ((e-3 (cdr u--ns))) (if (null? e-3) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (lambda (eta-0) (CoreC-45OptionsC-45Log-mkUnverifiedLogLevel u--n eta-0)) e-2)) '()))))))) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45String-parsePositive (csegen-597) e-3) (lambda (u--lvl) (PreludeC-45Types-u--pure_Applicative_Maybe (e-2 (PreludeC-45Types-u--fromInteger_Num_Nat u--lvl)))))))))))
(define CoreC-45OptionsC-45Log-mkUnverifiedLogLevel (lambda (arg-0 ext-0) (cond ((equal? arg-0 "") (CoreC-45OptionsC-45Log-mkLogLevelC-39 '() ext-0))(else (CoreC-45OptionsC-45Log-mkLogLevelC-39 (box (DataC-45String-split (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\.)) arg-0)) ext-0)))))
(define CoreC-45OptionsC-45Log-mkLogLevelC-39 (lambda (arg-0 arg-1) (cons (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (DataC-45List1-forget eta-0))) arg-0) arg-1)))
(define CoreC-45OptionsC-45Log-knownTopics(blodwen-lazy (lambda () (cons (cons "auto" '()) (cons (cons "builtin.Natural" '()) (cons (cons "builtin.Natural.addTransform" '()) (cons (cons "builtin.NaturalToInteger" '()) (cons (cons "builtin.NaturalToInteger.addTransforms" '()) (cons (cons "builtin.IntegerToNatural" '()) (cons (cons "builtin.IntegerToNatural.addTransforms" '()) (cons (cons "compile.casetree" '()) (cons (cons "compile.casetree.clauses" '()) (cons (cons "compile.casetree.getpmdef" '()) (cons (cons "compile.casetree.intermediate" '()) (cons (cons "compile.casetree.measure" (box "Log the node counts of each runtime case tree.")) (cons (cons "compile.casetree.pick" '()) (cons (cons "compile.casetree.partition" '()) (cons (cons "compiler.const-fold" '()) (cons (cons "compiler.cse" '()) (cons (cons "compiler.identity" '()) (cons (cons "compiler.inline.eval" '()) (cons (cons "compiler.inline.heuristic" '()) (cons (cons "compiler.interpreter" '()) (cons (cons "compiler.refc" '()) (cons (cons "compiler.refc.cc" '()) (cons (cons "compiler.scheme.chez" '()) (cons (cons "coverage" '()) (cons (cons "coverage.empty" '()) (cons (cons "coverage.missing" '()) (cons (cons "coverage.recover" '()) (cons (cons "declare.data" '()) (cons (cons "declare.data.constructor" '()) (cons (cons "declare.data.parameters" '()) (cons (cons "declare.def" '()) (cons (cons "declare.def.alias" '()) (cons (cons "declare.def.clause" '()) (cons (cons "declare.def.clause.impossible" '()) (cons (cons "declare.def.clause.with" '()) (cons (cons "declare.def.impossible" '()) (cons (cons "declare.def.lhs" '()) (cons (cons "declare.def.lhs.implicits" '()) (cons (cons "declare.param" '()) (cons (cons "declare.record" '()) (cons (cons "declare.record.field" '()) (cons (cons "declare.record.projection" '()) (cons (cons "declare.record.projection.prefix" '()) (cons (cons "declare.type" '()) (cons (cons "desugar.idiom" '()) (cons (cons "doc.data" '()) (cons (cons "doc.record" '()) (cons (cons "doc.module" '()) (cons (cons "elab" '()) (cons (cons "elab.ambiguous" '()) (cons (cons "elab.app.var" '()) (cons (cons "elab.app.lhs" '()) (cons (cons "elab.as" '()) (cons (cons "elab.bindnames" '()) (cons (cons "elab.binder" '()) (cons (cons "elab.case" '()) (cons (cons "elab.def.local" '()) (cons (cons "elab.delay" '()) (cons (cons "elab.hole" '()) (cons (cons "elab.implicits" '()) (cons (cons "elab.implementation" '()) (cons (cons "elab.interface" '()) (cons (cons "elab.interface.default" '()) (cons (cons "elab.local" '()) (cons (cons "elab.prune" '()) (cons (cons "elab.record" '()) (cons (cons "elab.retry" '()) (cons (cons "elab.rewrite" '()) (cons (cons "elab.unify" '()) (cons (cons "elab.update" '()) (cons (cons "elab.with" '()) (cons (cons "eval.casetree" '()) (cons (cons "eval.casetree.stuck" '()) (cons (cons "eval.eta" '()) (cons (cons "eval.stuck" '()) (cons (cons "idemode.hole" '()) (cons (cons "ide-mode.highlight" '()) (cons (cons "ide-mode.highlight.alias" '()) (cons (cons "ide-mode.send" '()) (cons (cons "import" '()) (cons (cons "import.file" '()) (cons (cons "interaction.casesplit" '()) (cons (cons "interaction.generate" '()) (cons (cons "interaction.search" '()) (cons (cons "metadata.names" '()) (cons (cons "module.hash" '()) (cons (cons "quantity" '()) (cons (cons "quantity.hole" '()) (cons (cons "quantity.hole.update" '()) (cons (cons "repl.eval" '()) (cons (cons "resugar.var" '()) (cons (cons "specialise" '()) (cons (cons "totality" '()) (cons (cons "totality.positivity" '()) (cons (cons "totality.requirement" '()) (cons (cons "totality.termination" '()) (cons (cons "totality.termination.calc" '()) (cons (cons "totality.termination.guarded" '()) (cons (cons "totality.termination.sizechange" '()) (cons (cons "totality.termination.sizechange.checkCall" '()) (cons (cons "totality.termination.sizechange.checkCall.inPath" '()) (cons (cons "totality.termination.sizechange.checkCall.inPathNot.restart" '()) (cons (cons "totality.termination.sizechange.checkCall.inPathNot.return" '()) (cons (cons "totality.termination.sizechange.inPath" '()) (cons (cons "totality.termination.sizechange.isTerminating" '()) (cons (cons "totality.termination.sizechange.needsChecking" '()) (cons (cons "transform.lhs" '()) (cons (cons "transform.rhs" '()) (cons (cons "ttc.read" '()) (cons (cons "ttc.write" '()) (cons (cons "typesearch.equiv" '()) (cons (cons "unelab.case" '()) (cons (cons "unelab.var" '()) (cons (cons "unify" '()) (cons (cons "unify.application" '()) (cons (cons "unify.binder" '()) (cons (cons "unify.constant" '()) (cons (cons "unify.constraint" '()) (cons (cons "unify.delay" '()) (cons (cons "unify.equal" '()) (cons (cons "unify.head" '()) (cons (cons "unify.hole" '()) (cons (cons "unify.instantiate" '()) (cons (cons "unify.invertible" '()) (cons (cons "unify.meta" '()) (cons (cons "unify.noeta" '()) (cons (cons "unify.postpone" '()) (cons (cons "unify.retry" '()) (cons (cons "unify.search" '()) (cons (cons "unify.unsolved" '()) '())))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45OptionsC-45Log-keepLog (lambda (arg-0 arg-1) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (cond ((equal? e-1 0) 1)(else (CoreC-45OptionsC-45Log-n--5393-2485-u--go e-1 e-0 arg-1 e-0 arg-1)))))))
(define CoreC-45OptionsC-45Log-insertLogLevel (lambda (arg-0 ext-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (LibrariesC-45DataC-45StringTrie-insert e-0 e-1 ext-0)))))
(define CoreC-45OptionsC-45Log-helpTopics(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45OptionsC-45Log-n--5084-2177-u--helpTopic eta-0)) (CoreC-45OptionsC-45Log-knownTopics)))))))
(define CoreC-45OptionsC-45Log-defaultLogLevel(blodwen-lazy (lambda () (LibrariesC-45DataC-45StringTrie-singleton '() 0))))
(define DataC-45These-these (lambda (arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (arg-3 e-2))) ((1) (let ((e-5 (vector-ref arg-6 1))) (arg-4 e-5))) (else (let ((e-8 (vector-ref arg-6 1))) (let ((e-9 (vector-ref arg-6 2))) ((arg-5 e-8) e-9)))))))
(define DataC-45These-fromThis (lambda (arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (box e-2))) ((1) '()) (else (let ((e-8 (vector-ref arg-2 1))) (box e-8))))))
(define DataC-45These-fromThat (lambda (arg-2) (case (vector-ref arg-2 0) ((0) '()) ((1) (let ((e-5 (vector-ref arg-2 1))) (box e-5))) (else (let ((e-9 (vector-ref arg-2 2))) (box e-9))))))
(define DataC-45These-bifold (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) e-2)) ((1) (let ((e-5 (vector-ref arg-2 1))) e-5)) (else (let ((e-8 (vector-ref arg-2 1))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-1 (car arg-1))) ((e-1 e-8) e-9))))))))
(define LibrariesC-45DataC-45StringTrie-n--2765-3268-u--rec (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (PreludeC-45Types-maybe (lambda () (LibrariesC-45DataC-45StringMap-insert arg-1 (LibrariesC-45DataC-45StringTrie-n--2765-3267-u--end arg-1 arg-2 arg-3 arg-4) arg-5)) (lambda () (lambda (u--tm) (LibrariesC-45DataC-45StringMap-insert arg-1 (LibrariesC-45DataC-45StringTrie-insertWith arg-2 arg-4 u--tm) arg-5))) (LibrariesC-45DataC-45StringMap-lookup arg-1 arg-5))))
(define LibrariesC-45DataC-45StringTrie-n--2765-3267-u--end (lambda (arg-1 arg-2 arg-3 arg-4) (LibrariesC-45DataC-45StringTrie-singleton arg-2 (arg-4 '()))))
(define LibrariesC-45DataC-45StringTrie-singleton (lambda (arg-1 arg-2) (if (null? arg-1) (vector 0 arg-2) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (vector 1 (LibrariesC-45DataC-45StringMap-singleton e-2 (LibrariesC-45DataC-45StringTrie-singleton e-3 arg-2))))))))
(define LibrariesC-45DataC-45StringTrie-insertWith (lambda (arg-1 arg-2 arg-3) (if (null? arg-1) (DataC-45These-these (lambda (eta-0) (vector 0 (arg-2 (box eta-0)))) (lambda (eta-0) (vector 2 (arg-2 '()) eta-0)) (lambda (eta-0) (lambda (eta-1) (vector 2 (arg-2 (box eta-0)) eta-1))) arg-3) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (DataC-45These-these (lambda (u--x) (vector 2 u--x (LibrariesC-45DataC-45StringMap-singleton e-2 (LibrariesC-45DataC-45StringTrie-n--2765-3267-u--end e-2 e-3 arg-3 arg-2)))) (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45StringTrie-n--2765-3268-u--rec e-2 e-3 arg-3 arg-2 eta-0))) (lambda (u--x) (lambda (eta-0) (vector 2 u--x (LibrariesC-45DataC-45StringTrie-n--2765-3268-u--rec e-2 e-3 arg-3 arg-2 eta-0)))) arg-3))))))
(define LibrariesC-45DataC-45StringTrie-insert (lambda (arg-1 arg-2 ext-0) (LibrariesC-45DataC-45StringTrie-insertWith arg-1 (lambda (eta-0) arg-2) ext-0)))
(define LibrariesC-45DataC-45StringTrie-empty(blodwen-lazy (lambda () (vector 1 (LibrariesC-45DataC-45StringMap-empty)))))
(define LibrariesC-45DataC-45StringMap-n--4815-2435-u--treeToListC-39 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (arg-3 (cons e-1 e-2))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 3))) (LibrariesC-45DataC-45StringMap-n--4815-2435-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45StringMap-n--4815-2435-u--treeToListC-39 arg-3 e-7))) e-5)))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 5))) (LibrariesC-45DataC-45StringMap-n--4815-2435-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45StringMap-n--4815-2435-u--treeToListC-39 (lambda (arg-1) (cons arg-1 (LibrariesC-45DataC-45StringMap-n--4815-2435-u--treeToListC-39 arg-3 e-14))) e-12))) e-10))))))))
(define LibrariesC-45DataC-45StringMap-n--5266-2884-u--inserted (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (LibrariesC-45DataC-45StringMap-toList arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-3) (LibrariesC-45DataC-45StringMap-lookup e-2 arg-2)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45StringMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45StringMap-n--4815-2435-u--treeToListC-39 (lambda (arg-0) (cons arg-0 '())) ext-0)))
(define LibrariesC-45DataC-45StringMap-treeLookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-2 e-1))) (cond ((equal? sc1 1) (box e-2)) (else '())))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-6))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-5)) (else (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-7)))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-11))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-10)) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-13))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-12)) (else (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-14))))))))))))))))
(define LibrariesC-45DataC-45StringMap-treeInsertC-39 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (PreludeC-45EqOrd-u--compare_Ord_String arg-2 e-1))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-2 arg-3) (cons arg-2 (vector 0 e-1 e-2))))) ((equal? sc1 1) (vector 0 (vector 0 arg-2 arg-3))) (else (vector 1 (cons (vector 0 e-1 e-2) (cons e-1 (vector 0 arg-2 arg-3)))))))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-6))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-5))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-6 e-7)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-10 e-12 e-13 e-6 e-7))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-5 e-6 e-2)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-5 e-6 e-10 e-12 e-13))))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-11))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-10))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-11 e-12 e-13 e-14)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-16 e-15) (cons e-11 (vector 1 e-12 e-13 e-14))))))))))))) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-2 e-13 e-14)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-8) (cons e-16 (vector 1 e-15 e-13 e-14))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-14))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-12 e-13 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-12) (cons e-13 (vector 1 e-8 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45StringMap-treeInsert (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45StringMap-toList (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45StringMap-treeToList e-3)))))
(define LibrariesC-45DataC-45StringMap-singleton (lambda (arg-1 arg-2) (cons 0 (vector 0 arg-1 arg-2))))
(define LibrariesC-45DataC-45StringMap-mergeWith (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45StringMap-insertFrom (LibrariesC-45DataC-45StringMap-n--5266-2884-u--inserted arg-3 arg-2 arg-1) arg-2)))
(define LibrariesC-45DataC-45StringMap-mergeLeft (lambda (arg-1 arg-2) (LibrariesC-45DataC-45StringMap-mergeWith (lambda (eta-0) (lambda (eta-1) eta-0)) arg-1 arg-2)))
(define LibrariesC-45DataC-45StringMap-lookup (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45StringMap-treeLookup arg-1 e-3)))))
(define LibrariesC-45DataC-45StringMap-insertFrom (lambda (ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (PreludeC-45Types-u--foldl_Foldable_List (csegen-734) eta-0 clam-0))) ext-0 ext-1)))
(define LibrariesC-45DataC-45StringMap-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons 0 (vector 0 arg-1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45StringMap-treeInsert arg-1 arg-2 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (cons e-2 e-4))) (else (let ((e-5 (vector-ref sc1 1))) (cons (+ 1 e-2) e-5))))))))))
(define LibrariesC-45DataC-45StringMap-fromList (lambda (arg-1) (PreludeC-45Types-u--foldl_Foldable_List (csegen-734) (LibrariesC-45DataC-45StringMap-empty) arg-1)))
(define LibrariesC-45DataC-45StringMap-empty(blodwen-lazy (lambda () '())))
(define CoreC-45Core-n--6673-3221-u--showRig (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) "linear" "irrelevant" (lambda (eta-0) "unrestricted") ext-0)))
(define CoreC-45Core-n--6673-3222-u--showRel (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) "relevant" "irrelevant" (lambda (eta-0) "non-linear") ext-0)))
(define CoreC-45Core-n--9775-5926-u--goTerm (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) ((arg-1 arg-2) arg-3)) ((1) ((arg-1 arg-2) arg-3)) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-24 (eta-0 eta-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((eta-1 e-5) eta-2)))))))) (arg-1 arg-2) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 2 e-11 e-12 e-13 e-5)))))) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 eta-2)) e-14 '() eta-1)) eta-0)))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-24 (eta-0 eta-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((eta-1 e-5) eta-2)))))))) (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 3 e-16 e-17 e-5 eta-3))))))) (lambda (eta-2) (CoreC-45CoreC-45Binder-traverse (lambda (eta-3) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 eta-3)) e-18 eta-2)) eta-1)) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 (cons e-17 arg-2) e-19) eta-0)))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-24 (eta-0 eta-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((eta-1 e-5) eta-2)))))))) (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 4 e-21 e-5 eta-3))))))) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 e-22) eta-1)) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 e-23) eta-0))))))) ((5) (let ((e-25 (vector-ref arg-3 1))) (let ((e-26 (vector-ref arg-3 2))) (let ((e-27 (vector-ref arg-3 3))) (let ((e-28 (vector-ref arg-3 4))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-24 (eta-0 eta-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((eta-1 e-5) eta-2)))))))) (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 5 e-25 e-26 e-5 eta-3))))))) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 e-27) eta-1)) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 e-28) eta-0)))))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-24 (eta-0 eta-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((eta-1 e-5) eta-2)))))))) (arg-1 arg-2) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 6 e-30 e-31 e-5)))))) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 e-32) eta-0))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-24 (eta-0 eta-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((eta-1 e-5) eta-2)))))))) (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 7 e-34 e-35 e-5 eta-3))))))) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 e-36) eta-1)) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 e-37) eta-0)))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (let ((e-41 (vector-ref arg-3 3))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-24 (eta-0 eta-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((eta-1 e-5) eta-2)))))))) (arg-1 arg-2) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 8 e-39 e-40 e-5)))))) (CoreC-45Core-n--9775-5926-u--goTerm arg-0 arg-1 arg-2 e-41) eta-0))))))) ((9) ((arg-1 arg-2) arg-3)) ((10) ((arg-1 arg-2) arg-3)) (else ((arg-1 arg-2) arg-3)))))
(define CoreC-45Core-u--throw_Catchable_Core_Error (lambda (ext-1 ext-0) (CoreC-45Core-coreFail ext-1 ext-0)))
(define CoreC-45Core-u--show_Show_Warning (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) e-1)) ((1) ":Unreachable clause") ((2) ":Shadowing names") ((3) (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 ":Deprecated " e-8))) (else (let ((e-9 (vector-ref arg-0 1))) e-9)))))
(define CoreC-45Core-u--show_Show_TTCErrorMsg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (let ((u--age (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int e-1 e-2))) (cond ((equal? sc1 1) "older") (else "newer"))))) (PreludeC-45TypesC-45String-C-43C-43 "TTC data is in an " (PreludeC-45TypesC-45String-C-43C-43 u--age (PreludeC-45TypesC-45String-C-43C-43 " format, file: " (PreludeC-45TypesC-45String-C-43C-43 e-0 (PreludeC-45TypesC-45String-C-43C-43 ", expected version: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-2) (PreludeC-45TypesC-45String-C-43C-43 ", actual version: " (PreludeC-45Show-u--show_Show_Int e-1))))))))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "End of buffer when reading " e-3))) (else (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Corrupt TTC data for " e-4))))))
(define CoreC-45Core-u--show_Show_Error (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45Core-u--show_Show_Error e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-2) (PreludeC-45TypesC-45String-C-43C-43 ":Type mismatch: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-1 e-5) (PreludeC-45TypesC-45String-C-43C-43 " and " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-1 e-6)))))))))) ((2) (let ((e-7 (vector-ref arg-0 1))) (let ((e-8 (vector-ref arg-0 2))) (let ((e-11 (vector-ref arg-0 5))) (let ((e-12 (vector-ref arg-0 6))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-8) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-7 e-11) (PreludeC-45TypesC-45String-C-43C-43 " and " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-7 e-12) " are not equal")))))))))) ((3) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (let ((e-16 (vector-ref arg-0 4))) (let ((e-17 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-14) (PreludeC-45TypesC-45String-C-43C-43 ":Pattern variable " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-16) (PreludeC-45TypesC-45String-C-43C-43 " unifies with " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-13 e-17)))))))))) ((4) (let ((e-18 (vector-ref arg-0 1))) (let ((e-19 (vector-ref arg-0 2))) (let ((e-21 (vector-ref arg-0 4))) (let ((e-22 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-19) (PreludeC-45TypesC-45String-C-43C-43 ":Cycle detected in metavariable solution " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-21) (PreludeC-45TypesC-45String-C-43C-43 " = " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-18 e-22)))))))))) ((5) (let ((e-23 (vector-ref arg-0 1))) (let ((e-24 (vector-ref arg-0 2))) (let ((e-27 (vector-ref arg-0 5))) (let ((e-28 (vector-ref arg-0 6))) (let ((e-29 (vector-ref arg-0 7))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-24) (PreludeC-45TypesC-45String-C-43C-43 ":When unifying: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-23 e-27) (PreludeC-45TypesC-45String-C-43C-43 " and " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-23 e-28) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;" (CoreC-45Core-u--show_Show_Error e-29))))))))))))) ((6) (let ((e-30 (vector-ref arg-0 1))) (let ((e-31 (vector-ref arg-0 2))) (let ((e-33 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-31) (PreludeC-45TypesC-45String-C-43C-43 ":" (case (vector-ref e-33 0) ((0) (let ((e-2 (vector-ref e-33 1))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-30 e-2) " is not a valid impossible pattern because it typechecks"))) (else (let ((e-5 (vector-ref e-33 1))) (PreludeC-45TypesC-45String-C-43C-43 "Not a valid impossible pattern:\xa;\x9;" (CoreC-45Core-u--show_Show_Error e-5))))))))))) ((7) (let ((e-34 (vector-ref arg-0 1))) (let ((e-35 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-34) (PreludeC-45TypesC-45String-C-43C-43 ":Undefined name " (CoreC-45Name-u--show_Show_Name e-35)))))) ((8) (let ((e-36 (vector-ref arg-0 1))) (let ((e-37 (vector-ref arg-0 2))) (let ((e-38 (vector-ref arg-0 3))) (if (null? e-38) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-36) (PreludeC-45TypesC-45String-C-43C-43 ":Name " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-37) " is private"))) (let ((e-211 (unbox e-38))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-36) (PreludeC-45TypesC-45String-C-43C-43 ":Name " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-37) (PreludeC-45TypesC-45String-C-43C-43 " is inaccessible since " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-211) " is not explicitly imported"))))))))))) ((9) (let ((e-39 (vector-ref arg-0 1))) (let ((e-40 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-39) (PreludeC-45TypesC-45String-C-43C-43 ":Return type of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-40) " must be Type")))))) ((10) (let ((e-41 (vector-ref arg-0 1))) (let ((e-42 (vector-ref arg-0 2))) (let ((e-43 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-41) (PreludeC-45TypesC-45String-C-43C-43 ":Return type of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-42) (PreludeC-45TypesC-45String-C-43C-43 " must be in " (CoreC-45Name-u--show_Show_Name e-43))))))))) ((11) (let ((e-44 (vector-ref arg-0 1))) (let ((e-45 (vector-ref arg-0 2))) (let ((e-46 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-44) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-45) (PreludeC-45TypesC-45String-C-43C-43 " is not covering:\xa;\x9;" (case (vector-ref e-46 0) ((0) "Oh yes it is (Internal error!)") ((1) (let ((e-0 (vector-ref e-46 1))) (PreludeC-45TypesC-45String-C-43C-43 "Missing cases:\xa;\x9;" (CoreC-45NameC-45Namespace-showSep "\xa;\x9;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() eta-0)) e-0))))) (else (let ((e-1 (vector-ref e-46 1))) (PreludeC-45TypesC-45String-C-43C-43 "Calls non covering function" (if (null? e-1) (PreludeC-45TypesC-45String-C-43C-43 "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))) (let ((e-3 (car e-1))) (let ((e-2 (cdr e-1))) (if (null? e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name e-3)) (PreludeC-45TypesC-45String-C-43C-43 "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))))))))))))))))))) ((12) (let ((e-47 (vector-ref arg-0 1))) (let ((e-48 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-47) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-48) " is not total")))))) ((13) (let ((e-50 (vector-ref arg-0 1))) (let ((e-51 (vector-ref arg-0 2))) (let ((e-52 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-50) (PreludeC-45TypesC-45String-C-43C-43 ":There are " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-51) (PreludeC-45TypesC-45String-C-43C-43 " uses of linear name " (CoreC-45Name-u--show_Show_Name e-52))))))))) ((14) (let ((e-53 (vector-ref arg-0 1))) (let ((e-54 (vector-ref arg-0 2))) (let ((e-55 (vector-ref arg-0 3))) (let ((e-56 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-53) (PreludeC-45TypesC-45String-C-43C-43 ":Trying to use " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Core-n--6673-3221-u--showRig e-56 e-55 e-54 e-53 e-55) (PreludeC-45TypesC-45String-C-43C-43 " name " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-54) (PreludeC-45TypesC-45String-C-43C-43 " in " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Core-n--6673-3222-u--showRel e-56 e-55 e-54 e-53 e-56) " context")))))))))))) ((15) (let ((e-57 (vector-ref arg-0 1))) (let ((e-58 (vector-ref arg-0 2))) (let ((e-60 (vector-ref arg-0 4))) (let ((e-61 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-58) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-57 e-60) (PreludeC-45TypesC-45String-C-43C-43 " borrows argument " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-57 e-61) " so must be fully applied")))))))))) ((16) (let ((e-62 (vector-ref arg-0 1))) (let ((e-63 (vector-ref arg-0 2))) (let ((e-65 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-63) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-62 e-65) " borrows, so must return a concrete type"))))))) ((17) (let ((e-66 (vector-ref arg-0 1))) (let ((e-67 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-66) (PreludeC-45TypesC-45String-C-43C-43 ":Ambiguous name " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-67)))))) ((18) (let ((e-68 (vector-ref arg-0 1))) (let ((e-69 (vector-ref arg-0 2))) (let ((e-71 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-69) (PreludeC-45TypesC-45String-C-43C-43 ":Ambiguous elaboration " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-68 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-68 u--d u--x)))) e-71))))))) ((19) (let ((e-72 (vector-ref arg-0 1))) (let ((e-73 (vector-ref arg-0 2))) (let ((e-76 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-73) (PreludeC-45TypesC-45String-C-43C-43 ":Ambiguous search " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-72 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-72 u--d u--x)))) e-76))))))) ((20) (let ((e-77 (vector-ref arg-0 1))) (let ((e-78 (vector-ref arg-0 2))) (let ((e-79 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-77) (PreludeC-45TypesC-45String-C-43C-43 ":Ambiguity too deep in " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-78) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-79))))))))) ((21) (let ((e-80 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "No successful elaboration: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-741) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-741) u--d u--x)))) e-80)))) ((22) (let ((e-82 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-82) ":Can't infer type of record to update"))) ((23) (let ((e-84 (vector-ref arg-0 1))) (let ((e-85 (vector-ref arg-0 2))) (let ((e-86 (vector-ref arg-0 3))) (if (null? e-86) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-84) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 e-85 " is not part of a record type"))) (let ((e-214 (unbox e-86))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-84) (PreludeC-45TypesC-45String-C-43C-43 ":Record type " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-214) (PreludeC-45TypesC-45String-C-43C-43 " has no field " e-85)))))))))) ((24) (let ((e-87 (vector-ref arg-0 1))) (let ((e-88 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-87) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-88) " is not a record type")))))) ((25) (let ((e-89 (vector-ref arg-0 1))) (let ((e-90 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-89) (PreludeC-45TypesC-45String-C-43C-43 ":Field update " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "->" e-90) " not compatible with other updates")))))) ((26) (let ((e-91 (vector-ref arg-0 1))) (let ((e-92 (vector-ref arg-0 2))) (let ((e-94 (vector-ref arg-0 4))) (let ((e-95 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-92) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-94) (PreludeC-45TypesC-45String-C-43C-43 " are not valid arguments in " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-91 e-95)))))))))) ((27) (let ((e-96 (vector-ref arg-0 1))) (let ((e-97 (vector-ref arg-0 2))) (let ((e-99 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-97) (PreludeC-45TypesC-45String-C-43C-43 ":Need to bind implicits " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "," (PreludeC-45Types-u--map_Functor_List (lambda (u--x) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (Builtin-fst u--x)) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-96 (Builtin-snd u--x))))) e-99)) "\xa;(The front end should probably have done this for you. Please report!)"))))))) ((28) (let ((e-100 (vector-ref arg-0 1))) (let ((e-101 (vector-ref arg-0 2))) (let ((e-103 (vector-ref arg-0 4))) (let ((e-104 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-101) (PreludeC-45TypesC-45String-C-43C-43 ":Can't bind name " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-nameRoot e-103) (PreludeC-45TypesC-45String-C-43C-43 " with type " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-100 e-104)))))))))) ((29) (let ((e-105 (vector-ref arg-0 1))) (let ((e-106 (vector-ref arg-0 2))) (let ((e-109 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-106) (PreludeC-45TypesC-45String-C-43C-43 ":Can't solve goal " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-105 e-109))))))) ((30) (let ((e-111 (vector-ref arg-0 1))) (let ((e-112 (vector-ref arg-0 2))) (let ((e-113 (vector-ref arg-0 3))) (let ((e-116 (vector-ref arg-0 6))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-112) (PreludeC-45TypesC-45String-C-43C-43 ":Can't solve goal " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-111 e-116) (PreludeC-45TypesC-45String-C-43C-43 " since argument " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-113) " can't be inferred")))))))))) ((31) (let ((e-117 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Unsolved holes " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-748) e-117)))) ((32) (let ((e-118 (vector-ref arg-0 1))) (let ((e-119 (vector-ref arg-0 2))) (let ((e-121 (vector-ref arg-0 4))) (let ((e-122 (vector-ref arg-0 5))) (let ((e-123 (vector-ref arg-0 6))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-119) (PreludeC-45TypesC-45String-C-43C-43 ":Can't infer type for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-121) (PreludeC-45TypesC-45String-C-43C-43 " (got " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-118 e-123) (PreludeC-45TypesC-45String-C-43C-43 " with hole " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-122) ")"))))))))))))) ((33) (let ((e-125 (vector-ref arg-0 2))) (let ((e-127 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-125) (PreludeC-45TypesC-45String-C-43C-43 ":Named hole " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-127) " is solved by unification")))))) ((34) (let ((e-129 (vector-ref arg-0 1))) (let ((e-130 (vector-ref arg-0 2))) (let ((e-131 (vector-ref arg-0 3))) (let ((e-132 (vector-ref arg-0 4))) (let ((e-133 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-129) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Visibility e-130) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-131) (PreludeC-45TypesC-45String-C-43C-43 " cannot refer to " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Visibility e-132) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name e-133))))))))))))))) ((35) (let ((e-134 (vector-ref arg-0 1))) (let ((e-135 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-134) (PreludeC-45TypesC-45String-C-43C-43 ":Non linear pattern variable " (CoreC-45Name-u--show_Show_Name e-135)))))) ((36) (let ((e-136 (vector-ref arg-0 1))) (let ((e-137 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-136) (PreludeC-45TypesC-45String-C-43C-43 ":Pattern not allowed here: " (CoreC-45Name-u--show_Show_Name e-137)))))) ((37) (let ((e-138 (vector-ref arg-0 1))) (let ((e-139 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-138) (PreludeC-45TypesC-45String-C-43C-43 ":No type declaration for " (CoreC-45Name-u--show_Show_Name e-139)))))) ((38) (let ((e-140 (vector-ref arg-0 1))) (let ((e-141 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-140) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-141) " is already defined")))))) ((39) (let ((e-142 (vector-ref arg-0 1))) (let ((e-143 (vector-ref arg-0 2))) (let ((e-145 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-143) (PreludeC-45TypesC-45String-C-43C-43 ":Not a function type: " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-142 e-145))))))) ((40) (let ((e-146 (vector-ref arg-0 1))) (let ((e-147 (vector-ref arg-0 2))) (let ((e-149 (vector-ref arg-0 4))) (let ((e-150 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-147) (PreludeC-45TypesC-45String-C-43C-43 ":Rewriting by " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-146 e-149) (PreludeC-45TypesC-45String-C-43C-43 " did not change type " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-146 e-150)))))))))) ((41) (let ((e-151 (vector-ref arg-0 1))) (let ((e-152 (vector-ref arg-0 2))) (let ((e-154 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-152) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-151 e-154) " is not a rewrite rule type"))))))) ((42) (let ((e-155 (vector-ref arg-0 1))) (let ((e-156 (vector-ref arg-0 2))) (let ((e-157 (vector-ref arg-0 3))) (case (vector-ref e-157 0) ((0) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-155) (PreludeC-45TypesC-45String-C-43C-43 ":Patterns for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-156) " have different numbers of arguments")))) ((1) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-155) (PreludeC-45TypesC-45String-C-43C-43 ":Patterns for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-156) " require matching on different types")))) ((4) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-155) (PreludeC-45TypesC-45String-C-43C-43 ":Can't infer type to match in " (CoreC-45Name-u--show_Show_Name e-156)))) ((2) (let ((e-215 (vector-ref e-157 1))) (let ((e-219 (car e-215))) (let ((e-220 (cdr e-215))) (let ((e-224 (cdr e-220))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-155) (PreludeC-45TypesC-45String-C-43C-43 ":Attempt to match on erased argument " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-219 e-224) (PreludeC-45TypesC-45String-C-43C-43 " in " (CoreC-45Name-u--show_Show_Name e-156)))))))))) (else (let ((e-216 (vector-ref e-157 1))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-155) (PreludeC-45TypesC-45String-C-43C-43 ":Constructor " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-216) " is not fully applied")))))))))) ((43) (let ((e-158 (vector-ref arg-0 1))) (let ((e-159 (vector-ref arg-0 2))) (let ((e-161 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-159) (PreludeC-45TypesC-45String-C-43C-43 ":Can't match on " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-158 e-161) " as it is has a polymorphic type"))))))) ((44) (let ((e-162 (vector-ref arg-0 1))) (let ((e-163 (vector-ref arg-0 2))) (let ((e-165 (vector-ref arg-0 4))) (let ((e-166 (vector-ref arg-0 5))) (let ((e-167 (vector-ref arg-0 6))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-163) (PreludeC-45TypesC-45String-C-43C-43 ":Can't match on " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-162 e-166) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Core-u--show_Show_DotReason e-165) (PreludeC-45TypesC-45String-C-43C-43 ")" (PreludeC-45TypesC-45String-C-43C-43 " - it elaborates to " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-162 e-167)))))))))))))) ((45) (let ((e-168 (vector-ref arg-0 1))) (let ((e-169 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-168) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 e-169 " can't be bound here")))))) ((46) (let ((e-170 (vector-ref arg-0 1))) (let ((e-171 (vector-ref arg-0 2))) (let ((e-173 (vector-ref arg-0 4))) (let ((e-174 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-171) (PreludeC-45TypesC-45String-C-43C-43 ":Bad elaborator script " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-170 e-173) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 e-174 ")")))))))))) ((47) (let ((e-175 (vector-ref arg-0 1))) (let ((e-176 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-175) (PreludeC-45TypesC-45String-C-43C-43 ":" e-176))))) ((48) (let ((e-177 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Error in TTC file: " (CoreC-45Core-u--show_Show_TTCErrorMsg e-177)))) ((49) (let ((e-178 (vector-ref arg-0 1))) (let ((e-179 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "File error (" (PreludeC-45TypesC-45String-C-43C-43 e-178 (PreludeC-45TypesC-45String-C-43C-43 "): " (SystemC-45FileC-45Error-u--show_Show_FileError e-179))))))) ((50) (let ((e-180 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Can't find package " e-180))) ((51) (let ((e-181 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-181) ":Can't parse literate"))) ((52) (let ((e-182 (vector-ref arg-0 1))) (let ((e-183 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-182) (PreludeC-45TypesC-45String-C-43C-43 ":Lexer error (" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-183) ")")))))) ((53) (let ((e-184 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Parse errors (" (PreludeC-45TypesC-45String-C-43C-43 (DataC-45List1-u--show_Show_C-40List1C-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-756) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-756) u--d u--x)))) e-184) ")")))) ((54) (let ((e-185 (vector-ref arg-0 1))) (let ((e-186 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-185) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-186) " not found")))))) ((55) (let ((e-187 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Module imports form a cycle: " (CoreC-45NameC-45Namespace-showSep " -> " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent eta-0)) e-187))))) ((56) "Internal error when resolving implicit laziness") ((57) (let ((e-188 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: " e-188))) ((58) (let ((e-189 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Error: " e-189))) ((59) (let ((e-190 (vector-ref arg-0 1))) (let ((e-191 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-190) (PreludeC-45TypesC-45String-C-43C-43 ":The given specifier " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-191) " was not accepted by any available backend.")))))) ((60) (let ((e-193 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "Invalid multiline string: " e-193))) ((61) (let ((e-194 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Timeout in " e-194))) ((62) (let ((e-195 (vector-ref arg-0 1))) (let ((e-196 (vector-ref arg-0 2))) (let ((e-197 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-195) (PreludeC-45TypesC-45String-C-43C-43 ":When elaborating type of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-196) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (CoreC-45Core-u--show_Show_Error e-197))))))))) ((63) (let ((e-198 (vector-ref arg-0 1))) (let ((e-199 (vector-ref arg-0 2))) (let ((e-200 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-198) (PreludeC-45TypesC-45String-C-43C-43 ":When elaborating type of constructor " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-199) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (CoreC-45Core-u--show_Show_Error e-200))))))))) ((64) (let ((e-201 (vector-ref arg-0 1))) (let ((e-202 (vector-ref arg-0 2))) (let ((e-203 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-201) (PreludeC-45TypesC-45String-C-43C-43 ":When elaborating left hand side of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-202) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (CoreC-45Core-u--show_Show_Error e-203))))))))) ((65) (let ((e-204 (vector-ref arg-0 1))) (let ((e-205 (vector-ref arg-0 2))) (let ((e-206 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-204) (PreludeC-45TypesC-45String-C-43C-43 ":When elaborating right hand side of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-205) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (CoreC-45Core-u--show_Show_Error e-206))))))))) ((66) (let ((e-207 (vector-ref arg-0 1))) (let ((e-208 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Core-u--show_Show_Error e-207) (PreludeC-45TypesC-45String-C-43C-43 "\xa;Did you mean" (if (null? e-208) (PreludeC-45TypesC-45String-C-43C-43 " any of: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_String eta-0)) (DataC-45List1-forget e-208))) "?")) (let ((e-1 (car e-208))) (let ((e-2 (cdr e-208))) (if (null? e-2) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 e-1 "?")) (PreludeC-45TypesC-45String-C-43C-43 " any of: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_String eta-0)) (DataC-45List1-forget e-208))) "?"))))))))))) (else (let ((e-209 (vector-ref arg-0 1))) (CoreC-45Core-u--show_Show_Warning e-209))))))
(define CoreC-45Core-u--show_Show_DotReason (lambda (arg-0) (cond ((equal? arg-0 0) "Non linear pattern variable") ((equal? arg-0 1) "Variable applied to arguments") ((equal? arg-0 2) "Not a constructor application or primitive") ((equal? arg-0 3) "Erased argument") ((equal? arg-0 4) "User dotted") ((equal? arg-0 5) "Unknown reason") (else "Under-applied constructor"))))
(define CoreC-45Core-u--showPrec_Show_Error (lambda (arg-0 arg-1) (CoreC-45Core-u--show_Show_Error arg-1)))
(define CoreC-45Core-u--pretty_Pretty_DotReason (lambda (arg-1) (cond ((equal? arg-1 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Non linear pattern variable")) ((equal? arg-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Variable applied to arguments")) ((equal? arg-1 2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Not a constructor application or primitive")) ((equal? arg-1 3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Erased argument")) ((equal? arg-1 4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "User dotted")) ((equal? arg-1 5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Unknown reason")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Under-applied constructor")))))
(define CoreC-45Core-u--catch_Catchable_Core_Error (lambda (arg-1 arg-2 ext-0) (let ((act-24 (arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) ((arg-2 e-2) ext-0))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 e-5)))))))
(define CoreC-45Core-writeFile (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-0 arg-1) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (vector 1 0))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 e-6) ext-0))))))))))
(define CoreC-45Core-wrapRef (lambda (arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-u--catch_Catchable_Core_Error arg-6 (lambda (u--err) (lambda (eta-0) (let ((act-25 ((arg-5 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (set-box! arg-4 e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))))))))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((arg-5 e-5) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (set-box! arg-4 e-5))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-6)))))))))))))))))
(define CoreC-45Core-wrapError (lambda (arg-1 arg-2) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-758) (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 (arg-1 e-2)))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 e-5))))) arg-2)))
(define CoreC-45Core-traverse_ (lambda (arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (arg-2 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (CoreC-45Core-traverse_ arg-2 e-3 ext-0)))))))))
(define CoreC-45Core-traverseVect (lambda (arg-3 arg-4 ext-0) (if (null? arg-4) (vector 1 '()) (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (vector 1 (csegen-525))) (arg-3 e-3) eta-0)) (lambda (eta-0) (CoreC-45Core-traverseVect arg-3 e-4 eta-0)) ext-0))))))
(define CoreC-45Core-traversePair (lambda (arg-3 arg-4 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-2 e-5)))))) (arg-3 e-3) ext-0)))))
(define CoreC-45Core-traverseList1_ (lambda (arg-2 arg-3) (let ((u--x (let ((e-1 (car arg-3))) e-1))) (let ((u--xs (let ((e-2 (cdr arg-3))) e-2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (arg-2 u--x) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ arg-2 u--xs eta-0)))))))))
(define CoreC-45Core-traverseC-39 (lambda (arg-2 arg-3 arg-4 ext-0) (if (null? arg-3) (vector 1 (PreludeC-45TypesC-45List-reverse arg-4)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((arg-2 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-traverseC-39 arg-2 e-3 (cons e-5 arg-4) ext-0))))))))))
(define CoreC-45CoreC-45PiInfo-traverse (lambda (arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-3 1))) (let ((act-24 ((arg-2 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5)))))))))))
(define CoreC-45CoreC-45Binder-traverse (lambda (arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse arg-2 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((arg-2 e-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-5 e-6))))))))))))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (let ((act-24 ((arg-2 e-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((arg-2 e-9) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (vector 1 e-6 e-7 e-5 e-10))))))))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse arg-2 e-13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((arg-2 e-14) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-11 e-12 e-5 e-6))))))))))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse arg-2 e-18 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((arg-2 e-19) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-16 e-17 e-5 e-6))))))))))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (let ((act-24 ((arg-2 e-23) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((arg-2 e-24) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-21 e-22 e-5 e-6))))))))))))))) (else (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((act-24 ((arg-2 e-28) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-26 e-27 e-5)))))))))))))
(define CoreC-45Core-newRef (lambda (arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 ((DataC-45IORef-newIORef (csegen-3) arg-3) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 e-5)))))))
(define CoreC-45Core-mapTermM (lambda (arg-0 arg-1 ext-0) (CoreC-45Core-n--9775-5926-u--goTerm arg-1 arg-0 arg-1 ext-0)))
(define CoreC-45Core-iwhenJust (lambda (arg-2 arg-3) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox arg-2))) (arg-3 e-1)))))
(define CoreC-45Core-iwhen (lambda (arg-1 arg-2 ext-0) (cond ((equal? arg-1 1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (box e-5)))))) (arg-2) ext-0)) (else (vector 1 '())))))
(define CoreC-45Core-iunless (lambda (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-iwhen (cond ((equal? arg-1 1) 0) (else 1)) arg-2 eta-0))))
(define CoreC-45Core-getWarningLoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (box e-0))) ((1) (let ((e-3 (vector-ref arg-0 2))) (box e-3))) ((2) (let ((e-6 (vector-ref arg-0 1))) (box e-6))) ((3) '()) (else '()))))
(define CoreC-45Core-getErrorLoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45Core-getErrorLoc e-0))) ((1) (let ((e-2 (vector-ref arg-0 2))) (box e-2))) ((2) (let ((e-8 (vector-ref arg-0 2))) (box e-8))) ((3) (let ((e-14 (vector-ref arg-0 2))) (box e-14))) ((4) (let ((e-19 (vector-ref arg-0 2))) (box e-19))) ((5) (let ((e-24 (vector-ref arg-0 2))) (box e-24))) ((6) (let ((e-31 (vector-ref arg-0 2))) (box e-31))) ((7) (let ((e-34 (vector-ref arg-0 1))) (box e-34))) ((8) (let ((e-36 (vector-ref arg-0 1))) (box e-36))) ((9) (let ((e-39 (vector-ref arg-0 1))) (box e-39))) ((10) (let ((e-41 (vector-ref arg-0 1))) (box e-41))) ((11) (let ((e-44 (vector-ref arg-0 1))) (box e-44))) ((12) (let ((e-47 (vector-ref arg-0 1))) (box e-47))) ((13) (let ((e-50 (vector-ref arg-0 1))) (box e-50))) ((14) (let ((e-53 (vector-ref arg-0 1))) (box e-53))) ((15) (let ((e-58 (vector-ref arg-0 2))) (box e-58))) ((16) (let ((e-63 (vector-ref arg-0 2))) (box e-63))) ((17) (let ((e-66 (vector-ref arg-0 1))) (box e-66))) ((18) (let ((e-69 (vector-ref arg-0 2))) (box e-69))) ((19) (let ((e-73 (vector-ref arg-0 2))) (box e-73))) ((20) (let ((e-77 (vector-ref arg-0 1))) (box e-77))) ((21) (let ((e-80 (vector-ref arg-0 1))) (if (null? e-80) '() (let ((e-211 (car e-80))) (let ((e-217 (cdr e-211))) (CoreC-45Core-getErrorLoc e-217)))))) ((22) (let ((e-82 (vector-ref arg-0 2))) (box e-82))) ((23) (let ((e-84 (vector-ref arg-0 1))) (box e-84))) ((24) (let ((e-87 (vector-ref arg-0 1))) (box e-87))) ((25) (let ((e-89 (vector-ref arg-0 1))) (box e-89))) ((26) (let ((e-92 (vector-ref arg-0 2))) (box e-92))) ((27) (let ((e-97 (vector-ref arg-0 2))) (box e-97))) ((28) (let ((e-101 (vector-ref arg-0 2))) (box e-101))) ((29) (let ((e-106 (vector-ref arg-0 2))) (box e-106))) ((30) (let ((e-112 (vector-ref arg-0 2))) (box e-112))) ((31) (let ((e-117 (vector-ref arg-0 1))) (if (null? e-117) '() (let ((e-219 (car e-117))) (let ((e-224 (car e-219))) (box e-224)))))) ((32) (let ((e-119 (vector-ref arg-0 2))) (box e-119))) ((33) (let ((e-125 (vector-ref arg-0 2))) (box e-125))) ((34) (let ((e-129 (vector-ref arg-0 1))) (box e-129))) ((35) (let ((e-134 (vector-ref arg-0 1))) (box e-134))) ((36) (let ((e-136 (vector-ref arg-0 1))) (box e-136))) ((37) (let ((e-138 (vector-ref arg-0 1))) (box e-138))) ((38) (let ((e-140 (vector-ref arg-0 1))) (box e-140))) ((39) (let ((e-143 (vector-ref arg-0 2))) (box e-143))) ((40) (let ((e-147 (vector-ref arg-0 2))) (box e-147))) ((41) (let ((e-152 (vector-ref arg-0 2))) (box e-152))) ((42) (let ((e-155 (vector-ref arg-0 1))) (box e-155))) ((43) (let ((e-159 (vector-ref arg-0 2))) (box e-159))) ((44) (let ((e-163 (vector-ref arg-0 2))) (box e-163))) ((45) (let ((e-168 (vector-ref arg-0 1))) (box e-168))) ((46) (let ((e-171 (vector-ref arg-0 2))) (box e-171))) ((47) (let ((e-175 (vector-ref arg-0 1))) (box e-175))) ((48) '()) ((49) '()) ((50) '()) ((51) (let ((e-181 (vector-ref arg-0 1))) (box e-181))) ((52) (let ((e-182 (vector-ref arg-0 1))) (box e-182))) ((53) (let ((e-184 (vector-ref arg-0 1))) (let ((e-227 (car e-184))) (let ((e-231 (car e-227))) (box e-231))))) ((54) (let ((e-185 (vector-ref arg-0 1))) (box e-185))) ((55) '()) ((56) '()) ((57) '()) ((58) '()) ((59) (let ((e-190 (vector-ref arg-0 1))) (box e-190))) ((60) (let ((e-192 (vector-ref arg-0 1))) (box e-192))) ((61) '()) ((62) (let ((e-197 (vector-ref arg-0 3))) (CoreC-45Core-getErrorLoc e-197))) ((63) (let ((e-200 (vector-ref arg-0 3))) (CoreC-45Core-getErrorLoc e-200))) ((64) (let ((e-203 (vector-ref arg-0 3))) (CoreC-45Core-getErrorLoc e-203))) ((65) (let ((e-206 (vector-ref arg-0 3))) (CoreC-45Core-getErrorLoc e-206))) ((66) (let ((e-207 (vector-ref arg-0 1))) (CoreC-45Core-getErrorLoc e-207))) (else (let ((e-209 (vector-ref arg-0 1))) (CoreC-45Core-getWarningLoc e-209))))))
(define CoreC-45Core-foldlC (lambda (arg-3 arg-4 arg-5 ext-0) (let ((e-2 (vector-ref arg-3 1))) (((((e-2 'erased) 'erased) (lambda (u--ma) (lambda (u--b) (lambda (eta-0) (let ((act-24 (u--ma eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) ((PreludeC-45Basics-flip arg-4 u--b e-7) eta-0))))))))) (lambda (eta-0) (vector 1 arg-5))) ext-0))))
(define CoreC-45Core-filterM (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 ((arg-1 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (CoreC-45Core-filterM arg-1 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-2 e-6))))))) (else (CoreC-45Core-filterM arg-1 e-3 ext-0))))))))))))
(define CoreC-45Core-coreRun (lambda (arg-2 arg-3 arg-4 ext-0) (let ((act-24 (arg-2 ext-0))) ((PreludeC-45Types-either (lambda () arg-3) (lambda () arg-4) act-24) ext-0))))
(define CoreC-45Core-coreFail (lambda (arg-1 ext-0) (vector 0 arg-1)))
(define CoreC-45Core-cond (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-1 (e-6))) (cond ((equal? e-1 1) (e-7)) (else (CoreC-45Core-cond e-3 arg-2)))))))))))
(define CoreC-45Core-anyM (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 ((arg-1 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (vector 1 1)) (else (CoreC-45Core-anyM arg-1 e-3 ext-0))))))))))))
(define CoreC-45Core-allM (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 1) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 ((arg-1 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (CoreC-45Core-allM arg-1 e-3 ext-0)) (else (vector 1 0))))))))))))
(define CoreC-45Core-C-60C-42C-62 (lambda (arg-2 arg-3 ext-0) (let ((act-17 (let ((act-17 (lambda (eta-0) (lambda (eta-1) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (case (vector-ref eta-1 0) ((1) (let ((e-8 (vector-ref eta-1 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref eta-1 1))) (vector 0 e-11))))))))))) (let ((act-16 (arg-2 ext-0))) (act-17 act-16))))) (let ((act-16 (arg-3 ext-0))) (act-17 act-16)))))
(define CoreC-45Core-C-42C-62 (lambda (arg-2 arg-3 ext-0) (let ((act-17 (let ((act-17 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Interfaces-C-42C-62 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-2 (vector-ref arg-215 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-215 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-609) (vector 1 arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-2 (vector-ref arg-610 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))) eta-0 eta-1))))) (let ((act-16 (arg-2 ext-0))) (act-17 act-16))))) (let ((act-16 (arg-3 ext-0))) (act-17 act-16)))))
(define DataC-45IORef-newIORef (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (box arg-3))))) (lambda (u--m) (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) u--m))))))))))
(define LibrariesC-45DataC-45IMaybe-fromJust (lambda (arg-1) (let ((e-1 (unbox arg-1))) e-1)))
(define CoreC-45Env-n--4774-1617-u--findUsedArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) arg-8 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (CoreC-45Env-n--4774-1617-u--findUsedArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (CoreC-45Env-findUsed arg-0 arg-7 arg-8 e-2) e-3))))))
(define CoreC-45Env-n--4774-1550-u--eqNat (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-8 arg-9)))
(define CoreC-45Env-n--4774-1632-u--dropS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) '() (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-2 0) (CoreC-45Env-n--4774-1632-u--dropS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))(else (let ((e-4 (- e-2 1))) (cons e-4 (CoreC-45Env-n--4774-1632-u--dropS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))
(define CoreC-45Env-toVar (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-2 (cdr arg-0))) (cond ((equal? arg-1 0) (box 0))(else (let ((e-3 (- arg-1 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Env-toVar e-2 e-3) (csegen-549)))))))))
(define CoreC-45Env-shrinkEnv (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (box arg-2))(else (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (case (vector-ref arg-3 0) ((1) (let ((e-8 (vector-ref arg-3 1))) (CoreC-45Env-shrinkEnv e-4 e-8))) (else (let ((e-12 (vector-ref arg-3 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Env-shrinkEnv e-4 e-12) (lambda (u--envC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkBinder e-3 e-12) (lambda (u--bC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons u--bC-39 u--envC-39)))))))))))))))
(define CoreC-45Env-mkShrinkSub (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (let ((sc1 (CoreC-45Env-isUsed 0 arg-2))) (cond ((equal? sc1 1) (cons (cons arg-0 '()) (vector 2 (vector 0 )))) (else (cons '() (vector 1 (vector 0 )))))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (CoreC-45Env-mkShrinkSub e-2 e-3 (CoreC-45TT-dropFirst arg-2)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (CoreC-45Env-isUsed 0 arg-2))) (cond ((equal? sc2 1) (cons (cons arg-0 e-5) (vector 2 e-4))) (else (cons e-5 (vector 1 e-4)))))))))))))
(define CoreC-45Env-mkShrink (lambda (arg-0 arg-1) (if (null? arg-0) (cons '() (vector 0 )) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (CoreC-45Env-mkShrinkSub e-2 e-3 arg-1))))))
(define CoreC-45Env-mkEnv (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (cons (vector 3 arg-0 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 10 arg-0 0)) (CoreC-45Env-mkEnv arg-0 e-3))))))
(define CoreC-45Env-letToLam (lambda (arg-1) (if (null? arg-1) '() (let ((e-4 (car arg-1))) (let ((e-5 (cdr arg-1))) (case (vector-ref e-4 0) ((1) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-10 (vector-ref e-4 4))) (cons (vector 0 e-7 e-8 (vector 1 ) e-10) (CoreC-45Env-letToLam e-5))))))(else (cons e-4 (CoreC-45Env-letToLam e-5)))))))))
(define CoreC-45Env-length (lambda (arg-2) (if (null? arg-2) 0 (let ((e-5 (cdr arg-2))) (+ 1 (CoreC-45Env-length e-5))))))
(define CoreC-45Env-isUsed (lambda (arg-1 arg-2) (if (null? arg-2) 0 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-1 (CoreC-45TT-varIdx e-2)))) (cond ((equal? sc1 1) 1) (else (CoreC-45Env-isUsed arg-1 e-3)))))))))
(define CoreC-45Env-getBinderUnder (lambda (arg-2 arg-3 arg-4 arg-5 arg-7) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? arg-4 0) (let ((e-7 (car arg-7))) (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (let ((e-3 (cdr arg-2))) ((((e-3 'erased) 'erased) (CoreC-45TTC-45SizeOf-reverse (CoreC-45TTC-45SizeOf-mkSizeOf (cons e-1 arg-5)))) eta-0))) e-7)))(else (let ((e-3 (- arg-4 1))) (let ((e-13 (cdr arg-7))) (CoreC-45Env-getBinderUnder arg-2 e-2 e-3 (cons e-1 arg-5) e-13)))))))))
(define CoreC-45Env-getBinderLoc (lambda (arg-2 arg-3 arg-5) (let ((e-2 (cdr arg-2))) (cond ((equal? arg-3 0) (let ((e-7 (car arg-5))) (CoreC-45TT-binderLoc e-7)))(else (let ((e-3 (- arg-3 1))) (let ((e-13 (cdr arg-5))) (CoreC-45Env-getBinderLoc e-2 e-3 e-13))))))))
(define CoreC-45Env-getBinder (lambda (arg-2 arg-3 arg-4 arg-6) (CoreC-45Env-getBinderUnder arg-2 arg-3 arg-4 '() arg-6)))
(define CoreC-45Env-findUsedLocs (lambda (arg-0 arg-1 arg-2) (DataC-45List-mapMaybe (lambda (eta-0) (CoreC-45Env-toVar arg-0 eta-0)) (CoreC-45Env-findUsed arg-0 arg-1 '() arg-2))))
(define CoreC-45Env-findUsedInBinder (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-3) e-4)))) ((4) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-8) e-9))))(else (CoreC-45Env-findUsed arg-0 arg-1 arg-2 (CoreC-45TT-binderType arg-3))))))
(define CoreC-45Env-findUsed (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((sc1 (DataC-45List-elemBy (lambda (eta-0) (lambda (eta-1) (CoreC-45Env-n--4774-1550-u--eqNat arg-0 e-4 e-3 e-2 arg-2 arg-1 eta-0 eta-1))) e-4 arg-2))) (cond ((equal? sc1 1) arg-2) (else (CoreC-45Env-findUsedInBinder arg-0 arg-1 (cons e-4 arg-2) (CoreC-45Env-getBinder (csegen-764) arg-0 e-4 arg-1))))))))) ((2) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (CoreC-45Env-n--4774-1617-u--findUsedArgs arg-0 e-7 e-8 e-9 e-10 arg-2 arg-1 arg-1 arg-2 e-10)))))) ((3) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (CoreC-45Env-n--4774-1632-u--dropS arg-0 e-13 e-15 e-14 e-12 arg-2 arg-1 (CoreC-45Env-findUsed (cons e-13 arg-0) (cons e-14 arg-1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (+ 1 eta-0)) (CoreC-45Env-findUsedInBinder arg-0 arg-1 arg-2 e-14)) e-15))))))) ((4) (let ((e-18 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 3))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-18) e-19)))) ((5) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-23) e-24)))) ((6) (let ((e-28 (vector-ref arg-3 3))) (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-28))) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-32) e-33)))) ((8) (let ((e-37 (vector-ref arg-3 3))) (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-37)))(else arg-2))))
(define CoreC-45Env-findSubEnv (lambda (arg-0 arg-1 arg-2) (CoreC-45Env-mkShrink arg-0 (CoreC-45Env-findUsedLocs arg-0 arg-1 arg-2))))
(define CoreC-45Env-defined (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (let ((sc2 (CoreC-45Name-nameEq arg-1 e-2))) (if (null? sc2) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Env-defined e-3 arg-1 e-9) (lambda (_-0) (let ((e-5 (car _-0))) (let ((e-4 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (+ 1 e-5) e-4)))))) (let ((e-4 (unbox sc2))) (cond (else (box (cons 0 (CoreC-45TT-multiplicity e-8)))))))))))))))
(define CoreC-45Env-bindEnv (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (CoreC-45Env-bindEnv e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 3 (CoreC-45TT-binderLoc e-8) (CoreC-45TT-multiplicity e-8) (vector 1 ) (CoreC-45TT-binderType e-8)) arg-3)))))))))
(define CoreC-45Env-allVarsNoLet (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-1))) (let ((e-9 (cdr arg-1))) (case (vector-ref e-8 0) ((1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) (CoreC-45Env-allVars e-3 e-9)))(else (cons 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) (CoreC-45Env-allVars e-3 e-9)))))))))))
(define CoreC-45Env-allVars (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-3 (cdr arg-0))) (let ((e-9 (cdr arg-1))) (cons 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) (CoreC-45Env-allVars e-3 e-9))))))))
(define CoreC-45Env-abstractFullEnvType (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (case (vector-ref e-8 0) ((2) (let ((e-11 (vector-ref e-8 1))) (let ((e-12 (vector-ref e-8 2))) (let ((e-13 (vector-ref e-8 3))) (let ((e-14 (vector-ref e-8 4))) (CoreC-45Env-abstractFullEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 2 e-11 e-12 e-13 e-14) arg-3)))))))(else (let ((u--bnd (vector 2 arg-1 (CoreC-45TT-multiplicity e-8) (vector 1 ) (CoreC-45TT-binderType e-8)))) (CoreC-45Env-abstractFullEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 u--bnd arg-3))))))))))))
(define CoreC-45Env-abstractEnvType (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (case (vector-ref e-8 0) ((1) (let ((e-11 (vector-ref e-8 1))) (let ((e-12 (vector-ref e-8 2))) (let ((e-13 (vector-ref e-8 3))) (let ((e-14 (vector-ref e-8 4))) (CoreC-45Env-abstractEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 1 e-11 e-12 e-13 e-14) arg-3))))))) ((2) (let ((e-16 (vector-ref e-8 1))) (let ((e-17 (vector-ref e-8 2))) (let ((e-18 (vector-ref e-8 3))) (let ((e-19 (vector-ref e-8 4))) (CoreC-45Env-abstractEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 2 e-16 e-17 e-18 e-19) arg-3)))))))(else (let ((u--bnd (vector 2 (CoreC-45TT-binderLoc e-8) (CoreC-45TT-multiplicity e-8) (vector 1 ) (CoreC-45TT-binderType e-8)))) (CoreC-45Env-abstractEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 u--bnd arg-3))))))))))))
(define CoreC-45ContextC-45Context-u--show_Show_SizeChange (lambda (arg-0) (cond ((equal? arg-0 0) "Smaller") ((equal? arg-0 1) "Same") (else "Unknown"))))
(define CoreC-45ContextC-45Context-u--show_Show_SCCall (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-0 (car arg-0))) e-0)) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-770) (let ((e-1 (cdr arg-0))) e-1))))))
(define CoreC-45ContextC-45Context-u--show_Show_DefFlag (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "inline") ((1) "invertible") ((2) "overloadable") ((3) "tcinline") ((4) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45TT-u--show_Show_TotalReq e-0))) ((5) "blockedhint") ((6) "macro") ((7) "partialeval") ((8) "allguarded") ((9) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "contype " (CoreC-45CompileExpr-u--show_Show_ConInfo e-2)))) (else (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "identity " (PreludeC-45Show-u--show_Show_Nat e-3)))))))
(define CoreC-45ContextC-45Context-u--show_Show_Def (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "undefined") ((1) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (let ((e-3 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-1) (PreludeC-45TypesC-45String-C-43C-43 ";\xa;Compile time tree: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-1 e-2) (PreludeC-45TypesC-45String-C-43C-43 "\xa;Run time tree: " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-1 e-3))))))))) ((5) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "DataCon " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-5) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-6) (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (u--n) (PreludeC-45TypesC-45String-C-43C-43 " (newtype by " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-783) (csegen-775)) u--n) ")")))) e-7))))))))) ((6) (let ((e-8 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (let ((e-10 (vector-ref arg-0 3))) (let ((e-13 (vector-ref arg-0 6))) (let ((e-14 (vector-ref arg-0 7))) (let ((e-15 (vector-ref arg-0 8))) (PreludeC-45TypesC-45String-C-43C-43 "TyCon " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-9) (PreludeC-45TypesC-45String-C-43C-43 " params: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-775) e-10) (PreludeC-45TypesC-45String-C-43C-43 " constructors: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-14) (PreludeC-45TypesC-45String-C-43C-43 " mutual with: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-13) (PreludeC-45TypesC-45String-C-43C-43 " detaggable by: " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-775) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-775) u--d u--x)))) e-15))))))))))))))))))) ((2) (let ((e-16 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "<external def with arity " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-16) ">")))) ((3) (let ((e-17 (vector-ref arg-0 1))) (let ((e-18 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "<foreign def with arity " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-17) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-18) ">"))))))) ((4) (let ((e-19 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "<builtin with arith " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-19) ">")))) ((7) (let ((e-22 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "Hole" (let ((sc1 (let ((e-0 (car e-22))) e-0))) (cond ((equal? sc1 1) " [impl]") (else "")))))) ((8) (let ((e-25 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Search in " (CoreC-45Name-u--show_Show_Name e-25)))) ((9) (let ((e-26 (vector-ref arg-0 1))) (let ((e-28 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Guess " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-26) (PreludeC-45TypesC-45String-C-43C-43 " when " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-246) e-28))))))) ((10) "Bound name") (else "Delayed"))))
(define CoreC-45ContextC-45Context-u--show_Show_Clause (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-0) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-0 e-2) (PreludeC-45TypesC-45String-C-43C-43 " = " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-0 e-3))))))))))
(define CoreC-45ContextC-45Context-u--showPrec_Show_SizeChange (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_SizeChange arg-1)))
(define CoreC-45ContextC-45Context-u--showPrec_Show_SCCall (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_SCCall arg-1)))
(define CoreC-45ContextC-45Context-u--showPrec_Show_DefFlag (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_DefFlag arg-1)))
(define CoreC-45ContextC-45Context-u--showPrec_Show_Def (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_Def arg-1)))
(define CoreC-45ContextC-45Context-u--showPrec_Show_Clause (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_Clause arg-1)))
(define CoreC-45ContextC-45Context-u--C-61C-61_Eq_SizeChange (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define CoreC-45ContextC-45Context-u--C-61C-61_Eq_SchemeMode (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0)))(else 0))))
(define CoreC-45ContextC-45Context-u--C-61C-61_Eq_SCCall (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-u--C-61C-61_Eq_Name (let ((e-0 (car arg-0))) e-0) (let ((e-0 (car arg-1))) e-0)))) (cond ((equal? sc0 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-790) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45Types-u--C-47C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-790) arg-4 arg-5)))) (let ((e-1 (cdr arg-0))) e-1) (let ((e-1 (cdr arg-1))) e-1))) (else 0)))))
(define CoreC-45ContextC-45Context-u--C-61C-61_Eq_DefFlag (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (case (vector-ref arg-1 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-1 0) ((3) 1)(else 0))) ((4) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-4 (vector-ref arg-1 1))) (CoreC-45TT-u--C-61C-61_Eq_TotalReq e-0 e-4)))(else 0)))) ((5) (case (vector-ref arg-1 0) ((5) 1)(else 0))) ((6) (case (vector-ref arg-1 0) ((6) 1)(else 0))) ((7) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-5 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-802) (csegen-792) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-802) (csegen-792) arg-4 arg-5)))) e-1 e-5)))(else 0)))) ((8) (case (vector-ref arg-1 0) ((8) 1)(else 0))) ((9) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-6 (vector-ref arg-1 1))) (CoreC-45CompileExpr-u--C-61C-61_Eq_ConInfo e-2 e-6)))(else 0)))) ((10) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-7 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-61C-61_Eq_Nat e-3 e-7)))(else 0))))(else 0))))
(define CoreC-45ContextC-45Context-u--C-47C-61_Eq_SizeChange (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SizeChange arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45ContextC-45Context-u--C-47C-61_Eq_SchemeMode (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SchemeMode arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45ContextC-45Context-u--C-47C-61_Eq_SCCall (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SCCall arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_DefFlag arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45ContextC-45Context-refersToRuntime (lambda (arg-0) (PreludeC-45Types-maybe (lambda () (LibrariesC-45DataC-45NameMap-empty)) (lambda () (lambda (eta-0) eta-0)) (let ((e-13 (vector-ref arg-0 13))) e-13))))
(define CoreC-45ContextC-45Context-refersTo (lambda (arg-0) (PreludeC-45Types-maybe (lambda () (LibrariesC-45DataC-45NameMap-empty)) (lambda () (lambda (eta-0) eta-0)) (let ((e-12 (vector-ref arg-0 12))) e-12))))
(define CoreC-45ContextC-45Context-holeInit (lambda (arg-0) (cons arg-0 0)))
(define CoreC-45ContextC-45Context-gDefKindedName (lambda (arg-0) (let ((u--nm (let ((e-1 (vector-ref arg-0 1))) e-1))) (vector (CoreC-45ContextC-45Context-defNameType (let ((e-17 (vector-ref arg-0 17))) e-17)) u--nm u--nm))))
(define CoreC-45ContextC-45Context-findSetTotal (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((4) (let ((e-4 (vector-ref e-2 1))) (box e-4)))(else (CoreC-45ContextC-45Context-findSetTotal e-3))))))))
(define CoreC-45ContextC-45Context-defaultPI(blodwen-lazy (lambda () (vector '() 0 0))))
(define CoreC-45ContextC-45Context-defaultFlags(blodwen-lazy (lambda () (cons 0 0))))
(define CoreC-45ContextC-45Context-defNameType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) '()) ((1) (box (vector 1 ))) ((2) (box (vector 1 ))) ((3) (box (vector 1 ))) ((4) (box (vector 1 ))) ((5) (let ((e-10 (vector-ref arg-0 1))) (let ((e-11 (vector-ref arg-0 2))) (box (vector 2 e-10 e-11))))) ((6) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (box (vector 3 e-13 e-14))))) ((7) (box (vector 1 ))) ((8) '()) ((9) '()) ((10) (box (vector 0 ))) (else '()))))
(define LibrariesC-45DataC-45UserNameMap-n--5061-7048-u--treeToListC-39 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (arg-3 (cons e-1 e-2))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 3))) (LibrariesC-45DataC-45UserNameMap-n--5061-7048-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45UserNameMap-n--5061-7048-u--treeToListC-39 arg-3 e-7))) e-5)))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 5))) (LibrariesC-45DataC-45UserNameMap-n--5061-7048-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45UserNameMap-n--5061-7048-u--treeToListC-39 (lambda (arg-1) (cons arg-1 (LibrariesC-45DataC-45UserNameMap-n--5061-7048-u--treeToListC-39 arg-3 e-14))) e-12))) e-10))))))))
(define LibrariesC-45DataC-45UserNameMap-n--5544-7522-u--inserted (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (LibrariesC-45DataC-45UserNameMap-toList arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-3) (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-2)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45UserNameMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45UserNameMap-n--5061-7048-u--treeToListC-39 (lambda (arg-0) (cons arg-0 '())) ext-0)))
(define LibrariesC-45DataC-45UserNameMap-treeLookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_UserName arg-2 e-1))) (cond ((equal? sc1 1) (box e-2)) (else '())))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-6))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-5)) (else (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-7)))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-11))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-10)) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-13))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-12)) (else (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-14))))))))))))))))
(define LibrariesC-45DataC-45UserNameMap-treeInsertC-39 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (CoreC-45Name-u--compare_Ord_UserName arg-2 e-1))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-2 arg-3) (cons arg-2 (vector 0 e-1 e-2))))) ((equal? sc1 1) (vector 0 (vector 0 arg-2 arg-3))) (else (vector 1 (cons (vector 0 e-1 e-2) (cons e-1 (vector 0 arg-2 arg-3)))))))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-6))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-5))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-6 e-7)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-10 e-12 e-13 e-6 e-7))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-5 e-6 e-2)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-5 e-6 e-10 e-12 e-13))))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-11))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-10))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-11 e-12 e-13 e-14)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-16 e-15) (cons e-11 (vector 1 e-12 e-13 e-14))))))))))))) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-2 e-13 e-14)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-8) (cons e-16 (vector 1 e-15 e-13 e-14))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-14))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-12 e-13 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-12) (cons e-13 (vector 1 e-8 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45UserNameMap-treeInsert (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45UserNameMap-toList (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45UserNameMap-treeToList e-3)))))
(define LibrariesC-45DataC-45UserNameMap-mergeWith (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45UserNameMap-insertFrom (LibrariesC-45DataC-45UserNameMap-n--5544-7522-u--inserted arg-3 arg-2 arg-1) arg-2)))
(define LibrariesC-45DataC-45UserNameMap-mergeLeft (lambda (arg-1 arg-2) (LibrariesC-45DataC-45UserNameMap-mergeWith (lambda (eta-0) (lambda (eta-1) eta-0)) arg-1 arg-2)))
(define LibrariesC-45DataC-45UserNameMap-lookup (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45UserNameMap-treeLookup arg-1 e-3)))))
(define LibrariesC-45DataC-45UserNameMap-insertFrom (lambda (ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-1) (lambda (eta-2) (PreludeC-45Basics-flip (lambda (eta-3) (PreludeC-45Basics-uncurry (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (LibrariesC-45DataC-45UserNameMap-insert eta-4 eta-5 eta-6)))) eta-3)) eta-1 eta-2))) eta-0 clam-0))) ext-0 ext-1)))
(define LibrariesC-45DataC-45UserNameMap-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons 0 (vector 0 arg-1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-treeInsert arg-1 arg-2 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (cons e-2 e-4))) (else (let ((e-5 (vector-ref sc1 1))) (cons (+ 1 e-2) e-5))))))))))
(define LibrariesC-45DataC-45UserNameMap-empty(blodwen-lazy (lambda () '())))
(define LibrariesC-45DataC-45IntMap-n--4815-2435-u--treeToListC-39 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (cons (cons e-1 e-2) arg-3)))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 3))) (LibrariesC-45DataC-45IntMap-n--4815-2435-u--treeToListC-39 (LibrariesC-45DataC-45IntMap-n--4815-2435-u--treeToListC-39 arg-3 e-7) e-5)))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 5))) (LibrariesC-45DataC-45IntMap-n--4815-2435-u--treeToListC-39 (LibrariesC-45DataC-45IntMap-n--4815-2435-u--treeToListC-39 (LibrariesC-45DataC-45IntMap-n--4815-2435-u--treeToListC-39 arg-3 e-14) e-12) e-10))))))))
(define LibrariesC-45DataC-45IntMap-n--5254-2866-u--inserted (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (LibrariesC-45DataC-45IntMap-toList arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-3) (LibrariesC-45DataC-45IntMap-lookup e-2 arg-2)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45IntMap-u--neutral_Monoid_C-40IntMapC-32C-36vC-41 (lambda (arg-1) (LibrariesC-45DataC-45IntMap-empty)))
(define LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45IntMap-merge arg-1 ext-0 ext-1)))
(define LibrariesC-45DataC-45IntMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45IntMap-n--4815-2435-u--treeToListC-39 '() ext-0)))
(define LibrariesC-45DataC-45IntMap-treeLookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 e-1))) (cond ((equal? sc1 1) (box e-2)) (else '())))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-6))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-5)) (else (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-7)))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-11))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-10)) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-13))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-12)) (else (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-14))))))))))))))))
(define LibrariesC-45DataC-45IntMap-treeInsertC-39 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (PreludeC-45EqOrd-u--compare_Ord_Int arg-2 e-1))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-2 arg-3) (cons arg-2 (vector 0 e-1 e-2))))) ((equal? sc1 1) (vector 0 (vector 0 arg-2 arg-3))) (else (vector 1 (cons (vector 0 e-1 e-2) (cons e-1 (vector 0 arg-2 arg-3)))))))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-6))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-5))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-6 e-7)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-10 e-12 e-13 e-6 e-7))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-5 e-6 e-2)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-5 e-6 e-10 e-12 e-13))))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-11))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-10))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-11 e-12 e-13 e-14)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-16 e-15) (cons e-11 (vector 1 e-12 e-13 e-14))))))))))))) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-2 e-13 e-14)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-8) (cons e-16 (vector 1 e-15 e-13 e-14))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-14))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-12 e-13 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-12) (cons e-13 (vector 1 e-8 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45IntMap-treeInsert (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45IntMap-treeDelete (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-1 0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 e-2))) (cond ((equal? sc2 1) (vector 1 0)) (else (vector 0 (vector 0 e-2 e-3))))))))(else (let ((e-0 (- arg-1 1))) (cond ((equal? e-0 0) (case (vector-ref arg-3 0) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-8))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-7))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-2 e-8 e-9)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 1 e-9)))))))) (else (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-9))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-7 e-8 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 1 e-7)))))))))))))) (else (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (let ((e-16 (vector-ref arg-3 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-2 e-13 e-14 e-15 e-16)))) (else (let ((e-5 (vector-ref sc3 1))) (cond (else (vector 0 (vector 1 e-14 e-15 e-16))))))))) (else (let ((sc3 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-15))) (cond ((equal? sc3 1) (let ((sc4 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-14))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-12 e-13 e-2 e-15 e-16)))) (else (let ((e-5 (vector-ref sc4 1))) (cond (else (vector 0 (vector 1 e-12 e-13 e-16))))))))) (else (let ((sc4 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-16))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-12 e-13 e-14 e-15 e-2)))) (else (let ((e-5 (vector-ref sc4 1))) (cond (else (vector 0 (vector 1 e-12 e-13 e-14))))))))))))))))))))))(else (let ((e-4 (- e-0 1))) (case (vector-ref arg-3 0) ((1) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-20))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeDelete (+ 1 e-4) arg-2 e-19))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-20 e-21)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-21 0) ((1) (let ((e-2 (vector-ref e-21 1))) (let ((e-3 (vector-ref e-21 2))) (let ((e-6 (vector-ref e-21 3))) (vector 1 (vector 2 e-5 e-20 e-2 e-3 e-6)))))) (else (let ((e-7 (vector-ref e-21 1))) (let ((e-8 (vector-ref e-21 2))) (let ((e-9 (vector-ref e-21 3))) (let ((e-10 (vector-ref e-21 4))) (let ((e-11 (vector-ref e-21 5))) (vector 0 (LibrariesC-45DataC-45IntMap-branch4 e-5 e-20 e-7 e-8 e-9 e-10 e-11)))))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45IntMap-treeDelete (+ 1 e-4) arg-2 e-21))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-19 e-20 e-2)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-19 0) ((1) (let ((e-2 (vector-ref e-19 1))) (let ((e-3 (vector-ref e-19 2))) (let ((e-6 (vector-ref e-19 3))) (vector 1 (vector 2 e-2 e-3 e-6 e-20 e-5)))))) (else (let ((e-7 (vector-ref e-19 1))) (let ((e-8 (vector-ref e-19 2))) (let ((e-9 (vector-ref e-19 3))) (let ((e-10 (vector-ref e-19 4))) (let ((e-11 (vector-ref e-19 5))) (vector 0 (LibrariesC-45DataC-45IntMap-branch4 e-7 e-8 e-9 e-10 e-11 e-20 e-5)))))))))))))))))))) (else (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (let ((e-27 (vector-ref arg-3 4))) (let ((e-28 (vector-ref arg-3 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-25))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeDelete (+ 1 e-4) arg-2 e-24))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-25 e-26 e-27 e-28)))) (else (let ((e-5 (vector-ref sc2 1))) (vector 0 (LibrariesC-45DataC-45IntMap-merge1 e-5 e-25 e-26 e-27 e-28))))))) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-27))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete (+ 1 e-4) arg-2 e-26))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-24 e-25 e-2 e-27 e-28)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45IntMap-merge2 e-24 e-25 e-5 e-27 e-28))))))) (else (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete (+ 1 e-4) arg-2 e-28))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-24 e-25 e-26 e-27 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45IntMap-merge3 e-24 e-25 e-26 e-27 e-5)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45IntMap-toList (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45IntMap-treeToList e-3)))))
(define LibrariesC-45DataC-45IntMap-singleton (lambda (arg-1 arg-2) (LibrariesC-45DataC-45IntMap-insert arg-1 arg-2 (LibrariesC-45DataC-45IntMap-empty))))
(define LibrariesC-45DataC-45IntMap-mergeWith (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45IntMap-insertFrom (LibrariesC-45DataC-45IntMap-n--5254-2866-u--inserted arg-3 arg-2 arg-1) arg-2)))
(define LibrariesC-45DataC-45IntMap-merge3 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-4 0) ((1) (let ((e-14 (vector-ref arg-4 1))) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (LibrariesC-45DataC-45IntMap-branch5 e-2 e-3 e-4 arg-3 e-14 e-15 e-16 arg-5 arg-6))))) (else (let ((e-19 (vector-ref arg-4 1))) (let ((e-20 (vector-ref arg-4 2))) (let ((e-21 (vector-ref arg-4 3))) (let ((e-22 (vector-ref arg-4 4))) (let ((e-23 (vector-ref arg-4 5))) (LibrariesC-45DataC-45IntMap-branch6 e-2 e-3 e-4 arg-3 e-19 e-20 e-21 e-22 e-23 arg-5 arg-6)))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((e-11 (vector-ref arg-2 5))) (case (vector-ref arg-4 0) ((1) (let ((e-26 (vector-ref arg-4 1))) (let ((e-27 (vector-ref arg-4 2))) (let ((e-28 (vector-ref arg-4 3))) (LibrariesC-45DataC-45IntMap-branch6 e-7 e-8 e-9 e-10 e-11 arg-3 e-26 e-27 e-28 arg-5 arg-6))))) (else (let ((e-31 (vector-ref arg-4 1))) (let ((e-32 (vector-ref arg-4 2))) (let ((e-33 (vector-ref arg-4 3))) (let ((e-34 (vector-ref arg-4 4))) (let ((e-35 (vector-ref arg-4 5))) (LibrariesC-45DataC-45IntMap-branch7 e-7 e-8 e-9 e-10 e-11 arg-3 e-31 e-32 e-33 e-34 e-35 arg-5 arg-6)))))))))))))))))
(define LibrariesC-45DataC-45IntMap-merge2 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-6 0) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (let ((e-16 (vector-ref arg-6 3))) (LibrariesC-45DataC-45IntMap-branch5 e-2 e-3 e-4 arg-3 arg-4 arg-5 e-14 e-15 e-16))))) (else (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (let ((e-22 (vector-ref arg-6 4))) (let ((e-23 (vector-ref arg-6 5))) (LibrariesC-45DataC-45IntMap-branch6 e-2 e-3 e-4 arg-3 arg-4 arg-5 e-19 e-20 e-21 e-22 e-23)))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((e-11 (vector-ref arg-2 5))) (case (vector-ref arg-6 0) ((1) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (LibrariesC-45DataC-45IntMap-branch6 e-7 e-8 e-9 e-10 e-11 arg-3 arg-4 arg-5 e-26 e-27 e-28))))) (else (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (let ((e-35 (vector-ref arg-6 5))) (LibrariesC-45DataC-45IntMap-branch7 e-7 e-8 e-9 e-10 e-11 arg-3 arg-4 arg-5 e-31 e-32 e-33 e-34 e-35)))))))))))))))))
(define LibrariesC-45DataC-45IntMap-merge1 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-4 0) ((1) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (case (vector-ref arg-6 0) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (let ((e-16 (vector-ref arg-6 3))) (LibrariesC-45DataC-45IntMap-branch5 arg-2 arg-3 e-2 e-3 e-4 arg-5 e-14 e-15 e-16))))) (else (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (let ((e-22 (vector-ref arg-6 4))) (let ((e-23 (vector-ref arg-6 5))) (LibrariesC-45DataC-45IntMap-branch6 arg-2 arg-3 e-2 e-3 e-4 arg-5 e-19 e-20 e-21 e-22 e-23)))))))))))) (else (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (let ((e-10 (vector-ref arg-4 4))) (let ((e-11 (vector-ref arg-4 5))) (case (vector-ref arg-6 0) ((1) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (LibrariesC-45DataC-45IntMap-branch6 arg-2 arg-3 e-7 e-8 e-9 e-10 e-11 arg-5 e-26 e-27 e-28))))) (else (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (let ((e-35 (vector-ref arg-6 5))) (LibrariesC-45DataC-45IntMap-branch7 arg-2 arg-3 e-7 e-8 e-9 e-10 e-11 arg-5 e-31 e-32 e-33 e-34 e-35)))))))))))))))))
(define LibrariesC-45DataC-45IntMap-merge (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45IntMap-mergeWith (lambda (eta-0) (lambda (eta-1) ((arg-1 eta-0) eta-1))) ext-0 ext-1)))
(define LibrariesC-45DataC-45IntMap-lookup (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45IntMap-treeLookup arg-1 e-3)))))
(define LibrariesC-45DataC-45IntMap-keys (lambda (ext-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (LibrariesC-45DataC-45IntMap-toList ext-0))))
(define LibrariesC-45DataC-45IntMap-insertFrom (lambda (ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-1) (lambda (eta-2) (PreludeC-45Basics-flip (lambda (eta-3) (PreludeC-45Basics-uncurry (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (LibrariesC-45DataC-45IntMap-insert eta-4 eta-5 eta-6)))) eta-3)) eta-1 eta-2))) eta-0 clam-0))) ext-0 ext-1)))
(define LibrariesC-45DataC-45IntMap-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons 0 (vector 0 arg-1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45IntMap-treeInsert arg-1 arg-2 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (cons e-2 e-4))) (else (let ((e-5 (vector-ref sc1 1))) (cons (+ 1 e-2) e-5))))))))))
(define LibrariesC-45DataC-45IntMap-empty(blodwen-lazy (lambda () '())))
(define LibrariesC-45DataC-45IntMap-delete (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 0) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-1 e-3))) (case (vector-ref sc2 0) ((0) (let ((e-4 (vector-ref sc2 1))) (cons 0 e-4))) (else (let ((e-5 (vector-ref sc2 1))) (cond (else '())))))))(else (let ((e-4 (- e-2 1))) (let ((sc1 (LibrariesC-45DataC-45IntMap-treeDelete (+ 1 e-4) arg-1 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-5 (vector-ref sc1 1))) (cons (+ 1 e-4) e-5))) (else (let ((e-5 (vector-ref sc1 1))) (cons e-4 e-5)))))))))))))
(define LibrariesC-45DataC-45IntMap-branch7 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (vector 2 (vector 2 arg-2 arg-3 arg-4 arg-5 arg-6) arg-7 (vector 1 arg-8 arg-9 arg-10) arg-11 (vector 1 arg-12 arg-13 arg-14))))
(define LibrariesC-45DataC-45IntMap-branch6 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 2 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 1 arg-6 arg-7 arg-8) arg-9 (vector 1 arg-10 arg-11 arg-12))))
(define LibrariesC-45DataC-45IntMap-branch5 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (vector 1 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 2 arg-6 arg-7 arg-8 arg-9 arg-10))))
(define LibrariesC-45DataC-45IntMap-branch4 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (vector 1 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 1 arg-6 arg-7 arg-8))))
(define CoreC-45Hash-u--hash_Hashable_String (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_String (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Nat (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Nat_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Namespace (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_Namespace (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_NamedDef (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedDef (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_NamedConstAlt (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedConstAlt (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_NamedConAlt (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedConAlt (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_NamedCExp (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Name (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Integer (lambda (ext-0) (blodwen-toSignedInt ext-0 63)))
(define CoreC-45Hash-u--hash_Hashable_Int8 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Int8_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Int64 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Int64_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Int32 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Int32_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Int16 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Int16_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Int (lambda (ext-0) ext-0))
(define CoreC-45Hash-u--hash_Hashable_Double (lambda (ext-0) (CoreC-45Hash-u--hash_Hashable_String (PreludeC-45Show-u--show_Show_Double ext-0))))
(define CoreC-45Hash-u--hash_Hashable_Char (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Char_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_CFType (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Bits8 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Bits8_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Bits64 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Bits64_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Bits32 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Bits32_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_Bits16 (lambda (ext-0) (PreludeC-45Cast-u--cast_Cast_Bits16_Int ext-0)))
(define CoreC-45Hash-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_C-40TermC-32C-36varsC-41 (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_C-40ListC-32C-36aC-41 (lambda (arg-1 ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 arg-1 (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_String (lambda (arg-0 ext-0) (LibrariesC-45DataC-45StringC-45Iterator-foldl (lambda (eta-0) (lambda (eta-1) (CoreC-45Hash-u--hashWithSalt_Hashable_Char eta-0 eta-1))) arg-0 ext-0)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (lambda (arg-0 ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1) (lambda (eta-0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)) ext-0)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Nat (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Nat arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Namespace (lambda (arg-0 arg-1) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-815) arg-0 (CoreC-45NameC-45Namespace-unsafeUnfoldNamespace arg-1))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_NamedDef (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (let ((e-0 (vector-ref ext-0 1))) (let ((e-1 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-817) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0) e-0) e-1)))) ((1) (let ((e-2 (vector-ref ext-0 1))) (let ((e-3 (vector-ref ext-0 2))) (let ((e-4 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (csegen-819) (CoreC-45Hash-u--hashWithSalt_Hashable_Nat (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (csegen-821) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1) e-2) e-3) e-4))))) ((2) (let ((e-5 (vector-ref ext-0 1))) (let ((e-6 (vector-ref ext-0 2))) (let ((e-7 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-823) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-815) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2) e-5) e-6) e-7))))) (else (let ((e-8 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3) e-8))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_NamedConstAlt (lambda (arg-0 arg-1) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Constant arg-0 e-0) e-1)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_NamedConAlt (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-817) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (csegen-821) (CoreC-45Hash-u--hashWithSalt_Hashable_ConInfo (CoreC-45Hash-u--hashWithSalt_Hashable_Name arg-0 e-0) e-1) e-2) e-3) e-4))))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (let ((e-1 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0) e-1))) ((1) (let ((e-3 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1) e-3))) ((2) (let ((e-5 (vector-ref ext-0 2))) (let ((e-6 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2) e-5) e-6)))) ((3) (let ((e-8 (vector-ref ext-0 2))) (let ((e-9 (vector-ref ext-0 3))) (let ((e-10 (vector-ref ext-0 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3) e-8) e-9) e-10))))) ((4) (let ((e-12 (vector-ref ext-0 2))) (let ((e-13 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-825) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4) e-12) e-13)))) ((5) (let ((e-15 (vector-ref ext-0 2))) (let ((e-16 (vector-ref ext-0 3))) (let ((e-17 (vector-ref ext-0 4))) (let ((e-18 (vector-ref ext-0 5))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-825) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (csegen-821) (CoreC-45Hash-u--hashWithSalt_Hashable_ConInfo (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5) e-15) e-16) e-17) e-18)))))) ((6) (let ((e-21 (vector-ref ext-0 3))) (let ((e-22 (vector-ref ext-0 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (csegen-825) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40PrimFnC-32C-36arityC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6) e-21) e-22)))) ((7) (let ((e-24 (vector-ref ext-0 2))) (let ((e-25 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-825) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7) e-24) e-25)))) ((8) (let ((e-27 (vector-ref ext-0 2))) (let ((e-28 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_LazyReason (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8) e-27) e-28)))) ((9) (let ((e-30 (vector-ref ext-0 2))) (let ((e-31 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_LazyReason (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9) e-30) e-31)))) ((10) (let ((e-33 (vector-ref ext-0 2))) (let ((e-34 (vector-ref ext-0 3))) (let ((e-35 (vector-ref ext-0 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (csegen-825) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_NamedConAlt arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedConAlt arg-568 arg-569)))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10) e-33) e-34) e-35))))) ((11) (let ((e-37 (vector-ref ext-0 2))) (let ((e-38 (vector-ref ext-0 3))) (let ((e-39 (vector-ref ext-0 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (csegen-825) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_NamedConstAlt arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedConstAlt arg-568 arg-569)))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 11) e-37) e-38) e-39))))) ((12) (let ((e-41 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 12) e-41))) ((13) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 13)) (else (let ((e-44 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_String (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 14) e-44))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Name (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-0 (vector-ref arg-1 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_String arg-0 e-0))) ((4) (let ((e-3 (vector-ref arg-1 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name arg-0 e-3))) ((0) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Namespace arg-0 e-4) e-5)))) ((8) (let ((e-6 (vector-ref arg-1 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int arg-0 e-6)))(else (CoreC-45Hash-u--hashWithSalt_Hashable_String arg-0 (CoreC-45Name-u--show_Show_Name arg-1))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_LazyReason (lambda (arg-0 ext-0) (cond ((equal? ext-0 0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0)) ((equal? ext-0 1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Integer (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Integer arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int8 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int8 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int64 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int64 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int32 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int32 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int16 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int16 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Double (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Double arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Constant (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (let ((e-0 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0) e-0))) ((5) (let ((e-1 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1) e-1))) ((6) (let ((e-2 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Bits8 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2) e-2))) ((7) (let ((e-3 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Bits16 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3) e-3))) ((8) (let ((e-4 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Bits32 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4) e-4))) ((9) (let ((e-5 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Bits64 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5) e-5))) ((10) (let ((e-6 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_String (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6) e-6))) ((11) (let ((e-7 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Char (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7) e-7))) ((12) (let ((e-8 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Double (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8) e-8))) ((13) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9)) ((14) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10)) ((19) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 11)) ((20) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 12)) ((21) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 13)) ((22) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 14)) ((23) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 15)) ((24) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 16)) ((25) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 17)) ((26) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 18)) ((27) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 19)) ((1) (let ((e-9 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int8 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 20) e-9))) ((2) (let ((e-10 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int16 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 21) e-10))) ((3) (let ((e-11 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int32 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 22) e-11))) ((4) (let ((e-12 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int64 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 23) e-12))) ((15) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 24)) ((16) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 25)) ((17) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 26)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 27)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_ConInfo (lambda (arg-0 ext-0) (cond ((equal? ext-0 0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0)) ((equal? ext-0 1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1)) ((equal? ext-0 2) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)) ((equal? ext-0 3) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3)) ((equal? ext-0 4) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4)) ((equal? ext-0 5) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5)) ((equal? ext-0 6) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6)) ((equal? ext-0 7) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7)) ((equal? ext-0 8) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8)) ((equal? ext-0 9) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Char (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Char arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_CFType (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0)) ((1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1)) ((7) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)) ((8) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3)) ((9) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4)) ((10) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5)) ((11) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6)) ((12) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7)) ((13) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8)) ((14) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9)) ((15) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10)) ((16) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 11)) ((18) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 12)) ((19) (let ((e-0 (vector-ref ext-0 1))) (let ((e-1 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 13) e-0) e-1)))) ((20) (let ((e-2 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 14) e-2))) ((21) (let ((e-3 (vector-ref ext-0 1))) (let ((e-4 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-815) (csegen-823) arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-815) (csegen-823) arg-568 arg-569)))) (CoreC-45Hash-u--hashWithSalt_Hashable_String (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 15) e-3) e-4)))) ((22) (let ((e-5 (vector-ref ext-0 1))) (let ((e-6 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-823) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 16) e-5) e-6)))) ((3) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 17)) ((4) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 18)) ((5) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 19)) ((6) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 20)) ((17) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 21)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 22)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Bits8 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Bits8 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Bits64 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Bits64 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Bits32 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Bits32 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Bits16 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Bits16 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-4 (cdr arg-3))) ((e-4 (let ((e-5 (cdr arg-2))) ((e-5 arg-4) e-2))) e-3))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_Nat (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 0) e-4))) ((1) (let ((e-9 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 1) e-9))) ((2) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-834) (CoreC-45Hash-u--hashWithSalt_Hashable_Int (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 2) e-13) e-14)))) ((3) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40BinderC-32C-36tyC-41 (csegen-834) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 3) e-18) e-19)))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 4) e-22) e-23)))) ((5) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 5) e-27) e-28)))) ((6) (let ((e-32 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 6) e-32))) ((7) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 7) e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 8) e-41))) ((9) (let ((e-44 (vector-ref arg-2 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_String (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 9) (CoreC-45TT-u--show_Show_Constant e-44)))) ((10) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 10)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 11)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40PrimFnC-32C-36arityC-41 (lambda (arg-1 ext-0) (case (vector-ref ext-0 0) ((0) (let ((e-0 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 0) e-0))) ((1) (let ((e-1 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 1) e-1))) ((2) (let ((e-2 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 2) e-2))) ((3) (let ((e-3 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 3) e-3))) ((4) (let ((e-4 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 4) e-4))) ((5) (let ((e-5 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 5) e-5))) ((6) (let ((e-6 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 6) e-6))) ((7) (let ((e-7 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 7) e-7))) ((8) (let ((e-8 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 8) e-8))) ((9) (let ((e-9 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 9) e-9))) ((10) (let ((e-10 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 10) e-10))) ((11) (let ((e-11 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 11) e-11))) ((12) (let ((e-12 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 12) e-12))) ((13) (let ((e-13 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 13) e-13))) ((14) (let ((e-14 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 14) e-14))) ((15) (let ((e-15 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 15) e-15))) ((16) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 16)) ((17) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 17)) ((18) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 18)) ((19) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 19)) ((20) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 20)) ((21) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 21)) ((22) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 22)) ((23) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 23)) ((24) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 24)) ((25) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 25)) ((27) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 26)) ((28) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 27)) ((29) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 28)) ((30) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 29)) ((31) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 30)) ((32) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 31)) ((33) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 32)) ((34) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 33)) ((35) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 34)) ((36) (let ((e-16 (vector-ref ext-0 1))) (let ((e-17 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 35) e-16) e-17)))) ((37) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 36)) ((38) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 37)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 38)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 0)) ((1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 1)) ((2) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 2)) (else (let ((e-4 (vector-ref arg-3 1))) (let ((e-2 (cdr arg-1))) ((e-2 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 3)) e-4)))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (PreludeC-45Num-u--abs_Abs_Int arg-2) (let ((e-2 (unbox arg-3))) (let ((e-3 (cdr arg-1))) ((e-3 arg-2) e-2))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (PreludeC-45Num-u--abs_Abs_Int arg-2) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 arg-1 (bs+ (bs* arg-2 33 63) (let ((e-1 (car arg-1))) (e-1 e-2)) 63) e-3))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40BinderC-32C-36tyC-41 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (cdr arg-1))) ((e-5 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40PiInfoC-32C-36tC-41 arg-1 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 0) e-2) e-3)) e-4)))))) ((1) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (let ((e-2 (cdr arg-1))) ((e-2 (let ((e-3 (cdr arg-1))) ((e-3 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 1) e-7)) e-8))) e-9)))))) ((2) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (let ((e-2 (cdr arg-1))) ((e-2 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40PiInfoC-32C-36tC-41 arg-1 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 2) e-12) e-13)) e-14)))))) ((3) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (let ((e-2 (cdr arg-1))) ((e-2 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40PiInfoC-32C-36tC-41 arg-1 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 3) e-17) e-18)) e-19)))))) ((4) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (let ((e-2 (cdr arg-1))) ((e-2 (let ((e-3 (cdr arg-1))) ((e-3 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 4) e-22)) e-23))) e-24)))))) (else (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-2 (cdr arg-1))) ((e-2 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 5) e-27)) e-28))))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (PreludeC-45Num-u--abs_Abs_Int arg-3) (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 arg-2 (bs+ (bs* arg-3 33 63) (let ((e-1 (car arg-2))) (e-1 e-3)) 63) e-4))))))
(define LibrariesC-45DataC-45StringC-45Iterator-n--2525-1357-u--loop (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((sc0 (LibrariesC-45DataC-45StringC-45Iterator-uncons arg-1 arg-5))) (if (null? sc0) arg-4 (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (LibrariesC-45DataC-45StringC-45Iterator-n--2525-1357-u--loop arg-1 arg-2 arg-3 ((arg-3 arg-4) e-2) e-3)))))))
(define LibrariesC-45DataC-45StringC-45Iterator-withString (lambda (arg-1 arg-2) (arg-2 (LibrariesC-45DataC-45StringC-45Iterator-fromString arg-1))))
(define LibrariesC-45DataC-45StringC-45Iterator-foldl (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45StringC-45Iterator-withString arg-3 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Iterator-n--2525-1357-u--loop arg-3 arg-2 arg-1 arg-2 eta-0)))))
(define CoreC-45CompileExpr-case--find-2793 (lambda (arg-3 arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-5 0) (if (null? arg-7) (CoreC-45CompileExpr-findDrop arg-6 arg-4 arg-3) (let ((e-3 (unbox arg-7))) (cond ((equal? arg-4 0) (vector 0 0 arg-6))(else (let ((e-4 (- arg-4 1))) (CoreC-45CompileExpr-u--weaken_Weaken_CExp (CoreC-45CompileExpr-find arg-6 e-3 e-4 arg-3))))))))(else (let ((e-3 (unbox arg-7))) (cond ((equal? arg-4 0) (vector 0 0 arg-6))(else (let ((e-4 (- arg-4 1))) (CoreC-45CompileExpr-u--weaken_Weaken_CExp (CoreC-45CompileExpr-find arg-6 e-3 e-4 arg-3))))))))))
(define CoreC-45CompileExpr-n--5458-1078-u--showFlag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-5 0) "")(else (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_ConInfo arg-5) " ")))))
(define CoreC-45CompileExpr-n--5148-862-u--showFlag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-5 0) "")(else (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_ConInfo arg-5) " ")))))
(define CoreC-45CompileExpr-u--weaken_Weaken_CExp (lambda (ext-0) (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp (CoreC-45TTC-45SizeOf-suc (CoreC-45TTC-45SizeOf-zero)) ext-0)))
(define CoreC-45CompileExpr-u--weaken_Weaken_CConAlt (lambda (ext-0) (CoreC-45CompileExpr-u--weakenNs_Weaken_CConAlt (CoreC-45TTC-45SizeOf-suc (CoreC-45TTC-45SizeOf-zero)) ext-0)))
(define CoreC-45CompileExpr-u--weakenNs_Weaken_CExp (lambda (arg-2 arg-3) (CoreC-45CompileExpr-insertNames (CoreC-45TTC-45SizeOf-zero) arg-2 arg-3)))
(define CoreC-45CompileExpr-u--weakenNs_Weaken_CConAlt (lambda (arg-2 arg-3) (CoreC-45CompileExpr-insertNamesConAlt (CoreC-45TTC-45SizeOf-zero) arg-2 arg-3)))
(define CoreC-45CompileExpr-u--show_Show_NamedDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-0) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45CompileExpr-u--show_Show_NamedCExp e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Constructor tag " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-246) e-2) (PreludeC-45TypesC-45String-C-43C-43 " arity " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-3) (PreludeC-45Types-maybe (lambda () "") (lambda () (csegen-836)) e-4))))))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Foreign call " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-5) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-837) e-6) (PreludeC-45TypesC-45String-C-43C-43 " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-7)))))))))) (else (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Error: " (CoreC-45CompileExpr-u--show_Show_NamedCExp e-8)))))))
(define CoreC-45CompileExpr-u--show_Show_NamedConstAlt (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (PreludeC-45TypesC-45String-C-43C-43 "(%constcase " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant e-0) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-1) ")"))))))))
(define CoreC-45CompileExpr-u--show_Show_NamedConAlt (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "(%concase " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-n--5458-1078-u--showFlag e-4 e-3 e-2 e-1 e-0 e-1) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-0) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-246) e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-4) ")"))))))))))))))))
(define CoreC-45CompileExpr-u--show_Show_NamedCExp (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "!" (CoreC-45Name-u--show_Show_Name e-1)))) ((1) (let ((e-3 (vector-ref arg-0 2))) (CoreC-45Name-u--show_Show_Name e-3))) ((2) (let ((e-5 (vector-ref arg-0 2))) (let ((e-6 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%lam " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-6) ")"))))))) ((3) (let ((e-8 (vector-ref arg-0 2))) (let ((e-9 (vector-ref arg-0 3))) (let ((e-10 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "(%let " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-9) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-10) ")")))))))))) ((4) (let ((e-12 (vector-ref arg-0 2))) (let ((e-13 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-12) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) e-13) ")"))))))) ((5) (let ((e-14 (vector-ref arg-0 1))) (let ((e-15 (vector-ref arg-0 2))) (let ((e-16 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 4))) (let ((e-18 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 "(%con " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-n--5148-862-u--showFlag e-14 e-18 e-17 e-16 e-15 e-16) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-15) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-246) e-17) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) e-18) ")"))))))))))))) ((6) (let ((e-21 (vector-ref arg-0 3))) (let ((e-22 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 e-21) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (DataC-45Vect-u--show_Show_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (csegen-839) e-22) ")"))))))) ((7) (let ((e-24 (vector-ref arg-0 2))) (let ((e-25 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%extern " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-24) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) e-25) ")"))))))) ((8) (let ((e-27 (vector-ref arg-0 2))) (let ((e-28 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%force " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_LazyReason e-27) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-28) ")"))))))) ((9) (let ((e-30 (vector-ref arg-0 2))) (let ((e-31 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%delay " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_LazyReason e-30) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-31) ")"))))))) ((10) (let ((e-33 (vector-ref arg-0 2))) (let ((e-34 (vector-ref arg-0 3))) (let ((e-35 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "(%case " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-33) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_NamedConAlt u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_NamedConAlt u--d u--x)))) e-34) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-839) e-35) ")")))))))))) ((11) (let ((e-37 (vector-ref arg-0 2))) (let ((e-38 (vector-ref arg-0 3))) (let ((e-39 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "(%case " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_NamedCExp e-37) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_NamedConstAlt u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_NamedConstAlt u--d u--x)))) e-38) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-839) e-39) ")")))))))))) ((12) (let ((e-41 (vector-ref arg-0 2))) (CoreC-45TT-u--show_Show_Constant e-41))) ((13) "___") (else (let ((e-44 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "(CRASH " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-44) ")")))))))
(define CoreC-45CompileExpr-u--show_Show_ConInfo (lambda (arg-0) (cond ((equal? arg-0 0) "[datacon]") ((equal? arg-0 1) "[tycon]") ((equal? arg-0 2) "[nil]") ((equal? arg-0 3) "[cons]") ((equal? arg-0 4) "[enum]") ((equal? arg-0 5) "[nothing]") ((equal? arg-0 6) "[just]") ((equal? arg-0 7) "[record]") ((equal? arg-0 8) "[zero]") ((equal? arg-0 9) "[succ]") (else "[unit]"))))
(define CoreC-45CompileExpr-u--show_Show_CFType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "Unit") ((1) "Int") ((2) "Integer") ((3) "Int_8") ((4) "Int_16") ((5) "Int_32") ((6) "Int_64") ((7) "Bits_8") ((8) "Bits_16") ((9) "Bits_32") ((10) "Bits_64") ((11) "String") ((12) "Double") ((13) "Char") ((14) "Ptr") ((15) "GCPtr") ((16) "Buffer") ((17) "ForeignObj") ((18) "%World") ((19) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_CFType e-0) (PreludeC-45TypesC-45String-C-43C-43 " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-1)))))) ((20) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "IORes " (CoreC-45CompileExpr-u--show_Show_CFType e-2)))) ((21) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "struct " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-3) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-576) (csegen-837)) eta-0)) e-4)))))))) (else (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-u--show_Show_CFType eta-0)) e-6))))))))))
(define CoreC-45CompileExpr-u--show_Show_CDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-0) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 e-0 e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Constructor tag " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-246) e-2) (PreludeC-45TypesC-45String-C-43C-43 " arity " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-3) (PreludeC-45Types-maybe (lambda () "") (lambda () (csegen-836)) e-4))))))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Foreign call " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-5) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-837) e-6) (PreludeC-45TypesC-45String-C-43C-43 " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-7)))))))))) (else (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Error: " (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 '() e-8)))))))
(define CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedCExp (CoreC-45CompileExpr-forget arg-0 arg-1))))
(define CoreC-45CompileExpr-u--showPrec_Show_NamedDef (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedDef arg-1)))
(define CoreC-45CompileExpr-u--showPrec_Show_NamedConstAlt (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedConstAlt arg-1)))
(define CoreC-45CompileExpr-u--showPrec_Show_NamedConAlt (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedConAlt arg-1)))
(define CoreC-45CompileExpr-u--showPrec_Show_NamedCExp (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedCExp arg-1)))
(define CoreC-45CompileExpr-u--showPrec_Show_CFType (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_CFType arg-1)))
(define CoreC-45CompileExpr-u--showPrec_Show_CDef (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_CDef arg-1)))
(define CoreC-45CompileExpr-u--C-61C-61_Eq_ConInfo (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0))) ((equal? arg-0 4) (cond ((equal? arg-1 4) 1)(else 0))) ((equal? arg-0 5) (cond ((equal? arg-1 5) 1)(else 0))) ((equal? arg-0 6) (cond ((equal? arg-1 6) 1)(else 0))) ((equal? arg-0 7) (cond ((equal? arg-1 7) 1)(else 0))) ((equal? arg-0 8) (cond ((equal? arg-1 8) 1)(else 0))) ((equal? arg-0 9) (cond ((equal? arg-1 9) 1)(else 0))) ((equal? arg-0 10) (cond ((equal? arg-1 10) 1)(else 0)))(else 0))))
(define CoreC-45CompileExpr-uniqueName (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45CompileExpr-elem arg-1 arg-2))) (cond ((equal? sc0 1) (CoreC-45CompileExpr-uniqueName (CoreC-45CompileExpr-tryNext arg-1) arg-2)) (else arg-1)))))
(define CoreC-45CompileExpr-tryNext (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (vector 2 (CoreC-45Name-displayUserName e-0) 0))) ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (vector 2 e-1 (bs+ 1 e-2 63)))))(else (vector 2 (CoreC-45Name-nameRoot arg-0) 0)))))
(define CoreC-45CompileExpr-substs (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45CompileExpr-substEnv (CoreC-45TTC-45SizeOf-zero) arg-2 arg-3)))
(define CoreC-45CompileExpr-substEnv (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (CoreC-45CompileExpr-find e-3 arg-3 e-2 arg-4)))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (let ((u--scC-39 (CoreC-45CompileExpr-substEnv (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-11))) (vector 2 e-9 e-10 u--scC-39)))))) ((3) (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((e-15 (vector-ref arg-5 3))) (let ((e-16 (vector-ref arg-5 4))) (let ((e-17 (vector-ref arg-5 5))) (let ((u--scC-39 (CoreC-45CompileExpr-substEnv (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-17))) (vector 3 e-13 e-14 e-15 (CoreC-45CompileExpr-substEnv arg-3 arg-4 e-16) u--scC-39)))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (vector 4 e-19 (CoreC-45CompileExpr-substEnv arg-3 arg-4 e-20) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((e-27 (vector-ref arg-5 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (let ((e-31 (vector-ref arg-5 3))) (let ((e-32 (vector-ref arg-5 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (vector 7 e-34 e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-substEnv arg-3 arg-4 e-40)))))) ((9) (let ((e-42 (vector-ref arg-5 1))) (let ((e-43 (vector-ref arg-5 2))) (let ((e-44 (vector-ref arg-5 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-substEnv arg-3 arg-4 e-44)))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (vector 10 e-46 (CoreC-45CompileExpr-substEnv arg-3 arg-4 e-47) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-substConAlt arg-3 arg-4 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-5 1))) (let ((e-52 (vector-ref arg-5 2))) (let ((e-53 (vector-ref arg-5 3))) (let ((e-54 (vector-ref arg-5 4))) (vector 11 e-51 (CoreC-45CompileExpr-substEnv arg-3 arg-4 e-52) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-substConstAlt arg-3 arg-4 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-5 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-5 1))) (let ((e-62 (vector-ref arg-5 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-substConstAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cons e-1 (CoreC-45CompileExpr-substEnv arg-3 arg-4 e-2))))))
(define CoreC-45CompileExpr-substConAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-substEnv (CoreC-45TTC-45SizeOf-C-43 (CoreC-45TTC-45SizeOf-mkSizeOf e-4) arg-3) arg-4 e-5)))))))))
(define CoreC-45CompileExpr-shrinkConstAlt (lambda (arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cons e-1 (CoreC-45CompileExpr-shrinkCExp arg-2 e-2))))))
(define CoreC-45CompileExpr-shrinkConAlt (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-shrinkCExp (CoreC-45TT-subExtend e-4 arg-2) e-5)))))))))
(define CoreC-45CompileExpr-shrinkCExp (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((sc1 (CoreC-45TT-subElem e-2 arg-2))) (if (null? sc1) (vector 13 e-3) (let ((e-4 (unbox sc1))) (vector 0 e-4 e-3))))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (let ((u--scC-39 (CoreC-45CompileExpr-shrinkCExp (vector 2 arg-2) e-11))) (vector 2 e-9 e-10 u--scC-39)))))) ((3) (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (let ((e-17 (vector-ref arg-3 5))) (let ((u--scC-39 (CoreC-45CompileExpr-shrinkCExp (vector 2 arg-2) e-17))) (vector 3 e-13 e-14 e-15 (CoreC-45CompileExpr-shrinkCExp arg-2 e-16) u--scC-39)))))))) ((4) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (vector 4 e-19 (CoreC-45CompileExpr-shrinkCExp arg-2 e-20) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (let ((e-32 (vector-ref arg-3 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (vector 7 e-34 e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-3 1))) (let ((e-39 (vector-ref arg-3 2))) (let ((e-40 (vector-ref arg-3 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-shrinkCExp arg-2 e-40)))))) ((9) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-shrinkCExp arg-2 e-44)))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (let ((e-49 (vector-ref arg-3 4))) (vector 10 e-46 (CoreC-45CompileExpr-shrinkCExp arg-2 e-47) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-shrinkConAlt arg-2 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-3 1))) (let ((e-52 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 3))) (let ((e-54 (vector-ref arg-3 4))) (vector 11 e-51 (CoreC-45CompileExpr-shrinkCExp arg-2 e-52) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-shrinkConstAlt arg-2 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-3 1))) (let ((e-57 (vector-ref arg-3 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-3 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-3 1))) (let ((e-62 (vector-ref arg-3 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-resolveRef (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-6 0) ((0) '()) (else (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-8 e-2))) (cond ((equal? sc1 1) (box (vector 0 (CoreC-45TT-weakenNVar (CoreC-45TTC-45SizeOf-C-43 arg-4 arg-5) 0) arg-7))) (else (CoreC-45CompileExpr-resolveRef arg-4 (CoreC-45TTC-45SizeOf-sucR arg-5) e-3 arg-7 arg-8))))))))))
(define CoreC-45CompileExpr-refsToLocals (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) arg-3)(else (CoreC-45CompileExpr-mkLocals (CoreC-45TTC-45SizeOf-zero) arg-2 arg-3)))))
(define CoreC-45CompileExpr-mkLocalsConstAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cons e-1 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-2))))))
(define CoreC-45CompileExpr-mkLocalsConAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((u--scC-39 e-5)) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-mkLocals (CoreC-45TTC-45SizeOf-C-43 (CoreC-45TTC-45SizeOf-mkSizeOf e-4) arg-3) arg-4 u--scC-39))))))))))
(define CoreC-45CompileExpr-mkLocals (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (vector 0 (CoreC-45TT-addVars arg-3 arg-4 e-2) e-3)))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (PreludeC-45Types-maybe (lambda () (vector 1 e-6 e-7)) (lambda () (lambda (eta-0) eta-0)) (CoreC-45CompileExpr-resolveRef arg-3 (CoreC-45TTC-45SizeOf-zero) arg-4 e-6 e-7))))) ((2) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (let ((u--scC-39 (CoreC-45CompileExpr-mkLocals (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-11))) (vector 2 e-9 e-10 u--scC-39)))))) ((3) (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((e-15 (vector-ref arg-5 3))) (let ((e-16 (vector-ref arg-5 4))) (let ((e-17 (vector-ref arg-5 5))) (let ((u--scC-39 (CoreC-45CompileExpr-mkLocals (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-17))) (vector 3 e-13 e-14 e-15 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-16) u--scC-39)))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (vector 4 e-19 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-20) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((e-27 (vector-ref arg-5 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (let ((e-31 (vector-ref arg-5 3))) (let ((e-32 (vector-ref arg-5 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (vector 7 e-34 e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-40)))))) ((9) (let ((e-42 (vector-ref arg-5 1))) (let ((e-43 (vector-ref arg-5 2))) (let ((e-44 (vector-ref arg-5 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-44)))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (vector 10 e-46 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-47) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-mkLocalsConAlt arg-3 arg-4 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-5 1))) (let ((e-52 (vector-ref arg-5 2))) (let ((e-53 (vector-ref arg-5 3))) (let ((e-54 (vector-ref arg-5 4))) (vector 11 e-51 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-52) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-mkLocalsConstAlt arg-3 arg-4 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-5 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-5 1))) (let ((e-62 (vector-ref arg-5 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-insertNamesConstAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cons e-1 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-2))))))
(define CoreC-45CompileExpr-insertNamesConAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((u--scC-39 e-5)) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-insertNames (CoreC-45TTC-45SizeOf-C-43 (CoreC-45TTC-45SizeOf-mkSizeOf e-4) arg-3) arg-4 u--scC-39))))))))))
(define CoreC-45CompileExpr-insertNames (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (vector 0 (CoreC-45TT-insertNVarNames arg-3 arg-4 e-2) e-3)))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (let ((u--scC-39 (CoreC-45CompileExpr-insertNames (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-11))) (vector 2 e-9 e-10 u--scC-39)))))) ((3) (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((e-15 (vector-ref arg-5 3))) (let ((e-16 (vector-ref arg-5 4))) (let ((e-17 (vector-ref arg-5 5))) (let ((u--scC-39 (CoreC-45CompileExpr-insertNames (CoreC-45TTC-45SizeOf-suc arg-3) arg-4 e-17))) (vector 3 e-13 e-14 e-15 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-16) u--scC-39)))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (vector 4 e-19 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-20) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((e-27 (vector-ref arg-5 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (let ((e-31 (vector-ref arg-5 3))) (let ((e-32 (vector-ref arg-5 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (vector 7 e-34 e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-40)))))) ((9) (let ((e-42 (vector-ref arg-5 1))) (let ((e-43 (vector-ref arg-5 2))) (let ((e-44 (vector-ref arg-5 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-44)))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (vector 10 e-46 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-47) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-insertNamesConAlt arg-3 arg-4 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-5 1))) (let ((e-52 (vector-ref arg-5 2))) (let ((e-53 (vector-ref arg-5 3))) (let ((e-54 (vector-ref arg-5 4))) (vector 11 e-51 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-52) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-insertNamesConstAlt arg-3 arg-4 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-5 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-5 1))) (let ((e-62 (vector-ref arg-5 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-getLocName (lambda (arg-2 arg-3) (cond ((equal? arg-2 0) (let ((e-3 (car arg-3))) e-3))(else (let ((e-0 (- arg-2 1))) (let ((e-8 (cdr arg-3))) (CoreC-45CompileExpr-getLocName e-0 e-8)))))))
(define CoreC-45CompileExpr-getFC (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 2))) e-3)) ((1) (let ((e-6 (vector-ref arg-1 1))) e-6)) ((2) (let ((e-9 (vector-ref arg-1 1))) e-9)) ((3) (let ((e-13 (vector-ref arg-1 1))) e-13)) ((4) (let ((e-19 (vector-ref arg-1 1))) e-19)) ((5) (let ((e-23 (vector-ref arg-1 1))) e-23)) ((6) (let ((e-30 (vector-ref arg-1 2))) e-30)) ((7) (let ((e-34 (vector-ref arg-1 1))) e-34)) ((8) (let ((e-38 (vector-ref arg-1 1))) e-38)) ((9) (let ((e-42 (vector-ref arg-1 1))) e-42)) ((10) (let ((e-46 (vector-ref arg-1 1))) e-46)) ((11) (let ((e-51 (vector-ref arg-1 1))) e-51)) ((12) (let ((e-56 (vector-ref arg-1 1))) e-56)) ((13) (let ((e-59 (vector-ref arg-1 1))) e-59)) (else (let ((e-61 (vector-ref arg-1 1))) e-61)))))
(define CoreC-45CompileExpr-forgetExp (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector 0 e-3 (CoreC-45CompileExpr-getLocName e-2 arg-1))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((u--locsC-39 (CoreC-45CompileExpr-addLocs (cons e-10 '()) arg-1))) (vector 2 e-9 (CoreC-45CompileExpr-getLocName 0 u--locsC-39) (CoreC-45CompileExpr-forgetExp u--locsC-39 e-11))))))) ((3) (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 4))) (let ((e-17 (vector-ref arg-2 5))) (let ((u--locsC-39 (CoreC-45CompileExpr-addLocs (cons e-14 '()) arg-1))) (vector 3 e-13 (CoreC-45CompileExpr-getLocName 0 u--locsC-39) (CoreC-45CompileExpr-forgetExp arg-1 e-16) (CoreC-45CompileExpr-forgetExp u--locsC-39 e-17)))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (vector 4 e-19 (CoreC-45CompileExpr-forgetExp arg-1 e-20) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-2 1))) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (let ((e-32 (vector-ref arg-2 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (vector 7 e-34 e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-forgetExp arg-1 e-40)))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-forgetExp arg-1 e-44)))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (vector 10 e-46 (CoreC-45CompileExpr-forgetExp arg-1 e-47) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-forgetConAlt arg-1 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-2 1))) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (vector 11 e-51 (CoreC-45CompileExpr-forgetExp arg-1 e-52) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-forgetConstAlt arg-1 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-2 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-2 1))) (let ((e-62 (vector-ref arg-2 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-forgetDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((u--ns (CoreC-45CompileExpr-addLocs e-0 '()))) (let ((u--argsC-39 (CoreC-45CompileExpr-conArgs e-0 u--ns))) (vector 0 u--argsC-39 (CoreC-45CompileExpr-forget e-0 e-1))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (vector 1 e-2 e-3 e-4))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (vector 2 e-5 e-6 e-7))))) (else (let ((e-8 (vector-ref arg-0 1))) (vector 3 (CoreC-45CompileExpr-forget '() e-8)))))))
(define CoreC-45CompileExpr-forgetConstAlt (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (cons e-1 (CoreC-45CompileExpr-forgetExp arg-1 e-2))))))
(define CoreC-45CompileExpr-forgetConAlt (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((u--argsC-39 (CoreC-45CompileExpr-addLocs e-4 arg-1))) (vector e-1 e-2 e-3 (CoreC-45CompileExpr-conArgs e-4 u--argsC-39) (CoreC-45CompileExpr-forgetExp u--argsC-39 e-5))))))))))
(define CoreC-45CompileExpr-forget (lambda (arg-0 arg-1) (CoreC-45CompileExpr-forgetExp (CoreC-45CompileExpr-addLocs arg-0 '()) arg-1)))
(define CoreC-45CompileExpr-findDrop (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (vector 0 arg-3 arg-2) (cond ((equal? arg-3 0) (let ((e-8 (car arg-4))) e-8))(else (let ((e-4 (- arg-3 1))) (let ((e-14 (cdr arg-4))) (CoreC-45CompileExpr-findDrop arg-2 e-4 e-14))))))))
(define CoreC-45CompileExpr-find (lambda (arg-3 arg-4 arg-5 arg-6) (CoreC-45CompileExpr-case--find-2793 arg-6 arg-5 arg-4 arg-3 (CoreC-45TT-sizedView arg-4))))
(define CoreC-45CompileExpr-embed (lambda (arg-2) (Builtin-believe_me arg-2)))
(define CoreC-45CompileExpr-elem (lambda (arg-1 arg-2) (if (null? arg-2) 0 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-1 e-2))) (cond ((equal? sc1 1) 1) (else (CoreC-45CompileExpr-elem arg-1 e-3)))))))))
(define CoreC-45CompileExpr-conArgs (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (let ((e-6 (car arg-2))) (let ((e-7 (cdr arg-2))) (cons e-6 (CoreC-45CompileExpr-conArgs e-3 e-7))))))))
(define CoreC-45CompileExpr-addLocs (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((u--rec (CoreC-45CompileExpr-addLocs e-3 arg-2))) (cons (CoreC-45CompileExpr-uniqueName e-2 u--rec) u--rec)))))))
(define CoreC-45CaseC-45CaseTree-n--6557-4074-u--getSet (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-5 (vector-ref arg-6 4))) (CoreC-45CaseC-45CaseTree-n--6557-4073-u--getAltSets arg-1 arg-2 arg-3 arg-5 e-5))) ((1) (let ((e-8 (vector-ref arg-6 2))) (((arg-3 'erased) arg-5) e-8))) ((2) arg-5) (else arg-5))))
(define CoreC-45CaseC-45CaseTree-n--6557-4073-u--getAltSets (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (CoreC-45CaseC-45CaseTree-n--6557-4073-u--getAltSets arg-1 arg-2 arg-3 (CoreC-45CaseC-45CaseTree-n--6557-4072-u--getAltSet arg-1 arg-2 arg-3 arg-5 e-2) e-3))))))
(define CoreC-45CaseC-45CaseTree-n--6557-4072-u--getAltSet (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45CaseC-45CaseTree-n--6557-4074-u--getSet arg-1 arg-2 arg-3 arg-5 e-4))) ((1) (let ((e-8 (vector-ref arg-6 3))) (CoreC-45CaseC-45CaseTree-n--6557-4074-u--getSet arg-1 arg-2 arg-3 arg-5 e-8))) ((2) (let ((e-11 (vector-ref arg-6 2))) (CoreC-45CaseC-45CaseTree-n--6557-4074-u--getSet arg-1 arg-2 arg-3 arg-5 e-11))) (else (let ((e-13 (vector-ref arg-6 1))) (CoreC-45CaseC-45CaseTree-n--6557-4074-u--getSet arg-1 arg-2 arg-3 arg-5 e-13))))))
(define CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree (lambda (arg-2 arg-3) (CoreC-45CaseC-45CaseTree-insertCaseNames (CoreC-45TTC-45SizeOf-zero) arg-2 arg-3)))
(define CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (vector 0 e-1 e-2 (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseAltC-32C-36varsC-41 arg-1 eta-0)) e-5))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (vector 1 e-7 (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-8)))))(else arg-2))))
(define CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (vector 0 e-1 e-2 e-3 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (vector 1 e-6 e-7 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-8)))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (vector 2 e-10 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11))))) (else (let ((e-13 (vector-ref arg-2 1))) (vector 3 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13)))))))
(define CoreC-45CaseC-45CaseTree-u--show_Show_Pat (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-1) (PreludeC-45TypesC-45String-C-43C-43 "@(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_Pat e-2) ")")))))) ((1) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (let ((e-7 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-4) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-5) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-847) e-7))))))))) ((2) (let ((e-9 (vector-ref arg-0 2))) (let ((e-11 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "<TyCon>" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-9) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-847) e-11))))))) ((3) (let ((e-13 (vector-ref arg-0 2))) (CoreC-45TT-u--show_Show_Constant e-13))) ((4) (let ((e-16 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_Pat e-16) (PreludeC-45TypesC-45String-C-43C-43 " -> " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_Pat e-17) ")"))))))) ((5) (let ((e-21 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "(Delay " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_Pat e-21) ")")))) ((6) (let ((e-23 (vector-ref arg-0 2))) (CoreC-45Name-u--show_Show_Name e-23))) (else (let ((e-25 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 ".(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-25) ")")))))))
(define CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-0 ext-0) (CoreC-45CaseC-45CaseTree-showCT arg-0 "" ext-0)))
(define CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseAltC-32C-36varsC-41 (lambda (arg-0 ext-0) (CoreC-45CaseC-45CaseTree-showCA arg-0 "" ext-0)))
(define CoreC-45CaseC-45CaseTree-u--showPrec_Show_Pat (lambda (arg-0 arg-1) (CoreC-45CaseC-45CaseTree-u--show_Show_Pat arg-1)))
(define CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (vector 0 e-1 e-2 (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseAltC-32C-36varsC-41 arg-1 eta-0)) e-5))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (vector 1 e-7 (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-8)))))(else arg-2))))
(define CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (vector 0 e-1 e-2 e-3 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (vector 1 e-6 e-7 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-8)))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (vector 2 e-10 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11))))) (else (let ((e-13 (vector-ref arg-2 1))) (vector 3 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13)))))))
(define CoreC-45CaseC-45CaseTree-u--pretty_Pretty_Pat (lambda (arg-1) (CoreC-45CaseC-45CaseTree-u--prettyPrec_Pretty_Pat (vector 0 ) arg-1)))
(define CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "case") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ":") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45TT-u--pretty_Pretty_C-40TermC-32C-36varsC-41 arg-1 e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "of") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseAltC-32C-36varsC-41 arg-1 eta-0)) e-5))))))))))))) ((1) (let ((e-8 (vector-ref arg-2 2))) (CoreC-45TT-u--pretty_Pretty_C-40TermC-32C-36varsC-41 arg-1 e-8))) ((2) (let ((e-10 (vector-ref arg-2 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Error:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-10)))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Impossible")))))
(define CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) (cons e-1 e-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "=>") (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-1) e-4))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-1) e-4))))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Delay") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "=>") (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 (cons e-6 (cons e-7 arg-1)) e-8))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 (cons e-6 (cons e-7 arg-1)) e-8)))))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45TT-u--pretty_Pretty_Constant e-10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "=>") (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11)))))))))) (else (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "_ =>") (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13)))))))))))
(define CoreC-45CaseC-45CaseTree-u--prettyPrec_Pretty_Pat (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (let ((e-2 (vector-ref arg-2 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "@") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_Pat e-2))))))) ((1) (let ((e-4 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-1 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (CoreC-45Name-u--pretty_Pretty_Name e-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--prettyPrec_Pretty_Pat (vector 6 ) eta-0)) e-7))))))) ((2) (let ((e-9 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-1 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (CoreC-45Name-u--pretty_Pretty_Name e-9) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--prettyPrec_Pretty_Pat (vector 6 ) eta-0)) e-11))))))) ((3) (let ((e-13 (vector-ref arg-2 2))) (CoreC-45TT-u--pretty_Pretty_Constant e-13))) ((4) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-1 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_Pat e-16) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "->") (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_Pat e-17))))))) ((5) (let ((e-21 (vector-ref arg-2 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Delay") (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_Pat e-21))))) ((6) (let ((e-23 (vector-ref arg-2 2))) (CoreC-45Name-u--pretty_Pretty_Name e-23))) (else (let ((e-25 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String ".") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (CoreC-45TT-u--pretty_Pretty_C-40TermC-32C-36varsC-41 '() e-25))))))))
(define CoreC-45CaseC-45CaseTree-showCT (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (PreludeC-45TypesC-45String-C-43C-43 "case " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-1) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-2) (PreludeC-45TypesC-45String-C-43C-43 "] : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-4) (PreludeC-45TypesC-45String-C-43C-43 " of" (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " { " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 arg-1 " | ")) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-showCA arg-0 (PreludeC-45TypesC-45String-C-43C-43 "  " arg-1) eta-0)) e-5)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 arg-1 " }")))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-7) (PreludeC-45TypesC-45String-C-43C-43 "] " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (PreludeC-45TypesC-45String-C-43C-43 "Error: " (PreludeC-45Show-u--show_Show_String e-10)))) (else "Impossible"))))
(define CoreC-45CaseC-45CaseTree-showCA (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) (cons e-1 e-3))) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45CaseC-45CaseTree-showCT (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-1 e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "Delay " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-7) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45CaseC-45CaseTree-showCT (cons e-6 (cons e-7 arg-0)) arg-1 e-8)))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "Constant " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant e-10) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45CaseC-45CaseTree-showCT arg-0 arg-1 e-11))))))) (else (let ((e-13 (vector-ref arg-2 1))) (PreludeC-45TypesC-45String-C-43C-43 "_ => " (CoreC-45CaseC-45CaseTree-showCT arg-0 arg-1 e-13)))))))
(define CoreC-45CaseC-45CaseTree-mkTerm (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 3))) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 e-2))) ((1) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((e-6 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-1 5))) (CoreC-45TT-apply e-3 (vector 1 e-3 (vector 2 e-5 e-6) e-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 eta-0)) e-7)))))))) ((2) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (CoreC-45TT-apply e-8 (vector 1 e-8 (vector 3 0 e-10) e-9) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 eta-0)) e-11))))))) ((3) (let ((e-12 (vector-ref arg-1 1))) (let ((e-13 (vector-ref arg-1 2))) (vector 9 e-12 e-13)))) ((4) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (let ((e-17 (vector-ref arg-1 4))) (vector 3 e-14 e-15 (vector 2 e-14 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 e-16)) (CoreC-45CaseC-45CaseTree-mkTerm (cons e-15 arg-0) e-17))))))) ((5) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (vector 7 e-18 e-19 (CoreC-45CaseC-45CaseTree-mkTerm arg-0 e-20) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 e-21))))))) ((6) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (let ((sc1 (CoreC-45TT-isVar e-23 arg-0))) (if (null? sc1) (vector 1 e-22 (vector 0 ) e-23) (let ((e-1 (unbox sc1))) (vector 0 e-22 '() e-1))))))) (else (let ((e-25 (vector-ref arg-1 2))) (CoreC-45TT-embed e-25))))))
(define CoreC-45CaseC-45CaseTree-measureAlts (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 4))) (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) (CoreC-45CaseC-45CaseTree-measure e-4)))) ((1) (let ((e-8 (vector-ref arg-1 3))) (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) (CoreC-45CaseC-45CaseTree-measure e-8)))) ((2) (let ((e-11 (vector-ref arg-1 2))) (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) (CoreC-45CaseC-45CaseTree-measure e-11)))) (else (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) (CoreC-45CaseC-45CaseTree-measure e-13)))))))
(define CoreC-45CaseC-45CaseTree-measure (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 4))) (PreludeC-45Interfaces-sum (cons (csegen-51) (csegen-118)) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45CaseC-45CaseTree-measureAlts eta-0)) e-5)))) ((1) 0) ((2) 0) (else 0))))
(define CoreC-45CaseC-45CaseTree-isPConst (lambda (arg-0) (case (vector-ref arg-0 0) ((3) (let ((e-1 (vector-ref arg-0 2))) (box e-1)))(else '()))))
(define CoreC-45CaseC-45CaseTree-isDefault (lambda (arg-1) (case (vector-ref arg-1 0) ((3) 1)(else 0))))
(define CoreC-45CaseC-45CaseTree-insertCaseNames (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (vector 0 e-1 (CoreC-45TT-insertNVarNames arg-3 arg-4 e-2) (CoreC-45TT-insertNames arg-3 arg-4 e-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseTree-insertCaseAltNames arg-3 arg-4 eta-0)) e-5))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (vector 1 e-7 (CoreC-45TT-insertNames arg-3 arg-4 e-8))))) ((2) (let ((e-10 (vector-ref arg-5 1))) (vector 2 e-10))) (else (vector 3 )))))
(define CoreC-45CaseC-45CaseTree-insertCaseAltNames (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (vector 0 e-1 e-2 e-3 (CoreC-45CaseC-45CaseTree-insertCaseNames (CoreC-45TTC-45SizeOf-C-43 (CoreC-45TTC-45SizeOf-mkSizeOf e-3) arg-3) arg-4 e-4))))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (vector 1 e-6 e-7 (CoreC-45CaseC-45CaseTree-insertCaseNames (CoreC-45TTC-45SizeOf-suc (CoreC-45TTC-45SizeOf-suc arg-3)) arg-4 e-8)))))) ((2) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (vector 2 e-10 (CoreC-45CaseC-45CaseTree-insertCaseNames arg-3 arg-4 e-11))))) (else (let ((e-13 (vector-ref arg-5 1))) (vector 3 (CoreC-45CaseC-45CaseTree-insertCaseNames arg-3 arg-4 e-13)))))))
(define CoreC-45CaseC-45CaseTree-getNames (lambda (arg-1 arg-2 arg-3) (CoreC-45CaseC-45CaseTree-n--6557-4074-u--getSet arg-3 arg-2 arg-1 arg-2 arg-3)))
(define CoreC-45CaseC-45CaseTree-getMetas (lambda (ext-0) (CoreC-45CaseC-45CaseTree-getNames (lambda (vs-4163) (lambda (eta-0) (lambda (eta-1) (CoreC-45TT-addMetas eta-0 eta-1)))) (LibrariesC-45DataC-45NameMap-empty) ext-0)))
(define CoreC-45CaseC-45CaseTree-addRefs (lambda (arg-1 arg-2 ext-0) (CoreC-45CaseC-45CaseTree-getNames (lambda (vs-4154) (lambda (eta-0) (lambda (eta-1) (CoreC-45TT-addRefs 0 arg-1 eta-0 eta-1)))) arg-2 ext-0)))
(define CoreC-45Context-case--checkTimer-19528 (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) (vector 1 0) (let ((e-1 (unbox arg-2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-24 (CoreC-45Context-getTime clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((sc3 (PreludeC-45EqOrd-u--C-62_Ord_Integer e-7 e-5))) (cond ((equal? sc3 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 e-6) clam-0)) (else (vector 1 0)))))))))))))))
(define CoreC-45Context-case--addTransform-14341 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "LHS of a transformation must be a function application") ext-0) (let ((e-1 (unbox arg-4))) (let ((act-24 (CoreC-45Context-toResolvedNames arg-2 (csegen-46) e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toResolvedNames arg-2 (csegen-852) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-2 (csegen-46) e-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-2 (csegen-852) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((sc5 (LibrariesC-45DataC-45NameMap-lookup e-5 (let ((e-13 (vector-ref arg-3 13))) e-13)))) (if (null? sc5) (let ((act-28 (set-box! arg-2 (let ((e-0 (vector-ref arg-3 0))) (let ((e-35 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-34 (vector-ref arg-3 5))) (let ((e-33 (vector-ref arg-3 6))) (let ((e-32 (vector-ref arg-3 7))) (let ((e-31 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (let ((e-10 (vector-ref arg-3 10))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (let ((e-17 (vector-ref arg-3 17))) (let ((e-18 (vector-ref arg-3 18))) (let ((e-19 (vector-ref arg-3 19))) (let ((e-20 (vector-ref arg-3 20))) (let ((e-21 (vector-ref arg-3 21))) (let ((e-22 (vector-ref arg-3 22))) (let ((e-23 (vector-ref arg-3 23))) (let ((e-24 (vector-ref arg-3 24))) (let ((e-25 (vector-ref arg-3 25))) (let ((e-26 (vector-ref arg-3 26))) (let ((e-27 (vector-ref arg-3 27))) (let ((e-28 (vector-ref arg-3 28))) (let ((e-29 (vector-ref arg-3 29))) (let ((e-30 (vector-ref arg-3 30))) (vector e-0 e-35 e-2 e-3 e-4 e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert e-5 (cons e-6 '()) e-13) (cons (cons e-7 e-8) e-14) e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-28)) (let ((e-2 (unbox sc5))) (let ((act-28 (set-box! arg-2 (let ((e-0 (vector-ref arg-3 0))) (let ((e-36 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-34 (vector-ref arg-3 5))) (let ((e-33 (vector-ref arg-3 6))) (let ((e-32 (vector-ref arg-3 7))) (let ((e-31 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (let ((e-10 (vector-ref arg-3 10))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (let ((e-17 (vector-ref arg-3 17))) (let ((e-18 (vector-ref arg-3 18))) (let ((e-19 (vector-ref arg-3 19))) (let ((e-20 (vector-ref arg-3 20))) (let ((e-21 (vector-ref arg-3 21))) (let ((e-22 (vector-ref arg-3 22))) (let ((e-23 (vector-ref arg-3 23))) (let ((e-24 (vector-ref arg-3 24))) (let ((e-25 (vector-ref arg-3 25))) (let ((e-26 (vector-ref arg-3 26))) (let ((e-27 (vector-ref arg-3 27))) (let ((e-28 (vector-ref arg-3 28))) (let ((e-29 (vector-ref arg-3 29))) (let ((e-30 (vector-ref arg-3 30))) (vector e-0 e-36 e-35 e-3 e-4 e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert e-5 (cons e-6 e-2) e-13) (cons (cons e-7 e-8) e-14) e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-28)))))))))))))))))))))))))
(define CoreC-45Context-case--caseC-32blockC-32inC-32setExternal-13596 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((6) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (let ((e-2 (vector-ref arg-7 3))) (let ((e-3 (vector-ref arg-7 4))) (let ((e-4 (vector-ref arg-7 5))) (let ((e-5 (vector-ref arg-7 6))) (let ((e-6 (vector-ref arg-7 7))) (let ((e-7 (vector-ref arg-7 8))) (let ((u--flC-39 (let ((e-9 (car e-4))) (cons e-9 arg-0)))) (lambda (eta-0) (CoreC-45Context-updateDef arg-3 arg-1 (lambda (eta-1) (box (vector 6 e-0 e-1 e-2 e-3 u--flC-39 e-5 e-6 e-7))) eta-0))))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-5 1))) e-1)) " is not a type constructor [setDetermining]")) eta-0))))))
(define CoreC-45Context-case--caseC-32blockC-32inC-32setUniqueSearch-13460 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((6) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (let ((e-2 (vector-ref arg-7 3))) (let ((e-3 (vector-ref arg-7 4))) (let ((e-4 (vector-ref arg-7 5))) (let ((e-5 (vector-ref arg-7 6))) (let ((e-6 (vector-ref arg-7 7))) (let ((e-7 (vector-ref arg-7 8))) (let ((u--flC-39 (let ((e-8 (cdr e-4))) (cons arg-0 e-8)))) (lambda (eta-0) (CoreC-45Context-updateDef arg-3 arg-1 (lambda (eta-1) (box (vector 6 e-0 e-1 e-2 e-3 u--flC-39 e-5 e-6 e-7))) eta-0))))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-5 1))) e-1)) " is not a type constructor [setDetermining]")) eta-0))))))
(define CoreC-45Context-case--aliasName-9559 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 arg-0)) (let ((e-1 (unbox arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-1 (let ((e-0 (vector-ref arg-2 0))) (let ((e-39 (vector-ref e-0 3))) e-39))))) (if (null? sc1) (lambda (eta-0) (vector 1 arg-0)) (let ((e-2 (unbox sc1))) (CoreC-45Context-n--15124-9499-u--findAlias arg-0 arg-1 e-2))))))))
(define CoreC-45Context-case--getSimilarNames-9009 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox arg-2))) (let ((sc1 (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45String-length e-2) (+ 1 0)))) (cond ((equal? sc1 1) (lambda (eta-0) (vector 1 (box (cons e-2 '()))))) (else (let ((u--threshold (PreludeC-45Types-u--max_Ord_Nat (+ 1 0) (DataC-45Nat-divNat (PreludeC-45TypesC-45String-length e-2) (+ 1 (+ 1 (+ 1 0))))))) (let ((u--test (lambda (u--nm) (lambda (clam-0) (let ((sc2 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (CoreC-45Name-u--show_Show_UserName eta-0)) (CoreC-45Name-userNameRoot u--nm)))) (if (null? sc2) '() (let ((e-1 (unbox sc2))) (let ((act-24 ((LibrariesC-45TextC-45DistanceC-45Levenshtein-compute (csegen-3) e-2 e-1) clam-0))) (PreludeC-45Interfaces-C-60C-36 (csegen-73) act-24 (PreludeC-45Interfaces-guard (csegen-538) (PreludeC-45Types-u--C-60C-61_Ord_Nat act-24 u--threshold))))))))))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((LibrariesC-45DataC-45NameMap-mapMaybeM (csegen-87) u--test (let ((e-0 (vector-ref e-5 0))) (let ((e-41 (vector-ref e-0 2))) e-41))) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box (cons e-2 (LibrariesC-45DataC-45NameMap-toList e-6))))))))))))))))))))))
(define CoreC-45Context-case--commitCtxt-3887 (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (lambda (eta-0) (vector 1 arg-0)))(else (let ((e-0 (- arg-1 1))) (cond ((equal? e-0 0) (let ((u--a (let ((e-4 (vector-ref arg-0 4))) e-4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox u--a))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45Context-n--9158-3857-u--commitStaged arg-0 (LibrariesC-45DataC-45IntMap-toList (let ((e-6 (vector-ref arg-0 6))) e-6)) e-5) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (let ((e-13 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (let ((e-10 (vector-ref arg-0 10))) (vector e-13 e-1 e-2 e-3 e-4 0 (LibrariesC-45DataC-45IntMap-empty) e-7 e-8 e-9 e-10)))))))))))))))))))))(else (lambda (eta-0) (vector 1 (let ((e-11 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (let ((e-10 (vector-ref arg-0 10))) (vector e-11 e-1 e-2 e-3 e-4 e-0 e-6 e-7 e-8 e-9 e-10))))))))))))))))))))
(define CoreC-45Context-case--lookupCtxtName-3730 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExactI arg-1 arg-0) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (vector 1 (cons (cons arg-1 (cons e-7 e-6)) '()))))))))))) (let ((e-2 (unbox arg-2))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 (let ((e-3 (vector-ref arg-0 3))) e-3)))) (if (null? sc1) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox sc1))) (CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 '() e-1))))))))
(define CoreC-45Context-case--lookupCtxtExact-3156 (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (let ((act-24 (let ((act-24 (unbox (let ((e-4 (vector-ref arg-1 4))) e-4)))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((LibrariesC-45DataC-45IOArray-readArray (csegen-3) e-5 arg-0) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-26 (CoreC-45Context-decode arg-1 arg-0 1 e-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (csegen-855) (CoreC-45Context-returnDef (let ((e-9 (vector-ref arg-1 9))) e-9) arg-0 e-7))))))))))))))))) (let ((e-1 (unbox arg-2))) (let ((act-24 (CoreC-45Context-decode arg-1 arg-0 1 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (csegen-855) (CoreC-45Context-returnDef (let ((e-9 (vector-ref arg-1 9))) e-9) arg-0 e-5)))))))))))
(define CoreC-45Context-case--returnDef-2989 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((sc1 (let ((e-6 (vector-ref e-0 1))) e-6))) (cond ((equal? sc1 1) (box (cons arg-1 arg-0))) (else '())))))(else '()))))
(define CoreC-45Context-case--addAlias-2494 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-0 (let ((e-2 (unbox arg-4))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-0))) (if (null? sc1) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (vector 1 arg-3 arg-2 arg-1) '()) arg-0) (let ((e-3 (unbox sc1))) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (vector 1 arg-3 arg-2 arg-1) e-3) arg-0))))))))
(define CoreC-45Context-case--addPossible-2433 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) arg-0 (let ((e-2 (unbox arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-0))) (if (null? sc1) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (vector 0 arg-2 arg-1) '()) arg-0) (let ((e-3 (unbox sc1))) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (vector 0 arg-2 arg-1) e-3) arg-0))))))))
(define CoreC-45Context-n--21909-15636-u--visible (lambda (arg-0 arg-1 arg-2) (CoreC-45NameC-45Namespace-isParentOf arg-2 arg-0)))
(define CoreC-45Context-n--11224-5803-u--trimNSpat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-5 e-10) (CoreC-45TT-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-5 e-11))))))))))))
(define CoreC-45Context-n--14755-9173-u--showNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--root (CoreC-45Name-nameRoot arg-5))) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-4 u--root))) (cond ((equal? sc0 1) (let ((u--full (CoreC-45Name-u--show_Show_Name arg-5))) (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-4 u--full))) (cond ((equal? sc2 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CoreC-45Name-u--show_Show_Name arg-3) u--full)))))) (cond ((equal? sc1 1) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe u--full))))))(else (PreludeC-45Types-u--pure_Applicative_Maybe u--root)))))))
(define CoreC-45Context-n--11225-5856-u--restoreNSpat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-5 e-10) (CoreC-45TT-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-5 e-11))))))))))))
(define CoreC-45Context-n--10899-5648-u--resolvedNamesPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-5 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-5 e-10) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-5 e-11) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (cons e-2 (cons e-5 (cons e-8 e-9)))))))))))))))))))))))))
(define CoreC-45Context-n--8670-3425-u--resn (lambda (arg-0 arg-1 arg-2) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) e-6))))
(define CoreC-45Context-n--14387-8830-u--resetElab (lambda (arg-0 arg-1) (let ((u--tot (let ((e-2 (vector-ref arg-1 2))) (let ((e-32 (vector-ref e-2 1))) e-32)))) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (vector e-0 e-1 e-2 (let ((sc0 (CoreC-45Options-defaultElab))) (let ((e-16 (vector-ref sc0 0))) (let ((e-15 (vector-ref sc0 1))) (let ((e-13 (vector-ref sc0 3))) (let ((e-12 (vector-ref sc0 4))) (let ((e-11 (vector-ref sc0 5))) (let ((e-10 (vector-ref sc0 6))) (vector e-16 e-15 u--tot e-13 e-12 e-11 e-10)))))))) e-4 e-5 e-6 e-7 e-8 e-9)))))))))))))
(define CoreC-45Context-n--23184-16876-u--resetCtxt (lambda (arg-1 arg-2) (let ((u--dir (let ((e-4 (vector-ref arg-2 4))) (let ((e-40 (vector-ref e-4 0))) (let ((e-50 (vector-ref e-40 0))) e-50))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-24 ((SystemC-45Directory-changeDir (csegen-3) u--dir) eta-1))) (vector 1 act-24))) eta-0)))))
(define CoreC-45Context-n--18379-12430-u--notHidden (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 ext-0) (let ((e-2 (car arg-5))) (let ((act-24 (CoreC-45Context-toFullNames arg-3 (csegen-46) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((sc2 (CoreC-45Context-isHidden e-5 arg-6))) (cond ((equal? sc2 1) 0) (else 1)))))))))))
(define CoreC-45Context-n--25792-19362-u--nano(blodwen-lazy (lambda () 1000000000)))
(define CoreC-45Context-n--8670-3426-u--lookupPossibles (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-reverse arg-2))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((sc2 (LibrariesC-45DataC-45NameMap-lookup e-4 (let ((e-10 (vector-ref arg-0 10))) e-10)))) (if (null? sc2) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact (vector 8 e-5) arg-0) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (if (null? e-6) ((CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 arg-2 e-3) eta-0) (let ((e-1 (unbox e-6))) (let ((sc5 (let ((sc6 (CoreC-45Name-matches arg-1 e-4))) (cond ((equal? sc6 1) (let ((sc7 (PreludeC-45Types-elem (csegen-225) e-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45Context-n--8670-3425-u--resn arg-0 arg-1 eta-1)) arg-2)))) (cond ((equal? sc7 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc5 1) ((CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 (cons (cons e-4 (cons e-5 e-1)) arg-2) e-3) eta-0)) (else ((CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 arg-2 e-3) eta-0))))))))))) (CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 arg-2 e-3)))))) (else (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-8 (vector-ref e-2 3))) (let ((sc2 (LibrariesC-45DataC-45NameMap-lookup e-7 (let ((e-10 (vector-ref arg-0 10))) e-10)))) (if (null? sc2) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact (vector 8 e-8) arg-0) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) ((CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 arg-2 e-3) eta-0) (let ((e-1 (unbox e-5))) (let ((sc5 (let ((sc6 (CoreC-45Name-matches arg-1 e-6))) (cond ((equal? sc6 1) (let ((sc7 (PreludeC-45Types-elem (csegen-225) e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45Context-n--8670-3425-u--resn arg-0 arg-1 eta-1)) arg-2)))) (cond ((equal? sc7 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc5 1) ((CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 (cons (cons e-7 (cons e-8 e-1)) arg-2) e-3) eta-0)) (else ((CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 arg-2 e-3) eta-0))))))))))) (CoreC-45Context-n--8670-3426-u--lookupPossibles arg-0 arg-1 arg-2 e-3)))))))))))))
(define CoreC-45Context-n--15520-9863-u--isHole (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 1) (let ((e-1 (unbox e-5))) (vector 1 (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((0) 1) ((7) 1)(else 0))))))))))))
(define CoreC-45Context-n--18379-12431-u--isDefault (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (Builtin-snd ext-0)))
(define CoreC-45Context-n--11440-6034-u--insertAll (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-2 e-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Context-n--11440-6034-u--insertAll arg-1 arg-2 (LibrariesC-45DataC-45NameMap-insert e-5 e-7 arg-3) e-3) clam-0)))))))))))))
(define CoreC-45Context-n--11439-6002-u--insertAll (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-2 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Context-n--11439-6002-u--insertAll arg-1 arg-2 (LibrariesC-45DataC-45NameMap-insert e-5 e-7 arg-3) e-3) clam-0)))))))))))))
(define CoreC-45Context-n--24946-18553-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) 0 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (CoreC-45Name-splitNS e-2))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 arg-3))) (cond ((equal? sc3 1) (CoreC-45NameC-45Namespace-isApproximationOf e-5 arg-2)) (else 0))))) (cond ((equal? sc2 1) 1) (else (CoreC-45Context-n--24946-18553-u--go arg-0 arg-1 arg-2 arg-3 e-3))))))))))))
(define CoreC-45Context-n--19068-13071-u--getPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((3) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (case (vector-ref e-4 0) ((2) (let ((sc2 (PreludeC-45Types-elem (csegen-802) e-3 arg-6))) (cond ((equal? sc2 1) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-n--19068-13071-u--getPos arg-0 arg-1 arg-2 arg-3 (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) arg-5) (DataC-45List-filter (lambda (arg-4) (CoreC-45Name-u--C-47C-61_Eq_Name arg-4 e-3)) arg-6) e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (cons arg-5 e-6)))))))) (else (CoreC-45Context-n--19068-13071-u--getPos arg-0 arg-1 arg-2 arg-3 (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) arg-5) arg-6 e-5)))))(else (lambda (clam-0) (if (null? arg-6) (vector 1 '()) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "Unknown determining arguments: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) arg-6)))) clam-0)))))))))(else (lambda (clam-1) (if (null? arg-6) (vector 1 '()) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "Unknown determining arguments: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) arg-6)))) clam-1)))))))
(define CoreC-45Context-n--21223-14989-u--getDir (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CoreC-45Options-u--C-61C-61_Eq_CG arg-0 e-2))) (cond ((equal? sc1 1) (box e-3)) (else '())))))))
(define CoreC-45Context-n--10898-5508-u--fullNamesPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-5 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-5 e-10) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-5 e-11) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (cons e-2 (cons e-5 (cons e-8 e-9)))))))))))))))))))))))))
(define CoreC-45Context-n--15124-9499-u--findAlias (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 arg-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 arg-0))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 e-4))) (else (CoreC-45Context-n--15124-9499-u--findAlias arg-0 arg-1 e-3)))))))(else (CoreC-45Context-n--15124-9499-u--findAlias arg-0 arg-1 e-3))))))))
(define CoreC-45Context-n--26034-19595-u--drop (lambda (arg-0 arg-1 arg-2 arg-4 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Options-u--C-61C-61_Eq_CG arg-4 e-6))) (cond ((equal? sc2 1) e-3) (else (cons (cons e-6 e-7) (CoreC-45Context-n--26034-19595-u--drop arg-0 arg-1 arg-2 arg-4 e-3))))))))))))
(define CoreC-45Context-n--18379-12432-u--direct (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (Builtin-snd ext-0)))
(define CoreC-45Context-n--9158-3857-u--commitStaged (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (lambda (eta-0) 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (PreludeC-45Interfaces-C-62C-62 (csegen-87) (LibrariesC-45DataC-45IOArray-writeArray (csegen-3) arg-2 e-6 e-7) (lambda () (CoreC-45Context-n--9158-3857-u--commitStaged arg-0 e-3 arg-2))))))))))
(define CoreC-45Context-n--26034-19594-u--addMod (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? arg-5) (cons (cons arg-3 (cons (cons e-2 '()) e-3)) '()) (let ((e-6 (car arg-5))) (let ((e-7 (cdr arg-5))) (let ((e-10 (car e-6))) (let ((e-11 (cdr e-6))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((sc4 (CoreC-45Options-u--C-61C-61_Eq_CG arg-3 e-10))) (cond ((equal? sc4 1) (cons (cons arg-3 (cons (cons e-2 e-14) (PreludeC-45TypesC-45List-tailRecAppend e-15 e-3))) e-7)) (else (cons (cons e-10 (cons e-14 e-15)) (CoreC-45Context-n--26034-19594-u--addMod arg-0 arg-1 arg-2 arg-3 (cons e-2 e-3) e-7))))))))))))))))
(define CoreC-45Context-u--trimNS_StripNamespace_GlobalDef (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (CoreC-45Context-u--trimNS_StripNamespace_Def arg-0 e-17) e-18 e-19 e-20 e-21)))))))))))))))))))))))))
(define CoreC-45Context-u--trimNS_StripNamespace_Def (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (vector 1 e-0 e-1 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-0 e-2) e-3 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Context-n--11224-5803-u--trimNSpat e-4 e-1 e-3 e-2 e-0 arg-0 eta-0)) e-4))))))))(else arg-1))))
(define CoreC-45Context-u--show_Show_BuiltinType (lambda (arg-0) (cond ((equal? arg-0 0) "Natural") ((equal? arg-0 1) "NaturalToInteger") (else "IntegerToNatural"))))
(define CoreC-45Context-u--restoreNS_StripNamespace_GlobalDef (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (CoreC-45Context-u--restoreNS_StripNamespace_Def arg-0 e-17) e-18 e-19 e-20 e-21)))))))))))))))))))))))))
(define CoreC-45Context-u--restoreNS_StripNamespace_Def (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (vector 1 e-0 e-1 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-0 e-2) e-3 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Context-n--11225-5856-u--restoreNSpat e-4 e-1 e-3 e-2 e-0 arg-0 eta-0)) e-4))))))))(else arg-1))))
(define CoreC-45Context-u--resolved_HasNames_Transform (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector e-0 e-5 e-6 e-7 e-8)))))))))))))))))))))))))
(define CoreC-45Context-u--resolved_HasNames_Totality (lambda (arg-0 arg-1 ext-0) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_Terminating arg-0 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--resolved_HasNames_Covering arg-0 e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))))
(define CoreC-45Context-u--resolved_HasNames_Terminating (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((2) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_PartialReason arg-0 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-5))))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-u--resolved_HasNames_SCCall (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 (let ((e-0 (car arg-1))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-1 (cdr arg-1))) (cons e-5 e-1)))))))))
(define CoreC-45Context-u--resolved_HasNames_Pat (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (csegen-856) (lambda (eta-2) (vector 1 e-0)) eta-1)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-1) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-2 eta-0)) ext-0))))) ((1) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((e-6 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (csegen-859) (lambda (eta-4) (vector 1 e-3)) eta-3)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-4) eta-2)) (lambda (eta-2) (vector 1 e-5)) eta-1)) (lambda (eta-1) (vector 1 e-6)) eta-0)) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (arg-2) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 arg-2 eta-1))) e-7 '() eta-0)) ext-0))))))) ((2) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-862) (lambda (eta-3) (vector 1 e-8)) eta-2)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-9) eta-1)) (lambda (eta-1) (vector 1 e-10)) eta-0)) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (arg-2) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 arg-2 eta-1))) e-11 '() eta-0)) ext-0)))))) ((3) (vector 1 arg-1)) ((4) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (let ((e-17 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-865) (lambda (eta-3) (vector 1 e-14)) eta-2)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-15) eta-1)) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-16 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-17 eta-0)) ext-0)))))) ((5) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-868) (lambda (eta-3) (vector 1 e-18)) eta-2)) (lambda (eta-2) (vector 1 e-19)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-20 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-21 eta-0)) ext-0)))))) ((6) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-22 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-23) ext-0)))) (else (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-24 e-5)))))) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-25) ext-0)))))))
(define CoreC-45Context-u--resolved_HasNames_PartialReason (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (vector 1 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-0 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-5)))))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-1 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-5)))))))))))
(define CoreC-45Context-u--resolved_HasNames_Name (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (vector 1 (vector 8 e-0))))(else (let ((sc0 (CoreC-45Context-getNameID arg-1 arg-0))) (if (null? sc0) (vector 1 arg-1) (let ((e-1 (unbox sc0))) (vector 1 (vector 8 e-1))))))))))
(define CoreC-45Context-u--resolved_HasNames_GlobalDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--resolved_HasNames_Def arg-0 (let ((e-17 (vector-ref arg-1 17))) e-17) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-u--resolved_HasNames_Totality arg-0 (let ((e-10 (vector-ref arg-1 10))) e-10) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-871) arg-0 (let ((e-12 (vector-ref arg-1 12))) e-12) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-871) arg-0 (let ((e-13 (vector-ref arg-1 13))) e-13) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_SCCall arg-0 eta-0 eta-1))) (let ((e-20 (vector-ref arg-1 20))) e-20) '() ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-27 (vector-ref arg-1 5))) (let ((e-26 (vector-ref arg-1 6))) (let ((e-25 (vector-ref arg-1 7))) (let ((e-24 (vector-ref arg-1 8))) (let ((e-23 (vector-ref arg-1 9))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-21 (vector-ref arg-1 21))) (vector e-0 e-1 e-5 e-3 e-4 e-27 e-26 e-25 e-24 e-23 e-7 e-11 e-8 e-9 e-14 e-15 e-16 e-6 e-18 e-19 e-10 e-21))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Context-u--resolved_HasNames_Def (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-0 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-0 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-n--10899-5648-u--resolvedNamesPat e-4 e-1 e-3 e-2 e-0 arg-0 eta-0)) e-4 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 1 e-0 e-1 e-5 e-6 e-7)))))))))))))))))))) ((6) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (let ((e-10 (vector-ref arg-1 6))) (let ((e-11 (vector-ref arg-1 7))) (let ((e-12 (vector-ref arg-1 8))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-10 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-11 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (vector 1 (vector 6 e-5 e-6 e-7 e-8 e-9 e-13 e-14 e-12))))))))))))))))))) ((8) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((e-15 (vector-ref arg-1 3))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-15) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-13 e-14 e-5)))))))))) ((9) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((e-18 (vector-ref arg-1 3))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-16) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 9 e-5 e-17 e-18))))))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-u--resolved_HasNames_Covering (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (vector 1 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 eta-0)) e-0 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-5)))))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-1 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-5)))))))))))
(define CoreC-45Context-u--resolved_HasNames_Clause (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (vector 1 (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (vector e-0 eta-3 eta-4 eta-5)))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-1 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-2) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) ext-0)))))))
(define CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((sc1 (CoreC-45Context-getNameID e-3 arg-1))) (if (null? sc1) (vector 1 (vector 1 e-1 e-2 e-3)) (let ((e-4 (unbox sc1))) (vector 1 (vector 1 e-1 e-2 (vector 8 e-4)))))))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (arg-3) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-8 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((sc2 (CoreC-45Context-getNameID e-6 arg-1))) (if (null? sc2) (vector 1 (vector 2 e-5 e-6 e-7 e-9)) (let ((e-1 (unbox sc2))) (vector 1 (vector 2 e-5 e-6 e-1 e-9)))))))))))))) ((3) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45CoreC-45Binder-traverse (lambda (arg-3) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-12 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-13) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-10 e-11 e-5 e-6))))))))))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-16) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-17) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-15 e-5 e-6)))))))))))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-21) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-22) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-19 e-20 e-5 e-6))))))))))))))) ((6) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-26) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-24 e-25 e-5)))))))))) ((7) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-30) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-31) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 7 e-28 e-29 e-5 e-6))))))))))))))) ((8) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((e-35 (vector-ref arg-2 3))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-35) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-33 e-34 e-5))))))))))(else (vector 1 arg-2))))))
(define CoreC-45Context-u--resolved_HasNames_C-40NameMapC-32C-36aC-41 (lambda (arg-1 arg-2) (CoreC-45Context-n--11440-6034-u--insertAll arg-2 arg-1 (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-toList arg-2))))
(define CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (unbox arg-3))) (let ((act-24 (let ((e-3 (cdr arg-1))) (((e-3 arg-2) e-2) ext-0)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box e-5))))))))))
(define CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (arg-3) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_C-40CaseAltC-32C-36varsC-41 arg-1 arg-3 eta-0))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-6 e-7))))))))))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-7 e-5)))))))))(else (vector 1 arg-2)))))
(define CoreC-45Context-u--resolved_HasNames_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (CoreC-45Context-getNameID e-1 arg-1))) (if (null? sc2) (vector 1 (vector 0 e-1 e-2 e-3 e-5)) (let ((e-6 (unbox sc2))) (vector 1 (vector 0 (vector 8 e-6) e-2 e-3 e-5)))))))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-6 e-7 e-5)))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-10 e-5))))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5)))))))))))
(define CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (let ((act-24 (CoreC-45CoreC-45Binder-traverse (lambda (arg-3) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-1 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (cons e-6 e-7)))))))))))))))
(define CoreC-45Context-u--full_HasNames_Transform (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-0 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector e-0 e-5 e-6 e-7 e-8)))))))))))))))))))))))))
(define CoreC-45Context-u--full_HasNames_Totality (lambda (arg-0 arg-1 ext-0) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Terminating arg-0 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_Covering arg-0 e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))))
(define CoreC-45Context-u--full_HasNames_Terminating (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((2) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Context-u--full_HasNames_PartialReason arg-0 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-5))))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-u--full_HasNames_SCCall (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-0 (let ((e-0 (car arg-1))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-1 (cdr arg-1))) (cons e-5 e-1)))))))))
(define CoreC-45Context-u--full_HasNames_Pat (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (csegen-856) (lambda (eta-2) (vector 1 e-0)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-1 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-2 eta-0)) ext-0))))) ((1) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((e-6 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (csegen-859) (lambda (eta-4) (vector 1 e-3)) eta-3)) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_Name arg-0 e-4 eta-3)) eta-2)) (lambda (eta-2) (vector 1 e-5)) eta-1)) (lambda (eta-1) (vector 1 e-6)) eta-0)) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (arg-2) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Pat arg-0 arg-2 eta-1))) e-7 '() eta-0)) ext-0))))))) ((2) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-862) (lambda (eta-3) (vector 1 e-8)) eta-2)) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 e-9 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-10)) eta-0)) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (arg-2) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Pat arg-0 arg-2 eta-1))) e-11 '() eta-0)) ext-0)))))) ((3) (vector 1 arg-1)) ((4) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (let ((e-17 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-865) (lambda (eta-3) (vector 1 e-14)) eta-2)) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 e-15 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-16 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-17 eta-0)) ext-0)))))) ((5) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-868) (lambda (eta-3) (vector 1 e-18)) eta-2)) (lambda (eta-2) (vector 1 e-19)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-20 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-21 eta-0)) ext-0)))))) ((6) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-22 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-23 eta-0)) ext-0)))) (else (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-24 e-5)))))) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-25) ext-0)))))))
(define CoreC-45Context-u--full_HasNames_PartialReason (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (vector 1 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-0 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-5)))))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-1 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-5)))))))))))
(define CoreC-45Context-u--full_HasNames_Name (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 ((CoreC-45Context-lookupCtxtExact (vector 8 e-0) arg-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 8 e-0)) (let ((e-1 (unbox e-5))) (vector 1 (let ((e-23 (vector-ref e-1 1))) e-23))))))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-u--full_HasNames_GlobalDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_Def arg-0 (let ((e-17 (vector-ref arg-1 17))) e-17) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-u--full_HasNames_Totality arg-0 (let ((e-10 (vector-ref arg-1 10))) e-10) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-871) arg-0 (let ((e-12 (vector-ref arg-1 12))) e-12) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-871) arg-0 (let ((e-13 (vector-ref arg-1 13))) e-13) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_SCCall arg-0 eta-0 eta-1))) (let ((e-20 (vector-ref arg-1 20))) e-20) '() ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-27 (vector-ref arg-1 5))) (let ((e-26 (vector-ref arg-1 6))) (let ((e-25 (vector-ref arg-1 7))) (let ((e-24 (vector-ref arg-1 8))) (let ((e-23 (vector-ref arg-1 9))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-21 (vector-ref arg-1 21))) (vector e-0 e-1 e-5 e-3 e-4 e-27 e-26 e-25 e-24 e-23 e-7 e-11 e-8 e-9 e-14 e-15 e-16 e-6 e-18 e-19 e-10 e-21))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Context-u--full_HasNames_Def (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-0 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-0 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-n--10898-5508-u--fullNamesPat e-4 e-1 e-3 e-2 e-0 arg-0 eta-0)) e-4 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 1 e-0 e-1 e-5 e-6 e-7)))))))))))))))))))) ((6) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (let ((e-10 (vector-ref arg-1 6))) (let ((e-11 (vector-ref arg-1 7))) (let ((e-12 (vector-ref arg-1 8))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-10 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-11 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (vector 1 (vector 6 e-5 e-6 e-7 e-8 e-9 e-13 e-14 e-12))))))))))))))))))) ((8) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((e-15 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-0 e-15 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-13 e-14 e-5)))))))))) ((9) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((e-18 (vector-ref arg-1 3))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-16) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 9 e-5 e-17 e-18))))))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-u--full_HasNames_Covering (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (vector 1 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 eta-0)) e-0 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-5)))))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-1 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-5)))))))))))
(define CoreC-45Context-u--full_HasNames_Clause (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector e-0 e-5 e-6 e-7))))))))))))))))))))
(define CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (case (vector-ref e-3 0) ((8) (let ((e-36 (vector-ref e-3 1))) (let ((act-24 ((CoreC-45Context-lookupCtxtExact (vector 8 e-36) arg-1) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 1 e-1 e-2 (vector 8 e-36))) (let ((e-4 (unbox e-5))) (vector 1 (vector 1 e-1 e-2 (let ((e-26 (vector-ref e-4 1))) e-26)))))))))))(else (vector 1 arg-2))))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (arg-3) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-8 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (vector 1 (vector 2 e-5 e-6 e-7 e-9))))))))))) ((3) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45CoreC-45Binder-traverse (lambda (arg-3) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-12 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-13) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-10 e-11 e-5 e-6))))))))))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-16) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-17) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-15 e-5 e-6)))))))))))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-21) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-22) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-19 e-20 e-5 e-6))))))))))))))) ((6) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-26) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-24 e-25 e-5)))))))))) ((7) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-30) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-31) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 7 e-28 e-29 e-5 e-6))))))))))))))) ((8) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((e-35 (vector-ref arg-2 3))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-35) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-33 e-34 e-5))))))))))(else (vector 1 arg-2))))))
(define CoreC-45Context-u--full_HasNames_C-40NameMapC-32C-36aC-41 (lambda (arg-1 arg-2) (CoreC-45Context-n--11439-6002-u--insertAll arg-2 arg-1 (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-toList arg-2))))
(define CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (unbox arg-3))) (let ((act-24 (let ((e-1 (car arg-1))) (((e-1 arg-2) e-2) ext-0)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box e-5))))))))))
(define CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (arg-3) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40CaseAltC-32C-36varsC-41 arg-1 arg-3 eta-0))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-6 e-7))))))))))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-7 e-5)))))))))(else (vector 1 arg-2)))))
(define CoreC-45Context-u--full_HasNames_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-1 arg-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 0 e-1 e-2 e-3 e-5)) (let ((e-7 (unbox e-6))) (vector 1 (vector 0 (let ((e-28 (vector-ref e-7 1))) e-28) e-2 e-3 e-5))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-6 e-7 e-5)))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-10 e-5))))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5)))))))))))
(define CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (let ((act-24 (CoreC-45CoreC-45Binder-traverse (lambda (arg-3) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-1 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (cons e-6 e-7)))))))))))))))
(define CoreC-45Context-withLogLevel (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--logs (let ((e-4 (vector-ref e-5 4))) (let ((e-39 (vector-ref e-4 2))) (let ((e-56 (vector-ref e-39 9))) e-56))))) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-65 (vector-ref e-33 0))) (let ((e-42 (vector-ref e-33 1))) (let ((e-43 (vector-ref e-33 2))) (let ((e-44 (vector-ref e-33 3))) (let ((e-45 (vector-ref e-33 4))) (let ((e-46 (vector-ref e-33 5))) (let ((e-47 (vector-ref e-33 6))) (let ((e-48 (vector-ref e-33 7))) (let ((e-49 (vector-ref e-33 8))) (let ((e-51 (vector-ref e-33 10))) (let ((e-52 (vector-ref e-33 11))) (let ((e-53 (vector-ref e-33 12))) (let ((e-54 (vector-ref e-33 13))) (let ((e-55 (vector-ref e-33 14))) (let ((e-56 (vector-ref e-33 15))) (let ((e-57 (vector-ref e-33 16))) (let ((e-58 (vector-ref e-33 17))) (let ((e-59 (vector-ref e-33 18))) (let ((e-60 (vector-ref e-33 19))) (let ((e-61 (vector-ref e-33 20))) (let ((e-62 (vector-ref e-33 21))) (let ((e-63 (vector-ref e-33 22))) (let ((e-64 (vector-ref e-33 23))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 (vector e-65 e-42 e-43 e-44 e-45 e-46 e-47 e-48 e-49 (CoreC-45OptionsC-45Log-insertLogLevel arg-2 u--logs) e-51 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64) e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (arg-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-1 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-34 (vector-ref e-8 5))) (let ((e-33 (vector-ref e-8 6))) (let ((e-32 (vector-ref e-8 7))) (let ((e-31 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (let ((e-44 (vector-ref e-4 0))) (let ((e-43 (vector-ref e-4 1))) (let ((e-42 (vector-ref e-4 2))) (let ((e-41 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-68 (vector-ref e-42 0))) (let ((e-67 (vector-ref e-42 1))) (let ((e-66 (vector-ref e-42 2))) (let ((e-65 (vector-ref e-42 3))) (let ((e-45 (vector-ref e-42 4))) (let ((e-46 (vector-ref e-42 5))) (let ((e-47 (vector-ref e-42 6))) (let ((e-48 (vector-ref e-42 7))) (let ((e-49 (vector-ref e-42 8))) (let ((e-51 (vector-ref e-42 10))) (let ((e-52 (vector-ref e-42 11))) (let ((e-53 (vector-ref e-42 12))) (let ((e-54 (vector-ref e-42 13))) (let ((e-55 (vector-ref e-42 14))) (let ((e-56 (vector-ref e-42 15))) (let ((e-57 (vector-ref e-42 16))) (let ((e-58 (vector-ref e-42 17))) (let ((e-59 (vector-ref e-42 18))) (let ((e-60 (vector-ref e-42 19))) (let ((e-61 (vector-ref e-42 20))) (let ((e-62 (vector-ref e-42 21))) (let ((e-63 (vector-ref e-42 22))) (let ((e-64 (vector-ref e-42 23))) (vector e-0 e-1 e-2 e-3 (vector e-44 e-43 (vector e-68 e-67 e-66 e-65 e-45 e-46 e-47 e-48 e-49 u--logs e-51 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64) e-41 e-35 e-36 e-37 e-38 e-39 e-40) e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 e-7))))))))))))))))))))))
(define CoreC-45Context-withExtendedNS (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--cns (let ((e-2 (vector-ref e-5 2))) e-2))) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 (CoreC-45NameC-45Namespace-C-60C-46C-62 u--cns arg-2) e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (vector 1 e-7)))))) arg-3 eta-0)) (lambda (eta-0) (lambda (eta-1) (vector 1 (vector 0 eta-0)))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-1 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-34 (vector-ref e-8 5))) (let ((e-33 (vector-ref e-8 6))) (let ((e-32 (vector-ref e-8 7))) (let ((e-31 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (vector e-0 e-1 u--cns e-3 e-4 e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (case (vector-ref e-7 0) ((0) (let ((e-2 (vector-ref e-7 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-2 ext-0))) (else (let ((e-10 (vector-ref e-7 1))) (vector 1 e-10)))))))))))))))))))))))))
(define CoreC-45Context-withCtxt (lambda (arg-1 ext-1 ext-0) (CoreC-45Core-wrapRef (vector "Core.Context.Ctxt" ) arg-1 (lambda (eta-0) (CoreC-45Context-n--23184-16876-u--resetCtxt arg-1 eta-0)) ext-1 ext-0)))
(define CoreC-45Context-visibleInAny (lambda (arg-0 arg-1 arg-2) (PreludeC-45Interfaces-any (csegen-51) (lambda (u--ns) (CoreC-45Context-visibleIn u--ns arg-1 arg-2)) arg-0)))
(define CoreC-45Context-visibleIn (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (cond ((equal? arg-2 0) (CoreC-45NameC-45Namespace-isParentOf e-0 arg-0))(else 1))))(else 1))))
(define CoreC-45Context-updateTy (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-1) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 (vector 8 arg-1) (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-24 arg-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) ext-0)))))))))))))
(define CoreC-45Context-updateDef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((sc3 (arg-2 (let ((e-17 (vector-ref e-1 17))) e-17)))) (if (null? sc3) (vector 1 0) (let ((e-2 (unbox sc3))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-1 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-24 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (vector e-0 e-25 e-24 e-3 e-4 e-23 e-22 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-2 e-18 e-19 e-20 '()))))))))))))))))))))) eta-0)) ext-0))))))))))))))))
(define CoreC-45Context-unsetFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((u--flagsC-39 (DataC-45List-filter (lambda (arg-4) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag arg-4 arg-3)) (let ((e-11 (vector-ref e-1 11))) e-11)))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 e-10 u--flagsC-39 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) ext-0))))))))))))))
(define CoreC-45Context-undefinedName (lambda (arg-1 arg-2 arg-3 ext-0) (CoreC-45Context-maybeMisspelling arg-1 (vector 7 arg-2 arg-3) arg-3 ext-0)))
(define CoreC-45Context-toResolvedNames (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (cdr arg-2))) (((e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) arg-3) ext-0))))))))
(define CoreC-45Context-toFullNames (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-1 (car arg-2))) (((e-1 (let ((e-0 (vector-ref e-5 0))) e-0)) arg-3) ext-0))))))))
(define CoreC-45Context-startTimer (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-getTime ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-32 (vector-ref e-6 5))) (let ((e-31 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 (box (cons (+ e-5 (* arg-1 1000000)) arg-2)) e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-26))))))))))))
(define CoreC-45Context-sndName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (box (let ((e-2 (vector-ref eta-0 2))) e-2)))) (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 4))) e-37))))))))))
(define CoreC-45Context-showSimilarNames (lambda (arg-0 arg-1 arg-2) (let ((u--sorted (DataC-45List-sortBy (lambda (u--x) (lambda (u--y) (PreludeC-45Types-u--compare_Ord_Nat (Builtin-snd u--x) (Builtin-snd u--y)))) arg-2))) (let ((u--roots (DataC-45List-mapMaybe (lambda (eta-0) (CoreC-45Context-n--14755-9173-u--showNames arg-2 arg-1 arg-0 arg-0 arg-1 (Builtin-fst eta-0))) u--sorted))) (DataC-45List-nub (csegen-17) u--roots)))))
(define CoreC-45Context-setWorkingDir (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((SystemC-45Directory-changeDir (csegen-3) arg-1) eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 ((csegen-878) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") ext-0) (let ((e-1 (unbox e-7))) (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-34 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-32 (vector-ref e-5 6))) (let ((e-31 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-44 (vector-ref e-4 0))) (let ((e-43 (vector-ref e-4 1))) (let ((e-42 (vector-ref e-4 2))) (let ((e-41 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-44 1))) (let ((e-52 (vector-ref e-44 2))) (let ((e-51 (vector-ref e-44 3))) (let ((e-45 (vector-ref e-44 4))) (let ((e-46 (vector-ref e-44 5))) (let ((e-47 (vector-ref e-44 6))) (let ((e-48 (vector-ref e-44 7))) (let ((e-49 (vector-ref e-44 8))) (let ((e-50 (vector-ref e-44 9))) (vector e-0 e-34 e-2 e-3 (vector (vector e-1 e-53 e-52 e-51 e-45 e-46 e-47 e-48 e-49 e-50) e-43 e-42 e-41 e-35 e-36 e-37 e-38 e-39 e-40) e-33 e-32 e-31 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-27)))))))))))))))))
(define CoreC-45Context-setVisible (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-42 (vector-ref e-0 0))) (let ((e-32 (vector-ref e-0 1))) (let ((e-33 (vector-ref e-0 2))) (let ((e-34 (vector-ref e-0 3))) (let ((e-35 (vector-ref e-0 4))) (let ((e-36 (vector-ref e-0 5))) (let ((e-37 (vector-ref e-0 6))) (let ((e-38 (vector-ref e-0 7))) (let ((e-39 (vector-ref e-0 8))) (let ((e-40 (vector-ref e-0 9))) (let ((e-41 (vector-ref e-0 10))) (vector (vector e-42 e-32 e-33 e-34 e-35 e-36 e-37 (cons arg-1 e-38) e-39 e-40 e-41) e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setUniqueSearch (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((CoreC-45Context-case--caseC-32blockC-32inC-32setUniqueSearch-13460 arg-3 arg-2 arg-1 arg-0 e-5 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17)) ext-0))))))))))))))
(define CoreC-45Context-setUnboundImplicits (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-48 (vector-ref e-34 0))) (let ((e-43 (vector-ref e-34 2))) (let ((e-44 (vector-ref e-34 3))) (let ((e-45 (vector-ref e-34 4))) (let ((e-46 (vector-ref e-34 5))) (let ((e-47 (vector-ref e-34 6))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 (vector e-48 arg-1 e-43 e-44 e-45 e-46 e-47) e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setTerminating (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-25 (cdr e-10))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 (cons arg-3 e-25) e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))))) eta-0)) ext-0)))))))))))))
(define CoreC-45Context-setSourceDir (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-51 (vector-ref e-41 0))) (let ((e-43 (vector-ref e-41 2))) (let ((e-44 (vector-ref e-41 3))) (let ((e-45 (vector-ref e-41 4))) (let ((e-46 (vector-ref e-41 5))) (let ((e-47 (vector-ref e-41 6))) (let ((e-48 (vector-ref e-41 7))) (let ((e-49 (vector-ref e-41 8))) (let ((e-50 (vector-ref e-41 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-51 arg-1 e-43 e-44 e-45 e-46 e-47 e-48 e-49 e-50) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setSizeChange (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 arg-3 e-21)))))))))))))))))))))) eta-0)) ext-0)))))))))))))
(define CoreC-45Context-setSession (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 arg-1 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setSearchTimeout (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-65 (vector-ref e-33 0))) (let ((e-42 (vector-ref e-33 1))) (let ((e-43 (vector-ref e-33 2))) (let ((e-44 (vector-ref e-33 3))) (let ((e-45 (vector-ref e-33 4))) (let ((e-46 (vector-ref e-33 5))) (let ((e-48 (vector-ref e-33 7))) (let ((e-49 (vector-ref e-33 8))) (let ((e-50 (vector-ref e-33 9))) (let ((e-51 (vector-ref e-33 10))) (let ((e-52 (vector-ref e-33 11))) (let ((e-53 (vector-ref e-33 12))) (let ((e-54 (vector-ref e-33 13))) (let ((e-55 (vector-ref e-33 14))) (let ((e-56 (vector-ref e-33 15))) (let ((e-57 (vector-ref e-33 16))) (let ((e-58 (vector-ref e-33 17))) (let ((e-59 (vector-ref e-33 18))) (let ((e-60 (vector-ref e-33 19))) (let ((e-61 (vector-ref e-33 20))) (let ((e-62 (vector-ref e-33 21))) (let ((e-63 (vector-ref e-33 22))) (let ((e-64 (vector-ref e-33 23))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 (vector e-65 e-42 e-43 e-44 e-45 e-46 arg-1 e-48 e-49 e-50 e-51 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64) e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setRewrite (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-32 (vector-ref e-5 6))) (let ((e-31 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setRewrite e-7 e-6 e-4) e-33 e-32 e-31 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-27))))))))))))))))
(define CoreC-45Context-setPrefixRecordProjections (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-48 (vector-ref e-34 0))) (let ((e-42 (vector-ref e-34 1))) (let ((e-43 (vector-ref e-34 2))) (let ((e-44 (vector-ref e-34 3))) (let ((e-45 (vector-ref e-34 4))) (let ((e-46 (vector-ref e-34 5))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 (vector e-48 e-42 e-43 e-44 e-45 e-46 arg-1) e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setPrefix (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-51 (vector-ref e-41 0))) (let ((e-42 (vector-ref e-41 1))) (let ((e-43 (vector-ref e-41 2))) (let ((e-44 (vector-ref e-41 3))) (let ((e-45 (vector-ref e-41 4))) (let ((e-47 (vector-ref e-41 6))) (let ((e-48 (vector-ref e-41 7))) (let ((e-49 (vector-ref e-41 8))) (let ((e-50 (vector-ref e-41 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-51 e-42 e-43 e-44 e-45 arg-1 e-47 e-48 e-49 e-50) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setPair (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-34 (vector-ref e-5 5))) (let ((e-33 (vector-ref e-5 6))) (let ((e-32 (vector-ref e-5 7))) (let ((e-31 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setPair e-6 e-7 e-8 e-4) e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-28))))))))))))))))))))
(define CoreC-45Context-setPPrint (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-41 arg-1 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setOutputDir (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-51 (vector-ref e-41 0))) (let ((e-42 (vector-ref e-41 1))) (let ((e-43 (vector-ref e-41 2))) (let ((e-44 (vector-ref e-41 3))) (let ((e-46 (vector-ref e-41 5))) (let ((e-47 (vector-ref e-41 6))) (let ((e-48 (vector-ref e-41 7))) (let ((e-49 (vector-ref e-41 8))) (let ((e-50 (vector-ref e-41 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-51 e-42 e-43 e-44 arg-1 e-46 e-47 e-48 e-49 e-50) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setOpenHints (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 arg-1 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setNestedNS (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 arg-1 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setNameFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) ext-0) (let ((e-7 (cdr e-1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) ext-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-2) (let ((u--flagsC-39 (cons arg-3 (DataC-45List-filter (lambda (arg-4) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag arg-4 arg-3)) (let ((e-22 (vector-ref e-11 11))) e-22))))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 (vector 8 e-10) (let ((e-0 (vector-ref e-11 0))) (let ((e-29 (vector-ref e-11 1))) (let ((e-28 (vector-ref e-11 2))) (let ((e-3 (vector-ref e-11 3))) (let ((e-4 (vector-ref e-11 4))) (let ((e-27 (vector-ref e-11 5))) (let ((e-26 (vector-ref e-11 6))) (let ((e-25 (vector-ref e-11 7))) (let ((e-24 (vector-ref e-11 8))) (let ((e-9 (vector-ref e-11 9))) (let ((e-23 (vector-ref e-11 10))) (let ((e-12 (vector-ref e-11 12))) (let ((e-13 (vector-ref e-11 13))) (let ((e-14 (vector-ref e-11 14))) (let ((e-15 (vector-ref e-11 15))) (let ((e-16 (vector-ref e-11 16))) (let ((e-17 (vector-ref e-11 17))) (let ((e-18 (vector-ref e-11 18))) (let ((e-19 (vector-ref e-11 19))) (let ((e-20 (vector-ref e-11 20))) (let ((e-21 (vector-ref e-11 21))) (vector e-0 e-29 e-28 e-3 e-4 e-27 e-26 e-25 e-24 e-9 e-23 u--flagsC-39 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) ext-0)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) ext-0))))))))))))))))))))
(define CoreC-45Context-setNS (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 arg-1 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setNFThreshold (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-48 (vector-ref e-34 0))) (let ((e-42 (vector-ref e-34 1))) (let ((e-43 (vector-ref e-34 2))) (let ((e-44 (vector-ref e-34 3))) (let ((e-45 (vector-ref e-34 4))) (let ((e-47 (vector-ref e-34 6))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 (vector e-48 e-42 e-43 e-44 e-45 arg-1 e-47) e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setMutWith (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((6) (let ((e-32 (vector-ref e-17 1))) (let ((e-31 (vector-ref e-17 2))) (let ((e-30 (vector-ref e-17 3))) (let ((e-29 (vector-ref e-17 4))) (let ((e-28 (vector-ref e-17 5))) (let ((e-26 (vector-ref e-17 7))) (let ((e-25 (vector-ref e-17 8))) (CoreC-45Context-updateDef arg-0 arg-2 (lambda (eta-0) (box (vector 6 e-32 e-31 e-30 e-29 e-28 arg-3 e-26 e-25))) ext-0)))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-45 (vector-ref e-1 1))) e-45)) " is not a type constructor [setMutWith]")) ext-0))))))))))))))))
(define CoreC-45Context-setLogTimings (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-65 (vector-ref e-33 0))) (let ((e-42 (vector-ref e-33 1))) (let ((e-43 (vector-ref e-33 2))) (let ((e-44 (vector-ref e-33 3))) (let ((e-45 (vector-ref e-33 4))) (let ((e-46 (vector-ref e-33 5))) (let ((e-47 (vector-ref e-33 6))) (let ((e-48 (vector-ref e-33 7))) (let ((e-49 (vector-ref e-33 8))) (let ((e-50 (vector-ref e-33 9))) (let ((e-52 (vector-ref e-33 11))) (let ((e-53 (vector-ref e-33 12))) (let ((e-54 (vector-ref e-33 13))) (let ((e-55 (vector-ref e-33 14))) (let ((e-56 (vector-ref e-33 15))) (let ((e-57 (vector-ref e-33 16))) (let ((e-58 (vector-ref e-33 17))) (let ((e-59 (vector-ref e-33 18))) (let ((e-60 (vector-ref e-33 19))) (let ((e-61 (vector-ref e-33 20))) (let ((e-62 (vector-ref e-33 21))) (let ((e-63 (vector-ref e-33 22))) (let ((e-64 (vector-ref e-33 23))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 (vector e-65 e-42 e-43 e-44 e-45 e-46 e-47 e-48 e-49 e-50 arg-1 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64) e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setLinearCheck (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-1) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 (vector 8 arg-1) (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 arg-2 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) ext-0)))))))))))))
(define CoreC-45Context-setIncData (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 (cons (cons arg-1 arg-2) e-22) e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setFromString (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromString arg-1 e-4) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setFromInteger (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromInteger arg-1 e-4) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setFromDouble (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromDouble arg-1 e-4) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setFromChar (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromChar arg-1 e-4) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((u--flagsC-39 (cons arg-3 (DataC-45List-filter (lambda (arg-4) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag arg-4 arg-3)) (let ((e-11 (vector-ref e-1 11))) e-11))))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 e-10 u--flagsC-39 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) ext-0))))))))))))))
(define CoreC-45Context-setExternal (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((CoreC-45Context-case--caseC-32blockC-32inC-32setExternal-13596 arg-3 arg-2 arg-1 arg-0 e-5 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17)) ext-0))))))))))))))
(define CoreC-45Context-setExtension (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setExtension arg-1 e-4) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setDetermining (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((6) (let ((e-32 (vector-ref e-17 1))) (let ((e-31 (vector-ref e-17 2))) (let ((e-30 (vector-ref e-17 3))) (let ((e-28 (vector-ref e-17 5))) (let ((e-27 (vector-ref e-17 6))) (let ((e-26 (vector-ref e-17 7))) (let ((e-25 (vector-ref e-17 8))) (let ((act-26 ((CoreC-45Context-n--19068-13071-u--getPos arg-3 arg-2 arg-1 arg-0 0 arg-3 (let ((e-52 (vector-ref e-1 2))) e-52)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-33 (vector-ref act-26 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-26 1))) (CoreC-45Context-updateDef arg-0 arg-2 (lambda (eta-0) (box (vector 6 e-32 e-31 e-30 e-33 e-28 e-27 e-26 e-25))) ext-0)))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-45 (vector-ref e-1 1))) e-45)) " is not a type constructor [setDetermining]")) ext-0))))))))))))))))
(define CoreC-45Context-setDetags (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((6) (let ((e-32 (vector-ref e-17 1))) (let ((e-31 (vector-ref e-17 2))) (let ((e-30 (vector-ref e-17 3))) (let ((e-29 (vector-ref e-17 4))) (let ((e-28 (vector-ref e-17 5))) (let ((e-27 (vector-ref e-17 6))) (let ((e-26 (vector-ref e-17 7))) (CoreC-45Context-updateDef arg-0 arg-2 (lambda (eta-0) (box (vector 6 e-32 e-31 e-30 e-29 e-28 e-27 e-26 arg-3))) ext-0)))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-45 (vector-ref e-1 1))) e-45)) " is not a type constructor [setDetermining]")) ext-0))))))))))))))))
(define CoreC-45Context-setDefaultTotalityOption (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-48 (vector-ref e-34 0))) (let ((e-42 (vector-ref e-34 1))) (let ((e-44 (vector-ref e-34 3))) (let ((e-45 (vector-ref e-34 4))) (let ((e-46 (vector-ref e-34 5))) (let ((e-47 (vector-ref e-34 6))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 (vector e-48 e-42 arg-1 e-44 e-45 e-46 e-47) e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setDebugElabCheck (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-65 (vector-ref e-33 0))) (let ((e-42 (vector-ref e-33 1))) (let ((e-43 (vector-ref e-33 2))) (let ((e-44 (vector-ref e-33 3))) (let ((e-45 (vector-ref e-33 4))) (let ((e-46 (vector-ref e-33 5))) (let ((e-47 (vector-ref e-33 6))) (let ((e-48 (vector-ref e-33 7))) (let ((e-49 (vector-ref e-33 8))) (let ((e-50 (vector-ref e-33 9))) (let ((e-51 (vector-ref e-33 10))) (let ((e-53 (vector-ref e-33 12))) (let ((e-54 (vector-ref e-33 13))) (let ((e-55 (vector-ref e-33 14))) (let ((e-56 (vector-ref e-33 15))) (let ((e-57 (vector-ref e-33 16))) (let ((e-58 (vector-ref e-33 17))) (let ((e-59 (vector-ref e-33 18))) (let ((e-60 (vector-ref e-33 19))) (let ((e-61 (vector-ref e-33 20))) (let ((e-62 (vector-ref e-33 21))) (let ((e-63 (vector-ref e-33 22))) (let ((e-64 (vector-ref e-33 23))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 (vector e-65 e-42 e-43 e-44 e-45 e-46 e-47 e-48 e-49 e-50 e-51 arg-1 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64) e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setCtxt (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector arg-1 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setCovering (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-26 (car e-10))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 (cons e-26 arg-3) e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))))) eta-0)) ext-0)))))))))))))
(define CoreC-45Context-setCompiled (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-1 (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (box arg-2) e-19 e-20 e-21)))))))))))))))))))))) eta-0)) ext-0)))))))))))))
(define CoreC-45Context-setCG (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-65 (vector-ref e-33 0))) (let ((e-42 (vector-ref e-33 1))) (let ((e-43 (vector-ref e-33 2))) (let ((e-44 (vector-ref e-33 3))) (let ((e-46 (vector-ref e-33 5))) (let ((e-47 (vector-ref e-33 6))) (let ((e-48 (vector-ref e-33 7))) (let ((e-49 (vector-ref e-33 8))) (let ((e-50 (vector-ref e-33 9))) (let ((e-51 (vector-ref e-33 10))) (let ((e-52 (vector-ref e-33 11))) (let ((e-53 (vector-ref e-33 12))) (let ((e-54 (vector-ref e-33 13))) (let ((e-55 (vector-ref e-33 14))) (let ((e-56 (vector-ref e-33 15))) (let ((e-57 (vector-ref e-33 16))) (let ((e-58 (vector-ref e-33 17))) (let ((e-59 (vector-ref e-33 18))) (let ((e-60 (vector-ref e-33 19))) (let ((e-61 (vector-ref e-33 20))) (let ((e-62 (vector-ref e-33 21))) (let ((e-63 (vector-ref e-33 22))) (let ((e-64 (vector-ref e-33 23))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 (vector e-65 e-42 e-43 e-44 arg-1 e-46 e-47 e-48 e-49 e-50 e-51 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64) e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setBuildDir (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-51 (vector-ref e-41 0))) (let ((e-42 (vector-ref e-41 1))) (let ((e-44 (vector-ref e-41 3))) (let ((e-45 (vector-ref e-41 4))) (let ((e-46 (vector-ref e-41 5))) (let ((e-47 (vector-ref e-41 6))) (let ((e-48 (vector-ref e-41 7))) (let ((e-49 (vector-ref e-41 8))) (let ((e-50 (vector-ref e-41 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-51 e-42 arg-1 e-44 e-45 e-46 e-47 e-48 e-49 e-50) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setAutoImplicitLimit (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-48 (vector-ref e-34 0))) (let ((e-42 (vector-ref e-34 1))) (let ((e-43 (vector-ref e-34 2))) (let ((e-44 (vector-ref e-34 3))) (let ((e-46 (vector-ref e-34 5))) (let ((e-47 (vector-ref e-34 6))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 (vector e-48 e-42 e-43 e-44 arg-1 e-46 e-47) e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setAmbigLimit (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-48 (vector-ref e-34 0))) (let ((e-42 (vector-ref e-34 1))) (let ((e-43 (vector-ref e-34 2))) (let ((e-45 (vector-ref e-34 4))) (let ((e-46 (vector-ref e-34 5))) (let ((e-47 (vector-ref e-34 6))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 (vector e-48 e-42 e-43 arg-1 e-45 e-46 e-47) e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-setAllPublic (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-42 (vector-ref e-0 0))) (let ((e-32 (vector-ref e-0 1))) (let ((e-33 (vector-ref e-0 2))) (let ((e-34 (vector-ref e-0 3))) (let ((e-35 (vector-ref e-0 4))) (let ((e-36 (vector-ref e-0 5))) (let ((e-37 (vector-ref e-0 6))) (let ((e-38 (vector-ref e-0 7))) (let ((e-40 (vector-ref e-0 9))) (let ((e-41 (vector-ref e-0 10))) (vector (vector e-42 e-32 e-33 e-34 e-35 e-36 e-37 e-38 arg-1 e-40 e-41) e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-returnDef (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-0 0) (box (cons arg-1 arg-2))) (else (CoreC-45Context-case--returnDef-2989 arg-2 arg-1 (let ((e-17 (vector-ref arg-2 17))) e-17))))))
(define CoreC-45Context-resolveName (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (vector 1 e-0)))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-getPosition arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-26 (CoreC-45Context-setCtxt arg-0 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))))))))))))
(define CoreC-45Context-resetFirstEntry (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-32 (vector-ref e-0 1))) (let ((e-33 (vector-ref e-0 2))) (let ((e-34 (vector-ref e-0 3))) (let ((e-35 (vector-ref e-0 4))) (let ((e-36 (vector-ref e-0 5))) (let ((e-37 (vector-ref e-0 6))) (let ((e-38 (vector-ref e-0 7))) (let ((e-39 (vector-ref e-0 8))) (let ((e-40 (vector-ref e-0 9))) (let ((e-41 (vector-ref e-0 10))) (vector (vector (let ((e-73 (vector-ref e-5 0))) (let ((e-83 (vector-ref e-73 1))) e-83)) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41) e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-reducibleInAny (lambda (arg-0 arg-1 arg-2) (PreludeC-45Interfaces-any (csegen-51) (lambda (u--ns) (CoreC-45Context-reducibleIn u--ns arg-1 arg-2)) arg-0)))
(define CoreC-45Context-reducibleIn (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((1) (cond ((equal? arg-2 1) (CoreC-45NameC-45Namespace-isParentOf e-0 arg-0)) ((equal? arg-2 0) (CoreC-45NameC-45Namespace-isParentOf e-0 arg-0))(else 1)))(else 1)))))(else 1))))
(define CoreC-45Context-recordWarning (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 (cons arg-1 e-29) e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26)))))))))))
(define CoreC-45Context-prettyName (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((5) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (lambda (clam-0) (if (null? e-0) (vector 1 (CoreC-45Name-u--show_Show_Name arg-1)) (let ((e-10 (car e-0))) (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) (vector 8 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-prettyName arg-0 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-prettyName arg-0 e-1) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 "," e-7))))))))))))))))))))) ((6) (let ((e-2 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "case block in " e-2))))) ((7) (let ((e-4 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "with block in " e-4))))) ((0) (let ((e-7 (vector-ref arg-1 2))) (CoreC-45Context-prettyName arg-0 e-7)))(else (lambda (eta-0) (vector 1 (CoreC-45Name-u--show_Show_Name arg-1)))))))
(define CoreC-45Context-noDeclaration (lambda (arg-1 arg-2 arg-3 ext-0) (CoreC-45Context-maybeMisspelling arg-1 (vector 37 arg-2 arg-3) arg-3 ext-0)))
(define CoreC-45Context-newEntry (lambda (arg-0 arg-1) (let ((u--idx (let ((e-1 (vector-ref arg-1 1))) e-1))) (let ((u--a (let ((e-4 (vector-ref arg-1 4))) e-4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox u--a))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int u--idx (LibrariesC-45DataC-45IOArray-max e-5)))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 ((LibrariesC-45DataC-45IOArray-newArrayCopy (csegen-3) (bs+ (LibrariesC-45DataC-45IOArray-max e-5) (CoreC-45Context-Grow) 63) e-5) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! u--a e-6))) (vector 1 act-26))))))) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (cons u--idx (let ((e-0 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-12 (vector-ref arg-1 5))) (let ((e-11 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (vector e-0 (bs+ u--idx 1 63) (LibrariesC-45DataC-45NameMap-insert arg-0 u--idx e-2) (CoreC-45Context-addPossible arg-0 u--idx e-3) e-4 e-12 e-11 e-7 e-8 e-9 e-10)))))))))))))))))))))))))
(define CoreC-45Context-newDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector arg-0 arg-1 arg-4 '() '() '() '() arg-2 arg-3 arg-5 (CoreC-45TT-unchecked) '() '() '() 0 0 0 arg-6 '() '() '() '())))
(define CoreC-45Context-newAlias (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((CoreC-45Context-getPosition arg-1 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (let ((e-0 (vector-ref e-3 0))) (let ((e-1 (vector-ref e-3 1))) (let ((e-13 (vector-ref e-3 2))) (let ((e-12 (vector-ref e-3 3))) (let ((e-4 (vector-ref e-3 4))) (let ((e-11 (vector-ref e-3 5))) (let ((e-6 (vector-ref e-3 6))) (let ((e-7 (vector-ref e-3 7))) (let ((e-8 (vector-ref e-3 8))) (let ((e-9 (vector-ref e-3 9))) (let ((e-10 (vector-ref e-3 10))) (vector e-0 e-1 e-13 (CoreC-45Context-addAlias arg-0 arg-1 e-2 e-12) e-4 e-11 e-6 e-7 e-8 e-9 e-10)))))))))))))))))))))
(define CoreC-45Context-maybeMisspelling (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((CoreC-45Context-getSimilarNames arg-1 arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error arg-2 ext-0) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((u--candidates (CoreC-45Context-showSimilarNames arg-3 e-7 e-6))) (if (null? u--candidates) (CoreC-45Core-u--throw_Catchable_Core_Error arg-2 ext-0) (let ((e-2 (car u--candidates))) (let ((e-3 (cdr u--candidates))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 66 arg-2 (cons e-2 e-3)) ext-0)))))))))))))))
(define CoreC-45Context-lookupTyName (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupNameBy (csegen-879) ext-2 ext-1 ext-0)))
(define CoreC-45Context-lookupTyExact (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupExactBy (csegen-879) ext-2 ext-1 ext-0)))
(define CoreC-45Context-lookupNameBy (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtName arg-2 arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons e-6 (arg-1 e-7)))))))) e-5))))))))
(define CoreC-45Context-lookupExactBy (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-2 arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (vector 1 (box (arg-1 e-1)))))))))))
(define CoreC-45Context-lookupDefTyExact (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupExactBy (csegen-880) ext-2 ext-1 ext-0)))
(define CoreC-45Context-lookupDefName (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupNameBy (csegen-881) ext-2 ext-1 ext-0)))
(define CoreC-45Context-lookupDefExact (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupExactBy (csegen-881) ext-2 ext-1 ext-0)))
(define CoreC-45Context-lookupCtxtName (lambda (arg-0 arg-1) (CoreC-45Context-case--lookupCtxtName-3730 arg-1 arg-0 (CoreC-45Name-userNameRoot arg-0))))
(define CoreC-45Context-lookupCtxtExactI (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (lambda (clam-0) (let ((sc1 (LibrariesC-45DataC-45IntMap-lookup e-0 (let ((e-6 (vector-ref arg-1 6))) e-6)))) (if (null? sc1) (let ((act-24 (let ((act-24 (unbox (let ((e-4 (vector-ref arg-1 4))) e-4)))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((LibrariesC-45DataC-45IOArray-readArray (csegen-3) e-5 e-0) clam-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-26 (CoreC-45Context-decode arg-1 e-0 1 e-1 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45Context-returnDef (let ((e-9 (vector-ref arg-1 9))) e-9) e-0 e-7)))))))))))))))) (let ((e-1 (unbox sc1))) (let ((act-24 (CoreC-45Context-decode arg-1 e-0 1 e-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45Context-returnDef (let ((e-9 (vector-ref arg-1 9))) e-9) e-0 e-5))))))))))))(else (let ((sc0 (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)))) (if (null? sc0) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox sc0))) (CoreC-45Context-lookupCtxtExactI (vector 8 e-1) arg-1))))))))
(define CoreC-45Context-lookupCtxtExact (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (lambda (eta-0) (CoreC-45Context-case--lookupCtxtExact-3156 e-0 arg-1 (LibrariesC-45DataC-45IntMap-lookup e-0 (let ((e-6 (vector-ref arg-1 6))) e-6)) eta-0))))(else (lambda (eta-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExactI arg-0 arg-1) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((e-6 (cdr e-1))) (vector 1 (box e-6))))))))))))))
(define CoreC-45Context-lookupContextEntry (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (let ((sc1 (LibrariesC-45DataC-45IntMap-lookup e-0 (let ((e-6 (vector-ref arg-1 6))) e-6)))) (if (null? sc1) (let ((u--a (let ((e-4 (vector-ref arg-1 4))) e-4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox u--a))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((LibrariesC-45DataC-45IOArray-readArray (csegen-3) e-5 e-0) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (vector 1 (box (cons e-0 e-1))))))))))))))) (let ((e-1 (unbox sc1))) (lambda (eta-0) (vector 1 (box (cons e-0 e-1)))))))))(else (let ((sc0 (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)))) (if (null? sc0) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox sc0))) (CoreC-45Context-lookupContextEntry (vector 8 e-1) arg-1))))))))
(define CoreC-45Context-lazyActive (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-42 (vector-ref e-34 1))) (let ((e-43 (vector-ref e-34 2))) (let ((e-44 (vector-ref e-34 3))) (let ((e-45 (vector-ref e-34 4))) (let ((e-46 (vector-ref e-34 5))) (let ((e-47 (vector-ref e-34 6))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 (vector arg-1 e-42 e-43 e-44 e-45 e-46 e-47) e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-isVisible (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CoreC-45Context-n--21909-15636-u--visible arg-1 arg-0 eta-0)) (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45NameC-45Namespace-allParents (let ((e-2 (vector-ref e-5 2))) e-2)) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-3 (vector-ref e-5 3))) e-3) (let ((e-0 (vector-ref e-5 0))) (let ((e-35 (vector-ref e-0 7))) e-35))))))))))))
(define CoreC-45Context-isUnboundImplicits (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-38 (vector-ref e-4 3))) (let ((e-47 (vector-ref e-38 1))) e-47))))))))))
(define CoreC-45Context-isPrimName (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-splitNS arg-1))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (CoreC-45Context-n--24946-18553-u--go arg-1 arg-0 e-2 e-3 arg-0))))))
(define CoreC-45Context-isPrefixRecordProjections (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-38 (vector-ref e-4 3))) (let ((e-42 (vector-ref e-38 6))) e-42)))))))) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0)))
(define CoreC-45Context-isPairType (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 4))) (if (null? e-37) (vector 1 0) (let ((e-42 (unbox e-37))) (let ((act-25 (CoreC-45Context-getFullName arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-43 (vector-ref act-25 1))) (vector 0 e-43))) (else (let ((e-43 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getFullName arg-0 (let ((e-46 (vector-ref e-42 0))) e-46) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-44 (vector-ref act-26 1))) (vector 0 e-44))) (else (let ((e-44 (vector-ref act-26 1))) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-43 e-44))))))))))))))))))))
(define CoreC-45Context-isLazyActive (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-38 (vector-ref e-4 3))) (let ((e-48 (vector-ref e-38 0))) e-48))))))))))
(define CoreC-45Context-isHidden (lambda (arg-0 arg-1) (DataC-45Maybe-isJust (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-10 (vector-ref arg-1 10))) e-10)))))
(define CoreC-45Context-isExtension (lambda (arg-0 arg-1) (CoreC-45Options-isExtension arg-0 (let ((e-4 (vector-ref arg-1 4))) e-4))))
(define CoreC-45Context-isEqualTy (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-4 (vector-ref e-5 4))) (let ((e-36 (vector-ref e-4 5))) (if (null? e-36) (vector 1 0) (let ((e-42 (unbox e-36))) (let ((act-25 (CoreC-45Context-getFullName arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-43 (vector-ref act-25 1))) (vector 0 e-43))) (else (let ((e-43 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getFullName arg-0 (let ((e-45 (car e-42))) e-45) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-44 (vector-ref act-26 1))) (vector 0 e-44))) (else (let ((e-44 (vector-ref act-26 1))) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-43 e-44))))))))))))))))))))
(define CoreC-45Context-isAllPublic (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-0 (vector-ref e-5 0))) (let ((e-34 (vector-ref e-0 8))) e-34)))))))))
(define CoreC-45Context-initSize(blodwen-lazy (lambda () (blodwen-toSignedInt 10000 63))))
(define CoreC-45Context-initHash (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 (blodwen-toSignedInt 5381 63) e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-initDefs (lambda (ext-0) (let ((act-24 (CoreC-45Context-initCtxt ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Options-defaults ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector e-5 '() (CoreC-45NameC-45Namespace-mainNS) '() e-6 (LibrariesC-45DataC-45NameMap-empty) (blodwen-toSignedInt 100 63) (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-empty) '() '() (LibrariesC-45DataC-45NameMap-empty) '() (LibrariesC-45DataC-45NameMap-empty) (blodwen-toSignedInt 5381 63) '() '() '() '() '() '() '() (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45StringMap-empty) '() '() 0))))))))))))
(define CoreC-45Context-initCtxtS (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 ((LibrariesC-45DataC-45IOArray-newArray (csegen-3) arg-0) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Core.Context.Context.Arr" ) e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 0 (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45UserNameMap-empty) e-6 0 (LibrariesC-45DataC-45IntMap-empty) (cons (CoreC-45NameC-45Namespace-partialEvalNS) '()) 0 0 (LibrariesC-45DataC-45NameMap-empty)))))))))))))
(define CoreC-45Context-initCtxt (lambda (ext-0) (CoreC-45Context-initCtxtS (CoreC-45Context-initSize) ext-0)))
(define CoreC-45Context-inCurrentNS (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 (let ((e-2 (vector-ref e-5 2))) e-2) (vector 1 e-0))))))))) ((6) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 (let ((e-32 (vector-ref e-5 2))) e-32) arg-1))))))) ((7) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 (let ((e-2 (vector-ref e-5 2))) e-2) arg-1))))))) ((5) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (vector 0 (let ((e-2 (vector-ref e-7 2))) e-2) arg-1))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 (let ((e-2 (vector-ref e-5 2))) e-2) arg-1))))))) ((4) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 (let ((e-2 (vector-ref e-5 2))) e-2) arg-1)))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-hideName (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 (LibrariesC-45DataC-45NameMap-insert arg-0 0 e-10)))))))))))))))
(define CoreC-45Context-hide (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) ext-0) (let ((e-8 (car e-1))) (if (null? e-2) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-36 (vector-ref e-5 1))) (let ((e-35 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-34 (vector-ref e-5 5))) (let ((e-33 (vector-ref e-5 6))) (let ((e-32 (vector-ref e-5 7))) (let ((e-31 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector (CoreC-45Context-hideName e-8 e-0) e-36 e-35 e-3 e-4 e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) ext-0)))))))))))))))))
(define CoreC-45Context-getWorkingDir (lambda (ext-0) (let ((act-24 (let ((act-24 ((csegen-878) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") ext-0) (let ((e-1 (unbox e-5))) (vector 1 e-1)))))))))
(define CoreC-45Context-getUserHoles (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--hs (DataC-45List-sort (csegen-883) (LibrariesC-45DataC-45NameMap-keys (let ((e-25 (vector-ref e-5 25))) e-25))))) (CoreC-45Core-filterM (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-n--15520-9863-u--isHole arg-0 e-5 eta-0 eta-1))) u--hs ext-0))))))))
(define CoreC-45Context-getTotality (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (vector 1 (let ((e-10 (vector-ref e-1 10))) e-10))))))))))))))
(define CoreC-45Context-getTime (lambda (ext-0) (let ((act-24 (let ((act-24 (SystemC-45Clock-clockTime 1 ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (+ (* (SystemC-45Clock-seconds e-5) (CoreC-45Context-n--25792-19362-u--nano)) (SystemC-45Clock-nanoseconds e-5)))))))))
(define CoreC-45Context-getSimilarNames (lambda (arg-0 arg-1) (CoreC-45Context-case--getSimilarNames-9009 arg-1 arg-0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (CoreC-45Name-u--show_Show_UserName eta-0)) (CoreC-45Name-userNameRoot arg-1)))))
(define CoreC-45Context-getSession (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-39 (vector-ref e-4 2))) e-39)))))))))
(define CoreC-45Context-getSearchData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 ext-0) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((6) (let ((e-11 (vector-ref e-1 4))) (let ((e-10 (vector-ref e-1 5))) (let ((act-26 (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (let ((sc5 (LibrariesC-45DataC-45NameMap-lookup e-12 (let ((e-36 (vector-ref e-5 7))) e-36)))) (if (null? sc5) (vector 1 '()) (let ((e-13 (unbox sc5))) (CoreC-45Core-filterM (lambda (u--x) (lambda (eta-0) (CoreC-45Context-n--18379-12430-u--notHidden arg-3 arg-2 arg-1 arg-0 u--x (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) e-13 ext-0)))))))))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (cond ((equal? arg-2 1) (let ((act-27 (CoreC-45Core-filterM (lambda (u--x) (lambda (eta-0) (let ((act-27 (CoreC-45Context-n--18379-12430-u--notHidden arg-3 arg-2 arg-1 arg-0 u--x (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (vector 1 (let ((sc7 (CoreC-45Context-n--18379-12431-u--isDefault arg-3 arg-2 arg-1 arg-0 u--x))) (cond ((equal? sc7 1) e-13) (else 0)))))))))) (LibrariesC-45DataC-45NameMap-toList (let ((e-35 (vector-ref e-5 8))) e-35)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((u--defns (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-13))) (vector 1 (cons '() (cons (cons 0 u--defns) '()))))))))) (else (let ((act-27 (CoreC-45Core-filterM (lambda (u--x) (lambda (eta-0) (CoreC-45Context-n--18379-12430-u--notHidden arg-3 arg-2 arg-1 arg-0 u--x (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (LibrariesC-45DataC-45NameMap-toList (let ((e-34 (vector-ref e-5 9))) e-34)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((u--opens (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-13))) (let ((act-28 (CoreC-45Core-filterM (lambda (u--x) (lambda (eta-0) (let ((act-28 (CoreC-45Context-n--18379-12430-u--notHidden arg-3 arg-2 arg-1 arg-0 u--x (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (let ((sc8 (CoreC-45Context-n--18379-12431-u--isDefault arg-3 arg-2 arg-1 arg-0 u--x))) (cond ((equal? sc8 1) 0) (else e-14)))))))))) (LibrariesC-45DataC-45NameMap-toList (let ((e-36 (vector-ref e-5 8))) e-36)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (let ((u--autos (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-14))) (let ((u--tyhs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (DataC-45List-filter (lambda (eta-0) (CoreC-45Context-n--18379-12432-u--direct arg-3 arg-2 arg-1 arg-0 eta-0)) e-12)))) (let ((u--chasers (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (DataC-45List-filter (lambda (eta-0) (let ((sc8 (CoreC-45Context-n--18379-12432-u--direct arg-3 arg-2 arg-1 arg-0 eta-0))) (cond ((equal? sc8 1) 0) (else 1)))) e-12)))) (vector 1 (cons e-11 (DataC-45List-filter (lambda (eta-0) (DataC-45List-isCons (Builtin-snd eta-0))) (cons (cons 0 u--opens) (cons (cons 0 u--autos) (cons (cons (let ((sc8 (let ((e-0 (car e-10))) e-0))) (cond ((equal? sc8 1) 0) (else 1))) u--tyhs) (cons (cons 1 u--chasers) '()))))))))))))))))))))))))))))(else (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 ext-0)))))))))))))))
(define CoreC-45Context-getRewrite (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (box (let ((e-1 (cdr eta-0))) e-1)))) (let ((e-4 (vector-ref e-5 4))) (let ((e-36 (vector-ref e-4 5))) e-36))))))))))
(define CoreC-45Context-getPrimitiveNames (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CoreC-45Options-primNamesToList e-5)))))) (lambda (eta-0) (CoreC-45Context-getPrimNames arg-0 eta-0)) ext-0)))
(define CoreC-45Context-getPrimNames (lambda (arg-0 ext-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-893) (lambda (eta-3) (CoreC-45Context-fromIntegerName arg-0 eta-3)) eta-2)) (lambda (eta-2) (CoreC-45Context-fromStringName arg-0 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-fromCharName arg-0 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-fromDoubleName arg-0 eta-0)) ext-0)))
(define CoreC-45Context-getPosition (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (lambda (eta-0) (vector 1 (cons e-0 arg-1)))))(else (let ((sc0 (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)))) (if (null? sc0) (CoreC-45Context-newEntry arg-0 arg-1) (let ((e-1 (unbox sc0))) (lambda (eta-0) (vector 1 (cons e-1 arg-1))))))))))
(define CoreC-45Context-getPPrint (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-40 (vector-ref e-4 1))) e-40)))))))))
(define CoreC-45Context-getNextTypeTag (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 (bs+ e-6 1 63) e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (let ((e-31 (vector-ref e-5 6))) e-31)))))))))))
(define CoreC-45Context-getNextEntry (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-0 (vector-ref e-5 0))) (let ((e-41 (vector-ref e-0 1))) e-41)))))))))
(define CoreC-45Context-getNestedNS (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-3 (vector-ref e-5 3))) e-3))))))))
(define CoreC-45Context-getNameID (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2))))))
(define CoreC-45Context-getNS (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2))))))))
(define CoreC-45Context-getFullName (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 e-0) (let ((e-32 (vector-ref e-5 0))) e-32)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 8 e-0)) (let ((e-1 (unbox e-6))) (vector 1 (let ((e-24 (vector-ref e-1 1))) e-24))))))))))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-getFnName (lambda (arg-0) (let ((e-3 (vector-ref arg-0 3))) (let ((sc0 (CoreC-45TT-getFn e-3))) (case (vector-ref sc0 0) ((1) (let ((e-5 (vector-ref sc0 3))) (box e-5)))(else '()))))))
(define CoreC-45Context-getFieldNames (lambda (arg-0 arg-1) (let ((u--nms (let ((e-2 (vector-ref arg-0 2))) e-2))) (LibrariesC-45DataC-45NameMap-keys (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45NameMap-filterBy eta-0 eta-1))) u--nms (lambda (u--n) (let ((sc0 (CoreC-45Name-isRF u--n))) (if (null? sc0) 0 (let ((e-2 (unbox sc0))) (let ((e-5 (car e-2))) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-5 arg-1)))))))))))
(define CoreC-45Context-getDirs (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 0))) e-41)))))))))
(define CoreC-45Context-getDirectives (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (let ((e-4 (vector-ref e-5 4))) (let ((e-39 (vector-ref e-4 2))) (let ((e-60 (vector-ref e-39 5))) e-60))) (DataC-45List-mapMaybe (lambda (eta-0) (CoreC-45Context-n--21223-14989-u--getDir arg-1 arg-0 eta-0)) (let ((e-20 (vector-ref e-5 20))) e-20))))))))))
(define CoreC-45Context-getDefaultTotalityOption (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-38 (vector-ref e-4 3))) (let ((e-46 (vector-ref e-38 2))) e-46))))))))))
(define CoreC-45Context-getContent (lambda (ext-0) (let ((e-4 (vector-ref ext-0 4))) e-4)))
(define CoreC-45Context-getAutoImplicitLimit (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-38 (vector-ref e-4 3))) (let ((e-44 (vector-ref e-38 4))) e-44))))))))))
(define CoreC-45Context-getAmbigLimit (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-38 (vector-ref e-4 3))) (let ((e-45 (vector-ref e-38 3))) e-45))))))))))
(define CoreC-45Context-fstName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (box (let ((e-1 (vector-ref eta-0 1))) e-1)))) (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 4))) e-37))))))))))
(define CoreC-45Context-fromStringName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-4 6))) (let ((e-44 (vector-ref e-35 1))) e-44))))))))))
(define CoreC-45Context-fromIntegerName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-4 6))) (let ((e-45 (vector-ref e-35 0))) e-45))))))))))
(define CoreC-45Context-fromDoubleName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-4 6))) (let ((e-42 (vector-ref e-35 3))) e-42))))))))))
(define CoreC-45Context-fromCharName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-4 6))) (let ((e-43 (vector-ref e-35 2))) e-43))))))))))
(define CoreC-45Context-extendNS (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 (CoreC-45NameC-45Namespace-C-60C-46C-62 e-2 arg-1) e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-dropMutData (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 (DataC-45List-filter (lambda (arg-2) (CoreC-45Name-u--C-47C-61_Eq_Name arg-2 arg-1)) e-1) e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-commitCtxt (lambda (arg-0) (CoreC-45Context-case--commitCtxt-3887 arg-0 (let ((e-5 (vector-ref arg-0 5))) e-5))))
(define CoreC-45Context-commit (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-commitCtxt (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Context-setCtxt arg-0 e-6 ext-0)))))))))))
(define CoreC-45Context-clearUserHole (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 (LibrariesC-45DataC-45NameMap-delete arg-1 e-25) e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-clearTimer (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 '() e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-clearSavedHints (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 '() '() e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-clearDefs (lambda (arg-0 ext-0) (vector 1 (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (let ((e-10 (vector-ref arg-0 10))) (let ((e-11 (vector-ref arg-0 11))) (let ((e-12 (vector-ref arg-0 12))) (let ((e-13 (vector-ref arg-0 13))) (let ((e-14 (vector-ref arg-0 14))) (let ((e-15 (vector-ref arg-0 15))) (let ((e-16 (vector-ref arg-0 16))) (let ((e-17 (vector-ref arg-0 17))) (let ((e-18 (vector-ref arg-0 18))) (let ((e-19 (vector-ref arg-0 19))) (let ((e-20 (vector-ref arg-0 20))) (let ((e-21 (vector-ref arg-0 21))) (let ((e-22 (vector-ref arg-0 22))) (let ((e-23 (vector-ref arg-0 23))) (let ((e-24 (vector-ref arg-0 24))) (let ((e-25 (vector-ref arg-0 25))) (let ((e-26 (vector-ref arg-0 26))) (let ((e-27 (vector-ref arg-0 27))) (let ((e-28 (vector-ref arg-0 28))) (let ((e-29 (vector-ref arg-0 29))) (let ((e-30 (vector-ref arg-0 30))) (let ((e-31 (vector-ref e-0 0))) (let ((e-32 (vector-ref e-0 1))) (let ((e-33 (vector-ref e-0 2))) (let ((e-34 (vector-ref e-0 3))) (let ((e-35 (vector-ref e-0 4))) (let ((e-36 (vector-ref e-0 5))) (let ((e-37 (vector-ref e-0 6))) (let ((e-38 (vector-ref e-0 7))) (let ((e-39 (vector-ref e-0 8))) (let ((e-41 (vector-ref e-0 10))) (vector (vector e-31 e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 1 e-41) e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Context-clearCtxt (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-initDefs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-32 (vector-ref e-6 5))) (let ((e-31 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Context-n--14387-8830-u--resetElab arg-0 (let ((e-59 (vector-ref e-5 4))) e-59)) e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 (let ((e-36 (vector-ref e-5 27))) e-36) e-28 e-29 e-30))))))))))))))))))))))))))))))))) (vector 1 act-26))))))))))))
(define CoreC-45Context-checkUnambig (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (if (null? e-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) ext-0) (let ((e-7 (cdr e-2))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) ext-0) (let ((e-10 (car e-7))) (if (null? e-3) (vector 1 (vector 8 e-10)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) ext-0)))))))))))))))))))
(define CoreC-45Context-checkTimer (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Context-case--checkTimer-19528 arg-0 e-5 (let ((e-28 (vector-ref e-5 28))) e-28)) ext-0)))))))
(define CoreC-45Context-branchCtxt (lambda (arg-0 ext-0) (vector 1 (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (let ((e-10 (vector-ref arg-0 10))) (vector e-0 e-1 e-2 e-3 e-4 (+ 1 e-5) e-6 e-7 e-8 e-9 e-10)))))))))))))))
(define CoreC-45Context-branch (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-branchCtxt (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-setCtxt arg-0 e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 e-5))))))))))))))
(define CoreC-45Context-allNames (lambda (arg-0 ext-0) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 8 eta-0)) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (csegen-219) 1 (bs- (let ((e-1 (vector-ref arg-0 1))) e-1) 1 63))) '() ext-0)))
(define CoreC-45Context-aliasName (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Context-case--aliasName-9559 arg-1 arg-0 e-5 (CoreC-45Name-userNameRoot arg-1)) ext-0)))))))
(define CoreC-45Context-addUserHole (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 (LibrariesC-45DataC-45NameMap-insert arg-2 arg-1 e-25) e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-addTransform (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-case--addTransform-14341 arg-2 arg-1 arg-0 e-5 (CoreC-45Context-getFnName arg-2) ext-0)))))))
(define CoreC-45Context-addToSave (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref e-5 0))) e-0) arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 (LibrariesC-45DataC-45NameMap-insert e-6 0 e-32) e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 (LibrariesC-45DataC-45NameMap-insert e-6 0 e-24) e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26))))))))))))
(define CoreC-45Context-addPossible (lambda (arg-0 arg-1 arg-2) (CoreC-45Context-case--addPossible-2433 arg-2 arg-1 arg-0 (CoreC-45Name-userNameRoot arg-0))))
(define CoreC-45Context-addPackageDir (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-51 (vector-ref e-41 0))) (let ((e-42 (vector-ref e-41 1))) (let ((e-43 (vector-ref e-41 2))) (let ((e-44 (vector-ref e-41 3))) (let ((e-45 (vector-ref e-41 4))) (let ((e-46 (vector-ref e-41 5))) (let ((e-47 (vector-ref e-41 6))) (let ((e-48 (vector-ref e-41 7))) (let ((e-49 (vector-ref e-41 8))) (let ((e-50 (vector-ref e-41 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-51 e-42 e-43 e-44 e-45 e-46 e-47 (PreludeC-45TypesC-45List-tailRecAppend e-48 (cons arg-1 '())) e-49 e-50) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-addOpenHint (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 e-7 e-8 (LibrariesC-45DataC-45NameMap-insert e-6 0 e-9) e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26))))))))))))
(define CoreC-45Context-addNameDirective (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 (LibrariesC-45DataC-45NameMap-insert e-6 arg-3 e-15) e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26))))))))))))
(define CoreC-45Context-addName (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (vector 1 e-0)))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-newEntry arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-26 (CoreC-45Context-setCtxt arg-0 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))))))))))))
(define CoreC-45Context-addMutData (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 (cons arg-1 e-1) e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-addLogLevel (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? arg-1) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-65 (vector-ref e-33 0))) (let ((e-42 (vector-ref e-33 1))) (let ((e-43 (vector-ref e-33 2))) (let ((e-44 (vector-ref e-33 3))) (let ((e-45 (vector-ref e-33 4))) (let ((e-46 (vector-ref e-33 5))) (let ((e-47 (vector-ref e-33 6))) (let ((e-48 (vector-ref e-33 7))) (let ((e-51 (vector-ref e-33 10))) (let ((e-52 (vector-ref e-33 11))) (let ((e-53 (vector-ref e-33 12))) (let ((e-54 (vector-ref e-33 13))) (let ((e-55 (vector-ref e-33 14))) (let ((e-56 (vector-ref e-33 15))) (let ((e-57 (vector-ref e-33 16))) (let ((e-58 (vector-ref e-33 17))) (let ((e-59 (vector-ref e-33 18))) (let ((e-60 (vector-ref e-33 19))) (let ((e-61 (vector-ref e-33 20))) (let ((e-62 (vector-ref e-33 21))) (let ((e-63 (vector-ref e-33 22))) (let ((e-64 (vector-ref e-33 23))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 (vector e-65 e-42 e-43 e-44 e-45 e-46 e-47 e-48 1 (CoreC-45OptionsC-45Log-defaultLogLevel) e-51 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64) e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25)) (let ((e-2 (unbox arg-1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-32 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-42 (vector-ref e-4 0))) (let ((e-41 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-66 (vector-ref e-33 0))) (let ((e-65 (vector-ref e-33 1))) (let ((e-43 (vector-ref e-33 2))) (let ((e-44 (vector-ref e-33 3))) (let ((e-45 (vector-ref e-33 4))) (let ((e-46 (vector-ref e-33 5))) (let ((e-47 (vector-ref e-33 6))) (let ((e-48 (vector-ref e-33 7))) (let ((e-50 (vector-ref e-33 9))) (let ((e-51 (vector-ref e-33 10))) (let ((e-52 (vector-ref e-33 11))) (let ((e-53 (vector-ref e-33 12))) (let ((e-54 (vector-ref e-33 13))) (let ((e-55 (vector-ref e-33 14))) (let ((e-56 (vector-ref e-33 15))) (let ((e-57 (vector-ref e-33 16))) (let ((e-58 (vector-ref e-33 17))) (let ((e-59 (vector-ref e-33 18))) (let ((e-60 (vector-ref e-33 19))) (let ((e-61 (vector-ref e-33 20))) (let ((e-62 (vector-ref e-33 21))) (let ((e-63 (vector-ref e-33 22))) (let ((e-64 (vector-ref e-33 23))) (vector e-0 e-1 e-32 e-3 (vector e-42 e-41 (vector e-66 e-65 e-43 e-44 e-45 e-46 e-47 e-48 1 (CoreC-45OptionsC-45Log-insertLogLevel e-2 e-50) e-51 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64) e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))))
(define CoreC-45Context-addLocalHint (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 e-7 e-8 e-9 (LibrariesC-45DataC-45NameMap-insert e-6 0 e-10) e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26))))))))))))
(define CoreC-45Context-addLibDir (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-51 (vector-ref e-41 0))) (let ((e-42 (vector-ref e-41 1))) (let ((e-43 (vector-ref e-41 2))) (let ((e-44 (vector-ref e-41 3))) (let ((e-45 (vector-ref e-41 4))) (let ((e-46 (vector-ref e-41 5))) (let ((e-47 (vector-ref e-41 6))) (let ((e-48 (vector-ref e-41 7))) (let ((e-49 (vector-ref e-41 8))) (let ((e-50 (vector-ref e-41 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-51 e-42 e-43 e-44 e-45 e-46 e-47 e-48 (PreludeC-45TypesC-45List-tailRecAppend e-49 (cons arg-1 '())) e-50) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-addImportedInc (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--cg (let ((e-4 (vector-ref e-5 4))) e-4))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (PreludeC-45Types-elem (csegen-898) u--cg (let ((e-21 (vector-ref e-5 21))) e-21)))) (cond ((equal? sc2 1) (((let ((sc3 (DataC-45List-lookup (csegen-898) u--cg arg-2))) (if (null? sc3) (lambda () (lambda (eta-0) (let ((act-26 (CoreC-45Context-recordWarning arg-0 (vector 4 (PreludeC-45TypesC-45String-C-43C-43 "No incremental compile data for " (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (set-box! arg-0 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-34 (vector-ref e-8 5))) (let ((e-33 (vector-ref e-8 6))) (let ((e-32 (vector-ref e-8 7))) (let ((e-31 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 (CoreC-45Context-n--26034-19595-u--drop arg-2 arg-1 arg-0 u--cg e-23) e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-28))))))))))) (let ((e-2 (unbox sc3))) (let ((e-8 (car e-2))) (let ((e-7 (cdr e-2))) (lambda () (lambda (eta-0) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-35 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-32 (vector-ref e-6 7))) (let ((e-31 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-0 e-1 e-35 e-3 e-4 e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 (CoreC-45Context-n--26034-19594-u--addMod arg-2 arg-1 arg-0 u--cg (cons e-8 e-7) e-23) e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26)))))))))) ext-0)) (else (vector 1 0)))))))))))))))
(define CoreC-45Context-addImported (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (cons arg-1 e-18) e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-addHintFor (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) arg-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--hs (let ((sc3 (LibrariesC-45DataC-45NameMap-lookup e-6 (let ((e-31 (vector-ref e-5 7))) e-31)))) (if (null? sc3) '() (let ((e-1 (unbox sc3))) e-1))))) (cond ((equal? arg-5 1) (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-32 (vector-ref e-5 6))) (let ((e-31 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-32 (LibrariesC-45DataC-45NameMap-insert e-6 (cons (cons e-7 arg-4) u--hs) e-31) e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-27))) (else (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-32 (vector-ref e-5 6))) (let ((e-31 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-32 (LibrariesC-45DataC-45NameMap-insert e-6 (cons (cons e-7 arg-4) u--hs) e-31) e-8 e-9 e-10 (cons (cons e-6 (cons e-7 arg-4)) e-11) e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-27)))))))))))))))))))
(define CoreC-45Context-addHashWithNames (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-toFullNames arg-1 arg-3 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-addHash arg-1 arg-2 e-5 ext-0)))))))
(define CoreC-45Context-addHash (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 (let ((e-32 (cdr arg-2))) ((e-32 (let ((e-48 (vector-ref e-5 16))) e-48)) arg-3)) e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-addGlobalHint (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 e-7 (LibrariesC-45DataC-45NameMap-insert e-6 arg-2 e-8) e-9 e-10 e-11 (cons (cons e-6 arg-2) e-12) e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26))))))))))))
(define CoreC-45Context-addExtraDir (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-51 (vector-ref e-41 0))) (let ((e-42 (vector-ref e-41 1))) (let ((e-43 (vector-ref e-41 2))) (let ((e-44 (vector-ref e-41 3))) (let ((e-45 (vector-ref e-41 4))) (let ((e-46 (vector-ref e-41 5))) (let ((e-47 (vector-ref e-41 6))) (let ((e-48 (vector-ref e-41 7))) (let ((e-49 (vector-ref e-41 8))) (let ((e-50 (vector-ref e-41 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-51 e-42 e-43 e-44 e-45 e-46 (PreludeC-45TypesC-45List-tailRecAppend e-47 (cons arg-1 '())) e-48 e-49 e-50) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-addEntry (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_Nat (let ((e-5 (vector-ref arg-2 5))) e-5) 0))) (cond ((equal? sc0 1) (let ((act-24 ((CoreC-45Context-getPosition arg-0 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((u--a (let ((e-4 (vector-ref e-3 4))) e-4))) (let ((act-25 (let ((act-25 (unbox u--a))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((LibrariesC-45DataC-45IOArray-writeArray (csegen-3) e-6 e-2 arg-1) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (cons e-2 e-3))))))))))))))))) (else (let ((act-24 ((CoreC-45Context-getPosition arg-0 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-2 (let ((e-0 (vector-ref e-3 0))) (let ((e-1 (vector-ref e-3 1))) (let ((e-13 (vector-ref e-3 2))) (let ((e-12 (vector-ref e-3 3))) (let ((e-4 (vector-ref e-3 4))) (let ((e-11 (vector-ref e-3 5))) (let ((e-6 (vector-ref e-3 6))) (let ((e-7 (vector-ref e-3 7))) (let ((e-8 (vector-ref e-3 8))) (let ((e-9 (vector-ref e-3 9))) (let ((e-10 (vector-ref e-3 10))) (vector e-0 e-1 e-13 e-12 e-4 e-11 (LibrariesC-45DataC-45IntMap-insert e-2 arg-1 e-6) e-7 e-8 e-9 e-10)))))))))))))))))))))))))
(define CoreC-45Context-addDirective (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) arg-1))) (if (null? sc1) (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Unknown code generator " arg-1)) ext-0))) (vector 1 act-25)) (let ((e-2 (unbox sc1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-32 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-32 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 (cons (cons e-2 arg-2) e-20) e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25)))))))))))
(define CoreC-45Context-addDef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-addCtxt arg-1 arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-26 (let ((act-26 (set-box! arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-34 (vector-ref e-5 2))) (let ((e-33 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-3 e-1 e-34 e-33 e-4 e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (let ((e-17 (vector-ref arg-2 17))) (case (vector-ref e-17 0) ((0) (vector 1 0)) ((7) (vector 1 0))(else (CoreC-45Context-clearUserHole arg-0 (let ((e-47 (vector-ref arg-2 1))) e-47) ext-0)))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (vector 1 e-2)))))))))))))))))))
(define CoreC-45Context-addDataDir (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (let ((e-51 (vector-ref e-41 0))) (let ((e-42 (vector-ref e-41 1))) (let ((e-43 (vector-ref e-41 2))) (let ((e-44 (vector-ref e-41 3))) (let ((e-45 (vector-ref e-41 4))) (let ((e-46 (vector-ref e-41 5))) (let ((e-47 (vector-ref e-41 6))) (let ((e-48 (vector-ref e-41 7))) (let ((e-49 (vector-ref e-41 8))) (let ((e-50 (vector-ref e-41 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-51 e-42 e-43 e-44 e-45 e-46 e-47 e-48 e-49 (PreludeC-45TypesC-45List-tailRecAppend e-50 (cons arg-1 '()))) e-32 e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Context-addCtxt (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_Nat (let ((e-5 (vector-ref arg-2 5))) e-5) 0))) (cond ((equal? sc0 1) (let ((act-24 ((CoreC-45Context-getPosition arg-0 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((u--a (let ((e-4 (vector-ref e-3 4))) e-4))) (let ((act-25 (let ((act-25 (unbox u--a))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((LibrariesC-45DataC-45IOArray-writeArray (csegen-3) e-6 e-2 (vector 1 arg-1)) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (cons e-2 e-3))))))))))))))))) (else (let ((act-24 ((CoreC-45Context-getPosition arg-0 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-2 (let ((e-0 (vector-ref e-3 0))) (let ((e-1 (vector-ref e-3 1))) (let ((e-13 (vector-ref e-3 2))) (let ((e-12 (vector-ref e-3 3))) (let ((e-4 (vector-ref e-3 4))) (let ((e-11 (vector-ref e-3 5))) (let ((e-6 (vector-ref e-3 6))) (let ((e-7 (vector-ref e-3 7))) (let ((e-8 (vector-ref e-3 8))) (let ((e-9 (vector-ref e-3 9))) (let ((e-10 (vector-ref e-3 10))) (vector e-0 e-1 e-13 e-12 e-4 e-11 (LibrariesC-45DataC-45IntMap-insert e-2 (vector 1 arg-1) e-6) e-7 e-8 e-9 e-10)))))))))))))))))))))))))
(define CoreC-45Context-addContextEntry (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-addEntry arg-2 (vector 0 arg-1 arg-3) (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-26 (let ((act-26 (set-box! arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-34 (vector-ref e-5 2))) (let ((e-33 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-3 e-1 e-34 e-33 e-4 e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))))))))))
(define CoreC-45Context-addContextAlias (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (CoreC-45Context-newAlias arg-1 arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (set-box! arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-32 (vector-ref e-5 6))) (let ((e-31 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-7 e-1 e-2 e-3 e-4 e-33 e-32 e-31 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-27)))))) (vector 1 0))))))))))))
(define CoreC-45Context-addBuiltin (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-1 arg-2 (vector (CoreC-45FC-emptyFC) arg-2 arg-3 '() '() '() '() (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) '() 2 arg-4 (cons (vector 0 ) '()) '() '() 0 0 1 (vector 4 arg-0 arg-5) '() '() '() '()) eta-0)) ext-0)))
(define CoreC-45Context-addAlias (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45Context-case--addAlias-2494 arg-3 arg-2 arg-1 arg-0 (CoreC-45Name-userNameRoot arg-0))))
(define CoreC-45Context-Grow(blodwen-lazy (lambda () (CoreC-45Context-initSize))))
(define SystemC-45Clock-with--clockTime-4296 (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (let ((act-24 (SystemC-45Clock-fetchOSClock arg-0 ext-0))) (SystemC-45Clock-fromOSClock arg-0 act-24 ext-0))) (else (let ((act-24 (SystemC-45Clock-fetchOSClock arg-0 ext-0))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 (blodwen-toSignedInt 1 63))) (lambda (eta-0) (SystemC-45Clock-osClockValid act-24 eta-0)) ext-0))) (cond ((equal? act-25 1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (box eta-0)) (lambda (eta-0) (SystemC-45Clock-fromOSClock arg-0 act-24 eta-0)) ext-0)) (else '()))))))))
(define SystemC-45Clock-seconds (lambda (arg-1) (let ((e-1 (vector-ref arg-1 1))) e-1)))
(define SystemC-45Clock-osClockValid (lambda (arg-0 ext-0) (SystemC-45Clock-prim__osClockValid arg-0 ext-0)))
(define SystemC-45Clock-osClockSecond (lambda (arg-0 ext-0) (SystemC-45Clock-prim__osClockSecond arg-0 ext-0)))
(define SystemC-45Clock-osClockNanosecond (lambda (arg-0 ext-0) (SystemC-45Clock-prim__osClockNanosecond arg-0 ext-0)))
(define SystemC-45Clock-nanoseconds (lambda (arg-1) (let ((e-2 (vector-ref arg-1 2))) e-2)))
(define SystemC-45Clock-isClockMandatory (lambda (arg-0) (cond ((equal? arg-0 5) 1) ((equal? arg-0 6) 1)(else 0))))
(define SystemC-45Clock-fromOSClock (lambda (arg-0 arg-1 ext-0) (let ((act-24 (SystemC-45Clock-osClockSecond arg-1 ext-0))) (let ((act-25 (SystemC-45Clock-osClockNanosecond arg-1 ext-0))) (vector arg-0 (PreludeC-45Cast-u--cast_Cast_Bits64_Integer act-24) (PreludeC-45Cast-u--cast_Cast_Bits64_Integer act-25))))))
(define SystemC-45Clock-fetchOSClock (lambda (arg-0 ext-0) (cond ((equal? arg-0 0) (SystemC-45Clock-clockTimeUtc ext-0)) ((equal? arg-0 1) (SystemC-45Clock-clockTimeMonotonic ext-0)) ((equal? arg-0 3) (SystemC-45Clock-clockTimeProcess ext-0)) ((equal? arg-0 4) (SystemC-45Clock-clockTimeThread ext-0)) ((equal? arg-0 5) (SystemC-45Clock-clockTimeGcCpu ext-0)) ((equal? arg-0 6) (SystemC-45Clock-clockTimeGcReal ext-0)) (else (SystemC-45Clock-clockTimeMonotonic ext-0)))))
(define SystemC-45Clock-clockTimeUtc (lambda (ext-0) (SystemC-45Clock-prim__clockTimeUtc ext-0)))
(define SystemC-45Clock-clockTimeThread (lambda (ext-0) (SystemC-45Clock-prim__clockTimeThread ext-0)))
(define SystemC-45Clock-clockTimeProcess (lambda (ext-0) (SystemC-45Clock-prim__clockTimeProcess ext-0)))
(define SystemC-45Clock-clockTimeMonotonic (lambda (ext-0) (SystemC-45Clock-prim__clockTimeMonotonic ext-0)))
(define SystemC-45Clock-clockTimeGcReal (lambda (ext-0) (SystemC-45Clock-prim__clockTimeGcReal ext-0)))
(define SystemC-45Clock-clockTimeGcCpu (lambda (ext-0) (SystemC-45Clock-prim__clockTimeGcCpu ext-0)))
(define SystemC-45Clock-clockTime (lambda (arg-0 ext-0) (SystemC-45Clock-with--clockTime-4296 arg-0 (SystemC-45Clock-isClockMandatory arg-0) ext-0)))
(define LibrariesC-45TextC-45DistanceC-45Levenshtein-compute (lambda (arg-1 arg-2 arg-3) (let ((u--w (DataC-45String-strLength arg-2))) (let ((u--h (DataC-45String-strLength arg-3))) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45IOMatrix-new arg-1 (bs+ u--w 1 63) (bs+ u--h 1 63))) (lambda (u--mat) (PreludeC-45Interfaces-C-62C-62 (let ((e-7 (car arg-1))) e-7) (PreludeC-45Interfaces-for_ (cons (csegen-51) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) e-10))) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (csegen-219) 0 u--w) (lambda (u--i) (LibrariesC-45DataC-45IOMatrix-write arg-1 u--mat u--i 0 u--i))) (lambda () (PreludeC-45Interfaces-C-62C-62 (let ((e-7 (car arg-1))) e-7) (PreludeC-45Interfaces-for_ (cons (csegen-51) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) e-10))) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (csegen-219) 0 u--h) (lambda (u--j) (LibrariesC-45DataC-45IOMatrix-write arg-1 u--mat 0 u--j u--j))) (let ((u--get (lambda (u--i) (lambda (u--j) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (LibrariesC-45DataC-45IOMatrix-read arg-1 u--mat u--i u--j)) (lambda (bind-0) (if (null? bind-0) (Builtin-idris_crash "INTERNAL ERROR: Badly initialised matrix") (let ((e-11 (unbox bind-0))) (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) e-11)))))))))))))) (lambda () (PreludeC-45Interfaces-C-62C-62 (let ((e-7 (car arg-1))) e-7) (PreludeC-45Interfaces-for_ (cons (csegen-51) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) e-10))) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (csegen-219) 1 u--h) (lambda (u--j) (PreludeC-45Interfaces-for_ (cons (csegen-51) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) e-10))) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (csegen-219) 1 u--w) (lambda (u--i) (let ((u--cost (let ((u--c (DataC-45String-strIndex arg-2 (bs- u--i 1 63)))) (let ((u--d (DataC-45String-strIndex arg-3 (bs- u--j 1 63)))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--c u--d))) (cond ((equal? sc1 1) (blodwen-toSignedInt 0 63)) (else (let ((sc2 (let ((sc3 (PreludeC-45Types-isAlpha u--c))) (cond ((equal? sc3 1) (PreludeC-45Types-isAlpha u--d)) (else 0))))) (cond ((equal? sc2 1) (blodwen-toSignedInt 1 63)) (else (let ((sc3 (let ((sc4 (PreludeC-45Types-isDigit u--c))) (cond ((equal? sc4 1) (PreludeC-45Types-isDigit u--d)) (else 0))))) (cond ((equal? sc3 1) (blodwen-toSignedInt 1 63)) (else (blodwen-toSignedInt 2 63)))))))))))))) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) ((u--get u--i) (bs- u--j 1 63))) (lambda (bind-0) (let ((e-12 (car arg-1))) (let ((e-14 (vector-ref e-12 1))) ((((e-14 'erased) 'erased) ((u--get (bs- u--i 1 63)) u--j)) (lambda (bind-1) (let ((e-17 (car arg-1))) (let ((e-19 (vector-ref e-17 1))) ((((e-19 'erased) 'erased) ((u--get (bs- u--i 1 63)) (bs- u--j 1 63))) (lambda (bind-2) (LibrariesC-45DataC-45IOMatrix-write arg-1 u--mat u--i u--j (LibrariesC-45DataC-45ListC-45Extra-minimum (csegen-224) (cons (bs+ (blodwen-toSignedInt 1 63) bind-0 63) (cons (bs+ (blodwen-toSignedInt 1 63) bind-1 63) (cons (bs+ u--cost bind-2 63) '())))))))))))))))))))))) (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-13 (vector-ref e-10 0))) e-13))) (lambda (eta-0) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer eta-0))) ((u--get u--w) u--h)))))))))))))))))
(define LibrariesC-45DataC-45ListC-45Extra-case--diffBy-2875 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--ysC-39 (PreludeC-45TypesC-45List-tailRecAppend e-2 e-7))) (if (null? e-6) (cons arg-1 (LibrariesC-45DataC-45ListC-45Extra-diffBy arg-4 arg-2 u--ysC-39)) (LibrariesC-45DataC-45ListC-45Extra-diffBy arg-4 arg-2 u--ysC-39)))))))))
(define LibrariesC-45DataC-45ListC-45Extra-case--splitAfter-2668 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (DataC-45List1-singleton e-2) (DataC-45List1-cons e-2 (LibrariesC-45DataC-45ListC-45Extra-splitAfter arg-2 e-3)))))))
(define LibrariesC-45DataC-45ListC-45Extra-splitAfter (lambda (arg-1 arg-2) (LibrariesC-45DataC-45ListC-45Extra-case--splitAfter-2668 arg-2 arg-1 (LibrariesC-45DataC-45ListC-45Extra-breakAfter arg-1 arg-2))))
(define LibrariesC-45DataC-45ListC-45Extra-sortedNub (lambda (arg-1 ext-0) (LibrariesC-45DataC-45ListC-45Extra-dedup (let ((e-1 (vector-ref arg-1 0))) e-1) (DataC-45List-sort arg-1 ext-0))))
(define LibrariesC-45DataC-45ListC-45Extra-minimum (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (let ((e-8 (vector-ref arg-1 7))) ((e-8 eta-0) eta-1)))) e-1 e-2)))))
(define LibrariesC-45DataC-45ListC-45Extra-findByC-39 (lambda (arg-1 arg-2) (if (null? arg-2) (cons '() (cons '() '())) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (cons '() (cons (box e-2) e-3))) (else (let ((sc2 (LibrariesC-45DataC-45ListC-45Extra-findByC-39 arg-1 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (cons (cons e-2 e-5) (cons e-6 e-7)))))))))))))))
(define LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (arg-2 e-2))) (if (null? sc1) (LibrariesC-45DataC-45ListC-45Extra-findBy arg-2 e-3) (let ((e-4 (unbox sc1))) (PreludeC-45Types-u--pure_Applicative_Maybe e-4)))))))))
(define LibrariesC-45DataC-45ListC-45Extra-elemAt (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? arg-2 0) (box e-2))(else (let ((e-4 (- arg-2 1))) (LibrariesC-45DataC-45ListC-45Extra-elemAt e-3 e-4)))))))))
(define LibrariesC-45DataC-45ListC-45Extra-diffBy (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45ListC-45Extra-case--diffBy-2875 e-2 e-3 arg-3 arg-1 (LibrariesC-45DataC-45ListC-45Extra-findByC-39 (arg-1 e-2) arg-3)))))))
(define LibrariesC-45DataC-45ListC-45Extra-dedup (lambda (arg-1 arg-2) (if (null? arg-2) arg-2 (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (if (null? e-2) arg-2 (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (let ((u--xs (cons e-4 e-5))) (let ((sc2 (let ((e-6 (car arg-1))) ((e-6 e-1) e-4)))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45ListC-45Extra-dedup arg-1 u--xs)) (else (cons e-1 (LibrariesC-45DataC-45ListC-45Extra-dedup arg-1 u--xs))))))))))))))
(define LibrariesC-45DataC-45ListC-45Extra-breakAfter (lambda (arg-1 arg-2) (if (null? arg-2) (cons '() '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (cons (cons e-2 '()) e-3)) (else (let ((sc2 (LibrariesC-45DataC-45ListC-45Extra-breakAfter arg-1 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons (cons e-2 e-5) e-4))))))))))))
(define LibrariesC-45DataC-45IOMatrix-write (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (let ((sc0 (LibrariesC-45DataC-45IOMatrix-toPosition arg-3 arg-4 arg-5))) (if (null? sc0) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) 0)))) (let ((e-2 (unbox sc0))) (PreludeC-45Interfaces-C-60C-36 (let ((e-1 (car arg-2))) (let ((e-6 (vector-ref e-1 0))) (let ((e-9 (vector-ref e-6 0))) e-9))) 1 (let ((e-3 (cdr arg-2))) ((e-3 'erased) (lambda (eta-0) (vector-set! (let ((e-4 (vector-ref arg-3 2))) e-4) e-2 (box arg-6)))))))))))
(define LibrariesC-45DataC-45IOMatrix-toPosition (lambda (arg-1 arg-2 arg-3) (let ((e-1 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-2 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) 1) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-3 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc2 1) 1) (else (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-2 e-1))) (cond ((equal? sc3 1) 1) (else (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-3 e-2)))))))))))) (cond ((equal? sc0 1) 0) (else 1)))) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe (bs+ (bs* arg-2 e-2 63) arg-3 63))))))))
(define LibrariesC-45DataC-45IOMatrix-read (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (LibrariesC-45DataC-45IOMatrix-toPosition arg-3 arg-4 arg-5))) (if (null? sc0) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) '())))) (let ((e-2 (unbox sc0))) (let ((e-3 (cdr arg-2))) ((e-3 'erased) (lambda (eta-0) (vector-ref (let ((e-4 (vector-ref arg-3 2))) e-4) e-2)))))))))
(define LibrariesC-45DataC-45IOMatrix-new (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (make-vector (bs* arg-3 arg-4 63) '()))))) (lambda (bind-0) (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector arg-3 arg-4 bind-0)))))))))))
(define CoreC-45BinaryC-45Prims-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32hashFileWith-5081 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (CoreC-45BinaryC-45Prims-n--8986-4986-u--err arg-0 arg-1 clam-0) (vector 1 (box (DataC-45List-last arg-6)))))))
(define CoreC-45BinaryC-45Prims-n--8215-4267-u--writeAll (lambda (arg-1 arg-2 arg-3 arg-4 arg-6 ext-0) (if (null? arg-6) (vector 1 0) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (let ((act-24 (let ((e-1 (car arg-2))) (((e-1 arg-4) e-3) ext-0)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-n--8215-4267-u--writeAll arg-1 arg-2 arg-3 arg-4 e-4 ext-0)))))))))
(define CoreC-45BinaryC-45Prims-n--8219-4292-u--readElems (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (cond ((equal? arg-6 0) (lambda (eta-0) (vector 1 (DataC-45Vect-reverse arg-5))))(else (let ((e-0 (- arg-6 1))) (lambda (eta-0) (let ((act-24 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) eta-0)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45BinaryC-45Prims-n--8219-4292-u--readElems arg-1 arg-2 arg-3 (cons e-5 arg-5) e-0) eta-0)))))))))))
(define CoreC-45BinaryC-45Prims-n--8067-4153-u--readElems (lambda (arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-4 0) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-reverse arg-3))))(else (let ((e-0 (- arg-4 1))) (lambda (eta-0) (let ((act-24 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) eta-0)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45BinaryC-45Prims-n--8067-4153-u--readElems arg-1 arg-2 (cons e-5 arg-3) e-0) eta-0)))))))))))
(define CoreC-45BinaryC-45Prims-n--8986-4987-u--osEscape (lambda (arg-0 arg-1 ext-0) (let ((sc0 (SystemC-45Info-isWindows))) (cond ((equal? sc0 1) ext-0) (else (LibrariesC-45UtilsC-45String-escapeStringUnix ext-0))))))
(define CoreC-45BinaryC-45Prims-n--8063-4118-u--length_aux (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) arg-5 (let ((e-3 (cdr arg-4))) (CoreC-45BinaryC-45Prims-n--8063-4118-u--length_aux arg-1 arg-2 arg-3 e-3 (bs+ 1 arg-5 63))))))
(define CoreC-45BinaryC-45Prims-n--8986-4986-u--err (lambda (arg-0 arg-1 ext-0) (CoreC-45Core-coreFail (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't get " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 " of " arg-1)))) ext-0)))
(define CoreC-45BinaryC-45Prims-n--8063-4119-u--TailRec_length (lambda (arg-1 arg-2 arg-3 arg-4) (CoreC-45BinaryC-45Prims-n--8063-4118-u--length_aux arg-1 arg-2 arg-3 arg-4 0)))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_WastefulInt (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-avail e-5) 8))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (DataC-45Buffer-prim__setInt (let ((e-0 (vector-ref e-5 0))) e-0) (let ((e-1 (vector-ref e-5 1))) e-1) arg-1 ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-5)))) (vector 1 act-26)))))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-extendBinary 8 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (DataC-45Buffer-prim__setInt (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-1 (vector-ref e-6 1))) e-1) arg-1 ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-6)))) (vector 1 act-27))))))))))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_String (lambda (arg-0 arg-1) (let ((u--req (DataC-45Buffer-stringByteLength arg-1))) (lambda (eta-0) (let ((act-24 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 u--req) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-avail e-6) u--req))) (cond ((equal? sc2 1) (let ((act-26 (let ((act-26 (DataC-45Buffer-prim__setString (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-1 (vector-ref e-6 1))) e-1) arg-1 eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended u--req e-6)))) (vector 1 act-27)))))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-extendBinary u--req e-6) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (DataC-45Buffer-prim__setString (let ((e-0 (vector-ref e-7 0))) e-0) (let ((e-1 (vector-ref e-7 1))) e-1) arg-1 eta-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended u--req e-7)))) (vector 1 act-28)))))))))))))))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat (lambda (arg-0 arg-1) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 (PreludeC-45Cast-u--cast_Cast_Nat_Integer arg-1) eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer (lambda (arg-0 arg-1 ext-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-1 0))) (cond ((equal? sc0 1) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-483) arg-0 (CoreC-45BinaryC-45Prims-toLimbs (- 0 arg-1)) ext-0))))) (else (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-483) arg-0 (CoreC-45BinaryC-45Prims-toLimbs arg-1) ext-0)))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int8 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (PreludeC-45Cast-u--cast_Cast_Int8_Int arg-1))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int64 (lambda (arg-0 arg-1) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 (PreludeC-45Cast-u--cast_Cast_Int64_Integer arg-1) eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int32 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (PreludeC-45Cast-u--cast_Cast_Int32_Int arg-1))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int16 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (PreludeC-45Cast-u--cast_Cast_Int16_Int arg-1))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int (lambda (arg-0 arg-1) (lambda (clam-0) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-1 (blodwen-toSignedInt -127 63)))) (cond ((equal? sc1 1) (PreludeC-45EqOrd-u--C-60_Ord_Int arg-1 (blodwen-toSignedInt 128 63))) (else 0))))) (cond ((equal? sc0 1) (CoreC-45BinaryC-45Prims-tag arg-0 (bs+ arg-1 (blodwen-toSignedInt 127 63) 63) clam-0)) (else (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 (blodwen-toSignedInt 255 63) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-avail e-6) 8))) (cond ((equal? sc3 1) (let ((act-26 (let ((act-26 (DataC-45Buffer-prim__setInt (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-1 (vector-ref e-6 1))) e-1) arg-1 clam-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-6)))) (vector 1 act-27)))))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-extendBinary 8 e-6) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (DataC-45Buffer-prim__setInt (let ((e-0 (vector-ref e-7 0))) e-0) (let ((e-1 (vector-ref e-7 1))) e-1) arg-1 clam-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-7)))) (vector 1 act-28)))))))))))))))))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Double (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-avail e-5) 8))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (DataC-45Buffer-prim__setDouble (let ((e-0 (vector-ref e-5 0))) e-0) (let ((e-1 (vector-ref e-5 1))) e-1) arg-1 ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-5)))) (vector 1 act-26)))))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-extendBinary 8 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (DataC-45Buffer-prim__setDouble (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-1 (vector-ref e-6 1))) e-1) arg-1 ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-6)))) (vector 1 act-27))))))))))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Char (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (PreludeC-45Cast-u--cast_Cast_Char_Int arg-1))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool (lambda (arg-0 arg-1) (lambda (clam-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 clam-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 1 clam-0))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits8 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (PreludeC-45Cast-u--cast_Cast_Bits8_Int arg-1))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits64 (lambda (arg-0 arg-1) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 (PreludeC-45Cast-u--cast_Cast_Bits64_Integer arg-1) eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits32 (lambda (arg-0 arg-1) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 (PreludeC-45Cast-u--cast_Cast_Bits32_Integer arg-1) eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits16 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (PreludeC-45Cast-u--cast_Cast_Bits16_Int arg-1))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Binary (lambda (arg-0 arg-1) (let ((u--len (let ((e-3 (vector-ref arg-1 3))) e-3))) (lambda (eta-0) (let ((act-24 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 u--len) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-avail e-6) u--len))) (cond ((equal? sc2 1) (let ((act-26 (let ((act-26 ((DataC-45Buffer-copyData (csegen-3) (let ((e-0 (vector-ref arg-1 0))) e-0) 0 u--len (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-1 (vector-ref e-6 1))) e-1)) eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended u--len e-6)))) (vector 1 act-27)))))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-extendBinary u--len e-6) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((DataC-45Buffer-copyData (csegen-3) (let ((e-0 (vector-ref arg-1 0))) e-0) 0 u--len (let ((e-0 (vector-ref e-7 0))) e-0) (let ((e-1 (vector-ref e-7 1))) e-1)) eta-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended u--len e-7)))) (vector 1 act-28)))))))))))))))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1 ext-0) (cond (else (vector 1 0)))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-24 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) (((e-1 arg-3) e-2) ext-0))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((sc2 (Builtin-snd arg-2))) (let ((e-1 (car sc2))) (((e-1 arg-3) e-3) ext-0))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 (lambda (arg-1 arg-2 ext-1 ext-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (Builtin-fst arg-1) arg-2 (LibrariesC-45DataC-45PosMap-u--toList_Foldable_PosMap ext-1) ext-0)))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (CoreC-45BinaryC-45Prims-tag arg-2 0 clam-0) (let ((e-2 (unbox arg-3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-2 1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-1 (car arg-1))) (((e-1 arg-2) e-2) clam-0))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-2 (CoreC-45BinaryC-45Prims-n--8063-4119-u--TailRec_length arg-1 arg-3 arg-2 arg-3)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ (lambda (clam-0) (let ((e-1 (car arg-1))) ((e-1 arg-2) clam-0))) arg-3 ext-0))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (eta-0) (CoreC-45BinaryC-45Prims-n--8215-4267-u--writeAll arg-1 arg-2 arg-4 arg-3 arg-4 eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40DPairC-32C-36aC-41C-32C-36pC-41 (lambda (arg-2 arg-3 arg-4 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-24 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) (((e-1 arg-3) e-2) ext-0))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((sc2 ((Builtin-snd arg-2) e-2))) (let ((e-1 (car sc2))) (((e-1 arg-3) e-3) ext-0))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_WastefulInt (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-toRead e-5) 8))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (DataC-45Buffer-prim__getInt (let ((e-0 (vector-ref e-5 0))) e-0) (let ((e-1 (vector-ref e-5 1))) e-1) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc 8 e-5)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 e-6))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Int " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-245) (cons (let ((e-1 (vector-ref e-5 1))) e-1) (let ((e-2 (vector-ref e-5 2))) e-2)))))) ext-0))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((sc2 (PreludeC-45EqOrd-u--C-60_Ord_Int e-5 0))) (cond ((equal? sc2 1) (CoreC-45BinaryC-45Prims-corrupt "String" ext-0)) (else (vector 1 0)))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-toRead e-6) e-5))) (cond ((equal? sc3 1) (let ((act-27 (let ((act-27 (DataC-45Buffer-prim__getString (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-1 (vector-ref e-6 1))) e-1) e-5 ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc e-5 e-6)))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 e-8))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "String length " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-5) (PreludeC-45TypesC-45String-C-43C-43 " at " (PreludeC-45Show-u--show_Show_Int (let ((e-1 (vector-ref e-6 1))) e-1))))))) ext-0)))))))))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--fromInteger_Num_Nat e-5))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-483) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (- 0 (CoreC-45BinaryC-45Prims-fromLimbs e-6)))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-483) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45BinaryC-45Prims-fromLimbs e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "Integer" ext-0)))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int8 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Int_Int8 e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int64 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Integer_Int64 e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int32 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Int_Int32 e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int16 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Int_Int16 e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 255) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-toRead e-6) 8))) (cond ((equal? sc3 1) (let ((act-26 (let ((act-26 (DataC-45Buffer-prim__getInt (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-1 (vector-ref e-6 1))) e-1) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc 8 e-6)))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-7))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Int " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-245) (cons (let ((e-1 (vector-ref e-6 1))) e-1) (let ((e-2 (vector-ref e-6 2))) e-2)))))) ext-0)))))))))(else (vector 1 (bs- e-5 (blodwen-toSignedInt 127 63) 63))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Double (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-toRead e-5) 8))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (DataC-45Buffer-prim__getDouble (let ((e-0 (vector-ref e-5 0))) e-0) (let ((e-1 (vector-ref e-5 1))) e-1) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc 8 e-5)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 e-6))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 1 "Double")) ext-0))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Char (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Int_Char e-5))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1))(else (CoreC-45BinaryC-45Prims-corrupt "Bool" ext-0)))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits8 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Int_Bits8 e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits64 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Integer_Bits64 e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits32 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Integer_Bits32 e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits16 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Cast-u--cast_Cast_Int_Bits16 e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Binary (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-toRead e-6) e-5))) (cond ((equal? sc2 1) (let ((act-26 (let ((act-26 ((DataC-45Buffer-newBuffer (csegen-3) e-5) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45BinaryC-45Prims-corrupt "Binary" ext-0) (let ((e-1 (unbox e-7))) (let ((act-27 (let ((act-27 ((DataC-45Buffer-copyData (csegen-3) (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-4 (vector-ref e-6 1))) e-4) e-5 e-1 0) ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc e-5 e-6)))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (vector e-1 0 e-5 e-5))))))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 1 "Binary")) ext-0))))))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 ext-0) (vector 1 0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 ext-0) (let ((act-24 (let ((sc0 (Builtin-fst arg-2))) (let ((e-2 (cdr sc0))) ((e-2 arg-3) ext-0))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (Builtin-snd arg-2))) (let ((e-2 (cdr sc1))) ((e-2 arg-3) ext-0))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 (lambda (arg-1 arg-2 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45PosMap-fromList (Builtin-snd arg-1) e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (Builtin-fst arg-1) arg-2 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 '())) ((equal? e-5 1) (let ((act-25 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) ext-0)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "Maybe" ext-0)))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45BinaryC-45Prims-n--8067-4153-u--readElems arg-1 arg-2 '() (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer e-5))) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (CoreC-45BinaryC-45Prims-n--8219-4292-u--readElems arg-2 arg-3 arg-1 '() arg-1)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40DPairC-32C-36aC-41C-32C-36pC-41 (lambda (arg-2 arg-3 ext-0) (let ((act-24 (let ((sc0 (Builtin-fst arg-2))) (let ((e-2 (cdr sc0))) ((e-2 arg-3) ext-0))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 ((Builtin-snd arg-2) e-5))) (let ((e-2 (cdr sc1))) ((e-2 arg-3) ext-0))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))
(define CoreC-45BinaryC-45Prims-toLimbs (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-0 0))) (cond ((equal? sc0 1) '()) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-0 -1))) (cond ((equal? sc1 1) (cons -1 '())) (else (cons (blodwen-toSignedInt (blodwen-and arg-0 4294967295) 63) (CoreC-45BinaryC-45Prims-toLimbs (blodwen-shr arg-0 32)))))))))))
(define CoreC-45BinaryC-45Prims-tag (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-avail e-5) 1))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (DataC-45Buffer-prim__setByte (let ((e-0 (vector-ref e-5 0))) e-0) (let ((e-1 (vector-ref e-5 1))) e-1) arg-1 ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 1 e-5)))) (vector 1 act-26)))))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-extendBinary 1 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (DataC-45Buffer-prim__setByte (let ((e-0 (vector-ref e-6 0))) e-0) (let ((e-1 (vector-ref e-6 1))) e-1) arg-1 ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 1 e-6)))) (vector 1 act-27))))))))))))))))))
(define CoreC-45BinaryC-45Prims-modTime (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45Handle-openFile (csegen-3) arg-0 0) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (let ((act-25 ((SystemC-45FileC-45Meta-fileModifiedTime (csegen-3) e-2) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-3 (vector-ref e-6 1))) (let ((act-26 (let ((act-26 ((SystemC-45FileC-45Handle-closeFile (csegen-3) e-2) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 e-3)))))) (else (let ((act-26 (let ((act-26 ((SystemC-45FileC-45Handle-closeFile (csegen-3) e-2) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (vector 1 0)))))))))))) (else (vector 1 0)))))))))
(define CoreC-45BinaryC-45Prims-initBinaryS (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 ((DataC-45Buffer-newBuffer (csegen-3) arg-0) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Buffer creation failed") ext-0) (let ((e-1 (unbox e-5))) (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) (LibrariesC-45UtilsC-45Binary-newBinary e-1 arg-0) ext-0)))))))))
(define CoreC-45BinaryC-45Prims-initBinary (lambda (ext-0) (let ((act-24 (let ((act-24 ((DataC-45Buffer-newBuffer (csegen-3) (LibrariesC-45UtilsC-45Binary-blockSize)) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Buffer creation failed") ext-0) (let ((e-1 (unbox e-5))) (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) (LibrariesC-45UtilsC-45Binary-newBinary e-1 (LibrariesC-45UtilsC-45Binary-blockSize)) ext-0)))))))))
(define CoreC-45BinaryC-45Prims-hashFileWith (lambda (arg-0 arg-1 ext-0) (if (null? arg-0) (vector 1 '()) (let ((e-2 (unbox arg-0))) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45Process-popen (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 " \"" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45BinaryC-45Prims-n--8986-4987-u--osEscape e-2 arg-1 arg-1) "\""))) 0) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-3 (vector-ref e-5 1))) (let ((act-25 (let ((act-25 ((SystemC-45FileC-45ReadWrite-fGetLine (csegen-3) e-3) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((_-0 (vector 1 e-3))) (case (vector-ref e-6 0) ((1) (let ((e-4 (vector-ref e-6 1))) (let ((act-26 (let ((act-26 ((SystemC-45FileC-45Process-pclose (csegen-3) e-3) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((_-1 (vector 1 e-4))) ((CoreC-45BinaryC-45Prims-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32hashFileWith-5081 e-2 arg-1 e-3 _-0 e-4 _-1 (DataC-45String-words e-4)) ext-0))))))) (else (let ((act-26 (let ((act-26 ((SystemC-45FileC-45Process-pclose (csegen-3) e-3) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45BinaryC-45Prims-n--8986-4986-u--err e-2 arg-1 ext-0))))))))))))) (else (CoreC-45BinaryC-45Prims-n--8986-4986-u--err e-2 arg-1 ext-0)))))))))))
(define CoreC-45BinaryC-45Prims-getTag (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (LibrariesC-45UtilsC-45Binary-toRead e-5) 1))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (DataC-45Buffer-prim__getByte (let ((e-0 (vector-ref e-5 0))) e-0) (let ((e-1 (vector-ref e-5 1))) e-1) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc 1 e-5)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 e-6))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 1 "Byte")) ext-0))))))))))
(define CoreC-45BinaryC-45Prims-fromLimbs (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (+ (PreludeC-45Cast-u--cast_Cast_Int_Integer e-2) (blodwen-shl (CoreC-45BinaryC-45Prims-fromLimbs e-3) 32)))))))
(define CoreC-45BinaryC-45Prims-extendBinary (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((u--newsize (bs* e-2 2 63))) (let ((u--sC-39 (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int (bs- u--newsize e-1 63) arg-0))) (cond ((equal? sc0 1) (bs+ u--newsize arg-0 63)) (else u--newsize))))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((DataC-45Buffer-resizeBuffer (csegen-3) e-0 u--sC-39) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Buffer expansion failed") eta-0) (let ((e-4 (unbox e-5))) (vector 1 (vector e-4 e-1 u--sC-39 e-3)))))))))))))))))
(define CoreC-45BinaryC-45Prims-corrupt (lambda (arg-1 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 2 arg-1)) ext-0)))
(define CoreC-45Ord-n--7479-3541-u--tag (lambda (arg-1 arg-2 arg-4) (case (vector-ref arg-4 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 5) ((6) 6) ((7) 7) ((8) 8) ((9) 9) ((10) 10) ((11) 11) ((12) 12) ((13) 13) (else 14))))
(define CoreC-45Ord-n--6049-1799-u--tag (lambda (arg-2 arg-3 arg-5) (case (vector-ref arg-5 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 5) ((6) 6) ((7) 7) ((8) 8) ((9) 9) ((10) 10) ((11) 11) ((12) 12) ((13) 13) ((14) 14) ((15) 15) ((16) 16) ((17) 17) ((18) 18) ((19) 19) ((20) 20) ((21) 21) ((22) 22) ((23) 23) ((24) 24) ((25) 25) ((26) 26) ((27) 27) ((28) 28) ((29) 29) ((30) 30) ((31) 31) ((32) 32) ((33) 33) ((34) 34) ((35) 35) ((36) 36) ((37) 37) (else 38))))
(define CoreC-45Ord-n--4904-742-u--tag (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 5) ((6) 6) ((7) 7) ((8) 8) ((9) 9) ((10) 10) ((11) 11) ((12) 12) ((13) 13) ((14) 14) ((15) 15) ((16) 16) ((17) 17) ((18) 18) ((19) 19) ((20) 20) ((21) 21) ((22) 22) ((23) 23) ((24) 24) ((25) 25) ((26) 26) (else 27))))
(define CoreC-45Ord-u--min_Ord_Constant (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Ord-u--C-60_Ord_Constant arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45Ord-u--min_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-60_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--min_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-60_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--min_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-60_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--max_Ord_Constant (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Ord-u--C-62_Ord_Constant arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45Ord-u--max_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-62_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--max_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-62_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--max_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-62_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--compare_Ord_LazyReason (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-lrTag arg-0) (CoreC-45Ord-lrTag arg-1))))
(define CoreC-45Ord-u--compare_Ord_Constant (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int e-0 e-13)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int8 e-1 e-14)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int16 e-2 e-15)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int32 e-3 e-16)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int64 e-4 e-17)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Integer e-5 e-18)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Bits8 e-6 e-19)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Bits16 e-7 e-20)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Bits32 e-8 e-21)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Bits64 e-9 e-22)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_String e-10 e-23)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Char e-11 e-24)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1)))))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Double e-12 e-25)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-0) (CoreC-45Ord-n--4904-742-u--tag arg-1 arg-0 arg-1))))))
(define CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (case (vector-ref arg-2 0) ((0) (let ((e-65 (vector-ref arg-2 1))) (PreludeC-45Types-u--compare_Ord_Nat e-2 e-65)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2)))))) ((1) (let ((e-7 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((1) (let ((e-70 (vector-ref arg-2 2))) (CoreC-45Name-u--compare_Ord_Name e-7 e-70)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2)))))) ((2) (let ((e-10 (vector-ref arg-1 2))) (let ((e-11 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((2) (let ((e-73 (vector-ref arg-2 2))) (let ((e-74 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Name-nameEq e-10 e-73))) (if (null? sc2) (CoreC-45Name-u--compare_Ord_Name e-10 e-73) (let ((e-1 (unbox sc2))) (cond (else (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-11 e-74)))))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))))) ((3) (let ((e-14 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 4))) (let ((e-17 (vector-ref arg-1 5))) (case (vector-ref arg-2 0) ((3) (let ((e-77 (vector-ref arg-2 2))) (let ((e-79 (vector-ref arg-2 4))) (let ((e-80 (vector-ref arg-2 5))) (let ((sc2 (CoreC-45Name-nameEq e-14 e-77))) (if (null? sc2) (CoreC-45Name-u--compare_Ord_Name e-14 e-77) (let ((e-1 (unbox sc2))) (cond (else (CoreC-45Ord-thenCmp (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-16 e-79) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-17 e-80))))))))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2)))))))) ((4) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-83 (vector-ref arg-2 2))) (let ((e-84 (vector-ref arg-2 3))) (CoreC-45Ord-thenCmp (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-20 e-83) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-912) e-21 e-84))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))))) ((5) (let ((e-24 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 4))) (let ((e-27 (vector-ref arg-1 5))) (case (vector-ref arg-2 0) ((5) (let ((e-87 (vector-ref arg-2 2))) (let ((e-89 (vector-ref arg-2 4))) (let ((e-90 (vector-ref arg-2 5))) (CoreC-45Ord-thenCmp (CoreC-45Ord-thenCmp (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) e-26 e-89) (lambda () (CoreC-45Name-u--compare_Ord_Name e-24 e-87))) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-912) e-27 e-90)))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2)))))))) ((6) (let ((e-31 (vector-ref arg-1 3))) (let ((e-32 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((6) (let ((e-94 (vector-ref arg-2 3))) (let ((e-95 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45Ord-primFnEq e-31 e-94))) (if (null? sc2) (CoreC-45Ord-primFnCmp e-31 e-94) (let ((e-1 (unbox sc2))) (cond (else (DataC-45Vect-u--compare_Ord_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (csegen-912) e-32 e-95)))))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))))) ((7) (let ((e-35 (vector-ref arg-1 2))) (let ((e-36 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((7) (let ((e-98 (vector-ref arg-2 2))) (let ((e-99 (vector-ref arg-2 3))) (CoreC-45Ord-thenCmp (CoreC-45Name-u--compare_Ord_Name e-35 e-98) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-912) e-36 e-99))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))))) ((8) (let ((e-39 (vector-ref arg-1 2))) (let ((e-40 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-102 (vector-ref arg-2 2))) (let ((e-103 (vector-ref arg-2 3))) (CoreC-45Ord-thenCmp (CoreC-45Ord-u--compare_Ord_LazyReason e-39 e-102) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-40 e-103))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))))) ((9) (let ((e-43 (vector-ref arg-1 2))) (let ((e-44 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((9) (let ((e-106 (vector-ref arg-2 2))) (let ((e-107 (vector-ref arg-2 3))) (CoreC-45Ord-thenCmp (CoreC-45Ord-u--compare_Ord_LazyReason e-43 e-106) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-44 e-107))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))))) ((10) (let ((e-47 (vector-ref arg-1 2))) (let ((e-48 (vector-ref arg-1 3))) (let ((e-49 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((10) (let ((e-110 (vector-ref arg-2 2))) (let ((e-111 (vector-ref arg-2 3))) (let ((e-112 (vector-ref arg-2 4))) (CoreC-45Ord-thenCmp (CoreC-45Ord-thenCmp (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-47 e-110) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (vector (csegen-924) (lambda (arg-418) (lambda (arg-419) (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (CoreC-45Ord-u--C-60_Ord_C-40CConAltC-32C-36varsC-41 arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (CoreC-45Ord-u--C-62_Ord_C-40CConAltC-32C-36varsC-41 arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (CoreC-45Ord-u--C-60C-61_Ord_C-40CConAltC-32C-36varsC-41 arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (CoreC-45Ord-u--C-62C-61_Ord_C-40CConAltC-32C-36varsC-41 arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (CoreC-45Ord-u--max_Ord_C-40CConAltC-32C-36varsC-41 arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (CoreC-45Ord-u--min_Ord_C-40CConAltC-32C-36varsC-41 arg-430 arg-431)))) e-48 e-111))) (lambda () (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (csegen-912) e-49 e-112)))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2)))))))) ((11) (let ((e-52 (vector-ref arg-1 2))) (let ((e-53 (vector-ref arg-1 3))) (let ((e-54 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((11) (let ((e-115 (vector-ref arg-2 2))) (let ((e-116 (vector-ref arg-2 3))) (let ((e-117 (vector-ref arg-2 4))) (CoreC-45Ord-thenCmp (CoreC-45Ord-thenCmp (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-52 e-115) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (vector (csegen-935) (lambda (arg-418) (lambda (arg-419) (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (CoreC-45Ord-u--C-60_Ord_C-40CConstAltC-32C-36varsC-41 arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (CoreC-45Ord-u--C-62_Ord_C-40CConstAltC-32C-36varsC-41 arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (CoreC-45Ord-u--C-60C-61_Ord_C-40CConstAltC-32C-36varsC-41 arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (CoreC-45Ord-u--C-62C-61_Ord_C-40CConstAltC-32C-36varsC-41 arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (CoreC-45Ord-u--max_Ord_C-40CConstAltC-32C-36varsC-41 arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (CoreC-45Ord-u--min_Ord_C-40CConstAltC-32C-36varsC-41 arg-430 arg-431)))) e-53 e-116))) (lambda () (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (csegen-912) e-54 e-117)))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2)))))))) ((12) (let ((e-57 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((12) (let ((e-120 (vector-ref arg-2 2))) (CoreC-45Ord-u--compare_Ord_Constant e-57 e-120)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2)))))) ((13) (case (vector-ref arg-2 0) ((13) 1)(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))) ((14) (let ((e-62 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((14) (let ((e-125 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--compare_Ord_String e-62 e-125)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7479-3541-u--tag arg-2 arg-1 arg-2))))))
(define CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (CoreC-45Ord-thenCmp (CoreC-45Ord-u--compare_Ord_Constant e-1 e-4) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-2 e-5)))))))))
(define CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-1 0))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-2 0))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-10 (vector-ref arg-2 3))) (let ((e-11 (vector-ref arg-2 4))) (CoreC-45Ord-thenCmp (CoreC-45Ord-thenCmp (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (csegen-224) e-3 e-9) (lambda () (CoreC-45Name-u--compare_Ord_Name e-1 e-7))) (let ((sc0 (CoreC-45Name-namesEq e-4 e-10))) (if (null? sc0) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-883) e-4 e-10)) (let ((e-6 (unbox sc0))) (cond (else (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-5 e-11))))))))))))))))))
(define CoreC-45Ord-u--C-62_Ord_Constant (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_Constant arg-0 arg-1) 2)))
(define CoreC-45Ord-u--C-62_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-62_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-62_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-62C-61_Ord_Constant (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_Constant arg-0 arg-1) 0)))
(define CoreC-45Ord-u--C-62C-61_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-62C-61_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-62C-61_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (case (vector-ref arg-2 0) ((0) (let ((e-65 (vector-ref arg-2 1))) (PreludeC-45Types-u--C-61C-61_Eq_Nat e-2 e-65)))(else 0)))) ((1) (let ((e-7 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((1) (let ((e-70 (vector-ref arg-2 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-7 e-70)))(else 0)))) ((2) (let ((e-10 (vector-ref arg-1 2))) (let ((e-11 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((2) (let ((e-73 (vector-ref arg-2 2))) (let ((e-74 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Name-nameEq e-10 e-73))) (if (null? sc2) 0 (let ((e-1 (unbox sc2))) (cond (else (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-11 e-74)))))))))(else 0))))) ((3) (let ((e-14 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 4))) (let ((e-17 (vector-ref arg-1 5))) (case (vector-ref arg-2 0) ((3) (let ((e-77 (vector-ref arg-2 2))) (let ((e-79 (vector-ref arg-2 4))) (let ((e-80 (vector-ref arg-2 5))) (let ((sc2 (CoreC-45Name-nameEq e-14 e-77))) (if (null? sc2) 0 (let ((e-1 (unbox sc2))) (cond (else (let ((sc4 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-16 e-79))) (cond ((equal? sc4 1) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-17 e-80)) (else 0))))))))))))(else 0)))))) ((4) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-83 (vector-ref arg-2 2))) (let ((e-84 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-20 e-83))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-913) e-21 e-84)) (else 0))))))(else 0))))) ((5) (let ((e-24 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 4))) (let ((e-27 (vector-ref arg-1 5))) (case (vector-ref arg-2 0) ((5) (let ((e-87 (vector-ref arg-2 2))) (let ((e-89 (vector-ref arg-2 4))) (let ((e-90 (vector-ref arg-2 5))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-225) e-26 e-89))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-24 e-87))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-913) e-27 e-90)) (else 0)))) (else 0)))))))(else 0)))))) ((6) (let ((e-31 (vector-ref arg-1 3))) (let ((e-32 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((6) (let ((e-94 (vector-ref arg-2 3))) (let ((e-95 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45Ord-primFnEq e-31 e-94))) (if (null? sc2) 0 (let ((e-1 (unbox sc2))) (cond (else (DataC-45Vect-u--C-61C-61_Eq_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (csegen-913) e-32 e-95)))))))))(else 0))))) ((7) (let ((e-35 (vector-ref arg-1 2))) (let ((e-36 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((7) (let ((e-98 (vector-ref arg-2 2))) (let ((e-99 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-35 e-98))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-913) e-36 e-99)) (else 0))))))(else 0))))) ((8) (let ((e-39 (vector-ref arg-1 2))) (let ((e-40 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-102 (vector-ref arg-2 2))) (let ((e-103 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_LazyReason e-39 e-102))) (cond ((equal? sc2 1) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-40 e-103)) (else 0))))))(else 0))))) ((9) (let ((e-43 (vector-ref arg-1 2))) (let ((e-44 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((9) (let ((e-106 (vector-ref arg-2 2))) (let ((e-107 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_LazyReason e-43 e-106))) (cond ((equal? sc2 1) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-44 e-107)) (else 0))))))(else 0))))) ((10) (let ((e-47 (vector-ref arg-1 2))) (let ((e-48 (vector-ref arg-1 3))) (let ((e-49 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((10) (let ((e-110 (vector-ref arg-2 2))) (let ((e-111 (vector-ref arg-2 3))) (let ((e-112 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-47 e-110))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-924) e-48 e-111))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-913) e-49 e-112)) (else 0)))) (else 0)))))))(else 0)))))) ((11) (let ((e-52 (vector-ref arg-1 2))) (let ((e-53 (vector-ref arg-1 3))) (let ((e-54 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((11) (let ((e-115 (vector-ref arg-2 2))) (let ((e-116 (vector-ref arg-2 3))) (let ((e-117 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-52 e-115))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-935) e-53 e-116))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-913) e-54 e-117)) (else 0)))) (else 0)))))))(else 0)))))) ((12) (let ((e-57 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((12) (let ((e-120 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-57 e-120)))(else 0)))) ((13) (case (vector-ref arg-2 0) ((13) 1)(else 0))) ((14) (let ((e-62 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((14) (let ((e-125 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-62 e-125)))(else 0))))(else 0))))
(define CoreC-45Ord-u--C-61C-61_Eq_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-1 e-4))) (cond ((equal? sc2 1) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-2 e-5)) (else 0)))))))))
(define CoreC-45Ord-u--C-61C-61_Eq_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-1 0))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-2 0))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-10 (vector-ref arg-2 3))) (let ((e-11 (vector-ref arg-2 4))) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-225) e-3 e-9))) (cond ((equal? sc0 1) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-7))) (cond ((equal? sc1 1) ((let ((sc2 (CoreC-45Name-namesEq e-4 e-10))) (if (null? sc2) (lambda () 0) (let ((e-6 (unbox sc2))) (cond (else (lambda () (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-5 e-11))))))))) (else 0)))) (else 0)))))))))))))
(define CoreC-45Ord-u--C-60_Ord_Constant (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_Constant arg-0 arg-1) 0)))
(define CoreC-45Ord-u--C-60_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-60_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-60_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-60C-61_Ord_Constant (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_Constant arg-0 arg-1) 2)))
(define CoreC-45Ord-u--C-60C-61_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-60C-61_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-60C-61_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-47C-61_Eq_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Ord-u--C-47C-61_Eq_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-61C-61_Eq_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Ord-u--C-47C-61_Eq_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-61C-61_Eq_C-40CConAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Ord-thenCmp (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 0) ((equal? arg-0 1) (arg-1)) (else 2))))
(define CoreC-45Ord-primFnEq (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((0) (let ((e-18 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-0 e-18))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((1) (let ((e-1 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((1) (let ((e-19 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-1 e-19))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((2) (let ((e-2 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((2) (let ((e-20 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-2 e-20))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((3) (let ((e-3 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((3) (let ((e-21 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-3 e-21))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((4) (let ((e-4 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((4) (let ((e-22 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-22))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((5) (let ((e-5 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((5) (let ((e-23 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-5 e-23))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((6) (let ((e-6 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((6) (let ((e-24 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((7) (let ((e-7 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((7) (let ((e-25 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-7 e-25))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((8) (let ((e-8 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((8) (let ((e-26 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-8 e-26))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((9) (let ((e-9 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((9) (let ((e-27 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-9 e-27))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((10) (let ((e-10 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((10) (let ((e-28 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-10 e-28))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((11) (let ((e-11 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((11) (let ((e-29 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-11 e-29))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((12) (let ((e-12 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((12) (let ((e-30 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-12 e-30))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((13) (let ((e-13 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((13) (let ((e-31 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-13 e-31))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((14) (let ((e-14 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((14) (let ((e-32 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-14 e-32))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((15) (let ((e-15 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((15) (let ((e-33 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-33))) (cond ((equal? sc2 1) (box 0)) (else '())))))(else '())))) ((16) (case (vector-ref arg-3 0) ((16) (box 0))(else '()))) ((17) (case (vector-ref arg-3 0) ((17) (box 0))(else '()))) ((18) (case (vector-ref arg-3 0) ((18) (box 0))(else '()))) ((19) (case (vector-ref arg-3 0) ((19) (box 0))(else '()))) ((20) (case (vector-ref arg-3 0) ((20) (box 0))(else '()))) ((21) (case (vector-ref arg-3 0) ((21) (box 0))(else '()))) ((22) (case (vector-ref arg-3 0) ((22) (box 0))(else '()))) ((23) (case (vector-ref arg-3 0) ((23) (box 0))(else '()))) ((24) (case (vector-ref arg-3 0) ((24) (box 0))(else '()))) ((25) (case (vector-ref arg-3 0) ((25) (box 0))(else '()))) ((26) (case (vector-ref arg-3 0) ((26) (box 0))(else '()))) ((27) (case (vector-ref arg-3 0) ((27) (box 0))(else '()))) ((28) (case (vector-ref arg-3 0) ((28) (box 0))(else '()))) ((29) (case (vector-ref arg-3 0) ((29) (box 0))(else '()))) ((30) (case (vector-ref arg-3 0) ((30) (box 0))(else '()))) ((31) (case (vector-ref arg-3 0) ((31) (box 0))(else '()))) ((32) (case (vector-ref arg-3 0) ((32) (box 0))(else '()))) ((33) (case (vector-ref arg-3 0) ((33) (box 0))(else '()))) ((34) (case (vector-ref arg-3 0) ((34) (box 0))(else '()))) ((35) (case (vector-ref arg-3 0) ((35) (box 0))(else '()))) ((36) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((36) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((sc2 (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-16 e-34))) (cond ((equal? sc3 1) (CoreC-45TT-u--C-61C-61_Eq_Constant e-17 e-35)) (else 0))))) (cond ((equal? sc2 1) (box 0)) (else '()))))))(else '()))))) ((37) (case (vector-ref arg-3 0) ((37) (box 0))(else '()))) ((38) (case (vector-ref arg-3 0) ((38) (box 0))(else '())))(else '()))))
(define CoreC-45Ord-primFnCmp (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((0) (let ((e-18 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-0 e-18)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((1) (let ((e-19 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-1 e-19)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((2) (let ((e-2 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((2) (let ((e-20 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-2 e-20)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((3) (let ((e-3 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((3) (let ((e-21 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-3 e-21)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((4) (let ((e-4 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((4) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-4 e-22)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((5) (let ((e-5 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((5) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-5 e-23)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((6) (let ((e-6 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((6) (let ((e-24 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-6 e-24)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((7) (let ((e-7 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((7) (let ((e-25 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-7 e-25)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((8) (let ((e-8 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((8) (let ((e-26 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-8 e-26)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((9) (let ((e-9 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((9) (let ((e-27 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-9 e-27)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((10) (let ((e-10 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((10) (let ((e-28 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-10 e-28)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((11) (let ((e-11 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((11) (let ((e-29 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-11 e-29)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((12) (let ((e-12 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((12) (let ((e-30 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-12 e-30)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((13) (let ((e-13 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((13) (let ((e-31 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-13 e-31)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((14) (let ((e-14 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((14) (let ((e-32 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-14 e-32)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((15) (let ((e-15 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((15) (let ((e-33 (vector-ref arg-3 1))) (CoreC-45Ord-u--compare_Ord_Constant e-15 e-33)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))) ((36) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((36) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (CoreC-45Ord-thenCmp (CoreC-45Ord-u--compare_Ord_Constant e-16 e-34) (lambda () (CoreC-45Ord-u--compare_Ord_Constant e-17 e-35))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3)))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-2) (CoreC-45Ord-n--6049-1799-u--tag arg-3 arg-2 arg-3))))))
(define CoreC-45Ord-lrTag (lambda (arg-0) (cond ((equal? arg-0 0) 0) ((equal? arg-0 1) 1) (else 2))))
(define CoreC-45Directory-n--7168-1376-u--findIpkgFileC-39 (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Directory-dirEntries arg-0 ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (let ((sc1 (DataC-45List-find (lambda (u--f) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-17) (LibrariesC-45UtilsC-45Path-extension u--f) (box "ipkg"))) e-2))) (if (null? sc1) (let ((sc2 (LibrariesC-45UtilsC-45Path-splitParent arg-0))) (if (null? sc2) '() (let ((e-1 (unbox sc2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (CoreC-45Directory-n--7168-1376-u--findIpkgFileC-39 e-5 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-6 arg-1) ext-0)))))) (let ((e-1 (unbox sc1))) (box (cons arg-0 (cons e-1 arg-1)))))))) (else '())))))
(define CoreC-45Directory-u--show_Show_IdrSrcExt (lambda (arg-0) (cond ((equal? arg-0 0) "idr") ((equal? arg-0 1) "lidr") ((equal? arg-0 2) "yaff") ((equal? arg-0 3) "org") (else "md"))))
(define CoreC-45Directory-readDataFile (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Directory-findDataFile arg-0 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) e-5) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (vector 1 e-2))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-5 e-7) ext-0))))))))))))))
(define CoreC-45Directory-nsToSource (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fnameOrig (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath arg-2))) (let ((u--fnameBase (PreludeC-45Types-maybe (lambda () u--fnameOrig) (lambda () (lambda (u--srcdir) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--srcdir u--fnameOrig))) (let ((e-1 (vector-ref e-5 1))) e-1)))) (let ((u--fs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--fnameBase (CoreC-45Directory-u--show_Show_IdrSrcExt eta-0))) (CoreC-45Directory-listOfExtensions)))) (let ((act-25 (CoreC-45Directory-firstAvailable arg-0 u--fs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 54 arg-1 arg-2) ext-0) (let ((e-1 (unbox e-6))) (vector 1 e-1))))))))))))))))
(define CoreC-45Directory-nsToPath (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fnameBase (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath arg-2))) (let ((u--fs (PreludeC-45Types-u--map_Functor_List (lambda (u--p) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--p (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--fnameBase "ttc"))) (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref e-5 2))) e-2) "ttc") (let ((e-6 (vector-ref e-5 6))) e-6))))) (let ((act-25 (CoreC-45Directory-firstAvailable arg-0 u--fs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 0 (vector 54 arg-1 arg-2))) (let ((e-1 (unbox e-6))) (vector 1 (vector 1 e-1))))))))))))))))
(define CoreC-45Directory-mkdirAll (lambda (arg-0 ext-0) (let ((sc0 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Path (LibrariesC-45UtilsC-45Path-parse arg-0) (LibrariesC-45UtilsC-45Path-emptyPath)))) (cond ((equal? sc0 1) (vector 1 0)) (else (let ((act-24 (CoreC-45Directory-dirExists arg-0 ext-0))) (cond ((equal? act-24 1) (vector 1 0)) (else (let ((act-25 (let ((sc2 (LibrariesC-45UtilsC-45Path-parent arg-0))) (if (null? sc2) (vector 1 0) (let ((e-1 (unbox sc2))) (CoreC-45Directory-mkdirAll e-1 ext-0)))))) (case (vector-ref act-25 0) ((1) (let ((e-2 (vector-ref act-25 1))) (cond ((equal? e-2 0) ((SystemC-45Directory-createDir (csegen-3) arg-0) ext-0))(else act-25))))(else act-25)))))))))))
(define CoreC-45Directory-mbPathToNS (lambda (arg-0 arg-1 arg-2) (let ((u--sdir (DataC-45Maybe-fromMaybe (lambda () "") arg-1))) (let ((u--base (let ((sc0 (LibrariesC-45UtilsC-45Path-isAbsolute arg-2))) (cond ((equal? sc0 1) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-0 u--sdir)) (else u--sdir))))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (CoreC-45NameC-45Namespace-unsafeFoldModuleIdent (PreludeC-45TypesC-45List-reverse (LibrariesC-45UtilsC-45Path-splitPath (LibrariesC-45UtilsC-45Path-dropExtension eta-0))))) (LibrariesC-45UtilsC-45Path-dropBase u--base arg-2))))))
(define CoreC-45Directory-makeBuildDirectory (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--bdir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref e-5 2))) e-2) "ttc"))) (let ((u--ns (PreludeC-45TypesC-45List-reverse (DataC-45Maybe-fromMaybe (lambda () '()) (DataC-45List-tailC-39 (CoreC-45NameC-45Namespace-unsafeUnfoldModuleIdent arg-1)))))) (let ((u--ndir (LibrariesC-45UtilsC-45Path-joinPath u--ns))) (let ((act-25 (let ((act-25 (CoreC-45Directory-mkdirAll (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--bdir u--ndir) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (vector 1 0)) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref e-5 2))) e-2) u--ndir) e-7) ext-0)))))))))))))))))
(define CoreC-45Directory-listOfExtensions(blodwen-lazy (lambda () (cons 0 (cons 1 (cons 2 (cons 3 (cons 4 '()))))))))
(define CoreC-45Directory-getTTCFileName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Directory-ctxtPathToNS arg-0 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fname (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath e-5) arg-2))) (let ((act-25 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--bdir (let ((e-2 (vector-ref e-6 2))) e-2))) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--bdir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 "ttc" u--fname)))))))))))))))
(define CoreC-45Directory-getObjFileName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Directory-ctxtPathToNS arg-0 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fname (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath e-5) arg-2))) (vector 1 u--fname))))))))
(define CoreC-45Directory-getEntries (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45Directory-dirEntry (csegen-3) arg-0) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Directory-getEntries arg-0 ext-0))) (cons e-2 act-25)))) (else '())))))
(define CoreC-45Directory-firstAvailable (lambda (arg-0 arg-1 ext-0) (if (null? arg-1) (vector 1 '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "import.file" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Attempting to read " e-2)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (let ((act-25 ((SystemC-45FileC-45Handle-openFile (csegen-3) e-2 0) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-4 (vector-ref e-6 1))) (let ((act-26 (let ((act-26 ((SystemC-45FileC-45Handle-closeFile (csegen-3) e-4) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (vector 1 (box e-2))))))) (else (CoreC-45Directory-firstAvailable arg-0 e-3 ext-0)))))))))))))))
(define CoreC-45Directory-findLibraryFile (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fs (PreludeC-45Types-u--map_Functor_List (lambda (u--p) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--p arg-1)) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-8 (vector-ref e-5 8))) e-8) (PreludeC-45Types-u--map_Functor_List (lambda (u--x) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--x "lib")) (let ((e-6 (vector-ref e-5 6))) e-6)))))) (let ((act-25 (CoreC-45Directory-firstAvailable arg-0 u--fs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't find library " arg-1)) ext-0) (let ((e-1 (unbox e-6))) (vector 1 e-1))))))))))))))
(define CoreC-45Directory-findIpkgFile (lambda (ext-0) (let ((act-24 ((csegen-878) ext-0))) (if (null? act-24) '() (let ((e-1 (unbox act-24))) (let ((act-25 (CoreC-45Directory-n--7168-1376-u--findIpkgFileC-39 e-1 "" ext-0))) act-25))))))
(define CoreC-45Directory-findDataFile (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fs (PreludeC-45Types-u--map_Functor_List (lambda (u--p) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--p arg-1)) (let ((e-9 (vector-ref e-5 9))) e-9)))) (let ((act-25 (CoreC-45Directory-firstAvailable arg-0 u--fs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't find data file " (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " in any of " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) u--fs))))) ext-0) (let ((e-1 (unbox e-6))) (vector 1 e-1))))))))))))))
(define CoreC-45Directory-ensureDirectoryExists (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Directory-mkdirAll arg-0 ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (vector 1 0)) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 e-6) ext-0))))))))))
(define CoreC-45Directory-dirExists (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45Directory-openDir (csegen-3) arg-0) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (SystemC-45Directory-closeDir (csegen-3) e-2) (lambda () (lambda (eta-0) 1))) ext-0))) (else 0)))))
(define CoreC-45Directory-dirEntries (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45Directory-openDir (csegen-3) arg-0) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Directory-getEntries e-2 ext-0))) ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (SystemC-45Directory-closeDir (csegen-3) e-2) (lambda () (lambda (eta-0) (vector 1 act-25)))) ext-0)))) (else (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5)))))))
(define CoreC-45Directory-ctxtPathToNS (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--wdir (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 0))) (let ((e-51 (vector-ref e-41 0))) e-51))))) (let ((u--sdir (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 0))) (let ((e-50 (vector-ref e-41 1))) e-50))))) ((CoreC-45Directory-corePathToNS u--wdir u--sdir arg-1) ext-0)))))))))
(define CoreC-45Directory-corePathToNS (lambda (arg-0 arg-1 arg-2) (let ((u--err (vector 58 (PreludeC-45TypesC-45String-C-43C-43 "Source file " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String arg-2) (PreludeC-45TypesC-45String-C-43C-43 " is not in the source directory " (PreludeC-45Show-u--show_Show_String (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-0 (DataC-45Maybe-fromMaybe (lambda () "") arg-1))))))))) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) (CoreC-45Directory-mbPathToNS arg-0 arg-1 arg-2)))))
(define CoreC-45ContextC-45Log-n--6589-5147-u--showTimeLog (lambda (arg-0 arg-1) (lambda (clam-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-3))) (let ((act-24 (let ((act-24 ((PreludeC-45IO-putStr (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 e-2 ": ")) clam-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Integer (PreludeC-45Num-u--div_Integral_Integer e-7 (CoreC-45ContextC-45Log-nano))) (PreludeC-45TypesC-45String-C-43C-43 "." (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45ContextC-45Log-n--6589-5146-u--addZeros arg-0 (PreludeC-45Types-fastUnpack (PreludeC-45Show-u--show_Show_Integer (PreludeC-45Num-u--div_Integral_Integer (PreludeC-45Num-u--mod_Integral_Integer e-7 (CoreC-45ContextC-45Log-nano)) (CoreC-45ContextC-45Log-micro))))) "s")))) clam-0))) (vector 1 act-25)))))))))))
(define CoreC-45ContextC-45Log-n--6589-5146-u--addZeros (lambda (arg-0 arg-1) (if (null? arg-1) "000" (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (PreludeC-45TypesC-45String-C-43C-43 "00" (PreludeC-45Cast-u--cast_Cast_Char_String e-2)) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (if (null? e-7) (PreludeC-45TypesC-45String-C-43C-43 "0" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Cast-u--cast_Cast_Char_String e-2) (PreludeC-45Cast-u--cast_Cast_Char_String e-6))) (PreludeC-45Types-fastPack arg-1))))))))))
(define CoreC-45ContextC-45Log-n--6101-4707-u--addZeros (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) "000" (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? e-3) (PreludeC-45TypesC-45String-C-43C-43 "00" (PreludeC-45Cast-u--cast_Cast_Char_String e-2)) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (if (null? e-7) (PreludeC-45TypesC-45String-C-43C-43 "0" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Cast-u--cast_Cast_Char_String e-2) (PreludeC-45Cast-u--cast_Cast_Char_String e-6))) (PreludeC-45Types-fastPack arg-5))))))))))
(define CoreC-45ContextC-45Log-unverifiedLogging (lambda (arg-0 arg-1 arg-2 ext-0) (cond ((equal? arg-2 0) (vector 1 1))(else (let ((act-24 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((sc1 (let ((e-8 (vector-ref e-5 8))) e-8))) (cond ((equal? sc1 1) (CoreC-45OptionsC-45Log-keepLog (CoreC-45OptionsC-45Log-mkUnverifiedLogLevel arg-1 arg-2) (let ((e-9 (vector-ref e-5 9))) e-9))) (else 0))))))))))))
(define CoreC-45ContextC-45Log-unverifiedLogC (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? arg-1 "") (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-2) (PreludeC-45TypesC-45String-C-43C-43 ": " e-6)))) ext-0))) (vector 1 act-26)))(else (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-2) (PreludeC-45TypesC-45String-C-43C-43 ": " e-6)))))) ext-0))) (vector 1 act-26))))))))) (else (vector 1 0)))))))))
(define CoreC-45ContextC-45Log-showTimeRecord (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45ContextC-45Log-n--6589-5147-u--showTimeLog arg-0 eta-0)) (LibrariesC-45DataC-45StringMap-toList (let ((e-27 (vector-ref e-5 27))) e-27)) ext-0)))))))
(define CoreC-45ContextC-45Log-nano(blodwen-lazy (lambda () 1000000000)))
(define CoreC-45ContextC-45Log-micro(blodwen-lazy (lambda () 1000000)))
(define CoreC-45ContextC-45Log-logTimeWhen (lambda (arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-2 1) (lambda (eta-0) (let ((act-24 (let ((act-24 (SystemC-45Clock-clockTime 3 eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--t (+ (* (SystemC-45Clock-seconds e-5) (CoreC-45ContextC-45Log-nano)) (SystemC-45Clock-nanoseconds e-5)))) (let ((act-25 (arg-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (SystemC-45Clock-clockTime 3 eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--tC-39 (+ (* (SystemC-45Clock-seconds e-7) (CoreC-45ContextC-45Log-nano)) (SystemC-45Clock-nanoseconds e-7)))) (let ((u--time (- u--tC-39 u--t))) (let ((act-27 (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "TIMING " (PreludeC-45TypesC-45String-C-43C-43 (arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Integer (PreludeC-45Num-u--div_Integral_Integer u--time (CoreC-45ContextC-45Log-nano))) (PreludeC-45TypesC-45String-C-43C-43 "." (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45ContextC-45Log-n--6101-4707-u--addZeros arg-4 arg-3 arg-2 arg-1 (PreludeC-45Types-fastUnpack (PreludeC-45Show-u--show_Show_Integer (PreludeC-45Num-u--div_Integral_Integer (PreludeC-45Num-u--mod_Integral_Integer u--time (CoreC-45ContextC-45Log-nano)) (CoreC-45ContextC-45Log-micro))))) "s"))))))) eta-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-6))))))))))))))))))))) (else arg-4))))
(define CoreC-45ContextC-45Log-logTime (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45ContextC-45Log-logTimeWhen arg-1 (let ((e-10 (vector-ref e-5 10))) e-10) arg-2 arg-3) ext-0)))))))
(define CoreC-45ContextC-45Log-logTerm (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (CoreC-45Context-toFullNames arg-1 (csegen-76) arg-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? arg-2 "") (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-6))))))) ext-0))) (vector 1 act-26)))(else (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-6))))))))) ext-0))) (vector 1 act-26))))))))) (else (vector 1 0)))))))))
(define CoreC-45ContextC-45Log-log (lambda (arg-0 arg-1 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (cond ((equal? arg-1 "") (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (arg-4))))) ext-0))) (vector 1 act-25)))(else (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (arg-4))))))) ext-0))) (vector 1 act-25))))) (else (vector 1 0)))))))))
(define CompilerC-45VMCode-n--7462-2151-u--toVMConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (car arg-6))) (let ((e-1 (cdr arg-6))) (cons e-0 (CompilerC-45VMCode-toVM arg-5 arg-4 e-1))))))
(define CompilerC-45VMCode-n--7462-2103-u--toVMConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((u--body (CompilerC-45VMCode-toVM arg-5 arg-4 e-4))) (let ((u--used (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (lambda (eta-0) (CompilerC-45VMCode-collectUsed eta-0)) u--body))) (cons (PreludeC-45Types-maybe (lambda () (vector 1 e-0)) (lambda () (lambda (eta-0) (vector 0 eta-0))) e-2) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45VMCode-projectArgs arg-0 0 u--used e-3) u--body))))))))))
(define CompilerC-45VMCode-n--7702-2281-u--findVarAlt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-65) (lambda (eta-0) (CompilerC-45VMCode-findVars eta-0)) e-3))))
(define CompilerC-45VMCode-n--7702-2323-u--findConstVarAlt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-65) (lambda (eta-0) (CompilerC-45VMCode-findVars eta-0)) e-3))))
(define CompilerC-45VMCode-n--7879-2377-u--declareAll (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (cons (vector 1 ) arg-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (PreludeC-45Types-elem (csegen-225) e-2 arg-2))) (cond ((equal? sc1 1) (CompilerC-45VMCode-n--7879-2377-u--declareAll arg-0 arg-1 arg-2 e-3)) (else (cons (vector 0 (vector 1 e-2)) (CompilerC-45VMCode-n--7879-2377-u--declareAll arg-0 arg-1 (cons e-2 arg-2) e-3))))))))))
(define CompilerC-45VMCode-u--show_Show_VMInst (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "DECLARE " (CompilerC-45VMCode-u--show_Show_Reg e-0)))) ((1) "START") ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-1) (PreludeC-45TypesC-45String-C-43C-43 " := " (CompilerC-45VMCode-u--show_Show_Reg e-2)))))) ((3) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-3) (PreludeC-45TypesC-45String-C-43C-43 " := MKCON " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (csegen-954) e-4) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) e-5)) ")"))))))))) ((4) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (let ((e-9 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-6) (PreludeC-45TypesC-45String-C-43C-43 " := MKCLOSURE " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-7) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-8) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) e-9)) ")")))))))))))) ((5) (let ((e-10 (vector-ref arg-0 1))) (let ((e-11 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-10) (PreludeC-45TypesC-45String-C-43C-43 " := MKCONSTANT " (CoreC-45TT-u--show_Show_Constant e-11)))))) ((6) (let ((e-12 (vector-ref arg-0 1))) (let ((e-13 (vector-ref arg-0 2))) (let ((e-14 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-12) (PreludeC-45TypesC-45String-C-43C-43 " := " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-13) (PreludeC-45TypesC-45String-C-43C-43 " @ " (CompilerC-45VMCode-u--show_Show_Reg e-14))))))))) ((7) (let ((e-15 (vector-ref arg-0 1))) (let ((e-16 (vector-ref arg-0 2))) (let ((e-17 (vector-ref arg-0 3))) (let ((e-18 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-15) (PreludeC-45TypesC-45String-C-43C-43 " := " (PreludeC-45TypesC-45String-C-43C-43 (cond ((equal? e-16 1) "TAILCALL ") (else "CALL ")) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-17) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) e-18)) ")"))))))))))) ((8) (let ((e-20 (vector-ref arg-0 1))) (let ((e-21 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-20) (PreludeC-45TypesC-45String-C-43C-43 " := " (PreludeC-45TypesC-45String-C-43C-43 "OP " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 e-21) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 e-22))) ")")))))))))) ((9) (let ((e-23 (vector-ref arg-0 1))) (let ((e-24 (vector-ref arg-0 2))) (let ((e-25 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-23) (PreludeC-45TypesC-45String-C-43C-43 " := " (PreludeC-45TypesC-45String-C-43C-43 "EXTPRIM " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-24) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) e-25)) ")")))))))))) ((10) (let ((e-26 (vector-ref arg-0 1))) (let ((e-27 (vector-ref arg-0 2))) (let ((e-28 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "CASE " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-26) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-957) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-957) u--d u--x)))) e-27) (PreludeC-45TypesC-45String-C-43C-43 " {default: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-961) e-28) "}")))))))))) ((11) (let ((e-29 (vector-ref arg-0 1))) (let ((e-30 (vector-ref arg-0 2))) (let ((e-31 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "CASE " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-29) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-969) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-969) u--d u--x)))) e-30) (PreludeC-45TypesC-45String-C-43C-43 " {default: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-961) e-31) "}")))))))))) ((12) (let ((e-32 (vector-ref arg-0 1))) (let ((e-33 (vector-ref arg-0 2))) (let ((e-34 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-32) (PreludeC-45TypesC-45String-C-43C-43 " := PROJECT(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-33) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-34) ")"))))))))) ((13) (let ((e-35 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-35) " := NULL"))) (else (let ((e-36 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "ERROR " (PreludeC-45Show-u--show_Show_String e-36)))))))
(define CompilerC-45VMCode-u--show_Show_VMDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-246) e-0) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-963) e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Foreign call " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-837) e-3) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45CompileExpr-u--show_Show_CFType e-4)))))))))) (else (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Error: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-963) e-5)))))))
(define CompilerC-45VMCode-u--show_Show_Reg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "RVAL") ((1) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "v" (PreludeC-45Show-u--show_Show_Int e-0)))) (else "DISCARD"))))
(define CompilerC-45VMCode-u--showPrec_Show_VMInst (lambda (arg-0 arg-1) (CompilerC-45VMCode-u--show_Show_VMInst arg-1)))
(define CompilerC-45VMCode-u--showPrec_Show_VMDef (lambda (arg-0 arg-1) (CompilerC-45VMCode-u--show_Show_VMDef arg-1)))
(define CompilerC-45VMCode-toVMDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (box (vector 0 e-0 (CompilerC-45VMCode-declareVars e-0 (CompilerC-45VMCode-toVM 1 (vector 0 ) e-1))))))) ((2) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (box (vector 1 e-2 e-3 e-4)))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (box (vector 2 (CompilerC-45VMCode-declareVars '() (CompilerC-45VMCode-toVM 1 (vector 0 ) e-5))))))(else '()))))
(define CompilerC-45VMCode-toVM (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((2) '())(else (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (if (null? e-1) (cons (vector 13 arg-1) '()) (let ((e-45 (unbox e-1))) (cons (vector 2 arg-1 (vector 1 e-45)) '()))))) ((1) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (cons (vector 7 arg-1 arg-0 e-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-5)) '())))) ((2) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (cons (vector 4 arg-1 e-7 e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-9)) '()))))) ((3) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (cons (vector 6 arg-1 (CompilerC-45VMCode-toReg e-12) (CompilerC-45VMCode-toReg e-13)) '())))) ((4) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45VMCode-toVM 0 (vector 1 e-15) e-16) (CompilerC-45VMCode-toVM arg-0 arg-1 e-17)))))) ((5) (let ((e-19 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 4))) (let ((e-22 (vector-ref arg-2 5))) (if (null? e-21) (cons (vector 3 arg-1 (vector 1 e-19) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-22)) '()) (let ((e-47 (unbox e-21))) (cons (vector 3 arg-1 (vector 0 e-47) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-22)) '()))))))) ((6) (let ((e-26 (vector-ref arg-2 3))) (let ((e-27 (vector-ref arg-2 4))) (cons (vector 8 arg-1 e-26 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-27)) '())))) ((7) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (cons (vector 9 arg-1 e-30 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-31)) '())))) ((8) (let ((e-32 (vector-ref arg-2 1))) (let ((e-33 (vector-ref arg-2 2))) (let ((e-34 (vector-ref arg-2 3))) (let ((e-35 (vector-ref arg-2 4))) (if (null? e-33) (cons (vector 13 arg-1) '()) (let ((e-49 (unbox e-33))) (if (null? e-34) (cons (vector 10 (vector 1 e-49) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-n--7462-2103-u--toVMConAlt e-49 e-35 e-34 e-32 arg-1 arg-0 eta-0)) e-34) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45VMCode-toVM arg-0 arg-1 eta-0)) e-35)) '()) (let ((e-51 (car e-34))) (let ((e-52 (cdr e-34))) (let ((e-56 (vector-ref e-51 3))) (let ((e-57 (vector-ref e-51 4))) (if (null? e-52) (if (null? e-35) (let ((u--body (CompilerC-45VMCode-toVM arg-0 arg-1 e-57))) (let ((u--used (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (lambda (eta-0) (CompilerC-45VMCode-collectUsed eta-0)) u--body))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45VMCode-projectArgs e-49 0 u--used e-56) u--body))) (cons (vector 10 (vector 1 e-49) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-n--7462-2103-u--toVMConAlt e-49 e-35 e-34 e-32 arg-1 arg-0 eta-0)) e-34) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45VMCode-toVM arg-0 arg-1 eta-0)) e-35)) '())) (cons (vector 10 (vector 1 e-49) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-n--7462-2103-u--toVMConAlt e-49 e-35 e-34 e-32 arg-1 arg-0 eta-0)) e-34) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45VMCode-toVM arg-0 arg-1 eta-0)) e-35)) '())))))))))))))) ((9) (let ((e-36 (vector-ref arg-2 1))) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (if (null? e-37) (cons (vector 13 arg-1) '()) (let ((e-60 (unbox e-37))) (cons (vector 11 (vector 1 e-60) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45VMCode-n--7462-2151-u--toVMConstAlt e-60 e-39 e-38 e-36 arg-1 arg-0 eta-0)) e-38) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45VMCode-toVM arg-0 arg-1 eta-0)) e-39)) '())))))))) ((10) (let ((e-41 (vector-ref arg-2 2))) (cons (vector 5 arg-1 e-41) '()))) ((11) (cons (vector 13 arg-1) '())) ((12) (let ((e-44 (vector-ref arg-2 2))) (cons (vector 14 e-44) '())))(else (cons (vector 13 arg-1) '())))))))
(define CompilerC-45VMCode-toReg (lambda (arg-0) (if (null? arg-0) (vector 2 ) (let ((e-0 (unbox arg-0))) (vector 1 e-0)))))
(define CompilerC-45VMCode-projectArgs (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45IntMap-lookup e-2 arg-2))) (if (null? sc1) (CompilerC-45VMCode-projectArgs arg-0 (bs+ arg-1 1 63) arg-2 e-3) (cons (vector 12 (vector 1 e-2) (vector 1 arg-0) arg-1) (CompilerC-45VMCode-projectArgs arg-0 (bs+ arg-1 1 63) arg-2 e-3)))))))))
(define CompilerC-45VMCode-findVars (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((1) (let ((e-34 (vector-ref e-0 1))) (cons e-34 '())))(else '())))) ((3) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref e-2 0) ((1) (let ((e-35 (vector-ref e-2 1))) (cons e-35 '())))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref e-5 0) ((1) (let ((e-36 (vector-ref e-5 1))) (cons e-36 '())))(else '())))) ((5) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref e-9 0) ((1) (let ((e-37 (vector-ref e-9 1))) (cons e-37 '())))(else '())))) ((6) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref e-11 0) ((1) (let ((e-38 (vector-ref e-11 1))) (cons e-38 '())))(else '())))) ((7) (let ((e-14 (vector-ref arg-0 1))) (case (vector-ref e-14 0) ((1) (let ((e-39 (vector-ref e-14 1))) (cons e-39 '())))(else '())))) ((8) (let ((e-19 (vector-ref arg-0 1))) (case (vector-ref e-19 0) ((1) (let ((e-40 (vector-ref e-19 1))) (cons e-40 '())))(else '())))) ((9) (let ((e-22 (vector-ref arg-0 1))) (case (vector-ref e-22 0) ((1) (let ((e-41 (vector-ref e-22 1))) (cons e-41 '())))(else '())))) ((10) (let ((e-25 (vector-ref arg-0 1))) (let ((e-26 (vector-ref arg-0 2))) (let ((e-27 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--foldMap_Foldable_List (csegen-65) (lambda (eta-0) (CompilerC-45VMCode-n--7702-2281-u--findVarAlt e-25 e-27 e-26 eta-0)) e-26) (DataC-45Maybe-fromMaybe (lambda () '()) (PreludeC-45Types-u--map_Functor_Maybe (csegen-973) e-27))))))) ((11) (let ((e-28 (vector-ref arg-0 1))) (let ((e-29 (vector-ref arg-0 2))) (let ((e-30 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--foldMap_Foldable_List (csegen-65) (lambda (eta-0) (CompilerC-45VMCode-n--7702-2323-u--findConstVarAlt e-28 e-30 e-29 eta-0)) e-29) (DataC-45Maybe-fromMaybe (lambda () '()) (PreludeC-45Types-u--map_Functor_Maybe (csegen-973) e-30))))))) ((12) (let ((e-31 (vector-ref arg-0 1))) (case (vector-ref e-31 0) ((1) (let ((e-42 (vector-ref e-31 1))) (cons e-42 '())))(else '()))))(else '()))))
(define CompilerC-45VMCode-declareVars (lambda (arg-0 arg-1) (let ((u--vs (PreludeC-45Types-u--foldMap_Foldable_List (csegen-65) (lambda (eta-0) (CompilerC-45VMCode-findVars eta-0)) arg-1))) (CompilerC-45VMCode-n--7879-2377-u--declareAll arg-1 arg-0 arg-0 u--vs))))
(define CompilerC-45VMCode-collectUsed (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45VMCode-collectReg e-0))) ((1) (LibrariesC-45DataC-45IntMap-empty)) ((2) (let ((e-2 (vector-ref arg-0 2))) (CompilerC-45VMCode-collectReg e-2))) ((3) (let ((e-5 (vector-ref arg-0 3))) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-5))) ((4) (let ((e-9 (vector-ref arg-0 4))) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-9))) ((5) (LibrariesC-45DataC-45IntMap-empty)) ((6) (let ((e-13 (vector-ref arg-0 2))) (let ((e-14 (vector-ref arg-0 3))) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (csegen-363) (CompilerC-45VMCode-collectReg e-13) (CompilerC-45VMCode-collectReg e-14))))) ((7) (let ((e-18 (vector-ref arg-0 4))) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-18))) ((8) (let ((e-22 (vector-ref arg-0 3))) (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 (csegen-951) (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-22))) ((9) (let ((e-25 (vector-ref arg-0 3))) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-25))) ((10) (let ((e-26 (vector-ref arg-0 1))) (let ((e-27 (vector-ref arg-0 2))) (let ((e-28 (vector-ref arg-0 3))) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (csegen-363) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (csegen-363) (CompilerC-45VMCode-collectReg e-26) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (csegen-974) e-27)) (PreludeC-45Types-maybe (lambda () (LibrariesC-45DataC-45IntMap-empty)) (lambda () (csegen-975)) e-28)))))) ((11) (let ((e-29 (vector-ref arg-0 1))) (let ((e-30 (vector-ref arg-0 2))) (let ((e-31 (vector-ref arg-0 3))) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (csegen-363) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (csegen-363) (CompilerC-45VMCode-collectReg e-29) (PreludeC-45Types-u--foldMap_Foldable_List (csegen-951) (csegen-974) e-30)) (PreludeC-45Types-maybe (lambda () (LibrariesC-45DataC-45IntMap-empty)) (lambda () (csegen-975)) e-31)))))) ((12) (let ((e-33 (vector-ref arg-0 2))) (CompilerC-45VMCode-collectReg e-33))) ((13) (LibrariesC-45DataC-45IntMap-empty)) (else (LibrariesC-45DataC-45IntMap-empty)))))
(define CompilerC-45VMCode-collectReg (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45DataC-45IntMap-singleton e-0 0)))(else (LibrariesC-45DataC-45IntMap-empty)))))
(define CompilerC-45VMCode-allDefs (lambda (ext-0) (DataC-45List-mapMaybe (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CompilerC-45VMCode-toVMDef e-3) (lambda (u--dC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-2 u--dC-39))))))) ext-0)))
(define CompilerC-45ANF-n--7073-1597-u--showArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (PreludeC-45TypesC-45String-C-43C-43 "v" (PreludeC-45Show-u--show_Show_Int arg-5))))
(define CompilerC-45ANF-n--7391-1880-u--doBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (arg-0 (PreludeC-45TypesC-45List-reverse arg-4)) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (if (null? e-6) (CompilerC-45ANF-n--7391-1880-u--doBind arg-0 arg-1 arg-2 arg-3 (cons e-6 arg-4) e-3) (let ((e-8 (unbox e-6))) (if (null? e-7) (CompilerC-45ANF-n--7391-1880-u--doBind arg-0 arg-1 arg-2 arg-3 (cons e-6 arg-4) e-3) (let ((e-10 (unbox e-7))) (vector 4 arg-2 e-8 e-10 (CompilerC-45ANF-n--7391-1880-u--doBind arg-0 arg-1 arg-2 arg-3 (cons (box e-8) arg-4) e-3)))))))))))))
(define CompilerC-45ANF-n--7985-2396-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 ext-0) (if (null? arg-5) (vector 1 (cons '() arg-6)) (let ((e-3 (cdr arg-5))) (let ((act-24 (CompilerC-45ANF-nextVar arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45ANF-n--7985-2396-u--bindArgs arg-0 arg-1 arg-2 arg-4 e-3 arg-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (cons e-5 e-7) (cons e-5 e-4)))))))))))))))))
(define CompilerC-45ANF-n--7470-2268-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-10 ext-0) (if (null? arg-9) (vector 1 (cons '() arg-10)) (let ((e-3 (cdr arg-9))) (let ((act-24 (CompilerC-45ANF-nextVar arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45ANF-n--7470-2268-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 arg-10 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (cons e-5 e-7) (cons e-5 e-4)))))))))))))))))
(define CompilerC-45ANF-u--show_Show_AVar (lambda (arg-0) (if (null? arg-0) "[__]" (let ((e-0 (unbox arg-0))) (PreludeC-45TypesC-45String-C-43C-43 "v" (PreludeC-45Show-u--show_Show_Int e-0))))))
(define CompilerC-45ANF-u--show_Show_ANFDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-246) e-0) (PreludeC-45TypesC-45String-C-43C-43 ": " (CompilerC-45ANF-u--show_Show_ANF e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Constructor tag " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-246) e-2) (PreludeC-45TypesC-45String-C-43C-43 " arity " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-3) (PreludeC-45TypesC-45String-C-43C-43 " newtype by " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-775) e-4)))))))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Foreign call " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-5) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-837) e-6) (PreludeC-45TypesC-45String-C-43C-43 " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-7)))))))))) (else (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Error: " (CompilerC-45ANF-u--show_Show_ANF e-8)))))))
(define CompilerC-45ANF-u--show_Show_ANF (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CompilerC-45ANF-u--show_Show_AVar e-1))) ((1) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (let ((e-5 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-4) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-showLazy e-3) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-5)) ")")))))))) ((2) (let ((e-7 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (let ((e-9 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "<" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-7) (PreludeC-45TypesC-45String-C-43C-43 " underapp " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-8) (PreludeC-45TypesC-45String-C-43C-43 ">(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-9)) ")")))))))))) ((3) (let ((e-11 (vector-ref arg-0 2))) (let ((e-12 (vector-ref arg-0 3))) (let ((e-13 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-u--show_Show_AVar e-12) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-showLazy e-11) (PreludeC-45TypesC-45String-C-43C-43 " @ (" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-u--show_Show_AVar e-13) ")")))))))) ((4) (let ((e-15 (vector-ref arg-0 2))) (let ((e-16 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "%let v" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-15) (PreludeC-45TypesC-45String-C-43C-43 " = (" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-u--show_Show_ANF e-16) (PreludeC-45TypesC-45String-C-43C-43 ") in (" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-u--show_Show_ANF e-17) ")")))))))))) ((5) (let ((e-19 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 5))) (PreludeC-45TypesC-45String-C-43C-43 "%con " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-19) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-22)) ")"))))))) ((6) (let ((e-25 (vector-ref arg-0 2))) (let ((e-26 (vector-ref arg-0 3))) (let ((e-27 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "%op " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 e-26) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-showLazy e-25) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-27))) ")"))))))))) ((7) (let ((e-29 (vector-ref arg-0 2))) (let ((e-30 (vector-ref arg-0 3))) (let ((e-31 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "%extprim " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-30) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-showLazy e-29) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-31)) ")"))))))))) ((8) (let ((e-33 (vector-ref arg-0 2))) (let ((e-34 (vector-ref arg-0 3))) (let ((e-35 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "%case " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-u--show_Show_AVar e-33) (PreludeC-45TypesC-45String-C-43C-43 " of { " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "| " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AConAlt eta-0)) e-34)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-977) e-35) " }")))))))))) ((9) (let ((e-37 (vector-ref arg-0 2))) (let ((e-38 (vector-ref arg-0 3))) (let ((e-39 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "%case " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ANF-u--show_Show_AVar e-37) (PreludeC-45TypesC-45String-C-43C-43 " of { " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "| " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AConstAlt eta-0)) e-38)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-977) e-39) " }")))))))))) ((10) (let ((e-41 (vector-ref arg-0 2))) (CoreC-45TT-u--show_Show_Constant e-41))) ((11) "___") (else (let ((e-44 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "%CRASH(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-44) ")")))))))
(define CompilerC-45ANF-u--show_Show_AConstAlt (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (PreludeC-45TypesC-45String-C-43C-43 "%constalt(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant e-0) (PreludeC-45TypesC-45String-C-43C-43 ") => " (CompilerC-45ANF-u--show_Show_ANF e-1))))))))
(define CompilerC-45ANF-u--show_Show_AConAlt (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (PreludeC-45TypesC-45String-C-43C-43 "%conalt " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-0) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ANF-n--7073-1597-u--showArg e-1 e-4 e-3 e-2 e-0 eta-0)) e-3)) (PreludeC-45TypesC-45String-C-43C-43 ") => " (CompilerC-45ANF-u--show_Show_ANF e-4)))))))))))))
(define CompilerC-45ANF-u--showPrec_Show_ANFDef (lambda (arg-0 arg-1) (CompilerC-45ANF-u--show_Show_ANFDef arg-1)))
(define CompilerC-45ANF-u--showPrec_Show_ANF (lambda (arg-0 arg-1) (CompilerC-45ANF-u--show_Show_ANF arg-1)))
(define CompilerC-45ANF-toANF (lambda (arg-0 ext-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (let ((act-24 (CoreC-45Core-newRef (vector "Compiler.ANF.Next" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45ANF-n--7985-2396-u--bindArgs e-1 e-0 e-2 e-5 e-0 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-4 (car e-6))) (let ((e-3 (cdr e-6))) (let ((u--vs e-3)) (let ((act-26 (CompilerC-45ANF-n--7985-2396-u--bindArgs e-1 e-0 e-2 e-5 e-1 u--vs ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-9 (car e-7))) (let ((e-8 (cdr e-7))) (let ((act-27 ((CompilerC-45ANF-anf (PreludeC-45TypesC-45List-tailRecAppend e-1 e-0) e-5 e-8 e-2) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (vector 1 (vector 0 (PreludeC-45TypesC-45List-tailRecAppend e-4 (PreludeC-45TypesC-45List-reverse e-9)) e-10))))))))))))))))))))))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (vector 1 (vector 1 e-3 e-4 e-5)))))) ((2) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (vector 1 (vector 2 e-6 e-7 e-8)))))) (else (let ((e-9 (vector-ref arg-0 1))) (let ((act-24 (CoreC-45Core-newRef (vector "Compiler.ANF.Next" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45ANF-anf '() e-5 '() e-9) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-6)))))))))))))))
(define CompilerC-45ANF-showLazy (lambda (ext-0) (PreludeC-45Types-maybe (lambda () "") (lambda () (csegen-979)) ext-0)))
(define CompilerC-45ANF-nextVar (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 e-5))))))))))
(define CompilerC-45ANF-mlet (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (vector 1 (arg-3 e-1))))(else (let ((act-24 (CompilerC-45ANF-nextVar arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 4 arg-1 e-5 arg-2 (arg-3 (box e-5))))))))))))
(define CompilerC-45ANF-lookup (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-3 (car arg-4))) e-3))(else (let ((e-0 (- arg-2 1))) (let ((e-8 (cdr arg-4))) (CompilerC-45ANF-lookup e-0 e-8)))))))
(define CompilerC-45ANF-letBind (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((CompilerC-45ANF-bindArgs arg-0 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45ANF-n--7391-1880-u--doBind arg-3 arg-2 arg-1 arg-0 '() e-5))))))))
(define CompilerC-45ANF-bindArgs (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 2))) (let ((act-24 ((CompilerC-45ANF-bindArgs arg-0 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (cons (cons e-5 '()) e-6)))))))) ((11) (let ((act-24 ((CompilerC-45ANF-bindArgs arg-0 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (cons '() '()) e-5)))))))(else (let ((act-24 (CompilerC-45ANF-nextVar arg-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45ANF-bindArgs arg-0 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (cons (box e-5) (box e-2)) e-6))))))))))))))))))
(define CompilerC-45ANF-anfConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((act-24 ((CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-1 e-5))))))))))
(define CompilerC-45ANF-anfConAlt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-24 (CompilerC-45ANF-n--7470-2268-u--bindArgs arg-0 e-4 e-5 e-3 e-2 e-1 arg-2 arg-1 e-4 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((act-25 ((CompilerC-45ANF-anf (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-1 e-7 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector e-1 e-2 e-3 e-8 e-9)))))))))))))))))))
(define CompilerC-45ANF-anfArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ANF-anf arg-0 arg-1 arg-3 eta-0)) arg-4 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CompilerC-45ANF-letBind arg-1 arg-2 e-5 arg-5 ext-0)))))))
(define CompilerC-45ANF-anf (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (vector 1 (vector 0 e-3 (box (CompilerC-45ANF-lookup e-2 arg-2))))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-6 arg-2 e-9 (lambda (eta-0) (vector 1 e-6 e-7 e-8 eta-0)) clam-0)))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-11 arg-2 e-14 (lambda (eta-0) (vector 2 e-11 e-12 e-13 eta-0)) clam-0)))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-16 arg-2 (cons e-18 (cons e-19 '())) (lambda (lcase-0) (if (null? lcase-0) (vector 12 e-16 "Can't happen (AApp)") (let ((e-1 (car lcase-0))) (let ((e-2 (cdr lcase-0))) (if (null? e-2) (vector 12 e-16 "Can't happen (AApp)") (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (vector 3 e-16 e-17 e-1 e-4) (vector 12 e-16 "Can't happen (AApp)"))))))))) clam-0)))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (let ((act-24 (CompilerC-45ANF-nextVar arg-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--vsC-39 (cons e-5 arg-2))) (let ((act-25 ((CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-23) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45ANF-anf (cons e-22 arg-0) arg-1 u--vsC-39 e-24) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 e-21 e-5 e-6 e-7)))))))))))))))))))) ((5) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (let ((e-30 (vector-ref arg-3 5))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-26 arg-2 e-30 (lambda (eta-0) (vector 5 e-26 e-27 e-28 e-29 eta-0)) clam-0))))))) ((6) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ANF-anf arg-0 arg-1 arg-2 eta-0)) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 e-36) '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CompilerC-45ANF-letBind arg-1 e-33 e-5 (lambda (u--args) (let ((sc2 (DataC-45Vect-toVect e-32 u--args))) (if (null? sc2) (vector 12 e-33 "Can't happen (AOp)") (let ((e-2 (unbox sc2))) (vector 6 e-33 e-34 e-35 e-2))))) clam-0))))))))))) ((7) (let ((e-38 (vector-ref arg-3 1))) (let ((e-39 (vector-ref arg-3 2))) (let ((e-40 (vector-ref arg-3 3))) (let ((e-41 (vector-ref arg-3 4))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-38 arg-2 e-41 (lambda (eta-0) (vector 7 e-38 e-39 e-40 eta-0)) clam-0)))))) ((8) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (let ((e-45 (vector-ref arg-3 3))) (let ((e-46 (vector-ref arg-3 4))) (let ((act-24 ((CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-44) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ANF-anfConAlt arg-0 arg-1 arg-2 eta-0 eta-1))) e-45 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-46) (vector 1 '()) (let ((e-2 (unbox e-46))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-2) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CompilerC-45ANF-mlet arg-1 e-43 e-5 (lambda (u--x) (vector 8 e-43 u--x e-6 e-7)) clam-0)))))))))))))))))) ((9) (let ((e-48 (vector-ref arg-3 1))) (let ((e-49 (vector-ref arg-3 2))) (let ((e-50 (vector-ref arg-3 3))) (let ((e-51 (vector-ref arg-3 4))) (let ((act-24 ((CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-49) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ANF-anfConstAlt arg-0 arg-1 arg-2 eta-0 eta-1))) e-50 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-51) (vector 1 '()) (let ((e-2 (unbox e-51))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-2) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CompilerC-45ANF-mlet arg-1 e-48 e-5 (lambda (u--x) (vector 9 e-48 u--x e-6 e-7)) clam-0)))))))))))))))))) ((10) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (vector 1 (vector 10 e-53 e-54))))) ((11) (let ((e-56 (vector-ref arg-3 1))) (vector 1 (vector 11 e-56)))) (else (let ((e-58 (vector-ref arg-3 1))) (let ((e-59 (vector-ref arg-3 2))) (vector 1 (vector 12 e-58 e-59)))))))))
(define CompilerC-45LambdaLift-n--7442-2963-u--usedConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (cdr arg-9))) (CompilerC-45LambdaLift-usedVars arg-0 arg-6 arg-8 e-2))))
(define CompilerC-45LambdaLift-n--7442-2928-u--usedConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-4 (vector-ref arg-9 3))) (let ((e-5 (vector-ref arg-9 4))) (CompilerC-45LambdaLift-contractUsedMany e-4 (CompilerC-45LambdaLift-usedVars (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-6 (CompilerC-45LambdaLift-weakenUsed e-4 arg-8) e-5))))))
(define CompilerC-45LambdaLift-n--7437-2523-u--traverseArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 ext-0) (if (null? arg-9) (vector 1 '()) (let ((e-3 (car arg-9))) (let ((e-4 (cdr arg-9))) (let ((act-24 ((CompilerC-45LambdaLift-liftExp arg-0 arg-7 arg-1 '() e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45LambdaLift-n--7437-2523-u--traverseArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6)))))))))))))))
(define CompilerC-45LambdaLift-n--7105-1816-u--mkName (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (vector 0 e-0 (CompilerC-45LambdaLift-n--7105-1816-u--mkName arg-0 e-1 arg-2))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (vector 2 (CoreC-45Name-displayUserName e-2) arg-2))) ((4) (let ((e-4 (vector-ref arg-1 2))) (CompilerC-45LambdaLift-n--7105-1816-u--mkName arg-0 e-4 arg-2))) ((6) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "case block in " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-6) ")")))) arg-2)))) ((7) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "with block in " (PreludeC-45TypesC-45String-C-43C-43 e-7 (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-8) ")")))) arg-2))))(else (vector 2 (CoreC-45Name-u--show_Show_Name arg-1) arg-2)))))
(define CompilerC-45LambdaLift-n--7437-2748-u--liftConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((CompilerC-45LambdaLift-liftExp arg-0 arg-7 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-1 e-5))))))))))
(define CompilerC-45LambdaLift-n--7437-2697-u--liftConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((e-1 (vector-ref arg-9 0))) (let ((e-2 (vector-ref arg-9 1))) (let ((e-3 (vector-ref arg-9 2))) (let ((e-4 (vector-ref arg-9 3))) (let ((e-5 (vector-ref arg-9 4))) (let ((act-24 ((CompilerC-45LambdaLift-liftExp (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-7 arg-1 arg-2 e-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))))))))))
(define CompilerC-45LambdaLift-n--7342-2028-u--finIdx (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (let ((e-2 (cdr arg-5))) (cond ((equal? arg-6 0) 0)(else (let ((e-3 (- arg-6 1))) (+ 1 (CompilerC-45LambdaLift-n--7342-2028-u--finIdx arg-1 arg-2 arg-3 e-2 e-3))))))))
(define CompilerC-45LambdaLift-n--7458-3458-u--dropConstCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-1 (car arg-8))) (let ((e-2 (cdr arg-8))) (cons e-1 (CompilerC-45LambdaLift-dropUnused arg-1 arg-7 arg-0 arg-6 e-2))))))
(define CompilerC-45LambdaLift-n--7458-3394-u--dropConCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-1 (vector-ref arg-8 0))) (let ((e-2 (vector-ref arg-8 1))) (let ((e-3 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 3))) (let ((e-5 (vector-ref arg-8 4))) (let ((u--scC-39 e-5)) (let ((u--droppedSc (CompilerC-45LambdaLift-dropUnused arg-1 arg-7 (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-6 u--scC-39))) (vector e-1 e-2 e-3 e-4 u--droppedSc))))))))))
(define CompilerC-45LambdaLift-n--7430-2174-u--allVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (vector 0 lamc-0 arg-7)) (CompilerC-45LambdaLift-n--7430-2173-u--allPrfs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9))))
(define CompilerC-45LambdaLift-n--7430-2173-u--allPrfs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) '() (let ((e-3 (cdr arg-7))) (let ((e-6 (car arg-8))) (let ((e-7 (cdr arg-8))) (cond ((equal? e-6 0) (cons 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) (CompilerC-45LambdaLift-n--7430-2173-u--allPrfs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-7)))) (else (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) (CompilerC-45LambdaLift-n--7430-2173-u--allPrfs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-7))))))))))
(define CompilerC-45LambdaLift-u--show_Show_LiftedDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-0) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (PreludeC-45TypesC-45List-reverse e-1)) (PreludeC-45TypesC-45String-C-43C-43 ": " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-1 e-0) e-2)))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Constructor tag " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-246) e-3) (PreludeC-45TypesC-45String-C-43C-43 " arity " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-4) (PreludeC-45Types-maybe (lambda () "") (lambda () (csegen-836)) e-5))))))))) ((2) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "Foreign call " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-837) e-7) (PreludeC-45TypesC-45String-C-43C-43 " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-8)))))))))) (else (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Error: " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 '() e-9)))))))
(define CompilerC-45LambdaLift-u--show_Show_C-40LiftedConstAltC-32C-36vsC-41 (lambda (arg-0 arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (PreludeC-45TypesC-45String-C-43C-43 "%constalt(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant e-1) (PreludeC-45TypesC-45String-C-43C-43 ") => " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-2))))))))
(define CompilerC-45LambdaLift-u--show_Show_C-40LiftedConAltC-32C-36vsC-41 (lambda (arg-0 arg-1) (let ((e-1 (vector-ref arg-1 0))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 "%conalt " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-1) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-4)) (PreludeC-45TypesC-45String-C-43C-43 ") => " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) e-5)))))))))))
(define CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "!" (CoreC-45Name-u--show_Show_Name (CoreC-45TT-nameAt arg-0 e-2))))) ((1) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (let ((e-9 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-8) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-showLazy e-7) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-9)) ")")))))))) ((2) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 "<" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-12) (PreludeC-45TypesC-45String-C-43C-43 " underapp " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-13) (PreludeC-45TypesC-45String-C-43C-43 ">(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-14)) ")")))))))))) ((3) (let ((e-17 (vector-ref arg-1 2))) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-18) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-showLazy e-17) (PreludeC-45TypesC-45String-C-43C-43 " @ (" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-19) ")")))))))) ((4) (let ((e-22 (vector-ref arg-1 2))) (let ((e-23 (vector-ref arg-1 3))) (let ((e-24 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 "%let " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-22) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-23) (PreludeC-45TypesC-45String-C-43C-43 " in " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 (cons e-22 arg-0) e-24)))))))))) ((5) (let ((e-27 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 5))) (PreludeC-45TypesC-45String-C-43C-43 "%con " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-27) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-30)) ")"))))))) ((6) (let ((e-34 (vector-ref arg-1 3))) (let ((e-35 (vector-ref arg-1 4))) (let ((e-36 (vector-ref arg-1 5))) (PreludeC-45TypesC-45String-C-43C-43 "%op " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 e-35) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-showLazy e-34) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-36))) ")"))))))))) ((7) (let ((e-39 (vector-ref arg-1 2))) (let ((e-40 (vector-ref arg-1 3))) (let ((e-41 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 "%extprim " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-40) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-showLazy e-39) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-41)) ")"))))))))) ((8) (let ((e-44 (vector-ref arg-1 2))) (let ((e-45 (vector-ref arg-1 3))) (let ((e-46 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 "%case " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-44) (PreludeC-45TypesC-45String-C-43C-43 " of { " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "| " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedConAltC-32C-36vsC-41 arg-0 eta-0)) e-45)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45LambdaLift-u--showPrec_Show_C-40LiftedC-32C-36vsC-41 arg-0 u--d u--x)))) e-46)))))))))) ((9) (let ((e-49 (vector-ref arg-1 2))) (let ((e-50 (vector-ref arg-1 3))) (let ((e-51 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 "%case " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-49) (PreludeC-45TypesC-45String-C-43C-43 " of { " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "| " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedConstAltC-32C-36vsC-41 arg-0 eta-0)) e-50)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45LambdaLift-u--showPrec_Show_C-40LiftedC-32C-36vsC-41 arg-0 u--d u--x)))) e-51)))))))))) ((10) (let ((e-54 (vector-ref arg-1 2))) (CoreC-45TT-u--show_Show_Constant e-54))) ((11) "___") (else (let ((e-59 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "%CRASH(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-59) ")")))))))
(define CompilerC-45LambdaLift-u--showPrec_Show_LiftedDef (lambda (arg-0 arg-1) (CompilerC-45LambdaLift-u--show_Show_LiftedDef arg-1)))
(define CompilerC-45LambdaLift-u--showPrec_Show_C-40LiftedC-32C-36vsC-41 (lambda (arg-0 arg-1 arg-2) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 arg-2)))
(define CompilerC-45LambdaLift-weakenUsed (lambda (arg-1 arg-2) (DataC-45Vect-C-43C-43 (DataC-45Vect-replicate (PreludeC-45TypesC-45List-length arg-1) 0) arg-2)))
(define CompilerC-45LambdaLift-usedVars (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (CompilerC-45LambdaLift-markUsed arg-0 e-2 arg-2))) ((1) (let ((e-9 (vector-ref arg-3 4))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-9))) ((2) (let ((e-14 (vector-ref arg-3 4))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-14))) ((3) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 (CompilerC-45LambdaLift-usedVars arg-0 arg-1 arg-2 e-19) e-18)))) ((4) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (let ((u--innerUsed (CompilerC-45LambdaLift-contractUsed (CompilerC-45LambdaLift-usedVars (PreludeC-45TypesC-45List-tailRecAppend (cons e-22 '()) arg-0) arg-1 (CompilerC-45LambdaLift-weakenUsed (cons e-22 '()) arg-2) e-24)))) (CompilerC-45LambdaLift-usedVars (PreludeC-45TypesC-45List-tailRecAppend '() arg-0) arg-1 u--innerUsed e-23)))))) ((5) (let ((e-30 (vector-ref arg-3 5))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-30))) ((6) (let ((e-36 (vector-ref arg-3 5))) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-36))) ((7) (let ((e-41 (vector-ref arg-3 4))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-41))) ((8) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (let ((e-45 (vector-ref arg-3 3))) (let ((e-46 (vector-ref arg-3 4))) (let ((u--defUsed (PreludeC-45Types-maybe (lambda () arg-2) (lambda () (lambda (eta-0) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 arg-2 eta-0))) e-46))) (let ((u--scDefUsed (CompilerC-45LambdaLift-usedVars arg-0 arg-1 u--defUsed e-44))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-n--7442-2928-u--usedConAlt arg-0 e-46 e-45 e-44 e-43 arg-2 arg-1 '() eta-0 eta-1))) u--scDefUsed e-45)))))))) ((9) (let ((e-48 (vector-ref arg-3 1))) (let ((e-49 (vector-ref arg-3 2))) (let ((e-50 (vector-ref arg-3 3))) (let ((e-51 (vector-ref arg-3 4))) (let ((u--defUsed (PreludeC-45Types-maybe (lambda () arg-2) (lambda () (lambda (eta-0) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 arg-2 eta-0))) e-51))) (let ((u--scDefUsed (CompilerC-45LambdaLift-usedVars arg-0 arg-1 u--defUsed e-49))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-n--7442-2963-u--usedConstAlt arg-0 e-51 e-50 e-49 e-48 arg-2 arg-1 '() eta-0 eta-1))) u--scDefUsed e-50)))))))) ((10) arg-2) ((11) arg-2) (else arg-2))))
(define CompilerC-45LambdaLift-unload (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 arg-3)) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (CompilerC-45LambdaLift-unload arg-1 '() (vector 3 arg-1 arg-2 arg-3 e-2) e-3))))))
(define CompilerC-45LambdaLift-showLazy (lambda (ext-0) (PreludeC-45Types-maybe (lambda () "") (lambda () (csegen-979)) ext-0)))
(define CompilerC-45LambdaLift-markUsed (lambda (arg-1 arg-2 arg-4) (let ((u--newUsed (DataC-45Vect-replaceAt (CompilerC-45LambdaLift-n--7342-2028-u--finIdx arg-1 arg-4 arg-2 arg-1 arg-2) 1 arg-4))) u--newUsed)))
(define CompilerC-45LambdaLift-makeLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((2) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (CompilerC-45LambdaLift-makeLam arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-5) e-3))))(else (lambda (eta-0) (let ((act-24 ((CompilerC-45LambdaLift-liftExp (PreludeC-45TypesC-45List-tailRecAppend arg-5 arg-1) arg-0 arg-2 arg-3 arg-6) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--scUsedL (CompilerC-45LambdaLift-usedVars (PreludeC-45TypesC-45List-tailRecAppend arg-5 arg-1) arg-0 (CompilerC-45LambdaLift-initUsed (PreludeC-45TypesC-45List-tailRecAppend arg-5 arg-1)) e-5))) (let ((u--unusedContracted (CompilerC-45LambdaLift-contractUsedMany arg-5 u--scUsedL))) (let ((u--unused (CompilerC-45LambdaLift-getUnused u--unusedContracted))) (let ((u--sclC-39 (CompilerC-45LambdaLift-dropUnused arg-1 arg-0 arg-5 u--unused e-5))) (let ((act-25 (CompilerC-45LambdaLift-genName arg-0 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (vector e-0 (cons (cons e-6 (vector 0 (CompilerC-45LambdaLift-dropped arg-1 u--unused) arg-5 u--sclC-39)) e-1) e-2))))))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-4 e-6 (PreludeC-45TypesC-45List-length arg-5) (CompilerC-45LambdaLift-n--7430-2174-u--allVars arg-2 arg-3 arg-5 arg-1 arg-6 arg-4 arg-0 arg-4 arg-1 u--unused)))))))))))))))))))))))))))
(define CompilerC-45LambdaLift-liftExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 0 e-2 e-3)))))) ((1) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 1 e-6 arg-3 e-7 '())))))) ((2) (let ((e-9 (vector-ref arg-4 1))) (let ((e-10 (vector-ref arg-4 2))) (let ((e-11 (vector-ref arg-4 3))) (CompilerC-45LambdaLift-makeLam arg-1 arg-0 arg-2 arg-3 e-9 (cons e-10 '()) e-11))))) ((3) (let ((e-13 (vector-ref arg-4 1))) (let ((e-14 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 4))) (let ((e-17 (vector-ref arg-4 5))) (lambda (eta-0) (let ((act-24 ((CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45LambdaLift-liftExp (cons e-14 arg-0) arg-1 arg-2 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-13 e-14 e-5 e-6)))))))))))))))) ((4) (let ((e-19 (vector-ref arg-4 1))) (let ((e-20 (vector-ref arg-4 2))) (let ((e-21 (vector-ref arg-4 3))) (lambda (clam-0) (case (vector-ref e-20 0) ((1) (let ((e-65 (vector-ref e-20 2))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() eta-0)) e-21 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-19 arg-3 e-65 e-5))))))))(else (let ((act-24 ((CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-20) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() eta-0)) e-21 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45LambdaLift-unload e-19 arg-3 e-5 e-6) clam-0)))))))))))))))) ((5) (let ((e-23 (vector-ref arg-4 1))) (let ((e-24 (vector-ref arg-4 2))) (let ((e-25 (vector-ref arg-4 3))) (let ((e-26 (vector-ref arg-4 4))) (let ((e-27 (vector-ref arg-4 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() eta-1)) e-27 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-23 e-24 e-25 e-26 e-5))))))))))))) ((6) (let ((e-29 (vector-ref arg-4 1))) (let ((e-30 (vector-ref arg-4 2))) (let ((e-31 (vector-ref arg-4 3))) (let ((e-32 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 (CompilerC-45LambdaLift-n--7437-2523-u--traverseArgs arg-0 arg-2 arg-3 e-29 e-32 e-31 e-30 arg-1 e-32 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-29 e-30 arg-3 e-31 e-5)))))))))))) ((7) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() eta-1)) e-36 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 7 e-34 arg-3 e-35 e-5))))))))))) ((8) (let ((e-38 (vector-ref arg-4 1))) (let ((e-40 (vector-ref arg-4 3))) (cond ((equal? arg-2 1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-40)) (else (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() (vector 4 e-38 e-40 (cons (vector 13 e-38) '())))))))) ((9) (let ((e-42 (vector-ref arg-4 1))) (let ((e-43 (vector-ref arg-4 2))) (let ((e-44 (vector-ref arg-4 3))) (cond ((equal? arg-2 1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 (box e-43) e-44)) (else (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() (vector 2 e-42 (vector 2 "act" 0) (CoreC-45CompileExpr-u--weaken_Weaken_CExp e-44))))))))) ((10) (let ((e-46 (vector-ref arg-4 1))) (let ((e-47 (vector-ref arg-4 2))) (let ((e-48 (vector-ref arg-4 3))) (let ((e-49 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-47) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45LambdaLift-n--7437-2697-u--liftConAlt arg-0 arg-2 arg-3 e-49 e-48 e-47 e-46 arg-1 arg-3 eta-1 eta-2))) e-48 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-49) (vector 1 '()) (let ((e-2 (unbox e-49))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-2) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 8 e-46 e-5 e-6 e-7)))))))))))))))))))) ((11) (let ((e-51 (vector-ref arg-4 1))) (let ((e-52 (vector-ref arg-4 2))) (let ((e-53 (vector-ref arg-4 3))) (let ((e-54 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-52) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45LambdaLift-n--7437-2748-u--liftConstAlt arg-0 arg-2 arg-3 e-54 e-53 e-52 e-51 arg-1 '() eta-1 eta-2))) e-53 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-54) (vector 1 '()) (let ((e-2 (unbox e-54))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-2) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 9 e-51 e-5 e-6 e-7)))))))))))))))))))) ((12) (let ((e-56 (vector-ref arg-4 1))) (let ((e-57 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 10 e-56 e-57)))))) ((13) (let ((e-59 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (vector 11 e-59))))) (else (let ((e-61 (vector-ref arg-4 1))) (let ((e-62 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 12 e-61 e-62)))))))))
(define CompilerC-45LambdaLift-liftBody (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Compiler.LambdaLift.Lifts" ) (vector arg-2 '() 0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45LambdaLift-liftExp arg-0 e-5 arg-1 '() arg-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cons e-6 (let ((e-1 (vector-ref e-7 1))) e-1)))))))))))))))))
(define CompilerC-45LambdaLift-lambdaLiftDef (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (let ((act-24 (CompilerC-45LambdaLift-liftBody e-0 arg-0 arg-1 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (cons arg-1 (vector 0 e-0 '() e-2)) e-3))))))))))) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (vector 1 (cons (cons arg-1 (vector 1 e-2 e-3 e-4)) '())))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (vector 1 (cons (cons arg-1 (vector 2 e-5 e-6 e-7)) '())))))) (else (let ((e-8 (vector-ref arg-2 1))) (let ((act-24 (CompilerC-45LambdaLift-liftBody '() arg-0 arg-1 e-8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (cons arg-1 (vector 3 e-2)) e-3)))))))))))))
(define CompilerC-45LambdaLift-lambdaLift (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-7 (cdr e-3))) (lambda (eta-0) (CompilerC-45LambdaLift-lambdaLiftDef arg-1 e-2 e-7 eta-0)))))))
(define CompilerC-45LambdaLift-initUsed (lambda (arg-0) (DataC-45Vect-replicate (PreludeC-45TypesC-45List-length arg-0) 0)))
(define CompilerC-45LambdaLift-getUnused (lambda (arg-1) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (cond ((equal? eta-0 1) 0) (else 1))) arg-1)))
(define CompilerC-45LambdaLift-genName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--i (let ((e-2 (vector-ref e-5 2))) e-2))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (vector e-0 e-1 (bs+ u--i 1 63))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (CompilerC-45LambdaLift-n--7105-1816-u--mkName arg-0 (let ((e-0 (vector-ref e-5 0))) e-0) u--i))))))))))))
(define CompilerC-45LambdaLift-dropped (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (cond ((equal? e-6 0) (cons e-2 (CompilerC-45LambdaLift-dropped e-3 e-7))) (else (CompilerC-45LambdaLift-dropped e-3 e-7))))))))))
(define CompilerC-45LambdaLift-dropUnused (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((10) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (vector 10 e-1 e-2)))) ((11) (let ((e-4 (vector-ref arg-4 1))) (vector 11 e-4))) ((12) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (vector 12 e-6 e-7)))) ((0) (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (vector 0 (CompilerC-45LambdaLift-dropIdx arg-0 e-10 arg-2 arg-3) e-11)))) ((5) (let ((e-14 (vector-ref arg-4 1))) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (let ((e-17 (vector-ref arg-4 4))) (let ((e-18 (vector-ref arg-4 5))) (let ((u--argsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-18))) (vector 5 e-14 e-15 e-16 e-17 u--argsC-39)))))))) ((4) (let ((e-20 (vector-ref arg-4 1))) (let ((e-21 (vector-ref arg-4 2))) (let ((e-22 (vector-ref arg-4 3))) (let ((e-23 (vector-ref arg-4 4))) (let ((u--valC-39 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-22))) (let ((u--scC-39 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 (cons e-21 arg-2) arg-3 e-23))) (vector 4 e-20 e-21 u--valC-39 u--scC-39)))))))) ((3) (let ((e-25 (vector-ref arg-4 1))) (let ((e-26 (vector-ref arg-4 2))) (let ((e-27 (vector-ref arg-4 3))) (let ((e-28 (vector-ref arg-4 4))) (let ((u--cC-39 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-27))) (let ((u--argC-39 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-28))) (vector 3 e-25 e-26 u--cC-39 u--argC-39)))))))) ((6) (let ((e-30 (vector-ref arg-4 1))) (let ((e-31 (vector-ref arg-4 2))) (let ((e-32 (vector-ref arg-4 3))) (let ((e-33 (vector-ref arg-4 4))) (let ((e-34 (vector-ref arg-4 5))) (let ((u--argsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-34))) (vector 6 e-30 e-31 e-32 e-33 u--argsC-39)))))))) ((7) (let ((e-36 (vector-ref arg-4 1))) (let ((e-37 (vector-ref arg-4 2))) (let ((e-38 (vector-ref arg-4 3))) (let ((e-39 (vector-ref arg-4 4))) (let ((u--argsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-39))) (vector 7 e-36 e-37 e-38 u--argsC-39))))))) ((1) (let ((e-41 (vector-ref arg-4 1))) (let ((e-42 (vector-ref arg-4 2))) (let ((e-43 (vector-ref arg-4 3))) (let ((e-44 (vector-ref arg-4 4))) (let ((u--argsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-44))) (vector 1 e-41 e-42 e-43 u--argsC-39))))))) ((2) (let ((e-46 (vector-ref arg-4 1))) (let ((e-47 (vector-ref arg-4 2))) (let ((e-48 (vector-ref arg-4 3))) (let ((e-49 (vector-ref arg-4 4))) (let ((u--argsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-49))) (vector 2 e-46 e-47 e-48 u--argsC-39))))))) ((8) (let ((e-51 (vector-ref arg-4 1))) (let ((e-52 (vector-ref arg-4 2))) (let ((e-53 (vector-ref arg-4 3))) (let ((e-54 (vector-ref arg-4 4))) (let ((u--altsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-n--7458-3394-u--dropConCase arg-2 arg-0 e-54 e-53 e-52 e-51 arg-3 arg-1 eta-0)) e-53))) (vector 8 e-51 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-52) u--altsC-39 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-54)))))))) (else (let ((e-56 (vector-ref arg-4 1))) (let ((e-57 (vector-ref arg-4 2))) (let ((e-58 (vector-ref arg-4 3))) (let ((e-59 (vector-ref arg-4 4))) (let ((u--altsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45LambdaLift-n--7458-3458-u--dropConstCase arg-2 arg-0 e-59 e-58 e-57 e-56 arg-3 arg-1 eta-0)) e-58))) (vector 9 e-56 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-57) u--altsC-39 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-59)))))))))))
(define CompilerC-45LambdaLift-dropIdx (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-1) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4)))))) (let ((e-9 (cdr arg-1))) (cond ((equal? arg-2 0) (if (null? arg-3) (if (null? arg-4) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4)))))) (let ((e-14 (car arg-4))) (cond ((equal? e-14 0) 0) ((equal? e-14 1) (Builtin-idris_crash "INTERNAL ERROR: Referenced variable marked as unused"))(else (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4)))))))))) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4))))))))(else (let ((e-10 (- arg-2 1))) (if (null? arg-3) (if (null? arg-4) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4)))))) (let ((e-19 (car arg-4))) (let ((e-20 (cdr arg-4))) (cond ((equal? e-19 0) (CoreC-45TTC-45Var-later (CompilerC-45LambdaLift-dropIdx e-9 e-10 '() e-20))) ((equal? e-19 1) (CompilerC-45LambdaLift-dropIdx e-9 e-10 '() e-20))(else (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4))))))))))) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4))))))))))))))
(define CompilerC-45LambdaLift-contractUsedMany (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-3 (cdr arg-1))) (CompilerC-45LambdaLift-contractUsedMany e-3 (CompilerC-45LambdaLift-contractUsed arg-2))))))
(define CompilerC-45LambdaLift-contractUsed (lambda (arg-2) (DataC-45Vect-tail arg-2)))
(define CompilerC-45OptsC-45CSE-case--caseC-32blockC-32inC-32analyze-9100 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 (cons arg-3 arg-4)) (let ((e-1 (unbox arg-6))) (let ((act-24 (CompilerC-45OptsC-45CSE-store arg-1 arg-3 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (cons arg-3 arg-4)) (let ((e-2 (unbox e-5))) (vector 1 (cons arg-3 (vector 1 (vector 2 ) e-2)))))))))))))
(define CompilerC-45OptsC-45CSE-n--10369-11216-u--toDef (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) '() (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((1) (box (cons e-2 (cons (vector 2 ) (vector 0 '() e-6)))))(else '()))))))))))
(define CompilerC-45OptsC-45CSE-u--show_Show_Count (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "Once") ((1) "Many") (else (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "C " (PreludeC-45Show-u--show_Show_Integer e-0)))))))
(define CompilerC-45OptsC-45CSE-toReplaceMap (lambda (ext-0) (LibrariesC-45DataC-45SortedMap-fromList (csegen-883) (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (cons e-10 (cons e-7 (vector 2 e-11))))))))) (LibrariesC-45DataC-45SortedMap-toList ext-0)))))
(define CompilerC-45OptsC-45CSE-store (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-1 5))) (cond ((equal? sc0 1) (vector 1 '())) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-0 (car e-5))) (let ((e-1 (cdr e-5))) (let ((act-25 (let ((sc3 (LibrariesC-45DataC-45SortedMap-lookup (cons arg-1 arg-2) e-0))) (if (null? sc3) (vector 1 (cons (vector 2 "csegen" e-1) (cons 1 (bs+ e-1 1 63)))) (let ((e-2 (unbox sc3))) (let ((e-7 (car e-2))) (let ((e-6 (cdr e-2))) (vector 1 (cons e-7 (cons (+ e-6 1) e-1)))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-26 (let ((act-26 (set-box! arg-0 (cons (LibrariesC-45DataC-45SortedMap-insert (cons arg-1 arg-2) (cons e-2 e-8) e-0) e-7)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (box e-2))))))))))))))))))))))))
(define CompilerC-45OptsC-45CSE-replaceRef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Trying to replace " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-5) ": "))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45SortedMap-lookup arg-5 e-6)))))) (lambda (eta-0) (let ((act-25 (unbox arg-1))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "  not a name generated durin CSE") ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (vector 1 arg-4 arg-5))))) (let ((e-2 (unbox e-6))) (let ((e-8 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-7 0) ((1) (let ((act-26 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "  already replaced: Occurs many times") ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (vector 1 (vector 4 (vector 2 ) (vector 1 arg-4 arg-5) '())))))) ((0) (let ((act-26 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "  already replaced: Occurs many times") ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (vector 1 (CoreC-45CompileExpr-embed e-8)))))) (else (let ((e-9 (vector-ref e-7 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "  expression of unknown quantity (" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Integer e-9) " occurences)"))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 ((CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 e-9 e-8) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-27 1))) (let ((sc7 (PreludeC-45EqOrd-u--C-62_Ord_Integer e-9 arg-3))) (cond ((equal? sc7 1) (let ((act-28 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-5) " assigned quantity \"Many\"")) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((act-29 (let ((act-29 (let ((act-29 (unbox arg-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-29 1))) (let ((act-30 (set-box! arg-1 (LibrariesC-45DataC-45SortedMap-insert arg-5 (cons e-11 (vector 1 )) e-13)))) (vector 1 act-30)))))))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (vector 1 (vector 4 (vector 2 ) (vector 1 arg-4 arg-5) '()))))))))) (else (let ((act-28 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-5) " assigned quantity \"Once\"")) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((act-29 (let ((act-29 (let ((act-29 (unbox arg-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-29 1))) (let ((act-30 (set-box! arg-1 (LibrariesC-45DataC-45SortedMap-insert arg-5 (cons e-11 (vector 0 )) e-13)))) (vector 1 act-30)))))))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (vector 1 (CoreC-45CompileExpr-embed e-11))))))))))))))))))))))))))))))))))
(define CompilerC-45OptsC-45CSE-replaceExp (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (vector 1 arg-4)) ((1) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (CompilerC-45OptsC-45CSE-replaceRef arg-1 arg-2 arg-3 e-6 e-7 clam-0)))) ((2) (let ((e-9 (vector-ref arg-4 1))) (let ((e-10 (vector-ref arg-4 2))) (let ((e-11 (vector-ref arg-4 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-9 e-10 e-5)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-11) clam-0))))) ((3) (let ((e-13 (vector-ref arg-4 1))) (let ((e-14 (vector-ref arg-4 2))) (let ((e-15 (vector-ref arg-4 3))) (let ((e-16 (vector-ref arg-4 4))) (let ((e-17 (vector-ref arg-4 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 3 e-13 e-14 e-15 e-5 eta-2))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-16) eta-0)) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-17) clam-0))))))) ((4) (let ((e-19 (vector-ref arg-4 1))) (let ((e-20 (vector-ref arg-4 2))) (let ((e-21 (vector-ref arg-4 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 4 e-19 e-5 eta-2))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-20) eta-0)) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 eta-1)) e-21 '() eta-0)) clam-0))))) ((5) (let ((e-23 (vector-ref arg-4 1))) (let ((e-24 (vector-ref arg-4 2))) (let ((e-25 (vector-ref arg-4 3))) (let ((e-26 (vector-ref arg-4 4))) (let ((e-27 (vector-ref arg-4 5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-23 e-24 e-25 e-26 e-5)))))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 eta-1)) e-27 '() eta-0)) clam-0))))))) ((6) (let ((e-29 (vector-ref arg-4 1))) (let ((e-30 (vector-ref arg-4 2))) (let ((e-31 (vector-ref arg-4 3))) (let ((e-32 (vector-ref arg-4 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-29 e-30 e-31 e-5)))))) (lambda (eta-0) (CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 eta-1)) e-32 eta-0)) clam-0)))))) ((7) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-34 e-35 e-5)))))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 eta-1)) e-36 '() eta-0)) clam-0))))) ((8) (let ((e-38 (vector-ref arg-4 1))) (let ((e-39 (vector-ref arg-4 2))) (let ((e-40 (vector-ref arg-4 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 8 e-38 e-39 e-5)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-40) clam-0))))) ((9) (let ((e-42 (vector-ref arg-4 1))) (let ((e-43 (vector-ref arg-4 2))) (let ((e-44 (vector-ref arg-4 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 9 e-42 e-43 e-5)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-44) clam-0))))) ((10) (let ((e-46 (vector-ref arg-4 1))) (let ((e-47 (vector-ref arg-4 2))) (let ((e-48 (vector-ref arg-4 3))) (let ((e-49 (vector-ref arg-4 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 10 e-46 e-5 eta-3 eta-4)))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-47) eta-1)) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45OptsC-45CSE-replaceConAlt arg-1 arg-2 arg-3 eta-2 eta-3))) e-48 '() eta-1)) eta-0)) (lambda (eta-0) (if (null? e-49) (vector 1 '()) (let ((e-2 (unbox e-49))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-2) eta-0)))) clam-0)))))) ((11) (let ((e-51 (vector-ref arg-4 1))) (let ((e-52 (vector-ref arg-4 2))) (let ((e-53 (vector-ref arg-4 3))) (let ((e-54 (vector-ref arg-4 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 11 e-51 e-5 eta-3 eta-4)))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-52) eta-1)) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45OptsC-45CSE-replaceConstAlt arg-1 arg-2 arg-3 eta-2 eta-3))) e-53 '() eta-1)) eta-0)) (lambda (eta-0) (if (null? e-54) (vector 1 '()) (let ((e-2 (unbox e-54))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-2) eta-0)))) clam-0)))))) ((12) (vector 1 arg-4)) ((13) (vector 1 arg-4)) (else (vector 1 arg-4))))))
(define CompilerC-45OptsC-45CSE-replaceDef (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (let ((e-9 (vector-ref e-7 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-2 (cons e-6 (vector 0 e-8 e-5)))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-0 arg-1 1 e-9) clam-0)))) ((1) (vector 1 (cons e-2 (cons e-6 e-7)))) ((2) (vector 1 (cons e-2 (cons e-6 e-7)))) (else (vector 1 (cons e-2 (cons e-6 e-7))))))))))))
(define CompilerC-45OptsC-45CSE-replaceConstAlt (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-1 e-5)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-2) ext-0)))))
(define CompilerC-45OptsC-45CSE-replaceConAlt (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-1 (vector-ref arg-4 0))) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-6 (vector-ref eta-0 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-5) ext-0))))))))
(define CompilerC-45OptsC-45CSE-newToplevelDefs (lambda (arg-0) (DataC-45List-mapMaybe (lambda (eta-0) (CompilerC-45OptsC-45CSE-n--10369-11216-u--toDef arg-0 eta-0)) (LibrariesC-45DataC-45SortedMap-toList arg-0))))
(define CompilerC-45OptsC-45CSE-dropVar (lambda (arg-2 arg-3) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (cond ((equal? arg-3 0) (box 0))(else (let ((e-4 (- arg-3 1))) (let ((sc1 (CompilerC-45OptsC-45CSE-dropVar e-3 e-4))) (if (null? sc1) '() (let ((e-1 (unbox sc1))) (box (+ 1 e-1))))))))))))
(define CompilerC-45OptsC-45CSE-dropEnv (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (u--q) (vector 0 e-2 e-3)) (CompilerC-45OptsC-45CSE-dropVar arg-1 e-2))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (box (vector 1 e-6 e-7))))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 2 e-9 e-10 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv (cons e-10 arg-1) e-11)))))) ((3) (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((e-15 (vector-ref arg-2 3))) (let ((e-16 (vector-ref arg-2 4))) (let ((e-17 (vector-ref arg-2 5))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (lambda (eta-1) (vector 3 e-13 e-14 e-15 eta-0 eta-1))) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-16)) (CompilerC-45OptsC-45CSE-dropEnv (cons e-14 arg-1) e-17)))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (lambda (eta-1) (vector 4 e-19 eta-0 eta-1))) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-20)) (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 5 e-23 e-24 e-25 e-26 eta-0)) (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-2 1))) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (let ((e-32 (vector-ref arg-2 4))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 6 e-29 e-30 e-31 eta-0)) (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 7 e-34 e-35 eta-0)) (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-38 e-39 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-40)))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 9 e-42 e-43 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-44)))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 10 e-46 eta-0 eta-1 eta-2)))) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-47)) (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropConAlt arg-1 eta-0)) e-48)) (PreludeC-45Types-u--traverse_Traversable_Maybe (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-2 1))) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 11 e-51 eta-0 eta-1 eta-2)))) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-52)) (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropConstAlt arg-1 eta-0)) e-53)) (PreludeC-45Types-u--traverse_Traversable_Maybe (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (box (vector 12 e-56 e-57))))) ((13) (let ((e-59 (vector-ref arg-2 1))) (box (vector 13 e-59)))) (else (let ((e-61 (vector-ref arg-2 1))) (let ((e-62 (vector-ref arg-2 2))) (box (vector 14 e-61 e-62))))))))
(define CompilerC-45OptsC-45CSE-dropConstAlt (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (cons e-1 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-2))))))
(define CompilerC-45OptsC-45CSE-dropConAlt (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-embed eta-0))) (CompilerC-45OptsC-45CSE-dropEnv e-4 e-5)))))))))
(define CompilerC-45OptsC-45CSE-cse (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Analysing " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-2)) " names"))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Core-newRef (vector "Compiler.Opts.CSE.Sts" ) (cons (LibrariesC-45DataC-45SortedMap-empty (vector (cons (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-450) (csegen-913) arg-4 arg-5))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-450) (csegen-913) arg-4 arg-5)))) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-989) (csegen-912) arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-989) (csegen-912) arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-989) (csegen-912) arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-989) (csegen-912) arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-989) (csegen-912) arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-989) (csegen-912) arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-989) (csegen-912) arg-430 arg-431))))) 0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (DataC-45List-mapMaybe (lambda (eta-1) eta-1) e-7)))))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45CSE-analyzeName e-6 arg-1 eta-1 eta-2))) arg-2 '() eta-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox e-6))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-0 (car e-8))) (let ((act-28 (CoreC-45Core-newRef (CompilerC-45OptsC-45CSE-ReplaceMap) (CompilerC-45OptsC-45CSE-toReplaceMap e-0) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45OptsC-45CSE-replaceDef e-9 arg-1 eta-0)) e-7 '() ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((CompilerC-45OptsC-45CSE-replaceExp e-9 arg-1 1 arg-3) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (unbox e-9))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((u--filtered (LibrariesC-45DataC-45SortedMap-toList e-12))) (let ((act-32 (CoreC-45ContextC-45Log-log arg-1 "compiler.cse" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (DataC-45String-fastUnlines (cons "Found the following unadjusted subexpressions:" (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-13 (cdr e-3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 ": count " (CompilerC-45OptsC-45CSE-u--show_Show_Count e-13))))))) u--filtered)))) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (vector 1 (cons (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45OptsC-45CSE-newToplevelDefs e-12) e-10) e-11))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45OptsC-45CSE-analyzeVect (lambda (arg-2 arg-3 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45Vect-u--unzip_Zippable_C-40VectC-32C-36kC-41 e-5)))))) (lambda (eta-0) (CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45OptsC-45CSE-analyze arg-2 eta-1)) arg-3 eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (PreludeC-45Interfaces-sum (cons (csegen-1006) (csegen-597)) e-2) e-3))))))))))
(define CompilerC-45OptsC-45CSE-analyzeSubExp (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (vector 1 (cons 1 arg-2))) ((1) (vector 1 (cons 1 arg-2))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-11) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 2 e-9 e-10 e-3))))))))))))) ((3) (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((e-15 (vector-ref arg-2 3))) (let ((e-16 (vector-ref arg-2 4))) (let ((e-17 (vector-ref arg-2 5))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-16) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-17) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (+ (+ e-2 e-7) 1) (vector 3 e-13 e-14 e-15 e-3 e-4))))))))))))))))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-20) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CompilerC-45OptsC-45CSE-analyzeList arg-1 e-21 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (+ (+ e-2 e-7) 1) (vector 4 e-19 e-3 e-4))))))))))))))))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (let ((act-24 (CompilerC-45OptsC-45CSE-analyzeList arg-1 e-27 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 5 e-23 e-24 e-25 e-26 e-3))))))))))))))) ((6) (let ((e-29 (vector-ref arg-2 1))) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (let ((e-32 (vector-ref arg-2 4))) (let ((act-24 (CompilerC-45OptsC-45CSE-analyzeVect arg-1 e-32 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 6 e-29 e-30 e-31 e-3)))))))))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((act-24 (CompilerC-45OptsC-45CSE-analyzeList arg-1 e-36 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 7 e-34 e-35 e-3))))))))))))) ((8) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-40) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 8 e-38 e-39 e-3))))))))))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-44) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 9 e-42 e-43 e-3))))))))))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-47) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-1020) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45CSE-analyzeConAlt arg-1 eta-1 eta-2))) e-48 '() eta-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-26 (CompilerC-45OptsC-45CSE-analyzeMaybe arg-1 e-49 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (vector 1 (cons (+ (+ (+ e-2 (PreludeC-45Interfaces-sum (csegen-1021) e-7)) e-10) 1) (vector 10 e-46 e-3 e-4 e-9)))))))))))))))))))))))))) ((11) (let ((e-51 (vector-ref arg-2 1))) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-52) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-1020) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45CSE-analyzeConstAlt arg-1 eta-1 eta-2))) e-53 '() eta-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-26 (CompilerC-45OptsC-45CSE-analyzeMaybe arg-1 e-54 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (vector 1 (cons (+ (+ (+ e-2 (PreludeC-45Interfaces-sum (csegen-1021) e-7)) e-10) 1) (vector 11 e-51 e-3 e-4 e-9)))))))))))))))))))))))))) ((12) (vector 1 (cons 1 arg-2))) ((13) (vector 1 (cons 1 arg-2))) (else (vector 1 (cons 1 arg-2))))))
(define CompilerC-45OptsC-45CSE-analyzeName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((e-18 (vector-ref e-1 18))) (if (null? e-18) (vector 1 '()) (let ((e-25 (unbox e-18))) (let ((act-26 (CompilerC-45OptsC-45CSE-analyzeDef arg-0 e-25 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-26 (vector-ref act-26 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-26 1))) (vector 1 (box (cons arg-2 (cons (let ((e-48 (vector-ref e-1 0))) e-48) e-26)))))))))))))))))))))))
(define CompilerC-45OptsC-45CSE-analyzeMaybe (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 (cons 0 '())) (let ((e-2 (unbox arg-2))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-4 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-4 (box e-3)))))))))))))
(define CompilerC-45OptsC-45CSE-analyzeList (lambda (arg-1 arg-2 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-1020) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45OptsC-45CSE-analyze arg-1 eta-1)) arg-2 '() eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (PreludeC-45Interfaces-sum (csegen-1021) e-2) e-3))))))))))
(define CompilerC-45OptsC-45CSE-analyzeDef (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-0 (Builtin-snd e-5))))))) (CompilerC-45OptsC-45CSE-analyze arg-0 e-1) ext-0)))) ((1) (vector 1 arg-1)) ((2) (vector 1 arg-1)) (else (vector 1 arg-1)))))
(define CompilerC-45OptsC-45CSE-analyzeConstAlt (lambda (arg-1 arg-2 ext-0) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-4 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-4 1) (cons e-1 e-3)))))))))))))
(define CompilerC-45OptsC-45CSE-analyzeConAlt (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-24 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (vector 1 (cons (+ e-8 1) (vector e-1 e-2 e-3 e-4 e-7))))))))))))))))
(define CompilerC-45OptsC-45CSE-analyze (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((6) (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0))) ((7) (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0))) ((8) (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0))) ((9) (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0)))(else (lambda (eta-0) (let ((act-24 (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((_-0 (cons e-2 e-3))) (CompilerC-45OptsC-45CSE-case--caseC-32blockC-32inC-32analyze-9100 arg-1 arg-2 e-2 e-3 _-0 (CompilerC-45OptsC-45CSE-dropEnv '() e-3) eta-0)))))))))))))
(define CompilerC-45OptsC-45CSE-ReplaceMap(blodwen-lazy (lambda () (vector "Libraries.Data.SortedMap.SortedMap" (vector "Core.Name.Name" ) (vector "Builtin.Pair" (vector "Core.CompileExpr.CExp" '()) (vector "Compiler.Opts.CSE.Count" ))))))
(define CompilerC-45Inline-case--caseC-32blockC-32inC-32mergeLamDef-5235 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((1) (let ((e-0 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (let ((sc3 (DataC-45List-isNil (let ((e-21 (vector-ref e-5 21))) e-21)))) (cond ((equal? sc3 1) 0) (else (let ((e-6 (vector-ref e-0 2))) e-6)))))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((e-18 (vector-ref arg-3 18))) (if (null? e-18) (vector 1 0) (let ((e-28 (unbox e-18))) (let ((act-25 ((CompilerC-45Inline-mergeLam arg-1 e-28) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-29 (vector-ref act-25 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-25 1))) (CoreC-45Context-setCompiled arg-1 arg-0 e-29 ext-0)))))))))))))))))(else (vector 1 0)))))
(define CompilerC-45Inline-case--caseC-32blockC-32inC-32updateCallGraph-5045 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox arg-5))) (let ((u--refs (CompilerC-45Inline-getRefs e-1))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45Context-addDef arg-1 arg-0 (let ((e-0 (vector-ref arg-3 0))) (let ((e-22 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((e-7 (vector-ref arg-3 7))) (let ((e-8 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (let ((e-10 (vector-ref arg-3 10))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (let ((e-17 (vector-ref arg-3 17))) (let ((e-18 (vector-ref arg-3 18))) (let ((e-19 (vector-ref arg-3 19))) (let ((e-20 (vector-ref arg-3 20))) (let ((e-21 (vector-ref arg-3 21))) (vector e-0 e-22 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (box u--refs) e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-1)) eta-0)))))))
(define CompilerC-45Inline-case--mergeLambdas-4578 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--expNs (CoreC-45CompileExpr-substs e-2 arg-1 e-6 e-7))) (let ((u--newArgs (PreludeC-45TypesC-45List-reverse (CompilerC-45Inline-getNewArgs e-2 e-6)))) (let ((u--expLocs (CoreC-45CompileExpr-mkLocals (CoreC-45TTC-45SizeOf-mkSizeOf arg-1) (CompilerC-45Inline-mkBounds u--newArgs) u--expNs))) (cons (PreludeC-45TypesC-45List-tailRecAppend arg-1 (PreludeC-45TypesC-45List-tailRecAppend u--newArgs '())) u--expLocs))))))))))
(define CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-2501 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2)))) (let ((e-1 (unbox arg-14))) (let ((u--arity (CompilerC-45Inline-getArity e-1))) (lambda (clam-0) (let ((sc1 (let ((sc2 (PreludeC-45Types-elem (csegen-1023) (vector 0 ) (let ((e-11 (vector-ref arg-12 11))) e-11)))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-elem (csegen-802) arg-2 arg-6))) (cond ((equal? sc3 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc1 1) (let ((act-24 ((CompilerC-45Inline-tryApply arg-0 arg-1 arg-8 arg-7 (cons arg-2 arg-6) arg-4 arg-5 e-1) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (DataC-45Maybe-fromMaybe (lambda () (CompilerC-45Inline-unloadApp u--arity arg-4 (vector 1 arg-3 arg-2))) e-5))))))) (else (vector 1 (CompilerC-45Inline-unloadApp u--arity arg-4 (vector 1 arg-3 arg-2))))))))))))
(define CompilerC-45Inline-case--eval-2354 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (cond ((equal? e-2 1) (if (null? e-3) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-8))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-2501 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-2 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18)) eta-0))))))))))))) (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (lambda (clam-0) (if (null? e-6) (let ((act-24 (let ((act-24 (unbox arg-8))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-7 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2))) (let ((e-1 (unbox e-8))) (let ((_-0 (box e-1))) ((CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-2501 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-2 e-7 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18)) clam-0)))))))))))) (let ((e-8 (car e-6))) (let ((e-9 (cdr e-6))) (if (null? e-9) (let ((act-24 (let ((act-24 (unbox arg-8))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-7 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2))) (let ((e-1 (unbox e-10))) (let ((_-0 (box e-1))) ((CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-2501 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-2 e-7 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18)) clam-0)))))))))))) (let ((e-11 (car e-9))) (let ((e-12 (cdr e-9))) (let ((act-24 (CompilerC-45Inline-genName arg-7 "act" clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-eval '() arg-1 arg-8 arg-7 arg-6 '() '() (vector 4 arg-3 e-8 (cons (vector 1 arg-3 e-7) (cons e-11 '())))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (CompilerC-45Inline-unload e-12 (vector 3 arg-3 e-7 0 (vector 4 arg-3 e-5 (cons e-11 '())) (CompilerC-45Inline-refToLocal e-7 e-7 e-10)))))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-8))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-2501 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-2 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18)) eta-0)))))))))))))))))))
(define CompilerC-45Inline-n--8575-3119-u--updateLoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 arg-15 arg-16) (if (null? arg-13) arg-15 (cond ((equal? arg-12 0) (let ((e-8 (cdr arg-15))) (cons arg-16 e-8)))(else (let ((e-0 (- arg-12 1))) (let ((e-11 (cdr arg-13))) (let ((e-15 (car arg-15))) (let ((e-16 (cdr arg-15))) (cons e-15 (CompilerC-45Inline-n--8575-3119-u--updateLoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-0 e-11 e-16 arg-16)))))))))))
(define CompilerC-45Inline-n--8575-3120-u--update (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-12 0) ((0) (let ((e-2 (vector-ref arg-12 1))) (CompilerC-45Inline-n--8575-3119-u--updateLoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 arg-11 arg-13 arg-14)))(else arg-13))))
(define CompilerC-45Inline-n--10804-4205-u--traverseArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 ext-0) (if (null? arg-8) (vector 1 '()) (let ((e-3 (car arg-8))) (let ((e-4 (cdr arg-8))) (let ((act-24 ((CompilerC-45Inline-fixArityTm arg-7 arg-5 e-3 '()) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45Inline-n--10804-4205-u--traverseArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6)))))))))))))))
(define CompilerC-45Inline-n--12547-5553-u--transform (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) (lambda (eta-0) (vector 1 0)))(else (let ((e-0 (- arg-1 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-inlineDef arg-0 eta-1 eta-2))) arg-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-mergeLamDef arg-0 eta-1 eta-2))) arg-2 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45CaseOpts-caseLamDef arg-0 eta-1 eta-2))) arg-2 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-fixArityDef arg-0 eta-1 eta-2))) arg-2 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45InlineHeuristics-inlineHeuristics arg-0 eta-1 eta-2))) arg-2 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45ConstantFold-constantFold arg-0 eta-1 eta-2))) arg-2 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45Identity-setIdentity arg-0 eta-1 eta-2))) arg-2 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else ((CompilerC-45Inline-n--12547-5553-u--transform arg-0 e-0 arg-2) eta-0))))))))))))))))))))))))))))
(define CompilerC-45Inline-n--12547-5554-u--nonErased (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (vector 1 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (let ((e-7 (vector-ref e-1 7))) e-7) (csegen-21)))))))))))))))
(define CompilerC-45Inline-n--8610-3630-u--matches (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23) (if (null? arg-21) (if (null? arg-23) (CoreC-45Name-u--C-61C-61_Eq_Name arg-20 arg-22) 0) (let ((e-1 (unbox arg-21))) (if (null? arg-23) 0 (let ((e-4 (unbox arg-23))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-1 e-4)))))))
(define CompilerC-45Inline-n--10804-4367-u--fixArityConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (let ((act-24 ((CompilerC-45Inline-fixArityTm arg-0 arg-6 e-2 '()) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-1 e-5))))))))))
(define CompilerC-45Inline-n--10804-4314-u--fixArityAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (let ((act-24 ((CompilerC-45Inline-fixArityTm (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-6 e-5 '()) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))))))))))
(define CompilerC-45Inline-usedConst (lambda (arg-1 arg-2 arg-4) (let ((e-2 (cdr arg-4))) (CompilerC-45Inline-used arg-1 arg-2 e-2))))
(define CompilerC-45Inline-usedCon (lambda (arg-1 arg-2 arg-4) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (CompilerC-45Inline-used (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-1) (CoreC-45TT-u--weakenNs_Weaken_Var (CoreC-45TTC-45SizeOf-mkSizeOf e-4) arg-2) e-5)))))
(define CompilerC-45Inline-used (lambda (arg-1 arg-2 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-2 e-2))) (cond ((equal? sc1 1) 1) (else 0))))) ((2) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (CompilerC-45Inline-used (cons e-7 arg-1) (+ 1 arg-2) e-8)))) ((3) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (cond ((equal? e-12 0) (let ((u--usedl (bs+ (CompilerC-45Inline-used arg-1 arg-2 e-13) (CompilerC-45Inline-used (cons e-11 arg-1) (+ 1 arg-2) e-14) 63))) (let ((sc2 (PreludeC-45EqOrd-u--C-62_Ord_Int u--usedl 0))) (cond ((equal? sc2 1) (blodwen-toSignedInt 1000 63)) (else u--usedl))))) ((equal? e-12 1) (bs+ (CompilerC-45Inline-used arg-1 arg-2 e-13) (CompilerC-45Inline-used (cons e-11 arg-1) (+ 1 arg-2) e-14) 63))(else 0))))))) ((4) (let ((e-17 (vector-ref arg-4 2))) (let ((e-18 (vector-ref arg-4 3))) (PreludeC-45Types-u--foldr_Foldable_List (csegen-1026) (CompilerC-45Inline-used arg-1 arg-2 e-17) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0)) e-18))))) ((5) (let ((e-24 (vector-ref arg-4 5))) (PreludeC-45Types-u--foldr_Foldable_List (csegen-1026) 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0)) e-24)))) ((6) (let ((e-29 (vector-ref arg-4 4))) (DataC-45Vect-u--foldr_Foldable_C-40VectC-32C-36nC-41 (csegen-1026) 0 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0)) e-29)))) ((7) (let ((e-33 (vector-ref arg-4 3))) (PreludeC-45Types-u--foldr_Foldable_List (csegen-1026) 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0)) e-33)))) ((8) (let ((e-37 (vector-ref arg-4 3))) (CompilerC-45Inline-used arg-1 arg-2 e-37))) ((9) (let ((e-41 (vector-ref arg-4 3))) (CompilerC-45Inline-used arg-1 arg-2 e-41))) ((10) (let ((e-44 (vector-ref arg-4 2))) (let ((e-45 (vector-ref arg-4 3))) (let ((e-46 (vector-ref arg-4 4))) (bs+ (CompilerC-45Inline-used arg-1 arg-2 e-44) (CompilerC-45Inline-largest (csegen-224) (PreludeC-45Types-maybe (lambda () (blodwen-toSignedInt 0 63)) (lambda () (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0))) e-46) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45Inline-usedCon arg-1 arg-2 eta-0)) e-45)) 63))))) ((11) (let ((e-49 (vector-ref arg-4 2))) (let ((e-50 (vector-ref arg-4 3))) (let ((e-51 (vector-ref arg-4 4))) (bs+ (CompilerC-45Inline-used arg-1 arg-2 e-49) (CompilerC-45Inline-largest (csegen-224) (PreludeC-45Types-maybe (lambda () (blodwen-toSignedInt 0 63)) (lambda () (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0))) e-51) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45Inline-usedConst arg-1 arg-2 eta-0)) e-50)) 63)))))(else 0))))
(define CompilerC-45Inline-updateCallGraph (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((CompilerC-45Inline-case--caseC-32blockC-32inC-32updateCallGraph-5045 arg-1 arg-0 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18)) ext-0))))))))))))))
(define CompilerC-45Inline-unloadApp (lambda (arg-1 arg-2 arg-3) (CompilerC-45Inline-unload (DataC-45List-drop arg-1 arg-2) (vector 4 (CoreC-45CompileExpr-getFC arg-3) arg-3 (DataC-45List-take arg-1 arg-2)))))
(define CompilerC-45Inline-unload (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (CompilerC-45Inline-unload e-3 (vector 4 (CoreC-45CompileExpr-getFC arg-2) arg-2 (cons e-2 '()))))))))
(define CompilerC-45Inline-tryApply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (lambda (clam-0) (let ((sc1 (CompilerC-45Inline-takeFromStack arg-6 arg-5 e-0))) (if (null? sc1) (vector 1 '()) (let ((e-2 (unbox sc1))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((act-24 ((CompilerC-45Inline-eval (PreludeC-45TypesC-45List-tailRecAppend e-0 arg-0) arg-1 arg-2 arg-3 arg-4 e-5 e-6 (CoreC-45CompileExpr-embed e-1)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (box e-7)))))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CompilerC-45Inline-takeFromStack (lambda (arg-2 arg-3 arg-4) (if (null? arg-3) (if (null? arg-4) (PreludeC-45Types-u--pure_Applicative_Maybe (cons arg-2 arg-3)) '()) (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (if (null? arg-4) (if (null? arg-4) (PreludeC-45Types-u--pure_Applicative_Maybe (cons arg-2 arg-3)) '()) (let ((e-7 (cdr arg-4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CompilerC-45Inline-takeFromStack arg-2 e-4 e-7) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-5 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (cons e-3 e-2) e-5)))))))))))))
(define CompilerC-45Inline-refToLocal (lambda (arg-1 arg-2 arg-3) (CoreC-45CompileExpr-refsToLocals (vector 1 arg-2 arg-1 (vector 0 )) arg-3)))
(define CompilerC-45Inline-pickConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-7 0) ((12) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (if (null? arg-8) (lambda (eta-0) (if (null? arg-9) (vector 1 '()) (let ((e-3 (unbox arg-9))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) eta-0)))) (let ((e-5 (car arg-8))) (let ((e-6 (cdr arg-8))) (if (null? e-5) (lambda (eta-0) (vector 1 '())) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-2 e-8))) (cond ((equal? sc3 1) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-9) eta-0))) (else (CompilerC-45Inline-pickConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 12 e-1 e-2) e-6 arg-9)))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CompilerC-45Inline-pickAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-7 0) ((5) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (if (null? arg-8) (lambda (eta-0) (if (null? arg-9) (vector 1 '()) (let ((e-6 (unbox arg-9))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6) eta-0)))) (let ((e-8 (car arg-8))) (let ((e-9 (cdr arg-8))) (let ((e-11 (vector-ref e-8 0))) (let ((e-12 (vector-ref e-8 1))) (let ((e-13 (vector-ref e-8 2))) (let ((e-14 (vector-ref e-8 3))) (let ((e-15 (vector-ref e-8 4))) (let ((u--con (vector 5 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CompilerC-45Inline-n--8610-3630-u--matches e-12 arg-1 e-5 e-4 e-3 e-2 e-1 u--con e-14 arg-0 e-15 e-13 e-11 e-9 arg-9 arg-6 arg-5 arg-4 arg-3 arg-2 e-2 e-4 e-11 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45LengthMatch-checkLengthMatch e-5 e-14))) (if (null? sc3) (lambda (eta-0) (vector 1 '())) (let ((e-6 (unbox sc3))) (let ((u--envC-39 (CompilerC-45Inline-extend arg-5 e-5 e-14 e-6))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval (PreludeC-45TypesC-45List-C-43C-43 e-14 arg-0) arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-15) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (box e-7)))))))))))) (else (CompilerC-45Inline-pickAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--con e-9 arg-9)))))))))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CompilerC-45Inline-mkBounds (lambda (arg-0) (if (null? arg-0) (vector 0 ) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (vector 1 e-2 e-2 (CompilerC-45Inline-mkBounds e-3)))))))
(define CompilerC-45Inline-mergeLambdas (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (CompilerC-45Inline-case--mergeLambdas-4578 e-2 arg-0 e-3 e-1 (CompilerC-45Inline-getLams '() 0 '() (vector 2 e-1 e-2 e-3)))))))(else (cons arg-0 arg-1)))))
(define CompilerC-45Inline-mergeLamDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (CompilerC-45Inline-case--caseC-32blockC-32inC-32mergeLamDef-5235 arg-1 arg-0 e-5 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17) ext-0))))))))))))))
(define CompilerC-45Inline-mergeLam (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((sc1 (CompilerC-45Inline-mergeLambdas e-0 e-1))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (vector 1 (vector 0 e-2 e-3))))))))(else (vector 1 arg-1))))))
(define CompilerC-45Inline-largest (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) arg-2 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (let ((e-4 (vector-ref arg-1 3))) ((e-4 e-2) arg-2)))) (cond ((equal? sc1 1) (CompilerC-45Inline-largest arg-1 e-2 e-3)) (else (CompilerC-45Inline-largest arg-1 arg-2 e-3)))))))))
(define CompilerC-45Inline-inlineDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((e-18 (vector-ref e-1 18))) (if (null? e-18) (vector 1 0) (let ((e-25 (unbox e-18))) (let ((act-26 (CompilerC-45Inline-inline arg-0 arg-1 e-25 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-26 (vector-ref act-26 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-26 1))) (CoreC-45Context-setCompiled arg-0 arg-1 e-26 ext-0))))))))))))))))))))
(define CompilerC-45Inline-inline (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (let ((act-24 (CompilerC-45Inline-doEval e-0 arg-0 arg-1 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-0 e-5)))))))))(else (vector 1 arg-2)))))
(define CompilerC-45Inline-getRefs (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CompilerC-45Inline-addRefs (LibrariesC-45DataC-45NameMap-empty) e-1)))(else (LibrariesC-45DataC-45NameMap-empty)))))
(define CompilerC-45Inline-getNewArgs (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (case (vector-ref e-8 0) ((1) (let ((e-12 (vector-ref e-8 2))) (cons e-12 (CompilerC-45Inline-getNewArgs e-3 e-9))))(else (cons e-2 (CompilerC-45Inline-getNewArgs e-3 e-9)))))))))))
(define CompilerC-45Inline-getLams (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (CompilerC-45Inline-getLams (cons e-2 arg-1) (bs+ arg-2 1 63) (cons (vector 1 e-1 (vector 2 "ext" arg-2)) arg-3) e-3)))))(else (cons arg-1 (cons arg-3 arg-4))))))
(define CompilerC-45Inline-getArity (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45List-length e-0))) ((1) (let ((e-3 (vector-ref arg-0 2))) e-3)) ((2) (let ((e-6 (vector-ref arg-0 2))) (PreludeC-45TypesC-45List-length e-6))) (else 0))))
(define CompilerC-45Inline-genName (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))))))
(define CompilerC-45Inline-fixArityTm (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (CompilerC-45Inline-unload arg-3 (vector 1 e-2 e-3))) (let ((e-1 (unbox e-6))) (let ((u--arity (let ((e-18 (vector-ref e-1 18))) (if (null? e-18) 0 (let ((e-27 (unbox e-18))) (CompilerC-45Inline-getArity e-27)))))) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 u--arity (vector 4 e-2 (vector 1 e-2 e-3) '()) arg-3))))))))))))))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-fixArityTm (cons e-6 arg-0) arg-1 e-7 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 2 e-5 e-6 e-8) arg-3))))))))))) ((3) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (let ((e-13 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-12 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-fixArityTm (cons e-10 arg-0) arg-1 e-13 '()) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 3 e-9 e-10 e-11 e-5 e-6) arg-3))))))))))))))))) ((4) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (u--tm) (CompilerC-45Inline-fixArityTm arg-0 arg-1 u--tm '())) e-17 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-16 (PreludeC-45TypesC-45List-tailRecAppend e-5 arg-3)) eta-0))))))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((e-23 (vector-ref arg-2 5))) (lambda (clam-0) (if (null? arg-3) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (u--tm) (CompilerC-45Inline-fixArityTm arg-0 arg-1 u--tm '())) e-23 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-19 e-20 e-21 e-22 e-5)))))) (if (null? arg-3) (vector 1 arg-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 arg-2 arg-3))))))))))) ((6) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (lambda (clam-1) (if (null? arg-3) (let ((act-24 (CompilerC-45Inline-n--10804-4205-u--traverseArgs arg-0 e-25 e-28 e-27 e-26 arg-1 arg-0 e-28 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-25 e-26 e-27 e-5)))))) (if (null? arg-3) (vector 1 arg-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 arg-2 arg-3)))))))))) ((7) (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (lambda (clam-2) (if (null? arg-3) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (u--tm) (CompilerC-45Inline-fixArityTm arg-0 arg-1 u--tm '())) e-32 '() clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 7 e-30 e-31 e-5)))))) (if (null? arg-3) (vector 1 arg-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 arg-2 arg-3))))))))) ((8) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-36 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 8 e-34 e-35 e-5) arg-3))))))))))) ((9) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-40 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 9 e-38 e-39 e-5) arg-3))))))))))) ((10) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (let ((e-45 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-43 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-n--10804-4314-u--fixArityAlt arg-0 e-45 e-44 e-43 e-42 arg-3 arg-1 eta-1 eta-2))) e-44 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-45) (vector 1 '()) (let ((e-2 (unbox e-45))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-fixArityTm arg-0 arg-1 e-2 '()) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 10 e-42 e-5 e-6 e-7) arg-3)))))))))))))))))))) ((11) (let ((e-47 (vector-ref arg-2 1))) (let ((e-48 (vector-ref arg-2 2))) (let ((e-49 (vector-ref arg-2 3))) (let ((e-50 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-48 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-n--10804-4367-u--fixArityConstAlt arg-0 e-50 e-49 e-48 e-47 arg-3 arg-1 eta-1 eta-2))) e-49 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-50) (vector 1 '()) (let ((e-2 (unbox e-50))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-fixArityTm arg-0 arg-1 e-2 '()) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 11 e-47 e-5 e-6 e-7) arg-3))))))))))))))))))))(else (lambda (clam-3) (if (null? arg-3) (vector 1 arg-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 arg-2 arg-3))))))))
(define CompilerC-45Inline-fixArityExp (lambda (arg-0 arg-1 arg-2) (CompilerC-45Inline-fixArityTm arg-0 arg-1 arg-2 '())))
(define CompilerC-45Inline-fixArityDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((e-18 (vector-ref e-1 18))) (if (null? e-18) (vector 1 0) (let ((e-25 (unbox e-18))) (let ((act-26 (CompilerC-45Inline-fixArity arg-0 e-25 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-26 (vector-ref act-26 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-26 1))) (CoreC-45Context-setCompiled arg-0 arg-1 e-26 ext-0))))))))))))))))))))
(define CompilerC-45Inline-fixArity (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-24 ((CompilerC-45Inline-fixArityTm e-0 arg-0 e-1 '()) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-0 e-5))))))))) ((3) (let ((e-2 (vector-ref arg-1 1))) (let ((act-24 ((CompilerC-45Inline-fixArityTm '() arg-0 e-2 '()) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5))))))))(else (vector 1 arg-1)))))
(define CompilerC-45Inline-extendLoc (lambda (arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 (cons (vector 0 ) arg-4)) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-24 (CompilerC-45Inline-genName arg-2 "cv" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45Inline-extendLoc arg-2 arg-3 arg-4 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (vector 1 e-2 e-5 e-7) (cons (vector 1 arg-3 e-5) e-4))))))))))))))))))
(define CompilerC-45Inline-extend (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-3) (cond ((equal? arg-5 0) arg-2)(else (blodwen-error-quit "Nat case not covered"))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-9 (cdr arg-4))) (cond ((equal? arg-5 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-16 (- arg-5 1))) (cons e-2 (CompilerC-45Inline-extend arg-2 e-3 e-9 e-16)))))))))))
(define CompilerC-45Inline-evalLocal (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-1) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-7 (vector 0 arg-9 arg-5)))) (let ((e-3 (cdr arg-1))) (let ((e-7 (car arg-8))) (let ((e-8 (cdr arg-8))) (cond ((equal? arg-9 0) (if (null? arg-7) (lambda (eta-0) (vector 1 e-7)) (CompilerC-45Inline-eval e-3 arg-2 arg-3 arg-4 arg-6 e-8 arg-7 (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp (CoreC-45TTC-45SizeOf-mkSizeOf e-3) e-7))))(else (let ((e-9 (- arg-9 1))) (CompilerC-45Inline-evalLocal e-3 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-8 e-9))))))))))
(define CompilerC-45Inline-evalConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-1 e-5)))))) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2) ext-0)))))
(define CompilerC-45Inline-evalAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-1 (vector-ref arg-8 0))) (let ((e-2 (vector-ref arg-8 1))) (let ((e-3 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 3))) (let ((e-5 (vector-ref arg-8 4))) (let ((act-24 (CompilerC-45Inline-extendLoc arg-3 arg-4 arg-6 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((act-25 ((CompilerC-45Inline-eval (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-1 arg-2 arg-3 arg-5 e-7 arg-7 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-refsToLocals e-8 e-9))))))))))))))))))))
(define CompilerC-45Inline-eval (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-65 (vector-ref arg-7 1))) (let ((e-66 (vector-ref arg-7 2))) (CompilerC-45Inline-evalLocal arg-0 arg-1 arg-2 arg-3 e-66 arg-4 arg-6 arg-5 e-65)))) ((1) (let ((e-69 (vector-ref arg-7 1))) (let ((e-70 (vector-ref arg-7 2))) (CompilerC-45Inline-case--eval-2354 arg-0 arg-1 e-70 e-69 arg-6 arg-5 arg-4 arg-3 arg-2 (cons (CoreC-45Name-u--C-61C-61_Eq_Name e-70 (vector 0 (CoreC-45NameC-45Namespace-primIONS) (vector 1 (vector 0 "io_bind")))) arg-6)))))(else (if (null? arg-6) (case (vector-ref arg-7 0) ((2) (let ((e-56 (vector-ref arg-7 1))) (let ((e-57 (vector-ref arg-7 2))) (let ((e-58 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (CompilerC-45Inline-genName arg-3 "lamv" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-eval (cons e-57 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-56 e-5) arg-5) '() e-58) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-56 e-57 (CompilerC-45Inline-refToLocal e-5 e-57 e-6))))))))))))))))(else (case (vector-ref arg-7 0) ((3) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (cond ((equal? e-3 0) (lambda (eta-0) (let ((act-24 (CompilerC-45Inline-genName arg-3 "letv" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-1 e-6) arg-5) '() e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 3 e-1 e-2 0 e-8 (CompilerC-45Inline-refToLocal e-6 e-2 e-7)))))))))))))))))) (else (let ((u--u (CompilerC-45Inline-used (cons e-2 (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1)) 0 e-5))) (lambda (clam-0) (let ((sc3 (PreludeC-45EqOrd-u--C-60_Ord_Int u--u 1))) (cond ((equal? sc3 1) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons e-6 arg-5) arg-6 e-5) clam-0)))))) (else (let ((act-24 (CompilerC-45Inline-genName arg-3 "letv" clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-1 e-6) arg-5) arg-6 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (vector 3 e-1 e-2 1 e-8 (CompilerC-45Inline-refToLocal e-6 e-2 e-7)))))))))))))))))))))))))))) ((4) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-9 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-5 arg-6) e-8) eta-0))))))))) ((5) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (let ((e-15 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-15 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 5 e-11 e-12 e-13 e-14 e-5)))))))))))))) ((6) (let ((e-17 (vector-ref arg-7 1))) (let ((e-18 (vector-ref arg-7 2))) (let ((e-19 (vector-ref arg-7 3))) (let ((e-20 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-20 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 6 e-17 e-18 e-19 e-5))))))))))))) ((7) (let ((e-22 (vector-ref arg-7 1))) (let ((e-23 (vector-ref arg-7 2))) (let ((e-24 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-24 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 7 e-22 e-23 e-5)))))))))))) ((8) (let ((e-26 (vector-ref arg-7 1))) (let ((e-27 (vector-ref arg-7 2))) (let ((e-28 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-28) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((9) (let ((e-3 (vector-ref e-5 3))) ((CompilerC-45Inline-eval '() arg-1 arg-2 arg-3 arg-4 '() arg-6 e-3) eta-0)))(else (vector 1 (CompilerC-45Inline-unload arg-6 (vector 8 e-26 e-27 e-5)))))))))))))) ((9) (let ((e-30 (vector-ref arg-7 1))) (let ((e-31 (vector-ref arg-7 2))) (let ((e-32 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-32) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 9 e-30 e-31 e-5)))))))))))) ((10) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (let ((e-37 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-35) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--envC-39 (CompilerC-45Inline-n--8575-3120-u--update arg-0 arg-1 e-37 e-36 e-35 e-34 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-35 arg-5 e-5))) (let ((act-25 ((CompilerC-45Inline-pickAlt arg-0 arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-5 e-36 e-37) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (if (null? e-37) (vector 1 '()) (let ((e-2 (unbox e-37))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-2) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-evalAlt arg-0 arg-1 arg-2 arg-3 e-34 arg-4 u--envC-39 arg-6 eta-1 eta-2))) e-36 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CompilerC-45CaseOpts-caseOfCase (vector 10 e-34 e-5 e-8 e-7))))))))))) (let ((e-2 (unbox e-6))) (vector 1 e-2)))))))))))))))))) ((11) (let ((e-39 (vector-ref arg-7 1))) (let ((e-40 (vector-ref arg-7 2))) (let ((e-41 (vector-ref arg-7 3))) (let ((e-42 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-40) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-pickConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-41 e-42) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (if (null? e-42) (vector 1 '()) (let ((e-2 (unbox e-42))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-evalConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-1 eta-2))) e-41 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CompilerC-45CaseOpts-caseOfCase (vector 11 e-39 e-5 e-8 e-7))))))))))) (let ((e-2 (unbox e-6))) (vector 1 e-2))))))))))))))))) ((12) (let ((e-44 (vector-ref arg-7 1))) (let ((e-45 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 12 e-44 e-45))))))) ((13) (let ((e-47 (vector-ref arg-7 1))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 13 e-47)))))) (else (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 14 e-49 e-50)))))))))) (let ((e-53 (car arg-6))) (let ((e-54 (cdr arg-6))) (case (vector-ref arg-7 0) ((2) (let ((e-61 (vector-ref arg-7 2))) (let ((e-62 (vector-ref arg-7 3))) (CompilerC-45Inline-eval (cons e-61 arg-0) arg-1 arg-2 arg-3 arg-4 (cons e-53 arg-5) e-54 e-62))))(else (case (vector-ref arg-7 0) ((3) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (cond ((equal? e-3 0) (lambda (eta-0) (let ((act-24 (CompilerC-45Inline-genName arg-3 "letv" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-1 e-6) arg-5) '() e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 3 e-1 e-2 0 e-8 (CompilerC-45Inline-refToLocal e-6 e-2 e-7)))))))))))))))))) (else (let ((u--u (CompilerC-45Inline-used (cons e-2 (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1)) 0 e-5))) (lambda (clam-1) (let ((sc3 (PreludeC-45EqOrd-u--C-60_Ord_Int u--u 1))) (cond ((equal? sc3 1) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons e-6 arg-5) arg-6 e-5) clam-1)))))) (else (let ((act-24 (CompilerC-45Inline-genName arg-3 "letv" clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-1 e-6) arg-5) arg-6 e-5) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (vector 3 e-1 e-2 1 e-8 (CompilerC-45Inline-refToLocal e-6 e-2 e-7)))))))))))))))))))))))))))) ((4) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-9 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-5 arg-6) e-8) eta-0))))))))) ((5) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (let ((e-15 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-15 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 5 e-11 e-12 e-13 e-14 e-5)))))))))))))) ((6) (let ((e-17 (vector-ref arg-7 1))) (let ((e-18 (vector-ref arg-7 2))) (let ((e-19 (vector-ref arg-7 3))) (let ((e-20 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-20 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 6 e-17 e-18 e-19 e-5))))))))))))) ((7) (let ((e-22 (vector-ref arg-7 1))) (let ((e-23 (vector-ref arg-7 2))) (let ((e-24 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-24 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 7 e-22 e-23 e-5)))))))))))) ((8) (let ((e-26 (vector-ref arg-7 1))) (let ((e-27 (vector-ref arg-7 2))) (let ((e-28 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-28) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((9) (let ((e-3 (vector-ref e-5 3))) ((CompilerC-45Inline-eval '() arg-1 arg-2 arg-3 arg-4 '() arg-6 e-3) eta-0)))(else (vector 1 (CompilerC-45Inline-unload arg-6 (vector 8 e-26 e-27 e-5)))))))))))))) ((9) (let ((e-30 (vector-ref arg-7 1))) (let ((e-31 (vector-ref arg-7 2))) (let ((e-32 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-32) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 9 e-30 e-31 e-5)))))))))))) ((10) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (let ((e-37 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-35) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--envC-39 (CompilerC-45Inline-n--8575-3120-u--update arg-0 arg-1 e-37 e-36 e-35 e-34 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-35 arg-5 e-5))) (let ((act-25 ((CompilerC-45Inline-pickAlt arg-0 arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-5 e-36 e-37) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (if (null? e-37) (vector 1 '()) (let ((e-2 (unbox e-37))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-2) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-evalAlt arg-0 arg-1 arg-2 arg-3 e-34 arg-4 u--envC-39 arg-6 eta-1 eta-2))) e-36 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CompilerC-45CaseOpts-caseOfCase (vector 10 e-34 e-5 e-8 e-7))))))))))) (let ((e-2 (unbox e-6))) (vector 1 e-2)))))))))))))))))) ((11) (let ((e-39 (vector-ref arg-7 1))) (let ((e-40 (vector-ref arg-7 2))) (let ((e-41 (vector-ref arg-7 3))) (let ((e-42 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-40) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45Inline-pickConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-41 e-42) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (if (null? e-42) (vector 1 '()) (let ((e-2 (unbox e-42))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-evalConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-1 eta-2))) e-41 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CompilerC-45CaseOpts-caseOfCase (vector 11 e-39 e-5 e-8 e-7))))))))))) (let ((e-2 (unbox e-6))) (vector 1 e-2))))))))))))))))) ((12) (let ((e-44 (vector-ref arg-7 1))) (let ((e-45 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 12 e-44 e-45))))))) ((13) (let ((e-47 (vector-ref arg-7 1))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 13 e-47)))))) (else (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 14 e-49 e-50)))))))))))))))))
(define CompilerC-45Inline-doEval (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Compiler.Inline.LVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "compiler.inline.eval" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-2) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 arg-0 arg-3)))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CompilerC-45Inline-eval '() arg-0 arg-1 e-5 '() '() '() arg-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "compiler.inline.eval" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Inlined: " (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 arg-0 e-7))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-7)))))))))))))))))
(define CompilerC-45Inline-compileAndInlineAll (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ns (LibrariesC-45DataC-45NameMap-keys (let ((e-24 (vector-ref e-5 24))) e-24)))) (let ((act-25 (CoreC-45Core-filterM (lambda (eta-0) (lambda (eta-1) (CompilerC-45Inline-n--12547-5554-u--nonErased arg-0 eta-0 eta-1))) u--ns ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CompilerC-45CompileExpr-compileDef arg-0 eta-0 eta-1))) e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CompilerC-45OptsC-45Identity-rewriteIdentityFlag arg-0 eta-0 eta-1))) e-6 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CompilerC-45Inline-n--12547-5553-u--transform arg-0 (+ 1 (+ 1 (+ 1 0))) e-6) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CompilerC-45Inline-updateCallGraph arg-0 eta-0 eta-1))) e-6 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((sc7 (DataC-45List-isNil (let ((e-21 (vector-ref e-11 21))) e-21)))) (cond ((equal? sc7 1) (vector 1 0)) (else (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CompilerC-45Inline-addArityHash arg-0 eta-0 eta-1))) e-6 ext-0)))))))))))))))))))))))))))))))
(define CompilerC-45Inline-addRefsConstAlts (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (cdr e-2))) (CompilerC-45Inline-addRefsConstAlts (CompilerC-45Inline-addRefs arg-1 e-6) e-3)))))))
(define CompilerC-45Inline-addRefsConAlts (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-9 (vector-ref e-2 4))) (CompilerC-45Inline-addRefsConAlts (CompilerC-45Inline-addRefs arg-1 e-9) e-3)))))))
(define CompilerC-45Inline-addRefsArgs (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CompilerC-45Inline-addRefsArgs (CompilerC-45Inline-addRefs arg-1 e-2) e-3))))))
(define CompilerC-45Inline-addRefs (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 2))) (LibrariesC-45DataC-45NameMap-insert e-2 0 arg-1))) ((2) (let ((e-6 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefs arg-1 e-6))) ((3) (let ((e-11 (vector-ref arg-2 4))) (let ((e-12 (vector-ref arg-2 5))) (CompilerC-45Inline-addRefs (CompilerC-45Inline-addRefs arg-1 e-11) e-12)))) ((4) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefsArgs (CompilerC-45Inline-addRefs arg-1 e-15) e-16)))) ((5) (let ((e-19 (vector-ref arg-2 2))) (let ((e-22 (vector-ref arg-2 5))) (CompilerC-45Inline-addRefsArgs (LibrariesC-45DataC-45NameMap-insert e-19 0 arg-1) e-22)))) ((6) (let ((e-27 (vector-ref arg-2 4))) (CompilerC-45Inline-addRefsArgs arg-1 (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 e-27)))) ((7) (let ((e-31 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefsArgs arg-1 e-31))) ((8) (let ((e-35 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefs arg-1 e-35))) ((9) (let ((e-39 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefs arg-1 e-39))) ((10) (let ((e-42 (vector-ref arg-2 2))) (let ((e-43 (vector-ref arg-2 3))) (let ((e-44 (vector-ref arg-2 4))) (let ((u--dsC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (eta-0) (CompilerC-45Inline-addRefs arg-1 eta-0))) e-44))) (CompilerC-45Inline-addRefsConAlts (CompilerC-45Inline-addRefs u--dsC-39 e-42) e-43)))))) ((11) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (let ((u--dsC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (eta-0) (CompilerC-45Inline-addRefs arg-1 eta-0))) e-49))) (CompilerC-45Inline-addRefsConstAlts (CompilerC-45Inline-addRefs u--dsC-39 e-47) e-48))))))(else arg-1))))
(define CompilerC-45Inline-addArityHash (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((e-18 (vector-ref e-1 18))) (if (null? e-18) (vector 1 0) (let ((e-25 (unbox e-18))) (case (vector-ref e-25 0) ((0) (let ((e-27 (vector-ref e-25 1))) (let ((sc5 (let ((e-40 (vector-ref e-1 9))) e-40))) (cond ((equal? sc5 0) (vector 1 0))(else (CoreC-45Context-addHash arg-0 (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-817) (csegen-819) arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-817) (csegen-819) arg-568 arg-569)))) (cons arg-1 (PreludeC-45TypesC-45List-length e-27)) ext-0))))))(else (vector 1 0))))))))))))))))))
(define LibrariesC-45DataC-45LengthMatch-checkLengthMatch (lambda (arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) (box 0) '()) (let ((e-3 (cdr arg-2))) (if (null? arg-3) '() (let ((e-11 (cdr arg-3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45LengthMatch-checkLengthMatch e-3 e-11) (lambda (bind-0) (box (+ 1 bind-0))))))))))
(define CompilerC-45OptsC-45InlineHeuristics-case--caseC-32blockC-32inC-32inlineHeuristics-1514 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (vector 1 0) (let ((e-1 (unbox arg-6))) (let ((sc1 (CompilerC-45OptsC-45InlineHeuristics-inlineCDef arg-1 e-1))) (cond ((equal? sc1 1) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "compiler.inline.heuristic" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "inlining heuristic decided to inline: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Context-setFlag arg-0 (vector 2 ) (vector 8 arg-3) (vector 0 ) clam-0))))) (else (vector 1 0)))))))))
(define CompilerC-45OptsC-45InlineHeuristics-simple (lambda (arg-0 arg-2) (case (vector-ref arg-2 0) ((0) 1) ((1) 1) ((2) 0) ((3) 0) ((4) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (case (vector-ref e-20 0) ((1) (let ((e-65 (vector-ref e-20 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-65))) (cond ((equal? sc2 1) 0) (else (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-21))))))(else (let ((sc1 (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 e-20))) (cond ((equal? sc1 1) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-21)) (else 0)))))))) ((5) (let ((e-27 (vector-ref arg-2 5))) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-27))) ((6) (let ((e-32 (vector-ref arg-2 4))) (PreludeC-45Interfaces-all (csegen-1006) (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-32))) ((7) (let ((e-36 (vector-ref arg-2 3))) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-36))) ((8) (let ((e-40 (vector-ref arg-2 3))) (CompilerC-45OptsC-45InlineHeuristics-simple arg-0 e-40))) ((9) (let ((e-44 (vector-ref arg-2 3))) (CompilerC-45OptsC-45InlineHeuristics-simple arg-0 e-44))) ((10) 0) ((11) 0) ((12) 1) ((13) 1) (else 0))))
(define CompilerC-45OptsC-45InlineHeuristics-isVar (lambda (arg-0 arg-2) (case (vector-ref arg-2 0) ((0) 1) ((1) 1) ((8) (let ((e-11 (vector-ref arg-2 3))) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 e-11))) ((9) (let ((e-15 (vector-ref arg-2 3))) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 e-15)))(else 0))))
(define CompilerC-45OptsC-45InlineHeuristics-inlineHeuristics (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExactI arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((_-0 (box (cons e-8 e-7)))) ((CompilerC-45OptsC-45InlineHeuristics-case--caseC-32blockC-32inC-32inlineHeuristics-1514 arg-0 arg-1 e-5 e-8 e-7 _-0 (let ((e-18 (vector-ref e-7 18))) e-18)) ext-0))))))))))))))))
(define CompilerC-45OptsC-45InlineHeuristics-inlineCDef (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (CompilerC-45OptsC-45InlineHeuristics-simple arg-0 e-1)))(else 0))))
(define CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32getFieldArgs-5354 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (vector 1 '())) (let ((e-2 (cdr arg-9))) (if (null? e-2) (lambda (eta-0) (vector 1 '())) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (let ((act-24 (CompilerC-45CompileExpr-getFieldArgs arg-2 arg-1 e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45CompileExpr-getPArgs arg-2 arg-1 e-4 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-25 1))) (let ((e-10 (car e-9))) (let ((e-3 (cdr e-9))) (vector 1 (cons (cons e-10 e-3) e-6)))))))))))) (vector 1 '())))))))))))))
(define CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32getPArgs-5165 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-7 "Badly formed struct type") clam-0) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (if (null? e-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-7 "Badly formed struct type") clam-0) (let ((e-4 (car e-2))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 e-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (case (vector-ref e-6 0) ((8) (let ((e-3 (vector-ref e-6 2))) (case (vector-ref e-3 0) ((10) (let ((e-8 (vector-ref e-3 1))) (vector 1 (cons e-8 e-1))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc e-6) "Unknown field name") clam-0)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc e-6) "Unknown field name") clam-0)))))))))))))))
(define CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32conCases-3947 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((5) (let ((e-2 (vector-ref arg-12 3))) (if (null? e-2) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-8 arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (CompilerC-45CompileExpr-mkDropSubst 0 (let ((e-3 (vector-ref arg-10 3))) e-3) arg-1 arg-0))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (let ((act-25 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) arg-8 arg-7 arg-6 arg-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-conCases arg-1 arg-8 arg-7 arg-6 arg-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc6 (CompilerC-45CompileExpr-n--10677-3895-u--dcon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (let ((e-17 (vector-ref arg-10 17))) e-17)))) (cond ((equal? sc6 1) (let ((act-27 (CompilerC-45CompileExpr-dconFlag arg-8 e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons (vector e-5 e-8 (box arg-3) e-4 (CoreC-45CompileExpr-shrinkCExp e-3 e-6)) e-7))))))) (else (let ((act-27 (CompilerC-45CompileExpr-dconFlag arg-8 e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons (vector e-5 e-8 '() e-4 (CoreC-45CompileExpr-shrinkCExp e-3 e-6)) e-7))))))))))))))))))))))))) (CompilerC-45CompileExpr-conCases arg-1 arg-8 arg-7 arg-6 arg-5))))(else (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-8 arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (CompilerC-45CompileExpr-mkDropSubst 0 (let ((e-3 (vector-ref arg-10 3))) e-3) arg-1 arg-0))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-25 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) arg-8 arg-7 arg-6 arg-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-conCases arg-1 arg-8 arg-7 arg-6 arg-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc4 (CompilerC-45CompileExpr-n--10677-3895-u--dcon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (let ((e-17 (vector-ref arg-10 17))) e-17)))) (cond ((equal? sc4 1) (let ((act-27 (CompilerC-45CompileExpr-dconFlag arg-8 e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons (vector e-5 e-8 (box arg-3) e-2 (CoreC-45CompileExpr-shrinkCExp e-3 e-6)) e-7))))))) (else (let ((act-27 (CompilerC-45CompileExpr-dconFlag arg-8 e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons (vector e-5 e-8 '() e-2 (CoreC-45CompileExpr-shrinkCExp e-3 e-6)) e-7)))))))))))))))))))))))))))))
(define CompilerC-45CompileExpr-case--toCExp-3692 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-toCExp arg-0 arg-5 arg-4 (lambda (vars-3746) (arg-3 'erased)) arg-2 eta-0)) e-3 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-5))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-toCExpTm arg-0 arg-5 arg-4 (lambda (vars-3729) (arg-3 'erased)) arg-2 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-numArgs e-6 e-2) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((2) (let ((e-0 (vector-ref e-8 1))) (let ((u--res (CompilerC-45CompileExpr-expandToArity arg-0 e-0 e-7 e-5))) (vector 1 ((arg-3 'erased) u--res))))) ((0) (let ((e-1 (vector-ref e-8 1))) (let ((e-4 (vector-ref e-8 2))) (let ((u--res (CompilerC-45CompileExpr-applyNewType arg-0 e-1 e-4 e-7 e-5))) (vector 1 ((arg-3 'erased) u--res)))))) (else (let ((e-9 (vector-ref e-8 1))) (let ((e-4 (vector-ref e-8 2))) (let ((u--res (CompilerC-45CompileExpr-eraseConArgs arg-0 e-9 e-4 e-7 e-5))) (vector 1 ((arg-3 'erased) u--res)))))))))))))))))))))))))))
(define CompilerC-45CompileExpr-n--13614-6491-u--toLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (cond ((equal? arg-9 1) (case (vector-ref arg-10 0) ((0) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (vector 0 '() (CompilerC-45CompileExpr-lamRHS e-0 e-1)))))(else arg-10)))(else arg-10))))
(define CompilerC-45CompileExpr-n--9635-2857-u--toEnum (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (cond ((equal? e-2 4) (if (null? e-3) '() (let ((e-7 (unbox e-3))) (if (null? e-4) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (vector 0 e-7) e-5)) '()))))(else '()))))))))
(define CompilerC-45CompileExpr-n--13614-6753-u--toArgExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (vector 0 arg-7 (CoreC-45FC-emptyFC))))
(define CompilerC-45CompileExpr-n--13614-6614-u--toArgExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6) (vector 0 arg-6 (CoreC-45FC-emptyFC))))
(define CompilerC-45CompileExpr-n--14312-7096-u--noDefYet (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (if (null? arg-3) 0 1))(else 0))))
(define CompilerC-45CompileExpr-n--10689-4302-u--mkSubst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) '() (let ((e-3 (cdr arg-15))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-12 arg-14))) (cond ((equal? sc1 1) (cons arg-13 (CompilerC-45CompileExpr-n--10689-4302-u--mkSubst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) arg-12) arg-13 arg-14 e-3))) (else (cons (vector 13 arg-8) (CompilerC-45CompileExpr-n--10689-4302-u--mkSubst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) arg-12) arg-13 arg-14 e-3)))))))))
(define CompilerC-45CompileExpr-n--8216-1570-u--mkLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (vector 0 arg-5 arg-4)))
(define CompilerC-45CompileExpr-n--8216-1571-u--mkApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (case (vector-ref arg-4 0) ((4) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (vector 4 e-1 e-2 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-5)))))) ((5) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((e-8 (vector-ref arg-4 4))) (let ((e-9 (vector-ref arg-4 5))) (vector 5 e-5 e-6 e-7 e-8 (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-5)))))))) ((7) (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (vector 7 e-11 e-12 (PreludeC-45TypesC-45List-tailRecAppend e-13 arg-5))))))(else (vector 4 (CoreC-45CompileExpr-getFC arg-4) arg-4 arg-5))))))
(define CompilerC-45CompileExpr-n--13568-6420-u--lamBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CompilerC-45CompileExpr-n--13568-6420-u--lamBind arg-0 arg-1 arg-2 e-3 (vector 2 arg-2 e-2 arg-4)))))))
(define CompilerC-45CompileExpr-n--8420-1753-u--keepArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6) (case (vector-ref arg-6 0) ((2) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (vector 2 e-1 e-2 (CompilerC-45CompileExpr-n--8420-1753-u--keepArg arg-0 arg-1 arg-2 arg-3 arg-4 e-3)))))) ((5) (let ((e-9 (vector-ref arg-6 5))) (CompilerC-45CompileExpr-n--8420-1752-u--keep arg-0 arg-1 arg-2 arg-3 arg-4 0 e-9)))(else (vector 13 (CoreC-45CompileExpr-getFC arg-2))))))
(define CompilerC-45CompileExpr-n--8420-1752-u--keep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (if (null? arg-7) (vector 13 (CoreC-45CompileExpr-getFC arg-2)) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-6 arg-3))) (cond ((equal? sc1 1) e-2) (else (CompilerC-45CompileExpr-n--8420-1752-u--keep arg-0 arg-1 arg-2 arg-3 arg-4 (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) arg-6) e-3)))))))))
(define CompilerC-45CompileExpr-n--8827-2111-u--go (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (CompilerC-45CompileExpr-n--8827-2110-u--fire arg-1 arg-2 e-2 arg-4))) (if (null? sc1) (CompilerC-45CompileExpr-n--8827-2111-u--go arg-1 arg-2 e-3 arg-4) (let ((e-4 (unbox sc1))) e-4))))))))
(define CompilerC-45CompileExpr-n--13614-6754-u--getVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) (if (null? arg-8) '() (let ((e-3 (cdr arg-8))) (cons 0 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45CompileExpr-weakenVar eta-0)) (CompilerC-45CompileExpr-n--13614-6754-u--getVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)))))))
(define CompilerC-45CompileExpr-n--13614-6615-u--getVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-7) (if (null? arg-7) '() (let ((e-3 (cdr arg-7))) (cons 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CompileExpr-weakenVar eta-0)) (CompilerC-45CompileExpr-n--13614-6615-u--getVars arg-0 arg-1 arg-2 arg-3 arg-4 e-3)))))))
(define CompilerC-45CompileExpr-n--8827-2110-u--fire (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-0 (vector-ref arg-3 1))) (let ((e-1 (vector-ref arg-3 2))) (let ((e-2 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((5) (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-11 (vector-ref arg-4 5))) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (CoreC-45Name-u--C-61C-61_Eq_Name e-0 e-8)) (lambda () (PreludeC-45Types-u--map_Functor_Maybe ((e-2 e-7) 'erased) (DataC-45Vect-toVect e-1 e-11))))))))(else '())))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((4) (let ((e-13 (vector-ref arg-4 1))) (let ((e-14 (vector-ref arg-4 2))) (let ((e-15 (vector-ref arg-4 3))) (case (vector-ref e-14 0) ((1) (let ((e-17 (vector-ref e-14 1))) (let ((e-18 (vector-ref e-14 2))) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (CoreC-45Name-u--C-61C-61_Eq_Name e-3 e-18)) (lambda () (PreludeC-45Types-u--map_Functor_Maybe (((e-5 e-13) e-17) 'erased) (DataC-45Vect-toVect e-4 e-15)))))))(else '()))))))(else '()))))))(else '()))))
(define CompilerC-45CompileExpr-n--10677-3895-u--dcon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((5) 1)(else 0))))
(define CompilerC-45CompileExpr-n--9869-3052-u--ciFlags (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) 0 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((9) (let ((e-4 (vector-ref e-2 1))) e-4))(else (CompilerC-45CompileExpr-n--9869-3052-u--ciFlags arg-0 arg-1 e-3))))))))
(define CompilerC-45CompileExpr-n--8316-1671-u--applyAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (CompilerC-45CompileExpr-n--8316-1671-u--applyAll arg-0 arg-1 arg-2 (vector 4 (CoreC-45CompileExpr-getFC arg-3) arg-3 (cons e-2 '())) e-3))))))
(define CompilerC-45CompileExpr-n--8316-1693-u--addArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((4) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (vector 4 e-1 e-2 (PreludeC-45TypesC-45List-tailRecAppend e-3 (cons arg-6 '()))))))) ((5) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (let ((e-9 (vector-ref arg-5 5))) (vector 5 e-5 e-6 e-7 e-8 (PreludeC-45TypesC-45List-tailRecAppend e-9 (cons arg-6 '()))))))))) ((7) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (vector 7 e-11 e-12 (PreludeC-45TypesC-45List-tailRecAppend e-13 (cons arg-6 '())))))))(else (vector 4 (CoreC-45CompileExpr-getFC arg-5) arg-5 (cons arg-6 '()))))))
(define CompilerC-45CompileExpr-weakenVar (lambda (arg-2) (+ 1 arg-2)))
(define CompilerC-45CompileExpr-unitTree (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((10) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (DataC-45Maybe-fromMaybe (let ((u--exp (vector 10 e-1 e-2 e-3 e-4))) (lambda () (lambda (eta-0) (vector 1 u--exp)))) (if (null? e-3) '() (let ((e-6 (car e-3))) (let ((e-5 (cdr e-3))) (let ((e-10 (vector-ref e-6 1))) (let ((e-7 (vector-ref e-6 3))) (let ((e-8 (vector-ref e-6 4))) (cond ((equal? e-10 10) (if (null? e-7) (if (null? e-5) (box (lambda (clam-0) (case (vector-ref e-2 0) ((0) (vector 1 e-8))(else (let ((act-24 (CompilerC-45CompileExpr-newMN arg-1 "_unit" clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-12 (vector-ref act-24 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-24 1))) (vector 1 (vector 3 e-1 e-12 0 e-2 (CoreC-45CompileExpr-u--weaken_Weaken_CExp e-8))))))))))) '()) '()))(else '()))))))))))))))(else (lambda (eta-0) (vector 1 arg-2))))))
(define CompilerC-45CompileExpr-tryZBranch (lambda (arg-1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (cond ((equal? e-2 8) (if (null? e-4) (box e-5) '()))(else '())))))))
(define CompilerC-45CompileExpr-trySBranch (lambda (arg-1 arg-2) (let ((e-2 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (cond ((equal? e-2 9) (if (null? e-4) '() (let ((e-7 (car e-4))) (let ((e-8 (cdr e-4))) (if (null? e-8) (box (vector 3 (CoreC-45CompileExpr-getFC arg-1) e-7 1 (CompilerC-45CompileExpr-magic__natUnsuc (CoreC-45CompileExpr-getFC arg-1) (CoreC-45CompileExpr-getFC arg-1) (cons arg-1 '())) e-5)) '())))))(else '())))))))
(define CompilerC-45CompileExpr-toCExpTreeC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (if (null? e-5) (lambda (eta-0) (vector 1 (vector 14 (CoreC-45TT-getLoc e-4) (PreludeC-45TypesC-45String-C-43C-43 "Missing case tree in " (CoreC-45Name-u--show_Show_Name arg-3))))) (let ((e-13 (car e-5))) (let ((e-14 (cdr e-5))) (case (vector-ref e-13 0) ((0) (let ((e-17 (vector-ref e-13 1))) (let ((e-18 (vector-ref e-13 2))) (let ((e-19 (vector-ref e-13 3))) (let ((e-20 (vector-ref e-13 4))) (let ((u--fc (CoreC-45TT-getLoc e-4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-getNewType arg-0 arg-1 arg-2 u--fc (vector 0 e-2 u--fc) arg-3 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--alts (cons (vector 0 e-17 e-18 e-19 e-20) e-14))) (if (null? e-6) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 ((CompilerC-45CompileExpr-conCases arg-0 arg-1 arg-2 arg-3 u--alts) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-getDef arg-0 arg-1 arg-2 arg-3 u--alts) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-27 1))) (let ((sc8 (DataC-45List-isNil e-8))) (cond ((equal? sc8 1) (vector 1 (DataC-45Maybe-fromMaybe (lambda () (vector 13 u--fc)) e-9))) (else (let ((act-28 ((CompilerC-45CompileExpr-builtinNatTree arg-2 (vector 10 u--fc (vector 0 e-2 u--fc) e-8 e-9)) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-28 1))) ((CompilerC-45CompileExpr-unitTree arg-2 (CompilerC-45CompileExpr-enumTree e-10)) eta-0))))))))))))))))))) (let ((e-3 (unbox e-6))) (vector 1 e-3))))))))))))))) ((1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Unexpected DelayCase") eta-0))) ((2) (let ((u--fc (CoreC-45TT-getLoc e-4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-constCases arg-0 arg-1 arg-2 arg-3 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CompileExpr-getDef arg-0 arg-1 arg-2 arg-3 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-25 1))) (let ((sc5 (DataC-45List-isNil e-6))) (cond ((equal? sc5 1) (vector 1 (DataC-45Maybe-fromMaybe (lambda () (vector 13 u--fc)) e-7))) (else (vector 1 (vector 11 u--fc (vector 0 e-2 u--fc) e-6 e-7)))))))))))))))) (else (let ((e-29 (vector-ref e-13 1))) (CompilerC-45CompileExpr-toCExpTree arg-0 arg-1 arg-2 arg-3 e-29))))))))))) ((1) (let ((e-8 (vector-ref arg-4 2))) (lambda (eta-0) (let ((act-24 (CompilerC-45CompileExpr-builtinMagic arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 (lambda (vars-5029) (e-5 'erased)) arg-3 e-8) eta-0)))))))) ((2) (let ((e-10 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (vector 14 (CoreC-45FC-emptyFC) e-10))))) (else (lambda (eta-0) (vector 1 (vector 14 (CoreC-45FC-emptyFC) (PreludeC-45TypesC-45String-C-43C-43 "Impossible case encountered in " (CoreC-45Name-u--show_Show_Name arg-3)))))))))
(define CompilerC-45CompileExpr-toCExpTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (if (null? e-5) (CompilerC-45CompileExpr-toCExpTreeC-39 arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-7 (car e-5))) (case (vector-ref e-7 0) ((1) (let ((e-10 (vector-ref e-7 1))) (let ((e-11 (vector-ref e-7 2))) (let ((e-12 (vector-ref e-7 3))) (let ((u--fc (CoreC-45TT-getLoc e-4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-toCExpTree (cons e-10 (cons e-11 arg-0)) arg-1 arg-2 arg-3 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector 3 u--fc e-11 1 (vector 8 u--fc 0 (vector 0 e-2 (CoreC-45TT-getLoc e-4))) (vector 3 u--fc e-10 1 (vector 13 u--fc) e-6)))))))))))))(else (CompilerC-45CompileExpr-toCExpTreeC-39 arg-0 arg-1 arg-2 arg-3 arg-4)))))))))(else (CompilerC-45CompileExpr-toCExpTreeC-39 arg-0 arg-1 arg-2 arg-3 arg-4)))))
(define CompilerC-45CompileExpr-toCExpTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 3))) (lambda (eta-0) (vector 1 (vector 0 e-4 e-2)))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (lambda (clam-0) (case (vector-ref e-8 0) ((2) (let ((e-50 (vector-ref e-8 1))) (let ((act-24 (CoreC-45Context-getFullName arg-1 e-9 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45CompileExpr-dconFlag arg-1 e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 4) (vector 1 (vector 12 e-7 (vector 0 e-50)))) ((equal? e-6 8) (vector 1 (vector 12 e-7 (vector 5 0)))) ((equal? e-6 9) (let ((act-26 (CompilerC-45CompileExpr-newMN arg-2 "succ" clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 2 e-7 e-10 (vector 6 (+ 1 (+ 1 0)) e-7 (vector 0 (vector 19 )) (cons (vector 12 e-7 (vector 5 1)) (cons (vector 0 0 e-7) '()))))))))))(else (vector 1 (vector 5 e-7 e-5 e-6 (box e-50) '())))))))))))))) ((3) (vector 1 (vector 5 e-7 e-9 1 '() '())))(else (let ((act-24 (CoreC-45Context-getFullName arg-1 e-9 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 4 e-7 (vector 1 e-7 e-5) '()))))))))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-14 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 (lambda (vars-3347) (arg-3 'erased)) arg-4 eta-1)) e-14 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 4 e-11 (vector 1 e-11 e-12) e-5))))))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (lambda (clam-1) (case (vector-ref e-18 0) ((0) (let ((act-24 ((CompilerC-45CompileExpr-toCExp (cons e-17 arg-0) arg-1 arg-2 (lambda (vars-3373) (arg-3 'erased)) arg-4 e-19) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-16 e-17 e-5))))))) ((1) (let ((e-61 (vector-ref e-18 2))) (let ((e-62 (vector-ref e-18 3))) (let ((act-24 ((CompilerC-45CompileExpr-toCExp (cons e-17 arg-0) arg-1 arg-2 (lambda (vars-3400) (arg-3 'erased)) arg-4 e-19) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 (lambda (vars-3411) (arg-3 'erased)) arg-4 e-62) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (AlgebraC-45Semiring-branchZero (csegen-475) (lambda () (CoreC-45CompileExpr-shrinkCExp (vector 1 (vector 0 )) e-5)) (lambda () (vector 3 e-16 e-17 1 e-6 e-5)) e-61))))))))))))) ((2) (let ((e-68 (vector-ref e-18 4))) (let ((act-24 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 (lambda (vars-3451) (arg-3 'erased)) arg-4 e-68) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CompileExpr-toCExp (cons e-17 arg-0) arg-1 arg-2 (lambda (vars-3462) (arg-3 'erased)) arg-4 e-19) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-16 (vector 1 (vector 0 "->")) 1 '() (cons e-5 (cons (vector 2 e-16 e-17 e-6) '()))))))))))))))(else (vector 1 (vector 13 e-16)))))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 (lambda (vars-3501) (arg-3 'erased)) arg-4 e-22) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 (lambda (vars-3512) (arg-3 'erased)) arg-4 e-23) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-21 e-5 (cons e-6 '())))))))))))))))) ((5) (let ((e-28 (vector-ref arg-5 4))) (CompilerC-45CompileExpr-toCExpTm arg-0 arg-1 arg-2 (lambda (vars-3540) (arg-3 'erased)) arg-4 e-28))) ((6) (let ((e-30 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 13 e-30))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-37 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 (lambda (vars-3568) (arg-3 'erased)) arg-4 e-37) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 9 e-34 e-35 e-5))))))))))) ((8) (let ((e-39 (vector-ref arg-5 1))) (let ((e-40 (vector-ref arg-5 2))) (let ((e-41 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 (lambda (vars-3587) (arg-3 'erased)) arg-4 e-41) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-39 e-40 e-5))))))))))) ((9) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (let ((u--t (CoreC-45TT-constTag e-44))) (lambda (clam-2) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--t 0))) (cond ((equal? sc1 1) (vector 1 (vector 12 e-43 e-44))) (else (vector 1 (vector 5 e-43 (vector 1 (vector 0 (CoreC-45TT-u--show_Show_Constant e-44))) 1 '() '())))))))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 13 e-46))))) (else (let ((e-49 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 5 e-49 (vector 1 (vector 0 "Type")) 1 '() '()))))))))
(define CompilerC-45CompileExpr-toCExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (eta-0) (CompilerC-45CompileExpr-case--toCExp-3692 arg-0 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-5) eta-0))))
(define CompilerC-45CompileExpr-toCDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 (vector 14 (CoreC-45FC-emptyFC) (PreludeC-45TypesC-45String-C-43C-43 "Encountered undefined name " (CoreC-45Name-u--show_Show_Name e-5))))))))))) ((1) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (let ((e-2 (vector-ref arg-4 3))) (let ((e-3 (vector-ref arg-4 4))) (let ((e-4 (vector-ref arg-4 5))) (lambda (clam-0) (let ((sc1 (CompilerC-45CompileExpr-mkSub 0 e-1 arg-3))) (let ((e-6 (car sc1))) (let ((e-5 (cdr sc1))) (let ((act-24 (CoreC-45Core-newRef (vector "Compiler.CompileExpr.NextMN" ) 0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CompileExpr-toCExpTree e-1 arg-0 e-7 arg-1 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (CompilerC-45CompileExpr-n--13614-6491-u--toLam e-1 e-2 e-4 e-3 e-0 arg-3 arg-2 arg-1 arg-0 (let ((e-9 (vector-ref e-0 2))) e-9) (let ((sc4 (DataC-45List-isNil arg-3))) (cond ((equal? sc4 1) (vector 0 e-1 e-8)) (else (vector 0 e-6 (CoreC-45CompileExpr-shrinkCExp e-5 e-8))))))))))))))))))))))))) ((2) (let ((e-5 (vector-ref arg-4 1))) (lambda (clam-1) (let ((sc1 (CompilerC-45CompileExpr-mkArgList 0 e-5))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector 0 e-2 (vector 7 (CoreC-45FC-emptyFC) e-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CompileExpr-n--13614-6614-u--toArgExp arg-3 e-5 arg-2 arg-1 arg-0 eta-0)) (CompilerC-45CompileExpr-n--13614-6615-u--getVars arg-3 e-5 arg-2 arg-1 arg-0 e-3))))))))))))))) ((3) (let ((e-7 (vector-ref arg-4 2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-getCFTypes arg-0 '() e-8) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (vector 1 (vector 2 e-7 e-2 e-3))))))))))))))) ((4) (let ((e-8 (vector-ref arg-4 1))) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-2) (let ((sc1 (CompilerC-45CompileExpr-mkArgList 0 e-8))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (vector 1 (vector 0 e-2 (vector 6 e-8 (CoreC-45FC-emptyFC) e-9 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45CompileExpr-n--13614-6753-u--toArgExp arg-3 e-8 e-9 arg-2 arg-1 arg-0 eta-0)) (CompilerC-45CompileExpr-n--13614-6754-u--getVars arg-3 e-8 e-9 arg-2 arg-1 arg-0 e-3)))))))))))) ((5) (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((u--nt (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-snd eta-0)) e-12))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CompileExpr-numArgs e-5 (vector 1 (vector 2 ) (vector 2 e-10 e-11) arg-1)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--arityC-39 (case (vector-ref e-6 0) ((0) (let ((e-0 (vector-ref e-6 1))) e-0)) ((1) (let ((e-2 (vector-ref e-6 1))) (let ((e-3 (vector-ref e-6 2))) (PreludeC-45Types-prim__integerToNat (- e-2 (PreludeC-45TypesC-45List-length e-3)))))) (else (let ((e-4 (vector-ref e-6 1))) e-4))))) (vector 1 (vector 1 (box e-10) u--arityC-39 u--nt))))))))))))))))) ((6) (let ((e-14 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 1 '() e-14 '()))))) ((7) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 (vector 14 (CoreC-45FC-emptyFC) (PreludeC-45TypesC-45String-C-43C-43 "Encountered unimplemented hole " (CoreC-45Name-u--show_Show_Name e-5))))))))))) ((9) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 (vector 14 (CoreC-45FC-emptyFC) (PreludeC-45TypesC-45String-C-43C-43 "Encountered constrained hole " (CoreC-45Name-u--show_Show_Name e-5))))))))))) ((8) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 (vector 14 (CoreC-45FC-emptyFC) (PreludeC-45TypesC-45String-C-43C-43 "Encountered incomplete proof search " (CoreC-45Name-u--show_Show_Name e-5)))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 (vector 14 (CoreC-45FC-emptyFC) (PreludeC-45TypesC-45String-C-43C-43 "Encountered uncompilable name " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (csegen-1034)) (cons e-5 arg-4)))))))))))))))
(define CompilerC-45CompileExpr-numArgs (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (case (vector-ref e-2 0) ((3) (let ((e-5 (vector-ref e-2 2))) (vector 1 (vector 2 e-5))))(else (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-3 (let ((e-0 (vector-ref arg-1 0))) e-0)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 2 0)) (let ((e-4 (unbox e-5))) (let ((e-17 (vector-ref e-4 17))) (case (vector-ref e-17 0) ((5) (let ((e-28 (vector-ref e-17 2))) (let ((e-27 (vector-ref e-17 3))) (if (null? e-27) (vector 1 (vector 1 e-28 (let ((e-48 (vector-ref e-4 3))) e-48))) (let ((e-30 (unbox e-27))) (if (null? e-30) (vector 1 (vector 2 0)) (let ((e-31 (cdr e-30))) (vector 1 (vector 0 e-28 e-31))))))))) ((1) (let ((e-30 (vector-ref e-17 2))) (vector 1 (vector 1 (PreludeC-45TypesC-45List-length e-30) (let ((e-50 (vector-ref e-4 3))) e-50))))) ((2) (let ((e-27 (vector-ref e-17 1))) (vector 1 (vector 2 e-27)))) ((3) (let ((e-28 (vector-ref e-17 1))) (vector 1 (vector 2 e-28)))) ((4) (let ((e-28 (vector-ref e-17 1))) (vector 1 (vector 2 e-28))))(else (vector 1 (vector 2 0))))))))))))))))(else (vector 1 (vector 2 0)))))))
(define CompilerC-45CompileExpr-nfToCFType (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-37 (vector-ref arg-3 2))) (case (vector-ref e-37 0) ((14) (lambda (eta-0) (vector 1 (vector 1 )))) ((19) (lambda (eta-0) (vector 1 (vector 2 )))) ((20) (lambda (eta-0) (vector 1 (vector 7 )))) ((21) (lambda (eta-0) (vector 1 (vector 8 )))) ((22) (lambda (eta-0) (vector 1 (vector 9 )))) ((23) (lambda (eta-0) (vector 1 (vector 10 )))) ((15) (lambda (eta-0) (vector 1 (vector 3 )))) ((16) (lambda (eta-0) (vector 1 (vector 4 )))) ((17) (lambda (eta-0) (vector 1 (vector 5 )))) ((18) (lambda (eta-0) (vector 1 (vector 6 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((8) (let ((e-31 (vector-ref arg-3 2))) (case (vector-ref e-31 0) ((24) (lambda (eta-0) (vector 1 (vector 11 ))))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-0) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-1) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-0))))))))))))))))))))))(else (lambda (clam-2) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-2))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-3) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-3))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-3))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-2))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-2))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-1) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-1)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-5) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-5))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-1)))))))))))))))))))(else (lambda (clam-6) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-6))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-7) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-7))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-6))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-6))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-2) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-2))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-2))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-9) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-9))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-9))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-2))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-2))))))))))))))))))))))(else (lambda (clam-10) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-10))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-10))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-10))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-10))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-11) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-11))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-11))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-10))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-10))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-10))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-10))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-10))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-10))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-3) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-3)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-3))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-3))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-13) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-13))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-13))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-3))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-3))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-3))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-3)))))))))))))))))))(else (lambda (clam-14) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-14))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-14))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-14))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-14))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-15) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-15))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-15))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-14))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-14))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-14))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-14))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-14))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-14))))))))))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-4) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-4))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-4))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-4))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-4))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-17) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-17))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-17))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-4))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-4))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-4))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-4))))))))))))))))))))))(else (lambda (clam-18) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-18))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-18))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-18))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-18))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-19) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-19))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-19))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-18))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-18))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-18))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-18))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-18))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-18))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-5) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-5)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-5))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-21) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-21))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-21))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-5))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-5)))))))))))))))))))(else (lambda (clam-22) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-22))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-22))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-22))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-22))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-23) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-23))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-23))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-22))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-22))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-22))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-22))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-22))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-22))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-6) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-6))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-6))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-25) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-25))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-25))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-6))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-6))))))))))))))))))))))(else (lambda (clam-26) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-26))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-26))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-26))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-26))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-27) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-27))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-27))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-26))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-26))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-26))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-26))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-26))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-26))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-7) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-7)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-7))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-29) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-29))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-29))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-7))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-7)))))))))))))))))))(else (lambda (clam-30) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-30))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-30))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-30))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-30))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-31) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-31))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-31))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-30))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-30))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-30))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-30))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-30))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-30))))))))))))))))))))))) ((equal? arg-2 1) (case (vector-ref arg-3 0) ((8) (let ((e-34 (vector-ref arg-3 2))) (case (vector-ref e-34 0) ((24) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "String not allowed in a foreign struct") eta-0)))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-8) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-8))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-8))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-8))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-8))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-8))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-8))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-8))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-8))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-33) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-33))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-33))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-8))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-8))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-8))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-8))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-8))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-8))))))))))))))))))))))(else (lambda (clam-34) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-34))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-34))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-34))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-34))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-35) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-35))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-35))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-34))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-34))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-34))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-34))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-34))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-34))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-9) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-9)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-9))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-9))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-9))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-9))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-37) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-37))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-37))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-9))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-9))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-9))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-9))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-9))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-9)))))))))))))))))))(else (lambda (clam-38) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-38))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-38))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-38))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-38))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-39) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-39))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-39))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-38))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-38))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-38))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-38))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-38))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-38))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-10) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-10))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-10))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-10))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-10))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-10))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-10))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-10))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-10))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-41) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-41))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-41))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-10))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-10))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-10))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-10))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-10))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-10))))))))))))))))))))))(else (lambda (clam-42) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-42))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-42))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-42))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-42))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-43) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-43))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-43))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-42))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-42))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-42))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-42))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-42))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-42))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-11) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-11)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-11))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-11))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-11))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-11))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-45) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-45))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-45))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-11))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-11))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-11))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-11))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-11))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-11)))))))))))))))))))(else (lambda (clam-46) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-46))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-46))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-46))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-46))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-47) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-47))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-47))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-46))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-46))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-46))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-46))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-46))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-46))))))))))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-12) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-12))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-12))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-12))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-12))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-12))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-12))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-12))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-12))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-49) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-49))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-49))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-12))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-12))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-12))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-12))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-12))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-12))))))))))))))))))))))(else (lambda (clam-50) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-50))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-50))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-50))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-50))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-51) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-51))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-51))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-50))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-50))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-50))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-50))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-50))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-50))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-13) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-13)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-13))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-13))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-13))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-13))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-53) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-53))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-53))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-13))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-13))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-13))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-13))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-13))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-13)))))))))))))))))))(else (lambda (clam-54) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-54))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-54))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-54))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-54))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-55) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-55))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-55))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-54))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-54))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-54))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-54))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-54))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-54))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-14) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-14))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-14))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-14))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-14))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-14))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-14))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-14))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-14))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-57) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-57))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-57))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-14))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-14))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-14))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-14))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-14))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-14))))))))))))))))))))))(else (lambda (clam-58) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-58))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-58))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-58))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-58))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-59) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-59))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-59))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-58))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-58))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-58))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-58))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-58))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-58))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-15) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-15)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-15))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-15))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-15))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-15))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-61) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-61))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-61))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-15))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-15))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-15))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-15))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-15))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-15)))))))))))))))))))(else (lambda (clam-62) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-62))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-62))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-62))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-62))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-63) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-63))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-63))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-62))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-62))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-62))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-62))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-62))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-62)))))))))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-16) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-16))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-16))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-16))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-16))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-16))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-16))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-16))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-16))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-65) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-65))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-65))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-16))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-16))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-16))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-16))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-16))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-16))))))))))))))))))))))(else (lambda (clam-66) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-66))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-66))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-66))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-66))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-67) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-67))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-67))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-66))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-66))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-66))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-66))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-66))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-66))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-17) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-17)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-17))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-17))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-17))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-17))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-69) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-69))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-69))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-17))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-17))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-17))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-17))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-17))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-17)))))))))))))))))))(else (lambda (clam-70) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-70))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-70))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-70))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-70))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-71) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-71))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-71))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-70))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-70))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-70))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-70))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-70))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-70))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-18) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-18))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-18))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-18))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-18))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-18))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-18))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-18))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-18))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-73) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-73))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-73))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-18))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-18))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-18))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-18))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-18))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-18))))))))))))))))))))))(else (lambda (clam-74) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-74))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-74))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-74))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-74))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-75) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-75))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-75))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-74))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-74))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-74))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-74))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-74))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-74))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-19) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-19)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-19))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-19))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-19))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-19))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-77) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-77))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-77))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-19))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-19))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-19))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-19))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-19))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-19)))))))))))))))))))(else (lambda (clam-78) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-78))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-78))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-78))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-78))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-79) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-79))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-79))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-78))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-78))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-78))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-78))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-78))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-78))))))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((8) (let ((e-31 (vector-ref arg-3 2))) (case (vector-ref e-31 0) ((24) (lambda (eta-0) (vector 1 (vector 11 ))))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-20) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-20))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-20))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-20))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-20))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-20))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-20))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-20))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-20))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-81) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-81))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-81))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-20))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-20))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-20))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-20))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-20))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-20))))))))))))))))))))))(else (lambda (clam-82) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-82))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-82))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-82))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-82))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-83) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-83))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-83))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-82))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-82))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-82))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-82))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-82))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-82))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-21) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-21)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-21))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-21))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-21))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-21))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-85) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-85))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-85))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-21))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-21))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-21))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-21))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-21))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-21)))))))))))))))))))(else (lambda (clam-86) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-86))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-86))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-86))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-86))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-87) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-87))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-87))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-86))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-86))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-86))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-86))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-86))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-86))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-22) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-22))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-22))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-22))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-22))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-22))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-22))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-22))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-22))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-89) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-89))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-89))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-22))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-22))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-22))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-22))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-22))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-22))))))))))))))))))))))(else (lambda (clam-90) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-90))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-90))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-90))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-90))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-91) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-91))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-91))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-90))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-90))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-90))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-90))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-90))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-90))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-23) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-23)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-23))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-23))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-23))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-23))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-93) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-93))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-93))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-23))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-23))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-23))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-23))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-23))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-23)))))))))))))))))))(else (lambda (clam-94) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-94))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-94))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-94))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-94))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-95) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-95))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-95))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-94))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-94))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-94))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-94))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-94))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-94))))))))))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-24) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-24))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-24))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-24))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-24))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-24))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-24))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-24))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-24))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-97) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-97))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-97))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-24))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-24))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-24))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-24))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-24))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-24))))))))))))))))))))))(else (lambda (clam-98) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-98))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-98))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-98))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-98))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-99) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-99))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-99))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-98))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-98))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-98))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-98))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-98))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-98))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-25) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-25)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-25))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-25))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-25))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-25))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-101) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-101))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-101))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-25))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-25))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-25))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-25))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-25))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-25)))))))))))))))))))(else (lambda (clam-102) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-102))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-102))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-102))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-102))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-103) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-103))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-103))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-102))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-102))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-102))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-102))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-102))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-102))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-26) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-26))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-26))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-26))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-26))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-26))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-26))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-26))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-26))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-105) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-105))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-105))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-26))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-26))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-26))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-26))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-26))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-26))))))))))))))))))))))(else (lambda (clam-106) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-106))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-106))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-106))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-106))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-107) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-107))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-107))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-106))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-106))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-106))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-106))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-106))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-106))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-27) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-27)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-27))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-27))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-27))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-27))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-109) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-109))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-109))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-27))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-27))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-27))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-27))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-27))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-27)))))))))))))))))))(else (lambda (clam-110) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-110))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-110))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-110))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-110))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-111) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-111))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-111))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-110))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-110))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-110))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-110))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-110))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-110))))))))))))))))))))))) ((equal? arg-2 1) (case (vector-ref arg-3 0) ((8) (let ((e-34 (vector-ref arg-3 2))) (case (vector-ref e-34 0) ((24) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "String not allowed in a foreign struct") eta-0)))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-28) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-28))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-28))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-28))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-28))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-28))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-28))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-28))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-28))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-113) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-113))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-113))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-28))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-28))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-28))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-28))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-28))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-28))))))))))))))))))))))(else (lambda (clam-114) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-114))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-114))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-114))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-114))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-115) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-115))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-115))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-114))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-114))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-114))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-114))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-114))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-114))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-29) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-29)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-29))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-29))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-29))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-29))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-117) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-117))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-117))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-29))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-29))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-29))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-29))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-29))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-29)))))))))))))))))))(else (lambda (clam-118) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-118))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-118))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-118))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-118))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-119) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-119))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-119))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-118))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-118))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-118))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-118))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-118))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-118))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-30) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-30))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-30))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-30))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-30))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-30))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-30))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-30))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-30))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-121) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-121))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-121))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-30))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-30))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-30))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-30))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-30))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-30))))))))))))))))))))))(else (lambda (clam-122) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-122))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-122))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-122))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-122))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-123) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-123))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-123))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-122))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-122))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-122))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-122))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-122))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-122))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-31) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-31)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-31))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-31))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-31))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-31))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-125) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-125))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-125))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-31))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-31))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-31))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-31))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-31))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-31)))))))))))))))))))(else (lambda (clam-126) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-126))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-126))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-126))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-126))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-127) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-127))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-127))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-126))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-126))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-126))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-126))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-126))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-126))))))))))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-32) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-32))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-32))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-32))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-32))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-32))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-32))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-32))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-32))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-129) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-129))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-129))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-32))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-32))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-32))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-32))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-32))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-32))))))))))))))))))))))(else (lambda (clam-130) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-130))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-130))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-130))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-130))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-131) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-131))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-131))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-130))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-130))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-130))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-130))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-130))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-130))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-33) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-33)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-33))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-33))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-33))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-33))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-133) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-133))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-133))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-33))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-33))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-33))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-33))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-33))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-33)))))))))))))))))))(else (lambda (clam-134) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-134))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-134))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-134))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-134))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-135) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-135))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-135))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-134))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-134))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-134))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-134))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-134))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-134))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-34) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-34))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-34))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-34))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-34))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-34))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-34))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-34))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-34))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-137) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-137))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-137))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-34))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-34))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-34))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-34))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-34))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-34))))))))))))))))))))))(else (lambda (clam-138) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-138))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-138))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-138))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-138))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-139) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-139))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-139))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-138))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-138))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-138))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-138))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-138))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-138))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-35) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-35)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-35))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-35))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-35))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-35))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-141) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-141))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-141))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-35))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-35))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-35))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-35))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-35))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-35)))))))))))))))))))(else (lambda (clam-142) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-142))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-142))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-142))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-142))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-143) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-143))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-143))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-142))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-142))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-142))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-142))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-142))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-142)))))))))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-28 (vector-ref arg-3 2))) (case (vector-ref e-28 0) ((26) (lambda (eta-0) (vector 1 (vector 12 )))) ((25) (lambda (eta-0) (vector 1 (vector 13 )))) ((27) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-36) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-36))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-36))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-36))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-36))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-36))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-36))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-36))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-36))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-145) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-145))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-145))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-36))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-36))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-36))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-36))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-36))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-36))))))))))))))))))))))(else (lambda (clam-146) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-146))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-146))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-146))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-146))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-147) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-147))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-147))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-146))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-146))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-146))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-146))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-146))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-146))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-37) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-37)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-37))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-37))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-37))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-37))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-149) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-149))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-149))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-37))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-37))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-37))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-37))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-37))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-37)))))))))))))))))))(else (lambda (clam-150) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-150))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-150))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-150))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-150))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-151) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-151))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-151))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-150))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-150))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-150))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-150))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-150))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-150))))))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-12 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (lambda (clam-38) (case (vector-ref e-14 0) ((2) (let ((e-20 (vector-ref e-14 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-20) clam-38))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-6) clam-38))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-12 0))) clam-38))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-12 0 e-7) clam-38))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 19 e-6 e-8))))))))))))))))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-38))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-38))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-38))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-38))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-153) (let ((e-16 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-153))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) clam-153))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons e-16 e-18)))))))))))))) e-9 '() clam-38))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-38))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-38))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-38))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-38))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-38))))))))))))))))))))))(else (lambda (clam-154) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-154))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-154))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-154))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-154))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-155) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-155))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-155))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-154))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-154))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-154))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-154))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-154))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-154))))))))))))))))))) ((equal? arg-2 1) (lambda (clam-39) (case (vector-ref arg-3 0) ((0) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-22 "Function types not allowed in a foreign struct") clam-39)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-39))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-39))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-39))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-39))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-157) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-157))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-157))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-39))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-39))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-39))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-39))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-39))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-39)))))))))))))))))))(else (lambda (clam-158) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-2 clam-158))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) clam-158))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-0)) e-9 '() clam-158))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-0)) e-10 '() clam-158))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 22 e-7 e-11)))))))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-159) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-159))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) clam-159))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (vector 1 (cons e-12 e-14)))))))))))))) e-9 '() clam-158))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 21 e-10 e-11))))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-158))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) clam-158))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (vector 20 e-11))))))))))))))))))))))))))))) ((10) (csegen-1036)) ((9) (csegen-1038))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 clam-158))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-6 clam-158))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't marshal type for foreign call " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) clam-158))))))))))))))))))))))))))
(define CompilerC-45CompileExpr-newMN (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))))))
(define CompilerC-45CompileExpr-natHack(blodwen-lazy (lambda () (cons (vector 1 (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 "natToInteger"))) (+ 1 0) (lambda (_-2390) (lambda (_-2392) (lambda (vars-2394) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-2))))))) (cons (vector 1 (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 "integerToNat"))) (+ 1 0) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (let ((e-2 (car eta-3))) (let ((e-3 (cdr eta-3))) (vector 4 eta-0 (vector 1 eta-1 (csegen-29)) (cons e-2 '()))))))))) (cons (vector 1 (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 "plus"))) (+ 1 (+ 1 0)) (lambda (u--fc) (lambda (u--fcC-39) (lambda (vars-2371) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 4 u--fc (vector 1 u--fcC-39 (vector 1 (vector 0 "prim__add_Integer"))) (cons e-2 (cons e-6 '())))))))))))) (cons (vector 1 (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 "mult"))) (+ 1 (+ 1 0)) (lambda (u--fc) (lambda (u--fcC-39) (lambda (vars-2359) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 4 u--fc (vector 1 u--fcC-39 (vector 1 (vector 0 "prim__mul_Integer"))) (cons e-2 (cons e-6 '())))))))))))) (cons (vector 1 (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 "minus"))) (+ 1 (+ 1 0)) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45CompileExpr-magic__natMinus eta-0 eta-1 eta-3)))))) (cons (vector 1 (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 "equalNat"))) (+ 1 (+ 1 0)) (lambda (u--fc) (lambda (u--fcC-39) (lambda (vars-2338) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 4 u--fc (vector 1 u--fcC-39 (vector 1 (vector 0 "prim__eq_Integer"))) (cons e-2 (cons e-6 '())))))))))))) (cons (vector 1 (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 "compareNat"))) (+ 1 (+ 1 0)) (lambda (u--fc) (lambda (u--fcC-39) (lambda (vars-2326) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 4 u--fc (vector 1 u--fcC-39 (vector 0 (CoreC-45NameC-45Namespace-eqOrdNS) (vector 1 (vector 0 "compareInteger")))) (cons e-2 (cons e-6 '())))))))))))) '()))))))))))
(define CompilerC-45CompileExpr-natBranch (lambda (arg-1) (let ((e-2 (vector-ref arg-1 1))) (cond ((equal? e-2 8) 1) ((equal? e-2 9) 1)(else 0)))))
(define CompilerC-45CompileExpr-mkSub (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (cons arg-1 (vector 0 )) (if (null? arg-1) (cons '() (vector 0 )) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc2 (CompilerC-45CompileExpr-mkSub (+ 1 arg-0) e-3 arg-2))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (let ((sc3 (PreludeC-45Types-elem (csegen-792) arg-0 arg-2))) (cond ((equal? sc3 1) (cons e-5 (vector 1 e-4))) (else (cons (cons e-2 e-5) (vector 2 e-4))))))))))))))
(define CompilerC-45CompileExpr-mkDropSubst (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (cons '() (vector 0 )) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (CompilerC-45CompileExpr-mkDropSubst (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) arg-0) arg-1 arg-2 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (PreludeC-45Types-elem (csegen-792) arg-0 arg-1))) (cond ((equal? sc2 1) (cons e-5 (vector 1 e-4))) (else (cons (cons e-2 e-5) (vector 2 e-4)))))))))))))
(define CompilerC-45CompileExpr-mkBounds (lambda (arg-0) (if (null? arg-0) (vector 0 ) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (vector 1 e-2 e-2 (CompilerC-45CompileExpr-mkBounds e-3)))))))
(define CompilerC-45CompileExpr-mkArgList (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (cons '() '()))(else (let ((e-0 (- arg-1 1))) (let ((sc0 (CompilerC-45CompileExpr-mkArgList (bs+ arg-0 1 63) e-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons (cons (vector 2 "arg" arg-0) e-2) (cons (vector 2 "arg" arg-0) e-3))))))))))
(define CompilerC-45CompileExpr-magic__natUnsuc (lambda (arg-0 arg-1 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (vector 4 arg-0 (vector 1 arg-1 (vector 1 (vector 0 "prim__sub_Integer"))) (cons e-2 (cons (vector 12 arg-0 (vector 5 1)) '())))))))
(define CompilerC-45CompileExpr-magic__natMinus (lambda (arg-0 arg-1 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 4 arg-0 (vector 1 arg-1 (csegen-29)) (cons (vector 4 arg-0 (vector 1 arg-1 (vector 1 (vector 0 "prim__sub_Integer"))) (cons e-2 (cons e-6 '()))) '()))))))))
(define CompilerC-45CompileExpr-magic (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((2) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 2 e-1 e-2 (CompilerC-45CompileExpr-magic arg-1 e-3))))))(else (CompilerC-45CompileExpr-n--8827-2111-u--go arg-2 arg-1 arg-1 arg-2)))))
(define CompilerC-45CompileExpr-lamRHSenv (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (cons (vector 1 arg-1 (vector 2 "x" arg-0)) (CompilerC-45CompileExpr-lamRHSenv (bs+ arg-0 1 63) arg-1 e-3))))))
(define CompilerC-45CompileExpr-lamRHS (lambda (arg-0 arg-1) (let ((u--env (CompilerC-45CompileExpr-lamRHSenv 0 (CoreC-45CompileExpr-getFC arg-1) arg-0))) (let ((u--tmExp (CoreC-45CompileExpr-substs arg-0 '() u--env arg-1))) (let ((u--newArgs (PreludeC-45TypesC-45List-reverse (CompilerC-45CompileExpr-getNewArgs arg-0 u--env)))) (let ((u--bounds (CompilerC-45CompileExpr-mkBounds u--newArgs))) (let ((u--expLocs (CoreC-45CompileExpr-mkLocals (CoreC-45TTC-45SizeOf-zero) u--bounds u--tmExp))) (CompilerC-45CompileExpr-n--13568-6420-u--lamBind arg-0 arg-1 (CoreC-45CompileExpr-getFC arg-1) (PreludeC-45TypesC-45List-tailRecAppend '() (PreludeC-45TypesC-45List-tailRecAppend u--newArgs '())) u--expLocs))))))))
(define CompilerC-45CompileExpr-getZBranch (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (CompilerC-45CompileExpr-tryZBranch e-2) (CompilerC-45CompileExpr-getZBranch e-3)))))))
(define CompilerC-45CompileExpr-getSBranch (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (CompilerC-45CompileExpr-trySBranch arg-1 e-2) (CompilerC-45CompileExpr-getSBranch arg-1 e-3)))))))
(define CompilerC-45CompileExpr-getPArgs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((2) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((_-0 (vector 2 e-1 e-2 e-3 e-4 e-6))) ((CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32getPArgs-5165 arg-2 arg-1 arg-0 e-2 e-3 e-4 e-6 e-1 _-0 (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-6))) ext-0))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc e-5) "Badly formed struct type") ext-0)))))))))
(define CompilerC-45CompileExpr-getNewType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((3) (lambda (eta-0) (vector 1 '()))) ((0) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (let ((e-9 (vector-ref e-2 3))) (let ((e-10 (vector-ref e-2 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact e-7 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((5) (let ((e-4 (vector-ref e-1 3))) (if (null? e-4) (vector 1 '()) (let ((e-13 (unbox e-4))) (if (null? e-13) (vector 1 '()) (let ((e-14 (cdr e-13))) (let ((u--env (CompilerC-45CompileExpr-n--10689-4302-u--mkSubst e-9 arg-0 e-10 e-8 e-7 e-3 arg-5 arg-4 arg-3 arg-2 arg-1 0 arg-4 e-14 e-9))) (let ((act-26 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-0) arg-1 arg-2 arg-5 e-10) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (vector 1 (box (CoreC-45CompileExpr-substs e-9 arg-0 u--env e-16))))))))))))))(else (vector 1 '())))))))))))))))))))(else (CompilerC-45CompileExpr-getNewType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))))))))
(define CompilerC-45CompileExpr-getNewArgs (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (case (vector-ref e-8 0) ((1) (let ((e-12 (vector-ref e-8 2))) (cons e-12 (CompilerC-45CompileExpr-getNewArgs e-3 e-9))))(else (cons e-2 (CompilerC-45CompileExpr-getNewArgs e-3 e-9)))))))))))
(define CompilerC-45CompileExpr-getNArgs (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (cond ((equal? e-3 "IORes") (lambda (clam-0) (if (null? arg-3) (vector 1 (vector 0 arg-2 arg-3)) (let ((e-5 (car arg-3))) (let ((e-6 (cdr arg-3))) (if (null? e-6) (vector 1 (vector 7 e-5)) (vector 1 (vector 0 arg-2 arg-3)))))))) ((equal? e-3 "Ptr") (lambda (clam-1) (if (null? arg-3) (vector 1 (vector 0 arg-2 arg-3)) (let ((e-10 (cdr arg-3))) (if (null? e-10) (vector 1 (vector 3 )) (vector 1 (vector 0 arg-2 arg-3))))))) ((equal? e-3 "AnyPtr") (lambda (clam-2) (if (null? arg-3) (vector 1 (vector 3 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "GCPtr") (lambda (clam-2) (if (null? arg-3) (vector 1 (vector 0 arg-2 arg-3)) (let ((e-15 (cdr arg-3))) (if (null? e-15) (vector 1 (vector 4 )) (vector 1 (vector 0 arg-2 arg-3))))))) ((equal? e-3 "GCAnyPtr") (lambda (clam-4) (if (null? arg-3) (vector 1 (vector 4 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "Buffer") (lambda (clam-5) (if (null? arg-3) (vector 1 (vector 5 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "ForeignObj") (lambda (clam-6) (if (null? arg-3) (vector 1 (vector 6 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "Unit") (lambda (clam-7) (if (null? arg-3) (vector 1 (vector 2 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "Struct") (if (null? arg-3) (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3))) (let ((e-22 (car arg-3))) (let ((e-23 (cdr arg-3))) (lambda (clam-3) (if (null? e-23) (vector 1 (vector 0 arg-2 arg-3)) (let ((e-25 (car e-23))) (let ((e-26 (cdr e-23))) (if (null? e-26) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-22) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((8) (let ((e-4 (vector-ref e-5 2))) (case (vector-ref e-4 0) ((10) (let ((e-7 (vector-ref e-4 1))) (let ((act-25 (CompilerC-45CompileExpr-getFieldArgs arg-0 arg-1 e-25 clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 1 e-7 e-8))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc e-5) "Unknown name for struct") clam-3)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc e-5) "Unknown name for struct") clam-3))))))) (vector 1 (vector 0 arg-2 arg-3)))))))))))(else (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3)))))))(else (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3)))))))(else (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3)))))))(else (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3)))))))
(define CompilerC-45CompileExpr-getFieldArgs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((2) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((_-0 (vector 2 e-1 e-2 e-3 e-4 e-6))) ((CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32getFieldArgs-5354 arg-2 arg-1 arg-0 e-2 e-3 e-4 e-6 e-1 _-0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-6)) ext-0))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc e-5) "Badly formed struct type") ext-0)))))))))
(define CompilerC-45CompileExpr-getDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((3) (let ((e-5 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-toCExpTree arg-0 arg-1 arg-2 arg-3 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (box e-6))))))))) ((2) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (case (vector-ref e-7 0) ((13) (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-toCExpTree arg-0 arg-1 arg-2 arg-3 e-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box e-5))))))))(else (CompilerC-45CompileExpr-getDef arg-0 arg-1 arg-2 arg-3 e-3))))))(else (CompilerC-45CompileExpr-getDef arg-0 arg-1 arg-2 arg-3 e-3))))))))
(define CompilerC-45CompileExpr-getCFTypes (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-9) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 0 e-10) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) ((CompilerC-45CompileExpr-getCFTypes arg-0 (cons e-10 arg-1) e-11) clam-0)))))))))))))))(else (let ((act-24 ((CompilerC-45CompileExpr-nfToCFType arg-0 (CoreC-45Value-getLoc arg-2) 0 arg-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (PreludeC-45TypesC-45List-reverse arg-1) e-5))))))))))))(else (let ((act-24 ((CompilerC-45CompileExpr-nfToCFType arg-0 (CoreC-45Value-getLoc arg-2) 0 arg-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (PreludeC-45TypesC-45List-reverse arg-1) e-5)))))))))))
(define CompilerC-45CompileExpr-expandToArity (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((13) (let ((e-6 (vector-ref arg-2 1))) (vector 13 e-6)))(else (cond ((equal? arg-1 0) (CompilerC-45CompileExpr-n--8316-1671-u--applyAll arg-0 arg-3 arg-2 arg-2 arg-3))(else (let ((e-1 (- arg-1 1))) (if (null? arg-3) (CompilerC-45CompileExpr-etaExpand arg-0 0 arg-1 arg-2 '()) (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (CompilerC-45CompileExpr-expandToArity arg-0 e-1 (CompilerC-45CompileExpr-n--8316-1693-u--addArg arg-0 e-1 e-3 e-4 arg-2 arg-2 e-3) e-4)))))))))))
(define CompilerC-45CompileExpr-etaExpand (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-2 0) (CompilerC-45CompileExpr-n--8216-1571-u--mkApp arg-0 arg-4 arg-3 arg-1 arg-3 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CompileExpr-n--8216-1570-u--mkLocal arg-0 arg-4 arg-3 arg-1 (CoreC-45CompileExpr-getFC arg-3) eta-0)) (PreludeC-45TypesC-45List-reverse arg-4))))(else (let ((e-0 (- arg-2 1))) (vector 2 (CoreC-45CompileExpr-getFC arg-3) (vector 2 "eta" arg-1) (CompilerC-45CompileExpr-etaExpand (cons (vector 2 "eta" arg-1) arg-0) (bs+ arg-1 1 63) e-0 (CoreC-45CompileExpr-u--weaken_Weaken_CExp arg-3) (cons 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CompileExpr-weakenVar eta-0)) arg-4)))))))))
(define CompilerC-45CompileExpr-eraseConArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--fnC-39 (CompilerC-45CompileExpr-expandToArity arg-0 arg-1 arg-3 arg-4))) (let ((sc0 (DataC-45List-isNil arg-2))) (cond ((equal? sc0 1) u--fnC-39) (else (CompilerC-45CompileExpr-dropPos arg-2 u--fnC-39)))))))
(define CompilerC-45CompileExpr-enumTree (lambda (arg-1) (case (vector-ref arg-1 0) ((10) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((u--x (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CompilerC-45CompileExpr-n--9635-2857-u--toEnum e-4 e-3 e-2 e-1 eta-0)) e-3))) (if (null? u--x) (vector 10 e-1 e-2 e-3 e-4) (let ((e-5 (unbox u--x))) (vector 11 e-1 e-2 e-5 e-4)))))))))(else arg-1))))
(define CompilerC-45CompileExpr-dropPos (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((2) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 2 e-1 e-2 (CompilerC-45CompileExpr-dropPos arg-1 e-3)))))) ((4) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (case (vector-ref e-6 0) ((4) (vector 4 e-5 (CompilerC-45CompileExpr-dropPos arg-1 e-6) e-7))(else (vector 4 e-5 e-6 (CompilerC-45CompileExpr-dropFrom arg-1 0 e-7)))))))) ((5) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (let ((e-13 (vector-ref arg-2 5))) (vector 5 e-9 e-10 e-11 e-12 (CompilerC-45CompileExpr-dropFrom arg-1 0 e-13))))))))(else arg-2))))
(define CompilerC-45CompileExpr-dropFrom (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) arg-2 arg-1))) (cond ((equal? sc1 1) (CompilerC-45CompileExpr-dropFrom arg-1 (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) arg-2) e-3)) (else (cons e-2 (CompilerC-45CompileExpr-dropFrom arg-1 (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) arg-2) e-3))))))))))
(define CompilerC-45CompileExpr-dconFlag (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't find " (CoreC-45Name-u--show_Show_Name arg-1))) ext-0) (let ((e-1 (unbox e-6))) (vector 1 (CompilerC-45CompileExpr-n--9869-3052-u--ciFlags arg-1 arg-0 (let ((e-11 (vector-ref e-1 11))) e-11)))))))))))))))
(define CompilerC-45CompileExpr-constCases (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-5 0) ((13) (CompilerC-45CompileExpr-constCases arg-0 arg-1 arg-2 arg-3 e-3))(else (lambda (eta-0) (let ((act-24 ((CompilerC-45CompileExpr-toCExpTree arg-0 arg-1 arg-2 arg-3 e-6) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CompileExpr-constCases arg-0 arg-1 arg-2 arg-3 e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (cons (cons e-5 e-7) e-8))))))))))))))))(else (CompilerC-45CompileExpr-constCases arg-0 arg-1 arg-2 arg-3 e-3))))))))
(define CompilerC-45CompileExpr-conCases (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-9 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (let ((act-26 (CoreC-45Context-getFullName arg-1 e-5 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend e-7 arg-0) arg-1 arg-2 arg-3 e-8) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45CompileExpr-conCases arg-0 arg-1 arg-2 arg-3 e-3) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-28 1))) (vector 1 (cons (vector e-11 1 '() e-7 e-12) e-13)))))))))))))) (let ((e-1 (unbox e-10))) (let ((_-0 (box e-1))) ((CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32conCases-3947 e-7 arg-0 e-8 e-6 e-5 e-3 arg-3 arg-2 arg-1 e-9 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17)) eta-0))))))))))))))))))(else (CompilerC-45CompileExpr-conCases arg-0 arg-1 arg-2 arg-3 e-3))))))))
(define CompilerC-45CompileExpr-compileExp (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CompilerC-45CompileExpr-builtinMagic arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Compiler.CompileExpr.NextMN" ) 0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45CompileExpr-toCExp '() arg-0 e-6 (lambda (vars-7080) (e-5 'erased)) (vector 1 (vector 0 "main")) arg-1) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 e-7)))))))))))))))
(define CompilerC-45CompileExpr-compileDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Trying to compile unknown name " (CoreC-45Name-u--show_Show_Name arg-1))) ext-0) (let ((e-1 (unbox e-6))) (let ((act-26 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc4 (CompilerC-45CompileExpr-n--14312-7096-u--noDefYet arg-1 arg-0 (let ((e-17 (vector-ref e-1 17))) e-17) (let ((e-21 (vector-ref e-7 21))) e-21)))) (cond ((equal? sc4 1) (CoreC-45Context-recordWarning arg-0 (vector 4 (PreludeC-45TypesC-45String-C-43C-43 "Compiling hole " (CoreC-45Name-u--show_Show_Name arg-1))) ext-0)) (else (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-0 (csegen-1050) (let ((e-17 (vector-ref e-1 17))) e-17) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((CompilerC-45CompileExpr-toCDef arg-0 arg-1 (let ((e-2 (vector-ref e-1 2))) e-2) (let ((e-3 (vector-ref e-1 3))) e-3) e-8) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Context-setCompiled arg-0 arg-1 e-8 ext-0))))))))))))))))))))))))
(define CompilerC-45CompileExpr-builtinNatTree (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((10) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (case (vector-ref e-2 0) ((0) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (vector 1 (let ((u--sc (vector 0 e-7 e-8))) (let ((sc2 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CompilerC-45CompileExpr-natBranch eta-0)) e-3))) (cond ((equal? sc2 1) (let ((u--defb (DataC-45Maybe-fromMaybe (lambda () (vector 14 e-1 "Nat case not covered")) e-4))) (let ((u--salt (PreludeC-45Types-maybe (lambda () u--defb) (lambda () (lambda (eta-0) eta-0)) (CompilerC-45CompileExpr-getSBranch u--sc e-3)))) (let ((u--zalt (PreludeC-45Types-maybe (lambda () u--defb) (lambda () (lambda (eta-0) eta-0)) (CompilerC-45CompileExpr-getZBranch e-3)))) (vector 11 e-1 u--sc (cons (cons (vector 5 0) u--zalt) '()) (box u--salt)))))) (else (vector 10 e-1 u--sc e-3 e-4)))))))))(else (let ((act-24 (CompilerC-45CompileExpr-newMN arg-1 "succ" clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CompileExpr-builtinNatTree arg-1 (vector 10 e-1 (vector 0 0 e-1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-u--weaken_Weaken_CConAlt eta-0)) e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-u--weaken_Weaken_CExp eta-0)) e-4))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-1 e-5 1 e-2 e-6)))))))))))))))))(else (vector 1 arg-2))))))
(define CompilerC-45CompileExpr-builtinMagic (lambda (arg-0 ext-0) (vector 1 (lambda (vars-2548) (lambda (eta-0) (CompilerC-45CompileExpr-magic (CompilerC-45CompileExpr-natHack) eta-0))))))
(define CompilerC-45CompileExpr-applyNewType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--fnC-39 (CompilerC-45CompileExpr-expandToArity arg-0 arg-1 arg-3 arg-4))) (CompilerC-45CompileExpr-n--8420-1753-u--keepArg arg-0 arg-4 arg-3 arg-2 arg-1 u--fnC-39))))
(define CoreC-45Value-u--show_Show_C-40NHeadC-32C-36freeC-41 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (CoreC-45TT-nameAt arg-0 e-3)) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-3) "]"))))) ((1) (let ((e-7 (vector-ref arg-1 2))) (CoreC-45Name-u--show_Show_Name e-7))) (else (let ((e-9 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 3))) (PreludeC-45TypesC-45String-C-43C-43 "?" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-9) (PreludeC-45TypesC-45String-C-43C-43 "_[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-11)) " closures]"))))))))))
(define CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref e-3 0) ((0) (let ((e-50 (vector-ref e-3 2))) (let ((e-51 (vector-ref e-3 3))) (let ((e-52 (vector-ref e-3 4))) (PreludeC-45TypesC-45String-C-43C-43 "\\" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-withPiInfo (csegen-1055) e-51 (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-50) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-52))))) " => [closure]")))))) ((1) (let ((e-55 (vector-ref e-3 2))) (let ((e-56 (vector-ref e-3 3))) (let ((e-57 (vector-ref e-3 4))) (PreludeC-45TypesC-45String-C-43C-43 "let " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-55) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-57) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-56) " in [closure]"))))))))))) ((2) (let ((e-60 (vector-ref e-3 2))) (let ((e-61 (vector-ref e-3 3))) (let ((e-62 (vector-ref e-3 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-withPiInfo (csegen-1055) e-61 (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-60) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-62))))) " -> [closure]"))))) ((3) (let ((e-65 (vector-ref e-3 2))) (let ((e-66 (vector-ref e-3 3))) (let ((e-67 (vector-ref e-3 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-withPiInfo (csegen-1055) e-66 (PreludeC-45TypesC-45String-C-43C-43 "pat " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-65) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-67)))))) " => [closure]"))))) ((4) (let ((e-70 (vector-ref e-3 2))) (let ((e-71 (vector-ref e-3 3))) (let ((e-72 (vector-ref e-3 4))) (PreludeC-45TypesC-45String-C-43C-43 "plet " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-70) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-72) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-71) " in [closure]"))))))))))) (else (let ((e-75 (vector-ref e-3 2))) (let ((e-76 (vector-ref e-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "pty " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-75) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-76) " => [closure]")))))))))))) ((1) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40NHeadC-32C-36freeC-41 arg-0 e-7) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-8)) " closures]")))))) ((2) (let ((e-11 (vector-ref arg-1 2))) (let ((e-14 (vector-ref arg-1 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-11) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-14)) " closures]")))))) ((3) (let ((e-17 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-17) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-20)) " closures]")))))) ((4) (let ((e-24 (vector-ref arg-1 3))) (let ((e-25 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-24) (PreludeC-45TypesC-45String-C-43C-43 "@" (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-25)))))) ((5) (let ((e-29 (vector-ref arg-1 3))) (PreludeC-45TypesC-45String-C-43C-43 "%Delayed " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-29)))) ((6) "%Delay [closure]") ((7) (let ((e-38 (vector-ref arg-1 3))) (let ((e-39 (vector-ref arg-1 4))) (PreludeC-45TypesC-45String-C-43C-43 "%Force " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-38) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-39)) " closures]"))))))) ((8) (let ((e-42 (vector-ref arg-1 2))) (CoreC-45TT-u--show_Show_Constant e-42))) ((9) "[__]") (else "Type"))))
(define CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 (lambda (arg-1) "[closure]"))
(define CoreC-45Value-u--showPrec_Show_C-40NFC-32C-36freeC-41 (lambda (arg-0 arg-1 arg-2) (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 arg-2)))
(define CoreC-45Value-u--showPrec_Show_C-40ClosureC-32C-36freeC-41 (lambda (arg-1 arg-2) (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 arg-2)))
(define CoreC-45Value-withHoles(blodwen-lazy (lambda () (vector 1 1 0 0 0 '() '() 1))))
(define CoreC-45Value-withArgHoles(blodwen-lazy (lambda () (vector 0 1 0 0 0 '() '() 1))))
(define CoreC-45Value-withAll(blodwen-lazy (lambda () (vector 0 0 1 1 0 '() '() 1))))
(define CoreC-45Value-tcOnly(blodwen-lazy (lambda () (let ((sc0 (CoreC-45Value-withArgHoles))) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-2 (vector-ref sc0 2))) (let ((e-3 (vector-ref sc0 3))) (let ((e-5 (vector-ref sc0 5))) (let ((e-6 (vector-ref sc0 6))) (let ((e-7 (vector-ref sc0 7))) (vector e-0 e-1 e-2 e-3 1 e-5 e-6 e-7))))))))))))
(define CoreC-45Value-ntCon (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (cond ((equal? e-2 "Type") (cond ((equal? arg-4 0) (if (null? arg-5) (vector 10 arg-1) (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc7 (CoreC-45TT-isConstantType arg-2))) (if (null? sc7) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-3 (unbox sc7))) (vector 8 arg-1 e-3)))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))))(else (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc5 (CoreC-45TT-isConstantType arg-2))) (if (null? sc5) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-3 (unbox sc5))) (vector 8 arg-1 e-3)))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5))))))(else (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc4 (CoreC-45TT-isConstantType arg-2))) (if (null? sc4) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-3 (unbox sc4))) (vector 8 arg-1 e-3)))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))))))(else (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc3 (CoreC-45TT-isConstantType arg-2))) (if (null? sc3) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-2 (unbox sc3))) (vector 8 arg-1 e-2)))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))))))(else (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc2 (CoreC-45TT-isConstantType arg-2))) (if (null? sc2) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-1 (unbox sc2))) (vector 8 arg-1 e-1)))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))))))
(define CoreC-45Value-getLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-6 (vector-ref arg-1 1))) e-6)) ((2) (let ((e-10 (vector-ref arg-1 1))) e-10)) ((3) (let ((e-16 (vector-ref arg-1 1))) e-16)) ((4) (let ((e-22 (vector-ref arg-1 1))) e-22)) ((5) (let ((e-27 (vector-ref arg-1 1))) e-27)) ((6) (let ((e-31 (vector-ref arg-1 1))) e-31)) ((7) (let ((e-36 (vector-ref arg-1 1))) e-36)) ((8) (let ((e-41 (vector-ref arg-1 1))) e-41)) ((9) (let ((e-44 (vector-ref arg-1 1))) e-44)) (else (let ((e-47 (vector-ref arg-1 1))) e-47)))))
(define CoreC-45Value-defaultOpts(blodwen-lazy (lambda () (vector 0 0 1 0 0 '() '() 1))))
(define CoreC-45Normalise-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32normalisePrims-3353 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (lambda (clam-0) (if (null? arg-14) (vector 1 '()) (let ((e-1 (unbox arg-14))) (let ((sc1 (arg-9 e-1))) (cond ((equal? sc1 1) (let ((act-24 (let ((act-24 (unbox arg-10))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (cond ((equal? arg-7 1) (CoreC-45Normalise-normaliseAll arg-10 arg-1 e-5 arg-2 arg-3 clam-0)) (else (CoreC-45Normalise-normalise arg-10 arg-1 e-5 arg-2 arg-3 clam-0))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box e-6)))))))))))(else (vector 1 '())))))))))
(define CoreC-45Normalise-case--caseC-32blockC-32inC-32normalisePrims-3318 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (vector 1 '())) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (CoreC-45Normalise-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32normalisePrims-3353 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2 e-1 (arg-8 e-1)))))))
(define CoreC-45Normalise-n--8611-2936-u--repSub (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((act-24 (CoreC-45CoreC-45Binder-traverse (lambda (u--c) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-0 arg-5 u--c) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Normalise-n--8611-2936-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5) eta-0))))))) e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (vector 2 "tmp" arg-6))) (let ((act-25 (let ((act-25 (((e-4 arg-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-4 (vector 1 e-1 (vector 0 ) u--xC-39))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Normalise-replaceC-39 arg-7 arg-0 (bs+ arg-6 1 63) arg-5 arg-4 arg-3 arg-2 e-6 clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-1 e-2 e-5 (CoreC-45TT-refsToLocals (vector 1 e-2 u--xC-39 (vector 0 )) e-6))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (if (null? e-8) (let ((act-24 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 (vector 1 e-6 e-7 '()) clam-0))))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Core-traversePair (lambda (eta-2) (lambda (eta-3) (CoreC-45Normalise-n--8611-2935-u--repArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-2 eta-3))) eta-0 eta-1))) e-8 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-replaceC-39 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 (vector 1 e-6 e-7 '()) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC e-9 e-5))))))))))))))) ((2) (let ((e-10 (vector-ref arg-8 1))) (let ((e-11 (vector-ref arg-8 2))) (let ((e-12 (vector-ref arg-8 3))) (let ((e-13 (vector-ref arg-8 4))) (let ((e-14 (vector-ref arg-8 5))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Core-traversePair (lambda (eta-2) (lambda (eta-3) (CoreC-45Normalise-n--8611-2935-u--repArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-2 eta-3))) eta-0 eta-1))) e-14 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-6 arg-4 (vector 2 e-10 e-11 e-12 e-13 '()) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-applyWithFC e-7 e-5)))))))))))))))))))) ((3) (let ((e-16 (vector-ref arg-8 1))) (let ((e-17 (vector-ref arg-8 2))) (let ((e-18 (vector-ref arg-8 3))) (let ((e-19 (vector-ref arg-8 4))) (let ((e-20 (vector-ref arg-8 5))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Core-traversePair (lambda (eta-2) (lambda (eta-3) (CoreC-45Normalise-n--8611-2935-u--repArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-2 eta-3))) eta-0 eta-1))) e-20 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-6 arg-4 (vector 3 e-16 e-17 e-18 e-19 '()) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-applyWithFC e-7 e-5)))))))))))))))))))) ((4) (let ((e-22 (vector-ref arg-8 1))) (let ((e-23 (vector-ref arg-8 2))) (let ((e-24 (vector-ref arg-8 3))) (let ((e-25 (vector-ref arg-8 4))) (let ((act-24 ((CoreC-45Normalise-n--8611-2936-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-24) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Normalise-n--8611-2936-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-25) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-22 e-23 e-5 e-6))))))))))))))) ((5) (let ((e-27 (vector-ref arg-8 1))) (let ((e-28 (vector-ref arg-8 2))) (let ((e-29 (vector-ref arg-8 3))) (let ((act-24 ((CoreC-45Normalise-n--8611-2936-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-29) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-27 e-28 e-5)))))))))) ((6) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (let ((e-33 (vector-ref arg-8 3))) (let ((e-34 (vector-ref arg-8 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-0 arg-5 e-33) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Normalise-replaceC-39 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-5 clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-0 arg-5 e-34) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Normalise-replaceC-39 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-6 clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 7 e-31 e-32 e-5 e-6))))))))))))))) ((7) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (let ((e-39 (vector-ref arg-8 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Core-traversePair (lambda (eta-2) (lambda (eta-3) (CoreC-45Normalise-n--8611-2935-u--repArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-2 eta-3))) eta-0 eta-1))) e-39 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Normalise-n--8611-2936-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-38) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 8 e-36 e-37 e-6) e-5)))))))))))))))(else (let ((act-24 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-8 clam-0))))))))))
(define CoreC-45Normalise-n--8611-2935-u--repArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-0 arg-5 arg-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Normalise-replaceC-39 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-5 ext-0)))))))
(define CoreC-45Normalise-n--8486-2823-u--dumpEnv (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) (lambda (clam-0) (vector 1 0)) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (lambda (clam-0) (let ((e-8 (car arg-8))) (let ((e-9 (cdr arg-8))) (case (vector-ref e-8 0) ((1) (let ((e-12 (vector-ref e-8 2))) (let ((e-13 (vector-ref e-8 3))) (let ((e-14 (vector-ref e-8 4))) (let ((act-24 (CoreC-45Normalise-logTermNFC-39 e-3 arg-6 arg-1 arg-5 (lambda () (PreludeC-45TypesC-45String-C-43C-43 arg-4 (PreludeC-45TypesC-45String-C-43C-43 ": let " (CoreC-45Name-u--show_Show_Name e-2)))) e-9 e-13 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Normalise-logTermNFC-39 e-3 arg-6 arg-1 arg-5 (lambda () (PreludeC-45TypesC-45String-C-43C-43 arg-4 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-12) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name e-2)))))) e-9 e-14 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((CoreC-45Normalise-n--8486-2823-u--dumpEnv arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 e-3 e-9) clam-0)))))))))))(else (let ((act-24 (CoreC-45Normalise-logTermNFC-39 e-3 arg-6 arg-1 arg-5 (lambda () (PreludeC-45TypesC-45String-C-43C-43 arg-4 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega (CoreC-45TT-multiplicity e-8)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-3 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-3 u--d u--x)))) (CoreC-45TT-piInfo e-8)) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name e-2)))))))) e-9 (CoreC-45TT-binderType e-8) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((CoreC-45Normalise-n--8486-2823-u--dumpEnv arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 e-3 e-9) clam-0))))))))))))))
(define CoreC-45Normalise-n--7883-2254-u--act (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-3 arg-0 "eval.eta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "  Considering") arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref e-4 0) ((4) (let ((e-11 (vector-ref e-4 1))) (let ((e-12 (vector-ref e-4 2))) (let ((e-13 (vector-ref e-4 3))) (case (vector-ref e-13 0) ((0) (let ((e-16 (vector-ref e-13 1))) (let ((e-17 (vector-ref e-13 2))) (let ((e-18 (vector-ref e-13 3))) (cond ((equal? e-18 0) (let ((act-25 (CoreC-45ContextC-45Log-logTerm (cons e-2 arg-3) arg-0 "eval.eta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "  Shrinking candidate") e-12 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((u--shrunk (CoreC-45TT-shrinkTerm e-12 (vector 1 (vector 0 ))))) (let ((u--tm (vector 3 e-1 e-2 (vector 0 e-6 e-7 e-8 e-9) (vector 4 e-11 e-12 (vector 0 e-16 e-17 0))))) (if (null? u--shrunk) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "eval.eta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "  Failure!") ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-14 (vector-ref act-26 1))) (vector 0 e-14))) (else (vector 1 u--tm)))) (let ((e-14 (unbox u--shrunk))) (let ((act-26 (CoreC-45ContextC-45Log-logTerm arg-3 arg-0 "eval.eta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "  Success!") e-14 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-15 (vector-ref act-26 1))) (vector 0 e-15))) (else (vector 1 e-14))))))))))))(else (vector 1 arg-4)))))))(else (vector 1 arg-4)))))))(else (vector 1 arg-4))))))))(else (vector 1 arg-4))))))))(else (vector 1 arg-4))))))))
(define CoreC-45Normalise-tryNormaliseSizeLimit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-4 arg-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF arg-0 arg-1 (vector 0 0 (box arg-3)) arg-2 arg-4 e-5 ext-0)))))))
(define CoreC-45Normalise-replaceC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-1 arg-3 arg-4 arg-5 arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (vector 1 arg-6)) (else ((CoreC-45Normalise-n--8611-2936-u--repSub arg-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 arg-7) ext-0)))))))))
(define CoreC-45Normalise-replace (lambda (arg-0 arg-1 ext-5 ext-1 ext-2 ext-3 ext-4 ext-0) (CoreC-45Normalise-replaceC-39 arg-0 arg-1 0 ext-5 ext-1 ext-2 ext-3 ext-4 ext-0)))
(define CoreC-45Normalise-normaliseSizeLimit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-4 arg-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF arg-0 arg-1 (vector 0 0 (box arg-3)) arg-2 arg-4 e-5 eta-0)))))) (lambda (u--err) (lambda (eta-0) (vector 1 arg-5))) ext-0)))
(define CoreC-45Normalise-normaliseScope (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-24 ((CoreC-45Normalise-normaliseScope arg-0 (cons e-2 arg-1) arg-2 (cons e-3 arg-3) e-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-1 e-2 e-3 e-5)))))))))))(else (CoreC-45Normalise-normalise arg-0 arg-1 arg-2 arg-3 arg-4 clam-0))))))
(define CoreC-45Normalise-normalisePrims (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (CoreC-45Context-getFullName arg-1 arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (CoreC-45Context-isPrimName arg-6 e-5))) (cond ((equal? sc1 1) ((CoreC-45Normalise-case--caseC-32blockC-32inC-32normalisePrims-3318 arg-2 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 e-5 (PreludeC-45TypesC-45List-reverse arg-8)) ext-0))(else (vector 1 '()))))))))))
(define CoreC-45Normalise-normalisePis (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (CoreC-45NormaliseC-45Quote-quoteWithPi arg-0 arg-1 arg-2 arg-3 e-5 ext-0))(else (vector 1 arg-4)))))(else (vector 1 arg-4)))))))))
(define CoreC-45Normalise-normaliseOpts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-3 arg-4 e-5 ext-0)))))))
(define CoreC-45Normalise-normaliseHoles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 (CoreC-45Value-withHoles) arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-2 arg-3 e-5 ext-0)))))))
(define CoreC-45Normalise-normaliseArgHoles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 (CoreC-45Value-withArgHoles) arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-2 arg-3 e-5 ext-0)))))))
(define CoreC-45Normalise-normaliseAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 (CoreC-45Value-withAll) arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-2 arg-3 e-5 ext-0)))))))
(define CoreC-45Normalise-normalise (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-2 arg-3 e-5 ext-0)))))))
(define CoreC-45Normalise-logTermNFC-39 (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-5 arg-6 arg-7 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? arg-2 "") (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7))))))) ext-0))) (vector 1 act-27)))(else (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7))))))))) ext-0))) (vector 1 act-27))))))))))))))))))
(define CoreC-45Normalise-logTermNF (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (CoreC-45Normalise-logTermNFC-39 arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0)) (else (vector 1 0)))))))))
(define CoreC-45Normalise-logNF (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-6 arg-6 arg-7 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? arg-2 "") (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8))))))) ext-0))) (vector 1 act-28)))(else (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8))))))))) ext-0))) (vector 1 act-28))))))))))))))))) (else (vector 1 0)))))))))
(define CoreC-45Normalise-logGlueNF (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm arg-7) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-6 arg-6 e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (cond ((equal? arg-2 "") (let ((act-29 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-9))))))) ext-0))) (vector 1 act-29)))(else (let ((act-29 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-9))))))))) ext-0))) (vector 1 act-29))))))))))))))))))))) (else (vector 1 0)))))))))
(define CoreC-45Normalise-logGlue (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm arg-7) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? arg-2 "") (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8))))))) ext-0))) (vector 1 act-28)))(else (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8))))))))) ext-0))) (vector 1 act-28)))))))))))))))) (else (vector 1 0)))))))))
(define CoreC-45Normalise-logEnv (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (cond ((equal? arg-2 "") (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " arg-5)))) ext-0))) (vector 1 act-25)))(else (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " arg-5)))))) ext-0))) (vector 1 act-25)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45Normalise-n--8486-2823-u--dumpEnv arg-0 arg-2 arg-6 arg-5 arg-4 arg-1 arg-0 arg-6) ext-0))))) (else (vector 1 0)))))))))
(define CoreC-45Normalise-glueClosure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector 0 (lambda (eta-0) (let ((act-24 (CoreC-45Context-clearDefs arg-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-3 arg-4 eta-0)))))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 arg-4)))))
(define CoreC-45Normalise-glueBack (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector 0 (lambda (eta-0) (let ((act-24 (CoreC-45Context-clearDefs arg-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 e-5 arg-3 arg-4 eta-0)))))) (lambda (eta-0) (lambda (eta-1) (vector 1 arg-4))))))
(define CoreC-45Normalise-getValArity (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-2 (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Normalise-getValArity arg-1 arg-2 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (+ 1 e-10)))))))))))(else (vector 1 0)))))))(else (vector 1 0))))))
(define CoreC-45Normalise-getArity (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Normalise-getValArity arg-2 arg-3 e-5) ext-0)))))))
(define CoreC-45Normalise-etaContract (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-1 arg-0 "eval.eta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Attempting to eta contract subterms of") arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Normalise-normalise arg-0 arg-1 e-5 (CoreC-45Env-mkEnv (vector 2 ) arg-1) arg-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-logTerm arg-1 arg-0 "eval.eta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Evaluated to") e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45Core-mapTermM (lambda (vars-2501) (lambda (eta-0) (lambda (eta-1) (CoreC-45Normalise-n--7883-2254-u--act arg-0 arg-1 arg-2 vars-2501 eta-0 eta-1)))) arg-1 arg-2) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45ContextC-45Log-logTerm arg-1 arg-0 "eval.eta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Result of eta-contraction") e-9 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 e-9))))))))))))))))))))))))
(define CoreC-45Primitives-n--9651-4674-u--powC-39 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((12) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref arg-2 0) ((12) (let ((e-1 (vector-ref arg-2 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 12 (PreludeC-45Types-pow e-0 e-1)))))(else '()))))(else '()))))
(define CoreC-45Primitives-unaryOp (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 eta-0)) (arg-0 e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-toInt (lambda (arg-0) (cond ((equal? arg-0 1) (vector 0 1)) (else (vector 0 0)))))
(define CoreC-45Primitives-sub (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (- e-0 e-12)))))(else '())))) ((0) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (bs- e-1 e-13 63)))))(else '())))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (bs- e-2 e-14 7)))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (bs- e-3 e-15 15)))))(else '())))) ((3) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (bs- e-4 e-16 31)))))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (bs- e-5 e-17 63)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (bu- e-6 e-18 8)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (bu- e-7 e-19 16)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (bu- e-8 e-20 32)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (bu- e-9 e-21 64)))))(else '())))) ((11) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 11 (PreludeC-45Cast-u--cast_Cast_Int_Char (bs- (PreludeC-45Cast-u--cast_Cast_Char_Int e-10) (PreludeC-45Cast-u--cast_Cast_Char_Int e-22) 63))))))(else '())))) ((12) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 12 (- e-11 e-23)))))(else '()))))(else '()))))
(define CoreC-45Primitives-strTail (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (cond ((equal? e-7 "") (if (null? e-3) '() (if (null? e-3) (box (vector 8 e-5 (vector 10 (substring e-7 1 (string-length e-7))))) '())))(else (if (null? e-3) (box (vector 8 e-5 (vector 10 (substring e-7 1 (string-length e-7))))) '())))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strSubstr (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((8) (let ((e-14 (vector-ref e-10 2))) (case (vector-ref e-14 0) ((0) (let ((e-15 (vector-ref e-14 1))) (if (null? e-11) '() (let ((e-18 (car e-11))) (let ((e-19 (cdr e-11))) (case (vector-ref e-18 0) ((8) (let ((e-22 (vector-ref e-18 2))) (case (vector-ref e-22 0) ((10) (let ((e-23 (vector-ref e-22 1))) (if (null? e-19) (box (vector 8 e-5 (vector 10 (string-substr e-7 e-15 e-23)))) '())))(else '()))))(else '())))))))(else '()))))(else '())))))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strReverse (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Types-reverse e-7)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-strLength (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45String-length e-7))))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-strIndex (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((8) (let ((e-14 (vector-ref e-10 2))) (case (vector-ref e-14 0) ((0) (let ((e-15 (vector-ref e-14 1))) (if (null? e-11) (let ((sc7 (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-15 0))) (cond ((equal? sc8 1) (PreludeC-45Types-u--C-60_Ord_Nat (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer e-15)) (PreludeC-45TypesC-45String-length e-7))) (else 0))))) (cond ((equal? sc7 1) (box (vector 8 e-5 (vector 11 (string-ref e-7 e-15))))) (else '()))) '())))(else '()))))(else '())))))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strHead (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (cond ((equal? e-7 "") (if (null? e-3) '() (if (null? e-3) (box (vector 8 e-5 (vector 11 (string-ref e-7 0)))) '())))(else (if (null? e-3) (box (vector 8 e-5 (vector 11 (string-ref e-7 0)))) '())))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strCons (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((11) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((8) (let ((e-14 (vector-ref e-10 2))) (case (vector-ref e-14 0) ((10) (let ((e-15 (vector-ref e-14 1))) (if (null? e-11) (box (vector 8 e-5 (vector 10 (PreludeC-45Types-strCons e-7 e-15)))) '())))(else '()))))(else '())))))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strAppend (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((8) (let ((e-14 (vector-ref e-10 2))) (case (vector-ref e-14 0) ((10) (let ((e-15 (vector-ref e-14 1))) (if (null? e-11) (box (vector 8 e-5 (vector 10 (PreludeC-45TypesC-45String-C-43C-43 e-7 e-15)))) '())))(else '()))))(else '())))))))(else '())))))(else '())))))))
(define CoreC-45Primitives-shiftr (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-9 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (blodwen-shr e-0 e-9)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-10 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (blodwen-shr e-1 e-10)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-11 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (blodwen-shr e-2 e-11)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (blodwen-shr e-3 e-12)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (blodwen-shr e-4 e-13)))))(else '())))) ((6) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (blodwen-shr e-5 e-14)))))(else '())))) ((7) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (blodwen-shr e-6 e-15)))))(else '())))) ((8) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (blodwen-shr e-7 e-16)))))(else '())))) ((9) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (blodwen-shr e-8 e-17)))))(else '()))))(else '()))))
(define CoreC-45Primitives-shiftl (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (blodwen-bits-shl-signed e-0 e-10 63)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-11 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (blodwen-bits-shl-signed e-1 e-11 7)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (blodwen-bits-shl-signed e-2 e-12 15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (blodwen-bits-shl-signed e-3 e-13 31)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (blodwen-bits-shl-signed e-4 e-14 63)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (blodwen-shl e-5 e-15)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (blodwen-bits-shl e-6 e-16 8)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (blodwen-bits-shl e-7 e-17 16)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (blodwen-bits-shl e-8 e-18 32)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (blodwen-bits-shl e-9 e-19 64)))))(else '()))))(else '()))))
(define CoreC-45Primitives-primTypes(blodwen-lazy (lambda () (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45Primitives-numTypes) (cons (vector 24 ) (cons (vector 25 ) '()))))))
(define CoreC-45Primitives-prim (lambda (arg-0) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "prim__" arg-0)))))
(define CoreC-45Primitives-predTy (lambda (arg-0 arg-1) (let ((u--arr (csegen-1064))) ((u--arr (vector 9 (CoreC-45FC-emptyFC) arg-0)) (vector 9 (CoreC-45FC-emptyFC) arg-1)))))
(define CoreC-45Primitives-pi (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (vector 3 (CoreC-45FC-emptyFC) (vector 1 (vector 0 arg-1)) (vector 2 (CoreC-45FC-emptyFC) arg-2 arg-3 arg-4) arg-5)))
(define CoreC-45Primitives-opName (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "add_" (CoreC-45TT-u--show_Show_Constant e-0))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "sub_" (CoreC-45TT-u--show_Show_Constant e-1))))) ((2) (let ((e-2 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "mul_" (CoreC-45TT-u--show_Show_Constant e-2))))) ((3) (let ((e-3 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "div_" (CoreC-45TT-u--show_Show_Constant e-3))))) ((4) (let ((e-4 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "mod_" (CoreC-45TT-u--show_Show_Constant e-4))))) ((5) (let ((e-5 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "negate_" (CoreC-45TT-u--show_Show_Constant e-5))))) ((6) (let ((e-6 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "shl_" (CoreC-45TT-u--show_Show_Constant e-6))))) ((7) (let ((e-7 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "shr_" (CoreC-45TT-u--show_Show_Constant e-7))))) ((8) (let ((e-8 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "and_" (CoreC-45TT-u--show_Show_Constant e-8))))) ((9) (let ((e-9 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "or_" (CoreC-45TT-u--show_Show_Constant e-9))))) ((10) (let ((e-10 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "xor_" (CoreC-45TT-u--show_Show_Constant e-10))))) ((11) (let ((e-11 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "lt_" (CoreC-45TT-u--show_Show_Constant e-11))))) ((12) (let ((e-12 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "lte_" (CoreC-45TT-u--show_Show_Constant e-12))))) ((13) (let ((e-13 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "eq_" (CoreC-45TT-u--show_Show_Constant e-13))))) ((14) (let ((e-14 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "gte_" (CoreC-45TT-u--show_Show_Constant e-14))))) ((15) (let ((e-15 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "gt_" (CoreC-45TT-u--show_Show_Constant e-15))))) ((16) (CoreC-45Primitives-prim "strLength")) ((17) (CoreC-45Primitives-prim "strHead")) ((18) (CoreC-45Primitives-prim "strTail")) ((19) (CoreC-45Primitives-prim "strIndex")) ((20) (CoreC-45Primitives-prim "strCons")) ((21) (CoreC-45Primitives-prim "strAppend")) ((22) (CoreC-45Primitives-prim "strReverse")) ((23) (CoreC-45Primitives-prim "strSubstr")) ((24) (CoreC-45Primitives-prim "doubleExp")) ((25) (CoreC-45Primitives-prim "doubleLog")) ((26) (CoreC-45Primitives-prim "doublePow")) ((27) (CoreC-45Primitives-prim "doubleSin")) ((28) (CoreC-45Primitives-prim "doubleCos")) ((29) (CoreC-45Primitives-prim "doubleTan")) ((30) (CoreC-45Primitives-prim "doubleASin")) ((31) (CoreC-45Primitives-prim "doubleACos")) ((32) (CoreC-45Primitives-prim "doubleATan")) ((33) (CoreC-45Primitives-prim "doubleSqrt")) ((34) (CoreC-45Primitives-prim "doubleFloor")) ((35) (CoreC-45Primitives-prim "doubleCeiling")) ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (CoreC-45Primitives-prim (PreludeC-45TypesC-45String-C-43C-43 "cast_" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Constant e-16) (CoreC-45TT-u--show_Show_Constant e-17))))))) ((37) (CoreC-45Primitives-prim "believe_me")) (else (CoreC-45Primitives-prim "crash")))))
(define CoreC-45Primitives-numTypes(blodwen-lazy (lambda () (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45Primitives-integralTypes) (cons (vector 26 ) '())))))
(define CoreC-45Primitives-neg (lambda (arg-0) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (- 0 e-0))))) ((0) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (bs- 0 e-1 63))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (bs- 0 e-2 7))))) ((2) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (bs- 0 e-3 15))))) ((3) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (bs- 0 e-4 31))))) ((4) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (bs- 0 e-5 63))))) ((6) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (bu- 0 e-6 8))))) ((7) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (bu- 0 e-7 16))))) ((8) (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (bu- 0 e-8 32))))) ((9) (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (bu- 0 e-9 64))))) ((12) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 12 (- e-10)))))(else '()))))
(define CoreC-45Primitives-mul (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-11 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (* e-0 e-11)))))(else '())))) ((6) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (bu* e-1 e-12 8)))))(else '())))) ((7) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (bu* e-2 e-13 16)))))(else '())))) ((8) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (bu* e-3 e-14 32)))))(else '())))) ((9) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (bu* e-4 e-15 64)))))(else '())))) ((0) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (bs* e-5 e-16 63)))))(else '())))) ((1) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (bs* e-6 e-17 7)))))(else '())))) ((2) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (bs* e-7 e-18 15)))))(else '())))) ((3) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (bs* e-8 e-19 31)))))(else '())))) ((4) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (bs* e-9 e-20 63)))))(else '())))) ((12) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 12 (PreludeC-45Num-u--C-42_Num_Double e-10 e-21)))))(else '()))))(else '()))))
(define CoreC-45Primitives-mod (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-10 (vector-ref arg-1 1))) (cond ((equal? e-10 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (PreludeC-45Num-u--mod_Integral_Integer e-0 e-10)))))))(else '())))) ((0) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-11 (vector-ref arg-1 1))) (cond ((equal? e-11 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (PreludeC-45Num-u--mod_Integral_Int e-1 e-11)))))))(else '())))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-12 (vector-ref arg-1 1))) (cond ((equal? e-12 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (PreludeC-45Num-u--mod_Integral_Int8 e-2 e-12)))))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-13 (vector-ref arg-1 1))) (cond ((equal? e-13 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (PreludeC-45Num-u--mod_Integral_Int16 e-3 e-13)))))))(else '())))) ((3) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-14 (vector-ref arg-1 1))) (cond ((equal? e-14 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (PreludeC-45Num-u--mod_Integral_Int32 e-4 e-14)))))))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-15 (vector-ref arg-1 1))) (cond ((equal? e-15 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (PreludeC-45Num-u--mod_Integral_Int64 e-5 e-15)))))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (cond ((equal? e-16 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (PreludeC-45Num-u--mod_Integral_Bits8 e-6 e-16)))))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (cond ((equal? e-17 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (PreludeC-45Num-u--mod_Integral_Bits16 e-7 e-17)))))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (cond ((equal? e-18 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (PreludeC-45Num-u--mod_Integral_Bits32 e-8 e-18)))))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (cond ((equal? e-19 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (PreludeC-45Num-u--mod_Integral_Bits64 e-9 e-19)))))))(else '()))))(else '()))))
(define CoreC-45Primitives-lte (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Double e-12 e-25)))))(else '()))))(else '()))))
(define CoreC-45Primitives-lt (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Double e-12 e-25)))))(else '()))))(else '()))))
(define CoreC-45Primitives-integralTypes(blodwen-lazy (lambda () (cons (vector 14 ) (cons (vector 15 ) (cons (vector 16 ) (cons (vector 17 ) (cons (vector 18 ) (cons (vector 19 ) (cons (vector 20 ) (cons (vector 21 ) (cons (vector 22 ) (cons (vector 23 ) '())))))))))))))
(define CoreC-45Primitives-gte (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Double e-12 e-25)))))(else '()))))(else '()))))
(define CoreC-45Primitives-gt (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Double e-12 e-25)))))(else '()))))(else '()))))
(define CoreC-45Primitives-getOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-add eta-1 eta-2))) arg-2 eta-0))) ((1) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-sub eta-1 eta-2))) arg-2 eta-0))) ((2) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-mul eta-1 eta-2))) arg-2 eta-0))) ((3) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-div eta-1 eta-2))) arg-2 eta-0))) ((4) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-mod eta-1 eta-2))) arg-2 eta-0))) ((5) (lambda (eta-0) (CoreC-45Primitives-unaryOp (lambda (eta-1) (CoreC-45Primitives-neg eta-1)) arg-2 eta-0))) ((6) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-shiftl eta-1 eta-2))) arg-2 eta-0))) ((7) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-shiftr eta-1 eta-2))) arg-2 eta-0))) ((8) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-band eta-1 eta-2))) arg-2 eta-0))) ((9) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-bor eta-1 eta-2))) arg-2 eta-0))) ((10) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-bxor eta-1 eta-2))) arg-2 eta-0))) ((11) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-lt eta-1 eta-2))) arg-2 eta-0))) ((12) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-lte eta-1 eta-2))) arg-2 eta-0))) ((13) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-eq eta-1 eta-2))) arg-2 eta-0))) ((14) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-gte eta-1 eta-2))) arg-2 eta-0))) ((15) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-gt eta-1 eta-2))) arg-2 eta-0))) ((16) (lambda (eta-0) (CoreC-45Primitives-strLength eta-0))) ((17) (lambda (eta-0) (CoreC-45Primitives-strHead eta-0))) ((18) (lambda (eta-0) (CoreC-45Primitives-strTail eta-0))) ((19) (lambda (eta-0) (CoreC-45Primitives-strIndex eta-0))) ((20) (lambda (eta-0) (CoreC-45Primitives-strCons eta-0))) ((21) (lambda (eta-0) (CoreC-45Primitives-strAppend eta-0))) ((22) (lambda (eta-0) (CoreC-45Primitives-strReverse eta-0))) ((23) (lambda (eta-0) (CoreC-45Primitives-strSubstr eta-0))) ((24) (lambda (eta-0) (CoreC-45Primitives-doubleExp eta-0))) ((25) (lambda (eta-0) (CoreC-45Primitives-doubleLog eta-0))) ((26) (lambda (eta-0) (CoreC-45Primitives-doublePow arg-2 eta-0))) ((27) (lambda (eta-0) (CoreC-45Primitives-doubleSin eta-0))) ((28) (lambda (eta-0) (CoreC-45Primitives-doubleCos eta-0))) ((29) (lambda (eta-0) (CoreC-45Primitives-doubleTan eta-0))) ((30) (lambda (eta-0) (CoreC-45Primitives-doubleASin eta-0))) ((31) (lambda (eta-0) (CoreC-45Primitives-doubleACos eta-0))) ((32) (lambda (eta-0) (CoreC-45Primitives-doubleATan eta-0))) ((33) (lambda (eta-0) (CoreC-45Primitives-doubleSqrt eta-0))) ((34) (lambda (eta-0) (CoreC-45Primitives-doubleFloor eta-0))) ((35) (lambda (eta-0) (CoreC-45Primitives-doubleCeiling eta-0))) ((36) (let ((e-17 (vector-ref arg-1 2))) (lambda (eta-0) (CoreC-45Primitives-castTo e-17 eta-0)))) ((37) (lambda (eta-0) (CoreC-45Primitives-believeMe eta-0)))(else (lambda (eta-0) '())))))
(define CoreC-45Primitives-eq (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Double e-12 e-25)))))(else '()))))(else '()))))
(define CoreC-45Primitives-doubleTy(blodwen-lazy (lambda () (CoreC-45Primitives-predTy (vector 26 ) (vector 26 )))))
(define CoreC-45Primitives-doubleTan (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-tan eta-0)) ext-0)))
(define CoreC-45Primitives-doubleSqrt (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-sqrt eta-0)) ext-0)))
(define CoreC-45Primitives-doubleSin (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-sin eta-0)) ext-0)))
(define CoreC-45Primitives-doublePow (lambda (arg-0 ext-0) (CoreC-45Primitives-binOp (lambda (eta-0) (lambda (eta-1) (CoreC-45Primitives-n--9651-4674-u--powC-39 arg-0 eta-0 eta-1))) arg-0 ext-0)))
(define CoreC-45Primitives-doubleOp (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((12) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (arg-1 e-7)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-doubleLog (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-log eta-0)) ext-0)))
(define CoreC-45Primitives-doubleFloor (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-floor eta-0)) ext-0)))
(define CoreC-45Primitives-doubleExp (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-exp eta-0)) ext-0)))
(define CoreC-45Primitives-doubleCos (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-cos eta-0)) ext-0)))
(define CoreC-45Primitives-doubleCeiling (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-ceiling eta-0)) ext-0)))
(define CoreC-45Primitives-doubleATan (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-atan eta-0)) ext-0)))
(define CoreC-45Primitives-doubleASin (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-asin eta-0)) ext-0)))
(define CoreC-45Primitives-doubleACos (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (PreludeC-45Types-acos eta-0)) ext-0)))
(define CoreC-45Primitives-div (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-11 (vector-ref arg-1 1))) (cond ((equal? e-11 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (PreludeC-45Num-u--div_Integral_Integer e-0 e-11)))))))(else '())))) ((0) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-12 (vector-ref arg-1 1))) (cond ((equal? e-12 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (PreludeC-45Num-u--div_Integral_Int e-1 e-12)))))))(else '())))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-13 (vector-ref arg-1 1))) (cond ((equal? e-13 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (PreludeC-45Num-u--div_Integral_Int8 e-2 e-13)))))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-14 (vector-ref arg-1 1))) (cond ((equal? e-14 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (PreludeC-45Num-u--div_Integral_Int16 e-3 e-14)))))))(else '())))) ((3) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-15 (vector-ref arg-1 1))) (cond ((equal? e-15 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (PreludeC-45Num-u--div_Integral_Int32 e-4 e-15)))))))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-16 (vector-ref arg-1 1))) (cond ((equal? e-16 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (PreludeC-45Num-u--div_Integral_Int64 e-5 e-16)))))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-17 (vector-ref arg-1 1))) (cond ((equal? e-17 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (PreludeC-45Num-u--div_Integral_Bits8 e-6 e-17)))))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-18 (vector-ref arg-1 1))) (cond ((equal? e-18 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (PreludeC-45Num-u--div_Integral_Bits16 e-7 e-18)))))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-19 (vector-ref arg-1 1))) (cond ((equal? e-19 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (PreludeC-45Num-u--div_Integral_Bits32 e-8 e-19)))))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-20 (vector-ref arg-1 1))) (cond ((equal? e-20 0) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (PreludeC-45Num-u--div_Integral_Bits64 e-9 e-20)))))))(else '())))) ((12) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 12 (PreludeC-45Num-u--C-47_Fractional_Double e-10 e-21)))))(else '()))))(else '()))))
(define CoreC-45Primitives-crashTy(blodwen-lazy (lambda () (CoreC-45Primitives-pi "a" (csegen-21) (vector 1 ) (vector 11 (CoreC-45FC-emptyFC)) (CoreC-45Primitives-pi "msg" (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 9 (CoreC-45FC-emptyFC) (vector 24 )) (csegen-1092))))))
(define CoreC-45Primitives-constantIntegerValue (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Int_Integer e-0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Int8_Integer e-1)))) ((2) (let ((e-2 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Int16_Integer e-2)))) ((3) (let ((e-3 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Int32_Integer e-3)))) ((4) (let ((e-4 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Int64_Integer e-4)))) ((5) (let ((e-5 (vector-ref arg-0 1))) (box e-5))) ((6) (let ((e-6 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Bits8_Integer e-6)))) ((7) (let ((e-7 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Bits16_Integer e-7)))) ((8) (let ((e-8 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Bits32_Integer e-8)))) ((9) (let ((e-9 (vector-ref arg-0 1))) (box (PreludeC-45Cast-u--cast_Cast_Bits64_Integer e-9))))(else '()))))
(define CoreC-45Primitives-constTy3 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--arr (csegen-1064))) ((u--arr (vector 9 (CoreC-45FC-emptyFC) arg-0)) ((u--arr (vector 9 (CoreC-45FC-emptyFC) arg-1)) ((u--arr (vector 9 (CoreC-45FC-emptyFC) arg-2)) (vector 9 (CoreC-45FC-emptyFC) arg-3)))))))
(define CoreC-45Primitives-constTy (lambda (arg-0 arg-1 arg-2) (let ((u--arr (csegen-1064))) ((u--arr (vector 9 (CoreC-45FC-emptyFC) arg-0)) ((u--arr (vector 9 (CoreC-45FC-emptyFC) arg-1)) (vector 9 (CoreC-45FC-emptyFC) arg-2))))))
(define CoreC-45Primitives-cmpTy (lambda (arg-0) (CoreC-45Primitives-constTy arg-0 arg-0 (vector 14 ))))
(define CoreC-45Primitives-castTo (lambda (arg-1 ext-0) (case (vector-ref arg-1 0) ((14) (CoreC-45Primitives-castInt ext-0)) ((15) (CoreC-45Primitives-castInt8 ext-0)) ((16) (CoreC-45Primitives-castInt16 ext-0)) ((17) (CoreC-45Primitives-castInt32 ext-0)) ((18) (CoreC-45Primitives-castInt64 ext-0)) ((19) (CoreC-45Primitives-castInteger ext-0)) ((20) (CoreC-45Primitives-castBits8 ext-0)) ((21) (CoreC-45Primitives-castBits16 ext-0)) ((22) (CoreC-45Primitives-castBits32 ext-0)) ((23) (CoreC-45Primitives-castBits64 ext-0)) ((24) (CoreC-45Primitives-castString ext-0)) ((25) (CoreC-45Primitives-castChar ext-0)) ((26) (CoreC-45Primitives-castDouble ext-0))(else '()))))
(define CoreC-45Primitives-castString (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int e-7)))) '()))) ((1) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int8 e-8)))) '()))) ((2) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int16 e-9)))) '()))) ((3) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int32 e-10)))) '()))) ((4) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int64 e-11)))) '()))) ((5) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Integer e-12)))) '()))) ((6) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Bits8 e-13)))) '()))) ((7) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Bits16 e-14)))) '()))) ((8) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Bits32 e-15)))) '()))) ((9) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Bits64 e-16)))) '()))) ((11) (let ((e-17 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (LibrariesC-45UtilsC-45String-stripQuotes (PreludeC-45Show-u--show_Show_Char e-17))))) '()))) ((12) (let ((e-18 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Double e-18)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castInteger (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-7)))) '()))) ((1) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Int8_Integer e-8)))) '()))) ((2) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Int16_Integer e-9)))) '()))) ((3) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Int32_Integer e-10)))) '()))) ((4) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Int64_Integer e-11)))) '()))) ((6) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Bits8_Integer e-12)))) '()))) ((7) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Bits16_Integer e-13)))) '()))) ((8) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Bits32_Integer e-14)))) '()))) ((9) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Bits64_Integer e-15)))) '()))) ((11) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Int_Integer (PreludeC-45Cast-u--cast_Cast_Char_Int e-16))))) '()))) ((12) (let ((e-17 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_Double_Integer e-17)))) '()))) ((10) (let ((e-18 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (PreludeC-45Cast-u--cast_Cast_String_Integer e-18)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castInt8 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-5 (vector 1 (PreludeC-45Cast-u--cast_Cast_Integer_Int8 eta-0)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castInt64 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-5 (vector 4 (PreludeC-45Cast-u--cast_Cast_Integer_Int64 eta-0)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castInt32 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-5 (vector 3 (PreludeC-45Cast-u--cast_Cast_Integer_Int32 eta-0)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castInt16 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-5 (vector 2 (PreludeC-45Cast-u--cast_Cast_Integer_Int16 eta-0)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castInt (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((1) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Int8_Int e-7)))) '()))) ((2) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Int16_Int e-8)))) '()))) ((3) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Int32_Int e-9)))) '()))) ((4) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Int64_Int e-10)))) '()))) ((5) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Integer_Int e-11)))) '()))) ((6) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Bits8_Int e-12)))) '()))) ((7) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Bits16_Int e-13)))) '()))) ((8) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Bits32_Int e-14)))) '()))) ((9) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Bits64_Int e-15)))) '()))) ((12) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Double_Int e-16)))) '()))) ((11) (let ((e-17 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_Char_Int e-17)))) '()))) ((10) (let ((e-18 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (PreludeC-45Cast-u--cast_Cast_String_Int e-18)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castDouble (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Int_Double e-7)))) '()))) ((1) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Int8_Double e-8)))) '()))) ((2) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Int16_Double e-9)))) '()))) ((3) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Int32_Double e-10)))) '()))) ((4) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Int64_Double e-11)))) '()))) ((6) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Bits8_Double e-12)))) '()))) ((7) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Bits16_Double e-13)))) '()))) ((8) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Bits32_Double e-14)))) '()))) ((9) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Bits64_Double e-15)))) '()))) ((5) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_Integer_Double e-16)))) '()))) ((10) (let ((e-17 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (PreludeC-45Cast-u--cast_Cast_String_Double e-17)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castChar (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Int_Char e-7)))) '()))) ((1) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Int8_Char e-8)))) '()))) ((2) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Int16_Char e-9)))) '()))) ((3) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Int32_Char e-10)))) '()))) ((4) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Int64_Char e-11)))) '()))) ((6) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Bits8_Char e-12)))) '()))) ((7) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Bits16_Char e-13)))) '()))) ((8) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Bits32_Char e-14)))) '()))) ((9) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Bits64_Char e-15)))) '()))) ((5) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (PreludeC-45Cast-u--cast_Cast_Integer_Char e-16)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castBits8 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-5 (vector 6 (PreludeC-45Cast-u--cast_Cast_Integer_Bits8 eta-0)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castBits64 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-5 (vector 9 (PreludeC-45Cast-u--cast_Cast_Integer_Bits64 eta-0)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castBits32 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-5 (vector 8 (PreludeC-45Cast-u--cast_Cast_Integer_Bits32 eta-0)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castBits16 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 8 e-5 (vector 7 (PreludeC-45Cast-u--cast_Cast_Integer_Bits16 eta-0)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-bxor (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (blodwen-xor e-0 e-10)))))(else '())))) ((6) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-11 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (blodwen-xor e-1 e-11)))))(else '())))) ((7) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (blodwen-xor e-2 e-12)))))(else '())))) ((8) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (blodwen-xor e-3 e-13)))))(else '())))) ((9) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (blodwen-xor e-4 e-14)))))(else '())))) ((1) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (blodwen-xor e-5 e-15)))))(else '())))) ((2) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (blodwen-xor e-6 e-16)))))(else '())))) ((3) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (blodwen-xor e-7 e-17)))))(else '())))) ((4) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (blodwen-xor e-8 e-18)))))(else '())))) ((5) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (blodwen-xor e-9 e-19)))))(else '()))))(else '()))))
(define CoreC-45Primitives-bor (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (blodwen-or e-0 e-10)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-11 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (blodwen-or e-1 e-11)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (blodwen-or e-2 e-12)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (blodwen-or e-3 e-13)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (blodwen-or e-4 e-14)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (blodwen-or e-5 e-15)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (blodwen-or e-6 e-16)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (blodwen-or e-7 e-17)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (blodwen-or e-8 e-18)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (blodwen-or e-9 e-19)))))(else '()))))(else '()))))
(define CoreC-45Primitives-binOp (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) '() (let ((e-9 (car e-3))) (let ((e-10 (cdr e-3))) (case (vector-ref e-9 0) ((8) (let ((e-13 (vector-ref e-9 2))) (if (null? e-10) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 eta-0)) ((arg-0 e-6) e-13)) '())))(else '()))))))))(else '())))))))
(define CoreC-45Primitives-believeMeTy(blodwen-lazy (lambda () (CoreC-45Primitives-pi "a" (csegen-21) (vector 1 ) (vector 11 (CoreC-45FC-emptyFC)) (CoreC-45Primitives-pi "b" (csegen-21) (vector 1 ) (vector 11 (CoreC-45FC-emptyFC)) (CoreC-45Primitives-pi "x" (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (csegen-1092) (csegen-1092)))))))
(define CoreC-45Primitives-believeMe (lambda (arg-1) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-10 0) ((2) (if (null? e-11) (box e-10) '())) ((3) (if (null? e-11) (box e-10) '())) ((8) (if (null? e-11) (box e-10) '())) ((10) (let ((e-29 (vector-ref e-10 1))) (if (null? e-11) (box (vector 10 e-29)) '())))(else '()))))))))
(define CoreC-45Primitives-band (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (blodwen-and e-0 e-10)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-11 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (blodwen-and e-1 e-11)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (blodwen-and e-2 e-12)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (blodwen-and e-3 e-13)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (blodwen-and e-4 e-14)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (blodwen-and e-5 e-15)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (blodwen-and e-6 e-16)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (blodwen-and e-7 e-17)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (blodwen-and e-8 e-18)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (blodwen-and e-9 e-19)))))(else '()))))(else '()))))
(define CoreC-45Primitives-arithTy (lambda (arg-0) (CoreC-45Primitives-constTy arg-0 arg-0 arg-0)))
(define CoreC-45Primitives-allPrimitives(blodwen-lazy (lambda () (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 0 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-numTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 1 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-numTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 2 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-numTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 0) (vector 5 u--t) (CoreC-45Primitives-predTy u--t u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-numTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 3 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-notCovering))) (CoreC-45Primitives-numTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 4 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-notCovering))) (CoreC-45Primitives-integralTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 6 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-integralTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 7 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-integralTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 8 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-integralTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 9 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-integralTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 10 u--t) (CoreC-45Primitives-arithTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-integralTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 11 u--t) (CoreC-45Primitives-cmpTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-primTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 12 u--t) (CoreC-45Primitives-cmpTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-primTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 13 u--t) (CoreC-45Primitives-cmpTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-primTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 14 u--t) (CoreC-45Primitives-cmpTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-primTypes)) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (vector (+ 1 (+ 1 0)) (vector 15 u--t) (CoreC-45Primitives-cmpTy u--t) (CoreC-45TT-isTotal))) (CoreC-45Primitives-primTypes)) (PreludeC-45TypesC-45List-tailRecAppend (cons (vector (+ 1 0) (vector 16 ) (CoreC-45Primitives-predTy (vector 24 ) (vector 14 )) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 17 ) (CoreC-45Primitives-predTy (vector 24 ) (vector 25 )) (CoreC-45TT-notCovering)) (cons (vector (+ 1 0) (vector 18 ) (CoreC-45Primitives-predTy (vector 24 ) (vector 24 )) (CoreC-45TT-notCovering)) (cons (vector (+ 1 (+ 1 0)) (vector 19 ) (CoreC-45Primitives-constTy (vector 24 ) (vector 14 ) (vector 25 )) (CoreC-45TT-notCovering)) (cons (vector (+ 1 (+ 1 0)) (vector 20 ) (CoreC-45Primitives-constTy (vector 25 ) (vector 24 ) (vector 24 )) (CoreC-45TT-isTotal)) (cons (vector (+ 1 (+ 1 0)) (vector 21 ) (CoreC-45Primitives-arithTy (vector 24 )) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 22 ) (CoreC-45Primitives-predTy (vector 24 ) (vector 24 )) (CoreC-45TT-isTotal)) (cons (vector (+ 1 (+ 1 (+ 1 0))) (vector 23 ) (CoreC-45Primitives-constTy3 (vector 14 ) (vector 14 ) (vector 24 ) (vector 24 )) (CoreC-45TT-isTotal)) (cons (vector (+ 1 (+ 1 (+ 1 0))) (vector 37 ) (CoreC-45Primitives-believeMeTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 (+ 1 0)) (vector 38 ) (CoreC-45Primitives-crashTy) (CoreC-45TT-notCovering)) '())))))))))) (PreludeC-45TypesC-45List-tailRecAppend (cons (vector (+ 1 0) (vector 24 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 25 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 (+ 1 0)) (vector 26 ) (CoreC-45Primitives-arithTy (vector 26 )) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 27 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 28 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 29 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 30 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 31 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 32 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 33 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 34 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) (cons (vector (+ 1 0) (vector 35 ) (CoreC-45Primitives-doubleTy) (CoreC-45TT-isTotal)) '())))))))))))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (CoreC-45Primitives-primTypes) (lambda (u--t1) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (CoreC-45Primitives-primTypes) (lambda (u--t2) (PreludeC-45Interfaces-C-62C-62 (csegen-1193) (PreludeC-45Interfaces-guard (csegen-1201) (let ((sc0 (CoreC-45TT-u--C-47C-61_Eq_Constant u--t1 u--t2))) (cond ((equal? sc0 1) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1204) (csegen-1204) (cons u--t1 u--t2) (cons (vector 24 ) (vector 25 ))))) (cond ((equal? sc1 1) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1204) (csegen-1204) (cons u--t1 u--t2) (cons (vector 26 ) (vector 25 ))))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1204) (csegen-1204) (cons u--t1 u--t2) (cons (vector 25 ) (vector 26 )))) (else 0)))) (else 0)))) (else 0)))) (lambda () (PreludeC-45Types-u--pure_Applicative_List (vector (+ 1 0) (vector 36 u--t1 u--t2) (CoreC-45Primitives-predTy u--t1 u--t2) (CoreC-45TT-isTotal))))))))))))))))))))))))))))))
(define CoreC-45Primitives-add (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 (+ e-0 e-12)))))(else '())))) ((0) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 (bs+ e-1 e-13 63)))))(else '())))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (bs+ e-2 e-14 7)))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 (bs+ e-3 e-15 15)))))(else '())))) ((3) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 (bs+ e-4 e-16 31)))))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 (bs+ e-5 e-17 63)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 (bu+ e-6 e-18 8)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 (bu+ e-7 e-19 16)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (bu+ e-8 e-20 32)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 (bu+ e-9 e-21 64)))))(else '())))) ((11) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 11 (PreludeC-45Cast-u--cast_Cast_Int_Char (bs+ (PreludeC-45Cast-u--cast_Cast_Char_Int e-10) (PreludeC-45Cast-u--cast_Cast_Char_Int e-22) 63))))))(else '())))) ((12) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 12 (PreludeC-45Num-u--C-43_Num_Double e-11 e-23)))))(else '()))))(else '()))))
(define CoreC-45NormaliseC-45Quote-n--7425-3441-u--toHolesOnly (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (let ((e-5 (vector-ref arg-13 5))) (vector 0 e-1 (let ((e-11 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (let ((e-9 (vector-ref e-2 4))) (let ((e-8 (vector-ref e-2 5))) (let ((e-6 (vector-ref e-2 6))) (let ((e-7 (vector-ref e-2 7))) (vector 1 1 e-11 e-10 e-9 e-8 e-6 e-7))))))) e-3 e-4 e-5)))))))(else arg-13))))
(define CoreC-45NormaliseC-45Quote-n--7425-3101-u--isRef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) 1)(else 0))))
(define CoreC-45NormaliseC-45Quote-n--7398-2487-u--findName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12) (case (vector-ref arg-12 0) ((0) '()) (else (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 e-5))) (cond ((equal? sc2 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Quote-n--7398-2487-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) (csegen-549)))))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Quote-n--7398-2487-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) (csegen-549))))))))))
(define CoreC-45NormaliseC-45Quote-n--7398-2353-u--addLater (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-15 arg-16) (if (null? arg-16) arg-15 (let ((e-3 (cdr arg-16))) (+ 1 (CoreC-45NormaliseC-45Quote-n--7398-2353-u--addLater arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-15 e-3))))))
(define CoreC-45NormaliseC-45Quote-u--quote_Quote_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Term arg-0 arg-1 e-5 (vector 1 0 '()) arg-2 arg-3 arg-4 ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quote_Quote_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF arg-0 arg-1 e-5 (vector 1 0 '()) arg-2 arg-3 arg-4) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure arg-0 arg-1 e-5 (vector 1 0 '()) arg-2 arg-3 arg-4 ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF arg-0 arg-1 e-5 arg-2 arg-3 arg-4 arg-5) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure arg-0 arg-1 e-5 arg-2 arg-3 arg-4 arg-5 ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quoteLHS_Quote_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF arg-0 arg-1 e-5 (vector 1 1 '()) arg-2 arg-3 arg-4) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quoteLHS_Quote_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure arg-0 arg-1 e-5 (vector 1 1 '()) arg-2 arg-3 arg-4 ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (vector 1 arg-6)))
(define CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 '() arg-1 arg-2 arg-3 arg-4 (vector 0 ) arg-5 arg-6 eta-0))))
(define CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-quoteWithPiGen (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (CoreC-45NormaliseC-45Quote-genName arg-3 "qv" clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (((e-4 arg-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-7 (vector 1 e-1 (vector 0 ) e-5))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) ((CoreC-45NormaliseC-45Quote-quoteWithPiGen arg-0 (cons e-2 arg-1) arg-2 arg-3 arg-4 arg-5 (vector 1 e-2 e-5 arg-6) arg-7 e-11) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 e-10 e-9) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 e-10 arg-6 arg-7 e-12 clam-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 e-10 arg-6 arg-7 e-8 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 e-7 e-13 e-12) e-11)))))))))))))))))))))))))))(else (let ((act-24 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6 arg-7 arg-8 clam-0))))))))))))(else (let ((act-24 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6 arg-7 arg-8 clam-0))))))))))
(define CoreC-45NormaliseC-45Quote-quoteWithPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Quote-quoteWithPiGen arg-0 '() arg-1 e-5 (vector 1 0 '()) arg-2 (vector 0 ) arg-3 arg-4) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-quotePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-8 1))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5)))))))))))
(define CoreC-45NormaliseC-45Quote-quoteHead (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-2 (vector-ref arg-9 1))) (let ((e-3 (vector-ref arg-9 2))) (lambda (eta-0) (vector 1 (vector 0 arg-6 e-2 (CoreC-45NormaliseC-45Quote-n--7398-2353-u--addLater arg-2 e-3 e-2 arg-8 arg-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 e-3 arg-1))))))) ((1) (let ((e-6 (vector-ref arg-9 1))) (let ((e-7 (vector-ref arg-9 2))) (lambda (clam-0) (case (vector-ref e-6 0) ((0) (case (vector-ref e-7 0) ((2) (let ((e-12 (vector-ref e-7 1))) (let ((e-13 (vector-ref e-7 2))) (vector 1 (let ((sc3 (CoreC-45NormaliseC-45Quote-n--7398-2487-u--findName arg-1 arg-2 e-13 e-12 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-7))) (if (null? sc3) (vector 1 arg-6 (vector 0 ) (vector 2 e-12 e-13)) (let ((e-1 (unbox sc3))) (vector 0 arg-6 '() e-1))))))))(else (vector 1 (vector 1 arg-6 e-6 e-7)))))(else (vector 1 (vector 1 arg-6 e-6 e-7)))))))) (else (let ((e-9 (vector-ref arg-9 1))) (let ((e-10 (vector-ref arg-9 2))) (let ((e-11 (vector-ref arg-9 3))) (lambda (eta-0) (let ((act-24 (CoreC-45NormaliseC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 e-11 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 arg-6 e-9 e-10 e-5))))))))))))))
(define CoreC-45NormaliseC-45Quote-quoteGenNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((act-24 (CoreC-45NormaliseC-45Quote-genName arg-3 "qv" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (((e-4 arg-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-7 (vector 1 e-1 (vector 0 ) e-5))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 (cons e-2 arg-1) arg-2 arg-3 arg-4 arg-5 (vector 1 e-2 e-5 arg-6) arg-7 e-6 ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-quoteBinder arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 3 e-1 e-2 e-7 e-6))))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (let ((act-24 ((CoreC-45NormaliseC-45Quote-quoteHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-6 arg-7 e-7) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((e-2 (vector-ref arg-4 2))) (if (null? e-2) (vector 1 arg-4) (let ((e-3 (unbox e-2))) (cond ((equal? e-3 0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Size limit exceeded") ext-0))(else (let ((e-4 (- e-3 1))) (vector 1 (let ((e-11 (vector-ref arg-4 0))) (let ((e-10 (vector-ref arg-4 1))) (vector e-11 e-10 (box e-4))))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((sc3 (let ((sc4 (let ((e-1 (vector-ref arg-4 1))) e-1))) (cond ((equal? sc4 1) (let ((sc5 (let ((e-0 (vector-ref arg-4 0))) e-0))) (cond ((equal? sc5 1) 0) (else (CoreC-45NormaliseC-45Quote-n--7425-3101-u--isRef arg-1 arg-2 e-8 e-7 e-6 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 e-7))))) (else 0))))) (cond ((equal? sc3 1) (let ((act-26 (CoreC-45Context-clearDefs arg-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 e-9 e-10 arg-6 arg-7 e-8 ext-0)))))) (else (CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 (let ((e-1 (vector-ref e-9 1))) (let ((e-2 (vector-ref e-9 2))) (vector 0 e-1 e-2))) arg-5 arg-6 arg-7 e-8 ext-0)))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-applyWithFC e-5 e-10)))))))))))))))))) ((2) (let ((e-10 (vector-ref arg-8 1))) (let ((e-11 (vector-ref arg-8 2))) (let ((e-12 (vector-ref arg-8 3))) (let ((e-13 (vector-ref arg-8 4))) (let ((e-14 (vector-ref arg-8 5))) (let ((act-24 (CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 1 e-10 (vector 2 e-12 e-13) e-11) e-5)))))))))))) ((3) (let ((e-16 (vector-ref arg-8 1))) (let ((e-17 (vector-ref arg-8 2))) (let ((e-18 (vector-ref arg-8 3))) (let ((e-19 (vector-ref arg-8 4))) (let ((e-20 (vector-ref arg-8 5))) (let ((act-24 (CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-20 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 1 e-16 (vector 3 e-18 e-19) e-17) e-5)))))))))))) ((4) (let ((e-22 (vector-ref arg-8 1))) (let ((e-23 (vector-ref arg-8 2))) (let ((e-24 (vector-ref arg-8 3))) (let ((e-25 (vector-ref arg-8 4))) (let ((act-24 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-24 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-25 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-22 e-23 e-5 e-6))))))))))))))) ((5) (let ((e-27 (vector-ref arg-8 1))) (let ((e-28 (vector-ref arg-8 2))) (let ((e-29 (vector-ref arg-8 3))) (let ((act-24 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-29 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-27 e-28 e-5)))))))))) ((6) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (let ((e-33 (vector-ref arg-8 3))) (let ((e-34 (vector-ref arg-8 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 (CoreC-45NormaliseC-45Quote-n--7425-3441-u--toHolesOnly arg-1 arg-2 e-34 e-33 e-32 e-31 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 e-34)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 (CoreC-45NormaliseC-45Quote-n--7425-3441-u--toHolesOnly arg-1 arg-2 e-34 e-33 e-32 e-31 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 e-33)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 7 e-31 e-32 e-8 e-6))))))))))))))))))))))) ((7) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (let ((e-39 (vector-ref arg-8 4))) (let ((act-24 (CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-39 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-38 0) ((6) (let ((e-4 (vector-ref e-38 4))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-applyWithFC e-7 e-5))))))))))))(else (let ((act-25 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-38 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 8 e-36 e-37 e-6) e-5))))))))))))))))) ((8) (let ((e-41 (vector-ref arg-8 1))) (let ((e-42 (vector-ref arg-8 2))) (vector 1 (vector 9 e-41 e-42))))) ((9) (let ((e-44 (vector-ref arg-8 1))) (let ((e-45 (vector-ref arg-8 2))) (vector 1 (vector 10 e-44 e-45))))) (else (let ((e-47 (vector-ref arg-8 1))) (vector 1 (vector 11 e-47)))))))
(define CoreC-45NormaliseC-45Quote-quoteBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-6 e-5))))))))))))))) ((1) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (let ((e-9 (vector-ref arg-8 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-9) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-10 ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (vector 1 e-6 e-7 e-5 e-10))))))))))))))) ((2) (let ((e-11 (vector-ref arg-8 1))) (let ((e-12 (vector-ref arg-8 2))) (let ((e-13 (vector-ref arg-8 3))) (let ((e-14 (vector-ref arg-8 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-14) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-13 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-11 e-12 e-6 e-5))))))))))))))) ((3) (let ((e-16 (vector-ref arg-8 1))) (let ((e-17 (vector-ref arg-8 2))) (let ((e-18 (vector-ref arg-8 3))) (let ((e-19 (vector-ref arg-8 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-19) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-18 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-16 e-17 e-6 e-5))))))))))))))) ((4) (let ((e-21 (vector-ref arg-8 1))) (let ((e-22 (vector-ref arg-8 2))) (let ((e-23 (vector-ref arg-8 3))) (let ((e-24 (vector-ref arg-8 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-23) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-24) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6 ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-21 e-22 e-5 e-6))))))))))))))) (else (let ((e-26 (vector-ref arg-8 1))) (let ((e-27 (vector-ref arg-8 2))) (let ((e-28 (vector-ref arg-8 3))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-28) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-26 e-27 e-5)))))))))))))
(define CoreC-45NormaliseC-45Quote-quoteArgsWithFC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-1 ext-0) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-quoteArgWithFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0 eta-1))) ext-1 '() ext-0)))
(define CoreC-45NormaliseC-45Quote-quoteArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-1 ext-0) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-quoteArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0 eta-1))) ext-1 '() ext-0)))
(define CoreC-45NormaliseC-45Quote-quoteArgWithFC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-1 ext-0) (CoreC-45Core-traversePair (lambda (eta-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-quoteArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0 eta-1))) ext-1 ext-0)))
(define CoreC-45NormaliseC-45Quote-quoteArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 arg-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 ext-0)))))))
(define CoreC-45NormaliseC-45Quote-genName (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))))))
(define CoreC-45NormaliseC-45Eval-case--caseC-32blockC-32inC-32evalDef-5377 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (lambda (clam-0) (if (null? arg-17) (vector 1 (arg-8)) (let ((e-2 (unbox arg-17))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-16 arg-3 arg-2 arg-15 e-5 arg-14 arg-12 e-6 arg-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (case (vector-ref e-7 0) ((0) (let ((e-1 (vector-ref e-7 1))) (vector 1 e-1)))(else (vector 1 (arg-8)))))))))))))))
(define CoreC-45NormaliseC-45Eval-case--evalOp-5211 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 (arg-3))) (let ((e-1 (unbox arg-8))) (lambda (clam-0) (if (null? e-1) (vector 1 (arg-3)) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (if (null? e-5) (let ((act-24 (CoreC-45NormaliseC-45Eval-n--7235-5176-u--evalAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (let ((sc4 (arg-6 e-6))) (if (null? sc4) (arg-3) (let ((e-2 (unbox sc4))) e-2)))))))) (vector 1 (arg-3)))))))))))
(define CoreC-45NormaliseC-45Eval-n--7233-5046-u--takeStk (lambda (arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-8) (cond ((equal? arg-6 0) (box (cons (DataC-45Vect-reverse arg-8) arg-7)))(else (let ((e-0 (- arg-6 1))) (if (null? arg-7) '() (let ((e-3 (car arg-7))) (let ((e-4 (cdr arg-7))) (CoreC-45NormaliseC-45Eval-n--7233-5046-u--takeStk arg-0 arg-1 arg-3 arg-4 e-0 e-4 (cons (Builtin-snd e-3) arg-8))))))))))
(define CoreC-45NormaliseC-45Eval-n--7061-1988-u--set (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-6 arg-2))) (cond ((equal? sc2 1) (cons (cons e-6 arg-3) e-3)) (else (cons (cons e-6 e-7) (CoreC-45NormaliseC-45Eval-n--7061-1988-u--set arg-0 arg-1 arg-2 arg-3 e-3))))))))))))
(define CoreC-45NormaliseC-45Eval-n--7235-5176-u--evalAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 ext-0) (if (null? arg-9) (vector 1 '()) (let ((e-3 (car arg-9))) (let ((e-4 (cdr arg-9))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-2 arg-0 e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Eval-n--7235-5176-u--evalAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6)))))))))))))))
(define CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((2) 1) ((3) 1) ((8) 1) ((0) 1) ((10) 1)(else 0))))
(define CoreC-45NormaliseC-45Eval-n--7221-2297-u--closeArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) '() (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (cons (vector 0 arg-2 arg-1 arg-9 arg-10 e-2) (CoreC-45NormaliseC-45Eval-n--7221-2297-u--closeArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3)))))))
(define CoreC-45NormaliseC-45Eval-updateLocal (lambda (arg-0 arg-1 arg-5 arg-6 arg-7 arg-9 arg-10) (cond ((equal? arg-7 0) (if (null? arg-9) arg-9 (let ((e-5 (cdr arg-9))) (cons (vector 1 arg-5 arg-6 arg-10) e-5))))(else (let ((e-0 (- arg-7 1))) (if (null? arg-9) arg-9 (let ((e-9 (car arg-9))) (let ((e-10 (cdr arg-9))) (cons e-9 (CoreC-45NormaliseC-45Eval-updateLocal arg-0 arg-1 arg-5 arg-6 e-0 e-10 arg-10))))))))))
(define CoreC-45NormaliseC-45Eval-updateLimit (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-0 0) ((1) (vector 1 (let ((sc1 (DataC-45List-isNil (let ((e-6 (vector-ref arg-2 6))) e-6)))) (cond ((equal? sc1 1) (box arg-2)) (else (let ((sc2 (DataC-45List-lookup (csegen-802) arg-1 (let ((e-6 (vector-ref arg-2 6))) e-6)))) (if (null? sc2) '() (let ((e-2 (unbox sc2))) (cond ((equal? e-2 0) '())(else (let ((e-3 (- e-2 1))) (box (let ((e-0 (vector-ref arg-2 0))) (let ((e-1 (vector-ref arg-2 1))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (let ((e-7 (vector-ref arg-2 7))) (vector e-0 e-1 e-9 e-8 e-4 e-5 (CoreC-45NormaliseC-45Eval-n--7061-1988-u--set arg-2 arg-1 arg-1 e-3 e-6) e-7)))))))))))))))))))))(else (vector 1 (box arg-2))))))
(define CoreC-45NormaliseC-45Eval-tryAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-10 0) ((2) (let ((e-5 (vector-ref arg-10 3))) (let ((e-7 (vector-ref arg-10 5))) (case (vector-ref arg-11 0) ((0) (let ((e-31 (vector-ref arg-11 2))) (let ((e-32 (vector-ref arg-11 3))) (let ((e-33 (vector-ref arg-11 4))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-31 e-5))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalConAlt arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-32 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-7) e-33)) (else (lambda (eta-0) (vector 1 (vector 1 ))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))) ((3) (let ((e-10 (vector-ref arg-10 2))) (let ((e-13 (vector-ref arg-10 5))) (case (vector-ref arg-11 0) ((0) (let ((e-35 (vector-ref arg-11 1))) (let ((e-37 (vector-ref arg-11 3))) (let ((e-38 (vector-ref arg-11 4))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-35))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalConAlt arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-37 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-13) e-38)) (else (lambda (eta-0) (vector 1 (vector 1 ))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))) ((8) (let ((e-16 (vector-ref arg-10 2))) (case (vector-ref arg-11 0) ((0) (let ((e-40 (vector-ref arg-11 1))) (let ((e-42 (vector-ref arg-11 3))) (let ((e-43 (vector-ref arg-11 4))) (if (null? e-42) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name (vector 1 (vector 0 (CoreC-45TT-u--show_Show_Constant e-16))) e-40))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-43)) (else (lambda (eta-0) (vector 1 (vector 1 )))))) (lambda (eta-0) (vector 1 (vector 1 )))))))) ((2) (let ((e-45 (vector-ref arg-11 1))) (let ((e-46 (vector-ref arg-11 2))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-45 e-16))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-46)) (else (lambda (eta-0) (vector 1 (vector 1 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))))))) ((10) (case (vector-ref arg-11 0) ((0) (let ((e-48 (vector-ref arg-11 1))) (let ((e-50 (vector-ref arg-11 3))) (let ((e-51 (vector-ref arg-11 4))) (case (vector-ref e-48 0) ((1) (let ((e-52 (vector-ref e-48 1))) (case (vector-ref e-52 0) ((0) (let ((e-53 (vector-ref e-52 1))) (cond ((equal? e-53 "Type") (if (null? e-50) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-51) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc7 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc7 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc5 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc5 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc4 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc3 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))) ((0) (let ((e-20 (vector-ref arg-10 1))) (let ((e-21 (vector-ref arg-10 2))) (let ((e-22 (vector-ref arg-10 3))) (let ((e-23 (vector-ref arg-10 4))) (case (vector-ref e-22 0) ((2) (let ((e-56 (vector-ref e-22 1))) (let ((e-57 (vector-ref e-22 2))) (let ((e-58 (vector-ref e-22 3))) (let ((e-59 (vector-ref e-22 4))) (case (vector-ref arg-11 0) ((0) (let ((e-61 (vector-ref arg-11 1))) (let ((e-63 (vector-ref arg-11 3))) (let ((e-64 (vector-ref arg-11 4))) (case (vector-ref e-61 0) ((1) (let ((e-65 (vector-ref e-61 1))) (case (vector-ref e-65 0) ((0) (let ((e-66 (vector-ref e-65 1))) (cond ((equal? e-66 "->") (if (null? e-63) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc8 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc8 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))) (let ((e-68 (car e-63))) (let ((e-69 (cdr e-63))) (if (null? e-69) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc9 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc9 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))) (let ((e-71 (car e-69))) (let ((e-72 (cdr e-69))) (if (null? e-72) (CoreC-45NormaliseC-45Eval-evalConAlt arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 (cons e-68 (cons e-71 '())) (cons e-59 (cons (vector 1 arg-7 arg-5 (vector 0 e-20 e-21 (vector 0 e-56 e-57 e-58 e-59) e-23)) '())) e-64) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc10 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc10 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc6 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc6 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc5 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc5 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc4 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc3 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))))) ((6) (let ((e-27 (vector-ref arg-10 3))) (let ((e-28 (vector-ref arg-10 4))) (case (vector-ref arg-11 0) ((1) (let ((e-75 (vector-ref arg-11 1))) (let ((e-76 (vector-ref arg-11 2))) (let ((e-77 (vector-ref arg-11 3))) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 (cons e-75 (cons e-76 arg-4)) arg-3 arg-5 (cons e-27 (cons e-28 arg-6)) arg-7 arg-8 arg-9 e-77)))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc1 (CoreC-45NormaliseC-45Eval-n--7230-4508-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc1 1) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1)) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))
(define CoreC-45NormaliseC-45Eval-toClosure (lambda (arg-1 arg-2 arg-3) (vector 0 '() arg-1 '() arg-2 arg-3)))
(define CoreC-45NormaliseC-45Eval-takeFromStack (lambda (arg-0 arg-1 arg-3 arg-4) (CoreC-45NormaliseC-45Eval-n--7233-5046-u--takeStk arg-0 arg-1 arg-4 arg-3 arg-3 arg-4 '())))
(define CoreC-45NormaliseC-45Eval-nfOpts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (CoreC-45NormaliseC-45Eval-eval arg-3 arg-2 arg-0 arg-1 '() arg-4 '() arg-5 '())))
(define CoreC-45NormaliseC-45Eval-nf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (CoreC-45NormaliseC-45Eval-eval arg-2 (CoreC-45Value-defaultOpts) arg-0 arg-1 '() arg-3 '() arg-4 '())))
(define CoreC-45NormaliseC-45Eval-isFromTerm (lambda (arg-1) (let ((e-1 (vector-ref arg-1 0))) e-1)))
(define CoreC-45NormaliseC-45Eval-gnf (lambda (arg-0 arg-1 arg-2) (vector 1 (lambda (eta-0) (vector 1 arg-2)) (lambda (u--c) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox u--c))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-nf u--c arg-0 e-5 arg-1 arg-2) eta-0))))))))))
(define CoreC-45NormaliseC-45Eval-getTerm (lambda (arg-1) (let ((e-2 (vector-ref arg-1 1))) e-2)))
(define CoreC-45NormaliseC-45Eval-getNF (lambda (arg-1 arg-2) (let ((e-3 (vector-ref arg-2 2))) (e-3 arg-1))))
(define CoreC-45NormaliseC-45Eval-getCaseBound (lambda (arg-0 arg-1 arg-4 arg-5 arg-6) (if (null? arg-4) (if (null? arg-5) (box arg-6) '()) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? arg-5) '() (let ((e-11 (cdr arg-5))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (arg-2) (cons e-2 arg-2)) (CoreC-45NormaliseC-45Eval-getCaseBound arg-0 arg-1 e-3 e-11 arg-6)))))))))
(define CoreC-45NormaliseC-45Eval-gType (lambda (arg-1) (vector 1 (lambda (eta-0) (vector 1 (vector 11 arg-1))) (lambda (eta-0) (lambda (eta-1) (vector 1 (vector 10 arg-1)))))))
(define CoreC-45NormaliseC-45Eval-gErased (lambda (arg-1) (vector 1 (lambda (eta-0) (vector 1 (vector 10 arg-1 0))) (lambda (eta-0) (lambda (eta-1) (vector 1 (vector 9 arg-1 0)))))))
(define CoreC-45NormaliseC-45Eval-findAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (if (null? arg-11) (let ((act-24 (CoreC-45ContextC-45Log-log arg-2 "eval.casetree.stuck" (+ 1 (+ 1 0)) (lambda () "Ran out of alternatives") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 2 ))))) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-tryAlt arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((0) (let ((e-1 (vector-ref e-5 1))) (vector 1 (vector 0 e-1)))) ((1) (CoreC-45NormaliseC-45Eval-findAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3 ext-0)) (else (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-2 (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40CaseAltC-32C-36varsC-41 arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_C-40CaseAltC-32C-36varsC-41 arg-4062 arg-4063 eta-0))))) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "eval.casetree.stuck" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Got stuck matching " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-4 arg-10) (PreludeC-45TypesC-45String-C-43C-43 " against " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseAltC-32C-36varsC-41 arg-3 e-6)))))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 (vector 2 ))))))))))))))))
(define CoreC-45NormaliseC-45Eval-evalWithOpts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0 ext-1 ext-2 ext-3) (CoreC-45NormaliseC-45Eval-eval arg-3 arg-4 arg-0 arg-1 arg-2 ext-0 ext-1 ext-2 ext-3)))
(define CoreC-45NormaliseC-45Eval-evalTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((e-5 (vector-ref arg-10 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalLocal arg-0 arg-1 arg-2 arg-4 arg-5 arg-8 '() e-2 '() arg-6) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-2 "eval.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Evaluated " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-1) (PreludeC-45TypesC-45String-C-43C-43 " to " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-4 e-6))))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((u--locC-39 (CoreC-45NormaliseC-45Eval-updateLocal arg-0 arg-1 arg-7 arg-5 e-2 arg-6 e-6))) (CoreC-45NormaliseC-45Eval-findAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--locC-39 arg-7 arg-8 arg-9 e-6 e-5 eta-0)))))))))))))) ((1) (let ((e-8 (vector-ref arg-10 2))) (let ((e-5 (vector-ref arg-7 5))) (if (null? e-5) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-4 arg-3 arg-0 arg-7 arg-5 arg-6 (CoreC-45TT-embed e-8) arg-9) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-10 (vector-ref act-24 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-24 1))) (vector 1 (vector 0 e-10))))))) (let ((e-10 (unbox e-5))) (cond ((equal? e-10 0) (lambda (eta-0) (vector 1 (vector 2 ))))(else (let ((e-11 (- e-10 1))) (let ((u--optsC-39 (let ((e-19 (vector-ref arg-7 0))) (let ((e-18 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-16 (vector-ref arg-7 3))) (let ((e-15 (vector-ref arg-7 4))) (let ((e-13 (vector-ref arg-7 6))) (let ((e-12 (vector-ref arg-7 7))) (vector e-19 e-18 e-17 e-16 e-15 (box e-11) e-13 e-12)))))))))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-4 arg-3 arg-0 u--optsC-39 arg-5 arg-6 (CoreC-45TT-embed e-8) arg-9) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-12 (vector-ref act-24 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-24 1))) (vector 1 (vector 0 e-12))))))))))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))
(define CoreC-45NormaliseC-45Eval-evalRef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-7 0) ((2) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (vector 1 (vector 2 arg-6 arg-8 e-0 e-1 arg-9))))) ((3) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (vector 1 (CoreC-45Value-ntCon arg-6 arg-8 e-2 e-3 arg-9))))) ((0) (vector 1 (arg-10))) (else (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-8 (let ((e-0 (vector-ref arg-0 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--nt (vector 1 ))) (if (null? e-5) (vector 1 (arg-10)) (let ((e-1 (unbox e-5))) (let ((u--redok1 (let ((e-3 (vector-ref arg-1 3))) e-3))) (let ((u--redok2 (CoreC-45Context-reducibleInAny (cons (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-3 (vector-ref arg-0 3))) e-3)) (let ((e-23 (vector-ref e-1 1))) e-23) (let ((e-9 (vector-ref e-1 9))) e-9)))) (let ((u--redok (cond ((equal? u--redok1 1) 1) (else u--redok2)))) (let ((act-25 (CoreC-45Context-checkTimer arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (cond ((equal? u--redok2 1) (vector 1 0)) (else (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "eval.stuck" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-0) (let ((act-26 (CoreC-45Context-toFullNames arg-2 (csegen-46) arg-8 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Stuck function: " (CoreC-45Name-u--show_Show_Name e-7)))))))) ext-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (cond ((equal? u--redok 1) (let ((act-27 (CoreC-45NormaliseC-45Eval-updateLimit u--nt arg-8 arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (if (null? e-8) (let ((act-28 (CoreC-45ContextC-45Log-log arg-2 "eval.stuck" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Function " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) " past reduction limit"))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (arg-10))))) (let ((e-2 (unbox e-8))) ((CoreC-45NormaliseC-45Eval-evalDef arg-0 arg-1 arg-2 arg-3 arg-4 e-2 arg-5 arg-6 (let ((e-23 (vector-ref e-1 7))) e-23) (let ((e-17 (vector-ref e-1 17))) e-17) (let ((e-11 (vector-ref e-1 11))) e-11) arg-9 arg-10) ext-0)))))))) (else (vector 1 (arg-10))))))))))))))))))))))))
(define CoreC-45NormaliseC-45Eval-evalOp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (CoreC-45NormaliseC-45Eval-case--evalOp-5211 arg-0 arg-1 arg-4 arg-7 arg-6 arg-3 arg-5 arg-2 (CoreC-45NormaliseC-45Eval-takeFromStack arg-0 arg-1 arg-3 arg-6))))
(define CoreC-45NormaliseC-45Eval-evalMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--argsC-39 (let ((sc0 (DataC-45List-isNil arg-9))) (cond ((equal? sc0 1) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-8)) (else (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-8) arg-9)))))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalRef arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-5 (vector 1 ) (vector 8 arg-7) u--argsC-39 (lambda () (vector 1 arg-5 (vector 2 arg-6 arg-7 arg-8) arg-9)) eta-0)))))
(define CoreC-45NormaliseC-45Eval-evalLocal (lambda (arg-0 arg-1 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 arg-12) (if (null? arg-12) (let ((sc1 (let ((sc2 (let ((sc3 (let ((e-0 (vector-ref arg-1 0))) e-0))) (cond ((equal? sc3 1) 1) (else (let ((e-1 (vector-ref arg-1 1))) e-1)))))) (cond ((equal? sc2 1) 0) (else (DataC-45Maybe-fromMaybe (lambda () 1) arg-8)))))) (cond ((equal? sc1 1) (let ((sc2 (CoreC-45Env-getBinder (csegen-764) arg-5 arg-9 arg-6))) (case (vector-ref sc2 0) ((1) (let ((e-3 (vector-ref sc2 3))) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-4 arg-5 '() arg-6 '() e-3 arg-11)))(else (lambda (eta-0) (vector 1 (vector 1 arg-7 (vector 0 arg-8 arg-9) arg-11))))))) (else (lambda (eta-0) (vector 1 (vector 1 arg-7 (vector 0 arg-8 arg-9) arg-11)))))) (cond ((equal? arg-9 0) (let ((e-4 (car arg-12))) (CoreC-45NormaliseC-45Eval-evalLocClosure arg-0 arg-1 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 e-4)))(else (let ((e-0 (- arg-9 1))) (let ((e-10 (cdr arg-12))) (CoreC-45NormaliseC-45Eval-evalLocal arg-0 arg-1 arg-4 arg-5 arg-6 arg-7 arg-8 e-0 arg-11 e-10))))))))
(define CoreC-45NormaliseC-45Eval-evalLocClosure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-3 e-1 arg-0 e-2 e-4 e-3 e-5 arg-7))))))) (else (let ((e-8 (vector-ref arg-8 2))) (let ((e-9 (vector-ref arg-8 3))) (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 e-8 0 e-9 arg-7)))))))
(define CoreC-45NormaliseC-45Eval-evalDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-9 0) ((1) (let ((e-0 (vector-ref arg-9 1))) (let ((e-1 (vector-ref arg-9 2))) (let ((e-2 (vector-ref arg-9 3))) (let ((e-3 (vector-ref arg-9 4))) (let ((e-4 (vector-ref arg-9 5))) (let ((sc1 (let ((sc2 (let ((e-6 (vector-ref e-0 1))) e-6))) (cond ((equal? sc2 1) 1) (else (let ((sc3 (let ((sc4 (let ((e-12 (vector-ref arg-5 0))) e-12))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (let ((e-11 (vector-ref arg-5 1))) e-11))) (cond ((equal? sc5 1) 1) (else (let ((e-8 (vector-ref arg-5 4))) e-8))))))))) (cond ((equal? sc3 1) (let ((sc4 (cond ((equal? arg-6 1) (let ((sc6 (AlgebraC-45Semiring-isErased (csegen-475) arg-8))) (cond ((equal? sc6 1) 0) (else 1)))) (else 0)))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (cond ((equal? arg-6 1) (let ((e-12 (vector-ref arg-5 0))) e-12)) (else 0)))) (cond ((equal? sc5 1) 1) (else (let ((sc6 (let ((e-8 (vector-ref arg-5 4))) e-8))) (cond ((equal? sc6 1) (PreludeC-45Types-elem (csegen-1023) (vector 3 ) arg-10)) (else 0)))))))))) (else 1)))))))) (cond ((equal? sc1 1) (CoreC-45NormaliseC-45Eval-case--caseC-32blockC-32inC-32evalDef-5377 arg-0 arg-1 arg-3 e-1 e-3 e-4 e-2 e-0 arg-12 arg-11 arg-10 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 (CoreC-45NormaliseC-45Eval-argsFromStack arg-0 arg-1 e-1 arg-11))) (else (lambda (eta-0) (vector 1 (arg-12)))))))))))) ((4) (let ((e-5 (vector-ref arg-9 1))) (let ((e-6 (vector-ref arg-9 2))) (CoreC-45NormaliseC-45Eval-evalOp arg-0 arg-1 arg-2 e-5 arg-3 (CoreC-45Primitives-getOp e-6 arg-3) arg-11 arg-12))))(else (lambda (eta-0) (vector 1 (arg-12)))))))
(define CoreC-45NormaliseC-45Eval-evalConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((sc0 (CoreC-45NormaliseC-45Eval-getCaseBound arg-0 arg-1 arg-11 arg-10 arg-6))) (if (null? sc0) (lambda (eta-0) (vector 1 (vector 2 ))) (let ((e-1 (unbox sc0))) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-tailRecAppend arg-10 arg-3) arg-4 arg-5 e-1 arg-7 arg-8 arg-9 arg-12))))))
(define CoreC-45NormaliseC-45Eval-evalClosure (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (CoreC-45NormaliseC-45Eval-eval arg-2 e-2 arg-0 arg-1 e-1 e-4 e-3 e-5 '()))))))) (else (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (CoreC-45NormaliseC-45Eval-applyToStack arg-2 e-7 arg-0 arg-1 e-8 1 e-9 '()))))))))
(define CoreC-45NormaliseC-45Eval-evalArg (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 arg-3)))
(define CoreC-45NormaliseC-45Eval-eval (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (CoreC-45NormaliseC-45Eval-evalLocal arg-0 arg-1 arg-2 arg-3 arg-5 e-2 e-3 e-4 arg-8 arg-6))))) ((1) (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalRef arg-0 arg-1 arg-2 arg-3 arg-5 0 e-7 e-8 e-9 arg-8 (lambda () (vector 1 e-7 (vector 1 e-8 e-9) arg-8)) eta-0)))))) ((2) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Eval-evalMeta arg-0 arg-1 arg-2 arg-3 arg-5 e-11 e-12 e-13 (CoreC-45NormaliseC-45Eval-n--7221-2297-u--closeArgs arg-0 arg-1 arg-4 arg-3 e-14 e-13 e-12 e-11 arg-8 arg-6 arg-5 arg-2 e-14) arg-8)))))) ((3) (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (let ((e-19 (vector-ref arg-7 4))) (case (vector-ref e-18 0) ((0) (if (null? arg-8) (let ((u--bC-39 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (vector 0 arg-4 arg-1 arg-6 arg-5 eta-0)) e-18))) (lambda (eta-0) (vector 1 (vector 0 e-16 e-17 u--bC-39 (lambda (u--defsC-39) (lambda (u--arg) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-3 (cons e-17 arg-4) u--defsC-39 arg-1 arg-5 (cons u--arg arg-6) e-19 arg-8))))))) (let ((e-61 (car arg-8))) (let ((e-62 (cdr arg-8))) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 (cons e-17 arg-4) arg-5 (cons (Builtin-snd e-61) arg-6) e-19 e-62))))) ((1) (let ((e-56 (vector-ref e-18 1))) (let ((e-57 (vector-ref e-18 2))) (let ((e-58 (vector-ref e-18 3))) (let ((e-59 (vector-ref e-18 4))) (let ((u--b (vector 1 e-56 e-57 e-58 e-59))) (let ((sc2 (let ((sc3 (let ((sc4 (let ((e-0 (vector-ref arg-1 0))) e-0))) (cond ((equal? sc4 1) 1) (else (let ((e-1 (vector-ref arg-1 1))) e-1)))))) (cond ((equal? sc3 1) (let ((sc4 (let ((e-4 (vector-ref arg-1 4))) e-4))) (cond ((equal? sc4 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc2 1) (let ((u--bC-39 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (vector 0 arg-4 arg-1 arg-6 arg-5 eta-0)) u--b))) (lambda (eta-0) (vector 1 (vector 0 e-16 e-17 u--bC-39 (lambda (u--defsC-39) (lambda (u--arg) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-3 (cons e-17 arg-4) u--defsC-39 arg-1 arg-5 (cons u--arg arg-6) e-19 arg-8)))))))) (else (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 (cons e-17 arg-4) arg-5 (cons (vector 0 arg-4 arg-1 arg-6 arg-5 e-58) arg-6) e-19 arg-8))))))))))(else (let ((u--bC-39 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (vector 0 arg-4 arg-1 arg-6 arg-5 eta-0)) e-18))) (lambda (eta-0) (vector 1 (vector 0 e-16 e-17 u--bC-39 (lambda (u--defsC-39) (lambda (u--arg) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-3 (cons e-17 arg-4) u--defsC-39 arg-1 arg-5 (cons u--arg arg-6) e-19 arg-8)))))))))))))) ((4) (let ((e-21 (vector-ref arg-7 1))) (let ((e-22 (vector-ref arg-7 2))) (let ((e-23 (vector-ref arg-7 3))) (let ((sc1 (let ((e-7 (vector-ref arg-1 7))) e-7))) (cond ((equal? sc1 0) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-23 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-22 (cons (cons e-21 (vector 1 arg-1 arg-5 e-5)) arg-8)) eta-0))))))) (else (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-22 (cons (cons e-21 (vector 0 arg-4 arg-1 arg-6 arg-5 e-23)) arg-8))))))))) ((5) (let ((e-25 (vector-ref arg-7 1))) (let ((e-26 (vector-ref arg-7 2))) (let ((e-27 (vector-ref arg-7 3))) (let ((e-28 (vector-ref arg-7 4))) (let ((sc1 (let ((e-2 (vector-ref arg-1 2))) e-2))) (cond ((equal? sc1 1) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-28 arg-8)) (else (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27 arg-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-28 arg-8) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-25 e-26 e-5 e-6))))))))))))))))))) ((6) (let ((e-30 (vector-ref arg-7 1))) (let ((e-31 (vector-ref arg-7 2))) (let ((e-32 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-32 arg-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-30 e-31 e-5))))))))))) ((7) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (let ((e-37 (vector-ref arg-7 4))) (lambda (eta-0) (vector 1 (vector 6 e-34 e-35 (vector 0 arg-4 arg-1 arg-6 arg-5 e-36) (vector 0 arg-4 arg-1 arg-6 arg-5 e-37))))))))) ((8) (let ((e-39 (vector-ref arg-7 1))) (let ((e-40 (vector-ref arg-7 2))) (let ((e-41 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-41 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((6) (let ((e-1 (vector-ref e-5 1))) (let ((e-4 (vector-ref e-5 4))) ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 (cons (vector 1 (vector 0 "fvar")) arg-4) arg-5 (cons e-4 arg-6) (vector 0 e-1 '() 0) arg-8) eta-0))))(else (vector 1 (vector 7 e-39 e-40 e-5 arg-8))))))))))))) ((9) (let ((e-43 (vector-ref arg-7 1))) (let ((e-44 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (vector 8 e-43 e-44)))))) ((10) (let ((e-46 (vector-ref arg-7 1))) (let ((e-47 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (vector 9 e-46 e-47)))))) (else (let ((e-49 (vector-ref arg-7 1))) (lambda (eta-0) (vector 1 (vector 10 e-49))))))))
(define CoreC-45NormaliseC-45Eval-continueNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (CoreC-45NormaliseC-45Eval-applyToStack arg-2 (CoreC-45Value-defaultOpts) arg-0 arg-1 arg-3 1 arg-4 '())))
(define CoreC-45NormaliseC-45Eval-argsFromStack (lambda (arg-0 arg-1 arg-3 arg-4) (if (null? arg-3) (box (cons '() arg-4)) (let ((e-3 (cdr arg-3))) (if (null? arg-4) '() (let ((e-6 (car arg-4))) (let ((e-7 (cdr arg-4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Eval-argsFromStack arg-0 arg-1 e-3 e-7) (lambda (_-0) (let ((e-5 (car _-0))) (let ((e-4 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (cons (Builtin-snd e-6) e-5) e-4)))))))))))))
(define CoreC-45NormaliseC-45Eval-applyToStack (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((0) (lambda (clam-0) (if (null? arg-7) (vector 1 (vector 0 e-1 e-2 e-3 (lambda (u--defsC-39) (lambda (u--arg) (lambda (eta-0) (let ((act-24 (((e-4 u--defsC-39) u--arg) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 arg-7) eta-0)))))))))) (let ((e-59 (car arg-7))) (let ((e-60 (cdr arg-7))) (let ((act-24 (((e-4 arg-0) (Builtin-snd e-59)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-60) clam-0)))))))))) ((1) (let ((e-54 (vector-ref e-3 1))) (let ((e-55 (vector-ref e-3 2))) (let ((e-56 (vector-ref e-3 3))) (let ((e-57 (vector-ref e-3 4))) (let ((u--b (vector 1 e-54 e-55 e-56 e-57))) (lambda (clam-1) (let ((sc2 (let ((sc3 (let ((sc4 (let ((e-0 (vector-ref arg-1 0))) e-0))) (cond ((equal? sc4 1) 1) (else (let ((e-11 (vector-ref arg-1 1))) e-11)))))) (cond ((equal? sc3 1) (let ((sc4 (let ((e-8 (vector-ref arg-1 4))) e-8))) (cond ((equal? sc4 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc2 1) (vector 1 (vector 0 e-1 e-2 u--b (lambda (u--defsC-39) (lambda (u--arg) (lambda (eta-0) (let ((act-24 (((e-4 u--defsC-39) u--arg) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 arg-7) eta-0))))))))))) (else (let ((act-24 (((e-4 arg-0) e-56) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 arg-7) clam-1)))))))))))))))(else (lambda (eta-0) (vector 1 (vector 0 e-1 e-2 e-3 (lambda (u--defsC-39) (lambda (u--arg) (lambda (eta-1) (let ((act-24 (((e-4 u--defsC-39) u--arg) eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 arg-7) eta-1)))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (case (vector-ref e-7 0) ((1) (let ((e-62 (vector-ref e-7 1))) (let ((e-63 (vector-ref e-7 2))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalRef arg-0 arg-1 arg-2 arg-3 arg-4 0 e-6 e-62 e-63 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-7) (lambda () (vector 1 e-6 (vector 1 e-62 e-63) (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-7))) eta-0))))) ((0) (let ((e-66 (vector-ref e-7 1))) (let ((e-67 (vector-ref e-7 2))) (CoreC-45NormaliseC-45Eval-evalLocal arg-0 arg-1 arg-2 arg-3 arg-4 e-6 e-66 e-67 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-7) '())))) (else (let ((e-70 (vector-ref e-7 1))) (let ((e-71 (vector-ref e-7 2))) (let ((e-72 (vector-ref e-7 3))) (CoreC-45NormaliseC-45Eval-evalMeta arg-0 arg-1 arg-2 arg-3 arg-4 e-6 e-70 e-71 e-72 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-7))))))))))) ((2) (let ((e-10 (vector-ref arg-6 1))) (let ((e-11 (vector-ref arg-6 2))) (let ((e-12 (vector-ref arg-6 3))) (let ((e-13 (vector-ref arg-6 4))) (let ((e-14 (vector-ref arg-6 5))) (lambda (eta-0) (vector 1 (vector 2 e-10 e-11 e-12 e-13 (PreludeC-45TypesC-45List-tailRecAppend e-14 arg-7)))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (lambda (eta-0) (vector 1 (vector 3 e-16 e-17 e-18 e-19 (PreludeC-45TypesC-45List-tailRecAppend e-20 arg-7)))))))))) ((4) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (let ((sc1 (let ((e-2 (vector-ref arg-1 2))) e-2))) (cond ((equal? sc1 1) (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-25 arg-7)) (else (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-24 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-25 arg-7) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-22 e-23 e-5 e-6))))))))))))))))))) ((5) (let ((e-27 (vector-ref arg-6 1))) (let ((e-28 (vector-ref arg-6 2))) (let ((e-29 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-29 arg-7) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-27 e-28 e-5))))))))))) ((6) (lambda (eta-0) (vector 1 arg-6))) ((7) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-38 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((6) (let ((e-1 (vector-ref e-5 1))) (let ((e-4 (vector-ref e-5 4))) ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 (cons (vector 1 (vector 0 "fvar")) '()) arg-4 (cons e-4 '()) (vector 0 e-1 '() 0) arg-7) eta-0))))(else (vector 1 (vector 7 e-36 e-37 e-5 (PreludeC-45TypesC-45List-tailRecAppend e-39 arg-7))))))))))))))) ((8) (lambda (eta-0) (vector 1 arg-6))) ((9) (lambda (eta-0) (vector 1 arg-6))) (else (lambda (eta-0) (vector 1 arg-6))))))
(define CoreC-45NormaliseC-45Convert-case--getMatchingVars-3736 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (if (null? arg-9) (vector 1 '()) (let ((e-1 (unbox arg-9))) (let ((act-24 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-8 arg-1 arg-7 (CoreC-45Env-mkEnv (CoreC-45TT-getLoc arg-2) arg-1) e-1 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (vector 1 (box arg-6))) (else (vector 1 '())))))))))))
(define CoreC-45NormaliseC-45Convert-case--caseC-32blockC-32inC-32getMatchingVarAlt-3336 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (if (null? arg-13) (vector 1 '()) (let ((e-1 (unbox arg-13))) (let ((act-24 ((CoreC-45NormaliseC-45Convert-getMatchingVars arg-12 (PreludeC-45TypesC-45List-tailRecAppend arg-2 arg-0) (PreludeC-45TypesC-45List-tailRecAppend arg-6 arg-1) arg-11 e-1 arg-3 arg-7) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-2 (unbox e-5))) (vector 1 (box (DataC-45List-mapMaybe (lambda (eta-0) (CoreC-45NormaliseC-45Convert-n--7977-3114-u--dropP arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-2 arg-6 eta-0)) e-2)))))))))))))
(define CoreC-45NormaliseC-45Convert-n--7977-3111-u--weakenP (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (cons (CoreC-45TT-u--weaken_Weaken_Var e-2) (CoreC-45TT-u--weaken_Weaken_Var e-3))))))
(define CoreC-45NormaliseC-45Convert-n--7424-2261-u--weakenP (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (cons (CoreC-45TT-u--weaken_Weaken_Var e-2) (CoreC-45TT-u--weaken_Weaken_Var e-3))))))
(define CoreC-45NormaliseC-45Convert-n--7424-2259-u--tryUpdatePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 ))) ((0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 ))) ((2) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 ))) (else (let ((e-4 (vector-ref arg-7 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-4) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 bind-0)))))))))
(define CoreC-45NormaliseC-45Convert-n--7424-2260-u--tryUpdateB (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7424-2259-u--tryUpdatePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-4) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 e-1 e-2 bind-0 bind-1))))))))))) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((e-9 (vector-ref arg-7 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-8) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-9) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 e-6 e-7 bind-0 bind-1))))))))))) ((2) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7424-2259-u--tryUpdatePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-14) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 e-11 e-12 bind-0 bind-1)))))))))))(else '()))))
(define CoreC-45NormaliseC-45Convert-n--7969-2778-u--quickConvHead (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (case (vector-ref arg-6 0) ((0) 1)(else 0))) ((1) (let ((e-7 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((1) (let ((e-19 (vector-ref arg-6 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-7 e-19)))(else 0)))) ((2) (let ((e-9 (vector-ref arg-5 1))) (case (vector-ref arg-6 0) ((2) (let ((e-21 (vector-ref arg-6 1))) (CoreC-45Name-u--C-61C-61_Eq_Name e-9 e-21)))(else 0))))(else 0))))
(define CoreC-45NormaliseC-45Convert-n--7969-2779-u--quickConvArg (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) 1)(else (case (vector-ref arg-6 0) ((0) 1)(else (case (vector-ref arg-5 0) ((1) (let ((e-5 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((1) (let ((e-48 (vector-ref arg-6 2))) (CoreC-45NormaliseC-45Convert-n--7969-2778-u--quickConvHead arg-1 arg-2 arg-3 arg-4 e-5 e-48)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((2) (let ((e-10 (vector-ref arg-5 3))) (case (vector-ref arg-6 0) ((2) (let ((e-53 (vector-ref arg-6 3))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-10 e-53)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((3) (let ((e-15 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((3) (let ((e-58 (vector-ref arg-6 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-15 e-58)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((4) (let ((e-23 (vector-ref arg-5 4))) (case (vector-ref arg-6 0) ((4) (let ((e-66 (vector-ref arg-6 4))) (CoreC-45NormaliseC-45Convert-n--7969-2779-u--quickConvArg arg-1 arg-2 arg-3 arg-4 e-23 e-66)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((5) (let ((e-27 (vector-ref arg-5 3))) (case (vector-ref arg-6 0) ((5) (let ((e-70 (vector-ref arg-6 3))) (CoreC-45NormaliseC-45Convert-n--7969-2779-u--quickConvArg arg-1 arg-2 arg-3 arg-4 e-27 e-70)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((6) (case (vector-ref arg-6 0) ((6) 1)(else (case (vector-ref arg-6 0) ((9) 1)(else 0))))) ((7) (let ((e-36 (vector-ref arg-5 3))) (case (vector-ref arg-6 0) ((7) (let ((e-79 (vector-ref arg-6 3))) (CoreC-45NormaliseC-45Convert-n--7969-2779-u--quickConvArg arg-1 arg-2 arg-3 arg-4 e-36 e-79)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((8) (let ((e-40 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((8) (let ((e-83 (vector-ref arg-6 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-40 e-83)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((10) (case (vector-ref arg-6 0) ((10) 1)(else (case (vector-ref arg-6 0) ((9) 1)(else 0))))) ((9) 1)(else (case (vector-ref arg-6 0) ((9) 1)(else 0))))))))))
(define CoreC-45NormaliseC-45Convert-n--8004-4398-u--getScrutinee (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14 arg-15) (cond ((equal? arg-14 0) (if (null? arg-15) '() (let ((e-2 (car arg-15))) (box e-2))))(else (let ((e-0 (- arg-14 1))) (if (null? arg-15) '() (let ((e-6 (cdr arg-15))) (CoreC-45NormaliseC-45Convert-n--8004-4398-u--getScrutinee arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-0 e-6))))))))
(define CoreC-45NormaliseC-45Convert-n--12223-6570-u--getInfPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (case (vector-ref arg-12 0) ((1) (let ((e-2 (vector-ref arg-12 2))) (cond ((equal? arg-9 1) (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-8 0))) e-0)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-3 (unbox e-5))) (vector 1 (let ((e-6 (vector-ref e-3 6))) e-6))))))))) (else (vector 1 '())))))(else (vector 1 '()))))))
(define CoreC-45NormaliseC-45Convert-n--7998-3890-u--getArgPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (cond ((equal? arg-10 0) (let ((e-2 (car arg-11))) (PreludeC-45Types-u--pure_Applicative_Maybe e-2)))(else (let ((e-0 (- arg-10 1))) (let ((e-6 (cdr arg-11))) (CoreC-45NormaliseC-45Convert-n--7998-3890-u--getArgPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-0 e-6))))))))
(define CoreC-45NormaliseC-45Convert-n--7424-2091-u--findIdx (lambda (arg-0 arg-1 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 arg-9))) (cond ((equal? sc2 1) (box e-7)) (else (CoreC-45NormaliseC-45Convert-n--7424-2091-u--findIdx arg-0 arg-1 arg-3 arg-5 arg-6 arg-7 e-3 arg-9)))))))))))
(define CoreC-45NormaliseC-45Convert-n--8004-4397-u--findArgPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14) (case (vector-ref arg-14 0) ((0) (let ((e-2 (vector-ref arg-14 2))) (box e-2)))(else '()))))
(define CoreC-45NormaliseC-45Convert-n--7977-3112-u--extend (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-13) (if (null? arg-14) (PreludeC-45Types-u--pure_Applicative_Maybe arg-15) '()) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (if (null? arg-14) '() (let ((e-6 (car arg-14))) (let ((e-7 (cdr arg-14))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7977-3112-u--extend arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 e-7 arg-15) (lambda (u--rest) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (cons 0 0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45NormaliseC-45Convert-n--7977-3111-u--weakenP arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-2 e-6 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) (PreludeC-45TypesC-45List-tailRecAppend e-7 arg-1) eta-0)) u--rest)))))))))))))
(define CoreC-45NormaliseC-45Convert-n--7977-3113-u--dropV (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14 arg-15) (if (null? arg-14) (box arg-15) (let ((e-3 (cdr arg-14))) (cond ((equal? arg-15 0) '())(else (let ((e-8 (- arg-15 1))) (CoreC-45NormaliseC-45Convert-n--7977-3113-u--dropV arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 e-8))))))))
(define CoreC-45NormaliseC-45Convert-n--7977-3114-u--dropP (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7977-3113-u--dropV arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7977-3113-u--dropV arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14 e-3) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (cons bind-0 bind-1))))))))))
(define CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13 arg-14 arg-15) (if (null? arg-14) arg-15 (if (null? arg-15) '() (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((sc2 (PreludeC-45Types-elem (csegen-792) arg-13 arg-14))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (+ 1 arg-13) arg-14 e-3)) (else (cons e-2 (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (+ 1 arg-13) arg-14 e-3)))))))))))
(define CoreC-45NormaliseC-45Convert-n--7998-3891-u--convertMatches (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((sc2 (CoreC-45NormaliseC-45Convert-n--7998-3890-u--getArgPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 arg-2))) (if (null? sc2) (vector 1 0) (let ((e-1 (unbox sc2))) (let ((sc3 (CoreC-45NormaliseC-45Convert-n--7998-3890-u--getArgPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7 arg-1))) (if (null? sc3) (vector 1 0) (let ((e-4 (unbox sc3))) (let ((act-24 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 e-1 e-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Convert-n--7998-3891-u--convertMatches arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (cond ((equal? e-5 1) e-8) (else 0)))))))))))))))))))))))))
(define CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-5)))
(define CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-2)))
(define CoreC-45NormaliseC-45Convert-u--convert_Convert_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Term arg-0 arg-1 e-5 0 arg-2 arg-3 arg-4 arg-5 ext-0)))))))
(define CoreC-45NormaliseC-45Convert-u--convert_Convert_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 e-5 0 arg-2 arg-3 arg-4 arg-5) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-u--convert_Convert_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 e-5 0 arg-2 arg-3 arg-4 arg-5 ext-0)))))))
(define CoreC-45NormaliseC-45Convert-u--convertInf_Convert_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 e-5 1 arg-2 arg-3 arg-4 arg-5) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-u--convGen_Convert_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 arg-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-6) ext-0)))))))))))
(define CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-97 (vector-ref arg-6 1))) (let ((e-98 (vector-ref arg-6 2))) (let ((e-99 (vector-ref arg-6 3))) (let ((e-100 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((0) (let ((e-109 (vector-ref arg-7 3))) (let ((e-110 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 (CoreC-45NormaliseC-45Quote-genName arg-2 "conv" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--c (vector 0 '() (CoreC-45Value-defaultOpts) '() arg-5 (vector 1 e-97 (vector 0 ) e-5)))) (let ((act-25 ((CoreC-45NormaliseC-45Convert-convBinders arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-99 e-109) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (let ((act-26 (((e-100 arg-4) u--c) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (((e-110 arg-4) u--c) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 e-8) eta-0)))))))))) (else (vector 1 0))))))))))))))))(else (case (vector-ref e-99 0) ((0) (let ((e-102 (vector-ref e-99 1))) (let ((e-103 (vector-ref e-99 2))) (let ((e-104 (vector-ref e-99 3))) (let ((e-105 (vector-ref e-99 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-clearDefs arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45CoreC-45PiInfo-traverse (lambda (clam-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 clam-0 eta-1))) e-104 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 e-105 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 e-5 arg-5 arg-7 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 (vector 3 e-97 e-98 (vector 0 e-102 e-103 e-6 e-7) (vector 4 e-97 (CoreC-45TT-u--weaken_Weaken_Term e-8) (vector 0 e-97 '() 0)))) eta-0))))))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6) eta-0)))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-87 (vector-ref arg-7 1))) (let ((e-88 (vector-ref arg-7 2))) (let ((e-89 (vector-ref arg-7 3))) (case (vector-ref e-89 0) ((0) (let ((e-92 (vector-ref e-89 1))) (let ((e-93 (vector-ref e-89 2))) (let ((e-94 (vector-ref e-89 3))) (let ((e-95 (vector-ref e-89 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-clearDefs arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45CoreC-45PiInfo-traverse (lambda (clam-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 clam-0 eta-1))) e-94 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 e-95 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 e-5 arg-5 arg-6 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 (vector 3 e-87 e-88 (vector 0 e-92 e-93 e-6 e-7) (vector 4 e-87 (CoreC-45TT-u--weaken_Weaken_Term e-8) (vector 0 e-87 '() 0)))) eta-0))))))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-7) eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-8 (vector-ref arg-6 1))) (let ((e-9 (vector-ref arg-6 2))) (let ((e-10 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((1) (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (let ((e-51 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Convert-chkConvHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 e-50) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 ((CoreC-45NormaliseC-45Convert-n--12223-6570-u--getInfPos arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 e-9) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-0)))))) (else ((CoreC-45NormaliseC-45Convert-chkConvCaseBlock arg-0 arg-1 e-8 arg-2 arg-3 arg-4 arg-5 e-9 (CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0) e-50 (CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-0))))))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-0) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))) ((2) (let ((e-14 (vector-ref arg-6 3))) (let ((e-16 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-55 (vector-ref arg-7 3))) (let ((e-57 (vector-ref arg-7 5))) (lambda (clam-1) (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-14 e-55))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-16) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-57) clam-1)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-2) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((3) (let ((e-19 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-60 (vector-ref arg-7 2))) (let ((e-63 (vector-ref arg-7 5))) (lambda (clam-3) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-19 e-60))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-22) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-63) clam-3)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-4) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((4) (let ((e-27 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((4) (let ((e-68 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-27 e-68)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-5) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))) ((5) (let ((e-30 (vector-ref arg-6 2))) (let ((e-31 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-71 (vector-ref arg-7 2))) (let ((e-72 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45TT-compatible e-30 e-71))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-31 e-72)) (else (lambda (eta-0) (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-6) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((6) (let ((e-34 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-75 (vector-ref arg-7 2))) (let ((e-77 (vector-ref arg-7 4))) (lambda (clam-5) (let ((sc4 (CoreC-45TT-compatible e-34 e-75))) (cond ((equal? sc4 1) (let ((act-24 (cond ((equal? e-34 1) (vector 1 arg-4))(else (CoreC-45Context-clearDefs arg-4 clam-5))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 e-5 arg-5 e-36 e-77 clam-5)))))) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-7) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((7) (let ((e-39 (vector-ref arg-6 2))) (let ((e-40 (vector-ref arg-6 3))) (let ((e-41 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-80 (vector-ref arg-7 2))) (let ((e-81 (vector-ref arg-7 3))) (let ((e-82 (vector-ref arg-7 4))) (lambda (clam-7) (let ((sc4 (CoreC-45TT-compatible e-39 e-80))) (cond ((equal? sc4 1) (let ((act-24 ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-40 e-81) clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-41) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-82) clam-7)) (else (vector 1 0)))))))) (else (vector 1 0)))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-8) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))) ((8) (let ((e-44 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((8) (let ((e-85 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-44 e-85)))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-9) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-10) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-8 (vector-ref arg-6 1))) (let ((e-9 (vector-ref arg-6 2))) (let ((e-10 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((1) (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (let ((e-51 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Convert-chkConvHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 e-50) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 ((CoreC-45NormaliseC-45Convert-n--12223-6570-u--getInfPos arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 e-9) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-0)))))) (else ((CoreC-45NormaliseC-45Convert-chkConvCaseBlock arg-0 arg-1 e-8 arg-2 arg-3 arg-4 arg-5 e-9 (CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0) e-50 (CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-0))))))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-11) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))) ((2) (let ((e-14 (vector-ref arg-6 3))) (let ((e-16 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-55 (vector-ref arg-7 3))) (let ((e-57 (vector-ref arg-7 5))) (lambda (clam-12) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-14 e-55))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-16) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-57) clam-12)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-13) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((3) (let ((e-19 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-60 (vector-ref arg-7 2))) (let ((e-63 (vector-ref arg-7 5))) (lambda (clam-14) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-19 e-60))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-22) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-63) clam-14)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-15) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((4) (let ((e-27 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((4) (let ((e-68 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-27 e-68)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-16) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))) ((5) (let ((e-30 (vector-ref arg-6 2))) (let ((e-31 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-71 (vector-ref arg-7 2))) (let ((e-72 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45TT-compatible e-30 e-71))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-31 e-72)) (else (lambda (eta-0) (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-17) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((6) (let ((e-34 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-75 (vector-ref arg-7 2))) (let ((e-77 (vector-ref arg-7 4))) (lambda (clam-16) (let ((sc3 (CoreC-45TT-compatible e-34 e-75))) (cond ((equal? sc3 1) (let ((act-24 (cond ((equal? e-34 1) (vector 1 arg-4))(else (CoreC-45Context-clearDefs arg-4 clam-16))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 e-5 arg-5 e-36 e-77 clam-16)))))) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-18) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((7) (let ((e-39 (vector-ref arg-6 2))) (let ((e-40 (vector-ref arg-6 3))) (let ((e-41 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-80 (vector-ref arg-7 2))) (let ((e-81 (vector-ref arg-7 3))) (let ((e-82 (vector-ref arg-7 4))) (lambda (clam-18) (let ((sc3 (CoreC-45TT-compatible e-39 e-80))) (cond ((equal? sc3 1) (let ((act-24 ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-40 e-81) clam-18))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-41) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-82) clam-18)) (else (vector 1 0)))))))) (else (vector 1 0)))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-19) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))) ((8) (let ((e-44 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((8) (let ((e-85 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-44 e-85)))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-20) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-21) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-87 (vector-ref arg-7 1))) (let ((e-88 (vector-ref arg-7 2))) (let ((e-89 (vector-ref arg-7 3))) (case (vector-ref e-89 0) ((0) (let ((e-92 (vector-ref e-89 1))) (let ((e-93 (vector-ref e-89 2))) (let ((e-94 (vector-ref e-89 3))) (let ((e-95 (vector-ref e-89 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-clearDefs arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45CoreC-45PiInfo-traverse (lambda (clam-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 clam-0 eta-1))) e-94 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 e-95 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 e-5 arg-5 arg-6 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 (vector 3 e-87 e-88 (vector 0 e-92 e-93 e-6 e-7) (vector 4 e-87 (CoreC-45TT-u--weaken_Weaken_Term e-8) (vector 0 e-87 '() 0)))) eta-0))))))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-7) eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-8 (vector-ref arg-6 1))) (let ((e-9 (vector-ref arg-6 2))) (let ((e-10 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((1) (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (let ((e-51 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Convert-chkConvHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 e-50) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 ((CoreC-45NormaliseC-45Convert-n--12223-6570-u--getInfPos arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 e-9) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-0)))))) (else ((CoreC-45NormaliseC-45Convert-chkConvCaseBlock arg-0 arg-1 e-8 arg-2 arg-3 arg-4 arg-5 e-9 (CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0) e-50 (CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-0))))))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-22) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))) ((2) (let ((e-14 (vector-ref arg-6 3))) (let ((e-16 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-55 (vector-ref arg-7 3))) (let ((e-57 (vector-ref arg-7 5))) (lambda (clam-23) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-14 e-55))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-16) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-57) clam-23)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-24) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((3) (let ((e-19 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-60 (vector-ref arg-7 2))) (let ((e-63 (vector-ref arg-7 5))) (lambda (clam-25) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-19 e-60))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-22) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-63) clam-25)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-26) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((4) (let ((e-27 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((4) (let ((e-68 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-27 e-68)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-27) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))) ((5) (let ((e-30 (vector-ref arg-6 2))) (let ((e-31 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-71 (vector-ref arg-7 2))) (let ((e-72 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45TT-compatible e-30 e-71))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-31 e-72)) (else (lambda (eta-0) (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-28) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((6) (let ((e-34 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-75 (vector-ref arg-7 2))) (let ((e-77 (vector-ref arg-7 4))) (lambda (clam-27) (let ((sc3 (CoreC-45TT-compatible e-34 e-75))) (cond ((equal? sc3 1) (let ((act-24 (cond ((equal? e-34 1) (vector 1 arg-4))(else (CoreC-45Context-clearDefs arg-4 clam-27))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 e-5 arg-5 e-36 e-77 clam-27)))))) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-29) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((7) (let ((e-39 (vector-ref arg-6 2))) (let ((e-40 (vector-ref arg-6 3))) (let ((e-41 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-80 (vector-ref arg-7 2))) (let ((e-81 (vector-ref arg-7 3))) (let ((e-82 (vector-ref arg-7 4))) (lambda (clam-29) (let ((sc3 (CoreC-45TT-compatible e-39 e-80))) (cond ((equal? sc3 1) (let ((act-24 ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-40 e-81) clam-29))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-41) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-82) clam-29)) (else (vector 1 0)))))))) (else (vector 1 0)))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-30) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))) ((8) (let ((e-44 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((8) (let ((e-85 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-44 e-85)))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-31) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-32) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-8 (vector-ref arg-6 1))) (let ((e-9 (vector-ref arg-6 2))) (let ((e-10 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((1) (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (let ((e-51 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Convert-chkConvHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 e-50) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 ((CoreC-45NormaliseC-45Convert-n--12223-6570-u--getInfPos arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 e-9) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) (CoreC-45NormaliseC-45Convert-n--12223-6571-u--dropInf arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-0)))))) (else ((CoreC-45NormaliseC-45Convert-chkConvCaseBlock arg-0 arg-1 e-8 arg-2 arg-3 arg-4 arg-5 e-9 (CoreC-45NormaliseC-45Convert-n--12223-6572-u--args1 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0) e-50 (CoreC-45NormaliseC-45Convert-n--12223-6573-u--args2 arg-1 e-49 e-10 e-9 e-8 e-51 e-50 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-0))))))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-33) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))) ((2) (let ((e-14 (vector-ref arg-6 3))) (let ((e-16 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-55 (vector-ref arg-7 3))) (let ((e-57 (vector-ref arg-7 5))) (lambda (clam-34) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-14 e-55))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-16) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-57) clam-34)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-35) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((3) (let ((e-19 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-60 (vector-ref arg-7 2))) (let ((e-63 (vector-ref arg-7 5))) (lambda (clam-36) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-19 e-60))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-22) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-63) clam-36)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-37) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((4) (let ((e-27 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((4) (let ((e-68 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-27 e-68)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-38) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))) ((5) (let ((e-30 (vector-ref arg-6 2))) (let ((e-31 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-71 (vector-ref arg-7 2))) (let ((e-72 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45TT-compatible e-30 e-71))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-31 e-72)) (else (lambda (eta-0) (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-39) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((6) (let ((e-34 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-75 (vector-ref arg-7 2))) (let ((e-77 (vector-ref arg-7 4))) (lambda (clam-38) (let ((sc2 (CoreC-45TT-compatible e-34 e-75))) (cond ((equal? sc2 1) (let ((act-24 (cond ((equal? e-34 1) (vector 1 arg-4))(else (CoreC-45Context-clearDefs arg-4 clam-38))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 e-5 arg-5 e-36 e-77 clam-38)))))) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-40) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))) ((7) (let ((e-39 (vector-ref arg-6 2))) (let ((e-40 (vector-ref arg-6 3))) (let ((e-41 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-80 (vector-ref arg-7 2))) (let ((e-81 (vector-ref arg-7 3))) (let ((e-82 (vector-ref arg-7 4))) (lambda (clam-40) (let ((sc2 (CoreC-45TT-compatible e-39 e-80))) (cond ((equal? sc2 1) (let ((act-24 ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-40 e-81) clam-40))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-41) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-82) clam-40)) (else (vector 1 0)))))))) (else (vector 1 0)))))))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-41) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))) ((8) (let ((e-44 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((8) (let ((e-85 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-44 e-85)))))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-42) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-43) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))
(define CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 arg-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-6) ext-0)))))))))))
(define CoreC-45NormaliseC-45Convert-tryUpdate (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7424-2091-u--findIdx arg-0 arg-1 e-4 e-3 e-2 arg-2 arg-2 e-4) (lambda (_-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 e-2 e-3 _-0)))))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 e-7 e-8 e-9)))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 eta-0)) e-14) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 e-11 e-12 e-13 bind-0))))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7424-2260-u--tryUpdateB arg-0 arg-1 e-17 e-19 e-18 e-16 arg-2 e-18) (lambda (u--bC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate (cons e-17 arg-0) (cons e-17 arg-1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45NormaliseC-45Convert-n--7424-2261-u--weakenP arg-0 arg-1 e-17 e-19 e-18 e-16 arg-2 e-17 eta-0)) arg-2) e-19) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 e-16 e-17 u--bC-39 bind-0))))))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-22) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-23) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 e-21 bind-0 bind-1)))))))))) ((5) (let ((e-25 (vector-ref arg-3 1))) (let ((e-26 (vector-ref arg-3 2))) (let ((e-27 (vector-ref arg-3 3))) (let ((e-28 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-27) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-28) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 e-25 e-26 bind-0 bind-1))))))))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-32) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 e-30 e-31 bind-0)))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-36) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-37) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 e-34 e-35 bind-0 bind-1))))))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (let ((e-41 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-41) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 e-39 e-40 bind-0)))))))) ((9) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 e-43 e-44))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 10 e-46 e-47))))) (else (let ((e-49 (vector-ref arg-3 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 11 e-49)))))))
(define CoreC-45NormaliseC-45Convert-quickConv (lambda (arg-1 arg-2) (if (null? arg-1) (if (null? arg-2) 1 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? arg-2) 0 (let ((e-6 (car arg-2))) (let ((e-7 (cdr arg-2))) (let ((sc2 (CoreC-45NormaliseC-45Convert-n--7969-2779-u--quickConvArg e-2 e-3 e-6 e-7 e-2 e-6))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-quickConv e-3 e-7)) (else 0)))))))))))
(define CoreC-45NormaliseC-45Convert-getMatchingVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 4))) (case (vector-ref arg-6 0) ((0) (let ((e-14 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 4))) (CoreC-45NormaliseC-45Convert-getMatchingVarAlts arg-0 arg-1 arg-2 arg-3 (cons (cons e-2 e-14) arg-4) e-5 e-17))))(else (lambda (eta-0) (vector 1 '()))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((1) (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (lambda (eta-0) (CoreC-45NormaliseC-45Convert-case--getMatchingVars-3736 arg-1 arg-2 e-8 e-7 e-20 e-19 arg-4 arg-3 arg-0 (CoreC-45NormaliseC-45Convert-tryUpdate arg-1 arg-2 arg-4 e-8) eta-0)))))(else (lambda (eta-0) (vector 1 '()))))))) ((2) (lambda (clam-0) (case (vector-ref arg-6 0) ((2) (vector 1 (box arg-4)))(else (vector 1 '()))))) ((3) (lambda (clam-1) (case (vector-ref arg-6 0) ((3) (vector 1 (box arg-4)))(else (vector 1 '())))))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45NormaliseC-45Convert-getMatchingVarAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-5) (if (null? arg-6) (vector 1 (box arg-4)) (vector 1 '())) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? arg-6) (vector 1 '()) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (let ((act-24 ((CoreC-45NormaliseC-45Convert-getMatchingVarAlt arg-0 arg-1 arg-2 arg-3 arg-4 e-2 e-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) ((CoreC-45NormaliseC-45Convert-getMatchingVarAlts arg-0 arg-1 arg-2 arg-3 e-1 e-3 e-7) clam-0))))))))))))))))
(define CoreC-45NormaliseC-45Convert-getMatchingVarAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref arg-6 0) ((0) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-11))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Convert-case--caseC-32blockC-32inC-32getMatchingVarAlt-3336 arg-1 arg-2 e-3 e-4 e-2 e-1 e-13 e-14 e-12 e-11 arg-4 arg-3 arg-0 (CoreC-45NormaliseC-45Convert-n--7977-3112-u--extend arg-1 arg-2 e-3 e-4 e-2 e-1 e-13 e-14 e-12 e-11 arg-4 arg-3 arg-0 e-3 e-13 arg-4) eta-0))) (else (lambda (eta-0) (vector 1 '()))))))))))(else (lambda (eta-0) (vector 1 '()))))))))) ((2) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((2) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-16))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-getMatchingVars arg-0 arg-1 arg-2 arg-3 arg-4 e-7 e-17)) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 '()))))))) ((3) (let ((e-9 (vector-ref arg-5 1))) (case (vector-ref arg-6 0) ((3) (let ((e-19 (vector-ref arg-6 1))) (CoreC-45NormaliseC-45Convert-getMatchingVars arg-0 arg-1 arg-2 arg-3 arg-4 e-9 e-19)))(else (lambda (eta-0) (vector 1 '()))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45NormaliseC-45Convert-convBinders (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((2) (let ((e-2 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((2) (let ((e-12 (vector-ref arg-7 2))) (let ((e-14 (vector-ref arg-7 4))) (lambda (clam-0) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-2 e-12))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 e-14 clam-0))))))))(else (lambda (clam-1) (let ((sc1 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (CoreC-45TT-multiplicity arg-6) (CoreC-45TT-multiplicity arg-7)))) (cond ((equal? sc1 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TT-binderType arg-6) (CoreC-45TT-binderType arg-7) clam-1)))))))))) ((0) (let ((e-7 (vector-ref arg-6 2))) (let ((e-9 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((0) (let ((e-17 (vector-ref arg-7 2))) (let ((e-19 (vector-ref arg-7 4))) (lambda (clam-2) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-7 e-17))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 e-19 clam-2))))))))(else (lambda (clam-3) (let ((sc1 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (CoreC-45TT-multiplicity arg-6) (CoreC-45TT-multiplicity arg-7)))) (cond ((equal? sc1 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TT-binderType arg-6) (CoreC-45TT-binderType arg-7) clam-3))))))))))(else (lambda (clam-4) (let ((sc0 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (CoreC-45TT-multiplicity arg-6) (CoreC-45TT-multiplicity arg-7)))) (cond ((equal? sc0 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TT-binderType arg-6) (CoreC-45TT-binderType arg-7) clam-4)))))))))
(define CoreC-45NormaliseC-45Convert-chkSameDefs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 (CoreC-45Context-lookupDefExact arg-6 (let ((e-0 (vector-ref arg-4 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 2))) (let ((e-4 (vector-ref e-1 3))) (let ((act-25 (CoreC-45Context-lookupDefExact arg-7 (let ((e-0 (vector-ref arg-4 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (vector 1 0) (let ((e-9 (unbox e-8))) (case (vector-ref e-9 0) ((1) (let ((e-13 (vector-ref e-9 2))) (let ((e-12 (vector-ref e-9 3))) (let ((act-26 ((CoreC-45NormaliseC-45Convert-getMatchingVars arg-0 e-3 e-13 arg-4 '() e-4 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-15 (vector-ref act-26 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-26 1))) (if (null? e-15) (vector 1 0) (let ((e-16 (unbox e-15))) ((CoreC-45NormaliseC-45Convert-n--7998-3891-u--convertMatches arg-1 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-3 e-13 e-16) ext-0))))))))))(else (vector 1 0))))))))))))(else (vector 1 0)))))))))))
(define CoreC-45NormaliseC-45Convert-chkConvHead (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 2))) (lambda (clam-0) (case (vector-ref arg-7 0) ((0) (let ((e-15 (vector-ref arg-7 2))) (vector 1 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-3 e-15))))(else (vector 1 0)))))) ((1) (let ((e-7 (vector-ref arg-6 2))) (lambda (clam-1) (case (vector-ref arg-7 0) ((1) (let ((e-19 (vector-ref arg-7 2))) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-7 e-19))))(else (vector 1 0)))))) ((2) (let ((e-10 (vector-ref arg-6 2))) (let ((e-11 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((2) (let ((e-22 (vector-ref arg-7 2))) (let ((e-23 (vector-ref arg-7 3))) (lambda (clam-0) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-10 e-22))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-11 e-23 clam-0)) (else (vector 1 0))))))))(else (lambda (eta-0) (vector 1 0)))))))(else (lambda (eta-0) (vector 1 0))))))
(define CoreC-45NormaliseC-45Convert-chkConvCaseBlock (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (case (vector-ref arg-7 0) ((1) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (case (vector-ref arg-9 0) ((1) (let ((e-4 (vector-ref arg-9 1))) (let ((e-5 (vector-ref arg-9 2))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-5 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (case (vector-ref e-6 0) ((0) (let ((e-3 (vector-ref e-6 2))) (case (vector-ref e-3 0) ((6) (let ((act-25 (CoreC-45Context-u--full_HasNames_Name (let ((e-39 (vector-ref arg-5 0))) e-39) e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 2))) (case (vector-ref e-10 0) ((6) (let ((act-26 (CoreC-45NormaliseC-45Convert-chkSameDefs arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 e-2 e-5 arg-8 arg-10 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-14 (vector-ref act-26 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-26 1))) (cond ((equal? e-14 0) (let ((act-27 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-45 (vector-ref arg-5 0))) e-45)) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-15 (vector-ref act-27 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-27 1))) (if (null? e-15) (vector 1 0) (let ((e-16 (unbox e-15))) (let ((act-28 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-47 (vector-ref arg-5 0))) e-47)) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-17 (vector-ref act-28 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-28 1))) (if (null? e-17) (vector 1 0) (let ((e-18 (unbox e-17))) (let ((e-23 (vector-ref e-16 17))) (case (vector-ref e-23 0) ((1) (let ((e-43 (vector-ref e-23 3))) (let ((e-50 (vector-ref e-18 17))) (case (vector-ref e-50 0) ((1) (let ((e-70 (vector-ref e-50 3))) (let ((sc16 (CoreC-45NormaliseC-45Convert-n--8004-4397-u--findArgPos arg-1 e-4 e-1 e-2 e-5 arg-10 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-43))) (if (null? sc16) (vector 1 0) (let ((e-73 (unbox sc16))) (let ((sc17 (CoreC-45NormaliseC-45Convert-n--8004-4397-u--findArgPos arg-1 e-4 e-1 e-2 e-5 arg-10 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-70))) (if (null? sc17) (vector 1 0) (let ((e-74 (unbox sc17))) (let ((sc18 (CoreC-45NormaliseC-45Convert-n--8004-4398-u--getScrutinee arg-1 e-4 e-1 e-2 e-5 arg-10 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-73 arg-8))) (if (null? sc18) (vector 1 0) (let ((e-75 (unbox sc18))) (let ((sc19 (CoreC-45NormaliseC-45Convert-n--8004-4398-u--getScrutinee arg-1 e-4 e-1 e-2 e-5 arg-10 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-74 arg-10))) (if (null? sc19) (vector 1 0) (let ((e-76 (unbox sc19))) (let ((act-29 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 e-75 e-76 eta-0)) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-77 (vector-ref act-29 1))) (vector 0 e-77))) (else (vector 1 (CoreC-45FC-u--C-61C-61_Eq_FC (let ((e-99 (vector-ref e-16 0))) e-99) (let ((e-99 (vector-ref e-18 0))) e-99))))))))))))))))))))(else (vector 1 0))))))(else (vector 1 0))))))))))))))))) (else (vector 1 1))))))))(else (vector 1 0)))))(else (vector 1 0))))))))(else (vector 1 0)))))(else (vector 1 0))))))))))(else (vector 1 0))))))(else (vector 1 0))))))
(define CoreC-45NormaliseC-45Convert-allConvNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-6) (if (null? arg-7) (vector 1 1) (vector 1 0)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? arg-7) (vector 1 0) (let ((e-6 (car arg-7))) (let ((e-7 (cdr arg-7))) (let ((act-24 ((CoreC-45NormaliseC-45Convert-allConvNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-6) clam-0)) (else (vector 1 0))))))))))))))))
(define CoreC-45NormaliseC-45Convert-allConv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 eta-0)) arg-6 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 eta-0)) arg-7 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (CoreC-45NormaliseC-45Convert-quickConv e-5 e-6))) (cond ((equal? sc2 1) ((CoreC-45NormaliseC-45Convert-allConvNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-6) ext-0)) (else (vector 1 0))))))))))))))
(define CompilerC-45OptsC-45Identity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32rewriteIdentityFlag-2418 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-8) (vector 1 0) (let ((e-1 (unbox arg-8))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "compiler.identity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "\x9;new def: " (CoreC-45CompileExpr-u--show_Show_CDef e-1))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Context-unsetFlag arg-0 (vector 2 ) (vector 8 arg-3) arg-7 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-setFlag arg-0 (vector 2 ) (vector 8 arg-3) (vector 0 ) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Context-setCompiled arg-0 (vector 8 arg-3) e-1 ext-0))))))))))))))
(define CompilerC-45OptsC-45Identity-case--caseC-32blockC-32inC-32rewriteIdentityFlag-2352 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (vector 1 0) (let ((e-1 (unbox arg-6))) (case (vector-ref e-1 0) ((10) (let ((e-2 (vector-ref e-1 1))) (let ((act-24 (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-0 "compiler.identity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "found identity flag for: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-2) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;old def: " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_CDef u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_CDef u--d u--x)))) (let ((e-18 (vector-ref arg-4 18))) e-18)))))))) clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((u--flg (vector 10 e-2))) (CompilerC-45OptsC-45Identity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32rewriteIdentityFlag-2418 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 u--flg (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((e-18 (vector-ref arg-4 18))) e-18) (lambda (eta-0) (CompilerC-45OptsC-45Identity-idCDef e-2 eta-0))) clam-0)))))))(else (vector 1 0))))))))
(define CompilerC-45OptsC-45Identity-n--6757-1229-u--makeArgsC-39 (lambda (arg-1 arg-3 arg-4) (if (null? arg-3) '() (let ((e-3 (cdr arg-3))) (cons (arg-4 0) (CompilerC-45OptsC-45Identity-n--6757-1229-u--makeArgsC-39 arg-1 e-3 (lambda (eta-0) (arg-4 (CoreC-45TT-u--weaken_Weaken_Var eta-0)))))))))
(define CompilerC-45OptsC-45Identity-n--7951-2311-u--isId (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((10) 1)(else 0))))
(define CompilerC-45OptsC-45Identity-n--6801-1709-u--eqArgs (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-12) (if (null? arg-13) 1 0) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (if (null? arg-13) 0 (let ((e-6 (car arg-13))) (let ((e-7 (cdr arg-13))) (let ((sc2 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 e-2 '() '() e-6))) (cond ((equal? sc2 1) (CompilerC-45OptsC-45Identity-n--6801-1709-u--eqArgs arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3 e-7)) (else 0)))))))))))
(define CompilerC-45OptsC-45Identity-n--6801-2083-u--altEq (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-1 (car arg-10))) (let ((e-2 (cdr arg-10))) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-9 arg-8 (box e-1) e-2)))))
(define CompilerC-45OptsC-45Identity-n--6801-2047-u--altEq (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-1 (vector-ref arg-10 0))) (let ((e-4 (vector-ref arg-10 3))) (let ((e-5 (vector-ref arg-10 4))) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 (CoreC-45TT-u--weakenNs_Weaken_Var (CoreC-45TTC-45SizeOf-mkSizeOf e-4) arg-9) (box (cons e-1 (CompilerC-45OptsC-45Identity-makeArgs e-4))) arg-7 e-5))))))
(define CompilerC-45OptsC-45Identity-unsuccIdentity (lambda (arg-0 arg-1 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((6) (let ((e-1 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (cond ((equal? e-1 0) 0)(else (let ((e-5 (- e-1 1))) (cond ((equal? e-5 0) 0)(else (let ((e-6 (- e-5 1))) (cond ((equal? e-6 0) (case (vector-ref e-3 0) ((0) (if (null? e-4) 0 (let ((e-10 (car e-4))) (let ((e-11 (cdr e-4))) (if (null? e-11) 0 (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (case (vector-ref e-14 0) ((12) (let ((e-18 (vector-ref e-14 2))) (if (null? e-15) (let ((sc7 (CoreC-45TT-u--C-61C-61_Eq_Constant arg-3 e-18))) (cond ((equal? sc7 1) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-4 '() '() e-10)) (else 0))) 0)))(else 0)))))))))(else 0)))(else 0))))))))))))(else 0))))
(define CompilerC-45OptsC-45Identity-setIdentity (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExactI arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((sc4 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((e-18 (vector-ref e-7 18))) e-18) (lambda (eta-0) (CompilerC-45OptsC-45Identity-calcIdentity arg-1 eta-0))))) (if (null? sc4) (vector 1 0) (let ((e-2 (unbox sc4))) (let ((act-26 (CoreC-45Context-setFlag arg-0 (vector 2 ) (vector 8 e-8) (vector 10 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (CompilerC-45OptsC-45Identity-rewriteIdentityFlag arg-0 (vector 8 e-8) ext-0)))))))))))))))))))))
(define CompilerC-45OptsC-45Identity-rewriteIdentityFlag (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExactI arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((_-0 (box (cons e-8 e-7)))) ((CompilerC-45OptsC-45Identity-case--caseC-32blockC-32inC-32rewriteIdentityFlag-2352 arg-0 arg-1 e-5 e-8 e-7 _-0 (DataC-45List-find (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--7951-2311-u--isId arg-0 arg-1 eta-0)) (let ((e-11 (vector-ref e-7 11))) e-11))) ext-0))))))))))))))))
(define CompilerC-45OptsC-45Identity-maybeVarEq (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (let ((e-2 (unbox arg-6))) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 arg-4 arg-5 e-2)))))
(define CompilerC-45OptsC-45Identity-makeArgs (lambda (arg-1) (CompilerC-45OptsC-45Identity-n--6757-1229-u--makeArgsC-39 arg-1 arg-1 (lambda (eta-0) eta-0))))
(define CompilerC-45OptsC-45Identity-isUnsucc (lambda (arg-0 arg-1 arg-4 arg-5) (case (vector-ref arg-5 0) ((6) (let ((e-5 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (cond ((equal? e-5 0) '())(else (let ((e-9 (- e-5 1))) (cond ((equal? e-9 0) '())(else (let ((e-10 (- e-9 1))) (cond ((equal? e-10 0) (case (vector-ref e-7 0) ((1) (if (null? e-8) '() (let ((e-14 (car e-8))) (let ((e-15 (cdr e-8))) (case (vector-ref e-14 0) ((0) (let ((e-18 (vector-ref e-14 1))) (if (null? e-15) '() (let ((e-23 (car e-15))) (let ((e-24 (cdr e-15))) (case (vector-ref e-23 0) ((12) (let ((e-27 (vector-ref e-23 2))) (if (null? e-24) (let ((sc8 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-4 e-18))) (cond ((equal? sc8 1) (box (cons e-27 0))) (else '()))) '())))(else '())))))))(else '()))))))(else '())))(else '()))))))))))))(else '()))))
(define CompilerC-45OptsC-45Identity-idCDef (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 0 e-0 eta-0)) (CompilerC-45OptsC-45Identity-getArg (CoreC-45CompileExpr-getFC e-1) arg-0 e-0)))))(else (box arg-1)))))
(define CompilerC-45OptsC-45Identity-getArg (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (cond ((equal? arg-1 0) (box (vector 0 0 arg-0)))(else (let ((e-0 (- arg-1 1))) (let ((e-6 (cdr arg-2))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (CoreC-45CompileExpr-u--weaken_Weaken_CExp eta-0)) (CompilerC-45OptsC-45Identity-getArg arg-0 e-0 e-6)))))))))
(define CompilerC-45OptsC-45Identity-checkIdentity (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CompilerC-45OptsC-45Identity-cexpIdentity arg-1 arg-4 e-2 '() '() arg-3))) (cond ((equal? sc1 1) (box arg-4)) (else (CompilerC-45OptsC-45Identity-checkIdentity arg-1 e-3 arg-3 (+ 1 arg-4))))))))))
(define CompilerC-45OptsC-45Identity-cexpIdentity (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-98 (vector-ref arg-6 1))) (PreludeC-45Types-u--C-61C-61_Eq_Nat e-98 arg-3)))(else (case (vector-ref arg-6 0) ((1) 0) ((2) 0) ((3) (let ((e-83 (vector-ref arg-6 4))) (let ((e-84 (vector-ref arg-6 5))) (let ((sc1 (let ((sc2 (CompilerC-45OptsC-45Identity-isUnsucc arg-0 arg-1 arg-3 e-83))) (if (null? sc2) 0 (let ((e-1 (unbox sc2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (CompilerC-45OptsC-45Identity-unsuccIdentity arg-0 arg-1 e-5 e-6 e-84)))))))) (cond ((equal? sc1 1) 1) (else (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 (CoreC-45TT-u--weaken_Weaken_Var arg-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-2 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45TT-u--weaken_Weaken_Var eta-1)) e-3))))) arg-4) arg-5 e-84))))))) ((4) (let ((e-87 (vector-ref arg-6 2))) (let ((e-88 (vector-ref arg-6 3))) (case (vector-ref e-87 0) ((1) (let ((e-91 (vector-ref e-87 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-91))) (cond ((equal? sc2 1) ((let ((sc3 (PreludeC-45Types-getAt arg-1 e-88))) (if (null? sc3) (lambda () 0) (let ((e-1 (unbox sc3))) (lambda () (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 arg-4 arg-5 e-1))))))) (else 0)))))(else 0)))))(else (if (null? arg-4) (case (vector-ref arg-6 0) ((5) 0)(else (case (vector-ref arg-6 0) ((6) (let ((e-15 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 3))) (let ((e-18 (vector-ref arg-6 4))) (cond ((equal? e-15 0) 0)(else (let ((e-41 (- e-15 1))) (cond ((equal? e-41 0) 0)(else (let ((e-42 (- e-41 1))) (cond ((equal? e-42 0) (case (vector-ref e-17 0) ((0) (if (null? e-18) 0 (let ((e-46 (car e-18))) (let ((e-47 (cdr e-18))) (if (null? e-47) 0 (let ((e-50 (car e-47))) (let ((e-51 (cdr e-47))) (if (null? e-51) (case (vector-ref e-50 0) ((12) (let ((e-2 (vector-ref e-50 2))) (case (vector-ref e-46 0) ((4) (let ((e-4 (vector-ref e-46 2))) (let ((e-3 (vector-ref e-46 3))) (case (vector-ref e-4 0) ((1) (let ((e-6 (vector-ref e-4 2))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-6))) (cond ((equal? sc10 1) ((let ((sc11 (PreludeC-45Types-getAt arg-1 e-3))) (if (null? sc11) (lambda () 0) (let ((e-8 (unbox sc11))) (case (vector-ref e-8 0) ((6) (let ((e-12 (vector-ref e-8 1))) (let ((e-10 (vector-ref e-8 3))) (let ((e-9 (vector-ref e-8 4))) (cond ((equal? e-12 0) (lambda () 0))(else (let ((e-13 (- e-12 1))) (cond ((equal? e-13 0) (lambda () 0))(else (let ((e-14 (- e-13 1))) (cond ((equal? e-14 0) (case (vector-ref e-10 0) ((1) (if (null? e-9) (lambda () 0) (let ((e-21 (car e-9))) (let ((e-20 (cdr e-9))) (if (null? e-20) (lambda () 0) (let ((e-23 (car e-20))) (let ((e-22 (cdr e-20))) (case (vector-ref e-23 0) ((12) (let ((e-24 (vector-ref e-23 2))) (if (null? e-22) (lambda () (let ((sc19 (CoreC-45TT-u--C-61C-61_Eq_Constant e-2 e-24))) (cond ((equal? sc19 1) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-21)) (else 0)))) (lambda () 0))))(else (lambda () 0))))))))))(else (lambda () 0))))(else (lambda () 0)))))))))))))(else (lambda () 0)))))))) (else 0)))))(else 0)))))(else 0))))(else 0)) 0))))))))(else 0)))(else 0)))))))))))) ((7) 0) ((8) 0) ((9) 0) ((10) (let ((e-32 (vector-ref arg-6 1))) (let ((e-33 (vector-ref arg-6 2))) (let ((e-34 (vector-ref arg-6 3))) (let ((e-35 (vector-ref arg-6 4))) (let ((sc2 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-33))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--6801-2047-u--altEq arg-0 arg-1 e-32 e-35 e-34 e-33 arg-5 arg-4 arg-3 eta-0)) e-34))) (cond ((equal? sc3 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-35)) (else 0)))) (else 0)))))))) ((11) (let ((e-37 (vector-ref arg-6 1))) (let ((e-38 (vector-ref arg-6 2))) (let ((e-39 (vector-ref arg-6 3))) (let ((e-40 (vector-ref arg-6 4))) (let ((sc2 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-38))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--6801-2083-u--altEq arg-0 arg-1 e-40 e-39 e-38 e-37 arg-5 arg-4 arg-3 eta-0)) e-39))) (cond ((equal? sc3 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-40)) (else 0)))) (else 0))))))))(else (if (null? arg-5) (case (vector-ref arg-6 0) ((12) 0)(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))) (let ((e-6 (unbox arg-5))) (case (vector-ref arg-6 0) ((12) (let ((e-10 (vector-ref arg-6 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-10)))(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))))))))) (let ((e-54 (unbox arg-4))) (if (null? e-54) (case (vector-ref arg-6 0) ((6) (let ((e-15 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 3))) (let ((e-18 (vector-ref arg-6 4))) (cond ((equal? e-15 0) 0)(else (let ((e-41 (- e-15 1))) (cond ((equal? e-41 0) 0)(else (let ((e-42 (- e-41 1))) (cond ((equal? e-42 0) (case (vector-ref e-17 0) ((0) (if (null? e-18) 0 (let ((e-46 (car e-18))) (let ((e-47 (cdr e-18))) (if (null? e-47) 0 (let ((e-50 (car e-47))) (let ((e-51 (cdr e-47))) (if (null? e-51) (case (vector-ref e-50 0) ((12) (let ((e-2 (vector-ref e-50 2))) (case (vector-ref e-46 0) ((4) (let ((e-4 (vector-ref e-46 2))) (let ((e-3 (vector-ref e-46 3))) (case (vector-ref e-4 0) ((1) (let ((e-6 (vector-ref e-4 2))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-6))) (cond ((equal? sc11 1) ((let ((sc12 (PreludeC-45Types-getAt arg-1 e-3))) (if (null? sc12) (lambda () 0) (let ((e-8 (unbox sc12))) (case (vector-ref e-8 0) ((6) (let ((e-12 (vector-ref e-8 1))) (let ((e-10 (vector-ref e-8 3))) (let ((e-9 (vector-ref e-8 4))) (cond ((equal? e-12 0) (lambda () 0))(else (let ((e-13 (- e-12 1))) (cond ((equal? e-13 0) (lambda () 0))(else (let ((e-14 (- e-13 1))) (cond ((equal? e-14 0) (case (vector-ref e-10 0) ((1) (if (null? e-9) (lambda () 0) (let ((e-21 (car e-9))) (let ((e-20 (cdr e-9))) (if (null? e-20) (lambda () 0) (let ((e-23 (car e-20))) (let ((e-22 (cdr e-20))) (case (vector-ref e-23 0) ((12) (let ((e-24 (vector-ref e-23 2))) (if (null? e-22) (lambda () (let ((sc20 (CoreC-45TT-u--C-61C-61_Eq_Constant e-2 e-24))) (cond ((equal? sc20 1) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-21)) (else 0)))) (lambda () 0))))(else (lambda () 0))))))))))(else (lambda () 0))))(else (lambda () 0)))))))))))))(else (lambda () 0)))))))) (else 0)))))(else 0)))))(else 0))))(else 0)) 0))))))))(else 0)))(else 0)))))))))))) ((7) 0) ((8) 0) ((9) 0) ((10) (let ((e-32 (vector-ref arg-6 1))) (let ((e-33 (vector-ref arg-6 2))) (let ((e-34 (vector-ref arg-6 3))) (let ((e-35 (vector-ref arg-6 4))) (let ((sc3 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-33))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--6801-2047-u--altEq arg-0 arg-1 e-32 e-35 e-34 e-33 arg-5 arg-4 arg-3 eta-0)) e-34))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-35)) (else 0)))) (else 0)))))))) ((11) (let ((e-37 (vector-ref arg-6 1))) (let ((e-38 (vector-ref arg-6 2))) (let ((e-39 (vector-ref arg-6 3))) (let ((e-40 (vector-ref arg-6 4))) (let ((sc3 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-38))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--6801-2083-u--altEq arg-0 arg-1 e-40 e-39 e-38 e-37 arg-5 arg-4 arg-3 eta-0)) e-39))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-40)) (else 0)))) (else 0))))))))(else (if (null? arg-5) (case (vector-ref arg-6 0) ((12) 0)(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))) (let ((e-6 (unbox arg-5))) (case (vector-ref arg-6 0) ((12) (let ((e-10 (vector-ref arg-6 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-10)))(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))))))) (let ((e-58 (car e-54))) (let ((e-59 (cdr e-54))) (case (vector-ref arg-6 0) ((5) (let ((e-61 (vector-ref arg-6 1))) (let ((e-62 (vector-ref arg-6 2))) (let ((e-63 (vector-ref arg-6 3))) (let ((e-64 (vector-ref arg-6 4))) (let ((e-65 (vector-ref arg-6 5))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-58 e-62))) (cond ((equal? sc3 1) (CompilerC-45OptsC-45Identity-n--6801-1709-u--eqArgs arg-0 arg-1 e-61 e-63 e-64 e-58 e-59 e-65 e-62 arg-5 arg-3 e-59 e-65)) (else 0)))))))))(else (case (vector-ref arg-6 0) ((6) (let ((e-15 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 3))) (let ((e-18 (vector-ref arg-6 4))) (cond ((equal? e-15 0) 0)(else (let ((e-41 (- e-15 1))) (cond ((equal? e-41 0) 0)(else (let ((e-42 (- e-41 1))) (cond ((equal? e-42 0) (case (vector-ref e-17 0) ((0) (if (null? e-18) 0 (let ((e-46 (car e-18))) (let ((e-47 (cdr e-18))) (if (null? e-47) 0 (let ((e-50 (car e-47))) (let ((e-51 (cdr e-47))) (if (null? e-51) (case (vector-ref e-50 0) ((12) (let ((e-2 (vector-ref e-50 2))) (case (vector-ref e-46 0) ((4) (let ((e-4 (vector-ref e-46 2))) (let ((e-3 (vector-ref e-46 3))) (case (vector-ref e-4 0) ((1) (let ((e-6 (vector-ref e-4 2))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-6))) (cond ((equal? sc11 1) ((let ((sc12 (PreludeC-45Types-getAt arg-1 e-3))) (if (null? sc12) (lambda () 0) (let ((e-8 (unbox sc12))) (case (vector-ref e-8 0) ((6) (let ((e-12 (vector-ref e-8 1))) (let ((e-10 (vector-ref e-8 3))) (let ((e-9 (vector-ref e-8 4))) (cond ((equal? e-12 0) (lambda () 0))(else (let ((e-13 (- e-12 1))) (cond ((equal? e-13 0) (lambda () 0))(else (let ((e-14 (- e-13 1))) (cond ((equal? e-14 0) (case (vector-ref e-10 0) ((1) (if (null? e-9) (lambda () 0) (let ((e-21 (car e-9))) (let ((e-20 (cdr e-9))) (if (null? e-20) (lambda () 0) (let ((e-23 (car e-20))) (let ((e-22 (cdr e-20))) (case (vector-ref e-23 0) ((12) (let ((e-24 (vector-ref e-23 2))) (if (null? e-22) (lambda () (let ((sc20 (CoreC-45TT-u--C-61C-61_Eq_Constant e-2 e-24))) (cond ((equal? sc20 1) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-21)) (else 0)))) (lambda () 0))))(else (lambda () 0))))))))))(else (lambda () 0))))(else (lambda () 0)))))))))))))(else (lambda () 0)))))))) (else 0)))))(else 0)))))(else 0))))(else 0)) 0))))))))(else 0)))(else 0)))))))))))) ((7) 0) ((8) 0) ((9) 0) ((10) (let ((e-32 (vector-ref arg-6 1))) (let ((e-33 (vector-ref arg-6 2))) (let ((e-34 (vector-ref arg-6 3))) (let ((e-35 (vector-ref arg-6 4))) (let ((sc3 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-33))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--6801-2047-u--altEq arg-0 arg-1 e-32 e-35 e-34 e-33 arg-5 arg-4 arg-3 eta-0)) e-34))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-35)) (else 0)))) (else 0)))))))) ((11) (let ((e-37 (vector-ref arg-6 1))) (let ((e-38 (vector-ref arg-6 2))) (let ((e-39 (vector-ref arg-6 3))) (let ((e-40 (vector-ref arg-6 4))) (let ((sc3 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-38))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--6801-2083-u--altEq arg-0 arg-1 e-40 e-39 e-38 e-37 arg-5 arg-4 arg-3 eta-0)) e-39))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-40)) (else 0)))) (else 0))))))))(else (if (null? arg-5) (case (vector-ref arg-6 0) ((12) 0)(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))) (let ((e-6 (unbox arg-5))) (case (vector-ref arg-6 0) ((12) (let ((e-10 (vector-ref arg-6 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-10)))(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))))))))))))))))))))
(define CompilerC-45OptsC-45Identity-calcIdentity (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (CompilerC-45OptsC-45Identity-checkIdentity arg-0 (CompilerC-45OptsC-45Identity-makeArgs e-0) e-1 0))))(else '()))))
(define CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32constantFold-2748 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (if (null? arg-7) (vector 1 0) (let ((e-1 (unbox arg-7))) (let ((act-24 (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-0 "compiler.const-fold" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "constant folding " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;old def: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_CDef arg-6) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;new def: " (CoreC-45CompileExpr-u--show_Show_CDef e-1))))))) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Context-setCompiled arg-0 (vector 8 arg-3) e-1 ext-0))))))))
(define CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32constantFold-2729 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox arg-6))) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32constantFold-2748 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-1 (CompilerC-45OptsC-45ConstantFold-constFoldCDef e-1) eta-0))))))
(define CompilerC-45OptsC-45ConstantFold-case--lookupC-44go-1678 (lambda (arg-3 arg-5 arg-6 arg-8 arg-12 arg-13 arg-15) (cond ((equal? arg-13 0) (if (null? arg-15) (CompilerC-45OptsC-45ConstantFold-n--7398-1610-u--go arg-3 arg-5 arg-6 arg-8 arg-12) (let ((e-3 (unbox arg-15))) (cond ((equal? arg-8 0) (vector 0 0))(else (let ((e-0 (- arg-8 1))) (let ((sc3 (CompilerC-45OptsC-45ConstantFold-n--7398-1610-u--go arg-3 arg-5 arg-6 e-0 (vector 2 e-3 arg-12)))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (CoreC-45TTC-45Var-later e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 1 (CompilerC-45OptsC-45ConstantFold-u--weaken_Weaken_WkCExp e-5))))))))))))(else (let ((e-3 (unbox arg-15))) (cond ((equal? arg-8 0) (vector 0 0))(else (let ((e-0 (- arg-8 1))) (let ((sc1 (CompilerC-45OptsC-45ConstantFold-n--7398-1610-u--go arg-3 arg-5 arg-6 e-0 (vector 2 e-3 arg-12)))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (vector 0 (CoreC-45TTC-45Var-later e-2)))) (else (let ((e-5 (vector-ref sc1 1))) (vector 1 (CompilerC-45OptsC-45ConstantFold-u--weaken_Weaken_WkCExp e-5))))))))))))))
(define CompilerC-45OptsC-45ConstantFold-n--7770-2156-u--toNF (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((12) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (case (vector-ref e-2 0) ((0) '()) ((12) '())(else (box (vector 8 e-1 e-2)))))))(else '()))))
(define CompilerC-45OptsC-45ConstantFold-n--7040-1279-u--smaller (lambda (arg-0 arg-1 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-0 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (CoreC-45TT-u--C-60C-61_Ord_Precision e-0 e-2))) (else (let ((e-3 (vector-ref arg-4 1))) (CoreC-45TT-u--C-60_Ord_Precision e-0 (box e-3))))))) (else (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((1) (let ((e-4 (vector-ref arg-4 1))) (PreludeC-45EqOrd-u--C-60C-61_Ord_Int e-1 e-4))) (else (let ((e-5 (vector-ref arg-4 1))) (CoreC-45TT-u--C-60_Ord_Precision (box e-1) e-5)))))))))
(define CompilerC-45OptsC-45ConstantFold-n--7398-1610-u--go (lambda (arg-3 arg-5 arg-6 arg-8 arg-12) (cond ((equal? arg-8 0) (case (vector-ref arg-12 0) ((1) (let ((e-9 (vector-ref arg-12 1))) (vector 1 (cons (CoreC-45TTC-45SizeOf-zero) e-9))))(else (let ((e-3 (vector-ref arg-12 1))) (let ((e-4 (vector-ref arg-12 2))) (CompilerC-45OptsC-45ConstantFold-case--lookupC-44go-1678 arg-3 arg-5 arg-6 arg-8 e-4 e-3 (CoreC-45TT-sizedView e-3)))))))(else (let ((e-5 (- arg-8 1))) (case (vector-ref arg-12 0) ((1) (let ((e-15 (vector-ref arg-12 2))) (CompilerC-45OptsC-45ConstantFold-n--7398-1610-u--go arg-3 arg-5 arg-6 e-5 e-15)))(else (let ((e-3 (vector-ref arg-12 1))) (let ((e-4 (vector-ref arg-12 2))) (CompilerC-45OptsC-45ConstantFold-case--lookupC-44go-1678 arg-3 arg-5 arg-6 arg-8 e-4 e-3 (CoreC-45TT-sizedView e-3)))))))))))
(define CompilerC-45OptsC-45ConstantFold-n--7770-2157-u--fromNF (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((8) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (box (vector 12 e-1 e-2)))))(else '()))))
(define CompilerC-45OptsC-45ConstantFold-n--7770-2526-u--foldAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (cons e-1 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-6 e-2))))))
(define CompilerC-45OptsC-45ConstantFold-n--7770-2491-u--foldAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (vector e-1 e-2 e-3 e-4 (CompilerC-45OptsC-45ConstantFold-constFold (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-1) (CompilerC-45OptsC-45ConstantFold-wk (CoreC-45TTC-45SizeOf-mkSizeOf e-4) arg-6) e-5)))))))))
(define CompilerC-45OptsC-45ConstantFold-n--7770-2159-u--constRight (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (cond ((equal? arg-7 0) (vector 6 arg-7 arg-8 arg-9 arg-10))(else (let ((e-0 (- arg-7 1))) (cond ((equal? e-0 0) (vector 6 arg-7 arg-8 arg-9 arg-10))(else (let ((e-1 (- e-0 1))) (cond ((equal? e-1 0) (case (vector-ref arg-9 0) ((0) (let ((e-2 (vector-ref arg-9 1))) (if (null? arg-10) (vector 6 arg-7 arg-8 arg-9 arg-10) (let ((e-6 (car arg-10))) (let ((e-7 (cdr arg-10))) (case (vector-ref e-6 0) ((12) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (if (null? e-7) (vector 6 arg-7 arg-8 arg-9 arg-10) (let ((e-13 (car e-7))) (let ((e-14 (cdr e-7))) (if (null? e-14) (let ((u--x (vector 12 e-9 e-10))) (let ((sc6 (CompilerC-45OptsC-45ConstantFold-n--7770-2158-u--commutative arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2))) (cond ((equal? sc6 1) (vector 6 (+ 1 (+ 1 0)) arg-8 (vector 0 e-2) (cons e-13 (cons u--x '())))) (else (vector 6 (+ 1 (+ 1 0)) arg-8 (vector 0 e-2) (cons u--x (cons e-13 '()))))))) (vector 6 arg-7 arg-8 arg-9 arg-10))))))))(else (vector 6 arg-7 arg-8 arg-9 arg-10)))))))) ((2) (let ((e-3 (vector-ref arg-9 1))) (if (null? arg-10) (vector 6 arg-7 arg-8 arg-9 arg-10) (let ((e-18 (car arg-10))) (let ((e-19 (cdr arg-10))) (case (vector-ref e-18 0) ((12) (let ((e-21 (vector-ref e-18 1))) (let ((e-22 (vector-ref e-18 2))) (if (null? e-19) (vector 6 arg-7 arg-8 arg-9 arg-10) (let ((e-25 (car e-19))) (let ((e-26 (cdr e-19))) (if (null? e-26) (let ((u--x (vector 12 e-21 e-22))) (let ((sc6 (CompilerC-45OptsC-45ConstantFold-n--7770-2158-u--commutative arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))) (cond ((equal? sc6 1) (vector 6 (+ 1 (+ 1 0)) arg-8 (vector 2 e-3) (cons e-25 (cons u--x '())))) (else (vector 6 (+ 1 (+ 1 0)) arg-8 (vector 2 e-3) (cons u--x (cons e-25 '()))))))) (vector 6 arg-7 arg-8 arg-9 arg-10))))))))(else (vector 6 arg-7 arg-8 arg-9 arg-10))))))))(else (vector 6 arg-7 arg-8 arg-9 arg-10))))(else (vector 6 arg-7 arg-8 arg-9 arg-10)))))))))))
(define CompilerC-45OptsC-45ConstantFold-n--7770-2158-u--commutative (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((26) 0)(else 1))))
(define CompilerC-45OptsC-45ConstantFold-u--weaken_Weaken_WkCExp (lambda (arg-2) (let ((e-3 (car arg-2))) (let ((e-5 (cdr arg-2))) (cons (CoreC-45TTC-45SizeOf-suc e-3) e-5)))))
(define CompilerC-45OptsC-45ConstantFold-wk (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) (vector 2 (CoreC-45TTC-45SizeOf-C-43 arg-3 e-3) e-4))))(else (vector 2 arg-3 arg-4)))))
(define CompilerC-45OptsC-45ConstantFold-lookup (lambda (arg-2 arg-3 arg-4) (let ((sc0 (CompilerC-45OptsC-45ConstantFold-n--7398-1610-u--go arg-3 arg-4 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2 arg-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-13 (car e-5))) (let ((e-15 (cdr e-5))) (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp e-13 e-15)))))))))
(define CompilerC-45OptsC-45ConstantFold-initSubst (lambda (arg-0) (vector 2 (CoreC-45TTC-45SizeOf-mkSizeOf arg-0) (vector 0 ))))
(define CompilerC-45OptsC-45ConstantFold-foldableOp (lambda (arg-1) (case (vector-ref arg-1 0) ((37) 0) ((36) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (DataC-45Maybe-fromMaybe (lambda () 0) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--pure_Applicative_Maybe (lambda (eta-0) (lambda (eta-1) (CompilerC-45OptsC-45ConstantFold-n--7040-1279-u--smaller e-1 e-0 eta-0 eta-1)))) (CoreC-45TT-intKind e-0)) (CoreC-45TT-intKind e-1))))))(else 1))))
(define CompilerC-45OptsC-45ConstantFold-findConstAlt (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant arg-1 e-5))) (cond ((equal? sc2 1) (box e-6)) (else (CompilerC-45OptsC-45ConstantFold-findConstAlt arg-1 e-3 arg-3)))))))))))
(define CompilerC-45OptsC-45ConstantFold-constantFold (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExactI arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((_-0 (box (cons e-8 e-7)))) ((CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32constantFold-2729 arg-0 arg-1 e-5 e-8 e-7 _-0 (let ((e-18 (vector-ref e-7 18))) e-18)) ext-0))))))))))))))))
(define CompilerC-45OptsC-45ConstantFold-constFoldCDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (box (vector 0 e-0 (CompilerC-45OptsC-45ConstantFold-constFold e-0 (CompilerC-45OptsC-45ConstantFold-initSubst e-0) e-1))))))(else '()))))
(define CompilerC-45OptsC-45ConstantFold-constFold (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (CompilerC-45OptsC-45ConstantFold-lookup e-3 e-2 arg-2)))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (vector 2 e-9 e-10 (CompilerC-45OptsC-45ConstantFold-constFold (PreludeC-45TypesC-45List-tailRecAppend (cons e-10 '()) arg-1) (CompilerC-45OptsC-45ConstantFold-wk (CoreC-45TTC-45SizeOf-mkSizeOf (cons e-10 '())) arg-2) e-11)))))) ((3) (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (let ((e-17 (vector-ref arg-3 5))) (let ((u--val (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-16))) (case (vector-ref u--val 0) ((12) (let ((e-1 (vector-ref u--val 1))) (let ((e-2 (vector-ref u--val 2))) (let ((val-0 (vector 12 e-1 e-2))) (cond ((equal? e-15 1) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 (vector 1 val-0 arg-2) e-17)) (else (vector 3 e-13 e-14 e-15 val-0 (CompilerC-45OptsC-45ConstantFold-constFold (PreludeC-45TypesC-45List-tailRecAppend (cons e-14 '()) arg-1) (CompilerC-45OptsC-45ConstantFold-wk (CoreC-45TTC-45SizeOf-mkSizeOf (cons e-14 '())) arg-2) e-17))))))))(else (vector 3 e-13 e-14 e-15 u--val (CompilerC-45OptsC-45ConstantFold-constFold (PreludeC-45TypesC-45List-tailRecAppend (cons e-14 '()) arg-1) (CompilerC-45OptsC-45ConstantFold-wk (CoreC-45TTC-45SizeOf-mkSizeOf (cons e-14 '())) arg-2) e-17))))))))))) ((4) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (vector 4 e-19 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-20) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (let ((e-32 (vector-ref arg-3 4))) (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--7770-2159-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda () (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (csegen-271) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--7770-2156-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--7770-2157-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf))))))))))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (vector 7 e-34 e-35 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-3 1))) (let ((e-39 (vector-ref arg-3 2))) (let ((e-40 (vector-ref arg-3 3))) (vector 8 e-38 e-39 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-40)))))) ((9) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 9 e-42 e-43 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-44)))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (let ((e-49 (vector-ref arg-3 4))) (vector 10 e-46 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-47) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--7770-2491-u--foldAlt arg-1 e-49 e-48 e-47 e-46 arg-2 eta-0)) e-48) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-3 1))) (let ((e-52 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 3))) (let ((e-54 (vector-ref arg-3 4))) (let ((u--scC-39 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-52))) (case (vector-ref u--scC-39 0) ((12) (let ((e-2 (vector-ref u--scC-39 2))) (let ((sc2 (CompilerC-45OptsC-45ConstantFold-findConstAlt e-2 e-53 e-54))) (if (null? sc2) (vector 11 e-51 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-52) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--7770-2526-u--foldAlt arg-1 e-54 e-53 e-52 e-51 arg-2 eta-0)) e-53) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-54)) (let ((e-3 (unbox sc2))) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-3))))))(else (vector 11 e-51 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-52) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--7770-2526-u--foldAlt arg-1 e-54 e-53 e-52 e-51 arg-2 eta-0)) e-53) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-54)))))))))) ((12) (let ((e-56 (vector-ref arg-3 1))) (let ((e-57 (vector-ref arg-3 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-3 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-3 1))) (let ((e-62 (vector-ref arg-3 2))) (vector 14 e-61 e-62)))))))
(define CompilerC-45CaseOpts-n--8544-2863-u--updateAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (cons e-1 (vector 11 arg-5 e-2 arg-2 arg-1))))))
(define CompilerC-45CaseOpts-n--8497-2823-u--updateAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-1 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 3))) (let ((e-5 (vector-ref arg-6 4))) (vector e-1 e-2 e-3 e-4 (vector 10 arg-5 e-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CompileExpr-u--weakenNs_Weaken_CConAlt (CoreC-45TTC-45SizeOf-mkSizeOf e-4) eta-0)) arg-2) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp (CoreC-45TTC-45SizeOf-mkSizeOf e-4) eta-0)) arg-1))))))))))
(define CompilerC-45CaseOpts-n--8750-3046-u--go (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) arg-3)(else (let ((e-0 (- arg-2 1))) (PreludeC-45Types-maybe (lambda () arg-3) (lambda () (lambda (eta-0) (CompilerC-45CaseOpts-n--8750-3046-u--go arg-1 e-0 eta-0))) (CompilerC-45CaseOpts-tryCaseOfCase arg-3)))))))
(define CompilerC-45CaseOpts-n--8385-2725-u--doCaseLam (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45Core-newRef (vector "Compiler.CaseOpts.NextName" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45CaseOpts-caseLam e-5 e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-0 e-6)))))))))))))(else (vector 1 arg-2)))))
(define CompilerC-45CaseOpts-n--7784-2379-u--defLam (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (let ((e-2 (unbox arg-6))) (case (vector-ref e-2 0) ((2) 1)(else 0))))))
(define CompilerC-45CaseOpts-n--7784-2173-u--defLam (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (let ((e-2 (unbox arg-6))) (case (vector-ref e-2 0) ((2) 1)(else 0))))))
(define CompilerC-45CaseOpts-n--8567-2972-u--constCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) 0 (let ((e-2 (cdr arg-7))) (case (vector-ref e-2 0) ((12) 1)(else 0))))))
(define CompilerC-45CaseOpts-n--8567-2886-u--conCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-5 (vector-ref arg-7 4))) (case (vector-ref e-5 0) ((5) 1)(else 0)))))
(define CompilerC-45CaseOpts-n--8567-2973-u--canCaseOfCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) 1 (let ((e-3 (cdr arg-7))) (if (null? e-3) 1 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45CaseOpts-n--8567-2972-u--constCase arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0)) arg-7))))))
(define CompilerC-45CaseOpts-n--8567-2887-u--canCaseOfCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) 1 (let ((e-3 (cdr arg-7))) (if (null? e-3) 1 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CompilerC-45CaseOpts-n--8567-2886-u--conCase arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0)) arg-7))))))
(define CompilerC-45CaseOpts-tryLiftOutConst (lambda (arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-2) '() (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (case (vector-ref e-6 0) ((2) (let ((e-10 (vector-ref e-6 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CompilerC-45CaseOpts-tryLiftOutConst arg-1 e-3) (lambda (u--asC-39) (let ((u--scC-39 (CompilerC-45CaseOpts-liftOutLambda '() arg-1 e-10))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (cons e-5 u--scC-39) u--asC-39)))))))(else '()))))))))))
(define CompilerC-45CaseOpts-tryLiftOut (lambda (arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-5 (vector-ref e-2 0))) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-8 (vector-ref e-2 3))) (let ((e-9 (vector-ref e-2 4))) (case (vector-ref e-9 0) ((2) (let ((e-13 (vector-ref e-9 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CompilerC-45CaseOpts-tryLiftOut arg-1 e-3) (lambda (u--asC-39) (let ((u--scC-39 (CompilerC-45CaseOpts-liftOutLambda e-8 arg-1 e-13))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (vector e-5 e-6 e-7 e-8 u--scC-39) u--asC-39)))))))(else '()))))))))))))
(define CompilerC-45CaseOpts-tryLiftDef (lambda (arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (unbox arg-2))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 3))) (let ((u--scC-39 (CompilerC-45CaseOpts-liftOutLambda '() arg-1 e-6))) (PreludeC-45Types-u--pure_Applicative_Maybe (box u--scC-39)))))(else '()))))))
(define CompilerC-45CaseOpts-tryCaseOfCase (lambda (arg-1) (case (vector-ref arg-1 0) ((10) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-2 0) ((10) (let ((e-11 (vector-ref e-2 1))) (let ((e-12 (vector-ref e-2 2))) (let ((e-13 (vector-ref e-2 3))) (let ((e-14 (vector-ref e-2 4))) (if (null? e-14) (let ((sc3 (CompilerC-45CaseOpts-n--8567-2887-u--canCaseOfCase e-13 e-12 e-11 e-4 e-3 e-1 e-13))) (cond ((equal? sc3 1) (box (CompilerC-45CaseOpts-doCaseOfCase e-11 e-12 e-13 e-3 e-4))) (else '()))) '()))))))(else '()))))))) ((11) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (let ((e-9 (vector-ref arg-1 4))) (case (vector-ref e-7 0) ((11) (let ((e-17 (vector-ref e-7 1))) (let ((e-18 (vector-ref e-7 2))) (let ((e-19 (vector-ref e-7 3))) (let ((e-20 (vector-ref e-7 4))) (if (null? e-20) (let ((sc3 (CompilerC-45CaseOpts-n--8567-2973-u--canCaseOfCase e-19 e-18 e-17 e-9 e-8 e-6 e-19))) (cond ((equal? sc3 1) (box (CompilerC-45CaseOpts-doCaseOfConstCase e-17 e-18 e-19 e-8 e-9))) (else '()))) '()))))))(else '())))))))(else '()))))
(define CompilerC-45CaseOpts-shiftVar (lambda (arg-3 arg-4 arg-5) (if (null? arg-3) (CompilerC-45CaseOpts-shiftUnder arg-4 arg-5) (let ((e-3 (cdr arg-3))) (cond ((equal? arg-5 0) 0)(else (let ((e-4 (- arg-5 1))) (+ 1 (CompilerC-45CaseOpts-shiftVar e-3 arg-4 e-4)))))))))
(define CompilerC-45CaseOpts-shiftUnder (lambda (arg-3 arg-4) (cond ((equal? arg-4 0) (CoreC-45TT-weakenNVar (CoreC-45TTC-45SizeOf-mkSizeOf arg-3) 0))(else (let ((e-0 (- arg-4 1))) (CoreC-45TT-insertNVar (CoreC-45TTC-45SizeOf-mkSizeOf arg-3) e-0))))))
(define CompilerC-45CaseOpts-shiftBinderConstAlt (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cons e-1 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-2))))))
(define CompilerC-45CaseOpts-shiftBinderConAlt (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((u--scC-39 e-5)) (vector e-1 e-2 e-3 e-4 (CompilerC-45CaseOpts-shiftBinder (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-2) arg-3 arg-4 u--scC-39))))))))))
(define CompilerC-45CaseOpts-shiftBinder (lambda (arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (vector 0 (CompilerC-45CaseOpts-shiftVar arg-2 arg-3 e-2) e-3)))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (vector 2 e-9 e-10 (CompilerC-45CaseOpts-shiftBinder (cons e-10 arg-2) arg-3 arg-4 e-11)))))) ((3) (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((e-15 (vector-ref arg-5 3))) (let ((e-16 (vector-ref arg-5 4))) (let ((e-17 (vector-ref arg-5 5))) (vector 3 e-13 e-14 e-15 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-16) (CompilerC-45CaseOpts-shiftBinder (cons e-14 arg-2) arg-3 arg-4 e-17)))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (vector 4 e-19 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-20) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((e-27 (vector-ref arg-5 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (let ((e-31 (vector-ref arg-5 3))) (let ((e-32 (vector-ref arg-5 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (vector 7 e-34 e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (vector 8 e-38 e-39 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-40)))))) ((9) (let ((e-42 (vector-ref arg-5 1))) (let ((e-43 (vector-ref arg-5 2))) (let ((e-44 (vector-ref arg-5 3))) (vector 9 e-42 e-43 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-44)))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (vector 10 e-46 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-47) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinderConAlt arg-2 arg-3 arg-4 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-5 1))) (let ((e-52 (vector-ref arg-5 2))) (let ((e-53 (vector-ref arg-5 3))) (let ((e-54 (vector-ref arg-5 4))) (vector 11 e-51 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-52) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinderConstAlt arg-2 arg-3 arg-4 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-5 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-5 1))) (let ((e-62 (vector-ref arg-5 2))) (vector 14 e-61 e-62)))))))
(define CompilerC-45CaseOpts-liftOutLambda (lambda (arg-2 ext-0 ext-1) (CompilerC-45CaseOpts-shiftBinder '() arg-2 ext-0 ext-1)))
(define CompilerC-45CaseOpts-getName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 "clam" e-5)))))))))))
(define CompilerC-45CaseOpts-doCaseOfConstCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (vector 11 arg-1 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CaseOpts-n--8544-2863-u--updateAlt arg-5 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-3) '())))
(define CompilerC-45CaseOpts-doCaseOfCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (vector 10 arg-1 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45CaseOpts-n--8497-2823-u--updateAlt arg-5 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-3) '())))
(define CompilerC-45CaseOpts-caseOfCase (lambda (arg-1) (CompilerC-45CaseOpts-n--8750-3046-u--go arg-1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) arg-1)))
(define CompilerC-45CaseOpts-caseLamDef (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((e-18 (vector-ref e-1 18))) (if (null? e-18) (vector 1 0) (let ((e-25 (unbox e-18))) (let ((act-26 (CompilerC-45CaseOpts-n--8385-2725-u--doCaseLam arg-1 arg-0 e-25 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-26 (vector-ref act-26 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-26 1))) (CoreC-45Context-setCompiled arg-0 arg-1 e-26 ext-0))))))))))))))))))))
(define CompilerC-45CaseOpts-caseLamConstAlt (lambda (arg-1 arg-2 ext-0) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-1 e-5)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-2) ext-0)))))
(define CompilerC-45CaseOpts-caseLamConAlt (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-6 (vector-ref eta-0 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-5) ext-0))))))))
(define CompilerC-45CaseOpts-caseLam (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((10) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((sc1 (let ((sc2 (CompilerC-45CaseOpts-allLams e-3))) (cond ((equal? sc2 1) (CompilerC-45CaseOpts-n--7784-2173-u--defLam e-4 e-3 e-2 e-1 arg-1 e-4)) (else 0))))) (cond ((equal? sc1 1) (let ((act-24 (CompilerC-45CaseOpts-getName arg-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (CompilerC-45CaseOpts-tryLiftOut e-5 e-3))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't happen caseLam 1") clam-0) (let ((e-6 (unbox sc3))) (let ((sc4 (CompilerC-45CaseOpts-tryLiftDef e-5 e-4))) (if (null? sc4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't happen caseLam 2") clam-0) (let ((e-7 (unbox sc4))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45CaseOpts-caseLamConAlt arg-1 eta-0 eta-1))) e-6 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (if (null? e-7) (vector 1 '()) (let ((e-9 (unbox e-7))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45CaseOpts-caseLam arg-1 e-9) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (vector 2 e-1 e-5 (vector 10 e-1 (CoreC-45CompileExpr-u--weaken_Weaken_CExp e-2) e-8 e-9)))))))))))))))))))))) (else (let ((act-24 ((CompilerC-45CaseOpts-caseLam arg-1 e-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45CaseOpts-caseLamConAlt arg-1 eta-0 eta-1))) e-3 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-4) (vector 1 '()) (let ((e-7 (unbox e-4))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45CaseOpts-caseLam arg-1 e-7) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 10 e-1 e-5 e-6 e-7)))))))))))))))))))))) ((11) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((sc1 (let ((sc2 (CompilerC-45CaseOpts-allLamsConst e-8))) (cond ((equal? sc2 1) (CompilerC-45CaseOpts-n--7784-2379-u--defLam e-9 e-8 e-7 e-6 arg-1 e-9)) (else 0))))) (cond ((equal? sc1 1) (let ((act-24 (CompilerC-45CaseOpts-getName arg-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (CompilerC-45CaseOpts-tryLiftOutConst e-5 e-8))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't happen caseLam 1") clam-0) (let ((e-1 (unbox sc3))) (let ((sc4 (CompilerC-45CaseOpts-tryLiftDef e-5 e-9))) (if (null? sc4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't happen caseLam 2") clam-0) (let ((e-2 (unbox sc4))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45CaseOpts-caseLamConstAlt arg-1 eta-0 eta-1))) e-1 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (if (null? e-2) (vector 1 '()) (let ((e-3 (unbox e-2))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45CaseOpts-caseLam arg-1 e-3) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (vector 2 e-6 e-5 (vector 11 e-6 (CoreC-45CompileExpr-u--weaken_Weaken_CExp e-7) e-10 e-11)))))))))))))))))))))) (else (let ((act-24 ((CompilerC-45CaseOpts-caseLam arg-1 e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45CaseOpts-caseLamConstAlt arg-1 eta-0 eta-1))) e-8 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (if (null? e-9) (vector 1 '()) (let ((e-2 (unbox e-9))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45CaseOpts-caseLam arg-1 e-2) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (vector 11 e-6 e-5 e-10 e-11)))))))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-11 e-12 e-5)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-13) clam-0))))) ((3) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((e-18 (vector-ref arg-2 4))) (let ((e-19 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 3 e-15 e-16 e-17 e-5 eta-2))))))) (CompilerC-45CaseOpts-caseLam arg-1 e-18) eta-0)) (CompilerC-45CaseOpts-caseLam arg-1 e-19) clam-0))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 4 e-21 e-5 eta-2))))))) (CompilerC-45CaseOpts-caseLam arg-1 e-22) eta-0)) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45CaseOpts-caseLam arg-1 eta-1)) e-23 '() eta-0)) clam-0))))) ((5) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (let ((e-29 (vector-ref arg-2 5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-25 e-26 e-27 e-28 e-5)))))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45CaseOpts-caseLam arg-1 eta-1)) e-29 '() eta-0)) clam-0))))))) ((6) (let ((e-31 (vector-ref arg-2 1))) (let ((e-32 (vector-ref arg-2 2))) (let ((e-33 (vector-ref arg-2 3))) (let ((e-34 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-31 e-32 e-33 e-5)))))) (lambda (eta-0) (CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45CaseOpts-caseLam arg-1 eta-1)) e-34 eta-0)) clam-0)))))) ((7) (let ((e-36 (vector-ref arg-2 1))) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-36 e-37 e-5)))))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45CaseOpts-caseLam arg-1 eta-1)) e-38 '() eta-0)) clam-0))))) ((8) (let ((e-40 (vector-ref arg-2 1))) (let ((e-41 (vector-ref arg-2 2))) (let ((e-42 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 8 e-40 e-41 e-5)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-42) clam-0))))) ((9) (let ((e-44 (vector-ref arg-2 1))) (let ((e-45 (vector-ref arg-2 2))) (let ((e-46 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 9 e-44 e-45 e-5)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-46) clam-0)))))(else (vector 1 arg-2))))))
(define CompilerC-45CaseOpts-allLamsConst (lambda (arg-1) (if (null? arg-1) 1 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-2) 0 (let ((e-6 (cdr e-2))) (case (vector-ref e-6 0) ((2) (CompilerC-45CaseOpts-allLamsConst e-3))(else 0)))))))))
(define CompilerC-45CaseOpts-allLams (lambda (arg-1) (if (null? arg-1) 1 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-9 (vector-ref e-2 4))) (case (vector-ref e-9 0) ((2) (CompilerC-45CaseOpts-allLams e-3))(else 0))))))))
(define IdrisC-45Driver-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32stMain-6418 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 ext-0) (let ((e-2 (car arg-23))) (let ((e-3 (cdr arg-23))) (let ((act-24 (let ((act-24 (IdrisC-45IDEModeC-45REPL-initIDESocketFile e-2 e-3 ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((0) (let ((e-4 (vector-ref e-5 1))) (let ((act-25 (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) e-4) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 ((csegen-1214) ext-0))) (vector 1 act-26))))))) (else (let ((e-6 (vector-ref e-5 1))) (let ((act-25 (IdrisC-45REPLC-45Opts-setOutput arg-12 (vector 0 0 e-6 e-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (IdrisC-45IDEModeC-45REPL-replIDE arg-6 arg-16 arg-7 arg-18 arg-12 ext-0)))))))))))))))
(define IdrisC-45Driver-n--13550-5575-u--renderError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((IdrisC-45Error-perror arg-2 arg-3 arg-4 arg-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Pretty-render arg-4 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 58 e-6) ext-0)))))))))))
(define IdrisC-45Driver-updateREPLOpts (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((IdrisC-45Env-idrisGetEnv (csegen-3) "EDITOR" 0) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-19 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-18 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-19 e-2 e-3 e-4 e-18 e-1 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-26))))))))))))))
(define IdrisC-45Driver-updateEnv (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((IdrisC-45Env-idrisGetEnv (csegen-3) "IDRIS2_PREFIX" 0) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-6) (CoreC-45Context-setPrefix arg-0 (IdrisPaths-yprefix) ext-0) (let ((e-1 (unbox e-6))) (CoreC-45Context-setPrefix arg-0 e-1 ext-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 ((IdrisC-45Env-idrisGetEnv (csegen-3) "IDRIS2_PATH" 0) ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (if (null? e-8) (vector 1 0) (let ((e-1 (unbox e-8))) ((CoreC-45Core-traverseList1_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addExtraDir arg-0 eta-0 eta-1))) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (DataC-45String-trim eta-0)) (DataC-45String-split (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 (LibrariesC-45UtilsC-45Path-pathSeparator))) e-1))) ext-0))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (let ((act-29 ((IdrisC-45Env-idrisGetEnv (csegen-3) "IDRIS2_DATA" 0) ext-0))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (if (null? e-10) (vector 1 0) (let ((e-1 (unbox e-10))) ((CoreC-45Core-traverseList1_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addDataDir arg-0 eta-0 eta-1))) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (DataC-45String-trim eta-0)) (DataC-45String-split (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 (LibrariesC-45UtilsC-45Path-pathSeparator))) e-1))) ext-0))))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (let ((act-31 ((IdrisC-45Env-idrisGetEnv (csegen-3) "IDRIS2_LIBS" 0) ext-0))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (if (null? e-12) (vector 1 0) (let ((e-1 (unbox e-12))) ((CoreC-45Core-traverseList1_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addLibDir arg-0 eta-0 eta-1))) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (DataC-45String-trim eta-0)) (DataC-45String-split (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 (LibrariesC-45UtilsC-45Path-pathSeparator))) e-1))) ext-0))))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (let ((act-33 ((IdrisC-45Env-idrisGetEnv (csegen-3) "IDRIS2_PACKAGE_PATH" 0) ext-0))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (if (null? e-14) (vector 1 0) (let ((e-1 (unbox e-14))) ((CoreC-45Core-traverseList1_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addPackageDir arg-0 eta-0 eta-1))) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (DataC-45String-trim eta-0)) (DataC-45String-split (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 (LibrariesC-45UtilsC-45Path-pathSeparator))) e-1))) ext-0))))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 (let ((act-35 ((IdrisC-45Env-idrisGetEnv (csegen-3) "IDRIS2_CG" 0) ext-0))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (let ((act-36 (if (null? e-16) (vector 1 0) (let ((e-1 (unbox e-16))) (let ((sc13 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) e-1))) (if (null? sc13) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Unknown code generator " (PreludeC-45Show-u--show_Show_String e-1))) ext-0) (let ((e-2 (unbox sc13))) (CoreC-45Context-setCG arg-0 e-2 ext-0)))))))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((act-37 (let ((act-37 ((IdrisC-45Env-idrisGetEnv (csegen-3) "IDRIS2_INC_CGS" 0) ext-0))) (vector 1 act-37)))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-37 1))) (let ((act-38 (if (null? e-18) (vector 1 0) (let ((e-1 (unbox e-18))) (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (IdrisC-45SetOptions-setIncrementalCG arg-0 arg-1 0 eta-0 eta-1))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (DataC-45String-trim eta-0)) (DataC-45List1-u--toList_Foldable_List1 (DataC-45String-split (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 #\,)) e-1))) ext-0))))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((act-39 (let ((act-39 (unbox arg-0))) (vector 1 act-39)))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-39 1))) (let ((act-40 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (IdrisC-45SetOptions-addPkgDir arg-0 "prelude" (IdrisC-45PackageC-45Types-anyBounds) eta-0)) (lambda (eta-0) (lambda (eta-1) (vector 1 0))) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((act-41 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (IdrisC-45SetOptions-addPkgDir arg-0 "base" (IdrisC-45PackageC-45Types-anyBounds) eta-0)) (lambda (eta-0) (lambda (eta-1) (vector 1 0))) ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-2 (vector-ref act-41 1))) (vector 0 e-2))) (else (let ((act-42 (CoreC-45Context-addDataDir arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-4 (vector-ref e-20 4))) (let ((e-58 (vector-ref e-4 0))) (let ((e-63 (vector-ref e-58 5))) e-63))) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (csegen-1224) "support")) ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-2 (vector-ref act-42 1))) (vector 0 e-2))) (else (let ((act-43 (CoreC-45Context-addLibDir arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-4 (vector-ref e-20 4))) (let ((e-59 (vector-ref e-4 0))) (let ((e-64 (vector-ref e-59 5))) e-64))) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (csegen-1224) "lib")) ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-2 (vector-ref act-43 1))) (vector 0 e-2))) (else (let ((act-44 (let ((act-44 ((csegen-878) ext-0))) (vector 1 act-44)))) (case (vector-ref act-44 0) ((0) (let ((e-2 (vector-ref act-44 1))) (vector 0 e-2))) (else (let ((e-25 (vector-ref act-44 1))) (if (null? e-25) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") ext-0) (let ((e-1 (unbox e-25))) (CoreC-45Context-addLibDir arg-0 e-1 ext-0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Driver-tryYaffle (lambda (arg-0) (if (null? arg-0) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((25) (let ((e-4 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (YaffleC-45Main-yaffleMain e-4 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (vector 1 1)))))))(else (IdrisC-45Driver-tryYaffle e-3))))))))
(define IdrisC-45Driver-tryTTM (lambda (arg-0) (if (null? arg-0) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((26) (let ((e-4 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Metadata-dumpTTM e-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (vector 1 1)))))))(else (IdrisC-45Driver-tryTTM e-3))))))))
(define IdrisC-45Driver-stMain (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((IdrisC-45Driver-tryYaffle arg-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 ((IdrisC-45Driver-tryTTM arg-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((_-0 0)) (cond ((equal? e-6 0) (let ((act-26 (CoreC-45Context-initDefs ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--updated (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--o) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (CoreC-45Options-addCG (cons e-2 (vector 8 e-2)) u--o)))) (let ((e-4 (vector-ref e-7 4))) e-4) arg-0))) (let ((act-27 (CoreC-45Core-newRef (vector "Core.Context.Ctxt" ) (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-33 (vector-ref e-7 5))) (let ((e-32 (vector-ref e-7 6))) (let ((e-31 (vector-ref e-7 7))) (let ((e-8 (vector-ref e-7 8))) (let ((e-9 (vector-ref e-7 9))) (let ((e-10 (vector-ref e-7 10))) (let ((e-11 (vector-ref e-7 11))) (let ((e-12 (vector-ref e-7 12))) (let ((e-13 (vector-ref e-7 13))) (let ((e-14 (vector-ref e-7 14))) (let ((e-15 (vector-ref e-7 15))) (let ((e-16 (vector-ref e-7 16))) (let ((e-17 (vector-ref e-7 17))) (let ((e-18 (vector-ref e-7 18))) (let ((e-19 (vector-ref e-7 19))) (let ((e-20 (vector-ref e-7 20))) (let ((e-21 (vector-ref e-7 21))) (let ((e-22 (vector-ref e-7 22))) (let ((e-23 (vector-ref e-7 23))) (let ((e-24 (vector-ref e-7 24))) (let ((e-25 (vector-ref e-7 25))) (let ((e-26 (vector-ref e-7 26))) (let ((e-27 (vector-ref e-7 27))) (let ((e-28 (vector-ref e-7 28))) (let ((e-29 (vector-ref e-7 29))) (let ((e-30 (vector-ref e-7 30))) (vector e-0 e-1 e-2 e-3 u--updated e-33 e-32 e-31 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-newRef (vector "Idris.Syntax.Syn" ) (IdrisC-45Syntax-initSyntax) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-setCG e-8 (PreludeC-45Types-maybe (lambda () (vector 0 )) (lambda () (lambda (eta-0) (vector 8 (Builtin-fst eta-0)))) (DataC-45List-headC-39 arg-0)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45InitPrimitives-addPrimitives e-8 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45Context-setWorkingDir e-8 "." ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (let ((act-32 (CoreC-45Context-getSession e-8 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((sc11 (IdrisC-45Driver-ignoreMissingIpkg arg-1))) (cond ((equal? sc11 1) (CoreC-45Context-setSession e-8 (let ((e-0 (vector-ref e-13 0))) (let ((e-1 (vector-ref e-13 1))) (let ((e-2 (vector-ref e-13 2))) (let ((e-3 (vector-ref e-13 3))) (let ((e-4 (vector-ref e-13 4))) (let ((e-32 (vector-ref e-13 5))) (let ((e-31 (vector-ref e-13 6))) (let ((e-29 (vector-ref e-13 8))) (let ((e-28 (vector-ref e-13 9))) (let ((e-27 (vector-ref e-13 10))) (let ((e-26 (vector-ref e-13 11))) (let ((e-25 (vector-ref e-13 12))) (let ((e-24 (vector-ref e-13 13))) (let ((e-14 (vector-ref e-13 14))) (let ((e-15 (vector-ref e-13 15))) (let ((e-16 (vector-ref e-13 16))) (let ((e-17 (vector-ref e-13 17))) (let ((e-18 (vector-ref e-13 18))) (let ((e-19 (vector-ref e-13 19))) (let ((e-20 (vector-ref e-13 20))) (let ((e-21 (vector-ref e-13 21))) (let ((e-22 (vector-ref e-13 22))) (let ((e-23 (vector-ref e-13 23))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 1 e-29 e-28 e-27 e-26 e-25 e-24 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) ext-0)) (else (vector 1 0)))))))))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((u--ide (IdrisC-45SetOptions-ideMode arg-1))) (let ((u--ideSocket (IdrisC-45SetOptions-ideModeSocket arg-1))) (let ((u--outmode (cond ((equal? u--ide 1) (vector 0 0 (SystemC-45FileC-45Virtual-stdin) (SystemC-45FileC-45Virtual-stdout))) (else (vector 1 2))))) (let ((u--fname (IdrisC-45Driver-findInput arg-1))) (let ((act-33 (CoreC-45Core-newRef (vector "Idris.REPL.Opts.ROpts" ) (IdrisC-45REPLC-45Opts-defaultOpts u--fname u--outmode arg-0) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (IdrisC-45Driver-updateEnv e-8 e-14 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 ((IdrisC-45Driver-showInfo e-8 e-14 arg-1) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (cond ((equal? e-16 1) (vector 1 0)) (else (let ((act-36 (IdrisC-45Package-processPackageOpts e-8 e-9 e-14 arg-1 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (cond ((equal? e-17 1) (vector 1 0)) (else ((PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45Core-u--catch_Catchable_Core_Error eta-0 eta-1 eta-2)))) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Driver-n--13550-5575-u--renderError arg-1 arg-0 e-8 e-9 e-14 eta-0 eta-1))) (lambda (eta-0) (let ((act-37 ((IdrisC-45SetOptions-preOptions e-8 e-14 arg-1) eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-37 1))) (let ((_-1 0)) (cond ((equal? e-18 1) (let ((act-38 (let ((sc19 (IdrisC-45Driver-checkVerbose arg-1))) (cond ((equal? sc19 1) (IdrisC-45REPLC-45Opts-setOutput e-14 (vector 1 2) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((act-39 (CoreC-45Core-newRef (vector "Core.UnifyState.UST" ) (CoreC-45UnifyState-initUState) eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-39 1))) (let ((act-40 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 (vector 2 0)))) (lambda () (lambda (fname-0) (lambda (eta-1) (let ((act-40 (CoreC-45Directory-ctxtPathToNS e-8 fname-0 eta-1))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-40 1))) (vector 1 (vector 0 e-21))))))))) u--fname) eta-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-40 1))) (let ((act-41 (CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata e-21) eta-0))) (case (vector-ref act-41 0) ((0) (let ((e-2 (vector-ref act-41 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-41 1))) (let ((act-42 (IdrisC-45Driver-updateREPLOpts e-14 eta-0))) (case (vector-ref act-42 0) ((0) (let ((e-2 (vector-ref act-42 1))) (vector 0 e-2))) (else (let ((act-43 (CoreC-45Context-getSession e-8 eta-0))) (case (vector-ref act-43 0) ((0) (let ((e-2 (vector-ref act-43 1))) (vector 0 e-2))) (else (let ((e-24 (vector-ref act-43 1))) (let ((act-44 (let ((sc25 (let ((e-2 (vector-ref e-24 2))) e-2))) (cond ((equal? sc25 1) (vector 1 0)) (else (let ((act-44 (IdrisC-45REPLC-45Common-iputStrLn e-8 e-14 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Driver-banner)) eta-0))) (case (vector-ref act-44 0) ((0) (let ((e-2 (vector-ref act-44 1))) (vector 0 e-2))) (else (let ((sc27 (DataC-45List-isCons arg-0))) (cond ((equal? sc27 1) (IdrisC-45REPLC-45Common-iputStrLn e-8 e-14 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "With codegen for:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (Builtin-fst eta-1))) arg-0))) eta-0)) (else (vector 1 0)))))))))))) (case (vector-ref act-44 0) ((0) (let ((e-2 (vector-ref act-44 1))) (vector 0 e-2))) (else (let ((act-45 (let ((sc26 (let ((e-3 (vector-ref e-24 3))) e-3))) (cond ((equal? sc26 1) (IdrisC-45Package-findIpkg e-8 e-14 e-9 u--fname eta-0)) (else (vector 1 u--fname)))))) (case (vector-ref act-45 0) ((0) (let ((e-2 (vector-ref act-45 1))) (vector 0 e-2))) (else (let ((e-26 (vector-ref act-45 1))) (let ((act-46 (IdrisC-45REPLC-45Opts-setMainFile e-14 e-26 eta-0))) (case (vector-ref act-46 0) ((0) (let ((e-2 (vector-ref act-46 1))) (vector 0 e-2))) (else (let ((act-47 (if (null? e-26) (CoreC-45ContextC-45Log-logTime e-8 (lambda () "+ Loading prelude") (lambda (eta-1) (let ((act-47 (let ((sc29 (let ((e-0 (vector-ref e-24 0))) e-0))) (cond ((equal? sc29 1) (vector 1 0)) (else (IdrisC-45ProcessIdr-readPrelude e-8 e-20 e-9 1 eta-1)))))) (case (vector-ref act-47 0) ((0) (let ((e-2 (vector-ref act-47 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))) eta-0) (let ((e-2 (unbox e-26))) (CoreC-45ContextC-45Log-logTime e-8 (lambda () "+ Loading main file") (lambda (eta-1) (let ((act-47 (IdrisC-45REPL-loadMainFile e-8 e-20 e-9 e-22 e-14 e-2 eta-1))) (case (vector-ref act-47 0) ((0) (let ((e-3 (vector-ref act-47 1))) (vector 0 e-3))) (else (let ((e-28 (vector-ref act-47 1))) (let ((act-48 (IdrisC-45REPL-displayErrors e-8 e-20 e-9 e-22 e-14 e-28 eta-1))) (case (vector-ref act-48 0) ((0) (let ((e-3 (vector-ref act-48 1))) (vector 0 e-3))) (else (vector 1 e-28))))))))) eta-0))))) (case (vector-ref act-47 0) ((0) (let ((e-2 (vector-ref act-47 1))) (vector 0 e-2))) (else (let ((e-28 (vector-ref act-47 1))) (let ((act-48 (CoreC-45Core-u--catch_Catchable_Core_Error (IdrisC-45SetOptions-postOptions e-8 e-20 e-9 e-22 e-14 e-28 arg-1) (lambda (u--err) (lambda (eta-1) (CoreC-45Core-C-42C-62 (lambda (eta-2) (IdrisC-45REPLC-45Common-emitError e-8 e-14 e-9 u--err eta-2)) (lambda (eta-2) (vector 1 0)) eta-1))) eta-0))) (case (vector-ref act-48 0) ((0) (let ((e-2 (vector-ref act-48 1))) (vector 0 e-2))) (else (let ((e-29 (vector-ref act-48 1))) (let ((_-2 1)) (cond ((equal? e-29 1) (let ((u--doRepl 1)) (let ((sc31 (cond ((equal? u--ide 1) 1) (else u--ideSocket)))) (cond ((equal? sc31 1) (cond ((equal? u--ideSocket 1) (IdrisC-45Driver-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32stMain-6418 arg-1 arg-0 _-0 _-1 e-7 u--updated e-8 e-9 u--ide u--ideSocket u--outmode u--fname e-14 e-16 e-17 _-2 e-20 e-21 e-22 e-24 e-26 e-28 u--doRepl (IdrisC-45CommandLine-ideSocketModeAddress arg-1) eta-0)) (else (let ((act-49 (IdrisC-45REPLC-45Opts-setOutput e-14 (vector 0 0 (SystemC-45FileC-45Virtual-stdin) (SystemC-45FileC-45Virtual-stdout)) eta-0))) (case (vector-ref act-49 0) ((0) (let ((e-2 (vector-ref act-49 1))) (vector 0 e-2))) (else (IdrisC-45IDEModeC-45REPL-replIDE e-8 e-20 e-9 e-22 e-14 eta-0))))))) (else (let ((act-49 (IdrisC-45REPL-repl e-8 e-20 e-9 e-22 e-14 eta-0))) (case (vector-ref act-49 0) ((0) (let ((e-2 (vector-ref act-49 1))) (vector 0 e-2))) (else (CoreC-45ContextC-45Log-showTimeRecord e-8 eta-0))))))))) (else (let ((act-49 (let ((act-49 (unbox e-14))) (vector 1 act-49)))) (case (vector-ref act-49 0) ((0) (let ((e-2 (vector-ref act-49 1))) (vector 0 e-2))) (else (let ((e-30 (vector-ref act-49 1))) (let ((act-50 (CoreC-45ContextC-45Log-showTimeRecord e-8 eta-0))) (case (vector-ref act-50 0) ((0) (let ((e-2 (vector-ref act-50 1))) (vector 0 e-2))) (else (let ((e-41 (vector-ref e-30 7))) (if (null? e-41) (vector 1 0) (let ((act-51 ((csegen-1214) eta-0))) (vector 1 act-51))))))))))))))))))))))))))))))))))))))))))))))))))))))) (else (vector 1 0)))))))))) ext-0)))))))))))))))))))))))))))))))))))))))))))))))))) (else (vector 1 0))))))))) (else (vector 1 0)))))))))
(define IdrisC-45Driver-showInfo (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-3 (cdr arg-2))) (IdrisC-45Driver-showInfo arg-0 arg-1 e-3)))))
(define IdrisC-45Driver-quitOpts (lambda (arg-0) (if (null? arg-0) (lambda (eta-0) 1) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((10) (PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) (IdrisC-45CommandLine-versionMsg)) (lambda () (lambda (eta-0) 0)))) ((11) (let ((e-4 (vector-ref e-2 1))) (if (null? e-4) (PreludeC-45Interfaces-C-62C-62 (csegen-87) (csegen-1230) (lambda () (lambda (eta-0) 0))) (let ((e-7 (unbox e-4))) (cond ((equal? e-7 0) (PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) (CoreC-45OptionsC-45Log-helpTopics)) (lambda () (lambda (eta-0) 0)))) ((equal? e-7 1) (PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) (IdrisC-45Syntax-pragmaTopics)) (lambda () (lambda (eta-0) 0))))(else (IdrisC-45Driver-quitOpts e-3)))))))(else (IdrisC-45Driver-quitOpts e-3))))))))
(define IdrisC-45Driver-mainWithCodegens (lambda (arg-0 ext-0) (let ((act-24 (IdrisC-45CommandLine-getCmdOpts ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Driver-quitOpts e-2) ext-0))) ((PreludeC-45Interfaces-when (csegen-5) act-25 (lambda () (PreludeC-45Interfaces-C-62C-62 (csegen-87) (lambda (eta-0) (LibrariesC-45UtilsC-45Term-setupTerm eta-0)) (lambda () (lambda (eta-0) (CoreC-45Core-coreRun (lambda (eta-1) (IdrisC-45Driver-stMain arg-0 e-2 eta-1)) (lambda (u--err) (PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Uncaught error: " (CoreC-45Core-u--show_Show_Error u--err))) (lambda () (csegen-1214)))) (lambda (u--res) (lambda (eta-1) 0)) eta-0)))))) ext-0)))) (else (let ((e-5 (vector-ref act-24 1))) ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) e-5) (lambda () (csegen-1230))) ext-0)))))))
(define IdrisC-45Driver-ignoreMissingIpkg (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((32) 1)(else (IdrisC-45Driver-ignoreMissingIpkg e-3))))))))
(define IdrisC-45Driver-findInput (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((22) (let ((e-4 (vector-ref e-2 1))) (box e-4)))(else (IdrisC-45Driver-findInput e-3))))))))
(define IdrisC-45Driver-checkVerbose (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((14) 1)(else (IdrisC-45Driver-checkVerbose e-3))))))))
(define IdrisC-45Driver-banner(blodwen-lazy (lambda () (PreludeC-45TypesC-45String-C-43C-43 "     ____    __     _         ___                                           \xa;" (PreludeC-45TypesC-45String-C-43C-43 "    /  _/___/ /____(_)____   |__ \\                                          \xa;" (PreludeC-45TypesC-45String-C-43C-43 "    / // __  / ___/ / ___/   __/ /     Version " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45Version-showVersion 1 (IdrisC-45Version-version)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "  _/ // /_/ / /  / (__  )   / __/      https://www.idris-lang.org           \xa;" (PreludeC-45TypesC-45String-C-43C-43 " /___/\\__,_/_/  /_/____/   /____/      Type :? for help                     \xa;" (PreludeC-45TypesC-45String-C-43C-43 "\xa;" "Welcome to Idris 2.  Enjoy yourself!")))))))))))
(define YaffleC-45Main-u--resolved_HasNames_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1 ext-0) (vector 1 0)))
(define YaffleC-45Main-u--full_HasNames_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1 ext-0) (vector 1 0)))
(define YaffleC-45Main-yaffleMain (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-initDefs ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Core.Context.Ctxt" ) e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((YaffleC-45Main-processArgs arg-1) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Directory-ctxtPathToNS e-6 arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata (vector 0 e-8)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-newRef (vector "Core.UnifyState.UST" ) (CoreC-45UnifyState-initUState) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-newRef (vector "Idris.Syntax.Syn" ) (IdrisC-45Syntax-initSyntax) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Context-setLogTimings e-6 e-7 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (CoreC-45InitPrimitives-addPrimitives e-6 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (let ((sc9 (LibrariesC-45UtilsC-45Path-extension arg-0))) (if (null? sc9) (let ((act-33 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (csegen-1250) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (TTImpC-45ProcessDecls-processTTImpFile e-6 e-9 e-10 e-11 arg-0 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (cond ((equal? e-15 1) (let ((act-35 (CoreC-45Directory-makeBuildDirectory e-6 e-8 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 (CoreC-45Directory-getTTCFileName e-6 arg-0 "ttc" ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (CoreC-45Binary-writeToTTC (csegen-1252) e-6 e-10 0 arg-0 e-17 ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (csegen-1256) ext-0)))))))))))) (else (vector 1 0)))))))))) (let ((e-1 (unbox sc9))) (cond ((equal? e-1 "ttc") (let ((act-33 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-33 ((PreludeC-45IO-putStrLn (csegen-3) "Processing as TTC") eta-0))) (vector 1 act-33))) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Binary-readFromTTC (csegen-1245) e-6 e-10 1 (CoreC-45FC-emptyFC) 1 arg-0 (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-emptyNS)) (CoreC-45NameC-45Namespace-emptyNS) eta-0)) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-35 ((PreludeC-45IO-putStrLn (csegen-3) "Read TTC") eta-0))) (vector 1 act-35))) ext-0))))))))(else (let ((act-33 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (csegen-1250) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (TTImpC-45ProcessDecls-processTTImpFile e-6 e-9 e-10 e-11 arg-0 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (cond ((equal? e-15 1) (let ((act-35 (CoreC-45Directory-makeBuildDirectory e-6 e-8 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 (CoreC-45Directory-getTTCFileName e-6 arg-0 "ttc" ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (CoreC-45Binary-writeToTTC (csegen-1252) e-6 e-10 0 arg-0 e-17 ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (csegen-1256) ext-0)))))))))))) (else (vector 1 0))))))))))))))))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (let ((act-34 (unbox e-10))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (YaffleC-45REPL-repl e-6 e-9 e-10 e-11 ext-0)))))))))))))))))))))))))))))))))))))))))))
(define YaffleC-45Main-usage(blodwen-lazy (lambda () "Usage: yaffle <input file> [--timing]")))
(define YaffleC-45Main-processArgs (lambda (arg-0) (if (null? arg-0) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (lambda (clam-0) (cond ((equal? e-2 "--timing") (if (null? e-3) (vector 1 1) (let ((act-24 ((csegen-1258) clam-0))) (vector 1 act-24))))(else (let ((act-24 ((csegen-1258) clam-0))) (vector 1 act-24))))))))))
(define YaffleC-45REPL-n--12776-654-u--printName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-7 (cdr e-3))) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-5 '() e-5 '() e-7 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Unelab-unelab '() arg-5 '() e-8) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-1262) e-9)))) eta-0))) (vector 1 act-27))) clam-0)))))))))))))))))))
(define YaffleC-45REPL-showInfo (lambda (arg-0) (lambda (clam-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-7 (cdr e-3))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " ==>\xa;" (PreludeC-45TypesC-45String-C-43C-43 "\x9;" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45ContextC-45Context-u--show_Show_Def (let ((e-17 (vector-ref e-7 17))) e-17)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "\x9;" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_SCCall u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_SCCall u--d u--x)))) (let ((e-20 (vector-ref e-7 20))) e-20)) "\xa;")))))))) eta-0))) (vector 1 act-24))) clam-0)))))))
(define YaffleC-45REPL-repl (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-24 ((PreludeC-45IO-putStr (csegen-3) "Yaffle> ") eta-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 ((csegen-1268) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (ParserC-45Source-runParser 1 (vector 2 0) '() e-6 (TTImpC-45Parser-command)))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-26 ((PreludeC-45IO-printLn (csegen-1269) e-2) eta-0))) (vector 1 act-26))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (YaffleC-45REPL-repl arg-0 arg-1 arg-2 arg-3 ext-0)))))) (else (let ((e-7 (vector-ref sc2 1))) (let ((e-9 (cdr e-7))) (let ((e-13 (cdr e-9))) (let ((act-26 (YaffleC-45REPL-processCatch arg-0 arg-1 arg-2 arg-3 e-13 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (cond ((equal? e-10 1) (YaffleC-45REPL-repl arg-0 arg-1 arg-2 arg-3 ext-0)) (else (vector 1 0))))))))))))))))))))))
(define YaffleC-45REPL-processCatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (YaffleC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (u--err) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (CoreC-45Core-u--show_Show_Error u--err)) eta-1))) (vector 1 act-24))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 1)))))) ext-0)))
(define YaffleC-45REPL-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (let ((e-0 (vector-ref arg-4 1))) (let ((act-24 ((TTImpC-45Elab-elabTerm '() arg-0 arg-1 arg-2 arg-3 0 (vector 2 ) '() '() '() e-0 '()) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Normalise-normalise arg-0 '() e-6 '() e-2 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((TTImpC-45Unelab-unelab '() arg-0 '() e-7) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-28 ((PreludeC-45IO-printLn (csegen-1271) e-8) eta-0))) (vector 1 act-28))) clam-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (vector 1 1))))))))))))))))))) ((1) (let ((e-1 (vector-ref arg-4 1))) (case (vector-ref e-1 0) ((0) (let ((e-10 (vector-ref e-1 1))) (let ((e-11 (vector-ref e-1 2))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyName e-11 (let ((e-0 (vector-ref e-5 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (YaffleC-45REPL-n--12776-654-u--printName e-10 e-11 arg-3 arg-2 arg-1 arg-0 eta-0)) e-6 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 1)))))))))))))))(else (let ((act-24 ((TTImpC-45Elab-elabTerm '() arg-0 arg-1 arg-2 arg-3 0 (vector 2 ) '() '() '() e-1 '()) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-3 (cdr e-5))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-3) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Normalise-normaliseHoles arg-0 '() e-6 '() e-7 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((TTImpC-45Unelab-unelab '() arg-0 '() e-8) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-29 ((PreludeC-45IO-printLn (csegen-1271) e-9) eta-0))) (vector 1 act-29))) clam-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (vector 1 1))))))))))))))))))))))))) ((2) (let ((e-2 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyName e-2 (let ((e-0 (vector-ref e-5 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) e-2 clam-0) (let ((e-1 (car e-6))) (let ((e-3 (cdr e-6))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0) (let ((e-11 (cdr e-7))) (if (null? e-3) (let ((act-26 (CoreC-45Unify-search '() arg-0 arg-2 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) 0 (PreludeC-45Types-u--fromInteger_Num_Nat 1000) e-8 e-11 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Normalise-normaliseHoles arg-0 '() e-12 '() e-9 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-13 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-29 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-30 ((PreludeC-45IO-printLn (cons (csegen-3) (csegen-1276)) e-14) eta-0))) (vector 1 act-30))) clam-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (vector 1 1)))))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0)))))))))))))))))))) ((3) (let ((e-3 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyName e-3 (let ((e-0 (vector-ref e-5 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) e-3 clam-0) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0) (if (null? e-2) (let ((act-26 (TTImpC-45InteractiveC-45ExprSearch-exprSearchN arg-0 arg-1 arg-2 arg-3 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) (+ 1 0) e-8 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (let ((act-27 ((PreludeC-45IO-printLn (cons (csegen-3) (csegen-1280)) eta-0) eta-1))) (vector 1 act-27)))) e-9 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (vector 1 1)))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 (CoreC-45FC-justFC (CoreC-45FC-defaultFC)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0))))))))))))))))))) ((4) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Metadata-findTyDeclAt arg-1 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine e-4 u--p))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (if (null? e-7) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't find declaration for " (CoreC-45Name-u--show_Show_Name e-5))) eta-0))) (vector 1 act-26))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 1)))) (let ((e-1 (unbox e-7))) (let ((e-8 (cdr e-1))) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (let ((act-26 (let ((act-26 (CoreC-45Context-lookupDefExact e-11 (let ((e-0 (vector-ref e-6 0))) e-0) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-26 1))) (if (null? e-12) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't find declaration for " (CoreC-45Name-u--show_Show_Name e-5))) eta-0))) (vector 1 act-27))) clam-0) (let ((e-2 (unbox e-12))) (case (vector-ref e-2 0) ((0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-27 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "Generation") (lambda (eta-1) (TTImpC-45InteractiveC-45GenerateDef-makeDefN arg-0 arg-1 arg-2 arg-3 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine e-4 u--p))) (+ 1 0) e-11 eta-1)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-15 (vector-ref act-27 1))) (if (null? e-15) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (csegen-1286) eta-0) (let ((e-16 (car e-15))) (if (null? e-16) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (csegen-1286) eta-0) (let ((e-17 (cdr e-16))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1283) e-17)) eta-1))) (vector 1 act-28))) eta-0)))))))))) (lambda (u--err) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Can't find a definition for " (CoreC-45Name-u--show_Show_Name e-11))) eta-1))) (vector 1 act-27))) eta-0))) clam-0))(else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) "Already defined") eta-0))) (vector 1 act-27))) clam-0))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 1)))))))))))))))))))) ((5) (let ((e-6 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-6 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 (CoreC-45FC-emptyFC) e-6 clam-0) (let ((act-26 (CoreC-45Core-traverse_ (lambda (u--fn) (lambda (eta-0) (let ((act-26 (CoreC-45Context-getTotality arg-0 (CoreC-45FC-emptyFC) u--fn eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-26 1))) (let ((e-1 (cdr e-8))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name u--fn) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() eta-2)) e-2))))) eta-1))) (vector 1 act-27))) eta-0))) ((2) (let ((e-2 (vector-ref e-1 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name u--fn) (PreludeC-45TypesC-45String-C-43C-43 ": Calls non covering function" (if (null? e-2) (PreludeC-45TypesC-45String-C-43C-43 "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (CoreC-45Name-u--show_Show_Name eta-2)) e-2))) (let ((e-4 (car e-2))) (let ((e-3 (cdr e-2))) (if (null? e-3) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name e-4)) (PreludeC-45TypesC-45String-C-43C-43 "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (CoreC-45Name-u--show_Show_Name eta-2)) e-2)))))))))) eta-1))) (vector 1 act-27))) eta-0)))(else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name u--fn) ": All cases covered")) eta-1))) (vector 1 act-27))) eta-0)))))))))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-7) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 1))))))))))))))) ((6) (let ((e-7 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-7 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 (CoreC-45FC-emptyFC) e-7 clam-0) (let ((act-26 (CoreC-45Core-traverse_ (lambda (u--fn) (lambda (eta-0) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45Termination-checkTotal arg-0 (CoreC-45FC-emptyFC) u--fn eta-1)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-getTotality arg-0 (CoreC-45FC-emptyFC) u--fn eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-27 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name u--fn) (PreludeC-45TypesC-45String-C-43C-43 " is " (CoreC-45TT-u--show_Show_Totality e-9)))) eta-1))) (vector 1 act-28))) eta-0)))))))))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 1))))))))))))))) ((7) (let ((e-8 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45Context-lookupCtxtName e-8 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-traverse_ (lambda (eta-0) (YaffleC-45REPL-showInfo eta-0)) e-6 clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 1)))))))))) (else (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) "Bye for now!") eta-0))) (vector 1 act-24))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 0)))))))))
(define ParserC-45Source-runParserTo (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (ParserC-45Unlit-unlit arg-3 arg-5))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromLitError arg-2 e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (u--str) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (ParserC-45LexerC-45Source-lexTo arg-4 u--str))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromLexError arg-2 e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc1 (LibrariesC-45TextC-45ParserC-45Core-parseWith (csegen-65) arg-1 arg-6 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (vector 0 (ParserC-45Support-fromParsingErrors (csegen-1292) arg-2 e-4)))) (else (let ((e-5 (vector-ref sc1 1))) (vector 1 e-5))))) (lambda (_-1) (let ((e-5 (car _-1))) (let ((e-4 (cdr _-1))) (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (let ((e-10 (car e-7))) (let ((u--cs (PreludeC-45Interfaces-C-60C-38C-62 (csegen-257) e-2 (lambda (u--c) (cons (cons arg-2 (cons (LibrariesC-45TextC-45Bounded-start u--c) (LibrariesC-45TextC-45Bounded-end u--c))) (cons 0 '())))))) (let ((u--ws (PreludeC-45Interfaces-C-60C-38C-62 (csegen-257) e-6 (lambda (lamc-0) (let ((e-9 (car lamc-0))) (let ((e-8 (cdr lamc-0))) (let ((u--mkFC (lambda (u--b) (vector 0 arg-2 (LibrariesC-45TextC-45Bounded-startBounds u--b) (LibrariesC-45TextC-45Bounded-endBounds u--b))))) (vector 0 (PreludeC-45Types-maybe (lambda () (vector 2 )) (lambda () u--mkFC) e-9) e-8)))))))) (vector 1 (cons u--ws (cons (PreludeC-45TypesC-45List-tailRecAppend u--cs e-5) e-10))))))))))))))))))))
(define ParserC-45Source-runParser (lambda (arg-1 arg-2 arg-3 ext-0 ext-1) (ParserC-45Source-runParserTo arg-1 arg-2 arg-3 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) 0)) ext-0 ext-1)))
(define ParserC-45Source-parseFile (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) arg-1) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (ParserC-45Source-runParser 1 arg-2 (ParserC-45Unlit-isLitFile arg-1) e-2 arg-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 0 (vector 49 arg-1 e-5))))))))
(define CoreC-45Metadata-case--addSemanticDecorations-11257 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 (let ((sc1 (DataC-45List-isNil e-3))) (cond ((equal? sc1 1) (vector 1 0)) (else (CoreC-45ContextC-45Log-log arg-1 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "ignored adding decorations to " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_OriginDesc (let ((e-6 (vector-ref arg-3 6))) e-6)) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1298) e-3))))) ext-0)))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (set-box! arg-2 (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-10 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((e-8 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (vector e-0 e-1 e-12 e-11 e-4 e-10 e-6 (LibrariesC-45DataC-45PosMap-union (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) (LibrariesC-45DataC-45PosMap-fromList (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) e-2) arg-5) e-8 e-9))))))))))))) (vector 1 act-25)))))))))
(define CoreC-45Metadata-n--9404-10443-u--toPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8) (if (null? arg-8) '() (let ((e-3 (car arg-8))) (let ((e-4 (cdr arg-8))) (case (vector-ref e-3 0) ((0) (let ((e-7 (vector-ref e-3 1))) (let ((e-8 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 3))) (let ((e-10 (vector-ref e-3 4))) (cons (vector 3 e-7 e-8 e-9 e-10) (CoreC-45Metadata-n--9404-10443-u--toPat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4)))))))(else (cons e-3 (CoreC-45Metadata-n--9404-10443-u--toPat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4)))))))))
(define CoreC-45Metadata-n--10426-11393-u--nfType (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (CoreC-45Normalise-normaliseArgHoles arg-0 '() arg-2 '() e-11 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-2 (cons e-6 (cons e-10 e-5)))))))))))))))))
(define CoreC-45Metadata-n--7564-8643-u--nameTypeDecoration (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) 5) ((1) 2) ((2) 3) (else 1))))
(define CoreC-45Metadata-n--10621-11577-u--fullTy (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-1 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-11) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (cons e-2 (cons e-5 (cons e-10 e-8)))))))))))))))))))))
(define CoreC-45Metadata-n--10621-11576-u--fullLHS (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-2 (cons e-6 e-5))))))))))))))
(define CoreC-45Metadata-n--10621-11578-u--fullHLHS (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-1 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))))
(define CoreC-45Metadata-n--10621-11579-u--fullDecls (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-1 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-2 e-5))))))))))
(define CoreC-45Metadata-u--toBuf_TTC_TTMFile (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 "TTM") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (let ((e-0 (car arg-1))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45Metadata-u--toBuf_TTC_Metadata arg-0 (let ((e-1 (cdr arg-1))) e-1) ext-0)))))))))
(define CoreC-45Metadata-u--toBuf_TTC_Metadata (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1321) arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1343) arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1343) arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1351) arg-0 (let ((e-4 (vector-ref arg-1 4))) e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 (csegen-1355) arg-0 (let ((e-13 (vector-ref arg-1 5))) e-13) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45TTC-u--toBuf_TTC_OriginDesc arg-0 (let ((e-13 (vector-ref arg-1 6))) e-13) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 (csegen-1360) arg-0 (let ((e-13 (vector-ref arg-1 7))) e-13) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 (csegen-1375) arg-0 (let ((e-13 (vector-ref arg-1 8))) e-13) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 (csegen-1360) arg-0 (let ((e-13 (vector-ref arg-1 9))) e-13) ext-0)))))))))))))))))))))))))))
(define CoreC-45Metadata-u--toBuf_TTC_Decoration (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 2) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((equal? arg-1 3) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((equal? arg-1 4) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((equal? arg-1 5) (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)) ((equal? arg-1 6) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((equal? arg-1 7) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((equal? arg-1 8) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)))))
(define CoreC-45Metadata-u--show_Show_Metadata (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (PreludeC-45TypesC-45String-C-43C-43 "Metadata:\xa;" (PreludeC-45TypesC-45String-C-43C-43 " lhsApps: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1382) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1382) u--d u--x)))) e-0) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 " names: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1388) e-1) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 " type declarations: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1388) e-2) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 " current LHS: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1276) e-3) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 " holes: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1398) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1398) u--d u--x)))) e-4) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 " nameLocMap: " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1402) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1402) u--d u--x)))) e-5) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 " sourceIdent: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_OriginDesc e-6) (PreludeC-45TypesC-45String-C-43C-43 " semanticHighlighting: " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (csegen-1298) e-7) (PreludeC-45TypesC-45String-C-43C-43 " semanticAliases: " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1406) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1406) u--d u--x)))) e-8) (PreludeC-45TypesC-45String-C-43C-43 " semanticDefaults: " (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (csegen-1298) e-9)))))))))))))))))))))))))))))))))))))))
(define CoreC-45Metadata-u--show_Show_Decoration (lambda (arg-0) (cond ((equal? arg-0 0) "comment") ((equal? arg-0 1) "type") ((equal? arg-0 2) "function") ((equal? arg-0 3) "data") ((equal? arg-0 4) "keyword") ((equal? arg-0 5) "bound") ((equal? arg-0 6) "namespace") ((equal? arg-0 7) "postulate") (else "module"))))
(define CoreC-45Metadata-u--showPrec_Show_Decoration (lambda (arg-0 arg-1) (CoreC-45Metadata-u--show_Show_Decoration arg-1)))
(define CoreC-45Metadata-u--full_HasNames_Metadata (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Metadata-n--10621-11576-u--fullLHS arg-1 arg-0 eta-0)) (let ((e-0 (vector-ref arg-1 0))) e-0) '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Metadata-n--10621-11577-u--fullTy arg-1 arg-0 eta-0)) (let ((e-1 (vector-ref arg-1 1))) e-1) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Metadata-n--10621-11577-u--fullTy arg-1 arg-0 eta-0)) (let ((e-2 (vector-ref arg-1 2))) e-2) '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Metadata-n--10621-11578-u--fullHLHS arg-1 arg-0 eta-0 eta-1))) (let ((e-4 (vector-ref arg-1 4))) e-4) '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Metadata-n--10621-11579-u--fullDecls arg-1 arg-0 eta-0 eta-1))) (LibrariesC-45DataC-45PosMap-u--toList_Foldable_PosMap (let ((e-13 (vector-ref arg-1 5))) e-13)) '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (let ((e-13 (vector-ref arg-1 6))) (let ((e-12 (vector-ref arg-1 7))) (let ((e-11 (vector-ref arg-1 8))) (let ((e-10 (vector-ref arg-1 9))) (vector e-5 e-6 e-7 '() e-8 (LibrariesC-45DataC-45PosMap-fromList (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) e-9) e-13 e-12 e-11 e-10))))))))))))))))))))))))))))
(define CoreC-45Metadata-u--fromBuf_TTC_TTMFile (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-5 "TTM"))) (cond ((equal? sc1 1) (CoreC-45BinaryC-45Prims-corrupt "TTM header" ext-0)) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Binary-checkTTCVersion "" e-7 (CoreC-45Binary-ttcVersion) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45Metadata-u--fromBuf_TTC_Metadata arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons e-7 e-9))))))))))))))))))))))
(define CoreC-45Metadata-u--fromBuf_TTC_Metadata (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1321) arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1343) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1343) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1351) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 (csegen-1355) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45TTC-u--fromBuf_TTC_OriginDesc arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 (csegen-1360) arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 (csegen-1375) arg-0 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 (csegen-1360) arg-0 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (vector 1 (vector e-5 e-6 e-7 '() e-8 e-9 e-10 e-11 e-12 e-13))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Metadata-u--fromBuf_TTC_Decoration (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 1)) ((equal? e-5 1) (vector 1 2)) ((equal? e-5 2) (vector 1 3)) ((equal? e-5 3) (vector 1 4)) ((equal? e-5 4) (vector 1 5)) ((equal? e-5 5) (vector 1 6)) ((equal? e-5 6) (vector 1 7)) ((equal? e-5 7) (vector 1 8)) ((equal? e-5 8) (vector 1 0))(else (CoreC-45BinaryC-45Prims-corrupt "Decoration" ext-0)))))))))
(define CoreC-45Metadata-writeToTTM (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Metadata-normaliseTypes arg-1 arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-initBinary ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (CoreC-45Metadata-u--full_HasNames_Metadata (let ((e-0 (vector-ref e-8 0))) e-0) e-7 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (CoreC-45Metadata-u--toBuf_TTC_TTMFile e-6 (cons (CoreC-45Binary-ttcVersion) e-9) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (let ((act-29 (let ((act-29 (unbox e-6))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((LibrariesC-45UtilsC-45Binary-writeToFile arg-2 e-10) ext-0))) (vector 1 act-30)))))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (case (vector-ref e-10 0) ((1) (vector 1 0)) (else (let ((e-11 (vector-ref e-10 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-11)))) ext-0))))))))))))))))))))))))))))
(define CoreC-45Metadata-withCurrentLHS (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getFullName arg-0 arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 0))) (lambda () (lambda (u--lhs) (lambda (eta-0) (let ((act-26 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 (cons (cons e-6 u--lhs) e-4) e-11 e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-26))))) (let ((e-3 (vector-ref e-5 3))) e-3)) ext-0)))))))))))
(define CoreC-45Metadata-substEnv (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-9 (cdr arg-2))) (CoreC-45Metadata-substEnv e-3 arg-1 e-9 (CoreC-45TTC-45SubstEnv-subst (vector 1 arg-1 (vector 0 ) e-2) arg-3))))))))
(define CoreC-45Metadata-setHoleLHS (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 (box arg-1) e-4 e-10 e-6 e-7 e-8 e-9))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Metadata-readMetadata (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Metadata-u--fromBuf_TTC_TTMFile e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-1 (cdr e-7))) (vector 1 e-1)))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-6)))) ext-0))))))))))
(define CoreC-45Metadata-readFromTTM (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (LibrariesC-45UtilsC-45Binary-readFromFile arg-1 ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Metadata-u--fromBuf_TTC_TTMFile e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (set-box! arg-0 (let ((e-1 (cdr e-7))) e-1)))) (vector 1 act-27)))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-6)))) ext-0))))))))))
(define CoreC-45Metadata-normaliseTypes (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Metadata-n--10426-11393-u--nfType arg-1 arg-0 e-6 eta-0)) (let ((e-1 (vector-ref e-5 1))) e-1) '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-11 (vector-ref e-5 6))) (let ((e-10 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-7 e-2 e-3 e-4 e-12 e-11 e-10 e-8 e-9))))))))))))) (vector 1 act-27))))))))))))))))
(define CoreC-45Metadata-nameDecoration (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-isUnsafeBuiltin arg-0))) (cond ((equal? sc0 1) 7) (else (CoreC-45Metadata-n--7564-8643-u--nameTypeDecoration arg-1 arg-0 arg-1))))))
(define CoreC-45Metadata-initMetadata (lambda (arg-0) (vector '() '() '() '() '() (LibrariesC-45DataC-45PosMap-empty) arg-0 (LibrariesC-45DataC-45PosMap-empty) (LibrariesC-45DataC-45PosMap-empty) (LibrariesC-45DataC-45PosMap-empty))))
(define CoreC-45Metadata-findTypeAt (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (CoreC-45Metadata-findEntryWith arg-1 (let ((e-1 (vector-ref e-5 1))) e-1))))))))))
(define CoreC-45Metadata-findTyDeclAt (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45Metadata-findEntryWith arg-1 (let ((e-2 (vector-ref e-5 2))) e-2)))))))))
(define CoreC-45Metadata-findLHSAt (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45Metadata-findEntryWith (lambda (u--loc) (lambda (u--tm) ((arg-1 u--loc) (Builtin-snd u--tm)))) (let ((e-0 (vector-ref e-5 0))) e-0)))))))))
(define CoreC-45Metadata-findHoleLHS (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (DataC-45List-lookupBy (csegen-1408) arg-1 (let ((e-4 (vector-ref e-5 4))) e-4)))))))))
(define CoreC-45Metadata-findEntryWith (lambda (ext-0 ext-1) (DataC-45List-find (lambda (eta-1) (PreludeC-45Basics-uncurry ext-0 eta-1)) ext-1)))
(define CoreC-45Metadata-dumpTTM (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45Metadata-readMetadata arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (CoreC-45Metadata-u--show_Show_Metadata e-5)) ext-0))) (vector 1 act-25))))))))
(define CoreC-45Metadata-clearHoleLHS (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 '() e-4 e-10 e-6 e-7 e-8 e-9))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Metadata-addTyDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getFullName arg-1 arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (CoreC-45FC-isNonEmptyFC arg-3))) (if (null? sc2) (vector 1 0) (let ((e-1 (unbox sc2))) (let ((act-26 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-12 (cons (cons e-1 (cons e-6 (cons (CoreC-45Env-length arg-5) (CoreC-45Env-bindEnv arg-0 arg-3 arg-5 arg-6)))) e-2) e-3 e-4 e-11 e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-26)))))))))))))))
(define CoreC-45Metadata-addSemanticDefault (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 e-4 e-10 e-6 e-7 e-8 (LibrariesC-45DataC-45PosMap-insert (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) arg-1 e-9))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Metadata-addSemanticDecorations (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--posmap (let ((e-7 (vector-ref e-5 7))) e-7))) (CoreC-45Metadata-case--addSemanticDecorations-11257 arg-2 arg-1 arg-0 e-5 e-6 u--posmap (DataC-45List-span (lambda (eta-0) (CoreC-45FC-u--C-61C-61_Eq_OriginDesc (let ((e-10 (vector-ref e-5 6))) e-10) (Builtin-fst (Builtin-fst eta-0)))) arg-2) ext-0))))))))))))
(define CoreC-45Metadata-addSemanticAlias (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 e-4 e-10 e-6 e-7 (LibrariesC-45DataC-45PosMap-insert (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) (cons arg-1 arg-2) e-8) e-9)))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Metadata-addNameType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getFullName arg-1 arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (CoreC-45FC-isConcreteFC arg-3))) (if (null? sc2) (vector 1 0) (let ((e-1 (unbox sc2))) (let ((act-26 (let ((act-26 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 (cons (cons e-1 (cons e-6 (cons 0 (CoreC-45Metadata-substEnv arg-0 arg-3 arg-5 arg-6)))) e-12) e-2 e-3 e-4 e-11 e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45ContextC-45Log-log arg-1 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) (PreludeC-45TypesC-45String-C-43C-43 " at line " (PreludeC-45Show-u--show_Show_Int (bs+ (blodwen-toSignedInt 1 63) (CoreC-45FC-startLine e-1) 63))))) ext-0)))))))))))))))))
(define CoreC-45Metadata-addNameLoc (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getFullName arg-1 arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc2) (vector 1 0) (let ((e-1 (unbox sc2))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-12 e-2 e-3 e-4 (LibrariesC-45DataC-45PosMap-insert (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) (cons e-1 e-6) e-11) e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-26)))))))))))))))
(define CoreC-45Metadata-addLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-1 (csegen-76) (CoreC-45Env-bindEnv arg-0 arg-3 (CoreC-45Metadata-n--9404-10443-u--toPat arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-5) arg-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (CoreC-45FC-isNonEmptyFC arg-3))) (if (null? sc2) (vector 1 0) (let ((e-1 (unbox sc2))) (let ((act-26 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector (cons (cons e-1 (cons arg-4 e-6)) e-0) e-12 e-2 e-3 e-4 e-11 e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-26)))))))))))))))
(define CoreC-45Binary-n--10730-10863-u--trimName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((u--n (vector 0 e-0 e-1))) (let ((sc1 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-0 arg-4))) (cond ((equal? sc1 1) e-1) (else u--n)))))))(else arg-5))))
(define CoreC-45Binary-n--9106-9374-u--resolved_aux (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 (PreludeC-45TypesC-45List-reverse arg-5)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 (let ((e-4 (cdr arg-1))) (((e-4 arg-4) e-2) ext-0)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Binary-n--9106-9374-u--resolved_aux arg-1 arg-2 arg-3 arg-4 (cons e-5 arg-5) e-3 ext-0))))))))))
(define CoreC-45Binary-n--9554-9951-u--resolvedRW (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (lambda (clam-0) (if (null? arg-25) (vector 1 '()) (let ((e-2 (unbox arg-25))) (let ((e-3 (car e-2))) (let ((e-4 (cdr e-2))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-24 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--resolved_HasNames_Name arg-24 e-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box (cons e-5 e-6))))))))))))))))))
(define CoreC-45Binary-n--9554-9952-u--resolvedPrim (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 ext-0) (let ((e-0 (vector-ref arg-25 0))) (let ((e-1 (vector-ref arg-25 1))) (let ((e-2 (vector-ref arg-25 2))) (let ((e-3 (vector-ref arg-25 3))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-46) arg-24 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-46) arg-24 e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-46) arg-24 e-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-46) arg-24 e-3 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector e-5 e-6 e-7 e-8))))))))))))))))))))))))
(define CoreC-45Binary-n--9554-9950-u--resolvedPair (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (lambda (clam-0) (if (null? arg-25) (vector 1 '()) (let ((e-2 (unbox arg-25))) (let ((e-3 (vector-ref e-2 0))) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-24 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--resolved_HasNames_Name arg-24 e-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-u--resolved_HasNames_Name arg-24 e-5) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (box (vector e-6 e-7 e-8)))))))))))))))))))))))
(define CoreC-45Binary-n--10260-10410-u--replaceNS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((0) arg-9)(else (cons (vector 0 arg-8 e-2) e-3)))))))
(define CoreC-45Binary-n--9105-9346-u--full_aux (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 (PreludeC-45TypesC-45List-reverse arg-5)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 (let ((e-1 (car arg-1))) (((e-1 arg-4) e-2) ext-0)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Binary-n--9105-9346-u--full_aux arg-1 arg-2 arg-3 arg-4 (cons e-5 arg-5) e-3 ext-0))))))))))
(define CoreC-45Binary-n--9553-9764-u--fullRW (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (lambda (clam-0) (if (null? arg-25) (vector 1 '()) (let ((e-2 (unbox arg-25))) (let ((e-3 (car e-2))) (let ((e-4 (cdr e-2))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-24 e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_Name arg-24 e-4 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box (cons e-5 e-6))))))))))))))))))
(define CoreC-45Binary-n--9553-9765-u--fullPrim (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 ext-0) (let ((e-0 (vector-ref arg-25 0))) (let ((e-1 (vector-ref arg-25 1))) (let ((e-2 (vector-ref arg-25 2))) (let ((e-3 (vector-ref arg-25 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-893) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-46) arg-24 e-0 eta-3)) eta-2)) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-46) arg-24 e-1 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-46) arg-24 e-2 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-46) arg-24 e-3 eta-0)) ext-0)))))))
(define CoreC-45Binary-n--9553-9763-u--fullPair (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (lambda (clam-0) (if (null? arg-25) (vector 1 '()) (let ((e-2 (unbox arg-25))) (let ((e-3 (vector-ref e-2 0))) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-24 e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_Name arg-24 e-4 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-u--full_HasNames_Name arg-24 e-5 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (box (vector e-6 e-7 e-8)))))))))))))))))))))))
(define CoreC-45Binary-n--11151-11236-u--completeDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 0 (let ((e-2 (unbox arg-6))) (let ((e-17 (vector-ref e-2 17))) (case (vector-ref e-17 0) ((0) 0) ((7) 0)(else 1)))))))
(define CoreC-45Binary-n--12089-12117-u--alreadyDone (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) 0 (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-15 (cdr e-11))) (let ((sc4 (let ((sc5 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-10 e-10))) (cond ((equal? sc5 1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-11 e-15)) (else 0))))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-10 e-10))) (cond ((equal? sc6 1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (CoreC-45NameC-45Namespace-miAsNamespace arg-10) arg-11)) (else 0))))) (cond ((equal? sc5 1) 1) (else (CoreC-45Binary-n--12089-12117-u--alreadyDone arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3))))))))))))))))
(define CoreC-45Binary-n--11835-11889-u--addT (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup arg-4 (let ((e-13 (vector-ref e-5 13))) e-13)))) (if (null? sc1) (let ((act-25 (set-box! arg-3 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert arg-4 (cons arg-5 '()) e-13) e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25)) (let ((e-2 (unbox sc1))) (let ((act-25 (set-box! arg-3 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-32 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-32 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert arg-4 (cons arg-5 e-2) e-13) e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25)))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32TransformC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32TransformC-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--resolved_HasNames_Transform arg-0 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-5 e-3))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-124C-41 (lambda (arg-0 arg-1) (lambda (clam-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (cons e-5 (cons e-8 e-7))))))))))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40ListC-32StringC-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40ListC-32StringC-41C-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-5 e-3))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40TTCFileC-32C-36eC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((e-6 (vector-ref arg-3 5))) (let ((e-7 (vector-ref arg-3 6))) (let ((e-8 (vector-ref arg-3 7))) (let ((e-9 (vector-ref arg-3 8))) (let ((e-10 (vector-ref arg-3 9))) (let ((e-11 (vector-ref arg-3 10))) (let ((e-12 (vector-ref arg-3 11))) (let ((e-13 (vector-ref arg-3 12))) (let ((e-14 (vector-ref arg-3 13))) (let ((e-15 (vector-ref arg-3 14))) (let ((e-16 (vector-ref arg-3 15))) (let ((e-17 (vector-ref arg-3 16))) (let ((e-18 (vector-ref arg-3 17))) (let ((e-19 (vector-ref arg-3 18))) (let ((e-20 (vector-ref arg-3 19))) (let ((e-21 (vector-ref arg-3 20))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41 arg-2 eta-0 eta-1))) e-9 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-22 (vector-ref act-24 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-124C-41 arg-2 eta-0)) e-10 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-23 (vector-ref act-25 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Binary-n--9554-9950-u--resolvedPair arg-1 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-15) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-24 (vector-ref act-26 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Binary-n--9554-9951-u--resolvedRW arg-1 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-16) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-25 (vector-ref act-27 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Binary-n--9554-9952-u--resolvedPrim arg-1 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-17 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-26 (vector-ref act-28 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-28 1))) (let ((act-29 ((CoreC-45Binary-u--resolved_HasNames_C-40ListC-32C-36aC-41 (csegen-1409) arg-2 e-18) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-27 (vector-ref act-29 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45Binary-u--resolved_HasNames_C-40ListC-32C-36aC-41 (csegen-1412) arg-2 e-20) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-28 (vector-ref act-30 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-30 1))) (let ((act-31 (let ((e-29 (cdr arg-1))) (((e-29 arg-2) e-21) ext-0)))) (case (vector-ref act-31 0) ((0) (let ((e-29 (vector-ref act-31 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-31 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-22 e-23 e-11 e-12 e-13 e-14 e-24 e-25 e-26 e-27 e-19 e-28 e-29)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (lambda (eta-0) (CoreC-45Binary-n--9106-9374-u--resolved_aux arg-1 arg-3 arg-2 arg-2 '() arg-3 eta-0))))
(define CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32TransformC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32TransformC-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_Transform arg-0 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6))))))))))))))
(define CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-5 e-3))))))))))
(define CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-124C-41 (lambda (arg-0 arg-1) (lambda (clam-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-u--full_HasNames_Name arg-0 e-6 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (cons e-5 (cons e-8 e-7))))))))))))))))))
(define CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40ListC-32StringC-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40ListC-32StringC-41C-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-5 e-3))))))))))
(define CoreC-45Binary-u--full_HasNames_C-40TTCFileC-32C-36eC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((e-6 (vector-ref arg-3 5))) (let ((e-7 (vector-ref arg-3 6))) (let ((e-8 (vector-ref arg-3 7))) (let ((e-9 (vector-ref arg-3 8))) (let ((e-10 (vector-ref arg-3 9))) (let ((e-11 (vector-ref arg-3 10))) (let ((e-12 (vector-ref arg-3 11))) (let ((e-13 (vector-ref arg-3 12))) (let ((e-14 (vector-ref arg-3 13))) (let ((e-15 (vector-ref arg-3 14))) (let ((e-16 (vector-ref arg-3 15))) (let ((e-17 (vector-ref arg-3 16))) (let ((e-18 (vector-ref arg-3 17))) (let ((e-19 (vector-ref arg-3 18))) (let ((e-20 (vector-ref arg-3 19))) (let ((e-21 (vector-ref arg-3 20))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41 arg-2 eta-0 eta-1))) e-9 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-22 (vector-ref act-24 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-124C-41 arg-2 eta-0)) e-10 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-23 (vector-ref act-25 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Binary-n--9553-9763-u--fullPair arg-1 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-15) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-24 (vector-ref act-26 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Binary-n--9553-9764-u--fullRW arg-1 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-16) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-25 (vector-ref act-27 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Binary-n--9553-9765-u--fullPrim arg-1 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-17 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-26 (vector-ref act-28 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-28 1))) (let ((act-29 ((CoreC-45Binary-u--full_HasNames_C-40ListC-32C-36aC-41 (csegen-1409) arg-2 e-18) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-27 (vector-ref act-29 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45Binary-u--full_HasNames_C-40ListC-32C-36aC-41 (csegen-1412) arg-2 e-20) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-28 (vector-ref act-30 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-30 1))) (let ((act-31 (let ((e-30 (car arg-1))) (((e-30 arg-2) e-21) ext-0)))) (case (vector-ref act-31 0) ((0) (let ((e-29 (vector-ref act-31 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-31 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-22 e-23 e-11 e-12 e-13 e-14 e-24 e-25 e-26 e-27 e-19 e-28 e-29)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Binary-u--full_HasNames_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (lambda (eta-0) (CoreC-45Binary-n--9105-9346-u--full_aux arg-1 arg-3 arg-2 arg-2 '() arg-3 eta-0))))
(define CoreC-45Binary-writeToTTC (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-initBinary ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-3))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Binary-getSaveDefs (let ((e-2 (vector-ref e-6 2))) e-2) (LibrariesC-45DataC-45NameMap-keys (let ((e-33 (vector-ref e-6 5))) e-33)) '() e-6 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-hashFileWith (let ((e-4 (vector-ref e-6 4))) (let ((e-35 (vector-ref e-4 9))) e-35)) arg-5 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-getDefaultTotalityOption arg-2 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45ContextC-45Log-log arg-2 "ttc.write" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (DataC-45String-unwords (cons "Writing" (cons arg-6 (cons "with source hash" (cons (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-576) e-9) (cons "and interface hash" (cons (PreludeC-45Show-u--show_Show_Int (let ((e-16 (vector-ref e-6 16))) e-16)) '())))))))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45Binary-writeTTCFile arg-1 arg-2 e-5 (vector (CoreC-45Binary-ttcVersion) e-10 e-9 (let ((e-16 (vector-ref e-6 16))) e-16) (let ((e-17 (vector-ref e-6 17))) e-17) (let ((e-22 (vector-ref e-6 22))) e-22) e-8 (LibrariesC-45DataC-45NameMap-keys (let ((e-25 (vector-ref e-6 25))) e-25)) (let ((e-12 (vector-ref e-6 12))) e-12) (let ((e-31 (vector-ref e-6 11))) e-31) (let ((e-18 (vector-ref e-6 18))) e-18) (let ((e-15 (vector-ref e-7 8))) e-15) (let ((e-2 (vector-ref e-6 2))) e-2) (let ((e-3 (vector-ref e-6 3))) e-3) (let ((e-4 (vector-ref e-6 4))) (let ((e-43 (vector-ref e-4 4))) e-43)) (let ((e-4 (vector-ref e-6 4))) (let ((e-42 (vector-ref e-4 5))) e-42)) (let ((e-4 (vector-ref e-6 4))) (let ((e-41 (vector-ref e-4 6))) e-41)) (LibrariesC-45DataC-45NameMap-toList (let ((e-15 (vector-ref e-6 15))) e-15)) (let ((e-20 (vector-ref e-6 20))) e-20) (let ((e-14 (vector-ref e-6 14))) e-14) arg-4) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (let ((act-32 (let ((act-32 (unbox e-5))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 ((LibrariesC-45UtilsC-45Binary-writeToFile arg-6 e-13) ext-0))) (vector 1 act-33)))))))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (case (vector-ref e-13 0) ((1) (vector 1 0)) (else (let ((e-14 (vector-ref e-13 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-14)))) ext-0))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Binary-writeTTCFile (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-toFullNames arg-2 (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Binary-u--full_HasNames_C-40TTCFileC-32C-36eC-41 (Builtin-fst arg-1) arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Binary-u--resolved_HasNames_C-40TTCFileC-32C-36eC-41 (Builtin-fst arg-1) arg-4062 arg-4063 eta-0))))) arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-3 "TT2") ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_WastefulInt arg-3 (let ((e-1 (vector-ref e-5 0))) e-1) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45TTC-u--toBuf_TTC_TotalReq arg-3 (let ((e-2 (vector-ref e-5 1))) e-2) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-479) arg-3 (let ((e-3 (vector-ref e-5 2))) e-3)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-3 (let ((e-4 (vector-ref e-5 3))) e-4)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1415) arg-3 (let ((e-27 (vector-ref e-5 4))) e-27) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1422) arg-3 (let ((e-27 (vector-ref e-5 5))) e-27) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1436) arg-3 (let ((e-23 (vector-ref e-5 10))) e-23) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (let ((sc9 (Builtin-snd arg-1))) (let ((e-1 (car sc9))) (((e-1 arg-3) (let ((e-21 (vector-ref e-5 20))) e-21)) ext-0))))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1447) arg-3 (let ((e-29 (vector-ref e-5 6))) e-29) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-3 (let ((e-29 (vector-ref e-5 7))) e-29) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-35) arg-3 (let ((e-29 (vector-ref e-5 8))) e-29) ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((act-37 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1454) arg-3 (let ((e-29 (vector-ref e-5 9))) e-29) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((act-38 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-3 (let ((e-28 (vector-ref e-5 11))) e-28)) ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((act-39 (CoreC-45TTC-u--toBuf_TTC_Namespace arg-3 (let ((e-28 (vector-ref e-5 12))) e-28) ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((act-40 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1418) arg-3 (let ((e-28 (vector-ref e-5 13))) e-28) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((act-41 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-1458) arg-3 (let ((e-28 (vector-ref e-5 14))) e-28)) ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-2 (vector-ref act-41 1))) (vector 0 e-2))) (else (let ((act-42 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-1461) arg-3 (let ((e-28 (vector-ref e-5 15))) e-28)) ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-2 (vector-ref act-42 1))) (vector 0 e-2))) (else (let ((act-43 (CoreC-45TTC-u--toBuf_TTC_PrimNames arg-3 (let ((e-28 (vector-ref e-5 16))) e-28) ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-2 (vector-ref act-43 1))) (vector 0 e-2))) (else (let ((act-44 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1464) arg-3 (let ((e-28 (vector-ref e-5 17))) e-28) ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-2 (vector-ref act-44 1))) (vector 0 e-2))) (else (let ((act-45 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1468) arg-3 (let ((e-28 (vector-ref e-5 18))) e-28) ext-0))) (case (vector-ref act-45 0) ((0) (let ((e-2 (vector-ref act-45 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1472) arg-3 (let ((e-28 (vector-ref e-5 19))) e-28) ext-0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Binary-updateTransforms (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 (let ((act-24 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toResolvedNames arg-0 (csegen-852) e-7 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (CoreC-45Binary-n--11835-11889-u--addT e-6 e-7 e-3 arg-0 e-5 e-8 clam-0))))))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((CoreC-45Binary-updateTransforms arg-0 e-3) clam-0))))))))))))
(define CoreC-45Binary-updateRewrite (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 e-34 e-35 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 arg-1 e-36) e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Binary-updatePrims (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 e-34 e-35 e-36 (CoreC-45Binary-updatePrimNames arg-1 e-37) e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Binary-updatePrimNames (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (vector (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-7 (vector-ref arg-0 0))) e-7) e-0) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-6 (vector-ref arg-0 1))) e-6) e-1) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-5 (vector-ref arg-0 2))) e-5) e-2) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-4 (vector-ref arg-0 3))) e-4) e-3))))))))
(define CoreC-45Binary-updatePair (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-41 (vector-ref e-4 0))) (let ((e-32 (vector-ref e-4 1))) (let ((e-33 (vector-ref e-4 2))) (let ((e-34 (vector-ref e-4 3))) (let ((e-35 (vector-ref e-4 4))) (let ((e-36 (vector-ref e-4 5))) (let ((e-37 (vector-ref e-4 6))) (let ((e-38 (vector-ref e-4 7))) (let ((e-39 (vector-ref e-4 8))) (let ((e-40 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-41 e-32 e-33 e-34 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 arg-1 e-35) e-36 e-37 e-38 e-39 e-40) e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45Binary-updateNameDirectives (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-35 (vector-ref e-5 2))) (let ((e-34 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-32 (vector-ref e-5 6))) (let ((e-31 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-35 e-34 e-4 e-33 e-32 e-31 e-8 e-9 e-10 e-11 e-12 e-13 e-14 (LibrariesC-45DataC-45NameMap-insert e-6 e-7 e-15) e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((CoreC-45Binary-updateNameDirectives arg-0 e-3) clam-0))))))))))))))))
(define CoreC-45Binary-updateCGDirectives (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--cgsC-39 (DataC-45List-nub (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-898) (csegen-17) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-898) (csegen-17) arg-4 arg-5)))) (PreludeC-45TypesC-45List-tailRecAppend arg-1 (let ((e-20 (vector-ref e-5 20))) e-20))))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 u--cgsC-39 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-25)))))))))
(define CoreC-45Binary-ttcVersion(blodwen-lazy (lambda () 66)))
(define CoreC-45Binary-readTotalReq (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (lambda (eta-1) (CoreC-45Binary-getTotalReq arg-0 e-6 eta-1)) eta-0)) (lambda (u--err) (lambda (eta-0) (vector 1 '()))) ext-0))))))) (else (vector 1 '())))))))))
(define CoreC-45Binary-readTTCFile (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-6))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-5 "TT2"))) (cond ((equal? sc2 1) (CoreC-45BinaryC-45Prims-corrupt (PreludeC-45TypesC-45String-C-43C-43 "TTC header in " (PreludeC-45TypesC-45String-C-43C-43 arg-4 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_String e-5)))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_WastefulInt arg-6 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Binary-checkTTCVersion arg-4 e-8 (CoreC-45Binary-ttcVersion) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-6 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-479) arg-6 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-6 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1415) arg-6 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1422) arg-6 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1436) arg-6 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (let ((act-35 (let ((e-2 (cdr arg-1))) ((e-2 arg-6) ext-0)))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (cond ((equal? arg-3 1) (let ((act-36 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1447) arg-6 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-6 ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-37 1))) (let ((act-38 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-35) arg-6 ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-38 1))) (let ((act-39 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1454) arg-6 ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-39 1))) (let ((act-40 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-6 ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-40 1))) (let ((act-41 (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-6 ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-2 (vector-ref act-41 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-41 1))) (let ((act-42 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1418) arg-6 ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-2 (vector-ref act-42 1))) (vector 0 e-2))) (else (let ((e-23 (vector-ref act-42 1))) (let ((act-43 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-1458) arg-6 ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-2 (vector-ref act-43 1))) (vector 0 e-2))) (else (let ((e-24 (vector-ref act-43 1))) (let ((act-44 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-1461) arg-6 ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-2 (vector-ref act-44 1))) (vector 0 e-2))) (else (let ((e-25 (vector-ref act-44 1))) (let ((act-45 (CoreC-45TTC-u--fromBuf_TTC_PrimNames arg-6 ext-0))) (case (vector-ref act-45 0) ((0) (let ((e-2 (vector-ref act-45 1))) (vector 0 e-2))) (else (let ((e-26 (vector-ref act-45 1))) (let ((act-46 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1464) arg-6 ext-0))) (case (vector-ref act-46 0) ((0) (let ((e-2 (vector-ref act-46 1))) (vector 0 e-2))) (else (let ((e-27 (vector-ref act-46 1))) (let ((act-47 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1468) arg-6 ext-0))) (case (vector-ref act-47 0) ((0) (let ((e-2 (vector-ref act-47 1))) (vector 0 e-2))) (else (let ((e-28 (vector-ref act-47 1))) (let ((act-48 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1472) arg-6 ext-0))) (case (vector-ref act-48 0) ((0) (let ((e-2 (vector-ref act-48 1))) (vector 0 e-2))) (else (let ((e-29 (vector-ref act-48 1))) (vector 1 (vector e-8 e-10 e-11 e-12 e-13 e-14 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Binary-n--10260-10410-u--replaceNS arg-1 arg-6 arg-5 arg-4 arg-3 arg-2 e-22 eta-0)) e-17) e-18 e-19 e-20 e-15 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-16))))))))))))))))))))))))))))))))))))))))))))))))))))))) (else (vector 1 (vector e-8 e-10 e-11 e-12 e-13 e-14 '() '() '() '() '() 0 (CoreC-45NameC-45Namespace-mkNamespace "") '() '() '() (csegen-583) '() '() '() e-16)))))))))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Binary-readImportHashes (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-26 (CoreC-45Binary-getImportHashes arg-0 e-6 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 e-7)))))) (lambda (u--err) (lambda (eta-0) (vector 1 '()))) ext-0))))))) (else (vector 1 '())))))))))
(define CoreC-45Binary-readHashes (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (CoreC-45Binary-getHashes arg-0 e-6 eta-0)) (lambda (u--err) (lambda (eta-0) (vector 1 (cons '() 0)))) ext-0))))))) (else (vector 1 (cons '() 0))))))))))
(define CoreC-45Binary-readFromTTC (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45Types-elem (csegen-1484) (cons arg-8 (cons arg-6 arg-9)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-19 (vector-ref e-5 19))) e-19))))) (cond ((equal? sc1 0) (let ((act-25 (let ((act-25 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-31 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 (cons (cons arg-7 (cons arg-8 (cons arg-6 arg-9))) e-19) e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (LibrariesC-45UtilsC-45Binary-readFromFile arg-7 ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (case (vector-ref e-7 0) ((1) (let ((e-2 (vector-ref e-7 1))) (let ((act-27 (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--as (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-9 (CoreC-45NameC-45Namespace-miAsNamespace arg-8)))) (cond ((equal? sc6 1) '()) (else (box arg-9)))))) (let ((sc6 (CoreC-45Binary-n--12089-12117-u--alreadyDone arg-1 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-8 arg-9 (let ((e-19 (vector-ref e-5 19))) e-19)))) (cond ((equal? sc6 1) (let ((act-28 (CoreC-45Binary-readTTCFile arg-1 arg-2 0 arg-7 u--as e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--ex (let ((e-21 (vector-ref e-9 20))) e-21))) (vector 1 (box (cons u--ex (cons (let ((e-4 (vector-ref e-9 3))) e-4) (let ((e-11 (vector-ref e-9 10))) e-11))))))))))) (else (let ((act-28 (CoreC-45Binary-readTTCFile arg-1 arg-2 1 arg-7 u--as e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--ex (let ((e-21 (vector-ref e-9 20))) e-21))) (let ((act-29 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Binary-addGlobalDef arg-2 arg-8 (let ((e-13 (vector-ref e-9 12))) e-13) u--as eta-0 eta-1))) (let ((e-24 (vector-ref e-9 6))) e-24) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addUserHole arg-2 1 eta-0 eta-1))) (let ((e-24 (vector-ref e-9 7))) e-24) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 (CoreC-45Context-setNS arg-2 (let ((e-13 (vector-ref e-9 12))) e-13) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((act-32 (cond ((equal? arg-4 1) (CoreC-45Context-setNestedNS arg-2 (let ((e-14 (vector-ref e-9 13))) e-14) ext-0)) (else (vector 1 0))))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (let ((act-33 (let ((sc12 (PreludeC-45Types-elem (csegen-1486) arg-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst (CoreC-45Binary-getNSas eta-0))) (let ((e-19 (vector-ref e-5 19))) e-19))))) (cond ((equal? sc12 1) (vector 1 0)) (else (let ((act-33 (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Binary-addTypeHint arg-2 arg-5 eta-0)) (let ((e-25 (vector-ref e-9 9))) e-25) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-3 (vector-ref act-33 1))) (vector 0 e-3))) (else (let ((act-34 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Binary-addAutoHint arg-2 eta-0 eta-1))) (let ((e-27 (vector-ref e-9 8))) e-27) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-3 (vector-ref act-34 1))) (vector 0 e-3))) (else (let ((act-35 (CoreC-45Context-addImportedInc arg-2 arg-8 (let ((e-31 (vector-ref e-9 5))) e-31) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-3 (vector-ref act-35 1))) (vector 0 e-3))) (else (let ((act-36 (let ((act-36 (unbox arg-2))) (vector 1 act-36)))) (case (vector-ref act-36 0) ((0) (let ((e-3 (vector-ref act-36 1))) (vector 0 e-3))) (else (let ((act-37 (CoreC-45Binary-updatePair arg-2 (let ((e-24 (vector-ref e-9 14))) e-24) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-3 (vector-ref act-37 1))) (vector 0 e-3))) (else (let ((act-38 (CoreC-45Binary-updateRewrite arg-2 (let ((e-24 (vector-ref e-9 15))) e-24) ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-3 (vector-ref act-38 1))) (vector 0 e-3))) (else (let ((act-39 (CoreC-45Binary-updatePrims arg-2 (let ((e-24 (vector-ref e-9 16))) e-24) ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-3 (vector-ref act-39 1))) (vector 0 e-3))) (else (let ((act-40 ((CoreC-45Binary-updateNameDirectives arg-2 (PreludeC-45TypesC-45List-reverse (let ((e-24 (vector-ref e-9 17))) e-24))) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-3 (vector-ref act-40 1))) (vector 0 e-3))) (else (let ((act-41 (CoreC-45Binary-updateCGDirectives arg-2 (let ((e-24 (vector-ref e-9 18))) e-24) ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-3 (vector-ref act-41 1))) (vector 0 e-3))) (else ((CoreC-45Binary-updateTransforms arg-2 (let ((e-24 (vector-ref e-9 19))) e-24)) ext-0))))))))))))))))))))))))))))))))) (case (vector-ref act-33 0) ((0) (let ((e-3 (vector-ref act-33 1))) (vector 0 e-3))) (else (let ((act-34 (cond ((equal? arg-6 1) (vector 1 0)) (else (CoreC-45Context-clearSavedHints arg-2 ext-0))))) (case (vector-ref act-34 0) ((0) (let ((e-3 (vector-ref act-34 1))) (vector 0 e-3))) (else (let ((act-35 (CoreC-45Context-resetFirstEntry arg-2 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-3 (vector-ref act-35 1))) (vector 0 e-3))) (else (let ((act-36 (let ((act-36 (unbox arg-3))) (vector 1 act-36)))) (case (vector-ref act-36 0) ((0) (let ((e-3 (vector-ref act-36 1))) (vector 0 e-3))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (let ((act-37 (set-box! arg-3 (let ((e-0 (vector-ref e-17 0))) (let ((e-1 (vector-ref e-17 1))) (let ((e-25 (vector-ref e-17 2))) (let ((e-3 (vector-ref e-17 3))) (let ((e-4 (vector-ref e-17 4))) (let ((e-24 (vector-ref e-17 5))) (let ((e-23 (vector-ref e-17 6))) (let ((e-22 (vector-ref e-17 7))) (let ((e-20 (vector-ref e-17 9))) (let ((e-19 (vector-ref e-17 10))) (let ((e-18 (vector-ref e-17 11))) (vector e-0 e-1 e-25 e-3 e-4 e-24 e-23 e-22 (let ((e-35 (vector-ref e-9 11))) e-35) e-20 e-19 e-18))))))))))))))) (vector 1 act-37)))) (case (vector-ref act-37 0) ((0) (let ((e-3 (vector-ref act-37 1))) (vector 0 e-3))) (else (vector 1 (box (cons u--ex (cons (let ((e-4 (vector-ref e-9 3))) e-4) (let ((e-29 (vector-ref e-9 10))) e-29)))))))))))))))))))))))))))))))))))))))))))))))) (else (let ((e-8 (vector-ref e-7 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 arg-7 (PreludeC-45TypesC-45String-C-43C-43 ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-8)))) ext-0)))))))))))) (else (vector 1 '()))))))))))
(define CoreC-45Binary-getTotalReq (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-5 "TT2"))) (cond ((equal? sc1 1) (CoreC-45BinaryC-45Prims-corrupt (PreludeC-45TypesC-45String-C-43C-43 "TTC header in " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_String e-5)))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_WastefulInt arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Binary-checkTTCVersion arg-0 e-7 (CoreC-45Binary-ttcVersion) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-1 ext-0)))))))))))))))))
(define CoreC-45Binary-getSaveDefs (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-1) (vector 1 arg-2) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-3 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Binary-getSaveDefs arg-0 e-3 arg-2 arg-3 ext-0) (let ((e-1 (unbox e-5))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((4) (CoreC-45Binary-getSaveDefs arg-0 e-3 arg-2 arg-3 ext-0))(else (let ((act-25 (CoreC-45BinaryC-45Prims-initBinaryS (blodwen-toSignedInt 16384 63) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-26 (vector-ref act-25 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (CoreC-45Context-u--full_HasNames_GlobalDef (let ((e-57 (vector-ref arg-3 0))) e-57) e-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-27 (vector-ref act-26 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-26 1))) (CoreC-45TTC-u--toBuf_TTC_GlobalDef e-26 (CoreC-45Context-u--trimNS_StripNamespace_GlobalDef arg-0 e-27) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-27 (vector-ref act-26 1))) (vector 0 e-27))) (else (let ((act-27 (let ((act-27 (unbox e-26))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-28 (vector-ref act-27 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-27 1))) (CoreC-45Binary-getSaveDefs arg-0 e-3 (cons (cons (CoreC-45Binary-n--10730-10863-u--trimName e-2 e-3 arg-3 arg-2 arg-0 (let ((e-49 (vector-ref e-1 1))) e-49)) e-28) arg-2) arg-3 ext-0))))))))))))))))))))))))))
(define CoreC-45Binary-getNSas (lambda (arg-0) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) (cons e-6 e-11)))))))
(define CoreC-45Binary-getImportHashes (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-5 "TT2"))) (cond ((equal? sc1 1) (CoreC-45BinaryC-45Prims-corrupt (PreludeC-45TypesC-45String-C-43C-43 "TTC header in " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_String e-5)))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_WastefulInt arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Binary-checkTTCVersion arg-0 e-7 (CoreC-45Binary-ttcVersion) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-479) arg-1 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-1 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1415) arg-1 ext-0))))))))))))))))))))))))))
(define CoreC-45Binary-getHashes (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-5 "TT2"))) (cond ((equal? sc1 1) (CoreC-45BinaryC-45Prims-corrupt (PreludeC-45TypesC-45String-C-43C-43 "TTC header in " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_String e-5)))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_WastefulInt arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Binary-checkTTCVersion arg-0 e-7 (CoreC-45Binary-ttcVersion) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-479) arg-1 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-1 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (vector 1 (cons e-10 e-11)))))))))))))))))))))))))))))
(define CoreC-45Binary-checkTTCVersion (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int arg-1 arg-2))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 0 arg-0 arg-1 arg-2)) ext-0)) (else (vector 1 0))))))
(define CoreC-45Binary-addTypeHint (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 (let ((act-24 (CoreC-45Context-getFullName arg-0 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getFullName arg-0 e-2 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "ttc.read" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " for " (CoreC-45Name-u--show_Show_Name e-8))))) clam-0))))))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (CoreC-45Context-addHintFor arg-0 arg-1 e-2 e-6 e-7 1 clam-0)))))))))))
(define CoreC-45Binary-addGlobalDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupContextEntry e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--p) (lambda (eta-0) (let ((act-26 (CoreC-45Context-decode (let ((e-0 (vector-ref e-5 0))) e-0) (Builtin-fst u--p) 0 (Builtin-snd u--p) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (box e-7))))))))) e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((sc4 (CoreC-45Binary-n--11151-11236-u--completeDef e-2 e-3 arg-3 arg-2 arg-1 arg-0 e-7))) (cond ((equal? sc4 1) (vector 1 0)) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addContextEntry arg-0 arg-2 e-2 e-3 eta-0)) ext-0)))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (if (null? arg-3) (vector 1 0) (let ((e-1 (unbox arg-3))) (CoreC-45Context-addContextAlias arg-0 (CoreC-45Name-asName arg-1 e-1 e-2) e-2 ext-0))))))))))))))))))))))
(define CoreC-45Binary-addAutoHint (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-34 (vector-ref e-5 2))) (let ((e-33 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-5 5))) (let ((e-31 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-0 e-1 e-34 e-33 e-4 e-32 e-31 e-7 (LibrariesC-45DataC-45NameMap-insert e-6 e-3 e-8) e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26))))))))))))))
(define CoreC-45UnifyState-case--caseC-32blockC-32inC-32dumpHole-5218 (lambda (arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (if (null? arg-12) (vector 1 0) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (case (vector-ref e-2 0) ((9) (let ((e-4 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 3))) (let ((act-24 (let ((act-24 (CoreC-45Context-getFullName arg-4 (vector 8 arg-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-4 '() arg-9 '() e-3 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toFullNames arg-4 (csegen-76) e-8 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Normalise-normaliseHoles arg-4 '() arg-9 '() e-4 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (cond ((equal? arg-0 "") (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "!" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-7) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-9) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;  = " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-10) "\xa;\x9;when")))))))))) clam-0))) (vector 1 act-28)))(else (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "!" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-7) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-9) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;  = " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-10) "\xa;\x9;when")))))))))))) clam-0))) (vector 1 act-28)))))))))))))))))))))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-n--11597-4784-u--dumpConstraint arg-0 arg-2 arg-3 arg-4 arg-5 eta-0 eta-1))) e-6 clam-0))))))) ((7) (let ((e-8 (vector-ref e-2 2))) (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-4 '() arg-9 '() e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? arg-0 "") (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "?" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-10 1))) e-1)) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5) (let ((sc4 (let ((e-0 (car e-8))) e-0))) (cond ((equal? sc4 1) " (ImplBind)") (else (PreludeC-45TypesC-45String-C-43C-43 "" (let ((sc5 (let ((e-14 (vector-ref arg-10 14))) e-14))) (cond ((equal? sc5 1) " (Invertible)") (else ""))))))))))))))) clam-0))) (vector 1 act-25)))(else (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "?" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-10 1))) e-1)) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5) (let ((sc3 (let ((e-0 (car e-8))) e-0))) (cond ((equal? sc3 1) " (ImplBind)") (else (PreludeC-45TypesC-45String-C-43C-43 "" (let ((sc4 (let ((e-14 (vector-ref arg-10 14))) e-14))) (cond ((equal? sc4 1) " (Invertible)") (else ""))))))))))))))))) clam-0))) (vector 1 act-25)))))))))) ((8) (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-4 '() arg-9 '() e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-4 (csegen-76) e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? arg-0 "") (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "Search " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-6)))))))) clam-0))) (vector 1 act-26)))(else (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "Search " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-6)))))))))) clam-0))) (vector 1 act-26))))))))))))) ((1) (let ((act-24 (CoreC-45Normalise-normalise arg-4 '() arg-9 '() e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normalise arg-4 '() arg-9 '() (vector 1 (CoreC-45FC-emptyFC) (vector 1 ) (vector 8 arg-2)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-4 arg-0 (+ 1 (+ 1 (+ 1 (+ 1 0)))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Solved: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5) (PreludeC-45TypesC-45String-C-43C-43 " = " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-6))))))) clam-0)))))))))) ((10) (let ((act-24 (CoreC-45Normalise-normalise arg-4 '() arg-9 '() e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-4 arg-0 (+ 1 (+ 1 (+ 1 (+ 1 0)))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Bound: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-2) (PreludeC-45TypesC-45String-C-43C-43 " : " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5))))) clam-0)))))) ((11) (let ((act-24 (CoreC-45Normalise-normalise arg-4 '() arg-9 '() e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-4 arg-0 (+ 1 (+ 1 (+ 1 (+ 1 0)))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Delayed elaborator : " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5))) clam-0))))))(else (vector 1 0)))))))))
(define CoreC-45UnifyState-case--dumpHoleC-44dumpConstraint-4807 (lambda (arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (vector 1 0) (let ((e-2 (unbox arg-9))) (case (vector-ref e-2 0) ((2) (cond ((equal? arg-0 "") (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " "\x9;Resolved")))) clam-0))) (vector 1 act-24)))(else (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " "\x9;Resolved")))))) clam-0))) (vector 1 act-24))))) ((0) (let ((e-3 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 3))) (let ((e-6 (vector-ref e-2 4))) (let ((e-7 (vector-ref e-2 5))) (let ((e-8 (vector-ref e-2 6))) (let ((act-24 (let ((act-24 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-4 e-3 arg-8 e-6 e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-4 (csegen-76) e-9 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-4 e-3 arg-8 e-6 e-8 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-4 (csegen-76) e-11 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (cond ((equal? arg-0 "") (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "\x9;  " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-10) (PreludeC-45TypesC-45String-C-43C-43 " =?= " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-12)))))))) clam-0))) (vector 1 act-28)))(else (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "\x9;  " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-10) (PreludeC-45TypesC-45String-C-43C-43 " =?= " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-12)))))))))) clam-0))) (vector 1 act-28)))))))))))))))))))))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((act-25 (CoreC-45Context-clearDefs arg-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-4 e-3 e-10 e-6 e-7 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-4 (csegen-76) e-11 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-4 e-3 e-10 e-6 e-8 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-toFullNames arg-4 (csegen-76) e-13 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) (CoreC-45ContextC-45Log-log arg-4 arg-0 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "\x9;    from " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-12) (PreludeC-45TypesC-45String-C-43C-43 " =?= " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-14) (cond ((equal? e-5 1) "\xa;\x9;(lazy allowed)") (else ""))))))) clam-0)))))))))))))))))))))))))))))) (else (let ((e-9 (vector-ref e-2 1))) (let ((e-12 (vector-ref e-2 4))) (let ((e-13 (vector-ref e-2 5))) (cond ((equal? arg-0 "") (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "\x9;\x9;" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 e-9 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Value-u--showPrec_Show_C-40NFC-32C-36freeC-41 e-9 u--d u--x)))) e-12) (PreludeC-45TypesC-45String-C-43C-43 " =?= " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 e-9 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Value-u--showPrec_Show_C-40NFC-32C-36freeC-41 e-9 u--d u--x)))) e-13)))))))) clam-0))) (vector 1 act-24)))(else (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 "\x9;\x9;" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 e-9 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Value-u--showPrec_Show_C-40NFC-32C-36freeC-41 e-9 u--d u--x)))) e-12) (PreludeC-45TypesC-45String-C-43C-43 " =?= " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 e-9 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Value-u--showPrec_Show_C-40NFC-32C-36freeC-41 e-9 u--d u--x)))) e-13)))))))))) clam-0))) (vector 1 act-24))))))))))))))
(define CoreC-45UnifyState-case--caseC-32blockC-32inC-32checkValidHole-3971 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (case (vector-ref arg-10 0) ((8) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact arg-2 (let ((e-34 (vector-ref e-5 0))) e-34) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-3 (unbox e-6))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-1 (let ((e-36 (vector-ref e-5 0))) e-36) '() e-3 '()) clam-0)))))))))))) ((9) (let ((e-5 (vector-ref arg-10 3))) (if (null? e-5) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-getFullName arg-5 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getRefs (vector 8 -1) (let ((e-2 (vector-ref arg-8 2))) e-2))) '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-n--10584-3902-u--checkRef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0 eta-1))) e-6 clam-0))))) (let ((e-7 (car e-5))) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((sc3 (LibrariesC-45DataC-45IntMap-lookup e-7 (let ((e-16 (vector-ref e-6 4))) e-16)))) (if (null? sc3) (vector 1 0) (let ((e-1 (unbox sc3))) (case (vector-ref e-1 0) ((0) (let ((e-0 (vector-ref e-1 1))) (let ((e-12 (vector-ref e-1 2))) (let ((e-11 (vector-ref e-1 4))) (let ((e-10 (vector-ref e-1 5))) (let ((e-9 (vector-ref e-1 6))) (let ((act-25 (let ((act-25 (set-box! arg-4 (let ((e-24 (vector-ref e-6 0))) (let ((e-22 (vector-ref e-6 2))) (let ((e-21 (vector-ref e-6 3))) (let ((e-20 (vector-ref e-6 4))) (let ((e-19 (vector-ref e-6 5))) (let ((e-18 (vector-ref e-6 6))) (let ((e-17 (vector-ref e-6 7))) (let ((e-16 (vector-ref e-6 8))) (let ((e-15 (vector-ref e-6 9))) (let ((e-14 (vector-ref e-6 10))) (let ((e-13 (vector-ref e-6 11))) (vector e-24 (LibrariesC-45DataC-45IntMap-empty) e-22 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((act-26 (CoreC-45Context-clearDefs arg-6 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-14 (vector-ref act-26 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-5 e-0 e-14 e-11 e-10 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-15 (vector-ref act-27 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-5 e-0 e-14 e-11 e-9 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-16 (vector-ref act-28 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-28 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 2 e-0 e-12 (let ((e-47 (vector-ref arg-6 0))) e-47) e-11 e-15 e-16) clam-0)))))))))))))))))))))) ((1) (let ((e-13 (vector-ref e-1 1))) (let ((e-12 (vector-ref e-1 2))) (let ((e-11 (vector-ref e-1 3))) (let ((e-9 (vector-ref e-1 4))) (let ((e-10 (vector-ref e-1 5))) (if (null? e-9) (vector 1 0) (let ((e-15 (car e-9))) (if (null? e-10) (vector 1 0) (let ((e-17 (car e-10))) (let ((act-25 (let ((act-25 (set-box! arg-4 (let ((e-0 (vector-ref e-6 0))) (let ((e-2 (vector-ref e-6 2))) (let ((e-26 (vector-ref e-6 3))) (let ((e-25 (vector-ref e-6 4))) (let ((e-24 (vector-ref e-6 5))) (let ((e-23 (vector-ref e-6 6))) (let ((e-22 (vector-ref e-6 7))) (let ((e-21 (vector-ref e-6 8))) (let ((e-20 (vector-ref e-6 9))) (let ((e-19 (vector-ref e-6 10))) (let ((e-18 (vector-ref e-6 11))) (vector e-0 (LibrariesC-45DataC-45IntMap-empty) e-2 e-26 e-25 e-24 e-23 e-22 e-21 e-20 e-19 e-18))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-clearDefs arg-6 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-5 e-13 e-19 e-11 e-15 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-5 e-13 e-19 e-11 e-17 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-28 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 2 e-13 e-12 (let ((e-0 (vector-ref arg-6 0))) e-0) e-11 e-20 e-21) clam-0))))))))))))))))))))))))))(else (vector 1 0))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-getFullName arg-5 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getRefs (vector 8 -1) (let ((e-2 (vector-ref arg-8 2))) e-2))) '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-n--10584-3902-u--checkRef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0 eta-1))) e-5 clam-0))))))))))
(define CoreC-45UnifyState-n--7239-839-u--tag (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-2 0) 1) ((equal? arg-2 1) 2) ((equal? arg-2 4) 3) ((equal? arg-2 2) 4) (else 5))))
(define CoreC-45UnifyState-n--11380-4572-u--nameEq (lambda (arg-0 arg-1 arg-2 arg-3 arg-6 arg-7) (let ((e-3 (cdr arg-6))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr arg-7))) (let ((e-15 (cdr e-11))) (CoreC-45Name-u--C-61C-61_Eq_Name e-7 e-15)))))))
(define CoreC-45UnifyState-n--10139-3489-u--envArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-0 0 arg-5 arg-3 '())))) u--args)))
(define CoreC-45UnifyState-n--10048-3400-u--envArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-0 0 arg-7 arg-3 '())))) u--args)))
(define CoreC-45UnifyState-n--9931-3280-u--envArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-1 1 arg-6 arg-4 '())))) u--args)))
(define CoreC-45UnifyState-n--9642-3022-u--envArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-3 arg-0 arg-8 arg-6 '())))) u--args)))
(define CoreC-45UnifyState-n--11597-4784-u--dumpConstraint (lambda (arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-4))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45UnifyState-case--dumpHoleC-44dumpConstraint-4807 arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-6 (LibrariesC-45DataC-45IntMap-lookup arg-6 (let ((e-4 (vector-ref e-5 4))) e-4))) ext-0)))))))))))
(define CoreC-45UnifyState-n--10584-3902-u--checkRef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((3) (let ((e-0 (vector-ref arg-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "Hole cannot depend on an unbound implicit " (CoreC-45Name-u--show_Show_Name e-0))) ext-0)))(else (vector 1 0)))))
(define CoreC-45UnifyState-u--compare_Ord_DelayReason (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45UnifyState-n--7239-839-u--tag arg-1 arg-0 arg-0) (CoreC-45UnifyState-n--7239-839-u--tag arg-1 arg-0 arg-1))))
(define CoreC-45UnifyState-u--C-61C-61_Eq_DelayReason (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0))) ((equal? arg-0 4) (cond ((equal? arg-1 4) 1)(else 0)))(else 0))))
(define CoreC-45UnifyState-tryUnify (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45UnifyState-tryErrorUnify arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (vector 1 e-2))) (else (arg-4 ext-0)))))))))
(define CoreC-45UnifyState-tryErrorUnify (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-branch arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-26 (arg-3 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-commit arg-1 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (vector 1 e-7)))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-26 (let ((act-26 (set-box! arg-2 e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-32 (vector-ref e-6 7))) (let ((e-31 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 (let ((e-38 (vector-ref e-8 27))) e-38) e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (vector 0 u--err)))))))))))))) ext-0)))))))))))
(define CoreC-45UnifyState-saveHoles (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 (LibrariesC-45DataC-45IntMap-empty) e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))))))))
(define CoreC-45UnifyState-restoreHoles (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 arg-1 e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-resetNextVar (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 0 e-9 e-10 e-11))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-removeNoSolve (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 (LibrariesC-45DataC-45IntMap-delete arg-1 e-12) e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-removeHoleName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (CoreC-45Context-getNameID arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)))) (if (null? sc1) (vector 1 0) (let ((e-1 (unbox sc1))) (CoreC-45UnifyState-removeHole arg-1 e-1 ext-0))))))))))
(define CoreC-45UnifyState-removeHole (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector (LibrariesC-45DataC-45IntMap-delete arg-1 e-0) e-1 (LibrariesC-45DataC-45IntMap-delete arg-1 e-2) (LibrariesC-45DataC-45IntMap-delete arg-1 e-3) e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-removeGuess (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 (LibrariesC-45DataC-45IntMap-delete arg-1 e-1) e-2 e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-newSearch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--hty (CoreC-45Env-abstractEnvType arg-0 arg-3 arg-7 arg-9))) (let ((u--hole (CoreC-45Context-newDef arg-3 arg-8 arg-4 '() u--hty 2 (vector 8 arg-4 arg-5 arg-6)))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "unify.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Adding new search " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name arg-8))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Normalise-logTermNF '() arg-1 "unify.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "New search type") '() u--hty eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-addDef arg-1 arg-8 u--hole eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-addGuessName arg-2 arg-3 arg-8 e-7 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (cons e-7 (vector 2 arg-3 arg-8 e-7 (CoreC-45UnifyState-n--10048-3400-u--envArgs arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1))))))))))))))))))))))
(define CoreC-45UnifyState-newMetaLets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--hty (cond ((equal? arg-10 1) (CoreC-45Env-abstractFullEnvType arg-0 arg-3 arg-5 arg-7)) (else (CoreC-45Env-abstractEnvType arg-0 arg-3 arg-5 arg-7))))) (let ((u--hole (let ((sc0 (CoreC-45Context-newDef arg-3 arg-6 arg-4 '() u--hty 2 arg-8))) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-2 (vector-ref sc0 2))) (let ((e-3 (vector-ref sc0 3))) (let ((e-4 (vector-ref sc0 4))) (let ((e-5 (vector-ref sc0 5))) (let ((e-6 (vector-ref sc0 6))) (let ((e-7 (vector-ref sc0 7))) (let ((e-8 (vector-ref sc0 8))) (let ((e-9 (vector-ref sc0 9))) (let ((e-10 (vector-ref sc0 10))) (let ((e-11 (vector-ref sc0 11))) (let ((e-12 (vector-ref sc0 12))) (let ((e-13 (vector-ref sc0 13))) (let ((e-14 (vector-ref sc0 14))) (let ((e-16 (vector-ref sc0 16))) (let ((e-17 (vector-ref sc0 17))) (let ((e-18 (vector-ref sc0 18))) (let ((e-19 (vector-ref sc0 19))) (let ((e-20 (vector-ref sc0 20))) (let ((e-21 (vector-ref sc0 21))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 arg-9 e-16 e-17 e-18 e-19 e-20 e-21))))))))))))))))))))))))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "unify.meta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Adding new meta " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1499) (cons arg-6 (cons arg-3 arg-4))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTerm '() arg-1 "unify.meta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "New meta type " (CoreC-45Name-u--show_Show_Name arg-6))) u--hty eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-addDef arg-1 arg-6 u--hole eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45UnifyState-addHoleName arg-2 arg-3 arg-6 e-8 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (cons e-8 (vector 2 arg-3 arg-6 e-8 (CoreC-45UnifyState-n--9642-3022-u--envArgs arg-10 arg-9 arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1)))))))))))))))))))))))))
(define CoreC-45UnifyState-newMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (CoreC-45UnifyState-newMetaLets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 0)))
(define CoreC-45UnifyState-newDelayed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((u--hty (CoreC-45Env-abstractEnvType arg-0 arg-3 arg-5 arg-7))) (let ((u--hole (CoreC-45Context-newDef arg-3 arg-6 arg-4 '() u--hty 2 (vector 11 )))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-addDef arg-2 arg-6 u--hole eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-2 "unify.delay" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Added delayed elaborator " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1506) (cons arg-6 e-5)))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45UnifyState-addHoleName arg-1 arg-3 arg-6 e-5 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (cons e-5 (vector 2 arg-3 arg-6 e-5 (CoreC-45UnifyState-n--10139-3489-u--envArgs arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1)))))))))))))))))))
(define CoreC-45UnifyState-newConstant (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((u--def (CoreC-45UnifyState-mkConstant arg-0 arg-3 arg-5 arg-6))) (let ((u--defty (CoreC-45Env-abstractFullEnvType arg-0 arg-3 arg-5 arg-7))) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genName arg-2 arg-1 "postpone" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--guess (CoreC-45Context-newDef arg-3 e-5 arg-4 '() u--defty 2 (vector 9 u--def (CoreC-45Env-length arg-5) arg-8)))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-2 "unify.constant" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Adding new constant " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1499) (cons e-5 (cons arg-3 arg-4))))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-logTerm '() arg-2 "unify.constant" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "New constant type " (CoreC-45Name-u--show_Show_Name e-5))) u--defty eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-addDef arg-2 e-5 u--guess eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45UnifyState-addGuessName arg-1 arg-3 e-5 e-8 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-3 e-5 e-8 (CoreC-45UnifyState-n--9931-3280-u--envArgs arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1))))))))))))))))))))))))))
(define CoreC-45UnifyState-mkConstantAppArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-4))) (let ((e-9 (cdr arg-4))) (let ((u--rec (CoreC-45UnifyState-mkConstantAppArgs e-3 arg-2 arg-3 e-9 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (cons e-2 '()))))) (let ((sc2 (cond ((equal? arg-2 1) 1) (else (let ((sc4 (CoreC-45TT-isLet e-8))) (cond ((equal? sc4 1) 0) (else 1))))))) (cond ((equal? sc2 1) (cons (vector 0 arg-3 (box (CoreC-45TT-isLet e-8)) (PreludeC-45TypesC-45List-length arg-5)) u--rec)) (else u--rec)))))))))))
(define CoreC-45UnifyState-mkConstant (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (let ((u--ty (CoreC-45TT-binderType e-8))) (CoreC-45UnifyState-mkConstant e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 0 arg-1 (CoreC-45TT-multiplicity e-8) (vector 1 ) u--ty) arg-3))))))))))
(define CoreC-45UnifyState-isCurrentHole (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) 1)) (LibrariesC-45DataC-45IntMap-lookup arg-1 (let ((e-2 (vector-ref e-5 2))) e-2))))))))))
(define CoreC-45UnifyState-initUState(blodwen-lazy (lambda () (vector (LibrariesC-45DataC-45IntMap-empty) (LibrariesC-45DataC-45IntMap-empty) (LibrariesC-45DataC-45IntMap-empty) (LibrariesC-45DataC-45IntMap-empty) (LibrariesC-45DataC-45IntMap-empty) (LibrariesC-45DataC-45IntMap-empty) '() '() 0 0 '() 0))))
(define CoreC-45UnifyState-handleUnify (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45UnifyState-tryErrorUnify arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (vector 1 e-2))) (else (let ((e-6 (vector-ref e-5 1))) ((arg-4 e-6) ext-0))))))))))
(define CoreC-45UnifyState-getHoles (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-0 (vector-ref e-5 0))) e-0))))))))
(define CoreC-45UnifyState-getGuesses (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-1 (vector-ref e-5 1))) e-1))))))))
(define CoreC-45UnifyState-getCurrentHoles (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2))))))))
(define CoreC-45UnifyState-genWithName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45Context-inCurrentNS arg-0 (vector 7 arg-2 (let ((e-8 (vector-ref e-5 8))) e-8)) ext-0))))))))))
(define CoreC-45UnifyState-genVarName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-2 (let ((e-8 (vector-ref e-5 8))) e-8))))))))))))
(define CoreC-45UnifyState-genName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-inCurrentNS arg-0 (vector 2 arg-2 (let ((e-8 (vector-ref e-5 8))) e-8)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 e-7))))))))))))))
(define CoreC-45UnifyState-genMVName (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (CoreC-45UnifyState-genName arg-0 arg-1 (CoreC-45Name-displayUserName e-0) clam-0))) ((2) (let ((e-1 (vector-ref arg-2 1))) (CoreC-45UnifyState-genName arg-0 arg-1 e-1 clam-0)))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-inCurrentNS arg-0 (vector 2 (CoreC-45Name-u--show_Show_Name arg-2) (let ((e-8 (vector-ref e-5 8))) e-8)) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 e-7)))))))))))))))))
(define CoreC-45UnifyState-genCaseName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45Context-inCurrentNS arg-0 (vector 6 arg-2 (let ((e-8 (vector-ref e-5 8))) e-8)) ext-0))))))))))
(define CoreC-45UnifyState-dumpHole (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-5) (let ((e-0 (vector-ref e-8 0))) e-0)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (if (null? e-9) (vector 1 0) (let ((e-2 (unbox e-9))) (let ((bind-0 (box e-2))) ((CoreC-45UnifyState-case--caseC-32blockC-32inC-32dumpHole-5218 arg-2 arg-5 arg-4 arg-1 arg-0 e-5 e-6 e-7 e-8 e-2 bind-0 (cons (let ((e-17 (vector-ref e-2 17))) e-17) (let ((e-27 (vector-ref e-2 2))) e-27))) ext-0))))))))))))))))))))))))))
(define CoreC-45UnifyState-dumpConstraints (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? e-8 1) (((let ((u--hs (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1)) (LibrariesC-45DataC-45IntMap-toList (cond ((equal? arg-5 1) (let ((e-0 (vector-ref e-5 0))) e-0)) (else (let ((e-2 (vector-ref e-5 2))) e-2))))))) (lambda () (lambda (clam-0) (let ((sc5 (DataC-45List-isNil u--hs))) (cond ((equal? sc5 1) (vector 1 0)) (else (let ((act-28 (cond ((equal? arg-2 "") (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " "--- CONSTRAINTS AND HOLES ---")))) clam-0))) (vector 1 act-28)))(else (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " "--- CONSTRAINTS AND HOLES ---")))))) clam-0))) (vector 1 act-28)))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-dumpHole arg-0 arg-1 arg-2 arg-4 eta-0 eta-1))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--hs) clam-0))))))))))) ext-0)) (else (vector 1 0)))))))))))))))))))
(define CoreC-45UnifyState-deleteConstraint (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 (LibrariesC-45DataC-45IntMap-delete arg-1 e-4) e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-checkValidHole (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-2 arg-2))) (cond ((equal? sc2 1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (if (null? e-9) (vector 1 0) (let ((e-1 (unbox e-9))) (let ((_-0 (box e-1))) ((CoreC-45UnifyState-case--caseC-32blockC-32inC-32checkValidHole-3971 e-2 e-6 e-7 arg-2 arg-1 arg-0 e-5 e-8 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17)) clam-0))))))))))))))))) (else (vector 1 0)))))))))))
(define CoreC-45UnifyState-checkUserHolesAfter (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45UnifyState-getGuesses arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--gs (LibrariesC-45DataC-45IntMap-toList e-5))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "unify.unsolved" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Unsolved guesses " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1510) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1510) u--d u--x)))) u--gs))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45UnifyState-checkValidHole arg-1 arg-0 arg-2 eta-0)) u--gs ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45UnifyState-getCurrentHoles arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--hs (LibrariesC-45DataC-45IntMap-toList e-8))) (let ((u--hsC-39 (let ((sc4 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CoreC-45Name-isUserName eta-0)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd (Builtin-snd eta-0))) u--hs)))) (cond ((equal? sc4 1) '()) (else u--hs))))) (let ((act-28 (let ((sc4 (cond ((equal? arg-3 1) (let ((sc6 (DataC-45List-isNil u--hsC-39))) (cond ((equal? sc6 1) 0) (else 1)))) (else 0)))) (cond ((equal? sc4 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 31 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-nubBy (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-n--11380-4572-u--nameEq arg-3 arg-2 arg-1 arg-0 eta-0 eta-1))) u--hs))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-addDelayedHoleName arg-0 eta-0 eta-1))) u--hsC-39 ext-0)))))))))))))))))))))))
(define CoreC-45UnifyState-checkDelayedHoles (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--hs (LibrariesC-45DataC-45IntMap-toList (let ((e-3 (vector-ref e-5 3))) e-3)))) (let ((sc1 (DataC-45List-isNil u--hs))) (cond ((equal? sc1 1) (vector 1 '())) (else (vector 1 (box (vector 31 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) u--hs))))))))))))))
(define CoreC-45UnifyState-applyToFull (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-0 1 arg-1 arg-3 '())))) (CoreC-45TT-apply arg-1 arg-2 u--args))))
(define CoreC-45UnifyState-applyTo (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-0 0 arg-1 arg-3 '())))) (CoreC-45TT-apply arg-1 arg-2 u--args))))
(define CoreC-45UnifyState-addPolyConstraint (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-5 0) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((u--x (vector 1 e-1 (vector 2 e-5 e-6 e-7) e-3))) (let ((e-0 (vector-ref e-8 0))) (let ((e-18 (vector-ref e-8 1))) (let ((e-17 (vector-ref e-8 2))) (let ((e-16 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-15 (vector-ref e-8 5))) (let ((e-14 (vector-ref e-8 6))) (let ((e-13 (vector-ref e-8 7))) (let ((e-12 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (vector e-0 e-18 e-17 e-16 e-4 e-15 (cons (vector arg-0 arg-2 arg-3 arg-4 u--x arg-6) e-14) e-13 e-12 e-9 e-10 e-11))))))))))))))))) (vector 1 act-25))))))))))(else (vector 1 0)))))))(else (vector 1 0))))))
(define CoreC-45UnifyState-addNoSolve (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 (LibrariesC-45DataC-45IntMap-insert arg-1 0 e-12) e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-addHoleName (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector (LibrariesC-45DataC-45IntMap-insert arg-3 (cons arg-1 arg-2) e-0) e-1 (LibrariesC-45DataC-45IntMap-insert arg-3 (cons arg-1 arg-2) e-2) e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-addGuessName (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 (LibrariesC-45DataC-45IntMap-insert arg-3 (cons arg-1 arg-2) e-1) e-2 e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-25))))))))
(define CoreC-45UnifyState-addDot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-6 arg-4 arg-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-6 arg-4 arg-8) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-15 (vector-ref e-5 5))) (let ((e-14 (vector-ref e-5 6))) (let ((e-13 (vector-ref e-5 7))) (let ((e-12 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-15 e-14 (cons (cons arg-5 (cons arg-7 (vector 0 arg-0 arg-3 0 arg-4 e-7 e-8))) e-13) e-12 e-9 e-10 e-11)))))))))))))))) (vector 1 act-28))))))))))))))))))))
(define CoreC-45UnifyState-addDelayedHoleName (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-14 (vector-ref e-5 2))) (let ((e-13 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-14 (LibrariesC-45DataC-45IntMap-insert e-2 e-3 e-13) e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-25))))))))))
(define CoreC-45UnifyState-addConstraint (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--cid (let ((e-9 (vector-ref e-5 9))) e-9))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 (LibrariesC-45DataC-45IntMap-insert u--cid arg-2 e-4) e-12 e-6 e-7 e-8 (bs+ u--cid 1 63) e-10 e-11))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 u--cid)))))))))))
(define ParserC-45Unlit-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32isLitLine-4084 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (let ((sc1 (LibrariesC-45TextC-45Literate-isLiterateLine (ParserC-45Unlit-styleTeX) arg-0))) (if (null? sc1) (cons '() arg-0) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (if (null? e-2) (cons '() arg-0) (let ((e-5 (unbox e-2))) (cons (box e-5) e-3))))))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-2) (let ((sc2 (LibrariesC-45TextC-45Literate-isLiterateLine (ParserC-45Unlit-styleTeX) arg-0))) (if (null? sc2) (cons '() arg-0) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (if (null? e-5) (cons '() arg-0) (let ((e-6 (unbox e-5))) (cons (box e-6) e-4))))))) (let ((e-5 (unbox e-2))) (cons (box e-5) e-3))))))))
(define ParserC-45Unlit-case--caseC-32blockC-32inC-32isLitLine-4059 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (ParserC-45Unlit-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32isLitLine-4084 arg-0 arg-1 arg-2 (LibrariesC-45TextC-45Literate-isLiterateLine (ParserC-45Unlit-styleCMark) arg-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-2) (ParserC-45Unlit-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32isLitLine-4084 arg-0 arg-1 arg-2 (LibrariesC-45TextC-45Literate-isLiterateLine (ParserC-45Unlit-styleCMark) arg-0)) (let ((e-5 (unbox e-2))) (cons (box e-5) e-3))))))))
(define ParserC-45Unlit-case--isLitLine-4038 (lambda (arg-0 arg-1) (if (null? arg-1) (ParserC-45Unlit-case--caseC-32blockC-32inC-32isLitLine-4059 arg-0 arg-1 (LibrariesC-45TextC-45Literate-isLiterateLine (ParserC-45Unlit-styleOrg) arg-0)) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-2) (ParserC-45Unlit-case--caseC-32blockC-32inC-32isLitLine-4059 arg-0 arg-1 (LibrariesC-45TextC-45Literate-isLiterateLine (ParserC-45Unlit-styleOrg) arg-0)) (let ((e-5 (unbox e-2))) (cons (box e-5) e-3))))))))
(define ParserC-45Unlit-n--2731-3964-u--isStyle (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (ParserC-45Unlit-n--2731-3963-u--hasSuffix arg-0 eta-0)) (let ((e-2 (vector-ref arg-1 2))) e-2)))) (cond ((equal? sc0 1) (box arg-1)) (else '())))))
(define ParserC-45Unlit-n--2731-3963-u--hasSuffix (lambda (arg-0 arg-1) (DataC-45String-isSuffixOf arg-1 arg-0)))
(define ParserC-45Unlit-unlit (lambda (arg-0 arg-1) (if (null? arg-0) (vector 1 arg-1) (let ((e-2 (unbox arg-0))) (LibrariesC-45TextC-45Literate-unlit e-2 arg-1)))))
(define ParserC-45Unlit-styleTeX(blodwen-lazy (lambda () (vector (cons (cons "\\begin{code}" "\\end{code}") (cons (cons "\\begin{hidden}" "\\end{hidden}") '())) '() (cons ".tex" (cons ".ltx" '()))))))
(define ParserC-45Unlit-styleOrg(blodwen-lazy (lambda () (vector (cons (cons "#+BEGIN_SRC idris" "#+END_SRC") (cons (cons "#+begin_src idris" "#+end_src") (cons (cons "#+BEGIN_COMMENT idris" "#+END_COMMENT") (cons (cons "#+begin_comment idris" "#+end_comment") '())))) (cons "#+IDRIS:" '()) (cons ".org" '())))))
(define ParserC-45Unlit-styleCMark(blodwen-lazy (lambda () (vector (cons (cons "```idris" "```") (cons (cons "~~~idris" "~~~") (cons (cons "<!-- idris" "-->") '()))) '() (cons ".md" (cons ".markdown" '()))))))
(define ParserC-45Unlit-styleBird(blodwen-lazy (lambda () (vector '() (cons ">" (cons "<" '())) (cons ".lidr" '())))))
(define ParserC-45Unlit-relit (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (unbox arg-0))) (DataC-45String-unwords (cons e-2 (cons arg-1 '())))))))
(define ParserC-45Unlit-isLitLine (lambda (arg-0) (ParserC-45Unlit-case--isLitLine-4038 arg-0 (LibrariesC-45TextC-45Literate-isLiterateLine (ParserC-45Unlit-styleBird) arg-0))))
(define ParserC-45Unlit-isLitFile (lambda (arg-0) (let ((sc0 (ParserC-45Unlit-n--2731-3964-u--isStyle arg-0 (ParserC-45Unlit-styleBird)))) (if (null? sc0) (let ((sc1 (ParserC-45Unlit-n--2731-3964-u--isStyle arg-0 (ParserC-45Unlit-styleOrg)))) (if (null? sc1) (let ((sc2 (ParserC-45Unlit-n--2731-3964-u--isStyle arg-0 (ParserC-45Unlit-styleCMark)))) (if (null? sc2) (ParserC-45Unlit-n--2731-3964-u--isStyle arg-0 (ParserC-45Unlit-styleTeX)) (let ((e-1 (unbox sc2))) (box e-1)))) (let ((e-1 (unbox sc1))) (box e-1)))) (let ((e-1 (unbox sc0))) (box e-1))))))
(define LibrariesC-45TextC-45Literate-with--isLiterateLine-4341 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-2) (cons '() arg-2) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-8 (vector-ref e-5 0))) (case (vector-ref e-8 0) ((2) (let ((e-11 (vector-ref e-8 1))) (let ((e-12 (vector-ref e-8 2))) (if (null? e-6) (if (null? e-3) (cons '() arg-2) (let ((e-17 (cdr e-3))) (if (null? e-17) (cons '() arg-2) (let ((e-21 (cdr e-17))) (cond ((equal? e-21 "") (cons (box e-11) e-12))(else (cons '() arg-2))))))) (cons '() arg-2)))))(else (cons '() arg-2)))))))))))
(define LibrariesC-45TextC-45Literate-with--withC-32blockC-32inC-32reduce-4198 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-0) (case (vector-ref arg-1 0) ((0) (LibrariesC-45TextC-45Literate-reduce arg-6 arg-5))(else (let ((e-2 (vector-ref arg-1 2))) (LibrariesC-45TextC-45Literate-reduce arg-6 (cons (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45StringC-45Extra-unlines e-2) "\xa;") (cons "\xa;" arg-5)))))) (let ((e-2 (vector-ref arg-1 2))) (LibrariesC-45TextC-45Literate-reduce arg-6 (cons (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45StringC-45Extra-unlines e-2) "\xa;") (cons "\xa;" arg-5)))))))
(define LibrariesC-45TextC-45Literate-with--reduce-4189 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (LibrariesC-45TextC-45Literate-with--withC-32blockC-32inC-32reduce-4198 e-2 (DataC-45ListC-45Views-snocList e-2) arg-2 arg-3 e-1 arg-7 arg-6 arg-5 arg-4 arg-0)))))
(define LibrariesC-45TextC-45Literate-case--extractCode-4276 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cond ((equal? e-11 "") (vector 1 (LibrariesC-45TextC-45Literate-reduce e-2 '())))(else (vector 0 (vector e-6 e-10 e-11))))))))))))
(define LibrariesC-45TextC-45Literate-untilEOL(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-manyUntil (LibrariesC-45TextC-45Lexer-newline) (LibrariesC-45TextC-45Lexer-any)))))
(define LibrariesC-45TextC-45Literate-unlit (lambda (ext-0 ext-1) (LibrariesC-45TextC-45Literate-extractCode ext-0 ext-1)))
(define LibrariesC-45TextC-45Literate-reduce (lambda (arg-0 arg-1) (if (null? arg-0) (DataC-45String-fastAppend (PreludeC-45TypesC-45List-reverse arg-1)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-5 (vector-ref e-2 0))) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (case (vector-ref e-5 0) ((1) (let ((e-8 (vector-ref e-5 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-8 "\xa;"))) (cond ((equal? sc2 1) (LibrariesC-45TextC-45Literate-reduce e-3 (cons "\xa;" arg-1))) (else (LibrariesC-45TextC-45Literate-reduce e-3 arg-1)))))) ((2) (let ((e-9 (vector-ref e-5 1))) (let ((e-10 (vector-ref e-5 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-9 (DataC-45String-trim e-10)))) (cond ((equal? sc2 1) (LibrariesC-45TextC-45Literate-reduce e-3 (cons "\xa;" arg-1))) (else (LibrariesC-45TextC-45Literate-reduce e-3 (cons (PreludeC-45Types-substr (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45TypesC-45String-length e-9) (+ 1 0)) (PreludeC-45TypesC-45String-length e-10) e-10) arg-1)))))))) (else (let ((e-11 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (let ((e-13 (vector-ref e-5 3))) (LibrariesC-45TextC-45Literate-with--reduce-4189 e-13 (LibrariesC-45DataC-45StringC-45Extra-lines e-13) e-6 e-7 e-12 e-11 e-3 arg-1))))))))))))))
(define LibrariesC-45TextC-45Literate-rawTokens (lambda (arg-0 arg-1) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (LibrariesC-45TextC-45Literate-block e-2 e-3) (lambda (eta-0) (vector 0 (DataC-45String-trim e-2) (DataC-45String-trim e-3) eta-0)))))) arg-0) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--m) (cons (LibrariesC-45TextC-45Literate-line u--m) (lambda (eta-0) (vector 2 (DataC-45String-trim u--m) eta-0)))) arg-1) (cons (cons (LibrariesC-45TextC-45Literate-notCodeLine) (lambda (eta-0) (vector 1 eta-0))) '())))))
(define LibrariesC-45TextC-45Literate-notCodeLine(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-newline) (vector 4 (LibrariesC-45TextC-45Lexer-any) (lambda () (LibrariesC-45TextC-45Literate-untilEOL)))))))
(define LibrariesC-45TextC-45Literate-line (lambda (arg-0) (vector 4 (LibrariesC-45TextC-45Lexer-exact arg-0) (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-newline) (vector 4 (LibrariesC-45TextC-45Lexer-space) (lambda () (LibrariesC-45TextC-45Literate-untilEOL))))))))
(define LibrariesC-45TextC-45Literate-isLiterateLine (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45Literate-with--isLiterateLine-4341 e-1 e-0 arg-1 (LibrariesC-45TextC-45LexerC-45Core-lex (LibrariesC-45TextC-45Literate-rawTokens e-0 e-1) arg-1) e-2))))))
(define LibrariesC-45TextC-45Literate-extractCode (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45Literate-case--extractCode-4276 e-2 e-1 e-0 arg-1 (LibrariesC-45TextC-45LexerC-45Core-lex (LibrariesC-45TextC-45Literate-rawTokens e-0 e-1) arg-1)))))))
(define LibrariesC-45TextC-45Literate-block (lambda (arg-0 arg-1) (LibrariesC-45TextC-45Lexer-surround (vector 4 (LibrariesC-45TextC-45Lexer-exact arg-0) (lambda () (LibrariesC-45TextC-45Literate-untilEOL))) (vector 4 (LibrariesC-45TextC-45Lexer-exact arg-1) (lambda () (LibrariesC-45TextC-45Literate-untilEOL))) (LibrariesC-45TextC-45Lexer-any))))
(define DataC-45ListC-45Views-snocListHelp (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) arg-2 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (DataC-45ListC-45Views-snocListHelp (PreludeC-45TypesC-45List-tailRecAppend arg-1 (cons e-2 '())) (vector 1 e-2 arg-1 arg-2) e-3))))))
(define DataC-45ListC-45Views-snocList (lambda (arg-1) (DataC-45ListC-45Views-snocListHelp '() (vector 0 ) arg-1)))
(define ParserC-45RuleC-45Source-case--isCapitalisedIdent-3922 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-1 "") (if (null? arg-4) arg-3 (let ((e-0 (car arg-4))) (let ((sc3 (let ((sc4 (PreludeC-45Types-isUpper e-0))) (cond ((equal? sc4 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char e-0 (PreludeC-45Types-chr (blodwen-toSignedInt 160 63)))))))) (cond ((equal? sc3 1) (vector 0 0)) (else arg-3))))))(else (let ((e-0 (car arg-4))) (let ((sc1 (let ((sc2 (PreludeC-45Types-isUpper e-0))) (cond ((equal? sc2 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char e-0 (PreludeC-45Types-chr (blodwen-toSignedInt 160 63)))))))) (cond ((equal? sc1 1) (vector 0 0)) (else arg-3))))))))
(define ParserC-45RuleC-45Source-n--9075-5308-u--restOfBlock (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (vector 0 ) arg-2) (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons '() u--ps)))))) (let ((e-1 (unbox arg-5))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries e-6 arg-2) (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons (box e-5) u--ps))))))))))))
(define ParserC-45RuleC-45Source-n--8054-4289-u--opNS (lambda (arg-0 arg-1) (vector 12 0 1 (ParserC-45RuleC-45Source-isCapitalisedIdent (PreludeC-45Interfaces-C-60C-36C-62 (csegen-360) (lambda (eta-0) (Builtin-snd eta-0)) arg-1)) (let ((u--ns (PreludeC-45Basics-uncurry (csegen-269) (let ((e-1 (vector-ref arg-1 0))) e-1)))) (vector 11 1 (ParserC-45RuleC-45Source-symbol ".(") (lambda () (vector 9 1 (vector 13 1 1 (ParserC-45RuleC-45Source-operator) (lambda () (ParserC-45RuleC-45Source-postfixProj))) (lambda () (lambda (u--n) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 (vector 0 u--ns u--n)))))))))))))
(define ParserC-45RuleC-45Source-n--8054-4288-u--nameNS (lambda (arg-0 arg-1) (let ((u--id (PreludeC-45Interfaces-C-60C-36C-62 (csegen-360) (lambda (eta-0) (Builtin-snd eta-0)) arg-1))) (vector 12 0 0 (ParserC-45RuleC-45Source-identWithCapital arg-0 u--id) (vector 12 0 0 (ParserC-45RuleC-45Source-isNotReservedName u--id) (vector 0 (PreludeC-45Basics-uncurry (lambda (eta-0) (lambda (eta-1) (CoreC-45Name-mkNamespacedName eta-0 eta-1))) (let ((e-1 (vector-ref arg-1 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (cons e-5 (vector 0 e-4))))))))))))
(define ParserC-45RuleC-45Source-n--6961-3249-u--isEOI (lambda (arg-0) (case (vector-ref arg-0 0) ((17) 1)(else 0))))
(define ParserC-45RuleC-45Source-n--8607-4832-u--afterSemi (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (vector 0 )) ((1) (let ((e-0 (vector-ref arg-2 1))) (vector 2 e-0))) ((2) (let ((e-1 (vector-ref arg-2 1))) (vector 2 e-1))) (else (vector 3 )))))
(define ParserC-45RuleC-45Source-n--8607-4833-u--afterDedent (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-3 arg-0))) (cond ((equal? sc1 1) (vector 0 (vector 0 ))) (else (vector 4 '() 0 "Not the end of a block entry"))))) ((2) (let ((e-0 (vector-ref arg-2 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-3 arg-0))) (cond ((equal? sc1 1) (vector 0 (vector 1 e-0))) (else (vector 4 '() 0 "Not the end of a block entry")))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-3 arg-0))) (cond ((equal? sc1 1) (vector 0 (vector 1 e-1))) (else (vector 4 '() 0 "Not the end of a block entry")))))) (else (vector 0 (vector 3 ))))))
(define ParserC-45RuleC-45Source-unqualifiedOperatorName(blodwen-lazy (lambda () (vector 1 "Expected operator" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((12) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Interfaces-C-60C-36 (csegen-73) e-0 (PreludeC-45Interfaces-guard (csegen-538) (let ((sc1 (PreludeC-45Types-elem (csegen-17) e-0 (ParserC-45LexerC-45Source-reservedSymbols)))) (cond ((equal? sc1 1) 0) (else 1)))))))(else '())))))))
(define ParserC-45RuleC-45Source-unqualifiedName(blodwen-lazy (lambda () (ParserC-45RuleC-45Source-identPart))))
(define ParserC-45RuleC-45Source-terminator (lambda (arg-0 arg-1) (vector 13 0 0 (vector 12 0 0 (ParserC-45RuleC-45Source-eoi) (vector 0 (vector 3 ))) (lambda () (vector 13 1 0 (vector 11 0 (ParserC-45RuleC-45Source-symbol ";") (lambda () (vector 0 (ParserC-45RuleC-45Source-n--8607-4832-u--afterSemi arg-1 arg-0 arg-0)))) (lambda () (vector 13 0 0 (vector 10 0 0 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (ParserC-45RuleC-45Source-n--8607-4833-u--afterDedent arg-1 arg-0 arg-0 u--col))) (lambda () (vector 0 (vector 3 ))))))))))
(define ParserC-45RuleC-45Source-symbol (lambda (arg-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Expected '" (PreludeC-45TypesC-45String-C-43C-43 arg-0 "'")) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((12) (let ((e-0 (vector-ref lcase-0 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))) (cond ((equal? sc1 1) (box 0)) (else '())))))(else '()))))))
(define ParserC-45RuleC-45Source-strLitLines(blodwen-lazy (lambda () (vector 1 "Expected string literal" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((7) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (DataC-45List1-u--traverse_Traversable_List1 (csegen-271) (lambda (eta-0) (ParserC-45Support-escape e-0 (PreludeC-45Types-fastPack eta-0))) (LibrariesC-45DataC-45ListC-45Extra-splitAfter (lambda (eta-0) (PreludeC-45Types-isNL eta-0)) (PreludeC-45Types-fastUnpack e-1))))))(else '())))))))
(define ParserC-45RuleC-45Source-strLit(blodwen-lazy (lambda () (vector 1 "Expected string literal" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((7) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (ParserC-45Support-escape e-0 e-1))))(else '())))))))
(define ParserC-45RuleC-45Source-strEnd(blodwen-lazy (lambda () (vector 1 "Expected string end" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((4) (box 0))(else '())))))))
(define ParserC-45RuleC-45Source-strBegin(blodwen-lazy (lambda () (vector 1 "Expected string begin" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (cond ((equal? e-0 1) (box 0))(else '()))))(else '())))))))
(define ParserC-45RuleC-45Source-simpleStr(blodwen-lazy (lambda () (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-strBegin)) (csegen-1554))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-strLit)))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-strEnd)))))))
(define ParserC-45RuleC-45Source-reservedNames(blodwen-lazy (lambda () (cons "Type" (cons "Int" (cons "Int8" (cons "Int16" (cons "Int32" (cons "Int64" (cons "Integer" (cons "Bits8" (cons "Bits16" (cons "Bits32" (cons "Bits64" (cons "String" (cons "Char" (cons "Double" (cons "Lazy" (cons "Inf" (cons "Force" (cons "Delay" '())))))))))))))))))))))
(define ParserC-45RuleC-45Source-pragma (lambda (arg-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Expected pragma " arg-0) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((19) (let ((e-0 (vector-ref lcase-0 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))) (cond ((equal? sc1 1) (box 0)) (else '())))))(else '()))))))
(define ParserC-45RuleC-45Source-postfixProj(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 1 eta-0))) (ParserC-45RuleC-45Source-aDotIdent)))))
(define ParserC-45RuleC-45Source-operatorCandidate(blodwen-lazy (lambda () (vector 1 "Expected operator" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((12) (let ((e-0 (vector-ref lcase-0 1))) (box (vector 1 (vector 0 e-0)))))(else '())))))))
(define ParserC-45RuleC-45Source-operator(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 0 eta-0))) (ParserC-45RuleC-45Source-unqualifiedOperatorName)))))
(define ParserC-45RuleC-45Source-opNonNS(blodwen-lazy (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (vector 14 (vector 13 1 1 (ParserC-45RuleC-45Source-operatorCandidate) (lambda () (ParserC-45RuleC-45Source-postfixProj)))) (lambda () (lambda (u--id) (vector 12 0 1 (ParserC-45RuleC-45Source-isNotReservedSymbol (PreludeC-45Interfaces-C-60C-36C-62 (csegen-360) (lambda (eta-0) (CoreC-45Name-nameRoot eta-0)) u--id)) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 (let ((e-1 (vector-ref u--id 0))) e-1))))))))))))))
(define ParserC-45RuleC-45Source-onOffLit(blodwen-lazy (lambda () (vector 1 "Expected on or off" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (let ((e-0 (vector-ref lcase-0 1))) (cond ((equal? e-0 "on") (box 1)) ((equal? e-0 "off") (box 0))(else '()))))(else '())))))))
(define ParserC-45RuleC-45Source-nonEmptyBlockAfter (lambda (arg-1 arg-2) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (ParserC-45RuleC-45Source-blockEntry (vector 0 ) arg-2) (lambda () (lambda (u--res) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-2) (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons (Builtin-fst u--res) u--ps)))))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-1))) (cond ((equal? sc0 0) (vector 9 0 (ParserC-45RuleC-45Source-blockEntry (vector 1 u--col) arg-2) (lambda () (lambda (u--res) (vector 10 0 0 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-2) (lambda (u--ps) (vector 0 (cons (Builtin-fst u--res) u--ps)))))))) (else (vector 4 '() 0 "Expected an indented non-empty block"))))))))))
(define ParserC-45RuleC-45Source-nonEmptyBlock (lambda (arg-1) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (ParserC-45RuleC-45Source-blockEntry (vector 0 ) arg-1) (lambda () (lambda (u--res) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-1) (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons (Builtin-fst u--res) u--ps)))))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 9 0 (ParserC-45RuleC-45Source-blockEntry (vector 1 u--col) arg-1) (lambda () (lambda (u--res) (vector 10 0 0 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-1) (lambda (u--ps) (vector 0 (cons (Builtin-fst u--res) u--ps)))))))))))))
(define ParserC-45RuleC-45Source-namespacedIdent(blodwen-lazy (lambda () (vector 1 "Expected namespaced name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((10) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (box (cons (box e-0) e-1))))) ((9) (let ((e-2 (vector-ref lcase-0 1))) (box (cons '() e-2))))(else '())))))))
(define ParserC-45RuleC-45Source-namespaceId(blodwen-lazy (lambda () (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-namespacedIdent)) (lambda () (lambda (u--nsid) (vector 12 0 0 (ParserC-45RuleC-45Source-isCapitalisedIdent (PreludeC-45Interfaces-C-60C-36C-62 (csegen-360) (lambda (eta-0) (Builtin-snd eta-0)) u--nsid)) (vector 0 (PreludeC-45Basics-uncurry (csegen-269) (let ((e-1 (vector-ref u--nsid 0))) e-1))))))))))
(define ParserC-45RuleC-45Source-nameWithCapital (lambda (arg-0) (vector 13 1 1 (ParserC-45RuleC-45Source-opNonNS) (lambda () (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-namespacedIdent)) (lambda () (lambda (u--nsx) (vector 13 1 0 (ParserC-45RuleC-45Source-n--8054-4289-u--opNS arg-0 u--nsx) (lambda () (ParserC-45RuleC-45Source-n--8054-4288-u--nameNS arg-0 u--nsx))))))))))
(define ParserC-45RuleC-45Source-name(blodwen-lazy (lambda () (ParserC-45RuleC-45Source-nameWithCapital 0))))
(define ParserC-45RuleC-45Source-mustContinue (lambda (arg-0 arg-1) (if (null? arg-1) (ParserC-45RuleC-45Source-continueF (vector 4 '() 1 "Unexpected end of expression") arg-0) (let ((e-2 (unbox arg-1))) (ParserC-45RuleC-45Source-continueF (vector 4 '() 1 (PreludeC-45TypesC-45String-C-43C-43 "Expected '" (PreludeC-45TypesC-45String-C-43C-43 e-2 "'"))) arg-0)))))
(define ParserC-45RuleC-45Source-multilineBegin(blodwen-lazy (lambda () (vector 1 "Expected multiline string begin" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (cond ((equal? e-0 0) (box 0))(else '()))))(else '())))))))
(define ParserC-45RuleC-45Source-moduleIdent(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (CoreC-45NameC-45Namespace-nsAsModuleIdent eta-0)) (ParserC-45RuleC-45Source-namespaceId)))))
(define ParserC-45RuleC-45Source-keyword (lambda (arg-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Expected '" (PreludeC-45TypesC-45String-C-43C-43 arg-0 "'")) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((18) (let ((e-0 (vector-ref lcase-0 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))) (cond ((equal? sc1 1) (box 0)) (else '())))))(else '()))))))
(define ParserC-45RuleC-45Source-isTerminator (lambda (arg-0) (case (vector-ref arg-0 0) ((12) (let ((e-0 (vector-ref arg-0 1))) (cond ((equal? e-0 ",") 1) ((equal? e-0 "]") 1) ((equal? e-0 ";") 1) ((equal? e-0 "}") 1) ((equal? e-0 ")") 1) ((equal? e-0 "|") 1) ((equal? e-0 "**") 1)(else 0)))) ((18) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 "in") 1) ((equal? e-1 "then") 1) ((equal? e-1 "else") 1) ((equal? e-1 "where") 1)(else 0)))) ((6) 1) ((17) 1)(else 0))))
(define ParserC-45RuleC-45Source-isNotReservedSymbol (lambda (arg-0) (let ((sc0 (PreludeC-45Types-elem (csegen-17) (let ((e-1 (vector-ref arg-0 0))) e-1) (ParserC-45LexerC-45Source-reservedSymbols)))) (cond ((equal? sc0 1) (vector 4 (box (let ((e-3 (vector-ref arg-0 2))) e-3)) 0 (PreludeC-45TypesC-45String-C-43C-43 "Can't use reserved symbol " (let ((e-1 (vector-ref arg-0 0))) e-1)))) (else (vector 0 0))))))
(define ParserC-45RuleC-45Source-isNotReservedName (lambda (arg-0) (let ((sc0 (PreludeC-45Types-elem (csegen-17) (let ((e-1 (vector-ref arg-0 0))) e-1) (ParserC-45RuleC-45Source-reservedNames)))) (cond ((equal? sc0 1) (vector 4 (box (let ((e-3 (vector-ref arg-0 2))) e-3)) 0 (PreludeC-45TypesC-45String-C-43C-43 "Can't use reserved name " (let ((e-1 (vector-ref arg-0 0))) e-1)))) (else (vector 0 0))))))
(define ParserC-45RuleC-45Source-isCapitalisedIdent (lambda (arg-0) (let ((u--val (let ((e-1 (vector-ref arg-0 0))) e-1))) (let ((u--loc (let ((e-3 (vector-ref arg-0 2))) e-3))) (let ((u--err (vector 4 (box u--loc) 0 (PreludeC-45TypesC-45String-C-43C-43 "Expected a capitalised identifier, got: " u--val)))) (ParserC-45RuleC-45Source-case--isCapitalisedIdent-3922 arg-0 u--val u--loc u--err (DataC-45String-strM u--val)))))))
(define ParserC-45RuleC-45Source-interpEnd(blodwen-lazy (lambda () (vector 1 "Expected string interp end" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((6) (box 0))(else '())))))))
(define ParserC-45RuleC-45Source-interpBegin(blodwen-lazy (lambda () (vector 1 "Expected string interp begin" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((5) (box 0))(else '())))))))
(define ParserC-45RuleC-45Source-intLit(blodwen-lazy (lambda () (vector 1 "Expected integer literal" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((2) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))))
(define ParserC-45RuleC-45Source-init(blodwen-lazy (lambda () 0)))
(define ParserC-45RuleC-45Source-identWithCapital (lambda (arg-0 arg-1) (cond ((equal? arg-0 1) (ParserC-45RuleC-45Source-isCapitalisedIdent arg-1)) (else (vector 0 0)))))
(define ParserC-45RuleC-45Source-identPart(blodwen-lazy (lambda () (vector 1 "Expected name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))))
(define ParserC-45RuleC-45Source-holeName(blodwen-lazy (lambda () (vector 1 "Expected hole name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((8) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))))
(define ParserC-45RuleC-45Source-exactIdent (lambda (arg-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Expected " arg-0) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (let ((e-0 (vector-ref lcase-0 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))) (cond ((equal? sc1 1) (box 0)) (else '())))))(else '()))))))
(define ParserC-45RuleC-45Source-eoi(blodwen-lazy (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) 0) (vector 2 "Expected end of input" (lambda (eta-0) (ParserC-45RuleC-45Source-n--6961-3249-u--isEOI eta-0)))))))
(define ParserC-45RuleC-45Source-documentationC-39(blodwen-lazy (lambda () (vector 1 "Expected documentation comment" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((15) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))))
(define ParserC-45RuleC-45Source-documentation(blodwen-lazy (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Extra-unlines (DataC-45List1-forget eta-0))) (LibrariesC-45TextC-45Parser-some (ParserC-45RuleC-45Source-documentationC-39))))))
(define ParserC-45RuleC-45Source-dataConstructorName(blodwen-lazy (lambda () (vector 13 1 1 (ParserC-45RuleC-45Source-opNonNS) (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 0 eta-0))) (ParserC-45RuleC-45Source-capitalisedIdent)))))))
(define ParserC-45RuleC-45Source-continueF (lambda (arg-0 arg-1) (vector 13 0 0 (vector 12 0 0 (ParserC-45RuleC-45Source-eoi) arg-0) (lambda () (vector 13 1 0 (vector 11 0 (ParserC-45RuleC-45Source-keyword "where") (lambda () arg-0)) (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (LibrariesC-45TextC-45Parser-when (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-1) (lambda () arg-0))))))))))
(define ParserC-45RuleC-45Source-continue (lambda (ext-0) (ParserC-45RuleC-45Source-continueF (vector 4 '() 0 "Unexpected end of expression") ext-0)))
(define ParserC-45RuleC-45Source-constant(blodwen-lazy (lambda () (vector 1 "Expected constant" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((0) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 11 eta-0)) (ParserC-45Support-getCharLit e-0)))) ((1) (let ((e-1 (vector-ref lcase-0 1))) (box (vector 12 e-1)))) ((2) (let ((e-2 (vector-ref lcase-0 1))) (box (vector 5 e-2)))) ((9) (let ((e-3 (vector-ref lcase-0 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-isConstantType (vector 1 (vector 0 e-3))) (lambda (lcase-1) (case (vector-ref lcase-1 0) ((27) '())(else (box lcase-1)))))))(else '())))))))
(define ParserC-45RuleC-45Source-checkValid (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (vector 0 0)) ((1) (let ((e-0 (vector-ref arg-0 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 e-0))) (cond ((equal? sc1 1) (vector 0 0)) (else (vector 4 '() 0 "Invalid indentation")))))) ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-1 e-1))) (cond ((equal? sc1 1) (vector 0 0)) (else (vector 4 '() 0 "Invalid indentation")))))) (else (vector 4 '() 0 "End of block")))))
(define ParserC-45RuleC-45Source-capitalisedName(blodwen-lazy (lambda () (ParserC-45RuleC-45Source-nameWithCapital 1))))
(define ParserC-45RuleC-45Source-capitalisedIdent(blodwen-lazy (lambda () (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-identPart)) (lambda () (lambda (u--id) (vector 12 0 0 (ParserC-45RuleC-45Source-isCapitalisedIdent u--id) (vector 12 0 0 (ParserC-45RuleC-45Source-isNotReservedName u--id) (vector 0 (let ((e-1 (vector-ref u--id 0))) e-1))))))))))
(define ParserC-45RuleC-45Source-builtinType(blodwen-lazy (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-60C-36 (csegen-352) 0 (ParserC-45RuleC-45Source-exactIdent "Natural")) (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-60C-36 (csegen-352) 1 (ParserC-45RuleC-45Source-exactIdent "NaturalToInteger")) (lambda () (PreludeC-45Interfaces-C-60C-36 (csegen-352) 2 (ParserC-45RuleC-45Source-exactIdent "IntegerToNatural")))))))))
(define ParserC-45RuleC-45Source-blockWithOptHeaderAfter (lambda (arg-2 arg-3 arg-4) (vector 13 1 0 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (ParserC-45RuleC-45Source-blockEntry (vector 0 ) arg-3)) (lambda (u--hidt) (ParserC-45RuleC-45Source-n--9075-5308-u--restOfBlock arg-4 arg-3 arg-2 u--hidt)))))) (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-2))) (cond ((equal? sc0 1) (vector 0 (cons '() '()))) (else (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (ParserC-45RuleC-45Source-blockEntry (vector 1 u--col) arg-3)) (lambda (u--hidt) (vector 10 0 0 (ParserC-45RuleC-45Source-blockEntries (vector 1 u--col) arg-4) (lambda (u--ps) (vector 0 (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-fst eta-0)) u--hidt) u--ps)))))))))))))))
(define ParserC-45RuleC-45Source-blockEntry (lambda (arg-1 arg-2) (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 12 0 1 (ParserC-45RuleC-45Source-checkValid arg-1 u--col) (vector 9 0 (arg-2 u--col) (lambda () (lambda (u--p) (vector 10 0 0 (ParserC-45RuleC-45Source-terminator arg-1 u--col) (lambda (u--validC-39) (vector 0 (cons u--p u--validC-39))))))))))))
(define ParserC-45RuleC-45Source-blockEntries (lambda (arg-1 arg-2) (vector 13 0 0 (vector 12 0 0 (ParserC-45RuleC-45Source-eoi) (vector 0 '())) (lambda () (vector 13 1 0 (vector 9 0 (ParserC-45RuleC-45Source-blockEntry arg-1 arg-2) (lambda () (lambda (u--res) (vector 10 0 0 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-2) (lambda (u--ts) (vector 0 (cons (Builtin-fst u--res) u--ts))))))) (lambda () (vector 0 '())))))))
(define ParserC-45RuleC-45Source-blockAfter (lambda (arg-1 arg-2) (vector 13 1 0 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (vector 0 ) arg-2) (csegen-1621))))) (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-1))) (cond ((equal? sc0 1) (vector 0 '())) (else (ParserC-45RuleC-45Source-blockEntries (vector 1 u--col) arg-2))))))))))
(define ParserC-45RuleC-45Source-block (lambda (arg-1) (vector 13 1 0 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (vector 0 ) arg-1) (csegen-1621))))) (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (ParserC-45RuleC-45Source-blockEntries (vector 1 u--col) arg-1)))))))
(define ParserC-45RuleC-45Source-atEndIndent (lambda (arg-0) (vector 13 0 0 (ParserC-45RuleC-45Source-eoi) (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (LibrariesC-45TextC-45Parser-when (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-0))) (cond ((equal? sc0 1) 0) (else 1))) (lambda () (vector 4 '() 0 "Not the end of a block entry")))))))))
(define ParserC-45RuleC-45Source-atEnd (lambda (arg-0) (vector 13 0 0 (ParserC-45RuleC-45Source-eoi) (lambda () (vector 13 0 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) 0) (vector 2 "Expected end of block" (lambda (eta-0) (ParserC-45RuleC-45Source-isTerminator eta-0)))) (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (LibrariesC-45TextC-45Parser-when (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-0))) (cond ((equal? sc0 1) 0) (else 1))) (lambda () (vector 4 '() 0 "Not the end of a block entry")))))))))))
(define ParserC-45RuleC-45Source-aDotIdent(blodwen-lazy (lambda () (vector 1 "Expected dot+identifier" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((11) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))))
(define ParserC-45Support-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32escapeC-39-3596 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (if (null? e-3) (ParserC-45Support-escapeC-39 arg-2 e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (if (null? e-7) (ParserC-45Support-escapeC-39 arg-2 e-3) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (if (null? e-10) (let ((sc5 (ParserC-45Support-getEsc (PreludeC-45Types-fastPack (cons e-6 (cons e-9 '())))))) (if (null? sc5) (ParserC-45Support-escapeC-39 arg-2 arg-3) (let ((e-1 (unbox sc5))) (box (cons e-1 '()))))) (let ((e-12 (car e-10))) (let ((e-13 (cdr e-10))) (let ((sc5 (ParserC-45Support-getEsc (PreludeC-45Types-fastPack (cons e-6 (cons e-9 (cons e-12 '()))))))) (if (null? sc5) (let ((sc6 (ParserC-45Support-getEsc (PreludeC-45Types-fastPack (cons e-6 (cons e-9 '())))))) (if (null? sc6) (ParserC-45Support-escapeC-39 arg-2 arg-3) (let ((e-1 (unbox sc6))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 (cons e-12 e-13)) (lambda (bind-0) (box (cons e-1 bind-0))))))) (let ((e-1 (unbox sc5))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-13) (lambda (bind-0) (box (cons e-1 bind-0)))))))))))))))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-3) (lambda (bind-0) (box (cons (PreludeC-45Cast-u--cast_Cast_Int_Char (PreludeC-45Cast-u--cast_Cast_String_Int (PreludeC-45Types-fastPack e-2))) bind-0)))))))))
(define ParserC-45Support-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32escapeC-39-3533 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (ParserC-45Support-escapeC-39 arg-2 e-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-n--6576-3068-u--toOct arg-0 arg-1 arg-2 1 (PreludeC-45TypesC-45List-reverse e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-3) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (PreludeC-45Cast-u--cast_Cast_Int_Char bind-0) bind-1)))))))))))
(define ParserC-45Support-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32escapeC-39-3465 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (ParserC-45Support-escapeC-39 arg-2 e-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-n--6576-3067-u--toHex arg-0 arg-1 arg-2 1 (PreludeC-45TypesC-45List-reverse e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-3) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (PreludeC-45Cast-u--cast_Cast_Int_Char bind-0) bind-1)))))))))))
(define ParserC-45Support-case--caseC-32blockC-32inC-32escapeC-39-3168 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (ParserC-45Support-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32escapeC-39-3596 arg-0 arg-1 arg-2 arg-3 (DataC-45List-span (lambda (eta-0) (PreludeC-45Types-isDigit eta-0)) arg-3)) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? e-1 #\\) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons #\\ bind-0))))) ((equal? e-1 (integer->char 10)) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe bind-0)))) ((equal? e-1 #\&) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe bind-0)))) ((equal? e-1 #\a) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (integer->char 7) bind-0))))) ((equal? e-1 #\b) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (integer->char 8) bind-0))))) ((equal? e-1 #\f) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (integer->char 12) bind-0))))) ((equal? e-1 #\n) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (integer->char 10) bind-0))))) ((equal? e-1 #\r) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (integer->char 13) bind-0))))) ((equal? e-1 #\t) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (integer->char 9) bind-0))))) ((equal? e-1 #\v) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (integer->char 11) bind-0))))) ((equal? e-1 #\') (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons #\' bind-0))))) ((equal? e-1 #\") (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-2 e-2) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons #\" bind-0))))) ((equal? e-1 #\x) (ParserC-45Support-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32escapeC-39-3465 arg-0 arg-1 arg-2 e-2 (DataC-45List-span (lambda (eta-0) (PreludeC-45Types-isHexDigit eta-0)) e-2))) ((equal? e-1 #\o) (ParserC-45Support-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32escapeC-39-3533 arg-0 arg-1 arg-2 e-2 (DataC-45List-span (lambda (eta-0) (PreludeC-45Types-isOctDigit eta-0)) e-2)))(else (ParserC-45Support-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32escapeC-39-3596 arg-0 arg-1 arg-2 arg-3 (DataC-45List-span (lambda (eta-0) (PreludeC-45Types-isDigit eta-0)) arg-3)))))))))
(define ParserC-45Support-n--6576-3068-u--toOct (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (box 0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-oct (PreludeC-45Types-toLower e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-n--6576-3068-u--toOct arg-0 arg-1 arg-2 (bs* arg-3 8 63) e-3) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (bs+ (bs* bind-0 arg-3 63) bind-1 63)))))))))))
(define ParserC-45Support-n--6576-3067-u--toHex (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (box 0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-hex (PreludeC-45Types-toLower e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-n--6576-3067-u--toHex arg-0 arg-1 arg-2 (bs* arg-3 16 63) e-3) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (bs+ (bs* bind-0 arg-3 63) bind-1 63)))))))))))
(define ParserC-45Support-n--5965-2452-u--fromError (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (if (null? e-2) (cons (vector 0 arg-2 (cons 0 0) (cons 0 0)) (LibrariesC-45DataC-45StringC-45Extra-C-43C-62 e-1 #\.)) (let ((e-5 (unbox e-2))) (let ((u--start (LibrariesC-45TextC-45Bounded-startBounds e-5))) (let ((u--end (LibrariesC-45TextC-45Bounded-endBounds e-5))) (let ((u--fc (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) u--start u--end))) (cond ((equal? sc2 1) (vector 0 arg-2 u--start (let ((e-4 (car u--start))) (let ((e-3 (cdr u--start))) (cons e-4 (bs+ e-3 1 63)))))) (else (vector 0 arg-2 u--start u--end)))))) (cons u--fc (LibrariesC-45DataC-45StringC-45Extra-C-43C-62 e-1 #\.)))))))))))
(define ParserC-45Support-oct (lambda (arg-0) (cond ((equal? arg-0 #\0) (box 0)) ((equal? arg-0 #\1) (box 1)) ((equal? arg-0 #\2) (box 2)) ((equal? arg-0 #\3) (box 3)) ((equal? arg-0 #\4) (box 4)) ((equal? arg-0 #\5) (box 5)) ((equal? arg-0 #\6) (box 6)) ((equal? arg-0 #\7) (box 7))(else '()))))
(define ParserC-45Support-hex (lambda (arg-0) (cond ((equal? arg-0 #\0) (box 0)) ((equal? arg-0 #\1) (box 1)) ((equal? arg-0 #\2) (box 2)) ((equal? arg-0 #\3) (box 3)) ((equal? arg-0 #\4) (box 4)) ((equal? arg-0 #\5) (box 5)) ((equal? arg-0 #\6) (box 6)) ((equal? arg-0 #\7) (box 7)) ((equal? arg-0 #\8) (box 8)) ((equal? arg-0 #\9) (box 9)) ((equal? arg-0 #\a) (box 10)) ((equal? arg-0 #\b) (box 11)) ((equal? arg-0 #\c) (box 12)) ((equal? arg-0 #\d) (box 13)) ((equal? arg-0 #\e) (box 14)) ((equal? arg-0 #\f) (box 15))(else '()))))
(define ParserC-45Support-getEsc (lambda (arg-0) (cond ((equal? arg-0 "NUL") (box (integer->char 0))) ((equal? arg-0 "SOH") (box (integer->char 1))) ((equal? arg-0 "STX") (box (integer->char 2))) ((equal? arg-0 "ETX") (box (integer->char 3))) ((equal? arg-0 "EOT") (box (integer->char 4))) ((equal? arg-0 "ENQ") (box (integer->char 5))) ((equal? arg-0 "ACK") (box (integer->char 6))) ((equal? arg-0 "BEL") (box (integer->char 7))) ((equal? arg-0 "BS") (box (integer->char 8))) ((equal? arg-0 "HT") (box (integer->char 9))) ((equal? arg-0 "LF") (box (integer->char 10))) ((equal? arg-0 "VT") (box (integer->char 11))) ((equal? arg-0 "FF") (box (integer->char 12))) ((equal? arg-0 "CR") (box (integer->char 13))) ((equal? arg-0 "SO") (box (integer->char 14))) ((equal? arg-0 "SI") (box (integer->char 15))) ((equal? arg-0 "DLE") (box (integer->char 16))) ((equal? arg-0 "DC1") (box (integer->char 17))) ((equal? arg-0 "DC2") (box (integer->char 18))) ((equal? arg-0 "DC3") (box (integer->char 19))) ((equal? arg-0 "DC4") (box (integer->char 20))) ((equal? arg-0 "NAK") (box (integer->char 21))) ((equal? arg-0 "SYN") (box (integer->char 22))) ((equal? arg-0 "ETB") (box (integer->char 23))) ((equal? arg-0 "CAN") (box (integer->char 24))) ((equal? arg-0 "EM") (box (integer->char 25))) ((equal? arg-0 "SUB") (box (integer->char 26))) ((equal? arg-0 "ESC") (box (integer->char 27))) ((equal? arg-0 "FS") (box (integer->char 28))) ((equal? arg-0 "GS") (box (integer->char 29))) ((equal? arg-0 "RS") (box (integer->char 30))) ((equal? arg-0 "US") (box (integer->char 31))) ((equal? arg-0 "SP") (box #\ )) ((equal? arg-0 "DEL") (box (integer->char 127)))(else '()))))
(define ParserC-45Support-getCharLit (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escape 0 arg-0) (lambda (u--e) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45String-length u--e) (PreludeC-45Types-u--fromInteger_Num_Nat 1)))) (cond ((equal? sc0 1) (box (string-ref u--e 0))) (else (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45String-length u--e) (PreludeC-45Types-u--fromInteger_Num_Nat 0)))) (cond ((equal? sc1 1) (box (integer->char 0))) (else '()))))))))))
(define ParserC-45Support-fromParsingErrors (lambda (arg-1 arg-2 ext-0) (vector 53 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (ParserC-45Support-n--5965-2452-u--fromError arg-1 arg-2 eta-0)) ext-0))))
(define ParserC-45Support-fromLitError (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (vector 51 (vector 0 arg-0 (cons e-0 e-1) (cons e-0 (bs+ e-1 1 63))))))))
(define ParserC-45Support-fromLexError (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((2) (let ((e-12 (vector-ref e-2 1))) (let ((e-13 (vector-ref e-2 2))) (if (null? e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (vector 52 (vector 0 arg-0 (cons e-6 e-10) (cons e-6 (bs+ e-10 1 63))) "Can't recognise token.")))) (let ((e-17 (cdr e-3))) (if (null? e-17) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (vector 52 (vector 0 arg-0 (cons e-6 e-10) (cons e-6 (bs+ e-10 1 63))) "Can't recognise token.")))) (vector 52 (vector 0 arg-0 e-12 e-13) "Bracket is not properly closed.")))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (vector 52 (vector 0 arg-0 (cons e-6 e-10) (cons e-6 (bs+ e-10 1 63))) "Can't recognise token."))))))))))
(define ParserC-45Support-escapeC-39 (lambda (arg-0 arg-1) (if (null? arg-1) (PreludeC-45Types-u--pure_Applicative_Maybe '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (DataC-45List-isPrefixOf (csegen-0) arg-0 (cons e-2 e-3)))) (cond ((equal? sc1 1) (ParserC-45Support-case--caseC-32blockC-32inC-32escapeC-39-3168 e-2 e-3 arg-0 (DataC-45List-drop (PreludeC-45TypesC-45List-length arg-0) (cons e-2 e-3)))) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45Support-escapeC-39 arg-0 e-3) (lambda (bind-0) (box (cons e-2 bind-0))))))))))))
(define ParserC-45Support-escape (lambda (arg-0 arg-1) (let ((u--escapeChars (cons #\\ (DataC-45List-replicate arg-0 #\#)))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (ParserC-45Support-escapeC-39 u--escapeChars (PreludeC-45Types-fastUnpack arg-1))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-1974 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((1) (let ((e-2 (vector-ref arg-10 1))) (vector 1 e-2))) (else (let ((e-5 (vector-ref arg-10 1))) (case (vector-ref e-5 0) ((2) (vector 0 e-5))(else (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1187-u--getFirstMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (arg-7) arg-9))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32tokeniseC-44getFirstMatch-1740 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28) (if (null? arg-28) (vector 0 (vector 2 (cons arg-4 arg-3) (cons arg-16 arg-17))) (let ((e-1 (unbox arg-28))) (if (null? e-1) (vector 0 (vector 2 (cons arg-4 arg-3) (cons arg-16 arg-17))) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (if (null? e-5) (vector 0 (vector 2 (cons arg-4 arg-3) (cons arg-16 arg-17))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-9) (vector 0 (vector 2 (cons arg-4 arg-3) (cons arg-16 arg-17))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((u--endTokC-39C-39 (vector (arg-8 e-4) 0 (vector arg-24 arg-25 e-8 e-12)))) (vector 1 (cons (PreludeC-45TypesC-45List-tailRecAppend (cons u--endTokC-39C-39 '()) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-reverse arg-22) (cons arg-21 '()))) (cons e-8 (cons e-12 e-13))))))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-1470 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (vector 0 (vector 1 )) (let ((e-1 (unbox arg-15))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((u--tag (arg-11 e-5))) (let ((u--middle ((arg-10) u--tag))) (let ((u--end (arg-9 u--tag))) (let ((u--beginTokC-39C-39 (vector (arg-12 e-5) 0 (vector arg-4 arg-3 e-9 e-13)))) (let ((sc4 (LibrariesC-45TextC-45LexerC-45Tokenizer-tokenise u--end u--middle e-9 e-13 '() e-14))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-12 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-16 (car e-11))) (let ((e-15 (cdr e-11))) (case (vector-ref e-8 0) ((2) (vector 0 e-8))(else (LibrariesC-45TextC-45LexerC-45Tokenizer-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32tokeniseC-44getFirstMatch-1740 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-5 e-9 e-13 e-14 u--middle u--end u--beginTokC-39C-39 e-2 e-8 e-12 e-16 e-15 u--tag (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1186-u--getNext arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--end e-12 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-1373 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (vector 0 (vector 1 )) (let ((e-1 (unbox arg-10))) (if (null? e-1) (vector 0 (vector 1 )) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (if (null? e-5) (vector 0 (vector 1 )) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-9) (vector 0 (vector 1 )) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((u--tokC-39 (vector (arg-7 e-4) 0 (vector arg-4 arg-3 e-8 e-12)))) (vector 1 (cons (cons u--tokC-39 '()) (cons e-8 (cons e-12 e-13))))))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getNext-1282 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (let ((e-1 (unbox arg-11))) (if (null? e-1) '() (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (let ((u--lineC-39 (bs+ arg-9 (PreludeC-45Cast-u--cast_Cast_Nat_Int (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1184-u--countNLs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4)) 63))) (let ((u--colC-39 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1185-u--getCols arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4 arg-8))) (let ((u--tokenStr (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-4)))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons u--tokenStr (cons u--lineC-39 (cons u--colC-39 e-5))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1186-u--getNext (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getNext-1282 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-10 arg-9 arg-8 arg-7 (LibrariesC-45TextC-45LexerC-45Core-scan arg-7 '() arg-10))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1187-u--getFirstMatch (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-1373 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 e-1 arg-8 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1186-u--getNext arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-1 arg-4 arg-3 arg-8))))) ((1) (let ((e-5 (vector-ref arg-7 1))) (let ((e-6 (vector-ref arg-7 2))) (let ((e-7 (vector-ref arg-7 3))) (let ((e-8 (vector-ref arg-7 4))) (let ((e-9 (vector-ref arg-7 5))) (let ((e-10 (vector-ref arg-7 6))) (LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-1470 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-10 e-9 e-8 e-7 e-6 e-5 arg-8 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1186-u--getNext arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 arg-4 arg-3 arg-8))))))))) (else (let ((e-12 (vector-ref arg-7 1))) (let ((e-13 (vector-ref arg-7 2))) (LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-1974 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13 e-12 arg-8 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1187-u--getFirstMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-12 arg-8))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1185-u--getCols (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((sc0 (DataC-45List-span (lambda (arg-0) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-0 (integer->char 10))) arg-7))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-3) (bs+ arg-8 (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45List-length e-2)) 63) (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45List-length e-2))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1184-u--countNLs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (PreludeC-45TypesC-45List-length (DataC-45List-filter (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 10))) arg-7))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-tokenise (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (cons (PreludeC-45TypesC-45List-reverse arg-5) (cons (vector 0 ) (cons arg-3 (cons arg-4 '())))) (let ((sc1 (LibrariesC-45TextC-45LexerC-45Core-scan arg-1 '() arg-6))) (if (null? sc1) (let ((sc2 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4287-1187-u--getFirstMatch arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-2 arg-6))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 1))) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((e-16 (car e-13))) (let ((e-17 (cdr e-13))) (LibrariesC-45TextC-45LexerC-45Tokenizer-tokenise arg-1 arg-2 e-12 e-16 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-5) e-17))))))))) (else (let ((e-5 (vector-ref sc2 1))) (cons (PreludeC-45TypesC-45List-reverse arg-5) (cons e-5 (cons arg-3 (cons arg-4 arg-6)))))))) (cons (PreludeC-45TypesC-45List-reverse arg-5) (cons (vector 0 ) (cons arg-3 (cons arg-4 arg-6)))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-match (lambda (ext-0 ext-1) (vector 0 ext-0 ext-1)))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-lexTo (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Tokenizer-tokenise arg-1 arg-2 0 0 '() (PreludeC-45Types-fastUnpack arg-3)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (cons e-2 (cons e-6 (cons e-10 (cons e-14 (PreludeC-45Types-fastPack e-15))))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-lex (lambda (arg-1 arg-2) (LibrariesC-45TextC-45LexerC-45Tokenizer-lexTo (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) 0)) arg-1 arg-2)))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-compose (lambda (ext-0 ext-1 ext-2 ext-3 ext-4 ext-5) (vector 1 ext-0 ext-1 ext-2 ext-3 ext-4 ext-5)))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (lambda (ext-0 ext-1) (vector 2 ext-0 ext-1)))
(define ParserC-45LexerC-45Source-case--lexTo-6720 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (vector 0 e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-6 0) ((0) (if (null? e-7) (vector 0 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (vector 0 e-3) (let ((e-14 (car e-11))) (let ((u--end (cons (vector (vector 17 ) 0 (vector e-10 e-14 e-10 e-14)) '()))) (vector 1 (let ((sc5 (DataC-45Either-partitionEithers (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (ParserC-45LexerC-45Source-n--5778-6658-u--spotComment arg-0 arg-1 eta-0)) (DataC-45List-filter (lambda (eta-0) (ParserC-45LexerC-45Source-n--5778-6657-u--isNotSpace arg-0 arg-1 eta-0)) e-2))))) (let ((e-5 (car sc5))) (let ((e-4 (cdr sc5))) (cons e-5 (PreludeC-45TypesC-45List-tailRecAppend e-4 u--end)))))))))))))(else (vector 0 e-3))))))))))
(define ParserC-45LexerC-45Source-n--5778-6658-u--spotComment (lambda (arg-0 arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (case (vector-ref e-1 0) ((14) (vector 0 (PreludeC-45Interfaces-C-60C-36 (csegen-360) 0 arg-2)))(else (vector 1 arg-2))))))
(define ParserC-45LexerC-45Source-n--5461-6339-u--removeUnderscores (lambda (arg-0) (PreludeC-45Types-fastPack (DataC-45List-filter (lambda (arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 #\_)) (PreludeC-45Types-fastUnpack arg-0)))))
(define ParserC-45LexerC-45Source-n--5461-6338-u--removeOptionalLeadingSpace (lambda (arg-0) (let ((sc0 (DataC-45String-strM arg-0))) (if (null? sc0) arg-0 (let ((e-0 (car sc0))) (let ((e-1 (cdr sc0))) (cond ((equal? e-0 #\ ) e-1)(else arg-0))))))))
(define ParserC-45LexerC-45Source-n--5461-6336-u--parseNamespace (lambda (arg-0) (let ((sc0 (CoreC-45NameC-45Namespace-mkNamespacedIdent arg-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-2) (ParserC-45LexerC-45Source-n--5461-6335-u--parseIdent e-3) (let ((e-6 (unbox e-2))) (vector 10 e-6 e-3))))))))
(define ParserC-45LexerC-45Source-n--5461-6335-u--parseIdent (lambda (arg-0) (let ((sc0 (PreludeC-45Types-elem (csegen-17) arg-0 (ParserC-45LexerC-45Source-keywords)))) (cond ((equal? sc0 1) (vector 18 arg-0)) (else (vector 9 arg-0))))))
(define ParserC-45LexerC-45Source-n--5778-6657-u--isNotSpace (lambda (arg-0 arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (case (vector-ref e-1 0) ((13) 0)(else 1)))))
(define ParserC-45LexerC-45Source-n--5335-6143-u--fromBin (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 0) (* 2 (ParserC-45LexerC-45Source-n--5335-6143-u--fromBin arg-0 e-3)))(else (+ e-2 (* 2 (ParserC-45LexerC-45Source-n--5335-6143-u--fromBin arg-0 e-3))))))))))
(define ParserC-45LexerC-45Source-n--5461-6337-u--countHashtag (lambda (ext-0) (PreludeC-45Types-count (csegen-51) (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 #\#)) (PreludeC-45Types-fastUnpack ext-0))))
(define ParserC-45LexerC-45Source-n--5335-6142-u--castBin (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\1) 1)(else 0))))
(define ParserC-45LexerC-45Source-u--show_Show_Token (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "character " (PreludeC-45Show-u--show_Show_String e-0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "double " (PreludeC-45Show-u--show_Show_Double e-1)))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "literal " (PreludeC-45Show-u--show_Show_Integer e-2)))) ((3) (let ((e-3 (vector-ref arg-0 1))) (cond ((equal? e-3 1) "string begin") (else "multiline string begin")))) ((4) "string end") ((5) "string interp begin") ((6) "string interp end") ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "string" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45StringC-45Extra-replicate e-4 #\#) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_String e-5))))))) ((8) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "hole identifier " e-6))) ((9) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "identifier " e-7))) ((10) (let ((e-8 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "namespaced identifier " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-8) (PreludeC-45TypesC-45String-C-43C-43 "." (PreludeC-45Show-u--show_Show_String e-9))))))) ((11) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "dot+identifier " e-10))) ((12) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "symbol " e-11))) ((13) "whitespace") ((14) "comment") ((15) (let ((e-12 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "doc comment: \"" (PreludeC-45TypesC-45String-C-43C-43 e-12 "\"")))) ((16) (let ((e-13 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "CGDirective " e-13))) ((17) "end of input") ((18) (let ((e-14 (vector-ref arg-0 1))) e-14)) ((19) (let ((e-15 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "pragma " e-15))) (else (let ((e-16 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Unrecognised " e-16))))))
(define ParserC-45LexerC-45Source-u--showPrec_Show_Token (lambda (arg-0 arg-1) (ParserC-45LexerC-45Source-u--show_Show_Token arg-1)))
(define ParserC-45LexerC-45Source-u--pretty_Pretty_Token (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "character") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-0))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "double") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Double e-1)))) ((2) (let ((e-2 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "literal") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Integer e-2)))) ((3) (let ((e-3 (vector-ref arg-1 1))) (cond ((equal? e-3 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string begin")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "multiline string begin"))))) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string end")) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string interp begin")) ((6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string interp end")) ((7) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (PreludeC-45TypesC-45String-C-43C-43 "string" (LibrariesC-45DataC-45StringC-45Extra-replicate e-4 #\#))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)))))) ((8) (let ((e-6 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "hole identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-6)))) ((9) (let ((e-7 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-7)))) ((10) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "namespaced identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace e-8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-9)))))) ((11) (let ((e-10 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "dot+identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-10)))) ((12) (let ((e-11 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "symbol") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-11)))) ((13) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "space")) ((14) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "comment")) ((15) (let ((e-12 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "doc comment:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-12))))) ((16) (let ((e-13 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "CGDirective") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-13)))) ((17) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "end of input")) ((18) (let ((e-14 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-14))) ((19) (let ((e-15 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "pragma") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-15)))) (else (let ((e-16 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Unrecognised") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-16)))))))
(define ParserC-45LexerC-45Source-u--prettyPrec_Pretty_Token (lambda (arg-1 arg-2) (ParserC-45LexerC-45Source-u--pretty_Pretty_Token arg-2)))
(define ParserC-45LexerC-45Source-validSymbol(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Source-isOpChar eta-0)))))))
(define ParserC-45LexerC-45Source-toEndComment (lambda (arg-0) (cond ((equal? arg-0 0) (LibrariesC-45TextC-45LexerC-45Core-empty))(else (let ((e-0 (- arg-0 1))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--c) (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char u--c #\-))) (cond ((equal? sc0 1) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char u--c #\{))) (cond ((equal? sc1 1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char u--c #\")) (else 0)))) (else 0)))))) (lambda () (ParserC-45LexerC-45Source-toEndComment (+ 1 e-0)))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (LibrariesC-45TextC-45Lexer-is #\{) (lambda () (ParserC-45LexerC-45Source-singleBrace e-0))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (LibrariesC-45TextC-45Lexer-is #\-) (lambda () (ParserC-45LexerC-45Source-singleDash e-0))) (vector 4 (LibrariesC-45TextC-45Lexer-stringLit) (lambda () (ParserC-45LexerC-45Source-toEndComment (+ 1 e-0))))))))))))
(define ParserC-45LexerC-45Source-symbols(blodwen-lazy (lambda () (cons "," (cons ";" (cons "_" (cons "`" '())))))))
(define ParserC-45LexerC-45Source-stringTokens (lambda (arg-0 arg-1) (let ((u--escapeChars (PreludeC-45TypesC-45String-C-43C-43 "\\" (LibrariesC-45DataC-45StringC-45Extra-replicate arg-1 #\#)))) (let ((u--interpStart (PreludeC-45TypesC-45String-C-43C-43 u--escapeChars "{"))) (let ((u--escapeLexer (LibrariesC-45TextC-45Lexer-escape (LibrariesC-45TextC-45Lexer-exact u--escapeChars) (LibrariesC-45TextC-45Lexer-any)))) (let ((u--charLexer (LibrariesC-45TextC-45Lexer-non (LibrariesC-45TextC-45Lexer-exact (cond ((equal? arg-0 1) (ParserC-45LexerC-45Source-multilineEnd arg-1)) (else (ParserC-45LexerC-45Source-stringEnd arg-1))))))) (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-someUntil (LibrariesC-45TextC-45Lexer-exact u--interpStart) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 u--escapeLexer u--charLexer)) (lambda (u--x) (vector 7 arg-1 u--x))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-compose (LibrariesC-45TextC-45Lexer-exact u--interpStart) (lambda (eta-0) (vector 5 )) (lambda (eta-0) 0) (lambda () (lambda (_-6332) (ParserC-45LexerC-45Source-rawTokens))) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-is #\})) (lambda (eta-0) (vector 6 )))))))))))
(define ParserC-45LexerC-45Source-stringEnd (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 "\"" (LibrariesC-45DataC-45StringC-45Extra-replicate arg-0 #\#))))
(define ParserC-45LexerC-45Source-stringBegin(blodwen-lazy (lambda () (vector 5 (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-is #\#)) (LibrariesC-45TextC-45Lexer-is #\")))))
(define ParserC-45LexerC-45Source-singleDash (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (LibrariesC-45TextC-45Lexer-is #\-) (lambda () (ParserC-45LexerC-45Source-doubleDash arg-0))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (LibrariesC-45TextC-45Lexer-is #\}) (lambda () (ParserC-45LexerC-45Source-toEndComment arg-0))) (ParserC-45LexerC-45Source-toEndComment (+ 1 arg-0))))))
(define ParserC-45LexerC-45Source-singleBrace (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-is #\-) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-is #\-)))) (lambda () (ParserC-45LexerC-45Source-singleDash (+ 1 arg-0)))) (ParserC-45LexerC-45Source-toEndComment (+ 1 arg-0)))))
(define ParserC-45LexerC-45Source-reservedSymbols(blodwen-lazy (lambda () (PreludeC-45TypesC-45List-tailRecAppend (ParserC-45LexerC-45Source-symbols) (PreludeC-45TypesC-45List-tailRecAppend (ParserC-45LexerC-45Source-groupSymbols) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (ParserC-45LexerC-45Source-groupClose eta-0)) (ParserC-45LexerC-45Source-groupSymbols)) (cons "%" (cons "\\" (cons ":" (cons "=" (cons ":=" (cons "|" (cons "|||" (cons "<-" (cons "->" (cons "=>" (cons "?" (cons "!" (cons "&" (cons "**" (cons ".." (cons "~" (cons "@" '())))))))))))))))))))))))
(define ParserC-45LexerC-45Source-rawTokens(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Common-comment) (lambda (eta-0) (vector 14 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Source-blockComment) (lambda (eta-0) (vector 14 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Source-docComment) (lambda (eta-0) (vector 15 (ParserC-45LexerC-45Source-n--5461-6338-u--removeOptionalLeadingSpace (LibrariesC-45DataC-45StringC-45Extra-drop (+ 1 (+ 1 (+ 1 0))) eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Source-cgDirective) (lambda (eta-0) (ParserC-45LexerC-45Source-mkDirective eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Source-holeIdent) (lambda (u--x) (vector 8 (DataC-45String-strTail u--x)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-compose (LibrariesC-45TextC-45Lexer-choice 1 (csegen-51) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact eta-0)) (ParserC-45LexerC-45Source-groupSymbols))) (lambda (eta-0) (vector 12 eta-0)) (lambda (eta-0) eta-0) (lambda () (lambda (_-6473) (ParserC-45LexerC-45Source-rawTokens))) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact (ParserC-45LexerC-45Source-groupClose eta-0))) (lambda (eta-0) (vector 12 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-choice 1 (csegen-51) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact eta-0)) (ParserC-45LexerC-45Source-symbols))) (lambda (eta-0) (vector 12 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Source-doubleLit) (lambda (eta-0) (vector 1 (PreludeC-45Cast-u--cast_Cast_String_Double eta-0)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-binUnderscoredLit) (lambda (eta-0) (vector 2 (ParserC-45LexerC-45Source-fromBinLit (ParserC-45LexerC-45Source-n--5461-6339-u--removeUnderscores eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-hexUnderscoredLit) (lambda (eta-0) (vector 2 (ParserC-45LexerC-45Source-fromHexLit (ParserC-45LexerC-45Source-n--5461-6339-u--removeUnderscores eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-octUnderscoredLit) (lambda (eta-0) (vector 2 (ParserC-45LexerC-45Source-fromOctLit (ParserC-45LexerC-45Source-n--5461-6339-u--removeUnderscores eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-digitsUnderscoredLit) (lambda (eta-0) (vector 2 (PreludeC-45Cast-u--cast_Cast_String_Integer (ParserC-45LexerC-45Source-n--5461-6339-u--removeUnderscores eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-compose (ParserC-45LexerC-45Source-multilineBegin) (lambda (eta-0) (vector 3 0)) (lambda (eta-0) (ParserC-45LexerC-45Source-n--5461-6337-u--countHashtag eta-0)) (lambda () (lambda (eta-0) (ParserC-45LexerC-45Source-stringTokens 1 eta-0))) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact (ParserC-45LexerC-45Source-multilineEnd eta-0))) (lambda (eta-0) (vector 4 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-compose (ParserC-45LexerC-45Source-stringBegin) (lambda (eta-0) (vector 3 1)) (lambda (eta-0) (ParserC-45LexerC-45Source-n--5461-6337-u--countHashtag eta-0)) (lambda () (lambda (eta-0) (ParserC-45LexerC-45Source-stringTokens 0 eta-0))) (lambda (u--hashtag) (vector 4 (LibrariesC-45TextC-45Lexer-exact (ParserC-45LexerC-45Source-stringEnd u--hashtag)) (lambda () (LibrariesC-45TextC-45LexerC-45Core-reject (LibrariesC-45TextC-45Lexer-is #\"))))) (lambda (eta-0) (vector 4 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-charLit) (lambda (eta-0) (vector 0 (LibrariesC-45UtilsC-45String-stripQuotes eta-0)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Source-dotIdent) (lambda (u--x) (vector 11 (DataC-45String-strTail u--x)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Common-namespacedIdent) (lambda (eta-0) (ParserC-45LexerC-45Source-n--5461-6336-u--parseNamespace eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Common-identNormal) (lambda (eta-0) (ParserC-45LexerC-45Source-n--5461-6335-u--parseIdent eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Source-pragma) (lambda (u--x) (vector 19 (DataC-45String-strTail u--x)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-space) (lambda (eta-0) (vector 13 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Source-validSymbol) (lambda (eta-0) (vector 12 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-symbol) (lambda (eta-0) (vector 20 eta-0))))))))))))))))))))))))))))))))))))))))))))))))
(define ParserC-45LexerC-45Source-pragma(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-is #\%) (lambda () (ParserC-45LexerC-45Common-identNormal))))))
(define ParserC-45LexerC-45Source-multilineEnd (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 "\"\"\"" (LibrariesC-45DataC-45StringC-45Extra-replicate arg-0 #\#))))
(define ParserC-45LexerC-45Source-multilineBegin(blodwen-lazy (lambda () (vector 4 (vector 4 (vector 5 (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-is #\#)) (LibrariesC-45TextC-45Lexer-exact "\"\"\"")) (lambda () (LibrariesC-45TextC-45Lexer-manyUntil (LibrariesC-45TextC-45Lexer-newline) (LibrariesC-45TextC-45Lexer-space)))) (lambda () (LibrariesC-45TextC-45Lexer-newline))))))
(define ParserC-45LexerC-45Source-mkDirective (lambda (arg-0) (vector 16 (DataC-45String-trim (PreludeC-45Types-substr (+ 1 (+ 1 (+ 1 0))) (PreludeC-45TypesC-45String-length arg-0) arg-0)))))
(define ParserC-45LexerC-45Source-lexTo (lambda (arg-0 arg-1) (ParserC-45LexerC-45Source-case--lexTo-6720 arg-1 arg-0 (LibrariesC-45TextC-45LexerC-45Tokenizer-lexTo arg-0 (ParserC-45LexerC-45Source-rawTokens) arg-1))))
(define ParserC-45LexerC-45Source-keywords(blodwen-lazy (lambda () (cons "data" (cons "module" (cons "where" (cons "let" (cons "in" (cons "do" (cons "record" (cons "auto" (cons "default" (cons "implicit" (cons "mutual" (cons "namespace" (cons "parameters" (cons "with" (cons "proof" (cons "impossible" (cons "case" (cons "of" (cons "if" (cons "then" (cons "else" (cons "forall" (cons "rewrite" (cons "using" (cons "interface" (cons "implementation" (cons "open" (cons "import" (cons "public" (cons "export" (cons "private" (cons "infixl" (cons "infixr" (cons "infix" (cons "prefix" (cons "total" (cons "partial" (cons "covering" '())))))))))))))))))))))))))))))))))))))))))
(define ParserC-45LexerC-45Source-isOpUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (DataC-45Maybe-fromMaybe (lambda () 0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-fst eta-0)) (PreludeC-45Types-strUncons e-0)) (lambda (u--c) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (ParserC-45LexerC-45Source-isOpChar u--c)) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe 1)))))))) ((1) 0) (else 0))))
(define ParserC-45LexerC-45Source-isOpName (lambda (ext-0) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (ParserC-45LexerC-45Source-isOpUserName eta-0))) (CoreC-45Name-userNameRoot ext-0))))
(define ParserC-45LexerC-45Source-isOpChar (lambda (arg-0) (PreludeC-45Types-elem (csegen-0) arg-0 (PreludeC-45Types-fastUnpack ":!#$%&*+./<=>?@\\^|-~"))))
(define ParserC-45LexerC-45Source-holeIdent(blodwen-lazy (lambda () (csegen-1758))))
(define ParserC-45LexerC-45Source-groupSymbols(blodwen-lazy (lambda () (cons ".(" (cons "@{" (cons "[|" (cons "(" (cons "{" (cons "[<" (cons "[>" (cons "[" (cons "`(" (cons "`{" (cons "`[" '()))))))))))))))
(define ParserC-45LexerC-45Source-groupClose (lambda (arg-0) (cond ((equal? arg-0 ".(") ")") ((equal? arg-0 "@{") "}") ((equal? arg-0 "[|") "|]") ((equal? arg-0 "(") ")") ((equal? arg-0 "[") "]") ((equal? arg-0 "[<") "]") ((equal? arg-0 "[>") "]") ((equal? arg-0 "{") "}") ((equal? arg-0 "`(") ")") ((equal? arg-0 "`{") "}") ((equal? arg-0 "`[") "]")(else ""))))
(define ParserC-45LexerC-45Source-fromOctLit (lambda (arg-0) (let ((sc0 (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45String-length arg-0) (PreludeC-45Types-u--fromInteger_Num_Nat 2)))) (cond ((equal? sc0 1) 0) (else (let ((u--num (DataC-45String-strTail (DataC-45String-strTail arg-0)))) (DataC-45Maybe-fromMaybe (lambda () 0) (LibrariesC-45UtilsC-45Octal-fromOct (PreludeC-45Types-reverse u--num)))))))))
(define ParserC-45LexerC-45Source-fromHexLit (lambda (arg-0) (let ((sc0 (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45String-length arg-0) (PreludeC-45Types-u--fromInteger_Num_Nat 2)))) (cond ((equal? sc0 1) 0) (else (let ((u--num (DataC-45String-strTail (DataC-45String-strTail arg-0)))) (DataC-45Maybe-fromMaybe (lambda () 0) (LibrariesC-45UtilsC-45Hex-fromHex (PreludeC-45Types-reverse u--num)))))))))
(define ParserC-45LexerC-45Source-fromBinLit (lambda (arg-0) (let ((sc0 (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45String-length arg-0) (PreludeC-45Types-u--fromInteger_Num_Nat 2)))) (cond ((equal? sc0 1) 0) (else (let ((u--num (DataC-45String-strTail (DataC-45String-strTail arg-0)))) (ParserC-45LexerC-45Source-n--5335-6143-u--fromBin arg-0 (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (ParserC-45LexerC-45Source-n--5335-6142-u--castBin arg-0 eta-0)) (PreludeC-45Types-fastUnpack u--num))))))))))
(define ParserC-45LexerC-45Source-doubleLit(blodwen-lazy (lambda () (vector 4 (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-digits) (lambda () (LibrariesC-45TextC-45Lexer-is #\.))) (lambda () (LibrariesC-45TextC-45Lexer-digits))) (lambda () (LibrariesC-45TextC-45Lexer-opt (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-is #\e) (lambda () (LibrariesC-45TextC-45Lexer-opt (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-is #\-) (LibrariesC-45TextC-45Lexer-is #\+))))) (lambda () (LibrariesC-45TextC-45Lexer-digits)))))))))
(define ParserC-45LexerC-45Source-doubleDash (lambda (arg-0) (vector 5 (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-is #\-)) (LibrariesC-45TextC-45Lexer-choice 1 (csegen-51) (cons (vector 4 (LibrariesC-45TextC-45Lexer-is #\}) (lambda () (ParserC-45LexerC-45Source-toEndComment arg-0))) (cons (vector 5 (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-isNot (integer->char 10))) (ParserC-45LexerC-45Source-toEndComment (+ 1 arg-0))) '()))))))
(define ParserC-45LexerC-45Source-dotIdent(blodwen-lazy (lambda () (csegen-1777))))
(define ParserC-45LexerC-45Source-docComment(blodwen-lazy (lambda () (vector 4 (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-is #\|) (lambda () (LibrariesC-45TextC-45Lexer-is #\|))) (lambda () (LibrariesC-45TextC-45Lexer-is #\|))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-isNot (integer->char 10))))))))
(define ParserC-45LexerC-45Source-cgDirective(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-exact "%cg") (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 4 (vector 4 (vector 4 (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45Lexer-space)) (lambda () (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isAlphaNum eta-0)))))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-space)))) (lambda () (LibrariesC-45TextC-45Lexer-is #\{))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-isNot #\})))) (lambda () (LibrariesC-45TextC-45Lexer-is #\}))) (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-isNot (integer->char 10)))))))))
(define ParserC-45LexerC-45Source-blockComment(blodwen-lazy (lambda () (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-is #\{) (lambda () (LibrariesC-45TextC-45Lexer-is #\-))) (lambda () (ParserC-45LexerC-45Source-toEndComment (+ 1 0)))))))
(define LibrariesC-45UtilsC-45Octal-n--2624-750-u--fromOctCharsC-39 (lambda (arg-0 arg-1) (if (null? arg-1) (box 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Octal-fromOctDigit (PreludeC-45Types-toLower e-2)) (lambda (u--digit) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Octal-n--2624-750-u--fromOctCharsC-39 (* arg-0 8) e-3) (lambda (u--digits) (PreludeC-45Types-u--pure_Applicative_Maybe (+ (* (PreludeC-45Cast-u--cast_Cast_Int_Integer u--digit) arg-0) u--digits)))))))))))
(define LibrariesC-45UtilsC-45Octal-fromOctDigit (lambda (arg-0) (cond ((equal? arg-0 #\0) (box 0)) ((equal? arg-0 #\1) (box 1)) ((equal? arg-0 #\2) (box 2)) ((equal? arg-0 #\3) (box 3)) ((equal? arg-0 #\4) (box 4)) ((equal? arg-0 #\5) (box 5)) ((equal? arg-0 #\6) (box 6)) ((equal? arg-0 #\7) (box 7))(else '()))))
(define LibrariesC-45UtilsC-45Octal-fromOctChars (lambda (ext-0) (LibrariesC-45UtilsC-45Octal-n--2624-750-u--fromOctCharsC-39 1 ext-0)))
(define LibrariesC-45UtilsC-45Octal-fromOct (lambda (ext-0) (LibrariesC-45UtilsC-45Octal-fromOctChars (PreludeC-45Types-fastUnpack ext-0))))
(define LibrariesC-45UtilsC-45Hex-n--3814-873-u--fromHexCharsC-39 (lambda (arg-0 arg-1) (if (null? arg-1) (box 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Hex-fromHexDigit (PreludeC-45Types-toLower e-2)) (lambda (u--digit) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Hex-n--3814-873-u--fromHexCharsC-39 (* arg-0 16) e-3) (lambda (u--digits) (PreludeC-45Types-u--pure_Applicative_Maybe (+ (* (PreludeC-45Cast-u--cast_Cast_Int_Integer u--digit) arg-0) u--digits)))))))))))
(define LibrariesC-45UtilsC-45Hex-n--3637-704-u--asHexC-39 (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) arg-2)(else (LibrariesC-45UtilsC-45Hex-n--3637-704-u--asHexC-39 arg-0 (blodwen-shr arg-1 (PreludeC-45Cast-u--cast_Cast_Nat_Bits64 (DataC-45Bits-fromNat (+ 1 (+ 1 (+ 1 (+ 1 0)))) (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (cons (LibrariesC-45UtilsC-45Hex-hexDigit (blodwen-and arg-1 15)) arg-2))))))
(define LibrariesC-45UtilsC-45Hex-leftPad (lambda (arg-0 arg-1 arg-2) (let ((sc0 (PreludeC-45Types-u--C-60_Ord_Nat (PreludeC-45TypesC-45String-length arg-2) arg-1))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-fastPack (DataC-45List-replicate (PreludeC-45Types-prim__integerToNat (- arg-1 (PreludeC-45TypesC-45String-length arg-2))) arg-0)) arg-2)) (else arg-2)))))
(define LibrariesC-45UtilsC-45Hex-hexDigit (lambda (arg-0) (cond ((equal? arg-0 0) #\0) ((equal? arg-0 1) #\1) ((equal? arg-0 2) #\2) ((equal? arg-0 3) #\3) ((equal? arg-0 4) #\4) ((equal? arg-0 5) #\5) ((equal? arg-0 6) #\6) ((equal? arg-0 7) #\7) ((equal? arg-0 8) #\8) ((equal? arg-0 9) #\9) ((equal? arg-0 10) #\a) ((equal? arg-0 11) #\b) ((equal? arg-0 12) #\c) ((equal? arg-0 13) #\d) ((equal? arg-0 14) #\e) ((equal? arg-0 15) #\f)(else #\X))))
(define LibrariesC-45UtilsC-45Hex-fromHexDigit (lambda (arg-0) (cond ((equal? arg-0 #\0) (box 0)) ((equal? arg-0 #\1) (box 1)) ((equal? arg-0 #\2) (box 2)) ((equal? arg-0 #\3) (box 3)) ((equal? arg-0 #\4) (box 4)) ((equal? arg-0 #\5) (box 5)) ((equal? arg-0 #\6) (box 6)) ((equal? arg-0 #\7) (box 7)) ((equal? arg-0 #\8) (box 8)) ((equal? arg-0 #\9) (box 9)) ((equal? arg-0 #\a) (box 10)) ((equal? arg-0 #\b) (box 11)) ((equal? arg-0 #\c) (box 12)) ((equal? arg-0 #\d) (box 13)) ((equal? arg-0 #\e) (box 14)) ((equal? arg-0 #\f) (box 15))(else '()))))
(define LibrariesC-45UtilsC-45Hex-fromHexChars (lambda (ext-0) (LibrariesC-45UtilsC-45Hex-n--3814-873-u--fromHexCharsC-39 1 ext-0)))
(define LibrariesC-45UtilsC-45Hex-fromHex (lambda (ext-0) (LibrariesC-45UtilsC-45Hex-fromHexChars (PreludeC-45Types-fastUnpack ext-0))))
(define LibrariesC-45UtilsC-45Hex-asHex (lambda (arg-0) (cond ((equal? arg-0 0) "0")(else (PreludeC-45Types-fastPack (LibrariesC-45UtilsC-45Hex-n--3637-704-u--asHexC-39 arg-0 arg-0 '()))))))
(define DataC-45Bits-fromNat (lambda (arg-0 arg-1) arg-0))
(define ParserC-45LexerC-45Common-spacesOrNewlines(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-space) (LibrariesC-45TextC-45Lexer-newline))))))
(define ParserC-45LexerC-45Common-namespacedIdent(blodwen-lazy (lambda () (vector 4 (ParserC-45LexerC-45Common-namespaceIdent) (lambda () (LibrariesC-45TextC-45Lexer-opt (csegen-1777)))))))
(define ParserC-45LexerC-45Common-namespaceIdent(blodwen-lazy (lambda () (vector 4 (csegen-1796) (lambda () (LibrariesC-45TextC-45Lexer-many (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-is #\.) (lambda () (csegen-1796))) (lambda () (LibrariesC-45TextC-45LexerC-45Core-expect (LibrariesC-45TextC-45Lexer-is #\.))))))))))
(define ParserC-45LexerC-45Common-isIdentTrailing (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 #\-) 1)(else (cond ((equal? arg-1 #\') 1) ((equal? arg-1 #\_) 1)(else (let ((sc1 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-1 (PreludeC-45Types-chr (blodwen-toSignedInt 160 63)))))))))))(else (cond ((equal? arg-1 #\') 1) ((equal? arg-1 #\_) 1)(else (let ((sc0 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc0 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-1 (PreludeC-45Types-chr (blodwen-toSignedInt 160 63))))))))))))
(define ParserC-45LexerC-45Common-isIdentStart (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\_) 1)(else (cond ((equal? arg-0 1) (let ((sc1 (PreludeC-45Types-isUpper arg-1))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-1 (PreludeC-45Types-chr (blodwen-toSignedInt 160 63)))))))(else (let ((sc0 (PreludeC-45Types-isAlpha arg-1))) (cond ((equal? sc0 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-1 (PreludeC-45Types-chr (blodwen-toSignedInt 160 63))))))))))))
(define ParserC-45LexerC-45Common-isIdentNormal (lambda (ext-0) (let ((sc0 (PreludeC-45Types-fastUnpack ext-0))) (if (null? sc0) 0 (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (ParserC-45LexerC-45Common-isIdentStart 2 e-2))) (cond ((equal? sc1 1) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentTrailing 2 eta-0)) e-3)) (else 0)))))))))
(define ParserC-45LexerC-45Common-identNormal(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentStart 2 eta-0))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentTrailing 2 eta-0)))))))))
(define ParserC-45LexerC-45Common-identAllowDashes(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentStart 0 eta-0))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentTrailing 0 eta-0)))))))))
(define ParserC-45LexerC-45Common-comment(blodwen-lazy (lambda () (vector 4 (vector 4 (vector 4 (vector 4 (LibrariesC-45TextC-45Lexer-is #\-) (lambda () (LibrariesC-45TextC-45Lexer-is #\-))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-is #\-)))) (lambda () (LibrariesC-45TextC-45LexerC-45Core-reject (LibrariesC-45TextC-45Lexer-is #\})))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-isNot (integer->char 10))))))))
(define TTImpC-45Unelab-case--dropParams-4643 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 (cons arg-1 arg-2))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((sc2 (DataC-45List-lookup (csegen-802) (let ((e-4 (vector-ref e-6 2))) e-4) arg-3))) (if (null? sc2) (vector 1 (cons arg-1 arg-2)) (let ((e-4 (unbox sc2))) (vector 1 (cons (TTImpC-45Unelab-n--7214-4617-u--apply arg-1 arg-2 arg-3 arg-4 (vector 0 e-5 e-6) (DataC-45List-drop e-4 e-3)) arg-2))))))))(else (vector 1 (cons arg-1 arg-2))))))))))
(define TTImpC-45Unelab-case--caseC-32blockC-32inC-32unelabCase-4249 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 2))) (let ((e-2 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 5))) (let ((sc1 (TTImpC-45Unelab-n--7204-3994-u--findArgPos arg-0 arg-1 arg-2 arg-3 arg-4 e-2))) (if (null? sc1) (lambda (eta-0) (vector 1 arg-0)) (let ((e-5 (unbox sc1))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-1) (PreludeC-45TypesC-45List-length e-1)))) (cond ((equal? sc2 1) (TTImpC-45Unelab-n--7204-3999-u--mkCase arg-0 arg-1 arg-2 arg-3 arg-4 e-4 e-5 0 arg-1)) (else (lambda (eta-0) (vector 1 arg-0))))))))))))(else (lambda (eta-0) (vector 1 arg-0))))))
(define TTImpC-45Unelab-n--7045-3815-u--usedBinder (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((sc1 (TTImpC-45Unelab-used arg-5 e-3))) (cond ((equal? sc1 1) 1) (else (TTImpC-45Unelab-used arg-5 e-4)))))))(else (TTImpC-45Unelab-used arg-5 (CoreC-45TT-binderType arg-6))))))
(define TTImpC-45Unelab-n--7226-5199-u--uniqueLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((sc0 (PreludeC-45Types-elem (csegen-802) arg-10 arg-9))) (cond ((equal? sc0 1) (TTImpC-45Unelab-n--7226-5199-u--uniqueLocal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (TTImpC-45Unelab-n--7226-5198-u--next arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10))) (else arg-10)))))
(define TTImpC-45Unelab-n--10655-6865-u--toName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-4 (vector-ref arg-8 3))) (box (CoreC-45TT-nameAt arg-0 e-4))))(else '()))))
(define TTImpC-45Unelab-n--10655-6867-u--showScope (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (TTImpC-45Unelab-n--10655-6866-u--showNScope arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (DataC-45List-mapMaybe (lambda (eta-0) (TTImpC-45Unelab-n--10655-6865-u--toName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) arg-8)))))
(define TTImpC-45Unelab-n--10655-6866-u--showNScope (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) "[no locals in scope]" (PreludeC-45TypesC-45String-C-43C-43 "[locals in scope: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) (DataC-45List-nub (csegen-802) arg-8))) "]")))))
(define TTImpC-45Unelab-n--7204-3997-u--nthArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((4) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (TTImpC-45Unelab-n--7204-3996-u--getNth arg-0 arg-1 arg-2 arg-3 arg-4 arg-7 (vector 4 e-1 e-2 e-3))))))(else (vector 10 arg-6 0)))))
(define TTImpC-45Unelab-n--7226-5198-u--next (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((2) (let ((e-0 (vector-ref arg-9 1))) (let ((e-1 (vector-ref arg-9 2))) (vector 2 e-0 (bs+ e-1 1 63))))) ((1) (let ((e-2 (vector-ref arg-9 1))) (vector 2 (CoreC-45Name-u--show_Show_UserName e-2) 0))) ((0) (let ((e-3 (vector-ref arg-9 1))) (let ((e-4 (vector-ref arg-9 2))) (vector 0 e-3 (TTImpC-45Unelab-n--7226-5198-u--next arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-4)))))(else (vector 2 (CoreC-45Name-u--show_Show_Name arg-9) 0)))))
(define TTImpC-45Unelab-n--7204-3998-u--mkClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--pat (TTImpC-45Unelab-n--7204-3997-u--nthArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-10))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm e-2 arg-4 "unelab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "Unelaborating LHS") u--pat eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (TTImpC-45Unelab-unelabTy e-2 arg-4 (vector 0 ) arg-3 e-6 u--pat eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-logTerm e-2 arg-4 "unelab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "Unelaborating RHS") e-11 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (CoreC-45Normalise-logEnv e-2 arg-4 "unelab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) "In Env" e-6 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (TTImpC-45Unelab-unelabTy e-2 arg-4 (vector 0 ) arg-3 e-6 e-11 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-28 1))) (vector 1 (vector 0 arg-5 (Builtin-fst e-8) (Builtin-fst e-13))))))))))))))))))))))))))))))
(define TTImpC-45Unelab-n--7204-3999-u--mkCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (cond ((equal? arg-6 0) (lambda (clam-0) (if (null? arg-8) (vector 1 arg-0) (let ((e-5 (car arg-8))) (case (vector-ref e-5 0) ((0) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45Unelab-n--7204-3998-u--mkClause arg-0 arg-1 arg-2 arg-3 arg-4 e-8 arg-7 eta-0)) arg-5 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (vector 4 e-8 e-9 (vector 32 e-8 0) e-7)))))))))(else (vector 1 arg-0)))))))(else (let ((e-0 (- arg-6 1))) (if (null? arg-8) (lambda (eta-0) (vector 1 arg-0)) (let ((e-3 (cdr arg-8))) (TTImpC-45Unelab-n--7204-3999-u--mkCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-0 (+ 1 arg-7) e-3))))))))
(define TTImpC-45Unelab-n--7237-6312-u--isNoSugar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((1) 1)(else 0))))
(define TTImpC-45Unelab-n--7237-6313-u--isDefImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15) (case (vector-ref arg-15 0) ((3) 1)(else 0))))
(define TTImpC-45Unelab-n--7204-3995-u--idxOrDefault (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8) (cond ((equal? arg-6 0) (if (null? arg-8) arg-7 (let ((e-3 (car arg-8))) e-3)))(else (let ((e-1 (- arg-6 1))) (if (null? arg-8) arg-7 (let ((e-7 (cdr arg-8))) (TTImpC-45Unelab-n--7204-3995-u--idxOrDefault arg-0 arg-1 arg-2 arg-3 arg-4 e-1 arg-7 e-7))))))))
(define TTImpC-45Unelab-n--7204-3996-u--getNth (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (let ((sc0 (CoreC-45TT-getFnArgs arg-7))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (TTImpC-45Unelab-n--7204-3995-u--idxOrDefault arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 e-2 e-3))))))
(define TTImpC-45Unelab-n--7204-3994-u--findArgPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 2))) (box e-2)))(else '()))))
(define TTImpC-45Unelab-n--7214-4617-u--apply (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (TTImpC-45Unelab-n--7214-4617-u--apply arg-1 arg-2 arg-3 arg-4 (vector 8 e-5 arg-5 e-6) e-3)))) ((1) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (TTImpC-45Unelab-n--7214-4617-u--apply arg-1 arg-2 arg-3 arg-4 (vector 9 e-8 arg-5 e-9) e-3)))) (else (let ((e-11 (vector-ref e-2 1))) (let ((e-12 (vector-ref e-2 2))) (let ((e-13 (vector-ref e-2 3))) (TTImpC-45Unelab-n--7214-4617-u--apply arg-1 arg-2 arg-3 arg-4 (vector 10 e-11 arg-5 e-12 e-13) e-3)))))))))))
(define TTImpC-45Unelab-used (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-1 e-4))) ((3) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((sc1 (TTImpC-45Unelab-n--7045-3815-u--usedBinder e-7 e-8 e-10 e-9 arg-1 e-9))) (cond ((equal? sc1 1) 1) (else (TTImpC-45Unelab-used (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-1) e-10))))))))) ((2) (let ((e-15 (vector-ref arg-2 4))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45Unelab-used arg-1 eta-0)) e-15))) ((4) (let ((e-18 (vector-ref arg-2 2))) (let ((e-19 (vector-ref arg-2 3))) (let ((sc1 (TTImpC-45Unelab-used arg-1 e-18))) (cond ((equal? sc1 1) 1) (else (TTImpC-45Unelab-used arg-1 e-19))))))) ((5) (let ((e-24 (vector-ref arg-2 4))) (TTImpC-45Unelab-used arg-1 e-24))) ((6) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45Unelab-used arg-1 e-28))) ((7) (let ((e-33 (vector-ref arg-2 4))) (TTImpC-45Unelab-used arg-1 e-33))) ((8) (let ((e-37 (vector-ref arg-2 3))) (TTImpC-45Unelab-used arg-1 e-37)))(else 0))))
(define TTImpC-45Unelab-unelabUniqueBinders (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 (vector 1 1) '() arg-2 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (Builtin-fst e-5))))))))
(define TTImpC-45Unelab-unelabTyC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 3))) (let ((u--nm (CoreC-45TT-nameAt arg-0 e-4))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "unelab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Found local name: " (CoreC-45Name-u--show_Show_Name u--nm))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((u--ty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 (CoreC-45TT-binderType (CoreC-45Env-getBinder (csegen-764) arg-0 e-4 arg-4))))) (vector 1 (cons (vector 0 e-2 (vector (box (vector 0 )) u--nm u--nm)) u--ty))))))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact e-9 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (case (vector-ref arg-2 0) ((2) (vector 1 (cons (vector 32 e-7 1) (CoreC-45NormaliseC-45Eval-gErased e-7))))(else (vector 1 (cons (vector 0 e-7 (vector (box e-8) e-9 e-9)) (CoreC-45NormaliseC-45Eval-gErased e-7))))) (let ((e-1 (unbox e-6))) (let ((act-26 (CoreC-45Context-getFullName arg-1 e-9 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (case (vector-ref arg-2 0) ((1) (vector 1 e-10))(else (CoreC-45Context-aliasName arg-1 e-10 eta-0))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-1 "unelab.var" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (DataC-45String-unwords (cons "Found name:" (cons (CoreC-45Name-u--show_Show_Name e-9) (cons (PreludeC-45TypesC-45String-C-43C-43 " (aka " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-10) ")")) (cons "sugared to" (cons (CoreC-45Name-u--show_Show_Name e-11) '()))))))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 0 e-7 (vector (box e-8) e-10 e-11)) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 (CoreC-45TT-embed e-1)))))))))))))))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--mkn (CoreC-45Name-nameRoot e-12))) (let ((act-25 (CoreC-45Context-lookupTyExact (vector 8 e-13) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (case (vector-ref arg-2 0) ((2) (vector 1 (cons (vector 32 e-11 1) (CoreC-45NormaliseC-45Eval-gErased e-11))))(else (vector 1 (cons (vector 30 e-11 u--mkn) (CoreC-45NormaliseC-45Eval-gErased e-11))))) (let ((e-1 (unbox e-6))) (vector 1 (cons (vector 30 e-11 u--mkn) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 (CoreC-45TT-embed e-1)))))))))))))))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 (TTImpC-45Unelab-unelabTy (cons e-17 arg-0) arg-1 arg-2 arg-3 (cons e-18 arg-4) e-19 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (cond ((equal? e-0 1) (let ((u--xC-39 (TTImpC-45Unelab-n--7226-5199-u--uniqueLocal arg-0 e-17 e-19 e-18 e-16 arg-4 arg-3 arg-2 arg-1 arg-0 e-17))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45Unelab-unelabBinder arg-0 arg-1 arg-2 arg-3 e-16 arg-4 u--xC-39 e-18 (CoreC-45TT-renameVars (+ 1 0) e-19) e-2 (CoreC-45TT-renameVars (+ 1 0) e-6) eta-0)))))))(else (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45Unelab-unelabBinder arg-0 arg-1 arg-2 arg-3 e-16 arg-4 e-17 e-18 e-19 e-2 e-6 eta-0)))))))))(else (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45Unelab-unelabBinder arg-0 arg-1 arg-2 arg-3 e-16 arg-4 e-17 e-18 e-19 e-2 e-6 eta-0))))))))))))))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-4 e-22 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-4 e-23 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-3) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((0) (let ((e-12 (vector-ref e-8 2))) (let ((e-11 (vector-ref e-8 3))) (let ((e-10 (vector-ref e-8 4))) (case (vector-ref e-11 0) ((2) (let ((e-14 (vector-ref e-11 3))) (case (vector-ref e-14 0) ((1) (let ((act-28 (((e-10 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-4 e-23)) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-17 (vector-ref act-28 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-28 1))) (vector 1 (cons (vector 8 e-21 e-2 e-7) (CoreC-45Normalise-glueBack arg-1 arg-0 e-9 arg-4 e-17))))))))(else (let ((act-28 (((e-10 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-4 e-23)) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-17 (vector-ref act-28 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-28 1))) (vector 1 (cons (vector 10 e-21 e-2 e-12 e-7) (CoreC-45Normalise-glueBack arg-1 arg-0 e-9 arg-4 e-17)))))))))))(else (vector 1 (cons (vector 8 e-21 e-2 e-7) (CoreC-45NormaliseC-45Eval-gErased e-21)))))))))(else (vector 1 (cons (vector 8 e-21 e-2 e-7) (CoreC-45NormaliseC-45Eval-gErased e-21))))))))))))))))))))))))))))) ((5) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-27 (vector-ref arg-5 3))) (let ((e-28 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-27) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-28) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (case (vector-ref e-2 0) ((0) (let ((e-8 (vector-ref e-2 2))) (case (vector-ref arg-2 0) ((1) (vector 1 (cons (vector 18 e-25 (CoreC-45TT-getLoc e-27) e-26 (let ((e-9 (vector-ref e-8 2))) e-9) e-7) e-4)))(else (vector 1 (cons e-7 e-4))))))(else (vector 1 (cons e-7 e-4))))))))))))))))))))) ((6) (let ((e-30 (vector-ref arg-5 1))) (let ((e-31 (vector-ref arg-5 2))) (let ((e-32 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-32) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 (cons (vector 20 e-30 e-31 e-2) (CoreC-45NormaliseC-45Eval-gErased e-30)))))))))))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-37 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-37) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 (cons (vector 21 e-34 e-2) (CoreC-45NormaliseC-45Eval-gErased e-34))))))))))))))) ((8) (let ((e-39 (vector-ref arg-5 1))) (let ((e-41 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-41) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 (cons (vector 22 e-39 e-2) (CoreC-45NormaliseC-45Eval-gErased e-39))))))))))))))) ((9) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (cons (vector 28 e-43 e-44) (CoreC-45NormaliseC-45Eval-gErased e-43))))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (cons (vector 32 e-46 1) (CoreC-45NormaliseC-45Eval-gErased e-46)))))) (else (let ((e-49 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (cons (vector 29 e-49) (CoreC-45NormaliseC-45Eval-gType e-49)))))))))
(define TTImpC-45Unelab-unelabTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Unelab-dropParams arg-1 arg-3 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45Unelab-unelabSugar arg-1 arg-2 arg-3 e-6) ext-0)))))))))))
(define TTImpC-45Unelab-unelabSugar (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((1) (lambda (eta-0) (vector 1 arg-4))) ((2) (lambda (eta-0) (vector 1 arg-4)))(else (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (TTImpC-45TTImp-getFnArgs e-2 '()))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (case (vector-ref e-5 0) ((0) (let ((e-6 (vector-ref e-5 2))) (let ((e-7 (vector-ref e-6 2))) (lambda (clam-0) (case (vector-ref e-7 0) ((0) (let ((e-11 (vector-ref e-7 1))) (let ((e-10 (vector-ref e-7 2))) (case (vector-ref e-10 0) ((6) (let ((e-13 (vector-ref e-10 1))) (let ((e-12 (vector-ref e-10 2))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "unelab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (DataC-45String-fastUnlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Unelaborating case " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-576) (csegen-246)) (cons e-13 e-12))) (cons (PreludeC-45TypesC-45String-C-43C-43 "with arguments: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ArgC-39C-32C-36nmC-41 (csegen-1262) u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ArgC-39C-32C-36nmC-41 (csegen-1262) u--d u--x)))) e-4)) '())))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-14 (vector-ref act-24 1))) (vector 0 e-14))) (else (let ((act-25 (TTImpC-45Unelab-unelabCase arg-1 arg-3 (vector 0 e-11 (vector 6 e-13 e-12)) e-4 e-2 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "unelab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Unelaborated to: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-1262) e-15))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (vector 1 (cons e-15 e-3)))))))))))))))(else (vector 1 (cons e-2 e-3)))))))(else (vector 1 (cons e-2 e-3))))))))(else (lambda (eta-0) (vector 1 (cons e-2 e-3))))))))))))))
(define TTImpC-45Unelab-unelabPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-4 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (vector 1 (vector 3 e-2))))))))))))
(define TTImpC-45Unelab-unelabNoSugar (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 (vector 1 0) '() arg-2 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (Builtin-fst e-5))))))))
(define TTImpC-45Unelab-unelabNoPatvars (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 (vector 2 ) '() arg-2 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (Builtin-fst e-5))))))))
(define TTImpC-45Unelab-unelabNest (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((u--mkn (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-nameRoot e-2) (TTImpC-45Unelab-n--10655-6867-u--showScope arg-0 e-4 e-3 e-2 e-1 arg-3 arg-2 arg-1 e-4)))) (lambda (eta-0) (vector 1 (vector 30 e-1 u--mkn)))))))))(else (lambda (eta-0) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 (vector 0 ) arg-2 arg-3 arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (Builtin-fst e-5)))))))))))
(define TTImpC-45Unelab-unelabCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 arg-4) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((TTImpC-45Unelab-case--caseC-32blockC-32inC-32unelabCase-4249 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17)) ext-0))))))))))))))
(define TTImpC-45Unelab-unelabBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-7 (car e-5))) (let ((act-25 (TTImpC-45Unelab-unelabPi arg-0 arg-1 arg-2 arg-3 arg-5 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (cons (vector 2 arg-4 e-2 e-8 (box arg-6) e-7 arg-9) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 3 arg-4 arg-6 (vector 2 e-1 e-2 e-3 e-4) arg-10)))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((e-9 (vector-ref arg-7 4))) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-9 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (let ((e-11 (car e-10))) (vector 1 (cons (vector 3 arg-4 (vector 2 ) e-7 arg-6 e-11 e-2 arg-9) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 3 arg-4 arg-6 (vector 1 e-6 e-7 e-8 e-9) arg-10))))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-14 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (TTImpC-45Unelab-unelabPi arg-0 arg-1 arg-2 arg-3 arg-5 e-13 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--nm (let ((sc4 (let ((sc5 (TTImpC-45Unelab-used 0 arg-8))) (cond ((equal? sc5 1) 1) (else (TTImpC-45Unelab-n--7237-6312-u--isNoSugar arg-0 e-11 e-14 e-13 e-12 arg-6 arg-10 arg-9 arg-8 arg-5 arg-4 arg-3 arg-2 arg-1 arg-2)))))) (cond ((equal? sc4 1) (box arg-6)) (else (let ((sc5 (let ((sc6 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-12 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))) (cond ((equal? sc6 1) 1) (else (TTImpC-45Unelab-n--7237-6313-u--isDefImp arg-0 e-11 e-14 e-13 e-12 arg-6 arg-10 arg-9 arg-8 arg-5 arg-4 arg-3 arg-2 arg-1 e-13)))))) (cond ((equal? sc5 1) (box (vector 1 (vector 2 )))) (else '())))))))) (vector 1 (cons (vector 1 arg-4 e-12 e-6 u--nm e-2 arg-9) (CoreC-45NormaliseC-45Eval-gType arg-4)))))))))))))))))) ((3) (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-19 (vector-ref arg-7 4))) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-19 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-9 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 3 arg-4 arg-6 (vector 5 e-16 e-17 e-19) arg-10)))))))))))) ((4) (let ((e-21 (vector-ref arg-7 1))) (let ((e-22 (vector-ref arg-7 2))) (let ((e-23 (vector-ref arg-7 3))) (let ((e-24 (vector-ref arg-7 4))) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-23 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-24 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (vector 1 (cons (vector 3 arg-4 (vector 2 ) e-22 arg-6 e-7 e-2 arg-9) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 3 arg-4 arg-6 (vector 4 e-21 e-22 e-23 e-24) arg-10))))))))))))))))))) (else (let ((e-28 (vector-ref arg-7 3))) (let ((act-24 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-28 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-9 (CoreC-45NormaliseC-45Eval-gType arg-4))))))))))))
(define TTImpC-45Unelab-unelab (lambda (arg-0 arg-1 ext-0 ext-1) (TTImpC-45Unelab-unelabNest arg-0 arg-1 '() ext-0 ext-1)))
(define TTImpC-45Unelab-dropParams (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (TTImpC-45Unelab-case--dropParams-4643 e-2 e-3 arg-2 arg-1 (TTImpC-45TTImp-getFnArgs e-2 '()))))))
(define TTImpC-45Utils-case--nameNum-2214 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 "") (cons arg-0 0))(else (let ((sc1 (PreludeC-45Types-fastUnpack e-3))) (if (null? sc1) (cons arg-0 0) (let ((e-1 (car sc1))) (let ((e-4 (cdr sc1))) (cond ((equal? e-1 #\_) (cons (PreludeC-45Types-reverse (PreludeC-45Types-fastPack e-4)) (PreludeC-45Cast-u--cast_Cast_String_Int (PreludeC-45Types-reverse e-2))))(else (cons arg-0 0)))))))))))))
(define TTImpC-45Utils-n--8095-2278-u--usedName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-lookupTyName (vector 1 (vector 0 arg-0)) (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (if (null? e-5) (PreludeC-45Types-elem (csegen-17) arg-0 arg-1) 1))))))))
(define TTImpC-45Utils-n--8095-2279-u--next (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (TTImpC-45Utils-nameNum arg-3))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45Show-u--show_Show_Int (bs+ e-3 1 63)))))))))
(define TTImpC-45Utils-n--6361-1198-u--getRawImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 2))) e-2)) (else (let ((e-5 (vector-ref arg-5 2))) e-5)))))
(define TTImpC-45Utils-n--6361-1044-u--getRawImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (cons e-2 (cons e-3 '()))))) ((1) (let ((e-6 (vector-ref arg-6 2))) (let ((e-7 (vector-ref arg-6 3))) (let ((e-10 (vector-ref arg-6 6))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-10 (lambda (bind-0) (PreludeC-45TypesC-45List-tailRecAppend (cons e-7 (cons e-6 '())) (TTImpC-45Utils-n--6361-1044-u--getRawImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 bind-0)))))))) (else (let ((e-13 (vector-ref arg-6 2))) (cons e-13 '()))))))
(define TTImpC-45Utils-n--6065-522-u--getParamTy (lambda (arg-0 arg-4) (let ((e-3 (cdr arg-4))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) e-11)))))
(define TTImpC-45Utils-n--6065-523-u--getFromTy (lambda (arg-0 arg-1) (let ((e-4 (vector-ref arg-1 3))) e-4)))
(define TTImpC-45Utils-n--6065-525-u--getFromPiInfo (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (cons e-1 '())))(else '()))))
(define TTImpC-45Utils-n--6065-526-u--getFromIField (lambda (arg-0 arg-1) (let ((e-3 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-n--6065-525-u--getFromPiInfo arg-0 e-3) (cons e-5 '()))))))
(define TTImpC-45Utils-n--6065-524-u--getFromClause (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (cons e-2 (cons e-3 '()))))) ((1) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-10 (vector-ref arg-1 6))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-10 (lambda (bind-0) (PreludeC-45TypesC-45List-tailRecAppend (cons e-7 (cons e-6 '())) (TTImpC-45Utils-n--6065-524-u--getFromClause arg-0 bind-0)))))))) (else (let ((e-13 (vector-ref arg-1 2))) (cons e-13 '()))))))
(define TTImpC-45Utils-uniqueName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (TTImpC-45Utils-n--8095-2278-u--usedName arg-2 arg-1 arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (TTImpC-45Utils-uniqueName arg-0 arg-1 (TTImpC-45Utils-n--8095-2279-u--next arg-2 arg-1 arg-0 arg-2) ext-0)) (else (vector 1 arg-2)))))))))
(define TTImpC-45Utils-substNamesTyC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (vector e-1 e-2 e-3 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-4))))))))
(define TTImpC-45Utils-substNamesDeclC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (vector 0 e-1 e-2 e-3 e-4 (TTImpC-45Utils-substNamesTyC-39 arg-0 arg-1 arg-2 e-5)))))))) ((2) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (vector 2 e-7 e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesClauseC-39 arg-0 arg-1 arg-2 eta-0)) e-9)))))) ((1) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (vector 1 e-11 e-12 (TTImpC-45Utils-substNamesDataC-39 arg-0 arg-1 arg-2 e-13)))))) ((5) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (vector 5 e-15 e-16 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-17))))))(else arg-3))))
(define TTImpC-45Utils-substNamesDataC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (vector 0 e-1 e-2 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-3) e-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesTyC-39 arg-0 arg-1 arg-2 eta-0)) e-5)))))))) (else (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (vector 1 e-7 e-8 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-9)))))))))
(define TTImpC-45Utils-substNamesClauseC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 eta-0))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (TTImpC-45Utils-findBindableNames 1 arg-1 '() e-2))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-2) arg-1)))) (vector 0 e-1 (TTImpC-45Utils-substNamesC-39 arg-0 '() '() e-2) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-3))))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (let ((e-9 (vector-ref arg-3 5))) (let ((e-10 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 eta-0))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (TTImpC-45Utils-findBindableNames 1 arg-1 '() e-6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-6) arg-1)))) (vector 1 e-5 (TTImpC-45Utils-substNamesC-39 arg-0 '() '() e-6) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-7) e-8 e-9 e-10))))))))) (else (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (vector 2 e-12 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 '() e-13))))))))
(define TTImpC-45Utils-substNamesClause (lambda (ext-0 ext-1 ext-2) (TTImpC-45Utils-substNamesClauseC-39 0 ext-0 ext-1 ext-2)))
(define TTImpC-45Utils-substNamesC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-0 0) (case (vector-ref arg-3 0) ((0) (let ((e-76 (vector-ref arg-3 1))) (let ((e-77 (vector-ref arg-3 2))) (let ((sc2 (PreludeC-45Types-elem (csegen-802) e-77 arg-1))) (cond ((equal? sc2 1) (vector 0 e-76 e-77)) (else (let ((sc3 (DataC-45List-lookup (csegen-802) e-77 arg-2))) (if (null? sc3) (vector 0 e-76 e-77) (let ((e-1 (unbox sc3))) e-1)))))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-4))) (vector 1 e-1 e-2 e-3 e-4 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-5) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-6)))))))))) ((2) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-11))) (vector 2 e-8 e-9 e-10 e-11 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-12) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-13)))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-21 (vector-ref arg-3 7))) (let ((u--boundC-39 (cons e-18 arg-1))) (vector 3 e-15 e-16 e-17 e-18 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-19) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-20) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-21))))))))))) ((4) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (vector 4 e-23 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-24) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-25) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesClauseC-39 arg-0 arg-1 arg-2 eta-0)) e-26))))))) ((5) (let ((e-28 (vector-ref arg-3 1))) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-definedInBlock (CoreC-45NameC-45Namespace-emptyNS) e-29) arg-1))) (vector 5 e-28 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-29) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-30))))))) ((8) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (vector 8 e-32 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-33) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-34)))))) ((10) (let ((e-36 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (let ((e-38 (vector-ref arg-3 3))) (let ((e-39 (vector-ref arg-3 4))) (vector 10 e-36 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-37) e-38 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-39))))))) ((9) (let ((e-41 (vector-ref arg-3 1))) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (vector 9 e-41 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-42) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-43)))))) ((11) (let ((e-45 (vector-ref arg-3 1))) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (vector 11 e-45 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-46) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-47)))))) ((13) (let ((e-49 (vector-ref arg-3 1))) (let ((e-50 (vector-ref arg-3 2))) (let ((e-51 (vector-ref arg-3 3))) (vector 13 e-49 e-50 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-0)) e-51)))))) ((15) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (vector 15 e-53 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-54))))) ((18) (let ((e-56 (vector-ref arg-3 1))) (let ((e-57 (vector-ref arg-3 2))) (let ((e-58 (vector-ref arg-3 3))) (let ((e-59 (vector-ref arg-3 4))) (let ((e-60 (vector-ref arg-3 5))) (vector 18 e-56 e-57 e-58 e-59 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-60)))))))) ((19) (let ((e-62 (vector-ref arg-3 1))) (let ((e-63 (vector-ref arg-3 2))) (let ((e-64 (vector-ref arg-3 3))) (vector 19 e-62 e-63 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-64)))))) ((20) (let ((e-66 (vector-ref arg-3 1))) (let ((e-67 (vector-ref arg-3 2))) (let ((e-68 (vector-ref arg-3 3))) (vector 20 e-66 e-67 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-68)))))) ((21) (let ((e-70 (vector-ref arg-3 1))) (let ((e-71 (vector-ref arg-3 2))) (vector 21 e-70 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-71))))) ((22) (let ((e-73 (vector-ref arg-3 1))) (let ((e-74 (vector-ref arg-3 2))) (vector 22 e-73 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-74)))))(else arg-3))))) ((equal? arg-0 1) (case (vector-ref arg-3 0) ((17) (let ((e-79 (vector-ref arg-3 1))) (let ((e-80 (vector-ref arg-3 2))) (let ((sc2 (PreludeC-45Types-elem (csegen-802) (vector 1 (vector 0 e-80)) arg-1))) (cond ((equal? sc2 1) (vector 17 e-79 e-80)) (else (let ((sc3 (DataC-45List-lookup (csegen-802) (vector 1 (vector 0 e-80)) arg-2))) (if (null? sc3) (vector 17 e-79 e-80) (let ((e-1 (unbox sc3))) e-1)))))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-4))) (vector 1 e-1 e-2 e-3 e-4 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-5) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-6)))))))))) ((2) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-11))) (vector 2 e-8 e-9 e-10 e-11 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-12) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-13)))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-21 (vector-ref arg-3 7))) (let ((u--boundC-39 (cons e-18 arg-1))) (vector 3 e-15 e-16 e-17 e-18 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-19) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-20) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-21))))))))))) ((4) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (vector 4 e-23 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-24) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-25) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesClauseC-39 arg-0 arg-1 arg-2 eta-0)) e-26))))))) ((5) (let ((e-28 (vector-ref arg-3 1))) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-definedInBlock (CoreC-45NameC-45Namespace-emptyNS) e-29) arg-1))) (vector 5 e-28 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-29) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-30))))))) ((8) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (vector 8 e-32 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-33) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-34)))))) ((10) (let ((e-36 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (let ((e-38 (vector-ref arg-3 3))) (let ((e-39 (vector-ref arg-3 4))) (vector 10 e-36 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-37) e-38 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-39))))))) ((9) (let ((e-41 (vector-ref arg-3 1))) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (vector 9 e-41 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-42) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-43)))))) ((11) (let ((e-45 (vector-ref arg-3 1))) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (vector 11 e-45 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-46) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-47)))))) ((13) (let ((e-49 (vector-ref arg-3 1))) (let ((e-50 (vector-ref arg-3 2))) (let ((e-51 (vector-ref arg-3 3))) (vector 13 e-49 e-50 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-0)) e-51)))))) ((15) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (vector 15 e-53 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-54))))) ((18) (let ((e-56 (vector-ref arg-3 1))) (let ((e-57 (vector-ref arg-3 2))) (let ((e-58 (vector-ref arg-3 3))) (let ((e-59 (vector-ref arg-3 4))) (let ((e-60 (vector-ref arg-3 5))) (vector 18 e-56 e-57 e-58 e-59 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-60)))))))) ((19) (let ((e-62 (vector-ref arg-3 1))) (let ((e-63 (vector-ref arg-3 2))) (let ((e-64 (vector-ref arg-3 3))) (vector 19 e-62 e-63 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-64)))))) ((20) (let ((e-66 (vector-ref arg-3 1))) (let ((e-67 (vector-ref arg-3 2))) (let ((e-68 (vector-ref arg-3 3))) (vector 20 e-66 e-67 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-68)))))) ((21) (let ((e-70 (vector-ref arg-3 1))) (let ((e-71 (vector-ref arg-3 2))) (vector 21 e-70 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-71))))) ((22) (let ((e-73 (vector-ref arg-3 1))) (let ((e-74 (vector-ref arg-3 2))) (vector 22 e-73 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-74)))))(else arg-3)))))(else (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-4))) (vector 1 e-1 e-2 e-3 e-4 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-5) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-6)))))))))) ((2) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-11))) (vector 2 e-8 e-9 e-10 e-11 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-12) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-13)))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-21 (vector-ref arg-3 7))) (let ((u--boundC-39 (cons e-18 arg-1))) (vector 3 e-15 e-16 e-17 e-18 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-19) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-20) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-21))))))))))) ((4) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (vector 4 e-23 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-24) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-25) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesClauseC-39 arg-0 arg-1 arg-2 eta-0)) e-26))))))) ((5) (let ((e-28 (vector-ref arg-3 1))) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-definedInBlock (CoreC-45NameC-45Namespace-emptyNS) e-29) arg-1))) (vector 5 e-28 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-29) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-30))))))) ((8) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (vector 8 e-32 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-33) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-34)))))) ((10) (let ((e-36 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (let ((e-38 (vector-ref arg-3 3))) (let ((e-39 (vector-ref arg-3 4))) (vector 10 e-36 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-37) e-38 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-39))))))) ((9) (let ((e-41 (vector-ref arg-3 1))) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (vector 9 e-41 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-42) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-43)))))) ((11) (let ((e-45 (vector-ref arg-3 1))) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (vector 11 e-45 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-46) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-47)))))) ((13) (let ((e-49 (vector-ref arg-3 1))) (let ((e-50 (vector-ref arg-3 2))) (let ((e-51 (vector-ref arg-3 3))) (vector 13 e-49 e-50 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-0)) e-51)))))) ((15) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (vector 15 e-53 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-54))))) ((18) (let ((e-56 (vector-ref arg-3 1))) (let ((e-57 (vector-ref arg-3 2))) (let ((e-58 (vector-ref arg-3 3))) (let ((e-59 (vector-ref arg-3 4))) (let ((e-60 (vector-ref arg-3 5))) (vector 18 e-56 e-57 e-58 e-59 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-60)))))))) ((19) (let ((e-62 (vector-ref arg-3 1))) (let ((e-63 (vector-ref arg-3 2))) (let ((e-64 (vector-ref arg-3 3))) (vector 19 e-62 e-63 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-64)))))) ((20) (let ((e-66 (vector-ref arg-3 1))) (let ((e-67 (vector-ref arg-3 2))) (let ((e-68 (vector-ref arg-3 3))) (vector 20 e-66 e-67 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-68)))))) ((21) (let ((e-70 (vector-ref arg-3 1))) (let ((e-71 (vector-ref arg-3 2))) (vector 21 e-70 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-71))))) ((22) (let ((e-73 (vector-ref arg-3 1))) (let ((e-74 (vector-ref arg-3 2))) (vector 22 e-73 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-74)))))(else arg-3))))))
(define TTImpC-45Utils-substNames (lambda (ext-0 ext-1 ext-2) (TTImpC-45Utils-substNamesC-39 0 ext-0 ext-1 ext-2)))
(define TTImpC-45Utils-substLocTy (lambda (arg-0 arg-1) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (vector arg-0 arg-0 e-3 (TTImpC-45Utils-substLoc arg-0 e-4))))))
(define TTImpC-45Utils-substLocDecl (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (vector 0 arg-0 e-2 e-3 e-4 (TTImpC-45Utils-substLocTy arg-0 e-5))))))) ((2) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (vector 2 arg-0 e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substLocClause arg-0 eta-0)) e-9))))) ((1) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (vector 1 arg-0 e-12 (TTImpC-45Utils-substLocData arg-0 e-13))))) ((5) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (vector 5 arg-0 e-16 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substLocDecl arg-0 eta-0)) e-17)))))(else arg-1))))
(define TTImpC-45Utils-substLocData (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (vector 0 arg-0 e-2 (TTImpC-45Utils-substLoc arg-0 e-3) e-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substLocTy arg-0 eta-0)) e-5))))))) (else (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (vector 1 arg-0 e-8 (TTImpC-45Utils-substLoc arg-0 e-9))))))))
(define TTImpC-45Utils-substLocClause (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector 0 arg-0 (TTImpC-45Utils-substLoc arg-0 e-2) (TTImpC-45Utils-substLoc arg-0 e-3))))) ((1) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (let ((e-10 (vector-ref arg-1 6))) (vector 1 arg-0 (TTImpC-45Utils-substLoc arg-0 e-6) (TTImpC-45Utils-substLoc arg-0 e-7) e-8 e-9 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substLocClause arg-0 eta-0)) e-10)))))))) (else (let ((e-13 (vector-ref arg-1 2))) (vector 2 arg-0 (TTImpC-45Utils-substLoc arg-0 e-13)))))))
(define TTImpC-45Utils-substLoc (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (vector 0 arg-0 e-2))) ((1) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (vector 1 arg-0 e-5 e-6 e-7 (TTImpC-45Utils-substLoc arg-0 e-8) (TTImpC-45Utils-substLoc arg-0 e-9)))))))) ((2) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (vector 2 arg-0 e-12 e-13 e-14 (TTImpC-45Utils-substLoc arg-0 e-15) (TTImpC-45Utils-substLoc arg-0 e-16)))))))) ((3) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (let ((e-22 (vector-ref arg-1 5))) (let ((e-23 (vector-ref arg-1 6))) (let ((e-24 (vector-ref arg-1 7))) (vector 3 arg-0 arg-0 e-20 e-21 (TTImpC-45Utils-substLoc arg-0 e-22) (TTImpC-45Utils-substLoc arg-0 e-23) (TTImpC-45Utils-substLoc arg-0 e-24)))))))) ((4) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((e-29 (vector-ref arg-1 4))) (vector 4 arg-0 (TTImpC-45Utils-substLoc arg-0 e-27) (TTImpC-45Utils-substLoc arg-0 e-28) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substLocClause arg-0 eta-0)) e-29)))))) ((5) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (vector 5 arg-0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substLocDecl arg-0 eta-0)) e-32) (TTImpC-45Utils-substLoc arg-0 e-33))))) ((8) (let ((e-36 (vector-ref arg-1 2))) (let ((e-37 (vector-ref arg-1 3))) (vector 8 arg-0 (TTImpC-45Utils-substLoc arg-0 e-36) (TTImpC-45Utils-substLoc arg-0 e-37))))) ((10) (let ((e-40 (vector-ref arg-1 2))) (let ((e-41 (vector-ref arg-1 3))) (let ((e-42 (vector-ref arg-1 4))) (vector 10 arg-0 (TTImpC-45Utils-substLoc arg-0 e-40) e-41 (TTImpC-45Utils-substLoc arg-0 e-42)))))) ((9) (let ((e-45 (vector-ref arg-1 2))) (let ((e-46 (vector-ref arg-1 3))) (vector 9 arg-0 (TTImpC-45Utils-substLoc arg-0 e-45) (TTImpC-45Utils-substLoc arg-0 e-46))))) ((11) (let ((e-49 (vector-ref arg-1 2))) (let ((e-50 (vector-ref arg-1 3))) (vector 11 arg-0 (TTImpC-45Utils-substLoc arg-0 e-49) (TTImpC-45Utils-substLoc arg-0 e-50))))) ((13) (let ((e-53 (vector-ref arg-1 2))) (let ((e-54 (vector-ref arg-1 3))) (vector 13 arg-0 e-53 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substLoc arg-0 eta-0)) e-54))))) ((15) (let ((e-57 (vector-ref arg-1 2))) (vector 15 arg-0 (TTImpC-45Utils-substLoc arg-0 e-57)))) ((18) (let ((e-61 (vector-ref arg-1 3))) (let ((e-62 (vector-ref arg-1 4))) (let ((e-63 (vector-ref arg-1 5))) (vector 18 arg-0 arg-0 e-61 e-62 (TTImpC-45Utils-substLoc arg-0 e-63)))))) ((19) (let ((e-66 (vector-ref arg-1 2))) (let ((e-67 (vector-ref arg-1 3))) (vector 19 arg-0 e-66 (TTImpC-45Utils-substLoc arg-0 e-67))))) ((20) (let ((e-70 (vector-ref arg-1 2))) (let ((e-71 (vector-ref arg-1 3))) (vector 20 arg-0 e-70 (TTImpC-45Utils-substLoc arg-0 e-71))))) ((21) (let ((e-74 (vector-ref arg-1 2))) (vector 21 arg-0 (TTImpC-45Utils-substLoc arg-0 e-74)))) ((22) (let ((e-77 (vector-ref arg-1 2))) (vector 22 arg-0 (TTImpC-45Utils-substLoc arg-0 e-77))))(else arg-1))))
(define TTImpC-45Utils-substBindVars (lambda (ext-0 ext-1 ext-2) (TTImpC-45Utils-substNamesC-39 1 ext-0 ext-1 ext-2)))
(define TTImpC-45Utils-rawImpFromDecl (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-5 (vector-ref arg-0 5))) (cons (TTImpC-45Utils-n--6065-523-u--getFromTy arg-0 e-5) '()))) ((1) (let ((e-9 (vector-ref arg-0 3))) (case (vector-ref e-9 0) ((0) (let ((e-47 (vector-ref e-9 3))) (let ((e-49 (vector-ref e-9 5))) (cons e-47 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-n--6065-523-u--getFromTy arg-0 eta-0)) e-49))))) (else (let ((e-53 (vector-ref e-9 3))) (cons e-53 '())))))) ((2) (let ((e-13 (vector-ref arg-0 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-13 (lambda (bind-0) (TTImpC-45Utils-n--6065-524-u--getFromClause arg-0 bind-0))))) ((3) (let ((e-16 (vector-ref arg-0 2))) (let ((e-17 (vector-ref arg-0 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-17 (lambda (bind-0) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-rawImpFromDecl bind-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-n--6065-522-u--getParamTy arg-0 eta-0)) e-16))))))) ((4) (let ((e-19 (vector-ref arg-0 1))) (let ((e-20 (vector-ref arg-0 2))) (let ((e-21 (vector-ref arg-0 3))) (let ((e-22 (vector-ref arg-0 4))) (let ((e-55 (vector-ref e-22 0))) (let ((e-56 (vector-ref e-22 1))) (let ((e-57 (vector-ref e-22 2))) (let ((e-58 (vector-ref e-22 3))) (let ((e-59 (vector-ref e-22 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd (Builtin-snd eta-0))) e-57) (lambda (_-0) (let ((u--decl (vector 4 e-19 e-20 e-21 (vector e-55 e-56 e-57 e-58 e-59)))) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-59 (lambda (bind-0) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-n--6065-525-u--getFromPiInfo u--decl e-2) (PreludeC-45TypesC-45List-tailRecAppend (cons e-3 '()) (TTImpC-45Utils-n--6065-526-u--getFromIField u--decl bind-0)))))))))))))))))))) ((5) (let ((e-26 (vector-ref arg-0 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-26 (lambda (bind-0) (TTImpC-45Utils-rawImpFromDecl bind-0))))) ((6) (let ((e-30 (vector-ref arg-0 3))) (let ((e-31 (vector-ref arg-0 4))) (cons e-30 (cons e-31 '()))))) ((7) '()) ((8) '()) ((9) '()) (else '()))))
(define TTImpC-45Utils-nameNum (lambda (arg-0) (TTImpC-45Utils-case--nameNum-2214 arg-0 (DataC-45String-span (lambda (eta-0) (PreludeC-45Types-isDigit eta-0)) (PreludeC-45Types-reverse arg-0)))))
(define TTImpC-45Utils-getUnique (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-elem (csegen-17) arg-1 arg-0))) (cond ((equal? sc0 1) (TTImpC-45Utils-getUnique arg-0 (PreludeC-45TypesC-45String-C-43C-43 arg-1 "'"))) (else arg-1)))))
(define TTImpC-45Utils-findUniqueBindableNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--assoc (DataC-45List-nub (csegen-1819) (TTImpC-45Utils-findBindableNames arg-2 arg-3 arg-4 arg-5)))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (let ((e-19 (vector-ref e-5 19))) e-19))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--ctxt (let ((e-0 (vector-ref e-6 0))) e-0))) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-49) (PreludeC-45Basics-flip (csegen-1822) u--assoc (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((act-26 ((CoreC-45Context-lookupCtxtName (vector 1 (vector 0 e-2)) u--ctxt) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--ns (PreludeC-45Basics-flip (csegen-537) e-7 (lambda (lamc-1) (let ((e-8 (car lamc-1))) (let ((e-4 (cdr lamc-1))) (let ((e-9 (cdr e-4))) (let ((e-17 (vector-ref e-9 17))) (case (vector-ref e-17 0) ((7) '())(else (PreludeC-45Types-u--pure_Applicative_Maybe e-8))))))))))) (vector 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-1) (cons e-2 eta-1)) (DataC-45List1-fromList u--ns)))))))))))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc4 (DataC-45List1-fromList e-7))) (if (null? sc4) (vector 1 0) (let ((e-1 (unbox sc4))) (CoreC-45Context-recordWarning arg-0 (vector 2 arg-1 e-1) eta-0)))))))))))))) (else (vector 1 0)))))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 u--assoc))))))))
(define TTImpC-45Utils-findIBindVars (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-5) (TTImpC-45Utils-findIBindVars e-6))))) ((2) (let ((e-12 (vector-ref arg-0 5))) (let ((e-13 (vector-ref arg-0 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-12) (TTImpC-45Utils-findIBindVars e-13))))) ((8) (let ((e-16 (vector-ref arg-0 2))) (let ((e-17 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-16) (TTImpC-45Utils-findIBindVars e-17))))) ((10) (let ((e-20 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-20) (TTImpC-45Utils-findIBindVars e-22))))) ((9) (let ((e-25 (vector-ref arg-0 2))) (let ((e-26 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-25) (TTImpC-45Utils-findIBindVars e-26))))) ((11) (let ((e-29 (vector-ref arg-0 2))) (let ((e-30 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-29) (TTImpC-45Utils-findIBindVars e-30))))) ((17) (let ((e-33 (vector-ref arg-0 2))) (cons (vector 1 (vector 0 e-33)) '()))) ((20) (let ((e-37 (vector-ref arg-0 3))) (TTImpC-45Utils-findIBindVars e-37))) ((21) (let ((e-40 (vector-ref arg-0 2))) (TTImpC-45Utils-findIBindVars e-40))) ((22) (let ((e-43 (vector-ref arg-0 2))) (TTImpC-45Utils-findIBindVars e-43))) ((13) (let ((e-47 (vector-ref arg-0 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45Utils-findIBindVars eta-0)) e-47)))(else '()))))
(define TTImpC-45Utils-findBindableNamesQuot (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-5 (cons e-6 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((2) (let ((e-12 (vector-ref arg-2 5))) (let ((e-13 (vector-ref arg-2 6))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-12 (cons e-13 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((3) (let ((e-19 (vector-ref arg-2 5))) (let ((e-20 (vector-ref arg-2 6))) (let ((e-21 (vector-ref arg-2 7))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-19 (cons e-20 (cons e-21 '()))) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0))))))) ((4) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-26 (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (PreludeC-45TypesC-45List-tailRecAppend (cons e-24 (cons e-25 '())) (TTImpC-45Utils-n--6361-1044-u--getRawImp e-26 e-25 e-24 e-23 arg-1 arg-0 bind-0)) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-1)))))))))) ((5) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-29 (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-30 (TTImpC-45Utils-rawImpFromDecl bind-0)) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-1)))))))) ((6) (let ((e-36 (vector-ref arg-2 5))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-36))) ((8) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-39 (cons e-40 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((10) (let ((e-43 (vector-ref arg-2 2))) (let ((e-45 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-43 (cons e-45 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((9) (let ((e-48 (vector-ref arg-2 2))) (let ((e-49 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-48 (cons e-49 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((11) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-52 (cons e-53 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((14) (let ((e-56 (vector-ref arg-2 2))) (let ((e-57 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-56 (cons e-57 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((15) (let ((e-60 (vector-ref arg-2 2))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-60))) ((16) (let ((e-64 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-64))) ((7) (let ((e-66 (vector-ref arg-2 1))) (let ((e-67 (vector-ref arg-2 2))) (let ((e-68 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (cons e-68 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-n--6361-1198-u--getRawImp e-68 e-67 e-66 arg-1 arg-0 eta-0)) e-67)) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0))))))) ((18) (let ((e-74 (vector-ref arg-2 5))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-74))) ((20) (let ((e-78 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-78))) ((21) (let ((e-81 (vector-ref arg-2 2))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-81))) ((22) (let ((e-84 (vector-ref arg-2 2))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-84))) ((26) (let ((e-87 (vector-ref arg-2 2))) (TTImpC-45Utils-findBindableNames 1 arg-0 arg-1 e-87))) ((33) (let ((e-91 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-91))) ((0) '()) ((12) '()) ((13) '()) ((17) '()) ((28) '()) ((29) '()) ((30) '()) ((32) '()) ((19) (let ((e-119 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-119))) ((31) (let ((e-123 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-123))) ((23) '()) ((24) '()) ((25) '()) (else '()))))
(define TTImpC-45Utils-findBindableNames (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-0 1) (case (vector-ref arg-3 0) ((0) (let ((e-65 (vector-ref arg-3 2))) (case (vector-ref e-65 0) ((1) (let ((e-66 (vector-ref e-65 1))) (case (vector-ref e-66 0) ((0) (let ((e-67 (vector-ref e-66 1))) (let ((u--nm (vector 1 (vector 0 e-67)))) (let ((sc4 (let ((sc5 (PreludeC-45Types-elem (csegen-802) u--nm arg-1))) (cond ((equal? sc5 1) 0) (else (LibrariesC-45UtilsC-45String-lowerFirst e-67)))))) (cond ((equal? sc4 1) (cons (cons e-67 (TTImpC-45Utils-getUnique arg-2 e-67)) '())) (else '()))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-4) arg-1 (let ((e-7 (unbox e-4))) (cons e-7 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-5) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-6))))))) ((2) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-11) arg-1 (let ((e-2 (unbox e-11))) (cons e-2 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-12) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-13))))))) ((8) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-16) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-17))))) ((10) (let ((e-20 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-20) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-22))))) ((9) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-25) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-26))))) ((11) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-29) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-30))))) ((18) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (case (vector-ref e-35 0) ((1) (let ((e-61 (vector-ref e-35 1))) (case (vector-ref e-61 0) ((0) (let ((e-62 (vector-ref e-61 1))) (cons (cons e-62 (TTImpC-45Utils-getUnique arg-2 e-62)) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))) ((19) (let ((e-40 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-40))) ((20) (let ((e-44 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-44))) ((21) (let ((e-47 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-47))) ((22) (let ((e-50 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-50))) ((23) (let ((e-53 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 e-53))) ((25) (let ((e-56 (vector-ref arg-3 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-56 (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (TTImpC-45Utils-rawImpFromDecl bind-0) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 bind-1))))))) ((13) (let ((e-60 (vector-ref arg-3 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 eta-0)) e-60)))(else '()))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-4) arg-1 (let ((e-7 (unbox e-4))) (cons e-7 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-5) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-6))))))) ((2) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-11) arg-1 (let ((e-2 (unbox e-11))) (cons e-2 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-12) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-13))))))) ((8) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-16) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-17))))) ((10) (let ((e-20 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-20) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-22))))) ((9) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-25) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-26))))) ((11) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-29) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-30))))) ((18) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (case (vector-ref e-35 0) ((1) (let ((e-61 (vector-ref e-35 1))) (case (vector-ref e-61 0) ((0) (let ((e-62 (vector-ref e-61 1))) (cons (cons e-62 (TTImpC-45Utils-getUnique arg-2 e-62)) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))) ((19) (let ((e-40 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-40))) ((20) (let ((e-44 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-44))) ((21) (let ((e-47 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-47))) ((22) (let ((e-50 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-50))) ((23) (let ((e-53 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 e-53))) ((25) (let ((e-56 (vector-ref arg-3 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-56 (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (TTImpC-45Utils-rawImpFromDecl bind-0) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 bind-1))))))) ((13) (let ((e-60 (vector-ref arg-3 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 eta-0)) e-60)))(else '()))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-4) arg-1 (let ((e-7 (unbox e-4))) (cons e-7 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-5) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-6))))))) ((2) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-11) arg-1 (let ((e-2 (unbox e-11))) (cons e-2 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-12) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-13))))))) ((8) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-16) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-17))))) ((10) (let ((e-20 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-20) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-22))))) ((9) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-25) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-26))))) ((11) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-29) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-30))))) ((18) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (case (vector-ref e-35 0) ((1) (let ((e-61 (vector-ref e-35 1))) (case (vector-ref e-61 0) ((0) (let ((e-62 (vector-ref e-61 1))) (cons (cons e-62 (TTImpC-45Utils-getUnique arg-2 e-62)) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))) ((19) (let ((e-40 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-40))) ((20) (let ((e-44 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-44))) ((21) (let ((e-47 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-47))) ((22) (let ((e-50 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-50))) ((23) (let ((e-53 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 e-53))) ((25) (let ((e-56 (vector-ref arg-3 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-56 (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (TTImpC-45Utils-rawImpFromDecl bind-0) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 bind-1))))))) ((13) (let ((e-60 (vector-ref arg-3 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 eta-0)) e-60)))(else '())))))(else (case (vector-ref arg-3 0) ((1) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-4) arg-1 (let ((e-7 (unbox e-4))) (cons e-7 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-5) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-6))))))) ((2) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-11) arg-1 (let ((e-2 (unbox e-11))) (cons e-2 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-12) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-13))))))) ((8) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-16) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-17))))) ((10) (let ((e-20 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-20) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-22))))) ((9) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-25) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-26))))) ((11) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-29) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-30))))) ((18) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (case (vector-ref e-35 0) ((1) (let ((e-61 (vector-ref e-35 1))) (case (vector-ref e-61 0) ((0) (let ((e-62 (vector-ref e-61 1))) (cons (cons e-62 (TTImpC-45Utils-getUnique arg-2 e-62)) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))) ((19) (let ((e-40 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-40))) ((20) (let ((e-44 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-44))) ((21) (let ((e-47 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-47))) ((22) (let ((e-50 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-50))) ((23) (let ((e-53 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 e-53))) ((25) (let ((e-56 (vector-ref arg-3 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-56 (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (TTImpC-45Utils-rawImpFromDecl bind-0) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 bind-1))))))) ((13) (let ((e-60 (vector-ref arg-3 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 eta-0)) e-60)))(else '()))))))
(define TTImpC-45Utils-findAllNames (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((sc1 (PreludeC-45Types-elem (csegen-802) e-2 arg-0))) (cond ((equal? sc1 1) '()) (else (cons e-2 '())))))) ((1) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (let ((u--envC-39 (if (null? e-7) arg-0 (let ((e-2 (unbox e-7))) (cons e-2 arg-0))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-8) (TTImpC-45Utils-findAllNames u--envC-39 e-9))))))) ((2) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (let ((u--envC-39 (if (null? e-14) arg-0 (let ((e-2 (unbox e-14))) (cons e-2 arg-0))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames u--envC-39 e-15) (TTImpC-45Utils-findAllNames u--envC-39 e-16))))))) ((8) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-19) (TTImpC-45Utils-findAllNames arg-0 e-20))))) ((10) (let ((e-23 (vector-ref arg-1 2))) (let ((e-25 (vector-ref arg-1 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-23) (TTImpC-45Utils-findAllNames arg-0 e-25))))) ((9) (let ((e-28 (vector-ref arg-1 2))) (let ((e-29 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-28) (TTImpC-45Utils-findAllNames arg-0 e-29))))) ((11) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-32) (TTImpC-45Utils-findAllNames arg-0 e-33))))) ((18) (let ((e-38 (vector-ref arg-1 4))) (let ((e-39 (vector-ref arg-1 5))) (cons e-38 (TTImpC-45Utils-findAllNames arg-0 e-39))))) ((19) (let ((e-43 (vector-ref arg-1 3))) (TTImpC-45Utils-findAllNames arg-0 e-43))) ((20) (let ((e-47 (vector-ref arg-1 3))) (TTImpC-45Utils-findAllNames arg-0 e-47))) ((21) (let ((e-50 (vector-ref arg-1 2))) (TTImpC-45Utils-findAllNames arg-0 e-50))) ((22) (let ((e-53 (vector-ref arg-1 2))) (TTImpC-45Utils-findAllNames arg-0 e-53))) ((23) (let ((e-56 (vector-ref arg-1 2))) (TTImpC-45Utils-findAllNames arg-0 e-56))) ((26) (let ((e-59 (vector-ref arg-1 2))) (TTImpC-45Utils-findAllNames arg-0 e-59))) ((13) (let ((e-63 (vector-ref arg-1 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45Utils-findAllNames arg-0 eta-0)) e-63)))(else '()))))
(define TTImpC-45TTImp-case--weakenNs-9149 (lambda (arg-2 arg-3 arg-4) (cond ((equal? arg-3 0) (if (null? arg-4) arg-2 (let ((e-3 (unbox arg-4))) (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45TTImp-u--weakenNs_Weaken_NestedNames e-3 arg-2)))))(else (let ((e-3 (unbox arg-4))) (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45TTImp-u--weakenNs_Weaken_NestedNames e-3 arg-2)))))))
(define TTImpC-45TTImp-n--7033-9182-u--wknName (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) e-10) (lambda (u--fc) (lambda (u--nt) (CoreC-45TT-u--weaken_Weaken_Term ((e-11 u--fc) u--nt)))))))))))))))
(define TTImpC-45TTImp-n--9863-11835-u--updateNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) '() (let ((e-1 (car arg-10))) (let ((e-2 (cdr arg-10))) (if (null? e-1) (box e-2) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-802) (box arg-9) e-1))) (cond ((equal? sc2 1) (box e-2)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45TTImp-n--9863-11835-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2) (lambda (u--nsC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-1 u--nsC-39)))))))))))))
(define TTImpC-45TTImp-n--10860-12872-u--toRF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) (let ((e-0 (vector-ref arg-11 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (vector 1 (vector 1 e-1))))(else arg-11))))(else arg-11))))
(define TTImpC-45TTImp-n--9855-11770-u--setAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((8) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((act-24 (TTImpC-45TTImp-n--9855-11770-u--setAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons '() arg-6) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-1 e-5 e-3)))))))))) ((9) (let ((e-5 (vector-ref arg-7 1))) (let ((e-6 (vector-ref arg-7 2))) (let ((e-7 (vector-ref arg-7 3))) (let ((act-24 (TTImpC-45TTImp-n--9855-11770-u--setAs arg-0 arg-1 arg-2 arg-3 arg-4 (cons '() arg-5) arg-6 e-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (vector 1 (vector 9 e-5 e-8 e-7)))))))))) ((10) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 3))) (let ((e-12 (vector-ref arg-7 4))) (let ((act-24 (TTImpC-45TTImp-n--9855-11770-u--setAs arg-0 arg-1 arg-2 arg-3 arg-4 (cons (box e-11) arg-5) (cons (box e-11) arg-6) e-10 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 10 e-9 e-5 e-11 e-12))))))))))) ((11) (let ((e-14 (vector-ref arg-7 1))) (let ((e-15 (vector-ref arg-7 2))) (let ((e-16 (vector-ref arg-7 3))) (let ((act-24 (TTImpC-45TTImp-n--9855-11770-u--setAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-15 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 11 e-14 e-5 e-16)))))))))) ((0) (let ((e-18 (vector-ref arg-7 1))) (let ((e-19 (vector-ref arg-7 2))) (let ((act-24 (CoreC-45Context-lookupTyExact (vector 8 arg-3) (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Could not find variable " (PreludeC-45Show-u--show_Show_Int arg-3))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 0 e-18 e-19))))) (let ((e-2 (unbox e-5))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-4 '() arg-2 '() e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 e-19 e-18 arg-6 arg-5 arg-5 arg-6 arg-1 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "\xa;  In the type of " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-2) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  Using locals: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-1) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  Found implicits: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1825) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1825) u--d u--x)))) e-7))))))))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (vector 1 (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 e-19 e-18 arg-6 arg-5 (CoreC-45FC-virtualiseFC e-18) e-7 (vector 0 e-18 e-19)))))))))))))))))))))))(else (vector 1 arg-7)))))
(define TTImpC-45TTImp-n--9863-11837-u--impAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (if (null? e-2) (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-6 0) ((1) (let ((e-11 (vector-ref e-6 1))) (case (vector-ref e-11 0) ((0) (let ((e-12 (vector-ref e-11 1))) (case (vector-ref e-7 0) ((2) (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 17 arg-9 e-12))))(else (case (vector-ref e-7 0) ((0) (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1))))) ((3) (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1)))))(else (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))(else (case (vector-ref e-7 0) ((0) (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1))))) ((3) (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1)))))(else (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))(else (case (vector-ref e-7 0) ((0) (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1))))) ((3) (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1)))))(else (TTImpC-45TTImp-n--9863-11837-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))))))))
(define TTImpC-45TTImp-n--10854-12675-u--getName (lambda (arg-0 arg-1 arg-2) (let ((e-3 (vector-ref arg-2 2))) e-3)))
(define TTImpC-45TTImp-n--10854-12676-u--getFieldName (lambda (arg-0 arg-1 arg-2) (let ((e-4 (vector-ref arg-2 3))) e-4)))
(define TTImpC-45TTImp-n--10860-12873-u--fnsUN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-n--10854-12676-u--getFieldName arg-0 arg-1 eta-0)) arg-6)))
(define TTImpC-45TTImp-n--10860-12874-u--fnsRF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-n--10860-12872-u--toRF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) (TTImpC-45TTImp-n--10860-12873-u--fnsUN arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10))))
(define TTImpC-45TTImp-n--10860-12871-u--fldnsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (PreludeC-45Types-maybe (lambda () arg-10) (lambda () (lambda (u--f) (CoreC-45NameC-45Namespace-C-60C-46C-62 arg-10 (CoreC-45NameC-45Namespace-mkNamespace u--f)))) arg-9)))
(define TTImpC-45TTImp-n--9863-11836-u--findImps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-11) (case (vector-ref arg-12 0) ((0) (let ((e-16 (vector-ref arg-12 1))) (let ((e-17 (vector-ref arg-12 2))) (let ((e-18 (vector-ref arg-12 3))) (let ((e-19 (vector-ref arg-12 4))) (lambda (clam-1) (case (vector-ref e-18 0) ((2) (let ((e-23 (vector-ref e-18 3))) (case (vector-ref e-23 0) ((1) (let ((act-24 (((e-19 arg-2) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-16 0))) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? arg-10) (let ((sc6 (TTImpC-45TTImp-n--9863-11835-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-10))) (if (null? sc6) (vector 1 '()) (let ((e-2 (unbox sc6))) ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 '() e-5) clam-1)))) (let ((e-1 (car arg-10))) (if (null? e-1) (let ((sc7 (TTImpC-45TTImp-n--9863-11835-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-10))) (if (null? sc7) (vector 1 '()) (let ((e-3 (unbox sc7))) ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 '() e-5) clam-1)))) (let ((e-4 (unbox e-1))) (case (vector-ref e-4 0) ((1) (let ((e-6 (vector-ref e-4 1))) (case (vector-ref e-6 0) ((2) ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() e-5) clam-1))(else (let ((sc8 (TTImpC-45TTImp-n--9863-11835-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-10))) (if (null? sc8) (vector 1 '()) (let ((e-3 (unbox sc8))) ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 '() e-5) clam-1))))))))(else (let ((sc7 (TTImpC-45TTImp-n--9863-11835-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-10))) (if (null? sc7) (vector 1 '()) (let ((e-3 (unbox sc7))) ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 '() e-5) clam-1))))))))))))))) ((2) (let ((act-24 (((e-19 arg-2) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-16 0))) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc5 (TTImpC-45TTImp-n--9863-11835-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-9))) (if (null? sc5) (let ((act-25 ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() e-5) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (cons e-17 (vector 2 )) e-6)))))) (let ((e-2 (unbox sc5))) ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2 arg-10 '() e-5) clam-1)))))))))(else (let ((act-24 (((e-19 arg-2) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-16 0))) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc4 (PreludeC-45Types-elem (cons (lambda (arg-13) (lambda (arg-14) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-802) arg-13 arg-14))) (lambda (arg-13) (lambda (arg-14) (PreludeC-45Types-u--C-47C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-802) arg-13 arg-14)))) (box e-17) arg-9))) (cond ((equal? sc4 1) ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() e-5) clam-1)) (else (let ((act-25 ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() e-5) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (cons e-17 (CoreC-45TT-forgetDef e-23)) e-6)))))))))))))))))(else (let ((act-24 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-11))) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 '()))))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-11))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 '()))))))) (let ((e-2 (cdr arg-11))) (case (vector-ref arg-12 0) ((0) (let ((e-5 (vector-ref arg-12 1))) (let ((e-7 (vector-ref arg-12 3))) (let ((e-8 (vector-ref arg-12 4))) (lambda (clam-0) (case (vector-ref e-7 0) ((2) (let ((e-12 (vector-ref e-7 3))) (case (vector-ref e-12 0) ((1) (let ((act-24 (((e-8 arg-2) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-5 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) ((TTImpC-45TTImp-n--9863-11836-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-9) clam-0))))))(else (let ((act-24 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-11))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 '()))))))))(else (let ((act-24 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-11))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 '())))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-11))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 '())))))))))))
(define TTImpC-45TTImp-n--10854-12677-u--expandNS (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-2 (CoreC-45NameC-45Namespace-emptyNS)))) (cond ((equal? sc0 1) arg-3) (else (case (vector-ref arg-3 0) ((1) (vector 0 arg-2 arg-3)) ((2) (vector 0 arg-2 arg-3)) ((4) (vector 0 arg-2 arg-3))(else arg-3)))))))
(define TTImpC-45TTImp-n--10854-12678-u--defName (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-5 (vector-ref arg-3 5))) (cons (TTImpC-45TTImp-n--10854-12677-u--expandNS arg-0 arg-1 arg-2 (TTImpC-45TTImp-n--10854-12675-u--getName arg-0 arg-1 e-5)) '()))) ((1) (let ((e-9 (vector-ref arg-3 3))) (case (vector-ref e-9 0) ((0) (let ((e-28 (vector-ref e-9 2))) (let ((e-31 (vector-ref e-9 5))) (cons (TTImpC-45TTImp-n--10854-12677-u--expandNS arg-0 arg-1 arg-2 e-28) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-n--10854-12677-u--expandNS arg-0 arg-1 arg-2 eta-0)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-n--10854-12675-u--getName arg-0 arg-1 eta-0)) e-31)))))) ((1) (let ((e-34 (vector-ref e-9 2))) (cons (TTImpC-45TTImp-n--10854-12677-u--expandNS arg-0 arg-1 arg-2 e-34) '())))(else '())))) ((3) (let ((e-13 (vector-ref arg-3 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45TTImp-n--10854-12678-u--defName arg-0 arg-1 arg-2 eta-0)) e-13))) ((5) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45TTImp-n--10854-12678-u--defName arg-0 arg-1 (CoreC-45NameC-45Namespace-C-60C-46C-62 arg-2 e-16) eta-0)) e-17)))) ((4) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (let ((e-37 (vector-ref e-22 0))) (let ((e-38 (vector-ref e-22 1))) (let ((e-39 (vector-ref e-22 2))) (let ((e-40 (vector-ref e-22 3))) (let ((e-41 (vector-ref e-22 4))) (cons (TTImpC-45TTImp-n--10854-12677-u--expandNS arg-0 arg-1 arg-2 e-40) (TTImpC-45TTImp-n--10860-12875-u--all arg-0 arg-1 e-19 e-21 e-37 e-39 e-41 e-40 e-38 e-20 arg-2)))))))))))) ((8) (let ((e-24 (vector-ref arg-3 1))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-n--10854-12677-u--expandNS arg-0 arg-1 arg-2 eta-0)) e-24)))(else '()))))
(define TTImpC-45TTImp-n--11756-13545-u--app (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) (vector 8 (TTImpC-45TTImp-getFC arg-4) arg-4 arg-6) (let ((e-2 (unbox arg-5))) (vector 10 (TTImpC-45TTImp-getFC arg-4) arg-4 e-2 arg-6)))))
(define TTImpC-45TTImp-n--10860-12875-u--all (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (cons (TTImpC-45TTImp-n--10854-12677-u--expandNS arg-0 arg-1 arg-10 arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-n--10854-12677-u--expandNS arg-0 arg-1 (TTImpC-45TTImp-n--10860-12871-u--fldnsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) eta-0)) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-n--10860-12874-u--fnsRF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (TTImpC-45TTImp-n--10860-12873-u--fnsUN arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10))))))
(define TTImpC-45TTImp-u--weaken_Weaken_NestedNames (lambda (arg-2) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-n--7033-9182-u--wknName arg-2 eta-0)) arg-2)))
(define TTImpC-45TTImp-u--weakenNs_Weaken_NestedNames (lambda (arg-2 arg-3) (TTImpC-45TTImp-case--weakenNs-9149 arg-3 arg-2 (CoreC-45TT-sizedView arg-2))))
(define TTImpC-45TTImp-u--toBuf_TTC_RawImp (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-2) eta-0))))))))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-1833) arg-0 e-6 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 e-7) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-8) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-9) eta-0))))))))))))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-11 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-12) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-1833) arg-0 e-13 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 e-14) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-15) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-16) eta-0))))))))))))))))))))))))))) ((3) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (let ((e-22 (vector-ref arg-1 5))) (let ((e-23 (vector-ref arg-1 6))) (let ((e-24 (vector-ref arg-1 7))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-18 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-19 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-20) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-21) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-22) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-23) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-24) eta-0))))))))))))))))))))))))))))))) ((4) (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((e-29 (vector-ref arg-1 4))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-27) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-28) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1836) arg-0 e-29 eta-0))))))))))))))))))) ((5) (let ((e-31 (vector-ref arg-1 1))) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 5 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-31 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1839) arg-0 e-32 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-33) eta-0))))))))))))))) ((6) (let ((e-39 (vector-ref arg-1 5))) (TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-39))) ((7) (let ((e-41 (vector-ref arg-1 1))) (let ((e-42 (vector-ref arg-1 2))) (let ((e-43 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 6 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-41 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1842) arg-0 e-42 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-43) eta-0))))))))))))))) ((8) (let ((e-45 (vector-ref arg-1 1))) (let ((e-46 (vector-ref arg-1 2))) (let ((e-47 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-45 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-46) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-47) eta-0))))))))))))))) ((10) (let ((e-49 (vector-ref arg-1 1))) (let ((e-50 (vector-ref arg-1 2))) (let ((e-51 (vector-ref arg-1 3))) (let ((e-52 (vector-ref arg-1 4))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 8 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-49 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-50) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-51) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-52) eta-0))))))))))))))))))) ((11) (let ((e-54 (vector-ref arg-1 1))) (let ((e-55 (vector-ref arg-1 2))) (let ((e-56 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 9 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-54 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-55) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-56) eta-0))))))))))))))) ((12) (let ((e-58 (vector-ref arg-1 1))) (let ((e-59 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 10 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-58 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-59) eta-0))))))))))) ((13) (let ((e-61 (vector-ref arg-1 1))) (let ((e-62 (vector-ref arg-1 2))) (let ((e-63 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 11 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-61 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (TTImpC-45TTImp-u--toBuf_TTC_AltType arg-0 e-62 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1833) arg-0 e-63 eta-0))))))))))))))) ((14) (let ((e-65 (vector-ref arg-1 1))) (let ((e-66 (vector-ref arg-1 2))) (let ((e-67 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 12 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-65 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-66) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-67) eta-0))))))))))))))) ((15) (let ((e-69 (vector-ref arg-1 1))) (let ((e-70 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 13 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-69 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-70) eta-0))))))))))) ((16) (let ((e-72 (vector-ref arg-1 1))) (let ((e-73 (vector-ref arg-1 2))) (let ((e-74 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 14 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-72 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (TTImpC-45TTImp-u--toBuf_TTC_BindMode arg-0 e-73 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-74) eta-0))))))))))))))) ((17) (let ((e-76 (vector-ref arg-1 1))) (let ((e-77 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 15 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-76 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-77) eta-0))))))))))) ((18) (let ((e-79 (vector-ref arg-1 1))) (let ((e-80 (vector-ref arg-1 2))) (let ((e-81 (vector-ref arg-1 3))) (let ((e-82 (vector-ref arg-1 4))) (let ((e-83 (vector-ref arg-1 5))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 16 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-79 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-80 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45TTC-u--toBuf_TTC_UseSide arg-0 e-81 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-82) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-83) eta-0))))))))))))))))))))))) ((19) (let ((e-85 (vector-ref arg-1 1))) (let ((e-87 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 17 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-85 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-87) eta-0))))))))))) ((20) (let ((e-89 (vector-ref arg-1 1))) (let ((e-90 (vector-ref arg-1 2))) (let ((e-91 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 18 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-89 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-0 e-90 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-91) eta-0))))))))))))))) ((21) (let ((e-93 (vector-ref arg-1 1))) (let ((e-94 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 19 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-93 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-94) eta-0))))))))))) ((22) (let ((e-96 (vector-ref arg-1 1))) (let ((e-97 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 20 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-96 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-97) eta-0))))))))))) ((23) (let ((e-99 (vector-ref arg-1 1))) (let ((e-100 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 21 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-99 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-100) eta-0))))))))))) ((24) (let ((e-102 (vector-ref arg-1 1))) (let ((e-103 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 22 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-102 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-103) eta-0))))))))))) ((25) (let ((e-105 (vector-ref arg-1 1))) (let ((e-106 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 23 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-105 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1839) arg-0 e-106 eta-0))))))))))) ((26) (let ((e-108 (vector-ref arg-1 1))) (let ((e-109 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 24 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-108 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-109) eta-0))))))))))) ((27) (let ((e-111 (vector-ref arg-1 1))) (let ((e-112 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-111 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-112) eta-0))))))))))) ((28) (let ((e-114 (vector-ref arg-1 1))) (let ((e-115 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 26 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-114 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-0 e-115 eta-0))))))))))) ((29) (let ((e-117 (vector-ref arg-1 1))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 27 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-117 eta-0))))))) ((30) (let ((e-119 (vector-ref arg-1 1))) (let ((e-120 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 28 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-119 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-120) eta-0))))))))))) ((31) (let ((e-124 (vector-ref arg-1 3))) (TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-124))) ((32) (let ((e-126 (vector-ref arg-1 1))) (let ((e-127 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 29 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-126 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 e-127) eta-0))))))))))) ((33) (let ((e-130 (vector-ref arg-1 2))) (let ((e-131 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 30 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-130 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-131) eta-0))))))))))) (else (let ((e-133 (vector-ref arg-1 1))) (let ((e-134 (vector-ref arg-1 2))) (let ((e-135 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 31 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-133 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-134) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-135) eta-0))))))))))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_ImpTy (lambda (arg-0 arg-1 ext-0) (let ((e-1 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-4) ext-0))))))))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_ImpRecord (lambda (arg-0 arg-1 ext-0) (let ((e-1 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((act-24 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1845) arg-0 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1863) arg-0 e-5 ext-0))))))))))))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_ImpDecl (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 (CoreC-45TTC-u--toBuf_TTC_Visibility arg-0 e-3 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((act-28 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1866) arg-0 e-4 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (TTImpC-45TTImp-u--toBuf_TTC_ImpTy arg-0 e-5 ext-0)))))))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-7 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_Visibility arg-0 e-8 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (TTImpC-45TTImp-u--toBuf_TTC_ImpData arg-0 e-9 ext-0)))))))))))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-11 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1836) arg-0 e-13 ext-0)))))))))))))) ((3) (let ((e-15 (vector-ref arg-1 1))) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-15 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1845) arg-0 e-16 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1839) arg-0 e-17 ext-0)))))))))))))) ((4) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (let ((e-22 (vector-ref arg-1 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-19 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-479) arg-0 e-20) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45TTC-u--toBuf_TTC_Visibility arg-0 e-21 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (TTImpC-45TTImp-u--toBuf_TTC_ImpRecord arg-0 e-22 ext-0)))))))))))))))))) ((5) (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-24 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_Namespace arg-0 e-25 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1839) arg-0 e-26 ext-0)))))))))))))) ((6) (let ((e-28 (vector-ref arg-1 1))) (let ((e-29 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 3))) (let ((e-31 (vector-ref arg-1 4))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-28 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-29) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-30) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-31) ext-0)))))))))))))))))) ((7) (let ((e-33 (vector-ref arg-1 1))) (let ((e-34 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-33 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-34) ext-0)))))))))) ((8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't write Pragma") ext-0)) ((9) (let ((e-39 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-1869) arg-0 e-39) ext-0)))))) (else (let ((e-41 (vector-ref arg-1 1))) (let ((e-42 (vector-ref arg-1 2))) (let ((e-43 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-41 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (TTImpC-45TTImp-u--toBuf_TTC_BuiltinType arg-0 e-42 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-43) ext-0)))))))))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_ImpData (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-3) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((act-28 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1873) arg-0 e-4 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1876) arg-0 e-5 ext-0)))))))))))))))))))))) (else (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-7 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-8) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-9) ext-0)))))))))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_ImpClause (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-3) ext-0)))))))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-6) ext-0)))))))))) (else (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (let ((e-13 (vector-ref arg-1 6))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-8 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-9) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-10) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 e-11) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1836) arg-0 e-13 ext-0)))))))))))))))))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_IFieldUpdate (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-2) ext-0)))))))))) (else (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 e-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-5) ext-0)))))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_IField (lambda (arg-0 arg-1 ext-0) (let ((e-1 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((act-24 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-1833) arg-0 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-5) ext-0))))))))))))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_FnOpt (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 clam-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 11 clam-0)) ((2) (let ((e-3 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 e-3) clam-0)))))) ((3) (let ((e-5 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 e-5) clam-0)))))) ((4) (CoreC-45BinaryC-45Prims-tag arg-0 3 clam-0)) ((5) (let ((e-8 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1833) arg-0 e-8 clam-0)))))) ((6) (CoreC-45BinaryC-45Prims-tag arg-0 5 clam-0)) ((7) (let ((e-11 (vector-ref arg-1 1))) (cond ((equal? e-11 0) (CoreC-45BinaryC-45Prims-tag arg-0 6 clam-0)) ((equal? e-11 1) (CoreC-45BinaryC-45Prims-tag arg-0 7 clam-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 8 clam-0))))) ((8) (CoreC-45BinaryC-45Prims-tag arg-0 9 clam-0)) (else (let ((e-14 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 10 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-14 clam-0))))))))))
(define TTImpC-45TTImp-u--toBuf_TTC_DataOpt (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-0 ext-0)))))) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)))))
(define TTImpC-45TTImp-u--toBuf_TTC_BuiltinType (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define TTImpC-45TTImp-u--toBuf_TTC_BindMode (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-0) ext-0)))))) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)))))
(define TTImpC-45TTImp-u--toBuf_TTC_AltType (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (let ((e-3 (vector-ref arg-1 1))) (let ((act-24 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-3) ext-0)))))))))
(define TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (car arg-1))) (e-4 e-2)))) ((1) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (let ((e-9 (vector-ref arg-2 6))) (PreludeC-45TypesC-45String-C-43C-43 "(%pi " (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-5) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (csegen-737) (vector 6 ) e-7) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-9) ")")))))))))))))))) ((2) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (let ((e-15 (vector-ref arg-2 5))) (let ((e-16 (vector-ref arg-2 6))) (PreludeC-45TypesC-45String-C-43C-43 "(%lam " (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-12) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-13) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (csegen-737) (vector 6 ) e-14) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-15) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-16) ")")))))))))))))))) ((3) (let ((e-20 (vector-ref arg-2 3))) (let ((e-21 (vector-ref arg-2 4))) (let ((e-22 (vector-ref arg-2 5))) (let ((e-23 (vector-ref arg-2 6))) (let ((e-24 (vector-ref arg-2 7))) (PreludeC-45TypesC-45String-C-43C-43 "(%let " (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-20) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-21) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-22) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-23) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-24) ")"))))))))))))))))) ((4) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (PreludeC-45TypesC-45String-C-43C-43 "(%case (" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-27) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-28) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-29) ")")))))))))) ((5) (let ((e-32 (vector-ref arg-2 2))) (let ((e-33 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%local (" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-32) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-33) ")"))))))) ((6) (let ((e-36 (vector-ref arg-2 2))) (let ((e-37 (vector-ref arg-2 3))) (let ((e-38 (vector-ref arg-2 4))) (let ((e-39 (vector-ref arg-2 5))) (PreludeC-45TypesC-45String-C-43C-43 "(%caselocal (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-36) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-37) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-38) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-39) ")"))))))))))))) ((7) (let ((e-42 (vector-ref arg-2 2))) (let ((e-43 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%record " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40IFieldUpdateC-39C-32C-36nmC-41 arg-1 eta-0)) e-42)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-43) ")"))))))) ((8) (let ((e-46 (vector-ref arg-2 2))) (let ((e-47 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-46) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-47) ")"))))))) ((10) (let ((e-50 (vector-ref arg-2 2))) (let ((e-51 (vector-ref arg-2 3))) (let ((e-52 (vector-ref arg-2 4))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-50) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-51) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-52) "])")))))))))) ((9) (let ((e-55 (vector-ref arg-2 2))) (let ((e-56 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-55) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-56) "])"))))))) ((11) (let ((e-59 (vector-ref arg-2 2))) (let ((e-60 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-59) (PreludeC-45TypesC-45String-C-43C-43 " | " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-60) ")"))))))) ((12) "%search") ((13) (let ((e-67 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(|" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "," (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 eta-0)) e-67)) "|)")))) ((14) (let ((e-70 (vector-ref arg-2 2))) (let ((e-71 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%rewrite (" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-70) (PreludeC-45TypesC-45String-C-43C-43 ") (" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-71) "))"))))))) ((15) (let ((e-74 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "(%coerced " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-74) ")")))) ((16) (let ((e-78 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%bindhere " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-78) ")")))) ((17) (let ((e-81 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "$" e-81))) ((18) (let ((e-86 (vector-ref arg-2 4))) (let ((e-87 (vector-ref arg-2 5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-86) (PreludeC-45TypesC-45String-C-43C-43 "@(" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-87) ")")))))) ((19) (let ((e-91 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 ".(" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-91) ")")))) ((20) (let ((e-95 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%delayed " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-95) ")")))) ((21) (let ((e-98 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "(%delay " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-98) ")")))) ((22) (let ((e-101 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "(%force " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-101) ")")))) ((23) (let ((e-104 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "(%quote " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-104) ")")))) ((24) (let ((e-107 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "(%quotename " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-107) ")")))) ((25) (let ((e-110 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "(%quotedecl " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-110) ")")))) ((26) (let ((e-113 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "(%unquote " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-113) ")")))) ((27) (let ((e-116 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "(%runelab " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-116) ")")))) ((28) (let ((e-119 (vector-ref arg-2 2))) (CoreC-45TT-u--show_Show_Constant e-119))) ((30) (let ((e-122 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "?" e-122))) ((31) (let ((e-125 (vector-ref arg-2 2))) (let ((e-126 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%logging " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45OptionsC-45Log-u--show_Show_LogLevel e-125) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-126) ")"))))))) ((29) "%type") ((32) (let ((e-131 (vector-ref arg-2 2))) (cond ((equal? e-131 1) "_") (else "?")))) (else (let ((e-134 (vector-ref arg-2 2))) (let ((e-135 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%with " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-134) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-135) ")"))))))))))
(define TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%claim " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-4) ")"))))))))
(define TTImpC-45TTImp-u--show_Show_C-40ImpRecordC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (PreludeC-45TypesC-45String-C-43C-43 "record " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (u--d) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d x-3)))) x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) u--d x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (u--d) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d x-2))))) x-1)) (lambda (u--d) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) u--d x-1))))) x-0)) (lambda (u--d) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) d-0 x-1))))) u--d x-0))))) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) d-0 x-1))))) x-0)) (lambda (d-0) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) x-1)) (lambda (d-1) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-3) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-3 x-3)))) d-2 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-2) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-2))))) d-1 x-1))))) d-0 x-0))))) u--d u--x)))) e-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-4) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "\xa;\x9;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40IFieldC-39C-32C-36nmC-41 arg-1 eta-0)) e-5)) "\xa;"))))))))))))))
(define TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40FnOptC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40FnOptC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-4) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 e-5))))))))) ((1) (let ((e-9 (vector-ref arg-2 3))) (TTImpC-45TTImp-u--show_Show_C-40ImpDataC-39C-32C-36nmC-41 arg-1 e-9))) ((2) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%def " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-12) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-13) ")"))))))) ((3) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "parameters " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (u--d) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d x-3)))) x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) u--d x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (u--d) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d x-2))))) x-1)) (lambda (u--d) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) u--d x-1))))) x-0)) (lambda (u--d) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) d-0 x-1))))) u--d x-0))))) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) d-0 x-1))))) x-0)) (lambda (d-0) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) x-1)) (lambda (d-1) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-3) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-3 x-3)))) d-2 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-2) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-2))))) d-1 x-1))))) d-0 x-0))))) u--d u--x)))) e-16) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;" (CoreC-45NameC-45Namespace-showSep "\xa;\x9;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 eta-0)) e-17)))))))) ((4) (let ((e-22 (vector-ref arg-2 4))) (TTImpC-45TTImp-u--show_Show_C-40ImpRecordC-39C-32C-36nmC-41 arg-1 e-22))) ((5) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "namespace " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-25) (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 eta-0)) e-26))))))) ((6) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (PreludeC-45TypesC-45String-C-43C-43 "%transform " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-29) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-30) (PreludeC-45TypesC-45String-C-43C-43 " ==> " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-31)))))))))) ((7) (let ((e-34 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "%runElab " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-34)))) ((8) "[externally defined pragma]") ((9) (let ((e-39 (vector-ref arg-2 1))) (if (null? e-39) "%logging off" (let ((e-46 (unbox e-39))) (let ((e-49 (car e-46))) (let ((e-50 (cdr e-46))) (PreludeC-45TypesC-45String-C-43C-43 "%logging " (if (null? e-49) (PreludeC-45Show-u--show_Show_Nat e-50) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) (DataC-45List-intersperse "." e-49)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_Nat e-50))))))))))) (else (let ((e-42 (vector-ref arg-2 2))) (let ((e-43 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "%builtin " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Context-u--show_Show_BuiltinType e-42) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name e-43))))))))))
(define TTImpC-45TTImp-u--show_Show_C-40ImpDataC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 5))) (PreludeC-45TypesC-45String-C-43C-43 "(%data " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-5) ")")))))))))) (else (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "(%datadecl " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-9) ")"))))))))))
(define TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-2) (PreludeC-45TypesC-45String-C-43C-43 " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-3)))))) ((1) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((e-10 (vector-ref arg-2 6))) (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-6) (PreludeC-45TypesC-45String-C-43C-43 " with " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-7) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-maybe (lambda () "") (lambda () (csegen-1879)) e-8) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-10))))))))))) (else (let ((e-13 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-13) " impossible"))))))
(define TTImpC-45TTImp-u--show_Show_C-40IFieldUpdateC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "->" e-1) (PreludeC-45TypesC-45String-C-43C-43 " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-2)))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "->" e-4) (PreludeC-45TypesC-45String-C-43C-43 " $= " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-5)))))))))
(define TTImpC-45TTImp-u--show_Show_C-40IFieldC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (case (vector-ref e-3 0) ((1) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-4) (PreludeC-45TypesC-45String-C-43C-43 " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-5))))(else (PreludeC-45TypesC-45String-C-43C-43 "{" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-4) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-5) "}")))))))))))
(define TTImpC-45TTImp-u--show_Show_C-40FnOptC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) "%inline") ((1) "%tcinline") ((2) (let ((e-3 (vector-ref arg-2 1))) (PreludeC-45TypesC-45String-C-43C-43 "%hint " (PreludeC-45Show-u--show_Show_Bool e-3)))) ((3) (let ((e-5 (vector-ref arg-2 1))) (PreludeC-45TypesC-45String-C-43C-43 "%globalhint " (PreludeC-45Show-u--show_Show_Bool e-5)))) ((4) "%extern") ((5) (let ((e-8 (vector-ref arg-2 1))) (PreludeC-45TypesC-45String-C-43C-43 "%foreign " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 eta-0)) e-8))))) ((6) "%invertible") ((7) (let ((e-11 (vector-ref arg-2 1))) (cond ((equal? e-11 0) "total") ((equal? e-11 1) "covering") (else "partial")))) ((8) "%macro") (else (let ((e-14 (vector-ref arg-2 1))) (PreludeC-45TypesC-45String-C-43C-43 "%spec " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-14))))))))
(define TTImpC-45TTImp-u--show_Show_C-40ArgC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-2))) ((1) (let ((e-5 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "@{" (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-5) "}")))) (else (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 "{" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-8) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-9) "}"))))))))))
(define TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 arg-3)))
(define TTImpC-45TTImp-u--showPrec_Show_C-40ImpTyC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 arg-3)))
(define TTImpC-45TTImp-u--showPrec_Show_C-40ImpDeclC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 arg-3)))
(define TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 arg-3)))
(define TTImpC-45TTImp-u--showPrec_Show_C-40FnOptC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40FnOptC-39C-32C-36nmC-41 arg-1 arg-3)))
(define TTImpC-45TTImp-u--showPrec_Show_C-40ArgC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40ArgC-39C-32C-36nmC-41 arg-1 arg-3)))
(define TTImpC-45TTImp-u--fromBuf_TTC_RawImp (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 0 e-6 e-7))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-1833) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (vector 1 (vector 1 e-6 e-7 e-8 e-9 e-10 e-11))))))))))))))))))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-1833) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (vector 1 (vector 2 e-6 e-7 e-8 e-9 e-10 e-11))))))))))))))))))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (vector 3 e-6 e-7 e-8 e-9 e-10 e-11 e-12))))))))))))))))))))))))))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1836) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 4 e-6 e-7 e-8 e-9))))))))))))))))))) ((equal? e-5 5) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1839) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 5 e-6 e-7 e-8))))))))))))))) ((equal? e-5 6) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1842) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 7 e-6 e-7 e-8))))))))))))))) ((equal? e-5 7) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 8 e-6 e-7 e-8))))))))))))))) ((equal? e-5 8) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 10 e-6 e-7 e-8 e-9))))))))))))))))))) ((equal? e-5 9) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 11 e-6 e-7 e-8))))))))))))))) ((equal? e-5 10) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 12 e-6 e-7))))))))))) ((equal? e-5 11) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_AltType arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1833) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 13 e-6 e-7 e-8))))))))))))))) ((equal? e-5 12) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 14 e-6 e-7 e-8))))))))))))))) ((equal? e-5 13) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 15 e-6 e-7))))))))))) ((equal? e-5 14) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_BindMode arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 16 e-6 e-7 e-8))))))))))))))) ((equal? e-5 15) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 17 e-6 e-7))))))))))) ((equal? e-5 16) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_UseSide arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (vector 18 e-6 e-7 e-8 e-9 e-10))))))))))))))))))))))) ((equal? e-5 17) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 19 e-6 5 e-7))))))))))) ((equal? e-5 18) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 20 e-6 e-7 e-8))))))))))))))) ((equal? e-5 19) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 21 e-6 e-7))))))))))) ((equal? e-5 20) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 22 e-6 e-7))))))))))) ((equal? e-5 21) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 23 e-6 e-7))))))))))) ((equal? e-5 22) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 24 e-6 e-7))))))))))) ((equal? e-5 23) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1839) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 25 e-6 e-7))))))))))) ((equal? e-5 24) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 26 e-6 e-7))))))))))) ((equal? e-5 25) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 27 e-6 e-7))))))))))) ((equal? e-5 26) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 28 e-6 e-7))))))))))) ((equal? e-5 27) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 29 e-6))))))) ((equal? e-5 28) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 30 e-6 e-7))))))))))) ((equal? e-5 29) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 32 e-6 e-7))))))))))) ((equal? e-5 30) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 33 e-6 e-7 e-8))))))))))))))) ((equal? e-5 31) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 9 e-6 e-7 e-8)))))))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "RawImp" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_ImpTy (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector e-5 e-6 e-7 e-8))))))))))))))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_ImpRecord (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1845) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1863) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector e-5 e-6 e-7 e-8 e-9))))))))))))))))))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_ImpDecl (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_Visibility arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1866) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45TTImp-u--fromBuf_TTC_ImpTy arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (vector 0 e-6 e-7 e-8 e-9 e-10))))))))))))))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Visibility arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_ImpData arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 1 e-6 e-7 e-8))))))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1836) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 2 e-6 e-7 e-8))))))))))))))) ((equal? e-5 3) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1845) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1839) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 3 e-6 e-7 e-8))))))))))))))) ((equal? e-5 4) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-479) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_Visibility arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45TTImp-u--fromBuf_TTC_ImpRecord arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 4 e-6 e-7 e-8 e-9))))))))))))))))))) ((equal? e-5 5) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1839) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 5 e-6 e-7 e-8))))))))))))))) ((equal? e-5 6) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 6 e-6 e-7 e-8 e-9))))))))))))))))))) ((equal? e-5 7) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 7 e-6 e-7))))))))))) ((equal? e-5 8) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-1869) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-6))))))) ((equal? e-5 9) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_BuiltinType arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 10 e-6 e-7 e-8)))))))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "ImpDecl" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_ImpData (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1873) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1876) arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (vector 0 e-6 e-7 e-8 e-9 e-10))))))))))))))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 1 e-6 e-7 e-8)))))))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "ImpData" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_ImpClause (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 0 e-6 e-7 e-8))))))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 e-6 e-7))))))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1836) arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (vector 1 e-6 e-7 e-8 e-9 '() e-10)))))))))))))))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "ImpClause" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_IFieldUpdate (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 0 e-6 e-7))))))))))) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-479) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 1 e-6 e-7)))))))))))(else (CoreC-45BinaryC-45Prims-corrupt "IFieldUpdate" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_IField (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-1833) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector e-5 e-6 e-7 e-8 e-9))))))))))))))))))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_FnOpt (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6))))))) ((equal? e-5 2) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-6))))))) ((equal? e-5 3) (vector 1 (vector 4 ))) ((equal? e-5 4) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1833) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-6))))))) ((equal? e-5 5) (vector 1 (vector 6 ))) ((equal? e-5 6) (vector 1 (vector 7 0))) ((equal? e-5 7) (vector 1 (vector 7 1))) ((equal? e-5 8) (vector 1 (vector 7 2))) ((equal? e-5 9) (vector 1 (vector 8 ))) ((equal? e-5 10) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-6))))))) ((equal? e-5 11) (vector 1 (vector 1 )))(else (CoreC-45BinaryC-45Prims-corrupt "FnOpt" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_DataOpt (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-6))))))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 2 ))) ((equal? e-5 3) (vector 1 (vector 3 ))) ((equal? e-5 4) (vector 1 (vector 4 )))(else (CoreC-45BinaryC-45Prims-corrupt "DataOpt" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_BuiltinType (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "BuiltinType" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_BindMode (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-6))))))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 3 ))) ((equal? e-5 3) (vector 1 (vector 2 )))(else (CoreC-45BinaryC-45Prims-corrupt "BindMode" ext-0)))))))))
(define TTImpC-45TTImp-u--fromBuf_TTC_AltType (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (let ((act-25 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6)))))))(else (CoreC-45BinaryC-45Prims-corrupt "AltType" ext-0)))))))))
(define TTImpC-45TTImp-u--C-61C-61_Eq_WithFlag (lambda (arg-0 arg-1) (cond (else (cond (else 1))))))
(define TTImpC-45TTImp-u--C-61C-61_Eq_DataOpt (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-802) e-0 e-1)))(else 0)))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-1 0) ((3) 1)(else 0))) ((4) (case (vector-ref arg-1 0) ((4) 1)(else 0)))(else 0))))
(define TTImpC-45TTImp-u--C-47C-61_Eq_WithFlag (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45TTImp-u--C-61C-61_Eq_WithFlag arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45TTImp-u--C-47C-61_Eq_DataOpt (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45TTImp-u--C-61C-61_Eq_DataOpt arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45TTImp-mapAltType (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((2) (let ((e-1 (vector-ref arg-2 1))) (vector 2 (arg-1 e-1))))(else arg-2))))
(define TTImpC-45TTImp-logRaw (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (cond ((equal? arg-1 "") (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-5))))))) ext-0))) (vector 1 act-25)))(else (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "LOG " (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (arg-4) (PreludeC-45TypesC-45String-C-43C-43 ": " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-5))))))))) ext-0))) (vector 1 act-25))))) (else (vector 1 0)))))))))
(define TTImpC-45TTImp-lhsInCurrentNS (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-2 e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-1 e-5 e-3))))))))))) ((9) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-2 e-6) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (vector 1 (vector 9 e-5 e-8 e-7))))))))))) ((10) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (let ((e-12 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-2 e-10) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 10 e-9 e-5 e-11 e-12)))))))))))) ((11) (let ((e-14 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 2))) (let ((e-16 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-2 e-15) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 11 e-14 e-5 e-16))))))))))) ((0) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-19 0) ((0) (vector 1 arg-3))(else (let ((sc1 (DataC-45List-lookup (csegen-802) e-19 arg-2))) (if (null? sc1) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 e-19 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-18 e-5)))))) (vector 1 (vector 0 e-18 e-19))))))))))(else (lambda (eta-0) (vector 1 arg-3))))))
(define TTImpC-45TTImp-isTotalityReq (lambda (arg-1) (case (vector-ref arg-1 0) ((7) 1)(else 0))))
(define TTImpC-45TTImp-isIVar (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (box (cons e-1 e-2)))))(else '()))))
(define TTImpC-45TTImp-isIPrimVal (lambda (arg-1) (case (vector-ref arg-1 0) ((28) (let ((e-2 (vector-ref arg-1 2))) (box e-2)))(else '()))))
(define TTImpC-45TTImp-isIBindVar (lambda (arg-1) (case (vector-ref arg-1 0) ((17) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (box (cons e-1 e-2)))))(else '()))))
(define TTImpC-45TTImp-isExplicit (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (box (cons e-1 e-2)))))(else '()))))
(define TTImpC-45TTImp-implicitsAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--implicits (TTImpC-45TTImp-findIBinds arg-4))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "declare.def.lhs.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Found implicits: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) u--implicits))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (TTImpC-45TTImp-n--9855-11770-u--setAs arg-4 arg-3 arg-2 arg-1 arg-0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (box eta-1)) (PreludeC-45TypesC-45List-tailRecAppend arg-3 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 1 (vector 0 eta-1))) u--implicits))) '() arg-4 eta-0))))))))
(define TTImpC-45TTImp-getFnArgs (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((8) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (TTImpC-45TTImp-getFnArgs e-2 (cons (vector 0 e-1 e-3) arg-2)))))) ((10) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (TTImpC-45TTImp-getFnArgs e-6 (cons (vector 2 e-5 e-7 e-8) arg-2))))))) ((9) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (let ((e-12 (vector-ref arg-1 3))) (TTImpC-45TTImp-getFnArgs e-11 (cons (vector 1 e-10 e-12) arg-2))))))(else (cons arg-1 arg-2)))))
(define TTImpC-45TTImp-getFn (lambda (arg-1) (case (vector-ref arg-1 0) ((8) (let ((e-2 (vector-ref arg-1 2))) (TTImpC-45TTImp-getFn e-2))) ((11) (let ((e-6 (vector-ref arg-1 2))) (TTImpC-45TTImp-getFn e-6))) ((10) (let ((e-10 (vector-ref arg-1 2))) (TTImpC-45TTImp-getFn e-10))) ((9) (let ((e-15 (vector-ref arg-1 2))) (TTImpC-45TTImp-getFn e-15))) ((18) (let ((e-22 (vector-ref arg-1 5))) (TTImpC-45TTImp-getFn e-22))) ((19) (let ((e-26 (vector-ref arg-1 3))) (TTImpC-45TTImp-getFn e-26)))(else arg-1))))
(define TTImpC-45TTImp-getFC (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-4 (vector-ref arg-1 1))) e-4)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-18 (vector-ref arg-1 1))) e-18)) ((4) (let ((e-26 (vector-ref arg-1 1))) e-26)) ((5) (let ((e-31 (vector-ref arg-1 1))) e-31)) ((6) (let ((e-35 (vector-ref arg-1 1))) e-35)) ((7) (let ((e-41 (vector-ref arg-1 1))) e-41)) ((8) (let ((e-45 (vector-ref arg-1 1))) e-45)) ((10) (let ((e-49 (vector-ref arg-1 1))) e-49)) ((9) (let ((e-54 (vector-ref arg-1 1))) e-54)) ((11) (let ((e-58 (vector-ref arg-1 1))) e-58)) ((12) (let ((e-62 (vector-ref arg-1 1))) e-62)) ((13) (let ((e-65 (vector-ref arg-1 1))) e-65)) ((14) (let ((e-69 (vector-ref arg-1 1))) e-69)) ((15) (let ((e-73 (vector-ref arg-1 1))) e-73)) ((28) (let ((e-76 (vector-ref arg-1 1))) e-76)) ((30) (let ((e-79 (vector-ref arg-1 1))) e-79)) ((31) (let ((e-82 (vector-ref arg-1 1))) e-82)) ((29) (let ((e-86 (vector-ref arg-1 1))) e-86)) ((17) (let ((e-88 (vector-ref arg-1 1))) e-88)) ((16) (let ((e-91 (vector-ref arg-1 1))) e-91)) ((19) (let ((e-95 (vector-ref arg-1 1))) e-95)) ((20) (let ((e-99 (vector-ref arg-1 1))) e-99)) ((21) (let ((e-103 (vector-ref arg-1 1))) e-103)) ((22) (let ((e-106 (vector-ref arg-1 1))) e-106)) ((23) (let ((e-109 (vector-ref arg-1 1))) e-109)) ((24) (let ((e-112 (vector-ref arg-1 1))) e-112)) ((25) (let ((e-115 (vector-ref arg-1 1))) e-115)) ((26) (let ((e-118 (vector-ref arg-1 1))) e-118)) ((27) (let ((e-121 (vector-ref arg-1 1))) e-121)) ((18) (let ((e-124 (vector-ref arg-1 1))) e-124)) ((32) (let ((e-130 (vector-ref arg-1 1))) e-130)) (else (let ((e-133 (vector-ref arg-1 1))) e-133)))))
(define TTImpC-45TTImpC-45ImpDecl-getFC (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-7 (vector-ref arg-1 1))) e-7)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-15 (vector-ref arg-1 1))) e-15)) ((4) (let ((e-19 (vector-ref arg-1 1))) e-19)) ((5) (let ((e-24 (vector-ref arg-1 1))) e-24)) ((6) (let ((e-28 (vector-ref arg-1 1))) e-28)) ((7) (let ((e-33 (vector-ref arg-1 1))) e-33)) ((8) (vector 2 )) ((9) (vector 2 )) (else (let ((e-41 (vector-ref arg-1 1))) e-41)))))
(define TTImpC-45TTImp-gapply (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (TTImpC-45TTImp-gapply (PreludeC-45Basics-uncurry (lambda (eta-0) (lambda (eta-1) (TTImpC-45TTImp-n--11756-13545-u--app e-2 e-3 arg-1 arg-1 eta-0 eta-1))) e-2) e-3))))))
(define TTImpC-45TTImp-findImplicits (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (if (null? e-4) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-5) (TTImpC-45TTImp-findImplicits e-6)) (let ((e-68 (unbox e-4))) (case (vector-ref e-68 0) ((1) (let ((e-69 (vector-ref e-68 1))) (case (vector-ref e-69 0) ((0) (let ((e-70 (vector-ref e-69 1))) (cons e-70 (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-5) (TTImpC-45TTImp-findImplicits e-6)))))(else (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-5) (TTImpC-45TTImp-findImplicits e-6))))))(else (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-5) (TTImpC-45TTImp-findImplicits e-6)))))))))) ((2) (let ((e-12 (vector-ref arg-1 5))) (let ((e-13 (vector-ref arg-1 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-12) (TTImpC-45TTImp-findImplicits e-13))))) ((8) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-16) (TTImpC-45TTImp-findImplicits e-17))))) ((9) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-20) (TTImpC-45TTImp-findImplicits e-21))))) ((10) (let ((e-24 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-24) (TTImpC-45TTImp-findImplicits e-26))))) ((11) (let ((e-29 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-29) (TTImpC-45TTImp-findImplicits e-30))))) ((18) (let ((e-36 (vector-ref arg-1 5))) (TTImpC-45TTImp-findImplicits e-36))) ((19) (let ((e-40 (vector-ref arg-1 3))) (TTImpC-45TTImp-findImplicits e-40))) ((13) (let ((e-44 (vector-ref arg-1 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45TTImp-findImplicits eta-0)) e-44))) ((20) (let ((e-48 (vector-ref arg-1 3))) (TTImpC-45TTImp-findImplicits e-48))) ((21) (let ((e-51 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-51))) ((22) (let ((e-54 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-54))) ((23) (let ((e-57 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-57))) ((26) (let ((e-60 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-60))) ((27) (let ((e-63 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-63))) ((17) (let ((e-66 (vector-ref arg-1 2))) (cons e-66 '())))(else '()))))
(define TTImpC-45TTImp-findIBinds (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-5) (TTImpC-45TTImp-findIBinds e-6))))) ((2) (let ((e-12 (vector-ref arg-1 5))) (let ((e-13 (vector-ref arg-1 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-12) (TTImpC-45TTImp-findIBinds e-13))))) ((8) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-16) (TTImpC-45TTImp-findIBinds e-17))))) ((9) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-20) (TTImpC-45TTImp-findIBinds e-21))))) ((10) (let ((e-24 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-24) (TTImpC-45TTImp-findIBinds e-26))))) ((11) (let ((e-29 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-29) (TTImpC-45TTImp-findIBinds e-30))))) ((18) (let ((e-35 (vector-ref arg-1 4))) (let ((e-36 (vector-ref arg-1 5))) (case (vector-ref e-35 0) ((1) (let ((e-71 (vector-ref e-35 1))) (case (vector-ref e-71 0) ((0) (let ((e-72 (vector-ref e-71 1))) (cons e-72 (TTImpC-45TTImp-findIBinds e-36))))(else (TTImpC-45TTImp-findIBinds e-36)))))(else (TTImpC-45TTImp-findIBinds e-36)))))) ((19) (let ((e-40 (vector-ref arg-1 3))) (TTImpC-45TTImp-findIBinds e-40))) ((13) (let ((e-44 (vector-ref arg-1 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45TTImp-findIBinds eta-0)) e-44))) ((20) (let ((e-48 (vector-ref arg-1 3))) (TTImpC-45TTImp-findIBinds e-48))) ((21) (let ((e-51 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-51))) ((22) (let ((e-54 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-54))) ((23) (let ((e-57 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-57))) ((26) (let ((e-60 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-60))) ((27) (let ((e-63 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-63))) ((16) (let ((e-67 (vector-ref arg-1 3))) (TTImpC-45TTImp-findIBinds e-67))) ((17) (let ((e-70 (vector-ref arg-1 2))) (cons e-70 '())))(else '()))))
(define TTImpC-45TTImp-definedInBlock (lambda (arg-0 arg-1) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45TTImp-n--10854-12678-u--defName arg-1 arg-0 arg-0 eta-0)) arg-1)))
(define TTImpC-45TTImp-apply (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--fFC (TTImpC-45TTImp-getFC arg-1))) (TTImpC-45TTImp-apply (vector 8 (DataC-45Maybe-fromMaybe (lambda () u--fFC) (CoreC-45FC-mergeFC u--fFC (TTImpC-45TTImp-getFC e-2))) arg-1 e-2) e-3)))))))
(define TTImpC-45TTImpC-45Arg-apply (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (case (vector-ref e-1 0) ((0) (let ((e-5 (vector-ref e-1 1))) (let ((e-6 (vector-ref e-1 2))) (TTImpC-45TTImpC-45Arg-apply (vector 8 e-5 arg-1 e-6) e-2)))) ((1) (let ((e-8 (vector-ref e-1 1))) (let ((e-9 (vector-ref e-1 2))) (TTImpC-45TTImpC-45Arg-apply (vector 9 e-8 arg-1 e-9) e-2)))) (else (let ((e-11 (vector-ref e-1 1))) (let ((e-12 (vector-ref e-1 2))) (let ((e-13 (vector-ref e-1 3))) (TTImpC-45TTImpC-45Arg-apply (vector 10 e-11 arg-1 e-12 e-13) e-2)))))))))))
(define TTImpC-45ProcessDecls-n--12556-8385-u--checkTotality (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45ContextC-45Log-logTime arg-1 (lambda () (PreludeC-45TypesC-45String-C-43C-43 "+++ Checking Termination " (CoreC-45Name-u--show_Show_Name arg-0))) (lambda (eta-1) (CoreC-45Termination-checkTotal arg-1 arg-2 arg-0 eta-1)) eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Context-getTotality arg-1 arg-2 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ProcessDecls-n--12556-8384-u--checkCovering arg-0 arg-1 arg-2 (let ((e-1 (cdr e-6))) e-1) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((PreludeC-45Types-maybe (let ((e-0 (car e-6))) (case (vector-ref e-0 0) ((2) (let ((e-2 (vector-ref e-0 1))) (lambda () (lambda (eta-0) (vector 1 (box (vector 12 arg-2 arg-0 e-2)))))))(else (lambda () (lambda (eta-0) (vector 1 '())))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 (box eta-0))))) e-7) ext-0))))))))))))))
(define TTImpC-45ProcessDecls-n--12556-8384-u--checkCovering (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (vector 1 '()))(else (vector 1 (box (vector 11 arg-2 arg-0 arg-3)))))))
(define TTImpC-45ProcessDecls-n--12922-8714-u--bindNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-11 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-13 (vector-ref e-5 2))) (let ((e-14 (vector-ref e-5 3))) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-7 e-1 '() arg-1 e-14 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-2 e-3 e-4 (vector e-11 e-12 e-13 e-6))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-8 1))) (let ((e-8 (vector-ref arg-8 2))) (let ((e-9 (vector-ref arg-8 3))) (let ((act-24 (TTImpC-45ProcessDecls-n--12922-8713-u--bindDataNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-9 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-7 e-8 e-5))))))))))(else (vector 1 arg-8))))))
(define TTImpC-45ProcessDecls-n--12922-8713-u--bindDataNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-7 e-1 '() arg-1 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDecls-n--12922-8712-u--bindConNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0 eta-1))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-6 e-4 e-7)))))))))))))))) (else (let ((e-7 (vector-ref arg-8 1))) (let ((e-8 (vector-ref arg-8 2))) (let ((e-9 (vector-ref arg-8 3))) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-7 e-7 '() arg-1 e-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-7 e-8 e-5)))))))))))))
(define TTImpC-45ProcessDecls-n--12922-8712-u--bindConNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-1 (vector-ref arg-8 0))) (let ((e-2 (vector-ref arg-8 1))) (let ((e-3 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 3))) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-7 e-1 '() arg-1 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector e-1 e-2 e-3 e-5))))))))))))
(define TTImpC-45ProcessDecls-processTTImpFile (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Directory-ctxtPathToNS arg-0 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "Parsing") (lambda (eta-0) (let ((act-25 (ParserC-45Source-parseFile arg-4 (vector 0 e-5) (vector 9 0 (TTImpC-45Parser-prog (vector 0 e-5)) (lambda () (lambda (u--decls) (vector 12 0 0 (ParserC-45RuleC-45Source-eoi) (vector 0 u--decls))))) eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-13 (cdr e-9))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-recordWarning arg-0 eta-0 eta-1))) e-8 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "Elaboration") (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-2) (TTImpC-45ProcessDecls-processTTImpDecls '() arg-0 arg-1 arg-2 arg-3 '() '() e-13 eta-2)) eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 (CoreC-45UnifyState-checkDelayedHoles arg-2 arg-0 eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-28 1))) (if (null? e-11) (vector 1 1) (let ((e-3 (unbox e-11))) (CoreC-45Core-u--throw_Catchable_Core_Error e-3 eta-1))))))))))) (lambda (u--err) (lambda (eta-1) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-2) (let ((act-27 ((PreludeC-45IO-printLn (csegen-1269) u--err) eta-2))) (vector 1 act-27))) eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (vector 1 0)))))) eta-0)) ext-0))))))))) (else (let ((e-7 (vector-ref e-6 1))) (let ((act-26 (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (CoreC-45Core-u--show_Show_Error e-7)) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 0)))))))))))))))))
(define TTImpC-45ProcessDecls-processTTImpDecls (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45Core-traverse_ (lambda (u--d) (lambda (eta-0) (let ((act-24 ((TTImpC-45ProcessDecls-n--12922-8714-u--bindNames arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--d) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-4 '() arg-5 arg-6 e-5) eta-0))))))) arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 1))))))
(define TTImpC-45ProcessDecls-processDecls (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-4 '() arg-5 arg-6 eta-0)) arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 1))))))
(define TTImpC-45ElabC-45Check-processDecl (lambda (ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8) (TTImpC-45ProcessDecls-process ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8)))
(define TTImpC-45ProcessDecls-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (lambda (eta-0) (TTImpC-45ProcessType-processType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-1 e-2 e-3 e-4 e-5 eta-0)))))))) ((1) (let ((e-7 (vector-ref arg-8 1))) (let ((e-8 (vector-ref arg-8 2))) (let ((e-9 (vector-ref arg-8 3))) (lambda (eta-0) (TTImpC-45ProcessData-processData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-7 e-8 e-9 eta-0)))))) ((2) (let ((e-11 (vector-ref arg-8 1))) (let ((e-12 (vector-ref arg-8 2))) (let ((e-13 (vector-ref arg-8 3))) (lambda (eta-0) (TTImpC-45ProcessDef-processDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-11 e-12 e-13 eta-0)))))) ((3) (let ((e-15 (vector-ref arg-8 1))) (let ((e-16 (vector-ref arg-8 2))) (let ((e-17 (vector-ref arg-8 3))) (TTImpC-45ProcessParams-processParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 e-15 e-16 e-17))))) ((4) (let ((e-20 (vector-ref arg-8 2))) (let ((e-21 (vector-ref arg-8 3))) (let ((e-22 (vector-ref arg-8 4))) (TTImpC-45ProcessRecord-processRecord arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-20 e-21 e-22))))) ((5) (let ((e-25 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 3))) (lambda (eta-0) (CoreC-45Context-withExtendedNS arg-1 e-25 (lambda (eta-1) (CoreC-45Core-traverse_ (lambda (eta-2) (TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-2)) e-26 eta-1)) eta-0))))) ((6) (let ((e-28 (vector-ref arg-8 1))) (let ((e-29 (vector-ref arg-8 2))) (let ((e-30 (vector-ref arg-8 3))) (let ((e-31 (vector-ref arg-8 4))) (lambda (eta-0) (TTImpC-45ProcessTransform-processTransform arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-28 e-29 e-30 e-31 eta-0))))))) ((7) (let ((e-33 (vector-ref arg-8 1))) (let ((e-34 (vector-ref arg-8 2))) (lambda (eta-0) (TTImpC-45ProcessRunElab-processRunElab arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-33 e-34 eta-0))))) ((8) (let ((e-37 (vector-ref arg-8 2))) (((e-37 arg-0) arg-6) arg-7))) ((9) (let ((e-39 (vector-ref arg-8 1))) (lambda (eta-0) (CoreC-45Context-addLogLevel arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-1) (PreludeC-45Basics-uncurry (lambda (eta-2) (lambda (eta-3) (CoreC-45OptionsC-45Log-unsafeMkLogLevel eta-2 eta-3))) eta-1)) e-39) eta-0)))) (else (let ((e-41 (vector-ref arg-8 1))) (let ((e-42 (vector-ref arg-8 2))) (let ((e-43 (vector-ref arg-8 3))) (TTImpC-45ProcessBuiltin-processBuiltin arg-1 arg-6 arg-7 e-41 e-42 e-43))))))))
(define TTImpC-45ProcessDecls-getTotalityErrors (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45ProcessDecls-checkTotalityOK arg-0 eta-0)) (LibrariesC-45DataC-45NameMap-keys (let ((e-31 (vector-ref e-5 5))) e-31)) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-6))))))))))))
(define TTImpC-45ProcessDecls-checkTotalityOK (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((2) (vector 1 '())) ((6) (vector 1 '()))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-33 (vector-ref e-5 0))) e-33)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-2 (unbox e-6))) (let ((u--fc (let ((e-26 (vector-ref e-2 0))) e-26))) (let ((act-26 (let ((e-17 (vector-ref e-2 17))) (case (vector-ref e-17 0) ((6) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Termination-checkPositive arg-0 u--fc arg-1 eta-0)) clam-0))(else (vector 1 0)))))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (CoreC-45Context-getDefaultTotalityOption arg-0 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--treq (DataC-45Maybe-fromMaybe (lambda () e-8) (CoreC-45ContextC-45Context-findSetTotal (let ((e-11 (vector-ref e-2 11))) e-11))))) (let ((u--tot (let ((e-10 (vector-ref e-2 10))) e-10))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-0 "totality" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) (PreludeC-45TypesC-45String-C-43C-43 " must be: " (CoreC-45TT-u--show_Show_TotalReq u--treq)))) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (cond ((equal? u--treq 2) (vector 1 '())) ((equal? u--treq 1) (TTImpC-45ProcessDecls-n--12556-8384-u--checkCovering arg-1 arg-0 u--fc (let ((e-3 (cdr u--tot))) e-3) clam-0)) (else (TTImpC-45ProcessDecls-n--12556-8385-u--checkTotality arg-1 arg-0 u--fc clam-0))))))))))))))))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((u--fc (let ((e-0 (vector-ref e-1 0))) e-0))) (let ((act-26 (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((6) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Termination-checkPositive arg-0 u--fc arg-1 eta-0)) clam-0))(else (vector 1 0)))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-getDefaultTotalityOption arg-0 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--treq (DataC-45Maybe-fromMaybe (lambda () e-8) (CoreC-45ContextC-45Context-findSetTotal (let ((e-11 (vector-ref e-1 11))) e-11))))) (let ((u--tot (let ((e-10 (vector-ref e-1 10))) e-10))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-0 "totality" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) (PreludeC-45TypesC-45String-C-43C-43 " must be: " (CoreC-45TT-u--show_Show_TotalReq u--treq)))) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (cond ((equal? u--treq 2) (vector 1 '())) ((equal? u--treq 1) (TTImpC-45ProcessDecls-n--12556-8384-u--checkCovering arg-1 arg-0 u--fc (let ((e-2 (cdr u--tot))) e-2) clam-0)) (else (TTImpC-45ProcessDecls-n--12556-8385-u--checkTotality arg-1 arg-0 u--fc clam-0)))))))))))))))))))))))))))))))
(define TTImpC-45ProcessType-case--findInferrableC-44findInf-9794 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (unbox arg-7))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) e-2 arg-6))) (cond ((equal? sc1 1) (vector 1 arg-6)) (else (vector 1 (cons e-2 arg-6))))))))))
(define TTImpC-45ProcessType-case--processFnOptC-44insertDeps-8451 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (TTImpC-45ProcessType-n--9844-8429-u--insertDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-8 arg-7 arg-6) (let ((e-2 (unbox arg-9))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) e-2 arg-8))) (cond ((equal? sc1 1) (TTImpC-45ProcessType-n--9844-8429-u--insertDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-8 arg-7 arg-6)) (else (TTImpC-45ProcessType-n--9844-8429-u--insertDeps arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-8) arg-7 arg-6))))))))
(define TTImpC-45ProcessType-n--10014-8852-u--splitPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (cons '() '()) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (let ((sc1 (TTImpC-45ProcessType-n--10014-8852-u--splitPs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-12) arg-13 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (PreludeC-45Types-elem (csegen-792) arg-12 arg-13))) (cond ((equal? sc2 1) (cons (cons e-2 e-5) e-4)) (else (cons e-5 (cons e-2 e-4)))))))))))))
(define TTImpC-45ProcessType-n--12019-10321-u--isNested (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30) (case (vector-ref arg-30 0) ((5) 1) ((0) (let ((e-3 (vector-ref arg-30 2))) (TTImpC-45ProcessType-n--12019-10321-u--isNested arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 e-3)))(else 0))))
(define TTImpC-45ProcessType-n--9844-8429-u--insertDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-5 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (TTImpC-45ProcessType-case--processFnOptC-44insertDeps-8451 arg-0 arg-1 arg-2 arg-3 arg-4 e-2 e-3 arg-6 arg-5 (DataC-45List-lookup (csegen-802) e-2 arg-6)))))))
(define TTImpC-45ProcessType-n--9844-8434-u--getNamePos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((TTImpC-45ProcessType-n--9844-8434-u--getNamePos arg-0 arg-1 arg-2 arg-3 arg-4 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-5) e-10) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (cons (cons e-2 arg-5) e-10)))))))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45ProcessType-n--9844-8431-u--getDepsArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (if (null? arg-6) (vector 1 arg-7) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 ((TTImpC-45ProcessType-n--9844-8432-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 arg-7) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45ProcessType-n--9844-8431-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 e-5 ext-0))))))))))
(define TTImpC-45ProcessType-n--9844-8432-u--getDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-29 (vector-ref e-3 4))) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 e-29) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ProcessType-n--9844-8432-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-7) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-3 0))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45ProcessType-n--9844-8432-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 e-6) clam-0)))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 (CoreC-45TT-binderType e-3)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ProcessType-n--9844-8432-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 0 e-6 arg-7) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-3 0))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45ProcessType-n--9844-8432-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 0 e-7 arg-7) clam-0)))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (lambda (clam-0) (case (vector-ref e-7 0) ((1) (let ((e-31 (vector-ref e-7 1))) (let ((e-32 (vector-ref e-7 2))) (case (vector-ref e-31 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 (Builtin-snd eta-0))) e-8 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (TTImpC-45ProcessType-n--9844-8431-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 0 e-9 arg-7 clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (LibrariesC-45DataC-45NameMap-insert e-32 arg-5 e-9)))))))))))(else (vector 1 arg-7))))))(else (vector 1 arg-7))))))) ((2) (let ((e-14 (vector-ref arg-6 5))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 (Builtin-snd eta-1))) e-14 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45ProcessType-n--9844-8431-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 0 e-6 arg-7 eta-0)))))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-lookupDefExact e-17 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((6) (let ((e-4 (vector-ref e-1 3))) (vector 1 e-4)))(else (vector 1 '()))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc3 (TTImpC-45ProcessType-n--10014-8852-u--splitPs arg-0 arg-1 arg-2 arg-3 arg-4 e-16 e-20 e-19 e-18 e-17 arg-7 arg-5 0 e-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-20)))) (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (let ((act-26 (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 eta-1)) e-2 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (TTImpC-45ProcessType-n--9844-8431-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 1 e-7 arg-7 eta-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 eta-1)) e-3 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (TTImpC-45ProcessType-n--9844-8431-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 0 e-8 e-7 eta-0))))))))))))))))))))))))))) ((5) (let ((e-24 (vector-ref arg-6 3))) (TTImpC-45ProcessType-n--9844-8432-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-24 arg-7)))(else (lambda (eta-0) (vector 1 arg-7))))))
(define TTImpC-45ProcessType-n--11492-9764-u--findInfs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 arg-3) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-24 (TTImpC-45ProcessType-n--11492-9764-u--findInfs arg-0 arg-1 arg-2 arg-3 arg-4 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ProcessType-n--11492-9763-u--findInf arg-0 arg-1 arg-2 e-5 arg-4 e-2) ext-0))))))))))
(define TTImpC-45ProcessType-n--11492-9763-u--findInf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (case (vector-ref e-2 0) ((1) (let ((e-21 (vector-ref e-2 1))) (let ((e-22 (vector-ref e-2 2))) (case (vector-ref e-21 0) ((0) (if (null? e-3) (TTImpC-45ProcessType-case--findInferrableC-44findInf-9794 arg-0 arg-1 arg-2 e-1 e-22 arg-4 arg-3 (DataC-45List-lookup (csegen-802) e-22 arg-4)) (lambda (eta-0) (vector 1 arg-3))))(else (lambda (eta-0) (vector 1 arg-3)))))))(else (lambda (eta-0) (vector 1 arg-3)))))))) ((2) (let ((e-9 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 (Builtin-snd eta-1))) e-9 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-24 1))) (TTImpC-45ProcessType-n--11492-9764-u--findInfs arg-0 arg-1 arg-2 arg-3 arg-4 e-10 eta-0)))))))) ((3) (let ((e-15 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 (Builtin-snd eta-1))) e-15 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45ProcessType-n--11492-9764-u--findInfs arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0)))))))) ((5) (let ((e-19 (vector-ref arg-5 3))) (TTImpC-45ProcessType-n--11492-9763-u--findInf arg-0 arg-1 arg-2 arg-3 arg-4 e-19)))(else (lambda (eta-0) (vector 1 arg-3))))))
(define TTImpC-45ProcessType-n--11492-9765-u--fi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((u--argn (vector 2 "inf" arg-4))) (lambda (eta-0) (let ((act-24 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-1 (vector 0 ) u--argn))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 e-9) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((TTImpC-45ProcessType-n--11492-9763-u--findInf arg-0 arg-1 arg-2 arg-6 arg-5 e-10) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ProcessType-n--11492-9765-u--fi arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-3) (bs+ (blodwen-toSignedInt 1 63) arg-4 63) (cons (cons u--argn arg-3) arg-5) e-10 e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 e-11)))))))))))))))))(else (TTImpC-45ProcessType-n--11492-9763-u--findInf arg-0 arg-1 arg-2 arg-6 arg-5 arg-7)))))))(else (TTImpC-45ProcessType-n--11492-9763-u--findInf arg-0 arg-1 arg-2 arg-6 arg-5 arg-7)))))
(define TTImpC-45ProcessType-n--9844-8433-u--collectSpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-1 (vector 0 ) e-2))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((sc5 (PreludeC-45Types-elem (csegen-802) e-2 arg-1))) (cond ((equal? sc5 1) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 e-9) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) ((TTImpC-45ProcessType-n--9844-8432-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 1 e-12 (LibrariesC-45DataC-45NameMap-empty)) clam-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((u--rs (DataC-45List-filter (lambda (u--x) (let ((sc7 (Builtin-snd u--x))) (cond ((equal? sc7 1) 1) (else (let ((sc8 (PreludeC-45Types-elem (csegen-802) (Builtin-fst u--x) arg-6))) (cond ((equal? sc8 1) 0) (else 1))))))) (LibrariesC-45DataC-45NameMap-toList e-12)))) (let ((u--accC-39 (TTImpC-45ProcessType-n--9844-8429-u--insertDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (cons e-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--rs))))) ((TTImpC-45ProcessType-n--9844-8433-u--collectSpec arg-0 arg-1 arg-2 arg-3 arg-4 u--accC-39 arg-6 arg-7 e-11) clam-0)))))))) (else ((TTImpC-45ProcessType-n--9844-8433-u--collectSpec arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-11) clam-0)))))))))))))))))(else (vector 1 arg-5))))))))(else (vector 1 arg-5))))))
(define TTImpC-45ProcessType-n--9844-8430-u--collectDDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-1 (vector 0 ) e-2))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((sc5 (PreludeC-45Types-elem (csegen-802) e-2 arg-1))) (cond ((equal? sc5 1) ((TTImpC-45ProcessType-n--9844-8430-u--collectDDeps arg-0 arg-1 arg-2 arg-3 arg-4 e-11) clam-0)) (else (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-4 '() e-10 '() e-9 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((u--deps (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getRefs (vector 1 (vector 2 )) e-12)))) (let ((act-28 ((TTImpC-45ProcessType-n--9844-8430-u--collectDDeps arg-0 arg-1 arg-2 arg-3 arg-4 e-11) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-13 u--deps))))))))))))))))))))))))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45ProcessType-processType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((e-1 (vector-ref arg-12 0))) (let ((e-2 (vector-ref arg-12 1))) (let ((e-3 (vector-ref arg-12 2))) (let ((e-4 (vector-ref arg-12 3))) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Metadata-addNameLoc arg-2 arg-1 e-2 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "declare.type" (+ 1 0) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Processing " (CoreC-45Name-u--show_Show_Name e-5))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "declare.type" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (DataC-45String-unwords (cons "Checking type decl:" (cons (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega arg-9) (cons (CoreC-45Name-u--show_Show_Name e-5) (cons ":" (cons (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-4) '()))))))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((act-28 (CoreC-45Context-resolveName arg-1 e-5 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (unbox arg-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-10 (vector-ref act-29 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45Context-lookupCtxtExact (vector 8 e-9) (let ((e-0 (vector-ref e-10 0))) e-0)) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-11 (vector-ref act-30 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-30 1))) (if (null? e-11) (let ((act-31 ((TTImpC-45ElabC-45Utils-wrapErrorC arg-5 (lambda (eta-0) (vector 62 arg-8 e-5 eta-0)) (lambda (eta-0) (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 e-9 (vector 0 ) (cons 0 arg-5) arg-6 arg-7 (vector 16 arg-8 (csegen-1885) e-4) (CoreC-45NormaliseC-45Eval-gType arg-8) eta-0))) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-12 (vector-ref act-31 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Normalise-logTermNF '() arg-1 "declare.type" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Type of " (CoreC-45Name-u--show_Show_Name e-5))) '() (CoreC-45Env-abstractFullEnvType arg-0 e-1 arg-7 e-12) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-13 (vector-ref act-32 1))) (vector 0 e-13))) (else (let ((act-33 ((TTImpC-45ProcessType-initDef arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-7 e-12 arg-11) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-14 (vector-ref act-33 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-33 1))) (let ((u--fullty (CoreC-45Env-abstractFullEnvType arg-0 e-1 arg-7 e-12))) (let ((act-34 (TTImpC-45ElabC-45Utils-findErased arg-1 u--fullty ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-15 (vector-ref act-34 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-34 1))) (let ((_-0 '())) (let ((e-17 (car e-15))) (let ((e-16 (cdr e-15))) (let ((act-35 (let ((act-35 (unbox arg-1))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-18 (vector-ref act-35 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-35 1))) (let ((act-36 (CoreC-45Context-clearDefs e-18 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-19 (vector-ref act-36 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-36 1))) (let ((act-37 (let ((act-37 ((CoreC-45NormaliseC-45Eval-nf arg-1 '() e-18 '() u--fullty) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-20 (vector-ref act-37 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-37 1))) ((TTImpC-45ProcessType-findInferrable arg-1 e-19 e-20) ext-0))))))) (case (vector-ref act-37 0) ((0) (let ((e-20 (vector-ref act-37 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-37 1))) (let ((act-38 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-1 (vector 8 e-9) (let ((sc16 (CoreC-45Context-newDef arg-8 e-5 arg-9 arg-0 u--fullty arg-10 e-14))) (let ((e-0 (vector-ref sc16 0))) (let ((e-41 (vector-ref sc16 1))) (let ((e-40 (vector-ref sc16 2))) (let ((e-37 (vector-ref sc16 5))) (let ((e-35 (vector-ref sc16 7))) (let ((e-34 (vector-ref sc16 8))) (let ((e-33 (vector-ref sc16 9))) (let ((e-32 (vector-ref sc16 10))) (let ((e-31 (vector-ref sc16 11))) (let ((e-30 (vector-ref sc16 12))) (let ((e-29 (vector-ref sc16 13))) (let ((e-28 (vector-ref sc16 14))) (let ((e-27 (vector-ref sc16 15))) (let ((e-26 (vector-ref sc16 16))) (let ((e-25 (vector-ref sc16 17))) (let ((e-24 (vector-ref sc16 18))) (let ((e-23 (vector-ref sc16 19))) (let ((e-22 (vector-ref sc16 20))) (let ((e-21 (vector-ref sc16 21))) (vector e-0 e-41 e-40 e-17 e-16 e-37 e-20 e-35 e-34 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-22 e-21))))))))))))))))))))) eta-0)) ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-21 (vector-ref act-38 1))) (vector 0 e-21))) (else (let ((act-39 (let ((sc17 (PreludeC-45Types-elem (csegen-1886) 1 arg-5))) (cond ((equal? sc17 1) (vector 1 0)) (else (CoreC-45Context-setLinearCheck arg-1 e-9 1 ext-0)))))) (case (vector-ref act-39 0) ((0) (let ((e-22 (vector-ref act-39 1))) (vector 0 e-22))) (else (let ((act-40 (CoreC-45ContextC-45Log-log arg-1 "declare.type" (+ 1 (+ 1 0)) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Setting options for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40FnOptC-39C-32C-36nmC-41 (csegen-737) u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40FnOptC-39C-32C-36nmC-41 (csegen-737) u--d u--x)))) arg-11))))) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-23 (vector-ref act-40 1))) (vector 0 e-23))) (else (let ((u--name (vector 8 e-9))) (let ((act-41 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ProcessType-processFnOpt arg-1 arg-8 (let ((sc19 (TTImpC-45ProcessType-n--12019-10321-u--isNested e-4 e-3 e-2 e-1 arg-11 arg-10 arg-9 arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-9 e-10 _-0 e-12 e-14 u--fullty e-17 e-16 e-15 e-18 e-19 e-20 u--name e-5))) (cond ((equal? sc19 1) 0) (else 1))) u--name eta-0)) arg-11 ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-24 (vector-ref act-41 1))) (vector 0 e-24))) (else (let ((act-42 (let ((act-42 (CoreC-45Context-getDefaultTotalityOption arg-1 ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-25 (vector-ref act-42 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-42 1))) (let ((sc21 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45TTImp-isTotalityReq eta-0)) arg-11))) (cond ((equal? sc21 1) (vector 1 0)) (else (CoreC-45Context-setFlag arg-1 arg-8 u--name (vector 4 e-25) ext-0)))))))))) (case (vector-ref act-42 0) ((0) (let ((e-25 (vector-ref act-42 1))) (vector 0 e-25))) (else (let ((act-43 (CoreC-45Metadata-addTyDecl arg-0 arg-1 arg-2 arg-8 (vector 8 e-9) arg-7 e-12 ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-26 (vector-ref act-43 1))) (vector 0 e-26))) (else (let ((act-44 (CoreC-45ContextC-45Log-log arg-1 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () "processType is adding \x2193;") ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-27 (vector-ref act-44 1))) (vector 0 e-27))) (else (let ((act-45 (CoreC-45Metadata-addNameType arg-0 arg-1 arg-2 e-2 (vector 8 e-9) arg-7 e-12 ext-0))) (case (vector-ref act-45 0) ((0) (let ((e-28 (vector-ref act-45 1))) (vector 0 e-28))) (else (let ((act-46 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addToSave arg-1 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-12)) ext-0))) (case (vector-ref act-46 0) ((0) (let ((e-29 (vector-ref act-46 1))) (vector 0 e-29))) (else (let ((act-47 (CoreC-45Context-addToSave arg-1 e-5 ext-0))) (case (vector-ref act-47 0) ((0) (let ((e-30 (vector-ref act-47 1))) (vector 0 e-30))) (else (let ((act-48 (CoreC-45ContextC-45Log-log arg-1 "declare.type" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Saving from " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-12))))))) ext-0))) (case (vector-ref act-48 0) ((0) (let ((e-31 (vector-ref act-48 1))) (vector 0 e-31))) (else (let ((sc27 (CoreC-45TT-u--C-47C-61_Eq_Visibility arg-10 0))) (cond ((equal? sc27 1) (let ((act-49 (CoreC-45Context-addHashWithNames arg-1 (csegen-817) (csegen-46) e-5 ext-0))) (case (vector-ref act-49 0) ((0) (let ((e-32 (vector-ref act-49 1))) (vector 0 e-32))) (else (CoreC-45Context-addHashWithNames arg-1 (csegen-834) (csegen-76) e-12 ext-0))))) (else (vector 1 0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 arg-8 e-5) ext-0)))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessType-processFnOpt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (lambda (eta-0) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) eta-0))) ((1) (lambda (eta-0) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 3 ) eta-0)))(else (cond ((equal? arg-2 1) (case (vector-ref arg-4 0) ((2) (let ((e-16 (vector-ref arg-4 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 eta-0) (let ((e-1 (unbox e-6))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() e-1) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45ProcessType-getRetTy e-5 e-7) eta-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Context-addHintFor arg-0 arg-1 e-7 arg-3 e-16 0 eta-0))))))))))))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-0 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Adding local hint " (CoreC-45Name-u--show_Show_Name e-5))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Context-addLocalHint arg-0 arg-3 eta-0))))))(else (cond ((equal? arg-2 1) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-12 (vector-ref arg-4 1))) (CoreC-45Context-addGlobalHint arg-0 arg-3 e-12 clam-0)))(else (case (vector-ref arg-4 0) ((3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "%globalhint is not valid in local definitions") clam-0)) ((4) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-0)) ((5) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-0)) ((6) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 1 ) clam-0)) ((7) (let ((e-7 (vector-ref arg-4 1))) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 4 e-7) clam-0))) ((8) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 6 ) clam-0)) (else (let ((e-10 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-0) (let ((e-1 (unbox e-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2)) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ProcessType-n--9844-8434-u--getNamePos arg-2 e-10 arg-3 arg-1 arg-0 0 e-7) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45ProcessType-n--9844-8430-u--collectDDeps arg-2 e-10 arg-3 arg-1 arg-0 e-7) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((TTImpC-45ProcessType-n--9844-8433-u--collectSpec arg-2 e-10 arg-3 arg-1 arg-0 '() e-9 e-8 e-7) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-29 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-3 (let ((e-0 (vector-ref e-1 0))) (let ((e-29 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-27 (vector-ref e-1 6))) (let ((e-26 (vector-ref e-1 7))) (let ((e-25 (vector-ref e-1 8))) (let ((e-24 (vector-ref e-1 9))) (let ((e-23 (vector-ref e-1 10))) (let ((e-22 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-29 e-2 e-3 e-4 e-11 e-27 e-26 e-25 e-24 e-23 e-22 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) clam-0))))))))))))))))))))))))))))))))))(else (lambda (clam-1) (case (vector-ref arg-4 0) ((3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "%globalhint is not valid in local definitions") clam-1)) ((4) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-1)) ((5) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-1)) ((6) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 1 ) clam-1)) ((7) (let ((e-7 (vector-ref arg-4 1))) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 4 e-7) clam-1))) ((8) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 6 ) clam-1)) (else (let ((e-10 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-1) (let ((e-1 (unbox e-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2)) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ProcessType-n--9844-8434-u--getNamePos arg-2 e-10 arg-3 arg-1 arg-0 0 e-7) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45ProcessType-n--9844-8430-u--collectDDeps arg-2 e-10 arg-3 arg-1 arg-0 e-7) clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((TTImpC-45ProcessType-n--9844-8433-u--collectSpec arg-2 e-10 arg-3 arg-1 arg-0 '() e-9 e-8 e-7) clam-1))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-29 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-3 (let ((e-0 (vector-ref e-1 0))) (let ((e-29 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-27 (vector-ref e-1 6))) (let ((e-26 (vector-ref e-1 7))) (let ((e-25 (vector-ref e-1 8))) (let ((e-24 (vector-ref e-1 9))) (let ((e-23 (vector-ref e-1 10))) (let ((e-22 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-29 e-2 e-3 e-4 e-11 e-27 e-26 e-25 e-24 e-23 e-22 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) clam-1))))))))))))))))))))))))))))))))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-0 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Adding local hint " (CoreC-45Name-u--show_Show_Name e-5))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Context-addLocalHint arg-0 arg-3 eta-0))))))(else (cond ((equal? arg-2 1) (lambda (clam-1) (case (vector-ref arg-4 0) ((3) (let ((e-12 (vector-ref arg-4 1))) (CoreC-45Context-addGlobalHint arg-0 arg-3 e-12 clam-1)))(else (case (vector-ref arg-4 0) ((3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "%globalhint is not valid in local definitions") clam-1)) ((4) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-1)) ((5) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-1)) ((6) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 1 ) clam-1)) ((7) (let ((e-7 (vector-ref arg-4 1))) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 4 e-7) clam-1))) ((8) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 6 ) clam-1)) (else (let ((e-10 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-1) (let ((e-1 (unbox e-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2)) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ProcessType-n--9844-8434-u--getNamePos arg-2 e-10 arg-3 arg-1 arg-0 0 e-7) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45ProcessType-n--9844-8430-u--collectDDeps arg-2 e-10 arg-3 arg-1 arg-0 e-7) clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((TTImpC-45ProcessType-n--9844-8433-u--collectSpec arg-2 e-10 arg-3 arg-1 arg-0 '() e-9 e-8 e-7) clam-1))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-29 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-3 (let ((e-0 (vector-ref e-1 0))) (let ((e-29 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-27 (vector-ref e-1 6))) (let ((e-26 (vector-ref e-1 7))) (let ((e-25 (vector-ref e-1 8))) (let ((e-24 (vector-ref e-1 9))) (let ((e-23 (vector-ref e-1 10))) (let ((e-22 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-29 e-2 e-3 e-4 e-11 e-27 e-26 e-25 e-24 e-23 e-22 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) clam-1))))))))))))))))))))))))))))))))))(else (lambda (clam-3) (case (vector-ref arg-4 0) ((3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "%globalhint is not valid in local definitions") clam-3)) ((4) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-3)) ((5) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-3)) ((6) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 1 ) clam-3)) ((7) (let ((e-7 (vector-ref arg-4 1))) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 4 e-7) clam-3))) ((8) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 6 ) clam-3)) (else (let ((e-10 (vector-ref arg-4 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-3) (let ((e-1 (unbox e-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2)) clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ProcessType-n--9844-8434-u--getNamePos arg-2 e-10 arg-3 arg-1 arg-0 0 e-7) clam-3))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45ProcessType-n--9844-8430-u--collectDDeps arg-2 e-10 arg-3 arg-1 arg-0 e-7) clam-3))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((TTImpC-45ProcessType-n--9844-8433-u--collectSpec arg-2 e-10 arg-3 arg-1 arg-0 '() e-9 e-8 e-7) clam-3))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-29 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-3 (let ((e-0 (vector-ref e-1 0))) (let ((e-29 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-27 (vector-ref e-1 6))) (let ((e-26 (vector-ref e-1 7))) (let ((e-25 (vector-ref e-1 8))) (let ((e-24 (vector-ref e-1 9))) (let ((e-23 (vector-ref e-1 10))) (let ((e-22 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-29 e-2 e-3 e-4 e-11 e-27 e-26 e-25 e-24 e-23 e-22 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) clam-3)))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessType-initDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (let ((act-24 (CoreC-45Context-addUserHole arg-1 0 arg-5 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-2 0) ((4) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-getArity arg-1 arg-0 e-5 arg-6 arg-7 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-6)))))))))))) ((5) (let ((e-6 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-getArity arg-1 arg-0 e-5 arg-6 arg-7 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45ProcessType-getFnString arg-1 arg-2 arg-3 arg-4 eta-1)) e-6 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (vector 3 e-7 e-8)))))))))))))))))(else (TTImpC-45ProcessType-initDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3))))))))
(define TTImpC-45ProcessType-getRetTy (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (((e-4 arg-0) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ProcessType-getRetTy arg-0 e-5) clam-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-1) "Can only add hints for concrete return types") clam-0))))))) ((3) (let ((e-7 (vector-ref arg-1 2))) (vector 1 e-7)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-1) "Can only add hints for concrete return types") clam-0))))))
(define TTImpC-45ProcessType-getFnString (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((28) (let ((e-2 (vector-ref arg-4 2))) (case (vector-ref e-2 0) ((10) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (let ((act-24 (CoreC-45Context-resolveName arg-0 (vector 1 (vector 0 "[foreign]")) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fc (TTImpC-45TTImp-getFC arg-4))) (let ((u--gstr (CoreC-45NormaliseC-45Eval-gnf '() '() (vector 9 u--fc (vector 24 ))))) (let ((act-25 (TTImpC-45Elab-checkTerm '() arg-0 arg-1 arg-2 arg-3 e-5 (vector 2 ) '() '() '() arg-4 u--gstr clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-7 '() e-6) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((8) (let ((e-3 (vector-ref e-8 2))) (case (vector-ref e-3 0) ((10) (let ((e-9 (vector-ref e-3 1))) (vector 1 e-9)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 u--fc "%foreign calling convention must evaluate to a String") clam-0)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 u--fc "%foreign calling convention must evaluate to a String") clam-0)))))))))))))))))))))))))(else (let ((act-24 (CoreC-45Context-resolveName arg-0 (vector 1 (vector 0 "[foreign]")) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fc (TTImpC-45TTImp-getFC arg-4))) (let ((u--gstr (CoreC-45NormaliseC-45Eval-gnf '() '() (vector 9 u--fc (vector 24 ))))) (let ((act-25 (TTImpC-45Elab-checkTerm '() arg-0 arg-1 arg-2 arg-3 e-5 (vector 2 ) '() '() '() arg-4 u--gstr clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-7 '() e-6) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((8) (let ((e-2 (vector-ref e-8 2))) (case (vector-ref e-2 0) ((10) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 u--fc "%foreign calling convention must evaluate to a String") clam-0)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 u--fc "%foreign calling convention must evaluate to a String") clam-0))))))))))))))))))))))))))
(define TTImpC-45ProcessType-findInferrable (lambda (arg-0 arg-1 arg-2) (TTImpC-45ProcessType-n--11492-9765-u--fi arg-2 arg-1 arg-0 0 0 '() '() arg-2)))
(define TTImpC-45Elab-case--doPLetRenames-8419 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (vector 3 arg-4 arg-1 arg-3 (TTImpC-45Elab-doPLetRenames (cons arg-1 arg-0) arg-6 arg-5 arg-2)) (let ((e-1 (unbox arg-7))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (vector 3 arg-4 e-6 (CoreC-45TT-setMultiplicity arg-3 (AlgebraC-45Preorder-lub (csegen-1892) e-5 (CoreC-45TT-multiplicity arg-3))) (TTImpC-45Elab-doPLetRenames (cons e-6 arg-0) arg-6 (cons e-6 arg-5) (CoreC-45TT-renameTop e-6 arg-2)))))))))
(define TTImpC-45Elab-case--findPLetRenames-8250 (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((2) (cons (cons arg-12 (cons arg-8 arg-9)) (TTImpC-45Elab-findPLetRenames (cons arg-9 arg-0) arg-10)))(else (TTImpC-45Elab-findPLetRenames (cons arg-9 arg-0) arg-10)))))
(define TTImpC-45Elab-n--10988-8507-u--updateType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (CoreC-45Normalise-tryNormaliseSizeLimit arg-1 '() arg-2 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) '() (let ((e-2 (vector-ref arg-4 2))) e-2) eta-0)) (lambda (u--err) (lambda (eta-0) (CoreC-45Normalise-normaliseHoles arg-1 '() arg-2 '() (let ((e-2 (vector-ref arg-4 2))) e-2) eta-0))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-1 (vector 8 arg-3) (let ((e-0 (vector-ref arg-4 0))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((e-22 (vector-ref arg-4 5))) (let ((e-6 (vector-ref arg-4 6))) (let ((e-7 (vector-ref arg-4 7))) (let ((e-8 (vector-ref arg-4 8))) (let ((e-9 (vector-ref arg-4 9))) (let ((e-10 (vector-ref arg-4 10))) (let ((e-11 (vector-ref arg-4 11))) (let ((e-12 (vector-ref arg-4 12))) (let ((e-13 (vector-ref arg-4 13))) (let ((e-14 (vector-ref arg-4 14))) (let ((e-15 (vector-ref arg-4 15))) (let ((e-16 (vector-ref arg-4 16))) (let ((e-17 (vector-ref arg-4 17))) (let ((e-18 (vector-ref arg-4 18))) (let ((e-19 (vector-ref arg-4 19))) (let ((e-20 (vector-ref arg-4 20))) (let ((e-21 (vector-ref arg-4 21))) (vector e-0 e-1 e-5 e-3 e-4 e-22 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) ext-0)))))))
(define TTImpC-45Elab-n--10988-8508-u--normaliseH (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-3) (let ((e-0 (vector-ref arg-2 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((7) (TTImpC-45Elab-n--10988-8507-u--updateType arg-0 arg-1 arg-2 arg-3 e-1 ext-0))(else (vector 1 0))))))))))))
(define TTImpC-45Elab-n--13073-10286-u--bindImpsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (lambda (clam-0) (if (null? arg-18) (vector 1 arg-19) (let ((e-2 (car arg-18))) (let ((e-3 (cdr arg-18))) (let ((e-6 (car e-2))) (let ((act-24 ((TTImpC-45Elab-n--13073-10286-u--bindImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-3 arg-19) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 arg-16 (csegen-21) (vector 0 ) (box e-6) (vector 32 arg-16 1) e-5)))))))))))))
(define TTImpC-45Elab-n--13073-10287-u--bindImps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-19 0) ((16) (let ((e-1 (vector-ref arg-19 1))) (let ((e-2 (vector-ref arg-19 2))) (let ((e-3 (vector-ref arg-19 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45Elab-n--13073-10286-u--bindImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 16 e-1 e-2 e-5)))))))))))(else (TTImpC-45Elab-n--13073-10286-u--bindImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19)))))
(define TTImpC-45Elab-n--11195-8717-u--addHoles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (if (null? arg-17) arg-15 (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (LibrariesC-45DataC-45IntMap-lookup e-6 arg-16))) (if (null? sc2) (TTImpC-45Elab-n--11195-8717-u--addHoles arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-3) (TTImpC-45Elab-n--11195-8717-u--addHoles arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (LibrariesC-45DataC-45IntMap-insert e-6 e-7 arg-15) arg-16 e-3))))))))))
(define TTImpC-45Elab-normaliseHoleTypes (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--hs (LibrariesC-45DataC-45IntMap-keys (let ((e-0 (vector-ref e-5 0))) e-0)))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45Elab-n--10988-8508-u--normaliseH arg-1 arg-0 e-6 eta-0 eta-1))) u--hs ext-0))))))))))))
(define TTImpC-45Elab-getRigNeeded (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (csegen-21)) ((1) (let ((e-0 (vector-ref arg-0 1))) (let ((sc1 (AlgebraC-45Semiring-isErased (csegen-475) e-0))) (cond ((equal? sc1 1) (csegen-21)) (else (csegen-519))))))(else (csegen-519)))))
(define TTImpC-45Elab-findPLetRenames (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((4) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref e-8 0) ((0) (let ((e-12 (vector-ref e-8 1))) (let ((e-13 (vector-ref e-8 2))) (let ((e-14 (vector-ref e-8 3))) (TTImpC-45Elab-case--findPLetRenames-8250 arg-0 e-6 e-12 e-13 e-14 e-9 e-7 e-2 e-4 e-1 (CoreC-45TT-nameAt arg-0 e-14))))))(else (TTImpC-45Elab-findPLetRenames (cons e-2 arg-0) e-4))))))))(else (TTImpC-45Elab-findPLetRenames (cons e-2 arg-0) e-4))))))))(else '()))))
(define TTImpC-45Elab-elabTermSub (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((u--incase (PreludeC-45Types-elem (csegen-1886) 1 arg-8))) (let ((u--inPE (PreludeC-45Types-elem (csegen-1886) 2 arg-8))) (let ((u--inTrans (PreludeC-45Types-elem (csegen-1886) 3 arg-8))) (lambda (eta-0) (let ((act-24 (cond ((equal? u--incase 1) (vector 1 (LibrariesC-45DataC-45IntMap-empty))) (else (CoreC-45UnifyState-saveHoles arg-4 eta-0))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-4))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--olddelayed (let ((e-10 (vector-ref e-6 10))) e-10))) (let ((act-26 (let ((act-26 (set-box! arg-4 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-13 (vector-ref e-6 5))) (let ((e-12 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-11 (vector-ref e-6 11))) (vector e-0 e-1 e-2 e-3 e-4 e-13 e-12 e-7 e-8 e-9 '() e-11))))))))))))))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-getNextEntry arg-2 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (unbox arg-2))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45Core-newRef (vector "TTImp.Elab.Check.EST" ) (TTImpC-45ElabC-45Check-initEStateSub arg-0 arg-6 arg-11 arg-12) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--rigc (TTImpC-45Elab-getRigNeeded arg-7))) (let ((act-30 ((TTImpC-45ElabC-45Check-check arg-1 arg-2 arg-3 arg-4 e-10 arg-5 u--rigc (TTImpC-45ElabC-45Check-initElabInfo arg-7) arg-9 arg-10 arg-13 arg-14) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((e-2 (car e-11))) (let ((e-3 (cdr e-11))) (let ((u--solvemode (case (vector-ref arg-7 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm))))) (let ((act-31 (CoreC-45Unify-solveConstraints arg-2 arg-4 u--solvemode 0 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (CoreC-45ContextC-45Log-logTerm arg-1 arg-2 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Looking for delayed in ") e-2 eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 (let ((act-33 (unbox arg-4))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (TTImpC-45ElabC-45Delayed-retryDelayed arg-1 arg-2 arg-3 arg-4 e-10 u--solvemode (DataC-45List-sortBy (lambda (u--x) (lambda (u--y) (CoreC-45UnifyState-u--compare_Ord_DelayReason (Builtin-fst u--x) (Builtin-fst u--y)))) (let ((e-16 (vector-ref e-14 10))) e-16)) eta-1)) (lambda (u--err) (lambda (eta-1) (let ((act-34 (let ((act-34 (unbox arg-4))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-34 1))) (let ((act-35 (let ((act-35 (set-box! arg-4 (let ((e-0 (vector-ref e-15 0))) (let ((e-1 (vector-ref e-15 1))) (let ((e-24 (vector-ref e-15 2))) (let ((e-23 (vector-ref e-15 3))) (let ((e-4 (vector-ref e-15 4))) (let ((e-22 (vector-ref e-15 5))) (let ((e-21 (vector-ref e-15 6))) (let ((e-20 (vector-ref e-15 7))) (let ((e-19 (vector-ref e-15 8))) (let ((e-18 (vector-ref e-15 9))) (let ((e-16 (vector-ref e-15 11))) (vector e-0 e-1 e-24 e-23 e-4 e-22 e-21 e-20 e-19 e-18 u--olddelayed e-16))))))))))))))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-1)))))))))) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((act-35 (let ((act-35 (unbox arg-4))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-35 1))) (let ((act-36 (let ((act-36 (set-box! arg-4 (let ((e-0 (vector-ref e-16 0))) (let ((e-1 (vector-ref e-16 1))) (let ((e-25 (vector-ref e-16 2))) (let ((e-24 (vector-ref e-16 3))) (let ((e-4 (vector-ref e-16 4))) (let ((e-23 (vector-ref e-16 5))) (let ((e-22 (vector-ref e-16 6))) (let ((e-21 (vector-ref e-16 7))) (let ((e-20 (vector-ref e-16 8))) (let ((e-19 (vector-ref e-16 9))) (let ((e-17 (vector-ref e-16 11))) (vector e-0 e-1 e-25 e-24 e-4 e-23 e-22 e-21 e-20 e-19 u--olddelayed e-17))))))))))))))) (vector 1 act-36)))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((act-37 (CoreC-45Unify-solveConstraintsAfter arg-2 arg-4 e-8 u--solvemode 2 eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (let ((act-38 (let ((sc15 (cond ((equal? u--incase 1) (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-7))) (else 1)))) (cond ((equal? sc15 1) (let ((act-38 (CoreC-45ContextC-45Log-log arg-2 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Resolving default hints") eta-0))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((act-39 (CoreC-45Unify-solveConstraintsAfter arg-2 arg-4 e-8 u--solvemode 1 eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (CoreC-45Unify-solveConstraintsAfter arg-2 arg-4 e-8 u--solvemode 3 eta-0)))))))) (else (vector 1 0)))))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((act-39 (CoreC-45UnifyState-dumpConstraints arg-4 arg-2 "elab" (+ 1 (+ 1 (+ 1 (+ 1 0)))) 0 eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (let ((act-40 (let ((act-40 (unbox arg-2))) (vector 1 act-40)))) (case (vector-ref act-40 0) ((0) (let ((e-4 (vector-ref act-40 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-40 1))) (let ((act-41 (cond ((equal? u--inPE 1) (CoreC-45Normalise-normaliseHoles arg-2 arg-1 e-21 arg-10 e-2 eta-0)) (else (CoreC-45Normalise-normaliseArgHoles arg-2 arg-1 e-21 arg-10 e-2 eta-0))))) (case (vector-ref act-41 0) ((0) (let ((e-4 (vector-ref act-41 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-41 1))) (let ((act-42 (case (vector-ref arg-7 0) ((1) (let ((act-42 (cond ((equal? u--incase 1) (vector 1 0)) (else (CoreC-45UnifyState-checkUserHolesAfter arg-4 arg-2 e-8 1 eta-0))))) (case (vector-ref act-42 0) ((0) (let ((e-4 (vector-ref act-42 1))) (vector 0 e-4))) (else (vector 1 e-22))))) ((3) (let ((act-42 (cond ((equal? u--incase 1) (vector 1 0)) (else (CoreC-45UnifyState-checkUserHolesAfter arg-4 arg-2 e-8 1 eta-0))))) (case (vector-ref act-42 0) ((0) (let ((e-4 (vector-ref act-42 1))) (vector 0 e-4))) (else (vector 1 e-22)))))(else (cond ((equal? u--incase 1) (vector 1 e-22)) (else (let ((act-42 (CoreC-45UnifyState-checkUserHolesAfter arg-4 arg-2 e-8 (cond ((equal? u--inTrans 1) 1) (else u--inPE)) eta-0))) (case (vector-ref act-42 0) ((0) (let ((e-4 (vector-ref act-42 1))) (vector 0 e-4))) (else (CoreC-45LinearCheck-linearCheck arg-1 arg-2 arg-4 (TTImpC-45TTImp-getFC arg-13) u--rigc 0 arg-10 e-22 eta-0)))))))))) (case (vector-ref act-42 0) ((0) (let ((e-4 (vector-ref act-42 1))) (vector 0 e-4))) (else (let ((e-23 (vector-ref act-42 1))) (let ((act-43 (TTImpC-45Elab-normaliseHoleTypes arg-2 arg-4 eta-0))) (case (vector-ref act-43 0) ((0) (let ((e-4 (vector-ref act-43 1))) (vector 0 e-4))) (else (let ((act-44 (cond ((equal? u--incase 1) (vector 1 0)) (else (let ((act-44 (CoreC-45UnifyState-getHoles arg-4 eta-0))) (case (vector-ref act-44 0) ((0) (let ((e-4 (vector-ref act-44 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-44 1))) (CoreC-45UnifyState-restoreHoles arg-4 (TTImpC-45Elab-n--11195-8717-u--addHoles arg-0 arg-1 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 (LibrariesC-45DataC-45IntMap-empty) e-25 (LibrariesC-45DataC-45IntMap-toList e-5)) eta-0))))))))) (case (vector-ref act-44 0) ((0) (let ((e-4 (vector-ref act-44 1))) (vector 0 e-4))) (else (let ((act-45 (let ((act-45 (unbox e-10))) (vector 1 act-45)))) (case (vector-ref act-45 0) ((0) (let ((e-4 (vector-ref act-45 1))) (vector 0 e-4))) (else (let ((e-26 (vector-ref act-45 1))) (let ((act-46 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (TTImpC-45Elab-addHoleToSave arg-2 eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys (let ((e-28 (vector-ref e-26 12))) e-28)) eta-0))) (case (vector-ref act-46 0) ((0) (let ((e-4 (vector-ref act-46 1))) (vector 0 e-4))) (else (case (vector-ref arg-7 0) ((1) (let ((u--vs (TTImpC-45Elab-findPLetRenames arg-1 e-23))) (let ((u--ret (TTImpC-45Elab-doPLetRenames arg-1 u--vs '() e-23))) (let ((act-47 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-0))) (case (vector-ref act-47 0) ((0) (let ((e-4 (vector-ref act-47 1))) (vector 0 e-4))) (else (let ((e-28 (vector-ref act-47 1))) (vector 1 (cons u--ret (CoreC-45NormaliseC-45Eval-gnf arg-1 arg-10 (TTImpC-45Elab-doPLetRenames arg-1 u--vs '() e-28)))))))))))(else (let ((act-47 (CoreC-45UnifyState-dumpConstraints arg-4 arg-2 "elab" (+ 1 (+ 1 0)) 0 eta-0))) (case (vector-ref act-47 0) ((0) (let ((e-4 (vector-ref act-47 1))) (vector 0 e-4))) (else (vector 1 (cons e-23 e-3))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45Elab-elabTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (TTImpC-45Elab-elabTermSub arg-0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-9 (vector 0 ) arg-10 arg-11)))
(define TTImpC-45Elab-doPLetRenames (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((4) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--b (vector 4 e-6 e-7 e-8 e-9))) (let ((sc2 (PreludeC-45Types-elem (csegen-802) e-2 arg-2))) (cond ((equal? sc2 1) (CoreC-45TTC-45SubstEnv-subst (vector 10 e-1 0) (TTImpC-45Elab-doPLetRenames (cons e-2 arg-0) arg-1 arg-2 e-4))) (else (vector 3 e-1 e-2 u--b (TTImpC-45Elab-doPLetRenames (cons e-2 arg-0) arg-1 arg-2 e-4)))))))))))(else (TTImpC-45Elab-case--doPLetRenames-8419 arg-0 e-2 e-4 e-3 e-1 arg-2 arg-1 (DataC-45List-lookup (csegen-802) e-2 arg-1)))))))))(else arg-3))))
(define TTImpC-45Elab-checkTermSub (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-24 (case (vector-ref arg-7 0) ((0) (CoreC-45Context-branch arg-2 ext-0))(else (let ((act-24 (unbox arg-2))) (vector 1 act-24)))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-4))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-3))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-u--catch_Catchable_Core_Error (TTImpC-45Elab-elabTermSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (box arg-14)) (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((27) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (let ((e-2 (vector-ref lcase-0 3))) (let ((e-3 (vector-ref lcase-0 4))) (let ((act-27 (let ((act-27 (set-box! arg-2 e-5))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (let ((act-28 (set-box! arg-4 e-6))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (let ((act-29 (set-box! arg-3 e-7))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 ((TTImpC-45Elab-n--13073-10287-u--bindImps arg-0 arg-1 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 e-0 e-1 e-2 e-3 arg-13) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) ((TTImpC-45Elab-elabTermSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-11 (box arg-14)) clam-0)))))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-0))))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (case (vector-ref arg-7 0) ((0) (CoreC-45Context-commit arg-2 ext-0))(else (vector 1 0))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (Builtin-fst e-8)))))))))))))))))))))))
(define TTImpC-45Elab-checkTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (TTImpC-45Elab-checkTermSub arg-0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-9 (vector 0 ) arg-10 arg-11 ext-0)))
(define TTImpC-45Elab-addHoleToSave (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((u--ms (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-1)))) (let ((act-26 (CoreC-45Context-addToSave arg-0 arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addToSave arg-0 eta-0 eta-1))) u--ms ext-0)))))))))))))))))
(define TTImpC-45ElabC-45Term-n--12396-18897-u--resolveNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (lambda (clam-0) (if (null? arg-15) (vector 1 (LibrariesC-45DataC-45UserNameMap-empty)) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((sc1 (CoreC-45Name-userNameRoot e-2))) (if (null? sc1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "non-UN in \"with\" LHS: " (CoreC-45Name-u--show_Show_Name e-2))) clam-0) (let ((e-4 (unbox sc1))) (let ((act-24 (let ((act-24 (unbox arg-13))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-13 arg-14 e-2 clam-0) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (if (null? e-7) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-9 (vector-ref eta-0 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45UserNameMap-insert e-4 e-8 e-9)))))) (TTImpC-45ElabC-45Term-n--12396-18897-u--resolveNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-3) clam-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-14 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0))))))))))))))))))))))
(define TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (case (vector-ref arg-7 0) ((2) (let ((e-17 (vector-ref arg-7 3))) (case (vector-ref e-17 0) ((0) (case (vector-ref arg-8 0) ((3) (let ((e-28 (vector-ref arg-8 3))) (case (vector-ref e-28 0) ((2) (let ((e-33 (vector-ref e-28 3))) (case (vector-ref e-33 0) ((0) (lambda (eta-0) (vector 1 (box arg-7))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-0) (let ((sc6 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc6 0) ((1) (let ((e-10 (vector-ref sc6 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc6 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-1) (let ((sc5 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-6 (vector-ref sc5 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-2) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-2 (vector-ref sc4 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-3) (let ((sc5 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-10 (vector-ref sc5 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-4) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-6 (vector-ref sc4 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-5) (let ((sc3 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-2 (vector-ref sc3 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-6) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-10 (vector-ref sc4 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-7) (let ((sc3 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-6 (vector-ref sc3 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-8) (let ((sc2 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))) ((2) (case (vector-ref arg-8 0) ((3) (let ((e-39 (vector-ref arg-8 3))) (case (vector-ref e-39 0) ((2) (let ((e-44 (vector-ref e-39 3))) (case (vector-ref e-44 0) ((2) (lambda (eta-0) (vector 1 (box arg-7))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-9) (let ((sc6 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc6 0) ((1) (let ((e-10 (vector-ref sc6 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc6 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-10) (let ((sc5 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-6 (vector-ref sc5 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-11) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-2 (vector-ref sc4 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-12) (let ((sc5 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-10 (vector-ref sc5 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-13) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-6 (vector-ref sc4 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-14) (let ((sc3 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-2 (vector-ref sc3 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-15) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-10 (vector-ref sc4 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-16) (let ((sc3 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-6 (vector-ref sc3 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-17) (let ((sc2 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))) ((3) (case (vector-ref arg-8 0) ((3) (let ((e-50 (vector-ref arg-8 3))) (case (vector-ref e-50 0) ((2) (let ((e-55 (vector-ref e-50 3))) (case (vector-ref e-55 0) ((3) (lambda (eta-0) (vector 1 (box arg-7))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-18) (let ((sc6 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc6 0) ((1) (let ((e-10 (vector-ref sc6 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc6 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-19) (let ((sc5 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-6 (vector-ref sc5 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-20) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-2 (vector-ref sc4 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-21) (let ((sc5 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-10 (vector-ref sc5 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-22) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-6 (vector-ref sc4 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-23) (let ((sc3 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-2 (vector-ref sc3 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-24) (let ((sc4 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-10 (vector-ref sc4 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-25) (let ((sc3 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-6 (vector-ref sc3 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-26) (let ((sc2 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-27) (let ((sc3 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-10 (vector-ref sc3 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-28) (let ((sc2 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-6 (vector-ref sc2 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-29) (let ((sc1 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc1 0) ((1) (let ((e-2 (vector-ref sc1 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc1 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11))))))))))))))) ((3) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))))))))))(else (lambda (clam-30) (let ((sc2 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-10 (vector-ref sc2 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-31) (let ((sc1 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc1 0) ((1) (let ((e-6 (vector-ref sc1 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc1 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-32) (let ((sc0 (CoreC-45TT-getFn arg-8))) (case (vector-ref sc0 0) ((1) (let ((e-2 (vector-ref sc0 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc0 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))
(define TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((2) (let ((e-17 (vector-ref arg-6 3))) (case (vector-ref e-17 0) ((0) (case (vector-ref arg-7 0) ((0) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref e-26 0) ((2) (let ((e-31 (vector-ref e-26 3))) (case (vector-ref e-31 0) ((0) (lambda (eta-0) (vector 1 arg-6)))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((3) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12)))))))))))))))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-1) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((3) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12)))))))))))))))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-2) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((3) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12)))))))))))))))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))) ((2) (case (vector-ref arg-7 0) ((0) (let ((e-37 (vector-ref arg-7 3))) (case (vector-ref e-37 0) ((2) (let ((e-42 (vector-ref e-37 3))) (case (vector-ref e-42 0) ((2) (lambda (eta-0) (vector 1 arg-6)))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-3) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-3))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-3))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((3) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-3))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12)))))))))))))))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-4) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-4))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-4))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((3) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-4))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12)))))))))))))))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-5) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((3) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12)))))))))))))))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6)))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-6) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((3) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12)))))))))))))))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-7) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((2) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))))))))))))))))) ((3) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-1 (vector 0 ) e-10))) clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12)))))))))))))))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))
(define TTImpC-45ElabC-45Term-n--11480-17210-u--bindLam (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm arg-7) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--11480-17208-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getNF arg-5 arg-7) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45ElabC-45Term-n--11480-17209-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7) ext-0))))) (let ((e-1 (unbox e-6))) (vector 1 e-1)))))))))))))
(define TTImpC-45ElabC-45Term-onLHS (lambda (arg-0) (case (vector-ref arg-0 0) ((1) 1)(else 0))))
(define TTImpC-45ElabC-45Term-insertImpLam (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-1 (unbox arg-5))) (TTImpC-45ElabC-45Term-n--11480-17210-u--bindLam e-1 arg-4 arg-3 arg-2 arg-1 arg-4 e-1 clam-0))))))
(define TTImpC-45ElabC-45Term-checkTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 (vector 0 e-1 e-2) '() '() '() arg-11)))) ((1) (let ((e-4 (vector-ref arg-10 1))) (let ((e-5 (vector-ref arg-10 2))) (let ((e-6 (vector-ref arg-10 3))) (let ((e-7 (vector-ref arg-10 4))) (let ((e-8 (vector-ref arg-10 5))) (let ((e-9 (vector-ref arg-10 6))) (if (null? e-7) (lambda (eta-0) (let ((act-24 (case (vector-ref e-6 0) ((1) (CoreC-45UnifyState-genVarName arg-1 arg-3 "arg" eta-0)) ((0) (CoreC-45UnifyState-genVarName arg-1 arg-3 "impArg" eta-0)) ((2) (CoreC-45UnifyState-genVarName arg-1 arg-3 "conArg" eta-0)) (else (CoreC-45UnifyState-genVarName arg-1 arg-3 "defArg" eta-0))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Binders-checkPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-4 e-5 e-6 e-10 e-8 e-9 arg-11) eta-0)))))) (let ((e-138 (unbox e-7))) (case (vector-ref e-138 0) ((1) (let ((e-139 (vector-ref e-138 1))) (case (vector-ref e-139 0) ((2) (TTImpC-45ElabC-45Term-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 1 e-4 e-5 e-6 '() e-8 e-9) arg-11))(else (TTImpC-45ElabC-45Binders-checkPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-4 e-5 e-6 e-138 e-8 e-9 arg-11)))))(else (TTImpC-45ElabC-45Binders-checkPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-4 e-5 e-6 e-138 e-8 e-9 arg-11)))))))))))) ((2) (let ((e-11 (vector-ref arg-10 1))) (let ((e-12 (vector-ref arg-10 2))) (let ((e-13 (vector-ref arg-10 3))) (let ((e-14 (vector-ref arg-10 4))) (let ((e-15 (vector-ref arg-10 5))) (let ((e-16 (vector-ref arg-10 6))) (if (null? e-14) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genVarName arg-1 arg-3 "_" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Binders-checkLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-11 e-12 e-13 e-5 e-15 e-16 arg-11) eta-0)))))) (let ((e-141 (unbox e-14))) (TTImpC-45ElabC-45Binders-checkLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-11 e-12 e-13 e-141 e-15 e-16 arg-11)))))))))) ((3) (let ((e-18 (vector-ref arg-10 1))) (let ((e-19 (vector-ref arg-10 2))) (let ((e-20 (vector-ref arg-10 3))) (let ((e-21 (vector-ref arg-10 4))) (let ((e-22 (vector-ref arg-10 5))) (let ((e-23 (vector-ref arg-10 6))) (let ((e-24 (vector-ref arg-10 7))) (TTImpC-45ElabC-45Binders-checkLet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-18 e-19 e-20 e-21 e-22 e-23 e-24 arg-11))))))))) ((4) (let ((e-26 (vector-ref arg-10 1))) (let ((e-27 (vector-ref arg-10 2))) (let ((e-28 (vector-ref arg-10 3))) (let ((e-29 (vector-ref arg-10 4))) (lambda (eta-0) (TTImpC-45ElabC-45Case-checkCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-26 e-27 e-28 e-29 arg-11 eta-0))))))) ((5) (let ((e-31 (vector-ref arg-10 1))) (let ((e-32 (vector-ref arg-10 2))) (let ((e-33 (vector-ref arg-10 3))) (lambda (eta-0) (TTImpC-45ElabC-45Local-checkLocal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-31 e-32 e-33 arg-11 eta-0)))))) ((6) (let ((e-35 (vector-ref arg-10 1))) (let ((e-36 (vector-ref arg-10 2))) (let ((e-37 (vector-ref arg-10 3))) (let ((e-38 (vector-ref arg-10 4))) (let ((e-39 (vector-ref arg-10 5))) (lambda (eta-0) (TTImpC-45ElabC-45Local-checkCaseLocal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-35 e-36 e-37 e-38 e-39 arg-11 eta-0)))))))) ((7) (let ((e-41 (vector-ref arg-10 1))) (let ((e-42 (vector-ref arg-10 2))) (let ((e-43 (vector-ref arg-10 3))) (lambda (eta-0) (TTImpC-45ElabC-45Record-checkUpdate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-41 e-42 e-43 arg-11 eta-0)))))) ((8) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((e-47 (vector-ref arg-10 3))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-45 e-46 (cons e-47 '()) '() '() arg-11))))) ((9) (let ((e-49 (vector-ref arg-10 1))) (let ((e-50 (vector-ref arg-10 2))) (let ((e-51 (vector-ref arg-10 3))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-49 e-50 '() (cons e-51 '()) '() arg-11))))) ((11) (let ((e-53 (vector-ref arg-10 1))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-53 "with application not implemented yet") eta-0)))) ((10) (let ((e-57 (vector-ref arg-10 1))) (let ((e-58 (vector-ref arg-10 2))) (let ((e-59 (vector-ref arg-10 3))) (let ((e-60 (vector-ref arg-10 4))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-57 e-58 '() '() (cons (cons e-59 e-60) '()) arg-11)))))) ((12) (let ((e-62 (vector-ref arg-10 1))) (let ((e-63 (vector-ref arg-10 2))) (lambda (clam-0) (if (null? arg-11) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genName arg-1 arg-3 "searchTy" clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 e-62 (csegen-21) arg-9 e-6 (vector 11 e-62) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-genName arg-1 arg-3 "search" clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-searchVar arg-0 arg-1 arg-3 e-62 arg-6 e-63 (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) arg-9 arg-8 e-8 e-7 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons e-9 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-7))))))))))))))))))))))) (let ((e-144 (unbox arg-11))) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genName arg-1 arg-3 "search" clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-144) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Check-searchVar arg-0 arg-1 arg-3 e-62 arg-6 e-63 (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) arg-9 arg-8 e-6 e-7 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons e-8 e-144)))))))))))))))))))))))) ((13) (let ((e-65 (vector-ref arg-10 1))) (let ((e-66 (vector-ref arg-10 2))) (let ((e-67 (vector-ref arg-10 3))) (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-checkAlternative arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-65 e-66 e-67 arg-11 eta-0)))))) ((14) (let ((e-69 (vector-ref arg-10 1))) (let ((e-70 (vector-ref arg-10 2))) (let ((e-71 (vector-ref arg-10 3))) (lambda (eta-0) (TTImpC-45ElabC-45Rewrite-checkRewrite arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-69 e-70 e-71 arg-11 eta-0)))))) ((15) (let ((e-74 (vector-ref arg-10 2))) (TTImpC-45ElabC-45Term-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-74 arg-11))) ((16) (let ((e-76 (vector-ref arg-10 1))) (let ((e-77 (vector-ref arg-10 2))) (let ((e-78 (vector-ref arg-10 3))) (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-checkBindHere arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-76 e-77 e-78 arg-11 eta-0)))))) ((17) (let ((e-80 (vector-ref arg-10 1))) (let ((e-81 (vector-ref arg-10 2))) (TTImpC-45ElabC-45ImplicitBind-checkBindVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-80 (vector 0 e-81) arg-11)))) ((18) (let ((e-83 (vector-ref arg-10 1))) (let ((e-84 (vector-ref arg-10 2))) (let ((e-85 (vector-ref arg-10 3))) (let ((e-86 (vector-ref arg-10 4))) (let ((e-87 (vector-ref arg-10 5))) (TTImpC-45ElabC-45As-checkAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-83 e-84 e-85 e-86 e-87 arg-11))))))) ((19) (let ((e-89 (vector-ref arg-10 1))) (let ((e-90 (vector-ref arg-10 2))) (let ((e-91 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Dot-checkDot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-89 e-90 e-91 arg-11))))) ((20) (let ((e-93 (vector-ref arg-10 1))) (let ((e-94 (vector-ref arg-10 2))) (let ((e-95 (vector-ref arg-10 3))) (lambda (eta-0) (TTImpC-45ElabC-45Lazy-checkDelayed arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-93 e-94 e-95 arg-11 eta-0)))))) ((21) (let ((e-97 (vector-ref arg-10 1))) (let ((e-98 (vector-ref arg-10 2))) (lambda (eta-0) (TTImpC-45ElabC-45Lazy-checkDelay arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-97 e-98 arg-11 eta-0))))) ((22) (let ((e-100 (vector-ref arg-10 1))) (let ((e-101 (vector-ref arg-10 2))) (lambda (eta-0) (TTImpC-45ElabC-45Lazy-checkForce arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-100 e-101 arg-11 eta-0))))) ((23) (let ((e-103 (vector-ref arg-10 1))) (let ((e-104 (vector-ref arg-10 2))) (lambda (eta-0) (TTImpC-45ElabC-45Quote-checkQuote arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-103 e-104 arg-11 eta-0))))) ((24) (let ((e-106 (vector-ref arg-10 1))) (let ((e-107 (vector-ref arg-10 2))) (lambda (eta-0) (TTImpC-45ElabC-45Quote-checkQuoteName arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 e-106 e-107 arg-11 eta-0))))) ((25) (let ((e-109 (vector-ref arg-10 1))) (let ((e-110 (vector-ref arg-10 2))) (lambda (eta-0) (TTImpC-45ElabC-45Quote-checkQuoteDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-109 e-110 arg-11 eta-0))))) ((26) (let ((e-112 (vector-ref arg-10 1))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-112 "Can't escape outside a quoted term") eta-0)))) ((27) (let ((e-115 (vector-ref arg-10 1))) (let ((e-116 (vector-ref arg-10 2))) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-checkRunElab arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-115 e-116 arg-11 eta-0))))) ((28) (let ((e-118 (vector-ref arg-10 1))) (let ((e-119 (vector-ref arg-10 2))) (lambda (clam-1) (let ((sc1 (TTImpC-45ElabC-45Prim-checkPrim e-118 e-119))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 e-118 e-2 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-3) arg-11 clam-1)))))))) ((29) (let ((e-121 (vector-ref arg-10 1))) (lambda (eta-0) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 e-121 (vector 11 e-121) (CoreC-45NormaliseC-45Eval-gType e-121) arg-11 eta-0)))) ((30) (let ((e-123 (vector-ref arg-10 1))) (let ((e-124 (vector-ref arg-10 2))) (lambda (eta-0) (TTImpC-45ElabC-45Hole-checkHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 e-123 (vector 0 e-124) arg-11 eta-0))))) ((31) (let ((e-127 (vector-ref arg-10 2))) (let ((e-128 (vector-ref arg-10 3))) (lambda (eta-0) (CoreC-45Context-withLogLevel arg-1 e-127 (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-128 arg-11) eta-0))))) ((32) (let ((e-130 (vector-ref arg-10 1))) (let ((e-131 (vector-ref arg-10 2))) (lambda (clam-2) (if (null? arg-11) (let ((act-24 (CoreC-45UnifyState-genName arg-1 arg-3 "implicit_type" clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 e-130 (csegen-21) arg-9 e-5 (vector 11 e-130) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "_" clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 e-130 arg-6 arg-9 e-7 e-6 clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((sc6 (cond ((equal? e-131 1) (let ((e-3 (vector-ref arg-7 3))) e-3)) (else 0)))) (cond ((equal? sc6 1) (let ((act-28 (let ((act-28 (unbox arg-4))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-7 arg-6 (vector 1 ) arg-9 e-8 e-6 e-9)))) (vector 1 act-29))))))) (else (vector 1 0)))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (cons e-8 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-6)))))))))))))))))))))) (let ((e-147 (unbox arg-11))) (let ((act-24 (CoreC-45UnifyState-genName arg-1 arg-3 "_" clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm e-147) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 e-130 arg-6 arg-9 e-5 e-6 clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((sc6 (cond ((equal? e-131 1) (let ((e-3 (vector-ref arg-7 3))) e-3)) (else 0)))) (cond ((equal? sc6 1) (let ((act-28 (let ((act-28 (unbox arg-4))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((CoreC-45NormaliseC-45Eval-getTerm e-147) clam-2))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-5 arg-6 (vector 1 ) arg-9 e-8 e-10 e-9)))) (vector 1 act-30))))))))))) (else (vector 1 0)))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (cons e-8 e-147)))))))))))))))))))))))))) (else (let ((e-133 (vector-ref arg-10 1))) (let ((e-134 (vector-ref arg-10 2))) (let ((e-135 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Term-n--12396-18897-u--resolveNames arg-0 e-135 e-134 e-133 arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-133 e-134) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-4 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-16 (vector-ref e-5 4))) (let ((e-15 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (vector e-1 e-2 e-3 e-4 e-16 e-15 e-7 e-8 e-9 e-10 e-11 e-12 e-13 (LibrariesC-45DataC-45UserNameMap-mergeLeft e-6 (let ((e-17 (vector-ref e-5 13))) e-17))))))))))))))))))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-135 arg-11) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (unbox arg-4))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (set-box! arg-4 (let ((e-1 (vector-ref e-9 0))) (let ((e-2 (vector-ref e-9 1))) (let ((e-3 (vector-ref e-9 2))) (let ((e-4 (vector-ref e-9 3))) (let ((e-19 (vector-ref e-9 4))) (let ((e-18 (vector-ref e-9 5))) (let ((e-17 (vector-ref e-9 6))) (let ((e-16 (vector-ref e-9 7))) (let ((e-15 (vector-ref e-9 8))) (let ((e-10 (vector-ref e-9 9))) (let ((e-11 (vector-ref e-9 10))) (let ((e-12 (vector-ref e-9 11))) (let ((e-13 (vector-ref e-9 12))) (vector e-1 e-2 e-3 e-4 e-19 e-18 e-17 e-16 e-15 e-10 e-11 e-12 e-13 (let ((e-20 (vector-ref e-5 13))) e-20)))))))))))))))))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 e-8)))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Check-checkImp (lambda (ext-12 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 ext-0) (let ((act-24 ((TTImpC-45ElabC-45Term-checkTerm ext-12 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (let ((sc2 (TTImpC-45ElabC-45Term-onLHS (let ((e-0 (vector-ref ext-7 0))) e-0)))) (cond ((equal? sc2 1) (let ((sc3 (let ((e-2 (vector-ref ext-7 2))) e-2))) (cond ((equal? sc3 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc1 1) (((let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (if (null? ext-11) (lambda () (lambda (eta-0) (vector 1 0))) (let ((e-1 (unbox ext-11))) (lambda () (lambda (eta-0) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF ext-1 e-1) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getNF ext-1 e-3) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) ((CoreC-45UnifyState-addPolyConstraint ext-12 ext-3 (TTImpC-45TTImp-getFC ext-10) ext-9 e-2 e-6 e-7) eta-0)))))))))))))))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 e-5))))))))))
(define TTImpC-45ElabC-45Check-check (lambda (ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11) (lambda (clam-0) (case (vector-ref ext-10 0) ((15) (let ((e-2 (vector-ref ext-10 2))) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 e-2 ext-11 clam-0))) ((3) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 clam-0)) ((5) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 clam-0)) ((7) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 clam-0))(else (let ((act-24 (let ((act-24 (unbox ext-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox ext-4))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45ElabC-45Ambiguity-expandAmbigName ext-0 ext-1 ext-4 (let ((e-0 (vector-ref ext-7 0))) e-0) ext-8 ext-9 ext-10 '() ext-10 ext-11) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-0 (vector-ref ext-7 0))) (case (vector-ref e-0 0) ((1) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 e-7 ext-11 clam-0))(else (let ((act-27 ((TTImpC-45ElabC-45Term-insertImpLam ext-1 ext-3 ext-9 e-7 ext-11) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 e-9 ext-11 clam-0)))))))))))))))))))))))
(define TTImpC-45Reflect-u--reify_Reify_WithFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Syntactic") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (vector 1 0) (CoreC-45Reflect-cantReify u--val "WithFlag" ext-0))))(else (CoreC-45Reflect-cantReify u--val "WithFlag" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "WithFlag" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "WithFlag" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "WithFlag" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_UseSide (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "UseLeft") (vector 1 0)) ((equal? e-8 "UseRight") (vector 1 1))(else (CoreC-45Reflect-cantReify u--val "UseSide" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "UseSide" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "UseSide" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "UseSide" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_RawImp (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "IVar") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-13) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-14 (vector-ref act-26 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-14) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-14 (vector-ref act-26 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-26 1))) (vector 1 (vector 0 e-13 e-14)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IPi") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-14 (car sc5))) (let ((e-15 (cdr sc5))) (if (null? e-15) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-17 (car e-15))) (let ((e-18 (cdr e-15))) (if (null? e-18) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-20 (car e-18))) (let ((e-21 (cdr e-18))) (if (null? e-21) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-23 (car e-21))) (let ((e-24 (cdr e-21))) (if (null? e-24) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (if (null? e-27) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-14) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-17) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (csegen-1896) arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (csegen-1897) arg-0 arg-1 arg-2 e-12) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-16 (vector-ref act-30 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-30 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-16 ext-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-16 (vector-ref act-30 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-30 1))) (vector 1 (vector 1 e-9 e-10 e-11 e-12 e-13 e-16)))))))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))))))))))))))) ((equal? e-8 "ILam") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-33 (car sc5))) (let ((e-34 (cdr sc5))) (if (null? e-34) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-36 (car e-34))) (let ((e-37 (cdr e-34))) (if (null? e-37) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-39 (car e-37))) (let ((e-40 (cdr e-37))) (if (null? e-40) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-42 (car e-40))) (let ((e-43 (cdr e-40))) (if (null? e-43) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-45 (car e-43))) (let ((e-46 (cdr e-43))) (if (null? e-46) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-48 (car e-46))) (let ((e-49 (cdr e-46))) (if (null? e-49) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-33) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-39) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (csegen-1896) arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-42) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (csegen-1897) arg-0 arg-1 arg-2 e-12) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-45) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-48) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-30 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-14 ext-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-30 1))) (vector 1 (vector 2 e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))))))))))))))) ((equal? e-8 "ILet") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-52 (car sc5))) (let ((e-53 (cdr sc5))) (if (null? e-53) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-55 (car e-53))) (let ((e-56 (cdr e-53))) (if (null? e-56) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-58 (car e-56))) (let ((e-59 (cdr e-56))) (if (null? e-59) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-61 (car e-59))) (let ((e-62 (cdr e-59))) (if (null? e-62) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-64 (car e-62))) (let ((e-65 (cdr e-62))) (if (null? e-65) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-67 (car e-65))) (let ((e-68 (cdr e-65))) (if (null? e-68) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-70 (car e-68))) (let ((e-71 (cdr e-68))) (if (null? e-71) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-52) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-55) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-58) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-61) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-12) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-64) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-67) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-30 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-14 ext-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-70) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-15 (vector-ref act-31 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-31 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-15 ext-0))))))) (case (vector-ref act-31 0) ((0) (let ((e-15 (vector-ref act-31 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-31 1))) (vector 1 (vector 3 e-9 e-10 e-11 e-12 e-13 e-14 e-15)))))))))))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))))))))))))))) ((equal? e-8 "ICase") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-74 (car sc5))) (let ((e-75 (cdr sc5))) (if (null? e-75) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-77 (car e-75))) (let ((e-78 (cdr e-75))) (if (null? e-78) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-80 (car e-78))) (let ((e-81 (cdr e-78))) (if (null? e-81) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-83 (car e-81))) (let ((e-84 (cdr e-81))) (if (null? e-84) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-74) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-77) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-80) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-83) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1898) arg-0 arg-1 arg-2 e-12) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (vector 1 (vector 4 e-9 e-10 e-11 e-12)))))))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))))))))) ((equal? e-8 "ILocal") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-87 (car sc5))) (let ((e-88 (cdr sc5))) (if (null? e-88) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-90 (car e-88))) (let ((e-91 (cdr e-88))) (if (null? e-91) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-93 (car e-91))) (let ((e-94 (cdr e-91))) (if (null? e-94) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-87) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-90) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1899) arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-93) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 5 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "IUpdate") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-97 (car sc5))) (let ((e-98 (cdr sc5))) (if (null? e-98) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-100 (car e-98))) (let ((e-101 (cdr e-98))) (if (null? e-101) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-103 (car e-101))) (let ((e-104 (cdr e-101))) (if (null? e-104) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-97) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-100) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_IFieldUpdate u--c u--vars arg-9108 arg-9109 eta-0)))))) arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-103) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 7 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "IApp") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-107 (car sc5))) (let ((e-108 (cdr sc5))) (if (null? e-108) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-110 (car e-108))) (let ((e-111 (cdr e-108))) (if (null? e-111) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-113 (car e-111))) (let ((e-114 (cdr e-111))) (if (null? e-114) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-107) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-110) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-113) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 8 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "INamedApp") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-117 (car sc5))) (let ((e-118 (cdr sc5))) (if (null? e-118) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-120 (car e-118))) (let ((e-121 (cdr e-118))) (if (null? e-121) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-123 (car e-121))) (let ((e-124 (cdr e-121))) (if (null? e-124) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-126 (car e-124))) (let ((e-127 (cdr e-124))) (if (null? e-127) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-117) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-120) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-123) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-126) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-12 ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (vector 1 (vector 10 e-9 e-10 e-11 e-12)))))))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))))))))) ((equal? e-8 "IAutoApp") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-130 (car sc5))) (let ((e-131 (cdr sc5))) (if (null? e-131) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-133 (car e-131))) (let ((e-134 (cdr e-131))) (if (null? e-134) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-136 (car e-134))) (let ((e-137 (cdr e-134))) (if (null? e-137) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-130) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-133) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-136) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 9 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "IWithApp") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-140 (car sc5))) (let ((e-141 (cdr sc5))) (if (null? e-141) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-143 (car e-141))) (let ((e-144 (cdr e-141))) (if (null? e-144) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-146 (car e-144))) (let ((e-147 (cdr e-144))) (if (null? e-147) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-140) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-143) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-146) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 11 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "ISearch") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-150 (car sc5))) (let ((e-151 (cdr sc5))) (if (null? e-151) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-153 (car e-151))) (let ((e-154 (cdr e-151))) (if (null? e-154) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-150) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-153) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Nat arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 12 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IAlternative") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-157 (car sc5))) (let ((e-158 (cdr sc5))) (if (null? e-158) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-160 (car e-158))) (let ((e-161 (cdr e-158))) (if (null? e-161) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-163 (car e-161))) (let ((e-164 (cdr e-161))) (if (null? e-164) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-157) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-160) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_AltType arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-163) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1896) arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 13 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "IRewrite") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-167 (car sc5))) (let ((e-168 (cdr sc5))) (if (null? e-168) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-170 (car e-168))) (let ((e-171 (cdr e-168))) (if (null? e-171) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-173 (car e-171))) (let ((e-174 (cdr e-171))) (if (null? e-174) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-167) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-170) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-173) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 14 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "IBindHere") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-177 (car sc5))) (let ((e-178 (cdr sc5))) (if (null? e-178) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-180 (car e-178))) (let ((e-181 (cdr e-178))) (if (null? e-181) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-183 (car e-181))) (let ((e-184 (cdr e-181))) (if (null? e-184) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-177) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-180) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_BindMode arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-183) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 16 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "IBindVar") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-187 (car sc5))) (let ((e-188 (cdr sc5))) (if (null? e-188) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-190 (car e-188))) (let ((e-191 (cdr e-188))) (if (null? e-191) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-187) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-190) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 17 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IAs") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-194 (car sc5))) (let ((e-195 (cdr sc5))) (if (null? e-195) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-197 (car e-195))) (let ((e-198 (cdr e-195))) (if (null? e-198) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-200 (car e-198))) (let ((e-201 (cdr e-198))) (if (null? e-201) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-203 (car e-201))) (let ((e-204 (cdr e-201))) (if (null? e-204) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-206 (car e-204))) (let ((e-207 (cdr e-204))) (if (null? e-207) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-194) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-197) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-200) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_UseSide arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-203) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-12) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-206) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (vector 1 (vector 18 e-9 e-10 e-11 e-12 e-13)))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))))))))) ((equal? e-8 "IMustUnify") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-210 (car sc5))) (let ((e-211 (cdr sc5))) (if (null? e-211) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-213 (car e-211))) (let ((e-214 (cdr e-211))) (if (null? e-214) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-216 (car e-214))) (let ((e-217 (cdr e-214))) (if (null? e-217) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-210) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-213) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_DotReason arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-216) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 19 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "IDelayed") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-220 (car sc5))) (let ((e-221 (cdr sc5))) (if (null? e-221) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-223 (car e-221))) (let ((e-224 (cdr e-221))) (if (null? e-224) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-226 (car e-224))) (let ((e-227 (cdr e-224))) (if (null? e-227) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-220) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-223) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_LazyReason arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-226) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 20 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))))))))) ((equal? e-8 "IDelay") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-230 (car sc5))) (let ((e-231 (cdr sc5))) (if (null? e-231) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-233 (car e-231))) (let ((e-234 (cdr e-231))) (if (null? e-234) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-230) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-233) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 21 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IForce") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-237 (car sc5))) (let ((e-238 (cdr sc5))) (if (null? e-238) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-240 (car e-238))) (let ((e-241 (cdr e-238))) (if (null? e-241) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-237) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-240) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 22 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IQuote") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-244 (car sc5))) (let ((e-245 (cdr sc5))) (if (null? e-245) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-247 (car e-245))) (let ((e-248 (cdr e-245))) (if (null? e-248) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-244) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-247) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 23 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IQuoteName") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-251 (car sc5))) (let ((e-252 (cdr sc5))) (if (null? e-252) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-254 (car e-252))) (let ((e-255 (cdr e-252))) (if (null? e-255) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-251) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-254) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 24 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IQuoteDecl") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-258 (car sc5))) (let ((e-259 (cdr sc5))) (if (null? e-259) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-261 (car e-259))) (let ((e-262 (cdr e-259))) (if (null? e-262) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-258) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-261) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1899) arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 25 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IUnquote") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-265 (car sc5))) (let ((e-266 (cdr sc5))) (if (null? e-266) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-268 (car e-266))) (let ((e-269 (cdr e-266))) (if (null? e-269) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-265) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-268) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 26 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IPrimVal") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-272 (car sc5))) (let ((e-273 (cdr sc5))) (if (null? e-273) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-275 (car e-273))) (let ((e-276 (cdr e-273))) (if (null? e-276) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-272) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-275) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Constant arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 28 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IType") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-279 (car sc5))) (let ((e-280 (cdr sc5))) (if (null? e-280) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-279) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 29 e-9)))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0))))))) ((equal? e-8 "IHole") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-283 (car sc5))) (let ((e-284 (cdr sc5))) (if (null? e-284) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-286 (car e-284))) (let ((e-287 (cdr e-284))) (if (null? e-287) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-283) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-286) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 30 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "Implicit") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-290 (car sc5))) (let ((e-291 (cdr sc5))) (if (null? e-291) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-293 (car e-291))) (let ((e-294 (cdr e-291))) (if (null? e-294) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-290) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-293) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Bool arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 32 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))) ((equal? e-8 "IWithUnambigNames") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-297 (car sc5))) (let ((e-298 (cdr sc5))) (if (null? e-298) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-300 (car e-298))) (let ((e-301 (cdr e-298))) (if (null? e-301) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0) (let ((e-303 (car e-301))) (let ((e-304 (cdr e-301))) (if (null? e-304) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-297) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-300) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1897) arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-303) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 33 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))))))(else (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "TTImp" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "TTImp" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_ImpTy (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkTy") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "ITy" ext-0) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "ITy" ext-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (CoreC-45Reflect-cantReify u--val "ITy" ext-0) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (CoreC-45Reflect-cantReify u--val "ITy" ext-0) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-18) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-19 (vector-ref act-27 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-19) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-19 (vector-ref act-27 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-20 (vector-ref act-28 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-28 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-20 ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-20 (vector-ref act-28 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-28 1))) (vector 1 (vector e-15 e-18 e-19 e-20)))))))))))))))))) (CoreC-45Reflect-cantReify u--val "ITy" ext-0))))))))))))))))(else (CoreC-45Reflect-cantReify u--val "ITy" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "ITy" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "ITy" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "ITy" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_ImpRecord (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkRecord") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Record" ext-0) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "Record" ext-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (CoreC-45Reflect-cantReify u--val "Record" ext-0) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (CoreC-45Reflect-cantReify u--val "Record" ext-0) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (CoreC-45Reflect-cantReify u--val "Record" ext-0) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (if (null? e-20) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-18) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-21 (vector-ref act-27 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1901) arg-0 arg-1 arg-2 e-21) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-21 (vector-ref act-27 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-22 (vector-ref act-28 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-22) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-22 (vector-ref act-28 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-23 (vector-ref act-29 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-29 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_IField u--c u--vars arg-9108 arg-9109 eta-0)))))) arg-0 arg-1 arg-2 e-23) ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-23 (vector-ref act-29 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-29 1))) (vector 1 (vector e-15 e-18 e-21 e-22 e-23)))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "Record" ext-0)))))))))))))))))))(else (CoreC-45Reflect-cantReify u--val "Record" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "Record" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "Record" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Record" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_ImpDecl (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "IClaim") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (if (null? e-20) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-18) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-21 (vector-ref act-27 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_Visibility arg-0 arg-1 arg-2 e-21) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-21 (vector-ref act-27 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-22 (vector-ref act-28 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_FnOpt u--c u--vars arg-9108 arg-9109 eta-0)))))) arg-0 arg-1 arg-2 e-22) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-22 (vector-ref act-28 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-23 (vector-ref act-29 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-29 1))) (TTImpC-45Reflect-u--reify_Reify_ImpTy arg-0 arg-1 arg-2 e-23 ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-23 (vector-ref act-29 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-29 1))) (vector 1 (vector 0 e-15 e-18 e-21 e-22 e-23)))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "Decl" ext-0))))))))))))))))))) ((equal? e-8 "IData") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-23 (car sc5))) (let ((e-24 (cdr sc5))) (if (null? e-24) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (if (null? e-27) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Visibility arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_ImpData arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 1 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "Decl" ext-0))))))))))))) ((equal? e-8 "IDef") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-33 (car sc5))) (let ((e-34 (cdr sc5))) (if (null? e-34) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-36 (car e-34))) (let ((e-37 (cdr e-34))) (if (null? e-37) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-39 (car e-37))) (let ((e-40 (cdr e-37))) (if (null? e-40) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-33) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-39) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1898) arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 2 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "Decl" ext-0))))))))))))) ((equal? e-8 "IParameters") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-43 (car sc5))) (let ((e-44 (cdr sc5))) (if (null? e-44) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-46 (car e-44))) (let ((e-47 (cdr e-44))) (if (null? e-47) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-49 (car e-47))) (let ((e-50 (cdr e-47))) (if (null? e-50) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-43) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-46) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1901) arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-49) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1899) arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 3 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "Decl" ext-0))))))))))))) ((equal? e-8 "IRecord") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-53 (car sc5))) (let ((e-54 (cdr sc5))) (if (null? e-54) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-56 (car e-54))) (let ((e-57 (cdr e-54))) (if (null? e-57) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-59 (car e-57))) (let ((e-60 (cdr e-57))) (if (null? e-60) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-62 (car e-60))) (let ((e-63 (cdr e-60))) (if (null? e-63) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-53) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-56) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (csegen-1911) arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-59) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_Visibility arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-62) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (TTImpC-45Reflect-u--reify_Reify_ImpRecord arg-0 arg-1 arg-2 e-12 ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (vector 1 (vector 4 e-9 e-10 e-11 e-12)))))))))))))))))) (CoreC-45Reflect-cantReify u--val "Decl" ext-0)))))))))))))))) ((equal? e-8 "INamespace") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-66 (car sc5))) (let ((e-67 (cdr sc5))) (if (null? e-67) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-69 (car e-67))) (let ((e-70 (cdr e-67))) (if (null? e-70) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-72 (car e-70))) (let ((e-73 (cdr e-70))) (if (null? e-73) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-66) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-69) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Namespace arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-72) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1899) arg-0 arg-1 arg-2 e-11) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 5 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "Decl" ext-0))))))))))))) ((equal? e-8 "ITransform") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-76 (car sc5))) (let ((e-77 (cdr sc5))) (if (null? e-77) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-79 (car e-77))) (let ((e-80 (cdr e-77))) (if (null? e-80) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-82 (car e-80))) (let ((e-83 (cdr e-80))) (if (null? e-83) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-85 (car e-83))) (let ((e-86 (cdr e-83))) (if (null? e-86) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-76) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-79) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-82) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-85) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-12 ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (vector 1 (vector 6 e-9 e-10 e-11 e-12)))))))))))))))))) (CoreC-45Reflect-cantReify u--val "Decl" ext-0)))))))))))))))) ((equal? e-8 "ILog") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Decl" ext-0) (let ((e-89 (car sc5))) (let ((e-90 (cdr sc5))) (if (null? e-90) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-89) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1911) eta-4 eta-5 eta-6 eta-7))))) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (CoreC-45Reflect-u--reify_Reify_Nat eta-4 eta-5 eta-6 eta-7)))))) eta-0 eta-1 eta-2 eta-3))))) arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 9 e-9)))))) (CoreC-45Reflect-cantReify u--val "Decl" ext-0)))))))(else (CoreC-45Reflect-cantReify u--val "Decl" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "Decl" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "Decl" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Decl" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_ImpData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkData") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Data" ext-0) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "Data" ext-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (CoreC-45Reflect-cantReify u--val "Data" ext-0) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (CoreC-45Reflect-cantReify u--val "Data" ext-0) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (CoreC-45Reflect-cantReify u--val "Data" ext-0) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (if (null? e-20) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-18) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-21 (vector-ref act-27 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-21 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-21 (vector-ref act-27 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-22 (vector-ref act-28 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_DataOpt u--c u--vars arg-9108 arg-9109 eta-0)))))) arg-0 arg-1 arg-2 e-22) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-22 (vector-ref act-28 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-23 (vector-ref act-29 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-29 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_ImpTy u--c u--vars arg-9108 arg-9109 eta-0)))))) arg-0 arg-1 arg-2 e-23) ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-23 (vector-ref act-29 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-29 1))) (vector 1 (vector 0 e-15 e-18 e-21 e-22 e-23)))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "Data" ext-0))))))))))))))))))) ((equal? e-8 "MkLater") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Data" ext-0) (let ((e-23 (car sc5))) (let ((e-24 (cdr sc5))) (if (null? e-24) (CoreC-45Reflect-cantReify u--val "Data" ext-0) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (if (null? e-27) (CoreC-45Reflect-cantReify u--val "Data" ext-0) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 1 e-9 e-10 e-11)))))))))))))) (CoreC-45Reflect-cantReify u--val "Data" ext-0)))))))))))))(else (CoreC-45Reflect-cantReify u--val "Data" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "Data" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "Data" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Data" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_ImpClause (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "PatClause") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-16 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-17 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (vector 1 (vector 0 e-15 e-16 e-17)))))))))))))) (CoreC-45Reflect-cantReify u--val "Clause" ext-0))))))))))))) ((equal? e-8 "WithClause") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-17 (car sc5))) (let ((e-18 (cdr sc5))) (if (null? e-18) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-20 (car e-18))) (let ((e-21 (cdr e-18))) (if (null? e-21) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-23 (car e-21))) (let ((e-24 (cdr e-21))) (if (null? e-24) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (if (null? e-27) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (if (null? e-33) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-17) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (csegen-1897) arg-0 arg-1 arg-2 e-12) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-9108) (lambda (arg-9109) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_WithFlag u--c u--vars arg-9108 arg-9109 eta-0)))))) arg-0 arg-1 arg-2 e-13) ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-32) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-30 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1898) arg-0 arg-1 arg-2 e-14) ext-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-30 1))) (vector 1 (vector 1 e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "Clause" ext-0)))))))))))))))))))))) ((equal? e-8 "ImpossibleClause") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-36 (car sc5))) (let ((e-37 (cdr sc5))) (if (null? e-37) (CoreC-45Reflect-cantReify u--val "Clause" ext-0) (let ((e-39 (car e-37))) (let ((e-40 (cdr e-37))) (if (null? e-40) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-39) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 2 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "Clause" ext-0))))))))))(else (CoreC-45Reflect-cantReify u--val "Clause" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "Clause" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "Clause" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Clause" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_IFieldUpdate (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "ISetField") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0) (let ((e-14 (car e-9))) (let ((e-15 (cdr e-9))) (if (null? e-14) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0) (let ((e-19 (cdr e-14))) (if (null? e-15) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1911) arg-0 arg-1 arg-2 e-13) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-16 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (vector 1 (vector 0 e-13 e-16)))))))))) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0))))))))))))) ((equal? e-8 "ISetFieldApp") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0) (let ((e-22 (car e-5))) (let ((e-23 (cdr e-5))) (if (null? e-22) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0) (let ((e-27 (cdr e-22))) (if (null? e-23) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0) (let ((e-29 (car e-23))) (let ((e-30 (cdr e-23))) (if (null? e-29) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0) (let ((e-34 (cdr e-29))) (if (null? e-30) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-27) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1911) arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-34) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 1 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0)))))))))))))(else (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "IFieldUpdate" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "IFieldUpdate" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_IField (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkIField") (let ((sc5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify u--val "IField" ext-0) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "IField" ext-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (CoreC-45Reflect-cantReify u--val "IField" ext-0) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (CoreC-45Reflect-cantReify u--val "IField" ext-0) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (CoreC-45Reflect-cantReify u--val "IField" ext-0) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (if (null? e-20) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-18) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-21 (vector-ref act-27 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (csegen-1896) arg-0 arg-1 arg-2 e-21) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-21 (vector-ref act-27 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-22 (vector-ref act-28 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-22) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-22 (vector-ref act-28 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-23 (vector-ref act-29 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-29 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-23 ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-23 (vector-ref act-29 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-29 1))) (vector 1 (vector e-15 e-18 e-21 e-22 e-23)))))))))))))))))))))) (CoreC-45Reflect-cantReify u--val "IField" ext-0)))))))))))))))))))(else (CoreC-45Reflect-cantReify u--val "IField" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "IField" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "IField" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "IField" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_FnOpt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Inline") (vector 1 (vector 0 ))) ((equal? e-8 "TCInline") (vector 1 (vector 1 ))) ((equal? e-8 "Hint") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Bool arg-0 arg-1 arg-2 e-13) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (vector 2 e-13)))))) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0)))))))) ((equal? e-8 "GlobalHint") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-15 (car e-5))) (let ((e-16 (cdr e-5))) (if (null? e-15) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-20 (cdr e-15))) (if (null? e-16) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Bool arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 3 e-9)))))) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0)))))))) ((equal? e-8 "ExternFn") (vector 1 (vector 4 ))) ((equal? e-8 "ForeignFn") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-23 (car e-5))) (let ((e-24 (cdr e-5))) (if (null? e-23) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-28 (cdr e-23))) (if (null? e-24) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-28) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1896) arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 5 e-9)))))) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0)))))))) ((equal? e-8 "Invertible") (vector 1 (vector 6 ))) ((equal? e-8 "Totality") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-31 (car e-5))) (let ((e-32 (cdr e-5))) (if (null? e-31) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-36 (cdr e-31))) (if (null? e-32) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_TotalReq arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 7 e-9)))))) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0)))))))) ((equal? e-8 "Macro") (vector 1 (vector 8 ))) ((equal? e-8 "SpecArgs") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-39 (car e-5))) (let ((e-40 (cdr e-5))) (if (null? e-39) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0) (let ((e-44 (cdr e-39))) (if (null? e-40) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-44) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1897) arg-0 arg-1 arg-2 e-9) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 9 e-9)))))) (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0))))))))(else (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "FnOpt" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "FnOpt" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_DotReason (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "NonLinearVar") (vector 1 0)) ((equal? e-8 "VarApplied") (vector 1 1)) ((equal? e-8 "NotConstructor") (vector 1 2)) ((equal? e-8 "ErasedArg") (vector 1 3)) ((equal? e-8 "UserDotted") (vector 1 4)) ((equal? e-8 "UnknownDot") (vector 1 5)) ((equal? e-8 "UnderAppliedCon") (vector 1 6))(else (CoreC-45Reflect-cantReify u--val "DotReason" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "DotReason" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "DotReason" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "DotReason" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_DataOpt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "SearchBy") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "DataOpt" ext-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "DataOpt" ext-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1897) arg-0 arg-1 arg-2 e-13) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (vector 0 e-13)))))) (CoreC-45Reflect-cantReify u--val "DataOpt" ext-0)))))))) ((equal? e-8 "NoHints") (vector 1 (vector 1 ))) ((equal? e-8 "UniqueSearch") (vector 1 (vector 2 ))) ((equal? e-8 "External") (vector 1 (vector 3 ))) ((equal? e-8 "NoNewtype") (vector 1 (vector 4 )))(else (CoreC-45Reflect-cantReify u--val "DataOpt" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "DataOpt" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "DataOpt" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "DataOpt" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_BindMode (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "PI") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "BindMode" ext-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "BindMode" ext-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-13) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (vector 0 e-13)))))) (CoreC-45Reflect-cantReify u--val "BindMode" ext-0)))))))) ((equal? e-8 "PATTERN") (vector 1 (vector 1 ))) ((equal? e-8 "COVERAGE") (vector 1 (vector 2 ))) ((equal? e-8 "NONE") (vector 1 (vector 3 )))(else (CoreC-45Reflect-cantReify u--val "BindMode" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "BindMode" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "BindMode" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "BindMode" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_AltType (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "FirstSuccess") (vector 1 (vector 0 ))) ((equal? e-8 "Unique") (vector 1 (vector 1 ))) ((equal? e-8 "UniqueDefault") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "AltType" ext-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "AltType" ext-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (vector 2 e-13)))))) (CoreC-45Reflect-cantReify u--val "AltType" ext-0))))))))(else (CoreC-45Reflect-cantReify u--val "AltType" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "AltType" ext-0)))))(else (CoreC-45Reflect-cantReify u--val "AltType" ext-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "AltType" ext-0)))))
(define TTImpC-45Reflect-u--reflect_Reflect_WithFlag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (cond (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Syntactic") ext-0)))))
(define TTImpC-45Reflect-u--reflect_Reflect_UseSide (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UseLeft") ext-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UseRight") ext-0)))))
(define TTImpC-45Reflect-u--reflect_Reflect_RawImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-11) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IVar") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((1) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (let ((e-18 (vector-ref arg-5 5))) (let ((e-19 (vector-ref arg-5 6))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-14) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-15) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (csegen-1919) arg-0 arg-1 arg-2 arg-3 arg-4 e-16) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (csegen-1920) arg-0 arg-1 arg-2 arg-3 arg-4 e-17) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-18) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-19) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IPi") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '())))))) eta-0))))))))))))))))))))))))))))))))) ((2) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (let ((e-24 (vector-ref arg-5 4))) (let ((e-25 (vector-ref arg-5 5))) (let ((e-26 (vector-ref arg-5 6))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-22) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (csegen-1919) arg-0 arg-1 arg-2 arg-3 arg-4 e-23) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (csegen-1920) arg-0 arg-1 arg-2 arg-3 arg-4 e-24) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-25) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-26) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ILam") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '())))))) eta-0))))))))))))))))))))))))))))))))) ((3) (let ((e-28 (vector-ref arg-5 1))) (let ((e-29 (vector-ref arg-5 2))) (let ((e-30 (vector-ref arg-5 3))) (let ((e-31 (vector-ref arg-5 4))) (let ((e-32 (vector-ref arg-5 5))) (let ((e-33 (vector-ref arg-5 6))) (let ((e-34 (vector-ref arg-5 7))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-28) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-29) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-30) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-31) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-32) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-33) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-34) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ILet") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 (cons e-11 '()))))))) eta-0)))))))))))))))))))))))))))))))))))))) ((4) (let ((e-36 (vector-ref arg-5 1))) (let ((e-37 (vector-ref arg-5 2))) (let ((e-38 (vector-ref arg-5 3))) (let ((e-39 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-36) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-37) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-38) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1921) arg-0 arg-1 arg-2 arg-3 arg-4 e-39) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ICase") (cons e-5 (cons e-6 (cons e-7 (cons e-8 '())))) eta-0))))))))))))))))))))))) ((5) (let ((e-41 (vector-ref arg-5 1))) (let ((e-42 (vector-ref arg-5 2))) (let ((e-43 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-41) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1922) arg-0 arg-1 arg-2 arg-3 arg-4 e-42) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-43) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ILocal") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((6) (let ((e-49 (vector-ref arg-5 5))) (TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-49))) ((7) (let ((e-51 (vector-ref arg-5 1))) (let ((e-52 (vector-ref arg-5 2))) (let ((e-53 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-51) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-1) (TTImpC-45Reflect-u--reflect_Reflect_IFieldUpdate u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-1)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-52) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-53) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IUpdate") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((8) (let ((e-55 (vector-ref arg-5 1))) (let ((e-56 (vector-ref arg-5 2))) (let ((e-57 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-55) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-56) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-57) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IApp") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((9) (let ((e-59 (vector-ref arg-5 1))) (let ((e-60 (vector-ref arg-5 2))) (let ((e-61 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-59) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-60) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-61) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IAutoApp") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((10) (let ((e-63 (vector-ref arg-5 1))) (let ((e-64 (vector-ref arg-5 2))) (let ((e-65 (vector-ref arg-5 3))) (let ((e-66 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-63) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-64) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-65) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-66) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "INamedApp") (cons e-5 (cons e-6 (cons e-7 (cons e-8 '())))) eta-0))))))))))))))))))))))) ((11) (let ((e-68 (vector-ref arg-5 1))) (let ((e-69 (vector-ref arg-5 2))) (let ((e-70 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-68) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-69) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-70) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IWithApp") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((12) (let ((e-72 (vector-ref arg-5 1))) (let ((e-73 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-72) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Nat arg-0 arg-1 arg-2 arg-3 arg-4 e-73) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ISearch") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((13) (let ((e-75 (vector-ref arg-5 1))) (let ((e-76 (vector-ref arg-5 2))) (let ((e-77 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-75) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45Reflect-u--reflect_Reflect_AltType arg-0 arg-1 arg-2 arg-3 arg-4 e-76 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1919) arg-0 arg-1 arg-2 arg-3 arg-4 e-77) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IAlternative") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((14) (let ((e-79 (vector-ref arg-5 1))) (let ((e-80 (vector-ref arg-5 2))) (let ((e-81 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-79) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-80) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-81) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IRewrite") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((15) (let ((e-84 (vector-ref arg-5 2))) (TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-84))) ((16) (let ((e-86 (vector-ref arg-5 1))) (let ((e-87 (vector-ref arg-5 2))) (let ((e-88 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-86) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45Reflect-u--reflect_Reflect_BindMode arg-0 arg-1 arg-2 arg-3 arg-4 e-87 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-88) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IBindHere") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((17) (let ((e-90 (vector-ref arg-5 1))) (let ((e-91 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-90) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-91 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IBindVar") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((18) (let ((e-93 (vector-ref arg-5 1))) (let ((e-94 (vector-ref arg-5 2))) (let ((e-95 (vector-ref arg-5 3))) (let ((e-96 (vector-ref arg-5 4))) (let ((e-97 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-93) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-94) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Reflect-u--reflect_Reflect_UseSide arg-0 arg-1 arg-2 arg-3 arg-4 e-95 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-96) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-97) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IAs") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 '()))))) eta-0)))))))))))))))))))))))))))) ((19) (let ((e-99 (vector-ref arg-5 1))) (let ((e-100 (vector-ref arg-5 2))) (let ((e-101 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-99) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45Reflect-u--reflect_Reflect_DotReason arg-0 arg-1 arg-2 arg-3 arg-4 e-100 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-101) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IMustUnify") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((20) (let ((e-103 (vector-ref arg-5 1))) (let ((e-104 (vector-ref arg-5 2))) (let ((e-105 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-103) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_LazyReason arg-0 arg-1 arg-2 arg-3 arg-4 e-104) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-105) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IDelayed") (cons e-5 (cons e-6 (cons e-7 '()))) eta-0)))))))))))))))))) ((21) (let ((e-107 (vector-ref arg-5 1))) (let ((e-108 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-107) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-108) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IDelay") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((22) (let ((e-110 (vector-ref arg-5 1))) (let ((e-111 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-110) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-111) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IForce") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((23) (let ((e-113 (vector-ref arg-5 1))) (let ((e-114 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-113) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-114) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IQuote") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((24) (let ((e-116 (vector-ref arg-5 1))) (let ((e-117 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-116) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-117) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IQuoteName") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((25) (let ((e-119 (vector-ref arg-5 1))) (let ((e-120 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-119) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1922) arg-0 arg-1 arg-2 arg-3 arg-4 e-120) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IQuoteDecl") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((26) (let ((e-122 (vector-ref arg-5 1))) (let ((e-123 (vector-ref arg-5 2))) (lambda (clam-0) (case (vector-ref e-123 0) ((0) (let ((e-141 (vector-ref e-123 2))) (vector 1 (vector 1 e-122 (vector 0 ) e-141))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't reflect an unquote: escapes should be lifted out") clam-0))))))) ((27) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't reflect a %runelab") eta-0))) ((28) (let ((e-128 (vector-ref arg-5 1))) (let ((e-129 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-128) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Constant arg-0 arg-1 arg-2 arg-3 arg-4 e-129) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IPrimVal") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((29) (let ((e-131 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-131) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IType") (cons e-5 '()) eta-0)))))))) ((30) (let ((e-133 (vector-ref arg-5 1))) (let ((e-134 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-133) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-134 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IHole") (cons e-5 (cons e-6 '())) eta-0))))))))))))) ((31) (let ((e-138 (vector-ref arg-5 3))) (TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-138)))(else (cond ((equal? arg-3 1) (lambda (clam-0) (case (vector-ref arg-5 0) ((32) (vector 1 (vector 10 arg-1 0)))(else (case (vector-ref arg-5 0) ((32) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Bool arg-0 arg-1 arg-2 arg-3 arg-4 e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Implicit") (cons e-5 (cons e-6 '())) clam-0)))))))))))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((e-6 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1920) arg-0 arg-1 arg-2 arg-3 arg-4 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-6) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "WithUnambigNames") (cons e-7 (cons e-8 (cons e-9 '()))) clam-0))))))))))))))))))))))(else (lambda (clam-2) (case (vector-ref arg-5 0) ((32) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Bool arg-0 arg-1 arg-2 arg-3 arg-4 e-2) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Implicit") (cons e-5 (cons e-6 '())) clam-2)))))))))))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((e-6 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-4) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1920) arg-0 arg-1 arg-2 arg-3 arg-4 e-5) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-6) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "WithUnambigNames") (cons e-7 (cons e-8 (cons e-9 '()))) clam-2)))))))))))))))))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkTy") (cons e-5 (cons e-6 (cons e-7 (cons e-8 '())))) ext-0)))))))))))))))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpRecord (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1925) arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_IField u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-5) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkRecord") (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '()))))) ext-0))))))))))))))))))))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_Visibility arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_FnOpt u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45Reflect-u--reflect_Reflect_ImpTy arg-0 arg-1 arg-2 arg-3 arg-4 e-5 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IClaim") (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '()))))) ext-0))))))))))))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-7) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Visibility arg-0 arg-1 arg-2 arg-3 arg-4 e-8) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Reflect-u--reflect_Reflect_ImpData arg-0 arg-1 arg-2 arg-3 arg-4 e-9 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IData") (cons e-5 (cons e-6 (cons e-10 '()))) ext-0))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-11) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-12) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1921) arg-0 arg-1 arg-2 arg-3 arg-4 e-13) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IDef") (cons e-5 (cons e-6 (cons e-7 '()))) ext-0))))))))))))))))) ((3) (let ((e-15 (vector-ref arg-5 1))) (let ((e-16 (vector-ref arg-5 2))) (let ((e-17 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-15) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1925) arg-0 arg-1 arg-2 arg-3 arg-4 e-16) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1922) arg-0 arg-1 arg-2 arg-3 arg-4 e-17) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IParameters") (cons e-5 (cons e-6 (cons e-7 '()))) ext-0))))))))))))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (let ((e-22 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-19) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (csegen-1935) arg-0 arg-1 arg-2 arg-3 arg-4 e-20) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_Visibility arg-0 arg-1 arg-2 arg-3 arg-4 e-21) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45Reflect-u--reflect_Reflect_ImpRecord arg-0 arg-1 arg-2 arg-3 arg-4 e-22 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IRecord") (cons e-5 (cons e-6 (cons e-7 (cons e-8 '())))) ext-0)))))))))))))))))))))) ((5) (let ((e-24 (vector-ref arg-5 1))) (let ((e-25 (vector-ref arg-5 2))) (let ((e-26 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-24) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Reflect-u--reflect_Reflect_Namespace arg-0 arg-1 arg-2 arg-3 arg-4 e-25 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1922) arg-0 arg-1 arg-2 arg-3 arg-4 e-26) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "INamespace") (cons e-5 (cons e-6 (cons e-7 '()))) ext-0))))))))))))))))) ((6) (let ((e-28 (vector-ref arg-5 1))) (let ((e-29 (vector-ref arg-5 2))) (let ((e-30 (vector-ref arg-5 3))) (let ((e-31 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-28) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-29) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-30) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-31) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ITransform") (cons e-5 (cons e-6 (cons e-7 (cons e-8 '())))) ext-0)))))))))))))))))))))) ((7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "Can't reflect a %runElab") ext-0)) ((8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "Can't reflect a pragma") ext-0)) ((9) (let ((e-39 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1935) eta-7 eta-8 eta-9 eta-10 eta-11 eta-12))))))) (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (CoreC-45Reflect-u--reflect_Reflect_Nat eta-7 eta-8 eta-9 eta-10 eta-11 eta-12)))))))) eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-39) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ILog") (cons e-5 '()) ext-0))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "Can't reflect a %builtin") ext-0)))))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_DataOpt u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_ImpTy u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-5) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkData") (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '()))))) ext-0))))))))))))))))))))))))))) (else (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-7) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-8) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-9) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkLater") (cons e-5 (cons e-6 (cons e-10 '()))) ext-0))))))))))))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "PatClause") (cons e-5 (cons e-6 (cons e-7 '()))) ext-0))))))))))))))))) ((1) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (let ((e-9 (vector-ref arg-5 5))) (let ((e-10 (vector-ref arg-5 6))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-7) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (csegen-1920) arg-0 arg-1 arg-2 arg-3 arg-4 e-8) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-9131) (lambda (arg-9132) (lambda (u--onLHS) (lambda (arg-9133) (lambda (arg-9135) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_WithFlag u--vars arg-9131 arg-9132 u--onLHS arg-9133 arg-9135 eta-0)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-9) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-28 1))) (let ((act-29 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1921) arg-0 arg-1 arg-2 arg-3 arg-4 e-10) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-29 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "WithClause") (cons e-11 (cons e-12 (cons e-13 (cons e-14 (cons e-15 (cons e-16 '())))))) ext-0)))))))))))))))))))))))))))))))) (else (let ((e-12 (vector-ref arg-5 1))) (let ((e-13 (vector-ref arg-5 2))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-12) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-13) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ImpossibleClause") (cons e-5 (cons e-6 '())) ext-0)))))))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_IFieldUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1935) arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ISetField") (cons e-5 (cons e-6 '())) ext-0)))))))))))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1935) arg-0 arg-1 arg-2 arg-3 arg-4 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ISetFieldApp") (cons e-6 (cons e-7 '())) ext-0)))))))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_IField (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (csegen-1919) arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-5) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkIField") (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '()))))) ext-0))))))))))))))))))))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_FnOpt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Inline") ext-0)) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "TCInline") ext-0)) ((2) (let ((e-3 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_Bool arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Hint") (cons e-5 '()) ext-0))))))) ((3) (let ((e-5 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_Bool arg-0 arg-1 arg-2 arg-3 arg-4 e-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "GlobalHint") (cons e-6 '()) ext-0))))))) ((4) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ExternFn") ext-0)) ((5) (let ((e-8 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1919) arg-0 arg-1 arg-2 arg-3 arg-4 e-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ForeignFn") (cons e-5 '()) ext-0))))))) ((6) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Invertible") ext-0)) ((7) (let ((e-11 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_TotalReq arg-0 arg-1 arg-2 arg-3 arg-4 e-11) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Totality") (cons e-5 '()) ext-0))))))) ((8) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Macro") ext-0)) (else (let ((e-14 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1920) arg-0 arg-1 arg-2 arg-3 arg-4 e-14) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "SpecArgs") (cons e-5 '()) ext-0))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_DotReason (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NonLinearVar") ext-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "VarApplied") ext-0)) ((equal? arg-5 2) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NotConstructor") ext-0)) ((equal? arg-5 3) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ErasedArg") ext-0)) ((equal? arg-5 4) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UserDotted") ext-0)) ((equal? arg-5 5) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UnknownDot") ext-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UnderAppliedCon") ext-0)))))
(define TTImpC-45Reflect-u--reflect_Reflect_DataOpt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1920) arg-0 arg-1 arg-2 arg-3 arg-4 e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "SearchBy") (cons e-5 '()) ext-0))))))) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NoHints") ext-0)) ((2) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UniqueSearch") ext-0)) ((3) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "External") ext-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NoNewtype") ext-0)))))
(define TTImpC-45Reflect-u--reflect_Reflect_BindMode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "PI") (cons e-5 '()) ext-0))))))) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "PATTERN") ext-0)) ((2) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "COVERAGE") ext-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NONE") ext-0)))))
(define TTImpC-45Reflect-u--reflect_Reflect_AltType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "FirstSuccess") ext-0)) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Unique") ext-0)) (else (let ((e-3 (vector-ref arg-5 1))) (let ((act-24 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UniqueDefault") (cons e-5 '()) ext-0))))))))))
(define CoreC-45Reflect-u--reify_Reify_Visibility (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (cond ((equal? e-7 "Private") (vector 1 0)) ((equal? e-7 "Export") (vector 1 1)) ((equal? e-7 "Public") (vector 1 2))(else (CoreC-45Reflect-cantReify u--val "Visibility" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Visibility" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Visibility" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Visibility" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_VirtualIdent (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Interactive") (if (null? e-5) (vector 1 0) (CoreC-45Reflect-cantReify u--val "VirtualIdent" clam-0)))(else (CoreC-45Reflect-cantReify u--val "VirtualIdent" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "VirtualIdent" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "VirtualIdent" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "VirtualIdent" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_UserName (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Basic") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-9 (car e-5))) (let ((e-10 (cdr e-5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-14 (cdr e-9))) (if (null? e-10) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-14) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-11) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) (vector 1 (vector 0 e-11)))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))))) ((equal? e-8 "Field") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-17 (car e-5))) (let ((e-18 (cdr e-5))) (if (null? e-17) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-22 (cdr e-17))) (if (null? e-18) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-22) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 1 e-9)))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))))) ((equal? e-8 "Underscore") (if (null? e-5) (vector 1 (vector 2 )) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))(else (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0))))) ((0) (let ((e-7 (vector-ref sc2 2))) (case (vector-ref e-7 0) ((1) (CoreC-45Reflect-cantReify u--val "Name, reifying it is unimplemented or intentionally internal" clam-0))(else (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Name, value is not an NDCon interally" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_TotalReq (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (cond ((equal? e-7 "Total") (vector 1 0)) ((equal? e-7 "CoveringOnly") (vector 1 1)) ((equal? e-7 "PartialOK") (vector 1 2))(else (CoreC-45Reflect-cantReify u--val "TotalReq" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "TotalReq" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "TotalReq" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "TotalReq" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_String (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((10) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "String" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "String" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_RigCount (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (cond ((equal? e-7 "M0") (csegen-517)) ((equal? e-7 "M1") (csegen-518)) ((equal? e-7 "MW") (vector 1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))(else (CoreC-45Reflect-cantReify u--val "Count" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Count" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Count" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Count" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_OriginDesc (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "PhysicalIdrSrc") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_ModuleIdent arg-0 arg-1 arg-2 e-13) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (vector 0 e-13)))))) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0)))))))) ((equal? e-8 "PhysicalPkgSrc") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0) (let ((e-15 (car e-5))) (let ((e-16 (cdr e-5))) (if (null? e-15) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0) (let ((e-20 (cdr e-15))) (if (null? e-16) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 1 e-9)))))) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0)))))))) ((equal? e-8 "Virtual") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0) (let ((e-23 (car e-5))) (let ((e-24 (cdr e-5))) (if (null? e-23) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0) (let ((e-28 (cdr e-23))) (if (null? e-24) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-28) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_VirtualIdent arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 2 e-9)))))) (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0))))))))(else (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "OriginDesc" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "OriginDesc" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Nat (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Z") (vector 1 0)) ((equal? e-8 "S") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Nat" clam-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "Nat" clam-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Nat arg-0 arg-1 arg-2 e-13) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (+ 1 e-13)))))) (CoreC-45Reflect-cantReify u--val "Nat" clam-0))))))))(else (CoreC-45Reflect-cantReify u--val "Nat" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Nat" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Nat" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Nat" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Namespace (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Namespace" eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-7) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Namespace" eta-0)) (let ((e-11 (car e-7))) (let ((e-12 (cdr e-7))) (lambda (clam-0) (if (null? e-8) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 (cons (cons e-11 e-12) '())))) (let ((sc5 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc5 0) ((1) (let ((e-0 (vector-ref sc5 1))) (case (vector-ref e-0 0) ((0) (let ((e-9 (vector-ref e-0 1))) (cond ((equal? e-9 "MkNS") (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1943) arg-0 arg-1 arg-2 e-10) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (CoreC-45NameC-45Namespace-unsafeFoldNamespace e-10)))))))(else (CoreC-45Reflect-cantReify u--val "Namespace" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Namespace" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Namespace" clam-0))))))))) (CoreC-45Reflect-cantReify arg-3 "Namespace" clam-0)))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Namespace" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Name (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "UN") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-9 (car e-5))) (let ((e-10 (cdr e-5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-14 (cdr e-9))) (if (null? e-10) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-14) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_UserName arg-0 arg-1 arg-2 e-11) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) (vector 1 (vector 1 e-11)))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))))) ((equal? e-8 "MN") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-17 (car e-5))) (let ((e-18 (cdr e-5))) (if (null? e-17) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-22 (cdr e-17))) (if (null? e-18) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-24 (car e-18))) (let ((e-25 (cdr e-18))) (if (null? e-24) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-29 (cdr e-24))) (if (null? e-25) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-22) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Int arg-0 arg-1 arg-2 e-10) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 2 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0))))))))))))) ((equal? e-8 "NS") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-32 (car e-5))) (let ((e-33 (cdr e-5))) (if (null? e-32) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-37 (cdr e-32))) (if (null? e-33) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-39 (car e-33))) (let ((e-40 (cdr e-33))) (if (null? e-39) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-44 (cdr e-39))) (if (null? e-40) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-37) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Namespace arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-44) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 0 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0))))))))))))) ((equal? e-8 "DN") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-47 (car e-5))) (let ((e-48 (cdr e-5))) (if (null? e-47) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-52 (cdr e-47))) (if (null? e-48) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-54 (car e-48))) (let ((e-55 (cdr e-48))) (if (null? e-54) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-59 (cdr e-54))) (if (null? e-55) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-52) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-59) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 4 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0))))))))))))) ((equal? e-8 "Nested") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-62 (car e-5))) (let ((e-63 (cdr e-5))) (if (null? e-62) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-67 (cdr e-62))) (if (null? e-63) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-69 (car e-63))) (let ((e-70 (cdr e-63))) (if (null? e-69) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-74 (cdr e-69))) (if (null? e-70) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-67) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1944) arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-74) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 5 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0))))))))))))) ((equal? e-8 "CaseBlock") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-77 (car e-5))) (let ((e-78 (cdr e-5))) (if (null? e-77) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-82 (cdr e-77))) (if (null? e-78) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-84 (car e-78))) (let ((e-85 (cdr e-78))) (if (null? e-84) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-89 (cdr e-84))) (if (null? e-85) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-82) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-89) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Int arg-0 arg-1 arg-2 e-10) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 6 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0))))))))))))) ((equal? e-8 "WithBlock") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-92 (car e-5))) (let ((e-93 (cdr e-5))) (if (null? e-92) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-97 (cdr e-92))) (if (null? e-93) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-99 (car e-93))) (let ((e-100 (cdr e-93))) (if (null? e-99) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0) (let ((e-104 (cdr e-99))) (if (null? e-100) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-97) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-104) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_Int arg-0 arg-1 arg-2 e-10) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (vector 7 e-9 e-10)))))))))) (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))))))))))(else (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0))))) ((0) (let ((e-7 (vector-ref sc2 2))) (case (vector-ref e-7 0) ((1) (CoreC-45Reflect-cantReify u--val "Name, reifying it is unimplemented or intentionally internal" clam-0))(else (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Name, the name was not found in context" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Name, value is not an NDCon interally" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_ModuleIdent (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "ModuleIdent" eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-7) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "ModuleIdent" eta-0)) (let ((e-11 (car e-7))) (let ((e-12 (cdr e-7))) (lambda (clam-0) (if (null? e-8) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 (cons (cons e-11 e-12) '())))) (let ((sc5 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc5 0) ((1) (let ((e-0 (vector-ref sc5 1))) (case (vector-ref e-0 0) ((0) (let ((e-9 (vector-ref e-0 1))) (cond ((equal? e-9 "MkMI") (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-1943) arg-0 arg-1 arg-2 e-10) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (CoreC-45NameC-45Namespace-unsafeFoldModuleIdent e-10)))))))(else (CoreC-45Reflect-cantReify u--val "ModuleIdent" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "ModuleIdent" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "ModuleIdent" clam-0))))))))) (CoreC-45Reflect-cantReify arg-3 "ModuleIdent" clam-0)))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "ModuleIdent" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_LazyReason (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (cond ((equal? e-7 "LInf") (vector 1 0)) ((equal? e-7 "LLazy") (vector 1 1)) ((equal? e-7 "LUnknown") (vector 1 2))(else (CoreC-45Reflect-cantReify u--val "LazyReason" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "LazyReason" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "LazyReason" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "LazyReason" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Integer (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((5) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Integer" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Integer" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int8 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Int8" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Int8" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int64 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((4) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Int64" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Int64" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int32 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((3) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Int32" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Int32" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int16 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((2) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Int16" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Int16" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Int" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Int" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_FC (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkFC") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "FC" clam-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "FC" clam-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "FC" clam-0) (let ((e-14 (car e-9))) (let ((e-15 (cdr e-9))) (if (null? e-14) (CoreC-45Reflect-cantReify u--val "FC" clam-0) (let ((e-19 (cdr e-14))) (if (null? e-15) (CoreC-45Reflect-cantReify u--val "FC" clam-0) (let ((e-21 (car e-15))) (let ((e-22 (cdr e-15))) (if (null? e-21) (CoreC-45Reflect-cantReify u--val "FC" clam-0) (let ((e-26 (cdr e-21))) (if (null? e-22) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_OriginDesc arg-0 arg-1 arg-2 e-13) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1944) arg-0 arg-1 arg-2 e-16) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) ((CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1944) arg-0 arg-1 arg-2 e-17) clam-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (vector 1 (vector 0 e-13 e-16 e-17)))))))))))))) (CoreC-45Reflect-cantReify u--val "FC" clam-0)))))))))))))))))) ((equal? e-8 "EmptyFC") (vector 1 (vector 2 )))(else (CoreC-45Reflect-cantReify u--val "FC" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "FC" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "FC" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "FC" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Double (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((12) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Double" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Double" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Constant (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "I") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Int arg-0 arg-1 arg-2 e-13) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (vector 0 e-13)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "I8") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-15 (car e-5))) (let ((e-16 (cdr e-5))) (if (null? e-15) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-20 (cdr e-15))) (if (null? e-16) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Int8 arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 1 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "I16") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-23 (car e-5))) (let ((e-24 (cdr e-5))) (if (null? e-23) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-28 (cdr e-23))) (if (null? e-24) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-28) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Int16 arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 2 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "I32") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-31 (car e-5))) (let ((e-32 (cdr e-5))) (if (null? e-31) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-36 (cdr e-31))) (if (null? e-32) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Int32 arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 3 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "I64") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-39 (car e-5))) (let ((e-40 (cdr e-5))) (if (null? e-39) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-44 (cdr e-39))) (if (null? e-40) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-44) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Int64 arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 4 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "BI") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-47 (car e-5))) (let ((e-48 (cdr e-5))) (if (null? e-47) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-52 (cdr e-47))) (if (null? e-48) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-52) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Integer arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 5 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "B8") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-55 (car e-5))) (let ((e-56 (cdr e-5))) (if (null? e-55) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-60 (cdr e-55))) (if (null? e-56) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-60) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Bits8 arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 6 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "B16") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-63 (car e-5))) (let ((e-64 (cdr e-5))) (if (null? e-63) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-68 (cdr e-63))) (if (null? e-64) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-68) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Bits16 arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 7 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "B32") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-71 (car e-5))) (let ((e-72 (cdr e-5))) (if (null? e-71) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-76 (cdr e-71))) (if (null? e-72) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-76) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Bits32 arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 8 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "B64") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-79 (car e-5))) (let ((e-80 (cdr e-5))) (if (null? e-79) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-84 (cdr e-79))) (if (null? e-80) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-84) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Bits64 arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 9 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "Str") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-87 (car e-5))) (let ((e-88 (cdr e-5))) (if (null? e-87) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-92 (cdr e-87))) (if (null? e-88) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-92) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 10 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "Ch") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-95 (car e-5))) (let ((e-96 (cdr e-5))) (if (null? e-95) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-100 (cdr e-95))) (if (null? e-96) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-100) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Char arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 11 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "Db") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-103 (car e-5))) (let ((e-104 (cdr e-5))) (if (null? e-103) (CoreC-45Reflect-cantReify u--val "Constant" clam-0) (let ((e-108 (cdr e-103))) (if (null? e-104) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-108) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_Double arg-0 arg-1 arg-2 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (vector 12 e-9)))))) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))) ((equal? e-8 "WorldVal") (if (null? e-5) (vector 1 (vector 13 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "IntType") (if (null? e-5) (vector 1 (vector 14 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "Int8Type") (if (null? e-5) (vector 1 (vector 15 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "Int16Type") (if (null? e-5) (vector 1 (vector 16 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "Int32Type") (if (null? e-5) (vector 1 (vector 17 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "Int64Type") (if (null? e-5) (vector 1 (vector 18 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "IntegerType") (if (null? e-5) (vector 1 (vector 19 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "Bits8Type") (if (null? e-5) (vector 1 (vector 20 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "Bits16Type") (if (null? e-5) (vector 1 (vector 21 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "Bits32Type") (if (null? e-5) (vector 1 (vector 22 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "Bits64Type") (if (null? e-5) (vector 1 (vector 23 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "StringType") (if (null? e-5) (vector 1 (vector 24 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "CharType") (if (null? e-5) (vector 1 (vector 25 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "DoubleType") (if (null? e-5) (vector 1 (vector 26 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0))) ((equal? e-8 "WorldType") (if (null? e-5) (vector 1 (vector 27 )) (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))(else (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Constant" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Constant" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Char (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((11) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Char" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Char" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bool (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (cond ((equal? e-7 "True") (vector 1 1)) ((equal? e-7 "False") (vector 1 0))(else (CoreC-45Reflect-cantReify u--val "Bool" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Bool" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Bool" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-3 "Bool" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bits8 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((6) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Bits8" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Bits8" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bits64 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((9) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Bits64" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Bits64" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bits32 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((8) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Bits32" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Bits32" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bits16 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((7) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-3 "Bits16" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 "Bits16" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((2) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-6 "Pair" eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-6 "Pair" eta-0)) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-6 "Pair" eta-0)) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-13) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-6 "Pair" eta-0)) (let ((e-17 (car e-13))) (let ((e-18 (cdr e-13))) (if (null? e-14) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-6 "Pair" eta-0)) (let ((e-20 (car e-14))) (let ((e-21 (cdr e-14))) (if (null? e-20) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-6 "Pair" eta-0)) (let ((e-24 (car e-20))) (let ((e-25 (cdr e-20))) (lambda (clam-0) (if (null? e-21) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-5 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 (cons e-7 (cons e-10 (cons (cons e-17 e-18) (cons (cons e-24 e-25) '()))))))) (let ((sc9 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc9 0) ((1) (let ((e-0 (vector-ref sc9 1))) (case (vector-ref e-0 0) ((0) (let ((e-9 (vector-ref e-0 1))) (cond ((equal? e-9 "MkPair") (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-3 arg-4 arg-5 e-18) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-12 (vector-ref act-25 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-25 1))) ((((((Builtin-fst arg-2) arg-3) arg-4) arg-5) e-12) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-12 (vector-ref act-25 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-3 arg-4 arg-5 e-25) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-15 (vector-ref act-26 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-26 1))) ((((((Builtin-snd arg-2) arg-3) arg-4) arg-5) e-15) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-15 (vector-ref act-26 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-26 1))) (vector 1 (cons e-12 e-15)))))))))))(else (CoreC-45Reflect-cantReify u--val "Pair" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Pair" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Pair" clam-0))))))))) (CoreC-45Reflect-cantReify arg-6 "Pair" clam-0)))))))))))))))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-6 "Pair" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-4 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "ImplicitArg") (vector 1 (vector 0 ))) ((equal? e-8 "ExplicitArg") (vector 1 (vector 1 ))) ((equal? e-8 "AutoImplicit") (vector 1 (vector 2 ))) ((equal? e-8 "DefImplicit") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "PiInfo" clam-0) (let ((e-9 (cdr e-5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "PiInfo" clam-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-12) (CoreC-45Reflect-cantReify u--val "PiInfo" clam-0) (let ((e-15 (cdr e-12))) (if (null? e-11) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-3 arg-4 e-15) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (((((arg-1 arg-2) arg-3) arg-4) e-13) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (vector 3 e-13)))))) (CoreC-45Reflect-cantReify u--val "PiInfo" clam-0))))))))))(else (CoreC-45Reflect-cantReify u--val "PiInfo" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "PiInfo" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "PiInfo" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-5 "PiInfo" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-4 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Nothing") (vector 1 '())) ((equal? e-8 "Just") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "Maybe" clam-0) (let ((e-9 (cdr e-5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "Maybe" clam-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-12) (CoreC-45Reflect-cantReify u--val "Maybe" clam-0) (let ((e-15 (cdr e-12))) (if (null? e-11) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-3 arg-4 e-15) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (((((arg-1 arg-2) arg-3) arg-4) e-13) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (box e-13)))))) (CoreC-45Reflect-cantReify u--val "Maybe" clam-0))))))))))(else (CoreC-45Reflect-cantReify u--val "Maybe" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Maybe" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "Maybe" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-5 "Maybe" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-4 0))) e-0) e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Nil") (vector 1 '())) ((equal? e-8 "::") (if (null? e-5) (CoreC-45Reflect-cantReify u--val "List" clam-0) (let ((e-9 (cdr e-5))) (if (null? e-9) (CoreC-45Reflect-cantReify u--val "List" clam-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-12) (CoreC-45Reflect-cantReify u--val "List" clam-0) (let ((e-15 (cdr e-12))) (if (null? e-11) (CoreC-45Reflect-cantReify u--val "List" clam-0) (let ((e-17 (car e-11))) (let ((e-18 (cdr e-11))) (if (null? e-17) (CoreC-45Reflect-cantReify u--val "List" clam-0) (let ((e-22 (cdr e-17))) (if (null? e-18) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-3 arg-4 e-15) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (((((arg-1 arg-2) arg-3) arg-4) e-13) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-3 arg-4 e-22) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3 arg-4 e-16) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (vector 1 (cons e-13 e-16)))))))))) (CoreC-45Reflect-cantReify u--val "List" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify u--val "List" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "List" clam-0)))))(else (CoreC-45Reflect-cantReify u--val "List" clam-0)))))))))))))))(else (CoreC-45Reflect-cantReify arg-5 "List" clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_Visibility (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Private") clam-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Export") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Public") clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_VirtualIdent (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Interactive") clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_UserName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Basic") (cons e-5 '()) clam-0))))))) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Field") (cons e-5 '()) clam-0))))))) (else (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Underscore") '() clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_TotalReq (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Total") clam-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "CoveringOnly") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "PartialOK") clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_String (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 10 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_RigCount (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (AlgebraC-45Semiring-elimSemi (csegen-475) (lambda (eta-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "M0") eta-0)) (lambda (eta-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "M1") eta-0)) (lambda (eta-0) (lambda (eta-1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MW") eta-1))) arg-5)))
(define CoreC-45Reflect-u--reflect_Reflect_OriginDesc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_ModuleIdent arg-0 arg-1 arg-2 arg-3 arg-4 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "PhysicalIdrSrc") (cons e-5 '()) ext-0))))))) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "PhysicalPkgSrc") (cons e-5 '()) ext-0))))))) (else (let ((e-2 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_VirtualIdent arg-0 arg-1 arg-2 arg-3 arg-4 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Virtual") (cons e-5 '()) ext-0))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_Nat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-5 0) (lambda (eta-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-preludetypes "Z") eta-0)))(else (let ((e-0 (- arg-5 1))) (lambda (eta-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_Nat arg-0 arg-1 arg-2 arg-3 arg-4 e-0) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-preludetypes "S") (cons e-5 '()) eta-0)))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_Namespace (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1946) arg-0 arg-1 arg-2 arg-3 arg-4 (CoreC-45NameC-45Namespace-unsafeUnfoldNamespace arg-5)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkNS") (cons e-5 '()) ext-0)))))))
(define CoreC-45Reflect-u--reflect_Reflect_Name (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((1) (let ((e-0 (vector-ref arg-5 1))) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_UserName arg-0 arg-1 arg-2 arg-3 arg-4 e-0) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "UN") (cons e-5 '()) clam-0))))))) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-2 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MN") (cons e-5 (cons e-6 '())) clam-0)))))))))))) ((0) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Namespace arg-0 arg-1 arg-2 arg-3 arg-4 e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "NS") (cons e-5 (cons e-6 '())) clam-0)))))))))))) ((4) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "DN") (cons e-7 (cons e-8 '())) clam-0)))))))))))) ((5) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1947) arg-0 arg-1 arg-2 arg-3 arg-4 e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-8) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Nested") (cons e-5 (cons e-6 '())) clam-0)))))))))))) ((6) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-9 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-10 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "CaseBlock") (cons e-5 (cons e-6 '())) clam-0)))))))))))) ((7) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-11 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-12 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "WithBlock") (cons e-5 (cons e-6 '())) clam-0)))))))))))) ((8) (let ((e-13 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 8 e-13) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((8) (CoreC-45Reflect-cantReflect arg-1 "Name directly, Resolved is intentionally internal" clam-0))(else ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-5) clam-0)))))))))(else (CoreC-45Reflect-cantReflect arg-1 "Name, reflecting it is unimplemented or intentionally internal" clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_ModuleIdent (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-1946) arg-0 arg-1 arg-2 arg-3 arg-4 (CoreC-45NameC-45Namespace-unsafeUnfoldModuleIdent arg-5)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkMI") (cons e-5 '()) ext-0)))))))
(define CoreC-45Reflect-u--reflect_Reflect_LazyReason (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "LInf") clam-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "LLazy") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "LUnknown") clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_Integer (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 5 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int8 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 1 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int64 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 4 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int32 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 3 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int16 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 2 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 0 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_FC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-3 1) (lambda (eta-0) (vector 1 (vector 10 arg-1 0))))(else (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_OriginDesc arg-0 arg-1 arg-2 arg-3 arg-4 e-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1947) arg-0 arg-1 arg-2 arg-3 arg-4 e-1 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1947) arg-0 arg-1 arg-2 arg-3 arg-4 e-2 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkFC") (cons e-5 (cons e-6 (cons e-7 '()))) clam-0))))))))))))))))) ((1) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_OriginDesc arg-0 arg-1 arg-2 arg-3 arg-4 e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1947) arg-0 arg-1 arg-2 arg-3 arg-4 e-4 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1947) arg-0 arg-1 arg-2 arg-3 arg-4 e-5 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-26 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkFC") (cons e-6 (cons e-7 (cons e-8 '()))) clam-0))))))))))))))))) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "EmptyFC") clam-0))))))))
(define CoreC-45Reflect-u--reflect_Reflect_Double (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 12 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Constant (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I") (cons e-5 '()) clam-0))))))) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Int8 arg-0 arg-1 arg-2 arg-3 arg-4 e-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I8") (cons e-5 '()) clam-0))))))) ((2) (let ((e-2 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Int16 arg-0 arg-1 arg-2 arg-3 arg-4 e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I16") (cons e-5 '()) clam-0))))))) ((3) (let ((e-3 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Int32 arg-0 arg-1 arg-2 arg-3 arg-4 e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I32") (cons e-5 '()) clam-0))))))) ((4) (let ((e-4 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Int64 arg-0 arg-1 arg-2 arg-3 arg-4 e-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I64") (cons e-5 '()) clam-0))))))) ((5) (let ((e-5 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Integer arg-0 arg-1 arg-2 arg-3 arg-4 e-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "BI") (cons e-6 '()) clam-0))))))) ((6) (let ((e-6 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Bits8 arg-0 arg-1 arg-2 arg-3 arg-4 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "B8") (cons e-5 '()) clam-0))))))) ((7) (let ((e-7 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Bits16 arg-0 arg-1 arg-2 arg-3 arg-4 e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "B16") (cons e-5 '()) clam-0))))))) ((8) (let ((e-8 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Bits32 arg-0 arg-1 arg-2 arg-3 arg-4 e-8 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "B32") (cons e-5 '()) clam-0))))))) ((9) (let ((e-9 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Bits64 arg-0 arg-1 arg-2 arg-3 arg-4 e-9 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "B64") (cons e-5 '()) clam-0))))))) ((10) (let ((e-10 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-10 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Str") (cons e-5 '()) clam-0))))))) ((11) (let ((e-11 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Char arg-0 arg-1 arg-2 arg-3 arg-4 e-11 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Ch") (cons e-5 '()) clam-0))))))) ((12) (let ((e-12 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Reflect-u--reflect_Reflect_Double arg-0 arg-1 arg-2 arg-3 arg-4 e-12 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Db") (cons e-5 '()) clam-0))))))) ((13) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "WorldVal") clam-0)) ((14) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "IntType") clam-0)) ((15) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Int8Type") clam-0)) ((16) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Int16Type") clam-0)) ((17) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Int32Type") clam-0)) ((18) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Int64Type") clam-0)) ((19) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "IntegerType") clam-0)) ((20) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bits8Type") clam-0)) ((21) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bits16Type") clam-0)) ((22) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bits32Type") clam-0)) ((23) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bits64Type") clam-0)) ((24) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "StringType") clam-0)) ((25) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "CharType") clam-0)) ((26) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "DoubleType") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "WorldType") clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_Char (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 11 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Bool (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-basics "True") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-basics "False") clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_Bits8 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 6 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Bits64 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 9 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Bits32 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 8 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Bits16 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 7 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-builtin "MkUnit") ext-0)))
(define CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((act-24 ((((((((Builtin-fst arg-2) arg-3) arg-4) arg-5) arg-6) arg-7) e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((((((((Builtin-snd arg-2) arg-3) arg-4) arg-5) arg-6) arg-7) e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-3 arg-4 arg-5 (CoreC-45Reflect-builtin "MkPair") (cons (vector 10 arg-4 0) (cons (vector 10 arg-4 0) (cons e-5 (cons e-6 '())))) ext-0)))))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-7 0) ((0) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-reflectiontt "ImplicitArg") (cons (vector 10 arg-3 0) '()) clam-0)) ((1) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-reflectiontt "ExplicitArg") (cons (vector 10 arg-3 0) '()) clam-0)) ((2) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-reflectiontt "AutoImplicit") (cons (vector 10 arg-3 0) '()) clam-0)) (else (let ((e-4 (vector-ref arg-7 1))) (let ((act-24 (((((((arg-1 arg-2) arg-3) arg-4) arg-5) arg-6) e-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-reflectiontt "DefImplicit") (cons (vector 10 arg-3 0) (cons e-5 '())) clam-0)))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-preludetypes "Nothing") (cons (vector 10 arg-3 0) '()) clam-0) (let ((e-2 (unbox arg-7))) (let ((act-24 (((((((arg-1 arg-2) arg-3) arg-4) arg-5) arg-6) e-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-preludetypes "Just") (cons (vector 10 arg-3 0) (cons e-5 '())) clam-0))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-basics "Nil") (cons (vector 10 arg-3 0) '()) clam-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-24 (((((((arg-1 arg-2) arg-3) arg-4) arg-5) arg-6) e-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-basics "::") (cons (vector 10 arg-3 0) (cons e-5 (cons e-6 '()))) clam-0)))))))))))))))
(define CoreC-45Reflect-reflectionttimp (lambda (arg-0) (vector 0 (CoreC-45NameC-45Namespace-reflectionTTImpNS) (vector 1 (vector 0 arg-0)))))
(define CoreC-45Reflect-reflectiontt (lambda (arg-0) (vector 0 (CoreC-45NameC-45Namespace-reflectionTTNS) (vector 1 (vector 0 arg-0)))))
(define CoreC-45Reflect-preludetypes (lambda (arg-0) (vector 0 (CoreC-45NameC-45Namespace-typesNS) (vector 1 (vector 0 arg-0)))))
(define CoreC-45Reflect-getCon (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-lookupDefExact arg-3 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 arg-1 arg-3) ext-0) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((5) (let ((e-2 (vector-ref e-1 1))) (let ((e-3 (vector-ref e-1 2))) ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 1 arg-1 (vector 2 e-2 e-3) arg-3)) ext-0)))) ((6) (let ((e-13 (vector-ref e-1 1))) (let ((e-6 (vector-ref e-1 2))) ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 1 arg-1 (vector 3 e-13 e-6) arg-3)) ext-0))))(else ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 1 arg-1 (vector 1 ) arg-3)) ext-0)))))))))))
(define CoreC-45Reflect-cantReify (lambda (arg-2 arg-3 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45Value-getLoc arg-2) (PreludeC-45TypesC-45String-C-43C-43 "Can't reify as " arg-3)) ext-0)))
(define CoreC-45Reflect-cantReflect (lambda (arg-1 arg-2 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "Can't reflect as " arg-2)) ext-0)))
(define CoreC-45Reflect-builtin (lambda (arg-0) (vector 0 (CoreC-45NameC-45Namespace-builtinNS) (vector 1 (vector 0 arg-0)))))
(define CoreC-45Reflect-basics (lambda (arg-0) (vector 0 (CoreC-45NameC-45Namespace-basicsNS) (vector 1 (vector 0 arg-0)))))
(define CoreC-45Reflect-appCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (let ((e-0 (vector-ref arg-2 0))) e-0) (CoreC-45TT-apply arg-1 e-5 arg-4)) ext-0)))))))
(define TTImpC-45ElabC-45RunElab-n--10723-3667-u--unelabType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (lambda (clam-0) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((e-7 (cdr e-3))) (let ((act-24 (TTImpC-45Unelab-unelabUniqueBinders '() arg-14 '() e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-5)))))))))))))
(define TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-16 arg-17 ext-0) (let ((act-24 (let ((act-24 (unbox arg-14))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((((((arg-16 arg-0) arg-10) e-5) 0) arg-8) arg-17) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45NormaliseC-45Eval-nfOpts arg-14 arg-0 (CoreC-45Value-withAll) e-5 arg-8 e-6) ext-0)))))))))))
(define TTImpC-45ElabC-45RunElab-n--10723-3259-u--quotePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 ext-0) (case (vector-ref arg-19 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 "Can't add default lambda") ext-0)))))
(define TTImpC-45ElabC-45RunElab-n--12844-4332-u--mkExpected (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (if (null? arg-13) (let ((act-24 (CoreC-45UnifyState-genName arg-12 arg-10 "scriptTy" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45ElabC-45Check-metaVar arg-0 arg-12 arg-10 arg-3 (csegen-21) arg-4 e-5 (vector 11 arg-3) ext-0))))) (let ((e-1 (unbox arg-13))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 e-5)))))))))
(define TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-16 arg-17 ext-0) (let ((act-24 (CoreC-45Context-clearDefs arg-16 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-14 arg-0 e-5 arg-8 arg-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 46 arg-0 arg-10 arg-8 e-6 arg-17) ext-0)))))))))))
(define TTImpC-45ElabC-45RunElab-n--10692-2381-u--elabCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (cond ((equal? arg-16 "Pure") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-2 (cdr arg-17))) (if (null? e-2) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (lambda (clam-0) (if (null? e-5) (let ((act-24 (CoreC-45Context-clearDefs arg-15 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 e-6 e-4) clam-0))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-0))))))))) ((equal? arg-16 "Bind") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-9 (cdr arg-17))) (if (null? e-9) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-12 (cdr e-9))) (if (null? e-12) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-14 (car e-12))) (let ((e-15 (cdr e-12))) (if (null? e-15) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-17 (car e-15))) (let ((e-18 (cdr e-15))) (lambda (clam-1) (if (null? e-18) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-14) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 e-5 arg-7 clam-1))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-17) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (case (vector-ref e-6 0) ((0) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (case (vector-ref e-3 0) ((0) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-14 arg-0 arg-15 arg-8 e-5 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-19 (vector-ref act-26 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-26 1))) (let ((act-27 (((e-4 arg-15) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-withAll) arg-8 e-19)) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-20 (vector-ref act-27 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-27 1))) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 e-20 arg-7 clam-1))))))))))(else (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "non-function RHS of a Bind: " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-6)) clam-1))))))(else (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "non-function RHS of a Bind: " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-6)) clam-1)))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-1)))))))))))))) ((equal? arg-16 "Fail") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-22 (cdr arg-17))) (if (null? e-22) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-24 (car e-22))) (let ((e-25 (cdr e-22))) (if (null? e-25) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-27 (car e-25))) (let ((e-28 (cdr e-25))) (lambda (clam-2) (if (null? e-28) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-27) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-24) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45Reflect-u--reify_Reify_FC arg-14 arg-0 arg-15 e-6) clam-2))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--customFC (case (vector-ref e-6 0) ((2) arg-10)(else e-6)))) (let ((act-26 ((CoreC-45Reflect-u--reify_Reify_String arg-14 arg-0 arg-15 e-5) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 u--customFC (PreludeC-45TypesC-45String-C-43C-43 "Error during reflection: " e-7)) clam-2)))))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-2)))))))))))) ((equal? arg-16 "Try") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-32 (cdr arg-17))) (if (null? e-32) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-34 (car e-32))) (let ((e-35 (cdr e-32))) (if (null? e-35) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-37 (car e-35))) (let ((e-38 (cdr e-35))) (lambda (clam-3) (if (null? e-38) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-34) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-37) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45UnifyState-tryUnify arg-14 arg-12 (lambda (eta-0) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 e-5 arg-7 eta-0)) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 e-6 arg-7 eta-0)) clam-3))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-3)))))))))))) ((equal? arg-16 "LogMsg") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-41 (car arg-17))) (let ((e-42 (cdr arg-17))) (if (null? e-42) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-44 (car e-42))) (let ((e-45 (cdr e-42))) (if (null? e-45) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-47 (car e-45))) (let ((e-48 (cdr e-45))) (lambda (clam-4) (if (null? e-48) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-41) clam-4))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-44) clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45Reflect-u--reify_Reify_String arg-14 arg-0 arg-15 e-5) clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reify_Reify_Nat arg-14 arg-0 arg-15 e-6) clam-4))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-14 e-7 e-8 (lambda (eta-0) (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-47) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) ((CoreC-45Reflect-u--reify_Reify_String arg-14 arg-0 arg-15 e-9) eta-0)))))) clam-4))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1950) 0 clam-4)))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-4))))))))))))) ((equal? arg-16 "LogTerm") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-51 (car arg-17))) (let ((e-52 (cdr arg-17))) (if (null? e-52) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-54 (car e-52))) (let ((e-55 (cdr e-52))) (if (null? e-55) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-57 (car e-55))) (let ((e-58 (cdr e-55))) (if (null? e-58) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-60 (car e-58))) (let ((e-61 (cdr e-58))) (lambda (clam-5) (if (null? e-61) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-51) clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-54) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45Reflect-u--reify_Reify_String arg-14 arg-0 arg-15 e-5) clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reify_Reify_Nat arg-14 arg-0 arg-15 e-6) clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-14 e-7 e-8 (lambda (eta-0) (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-57) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-60) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45Reflect-u--reify_Reify_String arg-14 arg-0 arg-15 e-9) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (TTImpC-45Reflect-u--reify_Reify_RawImp arg-14 arg-0 arg-15 e-10 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 e-11 (PreludeC-45TypesC-45String-C-43C-43 ": " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-12))))))))))))))))))))) clam-5))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1950) 0 clam-5)))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-5)))))))))))))))) ((equal? arg-16 "LogSugaredTerm") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-64 (car arg-17))) (let ((e-65 (cdr arg-17))) (if (null? e-65) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-67 (car e-65))) (let ((e-68 (cdr e-65))) (if (null? e-68) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-70 (car e-68))) (let ((e-71 (cdr e-68))) (if (null? e-71) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-73 (car e-71))) (let ((e-74 (cdr e-71))) (lambda (clam-6) (if (null? e-74) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-64) clam-6))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-67) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45Reflect-u--reify_Reify_String arg-14 arg-0 arg-15 e-5) clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reify_Reify_Nat arg-14 arg-0 arg-15 e-6) clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-14 e-7 e-8 (lambda (eta-0) (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-70) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-73) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-14 arg-0 arg-15 e-10 eta-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (IdrisC-45Resugar-pterm arg-14 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) e-10) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 ((CoreC-45Reflect-u--reify_Reify_String arg-14 arg-0 arg-15 e-9) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 e-12 (PreludeC-45TypesC-45String-C-43C-43 ": " (IdrisC-45Syntax-u--show_Show_IPTerm e-11))))))))))))))))))))) clam-6))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1950) 0 clam-6)))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-6)))))))))))))))) ((equal? arg-16 "Check") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-77 (car arg-17))) (let ((e-78 (cdr arg-17))) (if (null? e-78) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-80 (car e-78))) (let ((e-81 (cdr e-78))) (lambda (clam-7) (if (null? e-81) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-77) clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-80) clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-resolveName arg-14 (vector 1 (vector 0 "[elaborator script]")) clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-newRef (vector "TTImp.Elab.Check.EST" ) (TTImpC-45ElabC-45Check-initEState arg-0 e-7 arg-8) clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (TTImpC-45Reflect-u--reify_Reify_RawImp arg-14 arg-0 arg-15 e-6 clam-7))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-14 arg-13 arg-12 e-8 (lambda (eta-0) 1) (TTImpC-45ElabC-45Check-check arg-0 arg-14 arg-13 arg-12 e-8 arg-11 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (TTImpC-45ElabC-45Check-initElabInfo (vector 2 )) arg-9 arg-8 e-9 (box (CoreC-45Normalise-glueBack arg-14 arg-0 arg-15 arg-8 e-5))) clam-7))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((act-29 (CoreC-45Context-clearDefs arg-15 clam-7))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) ((CoreC-45NormaliseC-45Eval-nf arg-14 arg-0 e-10 arg-8 e-2) clam-7)))))))))))))))))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-7)))))))))) ((equal? arg-16 "Quote") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-85 (cdr arg-17))) (if (null? e-85) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-87 (car e-85))) (let ((e-88 (cdr e-85))) (lambda (clam-8) (if (null? e-88) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-87) clam-8))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-14))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearDefs e-6 clam-8))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-14 arg-0 e-7 arg-8 e-5 clam-8))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45Unelab-unelabUniqueBinders arg-0 arg-14 arg-8 e-8 clam-8))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1951) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-9) clam-8))))))))))))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-8))))))))) ((equal? arg-16 "Lambda") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-91 (car arg-17))) (let ((e-92 (cdr arg-17))) (if (null? e-92) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-94 (car e-92))) (let ((e-95 (cdr e-92))) (if (null? e-95) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-97 (car e-95))) (let ((e-98 (cdr e-95))) (lambda (clam-9) (if (null? e-98) (let ((act-24 (CoreC-45Context-clearDefs arg-15 clam-9))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-97) clam-9))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (case (vector-ref e-6 0) ((0) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (case (vector-ref e-3 0) ((0) (let ((e-10 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-26 (CoreC-45UnifyState-genVarName arg-14 arg-12 "x" clam-9))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (((e-4 arg-15) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-withAll) arg-8 (vector 1 e-1 (vector 0 ) e-11))) clam-9))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-14 arg-0 e-5 arg-8 e-12 clam-9))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (let ((u--lamsc (CoreC-45TT-refToLocal e-11 e-2 e-13))) (let ((act-29 (TTImpC-45ElabC-45RunElab-n--10723-3259-u--quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-94 e-91 e-97 arg-15 e-8 clam-9))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-14 arg-0 e-5 arg-8 e-9 clam-9))) (case (vector-ref act-30 0) ((0) (let ((e-15 (vector-ref act-30 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-30 1))) (let ((u--envC-39 (cons (vector 0 e-10 e-7 e-14 e-15) arg-8))) (let ((act-31 (let ((act-31 ((CoreC-45NormaliseC-45Eval-nf arg-14 (cons e-2 arg-0) arg-15 u--envC-39 u--lamsc) clam-9))) (case (vector-ref act-31 0) ((0) (let ((e-16 (vector-ref act-31 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-31 1))) (TTImpC-45ElabC-45RunElab-elabScript (cons e-2 arg-0) arg-14 arg-13 arg-12 arg-11 arg-10 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames arg-9) u--envC-39 e-16 '() clam-9))))))) (case (vector-ref act-31 0) ((0) (let ((e-16 (vector-ref act-31 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-31 1))) (let ((act-32 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-14 (cons e-2 arg-0) e-5 u--envC-39 e-16 clam-9))) (case (vector-ref act-32 0) ((0) (let ((e-17 (vector-ref act-32 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-32 1))) ((CoreC-45NormaliseC-45Eval-nf arg-14 arg-0 e-5 arg-8 (vector 3 e-1 e-2 (vector 0 e-10 e-7 e-14 e-15) e-17)) clam-9))))))))))))))))))))))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 "Not a lambda") clam-9))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 "Not a lambda") clam-9)))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-9))))))))))))) ((equal? arg-16 "Goal") (if (null? arg-17) (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (lambda (clam-0) (if (null? arg-7) (let ((act-24 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (csegen-1951) arg-0 arg-10 arg-15 0 arg-8 '()) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45NormaliseC-45Eval-nfOpts arg-14 arg-0 (CoreC-45Value-withAll) arg-15 arg-8 e-5) clam-0))))) (let ((e-1 (unbox arg-7))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm e-1) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45Unelab-unelabUniqueBinders arg-0 arg-14 arg-8 e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (csegen-1951) eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (box (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-6)) clam-0))))))))))))) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)))) ((equal? arg-16 "LocalVars") (lambda (clam-10) (if (null? arg-17) (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1953) arg-0 clam-10) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-10)))) ((equal? arg-16 "GenSym") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-103 (car arg-17))) (let ((e-104 (cdr arg-17))) (lambda (clam-11) (if (null? e-104) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-103) clam-11))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45Reflect-u--reify_Reify_String arg-14 arg-0 arg-15 e-5) clam-11))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45UnifyState-genVarName arg-14 arg-12 e-6 clam-11))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1920) e-6 clam-11))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-11))))))) ((equal? arg-16 "InCurrentNS") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-107 (car arg-17))) (let ((e-108 (cdr arg-17))) (lambda (clam-12) (if (null? e-108) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-107) clam-12))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45Reflect-u--reify_Reify_Name arg-14 arg-0 arg-15 e-5) clam-12))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Context-inCurrentNS arg-14 e-6 clam-12))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1920) e-6 clam-12))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-12))))))) ((equal? arg-16 "GetType") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-111 (car arg-17))) (let ((e-112 (cdr arg-17))) (lambda (clam-13) (if (null? e-112) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-111) clam-13))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45Reflect-u--reify_Reify_Name arg-14 arg-0 arg-15 e-5) clam-13))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Context-lookupTyName e-6 (let ((e-0 (vector-ref arg-15 0))) e-0) clam-13))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10723-3667-u--unelabType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-111 arg-15 eta-0)) e-6 '() clam-13)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1920) (csegen-1951)) eta-6 eta-7 eta-8 eta-9 eta-10 eta-11 eta-12)))))))) eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) e-7 clam-13))))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-13))))))) ((equal? arg-16 "GetLocalType") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-115 (car arg-17))) (let ((e-116 (cdr arg-17))) (lambda (clam-14) (if (null? e-116) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-115) clam-14))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reify_Reify_Name arg-14 arg-0 arg-15 e-5) clam-14))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (let ((sc5 (CoreC-45Env-defined arg-0 e-6 arg-8))) (if (null? sc5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) " is not a local variable")) clam-14) (let ((e-1 (unbox sc5))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) " is not a local variable")) clam-14) (let ((e-4 (car e-1))) (let ((u--binder (CoreC-45Env-getBinder (csegen-764) arg-0 e-4 arg-8))) (let ((u--bty (CoreC-45TT-binderType u--binder))) (let ((act-26 (TTImpC-45Unelab-unelabUniqueBinders arg-0 arg-14 arg-8 u--bty clam-14))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-26 1))) (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1951) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-8) clam-14))))))))))))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-14))))))) ((equal? arg-16 "GetCons") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-119 (car arg-17))) (let ((e-120 (cdr arg-17))) (lambda (clam-15) (if (null? e-120) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-119) clam-15))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reify_Reify_Name arg-14 arg-0 arg-15 e-5) clam-15))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-lookupDefExact e-6 (let ((e-0 (vector-ref arg-15 0))) e-0) clam-15))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) " is not a type")) clam-15) (let ((e-1 (unbox e-7))) (case (vector-ref e-1 0) ((6) (let ((e-8 (vector-ref e-1 7))) (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1953) e-8 clam-15)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) " is not a type")) clam-15)))))))))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-15))))))) ((equal? arg-16 "Declare") (if (null? arg-17) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0)) (let ((e-123 (car arg-17))) (let ((e-124 (cdr arg-17))) (lambda (clam-16) (if (null? e-124) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-123) clam-16))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_ImpDecl eta-0 eta-1 eta-2 eta-3 eta-4)))))) arg-14 arg-0 arg-15 e-5) clam-16))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl '() arg-14 arg-13 arg-12 arg-11 '() '() '() eta-0)) e-6 clam-16))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--10692-2380-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (csegen-1950) 0 clam-16)))))))))))) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) clam-16)))))))(else (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "unexpected Elab constructor " (PreludeC-45TypesC-45String-C-43C-43 arg-16 (PreludeC-45TypesC-45String-C-43C-43 ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-17))))) eta-0))))))
(define TTImpC-45ElabC-45RunElab-elabScript (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-8 0) ((2) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-1 (csegen-46) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((u--script (vector 2 e-1 e-2 e-3 e-4 e-5))) (case (vector-ref e-7 0) ((0) (let ((e-0 (vector-ref e-7 1))) (let ((e-8 (vector-ref e-7 2))) (case (vector-ref e-8 0) ((1) (let ((e-9 (vector-ref e-8 1))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 1))) (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-0 (CoreC-45NameC-45Namespace-reflectionNS)))) (cond ((equal? sc6 1) ((TTImpC-45ElabC-45RunElab-n--10692-2381-u--elabCon arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 e-10 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) ext-0)) (else (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 (PreludeC-45TypesC-45String-C-43C-43 "bad reflection namespace " (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0)) ext-0))))))(else (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 (PreludeC-45TypesC-45String-C-43C-43 "bad fullnames " (CoreC-45Name-u--show_Show_Name e-7)) ext-0)))))(else (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 (PreludeC-45TypesC-45String-C-43C-43 "bad fullnames " (CoreC-45Name-u--show_Show_Name e-7)) ext-0))))))(else (TTImpC-45ElabC-45RunElab-n--10692-2379-u--failWith arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 (PreludeC-45TypesC-45String-C-43C-43 "bad fullnames " (CoreC-45Name-u--show_Show_Name e-7)) ext-0))))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-6 arg-7 arg-8 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 46 arg-0 arg-5 arg-7 e-7 "script is not a data value") ext-0)))))))))))))))))
(define TTImpC-45ElabC-45RunElab-checkRunElab (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-24 (TTImpC-45ElabC-45RunElab-n--12844-4332-u--mkExpected arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-12 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((sc2 (CoreC-45Context-isExtension 0 e-6))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 "%language ElabReflection not enabled") ext-0)))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((u--n (csegen-1958))) (let ((act-27 (CoreC-45Reflect-appCon arg-0 arg-10 e-6 u--n (cons e-5 '()) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-0) 1) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-8))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((act-29 (let ((act-29 (unbox arg-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 ((CoreC-45NormaliseC-45Eval-nfOpts arg-1 arg-0 (CoreC-45Value-withAll) e-10 arg-9 e-2) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-1 arg-2 arg-3 arg-5 arg-10 arg-8 arg-9 e-11 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-5)) ext-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Context-clearDefs e-12 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-13 arg-9 e-11 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-33 1))) (vector 1 (cons e-14 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-5))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (vector 0 e-1 (arg-2 e-2))))) ((1) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (let ((e-8 (vector-ref arg-3 5))) (let ((e-9 (vector-ref arg-3 6))) (vector 1 e-4 e-5 (CoreC-45TT-u--map_Functor_PiInfo (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-6) e-7 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-8) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-9))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (let ((e-15 (vector-ref arg-3 5))) (let ((e-16 (vector-ref arg-3 6))) (vector 2 e-11 e-12 (CoreC-45TT-u--map_Functor_PiInfo (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-13) e-14 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-15) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-16))))))))) ((3) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (let ((e-21 (vector-ref arg-3 4))) (let ((e-22 (vector-ref arg-3 5))) (let ((e-23 (vector-ref arg-3 6))) (let ((e-24 (vector-ref arg-3 7))) (vector 3 e-18 e-19 e-20 e-21 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-22) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-23) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-24)))))))))) ((4) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (vector 4 e-26 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-27) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-28) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpClauseC-39 arg-2 eta-0)) e-29))))))) ((5) (let ((e-31 (vector-ref arg-3 1))) (let ((e-32 (vector-ref arg-3 2))) (let ((e-33 (vector-ref arg-3 3))) (vector 5 e-31 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-32) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-33)))))) ((6) (let ((e-35 (vector-ref arg-3 1))) (let ((e-36 (vector-ref arg-3 2))) (let ((e-37 (vector-ref arg-3 3))) (let ((e-38 (vector-ref arg-3 4))) (let ((e-39 (vector-ref arg-3 5))) (vector 6 e-35 e-36 e-37 e-38 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-39)))))))) ((7) (let ((e-41 (vector-ref arg-3 1))) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (vector 7 e-41 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_IFieldUpdateC-39 arg-2 eta-0)) e-42) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-43)))))) ((8) (let ((e-45 (vector-ref arg-3 1))) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (vector 8 e-45 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-46) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-47)))))) ((9) (let ((e-49 (vector-ref arg-3 1))) (let ((e-50 (vector-ref arg-3 2))) (let ((e-51 (vector-ref arg-3 3))) (vector 9 e-49 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-50) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-51)))))) ((10) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (let ((e-55 (vector-ref arg-3 3))) (let ((e-56 (vector-ref arg-3 4))) (vector 10 e-53 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-54) e-55 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-56))))))) ((11) (let ((e-58 (vector-ref arg-3 1))) (let ((e-59 (vector-ref arg-3 2))) (let ((e-60 (vector-ref arg-3 3))) (vector 11 e-58 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-59) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-60)))))) ((12) (let ((e-62 (vector-ref arg-3 1))) (let ((e-63 (vector-ref arg-3 2))) (vector 12 e-62 e-63)))) ((13) (let ((e-65 (vector-ref arg-3 1))) (let ((e-66 (vector-ref arg-3 2))) (let ((e-67 (vector-ref arg-3 3))) (vector 13 e-65 (TTImpC-45TTImpC-45Functor-u--map_Functor_AltTypeC-39 arg-2 e-66) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-67)))))) ((14) (let ((e-69 (vector-ref arg-3 1))) (let ((e-70 (vector-ref arg-3 2))) (let ((e-71 (vector-ref arg-3 3))) (vector 14 e-69 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-70) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-71)))))) ((15) (let ((e-73 (vector-ref arg-3 1))) (let ((e-74 (vector-ref arg-3 2))) (vector 15 e-73 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-74))))) ((16) (let ((e-76 (vector-ref arg-3 1))) (let ((e-77 (vector-ref arg-3 2))) (let ((e-78 (vector-ref arg-3 3))) (vector 16 e-76 e-77 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-78)))))) ((17) (let ((e-80 (vector-ref arg-3 1))) (let ((e-81 (vector-ref arg-3 2))) (vector 17 e-80 e-81)))) ((18) (let ((e-83 (vector-ref arg-3 1))) (let ((e-84 (vector-ref arg-3 2))) (let ((e-85 (vector-ref arg-3 3))) (let ((e-86 (vector-ref arg-3 4))) (let ((e-87 (vector-ref arg-3 5))) (vector 18 e-83 e-84 e-85 e-86 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-87)))))))) ((19) (let ((e-89 (vector-ref arg-3 1))) (let ((e-90 (vector-ref arg-3 2))) (let ((e-91 (vector-ref arg-3 3))) (vector 19 e-89 e-90 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-91)))))) ((20) (let ((e-93 (vector-ref arg-3 1))) (let ((e-94 (vector-ref arg-3 2))) (let ((e-95 (vector-ref arg-3 3))) (vector 20 e-93 e-94 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-95)))))) ((21) (let ((e-97 (vector-ref arg-3 1))) (let ((e-98 (vector-ref arg-3 2))) (vector 21 e-97 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-98))))) ((22) (let ((e-100 (vector-ref arg-3 1))) (let ((e-101 (vector-ref arg-3 2))) (vector 22 e-100 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-101))))) ((23) (let ((e-103 (vector-ref arg-3 1))) (let ((e-104 (vector-ref arg-3 2))) (vector 23 e-103 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-104))))) ((24) (let ((e-106 (vector-ref arg-3 1))) (let ((e-107 (vector-ref arg-3 2))) (vector 24 e-106 e-107)))) ((25) (let ((e-109 (vector-ref arg-3 1))) (let ((e-110 (vector-ref arg-3 2))) (vector 25 e-109 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-110))))) ((26) (let ((e-112 (vector-ref arg-3 1))) (let ((e-113 (vector-ref arg-3 2))) (vector 26 e-112 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-113))))) ((27) (let ((e-115 (vector-ref arg-3 1))) (let ((e-116 (vector-ref arg-3 2))) (vector 27 e-115 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-116))))) ((28) (let ((e-118 (vector-ref arg-3 1))) (let ((e-119 (vector-ref arg-3 2))) (vector 28 e-118 e-119)))) ((29) (let ((e-121 (vector-ref arg-3 1))) (vector 29 e-121))) ((30) (let ((e-123 (vector-ref arg-3 1))) (let ((e-124 (vector-ref arg-3 2))) (vector 30 e-123 e-124)))) ((31) (let ((e-126 (vector-ref arg-3 1))) (let ((e-127 (vector-ref arg-3 2))) (let ((e-128 (vector-ref arg-3 3))) (vector 31 e-126 e-127 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-128)))))) ((32) (let ((e-130 (vector-ref arg-3 1))) (let ((e-131 (vector-ref arg-3 2))) (vector 32 e-130 e-131)))) (else (let ((e-133 (vector-ref arg-3 1))) (let ((e-134 (vector-ref arg-3 2))) (let ((e-135 (vector-ref arg-3 3))) (vector 33 e-133 e-134 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-135)))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpTyC-39 (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (vector e-1 e-2 e-3 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-4))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpRecordC-39 (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (vector e-1 e-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpParameterC-39 arg-2 eta-0)) e-3) e-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_IFieldC-39 arg-2 eta-0)) e-5)))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpParameterC-39 (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons (CoreC-45TT-u--map_Functor_PiInfo (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-10) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-11))))))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (vector 0 e-1 e-2 e-3 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_FnOptC-39 arg-2 eta-0)) e-4) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpTyC-39 arg-2 e-5)))))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (vector 1 e-7 e-8 (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDataC-39 arg-2 e-9)))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (vector 2 e-11 e-12 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpClauseC-39 arg-2 eta-0)) e-13)))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (vector 3 e-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpParameterC-39 arg-2 eta-0)) e-16) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-17)))))) ((4) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (vector 4 e-19 e-20 e-21 (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpRecordC-39 arg-2 e-22))))))) ((5) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (vector 5 e-24 e-25 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-26)))))) ((6) (let ((e-28 (vector-ref arg-3 1))) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (let ((e-31 (vector-ref arg-3 4))) (vector 6 e-28 e-29 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-30) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-31))))))) ((7) (let ((e-33 (vector-ref arg-3 1))) (let ((e-34 (vector-ref arg-3 2))) (vector 7 e-33 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-34))))) ((8) (let ((e-36 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (vector 8 e-36 (lambda (vars-18047) (e-37 vars-18047)))))) ((9) (let ((e-39 (vector-ref arg-3 1))) (vector 9 e-39))) (else (let ((e-41 (vector-ref arg-3 1))) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (vector 10 e-41 e-42 e-43))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDataC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (vector 0 e-1 e-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-3) e-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpTyC-39 arg-2 eta-0)) e-5)))))))) (else (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (vector 1 e-7 e-8 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-9)))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpClauseC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (vector 0 e-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-2) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-3)))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (let ((e-9 (vector-ref arg-3 5))) (let ((e-10 (vector-ref arg-3 6))) (vector 1 e-5 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-6) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-7) e-8 e-9 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpClauseC-39 arg-2 eta-0)) e-10))))))))) (else (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (vector 2 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-13))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_IFieldUpdateC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (vector 0 e-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-2))))) (else (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (vector 1 e-4 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-5))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_IFieldC-39 (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (vector e-1 e-2 (CoreC-45TT-u--map_Functor_PiInfo (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-3) e-4 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-5)))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_FnOptC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 0 )) ((1) (vector 1 )) ((2) (let ((e-3 (vector-ref arg-3 1))) (vector 2 e-3))) ((3) (let ((e-5 (vector-ref arg-3 1))) (vector 3 e-5))) ((4) (vector 4 )) ((5) (let ((e-8 (vector-ref arg-3 1))) (vector 5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-8)))) ((6) (vector 6 )) ((7) (let ((e-11 (vector-ref arg-3 1))) (vector 7 e-11))) ((8) (vector 8 )) (else (let ((e-14 (vector-ref arg-3 1))) (vector 9 e-14))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_AltTypeC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 0 )) ((1) (vector 1 )) (else (let ((e-3 (vector-ref arg-3 1))) (vector 2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-3)))))))
(define TTImpC-45ElabC-45Delayed-n--8679-8263-u--newBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) arg-6)(else (vector 0 (CoreC-45TT-binderLoc arg-6) (CoreC-45TT-multiplicity arg-6) (vector 1 ) (CoreC-45TT-binderType arg-6))))))
(define TTImpC-45ElabC-45Delayed-n--9709-9115-u--mkExpected (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (if (null? arg-11) (let ((act-24 (CoreC-45UnifyState-genName arg-10 arg-8 "delayTy" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-10 arg-8 arg-6 (csegen-21) arg-4 e-5 (vector 11 arg-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 e-6)))))))))) (let ((e-1 (unbox arg-11))) (vector 1 e-1)))))
(define TTImpC-45ElabC-45Delayed-n--8935-8475-u--mkExpected (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (if (null? arg-12) (let ((act-24 (CoreC-45UnifyState-genName arg-11 arg-9 "delayTy" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-11 arg-9 arg-7 (csegen-21) arg-5 e-5 (vector 11 arg-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 e-6)))))))))) (let ((e-1 (unbox arg-12))) (vector 1 e-1)))))
(define TTImpC-45ElabC-45Delayed-n--12184-11281-u--hasPri (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9) (let ((e-2 (car arg-9))) (arg-3 e-2))))
(define TTImpC-45ElabC-45Delayed-n--11280-10531-u--better (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (case (vector-ref arg-15 0) ((47) arg-14)(else (case (vector-ref arg-14 0) ((47) arg-15)(else arg-14))))))
(define TTImpC-45ElabC-45Delayed-u--show_Show_RetryError (lambda (arg-0) (cond ((equal? arg-0 0) "RecoverableErrors") (else "AllErrors"))))
(define TTImpC-45ElabC-45Delayed-runDelays (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--olddelayed (let ((e-10 (vector-ref e-5 10))) e-10))) (let ((act-25 (let ((act-25 (set-box! arg-4 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 e-8 e-9 '() e-11))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (arg-7 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-4))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-2 "elab.delay" (+ 1 (+ 1 0)) (lambda () "Rerunning delayed in elaborator") ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (TTImpC-45ElabC-45Check-handle arg-1 arg-2 arg-3 arg-4 arg-5 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-1 arg-2 arg-3 arg-4 arg-5 1 0 '() (PreludeC-45TypesC-45List-reverse (DataC-45List-filter (lambda (eta-1) (TTImpC-45ElabC-45Delayed-n--12184-11281-u--hasPri arg-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 eta-1)) (let ((e-10 (vector-ref e-8 10))) e-10)))) eta-0)) (lambda (u--err) (lambda (eta-0) (let ((act-29 (let ((act-29 (set-box! arg-4 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-16 (vector-ref e-8 5))) (let ((e-15 (vector-ref e-8 6))) (let ((e-14 (vector-ref e-8 7))) (let ((e-13 (vector-ref e-8 8))) (let ((e-12 (vector-ref e-8 9))) (let ((e-11 (vector-ref e-8 11))) (vector e-0 e-1 e-2 e-3 e-4 e-16 e-15 e-14 e-13 e-12 u--olddelayed e-11))))))))))))))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0)))))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (let ((act-30 (unbox arg-4))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (set-box! arg-4 (let ((e-0 (vector-ref e-11 0))) (let ((e-1 (vector-ref e-11 1))) (let ((e-2 (vector-ref e-11 2))) (let ((e-3 (vector-ref e-11 3))) (let ((e-4 (vector-ref e-11 4))) (let ((e-18 (vector-ref e-11 5))) (let ((e-17 (vector-ref e-11 6))) (let ((e-16 (vector-ref e-11 7))) (let ((e-15 (vector-ref e-11 8))) (let ((e-14 (vector-ref e-11 9))) (let ((e-13 (vector-ref e-11 10))) (let ((e-12 (vector-ref e-11 11))) (vector e-0 e-1 e-2 e-3 e-4 e-18 e-17 e-16 e-15 e-14 (PreludeC-45TypesC-45List-tailRecAppend e-13 u--olddelayed) e-12)))))))))))))))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (vector 1 e-7))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Delayed-retryDelayedC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 (cons arg-6 (PreludeC-45TypesC-45List-reverse arg-7)))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact (vector 8 e-10) (let ((e-0 (vector-ref e-5 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((u--d (cons e-6 (cons e-10 (cons e-14 e-15))))) (if (null? e-8) ((TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0) (let ((e-1 (unbox e-8))) (case (vector-ref e-1 0) ((11) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-0) (let ((act-26 (let ((act-26 (unbox arg-4))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (CoreC-45Context-getFullName arg-1 (vector 8 e-10) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-1 "elab.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (let ((e-18 (vector-ref e-9 10))) e-18)) (PreludeC-45TypesC-45String-C-43C-43 ": Retrying delayed hole " (CoreC-45Name-u--show_Show_Name e-12)))) eta-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (let ((act-28 (unbox arg-3))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (set-box! arg-3 (let ((e-0 (vector-ref e-13 0))) (let ((e-25 (vector-ref e-13 1))) (let ((e-24 (vector-ref e-13 2))) (let ((e-23 (vector-ref e-13 3))) (let ((e-4 (vector-ref e-13 4))) (let ((e-22 (vector-ref e-13 5))) (let ((e-21 (vector-ref e-13 6))) (let ((e-20 (vector-ref e-13 7))) (let ((e-19 (vector-ref e-13 8))) (let ((e-18 (vector-ref e-13 9))) (let ((e-16 (vector-ref e-13 11))) (vector e-0 e-25 e-24 e-23 e-4 e-22 e-21 e-20 e-19 e-18 '() e-16))))))))))))))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (let ((act-30 (unbox arg-1))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (set-box! arg-1 (let ((e-0 (vector-ref e-17 0))) (let ((e-46 (vector-ref e-17 1))) (let ((e-45 (vector-ref e-17 2))) (let ((e-44 (vector-ref e-17 3))) (let ((e-4 (vector-ref e-17 4))) (let ((e-43 (vector-ref e-17 5))) (let ((e-42 (vector-ref e-17 6))) (let ((e-41 (vector-ref e-17 7))) (let ((e-40 (vector-ref e-17 8))) (let ((e-39 (vector-ref e-17 9))) (let ((e-37 (vector-ref e-17 11))) (let ((e-36 (vector-ref e-17 12))) (let ((e-35 (vector-ref e-17 13))) (let ((e-34 (vector-ref e-17 14))) (let ((e-33 (vector-ref e-17 15))) (let ((e-32 (vector-ref e-17 16))) (let ((e-31 (vector-ref e-17 17))) (let ((e-18 (vector-ref e-17 18))) (let ((e-19 (vector-ref e-17 19))) (let ((e-20 (vector-ref e-17 20))) (let ((e-21 (vector-ref e-17 21))) (let ((e-22 (vector-ref e-17 22))) (let ((e-23 (vector-ref e-17 23))) (let ((e-24 (vector-ref e-17 24))) (let ((e-25 (vector-ref e-17 25))) (let ((e-26 (vector-ref e-17 26))) (let ((e-27 (vector-ref e-17 27))) (let ((e-28 (vector-ref e-17 28))) (let ((e-29 (vector-ref e-17 29))) (let ((e-30 (vector-ref e-17 30))) (vector e-0 e-46 e-45 e-44 e-4 e-43 e-42 e-41 e-40 e-39 e-14 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (e-15 eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-32 1))) (let ((act-33 (let ((act-33 (unbox arg-3))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-33 1))) (let ((u--dsC-39 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-reverse (let ((e-22 (vector-ref e-20 10))) e-22)) e-3))) (let ((act-34 (CoreC-45Context-updateDef arg-1 (vector 8 e-10) (lambda (eta-1) (box (vector 1 (vector '() 1 0) '() (vector 1 0 e-19) (vector 1 0 e-19) '()))) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((act-35 (CoreC-45ContextC-45Log-logTerm '() arg-1 "elab.update" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Resolved delayed hole " (PreludeC-45Show-u--show_Show_Int e-10))) e-19 eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((act-36 (CoreC-45Normalise-logTermNF '() arg-1 "elab.update" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Resolved delayed hole NF " (PreludeC-45Show-u--show_Show_Int e-10))) '() e-19 eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((act-37 (CoreC-45UnifyState-removeHole arg-3 e-10 eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else ((TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 arg-7 u--dsC-39) eta-0)))))))))))))))))))))))))))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-26 (let ((act-26 (CoreC-45Context-getFullName arg-1 (vector 8 e-10) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (CoreC-45ContextC-45Log-log arg-1 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45ElabC-45Delayed-u--show_Show_RetryError arg-5) (PreludeC-45TypesC-45String-C-43C-43 ":Error in " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-9) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (CoreC-45Core-u--show_Show_Error u--err)))))) eta-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (cond ((equal? arg-5 0) (let ((act-27 ((TTImpC-45ElabC-45Delayed-recoverable arg-1 u--err) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (let ((u--errmode 0)) (cond ((equal? e-12 1) ((TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 u--errmode arg-6 (cons u--d arg-7) e-3) eta-0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))))))))) (else (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-1) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() e-3) eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-1))))) (lambda (u--errC-39) (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (TTImpC-45ElabC-45Delayed-n--11280-10531-u--better arg-0 e-6 e-10 e-14 e-15 u--d e-3 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--err u--errC-39) eta-1))) eta-0)))))))) clam-0))(else ((TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Delayed-retryDelayed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 0 0 '() arg-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-26 (CoreC-45Unify-solveConstraints arg-1 arg-3 arg-5 0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (cond ((equal? e-2 1) (TTImpC-45ElabC-45Delayed-retryDelayed arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 ext-0)) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 1 0 '() e-3) ext-0)))))))))))))))))
(define TTImpC-45ElabC-45Delayed-recoverable (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (let ((e-5 (vector-ref arg-1 6))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--defs (let ((e-36 (vector-ref e-6 1))) (let ((e-35 (vector-ref e-6 2))) (let ((e-34 (vector-ref e-6 3))) (let ((e-33 (vector-ref e-6 4))) (let ((e-32 (vector-ref e-6 5))) (let ((e-31 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-2 e-36 e-35 e-34 e-33 e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Delayed-contra arg-0 e-0 u--defs e-7 e-8) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (vector 1 (cond ((equal? e-9 1) 0) (else 1))))))))))))))))))))))))))) ((2) (let ((e-6 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 3))) (let ((e-9 (vector-ref arg-1 4))) (let ((e-10 (vector-ref arg-1 5))) (let ((e-11 (vector-ref arg-1 6))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--defs (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-5 5))) (let ((e-36 (vector-ref e-5 6))) (let ((e-35 (vector-ref e-5 7))) (let ((e-34 (vector-ref e-5 8))) (let ((e-33 (vector-ref e-5 9))) (let ((e-32 (vector-ref e-5 10))) (let ((e-31 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (vector e-8 e-1 e-2 e-3 e-4 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-10) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-11) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Delayed-contra arg-0 e-6 u--defs e-12 e-13) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-27 1))) (vector 1 (cond ((equal? e-14 1) 0) (else 1))))))))))))))))))))))))))) ((7) (lambda (eta-0) (vector 1 0))) ((14) (lambda (eta-0) (vector 1 0))) ((62) (let ((e-20 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-20))) ((63) (let ((e-23 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-23))) ((64) (let ((e-26 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-26))) ((65) (let ((e-29 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-29))) ((5) (let ((e-36 (vector-ref arg-1 7))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-36)))(else (lambda (eta-0) (vector 1 1))))))
(define TTImpC-45ElabC-45Delayed-mkClosedElab (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) (lambda (clam-0) (let ((act-24 (arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (vector 1 e-2))))))) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (TTImpC-45ElabC-45Delayed-mkClosedElab e-3 arg-1 e-9 (lambda (eta-0) (let ((act-24 (arg-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-6 (car e-5))) (let ((u--bC-39 (TTImpC-45ElabC-45Delayed-n--8679-8263-u--newBinder e-2 e-3 e-9 e-8 arg-3 arg-1 e-8))) (vector 1 (cons (vector 3 arg-1 e-2 u--bC-39 e-6) (CoreC-45NormaliseC-45Eval-gErased arg-1))))))))))))))))))
(define TTImpC-45ElabC-45Delayed-mismatchNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-26 (vector-ref arg-4 2))) (let ((e-29 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-2 e-26))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-7 (car arg-409))) (let ((e-6 (cdr arg-409))) (cons (arg-405 e-7) (arg-407 e-6))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-7 (car arg-416))) (let ((e-6 (cdr arg-416))) (cons (arg-414 e-7) e-6)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-7 (car arg-419))) (let ((e-6 (cdr arg-419))) (cons e-7 (arg-417 e-6)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-5 e-29) clam-0)))))))(else (vector 1 0))))))) ((2) (let ((e-9 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((2) (let ((e-33 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-9 e-33))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-11 e-35) clam-1)))))))(else (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-2) (case (vector-ref arg-4 0) ((8) (let ((e-38 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-47C-61_Eq_Constant e-14 e-38))))(else (vector 1 0)))))) ((5) (let ((e-18 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((5) (let ((e-42 (vector-ref arg-4 3))) (TTImpC-45ElabC-45Delayed-mismatchNF arg-0 arg-1 arg-2 e-18 e-42)))(else (lambda (eta-0) (vector 1 0)))))) ((6) (let ((e-23 (vector-ref arg-3 4))) (lambda (clam-3) (case (vector-ref arg-4 0) ((6) (let ((e-47 (vector-ref arg-4 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-47) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ElabC-45Delayed-mismatchNF arg-0 arg-1 arg-2 e-5 e-6) clam-3)))))))))))(else (vector 1 0))))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ElabC-45Delayed-mismatch (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ElabC-45Delayed-mismatchNF arg-0 arg-1 arg-2 e-5 e-6) ext-0)))))))))))))
(define TTImpC-45ElabC-45Delayed-delayOnFailure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-3))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--nos (let ((e-13 (vector-ref e-6 5))) e-13))) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (arg-11 0) (lambda (u--err) (lambda (eta-0) (let ((act-26 (let ((act-26 (unbox arg-4))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (TTImpC-45ElabC-45Delayed-n--8935-8475-u--mkExpected arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-8 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((sc4 (arg-9 u--err))) (cond ((equal? sc4 1) (let ((act-28 (CoreC-45UnifyState-genName arg-1 arg-3 "delayed" eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-getTerm e-8) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) ((CoreC-45UnifyState-newDelayed arg-0 arg-3 arg-1 arg-5 (csegen-519) arg-7 e-9 e-10) eta-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((e-2 (car e-10))) (let ((e-3 (cdr e-10))) (let ((act-30 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.delay" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Postponing elaborator " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-9) (PreludeC-45TypesC-45String-C-43C-43 " at " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC arg-5) " for"))))) arg-7 e-8 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (CoreC-45ContextC-45Log-log arg-1 "elab.delay" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Due to error " (CoreC-45Core-u--show_Show_Error u--err))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (let ((act-32 (unbox arg-3))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (let ((act-33 (unbox arg-1))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (let ((act-34 (set-box! arg-3 (let ((e-0 (vector-ref e-13 0))) (let ((e-1 (vector-ref e-13 1))) (let ((e-23 (vector-ref e-13 2))) (let ((e-22 (vector-ref e-13 3))) (let ((e-4 (vector-ref e-13 4))) (let ((e-21 (vector-ref e-13 5))) (let ((e-20 (vector-ref e-13 6))) (let ((e-19 (vector-ref e-13 7))) (let ((e-18 (vector-ref e-13 8))) (let ((e-17 (vector-ref e-13 9))) (let ((e-16 (vector-ref e-13 10))) (let ((e-15 (vector-ref e-13 11))) (vector e-0 e-1 e-23 e-22 e-4 e-21 e-20 e-19 e-18 e-17 (cons (cons arg-10 (cons e-2 (cons (let ((e-44 (vector-ref e-14 10))) e-44) (TTImpC-45ElabC-45Delayed-mkClosedElab arg-0 arg-5 arg-7 (lambda (eta-1) (TTImpC-45ElabC-45Delayed-deeper arg-4 (lambda (eta-2) (let ((act-34 (let ((act-34 (unbox arg-3))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-24 (vector-ref act-34 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-34 1))) (let ((u--nosC-39 (let ((e-31 (vector-ref e-24 5))) e-31))) (let ((act-35 (let ((act-35 (set-box! arg-3 (let ((e-36 (vector-ref e-24 0))) (let ((e-35 (vector-ref e-24 1))) (let ((e-34 (vector-ref e-24 2))) (let ((e-33 (vector-ref e-24 3))) (let ((e-32 (vector-ref e-24 4))) (let ((e-30 (vector-ref e-24 6))) (let ((e-29 (vector-ref e-24 7))) (let ((e-28 (vector-ref e-24 8))) (let ((e-27 (vector-ref e-24 9))) (let ((e-26 (vector-ref e-24 10))) (let ((e-25 (vector-ref e-24 11))) (vector e-36 e-35 e-34 e-33 e-32 u--nos e-30 e-29 e-28 e-27 e-26 e-25))))))))))))))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-25 (vector-ref act-35 1))) (vector 0 e-25))) (else (let ((act-36 ((arg-11 1) eta-2))) (case (vector-ref act-36 0) ((0) (let ((e-26 (vector-ref act-36 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-36 1))) (let ((act-37 (let ((act-37 (unbox arg-3))) (vector 1 act-37)))) (case (vector-ref act-37 0) ((0) (let ((e-27 (vector-ref act-37 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-37 1))) (let ((act-38 (let ((act-38 (set-box! arg-3 (let ((e-39 (vector-ref e-27 0))) (let ((e-38 (vector-ref e-27 1))) (let ((e-37 (vector-ref e-27 2))) (let ((e-36 (vector-ref e-27 3))) (let ((e-35 (vector-ref e-27 4))) (let ((e-33 (vector-ref e-27 6))) (let ((e-32 (vector-ref e-27 7))) (let ((e-31 (vector-ref e-27 8))) (let ((e-30 (vector-ref e-27 9))) (let ((e-29 (vector-ref e-27 10))) (let ((e-28 (vector-ref e-27 11))) (vector e-39 e-38 e-37 e-36 e-35 u--nosC-39 e-33 e-32 e-31 e-30 e-29 e-28))))))))))))))) (vector 1 act-38)))) (case (vector-ref act-38 0) ((0) (let ((e-28 (vector-ref act-38 1))) (vector 0 e-28))) (else (vector 1 e-26))))))))))))))))))))) eta-1)))))) e-16) e-15)))))))))))))))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (vector 1 (cons e-3 e-8)))))))))))))))))))))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))))))))))))) ext-0)))))))))))
(define TTImpC-45ElabC-45Delayed-delayElab (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-3))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--nos (let ((e-13 (vector-ref e-6 5))) e-13))) (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "delayed" ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Delayed-n--9709-9115-u--mkExpected arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-8 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm e-8) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) ((CoreC-45UnifyState-newDelayed arg-0 arg-3 arg-1 arg-5 (csegen-519) arg-7 e-7 e-9) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-29 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.delay" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Postponing elaborator " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-7) " for"))) arg-7 e-8 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (let ((act-30 (unbox arg-3))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (set-box! arg-3 (let ((e-0 (vector-ref e-11 0))) (let ((e-1 (vector-ref e-11 1))) (let ((e-21 (vector-ref e-11 2))) (let ((e-20 (vector-ref e-11 3))) (let ((e-4 (vector-ref e-11 4))) (let ((e-19 (vector-ref e-11 5))) (let ((e-18 (vector-ref e-11 6))) (let ((e-17 (vector-ref e-11 7))) (let ((e-16 (vector-ref e-11 8))) (let ((e-15 (vector-ref e-11 9))) (let ((e-14 (vector-ref e-11 10))) (let ((e-13 (vector-ref e-11 11))) (vector e-0 e-1 e-21 e-20 e-4 e-19 e-18 e-17 e-16 e-15 (cons (cons arg-9 (cons e-2 (cons (let ((e-42 (vector-ref e-12 10))) e-42) (TTImpC-45ElabC-45Delayed-mkClosedElab arg-0 arg-5 arg-7 (lambda (eta-0) (let ((act-32 (let ((act-32 (unbox arg-3))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-22 (vector-ref act-32 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-32 1))) (let ((u--nosC-39 (let ((e-29 (vector-ref e-22 5))) e-29))) (let ((act-33 (let ((act-33 (set-box! arg-3 (let ((e-34 (vector-ref e-22 0))) (let ((e-33 (vector-ref e-22 1))) (let ((e-32 (vector-ref e-22 2))) (let ((e-31 (vector-ref e-22 3))) (let ((e-30 (vector-ref e-22 4))) (let ((e-28 (vector-ref e-22 6))) (let ((e-27 (vector-ref e-22 7))) (let ((e-26 (vector-ref e-22 8))) (let ((e-25 (vector-ref e-22 9))) (let ((e-24 (vector-ref e-22 10))) (let ((e-23 (vector-ref e-22 11))) (vector e-34 e-33 e-32 e-31 e-30 u--nos e-28 e-27 e-26 e-25 e-24 e-23))))))))))))))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-23 (vector-ref act-33 1))) (vector 0 e-23))) (else (let ((act-34 (arg-10 eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-24 (vector-ref act-34 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-34 1))) (let ((act-35 (let ((act-35 (unbox arg-3))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-25 (vector-ref act-35 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-35 1))) (let ((act-36 (let ((act-36 (set-box! arg-3 (let ((e-37 (vector-ref e-25 0))) (let ((e-36 (vector-ref e-25 1))) (let ((e-35 (vector-ref e-25 2))) (let ((e-34 (vector-ref e-25 3))) (let ((e-33 (vector-ref e-25 4))) (let ((e-31 (vector-ref e-25 6))) (let ((e-30 (vector-ref e-25 7))) (let ((e-29 (vector-ref e-25 8))) (let ((e-28 (vector-ref e-25 9))) (let ((e-27 (vector-ref e-25 10))) (let ((e-26 (vector-ref e-25 11))) (vector e-37 e-36 e-35 e-34 e-33 u--nosC-39 e-31 e-30 e-29 e-28 e-27 e-26))))))))))))))) (vector 1 act-36)))) (case (vector-ref act-36 0) ((0) (let ((e-26 (vector-ref act-36 1))) (vector 0 e-26))) (else (vector 1 e-24))))))))))))))))))))))))) e-14) e-13)))))))))))))))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (vector 1 (cons e-3 e-8))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Delayed-deeper (lambda (arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--d (let ((e-11 (vector-ref e-5 10))) e-11))) (let ((act-25 (let ((act-25 (set-box! arg-2 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-4 e-15 e-6 e-7 e-8 e-9 e-10 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) u--d) e-12 e-13 e-14))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (arg-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-2))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-2 (let ((e-1 (vector-ref e-8 0))) (let ((e-2 (vector-ref e-8 1))) (let ((e-3 (vector-ref e-8 2))) (let ((e-4 (vector-ref e-8 3))) (let ((e-18 (vector-ref e-8 4))) (let ((e-17 (vector-ref e-8 5))) (let ((e-16 (vector-ref e-8 6))) (let ((e-15 (vector-ref e-8 7))) (let ((e-9 (vector-ref e-8 8))) (let ((e-10 (vector-ref e-8 9))) (let ((e-12 (vector-ref e-8 11))) (let ((e-13 (vector-ref e-8 12))) (let ((e-14 (vector-ref e-8 13))) (vector e-1 e-2 e-3 e-4 e-18 e-17 e-16 e-15 e-9 e-10 u--d e-12 e-13 e-14))))))))))))))))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 e-7))))))))))))))))))))))
(define TTImpC-45ElabC-45Delayed-contra (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-17 (vector-ref arg-4 2))) (let ((e-20 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-2 e-17))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-7 (car arg-409))) (let ((e-6 (cdr arg-409))) (cons (arg-405 e-7) (arg-407 e-6))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-7 (car arg-416))) (let ((e-6 (cdr arg-416))) (cons (arg-414 e-7) e-6)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-7 (car arg-419))) (let ((e-6 (cdr arg-419))) (cons e-7 (arg-417 e-6)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-5 e-20) clam-0)))))))(else (vector 1 0))))))) ((2) (let ((e-9 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((2) (let ((e-24 (vector-ref arg-4 3))) (let ((e-26 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-9 e-24))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-11 e-26) clam-1))))))) ((8) (vector 1 1))(else (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-2) (case (vector-ref arg-4 0) ((8) (let ((e-32 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-47C-61_Eq_Constant e-14 e-32)))) ((2) (vector 1 1))(else (vector 1 0))))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ElabC-45Delayed-ambiguous (lambda (arg-0) (case (vector-ref arg-0 0) ((18) 1) ((17) 1) ((20) 1) ((62) (let ((e-11 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Delayed-ambiguous e-11))) ((63) (let ((e-14 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Delayed-ambiguous e-14))) ((64) (let ((e-17 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Delayed-ambiguous e-17))) ((65) (let ((e-20 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Delayed-ambiguous e-20))) ((5) (let ((e-27 (vector-ref arg-0 7))) (TTImpC-45ElabC-45Delayed-ambiguous e-27)))(else 0))))
(define TTImpC-45ElabC-45Check-case--checkExp-12971 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (clam-0) (let ((e-3 (vector-ref arg-11 3))) (case (vector-ref e-3 0) ((0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Solved") arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 (cons arg-3 arg-2)))))) ((1) (let ((e-4 (vector-ref e-3 1))) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Force") arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 (CoreC-45Normalise-logGlue arg-0 arg-10 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Got") arg-5 arg-2 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 (CoreC-45Normalise-logGlue arg-0 arg-10 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Exp") arg-5 arg-1 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (vector 1 (cons (vector 8 arg-4 e-4 arg-3) arg-1))))))))))))) (else (let ((e-4 (vector-ref e-3 1))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm arg-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Delay") arg-3 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (vector 1 (cons (vector 7 arg-4 e-4 e-5 arg-3) arg-1)))))))))))))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Not solved") arg-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-10))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearDefs e-6 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CoreC-45NormaliseC-45Eval-getTerm arg-1) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45UnifyState-newConstant arg-0 arg-9 arg-10 arg-4 arg-7 arg-5 arg-3 e-8 arg-12) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45UnifyState-dumpConstraints arg-9 arg-10 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) 0 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-3 (vector-ref arg-11 3))) (case (vector-ref e-3 0) ((0) (vector 1 (cons e-9 arg-2))) ((1) (let ((e-4 (vector-ref e-3 1))) (vector 1 (cons (vector 8 arg-4 e-4 arg-3) arg-1)))) (else (let ((e-4 (vector-ref e-3 1))) (let ((act-30 ((CoreC-45NormaliseC-45Eval-getTerm arg-2) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-11 (vector-ref act-30 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-30 1))) (vector 1 (cons (vector 7 arg-4 e-4 e-11 arg-3) arg-1)))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Check-case--exactlyOneC-39C-44getRight-11990 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 arg-12) (if (null? arg-12) (let ((sc1 (DataC-45List-filter (csegen-1959) arg-12))) (if (null? sc1) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-1 (car sc1))) (let ((e-2 (cdr sc1))) (if (null? e-1) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-6 (cdr e-1))) (if (null? e-2) (vector 1 e-6) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12))))))))) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? e-1) (let ((sc2 (DataC-45List-filter (csegen-1959) arg-12))) (if (null? sc2) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-4 (car sc2))) (let ((e-3 (cdr sc2))) (if (null? e-4) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-6 (cdr e-4))) (if (null? e-3) (vector 1 e-6) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12))))))))) (let ((e-6 (cdr e-1))) (if (null? e-2) (vector 1 e-6) (let ((sc3 (DataC-45List-filter (csegen-1959) arg-12))) (if (null? sc3) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (if (null? e-4) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-7 (cdr e-4))) (if (null? e-3) (vector 1 e-7) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-12)))))))))))))))))
(define TTImpC-45ElabC-45Check-case--caseC-32blockC-32inC-32searchVarC-44envHints-10659 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (if (null? arg-19) (lambda (eta-0) (vector 1 (cons arg-14 (cons arg-15 arg-16)))) (let ((e-1 (unbox arg-19))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-10 (cdr e-6))) (let ((u--nC-39 (PreludeC-45Types-maybe (lambda () arg-11) (lambda () (lambda (eta-0) eta-0)) e-5))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-10))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact u--nC-39 (let ((e-0 (vector-ref e-7 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (vector 1 (cons arg-14 (cons arg-15 arg-16))) (let ((e-2 (unbox e-8))) (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-17 (vector-ref e-2 17))) e-17))))) (let ((u--app ((e-10 arg-8) u--nt))) (let ((u--tyenv (TTImpC-45ElabC-45Check-n--12602-10238-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-0 (CoreC-45TT-getArgs u--app) (CoreC-45TT-embed (let ((e-28 (vector-ref e-2 2))) e-28))))) (let ((u--binder (vector 1 arg-8 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-mkSizeOf arg-14) u--app) (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-mkSizeOf arg-14) u--tyenv)))) (let ((act-26 (CoreC-45Context-toFullNames arg-10 (csegen-46) u--nC-39 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (cons (cons e-11 arg-14) (cons (lambda (u--t) (arg-15 (vector 3 arg-8 e-11 u--binder u--t))) (cons u--binder arg-16)))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Check-case--strengthenedEStateC-44removeArg-8904 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45ElabC-45Check-n--10980-8779-u--removeArgVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) (lambda (u--argsC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-2 (vector 1 (vector 0 ))) (lambda (u--fC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (CoreC-45TT-apply (CoreC-45TT-getLoc e-2) u--fC-39 u--argsC-39))))))))))
(define TTImpC-45ElabC-45Check-n--10798-8599-u--wknTms (lambda (arg-0 arg-1 arg-2 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-3 0) ((0) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (let ((e-6 (vector-ref e-3 3))) (let ((e-7 (vector-ref e-3 4))) (let ((e-8 (vector-ref e-3 5))) (cons e-2 (vector 0 (cons arg-0 e-4) e-5 (CoreC-45TT-u--map_Functor_PiInfo (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) e-6) (CoreC-45TT-u--weaken_Weaken_Term e-7) (CoreC-45TT-u--weaken_Weaken_Term e-8))))))))) (else (let ((e-9 (vector-ref e-3 1))) (let ((e-10 (vector-ref e-3 2))) (let ((e-11 (vector-ref e-3 3))) (let ((e-12 (vector-ref e-3 4))) (let ((e-13 (vector-ref e-3 5))) (let ((e-14 (vector-ref e-3 6))) (cons e-2 (vector 1 (cons arg-0 e-9) e-10 (CoreC-45TT-u--map_Functor_PiInfo (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) e-11) (CoreC-45TT-u--weaken_Weaken_Term e-12) (CoreC-45TT-u--weaken_Weaken_Term e-13) (CoreC-45TT-u--weaken_Weaken_Term e-14)))))))))))))))
(define TTImpC-45ElabC-45Check-n--12602-10238-u--useVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-12) arg-13 (let ((e-12 (car arg-12))) (let ((e-13 (cdr arg-12))) (case (vector-ref arg-13 0) ((3) (let ((e-15 (vector-ref arg-13 1))) (let ((e-16 (vector-ref arg-13 2))) (let ((e-17 (vector-ref arg-13 3))) (let ((e-18 (vector-ref arg-13 4))) (case (vector-ref e-17 0) ((2) (let ((e-20 (vector-ref e-17 1))) (let ((e-21 (vector-ref e-17 2))) (let ((e-23 (vector-ref e-17 4))) (vector 3 e-15 e-16 (vector 1 e-20 e-21 e-12 e-23) (TTImpC-45ElabC-45Check-n--12602-10238-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (cons e-16 arg-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) e-13) e-18))))))(else (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (TTImpC-45ElabC-45Check-n--12602-10238-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (cons e-2 arg-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) arg-12) e-4)))))))(else arg-13)))))))(else arg-13)))))))))(else (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (TTImpC-45ElabC-45Check-n--12602-10238-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (cons e-2 arg-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) arg-12) e-4)))))))(else arg-13)))))))(else arg-13)))))))))
(define TTImpC-45ElabC-45Check-n--10980-8781-u--strTms (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (lambda (clam-0) (case (vector-ref e-3 0) ((0) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (let ((e-6 (vector-ref e-3 3))) (let ((e-7 (vector-ref e-3 4))) (let ((e-8 (vector-ref e-3 5))) (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((sc5 (CoreC-45TT-shrinkPi e-6 (vector 1 (vector 0 ))))) (if (null? sc5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 28 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-8) clam-0) (let ((e-11 (unbox sc5))) (let ((sc6 (TTImpC-45ElabC-45Check-n--10980-8780-u--removeArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9))) (if (null? sc6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 28 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-8) clam-0) (let ((e-12 (unbox sc6))) (let ((sc7 (CoreC-45TT-shrinkTerm e-10 (vector 1 (vector 0 ))))) (if (null? sc7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 28 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-8) clam-0) (let ((e-13 (unbox sc7))) (vector 1 (cons e-2 (vector 0 arg-0 e-5 e-11 e-12 e-13)))))))))))))))))))))))))) (else (let ((e-9 (vector-ref e-3 1))) (let ((e-10 (vector-ref e-3 2))) (let ((e-11 (vector-ref e-3 3))) (let ((e-12 (vector-ref e-3 4))) (let ((e-13 (vector-ref e-3 5))) (let ((e-14 (vector-ref e-3 6))) (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-12 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-13 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-14 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc6 (CoreC-45TT-shrinkPi e-11 (vector 1 (vector 0 ))))) (if (null? sc6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 28 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-13) clam-0) (let ((e-8 (unbox sc6))) (let ((sc7 (CoreC-45TT-shrinkTerm e-5 (vector 1 (vector 0 ))))) (if (null? sc7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 28 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-13) clam-0) (let ((e-15 (unbox sc7))) (let ((sc8 (CoreC-45TT-shrinkTerm e-6 (vector 1 (vector 0 ))))) (if (null? sc8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 28 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-13) clam-0) (let ((e-17 (unbox sc8))) (let ((sc9 (CoreC-45TT-shrinkTerm e-7 (vector 1 (vector 0 ))))) (if (null? sc9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 28 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-13) clam-0) (let ((e-21 (unbox sc9))) (vector 1 (cons e-2 (vector 1 arg-0 e-10 e-8 e-15 e-17 e-21))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Check-n--10980-8779-u--removeArgVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (if (null? arg-7) (PreludeC-45Types-u--pure_Applicative_Maybe '()) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-8 (vector-ref e-2 3))) (cond ((equal? e-8 0) (TTImpC-45ElabC-45Check-n--10980-8779-u--removeArgVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))(else (let ((e-10 (- e-8 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45ElabC-45Check-n--10980-8779-u--removeArgVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) (lambda (u--argsC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons (vector 0 e-6 e-7 e-10) u--argsC-39)))))))))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkTerm e-2 (vector 1 (vector 0 ))) (lambda (u--aC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45ElabC-45Check-n--10980-8779-u--removeArgVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) (lambda (u--argsC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons u--aC-39 u--argsC-39)))))))))))))
(define TTImpC-45ElabC-45Check-n--10980-8780-u--removeArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (TTImpC-45ElabC-45Check-case--strengthenedEStateC-44removeArg-8904 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (CoreC-45TT-getFnArgs arg-7))))
(define TTImpC-45ElabC-45Check-n--9998-7868-u--insertAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) arg-7 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45DataC-45NameMap-insert e-6 e-7 (TTImpC-45ElabC-45Check-n--9998-7868-u--insertAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 arg-7)))))))))
(define TTImpC-45ElabC-45Check-n--14556-11974-u--getRight (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11) (TTImpC-45ElabC-45Check-case--exactlyOneC-39C-44getRight-11990 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 (DataC-45Either-rights arg-11))))
(define TTImpC-45ElabC-45Check-n--14556-11975-u--getRes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10) (let ((e-2 (car arg-10))) (let ((e-6 (car e-2))) e-6))))
(define TTImpC-45ElabC-45Check-n--14556-11976-u--getDepthError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((20) (box arg-9))(else '()))))
(define TTImpC-45ElabC-45Check-n--12602-10239-u--find (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13) (if (null? arg-13) '() (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-12 e-6))) (cond ((equal? sc2 1) (box e-7)) (else (let ((e-5 (car e-7))) (let ((e-4 (cdr e-7))) (if (null? e-5) (TTImpC-45ElabC-45Check-n--12602-10239-u--find arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 e-3) (let ((e-8 (unbox e-5))) (let ((u--t (cons (box e-8) e-4))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name arg-12 e-8))) (cond ((equal? sc5 1) (box u--t)) (else (TTImpC-45ElabC-45Check-n--12602-10239-u--find arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 e-3)))))))))))))))))))
(define TTImpC-45ElabC-45Check-n--12602-10240-u--envHints (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (if (null? arg-11) (vector 1 (cons '() (cons (lambda (eta-0) eta-0) arg-12))) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-24 (TTImpC-45ElabC-45Check-n--12602-10240-u--envHints arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3 arg-12 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((e-8 (car e-4))) (let ((e-7 (cdr e-4))) (let ((act-25 (CoreC-45Context-toFullNames arg-10 (csegen-46) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((_-0 (cons e-6 (cons e-8 e-7)))) ((TTImpC-45ElabC-45Check-case--caseC-32blockC-32inC-32searchVarC-44envHints-10659 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-3 arg-12 e-6 e-8 e-7 _-0 e-9 (TTImpC-45ElabC-45Check-n--12602-10239-u--find arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-9 arg-3)) ext-0)))))))))))))))))))
(define TTImpC-45ElabC-45Check-n--10980-8782-u--dropTop (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (cond ((equal? arg-7 0) '())(else (let ((e-4 (- arg-7 1))) (box e-4))))))
(define TTImpC-45ElabC-45Check-n--10980-8778-u--dropSub (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-9 ext-0) (case (vector-ref arg-9 0) ((1) (let ((e-3 (vector-ref arg-9 1))) (vector 1 e-3)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Badly formed weakened environment") ext-0)))))
(define TTImpC-45ElabC-45Check-n--14556-11977-u--depthError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-7 (cdr e-2))) (PreludeC-45Types-maybe (lambda () (TTImpC-45ElabC-45Check-n--14556-11977-u--depthError arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)) (lambda () (lambda (eta-0) (box eta-0))) (TTImpC-45ElabC-45Check-n--14556-11976-u--getDepthError arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-7))))))))
(define TTImpC-45ElabC-45Check-n--14556-11978-u--altError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11) (if (null? arg-11) (let ((sc1 (TTImpC-45ElabC-45Check-n--14556-11977-u--depthError arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10))) (if (null? sc1) (vector 21 arg-10) (let ((e-2 (unbox sc1))) e-2))) (vector 18 arg-0 arg-3 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Check-n--14556-11975-u--getRes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-0)) arg-11)))))
(define TTImpC-45ElabC-45Check-n--14037-11496-u--abandon (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((7) 1) ((62) (let ((e-4 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Check-n--14037-11496-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-4))) ((63) (let ((e-7 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Check-n--14037-11496-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7))) ((64) (let ((e-10 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Check-n--14037-11496-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-10))) ((65) (let ((e-13 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Check-n--14037-11496-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-13))) ((21) (let ((e-14 (vector-ref arg-10 1))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45Check-n--14037-11496-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (Builtin-snd eta-0))) e-14)))(else 0))))
(define TTImpC-45ElabC-45Check-u--show_Show_ElabMode (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "InType") ((1) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "InLHS " (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-0)))) ((2) "InExpr") (else "InTransform"))))
(define TTImpC-45ElabC-45Check-u--show_Show_C-40ImplBindingC-32C-36varsC-41 (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-0 u--d u--x)))) (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-0 u--d u--x))))) (cons e-3 e-4)))))) (else (let ((e-5 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-5 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-5 u--d u--x)))) (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-5 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-5 u--d u--x))))) (cons e-8 e-9)) (PreludeC-45TypesC-45String-C-43C-43 "@" (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-5 e-8))))))))))
(define TTImpC-45ElabC-45Check-u--showPrec_Show_C-40ImplBindingC-32C-36varsC-41 (lambda (arg-1 arg-2) (TTImpC-45ElabC-45Check-u--show_Show_C-40ImplBindingC-32C-36varsC-41 arg-2)))
(define TTImpC-45ElabC-45Check-u--C-61C-61_Eq_ElabOpt (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define TTImpC-45ElabC-45Check-u--C-47C-61_Eq_ElabOpt (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45ElabC-45Check-u--C-61C-61_Eq_ElabOpt arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45ElabC-45Check-weakenedEState (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "TTImp.Elab.Check.EST" ) (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 (vector 1 e-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Check-n--10798-8599-u--wknTms arg-0 arg-1 arg-2 eta-0)) e-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Check-n--10798-8599-u--wknTms arg-0 arg-1 arg-2 eta-0)) e-6) e-7 e-8 e-9 '() e-11 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) e-12) e-13 e-14)))))))))))))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 e-6)))))))))))
(define TTImpC-45ElabC-45Check-updateEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 4))) (let ((e-6 (vector-ref arg-5 5))) (let ((e-8 (vector-ref arg-5 7))) (let ((e-9 (vector-ref arg-5 8))) (let ((e-10 (vector-ref arg-5 9))) (let ((e-11 (vector-ref arg-5 10))) (let ((e-12 (vector-ref arg-5 11))) (let ((e-13 (vector-ref arg-5 12))) (let ((e-14 (vector-ref arg-5 13))) (vector arg-1 e-2 arg-2 arg-3 e-5 e-6 arg-4 e-8 e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))
(define TTImpC-45ElabC-45Check-tryError (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-5))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-3))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-branch arg-2 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-28 (arg-6 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-commit arg-2 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 (vector 1 e-9)))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-28 (let ((act-28 (set-box! arg-4 e-5))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (let ((act-29 (set-box! arg-5 e-6))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (let ((act-30 (set-box! arg-3 e-7))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (let ((act-31 (unbox arg-2))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (set-box! arg-2 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-38 (vector-ref e-8 5))) (let ((e-37 (vector-ref e-8 6))) (let ((e-36 (vector-ref e-8 7))) (let ((e-35 (vector-ref e-8 8))) (let ((e-34 (vector-ref e-8 9))) (let ((e-33 (vector-ref e-8 10))) (let ((e-32 (vector-ref e-8 11))) (let ((e-31 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (vector e-0 e-1 e-2 e-3 e-4 e-38 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 (let ((e-42 (vector-ref e-12 27))) e-42) e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (vector 1 (vector 0 u--err)))))))))))))))))))) ext-0)))))))))))))))))))
(define TTImpC-45ElabC-45Check-try (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (TTImpC-45ElabC-45Check-tryError arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (vector 1 e-2))) (else (arg-7 ext-0)))))))))
(define TTImpC-45ElabC-45Check-successful (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (vector 1 '()) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ncons (cond ((equal? arg-6 1) (PreludeC-45Types-u--fromInteger_Num_Nat 0)) (else (PreludeC-45TypesC-45List-length (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1))))))) (let ((act-25 (let ((act-25 (unbox arg-5))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-3))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-branch arg-2 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-28 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-28 ((PreludeC-45Types-maybe (lambda () (csegen-1960)) (lambda () (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-toFullNames arg-2 (csegen-46) eta-2 eta-3)))) e-6) eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Running " (CoreC-45Name-u--show_Show_Name e-11)))))))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (e-7 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (unbox arg-4))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-30 1))) (let ((u--nconsC-39 (cond ((equal? arg-6 1) (PreludeC-45Types-u--fromInteger_Num_Nat 0)) (else (PreludeC-45TypesC-45List-length (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-13 1))) e-1))))))) (let ((act-31 (let ((act-31 (unbox arg-5))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (unbox arg-3))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-32 1))) (let ((act-33 (let ((act-33 (unbox arg-2))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-33 1))) (let ((act-34 (let ((act-34 (set-box! arg-4 e-5))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((act-35 (let ((act-35 (set-box! arg-5 e-8))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((act-36 (let ((act-36 (set-box! arg-3 e-9))) (vector 1 act-36)))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((act-37 (let ((act-37 (set-box! arg-2 e-10))) (vector 1 act-37)))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (let ((act-38 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-38 ((PreludeC-45Types-maybe (lambda () (csegen-1960)) (lambda () (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-toFullNames arg-2 (csegen-46) eta-2 eta-3)))) e-6) eta-1))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-38 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Success " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-21) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat u--nconsC-39) (PreludeC-45TypesC-45String-C-43C-43 " - " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat u--ncons) ")")))))))))))) eta-0))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((act-39 ((TTImpC-45ElabC-45Check-successful arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-39 1))) (vector 1 (cons (vector 1 (cons (PreludeC-45Types-prim__integerToNat (- u--nconsC-39 u--ncons)) (cons e-12 (cons e-16 (cons e-13 (cons e-14 e-15)))))) e-22)))))))))))))))))))))))))))))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-28 (let ((act-28 (set-box! arg-4 e-5))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (let ((act-29 (set-box! arg-5 e-8))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (let ((act-30 (set-box! arg-3 e-9))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (let ((act-31 (set-box! arg-2 e-10))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (let ((sc10 (TTImpC-45ElabC-45Check-n--14037-11496-u--abandon arg-1 e-6 e-7 e-3 arg-6 arg-5 arg-4 arg-3 arg-2 u--err))) (cond ((equal? sc10 1) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0)) (else (vector 1 0)))))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 ((TTImpC-45ElabC-45Check-successful arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-33 1))) (vector 1 (cons (vector 0 (cons e-6 u--err)) e-16))))))))))))))))))))))) clam-0))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Check-strengthenedEState (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Check-n--10980-8778-u--dropSub arg-1 arg-0 arg-5 arg-4 arg-3 arg-2 (let ((e-4 (vector-ref e-5 3))) e-4) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45ElabC-45Check-n--10980-8781-u--strTms arg-1 arg-0 arg-5 arg-4 arg-3 arg-2 e-6 eta-0)) (let ((e-17 (vector-ref e-5 4))) e-17) '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45ElabC-45Check-n--10980-8781-u--strTms arg-1 arg-0 arg-5 arg-4 arg-3 arg-2 e-6 eta-0)) (let ((e-17 (vector-ref e-5 5))) e-17) '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-17 (vector-ref e-5 6))) (let ((e-16 (vector-ref e-5 7))) (let ((e-15 (vector-ref e-5 8))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-7 e-8 e-9 e-17 e-16 e-15 '() e-11 (DataC-45List-mapMaybe (lambda (eta-0) (TTImpC-45ElabC-45Check-n--10980-8782-u--dropTop arg-1 arg-0 arg-5 arg-4 arg-3 arg-2 eta-0)) e-12) e-13 e-14))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Check-searchVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Check-n--12602-10240-u--envHints arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (LibrariesC-45DataC-45NameMap-keys (let ((e-10 (vector-ref e-5 10))) e-10)) arg-7 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-26 ((CoreC-45UnifyState-newSearch (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7 arg-9 (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-mkSizeOf e-2) arg-10)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((e-4 (cdr e-9))) (vector 1 (e-8 e-4)))))))))))))))))))))
(define TTImpC-45ElabC-45Check-saveHole (lambda (arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-4 e-15 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert arg-2 0 e-13) e-14)))))))))))))))))) (vector 1 act-25))))))))
(define TTImpC-45ElabC-45Check-notePatVar (lambda (arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-4 e-15 e-6 e-7 e-8 (cons arg-2 e-9) e-10 e-11 e-12 e-13 e-14)))))))))))))))))) (vector 1 act-25))))))))
(define TTImpC-45ElabC-45Check-noteLHSPatVar (lambda (arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-2 0) ((1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-4 e-15 e-6 e-7 (cons arg-3 e-8) e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))))))) (vector 1 act-25)))))))(else (vector 1 0)))))
(define TTImpC-45ElabC-45Check-metaVarI (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--hinf (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 2))) (case (vector-ref e-2 0) ((2) (let ((sc4 (CoreC-45ContextC-45Context-holeInit 0))) (let ((e-0 (car sc4))) (cons e-0 1))))(else (CoreC-45ContextC-45Context-holeInit 0)))))(else (CoreC-45ContextC-45Context-holeInit 0))))) ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 7 (CoreC-45Env-length arg-5) u--hinf) 1) ext-0))))))))))))
(define TTImpC-45ElabC-45Check-metaVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 7 (CoreC-45Env-length arg-5) (CoreC-45ContextC-45Context-holeInit 0)) 1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-3 (cdr e-5))) (vector 1 e-3))))))))
(define TTImpC-45ElabC-45Check-isLHS (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else '()))))
(define TTImpC-45ElabC-45Check-initElabInfo (lambda (arg-0) (vector arg-0 (vector 3 ) 0 1 0 '())))
(define TTImpC-45ElabC-45Check-initEStateSub (lambda (arg-1 arg-2 arg-3 arg-4) (vector arg-1 arg-2 arg-3 arg-4 '() '() '() '() '() '() 0 '() (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45UserNameMap-empty))))
(define TTImpC-45ElabC-45Check-initEState (lambda (arg-0 arg-1 arg-2) (TTImpC-45ElabC-45Check-initEStateSub arg-0 arg-1 arg-2 (vector 0 ))))
(define TTImpC-45ElabC-45Check-inScope (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (TTImpC-45ElabC-45Check-weakenedEState arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((arg-7 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Check-strengthenedEState arg-1 arg-2 arg-3 e-5 arg-5 arg-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (set-box! arg-4 e-7))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-6))))))))))))))))))
(define TTImpC-45ElabC-45Check-implBindVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 7 (CoreC-45Env-length arg-5) (CoreC-45ContextC-45Context-holeInit 1)) 1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-3 (cdr e-5))) (vector 1 e-3))))))))
(define TTImpC-45ElabC-45Check-handle (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (TTImpC-45ElabC-45Check-tryError arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (vector 1 e-2))) (else (let ((e-6 (vector-ref e-5 1))) ((arg-7 e-6) ext-0))))))))))
(define TTImpC-45ElabC-45Check-exactlyOneC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45Check-successful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (TTImpC-45ElabC-45Check-n--14556-11974-u--getRight arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 1))) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((e-16 (car e-13))) (let ((e-17 (cdr e-13))) (let ((e-20 (car e-17))) (let ((e-21 (cdr e-17))) (let ((act-25 (let ((act-25 (set-box! arg-3 e-16))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (let ((act-26 (set-box! arg-4 e-20))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (let ((act-27 (set-box! arg-2 e-21))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 (let ((act-28 (set-box! arg-1 e-12))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((act-29 (CoreC-45Context-commit arg-1 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (vector 1 e-8)))))))))))))))))))))))))) (else (let ((e-6 (vector-ref sc2 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (TTImpC-45ElabC-45Check-n--14556-11978-u--altError arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45Either-lefts e-5) e-6) eta-0)))))))))) (let ((e-1 (car arg-8))) (let ((e-2 (cdr arg-8))) (if (null? e-1) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45Check-successful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (TTImpC-45ElabC-45Check-n--14556-11974-u--getRight arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5))) (case (vector-ref sc3 0) ((1) (let ((e-3 (vector-ref sc3 1))) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((e-16 (car e-13))) (let ((e-17 (cdr e-13))) (let ((e-20 (car e-17))) (let ((e-21 (cdr e-17))) (let ((act-25 (let ((act-25 (set-box! arg-3 e-16))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (let ((act-26 (set-box! arg-4 e-20))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (let ((act-27 (set-box! arg-2 e-21))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (let ((act-28 (set-box! arg-1 e-12))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CoreC-45Context-commit arg-1 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (vector 1 e-8)))))))))))))))))))))))))) (else (let ((e-6 (vector-ref sc3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (TTImpC-45ElabC-45Check-n--14556-11978-u--altError arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45Either-lefts e-5) e-6) eta-0)))))))))) (let ((e-6 (cdr e-1))) (if (null? e-2) e-6 (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45Check-successful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((sc4 (TTImpC-45ElabC-45Check-n--14556-11974-u--getRight arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7))) (case (vector-ref sc4 0) ((1) (let ((e-3 (vector-ref sc4 1))) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((e-16 (car e-13))) (let ((e-17 (cdr e-13))) (let ((e-20 (car e-17))) (let ((e-21 (cdr e-17))) (let ((act-25 (let ((act-25 (set-box! arg-3 e-16))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (let ((act-26 (set-box! arg-4 e-20))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (let ((act-27 (set-box! arg-2 e-21))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (let ((act-28 (set-box! arg-1 e-12))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CoreC-45Context-commit arg-1 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (vector 1 e-8)))))))))))))))))))))))))) (else (let ((e-8 (vector-ref sc4 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (TTImpC-45ElabC-45Check-n--14556-11978-u--altError arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45Either-lefts e-7) e-8) eta-0))))))))))))))))))
(define TTImpC-45ElabC-45Check-convertWithLazy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--umode (let ((e-0 (vector-ref arg-6 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))))) (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-24 (CoreC-45Context-isLazyActive arg-1 eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--lazy (cond ((equal? e-5 1) arg-4) (else 0)))) (let ((act-25 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Unifying " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Bool arg-4) (PreludeC-45TypesC-45String-C-43C-43 " " (TTImpC-45ElabC-45Check-u--show_Show_ElabMode (let ((e-0 (vector-ref arg-6 0))) e-0)))))) arg-7 arg-8 eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "....with") arg-7 arg-9 eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((sc3 (let ((sc4 (CoreC-45NormaliseC-45Eval-isFromTerm arg-8))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Eval-isFromTerm arg-9)) (else 0))))) (cond ((equal? sc3 1) (let ((act-27 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm arg-9) eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (cond ((equal? u--lazy 1) (((((CoreC-45Unify-unifyWithLazy (csegen-1962) arg-0 arg-1 arg-2 u--umode arg-5) arg-7) e-8) e-9) eta-1)) (else (((((CoreC-45Unify-unify (csegen-1962) arg-0 arg-1 arg-2 u--umode arg-5) arg-7) e-8) e-9) eta-1)))))))))))) (else (let ((act-27 ((CoreC-45NormaliseC-45Eval-getNF arg-1 arg-8) eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-getNF arg-1 arg-9) eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (cond ((equal? u--lazy 1) (((((CoreC-45Unify-unifyWithLazy (csegen-1965) arg-0 arg-1 arg-2 u--umode arg-5) arg-7) e-8) e-9) eta-1)) (else (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 u--umode arg-5) arg-7) e-8) e-9) eta-1)))))))))))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((sc4 (let ((e-1 (vector-ref e-8 1))) e-1))) (cond ((equal? sc4 1) (CoreC-45Unify-solveConstraints arg-1 arg-2 u--umode 0 eta-1)) (else (vector 1 0)))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 e-8)))))))))))))))))))) (lambda (u--err) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm arg-9) eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-2) (CoreC-45Unify-solveConstraints arg-1 arg-2 u--umode 0 eta-2)) (lambda (err-0) (lambda (eta-2) (vector 1 0))) eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (unbox arg-1))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 5 arg-0 arg-5 (let ((e-0 (vector-ref e-9 0))) e-0) arg-7 e-6 e-7 u--err) eta-1))))))))))))))))))))) eta-0)))))
(define TTImpC-45ElabC-45Check-convert (lambda (arg-0 arg-1 arg-2 arg-3 ext-0 ext-1 ext-2 ext-3 ext-4) (TTImpC-45ElabC-45Check-convertWithLazy arg-0 arg-1 arg-2 arg-3 0 ext-0 ext-1 ext-2 ext-3 ext-4)))
(define TTImpC-45ElabC-45Check-concrete (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-2 (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Check-concrete arg-1 arg-2 e-5) clam-0))))))(else (vector 1 0))))))) ((2) (vector 1 1)) ((3) (vector 1 1)) ((8) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0))))))
(define TTImpC-45ElabC-45Check-clearToBind (lambda (arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((sc1 (TTImpC-45ElabC-45Check-clearBindIfUnsolved e-5))) (let ((e-1 (vector-ref sc1 0))) (let ((e-2 (vector-ref sc1 1))) (let ((e-3 (vector-ref sc1 2))) (let ((e-4 (vector-ref sc1 3))) (let ((e-15 (vector-ref sc1 4))) (let ((e-6 (vector-ref sc1 5))) (let ((e-7 (vector-ref sc1 6))) (let ((e-8 (vector-ref sc1 7))) (let ((e-9 (vector-ref sc1 8))) (let ((e-10 (vector-ref sc1 9))) (let ((e-11 (vector-ref sc1 10))) (let ((e-12 (vector-ref sc1 11))) (let ((e-13 (vector-ref sc1 12))) (let ((e-14 (vector-ref sc1 13))) (vector e-1 e-2 e-3 e-4 e-15 (DataC-45List-filter (lambda (u--x) (PreludeC-45Types-elem (csegen-802) (Builtin-fst u--x) arg-2)) e-6) e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14))))))))))))))))))) (vector 1 act-25))))))))
(define TTImpC-45ElabC-45Check-clearBindIfUnsolved (lambda (ext-0) (let ((e-1 (vector-ref ext-0 0))) (let ((e-2 (vector-ref ext-0 1))) (let ((e-3 (vector-ref ext-0 2))) (let ((e-4 (vector-ref ext-0 3))) (let ((e-5 (vector-ref ext-0 4))) (let ((e-6 (vector-ref ext-0 5))) (let ((e-8 (vector-ref ext-0 7))) (let ((e-9 (vector-ref ext-0 8))) (let ((e-10 (vector-ref ext-0 9))) (let ((e-11 (vector-ref ext-0 10))) (let ((e-12 (vector-ref ext-0 11))) (let ((e-13 (vector-ref ext-0 12))) (let ((e-14 (vector-ref ext-0 13))) (vector e-1 e-2 e-3 e-4 e-5 e-6 '() e-8 e-9 e-10 e-11 e-12 e-13 e-14))))))))))))))))
(define TTImpC-45ElabC-45Check-checkExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (if (null? arg-10) (vector 1 (cons arg-8 arg-9)) (let ((e-1 (unbox arg-10))) (let ((act-24 ((TTImpC-45ElabC-45Check-convertWithLazy arg-0 arg-1 arg-2 arg-3 1 arg-7 arg-5 arg-6 arg-9 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Check-case--checkExp-12971 arg-0 e-1 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0)))))))))
(define TTImpC-45ElabC-45Check-bindingType (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 5))) e-4)) (else (let ((e-9 (vector-ref arg-1 5))) e-9)))))
(define TTImpC-45ElabC-45Check-bindingTerm (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 4))) e-3)) (else (let ((e-8 (vector-ref arg-1 4))) e-8)))))
(define TTImpC-45ElabC-45Check-bindingRig (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) e-1)) (else (let ((e-6 (vector-ref arg-1 2))) e-6)))))
(define TTImpC-45ElabC-45Check-bindingMetas (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 5))) (CoreC-45TT-getMetas e-4))) (else (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (let ((e-10 (vector-ref arg-1 6))) (TTImpC-45ElabC-45Check-n--9998-7868-u--insertAll e-5 e-10 e-9 e-8 e-7 e-6 (LibrariesC-45DataC-45NameMap-toList (CoreC-45TT-getMetas e-9)) (CoreC-45TT-getMetas e-10))))))))))))
(define TTImpC-45ElabC-45Check-argVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (CoreC-45UnifyState-newMetaLets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 7 (CoreC-45Env-length arg-5) (CoreC-45ContextC-45Context-holeInit 0)) 0 1)))
(define TTImpC-45ElabC-45Check-anyOne (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-5 "No elaborators provided") eta-0)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-7 (cdr e-2))) (if (null? e-3) e-7 (lambda (eta-0) (TTImpC-45ElabC-45Check-try arg-0 arg-1 arg-2 arg-3 arg-4 e-7 (TTImpC-45ElabC-45Check-anyOne arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) eta-0)))))))))
(define TTImpC-45ElabC-45Check-addBindIfUnsolved (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (let ((e-6 (vector-ref arg-7 5))) (let ((e-7 (vector-ref arg-7 6))) (let ((e-8 (vector-ref arg-7 7))) (let ((e-9 (vector-ref arg-7 8))) (let ((e-10 (vector-ref arg-7 9))) (let ((e-11 (vector-ref arg-7 10))) (let ((e-12 (vector-ref arg-7 11))) (let ((e-13 (vector-ref arg-7 12))) (let ((e-14 (vector-ref arg-7 13))) (vector e-1 e-2 e-3 e-4 e-5 e-6 (let ((u--st (vector e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14))) (cons (cons arg-1 (cons arg-2 (cons arg-0 (cons arg-4 (cons arg-3 (cons arg-5 (cons arg-6 (let ((e-25 (vector-ref u--st 3))) e-25)))))))) e-7)) e-8 e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))))))
(define IdrisC-45Syntax-n--8801-1275-u--showDirective (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "%hide name") ((1) "%logging [topic] lvl") ((2) "%auto_lazy on|off") ((3) "%unbound_implicits") ((4) "%ambiguity_depth n") ((5) "%pair ty f s") ((6) "%rewrite eq rw") ((7) "%integerLit n") ((8) "%stringLit n") ((9) "%charLit n") ((10) "%doubleLit n") ((11) "--directive d") ((12) "%name ty ns") ((13) "%start expr") ((14) "%allow_overloads") ((15) "%language") ((16) "%default partial|total|covering") ((17) "%prefix_record_projections on|off") ((18) "%auto_implicit_depth n") ((19) "%nf_metavar_threshold n") (else "%search_timeout ms"))))
(define IdrisC-45Syntax-n--10711-2754-u--showCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-2) (PreludeC-45TypesC-45String-C-43C-43 " => " (IdrisC-45Syntax-showPTerm arg-1 e-3)))))) ((1) " | <<with alts not possible>>") (else (let ((e-14 (vector-ref arg-6 2))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-14) " impossible"))))))
(define IdrisC-45Syntax-n--10711-2687-u--showAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (PreludeC-45TypesC-45String-C-43C-43 " | " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-2) (PreludeC-45TypesC-45String-C-43C-43 " => " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-3) ";"))))))) ((1) " | <<with alts not possible>>") (else (let ((e-14 (vector-ref arg-10 2))) (PreludeC-45TypesC-45String-C-43C-43 " | " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-14) " impossible;")))))))
(define IdrisC-45Syntax-n--8799-1183-u--ph(blodwen-lazy (lambda () (vector 1 (vector 0 "")))))
(define IdrisC-45Syntax-n--13363-4863-u--insertAll (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 ((CoreC-45Context-u--resolved_HasNames_Name arg-3 e-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((e-4 (cdr arg-1))) (((e-4 arg-3) e-7) clam-0)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) ((IdrisC-45Syntax-n--13363-4863-u--insertAll arg-1 arg-2 arg-3 (LibrariesC-45DataC-45ANameMap-addName e-5 e-8 arg-4) e-3) clam-0)))))))))))))))))
(define IdrisC-45Syntax-n--13362-4822-u--insertAll (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Name arg-3 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((e-1 (car arg-1))) (((e-1 arg-3) e-7) clam-0)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) ((IdrisC-45Syntax-n--13362-4822-u--insertAll arg-1 arg-2 arg-3 (LibrariesC-45DataC-45ANameMap-addName e-5 e-8 arg-4) e-3) clam-0)))))))))))))))))
(define IdrisC-45Syntax-n--13573-5004-u--initSaveDocStrings(blodwen-lazy (lambda () (LibrariesC-45DataC-45NameMap-empty))))
(define IdrisC-45Syntax-n--13573-5002-u--initPrefix(blodwen-lazy (lambda () (LibrariesC-45DataC-45StringMap-fromList (cons (cons "-" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))) (cons (cons "negate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))) '()))))))
(define IdrisC-45Syntax-n--13573-5001-u--initInfix(blodwen-lazy (lambda () (LibrariesC-45DataC-45StringMap-insert "=" (cons 2 0) (LibrariesC-45DataC-45StringMap-empty)))))
(define IdrisC-45Syntax-n--13573-5003-u--initDocStrings(blodwen-lazy (lambda () (LibrariesC-45DataC-45ANameMap-empty))))
(define IdrisC-45Syntax-n--13654-5095-u--goPiInfo (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 3 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-1) ext-0)))(else (vector 1 arg-2)))))
(define IdrisC-45Syntax-n--13654-5099-u--goPairedPTerms (lambda (arg-1 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (cons (cons e-6 e-5) eta-2))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-7) eta-0)) (IdrisC-45Syntax-n--13654-5099-u--goPairedPTerms arg-1 e-3) clam-0)))))))))
(define IdrisC-45Syntax-n--13654-5111-u--goPTypeDecls (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5092-u--goPTypeDecl arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5111-u--goPTypeDecls arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5092-u--goPTypeDecl (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-6 (vector-ref eta-0 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-5) ext-0))))))))
(define IdrisC-45Syntax-n--13654-5098-u--goPTerms (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-2) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5098-u--goPTerms arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5086-u--goPTerm (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (arg-1 arg-2)) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (let ((e-9 (vector-ref arg-2 6))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-2 (vector-ref eta-4 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref eta-4 1))) (vector 1 (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (vector 1 e-4 e-5 e-10 eta-5 eta-6 eta-7))))))))) (lambda (eta-4) (IdrisC-45Syntax-n--13654-5095-u--goPiInfo arg-1 e-6 eta-4)) eta-3)) (lambda (eta-3) (vector 1 e-7)) eta-2)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-8) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-9) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-24 1))) ((arg-1 e-10) eta-0))))))))))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (let ((e-15 (vector-ref arg-2 5))) (let ((e-16 (vector-ref arg-2 6))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-2 (vector-ref eta-4 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-4 1))) (vector 1 (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (vector 2 e-11 e-12 e-5 eta-5 eta-6 eta-7))))))))) (lambda (eta-4) (IdrisC-45Syntax-n--13654-5095-u--goPiInfo arg-1 e-13 eta-4)) eta-3)) (lambda (eta-3) (vector 1 e-14)) eta-2)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-15) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))))))) ((3) (let ((e-18 (vector-ref arg-2 1))) (let ((e-19 (vector-ref arg-2 2))) (let ((e-20 (vector-ref arg-2 3))) (let ((e-21 (vector-ref arg-2 4))) (let ((e-22 (vector-ref arg-2 5))) (let ((e-23 (vector-ref arg-2 6))) (let ((e-24 (vector-ref arg-2 7))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-5) (case (vector-ref eta-5 0) ((0) (let ((e-2 (vector-ref eta-5 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-5 1))) (vector 1 (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (vector 3 e-18 e-19 e-5 eta-6 eta-7 eta-8 eta-9)))))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-20) eta-4)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-21) eta-3)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-22) eta-2)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-23) eta-1)) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5105-u--goPClauses arg-1 e-24 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))))))) ((4) (let ((e-26 (vector-ref arg-2 1))) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 4 e-26 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-27) eta-1)) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5105-u--goPClauses arg-1 e-28 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((5) (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 5 e-30 e-5 eta-3))))))) (lambda (eta-2) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-31 eta-2)) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-32) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((6) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 6 e-34 e-5)))))) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5108-u--goPFieldUpdates arg-1 e-35 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((7) (let ((e-37 (vector-ref arg-2 1))) (let ((e-38 (vector-ref arg-2 2))) (let ((e-39 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 7 e-37 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-38) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-39) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((8) (let ((e-41 (vector-ref arg-2 1))) (let ((e-42 (vector-ref arg-2 2))) (let ((e-43 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 8 e-41 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-42) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-43) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((10) (let ((e-45 (vector-ref arg-2 1))) (let ((e-46 (vector-ref arg-2 2))) (let ((e-47 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 10 e-45 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-46) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-47) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((9) (let ((e-49 (vector-ref arg-2 1))) (let ((e-50 (vector-ref arg-2 2))) (let ((e-51 (vector-ref arg-2 3))) (let ((e-52 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 9 e-49 e-5 eta-4 eta-5)))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-50) eta-2)) (lambda (eta-2) (vector 1 e-51)) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-52) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))))) ((11) (let ((e-54 (vector-ref arg-2 1))) (let ((e-55 (vector-ref arg-2 2))) (let ((e-56 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 11 e-54 e-55 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-56) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((12) (let ((e-58 (vector-ref arg-2 1))) (let ((e-59 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 12 e-58 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-59) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((13) (let ((e-61 (vector-ref arg-2 1))) (let ((e-62 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 13 e-61 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-62) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((14) (arg-1 arg-2)) ((15) (arg-1 arg-2)) ((16) (let ((e-70 (vector-ref arg-2 1))) (let ((e-71 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 16 e-70 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-71) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((17) (arg-1 arg-2)) ((18) (let ((e-76 (vector-ref arg-2 1))) (let ((e-77 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 18 e-76 e-5)))))) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45Syntax-n--13654-5091-u--goPDecl arg-1 eta-2 eta-3))) e-77 '() eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((19) (let ((e-79 (vector-ref arg-2 1))) (let ((e-80 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 19 e-79 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-80) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((20) (let ((e-82 (vector-ref arg-2 1))) (let ((e-83 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 20 e-82 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-83) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((21) (arg-1 arg-2)) ((22) (arg-1 arg-2)) ((23) (let ((e-91 (vector-ref arg-2 1))) (let ((e-92 (vector-ref arg-2 2))) (let ((e-93 (vector-ref arg-2 3))) (let ((e-94 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 23 e-91 e-92 e-93 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-94) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))))) ((24) (let ((e-96 (vector-ref arg-2 1))) (let ((e-97 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 24 e-96 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-97) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((25) (arg-1 arg-2)) ((26) (arg-1 arg-2)) ((27) (let ((e-103 (vector-ref arg-2 1))) (let ((e-104 (vector-ref arg-2 2))) (let ((e-105 (vector-ref arg-2 3))) (let ((e-106 (vector-ref arg-2 4))) (let ((e-107 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 27 e-103 e-104 e-105 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-106) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-107) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))))) ((28) (let ((e-109 (vector-ref arg-2 1))) (let ((e-110 (vector-ref arg-2 2))) (let ((e-111 (vector-ref arg-2 3))) (let ((e-112 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 28 e-109 e-110 e-111 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-112) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))))) ((29) (let ((e-114 (vector-ref arg-2 1))) (let ((e-115 (vector-ref arg-2 2))) (let ((e-116 (vector-ref arg-2 3))) (let ((e-117 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 29 e-114 e-115 e-116 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-117) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))))) ((30) (let ((e-119 (vector-ref arg-2 1))) (let ((e-120 (vector-ref arg-2 2))) (let ((e-121 (vector-ref arg-2 3))) (let ((e-122 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 30 e-119 e-120 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-121) eta-1)) (lambda (eta-1) (vector 1 e-122)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))))) ((31) (let ((e-124 (vector-ref arg-2 1))) (let ((e-125 (vector-ref arg-2 2))) (let ((e-126 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 31 e-124 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-125) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-126) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((32) (let ((e-128 (vector-ref arg-2 1))) (let ((e-129 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 32 e-128 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-129) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((33) (let ((e-131 (vector-ref arg-2 1))) (let ((e-132 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 33 e-131 e-5)))))) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5103-u--goPStrings arg-1 e-132 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((34) (let ((e-134 (vector-ref arg-2 1))) (let ((e-135 (vector-ref arg-2 2))) (let ((e-136 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 34 e-134 e-135 e-5)))))) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5102-u--goPStringLines arg-1 e-136 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((35) (let ((e-138 (vector-ref arg-2 1))) (let ((e-139 (vector-ref arg-2 2))) (let ((e-140 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 35 e-138 e-139 e-5)))))) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5104-u--goPDos arg-1 e-140 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((36) (let ((e-142 (vector-ref arg-2 1))) (let ((e-143 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 36 e-142 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-143) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((37) (let ((e-145 (vector-ref arg-2 1))) (let ((e-146 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 37 e-145 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-146) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))) ((38) (let ((e-148 (vector-ref arg-2 1))) (let ((e-149 (vector-ref arg-2 2))) (let ((e-150 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 38 e-148 e-149 e-5)))))) (IdrisC-45Syntax-n--13654-5099-u--goPairedPTerms arg-1 e-150) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((39) (let ((e-152 (vector-ref arg-2 1))) (let ((e-153 (vector-ref arg-2 2))) (let ((e-154 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 39 e-152 e-153 e-5)))))) (IdrisC-45Syntax-n--13654-5099-u--goPairedPTerms arg-1 e-154) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((40) (let ((e-156 (vector-ref arg-2 1))) (let ((e-157 (vector-ref arg-2 2))) (let ((e-158 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 40 e-156 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-157) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-158) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((41) (let ((e-160 (vector-ref arg-2 1))) (let ((e-161 (vector-ref arg-2 2))) (let ((e-162 (vector-ref arg-2 3))) (let ((e-163 (vector-ref arg-2 4))) (let ((e-164 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 41 e-160 e-161 e-5 eta-4 eta-5)))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-162) eta-2)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-163) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-164) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))))) ((42) (arg-1 arg-2)) ((43) (let ((e-168 (vector-ref arg-2 1))) (let ((e-169 (vector-ref arg-2 2))) (let ((e-170 (vector-ref arg-2 3))) (let ((e-171 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 43 e-168 e-5 eta-4 eta-5)))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-169) eta-2)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-170) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-171) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))))) ((44) (let ((e-173 (vector-ref arg-2 1))) (let ((e-174 (vector-ref arg-2 2))) (let ((e-175 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 44 e-173 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-174) eta-1)) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5104-u--goPDos arg-1 e-175 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((45) (let ((e-177 (vector-ref arg-2 1))) (let ((e-178 (vector-ref arg-2 2))) (let ((e-179 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 45 e-177 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-178) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-179) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((46) (let ((e-181 (vector-ref arg-2 1))) (let ((e-182 (vector-ref arg-2 2))) (let ((e-183 (vector-ref arg-2 3))) (let ((e-184 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 46 e-181 e-5 eta-4 eta-5)))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-182) eta-2)) (lambda (eta-2) (IdrisC-45Syntax-n--13654-5097-u--goMPTerm arg-1 e-183 eta-2)) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-184) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0))))))))))) ((47) (let ((e-186 (vector-ref arg-2 1))) (let ((e-187 (vector-ref arg-2 2))) (let ((e-188 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 47 e-186 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-187) eta-1)) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5097-u--goMPTerm arg-1 e-188 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((50) (let ((e-190 (vector-ref arg-2 1))) (let ((e-191 (vector-ref arg-2 2))) (let ((e-192 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 50 e-190 e-191 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-192) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((48) (let ((e-194 (vector-ref arg-2 1))) (let ((e-195 (vector-ref arg-2 2))) (let ((e-196 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 48 e-194 e-5 eta-3))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-195) eta-1)) (lambda (eta-1) (vector 1 e-196)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))) ((49) (let ((e-198 (vector-ref arg-2 1))) (let ((e-199 (vector-ref arg-2 2))) (arg-1 (vector 49 e-198 e-199))))) (else (let ((e-201 (vector-ref arg-2 1))) (let ((e-202 (vector-ref arg-2 2))) (let ((e-203 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 51 e-201 e-202 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-203) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((arg-1 e-5) eta-0)))))))))))))
(define IdrisC-45Syntax-n--13654-5103-u--goPStrings (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5088-u--goPStr arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5103-u--goPStrings arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5102-u--goPStringLines (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5103-u--goPStrings arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5102-u--goPStringLines arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5088-u--goPStr (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-1 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-2) ext-0))))(else (vector 1 arg-2)))))
(define IdrisC-45Syntax-n--13654-5110-u--goPFnOpts (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5096-u--goPFnOpt arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5110-u--goPFnOpts arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5096-u--goPFnOpt (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (vector 1 arg-2)) (else (let ((e-3 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-5)))))) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5098-u--goPTerms arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5109-u--goPFields (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5094-u--goPField arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5109-u--goPFields arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5108-u--goPFieldUpdates (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5087-u--goPFieldUpdate arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5108-u--goPFieldUpdates arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5087-u--goPFieldUpdate (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-2) ext-0)))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector 1 e-4 e-6)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-5) ext-0)))))))
(define IdrisC-45Syntax-n--13654-5094-u--goPField (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((e-6 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-7 (vector-ref eta-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector e-1 e-2 e-3 e-7 eta-3 eta-4)))))))) (lambda (eta-2) (IdrisC-45Syntax-n--13654-5095-u--goPiInfo arg-1 e-4 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-5)) eta-0)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-6) ext-0)))))))))
(define IdrisC-45Syntax-n--13654-5104-u--goPDos (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5089-u--goPDo arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5104-u--goPDos arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5089-u--goPDo (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-2) ext-0)))) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-0 1))) (vector 1 (vector 1 e-4 e-5 e-6 e-8)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-7) ext-0)))))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 2 e-9 e-5 eta-3 eta-4)))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-10) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-11) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5105-u--goPClauses arg-1 e-12 eta-0)) ext-0)))))) ((3) (let ((e-14 (vector-ref arg-2 1))) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (let ((e-18 (vector-ref arg-2 5))) (let ((e-19 (vector-ref arg-2 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 3 e-14 e-15 e-16 e-17 e-5 eta-2))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-18) eta-0)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-19) ext-0)))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (let ((e-25 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 4 e-21 e-5 eta-4 eta-5 eta-6))))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-22) eta-2)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-23) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-24) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5105-u--goPClauses arg-1 e-25 eta-0)) ext-0))))))) ((5) (let ((e-27 (vector-ref arg-2 1))) (let ((e-28 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-27 e-5)))))) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-28 eta-0)) ext-0)))) (else (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-30 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-31) ext-0)))))))
(define IdrisC-45Syntax-n--13654-5107-u--goPDecls (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5091-u--goPDecl arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5091-u--goPDecl (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-6 (vector-ref eta-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 0 e-1 e-2 e-3 e-6 eta-2))))))) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5110-u--goPFnOpts arg-1 e-4 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5092-u--goPTypeDecl arg-1 e-5 eta-0)) ext-0))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-7 e-5)))))) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5105-u--goPClauses arg-1 e-8 eta-0)) ext-0)))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-10 e-11 e-12 e-5)))))) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5093-u--goPDataDecl arg-1 e-13 eta-0)) ext-0)))))) ((3) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 3 e-15 e-5 eta-2))))))) (IdrisC-45Syntax-n--13654-5101-u--go4TupledPTerms arg-1 e-16) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-17 eta-0)) ext-0))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 4 e-19 e-5 eta-2))))))) (IdrisC-45Syntax-n--13654-5099-u--goPairedPTerms arg-1 e-20) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-21 eta-0)) ext-0))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-23 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-24) ext-0)))) ((6) (let ((e-26 (vector-ref arg-2 1))) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((e-30 (vector-ref arg-2 5))) (let ((e-31 (vector-ref arg-2 6))) (let ((e-32 (vector-ref arg-2 7))) (let ((e-33 (vector-ref arg-2 8))) (let ((e-34 (vector-ref arg-2 9))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (CoreC-45Core-C-60C-42C-62 (lambda (eta-5) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-6) (case (vector-ref eta-6 0) ((0) (let ((e-2 (vector-ref eta-6 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-6 1))) (vector 1 (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (vector 6 e-26 e-27 e-5 eta-7 eta-8 eta-9 eta-10 eta-11 eta-12)))))))))))) (IdrisC-45Syntax-n--13654-5099-u--goPairedPTerms arg-1 e-28) eta-5)) (lambda (eta-5) (vector 1 e-29)) eta-4)) (lambda (eta-4) (vector 1 e-30)) eta-3)) (IdrisC-45Syntax-n--13654-5100-u--go3TupledPTerms arg-1 e-31) eta-2)) (lambda (eta-2) (vector 1 e-32)) eta-1)) (lambda (eta-1) (vector 1 e-33)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-34 eta-0)) ext-0))))))))))) ((7) (let ((e-36 (vector-ref arg-2 1))) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (let ((e-40 (vector-ref arg-2 5))) (let ((e-41 (vector-ref arg-2 6))) (let ((e-42 (vector-ref arg-2 7))) (let ((e-43 (vector-ref arg-2 8))) (let ((e-44 (vector-ref arg-2 9))) (let ((e-45 (vector-ref arg-2 10))) (let ((e-46 (vector-ref arg-2 11))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (CoreC-45Core-C-60C-42C-62 (lambda (eta-5) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-6) (case (vector-ref eta-6 0) ((0) (let ((e-2 (vector-ref eta-6 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-6 1))) (vector 1 (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (vector 7 e-36 e-37 e-38 e-39 e-5 eta-7 eta-8 eta-9 eta-10 eta-11 eta-12)))))))))))) (IdrisC-45Syntax-n--13654-5100-u--go3TupledPTerms arg-1 e-40) eta-5)) (IdrisC-45Syntax-n--13654-5099-u--goPairedPTerms arg-1 e-41) eta-4)) (lambda (eta-4) (vector 1 e-42)) eta-3)) (lambda (eta-3) (IdrisC-45Syntax-n--13654-5098-u--goPTerms arg-1 e-43 eta-3)) eta-2)) (lambda (eta-2) (vector 1 e-44)) eta-1)) (lambda (eta-1) (vector 1 e-45)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5106-u--goMPDecls arg-1 e-46 eta-0)) ext-0))))))))))))) ((8) (let ((e-48 (vector-ref arg-2 1))) (let ((e-49 (vector-ref arg-2 2))) (let ((e-50 (vector-ref arg-2 3))) (let ((e-51 (vector-ref arg-2 4))) (let ((e-52 (vector-ref arg-2 5))) (let ((e-53 (vector-ref arg-2 6))) (let ((e-54 (vector-ref arg-2 7))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 8 e-48 e-49 e-50 e-51 e-5 eta-3 eta-4)))))))) (IdrisC-45Syntax-n--13654-5101-u--go4TupledPTerms arg-1 e-52) eta-1)) (lambda (eta-1) (vector 1 e-53)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5109-u--goPFields arg-1 e-54 eta-0)) ext-0))))))))) ((9) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 9 e-56 e-5)))))) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-57 eta-0)) ext-0)))) ((10) (vector 1 arg-2)) ((11) (let ((e-64 (vector-ref arg-2 1))) (let ((e-65 (vector-ref arg-2 2))) (let ((e-66 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 11 e-64 e-65 e-5)))))) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-66 eta-0)) ext-0))))) ((12) (let ((e-68 (vector-ref arg-2 1))) (let ((e-69 (vector-ref arg-2 2))) (let ((e-70 (vector-ref arg-2 3))) (let ((e-71 (vector-ref arg-2 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 12 e-68 e-69 e-5 eta-2))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-70) eta-0)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-71) ext-0)))))) ((13) (let ((e-73 (vector-ref arg-2 1))) (let ((e-74 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 13 e-73 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-74) ext-0)))) ((14) (vector 1 arg-2)) (else (vector 1 arg-2)))))
(define IdrisC-45Syntax-n--13654-5093-u--goPDataDecl (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-6 (vector-ref eta-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 0 e-1 e-2 e-6 eta-3 eta-4)))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-3) eta-1)) (lambda (eta-1) (vector 1 e-4)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5111-u--goPTypeDecls arg-1 e-5 eta-0)) ext-0))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-7 e-8 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-9) ext-0))))))))
(define IdrisC-45Syntax-n--13654-5105-u--goPClauses (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-1975) (lambda (eta-1) (IdrisC-45Syntax-n--13654-5090-u--goPClause arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5105-u--goPClauses arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45Syntax-n--13654-5090-u--goPClause (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-5 (vector-ref eta-2 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 0 e-1 e-5 eta-3 eta-4)))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-2) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-3) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-4 eta-0)) ext-0)))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((e-10 (vector-ref arg-2 5))) (let ((e-11 (vector-ref arg-2 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-2 (vector-ref eta-4 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-4 1))) (vector 1 (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (vector 1 e-6 e-5 eta-5 eta-6 eta-7 eta-8)))))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-7) eta-3)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-8) eta-2)) (lambda (eta-2) (vector 1 e-9)) eta-1)) (lambda (eta-1) (vector 1 e-10)) eta-0)) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5105-u--goPClauses arg-1 e-11 eta-0)) ext-0)))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-13 e-5)))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-14) ext-0)))))))
(define IdrisC-45Syntax-n--13654-5097-u--goMPTerm (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (unbox arg-2))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-2) ext-0)))))
(define IdrisC-45Syntax-n--13654-5106-u--goMPDecls (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (unbox arg-2))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (lambda (eta-0) (IdrisC-45Syntax-n--13654-5107-u--goPDecls arg-1 e-2 eta-0)) ext-0)))))
(define IdrisC-45Syntax-n--13654-5101-u--go4TupledPTerms (lambda (arg-1 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-4 (vector-ref eta-2 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (u--d) (lambda (u--ts) (cons (cons e-6 (cons e-10 (cons e-5 u--d))) u--ts)))))))) (lambda (eta-2) (IdrisC-45Syntax-n--13654-5095-u--goPiInfo arg-1 e-14 eta-2)) eta-1)) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-15) eta-0)) (IdrisC-45Syntax-n--13654-5101-u--go4TupledPTerms arg-1 e-3) clam-0)))))))))))))
(define IdrisC-45Syntax-n--13654-5100-u--go3TupledPTerms (lambda (arg-1 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (cons (cons e-6 (cons e-10 e-5)) eta-2))))))) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 e-11) eta-0)) (IdrisC-45Syntax-n--13654-5100-u--go3TupledPTerms arg-1 e-3) clam-0)))))))))))
(define IdrisC-45Syntax-n--10098-1759-u--getName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-3 (vector-ref arg-5 2))) e-3)))
(define IdrisC-45Syntax-n--10711-3470-u--dePure (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((7) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((u--tm (vector 7 e-1 (vector 0 e-5 e-6) e-3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (arg-1 e-6)) (vector 1 (vector 0 "pure"))))) (cond ((equal? sc2 1) e-3) (else u--tm)))))))(else arg-6))))))(else arg-6))))
(define IdrisC-45Syntax-n--10711-3471-u--deGuard (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (case (vector-ref e-2 0) ((7) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((e-6 (vector-ref e-2 3))) (case (vector-ref e-5 0) ((0) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((u--tm (vector 0 e-1 (vector 7 e-4 (vector 0 e-8 e-9) e-6)))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (arg-1 e-9)) (vector 1 (vector 0 "guard"))))) (cond ((equal? sc3 1) (vector 0 e-1 e-6)) (else u--tm)))))))(else arg-6))))))(else arg-6)))))(else arg-6))))
(define IdrisC-45Syntax-u--toBuf_TTC_SyntaxInfo (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1977) arg-0 (LibrariesC-45DataC-45StringMap-toList (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1988) arg-0 (LibrariesC-45DataC-45StringMap-toList (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1992) arg-0 (DataC-45List-filter (lambda (u--n) (DataC-45List-elemBy (lambda (eta-0) (lambda (eta-1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent eta-0 eta-1))) (Builtin-fst u--n) (let ((e-2 (vector-ref arg-1 2))) e-2))) (LibrariesC-45DataC-45SortedMap-toList (let ((e-3 (vector-ref arg-1 3))) e-3))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1997) arg-0 (DataC-45List-filter (lambda (u--n) (PreludeC-45Types-elem (csegen-802) (Builtin-fst u--n) (let ((e-4 (vector-ref arg-1 4))) e-4))) (LibrariesC-45DataC-45ANameMap-toList (let ((e-13 (vector-ref arg-1 5))) e-13))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-2004) arg-0 (DataC-45List-filter (lambda (u--n) (DataC-45Maybe-isJust (LibrariesC-45DataC-45NameMap-lookup (Builtin-fst u--n) (let ((e-13 (vector-ref arg-1 6))) e-13)))) (LibrariesC-45DataC-45ANameMap-toList (let ((e-12 (vector-ref arg-1 7))) e-12))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 (let ((e-12 (vector-ref arg-1 8))) e-12) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 (let ((e-11 (vector-ref arg-1 10))) e-11)) ext-0)))))))))))))))))))))
(define IdrisC-45Syntax-u--toBuf_TTC_Method (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((act-24 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-2008) arg-0 e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else ((TTImpC-45TTImp-u--toBuf_TTC_RawImp arg-0 e-3) ext-0))))))))))))))))
(define IdrisC-45Syntax-u--toBuf_TTC_IFaceInfo (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-24 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 e-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1833) arg-0 e-3 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((act-28 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-2011) arg-0 e-4 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-2014) arg-0 e-5 ext-0))))))))))))))))))))))))
(define IdrisC-45Syntax-u--toBuf_TTC_Fixity (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((equal? arg-1 2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)))))
(define IdrisC-45Syntax-u--show_Show_PTerm (lambda (arg-0) (IdrisC-45Syntax-u--showPrec_Show_PTerm (vector 0 ) arg-0)))
(define IdrisC-45Syntax-u--show_Show_Method (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_TotalReq u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_TotalReq u--d u--x)))) e-2) (PreludeC-45TypesC-45String-C-43C-43 "] " (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-1) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-0) (PreludeC-45TypesC-45String-C-43C-43 " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-3))))))))))))))
(define IdrisC-45Syntax-u--show_Show_IPTerm (lambda (arg-0) (IdrisC-45Syntax-u--showPrec_Show_IPTerm (vector 0 ) arg-0)))
(define IdrisC-45Syntax-u--show_Show_Fixity (lambda (arg-0) (cond ((equal? arg-0 0) "infixl") ((equal? arg-0 1) "infixr") ((equal? arg-0 2) "infix") (else "prefix"))))
(define IdrisC-45Syntax-u--showPrec_Show_PTerm (lambda (ext-0 ext-1) (IdrisC-45Syntax-showPTermPrec (lambda (eta-0) eta-0) ext-0 ext-1)))
(define IdrisC-45Syntax-u--showPrec_Show_Method (lambda (arg-0 arg-1) (IdrisC-45Syntax-u--show_Show_Method arg-1)))
(define IdrisC-45Syntax-u--showPrec_Show_IPTerm (lambda (ext-0 ext-1) (IdrisC-45Syntax-showPTermPrec (csegen-1949) ext-0 ext-1)))
(define IdrisC-45Syntax-u--resolved_HasNames_SyntaxInfo (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((IdrisC-45Syntax-u--resolved_HasNames_C-40ANameMapC-32C-36aC-41 (csegen-2023) arg-0 (let ((e-5 (vector-ref arg-1 5))) e-5)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) (let ((e-8 (vector-ref arg-1 8))) e-8) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-11 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-11 e-7 e-6 e-9 e-10)))))))))))))))))))))
(define IdrisC-45Syntax-u--resolved_HasNames_IFaceInfo (lambda (arg-0 arg-1 ext-0) (vector 1 arg-1)))
(define IdrisC-45Syntax-u--resolved_HasNames_C-40ANameMapC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (IdrisC-45Syntax-n--13363-4863-u--insertAll arg-1 arg-3 arg-2 (LibrariesC-45DataC-45ANameMap-empty) (LibrariesC-45DataC-45ANameMap-toList arg-3))))
(define IdrisC-45Syntax-u--pretty_Pretty_REPLOpt (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "showimplicits") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bool e-0))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "shownamespace") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bool e-1))))) ((2) (let ((e-2 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "showtypes") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bool e-2))))) ((3) (let ((e-3 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "eval") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (IdrisC-45Syntax-u--pretty_Pretty_REPLEval e-3))))) ((4) (let ((e-4 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "editor") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-4))))) ((5) (let ((e-5 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "cg") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5))))) ((6) (let ((e-6 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "profile") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bool e-6))))) (else (let ((e-7 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "evaltiming") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bool e-7))))))))
(define IdrisC-45Syntax-u--pretty_Pretty_REPLEval (lambda (arg-1) (cond ((equal? arg-1 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "typecheck")) ((equal? arg-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "normalise")) ((equal? arg-1 2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "execute")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "scheme")))))
(define IdrisC-45Syntax-u--full_HasNames_SyntaxInfo (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((IdrisC-45Syntax-u--full_HasNames_C-40ANameMapC-32C-36aC-41 (csegen-2023) arg-0 (let ((e-5 (vector-ref arg-1 5))) e-5)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) (let ((e-8 (vector-ref arg-1 8))) e-8) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-11 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-11 e-7 e-6 e-9 e-10)))))))))))))))))))))
(define IdrisC-45Syntax-u--full_HasNames_IFaceInfo (lambda (arg-0 arg-1 ext-0) (vector 1 arg-1)))
(define IdrisC-45Syntax-u--full_HasNames_C-40ANameMapC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (IdrisC-45Syntax-n--13362-4822-u--insertAll arg-1 arg-3 arg-2 (LibrariesC-45DataC-45ANameMap-empty) (LibrariesC-45DataC-45ANameMap-toList arg-3))))
(define IdrisC-45Syntax-u--fromBuf_TTC_SyntaxInfo (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1977) arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1988) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1992) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1997) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-2004) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (vector 1 (vector (LibrariesC-45DataC-45StringMap-fromList e-5) (LibrariesC-45DataC-45StringMap-fromList e-6) '() (LibrariesC-45DataC-45SortedMap-fromList (csegen-2026) e-7) '() (LibrariesC-45DataC-45ANameMap-fromList e-8) (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45ANameMap-fromList e-9) e-10 '() e-11))))))))))))))))))))))))))))))))
(define IdrisC-45Syntax-u--fromBuf_TTC_Method (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-2008) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-u--fromBuf_TTC_RawImp arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector e-5 e-6 e-7 e-8))))))))))))))))))))
(define IdrisC-45Syntax-u--fromBuf_TTC_IFaceInfo (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-38) arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1833) arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-2011) arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-2014) arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (vector e-5 e-6 e-7 e-8 e-9 e-10))))))))))))))))))))))))))))
(define IdrisC-45Syntax-u--fromBuf_TTC_Fixity (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2)) ((equal? e-5 3) (vector 1 3))(else (CoreC-45BinaryC-45Prims-corrupt "Fixity" ext-0)))))))))
(define IdrisC-45Syntax-u--C-61C-61_Eq_Pass (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define IdrisC-45Syntax-withSyn (lambda (arg-1 ext-1 ext-0) (CoreC-45Core-wrapRef (vector "Idris.Syntax.Syn" ) arg-1 (lambda (_-5076) (lambda (eta-0) (vector 1 0))) ext-1 ext-0)))
(define IdrisC-45Syntax-typePass (lambda (arg-0) (let ((sc0 (IdrisC-45Syntax-u--C-61C-61_Eq_Pass arg-0 0))) (cond ((equal? sc0 1) 1) (else (IdrisC-45Syntax-u--C-61C-61_Eq_Pass arg-0 1))))))
(define IdrisC-45Syntax-showUpdate (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "." e-1) (PreludeC-45TypesC-45String-C-43C-43 " = " (IdrisC-45Syntax-showPTerm arg-1 e-2)))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "." e-4) (PreludeC-45TypesC-45String-C-43C-43 " $= " (IdrisC-45Syntax-showPTerm arg-1 e-5)))))))))
(define IdrisC-45Syntax-showPTermPrec (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 2))) (CoreC-45Name-u--showPrec_Show_Name arg-2 (arg-1 e-2)))) ((1) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (let ((e-8 (vector-ref arg-3 5))) (let ((e-9 (vector-ref arg-3 6))) (case (vector-ref e-6 0) ((1) (if (null? e-7) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (PreludeC-45TypesC-45String-C-43C-43 " -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9))) (let ((e-211 (unbox e-7))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-5) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-211) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (PreludeC-45TypesC-45String-C-43C-43 ") -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))))) ((0) (if (null? e-7) (PreludeC-45TypesC-45String-C-43C-43 "{" (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-5) (PreludeC-45TypesC-45String-C-43C-43 "_ : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (PreludeC-45TypesC-45String-C-43C-43 "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))) (let ((e-214 (unbox e-7))) (PreludeC-45TypesC-45String-C-43C-43 "{" (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-5) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-214) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (PreludeC-45TypesC-45String-C-43C-43 "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))))) ((2) (if (null? e-7) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (PreludeC-45TypesC-45String-C-43C-43 " => " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9))) (let ((e-217 (unbox e-7))) (PreludeC-45TypesC-45String-C-43C-43 "{auto " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-5) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-217) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (PreludeC-45TypesC-45String-C-43C-43 "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))))) (else (let ((e-208 (vector-ref e-6 1))) (if (null? e-7) (PreludeC-45TypesC-45String-C-43C-43 "{default " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-208) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-5) (PreludeC-45TypesC-45String-C-43C-43 "_ : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (PreludeC-45TypesC-45String-C-43C-43 "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))) (let ((e-220 (unbox e-7))) (PreludeC-45TypesC-45String-C-43C-43 "{default " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-208) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-5) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-220) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (PreludeC-45TypesC-45String-C-43C-43 "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))))))))))))))) ((2) (let ((e-12 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 4))) (let ((e-15 (vector-ref arg-3 5))) (let ((e-16 (vector-ref arg-3 6))) (case (vector-ref e-15 0) ((25) (PreludeC-45TypesC-45String-C-43C-43 "\\" (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-12) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-14) (PreludeC-45TypesC-45String-C-43C-43 " => " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-16))))))(else (PreludeC-45TypesC-45String-C-43C-43 "\\" (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-12) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-14) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-15) (PreludeC-45TypesC-45String-C-43C-43 " => " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-16)))))))))))))) ((3) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (let ((e-21 (vector-ref arg-3 4))) (let ((e-22 (vector-ref arg-3 5))) (let ((e-23 (vector-ref arg-3 6))) (let ((e-24 (vector-ref arg-3 7))) (case (vector-ref e-21 0) ((25) (PreludeC-45TypesC-45String-C-43C-43 "let " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-19) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-20) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-22) (PreludeC-45TypesC-45String-C-43C-43 " in " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-23))))))))(else (PreludeC-45TypesC-45String-C-43C-43 "let " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount e-19) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-20) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-21) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-22) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (IdrisC-45Syntax-n--10711-2687-u--showAlt arg-1 e-18 e-24 e-23 e-22 e-21 e-20 e-19 arg-2 eta-0)) e-24) (PreludeC-45TypesC-45String-C-43C-43 " in " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-23)))))))))))))))))))) ((4) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "case " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-27) (PreludeC-45TypesC-45String-C-43C-43 " of { " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " ; " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Syntax-n--10711-2754-u--showCase arg-1 arg-2 e-26 e-28 e-27 eta-0)) e-28)) " }")))))))) ((5) (let ((e-32 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "let { << definitions >>  } in " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-32)))) ((6) (let ((e-35 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "record { " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Syntax-showUpdate arg-1 eta-0)) e-35)) " }")))) ((7) (let ((e-38 (vector-ref arg-3 2))) (let ((e-39 (vector-ref arg-3 3))) (let ((u--catchall (lambda () (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-38) (PreludeC-45TypesC-45String-C-43C-43 " " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-39)))))) (case (vector-ref e-38 0) ((0) (let ((e-1 (vector-ref e-38 1))) (let ((e-2 (vector-ref e-38 2))) (let ((u--f (vector 0 e-1 e-2))) (let ((sc2 (DataC-45Maybe-isJust (CoreC-45Name-isRF (arg-1 e-2))))) (cond ((equal? sc2 1) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-39) (PreludeC-45TypesC-45String-C-43C-43 " " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) u--f)))) (else (u--catchall))))))))(else (u--catchall))))))) ((8) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-42) (PreludeC-45TypesC-45String-C-43C-43 " | " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-43)))))) ((10) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-46) (PreludeC-45TypesC-45String-C-43C-43 " @{" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-47) "}")))))) ((11) (let ((e-50 (vector-ref arg-3 2))) (let ((e-51 (vector-ref arg-3 3))) (cond ((equal? e-50 0) (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 6 )) (PreludeC-45TypesC-45String-C-43C-43 "Inf " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-51))))(else (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 6 )) (PreludeC-45TypesC-45String-C-43C-43 "Lazy " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-51)))))))) ((12) (let ((e-54 (vector-ref arg-3 2))) (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 6 )) (PreludeC-45TypesC-45String-C-43C-43 "Delay " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-54))))) ((13) (let ((e-57 (vector-ref arg-3 2))) (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 6 )) (PreludeC-45TypesC-45String-C-43C-43 "Force " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-57))))) ((9) (let ((e-60 (vector-ref arg-3 2))) (let ((e-61 (vector-ref arg-3 3))) (let ((e-62 (vector-ref arg-3 4))) (case (vector-ref e-62 0) ((0) (let ((e-227 (vector-ref e-62 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-61 (arg-1 e-227)))) (cond ((equal? sc2 1) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-60) (PreludeC-45TypesC-45String-C-43C-43 " {" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-61) "}")))) (else (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-60) (PreludeC-45TypesC-45String-C-43C-43 " {" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-61) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 (arg-1 e-227)) "}"))))))))))(else (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-60) (PreludeC-45TypesC-45String-C-43C-43 " {" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-61) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-62) "}"))))))))))) ((14) "%search") ((16) (let ((e-68 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "`(" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-68) ")")))) ((17) (let ((e-71 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "`{" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-71) "}")))) ((18) "`[ <<declaration>> ]") ((19) (let ((e-77 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "~(" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-77) ")")))) ((20) (let ((e-80 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "%runElab " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-80)))) ((15) (let ((e-83 (vector-ref arg-3 2))) (CoreC-45TT-u--showPrec_Show_Constant arg-2 e-83))) ((21) (let ((e-87 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "?" e-87))) ((22) "Type") ((23) (let ((e-93 (vector-ref arg-3 3))) (let ((e-94 (vector-ref arg-3 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 e-93) (PreludeC-45TypesC-45String-C-43C-43 "@" (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-94)))))) ((24) (let ((e-97 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "." (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-97)))) ((25) "_") ((26) "?") ((27) (let ((e-105 (vector-ref arg-3 3))) (let ((e-106 (vector-ref arg-3 4))) (let ((e-107 (vector-ref arg-3 5))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-106) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showOpPrec arg-1 arg-2 e-105) (PreludeC-45TypesC-45String-C-43C-43 " " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-107))))))))) ((28) (let ((e-111 (vector-ref arg-3 3))) (let ((e-112 (vector-ref arg-3 4))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showOpPrec arg-1 arg-2 e-111) (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-112))))) ((29) (let ((e-116 (vector-ref arg-3 3))) (let ((e-117 (vector-ref arg-3 4))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showOpPrec arg-1 arg-2 e-116) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-117) ")"))))))) ((30) (let ((e-121 (vector-ref arg-3 3))) (let ((e-122 (vector-ref arg-3 4))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-121) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showOpPrec arg-1 arg-2 e-122) ")"))))))) ((31) (let ((e-125 (vector-ref arg-3 2))) (let ((e-126 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-125) (PreludeC-45TypesC-45String-C-43C-43 " = " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-126)))))) ((32) (let ((e-129 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-129) ")")))) ((33) (let ((e-132 (vector-ref arg-3 2))) (LibrariesC-45DataC-45StringC-45Extra-join " ++ " (csegen-51) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Syntax-showPStr arg-1 eta-0)) e-132)))) ((34) (let ((e-136 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "multiline (" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45StringC-45Extra-join " ++ " (csegen-51) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Syntax-showPStr arg-1 eta-0)) (PreludeC-45Interfaces-concat (csegen-50) e-136))) ")")))) ((35) (let ((e-140 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "do " (CoreC-45NameC-45Namespace-showSep " ; " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Syntax-showDo arg-1 eta-0)) e-140))))) ((36) (let ((e-143 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "!" (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-143)))) ((37) (let ((e-146 (vector-ref arg-3 2))) (PreludeC-45TypesC-45String-C-43C-43 "[|" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-146) "|]")))) ((38) (let ((e-150 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 (Builtin-snd eta-0))) e-150)) "]")))) ((39) (let ((e-154 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "[<" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 (Builtin-snd eta-0))) e-154)) "]")))) ((40) (let ((e-157 (vector-ref arg-3 2))) (let ((e-158 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-157) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-158) ")"))))))) ((41) (let ((e-162 (vector-ref arg-3 3))) (let ((e-163 (vector-ref arg-3 4))) (let ((e-164 (vector-ref arg-3 5))) (case (vector-ref e-163 0) ((25) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-162) (PreludeC-45TypesC-45String-C-43C-43 " ** " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-164) ")")))))(else (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-162) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-163) (PreludeC-45TypesC-45String-C-43C-43 " ** " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-164) ")")))))))))))) ((42) "()") ((43) (let ((e-169 (vector-ref arg-3 2))) (let ((e-170 (vector-ref arg-3 3))) (let ((e-171 (vector-ref arg-3 4))) (PreludeC-45TypesC-45String-C-43C-43 "if " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-169) (PreludeC-45TypesC-45String-C-43C-43 " then " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-170) (PreludeC-45TypesC-45String-C-43C-43 " else " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-171)))))))))) ((44) (let ((e-173 (vector-ref arg-3 1))) (let ((e-174 (vector-ref arg-3 2))) (let ((e-175 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 (IdrisC-45Syntax-n--10711-3470-u--dePure arg-1 e-173 e-175 e-174 arg-2 e-174)) (PreludeC-45TypesC-45String-C-43C-43 " | " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Syntax-showDo arg-1 (IdrisC-45Syntax-n--10711-3471-u--deGuard arg-1 e-173 e-175 e-174 arg-2 eta-0))) e-175)) "]")))))))) ((45) (let ((e-178 (vector-ref arg-3 2))) (let ((e-179 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "rewrite " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-178) (PreludeC-45TypesC-45String-C-43C-43 " in " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-179))))))) ((46) (let ((e-182 (vector-ref arg-3 2))) (let ((e-183 (vector-ref arg-3 3))) (let ((e-184 (vector-ref arg-3 4))) (if (null? e-183) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-182) (PreludeC-45TypesC-45String-C-43C-43 " .. " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-184) "]")))) (let ((e-232 (unbox e-183))) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-182) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-232) (PreludeC-45TypesC-45String-C-43C-43 " .. " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-184) "]")))))))))))) ((47) (let ((e-187 (vector-ref arg-3 2))) (let ((e-188 (vector-ref arg-3 3))) (if (null? e-188) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-187) " .. ]")) (let ((e-235 (unbox e-188))) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-187) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-235) " .. ]"))))))))) ((50) (let ((e-192 (vector-ref arg-3 3))) (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-192))) ((48) (let ((e-195 (vector-ref arg-3 2))) (let ((e-196 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-195) (PreludeC-45Interfaces-concatMap (csegen-67) (csegen-2034) e-196))))) ((49) (let ((e-199 (vector-ref arg-3 2))) (PreludeC-45Interfaces-concatMap (csegen-67) (csegen-2034) e-199))) (else (let ((e-202 (vector-ref arg-3 2))) (let ((e-203 (vector-ref arg-3 3))) (PreludeC-45TypesC-45String-C-43C-43 "with " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-202) (PreludeC-45TypesC-45String-C-43C-43 " " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-203))))))))))
(define IdrisC-45Syntax-showPTerm (lambda (arg-1 ext-0) (IdrisC-45Syntax-showPTermPrec arg-1 (vector 0 ) ext-0)))
(define IdrisC-45Syntax-showPStr (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45Show-u--show_Show_String e-2))) (else (let ((e-5 (vector-ref arg-2 2))) (IdrisC-45Syntax-showPTerm arg-1 e-5))))))
(define IdrisC-45Syntax-showOpPrec (lambda (arg-1 arg-2 arg-3) (let ((u--op (arg-1 arg-3))) (let ((sc0 (ParserC-45LexerC-45Source-isOpName u--op))) (cond ((equal? sc0 1) (CoreC-45Name-u--showPrec_Show_Name arg-2 u--op)) (else (PreludeC-45TypesC-45String-C-43C-43 "`" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--showPrec_Show_Name arg-2 u--op) "`"))))))))
(define IdrisC-45Syntax-showDo (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (IdrisC-45Syntax-showPTerm arg-1 e-2))) ((1) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) (PreludeC-45TypesC-45String-C-43C-43 " <- " (IdrisC-45Syntax-showPTerm arg-1 e-7)))))) ((2) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-10) (PreludeC-45TypesC-45String-C-43C-43 " <- " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-11) (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (IdrisC-45Syntax-showAlt arg-1 eta-0)) e-12)))))))) ((3) (let ((e-16 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 6))) (PreludeC-45TypesC-45String-C-43C-43 "let " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-16) (PreludeC-45TypesC-45String-C-43C-43 " = " (IdrisC-45Syntax-showPTerm arg-1 e-19))))))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-24 (vector-ref arg-2 4))) (let ((e-25 (vector-ref arg-2 5))) (PreludeC-45TypesC-45String-C-43C-43 "let " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-22) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-24) (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (IdrisC-45Syntax-showAlt arg-1 eta-0)) e-25))))))))) ((5) "let { << definitions >>  }") (else (let ((e-31 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 "rewrite " (IdrisC-45Syntax-showPTerm arg-1 e-31)))))))
(define IdrisC-45Syntax-showAlt (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 " | " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-2) (PreludeC-45TypesC-45String-C-43C-43 " => " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-3) ";"))))))) ((1) " | <<with alts not possible>>;") (else (let ((e-14 (vector-ref arg-2 2))) (PreludeC-45TypesC-45String-C-43C-43 " | " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-showPTerm arg-1 e-14) " impossible;")))))))
(define IdrisC-45Syntax-pragmaTopics(blodwen-lazy (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "+") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Syntax-n--8801-1275-u--showDirective eta-0)))) (DataC-45List-filter (lambda (eta-0) (IdrisC-45Syntax-isPragma eta-0)) (IdrisC-45Syntax-directiveList))))))))
(define IdrisC-45Syntax-papply (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) arg-2 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (IdrisC-45Syntax-papply arg-1 (vector 7 arg-1 arg-2 e-2) e-3))))))
(define IdrisC-45Syntax-mapPTermM (lambda (arg-1 ext-0) (IdrisC-45Syntax-n--13654-5086-u--goPTerm arg-1 ext-0)))
(define IdrisC-45Syntax-isStrLiteral (lambda (arg-0) (case (vector-ref arg-0 0) ((1) '()) (else (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (box (cons e-4 e-5))))))))
(define IdrisC-45Syntax-isStrInterp (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-1 (vector-ref arg-0 1))) (box e-1))) (else '()))))
(define IdrisC-45Syntax-isPragma (lambda (arg-0) (case (vector-ref arg-0 0) ((11) 0)(else 1))))
(define IdrisC-45Syntax-isPDef (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (box (cons e-1 e-2)))))(else '()))))
(define IdrisC-45Syntax-initSyntax(blodwen-lazy (lambda () (vector (IdrisC-45Syntax-n--13573-5001-u--initInfix) (IdrisC-45Syntax-n--13573-5002-u--initPrefix) '() (LibrariesC-45DataC-45SortedMap-empty (csegen-2026)) '() (LibrariesC-45DataC-45ANameMap-empty) (IdrisC-45Syntax-n--13573-5004-u--initSaveDocStrings) (IdrisC-45Syntax-n--13573-5003-u--initDocStrings) '() '() (vector 0 (vector 2 ) (vector 1 (vector 0 "main")))))))
(define IdrisC-45Syntax-getPTermLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-4 (vector-ref arg-1 1))) e-4)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-18 (vector-ref arg-1 1))) e-18)) ((4) (let ((e-26 (vector-ref arg-1 1))) e-26)) ((5) (let ((e-30 (vector-ref arg-1 1))) e-30)) ((6) (let ((e-34 (vector-ref arg-1 1))) e-34)) ((7) (let ((e-37 (vector-ref arg-1 1))) e-37)) ((8) (let ((e-41 (vector-ref arg-1 1))) e-41)) ((10) (let ((e-45 (vector-ref arg-1 1))) e-45)) ((9) (let ((e-49 (vector-ref arg-1 1))) e-49)) ((11) (let ((e-54 (vector-ref arg-1 1))) e-54)) ((12) (let ((e-58 (vector-ref arg-1 1))) e-58)) ((13) (let ((e-61 (vector-ref arg-1 1))) e-61)) ((14) (let ((e-64 (vector-ref arg-1 1))) e-64)) ((15) (let ((e-67 (vector-ref arg-1 1))) e-67)) ((16) (let ((e-70 (vector-ref arg-1 1))) e-70)) ((17) (let ((e-73 (vector-ref arg-1 1))) e-73)) ((18) (let ((e-76 (vector-ref arg-1 1))) e-76)) ((19) (let ((e-79 (vector-ref arg-1 1))) e-79)) ((20) (let ((e-82 (vector-ref arg-1 1))) e-82)) ((21) (let ((e-85 (vector-ref arg-1 1))) e-85)) ((22) (let ((e-89 (vector-ref arg-1 1))) e-89)) ((23) (let ((e-91 (vector-ref arg-1 1))) e-91)) ((24) (let ((e-96 (vector-ref arg-1 1))) e-96)) ((25) (let ((e-99 (vector-ref arg-1 1))) e-99)) ((26) (let ((e-101 (vector-ref arg-1 1))) e-101)) ((27) (let ((e-103 (vector-ref arg-1 1))) e-103)) ((28) (let ((e-109 (vector-ref arg-1 1))) e-109)) ((29) (let ((e-114 (vector-ref arg-1 1))) e-114)) ((30) (let ((e-119 (vector-ref arg-1 1))) e-119)) ((31) (let ((e-124 (vector-ref arg-1 1))) e-124)) ((32) (let ((e-128 (vector-ref arg-1 1))) e-128)) ((33) (let ((e-131 (vector-ref arg-1 1))) e-131)) ((34) (let ((e-134 (vector-ref arg-1 1))) e-134)) ((35) (let ((e-138 (vector-ref arg-1 1))) e-138)) ((36) (let ((e-142 (vector-ref arg-1 1))) e-142)) ((37) (let ((e-145 (vector-ref arg-1 1))) e-145)) ((38) (let ((e-148 (vector-ref arg-1 1))) e-148)) ((39) (let ((e-152 (vector-ref arg-1 1))) e-152)) ((40) (let ((e-156 (vector-ref arg-1 1))) e-156)) ((41) (let ((e-160 (vector-ref arg-1 1))) e-160)) ((42) (let ((e-166 (vector-ref arg-1 1))) e-166)) ((43) (let ((e-168 (vector-ref arg-1 1))) e-168)) ((44) (let ((e-173 (vector-ref arg-1 1))) e-173)) ((45) (let ((e-177 (vector-ref arg-1 1))) e-177)) ((46) (let ((e-181 (vector-ref arg-1 1))) e-181)) ((47) (let ((e-186 (vector-ref arg-1 1))) e-186)) ((48) (let ((e-190 (vector-ref arg-1 1))) e-190)) ((49) (let ((e-194 (vector-ref arg-1 1))) e-194)) ((50) (let ((e-197 (vector-ref arg-1 1))) e-197)) (else (let ((e-201 (vector-ref arg-1 1))) e-201)))))
(define IdrisC-45Syntax-getLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-4 (vector-ref arg-1 1))) e-4)) ((2) (let ((e-9 (vector-ref arg-1 1))) e-9)) ((3) (let ((e-14 (vector-ref arg-1 1))) e-14)) ((4) (let ((e-21 (vector-ref arg-1 1))) e-21)) ((5) (let ((e-27 (vector-ref arg-1 1))) e-27)) (else (let ((e-30 (vector-ref arg-1 1))) e-30)))))
(define IdrisC-45Syntax-directiveList(blodwen-lazy (lambda () (cons (vector 0 (IdrisC-45Syntax-n--8799-1183-u--ph)) (cons (vector 1 '()) (cons (vector 2 0) (cons (vector 3 0) (cons (vector 4 0) (cons (vector 5 (IdrisC-45Syntax-n--8799-1183-u--ph) (IdrisC-45Syntax-n--8799-1183-u--ph) (IdrisC-45Syntax-n--8799-1183-u--ph)) (cons (vector 6 (IdrisC-45Syntax-n--8799-1183-u--ph) (IdrisC-45Syntax-n--8799-1183-u--ph)) (cons (vector 7 (IdrisC-45Syntax-n--8799-1183-u--ph)) (cons (vector 8 (IdrisC-45Syntax-n--8799-1183-u--ph)) (cons (vector 9 (IdrisC-45Syntax-n--8799-1183-u--ph)) (cons (vector 10 (IdrisC-45Syntax-n--8799-1183-u--ph)) (cons (vector 11 "" "") (cons (vector 12 (IdrisC-45Syntax-n--8799-1183-u--ph) '()) (cons (vector 13 (vector 0 (vector 2 ) (IdrisC-45Syntax-n--8799-1183-u--ph))) (cons (vector 14 (IdrisC-45Syntax-n--8799-1183-u--ph)) (cons (vector 15 0) (cons (vector 16 2) (cons (vector 17 1) (cons (vector 18 0) (cons (vector 19 0) (cons (vector 20 0) '()))))))))))))))))))))))))
(define IdrisC-45Syntax-definedInData (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (cons e-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Syntax-n--10098-1759-u--getName e-1 e-3 e-4 e-5 e-2 eta-0)) e-5)))))))) (else (let ((e-8 (vector-ref arg-0 2))) (cons e-8 '()))))))
(define IdrisC-45Syntax-definedIn (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((0) (let ((e-9 (vector-ref e-2 5))) (let ((e-30 (vector-ref e-9 2))) (cons e-30 (IdrisC-45Syntax-definedIn e-3))))) ((2) (let ((e-14 (vector-ref e-2 4))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedInData e-14) (IdrisC-45Syntax-definedIn e-3)))) ((3) (let ((e-18 (vector-ref e-2 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedIn e-18) (IdrisC-45Syntax-definedIn e-3)))) ((4) (let ((e-22 (vector-ref e-2 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedIn e-22) (IdrisC-45Syntax-definedIn e-3)))) ((11) (let ((e-26 (vector-ref e-2 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedIn e-26) (IdrisC-45Syntax-definedIn e-3))))(else (IdrisC-45Syntax-definedIn e-3))))))))
(define IdrisC-45Syntax-defPass (lambda (arg-0) (let ((sc0 (IdrisC-45Syntax-u--C-61C-61_Eq_Pass arg-0 0))) (cond ((equal? sc0 1) 1) (else (IdrisC-45Syntax-u--C-61C-61_Eq_Pass arg-0 2))))))
(define IdrisC-45Syntax-applyArgs (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (IdrisC-45Syntax-applyArgs (vector 7 e-6 arg-1 e-7) e-3))))))))
(define LibrariesC-45DataC-45ANameMap-case--addToHier-7932 (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-2 (let ((e-2 (unbox arg-4))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-2))) (if (null? sc1) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (cons arg-3 arg-1) '()) arg-2) (let ((e-3 (unbox sc1))) (LibrariesC-45DataC-45UserNameMap-insert e-2 (LibrariesC-45DataC-45ANameMap-n--3439-7861-u--update arg-1 arg-2 arg-3 arg-1 e-3) arg-2))))))))
(define LibrariesC-45DataC-45ANameMap-case--lookupName-7766 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (let ((sc1 (LibrariesC-45DataC-45ANameMap-lookupExact arg-2 arg-1))) (if (null? sc1) '() (let ((e-2 (unbox sc1))) (cons (cons arg-2 e-2) '())))) (let ((e-2 (unbox arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 (let ((e-3 (cdr arg-1))) e-3)))) (if (null? sc1) '() (let ((e-3 (unbox sc1))) (DataC-45List-filter (lambda (eta-0) (CoreC-45Name-matches arg-2 (Builtin-fst eta-0))) e-3))))))))
(define LibrariesC-45DataC-45ANameMap-n--3439-7861-u--update (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (cons (cons arg-3 arg-4) '()) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-3 (Builtin-fst e-2)))) (cond ((equal? sc1 1) (cons (cons arg-3 arg-4) e-3)) (else (cons e-2 (LibrariesC-45DataC-45ANameMap-n--3439-7861-u--update arg-1 arg-2 arg-3 arg-4 e-3))))))))))
(define LibrariesC-45DataC-45ANameMap-n--3654-8049-u--insertFrom (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) arg-5 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45DataC-45ANameMap-n--3654-8049-u--insertFrom arg-1 arg-2 arg-3 e-3 (LibrariesC-45DataC-45ANameMap-addName e-6 e-7 arg-5)))))))))
(define LibrariesC-45DataC-45ANameMap-n--3630-8025-u--fromListC-39 (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45DataC-45ANameMap-n--3630-8025-u--fromListC-39 (LibrariesC-45DataC-45ANameMap-addName e-6 e-7 arg-1) e-3))))))))
(define LibrariesC-45DataC-45ANameMap-toList (lambda (arg-1) (LibrariesC-45DataC-45NameMap-toList (let ((e-1 (car arg-1))) e-1))))
(define LibrariesC-45DataC-45ANameMap-merge (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (LibrariesC-45DataC-45ANameMap-n--3654-8049-u--insertFrom e-2 e-1 arg-2 (LibrariesC-45DataC-45NameMap-toList e-1) arg-2)))))
(define LibrariesC-45DataC-45ANameMap-lookupName (lambda (arg-1 arg-2) (LibrariesC-45DataC-45ANameMap-case--lookupName-7766 arg-2 arg-1 (CoreC-45Name-userNameRoot arg-1))))
(define LibrariesC-45DataC-45ANameMap-lookupExact (lambda (arg-1 arg-2) (LibrariesC-45DataC-45NameMap-lookup arg-1 (let ((e-1 (car arg-2))) e-1))))
(define LibrariesC-45DataC-45ANameMap-fromList (lambda (ext-0) (LibrariesC-45DataC-45ANameMap-n--3630-8025-u--fromListC-39 (LibrariesC-45DataC-45ANameMap-empty) ext-0)))
(define LibrariesC-45DataC-45ANameMap-empty(blodwen-lazy (lambda () (cons (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45UserNameMap-empty)))))
(define LibrariesC-45DataC-45ANameMap-addToHier (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45ANameMap-case--addToHier-7932 arg-2 arg-3 arg-1 (CoreC-45Name-userNameRoot arg-1))))
(define LibrariesC-45DataC-45ANameMap-addName (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((u--dictC-39 (LibrariesC-45DataC-45NameMap-insert arg-1 arg-2 e-1))) (let ((u--hierC-39 (LibrariesC-45DataC-45ANameMap-addToHier arg-1 arg-2 e-2))) (cons u--dictC-39 u--hierC-39)))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-22979 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) (let ((u--gdef (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-18 (vector-ref arg-8 18))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (vector 1 (vector '() 1 0) '() (vector 1 0 arg-12) (vector 1 0 arg-12) '()) e-18 e-19 e-20 e-21)))))))))))))))))))))))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Resolved " (CoreC-45Name-u--show_Show_Name arg-2))) arg-12 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-1)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45UnifyState-removeGuess arg-5 arg-0 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (let ((e-1 (vector-ref arg-15 1))) e-1))))))))))))) (let ((u--gdef (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-18 (vector-ref arg-8 18))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (vector 9 arg-12 arg-11 arg-16) e-18 e-19 e-20 e-21)))))))))))))))))))))))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 0)))))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-22380 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (if (null? arg-15) (let ((act-24 (let ((e-3 (vector-ref arg-14 3))) (case (vector-ref e-3 0) ((0) (vector 1 arg-12)) ((1) (let ((e-4 (vector-ref e-3 1))) (vector 1 (CoreC-45Unify-forceMeta e-4 arg-11 arg-12)))) (else (let ((e-4 (vector-ref e-3 1))) (let ((act-24 ((CoreC-45GetType-getType '() arg-6 '() arg-12) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Retry Delay") arg-12 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-5) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45Unify-delayMeta '() e-4 arg-11 e-7 arg-12))))))))))))))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--gdef (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-22 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-18 (vector-ref arg-8 18))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (vector e-0 e-1 e-2 e-3 e-4 e-22 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (vector 1 (vector '() 1 0) '() (vector 1 0 e-5) (vector 1 0 e-5) '()) e-18 e-19 e-20 e-21)))))))))))))))))))))))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Resolved " (CoreC-45Name-u--show_Show_Name arg-2))) e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45UnifyState-removeGuess arg-5 arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (let ((e-1 (vector-ref arg-14 1))) e-1)))))))))))))))) (let ((act-24 (let ((e-3 (vector-ref arg-14 3))) (case (vector-ref e-3 0) ((0) (vector 1 arg-12)) ((1) (let ((e-4 (vector-ref e-3 1))) (vector 1 (CoreC-45Unify-forceMeta e-4 arg-11 arg-12)))) (else (let ((e-4 (vector-ref e-3 1))) (let ((act-24 ((CoreC-45GetType-getType '() arg-6 '() arg-12) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Retry Delay (constrained)") arg-12 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-5) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45Unify-delayMeta '() e-4 arg-11 e-7 arg-12))))))))))))))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--gdef (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-22 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-18 (vector-ref arg-8 18))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (vector e-0 e-1 e-2 e-3 e-4 e-22 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (vector 9 e-5 arg-11 arg-15) e-18 e-19 e-20 e-21)))))))))))))))))))))))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 0))))))))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32retryGuess-21882 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((8) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (let ((e-2 (vector-ref arg-10 3))) (lambda (eta-0) (CoreC-45UnifyState-handleUnify arg-6 arg-5 (lambda (eta-1) (let ((act-24 (CoreC-45Unify-search '() arg-6 arg-5 arg-1 e-0 (CoreC-45Unify-u--C-61C-61_Eq_SolveMode arg-3 1) e-1 e-2 (let ((e-22 (vector-ref arg-8 2))) e-22) '() eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--gdef (let ((e-25 (vector-ref arg-8 0))) (let ((e-24 (vector-ref arg-8 1))) (let ((e-23 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-22 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-18 (vector-ref arg-8 18))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (vector e-25 e-24 e-23 e-3 e-4 e-22 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (vector 1 (CoreC-45ContextC-45Context-defaultPI) '() (vector 1 0 e-5) (vector 1 0 e-5) '()) e-18 e-19 e-20 e-21)))))))))))))))))))))))) (let ((act-25 (CoreC-45Normalise-logTermNF '() arg-6 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Solved " (CoreC-45Name-u--show_Show_Name arg-2))) '() e-5 eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-2) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-2)) eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (CoreC-45UnifyState-removeGuess arg-5 arg-0 eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (vector 1 1)))))))))))))))) (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((30) (let ((e-6 (vector-ref lcase-0 3))) (let ((e-3 (vector-ref lcase-0 4))) (let ((act-24 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Failed (det " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) ")"))))) (let ((e-28 (vector-ref arg-8 2))) e-28) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((act-25 (CoreC-45Unify-setInvertible arg-6 arg-1 (vector 8 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (vector 1 0))))))))))(else (let ((act-24 (CoreC-45Normalise-logTermNF '() arg-6 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Search failed at " (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-0) (PreludeC-45TypesC-45String-C-43C-43 " for " (CoreC-45Name-u--show_Show_Name arg-2))))) '() (let ((e-22 (vector-ref arg-8 2))) e-22) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (cond ((equal? arg-3 3) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-0))(else (let ((sc2 (CoreC-45Unify-recoverable lcase-0))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-1 (let ((e-34 (vector-ref arg-7 0))) e-34) '() (let ((e-23 (vector-ref arg-8 2))) e-23) (box lcase-0)) clam-0))))))))))))) eta-0)))))) ((9) (let ((e-3 (vector-ref arg-10 1))) (let ((e-4 (vector-ref arg-10 2))) (let ((e-5 (vector-ref arg-10 3))) (if (null? e-5) (let ((u--umode (cond ((equal? arg-3 2) (CoreC-45Unify-inMatch))(else arg-4)))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Unify-retry arg-6 arg-5 u--umode eta-1 eta-2))) e-5 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--csAll (CoreC-45Unify-unionAll e-6))) ((CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-22979 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5 e-4 e-3 u--umode e-6 u--csAll (let ((e-0 (vector-ref u--csAll 0))) e-0)) eta-0)))))))) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (let ((u--umode (cond ((equal? arg-3 2) (CoreC-45Unify-inMatch))(else arg-4)))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-retry arg-6 arg-5 u--umode e-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-22380 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7 e-4 e-3 u--umode e-6 (let ((e-0 (vector-ref e-6 0))) e-0) eta-0))))))) (let ((u--umode (cond ((equal? arg-3 2) (CoreC-45Unify-inMatch))(else arg-4)))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Unify-retry arg-6 arg-5 u--umode eta-1 eta-2))) e-5 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--csAll (CoreC-45Unify-unionAll e-6))) ((CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-22979 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5 e-4 e-3 u--umode e-6 u--csAll (let ((e-0 (vector-ref u--csAll 0))) e-0)) eta-0))))))))))))))))(else (lambda (eta-0) (vector 1 0))))))
(define CoreC-45Unify-case--retry-21254 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 (CoreC-45Unify-success)) (let ((e-2 (unbox arg-5))) (case (vector-ref e-2 0) ((2) (vector 1 (CoreC-45Unify-success))) ((0) (let ((e-3 (vector-ref e-2 1))) (let ((e-4 (vector-ref e-2 2))) (let ((e-5 (vector-ref e-2 3))) (let ((e-6 (vector-ref e-2 4))) (let ((e-7 (vector-ref e-2 5))) (let ((e-8 (vector-ref e-2 6))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-3 e-9 e-6 e-7) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-3 e-9 e-6 e-8) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-27 (CoreC-45Normalise-logNF e-3 arg-0 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Retrying " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-1) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Unify-u--show_Show_UnifyMode (let ((e-1 (cdr arg-2))) e-1)))))) e-6 e-10 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((act-28 (CoreC-45Normalise-logNF e-3 arg-0 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "....with") e-6 e-11 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-0 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (cond ((equal? e-5 1) (lambda () "(lazy allowed)")) (else (lambda () "(no lazy)"))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((act-30 (cond ((equal? e-5 1) (((((CoreC-45Unify-unifyWithLazy (csegen-1965) e-3 arg-0 arg-3 arg-2 e-4) e-6) e-10) e-11) eta-0)) (else (((((CoreC-45Unify-unify (csegen-1965) e-3 arg-0 arg-3 (CoreC-45Unify-lower arg-2) e-4) e-6) e-10) e-11) eta-0))))) (case (vector-ref act-30 0) ((0) (let ((e-15 (vector-ref act-30 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-30 1))) (let ((e-0 (vector-ref e-15 0))) (if (null? e-0) (let ((act-31 (CoreC-45ContextC-45Log-log arg-0 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Success " (CoreC-45Unify-u--show_Show_AddLazy (let ((e-18 (vector-ref e-15 3))) e-18)))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-18 (vector-ref act-31 1))) (vector 0 e-18))) (else (let ((act-32 (CoreC-45UnifyState-deleteConstraint arg-3 arg-1 eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-19 (vector-ref act-32 1))) (vector 0 e-19))) (else (vector 1 e-15))))))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-0 "unify.retry" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Constraints " (CoreC-45Unify-u--show_Show_AddLazy (let ((e-18 (vector-ref e-15 3))) e-18)))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-18 (vector-ref act-31 1))) (vector 0 e-18))) (else (vector 1 e-15)))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-clearDefs e-12 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (let ((act-29 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 e-3 e-13 e-6 e-10 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 e-3 e-13 e-6 e-11 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-15 (vector-ref act-30 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-30 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 5 e-3 e-4 (let ((e-0 (vector-ref e-12 0))) e-0) e-6 e-14 e-15 u--err) eta-0))))))))))))))))))) clam-0)))))))))))))))))))) (else (let ((e-9 (vector-ref e-2 1))) (let ((e-10 (vector-ref e-2 2))) (let ((e-11 (vector-ref e-2 3))) (let ((e-12 (vector-ref e-2 4))) (let ((e-13 (vector-ref e-2 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-continueNF arg-0 e-9 e-5 e-11 eta-0)) e-12 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-continueNF arg-0 e-9 e-5 e-11 eta-0)) e-13 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Unify-unifyArgs (cons (csegen-1965) (vector (lambda (u--c) (lambda (u--vars) (lambda (arg-1928) (lambda (arg-1929) (lambda (arg-1931) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF u--c u--vars arg-1928 arg-1929 arg-1931 eta-0))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-1936) (lambda (arg-1937) (lambda (arg-1939) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteLHS_Quote_NF u--c u--vars arg-1936 arg-1937 arg-1939 eta-0))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-1942) (lambda (arg-1943) (lambda (arg-1944) (lambda (arg-1946) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF u--c u--vars arg-1942 arg-1943 arg-1944 arg-1946 eta-0)))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-1950) (lambda (arg-1953) (lambda (arg-1954) (lambda (arg-1955) (lambda (arg-1957) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF u--c u--vars arg-1950 arg-1953 arg-1954 arg-1955 arg-1957)))))))))) e-9 arg-0 arg-3 arg-2 e-10 e-11 e-6 e-7) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-0 (vector-ref e-8 0))) (if (null? e-0) (let ((act-28 (CoreC-45UnifyState-deleteConstraint arg-3 arg-1 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (vector 1 e-8)))) (vector 1 e-8)))))))))))))))))))))))))))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32unifyD-20392 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) ((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (case (vector-ref e-2 0) ((1) (let ((e-14 (vector-ref e-2 2))) (case (vector-ref e-14 0) ((2) (case (vector-ref e-3 0) ((1) (let ((e-22 (vector-ref e-3 2))) (case (vector-ref e-22 0) ((2) ((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12))(else (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-9 arg-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 arg-11 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 e-5 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-6) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-7) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) e-8) e-9) eta-0))))))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-0 (vector-ref e-8 0))) (if (null? e-0) (vector 1 e-8) (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-8 arg-3) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) e-10) eta-0))))))))))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-9 arg-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 arg-11 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 e-5 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-6) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-7) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) e-8) e-9) eta-0))))))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-0 (vector-ref e-8 0))) (if (null? e-0) (vector 1 e-8) (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-8 arg-3) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) e-10) eta-0)))))))))))))))))))))))))))(else (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 2))) (case (vector-ref e-6 0) ((2) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-9 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 e-8 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 arg-12 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-16) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-12) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-28 1))) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) e-17) e-18) eta-0))))))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-27 1))) (let ((e-0 (vector-ref e-17 0))) (if (null? e-0) (vector 1 e-17) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12) eta-0)))))))))))))))))))))(else ((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12)))))(else ((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12)))))))(else (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 2))) (case (vector-ref e-6 0) ((2) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-9 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 e-8 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 arg-12 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-13) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-12) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-28 1))) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) e-14) e-15) eta-0))))))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-27 1))) (let ((e-0 (vector-ref e-14 0))) (if (null? e-0) (vector 1 e-14) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12) eta-0)))))))))))))))))))))(else ((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12)))))(else ((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12))))))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32unifyBothBinders-17734 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 ext-0) (if (null? arg-26) (let ((act-24 (((arg-12 arg-20) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-15 (vector 1 arg-16 (vector 0 ) arg-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((arg-9 arg-20) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-15 (vector 1 arg-16 (vector 0 ) arg-24))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-19 arg-0 arg-21 arg-15 e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-19 arg-0 arg-21 arg-15 e-6 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (((((CoreC-45Unify-unify (csegen-1962) (cons arg-13 arg-0) arg-19 arg-18 (CoreC-45Unify-lower arg-17) arg-16) arg-25) (CoreC-45TT-refsToLocals (vector 1 arg-13 arg-24 (vector 0 )) e-7)) (CoreC-45TT-refsToLocals (vector 1 arg-13 arg-24 (vector 0 )) e-8)) ext-0))))))))))))))))) (let ((act-24 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-19 arg-0 arg-21 arg-15 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-19 arg-0 arg-21 arg-15 arg-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45UnifyState-newConstant arg-0 arg-18 arg-19 arg-16 (csegen-21) arg-15 (vector 3 arg-14 arg-13 (vector 0 arg-8 arg-7 (vector 1 ) e-5) (vector 0 arg-14 '() 0)) (vector 3 arg-14 arg-13 (vector 2 arg-8 arg-7 (vector 1 ) e-5) (CoreC-45TT-u--weaken_Weaken_Term e-6)) arg-26) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (((arg-12 arg-20) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-15 (vector 1 arg-16 (vector 0 ) arg-24))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (((arg-9 arg-20) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-15 (vector 4 arg-16 e-7 (vector 1 arg-16 (vector 0 ) arg-24)))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-19 arg-0 arg-21 arg-15 e-8 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-19 arg-0 arg-21 arg-15 e-9 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (((((CoreC-45Unify-unify (csegen-1962) (cons arg-13 arg-0) arg-19 arg-18 (CoreC-45Unify-lower arg-17) arg-16) arg-25) (CoreC-45TT-refsToLocals (vector 1 arg-13 arg-24 (vector 0 )) e-10)) (CoreC-45TT-refsToLocals (vector 1 arg-13 arg-24 (vector 0 )) e-11)) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (CoreC-45Unify-union arg-23 e-12)))))))))))))))))))))))))))))))))))))
(define CoreC-45Unify-case--headsConvert-13243 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (lambda (clam-0) (if (null? e-2) (vector 1 0) (let ((e-5 (car e-2))) (if (null? e-3) (vector 1 0) (let ((e-8 (car e-3))) (let ((act-24 (CoreC-45Normalise-logNF arg-0 arg-7 "unify.head" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unifying head") arg-3 e-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Normalise-logNF arg-0 arg-7 "unify.head" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () ".........with") arg-3 e-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-7 arg-6 arg-5 arg-4) arg-3) e-5) e-8) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (DataC-45List-isNil (let ((e-0 (vector-ref e-11 0))) e-0)))))))))))))))))))))))
(define CoreC-45Unify-case--occursCheck-10289 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (cond ((equal? arg-8 0) (vector 1 (box arg-1)))(else (let ((act-24 (let ((act-24 (unbox arg-6))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normalise arg-6 arg-0 e-5 arg-4 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Unify-getMetaNames arg-6 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc3 (PreludeC-45Types-elem (csegen-802) arg-2 e-7))) (cond ((equal? sc3 1) (let ((act-27 ((CoreC-45Unify-n--9279-10070-u--failOnStrongRigid arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 4 arg-0 arg-5 arg-4 arg-2 e-6) eta-0)) e-6) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 '()))))) (else (vector 1 (box e-6)))))))))))))))))))))
(define CoreC-45Unify-case--occursCheckC-44failOnStrongRigid-10151 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (if (null? e-3) (lambda (eta-0) (vector 1 0)) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((1) (vector 1 0))(else (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Unify-n--9279-10070-u--failOnStrongRigid arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 1 arg-8 eta-0)) e-3 clam-0)))))(else (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Unify-n--9279-10070-u--failOnStrongRigid arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-8 eta-0)) e-3 clam-0)))))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32patternEnvTm-10026 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (box (cons e-2 (cons (CoreC-45Unify-n--9064-9888-u--updateVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-7 e-3) e-3)))))))
(define CoreC-45Unify-case--patternEnvTm-9987 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) '() (let ((e-2 (unbox arg-7))) (CoreC-45Unify-case--caseC-32blockC-32inC-32patternEnvTm-10026 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 (CoreC-45Unify-toSubVars arg-0 e-2))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32patternEnv-9755 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (box (cons e-2 (cons (CoreC-45Unify-n--8732-9602-u--updateVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-8 e-3) e-3)))))))
(define CoreC-45Unify-case--patternEnv-9712 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (let ((e-2 (unbox arg-8))) (CoreC-45Unify-case--caseC-32blockC-32inC-32patternEnv-9755 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-2 (CoreC-45Unify-toSubVars arg-0 e-2))))))
(define CoreC-45Unify-case--chaseMetas-8743 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact arg-0 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) ((CoreC-45Unify-chaseMetas arg-3 arg-1 (LibrariesC-45DataC-45NameMap-insert arg-0 0 arg-2)) eta-0) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((1) (let ((e-4 (vector-ref e-1 3))) (case (vector-ref e-4 0) ((1) (let ((e-9 (vector-ref e-4 2))) (let ((u--sns (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-9)))) ((CoreC-45Unify-chaseMetas arg-3 (PreludeC-45TypesC-45List-tailRecAppend u--sns arg-1) (LibrariesC-45DataC-45NameMap-insert arg-0 0 arg-2)) eta-0))))(else ((CoreC-45Unify-chaseMetas arg-3 arg-1 (LibrariesC-45DataC-45NameMap-insert arg-0 0 arg-2)) eta-0)))))(else ((CoreC-45Unify-chaseMetas arg-3 arg-1 (LibrariesC-45DataC-45NameMap-insert arg-0 0 arg-2)) eta-0)))))))))))))) (CoreC-45Unify-chaseMetas arg-3 arg-1 arg-2))))
(define CoreC-45Unify-n--9064-9888-u--updateVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (CoreC-45TT-subElem e-2 arg-7))) (if (null? sc1) (CoreC-45Unify-n--9064-9888-u--updateVars arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-7) (let ((e-4 (unbox sc1))) (cons e-4 (CoreC-45Unify-n--9064-9888-u--updateVars arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-7))))))))))
(define CoreC-45Unify-n--8732-9602-u--updateVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (CoreC-45TT-subElem e-2 arg-7))) (if (null? sc1) (CoreC-45Unify-n--8732-9602-u--updateVars arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-7) (let ((e-4 (unbox sc1))) (cons e-4 (CoreC-45Unify-n--8732-9602-u--updateVars arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-7))))))))))
(define CoreC-45Unify-n--9911-11297-u--updateIVarsPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (case (vector-ref arg-24 0) ((1) (box (vector 1 ))) ((0) (box (vector 0 ))) ((2) (box (vector 2 ))) (else (let ((e-4 (vector-ref arg-24 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-4) (lambda (u--tC-39) (box (vector 3 u--tC-39)))))))))
(define CoreC-45Unify-n--9911-11298-u--updateIVarsB (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (case (vector-ref arg-24 0) ((0) (let ((e-1 (vector-ref arg-24 1))) (let ((e-2 (vector-ref arg-24 2))) (let ((e-3 (vector-ref arg-24 3))) (let ((e-4 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9911-11297-u--updateIVarsPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 e-3) (lambda (u--pC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-4) (lambda (bind-0) (box (vector 0 e-1 e-2 u--pC-39 bind-0))))))))))) ((1) (let ((e-6 (vector-ref arg-24 1))) (let ((e-7 (vector-ref arg-24 2))) (let ((e-8 (vector-ref arg-24 3))) (let ((e-9 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-8) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-9) (lambda (bind-1) (box (vector 1 e-6 e-7 bind-0 bind-1))))))))))) ((2) (let ((e-11 (vector-ref arg-24 1))) (let ((e-12 (vector-ref arg-24 2))) (let ((e-13 (vector-ref arg-24 3))) (let ((e-14 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9911-11297-u--updateIVarsPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 e-13) (lambda (u--pC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-14) (lambda (bind-0) (box (vector 2 e-11 e-12 u--pC-39 bind-0))))))))))) ((3) (let ((e-16 (vector-ref arg-24 1))) (let ((e-17 (vector-ref arg-24 2))) (let ((e-18 (vector-ref arg-24 3))) (let ((e-19 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9911-11297-u--updateIVarsPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 e-18) (lambda (u--pC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-19) (lambda (bind-0) (box (vector 3 e-16 e-17 u--pC-39 bind-0))))))))))) ((4) (let ((e-21 (vector-ref arg-24 1))) (let ((e-22 (vector-ref arg-24 2))) (let ((e-23 (vector-ref arg-24 3))) (let ((e-24 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-23) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-24) (lambda (bind-1) (box (vector 4 e-21 e-22 bind-0 bind-1))))))))))) (else (let ((e-26 (vector-ref arg-24 1))) (let ((e-27 (vector-ref arg-24 2))) (let ((e-28 (vector-ref arg-24 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-28) (lambda (bind-0) (box (vector 5 e-26 e-27 bind-0)))))))))))
(define CoreC-45Unify-n--9884-10621-u--updateIVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-17 0) ((0) (let ((e-2 (vector-ref arg-17 1))) (let ((e-3 (vector-ref arg-17 2))) (let ((e-4 (vector-ref arg-17 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10620-u--updateIVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-4 arg-16) (lambda (_-0) (box (vector 0 e-2 e-3 _-0)))))))) ((1) (let ((e-7 (vector-ref arg-17 1))) (let ((e-8 (vector-ref arg-17 2))) (let ((e-9 (vector-ref arg-17 3))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 e-7 e-8 e-9)))))) ((2) (let ((e-11 (vector-ref arg-17 1))) (let ((e-12 (vector-ref arg-17 2))) (let ((e-13 (vector-ref arg-17 3))) (let ((e-14 (vector-ref arg-17 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 eta-0)) e-14) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 e-11 e-12 e-13 bind-0))))))))) ((3) (let ((e-16 (vector-ref arg-17 1))) (let ((e-17 (vector-ref arg-17 2))) (let ((e-18 (vector-ref arg-17 3))) (let ((e-19 (vector-ref arg-17 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9911-11298-u--updateIVarsB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 e-17 e-19 e-18 e-16 arg-14 arg-16 arg-14 arg-15 arg-16 e-18) (lambda (u--bC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-17 arg-14) (cons e-17 arg-15) (cons (box 0) (CoreC-45Unify-u--weaken_Weaken_C-40IVarsC-32C-36vsC-41 arg-16)) e-19) (lambda (u--scC-39) (box (vector 3 e-16 e-17 u--bC-39 u--scC-39))))))))))) ((4) (let ((e-21 (vector-ref arg-17 1))) (let ((e-22 (vector-ref arg-17 2))) (let ((e-23 (vector-ref arg-17 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-22) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-23) (lambda (bind-1) (box (vector 4 e-21 bind-0 bind-1)))))))))) ((5) (let ((e-25 (vector-ref arg-17 1))) (let ((e-26 (vector-ref arg-17 2))) (let ((e-27 (vector-ref arg-17 3))) (let ((e-28 (vector-ref arg-17 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-27) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-28) (lambda (bind-1) (box (vector 5 e-25 e-26 bind-0 bind-1))))))))))) ((6) (let ((e-30 (vector-ref arg-17 1))) (let ((e-31 (vector-ref arg-17 2))) (let ((e-32 (vector-ref arg-17 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-32) (lambda (bind-0) (box (vector 6 e-30 e-31 bind-0)))))))) ((7) (let ((e-34 (vector-ref arg-17 1))) (let ((e-35 (vector-ref arg-17 2))) (let ((e-36 (vector-ref arg-17 3))) (let ((e-37 (vector-ref arg-17 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-36) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-37) (lambda (bind-1) (box (vector 7 e-34 e-35 bind-0 bind-1))))))))))) ((8) (let ((e-39 (vector-ref arg-17 1))) (let ((e-40 (vector-ref arg-17 2))) (let ((e-41 (vector-ref arg-17 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-41) (lambda (bind-0) (box (vector 8 e-39 e-40 bind-0)))))))) ((9) (let ((e-43 (vector-ref arg-17 1))) (let ((e-44 (vector-ref arg-17 2))) (box (vector 9 e-43 e-44))))) ((10) (let ((e-46 (vector-ref arg-17 1))) (let ((e-47 (vector-ref arg-17 2))) (box (vector 10 e-46 e-47))))) (else (let ((e-49 (vector-ref arg-17 1))) (box (vector 11 e-49)))))))
(define CoreC-45Unify-n--9884-10620-u--updateIVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 arg-18) (if (null? arg-18) '() (let ((e-3 (car arg-18))) (let ((e-4 (cdr arg-18))) (if (null? e-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10620-u--updateIVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 e-4) (csegen-549)) (let ((e-7 (unbox e-3))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-15 e-7))) (cond ((equal? sc2 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--9884-10620-u--updateIVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 e-4) (csegen-549))))))))))))
(define CoreC-45Unify-n--15363-15429-u--solveOrElsePostpone (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 ext-0) (let ((act-24 (CoreC-45Unify-solveHole arg-12 arg-11 arg-16 arg-0 arg-6 arg-9 arg-7 arg-5 arg-4 arg-3 arg-2 arg-17 arg-18 arg-26 arg-28 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (DataC-45Maybe-fromMaybe eta-0 eta-1))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0))) e-5) (lambda () (CoreC-45Unify-postponeS arg-0 arg-12 arg-11 arg-10 arg-8 arg-9 "Can't instantiate" arg-7 (vector 1 arg-8 (vector 2 arg-5 arg-4 arg-3) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-2)) arg-1))) ext-0)))))))
(define CoreC-45Unify-n--12470-14412-u--solutionHeadSame (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-16 0) ((1) (let ((e-2 (vector-ref arg-16 2))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 arg-9)))(else 0))))(else 0))))
(define CoreC-45Unify-n--12490-16722-u--pv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-16 0) ((3) 1)(else 0))))
(define CoreC-45Unify-n--9884-10618-u--noMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 arg-16) (case (vector-ref arg-15 0) ((4) (let ((e-2 (vector-ref arg-15 2))) (let ((e-3 (vector-ref arg-15 3))) (cond ((equal? arg-16 0) 0)(else (let ((e-47 (- arg-16 1))) (let ((sc1 (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2 e-47))) (cond ((equal? sc1 1) (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3 e-47)) (else 0))))))))) ((3) (let ((e-7 (vector-ref arg-15 3))) (let ((e-8 (vector-ref arg-15 4))) (cond ((equal? arg-16 0) 0)(else (let ((e-48 (- arg-16 1))) (let ((sc1 (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (CoreC-45TT-binderType e-7) e-48))) (cond ((equal? sc1 1) (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-8 e-48)) (else 0))))))))) ((2) 0) ((6) (let ((e-17 (vector-ref arg-15 3))) (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-17 arg-16))) ((7) (let ((e-21 (vector-ref arg-15 3))) (let ((e-22 (vector-ref arg-15 4))) (let ((sc1 (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-21 arg-16))) (cond ((equal? sc1 1) (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-22 arg-16)) (else 0)))))) ((8) (let ((e-26 (vector-ref arg-15 3))) (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-26 arg-16))) ((5) (let ((e-30 (vector-ref arg-15 3))) (let ((e-31 (vector-ref arg-15 4))) (let ((sc1 (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-30 arg-16))) (cond ((equal? sc1 1) (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-31 arg-16)) (else 0)))))) ((0) 1) ((1) 1) ((9) 1) ((11) 1)(else 0))))
(define CoreC-45Unify-n--9884-10622-u--mkDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (if (null? arg-16) (case (vector-ref arg-19 0) ((3) (let ((e-2 (vector-ref arg-19 1))) (let ((e-3 (vector-ref arg-19 2))) (let ((e-4 (vector-ref arg-19 3))) (let ((e-5 (vector-ref arg-19 4))) (case (vector-ref e-4 0) ((1) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-9 (vector-ref e-4 3))) (let ((e-10 (vector-ref e-4 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45Unify-n--9884-10622-u--mkDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-3 arg-14) arg-15 arg-16 (cons '() arg-17) arg-18 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (if (null? eta-2) (vector 1 '()) (let ((e-11 (unbox eta-2))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (eta-1 e-11) eta-3)))))) e-6 (lambda (u--scC-39) (let ((u--b (vector 1 e-7 e-8 e-9 e-10))) (lambda (clam-2) (let ((sc4 (CoreC-45TT-shrinkTerm u--scC-39 (vector 1 (vector 0 ))))) (if (null? sc4) (vector 1 (vector 3 e-2 e-3 u--b u--scC-39)) (let ((e-1 (unbox sc4))) (vector 1 e-1)))))))) eta-0)))))))))))(else (if (null? arg-16) (lambda (clam-4) (let ((sc3 (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc3) (CoreC-45Unify-ufail arg-11 (PreludeC-45TypesC-45String-C-43C-43 "Can't make solution for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-2070) (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-4) (let ((e-1 (unbox sc3))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))(else (if (null? arg-16) (lambda (clam-5) (let ((sc2 (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc2) (CoreC-45Unify-ufail arg-11 (PreludeC-45TypesC-45String-C-43C-43 "Can't make solution for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-2070) (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-5) (let ((e-1 (unbox sc2))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))) (let ((e-12 (car arg-16))) (let ((e-13 (cdr arg-16))) (case (vector-ref arg-19 0) ((3) (let ((e-15 (vector-ref arg-19 1))) (let ((e-16 (vector-ref arg-19 2))) (let ((e-17 (vector-ref arg-19 3))) (let ((e-18 (vector-ref arg-19 4))) (case (vector-ref e-17 0) ((2) (let ((e-20 (vector-ref e-17 1))) (let ((e-21 (vector-ref e-17 2))) (lambda (eta-0) (let ((act-24 ((CoreC-45Unify-n--9884-10622-u--mkDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-16 arg-14) arg-15 e-13 (cons (box e-12) arg-17) arg-18 e-18) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-1) (vector 3 e-15 e-16 (vector 0 e-20 e-21 (vector 1 ) (vector 10 e-15 0)) eta-1)) e-5))))))))))(else (case (vector-ref arg-19 0) ((3) (let ((e-2 (vector-ref arg-19 1))) (let ((e-3 (vector-ref arg-19 2))) (let ((e-4 (vector-ref arg-19 3))) (let ((e-5 (vector-ref arg-19 4))) (case (vector-ref e-4 0) ((1) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-9 (vector-ref e-4 3))) (let ((e-10 (vector-ref e-4 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45Unify-n--9884-10622-u--mkDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-3 arg-14) arg-15 arg-16 (cons '() arg-17) arg-18 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (if (null? eta-2) (vector 1 '()) (let ((e-11 (unbox eta-2))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (eta-1 e-11) eta-3)))))) e-6 (lambda (u--scC-39) (let ((u--b (vector 1 e-7 e-8 e-9 e-10))) (lambda (clam-0) (let ((sc5 (CoreC-45TT-shrinkTerm u--scC-39 (vector 1 (vector 0 ))))) (if (null? sc5) (vector 1 (vector 3 e-2 e-3 u--b u--scC-39)) (let ((e-1 (unbox sc5))) (vector 1 e-1)))))))) eta-0)))))))))))(else (if (null? arg-16) (lambda (clam-0) (let ((sc4 (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc4) (CoreC-45Unify-ufail arg-11 (PreludeC-45TypesC-45String-C-43C-43 "Can't make solution for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-2070) (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-0) (let ((e-1 (unbox sc4))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))(else (if (null? arg-16) (lambda (clam-1) (let ((sc3 (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc3) (CoreC-45Unify-ufail arg-11 (PreludeC-45TypesC-45String-C-43C-43 "Can't make solution for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-2070) (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-1) (let ((e-1 (unbox sc3))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))))(else (case (vector-ref arg-19 0) ((3) (let ((e-2 (vector-ref arg-19 1))) (let ((e-3 (vector-ref arg-19 2))) (let ((e-4 (vector-ref arg-19 3))) (let ((e-5 (vector-ref arg-19 4))) (case (vector-ref e-4 0) ((1) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-9 (vector-ref e-4 3))) (let ((e-10 (vector-ref e-4 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45Unify-n--9884-10622-u--mkDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-3 arg-14) arg-15 arg-16 (cons '() arg-17) arg-18 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (if (null? eta-2) (vector 1 '()) (let ((e-11 (unbox eta-2))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (eta-1 e-11) eta-3)))))) e-6 (lambda (u--scC-39) (let ((u--b (vector 1 e-7 e-8 e-9 e-10))) (lambda (clam-1) (let ((sc4 (CoreC-45TT-shrinkTerm u--scC-39 (vector 1 (vector 0 ))))) (if (null? sc4) (vector 1 (vector 3 e-2 e-3 u--b u--scC-39)) (let ((e-1 (unbox sc4))) (vector 1 e-1)))))))) eta-0)))))))))))(else (if (null? arg-16) (lambda (clam-2) (let ((sc3 (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc3) (CoreC-45Unify-ufail arg-11 (PreludeC-45TypesC-45String-C-43C-43 "Can't make solution for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-2070) (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-2) (let ((e-1 (unbox sc3))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))(else (if (null? arg-16) (lambda (clam-3) (let ((sc2 (CoreC-45Unify-n--9884-10621-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc2) (CoreC-45Unify-ufail arg-11 (PreludeC-45TypesC-45String-C-43C-43 "Can't make solution for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-2070) (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-3) (let ((e-1 (unbox sc2))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))))
(define CoreC-45Unify-n--12490-16723-u--localsIn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-16) (vector 1 0) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (let ((act-24 (let ((act-24 (unbox arg-15))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-15 arg-0 e-5 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-7 (vector-ref e-6 2))) (case (vector-ref e-7 0) ((0) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (+ 1 e-10)))))))(else (CoreC-45Unify-n--12490-16723-u--localsIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-3 ext-0)))))(else (CoreC-45Unify-n--12490-16723-u--localsIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-3 ext-0))))))))))))))))
(define CoreC-45Unify-n--9884-10619-u--isSimple (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15) (case (vector-ref arg-15 0) ((2) 1) ((3) (let ((e-8 (vector-ref arg-15 3))) (let ((e-9 (vector-ref arg-15 4))) (case (vector-ref e-8 0) ((0) (CoreC-45Unify-n--9884-10619-u--isSimple arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-9))(else (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 0)))))) ((4) (let ((e-12 (vector-ref arg-15 2))) (let ((e-13 (vector-ref arg-15 3))) (let ((sc1 (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-12 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))) (cond ((equal? sc1 1) (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-13 (+ 1 (+ 1 (+ 1 0))))) (else 0))))))(else (CoreC-45Unify-n--9884-10618-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 0)))))
(define CoreC-45Unify-n--12458-14069-u--isPatName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-17 0) ((3) 1)(else 0))))
(define CoreC-45Unify-n--12509-19044-u--isDelay (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((5) 1)(else 0))))
(define CoreC-45Unify-n--12470-14411-u--inNoSolve (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((sc0 (LibrariesC-45DataC-45IntMap-lookup arg-16 arg-17))) (if (null? sc0) 0 1))))
(define CoreC-45Unify-n--8485-9391-u--inArgs (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) 0 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-8 e-2))) (cond ((equal? sc1 1) 1) (else (CoreC-45Unify-n--8485-9391-u--inArgs arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)))))))))
(define CoreC-45Unify-n--24691-23736-u--getHoleName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 2))) (case (vector-ref e-2 0) ((2) (let ((e-9 (vector-ref e-2 1))) (vector 1 (box e-9))))(else (vector 1 '())))))(else (vector 1 '())))))))))))))
(define CoreC-45Unify-n--9279-10070-u--failOnStrongRigid (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((2) (let ((e-2 (vector-ref arg-9 2))) (let ((sc1 (cond ((equal? arg-7 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-2 arg-2)) (else 0)))) (cond ((equal? sc1 1) arg-8) (else (lambda (eta-0) (vector 1 0)))))))(else (CoreC-45Unify-case--occursCheckC-44failOnStrongRigid-10151 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-8 arg-7 (CoreC-45TT-getFnArgs arg-9))))))
(define CoreC-45Unify-n--24241-23335-u--constraintToHole (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (vector 1 0) (let ((e-1 (unbox e-8))) (case (vector-ref e-1 0) ((8) (CoreC-45Context-updateDef arg-1 (vector 8 e-2) (csegen-2078) clam-0)) ((9) (CoreC-45Context-updateDef arg-1 (vector 8 e-2) (csegen-2078) clam-0))(else (vector 1 0))))))))))))))))))
(define CoreC-45Unify-n--7927-8865-u--checkDefined (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (case (vector-ref arg-10 0) ((1) (let ((e-2 (vector-ref arg-10 2))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-6 (let ((e-0 (vector-ref arg-9 0))) e-0)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-8 arg-6 e-6 clam-0) (vector 1 0))))))))(else (vector 1 0)))))(else (vector 1 0))))))
(define CoreC-45Unify-n--24691-23737-u--checkConstraint (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (if (null? e-3) (vector 1 0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (let ((e-9 (vector-ref e-7 2))) (let ((e-11 (vector-ref e-7 4))) (let ((e-12 (vector-ref e-7 5))) (let ((e-13 (vector-ref e-7 6))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-8 e-5 e-11 e-12) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-8 e-5 e-11 e-13) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Normalise-logNF e-8 arg-0 "unify.constraint" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Dot") e-11 e-15 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (CoreC-45Normalise-logNF e-8 arg-0 "unify.constraint" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "  =") e-11 e-14 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (let ((act-29 (unbox arg-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-29 1))) (CoreC-45UnifyState-handleUnify arg-0 arg-1 (lambda (eta-0) (let ((act-30 (let ((act-30 (unbox arg-0))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-30 1))) (let ((act-31 ((CoreC-45Context-getPosition e-2 (let ((e-0 (vector-ref e-19 0))) e-0)) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-31 1))) (let ((e-21 (car e-20))) (let ((act-32 (CoreC-45Unify-n--24691-23736-u--getHoleName arg-0 arg-1 (vector 2 e-9 e-2 e-21 '()) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-22 (vector-ref act-32 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-32 1))) (let ((act-33 (((((CoreC-45Unify-unify (csegen-1965) e-8 arg-0 arg-1 (CoreC-45Unify-inMatch) e-9) e-11) e-14) e-15) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-23 (vector-ref act-33 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-33 1))) (let ((act-34 (let ((act-34 (unbox arg-0))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-24 (vector-ref act-34 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-34 1))) (let ((act-35 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 0))) (lambda () (lambda (u--n) (lambda (eta-1) (let ((act-35 (CoreC-45Context-lookupDefExact u--n (let ((e-0 (vector-ref e-24 0))) e-0) eta-1))) (case (vector-ref act-35 0) ((0) (let ((e-25 (vector-ref act-35 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-35 1))) (if (null? e-25) (CoreC-45Context-undefinedName arg-0 e-9 u--n eta-1) (let ((e-1 (unbox e-25))) (vector 1 (case (vector-ref e-1 0) ((7) 0)(else 1)))))))))))) e-22) eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-25 (vector-ref act-35 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-35 1))) (let ((act-36 (CoreC-45Unify-checkArgsSame arg-1 arg-0 (let ((e-27 (vector-ref e-23 2))) e-27) eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-26 (vector-ref act-36 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-36 1))) (let ((sc17 (let ((sc18 (DataC-45List-isNil (let ((e-0 (vector-ref e-23 0))) e-0)))) (cond ((equal? sc18 1) (cond ((equal? e-25 1) 1) (else e-26))) (else 1))))) (cond ((equal? sc17 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Dot pattern match fail") eta-0)) (else (vector 1 0)))))))))))))))))))))))))))))))))) (lambda (u--err) (lambda (clam-1) (case (vector-ref u--err 0) ((57) (let ((act-30 (let ((act-30 (unbox arg-0))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Context-lookupTyExact e-2 (let ((e-48 (vector-ref e-19 0))) e-48) clam-1))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-31 1))) (if (null? e-20) (CoreC-45Context-undefinedName arg-0 e-9 e-2 clam-1) (let ((e-1 (unbox e-20))) (let ((act-32 (CoreC-45Normalise-logTermNF '() arg-0 "unify.constraint" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Dot type") '() e-1 clam-1))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 (let ((act-33 (set-box! arg-1 (let ((e-32 (vector-ref e-18 0))) (let ((e-31 (vector-ref e-18 1))) (let ((e-30 (vector-ref e-18 2))) (let ((e-29 (vector-ref e-18 3))) (let ((e-4 (vector-ref e-18 4))) (let ((e-28 (vector-ref e-18 5))) (let ((e-27 (vector-ref e-18 6))) (let ((e-25 (vector-ref e-18 8))) (let ((e-24 (vector-ref e-18 9))) (let ((e-23 (vector-ref e-18 10))) (let ((e-22 (vector-ref e-18 11))) (vector e-32 e-31 e-30 e-29 e-4 e-28 e-27 '() e-25 e-24 e-23 e-22))))))))))))))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((act-34 (CoreC-45Context-clearDefs e-19 clam-1))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-23 (vector-ref act-34 1))) (let ((act-35 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 e-8 e-23 e-11 e-14 clam-1))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((e-24 (vector-ref act-35 1))) (let ((act-36 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 e-8 e-23 e-11 e-15 clam-1))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-36 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 44 e-8 e-9 e-11 e-6 e-24 e-25) clam-1))))))))))))))))))))))))))))))(else (let ((act-30 (let ((act-30 (set-box! arg-1 (let ((e-0 (vector-ref e-18 0))) (let ((e-1 (vector-ref e-18 1))) (let ((e-27 (vector-ref e-18 2))) (let ((e-26 (vector-ref e-18 3))) (let ((e-4 (vector-ref e-18 4))) (let ((e-25 (vector-ref e-18 5))) (let ((e-24 (vector-ref e-18 6))) (let ((e-22 (vector-ref e-18 8))) (let ((e-21 (vector-ref e-18 9))) (let ((e-20 (vector-ref e-18 10))) (let ((e-19 (vector-ref e-18 11))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-24 '() e-22 e-21 e-20 e-19))))))))))))))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-1)))))))) clam-0)))))))))))))))))))))))))))))(else (vector 1 0))))))))))))
(define CoreC-45Unify-n--24376-23471-u--anySame (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 0) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Unify-n--24376-23471-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 ext-0) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((1) (let ((e-9 (vector-ref e-1 2))) (let ((e-4 (vector-ref e-1 3))) (if (null? e-9) (case (vector-ref e-4 0) ((1) (let ((e-12 (vector-ref e-4 1))) (let ((e-11 (vector-ref e-4 2))) (cond ((equal? e-12 0) (let ((act-26 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-2 '() e-5 '() arg-4 e-11 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) (cond ((equal? e-13 1) (vector 1 1)) (else (CoreC-45Unify-n--24376-23471-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 ext-0))))))))(else (CoreC-45Unify-n--24376-23471-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 ext-0))))))(else (CoreC-45Unify-n--24376-23471-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 ext-0))) (CoreC-45Unify-n--24376-23471-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 ext-0)))))(else (CoreC-45Unify-n--24376-23471-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 ext-0))))))))))))))))))
(define CoreC-45Unify-n--8616-9500-u--anyFirst (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) 0 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cond ((equal? e-2 0) 1)(else (CoreC-45Unify-n--8616-9500-u--anyFirst arg-0 arg-1 arg-2 e-3))))))))
(define CoreC-45Unify-n--24183-23281-u--afterStart (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6) (let ((e-2 (car arg-6))) (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-2 arg-2))))
(define CoreC-45Unify-u--weaken_Weaken_C-40IVarsC-32C-36vsC-41 (lambda (arg-3) (if (null? arg-3) '() (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (if (null? e-4) (cons '() (CoreC-45Unify-u--weaken_Weaken_C-40IVarsC-32C-36vsC-41 e-5)) (let ((e-8 (unbox e-4))) (cons (box (CoreC-45TT-u--weaken_Weaken_Var e-8)) (CoreC-45Unify-u--weaken_Weaken_C-40IVarsC-32C-36vsC-41 e-5)))))))))
(define CoreC-45Unify-u--unifyWithLazyD_Unify_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-6 arg-7))) (cond ((equal? sc2 1) (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "unify.equal" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Skipped unification (equal already): " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-6) (PreludeC-45TypesC-45String-C-43C-43 " and " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-7))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45Unify-success)))))) (else (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (((((CoreC-45Unify-unifyWithLazy (csegen-1965) arg-0 arg-1 arg-2 arg-3 arg-4) arg-5) e-7) e-8) ext-0)))))))))))))))))))))
(define CoreC-45Unify-u--unifyWithLazyD_Unify_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((5) (let ((e-5 (vector-ref arg-6 1))) (let ((e-6 (vector-ref arg-6 2))) (let ((e-7 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-11 (vector-ref arg-7 3))) ((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-7) e-11)))(else (let ((u--x (vector 5 e-5 e-6 e-7))) (lambda (clam-0) (let ((sc1 (let ((sc2 (CoreC-45Unify-isHoleApp arg-7))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc1 1) (CoreC-45Unify-postpone arg-0 arg-1 arg-2 arg-4 arg-3 "Postponing in lazy" arg-5 u--x arg-7 clam-0)) (else (let ((act-24 (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-7) arg-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (vector 1 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (vector e-0 e-1 e-2 (vector 1 e-6)))))))))))))))))))))(else (case (vector-ref arg-7 0) ((5) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) arg-6) e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-0 (vector-ref e-5 0))) (let ((e-7 (vector-ref e-5 1))) (let ((e-6 (vector-ref e-5 2))) (vector e-0 e-7 e-6 (vector 2 e-2))))))))))))))(else ((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-3 arg-4) arg-5) arg-6) arg-7)))))))
(define CoreC-45Unify-u--unifyWithLazyD_Unify_Closure (lambda (arg-0 ext-7 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-0) (CoreC-45Unify-u--unifyD_Unify_Closure arg-0 ext-7 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-0)))
(define CoreC-45Unify-u--unifyD_Unify_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-6 arg-7))) (cond ((equal? sc2 1) (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "unify.equal" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Skipped unification (equal already): " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-6) (PreludeC-45TypesC-45String-C-43C-43 " and " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-7))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45Unify-success)))))) (else (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 arg-3 arg-4) arg-5) e-7) e-8) ext-0)))))))))))))))))))))
(define CoreC-45Unify-u--unifyD_Unify_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((0) (let ((e-21 (vector-ref arg-7 1))) (let ((e-22 (vector-ref arg-7 2))) (let ((e-23 (vector-ref arg-7 3))) (let ((e-24 (vector-ref arg-7 4))) (CoreC-45Unify-unifyBothBinders arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 e-11 e-12 e-13 e-14 e-21 e-22 e-23 e-24))))))(else (case (vector-ref e-13 0) ((0) (let ((e-16 (vector-ref e-13 1))) (let ((e-17 (vector-ref e-13 2))) (let ((e-18 (vector-ref e-13 3))) (let ((e-19 (vector-ref e-13 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "EtaR") arg-5 arg-6 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "...with") arg-5 arg-7 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((u--tmx (vector 0 e-11 e-12 (vector 0 e-16 e-17 e-18 e-19) e-14))) (let ((sc5 (CoreC-45Unify-isHoleApp arg-7))) (cond ((equal? sc5 1) (let ((act-27 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-1 arg-0 e-5 arg-5 u--tmx arg-7 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 u--tmx arg-7) eta-0)))))))) (else (let ((act-27 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-8 arg-5 e-19 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-8 arg-5 arg-7 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 (vector 3 e-11 e-12 (vector 0 e-16 e-17 (vector 1 ) e-9) (vector 4 e-11 (CoreC-45TT-u--weaken_Weaken_Term e-10) (vector 0 e-11 '() 0)))) eta-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expand") arg-5 e-10 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) u--tmx) e-10) eta-0))))))))))))))))))))))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "EtaL") arg-5 arg-6 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((act-26 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "...with") arg-5 arg-7 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-15 (vector-ref act-26 1))) (vector 0 e-15))) (else (let ((u--tmy (vector 0 e-1 e-2 (vector 0 e-6 e-7 e-8 e-9) e-4))) (let ((sc6 (CoreC-45Unify-isHoleApp arg-6))) (cond ((equal? sc6 1) (let ((act-27 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-1 arg-0 e-5 arg-5 arg-6 u--tmy eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (cond ((equal? e-16 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 arg-6 u--tmy) eta-0)))))))) (else (let ((act-27 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-16 arg-5 e-9 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-17 (vector-ref act-28 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-16 arg-5 arg-6 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-18 (vector-ref act-29 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-29 1))) ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 (vector 3 e-1 e-2 (vector 0 e-6 e-7 (vector 1 ) e-17) (vector 4 e-1 (CoreC-45TT-u--weaken_Weaken_Term e-18) (vector 0 e-1 '() 0)))) eta-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-18 (vector-ref act-29 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expand") arg-5 e-18 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-19 (vector-ref act-30 1))) (vector 0 e-19))) (else (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-18) u--tmy) eta-0))))))))))))))))))))))))))))))))))))(else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 arg-6 arg-7))))))))(else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 arg-6 arg-7))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "EtaL") arg-5 arg-6 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((act-26 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "...with") arg-5 arg-7 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((u--tmy (vector 0 e-1 e-2 (vector 0 e-6 e-7 e-8 e-9) e-4))) (let ((sc5 (CoreC-45Unify-isHoleApp arg-6))) (cond ((equal? sc5 1) (let ((act-27 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-1 arg-0 e-5 arg-5 arg-6 u--tmy eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (cond ((equal? e-12 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 arg-6 u--tmy) eta-0)))))))) (else (let ((act-27 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-12 arg-5 e-9 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-12 arg-5 arg-6 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 (vector 3 e-1 e-2 (vector 0 e-6 e-7 (vector 1 ) e-13) (vector 4 e-1 (CoreC-45TT-u--weaken_Weaken_Term e-14) (vector 0 e-1 '() 0)))) eta-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expand") arg-5 e-14 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-15 (vector-ref act-30 1))) (vector 0 e-15))) (else (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-14) u--tmy) eta-0))))))))))))))))))))))))))))))))))))(else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 arg-6 arg-7))))))))(else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 arg-6 arg-7)))))))
(define CoreC-45Unify-u--unifyD_Unify_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Closure arg-1 arg-0 e-6 arg-5 arg-6 arg-7 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) (vector 1 (CoreC-45Unify-success))) (else (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 arg-6) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 arg-7) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((bind-0 0)) ((CoreC-45Unify-case--caseC-32blockC-32inC-32unifyD-20392 arg-0 arg-1 arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 e-5 e-6 bind-0 e-8 e-9 (cons e-8 e-9)) ext-0))))))))))))))))))))))))))
(define CoreC-45Unify-u--show_Show_UnifyMode (lambda (arg-0) (cond ((equal? arg-0 0) "InLHS") ((equal? arg-0 1) "InTerm") ((equal? arg-0 2) "InMatch") (else "InSearch"))))
(define CoreC-45Unify-u--show_Show_AddLazy (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "NoLazy") ((1) "AddForce") (else "AddDelay"))))
(define CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define CoreC-45Unify-u--C-61C-61_Eq_SolveMode (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Unify-updateSolution (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Unify-patternEnvTm arg-1 arg-2 arg-0 arg-3 e-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-7 (unbox e-6))) (let ((e-9 (car e-7))) (let ((e-8 (cdr e-7))) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (let ((sc6 (CoreC-45TT-shrinkTerm arg-5 e-10))) (if (null? sc6) (vector 1 0) (let ((e-12 (unbox sc6))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact (vector 8 e-3) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) (if (null? e-13) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't happen: no definition") ext-0) (let ((e-14 (unbox e-13))) (CoreC-45Unify-tryInstantiate arg-1 arg-2 arg-0 e-9 e-1 (CoreC-45Unify-inTerm) arg-3 e-2 e-3 (PreludeC-45TypesC-45List-length e-4) e-14 e-11 arg-5 e-12 ext-0)))))))))))))))))))))))))))))(else (vector 1 0)))))
(define CoreC-45Unify-unionAll (lambda (arg-0) (if (null? arg-0) (csegen-2080) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? e-3) e-2 (CoreC-45Unify-union e-2 (CoreC-45Unify-unionAll e-3))))))))
(define CoreC-45Unify-union (lambda (arg-0 arg-1) (vector (DataC-45List-union (csegen-225) (let ((e-0 (vector-ref arg-0 0))) e-0) (let ((e-0 (vector-ref arg-1 0))) e-0)) (let ((sc0 (let ((e-1 (vector-ref arg-0 1))) e-1))) (cond ((equal? sc0 1) 1) (else (let ((e-1 (vector-ref arg-1 1))) e-1)))) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-2 (vector-ref arg-1 2))) e-2)) (vector 0 ))))
(define CoreC-45Unify-unifyWithLazy (lambda (arg-1 arg-2 arg-3 arg-4 ext-1 ext-0) (lambda (clam-0) (let ((e-2 (cdr arg-1))) (lambda (arg-5) (lambda (arg-6) ((((((((e-2 arg-2) arg-3) arg-4) ext-1) ext-0) clam-0) arg-5) arg-6)))))))
(define CoreC-45Unify-unifyNoEta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((2) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (let ((e-18 (vector-ref arg-6 4))) (let ((e-19 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-45 (vector-ref arg-7 1))) (let ((e-46 (vector-ref arg-7 2))) (let ((e-47 (vector-ref arg-7 3))) (let ((e-48 (vector-ref arg-7 4))) (let ((e-49 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-17 e-47))) (cond ((equal? sc3 1) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-19) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-49)) eta-0))))) (else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 2 e-15 e-16 e-17 e-18 e-19) (vector 2 e-45 e-46 e-47 e-48 e-49) eta-0))))))))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing else worked, unifyIfEq") eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-0)))))))))))))))))))))))) ((3) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (let ((e-24 (vector-ref arg-6 4))) (let ((e-25 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-51 (vector-ref arg-7 1))) (let ((e-52 (vector-ref arg-7 2))) (let ((e-53 (vector-ref arg-7 3))) (let ((e-54 (vector-ref arg-7 4))) (let ((e-55 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda (eta-1) (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-22 eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-52 eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Comparing type constructors " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " and " (CoreC-45Name-u--show_Show_Name e-6)))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-22 e-52))) (cond ((equal? sc3 1) (let ((u--xs (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-25))) (let ((u--ys (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-55))) (let ((act-25 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Constructor " (CoreC-45Name-u--show_Show_Name e-22)))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-2090) (lambda (eta-2) (CoreC-45Core-traverse_ (lambda (eta-3) (lambda (eta-4) (CoreC-45Unify-dumpArg arg-2 arg-0 arg-5 eta-3 eta-4))) u--xs eta-2)) eta-1)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-2090) (lambda (eta-2) (CoreC-45Core-traverse_ (lambda (eta-3) (lambda (eta-4) (CoreC-45Unify-dumpArg arg-2 arg-0 arg-5 eta-3 eta-4))) u--ys eta-2)) eta-1)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 u--xs u--ys) eta-0))))))))))))) (else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 3 e-21 e-22 e-23 e-24 e-25) (vector 3 e-51 e-52 e-53 e-54 e-55) eta-0))))))))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing else worked, unifyIfEq") eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-0)))))))))))))))))))))))) ((5) (let ((e-29 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-59 (vector-ref arg-7 3))) ((((CoreC-45Unify-unify (csegen-1965) arg-2 arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-29) e-59)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing else worked, unifyIfEq") eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-0)))))))))))))))))))) ((6) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-63 (vector-ref arg-7 3))) (let ((e-64 (vector-ref arg-7 4))) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (cons e-33 (cons e-34 '())) (cons e-63 (cons e-64 '()))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing else worked, unifyIfEq") eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-0))))))))))))))))))))) ((7) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-68 (vector-ref arg-7 3))) (let ((e-69 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 (((((CoreC-45Unify-unify (csegen-1965) arg-2 arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-38) e-68) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-39) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-69)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45Unify-union e-5 e-6))))))))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing else worked, unifyIfEq") eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-0))))))))))))))))))))) ((1) (let ((e-41 (vector-ref arg-6 1))) (let ((e-42 (vector-ref arg-6 2))) (let ((e-43 (vector-ref arg-6 3))) (case (vector-ref e-42 0) ((2) (let ((e-75 (vector-ref e-42 1))) (let ((e-76 (vector-ref e-42 2))) (let ((e-77 (vector-ref e-42 3))) (case (vector-ref arg-7 0) ((1) (let ((e-79 (vector-ref arg-7 1))) (let ((e-80 (vector-ref arg-7 2))) (let ((e-81 (vector-ref arg-7 3))) (case (vector-ref e-80 0) ((2) (let ((e-83 (vector-ref e-80 1))) (let ((e-84 (vector-ref e-80 2))) (let ((e-85 (vector-ref e-80 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-5 arg-6 arg-7 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--fx (vector 2 e-75 e-76 e-77))) (let ((u--fy (vector 2 e-83 e-84 e-85))) (cond ((equal? e-6 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-unifyBothApps arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-41 u--fx e-43 e-79 u--fy e-81) eta-0))))))))))))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-71 (vector-ref arg-7 1))) (let ((e-72 (vector-ref arg-7 2))) (let ((e-73 (vector-ref arg-7 3))) (CoreC-45Unify-unifyBothApps arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-41 e-42 e-43 e-71 e-72 e-73)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-41 e-42 e-43 arg-7)))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-71 (vector-ref arg-7 1))) (let ((e-72 (vector-ref arg-7 2))) (let ((e-73 (vector-ref arg-7 3))) (CoreC-45Unify-unifyBothApps arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-41 e-42 e-43 e-71 e-72 e-73)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-41 e-42 e-43 arg-7)))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-71 (vector-ref arg-7 1))) (let ((e-72 (vector-ref arg-7 2))) (let ((e-73 (vector-ref arg-7 3))) (CoreC-45Unify-unifyBothApps arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-41 e-42 e-43 e-71 e-72 e-73)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-41 e-42 e-43 arg-7)))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc1 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc1 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing else worked, unifyIfEq") eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc3 (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc3 1) 1) (else (CoreC-45Unify-n--12509-19044-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-0))))))))))))))))))))
(define CoreC-45Unify-unifyInvertible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact (vector 8 arg-8) (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Unify-ufail arg-5 (PreludeC-45TypesC-45String-C-43C-43 "No such metavariable " (CoreC-45Name-u--show_Show_Name arg-7)) ext-0) (let ((e-1 (unbox e-6))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-2 e-5 arg-6 (CoreC-45TT-embed e-1)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((CoreC-45Unify-getArgTypes arg-2 arg-0 e-5 e-7 (PreludeC-45TypesC-45List-tailRecAppend arg-9 arg-10)) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--ty) (lambda (eta-0) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-2 e-5 arg-6 (CoreC-45TT-embed u--ty)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((CoreC-45Unify-getArgTypes arg-2 arg-0 e-5 e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-13)) eta-0)))))))) arg-11) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45Unify-headsConvert arg-2 arg-0 arg-1 arg-4 arg-5 arg-6 e-7 e-8) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (cond ((equal? e-9 1) (let ((sc7 (PreludeC-45TypesC-45List-reverse arg-10))) (if (null? sc7) ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application [2]" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) (arg-12 arg-13)) ext-0) (let ((e-11 (car sc7))) (let ((e-10 (cdr sc7))) (let ((sc8 (PreludeC-45TypesC-45List-reverse arg-13))) (if (null? sc8) ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application [2]" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) (arg-12 arg-13)) ext-0) (let ((e-13 (car sc8))) (let ((e-12 (cdr sc8))) (CoreC-45UnifyState-tryUnify arg-0 arg-1 (lambda (clam-0) (cond ((equal? arg-3 1) (let ((act-29 (CoreC-45ContextC-45Log-log arg-0 "unify.invertible" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unifying invertible") clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (((((CoreC-45Unify-unify (csegen-2082) arg-2 arg-0 arg-1 arg-4 arg-5) arg-6) (Builtin-snd e-13)) e-11) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-30 1))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-0 "unify.invertible" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Constraints " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-246) (let ((e-0 (vector-ref e-15 0))) e-0)))) clam-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (((((CoreC-45Unify-unify (csegen-1965) arg-2 arg-0 arg-1 arg-4 arg-5) arg-6) (arg-12 (PreludeC-45TypesC-45List-reverse e-12))) (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) e-10)))) clam-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-32 1))) (vector 1 (CoreC-45Unify-union e-15 e-17))))))))))))))))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-0 "unify.invertible" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Unifying invertible") clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (((((CoreC-45Unify-unify (csegen-2082) arg-2 arg-0 arg-1 arg-4 arg-5) arg-6) e-11) (Builtin-snd e-13)) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-30 1))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-0 "unify.invertible" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Constraints " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-246) (let ((e-0 (vector-ref e-15 0))) e-0)))) clam-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (((((CoreC-45Unify-unify (csegen-1965) arg-2 arg-0 arg-1 arg-4 arg-5) arg-6) (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) e-10)))) (arg-12 (PreludeC-45TypesC-45List-reverse e-12))) clam-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-32 1))) (vector 1 (CoreC-45Unify-union e-15 e-17))))))))))))))))))) (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application [1]" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) (arg-12 arg-13)) ext-0)))))))))) (else (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-5 arg-4 "Postponing hole application [3]" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) (arg-12 arg-13) ext-0)))))))))))))))))))))))))))
(define CoreC-45Unify-unifyIfEq (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convertInf_Convert_NF arg-0 arg-2 e-5 arg-6 arg-7 arg-8 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 (CoreC-45Unify-success))) (else (cond ((equal? arg-3 1) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 arg-5 (PreludeC-45TypesC-45String-C-43C-43 "Postponing unifyIfEq " (PreludeC-45Show-u--show_Show_Bool (let ((e-0 (car arg-5))) e-0))) arg-6 arg-7 arg-8 ext-0)) (else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-6 arg-7 arg-8 ext-0)))))))))))))))
(define CoreC-45Unify-unifyHoleApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (let ((e-5 (vector-ref arg-11 5))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact e-2 (let ((e-0 (vector-ref e-6 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (CoreC-45Unify-unifyInvertible arg-0 arg-1 arg-2 arg-3 (CoreC-45Unify-lower arg-4) arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-7 (lambda (eta-1) (vector 3 e-1 e-2 e-3 e-4 eta-1)) e-5 eta-0)))))))))))))))) ((2) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (let ((e-9 (vector-ref arg-11 3))) (let ((e-10 (vector-ref arg-11 4))) (let ((e-11 (vector-ref arg-11 5))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact e-8 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Unify-unifyInvertible arg-0 arg-1 arg-2 arg-3 (CoreC-45Unify-lower arg-4) arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6 (lambda (eta-1) (vector 2 e-7 e-8 e-9 e-10 eta-1)) e-11 eta-0)))))))))))))))) ((1) (let ((e-13 (vector-ref arg-11 1))) (let ((e-14 (vector-ref arg-11 2))) (let ((e-15 (vector-ref arg-11 3))) (case (vector-ref e-14 0) ((0) (let ((e-18 (vector-ref e-14 1))) (let ((e-19 (vector-ref e-14 2))) (lambda (eta-0) (CoreC-45Unify-unifyInvertible arg-0 arg-1 arg-2 arg-3 (CoreC-45Unify-lower arg-4) arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() (lambda (eta-1) (vector 1 e-13 (vector 0 e-18 e-19) eta-1)) e-15 eta-0))))) ((2) (let ((e-22 (vector-ref e-14 1))) (let ((e-23 (vector-ref e-14 2))) (let ((e-24 (vector-ref e-14 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 e-23) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--tm (vector 1 e-13 (vector 2 e-22 e-23 e-24) e-15))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 e-13 arg-7 eta-0) (let ((e-1 (unbox e-6))) (let ((u--inv (let ((sc5 (CoreC-45Unify-n--12458-14069-u--isPatName arg-2 e-24 e-23 e-22 e-15 e-13 u--tm arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-22))) (cond ((equal? sc5 1) 1) (else (let ((e-26 (vector-ref e-1 14))) e-26)))))) (cond ((equal? u--inv 1) (CoreC-45Unify-unifyInvertible arg-0 arg-1 arg-2 arg-3 (CoreC-45Unify-lower arg-4) arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() (lambda (eta-1) (vector 1 e-13 (vector 2 e-22 e-23 e-24) eta-1)) e-15 eta-0)) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) u--tm) eta-0))))))))))))))))))))(else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) arg-11)))))))(else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) arg-11)))))
(define CoreC-45Unify-unifyHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--args (let ((sc2 (DataC-45List-isNil arg-11))) (cond ((equal? sc2 1) arg-10) (else (PreludeC-45TypesC-45List-tailRecAppend arg-10 arg-11)))))) (let ((act-26 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.hole" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-0) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalArg arg-0 arg-2 e-6 eta-1)) u--args '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-6 arg-6 clam-0 eta-1))) e-7 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-6 arg-6 arg-12 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Unifying: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-8) (PreludeC-45TypesC-45String-C-43C-43 " with " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-9)))))))))))))))))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Unify-patternEnv arg-0 arg-1 arg-2 arg-6 u--args ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (if (null? e-8) (let ((act-28 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-9) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (if (null? e-9) ((CoreC-45Unify-postponePatVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12) ext-0) (let ((e-1 (unbox e-9))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((7) (let ((sc8 (let ((e-37 (vector-ref e-1 14))) e-37))) (cond ((equal? sc8 1) ((CoreC-45Unify-unifyHoleApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12) ext-0)) (else ((CoreC-45Unify-postponePatVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12) ext-0)))))(else ((CoreC-45Unify-postponePatVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12) ext-0)))))))))) (let ((e-2 (unbox e-8))) (let ((e-10 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (let ((act-28 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-9) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-28 1))) (let ((bind-0 (box (cons e-10 (cons e-12 e-11))))) (if (null? e-13) ((CoreC-45Unify-postponePatVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12) ext-0) (let ((e-1 (unbox e-13))) (let ((_-0 (box e-1))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((7) (let ((e-34 (vector-ref e-17 1))) (let ((e-33 (vector-ref e-17 2))) (let ((u--qopts (vector 0 0 (box (let ((e-61 (vector-ref e-5 4))) (let ((e-72 (vector-ref e-61 3))) (let ((e-77 (vector-ref e-72 5))) e-77))))))) (let ((act-29 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF arg-0 arg-2 u--qopts e-6 arg-6 arg-12 eta-0)) (lambda (u--err) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-5 arg-6 arg-12 eta-0))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-35 (vector-ref act-29 1))) (vector 0 e-35))) (else (let ((e-35 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Unify-occursCheck arg-2 arg-0 arg-5 arg-6 arg-4 arg-8 e-35 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-36 (vector-ref act-30 1))) (vector 0 e-36))) (else (let ((e-36 (vector-ref act-30 1))) (if (null? e-36) ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Occurs check failed" arg-6 (vector 1 arg-5 (vector 2 arg-8 arg-9 arg-10) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-11)) arg-12) ext-0) (let ((e-37 (unbox e-36))) (let ((_-1 (box e-37))) (let ((sc13 (CoreC-45TT-shrinkTerm e-37 e-11))) (if (null? sc13) (let ((act-31 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-5 arg-6 arg-12 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-38 (vector-ref act-31 1))) (vector 0 e-38))) (else (let ((e-38 (vector-ref act-31 1))) (let ((sc15 (CoreC-45TT-shrinkTerm e-38 e-11))) (if (null? sc15) ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Can't shrink" arg-6 (vector 1 arg-5 (vector 2 arg-8 arg-9 arg-10) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-11)) arg-12) ext-0) (let ((e-39 (unbox sc15))) (CoreC-45Unify-n--15363-15429-u--solveOrElsePostpone arg-2 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-5 e-6 u--args e-10 e-12 e-11 bind-0 e-1 _-0 e-34 e-33 u--qopts e-35 e-37 _-1 e-39 ext-0)))))))) (let ((e-38 (unbox sc13))) (CoreC-45Unify-n--15363-15429-u--solveOrElsePostpone arg-2 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-5 e-6 u--args e-10 e-12 e-11 bind-0 e-1 _-0 e-34 e-33 u--qopts e-35 e-37 _-1 e-38 ext-0)))))))))))))))))))(else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Delayed hole" arg-6 (vector 1 arg-5 (vector 2 arg-8 arg-9 arg-10) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-11)) arg-12) ext-0))))))))))))))))))))))))))))))))))))
(define CoreC-45Unify-unifyBothBinders (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-8 0) ((2) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (lambda (clam-0) (case (vector-ref arg-12 0) ((2) (let ((e-11 (vector-ref arg-12 1))) (let ((e-12 (vector-ref arg-12 2))) (let ((e-13 (vector-ref arg-12 3))) (let ((e-14 (vector-ref arg-12 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-2 e-12))) (cond ((equal? sc3 1) (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 (vector 2 e-1 e-2 e-3 e-4) arg-9) (vector 0 arg-10 arg-11 (vector 2 e-11 e-12 e-13 e-14) arg-13) clam-0)) (else (let ((act-25 (CoreC-45Context-clearDefs e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-6 arg-5 e-4 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.binder" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-0) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-6 arg-5 e-14 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Unifying arg types " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-7) (PreludeC-45TypesC-45String-C-43C-43 " and " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-8)))))))))) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((act-28 (((((CoreC-45Unify-unify (csegen-2082) arg-2 arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-4) e-14) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45UnifyState-genVarName arg-0 arg-1 "x" clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-10 (vector-ref act-29 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--envC-39 (cons (vector 2 e-11 e-12 (vector 1 ) e-7) arg-5))) (CoreC-45Unify-case--caseC-32blockC-32inC-32unifyBothBinders-17734 arg-2 e-4 e-3 e-2 e-1 e-14 e-13 e-12 e-11 arg-13 arg-11 arg-10 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-5 e-6 e-7 e-9 e-10 u--envC-39 (let ((e-0 (vector-ref e-9 0))) e-0) clam-0)))))))))))))))))))))))))))))))))(else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 arg-8 arg-9) (vector 0 arg-10 arg-11 arg-12 arg-13) clam-0))))))))) ((0) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (let ((e-9 (vector-ref arg-8 4))) (lambda (clam-1) (case (vector-ref arg-12 0) ((0) (let ((e-16 (vector-ref arg-12 1))) (let ((e-17 (vector-ref arg-12 2))) (let ((e-18 (vector-ref arg-12 3))) (let ((e-19 (vector-ref arg-12 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-7 e-17))) (cond ((equal? sc3 1) (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 (vector 0 e-6 e-7 e-8 e-9) arg-9) (vector 0 arg-10 arg-11 (vector 0 e-16 e-17 e-18 e-19) arg-13) clam-1)) (else (let ((act-25 (CoreC-45Context-clearDefs e-5 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (((((CoreC-45Unify-unify (csegen-2082) arg-2 arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-9) e-19) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-genVarName arg-0 arg-1 "x" clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-10 arg-5 e-9 clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-28 1))) (let ((u--envC-39 (cons (vector 0 e-6 e-7 (vector 1 ) e-13) arg-5))) (let ((act-29 (((arg-9 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-5 (vector 1 arg-4 (vector 0 ) e-12))) clam-1))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 (((arg-13 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-5 (vector 1 arg-4 (vector 0 ) e-12))) clam-1))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-30 1))) (let ((act-31 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-10 arg-5 e-14 clam-1))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-31 1))) (let ((act-32 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-10 arg-5 e-15 clam-1))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-32 1))) (let ((act-33 (((((CoreC-45Unify-unify (csegen-1962) (cons arg-7 arg-2) arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) u--envC-39) (CoreC-45TT-refsToLocals (vector 1 arg-7 e-12 (vector 0 )) e-20)) (CoreC-45TT-refsToLocals (vector 1 arg-7 e-12 (vector 0 )) e-21)) clam-1))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-33 1))) (vector 1 (CoreC-45Unify-union e-11 e-22)))))))))))))))))))))))))))))))))))))))))))))))))))(else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 arg-8 arg-9) (vector 0 arg-10 arg-11 arg-12 arg-13) clam-1)))))))))(else (lambda (eta-0) (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 arg-8 arg-9) (vector 0 arg-10 arg-11 arg-12 arg-13) eta-0))))))
(define CoreC-45Unify-unifyBothApps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-7 0) ((0) (let ((e-50 (vector-ref arg-7 1))) (let ((e-51 (vector-ref arg-7 2))) (if (null? arg-8) (case (vector-ref arg-10 0) ((0) (let ((e-56 (vector-ref arg-10 1))) (let ((e-57 (vector-ref arg-10 2))) (if (null? arg-11) (lambda (clam-0) (let ((sc4 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-51 e-57))) (cond ((equal? sc4 1) (vector 1 (CoreC-45Unify-success))) (else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 1 arg-6 (vector 0 e-50 e-51) '()) (vector 1 arg-9 (vector 0 e-56 e-57) '()) clam-0))))) (if (null? arg-3) (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc8 (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc9 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc8 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc11 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc12 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc11 (let ((sc12 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc13 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc11 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))) (let ((e-36 (car arg-3))) (let ((e-37 (cdr arg-3))) (cond ((equal? e-37 1) (case (vector-ref arg-7 0) ((0) (let ((e-40 (vector-ref arg-7 1))) (let ((e-41 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((u--mode (cons e-36 1))) (let ((sc8 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-41 e-46))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (lambda (eta-0) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 u--mode "Postponing local app" arg-5 (vector 1 arg-6 (vector 0 e-40 e-41) arg-8) (vector 1 arg-9 (vector 0 e-45 e-46) arg-11) eta-0)))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc9 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc12 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc12 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc12 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc12 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc10 (let ((sc11 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc11 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc10 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc13 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc13 1) 1) (else (let ((sc14 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc14 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc13 (let ((sc14 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc14 1) (let ((sc15 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc15 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc13 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc8 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc11 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc11 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc8 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc11 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc11 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc9 (let ((sc10 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc10 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc9 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc12 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc12 1) 1) (else (let ((sc13 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc13 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc12 (let ((sc13 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc13 1) (let ((sc14 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc14 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc12 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc8 (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc9 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc8 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc11 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc12 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc11 (let ((sc12 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc13 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc11 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))))))(else (if (null? arg-3) (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))) (let ((e-36 (car arg-3))) (let ((e-37 (cdr arg-3))) (cond ((equal? e-37 1) (case (vector-ref arg-7 0) ((0) (let ((e-40 (vector-ref arg-7 1))) (let ((e-41 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((u--mode (cons e-36 1))) (let ((sc6 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-41 e-46))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (lambda (eta-0) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 u--mode "Postponing local app" arg-5 (vector 1 arg-6 (vector 0 e-40 e-41) arg-8) (vector 1 arg-9 (vector 0 e-45 e-46) arg-11) eta-0)))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc8 (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc9 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc8 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc11 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc12 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc11 (let ((sc12 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc13 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc11 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc7 (let ((sc8 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc8 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc7 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc10 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc10 1) 1) (else (let ((sc11 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc11 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc10 (let ((sc11 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc11 1) (let ((sc12 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc12 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc10 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))))))) (if (null? arg-3) (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))) (let ((e-36 (car arg-3))) (let ((e-37 (cdr arg-3))) (cond ((equal? e-37 1) (case (vector-ref arg-7 0) ((0) (let ((e-40 (vector-ref arg-7 1))) (let ((e-41 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((u--mode (cons e-36 1))) (let ((sc6 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-41 e-46))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (lambda (eta-0) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 u--mode "Postponing local app" arg-5 (vector 1 arg-6 (vector 0 e-40 e-41) arg-8) (vector 1 arg-9 (vector 0 e-45 e-46) arg-11) eta-0)))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc8 (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc9 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc8 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc11 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc12 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc11 (let ((sc12 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc13 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc11 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc7 (let ((sc8 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc8 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc7 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc10 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc10 1) 1) (else (let ((sc11 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc11 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc10 (let ((sc11 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc11 1) (let ((sc12 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc12 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc10 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))))))(else (if (null? arg-3) (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc6 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc4 (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc5 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc4 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc7 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc7 1) 1) (else (let ((sc8 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc8 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc7 (let ((sc8 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc8 1) (let ((sc9 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc9 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc7 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc5 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))) (let ((e-36 (car arg-3))) (let ((e-37 (cdr arg-3))) (cond ((equal? e-37 1) (case (vector-ref arg-7 0) ((0) (let ((e-40 (vector-ref arg-7 1))) (let ((e-41 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((u--mode (cons e-36 1))) (let ((sc4 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-41 e-46))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (lambda (eta-0) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 u--mode "Postponing local app" arg-5 (vector 1 arg-6 (vector 0 e-40 e-41) arg-8) (vector 1 arg-9 (vector 0 e-45 e-46) arg-11) eta-0)))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc5 (let ((sc6 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc6 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc5 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc8 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc8 1) 1) (else (let ((sc9 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc9 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc8 (let ((sc9 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc9 1) (let ((sc10 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc10 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc8 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc6 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc6 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc4 (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc5 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc4 1) ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11))) eta-0)) (else (let ((act-25 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Unify-n--12490-16723-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--xbigger (let ((sc7 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc7 1) 1) (else (let ((sc8 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-7))) (cond ((equal? sc8 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-length arg-8) (PreludeC-45TypesC-45List-length arg-11))) (else 0)))))))) (let ((sc7 (let ((sc8 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc8 1) (let ((sc9 (CoreC-45Unify-n--12490-16722-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc9 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc7 1) ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11)) eta-0)) (else ((CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)) eta-0)))))))))))))))))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc5 1) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-8) '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-snd eta-2)) arg-11) '() eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Matching args " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2081) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))))))
(define CoreC-45Unify-unifyArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) (lambda (clam-0) (if (null? arg-9) (vector 1 (CoreC-45Unify-success)) (CoreC-45Unify-ufail arg-6 "" clam-0))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (lambda (clam-1) (if (null? arg-9) (CoreC-45Unify-ufail arg-6 "" clam-1) (let ((e-6 (car arg-9))) (let ((e-7 (cdr arg-9))) (let ((act-24 ((CoreC-45Unify-unifyArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 e-7) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((((CoreC-45Unify-unify (Builtin-fst arg-1) arg-2 arg-3 arg-4 (CoreC-45Unify-lower arg-5) arg-6) arg-7) e-2) e-6) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (CoreC-45Unify-union e-8 e-5)))))))))))))))))))
(define CoreC-45Unify-unifyApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-8 0) ((2) (let ((e-50 (vector-ref arg-8 1))) (let ((e-51 (vector-ref arg-8 2))) (let ((e-52 (vector-ref arg-8 3))) (lambda (eta-0) (CoreC-45Unify-unifyHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-50 e-51 e-52 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-9) arg-10 eta-0))))))(else (case (vector-ref arg-10 0) ((1) (let ((e-42 (vector-ref arg-10 1))) (let ((e-43 (vector-ref arg-10 2))) (let ((e-44 (vector-ref arg-10 3))) (case (vector-ref e-43 0) ((2) (let ((e-46 (vector-ref e-43 1))) (let ((e-47 (vector-ref e-43 2))) (let ((e-48 (vector-ref e-43 3))) (lambda (eta-0) (CoreC-45Unify-unifyHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-42 e-46 e-47 e-48 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-44) (vector 1 arg-7 arg-8 arg-9) eta-0))))))(else (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Name against app, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (cond ((equal? arg-3 1) (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 arg-10 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) eta-0)) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) arg-10 eta-0)))))))))) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (if (null? arg-9) (case (vector-ref arg-10 0) ((1) (let ((e-32 (vector-ref arg-10 1))) (let ((e-33 (vector-ref arg-10 2))) (let ((e-34 (vector-ref arg-10 3))) (case (vector-ref e-33 0) ((0) (let ((e-37 (vector-ref e-33 1))) (let ((e-38 (vector-ref e-33 2))) (if (null? e-34) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((sc7 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-38))) (cond ((equal? sc7 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing var" arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) '()) (vector 1 e-32 (vector 0 e-37 e-38) '())) eta-0)))))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-0) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-0)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-0))))))))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-1) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-1)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-1))))))))))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-2) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-2)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-2)))))))))))))))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-3) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-3)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-3))))))))))))))))))))(else (lambda (clam-4) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-4)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-4))))))))))))))))))))))(else (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "unify.application" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Name against app, unifyIfEq") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (cond ((equal? arg-3 1) (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 arg-10 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) eta-0)) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) arg-10 eta-0)))))))))) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (if (null? arg-9) (case (vector-ref arg-10 0) ((1) (let ((e-32 (vector-ref arg-10 1))) (let ((e-33 (vector-ref arg-10 2))) (let ((e-34 (vector-ref arg-10 3))) (case (vector-ref e-33 0) ((0) (let ((e-37 (vector-ref e-33 1))) (let ((e-38 (vector-ref e-33 2))) (if (null? e-34) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((sc6 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-38))) (cond ((equal? sc6 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing var" arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) '()) (vector 1 e-32 (vector 0 e-37 e-38) '())) eta-0)))))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-5) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-5)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-5))))))))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-6) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-6)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-6))))))))))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-7) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-7)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-7)))))))))))))))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-8) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-8))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-8)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-8))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-8 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-8))))))))))))))))))))(else (lambda (clam-9) (cond ((equal? arg-3 0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 clam-9))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-9)))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) clam-9))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10) clam-9))))))))))))))))))))))
(define CoreC-45Unify-unify (lambda (arg-1 arg-2 arg-3 arg-4 ext-1 ext-0) (lambda (clam-0) (let ((e-1 (car arg-1))) (lambda (arg-5) (lambda (arg-6) ((((((((e-1 arg-2) arg-3) arg-4) ext-1) ext-0) clam-0) arg-5) arg-6)))))))
(define CoreC-45Unify-ufail (lambda (arg-1 arg-2 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 arg-2) ext-0)))
(define CoreC-45Unify-tryInstantiate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-3 arg-0 "unify.instantiate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Instantiating in " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-3))) arg-13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((e-1 (vector-ref arg-10 1))) (case (vector-ref e-1 0) ((3) (let ((e-24 (vector-ref e-1 1))) (let ((e-23 (vector-ref e-1 2))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 3 arg-2 arg-4 arg-6 (vector 3 e-24 e-23) arg-12) ext-0))))(else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Normalise-normalisePis arg-0 '() e-7 '() (let ((e-2 (vector-ref arg-10 2))) e-2) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45ContextC-45Log-logTerm '() arg-0 "unify.instantiate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Type: " (CoreC-45Name-u--show_Show_Name arg-7))) (let ((e-2 (vector-ref arg-10 2))) e-2) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45ContextC-45Log-logTerm '() arg-0 "unify.instantiate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Type: " (CoreC-45Name-u--show_Show_Name arg-7))) e-8 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45ContextC-45Log-log arg-0 "unify.instantiate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "With locs: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2074) arg-11))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45ContextC-45Log-log arg-0 "unify.instantiate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "From vars: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-3))) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (let ((act-32 (unbox arg-0))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 ((CoreC-45Unify-n--9884-10622-u--mkDef arg-2 arg-3 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-1 arg-0 '() arg-3 arg-11 '() arg-13 e-8) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (if (null? e-14) (let ((act-34 (CoreC-45ContextC-45Log-log arg-0 "unify.instantiate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Postponed") ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (vector 1 0)))) (let ((e-1 (unbox e-14))) (let ((act-34 (CoreC-45ContextC-45Log-logTerm '() arg-0 "unify.instantiate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Definition") e-1 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((u--simpleDef (vector (box arg-9) (let ((sc12 (CoreC-45Name-isUserName arg-7))) (cond ((equal? sc12 1) 0) (else (CoreC-45Unify-n--9884-10619-u--isSimple arg-2 arg-3 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-1 arg-0 e-1)))) 0))) (let ((u--newdef (let ((e-0 (vector-ref arg-10 0))) (let ((e-33 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (let ((e-4 (vector-ref arg-10 4))) (let ((e-32 (vector-ref arg-10 5))) (let ((e-31 (vector-ref arg-10 6))) (let ((e-30 (vector-ref arg-10 7))) (let ((e-29 (vector-ref arg-10 8))) (let ((e-28 (vector-ref arg-10 9))) (let ((e-27 (vector-ref arg-10 10))) (let ((e-26 (vector-ref arg-10 11))) (let ((e-25 (vector-ref arg-10 12))) (let ((e-24 (vector-ref arg-10 13))) (let ((e-23 (vector-ref arg-10 14))) (let ((e-22 (vector-ref arg-10 15))) (let ((e-16 (vector-ref arg-10 16))) (let ((e-18 (vector-ref arg-10 18))) (let ((e-19 (vector-ref arg-10 19))) (let ((e-20 (vector-ref arg-10 20))) (let ((e-21 (vector-ref arg-10 21))) (vector e-0 e-33 e-2 e-3 e-4 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-22 e-16 (vector 1 u--simpleDef '() (vector 1 0 e-1) (vector 1 0 e-1) '()) e-18 e-19 e-20 e-21)))))))))))))))))))))))) (let ((act-35 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 (vector 8 arg-8) u--newdef eta-0)) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 (CoreC-45UnifyState-removeHole arg-1 arg-8 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (vector 1 1)))))))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Unify-toSubVars (lambda (arg-0 arg-1) (if (null? arg-0) (cons '() (vector 0 )) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (CoreC-45Unify-toSubVars e-3 (CoreC-45TT-dropFirst arg-1)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (CoreC-45Unify-n--8616-9500-u--anyFirst e-2 e-3 arg-1 arg-1))) (cond ((equal? sc2 1) (cons (cons e-2 e-5) (vector 2 e-4))) (else (cons e-5 (vector 1 e-4)))))))))))))
(define CoreC-45Unify-success(blodwen-lazy (lambda () (csegen-2080))))
(define CoreC-45Unify-solvedHole (lambda (arg-0) (vector '() 1 (cons arg-0 '()) (vector 0 ))))
(define CoreC-45Unify-solveIfUndefined (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact (vector 8 e-3) (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--metavar (vector 2 e-1 e-2 e-3 e-4))) (if (null? e-6) (vector 1 0) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((7) (CoreC-45Unify-updateSolution arg-0 arg-1 arg-2 arg-3 u--metavar arg-5 ext-0))(else (vector 1 0)))))))))))))))))))(else (vector 1 0)))))
(define CoreC-45Unify-solveHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((sc3 (let ((sc4 (CoreC-45Unify-n--12470-14412-u--solutionHeadSame arg-2 arg-3 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-1 arg-0 arg-15))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--12470-14411-u--inNoSolve arg-2 arg-3 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-1 arg-0 arg-8 (let ((e-14 (vector-ref e-6 5))) e-14))))))) (cond ((equal? sc3 1) (vector 1 (box (CoreC-45Unify-success)))) (else (let ((act-27 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-8) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't happen: Lost hole " (CoreC-45Name-u--show_Show_Name arg-7))) ext-0) (let ((e-1 (unbox e-8))) (let ((act-28 (CoreC-45Unify-tryInstantiate arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 (PreludeC-45TypesC-45List-length arg-9) e-1 arg-11 arg-13 arg-14 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (DataC-45Maybe-toMaybe e-9 (lambda () (CoreC-45Unify-solvedHole arg-8))))))))))))))))))))))))))))))
(define CoreC-45Unify-solveConstraintsAfter (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Unify-retryGuess arg-0 arg-1 arg-3 arg-4 eta-0)) (DataC-45List-filter (lambda (eta-0) (CoreC-45Unify-n--24183-23281-u--afterStart arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1))) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) eta-0) e-6))) (cond ((equal? sc2 1) (CoreC-45Unify-solveConstraintsAfter arg-0 arg-1 arg-2 arg-3 0 ext-0)) (else (vector 1 0))))))))))))))
(define CoreC-45Unify-solveConstraints (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Unify-retryGuess arg-0 arg-1 arg-2 arg-3 eta-0)) (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1)) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) eta-0) e-6))) (cond ((equal? sc2 1) (CoreC-45Unify-solveConstraints arg-0 arg-1 arg-2 0 ext-0)) (else (vector 1 0))))))))))))))
(define CoreC-45Unify-setInvertible (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-24 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-23 (vector-ref e-1 5))) (let ((e-22 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-7 e-8 e-9 e-10 e-11 e-12 e-13 1 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-0)) ext-0)))))))))))))
(define CoreC-45Unify-search (lambda (ext-10 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-0) (let ((act-24 (let ((act-24 (unbox ext-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Normalise-logTermNF ext-10 ext-1 "auto" (+ 1 (+ 1 (+ 1 0))) (lambda () "Initial target: ") ext-9 ext-8 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-log ext-1 "auto" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Running search with defaults " (PreludeC-45Show-u--show_Show_Bool ext-5))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CoreC-45AutoSearch-searchType ext-10 ext-1 ext-2 ext-3 ext-4 ext-5 '() ext-6 ext-7 1 (CoreC-45Env-abstractEnvType ext-10 ext-3 ext-9 ext-8) ext-9 ext-8) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Normalise-logTermNF ext-10 ext-1 "auto" (+ 1 (+ 1 (+ 1 0))) (lambda () "Result") ext-9 e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (let ((act-29 (unbox ext-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 e-8))))))))))))))))))))))
(define CoreC-45Unify-retryGuess (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (vector 1 0) (let ((e-4 (unbox e-8))) (let ((bind-0 (box e-4))) ((CoreC-45Unify-case--caseC-32blockC-32inC-32retryGuess-21882 e-2 e-6 e-7 arg-3 arg-2 arg-1 arg-0 e-5 e-4 bind-0 (let ((e-17 (vector-ref e-4 17))) e-17)) clam-0)))))))))))))))))))
(define CoreC-45Unify-retry (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Unify-case--retry-21254 arg-0 arg-3 arg-2 arg-1 e-5 (LibrariesC-45DataC-45IntMap-lookup arg-3 (let ((e-4 (vector-ref e-5 4))) e-4))) ext-0)))))))
(define CoreC-45Unify-recoverable (lambda (arg-0) (case (vector-ref arg-0 0) ((7) 0) ((62) (let ((e-4 (vector-ref arg-0 3))) (CoreC-45Unify-recoverable e-4))) ((63) (let ((e-7 (vector-ref arg-0 3))) (CoreC-45Unify-recoverable e-7))) ((64) (let ((e-10 (vector-ref arg-0 3))) (CoreC-45Unify-recoverable e-10))) ((65) (let ((e-13 (vector-ref arg-0 3))) (CoreC-45Unify-recoverable e-13))) ((5) (let ((e-20 (vector-ref arg-0 7))) (CoreC-45Unify-recoverable e-20)))(else 1))))
(define CoreC-45Unify-postponeS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (cond ((equal? arg-3 1) (CoreC-45Unify-postpone arg-0 arg-1 arg-2 arg-4 (CoreC-45Unify-lower arg-5) arg-6 arg-7 arg-9 arg-8 clam-0)) (else (CoreC-45Unify-postpone arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 clam-0))))))
(define CoreC-45Unify-postponePatVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((u--x (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 u--x arg-11 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 (CoreC-45Unify-success))) (else ((CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Not in pattern fragment" arg-6 u--x arg-11) eta-0)))))))))))))))
(define CoreC-45Unify-postpone (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "unify.postpone" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-0) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-6 arg-7 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-6 arg-8 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-7 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-8 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 arg-5 (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-9) (PreludeC-45TypesC-45String-C-43C-43 " =?= " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-10))))))))))))))))))))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CoreC-45Unify-n--7927-8865-u--checkDefined arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 arg-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45Unify-n--7927-8865-u--checkDefined arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 arg-8) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45UnifyState-addConstraint arg-2 arg-1 (vector 0 arg-0 arg-3 (let ((e-0 (car arg-4))) e-0) arg-6 arg-7 arg-8) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45ContextC-45Log-log arg-1 "unify.postpone" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-10) (PreludeC-45TypesC-45String-C-43C-43 " NEW CONSTRAINT " (CoreC-45FC-u--show_Show_FC arg-3)))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45Normalise-logNF arg-0 arg-1 "unify.postpone" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "X") arg-6 arg-7 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (CoreC-45Normalise-logNF arg-0 arg-1 "unify.postpone" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Y") arg-6 arg-8 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45Unify-constrain e-10)))))))))))))))))))))))))))))))))
(define CoreC-45Unify-patternEnvTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45Unify-case--patternEnvTm-9987 arg-2 arg-4 arg-3 arg-1 arg-0 e-5 e-6 (CoreC-45Unify-getVarsTm '() arg-4)))))))))))))
(define CoreC-45Unify-patternEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalArg arg-0 arg-2 e-6 eta-0)) arg-4 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45Unify-case--patternEnv-9712 arg-2 arg-4 arg-3 arg-1 arg-0 e-5 e-6 e-7 (CoreC-45Unify-getVars arg-2 '() e-7)))))))))))))))))
(define CoreC-45Unify-occursCheck (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 ((CoreC-45Unify-getMetaNames arg-1 arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Unify-case--occursCheck-10289 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 (PreludeC-45Types-elem (csegen-802) arg-5 e-5) ext-0)))))))
(define CoreC-45Unify-lower (lambda (ext-0) (let ((e-1 (cdr ext-0))) (cons 0 e-1))))
(define CoreC-45Unify-isHoleApp (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-2 (vector-ref arg-1 2))) (case (vector-ref e-2 0) ((2) 1)(else 0))))(else 0))))
(define CoreC-45Unify-isDefInvertible (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-2) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 arg-1 (vector 8 arg-2)) ext-0) (let ((e-1 (unbox e-6))) (vector 1 (let ((e-14 (vector-ref e-1 14))) e-14))))))))))))))
(define CoreC-45Unify-inTerm(blodwen-lazy (lambda () (cons 1 1))))
(define CoreC-45Unify-inSearch(blodwen-lazy (lambda () (cons 1 3))))
(define CoreC-45Unify-inMatch(blodwen-lazy (lambda () (cons 1 2))))
(define CoreC-45Unify-inLHS(blodwen-lazy (lambda () (cons 1 0))))
(define CoreC-45Unify-headsConvert (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "unify.head" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing to convert") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 1))))) (let ((e-1 (unbox arg-6))) (if (null? arg-7) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "unify.head" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing to convert") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 1))))) (let ((e-3 (unbox arg-7))) (CoreC-45Unify-case--headsConvert-13243 arg-0 e-1 e-3 arg-5 arg-4 arg-3 arg-2 arg-1 (cons (PreludeC-45TypesC-45List-reverse e-1) (PreludeC-45TypesC-45List-reverse e-3)))))))))
(define CoreC-45Unify-giveUpConstraints (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Unify-n--24241-23335-u--constraintToHole arg-1 arg-0 eta-0)) (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1)) ext-0)))))))
(define CoreC-45Unify-getVarsTm (lambda (arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (let ((e-8 (vector-ref e-2 3))) (let ((sc2 (PreludeC-45Types-elem (csegen-792) e-8 arg-1))) (cond ((equal? sc2 1) '()) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-getVarsTm (cons e-8 arg-1) e-3) (lambda (u--xsC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-8 u--xsC-39)))))))))(else '())))))))
(define CoreC-45Unify-getVars (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((0) (let ((e-15 (vector-ref e-6 1))) (let ((e-16 (vector-ref e-6 2))) (if (null? e-7) (let ((sc4 (CoreC-45Unify-n--8485-9391-u--inArgs arg-0 e-16 e-15 e-5 e-3 arg-1 e-16 arg-1))) (cond ((equal? sc4 1) '()) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-getVars arg-0 (cons e-16 arg-1) e-3) (lambda (u--xsC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-16 u--xsC-39))))))) '()))))(else '())))))) ((4) (let ((e-12 (vector-ref e-2 4))) (CoreC-45Unify-getVars arg-0 arg-1 (cons e-12 e-3))))(else '())))))))
(define CoreC-45Unify-getMetaNames (lambda (arg-1 arg-2) (let ((u--metas (CoreC-45TT-getMetas arg-2))) (CoreC-45Unify-chaseMetas arg-1 (LibrariesC-45DataC-45NameMap-keys u--metas) (LibrariesC-45DataC-45NameMap-empty)))))
(define CoreC-45Unify-getIVars (lambda (arg-2) (if (null? arg-2) '() (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (cons e-4 (CoreC-45Unify-getIVars e-5)))))))
(define CoreC-45Unify-getArgTypes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (case (vector-ref e-4 0) ((2) (let ((e-10 (vector-ref e-4 4))) (lambda (clam-0) (if (null? arg-4) (if (null? arg-4) (vector 1 (box '())) (vector 1 '())) (let ((e-12 (car arg-4))) (let ((e-13 (cdr arg-4))) (let ((act-24 (let ((act-24 (((e-5 arg-2) e-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((CoreC-45Unify-getArgTypes arg-0 arg-1 arg-2 e-6 e-13) clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-2 e-10) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) (vector 1 (box (cons e-11 e-1)))))))))))))))))))(else (lambda (clam-1) (if (null? arg-4) (vector 1 (box '())) (vector 1 '()))))))))(else (lambda (clam-2) (if (null? arg-4) (vector 1 (box '())) (vector 1 '())))))))
(define CoreC-45Unify-forceMeta (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) (vector 8 (CoreC-45TT-getLoc arg-3) arg-1 arg-3))(else (let ((e-0 (- arg-2 1))) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (vector 3 e-2 e-3 e-4 (CoreC-45Unify-forceMeta arg-1 e-0 e-5)))))))(else (vector 8 (CoreC-45TT-getLoc arg-3) arg-1 arg-3))))))))
(define CoreC-45Unify-dumpArg (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-logTerm (PreludeC-45TypesC-45List-tailRecAppend e-1 arg-0) arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "Term: ") e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-7 (vector 0 e-1 e-2 e-3 e-4 e-5)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "  ") arg-2 e-9 ext-0))))))))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-6 arg-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Normalise-logNF arg-0 arg-1 "unify" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "  ") arg-2 e-7 ext-0)))))))))))))))))
(define CoreC-45Unify-delayMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-2 0) (vector 7 (CoreC-45TT-getLoc arg-4) arg-1 arg-3 arg-4))(else (let ((e-0 (- arg-2 1))) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (vector 3 e-2 e-3 e-4 (CoreC-45Unify-delayMeta (cons e-3 arg-0) arg-1 e-0 (CoreC-45TT-u--weaken_Weaken_Term arg-3) e-5)))))))(else (vector 7 (CoreC-45TT-getLoc arg-4) arg-1 arg-3 arg-4))))))))
(define CoreC-45Unify-convertErrorS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (cond ((equal? arg-3 1) (CoreC-45Unify-convertError arg-1 arg-2 arg-4 arg-5 arg-7 arg-6 clam-0)) (else (CoreC-45Unify-convertError arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 clam-0))))))
(define CoreC-45Unify-convertError (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-1 e-6 arg-4 arg-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-1 e-6 arg-4 arg-6 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 1 arg-1 arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) arg-4 e-7 e-8) ext-0)))))))))))))))))))
(define CoreC-45Unify-constrain (lambda (arg-0) (vector (cons arg-0 '()) 0 '() (vector 0 ))))
(define CoreC-45Unify-checkDots (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-getCurrentHoles arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Unify-n--24691-23737-u--checkConstraint arg-1 arg-0 eta-0)) (PreludeC-45TypesC-45List-reverse (let ((e-7 (vector-ref e-5 7))) e-7)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45UnifyState-getCurrentHoles arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (unbox arg-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (set-box! arg-0 (let ((e-0 (vector-ref e-9 0))) (let ((e-1 (vector-ref e-9 1))) (let ((e-2 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (let ((e-16 (vector-ref e-9 5))) (let ((e-15 (vector-ref e-9 6))) (let ((e-13 (vector-ref e-9 8))) (let ((e-12 (vector-ref e-9 9))) (let ((e-10 (vector-ref e-9 10))) (let ((e-11 (vector-ref e-9 11))) (vector e-0 e-1 e-2 e-3 e-4 e-16 e-15 '() e-13 e-12 e-10 e-11))))))))))))))) (vector 1 act-29)))))))))))))))))))))
(define CoreC-45Unify-checkArgsSame (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 ext-0) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((1) (let ((e-9 (vector-ref e-1 2))) (let ((e-4 (vector-ref e-1 3))) (if (null? e-9) (case (vector-ref e-4 0) ((1) (let ((e-12 (vector-ref e-4 1))) (let ((e-11 (vector-ref e-4 2))) (cond ((equal? e-12 0) (let ((act-26 (CoreC-45Unify-n--24376-23471-u--anySame e-2 e-3 arg-1 arg-0 e-11 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) (cond ((equal? e-13 1) (vector 1 1)) (else (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 ext-0))))))))(else (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 ext-0))))))(else (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 ext-0))) (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 ext-0)))))(else (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 ext-0))))))))))))))))))
(define CoreC-45Unify-chaseMetas (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45NameMap-keys arg-2))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (CoreC-45Unify-case--chaseMetas-8743 e-2 e-3 arg-2 arg-0 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-2)))))))
(define CoreC-45GetType-getType (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45GetType-chk arg-0 arg-1 arg-2 arg-3)))
(define CoreC-45GetType-discharge (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (vector 3 arg-1 arg-2 (vector 2 e-1 e-2 e-3 e-4) arg-5)))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (vector 3 arg-1 arg-2 (vector 1 e-6 e-7 e-8 e-9) arg-5)))))) ((2) arg-4) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 4))) (vector 3 arg-1 arg-2 (vector 5 e-16 e-17 e-19) arg-5))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (vector 3 arg-1 arg-2 (vector 4 e-21 e-22 e-23 e-24) arg-5)))))) (else arg-4))))
(define CoreC-45GetType-chkMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-3 arg-4))))))) (case (vector-ref arg-4 0) ((0) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (if (null? arg-5) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-3 arg-4 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-0 arg-2 arg-3 e-10) clam-0))))))))) (let ((e-11 (car arg-5))) (let ((e-12 (cdr arg-5))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45GetType-chk arg-0 arg-1 arg-3 e-11) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((act-26 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 e-11)) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) ((CoreC-45GetType-chkMeta arg-0 arg-1 arg-2 arg-3 e-13 e-12) clam-0))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-3 arg-4 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-0 arg-2 arg-3 e-6) clam-0)))))))))))))))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-3 arg-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-0 arg-2 arg-3 e-6) eta-0)))))))))))))))
(define CoreC-45GetType-chkConstant (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (vector 9 arg-1 (vector 14 ))) ((1) (vector 9 arg-1 (vector 15 ))) ((2) (vector 9 arg-1 (vector 16 ))) ((3) (vector 9 arg-1 (vector 17 ))) ((4) (vector 9 arg-1 (vector 18 ))) ((5) (vector 9 arg-1 (vector 19 ))) ((6) (vector 9 arg-1 (vector 20 ))) ((7) (vector 9 arg-1 (vector 21 ))) ((8) (vector 9 arg-1 (vector 22 ))) ((9) (vector 9 arg-1 (vector 23 ))) ((10) (vector 9 arg-1 (vector 24 ))) ((11) (vector 9 arg-1 (vector 25 ))) ((12) (vector 9 arg-1 (vector 26 ))) ((13) (vector 9 arg-1 (vector 27 )))(else (vector 11 arg-1)))))
(define CoreC-45GetType-chkBinder (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45GetType-chk arg-0 arg-1 arg-2 (CoreC-45TT-binderType arg-3))))
(define CoreC-45GetType-chk (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 3))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (CoreC-45TT-binderType (CoreC-45Env-getBinder (csegen-764) arg-0 e-4 arg-2))))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact e-9 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-1 e-7 e-9 eta-0) (let ((e-1 (unbox e-6))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (CoreC-45TT-embed e-1))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact (vector 8 e-13) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-1 e-11 e-12 eta-0) (let ((e-1 (unbox e-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-2 (CoreC-45TT-embed e-1)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((CoreC-45GetType-chkMeta arg-0 arg-1 e-11 arg-2 e-7 e-14) eta-0))))))))))))))))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45GetType-chkBinder arg-0 arg-1 arg-2 e-18) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45GetType-chk (cons e-17 arg-0) arg-1 (cons e-18 arg-2) e-19) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-getTerm e-6) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (CoreC-45GetType-discharge e-16 e-17 e-18 e-7 e-8))))))))))))))))))))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45GetType-chk arg-0 arg-1 arg-2 e-22) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((0) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45GetType-chk arg-0 arg-1 arg-2 e-23) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((act-28 (((e-4 e-11) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-2 e-23)) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (vector 1 (CoreC-45Normalise-glueBack arg-1 arg-0 e-11 arg-2 e-13))))))))))))))(else (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-0 e-21 arg-2 e-7) eta-0))))))))))(else (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-0 e-21 arg-2 e-7) eta-0)))))))))))))))))))) ((5) (let ((e-28 (vector-ref arg-3 4))) (CoreC-45GetType-chk arg-0 arg-1 arg-2 e-28))) ((6) (let ((e-30 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gType e-30))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-37 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45GetType-chk arg-0 arg-1 arg-2 e-37) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45Normalise-glueBack arg-1 arg-0 e-7 arg-2 (vector 5 e-34 e-35 e-6)))))))))))))))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-41 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45GetType-chk arg-0 arg-1 arg-2 e-41) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((5) (let ((e-3 (vector-ref e-6 3))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45Normalise-glueBack arg-1 arg-0 e-7 arg-2 e-3))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-39 "Not a delayed type") eta-0))))))))))))))) ((9) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (CoreC-45GetType-chkConstant e-43 e-44))))))) ((11) (let ((e-46 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gType e-46))))) (else (let ((e-48 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gErased e-48))))))))
(define IdrisC-45Resugar-n--10225-4666-u--needsBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) 0 (let ((e-1 (unbox arg-8))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (let ((u--ret (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) arg-0))) (let ((u--ns (TTImpC-45Utils-findBindableNames 0 '() '() u--ret))) (let ((u--allNs (TTImpC-45Utils-findAllNames '() u--ret))) (let ((sc3 (PreludeC-45Types-elem (csegen-802) e-1 u--allNs))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Types-elem (csegen-17) e-3 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--ns)))) (cond ((equal? sc4 1) 0) (else 1)))) (else 0))))))))(else 0))))(else 0))))))
(define IdrisC-45Resugar-n--8734-3179-u--needed (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((32) 0) ((0) 0) ((40) 0) ((41) 0) ((42) 0) ((44) 0) ((38) 0) ((39) 0) ((46) 0) ((47) 0) ((15) 0) ((37) 0) ((36) 0)(else 1))))
(define IdrisC-45Resugar-n--10225-5101-u--mkIf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((4) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (if (null? e-3) arg-7 (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (case (vector-ref e-5 0) ((0) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((e-10 (vector-ref e-5 3))) (let ((e-11 (vector-ref e-5 4))) (case (vector-ref e-9 0) ((0) (let ((e-13 (vector-ref e-9 1))) (let ((e-14 (vector-ref e-9 2))) (if (null? e-11) (if (null? e-6) arg-7 (let ((e-17 (car e-6))) (let ((e-18 (cdr e-6))) (case (vector-ref e-17 0) ((0) (let ((e-20 (vector-ref e-17 1))) (let ((e-21 (vector-ref e-17 2))) (let ((e-22 (vector-ref e-17 3))) (let ((e-23 (vector-ref e-17 4))) (case (vector-ref e-21 0) ((0) (let ((e-25 (vector-ref e-21 1))) (let ((e-26 (vector-ref e-21 2))) (if (null? e-23) (if (null? e-18) (let ((u--tm (vector 4 e-1 e-2 (cons (vector 0 e-8 (vector 0 e-13 e-14) e-10 '()) (cons (vector 0 e-20 (vector 0 e-25 e-26) e-22 '()) '()))))) (let ((sc10 (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (let ((e-4 (vector-ref e-14 2))) e-4)) (vector 1 (vector 0 "True"))))) (cond ((equal? sc11 1) (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (let ((e-4 (vector-ref e-26 2))) e-4)) (vector 1 (vector 0 "False")))) (else 0))))) (cond ((equal? sc10 1) (vector 43 e-1 e-2 e-10 e-22)) (else u--tm)))) arg-7) arg-7))))(else arg-7)))))))(else arg-7))))) arg-7))))(else arg-7)))))))(else arg-7)))))))))(else arg-7))))
(define IdrisC-45Resugar-n--10269-6093-u--mapPiInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-7 1))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-6 arg-5 (IdrisC-45Resugar-startPrec) e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5)))))))))))
(define IdrisC-45Resugar-n--12440-6514-u--cleanNode (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (lambda (eta-0) (IdrisC-45Resugar-n--12440-6512-u--cleanKindedName arg-0 arg-1 e-2 eta-0)) clam-0)))) ((27) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref eta-0 1))) (vector 1 (vector 27 e-4 e-5 e-9 e-7 e-8)))))) (lambda (eta-0) (IdrisC-45Resugar-n--12440-6512-u--cleanKindedName arg-0 arg-1 e-6 eta-0)) clam-0))))))) ((28) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 28 e-10 e-11 e-5 e-13)))))) (lambda (eta-0) (IdrisC-45Resugar-n--12440-6512-u--cleanKindedName arg-0 arg-1 e-12 eta-0)) clam-0)))))) ((29) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((e-18 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 29 e-15 e-16 e-5 e-18)))))) (lambda (eta-0) (IdrisC-45Resugar-n--12440-6512-u--cleanKindedName arg-0 arg-1 e-17 eta-0)) clam-0)))))) ((30) (let ((e-20 (vector-ref arg-2 1))) (let ((e-21 (vector-ref arg-2 2))) (let ((e-22 (vector-ref arg-2 3))) (let ((e-23 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 30 e-20 e-21 e-22 e-5)))))) (lambda (eta-0) (IdrisC-45Resugar-n--12440-6512-u--cleanKindedName arg-0 arg-1 e-23 eta-0)) clam-0)))))) ((1) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (let ((e-29 (vector-ref arg-2 5))) (let ((e-30 (vector-ref arg-2 6))) (if (null? e-28) (vector 1 arg-2) (let ((e-32 (unbox e-28))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-25 e-26 e-27 e-5 e-29 e-30)))))) (IdrisC-45Resugar-n--12440-6513-u--cleanBinderName arg-0 arg-1 e-27 e-32) clam-0))))))))))(else (vector 1 arg-2))))))
(define IdrisC-45Resugar-n--12440-6511-u--cleanName (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((2) (let ((e-0 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 (vector 1 (CoreC-45Name-mkUserName e-0)))))) ((3) (let ((e-2 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 e-2)))) ((4) (let ((e-4 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 (vector 1 (CoreC-45Name-mkUserName e-4)))))) ((0) (let ((e-7 (vector-ref arg-2 2))) (IdrisC-45Resugar-n--12440-6511-u--cleanName arg-0 arg-1 e-7))) ((5) (let ((e-9 (vector-ref arg-2 2))) (IdrisC-45Resugar-n--12440-6511-u--cleanName arg-0 arg-1 e-9))) ((1) (let ((e-10 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 (vector 1 e-10)))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 1 (CoreC-45Name-mkUserName e-5))))))) (CoreC-45Context-prettyName arg-1 arg-2) eta-0))))))
(define IdrisC-45Resugar-n--12440-6512-u--cleanKindedName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-0 (vector-ref arg-2 0))) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector e-0 e-1 e-5)))))) (IdrisC-45Resugar-n--12440-6511-u--cleanName arg-0 arg-1 e-2) ext-0))))))
(define IdrisC-45Resugar-n--12440-6513-u--cleanBinderName (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((2) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (lambda (clam-0) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (cond ((equal? e-2 "__con") (vector 1 '()))(else (PreludeC-45IO-u--map_Functor_IO (csegen-980) (IdrisC-45Resugar-n--12440-6511-u--cleanName arg-0 arg-1 arg-3) clam-0)))))(else (PreludeC-45IO-u--map_Functor_IO (csegen-980) (IdrisC-45Resugar-n--12440-6511-u--cleanName arg-0 arg-1 arg-3) clam-0))))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (IdrisC-45Resugar-n--12440-6511-u--cleanName arg-0 arg-1 arg-3) eta-0)))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (IdrisC-45Resugar-n--12440-6511-u--cleanName arg-0 arg-1 arg-3) eta-0))))))
(define IdrisC-45Resugar-unbracketApp (lambda (arg-1) (case (vector-ref arg-1 0) ((32) (let ((e-2 (vector-ref arg-1 2))) (case (vector-ref e-2 0) ((7) e-2)(else arg-1))))(else arg-1))))
(define IdrisC-45Resugar-unbracket (lambda (arg-1) (case (vector-ref arg-1 0) ((32) (let ((e-2 (vector-ref arg-1 2))) e-2))(else arg-1))))
(define IdrisC-45Resugar-tyPrec(blodwen-lazy (lambda () (+ 1 0))))
(define IdrisC-45Resugar-toPTypeDecl (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector e-1 e-2 e-3 "" e-5))))))))))))
(define IdrisC-45Resugar-toPTermApp (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-2 0) ((8) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-2 (cons (cons e-1 (cons '() e-5)) arg-3) ext-0))))))))) ((10) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-6 (cons (cons e-5 (cons (box (box e-7)) e-9)) arg-3) ext-0)))))))))) ((0) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (let ((e-2 (vector-ref e-11 2))) e-2) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--fn (vector 0 e-10 e-11))) (if (null? e-6) (let ((act-26 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-appPrec) u--fn) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((IdrisC-45Resugar-mkApp arg-0 arg-1 e-7 arg-3) ext-0))))) (let ((e-2 (unbox e-6))) (let ((act-26 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-appPrec) u--fn) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45Resugar-showFullEnv arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--argsC-39 (cond ((equal? e-8 1) arg-3) (else (DataC-45List-drop (PreludeC-45TypesC-45List-length (let ((e-24 (vector-ref e-2 8))) e-24)) arg-3))))) ((IdrisC-45Resugar-mkApp arg-0 arg-1 e-7 u--argsC-39) ext-0))))))))))))))))))))))))(else (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-appPrec) arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45Resugar-mkApp arg-0 arg-1 e-5 arg-3) ext-0)))))))))
(define IdrisC-45Resugar-toPTerm (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (let ((e-3 (vector-ref e-5 2))) e-3))) (cond ((equal? sc2 1) (vector 1 (vector 0 e-1 e-2))) (else ((IdrisC-45Resugar-toPRef e-1 e-2) eta-0)))))))))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "resugar.var" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (DataC-45String-unwords (cons "Resugaring" (cons (CoreC-45Name-u--show_Show_RawName (let ((e-3 (vector-ref e-2 2))) e-3)) (cons "to" (cons (IdrisC-45Syntax-u--show_Show_IPTerm e-5) '())))))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 e-5)))))))))))) ((1) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (let ((e-8 (vector-ref arg-3 5))) (let ((e-9 (vector-ref arg-3 6))) (lambda (clam-0) (case (vector-ref e-6 0) ((0) (let ((act-24 (IdrisC-45Resugar-showImplicits arg-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-24 1))) (cond ((equal? e-10 1) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-tyPrec) e-8) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-tyPrec) e-9) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-26 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-tyPrec) (vector 1 e-4 e-5 (vector 0 ) e-7 e-11 e-12) clam-0)))))))))) (else (let ((sc4 (IdrisC-45Resugar-n--10225-4666-u--needsBind e-9 e-8 e-7 e-5 e-4 arg-2 arg-1 arg-0 e-7))) (cond ((equal? sc4 1) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-tyPrec) e-8) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-tyPrec) e-9) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-26 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-tyPrec) (vector 1 e-4 e-5 (vector 0 ) e-7 e-11 e-12) clam-0)))))))))) (else ((IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-9) clam-0)))))))))))(else (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-appPrec) e-8) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-tyPrec) e-9) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-25 1))) (let ((act-26 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) eta-0)) e-6 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-26 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-tyPrec) (vector 1 e-4 e-5 e-12 e-7 e-10 e-11) clam-0))))))))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (let ((e-15 (vector-ref arg-3 5))) (let ((e-16 (vector-ref arg-3 6))) (let ((u--n (if (null? e-14) (vector 1 (vector 2 )) (let ((e-2 (unbox e-14))) e-2)))) (lambda (eta-0) (let ((act-24 (IdrisC-45Resugar-showImplicits arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (cond ((equal? e-5 1) ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-tyPrec) e-15) eta-0)) (else (vector 1 (vector 25 e-11)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-16) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) eta-1)) e-13 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--var (vector 0 e-11 (vector (box (vector 0 )) u--n u--n)))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) (vector 2 e-11 e-12 e-8 u--var e-6 e-7) eta-0))))))))))))))))))))))))))) ((3) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (let ((e-21 (vector-ref arg-3 4))) (let ((e-22 (vector-ref arg-3 5))) (let ((e-23 (vector-ref arg-3 6))) (let ((e-24 (vector-ref arg-3 7))) (lambda (eta-0) (let ((act-24 (IdrisC-45Resugar-showImplicits arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (cond ((equal? e-5 1) ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-22) eta-0)) (else (vector 1 (vector 25 e-18)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-23) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-24) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--var (vector 0 e-19 (vector (box (vector 0 )) e-21 e-21)))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) (vector 3 e-18 e-20 u--var e-6 e-7 e-8 '()) eta-0))))))))))))))))))))))))))) ((4) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (if (null? e-29) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-27) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-1 eta-2))) e-29 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) (IdrisC-45Resugar-n--10225-5101-u--mkIf e-29 e-28 e-27 e-26 arg-2 arg-1 arg-0 (vector 4 e-26 e-5 e-6)) eta-0)))))))))) (let ((e-138 (car e-29))) (let ((e-139 (cdr e-29))) (lambda (clam-0) (case (vector-ref e-138 0) ((0) (let ((e-142 (vector-ref e-138 2))) (let ((e-143 (vector-ref e-138 3))) (if (null? e-139) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-27) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-142) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-143) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) (vector 3 e-26 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) e-6 (vector 25 e-26) e-5 e-7 '()) clam-0))))))))))))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-27) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-0 eta-1))) e-29 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) (IdrisC-45Resugar-n--10225-5101-u--mkIf e-29 e-28 e-27 e-26 arg-2 arg-1 arg-0 (vector 4 e-26 e-5 e-6)) clam-0)))))))))))))(else (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-27) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-0 eta-1))) e-29 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) (IdrisC-45Resugar-n--10225-5101-u--mkIf e-29 e-28 e-27 e-26 arg-2 arg-1 arg-0 (vector 4 e-26 e-5 e-6)) clam-0)))))))))))))))))))) ((5) (let ((e-31 (vector-ref arg-3 1))) (let ((e-32 (vector-ref arg-3 2))) (let ((e-33 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-1 eta-2))) e-32 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-33) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) (vector 5 e-31 (DataC-45List-mapMaybe (lambda (eta-1) eta-1) e-5) e-6) eta-0)))))))))))))) ((6) (let ((e-39 (vector-ref arg-3 5))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-39))) ((7) (let ((e-41 (vector-ref arg-3 1))) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPFieldUpdate arg-0 arg-1 eta-1 eta-2))) e-42 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-43) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) (vector 7 e-41 (vector 6 e-41 e-5) e-6) eta-0)))))))))))))) ((8) (let ((e-45 (vector-ref arg-3 1))) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-47) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-46 (cons (cons e-45 (cons '() e-5)) '()) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-appPrec) e-6 eta-0)))))))))))))) ((9) (let ((e-49 (vector-ref arg-3 1))) (let ((e-50 (vector-ref arg-3 2))) (let ((e-51 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-51) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-50 (cons (cons e-49 (cons (box '()) e-5)) '()) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-appPrec) e-6 eta-0)))))))))))))) ((11) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (let ((e-55 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-55) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-54) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-appPrec) (vector 8 e-53 e-6 e-5) eta-0)))))))))))))) ((10) (let ((e-57 (vector-ref arg-3 1))) (let ((e-58 (vector-ref arg-3 2))) (let ((e-59 (vector-ref arg-3 3))) (let ((e-60 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-60) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-58 (cons (cons e-57 (cons (box (box e-59)) e-5)) '()) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Resugar-showImplicits arg-0 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) (IdrisC-45Resugar-bracket arg-1 arg-2 (IdrisC-45Resugar-startPrec) e-6 eta-0)) (else ((IdrisC-45Resugar-mkOp arg-1 e-6) eta-0))))))))))))))))))))) ((12) (let ((e-62 (vector-ref arg-3 1))) (let ((e-63 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (vector 14 e-62 e-63)))))) ((13) (let ((e-65 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (vector 25 e-65))))) ((14) (let ((e-69 (vector-ref arg-3 1))) (let ((e-70 (vector-ref arg-3 2))) (let ((e-71 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-70) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-71) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 45 e-69 e-5 e-6))))))))))))))) ((15) (let ((e-74 (vector-ref arg-3 2))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-74))) ((28) (let ((e-76 (vector-ref arg-3 1))) (let ((e-77 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (vector 15 e-76 e-77)))))) ((30) (let ((e-79 (vector-ref arg-3 1))) (let ((e-80 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (vector 21 e-79 0 e-80)))))) ((29) (let ((e-82 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (vector 22 e-82))))) ((17) (let ((e-84 (vector-ref arg-3 1))) (let ((e-85 (vector-ref arg-3 2))) (let ((u--nm (vector 1 (vector 0 e-85)))) (lambda (eta-0) (vector 1 (vector 0 e-84 (vector (box (vector 0 )) u--nm u--nm)))))))) ((16) (let ((e-89 (vector-ref arg-3 3))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-89))) ((18) (let ((e-91 (vector-ref arg-3 1))) (let ((e-92 (vector-ref arg-3 2))) (let ((e-94 (vector-ref arg-3 4))) (let ((e-95 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-95) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 23 e-91 e-92 e-94 e-5)))))))))))) ((19) (let ((e-97 (vector-ref arg-3 1))) (let ((e-99 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-99) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 24 e-97 e-5)))))))))) ((20) (let ((e-101 (vector-ref arg-3 1))) (let ((e-102 (vector-ref arg-3 2))) (let ((e-103 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-103) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 11 e-101 e-102 e-5))))))))))) ((21) (let ((e-105 (vector-ref arg-3 1))) (let ((e-106 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-106) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 12 e-105 e-5)))))))))) ((22) (let ((e-108 (vector-ref arg-3 1))) (let ((e-109 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-109) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 13 e-108 e-5)))))))))) ((23) (let ((e-111 (vector-ref arg-3 1))) (let ((e-112 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-112) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 16 e-111 e-5)))))))))) ((24) (let ((e-114 (vector-ref arg-3 1))) (let ((e-115 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (vector 17 e-114 e-115)))))) ((25) (let ((e-117 (vector-ref arg-3 1))) (let ((e-118 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-1 eta-2))) e-118 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 18 e-117 (DataC-45List-mapMaybe (lambda (eta-1) eta-1) e-5))))))))))) ((26) (let ((e-120 (vector-ref arg-3 1))) (let ((e-121 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-121) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 19 e-120 e-5)))))))))) ((27) (let ((e-123 (vector-ref arg-3 1))) (let ((e-124 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-argPrec) e-124) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 20 e-123 e-5)))))))))) ((31) (let ((e-128 (vector-ref arg-3 3))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-128))) ((32) (let ((e-130 (vector-ref arg-3 1))) (let ((e-131 (vector-ref arg-3 2))) (lambda (clam-2) (cond ((equal? e-131 1) (vector 1 (vector 25 e-130))) (else (vector 1 (vector 26 e-130)))))))) (else (let ((e-133 (vector-ref arg-3 1))) (let ((e-134 (vector-ref arg-3 2))) (let ((e-135 (vector-ref arg-3 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 51 e-133 e-134 e-5)))))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-135) eta-0)))))))))
(define IdrisC-45Resugar-toPRef (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((u--kn (vector e-0 e-1 e-2))) (case (vector-ref e-2 0) ((2) (let ((e-4 (vector-ref e-2 1))) (lambda (eta-0) (vector 1 (IdrisC-45Resugar-sugarApp (vector 0 arg-0 (vector e-0 e-1 (vector 1 (vector 0 e-4))))))))) ((3) (let ((e-4 (vector-ref e-2 1))) (lambda (eta-0) (vector 1 (IdrisC-45Resugar-sugarApp (vector 0 arg-0 (vector e-0 e-1 e-4))))))) ((4) (let ((e-4 (vector-ref e-2 1))) (lambda (eta-0) (vector 1 (IdrisC-45Resugar-sugarApp (vector 0 arg-0 (vector e-0 e-1 (vector 1 (vector 0 e-4))))))))) ((5) (let ((e-7 (vector-ref e-2 2))) (IdrisC-45Resugar-toPRef arg-0 (vector e-0 e-1 e-7))))(else (lambda (eta-0) (vector 1 (IdrisC-45Resugar-sugarApp (vector 0 arg-0 u--kn))))))))))))
(define IdrisC-45Resugar-toPRecord (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (let ((e-7 (car lamc-0))) (let ((e-6 (cdr lamc-0))) (lambda (clam-0) (let ((e-9 (car e-6))) (let ((e-8 (cdr e-6))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-11) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-12 (vector-ref act-24 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-n--10269-6093-u--mapPiInfo e-5 e-4 e-3 e-2 e-1 arg-1 arg-0 e-10 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-13 (vector-ref act-25 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-25 1))) (vector 1 (cons e-7 (cons e-9 (cons e-13 e-12)))))))))))))))))))) e-3 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPField arg-0 arg-1 eta-0 eta-1))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (cons e-2 (cons e-6 (cons (box e-4) e-7)))))))))))))))))))
(define IdrisC-45Resugar-toPFnOpt (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((5) (let ((e-1 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) eta-0)) e-1 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-5))))))))(else (vector 1 (vector 0 arg-2))))))
(define IdrisC-45Resugar-toPFieldUpdate (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-5))))))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector 1 e-4 e-6))))))))))))
(define IdrisC-45Resugar-toPField (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) eta-0)) e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector e-1 "" e-2 e-7 e-4 e-6)))))))))))))))))
(define IdrisC-45Resugar-toPDecl (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPFnOpt arg-0 arg-1 eta-0 eta-1))) e-4 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-toPTypeDecl arg-0 arg-1 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (box (vector 0 e-1 e-2 e-3 e-6 e-7))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((act-24 (IdrisC-45Resugar-toPData arg-0 arg-1 e-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (vector 2 e-7 "" e-8 e-5))))))))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-13 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-0 eta-1))) e-13 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (vector 1 e-11 e-5)))))))))) ((3) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-0 eta-1))) e-17 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-25 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) eta-0)) e-10 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-11) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (cons e-2 (cons e-6 (cons e-8 e-9)))))))))))))))))))) e-16 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box (vector 3 e-15 e-6 (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-5)))))))))))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((act-24 (IdrisC-45Resugar-toPRecord arg-0 arg-1 e-22 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (box (vector 8 e-19 "" e-21 e-2 e-6 e-10 e-11))))))))))))))))) ((5) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-0 eta-1))) e-26 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (vector 11 e-24 e-25 (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-5)))))))))))) ((6) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-30) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-31) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box (vector 12 e-28 (CoreC-45Name-u--show_Show_Name e-29) e-5 e-6)))))))))))))))) ((7) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-34) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (vector 13 e-33 e-5)))))))))) ((8) (vector 1 '())) ((9) (vector 1 '())) (else (let ((e-41 (vector-ref arg-2 1))) (let ((e-42 (vector-ref arg-2 2))) (let ((e-43 (vector-ref arg-2 3))) (vector 1 (box (vector 15 e-41 e-42 e-43))))))))))
(define IdrisC-45Resugar-toPData (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPTypeDecl arg-0 arg-1 eta-0 eta-1))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-6 e-4 e-7)))))))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-9) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-7 e-8 e-5)))))))))))))
(define IdrisC-45Resugar-toPClause (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-5 e-6 '())))))))))))))) ((1) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((e-9 (vector-ref arg-2 5))) (let ((e-10 (vector-ref arg-2 6))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-0 eta-1))) e-10 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (vector 1 (vector 1 e-5 e-11 e-12 e-8 e-9 e-13))))))))))))))))))))) (else (let ((e-12 (vector-ref arg-2 1))) (let ((e-13 (vector-ref arg-2 2))) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) e-13) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-12 e-5))))))))))))
(define IdrisC-45Resugar-toCleanPTerm (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Resugar-cleanPTerm arg-0 e-5 ext-0)))))))
(define IdrisC-45Resugar-sugarName (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(implicit) " e-0))) ((3) (let ((e-2 (vector-ref arg-0 1))) (IdrisC-45Resugar-sugarName e-2))) ((4) (let ((e-4 (vector-ref arg-0 1))) e-4))(else (CoreC-45Name-u--show_Show_Name arg-0)))))
(define IdrisC-45Resugar-sugarAppM (lambda (arg-0) (case (vector-ref arg-0 0) ((7) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (case (vector-ref e-2 0) ((7) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((7) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((0) (let ((e-17 (vector-ref e-10 2))) (let ((e-20 (vector-ref e-17 2))) (case (vector-ref e-20 0) ((0) (let ((e-22 (vector-ref e-20 2))) (let ((sc5 (CoreC-45Name-nameRoot e-22))) (cond ((equal? sc5 "rangeFromThenTo") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 46 e-1 (IdrisC-45Resugar-unbracket e-11) (box (IdrisC-45Resugar-unbracket e-7)) (IdrisC-45Resugar-unbracket e-3))))(else '())))))(else (let ((sc4 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc4) (case (vector-ref arg-0 0) ((0) (let ((e-8 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-12 (vector-ref e-4 2))) (case (vector-ref e-12 0) ((0) (let ((e-21 (vector-ref e-12 1))) (let ((e-15 (vector-ref e-12 2))) (let ((sc7 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (CoreC-45NameC-45Namespace-builtinNS) e-21))) (cond ((equal? sc7 1) (let ((sc8 (CoreC-45Name-nameRoot e-15))) (cond ((equal? sc8 "Unit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-8))) ((equal? sc8 "MkUnit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-8)))(else '())))) (else (let ((sc8 (CoreC-45Name-nameRoot e-15))) (cond ((equal? sc8 "Nil") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 38 e-8 e-8 '()))) ((equal? sc8 "Lin") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 39 e-8 e-8 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (case (vector-ref e-12 0) ((0) (let ((e-14 (vector-ref e-12 2))) (let ((e-21 (vector-ref e-14 2))) (case (vector-ref e-21 0) ((0) (let ((e-23 (vector-ref e-21 2))) (let ((sc8 (CoreC-45Name-nameRoot e-23))) (cond ((equal? sc8 "rangeFrom") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 47 e-4 (IdrisC-45Resugar-unbracket e-8) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc4))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 (PreludeC-45Cast-u--cast_Cast_Nat_Integer e-4))))))))))))(else (let ((sc3 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc3) (case (vector-ref arg-0 0) ((0) (let ((e-8 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-12 (vector-ref e-4 2))) (case (vector-ref e-12 0) ((0) (let ((e-16 (vector-ref e-12 1))) (let ((e-15 (vector-ref e-12 2))) (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (CoreC-45NameC-45Namespace-builtinNS) e-16))) (cond ((equal? sc6 1) (let ((sc7 (CoreC-45Name-nameRoot e-15))) (cond ((equal? sc7 "Unit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-8))) ((equal? sc7 "MkUnit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-8)))(else '())))) (else (let ((sc7 (CoreC-45Name-nameRoot e-15))) (cond ((equal? sc7 "Nil") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 38 e-8 e-8 '()))) ((equal? sc7 "Lin") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 39 e-8 e-8 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (case (vector-ref e-12 0) ((0) (let ((e-14 (vector-ref e-12 2))) (let ((e-17 (vector-ref e-14 2))) (case (vector-ref e-17 0) ((0) (let ((e-19 (vector-ref e-17 2))) (let ((sc7 (CoreC-45Name-nameRoot e-19))) (cond ((equal? sc7 "rangeFrom") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 47 e-4 (IdrisC-45Resugar-unbracket e-8) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc3))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 (PreludeC-45Cast-u--cast_Cast_Nat_Integer e-4)))))))))))) ((0) (let ((e-13 (vector-ref e-6 1))) (let ((e-14 (vector-ref e-6 2))) (let ((e-25 (vector-ref e-14 2))) (case (vector-ref e-25 0) ((0) (let ((e-26 (vector-ref e-25 1))) (let ((e-27 (vector-ref e-25 2))) (let ((sc4 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (CoreC-45NameC-45Namespace-builtinNS) e-26))) (cond ((equal? sc4 1) (let ((sc5 (CoreC-45Name-nameRoot e-27))) (cond ((equal? sc5 "Pair") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 40 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "MkPair") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 40 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "DPair") (let ((sc6 (IdrisC-45Resugar-unbracket e-3))) (case (vector-ref sc6 0) ((2) (let ((e-4 (vector-ref sc6 4))) (let ((e-8 (vector-ref sc6 6))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 41 e-1 e-13 e-4 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-8))))))(else '())))) ((equal? sc5 "Equal") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 31 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "===") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 31 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "~=~") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 31 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3))))(else '())))) (else (let ((sc5 (CoreC-45Name-nameRoot e-27))) (cond ((equal? sc5 "::") (let ((sc6 (IdrisC-45Resugar-sugarApp (IdrisC-45Resugar-unbracket e-3)))) (case (vector-ref sc6 0) ((38) (let ((e-9 (vector-ref sc6 1))) (let ((e-8 (vector-ref sc6 2))) (let ((e-4 (vector-ref sc6 3))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 38 e-9 e-8 (cons (cons e-13 (IdrisC-45Resugar-unbracketApp e-7)) e-4)))))))(else '())))) ((equal? sc5 ":<") (let ((sc6 (IdrisC-45Resugar-sugarApp (IdrisC-45Resugar-unbracket e-3)))) (case (vector-ref sc6 0) ((39) (let ((e-9 (vector-ref sc6 1))) (let ((e-8 (vector-ref sc6 2))) (let ((e-4 (vector-ref sc6 3))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 39 e-9 e-8 (PreludeC-45TypesC-45List-tailRecAppend e-4 (cons (cons e-13 (IdrisC-45Resugar-unbracketApp e-7)) '()))))))))(else '())))) ((equal? sc5 "rangeFromTo") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 46 e-1 (IdrisC-45Resugar-unbracket e-7) '() (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "rangeFromThen") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 47 e-1 (IdrisC-45Resugar-unbracket e-7) (box (IdrisC-45Resugar-unbracket e-3)))))(else '())))))))))(else (let ((sc3 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc3) (case (vector-ref arg-0 0) ((0) (let ((e-8 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-9 (vector-ref e-4 2))) (case (vector-ref e-9 0) ((0) (let ((e-15 (vector-ref e-9 1))) (let ((e-12 (vector-ref e-9 2))) (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (CoreC-45NameC-45Namespace-builtinNS) e-15))) (cond ((equal? sc6 1) (let ((sc7 (CoreC-45Name-nameRoot e-12))) (cond ((equal? sc7 "Unit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-8))) ((equal? sc7 "MkUnit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-8)))(else '())))) (else (let ((sc7 (CoreC-45Name-nameRoot e-12))) (cond ((equal? sc7 "Nil") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 38 e-8 e-8 '()))) ((equal? sc7 "Lin") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 39 e-8 e-8 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (case (vector-ref e-9 0) ((0) (let ((e-15 (vector-ref e-9 2))) (let ((e-17 (vector-ref e-15 2))) (case (vector-ref e-17 0) ((0) (let ((e-20 (vector-ref e-17 2))) (let ((sc7 (CoreC-45Name-nameRoot e-20))) (cond ((equal? sc7 "rangeFrom") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 47 e-4 (IdrisC-45Resugar-unbracket e-8) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc3))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 (PreludeC-45Cast-u--cast_Cast_Nat_Integer e-4)))))))))))))(else (let ((sc2 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc2) (case (vector-ref arg-0 0) ((0) (let ((e-8 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-9 (vector-ref e-4 2))) (case (vector-ref e-9 0) ((0) (let ((e-13 (vector-ref e-9 1))) (let ((e-12 (vector-ref e-9 2))) (let ((sc5 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (CoreC-45NameC-45Namespace-builtinNS) e-13))) (cond ((equal? sc5 1) (let ((sc6 (CoreC-45Name-nameRoot e-12))) (cond ((equal? sc6 "Unit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-8))) ((equal? sc6 "MkUnit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-8)))(else '())))) (else (let ((sc6 (CoreC-45Name-nameRoot e-12))) (cond ((equal? sc6 "Nil") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 38 e-8 e-8 '()))) ((equal? sc6 "Lin") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 39 e-8 e-8 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (case (vector-ref e-9 0) ((0) (let ((e-14 (vector-ref e-9 2))) (let ((e-17 (vector-ref e-14 2))) (case (vector-ref e-17 0) ((0) (let ((e-19 (vector-ref e-17 2))) (let ((sc6 (CoreC-45Name-nameRoot e-19))) (cond ((equal? sc6 "rangeFrom") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 47 e-4 (IdrisC-45Resugar-unbracket e-8) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc2))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 (PreludeC-45Cast-u--cast_Cast_Nat_Integer e-4))))))))))))(else (let ((sc1 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc1) (case (vector-ref arg-0 0) ((0) (let ((e-5 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-9 (vector-ref e-4 2))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 1))) (let ((e-11 (vector-ref e-9 2))) (let ((sc4 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (CoreC-45NameC-45Namespace-builtinNS) e-10))) (cond ((equal? sc4 1) (let ((sc5 (CoreC-45Name-nameRoot e-11))) (cond ((equal? sc5 "Unit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-5))) ((equal? sc5 "MkUnit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-5)))(else '())))) (else (let ((sc5 (CoreC-45Name-nameRoot e-11))) (cond ((equal? sc5 "Nil") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 38 e-5 e-5 '()))) ((equal? sc5 "Lin") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 39 e-5 e-5 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (let ((e-6 (vector-ref arg-0 3))) (case (vector-ref e-5 0) ((0) (let ((e-14 (vector-ref e-5 2))) (let ((e-17 (vector-ref e-14 2))) (case (vector-ref e-17 0) ((0) (let ((e-19 (vector-ref e-17 2))) (let ((sc5 (CoreC-45Name-nameRoot e-19))) (cond ((equal? sc5 "rangeFrom") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 47 e-4 (IdrisC-45Resugar-unbracket e-6) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 (PreludeC-45Cast-u--cast_Cast_Nat_Integer e-4)))))))))))))(else (let ((sc0 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-9 (vector-ref e-2 2))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 1))) (let ((e-11 (vector-ref e-9 2))) (let ((sc3 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (CoreC-45NameC-45Namespace-builtinNS) e-10))) (cond ((equal? sc3 1) (let ((sc4 (CoreC-45Name-nameRoot e-11))) (cond ((equal? sc4 "Unit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-1))) ((equal? sc4 "MkUnit") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 42 e-1)))(else '())))) (else (let ((sc4 (CoreC-45Name-nameRoot e-11))) (cond ((equal? sc4 "Nil") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 38 e-1 e-1 '()))) ((equal? sc4 "Lin") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 39 e-1 e-1 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (let ((e-6 (vector-ref arg-0 3))) (case (vector-ref e-5 0) ((0) (let ((e-14 (vector-ref e-5 2))) (let ((e-17 (vector-ref e-14 2))) (case (vector-ref e-17 0) ((0) (let ((e-19 (vector-ref e-17 2))) (let ((sc4 (CoreC-45Name-nameRoot e-19))) (cond ((equal? sc4 "rangeFrom") (PreludeC-45Types-u--pure_Applicative_Maybe (vector 47 e-4 (IdrisC-45Resugar-unbracket e-6) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-1 (unbox sc0))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 (PreludeC-45Cast-u--cast_Cast_Nat_Integer e-1)))))))))))
(define IdrisC-45Resugar-sugarApp (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () arg-0) (IdrisC-45Resugar-sugarAppM arg-0))))
(define IdrisC-45Resugar-startPrec(blodwen-lazy (lambda () 0)))
(define IdrisC-45Resugar-showImplicits (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-0 (vector-ref e-5 0))) e-0))))))))
(define IdrisC-45Resugar-showFullEnv (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-1 (vector-ref e-5 1))) e-1))))))))
(define IdrisC-45Resugar-resugarNoPatvars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (TTImpC-45Unelab-unelabNoPatvars arg-0 arg-1 arg-3 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Resugar-toCleanPTerm arg-1 arg-2 (IdrisC-45Resugar-startPrec) e-5 ext-0)))))))
(define IdrisC-45Resugar-resugar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((TTImpC-45Unelab-unelab arg-0 arg-1 arg-3 arg-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Resugar-toCleanPTerm arg-1 arg-2 (IdrisC-45Resugar-startPrec) e-5 ext-0)))))))
(define IdrisC-45Resugar-pterm (lambda (arg-0 arg-1 arg-2 ext-0) (IdrisC-45Resugar-toCleanPTerm arg-0 arg-1 (IdrisC-45Resugar-startPrec) arg-2 ext-0)))
(define IdrisC-45Resugar-mkOp (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((7) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (lambda (clam-0) (case (vector-ref e-2 0) ((7) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((0) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-24 1))) (let ((u--n (let ((e-4 (vector-ref e-10 2))) e-4))) (let ((u--tm (vector 7 e-1 (vector 7 e-5 (vector 0 e-9 e-10) e-7) e-3))) (let ((sc4 (LibrariesC-45DataC-45StringMap-lookup (CoreC-45Name-nameRoot u--n) (let ((e-0 (vector-ref e-8 0))) e-0)))) (if (null? sc4) (vector 1 u--tm) (vector 1 (vector 27 e-1 e-9 e-10 (IdrisC-45Resugar-unbracketApp e-7) (IdrisC-45Resugar-unbracketApp e-3))))))))))))))(else (vector 1 arg-1)))))))(else (vector 1 arg-1))))))))(else (lambda (eta-0) (vector 1 arg-1))))))
(define IdrisC-45Resugar-mkApp (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-10) (let ((u--ap (IdrisC-45Resugar-sugarApp (vector 7 e-6 arg-2 e-11)))) (IdrisC-45Resugar-mkApp arg-0 arg-1 u--ap e-3)) (let ((e-14 (unbox e-10))) (if (null? e-14) (let ((u--ap (IdrisC-45Resugar-sugarApp (vector 10 e-6 arg-2 e-11)))) (IdrisC-45Resugar-mkApp arg-0 arg-1 u--ap e-3)) (let ((e-17 (unbox e-14))) (lambda (eta-0) (let ((act-24 (IdrisC-45Resugar-showImplicits arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((u--ap (vector 9 e-6 arg-2 e-17 e-11))) ((IdrisC-45Resugar-mkApp arg-0 arg-1 u--ap e-3) eta-0))) (else ((IdrisC-45Resugar-mkApp arg-0 arg-1 arg-2 e-3) eta-0)))))))))))))))))))))
(define IdrisC-45Resugar-fullNamespace (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2))))))))
(define IdrisC-45Resugar-extractNat (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-15 (vector-ref e-2 2))) (case (vector-ref e-15 0) ((0) (let ((e-16 (vector-ref e-15 1))) (let ((e-17 (vector-ref e-15 2))) (case (vector-ref e-17 0) ((1) (let ((e-18 (vector-ref e-17 1))) (case (vector-ref e-18 0) ((0) (let ((e-19 (vector-ref e-18 1))) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-19 "Z")) (lambda () (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (let ((sc4 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-16 (CoreC-45NameC-45Namespace-typesNS)))) (cond ((equal? sc4 1) 1) (else (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-16 (CoreC-45NameC-45Namespace-preludeNS)))))) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe arg-0)))))))(else '()))))(else '())))))(else '()))))) ((7) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (case (vector-ref e-5 0) ((0) (let ((e-22 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-22 2))) (case (vector-ref e-25 0) ((0) (let ((e-26 (vector-ref e-25 1))) (let ((e-27 (vector-ref e-25 2))) (case (vector-ref e-27 0) ((1) (let ((e-28 (vector-ref e-27 1))) (case (vector-ref e-28 0) ((0) (let ((e-29 (vector-ref e-28 1))) (cond ((equal? e-29 "S") (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-26 (CoreC-45NameC-45Namespace-typesNS)))) (cond ((equal? sc6 1) 1) (else (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-26 (CoreC-45NameC-45Namespace-preludeNS)))))) (lambda () (IdrisC-45Resugar-extractNat (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-0) e-6)))) ((equal? e-29 "fromInteger") (IdrisC-45Resugar-extractNat arg-0 e-6))(else '()))))(else '()))))(else '())))))(else '())))))(else '()))))) ((15) (let ((e-9 (vector-ref arg-1 2))) (case (vector-ref e-9 0) ((5) (let ((e-30 (vector-ref e-9 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (PreludeC-45Types-u--C-43_Num_Nat arg-0 (PreludeC-45Types-prim__integerToNat e-30)))))(else '())))) ((32) (let ((e-12 (vector-ref arg-1 2))) (IdrisC-45Resugar-extractNat arg-0 e-12)))(else '()))))
(define IdrisC-45Resugar-cleanPTerm (lambda (arg-0 arg-1 ext-0) (let ((act-24 (IdrisC-45Resugar-fullNamespace arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (vector 1 arg-1)) (else ((IdrisC-45Syntax-mapPTermM (lambda (eta-0) (IdrisC-45Resugar-n--12440-6514-u--cleanNode arg-1 arg-0 eta-0)) arg-1) ext-0)))))))))
(define IdrisC-45Resugar-bracket (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((IdrisC-45Resugar-mkOp arg-0 arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45Types-u--C-62_Ord_Nat arg-1 arg-2))) (cond ((equal? sc1 1) (vector 1 (IdrisC-45Resugar-addBracket (CoreC-45FC-emptyFC) e-5))) (else (vector 1 e-5))))))))))
(define IdrisC-45Resugar-argPrec(blodwen-lazy (lambda () (PreludeC-45Types-u--fromInteger_Num_Nat 1000))))
(define IdrisC-45Resugar-appPrec(blodwen-lazy (lambda () (PreludeC-45Types-u--fromInteger_Num_Nat 999))))
(define IdrisC-45Resugar-addBracket (lambda (arg-1 arg-2) (let ((sc0 (IdrisC-45Resugar-n--8734-3179-u--needed arg-2 arg-1 arg-2))) (cond ((equal? sc0 1) (vector 32 arg-1 arg-2)) (else arg-2)))))
(define TTImpC-45ElabC-45Rewrite-rewriteErr (lambda (arg-0) (case (vector-ref arg-0 0) ((41) 1) ((40) 1) ((62) (let ((e-11 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-11))) ((63) (let ((e-14 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-14))) ((64) (let ((e-17 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-17))) ((65) (let ((e-20 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-20))) ((5) (let ((e-27 (vector-ref arg-0 7))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-27)))(else 0))))
(define TTImpC-45ElabC-45Rewrite-getRewriteTerms (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-5 (vector-ref arg-4 5))) (let ((act-24 (CoreC-45Context-isEqualTy arg-1 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (cond ((equal? e-6 1) (let ((sc3 (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 ext-0) (let ((e-8 (car sc3))) (let ((e-7 (cdr sc3))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 ext-0) (let ((e-10 (car e-7))) (let ((e-9 (cdr e-7))) (if (null? e-9) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 ext-0) (let ((e-11 (cdr e-9))) (if (null? e-11) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 ext-0) (let ((e-14 (car e-11))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-3 e-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-3 e-8) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-3 e-14) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (vector 1 (cons e-15 (cons e-16 e-17))))))))))))))))))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 ext-0))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 ext-0)))))
(define TTImpC-45ElabC-45Rewrite-findRewriteLemma (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-getRewrite arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 "No rewrite lemma defined") ext-0) (let ((e-2 (unbox e-5))) (vector 1 e-2)))))))))
(define TTImpC-45ElabC-45Rewrite-elabRewrite (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-genVarName arg-1 arg-2 "rwarg" ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-4 arg-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Rewrite-getRewriteTerms arg-0 arg-1 arg-3 e-5 e-7 (vector 41 arg-0 arg-3 arg-4 arg-6) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((e-9 (cdr e-3))) (let ((act-28 (TTImpC-45ElabC-45Rewrite-findRewriteLemma arg-1 arg-3 arg-6 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-28 1))) (let ((act-29 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-4 arg-5) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.rewrite" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Rewriting") arg-4 e-2 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.rewrite" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Rewriting in") arg-4 e-12 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (CoreC-45Normalise-replace arg-1 arg-0 e-5 arg-4 e-2 (vector 1 arg-3 (vector 0 ) e-6) e-12 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-32 1))) (let ((act-33 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.rewrite" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Rewritten to") e-15 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((act-34 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-34 1))) (let ((act-35 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-17 arg-4 e-9 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-35 1))) (let ((u--pred (vector 3 arg-3 e-6 (vector 0 arg-3 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) e-18) (CoreC-45TT-refsToLocals (vector 1 e-6 e-6 (vector 0 )) e-15)))) (let ((act-36 ((CoreC-45GetType-getType arg-0 arg-1 arg-4 u--pred) ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-36 1))) (let ((act-37 ((CoreC-45NormaliseC-45Eval-getTerm e-19) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-37 1))) (let ((act-38 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Term arg-1 arg-0 e-5 arg-4 arg-5 ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-38 1))) (let ((act-39 (let ((act-39 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-1 arg-0 e-5 arg-4 e-15 e-21 ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-39 1))) (cond ((equal? e-22 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 40 arg-0 arg-3 arg-4 arg-6 e-21) ext-0)) (else (vector 1 0))))))))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (vector 1 (cons e-11 (cons u--pred e-20)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Rewrite-checkRewrite (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (if (null? arg-13) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 "Can't infer a type for rewrite") ext-0) (let ((e-2 (unbox arg-13))) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 arg-6 arg-9 (box e-2) (lambda (eta-0) (TTImpC-45ElabC-45Rewrite-rewriteErr eta-0)) 3 (lambda (u--delayed) (let ((u--vfc (CoreC-45FC-virtualiseFC arg-10))) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (csegen-21) arg-7 arg-8 arg-9 arg-11 '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-4 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-2) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (cond ((equal? u--delayed 1) (CoreC-45ContextC-45Log-log arg-1 "elab.rewrite" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Retrying rewrite") eta-0)) (else (vector 1 0))))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((act-28 (TTImpC-45ElabC-45Rewrite-elabRewrite arg-0 arg-1 arg-3 u--vfc arg-9 e-7 e-6 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-11 (car e-9))) (let ((e-10 (cdr e-9))) (let ((e-13 (car e-10))) (let ((e-12 (cdr e-10))) (let ((act-29 (CoreC-45UnifyState-genVarName arg-1 arg-3 "_" eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 (CoreC-45UnifyState-genVarName arg-1 arg-3 "_" eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-15 (vector-ref act-30 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-30 1))) (let ((u--pbind (vector 1 u--vfc (csegen-21) e-13 e-12))) (let ((u--rbind (vector 1 u--vfc (csegen-21) (CoreC-45TT-u--weaken_Weaken_Term e-4) (CoreC-45TT-u--weaken_Weaken_Term e-6)))) (let ((u--envC-39 (cons u--rbind (cons u--pbind arg-9)))) (let ((act-31 (TTImpC-45ElabC-45Check-inScope e-15 arg-0 arg-1 arg-4 u--vfc (cons u--pbind arg-9) (lambda (u--eC-39) (lambda (eta-1) (TTImpC-45ElabC-45Check-inScope e-14 (cons e-15 arg-0) arg-1 u--eC-39 u--vfc u--envC-39 (lambda (u--eC-39C-39) (let ((u--offset (CoreC-45TTC-45SizeOf-mkSizeOf (cons e-14 (cons e-15 '()))))) (TTImpC-45ElabC-45Check-check (cons e-14 (cons e-15 arg-0)) arg-1 arg-2 arg-3 u--eC-39C-39 arg-5 arg-6 arg-7 (TTImpC-45TTImp-u--weakenNs_Weaken_NestedNames u--offset arg-8) u--envC-39 (TTImpC-45TTImp-apply (vector 0 u--vfc e-11) (cons (vector 0 u--vfc e-15) (cons (vector 0 u--vfc e-14) (cons arg-12 '())))) (box (CoreC-45NormaliseC-45Eval-gnf (cons e-14 (cons e-15 arg-0)) u--envC-39 (CoreC-45TT-u--weakenNs_Weaken_Term u--offset e-7)))))) eta-1))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-16 (vector-ref act-31 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-31 1))) (let ((e-18 (car e-16))) (let ((e-17 (cdr e-16))) (let ((act-32 ((CoreC-45NormaliseC-45Eval-getTerm e-17) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-19 (vector-ref act-32 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-32 1))) (let ((u--binding (lambda (eta-1) (vector 3 u--vfc e-15 u--pbind (vector 3 u--vfc e-14 u--rbind eta-1))))) (vector 1 (cons (u--binding e-18) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (u--binding e-19)))))))))))))))))))))))))))))))))))))))))))))))))))))) ext-0)))))
(define TTImpC-45ElabC-45Record-n--11119-18302-u--vloc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (CoreC-45FC-virtualiseFC arg-6)))
(define TTImpC-45ElabC-45Record-n--11119-18303-u--mkClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 0 (TTImpC-45ElabC-45Record-n--11119-18302-u--vloc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (TTImpC-45ElabC-45Record-toLHS (TTImpC-45ElabC-45Record-n--11119-18302-u--vloc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) arg-12) (TTImpC-45ElabC-45Record-toRHS (TTImpC-45ElabC-45Record-n--11119-18302-u--vloc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) arg-12))))
(define TTImpC-45ElabC-45Record-n--10478-17761-u--mkArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((act-24 (TTImpC-45ElabC-45Record-genFieldName arg-9 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Record-n--10478-17761-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((u--arg (PreludeC-45Types-maybe (lambda () (vector 0 (CoreC-45FC-virtualiseFC arg-8) (vector 1 (vector 0 e-5)))) (lambda () (lambda (eta-0) (vector 32 arg-8 0))) e-10))) (vector 1 (cons (cons e-6 (vector 0 e-10 e-5 u--arg)) e-8))))))))))))))))))))
(define TTImpC-45ElabC-45Record-n--10179-17447-u--getExpNames (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (let ((act-24 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Record-n--10179-17447-u--getExpNames arg-0 arg-1 arg-2 e-5) clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--imp (case (vector-ref e-8 0) ((1) '())(else (box e-2))))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 e-9) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (cons (cons (CoreC-45Name-nameRoot e-2) (cons u--imp (TTImpC-45ElabC-45Record-getRecordType '() e-10))) e-5))))))))))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45ElabC-45Record-toRHSC-39 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 3))) (cons e-0 e-2)))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((u--argsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Record-toRHSC-39 arg-0 (Builtin-snd eta-0))) e-5))) (cons e-3 (TTImpC-45TTImp-gapply (vector 0 arg-0 e-4) u--argsC-39))))))))))
(define TTImpC-45ElabC-45Record-toRHS (lambda (arg-0 arg-1) (Builtin-snd (TTImpC-45ElabC-45Record-toRHSC-39 arg-0 arg-1))))
(define TTImpC-45ElabC-45Record-toLHSC-39 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (if (null? e-0) (cons e-0 (vector 17 (CoreC-45FC-virtualiseFC arg-0) e-1)) (cons e-0 (vector 18 arg-0 (CoreC-45FC-virtualiseFC arg-0) 1 (vector 1 (vector 0 e-1)) (vector 32 arg-0 1))))))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((u--argsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Record-toLHSC-39 arg-0 (Builtin-snd eta-0))) e-5))) (cons e-3 (TTImpC-45TTImp-gapply (vector 0 arg-0 e-4) u--argsC-39))))))))))
(define TTImpC-45ElabC-45Record-toLHS (lambda (arg-0 arg-1) (Builtin-snd (TTImpC-45ElabC-45Record-toLHSC-39 arg-0 arg-1))))
(define TTImpC-45ElabC-45Record-replace (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-0 e-6))) (cond ((equal? sc2 1) (cons (cons arg-0 arg-1) e-3)) (else (cons (cons e-6 e-7) (TTImpC-45ElabC-45Record-replace arg-0 arg-1 e-3))))))))))))
(define TTImpC-45ElabC-45Record-recUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 arg-11) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (TTImpC-45ElabC-45Record-getRecordType arg-8 e-6))) (if (null? sc2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 22 arg-0 arg-6 arg-8) ext-0) (let ((e-1 (unbox sc2))) (let ((act-26 (TTImpC-45ElabC-45Record-genFieldName arg-2 "__fld" ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Record-getAllSides arg-1 arg-2 arg-6 arg-9 e-1 arg-10 (vector 0 '() e-7 (vector 0 (TTImpC-45ElabC-45Record-n--11119-18302-u--vloc arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (vector 1 (vector 0 e-7)))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 4 (TTImpC-45ElabC-45Record-n--11119-18302-u--vloc arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) arg-10 (vector 32 (TTImpC-45ElabC-45Record-n--11119-18302-u--vloc arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) 0) (cons (TTImpC-45ElabC-45Record-n--11119-18303-u--mkClause arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-8) '())))))))))))))))))))))))
(define TTImpC-45ElabC-45Record-needType (lambda (arg-0) (case (vector-ref arg-0 0) ((22) 1) ((62) (let ((e-5 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Record-needType e-5))) ((63) (let ((e-8 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Record-needType e-8))) ((64) (let ((e-11 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Record-needType e-11))) ((65) (let ((e-14 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Record-needType e-14))) ((5) (let ((e-21 (vector-ref arg-0 7))) (TTImpC-45ElabC-45Record-needType e-21)))(else 0))))
(define TTImpC-45ElabC-45Record-getSides (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 e-1 e-1 (box arg-4) (lambda (eta-0) e-2) arg-6)))) (else (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 e-4 e-4 (box arg-4) (lambda (u--n) (TTImpC-45TTImp-apply e-5 (cons (vector 0 (CoreC-45FC-virtualiseFC arg-2) (vector 1 (vector 0 u--n))) '()))) arg-6)))))))
(define TTImpC-45ElabC-45Record-getRecordType (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-2 (vector-ref arg-2 2))) (box e-2)))(else '()))))
(define TTImpC-45ElabC-45Record-getAllSides (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-3) (vector 1 arg-6) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((TTImpC-45ElabC-45Record-getSides arg-0 arg-1 arg-2 e-2 arg-4 arg-5 arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45ElabC-45Record-getAllSides arg-0 arg-1 arg-2 e-3 arg-4 arg-5 e-5 ext-0))))))))))
(define TTImpC-45ElabC-45Record-genFieldName (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45Show-u--show_Show_Int (let ((e-8 (vector-ref e-5 8))) e-8)))))))))))))
(define TTImpC-45ElabC-45Record-findPath (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-3) (lambda (clam-0) (case (vector-ref arg-7 0) ((0) (let ((e-4 (vector-ref arg-7 1))) (let ((e-5 (vector-ref arg-7 2))) (vector 1 (vector 0 e-4 e-5 (arg-6 e-5))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 25 arg-2 arg-4) clam-0)))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? arg-5) (case (vector-ref arg-7 0) ((0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 23 arg-2 e-2 '()) eta-0)))(else (lambda (clam-0) (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (let ((sc3 (DataC-45List-lookup (csegen-17) e-2 e-9))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 23 arg-2 e-2 arg-5) clam-0) (let ((e-1 (unbox sc3))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Record-findFields arg-0 e-5 e-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 1 e-7 e-8 e-9)) (let ((e-4 (unbox e-6))) (let ((sc7 (DataC-45List-lookup (csegen-17) e-2 e-4))) (if (null? sc7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 23 arg-2 e-2 arg-5) clam-0) (let ((e-10 (unbox sc7))) (let ((e-11 (cdr e-10))) (let ((act-26 ((TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 e-3 arg-4 e-11 arg-6 e-1) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) (vector 1 (vector 1 e-7 e-8 (TTImpC-45ElabC-45Record-replace e-2 e-13 e-9)))))))))))))))))))))))))))))) (let ((e-12 (unbox arg-5))) (case (vector-ref arg-7 0) ((0) (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Record-findConName e-5 e-12 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 24 arg-2 e-12) eta-0) (let ((e-1 (unbox e-6))) (let ((act-26 (TTImpC-45ElabC-45Record-findFields arg-0 e-5 e-1 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 24 arg-2 e-12) eta-0) (let ((e-4 (unbox e-7))) (let ((act-27 ((TTImpC-45ElabC-45Record-n--10478-17761-u--mkArgs e-2 e-3 e-12 e-18 e-17 e-16 arg-6 arg-4 arg-2 arg-1 arg-0 e-4) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--recC-39 (vector 1 e-16 e-1 e-8))) ((TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 (cons e-2 e-3) arg-4 (box e-12) arg-6 u--recC-39) eta-0)))))))))))))))))))))))))))(else (lambda (clam-1) (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (let ((sc3 (DataC-45List-lookup (csegen-17) e-2 e-9))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 23 arg-2 e-2 arg-5) clam-1) (let ((e-1 (unbox sc3))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Record-findFields arg-0 e-5 e-8 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 1 e-7 e-8 e-9)) (let ((e-4 (unbox e-6))) (let ((sc7 (DataC-45List-lookup (csegen-17) e-2 e-4))) (if (null? sc7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 23 arg-2 e-2 arg-5) clam-1) (let ((e-10 (unbox sc7))) (let ((e-11 (cdr e-10))) (let ((act-26 ((TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 e-3 arg-4 e-11 arg-6 e-1) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-14 (vector-ref act-26 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-26 1))) (vector 1 (vector 1 e-7 e-8 (TTImpC-45ElabC-45Record-replace e-2 e-14 e-9)))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Record-findFields (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-lookupTyExact arg-2 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() arg-1 '() e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ElabC-45Record-n--10179-17447-u--getExpNames arg-2 arg-1 arg-0 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (box e-7))))))))))))))))))
(define TTImpC-45ElabC-45Record-findConName (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-lookupDefExact arg-1 (let ((e-0 (vector-ref arg-0 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((6) (let ((e-8 (vector-ref e-1 7))) (if (null? e-8) (vector 1 '()) (let ((e-11 (car e-8))) (let ((e-12 (cdr e-8))) (if (null? e-12) (vector 1 (box e-11)) (vector 1 '())))))))(else (vector 1 '())))))))))))
(define TTImpC-45ElabC-45Record-checkUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-24 (if (null? arg-13) (let ((act-24 (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-3 (cdr e-5))) (vector 1 e-3)))))) (let ((e-1 (unbox arg-13))) (vector 1 e-1))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--solvemode (let ((e-0 (vector-ref arg-7 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))))) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 arg-6 arg-9 (box e-5) (lambda (eta-0) (TTImpC-45ElabC-45Record-needType eta-0)) 2 (lambda (u--delayed) (lambda (eta-0) (let ((act-25 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--rectyC-39 (cond ((equal? u--delayed 1) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-7)) (else e-5)))) (let ((act-27 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.record" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Bool u--delayed) (PreludeC-45TypesC-45String-C-43C-43 " record type " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-12)))) arg-9 u--rectyC-39 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (TTImpC-45ElabC-45Record-recUpdate arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-10 arg-8 arg-9 arg-11 arg-12 u--rectyC-39 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-1 "elab.record" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Record update: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-9))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-9 arg-13) eta-0))))))))))))))))))))) ext-0))))))))
(define TTImpC-45ElabC-45Quote-n--10140-17928-u--unqTuple (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-5 arg-4 arg-3 e-11 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-2 (cons e-6 (cons e-10 e-5)))))))))))))))))
(define TTImpC-45ElabC-45Quote-n--10122-17783-u--unqPair (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-7 arg-6 arg-5 e-11 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-2 (cons e-6 (cons e-10 e-5)))))))))))))))))
(define TTImpC-45ElabC-45Quote-onLHS (lambda (arg-0) (case (vector-ref arg-0 0) ((1) 1)(else 0))))
(define TTImpC-45ElabC-45Quote-getUnquoteUpdate (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-5))))))))) (else (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector 1 e-4 e-6))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteTy (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector e-1 e-2 e-3 e-5))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteRecord (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45ElabC-45Quote-n--10122-17783-u--unqPair e-5 e-4 e-3 e-2 e-1 arg-2 arg-1 arg-0 eta-0)) e-3 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteField arg-0 arg-1 arg-2 eta-0 eta-1))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector e-1 e-2 e-6 e-4 e-7)))))))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteField (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteDecl (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquoteTy arg-0 arg-1 arg-2 e-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-2 e-3 e-4 e-6)))))))))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquoteData arg-0 arg-1 arg-2 e-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-7 e-8 e-5)))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteClause arg-0 arg-1 arg-2 eta-0 eta-1))) e-13 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-11 e-12 e-5)))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45ElabC-45Quote-n--10140-17928-u--unqTuple e-17 e-16 e-15 arg-2 arg-1 arg-0 eta-0)) e-16 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteDecl arg-0 arg-1 arg-2 eta-0 eta-1))) e-17 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-15 e-5 e-6)))))))))))))) ((4) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquoteRecord arg-0 arg-1 arg-2 e-22 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 4 e-19 e-20 e-21 e-5))))))))))) ((5) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteDecl arg-0 arg-1 arg-2 eta-0 eta-1))) e-26 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-24 e-25 e-5)))))))))) ((6) (let ((e-28 (vector-ref arg-3 1))) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (let ((e-31 (vector-ref arg-3 4))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-30 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-31 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 6 e-28 e-29 e-5 e-6)))))))))))))))(else (vector 1 arg-3)))))
(define TTImpC-45ElabC-45Quote-getUnquoteData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteTy arg-0 arg-1 arg-2 eta-0 eta-1))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-6 e-4 e-7)))))))))))))))) (else (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 1 e-7 e-8 e-5)))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteClause (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-5 e-6)))))))))))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (let ((e-9 (vector-ref arg-3 5))) (let ((e-10 (vector-ref arg-3 6))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-7 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteClause arg-0 arg-1 arg-2 eta-0 eta-1))) e-10 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (vector 1 (vector 1 e-5 e-11 e-12 e-8 e-9 e-13))))))))))))))))))))) (else (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-12 e-5))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquote (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 1 e-1 e-2 e-3 e-4 e-7 e-8))))))))))))))))) ((2) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-12 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-13 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-8 e-9 e-10 e-11 e-5 e-6))))))))))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-21 (vector-ref arg-3 7))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-19 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-20 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-21 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 3 e-15 e-16 e-17 e-18 e-5 e-6 e-7)))))))))))))))))))))) ((4) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-24 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-25 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteClause arg-0 arg-1 arg-2 eta-0 eta-1))) e-26 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 e-23 e-5 e-6 e-7))))))))))))))))))) ((5) (let ((e-28 (vector-ref arg-3 1))) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteDecl arg-0 arg-1 arg-2 eta-0 eta-1))) e-29 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-30 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-28 e-5 e-6)))))))))))))) ((7) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteUpdate arg-0 arg-1 arg-2 eta-0 eta-1))) e-33 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-34 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 7 e-32 e-5 e-6)))))))))))))) ((8) (let ((e-36 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (let ((e-38 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-37 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-38 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 e-36 e-5 e-6)))))))))))))) ((9) (let ((e-40 (vector-ref arg-3 1))) (let ((e-41 (vector-ref arg-3 2))) (let ((e-42 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-41 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-42 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-40 e-5 e-6)))))))))))))) ((10) (let ((e-44 (vector-ref arg-3 1))) (let ((e-45 (vector-ref arg-3 2))) (let ((e-46 (vector-ref arg-3 3))) (let ((e-47 (vector-ref arg-3 4))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-45 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-47 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 10 e-44 e-5 e-46 e-6))))))))))))))) ((11) (let ((e-49 (vector-ref arg-3 1))) (let ((e-50 (vector-ref arg-3 2))) (let ((e-51 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-50 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-51 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 11 e-49 e-5 e-6)))))))))))))) ((13) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (let ((e-55 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 eta-0 eta-1))) e-55 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 13 e-53 e-54 e-5)))))))))) ((14) (let ((e-57 (vector-ref arg-3 1))) (let ((e-58 (vector-ref arg-3 2))) (let ((e-59 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-58 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-59 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 14 e-57 e-5 e-6)))))))))))))) ((15) (let ((e-61 (vector-ref arg-3 1))) (let ((e-62 (vector-ref arg-3 2))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-62 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 15 e-61 e-5))))))))) ((16) (let ((e-64 (vector-ref arg-3 1))) (let ((e-65 (vector-ref arg-3 2))) (let ((e-66 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-66 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 16 e-64 e-65 e-5)))))))))) ((18) (let ((e-68 (vector-ref arg-3 1))) (let ((e-69 (vector-ref arg-3 2))) (let ((e-70 (vector-ref arg-3 3))) (let ((e-71 (vector-ref arg-3 4))) (let ((e-72 (vector-ref arg-3 5))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-72 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 18 e-68 e-69 e-70 e-71 e-5)))))))))))) ((19) (let ((e-74 (vector-ref arg-3 1))) (let ((e-75 (vector-ref arg-3 2))) (let ((e-76 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-76 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 19 e-74 e-75 e-5)))))))))) ((20) (let ((e-78 (vector-ref arg-3 1))) (let ((e-79 (vector-ref arg-3 2))) (let ((e-80 (vector-ref arg-3 3))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-80 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 20 e-78 e-79 e-5)))))))))) ((21) (let ((e-82 (vector-ref arg-3 1))) (let ((e-83 (vector-ref arg-3 2))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-83 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 21 e-82 e-5))))))))) ((22) (let ((e-85 (vector-ref arg-3 1))) (let ((e-86 (vector-ref arg-3 2))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-86 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 22 e-85 e-5))))))))) ((23) (let ((e-88 (vector-ref arg-3 1))) (let ((e-89 (vector-ref arg-3 2))) (let ((act-24 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-89 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 23 e-88 e-5))))))))) ((26) (let ((e-91 (vector-ref arg-3 1))) (let ((e-92 (vector-ref arg-3 2))) (let ((act-24 (CoreC-45UnifyState-genVarName arg-0 arg-2 "q" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-1 (cons (cons e-5 (cons e-91 e-92)) e-6)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (vector 26 e-91 (vector 0 e-91 e-5)))))))))))))))))(else (vector 1 arg-3)))))
(define TTImpC-45ElabC-45Quote-checkQuoteName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-9 e-5 (TTImpC-45ElabC-45Quote-onLHS (let ((e-0 (vector-ref arg-6 0))) e-0)) arg-8 arg-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Reflect-getCon arg-0 arg-9 e-5 (CoreC-45Reflect-reflectiontt "Name") ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-6 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-8 e-7) arg-11 ext-0)))))))))))))))
(define TTImpC-45ElabC-45Quote-checkQuoteDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "TTImp.Elab.Quote.Unq" ) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteDecl arg-1 e-6 arg-3 eta-0 eta-1))) arg-11 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (TTImpC-45Reflect-u--reflect_Reflect_ImpDecl eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))) arg-0 arg-10 e-5 (TTImpC-45ElabC-45Quote-onLHS (let ((e-0 (vector-ref arg-7 0))) e-0)) arg-9 e-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (unbox e-6))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Reflect-getCon arg-0 arg-10 e-5 (CoreC-45Reflect-reflectionttimp "Decl") ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Reflect-appCon arg-0 arg-10 e-5 (CoreC-45Reflect-basics "List") (cons e-10 '()) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 ((TTImpC-45ElabC-45Quote-bindUnqs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 arg-6 arg-7 arg-8 arg-9 e-8) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 e-12 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-11) arg-12 ext-0)))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Quote-checkQuote (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "TTImp.Elab.Quote.Unq" ) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Quote-getUnquote arg-1 e-6 arg-3 arg-11 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-10 e-5 (TTImpC-45ElabC-45Quote-onLHS (let ((e-0 (vector-ref arg-7 0))) e-0)) arg-9 e-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (unbox e-6))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Reflect-getCon arg-0 arg-10 e-5 (CoreC-45Reflect-reflectionttimp "TTImp") ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((TTImpC-45ElabC-45Quote-bindUnqs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 arg-6 arg-7 arg-8 arg-9 e-8) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Normalise-normalise arg-1 arg-0 e-5 arg-9 e-11 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 e-12 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-10) arg-12 ext-0)))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Quote-bindUnqs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-6) (lambda (eta-0) (vector 1 arg-11)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExactI (CoreC-45Reflect-reflectionttimp "TTImp") (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 e-10 (CoreC-45Reflect-reflectionttimp "TTImp")) clam-0) (let ((e-1 (unbox e-8))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 e-10 (CoreC-45Reflect-reflectionttimp "TTImp")) clam-0) (let ((e-4 (car e-1))) (let ((act-26 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10 e-11 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 1 e-10 (vector 3 0 0) (vector 8 e-4))))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (let ((act-27 ((TTImpC-45ElabC-45Quote-bindUnqs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 arg-7 arg-8 arg-9 arg-10 arg-11) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-15 (vector-ref act-27 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm e-13) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-16 (vector-ref act-28 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-28 1))) (vector 1 (vector 3 e-10 e-6 (vector 1 e-10 (AlgebraC-45ZeroOneOmega-rigMult (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) arg-7) e-14 e-16) (CoreC-45TT-refToLocal e-6 e-6 e-15)))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Prim-checkPrim (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 0 e-0)) (vector 9 arg-1 (vector 14 ))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 1 e-1)) (vector 9 arg-1 (vector 15 ))))) ((2) (let ((e-2 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 2 e-2)) (vector 9 arg-1 (vector 16 ))))) ((3) (let ((e-3 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 3 e-3)) (vector 9 arg-1 (vector 17 ))))) ((4) (let ((e-4 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 4 e-4)) (vector 9 arg-1 (vector 18 ))))) ((5) (let ((e-5 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 5 e-5)) (vector 9 arg-1 (vector 19 ))))) ((6) (let ((e-6 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 6 e-6)) (vector 9 arg-1 (vector 20 ))))) ((7) (let ((e-7 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 7 e-7)) (vector 9 arg-1 (vector 21 ))))) ((8) (let ((e-8 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 8 e-8)) (vector 9 arg-1 (vector 22 ))))) ((9) (let ((e-9 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 9 e-9)) (vector 9 arg-1 (vector 23 ))))) ((10) (let ((e-10 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 10 e-10)) (vector 9 arg-1 (vector 24 ))))) ((11) (let ((e-11 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 11 e-11)) (vector 9 arg-1 (vector 25 ))))) ((12) (let ((e-12 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 12 e-12)) (vector 9 arg-1 (vector 26 ))))) ((13) (cons (vector 9 arg-1 (vector 13 )) (vector 9 arg-1 (vector 27 )))) ((14) (cons (vector 9 arg-1 (vector 14 )) (vector 11 arg-1))) ((15) (cons (vector 9 arg-1 (vector 15 )) (vector 11 arg-1))) ((16) (cons (vector 9 arg-1 (vector 16 )) (vector 11 arg-1))) ((17) (cons (vector 9 arg-1 (vector 17 )) (vector 11 arg-1))) ((18) (cons (vector 9 arg-1 (vector 18 )) (vector 11 arg-1))) ((19) (cons (vector 9 arg-1 (vector 19 )) (vector 11 arg-1))) ((20) (cons (vector 9 arg-1 (vector 20 )) (vector 11 arg-1))) ((21) (cons (vector 9 arg-1 (vector 21 )) (vector 11 arg-1))) ((22) (cons (vector 9 arg-1 (vector 22 )) (vector 11 arg-1))) ((23) (cons (vector 9 arg-1 (vector 23 )) (vector 11 arg-1))) ((24) (cons (vector 9 arg-1 (vector 24 )) (vector 11 arg-1))) ((25) (cons (vector 9 arg-1 (vector 25 )) (vector 11 arg-1))) ((26) (cons (vector 9 arg-1 (vector 26 )) (vector 11 arg-1))) (else (cons (vector 9 arg-1 (vector 27 )) (vector 11 arg-1))))))
(define TTImpC-45ElabC-45Local-case--getLocalTerm-9337 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Case Local failed") clam-0) (let ((e-1 (unbox arg-7))) (let ((e-5 (car e-1))) (let ((act-24 ((TTImpC-45ElabC-45Local-getLocalTerm arg-0 arg-6 arg-5 arg-4 (vector 4 arg-5 arg-3 (vector 0 arg-5 '() e-5)) arg-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (vector 1 (cons e-2 (cons e-5 e-3)))))))))))))))
(define TTImpC-45ElabC-45Local-n--10177-8247-u--updateTyName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-1 (vector-ref arg-12 0))) (let ((e-2 (vector-ref arg-12 1))) (let ((e-3 (vector-ref arg-12 2))) (let ((e-4 (vector-ref arg-12 3))) (vector e-1 e-2 (TTImpC-45ElabC-45Local-n--10177-8246-u--newName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3) e-4)))))))
(define TTImpC-45ElabC-45Local-n--10177-8249-u--updateName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (let ((e-4 (vector-ref arg-12 4))) (let ((e-5 (vector-ref arg-12 5))) (vector 0 e-1 e-2 e-3 e-4 (TTImpC-45ElabC-45Local-n--10177-8247-u--updateTyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5)))))))) ((2) (let ((e-7 (vector-ref arg-12 1))) (let ((e-8 (vector-ref arg-12 2))) (let ((e-9 (vector-ref arg-12 3))) (vector 2 e-7 (TTImpC-45ElabC-45Local-n--10177-8246-u--newName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-8) e-9))))) ((1) (let ((e-11 (vector-ref arg-12 1))) (let ((e-12 (vector-ref arg-12 2))) (let ((e-13 (vector-ref arg-12 3))) (vector 1 e-11 e-12 (TTImpC-45ElabC-45Local-n--10177-8248-u--updateDataName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-13))))))(else arg-12))))
(define TTImpC-45ElabC-45Local-n--10177-8248-u--updateDataName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (let ((e-4 (vector-ref arg-12 4))) (let ((e-5 (vector-ref arg-12 5))) (vector 0 e-1 (TTImpC-45ElabC-45Local-n--10177-8246-u--newName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2) e-3 e-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10177-8247-u--updateTyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-0)) e-5)))))))) (else (let ((e-7 (vector-ref arg-12 1))) (let ((e-8 (vector-ref arg-12 2))) (let ((e-9 (vector-ref arg-12 3))) (vector 1 e-7 (TTImpC-45ElabC-45Local-n--10177-8246-u--newName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-8) e-9))))))))
(define TTImpC-45ElabC-45Local-n--10177-8250-u--setPublic (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-4 (vector-ref arg-11 4))) (let ((e-5 (vector-ref arg-11 5))) (vector 0 e-1 e-2 2 e-4 e-5)))))) ((1) (let ((e-7 (vector-ref arg-11 1))) (let ((e-9 (vector-ref arg-11 3))) (vector 1 e-7 2 e-9)))) ((4) (let ((e-11 (vector-ref arg-11 1))) (let ((e-12 (vector-ref arg-11 2))) (let ((e-14 (vector-ref arg-11 4))) (vector 4 e-11 e-12 2 e-14))))) ((3) (let ((e-16 (vector-ref arg-11 1))) (let ((e-17 (vector-ref arg-11 2))) (let ((e-18 (vector-ref arg-11 3))) (vector 3 e-16 e-17 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10177-8250-u--setPublic arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) e-18)))))) ((5) (let ((e-20 (vector-ref arg-11 1))) (let ((e-21 (vector-ref arg-11 2))) (let ((e-22 (vector-ref arg-11 3))) (vector 5 e-20 e-21 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10177-8250-u--setPublic arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) e-22))))))(else arg-11))))
(define TTImpC-45ElabC-45Local-n--10177-8251-u--setErased (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-1 (vector-ref arg-11 1))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (let ((e-5 (vector-ref arg-11 5))) (vector 0 e-1 (csegen-21) e-3 e-4 e-5)))))) ((3) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (let ((e-9 (vector-ref arg-11 3))) (vector 3 e-7 e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10177-8251-u--setErased arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) e-9)))))) ((5) (let ((e-11 (vector-ref arg-11 1))) (let ((e-12 (vector-ref arg-11 2))) (let ((e-13 (vector-ref arg-11 3))) (vector 5 e-11 e-12 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10177-8251-u--setErased arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) e-13))))))(else arg-11))))
(define TTImpC-45ElabC-45Local-n--10177-8246-u--newName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((sc0 (DataC-45List-lookup (csegen-802) arg-12 arg-11))) (if (null? sc0) arg-12 (let ((e-1 (unbox sc0))) (if (null? e-1) arg-12 (let ((e-4 (car e-1))) (if (null? e-4) arg-12 (let ((e-7 (unbox e-4))) e-7)))))))))
(define TTImpC-45ElabC-45Local-n--10177-8244-u--dropLinear (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12) (if (null? arg-12) '() (let ((e-4 (car arg-12))) (let ((e-5 (cdr arg-12))) (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) (CoreC-45TT-multiplicity e-4)))) (cond ((equal? sc1 1) (cons (CoreC-45TT-setMultiplicity e-4 (csegen-21)) (TTImpC-45ElabC-45Local-n--10177-8244-u--dropLinear arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))) (else (cons e-4 (TTImpC-45ElabC-45Local-n--10177-8244-u--dropLinear arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))))))))))
(define TTImpC-45ElabC-45Local-n--10177-8245-u--applyEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-24 (let ((act-24 (unbox arg-8))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-8 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--nestedName_in (vector 5 (cons arg-11 (let ((e-8 (vector-ref e-5 8))) e-8)) arg-12))) (let ((act-26 (CoreC-45Context-inCurrentNS arg-10 u--nestedName_in ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-addName arg-10 e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons arg-12 (cons (box e-7) (cons (PreludeC-45TypesC-45List-reverse (CoreC-45Env-allVars arg-1 arg-4)) (lambda (u--fc) (lambda (u--nt) (CoreC-45UnifyState-applyToFull arg-1 u--fc (vector 1 u--fc u--nt (vector 8 e-8)) arg-4)))))))))))))))))))))))))
(define TTImpC-45ElabC-45Local-localHelper (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--f (let ((e-2 (vector-ref e-5 1))) e-2))) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--vis (PreludeC-45Types-maybe (lambda () 2) (lambda () (lambda (eta-0) (let ((e-9 (vector-ref eta-0 9))) e-9))) e-7))) (let ((u--mult (PreludeC-45Types-maybe (lambda () (csegen-519)) (lambda () (lambda (eta-0) (let ((e-22 (vector-ref eta-0 7))) e-22))) e-7))) (let ((u--nestdeclsVis (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Visibility u--vis 2))) (cond ((equal? sc3 1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10177-8250-u--setPublic arg-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 eta-0)) arg-9)) (else arg-9))))) (let ((u--nestdeclsMult (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega u--mult (csegen-21)))) (cond ((equal? sc3 1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10177-8251-u--setErased arg-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 eta-0)) u--nestdeclsVis)) (else u--nestdeclsVis))))) (let ((u--defNames (TTImpC-45TTImp-definedInBlock (CoreC-45NameC-45Namespace-emptyNS) u--nestdeclsMult))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Local-n--10177-8245-u--applyEnv arg-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 u--f eta-0 eta-1))) (DataC-45List-nub (csegen-802) u--defNames) '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--nestC-39 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-7))) (let ((u--envC-39 (TTImpC-45ElabC-45Local-n--10177-8244-u--dropLinear arg-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-8))) (let ((act-28 (let ((act-28 (unbox arg-4))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--olddelayed (let ((e-10 (vector-ref e-9 10))) e-10))) (let ((act-29 (let ((act-29 (set-box! arg-4 (let ((e-0 (vector-ref e-9 0))) (let ((e-1 (vector-ref e-9 1))) (let ((e-2 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (let ((e-16 (vector-ref e-9 5))) (let ((e-15 (vector-ref e-9 6))) (let ((e-14 (vector-ref e-9 7))) (let ((e-13 (vector-ref e-9 8))) (let ((e-12 (vector-ref e-9 9))) (let ((e-11 (vector-ref e-9 11))) (vector e-0 e-1 e-2 e-3 e-4 e-16 e-15 e-14 e-13 e-12 '() e-11))))))))))))))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (let ((act-30 (unbox arg-2))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((u--oldhints (let ((e-32 (vector-ref e-11 10))) e-32))) (let ((u--nestdecls (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10177-8249-u--updateName arg-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 u--nestC-39 eta-0)) u--nestdeclsMult))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-2 "elab.def.local" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2095) u--nestdecls)) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl arg-1 arg-2 arg-3 arg-4 arg-6 '() u--nestC-39 u--envC-39 eta-0)) u--nestdecls ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (let ((act-33 (unbox arg-4))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (let ((act-34 (set-box! arg-4 (let ((e-0 (vector-ref e-14 0))) (let ((e-1 (vector-ref e-14 1))) (let ((e-2 (vector-ref e-14 2))) (let ((e-3 (vector-ref e-14 3))) (let ((e-4 (vector-ref e-14 4))) (let ((e-21 (vector-ref e-14 5))) (let ((e-20 (vector-ref e-14 6))) (let ((e-19 (vector-ref e-14 7))) (let ((e-18 (vector-ref e-14 8))) (let ((e-17 (vector-ref e-14 9))) (let ((e-15 (vector-ref e-14 11))) (vector e-0 e-1 e-2 e-3 e-4 e-21 e-20 e-19 e-18 e-17 u--olddelayed e-15))))))))))))))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 (let ((act-35 (unbox arg-2))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 ((arg-10 u--nestC-39) ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (let ((act-37 (unbox arg-2))) (vector 1 act-37)))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-37 1))) (let ((act-38 (let ((act-38 (set-box! arg-2 (let ((e-0 (vector-ref e-18 0))) (let ((e-1 (vector-ref e-18 1))) (let ((e-2 (vector-ref e-18 2))) (let ((e-3 (vector-ref e-18 3))) (let ((e-4 (vector-ref e-18 4))) (let ((e-44 (vector-ref e-18 5))) (let ((e-43 (vector-ref e-18 6))) (let ((e-42 (vector-ref e-18 7))) (let ((e-41 (vector-ref e-18 8))) (let ((e-40 (vector-ref e-18 9))) (let ((e-38 (vector-ref e-18 11))) (let ((e-37 (vector-ref e-18 12))) (let ((e-36 (vector-ref e-18 13))) (let ((e-35 (vector-ref e-18 14))) (let ((e-34 (vector-ref e-18 15))) (let ((e-33 (vector-ref e-18 16))) (let ((e-32 (vector-ref e-18 17))) (let ((e-31 (vector-ref e-18 18))) (let ((e-19 (vector-ref e-18 19))) (let ((e-20 (vector-ref e-18 20))) (let ((e-21 (vector-ref e-18 21))) (let ((e-22 (vector-ref e-18 22))) (let ((e-23 (vector-ref e-18 23))) (let ((e-24 (vector-ref e-18 24))) (let ((e-25 (vector-ref e-18 25))) (let ((e-26 (vector-ref e-18 26))) (let ((e-27 (vector-ref e-18 27))) (let ((e-28 (vector-ref e-18 28))) (let ((e-29 (vector-ref e-18 29))) (let ((e-30 (vector-ref e-18 30))) (vector e-0 e-1 e-2 e-3 e-4 e-44 e-43 e-42 e-41 e-40 u--oldhints e-38 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-38)))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (vector 1 e-17))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Local-getLocalTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 (cons arg-4 '()))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (TTImpC-45ElabC-45Local-case--getLocalTerm-9337 arg-0 e-2 e-3 arg-4 arg-3 arg-2 arg-1 (CoreC-45Env-defined arg-0 e-2 arg-3)))))))
(define TTImpC-45ElabC-45Local-checkLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (TTImpC-45ElabC-45Local-localHelper arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8 arg-9 arg-11 (lambda (u--nestC-39) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--nestC-39 arg-9 arg-12 arg-13)) ext-0)))
(define TTImpC-45ElabC-45Local-checkCaseLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-12 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-14 arg-15) ext-0) (let ((e-1 (unbox e-6))) (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-17 (vector-ref e-1 17))) e-17))))) (let ((u--name (vector 1 arg-10 u--nt arg-12))) (let ((act-26 ((TTImpC-45ElabC-45Local-getLocalTerm arg-0 arg-1 arg-10 arg-9 u--name arg-13) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "elab.local" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Updating case local " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-11) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2074) e-3))))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.local" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "To") arg-9 e-2 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((u--nestC-39 (cons (cons arg-11 (cons (box arg-12) (cons e-3 (lambda (u--fc) (lambda (nt-0) e-2))))) arg-8))) ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--nestC-39 arg-9 arg-14 arg-15) ext-0))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Utils-n--7911-18001-u--notLets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8) (if (null? arg-7) arg-6 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-7 (car arg-8))) (let ((e-8 (cdr arg-8))) (let ((sc2 (CoreC-45TT-isLet e-7))) (cond ((equal? sc2 1) (TTImpC-45ElabC-45Utils-n--7911-18001-u--notLets arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 e-3 e-8)) (else (TTImpC-45ElabC-45Utils-n--7911-18001-u--notLets arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-6) e-3 e-8)))))))))))
(define TTImpC-45ElabC-45Utils-n--7020-17213-u--notErased (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) 1 (if (null? arg-9) 0 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((9) (let ((e-6 (vector-ref e-2 2))) (cond ((equal? e-6 1) (TTImpC-45ElabC-45Utils-n--7020-17213-u--notErased arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--C-43_Num_Nat arg-7 (+ 1 0)) arg-8 e-3))(else (let ((sc3 (PreludeC-45Types-elem (csegen-792) arg-7 arg-8))) (cond ((equal? sc3 1) 1) (else (TTImpC-45ElabC-45Utils-n--7020-17213-u--notErased arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--C-43_Num_Nat arg-7 (+ 1 0)) arg-8 e-3))))))))(else (let ((sc2 (PreludeC-45Types-elem (csegen-792) arg-7 arg-8))) (cond ((equal? sc2 1) 1) (else (TTImpC-45ElabC-45Utils-n--7020-17213-u--notErased arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--C-43_Num_Nat arg-7 (+ 1 0)) arg-8 e-3))))))))))))
(define TTImpC-45ElabC-45Utils-n--8359-18518-u--binderInlineSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-3 (vector-ref arg-6 3))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-5 e-3)))(else (lambda (eta-0) (vector 1 1))))))
(define TTImpC-45ElabC-45Utils-n--8667-18666-u--altsSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 ext-0) (if (null? arg-7) (vector 1 1) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-24 (let ((act-24 (unbox arg-6))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Utils-caseAltInlineSafe arg-0 arg-6 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (let ((act-26 (let ((act-26 (set-box! arg-6 e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45Utils-n--8667-18666-u--altsSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 e-3 ext-0))))) (else (vector 1 0))))))))))))))))
(define TTImpC-45ElabC-45Utils-n--8359-18460-u--allInlineSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 1) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 ((TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-5 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (TTImpC-45ElabC-45Utils-n--8359-18460-u--allInlineSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 ext-0)) (else (vector 1 0))))))))))))
(define TTImpC-45ElabC-45Utils-wrapErrorC (lambda (arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45Types-elem (csegen-1886) 1 arg-1))) (cond ((equal? sc0 1) ext-0) (else (CoreC-45Core-wrapError arg-2 ext-0))))))
(define TTImpC-45ElabC-45Utils-updateErasable (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((act-26 (TTImpC-45ElabC-45Utils-findErased arg-0 (let ((e-2 (vector-ref e-1 2))) e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 arg-1 (let ((e-0 (vector-ref e-1 0))) (let ((e-27 (vector-ref e-1 1))) (let ((e-26 (vector-ref e-1 2))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-22 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-27 e-26 e-2 e-3 e-24 e-23 e-22 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21))))))))))))))))))))) eta-0)) ext-0)))))))))))))))))))
(define TTImpC-45ElabC-45Utils-termInlineSafe (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (TTImpC-45ElabC-45Utils-isUsed e-4 e-5))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((act-25 (TTImpC-45ElabC-45Utils-setUsed e-4 arg-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (vector 1 1)))))))))))))) ((2) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (lambda (eta-0) (TTImpC-45ElabC-45Utils-n--8359-18460-u--allInlineSafe arg-0 e-10 e-9 e-8 e-7 arg-1 e-10 eta-0))))))) ((3) (let ((e-12 (vector-ref arg-2 1))) (let ((e-13 (vector-ref arg-2 2))) (let ((e-14 (vector-ref arg-2 3))) (let ((e-15 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45Utils-n--8359-18518-u--binderInlineSafe arg-0 e-13 e-15 e-14 e-12 arg-1 e-14) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (TTImpC-45ElabC-45Utils-inExtended 2 (cons e-13 '()) arg-1 (lambda (u--uC-39) (TTImpC-45ElabC-45Utils-termInlineSafe (cons e-13 arg-0) u--uC-39 e-15)) eta-0)) (else (vector 1 0))))))))))))) ((4) (let ((e-18 (vector-ref arg-2 2))) (let ((e-19 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-18) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) ((TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-19) eta-0)) (else (vector 1 0))))))))))) ((5) (let ((e-24 (vector-ref arg-2 4))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-24))) ((6) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-28))) ((7) (let ((e-33 (vector-ref arg-2 4))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-33))) ((8) (let ((e-37 (vector-ref arg-2 3))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-37)))(else (lambda (eta-0) (vector 1 1))))))
(define TTImpC-45ElabC-45Utils-setUsedVar (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (if (null? arg-4) arg-4 (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (cond ((equal? e-3 1) (cons 0 e-4))(else arg-4))))))(else (let ((e-0 (- arg-2 1))) (let ((e-7 (car arg-4))) (let ((e-8 (cdr arg-4))) (cons e-7 (TTImpC-45ElabC-45Utils-setUsedVar e-0 e-8)))))))))
(define TTImpC-45ElabC-45Utils-setUsed (lambda (arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-3 (TTImpC-45ElabC-45Utils-setUsedVar arg-2 e-5)))) (vector 1 act-25))))))))
(define TTImpC-45ElabC-45Utils-plicit (lambda (arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-3 (vector-ref arg-1 3))) (CoreC-45TT-forgetDef e-3))) ((3) (let ((e-8 (vector-ref arg-1 3))) (CoreC-45TT-forgetDef e-8)))(else (vector 1 )))))
(define TTImpC-45ElabC-45Utils-isUsed (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-3 (car arg-4))) (cond ((equal? e-3 0) 1)(else 0))))(else (let ((e-0 (- arg-2 1))) (let ((e-8 (cdr arg-4))) (TTImpC-45ElabC-45Utils-isUsed e-0 e-8)))))))
(define TTImpC-45ElabC-45Utils-initUsedCase (lambda (arg-0) (if (null? arg-0) '() (let ((e-3 (cdr arg-0))) (if (null? e-3) (cons 1 '()) (cons 2 (TTImpC-45ElabC-45Utils-initUsedCase e-3)))))))
(define TTImpC-45ElabC-45Utils-inExtended (lambda (arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "TTImp.Elab.Utils.Used" ) (TTImpC-45ElabC-45Utils-extendUsed arg-2 arg-3 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((arg-5 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (let ((act-27 (unbox e-6))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (set-box! arg-4 (TTImpC-45ElabC-45Utils-dropUsed arg-3 e-8)))) (vector 1 act-28)))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-7))))))))))))))))))
(define TTImpC-45ElabC-45Utils-findErasedFrom (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 (AlgebraC-45Semiring-isErased (csegen-475) e-7)))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Utils-findErasedFrom arg-0 arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2) e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((e-12 (car e-10))) (let ((e-11 (cdr e-10))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-9) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Utils-detagSafe arg-0 arg-1 e-13 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-14 (vector-ref act-27 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-27 1))) (let ((u--dtC-39 (cond ((equal? e-14 1) (cons arg-2 e-11)) (else e-11)))) (vector 1 (let ((sc7 (AlgebraC-45Semiring-isErased (csegen-475) e-7))) (cond ((equal? sc7 1) (cons (cons arg-2 e-12) u--dtC-39)) (else (cons e-12 u--dtC-39)))))))))))))))))))))))))))(else (vector 1 (cons '() '()))))))))(else (vector 1 (cons '() '())))))))
(define TTImpC-45ElabC-45Utils-findErased (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ElabC-45Utils-findErasedFrom arg-0 e-5 0 e-6) ext-0)))))))))))
(define TTImpC-45ElabC-45Utils-extendUsed (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-3 (cdr arg-2))) (cons arg-1 (TTImpC-45ElabC-45Utils-extendUsed arg-1 e-3 arg-3))))))
(define TTImpC-45ElabC-45Utils-dropUsed (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr arg-2))) (TTImpC-45ElabC-45Utils-dropUsed e-3 e-7))))))
(define TTImpC-45ElabC-45Utils-detagSafe (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-24 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (if (null? e-6) (vector 1 0) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((6) (let ((e-9 (vector-ref e-7 8))) (if (null? e-9) (vector 1 0) (let ((e-16 (unbox e-9))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-0))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-17 (vector-ref act-25 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-25 1))) (vector 1 (TTImpC-45ElabC-45Utils-n--7020-17213-u--notErased e-1 e-3 e-4 e-5 e-2 arg-1 arg-0 0 e-16 e-17))))))))))(else (vector 1 0)))))))))))))))(else (vector 1 0)))))
(define TTImpC-45ElabC-45Utils-caseInlineSafe (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((sc2 (TTImpC-45ElabC-45Utils-isUsed e-2 e-6))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((act-25 (TTImpC-45ElabC-45Utils-setUsed e-2 arg-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (TTImpC-45ElabC-45Utils-n--8667-18666-u--altsSafe arg-0 e-1 e-5 e-4 e-2 arg-1 e-5 eta-0))))))))))))))))) ((1) (let ((e-8 (vector-ref arg-2 2))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-8))) ((2) (lambda (eta-0) (vector 1 1))) (else (lambda (eta-0) (vector 1 1))))))
(define TTImpC-45ElabC-45Utils-caseAltInlineSafe (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (lambda (eta-0) (TTImpC-45ElabC-45Utils-inExtended 1 e-3 arg-1 (lambda (u--uC-39) (TTImpC-45ElabC-45Utils-caseInlineSafe (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) u--uC-39 e-4)) eta-0))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (lambda (eta-0) (TTImpC-45ElabC-45Utils-inExtended 1 (cons e-6 (cons e-7 '())) arg-1 (lambda (u--uC-39) (TTImpC-45ElabC-45Utils-caseInlineSafe (cons e-6 (cons e-7 arg-0)) u--uC-39 e-8)) eta-0)))))) ((2) (let ((e-11 (vector-ref arg-2 2))) (TTImpC-45ElabC-45Utils-caseInlineSafe arg-0 arg-1 e-11))) (else (let ((e-13 (vector-ref arg-2 1))) (TTImpC-45ElabC-45Utils-caseInlineSafe arg-0 arg-1 e-13))))))
(define TTImpC-45ElabC-45Utils-canInlineCaseBlock (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 2))) (let ((e-8 (vector-ref e-1 4))) (let ((act-26 (CoreC-45Core-newRef (vector "TTImp.Elab.Utils.Used" ) (TTImpC-45ElabC-45Utils-initUsedCase e-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-26 1))) ((TTImpC-45ElabC-45Utils-caseInlineSafe e-3 e-9 e-8) ext-0))))))))(else (vector 1 0)))))))))))))))
(define TTImpC-45ElabC-45Utils-bindReq (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-4 0) ((0) (PreludeC-45Types-u--pure_Applicative_Maybe (cons arg-5 (cons (TTImpC-45ElabC-45Utils-n--7911-18001-u--notLets arg-1 arg-6 arg-5 arg-3 arg-2 '() arg-1 arg-3) (CoreC-45Env-abstractEnvType arg-1 arg-2 arg-3 arg-6)))))(else (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-6 (car arg-3))) (let ((e-7 (cdr arg-3))) (case (vector-ref arg-4 0) ((2) (let ((e-11 (vector-ref arg-4 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-shrinkBinder e-6 e-11) (lambda (u--bC-39) (TTImpC-45ElabC-45Utils-bindReq e-2 arg-2 e-7 e-11 (cons (cons (TTImpC-45ElabC-45Utils-plicit e-6) e-1) arg-5) (vector 3 arg-2 e-1 (vector 2 (CoreC-45TT-binderLoc e-6) (CoreC-45TT-multiplicity e-6) (vector 1 ) (CoreC-45TT-binderType u--bC-39)) arg-6)))))) (else (let ((e-15 (vector-ref arg-4 1))) (TTImpC-45ElabC-45Utils-bindReq e-2 arg-2 e-7 e-15 arg-5 arg-6))))))))))))
(define TTImpC-45ElabC-45Utils-bindNotReq (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-1) (cons arg-6 (CoreC-45TT-embed arg-7)) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (case (vector-ref arg-5 0) ((0) (let ((u--tmptm (CoreC-45TTC-45SubstEnv-subst (vector 1 arg-2 (vector 0 ) (vector 2 "arg" arg-3)) arg-7))) (let ((sc3 (TTImpC-45ElabC-45Utils-bindNotReq e-3 arg-2 (bs+ (blodwen-toSignedInt 1 63) arg-3 63) e-10 (vector 0 ) arg-6 u--tmptm))) (let ((e-5 (car sc3))) (let ((e-4 (cdr sc3))) (cons e-5 (CoreC-45TT-refToLocal (vector 2 "arg" arg-3) e-2 e-4))))))) ((2) (let ((e-15 (vector-ref arg-5 1))) (let ((u--tmptm (CoreC-45TTC-45SubstEnv-subst (vector 1 arg-2 (vector 0 ) (vector 2 "arg" arg-3)) arg-7))) (let ((sc3 (TTImpC-45ElabC-45Utils-bindNotReq e-3 arg-2 (bs+ (blodwen-toSignedInt 1 63) arg-3 63) e-10 e-15 arg-6 u--tmptm))) (let ((e-5 (car sc3))) (let ((e-4 (cdr sc3))) (cons e-5 (CoreC-45TT-refToLocal (vector 2 "arg" arg-3) e-2 e-4)))))))) (else (let ((e-19 (vector-ref arg-5 1))) (TTImpC-45ElabC-45Utils-bindNotReq e-3 arg-2 arg-3 e-10 e-19 (cons (cons (TTImpC-45ElabC-45Utils-plicit e-9) e-2) arg-6) (vector 3 arg-2 e-2 (vector 2 (CoreC-45TT-binderLoc e-9) (CoreC-45TT-multiplicity e-9) (vector 1 ) (CoreC-45TT-binderType e-9)) arg-7))))))))))))
(define TTImpC-45ElabC-45Lazy-n--10025-17301-u--delayError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((47) 1)(else 0))))
(define TTImpC-45ElabC-45Lazy-checkForce (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--gty) (lambda (eta-0) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--gty) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 (vector 5 arg-10 2 e-6))))))))))) arg-12) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-3) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((5) (let ((e-9 (vector-ref e-8 2))) (let ((e-4 (vector-ref e-8 3))) (vector 1 (cons (vector 8 arg-10 e-9 e-2) (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 e-4))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 "Forcing a non-delayed type") ext-0)))))))))))))))))))))))
(define TTImpC-45ElabC-45Lazy-checkDelayed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-24 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 (box (CoreC-45NormaliseC-45Eval-gType arg-10))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (vector 6 arg-10 arg-11 e-2) e-3))))))))))
(define TTImpC-45ElabC-45Lazy-checkDelay (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-24 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-genName arg-1 arg-3 "delayTy" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-5 (vector 11 arg-10) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-6)))))))))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-12) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--solvemode (let ((e-0 (vector-ref arg-7 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))))) (let ((act-25 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 arg-6 arg-9 (box e-5) (lambda (eta-0) (TTImpC-45ElabC-45Lazy-n--10025-17301-u--delayError arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 eta-0)) 4 (lambda (u--delayed) (lambda (eta-0) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (case (vector-ref e-7 0) ((5) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 (box (CoreC-45Normalise-glueBack arg-1 arg-0 e-8 arg-9 e-3))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((act-29 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-4) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45NormaliseC-45Eval-getTerm e-4) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-30 1))) (vector 1 (cons (vector 7 arg-10 e-2 e-12 e-10) (CoreC-45Normalise-glueBack arg-1 arg-0 e-8 arg-9 (vector 5 arg-10 e-2 e-11)))))))))))))))))))))))))(else (let ((act-27 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.delay" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Expected delay type") arg-9 e-7 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 "Can't infer delay type") eta-0)))))))))))) ext-0)))))))))))
(define TTImpC-45ElabC-45ImplicitBind-case--caseC-32blockC-32inC-32checkBindVar-11853 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (if (null? arg-17) (let ((act-24 ((TTImpC-45ElabC-45ImplicitBind-mkPatternHole arg-0 arg-9 arg-12 arg-10 arg-3 arg-7 arg-15 arg-4 (let ((e-1 (vector-ref arg-6 1))) e-1) arg-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-25 (let ((e-1 (vector-ref arg-6 1))) (case (vector-ref e-1 0) ((0) (CoreC-45Unify-setInvertible arg-12 arg-3 arg-15 ext-0))(else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-12 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Added Bound implicit " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (u--d) (lambda (x-1) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-2))))) x-1)) (lambda (u--d) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) u--d x-1))))) x-0)) (lambda (u--d) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-0) (lambda (x-1) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) d-0 x-1))))) u--d x-0))))) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-0) (lambda (x-1) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) d-0 x-1))))) x-0)) (lambda (d-0) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-1) (lambda (x-1) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) x-1)) (lambda (d-1) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-2 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-2 x-2))))) d-1 x-1))))) d-0 x-0))))) u--d u--x))))) (cons arg-15 (cons arg-7 (cons e-2 (cons e-6 e-7))))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (let ((act-27 (unbox arg-9))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-9 (let ((e-1 (vector-ref e-10 0))) (let ((e-22 (vector-ref e-10 1))) (let ((e-21 (vector-ref e-10 2))) (let ((e-4 (vector-ref e-10 3))) (let ((e-20 (vector-ref e-10 4))) (let ((e-19 (vector-ref e-10 5))) (let ((e-18 (vector-ref e-10 6))) (let ((e-17 (vector-ref e-10 7))) (let ((e-16 (vector-ref e-10 8))) (let ((e-15 (vector-ref e-10 9))) (let ((e-11 (vector-ref e-10 10))) (let ((e-12 (vector-ref e-10 11))) (let ((e-13 (vector-ref e-10 12))) (let ((e-14 (vector-ref e-10 13))) (vector e-1 e-22 e-21 e-4 (cons (cons arg-15 (vector 0 arg-0 arg-7 (vector 1 ) e-2 e-6)) e-20) (cons (cons arg-15 (vector 0 arg-0 arg-7 (vector 1 ) e-2 e-7)) e-19) e-18 e-17 e-16 e-15 e-11 e-12 e-13 e-14)))))))))))))))))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-12 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () "checkBindVar is adding \x2193;") ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (CoreC-45Metadata-addNameType arg-0 arg-12 arg-11 arg-3 (vector 1 arg-2) arg-4 e-6 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (CoreC-45Metadata-addNameLoc arg-11 arg-12 arg-3 (vector 1 arg-2) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45Check-checkExp arg-0 arg-12 arg-10 arg-9 arg-7 arg-6 arg-4 arg-3 e-2 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 e-6) arg-1 ext-0))))))))))))))))))))))))))))))) (let ((e-2 (unbox arg-17))) (let ((act-24 (TTImpC-45ElabC-45ImplicitBind-n--13879-11440-u--combine arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (vector 1 arg-2) arg-7 (TTImpC-45ElabC-45Check-bindingRig e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((u--tm (TTImpC-45ElabC-45Check-bindingTerm e-2))) (let ((u--ty (TTImpC-45ElabC-45Check-bindingType e-2))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-12 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () "checkBindVar is adding \x2193;") ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (CoreC-45Metadata-addNameType arg-0 arg-12 arg-11 arg-3 (vector 1 arg-2) arg-4 u--ty ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (CoreC-45Metadata-addNameLoc arg-11 arg-12 arg-3 (vector 1 arg-2) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (TTImpC-45ElabC-45Check-checkExp arg-0 arg-12 arg-10 arg-9 arg-7 arg-6 arg-4 arg-3 u--tm (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 u--ty) arg-1 ext-0)))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-case--getToBindC-44normImps-10882 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (TTImpC-45ElabC-45ImplicitBind-n--12842-10526-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 arg-12 arg-11) (let ((e-2 (car arg-15))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-isCurrentHole arg-6 e-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-24 1))) (let ((sc3 (cond ((equal? e-9 1) (let ((sc5 (PreludeC-45Types-elem (csegen-802) e-6 arg-12))) (cond ((equal? sc5 1) 0) (else 1)))) (else 0)))) (cond ((equal? sc3 1) (let ((act-25 ((TTImpC-45ElabC-45ImplicitBind-n--12842-10526-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 (cons e-6 arg-12) arg-11) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45ImplicitBind-n--12842-10525-u--normBindingTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 arg-10 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (cons (cons e-6 e-11) e-10))))))))))) (else ((TTImpC-45ElabC-45ImplicitBind-n--12842-10526-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 arg-12 arg-11) eta-0))))))))))))(else (TTImpC-45ElabC-45ImplicitBind-n--12842-10526-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 arg-12 arg-11)))))))
(define TTImpC-45ElabC-45ImplicitBind-case--bindUnsolvedC-44makeBoundVar-8804 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-16) (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-76) arg-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "Can't bind implicit " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-15) (PreludeC-45TypesC-45String-C-43C-43 " of type " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-8 e-5))))) ext-0))))) (let ((e-2 (unbox arg-16))) (let ((act-24 (CoreC-45UnifyState-genVarName arg-6 arg-3 (CoreC-45Name-nameRoot arg-15) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Check-metaVar arg-7 arg-6 arg-3 arg-2 arg-14 arg-12 e-5 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--pC-39 (CoreC-45TT-forgetDef arg-13))) (let ((act-27 (let ((act-27 (set-box! arg-5 (let ((e-1 (vector-ref e-7 0))) (let ((e-18 (vector-ref e-7 1))) (let ((e-3 (vector-ref e-7 2))) (let ((e-4 (vector-ref e-7 3))) (let ((e-17 (vector-ref e-7 4))) (let ((e-16 (vector-ref e-7 5))) (let ((e-15 (vector-ref e-7 6))) (let ((e-8 (vector-ref e-7 7))) (let ((e-9 (vector-ref e-7 8))) (let ((e-10 (vector-ref e-7 9))) (let ((e-11 (vector-ref e-7 10))) (let ((e-12 (vector-ref e-7 11))) (let ((e-13 (vector-ref e-7 12))) (let ((e-14 (vector-ref e-7 13))) (vector e-1 e-18 e-3 e-4 e-17 (cons (cons e-5 (vector 0 arg-4 arg-14 u--pC-39 (CoreC-45TT-embedSub arg-10 e-6) (CoreC-45TT-embedSub arg-10 e-2))) e-16) e-15 e-8 e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))))))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (vector 1 (CoreC-45TT-embedSub arg-11 e-6))))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-case--mkPatternHole-8622 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (TTImpC-45ElabC-45ImplicitBind-mkPatternHole arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 '()) (let ((e-2 (unbox arg-14))) (lambda (eta-0) (let ((act-24 (TTImpC-45ElabC-45Check-implBindVar (let ((e-1 (vector-ref arg-10 0))) e-1) arg-8 arg-7 arg-6 arg-5 arg-12 arg-4 e-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (CoreC-45TT-apply arg-6 (CoreC-45TT-embedSub arg-11 e-5) (TTImpC-45ElabC-45ImplicitBind-n--10465-8510-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-0 arg-11)) (cons arg-13 (CoreC-45TT-embedSub arg-11 e-2)))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-case--mkOuterHole-8263 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-mkOuterHole arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 '() eta-0)) (let ((e-2 (unbox arg-12))) (let ((u--env (let ((e-3 (vector-ref arg-9 2))) e-3))) (lambda (eta-0) (let ((act-24 (TTImpC-45ElabC-45Check-implBindVar (let ((e-1 (vector-ref arg-9 0))) e-1) arg-7 arg-6 arg-5 arg-4 u--env arg-3 e-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (CoreC-45TT-embedSub arg-10 e-5) (CoreC-45TT-embedSub arg-10 e-2)))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--12232-10014-u--tidyName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 2))) (TTImpC-45ElabC-45ImplicitBind-n--12232-10014-u--tidyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-1))) ((3) (let ((e-2 (vector-ref arg-8 1))) (TTImpC-45ElabC-45ImplicitBind-n--12232-10014-u--tidyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-2))) ((5) (let ((e-5 (vector-ref arg-8 2))) (TTImpC-45ElabC-45ImplicitBind-n--12232-10014-u--tidyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5)))(else arg-8))))
(define TTImpC-45ElabC-45ImplicitBind-n--11497-9396-u--swapP (lambda (arg-4 arg-6 arg-8) (cond ((equal? arg-8 0) 0)(else (let ((e-0 (- arg-8 1))) (+ 1 (+ 1 e-0)))))))
(define TTImpC-45ElabC-45ImplicitBind-n--12842-10526-u--normImps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-6 0) ((3) (let ((e-8 (vector-ref e-6 1))) (let ((e-9 (vector-ref e-6 2))) (let ((act-24 (CoreC-45Normalise-logTermNF arg-1 arg-8 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Implicit pattern var " (CoreC-45Name-u--show_Show_Name (vector 3 e-8 e-9)))) arg-2 (TTImpC-45ElabC-45Check-bindingType e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((sc4 (PreludeC-45Types-elem (csegen-802) (vector 3 e-8 e-9) arg-10))) (cond ((equal? sc4 1) ((TTImpC-45ElabC-45ImplicitBind-n--12842-10526-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) clam-0)) (else (let ((act-25 ((TTImpC-45ElabC-45ImplicitBind-n--12842-10526-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons (vector 3 e-8 e-9) arg-10) e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45ImplicitBind-n--12842-10525-u--normBindingTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (cons (cons (vector 3 e-8 e-9) e-11) e-10)))))))))))))))))))(else (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-8 arg-1 arg-9 arg-2 (TTImpC-45ElabC-45Check-bindingTerm e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-1 arg-8 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Normalising implicit " (CoreC-45Name-u--show_Show_Name e-6))) e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((TTImpC-45ElabC-45ImplicitBind-case--getToBindC-44normImps-10882 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-6 e-7 e-3 arg-10 arg-9 e-5 (CoreC-45TT-getFnArgs e-5)) clam-0))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--12842-10525-u--normBindingTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 2))) (let ((e-2 (vector-ref arg-10 3))) (let ((e-3 (vector-ref arg-10 4))) (let ((e-4 (vector-ref arg-10 5))) (let ((act-24 (case (vector-ref arg-3 0) ((2) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-8 arg-1 arg-9 arg-2 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Coverage-isEmpty arg-1 arg-8 arg-9 arg-2 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Empty pattern in coverage check") ext-0)) (else (vector 1 0))))))))))))(else (vector 1 0))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 (TTImpC-45ElabC-45ImplicitBind-normaliseType arg-8 arg-1 arg-9 arg-2 e-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 arg-1 e-1 e-2 e-3 e-6)))))))))))))) (else (let ((e-6 (vector-ref arg-10 2))) (let ((e-7 (vector-ref arg-10 3))) (let ((e-8 (vector-ref arg-10 4))) (let ((e-9 (vector-ref arg-10 5))) (let ((e-10 (vector-ref arg-10 6))) (let ((act-24 (case (vector-ref arg-3 0) ((2) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-8 arg-1 arg-9 arg-2 e-9) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Coverage-isEmpty arg-1 arg-8 arg-9 arg-2 e-11 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (cond ((equal? e-12 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Empty pattern in coverage check") ext-0)) (else (vector 1 0))))))))))))(else (vector 1 0))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (TTImpC-45ElabC-45ImplicitBind-normaliseType arg-8 arg-1 arg-9 arg-2 e-9 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Normalise-normaliseHoles arg-8 arg-1 arg-9 arg-2 e-10 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (vector 1 (vector 1 arg-1 e-6 e-7 e-8 e-12 e-13))))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--10830-8784-u--mkImplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (lambda (clam-0) (let ((e-22 (car e-19))) (let ((e-23 (cdr e-19))) (let ((e-26 (car e-23))) (let ((e-27 (cdr e-23))) (let ((act-24 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-8 0))) e-0) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((7) (let ((act-25 (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-6 e-10 arg-8 e-14 e-26 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((TTImpC-45ElabC-45ImplicitBind-n--10830-8783-u--makeBoundVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-10 e-2 e-6 e-18 arg-9 e-27 arg-10 e-9) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-logTerm e-10 arg-6 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Added unbound implicit") e-9 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) ((((CoreC-45Unify-unify (csegen-1962) e-10 arg-6 arg-3 (case (vector-ref arg-1 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm))) arg-2) e-14) e-22) e-9) clam-0)))))))))(else (vector 1 0))))))))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--10465-8510-u--mkArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) '())(else (if (null? arg-11) '() (let ((e-2 (cdr arg-11))) (case (vector-ref arg-12 0) ((1) (let ((e-6 (vector-ref arg-12 1))) (cons (vector 0 arg-6 '() 0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) (TTImpC-45ElabC-45ImplicitBind-n--10465-8510-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 e-6)))))(else '()))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--10830-8783-u--makeBoundVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-case--bindUnsolvedC-44makeBoundVar-8804 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 (CoreC-45TT-shrinkTerm arg-15 arg-13) eta-0))))
(define TTImpC-45ElabC-45ImplicitBind-n--12160-9948-u--liftImpsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((3) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-2 0) ((3) (let ((e-10 (vector-ref e-2 1))) (let ((e-11 (vector-ref e-2 2))) (case (vector-ref e-3 0) ((2) (let ((e-15 (vector-ref e-3 3))) (case (vector-ref e-15 0) ((0) (vector 3 e-1 (vector 3 e-10 e-11) e-3 (TTImpC-45ElabC-45ImplicitBind-n--12160-9948-u--liftImpsC-39 arg-0 arg-1 arg-2 arg-3 (cons (vector 3 e-10 e-11) arg-4) e-4)))(else (case (vector-ref e-3 0) ((2) (TTImpC-45ElabC-45ImplicitBind-push arg-4 e-1 e-2 e-3 (TTImpC-45ElabC-45ImplicitBind-n--12160-9948-u--liftImpsC-39 arg-0 arg-1 arg-2 arg-3 (cons e-2 arg-4) e-4)))(else arg-5))))))(else (case (vector-ref e-3 0) ((2) (TTImpC-45ElabC-45ImplicitBind-push arg-4 e-1 e-2 e-3 (TTImpC-45ElabC-45ImplicitBind-n--12160-9948-u--liftImpsC-39 arg-0 arg-1 arg-2 arg-3 (cons e-2 arg-4) e-4)))(else arg-5)))))))(else (case (vector-ref e-3 0) ((2) (TTImpC-45ElabC-45ImplicitBind-push arg-4 e-1 e-2 e-3 (TTImpC-45ElabC-45ImplicitBind-n--12160-9948-u--liftImpsC-39 arg-0 arg-1 arg-2 arg-3 (cons e-2 arg-4) e-4)))(else arg-5)))))))))(else arg-5))))
(define TTImpC-45ElabC-45ImplicitBind-n--13879-11439-u--isIncompatible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((sc0 (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-13))) (cond ((equal? sc1 1) 1) (else (AlgebraC-45Semiring-isLinear (csegen-475) arg-14)))))) (cond ((equal? sc0 1) (AlgebraC-45Preorder-C-60 (csegen-2098) (csegen-519) (AlgebraC-45ZeroOneOmega-u--C-124C-43C-124_Semiring_ZeroOneOmega arg-13 arg-14))) (else 0)))))
(define TTImpC-45ElabC-45ImplicitBind-n--12842-10527-u--insert (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (cons arg-9 '()) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-5 (car arg-12))) (let ((e-6 (cdr arg-12))) (let ((e-9 (car e-5))) (let ((e-10 (cdr e-5))) (let ((u--used (DataC-45List-filter (lambda (u--n) (PreludeC-45Types-elem (csegen-802) u--n arg-10)) (LibrariesC-45DataC-45NameMap-keys (TTImpC-45ElabC-45Check-bindingMetas e-10))))) (let ((sc4 (PreludeC-45Types-elem (csegen-802) e-2 u--used))) (cond ((equal? sc4 1) (cons (cons e-2 e-3) (cons (cons e-9 e-10) e-6))) (else (cons (cons e-9 e-10) (TTImpC-45ElabC-45ImplicitBind-n--12842-10527-u--insert arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-2 e-3) arg-10 (cons e-9 arg-11) e-6)))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--12232-10015-u--getBinds (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-10 arg-11 arg-12 arg-13) (if (null? arg-10) (cons (CoreC-45TT-refsToLocals arg-11 arg-12) (CoreC-45TT-refsToLocals arg-11 arg-13)) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-11 0) ((0) (let ((e-13 (vector-ref e-11 2))) (let ((e-14 (vector-ref e-11 3))) (let ((e-16 (vector-ref e-11 5))) (let ((sc4 (TTImpC-45ElabC-45ImplicitBind-n--12232-10015-u--getBinds arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 (vector 1 e-6 e-10 arg-11) arg-12 arg-13))) (let ((e-5 (car sc4))) (let ((e-4 (cdr sc4))) (let ((u--btyC-39 (CoreC-45TT-refsToLocals arg-11 e-16))) (case (vector-ref arg-6 0) ((0) (let ((e-0 (vector-ref arg-6 1))) (cons (vector 3 arg-7 e-6 (vector 2 arg-7 e-0 (vector 0 ) u--btyC-39) e-5) (vector 11 arg-7))))(else (cons (vector 3 arg-7 e-6 (vector 3 arg-7 e-13 (CoreC-45TT-u--map_Functor_PiInfo (lambda (eta-0) (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45Bounds-sizeOf arg-11) eta-0)) e-14) u--btyC-39) e-5) (vector 3 arg-7 e-6 (vector 5 arg-7 e-13 u--btyC-39) e-4)))))))))))) (else (let ((e-18 (vector-ref e-11 2))) (let ((e-21 (vector-ref e-11 5))) (let ((e-22 (vector-ref e-11 6))) (let ((sc4 (TTImpC-45ElabC-45ImplicitBind-n--12232-10015-u--getBinds arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 (vector 1 e-6 e-10 arg-11) arg-12 arg-13))) (let ((e-5 (car sc4))) (let ((e-4 (cdr sc4))) (let ((u--btyC-39 (CoreC-45TT-refsToLocals arg-11 e-21))) (let ((u--bpatC-39 (CoreC-45TT-refsToLocals arg-11 e-22))) (cons (vector 3 arg-7 e-6 (vector 4 arg-7 e-18 u--bpatC-39 u--btyC-39) e-5) (vector 3 arg-7 e-6 (vector 4 arg-7 e-18 u--bpatC-39 u--btyC-39) e-4)))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--12842-10528-u--depSort (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) '() (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (TTImpC-45ElabC-45ImplicitBind-n--12842-10527-u--insert arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2 arg-9 '() (TTImpC-45ElabC-45ImplicitBind-n--12842-10528-u--depSort arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3)))))))
(define TTImpC-45ElabC-45ImplicitBind-n--13879-11440-u--combine (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((sc0 (TTImpC-45ElabC-45ImplicitBind-n--13879-11439-u--isIncompatible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14 arg-15))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-3 (+ 1 (+ 1 0)) arg-13) ext-0)) (else (vector 1 0))))))
(define TTImpC-45ElabC-45ImplicitBind-n--10465-8511-u--bindInner (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((0) (box arg-13))(else (if (null? arg-11) '() (let ((e-1 (car arg-11))) (let ((e-2 (cdr arg-11))) (if (null? arg-12) '() (let ((e-6 (car arg-12))) (let ((e-7 (cdr arg-12))) (case (vector-ref arg-14 0) ((1) (let ((e-11 (vector-ref arg-14 1))) (TTImpC-45ElabC-45ImplicitBind-n--10465-8511-u--bindInner arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 e-7 (vector 3 arg-6 e-1 e-6 arg-13) e-11)))(else '()))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-swapVars (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (vector 0 e-2 e-3 (TTImpC-45ElabC-45ImplicitBind-swapIsVar arg-3 e-4)))))) ((1) (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (vector 2 e-11 e-12 e-13 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 eta-0)) e-14))))))) ((3) (let ((e-16 (vector-ref arg-4 1))) (let ((e-17 (vector-ref arg-4 2))) (let ((e-18 (vector-ref arg-4 3))) (let ((e-19 (vector-ref arg-4 4))) (vector 3 e-16 e-17 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 eta-0)) e-18) (TTImpC-45ElabC-45ImplicitBind-swapVars (cons e-17 arg-3) e-19))))))) ((4) (let ((e-21 (vector-ref arg-4 1))) (let ((e-22 (vector-ref arg-4 2))) (let ((e-23 (vector-ref arg-4 3))) (vector 4 e-21 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-22) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-23)))))) ((5) (let ((e-25 (vector-ref arg-4 1))) (let ((e-26 (vector-ref arg-4 2))) (let ((e-27 (vector-ref arg-4 3))) (let ((e-28 (vector-ref arg-4 4))) (vector 5 e-25 e-26 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-27) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-28))))))) ((6) (let ((e-30 (vector-ref arg-4 1))) (let ((e-31 (vector-ref arg-4 2))) (let ((e-32 (vector-ref arg-4 3))) (vector 6 e-30 e-31 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-32)))))) ((7) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 3))) (let ((e-37 (vector-ref arg-4 4))) (vector 7 e-34 e-35 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-36) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-37))))))) ((8) (let ((e-39 (vector-ref arg-4 1))) (let ((e-40 (vector-ref arg-4 2))) (let ((e-41 (vector-ref arg-4 3))) (vector 8 e-39 e-40 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-41)))))) ((9) (let ((e-43 (vector-ref arg-4 1))) (let ((e-44 (vector-ref arg-4 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-4 1))) (let ((e-47 (vector-ref arg-4 2))) (vector 10 e-46 e-47)))) (else (let ((e-49 (vector-ref arg-4 1))) (vector 11 e-49))))))
(define TTImpC-45ElabC-45ImplicitBind-swapIsVarH (lambda (arg-4) (cond ((equal? arg-4 0) (+ 1 0))(else (let ((e-0 (- arg-4 1))) (TTImpC-45ElabC-45ImplicitBind-n--11497-9396-u--swapP e-0 arg-4 e-0))))))
(define TTImpC-45ElabC-45ImplicitBind-swapIsVar (lambda (arg-4 arg-5) (if (null? arg-4) (TTImpC-45ElabC-45ImplicitBind-swapIsVarH arg-5) (let ((e-3 (cdr arg-4))) (cond ((equal? arg-5 0) 0)(else (let ((e-4 (- arg-5 1))) (+ 1 (TTImpC-45ElabC-45ImplicitBind-swapIsVar e-3 e-4)))))))))
(define TTImpC-45ElabC-45ImplicitBind-solvePolyConstraint (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-0 (vector-ref arg-2 0))) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (case (vector-ref e-7 0) ((1) (let ((e-9 (vector-ref e-7 2))) (case (vector-ref e-9 0) ((2) (vector 1 0))(else (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-5) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (((((CoreC-45Unify-unify (csegen-1965) e-0 arg-0 arg-1 (CoreC-45Unify-inLHS) e-1) e-2) e-7) e-11) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (vector 1 0))))))))(else (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-5) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (((((CoreC-45Unify-unify (csegen-1965) e-0 arg-0 arg-1 (CoreC-45Unify-inLHS) e-1) e-2) e-7) e-8) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (vector 1 0)))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-push (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-2 0) ((3) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 1))) (let ((e-9 (vector-ref e-3 2))) (let ((e-10 (vector-ref e-3 3))) (let ((e-11 (vector-ref e-3 4))) (case (vector-ref e-10 0) ((0) (let ((u--tm (vector 3 e-1 (vector 3 e-5 e-6) (vector 2 e-8 e-9 (vector 0 ) e-11) e-4))) (let ((sc4 (CoreC-45TT-shrinkTerm e-11 (vector 1 (vector 0 ))))) (if (null? sc4) (vector 3 arg-1 arg-2 arg-3 u--tm) (let ((e-7 (unbox sc4))) (vector 3 e-1 (vector 3 e-5 e-6) (vector 2 e-8 e-9 (vector 0 ) e-7) (TTImpC-45ElabC-45ImplicitBind-push (cons (vector 3 e-5 e-6) arg-0) arg-1 arg-2 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) arg-3) (TTImpC-45ElabC-45ImplicitBind-swapVars '() e-4))))))))(else (vector 3 arg-1 arg-2 arg-3 arg-4))))))))(else (vector 3 arg-1 arg-2 arg-3 arg-4))))))(else (vector 3 arg-1 arg-2 arg-3 arg-4))))))))(else (vector 3 arg-1 arg-2 arg-3 arg-4)))))
(define TTImpC-45ElabC-45ImplicitBind-normaliseType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 (CoreC-45Value-withHoles) arg-2 arg-3 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF arg-0 arg-1 (vector 0 0 (box (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) arg-2 arg-3 e-5 eta-0)))))) (lambda (u--err) (lambda (eta-0) (CoreC-45Normalise-normalise arg-0 arg-1 arg-2 arg-3 arg-4 eta-0))) ext-0)))
(define TTImpC-45ElabC-45ImplicitBind-mkPatternHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((act-24 (TTImpC-45ElabC-45ImplicitBind-mkOuterHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-4 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-4 (cons e-3 e-3))))))))))(else (if (null? arg-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "Unknown type for pattern variable " (CoreC-45Name-u--show_Show_Name arg-6))) clam-0) (let ((e-1 (unbox arg-9))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--sub (let ((e-4 (vector-ref e-5 3))) e-4))) (let ((u--env (let ((e-3 (vector-ref e-5 2))) e-3))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm e-1) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ElabC-45ImplicitBind-case--mkPatternHole-8622 arg-0 e-1 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 u--sub u--env e-6 (TTImpC-45ElabC-45ImplicitBind-n--10465-8511-u--bindInner arg-0 e-1 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-7 e-6 u--sub)) clam-0))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-mkOuterHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-8) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--sub (let ((e-4 (vector-ref e-5 3))) e-4))) (let ((u--env (let ((e-3 (vector-ref e-5 2))) e-3))) (let ((act-25 (CoreC-45UnifyState-genName arg-2 arg-3 (PreludeC-45TypesC-45String-C-43C-43 "type_of_" (CoreC-45Name-nameRoot arg-6)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Check-metaVar (let ((e-1 (vector-ref e-5 0))) e-1) arg-2 arg-3 arg-4 (csegen-21) u--env e-6 (vector 11 arg-4) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-2 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Made metavariable for type of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-6) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45Name-u--show_Show_Name e-6))))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (set-box! arg-1 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-6 arg-5 (vector 1 ) arg-7 (CoreC-45TT-embedSub u--sub e-7) (vector 11 arg-4) e-5)))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (TTImpC-45ElabC-45Check-implBindVar (let ((e-1 (vector-ref e-5 0))) e-1) arg-2 arg-3 arg-4 arg-5 u--env arg-6 e-7 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (cons (CoreC-45TT-embedSub u--sub e-10) (CoreC-45TT-embedSub u--sub e-7))))))))))))))))))))))))))) (let ((e-1 (unbox arg-8))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--sub (let ((e-4 (vector-ref e-5 3))) e-4))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ElabC-45ImplicitBind-case--mkOuterHole-8263 arg-0 e-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 u--sub e-6 (CoreC-45TT-shrinkTerm e-6 u--sub)) ext-0))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-liftImps (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (if (null? arg-2) arg-2 (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (case (vector-ref e-4 0) ((11) (let ((e-6 (vector-ref e-4 1))) (cons (TTImpC-45ElabC-45ImplicitBind-n--12160-9948-u--liftImpsC-39 arg-0 e-0 e-3 e-6 arg-0 e-3) (vector 11 e-6))))(else arg-2)))))))(else arg-2))))
(define TTImpC-45ElabC-45ImplicitBind-implicitBind (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((7) (let ((act-26 (CoreC-45Context-updateDef arg-0 arg-2 (lambda (eta-0) (box (vector 10 ))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45UnifyState-removeHoleName arg-0 arg-1 arg-2 ext-0)))))(else (vector 1 0)))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-getToBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-6 0) ((3) (vector 1 '()))(else (let ((act-24 (CoreC-45Unify-solveConstraints arg-1 arg-3 (case (vector-ref arg-5 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm))) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (TTImpC-45ElabC-45ImplicitBind-bindUnsolved arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Unify-solveConstraints arg-1 arg-3 (case (vector-ref arg-5 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm))) 0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (unbox arg-2))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--tob (PreludeC-45TypesC-45List-reverse (DataC-45List-filter (lambda (u--x) (let ((sc5 (PreludeC-45Types-elem (csegen-802) (Builtin-fst u--x) arg-8))) (cond ((equal? sc5 1) 0) (else 1)))) (let ((e-18 (vector-ref e-9 5))) e-18))))) (let ((act-29 ((TTImpC-45ElabC-45ImplicitBind-n--12842-10526-u--normImps arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-8 '() u--tob) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--hnames (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-10))) (let ((u--resC-39 (TTImpC-45ElabC-45ImplicitBind-n--12842-10528-u--depSort arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--hnames e-10))) (let ((act-30 (CoreC-45ContextC-45Log-log arg-1 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Bound names: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2101) e-10))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45ContextC-45Log-log arg-1 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Sorted: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2101) u--resC-39))) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (vector 1 u--resC-39)))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-checkPolyConstraint (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (case (vector-ref e-7 0) ((1) (let ((e-9 (vector-ref e-7 2))) (case (vector-ref e-9 0) ((2) (let ((act-26 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-5) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-14 (vector-ref act-26 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Check-concrete e-6 e-2 e-14) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-15 (vector-ref act-27 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-27 1))) (cond ((equal? e-15 1) (let ((act-28 (CoreC-45Context-clearDefs e-6 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-16 (vector-ref act-28 1))) (vector 0 e-16))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 e-0 e-1 e-2 e-3) ext-0))))) (else (vector 1 0))))))))))))(else (vector 1 0)))))(else (vector 1 0)))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-checkBindVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((u--elabmode (let ((e-0 (vector-ref arg-7 0))) e-0))) (let ((sc0 (let ((e-1 (vector-ref arg-7 1))) (case (vector-ref e-1 0) ((0) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) 1)) (CoreC-45Env-defined arg-0 (vector 1 arg-11) arg-9)))(else 0))))) (cond ((equal? sc0 0) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (vector 3 (vector 1 arg-11) (let ((e-2 (vector-ref e-5 1))) e-2)))) (let ((act-25 (TTImpC-45ElabC-45Check-noteLHSPatVar arg-4 u--elabmode (vector 1 arg-11) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (TTImpC-45ElabC-45Check-notePatVar arg-4 u--n eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (unbox arg-4))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((sc5 (CoreC-45FC-isConcreteFC arg-10))) (if (null? sc5) (vector 1 0) (let ((e-1 (unbox sc5))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-1 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "getNameType is adding Bound: " (CoreC-45Name-u--show_Show_Name u--n))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (CoreC-45Metadata-addSemanticDecorations arg-2 arg-1 (cons (cons e-1 (cons 5 (box u--n))) '()) eta-0))))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45ImplicitBind-case--caseC-32blockC-32inC-32checkBindVar-11853 arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--elabmode e-5 u--n e-8 (DataC-45List-lookup (csegen-802) u--n (let ((e-19 (vector-ref e-8 4))) e-19)) eta-0)))))))))))))))))))))(else (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 0 arg-10 (vector 1 arg-11)) arg-12)))))))
(define TTImpC-45ElabC-45ImplicitBind-checkBindHere (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--oldenv (let ((e-3 (vector-ref e-5 2))) e-3))) (let ((u--oldsub (let ((e-4 (vector-ref e-5 3))) e-4))) (let ((u--oldbif (let ((e-7 (vector-ref e-5 6))) e-7))) (let ((u--dontbind (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (let ((e-6 (vector-ref e-5 5))) e-6)))) (let ((act-25 (let ((act-25 (set-box! arg-4 (TTImpC-45ElabC-45Check-updateEnv arg-0 arg-9 (vector 0 ) '() e-5)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-getNextEntry arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((e-0 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-8 (vector-ref arg-7 5))) (vector e-0 arg-11 e-2 1 e-4 e-8))))) arg-8 arg-9 arg-12 arg-13) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((u--solvemode (let ((e-0 (vector-ref arg-7 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))))) (let ((act-28 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (let ((act-29 (unbox arg-3))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (TTImpC-45ElabC-45Delayed-retryDelayed arg-0 arg-1 arg-2 arg-3 arg-4 u--solvemode (let ((e-12 (vector-ref e-10 10))) e-12) eta-0)) (lambda (u--err) (lambda (eta-0) (let ((act-30 (let ((act-30 (unbox arg-3))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (set-box! arg-3 (let ((e-0 (vector-ref e-11 0))) (let ((e-1 (vector-ref e-11 1))) (let ((e-20 (vector-ref e-11 2))) (let ((e-19 (vector-ref e-11 3))) (let ((e-4 (vector-ref e-11 4))) (let ((e-18 (vector-ref e-11 5))) (let ((e-17 (vector-ref e-11 6))) (let ((e-16 (vector-ref e-11 7))) (let ((e-15 (vector-ref e-11 8))) (let ((e-14 (vector-ref e-11 9))) (let ((e-12 (vector-ref e-11 11))) (vector e-0 e-1 e-20 e-19 e-4 e-18 e-17 e-16 e-15 e-14 '() e-12))))))))))))))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0)))))))))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (let ((act-31 (unbox arg-3))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (let ((u--cons (let ((e-18 (vector-ref e-12 6))) e-18))) (let ((act-32 (let ((act-32 (set-box! arg-3 (let ((e-0 (vector-ref e-12 0))) (let ((e-1 (vector-ref e-12 1))) (let ((e-21 (vector-ref e-12 2))) (let ((e-20 (vector-ref e-12 3))) (let ((e-4 (vector-ref e-12 4))) (let ((e-19 (vector-ref e-12 5))) (let ((e-17 (vector-ref e-12 7))) (let ((e-16 (vector-ref e-12 8))) (let ((e-15 (vector-ref e-12 9))) (let ((e-14 (vector-ref e-12 10))) (let ((e-13 (vector-ref e-12 11))) (vector e-0 e-1 e-21 e-20 e-4 e-19 '() e-17 e-16 e-15 e-14 e-13))))))))))))))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45ImplicitBind-solvePolyConstraint arg-1 arg-3 eta-0 eta-1))) u--cons ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((act-34 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45ImplicitBind-checkPolyConstraint arg-1 eta-0 eta-1))) u--cons ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((act-35 (CoreC-45Unify-solveConstraintsAfter arg-1 arg-3 e-7 (let ((e-0 (vector-ref arg-7 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))) 1 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((act-36 (CoreC-45Unify-checkDots arg-3 arg-1 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((act-37 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Binding names") e-2 ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (let ((act-38 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Normalised") arg-9 e-2 ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((act-39 (TTImpC-45ElabC-45ImplicitBind-getToBind arg-0 arg-1 arg-4 arg-3 arg-10 (let ((e-0 (vector-ref arg-7 0))) e-0) arg-11 arg-9 u--dontbind ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-39 1))) (let ((act-40 (TTImpC-45ElabC-45Check-clearToBind arg-4 u--dontbind ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-4 (vector-ref act-40 1))) (vector 0 e-4))) (else (let ((act-41 (let ((act-41 (unbox arg-4))) (vector 1 act-41)))) (case (vector-ref act-41 0) ((0) (let ((e-4 (vector-ref act-41 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-41 1))) (let ((act-42 (let ((act-42 (set-box! arg-4 (TTImpC-45ElabC-45Check-updateEnv (let ((e-1 (vector-ref e-5 0))) e-1) u--oldenv u--oldsub u--oldbif (let ((e-1 (vector-ref e-22 0))) (let ((e-34 (vector-ref e-22 1))) (let ((e-33 (vector-ref e-22 2))) (let ((e-4 (vector-ref e-22 3))) (let ((e-31 (vector-ref e-22 5))) (let ((e-30 (vector-ref e-22 6))) (let ((e-29 (vector-ref e-22 7))) (let ((e-28 (vector-ref e-22 8))) (let ((e-27 (vector-ref e-22 9))) (let ((e-26 (vector-ref e-22 10))) (let ((e-25 (vector-ref e-22 11))) (let ((e-24 (vector-ref e-22 12))) (let ((e-23 (vector-ref e-22 13))) (vector e-1 e-34 e-33 e-4 '() e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23)))))))))))))))))) (vector 1 act-42)))) (case (vector-ref act-42 0) ((0) (let ((e-4 (vector-ref act-42 1))) (vector 0 e-4))) (else (let ((act-43 ((CoreC-45NormaliseC-45Eval-getTerm e-3) ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-4 (vector-ref act-43 1))) (vector 0 e-4))) (else (let ((e-24 (vector-ref act-43 1))) (let ((act-44 (let ((act-44 (unbox arg-1))) (vector 1 act-44)))) (case (vector-ref act-44 0) ((0) (let ((e-4 (vector-ref act-44 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-44 1))) (let ((act-45 (let ((act-45 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-25 arg-9 e-2 ext-0))) (case (vector-ref act-45 0) ((0) (let ((e-4 (vector-ref act-45 1))) (vector 0 e-4))) (else (let ((e-26 (vector-ref act-45 1))) (let ((act-46 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-25 arg-9 e-24 ext-0))) (case (vector-ref act-46 0) ((0) (let ((e-4 (vector-ref act-46 1))) (vector 0 e-4))) (else (let ((e-27 (vector-ref act-46 1))) (TTImpC-45ElabC-45ImplicitBind-bindImplicits arg-1 arg-0 arg-10 arg-11 e-25 arg-9 e-20 e-26 e-27 ext-0))))))))))) (case (vector-ref act-45 0) ((0) (let ((e-4 (vector-ref act-45 1))) (vector 0 e-4))) (else (let ((e-26 (vector-ref act-45 1))) (let ((e-27 (car e-26))) (let ((e-4 (cdr e-26))) (let ((act-46 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45ImplicitBind-implicitBind arg-1 arg-3 eta-0 eta-1))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-20) ext-0))) (case (vector-ref act-46 0) ((0) (let ((e-28 (vector-ref act-46 1))) (vector 0 e-28))) (else (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 e-27 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-4) arg-13 ext-0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-bindUnsolved (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((3) (vector 1 0))(else (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--bifs (let ((e-7 (vector-ref e-5 6))) e-7))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "elab.implicits" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Bindable unsolved implicits: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--bifs)))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-n--10830-8784-u--mkImplicit arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 (let ((e-1 (vector-ref e-5 0))) e-1) e-6 (let ((e-3 (vector-ref e-5 2))) e-3) (let ((e-4 (vector-ref e-5 3))) e-4) eta-0)) (let ((e-15 (vector-ref e-5 6))) e-15) ext-0)))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-bindImplicits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-3 0) ((3) (vector 1 (cons arg-7 arg-8)))(else (vector 1 (TTImpC-45ElabC-45ImplicitBind-liftImps arg-1 arg-3 (TTImpC-45ElabC-45ImplicitBind-bindImplVars arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8)))))))
(define TTImpC-45ElabC-45ImplicitBind-bindImplVars (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-2 0) ((3) (cons arg-6 arg-7))(else (let ((u--imps (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (TTImpC-45ElabC-45ImplicitBind-n--12232-10014-u--tidyName arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-2) (cons e-2 e-3))))) arg-5))) (TTImpC-45ElabC-45ImplicitBind-n--12232-10015-u--getBinds arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--imps (vector 0 ) arg-6 arg-7))))))
(define CoreC-45Coverage-case--eraseApps-5450 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Coverage-eraseApps arg-2 eta-0)) e-3 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-apply e-5 (vector 1 e-5 (vector 0 ) e-7) e-8)))))))(else (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-7 (let ((e-0 (vector-ref e-8 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-25 1))) (let ((u--eargs (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (let ((e-27 (vector-ref eta-0 3))) e-27))) e-9))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Coverage-eraseApps arg-2 eta-0)) (CoreC-45Coverage-n--10478-5388-u--dropPos arg-1 arg-2 e-5 0 u--eargs e-3) '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-apply e-5 (vector 1 e-5 e-6 e-7) e-10)))))))))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Coverage-eraseApps arg-2 eta-0)) e-3 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-apply (CoreC-45TT-getLoc e-2) e-2 e-5)))))))))))))
(define CoreC-45Coverage-case--caseC-32blockC-32inC-32conflict-3522 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-8) (vector 1 0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-2 0) ((5) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-5 '() arg-4 '() e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) ((CoreC-45Coverage-n--7773-2934-u--conflictNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 arg-2 e-7) clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (if (null? e-7) (vector 1 1) (let ((e-8 (unbox e-7))) (vector 1 (CoreC-45Coverage-conflictMatch arg-0 e-8)))))))))(else (vector 1 0)))))))))
(define CoreC-45Coverage-n--10751-5650-u--tryClauses (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-3) (let ((act-24 (CoreC-45Normalise-logTermNF '() arg-2 "coverage" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Nothing matches") '() arg-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (box arg-4))))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((act-24 (CoreC-45Coverage-clauseMatches e-4 arg-2 e-5 e-6 arg-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-8 (vector-ref act-24 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-24 1))) (cond ((equal? e-8 1) (let ((act-25 (CoreC-45Normalise-logTermNF e-4 arg-2 "coverage" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Yes") e-5 e-6 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (vector 1 '()))))) (else (let ((act-25 (CoreC-45Normalise-logTermNF e-4 arg-2 "coverage" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "No match") e-5 e-6 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else ((CoreC-45Coverage-n--10751-5650-u--tryClauses arg-0 arg-1 arg-2 e-3 arg-4) clam-0)))))))))))))))))))
(define CoreC-45Coverage-n--9637-4607-u--rep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((3) (let ((e-1 (vector-ref arg-6 1))) (let ((act-24 (CoreC-45CaseC-45Util-getCons arg-5 arg-0 arg-3 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45Util-mkAlt arg-0 arg-4 e-1 eta-0)) e-5))))))))(else (vector 1 (cons arg-6 '()))))))
(define CoreC-45Coverage-n--10071-5011-u--notCovering (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-4 (let ((e-0 (vector-ref arg-3 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (let ((e-10 (vector-ref e-1 10))) (let ((e-24 (cdr e-10))) (case (vector-ref e-24 0) ((0) (vector 1 0))(else (vector 1 1)))))))))))))
(define CoreC-45Coverage-n--8954-4172-u--noneOf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CoreC-45Coverage-altMatch arg-7 eta-0)) arg-6))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Coverage-n--10071-5010-u--noAssert (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cond ((equal? e-3 1) '()) (else (box e-2)))))))
(define CoreC-45Coverage-n--10661-5563-u--mkSubstEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-5) '() (let ((e-3 (cdr arg-5))) (let ((e-9 (cdr arg-8))) (cons (vector 1 arg-6 (vector 0 ) (vector 2 "cov" arg-7)) (CoreC-45Coverage-n--10661-5563-u--mkSubstEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 (bs+ arg-7 1 63) e-9)))))))
(define CoreC-45Coverage-n--10071-5009-u--isCase (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 2))) (CoreC-45Coverage-n--10071-5009-u--isCase arg-0 arg-1 arg-2 e-1))) ((6) 1)(else 0))))
(define CoreC-45Coverage-n--7268-2481-u--findN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-4 (vector-ref arg-5 3))) (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-4 e-4)))(else (let ((sc0 (CoreC-45TT-getFnArgs arg-5))) (if (null? sc0) 0 (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((2) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CoreC-45Coverage-n--7268-2481-u--findN arg-0 arg-1 arg-2 arg-3 arg-4 eta-0)) e-3))(else 0))))(else 0))))))))))
(define CoreC-45Coverage-n--9637-4608-u--dropRep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 2))) (cons e-2 (CoreC-45Coverage-n--9637-4608-u--dropRep arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (DataC-45List-filter (lambda (eta-0) (let ((sc2 (CoreC-45CaseC-45Util-tagIs e-6 eta-0))) (cond ((equal? sc2 1) 0) (else 1)))) e-3)))))(else (cons e-2 (CoreC-45Coverage-n--9637-4608-u--dropRep arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)))))))))
(define CoreC-45Coverage-n--10478-5388-u--dropPos (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) arg-4 arg-5))) (cond ((equal? sc1 1) (cons (vector 10 arg-3 0) (CoreC-45Coverage-n--10478-5388-u--dropPos arg-1 arg-2 arg-3 (+ 1 arg-4) arg-5 e-3))) (else (cons e-2 (CoreC-45Coverage-n--10478-5388-u--dropPos arg-1 arg-2 arg-3 (+ 1 arg-4) arg-5 e-3))))))))))
(define CoreC-45Coverage-n--7268-2482-u--conflictTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) (let ((e-10 (vector-ref arg-4 3))) (let ((sc1 (CoreC-45TT-getFnArgs arg-5))) (if (null? sc1) 0 (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((2) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CoreC-45Coverage-n--7268-2481-u--findN arg-0 arg-1 arg-2 arg-3 e-10 eta-0)) e-3))(else 0))))(else 0))))))))(else (case (vector-ref arg-5 0) ((0) (let ((e-4 (vector-ref arg-5 3))) (let ((sc1 (CoreC-45TT-getFnArgs arg-4))) (if (null? sc1) 0 (let ((e-6 (car sc1))) (let ((e-5 (cdr sc1))) (case (vector-ref e-6 0) ((1) (let ((e-8 (vector-ref e-6 2))) (case (vector-ref e-8 0) ((2) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CoreC-45Coverage-n--7268-2481-u--findN arg-0 arg-1 arg-2 arg-3 e-4 eta-0)) e-5))(else 0))))(else 0))))))))(else (let ((sc0 (CoreC-45TT-getFnArgs arg-4))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (CoreC-45TT-getFnArgs arg-5))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (CoreC-45Coverage-n--7268-2480-u--clash arg-0 arg-1 arg-2 arg-3 e-2 e-5))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (CoreC-45Coverage-n--7268-2482-u--conflictTm arg-0 arg-1 arg-2 arg-3 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List e-3 e-4)))))))))))))))))
(define CoreC-45Coverage-n--7773-2934-u--conflictNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (let ((e-34 (vector-ref arg-8 4))) (let ((u--xC-39 (vector 2 (CoreC-45Name-u--show_Show_Name e-32) arg-6))) (lambda (eta-0) (let ((act-24 (((e-34 arg-4) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-31 (vector 0 ) u--xC-39))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Coverage-n--7773-2934-u--conflictNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-6 1 63) arg-7 e-5) eta-0))))))))))) ((1) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (case (vector-ref e-37 0) ((1) (let ((e-40 (vector-ref e-37 1))) (let ((e-41 (vector-ref e-37 2))) (case (vector-ref e-40 0) ((0) (if (null? e-38) (lambda (eta-0) (let ((act-24 (CoreC-45Context-clearDefs arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-5 arg-0 e-5 arg-3 arg-7 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box (cons (cons e-41 e-6) '())))))))))))) (case (vector-ref arg-7 0) ((2) (let ((e-3 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((2) (let ((e-18 (vector-ref arg-8 3))) (let ((e-20 (vector-ref arg-8 5))) (let ((sc6 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-3 e-18))) (cond ((equal? sc6 1) (CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-20))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((3) (let ((e-8 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((3) (let ((e-23 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 5))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-23))) (cond ((equal? sc6 1) (CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-26))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((8) (let ((e-14 (vector-ref arg-7 2))) (lambda (clam-0) (case (vector-ref arg-8 0) ((8) (let ((e-29 (vector-ref arg-8 2))) (let ((sc6 (CoreC-45TT-u--C-61C-61_Eq_Constant e-14 e-29))) (cond ((equal? sc6 1) (vector 1 (box '()))) (else (vector 1 '()))))))(else (vector 1 (box '())))))))(else (lambda (eta-0) (vector 1 (box '())))))))(else (case (vector-ref arg-7 0) ((2) (let ((e-3 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((2) (let ((e-18 (vector-ref arg-8 3))) (let ((e-20 (vector-ref arg-8 5))) (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-3 e-18))) (cond ((equal? sc4 1) (CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-20))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((3) (let ((e-8 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((3) (let ((e-23 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 5))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-23))) (cond ((equal? sc4 1) (CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-26))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((8) (let ((e-14 (vector-ref arg-7 2))) (lambda (clam-1) (case (vector-ref arg-8 0) ((8) (let ((e-29 (vector-ref arg-8 2))) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-14 e-29))) (cond ((equal? sc4 1) (vector 1 (box '()))) (else (vector 1 '()))))))(else (vector 1 (box '())))))))(else (lambda (eta-0) (vector 1 (box '()))))))))))(else (case (vector-ref arg-7 0) ((2) (let ((e-3 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((2) (let ((e-18 (vector-ref arg-8 3))) (let ((e-20 (vector-ref arg-8 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-3 e-18))) (cond ((equal? sc3 1) (CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-20))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((3) (let ((e-8 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((3) (let ((e-23 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 5))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-23))) (cond ((equal? sc3 1) (CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-26))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((8) (let ((e-14 (vector-ref arg-7 2))) (lambda (clam-2) (case (vector-ref arg-8 0) ((8) (let ((e-29 (vector-ref arg-8 2))) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-14 e-29))) (cond ((equal? sc3 1) (vector 1 (box '()))) (else (vector 1 '()))))))(else (vector 1 (box '())))))))(else (lambda (eta-0) (vector 1 (box '()))))))))))(else (case (vector-ref arg-7 0) ((2) (let ((e-3 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((2) (let ((e-18 (vector-ref arg-8 3))) (let ((e-20 (vector-ref arg-8 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-3 e-18))) (cond ((equal? sc2 1) (CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-20))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((3) (let ((e-8 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((3) (let ((e-23 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 5))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-23))) (cond ((equal? sc2 1) (CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-11) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-26))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((8) (let ((e-14 (vector-ref arg-7 2))) (lambda (clam-3) (case (vector-ref arg-8 0) ((8) (let ((e-29 (vector-ref arg-8 2))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-14 e-29))) (cond ((equal? sc2 1) (vector 1 (box '()))) (else (vector 1 '()))))))(else (vector 1 (box '())))))))(else (lambda (eta-0) (vector 1 (box '())))))))))
(define CoreC-45Coverage-n--7773-2933-u--conflictArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-7) (if (null? arg-8) (vector 1 (box '())) (vector 1 (box '()))) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (if (null? arg-8) (vector 1 (box '())) (let ((e-6 (car arg-8))) (let ((e-7 (cdr arg-8))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-5 arg-0 arg-4 e-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-5 '() arg-4 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Coverage-n--7773-2934-u--conflictNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-8) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (if (null? e-9) (vector 1 '()) (let ((e-1 (unbox e-9))) (let ((act-27 ((CoreC-45Coverage-n--7773-2933-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-7) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (if (null? e-10) (vector 1 '()) (let ((e-4 (unbox e-10))) (vector 1 (box (PreludeC-45TypesC-45List-tailRecAppend e-1 e-4))))))))))))))))))))))))))))))))
(define CoreC-45Coverage-n--7268-2483-u--conflictArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 0 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-6))) (cond ((equal? sc3 1) (CoreC-45Coverage-n--7268-2482-u--conflictTm arg-0 arg-1 arg-2 arg-3 arg-5 e-7)) (else 0))))) (cond ((equal? sc2 1) 1) (else (CoreC-45Coverage-n--7268-2483-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)))))))))))
(define CoreC-45Coverage-n--10661-5564-u--close (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (CoreC-45TTC-45SubstEnv-substs (CoreC-45Coverage-n--10661-5563-u--mkSubstEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 arg-7) arg-8)))
(define CoreC-45Coverage-n--7268-2480-u--clash (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((1) (let ((e-2 (vector-ref arg-4 2))) (case (vector-ref e-2 0) ((2) (let ((e-14 (vector-ref e-2 1))) (case (vector-ref arg-5 0) ((1) (let ((e-20 (vector-ref arg-5 2))) (case (vector-ref e-20 0) ((2) (let ((e-22 (vector-ref e-20 1))) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-14 e-22)))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2)))(else 0))))))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2)))(else 0)))))) ((3) (let ((e-16 (vector-ref e-2 1))) (case (vector-ref arg-5 0) ((1) (let ((e-26 (vector-ref arg-5 2))) (case (vector-ref e-26 0) ((3) (let ((e-28 (vector-ref e-26 1))) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-16 e-28)))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2)))(else 0))))))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2)))(else 0))))))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-2)))(else 0)))))) ((9) (let ((e-6 (vector-ref arg-4 2))) (case (vector-ref arg-5 0) ((9) (let ((e-32 (vector-ref arg-5 2))) (CoreC-45TT-u--C-47C-61_Eq_Constant e-6 e-32))) ((1) (let ((e-35 (vector-ref arg-5 2))) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-35)))) ((11) 1)(else 0)))) ((11) (case (vector-ref arg-5 0) ((1) (let ((e-41 (vector-ref arg-5 2))) (DataC-45Maybe-isJust (CoreC-45TT-isCon e-41)))) ((9) 1)(else 0)))(else 0))))
(define CoreC-45Coverage-n--9736-4689-u--buildArgsAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (lambda (clam-0) (if (null? arg-14) (vector 1 '()) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 2))) (let ((act-24 ((CoreC-45Coverage-n--9736-4688-u--buildArgAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Coverage-n--9736-4689-u--buildArgsAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (CoreC-45Coverage-addNot arg-3 arg-0 e-6 arg-13) e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-10))))))))))))(else (let ((act-24 ((CoreC-45Coverage-n--9736-4688-u--buildArgAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Coverage-n--9736-4689-u--buildArgsAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6))))))))))))))))))
(define CoreC-45Coverage-n--9736-4688-u--buildArgAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((0) (let ((e-1 (vector-ref arg-14 1))) (let ((e-2 (vector-ref arg-14 2))) (let ((e-3 (vector-ref arg-14 3))) (let ((e-4 (vector-ref arg-14 4))) (let ((u--l (CoreC-45TTC-45SizeOf-mkSizeOf e-3))) (let ((u--con (vector 1 arg-11 (vector 2 e-2 u--l) e-1))) (let ((u--psC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-substName arg-4 (CoreC-45TT-apply arg-11 u--con (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 1 arg-11 (vector 0 ) eta-1)) e-3)) eta-0)) arg-7))) (CoreC-45Coverage-buildArgs arg-12 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-11 arg-10 (CoreC-45Coverage-weakenNs u--l (cons (cons arg-3 e-2) arg-9)) (CoreC-45Coverage-weakenNs u--l arg-13) u--psC-39 e-4))))))))) ((1) (let ((e-6 (vector-ref arg-14 1))) (let ((e-7 (vector-ref arg-14 2))) (let ((e-8 (vector-ref arg-14 3))) (let ((u--l (CoreC-45TTC-45SizeOf-mkSizeOf (cons e-6 (cons e-7 '()))))) (let ((u--psC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-substName arg-4 (vector 7 arg-11 2 (vector 1 arg-11 (vector 0 ) e-6) (vector 1 arg-11 (vector 0 ) e-7)) eta-0)) arg-7))) (CoreC-45Coverage-buildArgs arg-12 (cons e-6 (cons e-7 arg-0)) arg-11 arg-10 (CoreC-45Coverage-weakenNs u--l arg-9) (CoreC-45Coverage-weakenNs u--l arg-13) u--psC-39 e-8))))))) ((2) (let ((e-10 (vector-ref arg-14 1))) (let ((e-11 (vector-ref arg-14 2))) (let ((u--psC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-substName arg-4 (vector 9 arg-11 e-10) eta-0)) arg-7))) (CoreC-45Coverage-buildArgs arg-12 arg-0 arg-11 arg-10 arg-9 arg-13 u--psC-39 e-11))))) (else (let ((e-13 (vector-ref arg-14 1))) (CoreC-45Coverage-buildArgs arg-12 arg-0 arg-11 arg-10 arg-9 arg-13 arg-7 e-13))))))
(define CoreC-45Coverage-weakenNs (lambda (arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (cons (cons (CoreC-45TT-u--weakenNs_Weaken_Var arg-3 e-6) e-7) (CoreC-45Coverage-weakenNs arg-3 e-3)))))))))
(define CoreC-45Coverage-tagIsNot (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((sc1 (PreludeC-45Types-elem (csegen-225) e-2 arg-1))) (cond ((equal? sc1 1) 0) (else 1))))) ((2) 1) ((1) 1) (else 0))))
(define CoreC-45Coverage-replaceDefaults (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((8) (vector 1 arg-5)) ((10) (vector 1 arg-5))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Coverage-n--9637-4607-u--rep arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 eta-0 eta-1))) arg-5 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45Coverage-n--9637-4608-u--dropRep arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))))))
(define CoreC-45Coverage-match (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) 1) ((1) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (case (vector-ref e-15 0) ((0) 1)(else (case (vector-ref arg-2 0) ((1) (let ((e-48 (vector-ref arg-2 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-16 e-48)))(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))) ((4) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-51 (vector-ref arg-2 2))) (let ((e-52 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Coverage-match e-19 e-51))) (cond ((equal? sc2 1) (CoreC-45Coverage-match e-20 e-52)) (else 0))))))(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))) ((5) (let ((e-25 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((5) (let ((e-57 (vector-ref arg-2 4))) (CoreC-45Coverage-match e-25 e-57)))(else (CoreC-45Coverage-match e-25 arg-2))))) ((6) (let ((e-29 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-61 (vector-ref arg-2 3))) (CoreC-45Coverage-match e-29 e-61)))(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))) ((7) (let ((e-34 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-66 (vector-ref arg-2 4))) (CoreC-45Coverage-match e-34 e-66)))(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))) ((8) (let ((e-38 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-70 (vector-ref arg-2 3))) (CoreC-45Coverage-match e-38 e-70)))(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))) ((9) (let ((e-41 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-73 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-41 e-73)))(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))
(define CoreC-45Coverage-isEmpty (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((e-5 (vector-ref arg-4 5))) (let ((act-24 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (if (null? e-6) (vector 1 0) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((6) (let ((e-11 (vector-ref e-7 5))) (let ((e-9 (vector-ref e-7 7))) (let ((sc4 (let ((e-15 (cdr e-11))) e-15))) (cond ((equal? sc4 1) (vector 1 0)) (else (CoreC-45Core-allM (lambda (eta-0) (lambda (eta-1) (CoreC-45Coverage-conflict arg-0 arg-1 arg-2 arg-3 (vector 3 e-1 e-2 e-3 e-4 e-5) eta-0 eta-1))) e-9 ext-0)))))))(else (vector 1 0)))))))))))))))(else (vector 1 0)))))
(define CoreC-45Coverage-getNonCoveringRefs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((u--ds (DataC-45List-mapMaybe (lambda (eta-0) (CoreC-45Coverage-n--10071-5010-u--noAssert arg-2 arg-1 arg-0 eta-0)) (LibrariesC-45DataC-45NameMap-toList (CoreC-45ContextC-45Context-refersTo e-1))))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-0 (csegen-46) eta-0 eta-1))) u--ds '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--cases (DataC-45List-filter (lambda (eta-0) (CoreC-45Coverage-n--10071-5009-u--isCase arg-2 arg-1 arg-0 eta-0)) e-7))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Coverage-getNonCoveringRefs arg-0 arg-1 eta-0 eta-1))) u--cases '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-filterM (lambda (eta-0) (lambda (eta-1) (CoreC-45Coverage-n--10071-5011-u--notCovering arg-2 arg-1 arg-0 e-5 eta-0 eta-1))) u--ds ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 (PreludeC-45Interfaces-concat (csegen-50) e-8)))))))))))))))))))))))))))))
(define CoreC-45Coverage-getMissingAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((8) (let ((e-2 (vector-ref arg-4 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((27) (let ((sc2 (DataC-45List-isNil arg-5))) (cond ((equal? sc2 1) (csegen-2108)) (else (vector 1 '())))))(else (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Looking for missing alts at type " (CoreC-45TT-u--show_Show_Constant e-2))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((sc2 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CoreC-45CaseC-45CaseTree-isDefault eta-0)) arg-5))) (cond ((equal? sc2 1) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "Found default") clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 '()))))) (else (csegen-2108)))))))))))) ((10) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Looking for missing alts at type Type") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((sc2 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-1) (CoreC-45CaseC-45CaseTree-isDefault eta-1)) arg-5))) (cond ((equal? sc2 1) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "Found default") eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '()))))) (else (csegen-2108)))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Getting constructors for: " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-1 arg-4))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Normalise-logNF arg-1 arg-0 "coverage.missing" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "Getting constructors for") (CoreC-45Env-mkEnv arg-2 arg-1) arg-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45CaseC-45Util-getCons arg-0 arg-1 arg-3 arg-4 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (DataC-45List-filter (lambda (eta-1) (CoreC-45Coverage-n--8954-4172-u--noneOf arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 arg-5 eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45CaseC-45Util-mkAlt arg-1 arg-2 (vector 2 "Coverage check") eta-1)) e-7))))))))))))))))))
(define CoreC-45Coverage-getMissing (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--psIn (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 arg-2 (vector 0 ) eta-0)) arg-0))) (let ((act-25 ((CoreC-45Coverage-buildArgs arg-1 arg-0 arg-2 e-5 '() '() u--psIn arg-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--pats (PreludeC-45Interfaces-concat (csegen-50) e-6))) (let ((act-26 (let ((sc2 ((PreludeC-45Types-u--null_Foldable_List u--pats)))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "coverage.missing" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (LibrariesC-45DataC-45StringC-45Extra-unlines e-7)))))) (PreludeC-45Basics-flip (csegen-1822) u--pats (lambda (u--pat) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7)))))) (lambda (eta-2) (CoreC-45Context-toFullNames arg-1 (csegen-76) u--pat eta-2)) eta-1)))) eta-0)) ext-0)))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-apply arg-2 (vector 1 arg-2 (vector 1 ) arg-3) eta-0)) e-6)))))))))))))))))
(define CoreC-45Coverage-findTag (lambda (arg-2 arg-3 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45TT-sameVar arg-2 e-6))) (cond ((equal? sc2 1) (box e-7)) (else (CoreC-45Coverage-findTag arg-2 arg-3 e-3)))))))))))
(define CoreC-45Coverage-eraseApps (lambda (arg-1 arg-2) (CoreC-45Coverage-case--eraseApps-5450 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-2))))
(define CoreC-45Coverage-conflictMatch (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Coverage-n--7268-2483-u--conflictArgs arg-0 e-6 e-7 e-3 e-6 e-7 e-3))) (cond ((equal? sc2 1) 1) (else (CoreC-45Coverage-conflictMatch arg-0 e-3)))))))))))
(define CoreC-45Coverage-conflict (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref arg-2 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (let ((_-0 (box e-1))) ((CoreC-45Coverage-case--caseC-32blockC-32inC-32conflict-3522 arg-0 arg-5 arg-4 arg-3 arg-2 arg-1 e-1 _-0 (cons (let ((e-17 (vector-ref e-1 17))) e-17) (let ((e-2 (vector-ref e-1 2))) e-2))) ext-0))))))))))
(define CoreC-45Coverage-clauseMatches (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45Coverage-eraseApps arg-1 (CoreC-45Coverage-n--10661-5564-u--close arg-0 arg-4 arg-3 arg-2 arg-1 arg-0 (CoreC-45TT-getLoc arg-3) arg-2 arg-3)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--lhs e-5)) (let ((act-25 (CoreC-45Context-toResolvedNames arg-1 (csegen-76) u--lhs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-toResolvedNames arg-1 (csegen-76) arg-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45Coverage-match e-6 e-7)))))))))))))))))
(define CoreC-45Coverage-checkMatched (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm '() arg-0 "coverage" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Checking coverage for") arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-76) arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "coverage" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(raw term: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-6) ")")))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45Coverage-eraseApps arg-0 arg-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-logTerm '() arg-0 "coverage" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Erased to") e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "coverage" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-0) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-0 (csegen-2112) eta-1 eta-2))) arg-1 '() eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Against clauses:\xa;" (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45ContextC-45Context-u--show_Show_Clause eta-1))) e-9))))))))))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else ((CoreC-45Coverage-n--10751-5650-u--tryClauses arg-2 arg-1 arg-0 arg-1 e-7) ext-0)))))))))))))))))))
(define CoreC-45Coverage-buildArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (let ((u--fenv (CoreC-45Env-mkEnv arg-2 arg-1))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-3 u--fenv e-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Coverage-replaceDefaults arg-0 arg-1 arg-2 arg-3 e-6 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Coverage-getMissingAlts arg-0 arg-1 arg-2 arg-3 e-6 e-7) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-26 1))) (let ((u--altsC-39 (PreludeC-45TypesC-45List-tailRecAppend e-7 e-8))) (let ((u--altsK (PreludeC-45Types-maybe (lambda () u--altsC-39) (lambda () (lambda (u--t) (DataC-45List-filter (lambda (eta-1) (CoreC-45CaseC-45Util-tagIs u--t eta-1)) u--altsC-39))) (CoreC-45Coverage-findTag e-2 arg-1 arg-4)))) (let ((u--altsN (PreludeC-45Types-maybe (lambda () u--altsK) (lambda () (lambda (u--ts) (DataC-45List-filter (lambda (eta-1) (CoreC-45Coverage-tagIsNot u--ts eta-1)) u--altsK))) (CoreC-45Coverage-findTag e-2 arg-1 arg-5)))) ((CoreC-45Coverage-n--9736-4689-u--buildArgsAlt arg-1 e-5 e-4 e-2 e-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 arg-5 u--altsN) eta-0))))))))))))))))))))))) ((1) (lambda (eta-0) (vector 1 '()))) ((2) (lambda (eta-0) (vector 1 (cons arg-6 '())))) (else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45Coverage-altMatch (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) 1)(else (case (vector-ref arg-1 0) ((1) (case (vector-ref arg-2 0) ((1) 1)(else 0))) ((0) (let ((e-6 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((0) (let ((e-18 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 e-18)))(else 0)))) ((2) (let ((e-10 (vector-ref arg-1 1))) (case (vector-ref arg-2 0) ((2) (let ((e-22 (vector-ref arg-2 1))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-10 e-22)))(else 0))))(else 0))))))
(define CoreC-45Coverage-addNot (lambda (arg-1 arg-2 arg-4 arg-5) (if (null? arg-5) (cons (cons arg-1 (cons arg-4 '())) '()) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45TT-sameVar arg-1 e-6))) (cond ((equal? sc2 1) (cons (cons e-6 (cons arg-4 e-7)) e-3)) (else (cons (cons e-6 e-7) (CoreC-45Coverage-addNot arg-1 arg-2 arg-4 e-3))))))))))))
(define CoreC-45CaseC-45Util-n--6601-9359-u--emptyRHSalt (lambda (arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (vector 0 e-1 e-2 e-3 (CoreC-45CaseC-45Util-emptyRHS arg-6 e-4))))))) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (vector 1 e-6 e-7 (CoreC-45CaseC-45Util-emptyRHS arg-6 e-8)))))) ((2) (let ((e-10 (vector-ref arg-7 1))) (let ((e-11 (vector-ref arg-7 2))) (vector 2 e-10 (CoreC-45CaseC-45Util-emptyRHS arg-6 e-11))))) (else (let ((e-13 (vector-ref arg-7 1))) (vector 3 (CoreC-45CaseC-45Util-emptyRHS arg-6 e-13)))))))
(define CoreC-45CaseC-45Util-n--6339-9139-u--addTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-8 (let ((e-0 (vector-ref arg-6 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((5) (let ((e-26 (vector-ref e-17 1))) (let ((e-25 (vector-ref e-17 2))) (vector 1 (box (vector arg-8 e-26 e-25))))))(else (vector 1 '()))))))))))))
(define CoreC-45CaseC-45Util-tagIs (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 e-2))) ((2) 0) ((1) 0) (else 1))))
(define CoreC-45CaseC-45Util-mkAlt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (vector 0 e-0 e-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 2 "m" eta-0)) (PreludeC-45Types-take e-2 (PreludeC-45Types-u--rangeFrom_Range_C-36a (csegen-219) (blodwen-toSignedInt 0 63)))) (CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree (CoreC-45TTC-45SizeOf-map (CoreC-45TTC-45SizeOf-take e-2)) (CoreC-45CaseC-45Util-emptyRHS arg-1 arg-2))))))))
(define CoreC-45CaseC-45Util-getCons (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Called `getCons` on something that is not a Type constructor") ext-0) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((6) (let ((e-8 (vector-ref e-7 7))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45CaseC-45Util-n--6339-9139-u--addTy arg-1 e-1 e-3 e-4 e-5 e-2 arg-2 arg-0 eta-0 eta-1))) e-8 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-16 (vector-ref act-25 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-25 1))) (vector 1 (DataC-45List-catMaybes e-16))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Called `getCons` on something that is not a Type constructor") ext-0)))))))))))))))(else (vector 1 '())))))
(define CoreC-45CaseC-45Util-emptyRHS (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (vector 0 e-1 e-2 e-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45Util-n--6601-9359-u--emptyRHSalt e-1 e-5 e-4 e-2 arg-1 eta-0)) e-5))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (vector 1 e-7 (vector 10 arg-1 0))))(else arg-2))))
(define TTImpC-45ElabC-45Hole-mkPrecise (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 2))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 2))) (CoreC-45Context-updateDef arg-1 (vector 8 e-6) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((7) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-4 (vector-ref lcase-0 2))) (box (vector 7 e-0 (let ((e-9 (car e-4))) (cons e-9 1)))))))(else '()))) clam-0)))(else (vector 1 0)))))(else (vector 1 0))))))
(define TTImpC-45ElabC-45Hole-checkHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (if (null? arg-11) (let ((act-24 (CoreC-45UnifyState-genName arg-1 arg-3 (PreludeC-45TypesC-45String-C-43C-43 "type_of_" (CoreC-45Name-u--show_Show_UserName arg-10)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--envC-39 (CoreC-45Env-letToLam arg-8))) (let ((act-25 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-9 (csegen-21) u--envC-39 e-5 (vector 11 arg-9) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-inCurrentNS arg-1 (vector 1 arg-10) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-8 u--envC-39 e-6) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) ((TTImpC-45ElabC-45Hole-mkPrecise arg-1 e-9) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((CoreC-45Context-lookupCtxtExact e-7 (let ((e-0 (vector-ref e-8 0))) e-0)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (if (null? e-10) (let ((act-30 (TTImpC-45ElabC-45Check-metaVarI arg-0 arg-1 arg-3 arg-9 arg-5 u--envC-39 e-7 e-6 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((e-2 (car e-11))) (let ((e-3 (cdr e-11))) (let ((act-31 (CoreC-45Metadata-withCurrentLHS arg-1 arg-2 (vector 8 e-2) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (CoreC-45Metadata-addNameLoc arg-2 arg-1 arg-9 e-7 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 (CoreC-45Context-addUserHole arg-1 0 e-7 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((act-34 (TTImpC-45ElabC-45Check-saveHole arg-4 e-7 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (vector 1 (cons e-3 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-8 e-6))))))))))))))))))))) (let ((act-30 (CoreC-45ContextC-45Log-log arg-1 "elab.hole" (+ 1 0) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-7) " already defined")) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 arg-9 e-7) ext-0))))))))))))))))))))))))))))) (let ((e-1 (unbox arg-11))) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 (vector 1 arg-10) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (let ((act-27 ((CoreC-45NormaliseC-45Eval-getTerm e-1) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--envC-39 (CoreC-45Env-letToLam arg-8))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVarI arg-0 arg-1 arg-3 arg-9 arg-5 u--envC-39 e-5 e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-1) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) ((TTImpC-45ElabC-45Hole-mkPrecise arg-1 e-10) ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (CoreC-45Metadata-withCurrentLHS arg-1 arg-2 (vector 8 e-2) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (CoreC-45Metadata-addNameLoc arg-2 arg-1 arg-9 e-5 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (CoreC-45Context-addUserHole arg-1 0 e-5 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 (TTImpC-45ElabC-45Check-saveHole arg-4 e-5 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (vector 1 (cons e-3 e-1)))))))))))))))))))))))))))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "elab.hole" (+ 1 0) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) " already defined")) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 arg-9 e-5) ext-0)))))))))))))))))))))
(define TTImpC-45ElabC-45Dot-case--checkDot-8321 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (case (vector-ref arg-14 0) ((1) (let ((act-24 ((TTImpC-45ElabC-45Check-check arg-0 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (vector (vector 2 ) e-1 e-2 e-3 e-4 e-5)))))) arg-6 arg-5 arg-2 (box arg-1)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (TTImpC-45ElabC-45Dot-registerDot arg-0 arg-13 arg-12 arg-11 arg-10 arg-8 arg-5 arg-4 arg-3 e-2 arg-1 ext-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "Dot pattern not valid here (Not LHS) " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-2))) ext-0)))))
(define TTImpC-45ElabC-45Dot-registerDot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (CoreC-45UnifyState-genName arg-1 arg-3 "dotTm" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm arg-10) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-7 arg-5 arg-6 e-5 e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-addDot arg-0 arg-1 arg-3 arg-7 arg-6 e-5 arg-9 arg-8 e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (cons e-7 arg-10)))))))))))))))))))
(define TTImpC-45ElabC-45Dot-checkDot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 (PreludeC-45TypesC-45String-C-43C-43 "Dot pattern not valid here (unknown type) " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-12))) eta-0)) (let ((e-2 (unbox arg-13))) (lambda (eta-0) (TTImpC-45ElabC-45Dot-case--checkDot-8321 arg-0 e-2 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref arg-7 0))) e-0) eta-0))))))
(define TTImpC-45ElabC-45Case-case--checkCaseC-44guessScrType-11695 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-19 0) ((0) (let ((e-2 (vector-ref arg-19 2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-14))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyName e-2 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) ((TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-18) eta-0) (let ((e-4 (car e-6))) (let ((e-3 (cdr e-6))) (if (null? e-4) ((TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-18) eta-0) (let ((e-7 (cdr e-4))) (if (null? e-7) ((TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-18) eta-0) (let ((e-10 (cdr e-7))) (if (null? e-3) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-14 '() e-5 '() e-10) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) ((TTImpC-45ElabC-45Case-n--14503-11424-u--getRetTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-5 e-11) eta-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (if (null? e-11) ((TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-18) eta-0) (let ((e-12 (unbox e-11))) (if (null? e-12) ((TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-18) eta-0) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) ((TTImpC-45ElabC-45Case-n--14503-11423-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-5 (vector 0 arg-5 e-14) e-13) eta-0)))))))))) ((TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-18) eta-0))))))))))))))))))))(else (TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-18)))))
(define TTImpC-45ElabC-45Case-n--11735-9148-u--usedIn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-17 0) ((17) (let ((e-2 (vector-ref arg-17 2))) (cons (vector 1 (vector 0 e-2)) '()))) ((8) (let ((e-5 (vector-ref arg-17 2))) (let ((e-6 (vector-ref arg-17 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45ElabC-45Case-n--11735-9148-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-5) (TTImpC-45ElabC-45Case-n--11735-9148-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-6))))) ((18) (let ((e-11 (vector-ref arg-17 4))) (let ((e-12 (vector-ref arg-17 5))) (cons e-11 (TTImpC-45ElabC-45Case-n--11735-9148-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-12))))) ((13) (let ((e-16 (vector-ref arg-17 3))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (TTImpC-45ElabC-45Case-n--11735-9148-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 eta-0)) e-16)))(else '()))))
(define TTImpC-45ElabC-45Case-n--11735-9151-u--updateClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (case (vector-ref arg-21 0) ((0) (let ((e-1 (vector-ref arg-21 1))) (let ((e-2 (vector-ref arg-21 2))) (let ((e-3 (vector-ref arg-21 3))) (let ((sc1 (TTImpC-45ElabC-45Case-n--11735-9145-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-0 0 arg-20 (TTImpC-45ElabC-45Case-n--11735-9148-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-2)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((u--argsC-39 (TTImpC-45ElabC-45Case-n--11735-9147-u--mkSplit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 e-2 e-4))) (let ((u--lhsC-39 (TTImpC-45TTImp-apply (vector 0 e-1 arg-17) u--argsC-39))) (vector 0 e-1 (TTImpC-45ElabC-45Case-n--11735-9150-u--applyNested arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-19 u--lhsC-39) (TTImpC-45ElabC-45Case-bindCaseLocals e-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Case-getNestData eta-0)) arg-19) e-5 e-3))))))))))) ((1) (let ((e-5 (vector-ref arg-21 1))) (let ((e-6 (vector-ref arg-21 2))) (let ((e-7 (vector-ref arg-21 3))) (let ((e-8 (vector-ref arg-21 4))) (let ((e-9 (vector-ref arg-21 5))) (let ((e-10 (vector-ref arg-21 6))) (let ((sc1 (TTImpC-45ElabC-45Case-n--11735-9145-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-0 0 arg-20 (TTImpC-45ElabC-45Case-n--11735-9148-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-6)))) (let ((e-3 (cdr sc1))) (let ((u--argsC-39 (TTImpC-45ElabC-45Case-n--11735-9147-u--mkSplit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 e-6 e-3))) (let ((u--lhsC-39 (TTImpC-45TTImp-apply (vector 0 e-5 arg-17) u--argsC-39))) (vector 1 e-5 (TTImpC-45ElabC-45Case-n--11735-9150-u--applyNested arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-19 u--lhsC-39) e-7 e-8 e-9 e-10)))))))))))) (else (let ((e-12 (vector-ref arg-21 1))) (let ((e-13 (vector-ref arg-21 2))) (let ((sc1 (TTImpC-45ElabC-45Case-n--11735-9145-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-0 0 arg-20 (TTImpC-45ElabC-45Case-n--11735-9148-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-13)))) (let ((e-3 (cdr sc1))) (let ((u--argsC-39 (TTImpC-45ElabC-45Case-n--11735-9147-u--mkSplit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 e-13 e-3))) (let ((u--lhsC-39 (TTImpC-45TTImp-apply (vector 0 e-12 arg-17) u--argsC-39))) (vector 2 e-12 (TTImpC-45ElabC-45Case-n--11735-9150-u--applyNested arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-19 u--lhsC-39))))))))))))
(define TTImpC-45ElabC-45Case-n--11735-9146-u--replace (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (cond ((equal? arg-17 0) (if (null? arg-19) arg-19 (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((u--lhsC-39 (case (vector-ref e-2 0) ((18) (let ((e-1 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-6 (vector-ref e-2 3))) (let ((e-4 (vector-ref e-2 4))) (vector 18 e-1 e-7 e-6 e-4 arg-18))))))(else arg-18)))) (cons u--lhsC-39 e-3))))))(else (let ((e-0 (- arg-17 1))) (if (null? arg-19) arg-19 (let ((e-5 (car arg-19))) (let ((e-6 (cdr arg-19))) (cons e-5 (TTImpC-45ElabC-45Case-n--11735-9146-u--replace arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-0 arg-18 e-6))))))))))
(define TTImpC-45ElabC-45Case-n--11735-9149-u--nestLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 arg-19) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons e-2 (TTImpC-45TTImp-apply (vector 0 arg-18 (DataC-45Maybe-fromMaybe (lambda () e-2) e-6)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 32 arg-18 0)) e-10))))))))))
(define TTImpC-45ElabC-45Case-n--11735-9147-u--mkSplit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 arg-19 arg-20) (if (null? arg-18) (PreludeC-45TypesC-45List-reverse (cons arg-19 arg-20)) (let ((e-2 (unbox arg-18))) (PreludeC-45TypesC-45List-reverse (TTImpC-45ElabC-45Case-n--11735-9146-u--replace arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-2 arg-19 arg-20))))))
(define TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (lambda (eta-0) (vector 1 (vector 32 arg-5 0))) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (TTImpC-45ElabC-45Case-case--checkCaseC-44guessScrType-11695 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-5 e-7 e-6 e-3 (TTImpC-45TTImp-getFn e-6))))))(else (TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-3))))))))
(define TTImpC-45ElabC-45Case-n--14503-11424-u--getRetTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (lambda (clam-0) (case (vector-ref arg-16 0) ((0) (let ((e-1 (vector-ref arg-16 1))) (let ((e-3 (vector-ref arg-16 3))) (let ((e-4 (vector-ref arg-16 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (((e-4 arg-15) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Case-n--14503-11424-u--getRetTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-5) clam-0))))))(else (vector 1 '()))))))) ((3) (let ((e-7 (vector-ref arg-16 2))) (let ((act-24 (CoreC-45Context-lookupTyExact e-7 (let ((e-0 (vector-ref arg-15 0))) e-0) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-14 '() arg-15 '() e-1) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-25 1))) (vector 1 (box (cons e-7 e-11)))))))))))))))(else (vector 1 '()))))))
(define TTImpC-45ElabC-45Case-n--11599-9025-u--getNameFrom (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((sc0 (TTImpC-45ElabC-45Case-n--11599-9024-u--getArg arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-6 arg-8))) (if (null? sc0) arg-1 (let ((e-2 (unbox sc0))) e-2)))))
(define TTImpC-45ElabC-45Case-n--11735-9144-u--getBindName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-18 0) ((1) (let ((e-0 (vector-ref arg-18 1))) (let ((u--n (vector 1 e-0))) (let ((sc1 (PreludeC-45Types-elem (csegen-802) u--n arg-19))) (cond ((equal? sc1 1) (cons u--n (vector 2 (CoreC-45Name-displayUserName e-0) arg-17))) (else (cons u--n u--n)))))))(else (let ((sc0 (PreludeC-45Types-elem (csegen-802) arg-18 arg-19))) (cond ((equal? sc0 1) (cons arg-18 (vector 2 "_cn" arg-17))) (else (cons arg-18 arg-18))))))))
(define TTImpC-45ElabC-45Case-n--11599-9024-u--getArg (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (if (null? e-2) (cond ((equal? arg-9 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-4 (- arg-9 1))) (TTImpC-45ElabC-45Case-n--11599-9024-u--getArg arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 e-4)))) (let ((e-8 (cdr e-2))) (cond ((equal? arg-9 0) (box e-8))(else (cond ((equal? arg-9 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-4 (- arg-9 1))) (TTImpC-45ElabC-45Case-n--11599-9024-u--getArg arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 e-4)))))))))))))
(define TTImpC-45ElabC-45Case-n--14503-11422-u--checkConcrete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-16) (lambda (clam-0) (case (vector-ref arg-16 0) ((1) (let ((e-2 (vector-ref arg-16 2))) (case (vector-ref e-2 0) ((2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-5 "Can't infer type for case scrutinee") clam-0))(else (vector 1 0)))))(else (vector 1 0))))))
(define TTImpC-45ElabC-45Case-n--14503-11423-u--applyTo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-17 0) ((0) (let ((e-1 (vector-ref arg-17 1))) (let ((e-2 (vector-ref arg-17 2))) (let ((e-3 (vector-ref arg-17 3))) (let ((e-4 (vector-ref arg-17 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((1) (let ((act-24 (((e-4 arg-15) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Case-n--14503-11423-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (vector 8 e-1 arg-16 (vector 32 e-1 0)) e-5) clam-0))))))(else (let ((act-24 (((e-4 arg-15) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-5 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Case-n--14503-11423-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (vector 10 arg-5 arg-16 e-2 (vector 32 arg-5 0)) e-5) clam-0)))))))))(else (vector 1 arg-16)))))))))(else (lambda (eta-0) (vector 1 arg-16))))))
(define TTImpC-45ElabC-45Case-n--11735-9150-u--applyNested (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((u--fc (TTImpC-45TTImp-getFC arg-18))) (TTImpC-45Utils-substNames '() (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Case-n--11735-9149-u--nestLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 u--fc eta-0)) arg-17) arg-18))))
(define TTImpC-45ElabC-45Case-n--11735-9145-u--addEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (if (null? arg-17) (cons '() '()) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((e-9 (cdr arg-19))) (let ((u--n (TTImpC-45ElabC-45Case-n--11735-9144-u--getBindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 e-2 arg-20))) (let ((sc2 (TTImpC-45ElabC-45Case-n--11735-9145-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-3 (bs+ arg-18 1 63) e-9 (cons (Builtin-snd u--n) arg-20)))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (let ((u--nsC-39 (cons u--n e-5))) (cons u--nsC-39 (cons (vector 18 arg-9 (vector 2 ) 0 (Builtin-snd u--n) (vector 32 arg-9 1)) e-4)))))))))))))
(define TTImpC-45ElabC-45Case-updateMults (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (TTImpC-45ElabC-45Case-updateMults e-3 (TTImpC-45ElabC-45Case-toRig0 e-2 arg-2)))))))
(define TTImpC-45ElabC-45Case-toRig1 (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) (CoreC-45TT-multiplicity e-4)))) (cond ((equal? sc2 1) (cons (CoreC-45TT-setMultiplicity e-4 (csegen-519)) e-5)) (else (cons e-4 e-5)))))))(else (let ((e-0 (- arg-2 1))) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (cons e-9 (TTImpC-45ElabC-45Case-toRig1 e-0 e-10)))))))))
(define TTImpC-45ElabC-45Case-toRig0 (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (cons (CoreC-45TT-setMultiplicity e-4 (csegen-21)) e-5))))(else (let ((e-0 (- arg-2 1))) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (cons e-9 (TTImpC-45ElabC-45Case-toRig0 e-0 e-10)))))))))
(define TTImpC-45ElabC-45Case-getNestData (lambda (arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons e-2 (cons e-6 e-10)))))))))
(define TTImpC-45ElabC-45Case-findScrutinee (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) '() (let ((e-1 (car arg-0))) (let ((e-2 (cdr arg-0))) (if (null? arg-1) '() (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (case (vector-ref arg-2 0) ((0) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((sc3 (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-10))) (cond ((equal? sc4 1) (let ((sc5 (CoreC-45TT-isLet e-6))) (cond ((equal? sc5 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc3 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45ElabC-45Case-findScrutinee e-2 e-7 (vector 0 e-9 e-10)) (csegen-549))))))))(else '()))))))))))
(define TTImpC-45ElabC-45Case-findImpsIn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref e-8 0) ((0) (TTImpC-45ElabC-45Case-findImpsIn (cons e-2 arg-0) arg-1 (cons e-3 arg-2) (cons (cons e-2 (CoreC-45TT-u--weaken_Weaken_Term e-9)) (PreludeC-45Types-u--map_Functor_List (csegen-2117) arg-3)) e-4))(else (TTImpC-45ElabC-45Case-findImpsIn (cons e-2 arg-0) arg-1 (cons e-3 arg-2) (PreludeC-45Types-u--map_Functor_List (csegen-2117) arg-3) e-4))))))(else (TTImpC-45ElabC-45Case-findImpsIn (cons e-2 arg-0) arg-1 (cons e-3 arg-2) (PreludeC-45Types-u--map_Functor_List (csegen-2117) arg-3) e-4)))))))(else (lambda (clam-0) (let ((sc0 (DataC-45List-isNil arg-3))) (cond ((equal? sc0 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-reverse arg-3)) clam-0)))))))))
(define TTImpC-45ElabC-45Case-explicitPi (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (car arg-1))) (let ((e-4 (cdr arg-1))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 1))) (let ((e-8 (vector-ref e-3 2))) (let ((e-10 (vector-ref e-3 4))) (cons (vector 2 e-7 e-8 (vector 1 ) e-10) (TTImpC-45ElabC-45Case-explicitPi e-4))))))(else (cons e-3 (TTImpC-45ElabC-45Case-explicitPi e-4)))))))))
(define TTImpC-45ElabC-45Case-checkCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (TTImpC-45ElabC-45Delayed-delayElab arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 arg-6 arg-9 arg-14 0 (lambda (eta-0) (let ((act-24 (case (vector-ref arg-12 0) ((32) ((TTImpC-45ElabC-45Case-n--14503-11425-u--guessScrType arg-0 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-13) eta-0))(else (vector 1 arg-12))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (csegen-21) arg-7 arg-8 arg-9 e-5 (box (CoreC-45NormaliseC-45Eval-gType arg-10))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((act-26 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected scrutinee type") e-2 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((u--chrig (let ((sc4 (AlgebraC-45Semiring-isErased (csegen-475) arg-6))) (cond ((equal? sc4 1) (csegen-21)) (else (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "elab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-11) (PreludeC-45TypesC-45String-C-43C-43 " at " (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega u--chrig))))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-1) (let ((act-28 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-2) 1) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--chrig arg-7 arg-8 arg-9 arg-11 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-2))) eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons (Builtin-fst e-9) (cons (Builtin-snd e-9) u--chrig)))))))) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((14) (let ((e-9 (vector-ref lcase-0 3))) (AlgebraC-45Semiring-branchOne (csegen-475) (lambda () (lambda (eta-1) (let ((act-28 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-2) 1) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (csegen-519) arg-7 arg-8 arg-9 arg-11 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-2))) eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (vector 1 (cons (Builtin-fst e-10) (cons (Builtin-snd e-10) (csegen-519)))))))))) (lambda () (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 eta-1))) e-9)))(else (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 eta-1))))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((e-12 (car e-4))) (let ((e-11 (cdr e-4))) (let ((act-29 ((CoreC-45NormaliseC-45Eval-getTerm e-12) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Scrutinee type") arg-9 e-13 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-15 (vector-ref act-31 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-15 arg-9 e-13) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-16 (vector-ref act-32 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-32 1))) ((TTImpC-45ElabC-45Case-n--14503-11422-u--checkConcrete arg-0 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-16) eta-0))))))) (case (vector-ref act-32 0) ((0) (let ((e-16 (vector-ref act-32 1))) (vector 0 e-16))) (else (TTImpC-45ElabC-45Case-caseBlock arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-10 arg-8 arg-9 arg-11 e-10 e-13 e-11 arg-13 arg-14 eta-0)))))))))))))))))))))))))))))))))))))))) ext-0)))
(define TTImpC-45ElabC-45Case-caseBlock (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45ImplicitBind-getToBind arg-0 arg-1 arg-4 arg-3 arg-8 (let ((e-0 (vector-ref arg-7 0))) e-0) (let ((e-1 (vector-ref arg-7 1))) e-1) arg-10 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "elab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Doing a case under unbound implicits " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2101) e-6))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45UnifyState-genVarName arg-1 arg-3 "scr" ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-46) (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((CoreC-45Context-prettyName arg-1 e-9) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (CoreC-45UnifyState-genCaseName arg-1 arg-3 e-10 ext-0))))))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--env (TTImpC-45ElabC-45Case-updateMults (let ((e-12 (vector-ref e-5 11))) e-12) arg-10))) (let ((act-29 (let ((act-29 (unbox arg-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45Context-lookupCtxtExact (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) (let ((e-0 (vector-ref e-10 0))) e-0)) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((u--vis (if (null? e-11) 2 (let ((e-1 (unbox e-11))) (let ((sc8 (CoreC-45TT-u--C-61C-61_Eq_Visibility (let ((e-24 (vector-ref e-1 9))) e-24) 2))) (cond ((equal? sc8 1) 2) (else 0))))))) (let ((u--splitOn (TTImpC-45ElabC-45Case-findScrutinee arg-0 u--env arg-11))) (let ((act-31 (if (null? arg-16) (let ((act-31 (CoreC-45UnifyState-genName arg-1 arg-3 "caseTy" ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-8 (csegen-21) u--env e-12 (vector 11 arg-8) ext-0))))) (let ((e-1 (unbox arg-16))) ((CoreC-45NormaliseC-45Eval-getTerm e-1) ext-0))))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (TTImpC-45ElabC-45ImplicitBind-bindImplicits arg-1 arg-0 arg-8 (let ((e-1 (vector-ref arg-7 1))) e-1) e-10 u--env e-6 e-12 (vector 11 arg-8) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((e-2 (car e-13))) (let ((u--casefnty (CoreC-45Env-abstractFullEnvType arg-0 arg-8 (TTImpC-45ElabC-45Case-allow u--splitOn (TTImpC-45ElabC-45Case-explicitPi u--env)) (PreludeC-45Types-maybe (lambda () (vector 3 arg-8 e-8 (vector 2 arg-8 arg-14 (vector 1 ) arg-13) (CoreC-45TT-u--weaken_Weaken_Term e-2))) (lambda () (lambda (eta-0) e-2)) u--splitOn)))) (let ((act-33 (CoreC-45Normalise-normaliseSizeLimit arg-1 '() e-10 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) '() u--casefnty ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (TTImpC-45ElabC-45Utils-findErased arg-1 e-14 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-34 1))) (let ((e-16 (car e-15))) (let ((act-35 (CoreC-45Normalise-logEnv arg-0 arg-1 "elab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) "Case env" u--env ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-17 (vector-ref act-35 1))) (vector 0 e-17))) (else (let ((act-36 (CoreC-45Normalise-logTermNF '() arg-1 "elab.case" (+ 1 (+ 1 0)) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Case function type: " (CoreC-45Name-u--show_Show_Name e-9))) '() e-14 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-18 (vector-ref act-36 1))) (vector 0 e-18))) (else (let ((act-37 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addToSave arg-1 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-14)) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-19 (vector-ref act-37 1))) (vector 0 e-19))) (else (let ((act-38 (let ((sc16 (DataC-45List-isNil e-6))) (cond ((equal? sc16 1) (vector 1 0)) (else ((TTImpC-45ElabC-45Case-findImpsIn '() arg-8 '() '() e-14) ext-0)))))) (case (vector-ref act-38 0) ((0) (let ((e-20 (vector-ref act-38 1))) (vector 0 e-20))) (else (let ((act-39 (CoreC-45Context-addDef arg-1 e-9 (let ((sc17 (CoreC-45Context-newDef arg-8 e-9 (let ((sc18 (AlgebraC-45Semiring-isErased (csegen-475) arg-6))) (cond ((equal? sc18 1) (csegen-21)) (else (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))) '() e-14 u--vis (vector 0 )))) (let ((e-0 (vector-ref sc17 0))) (let ((e-1 (vector-ref sc17 1))) (let ((e-40 (vector-ref sc17 2))) (let ((e-38 (vector-ref sc17 4))) (let ((e-37 (vector-ref sc17 5))) (let ((e-36 (vector-ref sc17 6))) (let ((e-35 (vector-ref sc17 7))) (let ((e-34 (vector-ref sc17 8))) (let ((e-33 (vector-ref sc17 9))) (let ((e-32 (vector-ref sc17 10))) (let ((e-31 (vector-ref sc17 11))) (let ((e-30 (vector-ref sc17 12))) (let ((e-29 (vector-ref sc17 13))) (let ((e-28 (vector-ref sc17 14))) (let ((e-27 (vector-ref sc17 15))) (let ((e-26 (vector-ref sc17 16))) (let ((e-25 (vector-ref sc17 17))) (let ((e-24 (vector-ref sc17 18))) (let ((e-23 (vector-ref sc17 19))) (let ((e-22 (vector-ref sc17 20))) (let ((e-21 (vector-ref sc17 21))) (vector e-0 e-1 e-40 e-16 e-38 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-22 e-21))))))))))))))))))))))) ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-21 (vector-ref act-39 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-39 1))) (let ((u--tot (DataC-45Maybe-fromMaybe (lambda () 2) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe e-11 (lambda (bind-0) (CoreC-45ContextC-45Context-findSetTotal (let ((e-32 (vector-ref bind-0 11))) e-32))))))) (let ((act-40 (CoreC-45ContextC-45Log-log arg-1 "elab.case" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (DataC-45String-unwords (cons "Setting totality requirement for" (cons (CoreC-45Name-u--show_Show_Name e-9) (cons "to" (cons (CoreC-45TT-u--show_Show_TotalReq u--tot) '())))))) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-22 (vector-ref act-40 1))) (vector 0 e-22))) (else (let ((act-41 (CoreC-45Context-setFlag arg-1 arg-8 (vector 8 e-21) (vector 4 u--tot) ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-23 (vector-ref act-41 1))) (vector 0 e-23))) (else (let ((u--caseRef (vector 1 arg-8 (vector 1 ) (vector 8 e-21)))) (let ((u--applyEnv (CoreC-45UnifyState-applyToFull arg-0 arg-8 u--caseRef u--env))) (let ((u--appTm (PreludeC-45Types-maybe (lambda () (vector 4 arg-8 u--applyEnv arg-12)) (lambda () (lambda (eta-0) u--applyEnv)) u--splitOn))) (let ((u--altsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Case-n--11735-9151-u--updateClause arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 u--splitOn arg-9 u--env eta-0)) arg-15))) (let ((act-42 (CoreC-45ContextC-45Log-log arg-1 "elab.case" (+ 1 (+ 1 0)) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Nested: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2121) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2121) u--d u--x)))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Case-getNestData eta-0)) arg-9)))) ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-24 (vector-ref act-42 1))) (vector 0 e-24))) (else (let ((act-43 (CoreC-45ContextC-45Log-log arg-1 "elab.case" (+ 1 (+ 1 0)) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Generated alts: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1283) u--altsC-39))) ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-25 (vector-ref act-43 1))) (vector 0 e-25))) (else (let ((act-44 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.case" (+ 1 (+ 1 0)) (lambda () "Case application") u--env u--appTm ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-26 (vector-ref act-44 1))) (vector 0 e-26))) (else (let ((u--nestC-39 '())) (let ((act-45 (let ((act-45 (unbox arg-3))) (vector 1 act-45)))) (case (vector-ref act-45 0) ((0) (let ((e-27 (vector-ref act-45 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-45 1))) (let ((u--olddelayed (let ((e-29 (vector-ref e-27 10))) e-29))) (let ((act-46 (let ((act-46 (set-box! arg-3 (let ((e-0 (vector-ref e-27 0))) (let ((e-1 (vector-ref e-27 1))) (let ((e-37 (vector-ref e-27 2))) (let ((e-36 (vector-ref e-27 3))) (let ((e-35 (vector-ref e-27 4))) (let ((e-34 (vector-ref e-27 5))) (let ((e-33 (vector-ref e-27 6))) (let ((e-32 (vector-ref e-27 7))) (let ((e-31 (vector-ref e-27 8))) (let ((e-30 (vector-ref e-27 9))) (let ((e-28 (vector-ref e-27 11))) (vector e-0 e-1 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-30 '() e-28))))))))))))))) (vector 1 act-46)))) (case (vector-ref act-46 0) ((0) (let ((e-28 (vector-ref act-46 1))) (vector 0 e-28))) (else (let ((act-47 ((TTImpC-45ElabC-45Check-processDecl '() arg-1 arg-2 arg-3 arg-5 (cons 1 '()) u--nestC-39 '() (vector 2 arg-8 e-9 u--altsC-39)) ext-0))) (case (vector-ref act-47 0) ((0) (let ((e-29 (vector-ref act-47 1))) (vector 0 e-29))) (else (let ((u--inlineOK (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) 1)) u--splitOn))) (let ((act-48 (cond ((equal? u--inlineOK 1) (CoreC-45Context-setFlag arg-1 arg-8 e-9 (vector 0 ) ext-0)) (else (vector 1 0))))) (case (vector-ref act-48 0) ((0) (let ((e-30 (vector-ref act-48 1))) (vector 0 e-30))) (else (let ((act-49 (let ((act-49 (unbox arg-3))) (vector 1 act-49)))) (case (vector-ref act-49 0) ((0) (let ((e-31 (vector-ref act-49 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-49 1))) (let ((act-50 (let ((act-50 (set-box! arg-3 (let ((e-0 (vector-ref e-31 0))) (let ((e-1 (vector-ref e-31 1))) (let ((e-41 (vector-ref e-31 2))) (let ((e-40 (vector-ref e-31 3))) (let ((e-39 (vector-ref e-31 4))) (let ((e-38 (vector-ref e-31 5))) (let ((e-37 (vector-ref e-31 6))) (let ((e-36 (vector-ref e-31 7))) (let ((e-35 (vector-ref e-31 8))) (let ((e-34 (vector-ref e-31 9))) (let ((e-32 (vector-ref e-31 11))) (vector e-0 e-1 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34 u--olddelayed e-32))))))))))))))) (vector 1 act-50)))) (case (vector-ref act-50 0) ((0) (let ((e-32 (vector-ref act-50 1))) (vector 0 e-32))) (else (vector 1 (cons u--appTm (CoreC-45NormaliseC-45Eval-gnf arg-0 u--env e-2)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Case-bindCaseLocals (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) arg-4 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 6 arg-1 e-6 (DataC-45Maybe-fromMaybe (lambda () e-6) e-10) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Case-n--11599-9025-u--getNameFrom e-6 e-10 e-11 e-3 arg-4 arg-3 arg-1 eta-0)) e-11) (TTImpC-45ElabC-45Case-bindCaseLocals arg-1 e-3 arg-3 arg-4)))))))))))
(define TTImpC-45ElabC-45Case-allow (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (unbox arg-1))) (TTImpC-45ElabC-45Case-toRig1 e-2 arg-2)))))
(define TTImpC-45ElabC-45Binders-n--11726-18717-u--linearErr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-18 0) ((14) (let ((e-2 (vector-ref arg-18 3))) (box e-2))) ((62) (let ((e-6 (vector-ref arg-18 3))) (TTImpC-45ElabC-45Binders-n--11726-18717-u--linearErr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-6))) ((63) (let ((e-9 (vector-ref arg-18 3))) (TTImpC-45ElabC-45Binders-n--11726-18717-u--linearErr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-9))) ((64) (let ((e-12 (vector-ref arg-18 3))) (TTImpC-45ElabC-45Binders-n--11726-18717-u--linearErr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-12))) ((65) (let ((e-15 (vector-ref arg-18 3))) (TTImpC-45ElabC-45Binders-n--11726-18717-u--linearErr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-15)))(else '()))))
(define TTImpC-45ElabC-45Binders-n--10131-17399-u--getRig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-17 0) ((1) arg-11)(else (csegen-21)))))
(define TTImpC-45ElabC-45Binders-n--9923-17203-u--drop (lambda (arg-1 arg-2 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-6 arg-2))) (cond ((equal? sc2 1) (TTImpC-45ElabC-45Binders-n--9923-17203-u--drop arg-1 arg-2 e-3)) (else (cons (cons e-6 e-7) (TTImpC-45ElabC-45Binders-n--9923-17203-u--drop arg-1 arg-2 e-3))))))))))))
(define TTImpC-45ElabC-45Binders-weakenExp (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (unbox arg-3))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (CoreC-45NormaliseC-45Eval-gnf (cons arg-0 arg-1) arg-2 (CoreC-45TT-u--weaken_Weaken_Term e-5))))))))))))
(define TTImpC-45ElabC-45Binders-inferLambda (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (let ((act-24 (TTImpC-45ElabC-45Binders-findLamRig arg-1 arg-16 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--rigb (AlgebraC-45Preorder-glb (csegen-1892) e-5 arg-11))) (let ((act-25 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (csegen-21) arg-7 arg-8 arg-9 arg-14 (box (CoreC-45NormaliseC-45Eval-gType arg-10))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((act-26 (TTImpC-45ElabC-45Binders-checkPiInfo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-11 arg-7 arg-8 arg-9 arg-12 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-2)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--envC-39 (cons (vector 0 arg-10 u--rigb e-7 e-2) arg-9))) (let ((u--nestC-39 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45ElabC-45Binders-dropName arg-13 arg-8)))) (let ((act-27 (TTImpC-45ElabC-45Check-inScope arg-13 arg-0 arg-1 arg-4 arg-10 u--envC-39 (lambda (u--eC-39) (TTImpC-45ElabC-45Check-check (cons arg-13 arg-0) arg-1 arg-2 arg-3 u--eC-39 arg-5 arg-6 arg-7 u--nestC-39 u--envC-39 arg-15 '())) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm e-4) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((u--lamty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (vector 3 arg-10 arg-13 (vector 2 arg-10 u--rigb e-7 e-2) e-10)))) (let ((act-29 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.binder" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Inferred lambda type") arg-9 u--lamty ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (let ((act-30 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 0))) (lambda () (lambda (eta-0) (lambda (eta-1) (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.binder" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Expected lambda type") arg-9 eta-0 eta-1)))) arg-16) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 (vector 3 arg-10 arg-13 (vector 0 arg-10 u--rigb e-7 e-2) e-9) u--lamty arg-16 ext-0))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Binders-getTyNF (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((3) (vector 1 arg-3))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-2 arg-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-7 arg-2 e-6 ext-0)))))))))))))))))
(define TTImpC-45ElabC-45Binders-findLamRig (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)) (let ((e-2 (unbox arg-2))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (vector 1 e-7)))(else (vector 1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))))))(else (vector 1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))))))))))))
(define TTImpC-45ElabC-45Binders-dropName (lambda (arg-1 arg-2) (TTImpC-45ElabC-45Binders-n--9923-17203-u--drop arg-2 arg-1 arg-2)))
(define TTImpC-45ElabC-45Binders-checkPiInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (case (vector-ref arg-10 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-10 1))) (let ((act-24 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-4 arg-11) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (vector 1 (vector 3 e-2))))))))))))
(define TTImpC-45ElabC-45Binders-checkPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (let ((u--pirig (TTImpC-45ElabC-45Binders-n--10131-17399-u--getRig arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref arg-7 0))) e-0)))) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--pirig arg-7 arg-8 arg-9 arg-14 (box (CoreC-45NormaliseC-45Eval-gType arg-10))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (TTImpC-45ElabC-45Binders-checkPiInfo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-11 arg-7 arg-8 arg-9 arg-12 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-2)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--envC-39 (cons (vector 2 arg-10 arg-11 e-6 e-2) arg-9))) (let ((u--nestC-39 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45ElabC-45Binders-dropName arg-13 arg-8)))) (let ((act-26 (TTImpC-45ElabC-45Check-inScope arg-13 arg-0 arg-1 arg-4 arg-10 u--envC-39 (lambda (u--eC-39) (TTImpC-45ElabC-45Check-check (cons arg-13 arg-0) arg-1 arg-2 arg-3 u--eC-39 arg-5 u--pirig arg-7 u--nestC-39 u--envC-39 arg-15 (box (CoreC-45NormaliseC-45Eval-gType arg-10)))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-8 (car e-7))) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 (vector 3 arg-10 arg-13 (vector 2 (TTImpC-45TTImp-getFC arg-14) arg-11 e-6 e-2) e-8) (CoreC-45NormaliseC-45Eval-gType arg-10) arg-16 eta-0)))))))))))))))))))))
(define TTImpC-45ElabC-45Binders-checkLet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((u--rigc (let ((sc0 (AlgebraC-45Semiring-isErased (csegen-475) arg-6))) (cond ((equal? sc0 1) (csegen-21)) (else (csegen-519)))))) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (csegen-21) arg-7 arg-8 arg-9 arg-14 (box (CoreC-45NormaliseC-45Eval-gType arg-10))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((act-25 (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-1) (let ((act-25 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (arg-18) (CoreC-45UnifyState-u--C-61C-61_Eq_DelayReason arg-18 0)) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-12 u--rigc) (let ((e-0 (vector-ref arg-7 0))) (let ((e-1 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-7 (vector-ref arg-7 3))) (let ((e-6 (vector-ref arg-7 5))) (vector e-0 e-1 e-8 e-7 1 e-6)))))) arg-8 arg-9 arg-15 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-2))) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (Builtin-fst e-6) (cons (Builtin-snd e-6) (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-12 u--rigc))))))))) (lambda (u--err) (let ((sc2 (TTImpC-45ElabC-45Binders-n--11726-18717-u--linearErr arg-0 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--err))) (if (null? sc2) (lambda (eta-1) (let ((act-25 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-12 u--rigc) arg-7 arg-8 arg-9 arg-15 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-2))) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (Builtin-fst e-6) (cons (Builtin-snd e-6) (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-12 u--rigc))))))))) (let ((e-1 (unbox sc2))) (AlgebraC-45Semiring-branchOne (csegen-475) (lambda () (lambda (eta-1) (let ((act-25 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (arg-18) (CoreC-45UnifyState-u--C-61C-61_Eq_DelayReason arg-18 0)) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (csegen-519) arg-7 arg-8 arg-9 arg-15 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-2))) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (Builtin-fst e-6) (cons (Builtin-snd e-6) (csegen-519)))))))))) (lambda () (lambda (eta-1) (let ((act-25 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-12 u--rigc) arg-7 arg-8 arg-9 arg-15 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-2))) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (Builtin-fst e-6) (cons (Builtin-snd e-6) (AlgebraC-45ZeroOneOmega-rigMult arg-12 u--rigc)))))))))) e-1))))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((e-8 (cdr e-4))) (let ((u--envC-39 (cons (vector 0 arg-10 e-8 (vector 1 ) e-2) arg-9))) (let ((u--nestC-39 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45ElabC-45Binders-dropName arg-13 arg-8)))) (let ((act-26 (TTImpC-45ElabC-45Binders-weakenExp arg-13 arg-0 u--envC-39 arg-17 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Check-inScope arg-13 arg-0 arg-1 arg-4 arg-10 u--envC-39 (lambda (u--eC-39) (TTImpC-45ElabC-45Check-check (cons arg-13 arg-0) arg-1 arg-2 arg-3 u--eC-39 arg-5 u--rigc arg-7 u--nestC-39 u--envC-39 arg-16 e-10)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((e-13 (car e-11))) (let ((e-12 (cdr e-11))) (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm e-12) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-1 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () "checkLet is adding \x2193;") eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-15 (vector-ref act-29 1))) (vector 0 e-15))) (else (let ((act-30 (CoreC-45Metadata-addNameType arg-0 arg-1 arg-2 arg-11 arg-13 arg-9 e-2 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-16 (vector-ref act-30 1))) (vector 0 e-16))) (else (vector 1 (cons (vector 3 arg-10 arg-13 (vector 1 arg-10 e-8 e-7 e-2) e-13) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (vector 3 arg-10 arg-13 (vector 1 arg-10 e-8 e-7 e-2) e-14))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Binders-checkLambda (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) (let ((u--rig (let ((sc1 (AlgebraC-45Semiring-isErased (csegen-475) arg-6))) (cond ((equal? sc1 1) (csegen-21)) (else (csegen-519)))))) (lambda (eta-0) (TTImpC-45ElabC-45Binders-inferLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--rig arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 '() eta-0))) (let ((e-2 (unbox arg-16))) (let ((u--rig (let ((sc1 (AlgebraC-45Semiring-isErased (csegen-475) arg-6))) (cond ((equal? sc1 1) (csegen-21)) (else (csegen-519)))))) (let ((u--solvemode (let ((e-0 (vector-ref arg-7 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))))) (lambda (eta-0) (let ((act-24 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 ((CoreC-45NormaliseC-45Eval-getTerm e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Binders-getTyNF arg-0 arg-1 arg-9 e-6 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-7 0) ((3) (let ((e-1 (vector-ref e-7 1))) (let ((e-9 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (case (vector-ref e-3 0) ((2) (let ((e-13 (vector-ref e-3 1))) (let ((e-12 (vector-ref e-3 2))) (let ((e-11 (vector-ref e-3 3))) (let ((e-10 (vector-ref e-3 4))) (let ((act-28 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (csegen-21) arg-7 arg-8 arg-9 arg-14 (box (CoreC-45NormaliseC-45Eval-gType arg-10))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (let ((u--exptynf (vector 3 e-1 e-9 (vector 2 e-13 e-12 e-11 e-10) e-4))) (let ((e-16 (car e-14))) (let ((act-29 (TTImpC-45ElabC-45Binders-checkPiInfo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-11 arg-7 arg-8 arg-9 arg-12 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-16)) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-17 (vector-ref act-29 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-29 1))) (let ((u--rigb (AlgebraC-45Preorder-glb (csegen-1892) arg-11 e-12))) (let ((u--envC-39 (cons (vector 0 arg-10 u--rigb e-17 e-16) arg-9))) (let ((act-30 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-10 arg-7 arg-9 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-16) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-10)) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-18 (vector-ref act-30 1))) (vector 0 e-18))) (else (let ((u--nestC-39 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45ElabC-45Binders-dropName arg-13 arg-8)))) (let ((act-31 (TTImpC-45ElabC-45Check-inScope arg-13 arg-0 arg-1 arg-4 arg-10 u--envC-39 (lambda (u--eC-39) (TTImpC-45ElabC-45Check-check (cons arg-13 arg-0) arg-1 arg-2 arg-3 u--eC-39 arg-5 u--rig arg-7 u--nestC-39 u--envC-39 arg-15 (box (CoreC-45NormaliseC-45Eval-gnf (cons arg-13 arg-0) u--envC-39 (CoreC-45TT-renameTop arg-13 e-4))))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-19 (vector-ref act-31 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-31 1))) (let ((e-21 (car e-19))) (let ((e-20 (cdr e-19))) (let ((act-32 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.binder" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Lambda type") arg-9 u--exptynf eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-22 (vector-ref act-32 1))) (vector 0 e-22))) (else (let ((act-33 (CoreC-45Normalise-logGlueNF (cons arg-13 arg-0) arg-1 "elab.binder" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Got scope type") u--envC-39 e-20 eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-23 (vector-ref act-33 1))) (vector 0 e-23))) (else (let ((act-34 (CoreC-45ContextC-45Log-log arg-1 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () "checkLambda is adding \x2193;") eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-24 (vector-ref act-34 1))) (vector 0 e-24))) (else (let ((act-35 (CoreC-45Metadata-addNameType arg-0 arg-1 arg-2 arg-10 arg-13 arg-9 e-10 eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-25 (vector-ref act-35 1))) (vector 0 e-25))) (else (let ((act-36 (let ((act-36 ((CoreC-45NormaliseC-45Eval-getTerm e-20) eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-26 (vector-ref act-36 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-36 1))) (let ((sc18 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega u--rigb e-12))) (cond ((equal? sc18 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 1 arg-0 arg-10 (let ((e-0 (vector-ref e-8 0))) e-0) arg-9 (vector 3 arg-10 arg-13 (vector 2 e-13 u--rigb e-17 e-16) e-26) (vector 3 arg-10 e-9 (vector 2 e-13 e-12 e-17 e-10) e-4)) eta-0)) (else (vector 1 0)))))))))) (case (vector-ref act-36 0) ((0) (let ((e-26 (vector-ref act-36 1))) (vector 0 e-26))) (else (let ((act-37 ((CoreC-45NormaliseC-45Eval-getTerm e-20) eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-27 (vector-ref act-37 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-37 1))) (vector 1 (cons (vector 3 arg-10 arg-13 (vector 0 e-13 u--rigb e-17 e-16) e-21) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (vector 3 arg-10 arg-13 (vector 2 e-13 u--rigb e-17 e-16) e-27))))))))))))))))))))))))))))))))))))))))))))))))))(else (TTImpC-45ElabC-45Binders-inferLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--rig arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (box e-2) eta-0))))))))(else (TTImpC-45ElabC-45Binders-inferLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--rig arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (box e-2) eta-0)))))))))))))))))))))))))
(define TTImpC-45ElabC-45As-n--10185-8248-u--rigPatC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (cond ((equal? arg-16 0) (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-10))) (cond ((equal? sc1 1) (csegen-519)) (else arg-10)))) (else (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-10))) (cond ((equal? sc1 1) (csegen-21)) (else arg-10)))))))
(define TTImpC-45ElabC-45As-n--10185-8249-u--rigPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (TTImpC-45ElabC-45As-n--10185-8248-u--rigPatC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-4)))
(define TTImpC-45ElabC-45As-n--10185-8250-u--rigAsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (cond ((equal? arg-16 0) (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-10))) (cond ((equal? sc1 1) (csegen-21)) (else arg-10)))) (else (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-10))) (cond ((equal? sc1 1) (csegen-519)) (else arg-10)))))))
(define TTImpC-45ElabC-45As-n--10185-8251-u--rigAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (TTImpC-45ElabC-45As-n--10185-8250-u--rigAsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-4)))
(define TTImpC-45ElabC-45As-checkAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((u--elabmode (let ((e-0 (vector-ref arg-7 0))) e-0))) (lambda (clam-0) (case (vector-ref u--elabmode 0) ((1) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (vector 3 arg-13 (let ((e-2 (vector-ref e-5 1))) e-2)))) (let ((act-25 (TTImpC-45ElabC-45Check-noteLHSPatVar arg-4 u--elabmode arg-13 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (TTImpC-45ElabC-45Check-notePatVar arg-4 u--n clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((sc4 (DataC-45List-lookup (csegen-802) u--n (let ((e-17 (vector-ref e-5 4))) e-17)))) (if (null? sc4) (let ((act-27 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (TTImpC-45ElabC-45As-n--10185-8249-u--rigPat arg-0 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) arg-7 arg-8 arg-9 arg-14 arg-15) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((act-28 ((TTImpC-45ElabC-45ImplicitBind-mkPatternHole arg-0 arg-4 arg-1 arg-3 arg-11 arg-6 u--n arg-9 (let ((e-1 (vector-ref arg-7 1))) e-1) arg-15) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((e-12 (car e-4))) (let ((e-11 (cdr e-4))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-1 "elab.as" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Added as pattern name " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (u--d) (lambda (x-1) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-2))))) x-1)) (lambda (u--d) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) u--d x-1))))) x-0)) (lambda (u--d) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-0) (lambda (x-1) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) d-0 x-1))))) u--d x-0))))) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1503) (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-0) (lambda (x-1) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) d-0 x-1))))) x-0)) (lambda (d-0) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-1) (lambda (x-1) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) x-1)) (lambda (d-1) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-2 x-2)))) (cons (lambda (x-2) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-2 x-2))))) d-1 x-1))))) d-0 x-0))))) u--d u--x))))) (cons u--n (cons (TTImpC-45ElabC-45As-n--10185-8251-u--rigAs arg-0 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (cons e-10 (cons e-12 e-11))))))) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((act-30 (let ((act-30 (unbox arg-1))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((act-31 (let ((act-31 (unbox arg-4))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-15 (vector-ref act-31 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (set-box! arg-4 (let ((e-1 (vector-ref e-15 0))) (let ((e-28 (vector-ref e-15 1))) (let ((e-27 (vector-ref e-15 2))) (let ((e-26 (vector-ref e-15 3))) (let ((e-25 (vector-ref e-15 4))) (let ((e-24 (vector-ref e-15 5))) (let ((e-23 (vector-ref e-15 6))) (let ((e-22 (vector-ref e-15 7))) (let ((e-21 (vector-ref e-15 8))) (let ((e-20 (vector-ref e-15 9))) (let ((e-19 (vector-ref e-15 10))) (let ((e-18 (vector-ref e-15 11))) (let ((e-17 (vector-ref e-15 12))) (let ((e-16 (vector-ref e-15 13))) (vector e-1 e-28 e-27 e-26 (let ((u--vars arg-0)) (cons (cons u--n (vector 1 arg-0 (TTImpC-45ElabC-45As-n--10185-8251-u--rigAs u--vars arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (vector 1 ) e-10 e-12 e-2)) e-25)) (let ((u--vars arg-0)) (cons (cons u--n (vector 1 arg-0 (TTImpC-45ElabC-45As-n--10185-8251-u--rigAs u--vars arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (vector 1 ) e-10 e-11 e-2)) e-24)) e-23 e-22 e-21 e-20 e-19 e-18 e-17 e-16)))))))))))))))))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-16 (vector-ref act-32 1))) (vector 0 e-16))) (else (let ((act-33 (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-11 e-10 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-12) (box e-3) clam-0))) (case (vector-ref act-33 0) ((0) (let ((e-17 (vector-ref act-33 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-33 1))) (let ((e-19 (car e-17))) (let ((e-18 (cdr e-17))) (let ((act-34 (CoreC-45ContextC-45Log-log arg-1 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () "checkAs is adding \x2193;") clam-0))) (case (vector-ref act-34 0) ((0) (let ((e-20 (vector-ref act-34 1))) (vector 0 e-20))) (else (let ((act-35 (let ((act-35 ((CoreC-45NormaliseC-45Eval-getTerm e-18) clam-0))) (case (vector-ref act-35 0) ((0) (let ((e-21 (vector-ref act-35 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-35 1))) (CoreC-45Metadata-addNameType arg-0 arg-1 arg-2 arg-11 arg-13 arg-9 e-21 clam-0))))))) (case (vector-ref act-35 0) ((0) (let ((e-21 (vector-ref act-35 1))) (vector 0 e-21))) (else (vector 1 (cons (vector 5 arg-10 arg-12 e-19 e-2) e-3))))))))))))))))))))))))))))))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 35 arg-10 arg-13) clam-0)))))))))))))))(else (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "elab.as" (+ 1 (+ 1 0)) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Bad @-pattern " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-14))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-10 "@-patterns only allowed in pattern clauses") clam-0))))))))))
(define TTImpC-45ElabC-45App-with--checkAppWithC-39-8331 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (if (null? arg-2) (TTImpC-45ElabC-45App-case--withC-32blockC-32inC-32checkAppWithC-39-8369 arg-4 arg-24 arg-23 arg-22 arg-3 arg-21 arg-20 arg-19 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-1 arg-0 (TTImpC-45ElabC-45App-findBindAllExpPattern arg-1)) (let ((e-1 (unbox arg-2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-10 (cdr e-5))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-19 arg-6))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-3 arg-24 arg-23 arg-22 arg-21 arg-20 arg-19 u--argRig arg-18 arg-17 arg-16 arg-15 arg-14 arg-0 arg-5 arg-7 arg-13 e-10 '() arg-12 e-6 arg-11 arg-10 eta-0))))))))))
(define TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkAppWith-10701 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (if (null? arg-25) (lambda (eta-0) (vector 1 arg-19)) (let ((e-1 (unbox arg-25))) (lambda (clam-0) (if (null? e-1) (vector 1 arg-19) (let ((e-5 (cdr e-1))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-5 (PreludeC-45TypesC-45List-length arg-24)))) (cond ((equal? sc2 1) (vector 1 arg-19)) (else (TTImpC-45ElabC-45Dot-registerDot arg-0 arg-18 arg-17 arg-16 arg-15 arg-13 arg-10 arg-9 6 (Builtin-fst arg-19) (Builtin-snd arg-19) clam-0)))))))))))
(define TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWith-10645 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-21) (lambda (eta-0) (vector 1 arg-19)) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkAppWith-10701 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-5 e-7 e-6 e-3 (CoreC-45TT-isCon e-6))))))(else (lambda (eta-0) (vector 1 arg-19)))))))))
(define TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-10244 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 ext-0) (if (null? arg-35) (vector 1 arg-33) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm arg-32) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45UnifyState-newConstant arg-4 arg-18 arg-20 arg-11 arg-15 arg-12 (Builtin-fst arg-33) e-5 arg-35) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-6 (CoreC-45NormaliseC-45Eval-gnf arg-4 arg-12 arg-25))))))))))))))
(define TTImpC-45ElabC-45App-case--withC-32blockC-32inC-32checkAppWithC-39-8369 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (if (null? arg-24) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-1) (TTImpC-45ElabC-45App-isImplicitAs eta-1)) (PreludeC-45TypesC-45List-tailRecAppend arg-14 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) (DataC-45List-filter (csegen-2130) arg-22)))))) (cond ((equal? sc2 1) (TTImpC-45ElabC-45Check-checkExp arg-4 arg-1 arg-3 arg-5 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-4 e-5 arg-10 arg-17) arg-16 eta-0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-4 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 1 (vector 0 "<auto>"))) arg-14) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-22)) arg-12) eta-0))))))))) (let ((e-1 (unbox arg-24))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-7 arg-20))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-4 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 arg-23 arg-21 arg-19 arg-13 e-1 '() arg-14 arg-22 arg-15 arg-16 eta-0)))))))
(define TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkRestAppC-44checkRtoL-6741 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 arg-40 arg-41 arg-42 arg-43 arg-44 arg-45 arg-46 arg-47 ext-0) (if (null? arg-47) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Unify-updateSolution arg-0 arg-23 arg-21 arg-14 arg-31 arg-41 eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 arg-35)))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm arg-36) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45UnifyState-newConstant arg-0 arg-21 arg-23 arg-13 arg-18 arg-14 arg-35 e-5 arg-47) ext-0))))))))
(define TTImpC-45ElabC-45App-case--getVarType-3146 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45App-getNameType arg-0 arg-8 arg-7 arg-6 arg-5 arg-3 arg-2 arg-1) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-2 (cons 0 e-3)))))))))) (let ((e-2 (unbox arg-9))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((act-24 (let ((act-24 (unbox arg-8))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((u--arglen (PreludeC-45TypesC-45List-length e-9))) (let ((u--nC-39 (DataC-45Maybe-fromMaybe (lambda () arg-1) e-5))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact u--nC-39 (let ((e-0 (vector-ref e-7 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (CoreC-45Context-undefinedName arg-8 arg-2 u--nC-39 clam-0) (let ((e-3 (unbox e-8))) (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-17 (vector-ref e-3 17))) e-17))))) (let ((u--tm ((e-10 arg-2) u--nt))) (let ((u--tyenv (TTImpC-45ElabC-45App-n--10711-3075-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-0 (CoreC-45TT-getArgs u--tm) (CoreC-45TT-embed (let ((e-29 (vector-ref e-3 2))) e-29))))) (let ((act-26 (TTImpC-45ElabC-45App-checkVisibleNS arg-8 arg-2 (let ((e-1 (vector-ref e-3 1))) e-1) (let ((e-23 (vector-ref e-3 9))) e-23) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (CoreC-45ContextC-45Log-logTerm arg-0 arg-8 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Type of " (CoreC-45Name-u--show_Show_Name u--nC-39))) u--tyenv clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (CoreC-45ContextC-45Log-logTerm arg-0 arg-8 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Expands to") u--tm clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-8 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Arg length " (PreludeC-45Show-u--show_Show_Nat u--arglen))) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (CoreC-45ContextC-45Log-log arg-8 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () "getVarType is adding \x2193;") clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (CoreC-45Metadata-addNameType arg-0 arg-8 arg-7 arg-2 arg-1 arg-3 u--tyenv clam-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (let ((sc12 (CoreC-45Name-isSourceName (let ((e-1 (vector-ref e-3 1))) e-1)))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc13) (vector 1 0) (let ((e-1 (unbox sc13))) (let ((u--decor (CoreC-45Metadata-nameDecoration (let ((e-36 (vector-ref e-3 1))) e-36) u--nt))) (let ((act-32 (CoreC-45ContextC-45Log-log arg-8 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "getNameType is adding " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Metadata-u--show_Show_Decoration u--decor) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45Name-u--show_Show_Name (let ((e-36 (vector-ref e-3 1))) e-36)))))) clam-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (CoreC-45Metadata-addSemanticDecorations arg-7 arg-8 (cons (cons e-1 (cons u--decor (box (let ((e-37 (vector-ref e-3 1))) e-37)))) '()) clam-0))))))))) (else (vector 1 0)))))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (vector 1 (cons u--tm (cons u--arglen (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-3 u--tyenv)))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-case--getNameType-2623 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-8) (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-7 arg-2 arg-1 clam-0) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0) (let ((e-7 (cdr e-1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-2) (let ((act-26 (TTImpC-45ElabC-45App-checkVisibleNS arg-7 arg-2 (let ((e-29 (vector-ref e-11 1))) e-29) (let ((e-9 (vector-ref e-11 9))) e-9) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (TTImpC-45ElabC-45App-n--10197-2596-u--rigSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (let ((e-26 (vector-ref e-11 7))) e-26) arg-4 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-17 (vector-ref e-11 17))) e-17))))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-7 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "getNameType is trying to add something for: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-31 (vector-ref e-11 1))) e-31)) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC arg-2) ")"))))) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((act-29 (let ((sc10 (CoreC-45Name-isSourceName (let ((e-32 (vector-ref e-11 1))) e-32)))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc11) (vector 1 0) (let ((e-3 (unbox sc11))) (let ((u--decor (CoreC-45Metadata-nameDecoration (let ((e-33 (vector-ref e-11 1))) e-33) u--nt))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-7 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "getNameType is adding " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Metadata-u--show_Show_Decoration u--decor) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45Name-u--show_Show_Name (let ((e-33 (vector-ref e-11 1))) e-33)))))) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (CoreC-45Metadata-addSemanticDecorations arg-6 arg-7 (cons (cons e-3 (cons u--decor (box (let ((e-34 (vector-ref e-11 1))) e-34)))) '()) clam-0))))))))) (else (vector 1 0)))))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (vector 1 (cons (vector 1 arg-2 u--nt (vector 8 e-10)) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-3 (CoreC-45TT-embed (let ((e-32 (vector-ref e-11 2))) e-32)))))))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6)) clam-0)))))))))))))))))) (let ((e-1 (unbox arg-8))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-24 (TTImpC-45ElabC-45App-n--10197-2596-u--rigSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6 arg-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((u--binder (CoreC-45Env-getBinder (csegen-764) arg-0 e-5 arg-3))) (let ((u--bty (CoreC-45TT-binderType u--binder))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-7 "metadata.names" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () "getNameType is adding \x2193;") clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Metadata-addNameType arg-0 arg-7 arg-6 arg-2 arg-1 arg-3 u--bty clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((sc5 (AlgebraC-45Semiring-isLinear (csegen-475) e-6))) (cond ((equal? sc5 1) (let ((act-27 (let ((act-27 (unbox arg-5))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (set-box! arg-5 (let ((e-21 (vector-ref e-10 0))) (let ((e-2 (vector-ref e-10 1))) (let ((e-3 (vector-ref e-10 2))) (let ((e-4 (vector-ref e-10 3))) (let ((e-20 (vector-ref e-10 4))) (let ((e-19 (vector-ref e-10 5))) (let ((e-18 (vector-ref e-10 6))) (let ((e-17 (vector-ref e-10 7))) (let ((e-16 (vector-ref e-10 8))) (let ((e-15 (vector-ref e-10 9))) (let ((e-11 (vector-ref e-10 10))) (let ((e-12 (vector-ref e-10 11))) (let ((e-13 (vector-ref e-10 12))) (let ((e-14 (vector-ref e-10 13))) (vector e-21 e-2 e-3 e-4 e-20 e-19 e-18 e-17 e-16 e-15 e-11 (cons e-5 e-12) e-13 e-14)))))))))))))))))) (vector 1 act-28))))))) (else (vector 1 0)))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45ContextC-45Log-log arg-7 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "getNameType is trying to add Bound: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC arg-2) ")"))))) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (let ((sc7 (CoreC-45Name-isSourceName arg-1))) (cond ((equal? sc7 1) (let ((sc8 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc8) (vector 1 0) (let ((e-2 (unbox sc8))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-7 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "getNameType is adding Bound: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (CoreC-45Metadata-addSemanticDecorations arg-6 arg-7 (cons (cons e-2 (cons 5 (box arg-1))) '()) clam-0)))))))) (else (vector 1 0)))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 0 arg-2 (box (CoreC-45TT-isLet u--binder)) e-5) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-3 u--bty))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-n--10711-3075-u--useVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-12 (car arg-10))) (let ((e-13 (cdr arg-10))) (case (vector-ref arg-11 0) ((3) (let ((e-15 (vector-ref arg-11 1))) (let ((e-16 (vector-ref arg-11 2))) (let ((e-17 (vector-ref arg-11 3))) (let ((e-18 (vector-ref arg-11 4))) (case (vector-ref e-17 0) ((2) (let ((e-20 (vector-ref e-17 1))) (let ((e-21 (vector-ref e-17 2))) (let ((e-23 (vector-ref e-17 4))) (vector 3 e-15 e-16 (vector 1 e-20 e-21 e-12 e-23) (TTImpC-45ElabC-45App-n--10711-3075-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-16 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) e-13) e-18))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (TTImpC-45ElabC-45App-n--10711-3075-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-2 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) arg-10) e-4)))))))(else arg-11)))))))(else arg-11)))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (TTImpC-45ElabC-45App-n--10711-3075-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-2 arg-9) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Term eta-0)) arg-10) e-4)))))))(else arg-11)))))))(else arg-11)))))))))
(define TTImpC-45ElabC-45App-n--20048-11105-u--updateElabInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (case (vector-ref arg-18 0) ((1) (if (null? arg-20) (lambda (eta-0) (vector 1 arg-21)) (let ((e-2 (car arg-20))) (let ((e-3 (cdr arg-20))) (lambda (clam-0) (case (vector-ref e-2 0) ((28) (if (null? e-3) (let ((act-24 (CoreC-45Context-getFullName arg-16 arg-19 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((sc5 (CoreC-45Context-isPrimName arg-17 e-7))) (cond ((equal? sc5 1) (vector 1 (let ((e-1 (vector-ref arg-21 1))) (let ((e-10 (vector-ref arg-21 2))) (let ((e-9 (vector-ref arg-21 3))) (let ((e-4 (vector-ref arg-21 4))) (let ((e-8 (vector-ref arg-21 5))) (vector (vector 2 ) e-1 e-10 e-9 e-4 e-8)))))))) (else (vector 1 arg-21)))))))) (vector 1 arg-21)))(else (vector 1 arg-21))))))))(else (lambda (eta-0) (vector 1 arg-21))))))
(define TTImpC-45ElabC-45App-n--10197-2596-u--rigSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 (CoreC-45Context-getFullName arg-7 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (AlgebraC-45Preorder-C-60 (csegen-2098) arg-8 arg-9))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 14 arg-2 e-5 arg-8 arg-9) ext-0)) (else (vector 1 0))))))))))
(define TTImpC-45ElabC-45App-n--20048-11104-u--normalisePrims (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 ext-0) (let ((act-24 (CoreC-45Normalise-normalisePrims arg-16 arg-17 (lambda (arg-21) (TTImpC-45ElabC-45App-n--20130-11114-u--boundSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-20 arg-19 arg-18 arg-21 (let ((e-0 (vector-ref arg-10 0))) e-0))) (lambda (eta-0) (TTImpC-45TTImp-isIPrimVal eta-0)) (let ((e-0 (vector-ref arg-10 0))) (case (vector-ref e-0 0) ((1) 1)(else 0))) arg-18 arg-1 arg-6 (Builtin-fst arg-20) arg-19 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (DataC-45Maybe-fromMaybe (lambda () (Builtin-fst arg-20)) e-5) (Builtin-snd arg-20)))))))))
(define TTImpC-45ElabC-45App-n--11217-4018-u--metavarImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (case (vector-ref arg-24 0) ((1) 1) ((3) 1)(else 0))))
(define TTImpC-45ElabC-45App-n--11203-3764-u--metavarImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23) (case (vector-ref arg-23 0) ((1) 1) ((3) 1)(else 0))))
(define TTImpC-45ElabC-45App-n--11256-5324-u--invalidArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (case (vector-ref arg-24 0) ((26) 1)(else 0))))
(define TTImpC-45ElabC-45App-n--11252-4610-u--dotTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((19) arg-8) ((17) arg-8) ((32) arg-8) ((18) (let ((e-11 (vector-ref arg-8 1))) (let ((e-12 (vector-ref arg-8 2))) (let ((e-13 (vector-ref arg-8 3))) (let ((e-14 (vector-ref arg-8 4))) (let ((e-15 (vector-ref arg-8 5))) (case (vector-ref e-15 0) ((17) arg-8) ((32) arg-8)(else (vector 18 e-11 e-12 e-13 e-14 (vector 19 e-11 3 arg-8))))))))))(else (vector 19 (TTImpC-45TTImp-getFC arg-8) 3 arg-8)))))
(define TTImpC-45ElabC-45App-n--11252-4609-u--countConstructors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((3) (let ((e-2 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length e-5) e-4))) (cond ((equal? sc1 1) (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref e-6 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (if (null? e-7) (vector 1 '()) (let ((e-8 (unbox e-7))) (let ((e-17 (vector-ref e-8 17))) (case (vector-ref e-17 0) ((6) (let ((e-31 (vector-ref e-17 7))) (vector 1 (box (PreludeC-45TypesC-45List-length e-31)))))(else (vector 1 '()))))))))))))))) (else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45ElabC-45App-n--11256-5325-u--checkRtoL (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 ext-0) (let ((act-24 (let ((act-24 (unbox arg-23))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45UnifyState-genMVName arg-23 arg-21 arg-11) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-23 arg-0 e-7 arg-14 arg-10 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45ElabC-45Check-argVar arg-0 arg-23 arg-21 (TTImpC-45TTImp-getFC arg-25) arg-17 arg-14 e-6 e-8) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((u--fntm (vector 4 arg-13 arg-12 e-3))) (let ((act-29 (CoreC-45ContextC-45Log-logTerm arg-0 arg-23 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "...as") e-3 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (((arg-9 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-14 e-3)) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 u--fntm e-11 (cons arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2)) arg-7 arg-6 arg-5 arg-24 arg-3 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (let ((_-0 (cons e-2 e-3))) (let ((e-13 (car e-12))) (let ((e-4 (cdr e-12))) (let ((act-32 (let ((act-32 (unbox arg-23))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-14 (vector-ref act-32 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-32 1))) (let ((act-33 ((CoreC-45NormaliseC-45Eval-nf arg-23 arg-0 e-14 arg-14 e-8) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-15 (vector-ref act-33 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Normalise-logNF arg-0 arg-23 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Now trying " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-25))))) arg-14 e-15 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-16 (vector-ref act-34 1))) (vector 0 e-16))) (else (let ((act-35 (let ((sc13 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc13 1) (((case (vector-ref e-15 0) ((1) (let ((e-18 (vector-ref e-15 2))) (case (vector-ref e-18 0) ((2) (let ((e-20 (vector-ref e-18 2))) (lambda () (lambda (eta-0) (let ((act-35 ((CoreC-45Context-lookupCtxtExact (vector 8 e-20) (let ((e-0 (vector-ref e-14 0))) e-0)) eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-22 (vector-ref act-35 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-35 1))) (if (null? e-22) (vector 1 0) (let ((e-23 (unbox e-22))) (let ((sc18 (AlgebraC-45Semiring-isErased (csegen-475) (let ((e-38 (vector-ref e-23 7))) e-38)))) (cond ((equal? sc18 1) (CoreC-45UnifyState-addNoSolve arg-21 e-20 eta-0)) (else (vector 1 0))))))))))))))(else (lambda () (lambda (eta-0) (vector 1 0)))))))(else (lambda () (lambda (eta-0) (vector 1 0)))))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-35 0) ((0) (let ((e-17 (vector-ref act-35 1))) (vector 0 e-17))) (else (let ((act-36 ((TTImpC-45ElabC-45Check-check arg-0 arg-23 arg-22 arg-21 arg-20 arg-19 arg-17 (let ((e-0 (vector-ref arg-16 0))) (let ((e-1 (vector-ref arg-16 1))) (let ((e-20 (vector-ref arg-16 3))) (let ((e-19 (vector-ref arg-16 4))) (let ((e-18 (vector-ref arg-16 5))) (vector e-0 e-1 0 e-20 e-19 e-18)))))) arg-15 arg-14 arg-25 (box (CoreC-45Normalise-glueBack arg-23 arg-0 e-14 arg-14 e-15))) ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-18 (vector-ref act-36 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-36 1))) (let ((act-37 (let ((sc15 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc15 1) (((case (vector-ref e-15 0) ((1) (let ((e-20 (vector-ref e-15 2))) (case (vector-ref e-20 0) ((2) (let ((e-22 (vector-ref e-20 2))) (lambda () (lambda (eta-0) (CoreC-45UnifyState-removeNoSolve arg-21 e-22 eta-0)))))(else (lambda () (lambda (eta-0) (vector 1 0)))))))(else (lambda () (lambda (eta-0) (vector 1 0)))))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-37 0) ((0) (let ((e-19 (vector-ref act-37 1))) (vector 0 e-19))) (else (let ((act-38 (let ((sc16 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc16 1) (let ((e-21 (car e-18))) (let ((e-20 (cdr e-18))) (TTImpC-45ElabC-45App-checkValidPattern arg-0 arg-23 arg-22 arg-21 arg-20 arg-18 arg-14 arg-13 e-21 e-20 ext-0)))) (else (vector 1 e-18)))))) (case (vector-ref act-38 0) ((0) (let ((e-20 (vector-ref act-38 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-38 1))) (let ((_-1 (cons e-13 e-4))) (let ((e-22 (car e-20))) (let ((e-21 (cdr e-20))) (let ((act-39 (let ((act-39 (unbox arg-23))) (vector 1 act-39)))) (case (vector-ref act-39 0) ((0) (let ((e-23 (vector-ref act-39 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-39 1))) (let ((act-40 (CoreC-45ContextC-45Log-logTerm arg-0 arg-23 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Solving " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-3) " with"))) e-22 ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-24 (vector-ref act-40 1))) (vector 0 e-24))) (else (let ((act-41 (CoreC-45Unify-solveIfUndefined arg-0 arg-23 arg-21 arg-14 e-3 e-22 ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-25 (vector-ref act-41 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-41 1))) (let ((act-42 (let ((_-2 (cons e-22 e-21))) (cond ((equal? e-25 1) (vector 1 e-13)) (else (let ((act-42 ((TTImpC-45ElabC-45Check-convert arg-0 arg-23 arg-21 arg-20 arg-13 arg-16 arg-14 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-14 e-3) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-14 e-22)) ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-26 (vector-ref act-42 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-42 1))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkRestAppC-44checkRtoL-6741 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-25 arg-24 e-5 e-6 e-7 e-8 e-2 e-3 _-0 u--fntm e-11 e-13 e-4 _-1 e-14 e-15 e-18 e-22 e-21 _-2 e-23 e-25 e-26 (let ((e-0 (vector-ref e-26 0))) e-0) ext-0)))))))))) (case (vector-ref act-42 0) ((0) (let ((e-26 (vector-ref act-42 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-42 1))) (let ((act-43 (let ((e-0 (vector-ref arg-16 0))) (case (vector-ref e-0 0) ((1) (let ((act-43 (CoreC-45Context-updateDef arg-23 (vector 8 e-2) (csegen-2078) ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-32 (vector-ref act-43 1))) (vector 0 e-32))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Unify-solveIfUndefined arg-0 arg-23 arg-21 arg-14 e-3 e-22 eta-0)) ext-0)))))(else (vector 1 0)))))) (case (vector-ref act-43 0) ((0) (let ((e-27 (vector-ref act-43 1))) (vector 0 e-27))) (else (let ((act-44 (CoreC-45UnifyState-removeHole arg-21 e-2 ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-28 (vector-ref act-44 1))) (vector 0 e-28))) (else (vector 1 (cons e-26 e-4))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-n--11256-5326-u--checkLtoR (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 ext-0) (let ((act-24 (let ((act-24 (unbox arg-23))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-logNF arg-0 arg-23 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Full function type") arg-14 (vector 0 arg-13 arg-11 (vector 2 arg-13 arg-17 (vector 1 ) arg-10) arg-9) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45ContextC-45Log-unverifiedLogC arg-23 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-0) (let ((act-26 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 '()))) (lambda () (lambda (u--t) (lambda (eta-1) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm u--t) eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-23 (csegen-76) e-7 eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (box e-8))))))))))))) arg-3) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Overall expected type: " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d u--x)))) e-7)))))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((TTImpC-45ElabC-45Check-check arg-0 arg-23 arg-22 arg-21 arg-20 arg-19 arg-17 (let ((e-0 (vector-ref arg-16 0))) (let ((e-1 (vector-ref arg-16 1))) (let ((e-3 (vector-ref arg-16 3))) (let ((e-4 (vector-ref arg-16 4))) (let ((e-8 (vector-ref arg-16 5))) (vector e-0 e-1 0 e-3 e-4 e-8)))))) arg-15 arg-14 arg-25 (box (CoreC-45Normalise-glueClosure arg-23 arg-0 e-5 arg-14 arg-10))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((sc4 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc4 1) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (TTImpC-45ElabC-45App-checkValidPattern arg-0 arg-23 arg-22 arg-21 arg-20 arg-18 arg-14 arg-13 e-2 e-3 ext-0)))) (else (vector 1 e-8)))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-29 (CoreC-45Normalise-logGlueNF arg-0 arg-23 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Got arg type") arg-14 e-3 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (let ((act-30 (unbox arg-23))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((u--fntm (vector 4 arg-13 arg-12 e-2))) (let ((act-31 (((arg-9 e-11) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-14 e-2)) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 u--fntm e-12 (cons arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2)) arg-7 arg-6 arg-5 arg-24 arg-3 ext-0)))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-n--20130-11114-u--boundSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (case (vector-ref arg-22 0) ((1) 1)(else (case (vector-ref arg-21 0) ((5) (let ((e-0 (vector-ref arg-21 1))) (PreludeC-45EqOrd-u--C-60_Ord_Integer (PreludeC-45Num-u--abs_Abs_Integer e-0) 100)))(else 1))))))
(define TTImpC-45ElabC-45App-onLHS (lambda (arg-0) (case (vector-ref arg-0 0) ((1) 1)(else 0))))
(define TTImpC-45ElabC-45App-needsDelayLHS (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 1))) ((8) (let ((e-5 (vector-ref arg-1 2))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-5))) ((9) (let ((e-9 (vector-ref arg-1 2))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-9))) ((10) (let ((e-13 (vector-ref arg-1 2))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-13))) ((13) (lambda (eta-0) (vector 1 1))) ((18) (let ((e-25 (vector-ref arg-1 5))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-25))) ((12) (lambda (eta-0) (vector 1 1))) ((28) (lambda (eta-0) (vector 1 1))) ((29) (lambda (eta-0) (vector 1 1))) ((33) (let ((e-37 (vector-ref arg-1 3))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-37)))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ElabC-45App-needsDelayExpr (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) (lambda (eta-0) (vector 1 0))) (else (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (if (null? e-6) 0 (let ((e-3 (cdr e-6))) (if (null? e-3) 0 1))))))))))))))) ((8) (let ((e-5 (vector-ref arg-2 2))) (TTImpC-45ElabC-45App-needsDelayExpr arg-0 1 e-5))) ((9) (let ((e-9 (vector-ref arg-2 2))) (TTImpC-45ElabC-45App-needsDelayExpr arg-0 1 e-9))) ((10) (let ((e-13 (vector-ref arg-2 2))) (TTImpC-45ElabC-45App-needsDelayExpr arg-0 1 e-13))) ((2) (lambda (eta-0) (vector 1 1))) ((4) (lambda (eta-0) (vector 1 1))) ((5) (lambda (eta-0) (vector 1 1))) ((7) (lambda (eta-0) (vector 1 1))) ((13) (lambda (eta-0) (vector 1 1))) ((12) (lambda (eta-0) (vector 1 1))) ((14) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (vector 1 0))))))))
(define TTImpC-45ElabC-45App-needsDelay (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-1 0) ((1) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 arg-3))(else (TTImpC-45ElabC-45App-needsDelayExpr arg-0 arg-2 arg-3)))))
(define TTImpC-45ElabC-45App-makeImplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45UnifyState-genMVName arg-1 arg-3 arg-13) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-7 arg-10 arg-14 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 arg-7 arg-10 e-6 e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--fntm (vector 4 arg-11 arg-12 e-9))) (let ((act-29 (((arg-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-10 e-9)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((sc7 (let ((e-12 (vector-ref arg-8 3))) e-12))) (cond ((equal? sc7 1) (let ((act-30 (let ((act-30 (unbox arg-4))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-6 arg-7 (vector 0 ) arg-10 e-9 e-8 e-11)))) (vector 1 act-31))))))) (else (vector 1 0)))))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 u--fntm e-10 (cons e-2 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-3)) arg-17 arg-18 arg-19 arg-20 arg-21 ext-0)))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-makeDefImplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (lambda (clam-0) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((sc1 (TTImpC-45ElabC-45App-n--11217-4018-u--metavarImp arg-0 e-2 e-3 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref arg-8 0))) e-0)))) (cond ((equal? sc1 1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45UnifyState-genMVName arg-1 arg-3 arg-13) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearDefs e-5 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-7 arg-10 arg-15 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 arg-7 arg-10 e-6 e-8 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--fntm (vector 4 arg-11 arg-12 e-9))) (let ((act-29 (((arg-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-10 e-9)) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (unbox arg-4))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-6 arg-7 (vector 2 ) arg-10 e-9 e-8 e-11)))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 u--fntm e-10 (cons e-2 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-3)) arg-18 arg-19 arg-20 arg-21 arg-22 clam-0)))))))))))))))))))))))))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-6 arg-10 arg-14 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--fntm (vector 4 arg-11 arg-12 e-7))) (let ((act-27 (((arg-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-10 e-7)) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 u--fntm e-8 (cons e-2 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-3)) arg-18 arg-19 arg-20 arg-21 arg-22 clam-0))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-makeAutoImplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (lambda (clam-0) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (let ((sc1 (TTImpC-45ElabC-45App-n--11203-3764-u--metavarImp arg-0 e-2 e-3 arg-21 arg-20 arg-19 arg-18 arg-17 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref arg-8 0))) e-0)))) (cond ((equal? sc1 1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45UnifyState-genMVName arg-1 arg-3 arg-13) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearDefs e-5 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-7 arg-10 arg-14 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 arg-7 arg-10 e-6 e-8 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--fntm (vector 4 arg-11 arg-12 e-9))) (let ((act-29 (((arg-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-10 e-9)) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (unbox arg-4))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-6 arg-7 (vector 2 ) arg-10 e-9 e-8 e-11)))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 u--fntm e-10 (cons e-2 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-3)) arg-17 arg-18 arg-19 arg-20 arg-21 clam-0)))))))))))))))))))))))))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45UnifyState-genMVName arg-1 arg-3 arg-13) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-5 arg-10 arg-14 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-4))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-getAutoImplicitLimit arg-1 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45ElabC-45Check-searchVar arg-0 arg-1 arg-3 arg-11 arg-7 e-9 (vector 8 (let ((e-21 (vector-ref e-8 1))) e-21)) arg-10 arg-9 e-6 e-7 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--fntm (vector 4 arg-11 arg-12 e-10))) (let ((act-30 (((arg-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-10 e-10)) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 u--fntm e-11 (cons e-2 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-3)) arg-17 arg-18 arg-19 arg-20 arg-21 clam-0))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-isImplicitAs (lambda (arg-0) (case (vector-ref arg-0 0) ((18) (let ((e-3 (vector-ref arg-0 3))) (let ((e-5 (vector-ref arg-0 5))) (cond ((equal? e-3 0) (case (vector-ref e-5 0) ((32) 1)(else 0)))(else 0)))))(else 0))))
(define TTImpC-45ElabC-45App-isHole (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-2 (vector-ref arg-1 2))) (case (vector-ref e-2 0) ((2) 1)(else 0))))(else 0))))
(define TTImpC-45ElabC-45App-isBindAllExpPattern (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((2) 1)(else 0))))(else 0))))
(define TTImpC-45ElabC-45App-getVarType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (TTImpC-45ElabC-45App-case--getVarType-3146 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45List-lookup (csegen-802) arg-8 arg-5))))
(define TTImpC-45ElabC-45App-getNameType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (TTImpC-45ElabC-45App-case--getNameType-2623 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45Env-defined arg-0 arg-7 arg-5))))
(define TTImpC-45ElabC-45App-findNamed (lambda (arg-0 arg-1) (let ((sc0 (DataC-45List-partition (lambda (eta-0) (CoreC-45Name-u--C-61C-61_Eq_Name (Builtin-fst eta-0) arg-0)) arg-1))) (if (null? sc0) '() (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-2) '() (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (box (cons e-5 (PreludeC-45TypesC-45List-tailRecAppend e-6 e-3))))))))))))
(define TTImpC-45ElabC-45App-findBindAllExpPattern (lambda (ext-0) (DataC-45List-lookup (csegen-802) (vector 1 (vector 2 )) ext-0)))
(define TTImpC-45ElabC-45App-dotErased (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-5 0) ((1) (let ((e-0 (vector-ref arg-5 1))) (let ((sc1 (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) e-0))) (cond ((equal? sc2 1) 0) (else (AlgebraC-45Semiring-isErased (csegen-475) arg-6)))))) (cond ((equal? sc1 1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 arg-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ElabC-45App-n--11252-4609-u--countConstructors arg-0 e-0 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 e-6) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc4 (let ((sc5 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-792) e-6 (box (PreludeC-45Types-u--fromInteger_Num_Nat 1))))) (cond ((equal? sc5 1) 1) (else (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-792) e-6 (box (PreludeC-45Types-u--fromInteger_Num_Nat 0)))))))) (cond ((equal? sc4 1) (vector 1 arg-7)) (else (let ((act-26 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--n) (CoreC-45Context-lookupCtxtExact u--n (let ((e-33 (vector-ref e-5 0))) e-33)))) arg-3) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 (TTImpC-45ElabC-45App-n--11252-4610-u--dotTerm arg-0 e-0 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 arg-7)) (let ((e-1 (unbox e-7))) (let ((sc7 (PreludeC-45Types-elem (csegen-792) arg-4 (let ((e-4 (vector-ref e-1 4))) e-4)))) (cond ((equal? sc7 1) (vector 1 arg-7)) (else (vector 1 (TTImpC-45ElabC-45App-n--11252-4610-u--dotTerm arg-0 e-0 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 arg-7))))))))))))))))))))))) (else (vector 1 arg-7))))))(else (vector 1 arg-7))))))
(define TTImpC-45ElabC-45App-checkVisibleNS (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45Context-isVisible arg-0 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (CoreC-45Context-isAllPublic arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getNS arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-getNestedNS arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((sc6 (cond ((equal? e-6 1) 1) (else (CoreC-45Context-visibleInAny (cons e-7 e-8) (vector 0 e-0 e-1) arg-3))))) (cond ((equal? sc6 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 8 arg-1 (vector 0 e-0 e-1) '()) ext-0))))))))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 8 arg-1 (vector 0 e-0 e-1) (box e-0)) ext-0))))))))))(else (vector 1 0)))))
(define TTImpC-45ElabC-45App-checkValidPattern (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "elab.app.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking that " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-8) " is a valid pattern"))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (case (vector-ref arg-8 0) ((3) (let ((e-3 (vector-ref arg-8 3))) (case (vector-ref e-3 0) ((0) (TTImpC-45ElabC-45Dot-registerDot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 2 arg-8 arg-9 ext-0))(else (vector 1 (cons arg-8 arg-9))))))(else (vector 1 (cons arg-8 arg-9)))))))))
(define TTImpC-45ElabC-45App-checkRestApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 ext-0) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ElabC-45App-dotErased arg-0 arg-1 arg-14 e-2 e-3 (let ((e-0 (vector-ref arg-8 0))) e-0) arg-7 arg-17) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (cond ((equal? arg-21 1) (vector 1 1)) (else (let ((act-26 (((arg-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-10 (vector 10 arg-11 0))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45ElabC-45Check-concrete e-5 arg-10 e-7) ext-0))))))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 arg-14) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((TTImpC-45ElabC-45App-needsDelay arg-1 (let ((e-0 (vector-ref arg-8 0))) e-0) e-7 arg-17) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((sc6 (let ((sc7 (let ((sc8 (TTImpC-45ElabC-45App-isHole e-8))) (cond ((equal? sc8 1) e-7) (else 0))))) (cond ((equal? sc7 1) 1) (else e-9))))) (cond ((equal? sc6 1) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-0) (TTImpC-45ElabC-45App-n--11256-5325-u--checkRtoL arg-0 e-2 e-3 arg-22 arg-21 arg-20 arg-19 arg-18 arg-17 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 e-6 eta-0)) (lambda (u--err) (lambda (clam-0) (let ((sc7 (TTImpC-45ElabC-45App-n--11256-5324-u--invalidArg arg-0 e-2 e-3 arg-22 arg-21 arg-20 arg-19 arg-18 arg-17 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--err))) (cond ((equal? sc7 1) (TTImpC-45ElabC-45App-n--11256-5326-u--checkLtoR arg-0 e-2 e-3 arg-22 arg-21 arg-20 arg-19 arg-18 arg-17 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 e-6 clam-0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-0)))))) ext-0)) (else (TTImpC-45ElabC-45App-n--11256-5326-u--checkLtoR arg-0 e-2 e-3 arg-22 arg-21 arg-20 arg-19 arg-18 arg-17 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 e-6 ext-0))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-checkAppWithC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-12 0) ((0) (let ((e-9 (vector-ref arg-12 1))) (let ((e-10 (vector-ref arg-12 2))) (let ((e-11 (vector-ref arg-12 3))) (let ((e-12 (vector-ref arg-12 4))) (case (vector-ref e-11 0) ((2) (let ((e-18 (vector-ref e-11 1))) (let ((e-19 (vector-ref e-11 2))) (let ((e-20 (vector-ref e-11 3))) (let ((e-21 (vector-ref e-11 4))) (case (vector-ref e-20 0) ((1) (if (null? arg-14) (TTImpC-45ElabC-45App-with--checkAppWithC-39-8331 e-10 arg-16 (TTImpC-45ElabC-45App-findNamed e-10 arg-16) arg-0 e-18 e-21 e-19 e-12 e-9 arg-12 arg-18 arg-17 arg-15 arg-13 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (let ((e-28 (car arg-14))) (let ((e-29 (cdr arg-14))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-28 e-29 arg-15 arg-16 arg-17 arg-18 eta-0))))))) ((0) (if (null? arg-14) (if (null? arg-15) (if (null? arg-16) (if (null? arg-18) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (let ((sc7 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc7) (lambda (eta-0) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-2 (unbox sc7))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 arg-15 e-6 arg-17 arg-18 eta-0))))))))) (let ((e-35 (unbox arg-18))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-35) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--ty (vector 0 e-9 e-10 (vector 2 e-18 e-19 (vector 0 ) e-21) e-12))) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-9 u--ty) (box e-35) eta-0))(else (let ((sc11 (let ((e-16 (vector-ref arg-7 4))) e-16))) (cond ((equal? sc11 1) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-9 u--ty) (box e-35) eta-1)) (lambda (u--err) (lambda (eta-1) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-35) eta-1))) eta-0)) (else (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-35) eta-0))))))))(else (let ((sc10 (let ((e-8 (vector-ref arg-7 4))) e-8))) (cond ((equal? sc10 1) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-9 u--ty) (box e-35) eta-1)) (lambda (u--err) (lambda (eta-1) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-35) eta-1))) eta-0)) (else (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-35) eta-0))))))))(else (let ((sc9 (let ((e-4 (vector-ref arg-7 4))) e-4))) (cond ((equal? sc9 1) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-9 u--ty) (box e-35) eta-1)) (lambda (u--err) (lambda (eta-1) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-35) eta-1))) eta-0)) (else (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-35) eta-0))))))))))))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (let ((sc6 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc6) (lambda (eta-0) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-2 (unbox sc6))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 arg-15 e-6 arg-17 arg-18 eta-0)))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc5) (lambda (eta-0) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-2 (unbox sc5))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 arg-15 e-6 arg-17 arg-18 eta-0)))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (let ((sc4 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc4) (lambda (eta-0) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-2 (unbox sc4))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 arg-15 e-6 arg-17 arg-18 eta-0))))))))))) ((2) (if (null? arg-14) (if (null? arg-15) (if (null? arg-16) (if (null? arg-18) (if (null? arg-15) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (let ((sc8 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc8) (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 arg-14 '() arg-16 arg-17 arg-18) (let ((e-1 (unbox sc8))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 '() e-6 arg-17 arg-18 eta-0))))))))) (let ((e-37 (car arg-15))) (let ((e-38 (cdr arg-15))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19) arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-37 arg-14 e-38 arg-16 arg-17 arg-18 eta-0))))) (let ((e-44 (unbox arg-18))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-44) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--ty (vector 0 e-9 e-10 (vector 2 e-18 e-19 (vector 2 ) e-21) e-12))) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((2) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-9 u--ty) (box e-44) eta-0))(else ((TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-44)) eta-0)))))(else ((TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-44)) eta-0)))))(else ((TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 '() '() '() arg-17 (box e-44)) eta-0)))))))))))))))) (if (null? arg-15) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (let ((sc7 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc7) (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 arg-14 '() arg-16 arg-17 arg-18) (let ((e-1 (unbox sc7))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 '() e-6 arg-17 arg-18 eta-0))))))))) (let ((e-37 (car arg-15))) (let ((e-38 (cdr arg-15))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19) arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-37 arg-14 e-38 arg-16 arg-17 arg-18 eta-0)))))) (if (null? arg-15) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (let ((sc6 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc6) (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 arg-14 '() arg-16 arg-17 arg-18) (let ((e-1 (unbox sc6))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 '() e-6 arg-17 arg-18 eta-0))))))))) (let ((e-37 (car arg-15))) (let ((e-38 (cdr arg-15))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19) arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-37 arg-14 e-38 arg-16 arg-17 arg-18 eta-0)))))) (if (null? arg-15) (let ((u--argRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19))) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc5) (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 arg-14 '() arg-16 arg-17 arg-18) (let ((e-1 (unbox sc5))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 '() e-6 arg-17 arg-18 eta-0))))))))) (let ((e-37 (car arg-15))) (let ((e-38 (cdr arg-15))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-6 e-19) arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-37 arg-14 e-38 arg-16 arg-17 arg-18 eta-0))))))) ((3) (let ((e-26 (vector-ref e-20 1))) (if (null? arg-14) (if (null? arg-15) (if (null? arg-16) (if (null? arg-18) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-6 e-19))) (let ((sc7 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc7) (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-26 e-21 e-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-2 (unbox sc7))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 arg-15 e-6 arg-17 arg-18 eta-0))))))))) (let ((e-49 (unbox arg-18))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-6 e-19))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-49) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--ty (vector 0 e-9 e-10 (vector 2 e-18 e-19 (vector 3 e-26) e-21) e-12))) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((3) (let ((e-15 (vector-ref e-8 1))) (let ((act-26 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Closure arg-1 arg-0 e-6 arg-9 e-26 e-15 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (cond ((equal? e-16 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-9 u--ty) (box e-49) eta-0)) (else ((TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-26 e-21 e-12 arg-13 '() '() '() arg-17 (box e-49)) eta-0)))))))))(else ((TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-26 e-21 e-12 arg-13 '() '() '() arg-17 (box e-49)) eta-0)))))(else ((TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-26 e-21 e-12 arg-13 '() '() '() arg-17 (box e-49)) eta-0)))))(else ((TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-26 e-21 e-12 arg-13 '() '() '() arg-17 (box e-49)) eta-0)))))))))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-6 e-19))) (let ((sc6 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc6) (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-26 e-21 e-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-2 (unbox sc6))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 arg-15 e-6 arg-17 arg-18 eta-0)))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-6 e-19))) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc5) (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-26 e-21 e-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-2 (unbox sc5))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 arg-15 e-6 arg-17 arg-18 eta-0)))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-6 e-19))) (let ((sc4 (TTImpC-45ElabC-45App-findNamed e-10 arg-16))) (if (null? sc4) (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-26 e-21 e-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-2 (unbox sc4))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--argRig arg-7 arg-8 arg-9 arg-10 arg-11 e-10 e-21 e-12 arg-13 e-13 arg-14 arg-15 e-6 arg-17 arg-18 eta-0))))))))))))(else (if (null? arg-13) (lambda (clam-11) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc5 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc5 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-11)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-11))))))))) (let ((e-3 (car arg-13))) (let ((e-4 (cdr arg-13))) (lambda (clam-5) (if (null? arg-14) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc6 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc6 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-5)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-5)))))))) (let ((e-6 (car arg-14))) (let ((e-7 (cdr arg-14))) (let ((act-24 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function type") arg-9 arg-12 clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function ") arg-11 clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" clam-5))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-13 (vector 11 arg-10) clam-5))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-28 1))) (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-15))) (let ((act-29 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-14 (vector 11 arg-10) clam-5))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-29 1))) (let ((act-30 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (box u--argTyG)) clam-5))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-30 1))) (let ((e-2 (car e-17))) (let ((e-22 (cdr e-17))) (let ((u--fntm (vector 4 arg-10 arg-11 e-2))) (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-23 (vector-ref act-31 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-31 1))) (let ((act-32 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-23 arg-9 e-16) clam-5))) (case (vector-ref act-32 0) ((0) (let ((e-24 (vector-ref act-32 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-32 1))) (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (vector 3 arg-10 e-13 (vector 2 arg-10 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) e-15) (CoreC-45TT-u--weaken_Weaken_Term e-16))))) (let ((act-33 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected function type") arg-9 u--expfnty clam-5))) (case (vector-ref act-33 0) ((0) (let ((e-25 (vector-ref act-33 1))) (vector 0 e-25))) (else (let ((act-34 (if (null? arg-18) (vector 1 0) (let ((e-1 (unbox arg-18))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected result type") arg-9 e-1 clam-5))))) (case (vector-ref act-34 0) ((0) (let ((e-26 (vector-ref act-34 1))) (vector 0 e-26))) (else (let ((act-35 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 u--fntm e-24 (cons e-3 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-4)) e-7 arg-15 arg-16 arg-17 arg-18) clam-5))) (case (vector-ref act-35 0) ((0) (let ((e-27 (vector-ref act-35 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-35 1))) (let ((act-36 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-10 arg-7 arg-9 (CoreC-45Normalise-glueBack arg-1 arg-0 e-23 arg-9 arg-12) u--expfnty) clam-5))) (case (vector-ref act-36 0) ((0) (let ((e-28 (vector-ref act-36 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-36 1))) (let ((_-0 (cons e-2 e-22))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-10244 e-3 e-4 e-6 e-7 arg-0 arg-18 arg-17 arg-16 arg-15 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-13 e-14 e-15 u--argTyG e-16 e-2 e-22 _-0 u--fntm e-23 e-24 u--expfnty e-27 e-28 (let ((e-0 (vector-ref e-28 0))) e-0) clam-5)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))(else (if (null? arg-13) (lambda (clam-13) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc4 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc4 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-13)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-13))))))))) (let ((e-3 (car arg-13))) (let ((e-4 (cdr arg-13))) (lambda (clam-6) (if (null? arg-14) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc5 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc5 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-6)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-6)))))))) (let ((e-6 (car arg-14))) (let ((e-7 (cdr arg-14))) (let ((act-24 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function type") arg-9 arg-12 clam-6))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function ") arg-11 clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" clam-6))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-13 (vector 11 arg-10) clam-6))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-28 1))) (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-15))) (let ((act-29 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-14 (vector 11 arg-10) clam-6))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-29 1))) (let ((act-30 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (box u--argTyG)) clam-6))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-30 1))) (let ((e-2 (car e-17))) (let ((e-18 (cdr e-17))) (let ((u--fntm (vector 4 arg-10 arg-11 e-2))) (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-19 (vector-ref act-31 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-31 1))) (let ((act-32 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-19 arg-9 e-16) clam-6))) (case (vector-ref act-32 0) ((0) (let ((e-20 (vector-ref act-32 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-32 1))) (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (vector 3 arg-10 e-13 (vector 2 arg-10 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) e-15) (CoreC-45TT-u--weaken_Weaken_Term e-16))))) (let ((act-33 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected function type") arg-9 u--expfnty clam-6))) (case (vector-ref act-33 0) ((0) (let ((e-21 (vector-ref act-33 1))) (vector 0 e-21))) (else (let ((act-34 (if (null? arg-18) (vector 1 0) (let ((e-1 (unbox arg-18))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected result type") arg-9 e-1 clam-6))))) (case (vector-ref act-34 0) ((0) (let ((e-22 (vector-ref act-34 1))) (vector 0 e-22))) (else (let ((act-35 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 u--fntm e-20 (cons e-3 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-4)) e-7 arg-15 arg-16 arg-17 arg-18) clam-6))) (case (vector-ref act-35 0) ((0) (let ((e-23 (vector-ref act-35 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-35 1))) (let ((act-36 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-10 arg-7 arg-9 (CoreC-45Normalise-glueBack arg-1 arg-0 e-19 arg-9 arg-12) u--expfnty) clam-6))) (case (vector-ref act-36 0) ((0) (let ((e-24 (vector-ref act-36 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-36 1))) (let ((_-0 (cons e-2 e-18))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-10244 e-3 e-4 e-6 e-7 arg-0 arg-18 arg-17 arg-16 arg-15 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-13 e-14 e-15 u--argTyG e-16 e-2 e-18 _-0 u--fntm e-19 e-20 u--expfnty e-23 e-24 (let ((e-0 (vector-ref e-24 0))) e-0) clam-6))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) ((5) (let ((e-14 (vector-ref arg-12 1))) (let ((e-15 (vector-ref arg-12 2))) (let ((e-16 (vector-ref arg-12 3))) (case (vector-ref e-16 0) ((0) (let ((e-53 (vector-ref e-16 3))) (case (vector-ref e-53 0) ((2) (TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 e-14 e-15 arg-11) e-16 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18))(else (if (null? arg-13) (lambda (clam-15) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc5 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc5 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-15)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-15))))))))) (let ((e-3 (car arg-13))) (let ((e-4 (cdr arg-13))) (lambda (clam-7) (if (null? arg-14) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc6 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc6 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-7)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-7)))))))) (let ((e-6 (car arg-14))) (let ((e-7 (cdr arg-14))) (let ((act-24 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function type") arg-9 arg-12 clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function ") arg-11 clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" clam-7))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-9 (vector 11 arg-10) clam-7))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-28 1))) (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-11))) (let ((act-29 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-10 (vector 11 arg-10) clam-7))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-29 1))) (let ((act-30 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (box u--argTyG)) clam-7))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-30 1))) (let ((e-2 (car e-13))) (let ((e-17 (cdr e-13))) (let ((u--fntm (vector 4 arg-10 arg-11 e-2))) (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-18 (vector-ref act-31 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-31 1))) (let ((act-32 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-18 arg-9 e-12) clam-7))) (case (vector-ref act-32 0) ((0) (let ((e-19 (vector-ref act-32 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-32 1))) (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (vector 3 arg-10 e-9 (vector 2 arg-10 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) e-11) (CoreC-45TT-u--weaken_Weaken_Term e-12))))) (let ((act-33 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected function type") arg-9 u--expfnty clam-7))) (case (vector-ref act-33 0) ((0) (let ((e-20 (vector-ref act-33 1))) (vector 0 e-20))) (else (let ((act-34 (if (null? arg-18) (vector 1 0) (let ((e-1 (unbox arg-18))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected result type") arg-9 e-1 clam-7))))) (case (vector-ref act-34 0) ((0) (let ((e-21 (vector-ref act-34 1))) (vector 0 e-21))) (else (let ((act-35 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 u--fntm e-19 (cons e-3 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-4)) e-7 arg-15 arg-16 arg-17 arg-18) clam-7))) (case (vector-ref act-35 0) ((0) (let ((e-22 (vector-ref act-35 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-35 1))) (let ((act-36 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-10 arg-7 arg-9 (CoreC-45Normalise-glueBack arg-1 arg-0 e-18 arg-9 arg-12) u--expfnty) clam-7))) (case (vector-ref act-36 0) ((0) (let ((e-23 (vector-ref act-36 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-36 1))) (let ((_-0 (cons e-2 e-17))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-10244 e-3 e-4 e-6 e-7 arg-0 arg-18 arg-17 arg-16 arg-15 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 e-10 e-11 u--argTyG e-12 e-2 e-17 _-0 u--fntm e-18 e-19 u--expfnty e-22 e-23 (let ((e-0 (vector-ref e-23 0))) e-0) clam-7))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))(else (if (null? arg-13) (lambda (clam-17) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc4 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc4 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-17)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-17))))))))) (let ((e-3 (car arg-13))) (let ((e-4 (cdr arg-13))) (lambda (clam-8) (if (null? arg-14) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc5 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc5 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-8)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-8)))))))) (let ((e-6 (car arg-14))) (let ((e-7 (cdr arg-14))) (let ((act-24 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function type") arg-9 arg-12 clam-8))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function ") arg-11 clam-8))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-8))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" clam-8))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-9 (vector 11 arg-10) clam-8))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-28 1))) (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-11))) (let ((act-29 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-10 (vector 11 arg-10) clam-8))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-29 1))) (let ((act-30 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (box u--argTyG)) clam-8))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-30 1))) (let ((e-2 (car e-13))) (let ((e-17 (cdr e-13))) (let ((u--fntm (vector 4 arg-10 arg-11 e-2))) (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-18 (vector-ref act-31 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-31 1))) (let ((act-32 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-18 arg-9 e-12) clam-8))) (case (vector-ref act-32 0) ((0) (let ((e-19 (vector-ref act-32 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-32 1))) (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (vector 3 arg-10 e-9 (vector 2 arg-10 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) e-11) (CoreC-45TT-u--weaken_Weaken_Term e-12))))) (let ((act-33 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected function type") arg-9 u--expfnty clam-8))) (case (vector-ref act-33 0) ((0) (let ((e-20 (vector-ref act-33 1))) (vector 0 e-20))) (else (let ((act-34 (if (null? arg-18) (vector 1 0) (let ((e-1 (unbox arg-18))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected result type") arg-9 e-1 clam-8))))) (case (vector-ref act-34 0) ((0) (let ((e-21 (vector-ref act-34 1))) (vector 0 e-21))) (else (let ((act-35 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 u--fntm e-19 (cons e-3 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-4)) e-7 arg-15 arg-16 arg-17 arg-18) clam-8))) (case (vector-ref act-35 0) ((0) (let ((e-22 (vector-ref act-35 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-35 1))) (let ((act-36 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-10 arg-7 arg-9 (CoreC-45Normalise-glueBack arg-1 arg-0 e-18 arg-9 arg-12) u--expfnty) clam-8))) (case (vector-ref act-36 0) ((0) (let ((e-23 (vector-ref act-36 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-36 1))) (let ((_-0 (cons e-2 e-17))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-10244 e-3 e-4 e-6 e-7 arg-0 arg-18 arg-17 arg-16 arg-15 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 e-10 e-11 u--argTyG e-12 e-2 e-17 _-0 u--fntm e-18 e-19 u--expfnty e-22 e-23 (let ((e-0 (vector-ref e-23 0))) e-0) clam-8))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))(else (if (null? arg-13) (lambda (clam-19) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc3 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-19)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-19))))))))) (let ((e-3 (car arg-13))) (let ((e-4 (cdr arg-13))) (lambda (clam-9) (if (null? arg-14) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc4 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-filter (csegen-2130) arg-16)))))) (cond ((equal? sc4 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-9 arg-10 arg-11 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-9 arg-12) arg-18 clam-9)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-0 arg-10 arg-9 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-16)) arg-11) clam-9)))))))) (let ((e-6 (car arg-14))) (let ((e-7 (cdr arg-14))) (let ((act-24 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function type") arg-9 arg-12 clam-9))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Function ") arg-11 clam-9))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-9))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" clam-9))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-9 (vector 11 arg-10) clam-9))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-28 1))) (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-11))) (let ((act-29 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-10 (vector 11 arg-10) clam-9))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-29 1))) (let ((act-30 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (box u--argTyG)) clam-9))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-30 1))) (let ((e-2 (car e-13))) (let ((e-14 (cdr e-13))) (let ((u--fntm (vector 4 arg-10 arg-11 e-2))) (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-15 (vector-ref act-31 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-31 1))) (let ((act-32 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-15 arg-9 e-12) clam-9))) (case (vector-ref act-32 0) ((0) (let ((e-16 (vector-ref act-32 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-32 1))) (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 (vector 3 arg-10 e-9 (vector 2 arg-10 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) e-11) (CoreC-45TT-u--weaken_Weaken_Term e-12))))) (let ((act-33 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected function type") arg-9 u--expfnty clam-9))) (case (vector-ref act-33 0) ((0) (let ((e-17 (vector-ref act-33 1))) (vector 0 e-17))) (else (let ((act-34 (if (null? arg-18) (vector 1 0) (let ((e-1 (unbox arg-18))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Expected result type") arg-9 e-1 clam-9))))) (case (vector-ref act-34 0) ((0) (let ((e-18 (vector-ref act-34 1))) (vector 0 e-18))) (else (let ((act-35 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 u--fntm e-16 (cons e-3 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) e-4)) e-7 arg-15 arg-16 arg-17 arg-18) clam-9))) (case (vector-ref act-35 0) ((0) (let ((e-19 (vector-ref act-35 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-35 1))) (let ((act-36 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-10 arg-7 arg-9 (CoreC-45Normalise-glueBack arg-1 arg-0 e-15 arg-9 arg-12) u--expfnty) clam-9))) (case (vector-ref act-36 0) ((0) (let ((e-20 (vector-ref act-36 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-36 1))) (let ((_-0 (cons e-2 e-14))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-10244 e-3 e-4 e-6 e-7 arg-0 arg-18 arg-17 arg-16 arg-15 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 e-10 e-11 u--argTyG e-12 e-2 e-14 _-0 u--fntm e-15 e-16 u--expfnty e-19 e-20 (let ((e-0 (vector-ref e-20 0))) e-0) clam-9))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-checkAppWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (let ((act-24 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (TTImpC-45ElabC-45Check-isLHS (let ((e-0 (vector-ref arg-7 0))) e-0)))) (if (null? sc1) (vector 1 e-5) (let ((e-1 (unbox sc1))) ((TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWith-10645 arg-0 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-1 (CoreC-45TT-getFnArgs (Builtin-fst e-5))) ext-0))))))))))
(define TTImpC-45ElabC-45App-checkApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (case (vector-ref arg-11 0) ((8) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 e-2 (cons e-3 arg-12) arg-13 arg-14 arg-15))))) ((9) (let ((e-5 (vector-ref arg-11 1))) (let ((e-6 (vector-ref arg-11 2))) (let ((e-7 (vector-ref arg-11 3))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5 e-6 arg-12 (cons e-7 arg-13) arg-14 arg-15))))) ((10) (let ((e-9 (vector-ref arg-11 1))) (let ((e-10 (vector-ref arg-11 2))) (let ((e-11 (vector-ref arg-11 3))) (let ((e-12 (vector-ref arg-11 4))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-9 e-10 arg-12 arg-13 (cons (cons e-11 e-12) arg-14) arg-15)))))) ((0) (let ((e-14 (vector-ref arg-11 1))) (let ((e-15 (vector-ref arg-11 2))) (lambda (eta-0) (let ((act-24 ((TTImpC-45ElabC-45App-getVarType arg-0 arg-1 arg-2 arg-4 arg-6 arg-8 arg-9 e-14 e-15) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-7) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getPrimitiveNames arg-1 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ElabC-45App-n--20048-11105-u--updateElabInfo arg-0 e-15 e-14 arg-15 arg-14 arg-13 arg-12 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 (let ((e-0 (vector-ref arg-7 0))) e-0) e-15 arg-12 arg-7) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Metadata-addNameLoc arg-2 arg-1 e-14 e-15 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "elab" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-1) (let ((act-29 (let ((act-29 (unbox arg-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-29 1))) (let ((act-30 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-12 arg-9 e-8 eta-1))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-30 1))) (let ((act-31 ((PreludeC-45Types-maybe (lambda () (lambda (eta-2) (vector 1 '()))) (lambda () (lambda (u--t) (lambda (eta-2) (let ((act-31 ((CoreC-45NormaliseC-45Eval-getTerm u--t) eta-2))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-12 arg-9 e-16 eta-2))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-17 eta-2))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-33 1))) (vector 1 (box e-18))))))))))))))))) arg-15) eta-1))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Context-getFullName arg-1 e-15 eta-1))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-13 eta-1))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-33 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Checking application of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-17) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-15) (PreludeC-45TypesC-45String-C-43C-43 ")" (PreludeC-45TypesC-45String-C-43C-43 " to " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1280) arg-12) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;Function type " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-18) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;Expected app type " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d u--x)))) e-16))))))))))))))))))))))))))))))))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((u--fn (let ((sc9 (DataC-45List-lookup (csegen-802) e-15 arg-8))) (if (null? sc9) e-15 (let ((e-1 (unbox sc9))) (if (null? e-1) e-15 (let ((e-4 (car e-1))) (if (null? e-4) e-15 (let ((e-16 (unbox e-4))) e-16))))))))) (let ((act-30 (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-10 arg-8 arg-9 arg-10 e-2 e-8 (cons (box u--fn) e-6) arg-12 arg-13 arg-14 0 arg-15 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-30 1))) (TTImpC-45ElabC-45App-n--20048-11104-u--normalisePrims arg-0 e-15 e-14 arg-15 arg-14 arg-13 arg-12 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-9 arg-9 e-13 eta-0))))))))))))))))))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-6 (cons '() 0) arg-12 arg-13 arg-14 0 arg-15 eta-0))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandAmbigName-8870 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-16) (let ((act-24 ((CoreC-45Context-lookupCtxtName arg-1 (let ((e-0 (vector-ref arg-11 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-filterM (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-n--10137-7815-u--visible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (CoreC-45ContextC-45Log-log arg-10 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Failed to find " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-5))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 arg-5)))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (if (null? e-3) (let ((act-26 (CoreC-45ContextC-45Log-log arg-10 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Only one " (CoreC-45Name-u--show_Show_Name (Builtin-fst e-2)))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (TTImpC-45ElabC-45Ambiguity-n--10137-7820-u--mkAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-15 arg-12 e-2))))) (vector 1 (vector 13 arg-2 (TTImpC-45ElabC-45Ambiguity-n--10137-7816-u--uniqType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-1 arg-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-n--10137-7820-u--mkAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-15 arg-12 eta-0)) e-6))))))))))))))) (let ((e-1 (unbox arg-16))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-10 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "unambiguous: " (CoreC-45Name-u--show_Show_Name (Builtin-fst e-1)))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (TTImpC-45ElabC-45Ambiguity-n--10137-7820-u--mkAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-15 arg-12 e-1)))))))))
(define TTImpC-45ElabC-45Ambiguity-case--expandAmbigNameC-44visible-7850 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (case (vector-ref arg-14 0) ((0) (let ((e-0 (vector-ref arg-14 1))) (let ((e-1 (vector-ref arg-14 2))) (let ((act-24 (CoreC-45Context-isVisible arg-10 e-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (CoreC-45Context-getNS arg-10 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getNestedNS arg-10 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45Context-visibleInAny (cons e-6 e-7) (vector 0 e-0 e-1) (let ((e-9 (vector-ref arg-13 9))) e-9)))))))))))) (else (vector 1 0))))))))))(else (vector 1 1)))))
(define TTImpC-45ElabC-45Ambiguity-n--10137-7818-u--wrapDot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-16 0) ((5) arg-17) ((6) arg-17)(else (case (vector-ref arg-13 0) ((1) (if (null? arg-15) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-14 (vector 8 (let ((e-2 (vector-ref arg-12 1))) e-2))))) (cond ((equal? sc2 1) arg-17) (else (vector 19 arg-2 2 arg-17)))) (let ((e-3 (cdr arg-15))) (if (null? e-3) (let ((sc3 (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name arg-14 (vector 8 (let ((e-16 (vector-ref arg-12 1))) e-16))))) (cond ((equal? sc4 1) 1) (else arg-11))))) (cond ((equal? sc3 1) arg-17) (else (vector 19 arg-2 2 arg-17)))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name arg-14 (vector 8 (let ((e-16 (vector-ref arg-12 1))) e-16))))) (cond ((equal? sc3 1) arg-17) (else (vector 19 arg-2 2 arg-17))))))))(else arg-17))))))
(define TTImpC-45ElabC-45Ambiguity-n--10137-7815-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-case--expandAmbigNameC-44visible-7850 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-6 e-7 (let ((e-1 (vector-ref e-7 1))) e-1) eta-0))))))))
(define TTImpC-45ElabC-45Ambiguity-n--10137-7816-u--uniqType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-0 (vector-ref arg-11 0))) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (if (null? e-0) (if (null? e-1) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-52 (cdr e-48))) (case (vector-ref e-52 0) ((28) (let ((e-54 (vector-ref e-52 1))) (let ((e-55 (vector-ref e-52 2))) (case (vector-ref e-55 0) ((10) (let ((e-56 (vector-ref e-55 1))) (if (null? e-44) (vector 2 (vector 28 e-54 (vector 10 e-56))) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-1) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-52 (cdr e-48))) (case (vector-ref e-52 0) ((28) (let ((e-54 (vector-ref e-52 1))) (let ((e-55 (vector-ref e-52 2))) (case (vector-ref e-55 0) ((10) (let ((e-56 (vector-ref e-55 1))) (if (null? e-44) (vector 2 (vector 28 e-54 (vector 10 e-56))) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-61 (car arg-13))) (let ((e-62 (cdr arg-13))) (if (null? e-61) (if (null? e-1) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-52 (cdr e-48))) (case (vector-ref e-52 0) ((28) (let ((e-54 (vector-ref e-52 1))) (let ((e-55 (vector-ref e-52 2))) (case (vector-ref e-55 0) ((10) (let ((e-56 (vector-ref e-55 1))) (if (null? e-44) (vector 2 (vector 28 e-54 (vector 10 e-56))) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-66 (cdr e-61))) (if (null? e-66) (if (null? e-1) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-52 (cdr e-48))) (case (vector-ref e-52 0) ((28) (let ((e-54 (vector-ref e-52 1))) (let ((e-55 (vector-ref e-52 2))) (case (vector-ref e-55 0) ((10) (let ((e-56 (vector-ref e-55 1))) (if (null? e-44) (vector 2 (vector 28 e-54 (vector 10 e-56))) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-70 (cdr e-66))) (case (vector-ref e-70 0) ((28) (let ((e-72 (vector-ref e-70 1))) (let ((e-73 (vector-ref e-70 2))) (case (vector-ref e-73 0) ((5) (let ((e-74 (vector-ref e-73 1))) (if (null? e-62) (vector 2 (vector 28 e-72 (vector 5 e-74))) (if (null? e-1) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-52 (cdr e-48))) (case (vector-ref e-52 0) ((28) (let ((e-54 (vector-ref e-52 1))) (let ((e-55 (vector-ref e-52 2))) (case (vector-ref e-55 0) ((10) (let ((e-56 (vector-ref e-55 1))) (if (null? e-44) (vector 2 (vector 28 e-54 (vector 10 e-56))) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))))))))))(else (if (null? e-1) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-52 (cdr e-48))) (case (vector-ref e-52 0) ((28) (let ((e-54 (vector-ref e-52 1))) (let ((e-55 (vector-ref e-52 2))) (case (vector-ref e-55 0) ((10) (let ((e-56 (vector-ref e-55 1))) (if (null? e-44) (vector 2 (vector 28 e-54 (vector 10 e-56))) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))))))))))))(else (if (null? e-1) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))) (let ((e-52 (cdr e-48))) (case (vector-ref e-52 0) ((28) (let ((e-54 (vector-ref e-52 1))) (let ((e-55 (vector-ref e-52 2))) (case (vector-ref e-55 0) ((10) (let ((e-56 (vector-ref e-55 1))) (if (null? e-44) (vector 2 (vector 28 e-54 (vector 10 e-56))) (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))) (let ((e-34 (cdr e-30))) (case (vector-ref e-34 0) ((28) (let ((e-36 (vector-ref e-34 1))) (let ((e-37 (vector-ref e-34 2))) (case (vector-ref e-37 0) ((11) (let ((e-38 (vector-ref e-37 1))) (if (null? e-26) (vector 2 (vector 28 e-36 (vector 11 e-38))) (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 ))))))))))))))))(else (if (null? e-3) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-7 (car arg-13))) (let ((e-8 (cdr arg-13))) (if (null? e-7) (vector 1 ) (let ((e-12 (cdr e-7))) (if (null? e-12) (vector 1 ) (let ((e-16 (cdr e-12))) (case (vector-ref e-16 0) ((28) (let ((e-18 (vector-ref e-16 1))) (let ((e-19 (vector-ref e-16 2))) (case (vector-ref e-19 0) ((12) (let ((e-20 (vector-ref e-19 1))) (if (null? e-8) (vector 2 (vector 28 e-18 (vector 12 e-20))) (vector 1 ))))(else (vector 1 ))))))(else (vector 1 )))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-n--13019-10284-u--notOverloadableFn (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 2))) (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-2 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 1) (vector 1 0))))))))(else (vector 1 1)))))
(define TTImpC-45ElabC-45Ambiguity-n--10137-7821-u--notLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) 0)(else 1))))
(define TTImpC-45ElabC-45Ambiguity-n--10137-7819-u--mkTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((u--tm (TTImpC-45ElabC-45Ambiguity-n--10137-7818-u--wrapDot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-8 arg-13 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd (Builtin-snd eta-0))) arg-4) (let ((e-17 (vector-ref arg-14 17))) e-17) (TTImpC-45ElabC-45Ambiguity-n--10137-7817-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 0 arg-2 arg-13) arg-4)))) (let ((sc0 (PreludeC-45Types-elem (csegen-1023) (vector 6 ) (let ((e-11 (vector-ref arg-14 11))) e-11)))) (cond ((equal? sc0 1) (case (vector-ref arg-8 0) ((1) u--tm)(else (vector 27 arg-2 (vector 15 arg-2 u--tm))))) (else u--tm))))))
(define TTImpC-45ElabC-45Ambiguity-n--10137-7820-u--mkAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-3 (cdr arg-13))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (TTImpC-45ElabC-45Ambiguity-n--10137-7819-u--mkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (vector 8 e-6) e-7))))))
(define TTImpC-45ElabC-45Ambiguity-n--10137-7814-u--lookupUN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13) (if (null? arg-12) '() (let ((e-2 (unbox arg-12))) (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-13)))))
(define TTImpC-45ElabC-45Ambiguity-n--10137-7817-u--buildAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) arg-11 (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-10) (TTImpC-45ElabC-45Ambiguity-n--10137-7817-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 e-6 arg-11 e-11) e-3) (let ((e-14 (unbox e-10))) (if (null? e-14) (TTImpC-45ElabC-45Ambiguity-n--10137-7817-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 9 e-6 arg-11 e-11) e-3) (let ((e-17 (unbox e-14))) (TTImpC-45ElabC-45Ambiguity-n--10137-7817-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 10 e-6 arg-11 e-17 e-11) e-3))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-stripDelay (lambda (arg-1) (case (vector-ref arg-1 0) ((5) (let ((e-3 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Ambiguity-stripDelay e-3)))(else arg-1))))
(define TTImpC-45ElabC-45Ambiguity-pruneByType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Ambiguity-couldBe arg-1 arg-0 e-5 (TTImpC-45ElabC-45Ambiguity-stripDelay arg-4) eta-0 eta-1))) arg-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--matches (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-6))) (let ((act-26 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.prune" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Prune by") arg-3 arg-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "elab.prune" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2131) u--matches)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((sc4 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (Builtin-fst eta-0)) u--matches))) (cond ((equal? sc4 1) (let ((act-28 (TTImpC-45ElabC-45Ambiguity-filterCore (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-notOverloadable e-5 eta-0)) u--matches ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-1 "elab.prune" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Keep " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2131) e-9))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-9)))))))))) (else (vector 1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) u--matches))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((sc5 (DataC-45List-isNil e-9))) (cond ((equal? sc5 1) (vector 1 arg-5)) (else (vector 1 e-9)))))))))))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-notOverloadable (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 1) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-n--13019-10284-u--notOverloadableFn e-2 e-3 arg-0 (TTImpC-45TTImp-getFn e-3) eta-0))))))))
(define TTImpC-45ElabC-45Ambiguity-mightMatchD (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (TTImpC-45ElabC-45Ambiguity-mightMatch arg-0 arg-1 arg-2 (TTImpC-45ElabC-45Ambiguity-stripDelay arg-3) (TTImpC-45ElabC-45Ambiguity-stripDelay arg-4))))
(define TTImpC-45ElabC-45Ambiguity-mightMatchArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-3) (if (null? arg-4) (vector 1 1) (vector 1 0)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? arg-4) (vector 1 0) (let ((e-6 (car arg-4))) (let ((e-7 (cdr arg-4))) (let ((act-24 (TTImpC-45ElabC-45Ambiguity-mightMatchArg arg-0 arg-1 arg-2 e-2 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 e-3 e-7) clam-0)) (else (vector 1 0))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-mightMatchArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-2 arg-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ElabC-45Ambiguity-mightMatchD arg-0 arg-1 arg-2 e-5 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cond ((equal? e-7 2) 0)(else 1)))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-mightMatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-59 (vector-ref arg-4 1))) (let ((e-61 (vector-ref arg-4 3))) (let ((e-62 (vector-ref arg-4 4))) (case (vector-ref e-61 0) ((2) (lambda (eta-0) (let ((act-24 (((e-62 arg-2) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-59 0))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ElabC-45Ambiguity-mightMatchD arg-0 arg-1 arg-2 arg-3 e-5) eta-0)))))))(else (case (vector-ref arg-3 0) ((0) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (vector 1 1))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))) ((3) (let ((e-14 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((3) (let ((e-43 (vector-ref arg-4 2))) (let ((e-46 (vector-ref arg-4 5))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-14 e-43))) (cond ((equal? sc3 1) (let ((act-24 ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-17) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-46)) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (vector 1 0)) (else (vector 1 2)))))))) (else (vector 1 2)))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))) ((2) (let ((e-21 (vector-ref arg-3 3))) (let ((e-23 (vector-ref arg-3 5))) (lambda (clam-2) (case (vector-ref arg-4 0) ((2) (let ((e-50 (vector-ref arg-4 3))) (let ((e-52 (vector-ref arg-4 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-21 e-50))) (cond ((equal? sc3 1) (let ((act-24 ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-23) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-52)) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (vector 1 0)) (else (vector 1 2)))))))) (else (vector 1 2)))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))) ((8) (let ((e-26 (vector-ref arg-3 2))) (lambda (clam-3) (case (vector-ref arg-4 0) ((8) (let ((e-55 (vector-ref arg-4 2))) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-26 e-55))) (cond ((equal? sc3 1) (vector 1 0)) (else (vector 1 2))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2)))))))) ((10) (lambda (clam-4) (case (vector-ref arg-4 0) ((10) (vector 1 0))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))) ((1) (lambda (eta-0) (vector 1 1))) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-8) (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))))))(else (case (vector-ref arg-3 0) ((0) (lambda (clam-5) (case (vector-ref arg-4 0) ((0) (vector 1 1))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))) ((3) (let ((e-14 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 5))) (lambda (clam-6) (case (vector-ref arg-4 0) ((3) (let ((e-43 (vector-ref arg-4 2))) (let ((e-46 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-14 e-43))) (cond ((equal? sc2 1) (let ((act-24 ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-17) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-46)) clam-6))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (vector 1 0)) (else (vector 1 2)))))))) (else (vector 1 2)))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))) ((2) (let ((e-21 (vector-ref arg-3 3))) (let ((e-23 (vector-ref arg-3 5))) (lambda (clam-7) (case (vector-ref arg-4 0) ((2) (let ((e-50 (vector-ref arg-4 3))) (let ((e-52 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-21 e-50))) (cond ((equal? sc2 1) (let ((act-24 ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-23) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-52)) clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (vector 1 0)) (else (vector 1 2)))))))) (else (vector 1 2)))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))) ((8) (let ((e-26 (vector-ref arg-3 2))) (lambda (clam-8) (case (vector-ref arg-4 0) ((8) (let ((e-55 (vector-ref arg-4 2))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-26 e-55))) (cond ((equal? sc2 1) (vector 1 0)) (else (vector 1 2))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2)))))))) ((10) (lambda (clam-9) (case (vector-ref arg-4 0) ((10) (vector 1 0))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))) ((1) (lambda (eta-0) (vector 1 1))) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-17) (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))))
(define TTImpC-45ElabC-45Ambiguity-getName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (box e-2))) ((8) (let ((e-5 (vector-ref arg-0 2))) (TTImpC-45ElabC-45Ambiguity-getName e-5))) ((10) (let ((e-9 (vector-ref arg-0 2))) (TTImpC-45ElabC-45Ambiguity-getName e-9))) ((9) (let ((e-14 (vector-ref arg-0 2))) (TTImpC-45ElabC-45Ambiguity-getName e-14)))(else '()))))
(define TTImpC-45ElabC-45Ambiguity-filterCore (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 ((arg-1 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ElabC-45Ambiguity-filterCore arg-1 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-5 1) (vector 1 (cons e-2 e-6))) (else (vector 1 e-6))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-expandAmbigName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-3 0) ((1) (case (vector-ref arg-8 0) ((17) (let ((e-18 (vector-ref arg-8 1))) (let ((e-19 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (PreludeC-45Types-elem (csegen-802) (vector 1 (vector 0 e-19)) (let ((e-8 (vector-ref e-5 7))) e-8)))) (cond ((equal? sc3 1) (vector 1 (vector 19 e-18 0 arg-6))) (else (vector 1 arg-6))))))))))))(else (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (clam-0) (let ((sc2 (DataC-45List-lookup (csegen-802) e-2 arg-4))) (if (null? sc2) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc4 (CoreC-45Env-defined arg-0 e-2 arg-5))) (if (null? sc4) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getPrimNames arg-1 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--prims (CoreC-45Options-primNamesToList e-7))) (let ((u--primApp (CoreC-45Context-isPrimName u--prims e-2))) (TTImpC-45ElabC-45Ambiguity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandAmbigName-8870 arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 e-7 u--prims u--primApp (TTImpC-45ElabC-45Ambiguity-n--10137-7814-u--lookupUN arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45Name-userNameRoot e-2) (let ((e-14 (vector-ref e-6 13))) e-14)) clam-0))))))))))) (let ((sc5 (let ((sc6 (DataC-45List-isNil arg-7))) (cond ((equal? sc6 1) 1) (else (TTImpC-45ElabC-45Ambiguity-n--10137-7821-u--notLHS arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3)))))) (cond ((equal? sc5 1) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Defined in env " (CoreC-45Name-u--show_Show_Name e-2))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 arg-6))))) (else (vector 1 (vector 19 e-1 1 arg-6))))))))))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Nested " (CoreC-45Name-u--show_Show_Name e-2))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 arg-6)))))))))) ((8) (let ((e-4 (vector-ref arg-8 1))) (let ((e-5 (vector-ref arg-8 2))) (let ((e-6 (vector-ref arg-8 3))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-4 (cons '() e-6)) arg-7) e-5 arg-9))))) ((10) (let ((e-8 (vector-ref arg-8 1))) (let ((e-9 (vector-ref arg-8 2))) (let ((e-10 (vector-ref arg-8 3))) (let ((e-11 (vector-ref arg-8 4))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-8 (cons (box (box e-10)) e-11)) arg-7) e-9 arg-9)))))) ((9) (let ((e-13 (vector-ref arg-8 1))) (let ((e-14 (vector-ref arg-8 2))) (let ((e-15 (vector-ref arg-8 3))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-13 (cons (box '()) e-15)) arg-7) e-14 arg-9)))))(else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "No ambiguity " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-6))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 arg-6))))))))))(else (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (clam-1) (let ((sc1 (DataC-45List-lookup (csegen-802) e-2 arg-4))) (if (null? sc1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (CoreC-45Env-defined arg-0 e-2 arg-5))) (if (null? sc3) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getPrimNames arg-1 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--prims (CoreC-45Options-primNamesToList e-7))) (let ((u--primApp (CoreC-45Context-isPrimName u--prims e-2))) (TTImpC-45ElabC-45Ambiguity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandAmbigName-8870 arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 e-7 u--prims u--primApp (TTImpC-45ElabC-45Ambiguity-n--10137-7814-u--lookupUN arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45Name-userNameRoot e-2) (let ((e-14 (vector-ref e-6 13))) e-14)) clam-1))))))))))) (let ((sc4 (let ((sc5 (DataC-45List-isNil arg-7))) (cond ((equal? sc5 1) 1) (else (TTImpC-45ElabC-45Ambiguity-n--10137-7821-u--notLHS arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3)))))) (cond ((equal? sc4 1) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Defined in env " (CoreC-45Name-u--show_Show_Name e-2))) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 arg-6))))) (else (vector 1 (vector 19 e-1 1 arg-6))))))))))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Nested " (CoreC-45Name-u--show_Show_Name e-2))) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 arg-6)))))))))) ((8) (let ((e-4 (vector-ref arg-8 1))) (let ((e-5 (vector-ref arg-8 2))) (let ((e-6 (vector-ref arg-8 3))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-4 (cons '() e-6)) arg-7) e-5 arg-9))))) ((10) (let ((e-8 (vector-ref arg-8 1))) (let ((e-9 (vector-ref arg-8 2))) (let ((e-10 (vector-ref arg-8 3))) (let ((e-11 (vector-ref arg-8 4))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-8 (cons (box (box e-10)) e-11)) arg-7) e-9 arg-9)))))) ((9) (let ((e-13 (vector-ref arg-8 1))) (let ((e-14 (vector-ref arg-8 2))) (let ((e-15 (vector-ref arg-8 3))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-13 (cons (box '()) e-15)) arg-7) e-14 arg-9)))))(else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "No ambiguity " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-6))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 arg-6)))))))))))
(define TTImpC-45ElabC-45Ambiguity-couldBeName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-lookupTyExact arg-4 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 1) (let ((e-2 (unbox e-5))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() arg-2 '() e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ElabC-45Ambiguity-mightMatchD arg-0 arg-1 arg-2 arg-3 e-6) ext-0)))))))))))))
(define TTImpC-45ElabC-45Ambiguity-couldBeFn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (TTImpC-45ElabC-45Ambiguity-couldBeName arg-0 arg-1 arg-2 arg-3 e-2 clam-0))) ((13) (vector 1 0))(else (vector 1 1))))))
(define TTImpC-45ElabC-45Ambiguity-couldBe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-3 0) ((3) (let ((act-24 ((TTImpC-45ElabC-45Ambiguity-couldBeFn arg-0 arg-1 arg-2 arg-3 (TTImpC-45TTImp-getFn arg-4)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (cond ((equal? e-6 0) (vector 1 (box (cons 1 arg-4)))) ((equal? e-6 1) (vector 1 (box (cons 0 arg-4)))) (else (vector 1 '())))))))) ((8) (let ((act-24 ((TTImpC-45ElabC-45Ambiguity-couldBeFn arg-0 arg-1 arg-2 arg-3 (TTImpC-45TTImp-getFn arg-4)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (box (cons 1 arg-4)))) ((equal? e-5 1) (vector 1 (box (cons 0 arg-4)))) (else (vector 1 '())))))))) ((10) (let ((act-24 ((TTImpC-45ElabC-45Ambiguity-couldBeFn arg-0 arg-1 arg-2 arg-3 (TTImpC-45TTImp-getFn arg-4)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (vector 1 (box (cons 1 arg-4)))) ((equal? e-5 1) (vector 1 (box (cons 0 arg-4)))) (else (vector 1 '()))))))))(else (vector 1 (box (cons 0 arg-4)))))))
(define TTImpC-45ElabC-45Ambiguity-checkAmbigDepth (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-getAmbigLimit arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ambs (let ((e-6 (vector-ref arg-4 5))) e-6))) (let ((sc1 (PreludeC-45Types-u--C-62_Ord_Nat (PreludeC-45TypesC-45List-length u--ambs) e-5))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 20 arg-3 (vector 8 (let ((e-2 (vector-ref e-6 1))) e-2)) u--ambs) ext-0)))))) (else (vector 1 0)))))))))))
(define TTImpC-45ElabC-45Ambiguity-checkAlternative (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (case (vector-ref arg-11 0) ((2) (let ((e-1 (vector-ref arg-11 1))) (let ((act-24 (TTImpC-45ElabC-45Ambiguity-checkAmbigDepth arg-1 arg-4 arg-10 arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-25 (CoreC-45UnifyState-genName arg-1 arg-3 "altTy" eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-6 (vector 11 arg-10) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-7)))))))))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-13) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--solvemode (let ((e-0 (vector-ref arg-7 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))))) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 arg-6 arg-9 (box e-6) (lambda (eta-0) (TTImpC-45ElabC-45Delayed-ambiguous eta-0)) 1 (lambda (u--delayed) (lambda (eta-0) (let ((act-26 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm e-6) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--expC-39 (cond ((equal? u--delayed 1) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-9)) (else e-6)))) (let ((act-29 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45Types-fastConcat (cons "Ambiguous elaboration at " (cons (CoreC-45FC-u--show_Show_FC arg-10) (cons ":\xa;" (cons (DataC-45String-fastUnlines (PreludeC-45Types-u--map_Functor_List (csegen-2135) arg-12)) (cons "With default. Target type " '()))))))) arg-9 u--expC-39 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (let ((act-30 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--expC-39) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (TTImpC-45ElabC-45Ambiguity-pruneByType arg-0 arg-1 arg-3 arg-9 e-11 arg-12 eta-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-1 "elab.prune" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Pruned " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-length arg-12) (PreludeC-45TypesC-45List-length e-11)))) (PreludeC-45TypesC-45String-C-43C-43 " alts." (PreludeC-45TypesC-45String-C-43C-43 " Kept:\xa;" (DataC-45String-fastUnlines (PreludeC-45Types-u--map_Functor_List (csegen-2135) e-11))))))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (cond ((equal? u--delayed 1) (TTImpC-45ElabC-45Check-try arg-0 arg-1 arg-2 arg-3 arg-4 (TTImpC-45ElabC-45Check-exactlyOneC-39 arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-10 arg-9 (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (cons (TTImpC-45ElabC-45Ambiguity-getName u--t) (lambda (eta-1) (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-11 (TTImpC-45ElabC-45Ambiguity-getName u--t)) arg-7) arg-8 arg-9 u--t (box u--expC-39) eta-1)))) e-11)) (lambda (eta-1) (let ((act-32 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "All failed, running default") eta-1))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-11 (TTImpC-45ElabC-45Ambiguity-getName e-1)) arg-7) arg-8 arg-9 e-1 (box u--expC-39) eta-1))))) eta-0)) (else ((TTImpC-45ElabC-45Check-exactlyOneC-39 arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-10 arg-9 (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (cons (TTImpC-45ElabC-45Ambiguity-getName u--t) (lambda (eta-1) (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-11 (TTImpC-45ElabC-45Ambiguity-getName u--t)) arg-7) arg-8 arg-9 u--t (box u--expC-39) eta-1)))) e-11)) eta-0)))))))))))))))))))))))))) ext-0)))))))))))(else (let ((act-24 (TTImpC-45ElabC-45Ambiguity-checkAmbigDepth arg-1 arg-4 arg-10 arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--exp) (lambda (eta-0) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--exp) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45ElabC-45Ambiguity-pruneByType arg-0 arg-1 arg-3 arg-9 e-6 arg-12 eta-0)))))))) arg-13) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "altTy" eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-7 (vector 11 arg-10) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-8)))))))))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-13) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--solvemode (let ((e-0 (vector-ref arg-7 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))))) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 arg-6 arg-9 (box e-7) (lambda (eta-0) (TTImpC-45ElabC-45Delayed-ambiguous eta-0)) 1 (lambda (u--delayed) (lambda (eta-0) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm e-7) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--expC-39 (cond ((equal? u--delayed 1) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-9)) (else e-7)))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--expC-39) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (TTImpC-45ElabC-45Ambiguity-pruneByType arg-0 arg-1 arg-3 arg-9 e-10 arg-12 eta-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45Types-fastConcat (cons "Ambiguous elaboration" (cons " (kept " (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-10)) (cons " out of " (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-12)) (cons " candidates)" (cons " (" (cons (cond ((equal? u--delayed 1) "") (else "not ")) (cons "delayed)" (cons " at " (cons (CoreC-45FC-u--show_Show_FC arg-10) (cons ":\xa;" (cons (DataC-45String-fastUnlines (PreludeC-45Types-u--map_Functor_List (csegen-2135) e-10)) (cons "Target type " '())))))))))))))))) arg-9 u--expC-39 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((u--tryall (lambda (clam-1) (case (vector-ref arg-11 0) ((0) (TTImpC-45ElabC-45Check-anyOne arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 clam-1))(else (TTImpC-45ElabC-45Check-exactlyOneC-39 arg-0 arg-1 arg-2 arg-3 arg-4 (cond ((equal? u--delayed 1) 0) (else 1)) arg-10 arg-9 clam-1)))))) ((u--tryall (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (cons (TTImpC-45ElabC-45Ambiguity-getName u--t) (lambda (eta-1) (let ((act-31 (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-10 (TTImpC-45ElabC-45Ambiguity-getName u--t)) arg-7) arg-8 arg-9 u--t (box u--expC-39) eta-1))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-1))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-1))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-737) (TTImpC-45ElabC-45Ambiguity-getName u--t)) " success")) eta-1))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (vector 1 e-12))))))))))))))))) e-10)) eta-0))))))))))))))))))) ext-0)))))) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-2) (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 arg-13 ext-0) (let ((act-26 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-3 "altTy" eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-10 (csegen-21) arg-9 e-7 (vector 11 arg-10) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-8)))))))))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-13) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--solvemode (let ((e-0 (vector-ref arg-7 0))) (case (vector-ref e-0 0) ((1) (CoreC-45Unify-inLHS))(else (CoreC-45Unify-inTerm)))))) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 arg-6 arg-9 (box e-7) (lambda (eta-0) (TTImpC-45ElabC-45Delayed-ambiguous eta-0)) 1 (lambda (u--delayed) (lambda (eta-0) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm e-7) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--expC-39 (cond ((equal? u--delayed 1) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-9 e-9)) (else e-7)))) (let ((act-29 (let ((act-29 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--expC-39) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-29 1))) (TTImpC-45ElabC-45Ambiguity-pruneByType arg-0 arg-1 arg-3 arg-9 e-10 arg-12 eta-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45Types-fastConcat (cons "Ambiguous elaboration" (cons " (kept " (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-10)) (cons " out of " (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-12)) (cons " candidates)" (cons " (" (cons (cond ((equal? u--delayed 1) "") (else "not ")) (cons "delayed)" (cons " at " (cons (CoreC-45FC-u--show_Show_FC arg-10) (cons ":\xa;" (cons (DataC-45String-fastUnlines (PreludeC-45Types-u--map_Functor_List (csegen-2135) e-10)) (cons "Target type " '())))))))))))))))) arg-9 u--expC-39 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((u--tryall (lambda (clam-0) (case (vector-ref arg-11 0) ((0) (TTImpC-45ElabC-45Check-anyOne arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 clam-0))(else (TTImpC-45ElabC-45Check-exactlyOneC-39 arg-0 arg-1 arg-2 arg-3 arg-4 (cond ((equal? u--delayed 1) 0) (else 1)) arg-10 arg-9 clam-0)))))) ((u--tryall (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (cons (TTImpC-45ElabC-45Ambiguity-getName u--t) (lambda (eta-1) (let ((act-31 (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-10 (TTImpC-45ElabC-45Ambiguity-getName u--t)) arg-7) arg-8 arg-9 u--t (box u--expC-39) eta-1))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-1))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (let ((act-33 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-1))) (case (vector-ref act-33 0) ((0) (let ((e-3 (vector-ref act-33 1))) (vector 0 e-3))) (else (let ((act-34 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-737) (TTImpC-45ElabC-45Ambiguity-getName u--t)) " success")) eta-1))) (case (vector-ref act-34 0) ((0) (let ((e-3 (vector-ref act-34 1))) (vector 0 e-3))) (else (vector 1 e-12))))))))))))))))) e-10)) eta-0))))))))))))))))))) ext-0)))))))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-addAmbig (lambda (arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) eta-0) (lambda (clam-0) (if (null? arg-1) clam-0 (let ((e-5 (cdr arg-1))) (if (null? e-5) clam-0 (let ((e-1 (unbox arg-2))) (let ((e-0 (vector-ref clam-0 0))) (let ((e-8 (vector-ref clam-0 1))) (let ((e-2 (vector-ref clam-0 2))) (let ((e-3 (vector-ref clam-0 3))) (let ((e-7 (vector-ref clam-0 4))) (let ((e-6 (vector-ref clam-0 5))) (vector e-0 e-8 e-2 e-3 e-7 (cons e-1 e-6))))))))))))))))
(define CoreC-45LinearCheck-case--lcheckDef-15795 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-8) (CoreC-45Context-undefinedName arg-6 arg-4 arg-1 ext-0) (let ((e-1 (unbox arg-8))) (let ((act-24 ((CoreC-45Context-lookupCtxtExact (vector 8 e-1) (let ((e-0 (vector-ref arg-7 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Context-undefinedName arg-6 arg-4 arg-1 ext-0) (let ((e-2 (unbox e-5))) (let ((act-25 (CoreC-45LinearCheck-n--8520-15555-u--rigSafe arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((e-7 (vector-ref e-2 7))) e-7) arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((sc4 (let ((e-16 (vector-ref e-2 16))) e-16))) (cond ((equal? sc4 1) (vector 1 (let ((e-24 (vector-ref e-2 2))) e-24))) (else (let ((e-17 (vector-ref e-2 17))) (case (vector-ref e-17 0) ((1) (let ((e-26 (vector-ref e-17 5))) (let ((act-26 (CoreC-45LinearCheck-getArgUsage arg-6 arg-5 (CoreC-45TT-getLoc (let ((e-50 (vector-ref e-2 2))) e-50)) arg-3 (let ((e-50 (vector-ref e-2 2))) e-50) e-26 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-31 (vector-ref act-26 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-6 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Overall arg usage " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2136) e-31))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-32 (vector-ref act-27 1))) (vector 0 e-32))) (else (let ((u--tyC-39 (CoreC-45LinearCheck-n--8520-15554-u--updateUsage arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-31 (let ((e-52 (vector-ref e-2 2))) e-52)))) (let ((act-28 (CoreC-45Context-updateTy arg-6 e-1 u--tyC-39 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-33 (vector-ref act-28 1))) (vector 0 e-33))) (else (let ((act-29 (CoreC-45Context-setLinearCheck arg-6 e-1 1 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-34 (vector-ref act-29 1))) (vector 0 e-34))) (else (let ((act-30 (CoreC-45ContextC-45Log-logTerm '() arg-6 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "New type of " (CoreC-45Name-u--show_Show_Name (let ((e-55 (vector-ref e-2 1))) e-55)))) u--tyC-39 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-35 (vector-ref act-30 1))) (vector 0 e-35))) (else (let ((act-31 (CoreC-45ContextC-45Log-logTerm '() arg-6 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Updated from " (CoreC-45Name-u--show_Show_Name (let ((e-56 (vector-ref e-2 1))) e-56)))) (let ((e-55 (vector-ref e-2 2))) e-55) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-36 (vector-ref act-31 1))) (vector 0 e-36))) (else (vector 1 u--tyC-39)))))))))))))))))))))))(else (vector 1 (let ((e-45 (vector-ref e-2 2))) e-45)))))))))))))))))))))
(define CoreC-45LinearCheck-case--updateHoleUsage-10378 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-2 0) ((1) (lambda (eta-0) (CoreC-45LinearCheck-updateHoleUsageArgs arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-3 eta-0)))(else (if (null? e-3) (lambda (eta-0) (vector 1 0)) (lambda (eta-0) (CoreC-45LinearCheck-updateHoleUsageArgs arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 (cons e-2 e-3) eta-0)))))))))
(define CoreC-45LinearCheck-n--8482-10549-u--used (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((sc0 (AlgebraC-45Semiring-isLinear (csegen-475) arg-11))) (cond ((equal? sc0 1) (cons arg-0 '())) (else '())))))
(define CoreC-45LinearCheck-n--8520-15554-u--updateUsage (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9) (if (null? arg-8) arg-9 (let ((e-1 (car arg-8))) (let ((e-2 (cdr arg-8))) (case (vector-ref arg-9 0) ((3) (let ((e-4 (vector-ref arg-9 1))) (let ((e-5 (vector-ref arg-9 2))) (let ((e-6 (vector-ref arg-9 3))) (let ((e-7 (vector-ref arg-9 4))) (case (vector-ref e-6 0) ((2) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (let ((e-12 (vector-ref e-6 4))) (let ((u--scC-39 (CoreC-45LinearCheck-n--8520-15554-u--updateUsage arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 e-7))) (let ((u--cC-39 (cond ((equal? e-1 1) (csegen-21)) ((equal? e-1 2) (csegen-519)) ((equal? e-1 4) e-10) ((equal? e-1 3) e-10) (else e-10)))) (vector 3 e-4 e-5 (vector 2 e-9 u--cC-39 e-11 e-12) u--scC-39))))))))(else arg-9)))))))(else arg-9)))))))
(define CoreC-45LinearCheck-n--8482-10776-u--unusedHoleArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 arg-13) (if (null? arg-12) (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (CoreC-45LinearCheck-n--8482-10776-u--unusedHoleArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 e-4)))))))(else arg-13)))))))(else arg-13)) (let ((e-12 (cdr arg-12))) (case (vector-ref arg-13 0) ((3) (let ((e-14 (vector-ref arg-13 1))) (let ((e-15 (vector-ref arg-13 2))) (let ((e-16 (vector-ref arg-13 3))) (let ((e-17 (vector-ref arg-13 4))) (case (vector-ref e-16 0) ((2) (let ((e-19 (vector-ref e-16 1))) (let ((e-21 (vector-ref e-16 3))) (let ((e-22 (vector-ref e-16 4))) (vector 3 e-14 e-15 (vector 2 e-19 (csegen-21) e-21 e-22) (CoreC-45LinearCheck-n--8482-10776-u--unusedHoleArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-12 e-17))))))(else (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (CoreC-45LinearCheck-n--8482-10776-u--unusedHoleArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 e-4)))))))(else arg-13)))))))(else arg-13)))))))))(else (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (CoreC-45LinearCheck-n--8482-10776-u--unusedHoleArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 e-4)))))))(else arg-13)))))))(else arg-13))))))))
(define CoreC-45LinearCheck-n--8526-16090-u--substMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-16 0) ((3) (let ((e-3 (vector-ref arg-16 2))) (let ((e-4 (vector-ref arg-16 3))) (let ((e-5 (vector-ref arg-16 4))) (case (vector-ref e-4 0) ((0) (if (null? arg-17) (lambda (clam-0) (if (null? arg-17) (vector 1 (CoreC-45TTC-45SubstEnv-substs arg-18 arg-16)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed metavar solution " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-5))))) clam-0))) (let ((e-17 (car arg-17))) (let ((e-18 (cdr arg-17))) (CoreC-45LinearCheck-n--8526-16090-u--substMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-3 arg-14) arg-15 e-5 e-18 (cons e-17 arg-18)))))) ((1) (let ((e-14 (vector-ref e-4 3))) (CoreC-45LinearCheck-n--8526-16090-u--substMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (CoreC-45TTC-45SubstEnv-subst e-14 e-5) arg-17 arg-18)))(else (lambda (clam-1) (if (null? arg-17) (vector 1 (CoreC-45TTC-45SubstEnv-substs arg-18 arg-16)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed metavar solution " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-5))))) clam-1)))))))))(else (lambda (clam-2) (if (null? arg-17) (vector 1 (CoreC-45TTC-45SubstEnv-substs arg-18 arg-16)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed metavar solution " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-8) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-5))))) clam-2)))))))
(define CoreC-45LinearCheck-n--6958-9120-u--showAll (lambda (arg-1 arg-3) (if (null? arg-3) "" (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (CoreC-45TT-u--show_Show_C-40VarC-32C-36nsC-41 e-2) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40VarC-32C-36nsC-41 e-2) (PreludeC-45TypesC-45String-C-43C-43 ", " (CoreC-45LinearCheck-u--show_Show_C-40UsageC-32C-36varsC-41 e-3)))))))))
(define CoreC-45LinearCheck-n--8520-15555-u--rigSafe (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 (CoreC-45Context-getFullName arg-6 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (AlgebraC-45Preorder-C-60 (csegen-2098) arg-7 arg-8))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 14 arg-4 e-5 arg-7 arg-8) ext-0)) (else (vector 1 0))))))))))
(define CoreC-45LinearCheck-n--8482-10548-u--rigSafe (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((sc0 (AlgebraC-45Preorder-C-60 (csegen-2098) arg-11 arg-12))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 14 arg-5 (CoreC-45LinearCheck-n--8482-10547-u--getName arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-0 arg-2) arg-11 arg-12) ext-0)) (else (vector 1 0))))))
(define CoreC-45LinearCheck-n--8482-11311-u--rig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-3 0) ((2) (let ((sc1 (AlgebraC-45Semiring-isErased (csegen-475) arg-7))) (cond ((equal? sc1 1) (csegen-21)) (else (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))))) ((1) arg-7)(else (let ((sc0 (AlgebraC-45Semiring-isErased (csegen-475) arg-7))) (cond ((equal? sc0 1) (csegen-21)) (else (csegen-519))))))))
(define CoreC-45LinearCheck-n--8510-14083-u--isLocArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (if (null? arg-8) 0 (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-2 0) ((0) (let ((e-8 (vector-ref e-2 3))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-8 (CoreC-45TT-varIdx arg-7)))) (cond ((equal? sc2 1) 1) (else (CoreC-45LinearCheck-n--8510-14083-u--isLocArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-3)))))) ((5) (let ((e-13 (vector-ref e-2 3))) (let ((e-14 (vector-ref e-2 4))) (CoreC-45LinearCheck-n--8510-14083-u--isLocArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (cons e-13 (cons e-14 e-3))))))(else (CoreC-45LinearCheck-n--8510-14083-u--isLocArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-3))))))))
(define CoreC-45LinearCheck-n--8482-11312-u--getZeroes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) '() (let ((e-3 (cdr arg-10))) (let ((e-8 (car arg-11))) (let ((e-9 (cdr arg-11))) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) (CoreC-45TT-multiplicity e-8)))) (cond ((equal? sc2 1) (cons 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) (CoreC-45LinearCheck-n--8482-11312-u--getZeroes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 e-9)))) (else (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) (CoreC-45LinearCheck-n--8482-11312-u--getZeroes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 e-9)))))))))))
(define CoreC-45LinearCheck-n--8510-14085-u--getPUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (CoreC-45Normalise-logEnv e-2 arg-5 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) "Env" e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTerm e-2 arg-5 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "LHS") e-10 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CoreC-45ContextC-45Log-logTerm e-2 arg-5 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Linear check in case RHS") e-11 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 ((CoreC-45LinearCheck-lcheck e-2 arg-5 arg-4 arg-2 0 e-6 e-11) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (let ((e-13 (car e-12))) (let ((e-4 (cdr e-12))) (let ((e-14 (cdr e-4))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-5 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Used: " (CoreC-45LinearCheck-u--show_Show_C-40UsageC-32C-36varsC-41 e-14))) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-16 (vector-ref act-28 1))) (vector 0 e-16))) (else (let ((u--args (CoreC-45TT-getArgs e-10))) (let ((act-29 ((CoreC-45LinearCheck-n--8510-14084-u--checkEnvUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-2 arg-2 e-6 e-14 u--args e-13) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-17 (vector-ref act-29 1))) (vector 0 e-17))) (else (let ((act-30 ((CoreC-45LinearCheck-n--8510-14081-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 arg-6 e-6 u--args e-14 e-11) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-18 (vector-ref act-30 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-30 1))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-5 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Arg usage: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2140) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2140) u--d u--x)))) e-18))) clam-0))) (case (vector-ref act-31 0) ((0) (let ((e-19 (vector-ref act-31 1))) (vector 0 e-19))) (else (vector 1 e-18))))))))))))))))))))))))))))))))))))))))
(define CoreC-45LinearCheck-n--8482-10547-u--getName (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13) (cond ((equal? arg-12 0) (let ((e-2 (car arg-13))) e-2))(else (let ((e-0 (- arg-12 1))) (let ((e-6 (cdr arg-13))) (CoreC-45LinearCheck-n--8482-10547-u--getName arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-0 e-6)))))))
(define CoreC-45LinearCheck-n--8510-14081-u--getCaseUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-10) (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (if (null? arg-10) (lambda (eta-0) (vector 1 '())) (let ((e-11 (car arg-10))) (let ((e-12 (cdr arg-10))) (let ((sc4 (AlgebraC-45Semiring-isLinear (csegen-475) e-7))) (cond ((equal? sc4 1) (lambda (clam-1) (case (vector-ref e-11 0) ((0) (let ((e-5 (vector-ref e-11 3))) (let ((act-24 ((CoreC-45LinearCheck-n--8510-14081-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4 arg-9 e-12 arg-11 arg-12) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-14 (vector-ref act-24 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-24 1))) (let ((u--used_in (CoreC-45LinearCheck-count e-5 arg-11))) (let ((act-25 ((CoreC-45LinearCheck-updateHoleUsage arg-7 arg-5 arg-4 (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0)) e-5 '() arg-12) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((u--ause (let ((sc8 (cond ((equal? e-15 1) (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0))) (else 0)))) (cond ((equal? sc8 1) 4) (else (let ((sc9 (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0)))) (cond ((equal? sc9 1) 1) (else 2)))))))) (vector 1 (cons (cons e-2 u--ause) e-14))))))))))))))(else (CoreC-45LinearCheck-n--12649-14134-u--elseCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-1 e-6 e-8 e-9 e-7 e-2 e-4 e-11 e-12 arg-12 arg-11 arg-9 clam-1))))) (else (lambda (eta-0) (CoreC-45LinearCheck-n--12649-14134-u--elseCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-1 e-6 e-8 e-9 e-7 e-2 e-4 e-11 e-12 arg-12 arg-11 arg-9 eta-0)))))))))))))(else (lambda (eta-0) (vector 1 '())))))))))(else (lambda (eta-0) (vector 1 '())))) (let ((e-14 (car arg-10))) (let ((e-15 (cdr arg-10))) (case (vector-ref e-14 0) ((5) (let ((e-20 (vector-ref e-14 4))) (CoreC-45LinearCheck-n--8510-14081-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 (cons e-20 e-15) arg-11 arg-12)))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (if (null? arg-10) (lambda (eta-0) (vector 1 '())) (let ((e-11 (car arg-10))) (let ((e-12 (cdr arg-10))) (let ((sc4 (AlgebraC-45Semiring-isLinear (csegen-475) e-7))) (cond ((equal? sc4 1) (lambda (clam-0) (case (vector-ref e-11 0) ((0) (let ((e-5 (vector-ref e-11 3))) (let ((act-24 ((CoreC-45LinearCheck-n--8510-14081-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4 arg-9 e-12 arg-11 arg-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-16 (vector-ref act-24 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-24 1))) (let ((u--used_in (CoreC-45LinearCheck-count e-5 arg-11))) (let ((act-25 ((CoreC-45LinearCheck-updateHoleUsage arg-7 arg-5 arg-4 (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0)) e-5 '() arg-12) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-17 (vector-ref act-25 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-25 1))) (let ((u--ause (let ((sc8 (cond ((equal? e-17 1) (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0))) (else 0)))) (cond ((equal? sc8 1) 4) (else (let ((sc9 (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0)))) (cond ((equal? sc9 1) 1) (else 2)))))))) (vector 1 (cons (cons e-2 u--ause) e-16))))))))))))))(else (CoreC-45LinearCheck-n--12649-14134-u--elseCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-1 e-6 e-8 e-9 e-7 e-2 e-4 e-11 e-12 arg-12 arg-11 arg-9 clam-0))))) (else (lambda (eta-0) (CoreC-45LinearCheck-n--12649-14134-u--elseCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-1 e-6 e-8 e-9 e-7 e-2 e-4 e-11 e-12 arg-12 arg-11 arg-9 eta-0)))))))))))))(else (lambda (eta-0) (vector 1 '())))))))))(else (lambda (eta-0) (vector 1 '())))))))))))
(define CoreC-45LinearCheck-n--8482-11313-u--eraseLinear (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11) (if (null? arg-11) '() (let ((e-4 (car arg-11))) (let ((e-5 (cdr arg-11))) (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) (CoreC-45TT-multiplicity e-4)))) (cond ((equal? sc1 1) (cons (CoreC-45TT-setMultiplicity e-4 (csegen-21)) (CoreC-45LinearCheck-n--8482-11313-u--eraseLinear arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5))) (else (cons e-4 (CoreC-45LinearCheck-n--8482-11313-u--eraseLinear arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5))))))))))
(define CoreC-45LinearCheck-n--12649-14134-u--elseCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 ext-0) (let ((act-24 ((CoreC-45LinearCheck-n--8510-14081-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-14 arg-19 arg-16 arg-18 arg-17) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((sc1 (AlgebraC-45Semiring-isErased (csegen-475) arg-12))) (cond ((equal? sc1 1) (cons (cons arg-13 1) e-5)) (else (cons (cons arg-13 3) e-5)))))))))))
(define CoreC-45LinearCheck-n--8510-14087-u--combineUsages (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-6) (if (null? arg-7) (vector 1 '()) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Argument usage lists inconsistent") clam-0)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? arg-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Argument usage lists inconsistent") clam-0) (let ((e-6 (car arg-7))) (let ((e-7 (cdr arg-7))) (let ((act-24 ((CoreC-45LinearCheck-n--8510-14086-u--combineUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45LinearCheck-n--8510-14087-u--combineUsages arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 e-7) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (cons e-5 e-8)))))))))))))))))))
(define CoreC-45LinearCheck-n--8510-14086-u--combineUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-95) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-94) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-93) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-92) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-91) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-90) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-89) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-88) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-87) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-86) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-85) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-84) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-83) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-82) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-81) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-80) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))))))))))))) (let ((e-22 (car arg-6))) (let ((e-23 (cdr arg-6))) (cond ((equal? e-23 1) (if (null? arg-7) (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-31) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-30) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-29) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-28) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-27) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-26) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-25) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-24) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-23) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-22) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-21) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-20) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-19) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-18) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-17) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-16) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))))))))))))) (let ((e-27 (cdr arg-7))) (cond ((equal? e-27 2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-3 (PreludeC-45TypesC-45String-C-43C-43 "Inconsistent usage of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-22) " in case branches"))) eta-0)))(else (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-15) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-14) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-13) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-12) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-11) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-10) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-9) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-8) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-7) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-6) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-5) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-4) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-3) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-2) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-1) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-0) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))))))))))))) ((equal? e-23 2) (if (null? arg-7) (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-63) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-62) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-61) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-60) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-59) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-58) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-57) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-56) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-55) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-54) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-53) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-52) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-51) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-50) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-49) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-48) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))))))))))))) (let ((e-31 (cdr arg-7))) (cond ((equal? e-31 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-3 (PreludeC-45TypesC-45String-C-43C-43 "Inconsistent usage of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-22) " in case branches"))) eta-0)))(else (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-47) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-46) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-45) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-44) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-43) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-42) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-41) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-40) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-39) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-38) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-37) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-36) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-35) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-34) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-33) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-32) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))))))))))))) ((equal? e-23 0) (lambda (eta-0) (vector 1 (cons e-22 0))))(else (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-79) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-78) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-77) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-76) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-75) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-74) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-73) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-72) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-71) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-70) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-69) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-68) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-67) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-66) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-65) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-64) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))))))))))))))))))))
(define CoreC-45LinearCheck-n--8510-14088-u--combine (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (vector 1 '()) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-3) (vector 1 e-2) (let ((act-24 ((CoreC-45LinearCheck-n--8510-14088-u--combine arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45LinearCheck-n--8510-14087-u--combineUsages arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-5) clam-0))))))))))))
(define CoreC-45LinearCheck-n--15530-16639-u--checkUsageOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((sc0 (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-12))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-11 (PreludeC-45Types-u--fromInteger_Num_Nat 1))) (else 0))))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-8 arg-11 arg-0) ext-0)) (else (vector 1 0))))))
(define CoreC-45LinearCheck-n--8510-14082-u--checkUsageOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((sc0 (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-10))) (cond ((equal? sc1 1) (let ((sc2 (cond ((equal? arg-9 1) (PreludeC-45Types-u--C-62_Ord_Nat arg-7 (PreludeC-45Types-u--fromInteger_Num_Nat 1))) (else 0)))) (cond ((equal? sc2 1) 1) (else (cond ((equal? arg-9 1) 0) (else (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-7 (PreludeC-45Types-u--fromInteger_Num_Nat 1)))))))) (else 0))))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-6 arg-7 arg-8) ext-0)) (else (vector 1 0))))))
(define CoreC-45LinearCheck-n--8482-11314-u--checkUsageOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((sc0 (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-11))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-10 (PreludeC-45Types-u--fromInteger_Num_Nat 1))) (else 0))))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-4 arg-10 arg-1) ext-0)) (else (vector 1 0))))))
(define CoreC-45LinearCheck-n--8510-14084-u--checkEnvUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-7) (lambda (clam-0) (vector 1 0)) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-8 (car arg-9))) (let ((e-9 (cdr arg-9))) (let ((u--pos (CoreC-45LinearCheck-localPrf arg-6))) (let ((u--used_in (CoreC-45LinearCheck-count (CoreC-45TT-varIdx u--pos) arg-10))) (lambda (eta-0) (let ((act-24 (let ((sc2 (AlgebraC-45Semiring-isLinear (csegen-475) (CoreC-45TT-multiplicity e-8)))) (cond ((equal? sc2 1) ((CoreC-45LinearCheck-updateHoleUsage (PreludeC-45TypesC-45List-tailRecAppend arg-6 (cons e-2 e-3)) arg-5 arg-4 (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0)) u--pos '() arg-12) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--used (let ((sc3 (let ((sc4 (AlgebraC-45Semiring-isLinear (csegen-475) (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega (CoreC-45TT-multiplicity e-8) arg-8)))) (cond ((equal? sc4 1) (cond ((equal? e-5 1) (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0))) (else 0))) (else 0))))) (cond ((equal? sc3 1) (PreludeC-45Types-u--fromInteger_Num_Nat 1)) (else u--used_in))))) (let ((act-25 (CoreC-45LinearCheck-n--8510-14082-u--checkUsageOK arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TT-getLoc (CoreC-45TT-binderType e-8)) u--used e-2 (CoreC-45LinearCheck-n--8510-14083-u--isLocArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--pos arg-11) (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega (CoreC-45TT-multiplicity e-8) arg-8) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((CoreC-45LinearCheck-n--8510-14084-u--checkEnvUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend arg-6 (cons e-2 '())) e-3 arg-8 e-9 arg-10 arg-11 arg-12) eta-0)))))))))))))))))))
(define CoreC-45LinearCheck-u--show_Show_ArgUsage (lambda (arg-0) (cond ((equal? arg-0 0) "any") ((equal? arg-0 1) "0") ((equal? arg-0 2) "1") ((equal? arg-0 3) "keep") (else "unknown"))))
(define CoreC-45LinearCheck-u--show_Show_C-40UsageC-32C-36varsC-41 (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45LinearCheck-n--6958-9120-u--showAll arg-1 arg-1) "]"))))
(define CoreC-45LinearCheck-u--showPrec_Show_ArgUsage (lambda (arg-0 arg-1) (CoreC-45LinearCheck-u--show_Show_ArgUsage arg-1)))
(define CoreC-45LinearCheck-updateHoleUsageArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 ((CoreC-45LinearCheck-updateHoleUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45LinearCheck-updateHoleUsageArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cond ((equal? e-5 1) 1) (else e-6))))))))))))))))
(define CoreC-45LinearCheck-updateHoleUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (let ((e-29 (vector-ref arg-6 2))) (let ((e-30 (vector-ref arg-6 3))) (let ((e-31 (vector-ref arg-6 4))) (case (vector-ref e-30 0) ((1) (let ((e-35 (vector-ref e-30 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45LinearCheck-updateHoleUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-35) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45LinearCheck-updateHoleUsage (cons e-29 arg-0) arg-1 arg-2 arg-3 (+ 1 arg-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45TT-u--weaken_Weaken_Var eta-1)) arg-5) e-31) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cond ((equal? e-5 1) 1) (else e-6))))))))))))))(else (CoreC-45LinearCheck-updateHoleUsage (cons e-29 arg-0) arg-1 arg-2 arg-3 (+ 1 arg-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-u--weaken_Weaken_Var eta-0)) arg-5) e-31)))))))(else (case (vector-ref arg-6 0) ((2) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 e-3) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45LinearCheck-updateHoleUsageArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 eta-0) (let ((e-7 (unbox e-6))) (let ((e-17 (vector-ref e-7 17))) (case (vector-ref e-17 0) ((7) (let ((u--ty (let ((e-50 (vector-ref e-7 2))) e-50))) (let ((act-26 ((CoreC-45LinearCheck-updateHoleType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--ty e-4) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-31 (vector-ref act-26 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-updateTy arg-1 e-3 e-31 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-32 (vector-ref act-27 1))) (vector 0 e-32))) (else (let ((act-28 (CoreC-45ContextC-45Log-logTerm '() arg-1 "quantity.hole.update" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "New type of " (CoreC-45Name-u--show_Show_Name (let ((e-53 (vector-ref e-7 1))) e-53)))) e-31 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-33 (vector-ref act-28 1))) (vector 0 e-33))) (else (let ((act-29 (CoreC-45ContextC-45Log-logTerm '() arg-1 "quantity.hole.update" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Updated from " (CoreC-45Name-u--show_Show_Name (let ((e-54 (vector-ref e-7 1))) e-54)))) (let ((e-53 (vector-ref e-7 2))) e-53) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-34 (vector-ref act-29 1))) (vector 0 e-34))) (else (vector 1 1))))))))))))))))(else (CoreC-45LinearCheck-updateHoleUsageArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 eta-0)))))))))))))))))) ((5) (let ((e-8 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45LinearCheck-updateHoleUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45LinearCheck-updateHoleUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-8) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (cond ((equal? e-5 1) 1) (else e-10)))))))))))))) ((6) (let ((e-13 (vector-ref arg-6 3))) (CoreC-45LinearCheck-updateHoleUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-13))) ((7) (let ((e-18 (vector-ref arg-6 4))) (CoreC-45LinearCheck-updateHoleUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-18))) ((8) (let ((e-22 (vector-ref arg-6 3))) (CoreC-45LinearCheck-updateHoleUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22)))(else (CoreC-45LinearCheck-case--updateHoleUsage-10378 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-6))))))))
(define CoreC-45LinearCheck-updateHoleType (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-7 0) ((3) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (if (null? arg-8) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45LinearCheck-updateHoleUsageArgs arg-1 arg-2 arg-3 0 arg-5 arg-6 arg-8 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (vector 1 arg-7))))) (let ((e-11 (car arg-8))) (let ((e-12 (cdr arg-8))) (case (vector-ref e-11 0) ((0) (let ((e-17 (vector-ref e-11 3))) (lambda (clam-0) (let ((sc4 (PreludeC-45Types-u--C-61C-61_Eq_Nat (CoreC-45TT-varIdx arg-5) e-17))) (cond ((equal? sc4 1) (let ((act-24 ((CoreC-45LinearCheck-updateHoleType arg-1 arg-2 arg-3 0 arg-5 arg-6 e-4 e-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--cC-39 (cond ((equal? arg-4 1) e-7) (else (csegen-21))))) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 u--cC-39 e-8 e-9) e-5)))))))) (else (let ((sc5 (PreludeC-45Types-elem (csegen-792) e-17 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45TT-varIdx eta-0)) arg-6)))) (cond ((equal? sc5 1) (let ((act-24 ((CoreC-45LinearCheck-updateHoleType arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 (csegen-21) e-8 e-9) e-5))))))) (else (let ((act-24 ((CoreC-45LinearCheck-updateHoleType arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 e-7 e-8 e-9) e-5)))))))))))))))(else (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 0 arg-5 arg-6 e-11) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CoreC-45LinearCheck-updateHoleType arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-12) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 e-7 e-8 e-9) e-10))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45LinearCheck-updateHoleUsageArgs arg-1 arg-2 arg-3 0 arg-5 arg-6 arg-8 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (vector 1 arg-7))))))))))))(else (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45LinearCheck-updateHoleUsageArgs arg-1 arg-2 arg-3 0 arg-5 arg-6 arg-8 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 arg-7)))))))))
(define CoreC-45LinearCheck-localPrf (lambda (arg-2) (if (null? arg-2) 0 (let ((e-3 (cdr arg-2))) (+ 1 (CoreC-45LinearCheck-localPrf e-3))))))
(define CoreC-45LinearCheck-linearCheck (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Linearity check on ") arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Normalise-logEnv arg-0 arg-1 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) "In env" arg-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((e-8 (cdr e-3))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Used: " (CoreC-45LinearCheck-u--show_Show_C-40UsageC-32C-36varsC-41 e-8))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (cond ((equal? arg-5 1) (vector 1 0)) (else ((CoreC-45LinearCheck-checkEnvUsage arg-0 '() arg-1 arg-2 arg-3 arg-4 arg-6 e-8 e-2) ext-0))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))))))))))))))))
(define CoreC-45LinearCheck-lcheckMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-9) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 2 arg-6 arg-7 arg-8 (PreludeC-45TypesC-45List-reverse arg-10)) (cons (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-5 arg-11) '())))))))) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (case (vector-ref arg-11 0) ((0) (let ((e-7 (vector-ref arg-11 3))) (let ((e-8 (vector-ref arg-11 4))) (case (vector-ref e-7 0) ((2) (let ((e-11 (vector-ref e-7 2))) (let ((u--checkRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega e-11 arg-3))) (lambda (eta-0) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 u--checkRig arg-4 arg-5 e-1) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) (let ((e-4 (car e-9))) (let ((e-3 (cdr e-9))) (let ((e-14 (cdr e-3))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-16 (vector-ref act-25 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-25 1))) (let ((act-26 (((e-8 e-16) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-5 e-4)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-17 (vector-ref act-26 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-26 1))) (let ((u--aerased (let ((sc8 (cond ((equal? arg-4 1) (AlgebraC-45Semiring-isErased (csegen-475) e-11)) (else 0)))) (cond ((equal? sc8 1) (vector 10 arg-6 0)) (else e-4))))) (let ((act-27 ((CoreC-45LinearCheck-lcheckMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2 (cons u--aerased arg-10) e-17) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-18 (vector-ref act-27 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-27 1))) (let ((e-20 (car e-18))) (let ((e-19 (cdr e-18))) (let ((e-22 (car e-19))) (let ((e-21 (cdr e-19))) (vector 1 (cons e-20 (cons e-22 (CoreC-45LinearCheck-C-43C-43 e-14 e-21))))))))))))))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-9 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-10 arg-5 arg-11 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-46) arg-7 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-11 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-28 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-6 (PreludeC-45TypesC-45String-C-43C-43 "Linearity checking failed on metavar " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-12) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-13) " not a function type)"))))) eta-0)))))))))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-6 arg-5 arg-11 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-46) arg-7 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-7 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-6 (PreludeC-45TypesC-45String-C-43C-43 "Linearity checking failed on metavar " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-8) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-9) " not a function type)"))))) eta-0)))))))))))))))))))))))))))))
(define CoreC-45LinearCheck-lcheckDef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (cond ((equal? arg-5 1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-7 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-1 arg-3 arg-7 ext-0) (let ((e-1 (unbox e-6))) (vector 1 (let ((e-2 (vector-ref e-1 2))) e-2))))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45LinearCheck-case--lcheckDef-15795 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 e-5 (CoreC-45Context-getNameID arg-7 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0)))))))))
(define CoreC-45LinearCheck-lcheckBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (csegen-21) arg-4 arg-5 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-7 (car e-5))) (let ((e-6 (cdr e-5))) (let ((e-9 (car e-6))) (vector 1 (cons (vector 0 e-1 e-2 e-3 e-7) (cons e-9 '()))))))))))))))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((e-9 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (csegen-21) arg-4 arg-5 e-9) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-11 (car e-3))) (let ((act-25 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-3 e-7) arg-4 arg-5 e-8) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-25 1))) (let ((e-13 (car e-12))) (let ((e-4 (cdr e-12))) (let ((e-14 (cdr e-4))) (vector 1 (cons (vector 1 e-6 e-7 e-13 e-2) (cons e-11 e-14)))))))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-3 e-12) arg-4 arg-5 e-14) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (vector 1 (cons (vector 2 e-11 e-12 e-13 e-2) (cons e-6 '()))))))))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (csegen-21) arg-4 arg-5 e-19) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (vector 1 (cons (vector 3 e-16 e-17 e-18 e-2) (cons e-6 '()))))))))))))))) ((4) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (let ((e-24 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (csegen-21) arg-4 arg-5 e-24) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((act-25 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega arg-3 e-22) arg-4 arg-5 e-23) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((e-10 (cdr e-4))) (vector 1 (cons (vector 4 e-21 e-22 e-9 e-2) (cons e-6 e-10)))))))))))))))))))))) (else (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (csegen-21) arg-4 arg-5 e-28) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (vector 1 (cons (vector 5 e-26 e-27 e-2) (cons e-6 '())))))))))))))))))
(define CoreC-45LinearCheck-lcheck (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 3))) (let ((u--b (CoreC-45Env-getBinder (csegen-764) arg-0 e-4 arg-5))) (let ((u--rigb (CoreC-45TT-multiplicity u--b))) (let ((u--ty (CoreC-45TT-binderType u--b))) (lambda (eta-0) (let ((act-24 (cond ((equal? arg-4 1) (vector 1 0)) (else (CoreC-45LinearCheck-n--8482-10548-u--rigSafe e-4 arg-0 e-3 e-2 arg-5 arg-4 arg-3 arg-2 arg-1 u--rigb arg-3 eta-0))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (vector 1 (cons (vector 0 e-2 e-3 e-4) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 u--ty) (CoreC-45LinearCheck-n--8482-10549-u--used e-4 arg-0 e-3 e-2 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3))))))))))))))) ((1) (let ((e-7 (vector-ref arg-6 1))) (let ((e-8 (vector-ref arg-6 2))) (let ((e-9 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-24 (CoreC-45LinearCheck-lcheckDef arg-1 arg-2 e-7 arg-3 arg-4 arg-5 e-9 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 1 e-7 e-8 e-9) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (CoreC-45TT-embed e-5)) '())))))))))))) ((2) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 e-13) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-1 e-11 e-12 eta-0) (let ((e-1 (unbox e-6))) (let ((u--expand (AlgebraC-45Semiring-branchZero (csegen-475) (let ((e-2 (vector-ref e-1 2))) (case (vector-ref e-2 0) ((10) (lambda () 1))(else (lambda () 0)))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((1) (lambda () 1))(else (lambda () 0)))) arg-3))) (let ((act-26 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "quantity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-1) (let ((act-26 (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((1) (let ((e-32 (vector-ref e-17 2))) (let ((e-31 (vector-ref e-17 3))) (case (vector-ref e-31 0) ((1) (let ((e-34 (vector-ref e-31 2))) (let ((act-26 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-34 eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-36 (vector-ref act-26 1))) (vector 0 e-36))) (else (let ((e-36 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-32 e-36))))))))(else (vector 1 ""))))))(else (vector 1 "")))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega arg-3) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-12) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-11) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45Show-u--show_Show_String e-7))))))))))))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (cond ((equal? u--expand 1) ((CoreC-45LinearCheck-expandMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-12 e-13 (let ((e-17 (vector-ref e-1 17))) e-17) e-14) eta-0)) (else (let ((u--ty (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((7) (CoreC-45LinearCheck-n--8482-10776-u--unusedHoleArgs arg-0 e-14 e-13 e-12 e-11 arg-5 arg-4 arg-3 arg-2 arg-1 e-14 (let ((e-51 (vector-ref e-1 2))) e-51)))(else (let ((e-49 (vector-ref e-1 2))) e-49)))))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 (CoreC-45TT-embed u--ty)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((CoreC-45LinearCheck-lcheckMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-11 e-12 e-13 e-14 '() e-8) eta-0)))))))))))))))))))))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-24 (CoreC-45UnifyState-handleUnify arg-1 arg-2 (lambda (eta-1) (CoreC-45LinearCheck-lcheckBinder arg-0 arg-1 arg-2 (CoreC-45LinearCheck-n--8482-11311-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1) arg-4 arg-5 e-18 eta-1)) (lambda (u--err) (case (vector-ref u--err 0) ((14) (lambda (eta-1) (CoreC-45LinearCheck-lcheckBinder arg-0 arg-1 arg-2 (CoreC-45LinearCheck-n--8482-11311-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1) arg-4 arg-5 (CoreC-45TT-setMultiplicity e-18 (csegen-519)) eta-1)))(else (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-1))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--envC-39 (let ((sc4 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega arg-3 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))) (cond ((equal? sc4 1) (case (vector-ref e-18 0) ((0) (CoreC-45LinearCheck-n--8482-11313-u--eraseLinear arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1 arg-5))(else arg-5))) (else arg-5))))) (let ((act-25 ((CoreC-45LinearCheck-lcheck (cons e-17 arg-0) arg-1 arg-2 (CoreC-45LinearCheck-n--8482-11311-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1) arg-4 (cons e-2 u--envC-39) e-19) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((e-11 (car e-4))) (let ((e-10 (cdr e-4))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((u--used_in (CoreC-45LinearCheck-count 0 e-10))) (let ((act-27 (let ((sc8 (cond ((equal? arg-4 1) 0) (else (AlgebraC-45Semiring-isLinear (csegen-475) (CoreC-45TT-multiplicity e-18)))))) (cond ((equal? sc8 1) ((CoreC-45LinearCheck-updateHoleUsage (cons e-17 arg-0) arg-1 arg-2 (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0)) 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45TT-u--weaken_Weaken_Var eta-1)) (CoreC-45LinearCheck-n--8482-11312-u--getZeroes arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--envC-39)) e-9) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((u--used (let ((sc9 (let ((sc10 (AlgebraC-45Semiring-isLinear (csegen-475) (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega (CoreC-45TT-multiplicity e-18) (CoreC-45LinearCheck-n--8482-11311-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1))))) (cond ((equal? sc10 1) (cond ((equal? e-13 1) (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0))) (else 0))) (else 0))))) (cond ((equal? sc9 1) (PreludeC-45Types-u--fromInteger_Num_Nat 1)) (else u--used_in))))) (let ((act-28 (cond ((equal? arg-4 1) (vector 1 0)) (else (CoreC-45LinearCheck-n--8482-11314-u--checkUsageOK arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1 u--used (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega (CoreC-45TT-multiplicity e-18) (CoreC-45LinearCheck-n--8482-11311-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1)) eta-0))))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((act-29 (let ((act-29 (unbox arg-1))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-15 (vector-ref act-29 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-29 1))) (CoreC-45LinearCheck-discharge arg-0 e-15 arg-5 e-16 e-17 e-2 e-6 e-9 e-11 (CoreC-45LinearCheck-C-43C-43 e-7 (CoreC-45LinearCheck-doneScope e-10)) eta-0)))))))))))))))))))))))))))))))))))))))) ((4) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-6) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (case (vector-ref e-10 0) ((2) (let ((e-14 (vector-ref e-10 2))) (let ((e-13 (vector-ref e-10 4))) (let ((u--checkRig (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega e-14 arg-3))) (let ((act-27 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 u--checkRig arg-4 arg-5 e-23) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (let ((e-18 (car e-16))) (let ((e-17 (cdr e-16))) (let ((e-20 (car e-17))) (let ((e-19 (cdr e-17))) (let ((act-28 (((e-4 e-8) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-5 e-18)) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-24 (vector-ref act-28 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-28 1))) (let ((u--aerased (let ((sc12 (cond ((equal? arg-4 1) (AlgebraC-45Semiring-isErased (csegen-475) e-14)) (else 0)))) (cond ((equal? sc12 1) (vector 10 e-21 0)) (else e-18))))) (let ((act-29 (CoreC-45Context-getSession arg-1 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-25 (vector-ref act-29 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-29 1))) (let ((act-30 (let ((sc13 (let ((e-38 (vector-ref e-25 11))) e-38))) (cond ((equal? sc13 1) (let ((act-30 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-20) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-26 (vector-ref act-30 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-30 1))) (let ((act-31 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-8 e-13) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-27 (vector-ref act-31 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-31 1))) (let ((act-32 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-1 arg-0 e-8 arg-5 e-26 e-27 eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-28 (vector-ref act-32 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-32 1))) (cond ((equal? e-28 1) (vector 1 0)) (else (let ((act-33 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-8 arg-5 e-13 eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-29 (vector-ref act-33 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-33 1))) (let ((act-34 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-8 arg-5 e-26 eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-30 (vector-ref act-34 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-34 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 1 arg-0 e-21 (let ((e-0 (vector-ref e-8 0))) e-0) arg-5 e-29 e-30) eta-0)))))))))))))))))))))))) (else (vector 1 0)))))) (case (vector-ref act-30 0) ((0) (let ((e-26 (vector-ref act-30 1))) (vector 0 e-26))) (else (vector 1 (cons (vector 4 e-21 e-2 u--aerased) (cons (CoreC-45Normalise-glueBack arg-1 arg-0 e-8 arg-5 e-24) (CoreC-45LinearCheck-C-43C-43 e-7 e-19))))))))))))))))))))))))))))(else (let ((act-27 ((CoreC-45NormaliseC-45Eval-getTerm e-6) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-2 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-12 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-21 (PreludeC-45TypesC-45String-C-43C-43 "Linearity checking failed on " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-13) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-14) " not a function type)"))))) eta-0)))))))))))))))))) ((1) (let ((e-11 (vector-ref e-9 2))) (case (vector-ref e-11 0) ((1) (let ((e-16 (vector-ref e-11 2))) (let ((act-27 ((CoreC-45Context-lookupCtxtExact e-16 (let ((e-0 (vector-ref e-8 0))) e-0)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-27 1))) (if (null? e-13) (CoreC-45Context-undefinedName arg-1 e-21 e-16 eta-0) (let ((act-28 ((CoreC-45NormaliseC-45Eval-getTerm e-6) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-2 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-14 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-30 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-21 (PreludeC-45TypesC-45String-C-43C-43 "Linearity checking failed on " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-17) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-18) " not a function type)"))))) eta-0))))))))))))))))))))(else (let ((act-27 ((CoreC-45NormaliseC-45Eval-getTerm e-6) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-2 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-13 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-29 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-21 (PreludeC-45TypesC-45String-C-43C-43 "Linearity checking failed on " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-14) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-15) " not a function type)"))))) eta-0)))))))))))))))))(else (let ((act-27 ((CoreC-45NormaliseC-45Eval-getTerm e-6) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-2 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-10 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-29 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-21 (PreludeC-45TypesC-45String-C-43C-43 "Linearity checking failed on " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-11) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-12) " not a function type)"))))) eta-0)))))))))))))))))))))))))))))))))))) ((5) (let ((e-25 (vector-ref arg-6 1))) (let ((e-26 (vector-ref arg-6 2))) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-27) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-28) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((e-11 (car e-4))) (let ((e-10 (cdr e-4))) (vector 1 (cons (vector 5 e-25 e-26 e-2 e-9) (cons e-11 e-10))))))))))))))))))))))) ((6) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-32) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-7 (cdr e-3))) (vector 1 (cons (vector 6 e-30 e-31 e-2) (cons (CoreC-45NormaliseC-45Eval-gType e-30) e-7))))))))))))))) ((7) (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (csegen-21) arg-4 arg-5 e-36) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-37) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((e-11 (car e-4))) (let ((e-10 (cdr e-4))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-getTerm e-11) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (vector 1 (cons (vector 7 e-34 e-35 e-2 e-9) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 6 e-34 e-35 e-12)) e-10))))))))))))))))))))))))))) ((8) (let ((e-39 (vector-ref arg-6 1))) (let ((e-41 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-41) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-6) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (case (vector-ref e-8 0) ((5) (let ((e-9 (vector-ref e-8 2))) (let ((e-4 (vector-ref e-8 3))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (cons (vector 8 e-39 e-9 e-2) (cons (CoreC-45Normalise-glueBack arg-1 arg-0 e-10 arg-5 e-4) e-7))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-39 "Not a delayed type") eta-0))))))))))))))))))) ((9) (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (lambda (eta-0) (vector 1 (cons (vector 9 e-43 e-44) (cons (CoreC-45NormaliseC-45Eval-gErased e-43) '()))))))) ((10) (let ((e-46 (vector-ref arg-6 1))) (let ((e-47 (vector-ref arg-6 2))) (lambda (eta-0) (vector 1 (cons (vector 10 e-46 e-47) (cons (CoreC-45NormaliseC-45Eval-gErased e-46) '()))))))) (else (let ((e-49 (vector-ref arg-6 1))) (lambda (eta-0) (vector 1 (cons (vector 11 e-49) (cons (CoreC-45NormaliseC-45Eval-gType e-49) '())))))))))
(define CoreC-45LinearCheck-getArgUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45LinearCheck-n--8510-14085-u--getPUsage arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-4 eta-0)) arg-5 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45LinearCheck-n--8510-14088-u--combine arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-6))))))))))))
(define CoreC-45LinearCheck-expandMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-8 0) ((1) (let ((e-0 (vector-ref arg-8 1))) (let ((e-1 (vector-ref arg-8 2))) (let ((e-2 (vector-ref arg-8 3))) (let ((e-3 (vector-ref arg-8 4))) (let ((e-4 (vector-ref arg-8 5))) (lambda (clam-0) (if (null? e-1) (case (vector-ref e-2 0) ((1) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (let ((act-24 ((CoreC-45LinearCheck-n--8526-16090-u--substMeta arg-0 e-0 e-3 e-4 e-7 e-8 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() arg-0 (CoreC-45TT-embed e-8) arg-9 '()) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) clam-0))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed metavar solution " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-6) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45ContextC-45Context-u--show_Show_Def arg-8))))) clam-0))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed metavar solution " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-6) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45ContextC-45Context-u--show_Show_Def arg-8))))) clam-0)))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed metavar solution " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-6) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45ContextC-45Context-u--show_Show_Def arg-8))))) eta-0))))))
(define CoreC-45LinearCheck-doneScope (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 0) (CoreC-45LinearCheck-doneScope e-3))(else (let ((e-8 (- e-2 1))) (cons e-8 (CoreC-45LinearCheck-doneScope e-3))))))))))
(define CoreC-45LinearCheck-discharge (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 0 e-1 e-2 e-3 e-4) arg-7) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (vector 3 arg-3 arg-4 (vector 2 e-1 e-2 e-3 e-4) e-5)) arg-9)))))))))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (let ((e-9 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 1 e-6 e-7 e-8 e-9) arg-7) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (vector 3 arg-3 arg-4 (vector 1 e-6 e-7 e-8 e-9) e-5)) arg-9)))))))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 2 e-11 e-12 e-13 e-14) arg-7) (cons arg-6 arg-9)))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 3 e-16 e-17 e-18 e-19) arg-7) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (vector 3 arg-3 arg-4 (vector 5 e-16 e-17 e-19) e-5)) arg-9)))))))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (let ((e-24 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 4 e-21 e-22 e-23 e-24) arg-7) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (vector 3 arg-3 arg-4 (vector 4 e-21 e-22 e-23 e-24) e-5)) arg-9)))))))))))) (else (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (let ((e-28 (vector-ref arg-5 3))) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 5 e-26 e-27 e-28) arg-7) (cons arg-6 arg-9))))))))))
(define CoreC-45LinearCheck-count (lambda (arg-1 arg-2) (if (null? arg-2) 0 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-1 (CoreC-45TT-varIdx e-2)))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) (CoreC-45LinearCheck-count arg-1 e-3))) (else (CoreC-45LinearCheck-count arg-1 e-3)))))))))
(define CoreC-45LinearCheck-checkEnvUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-0) (lambda (clam-0) (vector 1 0)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-6))) (let ((e-9 (cdr arg-6))) (let ((u--pos (CoreC-45LinearCheck-localPrf arg-1))) (let ((u--used_in (CoreC-45LinearCheck-count (CoreC-45TT-varIdx u--pos) arg-7))) (lambda (eta-0) (let ((act-24 (let ((sc2 (AlgebraC-45Semiring-isLinear (csegen-475) (CoreC-45TT-multiplicity e-8)))) (cond ((equal? sc2 1) ((CoreC-45LinearCheck-updateHoleUsage (PreludeC-45TypesC-45List-tailRecAppend arg-1 (cons e-2 e-3)) arg-2 arg-3 (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0)) u--pos '() arg-8) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--used (let ((sc3 (let ((sc4 (AlgebraC-45Semiring-isLinear (csegen-475) (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega (CoreC-45TT-multiplicity e-8) arg-5)))) (cond ((equal? sc4 1) (cond ((equal? e-5 1) (PreludeC-45Types-u--C-61C-61_Eq_Nat u--used_in (PreludeC-45Types-u--fromInteger_Num_Nat 0))) (else 0))) (else 0))))) (cond ((equal? sc3 1) (PreludeC-45Types-u--fromInteger_Num_Nat 1)) (else u--used_in))))) (let ((act-25 (CoreC-45LinearCheck-n--15530-16639-u--checkUsageOK e-2 e-3 e-9 e-8 arg-1 arg-8 arg-7 arg-5 arg-4 arg-3 arg-2 u--used (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega (CoreC-45TT-multiplicity e-8) arg-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((CoreC-45LinearCheck-checkEnvUsage e-3 (PreludeC-45TypesC-45List-tailRecAppend arg-1 (cons e-2 '())) arg-2 arg-3 arg-4 arg-5 e-9 arg-7 arg-8) eta-0)))))))))))))))))))
(define CoreC-45LinearCheck-C-43C-43 (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons e-2 (CoreC-45LinearCheck-C-43C-43 e-3 arg-2)))))))
(define TTImpC-45BindImplicits-n--7154-3196-u--tag (lambda (arg-0 arg-1 arg-3 arg-4) (DataC-45List-u--zip_Zippable_List (PreludeC-45Types-u--map_Functor_List (lambda (arg-2) (bs+ arg-2 arg-3 63)) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (csegen-219) 0 (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45List-length arg-4)))) arg-4)))
(define TTImpC-45BindImplicits-n--6043-2594-u--renameAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-4 arg-3 e-1) (lambda (bind-0) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 2 bind-0) eta-0))) ext-0)))(else (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) arg-5 ext-0)))))
(define TTImpC-45BindImplicits-n--7333-3362-u--piBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) arg-5 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (vector 1 arg-2 (csegen-21) (vector 0 ) (box (vector 1 (vector 0 e-2))) (vector 32 arg-2 0) (TTImpC-45BindImplicits-n--7333-3362-u--piBind arg-0 arg-1 arg-2 arg-3 e-3 arg-5)))))))
(define TTImpC-45BindImplicits-renameIBinds (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (if (null? e-4) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-6) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 1 e-1 e-2 e-3 e-4 bind-0 bind-1) eta-2))) eta-1))) eta-0)) (let ((e-59 (unbox e-4))) (case (vector-ref e-59 0) ((1) (let ((e-60 (vector-ref e-59 1))) (case (vector-ref e-60 0) ((0) (let ((e-61 (vector-ref e-60 1))) (let ((u--un (vector 1 (vector 0 e-61)))) (let ((sc4 (PreludeC-45Types-elem (csegen-17) e-61 arg-0))) (cond ((equal? sc4 1) (let ((u--nC-39 (TTImpC-45Utils-getUnique (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) e-61))) (let ((u--unC-39 (vector 1 (vector 0 u--nC-39)))) (let ((u--scC-39 (TTImpC-45Utils-substNames (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 eta-0))) (DataC-45List-filter (lambda (arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-3 e-61)) arg-1)) (cons (cons u--un (vector 0 e-1 u--unC-39)) '()) e-6))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 (cons u--nC-39 arg-1) u--scC-39) (lambda (u--scr) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (u--tyC-39) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (csegen-2154) (lambda (u--upds) (PreludeC-45Interfaces-C-62C-62 (csegen-2155) (lambda (u--y) (ControlC-45MonadC-45Identity-u--pure_Applicative_Identity (cons (cons (cons e-61 u--nC-39) u--upds) 0))) (lambda () (lambda (eta-3) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 1 e-1 e-2 e-3 (box u--unC-39) u--tyC-39 u--scr) eta-3))))) eta-2))) eta-1))) eta-0)))))) (else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-6) (lambda (u--scr) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (u--tyC-39) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 1 e-1 e-2 e-3 (box u--un) u--tyC-39 u--scr) eta-2))) eta-1))) eta-0))))))))(else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-6) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 1 e-1 e-2 e-3 e-4 bind-0 bind-1) eta-2))) eta-1))) eta-0))))))(else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-6) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 1 e-1 e-2 e-3 e-4 bind-0 bind-1) eta-2))) eta-1))) eta-0))))))))))))) ((2) (let ((e-8 (vector-ref arg-2 1))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-10 (vector-ref arg-2 3))) (let ((e-11 (vector-ref arg-2 4))) (let ((e-12 (vector-ref arg-2 5))) (let ((e-13 (vector-ref arg-2 6))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-12) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-13) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 2 e-8 e-9 e-10 e-11 bind-0 bind-1) eta-2))) eta-1))) eta-0))))))))) ((8) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-16) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-17) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 8 e-15 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((9) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-20) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-21) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 9 e-19 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((10) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-24) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-26) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 10 e-23 bind-0 e-25 bind-1) eta-2))) eta-1))) eta-0))))))) ((11) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-29) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-30) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 11 e-28 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((18) (let ((e-32 (vector-ref arg-2 1))) (let ((e-33 (vector-ref arg-2 2))) (let ((e-34 (vector-ref arg-2 3))) (let ((e-35 (vector-ref arg-2 4))) (let ((e-36 (vector-ref arg-2 5))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-36) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 18 e-32 e-33 e-34 e-35 bind-0) eta-1))) eta-0)))))))) ((19) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-40) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 19 e-38 e-39 bind-0) eta-1))) eta-0)))))) ((20) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-44) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 20 e-42 e-43 bind-0) eta-1))) eta-0)))))) ((21) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-47) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 21 e-46 bind-0) eta-1))) eta-0))))) ((22) (let ((e-49 (vector-ref arg-2 1))) (let ((e-50 (vector-ref arg-2 2))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-50) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 22 e-49 bind-0) eta-1))) eta-0))))) ((13) (let ((e-52 (vector-ref arg-2 1))) (let ((e-53 (vector-ref arg-2 2))) (let ((e-54 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (lambda (eta-1) (TTImpC-45BindImplicits-n--6043-2594-u--renameAlt e-54 e-53 e-52 arg-1 arg-0 e-53 eta-1)) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (PreludeC-45Types-u--traverse_Traversable_List (csegen-2156) (lambda (eta-2) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 eta-2)) e-54) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 13 e-52 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((17) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (let ((sc1 (PreludeC-45Types-elem (csegen-17) e-57 arg-0))) (cond ((equal? sc1 1) (let ((u--nC-39 (TTImpC-45Utils-getUnique (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) e-57))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (csegen-2142) (csegen-2154) (lambda (u--upds) (PreludeC-45Interfaces-C-62C-62 (csegen-2155) (lambda (u--y) (ControlC-45MonadC-45Identity-u--pure_Applicative_Identity (cons (cons (cons e-57 u--nC-39) u--upds) 0))) (lambda () (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 17 e-56 u--nC-39) eta-1))))) eta-0)))) (else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) (vector 17 e-56 e-57) eta-0))))))))(else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (csegen-2142) arg-2 eta-0))))))
(define TTImpC-45BindImplicits-piBindNames (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((TTImpC-45Utils-findUniqueBindableNames arg-0 arg-1 1 arg-2 '() arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (TTImpC-45BindImplicits-n--7333-3362-u--piBind arg-3 arg-2 arg-1 arg-0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-5) arg-3))))))))
(define TTImpC-45BindImplicits-getUsings (lambda (arg-0 arg-1) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (TTImpC-45BindImplicits-getUsing eta-1 eta-2))) arg-1 eta-0)) arg-0)))
(define TTImpC-45BindImplicits-getUsing (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-10) (let ((u--ns (DataC-45List-nub (csegen-802) (TTImpC-45Utils-findIBindVars e-11)))) (let ((sc4 (PreludeC-45Types-elem (csegen-802) arg-0 u--ns))) (cond ((equal? sc4 1) (cons (cons e-6 (cons (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (cons (vector 2 ) (cons '() e-11)))) (TTImpC-45BindImplicits-getUsing arg-0 e-3))) (else (TTImpC-45BindImplicits-getUsing arg-0 e-3))))) (let ((e-13 (unbox e-10))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-13))) (cond ((equal? sc4 1) (cons (cons e-6 (cons (csegen-21) (cons (vector 0 ) (cons (box arg-0) e-11)))) (TTImpC-45BindImplicits-getUsing arg-0 e-3))) (else (TTImpC-45BindImplicits-getUsing arg-0 e-3)))))))))))))))
(define TTImpC-45BindImplicits-doBind (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (case (vector-ref e-2 0) ((1) (let ((e-64 (vector-ref e-2 1))) (case (vector-ref e-64 0) ((0) (let ((e-65 (vector-ref e-64 1))) (PreludeC-45Types-maybe (lambda () (vector 0 e-1 e-2)) (lambda () (lambda (eta-0) (vector 17 e-1 eta-0))) (DataC-45List-lookup (csegen-17) e-65 arg-0))))(else arg-1))))(else arg-1))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (let ((u--nsC-39 (if (null? e-7) arg-0 (let ((e-1 (unbox e-7))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (DataC-45List-filter (lambda (u--x) (PreludeC-45EqOrd-u--C-47C-61_Eq_String (Builtin-fst u--x) e-3)) arg-0)))(else arg-0))))(else arg-0)))))) (vector 1 e-4 e-5 e-6 e-7 (TTImpC-45BindImplicits-doBind u--nsC-39 e-8) (TTImpC-45BindImplicits-doBind u--nsC-39 e-9)))))))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (let ((u--nsC-39 (if (null? e-14) arg-0 (let ((e-1 (unbox e-14))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (DataC-45List-filter (lambda (u--x) (PreludeC-45EqOrd-u--C-47C-61_Eq_String (Builtin-fst u--x) e-3)) arg-0)))(else arg-0))))(else arg-0)))))) (vector 2 e-11 e-12 e-13 e-14 (TTImpC-45BindImplicits-doBind u--nsC-39 e-15) (TTImpC-45BindImplicits-doBind u--nsC-39 e-16)))))))))) ((8) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (vector 8 e-18 (TTImpC-45BindImplicits-doBind arg-0 e-19) (TTImpC-45BindImplicits-doBind arg-0 e-20)))))) ((9) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (let ((e-24 (vector-ref arg-1 3))) (vector 9 e-22 (TTImpC-45BindImplicits-doBind arg-0 e-23) (TTImpC-45BindImplicits-doBind arg-0 e-24)))))) ((10) (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((e-29 (vector-ref arg-1 4))) (vector 10 e-26 (TTImpC-45BindImplicits-doBind arg-0 e-27) e-28 (TTImpC-45BindImplicits-doBind arg-0 e-29))))))) ((11) (let ((e-31 (vector-ref arg-1 1))) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (vector 11 e-31 (TTImpC-45BindImplicits-doBind arg-0 e-32) (TTImpC-45BindImplicits-doBind arg-0 e-33)))))) ((18) (let ((e-35 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (let ((e-37 (vector-ref arg-1 3))) (let ((e-38 (vector-ref arg-1 4))) (let ((e-39 (vector-ref arg-1 5))) (vector 18 e-35 e-36 e-37 e-38 (TTImpC-45BindImplicits-doBind arg-0 e-39)))))))) ((19) (let ((e-41 (vector-ref arg-1 1))) (let ((e-42 (vector-ref arg-1 2))) (let ((e-43 (vector-ref arg-1 3))) (vector 19 e-41 e-42 (TTImpC-45BindImplicits-doBind arg-0 e-43)))))) ((20) (let ((e-45 (vector-ref arg-1 1))) (let ((e-46 (vector-ref arg-1 2))) (let ((e-47 (vector-ref arg-1 3))) (vector 20 e-45 e-46 (TTImpC-45BindImplicits-doBind arg-0 e-47)))))) ((21) (let ((e-49 (vector-ref arg-1 1))) (let ((e-50 (vector-ref arg-1 2))) (vector 21 e-49 (TTImpC-45BindImplicits-doBind arg-0 e-50))))) ((22) (let ((e-52 (vector-ref arg-1 1))) (let ((e-53 (vector-ref arg-1 2))) (vector 22 e-52 (TTImpC-45BindImplicits-doBind arg-0 e-53))))) ((23) (let ((e-55 (vector-ref arg-1 1))) (let ((e-56 (vector-ref arg-1 2))) (vector 23 e-55 (TTImpC-45BindImplicits-doBind arg-0 e-56))))) ((26) (let ((e-58 (vector-ref arg-1 1))) (let ((e-59 (vector-ref arg-1 2))) (vector 26 e-58 (TTImpC-45BindImplicits-doBind arg-0 e-59))))) ((13) (let ((e-61 (vector-ref arg-1 1))) (let ((e-62 (vector-ref arg-1 2))) (let ((e-63 (vector-ref arg-1 3))) (vector 13 e-61 (TTImpC-45TTImp-mapAltType (lambda (eta-0) (TTImpC-45BindImplicits-doBind arg-0 eta-0)) e-62) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45BindImplicits-doBind arg-0 eta-0)) e-63))))))(else arg-1)))))
(define TTImpC-45BindImplicits-bindUsings (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 (TTImpC-45TTImp-getFC e-15) e-6 e-10 e-14 e-15 (TTImpC-45BindImplicits-bindUsings e-3 arg-1)))))))))))))
(define TTImpC-45BindImplicits-bindTypeNamesUsed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-isUnboundImplicits arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 ((TTImpC-45Utils-findUniqueBindableNames arg-0 arg-1 1 arg-3 arg-2 arg-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (TTImpC-45BindImplicits-doBind e-6 arg-4))))))) (else (vector 1 arg-4)))))))))
(define TTImpC-45BindImplicits-bindTypeNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-isUnboundImplicits arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 ((TTImpC-45Utils-findUniqueBindableNames arg-0 arg-1 1 arg-3 '() arg-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--btm (TTImpC-45BindImplicits-doBind e-6 arg-4))) (vector 1 (TTImpC-45BindImplicits-addUsing arg-2 u--btm)))))))) (else (vector 1 arg-4)))))))))
(define TTImpC-45BindImplicits-bindNames (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-isUnboundImplicits arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((u--ns (DataC-45List-nub (csegen-1819) (TTImpC-45Utils-findBindableNames arg-1 '() '() arg-2)))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "elab.bindnames" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Found names :" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2171) u--ns))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (cons (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 eta-0))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) u--ns)) (TTImpC-45BindImplicits-doBind u--ns arg-2)))))))) (else (vector 1 (cons '() arg-2))))))))))
(define TTImpC-45BindImplicits-addUsing (lambda (arg-0 arg-1) (let ((u--ns (DataC-45List-nub (csegen-802) (TTImpC-45Utils-findIBindVars arg-1)))) (let ((u--bs (DataC-45List-nubBy (lambda (u--x) (lambda (u--y) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (Builtin-fst u--x) (Builtin-fst u--y)))) (TTImpC-45BindImplicits-getUsings u--ns (TTImpC-45BindImplicits-n--7154-3196-u--tag arg-1 arg-0 0 arg-0))))) (TTImpC-45BindImplicits-bindUsings (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) u--bs) arg-1)))))
(define ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (lambda (arg-3 arg-4 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) (cons ext-0 arg-4))))))
(define ControlC-45MonadC-45StateC-45State-u--map_Functor_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (PreludeC-45Interfaces-C-60C-36C-62 arg-4 (lambda (eta-0) (let ((e-2 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-2 (arg-5 e-3))))) (arg-6 ext-0))))
(define ControlC-45MonadC-45StateC-45State-u--join_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (lambda (arg-3 arg-4 ext-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 arg-3 arg-4 (lambda (eta-0) eta-0) ext-0)))
(define ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (arg-5 ext-0)) (lambda (_-0) (let ((e-5 (car _-0))) (let ((e-4 (cdr _-0))) ((arg-6 e-4) e-5))))))))
(define ControlC-45MonadC-45StateC-45State-u--C-60C-42C-62_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (arg-5 ext-0)) (lambda (_-0) (let ((e-5 (car _-0))) (let ((e-4 (cdr _-0))) (let ((e-7 (vector-ref arg-4 1))) ((((e-7 'erased) 'erased) (arg-6 e-5)) (lambda (_-1) (let ((e-10 (car _-1))) (let ((e-9 (cdr _-1))) (let ((e-13 (vector-ref arg-4 0))) (let ((e-15 (vector-ref e-13 1))) ((e-15 'erased) (cons e-10 (e-4 e-9)))))))))))))))))
(define ControlC-45MonadC-45Identity-u--pure_Applicative_Identity (lambda (arg-1) arg-1))
(define ControlC-45MonadC-45Identity-u--map_Functor_Identity (lambda (arg-2 arg-3) (arg-2 arg-3)))
(define ControlC-45MonadC-45Identity-u--join_Monad_Identity (lambda (arg-1) (ControlC-45MonadC-45Identity-u--C-62C-62C-61_Monad_Identity arg-1 (lambda (eta-0) eta-0))))
(define ControlC-45MonadC-45Identity-u--C-62C-62C-61_Monad_Identity (lambda (arg-2 arg-3) (arg-3 arg-2)))
(define ControlC-45MonadC-45Identity-u--C-60C-42C-62_Applicative_Identity (lambda (arg-2 arg-3) (arg-2 arg-3)))
(define TTImpC-45ProcessTransform-processTransform (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 arg-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-resolveName arg-1 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ProcessDef-checkLHS arg-0 arg-1 arg-2 arg-3 arg-4 1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) 1 e-6 arg-5 arg-6 arg-7 arg-8 arg-10 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-3 (cdr e-7))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (let ((e-22 (car e-19))) (let ((e-23 (cdr e-19))) (let ((act-27 (CoreC-45ContextC-45Log-logTerm e-9 arg-1 "transform.lhs" (+ 1 (+ 1 (+ 1 0))) (lambda () "Transform LHS") e-22 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 ((CoreC-45Core-wrapError (lambda (eta-0) (vector 65 arg-8 arg-9 eta-0)) (lambda (eta-0) (TTImpC-45Elab-checkTermSub arg-0 e-9 arg-1 arg-2 arg-3 arg-4 e-6 (vector 2 ) (cons 3 arg-5) e-18 e-14 arg-7 e-10 arg-11 (CoreC-45NormaliseC-45Eval-gnf e-9 e-14 e-23) eta-0))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Metadata-clearHoleLHS arg-2 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (CoreC-45ContextC-45Log-logTerm e-9 arg-1 "transform.rhs" (+ 1 (+ 1 (+ 1 0))) (lambda () "Transform RHS") e-13 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (CoreC-45Context-addTransform arg-1 arg-8 (vector e-9 e-5 e-14 e-22 e-13) ext-0)))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessDef-with--withC-32blockC-32inC-32nameListEq-10877 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) '() (let ((e-1 (unbox arg-2))) (cond (else (box 0)))))))
(define TTImpC-45ProcessDef-with--nameListEq-10870 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) '() (let ((e-1 (unbox arg-2))) (cond (else (TTImpC-45ProcessDef-with--withC-32blockC-32inC-32nameListEq-10877 arg-4 arg-3 (TTImpC-45ProcessDef-nameListEq arg-3 arg-4) arg-0)))))))
(define TTImpC-45ProcessDef-with--extendEnv-4694 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (if (null? arg-2) (csegen-2176) (let ((e-2 (unbox arg-2))) (cond (else (TTImpC-45ProcessDef-extendEnv (cons arg-0 arg-4) (cons (vector 1 arg-14 arg-13 arg-11 arg-12) arg-19) (vector 1 arg-18) (TTImpC-45TTImp-u--weaken_Weaken_NestedNames arg-17) arg-15 arg-16)))))))
(define TTImpC-45ProcessDef-with--extendEnv-4613 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (if (null? arg-2) (csegen-2176) (let ((e-2 (unbox arg-2))) (cond (else (TTImpC-45ProcessDef-extendEnv (cons arg-0 arg-4) (cons (vector 3 arg-13 arg-12 arg-11 arg-10) arg-18) (vector 1 arg-17) (TTImpC-45TTImp-u--weaken_Weaken_NestedNames arg-16) arg-14 arg-15)))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32lookupOrAddAlias-12558 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (lambda (clam-0) (if (null? arg-16) (vector 1 '()) (let ((e-1 (unbox arg-16))) (let ((e-6 (cdr e-1))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-12 "declare.def" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Missing type declaration for the alias " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-5) ". Checking first whether it is a misspelling."))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 ((CoreC-45Context-getSimilarNames arg-12 arg-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (vector 1 '()) (let ((e-2 (unbox e-8))) (let ((e-10 (car e-2))) (let ((e-9 (cdr e-2))) (let ((act-26 ((PreludeC-45Basics-flip (csegen-1822) e-9 (lambda (lamc-0) (lambda (clam-1) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact e-4 (let ((e-0 (vector-ref arg-14 0))) e-0)) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (if (null? e-11) (vector 1 '()) (let ((e-12 (unbox e-11))) (let ((e-17 (vector-ref e-12 17))) (case (vector-ref e-17 0) ((0) (vector 1 (box (cons e-4 e-3))))(else (vector 1 '()))))))))))))))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (CoreC-45Context-showSimilarNames arg-5 e-10 (DataC-45List-catMaybes e-11))))))))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-12 "declare.def" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Not a misspelling: go ahead and declare it!") clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (TTImpC-45ProcessType-processType arg-0 arg-12 arg-13 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) 2 '() (vector arg-6 arg-6 arg-5 (TTImpC-45ProcessDef-n--24432-12467-u--holeyType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-6))) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (unbox arg-12))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-28 1))) ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref e-11 0))) e-0)) clam-0))))))))))) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 66 (vector 37 arg-6 arg-5) (cons e-2 e-3)) clam-0)))))))))))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32mkRunTime-11721 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((1) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (let ((e-2 (vector-ref arg-10 3))) (let ((e-4 (vector-ref arg-10 5))) (let ((u--ty (let ((e-24 (vector-ref arg-7 2))) e-24))) (lambda () (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45ProcessDef-n--23277-11434-u--toErased arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-26 (vector-ref arg-7 0))) e-26) (TTImpC-45ProcessDef-n--23277-11433-u--getSpec arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-11 (vector-ref arg-7 11))) e-11)) eta-1)) e-4 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--clauses_init (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (TTImpC-45ProcessDef-n--23277-11435-u--toClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-27 (vector-ref arg-7 0))) e-27) eta-1)) e-5))) (let ((u--clauses (case (vector-ref arg-9 0) ((1) (TTImpC-45ProcessDef-n--23277-11432-u--addErrorCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--clauses_init))(else u--clauses_init)))) (let ((act-25 (CoreC-45CaseC-45CaseBuilder-getPMDef arg-5 (let ((e-27 (vector-ref arg-7 0))) e-27) '() arg-0 u--ty u--clauses eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((e-10 (car e-7))) (let ((act-26 (let ((act-26 (CoreC-45Context-toFullNames arg-5 (csegen-2177) e-10 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-5 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (vector 1 (LibrariesC-45DataC-45StringC-45Extra-unlines (cons (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_Covering arg-9) ":") (cons (PreludeC-45TypesC-45String-C-43C-43 "Runtime tree for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-32 (vector-ref arg-7 1))) e-32)) ":")) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_C-40CaseTreeC-32C-36varsC-41 e-8 e-11))) '())))))) eta-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((act-27 (CoreC-45ContextC-45Log-log arg-5 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-8 e-10)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((act-28 (CoreC-45ContextC-45Log-log arg-5 "compile.casetree.measure" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))) (lambda () (PreludeC-45Show-u--show_Show_Nat (CoreC-45CaseC-45CaseTree-measure e-10))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((sc8 (TTImpC-45ProcessDef-nameListEq e-1 e-8))) (if (null? sc8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "WAT") eta-0) (let ((e-14 (unbox sc8))) (cond (else (let ((act-29 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45Context-addDef arg-5 arg-0 (let ((e-36 (vector-ref arg-7 0))) (let ((e-35 (vector-ref arg-7 1))) (let ((e-34 (vector-ref arg-7 2))) (let ((e-33 (vector-ref arg-7 3))) (let ((e-32 (vector-ref arg-7 4))) (let ((e-31 (vector-ref arg-7 5))) (let ((e-30 (vector-ref arg-7 6))) (let ((e-29 (vector-ref arg-7 7))) (let ((e-28 (vector-ref arg-7 8))) (let ((e-27 (vector-ref arg-7 9))) (let ((e-26 (vector-ref arg-7 10))) (let ((e-25 (vector-ref arg-7 11))) (let ((e-24 (vector-ref arg-7 12))) (let ((e-23 (vector-ref arg-7 13))) (let ((e-22 (vector-ref arg-7 14))) (let ((e-15 (vector-ref arg-7 15))) (let ((e-16 (vector-ref arg-7 16))) (let ((e-18 (vector-ref arg-7 18))) (let ((e-19 (vector-ref arg-7 19))) (let ((e-20 (vector-ref arg-7 20))) (let ((e-21 (vector-ref arg-7 21))) (vector e-36 e-35 e-34 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-22 e-15 e-16 (vector 1 e-0 e-1 e-2 e-10 e-4) e-18 e-19 e-20 e-21)))))))))))))))))))))) eta-1)) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-15 (vector-ref act-29 1))) (vector 0 e-15))) (else (let ((act-30 (CoreC-45Context-toFullNames arg-5 (csegen-46) arg-0 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-16 (vector-ref act-30 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-30 1))) (let ((sc12 (let ((sc13 (TTImpC-45ProcessDef-n--23277-11428-u--caseName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-16))) (cond ((equal? sc13 1) (TTImpC-45ProcessDef-n--23277-11427-u--noInline arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-27 (vector-ref arg-7 11))) e-27))) (else 0))))) (cond ((equal? sc12 1) (let ((act-31 (TTImpC-45ElabC-45Utils-canInlineCaseBlock arg-5 arg-0 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-17 (vector-ref act-31 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-31 1))) (cond ((equal? e-17 1) (CoreC-45Context-setFlag arg-5 arg-1 arg-0 (vector 0 ) eta-0)) (else (vector 1 0)))))))) (else (vector 1 0))))))))))))))))))))))))))))))))))))))))))))))(else (lambda () (lambda (eta-0) (vector 1 0)))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32calcRefs-11049 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((1) (let ((e-2 (vector-ref arg-7 3))) (let ((e-3 (vector-ref arg-7 4))) (let ((u--refs (cond ((equal? arg-2 1) (let ((e-13 (vector-ref arg-5 13))) e-13)) (else (let ((e-12 (vector-ref arg-5 12))) e-12))))) (if (null? u--refs) (let ((u--tree (cond ((equal? arg-2 1) e-3) (else e-2)))) (let ((u--metas (CoreC-45CaseC-45CaseTree-getMetas u--tree))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-addToSave arg-3 eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys u--metas) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((u--refs_all (CoreC-45CaseC-45CaseTree-addRefs arg-1 u--metas u--tree))) (let ((act-25 (cond ((equal? arg-2 1) (TTImpC-45ProcessDef-n--22656-10902-u--dropErased arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-keys u--refs_all) u--refs_all eta-0)) (else (vector 1 u--refs_all))))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (clam-0) (cond ((equal? arg-2 1) (CoreC-45Context-addDef arg-3 arg-0 (let ((e-28 (vector-ref arg-5 0))) (let ((e-27 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-24 (vector-ref arg-5 4))) (let ((e-23 (vector-ref arg-5 5))) (let ((e-22 (vector-ref arg-5 6))) (let ((e-7 (vector-ref arg-5 7))) (let ((e-8 (vector-ref arg-5 8))) (let ((e-9 (vector-ref arg-5 9))) (let ((e-10 (vector-ref arg-5 10))) (let ((e-11 (vector-ref arg-5 11))) (let ((e-12 (vector-ref arg-5 12))) (let ((e-14 (vector-ref arg-5 14))) (let ((e-15 (vector-ref arg-5 15))) (let ((e-16 (vector-ref arg-5 16))) (let ((e-17 (vector-ref arg-5 17))) (let ((e-18 (vector-ref arg-5 18))) (let ((e-19 (vector-ref arg-5 19))) (let ((e-20 (vector-ref arg-5 20))) (let ((e-21 (vector-ref arg-5 21))) (vector e-28 e-27 e-26 e-25 e-24 e-23 e-22 e-7 e-8 e-9 e-10 e-11 e-12 (box e-6) e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) clam-0)) (else (CoreC-45Context-addDef arg-3 arg-0 (let ((e-28 (vector-ref arg-5 0))) (let ((e-27 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-24 (vector-ref arg-5 4))) (let ((e-23 (vector-ref arg-5 5))) (let ((e-22 (vector-ref arg-5 6))) (let ((e-7 (vector-ref arg-5 7))) (let ((e-8 (vector-ref arg-5 8))) (let ((e-9 (vector-ref arg-5 9))) (let ((e-10 (vector-ref arg-5 10))) (let ((e-11 (vector-ref arg-5 11))) (let ((e-13 (vector-ref arg-5 13))) (let ((e-14 (vector-ref arg-5 14))) (let ((e-15 (vector-ref arg-5 15))) (let ((e-16 (vector-ref arg-5 16))) (let ((e-17 (vector-ref arg-5 17))) (let ((e-18 (vector-ref arg-5 18))) (let ((e-19 (vector-ref arg-5 19))) (let ((e-20 (vector-ref arg-5 20))) (let ((e-21 (vector-ref arg-5 21))) (vector e-28 e-27 e-26 e-25 e-24 e-23 e-22 e-7 e-8 e-9 e-10 e-11 (box e-6) e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))) clam-0)))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessDef-calcRefs arg-3 arg-2 arg-1 eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys e-6) eta-0))))))))))))))) (lambda (eta-0) (vector 1 0)))))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-9196 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 arg-40 arg-41 arg-42 arg-43 arg-44 arg-45 arg-46 arg-47 arg-48 arg-49 arg-50 arg-51 arg-52) (if (null? arg-52) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Impossible happened: With abstraction failure #4") eta-0)) (let ((e-1 (unbox arg-52))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((u--wargNames (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (box eta-0)) e-5) (cons '() (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (box eta-0)) arg-46))))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm '() arg-18 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 0))) (lambda () "With function type") e-10 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45ContextC-45Log-log arg-18 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Argument names " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2180) u--wargNames))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (CoreC-45Context-toFullNames arg-18 (csegen-46) (vector 8 arg-10) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Context-prettyName arg-18 e-11) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-27 1))) (CoreC-45UnifyState-genWithName arg-18 arg-16 e-12 eta-0))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-addDef arg-18 e-11 (let ((sc6 (CoreC-45Context-newDef (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) e-11 (let ((sc7 (AlgebraC-45Semiring-isErased (csegen-475) arg-14))) (cond ((equal? sc7 1) (csegen-21)) (else (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))) arg-6 e-10 arg-13 (vector 0 )))) (let ((e-0 (vector-ref sc6 0))) (let ((e-29 (vector-ref sc6 1))) (let ((e-2 (vector-ref sc6 2))) (let ((e-3 (vector-ref sc6 3))) (let ((e-4 (vector-ref sc6 4))) (let ((e-28 (vector-ref sc6 5))) (let ((e-27 (vector-ref sc6 6))) (let ((e-26 (vector-ref sc6 7))) (let ((e-25 (vector-ref sc6 8))) (let ((e-24 (vector-ref sc6 9))) (let ((e-23 (vector-ref sc6 10))) (let ((e-22 (vector-ref sc6 11))) (let ((e-12 (vector-ref sc6 12))) (let ((e-13 (vector-ref sc6 13))) (let ((e-14 (vector-ref sc6 14))) (let ((e-15 (vector-ref sc6 15))) (let ((e-16 (vector-ref sc6 16))) (let ((e-17 (vector-ref sc6 17))) (let ((e-18 (vector-ref sc6 18))) (let ((e-19 (vector-ref sc6 19))) (let ((e-20 (vector-ref sc6 20))) (let ((e-21 (vector-ref sc6 21))) (vector e-0 e-29 e-2 e-3 e-4 e-28 e-27 e-26 e-25 e-24 e-23 (cons (vector 4 arg-12) e-22) e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21)))))))))))))))))))))))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((u--toWarg (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (PreludeC-45Types-maybe eta-1 eta-2 eta-3)))) (lambda () (lambda (u--pn) (cons (cons '() (vector 0 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (Builtin-snd u--pn))) '()))) (lambda () (cons (cons '() arg-3) (if (null? arg-2) '() (let ((u--fc (CoreC-45FC-emptyFC))) (let ((u--refl (vector 0 u--fc (vector 0 (CoreC-45NameC-45Namespace-builtinNS) (vector 1 (vector 0 "Refl")))))) (cons (cons arg-2 (vector 10 u--fc u--refl (vector 1 (vector 0 "x")) arg-3)) '()))))))))) (let ((u--rhs_in (TTImpC-45TTImp-gapply (vector 0 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) e-11) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (u--nm) (cons '() (vector 0 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) u--nm))) e-9) (PreludeC-45Interfaces-concatMap (csegen-50) u--toWarg u--wargNames))))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-18 "declare.def.clause" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Applying to with argument " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--rhs_in))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (let ((act-29 (CoreC-45Context-getFullName arg-18 (vector 8 arg-10) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-29 1))) ((TTImpC-45ElabC-45Utils-wrapErrorC arg-9 (lambda (eta-1) (vector 65 arg-5 e-14 eta-1)) (lambda (eta-1) (TTImpC-45Elab-checkTermSub arg-6 arg-20 arg-18 arg-17 arg-16 arg-15 arg-10 arg-27 arg-9 arg-23 arg-51 arg-7 arg-21 u--rhs_in (CoreC-45NormaliseC-45Eval-gnf arg-20 arg-51 arg-25) eta-1))) eta-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessDef-n--17220-7312-u--mkClauseWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (+ 1 0) e-11 u--wargNames arg-19 eta-1 eta-2))) arg-0 '() eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-30 1))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-18 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "With clauses: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1283) e-15))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (TTImpC-45ProcessDef-applyEnv arg-6 arg-18 arg-7 e-11 eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-32 1))) (let ((u--nestC-39C-39 (cons e-17 arg-8))) (let ((u--wdef (vector 2 arg-5 e-11 e-15))) (let ((act-33 ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-18 arg-17 arg-16 arg-15 '() u--nestC-39C-39 arg-7 u--wdef) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (vector 1 (vector 1 (vector arg-20 arg-51 arg-24 e-14)))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-8736 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 ext-0) (if (null? arg-39) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Impossible happened: With abstraction failure #3") ext-0) (let ((e-1 (unbox arg-39))) (let ((act-24 ((TTImpC-45ProcessDef-n--17220-7310-u--bindWithArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-38 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (__leftTupleSection-0) (cons __leftTupleSection-0 arg-37)) arg-2) e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--bnr (TTImpC-45ElabC-45Utils-bindNotReq arg-20 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) 0 arg-22 arg-36 '() arg-25))) (let ((u--notreqns (Builtin-fst u--bnr))) (let ((u--notreqty (Builtin-snd u--bnr))) (let ((act-25 (let ((sc5 (PreludeC-45Types-elem (cons (lambda (arg-40) (lambda (arg-41) (TTImpC-45TTImp-u--C-61C-61_Eq_WithFlag arg-40 arg-41))) (lambda (arg-40) (lambda (arg-41) (TTImpC-45TTImp-u--C-47C-61_Eq_WithFlag arg-40 arg-41)))) 0 arg-1))) (cond ((equal? sc5 1) (CoreC-45Context-clearDefs arg-32 ext-0)) (else (vector 1 arg-32)))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-18 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-35) e-8 e-6 (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-mkSizeOf e-2) arg-37)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-18 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-35) e-8 e-6 (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-mkSizeOf e-2) u--notreqty)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (CoreC-45Normalise-replace arg-18 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-35) e-8 e-6 e-9 e-10 e-12 ext-0))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((u--bNotReq (e-11 e-9))) (let ((u--envC-39 (TTImpC-45ProcessDef-n--17220-7309-u--mkExplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-22))) (let ((_-0 (cons e-2 (cons e-6 (cons e-10 e-11))))) ((TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-9196 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 e-1 e-2 e-6 e-10 e-11 _-0 u--bnr u--notreqns u--notreqty e-8 e-9 u--bNotReq u--envC-39 (TTImpC-45ElabC-45Utils-bindReq arg-20 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) u--envC-39 arg-36 '() u--bNotReq)) ext-0)))))))))))))))))))))))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-8455 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 ext-0) (let ((e-2 (car arg-35))) (let ((e-3 (cdr arg-35))) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-20 arg-18 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "With value type") arg-34 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45ContextC-45Log-log arg-18 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Using vars " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-2))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((sc3 (CoreC-45TT-shrinkTerm arg-33 e-3))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Impossible happened: With abstraction failure #1") ext-0) (let ((e-1 (unbox sc3))) (let ((sc4 (CoreC-45TT-shrinkTerm arg-34 e-3))) (if (null? sc4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Impossible happened: With abstraction failure #2") ext-0) (let ((e-4 (unbox sc4))) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-8736 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 e-2 e-3 e-1 e-4 (CoreC-45Env-shrinkEnv arg-22 e-3) ext-0)))))))))))))))))
(define TTImpC-45ProcessDef-case--combineLinear-5594 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (let ((act-24 ((TTImpC-45ProcessDef-combineLinear arg-3 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (cons arg-0 arg-1) e-5)))))) (let ((act-24 (TTImpC-45ProcessDef-n--16132-5441-u--combineAll arg-0 arg-1 arg-2 arg-3 arg-1 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-combineLinear arg-3 (DataC-45List-filter (lambda (eta-0) (TTImpC-45ProcessDef-n--16132-5438-u--notN arg-0 arg-1 arg-2 arg-3 eta-0)) arg-2)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (cons arg-0 e-5) e-6)))))))))))))
(define TTImpC-45ProcessDef-case--findLinear-5136 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (if (null? e-3) (vector 1 '()) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact e-7 (let ((e-0 (vector-ref e-8 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-25 1))) (if (null? e-9) (vector 1 '()) (let ((e-1 (unbox e-9))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-5 '() e-8 '() e-1) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-26 1))) ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-0 (TTImpC-45ProcessDef-n--15407-4808-u--accessible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-2) e-10 e-3) clam-0)))))))))))))))))))(else (vector 1 '())))))))))
(define TTImpC-45ProcessDef-n--25383-13256-u--withTotality (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 ext-0) (let ((act-24 (CoreC-45Context-getDefaultTotalityOption arg-10 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setDefaultTotalityOption arg-10 arg-12 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-u--catch_Catchable_Core_Error (arg-13) (lambda (u--error) (lambda (eta-0) (let ((act-26 (CoreC-45Context-setDefaultTotalityOption arg-10 e-5 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--error eta-0)))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-setDefaultTotalityOption arg-10 e-5 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-7)))))))))))))))))
(define TTImpC-45ProcessDef-n--18476-7535-u--wargs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36) (cons arg-19 (cons (TTImpC-45ProcessDef-n--18476-7534-u--wargn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36) '()))))
(define TTImpC-45ProcessDef-n--18331-7370-u--wargs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 arg-21) (cons (TTImpC-45ProcessDef-n--18331-7369-u--wargn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 arg-21) '())))
(define TTImpC-45ProcessDef-n--18476-7534-u--wargn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36) (vector 2 "warg" 0)))
(define TTImpC-45ProcessDef-n--18331-7369-u--wargn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 arg-21) (vector 2 "warg" 0)))
(define TTImpC-45ProcessDef-n--17220-7308-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (CoreC-45FC-virtualiseFC arg-5)))
(define TTImpC-45ProcessDef-n--23277-11434-u--toErased (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (CoreC-45LinearCheck-linearCheck e-2 arg-5 arg-3 arg-6 (csegen-519) 1 e-6 e-10 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Transform-applyTransforms arg-5 e-6 e-11) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45PartialEval-applySpecialise e-2 arg-5 arg-4 arg-3 arg-2 e-6 arg-7 e-8) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45LinearCheck-linearCheck e-2 arg-5 arg-3 arg-6 (csegen-519) 1 e-6 e-9 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (cons e-2 (cons e-6 (cons e-5 e-12)))))))))))))))))))))))))))))
(define TTImpC-45ProcessDef-n--23277-11435-u--toClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector e-2 e-6 e-10 e-11)))))))))
(define TTImpC-45ProcessDef-n--25383-13257-u--simplePat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12) (case (vector-ref arg-12 0) ((0) 1) ((10) 1) ((5) (let ((e-13 (vector-ref arg-12 4))) (TTImpC-45ProcessDef-n--25383-13257-u--simplePat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-13)))(else 0))))
(define TTImpC-45ProcessDef-n--16132-5438-u--notN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (CoreC-45Name-u--C-47C-61_Eq_Name arg-0 e-2))))
(define TTImpC-45ProcessDef-n--23277-11427-u--noInline (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (case (vector-ref e-1 0) ((0) 0)(else (TTImpC-45ProcessDef-n--23277-11427-u--noInline arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2))))))))
(define TTImpC-45ProcessDef-n--17220-7309-u--mkExplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20) (if (null? arg-20) '() (let ((e-4 (car arg-20))) (let ((e-5 (cdr arg-20))) (case (vector-ref e-4 0) ((2) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-10 (vector-ref e-4 4))) (cons (vector 2 e-7 e-8 (vector 1 ) e-10) (TTImpC-45ProcessDef-n--17220-7309-u--mkExplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-5))))))(else (cons e-4 (TTImpC-45ProcessDef-n--17220-7309-u--mkExplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-5)))))))))
(define TTImpC-45ProcessDef-n--23277-11429-u--mkCrash (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (CoreC-45TT-apply arg-1 (vector 1 arg-1 (vector 1 ) (vector 0 (CoreC-45NameC-45Namespace-builtinNS) (vector 1 (vector 0 "idris_crash")))) (cons (vector 10 arg-1 0) (cons (vector 9 arg-1 (vector 10 arg-7)) '())))))
(define TTImpC-45ProcessDef-n--17220-7312-u--mkClauseWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 ext-0) (case (vector-ref arg-23 0) ((0) (let ((e-1 (vector-ref arg-23 1))) (let ((e-2 (vector-ref arg-23 2))) (let ((e-3 (vector-ref arg-23 3))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-18 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "PatClause") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 ((TTImpC-45WithClause-getNewLHS arg-18 arg-17 e-1 arg-19 arg-8 arg-20 arg-21 arg-22 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45WithClause-withRHS arg-18 arg-17 e-1 arg-19 arg-20 arg-21 e-3 arg-22) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 0 e-1 e-6 e-7))))))))))))))))) ((1) (let ((e-5 (vector-ref arg-23 1))) (let ((e-6 (vector-ref arg-23 2))) (let ((e-7 (vector-ref arg-23 3))) (let ((e-8 (vector-ref arg-23 4))) (let ((e-9 (vector-ref arg-23 5))) (let ((e-10 (vector-ref arg-23 6))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-18 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "WithClause") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((TTImpC-45WithClause-getNewLHS arg-18 arg-17 e-5 arg-19 arg-8 arg-20 arg-21 arg-22 e-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45WithClause-withRHS arg-18 arg-17 e-5 arg-19 arg-20 arg-21 e-7 arg-22) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-n--17220-7312-u--mkClauseWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (+ 1 arg-19) arg-20 arg-21 arg-22 eta-0 eta-1))) e-10 '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-27 1))) (vector 1 (vector 1 e-5 e-12 e-13 e-8 e-9 e-14)))))))))))))))))))))))) (else (let ((e-12 (vector-ref arg-23 1))) (let ((e-13 (vector-ref arg-23 2))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-18 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "ImpossibleClause") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((TTImpC-45WithClause-getNewLHS arg-18 arg-17 e-12 arg-19 arg-8 arg-20 arg-21 arg-22 e-13) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-12 e-6)))))))))))))))
(define TTImpC-45ProcessDef-n--23277-11430-u--matchAny (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (case (vector-ref arg-7 0) ((4) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (vector 4 e-1 (TTImpC-45ProcessDef-n--23277-11430-u--matchAny arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) (vector 10 e-1 0)))))(else arg-7))))
(define TTImpC-45ProcessDef-n--23277-11431-u--makeErrorClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (vector arg-6 arg-7 (TTImpC-45ProcessDef-n--23277-11430-u--matchAny arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) (TTImpC-45ProcessDef-n--23277-11429-u--mkCrash arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45String-C-43C-43 "Unhandled input for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-0) (PreludeC-45TypesC-45String-C-43C-43 " at " (CoreC-45FC-u--show_Show_FC arg-1))))))))
(define TTImpC-45ProcessDef-n--16132-5439-u--lookupAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-6))) (cond ((equal? sc2 1) (cons e-7 (TTImpC-45ProcessDef-n--16132-5439-u--lookupAll arg-0 arg-1 arg-2 arg-3 arg-4 e-3))) (else (TTImpC-45ProcessDef-n--16132-5439-u--lookupAll arg-0 arg-1 arg-2 arg-3 arg-4 e-3)))))))))))
(define TTImpC-45ProcessDef-n--17220-7311-u--keepOldEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-21 arg-22 arg-23) (case (vector-ref arg-22 0) ((0) (cons arg-21 (vector 0 )))(else (case (vector-ref arg-23 0) ((0) (cons arg-21 (vector 0 )))(else (let ((e-1 (car arg-21))) (let ((e-2 (cdr arg-21))) (case (vector-ref arg-22 0) ((1) (let ((e-6 (vector-ref arg-22 1))) (case (vector-ref arg-23 0) ((1) (let ((e-14 (vector-ref arg-23 1))) (let ((sc3 (TTImpC-45ProcessDef-n--17220-7311-u--keepOldEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 e-6 e-14))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (cons e-4 (vector 1 e-3))))))) (else (let ((e-18 (vector-ref arg-23 1))) (let ((sc3 (TTImpC-45ProcessDef-n--17220-7311-u--keepOldEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 e-6 e-18))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (cons (cons e-1 e-4) (vector 2 e-3)))))))))) (else (let ((e-10 (vector-ref arg-22 1))) (case (vector-ref arg-23 0) ((1) (let ((e-22 (vector-ref arg-23 1))) (let ((sc3 (TTImpC-45ProcessDef-n--17220-7311-u--keepOldEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 e-10 e-22))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (cons (cons e-1 e-4) (vector 2 e-3))))))) (else (let ((e-26 (vector-ref arg-23 1))) (let ((sc3 (TTImpC-45ProcessDef-n--17220-7311-u--keepOldEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 e-10 e-26))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (cons (cons e-1 e-4) (vector 2 e-3)))))))))))))))))))
(define TTImpC-45ProcessDef-n--24432-12467-u--holeyType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (vector 32 arg-6 0) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--xfc (CoreC-45FC-virtualiseFC e-6))) (vector 1 u--xfc (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box (vector 1 (vector 0 e-7))) (vector 32 u--xfc 0) (TTImpC-45ProcessDef-n--24432-12467-u--holeyType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3))))))))))
(define TTImpC-45ProcessDef-n--23277-11433-u--getSpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((7) (let ((e-4 (vector-ref e-2 1))) (box e-4)))(else (TTImpC-45ProcessDef-n--23277-11433-u--getSpec arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))))))))
(define TTImpC-45ProcessDef-n--25383-13260-u--getClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (case (vector-ref arg-11 0) ((0) (let ((e-2 (vector-ref arg-11 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-24 (TTImpC-45Impossible-getImpossibleTerm arg-0 arg-10 arg-4 arg-5 e-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-10 "declare.def.impossible" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Generated impossible LHS: " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 (box (vector '() '() e-5 (vector 10 (TTImpC-45TTImp-getFC e-2) 1)))))))))))) (lambda (u--e) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-10 "declare.def" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Error in getClause " (CoreC-45Core-u--show_Show_Error u--e))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 '())))))) ext-0))) (else (let ((e-5 (vector-ref arg-11 1))) (vector 1 (box e-5)))))))
(define TTImpC-45ProcessDef-n--15407-4809-u--findLinArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (case (vector-ref arg-8 0) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-8 (vector-ref arg-8 4))) (case (vector-ref e-7 0) ((2) (let ((e-11 (vector-ref e-7 2))) (lambda (clam-2) (if (null? arg-9) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-14))))))))))))) (let ((e-15 (car arg-9))) (let ((e-16 (cdr arg-9))) (case (vector-ref e-15 0) ((0) (let ((e-19 (vector-ref e-15 1))) (let ((e-21 (vector-ref e-15 3))) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((u--a (CoreC-45TT-nameAt arg-6 e-21))) (let ((sc6 (PreludeC-45Types-u--C-60_Ord_Nat e-21 arg-3))) (cond ((equal? sc6 1) (let ((act-25 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-19 (vector 0 ) e-6))) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 e-16) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-26 1))) (vector 1 (cons (cons u--a (AlgebraC-45ZeroOneOmega-rigMult e-11 arg-7)) e-17))))))))))) (else (let ((act-25 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-19 (vector 0 ) e-6))) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 e-16) clam-2))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega e-11 arg-7) e-15) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (let ((act-26 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-5 (vector 0 ) e-6))) clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-17 e-16) clam-2))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-14 e-18))))))))))))))))))))))))))(else (lambda (clam-10) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-10))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-10))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-10)))))))))))))))))))))(else (lambda (clam-11) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-11))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-11))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6)))))))))))))))) (let ((e-24 (car arg-9))) (let ((e-25 (cdr arg-9))) (case (vector-ref e-24 0) ((5) (let ((e-28 (vector-ref e-24 2))) (let ((e-29 (vector-ref e-24 3))) (let ((e-30 (vector-ref e-24 4))) (cond ((equal? e-28 0) (TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-30 e-25))) ((equal? e-28 1) (TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-29 e-25)))(else (case (vector-ref arg-8 0) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-8 (vector-ref arg-8 4))) (case (vector-ref e-7 0) ((2) (let ((e-11 (vector-ref e-7 2))) (lambda (clam-0) (if (null? arg-9) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-14))))))))))))) (let ((e-15 (car arg-9))) (let ((e-16 (cdr arg-9))) (case (vector-ref e-15 0) ((0) (let ((e-19 (vector-ref e-15 1))) (let ((e-21 (vector-ref e-15 3))) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((u--a (CoreC-45TT-nameAt arg-6 e-21))) (let ((sc7 (PreludeC-45Types-u--C-60_Ord_Nat e-21 arg-3))) (cond ((equal? sc7 1) (let ((act-25 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-19 (vector 0 ) e-6))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 e-16) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-26 1))) (vector 1 (cons (cons u--a (AlgebraC-45ZeroOneOmega-rigMult e-11 arg-7)) e-17))))))))))) (else (let ((act-25 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-19 (vector 0 ) e-6))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 e-16) clam-0))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega e-11 arg-7) e-15) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (let ((act-26 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-5 (vector 0 ) e-6))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-17 e-16) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-14 e-18))))))))))))))))))))))))))(else (lambda (clam-2) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-10)))))))))))))))))))))(else (lambda (clam-3) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6))))))))))))))))))))))(else (case (vector-ref arg-8 0) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-8 (vector-ref arg-8 4))) (case (vector-ref e-7 0) ((2) (let ((e-11 (vector-ref e-7 2))) (lambda (clam-1) (if (null? arg-9) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-14))))))))))))) (let ((e-15 (car arg-9))) (let ((e-16 (cdr arg-9))) (case (vector-ref e-15 0) ((0) (let ((e-19 (vector-ref e-15 1))) (let ((e-21 (vector-ref e-15 3))) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((u--a (CoreC-45TT-nameAt arg-6 e-21))) (let ((sc6 (PreludeC-45Types-u--C-60_Ord_Nat e-21 arg-3))) (cond ((equal? sc6 1) (let ((act-25 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-19 (vector 0 ) e-6))) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 e-16) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-26 1))) (vector 1 (cons (cons u--a (AlgebraC-45ZeroOneOmega-rigMult e-11 arg-7)) e-17))))))))))) (else (let ((act-25 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-19 (vector 0 ) e-6))) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 e-16) clam-1))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 (AlgebraC-45ZeroOneOmega-u--C-124C-42C-124_Semiring_ZeroOneOmega e-11 arg-7) e-15) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (let ((act-26 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-5 (vector 0 ) e-6))) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-17 e-16) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-14 e-18))))))))))))))))))))))))))(else (lambda (clam-6) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-6))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-10)))))))))))))))))))))(else (lambda (clam-7) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-24 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessDef-n--15407-4809-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6)))))))))))))))))))))))
(define TTImpC-45ProcessDef-n--22656-10902-u--dropErased (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-4) (vector 1 arg-5) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (TTImpC-45ProcessDef-n--22656-10902-u--dropErased arg-0 arg-1 arg-2 arg-3 e-3 arg-5 ext-0) (let ((e-1 (unbox e-6))) (let ((sc4 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (let ((e-7 (vector-ref e-1 7))) e-7) (csegen-21)))) (cond ((equal? sc4 1) (TTImpC-45ProcessDef-n--22656-10902-u--dropErased arg-0 arg-1 arg-2 arg-3 e-3 arg-5 ext-0)) (else (TTImpC-45ProcessDef-n--22656-10902-u--dropErased arg-0 arg-1 arg-2 arg-3 e-3 (LibrariesC-45DataC-45NameMap-delete e-2 arg-5) ext-0)))))))))))))))))))
(define TTImpC-45ProcessDef-n--16132-5441-u--combineAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-24 (TTImpC-45ProcessDef-n--16132-5440-u--combine arg-0 arg-1 arg-2 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45ProcessDef-n--16132-5441-u--combineAll arg-0 arg-1 arg-2 arg-3 e-5 e-3 ext-0))))))))))
(define TTImpC-45ProcessDef-n--16132-5440-u--combine (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((sc0 (let ((sc1 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega (AlgebraC-45ZeroOneOmega-u--C-124C-43C-124_Semiring_ZeroOneOmega arg-4 arg-5) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))) (cond ((equal? sc1 1) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) (AlgebraC-45Preorder-glb (csegen-1892) arg-4 arg-5)))) (cond ((equal? sc2 1) 0) (else (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (AlgebraC-45Preorder-glb (csegen-1892) arg-4 arg-5) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))))) (else 0))))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-3 (+ 1 (+ 1 0)) arg-0) ext-0)) (else (vector 1 (AlgebraC-45Preorder-lub (csegen-1892) arg-4 arg-5)))))))
(define TTImpC-45ProcessDef-n--25410-13351-u--closeEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (lambda (clam-0) (case (vector-ref arg-15 0) ((0) (let ((e-2 (vector-ref arg-15 2))) (let ((e-3 (vector-ref arg-15 3))) (let ((e-4 (vector-ref arg-15 4))) (case (vector-ref e-3 0) ((3) (let ((act-24 (((e-4 arg-14) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 arg-3 (vector 0 ) e-2))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ProcessDef-n--25410-13351-u--closeEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-5) clam-0))))))(else (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-10 '() arg-14 '() arg-15 clam-0)))))))(else (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-10 '() arg-14 '() arg-15 clam-0))))))
(define TTImpC-45ProcessDef-n--25383-13259-u--checkImpossible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-24 (TTImpC-45Unelab-unelabNoPatvars '() arg-10 '() arg-13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--itm (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-5))) (CoreC-45UnifyState-handleUnify arg-10 arg-8 (lambda (eta-0) (let ((act-25 (let ((act-25 (unbox arg-10))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-10 "declare.def.impossible" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking for impossibility: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--itm))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-isUnboundImplicits arg-10 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-setUnboundImplicits arg-10 1 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (TTImpC-45BindImplicits-bindNames arg-10 0 u--itm eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((e-3 (cdr e-10))) (let ((act-30 (CoreC-45Context-setUnboundImplicits arg-10 e-8 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 ((TTImpC-45Elab-elabTerm '() arg-10 arg-9 arg-8 arg-7 arg-11 (vector 1 arg-12) '() '() '() (vector 16 arg-3 (vector 2 ) e-3) '()) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (let ((e-13 (car e-12))) (let ((act-32 (let ((act-32 (unbox arg-10))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-14 (vector-ref act-32 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Normalise-normaliseHoles arg-10 '() e-14 '() e-13 eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-15 (vector-ref act-33 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-33 1))) (let ((act-34 (TTImpC-45ProcessDef-hasEmptyPat '() arg-10 e-14 '() e-15 eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-16 (vector-ref act-34 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-34 1))) (cond ((equal? e-16 1) (let ((act-35 (CoreC-45ContextC-45Log-log arg-10 "declare.def.impossible" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Some empty pat") eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-17 (vector-ref act-35 1))) (vector 0 e-17))) (else (let ((act-36 (let ((act-36 (set-box! arg-10 e-6))) (vector 1 act-36)))) (case (vector-ref act-36 0) ((0) (let ((e-18 (vector-ref act-36 1))) (vector 0 e-18))) (else (vector 1 '())))))))) (else (let ((act-35 (CoreC-45ContextC-45Log-log arg-10 "declare.def.impossible" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "No empty pat") eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-17 (vector-ref act-35 1))) (vector 0 e-17))) (else (let ((act-36 (CoreC-45Context-clearDefs e-6 eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-18 (vector-ref act-36 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-36 1))) (let ((act-37 (let ((act-37 ((CoreC-45NormaliseC-45Eval-nf arg-10 '() e-18 '() e-15) eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-19 (vector-ref act-37 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-37 1))) ((TTImpC-45ProcessDef-n--25410-13351-u--closeEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-12 arg-11 e-18 e-19) eta-0))))))) (case (vector-ref act-37 0) ((0) (let ((e-19 (vector-ref act-37 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-37 1))) (let ((act-38 (let ((act-38 (set-box! arg-10 e-6))) (vector 1 act-38)))) (case (vector-ref act-38 0) ((0) (let ((e-20 (vector-ref act-38 1))) (vector 0 e-20))) (else (vector 1 (box e-19)))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-25 (let ((act-25 (unbox arg-10))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ProcessDef-recoverableErr arg-10 e-6 u--err) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) (vector 1 (box arg-13))) (else (vector 1 '()))))))))))))) ext-0))))))))
(define TTImpC-45ProcessDef-n--25383-13261-u--checkCoverage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-n--25383-13260-u--getClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0 eta-1))) arg-14 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-10 (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-2112) arg-4060 arg-4061 eta-2)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-2112) arg-4062 arg-4063 eta-2))))) eta-0 eta-1))) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-10 "declare.def" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (LibrariesC-45DataC-45StringC-45Extra-unlines (cons "Using clauses :" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45TypesC-45String-C-43C-43 "  " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_Clause u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_Clause u--d u--x)))) eta-0))) e-6)))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--covcs (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-5))) (let ((act-26 (CoreC-45CaseC-45CaseBuilder-getPMDef arg-10 arg-3 (box arg-13) (vector 8 arg-11) arg-12 u--covcs ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((e-9 (car e-3))) (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-10 (csegen-2177) e-9 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-10 "declare.def" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Working from " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-2 e-10))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (let ((sc6 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45ProcessDef-n--25383-13258-u--catchAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) u--covcs))) (cond ((equal? sc6 1) (let ((act-28 (CoreC-45ContextC-45Log-log arg-10 "declare.def" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Catch all case in " (PreludeC-45Show-u--show_Show_Int arg-11))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (vector 1 '()))))) (else (CoreC-45Coverage-getMissing e-2 arg-10 arg-3 (vector 8 arg-11) e-9 ext-0)))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-28 1))) (let ((act-29 (CoreC-45ContextC-45Log-unverifiedLogC arg-10 "declare.def" (+ 1 (+ 1 (+ 1 0))) (lambda (eta-0) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-10 (csegen-76) eta-1 eta-2))) e-11 '() eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Context-getFullName arg-10 (vector 8 arg-11) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-30 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Initially missing in " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-13) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() eta-1)) e-12))))))))))))))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-n--25383-13259-u--checkImpossible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13 eta-0 eta-1))) e-11 '() ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Coverage-checkMatched arg-10 u--covcs eta-0 eta-1))) (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-13) '() ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-31 1))) (let ((u--miss (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-14))) (let ((sc10 (DataC-45List-isNil u--miss))) (cond ((equal? sc10 1) (let ((act-32 (CoreC-45Coverage-getNonCoveringRefs arg-10 arg-3 (vector 8 arg-11) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-32 1))) (if (null? e-15) (vector 1 (vector 0 )) (CoreC-45Context-toFullNames arg-10 (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Covering arg-4060 arg-4061 eta-0)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Covering arg-4062 arg-4063 eta-0))))) (vector 2 e-15) ext-0))))))) (else (vector 1 (vector 1 u--miss)))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessDef-n--25383-13258-u--catchAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (vector-ref arg-11 2))) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ProcessDef-n--25383-13257-u--simplePat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) (CoreC-45TT-getArgs e-2)))))
(define TTImpC-45ProcessDef-n--23277-11428-u--caseName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((6) 1) ((0) (let ((e-3 (vector-ref arg-6 2))) (TTImpC-45ProcessDef-n--23277-11428-u--caseName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)))(else 0))))
(define TTImpC-45ProcessDef-n--17220-7310-u--bindWithArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 arg-21 arg-22) (if (null? arg-21) (let ((u--scenv (cons (vector 2 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) arg-20) arg-22))) (let ((u--var (vector 0 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (box 0) 0))) (let ((u--binder (lambda (eta-0) (vector 3 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (TTImpC-45ProcessDef-n--18331-7369-u--wargn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-22 arg-20) (vector 2 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) arg-20) eta-0)))) (lambda (eta-0) (vector 1 (cons (TTImpC-45ProcessDef-n--18331-7370-u--wargs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-22 arg-20) (cons u--scenv (cons u--var u--binder)))))))) (let ((e-2 (unbox arg-21))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((act-24 (let ((act-24 (unbox arg-18))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((u--eqName (vector 0 (CoreC-45NameC-45Namespace-builtinNS) (vector 1 (vector 0 "Equal"))))) (let ((act-25 (CoreC-45Context-lookupDefExact u--eqName (let ((e-0 (vector-ref e-7 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Cannot find builtin Equal") clam-0) (let ((e-1 (unbox e-8))) (case (vector-ref e-1 0) ((6) (let ((e-14 (vector-ref e-1 1))) (let ((e-3 (vector-ref e-1 2))) (let ((e-4 (vector-ref e-1 3))) (let ((e-13 (vector-ref e-1 4))) (let ((e-12 (vector-ref e-1 5))) (let ((e-11 (vector-ref e-1 6))) (let ((e-10 (vector-ref e-1 7))) (let ((e-9 (vector-ref e-1 8))) (let ((act-26 (CoreC-45Context-toResolvedNames arg-18 (csegen-46) u--eqName clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-15 (vector-ref act-26 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-26 1))) (let ((u--eqTyCon (vector 1 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (vector 3 e-14 e-3) e-15))) (let ((u--wvalTyC-39 (CoreC-45TT-u--weaken_Weaken_Term arg-20))) (let ((u--eqTy (CoreC-45TT-apply (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) u--eqTyCon (cons u--wvalTyC-39 (cons u--wvalTyC-39 (cons (CoreC-45TT-u--weaken_Weaken_Term e-6) (cons (vector 0 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (box 0) 0) '()))))))) (let ((u--scenv (cons (vector 2 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 0 ) u--eqTy) (cons (vector 2 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) arg-20) arg-22)))) (let ((u--var (vector 0 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (box 0) (+ 1 0)))) (let ((u--binder (lambda (u--t) (vector 3 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (TTImpC-45ProcessDef-n--18476-7534-u--wargn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-5 e-6 arg-22 arg-20 e-7 u--eqName e-4 e-13 e-12 e-11 e-10 e-9 e-3 e-14 e-8 e-15 u--eqTyCon) (vector 2 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) arg-20) (vector 3 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) e-5 (vector 2 (TTImpC-45ProcessDef-n--17220-7308-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 0 ) u--eqTy) u--t))))) (vector 1 (cons (TTImpC-45ProcessDef-n--18476-7535-u--wargs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-5 e-6 arg-22 arg-20 e-7 u--eqName e-4 e-13 e-12 e-11 e-10 e-9 e-3 e-14 e-8 e-15 u--eqTyCon) (cons u--scenv (cons u--var u--binder)))))))))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Cannot find builtin Equal") clam-0)))))))))))))))))))))
(define TTImpC-45ProcessDef-n--23277-11432-u--addErrorCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (if (null? e-3) (cons (vector e-4 e-5 e-6 e-7) (cons (TTImpC-45ProcessDef-n--23277-11431-u--makeErrorClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 e-5 e-6) '())) (cons e-2 (TTImpC-45ProcessDef-n--23277-11432-u--addErrorCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))))))))))))
(define TTImpC-45ProcessDef-n--15407-4808-u--accessible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((1) (cond ((equal? arg-4 1) arg-7) (else (csegen-21))))(else arg-7))))
(define TTImpC-45ProcessDef-warnUnreachable (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (CoreC-45Context-recordWarning arg-0 (vector 1 e-0 (CoreC-45TT-getLoc e-2) e-1 e-2) ext-0))))))
(define TTImpC-45ProcessDef-toPats (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (cons e-0 (cons e-1 (cons e-2 e-3)))))))))
(define TTImpC-45ProcessDef-setLinear (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (case (vector-ref e-3 0) ((3) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--b (vector 3 e-6 e-7 e-8 e-9))) (let ((sc2 (DataC-45List-lookup (csegen-802) e-2 arg-1))) (if (null? sc2) (vector 3 e-1 e-2 u--b (TTImpC-45ProcessDef-setLinear arg-1 e-4)) (let ((e-5 (unbox sc2))) (vector 3 e-1 e-2 (CoreC-45TT-setMultiplicity u--b e-5) (TTImpC-45ProcessDef-setLinear arg-1 e-4))))))))))) ((5) (let ((e-11 (vector-ref e-3 1))) (let ((e-12 (vector-ref e-3 2))) (let ((e-13 (vector-ref e-3 3))) (let ((u--b (vector 5 e-11 e-12 e-13))) (let ((sc2 (DataC-45List-lookup (csegen-802) e-2 arg-1))) (if (null? sc2) (vector 3 e-1 e-2 u--b (TTImpC-45ProcessDef-setLinear arg-1 e-4)) (let ((e-5 (unbox sc2))) (vector 3 e-1 e-2 (CoreC-45TT-setMultiplicity u--b e-5) (TTImpC-45ProcessDef-setLinear arg-1 e-4))))))))))(else arg-2)))))))(else arg-2))))
(define TTImpC-45ProcessDef-recoverableErr (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 3))) (let ((e-3 (vector-ref arg-2 4))) (let ((e-4 (vector-ref arg-2 5))) (let ((e-5 (vector-ref arg-2 6))) (let ((u--defs (let ((e-35 (vector-ref arg-1 1))) (let ((e-34 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (let ((e-32 (vector-ref arg-1 4))) (let ((e-31 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (let ((e-23 (vector-ref arg-1 23))) (let ((e-24 (vector-ref arg-1 24))) (let ((e-25 (vector-ref arg-1 25))) (let ((e-26 (vector-ref arg-1 26))) (let ((e-27 (vector-ref arg-1 27))) (let ((e-28 (vector-ref arg-1 28))) (let ((e-29 (vector-ref arg-1 29))) (let ((e-30 (vector-ref arg-1 30))) (vector e-2 e-35 e-34 e-33 e-32 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "coverage.recover" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (LibrariesC-45DataC-45StringC-45Extra-unlines (cons "Recovering from CantConvert?" (cons "Checking:" (cons (PreludeC-45TypesC-45String-C-43C-43 "  " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 e-0 e-6)) (cons (PreludeC-45TypesC-45String-C-43C-43 "  " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 e-0 e-7)) '())))))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else ((TTImpC-45ProcessDef-recoverable arg-0 e-0 u--defs e-6 e-7) eta-0)))))))))))))))))))) ((2) (let ((e-6 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((e-10 (vector-ref arg-2 5))) (let ((e-11 (vector-ref arg-2 6))) (let ((u--defs (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-36 (vector-ref arg-1 6))) (let ((e-35 (vector-ref arg-1 7))) (let ((e-34 (vector-ref arg-1 8))) (let ((e-33 (vector-ref arg-1 9))) (let ((e-32 (vector-ref arg-1 10))) (let ((e-31 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (let ((e-23 (vector-ref arg-1 23))) (let ((e-24 (vector-ref arg-1 24))) (let ((e-25 (vector-ref arg-1 25))) (let ((e-26 (vector-ref arg-1 26))) (let ((e-27 (vector-ref arg-1 27))) (let ((e-28 (vector-ref arg-1 28))) (let ((e-29 (vector-ref arg-1 29))) (let ((e-30 (vector-ref arg-1 30))) (vector e-8 e-1 e-2 e-3 e-4 e-5 e-36 e-35 e-34 e-33 e-32 e-31 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-10) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-11) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) ((TTImpC-45ProcessDef-recoverable arg-0 e-6 u--defs e-5 e-12) eta-0))))))))))))))))) ((44) (let ((e-15 (vector-ref arg-2 4))) (lambda (clam-0) (cond ((equal? e-15 3) (vector 1 1))(else (vector 1 0)))))) ((4) (lambda (eta-0) (vector 1 1))) ((21) (let ((e-23 (vector-ref arg-2 1))) (lambda (eta-0) (CoreC-45Core-anyM (lambda (eta-1) (TTImpC-45ProcessDef-recoverableErr arg-0 arg-1 eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-23) eta-0)))) ((5) (let ((e-30 (vector-ref arg-2 7))) (TTImpC-45ProcessDef-recoverableErr arg-0 arg-1 e-30)))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessDef-recoverable (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-71 (vector-ref arg-3 2))) (let ((e-74 (vector-ref arg-3 5))) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-87 (vector-ref arg-4 2))) (let ((e-90 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-71 e-87))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((act-24 (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-74 e-90) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cond ((equal? e-5 1) 0) (else 1))))))))))))) ((8) (vector 1 0)) ((10) (vector 1 0)) ((0) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((2) (let ((e-42 (vector-ref arg-3 3))) (let ((e-44 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-42 e-51))) (cond ((equal? sc3 1) (vector 1 0)) (else (let ((act-24 (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-44 e-53) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cond ((equal? e-5 1) 0) (else 1))))))))))))) ((8) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-2) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-3) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-4) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-3) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-6) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-7) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))))))))) ((10) (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((2) (let ((e-42 (vector-ref arg-3 3))) (let ((e-44 (vector-ref arg-3 5))) (lambda (clam-4) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-42 e-51))) (cond ((equal? sc3 1) (vector 1 0)) (else (let ((act-24 (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-44 e-53) clam-4))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cond ((equal? e-5 1) 0) (else 1))))))))))))) ((8) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-5) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-10) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-11) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-6) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-13) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-14) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))))))))) ((0) (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((2) (let ((e-42 (vector-ref arg-3 3))) (let ((e-44 (vector-ref arg-3 5))) (lambda (clam-7) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-42 e-51))) (cond ((equal? sc3 1) (vector 1 0)) (else (let ((act-24 (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-44 e-53) clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cond ((equal? e-5 1) 0) (else 1))))))))))))) ((8) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-8) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-17) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-18) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-9) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-20) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-21) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))))))(else (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((2) (let ((e-42 (vector-ref arg-3 3))) (let ((e-44 (vector-ref arg-3 5))) (lambda (clam-10) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-42 e-51))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((act-24 (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-44 e-53) clam-10))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cond ((equal? e-5 1) 0) (else 1))))))))))))) ((8) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-11) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-24) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-25) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-12) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-27) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-28) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))))))))))
(define TTImpC-45ProcessDef-processDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 arg-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((TTImpC-45ProcessDef-lookupOrAddAlias arg-0 arg-2 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-5 arg-10) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Context-noDeclaration arg-1 arg-8 e-5 ext-0) (let ((e-1 (unbox e-7))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((0) (let ((u--ty (let ((e-45 (vector-ref e-1 2))) e-45))) (let ((u--hashit (CoreC-45TT-u--C-61C-61_Eq_Visibility (let ((e-38 (vector-ref e-1 9))) e-38) 2))) (let ((u--mult (let ((sc5 (AlgebraC-45Semiring-isErased (csegen-475) (let ((e-40 (vector-ref e-1 7))) e-40)))) (cond ((equal? sc5 1) (csegen-21)) (else (csegen-519)))))) (let ((act-27 (CoreC-45Context-resolveName arg-1 e-5 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-26 (vector-ref act-27 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-27 1))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-1 "declare.def" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Traversing clauses of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " with mult " (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega u--mult))))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-27 (vector-ref act-28 1))) (vector 0 e-27))) (else (let ((act-29 (CoreC-45Context-getDefaultTotalityOption arg-1 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-28 (vector-ref act-29 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-29 1))) (let ((u--treq (DataC-45Maybe-fromMaybe (lambda () e-28) (CoreC-45ContextC-45Context-findSetTotal (let ((e-39 (vector-ref e-1 11))) e-39))))) (let ((act-30 (TTImpC-45ProcessDef-n--25383-13256-u--withTotality arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--treq (lambda () (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessDef-checkClause arg-0 arg-1 arg-2 arg-3 arg-4 u--mult (let ((e-41 (vector-ref e-1 9))) e-41) u--treq u--hashit e-26 arg-5 arg-6 arg-7 eta-1 eta-2))) arg-10 '() eta-0))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-29 (vector-ref act-30 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-30 1))) (let ((u--pats (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ProcessDef-toPats eta-0)) (DataC-45Either-rights e-29)))) (let ((act-31 (CoreC-45ContextC-45Log-logTime arg-1 (lambda () (PreludeC-45TypesC-45String-C-43C-43 "+++ Building compile time case tree for " (CoreC-45Name-u--show_Show_Name e-5))) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-getPMDef arg-1 arg-8 (box u--mult) e-5 u--ty (DataC-45Either-rights e-29) eta-0)) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-30 (vector-ref act-31 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-31 1))) (let ((e-32 (car e-30))) (let ((e-31 (cdr e-30))) (let ((e-34 (car e-31))) (let ((e-33 (cdr e-31))) (let ((act-32 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-warnUnreachable arg-1 eta-0 eta-1))) e-33 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-35 (vector-ref act-32 1))) (vector 0 e-35))) (else (let ((act-33 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "declare.def" (+ 1 (+ 1 0)) (lambda (eta-0) (let ((act-33 (CoreC-45Context-toFullNames arg-1 (csegen-2177) e-34 eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-36 (vector-ref act-33 1))) (vector 0 e-36))) (else (let ((e-36 (vector-ref act-33 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Case tree for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-32 e-36)))))))))) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-36 (vector-ref act-33 1))) (vector 0 e-36))) (else (let ((act-34 (let ((act-34 (unbox arg-1))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-37 (vector-ref act-34 1))) (vector 0 e-37))) (else (let ((e-37 (vector-ref act-34 1))) (let ((u--pi (let ((sc15 (LibrariesC-45DataC-45NameMap-lookup e-5 (let ((e-43 (vector-ref e-37 25))) e-43)))) (if (null? sc15) (CoreC-45ContextC-45Context-defaultPI) (let ((e-38 (unbox sc15))) (let ((sc16 (CoreC-45ContextC-45Context-defaultPI))) (let ((e-41 (vector-ref sc16 0))) (let ((e-40 (vector-ref sc16 1))) (vector e-41 e-40 e-38))))))))) (let ((act-35 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-1 (vector 8 e-26) (let ((e-59 (vector-ref e-1 0))) (let ((e-58 (vector-ref e-1 1))) (let ((e-57 (vector-ref e-1 2))) (let ((e-56 (vector-ref e-1 3))) (let ((e-55 (vector-ref e-1 4))) (let ((e-54 (vector-ref e-1 5))) (let ((e-53 (vector-ref e-1 6))) (let ((e-52 (vector-ref e-1 7))) (let ((e-51 (vector-ref e-1 8))) (let ((e-50 (vector-ref e-1 9))) (let ((e-49 (vector-ref e-1 10))) (let ((e-48 (vector-ref e-1 11))) (let ((e-47 (vector-ref e-1 12))) (let ((e-46 (vector-ref e-1 13))) (let ((e-45 (vector-ref e-1 14))) (let ((e-44 (vector-ref e-1 15))) (let ((e-43 (vector-ref e-1 16))) (let ((e-41 (vector-ref e-1 18))) (let ((e-40 (vector-ref e-1 19))) (let ((e-39 (vector-ref e-1 20))) (let ((e-38 (vector-ref e-1 21))) (vector e-59 e-58 e-57 e-56 e-55 e-54 e-53 e-52 e-51 e-50 e-49 e-48 e-47 e-46 e-45 e-44 e-43 (vector 1 u--pi e-32 e-34 e-34 u--pats) e-41 e-40 e-39 e-38)))))))))))))))))))))) eta-0)) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-38 (vector-ref act-35 1))) (vector 0 e-38))) (else (let ((act-36 (let ((sc16 (CoreC-45TT-u--C-61C-61_Eq_Visibility (let ((e-51 (vector-ref e-1 9))) e-51) 2))) (cond ((equal? sc16 1) (((let ((u--rmetas (CoreC-45CaseC-45CaseTree-getMetas e-34))) (lambda () (lambda (eta-0) (let ((act-36 (CoreC-45ContextC-45Log-log arg-1 "declare.def" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Saving from " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (LibrariesC-45DataC-45NameMap-keys u--rmetas)))))) eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-39 (vector-ref act-36 1))) (vector 0 e-39))) (else (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-addToSave arg-1 eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys u--rmetas) eta-0)))))))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-36 0) ((0) (let ((e-39 (vector-ref act-36 1))) (vector 0 e-39))) (else (let ((act-37 (let ((sc17 (let ((sc18 (CoreC-45Name-isUserName e-5))) (cond ((equal? sc18 1) (CoreC-45TT-u--C-47C-61_Eq_Visibility (let ((e-52 (vector-ref e-1 9))) e-52) 0)) (else 0))))) (cond ((equal? sc17 1) (((let ((u--tymetas (CoreC-45TT-getMetas (let ((e-59 (vector-ref e-1 2))) e-59)))) (lambda () (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-addToSave arg-1 eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys u--tymetas) eta-0))))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-37 0) ((0) (let ((e-40 (vector-ref act-37 1))) (vector 0 e-40))) (else (let ((act-38 (CoreC-45Context-addToSave arg-1 e-5 ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-41 (vector-ref act-38 1))) (vector 0 e-41))) (else (let ((act-39 (let ((act-39 (unbox arg-1))) (vector 1 act-39)))) (case (vector-ref act-39 0) ((0) (let ((e-42 (vector-ref act-39 1))) (vector 0 e-42))) (else (let ((e-42 (vector-ref act-39 1))) (let ((act-40 (let ((act-40 (set-box! arg-1 (let ((e-73 (vector-ref e-42 0))) (let ((e-72 (vector-ref e-42 1))) (let ((e-71 (vector-ref e-42 2))) (let ((e-70 (vector-ref e-42 3))) (let ((e-69 (vector-ref e-42 4))) (let ((e-68 (vector-ref e-42 5))) (let ((e-67 (vector-ref e-42 6))) (let ((e-66 (vector-ref e-42 7))) (let ((e-65 (vector-ref e-42 8))) (let ((e-64 (vector-ref e-42 9))) (let ((e-63 (vector-ref e-42 10))) (let ((e-62 (vector-ref e-42 11))) (let ((e-61 (vector-ref e-42 12))) (let ((e-60 (vector-ref e-42 13))) (let ((e-59 (vector-ref e-42 14))) (let ((e-58 (vector-ref e-42 15))) (let ((e-57 (vector-ref e-42 16))) (let ((e-56 (vector-ref e-42 17))) (let ((e-55 (vector-ref e-42 18))) (let ((e-54 (vector-ref e-42 19))) (let ((e-53 (vector-ref e-42 20))) (let ((e-52 (vector-ref e-42 21))) (let ((e-51 (vector-ref e-42 22))) (let ((e-50 (vector-ref e-42 23))) (let ((e-49 (vector-ref e-42 24))) (let ((e-48 (vector-ref e-42 25))) (let ((e-47 (vector-ref e-42 26))) (let ((e-46 (vector-ref e-42 27))) (let ((e-45 (vector-ref e-42 28))) (let ((e-44 (vector-ref e-42 29))) (let ((e-43 (vector-ref e-42 30))) (vector e-73 e-72 e-71 e-70 e-69 e-68 e-67 e-66 e-65 e-64 e-63 e-62 e-61 e-60 e-59 e-58 e-57 e-56 e-55 e-54 e-53 (cons e-5 e-52) e-51 e-50 e-49 e-48 e-47 e-46 e-45 e-44 e-43))))))))))))))))))))))))))))))))))) (vector 1 act-40)))) (case (vector-ref act-40 0) ((0) (let ((e-43 (vector-ref act-40 1))) (vector 0 e-43))) (else (let ((act-41 (CoreC-45Context-toResolvedNames arg-1 (csegen-46) (csegen-2204) ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-44 (vector-ref act-41 1))) (vector 0 e-44))) (else (let ((e-44 (vector-ref act-41 1))) (let ((act-42 (CoreC-45ContextC-45Log-logTime arg-1 (lambda () (PreludeC-45TypesC-45String-C-43C-43 "+++ Building size change graphs " (CoreC-45Name-u--show_Show_Name e-5))) (lambda (clam-0) (let ((sc22 (PreludeC-45Types-elem (csegen-1886) 1 arg-5))) (cond ((equal? sc22 1) (vector 1 0)) (else (let ((act-42 (TTImpC-45ProcessDef-calcRefs arg-1 0 e-44 (vector 8 e-26) clam-0))) (case (vector-ref act-42 0) ((0) (let ((e-45 (vector-ref act-42 1))) (vector 0 e-45))) (else (let ((act-43 (CoreC-45Termination-calculateSizeChange arg-1 arg-8 e-5 clam-0))) (case (vector-ref act-43 0) ((0) (let ((e-46 (vector-ref act-43 1))) (vector 0 e-46))) (else (let ((e-46 (vector-ref act-43 1))) (let ((act-44 (CoreC-45Context-setSizeChange arg-1 arg-8 e-5 e-46 clam-0))) (case (vector-ref act-44 0) ((0) (let ((e-47 (vector-ref act-44 1))) (vector 0 e-47))) (else (CoreC-45Termination-checkIfGuarded arg-1 arg-8 e-5 clam-0))))))))))))))) ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-45 (vector-ref act-42 1))) (vector 0 e-45))) (else (let ((act-43 (let ((act-43 (unbox arg-2))) (vector 1 act-43)))) (case (vector-ref act-43 0) ((0) (let ((e-46 (vector-ref act-43 1))) (vector 0 e-46))) (else (let ((e-46 (vector-ref act-43 1))) (let ((act-44 (CoreC-45ContextC-45Log-logTime arg-1 (lambda () (PreludeC-45TypesC-45String-C-43C-43 "+++ Checking Coverage " (CoreC-45Name-u--show_Show_Name e-5))) (lambda (eta-0) (TTImpC-45ProcessDef-n--25383-13261-u--checkCoverage arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-26 u--ty u--mult e-29 eta-0)) ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-47 (vector-ref act-44 1))) (vector 0 e-47))) (else (let ((e-47 (vector-ref act-44 1))) (let ((act-45 (CoreC-45Context-setCovering arg-1 arg-8 e-5 e-47 ext-0))) (case (vector-ref act-45 0) ((0) (let ((e-48 (vector-ref act-45 1))) (vector 0 e-48))) (else (let ((act-46 (let ((act-46 (set-box! arg-2 e-46))) (vector 1 act-46)))) (case (vector-ref act-46 0) ((0) (let ((e-49 (vector-ref act-46 1))) (vector 0 e-49))) (else (let ((sc27 (PreludeC-45Types-elem (csegen-1886) 1 arg-5))) (cond ((equal? sc27 1) (vector 1 0)) (else (TTImpC-45ProcessDef-compileRunTime arg-1 arg-2 arg-3 arg-4 arg-8 e-44 ext-0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 arg-8 e-5) ext-0)))))))))))))))))))
(define TTImpC-45ProcessDef-nameListEq (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (box 0) '()) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? arg-1) '() (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (TTImpC-45ProcessDef-with--nameListEq-10870 e-2 e-6 (CoreC-45Name-nameEq e-2 e-6) e-3 e-7)))))))))
(define TTImpC-45ProcessDef-mkRunTime (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Making run time definition for " (CoreC-45Name-u--show_Show_Name e-5))) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 0) (let ((e-1 (unbox e-7))) (let ((u--cov (let ((e-10 (vector-ref e-1 10))) (let ((e-26 (cdr e-10))) e-26)))) (let ((sc4 (AlgebraC-45Semiring-isErased (csegen-475) (let ((e-22 (vector-ref e-1 7))) e-22)))) (cond ((equal? sc4 1) (vector 1 0)) (else (((let ((_-0 (box e-1))) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32mkRunTime-11721 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-6 e-1 _-0 u--cov (let ((e-17 (vector-ref e-1 17))) e-17)))) ext-0))))))))))))))))))))
(define TTImpC-45ProcessDef-mismatchNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-33 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-2 e-33))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-7 (car arg-409))) (let ((e-6 (cdr arg-409))) (cons (arg-405 e-7) (arg-407 e-6))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-7 (car arg-416))) (let ((e-6 (cdr arg-416))) (cons (arg-414 e-7) e-6)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-7 (car arg-419))) (let ((e-6 (cdr arg-419))) (cons e-7 (arg-417 e-6)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-5 e-36) clam-0))))))) ((8) (vector 1 1)) ((0) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0))))))) ((2) (let ((e-9 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((2) (let ((e-50 (vector-ref arg-4 3))) (let ((e-52 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-9 e-50))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-11 e-52) clam-1))))))) ((8) (vector 1 1))(else (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-2) (case (vector-ref arg-4 0) ((8) (let ((e-58 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-47C-61_Eq_Constant e-14 e-58)))) ((2) (vector 1 1)) ((0) (vector 1 1)) ((3) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0)))))) ((5) (let ((e-18 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((5) (let ((e-81 (vector-ref arg-4 3))) (TTImpC-45ProcessDef-mismatchNF arg-0 arg-1 arg-2 e-18 e-81)))(else (lambda (eta-0) (vector 1 0)))))) ((6) (let ((e-23 (vector-ref arg-3 4))) (lambda (clam-3) (case (vector-ref arg-4 0) ((6) (let ((e-86 (vector-ref arg-4 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-86) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ProcessDef-mismatchNF arg-0 arg-1 arg-2 e-5 e-6) clam-3)))))))))))(else (vector 1 0)))))) ((0) (lambda (clam-4) (case (vector-ref arg-4 0) ((8) (vector 1 1)) ((3) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0))))) ((10) (lambda (clam-5) (case (vector-ref arg-4 0) ((8) (vector 1 1)) ((3) (vector 1 1)) ((0) (vector 1 1))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessDef-mismatch (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ProcessDef-mismatchNF arg-0 arg-1 arg-2 e-5 e-6) ext-0)))))))))))))
(define TTImpC-45ProcessDef-lookupOrAddAlias (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Context-lookupCtxtExact arg-9 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0)))))) (let ((e-1 (car arg-10))) (let ((e-2 (cdr arg-10))) (lambda (clam-0) (case (vector-ref e-1 0) ((0) (let ((e-4 (vector-ref e-1 1))) (let ((e-5 (vector-ref e-1 2))) (let ((e-6 (vector-ref e-1 3))) (if (null? e-2) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-2 "declare.def.alias" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Looking at " (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 (csegen-737) e-1))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 ((CoreC-45Context-lookupCtxtExact arg-9 (let ((e-0 (vector-ref e-7 0))) e-0)) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-26 1))) (let ((u--cl (vector 0 e-4 e-5 e-6))) (if (null? e-9) (let ((_-0 '())) ((TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32lookupOrAddAlias-12558 arg-0 e-4 e-6 e-5 u--cl arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 _-0 (TTImpC-45ProcessDef-isAlias e-5)) clam-0)) (let ((e-3 (unbox e-9))) (vector 1 (box e-3)))))))))))))))) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) ((CoreC-45Context-lookupCtxtExact arg-9 (let ((e-0 (vector-ref e-7 0))) e-0)) clam-0))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Context-lookupCtxtExact arg-9 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0)))))))))))))
(define TTImpC-45ProcessDef-isAlias (lambda (arg-0) (let ((sc0 (TTImpC-45TTImp-getFnArgs arg-0 '()))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45TTImp-isIVar e-2) (lambda (u--hd) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (PreludeC-45Interfaces-C-62C-61C-62 (csegen-270) (lambda (eta-1) (TTImpC-45TTImp-isExplicit eta-1)) (lambda (clam-0) (let ((e-5 (car clam-0))) (let ((e-4 (cdr clam-0))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--pure_Applicative_Maybe (csegen-186)) (PreludeC-45Types-u--pure_Applicative_Maybe e-5)) (TTImpC-45TTImp-isIBindVar e-4))))) eta-0)) e-3) (lambda (u--args) (PreludeC-45Types-u--pure_Applicative_Maybe (cons u--hd u--args)))))))))))
(define TTImpC-45ProcessDef-impossibleOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-24 (vector-ref arg-4 2))) (let ((e-27 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-2 e-24))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-7 (car arg-409))) (let ((e-6 (cdr arg-409))) (cons (arg-405 e-7) (arg-407 e-6))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-7 (car arg-416))) (let ((e-6 (cdr arg-416))) (cons (arg-414 e-7) e-6)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-7 (car arg-419))) (let ((e-6 (cdr arg-419))) (cons e-7 (arg-417 e-6)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-5 e-27) clam-0))))))) ((8) (vector 1 1)) ((0) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0))))))) ((2) (let ((e-9 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((2) (let ((e-41 (vector-ref arg-4 3))) (let ((e-43 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-9 e-41))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-11 e-43) clam-1))))))) ((8) (vector 1 1))(else (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-2) (case (vector-ref arg-4 0) ((8) (let ((e-49 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-47C-61_Eq_Constant e-14 e-49)))) ((2) (vector 1 1)) ((0) (vector 1 1)) ((3) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0)))))) ((0) (lambda (clam-3) (case (vector-ref arg-4 0) ((8) (vector 1 1)) ((3) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0))))) ((10) (lambda (clam-4) (case (vector-ref arg-4 0) ((8) (vector 1 1)) ((3) (vector 1 1)) ((0) (vector 1 1))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessDef-impossibleErrOK (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 3))) (let ((e-3 (vector-ref arg-2 4))) (let ((e-4 (vector-ref arg-2 5))) (let ((e-5 (vector-ref arg-2 6))) (let ((u--defs (let ((e-35 (vector-ref arg-1 1))) (let ((e-34 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (let ((e-32 (vector-ref arg-1 4))) (let ((e-31 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (let ((e-23 (vector-ref arg-1 23))) (let ((e-24 (vector-ref arg-1 24))) (let ((e-25 (vector-ref arg-1 25))) (let ((e-26 (vector-ref arg-1 26))) (let ((e-27 (vector-ref arg-1 27))) (let ((e-28 (vector-ref arg-1 28))) (let ((e-29 (vector-ref arg-1 29))) (let ((e-30 (vector-ref arg-1 30))) (vector e-2 e-35 e-34 e-33 e-32 e-31 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) ((TTImpC-45ProcessDef-impossibleOK arg-0 e-0 u--defs e-6 e-7) eta-0))))))))))))))))) ((2) (let ((e-6 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((e-10 (vector-ref arg-2 5))) (let ((e-11 (vector-ref arg-2 6))) (let ((u--defs (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-36 (vector-ref arg-1 6))) (let ((e-35 (vector-ref arg-1 7))) (let ((e-34 (vector-ref arg-1 8))) (let ((e-33 (vector-ref arg-1 9))) (let ((e-32 (vector-ref arg-1 10))) (let ((e-31 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (let ((e-23 (vector-ref arg-1 23))) (let ((e-24 (vector-ref arg-1 24))) (let ((e-25 (vector-ref arg-1 25))) (let ((e-26 (vector-ref arg-1 26))) (let ((e-27 (vector-ref arg-1 27))) (let ((e-28 (vector-ref arg-1 28))) (let ((e-29 (vector-ref arg-1 29))) (let ((e-30 (vector-ref arg-1 30))) (vector e-8 e-1 e-2 e-3 e-4 e-5 e-36 e-35 e-34 e-33 e-32 e-31 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-10) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-11) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) ((TTImpC-45ProcessDef-impossibleOK arg-0 e-6 u--defs e-5 e-12) eta-0))))))))))))))))) ((44) (let ((e-15 (vector-ref arg-2 4))) (lambda (clam-0) (cond ((equal? e-15 3) (vector 1 1))(else (vector 1 0)))))) ((4) (lambda (eta-0) (vector 1 1))) ((21) (let ((e-23 (vector-ref arg-2 1))) (lambda (eta-0) (CoreC-45Core-anyM (lambda (eta-1) (TTImpC-45ProcessDef-impossibleErrOK arg-0 arg-1 eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-23) eta-0)))) ((5) (let ((e-30 (vector-ref arg-2 7))) (TTImpC-45ProcessDef-impossibleErrOK arg-0 arg-1 e-30)))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessDef-hasEmptyPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-2 arg-3 (CoreC-45TT-binderType e-3)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Coverage-isEmpty arg-0 arg-1 arg-2 arg-3 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ProcessDef-hasEmptyPat (cons e-2 arg-0) arg-1 arg-2 (cons e-3 arg-3) e-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cond ((equal? e-6 1) 1) (else e-7)))))))))))))))))))(else (vector 1 0)))))
(define TTImpC-45ProcessDef-findLinear (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((3) (let ((e-2 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 4))) (TTImpC-45ProcessDef-findLinear (cons e-2 arg-0) arg-1 arg-2 (+ 1 arg-3) arg-4 e-4)))) ((5) (let ((e-9 (vector-ref arg-5 4))) (TTImpC-45ProcessDef-findLinear arg-0 arg-1 arg-2 arg-3 arg-4 e-9)))(else (TTImpC-45ProcessDef-case--findLinear-5136 arg-0 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-5))))))
(define TTImpC-45ProcessDef-extendEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((3) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((3) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref arg-6 0) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (case (vector-ref e-18 0) ((5) (let ((e-21 (vector-ref e-18 1))) (let ((e-22 (vector-ref e-18 2))) (let ((e-23 (vector-ref e-18 3))) (TTImpC-45ProcessDef-with--extendEnv-4613 e-2 e-17 (CoreC-45Name-nameEq e-2 e-17) 'erased arg-1 e-16 e-21 e-22 e-23 e-1 e-9 e-8 e-7 e-6 e-4 e-19 arg-4 arg-3 arg-2)))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6))))))))))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6)))))))))))))) ((4) (let ((e-11 (vector-ref e-3 1))) (let ((e-12 (vector-ref e-3 2))) (let ((e-13 (vector-ref e-3 3))) (let ((e-14 (vector-ref e-3 4))) (case (vector-ref arg-6 0) ((3) (let ((e-25 (vector-ref arg-6 1))) (let ((e-26 (vector-ref arg-6 2))) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (case (vector-ref e-27 0) ((4) (let ((e-30 (vector-ref e-27 1))) (let ((e-31 (vector-ref e-27 2))) (let ((e-32 (vector-ref e-27 3))) (let ((e-33 (vector-ref e-27 4))) (TTImpC-45ProcessDef-with--extendEnv-4694 e-2 e-26 (CoreC-45Name-nameEq e-2 e-26) 'erased arg-1 e-25 e-30 e-31 e-33 e-32 e-1 e-13 e-14 e-12 e-11 e-4 e-28 arg-4 arg-3 arg-2))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6))))))))))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6))))))))))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6))))))))))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6)))))))))))
(define TTImpC-45ProcessDef-compileRunTime (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mkRunTime arg-0 arg-1 arg-2 arg-3 arg-4 eta-0 eta-1))) (let ((e-21 (vector-ref e-5 21))) e-21) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-calcRefs arg-0 1 arg-5 eta-0 eta-1))) (let ((e-21 (vector-ref e-5 21))) e-21) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (set-box! arg-0 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-34 (vector-ref e-8 5))) (let ((e-33 (vector-ref e-8 6))) (let ((e-32 (vector-ref e-8 7))) (let ((e-31 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-32 e-31 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 '() e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-28))))))))))))))))))
(define TTImpC-45ProcessDef-combineLinear (lambda (arg-0 arg-1) (if (null? arg-1) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (eta-0) (TTImpC-45ProcessDef-case--combineLinear-5594 e-6 e-7 e-3 arg-0 (TTImpC-45ProcessDef-n--16132-5439-u--lookupAll e-6 e-7 e-3 arg-0 e-6 e-3) eta-0)))))))))
(define TTImpC-45ProcessDef-checkLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45TTImp-logRaw arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) (lambda () "Raw LHS: ") arg-13 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (cond ((equal? arg-5 1) (vector 1 arg-13)) (else ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-10 arg-13) ext-0))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45TTImp-logRaw arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) (lambda () "Raw LHS in current NS: ") e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45Context-isUnboundImplicits arg-1 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-setUnboundImplicits arg-1 1 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (TTImpC-45BindImplicits-bindNames arg-1 0 e-7 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((e-3 (cdr e-11))) (let ((act-31 (CoreC-45Context-setUnboundImplicits arg-1 e-9 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (TTImpC-45TTImp-logRaw arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) (lambda () "Raw LHS with implicits bound") e-3 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 (cond ((equal? arg-5 1) (vector 1 e-3)) (else ((TTImpC-45TTImp-implicitsAs arg-1 arg-8 e-5 arg-0 e-3) ext-0))))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-0) (let ((act-34 (CoreC-45Context-getFullName arg-1 (vector 8 arg-8) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-34 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Checking LHS of " (CoreC-45Name-u--show_Show_Name e-15)))))))) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((act-35 (CoreC-45ContextC-45Log-log arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-14)) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((act-36 (CoreC-45Normalise-logEnv arg-0 arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) "In env" arg-11 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((u--lhsMode (cond ((equal? arg-5 1) (vector 3 )) (else (vector 1 arg-6))))) (let ((act-37 (let ((act-37 (CoreC-45Context-getFullName arg-1 (vector 8 arg-8) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-37 1))) ((TTImpC-45ElabC-45Utils-wrapErrorC arg-9 (lambda (eta-0) (vector 64 arg-12 e-18 eta-0)) (TTImpC-45Elab-elabTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-8 u--lhsMode arg-9 arg-10 arg-11 (vector 16 arg-12 (vector 1 ) e-14) '())) ext-0))))))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-37 1))) (let ((e-19 (car e-18))) (let ((e-4 (cdr e-18))) (let ((act-38 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Checked LHS term") e-19 ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-20 (vector-ref act-38 1))) (vector 0 e-20))) (else (let ((act-39 ((CoreC-45NormaliseC-45Eval-getTerm e-4) ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-21 (vector-ref act-39 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-39 1))) (let ((act-40 (let ((act-40 (unbox arg-1))) (vector 1 act-40)))) (case (vector-ref act-40 0) ((0) (let ((e-22 (vector-ref act-40 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-40 1))) (let ((u--lhsenv (CoreC-45Env-letToLam arg-11))) (let ((act-41 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-22 u--lhsenv e-19 ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-23 (vector-ref act-41 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-41 1))) (let ((act-42 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-22 arg-11 e-21 ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-24 (vector-ref act-42 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-42 1))) (let ((act-43 ((TTImpC-45ProcessDef-findLinear arg-0 arg-1 1 0 (csegen-519) e-23) ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-25 (vector-ref act-43 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-43 1))) (let ((act-44 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Checked LHS term after normalise") e-23 ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-26 (vector-ref act-44 1))) (vector 0 e-26))) (else (let ((act-45 (CoreC-45ContextC-45Log-log arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Linearity of names in " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-8) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2210) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2210) u--d u--x)))) e-25))))) ext-0))) (case (vector-ref act-45 0) ((0) (let ((e-27 (vector-ref act-45 1))) (vector 0 e-27))) (else (let ((act-46 ((TTImpC-45ProcessDef-combineLinear arg-12 e-25) ext-0))) (case (vector-ref act-46 0) ((0) (let ((e-28 (vector-ref act-46 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-46 1))) (let ((u--lhstm_lin (TTImpC-45ProcessDef-setLinear e-28 e-23))) (let ((u--lhsty_lin (TTImpC-45ProcessDef-setLinear e-28 e-24))) (let ((act-47 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 0))) (lambda () "LHS term") u--lhstm_lin ext-0))) (case (vector-ref act-47 0) ((0) (let ((e-29 (vector-ref act-47 1))) (vector 0 e-29))) (else (let ((act-48 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "declare.def.lhs" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "LHS type") u--lhsty_lin ext-0))) (case (vector-ref act-48 0) ((0) (let ((e-30 (vector-ref act-48 1))) (vector 0 e-30))) (else (let ((act-49 (CoreC-45Metadata-setHoleLHS arg-2 (CoreC-45Env-bindEnv arg-0 arg-12 arg-11 u--lhstm_lin) ext-0))) (case (vector-ref act-49 0) ((0) (let ((e-31 (vector-ref act-49 1))) (vector 0 e-31))) (else (let ((act-50 ((TTImpC-45ProcessDef-extendEnv arg-0 arg-11 (vector 0 ) arg-10 u--lhstm_lin u--lhsty_lin) ext-0))) (case (vector-ref act-50 0) ((0) (let ((e-32 (vector-ref act-50 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-50 1))) (vector 1 (cons e-14 e-32)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessDef-checkClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (case (vector-ref arg-13 0) ((2) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((act-24 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-11 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45UnifyState-handleUnify arg-1 arg-3 (lambda (eta-0) (let ((act-25 (CoreC-45Context-isUnboundImplicits arg-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-setUnboundImplicits arg-1 1 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (TTImpC-45BindImplicits-bindNames arg-1 0 e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-3 (cdr e-8))) (let ((act-28 (CoreC-45Context-setUnboundImplicits arg-1 e-6 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause.impossible" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-3))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-10 (vector-ref act-29 1))) (vector 0 e-10))) (else (let ((act-30 (CoreC-45Normalise-logEnv arg-0 arg-1 "declare.def.clause.impossible" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) "In env" arg-12 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-11 (vector-ref act-30 1))) (vector 0 e-11))) (else (let ((act-31 ((TTImpC-45Elab-elabTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-9 (vector 1 arg-5) arg-10 arg-11 arg-12 (vector 16 e-1 (vector 1 ) e-3) '()) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-12 (vector-ref act-31 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-31 1))) (let ((e-14 (car e-12))) (let ((act-32 (let ((act-32 (unbox arg-1))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-15 (vector-ref act-32 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-15 arg-12 e-14 eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-16 (vector-ref act-33 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-33 1))) (let ((act-34 (TTImpC-45ProcessDef-hasEmptyPat arg-0 arg-1 e-15 arg-12 e-16 eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-17 (vector-ref act-34 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-34 1))) (cond ((equal? e-17 1) (vector 1 (vector 0 e-5))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 6 arg-0 e-1 arg-12 (vector 0 e-16)) eta-0)))))))))))))))))))))))))))))))))))))))))) (lambda (u--err) (lambda (clam-1) (case (vector-ref u--err 0) ((6) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-1))(else (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ProcessDef-impossibleErrOK arg-1 e-6 u--err) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) (vector 1 (vector 0 e-5))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 6 arg-0 e-1 arg-12 (vector 1 u--err)) clam-1))))))))))))))) ext-0)))))))) ((0) (let ((e-4 (vector-ref arg-13 1))) (let ((e-5 (vector-ref arg-13 2))) (let ((e-6 (vector-ref arg-13 3))) (let ((act-24 (TTImpC-45ProcessDef-checkLHS arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-5 arg-8 arg-9 arg-10 arg-11 arg-12 e-4 e-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((e-3 (cdr e-7))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (let ((e-22 (car e-19))) (let ((e-23 (cdr e-19))) (let ((u--rhsMode (let ((sc8 (AlgebraC-45Semiring-isErased (csegen-475) arg-5))) (cond ((equal? sc8 1) (vector 0 )) (else (vector 2 )))))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking RHS " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-6))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-12 (vector-ref act-25 1))) (vector 0 e-12))) (else (let ((act-26 (CoreC-45Normalise-logEnv e-9 arg-1 "declare.def.clause" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) "In env" e-14 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((act-27 (let ((act-27 (CoreC-45Context-getFullName arg-1 (vector 8 arg-9) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-logTime arg-1 (lambda () (PreludeC-45TypesC-45String-C-43C-43 "+++ Check RHS " (CoreC-45FC-u--show_Show_FC e-4))) (TTImpC-45ElabC-45Utils-wrapErrorC arg-10 (lambda (eta-0) (vector 65 e-4 e-16 eta-0)) (lambda (eta-0) (TTImpC-45Elab-checkTermSub arg-0 e-9 arg-1 arg-2 arg-3 arg-4 arg-9 u--rhsMode arg-10 e-18 e-14 arg-12 e-10 e-6 (CoreC-45NormaliseC-45Eval-gnf e-9 e-14 e-23) eta-0))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Metadata-clearHoleLHS arg-2 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-17 (vector-ref act-28 1))) (vector 0 e-17))) (else (let ((act-29 (CoreC-45ContextC-45Log-logTerm e-9 arg-1 "declare.def.clause" (+ 1 (+ 1 (+ 1 0))) (lambda () "RHS term") e-16 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-20 (vector-ref act-29 1))) (vector 0 e-20))) (else (let ((act-30 (cond ((equal? arg-8 1) (let ((act-30 (CoreC-45Context-addHashWithNames arg-1 (csegen-834) (csegen-76) e-22 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-21 (vector-ref act-30 1))) (vector 0 e-21))) (else (CoreC-45Context-addHashWithNames arg-1 (csegen-834) (csegen-76) e-16 ext-0))))) (else (vector 1 0))))) (case (vector-ref act-30 0) ((0) (let ((e-21 (vector-ref act-30 1))) (vector 0 e-21))) (else (let ((act-31 (case (vector-ref e-16 0) ((2) (CoreC-45Metadata-addLHS e-9 arg-1 arg-2 (TTImpC-45TTImp-getFC e-5) (CoreC-45Env-length arg-12) e-14 e-22 ext-0))(else (vector 1 0))))) (case (vector-ref act-31 0) ((0) (let ((e-24 (vector-ref act-31 1))) (vector 0 e-24))) (else (vector 1 (vector 1 (vector e-9 e-14 e-22 e-16))))))))))))))))))))))))))))))))))))))))))))) (else (let ((e-8 (vector-ref arg-13 1))) (let ((e-9 (vector-ref arg-13 2))) (let ((e-10 (vector-ref arg-13 3))) (let ((e-11 (vector-ref arg-13 4))) (let ((e-12 (vector-ref arg-13 5))) (let ((e-13 (vector-ref arg-13 6))) (let ((act-24 (TTImpC-45ProcessDef-checkLHS arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-5 arg-8 arg-9 arg-10 arg-11 arg-12 e-8 e-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-15 (car e-7))) (let ((e-14 (cdr e-7))) (let ((e-17 (car e-14))) (let ((e-16 (cdr e-14))) (let ((e-18 (car e-16))) (let ((e-19 (cdr e-16))) (let ((e-22 (car e-19))) (let ((e-23 (cdr e-19))) (let ((u--wmode (let ((sc8 (AlgebraC-45Semiring-isErased (csegen-475) arg-5))) (cond ((equal? sc8 1) (vector 0 )) (else (vector 2 )))))) (let ((act-25 (let ((act-25 (CoreC-45Context-getFullName arg-1 (vector 8 arg-9) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-25 1))) ((TTImpC-45ElabC-45Utils-wrapErrorC arg-10 (lambda (eta-0) (vector 65 e-8 e-20 eta-0)) (TTImpC-45Elab-elabTermSub arg-0 e-6 arg-1 arg-2 arg-3 arg-4 arg-9 u--wmode arg-10 e-18 e-17 arg-12 e-15 e-10 '())) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-25 1))) (let ((_-0 (cons e-2 (cons e-6 (cons e-15 (cons e-17 (cons e-18 (cons e-22 e-23)))))))) (let ((e-21 (car e-20))) (let ((e-4 (cdr e-20))) (let ((act-26 (CoreC-45Metadata-clearHoleLHS arg-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-24 (vector-ref act-26 1))) (vector 0 e-24))) (else (let ((act-27 (CoreC-45ContextC-45Log-logTerm e-6 arg-1 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "With value") e-21 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-25 (vector-ref act-27 1))) (vector 0 e-25))) (else (let ((act-28 (CoreC-45ContextC-45Log-logTerm e-6 arg-1 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 0))) (lambda () "Required type") e-23 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-26 (vector-ref act-28 1))) (vector 0 e-26))) (else (let ((act-29 ((CoreC-45NormaliseC-45Eval-getTerm e-4) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-27 (vector-ref act-29 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (unbox arg-1))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-28 (vector-ref act-30 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Normalise-normaliseHoles arg-1 e-6 e-28 e-17 e-21 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-29 (vector-ref act-31 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Normalise-normaliseHoles arg-1 e-6 e-28 e-17 e-27 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-30 (vector-ref act-32 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-32 1))) (let ((_-1 (cons e-21 e-4))) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-8455 e-13 e-12 e-11 e-10 e-9 e-8 arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-2 e-6 e-15 e-17 e-18 e-22 e-23 _-0 u--wmode e-21 e-4 _-1 e-27 e-28 e-29 e-30 (TTImpC-45ProcessDef-n--17220-7311-u--keepOldEnv e-13 e-12 e-11 e-10 e-9 e-8 arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 e-15 (let ((sc17 (CoreC-45Env-findSubEnv e-6 e-17 e-29))) (let ((e-31 (cdr sc17))) e-31))) ext-0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessDef-calcRefs (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32calcRefs-11049 arg-3 arg-2 arg-1 arg-0 e-5 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17)) ext-0))))))))))))))
(define TTImpC-45ProcessDef-applyEnv (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-resolveName arg-1 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-3 (cons (box arg-3) (cons (PreludeC-45TypesC-45List-reverse (CoreC-45Env-allVarsNoLet arg-0 arg-2)) (lambda (u--fc) (lambda (u--nt) (CoreC-45UnifyState-applyTo arg-0 u--fc (vector 1 u--fc u--nt (vector 8 e-5)) arg-2)))))))))))))
(define TTImpC-45WithClause-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getNewLHS-14882 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (if (null? arg-21) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-7 "Badly formed 'with' clause") ext-0) (let ((e-1 (car arg-21))) (let ((e-2 (cdr arg-21))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-9 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-16) (PreludeC-45TypesC-45String-C-43C-43 " against " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-19) (PreludeC-45TypesC-45String-C-43C-43 " dropping " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1280) (cons e-1 e-2))))))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 ((TTImpC-45WithClause-getMatch arg-8 arg-9 1 arg-16 arg-19) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-9 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Matches: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2212) e-6))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((u--params (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45WithClause-getArgMatch arg-10 (vector 1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)) 0 e-1 e-6 eta-0)) arg-3))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-9 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Parameters: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1280) u--params))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 ((TTImpC-45WithClause-getHeadLoc arg-1) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--newlhs (TTImpC-45TTImp-apply (vector 0 e-9 arg-4) (PreludeC-45TypesC-45List-tailRecAppend u--params e-2)))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-9 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "New LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--newlhs))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (vector 1 u--newlhs))))))))))))))))))))))))))))
(define TTImpC-45WithClause-n--8319-15123-u--wrhsC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-2 e-5))))))))))(else (vector 1 arg-8)))))
(define TTImpC-45WithClause-n--8319-15122-u--wrhs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 1 e-1 e-2 e-3 e-4 e-7 e-8)))))))))))))))))) ((2) (let ((e-8 (vector-ref arg-8 1))) (let ((e-9 (vector-ref arg-8 2))) (let ((e-10 (vector-ref arg-8 3))) (let ((e-11 (vector-ref arg-8 4))) (let ((e-12 (vector-ref arg-8 5))) (let ((e-13 (vector-ref arg-8 6))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-13) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-8 e-9 e-10 e-11 e-5 e-6)))))))))))))))))) ((3) (let ((e-15 (vector-ref arg-8 1))) (let ((e-16 (vector-ref arg-8 2))) (let ((e-17 (vector-ref arg-8 3))) (let ((e-18 (vector-ref arg-8 4))) (let ((e-19 (vector-ref arg-8 5))) (let ((e-20 (vector-ref arg-8 6))) (let ((e-21 (vector-ref arg-8 7))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-19) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-20) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-21) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 3 e-15 e-16 e-17 e-18 e-5 e-6 e-7))))))))))))))))))))))) ((4) (let ((e-23 (vector-ref arg-8 1))) (let ((e-24 (vector-ref arg-8 2))) (let ((e-25 (vector-ref arg-8 3))) (let ((e-26 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-24) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-25) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45WithClause-n--8319-15123-u--wrhsC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-1 eta-2))) e-26 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 e-23 e-5 e-6 e-7)))))))))))))))))))) ((5) (let ((e-28 (vector-ref arg-8 1))) (let ((e-29 (vector-ref arg-8 2))) (let ((e-30 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-30) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-28 e-29 e-5))))))))))) ((7) (let ((e-32 (vector-ref arg-8 1))) (let ((e-33 (vector-ref arg-8 2))) (let ((e-34 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-34) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 7 e-32 e-33 e-5))))))))))) ((8) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-37) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-38) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 e-36 e-5 e-6))))))))))))))) ((9) (let ((e-40 (vector-ref arg-8 1))) (let ((e-41 (vector-ref arg-8 2))) (let ((e-42 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-41) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-42) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-40 e-5 e-6))))))))))))))) ((10) (let ((e-44 (vector-ref arg-8 1))) (let ((e-45 (vector-ref arg-8 2))) (let ((e-46 (vector-ref arg-8 3))) (let ((e-47 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-45) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-47) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 10 e-44 e-5 e-46 e-6)))))))))))))))) ((11) (let ((e-49 (vector-ref arg-8 1))) (let ((e-50 (vector-ref arg-8 2))) (let ((e-51 (vector-ref arg-8 3))) (TTImpC-45WithClause-n--8319-15121-u--updateWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-49 e-50 (cons e-51 '())))))) ((14) (let ((e-53 (vector-ref arg-8 1))) (let ((e-54 (vector-ref arg-8 2))) (let ((e-55 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-54) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-55) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 14 e-53 e-5 e-6))))))))))))))) ((20) (let ((e-57 (vector-ref arg-8 1))) (let ((e-58 (vector-ref arg-8 2))) (let ((e-59 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-59) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 20 e-57 e-58 e-5))))))))))) ((21) (let ((e-61 (vector-ref arg-8 1))) (let ((e-62 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-62) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 21 e-61 e-5)))))))))) ((22) (let ((e-64 (vector-ref arg-8 1))) (let ((e-65 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--8319-15122-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-65) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 22 e-64 e-5))))))))))(else (lambda (eta-0) (vector 1 arg-8))))))
(define TTImpC-45WithClause-n--8319-15120-u--withApply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) arg-9 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (TTImpC-45WithClause-n--8319-15120-u--withApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 11 arg-8 arg-9 e-2) e-3))))))
(define TTImpC-45WithClause-n--8319-15121-u--updateWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-9 0) ((11) (let ((e-6 (vector-ref arg-9 2))) (let ((e-7 (vector-ref arg-9 3))) (TTImpC-45WithClause-n--8319-15121-u--updateWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-6 (cons e-7 arg-10)))))(else (lambda (clam-0) (if (null? arg-10) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-8 "Badly formed 'with' application") clam-0) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-7 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "With-app: Matching " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-0) (PreludeC-45TypesC-45String-C-43C-43 " against " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-9))))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 ((TTImpC-45WithClause-getMatch arg-6 arg-7 0 arg-0 arg-9) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45WithClause-getHeadLoc arg-9) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-7 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Result: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2212) e-6))) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((u--newrhs (TTImpC-45TTImp-apply (vector 0 e-7 arg-3) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45WithClause-getArgMatch arg-8 (vector 2 ) 1 e-2 e-6 eta-0)) arg-2)))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-7 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "With args for RHS: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2180) arg-2))) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-7 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "New RHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--newrhs))) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (vector 1 (TTImpC-45WithClause-n--8319-15120-u--withApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 u--newrhs e-3)))))))))))))))))))))))))))))))
(define TTImpC-45WithClause-n--7723-14619-u--dropWithArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (cond ((equal? arg-10 0) (lambda (eta-0) (vector 1 (cons arg-11 '()))))(else (let ((e-0 (- arg-10 1))) (lambda (clam-0) (case (vector-ref arg-11 0) ((8) (let ((e-3 (vector-ref arg-11 2))) (let ((e-4 (vector-ref arg-11 3))) (let ((act-24 ((TTImpC-45WithClause-n--7723-14619-u--dropWithArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-0 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-7 (car e-5))) (let ((e-6 (cdr e-5))) (vector 1 (cons e-7 (cons e-4 e-6))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-7 "Badly formed 'with' clause") clam-0)))))))))
(define TTImpC-45WithClause-withRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (TTImpC-45WithClause-n--8319-15122-u--wrhs arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-6)))
(define TTImpC-45WithClause-mergeMatches (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (DataC-45List-lookup (csegen-17) e-6 e-5))) (if (null? sc3) (vector 1 (cons (cons e-6 e-7) e-5)) (let ((e-4 (unbox sc3))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-7 e-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (vector 1 e-5)))))))))))))))))))
(define TTImpC-45WithClause-matchFail (lambda (arg-1 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "With clause does not match parent") ext-0)))
(define TTImpC-45WithClause-matchAny (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (TTImpC-45WithClause-matchFail arg-2 clam-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45Core-u--catch_Catchable_Core_Error (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-3 e-6 e-7) (lambda (u--err) (TTImpC-45WithClause-matchAny arg-0 arg-1 arg-2 arg-3 e-3)) clam-0)))))))))
(define TTImpC-45WithClause-matchAll (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 ((TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-6 e-7) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-tailRecAppend e-8 e-5)) clam-0)))))))))))))))))
(define TTImpC-45WithClause-getNewLHS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--vploc (CoreC-45FC-virtualiseFC arg-3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-n--7723-14619-u--dropWithArgs arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-4 arg-9) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Context-isUnboundImplicits arg-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-setUnboundImplicits arg-1 1 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (TTImpC-45BindImplicits-bindNames arg-1 0 arg-8 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((_-0 (cons e-2 e-3))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((act-28 (TTImpC-45BindImplicits-bindNames arg-1 0 e-2 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((_-1 (cons e-9 e-4))) (let ((e-12 (car e-10))) (let ((e-11 (cdr e-10))) (let ((act-29 (CoreC-45Context-setUnboundImplicits arg-1 e-6 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((act-30 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Parent LHS (with implicits): " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-4))) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (let ((act-31 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause.with" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Modified LHS (with implicits): " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-11))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-15 (vector-ref act-31 1))) (vector 0 e-15))) (else (let ((_-2 (cons e-12 e-11))) (TTImpC-45WithClause-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getNewLHS-14882 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--vploc e-2 e-3 _-0 e-6 e-9 e-4 _-1 e-12 e-11 _-2 (PreludeC-45TypesC-45List-reverse e-3) eta-0))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45WithClause-getMatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((17) (let ((e-68 (vector-ref arg-3 1))) (let ((e-69 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref arg-4 0) ((17) (let ((e-101 (vector-ref arg-4 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 (cons (cons e-69 arg-4) '()))))) (TTImpC-45WithClause-addAlias arg-0 arg-1 e-101 e-68) clam-0)))(else (vector 1 (cons (cons e-69 arg-4) '())))))))) ((32) (lambda (eta-0) (vector 1 '()))) ((0) (let ((e-74 (vector-ref arg-3 1))) (let ((e-75 (vector-ref arg-3 2))) (case (vector-ref e-75 0) ((0) (let ((e-106 (vector-ref e-75 1))) (let ((e-107 (vector-ref e-75 2))) (case (vector-ref arg-4 0) ((0) (let ((e-109 (vector-ref arg-4 1))) (let ((e-110 (vector-ref arg-4 2))) (case (vector-ref e-110 0) ((0) (let ((e-111 (vector-ref e-110 1))) (let ((e-112 (vector-ref e-110 2))) (lambda (clam-0) (let ((sc4 (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-107 e-112))) (cond ((equal? sc5 1) (CoreC-45NameC-45Namespace-isParentOf e-111 e-106)) (else 0))))) (cond ((equal? sc4 1) (PreludeC-45IO-u--map_Functor_IO (csegen-2216) (TTImpC-45WithClause-addAlias arg-0 arg-1 e-109 e-74) clam-0)) (else (TTImpC-45WithClause-matchFail e-109 clam-0))))))))(else (lambda (clam-1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-107 e-110))) (cond ((equal? sc3 1) (PreludeC-45IO-u--map_Functor_IO (csegen-2216) (TTImpC-45WithClause-addAlias arg-0 arg-1 e-109 e-74) clam-1)) (else (TTImpC-45WithClause-matchFail e-109 clam-1))))))))))(else (case (vector-ref arg-4 0) ((0) (let ((e-104 (vector-ref arg-4 1))) (let ((e-105 (vector-ref arg-4 2))) (lambda (clam-2) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-75 e-105))) (cond ((equal? sc3 1) (PreludeC-45IO-u--map_Functor_IO (csegen-2216) (TTImpC-45WithClause-addAlias arg-0 arg-1 e-104 e-74) clam-2)) (else (TTImpC-45WithClause-matchFail e-104 clam-2))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-3) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-3))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-4) (let ((sc6 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-4)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-5) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-5)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-5)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-5))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-6) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-6))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-7) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-7)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 e-60))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 e-65)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-8) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-8))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-9) (let ((sc6 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-9)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-10) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-10))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-10)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-10))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-10)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-10))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-10))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-11) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-11))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-12) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-12)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-13) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-13))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-14) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-14)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-15) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-15))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-15)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-15))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-15)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-15))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-15))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-16) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-16))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-17) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-17)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))))(else (case (vector-ref arg-4 0) ((0) (let ((e-104 (vector-ref arg-4 1))) (let ((e-105 (vector-ref arg-4 2))) (lambda (clam-18) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-75 e-105))) (cond ((equal? sc2 1) (PreludeC-45IO-u--map_Functor_IO (csegen-2216) (TTImpC-45WithClause-addAlias arg-0 arg-1 e-104 e-74) clam-18)) (else (TTImpC-45WithClause-matchFail e-104 clam-18))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-19) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-19))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-20) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-20)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-21) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-21))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-21)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-21))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-21)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-21))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-21))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-22) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-22))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-23) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-23)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 e-60))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 e-65)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-24) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-24))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-25) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-25)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-26) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-26))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-26)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-26))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-26)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-26))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-26))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-27) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-27))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-28) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-28)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-29) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-29))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-30) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-30)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-31) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-31))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-31)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-31))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-31)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-31))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-31))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-32) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-32))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-33) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-33)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))))) ((1) (let ((e-78 (vector-ref arg-3 2))) (let ((e-79 (vector-ref arg-3 3))) (let ((e-80 (vector-ref arg-3 4))) (let ((e-81 (vector-ref arg-3 5))) (let ((e-82 (vector-ref arg-3 6))) (case (vector-ref arg-4 0) ((1) (let ((e-114 (vector-ref arg-4 1))) (let ((e-115 (vector-ref arg-4 2))) (let ((e-116 (vector-ref arg-4 3))) (let ((e-117 (vector-ref arg-4 4))) (let ((e-118 (vector-ref arg-4 5))) (let ((e-119 (vector-ref arg-4 6))) (let ((sc2 (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-78 e-115))) (cond ((equal? sc3 1) (let ((sc4 (CoreC-45TT-eqPiInfoBy (lambda (_-13776) (lambda (_-13778) 1)) e-79 e-116))) (cond ((equal? sc4 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-802) e-80 e-117)) (else 0)))) (else 0))))) (cond ((equal? sc2 1) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-81 e-118) (cons (cons e-82 e-119) '())))) (else (lambda (eta-0) (TTImpC-45WithClause-matchFail e-114 eta-0))))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-34) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-34))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-35) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-35)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-36) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-36))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-36)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-36))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-36)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-36))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-36))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-37) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-37))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-38) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-38)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 e-60))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 e-65)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-39) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-39))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-40) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-40)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-41) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-41))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-41)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-41))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-41)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-41))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-41))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-42) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-42))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-43) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-43)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-44) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-44))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-45) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-45)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-46) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-46))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-46)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-46))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-46)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-46))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-46))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-47) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-47))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-48) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-48)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))))) ((8) (let ((e-85 (vector-ref arg-3 2))) (let ((e-86 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-122 (vector-ref arg-4 2))) (let ((e-123 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-85 e-122) (cons (cons e-86 e-123) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-49) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-49))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-50) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-50)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-51) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-51))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-51)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-51))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-51)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-51))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-51))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-52) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-52))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-53) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-53)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 e-60))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 e-65)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-54) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-54))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-55) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-55)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-56) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-56))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-56)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-56))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-56)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-56))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-56))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-57) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-57))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-58) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-58)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-59) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-59))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-60) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-60)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-61) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-61))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-61)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-61))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-61)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-61))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-61))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-62) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-62))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-63) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-63)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))) ((9) (let ((e-89 (vector-ref arg-3 2))) (let ((e-90 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((9) (let ((e-126 (vector-ref arg-4 2))) (let ((e-127 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-89 e-126) (cons (cons e-90 e-127) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-64) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-64))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-65) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-65)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-66) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-66))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-66)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-66))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-66)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-66))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-66))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-67) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-67))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-68) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-68)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 e-60))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 e-65)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-69) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-69))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-70) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-70)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-71) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-71))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-71)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-71))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-71)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-71))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-71))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-72) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-72))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-73) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-73)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-74) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-74))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-75) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-75)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-76) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-76))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-76)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-76))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-76)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-76))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-76))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-77) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-77))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-78) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-78)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))) ((10) (let ((e-93 (vector-ref arg-3 2))) (let ((e-94 (vector-ref arg-3 3))) (let ((e-95 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((10) (let ((e-129 (vector-ref arg-4 1))) (let ((e-130 (vector-ref arg-4 2))) (let ((e-131 (vector-ref arg-4 3))) (let ((e-132 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-94 e-131))) (cond ((equal? sc2 1) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-93 e-130) (cons (cons e-95 e-132) '())))) (else (lambda (eta-0) (TTImpC-45WithClause-matchFail e-129 eta-0))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-79) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-79))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-80) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-80)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-81) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-81))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-81)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-81))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-81)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-81))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-81))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-82) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-82))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-83) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-83)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 e-60))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 e-65)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-84) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-84))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-85) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-85)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-86) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-86))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-86)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-86))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-86)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-86))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-86))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-87) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-87))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-88) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-88)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-89) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-89))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-90) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-90)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-91) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-91))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-91)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-91))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-91)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-91))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-91))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-92) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-92))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-93) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-93)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))) ((11) (let ((e-98 (vector-ref arg-3 2))) (let ((e-99 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((11) (let ((e-135 (vector-ref arg-4 2))) (let ((e-136 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-98 e-135) (cons (cons e-99 e-136) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-94) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-94))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-95) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-95)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-96) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-96))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-96)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-96))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-96)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-96))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-96))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-97) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-97))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-98) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-98)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 e-60))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 e-65)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-99) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-99))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-100) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-100)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-101) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-101))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-101)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-101))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-101)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-101))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-101))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-102) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-102))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-103) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-103)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-104) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-104))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-105) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-105)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-106) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-106))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-106)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-106))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-106)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-106))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-106))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-107) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-107))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-108) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-108)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-109) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-109))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-110) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-110)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-111) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-111))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-111)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-111))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-111)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-111))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-111))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-112) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-112))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-113) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-113)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 e-60))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 e-65)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-114) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-114))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-115) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-115)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-116) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-116))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-116)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-116))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-116)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-116))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-116))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-117) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-117))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-118) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-118)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-119) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-119))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-120) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-120)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-121) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((e-39 (vector-ref e-38 1))) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-121))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 17 e-34 e-39)) e-5)) clam-121)))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-121))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-121)))))))))(else (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-121))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) clam-121))))))))))))(else (lambda (eta-0) (let ((act-24 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-122) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-122))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-123) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc2 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-123)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))
(define TTImpC-45WithClause-getHeadLoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 1))) (lambda (eta-0) (vector 1 e-1)))) ((8) (let ((e-5 (vector-ref arg-0 2))) (TTImpC-45WithClause-getHeadLoc e-5))) ((9) (let ((e-9 (vector-ref arg-0 2))) (TTImpC-45WithClause-getHeadLoc e-9))) ((10) (let ((e-13 (vector-ref arg-0 2))) (TTImpC-45WithClause-getHeadLoc e-13)))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Could not find head of LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-0))) eta-0))))))
(define TTImpC-45WithClause-getArgMatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-3 (cond ((equal? arg-2 1) (if (null? arg-5) (let ((e-1 (unbox arg-5))) (let ((e-5 (cdr e-1))) (let ((sc5 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-5) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup (csegen-17) u--n arg-4)))))))) (if (null? sc5) (let ((u--arg (vector 32 arg-0 1))) (let ((sc6 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc6 1) (vector 18 arg-0 arg-0 0 e-5 u--arg)) (else u--arg)))) (let ((e-2 (unbox sc5))) e-2))))) (let ((e-7 (unbox arg-5))) (if (null? e-7) (let ((e-1 (unbox arg-5))) (let ((e-5 (cdr e-1))) (let ((sc6 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-5) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup (csegen-17) u--n arg-4)))))))) (if (null? sc6) (let ((u--arg (vector 32 arg-0 1))) (let ((sc7 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc7 1) (vector 18 arg-0 arg-0 0 e-5 u--arg)) (else u--arg)))) (let ((e-2 (unbox sc6))) e-2))))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-10 0) ((2) (let ((sc5 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-11) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup (csegen-17) u--n arg-4)))))))) (if (null? sc5) (let ((u--arg (vector 12 arg-0 (PreludeC-45Types-u--fromInteger_Num_Nat 500)))) (let ((sc6 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc6 1) (vector 18 arg-0 arg-0 0 e-11 u--arg)) (else u--arg)))) (let ((e-1 (unbox sc5))) e-1))))(else (let ((e-1 (unbox arg-5))) (let ((e-5 (cdr e-1))) (let ((sc6 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-5) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup (csegen-17) u--n arg-4)))))))) (if (null? sc6) (let ((u--arg (vector 32 arg-0 1))) (let ((sc7 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc7 1) (vector 18 arg-0 arg-0 0 e-5 u--arg)) (else u--arg)))) (let ((e-2 (unbox sc6))) e-2)))))))))))))(else (let ((e-1 (unbox arg-5))) (let ((e-5 (cdr e-1))) (let ((sc3 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-5) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup (csegen-17) u--n arg-4)))))))) (if (null? sc3) (let ((u--arg (vector 32 arg-0 1))) (let ((sc4 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc4 1) (vector 18 arg-0 arg-0 0 e-5 u--arg)) (else u--arg)))) (let ((e-2 (unbox sc3))) e-2))))))))))
(define TTImpC-45WithClause-addAlias (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (let ((sc0 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc0) (vector 1 0) (let ((e-1 (unbox sc0))) (let ((sc1 (CoreC-45FC-isConcreteFC arg-3))) (if (null? sc1) (vector 1 0) (let ((e-2 (unbox sc1))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "ide-mode.highlight.alias" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Adding alias: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1303) e-1) (PreludeC-45TypesC-45String-C-43C-43 " -> " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1303) e-2))))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (CoreC-45Metadata-addSemanticAlias arg-0 e-1 e-2 clam-0)))))))))))))
(define TTImpC-45PartialEval-case--caseC-32blockC-32inC-32quoteGenNF-12933 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (if (null? arg-15) (let ((act-24 (TTImpC-45PartialEval-quoteArgsWithFC arg-12 arg-11 arg-10 arg-9 arg-0 arg-1 arg-8 arg-7 arg-6 arg-5 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 1 arg-4 (vector 1 ) arg-2) e-5)))))) (let ((act-24 (CoreC-45Context-clearDefs arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45PartialEval-quoteArgsWithFC arg-12 arg-11 arg-10 arg-9 arg-0 arg-1 arg-8 arg-7 arg-6 arg-5 arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45PartialEval-specialise (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) arg-12 arg-11 arg-10 arg-9 arg-4 (TTImpC-45PartialEval-n--13817-12863-u--extendEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-6 arg-5) arg-13 arg-2 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (let ((act-27 (TTImpC-45PartialEval-quoteArgsWithFC arg-12 arg-11 arg-10 arg-9 arg-0 arg-1 arg-8 e-5 arg-6 arg-5 arg-3 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 1 arg-4 (vector 1 ) arg-2) e-8)))))) (let ((e-1 (unbox e-7))) (vector 1 e-1))))))))))))))))))
(define TTImpC-45PartialEval-case--specialise-11193 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (if (null? arg-10) (vector 1 '()) (let ((act-24 (CoreC-45Context-toFullNames arg-9 (csegen-46) arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45PartialEval-n--12648-10856-u--getSpecArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 0 arg-10 arg-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((u--nhash (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hash_Hashable_C-40ListC-32C-36aC-41 (csegen-834) (DataC-45List-mapMaybe (lambda (eta-0) (TTImpC-45PartialEval-getStatic eta-0)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-1))) arg-2))) (let ((u--pename (vector 0 (CoreC-45NameC-45Namespace-partialEvalNS) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "PE_" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-nameRoot e-5) (PreludeC-45TypesC-45String-C-43C-43 "_" (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Int_Bits64 u--nhash)))))))))) (let ((act-26 (let ((act-26 (unbox arg-9))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc5 (LibrariesC-45DataC-45NameMap-lookup u--pename (let ((e-26 (vector-ref e-7 26))) e-26)))) (if (null? sc5) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (lambda (eta-0) (TTImpC-45PartialEval-mkSpecDef arg-9 arg-8 arg-7 arg-6 arg-5 arg-3 u--pename e-1 arg-2 arg-1 eta-0)) ext-0) (vector 1 '()))))))))))))))))))))))
(define TTImpC-45PartialEval-case--eraseInferred-10714 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (lambda (eta-0) (vector 1 e-2)) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((1) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-7 (let ((e-0 (vector-ref e-8 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-25 1))) (if (null? e-9) (vector 1 arg-1) (let ((e-1 (unbox e-9))) (let ((u--argsE (TTImpC-45PartialEval-n--12400-10644-u--dropErased arg-1 arg-2 e-5 0 (let ((e-25 (vector-ref e-1 6))) e-25) e-3))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45PartialEval-eraseInferred arg-2 eta-0)) u--argsE '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-apply e-5 (vector 1 e-5 (vector 1 ) e-7) e-10))))))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45PartialEval-eraseInferred arg-2 eta-0)) e-3 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 (CoreC-45TT-apply (CoreC-45TT-getLoc e-2) e-2 e-3)))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45PartialEval-eraseInferred arg-2 eta-0)) e-3 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 (CoreC-45TT-apply (CoreC-45TT-getLoc e-2) e-2 e-3)))))))))))))
(define TTImpC-45PartialEval-case--caseC-32blockC-32inC-32mkSpecDef-10034 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (case (vector-ref arg-21 0) ((1) (let ((e-4 (vector-ref arg-21 5))) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-10 "specialise" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45PartialEval-n--11174-9556-u--unelabDef arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1)) e-4 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Attempting to specialise:\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (TTImpC-45PartialEval-n--11174-9557-u--showPat arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1)) e-5))))))))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-10 '() arg-19 '() (let ((e-25 (vector-ref arg-5 2))) e-25)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-getSpecPats arg-10 arg-6 arg-4 arg-2 arg-1 e-6 arg-3 arg-12 e-4) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (CoreC-45TT-applyWithFC (vector 1 arg-6 (vector 1 ) arg-2) arg-1)) (let ((e-7 (unbox e-6))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-10 "specialise" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "New patterns for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-4) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45PartialEval-n--11174-9557-u--showPat arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-0)) e-7)))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 ((TTImpC-45ElabC-45Check-processDecl '() arg-10 arg-9 arg-8 arg-7 (cons 2 '()) '() '() (vector 2 arg-6 (vector 8 arg-16) e-7)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((act-28 (CoreC-45Context-setAllPublic arg-10 0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (vector 1 arg-13)))))))))))))))))))))(else (vector 1 (CoreC-45TT-applyWithFC (vector 1 arg-6 (vector 1 ) arg-2) arg-1))))))
(define TTImpC-45PartialEval-case--specPatByVar-8753 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-mkSubsts 0 arg-4 e-3 arg-3) (lambda (u--psubs) (let ((u--lhsC-39 (CoreC-45TT-apply (CoreC-45TT-getLoc e-2) e-2 e-3))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons arg-0 (cons arg-1 (cons (TTImpC-45PartialEval-substLocs arg-0 u--psubs u--lhsC-39) (TTImpC-45PartialEval-substLocs arg-0 u--psubs arg-3))))))))))))
(define TTImpC-45PartialEval-n--10524-8940-u--unelabPat (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (TTImpC-45Unelab-unelabNoSugar e-2 arg-9 e-6 e-10 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--lhsC-39 (TTImpC-45PartialEval-n--10524-8939-u--dropArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-5)))) (let ((act-25 (let ((act-25 (unbox arg-9))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Normalise-normaliseArgHoles arg-9 e-2 e-8 e-6 e-11 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45Unelab-unelabNoSugar e-2 arg-9 e-6 e-9 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 0 arg-8 u--lhsC-39 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-12)))))))))))))))))))))))))))))
(define TTImpC-45PartialEval-n--11174-9556-u--unelabDef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (TTImpC-45Unelab-unelabNoSugar e-2 arg-10 e-6 e-10 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-10))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Normalise-normaliseArgHoles arg-10 e-2 e-8 e-6 e-11 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45Unelab-unelabNoSugar e-2 arg-10 e-6 e-9 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (vector 0 arg-6 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-5) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-12))))))))))))))))))))))))))))
(define TTImpC-45PartialEval-n--11174-9557-u--showPat (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-2) (PreludeC-45TypesC-45String-C-43C-43 " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-3))))))(else "Can't happen"))))
(define TTImpC-45PartialEval-n--10524-8938-u--reapply (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) arg-10 (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (if (null? e-6) (TTImpC-45PartialEval-n--10524-8938-u--reapply arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 8 arg-8 arg-10 e-7) e-3) (let ((e-10 (unbox e-6))) (TTImpC-45PartialEval-n--10524-8938-u--reapply arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 10 arg-8 arg-10 e-10 e-7) e-3))))))))))
(define TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-10 0) ((0) (let ((e-12 (vector-ref arg-10 2))) (let ((e-13 (vector-ref arg-10 3))) (let ((e-14 (vector-ref arg-10 4))) (case (vector-ref e-13 0) ((2) (let ((e-18 (vector-ref e-13 3))) (case (vector-ref e-18 0) ((1) (if (null? arg-12) (if (null? arg-12) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-38 (car arg-12))) (let ((e-39 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-41 (car arg-13))) (let ((e-42 (cdr arg-13))) (if (null? e-41) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-46 (cdr e-41))) (if (null? e-46) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (vector 0 arg-8 (vector 1 (vector 0 e-38)))) e-39 e-42) eta-0)))))))))) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0)))))))))))))))))))))))))))))))) (let ((e-49 (car arg-12))) (let ((e-50 (cdr arg-12))) (if (null? arg-13) (if (null? arg-12) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-38 (car arg-12))) (let ((e-39 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-41 (car arg-13))) (let ((e-42 (cdr arg-13))) (if (null? e-41) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-46 (cdr e-41))) (if (null? e-46) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (vector 0 arg-8 (vector 1 (vector 0 e-38)))) e-39 e-42) eta-0)))))))))) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0)))))))))))))))))))))))))))))))) (let ((e-52 (car arg-13))) (let ((e-53 (cdr arg-13))) (if (null? e-52) (if (null? arg-12) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-38 (car arg-12))) (let ((e-39 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-41 (car arg-13))) (let ((e-42 (cdr arg-13))) (if (null? e-41) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-46 (cdr e-41))) (if (null? e-46) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (vector 0 arg-8 (vector 1 (vector 0 e-38)))) e-39 e-42) eta-0)))))))))) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0)))))))))))))))))))))))))))))))) (let ((e-57 (cdr e-52))) (if (null? e-57) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-49)))) e-50 e-53) eta-0)))))))))) (if (null? arg-12) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-38 (car arg-12))) (let ((e-39 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-41 (car arg-13))) (let ((e-42 (cdr arg-13))) (if (null? e-41) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-46 (cdr e-41))) (if (null? e-46) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (vector 0 arg-8 (vector 1 (vector 0 e-38)))) e-39 e-42) eta-0)))))))))) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))))))))))))))))))))))(else (if (null? arg-12) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-38 (car arg-12))) (let ((e-39 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-41 (car arg-13))) (let ((e-42 (cdr arg-13))) (if (null? e-41) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))) (let ((e-46 (cdr e-41))) (if (null? e-46) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (vector 0 arg-8 (vector 1 (vector 0 e-38)))) e-39 e-42) eta-0)))))))))) (case (vector-ref e-18 0) ((1) (if (null? arg-13) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-30 (car arg-13))) (let ((e-31 (cdr arg-13))) (if (null? e-30) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-35 (cdr e-30))) (if (null? e-35) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))) (let ((e-36 (unbox e-35))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-36 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-31) eta-0))))))))))))))))))))))(else (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-21 (car arg-13))) (let ((e-22 (cdr arg-13))) (if (null? e-21) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-26 (cdr e-21))) (if (null? e-26) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-27 (unbox e-26))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-14 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 arg-8 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-12 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-7)) arg-12 e-22) eta-0))))))))))))))))))))))))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11)))))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11)))))))))))))))
(define TTImpC-45PartialEval-n--10524-8935-u--mkDynNames (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (if (null? e-2) (TTImpC-45PartialEval-n--10524-8935-u--mkDynNames arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) (let ((e-7 (cdr e-2))) (if (null? e-7) (cons (PreludeC-45TypesC-45String-C-43C-43 "_pe" (PreludeC-45Show-u--show_Show_Int arg-10)) (TTImpC-45PartialEval-n--10524-8935-u--mkDynNames arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (bs+ (blodwen-toSignedInt 1 63) arg-10 63) e-3)) (TTImpC-45PartialEval-n--10524-8935-u--mkDynNames arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3)))))))))
(define TTImpC-45PartialEval-n--12648-10856-u--getSpecArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (if (null? arg-12) (vector 1 (box '())) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-7 (cdr e-2))) (let ((act-24 ((TTImpC-45PartialEval-n--12648-10856-u--getSpecArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-10) arg-11 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((sc4 (PreludeC-45Types-elem (csegen-792) arg-10 arg-11))) (cond ((equal? sc4 1) (let ((act-25 (let ((act-25 (unbox arg-9))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Normalise-normaliseHoles arg-9 arg-0 e-8 arg-4 e-7 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45PartialEval-eraseInferred arg-9 e-9) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (let ((sc8 (TTImpC-45PartialEval-n--12648-10855-u--concrete arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-0 e-10))) (if (null? sc8) (vector 1 '()) (let ((e-4 (unbox sc8))) (vector 1 (box (cons (cons arg-10 (box e-4)) e-1))))))))))))))))))) (else (vector 1 (box (cons (cons arg-10 '()) e-1)))))))))))))))))))
(define TTImpC-45PartialEval-n--10524-8937-u--getRawArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((8) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (TTImpC-45PartialEval-n--10524-8937-u--getRawArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons (cons '() e-3) arg-10) e-2)))) ((10) (let ((e-6 (vector-ref arg-11 2))) (let ((e-7 (vector-ref arg-11 3))) (let ((e-8 (vector-ref arg-11 4))) (TTImpC-45PartialEval-n--10524-8937-u--getRawArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons (cons (box e-7) e-8) arg-10) e-6)))))(else arg-10))))
(define TTImpC-45PartialEval-n--11174-9554-u--getAllRefs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) arg-11 (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? e-1) (TTImpC-45PartialEval-n--11174-9554-u--getAllRefs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2) (let ((e-4 (unbox e-1))) (CoreC-45TT-addRefs 0 (vector 1 (vector 2 )) (TTImpC-45PartialEval-n--11174-9554-u--getAllRefs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2) e-4))))))))
(define TTImpC-45PartialEval-n--13772-12159-u--findName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14) (case (vector-ref arg-14 0) ((0) '()) (else (let ((e-2 (vector-ref arg-14 2))) (let ((e-3 (vector-ref arg-14 3))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 e-5))) (cond ((equal? sc2 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-n--13772-12159-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) (csegen-549)))))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-n--13772-12159-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) (csegen-549))))))))))
(define TTImpC-45PartialEval-n--13817-12863-u--extendEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-15 arg-16) (case (vector-ref arg-15 0) ((0) arg-16) (else (let ((e-3 (vector-ref arg-15 3))) (cons (vector 0 arg-4 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 10 arg-4 0)) (TTImpC-45PartialEval-n--13817-12863-u--extendEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 arg-16)))))))
(define TTImpC-45PartialEval-n--12400-10644-u--dropErased (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) arg-4 arg-5))) (cond ((equal? sc1 1) (cons (vector 10 arg-3 0) (TTImpC-45PartialEval-n--12400-10644-u--dropErased arg-1 arg-2 arg-3 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-4) arg-5 e-3))) (else (cons e-2 (TTImpC-45PartialEval-n--12400-10644-u--dropErased arg-1 arg-2 arg-3 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-4) arg-5 e-3))))))))))
(define TTImpC-45PartialEval-n--10524-8939-u--dropArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (TTImpC-45PartialEval-n--10524-8938-u--reapply arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 0 arg-8 arg-10) (TTImpC-45PartialEval-dropSpec 0 arg-2 (TTImpC-45PartialEval-n--10524-8937-u--getRawArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 '() arg-11)))))
(define TTImpC-45PartialEval-n--12648-10854-u--dropAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (vector 0 ) (let ((e-3 (cdr arg-10))) (vector 1 (TTImpC-45PartialEval-n--12648-10854-u--dropAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3))))))
(define TTImpC-45PartialEval-n--12648-10855-u--concrete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (CoreC-45TT-shrinkTerm arg-11 (TTImpC-45PartialEval-n--12648-10854-u--dropAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10))))
(define TTImpC-45PartialEval-n--13772-12017-u--addLater (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-17 arg-18) (if (null? arg-18) arg-17 (let ((e-3 (cdr arg-18))) (+ 1 (TTImpC-45PartialEval-n--13772-12017-u--addLater arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-17 e-3))))))
(define TTImpC-45PartialEval-u--show_Show_ArgMode (lambda (arg-0) (if (null? arg-0) "Dynamic" (let ((e-0 (unbox arg-0))) (PreludeC-45TypesC-45String-C-43C-43 "Static " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() e-0))))))
(define TTImpC-45PartialEval-u--showPrec_Show_ArgMode (lambda (arg-0 arg-1) (TTImpC-45PartialEval-u--show_Show_ArgMode arg-1)))
(define TTImpC-45PartialEval-substLocs (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (TTImpC-45PartialEval-substLocs arg-0 e-3 (TTImpC-45PartialEval-substLoc arg-0 e-6 e-7 arg-2)))))))))
(define TTImpC-45PartialEval-substLoc (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-1 e-4))) (cond ((equal? sc1 1) arg-2) (else (vector 0 e-2 e-3 e-4)))))))) ((3) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (vector 3 e-7 e-8 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 eta-0)) e-9) (TTImpC-45PartialEval-substLoc (cons e-8 arg-0) (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-1) (CoreC-45TT-u--weaken_Weaken_Term arg-2) e-10))))))) ((2) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (vector 2 e-12 e-13 e-14 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 eta-0)) e-15))))))) ((4) (let ((e-17 (vector-ref arg-3 1))) (let ((e-18 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 3))) (vector 4 e-17 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-18) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-19)))))) ((5) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (vector 5 e-21 e-22 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-23) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-24))))))) ((6) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (vector 6 e-26 e-27 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-28)))))) ((7) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (vector 7 e-30 e-31 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-32) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-33))))))) ((8) (let ((e-35 (vector-ref arg-3 1))) (let ((e-36 (vector-ref arg-3 2))) (let ((e-37 (vector-ref arg-3 3))) (vector 8 e-35 e-36 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-37))))))(else arg-3))))
(define TTImpC-45PartialEval-specialiseTy (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((sc2 (DataC-45List-lookup (csegen-792) arg-1 arg-2))) (if (null? sc2) (vector 3 e-1 e-2 (vector 2 e-6 e-7 (vector 1 ) e-9) (TTImpC-45PartialEval-specialiseTy (cons e-2 arg-0) (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-1) arg-2 e-4)) (let ((e-5 (unbox sc2))) (TTImpC-45PartialEval-specialiseTy arg-0 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-1) arg-2 (CoreC-45TTC-45SubstEnv-subst (CoreC-45TT-embed e-5) e-4)))))))))(else arg-3)))))))(else arg-3))))
(define TTImpC-45PartialEval-specialise (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (eta-0) (TTImpC-45PartialEval-case--specialise-11193 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-5 (vector-ref arg-7 5))) e-5) eta-0))))
(define TTImpC-45PartialEval-specPatByVar (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (TTImpC-45PartialEval-case--specPatByVar-8753 e-2 e-6 e-10 e-11 arg-0 (CoreC-45TT-getFnArgs e-10))))))))))
(define TTImpC-45PartialEval-specByVar (lambda (arg-0 arg-1) (if (null? arg-1) (PreludeC-45Types-u--pure_Applicative_Maybe '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-specPatByVar arg-0 e-2) (lambda (u--pC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-specByVar arg-0 e-3) (lambda (u--psC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons u--pC-39 u--psC-39)))))))))))
(define TTImpC-45PartialEval-quotePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-10 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-10 1))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5)))))))))))
(define TTImpC-45PartialEval-quoteHead (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-2 (vector-ref arg-11 1))) (let ((e-3 (vector-ref arg-11 2))) (lambda (eta-0) (vector 1 (vector 0 arg-8 e-2 (TTImpC-45PartialEval-n--13772-12017-u--addLater arg-1 e-3 e-2 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 e-3 arg-0))))))) ((1) (let ((e-6 (vector-ref arg-11 1))) (let ((e-7 (vector-ref arg-11 2))) (case (vector-ref e-6 0) ((0) (lambda (clam-0) (case (vector-ref e-7 0) ((2) (let ((e-12 (vector-ref e-7 1))) (let ((e-13 (vector-ref e-7 2))) (let ((sc3 (TTImpC-45PartialEval-n--13772-12159-u--findName arg-0 arg-1 e-13 e-12 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-9))) (if (null? sc3) (vector 1 (vector 1 arg-8 (vector 0 ) (vector 2 e-12 e-13))) (let ((e-1 (unbox sc3))) (vector 1 (vector 0 arg-8 '() e-1))))))))(else (vector 1 (vector 1 arg-8 e-6 e-7))))))(else (lambda (eta-0) (vector 1 (vector 1 arg-8 e-6 e-7)))))))) (else (let ((e-9 (vector-ref arg-11 1))) (let ((e-10 (vector-ref arg-11 2))) (let ((e-11 (vector-ref arg-11 3))) (lambda (eta-0) (let ((act-24 (TTImpC-45PartialEval-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-10 e-11 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 arg-8 e-9 e-10 e-5))))))))))))))
(define TTImpC-45PartialEval-quoteGenNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (let ((e-4 (vector-ref arg-10 4))) (lambda (eta-0) (let ((act-24 (TTImpC-45PartialEval-bName arg-6 "qv" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (((e-4 arg-7) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-9 (vector 1 e-1 (vector 0 ) e-5))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-quoteGenNF (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 1 e-2 e-5 arg-8) arg-9 e-6) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45PartialEval-quoteBinder arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 3 e-1 e-2 e-7 e-6)))))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((e-8 (vector-ref arg-10 3))) (lambda (clam-0) (case (vector-ref e-7 0) ((1) (let ((e-49 (vector-ref e-7 1))) (let ((e-50 (vector-ref e-7 2))) (case (vector-ref e-49 0) ((1) (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-50 (let ((e-0 (vector-ref arg-7 0))) e-0)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-0 arg-1 arg-6 arg-7 arg-8 arg-9 e-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 1 e-6 (vector 1 ) e-50) e-9)))))) (let ((e-1 (unbox e-5))) (let ((_-0 (box e-1))) (TTImpC-45PartialEval-case--caseC-32blockC-32inC-32quoteGenNF-12933 arg-0 arg-1 e-50 e-8 e-6 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 e-1 _-0 (let ((e-25 (vector-ref e-1 5))) e-25) clam-0)))))))))(else (let ((act-24 ((TTImpC-45PartialEval-quoteHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6 arg-8 arg-9 e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-0 arg-1 arg-6 arg-7 arg-8 arg-9 e-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC e-5 e-9)))))))))))))))(else (let ((act-24 ((TTImpC-45PartialEval-quoteHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6 arg-8 arg-9 e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-0 arg-1 arg-6 arg-7 arg-8 arg-9 e-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC e-5 e-9))))))))))))))))) ((2) (let ((e-10 (vector-ref arg-10 1))) (let ((e-11 (vector-ref arg-10 2))) (let ((e-12 (vector-ref arg-10 3))) (let ((e-13 (vector-ref arg-10 4))) (let ((e-14 (vector-ref arg-10 5))) (lambda (eta-0) (let ((act-24 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-0 arg-1 arg-6 arg-7 arg-8 arg-9 e-14 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 1 e-10 (vector 2 e-12 e-13) e-11) e-5))))))))))))) ((3) (let ((e-16 (vector-ref arg-10 1))) (let ((e-17 (vector-ref arg-10 2))) (let ((e-18 (vector-ref arg-10 3))) (let ((e-19 (vector-ref arg-10 4))) (let ((e-20 (vector-ref arg-10 5))) (lambda (eta-0) (let ((act-24 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-0 arg-1 arg-6 arg-7 arg-8 arg-9 e-20 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 1 e-16 (vector 3 e-18 e-19) e-17) e-5))))))))))))) ((4) (let ((e-22 (vector-ref arg-10 1))) (let ((e-23 (vector-ref arg-10 2))) (let ((e-24 (vector-ref arg-10 3))) (let ((e-25 (vector-ref arg-10 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-24) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-25) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-22 e-23 e-5 e-6)))))))))))))))) ((5) (let ((e-27 (vector-ref arg-10 1))) (let ((e-28 (vector-ref arg-10 2))) (let ((e-29 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-29) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-27 e-28 e-5))))))))))) ((6) (let ((e-31 (vector-ref arg-10 1))) (let ((e-32 (vector-ref arg-10 2))) (let ((e-33 (vector-ref arg-10 3))) (let ((e-34 (vector-ref arg-10 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-34) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-33) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 7 e-31 e-32 e-8 e-6)))))))))))))))))))))))) ((7) (let ((e-36 (vector-ref arg-10 1))) (let ((e-37 (vector-ref arg-10 2))) (let ((e-38 (vector-ref arg-10 3))) (let ((e-39 (vector-ref arg-10 4))) (lambda (eta-0) (let ((act-24 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-0 arg-1 arg-6 arg-7 arg-8 arg-9 e-39 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-38 0) ((6) (let ((e-4 (vector-ref e-38 4))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45TT-applyWithFC e-7 e-5))))))))))))(else (let ((act-25 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-38) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 8 e-36 e-37 e-6) e-5)))))))))))))))))) ((8) (let ((e-41 (vector-ref arg-10 1))) (let ((e-42 (vector-ref arg-10 2))) (lambda (eta-0) (vector 1 (vector 9 e-41 e-42)))))) ((9) (let ((e-44 (vector-ref arg-10 1))) (let ((e-45 (vector-ref arg-10 2))) (lambda (eta-0) (vector 1 (vector 10 e-44 e-45)))))) (else (let ((e-47 (vector-ref arg-10 1))) (lambda (eta-0) (vector 1 (vector 11 e-47))))))))
(define TTImpC-45PartialEval-quoteBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (let ((e-4 (vector-ref arg-10 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45PartialEval-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-6 e-5))))))))))))))) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((e-8 (vector-ref arg-10 3))) (let ((e-9 (vector-ref arg-10 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-9) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-10) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (vector 1 e-6 e-7 e-5 e-10))))))))))))))) ((2) (let ((e-11 (vector-ref arg-10 1))) (let ((e-12 (vector-ref arg-10 2))) (let ((e-13 (vector-ref arg-10 3))) (let ((e-14 (vector-ref arg-10 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-14) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45PartialEval-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-13 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-11 e-12 e-6 e-5))))))))))))))) ((3) (let ((e-16 (vector-ref arg-10 1))) (let ((e-17 (vector-ref arg-10 2))) (let ((e-18 (vector-ref arg-10 3))) (let ((e-19 (vector-ref arg-10 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-19) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45PartialEval-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-18 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-16 e-17 e-6 e-5))))))))))))))) ((4) (let ((e-21 (vector-ref arg-10 1))) (let ((e-22 (vector-ref arg-10 2))) (let ((e-23 (vector-ref arg-10 3))) (let ((e-24 (vector-ref arg-10 4))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-23) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-24) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-21 e-22 e-5 e-6))))))))))))))) (else (let ((e-26 (vector-ref arg-10 1))) (let ((e-27 (vector-ref arg-10 2))) (let ((e-28 (vector-ref arg-10 3))) (let ((act-24 (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-28) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-26 e-27 e-5)))))))))))))
(define TTImpC-45PartialEval-quoteArgsWithFC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (TTImpC-45PartialEval-quoteArgs arg-4 arg-5 arg-0 arg-1 arg-2 arg-3 arg-6 arg-7 arg-8 arg-9 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-10) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (DataC-45List-u--zip_Zippable_List (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-10) e-5))))))))
(define TTImpC-45PartialEval-quoteArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (if (null? arg-10) (vector 1 '()) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-7 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45PartialEval-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cons e-6 e-7)))))))))))))))))))
(define TTImpC-45PartialEval-mkSubsts (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) (box '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-mkSubsts (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-1) arg-2 e-3 arg-4) (lambda (u--subs) (let ((sc1 (DataC-45List-lookup (csegen-792) arg-1 arg-2))) (if (null? sc1) (box u--subs) (let ((e-4 (unbox sc1))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 3))) (box (cons (cons e-5 (CoreC-45TT-embed e-4)) u--subs)))) ((5) (let ((e-9 (vector-ref e-2 3))) (let ((e-10 (vector-ref e-2 4))) (case (vector-ref e-9 0) ((0) (let ((e-21 (vector-ref e-9 3))) (case (vector-ref e-10 0) ((0) (let ((e-27 (vector-ref e-10 3))) (box (cons (cons e-21 (CoreC-45TT-embed e-4)) (cons (cons e-27 (CoreC-45TT-embed e-4)) u--subs)))))(else (case (vector-ref e-10 0) ((0) (let ((e-15 (vector-ref e-10 3))) (box (cons (cons e-15 (CoreC-45TT-embed e-4)) u--subs))))(else '()))))))(else (case (vector-ref e-10 0) ((0) (let ((e-15 (vector-ref e-10 3))) (box (cons (cons e-15 (CoreC-45TT-embed e-4)) u--subs))))(else '())))))))(else '()))))))))))))
(define TTImpC-45PartialEval-mkSpecDef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (CoreC-45UnifyState-handleUnify arg-1 arg-3 (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setAllPublic arg-1 1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--staticargs (DataC-45List-mapMaybe (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (if (null? e-3) '() (let ((e-0 (unbox e-3))) (box (cons e-2 e-0))))))) arg-8))) (let ((u--peapp (CoreC-45TT-applyWithFC (vector 1 arg-5 (vector 1 ) arg-7) (TTImpC-45PartialEval-dropSpec 0 u--staticargs arg-10)))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact arg-7 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (let ((act-27 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "specialise" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-46) arg-9 eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-28 (if (null? e-3) (vector 1 '()) (let ((e-0 (unbox e-3))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-0 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (box e-9)))))))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-775) (cons (lambda (u--x) (TTImpC-45PartialEval-u--show_Show_ArgMode u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45PartialEval-u--showPrec_Show_ArgMode u--d u--x))))) (cons e-2 e-9))))))))))) arg-8 '() eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Specialising " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-8) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-9) (PreludeC-45TypesC-45String-C-43C-43 ") by " (CoreC-45NameC-45Namespace-showSep ", " e-9)))))))))))))))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((u--sty (TTImpC-45PartialEval-specialiseTy '() 0 u--staticargs (let ((e-2 (vector-ref arg-6 2))) e-2)))) (let ((act-28 (CoreC-45Normalise-logTermNF '() arg-1 "specialise" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Specialised type " (CoreC-45Name-u--show_Show_Name arg-7))) '() u--sty eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45Context-addDef arg-1 arg-7 (CoreC-45Context-newDef arg-5 arg-7 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) '() u--sty 2 (vector 0 )) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Context-addToSave arg-1 (vector 8 e-10) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((u--specnames (TTImpC-45PartialEval-n--11174-9554-u--getAllRefs arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (LibrariesC-45DataC-45NameMap-empty) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-8)))) (let ((act-31 (CoreC-45Core-traverseC-39 (lambda (u--n) (lambda (eta-1) (vector 1 (cons u--n (+ 1 0))))) (LibrariesC-45DataC-45NameMap-keys u--specnames) '() eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (unbox arg-1))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 ((TTImpC-45PartialEval-getReducible (cons arg-9 '()) (LibrariesC-45DataC-45NameMap-empty) e-13) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Context-setFlag arg-1 arg-5 (vector 8 e-10) (vector 7 (PreludeC-45TypesC-45List-tailRecAppend e-12 (LibrariesC-45DataC-45NameMap-toList e-14))) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((_-0 '())) (TTImpC-45PartialEval-case--caseC-32blockC-32inC-32mkSpecDef-10034 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 u--staticargs u--peapp _-0 u--sty e-10 u--specnames e-12 e-13 e-14 (let ((e-17 (vector-ref arg-6 17))) e-17) eta-0)))))))))))))))))))))))))))))))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "specialise" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Already specialised " (CoreC-45Name-u--show_Show_Name arg-7))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (vector 1 u--peapp))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-1 (csegen-46) arg-9 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-1 "specialise" (+ 1 0) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Partial evaluation of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " failed" (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (CoreC-45Core-u--show_Show_Error u--err)))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-32 (vector-ref e-6 5))) (let ((e-31 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 (LibrariesC-45DataC-45NameMap-insert arg-7 0 e-26) e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45TT-applyWithFC (vector 1 arg-5 (vector 1 ) arg-9) arg-10)))))))))))))) ext-0)))
(define TTImpC-45PartialEval-getStatic (lambda (arg-0) (if (null? arg-0) '() (let ((e-0 (unbox arg-0))) (box e-0)))))
(define TTImpC-45PartialEval-getSpecPats (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((sc0 (TTImpC-45PartialEval-specByVar arg-8 arg-9))) (if (null? sc0) (let ((u--dynnames (TTImpC-45PartialEval-n--10524-8935-u--mkDynNames arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 0 arg-7))) (let ((u--lhs (TTImpC-45TTImp-apply (vector 0 arg-2 arg-3) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 17 arg-2 eta-0)) u--dynnames)))) (lambda (eta-0) (let ((act-24 ((TTImpC-45PartialEval-n--10524-8936-u--mkRHSargs arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-6 (vector 0 arg-2 arg-4) u--dynnames arg-7) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (cons (vector 0 arg-2 u--lhs e-5) '())))))))))) (let ((e-2 (unbox sc0))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45PartialEval-n--10524-8940-u--unelabPat arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3 eta-1)) e-2 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box e-5))))))))))))
(define TTImpC-45PartialEval-getReducible (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (vector 1 arg-1)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-1))) (if (null? sc1) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-2 0))) e-0)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) ((TTImpC-45PartialEval-getReducible e-3 arg-1 arg-2) eta-0) (let ((e-4 (unbox e-5))) (let ((u--refsC-39 (LibrariesC-45DataC-45NameMap-insert e-2 (PreludeC-45Types-u--fromInteger_Num_Nat 65536) arg-1))) (let ((u--calls (CoreC-45ContextC-45Context-refersTo e-4))) ((TTImpC-45PartialEval-getReducible (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45NameMap-keys u--calls) e-3) u--refsC-39 arg-2) eta-0)))))))))) (TTImpC-45PartialEval-getReducible e-3 arg-1 arg-2))))))))
(define TTImpC-45PartialEval-findSpecs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-7 0) ((1) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (case (vector-ref e-2 0) ((1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-3 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (CoreC-45TT-applyWithFC (vector 1 e-1 (vector 1 ) e-3) arg-6)) (let ((e-4 (unbox e-6))) (let ((act-26 ((TTImpC-45PartialEval-specialise arg-0 arg-1 arg-2 arg-3 arg-4 e-1 arg-5 e-4 e-3 arg-6) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 (CoreC-45TT-applyWithFC (vector 1 e-1 (vector 1 ) e-3) arg-6)) (let ((e-8 (unbox e-7))) (vector 1 e-8))))))))))))))))))(else (vector 1 (CoreC-45TT-applyWithFC arg-7 arg-6)))))))) ((2) (let ((e-5 (vector-ref arg-7 1))) (let ((e-6 (vector-ref arg-7 2))) (let ((e-7 (vector-ref arg-7 3))) (let ((e-8 (vector-ref arg-7 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-0)) e-8 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 2 e-5 e-6 e-7 e-9) arg-6))))))))))) ((3) (let ((e-10 (vector-ref arg-7 1))) (let ((e-11 (vector-ref arg-7 2))) (let ((e-12 (vector-ref arg-7 3))) (let ((e-13 (vector-ref arg-7 4))) (let ((act-24 (CoreC-45CoreC-45Binder-traverse (lambda (eta-0) (TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-0)) e-12 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45PartialEval-findSpecs (cons e-11 arg-0) arg-1 arg-2 arg-3 arg-4 (cons e-5 arg-5) '() e-13) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 3 e-10 e-11 e-5 e-6) arg-6))))))))))))))) ((4) (let ((e-15 (vector-ref arg-7 1))) (let ((e-16 (vector-ref arg-7 2))) (let ((e-17 (vector-ref arg-7 3))) (let ((act-24 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-17) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons (cons e-15 e-5) arg-6) e-16) clam-0))))))))) ((6) (let ((e-19 (vector-ref arg-7 1))) (let ((e-20 (vector-ref arg-7 2))) (let ((e-21 (vector-ref arg-7 3))) (let ((act-24 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-21) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 6 e-19 e-20 e-5) arg-6)))))))))) ((7) (let ((e-23 (vector-ref arg-7 1))) (let ((e-24 (vector-ref arg-7 2))) (let ((e-25 (vector-ref arg-7 3))) (let ((e-26 (vector-ref arg-7 4))) (let ((act-24 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-25) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-26) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 7 e-23 e-24 e-5 e-6) arg-6))))))))))))))) ((8) (let ((e-28 (vector-ref arg-7 1))) (let ((e-29 (vector-ref arg-7 2))) (let ((e-30 (vector-ref arg-7 3))) (let ((act-24 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-30) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-applyWithFC (vector 8 e-28 e-29 e-5) arg-6))))))))))(else (vector 1 (CoreC-45TT-applyWithFC arg-7 arg-6)))))))
(define TTImpC-45PartialEval-evalRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) (blodwen-toSignedInt 0 63) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45PartialEval-quoteGenNF '() arg-0 arg-1 arg-2 arg-3 arg-4 e-5 e-6 (vector 0 ) arg-5 arg-6) ext-0)))))))))))
(define TTImpC-45PartialEval-eraseInferred (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CoreC-45CoreC-45Binder-traverse (lambda (eta-1) (TTImpC-45PartialEval-eraseInferred arg-1 eta-1)) e-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45PartialEval-eraseInferred arg-1 e-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-1 e-2 e-5 e-6))))))))))))))))(else (TTImpC-45PartialEval-case--eraseInferred-10714 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-2))))))
(define TTImpC-45PartialEval-dropSpec (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (DataC-45List-lookup (csegen-792) arg-1 arg-2))) (if (null? sc1) (cons e-2 (TTImpC-45PartialEval-dropSpec (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-1) arg-2 e-3)) (TTImpC-45PartialEval-dropSpec (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-1) arg-2 e-3))))))))
(define TTImpC-45PartialEval-bName (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))))))
(define TTImpC-45PartialEval-applySpecialise (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) (TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-7) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toResolvedNames arg-1 (csegen-76) arg-7 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 e-6) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45PartialEval-evalRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-8 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Normalise-logTermNF arg-0 arg-1 "specialise" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "New RHS") arg-5 e-9 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (vector 1 e-9))))))))))))))))))))))))))))
(define TTImpC-45Impossible-n--6842-2480-u--sameRet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (lambda (eta-0) (vector 1 1))) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-5 0) ((1) (lambda (eta-0) (vector 1 1))) ((9) (lambda (eta-0) (vector 1 1))) ((3) (let ((e-19 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((3) (let ((e-30 (vector-ref arg-6 2))) (lambda (eta-0) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-19 e-30)))))(else (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((TTImpC-45Impossible-n--6842-2480-u--sameRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10) clam-0))))))))))(else (vector 1 0)))))))(else (vector 1 0)))))))) ((8) (let ((e-25 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((8) (let ((e-36 (vector-ref arg-6 2))) (lambda (eta-0) (vector 1 (CoreC-45TT-u--C-61C-61_Eq_Constant e-25 e-36)))))(else (lambda (clam-1) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((TTImpC-45Impossible-n--6842-2480-u--sameRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10) clam-1))))))))))(else (vector 1 0)))))))(else (vector 1 0)))))))) ((10) (case (vector-ref arg-6 0) ((10) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-2) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((TTImpC-45Impossible-n--6842-2480-u--sameRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10) clam-2))))))))))(else (vector 1 0)))))))(else (vector 1 0)))))))(else (lambda (clam-3) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((TTImpC-45Impossible-n--6842-2480-u--sameRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10) clam-3))))))))))(else (vector 1 0)))))))(else (vector 1 0))))))))))
(define TTImpC-45Impossible-n--8182-3705-u--expandNest (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((sc1 (DataC-45List-lookup (csegen-802) e-2 arg-2))) (if (null? sc1) (vector 0 e-1 e-2) (let ((e-3 (unbox sc1))) (if (null? e-3) (vector 0 e-1 e-2) (let ((e-4 (car e-3))) (let ((e-5 (cdr e-3))) (if (null? e-4) (vector 0 e-1 e-2) (let ((e-7 (unbox e-4))) (if (null? e-5) (vector 0 e-1 e-2) (vector 0 e-1 e-7)))))))))))))(else arg-5))))
(define TTImpC-45Impossible-n--8182-3706-u--applyEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((8) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (vector 8 e-1 (TTImpC-45Impossible-n--8182-3706-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-2) e-3))))) ((9) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (vector 9 e-5 (TTImpC-45Impossible-n--8182-3706-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-6) e-7))))) ((10) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (let ((e-12 (vector-ref arg-5 4))) (vector 10 e-9 (TTImpC-45Impossible-n--8182-3706-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-10) e-11 e-12))))))(else (TTImpC-45TTImp-apply (TTImpC-45Impossible-n--8182-3705-u--expandNest arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (TTImpC-45Impossible-n--8182-3704-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-0 (TTImpC-45TTImp-getFC arg-5) arg-3))))))
(define TTImpC-45Impossible-n--8182-3704-u--addEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-5) '() (let ((e-3 (cdr arg-5))) (let ((e-8 (car arg-7))) (let ((e-9 (cdr arg-7))) (let ((sc2 (CoreC-45TT-isLet e-8))) (cond ((equal? sc2 1) (TTImpC-45Impossible-n--8182-3704-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 e-9)) (else (cons (vector 32 arg-6 0) (TTImpC-45Impossible-n--8182-3704-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 e-9)))))))))))
(define TTImpC-45Impossible-processArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (case (vector-ref e-6 0) ((2) (let ((e-11 (vector-ref e-6 3))) (let ((e-12 (vector-ref e-6 4))) (case (vector-ref e-11 0) ((1) (if (null? arg-4) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-5 arg-6))) (if (null? sc5) (TTImpC-45Impossible-badClause arg-2 '() arg-5 arg-6 eta-0) (let ((e-1 (unbox sc5))) (let ((e-14 (car e-1))) (let ((e-13 (cdr e-1))) (let ((e-15 (cdr e-14))) (let ((act-25 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-15 (box e-12) '() '() '()) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-25 1))) (let ((act-26 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() e-17)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-26 1))) ((TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-17) e-18 '() arg-5 e-13) eta-0)))))))))))))))))))) (let ((e-17 (car arg-4))) (let ((e-18 (cdr arg-4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-17 (box e-12) '() '() '()) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-25 1))) (let ((act-26 (((e-7 e-13) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() e-8)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-26 1))) ((TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-8) e-14 e-18 arg-5 arg-6) eta-0)))))))))))))))))) ((0) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (let ((sc4 (TTImpC-45ElabC-45App-findNamed e-5 arg-6))) (if (null? sc4) (let ((act-25 (TTImpC-45Impossible-nextVar arg-1 e-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-25 1))) (let ((act-26 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() e-13)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-26 1))) ((TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-13) e-14 arg-4 arg-5 arg-6) eta-0))))))))) (let ((e-2 (unbox sc4))) (let ((e-14 (car e-2))) (let ((e-13 (cdr e-2))) (let ((e-15 (cdr e-14))) (let ((act-25 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-15 (box e-12) '() '() '()) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-17 (vector-ref act-25 1))) (let ((act-26 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() e-17)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-18 (vector-ref act-26 1))) ((TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-17) e-18 arg-4 arg-5 e-13) eta-0))))))))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (if (null? arg-5) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-5 arg-6))) (if (null? sc5) (let ((act-25 (TTImpC-45Impossible-nextVar arg-1 e-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-25 1))) (let ((act-26 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() e-13)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-26 1))) ((TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-13) e-14 arg-4 '() arg-6) eta-0))))))))) (let ((e-2 (unbox sc5))) (let ((e-14 (car e-2))) (let ((e-13 (cdr e-2))) (let ((e-15 (cdr e-14))) (let ((act-25 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-15 (box e-12) '() '() '()) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-17 (vector-ref act-25 1))) (let ((act-26 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() e-17)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-18 (vector-ref act-26 1))) ((TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-17) e-18 arg-4 '() e-13) eta-0))))))))))))))) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((act-25 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-1 (box e-12) '() '() '()) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-25 1))) (let ((act-26 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() e-13)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-26 1))) ((TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-13) e-14 arg-4 e-2 arg-6) eta-0))))))))))))))))))(else (if (null? arg-4) (if (null? arg-5) (lambda (clam-1) (if (null? arg-6) (vector 1 arg-2) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 clam-1))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))))))))(else (if (null? arg-4) (if (null? arg-5) (lambda (clam-2) (if (null? arg-6) (vector 1 arg-2) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 clam-2))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))))))))))(else (if (null? arg-4) (if (null? arg-5) (lambda (clam-3) (if (null? arg-6) (vector 1 arg-2) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 clam-3))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0)))))))
(define TTImpC-45Impossible-nextVar (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 1 arg-1 (vector 0 ) (vector 2 "imp" e-5))))))))))))
(define TTImpC-45Impossible-mkTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (lambda (eta-0) (TTImpC-45Impossible-buildApp arg-0 arg-1 e-1 e-2 arg-3 arg-4 arg-5 arg-6 eta-0))))) ((8) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (TTImpC-45Impossible-mkTerm arg-0 arg-1 e-5 arg-3 (cons e-6 arg-4) arg-5 arg-6)))) ((9) (let ((e-9 (vector-ref arg-2 2))) (let ((e-10 (vector-ref arg-2 3))) (TTImpC-45Impossible-mkTerm arg-0 arg-1 e-9 arg-3 arg-4 (cons e-10 arg-5) arg-6)))) ((10) (let ((e-13 (vector-ref arg-2 2))) (let ((e-14 (vector-ref arg-2 3))) (let ((e-15 (vector-ref arg-2 4))) (TTImpC-45Impossible-mkTerm arg-0 arg-1 e-13 arg-3 arg-4 arg-5 (cons (cons e-14 e-15) arg-6)))))) ((28) (let ((e-17 (vector-ref arg-2 1))) (let ((e-18 (vector-ref arg-2 2))) (lambda (eta-0) (vector 1 (vector 9 e-17 e-18))))))(else (lambda (eta-0) (TTImpC-45Impossible-nextVar arg-1 (TTImpC-45TTImp-getFC arg-2) eta-0))))))
(define TTImpC-45Impossible-match (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() e-7) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) ((TTImpC-45Impossible-n--6842-2480-u--sameRet e-2 e-6 e-7 arg-1 arg-0 arg-1 e-8) clam-0))))))))))))))))
(define TTImpC-45Impossible-getImpossibleTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45Impossible-mkTerm arg-1 e-5 (TTImpC-45Impossible-n--8182-3706-u--applyEnv arg-0 arg-4 arg-3 arg-2 arg-1 arg-4) '() '() '() '()) ext-0)))))))
(define TTImpC-45Impossible-dropNoMatch (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (clam-1) (if (null? arg-1) (vector 1 arg-2) (let ((e-2 (unbox arg-1))) (CoreC-45Core-filterM (lambda (eta-0) (TTImpC-45Impossible-match arg-0 e-2 (let ((e-4 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-4 (let ((e-6 (car e-3))) (let ((e-5 (cdr e-3))) (cons e-6 (let ((e-26 (vector-ref e-5 2))) e-26))))))))) arg-2 clam-1)))) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (lambda (clam-0) (if (null? e-5) (vector 1 (cons e-4 '())) (if (null? arg-1) (vector 1 arg-2) (let ((e-2 (unbox arg-1))) (CoreC-45Core-filterM (lambda (eta-0) (TTImpC-45Impossible-match arg-0 e-2 (let ((e-6 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-6 (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-8 (let ((e-28 (vector-ref e-7 2))) e-28))))))))) arg-2 clam-0))))))))))
(define TTImpC-45Impossible-buildApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getPrimitiveNames arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((sc2 (PreludeC-45Types-elem (csegen-802) arg-3 e-6))) (cond ((equal? sc2 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't deal with constants here yet") ext-0)) (else (vector 1 0)))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-lookupNameBy (lambda (eta-0) eta-0) arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (if (null? arg-4) (vector 1 '()) (let ((e-2 (unbox arg-4))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-2) ext-0))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) ((TTImpC-45Impossible-dropNoMatch arg-0 e-9 e-8) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (if (null? e-9) (CoreC-45Context-undefinedName arg-0 arg-2 arg-3 ext-0) (let ((e-1 (car e-9))) (let ((e-2 (cdr e-9))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-9)) ext-0) (let ((e-10 (cdr e-1))) (if (null? e-10) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-9)) ext-0) (let ((e-13 (car e-10))) (let ((e-12 (cdr e-10))) (if (null? e-2) (let ((act-29 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-31 (vector-ref e-12 2))) e-31)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-29 1))) (let ((u--head (let ((e-17 (vector-ref e-12 17))) (case (vector-ref e-17 0) ((5) (let ((e-36 (vector-ref e-17 1))) (let ((e-35 (vector-ref e-17 2))) (vector 2 e-36 e-35)))) ((6) (let ((e-41 (vector-ref e-17 1))) (let ((e-40 (vector-ref e-17 2))) (vector 3 e-41 e-40))))(else (vector 1 )))))) ((TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 1 arg-2 u--head (vector 8 e-13)) e-14 arg-5 arg-6 arg-7) ext-0)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-9)) ext-0)))))))))))))))))))))))))))))))
(define TTImpC-45Impossible-badClause (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45TT-getLoc arg-1) (PreludeC-45TypesC-45String-C-43C-43 "Badly formed impossible clause " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-1276) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2224) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2224) u--d u--x))))) (cons arg-1 (cons arg-2 (cons arg-3 arg-4)))))) ext-0)))
(define CoreC-45Transform-case--trans-8872 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 (CoreC-45Transform-unload arg-3 (vector 1 arg-2 (vector 1 ) arg-1)))) (let ((e-2 (unbox arg-8))) (let ((u--fullapp (CoreC-45Transform-unload arg-3 (vector 1 arg-2 (vector 1 ) arg-1)))) (lambda (clam-0) (let ((sc1 (CoreC-45Transform-apply e-2 u--fullapp))) (let ((e-4 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-24 (let ((act-24 (unbox arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-5 (cond ((equal? e-5 1) 1) (else e-4))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (vector 1 e-3)))))))))))))))))
(define CoreC-45Transform-case--addMatch-8339 (lambda (arg-3 arg-4 arg-5 arg-7) (if (null? arg-7) (box (vector 1 arg-5 arg-4 arg-3)) (let ((e-2 (unbox arg-7))) (let ((sc1 (CoreC-45TT-eqTerm arg-4 e-2))) (cond ((equal? sc1 1) (box arg-3)) (else '())))))))
(define CoreC-45Transform-unload (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45Transform-unload e-3 (vector 4 e-6 arg-2 e-7)))))))))
(define CoreC-45Transform-tryReplace (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 3))) (CoreC-45Transform-lookupMatch e-4 arg-2))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 e-7 e-8 e-9)))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List (csegen-271) (lambda (eta-0) (CoreC-45Transform-tryReplace arg-2 eta-0)) e-14) (lambda (u--asC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 e-11 e-12 e-13 u--asC-39))))))))) ((3) '()) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-22) (lambda (u--fC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-23) (lambda (u--aC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 e-21 u--fC-39 u--aC-39)))))))))) ((5) (let ((e-25 (vector-ref arg-3 1))) (let ((e-26 (vector-ref arg-3 2))) (let ((e-27 (vector-ref arg-3 3))) (let ((e-28 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-27) (lambda (u--aC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-28) (lambda (u--pC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 e-25 e-26 u--aC-39 u--pC-39))))))))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-32) (lambda (u--tmC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 e-30 e-31 u--tmC-39)))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-36) (lambda (u--tyC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-37) (lambda (u--tmC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 e-34 e-35 u--tyC-39 u--tmC-39))))))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (let ((e-41 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-41) (lambda (u--tmC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 e-39 e-40 u--tmC-39)))))))) ((9) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 9 e-43 e-44))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 10 e-46 e-47))))) (else (let ((e-49 (vector-ref arg-3 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 11 e-49)))))))
(define CoreC-45Transform-tryApply (lambda (arg-1 arg-2) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((u--trans (vector e-0 e-1 e-2 e-3 e-4))) (let ((sc0 (CoreC-45Transform-match (vector 0 ) e-3 arg-2))) (if (null? sc0) (case (vector-ref arg-2 0) ((4) (let ((e-7 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-5 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryApply u--trans e-6) (lambda (u--fC-39) (box (vector 4 e-7 u--fC-39 e-5))))))))(else '())) (let ((e-5 (unbox sc0))) (CoreC-45Transform-tryReplace e-5 e-4))))))))))))
(define CoreC-45Transform-transLoop (lambda (arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-2 0) (lambda (eta-0) (vector 1 arg-4)))(else (let ((e-0 (- arg-2 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Transform.Upd" ) 0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Transform-trans arg-1 e-5 arg-3 '() arg-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) ((CoreC-45Transform-transLoop arg-1 e-0 arg-3 e-6) eta-0)) (else (vector 1 e-6)))))))))))))))))))))
(define CoreC-45Transform-trans (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (case (vector-ref e-2 0) ((1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Transform-case--trans-8872 e-3 e-1 arg-4 arg-3 arg-2 arg-1 e-5 (LibrariesC-45DataC-45NameMap-lookup e-3 (let ((e-13 (vector-ref e-5 13))) e-13))) clam-0))))))(else (vector 1 (CoreC-45Transform-unload arg-4 arg-5)))))))) ((2) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Transform-trans arg-1 arg-2 arg-3 '() eta-0)) e-8 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (vector 1 (CoreC-45Transform-unload arg-4 (vector 2 e-5 e-6 e-7 e-9)))))))))))) ((3) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (let ((e-13 (vector-ref arg-5 4))) (let ((act-24 (CoreC-45CoreC-45Binder-traverse (lambda (eta-0) (CoreC-45Transform-trans arg-1 arg-2 arg-3 '() eta-0)) e-12 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Transform-trans arg-1 arg-2 (cons e-5 arg-3) '() e-13) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45Transform-unload arg-4 (vector 3 e-10 e-11 e-5 e-6)))))))))))))))) ((4) (let ((e-15 (vector-ref arg-5 1))) (let ((e-16 (vector-ref arg-5 2))) (let ((e-17 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-17) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Transform-trans arg-1 arg-2 arg-3 (cons (cons e-15 e-5) arg-4) e-16) clam-0))))))))) ((6) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-21) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45Transform-unload arg-4 (vector 6 e-19 e-20 e-5))))))))))) ((7) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((act-24 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-25) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-26) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CoreC-45Transform-unload arg-4 (vector 7 e-23 e-24 e-5 e-6)))))))))))))))) ((8) (let ((e-28 (vector-ref arg-5 1))) (let ((e-29 (vector-ref arg-5 2))) (let ((e-30 (vector-ref arg-5 3))) (let ((act-24 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-30) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45Transform-unload arg-4 (vector 8 e-28 e-29 e-5)))))))))))(else (vector 1 (CoreC-45Transform-unload arg-4 arg-5)))))))
(define CoreC-45Transform-match (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 3))) (CoreC-45Transform-addMatch e-4 arg-4 arg-2))) ((4) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((4) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-match arg-2 e-8 e-12) (lambda (u--msC-39) (CoreC-45Transform-match u--msC-39 e-9 e-13))))))(else (let ((sc1 (CoreC-45TT-eqTerm arg-3 arg-4))) (cond ((equal? sc1 1) (box arg-2)) (else '()))))))))(else (let ((sc0 (CoreC-45TT-eqTerm arg-3 arg-4))) (cond ((equal? sc0 1) (box arg-2)) (else '())))))))
(define CoreC-45Transform-lookupMatch (lambda (arg-3 arg-5) (case (vector-ref arg-5 0) ((0) '()) (else (let ((e-5 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-3 e-5))) (cond ((equal? sc1 1) (box e-7)) (else (CoreC-45Transform-lookupMatch arg-3 e-8)))))))))))
(define CoreC-45Transform-applyTransforms (lambda (arg-1 arg-2 arg-3) (CoreC-45Transform-transLoop arg-1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) arg-2 arg-3)))
(define CoreC-45Transform-apply (lambda (arg-1 arg-2) (if (null? arg-1) (cons 0 arg-2) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (CoreC-45Transform-tryApply e-2 arg-2))) (if (null? sc1) (CoreC-45Transform-apply e-3 arg-2) (let ((e-4 (unbox sc1))) (cons 1 e-4)))))))))
(define CoreC-45Transform-addMatch (lambda (arg-3 arg-5 arg-6) (CoreC-45Transform-case--addMatch-8339 arg-6 arg-5 arg-3 (CoreC-45Transform-lookupMatch arg-3 arg-6))))
(define CoreC-45Termination-case--caseC-32blockC-32inC-32checkTotal-10215 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref arg-7 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (csegen-881) e-5))) (if (null? sc2) (let ((act-25 (let ((sc3 (PreludeC-45Interfaces-C-61C-60C-60 (csegen-270) (csegen-2240) e-5))) (if (null? sc3) (vector 1 0) (let ((e-1 (unbox sc3))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-2 (csegen-46) eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys e-1) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-2 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "  Mutually defined with:" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-6))) ext-0)))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45Termination-checkTerminating arg-2 arg-1 arg-5 ext-0)))) (let ((e-1 (unbox sc2))) (case (vector-ref e-1 0) ((6) (CoreC-45Termination-checkPositive arg-2 arg-1 arg-5 ext-0))(else (let ((act-25 (let ((sc3 (PreludeC-45Interfaces-C-61C-60C-60 (csegen-270) (csegen-2240) e-5))) (if (null? sc3) (vector 1 0) (let ((e-2 (unbox sc3))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-2 (csegen-46) eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys e-2) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-2 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "  Mutually defined with:" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-6))) ext-0)))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45Termination-checkTerminating arg-2 arg-1 arg-5 ext-0))))))))))))))(else (vector 1 arg-8)))))
(define CoreC-45Termination-case--checkTotal-10161 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45Context-undefinedName arg-2 arg-1 arg-0 eta-0)) (let ((e-1 (unbox arg-4))) (let ((u--n (vector 8 e-1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getTotality arg-2 arg-1 u--n eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-2 (csegen-46) u--n eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-2 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking totality: " (CoreC-45Name-u--show_Show_Name e-6))) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (unbox arg-2))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Termination-case--caseC-32blockC-32inC-32checkTotal-10215 arg-0 arg-1 arg-2 arg-3 e-1 u--n e-5 e-7 (let ((e-0 (car e-5))) e-0) eta-0))))))))))))))))))
(define CoreC-45Termination-case--checkPositive-10084 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((act-24 (CoreC-45Termination-calcPositive arg-2 arg-1 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Context-setTerminating arg-2 arg-1 arg-3 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CoreC-45Core-traverse_ (lambda (u--c) (lambda (eta-0) (CoreC-45Context-setTerminating arg-2 arg-1 u--c e-2 eta-0))) e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))))))))(else (vector 1 arg-5)))))
(define CoreC-45Termination-case--checkTerminating-8638 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((act-24 (CoreC-45Termination-calcTerminating arg-2 arg-1 arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setTerminating arg-2 arg-1 arg-0 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 e-5)))))))))(else (vector 1 arg-4)))))
(define CoreC-45Termination-case--asserted-5935 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((1) (let ((e-7 (vector-ref e-2 3))) (if (null? e-3) '() (let ((e-10 (cdr e-3))) (if (null? e-10) '() (let ((e-13 (cdr e-10))) (if (null? e-13) '() (let ((e-15 (car e-13))) (let ((e-16 (cdr e-13))) (if (null? e-16) '() (let ((e-19 (cdr e-16))) (if (null? e-19) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-7 arg-2))) (cond ((equal? sc7 1) (box e-15)) (else '()))) '()))))))))))))(else '())))))))
(define CoreC-45Termination-case--smallerArg-5850 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (case (vector-ref arg-2 0) ((4) (let ((e-2 (vector-ref arg-2 2))) (lambda () (CoreC-45Termination-smaller arg-5 arg-4 arg-3 e-2 arg-1))))(else (lambda () 0))) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((2) (lambda () (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CoreC-45Termination-smaller 1 arg-4 arg-3 arg-2 eta-0)) e-3)))(else (case (vector-ref arg-2 0) ((4) (let ((e-8 (vector-ref arg-2 2))) (lambda () (CoreC-45Termination-smaller arg-5 arg-4 arg-3 e-8 arg-1))))(else (lambda () 0)))))))(else (case (vector-ref arg-2 0) ((4) (let ((e-5 (vector-ref arg-2 2))) (lambda () (CoreC-45Termination-smaller arg-5 arg-4 arg-3 e-5 arg-1))))(else (lambda () 0))))))))))
(define CoreC-45Termination-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32findSC-5305 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (cond ((equal? e-2 3) (if (null? e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-1) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-11 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) clam-1))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Lookup failed") clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 0 e-7 clam-1)))) (let ((e-1 (unbox e-8))) (let ((act-26 (CoreC-45Normalise-getArity arg-6 '() arg-5 '() e-1 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-26 1))) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-12 e-7 clam-1)))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))) (let ((e-14 (car e-3))) (let ((e-15 (cdr e-3))) (lambda (clam-0) (case (vector-ref e-14 0) ((1) (let ((e-18 (vector-ref e-14 2))) (case (vector-ref e-18 0) ((2) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 3 arg-2 eta-0)) e-15 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-15 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-15 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))) ((equal? e-2 2) (if (null? e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-4) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-11 clam-4))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) clam-4))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Lookup failed") clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 0 e-7 clam-4)))) (let ((e-1 (unbox e-8))) (let ((act-26 (CoreC-45Normalise-getArity arg-6 '() arg-5 '() e-1 clam-4))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-26 1))) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-12 e-7 clam-4)))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-4))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-4))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))) (let ((e-24 (car e-3))) (let ((e-25 (cdr e-3))) (case (vector-ref e-24 0) ((1) (let ((e-28 (vector-ref e-24 2))) (case (vector-ref e-28 0) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 2 arg-2 eta-1)) e-25 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-2) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-11 clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) clam-2))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Lookup failed") clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 0 e-7 clam-2)))) (let ((e-1 (unbox e-8))) (let ((act-26 (CoreC-45Normalise-getArity arg-6 '() arg-5 '() e-1 clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-26 1))) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-12 e-7 clam-2)))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))))))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-3) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-11 clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) clam-3))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Lookup failed") clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 0 e-7 clam-3)))) (let ((e-1 (unbox e-8))) (let ((act-26 (CoreC-45Normalise-getArity arg-6 '() arg-5 '() e-1 clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-26 1))) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-12 e-7 clam-3)))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))))))) ((equal? e-2 0) (if (null? e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-7) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-11 clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) clam-7))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-7))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Lookup failed") clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 0 e-7 clam-7)))) (let ((e-1 (unbox e-8))) (let ((act-26 (CoreC-45Normalise-getArity arg-6 '() arg-5 '() e-1 clam-7))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-26 1))) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-12 e-7 clam-7)))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-7))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))) (let ((e-34 (car e-3))) (let ((e-35 (cdr e-3))) (case (vector-ref e-34 0) ((1) (let ((e-38 (vector-ref e-34 2))) (case (vector-ref e-38 0) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 2 arg-2 eta-1)) e-35 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-5) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-11 clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) clam-5))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Lookup failed") clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 0 e-7 clam-5)))) (let ((e-1 (unbox e-8))) (let ((act-26 (CoreC-45Normalise-getArity arg-6 '() arg-5 '() e-1 clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-26 1))) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-12 e-7 clam-5)))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))))))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-6) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-11 clam-6))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) clam-6))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Lookup failed") clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 0 e-7 clam-6)))) (let ((e-1 (unbox e-8))) (let ((act-26 (CoreC-45Normalise-getArity arg-6 '() arg-5 '() e-1 clam-6))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-26 1))) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-12 e-7 clam-6)))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-6))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-6))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))))))))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-8) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-11 clam-8))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) clam-8))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-8))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (let ((act-26 (CoreC-45ContextC-45Log-log arg-6 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Lookup failed") clam-8))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 0 e-7 clam-8)))) (let ((e-1 (unbox e-8))) (let ((act-26 (CoreC-45Normalise-getArity arg-6 '() arg-5 '() e-1 clam-8))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-26 1))) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-12 e-7 clam-8)))))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-8))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '() clam-8))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))))))))))))
(define CoreC-45Termination-case--findSC-5242 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-24 (CoreC-45Termination-n--8269-5016-u--handleCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 ((CoreC-45Termination-n--8269-5017-u--conIfGuarded arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((_-0 '())) ((CoreC-45Termination-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32findSC-5305 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 e-3 _-0 e-6 (cons arg-3 (cons e-6 e-3))) ext-0)))))) (let ((e-4 (unbox e-5))) (vector 1 e-4)))))))))))
(define CoreC-45Termination-case--caseC-32blockC-32inC-32totRefs-3833 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((1) (lambda (eta-0) (vector 1 arg-4))) ((0) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-3 (csegen-46) arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-3 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Totality unchecked for " (CoreC-45Name-u--show_Show_Name e-5))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 arg-4))))))(else (lambda (clam-0) (case (vector-ref arg-4 0) ((2) (let ((e-0 (vector-ref arg-4 1))) (case (vector-ref e-0 0) ((1) (let ((e-1 (vector-ref e-0 1))) (CoreC-45Context-toFullNames arg-3 (csegen-2241) (vector 2 (vector 1 (cons arg-0 e-1))) clam-0)))(else (CoreC-45Context-toFullNames arg-3 (csegen-2241) (vector 2 (vector 1 (cons arg-0 '()))) clam-0)))))(else (CoreC-45Context-toFullNames arg-3 (csegen-2241) (vector 2 (vector 1 (cons arg-0 '()))) clam-0))))))))
(define CoreC-45Termination-n--9677-6113-u--urhs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-2 (vector-ref arg-10 1))) (vector 10 e-2 0))) ((1) (let ((e-7 (vector-ref arg-10 1))) (let ((e-8 (vector-ref arg-10 2))) (let ((e-9 (vector-ref arg-10 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-10 1))) (let ((e-12 (vector-ref arg-10 2))) (let ((e-13 (vector-ref arg-10 3))) (let ((e-14 (vector-ref arg-10 4))) (vector 2 e-11 e-12 e-13 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 eta-0)) e-14))))))) ((4) (let ((e-16 (vector-ref arg-10 1))) (let ((e-17 (vector-ref arg-10 2))) (let ((e-18 (vector-ref arg-10 3))) (vector 4 e-16 (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-17) (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-18)))))) ((5) (let ((e-20 (vector-ref arg-10 1))) (let ((e-21 (vector-ref arg-10 2))) (let ((e-22 (vector-ref arg-10 3))) (let ((e-23 (vector-ref arg-10 4))) (vector 5 e-20 e-21 (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-22) (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-23))))))) ((6) (let ((e-25 (vector-ref arg-10 1))) (let ((e-26 (vector-ref arg-10 2))) (let ((e-27 (vector-ref arg-10 3))) (vector 6 e-25 e-26 (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-27)))))) ((7) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (let ((e-31 (vector-ref arg-10 3))) (let ((e-32 (vector-ref arg-10 4))) (vector 7 e-29 e-30 (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-31) (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-32))))))) ((8) (let ((e-34 (vector-ref arg-10 1))) (let ((e-35 (vector-ref arg-10 2))) (let ((e-36 (vector-ref arg-10 3))) (vector 8 e-34 e-35 (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-36)))))) ((3) (let ((e-38 (vector-ref arg-10 1))) (let ((e-39 (vector-ref arg-10 2))) (let ((e-40 (vector-ref arg-10 3))) (let ((e-41 (vector-ref arg-10 4))) (vector 3 e-38 e-39 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 eta-0)) e-40) (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons e-39 arg-6) (cons e-39 arg-8) (PreludeC-45Types-u--map_Functor_List (lambda (u--vt) (cons (CoreC-45TT-u--weaken_Weaken_Term (Builtin-fst u--vt)) (CoreC-45TT-u--weaken_Weaken_Term (Builtin-snd u--vt)))) arg-9) e-41))))))) ((9) (let ((e-43 (vector-ref arg-10 1))) (let ((e-44 (vector-ref arg-10 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-10 1))) (let ((e-47 (vector-ref arg-10 2))) (vector 10 e-46 e-47)))) (else (let ((e-49 (vector-ref arg-10 1))) (vector 11 e-49))))))
(define CoreC-45Termination-n--8289-6105-u--updateRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((sc0 (CoreC-45Termination-n--9677-6114-u--lookupTm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-7 arg-8 arg-9 arg-8))) (if (null? sc0) (CoreC-45Termination-n--9677-6113-u--urhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-7 arg-8 arg-9) (let ((e-2 (unbox sc0))) e-2)))))
(define CoreC-45Termination-n--8289-6106-u--updatePat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (cons e-2 (CoreC-45Termination-n--8289-6105-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3))))))
(define CoreC-45Termination-n--11061-7366-u--updateArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (let ((e-14 (unbox arg-8))) (if (null? e-14) (cond ((equal? arg-7 2) (if (null? arg-8) (if (null? arg-8) arg-8 (let ((e-1 (unbox arg-8))) (if (null? e-1) arg-8 (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (cond ((equal? e-5 1) (box (cons e-4 arg-7)))(else arg-8))))))) (let ((e-7 (unbox arg-8))) (if (null? e-7) (if (null? arg-8) arg-8 (let ((e-1 (unbox arg-8))) (if (null? e-1) arg-8 (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (cond ((equal? e-5 1) (box (cons e-4 arg-7)))(else arg-8))))))) (let ((e-10 (car e-7))) (box (cons e-10 2)))))))(else (if (null? arg-8) arg-8 (let ((e-1 (unbox arg-8))) (if (null? e-1) arg-8 (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (cond ((equal? e-5 1) (box (cons e-4 arg-7)))(else arg-8))))))))) (let ((e-18 (cdr e-14))) (cond ((equal? e-18 2) arg-8)(else (cond ((equal? arg-7 2) (if (null? arg-8) (if (null? arg-8) arg-8 (let ((e-1 (unbox arg-8))) (if (null? e-1) arg-8 (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (cond ((equal? e-5 1) (box (cons e-4 arg-7)))(else arg-8))))))) (let ((e-7 (unbox arg-8))) (if (null? e-7) (if (null? arg-8) arg-8 (let ((e-1 (unbox arg-8))) (if (null? e-1) arg-8 (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (cond ((equal? e-5 1) (box (cons e-4 arg-7)))(else arg-8))))))) (let ((e-10 (car e-7))) (box (cons e-10 2)))))))(else (if (null? arg-8) arg-8 (let ((e-1 (unbox arg-8))) (if (null? e-1) arg-8 (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (cond ((equal? e-5 1) (box (cons e-4 arg-7)))(else arg-8)))))))))))))))))
(define CoreC-45Termination-n--12728-8968-u--splitParams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (cons '() '()) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((u--nf (vector 3 arg-4 arg-3 arg-0 arg-1 arg-2))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) arg-9 arg-10))) (cond ((equal? sc1 1) (let ((sc2 (CoreC-45Termination-n--12728-8968-u--splitParams arg-0 arg-1 arg-2 arg-3 arg-4 u--nf arg-6 arg-7 arg-8 (+ 1 arg-9) arg-10 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons (cons e-2 e-5) e-4))))) (else (let ((sc2 (CoreC-45Termination-n--12728-8968-u--splitParams arg-0 arg-1 arg-2 arg-3 arg-4 u--nf arg-6 arg-7 arg-8 (+ 1 arg-9) arg-10 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons e-5 (cons e-2 e-4))))))))))))))
(define CoreC-45Termination-n--11061-7367-u--mkArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) '() (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (if (null? e-2) (cons '() (CoreC-45Termination-n--11061-7367-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)) (let ((e-6 (unbox e-2))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (CoreC-45Termination-n--11061-7365-u--getPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-1 e-9))) (if (null? sc3) (cons '() (CoreC-45Termination-n--11061-7367-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)) (let ((e-4 (unbox sc3))) (cons (CoreC-45Termination-n--11061-7366-u--updateArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-10 e-4) (CoreC-45Termination-n--11061-7367-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))))))
(define CoreC-45Termination-n--8289-6107-u--matchArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--patMatch (PreludeC-45TypesC-45List-reverse (DataC-45List-u--zip_Zippable_List arg-1 (CoreC-45TT-getArgs e-10))))) (cons e-2 (cons e-6 (cons (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Termination-n--8289-6106-u--updatePat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-0 e-2 u--patMatch eta-0)) arg-2) e-11))))))))))))
(define CoreC-45Termination-n--9677-6114-u--lookupTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (case (vector-ref arg-10 0) ((5) (let ((e-13 (vector-ref arg-10 1))) (let ((e-14 (vector-ref arg-10 2))) (let ((e-16 (vector-ref arg-10 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Termination-n--9677-6114-u--lookupTm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-16 arg-11) (lambda (u--tmC-39) (box (vector 5 e-13 e-14 u--tmC-39 (CoreC-45Termination-n--9677-6113-u--urhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-16)))))))))(else (let ((e-1 (car arg-11))) (let ((e-2 (cdr arg-11))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (case (vector-ref e-5 0) ((5) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((e-10 (vector-ref e-5 3))) (let ((e-11 (vector-ref e-5 4))) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-10 e-10))) (cond ((equal? sc4 1) (box e-6)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Termination-n--9677-6114-u--lookupTm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (cons (cons e-11 e-6) e-2)) (lambda (u--tmC-39) (box (vector 5 e-8 e-9 (CoreC-45Termination-n--9677-6113-u--urhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-10) u--tmC-39))))))))))))(else (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-10 e-5))) (cond ((equal? sc3 1) (box e-6)) (else (CoreC-45Termination-n--9677-6114-u--lookupTm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2)))))))))))))))
(define CoreC-45Termination-n--8269-5016-u--handleCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-7 0) ((1) (let ((e-1 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 3))) (let ((act-24 (CoreC-45Context-toFullNames arg-6 (csegen-46) e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (CoreC-45Termination-caseFn e-5))) (cond ((equal? sc2 1) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (lambda (eta-0) (CoreC-45Termination-findSCcall arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-1 e-3 (+ 1 (+ 1 (+ 1 (+ 1 0)))) arg-8 eta-0)) ext-0)) (else (vector 1 '())))))))))))(else (vector 1 '())))))
(define CoreC-45Termination-n--7298-3992-u--guardedNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((2) (vector 1 1)) ((1) (let ((e-8 (vector-ref arg-6 2))) (case (vector-ref e-8 0) ((1) (let ((e-12 (vector-ref e-8 2))) (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-12 (let ((e-0 (vector-ref arg-4 0))) e-0)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (vector 1 (PreludeC-45Types-elem (csegen-1023) (vector 8 ) (let ((e-23 (vector-ref e-1 11))) e-23)))))))))))(else (vector 1 0)))))(else (vector 1 0))))))
(define CoreC-45Termination-n--7298-3994-u--guarded (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-2 arg-3 e-6 arg-4 arg-5) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Termination-n--7298-3992-u--guardedNF arg-0 arg-1 arg-2 arg-3 e-5 arg-4 e-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? e-8 1) (let ((act-28 ((CoreC-45Context-lookupCtxtExact arg-0 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (if (null? e-9) (vector 1 0) (let ((e-1 (unbox e-9))) (CoreC-45Core-allM (lambda (eta-0) (lambda (eta-1) (CoreC-45Termination-n--7298-3993-u--checkNotFn arg-0 arg-1 arg-2 e-5 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-1)) ext-0)))))))) (else (vector 1 0)))))))))))))))))))))
(define CoreC-45Termination-n--11061-7369-u--getWorst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) arg-7 (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-2 0) ((1) (CoreC-45Termination-n--11061-7369-u--getWorst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)) ((0) (CoreC-45Termination-n--11061-7369-u--getWorst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 0 ) e-3))(else e-2)))))))
(define CoreC-45Termination-n--11061-7365-u--getPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (cond ((equal? arg-9 0) (box e-2))(else (let ((e-4 (- arg-9 1))) (CoreC-45Termination-n--11061-7365-u--getPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-4)))))))))
(define CoreC-45Termination-n--8269-4911-u--findSCbinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((1) (let ((e-3 (vector-ref arg-10 3))) (CoreC-45Termination-findSC arg-1 arg-9 arg-8 arg-7 arg-6 arg-5 e-3)))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45Termination-n--11061-7370-u--continue (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Termination-n--11061-7368-u--checkCall arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 eta-0 eta-1))) arg-7 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45Termination-n--11061-7369-u--getWorst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 1 ) e-5))))))))
(define CoreC-45Termination-n--8269-5017-u--conIfGuarded (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-7 0) ((1) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (case (vector-ref e-2 0) ((1) (let ((act-24 (let ((act-24 (unbox arg-6))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-3 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 1 e-1 (vector 1 ) e-3)) (let ((e-4 (unbox e-6))) (let ((sc5 (PreludeC-45Types-elem (csegen-1023) (vector 8 ) (let ((e-11 (vector-ref e-4 11))) e-11)))) (cond ((equal? sc5 1) (vector 1 (vector 1 e-1 (vector 2 0 0) e-3))) (else (vector 1 (vector 1 e-1 (vector 1 ) e-3))))))))))))))))(else (vector 1 arg-7)))))))(else (vector 1 arg-7))))))
(define CoreC-45Termination-n--7298-3993-u--checkNotFn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-4 (let ((e-0 (vector-ref arg-3 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((5) (vector 1 1))(else (vector 1 (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega (let ((e-38 (vector-ref e-1 7))) e-38) (csegen-21)))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-elem (csegen-1023) (vector 8 ) (let ((e-34 (vector-ref e-1 11))) e-34)))))))))))))))))
(define CoreC-45Termination-n--11061-7364-u--checkDesc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) (vector 2 (vector 2 (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-8)))) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-2 0) (vector 1 ))(else (CoreC-45Termination-n--11061-7364-u--checkDesc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 arg-8))))))))
(define CoreC-45Termination-n--11061-7368-u--checkCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact (let ((e-0 (car arg-8))) e-0) (let ((e-0 (vector-ref arg-3 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 1 )) (let ((e-1 (unbox e-5))) (let ((e-10 (vector-ref e-1 10))) (let ((e-25 (car e-10))) (case (vector-ref e-25 0) ((0) (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-5 (csegen-46) (let ((e-27 (car arg-8))) e-27) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-26 (vector-ref act-25 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-5 "totality.termination.sizechange.checkCall" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "CheckCall Size Change Graph: " (CoreC-45Name-u--show_Show_Name e-26))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-26 (vector-ref act-25 1))) (vector 0 e-26))) (else (let ((act-26 (CoreC-45Termination-checkSC arg-6 arg-5 arg-4 arg-3 (let ((e-28 (car arg-8))) e-28) (CoreC-45Termination-n--11061-7367-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((e-27 (cdr arg-8))) e-27)) arg-7 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-27 (vector-ref act-26 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-26 1))) (let ((u--inpath (PreludeC-45Types-elem (csegen-802) (let ((e-29 (car arg-8))) e-29) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-7)))) (cond ((equal? u--inpath 1) (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-5 (csegen-46) (let ((e-29 (car arg-8))) e-29) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-28 (vector-ref act-27 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-5 "totality.termination.sizechange.checkCall.inPath" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Have Result: " (CoreC-45Name-u--show_Show_Name e-28))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-28 (vector-ref act-27 1))) (vector 0 e-28))) (else (vector 1 e-27))))) (else (case (vector-ref e-27 0) ((2) (let ((e-28 (vector-ref e-27 1))) (case (vector-ref e-28 0) ((2) (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-5 (csegen-46) (let ((e-31 (car arg-8))) e-31) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-30 (vector-ref act-27 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-5 "totality.termination.sizechange.checkCall.inPathNot.restart" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "ReChecking Size Change Graph: " (CoreC-45Name-u--show_Show_Name e-30))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-30 (vector-ref act-27 1))) (vector 0 e-30))) (else (let ((act-28 ((CoreC-45Termination-initArgs arg-6 (PreludeC-45TypesC-45List-length (let ((e-31 (cdr arg-8))) e-31))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-31 (vector-ref act-28 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Termination-checkSC arg-6 arg-5 arg-4 arg-3 (let ((e-33 (car arg-8))) e-33) e-31 arg-7 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-32 (vector-ref act-29 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Context-setTerminating arg-5 (CoreC-45FC-emptyFC) (let ((e-34 (car arg-8))) e-34) e-32 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-33 (vector-ref act-30 1))) (vector 0 e-33))) (else (vector 1 e-32))))))))))))))))(else (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-5 (csegen-46) (let ((e-30 (car arg-8))) e-30) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-29 (vector-ref act-27 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-5 "totality.termination.sizechange.checkCall.inPathNot.return" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Have result: " (CoreC-45Name-u--show_Show_Name e-29))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-29 (vector-ref act-27 1))) (vector 0 e-29))) (else (vector 1 e-27))))))))(else (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-5 (csegen-46) (let ((e-29 (car arg-8))) e-29) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-28 (vector-ref act-27 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-5 "totality.termination.sizechange.checkCall.inPathNot.return" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Have result: " (CoreC-45Name-u--show_Show_Name e-28))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-28 (vector-ref act-27 1))) (vector 0 e-28))) (else (vector 1 e-27))))))))))))))))) ((1) (vector 1 (vector 1 )))(else (vector 1 (vector 2 (vector 1 (cons (let ((e-27 (car arg-8))) e-27) '()))))))))))))))))
(define CoreC-45Termination-n--7298-3995-u--allGuarded (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-15 (cdr e-11))) (let ((act-24 (CoreC-45Termination-n--7298-3994-u--guarded arg-0 arg-1 arg-2 e-6 e-10 e-15 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) ((CoreC-45Termination-n--7298-3995-u--allGuarded arg-0 arg-1 arg-2 e-3) clam-0)) (else (vector 1 0))))))))))))))))))
(define CoreC-45Termination-n--12073-8284-u--addCasesC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45NameMap-keys arg-4))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-4))) (if (null? sc1) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-2 e-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (CoreC-45Termination-caseFn e-5))) (cond ((equal? sc3 1) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-3 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) ((CoreC-45Termination-n--12073-8284-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-insert e-2 0 arg-4) e-3) eta-0) (let ((e-1 (unbox e-6))) ((CoreC-45Termination-n--12073-8284-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-insert e-2 0 arg-4) (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-1)) e-3)) eta-0)))))))) (else ((CoreC-45Termination-n--12073-8284-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-insert e-2 0 arg-4) e-3) eta-0))))))))) (CoreC-45Termination-n--12073-8284-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-3))))))))
(define CoreC-45Termination-n--12073-8285-u--addCases (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (CoreC-45Termination-n--12073-8284-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-empty) arg-4)))
(define CoreC-45Termination-totRefsIn (lambda (arg-1 arg-2 arg-3) (lambda (eta-0) (CoreC-45Termination-totRefs arg-1 arg-2 (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getRefs (vector 8 -1) arg-3)) eta-0))))
(define CoreC-45Termination-totRefs (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 (vector 1 )) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 (CoreC-45Termination-totRefs arg-0 arg-1 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 e-5) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((CoreC-45Termination-case--caseC-32blockC-32inC-32totRefs-3833 e-2 e-3 arg-1 arg-0 e-5 e-1 _-0 (let ((e-10 (vector-ref e-1 10))) (let ((e-28 (car e-10))) e-28))) ext-0)))))))))))))))))
(define CoreC-45Termination-smallerArg (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((5) (let ((e-4 (vector-ref arg-4 4))) (CoreC-45Termination-smallerArg arg-1 arg-2 arg-3 e-4 arg-5)))(else (let ((sc0 (CoreC-45Termination-assertedSmaller arg-3 arg-5))) (cond ((equal? sc0 1) 1) (else ((CoreC-45Termination-case--smallerArg-5850 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-5))))))))))
(define CoreC-45Termination-smaller (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((10) 0) ((5) (let ((e-6 (vector-ref arg-5 3))) (let ((e-7 (vector-ref arg-5 4))) (let ((sc1 (CoreC-45Termination-smaller arg-1 arg-2 arg-3 arg-4 e-6))) (cond ((equal? sc1 1) 1) (else (CoreC-45Termination-smaller arg-1 arg-2 arg-3 arg-4 e-7)))))))(else (cond ((equal? arg-1 1) (let ((sc1 (CoreC-45TT-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-4 arg-5))) (cond ((equal? sc1 1) 1) (else (CoreC-45Termination-smallerArg 1 arg-2 arg-3 arg-4 arg-5)))))(else (CoreC-45Termination-smallerArg arg-1 arg-2 arg-3 arg-4 arg-5)))))))
(define CoreC-45Termination-scEq (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-79 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((0) (let ((e-94 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-61C-61_Eq_Nat e-79 e-94)))(else (case (vector-ref arg-2 0) ((2) 1)(else (case (vector-ref arg-1 0) ((3) (case (vector-ref arg-2 0) ((3) 0)(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc4 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc4 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))) ((4) (let ((e-54 (vector-ref arg-1 2))) (let ((e-55 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-68 (vector-ref arg-2 2))) (let ((e-69 (vector-ref arg-2 3))) (let ((sc3 (CoreC-45Termination-scEq e-54 e-68))) (cond ((equal? sc3 1) (CoreC-45Termination-scEq e-55 e-69)) (else 0))))))(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc4 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc4 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))) ((5) (let ((e-60 (vector-ref arg-1 4))) (CoreC-45Termination-scEq e-60 arg-2)))(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc3 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc3 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))))))) ((1) (let ((e-84 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((1) (let ((e-99 (vector-ref arg-2 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-84 e-99)))(else (case (vector-ref arg-2 0) ((2) 1)(else (case (vector-ref arg-1 0) ((3) (case (vector-ref arg-2 0) ((3) 0)(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc4 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc4 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))) ((4) (let ((e-54 (vector-ref arg-1 2))) (let ((e-55 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-68 (vector-ref arg-2 2))) (let ((e-69 (vector-ref arg-2 3))) (let ((sc3 (CoreC-45Termination-scEq e-54 e-68))) (cond ((equal? sc3 1) (CoreC-45Termination-scEq e-55 e-69)) (else 0))))))(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc4 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc4 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))) ((5) (let ((e-60 (vector-ref arg-1 4))) (CoreC-45Termination-scEq e-60 arg-2)))(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc3 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc3 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))))))) ((2) 1)(else (case (vector-ref arg-2 0) ((2) 1)(else (case (vector-ref arg-1 0) ((3) (case (vector-ref arg-2 0) ((3) 0)(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc3 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc3 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))) ((4) (let ((e-54 (vector-ref arg-1 2))) (let ((e-55 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-68 (vector-ref arg-2 2))) (let ((e-69 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Termination-scEq e-54 e-68))) (cond ((equal? sc2 1) (CoreC-45Termination-scEq e-55 e-69)) (else 0))))))(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc3 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc3 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))) ((5) (let ((e-60 (vector-ref arg-1 4))) (CoreC-45Termination-scEq e-60 arg-2)))(else (case (vector-ref arg-2 0) ((5) (let ((e-46 (vector-ref arg-2 4))) (CoreC-45Termination-scEq arg-1 e-46)))(else (case (vector-ref arg-1 0) ((6) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-24 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-3 e-24)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45Termination-scEq e-7 e-28))) (cond ((equal? sc2 1) (CoreC-45Termination-scEq e-8 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-12 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-33 (vector-ref arg-2 3))) (CoreC-45Termination-scEq e-12 e-33)))(else 0)))) ((9) (let ((e-15 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-36 (vector-ref arg-2 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-15 e-36)))(else 0)))) ((10) (case (vector-ref arg-2 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))))
(define CoreC-45Termination-posArgs (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 (vector 1 )) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Checking parameter for positivity") '() e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 ((CoreC-45Termination-posArg arg-0 arg-1 arg-2 e-5) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (case (vector-ref e-7 0) ((1) (CoreC-45Termination-posArgs arg-0 arg-1 arg-2 e-3 ext-0))(else (vector 1 e-7)))))))))))))))))))
(define CoreC-45Termination-posArg (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Found a type constructor") '() arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 (let ((act-25 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-1 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((u--nf (vector 3 e-1 e-2 e-3 e-4 e-5))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-1 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) " not a data type")) clam-0) (let ((e-8 (unbox e-7))) (case (vector-ref e-8 0) ((6) (let ((e-14 (vector-ref e-8 3))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (DataC-45String-unwords (cons (CoreC-45Name-u--show_Show_Name e-2) (cons "has" (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-14)) (cons "parameters" '())))))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-17 (vector-ref act-26 1))) (vector 0 e-17))) (else (vector 1 (CoreC-45Termination-n--12728-8968-u--splitParams e-3 e-4 e-5 e-2 e-1 u--nf arg-2 arg-1 arg-0 0 e-14 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-1 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) " not a data type")) clam-0)))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((e-9 (car e-7))) (let ((e-8 (cdr e-7))) (let ((act-26 (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 eta-0)) e-8 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (CoreC-45Core-anyM (lambda (eta-0) (CoreC-45Termination-nameIn arg-0 arg-1 arg-2 eta-0)) e-10 clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (cond ((equal? e-10 0) (CoreC-45Termination-posArgs arg-0 arg-1 arg-2 e-9 clam-0)) (else (vector 1 (vector 2 (vector 0 )))))))))))))))))))))))) ((0) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (case (vector-ref e-9 0) ((2) (let ((e-19 (vector-ref e-9 4))) (let ((act-24 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Found a Pi-type") '() arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-19) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Termination-nameIn arg-0 arg-1 arg-2 e-6) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-26 1))) (cond ((equal? e-11 1) (vector 1 (vector 2 (vector 0 )))) (else (let ((u--nm (vector 1 e-7 (vector 0 ) (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "POSCHECK_" (CoreC-45Name-u--show_Show_Name e-8)) 1)))) (let ((u--arg (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() u--nm))) (let ((act-27 (((e-10 arg-1) u--arg) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-27 1))) ((CoreC-45Termination-posArg arg-0 arg-1 arg-2 e-12) clam-0))))))))))))))))))))))(else (let ((act-24 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Reached the catchall") '() arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 1 )))))))))))) ((1) (let ((e-14 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Found an application") '() arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-0))) e-14 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-anyM (lambda (eta-0) (CoreC-45Termination-nameIn arg-0 arg-1 arg-2 eta-0)) e-6 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cond ((equal? e-7 1) (vector 2 (vector 0 ))) (else (vector 1 )))))))))))))))))(else (let ((act-24 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Reached the catchall") '() arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 1 ))))))))))
(define CoreC-45Termination-nextArg (lambda (arg-0) (bs+ arg-0 1 63)))
(define CoreC-45Termination-nameIn (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (CoreC-45TT-binderType e-3)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Termination-nameIn arg-0 arg-1 arg-2 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 1)) (else (let ((u--nm (vector 1 e-1 (vector 0 ) (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "NAMEIN_" (CoreC-45Name-u--show_Show_Name e-2)) 0)))) (let ((u--arg (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() u--nm))) (let ((act-26 (((e-4 arg-1) u--arg) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) ((CoreC-45Termination-nameIn arg-0 arg-1 arg-2 e-7) clam-0)))))))))))))))))))))) ((1) (let ((e-8 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-0))) e-8 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-anyM (lambda (eta-0) (CoreC-45Termination-nameIn arg-0 arg-1 arg-2 eta-0)) e-5 clam-0))))))) ((3) (let ((e-11 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (PreludeC-45Types-elem (csegen-802) e-11 arg-2))) (cond ((equal? sc1 1) (vector 1 1)) (else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-0))) e-14 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-anyM (lambda (eta-0) (CoreC-45Termination-nameIn arg-0 arg-1 arg-2 eta-0)) e-5 clam-0))))))))))) ((2) (let ((e-20 (vector-ref arg-3 5))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-0))) e-20 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-anyM (lambda (eta-0) (CoreC-45Termination-nameIn arg-0 arg-1 arg-2 eta-0)) e-5 clam-0)))))))(else (vector 1 0))))))
(define CoreC-45Termination-mkChange (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-7 0) ((5) (let ((e-11 (vector-ref e-7 3))) (let ((e-12 (vector-ref e-7 4))) (CoreC-45Termination-mkChange arg-1 arg-2 (cons (cons e-6 e-11) (cons (cons e-6 e-12) e-3)) arg-4))))(else (CoreC-45Core-cond (cons (cons (lambda () (CoreC-45Termination-scEq arg-4 e-7)) (lambda () (box (cons e-6 1)))) (cons (cons (lambda () (CoreC-45Termination-smaller 0 arg-1 (CoreC-45Termination-asserted arg-2 arg-4) arg-4 e-7)) (lambda () (box (cons e-6 0)))) '())) (CoreC-45Termination-mkChange arg-1 arg-2 e-3 arg-4)))))))))))
(define CoreC-45Termination-initArgs (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (lambda (eta-0) (vector 1 '())))(else (let ((e-0 (- arg-1 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (CoreC-45Termination-nextArg e-5)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45Termination-initArgs arg-0 e-0) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cons (box (cons e-5 1)) e-7)))))))))))))))))))
(define CoreC-45Termination-getSC (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-4 (vector-ref arg-2 5))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Termination-findCalls arg-0 arg-1 eta-0)) e-4 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (DataC-45List-nub (cons (lambda (arg-3) (lambda (arg-4) (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SCCall arg-3 arg-4))) (lambda (arg-4) (lambda (arg-5) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_SCCall arg-4 arg-5)))) (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))))(else (vector 1 '())))))
(define CoreC-45Termination-getCasePats (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Context-lookupDefExact arg-3 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((1) (let ((e-6 (vector-ref e-1 5))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (DataC-45String-unwords (cons "Looking at the" (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-6)) (cons "cases of" (cons (CoreC-45Name-u--show_Show_Name arg-3) '())))))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((u--pdefsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Termination-n--8289-6107-u--matchArgs arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 eta-0)) e-6))) (let ((act-26 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda (eta-0) (let ((act-26 ((PreludeC-45Basics-flip (csegen-1822) e-6 (lambda (lamc-0) (let ((e-10 (car lamc-0))) (let ((e-9 (cdr lamc-0))) (lambda (clam-0) (let ((e-11 (cdr e-9))) (let ((e-14 (car e-11))) (let ((e-13 (cdr e-11))) (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-14 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-15 (vector-ref act-26 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-13 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "    " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-10 e-15) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-10 e-16))))))))))))))))))))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 ((PreludeC-45Basics-flip (csegen-1822) u--pdefsC-39 (lambda (lamc-0) (let ((e-11 (car lamc-0))) (let ((e-10 (cdr lamc-0))) (lambda (clam-1) (let ((e-12 (cdr e-10))) (let ((e-15 (car e-12))) (let ((e-14 (cdr e-12))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-0 (csegen-76) (Builtin-snd eta-1) eta-2))) e-15 '() clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-14 clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-17 (vector-ref act-28 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-28 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "    " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-11 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-11 u--d u--x)))) e-16) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-11 e-17))))))))))))))))))))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (vector 1 (DataC-45String-fastUnlines (cons "Updated" (PreludeC-45TypesC-45List-tailRecAppend e-9 (cons "  to:" e-10)))))))))))))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (vector 1 (box u--pdefsC-39)))))))))))(else (vector 1 '())))))))))))
(define CoreC-45Termination-firstArg(blodwen-lazy (lambda () 0)))
(define CoreC-45Termination-findSCcall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-7 (let ((e-0 (vector-ref arg-2 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Context-undefinedName arg-1 arg-6 arg-7 ext-0) (let ((e-1 (unbox e-5))) (let ((u--fn (let ((e-23 (vector-ref e-1 1))) e-23))) (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-1 (csegen-46) u--fn ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-1 "totality.termination.sizechange" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Looking under " (CoreC-45Name-u--show_Show_Name e-6))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45Context-u--resolved_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 0 (CoreC-45NameC-45Namespace-builtinNS) (vector 1 (vector 0 "assert_smaller")))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((CoreC-45Core-cond (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name u--fn (csegen-2204))) (lambda () (lambda (eta-0) (vector 1 '())))) (cons (cons (lambda () (CoreC-45Termination-caseFn u--fn)) (lambda () (lambda (eta-0) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Termination-findSC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1)) arg-9 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Termination-getCasePats arg-1 arg-0 arg-2 u--fn arg-5 arg-9 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Termination-findInCase arg-1 arg-2 arg-4 eta-1)) (DataC-45Maybe-fromMaybe (lambda () '()) e-9) '() eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) (PreludeC-45TypesC-45List-tailRecAppend e-8 e-10)))))))))))))))))) '())) (lambda (eta-0) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Termination-findSC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1)) arg-9 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (cons (cons u--fn (CoreC-45Termination-expandToArity arg-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45Termination-mkChange arg-2 e-7 arg-5 eta-1)) arg-9))) '()) (PreludeC-45Interfaces-concat (csegen-50) e-8))))))))) ext-0)))))))))))))))))
(define CoreC-45Termination-findSC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45Termination-n--8269-4911-u--findSCbinder e-12 arg-0 e-14 e-13 e-11 arg-5 arg-4 arg-3 arg-2 arg-1 e-13) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Termination-findSC (cons e-12 arg-0) arg-1 arg-2 (cons e-13 arg-3) arg-4 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (CoreC-45TT-u--weaken_Weaken_Term e-3))))) arg-5) e-14) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6))))))))))))))))(else (cond ((equal? arg-4 2) (case (vector-ref arg-6 0) ((7) (let ((e-9 (vector-ref arg-6 4))) (CoreC-45Termination-findSC arg-0 arg-1 arg-2 arg-3 3 arg-5 e-9)))(else (case (vector-ref arg-6 0) ((7) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Termination-findSC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4)))(else (lambda (eta-0) (CoreC-45Termination-case--findSC-5242 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-6) eta-0)))))))(else (case (vector-ref arg-6 0) ((7) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Termination-findSC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4)))(else (lambda (eta-0) (CoreC-45Termination-case--findSC-5242 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-6) eta-0))))))))))
(define CoreC-45Termination-findInCase (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-0 (csegen-76) eta-1 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-10) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Looking in case args " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 e-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-2 u--d u--x)))) e-5)))))))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Normalise-logTermNF e-2 arg-0 "totality" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "        =") e-6 e-11 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CoreC-45Normalise-normaliseOpts arg-0 e-2 (CoreC-45Value-tcOnly) arg-1 e-6 e-11 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) ((CoreC-45Termination-findSC e-2 arg-0 arg-1 e-6 arg-2 e-10 (CoreC-45Termination-delazy arg-1 e-9)) clam-0))))))))))))))))))))
(define CoreC-45Termination-findCalls (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--pargs (CoreC-45TT-getArgs (CoreC-45Termination-delazy arg-1 e-10)))) (lambda (eta-0) (let ((act-24 (CoreC-45Normalise-normaliseOpts arg-0 e-2 (CoreC-45Value-tcOnly) arg-1 e-6 e-11 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Termination-findSC e-2 arg-0 arg-1 e-6 0 (DataC-45List-u--zip_Zippable_List (PreludeC-45Types-take (PreludeC-45TypesC-45List-length u--pargs) (PreludeC-45Types-u--rangeFrom_Range_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 0))) u--pargs) (CoreC-45Termination-delazy arg-1 e-5)) eta-0)))))))))))))))
(define CoreC-45Termination-expandToArity (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1)(else (let ((e-0 (- arg-0 1))) (if (null? arg-1) (cons '() (CoreC-45Termination-expandToArity e-0 '())) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons e-2 (CoreC-45Termination-expandToArity e-0 e-3))))))))))
(define CoreC-45Termination-delazy (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((6) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((u--tmC-39 (CoreC-45Termination-delazy arg-1 e-3))) (cond ((equal? e-2 0) (vector 6 e-1 e-2 u--tmC-39))(else u--tmC-39))))))) ((7) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((u--tyC-39 (CoreC-45Termination-delazy arg-1 e-7))) (let ((u--tmC-39 (CoreC-45Termination-delazy arg-1 e-8))) (cond ((equal? e-6 0) (vector 7 e-5 e-6 u--tyC-39 u--tmC-39))(else u--tmC-39))))))))) ((8) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (cond ((equal? e-11 0) (vector 8 e-10 e-11 (CoreC-45Termination-delazy arg-1 e-12)))(else (CoreC-45Termination-delazy arg-1 e-12))))))) ((2) (let ((e-14 (vector-ref arg-2 1))) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (vector 2 e-14 e-15 e-16 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Termination-delazy arg-1 eta-0)) e-17))))))) ((3) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (vector 3 e-19 e-20 (CoreC-45TT-u--map_Functor_Binder (lambda (eta-0) (CoreC-45Termination-delazy arg-1 eta-0)) e-21) (CoreC-45Termination-delazy arg-1 e-22))))))) ((4) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (vector 4 e-24 (CoreC-45Termination-delazy arg-1 e-25) (CoreC-45Termination-delazy arg-1 e-26)))))) ((5) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (vector 5 e-28 e-29 (CoreC-45Termination-delazy arg-1 e-30) (CoreC-45Termination-delazy arg-1 e-31)))))))(else arg-2))))
(define CoreC-45Termination-checkTotal (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45Termination-case--checkTotal-10161 arg-2 arg-1 arg-0 e-5 (CoreC-45Context-getNameID arg-2 (let ((e-0 (vector-ref e-5 0))) e-0))) ext-0)))))))
(define CoreC-45Termination-checkTerminating (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-getTotality arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-0 "totality.termination" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking termination: " (CoreC-45Name-u--show_Show_Name e-6))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45Termination-case--checkTerminating-8638 arg-2 arg-1 arg-0 e-5 (let ((e-0 (car e-5))) e-0) ext-0))))))))))
(define CoreC-45Termination-checkSC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-1 (csegen-46) arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-1 "totality.termination.sizechange" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking Size Change Graph: " (CoreC-45Name-u--show_Show_Name e-6))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--pos (cons arg-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (Builtin-fst eta-1)) eta-0)) arg-5)))) (let ((sc2 (LibrariesC-45DataC-45SortedMap-lookup u--pos e-5))) (if (null? sc2) (let ((sc3 (PreludeC-45Types-elem (csegen-2251) u--pos arg-6))) (cond ((equal? sc3 1) (let ((act-26 (let ((act-26 (CoreC-45Context-toFullNames arg-1 (csegen-46) arg-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45ContextC-45Log-log arg-1 "totality.termination.sizechange.inPath" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking arguments: " (CoreC-45Name-u--show_Show_Name e-7))) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-2241) (CoreC-45Termination-n--11061-7364-u--checkDesc arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (DataC-45List-mapMaybe (lambda (eta-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (Builtin-snd eta-1)) eta-0)) arg-5) arg-6) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-2 (LibrariesC-45DataC-45SortedMap-insert u--pos e-8 e-5)))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 e-8)))))))))))) (else (let ((act-26 ((CoreC-45Context-lookupCtxtExact arg-4 (let ((e-0 (vector-ref arg-3 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-46) arg-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-1 "totality.termination.sizechange.isTerminating" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Size Change Graph is Terminating for: " (CoreC-45Name-u--show_Show_Name e-8))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (vector 1 ))))) (let ((e-2 (unbox e-7))) (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-46) arg-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-1 "totality.termination.sizechange.needsChecking" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Size Change Graph needs traversing: " (CoreC-45Name-u--show_Show_Name e-8))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (CoreC-45Termination-n--11061-7370-u--continue arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (let ((e-20 (vector-ref e-2 20))) e-20) (cons u--pos arg-6) ext-0))))))))))))) (let ((e-1 (unbox sc2))) (vector 1 e-1))))))))))))))
(define CoreC-45Termination-checkPositive (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getTotality arg-0 arg-1 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking positivity: " (CoreC-45Name-u--show_Show_Name e-7))) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Termination-case--checkPositive-10084 arg-2 arg-1 arg-0 e-5 e-6 (let ((e-0 (car e-6))) e-0) ext-0))))))))))))))
(define CoreC-45Termination-checkPosArgs (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-9) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Termination-posArg arg-0 arg-1 arg-2 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (case (vector-ref e-10 0) ((1) (let ((u--nm (vector 1 e-1 (vector 0 ) (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "POSCHECK_" (CoreC-45Name-u--show_Show_Name e-2)) 0)))) (let ((u--arg (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() u--nm))) (let ((act-26 (((e-4 arg-1) u--arg) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) ((CoreC-45Termination-checkPosArgs arg-0 arg-1 arg-2 e-11) clam-0))))))))(else (vector 1 e-10)))))))))))))(else (let ((act-24 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Giving up on non-Pi type") '() arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (vector 1 (vector 1 ))))))))))))(else (let ((act-24 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () "Giving up on non-Pi type") '() arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 1 ))))))))))
(define CoreC-45Termination-checkIfGuarded (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-0 "totality.termination.guarded" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Check if Guarded: " (CoreC-45Name-u--show_Show_Name e-5))) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-lookupDefExact arg-2 (let ((e-0 (vector-ref e-6 0))) e-0) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 0) (let ((e-1 (unbox e-7))) (case (vector-ref e-1 0) ((1) (let ((e-8 (vector-ref e-1 5))) (let ((act-27 ((CoreC-45Termination-n--7298-3995-u--allGuarded arg-2 arg-1 arg-0 e-8) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (cond ((equal? e-10 1) (CoreC-45Context-setFlag arg-0 arg-1 arg-2 (vector 8 ) ext-0)) (else (vector 1 0)))))))))(else (vector 1 0))))))))))))))))))
(define CoreC-45Termination-checkData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 (vector 1 )) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking positivity of constructor " (CoreC-45Name-u--show_Show_Name e-2))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Termination-checkCon arg-0 arg-1 arg-2 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (CoreC-45Termination-checkData arg-0 arg-1 arg-2 e-3 ext-0))(else (vector 1 e-6)))))))))))))))
(define CoreC-45Termination-checkCon (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-lookupTyExact arg-3 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Couldn't find constructor " (CoreC-45Name-u--show_Show_Name arg-3))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 0 ))))) (let ((e-2 (unbox e-5))) (let ((act-25 ((CoreC-45Termination-totRefsIn arg-0 arg-1 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() arg-1 '() e-2) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "Checking the type ") '() e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else ((CoreC-45Termination-checkPosArgs arg-0 arg-1 arg-2 e-7) ext-0)))))))))(else (vector 1 e-6)))))))))))))))
(define CoreC-45Termination-caseFn (lambda (arg-0) (case (vector-ref arg-0 0) ((6) 1) ((4) (let ((e-3 (vector-ref arg-0 2))) (CoreC-45Termination-caseFn e-3))) ((0) (let ((e-5 (vector-ref arg-0 2))) (CoreC-45Termination-caseFn e-5)))(else 0))))
(define CoreC-45Termination-calculateSizeChange (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45ContextC-45Log-log arg-0 "totality.termination.sizechange" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Calculating Size Change: " (CoreC-45Name-u--show_Show_Name e-5))) ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-7))) (CoreC-45Termination-getSC arg-0 e-6 (let ((e-17 (vector-ref e-1 17))) e-17) ext-0))))))))))))))))
(define CoreC-45Termination-calcTerminating (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-0 "totality.termination.calc" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Calculating termination: " (CoreC-45Name-u--show_Show_Name e-6))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-2 (unbox e-7))) (let ((act-27 ((CoreC-45Termination-n--12073-8285-u--addCases arg-2 arg-1 arg-0 e-5 (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-2))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Termination-totRefs arg-0 e-5 (DataC-45List-nub (csegen-802) e-8) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (case (vector-ref e-9 0) ((1) (let ((u--ty (let ((e-27 (vector-ref e-2 2))) e-27))) (let ((act-29 (CoreC-45Core-newRef (vector "Core.Termination.APos" ) (CoreC-45Termination-firstArg) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (CoreC-45Normalise-getArity arg-0 '() e-5 '() u--ty ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-30 1))) ((CoreC-45Termination-initArgs e-10 e-11) ext-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Core-newRef (vector "Core.Termination.Explored" ) (LibrariesC-45DataC-45SortedMap-empty (vector (csegen-2251) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-883) (csegen-2264) arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-883) (csegen-2264) arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-883) (csegen-2264) arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-883) (csegen-2264) arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-883) (csegen-2264) arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-883) (csegen-2264) arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-883) (csegen-2264) arg-430 arg-431))))) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-31 1))) (CoreC-45Termination-checkSC e-10 arg-0 e-12 e-5 arg-2 e-11 '() ext-0)))))))))))))))(else (vector 1 e-9))))))))))))))))))))))))))
(define CoreC-45Termination-calcPositive (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Calculating positivity: " (CoreC-45Name-u--show_Show_Name e-6))) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-lookupDefTyExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (unbox e-7))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-2) " not a data type")) ext-0) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (case (vector-ref e-9 0) ((6) (let ((e-12 (vector-ref e-9 6))) (let ((e-13 (vector-ref e-9 7))) (let ((act-27 ((CoreC-45Termination-totRefsIn arg-0 e-5 e-8) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-27 1))) (case (vector-ref e-18 0) ((1) (let ((act-28 (let ((act-28 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-28 1))) (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Now checking constructors of " (CoreC-45Name-u--show_Show_Name e-19))) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45Termination-checkData arg-0 e-5 (cons arg-2 e-12) e-13 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-29 1))) (vector 1 (cons e-20 e-13))))))))))(else (vector 1 (cons e-18 e-13)))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-2) " not a data type")) ext-0)))))))))))))))))))))
(define CoreC-45Termination-assertedSmaller (lambda (arg-1 arg-2) (if (null? arg-1) 0 (let ((e-1 (unbox arg-1))) (CoreC-45Termination-scEq e-1 arg-2)))))
(define CoreC-45Termination-asserted (lambda (arg-1 arg-2) (CoreC-45Termination-case--asserted-5935 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-2))))
(define CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addConstG-7966 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-11 0) ((2) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (if (null? e-8) (lambda (clam-2) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7122-u--addConstG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-12 arg-17 arg-16 arg-15 arg-14) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5))))))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (let ((e-14 (vector-ref e-10 0))) (let ((e-15 (vector-ref e-10 1))) (let ((e-16 (vector-ref e-10 2))) (let ((e-17 (vector-ref e-10 3))) (case (vector-ref arg-13 0) ((2) (let ((u--newclause (vector e-14 arg-17 arg-16 arg-15))) (lambda (eta-0) (vector 1 (cons (vector 2 e-7 (cons (vector e-14 e-15 e-16 e-17) (PreludeC-45TypesC-45List-tailRecAppend e-11 (cons u--newclause '())))) arg-14)))))(else (lambda (clam-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7122-u--addConstG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-12 arg-17 arg-16 arg-15 arg-14) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5)))))))))))))))))))(else (lambda (clam-3) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7122-u--addConstG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-12 arg-17 arg-16 arg-15 arg-14) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5)))))))))))
(define CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addDelayG-7792 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-11 0) ((1) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (let ((e-9 (vector-ref arg-11 3))) (if (null? e-9) (lambda (clam-2) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7121-u--addDelayG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5))))))) (let ((e-11 (car e-9))) (let ((e-12 (cdr e-9))) (let ((e-15 (vector-ref e-11 0))) (let ((e-16 (vector-ref e-11 1))) (let ((e-17 (vector-ref e-11 2))) (let ((e-18 (vector-ref e-11 3))) (case (vector-ref arg-12 0) ((1) (let ((u--l (CoreC-45TTC-45SizeOf-mkSizeOf (cons e-7 (cons e-8 '()))))) (let ((u--newps (CoreC-45CaseC-45CaseBuilder-newPats (cons arg-18 (cons arg-17 '())) (+ 1 (+ 1 0)) e-16))) (let ((u--patsC-39 (CoreC-45CaseC-45CaseBuilder-updatePatNames (CoreC-45CaseC-45CaseBuilder-updateNames (cons (cons e-7 arg-18) (cons (cons e-8 arg-17) '()))) (CoreC-45CaseC-45CaseBuilder-weakenNs u--l arg-16)))) (let ((u--newclause (vector e-15 (CoreC-45CaseC-45CaseBuilder-C-43C-43 u--newps u--patsC-39) arg-15 (CoreC-45TT-u--weakenNs_Weaken_Term u--l arg-14)))) (lambda (eta-0) (vector 1 (cons (vector 1 e-7 e-8 (cons (vector e-15 e-16 e-17 e-18) (PreludeC-45TypesC-45List-tailRecAppend e-12 (cons u--newclause '())))) arg-13))))))))(else (lambda (clam-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7121-u--addDelayG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5))))))))))))))))))))(else (lambda (clam-3) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7121-u--addDelayG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5)))))))))))
(define CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addConG-7464 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-11 0) ((0) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (let ((e-9 (vector-ref arg-11 3))) (let ((e-10 (vector-ref arg-11 4))) (if (null? e-10) (lambda (clam-2) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7120-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-14 arg-13 arg-12 arg-19 arg-18 arg-17 arg-16) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5))))))) (let ((e-12 (car e-10))) (let ((e-13 (cdr e-10))) (let ((e-16 (vector-ref e-12 0))) (let ((e-17 (vector-ref e-12 1))) (let ((e-18 (vector-ref e-12 2))) (let ((e-19 (vector-ref e-12 3))) (case (vector-ref arg-15 0) ((0) (let ((e-31 (vector-ref arg-15 2))) (let ((u--newps (CoreC-45CaseC-45CaseBuilder-newPats arg-12 e-31 e-17))) (let ((u--l (CoreC-45TTC-45SizeOf-mkSizeOf e-7))) (let ((u--patsC-39 (CoreC-45CaseC-45CaseBuilder-updatePatNames (CoreC-45CaseC-45CaseBuilder-updateNames (DataC-45List-u--zip_Zippable_List e-7 arg-12)) (CoreC-45CaseC-45CaseBuilder-weakenNs u--l arg-19)))) (let ((u--newclause (vector e-16 (CoreC-45CaseC-45CaseBuilder-C-43C-43 u--newps u--patsC-39) arg-18 (CoreC-45TT-u--weakenNs_Weaken_Term u--l arg-17)))) (lambda (eta-0) (vector 1 (cons (vector 0 e-7 e-8 e-9 (cons (vector e-16 e-17 e-18 e-19) (PreludeC-45TypesC-45List-tailRecAppend e-13 (cons u--newclause '())))) arg-16)))))))))(else (lambda (clam-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7120-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-14 arg-13 arg-12 arg-19 arg-18 arg-17 arg-16) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5)))))))))))))))))))))(else (lambda (clam-3) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7120-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-14 arg-13 arg-12 arg-19 arg-18 arg-17 arg-16) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons arg-11 e-5)))))))))))
(define CoreC-45CaseC-45CaseBuilder-with--partition-5468 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (let ((e-3 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 3))) (let ((e-6 (vector-ref arg-5 4))) (let ((e-7 (vector-ref arg-5 5))) (if (null? e-3) (let ((sc4 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc4 0) (vector 0 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))) (else (vector 1 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))))) (let ((sc2 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc2 0) (vector 0 (cons arg-0 arg-1) arg-2 e-5 (cons arg-6 e-6) e-7)) (else (vector 1 (cons arg-0 arg-1) arg-2 (PreludeC-45TypesC-45List-tailRecAppend e-6 e-5) (cons arg-6 '()) (vector 0 (cons arg-0 arg-1) arg-2 e-5 e-6 e-7))))))))))) ((1) (let ((e-8 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 3))) (let ((e-11 (vector-ref arg-5 4))) (let ((e-12 (vector-ref arg-5 5))) (if (null? e-8) (let ((sc4 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc4 0) (vector 0 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))) (else (vector 1 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))))) (let ((sc2 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc2 0) (vector 0 (cons arg-0 arg-1) arg-2 (PreludeC-45TypesC-45List-tailRecAppend e-11 e-10) (cons arg-6 '()) (vector 1 (cons arg-0 arg-1) arg-2 e-10 e-11 e-12))) (else (vector 1 (cons arg-0 arg-1) arg-2 e-10 (cons arg-6 e-11) e-12))))))))))(else (let ((sc2 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc2 0) (vector 0 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))) (else (vector 1 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 )))))))))
(define CoreC-45CaseC-45CaseBuilder-case--identifyUnreachableDefaults-13520 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((u--extraClauseIdxsC-39 (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-1) (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45TypesC-45List-length e-2) (+ 1 0))))) (cond ((equal? sc1 1) e-3) (else (csegen-2286)))))) (lambda (eta-0) (let ((act-24 (let ((sc1 ((LibrariesC-45DataC-45SortedSet-u--null_Foldable_SortedSet u--extraClauseIdxsC-39)))) (cond ((equal? sc1 1) (vector 1 0)) (else (CoreC-45ContextC-45Log-log arg-5 "compile.casetree.clauses" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Marking the following clause indices as unreachable under the current branch of the tree: " (LibrariesC-45DataC-45SortedSet-u--show_Show_C-40SortedSetC-32C-36kC-41 (csegen-246) u--extraClauseIdxsC-39))) eta-0)))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 u--extraClauseIdxsC-39))))))))))
(define CoreC-45CaseC-45CaseBuilder-case--identifyUnreachableDefaultsC-44dropRep-13368 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (let ((u--extraClauses (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-3 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-findReachedAlts eta-0))))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--20360-13320-u--dropRep arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 (LibrariesC-45DataC-45SortedSet-fromList (csegen-224) u--extraClauses)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (cons arg-10 e-5) (LibrariesC-45DataC-45SortedSet-union arg-12 e-4))))))))))
(define CoreC-45CaseC-45CaseBuilder-case--patCompile-12658 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((act-24 (CoreC-45CaseC-45CaseBuilder-n--19496-12554-u--mkPatClausesFrom arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 0 e-2 (cons arg-0 arg-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-unverifiedLogC arg-7 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-0) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-7 (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-3) (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 arg-4060 arg-4061 eta-3)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-3) (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 arg-4062 arg-4063 eta-3))))) eta-1 eta-2))) e-5 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Pattern clauses:\xa;" (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-u--pretty_Pretty_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-2 e-2 eta-1)) e-6))))))))))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-7 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-2 e-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CaseC-45CaseBuilder-u--showPrec_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-2 e-2 u--d u--x)))) e-5)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (CoreC-45Core-newRef (vector "Core.Case.CaseBuilder.PName" ) 0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45CaseC-45CaseBuilder-match e-2 e-2 e-8 arg-7 arg-6 arg-5 arg-4 e-5 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree e-3 eta-0)) arg-2)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons e-2 e-9))))))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-case--match-10863 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((u--prioritizedClauses (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-shuffleVars e-3 eta-0)) arg-4))) (lambda (eta-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-pickNextViable e-2 arg-0 (CoreC-45TT-dropVar (cons arg-2 arg-1) e-3) arg-9 arg-8 arg-7 arg-5 arg-6 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-getNPs eta-1)) u--prioritizedClauses)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.pick" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Picked " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-6) " as the next split"))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((u--clausesC-39 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-shuffleVars e-4 eta-1)) u--prioritizedClauses))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.clauses" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (LibrariesC-45DataC-45StringC-45Extra-unlines (cons "Using clauses:" (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (PreludeC-45TypesC-45String-C-43C-43 "  " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 arg-0 (cons e-6 (CoreC-45TT-dropVar (cons e-2 (CoreC-45TT-dropVar (cons arg-2 arg-1) e-3)) e-4)) eta-1))) u--clausesC-39)))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((u--ps (CoreC-45CaseC-45CaseBuilder-partition e-6 (CoreC-45TT-dropVar (cons e-2 (CoreC-45TT-dropVar (cons arg-2 arg-1) e-3)) e-4) arg-0 arg-5 u--clausesC-39))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.partition" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Got Partition:\xa;" (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40PartitionsC-32C-36psC-41 u--clausesC-39 u--ps))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((act-28 ((CoreC-45CaseC-45CaseBuilder-mixture e-6 arg-0 (CoreC-45TT-dropVar (cons e-2 (CoreC-45TT-dropVar (cons arg-2 arg-1) e-3)) e-4) arg-9 arg-8 u--clausesC-39 arg-7 arg-6 arg-5 u--ps arg-3) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (if (null? e-10) (let ((act-29 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.intermediate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () "match: No clauses") eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (vector 1 (vector 2 "No clauses"))))) (let ((e-11 (unbox e-10))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.intermediate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "match: new case tree " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 arg-0 e-11))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-12 (vector-ref act-29 1))) (vector 0 e-12))) (else (vector 1 e-11)))))))))))))))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-case--weakenNs-4295 (lambda (arg-3 arg-4 arg-5) (cond ((equal? arg-4 0) (if (null? arg-5) arg-3 (let ((e-3 (unbox arg-5))) (CoreC-45CaseC-45CaseBuilder-u--weaken_Weaken_C-40PatInfoC-32C-36pC-41 (CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_C-40PatInfoC-32C-36pC-41 e-3 arg-3)))))(else (let ((e-3 (unbox arg-5))) (CoreC-45CaseC-45CaseBuilder-u--weaken_Weaken_C-40PatInfoC-32C-36pC-41 (CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_C-40PatInfoC-32C-36pC-41 e-3 arg-3)))))))
(define CoreC-45CaseC-45CaseBuilder-case--substInPatInfo-3274 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (let ((act-24 (let ((act-24 (unbox arg-8))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-8 arg-1 e-5 (CoreC-45Env-mkEnv arg-7 arg-1) e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (vector 1 (cons (let ((e-11 (vector-ref arg-4 0))) (let ((e-10 (vector-ref arg-4 1))) (let ((e-9 (vector-ref arg-4 2))) (vector e-11 e-10 e-9 (vector 0 e-1 (CoreC-45TT-substName arg-6 arg-5 e-2)))))) arg-2)))(else (vector 1 (cons arg-4 arg-2))))))))))))))) ((1) (let ((e-4 (vector-ref arg-9 1))) (let ((act-24 (let ((act-24 (unbox arg-8))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--env (CoreC-45Env-mkEnv arg-7 arg-1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-8 arg-1 e-5 u--env (CoreC-45TT-substName arg-6 arg-5 e-4)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (case (vector-ref e-7 0) ((0) (let ((e-1 (vector-ref e-7 1))) (let ((e-3 (vector-ref e-7 3))) (let ((e-8 (vector-ref e-7 4))) (case (vector-ref e-3 0) ((2) (let ((e-11 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-8 arg-1 e-6 u--env e-9 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 (((e-8 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) u--env (vector 1 e-1 (vector 0 ) arg-3))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (let ((act-29 ((CoreC-45CaseC-45CaseBuilder-updatePats arg-1 arg-0 arg-8 u--env e-14 arg-2) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-15 (vector-ref act-29 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-29 1))) (vector 1 (cons (let ((e-19 (vector-ref arg-4 0))) (let ((e-18 (vector-ref arg-4 1))) (let ((e-17 (vector-ref arg-4 2))) (vector e-19 e-18 e-17 (vector 0 e-11 e-13))))) e-15)))))))))))))))))(else (vector 1 (cons arg-4 arg-2))))))))(else (vector 1 (cons arg-4 arg-2))))))))))))))))))) (else (vector 1 (cons arg-4 arg-2))))))
(define CoreC-45CaseC-45CaseBuilder-n--17657-11574-u--updateVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-2 (vector-ref arg-10 0))) (let ((e-3 (vector-ref arg-10 1))) (let ((e-4 (vector-ref arg-10 2))) (let ((e-5 (vector-ref arg-10 3))) (let ((e-9 (car e-3))) (let ((e-10 (cdr e-3))) (lambda (clam-0) (let ((e-13 (vector-ref e-9 0))) (let ((e-14 (vector-ref e-9 1))) (let ((e-15 (vector-ref e-9 2))) (let ((e-17 (vector-ref e-9 3))) (case (vector-ref e-15 0) ((6) (let ((e-18 (vector-ref e-15 1))) (let ((e-19 (vector-ref e-15 2))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-1 arg-0 arg-8 arg-7 arg-3 (vector 0 e-18 (box 0) e-13) e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector (cons e-19 e-2) e-6 e-4 (CoreC-45TT-substName e-19 (vector 0 e-18 (box 0) e-13) e-5)))))))))) ((0) (let ((e-20 (vector-ref e-15 1))) (let ((e-21 (vector-ref e-15 2))) (let ((e-22 (vector-ref e-15 3))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-1 arg-0 arg-8 arg-7 arg-3 (CoreC-45CaseC-45CaseTree-mkTerm arg-1 e-22) e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--rhsC-39 (CoreC-45TT-substName e-21 (vector 0 e-20 (box 1) e-13) e-5))) ((CoreC-45CaseC-45CaseBuilder-n--17657-11574-u--updateVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector e-2 (cons (vector e-13 e-14 e-22 e-17) e-6) e-4 u--rhsC-39)) clam-0))))))))))(else (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-1 arg-0 arg-8 arg-7 arg-3 (CoreC-45CaseC-45CaseTree-mkTerm arg-1 e-15) e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector e-2 e-6 e-4 e-5)))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update (lambda (arg-3 arg-4 arg-5 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (let ((e-2 (vector-ref arg-7 3))) (let ((sc1 (DataC-45List-lookup (csegen-802) e-1 arg-5))) (if (null? sc1) (vector 0 e-0 e-1 (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update arg-3 arg-4 arg-5 e-2)) (let ((e-3 (unbox sc1))) (vector 0 e-0 e-3 (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update arg-3 arg-4 arg-5 e-2))))))))) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (let ((e-5 (vector-ref arg-7 3))) (let ((e-6 (vector-ref arg-7 4))) (let ((e-7 (vector-ref arg-7 5))) (vector 1 e-3 e-4 e-5 e-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update arg-3 arg-4 arg-5 eta-0)) e-7)))))))) ((2) (let ((e-8 (vector-ref arg-7 1))) (let ((e-9 (vector-ref arg-7 2))) (let ((e-10 (vector-ref arg-7 3))) (let ((e-11 (vector-ref arg-7 4))) (vector 2 e-8 e-9 e-10 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update arg-3 arg-4 arg-5 eta-0)) e-11))))))) ((4) (let ((e-12 (vector-ref arg-7 1))) (let ((e-13 (vector-ref arg-7 2))) (let ((e-14 (vector-ref arg-7 3))) (let ((e-15 (vector-ref arg-7 4))) (vector 4 e-12 e-13 (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update arg-3 arg-4 arg-5 e-14) (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update arg-3 arg-4 arg-5 e-15))))))) ((5) (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (let ((e-19 (vector-ref arg-7 4))) (vector 5 e-16 e-17 (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update arg-3 arg-4 arg-5 e-18) (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update arg-3 arg-4 arg-5 e-19))))))) ((6) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (let ((sc1 (DataC-45List-lookup (csegen-802) e-21 arg-5))) (if (null? sc1) (vector 6 e-20 e-21) (let ((e-2 (unbox sc1))) (vector 6 e-20 e-2)))))))(else arg-7))))
(define CoreC-45CaseC-45CaseBuilder-n--13300-6894-u--update (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-3 0) ((6) (let ((e-5 (vector-ref e-3 2))) (box (cons e-5 e-2))))(else '())))))))
(define CoreC-45CaseC-45CaseBuilder-n--20839-13815-u--toClosed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-4 (vector-ref e-3 0))) (let ((e-5 (vector-ref e-3 1))) (let ((e-6 (vector-ref e-3 2))) (let ((e-7 (vector-ref e-3 3))) (cons (CoreC-45CaseC-45CaseBuilder-n--20839-13814-u--close arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 e-5 e-2 e-6) (CoreC-45CaseC-45CaseBuilder-n--20839-13814-u--close arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 e-5 e-2 e-7))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--11187-5101-u--splitCon (lambda (arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-13 (PreludeC-45TypesC-45List-length arg-14)))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45CaseC-45CaseBuilder-n--9938-3987-u--showAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) "" (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-3) (if (null? arg-5) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_Pat (let ((e-4 (vector-ref e-8 2))) e-4)) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 arg-3 (let ((e-6 (vector-ref e-8 3))) e-6)) (PreludeC-45TypesC-45String-C-43C-43 "]" (PreludeC-45TypesC-45String-C-43C-43 ", " (CoreC-45CaseC-45CaseBuilder-n--9938-3987-u--showAll arg-0 arg-1 arg-2 arg-3 e-3 e-9)))))))))) (let ((e-14 (car arg-5))) (let ((e-15 (cdr arg-5))) (if (null? e-15) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_Pat (let ((e-4 (vector-ref e-14 2))) e-4)) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 arg-3 (let ((e-6 (vector-ref e-14 3))) e-6)) "]"))))) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_Pat (let ((e-4 (vector-ref e-8 2))) e-4)) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 arg-3 (let ((e-6 (vector-ref e-8 3))) e-6)) (PreludeC-45TypesC-45String-C-43C-43 "]" (PreludeC-45TypesC-45String-C-43C-43 ", " (CoreC-45CaseC-45CaseBuilder-n--9938-3987-u--showAll arg-0 arg-1 arg-2 arg-3 e-3 e-9)))))))))))))) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseTree-u--show_Show_Pat (let ((e-4 (vector-ref e-8 2))) e-4)) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 arg-3 (let ((e-6 (vector-ref e-8 3))) e-6)) (PreludeC-45TypesC-45String-C-43C-43 "]" (PreludeC-45TypesC-45String-C-43C-43 ", " (CoreC-45CaseC-45CaseBuilder-n--9938-3987-u--showAll arg-0 arg-1 arg-2 arg-3 e-3 e-9))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--15810-9155-u--scores (lambda (arg-2 arg-3 arg-4 arg-5 arg-8) (if (null? arg-8) '() (let ((e-4 (car arg-8))) (let ((e-5 (cdr arg-8))) (let ((u--score (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--15810-9154-u--isBlank arg-2 arg-3 arg-4 arg-5 (let ((e-7 (vector-ref e-4 2))) e-7)))) (cond ((equal? sc1 1) 0) (else 1))))) (cons u--score (CoreC-45CaseC-45CaseBuilder-n--15810-9155-u--scores arg-2 arg-3 arg-4 arg-5 e-5))))))))
(define CoreC-45CaseC-45CaseBuilder-n--15557-8914-u--scoreFirstColumn (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9) (if (null? arg-9) (cons '() (cons 0 '())) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-7 (car e-2))) (let ((e-8 (cdr e-2))) (let ((u--ps (cons arg-1 arg-2))) (let ((sc2 (CoreC-45CaseC-45CaseBuilder-n--15557-8914-u--scoreFirstColumn arg-1 arg-2 arg-3 arg-4 arg-5 u--ps e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (let ((e-6 (car e-4))) (let ((e-9 (cdr e-4))) (cons (cons e-8 e-5) (cons (+ 1 e-6) (cons (arg-5 (let ((e-11 (vector-ref e-7 2))) e-11)) e-9))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--15557-8915-u--scoreColumns (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) '() (let ((e-3 (cdr arg-7))) (let ((u--ps (cons arg-1 arg-2))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--15557-8914-u--scoreFirstColumn arg-1 arg-2 arg-3 arg-4 arg-5 u--ps arg-8))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((e-7 (cdr e-4))) (cons e-7 (CoreC-45CaseC-45CaseBuilder-n--15557-8915-u--scoreColumns arg-1 arg-2 arg-3 arg-4 arg-5 u--ps e-3 e-5)))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--16201-9525-u--sameTypeAs (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (lambda (clam-0) (if (null? arg-13) (vector 1 0) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 2))) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-9 arg-2 e-7 arg-5 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((sc4 (CoreC-45CaseC-45CaseBuilder-n--16201-9524-u--headEq arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 e-8 arg-7))) (cond ((equal? sc4 1) ((CoreC-45CaseC-45CaseBuilder-n--16201-9525-u--sameTypeAs arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) clam-0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 42 arg-8 arg-6 (vector 1 )) clam-0))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 42 arg-8 arg-6 (vector 1 )) clam-0)))))))))
(define CoreC-45CaseC-45CaseBuilder-n--16637-9907-u--samePatAs (lambda (arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (case (vector-ref arg-5 0) ((2) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (let ((e-3 (vector-ref arg-5 4))) (if (null? arg-6) 0 (let ((e-22 (car arg-6))) (let ((e-23 (cdr arg-6))) (case (vector-ref e-22 0) ((2) (let ((e-25 (vector-ref e-22 2))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-25))) (cond ((equal? sc4 1) (CoreC-45CaseC-45CaseBuilder-n--16637-9907-u--samePatAs arg-3 arg-4 (vector 2 e-0 e-1 e-2 e-3) e-23)) (else 0)))))(else 0)))))))))) ((1) (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((e-6 (vector-ref arg-5 3))) (let ((e-7 (vector-ref arg-5 4))) (let ((e-8 (vector-ref arg-5 5))) (if (null? arg-6) 0 (let ((e-29 (car arg-6))) (let ((e-30 (cdr arg-6))) (case (vector-ref e-29 0) ((1) (let ((e-32 (vector-ref e-29 2))) (let ((e-33 (vector-ref e-29 3))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-32))) (cond ((equal? sc4 1) (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 e-33))) (cond ((equal? sc5 1) (CoreC-45CaseC-45CaseBuilder-n--16637-9907-u--samePatAs arg-3 arg-4 (vector 1 e-4 e-5 e-6 e-7 e-8) e-30)) (else 0)))) (else 0))))))(else 0))))))))))) ((3) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (if (null? arg-6) 0 (let ((e-37 (car arg-6))) (let ((e-38 (cdr arg-6))) (case (vector-ref e-37 0) ((3) (let ((e-40 (vector-ref e-37 2))) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Constant e-10 e-40))) (cond ((equal? sc4 1) (CoreC-45CaseC-45CaseBuilder-n--16637-9907-u--samePatAs arg-3 arg-4 (vector 3 e-9 e-10) e-38)) (else 0)))))(else 0)))))))) ((4) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (if (null? arg-6) 0 (let ((e-42 (car arg-6))) (let ((e-43 (cdr arg-6))) (case (vector-ref e-42 0) ((4) (CoreC-45CaseC-45CaseBuilder-n--16637-9907-u--samePatAs arg-3 arg-4 (vector 4 e-11 e-12 e-13 e-14) e-43))(else 0)))))))))) ((5) (let ((e-15 (vector-ref arg-5 1))) (let ((e-16 (vector-ref arg-5 2))) (let ((e-17 (vector-ref arg-5 3))) (let ((e-18 (vector-ref arg-5 4))) (if (null? arg-6) 0 (let ((e-49 (car arg-6))) (let ((e-50 (cdr arg-6))) (case (vector-ref e-49 0) ((5) (CoreC-45CaseC-45CaseBuilder-n--16637-9907-u--samePatAs arg-3 arg-4 (vector 5 e-15 e-16 e-17 e-18) e-50))(else 0)))))))))) ((6) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (if (null? arg-6) 0 (let ((e-56 (car arg-6))) (let ((e-57 (cdr arg-6))) (case (vector-ref e-56 0) ((6) (CoreC-45CaseC-45CaseBuilder-n--16637-9907-u--samePatAs arg-3 arg-4 (vector 6 e-19 e-20) e-57))(else 0))))))))(else 0)))))
(define CoreC-45CaseC-45CaseBuilder-n--20360-13319-u--rep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((3) (let ((e-1 (vector-ref arg-6 1))) (let ((act-24 (CoreC-45CaseC-45Util-getCons arg-5 arg-0 arg-3 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45Util-mkAlt arg-0 arg-4 e-1 eta-0)) e-5))))))))(else (vector 1 (cons arg-6 '()))))))
(define CoreC-45CaseC-45CaseBuilder-n--10069-4113-u--prettyAll (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-8 (car arg-6))) (let ((e-9 (cdr arg-6))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "=") (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_Pat (let ((e-4 (vector-ref e-8 2))) e-4))))) (CoreC-45CaseC-45CaseBuilder-n--10069-4113-u--prettyAll arg-1 arg-2 arg-3 arg-4 e-3 e-9)))))))))
(define CoreC-45CaseC-45CaseBuilder-n--20839-13813-u--mkSubstEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-5 (cdr arg-9))) (cons (vector 1 arg-4 (vector 0 ) (vector 2 arg-8 arg-7)) (CoreC-45CaseC-45CaseBuilder-n--20839-13813-u--mkSubstEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-7 1 63) arg-8 e-5))))))
(define CoreC-45CaseC-45CaseBuilder-n--19496-12554-u--mkPatClausesFrom (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (if (null? arg-10) (vector 1 '()) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-mkPatClause arg-7 arg-6 arg-5 arg-9 arg-3 arg-8 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45CaseC-45CaseBuilder-n--19496-12554-u--mkPatClausesFrom arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (bs+ arg-8 1 63) arg-9 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6)))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--19120-12110-u--mkNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-8) (cond ((equal? arg-10 0) (lambda (eta-0) (vector 1 '())))(else (blodwen-error-quit "Nat case not covered"))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-8 (car arg-9))) (let ((e-9 (cdr arg-9))) (cond ((equal? arg-10 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-16 (- arg-10 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? arg-11) (vector 1 (cons '() (vector 2 ))) (let ((e-4 (unbox arg-11))) (case (vector-ref e-4 0) ((0) (let ((e-12 (vector-ref e-4 1))) (let ((e-10 (vector-ref e-4 3))) (let ((e-7 (vector-ref e-4 4))) (case (vector-ref e-10 0) ((2) (let ((e-15 (vector-ref e-10 2))) (let ((e-13 (vector-ref e-10 4))) (let ((act-26 (((e-7 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 1 e-12 (vector 0 ) e-2))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-7 '() e-6 '() e-13 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-19 (vector-ref act-27 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-27 1))) (vector 1 (cons (box e-18) (vector 0 e-15 (CoreC-45TT-embed e-19)))))))))))))))(else (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 '() e-6 '() e-4 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) (vector 1 (cons '() (vector 1 (CoreC-45TT-embed e-13))))))))))))))(else (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 '() e-6 '() e-4 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cons '() (vector 1 (CoreC-45TT-embed e-7)))))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45CaseC-45CaseBuilder-n--19120-12110-u--mkNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 e-9 e-16 (Builtin-fst e-7)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (vector 1 (cons (vector 0 e-2 e-8 (Builtin-snd e-7)) (CoreC-45CaseC-45CaseBuilder-weaken e-2 e-3 e-10))))))))))))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--20839-13812-u--labelPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (cons (cons (PreludeC-45TypesC-45String-C-43C-43 "pat" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-7) ":")) e-2) (CoreC-45CaseC-45CaseBuilder-n--20839-13812-u--labelPat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-7 1 63) e-3)))))))
(define CoreC-45CaseC-45CaseBuilder-n--15810-9154-u--isBlank (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((6) 1)(else 0))))
(define CoreC-45CaseC-45CaseBuilder-n--16201-9524-u--headEq (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-11 0) ((0) (let ((e-6 (vector-ref arg-11 3))) (case (vector-ref e-6 0) ((2) (case (vector-ref arg-12 0) ((0) (let ((e-34 (vector-ref arg-12 3))) (case (vector-ref e-34 0) ((2) 1)(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))) ((3) (let ((e-10 (vector-ref arg-11 2))) (case (vector-ref arg-12 0) ((3) (let ((e-43 (vector-ref arg-12 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-43)))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))) ((8) (let ((e-16 (vector-ref arg-11 2))) (case (vector-ref arg-12 0) ((8) (let ((e-49 (vector-ref arg-12 2))) (CoreC-45TT-u--C-61C-61_Eq_Constant e-16 e-49)))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))) ((10) (case (vector-ref arg-12 0) ((10) 1)(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))) ((1) (let ((e-21 (vector-ref arg-11 2))) (case (vector-ref e-21 0) ((1) (let ((e-54 (vector-ref e-21 2))) (case (vector-ref arg-12 0) ((1) (let ((e-57 (vector-ref arg-12 2))) (case (vector-ref e-57 0) ((1) (let ((e-61 (vector-ref e-57 2))) (if (null? arg-13) (CoreC-45Name-u--C-61C-61_Eq_Name e-54 e-61) (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))) ((9) (if (null? arg-13) 1 (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))))
(define CoreC-45CaseC-45CaseBuilder-n--20839-13811-u--getUnreachable (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((sc1 (PreludeC-45Types-elem (csegen-225) arg-6 arg-7))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-n--20839-13811-u--getUnreachable arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-6 1 63) arg-7 e-3)) (else (cons e-2 (CoreC-45CaseC-45CaseBuilder-n--20839-13811-u--getUnreachable arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-6 1 63) arg-7 e-3))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--19496-12555-u--getNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (cons '() (CoreC-45TTC-45SizeOf-zero)) (let ((e-3 (cdr arg-9))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--19496-12555-u--getNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (bs+ arg-8 1 63) e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (cons (vector 2 "arg" arg-8) e-5) (CoreC-45TTC-45SizeOf-suc e-4)))))))))
(define CoreC-45CaseC-45CaseBuilder-n--11187-5103-u--getClauseType (lambda (arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-13) (case (vector-ref arg-14 0) ((0) (let ((e-5 (vector-ref arg-14 3))) (CoreC-45CaseC-45CaseBuilder-n--11187-5103-u--getClauseType arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-5 arg-15)))(else (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) e-1))) (cond ((equal? sc2 1) 1) (else (CoreC-45CaseC-45CaseBuilder-n--11187-5102-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))))(else (CoreC-45CaseC-45CaseBuilder-n--11187-5102-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))) (let ((e-6 (unbox arg-13))) (case (vector-ref arg-14 0) ((1) (let ((e-10 (vector-ref arg-14 4))) (let ((e-11 (vector-ref arg-14 5))) (case (vector-ref arg-15 0) ((0) (let ((e-13 (vector-ref arg-15 1))) (let ((sc3 (let ((sc4 (AlgebraC-45Semiring-isErased (csegen-475) e-13))) (cond ((equal? sc4 1) (let ((sc5 (AlgebraC-45Semiring-isErased (csegen-475) e-6))) (cond ((equal? sc5 1) 0) (else (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesIn (PreludeC-45TypesC-45List-tailRecAppend arg-11 (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-namesFrom eta-1)) (CoreC-45CaseC-45CaseBuilder-getPatInfo arg-8))) eta-0)) e-11))))) (else 0))))) (cond ((equal? sc3 1) 1) (else (CoreC-45CaseC-45CaseBuilder-n--11187-5101-u--splitCon arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-11))))))(else (case (vector-ref arg-14 0) ((0) (let ((e-5 (vector-ref arg-14 3))) (CoreC-45CaseC-45CaseBuilder-n--11187-5103-u--getClauseType arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-5 arg-15)))(else (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((sc3 (AlgebraC-45Semiring-isErased (csegen-475) e-1))) (cond ((equal? sc3 1) 1) (else (CoreC-45CaseC-45CaseBuilder-n--11187-5102-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))))(else (CoreC-45CaseC-45CaseBuilder-n--11187-5102-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))))))))(else (case (vector-ref arg-14 0) ((0) (let ((e-5 (vector-ref arg-14 3))) (CoreC-45CaseC-45CaseBuilder-n--11187-5103-u--getClauseType arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-5 arg-15)))(else (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) e-1))) (cond ((equal? sc2 1) 1) (else (CoreC-45CaseC-45CaseBuilder-n--11187-5102-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))))(else (CoreC-45CaseC-45CaseBuilder-n--11187-5102-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14)))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--20839-13710-u--getArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45CaseC-45CaseBuilder-n--20839-13710-u--getArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (cons (vector 2 "arg" arg-5) e-11)))))))))))))))(else (vector 1 '())))))))(else (vector 1 '()))))))
(define CoreC-45CaseC-45CaseBuilder-n--13543-7124-u--gc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-12)) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (let ((e-9 (vector-ref e-2 3))) (lambda (clam-0) (let ((e-13 (car e-7))) (let ((e-14 (cdr e-7))) (let ((e-17 (vector-ref e-13 0))) (let ((e-19 (vector-ref e-13 2))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--13543-7123-u--addGroup arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-17 e-19 e-14 e-8 e-9 arg-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45CaseC-45CaseBuilder-n--13543-7124-u--gc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5 e-3) clam-0))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--20754-13632-u--findExtraAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-3 (vector-ref arg-10 3))) (let ((e-4 (vector-ref arg-10 4))) (CoreC-45CaseC-45CaseBuilder-findExtraDefaults arg-9 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-8 arg-7 e-4)))) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((e-8 (vector-ref arg-10 3))) (CoreC-45CaseC-45CaseBuilder-findExtraDefaults arg-9 (cons e-6 (cons e-7 arg-0)) arg-8 arg-7 e-8))))) ((2) (let ((e-11 (vector-ref arg-10 2))) (CoreC-45CaseC-45CaseBuilder-findExtraDefaults arg-9 arg-0 arg-8 arg-7 e-11))) (else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45CaseC-45CaseBuilder-n--20360-13320-u--dropRep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) (cons '() arg-7) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (let ((u--c (vector 0 e-5 e-6 e-7 e-8))) (CoreC-45CaseC-45CaseBuilder-case--identifyUnreachableDefaultsC-44dropRep-13368 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 e-8 e-6 e-5 u--c e-3 arg-7 (DataC-45List-partition (lambda (eta-0) (let ((sc2 (CoreC-45CaseC-45Util-tagIs e-6 eta-0))) (cond ((equal? sc2 1) 0) (else 1)))) e-3))))))))(else (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--20360-13320-u--dropRep arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 arg-7))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (cons e-2 e-5) e-4)))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--16637-9906-u--dropAs (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 3))) e-2))(else arg-5))))
(define CoreC-45CaseC-45CaseBuilder-n--20839-13814-u--close (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (CoreC-45TTC-45SubstEnv-substs (CoreC-45CaseC-45CaseBuilder-n--20839-13813-u--mkSubstEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 arg-8 arg-7) arg-9)))
(define CoreC-45CaseC-45CaseBuilder-n--11187-5102-u--clauseTypeC-39 (lambda (arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((1) (let ((e-3 (vector-ref arg-13 4))) (let ((e-4 (vector-ref arg-13 5))) (CoreC-45CaseC-45CaseBuilder-n--11187-5101-u--splitCon arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 e-4)))) ((2) (let ((e-7 (vector-ref arg-13 3))) (let ((e-8 (vector-ref arg-13 4))) (CoreC-45CaseC-45CaseBuilder-n--11187-5101-u--splitCon arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-7 e-8)))) ((3) 0) ((4) 0) ((5) 0)(else 1))))
(define CoreC-45CaseC-45CaseBuilder-n--17637-11267-u--altGroups (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--e) (lambda (eta-0) (vector 1 (cons (vector 3 u--e) '()))))) arg-4) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-8 (vector-ref e-2 3))) (let ((e-9 (vector-ref e-2 4))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-match (PreludeC-45TypesC-45List-tailRecAppend e-6 arg-3) (PreludeC-45TypesC-45List-tailRecAppend e-6 arg-1) arg-12 arg-11 arg-10 arg-9 arg-8 e-9 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree (CoreC-45TTC-45SizeOf-mkSizeOf e-6) eta-0)) arg-4)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-n--17637-11267-u--altGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (cons (vector 0 e-7 e-8 e-6 e-5) e-10))))))))))))))) ((1) (let ((e-12 (vector-ref e-2 1))) (let ((e-13 (vector-ref e-2 2))) (let ((e-14 (vector-ref e-2 3))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-match (cons e-12 (cons e-13 arg-3)) (cons e-12 (cons e-13 arg-1)) arg-12 arg-11 arg-10 arg-9 arg-8 e-14 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree (CoreC-45TTC-45SizeOf-mkSizeOf (cons e-12 (cons e-13 '()))) eta-0)) arg-4)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-n--17637-11267-u--altGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (vector 1 e-12 e-13 e-5) e-6)))))))))))))) (else (let ((e-17 (vector-ref e-2 1))) (let ((e-18 (vector-ref e-2 2))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-match arg-3 arg-1 arg-12 arg-11 arg-10 arg-9 arg-8 e-18 arg-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-n--17637-11267-u--altGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (vector 2 e-17 e-5) e-6))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--13543-7123-u--addGroup (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 arg-12 arg-13 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-13 0) ((0) (let ((e-0 (vector-ref arg-13 1))) (let ((e-1 (vector-ref arg-13 2))) (let ((e-2 (vector-ref arg-13 3))) (CoreC-45CaseC-45CaseBuilder-n--13543-7123-u--addGroup arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 arg-12 e-2 arg-15 arg-16 (CoreC-45TT-substName e-1 (vector 0 e-0 (box 1) arg-12) arg-17) arg-18))))) ((1) (let ((e-3 (vector-ref arg-13 1))) (let ((e-4 (vector-ref arg-13 2))) (let ((e-5 (vector-ref arg-13 3))) (let ((e-6 (vector-ref arg-13 4))) (let ((e-7 (vector-ref arg-13 5))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 (PreludeC-45TypesC-45List-length e-7)))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-n--13543-7120-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-4 e-5 e-7 arg-15 arg-16 arg-17 arg-18)) (else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 42 e-3 arg-5 (vector 3 e-4)) eta-0))))))))))) ((2) (let ((e-8 (vector-ref arg-13 1))) (let ((e-9 (vector-ref arg-13 2))) (let ((e-10 (vector-ref arg-13 3))) (let ((e-11 (vector-ref arg-13 4))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-10 (PreludeC-45TypesC-45List-length e-11)))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-n--13543-7120-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-9 0 e-11 arg-15 arg-16 arg-17 arg-18)) (else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 42 e-8 arg-5 (vector 3 e-9)) eta-0)))))))))) ((4) (let ((e-14 (vector-ref arg-13 3))) (let ((e-15 (vector-ref arg-13 4))) (CoreC-45CaseC-45CaseBuilder-n--13543-7120-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 (vector 1 (vector 0 "->")) 0 (cons e-14 (cons e-15 '())) arg-15 arg-16 arg-17 arg-18)))) ((5) (let ((e-18 (vector-ref arg-13 3))) (let ((e-19 (vector-ref arg-13 4))) (CoreC-45CaseC-45CaseBuilder-n--13543-7121-u--addDelayG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-18 e-19 arg-15 arg-16 arg-17 arg-18)))) ((3) (let ((e-21 (vector-ref arg-13 2))) (CoreC-45CaseC-45CaseBuilder-n--13543-7122-u--addConstG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-21 arg-15 arg-16 arg-17 arg-18)))(else (lambda (eta-0) (vector 1 arg-18))))))
(define CoreC-45CaseC-45CaseBuilder-n--13543-7121-u--addDelayG (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) (let ((u--dty (vector 0 arg-6 (vector 2 "a" 0) (vector 2 arg-6 (csegen-21) (vector 1 ) (vector 1 (CoreC-45Value-defaultOpts) (CoreC-45Env-mkEnv arg-6 arg-9) (vector 10 arg-6))) (lambda (u--d) (lambda (u--a) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-9 u--d u--a) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 arg-6 (vector 2 "x" 0) (vector 2 arg-6 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) u--a) (lambda (u--dv) (lambda (u--av) (lambda (eta-1) (vector 1 (vector 5 arg-6 2 e-5))))))))))))))))) (lambda (eta-0) (let ((act-24 (CoreC-45CaseC-45CaseBuilder-nextNames arg-9 arg-8 arg-7 arg-6 "e" (cons arg-11 (cons arg-12 '())) (box u--dty) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Error compiling Delay pattern match") eta-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (if (null? e-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Error compiling Delay pattern match") eta-0) (let ((e-7 (car e-2))) (let ((e-6 (cdr e-2))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Error compiling Delay pattern match") eta-0) (let ((e-8 (car e-6))) (let ((e-9 (cdr e-6))) (if (null? e-9) (if (null? e-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Error compiling Delay pattern match") eta-0) (let ((e-13 (car e-3))) (let ((e-14 (cdr e-3))) (let ((u--patsC-39 (CoreC-45CaseC-45CaseBuilder-updatePatNames (CoreC-45CaseC-45CaseBuilder-updateNames (cons (cons e-7 arg-11) (cons (cons e-8 arg-12) '()))) (CoreC-45CaseC-45CaseBuilder-weakenNs e-13 arg-13)))) (let ((u--clause (vector arg-4 (CoreC-45CaseC-45CaseBuilder-C-43C-43 e-14 u--patsC-39) arg-14 (CoreC-45TT-u--weakenNs_Weaken_Term e-13 arg-15)))) (vector 1 (cons (vector 1 e-7 e-8 (cons u--clause '())) '()))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Error compiling Delay pattern match") eta-0))))))))))))))))) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addDelayG-7792 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 e-2 (CoreC-45CaseC-45CaseBuilder-checkGroupMatch (vector 1 ) '() e-2) e-3 arg-15 arg-14 arg-13 arg-12 arg-11))))))
(define CoreC-45CaseC-45CaseBuilder-n--13543-7122-u--addConstG (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (lambda (eta-0) (vector 1 (cons (vector 2 arg-11 (cons (vector arg-4 arg-12 arg-13 arg-14) '())) '()))) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addConstG-7966 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 e-2 arg-11 (CoreC-45CaseC-45CaseBuilder-checkGroupMatch (vector 2 arg-11) '() e-2) e-3 arg-14 arg-13 arg-12))))))
(define CoreC-45CaseC-45CaseBuilder-n--13543-7120-u--addConG (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (if (null? arg-17) (lambda (eta-0) (let ((act-24 (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-11 (vector 1 (vector 0 "->"))))) (cond ((equal? sc1 1) (vector 1 (vector 0 arg-6 (vector 2 "_" 0) (vector 2 arg-6 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 1 (CoreC-45Value-defaultOpts) (CoreC-45Env-mkEnv arg-6 arg-9) (vector 10 arg-6))) (lambda (u--d) (lambda (u--a) (lambda (eta-1) (vector 1 (vector 0 arg-6 (vector 2 "_" 1) (vector 2 arg-6 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 1 (CoreC-45Value-defaultOpts) (CoreC-45Env-mkEnv arg-6 arg-9) (vector 9 arg-6 0))) (lambda (d-0) (lambda (a-0) (lambda (eta-2) (vector 1 (vector 10 arg-6))))))))))))) (else (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact arg-11 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 9 arg-6 0)) (let ((e-1 (unbox e-6))) ((CoreC-45NormaliseC-45Eval-nf arg-7 arg-9 e-5 (CoreC-45Env-mkEnv arg-6 arg-9) (CoreC-45TT-embed e-1)) eta-0)))))))))))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45CaseC-45CaseBuilder-nextNames arg-9 arg-8 arg-7 arg-6 "e" arg-13 (box e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--patsC-39 (CoreC-45CaseC-45CaseBuilder-updatePatNames (CoreC-45CaseC-45CaseBuilder-updateNames (DataC-45List-u--zip_Zippable_List e-2 arg-13)) (CoreC-45CaseC-45CaseBuilder-weakenNs e-8 arg-14)))) (let ((u--clause (vector arg-4 (CoreC-45CaseC-45CaseBuilder-C-43C-43 e-7 u--patsC-39) arg-15 (CoreC-45TT-u--weakenNs_Weaken_Term e-8 arg-16)))) (vector 1 (cons (vector 0 e-2 arg-11 arg-12 (cons u--clause '())) '()))))))))))))))))) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addConG-7464 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 e-2 arg-13 arg-12 arg-11 (CoreC-45CaseC-45CaseBuilder-checkGroupMatch (vector 0 arg-11 arg-12) arg-13 e-2) e-3 arg-16 arg-15 arg-14))))))
(define CoreC-45CaseC-45CaseBuilder-u--weaken_Weaken_ArgType (lambda (arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (vector 0 e-1 (CoreC-45TT-u--weaken_Weaken_Term e-2))))) ((1) (let ((e-4 (vector-ref arg-2 1))) (vector 1 (CoreC-45TT-u--weaken_Weaken_Term e-4)))) (else (vector 2 )))))
(define CoreC-45CaseC-45CaseBuilder-u--weaken_Weaken_C-40PatInfoC-32C-36pC-41 (lambda (arg-3) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (vector (+ 1 e-2) e-3 e-4 (CoreC-45CaseC-45CaseBuilder-u--weaken_Weaken_ArgType e-6))))))))
(define CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_C-40PatInfoC-32C-36pC-41 (lambda (arg-3 arg-4) (CoreC-45CaseC-45CaseBuilder-case--weakenNs-4295 arg-4 arg-3 (CoreC-45TT-sizedView arg-3))))
(define CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40PartitionsC-32C-36psC-41 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (let ((e-6 (vector-ref arg-3 4))) (let ((e-7 (vector-ref arg-3 5))) (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45StringC-45Extra-unlines (cons "CON" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45TypesC-45String-C-43C-43 "  " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-4 e-3 eta-0))) e-6))) (PreludeC-45TypesC-45String-C-43C-43 "\xa;, " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40PartitionsC-32C-36psC-41 e-5 e-7))))))))) ((1) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45StringC-45Extra-unlines (cons "VAR" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45TypesC-45String-C-43C-43 "  " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-9 e-8 eta-0))) e-11))) (PreludeC-45TypesC-45String-C-43C-43 "\xa;, " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40PartitionsC-32C-36psC-41 e-10 e-12)))))))))(else "NONE"))))
(define CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (PreludeC-45TypesC-45String-C-43C-43 "Known " (PreludeC-45TypesC-45String-C-43C-43 (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-1) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-2))))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "Stuck " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-4)))) (else "Unknown"))))
(define CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-0 arg-1 arg-2) (let ((e-3 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-0 arg-1 e-3) (PreludeC-45TypesC-45String-C-43C-43 " => " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-0 arg-1 arg-2) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseBuilder-n--9938-3987-u--showAll arg-0 arg-1 arg-2 arg-0 arg-1 arg-2) "]"))))
(define CoreC-45CaseC-45CaseBuilder-u--showPrec_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 arg-0 arg-1 arg-3)))
(define CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40ArgTypeC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-2) ext-0)))) ((1) (let ((e-4 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-2292) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-4) ext-0))) (else (vector 1 (vector 2 ))))))
(define CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40PatInfoC-32C-36nC-41C-32C-36varsC-41 (lambda (arg-2 arg-3 ext-0) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Context-u--resolved_HasNames_Pat arg-2 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40ArgTypeC-32C-36varsC-41 arg-2 e-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector e-2 e-3 e-5 e-7))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-2 arg-3 ext-0) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-2293) (lambda (eta-3) (CoreC-45Core-traverseC-39 (lambda (eta-4) (CoreC-45Context-u--resolved_HasNames_Name arg-2 eta-4)) e-2 '() eta-3)) eta-2)) (lambda (eta-2) (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-2 e-3 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-4)) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-2 e-5) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (csegen-2296) (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40PatInfoC-32C-36nC-41C-32C-36varsC-41 arg-2 e-4 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-2 e-5 eta-0)) ext-0))))))
(define CoreC-45CaseC-45CaseBuilder-u--pretty_Pretty_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-1 arg-2 arg-3) (let ((e-3 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45CaseC-45CaseBuilder-u--pretty_Pretty_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-1 arg-2 e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "=>") (CoreC-45TT-u--pretty_Pretty_C-40TermC-32C-36varsC-41 arg-1 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-u--pretty_Pretty_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-1 arg-2 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (CoreC-45CaseC-45CaseBuilder-n--10069-4113-u--prettyAll arg-1 arg-2 arg-3 arg-1 arg-2 arg-3))))
(define CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40ArgTypeC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-2) ext-0)))) ((1) (let ((e-4 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-2292) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-4) ext-0))) (else (vector 1 (vector 2 ))))))
(define CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40PatInfoC-32C-36nC-41C-32C-36varsC-41 (lambda (arg-2 arg-3 ext-0) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((act-24 (CoreC-45Context-u--full_HasNames_Pat arg-2 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40ArgTypeC-32C-36varsC-41 arg-2 e-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (vector e-2 e-3 e-5 e-7))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-2 arg-3 ext-0) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (csegen-2293) (lambda (eta-3) (CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (CoreC-45Context-u--full_HasNames_Name arg-2 eta-4 eta-5))) e-2 '() eta-3)) eta-2)) (lambda (eta-2) (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-2 e-3 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-4)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-2 e-5) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (csegen-2296) (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40PatInfoC-32C-36nC-41C-32C-36varsC-41 arg-2 e-4 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-2 e-5 eta-0)) ext-0))))))
(define CoreC-45CaseC-45CaseBuilder-zeroedScore (lambda (arg-2 arg-3) (cons arg-3 (DataC-45Vect-replicate (+ 1 (PreludeC-45TypesC-45List-length arg-2)) 0))))
(define CoreC-45CaseC-45CaseBuilder-weakenNs (lambda (arg-3 arg-4) (if (null? arg-4) '() (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (cons (CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_C-40PatInfoC-32C-36pC-41 arg-3 e-4) (CoreC-45CaseC-45CaseBuilder-weakenNs arg-3 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-weaken (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (cons (CoreC-45CaseC-45CaseBuilder-u--weaken_Weaken_C-40PatInfoC-32C-36pC-41 e-4) (CoreC-45CaseC-45CaseBuilder-weaken arg-1 arg-2 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-varRule (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--17657-11574-u--updateVar arg-2 arg-1 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 eta-0)) arg-8 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45CaseC-45CaseBuilder-match arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 arg-9) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-updatePats (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-1) (lambda (clam-0) (vector 1 '())) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref arg-4 0) ((0) (let ((e-11 (vector-ref arg-4 1))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (case (vector-ref e-13 0) ((2) (let ((e-17 (vector-ref e-13 2))) (let ((e-19 (vector-ref e-13 4))) (if (null? arg-5) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (lambda (clam-1) (let ((e-6 (vector-ref e-8 3))) (case (vector-ref e-6 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-10 (vector-ref act-24 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-10 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-15 arg-3 arg-4 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-20 (vector-ref act-26 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-26 1))) (vector 1 (cons (let ((e-24 (vector-ref e-8 0))) (let ((e-23 (vector-ref e-8 1))) (let ((e-22 (vector-ref e-8 2))) (vector e-24 e-23 e-22 (vector 1 e-20))))) e-9)))))))))))))))(else (vector 1 (cons e-8 e-9)))))))) (let ((e-23 (car arg-5))) (let ((e-24 (cdr arg-5))) (lambda (clam-0) (let ((e-6 (vector-ref e-23 3))) (case (vector-ref e-6 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-8 (vector-ref act-24 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-2 arg-0 e-9 arg-3 e-19 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (((e-14 e-8) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-3 (vector 1 e-11 (vector 0 ) e-2))) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-15 (vector-ref act-27 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45CaseC-45CaseBuilder-updatePats arg-0 e-3 arg-2 arg-3 e-15 e-24) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-20 (vector-ref act-28 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-28 1))) (vector 1 (cons (let ((e-26 (vector-ref e-23 0))) (let ((e-25 (vector-ref e-23 1))) (let ((e-22 (vector-ref e-23 2))) (vector e-26 e-25 e-22 (vector 0 e-17 e-10))))) e-20)))))))))))))))))))))))(else (vector 1 (cons e-23 e-24))))))))))))(else (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (lambda (clam-2) (let ((e-6 (vector-ref e-8 3))) (case (vector-ref e-6 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-10 (vector-ref act-24 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-10 clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-15 (vector-ref act-25 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-15 arg-3 arg-4 clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (vector 1 (cons (let ((e-20 (vector-ref e-8 0))) (let ((e-19 (vector-ref e-8 1))) (let ((e-18 (vector-ref e-8 2))) (vector e-20 e-19 e-18 (vector 1 e-16))))) e-9)))))))))))))))(else (vector 1 (cons e-8 e-9))))))))))))))(else (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (lambda (clam-3) (let ((e-6 (vector-ref e-8 3))) (case (vector-ref e-6 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-10 (vector-ref act-24 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-10 clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) (let ((act-26 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-11 arg-3 arg-4 clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (vector 1 (cons (let ((e-16 (vector-ref e-8 0))) (let ((e-15 (vector-ref e-8 1))) (let ((e-14 (vector-ref e-8 2))) (vector e-16 e-15 e-14 (vector 1 e-12))))) e-9)))))))))))))))(else (vector 1 (cons e-8 e-9)))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-updatePatNames (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (cons (let ((e-2 (vector-ref e-4 0))) (let ((e-3 (vector-ref e-4 1))) (let ((e-7 (vector-ref e-4 2))) (let ((e-6 (vector-ref e-4 3))) (vector e-2 e-3 (CoreC-45CaseC-45CaseBuilder-n--13324-6935-u--update e-5 e-4 arg-2 e-7) e-6))))) (CoreC-45CaseC-45CaseBuilder-updatePatNames arg-2 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-updateNames (lambda (ext-0) (DataC-45List-mapMaybe (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--13300-6894-u--update eta-0)) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-toPatClause (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (CoreC-45TT-getFnArgs e-2))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-8 (vector-ref e-5 1))) (let ((e-6 (vector-ref e-5 2))) (let ((e-7 (vector-ref e-5 3))) (case (vector-ref e-6 0) ((1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-getPosition arg-2 (let ((e-0 (vector-ref e-9 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((e-12 (car e-10))) (let ((act-26 ((CoreC-45Context-getPosition e-7 (let ((e-0 (vector-ref e-9 0))) e-0)) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) (let ((e-15 (car e-13))) (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-12 e-15))) (cond ((equal? sc9 1) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-argToPat arg-0 eta-0)) e-4 '() clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (vector 1 (cons e-16 e-3))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-8 (PreludeC-45TypesC-45String-C-43C-43 "Wrong function name in pattern LHS " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2299) (cons arg-2 e-7)))) clam-0)))))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "Not a function name in pattern LHS") clam-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-1 "Not a function name in pattern LHS") clam-0)))))))))))
(define CoreC-45CaseC-45CaseBuilder-tail (lambda (arg-3) (let ((e-4 (cdr arg-3))) e-4)))
(define CoreC-45CaseC-45CaseBuilder-substInPats (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-1) (vector 1 '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-6))) (let ((e-9 (cdr arg-6))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-substInPatInfo e-2 arg-0 e-3 arg-2 arg-3 arg-4 arg-5 e-8 e-9) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-0 e-3 arg-2 arg-3 arg-4 arg-5 e-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (cons e-6 e-7))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-substInPatInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-case--substInPatInfo-3274 arg-2 arg-1 arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 (let ((e-6 (vector-ref arg-7 3))) e-6) eta-0))))
(define CoreC-45CaseC-45CaseBuilder-substInClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (vector-ref arg-5 0))) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (lambda (clam-0) (let ((e-9 (car e-3))) (let ((e-10 (cdr e-3))) (let ((e-13 (vector-ref e-9 0))) (let ((e-14 (vector-ref e-9 1))) (let ((e-15 (vector-ref e-9 2))) (let ((e-17 (vector-ref e-9 3))) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-1 arg-2 arg-3 arg-4 arg-0 (CoreC-45CaseC-45CaseTree-mkTerm arg-1 e-15) e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector e-2 (cons (vector e-13 e-14 e-15 e-17) e-6) e-4 e-5)))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-simpleCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (vector 1 (csegen-2302))) (lambda (eta-2) (CoreC-45Context-toFullNames arg-0 (csegen-76) e-2 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-toFullNames arg-0 (csegen-76) e-3 eta-1)) clam-0))))) arg-6 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "simpleCase: Clauses:\xa;" (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Basics-flip (csegen-2303) e-5 (lambda (lamc-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45TT-u--pretty_Pretty_C-40TermC-32C-36varsC-41 '() (Builtin-fst lamc-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "=") (CoreC-45TT-u--pretty_Pretty_C-40TermC-32C-36varsC-41 '() (Builtin-snd lamc-0)))))))))))))))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-toPatClause arg-0 arg-1 arg-3 eta-0)) arg-6 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((CoreC-45CaseC-45CaseBuilder-patCompile arg-0 arg-1 arg-3 arg-2 arg-4 e-6 arg-5) ext-0)))))))))))))
(define CoreC-45CaseC-45CaseBuilder-shuffleVars (lambda (arg-3 arg-5) (cond ((equal? arg-3 0) arg-5)(else (let ((e-2 (vector-ref arg-5 0))) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (vector e-2 (CoreC-45CaseC-45CaseBuilder-moveFirst arg-3 e-3) e-4 e-5)))))))))
(define CoreC-45CaseC-45CaseBuilder-sameType (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (if (null? arg-9) (vector 1 0) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (CoreC-45CaseC-45CaseBuilder-getFirstArgType e-2))) (case (vector-ref sc2 0) ((0) (let ((e-4 (vector-ref sc2 2))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-4 arg-2 e-5 arg-8 e-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45CaseC-45CaseBuilder-n--16201-9525-u--sameTypeAs arg-2 e-2 e-3 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-6 e-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-getFirstArgType eta-0)) e-3)) ext-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 42 arg-5 arg-7 (vector 1 )) ext-0)))))))))))))
(define CoreC-45CaseC-45CaseBuilder-samePat (lambda (arg-3) (if (null? arg-3) 1 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CoreC-45CaseC-45CaseBuilder-n--16637-9907-u--samePatAs e-2 e-3 (CoreC-45CaseC-45CaseBuilder-n--16637-9906-u--dropAs e-2 e-3 (CoreC-45CaseC-45CaseBuilder-getFirstPat e-2)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--16637-9906-u--dropAs e-2 e-3 (CoreC-45CaseC-45CaseBuilder-getFirstPat eta-0))) e-3)))))))
(define CoreC-45CaseC-45CaseBuilder-pickNextViable (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-2) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-samePat arg-8))) (cond ((equal? sc1 1) (vector 1 (cons arg-0 0))) (else (let ((act-24 (CoreC-45CaseC-45CaseBuilder-getScore arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (vector 1 (cons arg-0 0)))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 42 arg-5 arg-7 e-6) clam-0))))))))))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-samePat arg-8))) (cond ((equal? sc1 1) (vector 1 (cons arg-0 0))) (else (let ((act-24 (CoreC-45CaseC-45CaseBuilder-getScore arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-4 (vector-ref e-5 1))) (cond ((equal? e-4 0) (vector 1 (cons arg-0 0)))(else (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-pickNextViable e-2 arg-1 e-3 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-tail eta-0)) arg-8)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (vector 1 (cons e-8 (+ 1 e-7)))))))))))))(else (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-pickNextViable e-2 arg-1 e-3 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-tail eta-0)) arg-8)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons e-7 (+ 1 e-4))))))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-patCompile (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 (cons '() (vector 2 "No definition"))))) (lambda () (lambda (u--e) (lambda (eta-0) (vector 1 (cons '() u--e))))) arg-6) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-case--patCompile-12658 e-2 e-3 arg-6 arg-4 arg-3 arg-2 arg-1 arg-0 (CoreC-45CaseC-45CaseBuilder-n--19496-12555-u--getNames e-2 e-3 arg-6 arg-4 arg-3 arg-2 arg-1 arg-0 0 (Builtin-fst e-2)) eta-0)))))))
(define CoreC-45CaseC-45CaseBuilder-partition (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (vector 2 ) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (CoreC-45CaseC-45CaseBuilder-with--partition-5468 arg-0 arg-1 arg-2 e-3 arg-3 (CoreC-45CaseC-45CaseBuilder-partition arg-0 arg-1 arg-2 arg-3 e-3) e-2))))))
(define CoreC-45CaseC-45CaseBuilder-nextNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-5) (vector 1 (cons '() (cons (CoreC-45TTC-45SizeOf-zero) '()))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45CaseC-45CaseBuilder-nextName arg-1 arg-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--env (CoreC-45Env-mkEnv arg-3 arg-0))) (let ((act-27 (if (null? arg-6) (vector 1 (cons '() (vector 2 ))) (let ((e-4 (unbox arg-6))) (case (vector-ref e-4 0) ((0) (let ((e-11 (vector-ref e-4 1))) (let ((e-9 (vector-ref e-4 3))) (let ((e-8 (vector-ref e-4 4))) (case (vector-ref e-9 0) ((2) (let ((e-14 (vector-ref e-9 2))) (let ((e-12 (vector-ref e-9 4))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-0 e-5 e-12) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-16 (vector-ref act-27 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-27 1))) (case (vector-ref e-16 0) ((9) (let ((act-28 (((e-8 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) u--env (vector 1 e-11 (vector 0 ) e-7))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-28 1))) (vector 1 (cons (box e-18) (vector 2 ))))))))(else (let ((act-28 (((e-8 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) u--env (vector 1 e-11 (vector 0 ) e-7))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-17 (vector-ref act-28 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-28 1))) (let ((act-29 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-6 u--env e-16 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-18 (vector-ref act-29 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-29 1))) (vector 1 (cons (box e-17) (vector 0 e-14 e-18))))))))))))))))))))(else (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-6 u--env e-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (cons '() (vector 1 e-12)))))))))))))(else (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-6 u--env e-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons '() (vector 1 e-8))))))))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45CaseC-45CaseBuilder-nextNames arg-0 arg-1 arg-2 arg-3 arg-4 e-3 (Builtin-fst e-8) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((e-12 (car e-4))) (let ((e-11 (cdr e-4))) (let ((u--argTy (let ((sc8 (Builtin-snd e-8))) (case (vector-ref sc8 0) ((2) (vector 2 )) ((0) (let ((e-14 (vector-ref sc8 1))) (let ((e-13 (vector-ref sc8 2))) (vector 0 e-14 (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-suc e-12) e-13))))) (else (let ((e-13 (vector-ref sc8 1))) (vector 1 (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-suc e-12) e-13)))))))) (vector 1 (cons (cons e-7 e-10) (cons (CoreC-45TTC-45SizeOf-suc e-12) (cons (vector 0 e-7 e-2 u--argTy) (CoreC-45CaseC-45CaseBuilder-weaken e-7 (PreludeC-45TypesC-45List-tailRecAppend e-10 arg-0) e-11))))))))))))))))))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-nextName (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))))))
(define CoreC-45CaseC-45CaseBuilder-nextIdxByScore (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-3 0) (cons arg-1 0))(else (if (null? arg-4) (cond (else (DataC-45Maybe-fromMaybe (lambda () (cons arg-1 0)) (CoreC-45CaseC-45CaseBuilder-applyHeuristics arg-1 arg-2 (CoreC-45CaseC-45CaseBuilder-zeroedScore arg-2 arg-5) (cons (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-heuristicF arg-2 eta-0)) (cons (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-heuristicB (cons arg-1 arg-2) eta-0)) (cons (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-heuristicA (cons arg-1 arg-2) eta-0)) '()))))))) (cons arg-1 0))))))
(define CoreC-45CaseC-45CaseBuilder-newPats (lambda (arg-3 arg-4 arg-5) (if (null? arg-3) (cond ((equal? arg-4 0) '())(else (blodwen-error-quit "Nat case not covered"))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cond ((equal? arg-4 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-12 (- arg-4 1))) (let ((e-16 (car arg-5))) (let ((e-17 (cdr arg-5))) (cons (let ((e-7 (vector-ref e-16 0))) (let ((e-5 (vector-ref e-16 1))) (let ((e-6 (vector-ref e-16 3))) (vector e-7 e-5 e-2 e-6)))) (CoreC-45CaseC-45CaseBuilder-newPats e-3 e-12 e-17))))))))))))
(define CoreC-45CaseC-45CaseBuilder-namesIn (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((sc1 (PreludeC-45Types-elem (csegen-802) e-1 arg-0))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-2)) (else 0)))))) ((1) (let ((e-7 (vector-ref arg-1 5))) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 eta-0)) e-7))) ((2) (let ((e-11 (vector-ref arg-1 4))) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 eta-0)) e-11))) ((4) (let ((e-14 (vector-ref arg-1 3))) (let ((e-15 (vector-ref arg-1 4))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-14))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-15)) (else 0)))))) ((5) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-18))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-19)) (else 0)))))) ((6) (let ((e-21 (vector-ref arg-1 2))) (PreludeC-45Types-elem (csegen-802) e-21 arg-0)))(else 1))))
(define CoreC-45CaseC-45CaseBuilder-namesFrom (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (cons e-1 (CoreC-45CaseC-45CaseBuilder-namesFrom e-2))))) ((1) (let ((e-7 (vector-ref arg-0 5))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesFrom eta-0)) e-7))) ((2) (let ((e-11 (vector-ref arg-0 4))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesFrom eta-0)) e-11))) ((4) (let ((e-14 (vector-ref arg-0 3))) (let ((e-15 (vector-ref arg-0 4))) (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45CaseC-45CaseBuilder-namesFrom e-14) (CoreC-45CaseC-45CaseBuilder-namesFrom e-15))))) ((5) (let ((e-18 (vector-ref arg-0 3))) (let ((e-19 (vector-ref arg-0 4))) (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45CaseC-45CaseBuilder-namesFrom e-18) (CoreC-45CaseC-45CaseBuilder-namesFrom e-19))))) ((6) (let ((e-21 (vector-ref arg-0 2))) (cons e-21 '())))(else '()))))
(define CoreC-45CaseC-45CaseBuilder-moveFirst (lambda (arg-3 arg-5) (cons (CoreC-45CaseC-45CaseBuilder-getPat arg-3 arg-5) (CoreC-45CaseC-45CaseBuilder-dropPat arg-3 arg-5))))
(define CoreC-45CaseC-45CaseBuilder-mkPatClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 42 arg-1 arg-2 (vector 0 )) eta-0))) (lambda () (lambda (u--eq) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-4) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45CaseC-45CaseBuilder-n--19120-12110-u--mkNames e-2 e-3 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-3 e-2 u--eq (box e-6)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Make pat clause for names " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-3 arg-3 e-7) (PreludeC-45TypesC-45String-C-43C-43 " in LHS " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-847) e-2))))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (vector 1 (vector '() e-7 arg-5 (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-mkSizeOf arg-3) e-3))))))))))))))))))))) (LibrariesC-45DataC-45LengthMatch-checkLengthMatch arg-3 e-2))))))
(define CoreC-45CaseC-45CaseBuilder-mkPat (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (vector 1 (vector 6 e-1 e-3))) ((2) (let ((e-28 (vector-ref e-2 1))) (let ((e-29 (vector-ref e-2 2))) (vector 1 (vector 1 e-1 e-3 e-28 e-29 arg-1))))) ((3) (let ((e-31 (vector-ref e-2 2))) (vector 1 (vector 2 e-1 e-3 e-31 arg-1)))) ((1) (let ((act-24 (CoreC-45Context-getPrimitiveNames arg-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normalisePrims arg-0 '() (lambda (eta-0) 1) (lambda (eta-0) (CoreC-45CaseC-45CaseTree-isPConst eta-0)) 1 e-5 e-3 arg-1 arg-2 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Unmatchable function: " (CoreC-45Name-u--show_Show_Name e-3))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (vector 7 (CoreC-45TT-getLoc arg-2) arg-2))))) (let ((e-4 (unbox e-6))) (let ((sc5 (CoreC-45TT-u--C-47C-61_Eq_C-40TermC-32C-36varsC-41 e-4 arg-2))) (cond ((equal? sc5 1) ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-4 e-4) clam-0)) (else (vector 1 (vector 7 (CoreC-45TT-getLoc arg-2) arg-2))))))))))))))))(else (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Catchall: marking " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 (vector 7 (CoreC-45TT-getLoc arg-2) arg-2)))))))))))) ((3) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (case (vector-ref e-7 0) ((2) (let ((e-36 (vector-ref e-7 4))) (let ((u--tC-39 (CoreC-45TTC-45SubstEnv-subst (vector 10 e-5 0) e-8))) (lambda (eta-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-36 e-36) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() u--tC-39 u--tC-39) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (vector 4 e-5 e-6 e-9 e-10))))))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Catchall: marking " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 7 (CoreC-45TT-getLoc arg-2) arg-2))))))))))))) ((4) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-12 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 (cons e-5 arg-1) arg-2 e-11) eta-0))))))))) ((5) (let ((e-14 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 3))) (let ((e-17 (vector-ref arg-3 4))) (case (vector-ref e-16 0) ((1) (let ((e-39 (vector-ref e-16 2))) (let ((e-40 (vector-ref e-16 3))) (case (vector-ref e-39 0) ((0) (lambda (eta-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-17 e-17) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-14 e-40 e-5))))))))(else (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-17))))))(else (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-17))))))) ((7) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-22) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-19 e-20 e-5 e-6)))))))))))))))) ((9) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (CoreC-45TT-constTag e-25) 0))) (cond ((equal? sc1 1) (vector 3 e-24 e-25)) (else (vector 2 e-24 (vector 1 (vector 0 (CoreC-45TT-u--show_Show_Constant e-25))) 0 '()))))))))) ((11) (let ((e-27 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (vector 2 e-27 (vector 1 (vector 0 "Type")) 0 '())))))(else (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Catchall: marking " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 7 (CoreC-45TT-getLoc arg-2) arg-2))))))))))
(define CoreC-45CaseC-45CaseBuilder-mixture (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-9 0) ((0) (let ((e-3 (vector-ref arg-9 1))) (let ((e-5 (vector-ref arg-9 3))) (let ((e-6 (vector-ref arg-9 4))) (let ((e-7 (vector-ref arg-9 5))) (if (null? e-3) (lambda (clam-0) (vector 1 arg-10)) (lambda (eta-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-mixture arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6 arg-7 arg-8 e-7 arg-10) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-conRule arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 e-6 e-8) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (box e-9))))))))))))))))) ((1) (let ((e-8 (vector-ref arg-9 1))) (let ((e-10 (vector-ref arg-9 3))) (let ((e-11 (vector-ref arg-9 4))) (let ((e-12 (vector-ref arg-9 5))) (if (null? e-8) (lambda (clam-1) (vector 1 arg-10)) (lambda (eta-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-mixture arg-0 arg-1 arg-2 arg-3 arg-4 e-10 arg-6 arg-7 arg-8 e-12 arg-10) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45CaseC-45CaseBuilder-varRule arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 e-11 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box e-6)))))))))))))))))(else (lambda (clam-2) (vector 1 arg-10))))))
(define CoreC-45CaseC-45CaseBuilder-match (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-1) (if (null? arg-7) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 (vector 2 "No patterns")))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-8) (let ((e-6 (car arg-7))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (lambda (clam-0) (case (vector-ref e-13 0) ((10) (let ((e-17 (vector-ref e-13 2))) (cond ((equal? e-17 1) (vector 1 (vector 3 )))(else (vector 1 (vector 1 e-12 e-13))))))(else (vector 1 (vector 1 e-12 e-13)))))))))) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((u--nps (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-getNPs eta-0)) arg-7))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getSession arg-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45CaseC-45CaseBuilder-case--match-10863 arg-0 e-2 e-1 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 u--nps e-5 (CoreC-45CaseC-45CaseBuilder-nextIdxByScore e-1 e-2 (let ((e-23 (vector-ref e-5 23))) e-23) arg-6 u--nps)) eta-0))))))))))))
(define CoreC-45CaseC-45CaseBuilder-identifyUnreachableDefaults (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((8) (csegen-2310)) ((10) (csegen-2310))(else (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-n--20360-13319-u--rep arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 eta-0 eta-1))) arg-5 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45CaseC-45CaseBuilder-case--identifyUnreachableDefaults-13520 arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 e-5 (CoreC-45CaseC-45CaseBuilder-n--20360-13320-u--dropRep arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 (PreludeC-45Interfaces-concat (csegen-50) e-5) (csegen-2286))) ext-0)))))))))
(define CoreC-45CaseC-45CaseBuilder-highScoreIdx (lambda (arg-1 arg-2 arg-3) (let ((e-4 (cdr arg-3))) (let ((e-7 (car e-4))) (let ((e-8 (cdr e-4))) (CoreC-45CaseC-45CaseBuilder-highScore '() (cons arg-1 arg-2) (cons e-7 e-8) (bs- e-7 1 63) (cons arg-1 0) 0))))))
(define CoreC-45CaseC-45CaseBuilder-highScore (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-1) (cond ((equal? arg-5 1) '()) (else (box arg-4))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (car arg-2))) (let ((e-8 (cdr arg-2))) (let ((u--next (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45CaseC-45CaseBuilder-highScore (DataC-45List-snoc arg-0 e-2) e-3 e-8 eta-0 eta-1 eta-2)))))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-7 arg-3))) (cond ((equal? sc2 0) (((u--next arg-3) arg-4) arg-5)) ((equal? sc2 1) (((u--next arg-3) arg-4) 1)) (else (((u--next e-7) (cons e-2 (CoreC-45TT-weakenNVar (CoreC-45TTC-45SizeOf-mkSizeOf arg-0) 0))) 0))))))))))))
(define CoreC-45CaseC-45CaseBuilder-heuristicF (lambda (arg-2 arg-3) (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (if (null? e-3) arg-3 (let ((e-7 (car e-3))) (let ((e-8 (cdr e-3))) (let ((u--columnScores (CoreC-45CaseC-45CaseBuilder-n--15810-9155-u--scores arg-2 e-7 e-8 e-4 e-7))) (let ((u--ysC-39 (DataC-45Vect-u--zipWith_Zippable_C-40VectC-32C-36kC-41 (csegen-1026) e-4 u--columnScores))) (cons (cons e-7 e-8) u--ysC-39))))))))))
(define CoreC-45CaseC-45CaseBuilder-heuristicB (lambda (arg-1 ext-0) (CoreC-45CaseC-45CaseBuilder-consScoreHeuristic arg-1 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-headConsPenalty (lambda (u--arity) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_Nat u--arity 0))) (cond ((equal? sc0 1) 0) (else -1)))) eta-0)) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-heuristicA (lambda (arg-1 ext-0) (CoreC-45CaseC-45CaseBuilder-consScoreHeuristic arg-1 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-headConsPenalty (lambda (eta-1) (bs- 0 (PreludeC-45Cast-u--cast_Cast_Nat_Int eta-1) 63)) eta-0)) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-headConsPenalty (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 3))) (CoreC-45CaseC-45CaseBuilder-headConsPenalty arg-0 e-2))) ((1) (let ((e-6 (vector-ref arg-1 4))) (arg-0 e-6))) ((2) (let ((e-10 (vector-ref arg-1 3))) (arg-0 e-10))) ((3) 0) ((4) 0) ((5) (let ((e-21 (vector-ref arg-1 4))) (CoreC-45CaseC-45CaseBuilder-headConsPenalty arg-0 e-21))) ((6) 0) (else 0))))
(define CoreC-45CaseC-45CaseBuilder-groupCons (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (CoreC-45CaseC-45CaseBuilder-n--13543-7124-u--gc arg-0 arg-1 arg-2 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-1 arg-2 '() arg-8)))
(define CoreC-45CaseC-45CaseBuilder-getScore (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-24 (CoreC-45CaseC-45CaseBuilder-sameType arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (CoreC-45Env-mkEnv arg-5 arg-2) arg-8 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 1 0)))))) (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((42) (let ((e-2 (vector-ref lcase-0 3))) (vector 1 (vector 0 e-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-0))))) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-getPatInfo (lambda (arg-2) (if (null? arg-2) '() (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (cons (let ((e-7 (vector-ref e-4 2))) e-7) (CoreC-45CaseC-45CaseBuilder-getPatInfo e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-getPat (lambda (arg-3 arg-5) (cond ((equal? arg-3 0) (let ((e-4 (car arg-5))) e-4))(else (let ((e-0 (- arg-3 1))) (let ((e-10 (cdr arg-5))) (CoreC-45CaseC-45CaseBuilder-getPat e-0 e-10)))))))
(define CoreC-45CaseC-45CaseBuilder-getPMDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree.getpmdef" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "getPMDef: No clauses!") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-6 '() arg-4) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45CaseC-45CaseBuilder-n--20839-13710-u--getArgs arg-4 arg-3 arg-2 arg-1 arg-0 0 e-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons e-8 (cons (vector 2 "No clauses") '())))))))))))))))))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--cs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--20839-13815-u--toClosed arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 eta-0)) (CoreC-45CaseC-45CaseBuilder-n--20839-13812-u--labelPat arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 0 arg-5)))) (let ((act-25 (CoreC-45CaseC-45CaseBuilder-simpleCase arg-0 arg-1 arg-2 arg-3 arg-4 '() u--cs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-26 (let ((act-26 (CoreC-45Context-toFullNames arg-0 (csegen-2177) e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "compile.casetree.getpmdef" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Compiled to: " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-2 e-7)))) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((u--reached (CoreC-45CaseC-45CaseBuilder-findReached e-3))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree.clauses" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Reached clauses: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-246) u--reached))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 ((CoreC-45CaseC-45CaseBuilder-findExtraDefaults arg-0 e-2 arg-1 e-5 e-3) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--unreachable (CoreC-45CaseC-45CaseBuilder-n--20839-13811-u--getUnreachable arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 0 (DataC-45List-C-92C-92 (csegen-225) u--reached e-9) arg-5))) (vector 1 (cons e-2 (cons e-3 u--unreachable)))))))))))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-getNPs (lambda (arg-2) (let ((e-3 (vector-ref arg-2 1))) e-3)))
(define CoreC-45CaseC-45CaseBuilder-getFirstPat (lambda (arg-3) (let ((e-3 (car arg-3))) (let ((e-5 (vector-ref e-3 2))) e-5))))
(define CoreC-45CaseC-45CaseBuilder-getFirstArgType (lambda (arg-3) (let ((e-3 (car arg-3))) (let ((e-6 (vector-ref e-3 3))) e-6))))
(define CoreC-45CaseC-45CaseBuilder-findReachedAlts (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 4))) (CoreC-45CaseC-45CaseBuilder-findReached e-4))) ((1) (let ((e-8 (vector-ref arg-1 3))) (CoreC-45CaseC-45CaseBuilder-findReached e-8))) ((2) (let ((e-11 (vector-ref arg-1 2))) (CoreC-45CaseC-45CaseBuilder-findReached e-11))) (else (let ((e-13 (vector-ref arg-1 1))) (CoreC-45CaseC-45CaseBuilder-findReached e-13))))))
(define CoreC-45CaseC-45CaseBuilder-findReached (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 4))) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-findReachedAlts eta-0)) e-5))) ((1) (let ((e-7 (vector-ref arg-1 1))) (cons e-7 '())))(else '()))))
(define CoreC-45CaseC-45CaseBuilder-findExtraDefaults (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (let ((u--fenv (CoreC-45Env-mkEnv arg-2 arg-1))) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-3 u--fenv e-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45CaseC-45CaseBuilder-identifyUnreachableDefaults arg-0 arg-1 arg-2 arg-3 e-6 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-2316) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45CaseC-45CaseBuilder-n--20754-13632-u--findExtraAlts arg-1 e-5 e-4 e-2 e-1 arg-4 arg-3 arg-2 arg-0 eta-2)) e-5 '() eta-1)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45SortedSet-toList e-7) e-8)))))))))))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45CaseC-45CaseBuilder-dropPat (lambda (arg-3 arg-5) (cond ((equal? arg-3 0) (let ((e-5 (cdr arg-5))) e-5))(else (let ((e-0 (- arg-3 1))) (let ((e-9 (car arg-5))) (let ((e-10 (cdr arg-5))) (cons e-9 (CoreC-45CaseC-45CaseBuilder-dropPat e-0 e-10)))))))))
(define CoreC-45CaseC-45CaseBuilder-consScoreHeuristic (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-6 (car arg-3))) (let ((e-7 (cdr arg-3))) (if (null? e-6) arg-3 (let ((u--columnScores (PreludeC-45Interfaces-C-60C-36C-62 (csegen-2317) (lambda (eta-0) (PreludeC-45Interfaces-sum (cons (csegen-1006) (csegen-190)) eta-0)) (CoreC-45CaseC-45CaseBuilder-n--15557-8915-u--scoreColumns e-1 e-2 e-7 e-6 arg-2 arg-1 (cons e-1 e-2) e-6)))) (let ((u--ysC-39 (DataC-45Vect-u--zipWith_Zippable_C-40VectC-32C-36kC-41 (csegen-1026) e-7 u--columnScores))) (cons e-6 u--ysC-39))))))))))
(define CoreC-45CaseC-45CaseBuilder-conRule (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 (vector 2 "No constructor clauses")))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-9) (let ((e-2 (car arg-8))) (let ((e-6 (vector-ref e-2 0))) (let ((e-7 (vector-ref e-2 1))) (lambda (clam-0) (let ((e-13 (car e-7))) (let ((e-17 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-13 1))) (let ((e-21 (vector-ref e-13 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-substInClause arg-0 arg-1 arg-2 arg-4 arg-5 eta-0)) arg-8 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45CaseC-45CaseBuilder-groupCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (case (vector-ref e-21 0) ((0) (let ((e-4 (vector-ref e-21 2))) (vector 1 e-4)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 42 arg-5 arg-6 (vector 4 )) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-26 1))) (CoreC-45CaseC-45CaseBuilder-caseGroups e-18 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-17 e-11 e-10 arg-9 clam-0))))))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-clauseType (lambda (arg-3 arg-4) (let ((e-2 (vector-ref arg-4 0))) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) (let ((e-5 (vector-ref arg-4 3))) (let ((e-9 (car e-3))) (let ((e-10 (cdr e-3))) (let ((e-13 (vector-ref e-9 0))) (let ((e-14 (vector-ref e-9 1))) (let ((e-15 (vector-ref e-9 2))) (let ((e-17 (vector-ref e-9 3))) (CoreC-45CaseC-45CaseBuilder-n--11187-5103-u--getClauseType e-13 e-14 e-17 e-15 e-10 e-5 e-4 e-2 arg-3 arg-3 e-15 e-17)))))))))))))
(define CoreC-45CaseC-45CaseBuilder-checkGroupMatch (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (case (vector-ref arg-4 0) ((0) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((e-8 (vector-ref arg-4 4))) (if (null? e-8) (vector 3 ) (let ((e-10 (car e-8))) (let ((sc3 (LibrariesC-45DataC-45LengthMatch-checkLengthMatch arg-3 e-5))) (if (null? sc3) (vector 3 ) (let ((e-2 (unbox sc3))) (let ((sc4 (CoreC-45Name-nameEq e-0 e-6))) (if (null? sc4) (vector 3 ) (let ((e-9 (unbox sc4))) (cond ((equal? e-9 0) (let ((sc6 (DecidableC-45Equality-u--decEq_DecEq_Int e-1 e-7))) (case (vector-ref sc6 0) ((0) (let ((e-12 (vector-ref sc6 1))) (cond ((equal? e-12 0) (vector 0 e-1 e-2))(else (vector 3 )))))(else (vector 3 )))))(else (vector 3 ))))))))))))))))(else (vector 3 )))))) ((1) (if (null? arg-3) (case (vector-ref arg-4 0) ((1) (let ((e-23 (vector-ref arg-4 3))) (if (null? e-23) (vector 3 ) (let ((e-25 (car e-23))) (vector 1 )))))(else (vector 3 ))) (vector 3 ))) ((2) (let ((e-2 (vector-ref arg-2 1))) (if (null? arg-3) (case (vector-ref arg-4 0) ((2) (let ((e-36 (vector-ref arg-4 1))) (let ((e-37 (vector-ref arg-4 2))) (if (null? e-37) (vector 3 ) (let ((e-39 (car e-37))) (let ((sc4 (CoreC-45TT-constantEq e-2 e-36))) (if (null? sc4) (vector 3 ) (let ((e-3 (unbox sc4))) (cond (else (vector 2 )))))))))))(else (vector 3 ))) (vector 3 ))))(else (vector 3 )))))
(define CoreC-45CaseC-45CaseBuilder-caseGroups (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 arg-12 ext-0) (let ((act-24 ((CoreC-45CaseC-45CaseBuilder-n--17637-11267-u--altGroups arg-0 arg-2 arg-8 arg-1 arg-12 arg-11 arg-10 arg-7 arg-6 arg-5 arg-4 arg-3 arg-11) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 arg-0 arg-8 (CoreC-45TT-resolveNames arg-1 arg-10) e-5))))))))
(define CoreC-45CaseC-45CaseBuilder-argToPat (lambda (arg-0 arg-1) (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-1 arg-1)))
(define CoreC-45CaseC-45CaseBuilder-applyHeuristics (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (CoreC-45CaseC-45CaseBuilder-highScoreIdx arg-1 arg-2 arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (CoreC-45CaseC-45CaseBuilder-highScoreIdx arg-1 arg-2 arg-3) (lambda () (CoreC-45CaseC-45CaseBuilder-applyHeuristics arg-1 arg-2 (e-2 arg-3) e-3))))))))
(define CoreC-45CaseC-45CaseBuilder-C-43C-43 (lambda (arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (cons e-4 (CoreC-45CaseC-45CaseBuilder-C-43C-43 e-5 arg-4)))))))
(define LibrariesC-45DataC-45SortedSet-u--show_Show_C-40SortedSetC-32C-36kC-41 (lambda (arg-1 ext-0) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-1 (LibrariesC-45DataC-45SortedSet-toList ext-0))))
(define LibrariesC-45DataC-45SortedSet-u--null_Foldable_SortedSet (lambda (arg-1) (LibrariesC-45DataC-45SortedMap-u--null_Foldable_C-40SortedMapC-32C-36kC-41 arg-1)))
(define LibrariesC-45DataC-45SortedSet-u--neutral_Monoid_C-40SortedSetC-32C-36kC-41 (lambda (arg-1) (LibrariesC-45DataC-45SortedSet-empty arg-1)))
(define LibrariesC-45DataC-45SortedSet-u--foldr_Foldable_SortedSet (lambda (arg-2 arg-3 arg-4) (PreludeC-45Types-u--foldr_Foldable_List arg-2 arg-3 (LibrariesC-45DataC-45SortedSet-toList arg-4))))
(define LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45SortedSet-union ext-0 ext-1)))
(define LibrariesC-45DataC-45SortedSet-union (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedSet-u--foldr_Foldable_SortedSet (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45SortedSet-insert eta-0 eta-1))) arg-1 arg-2)))
(define LibrariesC-45DataC-45SortedSet-toList (lambda (arg-1) (LibrariesC-45DataC-45SortedMap-keys arg-1)))
(define LibrariesC-45DataC-45SortedSet-singleton (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedSet-insert arg-2 (LibrariesC-45DataC-45SortedSet-empty arg-1))))
(define LibrariesC-45DataC-45SortedSet-insert (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedMap-insert arg-1 0 arg-2)))
(define LibrariesC-45DataC-45SortedSet-fromList (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedMap-fromList arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (u--i) (cons u--i 0)) arg-2))))
(define LibrariesC-45DataC-45SortedSet-empty (lambda (arg-1) (LibrariesC-45DataC-45SortedMap-empty arg-1)))
(define LibrariesC-45DataC-45SortedSet-delete (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedMap-delete arg-1 arg-2)))
(define LibrariesC-45DataC-45SortedSet-contains (lambda (arg-1 arg-2) (DataC-45Maybe-isJust (LibrariesC-45DataC-45SortedMap-lookup arg-1 arg-2))))
(define TTImpC-45ProcessRunElab-processRunElab (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (CoreC-45Context-isExtension 0 e-5))) (cond ((equal? sc1 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-8 "%language ElabReflection not enabled") ext-0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-resolveName arg-1 (vector 1 (vector 0 "[elaborator script]")) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--n (csegen-1958))) (let ((act-27 (CoreC-45Reflect-getCon arg-0 arg-8 e-5 (CoreC-45Reflect-builtin "Unit") ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Reflect-appCon arg-0 arg-8 e-5 u--n (cons e-8 '()) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 e-7 (vector 2 ) arg-5 arg-6 arg-7 arg-9 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-7 e-9) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45NormaliseC-45Eval-nfOpts arg-1 arg-0 (CoreC-45Value-withAll) e-5 arg-7 e-10) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-1 arg-2 arg-3 arg-4 arg-8 arg-6 arg-7 e-11 '() eta-0)) ext-0)))))))))))))))))))))))))))))))
(define TTImpC-45ProcessRecord-n--9555-2416-u--recTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (TTImpC-45ProcessRecord-n--9588-2529-u--apply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (vector 0 (CoreC-45FC-virtualiseFC arg-9) arg-15) (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons e-2 (cons (vector 0 (vector 2 ) e-2) e-10))))))) arg-2))))
(define TTImpC-45ProcessRecord-n--9555-2412-u--paramTelescope (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ProcessRecord-n--9584-2424-u--jname arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 eta-0)) arg-2)))
(define TTImpC-45ProcessRecord-n--9555-2415-u--mkTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-15) arg-16 (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (vector 1 e-6 e-14 e-18 e-10 e-19 (TTImpC-45ProcessRecord-n--9555-2415-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-3 arg-16)))))))))))))))
(define TTImpC-45ProcessRecord-n--9584-2424-u--jname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) (cons (vector 2 ) (cons (box e-2) (cons (csegen-21) (cons (vector 0 ) e-11))))))))))
(define TTImpC-45ProcessRecord-n--9555-2413-u--fname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-4 (vector-ref arg-15 3))) e-4)))
(define TTImpC-45ProcessRecord-n--9555-2414-u--farg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-1 (vector-ref arg-15 0))) (let ((e-2 (vector-ref arg-15 1))) (let ((e-3 (vector-ref arg-15 2))) (let ((e-4 (vector-ref arg-15 3))) (let ((e-5 (vector-ref arg-15 4))) (cons (CoreC-45FC-virtualiseFC e-1) (cons (box e-4) (cons e-2 (cons e-3 e-5)))))))))))
(define TTImpC-45ProcessRecord-n--9555-2419-u--elabGetters (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (case (vector-ref arg-21 0) ((3) (let ((e-1 (vector-ref arg-21 1))) (let ((e-2 (vector-ref arg-21 2))) (let ((e-3 (vector-ref arg-21 3))) (let ((e-4 (vector-ref arg-21 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--rig (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) e-7))) (cond ((equal? sc2 1) (csegen-21)) (else (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))))) (let ((u--isVis (TTImpC-45ProcessRecord-projVis arg-4))) (let ((u--b (vector 2 e-6 e-7 e-8 e-9))) (let ((sc2 (let ((sc3 (PreludeC-45Types-elem (csegen-802) e-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-2)))) (cond ((equal? sc3 1) 1) (else (PreludeC-45Types-elem (csegen-802) e-2 arg-6)))))) (cond ((equal? sc2 1) (TTImpC-45ProcessRecord-n--9555-2419-u--elabGetters arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (cons e-2 arg-15) arg-16 arg-17 (let ((sc3 (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 (csegen-546) e-8 (vector 1 )))) (cond ((equal? sc4 1) (let ((sc5 (PreludeC-45Types-elem (csegen-802) e-2 arg-6))) (cond ((equal? sc5 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc3 1) (+ 1 arg-18)) (else arg-18))) arg-19 (cons u--b arg-20) e-4)) (else (let ((u--fldNameStr (CoreC-45Name-nameRoot e-2))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-14 (vector 1 (vector 1 u--fldNameStr)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-inCurrentNS arg-14 (vector 1 (vector 0 u--fldNameStr)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((u--nestDrop (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((e-13 (cdr e-11))) (let ((e-16 (car e-13))) (cons e-12 (PreludeC-45TypesC-45List-length e-16))))))) arg-7))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-26 (CoreC-45Context-toFullNames arg-14 (csegen-46) e-12 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) (vector 1 (cons e-13 e-11)))))))))) u--nestDrop '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45Unelab-unelabNest arg-15 arg-14 e-11 arg-20 e-9) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((u--tyC-39 (TTImpC-45Utils-substNames arg-6 arg-19 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-12)))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-14 "declare.record.field" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Field type: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--tyC-39))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((u--rname (vector 2 "rec" 0))) (let ((act-29 (TTImpC-45BindImplicits-bindTypeNames arg-14 arg-9 '() (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-2) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (TTImpC-45ProcessRecord-n--9555-2413-u--fname arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 eta-1)) arg-0) arg-6)) (TTImpC-45ProcessRecord-n--9555-2415-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (TTImpC-45ProcessRecord-n--9555-2412-u--paramTelescope arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (vector 1 e-1 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box u--rname) (TTImpC-45ProcessRecord-n--9555-2416-u--recTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-16) u--tyC-39)) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) (let ((u--mkProjClaim (lambda (u--nm) (let ((u--ty (vector (vector 2 ) (vector 2 ) u--nm e-14))) (vector 0 e-1 u--rig u--isVis (cons (vector 0 ) '()) u--ty))))) (let ((act-30 (CoreC-45ContextC-45Log-log arg-14 "declare.record.projection" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Projection " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-14))))) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-15 (vector-ref act-30 1))) (vector 0 e-15))) (else (let ((act-31 ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-13 arg-12 arg-11 '() arg-7 arg-8 (u--mkProjClaim e-5)) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-16 (vector-ref act-31 1))) (vector 0 e-16))) (else (let ((u--lhs_exp (TTImpC-45TTImp-apply (vector 0 e-1 arg-17) (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-replicate arg-18 (vector 32 e-1 1)) (PreludeC-45TypesC-45List-tailRecAppend (let ((sc11 (CoreC-45TT-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 (csegen-546) e-8 (vector 1 )))) (cond ((equal? sc11 1) (cons (vector 17 (vector 2 ) u--fldNameStr) '())) (else '()))) (DataC-45List-replicate (TTImpC-45ProcessRecord-n--9555-2418-u--countExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-4) (vector 32 e-1 1))))))) (let ((u--lhs (vector 8 e-1 (vector 0 e-1 e-5) (let ((sc11 (CoreC-45TT-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 (csegen-546) e-8 (vector 1 )))) (cond ((equal? sc11 1) u--lhs_exp) (else (vector 10 e-1 u--lhs_exp (vector 1 (vector 0 u--fldNameStr)) (vector 17 e-1 u--fldNameStr)))))))) (let ((u--rhs (vector 0 (vector 2 ) (vector 1 (vector 0 u--fldNameStr))))) (let ((act-32 (CoreC-45ContextC-45Log-log arg-14 "declare.record.projection" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Projection " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--lhs) (PreludeC-45TypesC-45String-C-43C-43 " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--rhs))))) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-17 (vector-ref act-32 1))) (vector 0 e-17))) (else (let ((act-33 ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-13 arg-12 arg-11 '() arg-7 arg-8 (vector 2 e-1 e-5 (cons (vector 0 e-1 u--lhs u--rhs) '()))) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-18 (vector-ref act-33 1))) (vector 0 e-18))) (else (let ((act-34 (let ((act-34 (CoreC-45Context-isPrefixRecordProjections arg-14 eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-19 (vector-ref act-34 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-34 1))) (cond ((equal? e-19 1) (let ((act-35 (CoreC-45ContextC-45Log-log arg-14 "declare.record.projection.prefix" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Prefix projection " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-10) (PreludeC-45TypesC-45String-C-43C-43 " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-14))))) eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-20 (vector-ref act-35 1))) (vector 0 e-20))) (else (let ((act-36 ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-13 arg-12 arg-11 '() arg-7 arg-8 (u--mkProjClaim e-10)) eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-21 (vector-ref act-36 1))) (vector 0 e-21))) (else (let ((lhs-0 (vector 0 e-1 e-10))) (let ((rhs-0 (vector 0 e-1 e-5))) (let ((act-37 (CoreC-45ContextC-45Log-log arg-14 "declare.record.projection.prefix" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Prefix projection " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) lhs-0) (PreludeC-45TypesC-45String-C-43C-43 " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) rhs-0))))) eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-22 (vector-ref act-37 1))) (vector 0 e-22))) (else ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-13 arg-12 arg-11 '() arg-7 arg-8 (vector 2 e-1 e-10 (cons (vector 0 e-1 lhs-0 rhs-0) '()))) eta-0))))))))))))) (else (vector 1 0))))))))) (case (vector-ref act-34 0) ((0) (let ((e-19 (vector-ref act-34 1))) (vector 0 e-19))) (else (let ((u--updsC-39 (cons (cons e-2 (vector 8 e-1 (vector 0 e-1 e-10) (vector 0 e-1 u--rname))) arg-19))) ((TTImpC-45ProcessRecord-n--9555-2419-u--elabGetters arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (cons e-2 arg-15) arg-16 arg-17 (let ((sc14 (CoreC-45TT-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 (csegen-546) e-8 (vector 1 )))) (cond ((equal? sc14 1) (+ 1 arg-18)) (else arg-18))) u--updsC-39 (cons u--b arg-20) e-4) eta-0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))(else (lambda (eta-0) (vector 1 0)))))))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessRecord-n--9555-2417-u--elabAsData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (let ((u--fc (CoreC-45FC-virtualiseFC arg-9))) (let ((u--conty (TTImpC-45ProcessRecord-n--9555-2415-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (TTImpC-45ProcessRecord-n--9555-2412-u--paramTelescope arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (TTImpC-45ProcessRecord-n--9555-2415-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45ProcessRecord-n--9555-2414-u--farg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 eta-0)) arg-0) (TTImpC-45ProcessRecord-n--9555-2416-u--recTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15))))) (lambda (eta-0) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-14 u--fc '() (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-2) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (TTImpC-45ProcessRecord-n--9555-2413-u--fname arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 eta-1)) arg-0) arg-6)) u--conty eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--con (vector (vector 2 ) (vector 2 ) arg-16 e-5))) (let ((act-25 (TTImpC-45BindImplicits-bindTypeNames arg-14 u--fc '() (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-2) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (TTImpC-45ProcessRecord-n--9555-2413-u--fname arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 eta-1)) arg-0) arg-6)) (TTImpC-45ProcessRecord-mkDataTy u--fc arg-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--dt (vector 0 u--fc arg-15 e-6 '() (cons u--con '())))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-14 "declare.record" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Record data type " (TTImpC-45TTImp-u--show_Show_C-40ImpDataC-39C-32C-36nmC-41 (csegen-737) u--dt))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-13 arg-12 arg-11 '() arg-7 arg-8 (vector 1 u--fc arg-4 u--dt)) eta-0)))))))))))))))))))
(define TTImpC-45ProcessRecord-n--9555-2418-u--countExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-16) (case (vector-ref arg-16 0) ((3) (let ((e-3 (vector-ref arg-16 3))) (let ((e-4 (vector-ref arg-16 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((1) (+ 1 (TTImpC-45ProcessRecord-n--9555-2418-u--countExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-4)))(else (TTImpC-45ProcessRecord-n--9555-2418-u--countExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-4)))))(else 0)))))(else 0))))
(define TTImpC-45ProcessRecord-n--9588-2529-u--apply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (if (null? arg-17) arg-16 (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-11 0) ((1) (TTImpC-45ProcessRecord-n--9588-2529-u--apply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (vector 8 (TTImpC-45TTImp-getFC arg-16) arg-16 e-10) e-3))(else (TTImpC-45ProcessRecord-n--9588-2529-u--apply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (vector 10 (TTImpC-45TTImp-getFC arg-16) arg-16 e-6 e-10) e-3))))))))))))
(define TTImpC-45ProcessRecord-projVis (lambda (arg-0) (cond ((equal? arg-0 2) 2)(else 0))))
(define TTImpC-45ProcessRecord-processRecord (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (let ((e-1 (vector-ref arg-10 0))) (let ((e-2 (vector-ref arg-10 1))) (let ((e-3 (vector-ref arg-10 2))) (let ((e-4 (vector-ref arg-10 3))) (let ((e-5 (vector-ref arg-10 4))) (TTImpC-45ProcessRecord-elabRecord arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-1 arg-7 arg-6 arg-8 arg-9 e-2 e-3 e-4 e-5 clam-0)))))))))
(define TTImpC-45ProcessRecord-mkDataTy (lambda (arg-0 arg-1) (if (null? arg-1) (vector 29 arg-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 arg-0 e-10 e-14 (box e-6) e-15 (TTImpC-45ProcessRecord-mkDataTy arg-0 e-3)))))))))))))
(define TTImpC-45ProcessRecord-elabRecord (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 arg-11 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-inCurrentNS arg-1 arg-13 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ProcessRecord-n--9555-2417-u--elabAsData arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-lookupTyExact e-6 (let ((e-0 (vector-ref e-8 0))) e-0) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (if (null? e-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Adding " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) "failed"))) ext-0) (let ((e-1 (unbox e-9))) (if (null? arg-9) ((TTImpC-45ProcessRecord-n--9555-2419-u--elabGetters arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() e-5 e-6 0 '() '() e-1) ext-0) (let ((e-2 (unbox arg-9))) (let ((u--cns (let ((e-36 (vector-ref e-8 2))) e-36))) (let ((u--nns (let ((e-3 (vector-ref e-8 3))) e-3))) (let ((act-29 (CoreC-45Context-extendNS arg-1 (CoreC-45NameC-45Namespace-mkNamespace e-2) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (CoreC-45Context-getNS arg-1 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 ((TTImpC-45ProcessRecord-n--9555-2419-u--elabGetters arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() e-5 e-6 0 '() '() e-1) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((act-32 (let ((act-32 (unbox arg-1))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (set-box! arg-1 (let ((e-0 (vector-ref e-13 0))) (let ((e-41 (vector-ref e-13 1))) (let ((e-4 (vector-ref e-13 4))) (let ((e-39 (vector-ref e-13 5))) (let ((e-38 (vector-ref e-13 6))) (let ((e-37 (vector-ref e-13 7))) (let ((e-36 (vector-ref e-13 8))) (let ((e-35 (vector-ref e-13 9))) (let ((e-34 (vector-ref e-13 10))) (let ((e-33 (vector-ref e-13 11))) (let ((e-32 (vector-ref e-13 12))) (let ((e-31 (vector-ref e-13 13))) (let ((e-14 (vector-ref e-13 14))) (let ((e-15 (vector-ref e-13 15))) (let ((e-16 (vector-ref e-13 16))) (let ((e-17 (vector-ref e-13 17))) (let ((e-18 (vector-ref e-13 18))) (let ((e-19 (vector-ref e-13 19))) (let ((e-20 (vector-ref e-13 20))) (let ((e-21 (vector-ref e-13 21))) (let ((e-22 (vector-ref e-13 22))) (let ((e-23 (vector-ref e-13 23))) (let ((e-24 (vector-ref e-13 24))) (let ((e-25 (vector-ref e-13 25))) (let ((e-26 (vector-ref e-13 26))) (let ((e-27 (vector-ref e-13 27))) (let ((e-28 (vector-ref e-13 28))) (let ((e-29 (vector-ref e-13 29))) (let ((e-30 (vector-ref e-13 30))) (vector e-0 e-41 u--cns (cons e-11 u--nns) e-4 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (vector 1 act-33)))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessParams-case--processParams-17388 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (lambda (clam-0) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (CoreC-45Normalise-logEnv e-2 arg-9 "declare.param" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) "Param env" e-10 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (let ((act-25 (unbox arg-9))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((u--defNames (TTImpC-45TTImp-definedInBlock (let ((e-38 (vector-ref e-8 2))) e-38) arg-0))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessParams-n--9910-17274-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 e-10 eta-0 eta-1))) u--defNames '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((u--nestBlock (PreludeC-45TypesC-45List-tailRecAppend e-9 e-11))) (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl e-2 arg-9 arg-8 arg-7 arg-6 '() u--nestBlock e-10 eta-0)) arg-0 clam-0))))))))))))))))))))))
(define TTImpC-45ProcessParams-n--9910-17273-u--mkParamTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (vector 29 arg-2) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 arg-2 e-10 e-14 (box e-6) e-15 (TTImpC-45ProcessParams-n--9910-17273-u--mkParamTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3)))))))))))))
(define TTImpC-45ProcessParams-n--9910-17274-u--applyEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-24 (CoreC-45Context-resolveName arg-9 arg-12 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 8 e-5) (cons '() (cons (PreludeC-45TypesC-45List-reverse (CoreC-45Env-allVars arg-10 arg-11)) (lambda (u--fc) (lambda (u--nt) (CoreC-45UnifyState-applyToFull arg-10 u--fc (vector 1 u--fc u--nt (vector 8 e-5)) arg-11)))))))))))))
(define TTImpC-45ProcessParams-processParams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--pty_raw (TTImpC-45ProcessParams-n--9910-17273-u--mkParamTy arg-9 arg-8 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-8))) (lambda (eta-0) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-7 '() arg-0 (vector 16 arg-7 (csegen-1885) u--pty_raw) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "declare.param" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-5))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 -1 (vector 0 ) '() arg-5 arg-6 e-5 (CoreC-45NormaliseC-45Eval-gType arg-7) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45ProcessParams-case--processParams-17388 arg-9 arg-8 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--pty_raw e-5 e-7 (TTImpC-45ProcessParams-extend arg-0 arg-6 (vector 0 ) arg-5 e-7)) eta-0))))))))))))))))
(define TTImpC-45ProcessParams-extend (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((3) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((2) (TTImpC-45ProcessParams-extend (cons e-2 arg-1) (cons e-3 arg-2) (vector 1 arg-3) (TTImpC-45TTImp-u--weaken_Weaken_NestedNames arg-4) e-4))(else (cons arg-1 (cons arg-3 (cons arg-2 arg-4)))))))))(else (cons arg-1 (cons arg-3 (cons arg-2 arg-4)))))))
(define TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-10746 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13) (lambda (clam-0) (if (null? arg-13) (vector 1 0) (let ((e-1 (unbox arg-13))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 arg-3))) (cond ((equal? sc1 1) (let ((act-24 (CoreC-45Context-setFlag arg-5 arg-4 arg-6 (vector 9 8) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Context-setFlag arg-5 arg-4 arg-8 (vector 9 9) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 1)))))))) (else (vector 1 0)))))))))
(define TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-10710 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox arg-11))) (TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-10746 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-1 (TTImpC-45ProcessData-typeCon e-1))))))
(define TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-10681 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox arg-10))) (TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-10710 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 (TTImpC-45ProcessData-firstArg (let ((e-3 (vector-ref e-1 3))) e-3)))))))
(define TTImpC-45ProcessData-n--10565-8502-u--updateNSApp (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name e-2 arg-2))) (cond ((equal? sc1 1) (vector 0 e-1 arg-1)) (else (vector 0 e-1 e-2))))))) ((8) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (vector 8 e-4 (TTImpC-45ProcessData-n--10565-8502-u--updateNSApp arg-0 arg-1 arg-2 e-5) e-6))))) ((9) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (vector 9 e-8 (TTImpC-45ProcessData-n--10565-8502-u--updateNSApp arg-0 arg-1 arg-2 e-9) e-10))))) ((10) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (vector 10 e-12 (TTImpC-45ProcessData-n--10565-8502-u--updateNSApp arg-0 arg-1 arg-2 e-13) e-14 e-15))))))(else arg-3))))
(define TTImpC-45ProcessData-n--12767-10499-u--isNullary (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normalise arg-2 '() e-5 '() (let ((e-3 (vector-ref arg-3 3))) e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (TTImpC-45ProcessData-hasArgs 0 e-6))))))))))))
(define TTImpC-45ProcessData-n--11062-8937-u--getRetType (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (((e-4 arg-2) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45ProcessData-n--11062-8937-u--getRetType arg-0 arg-1 arg-2 e-5) clam-0))))))(else (vector 1 arg-3)))))))(else (vector 1 arg-3))))))
(define TTImpC-45ProcessData-n--11062-8938-u--getPats (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((3) (let ((e-5 (vector-ref arg-3 5))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-1 '() arg-2 (Builtin-snd eta-0))) e-5 '() ext-0)))(else (vector 1 '())))))
(define TTImpC-45ProcessData-n--11155-9049-u--getDisjointPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (vector 1 '()) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-24 (TTImpC-45ProcessData-n--11155-9049-u--getDisjointPos arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-3) e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45ProcessData-n--11155-9048-u--allDisjoint arg-0 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 (cons arg-3 e-5))) (else (vector 1 e-5))))))))))))))))
(define TTImpC-45ProcessData-n--11155-9045-u--disjointArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) (lambda (eta-0) (vector 1 0)) (if (null? arg-4) (lambda (eta-0) (vector 1 0)) (lambda (clam-0) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (let ((act-24 ((TTImpC-45ProcessData-n--11155-9046-u--disjoint arg-0 arg-1 arg-2 e-1 e-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (cond ((equal? e-6 1) (vector 1 1)) (else ((TTImpC-45ProcessData-n--11155-9045-u--disjointArgs arg-0 arg-1 arg-2 e-2 e-5) clam-0))))))))))))))))
(define TTImpC-45ProcessData-n--11155-9046-u--disjoint (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((2) (let ((e-3 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 5))) (lambda (clam-0) (case (vector-ref arg-4 0) ((2) (let ((e-18 (vector-ref arg-4 3))) (let ((e-20 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-3 e-18))) (cond ((equal? sc2 1) (vector 1 1)) (else (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() e-6 (Builtin-snd eta-0))) e-5 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() e-6 (Builtin-snd eta-0))) e-20 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) ((TTImpC-45ProcessData-n--11155-9045-u--disjointArgs arg-0 arg-1 arg-2 e-7 e-8) clam-0)))))))))))))))))))(else (vector 1 0))))))) ((3) (let ((e-8 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((2) (let ((e-23 (vector-ref arg-4 2))) (let ((e-26 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-8 e-23))) (cond ((equal? sc2 1) (vector 1 1)) (else (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() e-5 (Builtin-snd eta-0))) e-11 '() clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() e-5 (Builtin-snd eta-0))) e-26 '() clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-26 1))) ((TTImpC-45ProcessData-n--11155-9045-u--disjointArgs arg-0 arg-1 arg-2 e-6 e-12) clam-1)))))))))))))))))))(else (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-2) (case (vector-ref arg-4 0) ((8) (let ((e-29 (vector-ref arg-4 2))) (vector 1 (CoreC-45TT-u--C-47C-61_Eq_Constant e-14 e-29))))(else (vector 1 0))))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessData-n--11155-9047-u--allDisjointWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 1)) (lambda (clam-0) (case (vector-ref arg-3 0) ((9) (vector 1 0))(else (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (let ((act-24 ((TTImpC-45ProcessData-n--11155-9046-u--disjoint arg-0 arg-1 arg-2 arg-3 e-1) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) ((TTImpC-45ProcessData-n--11155-9047-u--allDisjointWith arg-0 arg-1 arg-2 arg-3 e-2) clam-0)) (else (vector 1 0)))))))))))))))
(define TTImpC-45ProcessData-n--11155-9048-u--allDisjoint (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 1) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((9) (vector 1 0))(else (let ((act-24 ((TTImpC-45ProcessData-n--11155-9048-u--allDisjoint arg-0 arg-1 arg-2 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) ((TTImpC-45ProcessData-n--11155-9047-u--allDisjointWith arg-0 arg-1 arg-2 e-2 e-3) clam-0)) (else (vector 1 0)))))))))))))))
(define TTImpC-45ProcessData-updateNS (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (vector 1 e-1 e-2 e-3 e-4 e-5 (TTImpC-45ProcessData-updateNS arg-0 arg-1 e-6)))))))))(else (TTImpC-45ProcessData-n--10565-8502-u--updateNSApp arg-2 arg-1 arg-0 arg-2)))))
(define TTImpC-45ProcessData-typeCon (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref e-2 0) ((3) (box e-3))(else '()))))) ((4) (let ((e-6 (vector-ref arg-1 2))) (TTImpC-45ProcessData-typeCon e-6)))(else '()))))
(define TTImpC-45ProcessData-shaped (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normalise arg-0 '() e-5 '() (let ((e-4 (vector-ref e-2 3))) e-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc3 ((arg-1 'erased) e-6))) (cond ((equal? sc3 1) (vector 1 (box (let ((e-1 (vector-ref e-2 1))) e-1)))) (else (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10197) (arg-1 'erased)) e-3 ext-0)))))))))))))))))
(define TTImpC-45ProcessData-processDataOpt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((1) (vector 1 0)) ((0) (let ((e-0 (vector-ref arg-3 1))) (CoreC-45Context-setDetermining arg-0 arg-1 arg-2 e-0 ext-0))) ((2) (CoreC-45Context-setUniqueSearch arg-0 arg-1 arg-2 1 ext-0)) ((3) (CoreC-45Context-setExternal arg-0 arg-1 arg-2 1 ext-0)) (else (vector 1 0)))))
(define TTImpC-45ProcessData-processData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-10 0) ((1) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-8 '() arg-0 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-7 0))) e-0)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (if (null? e-8) (let ((act-28 (let ((act-28 (CoreC-45Context-resolveName arg-1 e-5 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) ((TTImpC-45ElabC-45Utils-wrapErrorC arg-5 (lambda (eta-0) (vector 63 arg-8 e-5 eta-0)) (TTImpC-45Elab-elabTerm arg-0 arg-1 arg-2 arg-3 arg-4 e-9 (vector 0 ) arg-5 arg-6 arg-7 (vector 16 arg-8 (csegen-1885) e-6) (box (CoreC-45NormaliseC-45Eval-gType e-1)))) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-10 (car e-9))) (let ((u--fullty (CoreC-45Env-abstractEnvType arg-0 e-1 arg-7 e-10))) (let ((act-29 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "data " (CoreC-45Name-u--show_Show_Name e-5))) '() u--fullty ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (let ((act-30 (let ((act-30 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-7 arg-7 e-10) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-30 1))) ((TTImpC-45ProcessData-checkIsType arg-1 arg-8 e-5 arg-7 e-12) ext-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (let ((act-31 (CoreC-45Normalise-getArity arg-1 '() e-7 '() u--fullty ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-13 (vector-ref act-31 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Context-addDef arg-1 e-5 (CoreC-45Context-newDef arg-8 e-5 (csegen-519) arg-0 u--fullty arg-9 (vector 6 0 e-13 '() '() (CoreC-45ContextC-45Context-defaultFlags) '() '() '())) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-14 (vector-ref act-32 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Context-addMutData arg-1 (vector 8 e-14) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-15 (vector-ref act-33 1))) (vector 0 e-15))) (else (let ((act-34 (let ((act-34 (unbox arg-1))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-16 (vector-ref act-34 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-34 1))) (let ((act-35 (CoreC-45Core-traverse_ (lambda (u--n) (lambda (eta-0) (CoreC-45Context-setMutWith arg-1 arg-8 u--n (let ((e-46 (vector-ref e-16 1))) e-46) eta-0))) (let ((e-46 (vector-ref e-16 1))) e-46) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-17 (vector-ref act-35 1))) (vector 0 e-17))) (else (let ((act-36 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addToSave arg-1 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-10)) ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-18 (vector-ref act-36 1))) (vector 0 e-18))) (else (let ((act-37 (CoreC-45Context-addToSave arg-1 e-5 ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-19 (vector-ref act-37 1))) (vector 0 e-19))) (else (let ((act-38 (CoreC-45ContextC-45Log-log arg-1 "declare.data" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Saving from " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-10))))))) ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-20 (vector-ref act-38 1))) (vector 0 e-20))) (else (cond ((equal? arg-9 0) (vector 1 0))(else (let ((act-39 (CoreC-45Context-addHashWithNames arg-1 (csegen-817) (csegen-46) e-5 ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-21 (vector-ref act-39 1))) (vector 0 e-21))) (else (CoreC-45Context-addHashWithNames arg-1 (csegen-834) (csegen-76) u--fullty ext-0))))))))))))))))))))))))))))))))))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 arg-8 e-5) ext-0)))))))))))))))))))))) (else (let ((e-5 (vector-ref arg-10 1))) (let ((e-6 (vector-ref arg-10 2))) (let ((e-7 (vector-ref arg-10 3))) (let ((e-8 (vector-ref arg-10 4))) (let ((e-9 (vector-ref arg-10 5))) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 e-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-8 '() arg-0 e-7 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "declare.data" (+ 1 0) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Processing " (CoreC-45Name-u--show_Show_Name e-10))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (CoreC-45Context-resolveName arg-1 e-10 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-28 1))) ((TTImpC-45ElabC-45Utils-wrapErrorC arg-5 (lambda (eta-0) (vector 63 arg-8 e-10 eta-0)) (TTImpC-45Elab-elabTerm arg-0 arg-1 arg-2 arg-3 arg-4 e-14 (vector 0 ) arg-5 arg-6 arg-7 (vector 16 arg-8 (csegen-1885) e-11) (box (CoreC-45NormaliseC-45Eval-gType e-5)))) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-28 1))) (let ((e-2 (car e-14))) (let ((u--fullty (CoreC-45Env-abstractEnvType arg-0 e-5 arg-7 e-2))) (let ((act-29 ((CoreC-45Context-lookupCtxtExact e-10 (let ((e-0 (vector-ref e-13 0))) e-0)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-29 1))) (let ((act-30 (if (null? e-15) (vector 1 '()) (let ((e-4 (unbox e-15))) (let ((e-17 (vector-ref e-4 17))) (case (vector-ref e-17 0) ((6) (let ((e-38 (vector-ref e-17 6))) (let ((e-37 (vector-ref e-17 7))) (if (null? e-37) (let ((act-30 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-1 '() e-13 '() u--fullty (let ((e-63 (vector-ref e-4 2))) e-63) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-44 (vector-ref act-30 1))) (vector 0 e-44))) (else (let ((e-44 (vector-ref act-30 1))) (cond ((equal? e-44 1) (vector 1 e-38)) (else (let ((act-31 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data" (+ 1 0) (lambda () "Previous") '() (let ((e-64 (vector-ref e-4 2))) e-64) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-45 (vector-ref act-31 1))) (vector 0 e-45))) (else (let ((act-32 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data" (+ 1 0) (lambda () "Now") '() u--fullty ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-46 (vector-ref act-32 1))) (vector 0 e-46))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 arg-8 e-10) ext-0))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 arg-8 e-10) ext-0)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 arg-8 e-10) ext-0)))))))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "data " (CoreC-45Name-u--show_Show_Name e-10))) '() u--fullty ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (let ((act-32 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-13 arg-7 e-2) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-32 1))) ((TTImpC-45ProcessData-checkIsType arg-1 arg-8 e-10 arg-7 e-18) ext-0))))))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 (CoreC-45Normalise-getArity arg-1 '() e-13 '() u--fullty ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Context-addDef arg-1 e-10 (CoreC-45Context-newDef arg-8 e-10 (csegen-519) arg-0 u--fullty arg-9 (vector 6 0 e-19 '() '() (CoreC-45ContextC-45Context-defaultFlags) '() '() '())) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-34 1))) (let ((act-35 (cond ((equal? arg-9 0) (vector 1 0))(else (let ((act-35 (CoreC-45Context-addHashWithNames arg-1 (csegen-817) (csegen-46) e-10 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (CoreC-45Context-addHashWithNames arg-1 (csegen-834) (csegen-76) u--fullty ext-0)))))))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((u--cvis (let ((sc14 (CoreC-45TT-u--C-61C-61_Eq_Visibility arg-9 1))) (cond ((equal? sc14 1) 0) (else arg-9))))) (let ((act-36 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessData-checkCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--cvis e-6 (vector 8 e-20) eta-0 eta-1))) e-9 '() ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-36 1))) (let ((u--ddef (cons (vector e-5 e-10 e-19 u--fullty) e-22))) (let ((act-37 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (CoreC-45ContextC-45Data-addData arg-1 arg-0 arg-9 e-20 u--ddef) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (let ((act-38 (let ((sc16 (PreludeC-45Types-elem (csegen-2323) (vector 4 ) e-8))) (cond ((equal? sc16 1) (vector 1 0)) (else ((TTImpC-45ProcessData-findNewtype arg-1 e-22) ext-0)))))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((act-39 (let ((act-39 (unbox arg-1))) (vector 1 act-39)))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (let ((act-40 (CoreC-45ContextC-45Log-log arg-1 "declare.data" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-10) (PreludeC-45TypesC-45String-C-43C-43 " defined in a mutual block with " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-16)))) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-4 (vector-ref act-40 1))) (vector 0 e-4))) (else (let ((act-41 (CoreC-45Context-setMutWith arg-1 arg-8 (vector 8 e-20) e-16 ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-4 (vector-ref act-41 1))) (vector 0 e-4))) (else (let ((act-42 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessData-processDataOpt arg-1 arg-8 (vector 8 e-20) eta-0 eta-1))) e-8 ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-4 (vector-ref act-42 1))) (vector 0 e-4))) (else (let ((act-43 (CoreC-45Context-dropMutData arg-1 (vector 8 e-20) ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-4 (vector-ref act-43 1))) (vector 0 e-4))) (else (let ((act-44 ((TTImpC-45ProcessData-getDetags arg-1 arg-8 (PreludeC-45Types-u--map_Functor_List (csegen-2326) e-22)) ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-4 (vector-ref act-44 1))) (vector 0 e-4))) (else (let ((e-30 (vector-ref act-44 1))) (let ((act-45 (CoreC-45Context-setDetags arg-1 arg-8 (vector 8 e-20) e-30 ext-0))) (case (vector-ref act-45 0) ((0) (let ((e-4 (vector-ref act-45 1))) (vector 0 e-4))) (else (let ((act-46 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addToSave arg-1 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-2)) ext-0))) (case (vector-ref act-46 0) ((0) (let ((e-4 (vector-ref act-46 1))) (vector 0 e-4))) (else (let ((act-47 (CoreC-45Context-addToSave arg-1 e-10 ext-0))) (case (vector-ref act-47 0) ((0) (let ((e-4 (vector-ref act-47 1))) (vector 0 e-4))) (else (let ((act-48 (CoreC-45ContextC-45Log-log arg-1 "declare.data" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Saving from " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-10) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-2))))))) ext-0))) (case (vector-ref act-48 0) ((0) (let ((e-4 (vector-ref act-48 1))) (vector 0 e-4))) (else (let ((u--connames (PreludeC-45Types-u--map_Functor_List (csegen-2327) e-22))) (let ((act-49 (let ((sc27 (PreludeC-45Types-elem (csegen-2323) (vector 1 ) e-8))) (cond ((equal? sc27 1) (vector 1 0)) (else (CoreC-45Core-traverse_ (lambda (u--x) (lambda (eta-0) (CoreC-45Context-addHintFor arg-1 arg-8 (vector 8 e-20) u--x 1 0 eta-0))) u--connames ext-0)))))) (case (vector-ref act-49 0) ((0) (let ((e-4 (vector-ref act-49 1))) (vector 0 e-4))) (else (let ((act-50 (TTImpC-45ProcessData-calcConInfo arg-1 arg-8 (vector 8 e-20) e-22 ext-0))) (case (vector-ref act-50 0) ((0) (let ((e-4 (vector-ref act-50 1))) (vector 0 e-4))) (else (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Utils-updateErasable arg-1 eta-0 eta-1))) (cons (vector 8 e-20) u--connames) ext-0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessData-hasArgs (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) (case (vector-ref arg-2 0) ((3) (let ((e-14 (vector-ref arg-2 3))) (let ((e-15 (vector-ref arg-2 4))) (case (vector-ref e-14 0) ((2) (let ((e-18 (vector-ref e-14 2))) (let ((sc3 (AlgebraC-45Semiring-isErased (csegen-475) e-18))) (cond ((equal? sc3 1) (TTImpC-45ProcessData-hasArgs 0 e-15)) (else 0)))))(else 1)))))(else 1)))(else (let ((e-0 (- arg-1 1))) (case (vector-ref arg-2 0) ((3) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (case (vector-ref e-4 0) ((2) (let ((e-8 (vector-ref e-4 2))) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) e-8))) (cond ((equal? sc2 1) (TTImpC-45ProcessData-hasArgs (+ 1 e-0) e-5)) (else (TTImpC-45ProcessData-hasArgs e-0 e-5))))))(else 0)))))(else 0)))))))
(define TTImpC-45ProcessData-getRelevantArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-9) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((AlgebraC-45Semiring-branchZero (csegen-475) (lambda () (TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2) arg-3 arg-4 e-5)) (case (vector-ref e-10 0) ((8) (let ((e-11 (vector-ref e-10 2))) (case (vector-ref e-11 0) ((27) (lambda () (lambda (eta-0) (let ((act-26 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) ((TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2) arg-3 0 e-13) eta-0))))))))(else (lambda () (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-26 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-26 1))) ((TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2) (box arg-2) 0 e-13) eta-0))))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 '())))) arg-3))))))(else (lambda () (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-26 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) ((TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2) (box arg-2) 0 e-11) eta-0))))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 '())))) arg-3)))) e-7) clam-0))))))))))))(else (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (u--r) (box (cons arg-4 u--r)))) arg-3))))))))(else (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (u--r) (box (cons arg-4 u--r)))) arg-3)))))))
(define TTImpC-45ProcessData-getIndexPats (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45ProcessData-n--11062-8937-u--getRetType arg-1 arg-0 e-5 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (TTImpC-45ProcessData-n--11062-8938-u--getPats arg-1 arg-0 e-5 e-7 ext-0)))))))))))))))
(define TTImpC-45ProcessData-getDetags (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) (vector 1 (box '())) (let ((e-3 (cdr arg-2))) (if (null? e-3) (vector 1 (box '())) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessData-getIndexPats arg-0 eta-0 eta-1))) arg-2 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ProcessData-n--11155-9049-u--getDisjointPos arg-2 arg-1 arg-0 0 (DataC-45List-transpose e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (vector 1 (box e-6)))))))))))))))))
(define TTImpC-45ProcessData-firstArg (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) e-7))) (cond ((equal? sc2 1) (TTImpC-45ProcessData-firstArg e-4)) (else (box e-9)))))))(else '())))))(else '()))))
(define TTImpC-45ProcessData-findNewtype (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 0) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-3 (vector-ref e-1 3))) e-3)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45ProcessData-getRelevantArg arg-0 e-5 0 '() 1 e-6) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-3 (unbox e-6))) (CoreC-45Context-updateDef arg-0 (let ((e-8 (vector-ref e-1 1))) e-8) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((5) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-7 (vector-ref lcase-0 2))) (box (vector 5 e-0 e-7 (box e-3))))))(else '()))) clam-0))))))))))) (vector 1 0))))))))
(define TTImpC-45ProcessData-checkRetType (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-2 (vector 10 e-1 0))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) ((TTImpC-45ProcessData-checkRetType arg-1 arg-2 e-10 arg-4) eta-0)))))))))))(else (arg-4 arg-3)))))))(else (arg-4 arg-3)))))
(define TTImpC-45ProcessData-checkIsType (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (TTImpC-45ProcessData-checkRetType arg-1 arg-4 arg-5 (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((10) (vector 1 0))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 9 arg-2 arg-3) clam-0))))))))
(define TTImpC-45ProcessData-checkFamily (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (TTImpC-45ProcessData-checkRetType arg-1 arg-5 arg-6 (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((10) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 10 arg-2 arg-3 arg-4) clam-0)) ((3) (let ((e-4 (vector-ref lcase-0 2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-4))) (cond ((equal? sc1 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 10 arg-2 arg-3 arg-4) clam-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 10 arg-2 arg-3 arg-4) clam-0))))))))
(define TTImpC-45ProcessData-checkCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((e-1 (vector-ref arg-11 0))) (let ((e-3 (vector-ref arg-11 2))) (let ((e-4 (vector-ref arg-11 3))) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ty_raw (TTImpC-45ProcessData-updateNS arg-9 arg-10 e-4))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "declare.data.constructor" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Checking constructor type " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--ty_raw))))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "declare.data.constructor" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Updated " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2299) (cons arg-9 arg-10)))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-8 0))) e-0)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (if (null? e-9) (let ((act-29 (let ((act-29 (CoreC-45Context-resolveName arg-1 e-5 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-10 (vector-ref act-29 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-29 1))) ((TTImpC-45ElabC-45Utils-wrapErrorC arg-5 (lambda (eta-0) (vector 63 e-1 e-5 eta-0)) (lambda (eta-0) (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 e-10 (vector 0 ) arg-5 arg-6 arg-7 (vector 16 e-1 (csegen-1885) u--ty_raw) (CoreC-45NormaliseC-45Eval-gType e-1) eta-0))) ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-10 (vector-ref act-29 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-8 arg-7 e-10) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-11 (vector-ref act-30 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-30 1))) ((TTImpC-45ProcessData-checkFamily arg-1 e-1 e-5 arg-10 arg-7 e-11) ext-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-11 (vector-ref act-30 1))) (vector 0 e-11))) (else (let ((u--fullty (CoreC-45Env-abstractEnvType arg-0 e-1 arg-7 e-10))) (let ((act-31 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data.constructor" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Constructor " (CoreC-45Name-u--show_Show_Name e-5))) '() u--fullty ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-12 (vector-ref act-31 1))) (vector 0 e-12))) (else (let ((act-32 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-addToSave arg-1 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-10)) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-13 (vector-ref act-32 1))) (vector 0 e-13))) (else (let ((act-33 (CoreC-45Context-addToSave arg-1 e-5 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-14 (vector-ref act-33 1))) (vector 0 e-14))) (else (let ((act-34 (CoreC-45ContextC-45Log-log arg-1 "declare.data.constructor" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Saving from " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-10))))))) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-15 (vector-ref act-34 1))) (vector 0 e-15))) (else (let ((act-35 (cond ((equal? arg-8 2) (let ((act-35 (CoreC-45Context-addHashWithNames arg-1 (csegen-817) (csegen-46) e-5 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-16 (vector-ref act-35 1))) (vector 0 e-16))) (else (CoreC-45Context-addHashWithNames arg-1 (csegen-834) (csegen-76) u--fullty ext-0)))))(else (vector 1 0))))) (case (vector-ref act-35 0) ((0) (let ((e-16 (vector-ref act-35 1))) (vector 0 e-16))) (else (let ((act-36 (CoreC-45Normalise-getArity arg-1 '() e-8 '() u--fullty ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-17 (vector-ref act-36 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-36 1))) (vector 1 (vector e-1 e-5 e-17 u--fullty))))))))))))))))))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 e-1 e-5) ext-0))))))))))))))))))))))))))
(define TTImpC-45ProcessData-calcUnity (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 0) (let ((e-2 (cdr arg-3))) (if (null? e-2) (let ((act-24 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10990) (lambda (eta-0) (TTImpC-45ProcessData-hasArgs 0 eta-0))) arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-3 (unbox e-5))) (let ((act-25 (CoreC-45Context-setFlag arg-0 arg-1 e-3 (vector 9 10) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 1)))))))))) (vector 1 0)))))))
(define TTImpC-45ProcessData-calcRecord (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) (vector 1 0) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (if (null? e-2) (let ((act-24 (CoreC-45Context-setFlag arg-0 arg-1 (let ((e-5 (vector-ref e-1 1))) e-5) (vector 9 7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 1)))) (vector 1 0))))))))
(define TTImpC-45ProcessData-calcNaty (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 0)) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (lambda (clam-0) (if (null? e-2) (vector 1 0) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (let ((act-24 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10610) (lambda (eta-0) (TTImpC-45ProcessData-hasArgs 0 eta-0))) arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--cs (cons e-1 (cons e-4 '())))) (if (null? e-6) (vector 1 0) (let ((e-3 (unbox e-6))) (let ((act-25 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10640) (csegen-2331)) u--cs clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((_-0 (box e-3))) (if (null? e-7) (vector 1 0) (let ((e-8 (unbox e-7))) (let ((_-1 (box e-8))) ((TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-10681 e-4 e-1 u--cs arg-2 arg-1 arg-0 e-3 _-0 e-8 _-1 (DataC-45List-find (lambda (u--con) (CoreC-45Name-u--C-61C-61_Eq_Name (let ((e-11 (vector-ref u--con 1))) e-11) e-8)) u--cs)) clam-0)))))))))))))))) (vector 1 0)))))))))))
(define TTImpC-45ProcessData-calcMaybe (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (lambda (clam-0) (if (null? e-2) (vector 1 0) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (let ((act-24 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10392) (lambda (eta-0) (TTImpC-45ProcessData-hasArgs 0 eta-0))) arg-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--cs (cons e-1 (cons e-4 '())))) (if (null? e-6) (vector 1 0) (let ((e-3 (unbox e-6))) (let ((act-25 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10420) (csegen-2331)) u--cs clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (if (null? e-7) (vector 1 0) (let ((e-8 (unbox e-7))) (let ((act-26 (CoreC-45Context-setFlag arg-0 arg-1 e-3 (vector 9 5) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((act-27 (CoreC-45Context-setFlag arg-0 arg-1 e-8 (vector 9 6) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (vector 1 1)))))))))))))))))))) (vector 1 0)))))))))))
(define TTImpC-45ProcessData-calcListy (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (lambda (clam-0) (if (null? e-2) (let ((act-24 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10215) (csegen-2335)) arg-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-3 (unbox e-5))) (let ((act-25 (CoreC-45Context-setFlag arg-0 arg-1 e-3 (vector 9 3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 1)))))))))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (if (null? e-6) (let ((act-24 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10270) (lambda (eta-0) (TTImpC-45ProcessData-hasArgs 0 eta-0))) arg-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((u--cs (cons e-1 (cons e-5 '())))) (if (null? e-7) (vector 1 0) (let ((e-3 (unbox e-7))) (let ((act-25 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-10298) (csegen-2335)) u--cs clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (vector 1 0) (let ((e-4 (unbox e-8))) (let ((act-26 (CoreC-45Context-setFlag arg-0 arg-1 e-3 (vector 9 2) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((act-27 (CoreC-45Context-setFlag arg-0 arg-1 e-4 (vector 9 3) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (vector 1 1)))))))))))))))))))) (vector 1 0)))))))))))
(define TTImpC-45ProcessData-calcEnum (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Core-allM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessData-n--12767-10499-u--isNullary arg-2 arg-1 arg-0 eta-0 eta-1))) arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (CoreC-45Core-traverse_ (lambda (u--c) (lambda (eta-0) (CoreC-45Context-setFlag arg-0 arg-1 u--c (vector 9 4) eta-0))) (PreludeC-45Types-u--map_Functor_List (csegen-2327) arg-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 1))))) (else (vector 1 0)))))))))
(define TTImpC-45ProcessData-calcConInfo (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((TTImpC-45ProcessData-calcNaty arg-0 arg-1 arg-2 arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 0) (let ((act-25 ((TTImpC-45ProcessData-calcUnity arg-0 arg-1 arg-2 arg-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 0) (let ((act-26 ((TTImpC-45ProcessData-calcListy arg-0 arg-1 arg-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 0) (let ((act-27 ((TTImpC-45ProcessData-calcMaybe arg-0 arg-1 arg-3) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? e-8 0) (let ((act-28 (TTImpC-45ProcessData-calcEnum arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (cond ((equal? e-9 0) (let ((act-29 ((TTImpC-45ProcessData-calcRecord arg-0 arg-1 arg-3) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (cond ((equal? e-10 0) (vector 1 0)) (else (vector 1 0)))))))) (else (vector 1 0)))))))) (else (vector 1 0)))))))) (else (vector 1 0)))))))) (else (vector 1 0)))))))) (else (vector 1 0)))))))))
(define CoreC-45ContextC-45Data-case--getPs-8297 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 arg-4)) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-7 (vector-ref e-2 3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-7 arg-3))) (cond ((equal? sc2 1) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (lambda (eta-0) (CoreC-45ContextC-45Data-updateParams arg-0 arg-1 arg-4 e-3 eta-0)) clam-0)) (else (vector 1 arg-4))))))(else (vector 1 arg-4)))))))))
(define CoreC-45ContextC-45Data-n--5933-7931-u--toNothing (lambda (arg-1 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-7 (let ((e-1 (unbox arg-7))) (case (vector-ref e-1 0) ((0) (let ((e-4 (vector-ref e-1 1))) (let ((e-5 (vector-ref e-1 2))) (let ((e-6 (vector-ref e-1 3))) (let ((u--tm (box (vector 0 e-4 e-5 e-6)))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-1 e-6))) (cond ((equal? sc2 1) '()) (else u--tm))))))))(else arg-7))))))
(define CoreC-45ContextC-45Data-n--6256-8225-u--shrink (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (let ((e-2 (unbox arg-11))) (CoreC-45TT-shrinkTerm e-2 (vector 1 (vector 0 )))))))
(define CoreC-45ContextC-45Data-n--6063-8097-u--mergeArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) '() (let ((e-1 (unbox arg-4))) (case (vector-ref e-1 0) ((0) (let ((e-4 (vector-ref e-1 1))) (let ((e-5 (vector-ref e-1 2))) (let ((e-6 (vector-ref e-1 3))) (case (vector-ref arg-5 0) ((0) (let ((e-12 (vector-ref arg-5 3))) (let ((sc3 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-6 e-12))) (cond ((equal? sc3 1) (box (vector 0 e-4 e-5 e-6))) (else '())))))(else '()))))))(else '()))))))
(define CoreC-45ContextC-45Data-n--6452-8396-u--justPos (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-2) (CoreC-45ContextC-45Data-n--6452-8396-u--justPos arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2) e-3) (cons arg-2 (CoreC-45ContextC-45Data-n--6452-8396-u--justPos arg-1 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-2) e-3))))))))
(define CoreC-45ContextC-45Data-n--6063-8041-u--couldBeParam (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Normalise-etaContract arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (case (vector-ref e-5 0) ((0) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (box (vector 0 e-2 e-3 e-4))))))(else '())))))))))
(define CoreC-45ContextC-45Data-n--6615-8553-u--conVisibility (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (cond ((equal? arg-9 1) 0)(else arg-9))))
(define CoreC-45ContextC-45Data-n--6615-8552-u--allDet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (cond ((equal? arg-9 0) '())(else (let ((e-0 (- arg-9 1))) (PreludeC-45Types-u--rangeFromTo_Range_Nat 0 e-0))))))
(define CoreC-45ContextC-45Data-n--6615-8554-u--addDataConstructors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) (lambda (eta-0) (vector 1 arg-11)) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((u--condef (CoreC-45Context-newDef e-4 e-5 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) arg-7 e-7 (CoreC-45ContextC-45Data-n--6615-8553-u--conVisibility arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-6) (vector 5 arg-9 e-6 '())))) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact e-5 arg-11) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-8 (vector-ref act-24 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-24 1))) (if (null? e-8) (let ((act-25 (CoreC-45Context-addCtxt e-5 u--condef arg-11 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((e-10 (cdr e-9))) ((CoreC-45ContextC-45Data-n--6615-8554-u--addDataConstructors arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (bs+ arg-9 1 63) e-3 e-10) eta-0)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 38 e-4 e-5) eta-0)))))))))))))))))
(define CoreC-45ContextC-45Data-updateParams (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CoreC-45ContextC-45Data-dropReps e-5)))))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45ContextC-45Data-n--6063-8041-u--couldBeParam arg-0 arg-1 arg-3 eta-1 eta-2))) arg-3 '() eta-0)) ext-0) (let ((e-2 (unbox arg-2))) (vector 1 (CoreC-45ContextC-45Data-dropReps (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (CoreC-45ContextC-45Data-n--6063-8097-u--mergeArg arg-0 arg-1 e-2 arg-3 eta-0 eta-1))) e-2 arg-3)))))))
(define CoreC-45ContextC-45Data-toPos (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (unbox arg-1))) (CoreC-45ContextC-45Data-n--6452-8396-u--justPos e-2 0 e-2)))))
(define CoreC-45ContextC-45Data-paramPos (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45ContextC-45Data-getConPs arg-0 '() '() arg-1 eta-0)) arg-2 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (DataC-45List-intersectAll (csegen-792) e-5))))))))))
(define CoreC-45ContextC-45Data-getPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45ContextC-45Data-getPs arg-0 (cons e-2 arg-1) (PreludeC-45Types-u--map_Functor_Maybe (csegen-2339) arg-2) arg-3 e-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (CoreC-45ContextC-45Data-n--6256-8225-u--shrink arg-0 arg-1 e-1 e-6 e-7 e-8 e-9 e-2 e-4 arg-3 arg-2 eta-2)) eta-1)) e-5))))))))))))(else (CoreC-45ContextC-45Data-case--getPs-8297 arg-0 arg-1 arg-4 arg-3 arg-2 (CoreC-45TT-getFnArgs arg-4)))))))))(else (CoreC-45ContextC-45Data-case--getPs-8297 arg-0 arg-1 arg-4 arg-3 arg-2 (CoreC-45TT-getFnArgs arg-4))))))
(define CoreC-45ContextC-45Data-getConPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45ContextC-45Data-getPs arg-0 arg-1 arg-2 arg-3 e-9) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45ContextC-45Data-getConPs arg-0 (cons e-2 arg-1) (PreludeC-45Types-u--map_Functor_Maybe (csegen-2339) e-5) arg-3 e-4) eta-0)))))))) ((1) (let ((e-13 (vector-ref e-3 3))) (CoreC-45ContextC-45Data-getConPs arg-0 arg-1 arg-2 arg-3 (CoreC-45TTC-45SubstEnv-subst e-13 e-4))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-2341) (CoreC-45ContextC-45Data-getPs arg-0 arg-1 arg-2 arg-3 arg-4) eta-0))))))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-2341) (CoreC-45ContextC-45Data-getPs arg-0 arg-1 arg-2 arg-3 arg-4) eta-0))))))
(define CoreC-45ContextC-45Data-dropReps (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-2) (cons e-2 (CoreC-45ContextC-45Data-dropReps e-3)) (let ((e-5 (unbox e-2))) (case (vector-ref e-5 0) ((0) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((e-10 (vector-ref e-5 3))) (cons (box (vector 0 e-8 e-9 e-10)) (CoreC-45ContextC-45Data-dropReps (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45ContextC-45Data-n--5933-7931-u--toNothing e-10 e-9 e-8 e-3 eta-0)) e-3)))))))(else (cons e-2 (CoreC-45ContextC-45Data-dropReps e-3)))))))))))
(define CoreC-45ContextC-45Data-addData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (let ((e-2 (vector-ref e-0 0))) (let ((e-3 (vector-ref e-0 1))) (let ((e-4 (vector-ref e-0 2))) (let ((e-5 (vector-ref e-0 3))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getNextTypeTag arg-0 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((u--allPos (CoreC-45ContextC-45Data-n--6615-8552-u--allDet e-5 e-4 e-3 e-2 e-1 arg-3 arg-2 arg-1 arg-0 e-4))) (let ((act-26 (CoreC-45ContextC-45Data-paramPos arg-0 (vector 8 arg-3) (PreludeC-45Types-u--map_Functor_List (csegen-2326) e-1) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((u--paramPositions (DataC-45Maybe-fromMaybe (lambda () u--allPos) e-8))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-0 "declare.data.parameters" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Positions of parameters for datatype" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-3) (PreludeC-45TypesC-45String-C-43C-43 ": [" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_Nat eta-0)) u--paramPositions)) "]"))))) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((u--tydef (CoreC-45Context-newDef e-2 e-3 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) arg-1 e-5 arg-2 (vector 6 e-7 e-4 u--paramPositions u--allPos (CoreC-45ContextC-45Context-defaultFlags) '() (PreludeC-45Types-u--map_Functor_List (csegen-2327) e-1) '())))) (let ((act-28 (CoreC-45Context-addCtxt e-3 u--tydef (let ((e-40 (vector-ref e-6 0))) e-40) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((e-12 (car e-10))) (let ((e-11 (cdr e-10))) (let ((act-29 ((CoreC-45ContextC-45Data-n--6615-8554-u--addDataConstructors e-5 e-4 e-3 e-2 e-1 arg-3 arg-2 arg-1 arg-0 0 e-1 e-11) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (set-box! arg-0 (let ((e-43 (vector-ref e-6 1))) (let ((e-42 (vector-ref e-6 2))) (let ((e-41 (vector-ref e-6 3))) (let ((e-40 (vector-ref e-6 4))) (let ((e-39 (vector-ref e-6 5))) (let ((e-38 (vector-ref e-6 6))) (let ((e-37 (vector-ref e-6 7))) (let ((e-36 (vector-ref e-6 8))) (let ((e-35 (vector-ref e-6 9))) (let ((e-34 (vector-ref e-6 10))) (let ((e-33 (vector-ref e-6 11))) (let ((e-32 (vector-ref e-6 12))) (let ((e-31 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-13 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-14 (vector-ref act-30 1))) (vector 0 e-14))) (else (vector 1 e-12)))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processIntegerToNat-20409 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (if (null? arg-18) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "No type constructor found for return type of " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "."))) ext-0) (let ((e-1 (unbox arg-18))) (let ((act-24 (TTImpC-45ProcessBuiltin-isNatural arg-0 arg-2 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (CoreC-45Context-setFlag arg-0 arg-2 (vector 8 arg-6) (vector 10 arg-15) ext-0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 "Return type is not a 'Nat'-like type") ext-0)))))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processIntegerToNat-20363 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Unexpected type " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-9))) eta-0)) (let ((e-1 (unbox arg-16))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (lambda (eta-0) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processIntegerToNat-20409 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-5 e-6 (TTImpC-45ProcessBuiltin-getTypeCons e-5 e-6) eta-0))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32processIntegerToNat-20267 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-10 0) ((1) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (let ((e-2 (vector-ref arg-10 3))) (let ((e-3 (vector-ref arg-10 4))) (let ((e-4 (vector-ref arg-10 5))) (let ((act-24 (CoreC-45ContextC-45Log-logTerm '() arg-0 "builtin.IntegerToNatural" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Type of " arg-3)) arg-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((sc2 (TTImpC-45ProcessBuiltin-getNEIntegerIndex arg-9))) (if (null? sc2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Unexpected arity while processing %builtin IntegerToNatural " (PreludeC-45TypesC-45String-C-43C-43 arg-3 " (getNEIntegerIndex returned Nothing)"))) ext-0) (let ((e-6 (unbox sc2))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "No unrestricted arguments of type `Integer` found for " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "."))) ext-0) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (if (null? e-7) ((TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processIntegerToNat-20363 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-0 e-1 e-2 e-3 e-4 e-8 (TTImpC-45ProcessBuiltin-getReturnType '() arg-9)) ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "More than one unrestricted arguments of type `Integer` found for " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "."))) ext-0)))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "Expected function definition, found " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45ProcessBuiltin-showDefType arg-10) "."))) ext-0)))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processNatToInteger-19741 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (if (null? arg-17) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "No type constructor found for non-erased arguement of " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "."))) ext-0) (let ((e-1 (unbox arg-17))) (let ((act-24 (TTImpC-45ProcessBuiltin-isNatural arg-0 arg-2 e-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((sc3 (TTImpC-45ProcessBuiltin-getNEIndex arg-14))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Couldn't find non-erased argument.") ext-0) (let ((e-2 (unbox sc3))) (CoreC-45Context-setFlag arg-0 arg-2 (vector 8 arg-6) (vector 10 e-2) ext-0))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 "Non-erased argument is not a 'Nat'-like type.") ext-0)))))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processNatToInteger-19695 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "No arguments found for " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "."))) eta-0)) (let ((e-1 (car arg-15))) (let ((e-2 (cdr arg-15))) (if (null? e-1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "More than 1 non-erased arguments found for " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "."))) eta-0)) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-2) (lambda (eta-0) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processNatToInteger-19741 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-6 e-7 (TTImpC-45ProcessBuiltin-getTypeCons e-6 e-7) eta-0)) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "More than 1 non-erased arguments found for " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "."))) eta-0)))))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32processNatToInteger-19639 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-9 0) ((1) (let ((e-0 (vector-ref arg-9 1))) (let ((e-1 (vector-ref arg-9 2))) (let ((e-2 (vector-ref arg-9 3))) (let ((e-3 (vector-ref arg-9 4))) (let ((e-4 (vector-ref arg-9 5))) (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-76) (let ((e-24 (vector-ref arg-7 2))) e-24) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm '() arg-0 "builtin.NaturalToInteger" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Type of " arg-3)) e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else ((TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processNatToInteger-19695 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-0 e-1 e-2 e-4 e-3 e-5 (TTImpC-45ProcessBuiltin-getNEArgs '() e-5)) ext-0))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "Expected function definition, found " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45ProcessBuiltin-showDefType arg-9) "."))) ext-0)))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processBuiltinNatural-19421 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-9 0) ((6) (let ((e-6 (vector-ref arg-9 7))) (let ((act-24 (TTImpC-45ProcessBuiltin-getConsGDef arg-0 arg-2 e-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-8 (vector-ref act-24 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-24 1))) (TTImpC-45ProcessBuiltin-checkNatCons (let ((e-39 (vector-ref arg-3 0))) e-39) e-8 arg-5 arg-2 ext-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "Expected a type constructor, found " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45ProcessBuiltin-showDefType arg-9) "."))) ext-0)))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32checkNatConsC-44checkCon-18905 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((5) (let ((e-1 (vector-ref arg-10 2))) (let ((sc1 (PreludeC-45Types-prim__integerToNat (- e-1 (PreludeC-45TypesC-45List-length (let ((e-3 (vector-ref arg-5 3))) e-3)))))) (cond ((equal? sc1 0) (lambda (clam-0) (if (null? arg-7) (vector 1 (cons (box arg-4) arg-8)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Multiple 'Z'-like constructors for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) "."))) clam-0))))(else (let ((e-3 (- (PreludeC-45Types-prim__integerToNat (- e-1 (PreludeC-45TypesC-45List-length (let ((e-3 (vector-ref arg-5 3))) e-3)))) 1))) (lambda (clam-0) (cond ((equal? e-3 0) (if (null? arg-8) (let ((act-24 ((TTImpC-45ProcessBuiltin-n--9264-18633-u--checkTyS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 (cons arg-7 (box arg-4)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Multiple 'S'-like constructors for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) "."))) clam-0)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Constructor " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-4) " doesn't match any pattern for Natural."))) clam-0))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Expected data constructor, found:" (TTImpC-45ProcessBuiltin-showDefType arg-10))) eta-0))))))
(define TTImpC-45ProcessBuiltin-n--9128-18507-u--isNatFlag (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((9) (let ((e-0 (vector-ref arg-3 1))) (cond ((equal? e-0 8) 1) ((equal? e-0 9) 1)(else 0))))(else 0))))
(define TTImpC-45ProcessBuiltin-n--8388-17827-u--isInteger (lambda (arg-1 arg-2 arg-3 arg-4 arg-6) (case (vector-ref arg-6 0) ((9) (let ((e-2 (vector-ref arg-6 2))) (case (vector-ref e-2 0) ((19) 1)(else 0))))(else 0))))
(define TTImpC-45ProcessBuiltin-n--9128-18508-u--hasNatFlag (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45ProcessBuiltin-n--9128-18507-u--isNatFlag arg-0 arg-1 arg-2 eta-0)) (let ((e-11 (vector-ref e-3 11))) e-11)))))
(define TTImpC-45ProcessBuiltin-n--9264-18633-u--checkTyS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--type (let ((e-2 (vector-ref arg-5 2))) e-2))) (let ((sc0 (TTImpC-45ProcessBuiltin-getFirstNEType '() u--type))) (if (null? sc0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Expected a non-erased argument, found none.") eta-0)) (let ((e-1 (unbox sc0))) (let ((e-6 (cdr e-1))) (lambda (clam-0) (let ((sc2 (TTImpC-45ProcessBuiltin-getReturnType '() u--type))) (if (null? sc2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Unexpected type " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() u--type))) clam-0) (let ((e-2 (unbox sc2))) (let ((e-7 (cdr e-2))) (let ((act-24 (let ((sc4 (TTImpC-45ProcessBuiltin-termConMatch e-6 e-7))) (cond ((equal? sc4 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Incorrect type for 'S'-like constructor for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) "."))) clam-0)))))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (let ((sc5 (TTImpC-45ProcessBuiltin-isStrict e-6))) (cond ((equal? sc5 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 "Natural builtin does not support lazy types.") clam-0)))))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 0)))))))))))))))))))
(define TTImpC-45ProcessBuiltin-n--9264-18634-u--checkCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-24 (arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((_-0 (cons e-6 e-4))) ((TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32checkNatConsC-44checkCon-18905 arg-0 arg-1 arg-2 arg-3 e-2 e-3 arg-5 e-6 e-4 _-0 (let ((e-17 (vector-ref e-3 17))) e-17)) ext-0))))))))))))
(define TTImpC-45ProcessBuiltin-termConMatch (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-42 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((0) (let ((e-75 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-61C-61_Eq_Nat e-42 e-75)))(else (case (vector-ref arg-3 0) ((6) (let ((e-37 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-37)))(else (case (vector-ref arg-2 0) ((7) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-23 e-32))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-24 e-33)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-28 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0)))))))))))) ((1) (let ((e-47 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((1) (let ((e-80 (vector-ref arg-3 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-47 e-80)))(else (case (vector-ref arg-3 0) ((6) (let ((e-37 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-37)))(else (case (vector-ref arg-2 0) ((7) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-23 e-32))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-24 e-33)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-28 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0)))))))))))) ((2) (let ((e-51 (vector-ref arg-2 3))) (let ((e-52 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((2) (let ((e-84 (vector-ref arg-3 3))) (let ((e-85 (vector-ref arg-3 4))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-51 e-84))) (cond ((equal? sc2 1) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (csegen-2344) eta-0)) (DataC-45List-u--zip_Zippable_List e-52 e-85))) (else 0))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-37 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-37)))(else (case (vector-ref arg-2 0) ((7) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-23 e-32))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-24 e-33)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-28 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))))))) ((3) (let ((e-56 (vector-ref arg-2 3))) (let ((e-57 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((3) (let ((e-89 (vector-ref arg-3 3))) (let ((e-90 (vector-ref arg-3 4))) (let ((sc2 (CoreC-45TT-eqBinderBy (csegen-2344) e-56 e-89))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-termConMatch e-57 e-90)) (else 0))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-37 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-37)))(else (case (vector-ref arg-2 0) ((7) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-23 e-32))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-24 e-33)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-28 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))))))) ((4) (let ((e-60 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((4) (let ((e-93 (vector-ref arg-3 2))) (TTImpC-45ProcessBuiltin-termConMatch e-60 e-93)))(else (case (vector-ref arg-3 0) ((6) (let ((e-37 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-37)))(else (case (vector-ref arg-2 0) ((7) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-23 e-32))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-24 e-33)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-28 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0)))))))))))) ((5) (let ((e-65 (vector-ref arg-2 3))) (let ((e-66 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((5) (let ((e-98 (vector-ref arg-3 3))) (let ((e-99 (vector-ref arg-3 4))) (let ((sc2 (TTImpC-45ProcessBuiltin-termConMatch e-65 e-98))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-termConMatch e-66 e-99)) (else 0))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-37 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-37)))(else (case (vector-ref arg-2 0) ((7) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-23 e-32))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-24 e-33)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-28 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))))))) ((6) (let ((e-70 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-70 arg-3)))(else (case (vector-ref arg-3 0) ((6) (let ((e-37 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-37)))(else (case (vector-ref arg-2 0) ((7) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (let ((sc2 (TTImpC-45ProcessBuiltin-termConMatch e-23 e-32))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-termConMatch e-24 e-33)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-28 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-19 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-19)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))))))
(define TTImpC-45ProcessBuiltin-showDefType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "undefined") ((1) "function") ((2) "external function") ((3) "foreign function") ((4) "builtin function") ((5) "data constructor") ((6) "type constructor") ((7) "hole") ((8) "search") ((9) "guess") ((10) "bound name") (else "delayed"))))
(define TTImpC-45ProcessBuiltin-processNatToInteger (lambda (arg-0 arg-1 arg-2) (let ((u--show_fn (CoreC-45Name-u--show_Show_Name arg-2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "builtin.NaturalToInteger" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Processing %builtin NaturalToInteger " (PreludeC-45TypesC-45String-C-43C-43 u--show_fn "."))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-0) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) eta-0) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) eta-0) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (if (null? e-2) (let ((_-0 (cons (cons e-9 (cons e-10 e-11)) '()))) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32processNatToInteger-19639 arg-0 arg-2 arg-1 u--show_fn e-5 e-9 e-10 e-11 _-0 (let ((e-17 (vector-ref e-11 17))) e-17) eta-0)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) eta-0))))))))))))))))))))))))))
(define TTImpC-45ProcessBuiltin-processIntegerToNat (lambda (arg-0 arg-1 arg-2) (let ((u--show_fn (CoreC-45Name-u--show_Show_Name arg-2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "builtin.IntegerToNatural" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Processing %builtin IntegerToNatural " (PreludeC-45TypesC-45String-C-43C-43 u--show_fn "."))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-0) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) eta-0) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) eta-0) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (if (null? e-2) (let ((act-27 (CoreC-45Context-toFullNames arg-0 (csegen-76) (let ((e-29 (vector-ref e-11 2))) e-29) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-27 1))) (let ((_-0 (cons (cons e-9 (cons e-10 e-11)) '()))) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32processIntegerToNat-20267 arg-0 arg-2 arg-1 u--show_fn e-5 e-9 e-10 e-11 _-0 e-12 (let ((e-17 (vector-ref e-11 17))) e-17) eta-0)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) eta-0))))))))))))))))))))))))))
(define TTImpC-45ProcessBuiltin-processBuiltinNatural (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "builtin.Natural" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Processing %builtin Natural " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-2) "."))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 ext-0) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) ext-0) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) ext-0) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (if (null? e-2) (let ((act-27 (TTImpC-45ProcessBuiltin-isNatural arg-0 arg-1 e-9 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-27 1))) (let ((_-0 (cons (cons e-9 (cons e-10 e-11)) '()))) (cond ((equal? e-12 0) (let ((_-1 0)) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processBuiltinNatural-19421 arg-0 arg-2 arg-1 e-5 e-10 e-9 e-11 _-0 _-1 (let ((e-17 (vector-ref e-11 17))) e-17) ext-0))) (else (vector 1 0)))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7)) ext-0))))))))))))))))))))))))
(define TTImpC-45ProcessBuiltin-processBuiltin (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-5 0) (lambda (eta-0) (TTImpC-45ProcessBuiltin-processBuiltinNatural arg-1 arg-4 arg-6 eta-0))) ((equal? arg-5 1) (TTImpC-45ProcessBuiltin-processNatToInteger arg-1 arg-4 arg-6)) (else (TTImpC-45ProcessBuiltin-processIntegerToNat arg-1 arg-4 arg-6)))))
(define TTImpC-45ProcessBuiltin-isStrict (lambda (arg-1) (case (vector-ref arg-1 0) ((0) 1) ((1) 1) ((2) (let ((e-14 (vector-ref arg-1 4))) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ProcessBuiltin-isStrict eta-0)) e-14))) ((3) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (let ((sc1 (TTImpC-45ProcessBuiltin-isStrict (CoreC-45TT-binderType e-18)))) (cond ((equal? sc1 1) (TTImpC-45ProcessBuiltin-isStrict e-19)) (else 0)))))) ((4) (let ((e-22 (vector-ref arg-1 2))) (let ((e-23 (vector-ref arg-1 3))) (let ((sc1 (TTImpC-45ProcessBuiltin-isStrict e-22))) (cond ((equal? sc1 1) (TTImpC-45ProcessBuiltin-isStrict e-23)) (else 0)))))) ((5) (let ((e-27 (vector-ref arg-1 3))) (let ((e-28 (vector-ref arg-1 4))) (let ((sc1 (TTImpC-45ProcessBuiltin-isStrict e-27))) (cond ((equal? sc1 1) (TTImpC-45ProcessBuiltin-isStrict e-28)) (else 0)))))) ((6) 0) ((7) (let ((e-36 (vector-ref arg-1 3))) (let ((e-37 (vector-ref arg-1 4))) (let ((sc1 (TTImpC-45ProcessBuiltin-isStrict e-36))) (cond ((equal? sc1 1) (TTImpC-45ProcessBuiltin-isStrict e-37)) (else 0)))))) ((8) (let ((e-41 (vector-ref arg-1 3))) (TTImpC-45ProcessBuiltin-isStrict e-41))) ((9) 1) ((10) 1) (else 1))))
(define TTImpC-45ProcessBuiltin-isNatural (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 (vector 2 ) arg-2 ext-0) (let ((e-1 (unbox e-6))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((6) (let ((e-26 (vector-ref e-17 7))) (let ((act-26 (TTImpC-45ProcessBuiltin-getConsGDef arg-0 arg-1 e-26 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-33 (vector-ref act-26 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-26 1))) (vector 1 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (TTImpC-45ProcessBuiltin-n--9128-18508-u--hasNatFlag arg-0 arg-2 arg-1 eta-0)) e-33))))))))(else (vector 1 0))))))))))))))))
(define TTImpC-45ProcessBuiltin-getTypeCons (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 3))) (box (CoreC-45TT-nameAt arg-0 e-4)))) ((1) (let ((e-9 (vector-ref arg-1 3))) (box e-9))) ((2) '()) ((3) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (case (vector-ref e-18 0) ((1) (let ((e-3 (vector-ref e-18 3))) (TTImpC-45ProcessBuiltin-getTypeCons arg-0 (CoreC-45TTC-45SubstEnv-subst e-3 e-19))))(else '()))))) ((4) (let ((e-22 (vector-ref arg-1 2))) (TTImpC-45ProcessBuiltin-getTypeCons arg-0 e-22)))(else '()))))
(define TTImpC-45ProcessBuiltin-getReturnType (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 3))) (TTImpC-45ProcessBuiltin-getReturnType arg-0 (CoreC-45TTC-45SubstEnv-subst e-6 e-4)))) ((2) (TTImpC-45ProcessBuiltin-getReturnType (cons e-2 arg-0) e-4))(else '()))))))(else (box (cons arg-0 arg-1))))))
(define TTImpC-45ProcessBuiltin-getNEIntegerIndex (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 3))) (TTImpC-45ProcessBuiltin-getNEIntegerIndex (CoreC-45TTC-45SubstEnv-subst e-6 e-4)))) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--b (vector 2 e-6 e-7 e-8 e-9))) (let ((sc2 (let ((sc3 (AlgebraC-45Semiring-isErased (csegen-475) e-7))) (cond ((equal? sc3 1) 0) (else (TTImpC-45ProcessBuiltin-n--8388-17827-u--isInteger e-1 e-2 e-4 u--b e-9)))))) (cond ((equal? sc2 1) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (cons 0 (PreludeC-45Types-u--map_Functor_List (lambda (arg-0) (PreludeC-45Types-u--C-43_Num_Nat arg-0 (+ 1 0))) eta-0))) (TTImpC-45ProcessBuiltin-getNEIntegerIndex e-4))) (else (TTImpC-45ProcessBuiltin-getNEIntegerIndex e-4))))))))))(else '())))))))(else (box '())))))
(define TTImpC-45ProcessBuiltin-getNEIndex (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 3))) (TTImpC-45ProcessBuiltin-getNEIndex (CoreC-45TTC-45SubstEnv-subst e-6 e-4)))) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) e-7))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-getNEIndex e-4)) (else (box 0))))))(else '())))))(else '()))))
(define TTImpC-45ProcessBuiltin-getNEArgs (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 3))) (TTImpC-45ProcessBuiltin-getNEArgs arg-0 (CoreC-45TTC-45SubstEnv-subst e-6 e-4)))) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((sc2 (AlgebraC-45Semiring-isErased (csegen-475) e-7))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-getNEArgs (cons e-2 arg-0) e-4)) (else (cons (cons arg-0 e-9) (TTImpC-45ProcessBuiltin-getNEArgs (cons e-2 arg-0) e-4))))))))(else '()))))))(else '()))))
(define TTImpC-45ProcessBuiltin-getFirstNEType (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45ProcessBuiltin-getNEArgs arg-0 arg-1))) (if (null? sc0) '() (let ((e-2 (car sc0))) (box e-2))))))
(define TTImpC-45ProcessBuiltin-getConsGDef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--c (let ((e-0 (vector-ref e-5 0))) e-0))) ((PreludeC-45Basics-flip (csegen-1822) arg-2 (lambda (u--n) (lambda (eta-0) (let ((act-25 ((CoreC-45Context-lookupCtxtName u--n u--c) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 u--n eta-0) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-6)) eta-0) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-6)) eta-0) (let ((e-11 (cdr e-7))) (if (null? e-2) (vector 1 (cons e-8 e-11)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-6)) eta-0))))))))))))))))) ext-0))))))))
(define TTImpC-45ProcessBuiltin-checkNatCons (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessBuiltin-n--9264-18634-u--checkCon arg-3 arg-2 arg-1 arg-0 eta-0 eta-1 eta-2)))) (lambda (eta-0) (vector 1 (cons '() '()))) arg-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (if (null? e-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-3 (PreludeC-45TypesC-45String-C-43C-43 "No 'Z'-like constructors for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-2) "."))) ext-0) (if (null? e-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-3 (PreludeC-45TypesC-45String-C-43C-43 "No 'S'-like constructors for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-2) "."))) ext-0) (vector 1 0)))))))))))
(define TTImpC-45Parser-n--7734-9101-u--spanMap (lambda (arg-0 arg-1 arg-2 arg-3 arg-6 arg-7) (if (null? arg-7) (cons '() '()) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (arg-6 e-2))) (if (null? sc1) (cons '() (cons e-2 e-3)) (let ((e-4 (unbox sc1))) (let ((sc2 (TTImpC-45Parser-n--7734-9101-u--spanMap arg-0 arg-1 arg-2 arg-3 arg-6 e-3))) (let ((e-6 (car sc2))) (let ((e-5 (cdr sc2))) (cons (PreludeC-45TypesC-45List-tailRecAppend e-4 e-6) e-5))))))))))))
(define TTImpC-45Parser-n--11093-7549-u--parseWithArg (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol "|") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (TTImpC-45Parser-expr arg-1 arg-0) (lambda () (lambda (u--tm) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (cons (vector 0 arg-1 u--start u--end) u--tm)))))))))))))
(define TTImpC-45Parser-n--8609-7034-u--mkPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (vector 1 (vector 0 arg-1 arg-2 arg-3) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) e-6 '() arg-4 (TTImpC-45Parser-n--8609-7034-u--mkPi arg-0 arg-1 arg-2 arg-3 e-7 e-3)))))))))
(define TTImpC-45Parser-n--7734-9102-u--isClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((2) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-2))) (cond ((equal? sc1 1) (box e-3)) (else '()))))))(else '()))))
(define TTImpC-45Parser-n--11091-7251-u--getFn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 2))) (vector 0 e-2))) ((8) (let ((e-5 (vector-ref arg-5 2))) (TTImpC-45Parser-n--11091-7251-u--getFn arg-0 arg-1 arg-2 arg-3 arg-4 e-5))) ((9) (let ((e-9 (vector-ref arg-5 2))) (TTImpC-45Parser-n--11091-7251-u--getFn arg-0 arg-1 arg-2 arg-3 arg-4 e-9))) ((10) (let ((e-13 (vector-ref arg-5 2))) (TTImpC-45Parser-n--11091-7251-u--getFn arg-0 arg-1 arg-2 arg-3 arg-4 e-13)))(else (vector 4 '() 0 "Not a function application")))))
(define TTImpC-45Parser-n--12121-8287-u--fieldBody (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 1 (csegen-2348) (lambda () (lambda (u--ns) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-1 arg-0) (lambda () (lambda (u--ty) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (u--n) (vector (vector 0 arg-1 u--start u--end) (csegen-519) arg-2 (vector 1 (vector 0 u--n)) u--ty)) (DataC-45List1-forget u--ns)))))))))))))))))
(define TTImpC-45Parser-n--8599-6025-u--bindAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 2 arg-2 e-6 (vector 1 ) (box e-10) e-11 (TTImpC-45Parser-n--8599-6025-u--bindAll arg-0 arg-1 arg-2 e-3 arg-4)))))))))))
(define TTImpC-45Parser-n--8574-4717-u--applyExpImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (TTImpC-45Parser-n--8574-4717-u--applyExpImp arg-0 arg-1 arg-2 arg-3 (vector 8 (vector 0 arg-1 arg-2 arg-3) arg-4 e-6) e-3))) (else (let ((e-9 (vector-ref e-2 1))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (if (null? e-12) (TTImpC-45Parser-n--8574-4717-u--applyExpImp arg-0 arg-1 arg-2 arg-3 (vector 9 (vector 0 arg-1 arg-2 arg-3) arg-4 e-13) e-3) (let ((e-15 (unbox e-12))) (TTImpC-45Parser-n--8574-4717-u--applyExpImp arg-0 arg-1 arg-2 arg-3 (vector 10 (vector 0 arg-1 arg-2 arg-3) arg-4 e-15 e-13) e-3)))))))))))))
(define TTImpC-45Parser-n--11093-7548-u--applyArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (TTImpC-45Parser-n--11093-7548-u--applyArgs arg-0 arg-1 arg-2 (vector 8 e-6 arg-3 e-7) e-3))))))))
(define TTImpC-45Parser-visibility(blodwen-lazy (lambda () (vector 13 1 0 (TTImpC-45Parser-visOption) (lambda () (vector 0 0))))))
(define TTImpC-45Parser-visOption(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-keyword "public") (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "export") (lambda () (vector 0 2))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-keyword "export") (lambda () (vector 0 1))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "private") (lambda () (vector 0 0))))))))))
(define TTImpC-45Parser-visOpt(blodwen-lazy (lambda () (vector 13 1 1 (vector 9 0 (TTImpC-45Parser-visOption) (lambda () (lambda (u--vis) (vector 0 (vector 0 u--vis))))) (lambda () (vector 13 1 1 (vector 9 0 (TTImpC-45Parser-fnOpt) (lambda () (lambda (u--tot) (vector 0 (vector 1 u--tot))))) (lambda () (vector 9 0 (TTImpC-45Parser-fnDirectOpt) (lambda () (lambda (u--opt) (vector 0 (vector 1 u--opt))))))))))))
(define TTImpC-45Parser-typeExpr (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (TTImpC-45Parser-appExpr arg-0 arg-1) (lambda () (lambda (u--arg) (vector 13 1 0 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 9 0 (LibrariesC-45TextC-45Parser-some (vector 9 1 (TTImpC-45Parser-bindSymbol) (lambda () (lambda (u--exp) (vector 9 0 (TTImpC-45Parser-appExpr arg-0 arg-1) (lambda () (lambda (u--op) (vector 0 (cons u--exp u--op))))))))) (lambda () (lambda (u--rest) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (TTImpC-45Parser-n--8609-7034-u--mkPi arg-1 arg-0 u--start u--end u--arg (DataC-45List1-forget u--rest))))))))) (lambda () (vector 0 u--arg))))))))))
(define TTImpC-45Parser-tyDecl (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--nameEnd) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--ty) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector (vector 0 arg-0 u--start u--end) (vector 0 arg-0 u--start u--nameEnd) u--n u--ty)))))))))))))))))))
(define TTImpC-45Parser-totalityOpt(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-keyword "partial") (lambda () (vector 0 2))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-keyword "total") (lambda () (vector 0 0))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "covering") (lambda () (vector 0 1))))))))))
(define TTImpC-45Parser-topDecl (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 10 0 1 (TTImpC-45Parser-visibility) (lambda (u--vis) (vector 9 0 (TTImpC-45Parser-dataDecl arg-0 arg-1) (lambda () (lambda (u--dat) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 1 (vector 0 arg-0 u--start u--end) u--vis u--dat))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 1 (TTImpC-45Parser-namespaceDecl) (lambda () (lambda (u--ns) (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (TTImpC-45Parser-topDecl arg-0 eta-0))) (lambda () (lambda (u--ds) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 5 (vector 0 arg-0 u--start u--end) u--ns (DataC-45List1-forget u--ds))))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (TTImpC-45Parser-visOpt)) (lambda (u--visOpts) (vector 10 0 1 (TTImpC-45Parser-getVisibility '() u--visOpts) (lambda (u--vis) (let ((u--opts (DataC-45List-mapMaybe (lambda (eta-0) (TTImpC-45Parser-getRight eta-0)) u--visOpts))) (vector 10 0 1 (TTImpC-45Parser-multiplicity) (lambda (u--m) (vector 10 0 1 (TTImpC-45Parser-getMult u--m) (lambda (u--rig) (vector 9 0 (TTImpC-45Parser-tyDecl arg-0 arg-1) (lambda () (lambda (u--claim) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 0 (vector 0 arg-0 u--start u--end) u--rig u--vis u--opts u--claim)))))))))))))))))) (lambda () (vector 13 1 1 (TTImpC-45Parser-recordDecl arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-directive arg-0 arg-1) (lambda () (TTImpC-45Parser-definition arg-0 arg-1)))))))))))))
(define TTImpC-45Parser-simpleExpr (lambda (arg-0 arg-1) (vector 13 1 1 (TTImpC-45Parser-as arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-atom arg-0) (lambda () (vector 13 1 1 (TTImpC-45Parser-binder arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-rewrite_ arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-record_ arg-0 arg-1) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--e) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 u--e))))))))))))))))))))
(define TTImpC-45Parser-rewrite_ (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "rewrite") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--rule) (vector 11 1 (ParserC-45RuleC-45Source-keyword "in") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 14 (vector 0 arg-0 u--start u--end) u--rule u--tm))))))))))))))))))
(define TTImpC-45Parser-record_ (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "record") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") (TTImpC-45Parser-field arg-0 arg-1)) (lambda () (lambda (u--fs) (vector 11 1 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--sc) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 7 (vector 0 arg-0 u--start u--end) (DataC-45List1-forget u--fs) u--sc)))))))))))))))))))))
(define TTImpC-45Parser-recordParam (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 1 (TTImpC-45Parser-pibindListName arg-0 u--start arg-1) (lambda () (lambda (u--params) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-6 (cons e-2 (cons (vector 1 ) e-7)))))))) u--params))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 10 0 1 (vector 13 1 0 (vector 10 0 1 (csegen-2368) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-keyword "auto")))) (lambda () (vector 13 1 0 (vector 11 1 (ParserC-45RuleC-45Source-keyword "default") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--t) (vector 0 (vector 3 u--t))))))) (lambda () (vector 0 (vector 0 )))))) (lambda (u--info) (vector 9 1 (TTImpC-45Parser-pibindListName arg-0 u--start arg-1) (lambda () (lambda (u--params) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-6 (cons e-2 (cons u--info e-7)))))))) u--params)))))))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (cons (cons u--n (cons (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (cons (vector 1 ) (vector 32 (vector 0 arg-0 u--start u--end) 0)))) '())))))))))))))))
(define TTImpC-45Parser-recordDecl (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 10 0 1 (TTImpC-45Parser-visibility) (lambda (u--vis) (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 11 1 (ParserC-45RuleC-45Source-keyword "record") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (TTImpC-45Parser-recordParam arg-0 arg-1)) (lambda (u--paramss) (let ((u--params (PreludeC-45Interfaces-concat (csegen-50) u--paramss))) (vector 11 1 (ParserC-45RuleC-45Source-keyword "where") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "constructor") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--dc) (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter u--col (lambda (eta-0) (TTImpC-45Parser-fieldDecl arg-0 eta-0))) (lambda (u--flds) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (let ((u--fc (vector 0 arg-0 u--start u--end))) (vector 4 u--fc '() u--vis (vector u--fc u--n u--params u--dc (PreludeC-45Interfaces-concat (csegen-50) u--flds)))))))))))))))))))))))))))))))))
(define TTImpC-45Parser-prog (lambda (arg-0) (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (TTImpC-45Parser-topDecl arg-0 eta-0))) (lambda () (lambda (u--ds) (vector 0 (TTImpC-45Parser-collectDefs (DataC-45List1-forget u--ds))))))))
(define TTImpC-45Parser-pibindListName (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (vector 10 0 1 (TTImpC-45Parser-multiplicity) (lambda (u--rigc) (vector 9 1 (csegen-2348) (lambda () (lambda (u--ns) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-2) (lambda () (lambda (u--ty) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-2) (vector 10 0 0 (TTImpC-45Parser-getMult u--rigc) (lambda (u--rig) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (u--n) (cons u--rig (cons (vector 1 (vector 0 u--n)) u--ty))) (DataC-45List1-forget u--ns)))))))))))))))) (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") (vector 10 0 1 (TTImpC-45Parser-multiplicity) (lambda (u--rigc) (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-2) (lambda () (lambda (u--ty) (vector 10 0 0 (TTImpC-45Parser-getMult u--rigc) (lambda (u--rig) (vector 0 (cons u--rig (cons u--n u--ty)))))))))))))))))))))
(define TTImpC-45Parser-pibindList (lambda (arg-0 arg-1 arg-2) (vector 9 0 (TTImpC-45Parser-pibindListName arg-0 arg-1 arg-2) (lambda () (lambda (u--params) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons (box e-6) e-7))))))) u--params)))))))
(define TTImpC-45Parser-pibindAll (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 arg-0 e-6 arg-1 e-10 e-11 (TTImpC-45Parser-pibindAll arg-0 arg-1 e-3 arg-3)))))))))))
(define TTImpC-45Parser-parseRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "=") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (TTImpC-45Parser-expr arg-1 arg-2) (lambda () (lambda (u--rhs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-2) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (let ((u--fc (vector 0 arg-1 arg-3 u--end))) (vector 10 0 0 (TTImpC-45Parser-n--11091-7251-u--getFn arg-4 arg-3 arg-2 arg-1 arg-0 arg-4) (lambda (bind-0) (vector 0 (cons bind-0 (vector 0 u--fc arg-4 u--rhs))))))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-keyword "with") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--wstart) (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-1 arg-2) (lambda () (lambda (u--wval) (vector 11 1 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-keyword "proof")) (csegen-2374))) (lambda (u--prf) (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (TTImpC-45Parser-clause (+ 1 arg-0) arg-1 eta-0))) (lambda () (lambda (u--ws) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (let ((u--fc (vector 0 arg-1 arg-3 u--end))) (vector 10 0 0 (TTImpC-45Parser-n--11091-7251-u--getFn arg-4 arg-3 arg-2 arg-1 arg-0 arg-4) (lambda (bind-0) (vector 0 (cons bind-0 (vector 1 u--fc arg-4 u--wval u--prf '() (DataC-45List1-forget (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (Builtin-snd eta-0)) u--ws)))))))))))))))))))))))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "impossible") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-2) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (let ((u--fc (vector 0 arg-1 arg-3 u--end))) (vector 10 0 0 (TTImpC-45Parser-n--11091-7251-u--getFn arg-4 arg-3 arg-2 arg-1 arg-0 arg-4) (lambda (bind-0) (vector 0 (cons bind-0 (vector 2 u--fc arg-4)))))))))))))))))
(define TTImpC-45Parser-namespaceDecl(blodwen-lazy (lambda () (vector 11 1 (ParserC-45RuleC-45Source-keyword "namespace") (lambda () (vector 12 0 1 (vector 7 ) (ParserC-45RuleC-45Source-namespaceId)))))))
(define TTImpC-45Parser-multiplicity(blodwen-lazy (lambda () (vector 13 1 0 (vector 9 0 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--c) (vector 0 (box u--c))))) (lambda () (vector 0 '()))))))
(define TTImpC-45Parser-logLevel(blodwen-lazy (lambda () (vector 13 1 1 (csegen-2380) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 '() (vector 10 1 0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (csegen-113) (ParserC-45RuleC-45Source-unqualifiedName)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-many (ParserC-45RuleC-45Source-aDotIdent)))))) (lambda (u--topic) (vector 9 0 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--lvl) (vector 0 (box (cons u--topic (PreludeC-45Types-u--fromInteger_Num_Nat u--lvl))))))))))))))
(define TTImpC-45Parser-let_ (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "let") (lambda () (vector 10 0 1 (TTImpC-45Parser-multiplicity) (lambda (u--rigc) (vector 10 0 1 (TTImpC-45Parser-getMult u--rigc) (lambda (u--rig) (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 11 1 (ParserC-45RuleC-45Source-symbol "=") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--val) (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 11 1 (ParserC-45RuleC-45Source-keyword "in") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (let ((u--fc (vector 0 arg-0 u--start u--end))) (vector 3 u--fc (CoreC-45FC-boundToFC arg-0 u--n) u--rig (let ((e-1 (vector-ref u--n 0))) e-1) (vector 32 u--fc 0) u--val u--scope)))))))))))))))))))))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "let") (lambda () (vector 10 0 1 (ParserC-45RuleC-45Source-block (lambda (eta-0) (TTImpC-45Parser-topDecl arg-0 eta-0))) (lambda (u--ds) (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 11 1 (ParserC-45RuleC-45Source-keyword "in") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 5 (vector 0 arg-0 u--start u--end) (TTImpC-45Parser-collectDefs u--ds) u--scope))))))))))))))))))))
(define TTImpC-45Parser-lazy (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "Lazy") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 20 (vector 0 arg-0 u--start u--end) 1 u--tm))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "Inf") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 20 (vector 0 arg-0 u--start u--end) 0 u--tm))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "Delay") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 21 (vector 0 arg-0 u--start u--end) u--tm))))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "Force") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 22 (vector 0 arg-0 u--start u--end) u--tm)))))))))))))))))))
(define TTImpC-45Parser-lam (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "\\") (lambda () (vector 9 1 (TTImpC-45Parser-bindList arg-0 u--start arg-1) (lambda () (lambda (u--binders) (vector 11 1 (ParserC-45RuleC-45Source-symbol "=>") (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-mustContinue arg-1 '()) (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (TTImpC-45Parser-n--8599-6025-u--bindAll arg-1 arg-0 (vector 0 arg-0 u--start u--end) u--binders u--scope)))))))))))))))))))
(define TTImpC-45Parser-implicitPi (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 9 1 (TTImpC-45Parser-pibindList arg-0 u--start arg-1) (lambda () (lambda (u--binders) (vector 11 1 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "->") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (TTImpC-45Parser-pibindAll (vector 0 arg-0 u--start u--end) (vector 0 ) u--binders u--scope))))))))))))))))))))
(define TTImpC-45Parser-implicitArg (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 9 1 (csegen-2387) (lambda () (lambda (u--x) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "=") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons (box u--x) u--tm)))))))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (cons (box u--x) (vector 0 (vector 0 arg-0 u--start u--end) u--x)))))))))))))))) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "@{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons '() u--tm))))))))))))))
(define TTImpC-45Parser-getVisibility (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (vector 0 0) (let ((e-8 (car arg-1))) (let ((e-9 (cdr arg-1))) (case (vector-ref e-8 0) ((0) (let ((e-12 (vector-ref e-8 1))) (TTImpC-45Parser-getVisibility (box e-12) e-9)))(else (let ((e-2 (cdr arg-1))) (TTImpC-45Parser-getVisibility arg-0 e-2))))))) (let ((e-5 (unbox arg-0))) (if (null? arg-1) (vector 0 e-5) (let ((e-15 (car arg-1))) (case (vector-ref e-15 0) ((0) (vector 4 '() 1 "Multiple visibility modifiers"))(else (let ((e-2 (cdr arg-1))) (TTImpC-45Parser-getVisibility arg-0 e-2))))))))))
(define TTImpC-45Parser-getRight (lambda (arg-2) (case (vector-ref arg-2 0) ((0) '()) (else (let ((e-5 (vector-ref arg-2 1))) (box e-5))))))
(define TTImpC-45Parser-getMult (lambda (arg-0) (if (null? arg-0) (vector 0 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)) (let ((e-1 (unbox arg-0))) (cond ((equal? e-1 0) (csegen-2389)) ((equal? e-1 1) (csegen-2390))(else (vector 4 '() 1 "Invalid multiplicity (must be 0 or 1)")))))))
(define TTImpC-45Parser-forall_ (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "forall") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--nstart) (vector 9 1 (csegen-2348) (lambda () (lambda (u--ns) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--nend) (let ((u--nfc (vector 0 arg-0 u--nstart u--nend))) (let ((u--binders (PreludeC-45Types-u--map_Functor_List (lambda (u--n) (cons (csegen-21) (cons (box (vector 1 (vector 0 u--n))) (vector 32 u--nfc 0)))) (DataC-45List1-forget u--ns)))) (vector 11 1 (ParserC-45RuleC-45Source-symbol ".") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (TTImpC-45Parser-pibindAll (vector 0 arg-0 u--start u--end) (vector 0 ) u--binders u--scope)))))))))))))))))))))))))
(define TTImpC-45Parser-fnOpt(blodwen-lazy (lambda () (vector 9 0 (TTImpC-45Parser-totalityOpt) (lambda () (lambda (u--x) (vector 0 (vector 7 u--x))))))))
(define TTImpC-45Parser-fnDirectOpt(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "hint") (lambda () (vector 0 (vector 2 1)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "chaser") (lambda () (vector 0 (vector 2 0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "globalhint") (lambda () (vector 0 (vector 3 1)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "defaulthint") (lambda () (vector 0 (vector 3 0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "inline") (lambda () (vector 0 (vector 0 )))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-pragma "extern") (lambda () (vector 0 (vector 4 )))))))))))))))))
(define TTImpC-45Parser-fieldDecl (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-n--12121-8287-u--fieldBody arg-1 arg-0 (vector 0 )) (lambda () (lambda (u--fs) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 u--fs)))))))))) (lambda () (vector 9 0 (TTImpC-45Parser-n--12121-8287-u--fieldBody arg-1 arg-0 (vector 1 )) (lambda () (lambda (u--fs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 u--fs)))))))))
(define TTImpC-45Parser-field (lambda (arg-0 arg-1) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol "->") (ParserC-45RuleC-45Source-unqualifiedName)) (lambda () (lambda (u--path) (vector 9 1 (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-symbol "=") (lambda () (vector 0 (lambda (eta-0) (lambda (eta-1) (vector 0 eta-0 eta-1)))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-symbol "$=") (lambda () (vector 0 (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0 eta-1)))))))) (lambda () (lambda (u--upd) (vector 9 0 (TTImpC-45Parser-appExpr arg-0 arg-1) (lambda () (lambda (u--val) (vector 0 ((u--upd (DataC-45List1-forget u--path)) u--val)))))))))))))
(define TTImpC-45Parser-expr (lambda (ext-0 ext-1) (TTImpC-45Parser-typeExpr ext-0 ext-1)))
(define TTImpC-45Parser-explicitPi (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 9 1 (TTImpC-45Parser-pibindList arg-0 u--start arg-1) (lambda () (lambda (u--binders) (vector 11 1 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 9 1 (TTImpC-45Parser-bindSymbol) (lambda () (lambda (u--exp) (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (TTImpC-45Parser-pibindAll (vector 0 arg-0 u--start u--end) u--exp u--binders u--scope)))))))))))))))))))))
(define TTImpC-45Parser-directive (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-pragma "logging") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (TTImpC-45Parser-logLevel) (lambda () (lambda (u--lvl) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 9 u--lvl))))))))) (lambda () (vector 9 0 (csegen-2411) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 10 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3)))))))))))))
(define TTImpC-45Parser-definition (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (TTImpC-45Parser-clause 0 arg-0 arg-1) (lambda () (lambda (u--nd) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 2 (vector 0 arg-0 u--start u--end) (Builtin-fst u--nd) (cons (Builtin-snd u--nd) '()))))))))))))
(define TTImpC-45Parser-dataOpt(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "noHints") (lambda () (vector 0 (vector 1 )))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "uniqueSearch") (lambda () (vector 0 (vector 2 )))) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "search") (lambda () (vector 9 0 (csegen-2422) (lambda () (lambda (u--ns) (vector 0 (vector 0 u--ns))))))))))))))
(define TTImpC-45Parser-dataDecl (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "data") (lambda () (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--ty) (vector 11 0 (ParserC-45RuleC-45Source-keyword "where") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 '() (vector 11 1 (ParserC-45RuleC-45Source-symbol "[") (lambda () (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") (TTImpC-45Parser-dataOpt)) (lambda () (lambda (u--dopts) (vector 11 0 (ParserC-45RuleC-45Source-symbol "]") (lambda () (vector 0 (DataC-45List1-forget u--dopts)))))))))) (lambda (u--opts) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (TTImpC-45Parser-tyDecl arg-0 eta-0))) (lambda (u--cs) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 0 (vector 0 arg-0 u--start u--end) u--n u--ty u--opts u--cs))))))))))))))))))))))))
(define TTImpC-45Parser-command(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "t") (lambda () (vector 9 0 (TTImpC-45Parser-expr (vector 2 0) (ParserC-45RuleC-45Source-init)) (lambda () (lambda (u--tm) (vector 0 (vector 1 u--tm))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "s") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 2 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "es") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 3 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "gd") (lambda () (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--l) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 4 (blodwen-toSignedInt u--l 63) u--n)))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "missing") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 5 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-keyword "total") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 6 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "di") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 7 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "q") (lambda () (vector 0 (vector 8 )))))) (lambda () (vector 9 0 (TTImpC-45Parser-expr (vector 2 0) (ParserC-45RuleC-45Source-init)) (lambda () (lambda (u--tm) (vector 0 (vector 0 u--tm))))))))))))))))))))))))
(define TTImpC-45Parser-collectDefs (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((sc2 (TTImpC-45Parser-n--7734-9101-u--spanMap e-7 e-6 e-5 e-3 (lambda (eta-0) (TTImpC-45Parser-n--7734-9102-u--isClause e-7 e-6 e-5 e-3 e-6 eta-0)) e-3))) (let ((e-8 (car sc2))) (let ((e-4 (cdr sc2))) (cons (vector 2 e-5 e-6 (PreludeC-45TypesC-45List-tailRecAppend e-7 e-8)) (TTImpC-45Parser-collectDefs e-4))))))))) ((5) (let ((e-9 (vector-ref e-2 1))) (let ((e-10 (vector-ref e-2 2))) (let ((e-11 (vector-ref e-2 3))) (cons (vector 5 e-9 e-10 (TTImpC-45Parser-collectDefs e-11)) (TTImpC-45Parser-collectDefs e-3))))))(else (cons e-2 (TTImpC-45Parser-collectDefs e-3)))))))))
(define TTImpC-45Parser-clause (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 1 (TTImpC-45Parser-expr arg-1 arg-2) (lambda () (lambda (u--lhs) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (TTImpC-45Parser-n--11093-7549-u--parseWithArg arg-2 arg-1 arg-0)) (lambda (u--extra) (let ((sc0 (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-0 (PreludeC-45TypesC-45List-length u--extra)))) (cond ((equal? sc0 1) (vector 4 '() 1 "Wrong number of 'with' arguments")) (else (TTImpC-45Parser-parseRHS arg-0 arg-1 arg-2 u--start (TTImpC-45Parser-n--11093-7548-u--applyArgs arg-2 arg-1 arg-0 u--lhs u--extra))))))))))))))
(define TTImpC-45Parser-case_ (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "case") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--scr) (vector 11 0 (ParserC-45RuleC-45Source-keyword "of") (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (TTImpC-45Parser-caseAlt arg-0 eta-0))) (lambda (u--alts) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (let ((u--fc (vector 0 arg-0 u--start u--end))) (vector 4 u--fc u--scr (vector 32 u--fc 0) u--alts))))))))))))))))))
(define TTImpC-45Parser-caseRHS (lambda (arg-0 arg-1 arg-2 arg-3) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "=>") (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--rhs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 0 (vector 0 arg-0 arg-2 u--end) arg-3 u--rhs))))))))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "impossible") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 2 (vector 0 arg-0 arg-2 u--end) arg-3)))))))))))
(define TTImpC-45Parser-caseAlt (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 1 (TTImpC-45Parser-appExpr arg-0 arg-1) (lambda () (lambda (u--lhs) (TTImpC-45Parser-caseRHS arg-0 arg-1 u--start u--lhs))))))))
(define TTImpC-45Parser-binder (lambda (arg-0 arg-1) (vector 13 1 1 (TTImpC-45Parser-autoImplicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-forall_ arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-implicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-explicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-lam arg-0 arg-1) (lambda () (TTImpC-45Parser-let_ arg-0 arg-1)))))))))))))
(define TTImpC-45Parser-bindSymbol(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-symbol "->") (lambda () (vector 0 (vector 1 )))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-symbol "=>") (lambda () (vector 0 (vector 2 )))))))))
(define TTImpC-45Parser-bindList (lambda (arg-0 arg-1 arg-2) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") (vector 10 0 1 (TTImpC-45Parser-multiplicity) (lambda (u--rigc) (vector 9 0 (ParserC-45RuleC-45Source-unqualifiedName) (lambda () (lambda (u--n) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 (vector 32 (vector 0 arg-0 arg-1 u--end) 0) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (TTImpC-45Parser-appExpr arg-0 arg-2)))) (lambda (u--ty) (vector 10 0 0 (TTImpC-45Parser-getMult u--rigc) (lambda (u--rig) (vector 0 (cons u--rig (cons (vector 1 (vector 0 u--n)) u--ty))))))))))))))))))
(define TTImpC-45Parser-autoImplicitPi (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-keyword "auto") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-pibindList arg-0 u--start arg-1) (lambda () (lambda (u--binders) (vector 11 1 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "->") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (TTImpC-45Parser-pibindAll (vector 0 arg-0 u--start u--end) (vector 2 ) u--binders u--scope)))))))))))))))))))))))
(define TTImpC-45Parser-atom (lambda (arg-0) (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (ParserC-45RuleC-45Source-constant) (lambda () (lambda (u--x) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 28 (vector 0 arg-0 u--start u--end) u--x))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (ParserC-45RuleC-45Source-simpleStr) (lambda () (lambda (u--str) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 28 (vector 0 arg-0 u--start u--end) (vector 10 u--str)))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "Type") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 29 (vector 0 arg-0 u--start u--end))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 0 (ParserC-45RuleC-45Source-symbol "_") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 32 (vector 0 arg-0 u--start u--end) 1)))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 0 (ParserC-45RuleC-45Source-symbol "?") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 32 (vector 0 arg-0 u--start u--end) 0)))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 0 (ParserC-45RuleC-45Source-pragma "search") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 12 (vector 0 arg-0 u--start u--end) (PreludeC-45Types-u--fromInteger_Num_Nat 1000))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--x) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 0 (vector 0 arg-0 u--start u--end) u--x))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "$") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-unqualifiedName) (lambda () (lambda (u--x) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 17 (vector 0 arg-0 u--start u--end) u--x))))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (ParserC-45RuleC-45Source-holeName) (lambda () (lambda (u--x) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 30 (vector 0 arg-0 u--start u--end) u--x)))))))))))))))))))))))))))
(define TTImpC-45Parser-as (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 1 (csegen-2387) (lambda () (lambda (u--x) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--nameEnd) (vector 11 1 (ParserC-45RuleC-45Source-symbol "@") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--pat) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 18 (vector 0 arg-0 u--start u--end) (vector 0 arg-0 u--start u--nameEnd) 1 u--x u--pat))))))))))))))))))
(define TTImpC-45Parser-argExpr (lambda (arg-0 arg-1) (vector 13 1 1 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--arg) (vector 0 (vector 0 u--arg)))))) (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 9 0 (TTImpC-45Parser-implicitArg arg-0 arg-1) (lambda () (lambda (u--arg) (vector 0 (vector 1 u--arg))))))))))
(define TTImpC-45Parser-appExpr (lambda (arg-0 arg-1) (vector 13 1 1 (TTImpC-45Parser-case_ arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-lazy arg-0 arg-1) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--f) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (TTImpC-45Parser-argExpr arg-0 arg-1)) (lambda (u--args) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (TTImpC-45Parser-n--8574-4717-u--applyExpImp arg-1 arg-0 u--start u--end u--f u--args)))))))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-case--propBindableUsed-4014 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-2 0))) (cond ((equal? sc1 1) 1.0) (else (PreludeC-45Num-u--C-47_Fractional_Double (PreludeC-45Cast-u--cast_Cast_Nat_Double e-3) (PreludeC-45Cast-u--cast_Cast_Nat_Double e-2)))))))))
(define TTImpC-45InteractiveC-45GenerateDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandClause-2565 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (case (vector-ref arg-15 0) ((2) (let ((e-2 (vector-ref arg-15 2))) (let ((e-3 (vector-ref arg-15 3))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupDefExact (vector 8 e-3) (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 "No searchable hole on RHS") ext-0) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((7) (let ((e-9 (vector-ref e-7 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "interaction.generate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Expression search for " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1506) (cons e-2 e-3)))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((act-27 (TTImpC-45InteractiveC-45ExprSearch-exprSearchOpts arg-0 arg-7 arg-6 arg-5 arg-3 arg-4 (vector 8 e-3) '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (TTImpC-45InteractiveC-45ExprSearch-traverse (lambda (u--rhsC-39) (let ((u--rhsraw (TTImpC-45InteractiveC-45GenerateDef-n--11645-2453-u--dropLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-9 u--rhsC-39))) (lambda (eta-0) (let ((act-28 (CoreC-45Normalise-logTermNF arg-10 arg-0 "interaction.generate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Got clause") arg-13 arg-12 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-0 "interaction.generate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "        = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--rhsraw))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (vector 1 (cons (TTImpC-45InteractiveC-45GenerateDef-n--11645-2452-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 u--rhsraw) '()))))))))))) e-11 ext-0))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 "No searchable hole on RHS") ext-0))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 "No searchable hole on RHS") ext-0)))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12177-2910-u--valid (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 2))) (box e-1)))(else '()))))
(define TTImpC-45InteractiveC-45GenerateDef-n--11645-2452-u--updateRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (vector 0 e-1 e-2 arg-9)))) ((1) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-8 (vector-ref arg-8 4))) (let ((e-9 (vector-ref arg-8 5))) (let ((e-10 (vector-ref arg-8 6))) (vector 1 e-5 e-6 e-7 e-8 e-9 e-10)))))))) (else (let ((e-12 (vector-ref arg-8 1))) (let ((e-13 (vector-ref arg-8 2))) (vector 2 e-12 e-13)))))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12177-2912-u--updateLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((sc1 (DataC-45List-lookup (csegen-802) e-2 arg-9))) (if (null? sc1) (vector 0 e-1 e-2) (let ((e-3 (unbox sc1))) (TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3))))))) ((17) (let ((e-4 (vector-ref arg-10 1))) (let ((e-5 (vector-ref arg-10 2))) (let ((sc1 (DataC-45List-lookup (csegen-802) (vector 1 (vector 0 e-5)) arg-9))) (if (null? sc1) (vector 17 e-4 e-5) (let ((e-2 (unbox sc1))) (TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2))))))) ((8) (let ((e-7 (vector-ref arg-10 1))) (let ((e-8 (vector-ref arg-10 2))) (let ((e-9 (vector-ref arg-10 3))) (vector 8 e-7 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2912-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-8) (TTImpC-45InteractiveC-45GenerateDef-n--12177-2912-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-9)))))) ((9) (let ((e-11 (vector-ref arg-10 1))) (let ((e-12 (vector-ref arg-10 2))) (let ((e-13 (vector-ref arg-10 3))) (vector 9 e-11 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2912-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-12) (TTImpC-45InteractiveC-45GenerateDef-n--12177-2912-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-13)))))) ((10) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((e-18 (vector-ref arg-10 4))) (vector 10 e-15 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2912-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-16) e-17 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2912-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-18)))))))(else arg-10))))
(define TTImpC-45InteractiveC-45GenerateDef-n--11600-2404-u--mkUniqueName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((30) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45Utils-uniqueName e-5 '() e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 30 e-1 e-6)))))))))))))(else (vector 1 arg-4)))))
(define TTImpC-45InteractiveC-45GenerateDef-n--13356-3928-u--getProp (lambda (arg-0 arg-1) (if (null? arg-1) (cons 0 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (TTImpC-45InteractiveC-45GenerateDef-n--13356-3928-u--getProp arg-0 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (TTImpC-45InteractiveC-45GenerateDef-bindableUsed e-2))) (if (null? sc2) (cons e-5 e-4) (let ((e-6 (unbox sc2))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (cons (PreludeC-45Types-u--C-43_Num_Nat e-5 (PreludeC-45TypesC-45List-length (DataC-45List-nub (csegen-802) e-8))) (PreludeC-45Types-u--C-43_Num_Nat e-4 (PreludeC-45TypesC-45List-length (DataC-45List-nub (csegen-802) e-7)))))))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (case (vector-ref e-2 0) ((1) (let ((e-16 (vector-ref e-2 1))) (case (vector-ref e-16 0) ((0) (let ((e-19 (vector-ref e-16 1))) (vector 17 e-1 e-19)))(else arg-9)))) ((2) (vector 32 e-1 1))(else arg-9))))) ((8) (let ((e-4 (vector-ref arg-9 1))) (let ((e-5 (vector-ref arg-9 2))) (let ((e-6 (vector-ref arg-9 3))) (vector 8 e-4 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-5) (TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-6)))))) ((9) (let ((e-8 (vector-ref arg-9 1))) (let ((e-9 (vector-ref arg-9 2))) (let ((e-10 (vector-ref arg-9 3))) (vector 9 e-8 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-9) (TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-10)))))) ((10) (let ((e-12 (vector-ref arg-9 1))) (let ((e-13 (vector-ref arg-9 2))) (let ((e-14 (vector-ref arg-9 3))) (let ((e-15 (vector-ref arg-9 4))) (vector 10 e-12 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-13) e-14 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2911-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-15)))))))(else arg-9))))
(define TTImpC-45InteractiveC-45GenerateDef-n--11645-2453-u--dropLams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (cond ((equal? arg-8 0) arg-9)(else (let ((e-0 (- arg-8 1))) (case (vector-ref arg-9 0) ((2) (let ((e-7 (vector-ref arg-9 6))) (TTImpC-45InteractiveC-45GenerateDef-n--11645-2453-u--dropLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-0 e-7)))(else arg-9)))))))
(define TTImpC-45InteractiveC-45GenerateDef-uniqueRHS (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((act-24 (TTImpC-45InteractiveC-45GenerateDef-n--11600-2404-u--mkUniqueName e-3 e-2 e-1 arg-0 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-2 e-5))))))))))(else (vector 1 arg-1)))))
(define TTImpC-45InteractiveC-45GenerateDef-trySplit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-getSplitsLHS arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-6 arg-8) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-1 (vector-ref e-5 1))) (vector 1 (cons arg-8 (PreludeC-45Types-u--map_Functor_List (lambda (u--ups) (vector 0 arg-4 (TTImpC-45InteractiveC-45GenerateDef-n--12177-2912-u--updateLHS arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--ups arg-5) arg-7)) (DataC-45List-mapMaybe (lambda (eta-0) (TTImpC-45InteractiveC-45GenerateDef-n--12177-2910-u--valid arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) e-1))))))(else (vector 1 (cons arg-8 '()))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-tryAllSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (if (null? e-7) (TTImpC-45InteractiveC-45GenerateDef-tryAllSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "interaction.generate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Splitting on " (CoreC-45Name-u--show_Show_Name e-6))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((TTImpC-45InteractiveC-45ExprSearch-trySearch arg-0 arg-2 (lambda (eta-1) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-2) (TTImpC-45InteractiveC-45GenerateDef-mkSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-2)) e-7 '() eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (TTImpC-45InteractiveC-45GenerateDef-collectClauses arg-0 arg-2 e-8 eta-1)))))) (TTImpC-45InteractiveC-45GenerateDef-tryAllSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)) eta-0)))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-splittableNames (lambda (arg-0) (case (vector-ref arg-0 0) ((8) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (case (vector-ref e-3 0) ((17) (let ((e-15 (vector-ref e-3 2))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-2) (cons (vector 1 (vector 0 e-15)) '()))))(else (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-2)))))) ((9) (let ((e-6 (vector-ref arg-0 2))) (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-6))) ((10) (let ((e-10 (vector-ref arg-0 2))) (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-10)))(else '()))))
(define TTImpC-45InteractiveC-45GenerateDef-propBindableUsed (lambda (arg-0) (TTImpC-45InteractiveC-45GenerateDef-case--propBindableUsed-4014 arg-0 (TTImpC-45InteractiveC-45GenerateDef-n--13356-3928-u--getProp arg-0 arg-0))))
(define TTImpC-45InteractiveC-45GenerateDef-mostUsed (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Double (TTImpC-45InteractiveC-45GenerateDef-propBindableUsed arg-1) (TTImpC-45InteractiveC-45GenerateDef-propBindableUsed arg-0))))
(define TTImpC-45InteractiveC-45GenerateDef-mkSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (TTImpC-45InteractiveC-45ExprSearch-trySearch arg-0 arg-2 (lambda (clam-0) (let ((sc0 (let ((e-7 (vector-ref arg-5 7))) e-7))) (cond ((equal? sc0 1) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0)) (else (TTImpC-45InteractiveC-45GenerateDef-expandClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 clam-0))))) (lambda (eta-0) (let ((act-24 (TTImpC-45InteractiveC-45GenerateDef-generateSplits arg-1 arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "interaction.generate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Splits: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2466) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2466) u--d u--x)))) e-5))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45GenerateDef-tryAllSplits arg-0 arg-1 arg-2 arg-3 arg-4 (let ((e-0 (vector-ref arg-5 0))) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-11 (vector-ref arg-5 5))) (let ((e-10 (vector-ref arg-5 6))) (let ((e-9 (vector-ref arg-5 9))) (vector e-0 e-1 e-2 e-3 e-4 e-11 e-10 0 1 e-9))))))))) arg-6 e-5) eta-0))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-makeDefSort (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (TTImpC-45InteractiveC-45ExprSearch-searchSort arg-0 arg-2 arg-5 (lambda (eta-0) (TTImpC-45InteractiveC-45GenerateDef-makeDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-7 eta-0)) (lambda (u--x) (lambda (u--y) ((arg-6 (Builtin-snd u--x)) (Builtin-snd u--y)))) ext-0)))
(define TTImpC-45InteractiveC-45GenerateDef-makeDefN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (TTImpC-45InteractiveC-45ExprSearch-searchN arg-0 arg-2 arg-5 (lambda (eta-0) (TTImpC-45InteractiveC-45GenerateDef-makeDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (vector 1 e-2))))))))
(define TTImpC-45InteractiveC-45GenerateDef-makeDefFromType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (CoreC-45UnifyState-tryUnify arg-0 arg-2 (lambda (eta-0) (let ((act-24 (CoreC-45Context-branch arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-2))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-8) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((TTImpC-45InteractiveC-45CaseSplit-getEnvArgNames arg-0 e-5 arg-7 e-8) eta-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--pre_env (DataC-45List-replicate arg-7 (vector 32 arg-4 1)))) (let ((act-28 (TTImpC-45Utils-uniqueName e-5 '() (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45InteractiveC-45GenerateDef-fnName 0 arg-6) "_rhs") eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--initcs (vector 0 arg-4 (TTImpC-45TTImp-apply (vector 0 arg-4 arg-6) (PreludeC-45TypesC-45List-tailRecAppend u--pre_env (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 17 arg-4 eta-1)) e-8))) (vector 30 arg-4 e-9)))) (let ((sc5 (CoreC-45Context-getNameID arg-6 (let ((e-0 (vector-ref e-5 0))) e-0)))) (if (null? sc5) (CoreC-45Context-undefinedName arg-0 arg-4 arg-6 eta-0) (let ((e-1 (unbox sc5))) (let ((act-29 ((TTImpC-45InteractiveC-45GenerateDef-mkSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-1 u--initcs) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (set-box! arg-0 e-5))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (let ((act-31 (set-box! arg-1 e-6))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (let ((act-32 (set-box! arg-2 e-7))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (vector 1 (TTImpC-45InteractiveC-45ExprSearch-u--map_Functor_Search (lambda (u--c) (cons arg-4 u--c)) e-10))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)) ext-0)))
(define TTImpC-45InteractiveC-45GenerateDef-makeDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Metadata-findTyDeclAt arg-1 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (TTImpC-45InteractiveC-45ExprSearch-noResult ext-0) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((act-25 (CoreC-45Context-getFullName arg-0 e-9 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-logTerm '() arg-0 "interaction.generate" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Searching for " (CoreC-45Name-u--show_Show_Name e-8))) e-14 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((u--opts (let ((sc7 (csegen-2471))) (let ((e-0 (vector-ref sc7 0))) (let ((e-19 (vector-ref sc7 1))) (let ((e-2 (vector-ref sc7 2))) (let ((e-3 (vector-ref sc7 3))) (let ((e-4 (vector-ref sc7 4))) (let ((e-18 (vector-ref sc7 5))) (let ((e-17 (vector-ref sc7 6))) (let ((e-16 (vector-ref sc7 7))) (let ((e-15 (vector-ref sc7 8))) (vector e-0 e-19 e-2 e-3 e-4 e-18 e-17 e-16 e-15 (box (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (TTImpC-45InteractiveC-45GenerateDef-makeDefFromType arg-0 arg-1 arg-2 arg-3 (CoreC-45FC-justFC e-7) eta-0 eta-1 eta-2 eta-3 eta-4)))))))))))))))))))) (TTImpC-45InteractiveC-45GenerateDef-makeDefFromType arg-0 arg-1 arg-2 arg-3 (CoreC-45FC-justFC e-7) u--opts e-8 e-13 e-14 ext-0)))))))))))))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-generateSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((2) (vector 1 '())) ((1) (vector 1 '())) (else (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((act-24 ((TTImpC-45Elab-elabTerm '() arg-1 arg-0 arg-2 arg-3 arg-6 (vector 1 (csegen-519)) '() '() '() (vector 16 arg-4 (vector 1 ) e-12) '()) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((u--splitnames (let ((sc3 (let ((e-6 (vector-ref arg-5 6))) e-6))) (cond ((equal? sc3 1) (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-12)) (else (PreludeC-45TypesC-45List-reverse (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-12))))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45InteractiveC-45GenerateDef-trySplit arg-0 arg-1 arg-2 arg-3 e-11 e-12 e-2 e-13 eta-0 eta-1))) u--splitnames '() ext-0))))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-fnName (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((0) (let ((e-5 (vector-ref e-0 1))) (let ((sc2 (ParserC-45LexerC-45Common-isIdentNormal e-5))) (cond ((equal? sc2 1) e-5) (else (cond ((equal? arg-0 1) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-5 ")"))) (else "op")))))))(else (CoreC-45Name-nameRoot arg-1))))) ((0) (let ((e-2 (vector-ref arg-1 2))) (TTImpC-45InteractiveC-45GenerateDef-fnName arg-0 e-2))) ((4) (let ((e-3 (vector-ref arg-1 1))) e-3))(else (CoreC-45Name-nameRoot arg-1)))))
(define TTImpC-45InteractiveC-45GenerateDef-expandClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (TTImpC-45InteractiveC-45GenerateDef-uniqueRHS arg-0 arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45ProcessDef-checkClause '() arg-0 arg-1 arg-2 arg-3 (csegen-519) 0 2 0 arg-6 '() '() '() e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (let ((_-0 (vector 1 e-2))) (let ((e-0 (vector-ref e-2 0))) (let ((e-1 (vector-ref e-2 1))) (let ((e-4 (vector-ref e-2 2))) (let ((e-3 (vector-ref e-2 3))) (let ((u--clause (vector e-0 e-1 e-4 e-3))) (TTImpC-45InteractiveC-45GenerateDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandClause-2565 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 _-0 e-0 e-3 e-4 e-1 u--clause (CoreC-45TT-getFn e-3) ext-0))))))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult ext-0)))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-collectClauses (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (TTImpC-45InteractiveC-45ExprSearch-one '() ext-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 (TTImpC-45InteractiveC-45GenerateDef-collectClauses arg-0 arg-1 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45ExprSearch-combine arg-0 arg-1 (csegen-2473) e-2 e-5) ext-0))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-bindableUsed (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((u--lhsns (TTImpC-45Utils-findIBindVars e-2))) (let ((u--rhsns (TTImpC-45Utils-findAllNames '() e-3))) (box (cons u--lhsns (DataC-45List-filter (lambda (u--x) (PreludeC-45Types-elem (csegen-802) u--x u--lhsns)) u--rhsns))))))))(else '()))))
(define TTImpC-45InteractiveC-45ExprSearch-case--searchType-7281 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Searching locals only at") arg-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((u--tryInt (let ((sc2 (let ((e-10 (vector-ref arg-5 5))) e-10))) (cond ((equal? sc2 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediate arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '())))))) (let ((u--tryIntRec (let ((sc2 (let ((sc3 (let ((e-4 (vector-ref arg-5 4))) e-4))) (cond ((equal? sc3 1) 1) (else (let ((sc4 (let ((e-8 (vector-ref arg-5 8))) e-8))) (cond ((equal? sc4 1) 0) (else 1)))))))) (cond ((equal? sc2 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 (let ((e-2 (vector-ref arg-5 2))) e-2)) '())))))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 1 arg-4 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend u--tryInt (PreludeC-45TypesC-45List-tailRecAppend (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '()) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-2 (vector-ref arg-5 2))) (if (null? e-2) '() (let ((e-11 (unbox e-2))) (cons (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 e-11 eta-1)) '())))) u--tryIntRec))) eta-0))))))) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((3) (let ((e-9 (vector-ref e-6 2))) (let ((act-24 (let ((act-24 (unbox arg-10))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((sc4 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length e-3) e-9))) (cond ((equal? sc4 1) (let ((act-25 (CoreC-45Context-getSearchData arg-10 arg-7 0 e-7 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-25 1))) (let ((u--allHints (PreludeC-45Interfaces-concat (csegen-50) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-1 (cdr e-11))) e-1))))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-10 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Hints found for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-7) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) u--allHints))))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((u--tries (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) (cons (TTImpC-45InteractiveC-45ExprSearch-searchNames arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 u--allHints) '())))) (let ((u--tryRec (let ((e-19 (vector-ref arg-5 2))) (if (null? e-19) '() (let ((e-20 (unbox e-19))) (cons (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 e-20 eta-0)) '())))))) (let ((u--tryIntRec (let ((sc7 (let ((e-14 (vector-ref arg-5 8))) e-14))) (cond ((equal? sc7 1) (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 (let ((e-19 (vector-ref arg-5 2))) e-19)) '())) (else '()))))) (let ((u--tryInt (let ((sc7 (let ((e-17 (vector-ref arg-5 5))) e-17))) (cond ((equal? sc7 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediate arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '())))))) (let ((u--allns (let ((sc7 (let ((e-4 (vector-ref arg-5 4))) e-4))) (cond ((equal? sc7 1) (PreludeC-45TypesC-45List-tailRecAppend u--tryRec (PreludeC-45TypesC-45List-tailRecAppend u--tryInt u--tries))) (else (PreludeC-45TypesC-45List-tailRecAppend u--tryInt (PreludeC-45TypesC-45List-tailRecAppend u--tries (PreludeC-45TypesC-45List-tailRecAppend u--tryRec u--tryIntRec)))))))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 1 arg-4 arg-2 arg-3 u--allns clam-0))))))))))))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0)))))))))(else (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Searching locals only at") arg-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((u--tryInt (let ((sc3 (let ((e-13 (vector-ref arg-5 5))) e-13))) (cond ((equal? sc3 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediate arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '())))))) (let ((u--tryIntRec (let ((sc3 (let ((sc4 (let ((e-4 (vector-ref arg-5 4))) e-4))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (let ((e-10 (vector-ref arg-5 8))) e-10))) (cond ((equal? sc5 1) 0) (else 1)))))))) (cond ((equal? sc3 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 (let ((e-15 (vector-ref arg-5 2))) e-15)) '())))))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 1 arg-4 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend u--tryInt (PreludeC-45TypesC-45List-tailRecAppend (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '()) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-15 (vector-ref arg-5 2))) (if (null? e-15) '() (let ((e-16 (unbox e-15))) (cons (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 e-16 eta-0)) '())))) u--tryIntRec))) clam-0)))))))))))(else (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Searching locals only at") arg-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((u--tryInt (let ((sc2 (let ((e-10 (vector-ref arg-5 5))) e-10))) (cond ((equal? sc2 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediate arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '())))))) (let ((u--tryIntRec (let ((sc2 (let ((sc3 (let ((e-4 (vector-ref arg-5 4))) e-4))) (cond ((equal? sc3 1) 1) (else (let ((sc4 (let ((e-8 (vector-ref arg-5 8))) e-8))) (cond ((equal? sc4 1) 0) (else 1)))))))) (cond ((equal? sc2 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 (let ((e-12 (vector-ref arg-5 2))) e-12)) '())))))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 1 arg-4 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend u--tryInt (PreludeC-45TypesC-45List-tailRecAppend (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '()) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-12 (vector-ref arg-5 2))) (if (null? e-12) '() (let ((e-13 (unbox e-12))) (cons (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 e-13 eta-0)) '())))) u--tryIntRec))) clam-0))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32searchIfHole-2214 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (case (vector-ref arg-15 0) ((7) (let ((act-24 (TTImpC-45InteractiveC-45ExprSearch-search arg-8 arg-7 arg-6 arg-5 arg-11 (let ((e-11 (vector-ref arg-4 0))) (let ((e-10 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-5 (vector-ref arg-4 5))) (let ((e-6 (vector-ref arg-4 6))) (let ((e-7 (vector-ref arg-4 7))) (let ((e-8 (vector-ref arg-4 8))) (let ((e-9 (vector-ref arg-4 9))) (vector e-11 e-10 e-2 arg-9 1 e-5 e-6 e-7 e-8 e-9))))))))) arg-3 (vector 8 arg-10) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45InteractiveC-45ExprSearch-traverse (lambda (lamc-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-8 arg-0 arg-12 arg-2 (CoreC-45UnifyState-applyTo arg-0 arg-5 (CoreC-45TT-embed e-2) arg-2) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-6 e-3)))))))))) e-5 ext-0))))))(else (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-8 arg-0 arg-12 arg-2 (let ((e-4 (vector-ref arg-1 3))) e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45InteractiveC-45ExprSearch-one (cons e-5 '()) ext-0)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--13642-3620-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-14 arg-12) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((sc2 (CoreC-45Context-visibleInAny arg-13 arg-14 (let ((e-9 (vector-ref e-1 9))) e-9)))) (cond ((equal? sc2 1) (vector 1 (box (cons arg-14 e-1)))) (else (vector 1 '()))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--12720-2829-u--usableName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((1) 1) ((0) (let ((e-2 (vector-ref arg-12 2))) (TTImpC-45InteractiveC-45ExprSearch-n--12720-2829-u--usableName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2))) ((5) (let ((e-4 (vector-ref arg-12 2))) (TTImpC-45InteractiveC-45ExprSearch-n--12720-2829-u--usableName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-4)))(else 0))))
(define TTImpC-45InteractiveC-45ExprSearch-n--11712-1945-u--usableName (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((1) 1)(else 0))))
(define TTImpC-45InteractiveC-45ExprSearch-n--15768-5519-u--toApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14) (case (vector-ref arg-14 0) ((2) (let ((e-1 (vector-ref arg-14 1))) (let ((e-3 (vector-ref arg-14 3))) (let ((e-4 (vector-ref arg-14 4))) (CoreC-45TT-apply e-1 (vector 1 e-1 (vector 1 ) (vector 8 e-3)) e-4)))))(else arg-14))))
(define TTImpC-45InteractiveC-45ExprSearch-n--13949-3889-u--structDiffTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) (let ((e-2 (car arg-14))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3888-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-2))))
(define TTImpC-45InteractiveC-45ExprSearch-n--13949-3888-u--structDiff (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) (let ((sc0 (CoreC-45TT-getFnArgs arg-13))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (CoreC-45TT-getFnArgs arg-14))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3887-u--appsDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-5 e-3 e-4)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--11290-1539-u--returnBatch (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-6) (TTImpC-45InteractiveC-45ExprSearch-searchSort arg-5 arg-4 arg-3 arg-7 arg-1 clam-0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (vector 1 (cons e-2 (TTImpC-45InteractiveC-45ExprSearch-n--11290-1539-u--returnBatch arg-1 arg-2 arg-3 arg-4 arg-5 e-3 arg-7)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--16541-6183-u--matchable (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (lambda (clam-0) (case (vector-ref arg-14 0) ((0) (let ((e-1 (vector-ref arg-14 1))) (let ((e-3 (vector-ref arg-14 3))) (let ((e-4 (vector-ref arg-14 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (((e-4 arg-13) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-6 (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45ExprSearch-n--16541-6183-u--matchable arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-5) clam-0))))))(else (vector 1 0))))))) ((3) (vector 1 1))(else (vector 1 0))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--19606-8825-u--lookupHoleName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExactI arg-8 (let ((e-0 (vector-ref arg-9 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 ((CoreC-45Context-lookupCtxtName arg-8 (let ((e-0 (vector-ref arg-9 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-2) (vector 1 (box e-1)) (vector 1 '()))))))))) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (vector 1 (box (cons arg-8 (cons e-7 e-6))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--11704-8206-u--lookupHoleName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExactI arg-8 arg-9) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 ((CoreC-45Context-lookupCtxtName arg-8 arg-9) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-2) (vector 1 (box e-1)) (vector 1 '()))))))))) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (vector 1 (box (cons arg-8 (cons e-7 e-6))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--16980-6558-u--isSingleCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (case (vector-ref arg-12 0) ((0) (let ((e-1 (vector-ref arg-12 1))) (let ((e-3 (vector-ref arg-12 3))) (let ((e-4 (vector-ref arg-12 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (((e-4 arg-11) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45ExprSearch-n--16980-6558-u--isSingleCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5) clam-0))))))(else (vector 1 0))))))) ((3) (let ((e-7 (vector-ref arg-12 2))) (let ((act-24 (CoreC-45Context-lookupDefExact e-7 (let ((e-0 (vector-ref arg-11 0))) e-0) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((6) (let ((e-12 (vector-ref e-1 7))) (if (null? e-12) (vector 1 0) (let ((e-16 (cdr e-12))) (if (null? e-16) (vector 1 1) (vector 1 0))))))(else (vector 1 0)))))))))))(else (vector 1 0))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--19357-8589-u--getLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((3) (TTImpC-45InteractiveC-45ExprSearch-n--19357-8589-u--getLHS arg-0 arg-1 arg-2 (cons e-2 arg-3) e-4)) ((4) (TTImpC-45InteractiveC-45ExprSearch-n--19357-8589-u--getLHS arg-0 arg-1 arg-2 (cons e-2 arg-3) e-4))(else (let ((sc1 (CoreC-45TT-getFn arg-4))) (case (vector-ref sc1 0) ((1) (let ((e-5 (vector-ref sc1 3))) (box (vector arg-3 e-5 arg-4))))(else '())))))))))(else (let ((sc0 (CoreC-45TT-getFn arg-4))) (case (vector-ref sc0 0) ((1) (let ((e-3 (vector-ref sc0 3))) (box (vector arg-3 e-3 arg-4))))(else '())))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--14800-4661-u--findPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-17 0) ((3) (let ((e-2 (vector-ref arg-17 2))) (let ((e-5 (vector-ref arg-17 5))) (if (null? e-5) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--14800-4660-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-7) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--14800-4660-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-11 (car e-7))) (let ((e-12 (cdr e-7))) (if (null? e-8) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--14800-4660-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-14 (car e-8))) (let ((e-15 (cdr e-8))) (if (null? e-14) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--14800-4660-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-18 (car e-14))) (let ((e-19 (cdr e-14))) (lambda (clam-0) (if (null? e-15) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-13 arg-12 arg-11 arg-10 arg-8 arg-7 0 arg-6 arg-5 arg-4 (cons (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--14800-4660-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (cons (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-fstName arg-13 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "No fst") eta-1))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1)))) e-6) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-sndName arg-13 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "No snd") eta-1))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1)))) e-9) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-isPairType arg-13 e-2 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (cond ((equal? e-10 1) (let ((act-27 (CoreC-45Context-clearDefs arg-14 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-13 arg-0 e-13 arg-6 e-12 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-16 (vector-ref act-28 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-28 1))) (let ((act-29 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-13 arg-0 e-13 arg-6 e-19 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-17 (vector-ref act-29 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-29 1))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-13 arg-12 arg-11 arg-10 arg-8 arg-7 0 arg-6 arg-5 arg-4 (cons (lambda (eta-1) (let ((act-30 ((CoreC-45NormaliseC-45Eval-evalClosure arg-13 arg-0 arg-14 e-12) eta-1))) (case (vector-ref act-30 0) ((0) (let ((e-20 (vector-ref act-30 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-30 1))) ((TTImpC-45InteractiveC-45ExprSearch-n--14800-4661-u--findPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (lambda (u--arg) (CoreC-45TT-applyWithFC (vector 1 arg-10 (vector 1 ) e-6) (cons (cons e-11 e-16) (cons (cons e-18 e-17) (cons (cons arg-10 (arg-16 u--arg)) '()))))) e-20 arg-18) eta-1)))))) (cons (lambda (eta-1) (let ((act-30 ((CoreC-45NormaliseC-45Eval-evalClosure arg-13 arg-0 arg-14 e-19) eta-1))) (case (vector-ref act-30 0) ((0) (let ((e-20 (vector-ref act-30 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-30 1))) ((TTImpC-45InteractiveC-45ExprSearch-n--14800-4661-u--findPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (lambda (u--arg) (CoreC-45TT-applyWithFC (vector 1 arg-10 (vector 1 ) e-9) (cons (cons e-11 e-16) (cons (cons e-18 e-17) (cons (cons arg-10 (arg-16 u--arg)) '()))))) e-20 arg-18) eta-1)))))) '())) eta-0)))))))))))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)))))))))))))))) '())) clam-0) (TTImpC-45InteractiveC-45ExprSearch-n--14800-4660-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 clam-0))))))))))))))))))(else (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--14800-4660-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--14800-4660-u--findDirect (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (let ((act-24 ((CoreC-45AutoSearch-mkArgs arg-0 arg-13 arg-11 arg-10 arg-8 arg-6 arg-17) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((sc2 (TTImpC-45InteractiveC-45ExprSearch-usableLocal arg-10 arg-6 arg-17))) (cond ((equal? sc2 1) (CoreC-45UnifyState-tryUnify arg-13 arg-11 (lambda (eta-0) (let ((act-25 (let ((sc3 (let ((sc4 (DataC-45List-isNil e-2))) (cond ((equal? sc4 1) 0) (else arg-9))))) (cond ((equal? sc3 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Must apply function") eta-0)) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-13 arg-11 (CoreC-45Unify-inTerm) arg-10) arg-6) arg-18) arg-17) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-0 (vector-ref e-7 0))) (if (null? e-0) ((TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-13 arg-11 arg-10 (arg-16 arg-15) '() '()) eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't use directly") eta-0))))))))))) (lambda (eta-0) (let ((act-25 (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-13 arg-11 (CoreC-45Unify-inTerm) arg-10) arg-6) arg-18) e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-0 (vector-ref e-6 0))) (if (null? e-0) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-searchIfHole arg-0 arg-13 arg-12 arg-11 arg-10 arg-7 arg-4 arg-6 eta-1)) e-2 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) ((TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-13 arg-11 arg-10 (arg-16 arg-15) '() e-8) eta-0))))) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)))))))) ext-0)) (else (TTImpC-45InteractiveC-45ExprSearch-noResult ext-0))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--11131-1392-u--count (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (csegen-2476) (cond ((equal? arg-5 0) (csegen-2476))(else (let ((e-0 (- arg-5 1))) (cond ((equal? e-0 0) (lambda (clam-0) (if (null? arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 (let ((act-24 (e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45ExprSearch-n--11131-1392-u--count arg-1 arg-2 arg-3 arg-4 e-0 e-5) clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (vector 1 (cons (cons e-2 e-6) e-4)))))))))) (let ((e-5 (car arg-6))) (let ((e-6 (cdr arg-6))) (vector 1 (cons (cons e-5 '()) e-6)))))))(else (lambda (clam-1) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 (let ((act-24 (e-3 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45ExprSearch-n--11131-1392-u--count arg-1 arg-2 arg-3 arg-4 e-0 e-5) clam-1))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (vector 1 (cons (cons e-2 e-6) e-4)))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--12351-2482-u--continue (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (set-box! arg-3 arg-5))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (set-box! arg-4 arg-6))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45ExprSearch-firstSuccess arg-4 arg-3 arg-7) ext-0)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) (case (vector-ref arg-13 0) ((0) 0) ((1) (let ((e-48 (vector-ref arg-13 3))) (case (vector-ref arg-14 0) ((1) (let ((e-57 (vector-ref arg-14 3))) (CoreC-45Name-u--C-47C-61_Eq_Name e-48 e-57)))(else (case (vector-ref arg-14 0) ((3) 0)(else (case (vector-ref arg-13 0) ((4) (let ((e-19 (vector-ref arg-13 2))) (let ((e-20 (vector-ref arg-13 3))) (case (vector-ref arg-14 0) ((4) (let ((e-29 (vector-ref arg-14 2))) (let ((e-30 (vector-ref arg-14 3))) (let ((sc3 (TTImpC-45InteractiveC-45ExprSearch-n--13949-3888-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-19 e-29))) (cond ((equal? sc3 1) 1) (else (TTImpC-45InteractiveC-45ExprSearch-n--13949-3888-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-20 e-30)))))))(else (case (vector-ref arg-14 0) ((10) 0)(else (case (vector-ref arg-13 0) ((11) (case (vector-ref arg-14 0) ((11) 0)(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))) ((5) (let ((e-11 (vector-ref arg-13 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11 arg-14)))(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))))))))) ((9) (let ((e-23 (vector-ref arg-13 2))) (case (vector-ref arg-14 0) ((9) (let ((e-33 (vector-ref arg-14 2))) (CoreC-45TT-u--C-47C-61_Eq_Constant e-23 e-33)))(else (case (vector-ref arg-14 0) ((10) 0)(else (case (vector-ref arg-13 0) ((11) (case (vector-ref arg-14 0) ((11) 0)(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))) ((5) (let ((e-11 (vector-ref arg-13 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11 arg-14)))(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1)))))))))) ((10) 0)(else (case (vector-ref arg-14 0) ((10) 0)(else (case (vector-ref arg-13 0) ((11) (case (vector-ref arg-14 0) ((11) 0)(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))) ((5) (let ((e-11 (vector-ref arg-13 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11 arg-14)))(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1)))))))))))))) ((3) 0)(else (case (vector-ref arg-14 0) ((3) 0)(else (case (vector-ref arg-13 0) ((4) (let ((e-19 (vector-ref arg-13 2))) (let ((e-20 (vector-ref arg-13 3))) (case (vector-ref arg-14 0) ((4) (let ((e-29 (vector-ref arg-14 2))) (let ((e-30 (vector-ref arg-14 3))) (let ((sc2 (TTImpC-45InteractiveC-45ExprSearch-n--13949-3888-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-19 e-29))) (cond ((equal? sc2 1) 1) (else (TTImpC-45InteractiveC-45ExprSearch-n--13949-3888-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-20 e-30)))))))(else (case (vector-ref arg-14 0) ((10) 0)(else (case (vector-ref arg-13 0) ((11) (case (vector-ref arg-14 0) ((11) 0)(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))) ((5) (let ((e-11 (vector-ref arg-13 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11 arg-14)))(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))))))))) ((9) (let ((e-23 (vector-ref arg-13 2))) (case (vector-ref arg-14 0) ((9) (let ((e-33 (vector-ref arg-14 2))) (CoreC-45TT-u--C-47C-61_Eq_Constant e-23 e-33)))(else (case (vector-ref arg-14 0) ((10) 0)(else (case (vector-ref arg-13 0) ((11) (case (vector-ref arg-14 0) ((11) 0)(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))) ((5) (let ((e-11 (vector-ref arg-13 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11 arg-14)))(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1)))))))))) ((10) 0)(else (case (vector-ref arg-14 0) ((10) 0)(else (case (vector-ref arg-13 0) ((11) (case (vector-ref arg-14 0) ((11) 0)(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))) ((5) (let ((e-11 (vector-ref arg-13 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11 arg-14)))(else (case (vector-ref arg-14 0) ((5) (let ((e-4 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 e-4)))(else 1))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--13949-3887-u--appsDiff (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-13 0) ((1) (let ((e-4 (vector-ref arg-13 2))) (let ((e-5 (vector-ref arg-13 3))) (case (vector-ref e-4 0) ((2) (case (vector-ref arg-14 0) ((1) (let ((e-30 (vector-ref arg-14 2))) (let ((e-31 (vector-ref arg-14 3))) (case (vector-ref e-30 0) ((2) (let ((sc4 (CoreC-45Name-u--C-47C-61_Eq_Name e-5 e-31))) (cond ((equal? sc4 1) 1) (else (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-15 arg-16))))))(else (case (vector-ref arg-14 0) ((1) (let ((e-23 (vector-ref arg-14 3))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc4 1) (let ((sc5 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-15) (PreludeC-45TypesC-45List-length arg-16)))) (cond ((equal? sc5 1) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-15 arg-16))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-14 0) ((0) 1)(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))))))))(else (case (vector-ref arg-14 0) ((1) (let ((e-23 (vector-ref arg-14 3))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-15) (PreludeC-45TypesC-45List-length arg-16)))) (cond ((equal? sc4 1) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-15 arg-16))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-14 0) ((0) 1)(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0)))))))) ((3) (case (vector-ref arg-14 0) ((1) (let ((e-36 (vector-ref arg-14 2))) (let ((e-37 (vector-ref arg-14 3))) (case (vector-ref e-36 0) ((3) (let ((sc4 (CoreC-45Name-u--C-47C-61_Eq_Name e-5 e-37))) (cond ((equal? sc4 1) 1) (else (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-15 arg-16))))))(else (case (vector-ref arg-14 0) ((1) (let ((e-23 (vector-ref arg-14 3))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc4 1) (let ((sc5 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-15) (PreludeC-45TypesC-45List-length arg-16)))) (cond ((equal? sc5 1) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-15 arg-16))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-14 0) ((0) 1)(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))))))))(else (case (vector-ref arg-14 0) ((1) (let ((e-23 (vector-ref arg-14 3))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-15) (PreludeC-45TypesC-45List-length arg-16)))) (cond ((equal? sc4 1) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-15 arg-16))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-14 0) ((0) 1)(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))))))(else (case (vector-ref arg-14 0) ((1) (let ((e-23 (vector-ref arg-14 3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-15) (PreludeC-45TypesC-45List-length arg-16)))) (cond ((equal? sc3 1) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-15 arg-16))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-14 0) ((0) 1)(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0)))))))))) ((0) (case (vector-ref arg-14 0) ((1) (let ((e-42 (vector-ref arg-14 2))) (case (vector-ref e-42 0) ((2) 1)(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0)))))(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0))))(else (if (null? arg-15) (if (null? arg-16) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3886-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-14) 0) 0)))))
(define TTImpC-45InteractiveC-45ExprSearch-n--16541-6184-u--applyLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-15 0) ((0) (let ((e-3 (vector-ref arg-15 3))) (let ((e-4 (vector-ref arg-15 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((act-24 (let ((act-24 (((e-4 arg-13) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-6 (vector 10 arg-9 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45ExprSearch-n--16541-6183-u--matchable arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-5) clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (CoreC-45UnifyState-genVarName arg-12 arg-10 "cty" clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-12 arg-10 e-6 (csegen-21) arg-6 e-10 (vector 11 arg-9) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((u--optsC-39 (let ((e-0 (vector-ref arg-7 0))) (let ((e-20 (vector-ref arg-7 1))) (let ((e-19 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (let ((e-17 (vector-ref arg-7 4))) (let ((e-15 (vector-ref arg-7 6))) (let ((e-14 (vector-ref arg-7 7))) (let ((e-13 (vector-ref arg-7 8))) (let ((e-12 (vector-ref arg-7 9))) (vector e-0 e-20 e-19 e-18 e-17 1 e-15 e-14 e-13 e-12)))))))))))) (let ((act-27 ((TTImpC-45InteractiveC-45ExprSearch-searchLocalWith arg-0 arg-12 arg-11 arg-10 arg-9 1 arg-8 u--optsC-39 arg-6 (cons (cons arg-1 arg-2) '()) e-11 arg-4) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) ((TTImpC-45InteractiveC-45ExprSearch-makeHelper arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 e-11 arg-16 e-12) clam-0))))))))))))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0)))))))))(else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0)))))))(else (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0))))))
(define TTImpC-45InteractiveC-45ExprSearch-u--map_Functor_Search (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cons (arg-2 e-2) (lambda (eta-0) (let ((act-24 (e-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (TTImpC-45InteractiveC-45ExprSearch-u--map_Functor_Search arg-2 e-5)))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-usableLocal (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((2) 0)(else 1))))(else 1))))
(define TTImpC-45InteractiveC-45ExprSearch-trySearch (lambda (arg-1 arg-2 arg-3 arg-4) (TTImpC-45InteractiveC-45ExprSearch-firstSuccess arg-1 arg-2 (cons arg-3 (cons arg-4 '())))))
(define TTImpC-45InteractiveC-45ExprSearch-tryRecursive (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (let ((e-1 (vector-ref arg-10 1))) e-1) (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (TTImpC-45InteractiveC-45ExprSearch-noResult ext-0) (let ((e-2 (unbox e-6))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-7 arg-8) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (TTImpC-45InteractiveC-45ExprSearch-searchName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-12 (vector-ref arg-6 5))) (let ((e-11 (vector-ref arg-6 6))) (let ((e-10 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (vector e-0 e-1 '() e-3 e-4 e-12 e-11 e-10 e-8 e-9)))))))))) arg-7 e-7 arg-9 (cons (let ((e-1 (vector-ref arg-10 1))) e-1) e-2) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 (TTImpC-45InteractiveC-45ExprSearch-traverse (lambda (lamc-0) (lambda (clam-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-28 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-4 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons e-9 e-3)))))))))) e-7 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (TTImpC-45InteractiveC-45ExprSearch-filterS (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--13949-3889-u--structDiffTm arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-3 (vector-ref arg-10 2))) e-3) eta-0)) e-9 ext-0))))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-tryIntermediateWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (if (null? arg-8) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-7 e-7) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 arg-7 arg-9 arg-10 (cons (TTImpC-45InteractiveC-45ExprSearch-n--16541-6184-u--applyLocal arg-0 e-6 e-7 e-3 arg-10 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 e-8 arg-9) (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 arg-9 arg-10) '())) clam-0)))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (if (null? arg-10) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (unbox arg-10))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact (let ((e-1 (vector-ref e-2 1))) e-1) (let ((e-0 (vector-ref e-5 0))) e-0) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-1 (unbox e-6))) (let ((act-26 (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 '() e-5 '() e-1) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) ((TTImpC-45InteractiveC-45ExprSearch-n--16980-6558-u--isSingleCon arg-0 e-2 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-7) clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) (let ((act-27 (CoreC-45UnifyState-genVarName arg-1 arg-3 "cty" clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-4 (csegen-21) arg-7 e-8 (vector 11 arg-4) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--optsC-39 (let ((e-0 (vector-ref arg-6 0))) (let ((e-16 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-13 (vector-ref arg-6 6))) (let ((e-12 (vector-ref arg-6 7))) (let ((e-11 (vector-ref arg-6 8))) (let ((e-10 (vector-ref arg-6 9))) (vector e-0 e-16 '() e-3 e-4 1 e-13 e-12 e-11 e-10))))))))))) (let ((act-29 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Trying recursive search for") arg-8 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (let ((act-30 (CoreC-45Context-toFullNames arg-1 (csegen-46) (let ((e-4 (vector-ref e-2 1))) e-4) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-30 1))) (CoreC-45ContextC-45Log-log arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (CoreC-45Name-u--show_Show_Name e-11)) clam-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 (let ((act-31 (CoreC-45Context-toFullNames arg-1 (csegen-76) (let ((e-3 (vector-ref e-2 2))) e-3) clam-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-31 1))) (CoreC-45ContextC-45Log-logTerm (let ((e-0 (vector-ref e-2 0))) e-0) arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "LHS") e-12 clam-0))))))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((act-32 (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--optsC-39 arg-7 e-9 arg-9 e-2 clam-0))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-32 1))) ((TTImpC-45InteractiveC-45ExprSearch-makeHelper arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--optsC-39 arg-7 e-9 arg-8 e-13) clam-0))))))))))))))))))))))))(else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-tryIntermediate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45TypesC-45List-reverse (TTImpC-45InteractiveC-45ExprSearch-getAllEnv arg-0 arg-4 (CoreC-45TTC-45SizeOf-zero) arg-7)) arg-8 arg-9)))
(define TTImpC-45InteractiveC-45ExprSearch-traverse (lambda (arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((arg-2 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-5 (lambda (eta-0) (let ((act-25 (e-3 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (TTImpC-45InteractiveC-45ExprSearch-traverse arg-2 e-6 eta-0)))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (cond ((equal? arg-9 0) (case (vector-ref arg-10 0) ((3) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((e-14 (vector-ref arg-10 3))) (let ((e-15 (vector-ref arg-10 4))) (case (vector-ref e-14 0) ((2) (let ((e-17 (vector-ref e-14 1))) (let ((e-18 (vector-ref e-14 2))) (let ((e-19 (vector-ref e-14 3))) (let ((e-20 (vector-ref e-14 4))) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 arg-7 e-20 arg-8 (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 3 e-12 e-13 e-14 e-15) arg-8) (cons (lambda (eta-1) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-7 e-20) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45InteractiveC-45CaseSplit-getArgName arg-0 arg-1 e-5 e-13 '() arg-0 e-6 eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--nC-39 (vector 1 (vector 0 e-7)))) (let ((u--envC-39 (cons e-14 arg-7))) (let ((u--scC-39 (CoreC-45TT-renameTop u--nC-39 e-15))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Introduced lambda, search for " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (cons u--nC-39 arg-0) u--scC-39))) eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((TTImpC-45InteractiveC-45ExprSearch-searchType (cons u--nC-39 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--envC-39 arg-8 0 u--scC-39) eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (TTImpC-45InteractiveC-45ExprSearch-u--map_Functor_Search (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (vector 3 e-12 u--nC-39 (vector 0 e-17 e-18 e-19 e-20) e-2) e-3)))) e-9))))))))))))))))))))))))) '())) eta-0)))))))(else (TTImpC-45InteractiveC-45ExprSearch-case--searchType-7281 arg-0 arg-9 arg-10 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-10)))))))))(else (TTImpC-45InteractiveC-45ExprSearch-case--searchType-7281 arg-0 arg-9 arg-10 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-10)))))(else (let ((e-0 (- arg-9 1))) (case (vector-ref arg-10 0) ((3) (let ((e-2 (vector-ref arg-10 1))) (let ((e-3 (vector-ref arg-10 2))) (let ((e-4 (vector-ref arg-10 3))) (let ((e-5 (vector-ref arg-10 4))) (case (vector-ref e-4 0) ((2) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-9 (vector-ref e-4 3))) (let ((e-10 (vector-ref e-4 4))) (let ((u--envC-39 (cons e-4 arg-7))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Introduced lambda, search for " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-3 arg-0) e-5))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 ((TTImpC-45InteractiveC-45ExprSearch-searchType (cons e-3 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--envC-39 arg-8 e-0 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) (vector 1 (TTImpC-45InteractiveC-45ExprSearch-u--map_Functor_Search (lambda (lamc-0) (let ((e-13 (car lamc-0))) (let ((e-12 (cdr lamc-0))) (cons (vector 3 e-2 e-3 (vector 0 e-7 e-8 e-9 e-10) e-13) e-12)))) e-11))))))))))))))))(else (TTImpC-45InteractiveC-45ExprSearch-case--searchType-7281 arg-0 arg-9 arg-10 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-10)))))))))(else (TTImpC-45InteractiveC-45ExprSearch-case--searchType-7281 arg-0 arg-9 arg-10 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TT-getFnArgs arg-10)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchSort (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (TTImpC-45InteractiveC-45ExprSearch-searchN arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((sc2 (DataC-45List-isNil e-2))) (cond ((equal? sc2 1) (vector 1 '())) (else ((TTImpC-45InteractiveC-45ExprSearch-n--11290-1539-u--returnBatch arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45List-sortBy arg-5 e-2) e-3) ext-0))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (if (null? arg-10) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-checkTimer arg-1 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-n--13642-3620-u--visible arg-0 e-2 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref e-5 0))) e-0) (cons (let ((e-34 (vector-ref e-5 2))) e-34) (let ((e-33 (vector-ref e-5 3))) e-33)) eta-0 eta-1))) (cons e-2 e-3) '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--visns (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-7))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-7 arg-8) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Searching " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--visns)) " for "))) arg-8 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 arg-7 arg-8 arg-9 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-searchName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-8 arg-9 eta-0 eta-1))) u--visns) clam-0))))))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-checkTimer arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CoreC-45Context-getNS arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-getNestedNS arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((sc5 (CoreC-45Context-visibleInAny (cons e-7 e-8) (let ((e-1 (vector-ref e-3 1))) e-1) (let ((e-9 (vector-ref e-3 9))) e-9)))) (cond ((equal? sc5 1) (let ((u--ty (let ((e-27 (vector-ref e-3 2))) e-27))) (let ((sc6 (TTImpC-45InteractiveC-45ExprSearch-n--12720-2829-u--usableName arg-0 e-2 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-1 (vector-ref e-3 1))) e-1)))) (cond ((equal? sc6 1) (let ((u--namety (let ((e-17 (vector-ref e-3 17))) (case (vector-ref e-17 0) ((5) (let ((e-30 (vector-ref e-17 1))) (let ((e-29 (vector-ref e-17 2))) (vector 2 e-30 e-29)))) ((6) (let ((e-35 (vector-ref e-17 1))) (let ((e-34 (vector-ref e-17 2))) (vector 3 e-35 e-34))))(else (vector 1 )))))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Trying " (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref e-3 1))) e-1)))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-7 (CoreC-45TT-embed u--ty)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45AutoSearch-mkArgs arg-0 arg-1 arg-3 arg-4 arg-5 arg-7 e-10) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (let ((e-12 (car e-11))) (let ((e-4 (cdr e-11))) (let ((act-31 (CoreC-45Normalise-logNF arg-0 arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Target") arg-7 arg-8 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-13 (vector-ref act-31 1))) (vector 0 e-13))) (else (let ((act-32 (CoreC-45Normalise-logNF arg-0 arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "App type") arg-7 e-4 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-14 (vector-ref act-32 1))) (vector 0 e-14))) (else (let ((act-33 (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-3 (CoreC-45Unify-inSearch) arg-4) arg-7) arg-8) e-4) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-15 (vector-ref act-33 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-33 1))) (let ((e-0 (vector-ref e-15 0))) (if (null? e-0) (let ((act-34 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-searchIfHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-9 arg-7 eta-0)) (DataC-45List-filter (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-explicit eta-0)) e-12) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-18 (vector-ref act-34 1))) (vector 0 e-18))) (else (let ((act-35 (CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-searchIfHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-9 arg-7 eta-0)) e-12 '() ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-19 (vector-ref act-35 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-35 1))) ((TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-1 arg-3 arg-4 (vector 1 arg-4 u--namety e-2) '() e-19) ext-0)))))))) (TTImpC-45InteractiveC-45ExprSearch-noResult ext-0))))))))))))))))))))))))))))(else (TTImpC-45InteractiveC-45ExprSearch-noResult ext-0))))))(else (TTImpC-45InteractiveC-45ExprSearch-noResult ext-0)))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchN (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-startTimer arg-1 (let ((e-6 (vector-ref e-5 6))) e-6) "expression search" ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45UnifyState-tryUnify arg-1 arg-2 (lambda (eta-0) (let ((act-25 (arg-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45InteractiveC-45ExprSearch-n--11131-1392-u--count arg-4 arg-3 arg-2 arg-1 arg-3 e-6) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-clearTimer arg-1 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-7))))))))))))) (lambda (eta-0) (let ((act-25 (CoreC-45Context-clearTimer arg-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (csegen-2477))))) ext-0))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchLocalWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (lambda (clam-0) (if (null? arg-9) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-checkTimer arg-1 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-8 arg-10) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-8 e-7) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 0 arg-8 arg-10 arg-11 (cons (TTImpC-45InteractiveC-45ExprSearch-n--14800-4661-u--findPos arg-0 e-6 e-7 e-3 arg-11 arg-10 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 (lambda (eta-0) eta-0) e-10 e-9) (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocalWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 arg-10 arg-11) '())) clam-0))))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (TTImpC-45InteractiveC-45ExprSearch-searchLocalWith arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-5 arg-6 arg-7 (PreludeC-45TypesC-45List-reverse (TTImpC-45InteractiveC-45ExprSearch-getAllEnv arg-0 arg-4 (CoreC-45TTC-45SizeOf-zero) arg-7)) arg-8 arg-9)))
(define TTImpC-45InteractiveC-45ExprSearch-searchIfHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((sc0 (let ((e-3 (vector-ref arg-5 3))) e-3))) (cond ((equal? sc0 0) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)))(else (let ((e-0 (- (let ((e-3 (vector-ref arg-5 3))) e-3) 1))) (let ((u--hole (let ((e-1 (vector-ref arg-8 0))) e-1))) (let ((u--rig (let ((e-2 (vector-ref arg-8 1))) e-2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 u--hole) (let ((e-32 (vector-ref e-5 0))) e-32)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (TTImpC-45InteractiveC-45ExprSearch-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32searchIfHole-2214 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-0 u--hole u--rig e-5 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17) eta-0)))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-24 (CoreC-45Normalise-normalise arg-0 '() arg-9 '() (let ((e-2 (vector-ref arg-10 2))) e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm '() arg-0 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Normalised type") e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-checkTimer arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45ExprSearch-searchType '() arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-8 arg-7 e-5) ext-0)))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-search (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45InteractiveC-45ExprSearch-n--11704-8206-u--lookupHoleName arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-7 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-7) " not found")) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Context-undefinedName arg-0 arg-3 arg-7 ext-0)))) (let ((e-1 (unbox e-6))) (if (null? e-1) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-7) " not found")) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Context-undefinedName arg-0 arg-3 arg-7 ext-0)))) (let ((e-4 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-7) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-7) " not found")) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Context-undefinedName arg-0 arg-3 arg-7 ext-0)))) (let ((e-9 (cdr e-7))) (let ((e-17 (vector-ref e-9 17))) (case (vector-ref e-17 0) ((7) (let ((e-30 (vector-ref e-17 1))) (TTImpC-45InteractiveC-45ExprSearch-searchHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 e-30 arg-6 e-5 e-9 ext-0))) ((8) (let ((act-26 (CoreC-45Normalise-getArity arg-0 '() e-5 '() (let ((e-51 (vector-ref e-9 2))) e-51) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-32 (vector-ref act-26 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-26 1))) (TTImpC-45InteractiveC-45ExprSearch-searchHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 e-32 arg-6 e-5 e-9 ext-0))))))(else (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-7) " not a hole")) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-29 (vector-ref act-26 1))) (vector 0 e-29))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Not a hole: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-4) (PreludeC-45TypesC-45String-C-43C-43 " in " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-737) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-31 (vector-ref eta-0 1))) e-31)) (let ((e-37 (vector-ref arg-5 2))) e-37))))))) ext-0))))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-one (lambda (arg-1 ext-0) (vector 1 (cons arg-1 (lambda (eta-0) (vector 1 '()))))))
(define TTImpC-45InteractiveC-45ExprSearch-noResult (lambda (ext-0) (vector 1 '())))
(define TTImpC-45InteractiveC-45ExprSearch-nextResult (lambda (arg-1 arg-2 arg-3 ext-0) (CoreC-45UnifyState-tryUnify arg-1 arg-2 (lambda (eta-0) (let ((act-24 (arg-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (box (cons e-2 e-3))))))))))) (lambda (eta-0) (vector 1 '())) ext-0)))
(define TTImpC-45InteractiveC-45ExprSearch-mkCandidates (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-one (cons arg-4 arg-5) eta-0)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-2) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-6))) (let ((e-11 (cdr e-6))) (TTImpC-45InteractiveC-45ExprSearch-firstSuccess arg-1 arg-2 (cons (TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-1 arg-2 arg-3 (vector 4 arg-3 arg-4 e-10) (PreludeC-45TypesC-45List-tailRecAppend arg-5 e-11) e-3) (cons (lambda (eta-0) (let ((act-24 (e-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons e-5 e-3)) eta-0)))))) '())))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-makeHelper (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (let ((e-12 (vector-ref arg-6 3))) e-12))) (cond ((equal? sc2 0) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)))(else (let ((e-0 (- (let ((e-12 (vector-ref arg-6 3))) e-12) 1))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Local app") e-6 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref arg-6 9))) (if (null? e-9) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0) (let ((e-16 (unbox e-9))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-17 (vector-ref act-25 1))) (vector 0 e-17))) (else (let ((act-26 (CoreC-45UnifyState-genVarName arg-1 arg-3 "cval" eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-18 (vector-ref act-26 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-26 1))) (let ((act-27 (CoreC-45UnifyState-genCaseName arg-1 arg-3 "search" eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-19 (vector-ref act-27 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-inCurrentNS arg-1 e-19 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-20 (vector-ref act-28 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-28 1))) (let ((u--envC-39 (cons (vector 0 arg-4 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) arg-8) arg-7))) (let ((act-29 (TTImpC-45ElabC-45Check-metaVar (cons e-18 arg-0) arg-1 arg-3 arg-4 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) u--envC-39 e-20 (CoreC-45TT-u--weaken_Weaken_Term arg-9) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-21 (vector-ref act-29 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-29 1))) (let ((u--scope (TTImpC-45InteractiveC-45ExprSearch-n--15768-5519-u--toApp arg-0 e-6 e-7 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-21))) (let ((act-30 (CoreC-45Context-updateDef arg-1 e-20 (lambda (eta-1) (box (vector 0 ))) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-22 (vector-ref act-30 1))) (vector 0 e-22))) (else (let ((u--def (vector 4 arg-4 (vector 3 arg-4 e-18 (vector 0 arg-4 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) arg-8) u--scope) e-6))) (let ((act-31 (CoreC-45Normalise-logTermNF arg-0 arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Binding def") arg-7 u--def eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-23 (vector-ref act-31 1))) (vector 0 e-23))) (else (let ((act-32 (let ((act-32 (unbox arg-1))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-24 (vector-ref act-32 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Context-lookupTyExact e-20 (let ((e-55 (vector-ref e-24 0))) e-55) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-25 (vector-ref act-33 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-33 1))) (if (null? e-25) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't happen") eta-0) (let ((e-26 (unbox e-25))) (let ((act-34 (CoreC-45Normalise-logTermNF '() arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Type of scope name") '() e-26 eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-27 (vector-ref act-34 1))) (vector 0 e-27))) (else (let ((act-35 (TTImpC-45InteractiveC-45ExprSearch-searchN arg-1 arg-3 (+ 1 0) ((((e-16 (let ((e-37 (vector-ref arg-6 0))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 4))) (let ((e-29 (vector-ref arg-6 8))) (let ((e-28 (vector-ref arg-6 9))) (vector e-37 0 e-35 e-0 e-33 1 0 1 e-29 e-28))))))) e-20) 0) e-26) eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-28 (vector-ref act-35 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-35 1))) (if (null? e-28) (let ((act-36 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "No results") eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-29 (vector-ref act-36 1))) (vector 0 e-29))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)))) (let ((e-30 (car e-28))) (if (null? e-30) (let ((act-36 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "No results") eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-31 (vector-ref act-36 1))) (vector 0 e-31))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)))) (let ((e-32 (car e-30))) (let ((u--helperdef (vector 2 arg-4 e-20 (Builtin-snd e-32)))) (let ((act-36 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Def: " (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 (csegen-737) u--helperdef))) eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-33 (vector-ref act-36 1))) (vector 0 e-33))) (else (vector 1 (cons (cons u--def (cons u--helperdef e-7)) (lambda (eta-1) (let ((act-37 (e-3 eta-1))) (case (vector-ref act-37 0) ((0) (let ((e-34 (vector-ref act-37 1))) (vector 0 e-34))) (else (let ((e-34 (vector-ref act-37 1))) ((TTImpC-45InteractiveC-45ExprSearch-makeHelper arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-34) eta-1)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-initSearchOpts (lambda (arg-0 arg-1) (vector 0 arg-0 '() arg-1 0 0 1 0 0 '())))
(define TTImpC-45InteractiveC-45ExprSearch-getSuccessful (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-24 ((TTImpC-45InteractiveC-45ExprSearch-firstSuccess arg-1 arg-3 arg-11) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((sc2 (cond ((equal? arg-7 1) (let ((e-0 (vector-ref arg-6 0))) e-0)) (else 0)))) (cond ((equal? sc2 1) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--base (PreludeC-45Types-maybe (lambda () "arg") (lambda () (lambda (u--r) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-nameRoot (let ((e-1 (vector-ref u--r 1))) e-1)) "_rhs"))) (let ((e-2 (vector-ref arg-6 2))) e-2)))) (let ((act-26 (TTImpC-45Utils-uniqueName e-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-nameRoot eta-0)) arg-0) u--base ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-3 arg-4 arg-5 arg-8 (vector 1 (vector 0 e-7)) arg-9 (vector 7 (CoreC-45Env-length arg-8) (CoreC-45ContextC-45Context-holeInit 0)) 0) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-3 (cdr e-8))) (TTImpC-45InteractiveC-45ExprSearch-one (cons e-3 '()) ext-0)))))))))))))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult ext-0)))) (vector 1 e-5))))))))
(define TTImpC-45InteractiveC-45ExprSearch-getLHSData (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (unbox arg-2))) (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-0 '() arg-1 '() e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (TTImpC-45InteractiveC-45ExprSearch-n--19357-8589-u--getLHS e-2 arg-1 arg-0 '() e-6))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-getAllEnv (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-4))) (let ((e-9 (cdr arg-4))) (let ((u--rest (TTImpC-45InteractiveC-45ExprSearch-getAllEnv e-3 arg-2 (CoreC-45TTC-45SizeOf-sucR arg-3) e-9))) (let ((u--usable (TTImpC-45InteractiveC-45ExprSearch-n--11712-1945-u--usableName e-2 e-3 e-9 e-8 arg-3 arg-2 e-2))) (cond ((equal? u--usable 1) (cons (cons (vector 0 arg-2 '() (CoreC-45TT-weakenVar arg-3 0)) (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-sucR arg-3) (CoreC-45TT-binderType e-8))) u--rest)) (else u--rest)))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-firstSuccess (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-26 (e-2 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (TTImpC-45InteractiveC-45ExprSearch-n--12351-2482-u--continue e-2 e-3 arg-2 arg-1 e-5 e-6 e-3 eta-0) (let ((e-1 (car e-7))) (let ((e-4 (cdr e-7))) (vector 1 (cons e-1 (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-n--12351-2482-u--continue e-2 e-3 arg-2 arg-1 e-5 e-6 (cons e-4 e-3) eta-1)))))))))))) (lambda (u--err) (lambda (clam-1) (case (vector-ref u--err 0) ((61) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-1))(else (TTImpC-45InteractiveC-45ExprSearch-n--12351-2482-u--continue e-2 e-3 arg-2 arg-1 e-5 e-6 e-3 clam-1))))) clam-0)))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-firstLinearOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45UnifyState-handleUnify arg-0 arg-2 (lambda (eta-0) (let ((act-24 (let ((sc2 (DataC-45List-isNil e-7))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45Core-traverse_ (lambda (eta-1) (TTImpC-45ElabC-45Check-processDecl '() arg-0 arg-1 arg-2 arg-3 (cons 1 '()) '() '() eta-1)) e-7 eta-0)))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45LinearCheck-linearCheck '() arg-0 arg-2 arg-4 (csegen-519) 0 '() e-6 eta-1)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Normalise-normaliseHoles arg-0 '() e-9 '() e-6 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-10 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-28 1))) ((TTImpC-45Unelab-unelab '() arg-0 '() e-11) eta-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-28 1))) (let ((act-29 (e-3 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-29 1))) (vector 1 (cons (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-11) (TTImpC-45InteractiveC-45ExprSearch-firstLinearOK arg-0 arg-1 arg-2 arg-3 arg-4 e-12)))))))))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-24 (e-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45ExprSearch-firstLinearOK arg-0 arg-1 arg-2 arg-3 arg-4 e-5) eta-0))))))) clam-0)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-filterS (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-24 (e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fnext (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-filterS arg-1 e-5 eta-0)))) (let ((sc2 (arg-1 e-2))) (cond ((equal? sc2 1) (vector 1 (cons e-2 u--fnext))) (else (u--fnext ext-0))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-exprSearchOpts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45InteractiveC-45ExprSearch-n--19606-8825-u--lookupHoleName arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-6 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-5 arg-6 ext-0) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (let ((e-17 (vector-ref e-10 17))) (case (vector-ref e-17 0) ((7) (let ((act-26 (let ((act-26 (CoreC-45Context-getFullName arg-0 (vector 8 e-9) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-31 (vector-ref act-26 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-26 1))) (CoreC-45Metadata-findHoleLHS arg-1 e-31 ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-31 (vector-ref act-26 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "LHS hole data " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1276) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (csegen-1276) u--d u--x))))) (cons e-8 e-31)))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-32 (vector-ref act-27 1))) (vector 0 e-32))) (else (let ((act-28 (let ((sc8 (let ((e-41 (vector-ref arg-4 1))) e-41))) (cond ((equal? sc8 1) (let ((act-28 (TTImpC-45InteractiveC-45ExprSearch-getLHSData arg-0 e-5 e-31 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-33 (vector-ref act-28 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-28 1))) (vector 1 (let ((e-43 (vector-ref arg-4 0))) (let ((e-42 (vector-ref arg-4 1))) (let ((e-40 (vector-ref arg-4 3))) (let ((e-39 (vector-ref arg-4 4))) (let ((e-38 (vector-ref arg-4 5))) (let ((e-37 (vector-ref arg-4 6))) (let ((e-36 (vector-ref arg-4 7))) (let ((e-35 (vector-ref arg-4 8))) (let ((e-34 (vector-ref arg-4 9))) (vector e-43 e-42 e-33 e-40 e-39 e-38 e-37 e-36 e-35 e-34)))))))))))))))) (else (vector 1 arg-4)))))) (case (vector-ref act-28 0) ((0) (let ((e-33 (vector-ref act-28 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45InteractiveC-45ExprSearch-search arg-0 arg-1 arg-2 arg-5 (let ((e-48 (vector-ref e-10 7))) e-48) e-33 (let ((e-53 (vector-ref e-10 2))) e-53) e-8 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-34 (vector-ref act-29 1))) (vector 0 e-34))) (else (let ((e-34 (vector-ref act-29 1))) ((TTImpC-45InteractiveC-45ExprSearch-firstLinearOK arg-0 arg-1 arg-2 arg-3 arg-5 e-34) ext-0))))))))))))))))) ((1) (let ((e-32 (vector-ref e-17 2))) (let ((e-31 (vector-ref e-17 3))) (if (null? e-32) (case (vector-ref e-31 0) ((1) (let ((e-34 (vector-ref e-31 2))) (let ((act-26 (let ((act-26 (CoreC-45Normalise-normaliseHoles arg-0 '() e-5 '() e-34 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-36 (vector-ref act-26 1))) (vector 0 e-36))) (else (let ((e-36 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-0 (csegen-76) e-36 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-37 (vector-ref act-27 1))) (vector 0 e-37))) (else (let ((e-37 (vector-ref act-27 1))) ((TTImpC-45Unelab-unelab '() arg-0 '() e-37) ext-0))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-36 (vector-ref act-26 1))) (vector 0 e-36))) (else (let ((e-36 (vector-ref act-26 1))) (TTImpC-45InteractiveC-45ExprSearch-one (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (csegen-1949) e-36) ext-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-5 "Name is already defined") ext-0))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-5 "Name is already defined") ext-0)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-5 "Name is already defined") ext-0))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-exprSearchN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (TTImpC-45InteractiveC-45ExprSearch-searchN arg-0 arg-2 arg-5 (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-exprSearch arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (vector 1 e-2))))))))
(define TTImpC-45InteractiveC-45ExprSearch-exprSearchC-39 (lambda (arg-0 arg-1 arg-2 arg-3 ext-3 ext-1 ext-2 ext-0) (TTImpC-45InteractiveC-45ExprSearch-exprSearchOpts arg-0 arg-1 arg-2 arg-3 (csegen-2471) ext-3 ext-1 ext-2 ext-0)))
(define TTImpC-45InteractiveC-45ExprSearch-exprSearch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-startTimer arg-0 (let ((e-6 (vector-ref e-5 6))) e-6) "expression search" ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (TTImpC-45InteractiveC-45ExprSearch-exprSearchC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-clearTimer arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 e-6)))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-explicit (lambda (arg-1) (let ((e-3 (vector-ref arg-1 2))) (case (vector-ref e-3 0) ((1) 1)(else 0)))))
(define TTImpC-45InteractiveC-45ExprSearch-combine (lambda (arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-6) (vector 1 '()) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? arg-7) (vector 1 '()) (let ((e-6 (car arg-7))) (let ((e-7 (cdr arg-7))) (vector 1 (cons ((arg-5 e-2) e-6) (TTImpC-45InteractiveC-45ExprSearch-trySearch arg-3 arg-4 (lambda (eta-0) (let ((act-24 (e-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45InteractiveC-45ExprSearch-one e-2 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) ((TTImpC-45InteractiveC-45ExprSearch-combine arg-3 arg-4 arg-5 e-8 e-5) eta-0)))))))))) (TTImpC-45InteractiveC-45ExprSearch-trySearch arg-3 arg-4 (lambda (eta-0) (let ((act-24 (e-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45InteractiveC-45ExprSearch-one e-6 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) ((TTImpC-45InteractiveC-45ExprSearch-combine arg-3 arg-4 arg-5 e-5 e-8) eta-0)))))))))) (lambda (eta-0) (let ((act-24 (e-3 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (e-7 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) ((TTImpC-45InteractiveC-45ExprSearch-combine arg-3 arg-4 arg-5 e-5 e-8) eta-0)))))))))))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-case--newLHS-9692 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((u--keep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 0 arg-5 (vector 32 arg-5 1))) (DataC-45List-take arg-4 e-3)))) (let ((u--ups (DataC-45List-drop arg-4 e-3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45CaseSplit-update arg-6 arg-3 arg-2 arg-1 eta-1 eta-2))) u--ups '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (TTImpC-45TTImpC-45Arg-apply e-2 (PreludeC-45TypesC-45List-tailRecAppend u--keep e-5))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-n--11022-8960-u--notBound (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 (PreludeC-45Types-elem (csegen-802) (vector 1 (vector 0 arg-7)) arg-3))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45InteractiveC-45CaseSplit-n--10917-8866-u--mkVarN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 0) arg-5)(else (PreludeC-45TypesC-45String-C-43C-43 arg-5 (PreludeC-45Show-u--show_Show_Int arg-6))))))
(define TTImpC-45InteractiveC-45CaseSplit-n--11022-8959-u--lookupName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (vector 1 '()) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 (CoreC-45Context-getFullName arg-6 arg-8 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getFullName arg-6 e-6 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-8))) (cond ((equal? sc4 1) (vector 1 (box e-7))) (else ((TTImpC-45InteractiveC-45CaseSplit-n--11022-8959-u--lookupName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 e-3) clam-0))))))))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-n--11022-8962-u--getName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-7 0) ((1) (let ((e-0 (vector-ref arg-7 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (TTImpC-45InteractiveC-45CaseSplit-unique (cons e-1 arg-8) (cons e-1 arg-8) 0 arg-9)))(else (TTImpC-45InteractiveC-45CaseSplit-unique arg-8 arg-8 0 arg-9)))))(else (TTImpC-45InteractiveC-45CaseSplit-unique arg-8 arg-8 0 arg-9)))))
(define TTImpC-45InteractiveC-45CaseSplit-n--11022-8961-u--findNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-7 0) ((0) (let ((e-3 (vector-ref arg-7 3))) (case (vector-ref e-3 0) ((2) (vector 1 (DataC-45List-filter (lambda (eta-0) (TTImpC-45InteractiveC-45CaseSplit-n--11022-8960-u--notBound arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0)) (cons "f" (cons "g" '())))))(else (vector 1 (DataC-45List-filter (lambda (eta-0) (TTImpC-45InteractiveC-45CaseSplit-n--11022-8960-u--notBound arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0)) (TTImpC-45InteractiveC-45CaseSplit-defaultNames))))))) ((3) (let ((e-7 (vector-ref arg-7 2))) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-n--11022-8959-u--lookupName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7 (LibrariesC-45DataC-45NameMap-toList (let ((e-15 (vector-ref arg-5 15))) e-15))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (DataC-45List-filter (lambda (eta-0) (TTImpC-45InteractiveC-45CaseSplit-n--11022-8960-u--notBound arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0)) (TTImpC-45InteractiveC-45CaseSplit-defaultNames))) (let ((e-2 (unbox e-5))) (vector 1 (DataC-45List-filter (lambda (eta-0) (TTImpC-45InteractiveC-45CaseSplit-n--11022-8960-u--notBound arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0)) e-2))))))))))(else (vector 1 (DataC-45List-filter (lambda (eta-0) (TTImpC-45InteractiveC-45CaseSplit-n--11022-8960-u--notBound arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0)) (TTImpC-45InteractiveC-45CaseSplit-defaultNames))))))))
(define TTImpC-45InteractiveC-45CaseSplit-u--show_Show_SplitError (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "No valid case splits") ((1) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "Can't split on " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-0) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 e-1 ")"))))))) (else "No clause to split here"))))
(define TTImpC-45InteractiveC-45CaseSplit-u--show_Show_ClauseUpdate (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "Valid: " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-0) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "Updates: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2233) e-1)))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Impossible: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-2)))) (else "Invalid"))))
(define TTImpC-45InteractiveC-45CaseSplit-u--showPrec_Show_ClauseUpdate (lambda (arg-0 arg-1) (TTImpC-45InteractiveC-45CaseSplit-u--show_Show_ClauseUpdate arg-1)))
(define TTImpC-45InteractiveC-45CaseSplit-updateArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (PreludeC-45Types-elem (csegen-802) e-2 arg-1))) (cond ((equal? sc1 1) (lambda (clam-0) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-2 arg-2))) (cond ((equal? sc2 1) (TTImpC-45InteractiveC-45CaseSplit-expandCon arg-0 e-1 (DataC-45List-filter (lambda (arg-5) (CoreC-45Name-u--C-47C-61_Eq_Name arg-5 e-2)) arg-1) arg-3 clam-0)) (else (vector 1 (vector 32 e-1 1))))))) (else (lambda (eta-0) (vector 1 (vector 0 e-1 e-2))))))))) ((8) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-6) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 8 e-4 e-7 e-8))))))))))))))) ((9) (let ((e-8 (vector-ref arg-4 1))) (let ((e-9 (vector-ref arg-4 2))) (let ((e-10 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-9) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-10) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-8 e-5 e-6))))))))))))))) ((10) (let ((e-12 (vector-ref arg-4 1))) (let ((e-13 (vector-ref arg-4 2))) (let ((e-14 (vector-ref arg-4 3))) (let ((e-15 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-13) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-15) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 10 e-12 e-5 e-14 e-6)))))))))))))))) ((18) (let ((e-21 (vector-ref arg-4 5))) (TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-21)))(else (lambda (eta-0) (vector 1 (vector 32 (TTImpC-45TTImp-getFC arg-4) 1)))))))
(define TTImpC-45InteractiveC-45CaseSplit-update (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-5))))))))) ((1) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector 1 e-4 e-6))))))))) (else (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-9) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-7 e-8 e-5)))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-unique (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) (TTImpC-45InteractiveC-45CaseSplit-unique arg-1 arg-1 (bs+ arg-2 1 63) arg-3) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((u--var (TTImpC-45InteractiveC-45CaseSplit-n--10917-8866-u--mkVarN e-2 e-3 arg-3 arg-2 arg-1 e-2 arg-2))) (let ((sc1 (PreludeC-45Types-elem (csegen-802) (vector 1 (vector 0 u--var)) arg-3))) (cond ((equal? sc1 1) (TTImpC-45InteractiveC-45CaseSplit-unique e-3 arg-1 arg-2 arg-3)) (else u--var)))))))))
(define TTImpC-45InteractiveC-45CaseSplit-substLets (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-8 (vector-ref e-3 3))) (TTImpC-45InteractiveC-45CaseSplit-substLets arg-0 (CoreC-45TTC-45SubstEnv-subst e-8 e-4)))) ((4) (let ((e-13 (vector-ref e-3 3))) (TTImpC-45InteractiveC-45CaseSplit-substLets arg-0 (CoreC-45TTC-45SubstEnv-subst e-13 e-4))))(else (vector 3 e-1 e-2 e-3 (TTImpC-45InteractiveC-45CaseSplit-substLets (cons e-2 arg-0) e-4)))))))))(else arg-1))))
(define TTImpC-45InteractiveC-45CaseSplit-recordUpdate (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--nupdates (PreludeC-45Types-u--map_Functor_List (lambda (u--x) (cons (Builtin-fst u--x) (vector 0 arg-1 (Builtin-snd u--x)))) (let ((e-0 (car e-5))) e-0)))) (let ((act-25 (set-box! arg-0 (let ((e-0 (car e-5))) (let ((e-1 (cdr e-5))) (cons e-0 (cons (cons arg-2 (TTImpC-45Utils-substNames '() u--nupdates arg-3)) e-1))))))) (vector 1 act-25)))))))))
(define TTImpC-45InteractiveC-45CaseSplit-newLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (TTImpC-45InteractiveC-45CaseSplit-case--newLHS-9692 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (TTImpC-45TTImp-getFnArgs arg-6 '()))))
(define TTImpC-45InteractiveC-45CaseSplit-mkCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata (vector 2 0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-27 (CoreC-45Context-setAllPublic arg-0 1 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((TTImpC-45Elab-elabTerm '() arg-0 e-5 arg-1 arg-2 arg-3 (vector 1 (csegen-21)) '() '() '() (vector 16 (TTImpC-45TTImp-getFC arg-5) (vector 1 ) arg-5) '()) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((act-29 (CoreC-45Context-setAllPublic arg-0 0 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (let ((act-30 (set-box! arg-0 e-6))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (let ((act-31 (set-box! arg-1 e-7))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (PreludeC-45IO-u--map_Functor_IO (csegen-2487) (lambda (eta-1) (TTImpC-45Unelab-unelabNoSugar '() arg-0 '() e-2 eta-1)) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45ContextC-45Log-log arg-0 "interaction.casesplit" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Original LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) arg-4))) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((act-34 (CoreC-45ContextC-45Log-log arg-0 "interaction.casesplit" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "New LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-13))) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((act-35 (TTImpC-45InteractiveC-45CaseSplit-getUpdates e-6 arg-4 e-13 eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-35 1))) (vector 1 (vector 0 e-13 e-16)))))))))))))))))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-27 (let ((act-27 (set-box! arg-0 e-6))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (set-box! arg-1 e-7))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (case (vector-ref u--err 0) ((5) (let ((e-0 (vector-ref u--err 1))) (let ((e-2 (vector-ref u--err 3))) (let ((e-3 (vector-ref u--err 4))) (let ((e-4 (vector-ref u--err 5))) (let ((e-11 (vector-ref u--err 6))) (let ((u--defs (let ((e-41 (vector-ref e-6 1))) (let ((e-40 (vector-ref e-6 2))) (let ((e-39 (vector-ref e-6 3))) (let ((e-38 (vector-ref e-6 4))) (let ((e-37 (vector-ref e-6 5))) (let ((e-36 (vector-ref e-6 6))) (let ((e-35 (vector-ref e-6 7))) (let ((e-34 (vector-ref e-6 8))) (let ((e-33 (vector-ref e-6 9))) (let ((e-32 (vector-ref e-6 10))) (let ((e-31 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-2 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30))))))))))))))))))))))))))))))))) (let ((act-29 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-4) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-12 (vector-ref act-29 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-29 1))) (let ((act-30 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-11) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-13 (vector-ref act-30 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-30 1))) (let ((act-31 ((TTImpC-45ProcessDef-impossibleOK arg-0 e-0 u--defs e-12 e-13) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-14 (vector-ref act-31 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-31 1))) (cond ((equal? e-14 1) (vector 1 (vector 1 arg-5))) (else (vector 1 (vector 2 )))))))))))))))))))))))(else (vector 1 (vector 2 )))))))))))) ext-0)))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-getUpdates (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "TTImp.Interactive.CaseSplit.UPD" ) (cons '() '()) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates e-5 arg-0 arg-1 arg-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (unbox e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (let ((e-1 (cdr e-7))) e-1)))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-getSplitsLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((u--lhs (TTImpC-45InteractiveC-45CaseSplit-substLets '() arg-6))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm '() arg-1 "interaction.casesplit" (+ 1 (+ 1 (+ 1 0))) (lambda () "Splitting") arg-6 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((u--usedns (TTImpC-45InteractiveC-45CaseSplit-findAllVars arg-6))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45InteractiveC-45CaseSplit-findCons arg-1 arg-7 u--lhs eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (case (vector-ref e-7 0) ((1) (let ((e-1 (vector-ref e-7 1))) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (let ((e-11 (cdr e-8))) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-2487) (lambda (eta-1) (TTImpC-45Unelab-unelabNoSugar '() arg-1 '() u--lhs eta-1)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (u--c) (TTImpC-45InteractiveC-45CaseSplit-newLHS arg-1 arg-4 arg-5 u--usedns arg-7 u--c e-12)) e-11 '() eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-28 1))) (let ((sc8 (CoreC-45Context-getNameID e-9 (let ((e-0 (vector-ref e-6 0))) e-0)))) (if (null? sc8) (CoreC-45Context-undefinedName arg-1 arg-4 e-9 eta-0) (let ((e-2 (unbox sc8))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45CaseSplit-mkCase arg-1 arg-2 arg-3 e-2 e-12 eta-1 eta-2))) e-13 '() eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 (CoreC-45ContextC-45Log-log arg-1 "interaction.casesplit" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Found cases: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45InteractiveC-45CaseSplit-u--show_Show_ClauseUpdate u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45InteractiveC-45CaseSplit-u--showPrec_Show_ClauseUpdate u--d u--x)))) e-14))) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (vector 1 (TTImpC-45InteractiveC-45CaseSplit-combine e-14 '()))))))))))))))))))))))))) (else (let ((e-3 (vector-ref e-7 1))) (vector 1 (vector 0 e-3)))))))))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-getSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Metadata-findLHSAt arg-1 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 0 (vector 2 ))) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) ((TTImpC-45InteractiveC-45CaseSplit-getSplitsLHS arg-1 arg-0 arg-2 arg-3 (CoreC-45FC-justFC e-7) e-9 e-10 arg-5) ext-0)))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-getEnvArgNames (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) (lambda (eta-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-explicitlyBound arg-1 arg-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45CaseSplit-getArgNames '() arg-0 arg-1 e-5 '() '() arg-3) eta-0)))))))(else (let ((e-0 (- arg-2 1))) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-24 (((e-5 arg-1) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-2 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((TTImpC-45InteractiveC-45CaseSplit-getEnvArgNames arg-0 arg-1 e-0 e-6) clam-0))))))))(else (vector 1 '())))))))))
(define TTImpC-45InteractiveC-45CaseSplit-getDefining (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-4 (vector-ref arg-1 4))) (TTImpC-45InteractiveC-45CaseSplit-getDefining e-4)))(else (let ((sc0 (CoreC-45TT-getFn arg-1))) (case (vector-ref sc0 0) ((1) (let ((e-3 (vector-ref sc0 3))) (box e-3)))(else '())))))))
(define TTImpC-45InteractiveC-45CaseSplit-getArgNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (case (vector-ref e-8 0) ((1) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-2 e-9) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45InteractiveC-45CaseSplit-getArgName arg-0 arg-1 arg-2 e-2 arg-3 arg-4 e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (cons e-10 '())))))))))))(else (vector 1 '()))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-4 arg-2) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-5 (vector 10 e-1 0))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 ((TTImpC-45InteractiveC-45CaseSplit-getArgNames arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 1 (vector 0 eta-0))) e-5) arg-4) arg-5 e-10) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-11)))))))))))))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45InteractiveC-45CaseSplit-getArgName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-n--11022-8961-u--findNames arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (TTImpC-45InteractiveC-45CaseSplit-n--11022-8962-u--getName arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3 e-5 arg-5))))))))
(define TTImpC-45InteractiveC-45CaseSplit-findUpdates (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-32 (vector-ref arg-2 1))) (let ((e-33 (vector-ref arg-2 2))) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-44 (vector-ref arg-3 2))) (let ((act-24 (CoreC-45Context-lookupTyExact e-44 (let ((e-0 (vector-ref arg-1 0))) e-0) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc5 (DataC-45List-lookup (csegen-802) e-44 (let ((e-0 (car e-6))) e-0)))) (if (null? sc5) (let ((act-26 (set-box! arg-0 (let ((e-0 (car e-6))) (let ((e-1 (cdr e-6))) (cons (cons (cons e-44 e-33) e-0) e-1)))))) (vector 1 act-26)) (let ((e-2 (unbox sc5))) (let ((act-26 (set-box! arg-0 (let ((e-0 (car e-6))) (let ((e-1 (cdr e-6))) (cons e-0 (cons (cons e-33 (vector 0 e-32 e-2)) e-1))))))) (vector 1 act-26))))))))) (TTImpC-45InteractiveC-45CaseSplit-recordUpdate arg-0 e-32 e-33 (vector 0 e-32 e-44) clam-0))))))))(else (TTImpC-45InteractiveC-45CaseSplit-recordUpdate arg-0 e-32 e-33 arg-3 clam-0))))))) ((8) (let ((e-36 (vector-ref arg-2 2))) (let ((e-37 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((8) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-36 e-47) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-37 e-48) eta-0))))))))(else (case (vector-ref arg-3 0) ((9) (let ((e-29 (vector-ref arg-3 2))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-29)))(else (case (vector-ref arg-2 0) ((10) (let ((e-19 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((10) (let ((e-24 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-19 e-24) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-21 e-26) eta-0))))))))(else (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-19 arg-3))))))(else (case (vector-ref arg-3 0) ((10) (let ((e-14 (vector-ref arg-3 2))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-14)))(else (case (vector-ref arg-2 0) ((18) (let ((e-11 (vector-ref arg-2 5))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-11 arg-3)))(else (case (vector-ref arg-3 0) ((18) (let ((e-5 (vector-ref arg-3 5))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-5)))(else (lambda (eta-0) (vector 1 0))))))))))))))))) ((9) (let ((e-40 (vector-ref arg-2 2))) (let ((e-41 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((9) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-40 e-51) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-41 e-52) eta-0))))))))(else (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-40 arg-3))))))(else (case (vector-ref arg-3 0) ((9) (let ((e-29 (vector-ref arg-3 2))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-29)))(else (case (vector-ref arg-2 0) ((10) (let ((e-19 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((10) (let ((e-24 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-19 e-24) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-21 e-26) eta-0))))))))(else (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-19 arg-3))))))(else (case (vector-ref arg-3 0) ((10) (let ((e-14 (vector-ref arg-3 2))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-14)))(else (case (vector-ref arg-2 0) ((18) (let ((e-11 (vector-ref arg-2 5))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-11 arg-3)))(else (case (vector-ref arg-3 0) ((18) (let ((e-5 (vector-ref arg-3 5))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-5)))(else (lambda (eta-0) (vector 1 0))))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-findTyName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((3) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((3) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--b (vector 3 e-6 e-7 e-8 e-9))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-2))) (cond ((equal? sc2 1) (lambda (eta-0) (let ((act-24 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-2 arg-3 e-9) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((3) (let ((e-13 (vector-ref e-5 2))) (vector 1 (box e-13))))(else (vector 1 '()))))))))) (else (TTImpC-45InteractiveC-45CaseSplit-findTyName (cons e-2 arg-0) arg-1 arg-2 (cons u--b arg-3) arg-4 e-4))))))))))(else (TTImpC-45InteractiveC-45CaseSplit-findTyName (cons e-2 arg-0) arg-1 arg-2 (cons e-3 arg-3) arg-4 e-4)))))))(else (lambda (eta-0) (vector 1 '()))))))
(define TTImpC-45InteractiveC-45CaseSplit-findCons (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (TTImpC-45InteractiveC-45CaseSplit-getDefining arg-2))) (if (null? sc0) (vector 1 (vector 0 (vector 1 arg-1 "Can't find function name on LHS"))) (let ((e-2 (unbox sc0))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45InteractiveC-45CaseSplit-findTyName '() arg-0 e-5 '() arg-1 arg-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 0 (vector 1 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "Can't find type of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) " in LHS"))))) (let ((e-3 (unbox e-6))) (let ((act-26 (CoreC-45Context-lookupDefExact e-3 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 (vector 0 (vector 1 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "Not a type constructor " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1034) e-7))))) (let ((e-1 (unbox e-7))) (case (vector-ref e-1 0) ((6) (let ((e-8 (vector-ref e-1 7))) (let ((act-27 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-3 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-15 (vector-ref act-27 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-0 (csegen-46) eta-0 eta-1))) e-8 '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-16 (vector-ref act-28 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-28 1))) (vector 1 (vector 1 (cons e-2 (cons e-15 e-16))))))))))))))(else (vector 1 (vector 0 (vector 1 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "Not a type constructor " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1034) e-7))))))))))))))))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-findAllVars (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((3) (cons e-2 (TTImpC-45InteractiveC-45CaseSplit-findAllVars e-4))) ((1) (cons e-2 (TTImpC-45InteractiveC-45CaseSplit-findAllVars e-4))) ((4) (cons e-2 (TTImpC-45InteractiveC-45CaseSplit-findAllVars e-4)))(else '()))))))(else '()))))
(define TTImpC-45InteractiveC-45CaseSplit-explicitlyBound (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((2) (let ((act-24 (((e-4 arg-0) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) '() (vector 10 e-1 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((TTImpC-45InteractiveC-45CaseSplit-explicitlyBound arg-0 e-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (cons e-2 e-10)))))))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45InteractiveC-45CaseSplit-expandCon (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-lookupTyExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 ext-0) (let ((e-1 (unbox e-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() e-1) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45InteractiveC-45CaseSplit-getArgNames '() arg-0 e-5 '() arg-2 '() e-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (TTImpC-45TTImp-apply (vector 0 arg-1 arg-3) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 17 arg-1 eta-0)) e-8)))))))))))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-defaultNames(blodwen-lazy (lambda () (cons "x" (cons "y" (cons "z" (cons "w" (cons "v" (cons "s" (cons "t" (cons "u" '())))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-combine (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (vector 0 (vector 0 )) (vector 1 (PreludeC-45TypesC-45List-reverse arg-1))) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((2) (TTImpC-45InteractiveC-45CaseSplit-combine e-3 arg-1))(else (TTImpC-45InteractiveC-45CaseSplit-combine e-3 (cons e-2 arg-1)))))))))
(define CoreC-45AutoSearch-case--caseC-32blockC-32inC-32getUsableEnv-2676 (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9) (cons (cons (vector 0 (CoreC-45TT-binderLoc arg-3) '() arg-9) (CoreC-45TT-u--weakenNs_Weaken_Term (CoreC-45TTC-45SizeOf-sucR arg-5) (CoreC-45TT-binderType arg-3))) arg-8)))
(define CoreC-45AutoSearch-case--exactlyOne-2459 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-5 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-3 '()) eta-0)))))) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (if (null? e-1) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-2 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45AutoSearch-n--8668-2431-u--normRes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-1)) arg-9 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 19 arg-0 arg-5 arg-4 e-6 e-7) eta-0)))))))))))))) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (lambda (clam-0) (if (null? e-7) (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-2 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45AutoSearch-n--8668-2431-u--normRes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) arg-9 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 19 arg-0 arg-5 arg-4 e-8 e-9) clam-0))))))))))))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-2) (let ((act-24 (let ((act-24 (set-box! arg-6 e-11))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (let ((act-25 (set-box! arg-7 e-10))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (CoreC-45Context-commit arg-7 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (vector 1 e-6)))))))))) (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-2 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45AutoSearch-n--8668-2431-u--normRes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) arg-9 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 19 arg-0 arg-5 arg-4 e-8 e-9) clam-0))))))))))))))))))))))))))
(define CoreC-45AutoSearch-case--caseC-32blockC-32inC-32searchIfHole-1618 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (case (vector-ref arg-17 0) ((7) (let ((act-24 (cond ((equal? arg-6 1) ((CoreC-45Normalise-normaliseScope arg-11 '() arg-14 '() (let ((e-2 (vector-ref arg-15 2))) e-2)) ext-0)) (else (vector 1 arg-4))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45Normalise-normaliseScope arg-11 arg-0 arg-14 arg-3 (let ((e-6 (vector-ref arg-2 4))) e-6)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45AutoSearch-searchType arg-0 arg-11 arg-10 arg-9 arg-13 arg-8 arg-7 arg-1 arg-5 0 e-5 arg-3 e-6) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Normalise-logTermNF arg-0 arg-11 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Solved arg") arg-3 e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Normalise-logTermNF arg-0 arg-11 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Arg meta") arg-3 (let ((e-4 (vector-ref arg-2 3))) e-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45Unify-solveIfUndefined arg-0 arg-11 arg-10 arg-3 (let ((e-4 (vector-ref arg-2 3))) e-4) e-6 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (cond ((equal? e-9 1) (vector 1 0)) (else (let ((act-29 (((((CoreC-45Unify-unify (csegen-1962) arg-0 arg-11 arg-10 (CoreC-45Unify-inTerm) arg-9) arg-3) (let ((e-4 (vector-ref arg-2 3))) e-4)) e-6) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((e-11 (vector-ref e-10 0))) (if (null? e-11) (vector 1 0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-9 (let ((e-42 (vector-ref arg-14 0))) e-42) '() arg-4 '()) ext-0))))))))))))))))))))))))))))(else (vector 1 0)))))
(define CoreC-45AutoSearch-n--11202-4688-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-17 arg-15) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((sc2 (CoreC-45Context-visibleInAny arg-16 arg-17 (let ((e-9 (vector-ref e-1 9))) e-9)))) (cond ((equal? sc2 1) (vector 1 (box (cons arg-17 e-1)))) (else (vector 1 '()))))))))))))
(define CoreC-45AutoSearch-n--9148-2827-u--usableLocalArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) arg-10 arg-11))) (cond ((equal? sc1 1) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-9 arg-3 e-5 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45AutoSearch-usableLocal arg-3 arg-9 arg-8 arg-7 arg-6 e-6) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) ((CoreC-45AutoSearch-n--9148-2827-u--usableLocalArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-10) arg-11 e-3) eta-0)) (else (vector 1 0))))))))))))) (else (CoreC-45AutoSearch-n--9148-2827-u--usableLocalArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-10) arg-11 e-3)))))))))
(define CoreC-45AutoSearch-n--7339-5885-u--tryGroups (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-13) (if (null? arg-15) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-12))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-10 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-3 '()) eta-0)))))) (lambda (clam-1) (let ((e-1 (car arg-15))) (let ((e-2 (cdr arg-15))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (CoreC-45UnifyState-handleUnify arg-12 arg-11 (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-12 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-getFullName arg-12 eta-2 eta-3))) e-6 '() eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Search: Trying " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-7)) (PreludeC-45TypesC-45String-C-43C-43 " names " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-7)))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (CoreC-45Normalise-logNF arg-0 arg-12 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "For target") arg-2 arg-14 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (CoreC-45AutoSearch-searchNames arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 (cons arg-1 arg-7) arg-6 arg-5 arg-3 arg-2 e-5 e-6 arg-14 eta-0)))))))) (lambda (u--err) (let ((sc4 (CoreC-45AutoSearch-n--7339-5884-u--ambig arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 u--err))) (cond ((equal? sc4 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))) (else (CoreC-45AutoSearch-n--7339-5885-u--tryGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (box (DataC-45Maybe-fromMaybe (lambda () u--err) arg-13)) arg-14 e-2))))) clam-1))))))) (let ((e-8 (unbox arg-13))) (if (null? arg-15) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error e-8 eta-0)) (lambda (clam-0) (let ((e-1 (car arg-15))) (let ((e-2 (cdr arg-15))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (CoreC-45UnifyState-handleUnify arg-12 arg-11 (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogC arg-12 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda (eta-1) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-getFullName arg-12 eta-2 eta-3))) e-6 '() eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Search: Trying " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-7)) (PreludeC-45TypesC-45String-C-43C-43 " names " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-7)))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (CoreC-45Normalise-logNF arg-0 arg-12 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "For target") arg-2 arg-14 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (CoreC-45AutoSearch-searchNames arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 (cons arg-1 arg-7) arg-6 arg-5 arg-3 arg-2 e-5 e-6 arg-14 eta-0)))))))) (lambda (u--err) (let ((sc4 (CoreC-45AutoSearch-n--7339-5884-u--ambig arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 u--err))) (cond ((equal? sc4 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))) (else (CoreC-45AutoSearch-n--7339-5885-u--tryGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (box (DataC-45Maybe-fromMaybe (lambda () u--err) arg-13)) arg-14 e-2))))) clam-0)))))))))))
(define CoreC-45AutoSearch-n--8668-2431-u--normRes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-3))) (CoreC-45Normalise-normaliseHoles arg-7 arg-0 e-6 arg-4 e-2 clam-0)))))))
(define CoreC-45AutoSearch-n--7691-1487-u--impl (lambda (arg-1 arg-3) (let ((e-3 (vector-ref arg-3 2))) (case (vector-ref e-3 0) ((1) 0)(else 1)))))
(define CoreC-45AutoSearch-n--9587-3214-u--findPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-17 0) ((3) (let ((e-2 (vector-ref arg-17 2))) (let ((e-5 (vector-ref arg-17 5))) (if (null? e-5) (lambda (eta-0) (CoreC-45AutoSearch-n--9587-3213-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-7) (lambda (eta-0) (CoreC-45AutoSearch-n--9587-3213-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-12 (cdr e-7))) (if (null? e-8) (lambda (eta-0) (CoreC-45AutoSearch-n--9587-3213-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-14 (car e-8))) (let ((e-15 (cdr e-8))) (if (null? e-14) (lambda (eta-0) (CoreC-45AutoSearch-n--9587-3213-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-19 (cdr e-14))) (lambda (clam-0) (if (null? e-15) (CoreC-45UnifyState-handleUnify arg-13 arg-12 (lambda (eta-0) (CoreC-45AutoSearch-n--9587-3213-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-1 arg-16 arg-17 arg-18 eta-0)) (lambda (u--e) (lambda (clam-1) (let ((sc6 (CoreC-45AutoSearch-n--9587-3210-u--ambig arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 u--e))) (cond ((equal? sc6 1) (CoreC-45Core-u--throw_Catchable_Core_Error u--e clam-1)) (else (let ((act-24 (let ((act-24 (CoreC-45Context-fstName arg-13 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-11 (let ((e-0 (vector-ref arg-14 0))) e-0) '() arg-5 '()) eta-0))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) e-6) clam-1))))))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-sndName arg-13 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-11 (let ((e-0 (vector-ref arg-14 0))) e-0) '() arg-5 '()) eta-0))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) e-9) clam-1))))))) (case (vector-ref act-25 0) ((0) (let ((e-9 (vector-ref act-25 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-isPairType arg-13 e-2 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) (cond ((equal? e-10 1) (let ((act-27 (CoreC-45Context-clearDefs arg-14 clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-13 arg-0 e-13 arg-4 e-12 clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-16 (vector-ref act-28 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-28 1))) (let ((act-29 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-13 arg-0 e-13 arg-4 e-19 clam-1))) (case (vector-ref act-29 0) ((0) (let ((e-17 (vector-ref act-29 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-29 1))) ((CoreC-45AutoSearch-exactlyOne arg-0 arg-13 arg-12 arg-11 arg-4 arg-5 arg-18 (cons (lambda (eta-0) (let ((act-30 ((CoreC-45NormaliseC-45Eval-evalClosure arg-13 arg-0 arg-14 e-12) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-20 (vector-ref act-30 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-30 1))) ((CoreC-45AutoSearch-n--9587-3214-u--findPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (lambda (u--arg) (CoreC-45TT-apply arg-11 (vector 1 arg-11 (vector 1 ) e-6) (cons e-16 (cons e-17 (cons (arg-16 u--arg) '()))))) e-20 arg-18) eta-0)))))) (cons (lambda (eta-0) (let ((act-30 ((CoreC-45NormaliseC-45Eval-evalClosure arg-13 arg-0 arg-14 e-19) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-20 (vector-ref act-30 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-30 1))) ((CoreC-45AutoSearch-n--9587-3214-u--findPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (lambda (u--arg) (CoreC-45TT-apply arg-11 (vector 1 arg-11 (vector 1 ) e-9) (cons e-16 (cons e-17 (cons (arg-16 u--arg) '()))))) e-20 arg-18) eta-0)))))) '()))) clam-1)))))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-11 (let ((e-0 (vector-ref arg-14 0))) e-0) '() arg-5 '()) clam-1)))))))))))))))))))) clam-0) (CoreC-45AutoSearch-n--9587-3213-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 clam-0))))))))))))))))(else (lambda (eta-0) (CoreC-45AutoSearch-n--9587-3213-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0))))))
(define CoreC-45AutoSearch-n--9587-3213-u--findDirect (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (let ((act-24 ((CoreC-45AutoSearch-mkArgs arg-0 arg-13 arg-12 arg-11 arg-10 arg-4 arg-17) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Normalise-logTermNF arg-0 arg-13 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Trying") arg-4 (arg-16 arg-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CoreC-45Normalise-logNF arg-0 arg-13 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Type") arg-4 arg-17 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (CoreC-45Normalise-logNF arg-0 arg-13 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "For target") arg-4 arg-18 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-13 arg-12 (CoreC-45Unify-inTerm) arg-11) arg-4) arg-18) e-3) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-0 (vector-ref e-9 0))) (if (null? e-0) (let ((act-29 ((CoreC-45AutoSearch-usableLocal arg-0 arg-13 arg-11 arg-9 arg-4 arg-17) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-29 1))) (cond ((equal? e-11 1) (let ((u--candidate (CoreC-45TT-apply arg-11 (arg-16 arg-1) (PreludeC-45Types-u--map_Functor_List (csegen-2497) e-2)))) (let ((act-30 (CoreC-45Normalise-logTermNF arg-0 arg-13 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Local var candidate ") arg-4 u--candidate ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (let ((u--envC-39 (CoreC-45AutoSearch-n--9587-3212-u--clearEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-1 arg-4))) (let ((act-31 (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45AutoSearch-searchIfHole arg-0 arg-13 arg-12 arg-11 arg-9 arg-8 0 arg-7 arg-6 arg-5 u--envC-39 eta-0)) (CoreC-45AutoSearch-impLast e-2) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-13 (vector-ref act-31 1))) (vector 0 e-13))) (else (vector 1 u--candidate)))))))))) (else (let ((act-30 (CoreC-45Normalise-logNF arg-0 arg-13 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Can't use ") arg-4 arg-17 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-11 (let ((e-43 (vector-ref arg-14 0))) e-43) '() arg-5 '()) ext-0)))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-11 (let ((e-41 (vector-ref arg-14 0))) e-41) '() arg-5 '()) ext-0))))))))))))))))))))))))
(define CoreC-45AutoSearch-n--11610-5016-u--drop (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 arg-14) (if (null? arg-14) '() (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) arg-12 arg-13))) (cond ((equal? sc1 1) (cons e-2 (CoreC-45AutoSearch-n--11610-5016-u--drop arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-12) arg-13 e-3))) (else (CoreC-45AutoSearch-n--11610-5016-u--drop arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-12) arg-13 e-3)))))))))
(define CoreC-45AutoSearch-n--11610-5017-u--concrete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-12 0) ((0) (let ((e-1 (vector-ref arg-12 1))) (let ((e-4 (vector-ref arg-12 4))) (lambda (eta-0) (let ((act-24 (((e-4 arg-11) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-6 (vector 10 e-1 0))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45AutoSearch-n--11610-5017-u--concrete arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5 0) eta-0))))))))) ((3) (let ((e-6 (vector-ref arg-12 1))) (let ((e-7 (vector-ref arg-12 2))) (let ((e-10 (vector-ref arg-12 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getSearchData arg-10 e-6 0 e-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--argsC-39 (CoreC-45AutoSearch-n--11610-5016-u--drop arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 0 (let ((e-0 (car e-5))) e-0) e-10))) (CoreC-45Core-traverse_ (lambda (u--parg) (lambda (eta-1) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-10 arg-0 arg-11 u--parg) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-25 1))) ((CoreC-45AutoSearch-n--11610-5017-u--concrete arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-11 0) eta-1))))))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) u--argsC-39) eta-0))))))))))) ((2) (let ((e-16 (vector-ref arg-12 5))) (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (u--parg) (lambda (eta-1) (let ((act-24 ((CoreC-45NormaliseC-45Eval-evalClosure arg-10 arg-0 arg-11 u--parg) eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45AutoSearch-n--11610-5017-u--concrete arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5 0) eta-1))))))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-16) eta-0)))) ((1) (let ((e-19 (vector-ref arg-12 2))) (lambda (clam-0) (case (vector-ref e-19 0) ((2) (let ((e-22 (vector-ref e-19 1))) (let ((e-23 (vector-ref e-19 2))) (cond ((equal? arg-13 1) (let ((act-24 (CoreC-45Context-lookupDefExact e-22 (let ((e-0 (vector-ref arg-11 0))) e-0) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-8 e-22 e-23 '() arg-5) clam-0) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((7) (let ((e-3 (vector-ref e-1 2))) (let ((sc6 (let ((e-0 (car e-3))) e-0))) (cond ((equal? sc6 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-8 e-22 e-23 '() arg-5) clam-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-8 e-22 e-23 '() arg-5) clam-0)))))))))) ((equal? arg-13 0) (let ((act-24 (CoreC-45Context-lookupDefExact e-22 (let ((e-0 (vector-ref arg-11 0))) e-0) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-8 (let ((e-0 (vector-ref arg-11 0))) e-0) '() arg-5 '()) clam-0) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((7) (let ((e-3 (vector-ref e-1 2))) (let ((sc6 (let ((e-0 (car e-3))) e-0))) (cond ((equal? sc6 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-8 (let ((e-0 (vector-ref arg-11 0))) e-0) '() arg-5 '()) clam-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-8 (let ((e-0 (vector-ref arg-11 0))) e-0) '() arg-5 '()) clam-0))))))))))(else (vector 1 0))))))(else (vector 1 0))))))(else (lambda (eta-0) (vector 1 0))))))
(define CoreC-45AutoSearch-n--9587-3211-u--clearEnvType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-16 arg-18 arg-19) (cond ((equal? arg-16 0) (let ((e-4 (car arg-19))) (let ((e-5 (cdr arg-19))) (cons (vector 0 (CoreC-45TT-binderLoc e-4) (CoreC-45TT-multiplicity e-4) (vector 1 ) (vector 10 arg-18 0)) e-5))))(else (let ((e-0 (- arg-16 1))) (let ((e-9 (car arg-19))) (let ((e-10 (cdr arg-19))) (cons e-9 (CoreC-45AutoSearch-n--9587-3211-u--clearEnvType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-0 arg-18 e-10)))))))))
(define CoreC-45AutoSearch-n--9587-3212-u--clearEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (case (vector-ref arg-14 0) ((0) (let ((e-2 (vector-ref arg-14 1))) (let ((e-4 (vector-ref arg-14 3))) (CoreC-45AutoSearch-n--9587-3211-u--clearEnvType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-4 e-2 arg-15))))(else arg-15))))
(define CoreC-45AutoSearch-n--9587-3210-u--ambig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((19) 1)(else 0))))
(define CoreC-45AutoSearch-n--7339-5884-u--ambig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((19) 1)(else 0))))
(define CoreC-45AutoSearch-usableLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (clam-0) (case (vector-ref e-2 0) ((2) (let ((e-25 (vector-ref e-2 1))) (case (vector-ref e-25 0) ((3) (vector 1 1))(else (vector 1 0))))) ((0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 eta-0)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-3) '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45AutoSearch-usableLocal arg-0 arg-1 arg-2 arg-3 arg-4 eta-0)) e-6 '() clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) eta-0) e-6)))))))))))(else (vector 1 1))))))) ((3) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (let ((e-9 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getSearchData arg-1 arg-2 (cond ((equal? arg-3 1) 0) (else 1)) e-6 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-24 1))) ((CoreC-45AutoSearch-n--9148-2827-u--usableLocalArg e-5 e-7 e-8 arg-0 e-9 e-6 arg-4 arg-3 arg-2 arg-1 0 (let ((e-0 (car e-10))) e-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-9)) eta-0)))))))))))) ((2) (let ((e-15 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-15) '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45AutoSearch-usableLocal arg-0 arg-1 arg-2 arg-3 arg-4 eta-1)) e-6 '() eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-1) eta-1) e-6))))))))))))) ((0) (let ((e-17 (vector-ref arg-5 1))) (let ((e-19 (vector-ref arg-5 3))) (let ((e-20 (vector-ref arg-5 4))) (lambda (clam-1) (case (vector-ref e-19 0) ((2) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (((e-20 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-4 (vector 10 e-17 0))) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45AutoSearch-usableLocal arg-0 arg-1 arg-2 arg-3 arg-4 e-6) clam-1))))))))))(else (vector 1 1)))))))) ((9) (lambda (eta-0) (vector 1 0)))(else (lambda (eta-0) (vector 1 1))))))
(define CoreC-45AutoSearch-successful (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-branch arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-26 (e-2 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-2))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (unbox arg-1))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (set-box! arg-2 e-5))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (let ((act-30 (set-box! arg-1 e-6))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (CoreC-45AutoSearch-successful arg-0 arg-1 arg-2 e-3 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (cons (vector 1 (cons e-7 (cons e-9 e-8))) e-12))))))))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-26 (let ((act-26 (set-box! arg-2 e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (let ((act-27 (set-box! arg-1 e-6))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (CoreC-45AutoSearch-successful arg-0 arg-1 arg-2 e-3 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons (vector 0 u--err) e-9)))))))))))))) ext-0))))))))))))))
(define CoreC-45AutoSearch-searchType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (case (vector-ref arg-12 0) ((3) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (let ((e-4 (vector-ref arg-12 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 ((CoreC-45AutoSearch-searchType (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-7 arg-8 arg-9 arg-10 (cons e-3 arg-11) e-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-1 e-2 (vector 0 e-6 e-7 e-8 e-9) e-5))))))))))) ((1) (let ((act-24 ((CoreC-45AutoSearch-searchType (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-7 arg-8 arg-9 arg-10 (cons e-3 arg-11) e-4) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-1 e-2 e-3 e-5)))))))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45AutoSearch-abandonIfCycle arg-0 arg-1 arg-11 arg-12 arg-6 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((u--tryingC-39 (cons arg-12 arg-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-11 arg-12) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (case (vector-ref e-7 0) ((3) (let ((e-12 (vector-ref e-7 1))) (let ((e-11 (vector-ref e-7 2))) (let ((e-10 (vector-ref e-7 3))) (let ((e-9 (vector-ref e-7 4))) (let ((e-8 (vector-ref e-7 5))) (let ((u--nty (vector 3 e-12 e-11 e-10 e-9 e-8))) (let ((sc5 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-9 (PreludeC-45TypesC-45List-length e-8)))) (cond ((equal? sc5 1) (let ((act-27 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Next target") arg-11 u--nty clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((act-28 (CoreC-45Context-getSearchData arg-1 arg-3 arg-5 e-11 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-28 1))) (let ((act-29 (cond ((equal? arg-9 1) (CoreC-45AutoSearch-checkConcreteDets arg-0 arg-1 arg-2 arg-3 arg-5 arg-11 arg-10 (vector 3 e-12 e-11 e-10 e-9 e-8) clam-0)) (else (vector 1 0))))) (case (vector-ref act-29 0) ((0) (let ((e-15 (vector-ref act-29 1))) (vector 0 e-15))) (else (let ((sc9 (cond ((equal? arg-5 1) arg-9) (else 0)))) (cond ((equal? sc9 1) ((CoreC-45AutoSearch-n--7339-5885-u--tryGroups arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() u--nty (let ((e-16 (cdr e-14))) e-16)) clam-0)) (else (CoreC-45UnifyState-handleUnify arg-1 arg-2 (CoreC-45AutoSearch-searchLocalVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--tryingC-39 arg-7 arg-8 arg-10 arg-11 u--nty) (lambda (u--e) (let ((sc10 (CoreC-45AutoSearch-n--7339-5884-u--ambig arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--e))) (cond ((equal? sc10 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error u--e eta-0))) (else (CoreC-45AutoSearch-n--7339-5885-u--tryGroups arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() u--nty (let ((e-16 (cdr e-14))) e-16)))))) clam-0))))))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-10 '()) clam-0)))))))))))(else (let ((act-27 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Next target: ") arg-11 e-7 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else ((CoreC-45AutoSearch-searchLocalVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--tryingC-39 arg-7 arg-8 arg-10 arg-11 e-7) clam-0)))))))))))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45AutoSearch-abandonIfCycle arg-0 arg-1 arg-11 arg-12 arg-6 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--tryingC-39 (cons arg-12 arg-6))) (let ((act-26 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-11 arg-12) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (case (vector-ref e-7 0) ((3) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-8 (vector-ref e-7 5))) (let ((u--nty (vector 3 e-1 e-2 e-3 e-4 e-8))) (let ((sc4 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-4 (PreludeC-45TypesC-45List-length e-8)))) (cond ((equal? sc4 1) (let ((act-27 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Next target") arg-11 u--nty clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((act-28 (CoreC-45Context-getSearchData arg-1 arg-3 arg-5 e-2 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((act-29 (cond ((equal? arg-9 1) (CoreC-45AutoSearch-checkConcreteDets arg-0 arg-1 arg-2 arg-3 arg-5 arg-11 arg-10 (vector 3 e-1 e-2 e-3 e-4 e-8) clam-0)) (else (vector 1 0))))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (let ((sc8 (cond ((equal? arg-5 1) arg-9) (else 0)))) (cond ((equal? sc8 1) ((CoreC-45AutoSearch-n--7339-5885-u--tryGroups arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() u--nty (let ((e-12 (cdr e-10))) e-12)) clam-0)) (else (CoreC-45UnifyState-handleUnify arg-1 arg-2 (CoreC-45AutoSearch-searchLocalVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--tryingC-39 arg-7 arg-8 arg-10 arg-11 u--nty) (lambda (u--e) (let ((sc9 (CoreC-45AutoSearch-n--7339-5884-u--ambig arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--e))) (cond ((equal? sc9 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error u--e eta-0))) (else (CoreC-45AutoSearch-n--7339-5885-u--tryGroups arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() u--nty (let ((e-12 (cdr e-10))) e-12)))))) clam-0))))))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-10 '()) clam-0)))))))))))(else (let ((act-27 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Next target: ") arg-11 e-7 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else ((CoreC-45AutoSearch-searchLocalVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--tryingC-39 arg-7 arg-8 arg-10 arg-11 e-7) clam-0)))))))))))))))))))))))
(define CoreC-45AutoSearch-searchNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (if (null? arg-12) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-9 '()) ext-0))))) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45AutoSearch-n--11202-4688-u--visible arg-0 e-2 e-3 arg-13 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref e-5 0))) e-0) (cons (let ((e-33 (vector-ref e-5 2))) e-33) (let ((e-32 (vector-ref e-5 3))) e-32)) eta-0 eta-1))) (cons e-2 e-3) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--visns (DataC-45List-mapMaybe (lambda (eta-0) eta-0) e-6))) (let ((u--elabs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (lambda (eta-1) (CoreC-45AutoSearch-searchName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 eta-0 eta-1))) u--visns))) (cond ((equal? arg-11 1) ((CoreC-45AutoSearch-anyOne arg-0 arg-1 arg-2 arg-3 arg-10 arg-9 u--elabs) ext-0)) (else ((CoreC-45AutoSearch-exactlyOne arg-0 arg-1 arg-2 arg-3 arg-10 arg-9 arg-13 u--elabs) ext-0))))))))))))))))))
(define CoreC-45AutoSearch-searchName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-getNS arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getNestedNS arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc4 (CoreC-45Context-visibleInAny (cons e-6 e-7) (let ((e-1 (vector-ref e-3 1))) e-1) (let ((e-9 (vector-ref e-3 9))) e-9)))) (cond ((equal? sc4 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-9 '()) ext-0)))))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (let ((sc3 (PreludeC-45Types-elem (csegen-1023) (vector 5 ) (let ((e-11 (vector-ref e-3 11))) e-11)))) (cond ((equal? sc3 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-9 '()) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((u--ty (let ((e-26 (vector-ref e-3 2))) e-26))) (let ((u--namety (let ((e-17 (vector-ref e-3 17))) (case (vector-ref e-17 0) ((5) (let ((e-29 (vector-ref e-17 1))) (let ((e-28 (vector-ref e-17 2))) (vector 2 e-29 e-28)))) ((6) (let ((e-34 (vector-ref e-17 1))) (let ((e-33 (vector-ref e-17 2))) (vector 3 e-34 e-33))))(else (vector 1 )))))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-10 (CoreC-45TT-embed u--ty)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Searching Name " (CoreC-45Name-u--show_Show_Name e-2))) arg-10 e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 ((CoreC-45AutoSearch-mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 e-8) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((e-11 (car e-10))) (let ((e-4 (cdr e-10))) (let ((act-30 (((((CoreC-45Unify-unify (csegen-1965) arg-0 arg-1 arg-2 (CoreC-45Unify-inTerm) arg-3) arg-10) arg-11) e-4) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-30 1))) (let ((e-0 (vector-ref e-12 0))) (if (null? e-0) (let ((act-31 ((CoreC-45AutoSearch-isPairNF arg-1 arg-10 e-8 e-5) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-15 (vector-ref act-31 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-31 1))) (let ((u--candidate (CoreC-45TT-apply arg-3 (vector 1 arg-3 u--namety e-2) (PreludeC-45Types-u--map_Functor_List (csegen-2497) e-11)))) (let ((act-32 (CoreC-45Normalise-logTermNF arg-0 arg-1 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Candidate ") arg-10 u--candidate ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-16 (vector-ref act-32 1))) (vector 0 e-16))) (else (let ((act-33 (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45AutoSearch-searchIfHole arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 e-15 arg-7 arg-8 arg-9 arg-10 eta-0)) (CoreC-45AutoSearch-impLast e-11) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-17 (vector-ref act-33 1))) (vector 0 e-17))) (else (vector 1 u--candidate)))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-45 (vector-ref e-5 0))) e-45) '() arg-9 '()) ext-0))))))))))))))))))))))))))))))))))))
(define CoreC-45AutoSearch-searchLocalWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-10 e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45AutoSearch-n--9587-3214-u--findPos arg-0 e-2 e-3 arg-12 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-2 (lambda (eta-0) eta-0) e-6 arg-12) ext-0)))))))))))))
(define CoreC-45AutoSearch-searchLocalVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((u--elabs (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (lambda (eta-0) (CoreC-45AutoSearch-searchLocalWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 u--t arg-11 eta-0))) (CoreC-45AutoSearch-getUsableEnv arg-0 arg-3 arg-4 (CoreC-45TTC-45SizeOf-zero) arg-10)))) (CoreC-45AutoSearch-exactlyOne arg-0 arg-1 arg-2 arg-3 arg-10 arg-9 arg-11 u--elabs))))
(define CoreC-45AutoSearch-searchIfHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (cond ((equal? arg-7 0) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-9 '()) eta-0)))))))(else (let ((e-0 (- arg-7 1))) (let ((u--hole (let ((e-1 (vector-ref arg-11 0))) e-1))) (let ((u--rig (let ((e-2 (vector-ref arg-11 1))) e-2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact (vector 8 u--hole) (let ((e-32 (vector-ref e-5 0))) e-32)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-34 (vector-ref e-7 0))) e-34) '() arg-9 '()) eta-0))))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (CoreC-45AutoSearch-case--caseC-32blockC-32inC-32searchIfHole-1618 arg-0 e-0 arg-11 arg-10 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--hole u--rig e-5 e-1 _-0 (let ((e-17 (vector-ref e-1 17))) e-17) eta-0))))))))))))))))))))
(define CoreC-45AutoSearch-mkArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-clearDefs e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (let ((act-26 (CoreC-45UnifyState-genName arg-1 arg-2 "sa" clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-10 arg-5 e-9 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-27 1))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-4 e-7))) (let ((act-28 ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-2 e-6 u--argRig arg-5 e-11 e-12 (vector 7 (CoreC-45Env-length arg-5) (CoreC-45ContextC-45Context-holeInit 0)) 0) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-28 1))) (let ((e-15 (car e-13))) (let ((e-14 (cdr e-13))) (let ((act-29 (CoreC-45Unify-setInvertible arg-1 arg-3 (vector 8 e-15) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-16 (vector-ref act-29 1))) (vector 0 e-16))) (else (let ((act-30 (let ((act-30 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-5 e-14)) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-17 (vector-ref act-30 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-30 1))) ((CoreC-45AutoSearch-mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-17) clam-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-17 (vector-ref act-30 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-30 1))) (let ((e-19 (car e-17))) (let ((e-18 (cdr e-17))) (vector 1 (cons (cons (vector e-15 u--argRig e-8 e-14 e-12) e-19) e-18)))))))))))))))))))))))))))))))))))))))(else (vector 1 (cons '() arg-6)))))))(else (vector 1 (cons '() arg-6)))))))
(define CoreC-45AutoSearch-isPairNF (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (CoreC-45Context-isPairType arg-1 e-2 clam-0))) ((0) (let ((e-7 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (case (vector-ref e-9 0) ((2) (let ((act-24 (((e-10 arg-4) (CoreC-45NormaliseC-45Eval-toClosure (CoreC-45Value-defaultOpts) arg-2 (vector 10 e-7 0))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45AutoSearch-isPairNF arg-1 arg-2 e-5 arg-4) clam-0))))))(else (vector 1 0)))))))(else (vector 1 0))))))
(define CoreC-45AutoSearch-impLast (lambda (arg-1) (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-filter (lambda (eta-0) (let ((sc0 (CoreC-45AutoSearch-n--7691-1487-u--impl arg-1 eta-0))) (cond ((equal? sc0 1) 0) (else 1)))) arg-1) (DataC-45List-filter (lambda (eta-0) (CoreC-45AutoSearch-n--7691-1487-u--impl arg-1 eta-0)) arg-1))))
(define CoreC-45AutoSearch-getUsableEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (let ((u--rest (CoreC-45AutoSearch-getUsableEnv e-3 arg-2 arg-3 (CoreC-45TTC-45SizeOf-sucR arg-4) e-9))) (let ((sc2 (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega (CoreC-45TT-multiplicity e-8) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))) (cond ((equal? sc3 1) 1) (else (AlgebraC-45Semiring-isErased (csegen-475) arg-3)))))) (cond ((equal? sc2 1) (CoreC-45AutoSearch-case--caseC-32blockC-32inC-32getUsableEnv-2676 e-2 e-3 e-9 e-8 arg-4 arg-3 arg-2 u--rest (CoreC-45TT-weakenVar arg-4 0))) (else u--rest)))))))))))
(define CoreC-45AutoSearch-exactlyOne (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (let ((act-24 (CoreC-45AutoSearch-successful arg-0 arg-1 arg-2 arg-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45AutoSearch-case--exactlyOne-2459 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 (DataC-45Either-rights e-5)) clam-0))))) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (if (null? e-2) (CoreC-45Core-u--catch_Catchable_Core_Error e-1 (lambda (lcase-0) (lambda (clam-1) (case (vector-ref lcase-0 0) ((29) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-1))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-5 '()) clam-1))))))))) clam-0) (let ((act-24 (CoreC-45AutoSearch-successful arg-0 arg-1 arg-2 arg-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45AutoSearch-case--exactlyOne-2459 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 (DataC-45Either-rights e-5)) clam-0))))))))))))
(define CoreC-45AutoSearch-concreteDets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((sc1 (PreludeC-45Types-elem (csegen-792) arg-7 arg-8))) (cond ((equal? sc1 1) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45AutoSearch-n--11610-5017-u--concrete arg-0 e-2 e-3 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 1) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else ((CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-7) arg-8 e-3) eta-0)))))))))))))) (else (CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-7) arg-8 e-3)))))))))
(define CoreC-45AutoSearch-checkConcreteDets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((3) (let ((e-2 (vector-ref arg-7 2))) (let ((e-5 (vector-ref arg-7 5))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-isPairType arg-1 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (cond ((equal? e-7 1) (if (null? e-5) (let ((act-26 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) ((CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-8))) e-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) ext-0))))) (let ((e-9 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-9) (let ((act-26 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-10 (vector-ref act-26 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-26 1))) ((CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-10))) e-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) ext-0))))) (let ((e-10 (cdr e-9))) (if (null? e-8) (let ((act-26 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) ((CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-12))) e-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) ext-0))))) (let ((e-13 (car e-8))) (let ((e-12 (cdr e-8))) (if (null? e-13) (let ((act-26 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-14 (vector-ref act-26 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-26 1))) ((CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-14))) e-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) ext-0))))) (let ((e-14 (cdr e-13))) (if (null? e-12) (let ((act-26 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-6 e-10) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-6 e-14) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-17 (vector-ref act-27 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-27 1))) (let ((act-28 (CoreC-45AutoSearch-checkConcreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-18 (vector-ref act-28 1))) (vector 0 e-18))) (else (CoreC-45AutoSearch-checkConcreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-17 ext-0)))))))))))) (let ((act-26 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-16 (vector-ref act-26 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-26 1))) ((CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-16))) e-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) ext-0))))))))))))))))) (else (let ((act-26 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-46) e-2 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-1 "auto" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Determining arguments for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-9) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-775) (let ((e-0 (car e-8))) e-0)))))) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else ((CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-8))) e-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)) ext-0)))))))))))))))))))))(else (vector 1 0)))))
(define CoreC-45AutoSearch-anyOne (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-5 '()) clam-0))))) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-3) (CoreC-45Core-u--catch_Catchable_Core_Error e-2 (lambda (lcase-0) (lambda (clam-1) (case (vector-ref lcase-0 0) ((29) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-1))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-5 '()) clam-1))))))))) clam-0) (CoreC-45UnifyState-tryUnify arg-1 arg-2 e-2 (CoreC-45AutoSearch-anyOne arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) clam-0))))))))
(define CoreC-45AutoSearch-abandonIfCycle (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (vector 1 0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-1 arg-0 e-5 arg-2 arg-3 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Cycle in search") ext-0)) (else (CoreC-45AutoSearch-abandonIfCycle arg-0 arg-1 arg-2 arg-3 e-3 ext-0))))))))))))))))
(define CoreC-45InitPrimitives-addPrimitives (lambda (arg-0 ext-0) (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45InitPrimitives-addPrim arg-0 eta-0 eta-1))) (CoreC-45Primitives-allPrimitives) ext-0)))
(define CoreC-45InitPrimitives-addPrim (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-addBuiltin (let ((e-0 (vector-ref arg-1 0))) e-0) arg-0 (CoreC-45Primitives-opName (let ((e-1 (vector-ref arg-1 1))) e-1)) (let ((e-2 (vector-ref arg-1 2))) e-2) (let ((e-3 (vector-ref arg-1 3))) e-3) (let ((e-1 (vector-ref arg-1 1))) e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CompilerC-45CompileExpr-compileDef arg-0 (CoreC-45Primitives-opName (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))))))
(define LibrariesC-45UtilsC-45Term-setupTerm (lambda (ext-0) (LibrariesC-45UtilsC-45Term-prim__setupTerm ext-0)))
(define LibrariesC-45UtilsC-45Term-getTermCols (lambda (ext-0) (LibrariesC-45UtilsC-45Term-prim__getTermCols ext-0)))
(define SystemC-45FFI-free (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45FFI-prim__free arg-2 eta-0))))))
(define IdrisPaths-yprefix(blodwen-lazy (lambda () "__PREFIX__")))
(define IdrisPaths-idrisVersion(blodwen-lazy (lambda () (cons (cons 0 (cons (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (+ 1 0))) "bb4e3773b"))))
(define IdrisC-45Error-case--perror-7187 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 (IdrisC-45Error-pshow e-2 arg-8 arg-7 e-6 e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-6 arg-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't find an implementation for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-8))) (let ((act-26 (let ((act-26 (set-box! arg-8 arg-9))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (if (null? arg-1) (vector 1 u--res) (let ((e-4 (unbox arg-1))) (let ((act-27 ((IdrisC-45Error-perror arg-8 arg-7 arg-6 e-4) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Possible cause:") e-10))))))))))))))))))))))))))))
(define IdrisC-45Error-case--caseC-32blockC-32inC-32perrorC-44order-4870 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) (cons arg-9 (vector 2 )) (let ((e-1 (unbox arg-13))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-11 e-9))) (cond ((equal? sc3 1) (cons arg-9 arg-8)) (else (let ((sc4 (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-225) (csegen-225) arg-11 e-9))) (cond ((equal? sc5 1) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) arg-12 e-10)) (else 0))))) (cond ((equal? sc4 1) (cons arg-9 arg-8)) (else (cons arg-8 arg-9))))))))))))))
(define IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc2-3457 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (cond ((equal? e-2 1) (if (null? e-3) (lambda (clam-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))) (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (cond ((equal? e-10 1) (cond ((equal? e-11 1) (let ((u--line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0))) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int arg-14)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-9 arg-14)) #\^)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45Types-prim__integerToNat (- arg-15 arg-9))))) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-12 arg-15)) #\^))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (cons arg-19 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line (cons u--emph '()))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) '()))))))))))) ((equal? e-11 0) (let ((u--line1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0))) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int arg-14)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-9 arg-14)) #\^))))))) (let ((u--line2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0))) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-16))))) (let ((u--emph2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int arg-15)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-12 arg-15)) #\^))))))) (let ((u--numbered (let ((sc5 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45Types-prim__integerToNat (- arg-16 arg-10)) (PreludeC-45Types-u--fromInteger_Num_Nat 1)))) (cond ((equal? sc5 1) '()) (else (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0)) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0)) arg-10 arg-20)))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (cons arg-19 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line1 (cons u--emph1 '()))))) '())))) (PreludeC-45TypesC-45List-tailRecAppend u--numbered (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat (PreludeC-45Types-u--C-43_Num_Nat arg-16 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line2 (cons u--emph2 '()))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) '())))))))))))))(else (lambda (clam-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))))))) ((equal? e-10 0) (let ((u--line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0))) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int arg-14)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-9 arg-14)) #\^))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (cons arg-19 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line (cons u--emph '()))))) '())))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0)) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0)) (PreludeC-45Types-u--max_Ord_Nat arg-10 arg-11) arg-20))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) '())))))))))(else (lambda (clam-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))))))) ((equal? e-2 0) (if (null? e-3) (lambda (clam-5) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))) (let ((e-14 (car e-3))) (let ((e-15 (cdr e-3))) (cond ((equal? e-14 1) (cond ((equal? e-15 1) (let ((u--line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0))) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int arg-14)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-9 arg-14)) #\^))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (cons arg-19 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line (cons u--emph '()))))) '())))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0)) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0)) (PreludeC-45Types-u--max_Ord_Nat arg-10 arg-11) arg-20))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) '()))))))))) ((equal? e-15 0) (let ((u--top (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0)) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (+ 1 0)) arg-10 arg-20))))) (let ((u--line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0))) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int arg-15)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-12 arg-15)) #\^))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (cons arg-19 '()))) (PreludeC-45TypesC-45List-tailRecAppend u--top (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat (PreludeC-45Types-u--C-43_Num_Nat arg-16 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line (cons u--emph '()))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) '())))))))))))(else (lambda (clam-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))))(else (lambda (clam-4) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))))))))))(else (lambda (clam-6) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons arg-18 (IdrisC-45Error-n--11228-2938-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) (IdrisC-45Error-n--11228-2936-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))))))))))
(define IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc2-3235 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((sc1 (PreludeC-45Types-u--C-62_Ord_Nat e-2 (PreludeC-45Types-u--C-43_Num_Nat arg-13 (PreludeC-45Types-u--fromInteger_Num_Nat 5))))) (cond ((equal? sc1 1) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 (vector 0 arg-3 arg-4 arg-5)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 (vector 0 arg-6 arg-7 arg-8)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))) (else (let ((u--nsize (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-u--C-43_Num_Nat e-2 (+ 1 0)))))) (let ((u--head (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (CoreC-45FC-u--pretty_Pretty_FC (vector 0 arg-3 arg-4 arg-8))))) (let ((u--firstRow (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45Types-u--C-43_Num_Nat u--nsize (+ 1 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe))))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-2501) (lambda (eta-1) (IdrisC-45REPLC-45Opts-getCurrentElabSource arg-2 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc2-3457 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-14 arg-13 e-2 e-3 arg-9 arg-10 arg-11 arg-12 u--nsize u--head u--firstRow e-5 (cons (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-9 arg-13) (cons (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-12 e-2) (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-9 arg-12)))) eta-0))))))))))))))))
(define IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc-2715 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((u--nsize (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-u--C-43_Num_Nat e-2 (+ 1 0)))))) (let ((u--head (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (CoreC-45FC-u--pretty_Pretty_FC arg-0)))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-2501) (lambda (eta-1) (IdrisC-45REPLC-45Opts-getCurrentElabSource arg-1 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-5 e-2))) (cond ((equal? sc2 1) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--C-43_Num_Nat u--nsize arg-6) (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- e-3 arg-6)) #\^)))))) (let ((u--firstr (PreludeC-45Types-prim__integerToNat (- e-2 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons u--head '())) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Error-n--10823-2559-u--addLineNumbers arg-0 arg-1 u--nsize u--firstr (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) (IdrisC-45Error-n--10823-2557-u--extractRange arg-0 arg-1 u--firstr e-2 e-5))) (cons u--emph '())))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))) (else (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (cons u--head (IdrisC-45Error-n--10823-2559-u--addLineNumbers arg-0 arg-1 u--nsize arg-5 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) (IdrisC-45Error-n--10823-2557-u--extractRange arg-0 arg-1 arg-5 (PreludeC-45Types-u--min_Ord_Nat e-2 (PreludeC-45Types-u--C-43_Num_Nat arg-5 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) e-5)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))))))))))))))
(define IdrisC-45Error-case--ploc-2647 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))) (let ((e-1 (unbox arg-2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-2 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-2) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-2 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-2 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-2 (arg-417 e-3)))))))))) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat (PreludeC-45Cast-u--cast_Cast_Int_Integer eta-0))) e-9))) (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc-2715 arg-0 arg-1 e-5 e-9 e-10 e-2 e-3 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-7 (car arg-409))) (let ((e-4 (cdr arg-409))) (cons (arg-405 e-7) (arg-407 e-4))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-7 (car arg-416))) (let ((e-4 (cdr arg-416))) (cons (arg-414 e-7) e-4)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-7 (car arg-419))) (let ((e-4 (cdr arg-419))) (cons e-7 (arg-417 e-4)))))))))) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat (PreludeC-45Cast-u--cast_Cast_Int_Integer eta-0))) e-10)))))))))))))
(define IdrisC-45Error-n--13056-6972-u--tshow (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((act-24 (IdrisC-45Error-pshow arg-7 arg-6 arg-5 arg-8 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-code e-5))))))))))))
(define IdrisC-45Error-n--12900-4552-u--pshadowing (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-2) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is shadowing") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) (DataC-45List1-forget e-3)))))))))))
(define IdrisC-45Error-n--13056-4818-u--prettyVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((3) (let ((e-0 (vector-ref arg-8 1))) (IdrisC-45Error-n--13056-4818-u--prettyVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-0)))(else (CoreC-45Name-u--pretty_Pretty_Name arg-8)))))
(define IdrisC-45Error-n--13056-6023-u--prettyRig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "irrelevant") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "linear") (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "unrestricted")) ext-0)))
(define IdrisC-45Error-n--13056-6024-u--prettyRel (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "irrelevant") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "relevant") (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "non-linear")) ext-0)))
(define IdrisC-45Error-n--13056-7400-u--prettyHoles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 ((IdrisC-45Error-ploc arg-1 e-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-n--13056-7400-u--prettyHoles arg-0 arg-1 arg-2 arg-3 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-meta (CoreC-45Name-u--pretty_Pretty_Name e-7)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "introduced at:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 e-8))))))))))))))))))))
(define IdrisC-45Error-n--13056-8359-u--prettyErrors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))) (cond ((equal? arg-5 0) (lambda (eta-0) (vector 1 (IdrisC-45Pretty-meta (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (PreludeC-45TypesC-45String-C-43C-43 "... (" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-6)) " others)")))))))(else (let ((e-0 (- arg-5 1))) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--idx (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-prim__integerToNat (- arg-4 e-0))))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-1 e-6) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-n--13056-8359-u--prettyErrors arg-0 arg-1 arg-2 arg-3 arg-4 e-0 e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-warning (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (PreludeC-45TypesC-45String-C-43C-43 u--idx (PreludeC-45TypesC-45String-C-43C-43 ": " e-7)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5) e-8))))))))))))))))))))))
(define IdrisC-45Error-n--11228-2937-u--pad (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-3 (PreludeC-45TypesC-45String-length arg-4))) #\0) arg-4)))
(define IdrisC-45Error-n--10823-2558-u--pad (lambda (arg-0 arg-1 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45StringC-45Extra-replicate (PreludeC-45Types-prim__integerToNat (- arg-2 (PreludeC-45TypesC-45String-length arg-3))) #\0) arg-3)))
(define IdrisC-45Error-n--13056-6516-u--pAlterror (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (let ((act-24 ((IdrisC-45Error-perror arg-3 arg-2 arg-1 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Possible error") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 e-5))))))) (let ((e-5 (unbox e-2))) (let ((act-24 (CoreC-45Context-getFullName arg-3 e-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-aliasName arg-3 e-6 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Error-perror arg-3 arg-2 arg-1 e-3) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "If") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-7)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) e-8))))))))))))))))))))))
(define IdrisC-45Error-n--13056-4819-u--order (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((sc0 (CoreC-45FC-isNonEmptyFC arg-8))) (if (null? sc0) (cons (vector 2 ) arg-9) (let ((e-1 (unbox sc0))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (IdrisC-45Error-case--caseC-32blockC-32inC-32perrorC-44order-4870 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-8 e-5 e-9 e-10 (CoreC-45FC-isNonEmptyFC arg-9)))))))))))
(define IdrisC-45Error-n--13056-8360-u--listErrors (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-39 (vector-ref e-4 2))) (let ((e-48 (vector-ref e-39 17))) e-48)))))))) (lambda (eta-0) (let ((act-24 (unbox arg-3))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45Error-n--13056-8359-u--prettyErrors arg-0 arg-1 arg-2 arg-3 e-5 e-5 (DataC-45List-nub (cons (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2506) (csegen-17) arg-4 arg-5))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2506) (csegen-17) arg-4 arg-5)))) (PreludeC-45TypesC-45List-reverse (DataC-45List1-forget arg-0)))) ext-0)))))))
(define IdrisC-45Error-n--11228-2936-u--extractRange (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (DataC-45List-take (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-prim__integerToNat (- arg-4 arg-3)) (+ 1 0)) (DataC-45List-drop arg-3 arg-5))))
(define IdrisC-45Error-n--10823-2557-u--extractRange (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (DataC-45List-take (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-prim__integerToNat (- arg-3 arg-2)) (+ 1 0)) (DataC-45List-drop arg-2 arg-4))))
(define IdrisC-45Error-n--13056-7104-u--dropEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((3) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (case (vector-ref e-3 0) ((2) (IdrisC-45Error-n--13056-7104-u--dropEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-2 arg-9) (cons e-3 arg-10) e-4)) ((1) (IdrisC-45Error-n--13056-7104-u--dropEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-2 arg-9) (cons e-3 arg-10) e-4))(else (cons arg-9 (cons arg-10 arg-11))))))))(else (cons arg-9 (cons arg-10 arg-11))))))
(define IdrisC-45Error-n--13056-6517-u--allUndefined (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) '() (let ((e-7 (cdr e-2))) (case (vector-ref e-7 0) ((7) (if (null? e-3) (box e-7) (IdrisC-45Error-n--13056-6517-u--allUndefined arg-0 arg-1 arg-2 arg-3 e-3)))(else '())))))))))
(define IdrisC-45Error-n--11228-2938-u--addLineNumbers (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (Builtin-snd (PreludeC-45Types-u--foldl_Foldable_List (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (+ 1 e-2) (DataC-45List-snoc e-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Error-n--11228-2937-u--pad arg-0 arg-1 arg-2 arg-3 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-u--C-43_Num_Nat e-2 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)))) clam-0))))))) (cons arg-4 '()) arg-5))))
(define IdrisC-45Error-n--10823-2559-u--addLineNumbers (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (Builtin-snd (PreludeC-45Types-u--foldl_Foldable_List (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (+ 1 e-2) (DataC-45List-snoc e-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Error-n--10823-2558-u--pad arg-0 arg-1 arg-2 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-u--C-43_Num_Nat e-2 (+ 1 0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)))) clam-0))))))) (cons arg-3 '()) arg-4))))
(define IdrisC-45Error-pwarning (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-0 (vector-ref arg-3 1))) (let ((e-1 (vector-ref arg-3 2))) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5))))))))) ((1) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-24 (IdrisC-45Error-pshow e-2 arg-0 arg-1 e-4 e-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Unreachable clause:") (IdrisC-45Pretty-code e-6))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-7))))))))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (DataC-45List-snoc (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "We are about to implicitly bind the following lowercase names.") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "You may be unintentionally shadowing the associated global definitions:") (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Error-n--12900-4552-u--pshadowing e-7 e-6 arg-2 arg-1 arg-0 eta-0)) (DataC-45List1-forget e-7)))) e-5)))))))))) ((3) (let ((e-8 (vector-ref arg-3 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Deprecation warning:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-8))))) (else (let ((e-9 (vector-ref arg-3 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-9)))))))
(define IdrisC-45Error-pshowNoNorm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (IdrisC-45Error-pShowMN arg-0 arg-4 arg-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 6 eta-0)) (IdrisC-45Pretty-prettyTerm e-6)))))))))))))
(define IdrisC-45Error-pshow (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-5 arg-3 arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-3 e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (IdrisC-45Error-pShowMN arg-0 e-6 arg-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 6 eta-0)) (IdrisC-45Pretty-prettyTerm e-7))))))))))))))))))
(define IdrisC-45Error-ploc2 (lambda (arg-0 arg-1 arg-2) (let ((sc0 (CoreC-45FC-isNonEmptyFC arg-1))) (if (null? sc0) (IdrisC-45Error-ploc arg-0 arg-2) (let ((e-1 (unbox sc0))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (CoreC-45FC-isNonEmptyFC arg-2))) (if (null? sc3) (IdrisC-45Error-ploc arg-0 arg-1) (let ((e-2 (unbox sc3))) (let ((e-8 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-12 (car e-7))) (let ((e-11 (cdr e-7))) (let ((sc6 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-4 (car arg-409))) (let ((e-3 (cdr arg-409))) (cons (arg-405 e-4) (arg-407 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-4 (car arg-416))) (let ((e-3 (cdr arg-416))) (cons (arg-414 e-4) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-4 (car arg-419))) (let ((e-3 (cdr arg-419))) (cons e-4 (arg-417 e-3)))))))))) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat (PreludeC-45Cast-u--cast_Cast_Int_Integer eta-0))) e-9))) (let ((e-4 (car sc6))) (let ((e-3 (cdr sc6))) (let ((sc7 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-14 (car arg-409))) (let ((e-13 (cdr arg-409))) (cons (arg-405 e-14) (arg-407 e-13))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-14 (car arg-416))) (let ((e-13 (cdr arg-416))) (cons (arg-414 e-14) e-13)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-14 (car arg-419))) (let ((e-13 (cdr arg-419))) (cons e-14 (arg-417 e-13)))))))))) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat (PreludeC-45Cast-u--cast_Cast_Int_Integer eta-0))) e-12))) (let ((e-14 (car sc7))) (let ((e-13 (cdr sc7))) (let ((sc8 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-16 (car arg-409))) (let ((e-15 (cdr arg-409))) (cons (arg-405 e-16) (arg-407 e-15))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-16 (car arg-416))) (let ((e-15 (cdr arg-416))) (cons (arg-414 e-16) e-15)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-16 (car arg-419))) (let ((e-15 (cdr arg-419))) (cons e-16 (arg-417 e-15)))))))))) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat (PreludeC-45Cast-u--cast_Cast_Int_Integer eta-0))) e-10))) (let ((e-16 (car sc8))) (let ((e-15 (cdr sc8))) (IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc2-3235 arg-2 arg-1 arg-0 e-5 e-9 e-10 e-8 e-12 e-11 e-4 e-3 e-13 e-14 e-16 e-15 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-405) (lambda (arg-407) (lambda (arg-409) (let ((e-18 (car arg-409))) (let ((e-17 (cdr arg-409))) (cons (arg-405 e-18) (arg-407 e-17))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-414) (lambda (arg-416) (let ((e-18 (car arg-416))) (let ((e-17 (cdr arg-416))) (cons (arg-414 e-18) e-17)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-417) (lambda (arg-419) (let ((e-18 (car arg-419))) (let ((e-17 (cdr arg-419))) (cons e-18 (arg-417 e-17)))))))))) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat (PreludeC-45Cast-u--cast_Cast_Int_Integer eta-0))) e-11)))))))))))))))))))))))))))
(define IdrisC-45Error-ploc (lambda (arg-0 arg-1) (IdrisC-45Error-case--ploc-2647 arg-1 arg-0 (CoreC-45FC-isNonEmptyFC arg-1))))
(define IdrisC-45Error-perror (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-0 (vector-ref arg-3 1))) (IdrisC-45Error-perror arg-0 arg-1 arg-2 e-0))) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setCtxt arg-0 e-3 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((act-26 (IdrisC-45Error-pshow e-1 arg-0 arg-1 e-4 e-5 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45Error-pshow e-1 arg-0 arg-1 e-4 e-6 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 ((IdrisC-45Error-ploc arg-2 e-2) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Mismatch between") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (cons (IdrisC-45Pretty-code e-9) (cons (csegen-2510) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) '())))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-11))) (let ((act-29 (let ((act-29 (set-box! arg-0 e-7))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-12 (vector-ref act-29 1))) (vector 0 e-12))) (else (vector 1 u--res)))))))))))))))))))))))))))))))) ((2) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (let ((e-11 (vector-ref arg-3 5))) (let ((e-12 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setCtxt arg-0 e-9 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (IdrisC-45Error-pshow e-7 arg-0 arg-1 e-10 e-11 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45Error-pshow e-7 arg-0 arg-1 e-10 e-12 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-27 1))) (let ((act-28 ((IdrisC-45Error-ploc arg-2 e-8) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-28 1))) (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't solve constraint between") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (cons (IdrisC-45Pretty-code e-13) (cons (csegen-2510) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-14) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) '())))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-15))) (let ((act-29 (let ((act-29 (set-box! arg-0 e-5))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 u--res)))))))))))))))))))))))))))))))) ((3) (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (let ((e-17 (vector-ref arg-3 5))) (lambda (clam-0) (let ((sc1 (IdrisC-45Error-n--13056-4819-u--order e-13 e-17 e-16 e-15 e-14 arg-2 arg-1 arg-0 e-14 (CoreC-45TT-getLoc e-17)))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-24 (IdrisC-45Error-pshow e-13 arg-0 arg-1 e-15 e-17 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc2 arg-2 e-2 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Pattern variable") (cons (IdrisC-45Pretty-code (IdrisC-45Error-n--13056-4818-u--prettyVar e-13 e-17 e-16 e-15 e-14 arg-2 arg-1 arg-0 e-16)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "unifies with") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) '())))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: Use the same name for both pattern variables, since they unify."))))))))))))))))))))) ((4) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (let ((e-21 (vector-ref arg-3 4))) (let ((e-22 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Error-pshow e-18 arg-0 arg-1 e-20 e-22 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Error-ploc arg-2 e-19) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Cycle detected in solution of metavariable") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-meta (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (IdrisC-45Pretty-code e-6))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-7))))))))))))))))))))) ((5) (let ((e-23 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (let ((e-28 (vector-ref arg-3 6))) (let ((e-29 (vector-ref arg-3 7))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setCtxt arg-0 e-25 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (IdrisC-45Error-pshow e-23 arg-0 arg-1 e-26 e-27 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45Error-pshow e-23 arg-0 arg-1 e-26 e-28 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((IdrisC-45Error-perror arg-0 arg-1 arg-2 e-29) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "When unifying:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "    ")) (IdrisC-45Pretty-code e-7)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "and:")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "    ")) (IdrisC-45Pretty-code e-8))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-9))) (let ((act-29 (let ((act-29 (set-box! arg-0 e-5))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 u--res)))))))))))))))))))))))))))))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (lambda (clam-1) (case (vector-ref e-33 0) ((0) (let ((e-212 (vector-ref e-33 1))) (let ((act-24 (IdrisC-45Error-pshow e-30 arg-0 arg-1 e-32 e-212 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-31) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a valid impossible case."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))) (else (let ((e-215 (vector-ref e-33 1))) (let ((act-24 ((IdrisC-45Error-perror arg-0 arg-1 arg-2 e-215) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Impossible pattern gives an error") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5))))))))))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-34) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Undefined name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-35)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))))))))) ((8) (let ((e-36 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (let ((e-38 (vector-ref arg-3 3))) (lambda (clam-2) (if (null? e-38) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-36) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-37)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is private.")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: add an explicit")) (csegen-2519))))))) (let ((e-217 (unbox e-38))) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-36) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-37)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is inaccessible since") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace e-217)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not explicitly imported.")))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: add an explicit")) (csegen-2519)))))))))))))) ((9) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-39) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Return type of") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-40)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "must be") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc2 (DataC-45String-isSuffixOf "\xa;" "Type"))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Type")) (else "Type")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((10) (let ((e-41 (vector-ref arg-3 1))) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-43 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-41) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Return type of") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-42)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "must be in") (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-5)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6)))))))))))))))) ((11) (let ((e-44 (vector-ref arg-3 1))) (let ((e-45 (vector-ref arg-3 2))) (let ((e-46 (vector-ref arg-3 3))) (lambda (clam-3) (case (vector-ref e-46 0) ((0) (vector 1 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Internal error") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Coverage of") (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-45)))))))) ((1) (let ((e-219 (vector-ref e-46 1))) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-45) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-44) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Error-pshow '() arg-0 arg-1 '() eta-0 eta-1))) e-219 '() clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not covering."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Missing cases")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))))))))))))))))) (else (let ((e-220 (vector-ref e-46 1))) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-45) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-44) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not covering."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Calls non covering function")) (if (null? e-220) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\s) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) e-220))) (let ((e-1 (car e-220))) (let ((e-2 (cdr e-220))) (if (null? e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (CoreC-45Name-u--pretty_Pretty_Name e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\s) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Name eta-0)) e-220))))))))))))))))))))))))) ((12) (let ((e-47 (vector-ref arg-3 1))) (let ((e-48 (vector-ref arg-3 2))) (let ((e-49 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-48) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-47) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not total,") (CoreC-45TT-u--pretty_Pretty_PartialReason e-49)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))))))))))))))) ((13) (let ((e-50 (vector-ref arg-3 1))) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-50) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "There are") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat e-51) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "uses of linear name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Resugar-sugarName e-52))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: linearly bounded variables must be used exactly once."))))))))))))) ((14) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (let ((e-55 (vector-ref arg-3 3))) (let ((e-56 (vector-ref arg-3 4))) (lambda (clam-4) (let ((sc1 (AlgebraC-45Semiring-isErased (csegen-475) e-55))) (cond ((equal? sc1 1) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-53) clam-4))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-54)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not accessible in this context."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5))))))) (else (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-53) clam-4))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Trying to use") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-n--13056-6023-u--prettyRig e-56 e-55 e-54 e-53 arg-2 arg-1 arg-0 e-55) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Resugar-sugarName e-54))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-n--13056-6024-u--prettyRel e-56 e-55 e-54 e-53 arg-2 arg-1 arg-0 e-56) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "context.")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5))))))))))))))) ((15) (let ((e-57 (vector-ref arg-3 1))) (let ((e-58 (vector-ref arg-3 2))) (let ((e-59 (vector-ref arg-3 3))) (let ((e-60 (vector-ref arg-3 4))) (let ((e-61 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-57 arg-0 arg-1 e-59 e-60 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Error-pshow e-57 arg-0 arg-1 e-59 e-61 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Error-ploc arg-2 e-58) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "borrows argument") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "so must be fully applied."))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-7))))))))))))))))))))) ((16) (let ((e-62 (vector-ref arg-3 1))) (let ((e-63 (vector-ref arg-3 2))) (let ((e-64 (vector-ref arg-3 3))) (let ((e-65 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-62 arg-0 arg-1 e-64 e-65 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-63) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "borrows, so must return a concrete type."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))))))) ((17) (let ((e-66 (vector-ref arg-3 1))) (let ((e-67 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-66) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Ambiguous name") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_C-40ListC-32C-36aC-41 (csegen-2549) e-67)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((18) (let ((e-68 (vector-ref arg-3 1))) (let ((e-69 (vector-ref arg-3 2))) (let ((e-70 (vector-ref arg-3 3))) (let ((e-71 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (vector e-0 e-1 1))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Error-pshow e-68 arg-0 arg-1 e-70 eta-1 eta-2))) e-71 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((IdrisC-45Error-ploc arg-2 e-69) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Ambiguous elaboration. Possible results") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7)) '()))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-8))) (let ((act-28 (CoreC-45Context-setPPrint arg-0 e-5 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 u--res)))))))))))))))))))))))))) ((19) (let ((e-72 (vector-ref arg-3 1))) (let ((e-73 (vector-ref arg-3 2))) (let ((e-74 (vector-ref arg-3 3))) (let ((e-75 (vector-ref arg-3 4))) (let ((e-76 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshowNoNorm e-72 arg-0 arg-1 e-74 e-75 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-73) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Error-pshowNoNorm e-72 arg-0 arg-1 e-74 eta-1 eta-2))) e-76 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Multiple solutions found in search of") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 e-5) (cons e-6 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Possible correct results") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7)) '())))))))))))))))))))))))))) ((20) (let ((e-77 (vector-ref arg-3 1))) (let ((e-78 (vector-ref arg-3 2))) (let ((e-79 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 e-78 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-getFullName arg-0 eta-1 eta-2))) e-79 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Error-ploc arg-2 e-77) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Maximum ambiguity depth exceeded in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (eta-1) (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String " --> ") eta-1 eta-2))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (CoreC-45Name-u--pretty_Pretty_Name eta-1)) e-6))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: the default ambiguity depth limit is 3, the")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc4 (DataC-45String-isSuffixOf "\xa;" "%ambiguity_depth"))) (cond ((equal? sc4 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "%ambiguity_depth")) (else "%ambiguity_depth")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "pragma can be used to extend this limit, but beware compilation times can be severely impacted.")))))))))))))))))))))) ((21) (let ((e-80 (vector-ref arg-3 1))) (let ((sc1 (IdrisC-45Error-n--13056-6517-u--allUndefined e-80 arg-2 arg-1 arg-0 e-80))) (if (null? sc1) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Error-n--13056-6516-u--pAlterror e-80 arg-2 arg-1 arg-0 eta-1)) e-80 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Sorry, I can't find any elaboration which works. All errors") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-5)))))))) (let ((e-1 (unbox sc1))) (IdrisC-45Error-perror arg-0 arg-1 arg-2 e-1)))))) ((22) (let ((e-82 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-82) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't infer type for this record update.")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5))))))))) ((23) (let ((e-84 (vector-ref arg-3 1))) (let ((e-85 (vector-ref arg-3 2))) (let ((e-86 (vector-ref arg-3 3))) (lambda (clam-5) (if (null? e-86) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-84) clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-85)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not part of a record type."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))) (let ((e-223 (unbox e-86))) (let ((act-24 (CoreC-45Context-getFullName arg-0 e-223 clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-84) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Record type") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "has no field") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-85)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))))))))))))))))) ((24) (let ((e-87 (vector-ref arg-3 1))) (let ((e-88 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 e-88 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-87) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a record type."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))))) ((25) (let ((e-89 (vector-ref arg-3 1))) (let ((e-90 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-89) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Field update") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (eta-1) (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "->") eta-1 eta-2))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) e-90)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not compatible with other updates at") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))))) ((26) (let ((e-91 (vector-ref arg-3 1))) (let ((e-92 (vector-ref arg-3 2))) (let ((e-93 (vector-ref arg-3 3))) (let ((e-94 (vector-ref arg-3 4))) (let ((e-95 (vector-ref arg-3 5))) (lambda (clam-0) (if (null? e-94) (let ((act-24 (IdrisC-45Error-pshow e-91 arg-0 arg-1 e-93 e-95 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-92) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name eta-0))) e-94)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "are not valid arguments in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))) (let ((e-225 (car e-94))) (let ((e-226 (cdr e-94))) (if (null? e-226) (let ((act-24 (IdrisC-45Error-pshow e-91 arg-0 arg-1 e-93 e-95 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-92) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-225)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a valid argument in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))) (let ((act-24 (IdrisC-45Error-pshow e-91 arg-0 arg-1 e-93 e-95 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-92) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name eta-0))) e-94)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "are not valid arguments in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))))))))))))))))))))) ((27) (let ((e-96 (vector-ref arg-3 1))) (let ((e-97 (vector-ref arg-3 2))) (let ((e-98 (vector-ref arg-3 3))) (let ((e-99 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Error-n--13056-6972-u--tshow e-96 e-99 e-98 e-97 arg-2 arg-1 arg-0 e-96 e-98 eta-1 eta-2))) e-99 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-97) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Need to bind implicits") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))))))) ((28) (let ((e-100 (vector-ref arg-3 1))) (let ((e-101 (vector-ref arg-3 2))) (let ((e-102 (vector-ref arg-3 3))) (let ((e-103 (vector-ref arg-3 4))) (let ((e-104 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-100 arg-0 arg-1 e-102 e-104 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-101) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't bind name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Name-nameRoot e-103))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with type") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: try an explicit bind.")))))))))))))))))) ((29) (let ((e-105 (vector-ref arg-3 1))) (let ((e-106 (vector-ref arg-3 2))) (let ((e-107 (vector-ref arg-3 3))) (let ((e-108 (vector-ref arg-3 4))) (let ((e-109 (vector-ref arg-3 5))) (let ((e-110 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setCtxt arg-0 e-107 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((IdrisC-45Error-case--perror-7187 e-105 e-110 e-109 e-108 e-107 e-106 arg-2 arg-1 arg-0 e-5 (IdrisC-45Error-n--13056-7104-u--dropEnv e-105 e-110 e-109 e-108 e-107 e-106 arg-2 arg-1 arg-0 e-105 e-108 e-109)) eta-0)))))))))))))))) ((30) (let ((e-111 (vector-ref arg-3 1))) (let ((e-112 (vector-ref arg-3 2))) (let ((e-113 (vector-ref arg-3 3))) (let ((e-115 (vector-ref arg-3 5))) (let ((e-116 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-111 arg-0 arg-1 e-115 e-116 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-112) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't find an implementation for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "since I can't infer a value for argument")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-113)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))))))))))))))))) ((31) (let ((e-117 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-n--13056-7400-u--prettyHoles e-117 arg-2 arg-1 arg-0 e-117) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Unsolved holes") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5))))))))) ((32) (let ((e-118 (vector-ref arg-3 1))) (let ((e-119 (vector-ref arg-3 2))) (let ((e-120 (vector-ref arg-3 3))) (let ((e-121 (vector-ref arg-3 4))) (let ((e-122 (vector-ref arg-3 5))) (let ((e-123 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-118 arg-0 arg-1 e-120 e-123 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-119) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't infer type for argument") (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-121)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc3 (DataC-45String-isSuffixOf "\xa;" "Got"))) (cond ((equal? sc3 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Got")) (else "Got")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with hole") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-meta (CoreC-45Name-u--pretty_Pretty_Name e-122)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))))))))))))))))))))) ((33) (let ((e-124 (vector-ref arg-3 1))) (let ((e-125 (vector-ref arg-3 2))) (let ((e-126 (vector-ref arg-3 3))) (let ((e-127 (vector-ref arg-3 4))) (let ((e-128 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-124 arg-0 arg-1 e-126 e-128 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-125) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Named hole") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-meta (CoreC-45Name-u--pretty_Pretty_Name e-127)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "has been solved by unification.")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc3 (DataC-45String-isSuffixOf "\xa;" "Result"))) (cond ((equal? sc3 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Result")) (else "Result")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))))))))) ((34) (let ((e-129 (vector-ref arg-3 1))) (let ((e-130 (vector-ref arg-3 2))) (let ((e-131 (vector-ref arg-3 3))) (let ((e-132 (vector-ref arg-3 4))) (let ((e-133 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-131 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-133 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Error-ploc arg-2 e-129) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (CoreC-45TT-u--pretty_Pretty_Visibility e-130)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Resugar-sugarName e-5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "cannot refer to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (CoreC-45TT-u--pretty_Pretty_Visibility e-132)) (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Resugar-sugarName e-6)))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-7))))))))))))))))))))) ((35) (let ((e-134 (vector-ref arg-3 1))) (let ((e-135 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-134) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Non linear pattern") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Resugar-sugarName e-135))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((36) (let ((e-136 (vector-ref arg-3 1))) (let ((e-137 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-136) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Pattern not allowed here") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-137)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((37) (let ((e-138 (vector-ref arg-3 1))) (let ((e-139 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-138) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No type declaration for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-139)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((38) (let ((e-140 (vector-ref arg-3 1))) (let ((e-141 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-140) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-141)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is already defined."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((39) (let ((e-142 (vector-ref arg-3 1))) (let ((e-143 (vector-ref arg-3 2))) (let ((e-144 (vector-ref arg-3 3))) (let ((e-145 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-142 arg-0 arg-1 e-144 e-145 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-143) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a function type."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))))))) ((40) (let ((e-146 (vector-ref arg-3 1))) (let ((e-147 (vector-ref arg-3 2))) (let ((e-148 (vector-ref arg-3 3))) (let ((e-149 (vector-ref arg-3 4))) (let ((e-150 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-146 arg-0 arg-1 e-148 e-149 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Error-pshow e-146 arg-0 arg-1 e-148 e-150 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Error-ploc arg-2 e-147) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Rewriting by") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "did not change type") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-7))))))))))))))))))))) ((41) (let ((e-151 (vector-ref arg-3 1))) (let ((e-152 (vector-ref arg-3 2))) (let ((e-153 (vector-ref arg-3 3))) (let ((e-154 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-151 arg-0 arg-1 e-153 e-154 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-152) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a rewrite rule type."))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))))))) ((42) (let ((e-155 (vector-ref arg-3 1))) (let ((e-156 (vector-ref arg-3 2))) (let ((e-157 (vector-ref arg-3 3))) (case (vector-ref e-157 0) ((0) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-156) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-155) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Patterns for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "have differing numbers of arguments.")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))) ((1) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-156) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-155) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Patterns for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "require matching on different types.")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))) ((4) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-156) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-155) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't infer type to match in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))) ((3) (let ((e-228 (vector-ref e-157 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) e-228 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-155) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Constructor") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not fully applied.")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))))))))))))) (else (let ((e-229 (vector-ref e-157 1))) (lambda (clam-1) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (let ((e-236 (car e-233))) (let ((e-237 (cdr e-233))) (let ((act-24 (IdrisC-45Error-pshow e-232 arg-0 arg-1 e-236 e-237 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-prettyName arg-0 e-156) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Error-ploc arg-2 e-155) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Attempt to match on erased argument") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-6)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-7)))))))))))))))))))))))))) ((44) (let ((e-158 (vector-ref arg-3 1))) (let ((e-159 (vector-ref arg-3 2))) (let ((e-160 (vector-ref arg-3 3))) (let ((e-161 (vector-ref arg-3 4))) (let ((e-162 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-158 arg-0 arg-1 e-160 e-162 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-159) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't match on") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (CoreC-45Core-u--pretty_Pretty_DotReason e-161)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))))))))))))))))) ((43) (let ((e-164 (vector-ref arg-3 1))) (let ((e-165 (vector-ref arg-3 2))) (let ((e-166 (vector-ref arg-3 3))) (let ((e-167 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-164 arg-0 arg-1 e-166 e-167 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-165) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't match on") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "as it must have a polymorphic type.")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6)))))))))))))))) ((45) (let ((e-168 (vector-ref arg-3 1))) (let ((e-169 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-168) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't infer type for unbound implicit name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-169)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: try making it a bound implicit."))))))))))) ((46) (let ((e-170 (vector-ref arg-3 1))) (let ((e-171 (vector-ref arg-3 2))) (let ((e-172 (vector-ref arg-3 3))) (let ((e-173 (vector-ref arg-3 4))) (let ((e-174 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-pshow e-170 arg-0 arg-1 e-172 e-173 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-171) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Bad elaborator script") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-174)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))))))))))))))))) ((47) (let ((e-175 (vector-ref arg-3 1))) (let ((e-176 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-175) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-176) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((48) (let ((e-177 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error in TTC file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Core-u--show_Show_TTCErrorMsg e-177)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "the most likely case is that the ./build directory in your current project contains files from a previous build of idris2 or the idris2 executable is from a different build than the installed .ttc files"))))))) ((49) (let ((e-178 (vector-ref arg-3 1))) (let ((e-179 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "File error in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-178) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (SystemC-45FileC-45Error-u--show_Show_FileError e-179)))))))) ((50) (let ((e-180 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't find package ") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-180))))))) ((51) (let ((e-181 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-181) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't parse literate.")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5))))))))) ((52) (let ((e-182 (vector-ref arg-3 1))) (let ((e-183 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-182) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-183)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((53) (let ((e-184 (vector-ref arg-3 1))) (if (null? e-184) (lambda (eta-0) (let ((act-24 (IdrisC-45Error-n--13056-8360-u--listErrors e-184 arg-2 arg-1 arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (csegen-2583) e-5))))))) (let ((e-239 (car e-184))) (let ((e-240 (cdr e-184))) (lambda (clam-2) (if (null? e-239) (let ((act-24 (IdrisC-45Error-n--13056-8360-u--listErrors e-184 arg-2 arg-1 arg-0 clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (csegen-2583) e-5)))))) (let ((e-243 (car e-239))) (let ((e-244 (cdr e-239))) (if (null? e-240) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-243) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-244)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))) (let ((act-24 (IdrisC-45Error-n--13056-8360-u--listErrors e-184 arg-2 arg-1 arg-0 clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (csegen-2583) e-5)))))))))))))))) ((54) (let ((e-185 (vector-ref arg-3 1))) (let ((e-186 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-185) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Module") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (CoreC-45NameC-45Namespace-u--pretty_Pretty_ModuleIdent e-186)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not found")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((55) (let ((e-187 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Module imports form a cycle") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-545) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (CoreC-45NameC-45Namespace-u--pretty_Pretty_ModuleIdent eta-1)) e-187))))))) ((56) (lambda (eta-0) (vector 1 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Internal error when resolving implicit laziness"))))) ((57) (let ((e-188 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "INTERNAL ERROR") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-188)))))) ((58) (let ((e-189 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Error") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-189)))))) ((59) (let ((e-190 (vector-ref arg-3 1))) (let ((e-191 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--cgs (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (Builtin-fst eta-1)) (CoreC-45Options-availableCGs (let ((e-4 (vector-ref e-5 4))) e-4))))) (let ((act-25 ((IdrisC-45Error-ploc arg-2 e-190) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow (PreludeC-45TypesC-45String-C-43C-43 "The given specifier '" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) e-191) "' was not accepted by any backend. Available backends"))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ", ")) u--y))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow eta-1)) u--cgs))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Some backends have additional specifier rules, refer to their documentation.") '())))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-6))) (vector 1 u--res))))))))))))))) ((60) (let ((e-192 (vector-ref arg-3 1))) (let ((e-193 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-ploc arg-2 e-192) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing multi-line string") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-193) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) e-5)))))))))) ((61) (let ((e-194 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Timeout in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-194))))))) ((62) (let ((e-196 (vector-ref arg-3 2))) (let ((e-197 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-196) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-perror arg-0 arg-1 arg-2 e-197) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing type of") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (cons e-6 '())))))))))))))))) ((63) (let ((e-199 (vector-ref arg-3 2))) (let ((e-200 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-199) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-perror arg-0 arg-1 arg-2 e-200) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing constructor") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (cons e-6 '())))))))))))))))) ((64) (let ((e-202 (vector-ref arg-3 2))) (let ((e-203 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-202) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-perror arg-0 arg-1 arg-2 e-203) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing left hand side of") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (cons e-6 '())))))))))))))))) ((65) (let ((e-205 (vector-ref arg-3 2))) (let ((e-206 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45Context-prettyName arg-0 e-205) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Error-perror arg-0 arg-1 arg-2 e-206) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing right hand side of") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-5)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (cons e-6 '())))))))))))))))) ((66) (let ((e-207 (vector-ref arg-3 1))) (let ((e-208 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-perror arg-0 arg-1 arg-2 e-207) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 (if (null? e-208) (let ((sc3 (LibrariesC-45DataC-45List1-unsnoc e-208))) (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Did you mean any of:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) e-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "?")))))))) (let ((e-1 (car e-208))) (let ((e-2 (cdr e-208))) (if (null? e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Did you mean:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "?"))) (let ((sc4 (LibrariesC-45DataC-45List1-unsnoc e-208))) (let ((e-4 (car sc4))) (let ((e-3 (cdr sc4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Did you mean any of:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) e-4)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "?")))))))))))))))))))))) (else (let ((e-209 (vector-ref arg-3 1))) (lambda (eta-0) (IdrisC-45Error-pwarning arg-0 arg-1 arg-2 e-209 eta-0)))))))
(define IdrisC-45Error-pShowMN (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (let ((sc1 (CoreC-45Name-dropAllNS (CoreC-45TT-nameAt arg-1 e-4)))) (case (vector-ref sc1 0) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "implicitly bound at") (CoreC-45FC-u--pretty_Pretty_FC (CoreC-45Env-getBinderLoc arg-1 e-4 arg-3))))))(else arg-4)))))(else arg-4))))
(define IdrisC-45Error-keyword (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 5 )) ext-0)))
(define IdrisC-45Error-displayWarning (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (IdrisC-45Error-pwarning arg-0 arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Warning:")) e-5))))))))
(define IdrisC-45Error-display (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((IdrisC-45Error-perror arg-0 arg-1 arg-2 arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Error:")) e-5))))))))
(define LibrariesC-45DataC-45List1-n--2592-750-u--go (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (cons '() arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45List1-n--2592-750-u--go arg-1 arg-2 e-2 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (cons arg-3 e-5) e-4)))))))))
(define LibrariesC-45DataC-45List1-unsnoc (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (LibrariesC-45DataC-45List1-n--2592-750-u--go e-1 e-2 e-1 e-2)))))
(define DataC-45Stream-repeat (lambda (arg-1) (cons arg-1 (lambda () (DataC-45Stream-repeat arg-1)))))
(define IdrisC-45Pretty-n--9347-1082-u--startPrec(blodwen-lazy (lambda () (vector 4 0))))
(define IdrisC-45Pretty-n--9347-1085-u--prettyOp (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((u--op (vector e-0 e-1 e-2))) (let ((sc0 (ParserC-45LexerC-45Source-isOpName e-2))) (cond ((equal? sc0 1) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (IdrisC-45Pretty-kindAnn u--op)) (CoreC-45Name-u--pretty_Pretty_Name e-2))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (vector 1 #\`) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (IdrisC-45Pretty-kindAnn u--op)) (CoreC-45Name-u--pretty_Pretty_Name e-2))) (vector 1 #\`)))))))))))
(define IdrisC-45Pretty-n--9655-1518-u--prettyBindings (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-11 0) ((25) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-6) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-10)) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-6) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-11))) (case (vector-ref e-11 0) ((25) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-6) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9655-1518-u--prettyBindings arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-6) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9655-1518-u--prettyBindings arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))))))))(else (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-6) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-11))) (case (vector-ref e-11 0) ((25) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-6) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9655-1518-u--prettyBindings arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-6) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9655-1518-u--prettyBindings arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))))))))))
(define IdrisC-45Pretty-n--9347-1084-u--leftAppPrec(blodwen-lazy (lambda () (vector 4 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))
(define IdrisC-45Pretty-n--9347-1086-u--go (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (IdrisC-45Pretty-kindAnn e-2)) (CoreC-45Name-u--pretty_Pretty_Name (let ((e-3 (vector-ref e-2 2))) e-3))))) ((1) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (case (vector-ref e-6 0) ((1) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (AlgebraC-45Semiring-branchVal (csegen-475) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9)))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "_")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9)))) e-5))) (let ((e-211 (unbox e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-5) (IdrisC-45Pretty-prettyBinder e-211)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9)))))))) ((0) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\_)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9))))) (let ((e-214 (unbox e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-5) (IdrisC-45Pretty-prettyBinder e-214)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9)))))))) ((2) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (AlgebraC-45Semiring-branchVal (csegen-475) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "=>") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9)))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-auto_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "_")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9)))) e-5))) (let ((e-217 (unbox e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-auto_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-5) (IdrisC-45Pretty-prettyBinder e-217)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9)))))))) (else (let ((e-208 (vector-ref e-6 1))) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-default_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1083-u--appPrec) e-208) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "_")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9))))) (let ((e-220 (unbox e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-default_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1083-u--appPrec) e-208) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-5) (IdrisC-45Pretty-prettyBinder e-220)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-8)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-9)))))))))))))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (let ((sc1 (IdrisC-45Pretty-n--9655-1517-u--getLamNames e-11 e-13 e-16 e-15 e-14 e-12 arg-0 (cons (cons e-12 (cons e-14 e-15)) '()) e-16))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-backslash) (IdrisC-45Pretty-n--9655-1518-u--prettyBindings e-11 e-13 e-16 e-15 e-14 e-12 arg-0 e-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "=>") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-3))))))))))))))) ((3) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (let ((e-22 (vector-ref arg-1 5))) (let ((e-23 (vector-ref arg-1 6))) (let ((e-24 (vector-ref arg-1 7))) (case (vector-ref e-21 0) ((25) (let ((e-222 (vector-ref e-21 1))) (DataC-45Maybe-fromMaybe (lambda () (IdrisC-45Pretty-n--9655-1726-u--fullLet e-18 e-222 e-24 e-23 e-22 e-20 e-19 arg-0)) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45Pretty-n--9655-1727-u--getPRefName e-18 e-222 e-24 e-23 e-22 e-20 e-19 arg-0 e-20) (lambda (u--nName) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45Pretty-n--9655-1727-u--getPRefName e-18 e-222 e-24 e-23 e-22 e-20 e-19 arg-0 e-22) (lambda (u--valName) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CoreC-45Name-u--show_Show_Name u--nName) (CoreC-45Name-u--show_Show_Name u--valName))) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe (IdrisC-45Pretty-n--9655-1725-u--continuation e-18 e-222 e-24 e-23 e-22 e-20 e-19 arg-0)))))))) (lambda () (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45Pretty-n--9655-1727-u--getPRefName e-18 e-222 e-24 e-23 e-22 e-20 e-19 arg-0 e-20) (lambda (u--nName) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (CoreC-45Name-isUnderscoreName u--nName)) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe (IdrisC-45Pretty-n--9655-1725-u--continuation e-18 e-222 e-24 e-23 e-22 e-20 e-19 arg-0)))))))))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-let_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-19) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-20)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-21) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-22)))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyAlt eta-0)) e-24)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-in_)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-23))))))))))))))))))) ((4) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-case_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-27) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-of_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyCase eta-0)) e-28)))))))))))) ((5) (let ((e-32 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-let_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "definitions")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-in_)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-32)))))))) ((6) (let ((e-35 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-record_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyUpdate eta-0)) e-35))))))))) ((7) (let ((e-38 (vector-ref arg-1 2))) (let ((e-39 (vector-ref arg-1 3))) (let ((u--catchall (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1084-u--leftAppPrec) e-38) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1083-u--appPrec) e-39))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (case (vector-ref e-38 0) ((0) (let ((e-1 (vector-ref e-38 1))) (let ((e-2 (vector-ref e-38 2))) (let ((u--f (vector 0 e-1 e-2))) (let ((sc2 (DataC-45Maybe-isJust (CoreC-45Name-isRF (let ((e-3 (vector-ref e-2 2))) e-3))))) (cond ((equal? sc2 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1084-u--leftAppPrec) e-39) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1083-u--appPrec) u--f))) (else (u--catchall))))))))(else (u--catchall))))))))) ((8) (let ((e-42 (vector-ref arg-1 2))) (let ((e-43 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go arg-0 e-42) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (IdrisC-45Pretty-n--9347-1086-u--go arg-0 e-43)))))) ((11) (let ((e-46 (vector-ref arg-1 2))) (let ((e-47 (vector-ref arg-1 3))) (cond ((equal? e-46 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Inf") (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1083-u--appPrec) e-47))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Lazy") (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1083-u--appPrec) e-47)))))))) ((12) (let ((e-50 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Delay") (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1083-u--appPrec) e-50))))) ((13) (let ((e-53 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Force") (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1083-u--appPrec) e-53))))) ((10) (let ((e-56 (vector-ref arg-1 2))) (let ((e-57 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1084-u--leftAppPrec) e-56) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "@") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-57))))))))) ((9) (let ((e-60 (vector-ref arg-1 2))) (let ((e-61 (vector-ref arg-1 3))) (let ((e-62 (vector-ref arg-1 4))) (case (vector-ref e-62 0) ((0) (let ((e-225 (vector-ref e-62 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-61 (let ((e-2 (vector-ref e-225 2))) e-2)))) (cond ((equal? sc2 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1084-u--leftAppPrec) e-60) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (CoreC-45Name-u--pretty_Pretty_Name e-61)))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1084-u--leftAppPrec) e-60) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-61) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (CoreC-45Name-u--pretty_Pretty_Name (let ((e-2 (vector-ref e-225 2))) e-2)))))))))))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1084-u--leftAppPrec) e-60) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-61) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (IdrisC-45Pretty-n--9347-1086-u--go arg-0 e-62))))))))))))) ((14) (IdrisC-45Pretty-pragma (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "%search"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "%search")) (else "%search"))))))))) ((16) (let ((e-68 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-68)))))) ((17) (let ((e-71 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (CoreC-45Name-u--pretty_Pretty_Name e-71))))))) ((18) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "declaration"))))))) ((19) (let ((e-77 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "~") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-77)))))) ((20) (let ((e-80 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-pragma (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "%runElab"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "%runElab")) (else "%runElab")))))))) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-80))))) ((15) (let ((e-83 (vector-ref arg-1 2))) (let ((u--decor (let ((sc1 (CoreC-45TT-isPrimType e-83))) (cond ((equal? sc1 1) (vector 1 '())) (else (vector 2 '())))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate u--decor (CoreC-45TT-u--pretty_Pretty_Constant e-83))))) ((21) (let ((e-87 (vector-ref arg-1 3))) (IdrisC-45Pretty-hole (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (PreludeC-45Types-strCons #\? e-87))))) ((22) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 '()) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Type"))) ((23) (let ((e-93 (vector-ref arg-1 3))) (let ((e-94 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45Name-u--pretty_Pretty_Name e-93) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "@")) (IdrisC-45Pretty-n--9347-1086-u--go arg-0 e-94))))) ((24) (let ((e-97 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (IdrisC-45Pretty-n--9347-1086-u--go arg-0 e-97)))) ((25) (csegen-248)) ((26) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "?"))) ((27) (let ((e-105 (vector-ref arg-1 3))) (let ((e-106 (vector-ref arg-1 4))) (let ((e-107 (vector-ref arg-1 5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-106) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1085-u--prettyOp e-105) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-107))))))))) ((28) (let ((e-111 (vector-ref arg-1 3))) (let ((e-112 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-n--9347-1085-u--prettyOp e-111) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-112)))))) ((29) (let ((e-116 (vector-ref arg-1 3))) (let ((e-117 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1085-u--prettyOp e-116) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-117)))))) ((30) (let ((e-121 (vector-ref arg-1 3))) (let ((e-122 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-121) (IdrisC-45Pretty-n--9347-1085-u--prettyOp e-122)))))) ((31) (let ((e-125 (vector-ref arg-1 2))) (let ((e-126 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-125) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-126))))))) ((32) (let ((e-129 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-129)))) ((33) (let ((e-132 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "++") (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyString eta-0)) e-132)))))) ((34) (let ((e-136 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "multiline") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "++") (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyString eta-0)) (PreludeC-45Interfaces-concat (csegen-50) e-136)))))))) ((35) (let ((e-140 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-do_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyDo eta-0)) e-140)))))))))) ((36) (let ((e-143 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "!") (IdrisC-45Pretty-n--9347-1086-u--go arg-0 e-143)))) ((37) (let ((e-146 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "[|") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "|]") (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-146)))) ((38) (let ((e-150 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (csegen-2611) e-150)))))))) ((39) (let ((e-154 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "[<") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (csegen-2611) e-154)))))))) ((40) (let ((e-157 (vector-ref arg-1 2))) (let ((e-158 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-157) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-158))))))) ((41) (let ((e-162 (vector-ref arg-1 3))) (let ((e-163 (vector-ref arg-1 4))) (let ((e-164 (vector-ref arg-1 5))) (case (vector-ref e-163 0) ((25) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-162) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "**") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-164))))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-162) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-163) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "**") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-164))))))))))))) ((42) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "()"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "()")) (else "()")))))))) ((43) (let ((e-169 (vector-ref arg-1 2))) (let ((e-170 (vector-ref arg-1 3))) (let ((e-171 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "if"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "if")) (else "if")))))))) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-169)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "then"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "then")) (else "then")))))))) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-170)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "else"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "else")) (else "else")))))))) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-171)) '())))))))))))) ((44) (let ((e-173 (vector-ref arg-1 1))) (let ((e-174 (vector-ref arg-1 2))) (let ((e-175 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) (IdrisC-45Pretty-n--9655-2781-u--dePure e-173 e-175 e-174 arg-0 e-174)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyDo (IdrisC-45Pretty-n--9655-2782-u--deGuard e-173 e-175 e-174 arg-0 eta-0))) e-175))))))))))) ((45) (let ((e-178 (vector-ref arg-1 2))) (let ((e-179 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-rewrite_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-178) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-in_)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-179)))))))) ((46) (let ((e-182 (vector-ref arg-1 2))) (let ((e-183 (vector-ref arg-1 3))) (let ((e-184 (vector-ref arg-1 4))) (if (null? e-183) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-182) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "..") (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-184)))) (let ((e-230 (unbox e-183))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-182) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-230) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "..") (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-184))))))))))) ((47) (let ((e-187 (vector-ref arg-1 2))) (let ((e-188 (vector-ref arg-1 3))) (if (null? e-188) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-187) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String ".."))) (let ((e-233 (unbox e-188))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-187) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-233) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String ".."))))))))) ((50) (let ((e-192 (vector-ref arg-1 3))) (IdrisC-45Pretty-n--9347-1086-u--go arg-0 e-192))) ((48) (let ((e-195 (vector-ref arg-1 2))) (let ((e-196 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-195) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-256) (PreludeC-45Types-u--map_Functor_List (csegen-2639) e-196)))))))) ((49) (let ((e-199 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-256) (PreludeC-45Types-u--map_Functor_List (csegen-2639) e-199)))))) (else (let ((e-202 (vector-ref arg-1 2))) (let ((e-203 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (IdrisC-45Pretty-n--9347-1083-u--appPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-with_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_C-40ListC-32C-36aC-41 (csegen-2549) e-202) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) e-203)))))))))))
(define IdrisC-45Pretty-n--9655-1727-u--getPRefName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-2 (vector-ref arg-8 2))) (box (let ((e-3 (vector-ref e-2 2))) e-3))))(else '()))))
(define IdrisC-45Pretty-n--9655-1517-u--getLamNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((2) (let ((e-2 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (IdrisC-45Pretty-n--9655-1517-u--getLamNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-2 (cons e-4 e-5)) arg-7) e-6))))))(else (cons (PreludeC-45TypesC-45List-reverse arg-7) arg-8)))))
(define IdrisC-45Pretty-n--9655-1726-u--fullLet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-7 (IdrisC-45Pretty-n--9347-1082-u--startPrec)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-let_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig arg-6) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) arg-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) arg-4)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (IdrisC-45Pretty-in_)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (IdrisC-45Pretty-n--9655-1725-u--continuation arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))))))))
(define IdrisC-45Pretty-n--9655-2781-u--dePure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((7) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((u--tm (vector 7 e-1 (vector 0 e-5 e-6) e-3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (let ((e-4 (vector-ref e-6 2))) e-4)) (vector 1 (vector 0 "pure"))))) (cond ((equal? sc2 1) e-3) (else u--tm)))))))(else arg-4))))))(else arg-4))))
(define IdrisC-45Pretty-n--9655-2782-u--deGuard (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (case (vector-ref e-2 0) ((7) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((e-6 (vector-ref e-2 3))) (case (vector-ref e-5 0) ((0) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((u--tm (vector 0 e-1 (vector 7 e-4 (vector 0 e-8 e-9) e-6)))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (let ((e-3 (vector-ref e-9 2))) e-3)) (vector 1 (vector 0 "guard"))))) (cond ((equal? sc3 1) (vector 0 e-1 e-6)) (else u--tm)))))))(else arg-4))))))(else arg-4)))))(else arg-4))))
(define IdrisC-45Pretty-n--9655-1725-u--continuation (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (IdrisC-45Pretty-n--9347-1086-u--go (IdrisC-45Pretty-n--9347-1082-u--startPrec) arg-3)))
(define IdrisC-45Pretty-n--9347-1083-u--appPrec(blodwen-lazy (lambda () (vector 4 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))
(define IdrisC-45Pretty-with_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "with")))))
(define IdrisC-45Pretty-warning (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) ext-0)))
(define IdrisC-45Pretty-syntaxToDecoration (lambda (arg-0) (case (vector-ref arg-0 0) ((0) '()) ((1) (PreludeC-45Types-u--pure_Applicative_Maybe 1)) ((2) (PreludeC-45Types-u--pure_Applicative_Maybe 3)) ((3) (PreludeC-45Types-u--pure_Applicative_Maybe 2)) ((4) (PreludeC-45Types-u--pure_Applicative_Maybe 5)) ((5) (PreludeC-45Types-u--pure_Applicative_Maybe 4)) (else '()))))
(define IdrisC-45Pretty-syntaxAnn (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 10)) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 12)) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 9)) ((3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 10)) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-italic)) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 15)) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 13)))))
(define IdrisC-45Pretty-showCategory (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) arg-1 (IdrisC-45Pretty-kindAnn (CoreC-45ContextC-45Context-gDefKindedName arg-2))))))
(define IdrisC-45Pretty-rewrite_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "rewrite")))))
(define IdrisC-45Pretty-renderWithDecorations (lambda (arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (IdrisC-45PrettyC-45Render-renderWithSpans arg-3 arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((u--spans (DataC-45List-mapMaybe (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--traverse_Traversable_Span (csegen-271) arg-4 eta-0)) e-3))) (vector 1 (cons e-2 u--spans)))))))))))
(define IdrisC-45Pretty-render (lambda (arg-0 ext-1 ext-0) (IdrisC-45PrettyC-45Render-render arg-0 (lambda (eta-0) (IdrisC-45Pretty-colorAnn eta-0)) ext-1 ext-0)))
(define IdrisC-45Pretty-record_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "record")))))
(define IdrisC-45Pretty-prettyUpdate (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-256) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (IdrisC-45Pretty-prettyTerm e-2)))))) (else (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-256) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) e-4)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\$) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals)) (IdrisC-45Pretty-prettyTerm e-5)))))))))
(define IdrisC-45Pretty-prettyTerm (lambda (ext-0) (IdrisC-45Pretty-n--9347-1086-u--go (vector 0 ) ext-0)))
(define IdrisC-45Pretty-prettyString (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-2))) (else (let ((e-5 (vector-ref arg-0 2))) (IdrisC-45Pretty-prettyTerm e-5))))))
(define IdrisC-45Pretty-prettyRig (lambda (ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space)) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) ext-0)))
(define IdrisC-45Pretty-prettyDo (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (IdrisC-45Pretty-prettyTerm e-2))) ((1) (let ((e-6 (vector-ref arg-0 3))) (let ((e-7 (vector-ref arg-0 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "<-") (IdrisC-45Pretty-prettyTerm e-7)))))) ((2) (let ((e-10 (vector-ref arg-0 2))) (let ((e-11 (vector-ref arg-0 3))) (let ((e-12 (vector-ref arg-0 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyTerm e-10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "<-") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyTerm e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyAlt eta-0)) e-12)))))))))) ((3) (let ((e-16 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 4))) (let ((e-19 (vector-ref arg-0 6))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-let_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyRig e-17) (CoreC-45Name-u--pretty_Pretty_Name e-16)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (IdrisC-45Pretty-prettyTerm e-19)))))))) ((4) (let ((e-22 (vector-ref arg-0 2))) (let ((e-24 (vector-ref arg-0 4))) (let ((e-25 (vector-ref arg-0 5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-let_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyTerm e-22) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyTerm e-24) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-prettyAlt eta-0)) e-25))))))))))) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-let_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "definitions")))))) (else (let ((e-31 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-rewrite_) (IdrisC-45Pretty-prettyTerm e-31)))))))
(define IdrisC-45Pretty-prettyCase (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyTerm e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "=>") (IdrisC-45Pretty-prettyTerm e-3)))))) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with alts not possible"))))) (else (let ((e-14 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyTerm e-14) (IdrisC-45Pretty-impossible_)))))))
(define IdrisC-45Pretty-prettyBinder (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (CoreC-45Name-u--pretty_Pretty_Name ext-0))))
(define IdrisC-45Pretty-prettyAlt (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyTerm e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "=>") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyTerm e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi)))))))) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with alts not possible"))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi)))) (else (let ((e-14 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyTerm e-14) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-impossible_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi)))))))))
(define IdrisC-45Pretty-pragma (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 ) ext-0)))
(define IdrisC-45Pretty-of_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "of")))))
(define IdrisC-45Pretty-meta (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) ext-0)))
(define IdrisC-45Pretty-let_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "let")))))
(define IdrisC-45Pretty-kindAnn (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe e-0 (lambda (u--cat) (PreludeC-45Types-u--pure_Applicative_Maybe (case (vector-ref u--cat 0) ((0) (vector 4 )) ((1) (vector 3 e-1)) ((2) (vector 2 (box e-1))) (else (vector 1 (box e-1)))))))))))
(define IdrisC-45Pretty-keyword (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) ext-0)))
(define IdrisC-45Pretty-in_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "in")))))
(define IdrisC-45Pretty-impossible_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "impossible")))))
(define IdrisC-45Pretty-hole (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) ext-0)))
(define IdrisC-45Pretty-fileCtxt (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) ext-0)))
(define IdrisC-45Pretty-errorDesc (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) ext-0)))
(define IdrisC-45Pretty-error (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) ext-0)))
(define IdrisC-45Pretty-do_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "do")))))
(define IdrisC-45Pretty-default_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "default")))))
(define IdrisC-45Pretty-colorAnn (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40ListC-32C-36aC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold))) ((1) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40ListC-32C-36aC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold))) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold)) ((3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 12)) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 5)) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 2)) (else (let ((e-0 (vector-ref arg-0 1))) (IdrisC-45Pretty-syntaxAnn e-0))))))
(define IdrisC-45Pretty-code (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) ext-0)))
(define IdrisC-45Pretty-case_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "case")))))
(define IdrisC-45Pretty-auto_(blodwen-lazy (lambda () (IdrisC-45Pretty-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "auto")))))
(define IdrisC-45REPLC-45Opts-n--9534-4558-u--litStyle (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (unbox arg-3))) (ParserC-45Unlit-isLitFile e-2)))))
(define IdrisC-45REPLC-45Opts-withROpts (lambda (arg-1 ext-1 ext-0) (CoreC-45Core-wrapRef (vector "Idris.REPL.Opts.ROpts" ) arg-1 (lambda (_-4589) (lambda (eta-0) (vector 1 0))) ext-1 ext-0)))
(define IdrisC-45REPLC-45Opts-setSynHighlightOn (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 arg-1)))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-setSource (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 arg-1 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-setOutput (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 arg-1 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-setMainFile (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 arg-1 (IdrisC-45REPLC-45Opts-litStyle arg-1) e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-setEvalTiming (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 arg-1 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-setCurrentElabSource (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 arg-1 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-setConsoleWidth (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 arg-1 e-15 e-16)))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-setColor (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 arg-1 e-16)))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-resetProofState (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 '() '() e-12 e-13 e-14 e-15 e-16))))))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45REPLC-45Opts-litStyle (lambda (ext-0) (PreludeC-45Types-u--join_Monad_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (ParserC-45Unlit-isLitFile eta-0)) ext-0))))
(define IdrisC-45REPLC-45Opts-getSourceLine (lambda (arg-0 arg-1 ext-0) (let ((act-24 (IdrisC-45REPLC-45Opts-getSource arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45DataC-45ListC-45Extra-elemAt (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines e-5)) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- arg-1 1 63)))))))))))
(define IdrisC-45REPLC-45Opts-getSource (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-17 (vector-ref e-5 5))) e-17))))))))
(define IdrisC-45REPLC-45Opts-getOutput (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-8 (vector-ref e-5 8))) e-8))))))))
(define IdrisC-45REPLC-45Opts-getLitStyle (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) e-4))))))))
(define IdrisC-45REPLC-45Opts-getEvalTiming (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2))))))))
(define IdrisC-45REPLC-45Opts-getCurrentElabSource (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-9 (vector-ref e-5 9))) e-9))))))))
(define IdrisC-45REPLC-45Opts-getConsoleWidth (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-14 (vector-ref e-5 14))) e-14))))))))
(define IdrisC-45REPLC-45Opts-getColor (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (let ((e-15 (vector-ref e-5 15))) e-15))))))))
(define IdrisC-45REPLC-45Opts-getCodegen (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (DataC-45List-lookup (csegen-17) arg-1 (let ((e-13 (vector-ref e-5 13))) e-13)))))))))
(define IdrisC-45REPLC-45Opts-defaultOpts (lambda (arg-0 arg-1 arg-2) (vector 0 1 0 arg-0 (IdrisC-45REPLC-45Opts-n--9534-4558-u--litStyle arg-2 arg-1 arg-0 arg-0) "" "vim" '() arg-1 "" '() '() '() arg-2 '() 1 1)))
(define IdrisC-45PrettyC-45Render-renderWithoutColor (lambda (arg-1 arg-2 ext-0) (let ((act-24 (IdrisC-45PrettyC-45Render-getPageWidth arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--opts e-5)) (let ((u--layout (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty u--opts arg-2))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-renderString (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS u--layout)))))))))))
(define IdrisC-45PrettyC-45Render-renderWithSpans (lambda (arg-1 arg-2 ext-0) (let ((act-24 (IdrisC-45PrettyC-45Render-getPageWidth arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--opts e-5)) (let ((u--layout (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty u--opts arg-2))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-displaySpans u--layout))))))))))
(define IdrisC-45PrettyC-45Render-render (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (IdrisC-45REPLC-45Opts-getColor arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-17) (box "dumb") e-6)))))) (lambda (eta-0) (let ((act-25 ((System-getEnv (csegen-3) "TERM") eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45PrettyC-45Render-getPageWidth arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--opts e-7)) (let ((u--layout (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty u--opts arg-3))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-renderString (let ((sc3 (cond ((equal? e-5 1) (cond ((equal? e-6 1) 0) (else 1))) (else 0)))) (cond ((equal? sc3 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 u--layout)) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS u--layout))))))))))))))))))))))
(define IdrisC-45PrettyC-45Render-getPageWidth (lambda (arg-0 ext-0) (let ((act-24 (IdrisC-45REPLC-45Opts-getConsoleWidth arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 (let ((act-25 (LibrariesC-45UtilsC-45Term-getTermCols ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc3 1) '()) (else (cons e-6 1.0))))))))) (let ((e-2 (unbox e-5))) (cond ((equal? e-2 0) (vector 1 '()))(else (vector 1 (cons (PreludeC-45Cast-u--cast_Cast_Nat_Int e-2) 1.0))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-769-u--writeOutput (lambda (arg-0 arg-2 arg-3 ext-0) (ControlC-45MonadC-45ST-modifySTRef arg-2 (lambda (arg-1) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String arg-1 arg-3)) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-766-u--push (lambda (arg-0 arg-2 arg-3 ext-0) (ControlC-45MonadC-45ST-modifySTRef arg-2 (lambda (arg-1) (cons arg-3 arg-1)) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-768-u--pop (lambda (arg-0 arg-2 ext-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (unbox arg-2)) (lambda (_-0) (if (null? _-0) (lambda (eta-0) (ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 '() eta-0)) (let ((e-1 (car _-0))) (let ((e-2 (cdr _-0))) (PreludeC-45Interfaces-C-62C-62 (csegen-2653) (lambda (eta-0) (set-box! arg-2 e-2)) (lambda () (lambda (eta-0) (ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 (box e-1) eta-0)))))))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-767-u--peek (lambda (arg-0 arg-2 ext-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (unbox arg-2)) (lambda (_-0) (lambda (clam-0) (if (null? _-0) (ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 '() clam-0) (let ((e-1 (car _-0))) (ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 (box e-1) clam-0))))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-770-u--go (lambda (arg-0 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (lambda (eta-0) (ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 0 eta-0))) ((1) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (PreludeC-45Interfaces-C-62C-62 (csegen-2653) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-769-u--writeOutput arg-0 arg-3 (DataC-45String-singleton e-2) eta-0)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-770-u--go arg-0 arg-2 arg-3 (e-3))))))) ((2) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (PreludeC-45Interfaces-C-62C-62 (csegen-2653) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-769-u--writeOutput arg-0 arg-3 e-6 eta-0)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-770-u--go arg-0 arg-2 arg-3 (e-7))))))) ((3) (let ((e-9 (vector-ref arg-4 1))) (let ((e-10 (vector-ref arg-4 2))) (PreludeC-45Interfaces-C-62C-62 (csegen-2653) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-769-u--writeOutput arg-0 arg-3 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (DataC-45String-singleton (integer->char 10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces e-9)) eta-0)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-770-u--go arg-0 arg-2 arg-3 e-10)))))) ((4) (let ((e-12 (vector-ref arg-4 1))) (let ((e-13 (vector-ref arg-4 2))) (lambda (eta-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-767-u--peek arg-0 arg-2 eta-1)) (lambda (_-0) (if (null? _-0) (lambda (eta-1) (set-box! arg-2 '())) (let ((e-1 (unbox _-0))) (let ((u--newStyle (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40ListC-32C-36aC-41 e-12 e-1))) (PreludeC-45Interfaces-C-62C-62 (csegen-2653) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-766-u--push arg-0 arg-2 u--newStyle eta-1)) (lambda () (PreludeC-45Interfaces-C-62C-62 (csegen-2653) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-769-u--writeOutput arg-0 arg-3 (LibrariesC-45ControlC-45ANSIC-45SGR-escapeSGR u--newStyle) eta-1)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-770-u--go arg-0 arg-2 arg-3 e-13))))))))) eta-0))))) (else (let ((e-15 (vector-ref arg-4 1))) (lambda (eta-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-768-u--pop arg-0 arg-2 eta-1)) (lambda (u--_) (lambda (eta-1) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-767-u--peek arg-0 arg-2 eta-2)) (lambda (_-0) (if (null? _-0) (lambda (eta-2) (set-box! arg-2 '())) (let ((e-1 (unbox _-0))) (PreludeC-45Interfaces-C-62C-62 (csegen-2653) (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-769-u--writeOutput arg-0 arg-3 (LibrariesC-45ControlC-45ANSIC-45SGR-escapeSGR (cons (vector 0 ) e-1)) eta-2)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-770-u--go arg-0 arg-2 arg-3 e-15)))))) eta-1))) eta-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-underline(blodwen-lazy (lambda () (PreludeC-45Types-u--pure_Applicative_List (vector 3 4)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-renderString (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () "<internal pretty printing error>") (ControlC-45MonadC-45ST-runST (lambda (s-1074) (lambda (eta-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-1) (ControlC-45MonadC-45ST-newSTRef (cons (PreludeC-45Types-u--neutral_Monoid_C-40ListC-32C-36aC-41) '()) eta-1)) (lambda (u--styleStackRef) (lambda (eta-1) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-2) (ControlC-45MonadC-45ST-newSTRef (PreludeC-45Types-u--neutral_Monoid_String) eta-2)) (lambda (u--outputRef) (PreludeC-45Interfaces-C-62C-62 (csegen-2653) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--3322-770-u--go arg-0 u--styleStackRef u--outputRef arg-0) (lambda () (lambda (eta-2) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-3) (unbox u--styleStackRef)) (lambda (lcase-0) (if (null? lcase-0) (lambda (eta-3) (ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 '() eta-3)) (let ((e-3 (cdr lcase-0))) (if (null? e-3) (PreludeC-45Interfaces-C-60C-36C-62 (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (ControlC-45MonadC-45ST-u--map_Functor_C-40STC-32C-36sC-41 eta-5 eta-6))))) (lambda (eta-3) (box eta-3)) (lambda (eta-3) (unbox u--outputRef))) (lambda (eta-3) (ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 '() eta-3)))))) eta-2))))) eta-1))) eta-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-italic(blodwen-lazy (lambda () (PreludeC-45Types-u--pure_Applicative_List (vector 3 3)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color (lambda (arg-0) (PreludeC-45Types-u--pure_Applicative_List (vector 1 arg-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold(blodwen-lazy (lambda () (PreludeC-45Types-u--pure_Applicative_List (vector 3 0)))))
(define ControlC-45MonadC-45ST-u--pure_Applicative_C-40STC-32C-36sC-41 (lambda (ext-0 ext-1) ext-0))
(define ControlC-45MonadC-45ST-u--map_Functor_C-40STC-32C-36sC-41 (lambda (arg-3 arg-4) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-758) arg-3 arg-4)))
(define ControlC-45MonadC-45ST-u--join_Monad_C-40STC-32C-36sC-41 (lambda (arg-2 ext-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 arg-2 (lambda (eta-0) eta-0) ext-0)))
(define ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (arg-3 arg-4 ext-0) (let ((act-24 (arg-3 ext-0))) ((arg-4 act-24) ext-0))))
(define ControlC-45MonadC-45ST-u--C-60C-42C-62_Applicative_C-40STC-32C-36sC-41 (lambda (arg-3 arg-4 ext-0) (let ((act-17 (arg-3 ext-0))) (let ((act-16 (arg-4 ext-0))) (act-17 act-16)))))
(define ControlC-45MonadC-45ST-runST (lambda (arg-1) (PrimIO-unsafePerformIO (arg-1 'erased))))
(define ControlC-45MonadC-45ST-newSTRef (lambda (arg-2 ext-0) (let ((act-24 ((DataC-45IORef-newIORef (csegen-3) arg-2) ext-0))) act-24)))
(define ControlC-45MonadC-45ST-modifySTRef (lambda (arg-2 arg-3 ext-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (unbox arg-2)) (lambda (u--val) (lambda (eta-0) (set-box! arg-2 (arg-3 u--val)))) ext-0)))
(define LibrariesC-45ControlC-45ANSIC-45SGR-n--2900-855-u--toCode (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) "0") ((1) (let ((e-0 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "38;5;" (LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Color_String e-0)))) ((2) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45TypesC-45String-C-43C-43 "48;5;" (LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Color_String e-1)))) ((3) (let ((e-2 (vector-ref arg-1 1))) (LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Style_String e-2))) (else (let ((e-3 (vector-ref arg-1 1))) (LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Blink_String e-3))))))
(define LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Style_String (lambda (arg-0) (cond ((equal? arg-0 0) "1") ((equal? arg-0 1) "2") ((equal? arg-0 2) "22") ((equal? arg-0 3) "3") ((equal? arg-0 4) "4") ((equal? arg-0 5) "21") ((equal? arg-0 6) "24") ((equal? arg-0 7) "9") (else "29"))))
(define LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Color_String (lambda (arg-0) (cond ((equal? arg-0 0) "0") ((equal? arg-0 1) "1") ((equal? arg-0 2) "2") ((equal? arg-0 3) "3") ((equal? arg-0 4) "4") ((equal? arg-0 5) "5") ((equal? arg-0 6) "6") ((equal? arg-0 7) "7") ((equal? arg-0 8) "8") ((equal? arg-0 9) "9") ((equal? arg-0 10) "10") ((equal? arg-0 11) "11") ((equal? arg-0 12) "12") ((equal? arg-0 13) "13") ((equal? arg-0 14) "14") (else "15"))))
(define LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Blink_String (lambda (arg-0) (cond ((equal? arg-0 0) "5") ((equal? arg-0 1) "6") (else "25"))))
(define LibrariesC-45ControlC-45ANSIC-45SGR-escapeSGR (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 "\x1b;[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) (DataC-45List-intersperse ";" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45ControlC-45ANSIC-45SGR-n--2900-855-u--toCode arg-0 eta-0)) arg-0))) "m"))))
(define IdrisC-45Version-with--version-2518 (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-3 "") (cons e-2 '()))(else (cons e-2 (box e-3))))))))
(define IdrisC-45Version-version(blodwen-lazy (lambda () (IdrisC-45Version-with--version-2518 (IdrisPaths-idrisVersion)))))
(define LibrariesC-45DataC-45Version-case--compare-2193 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-4 1) (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (csegen-261) arg-0 arg-2))(else arg-4))))
(define LibrariesC-45DataC-45Version-n--3419-1958-u--showTag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) "" (let ((e-2 (unbox arg-3))) (PreludeC-45TypesC-45String-C-43C-43 "-" e-2)))))
(define LibrariesC-45DataC-45Version-u--tokValue_TokenKind_VersionTokenKind (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1) ((equal? arg-0 2) 0) ((equal? arg-0 3) 0) (else (DataC-45String-stringToNatOrZ arg-1)))))
(define LibrariesC-45DataC-45Version-u--show_Show_Version (lambda (ext-0) (LibrariesC-45DataC-45Version-showVersion 1 ext-0)))
(define LibrariesC-45DataC-45Version-u--compare_Ord_Version (lambda (arg-0 arg-1) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45Version-case--compare-2193 e-1 e-0 e-3 e-2 (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2672) (vector (cons (lambda (arg-2) (lambda (arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-792) (csegen-792) arg-2 arg-3))) (lambda (arg-4) (lambda (arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-792) (csegen-792) arg-4 arg-5)))) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2672) (csegen-2672) arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2672) (csegen-2672) arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2672) (csegen-2672) arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2672) (csegen-2672) arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2672) (csegen-2672) arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2672) (csegen-2672) arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2672) (csegen-2672) arg-430 arg-431)))) e-0 e-2))))))))
(define LibrariesC-45DataC-45Version-u--TokType_TokenKind_VersionTokenKind (lambda (arg-0) (cond ((equal? arg-0 0) (vector "String" )) ((equal? arg-0 2) (vector "Builtin.Unit" )) ((equal? arg-0 3) (vector "Builtin.Unit" )) (else (vector "Prelude.Types.Nat" )))))
(define LibrariesC-45DataC-45Version-u--C-61C-61_Eq_VersionTokenKind (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define LibrariesC-45DataC-45Version-u--C-60_Ord_Version (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (LibrariesC-45DataC-45Version-u--compare_Ord_Version arg-0 arg-1) 0)))
(define LibrariesC-45DataC-45Version-u--C-47C-61_Eq_VersionTokenKind (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45DataC-45Version-u--C-61C-61_Eq_VersionTokenKind arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define LibrariesC-45DataC-45Version-versionTokenMap(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-toTokenMap (cons (cons (LibrariesC-45TextC-45Lexer-is #\.) 2) (cons (cons (LibrariesC-45TextC-45Lexer-is #\-) 3) (cons (cons (LibrariesC-45TextC-45Lexer-digits) 1) (cons (cons (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45Lexer-alphaNum)) 0) '()))))))))
(define LibrariesC-45DataC-45Version-versionParser(blodwen-lazy (lambda () (vector 9 1 (csegen-2697) (lambda () (lambda (u--maj) (vector 11 1 (csegen-2705) (lambda () (vector 9 1 (csegen-2697) (lambda () (lambda (u--min) (vector 11 1 (csegen-2705) (lambda () (vector 9 0 (csegen-2697) (lambda () (lambda (u--patch) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (LibrariesC-45TextC-45Parser-match (csegen-2698) 3)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (LibrariesC-45TextC-45Parser-match (csegen-2698) 0))))) (lambda (u--optTag) (vector 0 (cons (cons u--maj (cons u--min u--patch)) u--optTag))))))))))))))))))))
(define LibrariesC-45DataC-45Version-showVersion (lambda (arg-0 arg-1) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((e-4 (car e-0))) (let ((e-5 (cdr e-0))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) (DataC-45List-intersperse "." (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_Nat eta-0)) (cons e-4 (cons e-8 (cons e-9 '())))))) (cond ((equal? arg-0 1) (LibrariesC-45DataC-45Version-n--3419-1958-u--showTag e-4 e-8 e-9 e-1 arg-0)) (else "")))))))))))
(define LibrariesC-45DataC-45Version-parseVersion (lambda (arg-0) (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-parse 1 (LibrariesC-45DataC-45Version-versionParser) (LibrariesC-45DataC-45Version-lexVersion arg-0)))) (case (vector-ref sc0 0) ((1) (let ((e-2 (vector-ref sc0 1))) (if (null? e-2) '() (let ((e-6 (cdr e-2))) (if (null? e-6) '() (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (if (null? e-10) (box e-9) '()))))))))(else '())))))
(define LibrariesC-45DataC-45Version-lexVersion (lambda (arg-0) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Core-lex (LibrariesC-45DataC-45Version-versionTokenMap) arg-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-7 (cdr e-3))) e-2))))))
(define IdrisC-45SetOptions-case--setIncrementalCG-3553 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (cond ((equal? arg-1 1) (let ((act-24 (let ((act-24 ((csegen-2712) clam-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Code generators available: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (CoreC-45Options-availableCGs (let ((e-4 (vector-ref arg-4 4))) e-4)))))) clam-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((csegen-1214) clam-0))) (vector 1 act-26))))))))) (else (vector 1 0))) (let ((e-1 (unbox arg-5))) (let ((act-24 (IdrisC-45ProcessIdr-getCG arg-2 arg-3 e-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-2 (unbox e-5))) (let ((e-4 (vector-ref e-2 2))) (if (null? e-4) (cond ((equal? arg-1 1) (let ((act-25 (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 arg-0 " does not support incremental builds")) clam-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 ((csegen-1214) clam-0))) (vector 1 act-26)))))) (else (vector 1 0))) (let ((act-25 (CoreC-45Context-getSession arg-3 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (CoreC-45Context-setSession arg-3 (let ((e-32 (vector-ref e-8 0))) (let ((e-31 (vector-ref e-8 1))) (let ((e-30 (vector-ref e-8 2))) (let ((e-29 (vector-ref e-8 3))) (let ((e-28 (vector-ref e-8 4))) (let ((e-27 (vector-ref e-8 5))) (let ((e-26 (vector-ref e-8 6))) (let ((e-25 (vector-ref e-8 7))) (let ((e-24 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (vector e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 (cons e-1 e-21) e-22 e-23))))))))))))))))))))))))) clam-0))))))))))))))))))
(define IdrisC-45SetOptions-case--pkgDir-2441 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-2) (vector arg-0 e-3 '()) (let ((sc2 (IdrisC-45SetOptions-n--11736-2387-u--toVersion arg-0 e-3))) (if (null? sc2) (vector arg-0 arg-0 '()) (let ((e-1 (unbox sc2))) (vector arg-0 (PreludeC-45Interfaces-concat (csegen-67) (DataC-45List-intersperse "-" e-2)) (box e-1))))))))))
(define IdrisC-45SetOptions-n--12340-2944-u--viable (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45SetOptions-n--12340-2942-u--notHidden arg-0 arg-1))) (cond ((equal? sc0 1) (IdrisC-45SetOptions-n--12340-2943-u--notDenylisted arg-0 arg-1)) (else 0)))))
(define IdrisC-45SetOptions-n--11736-2387-u--toVersion (lambda (arg-0 ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) eta-0) (DataC-45List1-u--traverse_Traversable_List1 (csegen-271) (lambda (eta-0) (DataC-45String-parsePositive (csegen-118) eta-0)) (DataC-45String-split (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\.)) ext-0)))))
(define IdrisC-45SetOptions-n--12636-3258-u--prefixes (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons e-2 (PreludeC-45Types-u--map_Functor_List (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 e-2 ".") arg-1)) (IdrisC-45SetOptions-n--12636-3258-u--prefixes e-3))))))))
(define IdrisC-45SetOptions-n--12459-3078-u--pkgDesc (lambda (arg-0 arg-1 arg-2) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_C-40MaybeC-32C-36aC-41 (cons (lambda (u--ann) (lambda (arg-5185) (IdrisC-45PackageC-45Types-u--pretty_Pretty_PkgVersion arg-5185))) (lambda (u--ann) (lambda (arg-5186) (lambda (arg-5187) (IdrisC-45PackageC-45Types-u--prettyPrec_Pretty_PkgVersion arg-5186 arg-5187))))) e-2)))))))
(define IdrisC-45SetOptions-n--12340-2942-u--notHidden (lambda (arg-0 ext-0) (let ((sc0 (DataC-45String-isPrefixOf "." (let ((e-1 (vector-ref ext-0 1))) e-1)))) (cond ((equal? sc0 1) 0) (else 1)))))
(define IdrisC-45SetOptions-n--12340-2943-u--notDenylisted (lambda (arg-0 ext-0) (let ((sc0 (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (PreludeC-45Types-elem (csegen-17) eta-0 eta-1))) (cons "include" (cons "lib" (cons "support" (cons "refc" '())))) (let ((e-1 (vector-ref ext-0 1))) e-1)))) (cond ((equal? sc0 1) 0) (else 1)))))
(define IdrisC-45SetOptions-n--11845-2498-u--getFiles (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((SystemC-45Directory-dirEntry (csegen-3) arg-1) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (IdrisC-45SetOptions-n--11845-2498-u--getFiles arg-0 arg-1 (cons e-2 arg-2) ext-0))) (else (PreludeC-45TypesC-45List-reverse arg-2))))))
(define IdrisC-45SetOptions-n--11948-2596-u--checkBounds (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 arg-1))) (cond ((equal? sc0 1) (IdrisC-45PackageC-45Types-inBounds e-2 arg-0)) (else 0)))) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 e-0) e-2)))))))))
(define IdrisC-45SetOptions-visiblePackages (lambda (arg-0) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-758) (lambda (eta-0) (DataC-45List-filter (lambda (eta-1) (IdrisC-45SetOptions-n--12340-2944-u--viable arg-0 eta-1)) eta-0)) (IdrisC-45SetOptions-getPackageDirs arg-0))))
(define IdrisC-45SetOptions-setIncrementalCG (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45SetOptions-case--setIncrementalCG-3553 arg-3 arg-2 arg-1 arg-0 e-5 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) arg-3)) ext-0)))))))
(define IdrisC-45SetOptions-prefixOnlyIfNonEmpty (lambda (arg-0) (lambda (clam-0) (cond ((equal? arg-0 "--") clam-0)(else (IdrisC-45SetOptions-prefixOnly arg-0 clam-0))))))
(define IdrisC-45SetOptions-prefixOnly (lambda (arg-0 ext-0) (LibrariesC-45DataC-45ListC-45Extra-sortedNub (csegen-261) (DataC-45List-filter (lambda (u--s) (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-0 u--s))) (cond ((equal? sc0 1) (DataC-45String-isPrefixOf arg-0 u--s)) (else 0)))) ext-0))))
(define IdrisC-45SetOptions-preOptions (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((12) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 1 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((1) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 3))) (let ((e-25 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 1 e-26 e-25 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((2) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-26 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-25 (vector-ref e-6 5))) (let ((e-24 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (vector e-0 e-1 1 e-26 e-4 e-25 e-24 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((23) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 1 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((24) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-24 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 1 e-26 e-4 e-25 e-24 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((0) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 1 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((9) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-26 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 1 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((13) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setOutput arg-1 (vector 1 1) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((5) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector 1 e-1 e-26 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((3) (let ((e-7 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) e-7))) (if (null? sc3) (let ((act-25 (let ((act-25 ((csegen-2712) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Code generators available: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) (CoreC-45Options-availableCGs (let ((e-4 (vector-ref e-5 4))) e-4)))))) eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 ((csegen-1214) eta-0))) (vector 1 act-27)))))))) (let ((e-1 (unbox sc3))) (let ((act-25 (CoreC-45Context-setCG arg-0 e-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))))))))))) ((4) (let ((e-8 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-24 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-27 e-26 e-4 (cons e-8 e-25) e-6 e-7 e-24 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((18) (let ((e-9 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45SetOptions-addPkgDir arg-0 e-9 (IdrisC-45PackageC-45Types-anyBounds) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((6) (let ((e-10 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-setSourceDir arg-0 (box e-10) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((7) (let ((e-11 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-setBuildDir arg-0 e-11 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((8) (let ((e-12 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-setOutputDir arg-0 (box e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((21) (let ((e-13 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45SetOptions-dirOption arg-0 arg-1 (let ((e-4 (vector-ref e-5 4))) (let ((e-44 (vector-ref e-4 0))) e-44)) e-13 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 0))))))))))) ((19) (lambda (eta-0) (let ((act-24 (IdrisC-45SetOptions-listPackages arg-0 arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 0)))))) ((34) (lambda (eta-0) (let ((act-24 (CoreC-45Context-setLogTimings arg-0 1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((35) (lambda (eta-0) (let ((act-24 (CoreC-45Context-setDebugElabCheck arg-0 1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((36) (let ((e-14 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-24 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-24 e-15 e-16 e-14 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((31) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setOutput arg-1 (vector 1 1) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (let ((act-25 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-27 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-26 (vector-ref e-6 5))) (let ((e-25 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-24 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (vector e-0 e-1 1 e-27 e-4 e-26 e-25 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-24 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))))) ((33) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-26 1 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((32) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-26 e-25 e-4 e-24 e-6 1 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((27) (let ((e-16 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-24 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 (box e-16) e-13 e-14 e-15 e-24 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((28) (let ((e-17 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-24 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (box e-17) e-14 e-15 e-16 e-24 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((29) (let ((e-18 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-24 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 (box e-18) e-15 e-16 e-17 e-24 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((30) (let ((e-19 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-24 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 (box e-19) e-16 e-17 e-18 e-24 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((17) (let ((e-20 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-24 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 1 (CoreC-45OptionsC-45Log-insertLogLevel e-20 e-9) e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-24 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((15) (let ((e-21 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setConsoleWidth arg-1 e-21 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((16) (let ((e-22 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setColor arg-1 e-22 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((37) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-26 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 1 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((38) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-26 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 0 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((39) (lambda (eta-0) (let ((act-24 (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "-Xcheck-hashes disabled (see issue #1935)") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (let ((act-25 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-27 (vector-ref e-6 2))) (let ((e-26 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-25 (vector-ref e-6 5))) (let ((e-24 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-24 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 1 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))))) ((40) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (vector e-0 e-1 e-26 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 1)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((41) (let ((e-23 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (IdrisC-45SetOptions-setIncrementalCG arg-0 arg-1 1 e-23 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))))))) ((42) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-26 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 1 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((43) (let ((e-24 (vector-ref e-2 1))) (let ((e-25 (vector-ref e-2 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45SetOptions-opts arg-0 e-24 e-25) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((PreludeC-45IO-putStr (csegen-3) (DataC-45String-fastUnlines e-5)) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 0)))))))))))) ((44) (let ((e-26 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (IdrisC-45SetOptions-completionScript e-26)) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 0))))))) ((45) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-26 (vector-ref e-5 2))) (let ((e-25 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-24 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 0 e-26 e-25 e-4 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))(else (IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3))))))))
(define IdrisC-45SetOptions-postOptions (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 1)) (case (vector-ref arg-5 0) ((11) (if (null? arg-6) (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (IdrisC-45REPL-compileExp arg-0 arg-1 arg-2 arg-3 arg-4 (csegen-2721) e-3 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 0)))))))))) ((2) (let ((e-4 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 0 (vector 2 ) (vector 1 (vector 0 e-4))) eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 0)))))))))) ((0) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 0)))))) ((31) (let ((e-5 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPL-replCmd arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 0)))))))(else (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2))))) (let ((e-9 (car arg-6))) (let ((e-10 (cdr arg-6))) (case (vector-ref e-9 0) ((1) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 0))))))(else (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (IdrisC-45REPL-compileExp arg-0 arg-1 arg-2 arg-3 arg-4 (csegen-2721) e-3 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 0)))))))))) ((2) (let ((e-4 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 0 (vector 2 ) (vector 1 (vector 0 e-4))) eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 0)))))))))) ((0) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 0)))))) ((31) (let ((e-5 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPL-replCmd arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 0)))))))(else (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2)))))))))))(else (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (IdrisC-45REPL-compileExp arg-0 arg-1 arg-2 arg-3 arg-4 (csegen-2721) e-3 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 0)))))))))) ((2) (let ((e-4 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 0 (vector 2 ) (vector 1 (vector 0 e-4))) eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 0)))))))))) ((0) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 0)))))) ((31) (let ((e-5 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPL-replCmd arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 0)))))))(else (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2))))))))))
(define IdrisC-45SetOptions-pkgDir (lambda (arg-0) (IdrisC-45SetOptions-case--pkgDir-2441 arg-0 (LibrariesC-45DataC-45List1-unsnoc (DataC-45String-split (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\-)) arg-0)))))
(define IdrisC-45SetOptions-opts (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 "--") (cond ((equal? arg-2 "idris2") (lambda (eta-0) (vector 1 (IdrisC-45CommandLine-optionFlags))))(else (cond ((equal? arg-2 "--cg") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-1) (IdrisC-45SetOptions-codegens arg-0 eta-1)) eta-0))) ((equal? arg-2 "--codegen") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-1) (IdrisC-45SetOptions-codegens arg-0 eta-1)) eta-0))) ((equal? arg-2 "-p") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (PreludeC-45Types-u--map_Functor_List (csegen-2722) e-5))))))) (lambda (eta-1) (IdrisC-45SetOptions-findPackages arg-0 eta-1)) eta-0))) ((equal? arg-2 "--package") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (PreludeC-45Types-u--map_Functor_List (csegen-2722) e-5))))))) (lambda (eta-1) (IdrisC-45SetOptions-findPackages arg-0 eta-1)) eta-0))) ((equal? arg-2 "--log") (lambda (eta-0) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (IdrisC-45SetOptions-logLevels)))))(else (cond ((equal? arg-1 "--") (lambda (clam-0) (cond ((equal? arg-2 "-o") (vector 1 '())) ((equal? arg-2 "--output") (vector 1 '())) ((equal? arg-2 "--source-dir") (vector 1 '())) ((equal? arg-2 "--build-dir") (vector 1 '())) ((equal? arg-2 "--output-dir") (vector 1 '()))(else (cond ((equal? arg-2 "--build") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--install") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--mkdoc") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--typecheck") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--clean") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--repl") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0))(else (vector 1 (let ((sc2 (PreludeC-45Types-elem (csegen-17) arg-1 (IdrisC-45CommandLine-optionFlags)))) (cond ((equal? sc2 1) '()) (else (IdrisC-45SetOptions-prefixOnly arg-1 (IdrisC-45CommandLine-optionFlags))))))))))))(else (lambda (clam-1) (cond ((equal? arg-2 "--build") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--install") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--mkdoc") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--typecheck") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--clean") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--repl") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1))(else (vector 1 (let ((sc1 (PreludeC-45Types-elem (csegen-17) arg-1 (IdrisC-45CommandLine-optionFlags)))) (cond ((equal? sc1 1) '()) (else (IdrisC-45SetOptions-prefixOnly arg-1 (IdrisC-45CommandLine-optionFlags))))))))))))))))(else (cond ((equal? arg-2 "--cg") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-1) (IdrisC-45SetOptions-codegens arg-0 eta-1)) eta-0))) ((equal? arg-2 "--codegen") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-1) (IdrisC-45SetOptions-codegens arg-0 eta-1)) eta-0))) ((equal? arg-2 "-p") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (PreludeC-45Types-u--map_Functor_List (csegen-2722) e-5))))))) (lambda (eta-1) (IdrisC-45SetOptions-findPackages arg-0 eta-1)) eta-0))) ((equal? arg-2 "--package") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (PreludeC-45Types-u--map_Functor_List (csegen-2722) e-5))))))) (lambda (eta-1) (IdrisC-45SetOptions-findPackages arg-0 eta-1)) eta-0))) ((equal? arg-2 "--log") (lambda (eta-0) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (IdrisC-45SetOptions-logLevels)))))(else (cond ((equal? arg-1 "--") (lambda (clam-1) (cond ((equal? arg-2 "-o") (vector 1 '())) ((equal? arg-2 "--output") (vector 1 '())) ((equal? arg-2 "--source-dir") (vector 1 '())) ((equal? arg-2 "--build-dir") (vector 1 '())) ((equal? arg-2 "--output-dir") (vector 1 '()))(else (cond ((equal? arg-2 "--build") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--install") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--mkdoc") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--typecheck") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--clean") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--repl") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1))(else (vector 1 (let ((sc1 (PreludeC-45Types-elem (csegen-17) arg-1 (IdrisC-45CommandLine-optionFlags)))) (cond ((equal? sc1 1) '()) (else (IdrisC-45SetOptions-prefixOnly arg-1 (IdrisC-45CommandLine-optionFlags))))))))))))(else (lambda (clam-3) (cond ((equal? arg-2 "--build") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--install") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--mkdoc") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--typecheck") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--clean") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--repl") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3))(else (vector 1 (let ((sc0 (PreludeC-45Types-elem (csegen-17) arg-1 (IdrisC-45CommandLine-optionFlags)))) (cond ((equal? sc0 1) '()) (else (IdrisC-45SetOptions-prefixOnly arg-1 (IdrisC-45CommandLine-optionFlags)))))))))))))))))
(define IdrisC-45SetOptions-logLevels(blodwen-lazy (lambda () (PreludeC-45Types-u--C-62C-62C-61_Monad_List (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (CoreC-45OptionsC-45Log-knownTopics)) (lambda (eta-0) (IdrisC-45SetOptions-n--12636-3258-u--prefixes (DataC-45List1-forget (DataC-45String-split (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 #\.)) eta-0))))))))
(define IdrisC-45SetOptions-localPackageDir (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((csegen-878) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") ext-0) (let ((e-1 (unbox e-6))) (let ((u--depends (let ((e-4 (vector-ref e-5 4))) (let ((e-43 (vector-ref e-4 0))) (let ((e-50 (vector-ref e-43 3))) e-50))))) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-1 u--depends)))))))))))))))
(define IdrisC-45SetOptions-listPackages (lambda (arg-0 arg-1 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45List-sortBy (lambda (eta-1) (lambda (eta-2) (PreludeC-45Basics-on (lambda (eta-3) (lambda (eta-4) (PreludeC-45EqOrd-u--compare_Ord_String eta-3 eta-4))) (csegen-2722) eta-1 eta-2))) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findPackages arg-0 eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-1 (IdrisC-45SetOptions-n--12459-3078-u--pkgDesc arg-1 arg-0 eta-0) eta-1))) e-5 ext-0)))))))
(define IdrisC-45SetOptions-ideModeSocket (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((24) 1)(else (IdrisC-45SetOptions-ideModeSocket e-3))))))))
(define IdrisC-45SetOptions-ideMode (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((23) 1)(else (IdrisC-45SetOptions-ideMode e-3))))))))
(define IdrisC-45SetOptions-globalPackageDir (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 0))) (let ((e-46 (vector-ref e-41 5))) e-46))) (csegen-1224)))))))))
(define IdrisC-45SetOptions-getPackageDirs (lambda (arg-0) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-758) (lambda (eta-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (IdrisC-45SetOptions-pkgDir eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SetOptions-dirEntries arg-0 eta-0)))))
(define IdrisC-45SetOptions-findPackages (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (IdrisC-45SetOptions-globalPackageDir arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45SetOptions-visiblePackages e-6) ext-0))) (vector 1 act-26)))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--pkgDirs (let ((e-4 (vector-ref e-5 4))) (let ((e-42 (vector-ref e-4 0))) (let ((e-45 (vector-ref e-42 7))) e-45))))) (let ((act-26 (let ((act-26 ((PreludeC-45Types-u--traverse_Traversable_List (csegen-5) (lambda (u--d) (IdrisC-45SetOptions-visiblePackages u--d)) u--pkgDirs) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (IdrisC-45SetOptions-localPackageDir arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((IdrisC-45SetOptions-visiblePackages e-8) ext-0))) (vector 1 act-28)))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-6 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--join_Monad_List e-7) e-8))))))))))))))))))))))
(define IdrisC-45SetOptions-findIpkg (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 ((csegen-878) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") ext-0) (let ((e-1 (unbox e-5))) (let ((act-25 (let ((act-25 (IdrisC-45SetOptions-dirEntries e-1 ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (DataC-45List-filter (lambda (arg-1) (DataC-45String-isSuffixOf ".ipkg" arg-1)) e-6))))))))))))))
(define IdrisC-45SetOptions-dirOption (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (cond ((equal? arg-3 0) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-5 (vector-ref arg-2 5))) e-5) (csegen-1224))) ext-0))) (vector 1 act-24))) ((equal? arg-3 2) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Options-toString arg-2)) ext-0)) (else (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (let ((e-5 (vector-ref arg-2 5))) e-5)) ext-0))) (vector 1 act-24))))))
(define IdrisC-45SetOptions-dirEntries (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45Directory-openDir (csegen-3) arg-0) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (IdrisC-45SetOptions-n--11845-2498-u--getFiles arg-0 e-2 '() ext-0))) (else '())))))
(define IdrisC-45SetOptions-completionScript (lambda (arg-0) (let ((u--funC-39 (PreludeC-45TypesC-45String-C-43C-43 "_" arg-0))) (DataC-45String-fastUnlines (cons (PreludeC-45TypesC-45String-C-43C-43 u--funC-39 "()") (cons "{" (cons "  ED=$([ -z $2 ] && echo \"--\" || echo $2)" (cons "  COMPREPLY=($(idris2 --bash-completion $ED $3))" (cons "}" (cons "" (cons (PreludeC-45TypesC-45String-C-43C-43 "complete -F " (PreludeC-45TypesC-45String-C-43C-43 u--funC-39 " -o default idris2")) '())))))))))))
(define IdrisC-45SetOptions-codegens (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) (CoreC-45Options-availableCGs (let ((e-4 (vector-ref e-5 4))) e-4)))))))) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0)))
(define IdrisC-45SetOptions-candidateDirs (lambda (arg-0 arg-1 arg-2) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-758) (lambda (eta-0) (DataC-45List-mapMaybe (lambda (eta-1) (IdrisC-45SetOptions-n--11948-2596-u--checkBounds arg-2 arg-1 arg-0 eta-1)) eta-0)) (IdrisC-45SetOptions-getPackageDirs arg-0))))
(define IdrisC-45SetOptions-addPkgDir (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45SetOptions-globalPackageDir arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45SetOptions-localPackageDir arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((IdrisC-45SetOptions-candidateDirs e-7 arg-1 arg-2) ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((IdrisC-45SetOptions-candidateDirs e-6 arg-1 arg-2) ext-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--pkgdirs (let ((e-4 (vector-ref e-5 4))) (let ((e-45 (vector-ref e-4 0))) (let ((e-48 (vector-ref e-45 7))) e-48))))) (let ((act-29 (let ((act-29 ((PreludeC-45Types-u--traverse_Traversable_List (csegen-5) (lambda (u--d) (IdrisC-45SetOptions-candidateDirs u--d arg-1 arg-2)) u--pkgdirs) ext-0))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--allFiles (let ((sc6 (DataC-45List-isNil e-8))) (cond ((equal? sc6 1) (PreludeC-45TypesC-45List-tailRecAppend e-9 (PreludeC-45Interfaces-concat (csegen-50) e-10))) (else e-8))))) (let ((u--sorted (DataC-45List-sortBy (lambda (u--x) (lambda (u--y) (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (vector (cons (lambda (arg-3) (lambda (arg-4) (IdrisC-45PackageC-45Types-u--C-61C-61_Eq_PkgVersion arg-3 arg-4))) (lambda (arg-4) (lambda (arg-5) (IdrisC-45PackageC-45Types-u--C-47C-61_Eq_PkgVersion arg-4 arg-5)))) (lambda (arg-418) (lambda (arg-419) (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (IdrisC-45PackageC-45Types-u--C-60C-61_Ord_PkgVersion arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (IdrisC-45PackageC-45Types-u--C-62C-61_Ord_PkgVersion arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (IdrisC-45PackageC-45Types-u--max_Ord_PkgVersion arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (IdrisC-45PackageC-45Types-u--min_Ord_PkgVersion arg-430 arg-431)))) (Builtin-snd u--y) (Builtin-snd u--x)))) u--allFiles))) (if (null? u--sorted) (let ((sc7 (let ((e-4 (vector-ref e-5 4))) (let ((e-44 (vector-ref e-4 2))) (let ((e-63 (vector-ref e-44 7))) e-63))))) (cond ((equal? sc7 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45PackageC-45Types-u--show_Show_PkgVersionBounds arg-2) ")")))) ext-0)))) (let ((e-2 (car u--sorted))) (let ((e-12 (car e-2))) (CoreC-45Context-addExtraDir arg-0 e-12 ext-0)))))))))))))))))))))))))))))))))
(define IdrisC-45REPL-case--process-11609 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Package not found in the known search directories")))) (let ((e-1 (unbox arg-8))) (let ((u--packageDirPath (LibrariesC-45UtilsC-45Path-parse e-1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (LibrariesC-45SystemC-45DirectoryC-45Tree-explore u--packageDirPath eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((IdrisC-45REPL-n--27284-11557-u--toPaths arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (LibrariesC-45UtilsC-45Path-parse "") (LibrariesC-45SystemC-45DirectoryC-45TreeC-45Tree-toRelative e-5)) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((PreludeC-45Basics-flip (csegen-1822) e-6 (lambda (u--entry) (let ((u--entryC-39 (LibrariesC-45UtilsC-45Path-dropExtension u--entry))) (let ((u--sp (DataC-45List1-forget (DataC-45String-split (lambda (arg-9) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-9 (LibrariesC-45UtilsC-45Path-dirSeparator))) u--entryC-39)))) (let ((u--ns (PreludeC-45Interfaces-concat (csegen-67) (DataC-45List-intersperse "." u--sp)))) (let ((u--nsC-39 (CoreC-45NameC-45Namespace-mkNamespace u--ns))) (lambda (eta-1) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-2) (let ((act-26 (IdrisC-45ProcessIdr-addImport arg-5 arg-4 arg-3 (vector (CoreC-45FC-emptyFC) 0 (CoreC-45NameC-45Namespace-nsAsModuleIdent u--nsC-39) u--nsC-39) eta-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 '()))))) (lambda (u--err) (lambda (eta-2) (vector 1 (box u--err)))) eta-1)))))))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--errsC-39 (DataC-45List-catMaybes e-7))) (let ((act-27 (if (null? u--errsC-39) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Done")) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Error-display arg-5 arg-3 arg-1 eta-1 eta-2))) u--errsC-39 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-8))))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 5 e-8)))))))))))))))))))))))))
(define IdrisC-45REPL-case--process-10803 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 (vector 13 ))) (let ((e-2 (unbox arg-6))) (let ((u--line (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (u--i) (PreludeC-45TypesC-45String-C-43C-43 " +" (PreludeC-45Show-u--show_Show_Int (bs+ u--i 1 63))))) (let ((e-7 (vector-ref arg-5 7))) e-7)))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-24 ((System-system (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (let ((e-6 (vector-ref arg-5 6))) e-6) (PreludeC-45TypesC-45String-C-43C-43 " \"" (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 "\"" u--line))))) eta-1))) (vector 1 act-24))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (IdrisC-45REPL-loadMainFile arg-4 arg-3 arg-2 arg-1 arg-0 e-2 eta-0))))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-7305 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 ext-0) (let ((e-2 (car arg-25))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPL-printClause arg-8 arg-6 e-2 arg-22 eta-0 eta-1))) arg-20 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? arg-3 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-0) (IdrisC-45REPL-addClause (LibrariesC-45DataC-45StringC-45Extra-unlines e-5) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer arg-2)) eta-0)) ext-0)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0)) e-5)))))))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-6611 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (lambda (clam-0) (let ((e-2 (car arg-22))) (let ((e-3 (cdr arg-22))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 (IdrisC-45Resugar-resugar e-2 arg-8 arg-6 e-6 e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--itmC-39 (cond ((equal? arg-11 1) (IdrisC-45Resugar-addBracket (CoreC-45FC-replFC) e-5)) (else e-5)))) (cond ((equal? arg-3 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-0) (IdrisC-45REPL-proofSearch arg-1 (IdrisC-45Syntax-u--show_Show_IPTerm u--itmC-39) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- arg-2 1 63))) eta-0)) clam-0)) (else (vector 1 (vector 0 (IdrisC-45REPL-prettyTerm u--itmC-39)))))))))))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32processEdit-6508 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 ext-0) (if (null? arg-20) (csegen-2746) (let ((e-0 (unbox arg-20))) (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-8 '() arg-9 '() arg-17 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-6611 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-0 e-5 (IdrisC-45REPL-dropLamsTm '() e-0 '() e-5)) ext-0)))))))))
(define IdrisC-45REPL-case--processEdit-5558 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (if (null? e-3) (lambda (clam-2) (if (null? e-2) (CoreC-45Context-undefinedName arg-7 (CoreC-45FC-replFC) arg-10 clam-2) (let ((e-5 (unbox e-2))) (vector 1 (vector 0 e-5))))) (let ((e-10 (unbox e-3))) (if (null? e-10) (lambda (clam-1) (if (null? e-2) (CoreC-45Context-undefinedName arg-7 (CoreC-45FC-replFC) arg-10 clam-1) (let ((e-5 (unbox e-2))) (vector 1 (vector 0 e-5))))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (if (null? e-14) (lambda (clam-0) (if (null? e-2) (CoreC-45Context-undefinedName arg-7 (CoreC-45FC-replFC) arg-10 clam-0) (let ((e-5 (unbox e-2))) (vector 1 (vector 0 e-5))))) (let ((e-18 (cdr e-14))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPL-displayTerm arg-7 arg-5 arg-8 e-18 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45REPL-n--21971-5351-u--prettyLocalName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-13) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) e-5))))))))))))))))))))
(define IdrisC-45REPL-case--findInTreeC-44startsWithUpper-5233 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 "") (if (null? arg-4) 0 (let ((e-0 (car arg-4))) (let ((sc3 (PreludeC-45Types-isUpper e-0))) (cond ((equal? sc3 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char e-0 (PreludeC-45Types-chr (blodwen-toSignedInt 160 63)))))))))(else (let ((e-0 (car arg-4))) (let ((sc1 (PreludeC-45Types-isUpper e-0))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char e-0 (PreludeC-45Types-chr (blodwen-toSignedInt 160 63)))))))))))
(define IdrisC-45REPL-case--nextGenDef-4850 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 '()) (let ((e-1 (unbox arg-5))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-24 (TTImpC-45InteractiveC-45ExprSearch-nextResult arg-3 arg-2 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (if (null? e-7) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref arg-4 0))) (let ((e-20 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((e-19 (vector-ref arg-4 5))) (let ((e-18 (vector-ref arg-4 6))) (let ((e-17 (vector-ref arg-4 7))) (let ((e-8 (vector-ref arg-4 8))) (let ((e-9 (vector-ref arg-4 9))) (let ((e-10 (vector-ref arg-4 10))) (let ((e-12 (vector-ref arg-4 12))) (let ((e-13 (vector-ref arg-4 13))) (let ((e-14 (vector-ref arg-4 14))) (let ((e-15 (vector-ref arg-4 15))) (let ((e-16 (vector-ref arg-4 16))) (vector e-0 e-20 e-2 e-3 e-4 e-19 e-18 e-17 e-8 e-9 e-10 '() e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '())))) (let ((e-2 (unbox e-7))) (let ((e-9 (car e-2))) (let ((e-8 (cdr e-2))) (let ((act-25 (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref arg-4 0))) (let ((e-23 (vector-ref arg-4 1))) (let ((e-22 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((e-21 (vector-ref arg-4 5))) (let ((e-20 (vector-ref arg-4 6))) (let ((e-19 (vector-ref arg-4 7))) (let ((e-18 (vector-ref arg-4 8))) (let ((e-17 (vector-ref arg-4 9))) (let ((e-10 (vector-ref arg-4 10))) (let ((e-12 (vector-ref arg-4 12))) (let ((e-13 (vector-ref arg-4 13))) (let ((e-14 (vector-ref arg-4 14))) (let ((e-15 (vector-ref arg-4 15))) (let ((e-16 (vector-ref arg-4 16))) (vector e-0 e-23 e-22 e-3 e-4 e-21 e-20 e-19 e-18 e-17 e-10 (box (cons e-5 e-8)) e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (cond ((equal? arg-0 0) (vector 1 (box (cons e-5 e-9))))(else (let ((e-0 (- arg-0 1))) (IdrisC-45REPL-nextGenDef arg-3 arg-2 arg-1 e-0 clam-0))))))))))))))))))))))
(define IdrisC-45REPL-case--nextProofSearch-4652 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 '()) (let ((e-1 (unbox arg-4))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-24 (TTImpC-45InteractiveC-45ExprSearch-nextResult arg-2 arg-1 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (if (null? e-7) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref arg-3 0))) (let ((e-20 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-18 (vector-ref arg-3 6))) (let ((e-17 (vector-ref arg-3 7))) (let ((e-8 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (vector e-0 e-20 e-2 e-3 e-4 e-19 e-18 e-17 e-8 e-9 '() e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '())))) (let ((e-2 (unbox e-7))) (let ((e-9 (car e-2))) (let ((e-8 (cdr e-2))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref arg-3 0))) (let ((e-23 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-21 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-19 (vector-ref arg-3 7))) (let ((e-18 (vector-ref arg-3 8))) (let ((e-17 (vector-ref arg-3 9))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (vector e-0 e-23 e-22 e-3 e-4 e-21 e-20 e-19 e-18 e-17 (box (cons e-5 e-8)) e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 (box (cons e-5 e-9)))))))))))))))))))))
(define IdrisC-45REPL-case--updateFile-4224 (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))) (let ((e-1 (unbox arg-3))) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) e-1) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 e-1 "~") e-2) eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-26 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) e-1 (LibrariesC-45DataC-45StringC-45Extra-unlines (arg-0 (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines e-2))))) eta-0))) (vector 1 act-26))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-1 e-6) ext-0))))))))))))
(define IdrisC-45REPL-n--27284-11557-u--toPaths (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (LibrariesC-45SystemC-45DirectoryC-45Tree-depthFirst (lambda (root-11571) (lambda (u--x) (lambda (eta-0) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO (lambda (arg-8) (cons (LibrariesC-45SystemC-45DirectoryC-45Tree-toFilePath root-11571 u--x) arg-8)) (eta-0) eta-4))))) arg-6 arg-7 (lambda (eta-0) '()))))
(define IdrisC-45REPL-n--21797-5166-u--startsWithUpper (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45REPL-case--findInTreeC-44startsWithUpper-5233 arg-0 arg-1 arg-2 arg-3 (DataC-45String-strM arg-3))))
(define IdrisC-45REPL-n--20937-4408-u--replaceStr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 "") "")(else (let ((sc0 (DataC-45String-isPrefixOf arg-4 arg-6))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 arg-5 (PreludeC-45Types-fastPack (DataC-45List-drop (PreludeC-45TypesC-45String-length arg-4) (PreludeC-45Types-fastUnpack arg-6))))) (else (PreludeC-45Types-strCons (string-ref arg-6 0) (IdrisC-45REPL-n--20937-4408-u--replaceStr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (substring arg-6 1 (string-length arg-6)))))))))))
(define IdrisC-45REPL-n--29779-12275-u--prompt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-5 0) "[tc] ") ((equal? arg-5 1) "") ((equal? arg-5 2) "[exec] ") (else "[scheme] "))))
(define IdrisC-45REPL-n--21971-5351-u--prettyLocalName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((1) (CoreC-45Name-u--pretty_Pretty_Name arg-8)) ((0) (let ((e-2 (vector-ref arg-8 2))) (case (vector-ref e-2 0) ((1) (CoreC-45Name-u--pretty_Pretty_Name arg-8))(else (let ((sc1 (CoreC-45Name-userNameRoot arg-8))) (if (null? sc1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Name-nameRoot arg-8)) (let ((e-3 (unbox sc1))) (CoreC-45Name-u--pretty_Pretty_UserName e-3))))))))(else (let ((sc0 (CoreC-45Name-userNameRoot arg-8))) (if (null? sc0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Name-nameRoot arg-8)) (let ((e-1 (unbox sc0))) (CoreC-45Name-u--pretty_Pretty_UserName e-1))))))))
(define IdrisC-45REPL-n--21797-5167-u--matchingRoots (lambda (arg-0 arg-1 arg-2 ext-0 ext-1) (PreludeC-45Basics-on (lambda (eta-0) (lambda (eta-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String eta-0 eta-1))) (lambda (eta-0) (CoreC-45Name-nameRoot eta-0)) ext-0 ext-1)))
(define IdrisC-45REPL-n--21797-5169-u--match (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (let ((sc1 (CoreC-45Name-matches arg-1 e-3))) (cond ((equal? sc1 1) (IdrisC-45REPL-n--21797-5168-u--checkCandidate arg-0 arg-1 arg-2 e-3)) (else 0))))))
(define IdrisC-45REPL-n--29817-12970-u--makeSpace (lambda (arg-0) (PreludeC-45Types-fastPack (PreludeC-45Types-take arg-0 (DataC-45Stream-repeat #\ )))))
(define IdrisC-45REPL-n--21018-4479-u--insertInBlank (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (cons (ParserC-45Unlit-relit arg-6 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-4) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "\xa;")))) '()) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String (DataC-45String-trim e-2) ""))) (cond ((equal? sc1 1) (cons (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (ParserC-45Unlit-relit arg-6 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-4) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 arg-3 "\xa;"))))) e-3)) (else (cons e-2 (IdrisC-45REPL-n--21018-4479-u--insertInBlank arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))
(define IdrisC-45REPL-n--29509-11951-u--getLoad (lambda (arg-0 arg-1 arg-2 arg-3) (box (arg-2 (DataC-45String-trim (PreludeC-45Types-substr arg-1 (PreludeC-45TypesC-45String-length arg-3) arg-3))))))
(define IdrisC-45REPL-n--29509-11952-u--fnameCmd (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (DataC-45String-isPrefixOf e-6 arg-2))) (cond ((equal? sc2 1) (IdrisC-45REPL-n--29509-11951-u--getLoad arg-0 (PreludeC-45TypesC-45String-length e-6) e-7 arg-2)) (else (IdrisC-45REPL-n--29509-11952-u--fnameCmd arg-0 e-3 arg-2)))))))))))
(define IdrisC-45REPL-n--26574-9285-u--execDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 ((IdrisC-45Desugar-desugarDecl arg-3 arg-5 arg-4 arg-2 '() arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-resolveName arg-5 (vector 1 (vector 0 "[defs]")) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-newRef (vector "TTImp.Elab.Check.EST" ) (TTImpC-45ElabC-45Check-initEStateSub '() e-6 '() (vector 0 )) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45REPL-getItDecls arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (IdrisC-45REPL-processLocal '() arg-5 arg-2 arg-4 e-7 arg-3 '() '() '() e-8 e-5 ext-0)))))))))))))))))))
(define IdrisC-45REPL-n--27179-9825-u--elabMode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-7 0) (vector 0 ))(else (vector 2 )))))
(define IdrisC-45REPL-n--29817-12971-u--col (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45REPL-n--29817-12970-u--makeSpace (PreludeC-45Types-prim__integerToNat (- arg-0 (PreludeC-45TypesC-45String-length arg-2)))) (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45REPL-n--29817-12970-u--makeSpace (PreludeC-45Types-prim__integerToNat (- arg-1 (PreludeC-45TypesC-45String-length arg-3)))) arg-4))))))
(define IdrisC-45REPL-n--21797-5164-u--cmp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (let ((e-14 (car arg-4))) (let ((e-15 (cdr arg-4))) (let ((e-18 (car e-14))) (let ((e-19 (cdr e-14))) (let ((e-22 (car e-15))) (let ((e-23 (cdr e-15))) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-224) (csegen-224) (cons (bs- e-10 e-6 63) (bs- e-11 e-7 63)) (cons (bs- e-22 e-18 63) (bs- e-23 e-19 63)))))))))))))))))
(define IdrisC-45REPL-n--29817-12972-u--cmdInfo (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (PreludeC-45TypesC-45String-C-43C-43 " " (IdrisC-45REPL-n--29817-12971-u--col (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))) (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (CoreC-45NameC-45Namespace-showSep " " e-2) (IdrisC-45Parser-u--show_Show_CmdArg e-6) e-7))))))))
(define IdrisC-45REPL-n--21797-5168-u--checkCandidate (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (IdrisC-45REPL-n--21797-5167-u--matchingRoots arg-0 arg-1 arg-2 arg-1 arg-3))) (cond ((equal? sc0 1) 1) (else ((case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (lambda () (let ((sc3 (IdrisC-45REPL-n--21797-5166-u--startsWithUpper arg-0 arg-1 arg-2 e-1))) (cond ((equal? sc3 1) (IdrisC-45REPL-n--21797-5165-u--checkAsNamespace arg-0 arg-1 arg-2 e-1 arg-3)) (else 0))))))(else (lambda () 0)))))(else (lambda () 0)))))))))
(define IdrisC-45REPL-n--21797-5165-u--checkAsNamespace (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-0 (vector-ref arg-4 1))) (CoreC-45NameC-45Namespace-isInPathOf arg-3 e-0)))(else 0))))
(define IdrisC-45REPL-n--21148-4595-u--addW (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-4 0) (if (null? arg-6) '() (let ((e-3 (cdr arg-6))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-reverse arg-5) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (ParserC-45Unlit-relit arg-3 eta-0)) arg-2) e-3)))))(else (let ((e-0 (- arg-4 1))) (if (null? arg-6) (PreludeC-45TypesC-45List-reverse arg-5) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (IdrisC-45REPL-n--21148-4595-u--addW arg-0 arg-1 arg-2 arg-3 e-0 (cons e-6 arg-5) e-7)))))))))
(define IdrisC-45REPL-n--21018-4480-u--addApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (cond ((equal? arg-7 0) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-reverse (IdrisC-45REPL-n--21018-4479-u--insertInBlank arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8)) arg-9))(else (let ((e-0 (- arg-7 1))) (if (null? arg-9) (PreludeC-45TypesC-45List-reverse arg-8) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (IdrisC-45REPL-n--21018-4480-u--addApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-0 (cons e-2 arg-8) e-3)))))))))
(define IdrisC-45REPL-updateFile (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45REPL-case--updateFile-4224 arg-1 arg-0 e-5 (let ((e-3 (vector-ref e-5 3))) e-3) ext-0)))))))
(define IdrisC-45REPL-showInfo (lambda (arg-0 arg-1) (lambda (clam-0) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-3))) (let ((act-24 (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-1050) (let ((e-17 (vector-ref e-7 17))) e-17) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref e-7 1))) e-1)) (PreludeC-45TypesC-45String-C-43C-43 " ==> " (CoreC-45ContextC-45Context-u--show_Show_Def e-5)))) eta-0))) (vector 1 act-25))) clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega (let ((e-22 (vector-ref e-7 7))) e-22))) eta-0))) (vector 1 act-25))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Erasable args: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-775) (let ((e-26 (vector-ref e-7 3))) e-26)))) eta-0))) (vector 1 act-26))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-27 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Detaggable arg types: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-775) (let ((e-4 (vector-ref e-7 4))) e-4)))) eta-0))) (vector 1 act-27))) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Specialise args: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-775) (let ((e-27 (vector-ref e-7 5))) e-27)))) eta-0))) (vector 1 act-28))) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-29 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Inferrable args: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-775) (let ((e-27 (vector-ref e-7 6))) e-27)))) eta-0))) (vector 1 act-29))) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (let ((e-18 (vector-ref e-7 18))) (if (null? e-18) (vector 1 0) (let ((e-32 (unbox e-18))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-30 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Compiled: " (CoreC-45CompileExpr-u--show_Show_CDef e-32))) eta-0))) (vector 1 act-30))) clam-0)))))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (let ((act-31 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-getFullName arg-0 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-7)) '() clam-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-31 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-32 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Refers to: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-14))) eta-0))) (vector 1 act-32))) clam-0))))))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (let ((act-32 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-getFullName arg-0 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersToRuntime e-7)) '() clam-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-32 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-33 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Refers to (runtime): " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-15))) eta-0))) (vector 1 act-33))) clam-0))))))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((act-33 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-33 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Flags: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_DefFlag u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_DefFlag u--d u--x)))) (let ((e-26 (vector-ref e-7 11))) e-26)))) eta-0))) (vector 1 act-33))) clam-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((act-34 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-0 (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_SCCall arg-4060 arg-4061 eta-2)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_SCCall arg-4062 arg-4063 eta-2))))) eta-0 eta-1))) (let ((e-20 (vector-ref e-7 20))) e-20) '() clam-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-34 1))) (let ((sc13 (DataC-45List-isNil (let ((e-20 (vector-ref e-7 20))) e-20)))) (cond ((equal? sc13 1) (vector 1 0)) (else (((let ((u--scinfo (PreludeC-45Types-u--map_Functor_List (lambda (u--s) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-0 (car u--s))) e-0)) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-770) (let ((e-1 (cdr u--s))) e-1))))) e-17))) (lambda () (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-35 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Size change: " (CoreC-45NameC-45Namespace-showSep ", " u--scinfo))) eta-1))) (vector 1 act-35))) eta-0))))) clam-0)))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45REPL-setOpt (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setPPrint arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (vector e-0 e-1 e-2))) ext-0))))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-3 (vector-ref e-5 1))) (vector e-0 e-3 e-1))) ext-0))))))) ((2) (let ((e-2 (vector-ref arg-2 1))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((e-1 (vector-ref e-5 1))) (let ((e-18 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-2 e-1 e-18 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))))))) ((3) (let ((e-3 (vector-ref arg-2 1))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 2))) (let ((e-18 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-3 e-2 e-18 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))))))) ((4) (let ((e-4 (vector-ref arg-2 1))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-18 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-18 e-17 e-4 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))))))) ((5) (let ((e-5 (vector-ref arg-2 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((sc2 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-6 4))) e-4) e-5))) (if (null? sc2) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No such code generator available") ext-0) (let ((e-1 (unbox sc2))) (CoreC-45Context-setCG arg-0 e-1 ext-0)))))))))) ((6) (let ((e-6 (vector-ref arg-2 1))) (let ((act-24 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-24 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-2 e-3 e-4 e-25 e-24 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-6 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) ext-0))))))) (else (let ((e-7 (vector-ref arg-2 1))) (IdrisC-45REPLC-45Opts-setEvalTiming arg-1 e-7 ext-0))))))
(define IdrisC-45REPL-rtrim (lambda (arg-0) (PreludeC-45Types-reverse (DataC-45String-ltrim (PreludeC-45Types-reverse arg-0)))))
(define IdrisC-45REPL-replEval (lambda (arg-0 arg-1 arg-2 ext-1 ext-0) (lambda (clam-0) (cond ((equal? arg-2 1) (lambda (eta-0) (CoreC-45Normalise-normaliseOpts arg-0 arg-1 (let ((sc1 (CoreC-45Value-withAll))) (let ((e-0 (vector-ref sc1 0))) (let ((e-1 (vector-ref sc1 1))) (let ((e-2 (vector-ref sc1 2))) (let ((e-3 (vector-ref sc1 3))) (let ((e-4 (vector-ref sc1 4))) (let ((e-5 (vector-ref sc1 5))) (let ((e-6 (vector-ref sc1 6))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 0))))))))) ext-1 ext-0 clam-0 eta-0)))(else (lambda (eta-0) (CoreC-45Normalise-normalise arg-0 arg-1 ext-1 ext-0 clam-0 eta-0)))))))
(define IdrisC-45REPL-replCmd (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (cond ((equal? arg-5 "") (vector 1 0))(else (let ((act-24 (IdrisC-45REPL-interpret arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45REPL-displayResult arg-0 arg-1 arg-2 arg-3 arg-4 e-5) ext-0)))))))))
(define IdrisC-45REPL-repl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-getNS arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-4))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-26 ((PreludeC-45IO-putStr (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45REPL-n--29779-12275-u--prompt arg-4 arg-3 arg-2 arg-1 arg-0 (let ((e-1 (vector-ref e-6 1))) e-1)) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-5) "> "))) eta-0))) (vector 1 act-26))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-27 ((csegen-2764) eta-0))) (vector 1 act-27))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 ((csegen-1268) ext-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 ((SystemC-45FileC-45ReadWrite-fEOF (csegen-3) (SystemC-45FileC-45Virtual-stdin)) ext-0))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (cond ((equal? e-10 1) (let ((act-30 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-30 ((PreludeC-45IO-putStrLn (csegen-3) "") eta-0))) (vector 1 act-30))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Bye for now!") ext-0))))) (else (let ((act-30 (IdrisC-45REPL-interpret arg-0 arg-1 arg-2 arg-3 arg-4 e-9 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (IdrisC-45REPL-handleResult arg-0 arg-1 arg-2 arg-3 arg-4 e-11 ext-0)))))))))))))))))))))))))))))))
(define IdrisC-45REPL-proofSearch (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) (if (null? arg-3) '() (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (cons (IdrisC-45REPL-n--20937-4408-u--replaceStr e-3 e-4 arg-1 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "?" (CoreC-45Name-u--show_Show_Name arg-0)) arg-1 e-3) e-4)))))(else (let ((e-1 (- arg-2 1))) (if (null? arg-3) '() (let ((e-6 (car arg-3))) (let ((e-7 (cdr arg-3))) (cons e-6 (IdrisC-45REPL-proofSearch arg-0 arg-1 e-1 e-7))))))))))
(define IdrisC-45REPL-processLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (TTImpC-45ElabC-45Local-localHelper arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 (lambda (u--nestC-39) (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (eta-1) (TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 u--nestC-39 arg-8 eta-1)) arg-10 eta-0))) ext-0)))
(define IdrisC-45REPL-processEdit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-3))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--name (DataC-45Maybe-fromMaybe (lambda () e-2) (IdrisC-45REPL-findInTree (cons (bs- e-0 1 63) e-1) e-2 (let ((e-11 (vector-ref e-6 5))) e-11))))) (let ((act-26 ((CoreC-45Context-lookupCtxtName u--name (let ((e-35 (vector-ref e-5 0))) e-35)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (if (null? e-7) (vector 1 '()) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45REPL-displayType arg-0 arg-2 e-5 eta-1)) e-7 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-8)))))))))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Metadata-findTypeAt arg-3 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPL-anyAt (lambda (eta-3) (CoreC-45FC-within (cons (bs- e-0 1 63) e-1) eta-3)) eta-1 eta-2))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) ((IdrisC-45REPL-case--processEdit-5558 e-2 e-1 e-0 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 u--name e-7 e-8 e-9 (cons e-8 e-9)) eta-0))))))))))))))))))))))))))) ((1) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (let ((e-6 (vector-ref arg-5 4))) (let ((u--find (lambda (clam-0) (let ((sc1 (PreludeC-45EqOrd-u--C-62_Ord_Int e-5 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (CoreC-45FC-within (cons (bs- e-4 1 63) (bs- e-5 1 63)) clam-0)) (else (CoreC-45FC-onLine (bs- e-4 1 63) clam-0))))))) (lambda (eta-0) (let ((act-24 (TTImpC-45InteractiveC-45CaseSplit-getSplits arg-0 arg-3 arg-1 arg-2 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPL-anyAt u--find eta-1 eta-2))) e-6 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (case (vector-ref e-7 0) ((1) (let ((e-1 (vector-ref e-7 1))) (let ((act-25 (IdrisC-45IDEModeC-45CaseSplit-updateCase arg-0 arg-2 arg-4 e-1 (bs- e-4 1 63) (bs- e-5 1 63) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (cond ((equal? e-3 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-1) (IdrisC-45REPL-caseSplit (LibrariesC-45DataC-45StringC-45Extra-unlines e-8) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- e-4 1 63))) eta-1)) eta-0)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) e-8)))))))))))) (else (let ((e-8 (vector-ref e-7 1))) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (TTImpC-45InteractiveC-45CaseSplit-u--show_Show_SplitError e-8)))))))))))))))))) ((2) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45CaseSplit-getClause arg-0 arg-3 arg-4 e-8 e-9 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not defined here")))) (let ((e-1 (unbox e-5))) (cond ((equal? e-7 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-1) (IdrisC-45REPL-addClause e-1 (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer e-8)) eta-1)) eta-0)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-1)))))))))))))))) ((3) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (let ((e-13 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--brack (DataC-45List-elemBy (csegen-1408) e-12 (let ((e-8 (vector-ref e-6 8))) e-8)))) (let ((act-26 (CoreC-45Context-lookupDefName e-12 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Unknown name") (CoreC-45Name-u--pretty_Pretty_Name e-12)))) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) (csegen-2746) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (if (null? e-8) (csegen-2746) (let ((e-15 (car e-8))) (let ((e-14 (cdr e-8))) (case (vector-ref e-14 0) ((7) (let ((e-17 (vector-ref e-14 1))) (if (null? e-2) (let ((u--searchtm (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-exprSearch arg-0 arg-3 arg-1 arg-2 (CoreC-45FC-replFC) e-12 '() eta-1)))) (let ((act-27 (let ((act-27 (unbox arg-4))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-18 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-4 (let ((e-0 (vector-ref e-18 0))) (let ((e-32 (vector-ref e-18 1))) (let ((e-31 (vector-ref e-18 2))) (let ((e-3 (vector-ref e-18 3))) (let ((e-4 (vector-ref e-18 4))) (let ((e-30 (vector-ref e-18 5))) (let ((e-29 (vector-ref e-18 6))) (let ((e-28 (vector-ref e-18 7))) (let ((e-27 (vector-ref e-18 8))) (let ((e-26 (vector-ref e-18 9))) (let ((e-24 (vector-ref e-18 11))) (let ((e-23 (vector-ref e-18 12))) (let ((e-22 (vector-ref e-18 13))) (let ((e-21 (vector-ref e-18 14))) (let ((e-20 (vector-ref e-18 15))) (let ((e-19 (vector-ref e-18 16))) (vector e-0 e-32 e-31 e-3 e-4 e-30 e-29 e-28 e-27 e-26 (box (cons e-12 u--searchtm)) e-24 e-23 e-22 e-21 e-20 e-19)))))))))))))))))))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((act-29 (let ((act-29 (unbox arg-0))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (IdrisC-45REPL-nextProofSearch arg-0 arg-1 arg-4 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((e-21 (vector-ref act-30 1))) (if (null? e-21) (csegen-2768) (let ((e-3 (unbox e-21))) (let ((e-22 (cdr e-3))) (let ((u--tmC-39 (IdrisC-45REPL-dropLams e-17 e-22))) (let ((act-31 (IdrisC-45Resugar-pterm arg-0 arg-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) u--tmC-39) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-24 (vector-ref act-31 1))) (let ((u--itmC-39 (cond ((equal? u--brack 1) (IdrisC-45Resugar-addBracket (CoreC-45FC-replFC) e-24)) (else e-24)))) (cond ((equal? e-10 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-1) (IdrisC-45REPL-proofSearch e-12 (IdrisC-45Syntax-u--show_Show_IPTerm u--itmC-39) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- e-11 1 63))) eta-1)) eta-0)) (else (vector 1 (vector 0 (IdrisC-45REPL-prettyTerm u--itmC-39))))))))))))))))))))))))))))) (csegen-2746)))) ((1) (let ((e-20 (vector-ref e-14 1))) (let ((e-19 (vector-ref e-14 2))) (let ((e-16 (vector-ref e-14 3))) (let ((e-17 (vector-ref e-14 4))) (let ((e-18 (vector-ref e-14 5))) (if (null? e-19) (case (vector-ref e-16 0) ((1) (let ((e-22 (vector-ref e-16 1))) (let ((e-23 (vector-ref e-16 2))) (if (null? e-2) (let ((bind-0 (cons (cons e-9 (cons e-15 (vector 1 e-20 '() (vector 1 e-22 e-23) e-17 e-18))) '()))) (IdrisC-45REPL-case--caseC-32blockC-32inC-32processEdit-6508 e-13 e-12 e-11 e-10 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 u--brack e-17 e-18 e-22 e-9 e-15 e-23 e-20 bind-0 (let ((e-0 (vector-ref e-20 0))) e-0) eta-0)) (csegen-2746)))))(else (csegen-2746))) (csegen-2746))))))))(else (csegen-2746))))))))))))))))))))))))))))))) ((4) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45REPL-nextProofSearch arg-0 arg-1 arg-4 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (csegen-2776) (let ((e-1 (unbox e-7))) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (let ((act-27 (CoreC-45Context-lookupDefName e-9 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-27 1))) (if (null? e-10) (csegen-2746) (let ((e-3 (car e-10))) (let ((e-2 (cdr e-10))) (if (null? e-3) (csegen-2746) (let ((e-11 (cdr e-3))) (if (null? e-11) (csegen-2746) (let ((e-13 (cdr e-11))) (case (vector-ref e-13 0) ((7) (let ((e-16 (vector-ref e-13 1))) (if (null? e-2) (let ((u--brack (DataC-45List-elemBy (csegen-1408) e-9 (let ((e-19 (vector-ref e-6 8))) e-19)))) (let ((u--tmC-39 (IdrisC-45REPL-dropLams e-16 e-8))) (let ((act-28 (IdrisC-45Resugar-pterm arg-0 arg-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) u--tmC-39) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-28 1))) (let ((u--itmC-39 (cond ((equal? u--brack 1) (IdrisC-45Resugar-addBracket (CoreC-45FC-replFC) e-17)) (else e-17)))) (vector 1 (vector 0 (IdrisC-45REPL-prettyTerm u--itmC-39)))))))))) (csegen-2746))))(else (csegen-2746)))))))))))))))))))))))))))))))) ((5) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Metadata-findTyDeclAt arg-3 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine (bs- e-15 1 63) u--p))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Can't find declaration for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-16) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "on line") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Int e-15)))))) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (let ((e-13 (car e-10))) (let ((e-18 (cdr e-10))) (let ((act-26 (CoreC-45Context-lookupDefExact e-9 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-26 1))) (let ((_-0 (box (cons e-8 (cons e-9 (cons e-13 e-18)))))) (if (null? e-11) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Can't find declaration for") (CoreC-45Name-u--pretty_Pretty_Name e-16)))) (let ((e-2 (unbox e-11))) (case (vector-ref e-2 0) ((0) (let ((u--searchdef (lambda (eta-1) (TTImpC-45InteractiveC-45GenerateDef-makeDefSort arg-0 arg-3 arg-1 arg-2 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine (bs- e-15 1 63) u--p))) (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))) (lambda (eta-2) (lambda (eta-3) (TTImpC-45InteractiveC-45GenerateDef-mostUsed eta-2 eta-3))) e-9 eta-1)))) (let ((act-27 (let ((act-27 (unbox arg-4))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-4 (let ((e-0 (vector-ref e-12 0))) (let ((e-32 (vector-ref e-12 1))) (let ((e-31 (vector-ref e-12 2))) (let ((e-3 (vector-ref e-12 3))) (let ((e-4 (vector-ref e-12 4))) (let ((e-30 (vector-ref e-12 5))) (let ((e-29 (vector-ref e-12 6))) (let ((e-28 (vector-ref e-12 7))) (let ((e-27 (vector-ref e-12 8))) (let ((e-26 (vector-ref e-12 9))) (let ((e-25 (vector-ref e-12 10))) (let ((e-23 (vector-ref e-12 12))) (let ((e-22 (vector-ref e-12 13))) (let ((e-21 (vector-ref e-12 14))) (let ((e-20 (vector-ref e-12 15))) (let ((e-19 (vector-ref e-12 16))) (vector e-0 e-32 e-31 e-3 e-4 e-30 e-29 e-28 e-27 e-26 e-25 (box (cons e-15 u--searchdef)) e-23 e-22 e-21 e-20 e-19)))))))))))))))))))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((act-29 (IdrisC-45REPL-nextGenDef arg-0 arg-1 arg-4 e-17 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-20 (vector-ref act-29 1))) (let ((bind-0 (box (vector 0 )))) (if (null? e-20) (csegen-2768) (let ((e-3 (unbox e-20))) (let ((e-22 (car e-3))) (let ((e-21 (cdr e-3))) (let ((e-24 (car e-21))) (let ((e-23 (cdr e-21))) (let ((u--l (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (CoreC-45FC-startCol (CoreC-45FC-toNonEmptyFC e-24)))))) (let ((act-30 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-15 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-30 1))) (let ((_-1 (box (cons e-22 (cons e-24 e-23))))) (if (null? e-25) (csegen-2785) (let ((e-4 (unbox e-25))) (let ((_-2 (box e-4))) (IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-7305 e-17 e-16 e-15 e-14 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-18 e-13 e-8 e-9 _-0 bind-0 u--searchdef e-12 e-22 e-24 e-23 _-1 u--l e-4 _-2 (ParserC-45Unlit-isLitLine e-4) eta-0))))))))))))))))))))))))))))))(else (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc9 (DataC-45String-isSuffixOf "\xa;" "Already defined"))) (cond ((equal? sc9 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Already defined")) (else "Already defined")))))))))))))))))))))))))))))))))))))))) ((6) (lambda (eta-0) (let ((act-24 (IdrisC-45REPL-nextGenDef arg-0 arg-1 arg-4 0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (csegen-2776) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((u--l (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (CoreC-45FC-startCol (CoreC-45FC-toNonEmptyFC e-9)))))) (let ((act-25 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-7 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (csegen-2785) (let ((e-2 (unbox e-8))) (let ((sc7 (ParserC-45Unlit-isLitLine e-2))) (let ((e-4 (car sc7))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPL-printClause arg-0 arg-2 e-4 u--l eta-1 eta-2))) e-10 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-1)) e-11))))))))))))))))))))))))))))) ((7) (let ((e-18 (vector-ref arg-5 1))) (let ((e-19 (vector-ref arg-5 2))) (let ((e-20 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--brack (DataC-45List-elemBy (csegen-1408) e-20 (let ((e-8 (vector-ref e-6 8))) e-8)))) (let ((act-26 (IdrisC-45REPL-lookupDefTyName e-20 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (csegen-2801) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) (csegen-2801) (let ((e-8 (cdr e-1))) (if (null? e-8) (csegen-2801) (let ((e-10 (cdr e-8))) (if (null? e-10) (csegen-2801) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (case (vector-ref e-13 0) ((7) (let ((e-15 (vector-ref e-13 1))) (if (null? e-2) (let ((act-27 (TTImpC-45InteractiveC-45MakeLemma-makeLemma arg-3 arg-0 (CoreC-45FC-replFC) e-20 e-15 e-14 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-27 1))) (let ((e-4 (car e-12))) (let ((e-3 (cdr e-12))) (let ((act-28 (IdrisC-45Resugar-pterm arg-0 arg-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) e-4) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-17 (vector-ref act-28 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-28 1))) (let ((act-29 (IdrisC-45Resugar-pterm arg-0 arg-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) e-3) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-21 (vector-ref act-29 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (unbox arg-4))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-22 (vector-ref act-30 1))) (vector 0 e-22))) (else (let ((u--pappstr (IdrisC-45Syntax-u--show_Show_IPTerm (cond ((equal? u--brack 1) (IdrisC-45Resugar-addBracket (CoreC-45FC-replFC) e-21)) (else e-21))))) (let ((act-31 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-19 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-23 (vector-ref act-31 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-31 1))) (if (null? e-23) (csegen-2785) (let ((e-24 (unbox e-23))) (let ((sc17 (ParserC-45Unlit-isLitLine e-24))) (let ((e-26 (car sc17))) (cond ((equal? e-18 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-1) (IdrisC-45REPL-addMadeLemma e-26 e-20 (IdrisC-45Syntax-u--show_Show_IPTerm e-17) u--pappstr (PreludeC-45Types-u--max_Ord_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 0) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- e-19 1 63)))) eta-1)) eta-0)) (else (vector 1 (vector 2 e-26 e-20 e-17 u--pappstr)))))))))))))))))))))))))))))) (csegen-2801))))(else (csegen-2801))))))))))))))))))))))))))))))) ((8) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-getLitStyle arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-2))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--brack (DataC-45List-elemBy (csegen-1408) e-23 (let ((e-8 (vector-ref e-6 8))) e-8)))) (let ((act-26 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-22 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (csegen-2817) (let ((e-1 (unbox e-7))) (let ((sc5 (ParserC-45Unlit-unlit e-5 e-1))) (case (vector-ref sc5 0) ((1) (let ((e-2 (vector-ref sc5 1))) (let ((sc6 (ParserC-45Unlit-isLitLine e-1))) (let ((e-4 (car sc6))) (let ((u--c (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (IdrisC-45IDEModeC-45MakeClause-makeCase u--brack e-23 e-2))))) (cond ((equal? e-21 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-1) (IdrisC-45REPL-addMadeCase e-4 u--c (PreludeC-45Types-u--max_Ord_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 0) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- e-22 1 63)))) eta-1)) eta-0)) (else (vector 1 (vector 4 e-4 u--c))))))))) (else (csegen-2809)))))))))))))))))))))))) (else (let ((e-24 (vector-ref arg-5 1))) (let ((e-25 (vector-ref arg-5 2))) (let ((e-26 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-getLitStyle arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-25 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (csegen-2817) (let ((e-1 (unbox e-6))) (let ((sc4 (ParserC-45Unlit-unlit e-5 e-1))) (case (vector-ref sc4 0) ((1) (let ((e-2 (vector-ref sc4 1))) (let ((sc5 (ParserC-45Unlit-isLitLine e-1))) (let ((e-4 (car sc5))) (let ((u--w (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (IdrisC-45IDEModeC-45MakeClause-makeWith e-26 e-2))))) (cond ((equal? e-24 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-1) (IdrisC-45REPL-addMadeCase e-4 u--w (PreludeC-45Types-u--max_Ord_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 0) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (bs- e-25 1 63)))) eta-1)) eta-0)) (else (vector 1 (vector 3 e-4 u--w))))))))) (else (csegen-2809))))))))))))))))))))))
(define IdrisC-45REPL-processCatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Context-branch arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-2))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-4))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-28 ((IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-commit arg-0 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 e-9))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-28 (let ((act-28 (set-box! arg-0 e-5))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (let ((act-29 (set-box! arg-1 e-6))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (let ((act-30 (set-box! arg-2 e-7))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (let ((act-31 (set-box! arg-4 e-8))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (IdrisC-45Error-display arg-0 arg-2 arg-4 u--err eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (vector 1 (vector 1 e-13)))))))))))))))))))) ext-0)))))))))))))))))))
(define IdrisC-45REPL-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPL-execDecls arg-0 arg-1 arg-2 arg-3 arg-4 e-0 eta-0)))) ((1) (let ((e-1 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--emode (let ((e-18 (vector-ref e-5 1))) e-18))) (cond ((equal? u--emode 2) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 e-1 eta-1)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 e-1)))))) ((equal? u--emode 3) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (IdrisC-45REPL-inferAndElab arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 ) e-1 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-0 (car e-7))) (let ((act-27 (let ((act-27 (IdrisC-45REPLC-45Opts-getEvalTiming arg-4 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) ((CoreC-45ContextC-45Log-logTimeWhen arg-0 e-8 (lambda () "Evaluation") (lambda (eta-1) (let ((act-28 (CoreC-45SchemeEval-snfAll arg-0 '() '() e-0 eta-1))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (CoreC-45SchemeEvalC-45Quote-quote arg-0 '() '() e-9 eta-1))))))) eta-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45ContextC-45Log-logTimeWhen arg-0 0 (lambda () "resugar") (lambda (eta-1) (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-8 eta-1))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 4 e-9 '())))))))))))))))))))(else (let ((act-25 (let ((act-25 (IdrisC-45REPLC-45Opts-getEvalTiming arg-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45ContextC-45Log-logTimeWhen arg-0 e-6 (lambda () "Evaluation") (lambda (eta-1) (IdrisC-45REPL-inferAndNormalize arg-0 arg-1 arg-2 arg-3 arg-4 u--emode e-1 eta-1))) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-0 (car e-6))) (let ((e-2 (cdr e-6))) (let ((act-26 (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-0 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (unbox arg-4))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--norm (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPL-replEval arg-0 '() u--emode eta-1 eta-2))))) (let ((act-29 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-3 (vector-ref eta-1 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref eta-1 1))) (vector 1 (vector 4 "it" e-10)))))) (lambda (eta-1) (CoreC-45UnifyState-genName arg-0 arg-1 "evalResult" eta-1)) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45Context-addDef arg-0 e-10 (CoreC-45Context-newDef (CoreC-45FC-replFC) e-10 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) '() e-2 0 (vector 1 (CoreC-45ContextC-45Context-defaultPI) '() (vector 1 0 e-0) (vector 1 0 e-0) '())) eta-1)) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 (CoreC-45Context-addToSave arg-0 e-10 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((act-32 (let ((act-32 (set-box! arg-4 (let ((e-27 (vector-ref e-9 0))) (let ((e-26 (vector-ref e-9 1))) (let ((e-25 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (let ((e-24 (vector-ref e-9 5))) (let ((e-23 (vector-ref e-9 6))) (let ((e-22 (vector-ref e-9 7))) (let ((e-21 (vector-ref e-9 8))) (let ((e-20 (vector-ref e-9 9))) (let ((e-19 (vector-ref e-9 10))) (let ((e-18 (vector-ref e-9 11))) (let ((e-13 (vector-ref e-9 13))) (let ((e-14 (vector-ref e-9 14))) (let ((e-15 (vector-ref e-9 15))) (let ((e-16 (vector-ref e-9 16))) (vector e-27 e-26 e-25 e-3 e-4 e-24 e-23 e-22 e-21 e-20 e-19 e-18 (box e-10) e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (let ((sc11 (let ((e-28 (vector-ref e-9 0))) e-28))) (cond ((equal? sc11 1) (let ((act-33 (let ((act-33 ((((u--norm e-8) '()) e-2) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-3 (vector-ref act-33 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-33 1))) (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-14 eta-0))))))) (case (vector-ref act-33 0) ((0) (let ((e-3 (vector-ref act-33 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-33 1))) (vector 1 (vector 4 e-7 (box e-14)))))))) (else (vector 1 (vector 4 e-7 '()))))))))))))))))))))))))))))))))))))))))))))))) ((2) (let ((e-2 (vector-ref arg-5 1))) (case (vector-ref e-2 0) ((0) (let ((e-27 (vector-ref e-2 1))) (let ((e-28 (vector-ref e-2 2))) (case (vector-ref e-28 0) ((1) (let ((e-29 (vector-ref e-28 1))) (lambda (clam-0) (case (vector-ref e-29 0) ((0) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 "it") (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-12 (vector-ref e-5 12))) (if (null? e-12) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 e-27 (vector 1 (vector 0 "it"))) clam-0) (let ((e-19 (unbox e-12))) ((IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 (vector 0 e-27 e-19))) clam-0)))))))))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-28 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 e-27 e-28 clam-0) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45REPL-displayType arg-0 arg-2 e-5 eta-0)) e-6 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7))))))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-28 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 e-27 e-28 clam-0) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45REPL-displayType arg-0 arg-2 e-5 eta-0)) e-6 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7)))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-28 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 e-27 e-28 eta-0) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45REPL-displayType arg-0 arg-2 e-5 eta-1)) e-6 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7))))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 (IdrisC-45REPL-inferAndElab arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 ) e-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-0 (car e-5))) (let ((e-1 (cdr e-5))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (CoreC-45Normalise-normaliseHoles arg-0 '() e-6 '() e-0 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-7 eta-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (CoreC-45Normalise-normalise arg-0 '() e-6 '() e-1 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-8 eta-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 7 e-7 e-8))))))))))))))))))))))))) ((3) (let ((e-3 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (let ((e-0 (vector-ref e-5 0))) e-0)))))) (lambda (eta-1) (CoreC-45Context-getPPrint arg-0 eta-1)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45REPL-setOpt arg-0 arg-4 (vector 0 1) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 e-3)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45REPL-setOpt arg-0 arg-4 (vector 0 e-5) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 e-7)))))))))))))))))) ((4) (let ((e-4 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-4 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 (CoreC-45FC-replFC) e-4 eta-0) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45REPL-displayPats arg-0 arg-2 e-5 eta-1)) e-6 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7))))))))))))))))))) ((5) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-3 (vector-ref e-5 3))) (if (null? e-3) (vector 1 (vector 13 )) (let ((e-18 (unbox e-3))) (IdrisC-45REPL-loadMainFile arg-0 arg-1 arg-2 arg-3 arg-4 e-18 eta-0)))))))))) ((6) (let ((e-5 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-4 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-4 (vector-ref e-6 4))) (let ((e-18 (vector-ref e-6 5))) (let ((e-17 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (vector e-0 e-1 e-2 (box e-5) e-4 e-18 e-17 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (IdrisC-45REPL-loadMainFile arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))))))))))) ((7) (let ((e-6 (vector-ref arg-5 1))) (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-24 (IdrisC-45ProcessIdr-addImport arg-0 arg-1 arg-2 (vector (CoreC-45FC-emptyFC) 0 e-6 (CoreC-45NameC-45Namespace-miAsNamespace e-6)) eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 9 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-6))))))) (lambda (u--err) (lambda (eta-1) (vector 1 (vector 10 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-6) u--err)))) eta-0)))) ((18) (let ((e-7 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-setWorkingDir arg-0 e-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Context-getWorkingDir eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 14 e-6)))))))))))) ((19) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getWorkingDir eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 14 e-5)))))))) ((8) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45REPL-case--process-10803 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 (let ((e-3 (vector-ref e-5 3))) e-3)) eta-0))))))) ((9) (let ((e-8 (vector-ref arg-5 1))) (let ((e-9 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45REPL-compileExp arg-0 arg-1 arg-2 arg-3 arg-4 e-8 e-9 eta-0))))) ((10) (let ((e-10 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 e-10 eta-0)))) ((11) (lambda (eta-0) (vector 1 (vector 3 )))) ((12) (let ((e-11 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-branch arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--curr (let ((e-2 (vector-ref e-5 2))) e-2))) (let ((u--ctxt (let ((e-0 (vector-ref e-5 0))) e-0))) (let ((act-25 (IdrisC-45Desugar-desugar arg-2 arg-0 arg-3 arg-1 1 '() e-11 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45BindImplicits-piBindNames arg-0 (CoreC-45FC-replFC) '() e-6 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45Elab-elabTerm '() arg-0 arg-3 arg-1 arg-2 0 (vector 0 ) '() '() '() e-7 '()) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-2 (car e-8))) (let ((act-28 (CoreC-45Context-toResolvedNames arg-0 (csegen-76) e-2 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (CoreC-45Context-allNames u--ctxt eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-traverseC-39 (lambda (eta-1) (PreludeC-45Basics-flip (csegen-2828) u--ctxt eta-1)) e-10 '() eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-30 1))) (let ((u--defs (PreludeC-45Basics-flip (csegen-537) e-12 (lambda (u--md) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe u--md (lambda (u--d) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (CoreC-45Context-visibleIn u--curr (let ((e-1 (vector-ref u--d 1))) e-1) (let ((e-25 (vector-ref u--d 9))) e-25))) (lambda () (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (DataC-45Maybe-isJust (CoreC-45Name-userNameRoot (let ((e-1 (vector-ref u--d 1))) e-1)))) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe u--d))))))))))) (let ((act-31 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_GlobalDef u--ctxt eta-1 eta-2))) u--defs '() eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-31 1))) (CoreC-45Core-filterM (lambda (u--def) (lambda (eta-1) (IdrisC-45REPLC-45Common-equivTypes arg-0 (let ((e-32 (vector-ref u--def 2))) e-32) e-9 eta-1))) e-13 eta-0)))))))))))))))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (set-box! arg-0 e-5))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45Common-docsOrSignature arg-4 arg-0 arg-2 (CoreC-45FC-replFC) eta-1 eta-2))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (csegen-2829) e-10) '() eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-31 1))) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-13)))))))))))))))))))))))))))))))))))))))) ((20) (let ((e-12 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-12 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 (CoreC-45FC-replFC) e-12 eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (vector 18 e-7)))))) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (u--fn) (lambda (eta-2) (let ((act-26 (CoreC-45Context-getTotality arg-0 (CoreC-45FC-replFC) u--fn eta-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-1 (cdr e-7))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (IdrisC-45REPL-displayPatTerm arg-0 arg-2 e-5 eta-3 eta-4))) e-2 '() eta-2))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 0 u--fn e-8)))))))) ((2) (let ((e-2 (vector-ref e-1 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Context-getFullName arg-0 eta-3 eta-4))) e-2 '() eta-2))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 1 u--fn e-8))))))))(else (vector 1 (vector 2 u--fn))))))))))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-fst eta-2)) e-6) '() eta-1)) eta-0))))))))))))) ((21) (let ((e-13 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName e-13 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 (CoreC-45FC-replFC) e-13 eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (vector 19 e-7)))))) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (u--fn) (lambda (eta-2) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-3) (CoreC-45Termination-checkTotal arg-0 (CoreC-45FC-replFC) u--fn eta-3)) eta-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (CoreC-45Context-getTotality arg-0 (CoreC-45FC-replFC) u--fn eta-2))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Context-toFullNames arg-0 (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_Totality arg-4060 arg-4061 eta-3)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-3) (CoreC-45Context-u--resolved_HasNames_Totality arg-4062 arg-4063 eta-3))))) e-8 eta-2))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (cons u--fn e-8))))))))))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-fst eta-2)) e-6) '() eta-1)) eta-0))))))))))))) ((22) (let ((e-14 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 ((IdrisC-45DocC-45String-getDocsForPTerm arg-4 arg-0 arg-2 e-14) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-5))))))))) ((23) (let ((e-15 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45DocC-45String-getContents arg-4 arg-0 arg-2 e-15 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-5))))))))) ((14) (let ((e-16 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45Context-lookupCtxtName e-16 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-traverse_ (lambda (eta-1) (IdrisC-45REPL-showInfo arg-0 eta-1)) e-6 eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))))))) ((15) (let ((e-17 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPL-setOpt arg-0 arg-4 e-17 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))) ((16) (lambda (eta-0) (let ((act-24 (IdrisC-45REPL-getOptions arg-0 arg-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 20 e-5)))))))) ((24) (let ((e-18 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-addLogLevel arg-0 e-18 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 21 e-18)))))))) ((25) (let ((e-19 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setConsoleWidth arg-4 e-19 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 22 e-19)))))))) ((26) (let ((e-20 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setColor arg-4 e-20 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 23 e-20)))))))) ((27) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45Holes-getUserHolesData arg-0 arg-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-1) (vector 6 eta-1)) (IdrisC-45IDEModeC-45Holes-prettyHoles e-5)))))))))) ((28) (let ((e-21 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 2))) (vector e-0 0 e-2))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((IdrisC-45REPL-processEdit arg-0 arg-1 arg-2 arg-3 arg-4 e-21) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-setPPrint arg-0 e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (vector 27 e-7))))))))))))))))))) ((17) (let ((e-22 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-24 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-2 e-3 e-4 (cons e-22 e-25) e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-24 e-23))))))))))))))))))))))))) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))) ((29) (let ((e-23 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-24 ((System-system (csegen-3) e-23) eta-1))) (vector 1 act-24))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))) ((31) (lambda (eta-0) (vector 1 (vector 26 )))) ((32) (lambda (eta-0) (vector 1 (vector 0 )))) ((30) (lambda (eta-0) (vector 1 (vector 24 (IdrisC-45Version-version))))) ((33) (let ((e-24 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--searchDirs (let ((e-4 (vector-ref e-5 4))) (let ((e-42 (vector-ref e-4 0))) (let ((e-46 (vector-ref e-42 6))) e-46))))) ((IdrisC-45REPL-case--process-11609 e-24 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 u--searchDirs (DataC-45List-find (lambda (u--d) (DataC-45String-isInfixOf e-24 (DataC-45Maybe-fromMaybe (lambda () u--d) (LibrariesC-45UtilsC-45Path-fileName u--d)))) u--searchDirs)) eta-0))))))))) (else (let ((e-25 (vector-ref arg-5 1))) (IdrisC-45REPLC-45FuzzySearch-fuzzySearch arg-0 arg-1 arg-2 arg-3 arg-4 e-25))))))
(define IdrisC-45REPL-printClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((act-24 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (ParserC-45Unlit-relit arg-2 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-fastPack (DataC-45List-replicate arg-3 #\ )) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-u--show_Show_IPTerm e-5) (PreludeC-45TypesC-45String-C-43C-43 " = " (IdrisC-45Syntax-u--show_Show_IPTerm e-6))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((e-8 (vector-ref arg-4 4))) (let ((e-10 (vector-ref arg-4 6))) (let ((act-24 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPL-printClause arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat arg-3 (+ 1 (+ 1 0))) eta-0 eta-1))) e-10 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 (ParserC-45Unlit-relit arg-2 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-fastPack (DataC-45List-replicate arg-3 #\ )) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-u--show_Show_IPTerm e-11) (PreludeC-45TypesC-45String-C-43C-43 " with (" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-u--show_Show_IPTerm e-12) (PreludeC-45TypesC-45String-C-43C-43 ")" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-maybe (lambda () "") (lambda () (csegen-1879)) e-8) "\xa;"))))))) (CoreC-45NameC-45Namespace-showSep "\xa;" e-13)))))))))))))))))))) (else (let ((e-13 (vector-ref arg-4 2))) (let ((act-24 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-13) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (ParserC-45Unlit-relit arg-2 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-fastPack (DataC-45List-replicate arg-3 #\ )) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-u--show_Show_IPTerm e-5) " impossible")))))))))))))
(define IdrisC-45REPL-prettyTerm (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 6 eta-0)) (IdrisC-45Pretty-prettyTerm ext-0))))
(define IdrisC-45REPL-prepareExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (IdrisC-45Desugar-desugar arg-2 arg-0 arg-3 arg-1 1 '() (vector 7 (CoreC-45FC-replFC) (vector 0 (CoreC-45FC-replFC) (vector 1 (vector 0 "unsafePerformIO"))) arg-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45REPL-getItDecls arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--ttimpWithIt (vector 5 (CoreC-45FC-replFC) e-6 e-5))) (let ((act-26 (CoreC-45Context-resolveName arg-0 (vector 1 (vector 0 "[input]")) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((TTImpC-45Elab-elabTerm '() arg-0 arg-3 arg-1 arg-2 e-7 (vector 2 ) '() '() '() u--ttimpWithIt '()) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-2 (car e-8))) (let ((act-28 (CoreC-45LinearCheck-linearCheck '() arg-0 arg-1 (CoreC-45FC-replFC) (csegen-519) 1 '() e-2 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CompilerC-45Inline-compileAndInlineAll arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (vector 1 e-9))))))))))))))))))))))))))))
(define IdrisC-45REPL-parseRepl (lambda (arg-0) (let ((sc0 (IdrisC-45REPL-n--29509-11952-u--fnameCmd arg-0 (cons (cons ":load " (lambda (eta-0) (vector 6 eta-0))) (cons (cons ":l " (lambda (eta-0) (vector 6 eta-0))) (cons (cons ":cd " (lambda (eta-0) (vector 18 eta-0))) (cons (cons ":!" (lambda (eta-0) (vector 29 eta-0))) '())))) arg-0))) (if (null? sc0) (let ((sc1 (ParserC-45Source-runParser 0 (vector 2 0) '() arg-0 (vector 13 0 0 (IdrisC-45REPL-parseEmptyCmd) (lambda () (IdrisC-45REPL-parseCmd)))))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc1 1))) (let ((e-9 (cdr e-5))) (let ((e-13 (cdr e-9))) (vector 1 e-13))))))) (let ((e-2 (unbox sc0))) (vector 1 (box e-2)))))))
(define IdrisC-45REPL-parseEmptyCmd(blodwen-lazy (lambda () (vector 10 0 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-eoi)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (vector 0 '())))))))
(define IdrisC-45REPL-parseCmd(blodwen-lazy (lambda () (vector 10 0 0 (IdrisC-45Parser-command) (lambda (u--c) (vector 12 0 0 (ParserC-45RuleC-45Source-eoi) (vector 0 (box u--c))))))))
(define IdrisC-45REPL-nextProofSearch (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45REPL-case--nextProofSearch-4652 arg-2 arg-1 arg-0 e-5 (let ((e-10 (vector-ref e-5 10))) e-10)) ext-0)))))))
(define IdrisC-45REPL-nextGenDef (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45REPL-case--nextGenDef-4850 arg-3 arg-2 arg-1 arg-0 e-5 (let ((e-11 (vector-ref e-5 11))) e-11)) ext-0)))))))
(define IdrisC-45REPL-lookupDefTyName (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupNameBy (csegen-880) ext-2 ext-1 ext-0)))
(define IdrisC-45REPL-loadMainFile (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-4 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 '() e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Directory-ctxtPathToNS arg-0 arg-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45REPLC-45Common-resetContext arg-0 arg-1 arg-2 arg-3 (vector 0 e-7) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) arg-5) ext-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (case (vector-ref e-9 0) ((1) (let ((e-2 (vector-ref e-9 1))) (let ((act-29 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "+ Build deps") (lambda (eta-0) (IdrisC-45ModTree-buildDeps arg-0 arg-2 arg-3 arg-1 arg-4 arg-5 eta-0)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (IdrisC-45REPLC-45Common-updateErrorLine arg-4 e-10 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 (IdrisC-45REPLC-45Opts-setSource arg-4 e-2 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((act-32 (IdrisC-45REPLC-45Opts-resetProofState arg-4 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (if (null? e-10) (vector 1 (vector 8 arg-5)) (vector 1 (vector 12 arg-5 e-10)))))))))))))))))) (else (let ((e-10 (vector-ref e-9 1))) (let ((act-29 (IdrisC-45REPLC-45Opts-setSource arg-4 "" ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 (vector 11 arg-5 e-10))))))))))))))))))))))))))))
(define IdrisC-45REPL-interpret (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setCurrentElabSource arg-4 arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((sc1 (IdrisC-45REPL-parseRepl arg-5))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (let ((act-25 ((IdrisC-45Error-perror arg-0 arg-2 arg-4 e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 e-6)))))))) (else (let ((e-6 (vector-ref sc1 1))) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-8 (unbox e-6))) (IdrisC-45REPL-processCatch arg-0 arg-1 arg-2 arg-3 arg-4 e-8 ext-0))))))))))))
(define IdrisC-45REPL-inferAndNormalize (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (IdrisC-45REPL-inferAndElab arg-0 arg-1 arg-2 arg-3 arg-4 (IdrisC-45REPL-n--27179-9825-u--elabMode arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-5) arg-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-0 (car e-5))) (let ((e-1 (cdr e-5))) (let ((act-25 (CoreC-45ContextC-45Log-logTerm '() arg-0 "repl.eval" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Elaborated input") e-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--norm (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPL-replEval arg-0 '() arg-5 eta-0 eta-1))))) (let ((act-27 ((((u--norm e-7) '()) e-0) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Normalise-logTermNF '() arg-0 "repl.eval" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () "Normalised") '() e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (cons e-8 e-1)))))))))))))))))))))))))
(define IdrisC-45REPL-inferAndElab (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (IdrisC-45Desugar-desugar arg-2 arg-0 arg-3 arg-1 1 '() arg-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45REPL-getItDecls arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--ttimpWithIt (vector 5 (CoreC-45FC-replFC) e-6 e-5))) (let ((act-26 (CoreC-45Context-resolveName arg-0 (vector 1 (vector 0 "[input]")) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-27 (CoreC-45Context-hide arg-0 (CoreC-45FC-replFC) (vector 0 (CoreC-45NameC-45Namespace-primIONS) (vector 1 (vector 0 "::"))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (CoreC-45Context-hide arg-0 (CoreC-45FC-replFC) (vector 0 (CoreC-45NameC-45Namespace-primIONS) (vector 1 (vector 0 "Nil"))) eta-0))))) (lambda (u--err) (lambda (eta-0) (vector 1 0))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((TTImpC-45Elab-elabTerm '() arg-0 arg-3 arg-1 arg-2 e-7 arg-5 '() '() '() u--ttimpWithIt '()) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-29 ((CoreC-45NormaliseC-45Eval-getTerm e-3) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (cons e-2 e-10))))))))))))))))))))))))))))))
(define IdrisC-45REPL-handleResult (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((26) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Bye for now!") ext-0))(else (let ((act-24 ((IdrisC-45REPL-displayResult arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (IdrisC-45REPL-repl arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))))))))
(define IdrisC-45REPL-handleMissingC-39 (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-0) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 ": Calls non covering function" (if (null? e-3) (PreludeC-45TypesC-45String-C-43C-43 "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-3))) (let ((e-1 (car e-3))) (let ((e-4 (cdr e-3))) (if (null? e-4) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name e-1)) (PreludeC-45TypesC-45String-C-43C-43 "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-3)))))))))))) (else (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-4) ": All cases covered"))))))
(define IdrisC-45REPL-handleMissing (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45Name-u--pretty_Pretty_Name e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String eta-0))) e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45Name-u--pretty_Pretty_Name e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Calls non covering") (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "functions:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name eta-0))) e-3))) (let ((e-1 (car e-3))) (let ((e-4 (cdr e-3))) (if (null? e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "function") (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name e-1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "functions:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (csegen-544) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Pretty-code (CoreC-45Name-u--pretty_Pretty_Name eta-0))) e-3)))))))))))) (else (let ((e-4 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45Name-u--pretty_Pretty_Name e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "All cases covered")))))))
(define IdrisC-45REPL-getOptions (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (vector 0 (let ((e-0 (vector-ref e-5 0))) e-0)) (cons (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)) (cons (vector 2 (let ((e-0 (vector-ref e-6 0))) e-0)) (cons (vector 3 (let ((e-1 (vector-ref e-6 1))) e-1)) (cons (vector 4 (let ((e-17 (vector-ref e-6 6))) e-17)) '()))))))))))))))))
(define IdrisC-45REPL-getItDecls (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-12 (vector-ref e-5 12))) (if (null? e-12) (vector 1 '()) (let ((e-18 (unbox e-12))) (let ((u--it (vector 1 (vector 0 "it")))) (vector 1 (cons (vector 0 (CoreC-45FC-replFC) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) 0 '() (vector (CoreC-45FC-replFC) (vector 2 ) u--it (vector 32 (CoreC-45FC-replFC) 0))) (cons (vector 2 (CoreC-45FC-replFC) u--it (cons (vector 0 (CoreC-45FC-replFC) (vector 0 (CoreC-45FC-replFC) u--it) (vector 0 (CoreC-45FC-replFC) e-18)) '())) '())))))))))))))
(define IdrisC-45REPL-findInTree (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-headC-39 (DataC-45List-sortBy (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-on (lambda (eta-2) (lambda (eta-3) (IdrisC-45REPL-n--21797-5164-u--cmp arg-2 arg-1 arg-0 eta-2 eta-3))) (lambda (eta-2) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-2)) eta-0 eta-1))) (DataC-45List-filter (lambda (eta-0) (IdrisC-45REPL-n--21797-5169-u--match arg-2 arg-1 arg-0 eta-0)) (LibrariesC-45DataC-45PosMap-searchPos (csegen-2852) arg-0 arg-2)))))))
(define IdrisC-45REPL-execExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (IdrisC-45REPL-prepareExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45ProcessIdr-findCG arg-4 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No such code generator available") ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (vector 15 ))))) (let ((e-1 (unbox e-6))) (let ((act-26 (let ((act-26 (IdrisC-45REPLC-45Opts-getEvalTiming arg-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((CoreC-45ContextC-45Log-logTimeWhen arg-0 e-7 (lambda () "Execution") (lambda (eta-0) (CompilerC-45Common-execute arg-0 e-1 e-5 eta-0))) ext-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-5)))))))))))))))))
(define IdrisC-45REPL-execDecls (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPL-n--26574-9285-u--execDecl arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0 eta-1))) arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 25 )))))))
(define IdrisC-45REPL-dropLamsTm (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-1 0) (cons arg-0 (cons arg-2 arg-3)))(else (let ((e-0 (- arg-1 1))) (case (vector-ref arg-3 0) ((3) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (IdrisC-45REPL-dropLamsTm (cons e-3 arg-0) e-0 (cons e-4 arg-2) e-5)))))(else (cons arg-0 (cons arg-2 arg-3)))))))))
(define IdrisC-45REPL-dropLams (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) arg-2)(else (let ((e-0 (- arg-1 1))) (case (vector-ref arg-2 0) ((2) (let ((e-7 (vector-ref arg-2 6))) (IdrisC-45REPL-dropLams e-0 e-7)))(else arg-2)))))))
(define IdrisC-45REPL-displayType (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-7 (cdr e-3))) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-0 '() arg-2 '() (let ((e-25 (vector-ref e-7 2))) e-25) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-5 eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-aliasName arg-0 (let ((e-1 (vector-ref e-7 1))) e-1) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((u--ann (IdrisC-45Pretty-showCategory (lambda (eta-1) (vector 6 eta-1)) e-7))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (u--ann (CoreC-45Name-u--pretty_Pretty_Name e-8)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45REPL-prettyTerm e-5))))))))))))))) (lambda () (lambda (u--num) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-2) (vector 6 eta-2)) e-5)))))) (lambda (eta-1) (IdrisC-45IDEModeC-45Holes-prettyHole '() arg-0 arg-1 arg-2 '() e-2 u--num (let ((e-25 (vector-ref e-7 2))) e-25) eta-1)) eta-0)))) (IdrisC-45IDEModeC-45Holes-isHole e-7)))))))
(define IdrisC-45REPL-displayTerm (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-0 '() arg-2 '() arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (IdrisC-45REPL-prettyTerm e-5))))))))
(define IdrisC-45REPL-displayResult (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-0 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 e-0 eta-0)))) ((4) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (lambda (clam-0) (if (null? e-2) (IdrisC-45REPLC-45Common-printResult arg-4 (IdrisC-45REPL-prettyTerm e-1) clam-0) (let ((e-29 (unbox e-2))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45REPL-prettyTerm e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45REPL-prettyTerm e-29))) clam-0))))))) ((5) (let ((e-3 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 e-3 eta-0)))) ((6) (let ((e-4 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printDocResult arg-4 e-4 eta-0)))) ((7) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45REPL-prettyTerm e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45REPL-prettyTerm e-6))) eta-0))))) ((8) (let ((e-7 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Loaded file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-7)) eta-0)))) ((9) (let ((e-8 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Imported module") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-8)) eta-0)))) ((10) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Error-perror arg-0 arg-2 arg-4 e-10) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error loading module") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) e-5)) eta-0))))))))) ((11) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error loading file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (SystemC-45FileC-45Error-u--show_Show_FileError e-12)))) eta-0))))) ((12) (let ((e-13 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error(s) building file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-13)) eta-0)))) ((13) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No file can be reloaded") eta-0))) ((14) (let ((e-15 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Current working directory is") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-15))) eta-0)))) ((15) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Compilation failed") eta-0))) ((16) (let ((e-16 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "File") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-16) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "written"))) eta-0)))) ((17) (let ((e-17 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (IdrisC-45REPL-prettyTerm e-17) eta-0)))) ((18) (let ((e-18 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (IdrisC-45REPL-handleMissing eta-1)) e-18)) eta-0)))) ((19) (let ((e-19 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "is") (CoreC-45TT-u--pretty_Pretty_Totality e-3)))))) e-19)) eta-0)))) ((21) (let ((e-20 (vector-ref arg-5 1))) (lambda (clam-1) (if (null? e-20) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Logging turned off") clam-1) (let ((e-32 (unbox e-20))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Set log level to") (CoreC-45OptionsC-45Log-u--pretty_Pretty_LogLevel e-32)) clam-1)))))) ((22) (let ((e-21 (vector-ref arg-5 1))) (lambda (clam-2) (if (null? e-21) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Set consolewidth to auto") clam-2) (let ((e-34 (unbox e-21))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Set consolewidth to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat e-34)) clam-2)))))) ((23) (let ((e-22 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow (cond ((equal? e-22 1) "Set color on") (else "Set color off"))) eta-0)))) ((24) (let ((e-23 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45Version-showVersion 1 e-23)) eta-0)))) ((3) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45REPL-displayHelp)) eta-0))) ((27) (let ((e-24 (vector-ref arg-5 1))) (lambda (clam-0) (case (vector-ref e-24 0) ((0) (let ((e-36 (vector-ref e-24 1))) (case (vector-ref e-36 0) ((0) (vector 1 0))(else (IdrisC-45REPLC-45Common-printResult arg-4 e-36 clam-0))))) ((1) (let ((e-37 (vector-ref e-24 1))) (IdrisC-45REPLC-45Common-printResult arg-4 e-37 clam-0))) ((2) (let ((e-38 (vector-ref e-24 1))) (let ((e-39 (vector-ref e-24 2))) (let ((e-40 (vector-ref e-24 3))) (let ((e-41 (vector-ref e-24 4))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (PreludeC-45TypesC-45String-C-43C-43 (ParserC-45Unlit-relit e-38 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-39) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-u--show_Show_IPTerm e-40) "\xa;")))) e-41)) clam-0)))))) ((3) (let ((e-42 (vector-ref e-24 1))) (let ((e-43 (vector-ref e-24 2))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (ParserC-45Unlit-relit e-42 eta-0)) e-43))) clam-0)))) (else (let ((e-44 (vector-ref e-24 1))) (let ((e-45 (vector-ref e-24 2))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (ParserC-45Unlit-relit e-44 eta-0)) e-45))) clam-0)))))))) ((20) (let ((e-25 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (IdrisC-45Syntax-u--pretty_Pretty_REPLOpt eta-1)) e-25)) eta-0)))) ((0) (lambda (eta-0) (vector 1 0))) ((2) (lambda (eta-0) (vector 1 0))) ((25) (lambda (eta-0) (vector 1 0))) (else (lambda (eta-0) (vector 1 0))))))
(define IdrisC-45REPL-displayPats (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-0) (let ((e-17 (vector-ref e-7 17))) (case (vector-ref e-17 0) ((1) (let ((e-26 (vector-ref e-17 5))) (let ((act-24 ((IdrisC-45REPL-displayType arg-0 arg-1 arg-2 (cons e-2 (cons e-6 e-7))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-31 (vector-ref act-24 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45REPL-displayClause arg-0 arg-1 arg-2 eta-0)) e-26 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-32 (vector-ref act-25 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons e-31 e-32)))))))))))))(else (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a pattern matching definition")))))))))))))
(define IdrisC-45REPL-displayPatTerm (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-0 '() arg-2 '() arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Resugar-resugarNoPatvars '() arg-0 arg-1 '() e-5 ext-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (IdrisC-45Syntax-u--show_Show_IPTerm e-5))))))))
(define IdrisC-45REPL-displayHelp(blodwen-lazy (lambda () (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45REPL-n--29817-12972-u--cmdInfo eta-0)) (IdrisC-45Parser-help))))))
(define IdrisC-45REPL-displayErrors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((11) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (IdrisC-45REPLC-45Common-printError arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "File error in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (SystemC-45FileC-45Error-u--show_Show_FileError e-1)))) ext-0))))(else (vector 1 0)))))
(define IdrisC-45REPL-displayClause (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (let ((act-24 (CoreC-45Normalise-normaliseHoles arg-0 e-2 arg-2 e-6 e-10 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Resugar-resugar e-2 arg-0 arg-1 e-6 e-5 clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-0 e-2 arg-2 e-6 e-11 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (IdrisC-45Resugar-resugar e-2 arg-0 arg-1 e-6 e-8 clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45REPL-prettyTerm e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (IdrisC-45REPL-prettyTerm e-8)))))))))))))))))))))
(define IdrisC-45REPL-compileExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (IdrisC-45REPL-prepareExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45ProcessIdr-findCG arg-4 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No such code generator available") ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (vector 15 ))))) (let ((e-1 (unbox e-6))) (let ((act-26 (CompilerC-45Common-compile arg-0 e-1 e-5 arg-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 (vector 15 )))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 (vector 16 eta-0))))) e-7) ext-0)))))))))))))))))
(define IdrisC-45REPL-caseSplit (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) (if (null? arg-2) (cons arg-0 '()) (let ((e-4 (cdr arg-2))) (cons (IdrisC-45REPL-rtrim arg-0) e-4))))(else (let ((e-1 (- arg-1 1))) (if (null? arg-2) (cons arg-0 '()) (let ((e-6 (car arg-2))) (let ((e-7 (cdr arg-2))) (cons e-6 (IdrisC-45REPL-caseSplit arg-0 e-1 e-7))))))))))
(define IdrisC-45REPL-anyAt (lambda (arg-2 arg-3 arg-4) (arg-2 arg-3)))
(define IdrisC-45REPL-addMadeLemma (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (IdrisC-45REPL-n--21018-4480-u--addApp arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-0 arg-4 '() (IdrisC-45REPL-proofSearch arg-1 arg-3 arg-4 arg-5))))
(define IdrisC-45REPL-addMadeCase (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45REPL-n--21148-4595-u--addW arg-3 arg-2 arg-1 arg-0 arg-2 '() arg-3)))
(define IdrisC-45REPL-addClause (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) (if (null? arg-2) (cons (IdrisC-45REPL-rtrim arg-0) '()) (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (let ((sc2 (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) (PreludeC-45Types-fastUnpack e-3)))) (cond ((equal? sc2 1) (cons (IdrisC-45REPL-rtrim arg-0) (cons e-3 e-4))) (else (cons e-3 (IdrisC-45REPL-addClause arg-0 0 e-4)))))))))(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) (cons arg-0 '()) (let ((e-6 (car arg-2))) (let ((e-7 (cdr arg-2))) (cons e-6 (IdrisC-45REPL-addClause arg-0 e-0 e-7))))))))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-n--4358-4414-u--filesC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (DataC-45List-filter (arg-4 arg-0) arg-2)))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-n--4358-4415-u--dirsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45Basics-flip (csegen-537) arg-1 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) ((arg-3 arg-0) e-2)) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-2 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (LibrariesC-45SystemC-45DirectoryC-45Tree-filter (lambda (root-4468) (arg-4 root-4468)) (lambda (root-4472) (arg-3 root-4472)) (LibrariesC-45UtilsC-45Path-C-47C-62 arg-0 (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName e-2)) eta-1)) e-3 eta-0))))))))))))
(define LibrariesC-45SystemC-45DirectoryC-45TreeC-45Tree-toRelative (lambda (arg-1) (Builtin-believe_me arg-1)))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-toFilePath (lambda (arg-0 arg-1) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (LibrariesC-45UtilsC-45Path-C-47C-62 arg-0 (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName arg-1)))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-go (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((SystemC-45Directory-dirEntry (csegen-3) arg-1) ext-0))) (case (vector-ref act-24 0) ((0) ((PreludeC-45Interfaces-C-60C-36 (csegen-758) arg-2 (SystemC-45Directory-closeDir (csegen-3) arg-1)) ext-0)) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45Types-elem (csegen-17) e-5 (cons "." (cons ".." '()))))) (cond ((equal? sc1 0) (let ((u--entry e-5)) (let ((act-25 (LibrariesC-45SystemC-45DirectoryC-45Tree-directoryExists arg-0 u--entry ext-0))) (let ((u--acc (cond ((equal? act-25 1) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (cons e-1 (cons (cons u--entry (lambda (eta-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-explore (LibrariesC-45UtilsC-45Path-C-47C-62 arg-0 (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName u--entry)) eta-0))) e-2))))) (else (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (cons (cons u--entry e-1) e-2))))))) (LibrariesC-45SystemC-45DirectoryC-45Tree-go arg-0 arg-1 u--acc ext-0)))))(else (LibrariesC-45SystemC-45DirectoryC-45Tree-go arg-0 arg-1 arg-2 ext-0))))))))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-filter (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cons (LibrariesC-45SystemC-45DirectoryC-45Tree-n--4358-4414-u--filesC-39 arg-2 e-2 e-1 arg-1 arg-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-n--4358-4415-u--dirsC-39 arg-2 e-2 e-1 arg-1 arg-0))))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-fileName (lambda (arg-1) arg-1))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-explore (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45Directory-openDir (csegen-3) (LibrariesC-45UtilsC-45Path-u--show_Show_Path arg-0)) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (LibrariesC-45SystemC-45DirectoryC-45Tree-go arg-0 e-2 (LibrariesC-45SystemC-45DirectoryC-45Tree-emptyTree) ext-0))) (else (LibrariesC-45SystemC-45DirectoryC-45Tree-emptyTree))))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-emptyTree(blodwen-lazy (lambda () (cons '() '()))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-directoryExists (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((SystemC-45Directory-openDir (csegen-3) (LibrariesC-45SystemC-45DirectoryC-45Tree-toFilePath arg-0 arg-1)) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (SystemC-45Directory-closeDir (csegen-3) e-2) (lambda () (lambda (eta-0) 1))) ext-0))) (else 0)))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-depthFirst (lambda (arg-1 arg-2 arg-3 arg-4) (let ((u--next (PreludeC-45Types-u--foldr_Foldable_List (lambda (lamc-0) (lambda (clam-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-24 (e-3 clam-1))) ((LibrariesC-45SystemC-45DirectoryC-45Tree-depthFirst (lambda (root-4876) (arg-1 root-4876)) (LibrariesC-45UtilsC-45Path-C-47C-62 arg-2 (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName e-2)) act-24 clam-0) clam-1))))))) arg-4 (let ((e-2 (cdr arg-3))) e-2)))) (PreludeC-45Types-u--foldr_Foldable_List (lambda (u--fn) (lambda (u--def) (((arg-1 arg-2) u--fn) (lambda () u--def)))) u--next (let ((e-1 (car arg-3))) e-1)))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-copyFile (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Buffer-createBufferFromFile arg-1 arg-2)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) (DataC-45Buffer-prim__bufferSize e-6)))))) (lambda (bind-0) (SystemC-45FileC-45Buffer-writeBufferToFile arg-1 arg-3 e-6 bind-0))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 e-6))))))))))))))
(define TTImpC-45InteractiveC-45MakeLemma-n--7846-3081-u--getArg (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) '() (let ((e-7 (cdr e-3))) (if (null? e-7) '() (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-10 0) ((1) (if (null? e-11) '() (box (vector 0 arg-2 e-2))))(else '()))))))))))))
(define TTImpC-45InteractiveC-45MakeLemma-used (lambda (ext-0) (let ((sc0 (AlgebraC-45Semiring-isErased (csegen-475) ext-0))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45InteractiveC-45MakeLemma-mkType (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (vector 1 arg-0 e-18 e-14 e-10 e-19 (TTImpC-45InteractiveC-45MakeLemma-mkType arg-0 e-3 arg-2))))))))))))))
(define TTImpC-45InteractiveC-45MakeLemma-mkApp (lambda (arg-0 arg-1 arg-2) (TTImpC-45TTImp-apply (vector 0 arg-0 arg-1) (DataC-45List-mapMaybe (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-n--7846-3081-u--getArg arg-2 arg-1 arg-0 eta-0)) arg-2))))
(define TTImpC-45InteractiveC-45MakeLemma-makeLemma (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Normalise-normalise arg-1 '() e-5 '() arg-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((TTImpC-45InteractiveC-45MakeLemma-getArgs '() arg-1 '() arg-4 e-6) ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (vector 1 (cons (TTImpC-45InteractiveC-45MakeLemma-mkType arg-2 e-2 e-3) (TTImpC-45InteractiveC-45MakeLemma-mkApp arg-2 arg-3 e-2)))))))))))))))
(define TTImpC-45InteractiveC-45MakeLemma-hiddenName (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) (cond ((equal? e-0 "_") 1)(else 0))))(else 0))))
(define TTImpC-45InteractiveC-45MakeLemma-getArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 0) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Normalise-normalise arg-1 arg-0 e-5 arg-2 arg-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-2487) (TTImpC-45Unelab-unelab arg-0 arg-1 arg-2 e-6) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons '() e-6))))))))))))(else (let ((e-0 (- arg-3 1))) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (case (vector-ref e-4 0) ((2) (let ((e-8 (vector-ref e-4 2))) (let ((e-10 (vector-ref e-4 4))) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Normalise-normalise arg-1 arg-0 e-6 arg-2 e-10 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-2487) (TTImpC-45Unelab-unelab arg-0 arg-1 arg-2 e-11) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-11 (vector-ref act-25 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45Utils-uniqueName e-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-nameRoot eta-0)) arg-0) (CoreC-45Name-nameRoot e-3) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (let ((u--xC-39 (vector 1 (vector 0 e-12)))) (let ((act-27 ((TTImpC-45InteractiveC-45MakeLemma-getArgs (cons u--xC-39 arg-0) arg-1 (cons e-4 arg-2) e-0 (CoreC-45TT-renameTop u--xC-39 e-5)) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((e-15 (car e-13))) (let ((e-14 (cdr e-13))) (let ((u--mn (let ((sc7 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-8 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))) (cond ((equal? sc7 1) (let ((sc8 (CoreC-45TT-shrinkTerm e-5 (vector 1 (vector 0 ))))) (if (null? sc8) (box u--xC-39) '()))) (else (box u--xC-39)))))) (let ((u--pC-39 (let ((sc7 (let ((sc8 (TTImpC-45InteractiveC-45MakeLemma-used e-8))) (cond ((equal? sc8 1) (let ((sc9 (TTImpC-45InteractiveC-45MakeLemma-bindableArg 0 e-5))) (cond ((equal? sc9 1) 0) (else (let ((sc10 (TTImpC-45InteractiveC-45MakeLemma-hiddenName e-3))) (cond ((equal? sc10 1) 0) (else 1))))))) (else 0))))) (cond ((equal? sc7 1) (vector 1 )) (else (vector 0 )))))) (vector 1 (cons (cons (cons e-3 (cons u--mn (cons u--pC-39 (cons e-8 e-11)))) e-15) e-14))))))))))))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Normalise-normalise arg-1 arg-0 e-6 arg-2 arg-4 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-2487) (TTImpC-45Unelab-unelab arg-0 arg-1 arg-2 e-7) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (cons '() e-7))))))))))))))))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Normalise-normalise arg-1 arg-0 e-5 arg-2 arg-4 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-2487) (TTImpC-45Unelab-unelab arg-0 arg-1 arg-2 e-6) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons '() e-6))))))))))))))))))
(define TTImpC-45InteractiveC-45MakeLemma-bindableArg (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((sc2 (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 e-9))) (cond ((equal? sc2 1) 1) (else (TTImpC-45InteractiveC-45MakeLemma-bindableArg (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-1) e-4))))))(else 0)))))(else 0))))
(define TTImpC-45InteractiveC-45MakeLemma-bindable (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45TT-getFnArgs arg-2))) (if (null? sc0) 0 (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((3) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) e-3)) ((2) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) e-3))(else 0)))) ((6) (let ((e-11 (vector-ref e-2 3))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) (cons e-11 e-3)))) ((7) (let ((e-16 (vector-ref e-2 4))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) (cons e-16 e-3)))) ((8) (let ((e-20 (vector-ref e-2 3))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) (cons e-20 e-3)))) ((0) (let ((e-25 (vector-ref e-2 3))) (if (null? e-3) (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-1 e-25) 0)))(else 0))))))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3121-u--toFullNamesC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-6 (vector-ref arg-6 7))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-7 (vector-ref eta-0 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (vector 0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7)))))) (lambda (eta-0) (CoreC-45Context-toFullNames arg-5 (csegen-46) e-6 eta-0)) ext-0)))(else (vector 1 arg-6)))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3115-u--parseNameOrConst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 2))) (box (vector 0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2)))) ((15) (let ((e-5 (vector-ref arg-6 2))) (case (vector-ref e-5 0) ((14) (box (vector 1 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((19) (box (vector 2 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((20) (box (vector 3 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((21) (box (vector 4 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((22) (box (vector 5 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((23) (box (vector 6 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((24) (box (vector 7 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((25) (box (vector 8 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((26) (box (vector 9 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5))) ((27) (box (vector 10 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5)))(else '())))) ((22) (box (vector 11 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5)))(else '()))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3116-u--parseExprC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((7) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--pure_Applicative_Maybe (csegen-113)) (IdrisC-45REPLC-45FuzzySearch-n--16101-3115-u--parseNameOrConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)) (IdrisC-45REPLC-45FuzzySearch-n--16101-3116-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2)))))(else (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (arg-7) (cons arg-7 '())) (IdrisC-45REPLC-45FuzzySearch-n--16101-3115-u--parseNameOrConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6))))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3117-u--parseExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (case (vector-ref e-6 0) ((25) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45REPLC-45FuzzySearch-n--16101-3116-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) (lambda (u--aC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons u--aC-39 '())))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45REPLC-45FuzzySearch-n--16101-3116-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) (lambda (u--aC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45REPLC-45FuzzySearch-n--16101-3116-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6) (lambda (u--bC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons u--aC-39 u--bC-39)))))))))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45REPLC-45FuzzySearch-n--16101-3116-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (u--bC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons '() u--bC-39))))))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3119-u--isApproximationOfC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-6 (vector-ref arg-6 7))) (case (vector-ref arg-7 0) ((0) (let ((e-13 (vector-ref arg-7 7))) (IdrisC-45REPLC-45FuzzySearch-n--16101-3118-u--isApproximationOf arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 e-13)))(else (IdrisC-45REPLC-45FuzzySearch-n--16101-3114-u--eqConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))(else (IdrisC-45REPLC-45FuzzySearch-n--16101-3114-u--eqConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3118-u--isApproximationOf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-0 (vector-ref arg-6 1))) (let ((e-1 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((0) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-4))) (cond ((equal? sc2 1) (CoreC-45NameC-45Namespace-isApproximationOf e-0 e-3)) (else 0))))))(else 0))))) ((1) (let ((e-2 (vector-ref arg-6 1))) (case (vector-ref arg-7 0) ((0) (let ((e-6 (vector-ref arg-7 2))) (case (vector-ref e-6 0) ((1) (let ((e-8 (vector-ref e-6 1))) (CoreC-45Name-u--C-61C-61_Eq_UserName e-2 e-8)))(else 0)))) ((1) (let ((e-7 (vector-ref arg-7 1))) (CoreC-45Name-u--C-61C-61_Eq_UserName e-2 e-7)))(else 0))))(else 0))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3122-u--fuzzyMatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((3) (let ((e-7 (vector-ref arg-9 3))) (let ((e-8 (vector-ref arg-9 4))) (let ((u--refsB (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() (CoreC-45TT-binderType e-7)))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45FuzzySearch-n--16101-3121-u--toFullNamesC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) u--refsB '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-24 1))) (let ((u--negC-39 (LibrariesC-45DataC-45ListC-45Extra-diffBy (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45FuzzySearch-n--16101-3119-u--isApproximationOfC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) arg-7 e-9))) ((IdrisC-45REPLC-45FuzzySearch-n--16101-3122-u--fuzzyMatch arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--negC-39 arg-8 e-8) eta-0)))))))))))(else (if (null? arg-7) (let ((u--refsB (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-9))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45FuzzySearch-n--16101-3121-u--toFullNamesC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) u--refsB '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (DataC-45List-isNil (LibrariesC-45DataC-45ListC-45Extra-diffBy (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45FuzzySearch-n--16101-3119-u--isApproximationOfC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) arg-8 e-5))))))))) (lambda (eta-0) (vector 1 0)))))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3114-u--eqConst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((1) (case (vector-ref arg-7 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-7 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-7 0) ((3) 1)(else 0))) ((4) (case (vector-ref arg-7 0) ((4) 1)(else 0))) ((5) (case (vector-ref arg-7 0) ((5) 1)(else 0))) ((6) (case (vector-ref arg-7 0) ((6) 1)(else 0))) ((7) (case (vector-ref arg-7 0) ((7) 1)(else 0))) ((8) (case (vector-ref arg-7 0) ((8) 1)(else 0))) ((9) (case (vector-ref arg-7 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-7 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-7 0) ((11) 1)(else 0)))(else 0))))
(define IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) arg-7) ((1) (let ((e-9 (vector-ref arg-8 3))) (cons (vector 0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9) arg-7))) ((2) (let ((e-14 (vector-ref arg-8 4))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0 eta-1))) arg-7 e-14))) ((3) (let ((e-18 (vector-ref arg-8 3))) (let ((e-19 (vector-ref arg-8 4))) (case (vector-ref e-18 0) ((1) (let ((e-53 (vector-ref e-18 3))) (let ((e-54 (vector-ref e-18 4))) (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-53) e-54) e-19))))(else (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (CoreC-45TT-binderType e-18)) e-19)))))) ((4) (let ((e-22 (vector-ref arg-8 2))) (let ((e-23 (vector-ref arg-8 3))) (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-22) e-23)))) ((5) (let ((e-28 (vector-ref arg-8 4))) (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-28))) ((6) (let ((e-32 (vector-ref arg-8 3))) (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-32))) ((7) (let ((e-36 (vector-ref arg-8 3))) (let ((e-37 (vector-ref arg-8 4))) (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-8 3))) (IdrisC-45REPLC-45FuzzySearch-n--16101-3120-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-41))) ((9) (let ((e-43 (vector-ref arg-8 1))) (let ((e-44 (vector-ref arg-8 2))) (PreludeC-45TypesC-45List-tailRecAppend (DataC-45Maybe-fromMaybe (lambda () '()) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (arg-6) (cons arg-6 '())) (IdrisC-45REPLC-45FuzzySearch-n--16101-3115-u--parseNameOrConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (vector 15 e-43 e-44)))) arg-7)))) ((10) arg-7) (else (cons (vector 11 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) arg-7)))))
(define IdrisC-45REPLC-45FuzzySearch-fuzzySearch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (let ((sc0 (IdrisC-45REPLC-45FuzzySearch-n--16101-3117-u--parseExpr arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-5))) (if (null? sc0) (csegen-2862) (let ((e-1 (unbox sc0))) (if (null? e-1) (csegen-2862) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (let ((act-24 (CoreC-45Context-branch arg-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--curr (let ((e-2 (vector-ref e-6 2))) e-2))) (let ((u--ctxt (let ((e-0 (vector-ref e-6 0))) e-0))) (let ((act-25 (let ((act-25 (CoreC-45Context-allNames u--ctxt clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (PreludeC-45Basics-flip (csegen-2828) u--ctxt eta-0)) e-7 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-26 1))) (let ((u--defs (PreludeC-45Basics-flip (csegen-537) e-8 (lambda (u--md) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe u--md (lambda (u--d) (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (CoreC-45Context-visibleIn u--curr (let ((e-27 (vector-ref u--d 1))) e-27) (let ((e-9 (vector-ref u--d 9))) e-9))) (lambda () (PreludeC-45Interfaces-C-62C-62 (csegen-270) (PreludeC-45Interfaces-guard (csegen-538) (DataC-45Maybe-isJust (CoreC-45Name-userNameRoot (let ((e-27 (vector-ref u--d 1))) e-27)))) (lambda () (PreludeC-45Types-u--pure_Applicative_Maybe u--d))))))))))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_GlobalDef u--ctxt eta-0 eta-1))) u--defs '() clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-27 1))) (CoreC-45Core-filterM (lambda (u--def) (IdrisC-45REPLC-45FuzzySearch-n--16101-3122-u--fuzzyMatch arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-4 e-5 (let ((e-2 (vector-ref u--def 2))) e-2))) e-9 clam-0)))))))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-0 e-6))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPLC-45Common-docsOrSignature arg-4 arg-0 arg-2 (vector 2 ) eta-0 eta-1))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (csegen-2829) e-7) '() clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-27 1))) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-9)))))))))))))))))))))))))))))
(define IdrisC-45REPLC-45Common-case--caseC-32blockC-32inC-32docsOrSignature-3604 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (lambda (clam-0) (if (null? arg-11) (IdrisC-45REPLC-45Common-n--12665-3457-u--typeSummary arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 clam-0) (IdrisC-45DocC-45String-getDocsForName arg-4 arg-3 arg-2 arg-1 arg-0 (vector 1 0 1) clam-0)))))
(define IdrisC-45REPLC-45Common-case--caseC-32blockC-32inC-32emitProblem-2739 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (IdrisC-45REPLC-45Common-iputStrLn arg-7 arg-6 arg-13 eta-0)) (let ((e-2 (unbox arg-14))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((act-24 (case (vector-ref e-5 0) ((0) (let ((e-0 (vector-ref e-5 1))) (let ((u--fc (vector 0 (vector 0 e-0) e-9 e-10))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (CoreC-45Directory-nsToSource arg-7 u--fc e-0 eta-0)) (lambda (eta-0) (lambda (eta-1) (vector 1 "(File-Not-Found)"))) clam-0)))) ((1) (let ((e-1 (vector-ref e-5 1))) (vector 1 e-1))) (else (let ((e-3 (vector-ref e-5 1))) (cond (else (vector 1 "(Interactive)")))))))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45PrettyC-45Render-renderWithoutColor arg-6 arg-13 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-25 1))) ((IdrisC-45IDEModeC-45Commands-send arg-7 (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp eta-0)) arg-11 (vector 0 (cons (vector 4 "warning") (cons (vector 0 (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_String e-7) (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2874) (IdrisC-45REPLC-45Common-n--11796-2634-u--addOne arg-10 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-9)) (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2874) (IdrisC-45REPLC-45Common-n--11796-2634-u--addOne arg-10 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-10)) (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_String e-8) (cons (vector 0 '()) '())))))) (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Integer arg-12) '()))))) clam-0))))))))))))))))))
(define IdrisC-45REPLC-45Common-case--printWithStatus-2499 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((1) (let ((e-0 (vector-ref arg-6 1))) (let ((sc1 (IdrisC-45REPLC-45Common-doPrint arg-1 e-0))) (cond ((equal? sc1 1) (let ((act-24 ((arg-3 arg-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) e-5) clam-0))) (vector 1 act-25))))))) (else (vector 1 0)))))) (else (vector 1 0))))))
(define IdrisC-45REPLC-45Common-n--12665-3457-u--typeSummary (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-0 (let ((e-0 (vector-ref arg-5 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (csegen-2875) (let ((e-1 (unbox e-5))) (let ((act-25 (let ((act-25 (CoreC-45Normalise-normaliseHoles arg-3 '() arg-5 '() (let ((e-2 (vector-ref e-1 2))) e-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Resugar-resugar '() arg-3 arg-2 '() e-6 ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ":") (IdrisC-45REPLC-45Common-prettyTerm e-6))))))))))))))))
(define IdrisC-45REPLC-45Common-n--11796-2634-u--addOne (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (cons (bs+ e-2 1 63) (bs+ e-3 1 63))))))
(define IdrisC-45REPLC-45Common-updateErrorLine (lambda (arg-0 arg-1 ext-0) (if (null? arg-1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 '() e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25)))))) (let ((e-2 (car arg-1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-19 (vector-ref e-5 2))) (let ((e-18 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-19 e-18 e-4 e-17 e-6 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Core-getErrorLoc e-2) (lambda (eta-0) (IdrisC-45REPLC-45Common-getFCLine eta-0))) e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-25))))))))))
(define IdrisC-45REPLC-45Common-resetContext (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (CoreC-45Context-initDefs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-32 (vector-ref e-6 5))) (let ((e-31 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-clearNames (let ((e-59 (vector-ref e-5 4))) e-59)) e-32 e-31 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30)))))))))))))))))))))))))))))))))) (vector 1 act-26)))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45InitPrimitives-addPrimitives arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (set-box! arg-1 (CoreC-45UnifyState-initUState)))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (set-box! arg-2 (IdrisC-45Syntax-initSyntax)))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (set-box! arg-3 (CoreC-45Metadata-initMetadata arg-4)))) (vector 1 act-29))))))))))))))))))))
(define IdrisC-45REPLC-45Common-printWithStatus (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45REPLC-45Common-case--printWithStatus-2499 arg-4 arg-3 arg-2 arg-1 e-5 (let ((e-8 (vector-ref e-5 8))) e-8)) ext-0)))))))
(define IdrisC-45REPLC-45Common-printResult (lambda (arg-0 arg-1 ext-0) (IdrisC-45REPLC-45Common-printWithStatus arg-0 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Pretty-render arg-0 eta-0 eta-1))) arg-1 0 ext-0)))
(define IdrisC-45REPLC-45Common-printError (lambda (arg-0 arg-1 ext-0) (IdrisC-45REPLC-45Common-printWithStatus arg-0 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Pretty-render arg-0 eta-0 eta-1))) arg-1 1 ext-0)))
(define IdrisC-45REPLC-45Common-printDocResult (lambda (arg-0 arg-1 ext-0) (IdrisC-45REPLC-45Common-printWithStatus arg-0 (lambda (eta-0) (lambda (eta-1) (IdrisC-45PrettyC-45Render-render arg-0 (lambda (eta-2) (IdrisC-45DocC-45String-styleAnn eta-2)) eta-0 eta-1))) arg-1 0 ext-0)))
(define IdrisC-45REPLC-45Common-prettyTerm (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 5 eta-0)) (IdrisC-45Pretty-prettyTerm ext-0))))
(define IdrisC-45REPLC-45Common-iputStrLn (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-8 (vector-ref e-5 8))) (case (vector-ref e-8 0) ((1) (let ((e-18 (vector-ref e-8 1))) (cond ((equal? e-18 2) (let ((act-25 (IdrisC-45Pretty-render arg-1 arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-19 (vector-ref act-25 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-25 1))) (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) e-19) ext-0))) (vector 1 act-26)))))))(else (vector 1 0))))) (else (let ((e-20 (vector-ref e-8 1))) (let ((e-18 (vector-ref e-8 3))) (let ((act-25 (IdrisC-45PrettyC-45Render-renderWithoutColor arg-1 arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-21 (vector-ref act-25 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-25 1))) ((IdrisC-45IDEModeC-45Commands-send arg-0 (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp eta-0)) e-18 (vector 0 (cons (vector 4 "write-string") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_String e-21) (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Integer e-20) '()))))) ext-0))))))))))))))))
(define IdrisC-45REPLC-45Common-getFCLine (lambda (ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45FC-startLine eta-0)) (CoreC-45FC-isNonEmptyFC ext-0))))
(define IdrisC-45REPLC-45Common-equivTypes (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (CoreC-45TT-isErased arg-1))) (cond ((equal? sc0 0) (let ((act-24 (CoreC-45ContextC-45Log-logTerm '() arg-0 "typesearch.equiv" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Candidate: ") arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (CoreC-45Normalise-getArity arg-0 '() e-6 '() arg-1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Normalise-getArity arg-0 '() e-6 '() arg-2 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-7 e-8)))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) (let ((act-27 (CoreC-45Core-newRef (vector "Core.UnifyState.UST" ) (CoreC-45UnifyState-initUState) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-28 (((((CoreC-45Unify-unify (csegen-1962) '() arg-0 e-8 (CoreC-45Unify-inTerm) (vector 2 )) '()) arg-1) arg-2) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-0 (vector-ref e-9 0))) (let ((e-2 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (if (null? e-0) (if (null? e-2) (case (vector-ref e-3 0) ((0) (vector 1 1))(else (vector 1 0))) (vector 1 0)) (vector 1 0)))))))))) (lambda (u--err) (lambda (eta-0) (vector 1 0))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (cond ((equal? e-9 1) (CoreC-45ContextC-45Log-logTerm '() arg-0 "typesearch.equiv" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () "Accepted: ") arg-1 ext-0)) (else (vector 1 0))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 e-9))))))))))))) (else (vector 1 0)))))))))))))))(else (vector 1 0))))))
(define IdrisC-45REPLC-45Common-emitWarningsAndErrors (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (IdrisC-45REPLC-45Common-emitWarnings arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPLC-45Common-emitError arg-0 arg-1 arg-2 eta-0 eta-1))) arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 e-5))))))))))
(define IdrisC-45REPLC-45Common-emitWarnings (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ws (PreludeC-45TypesC-45List-reverse (let ((e-29 (vector-ref e-5 29))) e-29)))) (let ((act-25 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (let ((e-18 (vector-ref e-6 18))) e-18))) (cond ((equal? sc2 1) (let ((u--errs (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (vector 67 eta-0)) u--ws))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 u--errs)))) (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45Common-emitError arg-0 arg-1 arg-2 eta-1 eta-2))) u--errs eta-0)) ext-0))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-2216) (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45Common-emitWarning arg-0 arg-1 arg-2 eta-1 eta-2))) u--ws eta-0)) ext-0)))))))))))))))
(define IdrisC-45REPLC-45Common-emitWarning (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (IdrisC-45REPLC-45Common-emitProblem arg-0 arg-1 arg-2 arg-3 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Error-displayWarning arg-0 arg-2 arg-1 eta-0 eta-1))) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Error-pwarning arg-0 arg-2 arg-1 eta-0 eta-1))) (lambda (eta-0) (CoreC-45Core-getWarningLoc eta-0)) 2 ext-0)))
(define IdrisC-45REPLC-45Common-emitProblem (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-8 (vector-ref e-5 8))) (case (vector-ref e-8 0) ((1) (let ((act-25 ((arg-5 arg-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-19 (vector-ref act-25 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-25 1))) (IdrisC-45REPLC-45Common-printWithStatus arg-2 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Pretty-render arg-2 eta-0 eta-1))) e-19 arg-8 ext-0)))))) (else (let ((e-20 (vector-ref e-8 1))) (let ((e-19 (vector-ref e-8 2))) (let ((e-18 (vector-ref e-8 3))) (let ((act-25 ((arg-6 arg-4) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-21 (vector-ref act-25 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-25 1))) ((IdrisC-45REPLC-45Common-case--caseC-32blockC-32inC-32emitProblem-2739 arg-8 arg-7 arg-6 arg-5 arg-3 arg-2 arg-1 e-5 e-19 arg-4 e-18 e-20 e-21 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45FC-toNonEmptyFC eta-0)) (arg-7 arg-4))) ext-0)))))))))))))))))
(define IdrisC-45REPLC-45Common-emitError (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (IdrisC-45REPLC-45Common-emitProblem arg-0 arg-1 arg-2 arg-3 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Error-display arg-0 arg-2 arg-1 eta-0 eta-1))) (lambda (eta-0) (IdrisC-45Error-perror arg-0 arg-2 arg-1 eta-0)) (lambda (eta-0) (CoreC-45Core-getErrorLoc eta-0)) 1 ext-0)))
(define IdrisC-45REPLC-45Common-docsOrSignature (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtName arg-4 (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Context-undefinedName arg-1 arg-3 arg-4 ext-0) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (let ((_-0 (cons e-1 e-2))) (let ((u--all (cons e-1 e-2))) ((IdrisC-45REPLC-45Common-case--caseC-32blockC-32inC-32docsOrSignature-3604 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 e-2 e-1 _-0 u--all (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (u--n) (LibrariesC-45DataC-45ANameMap-lookupName u--n (let ((e-11 (vector-ref e-5 7))) e-11))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--all))) ext-0))))))))))))))))))))
(define IdrisC-45REPLC-45Common-doPrint (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 2) 1) ((equal? arg-1 1) 1) (else 1))) ((equal? arg-0 1) (cond ((equal? arg-1 2) 1) ((equal? arg-1 1) 1) (else 0))) (else (cond ((equal? arg-1 2) 1) ((equal? arg-1 1) 0) (else 0))))))
(define IdrisC-45IDEModeC-45Holes-case--isHole-613 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((7) (let ((e-0 (vector-ref arg-1 1))) (box e-0))) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-0 (vector-ref e-2 0))) (if (null? e-0) '() (let ((e-8 (unbox e-0))) (box e-8)))))) ((0) (box 0))(else '()))))
(define IdrisC-45IDEModeC-45Holes-n--9118-543-u--prettyHole (lambda (arg-0 arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name (let ((e-0 (vector-ref arg-1 0))) e-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-prettyTerm (let ((e-1 (vector-ref arg-1 1))) e-1))))))
(define IdrisC-45IDEModeC-45Holes-n--9615-1011-u--dropShadows (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((sc1 (PreludeC-45Types-elem (csegen-802) (let ((e-0 (vector-ref e-2 0))) e-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (let ((e-0 (vector-ref eta-0 0))) e-0)) e-3)))) (cond ((equal? sc1 1) (IdrisC-45IDEModeC-45Holes-n--9615-1011-u--dropShadows arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)) (else (cons e-2 (IdrisC-45IDEModeC-45Holes-n--9615-1011-u--dropShadows arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3))))))))))
(define IdrisC-45IDEModeC-45Holes-tidy (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) e-0))(else (CoreC-45Name-u--show_Show_Name arg-0)))))
(define IdrisC-45IDEModeC-45Holes-showName (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((2) 0)(else 1)))) ((2) 0)(else 1))))
(define IdrisC-45IDEModeC-45Holes-sexpPremise (lambda (arg-0) (vector 0 (cons (vector 1 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (Algebra-showCount (let ((e-2 (vector-ref arg-0 2))) e-2)) (PreludeC-45TypesC-45String-C-43C-43 " " (IdrisC-45IDEModeC-45Holes-impBracket (let ((e-3 (vector-ref arg-0 3))) e-3) (IdrisC-45IDEModeC-45Holes-tidy (let ((e-0 (vector-ref arg-0 0))) e-0))))))) (cons (vector 1 (IdrisC-45Syntax-u--show_Show_IPTerm (let ((e-1 (vector-ref arg-0 1))) e-1))) (cons (vector 0 '()) '()))))))
(define IdrisC-45IDEModeC-45Holes-sexpHole (lambda (arg-0) (vector 0 (cons (vector 1 (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-0 0))) e-0))) (cons (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45IDEModeC-45Holes-sexpPremise eta-0)) (let ((e-2 (vector-ref arg-0 2))) e-2))) (cons (vector 0 (cons (vector 1 (IdrisC-45Syntax-u--show_Show_IPTerm (let ((e-1 (vector-ref arg-0 1))) e-1))) (cons (vector 0 '()) '()))) '()))))))
(define IdrisC-45IDEModeC-45Holes-prettyRigHole (lambda (ext-0) (AlgebraC-45Semiring-elimSemi (csegen-475) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Char #\1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space)) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space))) ext-0)))
(define IdrisC-45IDEModeC-45Holes-prettyName (lambda (arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-0 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-0)))(else (CoreC-45Name-u--pretty_Pretty_Name arg-1)))))
(define IdrisC-45IDEModeC-45Holes-prettyImpBracket (lambda (arg-1 ext-0) (cond ((equal? arg-1 0) ext-0) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces ext-0)))))
(define IdrisC-45IDEModeC-45Holes-prettyHoles (lambda (arg-0) (if (null? arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "No holes"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "No holes")) (else "No holes"))))))) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "1 hole") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (IdrisC-45IDEModeC-45Holes-n--9118-543-u--prettyHole arg-0 e-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat (PreludeC-45TypesC-45List-length arg-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "holes") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (IdrisC-45IDEModeC-45Holes-n--9118-543-u--prettyHole arg-0 eta-0))) arg-0)))))))))
(define IdrisC-45IDEModeC-45Holes-prettyHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (IdrisC-45IDEModeC-45Holes-holeData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (vector-ref e-5 2))) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Name (let ((e-6 (vector-ref e-5 0))) e-6)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-prettyTerm (let ((e-4 (vector-ref e-5 1))) e-4))))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (u--premise) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45IDEModeC-45Holes-prettyRigHole (let ((e-4 (vector-ref u--premise 2))) e-4)) (IdrisC-45IDEModeC-45Holes-prettyImpBracket (let ((e-3 (vector-ref u--premise 3))) e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45IDEModeC-45Holes-prettyName (let ((e-7 (vector-ref u--premise 0))) e-7)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-prettyTerm (let ((e-6 (vector-ref u--premise 1))) e-6))))))) (let ((e-3 (vector-ref e-5 2))) e-3)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))) #\-))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Name-nameRoot (let ((e-6 (vector-ref e-5 0))) e-6)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45Pretty-prettyTerm (let ((e-4 (vector-ref e-5 1))) e-4)))))))))))))
(define IdrisC-45IDEModeC-45Holes-isHole (lambda (arg-0) (IdrisC-45IDEModeC-45Holes-case--isHole-613 arg-0 (let ((e-17 (vector-ref arg-0 17))) e-17))))
(define IdrisC-45IDEModeC-45Holes-impBracket (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1) (else (PreludeC-45TypesC-45String-C-43C-43 "{" (PreludeC-45TypesC-45String-C-43C-43 arg-1 "}"))))))
(define IdrisC-45IDEModeC-45Holes-holeData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 ((IdrisC-45IDEModeC-45Holes-extractHoleData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getPPrint arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (let ((sc2 (let ((e-0 (vector-ref e-6 0))) e-0))) (cond ((equal? sc2 1) e-5) (else (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (vector e-0 e-1 (IdrisC-45IDEModeC-45Holes-n--9615-1011-u--dropShadows arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-2)))))))))))))))))))
(define IdrisC-45IDEModeC-45Holes-getUserHolesData (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ctxt (let ((e-0 (vector-ref e-5 0))) e-0))) (let ((act-25 (CoreC-45Context-getUserHoles arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (u--n) (CoreC-45Context-lookupCtxtName u--n u--ctxt)) e-6 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--globs (PreludeC-45Interfaces-concat (csegen-50) e-7))) (let ((u--holesWithArgs (DataC-45List-mapMaybe (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-8 (cdr e-3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45IDEModeC-45Holes-isHole e-8) (lambda (u--args) (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-2 (cons e-8 u--args))))))))) u--globs))) (CoreC-45Core-traverseC-39 (lambda (u--n_gdef_args) (let ((e-2 (car u--n_gdef_args))) (let ((e-3 (cdr u--n_gdef_args))) (lambda (clam-0) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (IdrisC-45IDEModeC-45Holes-holeData '() arg-0 arg-1 e-5 '() e-2 e-8 (let ((e-28 (vector-ref e-9 2))) e-28) clam-0))))))) u--holesWithArgs '() ext-0))))))))))))))))))
(define IdrisC-45IDEModeC-45Holes-extractHoleData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-6 0) (lambda (eta-0) (let ((act-24 (CoreC-45Normalise-normalise arg-1 arg-0 arg-3 arg-4 arg-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-4 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (CoreC-45Context-toFullNames arg-1 (csegen-76) arg-7 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-1 "idemode.hole" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Return type: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  Evaluated to: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  Resugared to: " (IdrisC-45Syntax-u--show_Show_IPTerm e-6))))))) eta-0))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (vector arg-5 e-6 '())))))))))))))))(else (let ((e-0 (- arg-6 1))) (case (vector-ref arg-7 0) ((3) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (case (vector-ref e-4 0) ((1) (let ((e-9 (vector-ref e-4 3))) (IdrisC-45IDEModeC-45Holes-extractHoleData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-0 (CoreC-45TTC-45SubstEnv-subst e-9 e-5))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45IDEModeC-45Holes-extractHoleData (cons e-3 arg-0) arg-1 arg-2 arg-3 (cons e-4 arg-4) arg-5 e-0 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((sc2 (IdrisC-45IDEModeC-45Holes-showName e-3))) (cond ((equal? sc2 1) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "idemode.hole" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Showing name: " (CoreC-45Name-u--show_Show_Name e-3))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 (let ((act-26 (CoreC-45Normalise-normalise arg-1 arg-0 arg-3 arg-4 (CoreC-45TT-binderType e-4) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-4 e-8 eta-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((u--premise (vector e-3 e-8 (CoreC-45TT-multiplicity e-4) (CoreC-45TT-isImplicit e-4)))) (vector 1 (let ((e-10 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-9 (vector-ref e-6 2))) (vector e-10 e-1 (cons u--premise e-9))))))))))))))) (else (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "idemode.hole" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Not showing name: " (CoreC-45Name-u--show_Show_Name e-3))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (vector 1 e-6))))))))))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45Normalise-normalise arg-1 arg-0 arg-3 arg-4 arg-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-4 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (CoreC-45Context-toFullNames arg-1 (csegen-76) arg-7 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-toFullNames arg-1 (csegen-76) e-5 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45ContextC-45Log-log arg-1 "idemode.hole" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Return type: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  Evaluated to: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  Resugared to: " (IdrisC-45Syntax-u--show_Show_IPTerm e-6))))))) eta-0))))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (vector arg-5 e-6 '())))))))))))))))))))))
(define IdrisC-45IDEModeC-45Commands-case--toSExp-3767 (lambda (arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (vector 0 (cons ((Builtin-fst arg-2) arg-3) e-0))))(else (vector 0 (cons ((Builtin-fst arg-2) arg-3) (cons arg-5 '())))))))
(define IdrisC-45IDEModeC-45Commands-n--5703-2706-u--getMode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-4 "all")))
(define IdrisC-45IDEModeC-45Commands-n--6831-3543-u--escapeChar (lambda (arg-0) (cond ((equal? arg-0 #\\) (cons #\\ (cons #\\ '()))) ((equal? arg-0 #\") (cons #\\ (cons #\" '())))(else (cons arg-0 '())))))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_String (lambda (ext-0) (vector 1 ext-0)))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp (lambda (ext-0) ext-0))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Nat (lambda (ext-0) (vector 3 (PreludeC-45Cast-u--cast_Cast_Nat_Integer ext-0))))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Name (lambda (ext-0) (vector 4 (CoreC-45Name-u--show_Show_Name ext-0))))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Integer (lambda (ext-0) (vector 3 ext-0)))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Int (lambda (ext-0) (vector 3 (PreludeC-45Cast-u--cast_Cast_Int_Integer ext-0))))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Bool (lambda (ext-0) (vector 2 ext-0)))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (IdrisC-45IDEModeC-45Commands-case--toSExp-3767 arg-2 e-2 e-3 ((Builtin-snd arg-2) e-3))))))
(define IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (arg-0) (arg-1 arg-0)) arg-2))))
(define IdrisC-45IDEModeC-45Commands-u--show_Show_SExp (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--show_Show_SExp eta-0)) e-0)) ")")))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45Commands-escape e-1) "\"")))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45Show-u--show_Show_Bool e-2)))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Integer e-3))) (else (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 ":" e-4))))))
(define IdrisC-45IDEModeC-45Commands-version (lambda (arg-0 arg-1) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (arg-3649) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp arg-3649)) (lambda (arg-3649) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (arg-3650) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Int arg-3650)) (lambda (arg-3650) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Int arg-3650))) arg-3649))) (cons (vector 4 "protocol-version") (cons arg-0 arg-1)))))
(define IdrisC-45IDEModeC-45Commands-sendStr (lambda (arg-0 arg-1 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) 0) (SystemC-45FileC-45ReadWrite-fPutStr (csegen-3) arg-0 arg-1) ext-0)))
(define IdrisC-45IDEModeC-45Commands-send (lambda (arg-1 arg-2 arg-3 arg-4) (let ((u--r (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45Commands-u--show_Show_SExp (arg-2 arg-4)) "\xa;"))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-1 "ide-mode.send" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () u--r) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (IdrisC-45IDEModeC-45Commands-sendStr arg-3 (LibrariesC-45UtilsC-45Hex-leftPad #\0 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))) (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Nat_Bits64 (PreludeC-45TypesC-45String-length u--r)))) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (IdrisC-45IDEModeC-45Commands-sendStr arg-3 u--r eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((SystemC-45FileC-45Process-fflush (csegen-3) arg-3) eta-0))) (vector 1 act-27)))))))))))))))
(define IdrisC-45IDEModeC-45Commands-readHints (lambda (arg-0) (if (null? arg-0) (box '()) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45IDEModeC-45Commands-readHints e-3) (lambda (u--restC-39) (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-4 u--restC-39))))))(else '())))))))
(define IdrisC-45IDEModeC-45Commands-getMsg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) '() (let ((e-2 (car e-0))) (let ((e-3 (cdr e-0))) (if (null? e-3) '() (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (case (vector-ref e-5 0) ((3) (let ((e-7 (vector-ref e-5 1))) (if (null? e-6) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45IDEModeC-45Commands-getIDECommand e-2) (lambda (u--cmd) (PreludeC-45Types-u--pure_Applicative_Maybe (cons u--cmd e-7)))) '())))(else '()))))))))))(else '()))))
(define IdrisC-45IDEModeC-45Commands-getIDECommand (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) '() (let ((e-3 (car e-0))) (let ((e-4 (cdr e-0))) (case (vector-ref e-3 0) ((4) (let ((e-5 (vector-ref e-3 1))) (cond ((equal? e-5 "interpret") (if (null? e-4) '() (let ((e-7 (car e-4))) (let ((e-8 (cdr e-4))) (case (vector-ref e-7 0) ((1) (let ((e-9 (vector-ref e-7 1))) (if (null? e-8) (box (vector 0 e-9)) '())))(else '())))))) ((equal? e-5 "load-file") (if (null? e-4) '() (let ((e-12 (car e-4))) (let ((e-13 (cdr e-4))) (case (vector-ref e-12 0) ((1) (let ((e-14 (vector-ref e-12 1))) (if (null? e-13) (box (vector 1 e-14 '())) (let ((e-17 (car e-13))) (let ((e-18 (cdr e-13))) (case (vector-ref e-17 0) ((3) (let ((e-19 (vector-ref e-17 1))) (if (null? e-18) (box (vector 1 e-14 (box e-19))) '())))(else '())))))))(else '())))))) ((equal? e-5 "type-of") (if (null? e-4) '() (let ((e-22 (car e-4))) (let ((e-23 (cdr e-4))) (case (vector-ref e-22 0) ((1) (let ((e-24 (vector-ref e-22 1))) (if (null? e-23) (box (vector 2 e-24 '())) (let ((e-27 (car e-23))) (let ((e-28 (cdr e-23))) (case (vector-ref e-27 0) ((3) (let ((e-29 (vector-ref e-27 1))) (if (null? e-28) '() (let ((e-31 (car e-28))) (let ((e-32 (cdr e-28))) (case (vector-ref e-31 0) ((3) (let ((e-33 (vector-ref e-31 1))) (if (null? e-32) (box (vector 2 e-24 (box (cons e-29 e-33)))) '())))(else '())))))))(else '())))))))(else '())))))) ((equal? e-5 "name-at") (if (null? e-4) '() (let ((e-36 (car e-4))) (let ((e-37 (cdr e-4))) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (if (null? e-37) (box (vector 3 e-38 '())) (let ((e-41 (car e-37))) (let ((e-42 (cdr e-37))) (case (vector-ref e-41 0) ((3) (let ((e-43 (vector-ref e-41 1))) (if (null? e-42) '() (let ((e-45 (car e-42))) (let ((e-46 (cdr e-42))) (case (vector-ref e-45 0) ((3) (let ((e-47 (vector-ref e-45 1))) (if (null? e-46) (box (vector 3 e-38 (box (cons e-43 e-47)))) '())))(else '())))))))(else '())))))))(else '())))))) ((equal? e-5 "case-split") (if (null? e-4) '() (let ((e-50 (car e-4))) (let ((e-51 (cdr e-4))) (case (vector-ref e-50 0) ((3) (let ((e-52 (vector-ref e-50 1))) (if (null? e-51) '() (let ((e-54 (car e-51))) (let ((e-55 (cdr e-51))) (case (vector-ref e-54 0) ((3) (let ((e-56 (vector-ref e-54 1))) (if (null? e-55) '() (let ((e-59 (car e-55))) (let ((e-60 (cdr e-55))) (case (vector-ref e-59 0) ((1) (let ((e-61 (vector-ref e-59 1))) (if (null? e-60) (box (vector 4 e-52 e-56 e-61)) '())))(else '()))))))) ((1) (let ((e-57 (vector-ref e-54 1))) (if (null? e-55) (box (vector 4 e-52 0 e-57)) '())))(else '())))))))(else '())))))) ((equal? e-5 "add-clause") (if (null? e-4) '() (let ((e-65 (car e-4))) (let ((e-66 (cdr e-4))) (case (vector-ref e-65 0) ((3) (let ((e-67 (vector-ref e-65 1))) (if (null? e-66) '() (let ((e-69 (car e-66))) (let ((e-70 (cdr e-66))) (case (vector-ref e-69 0) ((1) (let ((e-71 (vector-ref e-69 1))) (if (null? e-70) (box (vector 5 e-67 e-71)) '())))(else '())))))))(else '())))))) ((equal? e-5 "add-missing") (if (null? e-4) '() (let ((e-74 (car e-4))) (let ((e-75 (cdr e-4))) (case (vector-ref e-74 0) ((3) (let ((e-76 (vector-ref e-74 1))) (if (null? e-75) '() (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (case (vector-ref e-78 0) ((1) (let ((e-80 (vector-ref e-78 1))) (if (null? e-79) (box (vector 6 e-76 e-80)) '())))(else '())))))))(else '())))))) ((equal? e-5 "proof-search") (if (null? e-4) '() (let ((e-83 (car e-4))) (let ((e-84 (cdr e-4))) (case (vector-ref e-83 0) ((3) (let ((e-85 (vector-ref e-83 1))) (if (null? e-84) '() (let ((e-87 (car e-84))) (let ((e-88 (cdr e-84))) (case (vector-ref e-87 0) ((1) (let ((e-89 (vector-ref e-87 1))) (if (null? e-88) (box (vector 7 e-85 e-89 '() 0)) (let ((e-92 (car e-88))) (let ((e-93 (cdr e-88))) (case (vector-ref e-92 0) ((0) (let ((e-94 (vector-ref e-92 1))) (if (null? e-93) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (u--hsC-39) (vector 7 e-85 e-89 u--hsC-39 0)) (IdrisC-45IDEModeC-45Commands-readHints e-94)) (let ((e-97 (car e-93))) (let ((e-98 (cdr e-93))) (case (vector-ref e-97 0) ((4) (let ((e-99 (vector-ref e-97 1))) (if (null? e-98) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (u--hsC-39) (vector 7 e-85 e-89 u--hsC-39 (IdrisC-45IDEModeC-45Commands-n--5703-2706-u--getMode e-85 e-89 e-94 e-99 e-99))) (IdrisC-45IDEModeC-45Commands-readHints e-94)) '())))(else '())))))))(else '())))))))(else '())))))))(else '())))))) ((equal? e-5 "generate-def") (if (null? e-4) '() (let ((e-102 (car e-4))) (let ((e-103 (cdr e-4))) (case (vector-ref e-102 0) ((3) (let ((e-104 (vector-ref e-102 1))) (if (null? e-103) '() (let ((e-106 (car e-103))) (let ((e-107 (cdr e-103))) (case (vector-ref e-106 0) ((1) (let ((e-108 (vector-ref e-106 1))) (if (null? e-107) (box (vector 9 e-104 e-108)) '())))(else '())))))))(else '())))))) ((equal? e-5 "make-lemma") (if (null? e-4) '() (let ((e-111 (car e-4))) (let ((e-112 (cdr e-4))) (case (vector-ref e-111 0) ((3) (let ((e-113 (vector-ref e-111 1))) (if (null? e-112) '() (let ((e-115 (car e-112))) (let ((e-116 (cdr e-112))) (case (vector-ref e-115 0) ((1) (let ((e-117 (vector-ref e-115 1))) (if (null? e-116) (box (vector 11 e-113 e-117)) '())))(else '())))))))(else '())))))) ((equal? e-5 "make-case") (if (null? e-4) '() (let ((e-120 (car e-4))) (let ((e-121 (cdr e-4))) (case (vector-ref e-120 0) ((3) (let ((e-122 (vector-ref e-120 1))) (if (null? e-121) '() (let ((e-124 (car e-121))) (let ((e-125 (cdr e-121))) (case (vector-ref e-124 0) ((1) (let ((e-126 (vector-ref e-124 1))) (if (null? e-125) (box (vector 12 e-122 e-126)) '())))(else '())))))))(else '())))))) ((equal? e-5 "make-with") (if (null? e-4) '() (let ((e-129 (car e-4))) (let ((e-130 (cdr e-4))) (case (vector-ref e-129 0) ((3) (let ((e-131 (vector-ref e-129 1))) (if (null? e-130) '() (let ((e-133 (car e-130))) (let ((e-134 (cdr e-130))) (case (vector-ref e-133 0) ((1) (let ((e-135 (vector-ref e-133 1))) (if (null? e-134) (box (vector 13 e-131 e-135)) '())))(else '())))))))(else '())))))) ((equal? e-5 "docs-for") (if (null? e-4) '() (let ((e-138 (car e-4))) (let ((e-139 (cdr e-4))) (case (vector-ref e-138 0) ((1) (let ((e-140 (vector-ref e-138 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (if (null? e-139) (box '()) (let ((e-2 (car e-139))) (let ((e-6 (cdr e-139))) (case (vector-ref e-2 0) ((4) (let ((e-7 (vector-ref e-2 1))) (cond ((equal? e-7 "overview") (if (null? e-6) (box (box 0)) '())) ((equal? e-7 "full") (if (null? e-6) (box (box 1)) '()))(else '()))))(else '()))))) (lambda (u--modeOpt) (box (vector 14 e-140 u--modeOpt))))))(else '())))))) ((equal? e-5 "apropos") (if (null? e-4) '() (let ((e-142 (car e-4))) (let ((e-143 (cdr e-4))) (case (vector-ref e-142 0) ((1) (let ((e-144 (vector-ref e-142 1))) (if (null? e-143) (box (vector 16 e-144)) '())))(else '())))))) ((equal? e-5 "directive") (if (null? e-4) '() (let ((e-147 (car e-4))) (let ((e-148 (cdr e-4))) (case (vector-ref e-147 0) ((1) (let ((e-149 (vector-ref e-147 1))) (if (null? e-148) (box (vector 15 e-149)) '())))(else '())))))) ((equal? e-5 "metavariables") (if (null? e-4) '() (let ((e-152 (car e-4))) (let ((e-153 (cdr e-4))) (case (vector-ref e-152 0) ((3) (let ((e-154 (vector-ref e-152 1))) (if (null? e-153) (box (vector 17 e-154)) '())))(else '())))))) ((equal? e-5 "who-calls") (if (null? e-4) '() (let ((e-157 (car e-4))) (let ((e-158 (cdr e-4))) (case (vector-ref e-157 0) ((1) (let ((e-159 (vector-ref e-157 1))) (if (null? e-158) (box (vector 18 e-159)) '())))(else '())))))) ((equal? e-5 "calls-who") (if (null? e-4) '() (let ((e-162 (car e-4))) (let ((e-163 (cdr e-4))) (case (vector-ref e-162 0) ((1) (let ((e-164 (vector-ref e-162 1))) (if (null? e-163) (box (vector 19 e-164)) '())))(else '())))))) ((equal? e-5 "browse-namespace") (if (null? e-4) '() (let ((e-167 (car e-4))) (let ((e-168 (cdr e-4))) (case (vector-ref e-167 0) ((1) (let ((e-169 (vector-ref e-167 1))) (if (null? e-168) (box (vector 20 e-169)) '())))(else '())))))) ((equal? e-5 "normalise-term") (if (null? e-4) '() (let ((e-172 (car e-4))) (let ((e-173 (cdr e-4))) (case (vector-ref e-172 0) ((1) (let ((e-174 (vector-ref e-172 1))) (if (null? e-173) (box (vector 21 e-174)) '())))(else '())))))) ((equal? e-5 "show-term-implicits") (if (null? e-4) '() (let ((e-177 (car e-4))) (let ((e-178 (cdr e-4))) (case (vector-ref e-177 0) ((1) (let ((e-179 (vector-ref e-177 1))) (if (null? e-178) (box (vector 22 e-179)) '())))(else '())))))) ((equal? e-5 "hide-term-implicits") (if (null? e-4) '() (let ((e-182 (car e-4))) (let ((e-183 (cdr e-4))) (case (vector-ref e-182 0) ((1) (let ((e-184 (vector-ref e-182 1))) (if (null? e-183) (box (vector 23 e-184)) '())))(else '())))))) ((equal? e-5 "elaborate-term") (if (null? e-4) '() (let ((e-187 (car e-4))) (let ((e-188 (cdr e-4))) (case (vector-ref e-187 0) ((1) (let ((e-189 (vector-ref e-187 1))) (if (null? e-188) (box (vector 24 e-189)) '())))(else '())))))) ((equal? e-5 "print-definition") (if (null? e-4) '() (let ((e-192 (car e-4))) (let ((e-193 (cdr e-4))) (case (vector-ref e-192 0) ((1) (let ((e-194 (vector-ref e-192 1))) (if (null? e-193) (box (vector 25 e-194)) '())))(else '())))))) ((equal? e-5 "repl-completions") (if (null? e-4) '() (let ((e-197 (car e-4))) (let ((e-198 (cdr e-4))) (case (vector-ref e-197 0) ((1) (let ((e-199 (vector-ref e-197 1))) (if (null? e-198) (box (vector 26 e-199)) '())))(else '())))))) ((equal? e-5 "enable-syntax") (if (null? e-4) '() (let ((e-202 (car e-4))) (let ((e-203 (cdr e-4))) (case (vector-ref e-202 0) ((2) (let ((e-204 (vector-ref e-202 1))) (if (null? e-203) (box (vector 27 e-204)) '())))(else '())))))) ((equal? e-5 "get-options") (if (null? e-4) (box (vector 29 )) '()))(else '()))))(else '()))))))) ((4) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 "proof-search-next") (box (vector 8 ))) ((equal? e-1 "generate-def-next") (box (vector 10 ))) ((equal? e-1 "version") (box (vector 28 )))(else '()))))(else '()))))
(define IdrisC-45IDEModeC-45Commands-escape (lambda (ext-0) (PreludeC-45Types-fastPack (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-n--6831-3543-u--escapeChar eta-0)) (PreludeC-45Types-fastUnpack ext-0)))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForName-4283 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (if (null? arg-13) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45DocC-45String-n--11674-1377-u--showDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-0 eta-0)) arg-13 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat e-5)))))))))
(define IdrisC-45DocC-45String-case--getDocsForName-4240 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (CoreC-45Context-undefinedName arg-4 arg-2 arg-1 eta-0)) (let ((e-1 (car arg-10))) (let ((e-2 (cdr arg-10))) (let ((u--all (cons e-1 e-2))) (lambda (eta-0) (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForName-4283 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 e-1 u--all (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (u--n) (LibrariesC-45DataC-45ANameMap-lookupName u--n (let ((e-7 (vector-ref arg-6 7))) e-7))) u--all) eta-0))))))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getExtra-3323 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((1) (lambda (eta-0) (vector 1 (cons '() (cons (IdrisC-45DocC-45String-n--11674-1379-u--showTotal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (let ((e-10 (vector-ref arg-6 10))) e-10)) '()))))) ((6) (let ((e-11 (vector-ref arg-9 7))) (let ((u--tot (cons (IdrisC-45DocC-45String-n--11674-1379-u--showTotal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (let ((e-24 (vector-ref arg-6 10))) e-24)) '()))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (PreludeC-45Basics-flip (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (let ((act-24 (eta-4 eta-6))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-24 1))) ((eta-5 e-13) eta-6)))))))) eta-2 (eta-1 eta-3))))) (lambda (eta-1) (lambda (eta-2) (IdrisC-45DocC-45String-n--11674-1380-u--getDConDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-4 (csegen-46) eta-1 eta-2)))) e-11 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-24 1))) (let ((act-25 (if (null? e-13) (vector 1 (cons (box "data") '())) (let ((e-2 (car e-13))) (let ((e-3 (cdr e-13))) (if (null? e-3) (let ((u--cdoc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (csegen-2898) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) e-2)))) (let ((act-25 ((IdrisC-45DocC-45String-n--11674-1388-u--getFieldsDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-25 1))) (if (null? e-14) (vector 1 (cons (box "data") (cons u--cdoc '()))) (let ((e-4 (unbox e-14))) (vector 1 (cons (box "record") (cons u--cdoc (cons e-4 '()))))))))))) (vector 1 (cons (box "data") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (csegen-2905) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 eta-1)) e-13))) '()))) '()))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45DocC-45String-getHintsForType arg-4 arg-3 arg-7 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-26 1))) (vector 1 (let ((e-2 (car e-14))) (let ((e-3 (cdr e-14))) (cons e-2 (PreludeC-45TypesC-45List-tailRecAppend u--tot (PreludeC-45TypesC-45List-tailRecAppend e-3 e-15))))))))))))))))))))))(else (lambda (eta-0) (vector 1 (cons '() '())))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getFieldsDoc-3086 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (if (null? e-2) (lambda (eta-0) (vector 1 '())) (let ((e-5 (unbox e-2))) (let ((u--recNS (CoreC-45NameC-45Namespace-C-60C-46C-62 e-5 (CoreC-45NameC-45Namespace-mkNamespace e-3)))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--fields (CoreC-45Context-getFieldNames (let ((e-0 (vector-ref e-6 0))) e-0) u--recNS))) (let ((act-25 (let ((act-25 (unbox arg-3))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (if (null? u--fields) (vector 1 '()) (let ((e-8 (car u--fields))) (let ((e-4 (cdr u--fields))) (if (null? e-4) (let ((act-26 (IdrisC-45DocC-45String-n--11674-1387-u--getFieldDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-8 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc7 (DataC-45String-isSuffixOf "\xa;" "Projection"))) (cond ((equal? sc7 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Projection")) (else "Projection")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) e-9)))))))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45DocC-45String-n--11674-1387-u--getFieldDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) u--fields '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (csegen-2920) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 eta-1)) e-9))) '()))))))))))))))))))))))))))))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getFieldDoc-2927 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (vector 1 arg-13)) (let ((e-1 (car arg-14))) (let ((e-2 (cdr arg-14))) (if (null? e-1) (lambda (eta-0) (vector 1 arg-13)) (let ((e-6 (cdr e-1))) (cond ((equal? e-6 "") (lambda (clam-0) (if (null? e-2) (vector 1 arg-13) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons arg-13 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (IdrisC-45DocC-45String-n--11674-1378-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6)))) '())))) (vector 1 arg-13)))))(else (lambda (clam-1) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons arg-13 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (IdrisC-45DocC-45String-n--11674-1378-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6)))) '())))) (vector 1 arg-13))))))))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-2773 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Parameters"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Parameters")) (else "Parameters")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Name-u--show_Show_Name eta-0))) arg-8)))) '()))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-2632 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((4) '())(else (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (csegen-2898) (cons (IdrisC-45DocC-45String-dCon arg-11 (IdrisC-45DocC-45String-prettyName arg-11)) '()))) '())))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-2544 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) '() (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Methods"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Methods")) (else "Methods")))))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 eta-0)) arg-13))) '()))) '()))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-2387 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) '() (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (if (null? e-3) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc2 (DataC-45String-isSuffixOf "\xa;" "Implementation"))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Implementation")) (else "Implementation")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) e-2)) '()) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (csegen-2948) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 eta-0)) arg-16))) '()))) '())))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getFixityDoc-2129 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (if (null? e-3) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc2 (DataC-45String-isSuffixOf "\xa;" "Fixity Declaration"))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Fixity Declaration")) (else "Fixity Declaration")))))))) e-2) '()) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (csegen-2962) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat arg-9))) '())))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getPrefixDoc-1992 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (vector 1 '()) (let ((e-1 (unbox arg-7))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (LibrariesC-45DataC-45StringMap-lookup e-2 (let ((e-13 (vector-ref e-5 1))) e-13)))) (if (null? sc3) (vector 1 '()) (let ((e-3 (unbox sc3))) (vector 1 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "prefix operator, level") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (PreludeC-45Show-u--show_Show_Nat e-3))) '())))))))))))(else (vector 1 '()))))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getInfixDoc-1849 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (vector 1 '()) (let ((e-1 (unbox arg-7))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc3 (LibrariesC-45DataC-45StringMap-lookup e-2 (let ((e-0 (vector-ref e-5 0))) e-0)))) (if (null? sc3) (vector 1 '()) (let ((e-3 (unbox sc3))) (let ((e-7 (car e-3))) (let ((e-6 (cdr e-3))) (vector 1 (PreludeC-45Types-u--pure_Applicative_List (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Syntax-u--show_Show_Fixity e-7)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "operator,") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "level") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (PreludeC-45Show-u--show_Show_Nat e-6)) '()))))))))))))))))))(else (vector 1 '()))))))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getDConDoc-1551 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-12)) (let ((e-1 (car arg-13))) (let ((e-2 (cdr arg-13))) (if (null? e-1) (lambda (eta-0) (vector 1 arg-12)) (let ((e-6 (cdr e-1))) (cond ((equal? e-6 "") (lambda (clam-0) (if (null? e-2) (vector 1 arg-12) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons arg-12 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (IdrisC-45DocC-45String-n--11674-1378-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6)))) '())))) (vector 1 arg-12)))))(else (lambda (clam-1) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons arg-12 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (IdrisC-45DocC-45String-n--11674-1378-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6)))) '())))) (vector 1 arg-12))))))))))))
(define IdrisC-45DocC-45String-case--getImplDocs-982 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? e-3) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc2 (DataC-45String-isSuffixOf "\xa;" "Hint"))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Hint")) (else "Hint")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) e-2)) '()) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (csegen-2977) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 eta-0)) arg-5))) '()))) '())))))))
(define IdrisC-45DocC-45String-case--prettyName-668 (lambda (arg-0 arg-1) (if (null? arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Name-nameRoot arg-0)) (let ((e-2 (unbox arg-1))) (let ((sc1 (ParserC-45LexerC-45Source-isOpUserName e-2))) (cond ((equal? sc1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (CoreC-45Name-u--pretty_Pretty_UserName e-2))) (else (CoreC-45Name-u--pretty_Pretty_UserName e-2))))))))
(define IdrisC-45DocC-45String-n--15393-4761-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref arg-4 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (vector 1 (CoreC-45TT-u--C-47C-61_Eq_Visibility (let ((e-9 (vector-ref e-1 9))) e-9) 0))))))))))
(define IdrisC-45DocC-45String-n--11674-1379-u--showTotal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-0 (car arg-7))) (case (vector-ref e-0 0) ((0) (csegen-2876))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Totality"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Totality")) (else "Totality")))))))) (CoreC-45TT-u--pretty_Pretty_Totality arg-7)))))))
(define IdrisC-45DocC-45String-n--11674-1377-u--showDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-5 (car arg-7))) (let ((e-6 (cdr arg-7))) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-36 (vector-ref e-7 0))) e-36)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-25 1))) (if (null? e-8) (CoreC-45Context-undefinedName arg-4 arg-2 e-5 clam-0) (let ((e-3 (unbox e-8))) (let ((act-26 (cond ((equal? e-2 1) (IdrisC-45DocC-45String-n--11674-1389-u--getExtra arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-3 clam-0)) (else (vector 1 (cons '() '())))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((act-27 ((PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-27 (eta-0 eta-2))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) ((eta-1 e-11) eta-2)))))))) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-resugar '() arg-4 arg-3 '() eta-0 eta-1))) (lambda (eta-0) (CoreC-45Normalise-normaliseHoles arg-4 '() e-7 '() (let ((e-30 (vector-ref e-3 2))) e-30) eta-0))) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-11 (vector-ref act-27 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-27 1))) (let ((u--ty (cond ((equal? e-1 1) ((case (vector-ref e-11 0) ((1) (let ((e-15 (vector-ref e-11 3))) (let ((e-12 (vector-ref e-11 6))) (case (vector-ref e-15 0) ((2) (lambda () e-12))(else (lambda () e-11))))))(else (lambda () e-11))))) (else e-11)))) (let ((act-28 (CoreC-45Context-aliasName arg-4 e-5 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-12 (vector-ref act-28 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-28 1))) (let ((u--cat (IdrisC-45Pretty-showCategory (lambda (eta-0) (vector 5 eta-0)) e-3))) (let ((u--nm (IdrisC-45DocC-45String-prettyKindedName e-10 (u--cat (cond ((equal? e-0 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (CoreC-45Name-u--show_Show_Name e-12))) (else (IdrisC-45DocC-45String-prettyName e-12))))))) (let ((u--docDecl (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons u--nm (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (cons (IdrisC-45DocC-45String-prettyTerm u--ty) '()))))))) (let ((u--docText (let ((u--docs (IdrisC-45DocC-45String-n--11674-1378-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6))) (PreludeC-45Interfaces-C-60C-36 (csegen-73) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat u--docs)) (PreludeC-45Interfaces-guard (csegen-538) (let ((sc8 ((PreludeC-45Types-u--null_Foldable_List u--docs)))) (cond ((equal? sc8 1) 0) (else 1)))))))) (let ((act-29 (IdrisC-45DocC-45String-n--11674-1385-u--getFixityDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-13 (vector-ref act-29 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-29 1))) (let ((u--docBody (let ((u--docs ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () (csegen-113)) u--docText) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 eta-0)) (PreludeC-45TypesC-45List-tailRecAppend e-4 e-13))))) (PreludeC-45Interfaces-C-60C-36 (csegen-257) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--l) (lambda (u--r) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--l (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline)) u--r))) u--docs)) (PreludeC-45Interfaces-guard (csegen-1201) (let ((sc9 ((PreludeC-45Types-u--null_Foldable_List u--docs)))) (cond ((equal? sc9 1) 0) (else 1)))))))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons u--docDecl u--docBody)))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45DocC-45String-n--11674-1378-u--reflowDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 "") '())(else (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow eta-0))) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines arg-6)))))))
(define IdrisC-45DocC-45String-n--11486-1198-u--primDoc (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (csegen-2993)) ((1) (csegen-2993)) ((2) (csegen-2993)) ((3) (csegen-2993)) ((4) (csegen-2993)) ((5) (csegen-2993)) ((6) (csegen-2993)) ((7) (csegen-2993)) ((8) (csegen-2993)) ((9) (csegen-2993)) ((10) (csegen-2993)) ((11) (csegen-2993)) ((12) (csegen-2993)) ((13) (csegen-2993)) ((14) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of bounded signed integers (backend dependent size)"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of bounded signed integers (backend dependent size)")) (else "Primitive type of bounded signed integers (backend dependent size)")))))))) ((15) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of 8 bits signed integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of 8 bits signed integers")) (else "Primitive type of 8 bits signed integers")))))))) ((16) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of 16 bits signed integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of 16 bits signed integers")) (else "Primitive type of 16 bits signed integers")))))))) ((17) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of 32 bits signed integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of 32 bits signed integers")) (else "Primitive type of 32 bits signed integers")))))))) ((18) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of 64 bits signed integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of 64 bits signed integers")) (else "Primitive type of 64 bits signed integers")))))))) ((19) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of unbounded signed integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of unbounded signed integers")) (else "Primitive type of unbounded signed integers")))))))) ((20) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of 8 bits unsigned integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of 8 bits unsigned integers")) (else "Primitive type of 8 bits unsigned integers")))))))) ((21) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of 16 bits unsigned integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of 16 bits unsigned integers")) (else "Primitive type of 16 bits unsigned integers")))))))) ((22) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of 32 bits unsigned integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of 32 bits unsigned integers")) (else "Primitive type of 32 bits unsigned integers")))))))) ((23) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of 64 bits unsigned integers"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of 64 bits unsigned integers")) (else "Primitive type of 64 bits unsigned integers")))))))) ((24) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of strings"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of strings")) (else "Primitive type of strings")))))))) ((25) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of characters"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of characters")) (else "Primitive type of characters")))))))) ((26) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive type of double-precision floating-points"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive type of double-precision floating-points")) (else "Primitive type of double-precision floating-points")))))))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Primitive token for IO actions"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Primitive token for IO actions")) (else "Primitive token for IO actions")))))))))))
(define IdrisC-45DocC-45String-n--15393-4762-u--inNS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (case (vector-ref e-1 0) ((1) (CoreC-45NameC-45Namespace-isParentOf arg-0 e-0))(else 0)))))(else 0))))
(define IdrisC-45DocC-45String-n--11674-1384-u--getPrefixDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (IdrisC-45DocC-45String-case--getDocsForNameC-44getPrefixDoc-1992 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (CoreC-45Name-userNameRoot arg-6))))
(define IdrisC-45DocC-45String-n--11674-1382-u--getMethDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (LibrariesC-45DataC-45ANameMap-lookupName (let ((e-0 (vector-ref arg-6 0))) e-0) (let ((e-7 (vector-ref e-5 7))) e-7)))) (if (null? sc1) (vector 1 '()) (let ((e-1 (car sc1))) (let ((e-2 (cdr sc1))) (if (null? e-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--pure_Applicative_List e-6)))))) (IdrisC-45DocC-45String-n--11674-1377-u--showDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45DocC-45String-methodsConfig) e-1) ext-0) (vector 1 '()))))))))))))
(define IdrisC-45DocC-45String-n--11674-1383-u--getInfixDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (IdrisC-45DocC-45String-case--getDocsForNameC-44getInfixDoc-1849 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (CoreC-45Name-userNameRoot arg-6))))
(define IdrisC-45DocC-45String-n--11674-1381-u--getImplDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-6 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-26 ((PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-26 (eta-0 eta-2))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((eta-1 e-7) eta-2)))))))) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-resugar '() arg-4 arg-3 '() eta-0 eta-1))) (lambda (eta-0) (CoreC-45Normalise-normaliseHoles arg-4 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2) eta-0))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 arg-6) (IdrisC-45DocC-45String-prettyTerm e-7)) '()))))))))))))))))))
(define IdrisC-45DocC-45String-n--11674-1386-u--getIFaceDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((u--params (IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-2773 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-3 (let ((e-7 (vector-ref e-3 2))) e-7)))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-pterm arg-4 arg-3 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-3) (CoreC-45TT-defaultKindedName eta-3)) eta-1) eta-2))) (let ((e-6 (vector-ref e-3 3))) e-6) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--constraints (if (null? e-5) '() (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (IdrisC-45DocC-45String-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc3 (DataC-45String-isSuffixOf "\xa;" "Constraints"))) (cond ((equal? sc3 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Constraints")) (else "Constraints")))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Syntax-u--show_Show_IPTerm eta-1))) e-5)))) '())))) (let ((u--icon (IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-2632 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-3 u--params e-5 u--constraints (CoreC-45Name-dropNS (let ((e-0 (vector-ref e-3 0))) e-0))))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45DocC-45String-n--11674-1382-u--getMethDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) (let ((e-4 (vector-ref e-3 4))) e-4) '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--meths (IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-2544 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-3 u--params e-5 u--constraints u--icon e-6 (PreludeC-45Interfaces-concat (csegen-50) e-6)))) (let ((act-26 (CoreC-45Context-getSearchData arg-4 arg-2 0 e-2 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((e-1 (cdr e-7))) (if (null? e-1) (vector 1 '()) (let ((e-8 (car e-1))) (let ((e-9 (cdr e-8))) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45DocC-45String-n--11674-1381-u--getImplDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) e-9 '() eta-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--insts (IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-2387 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-3 u--params e-5 u--constraints u--icon e-6 u--meths e-7 e-8 (PreludeC-45Interfaces-concat (csegen-50) e-8)))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend u--params (PreludeC-45TypesC-45List-tailRecAppend u--constraints (PreludeC-45TypesC-45List-tailRecAppend u--icon (PreludeC-45TypesC-45List-tailRecAppend u--meths u--insts))))))))))))))))))))))))))))))))
(define IdrisC-45DocC-45String-n--11674-1385-u--getFixityDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 ((IdrisC-45DocC-45String-n--11674-1383-u--getInfixDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45DocC-45String-n--11674-1384-u--getPrefixDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (IdrisC-45DocC-45String-case--getDocsForNameC-44getFixityDoc-2129 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-6 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--toList_Foldable_List e-5) (PreludeC-45Types-u--toList_Foldable_List e-6))))))))))))))
(define IdrisC-45DocC-45String-n--11674-1388-u--getFieldsDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (IdrisC-45DocC-45String-case--getDocsForNameC-44getFieldsDoc-3086 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (CoreC-45Name-displayName arg-6))))
(define IdrisC-45DocC-45String-n--11674-1387-u--getFieldDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-4))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact arg-6 (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 (vector 0 )) (let ((e-1 (unbox e-7))) (let ((act-27 ((PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-27 (eta-0 eta-2))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((eta-1 e-8) eta-2)))))))) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-resugar '() arg-4 arg-3 '() eta-0 eta-1))) (lambda (eta-0) (CoreC-45Normalise-normaliseHoles arg-4 '() e-6 '() (let ((e-2 (vector-ref e-1 2))) e-2) eta-0))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--prettyName (IdrisC-45DocC-45String-prettyName arg-6))) (let ((u--projDecl (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 arg-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (IdrisC-45DocC-45String-fun arg-6 u--prettyName) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (cons (IdrisC-45DocC-45String-prettyTerm e-8) '()))))))) (let ((_-0 (box e-1))) ((IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getFieldDoc-2927 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-6 e-1 _-0 e-8 u--prettyName u--projDecl (LibrariesC-45DataC-45ANameMap-lookupName arg-6 (let ((e-12 (vector-ref e-5 7))) e-12))) ext-0))))))))))))))))))))))))
(define IdrisC-45DocC-45String-n--11674-1389-u--getExtra (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (LibrariesC-45DataC-45ANameMap-lookupName arg-6 (let ((e-11 (vector-ref e-5 5))) e-11)))) (if (null? sc1) ((IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getExtra-3323 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-6 e-5 (let ((e-17 (vector-ref arg-7 17))) e-17)) ext-0) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (if (null? e-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (cons (box "interface") (PreludeC-45Types-u--pure_Applicative_List e-6))))))) (IdrisC-45DocC-45String-n--11674-1386-u--getIFaceDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) ext-0) (vector 1 (cons '() '())))))))))))))
(define IdrisC-45DocC-45String-n--11674-1380-u--getDConDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact arg-6 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-1 (unbox e-6))) (let ((act-26 (let ((act-26 (unbox arg-3))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (let ((act-27 (eta-0 eta-2))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((eta-1 e-8) eta-2)))))))) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-resugar '() arg-4 arg-3 '() eta-0 eta-1))) (lambda (eta-0) (CoreC-45Normalise-normaliseHoles arg-4 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2) eta-0))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--conWithTypeDoc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 arg-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (IdrisC-45DocC-45String-dCon arg-6 (IdrisC-45DocC-45String-prettyName arg-6)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (cons (IdrisC-45DocC-45String-prettyTerm e-8) '()))))))) (let ((_-0 (box e-1))) ((IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getDConDoc-1551 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-1 _-0 e-7 e-8 u--conWithTypeDoc (LibrariesC-45DataC-45ANameMap-lookupName arg-6 (let ((e-12 (vector-ref e-7 7))) e-12))) ext-0)))))))))))))))))))))))
(define IdrisC-45DocC-45String-summarise (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (csegen-2875) (let ((e-1 (unbox e-7))) (let ((act-27 (CoreC-45Normalise-normaliseHoles arg-0 '() e-6 '() (let ((e-2 (vector-ref e-1 2))) e-2) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-8 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 ((IdrisC-45Pretty-showCategory (lambda (eta-0) (vector 5 eta-0)) e-1) (IdrisC-45DocC-45String-prettyName arg-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 0 (IdrisC-45DocC-45String-prettyTerm e-9))))))))))))))))))))))))))))
(define IdrisC-45DocC-45String-styleAnn (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-underline)) ((1) '()) ((2) '()) ((3) '()) ((4) '()) (else (let ((e-1 (vector-ref arg-0 1))) (IdrisC-45Pretty-syntaxAnn e-1))))))
(define IdrisC-45DocC-45String-shortNamesConfig(blodwen-lazy (lambda () (vector 0 0 1))))
(define IdrisC-45DocC-45String-prettyTerm (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 5 eta-0)) (IdrisC-45Pretty-prettyTerm ext-0))))
(define IdrisC-45DocC-45String-prettyName (lambda (arg-0) (IdrisC-45DocC-45String-case--prettyName-668 arg-0 (CoreC-45Name-userNameRoot arg-0))))
(define IdrisC-45DocC-45String-prettyKindedName (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (unbox arg-0))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 (vector 5 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-2)) arg-1)))))
(define IdrisC-45DocC-45String-methodsConfig(blodwen-lazy (lambda () (vector 0 1 0))))
(define IdrisC-45DocC-45String-header (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))))
(define IdrisC-45DocC-45String-getImplDocs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((PreludeC-45Basics-flip (csegen-1822) (PreludeC-45Interfaces-concat (csegen-50) (LibrariesC-45DataC-45NameMap-values (let ((e-7 (vector-ref e-5 7))) e-7))) (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((sc4 (CoreC-45ContextC-45Context-defNameType (let ((e-17 (vector-ref e-1 17))) e-17)))) (if (null? sc4) (vector 1 '()) (let ((e-4 (unbox sc4))) (case (vector-ref e-4 0) ((1) (let ((act-26 (let ((act-26 (CoreC-45Normalise-normaliseHoles arg-0 '() e-5 '() (let ((e-26 (vector-ref e-1 2))) e-26) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (CoreC-45Context-toFullNames arg-0 (csegen-76) e-7 clam-0))))))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((arg-2 e-7) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? e-8 1) (let ((act-28 (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-7 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 e-2) (IdrisC-45DocC-45String-prettyTerm e-9)) '()))))))) (else (vector 1 '()))))))))))))(else (vector 1 '())))))))))))))))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (IdrisC-45DocC-45String-case--getImplDocs-982 arg-2 arg-1 arg-0 e-5 e-6 (PreludeC-45Interfaces-concat (csegen-50) e-6)))))))))))))
(define IdrisC-45DocC-45String-getHintsForType (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "doc.data" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Looking at " (CoreC-45Name-u--show_Show_Name arg-2))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (IdrisC-45DocC-45String-getImplDocs arg-0 arg-1 (lambda (u--ty) (let ((u--nms (CoreC-45TTC-45Traversals-allGlobals u--ty))) (lambda (eta-0) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "doc.data" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (DataC-45String-fastUnlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Candidate: " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() u--ty)) (cons (PreludeC-45TypesC-45String-C-43C-43 "Containing names: " (LibrariesC-45DataC-45NameMap-u--show_Show_C-40NameMapC-32C-36vC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124UnitC-44MkUnitC-124C-41 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124UnitC-44MkUnitC-124C-41 u--d u--x)))) u--nms)) '())))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (DataC-45Maybe-isJust (LibrariesC-45DataC-45NameMap-lookup arg-2 u--nms))))))))) ext-0))))))
(define IdrisC-45DocC-45String-getHintsForPrimitive (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "doc.data" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Looking at " (CoreC-45TT-u--show_Show_Constant arg-2))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (IdrisC-45DocC-45String-getImplDocs arg-0 arg-1 (lambda (u--ty) (let ((u--nms (CoreC-45TTC-45Traversals-allConstants u--ty))) (lambda (eta-0) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "doc.data" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (DataC-45String-fastUnlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Candidate: " (CoreC-45TT-u--show_Show_C-40TermC-32C-36varsC-41 '() u--ty)) (cons (PreludeC-45TypesC-45String-C-43C-43 "Containing constants: " (LibrariesC-45DataC-45SortedSet-u--show_Show_C-40SortedSetC-32C-36kC-41 (csegen-970) u--nms)) '())))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (LibrariesC-45DataC-45SortedSet-contains arg-2 u--nms)))))))) ext-0))))))
(define IdrisC-45DocC-45String-getDocsForPrimitive (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (TTImpC-45ElabC-45Prim-checkPrim (vector 2 ) arg-2))) (let ((e-3 (cdr sc0))) (let ((act-24 (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--typeString (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45String-prettyTerm (vector 15 (vector 2 ) arg-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45DocC-45String-prettyTerm e-5))))) (let ((act-25 (IdrisC-45DocC-45String-getHintsForPrimitive arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons u--typeString (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (IdrisC-45DocC-45String-n--11486-1198-u--primDoc arg-2 arg-1 arg-0 arg-2)) e-6)))))))))))))))))
(define IdrisC-45DocC-45String-getDocsForPTerm (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (lambda (eta-0) (IdrisC-45DocC-45String-getDocsForName arg-0 arg-1 arg-2 e-1 e-2 (vector 1 0 1) eta-0))))) ((15) (let ((e-5 (vector-ref arg-3 2))) (lambda (eta-0) (IdrisC-45DocC-45String-getDocsForPrimitive arg-1 arg-2 e-5 eta-0)))) ((22) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Type : Type"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Type : Type")) (else "Type : Type"))))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "The type of all types is Type. The type of Type is Type.")) '())))))) ((33) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "String Literal"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "String Literal")) (else "String Literal"))))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to a fromString call")) '())))))) ((38) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "List Literal"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "List Literal")) (else "List Literal"))))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to (::) and Nil")) '())))))) ((39) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "SnocList Literal"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "SnocList Literal")) (else "SnocList Literal"))))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to (:<) and Empty")) '())))))) ((40) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Pair Literal"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Pair Literal")) (else "Pair Literal"))))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to MkPair or Pair")) '())))))) ((41) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Dependant Pair Literal"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Dependant Pair Literal")) (else "Dependant Pair Literal"))))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to MkDPair or DPair")) '())))))) ((42) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-1)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Unit Literal"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Unit Literal")) (else "Unit Literal"))))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to MkUnit or Unit")) '()))))))(else (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Docs not implemented for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45Syntax-u--show_Show_PTerm arg-3)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "yet")))))))))
(define IdrisC-45DocC-45String-getDocsForName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--extra (let ((sc2 (CoreC-45Name-nameRoot arg-4))) (cond ((equal? sc2 "-") (cons (vector 0 (CoreC-45NameC-45Namespace-numNS) (vector 1 (vector 0 "negate"))) '()))(else '()))))) (let ((act-26 ((CoreC-45Context-lookupCtxtName arg-4 (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) ((IdrisC-45DocC-45String-case--getDocsForName-4240 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 u--extra e-7 (PreludeC-45TypesC-45List-tailRecAppend u--extra (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-7))) ext-0))))))))))))))))
(define IdrisC-45DocC-45String-getContents (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-allNames (let ((e-0 (vector-ref e-5 0))) e-0) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--allNs (DataC-45List-filter (lambda (eta-0) (IdrisC-45DocC-45String-n--15393-4762-u--inNS arg-3 arg-2 arg-1 arg-0 eta-0)) e-6))) (let ((act-26 (CoreC-45Core-filterM (lambda (eta-0) (lambda (eta-1) (IdrisC-45DocC-45String-n--15393-4761-u--visible arg-3 arg-2 arg-1 arg-0 e-5 eta-0 eta-1))) u--allNs ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-8)))))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45DocC-45String-summarise arg-1 arg-2 eta-1 eta-2))) (DataC-45List-sort (csegen-883) e-7) '() eta-0)) ext-0))))))))))))))))
(define IdrisC-45DocC-45String-fun (lambda (arg-0 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 (vector 3 arg-0)) ext-0)))
(define IdrisC-45DocC-45String-dCon (lambda (arg-0 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 (vector 2 (box arg-0))) ext-0)))
(define IdrisC-45DocC-45String-addModDocString (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (vector e-0 e-1 (cons arg-1 e-2) (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-2 e-3) e-4 e-11 e-6 e-7 e-8 e-9 e-10))))))))))))))) (vector 1 act-25))))))))
(define IdrisC-45DocC-45String-addDocStringNS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-0 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--nC-39 (case (vector-ref e-5 0) ((0) (let ((e-0 (vector-ref e-5 1))) (let ((e-1 (vector-ref e-5 2))) (vector 0 (CoreC-45NameC-45Namespace-C-60C-46C-62 e-0 arg-2) e-1))))(else (vector 0 arg-2 e-5))))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-12 (vector-ref e-6 5))) (let ((e-11 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (vector e-0 e-1 e-2 e-3 e-4 e-12 (LibrariesC-45DataC-45NameMap-insert u--nC-39 0 e-11) (LibrariesC-45DataC-45ANameMap-addName u--nC-39 arg-4 e-7) e-8 e-9 e-10))))))))))))))) (vector 1 act-26)))))))))))))
(define IdrisC-45DocC-45String-addDocString (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-0 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "doc.record" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Adding doc for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-2) (PreludeC-45TypesC-45String-C-43C-43 " (aka " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) " in current NS)"))))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (set-box! arg-1 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-13 (vector-ref e-7 5))) (let ((e-12 (vector-ref e-7 6))) (let ((e-11 (vector-ref e-7 7))) (let ((e-8 (vector-ref e-7 8))) (let ((e-9 (vector-ref e-7 9))) (let ((e-10 (vector-ref e-7 10))) (vector e-0 e-1 e-2 e-3 e-4 e-13 (LibrariesC-45DataC-45NameMap-insert e-5 0 e-12) (LibrariesC-45DataC-45ANameMap-addName e-5 arg-3 e-11) e-8 e-9 e-10))))))))))))))) (vector 1 act-27)))))))))))))))
(define CoreC-45TTC-45Traversals-n--4420-5627-u--gos (lambda (arg-2 arg-3 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (CoreC-45TTC-45Traversals-n--4420-5627-u--gos arg-2 arg-3 (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 arg-5 e-2) e-3))))))
(define CoreC-45TTC-45Traversals-n--4277-5499-u--gos (lambda (arg-2 arg-3 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (CoreC-45TTC-45Traversals-n--4277-5499-u--gos arg-2 arg-3 (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 arg-5 e-2) e-3))))))
(define CoreC-45TTC-45Traversals-n--4420-5626-u--go (lambda (arg-2 arg-3 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) arg-5) ((1) arg-5) ((2) (let ((e-14 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--4420-5627-u--gos arg-2 arg-3 arg-5 e-14))) ((3) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 (let ((e-1 (car arg-2))) ((e-1 arg-5) (PreludeC-45Interfaces-concatMap (cons (csegen-3174) arg-2) (lambda (eta-0) (CoreC-45TTC-45Traversals-onConstants arg-2 arg-3 eta-0)) e-18))) e-19)))) ((4) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 arg-5 e-22) e-23)))) ((5) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 arg-5 e-27) e-28)))) ((6) (let ((e-32 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 arg-5 e-32))) ((7) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 arg-5 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 arg-5 e-41))) ((9) (let ((e-44 (vector-ref arg-6 2))) (let ((e-1 (car arg-2))) ((e-1 arg-5) (arg-3 e-44))))) ((10) arg-5) (else arg-5))))
(define CoreC-45TTC-45Traversals-n--4277-5498-u--go (lambda (arg-2 arg-3 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) arg-5) ((1) (let ((e-9 (vector-ref arg-6 3))) (let ((e-1 (car arg-2))) ((e-1 arg-5) (arg-3 e-9))))) ((2) (let ((e-14 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--4277-5499-u--gos arg-2 arg-3 arg-5 e-14))) ((3) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 (let ((e-1 (car arg-2))) ((e-1 arg-5) (PreludeC-45Interfaces-concatMap (cons (csegen-3174) arg-2) (lambda (eta-0) (CoreC-45TTC-45Traversals-onPRefs arg-2 arg-3 eta-0)) e-18))) e-19)))) ((4) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 arg-5 e-22) e-23)))) ((5) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 arg-5 e-27) e-28)))) ((6) (let ((e-32 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 arg-5 e-32))) ((7) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 arg-5 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 arg-5 e-41))) ((9) arg-5) ((10) arg-5) (else arg-5))))
(define CoreC-45TTC-45Traversals-onPRefs (lambda (arg-2 arg-3 ext-0) (CoreC-45TTC-45Traversals-n--4277-5498-u--go arg-2 arg-3 (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define CoreC-45TTC-45Traversals-onConstants (lambda (arg-2 arg-3 ext-0) (CoreC-45TTC-45Traversals-n--4420-5626-u--go arg-2 arg-3 (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define CoreC-45TTC-45Traversals-allGlobals (lambda (ext-0) (CoreC-45TTC-45Traversals-onPRefs (cons (lambda (arg-2) (lambda (arg-3) (LibrariesC-45DataC-45NameMap-u--C-60C-43C-62_Semigroup_C-40NameMapC-32C-36vC-41 (csegen-363) arg-2 arg-3))) (LibrariesC-45DataC-45NameMap-u--neutral_Monoid_C-40NameMapC-32C-36vC-41 (csegen-363))) (lambda (u--n) (LibrariesC-45DataC-45NameMap-singleton u--n 0)) ext-0)))
(define CoreC-45TTC-45Traversals-allConstants (lambda (ext-0) (CoreC-45TTC-45Traversals-onConstants (cons (csegen-3192) (LibrariesC-45DataC-45SortedSet-empty (csegen-3194))) (lambda (eta-0) (LibrariesC-45DataC-45SortedSet-singleton (csegen-3194) eta-0)) ext-0)))
(define IdrisC-45ProcessIdr-unchangedTime (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-modTime arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-modTime arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int e-5 e-6))))))))))))
(define IdrisC-45ProcessIdr-unchangedHash (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-hashFileWith arg-0 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (let ((act-25 (CoreC-45Binary-readHashes arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-2 (car e-6))) (if (null? e-2) (vector 1 0) (let ((e-7 (unbox e-2))) (vector 1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 e-7))))))))))))))))))
(define IdrisC-45ProcessIdr-readPrelude (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (IdrisC-45ProcessIdr-readImport arg-0 arg-1 arg-2 arg-3 (IdrisC-45ProcessIdr-prelude) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Context-setNS arg-0 (CoreC-45NameC-45Namespace-mainNS) ext-0))))))
(define IdrisC-45ProcessIdr-readModule (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (PreludeC-45Types-elem (csegen-1484) (cons arg-6 (cons arg-5 arg-7)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-19 (vector-ref e-5 19))) e-19))))) (cond ((equal? sc1 0) (let ((act-25 (CoreC-45Directory-nsToPath arg-0 arg-4 arg-6 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (let ((act-26 (CoreC-45Binary-readFromTTC (csegen-3203) arg-0 arg-1 0 arg-4 arg-5 e-2 arg-6 arg-7 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (cond ((equal? arg-5 1) (CoreC-45Context-setVisible arg-0 (CoreC-45NameC-45Namespace-miAsNamespace arg-6) ext-0)) (else (vector 1 0))) (let ((e-1 (unbox e-7))) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (let ((e-10 (cdr e-8))) (let ((act-27 (IdrisC-45Desugar-extendSyn arg-2 arg-0 e-9 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 (let ((act-28 (unbox arg-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((act-29 (CoreC-45Context-getNS arg-0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 (cond ((equal? arg-5 1) (CoreC-45Context-setVisible arg-0 (CoreC-45NameC-45Namespace-miAsNamespace arg-6) ext-0)) (else (vector 1 0))))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 (CoreC-45Core-traverse_ (lambda (u--mimp) (let ((u--m (Builtin-fst u--mimp))) (let ((u--reexp (Builtin-fst (Builtin-snd u--mimp)))) (let ((u--as (Builtin-snd (Builtin-snd u--mimp)))) (lambda (clam-0) (let ((sc12 (cond ((equal? u--reexp 1) 1) (else arg-3)))) (cond ((equal? sc12 1) (IdrisC-45ProcessIdr-readModule arg-0 arg-1 arg-2 arg-3 arg-4 u--reexp u--m u--as clam-0)) (else (vector 1 0))))))))) e-10 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (CoreC-45Context-setNS arg-0 e-14 ext-0)))))))))))))))))))))))))))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-7 ext-0))))))))) (else (cond ((equal? arg-5 1) (CoreC-45Context-setVisible arg-0 (CoreC-45NameC-45Namespace-miAsNamespace arg-6) ext-0)) (else (vector 1 0))))))))))))
(define IdrisC-45ProcessIdr-readImportMeta (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Directory-nsToPath arg-0 (let ((e-0 (vector-ref arg-2 0))) e-0) (let ((e-2 (vector-ref arg-2 2))) e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (CoreC-45Binary-readHashes e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-3 (cdr e-6))) (vector 1 (cons (let ((e-1 (vector-ref arg-2 1))) e-1) (cons (let ((e-7 (vector-ref arg-2 3))) e-7) e-3)))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-6 ext-0))))))))))
(define IdrisC-45ProcessIdr-readImport (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (IdrisC-45ProcessIdr-readModule arg-0 arg-1 arg-2 arg-3 (let ((e-0 (vector-ref arg-4 0))) e-0) 1 (let ((e-2 (vector-ref arg-4 2))) e-2) (let ((e-3 (vector-ref arg-4 3))) e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Context-addImported arg-0 (cons (let ((e-2 (vector-ref arg-4 2))) e-2) (cons (let ((e-1 (vector-ref arg-4 1))) e-1) (let ((e-3 (vector-ref arg-4 3))) e-3))) ext-0))))))
(define IdrisC-45ProcessIdr-readHeader (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) arg-2) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-25 (IdrisC-45REPLC-45Opts-setCurrentElabSource arg-1 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((sc3 (ParserC-45Source-runParserTo 0 (vector 0 arg-3) (ParserC-45Unlit-isLitFile arg-2) (LibrariesC-45TextC-45Lexer-is #\:) e-2 (IdrisC-45Parser-progHdr (vector 0 arg-3))))) (case (vector-ref sc3 0) ((1) (let ((e-3 (vector-ref sc3 1))) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (let ((e-13 (cdr e-9))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-recordWarning arg-0 eta-0 eta-1))) e-8 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 e-13))))))))) (else (let ((e-7 (vector-ref sc3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-7 ext-0)))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 e-6) ext-0))))))))))
(define IdrisC-45ProcessIdr-readAsMain (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Binary-readFromTTC (csegen-3203) arg-0 arg-1 1 (vector 2 ) 1 arg-3 (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-emptyNS)) (CoreC-45NameC-45Namespace-emptyNS) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Already loaded") ext-0) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-10 (cdr e-6))) (let ((act-25 (CoreC-45Context-getNS arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Context-getNestedNS arg-0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45Desugar-extendSyn arg-2 arg-0 e-7 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (unbox arg-1))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverse_ (lambda (u--mimp) (let ((u--m (Builtin-fst u--mimp))) (let ((u--as (Builtin-snd (Builtin-snd u--mimp)))) (lambda (eta-0) (let ((act-29 (IdrisC-45ProcessIdr-readModule arg-0 arg-1 arg-2 1 (CoreC-45FC-emptyFC) 1 u--m u--as eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (CoreC-45Context-addImported arg-0 (cons u--m (cons 1 u--as)) eta-0)))))))) e-10 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (let ((act-30 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-30 1))) (let ((sc10 (let ((e-0 (vector-ref e-15 0))) e-0))) (cond ((equal? sc10 1) (vector 1 0)) (else (IdrisC-45ProcessIdr-readModule arg-0 arg-1 arg-2 1 (CoreC-45FC-emptyFC) 1 (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-preludeNS)) (CoreC-45NameC-45Namespace-preludeNS) ext-0)))))))))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (let ((act-31 (unbox arg-1))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (set-box! arg-1 (let ((e-0 (vector-ref e-16 0))) (let ((e-24 (vector-ref e-16 1))) (let ((e-2 (vector-ref e-16 2))) (let ((e-3 (vector-ref e-16 3))) (let ((e-4 (vector-ref e-16 4))) (let ((e-23 (vector-ref e-16 5))) (let ((e-22 (vector-ref e-16 6))) (let ((e-21 (vector-ref e-16 7))) (let ((e-19 (vector-ref e-16 9))) (let ((e-18 (vector-ref e-16 10))) (let ((e-17 (vector-ref e-16 11))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-21 (let ((e-28 (vector-ref e-13 8))) e-28) e-19 e-18 e-17))))))))))))))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (CoreC-45Context-setNS arg-0 e-8 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (CoreC-45Context-setNestedNS arg-0 e-11 ext-0)))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45ProcessIdr-processMod (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setCurrentElabSource arg-4 arg-8 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45ProcessIdr-readHeader arg-0 arg-4 arg-5 arg-9 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--ns (let ((e-1 (vector-ref e-7 1))) e-1))) (let ((u--imports (let ((sc3 (let ((sc4 (let ((e-0 (vector-ref e-6 0))) e-0))) (cond ((equal? sc4 1) 1) (else (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent (let ((e-1 (vector-ref e-7 1))) e-1) (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-preludeNS)))))))) (cond ((equal? sc3 1) (let ((e-2 (vector-ref e-7 2))) e-2)) (else (IdrisC-45ProcessIdr-addPrelude (let ((e-2 (vector-ref e-7 2))) e-2))))))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45ProcessIdr-readImportMeta arg-0 arg-1 eta-1 eta-2))) u--imports '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--importInterfaceHashes (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-1) (Builtin-snd eta-1)) e-8))) (let ((act-28 (let ((act-28 (unbox arg-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-0 "module.hash" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Interface hash of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent u--ns) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_Int (let ((e-16 (vector-ref e-9 16))) e-16)))))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45ContextC-45Log-log arg-0 "module.hash" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Interface hashes of " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent u--ns) (PreludeC-45TypesC-45String-C-43C-43 " hashes:\xa;" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-3206) (DataC-45List-sort (csegen-3212) u--importInterfaceHashes)))))) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45Binary-readImportHashes arg-6 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45ContextC-45Log-log arg-0 "module.hash" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Stored interface hashes of " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-3206) (DataC-45List-sort (csegen-3212) e-12)))))) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (let ((sc9 (let ((e-20 (vector-ref e-6 20))) e-20))) (cond ((equal? sc9 1) (IdrisC-45ProcessIdr-unchangedHash (let ((e-4 (vector-ref e-9 4))) (let ((e-40 (vector-ref e-4 9))) e-40)) arg-5 arg-6 eta-0)) (else (IdrisC-45ProcessIdr-unchangedTime arg-5 arg-6 eta-0)))))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((sc10 (cond ((equal? e-14 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-3213) (DataC-45List-sort (csegen-3212) u--importInterfaceHashes) (DataC-45List-sort (csegen-3212) e-12))) (else 0)))) (cond ((equal? sc10 1) (let ((act-34 (CoreC-45Context-setNS arg-0 (CoreC-45NameC-45Namespace-miAsNamespace u--ns) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (vector 1 '()))))) (else (let ((act-34 (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 arg-7 eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () (PreludeC-45TypesC-45String-C-43C-43 "++ Parsing " arg-5)) (lambda (eta-1) (vector 1 (ParserC-45Source-runParser 0 (vector 0 arg-9) (ParserC-45Unlit-isLitFile arg-5) arg-8 (vector 10 0 0 (IdrisC-45Parser-prog (vector 0 arg-9)) (lambda (u--p) (vector 12 0 0 (ParserC-45RuleC-45Source-eoi) (vector 0 u--p))))))) eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (case (vector-ref e-16 0) ((1) (let ((e-2 (vector-ref e-16 1))) (let ((e-18 (car e-2))) (let ((e-17 (cdr e-2))) (let ((e-20 (car e-17))) (let ((e-19 (cdr e-17))) (let ((act-36 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-recordWarning arg-0 eta-1 eta-2))) e-18 eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-3 (vector-ref act-36 1))) (vector 0 e-3))) (else (let ((act-37 (CoreC-45ContextC-45Log-log arg-0 "doc.module" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (LibrariesC-45DataC-45StringC-45Extra-unlines (cons "Recording doc" (cons (let ((e-3 (vector-ref e-19 3))) e-3) (cons (PreludeC-45TypesC-45String-C-43C-43 "for module " (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent (let ((e-1 (vector-ref e-19 1))) e-1))) '()))))) eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-3 (vector-ref act-37 1))) (vector 0 e-3))) (else (let ((act-38 (IdrisC-45DocC-45String-addModDocString arg-2 (let ((e-1 (vector-ref e-19 1))) e-1) (let ((e-3 (vector-ref e-19 3))) e-3) eta-0))) (case (vector-ref act-38 0) ((0) (let ((e-3 (vector-ref act-38 1))) (vector 0 e-3))) (else (let ((act-39 (CoreC-45Metadata-addSemanticDecorations arg-3 arg-0 e-20 eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-3 (vector-ref act-39 1))) (vector 0 e-3))) (else (let ((act-40 (CoreC-45Context-initHash arg-0 eta-0))) (case (vector-ref act-40 0) ((0) (let ((e-3 (vector-ref act-40 1))) (vector 0 e-3))) (else (let ((act-41 (CoreC-45Core-traverse_ (lambda (eta-1) (IdrisC-45ProcessIdr-addPublicHash arg-0 eta-1)) (DataC-45List-sort (vector (cons (lambda (arg-10) (lambda (arg-11) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1491) (csegen-3213) arg-10 arg-11))) (lambda (arg-10) (lambda (arg-11) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1491) (csegen-3213) arg-10 arg-11)))) (lambda (arg-418) (lambda (arg-419) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3237) (csegen-3212) arg-418 arg-419))) (lambda (arg-420) (lambda (arg-421) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3237) (csegen-3212) arg-420 arg-421))) (lambda (arg-422) (lambda (arg-423) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3237) (csegen-3212) arg-422 arg-423))) (lambda (arg-424) (lambda (arg-425) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3237) (csegen-3212) arg-424 arg-425))) (lambda (arg-426) (lambda (arg-427) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3237) (csegen-3212) arg-426 arg-427))) (lambda (arg-428) (lambda (arg-429) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3237) (csegen-3212) arg-428 arg-429))) (lambda (arg-430) (lambda (arg-431) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3237) (csegen-3212) arg-430 arg-431)))) e-8) eta-0))) (case (vector-ref act-41 0) ((0) (let ((e-3 (vector-ref act-41 1))) (vector 0 e-3))) (else (let ((act-42 (CoreC-45UnifyState-resetNextVar arg-1 eta-0))) (case (vector-ref act-42 0) ((0) (let ((e-3 (vector-ref act-42 1))) (vector 0 e-3))) (else (let ((act-43 (let ((sc23 (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_ModuleIdent u--ns (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-mainNS))))) (cond ((equal? sc23 1) (let ((sc24 (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_ModuleIdent u--ns arg-9))) (cond ((equal? sc24 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (let ((e-0 (vector-ref e-19 0))) e-0) (PreludeC-45TypesC-45String-C-43C-43 "Module name " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent u--ns) (PreludeC-45TypesC-45String-C-43C-43 " does not match file name " (PreludeC-45Show-u--show_Show_String arg-5))))) eta-0)) (else (vector 1 0))))) (else (vector 1 0)))))) (case (vector-ref act-43 0) ((0) (let ((e-3 (vector-ref act-43 1))) (vector 0 e-3))) (else (let ((act-44 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Reading imports") (lambda (eta-1) (CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (IdrisC-45ProcessIdr-readImport arg-0 arg-1 arg-2 0 eta-2 eta-3))) u--imports eta-1)) eta-0))) (case (vector-ref act-44 0) ((0) (let ((e-3 (vector-ref act-44 1))) (vector 0 e-3))) (else (let ((act-45 (CoreC-45Context-setNS arg-0 (CoreC-45NameC-45Namespace-miAsNamespace u--ns) eta-0))) (case (vector-ref act-45 0) ((0) (let ((e-3 (vector-ref act-45 1))) (vector 0 e-3))) (else (let ((act-46 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Processing decls") (lambda (eta-1) (IdrisC-45ProcessIdr-processDecls arg-0 arg-1 arg-2 arg-3 (let ((e-4 (vector-ref e-19 4))) e-4) eta-1)) eta-0))) (case (vector-ref act-46 0) ((0) (let ((e-3 (vector-ref act-46 1))) (vector 0 e-3))) (else (let ((e-31 (vector-ref act-46 1))) (let ((act-47 (let ((sc27 (DataC-45List-isNil e-31))) (cond ((equal? sc27 1) (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "++ Compile defs") (lambda (eta-1) (CompilerC-45Inline-compileAndInlineAll arg-0 eta-1)) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-47 0) ((0) (let ((e-3 (vector-ref act-47 1))) (vector 0 e-3))) (else (let ((act-48 (let ((act-48 (unbox arg-0))) (vector 1 act-48)))) (case (vector-ref act-48 0) ((0) (let ((e-3 (vector-ref act-48 1))) (vector 0 e-3))) (else (let ((e-33 (vector-ref act-48 1))) (let ((act-49 (let ((act-49 (set-box! arg-0 (let ((e-0 (vector-ref e-33 0))) (let ((e-1 (vector-ref e-33 1))) (let ((e-60 (vector-ref e-33 2))) (let ((e-3 (vector-ref e-33 3))) (let ((e-4 (vector-ref e-33 4))) (let ((e-59 (vector-ref e-33 5))) (let ((e-58 (vector-ref e-33 6))) (let ((e-57 (vector-ref e-33 7))) (let ((e-56 (vector-ref e-33 8))) (let ((e-55 (vector-ref e-33 9))) (let ((e-54 (vector-ref e-33 10))) (let ((e-53 (vector-ref e-33 11))) (let ((e-52 (vector-ref e-33 12))) (let ((e-51 (vector-ref e-33 13))) (let ((e-50 (vector-ref e-33 14))) (let ((e-49 (vector-ref e-33 15))) (let ((e-48 (vector-ref e-33 16))) (let ((e-46 (vector-ref e-33 18))) (let ((e-45 (vector-ref e-33 19))) (let ((e-44 (vector-ref e-33 20))) (let ((e-43 (vector-ref e-33 21))) (let ((e-42 (vector-ref e-33 22))) (let ((e-41 (vector-ref e-33 23))) (let ((e-40 (vector-ref e-33 24))) (let ((e-39 (vector-ref e-33 25))) (let ((e-38 (vector-ref e-33 26))) (let ((e-37 (vector-ref e-33 27))) (let ((e-36 (vector-ref e-33 28))) (let ((e-35 (vector-ref e-33 29))) (let ((e-34 (vector-ref e-33 30))) (vector e-0 e-1 e-60 e-3 e-4 e-59 e-58 e-57 e-56 e-55 e-54 e-53 e-52 e-51 e-50 e-49 e-48 u--importInterfaceHashes e-46 e-45 e-44 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34)))))))))))))))))))))))))))))))))) (vector 1 act-49)))) (case (vector-ref act-49 0) ((0) (let ((e-3 (vector-ref act-49 1))) (vector 0 e-3))) (else (vector 1 (box e-31)))))))))))))))))))))))))))))))))))))))))))))))))))) (else (let ((e-17 (vector-ref e-16 1))) (vector 1 (box (cons e-17 '())))))))))))))))))))))))))))))))))))))))))))))))))))))))) (lambda (u--err) (lambda (eta-0) (vector 1 (box (cons u--err '()))))) ext-0)))
(define IdrisC-45ProcessIdr-processDecls (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-2316) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45ProcessIdr-processDecl arg-0 arg-1 arg-2 arg-3 eta-1)) arg-4 '() eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45UnifyState-checkDelayedHoles arg-1 arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (let ((act-26 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () "+++ Totality check overall") (lambda (eta-0) (TTImpC-45ProcessDecls-getTotalityErrors arg-0 eta-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-7)))))) (let ((e-2 (unbox e-6))) (vector 1 (let ((sc3 ((PreludeC-45Types-u--null_Foldable_List e-5)))) (cond ((equal? sc3 1) (cons e-2 '())) (else e-5))))))))))))))))
(define IdrisC-45ProcessIdr-processDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((11) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (lambda (eta-0) (CoreC-45Context-withExtendedNS arg-0 e-2 (lambda (eta-1) (IdrisC-45ProcessIdr-processDecls arg-0 arg-1 arg-2 arg-3 e-3 eta-1)) eta-0))))) ((9) (let ((e-6 (vector-ref arg-4 2))) (lambda (clam-0) (let ((sc1 (IdrisC-45DesugarC-45Mutual-splitMutual e-6))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (IdrisC-45ProcessIdr-processDecls arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend e-2 e-3) clam-0)))))))(else (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-24 ((IdrisC-45Desugar-desugarDecl arg-2 arg-0 arg-1 arg-3 '() arg-4) eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverse_ (lambda (eta-2) (TTImpC-45ElabC-45Check-processDecl '() arg-0 arg-3 arg-1 arg-2 '() '() '() eta-2)) e-5 eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '()))))))))) (lambda (u--err) (lambda (eta-1) (let ((act-24 (CoreC-45Unify-giveUpConstraints arg-0 arg-1 eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (cons u--err '()))))))) eta-0))))))
(define IdrisC-45ProcessIdr-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) arg-6) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-25 (CoreC-45Directory-getTTCFileName arg-0 arg-6 "ttc" eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-logTime arg-0 (lambda () (PreludeC-45TypesC-45String-C-43C-43 "+ Elaborating " arg-6)) (lambda (eta-1) (IdrisC-45ProcessIdr-processMod arg-0 arg-2 arg-3 arg-1 arg-4 arg-6 e-6 arg-5 e-2 arg-7 eta-1)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 '()) (let ((e-1 (unbox e-7))) (let ((sc5 (DataC-45List-isNil e-1))) (cond ((equal? sc5 1) (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 (CoreC-45Directory-ctxtPathToNS arg-0 arg-6 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Directory-makeBuildDirectory arg-0 e-9 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (let ((act-30 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-30 1))) (CoreC-45Core-traverse_ (lambda (u--cg) (lambda (eta-1) (let ((act-31 (IdrisC-45ProcessIdr-getCG arg-4 arg-0 u--cg eta-1))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-31 1))) (if (null? e-12) (let ((act-32 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "No incremental code generator for " (CoreC-45Options-u--show_Show_CG u--cg))) eta-1))) (vector 1 act-32)) (let ((e-3 (unbox e-12))) (let ((act-32 ((CompilerC-45Common-incCompile arg-0 e-3 arg-6) eta-1))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-32 1))) (if (null? e-13) (vector 1 0) (let ((e-4 (unbox e-13))) (CoreC-45Context-setIncData arg-0 u--cg e-4 eta-1))))))))))))))) (let ((e-21 (vector-ref e-11 21))) e-21) eta-0))))))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 (let ((act-31 (let ((act-31 (unbox arg-3))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-31 1))) (CoreC-45Binary-writeToTTC (cons (cons (lambda (arg-4060) (lambda (arg-4061) (lambda (eta-1) (IdrisC-45Syntax-u--full_HasNames_SyntaxInfo arg-4060 arg-4061 eta-1)))) (lambda (arg-4062) (lambda (arg-4063) (lambda (eta-1) (IdrisC-45Syntax-u--resolved_HasNames_SyntaxInfo arg-4062 arg-4063 eta-1))))) (csegen-3203)) arg-0 arg-2 e-12 arg-6 e-6 eta-0))))))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((act-32 (CoreC-45Directory-getTTCFileName arg-0 arg-6 "ttm" eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Metadata-writeToTTM arg-0 arg-1 e-13 eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-3 (vector-ref act-33 1))) (vector 0 e-3))) (else (vector 1 '()))))))))))))))))))))))))) (else (vector 1 e-1))))))))))))))) (lambda (u--err) (lambda (eta-0) (vector 1 (cons u--err '())))) ext-0))) (else (let ((e-6 (vector-ref e-5 1))) (vector 1 (cons (vector 49 arg-6 e-6) '())))))))))))
(define IdrisC-45ProcessIdr-prelude(blodwen-lazy (lambda () (vector (vector 0 (vector 2 0) (cons 0 0) (cons 0 0)) 0 (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-preludeNS)) (CoreC-45NameC-45Namespace-preludeNS)))))
(define IdrisC-45ProcessIdr-getCG (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (vector 1 (box (CompilerC-45SchemeC-45Chez-codegenChez)))) ((1) (vector 1 (box (CompilerC-45SchemeC-45ChezSep-codegenChezSep)))) ((2) (vector 1 (box (CompilerC-45SchemeC-45Racket-codegenRacket)))) ((3) (vector 1 (box (CompilerC-45SchemeC-45Gambit-codegenGambit)))) ((4) (vector 1 (box (CompilerC-45ESC-45Node-codegenNode)))) ((5) (vector 1 (box (CompilerC-45ESC-45Javascript-codegenJavascript)))) ((6) (vector 1 (box (CompilerC-45RefCC-45RefC-codegenRefC)))) ((7) (vector 1 (box (CompilerC-45InterpreterC-45VMCode-codegenVMCodeInterp)))) (else (let ((e-0 (vector-ref arg-2 1))) (IdrisC-45REPLC-45Opts-getCodegen arg-0 e-0 ext-0))))))
(define IdrisC-45ProcessIdr-findCG (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45ProcessIdr-getCG arg-0 arg-1 (let ((e-4 (vector-ref e-5 4))) (let ((e-39 (vector-ref e-4 2))) (let ((e-61 (vector-ref e-39 4))) e-61))) ext-0)))))))
(define IdrisC-45ProcessIdr-addPublicHash (lambda (arg-0 arg-1) (if (null? arg-1) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (lambda (clam-0) (cond ((equal? e-2 1) (if (null? e-3) (vector 1 0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-24 (CoreC-45Context-addHash arg-0 (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_Namespace arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_Namespace arg-568 arg-569)))) e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (CoreC-45Context-addHash arg-0 (csegen-821) e-7 clam-0))))))))(else (vector 1 0)))))))))
(define IdrisC-45ProcessIdr-addPrelude (lambda (arg-0) (let ((sc0 (PreludeC-45Types-elem (csegen-1486) (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-preludeNS)) (PreludeC-45Types-u--map_Functor_List (csegen-3261) arg-0)))) (cond ((equal? sc0 1) arg-0) (else (cons (IdrisC-45ProcessIdr-prelude) arg-0))))))
(define IdrisC-45ProcessIdr-addImport (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-getNS arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45ProcessIdr-readImport arg-0 arg-1 arg-2 1 arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45Context-setNS arg-0 e-5 ext-0))))))))))
(define IdrisC-45Parser-case--collectDefs-17290 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((u--csC-39 (PreludeC-45TypesC-45List-tailRecAppend arg-0 (PreludeC-45Interfaces-concat (csegen-50) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-2))))) (let ((u--annotC-39 (PreludeC-45Types-u--foldr_Foldable_List (lambda (u--fc1) (lambda (u--fc2) (DataC-45Maybe-fromMaybe (lambda () (vector 2 )) (CoreC-45FC-mergeFC u--fc1 u--fc2)))) arg-1 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-2)))) (cons (vector 1 u--annotC-39 u--csC-39) (IdrisC-45Parser-collectDefs e-3))))))))
(define IdrisC-45Parser-case--multilineStrC-44toLines-10558 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 1))) (IdrisC-45Parser-n--10943-10542-u--toLines arg-0 arg-1 arg-2 arg-4 (DataC-45List-snoc arg-6 (vector 1 (CoreC-45FC-boundToFC arg-1 arg-3) e-2)) arg-5))) (else (let ((e-5 (vector-ref arg-7 1))) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (IdrisC-45Parser-n--10943-10542-u--toLines arg-0 arg-1 arg-2 arg-4 (DataC-45List-snoc arg-6 (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) e-7)) arg-5) (let ((e-11 (car e-8))) (let ((e-12 (cdr e-8))) (IdrisC-45Parser-n--10943-10542-u--toLines arg-0 arg-1 arg-2 arg-4 (cons (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) (DataC-45List-last e-8)) '()) (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-snoc arg-5 (DataC-45List-snoc arg-6 (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) e-7))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (u--str) (cons (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) u--str) '())) (let ((u--strs (cons e-11 e-12))) (DataC-45List-init u--strs)))))))))))))))
(define IdrisC-45Parser-case--doAct-9938 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (vector 0 (cons (vector 1 (CoreC-45FC-boundToFC arg-1 arg-2) (CoreC-45FC-boundToFC arg-1 e-2) (let ((e-1 (vector-ref e-2 0))) e-1) e-3) '()))))))
(define IdrisC-45Parser-case--nonEmptyTupleC-44mergePairs-6284 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc2 (IdrisC-45Parser-n--10896-6189-u--mergePairs arg-1 arg-2 arg-3 arg-4 e-2 arg-5 arg-6))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons (PreludeC-45TypesC-45List-tailRecAppend e-6 e-5) (vector 40 (Builtin-fst arg-5) e-7 e-4)))))))))))
(define IdrisC-45Parser-n--10879-3888-u--underscore (lambda (arg-0 arg-1 arg-2 arg-3) (vector 2 (vector 1 (vector 2 )) (vector 25 arg-3))))
(define IdrisC-45Parser-n--10942-10327-u--toPStr (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (case (vector-ref e-1 0) ((1) (let ((e-4 (vector-ref e-1 1))) (let ((e-7 (car e-4))) (let ((e-8 (cdr e-4))) (if (null? e-8) (vector 1 (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) e-7)) (vector 0 "Multi-line string is expected to begin with \"\"\"")))))) (else (let ((e-5 (vector-ref e-1 1))) (vector 1 (vector 1 (CoreC-45FC-boundToFC arg-1 arg-3) e-5))))))))
(define IdrisC-45Parser-n--10943-10542-u--toLines (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-3) (DataC-45List-snoc arg-5 arg-4) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (IdrisC-45Parser-case--multilineStrC-44toLines-10558 arg-0 arg-1 arg-2 e-2 e-3 arg-5 arg-4 (let ((e-1 (vector-ref e-2 0))) e-1)))))))
(define IdrisC-45Parser-n--10880-4359-u--singleName (lambda (arg-0 arg-1) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (cons u--n '())))))))
(define IdrisC-45Parser-n--10930-9231-u--recFieldCompat (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (IdrisC-45Parser-decorate arg-1 2 (ParserC-45RuleC-45Source-postfixProj)) (lambda () (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-1 "->")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decorate arg-1 2 (ParserC-45RuleC-45Source-name)))))))))
(define IdrisC-45Parser-n--18544-11477-u--parseWithArg (lambda (arg-0 arg-1 arg-2 arg-3) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "|") (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-expr (IdrisC-45Parser-plhs) arg-1 arg-0)) (lambda () (lambda (u--tm) (vector 0 (cons (CoreC-45FC-boundToFC arg-1 u--tm) (let ((e-1 (vector-ref u--tm 0))) e-1))))))))))
(define IdrisC-45Parser-n--26924-19477-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-logLevel)) (lambda () (lambda (u--lvl) (vector 0 (arg-1 u--lvl)))))))))))
(define IdrisC-45Parser-n--26853-19403-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 1 (vector 8 (ParserC-45RuleC-45Source-unqualifiedName)) (lambda () (lambda (u--n) (vector 9 0 (vector 8 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) (vector 2 0) (ParserC-45RuleC-45Source-init))) (lambda () (lambda (u--tm) (vector 0 ((arg-1 u--tm) u--n))))))))))))))
(define IdrisC-45Parser-n--26804-19351-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (ParserC-45RuleC-45Source-onOffLit)) (lambda () (lambda (u--i) (vector 0 (arg-1 u--i)))))))))))
(define IdrisC-45Parser-n--26721-19264-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-n--26721-19263-u--autoNumber arg-0 arg-1 arg-2)) (lambda () (lambda (u--mi) (vector 0 (arg-1 u--mi)))))))))))
(define IdrisC-45Parser-n--26619-19158-u--parse (lambda (arg-0 arg-1 arg-2 arg-3) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-3) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-setOption arg-1)) (lambda () (lambda (u--opt) (vector 0 (arg-2 u--opt)))))))))))
(define IdrisC-45Parser-n--26568-19104-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-topDecl (vector 2 0) (ParserC-45RuleC-45Source-init))) (lambda () (lambda (u--tm) (vector 0 (arg-1 u--tm)))))))))))
(define IdrisC-45Parser-n--26517-19051-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (csegen-3269)) (lambda () (lambda (u--tm) (vector 0 (arg-1 u--tm)))))))))))
(define IdrisC-45Parser-n--26468-19000-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (ParserC-45RuleC-45Source-moduleIdent)) (lambda () (lambda (u--n) (vector 0 (arg-1 u--n)))))))))))
(define IdrisC-45Parser-n--26419-18949-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (ParserC-45RuleC-45Source-simpleStr)) (lambda () (lambda (u--s) (vector 0 (arg-1 u--s)))))))))))
(define IdrisC-45Parser-n--26369-18897-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 0 (arg-1 u--n)))))))))))
(define IdrisC-45Parser-n--26332-18859-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 0 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 0 arg-1)))))))
(define IdrisC-45Parser-n--10896-6188-u--optionalPair (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-3) (let ((u--var (vector 0 e-2 (vector 2 "__infixTupleSection" arg-5)))) (cons (bs+ arg-5 1 63) (cons (cons (cons e-2 u--var) '()) u--var))) (let ((e-5 (unbox e-3))) (cons arg-5 (cons '() e-5))))))))
(define IdrisC-45Parser-n--23682-16216-u--oldParamDecls (lambda (arg-0 arg-1 arg-2 arg-3) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-2 "(") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-2 ",") (vector 9 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-2)) (lambda () (lambda (u--x) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-2 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-2 arg-3) (lambda () (lambda (u--ty) (vector 0 (cons u--x (cons (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (cons (vector 1 ) u--ty))))))))))))) (lambda (u--ps) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-2 ")") (lambda () (vector 0 u--ps)))))))))
(define IdrisC-45Parser-n--23682-16217-u--newParamDecls (lambda (arg-0 arg-1 arg-2 arg-3) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (PreludeC-45Interfaces-concat (csegen-3271) eta-0)) (LibrariesC-45TextC-45Parser-some (IdrisC-45Parser-typedArg arg-2 arg-3)))))
(define IdrisC-45Parser-n--26924-19476-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26853-19402-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26804-19350-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26721-19262-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26619-19157-u--names (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45Parser-extractNames arg-3)))
(define IdrisC-45Parser-n--26568-19103-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26517-19050-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26468-18999-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26419-18948-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26369-18896-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--26332-18858-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--10880-4360-u--nameList (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "[") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-1 ",") (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--ns) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-1 "]") (lambda () (vector 0 (DataC-45List1-forget u--ns))))))))))))
(define IdrisC-45Parser-n--10939-10165-u--mkPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (let ((e-1 (vector-ref arg-3 0))) e-1) (let ((e-2 (unbox arg-4))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (vector 1 (CoreC-45FC-boundToFC arg-1 arg-3) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) e-5 '() (let ((e-1 (vector-ref arg-3 0))) e-1) e-6)))))))
(define IdrisC-45Parser-n--10896-6189-u--mergePairs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (Builtin-snd (IdrisC-45Parser-n--10896-6188-u--optionalPair arg-1 arg-2 arg-3 arg-4 arg-5 arg-6)) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (IdrisC-45Parser-case--nonEmptyTupleC-44mergePairs-6284 arg-1 arg-2 arg-3 arg-4 e-2 e-3 arg-6 arg-5 (IdrisC-45Parser-n--10896-6188-u--optionalPair arg-1 arg-2 arg-3 arg-4 arg-5 arg-6)))))))
(define IdrisC-45Parser-n--10922-8580-u--letDecl (lambda (arg-0 arg-1) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-3271) eta-0))) (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (vector 6 (IdrisC-45Parser-topDecl arg-1 eta-0)))))))
(define IdrisC-45Parser-n--10922-8579-u--letBinder (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 10 0 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-356) (csegen-2302) (IdrisC-45Parser-multiplicity arg-1)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-expr (IdrisC-45Parser-plhs) arg-1 arg-0))))) (lambda () (lambda (u--s) (vector 10 0 1 (vector 0 (let ((e-1 (vector-ref u--s 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 (vector 25 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-1 u--s))) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-1 ":")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pnoeq (IdrisC-45Parser-pdef)) arg-1 arg-0))))) (lambda (u--ty) (vector 11 1 (vector 13 1 1 (IdrisC-45Parser-decoratedSymbol arg-1 "=") (lambda () (IdrisC-45Parser-decoratedSymbol arg-1 ":="))) (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pnowith) arg-1 arg-0) (lambda () (lambda (u--val) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-patAlt arg-1 eta-0))) (lambda (u--alts) (vector 0 (vector e-2 e-3 u--ty u--val u--alts))))))))))))))))))))
(define IdrisC-45Parser-n--10896-6186-u--lams (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) arg-6 (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-6))) (vector 2 u--vfc (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) e-7 (vector 26 u--vfc) (IdrisC-45Parser-n--10896-6186-u--lams arg-1 arg-2 arg-3 arg-4 e-3 arg-6))))))))))
(define IdrisC-45Parser-n--10930-9230-u--fieldName (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-0 (vector-ref arg-3 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) e-1)) ((1) (let ((e-2 (vector-ref e-0 1))) e-2))(else "_impossible"))))(else "_impossible"))))
(define IdrisC-45Parser-n--23042-15573-u--fieldBody (lambda (arg-0 arg-1 arg-2 arg-3) (vector 9 0 (vector 14 (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-1) (lambda (u--rig) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-1 ",") (vector 9 0 (IdrisC-45Parser-decorate arg-1 2 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 0 u--n))))) (lambda () (lambda (u--ns) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-1 arg-0) (lambda () (lambda (u--ty) (vector 0 (lambda (u--fc) (PreludeC-45Types-u--map_Functor_List (lambda (u--n) (vector u--fc arg-2 u--rig arg-3 u--n u--ty)) (DataC-45List1-forget u--ns))))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-1 u--b)))))))))
(define IdrisC-45Parser-n--20136-12646-u--drop (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 e-2))) (cond ((equal? sc1 1) (IdrisC-45Parser-n--20136-12646-u--drop arg-0 arg-1 e-3)) (else (cons e-2 e-3)))))))))
(define IdrisC-45Parser-n--10921-8411-u--continueLamCase (lambda (arg-0 arg-1 arg-2) (vector 9 0 (vector 14 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-caseAlt arg-1 eta-0))))) (lambda () (lambda (u--b) (vector 0 (let ((u--fc (CoreC-45FC-boundToFC arg-1 u--b))) (let ((u--fcCase (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-1 arg-2)))) (let ((u--n (vector 2 "lcase" 0))) (vector 2 u--fcCase (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 0 u--fcCase u--n) (vector 26 u--fcCase) (vector 4 (CoreC-45FC-virtualiseFC u--fc) (vector 0 u--fcCase u--n) (let ((e-1 (vector-ref u--b 0))) e-1))))))))))))
(define IdrisC-45Parser-n--10921-8410-u--continueLam (lambda (arg-0 arg-1) (vector 9 1 (IdrisC-45Parser-bindList arg-1 arg-0) (lambda () (lambda (u--binders) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "=>") (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-mustContinue arg-0 '()) (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-1 arg-0) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-n--10921-8409-u--bindAll arg-0 arg-1 u--binders u--scope)))))))))))))
(define IdrisC-45Parser-n--18544-11476-u--clauseLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7) (if (null? arg-7) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (__leftTupleSection-0) (cons __leftTupleSection-0 '())) (IdrisC-45Parser-opExpr (IdrisC-45Parser-plhs) arg-5 arg-0)) (let ((e-2 (unbox arg-7))) (vector 9 0 (IdrisC-45Parser-opExpr (IdrisC-45Parser-plhs) arg-5 arg-0) (lambda () (lambda (u--e) (vector 0 (case (vector-ref u--e 0) ((25) e-2)(else (cons u--e '())))))))))))
(define IdrisC-45Parser-n--10896-6187-u--buildOutput (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (IdrisC-45Parser-n--10896-6186-u--lams arg-1 arg-2 arg-3 arg-4 e-2 (vector 40 arg-5 arg-1 e-3))))))
(define IdrisC-45Parser-n--10879-3889-u--braceArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-3 "{")) (lambda () (lambda (u--start) (vector 10 0 1 (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-3 ",") (vector 9 0 (vector 14 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleNamedArg arg-3))) (lambda () (lambda (u--x) (let ((u--fc (CoreC-45FC-boundToFC arg-3 u--x))) (LibrariesC-45TextC-45Parser-option 1 (vector 2 (let ((e-1 (vector-ref u--x 0))) e-1) (vector 0 u--fc (let ((e-1 (vector-ref u--x 0))) e-1))) (vector 9 0 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-3 "=")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-3 arg-4)))) (lambda () (lambda (u--tm) (vector 0 (vector 2 (let ((e-1 (vector-ref u--x 0))) e-1) u--tm))))))))))) (lambda (u--list) (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 '() (let ((sc0 (DataC-45List-isCons u--list))) (cond ((equal? sc0 1) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-3 ",") (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-3 "_")) (lambda () (lambda (u--x) (vector 0 (cons (IdrisC-45Parser-n--10879-3888-u--underscore arg-0 arg-1 arg-2 (CoreC-45FC-boundToFC arg-3 u--x)) '())))))))) (else (vector 4 '() 0 "non-empty list required"))))) (lambda (u--matchAny) (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-3 "}")) (lambda () (lambda (u--end) (vector 10 0 0 (let ((u--fc (CoreC-45FC-boundToFC arg-3 (LibrariesC-45TextC-45Bounded-mergeBounds u--start u--end)))) (vector 0 (let ((sc0 (DataC-45List-isNil u--list))) (cond ((equal? sc0 1) (cons (IdrisC-45Parser-n--10879-3888-u--underscore arg-0 arg-1 arg-2 u--fc) '())) (else u--matchAny))))) (lambda (matchAny-0) (vector 0 (PreludeC-45TypesC-45List-tailRecAppend matchAny-0 u--list)))))))))))))) (lambda () (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-3 "@{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-3 arg-4) (lambda () (lambda (u--tm) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-3 "}") (lambda () (vector 0 (cons (vector 1 u--tm) '()))))))))))))))
(define IdrisC-45Parser-n--10909-7638-u--binderName (lambda (arg-0 arg-1) (vector 13 1 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 0 eta-0)) (ParserC-45RuleC-45Source-unqualifiedName)) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-symbol "_") (vector 2 ))))))
(define IdrisC-45Parser-n--10921-8409-u--bindAll (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 2 (CoreC-45FC-boundToFC arg-1 e-10) e-6 (vector 1 ) (let ((e-1 (vector-ref e-10 0))) e-1) e-11 (IdrisC-45Parser-n--10921-8409-u--bindAll arg-0 arg-1 e-3 arg-3)))))))))))
(define IdrisC-45Parser-n--26721-19263-u--autoNumber (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (PreludeC-45Interfaces-C-60C-36 (csegen-352) '() (ParserC-45RuleC-45Source-keyword "auto")) (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (box (PreludeC-45Types-u--fromInteger_Num_Nat eta-0))) (ParserC-45RuleC-45Source-intLit))))))
(define IdrisC-45Parser-n--10878-3638-u--applyExpImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (IdrisC-45Parser-n--10878-3638-u--applyExpImp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 7 (vector 0 arg-1 arg-3 arg-4) arg-5 e-4) e-3))) ((1) (let ((e-5 (vector-ref e-2 1))) (IdrisC-45Parser-n--10878-3638-u--applyExpImp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 10 (vector 0 arg-1 arg-3 arg-4) arg-5 e-5) e-3))) ((2) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((u--fc (vector 0 arg-1 arg-3 arg-4))) (IdrisC-45Parser-n--10878-3638-u--applyExpImp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 9 u--fc arg-5 e-6 e-7) e-3))))) (else (let ((e-8 (vector-ref e-2 1))) (IdrisC-45Parser-n--10878-3638-u--applyExpImp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 8 (vector 0 arg-1 arg-3 arg-4) arg-5 e-8) e-3)))))))))
(define IdrisC-45Parser-u--show_Show_CmdArg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "") ((1) "<name>") ((2) "<expr>") ((3) "<decls>") ((4) "<number>") ((5) "<number|auto>") ((6) "<option>") ((7) "<file>") ((8) "<module>") ((9) "<string>") ((10) "(on|off)") (else (let ((e-0 (vector-ref arg-0 1))) (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Parser-u--show_Show_CmdArg eta-0)) e-0)))))))
(define IdrisC-45Parser-with_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "with") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (vector 13 1 1 (IdrisC-45Parser-n--10880-4359-u--singleName arg-1 arg-0) (lambda () (IdrisC-45Parser-n--10880-4360-u--nameList arg-1 arg-0))) (lambda () (lambda (u--ns) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--rhs) (vector 0 (cons u--ns u--rhs)))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 51 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3)))))))))))
(define IdrisC-45Parser-withFlags(blodwen-lazy (lambda () (vector 13 1 0 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-pragma "syntactic")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (PreludeC-45Interfaces-C-60C-36C-62 (csegen-356) (lambda (arg-0) (cons 0 arg-0)) (IdrisC-45Parser-withFlags))))) (lambda () (vector 0 '()))))))
(define IdrisC-45Parser-whereBlock (lambda (arg-0 arg-1) (vector 11 0 (IdrisC-45Parser-decoratedKeyword arg-0 "where") (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter arg-1 (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda (u--ds) (vector 0 (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-50) u--ds)))))))))
(define IdrisC-45Parser-visibility (lambda (arg-0) (vector 13 1 0 (IdrisC-45Parser-visOption arg-0) (lambda () (vector 0 0)))))
(define IdrisC-45Parser-visOption (lambda (arg-0) (vector 13 1 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "public")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedKeyword arg-0 "export") 2)))) (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedKeyword arg-0 "export") 1) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedKeyword arg-0 "private") 0)))))))
(define IdrisC-45Parser-visOpt (lambda (arg-0) (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-visOption arg-0) (lambda () (lambda (u--vis) (vector 0 (vector 0 u--vis))))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-fnOpt arg-0) (lambda () (lambda (u--tot) (vector 0 (vector 1 u--tot))))) (lambda () (vector 9 0 (IdrisC-45Parser-fnDirectOpt arg-0) (lambda () (lambda (u--opt) (vector 0 (vector 1 u--opt)))))))))))
(define IdrisC-45Parser-validPatternVar (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((2) (vector 0 0)) ((0) (let ((e-1 (vector-ref e-0 1))) (LibrariesC-45TextC-45Parser-when (let ((sc2 (LibrariesC-45UtilsC-45String-lowerFirst e-1))) (cond ((equal? sc2 1) 0) (else 1))) (lambda () (vector 4 '() 0 "Not a pattern variable")))))(else (vector 4 '() 0 "Not a pattern variable")))))(else (vector 4 '() 0 "Not a pattern variable")))))
(define IdrisC-45Parser-usingDecls (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "using") (lambda () (vector 12 0 1 (vector 7 ) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "(") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 9 1 (ParserC-45RuleC-45Source-unqualifiedName) (lambda () (lambda (u--x) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 0 (vector 1 (vector 0 u--x))))))))) (lambda (u--n) (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--ty) (vector 0 (cons u--n u--ty)))))))) (lambda (u--us) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda () (lambda (u--ds) (vector 0 (cons u--us u--ds))))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 4 (CoreC-45FC-boundToFC arg-0 u--b) e-2 (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-3271) e-3)))))))))))))
(define IdrisC-45Parser-typedArg (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-parens 1 arg-0 (IdrisC-45Parser-pibindListName arg-0 arg-1)) (lambda () (lambda (u--params) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (let ((e-1 (vector-ref e-6 0))) e-1) (cons e-2 (cons (vector 1 ) e-7)))))))) u--params))))) (lambda () (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (vector 13 1 0 (vector 10 0 1 (csegen-2368) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedKeyword arg-0 "auto")))) (lambda () (vector 13 1 0 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "default")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 3 eta-0)) (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (vector 0 (vector 0 )))))) (lambda (u--info) (vector 9 1 (IdrisC-45Parser-pibindListName arg-0 arg-1) (lambda () (lambda (u--params) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (let ((e-1 (vector-ref e-6 0))) e-1) (cons e-2 (cons u--info e-7)))))))) u--params))))))))))))))))
(define IdrisC-45Parser-typeExpr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (IdrisC-45Parser-binder arg-1 arg-2) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-expr arg-0 arg-1 arg-2)) (lambda () (lambda (u--arg) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (vector 9 1 (IdrisC-45Parser-bindSymbol arg-1) (lambda () (lambda (u--bd) (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr arg-0 arg-1 arg-2)) (lambda () (lambda (u--scope) (vector 0 (cons u--bd u--scope)))))))))) (lambda (u--mscope) (vector 0 (IdrisC-45Parser-n--10939-10165-u--mkPi arg-2 arg-1 arg-0 u--arg u--mscope)))))))))))
(define IdrisC-45Parser-tyDecls (lambda (arg-0 arg-1 arg-2 arg-3) (vector 9 0 (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-2 ",") (vector 10 0 1 (vector 10 0 0 (csegen-3300) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (vector 14 arg-0))))) (lambda () (lambda (u--docns) (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-2 ":")) (lambda () (lambda (u--b) (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Expected a type declaration" (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-2 arg-3) (lambda () (lambda (u--ty) (vector 0 (DataC-45List1-u--map_Functor_List1 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (cons (let ((e-1 (vector-ref e-3 0))) e-1) (cons (CoreC-45FC-boundToFC arg-2 e-3) u--ty)))))) u--docns)))))))))))) (lambda () (lambda (u--bs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-3) (vector 0 (DataC-45List1-u--map_Functor_List1 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector e-10 e-10 e-6 (PreludeC-45TypesC-45String-C-43C-43 arg-1 e-2) e-11)))))))) u--bs))))))))
(define IdrisC-45Parser-tuple (lambda (arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (IdrisC-45Parser-nonEmptyTuple arg-1 arg-2 arg-3 arg-4) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-continueWithDecorated arg-1 arg-3 ")")) (lambda () (lambda (u--end) (vector 12 0 0 (vector 16 (cons (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '())) '())) (vector 0 (vector 32 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--end)) arg-4))))))))))
(define IdrisC-45Parser-transformDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (ParserC-45RuleC-45Source-pragma "transform") (lambda () (vector 9 1 (ParserC-45RuleC-45Source-simpleStr) (lambda () (lambda (u--n) (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-plhs) arg-0 arg-1) (lambda () (lambda (u--lhs) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "=") (lambda () (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pnowith) arg-0 arg-1) (lambda () (lambda (u--rhs) (vector 0 (cons u--n (cons u--lhs u--rhs))))))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 12 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-6 e-7)))))))))))))
(define IdrisC-45Parser-totalityOpt (lambda (arg-0) (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedKeyword arg-0 "partial") 2) (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedKeyword arg-0 "total") 0) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedKeyword arg-0 "covering") 1)))))))
(define IdrisC-45Parser-topDecl (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-dataDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-claims arg-0 arg-1) (lambda () (lambda (u--ds) (vector 0 (DataC-45List1-forget u--ds))))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-definition arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (IdrisC-45Parser-fixDecl arg-0 arg-1) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-ifaceDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-implDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-recordDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-namespaceDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-mutualDecls arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-paramDecls arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-usingDecls arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-builtinDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-runElabDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-transformDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-directiveDecl arg-0 arg-1) (lambda () (csegen-3302))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 1 "Expected CG directive" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((16) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '()))))) (lambda () (lambda (u--dstr) (vector 0 (cons (let ((u--cgrest (DataC-45String-span (lambda (eta-0) (PreludeC-45Types-isAlphaNum eta-0)) (let ((e-1 (vector-ref u--dstr 0))) e-1)))) (vector 14 (CoreC-45FC-boundToFC arg-0 u--dstr) (vector 11 (Builtin-fst u--cgrest) (IdrisC-45Parser-stripBraces (DataC-45String-trim (Builtin-snd u--cgrest)))))) '()))))) (lambda () (vector 4 '() 1 "Couldn't parse declaration")))))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-stripBraces (lambda (arg-0) (PreludeC-45Types-fastPack (IdrisC-45Parser-n--20136-12646-u--drop arg-0 #\{ (PreludeC-45TypesC-45List-reverse (IdrisC-45Parser-n--20136-12646-u--drop arg-0 #\} (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-fastUnpack arg-0))))))))
(define IdrisC-45Parser-stringArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26419-18948-u--names arg-2 arg-1 arg-0) (cons (vector 9 ) (cons arg-2 (IdrisC-45Parser-n--26419-18949-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-snocListExpr (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-2) (lambda () (lambda (u--x) (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol ",")) (lambda () (lambda (u--b) (vector 0 (PreludeC-45Interfaces-C-60C-36 (csegen-360) u--x u--b))))))))) (lambda (u--hd) (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-2) (lambda () (lambda (u--tl) (vector 0 (cons u--hd u--tl)))))))) (lambda (u--mHeadTail) (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol "]")) (lambda () (lambda (u--b) (vector 0 (let ((u--xs (if (null? u--mHeadTail) '() (let ((e-2 (unbox u--mHeadTail))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (PreludeC-45Interfaces-C-60C-36 (csegen-360) e-6 u--b) '())))))))) (let ((u--fc (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds arg-1 u--b)))) (let ((u--nilFC (let ((sc0 ((PreludeC-45Types-u--null_Foldable_List u--xs)))) (cond ((equal? sc0 1) u--fc) (else (CoreC-45FC-boundToFC arg-0 arg-1)))))) (vector 39 u--fc u--nilFC (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (cons (CoreC-45FC-boundToFC arg-0 u--t) (let ((e-1 (vector-ref u--t 0))) e-1))) u--xs)))))))))))))
(define IdrisC-45Parser-singlelineStr (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-decorate arg-1 3 (vector 9 0 (vector 14 (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-strBegin)) (lambda () (lambda (u--begin) (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (vector 14 (LibrariesC-45TextC-45ParserC-45Core-C-60C-124C-124C-62 1 1 (IdrisC-45Parser-interpBlock arg-0 arg-1 arg-2) (lambda () (ParserC-45RuleC-45Source-strLitLines))))) (lambda (u--xs) (vector 10 0 1 (let ((sc0 (PreludeC-45Types-u--traverse_Traversable_List (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-2 (vector-ref arg-215 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-215 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-609) (vector 1 arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-2 (vector-ref arg-610 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (IdrisC-45Parser-n--10942-10327-u--toPStr arg-2 arg-1 arg-0 eta-0)) u--xs))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 4 (box (let ((e-3 (vector-ref u--begin 2))) e-3)) 1 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (vector 0 e-5))))) (lambda (u--pstrs) (vector 11 0 (ParserC-45RuleC-45Source-strEnd) (lambda () (vector 0 u--pstrs)))))))))))) (lambda () (lambda (u--b) (vector 0 (vector 33 (CoreC-45FC-boundToFC arg-1 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))))))
(define IdrisC-45Parser-simplerExpr (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (vector 14 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-0))) (lambda () (lambda (u--x) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "@") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (IdrisC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--expr) (vector 0 (cons u--x u--expr)))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 23 (CoreC-45FC-boundToFC arg-0 u--b) (CoreC-45FC-boundToFC arg-0 e-2) (let ((e-1 (vector-ref e-2 0))) e-1) e-3))))))))) (lambda () (vector 13 1 1 (IdrisC-45Parser-atom arg-0) (lambda () (vector 13 1 1 (IdrisC-45Parser-record_ arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-singlelineStr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-multilineStr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ".(") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--t) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 0 u--t)))))))))) (lambda () (lambda (u--b) (vector 0 (vector 24 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "`(") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--t) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 0 u--t))))))))) (lambda () (lambda (u--b) (vector 0 (vector 16 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "`{") (lambda () (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--t) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 u--t))))))))) (lambda () (lambda (u--b) (vector 0 (vector 17 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "`[") (lambda () (vector 9 1 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda () (lambda (u--ts) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "]") (lambda () (vector 0 u--ts))))))))) (lambda () (lambda (u--b) (vector 0 (vector 18 (CoreC-45FC-boundToFC arg-0 u--b) (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-3271) (let ((e-1 (vector-ref u--b 0))) e-1)))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "~")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (lambda (u--b) (vector 0 (vector 19 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "(")) (lambda () (lambda (u--start) (IdrisC-45Parser-bracketedExpr arg-0 u--start arg-1)))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "[<")) (lambda () (lambda (u--start) (IdrisC-45Parser-snocListExpr arg-0 u--start arg-1)))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (vector 13 1 1 (ParserC-45RuleC-45Source-symbol "[>") (lambda () (ParserC-45RuleC-45Source-symbol "[")))) (lambda () (lambda (u--start) (IdrisC-45Parser-listExpr arg-0 u--start arg-1)))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "!")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (lambda (u--b) (vector 0 (vector 36 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--b)) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "[|") (lambda () (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--t) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "|]") (lambda () (vector 0 u--t))))))))) (lambda () (lambda (u--b) (vector 0 (vector 37 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (ParserC-45RuleC-45Source-pragma "logging") (lambda () (vector 10 0 1 (csegen-3310) (lambda (u--topic) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--lvl) (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--e) (vector 0 (cons (CoreC-45OptionsC-45Log-mkLogLevelC-39 u--topic (PreludeC-45Types-prim__integerToNat u--lvl)) u--e))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 50 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3))))))))) (lambda () (vector 10 1 0 (vector 14 (IdrisC-45Parser-lam arg-0 arg-1)) (lambda (u--res) (vector 12 0 0 (vector 5 (box (let ((e-3 (vector-ref u--res 2))) e-3)) "DEPRECATED: trailing lambda. Use a $ or parens") (vector 0 (let ((e-1 (vector-ref u--res 0))) e-1)))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-simpleExpr (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 0 (IdrisC-45Parser-simplerExpr arg-0 arg-1) (lambda () (lambda (u--root) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (vector 14 (ParserC-45RuleC-45Source-postfixProj))) (lambda (u--projs) (vector 0 (cons u--root u--projs)))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--projs (PreludeC-45Types-u--map_Functor_List (lambda (u--proj) (cons (CoreC-45FC-boundToFC arg-0 u--proj) (let ((e-1 (vector-ref u--proj 0))) e-1))) e-3))) (vector 0 (if (null? u--projs) e-2 (vector 48 (CoreC-45FC-boundToFC arg-0 u--b) e-2 u--projs))))))))))) (lambda () (vector 9 0 (csegen-3315) (lambda () (lambda (u--b) (vector 0 (let ((u--projs (PreludeC-45Types-u--map_Functor_List (lambda (u--proj) (cons (CoreC-45FC-boundToFC arg-0 u--proj) (let ((e-1 (vector-ref u--proj 0))) e-1))) (let ((e-1 (vector-ref u--b 0))) e-1)))) (vector 49 (CoreC-45FC-boundToFC arg-0 u--b) u--projs))))))))))
(define IdrisC-45Parser-simpleData (lambda (arg-1 arg-2 arg-3 arg-4) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (vector 14 (IdrisC-45Parser-decorate arg-1 5 (ParserC-45RuleC-45Source-name)))) (lambda (u--params) (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-1 "=")) (lambda () (lambda (u--tyend) (vector 8 (let ((u--tyfc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--tyend)))) (let ((u--tyCon (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) (let ((e-1 (vector-ref arg-3 0))) e-1)))) (let ((u--toPRef (lambda (u--t) (vector 0 (CoreC-45FC-boundToFC arg-1 u--t) (let ((e-1 (vector-ref u--t 0))) e-1))))) (let ((u--conRetTy (IdrisC-45Syntax-papply u--tyfc u--tyCon (PreludeC-45Types-u--map_Functor_List u--toPRef u--params)))) (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-1 "|") (IdrisC-45Parser-simpleCon arg-1 u--conRetTy arg-4)) (lambda () (lambda (u--cons) (vector 0 (cons u--params (cons u--tyfc (DataC-45List1-forget u--cons)))))))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 0 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--b)) (let ((e-1 (vector-ref arg-3 0))) e-1) (IdrisC-45Parser-mkTyConType arg-1 e-6 e-2) '() e-7)))))))))))))
(define IdrisC-45Parser-simpleCon (lambda (arg-0 arg-1 arg-2) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--cdoc) (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedDataConstructorName arg-0)) (lambda () (lambda (u--cname) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-argExpr (IdrisC-45Parser-plhs) arg-0 arg-2)) (lambda (u--params) (vector 0 (cons u--cdoc (cons (let ((e-1 (vector-ref u--cname 0))) e-1) (cons (CoreC-45FC-boundToFC arg-0 u--cname) u--params)))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-2) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--cfc (CoreC-45FC-boundToFC arg-0 u--b))) (DataC-45Maybe-fromMaybe (lambda () (vector 4 '() 1 "Named arguments not allowed in ADT constructors")) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 0 (vector u--cfc e-10 e-6 e-2 eta-0))) (IdrisC-45Parser-mkDataConType u--cfc arg-1 (PreludeC-45Interfaces-concat (csegen-50) e-11)))))))))))))))))))
(define IdrisC-45Parser-setVarOption(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "eval") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 1 (IdrisC-45Parser-parseMode)) (lambda (u--mode) (vector 0 (vector 3 u--mode)))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "editor") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-unqualifiedName) (lambda () (lambda (u--e) (vector 0 (vector 4 u--e))))))) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "cg") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-unqualifiedName) (lambda () (lambda (u--c) (vector 0 (vector 5 u--c))))))))))))))
(define IdrisC-45Parser-setOption (lambda (arg-0) (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "showimplicits") (lambda () (vector 0 (vector 0 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "shownamespace") (lambda () (vector 0 (vector 1 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "showtypes") (lambda () (vector 0 (vector 2 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "profile") (lambda () (vector 0 (vector 6 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "evaltiming") (lambda () (vector 0 (vector 7 arg-0)))) (cond ((equal? arg-0 1) (lambda () (IdrisC-45Parser-setVarOption))) (else (lambda () (vector 4 '() 1 "Unrecognised option")))))))))))))))
(define IdrisC-45Parser-runParseCmd (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (IdrisC-45Parser-replCmd e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (ParserC-45RuleC-45Source-keyword e-1))) (else (let ((e-2 (vector-ref arg-0 1))) (ParserC-45RuleC-45Source-exactIdent e-2))))))
(define IdrisC-45Parser-runElabDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 1 1 (csegen-3325) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-expr (IdrisC-45Parser-pnowith) arg-0 arg-1))))) (lambda () (lambda (u--tm) (vector 0 (vector 13 (CoreC-45FC-boundToFC arg-0 u--tm) (let ((e-1 (vector-ref u--tm 0))) e-1))))))))
(define IdrisC-45Parser-rewrite_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "rewrite") (lambda () (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--rule) (vector 11 1 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "in") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--tm) (vector 0 (cons u--rule u--tm))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 45 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3)))))))))))
(define IdrisC-45Parser-replCmd (lambda (arg-0) (if (null? arg-0) (vector 4 '() 0 "Unrecognised command") (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (vector 13 1 1 (ParserC-45RuleC-45Source-exactIdent e-2) (lambda () (vector 13 1 1 (ParserC-45RuleC-45Source-symbol e-2) (lambda () (IdrisC-45Parser-replCmd e-3))))))))))
(define IdrisC-45Parser-record_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 0 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedKeyword arg-0 "record") 1)) (lambda (u--kw) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-field u--kw arg-0 arg-1)) (lambda () (lambda (u--fs) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 (DataC-45List1-forget u--fs))))))))))))) (lambda () (lambda (u--b) (vector 0 (vector 6 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1))))))))
(define IdrisC-45Parser-recordParam (lambda (arg-0 arg-1) (vector 13 1 1 (IdrisC-45Parser-typedArg arg-0 arg-1) (lambda () (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 0 (cons (cons (let ((e-1 (vector-ref u--n 0))) e-1) (cons (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (cons (vector 1 ) (vector 26 (CoreC-45FC-boundToFC arg-0 u--n))))) '())))))))))
(define IdrisC-45Parser-recordDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 10 0 1 (IdrisC-45Parser-visibility arg-0) (lambda (u--vis) (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "record") (lambda () (vector 9 1 (vector 8 (IdrisC-45Parser-decoratedDataTypeName arg-0)) (lambda () (lambda (u--n) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-recordParam arg-0 arg-1)) (lambda (u--paramss) (let ((u--params (PreludeC-45Interfaces-concat (csegen-50) u--paramss))) (vector 11 0 (IdrisC-45Parser-decoratedKeyword arg-0 "where") (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-blockWithOptHeaderAfter u--col (lambda (u--idt) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (IdrisC-45Parser-recordConstructor arg-0)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-atEnd u--idt))))) (lambda (eta-0) (IdrisC-45Parser-fieldDecl arg-0 eta-0))) (lambda (u--dcflds) (vector 0 (lambda (u--fc) (vector 8 u--fc u--doc u--vis u--n u--params (Builtin-fst u--dcflds) (PreludeC-45Interfaces-concat (csegen-50) (Builtin-snd u--dcflds)))))))))))))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-0 u--b)))))))))
(define IdrisC-45Parser-recordConstructor (lambda (arg-0) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "constructor") (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-decoratedDataConstructorName arg-0)) (lambda () (lambda (u--n) (vector 0 u--n))))))))
(define IdrisC-45Parser-progHdr (lambda (arg-0) (vector 10 0 0 (vector 14 (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-mainNS)) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "module") (lambda () (vector 8 (ParserC-45RuleC-45Source-moduleIdent))))) (lambda (u--nspace) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-import_ arg-0 eta-0))) (lambda (u--imports) (vector 0 (cons u--doc (cons u--nspace u--imports)))))))))) (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector (CoreC-45FC-boundToFC arg-0 u--b) e-6 e-7 e-2 '()))))))))))))
(define IdrisC-45Parser-prog (lambda (arg-0) (vector 10 0 0 (vector 14 (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-mainNS)) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "module") (lambda () (IdrisC-45Parser-decorate arg-0 8 (vector 8 (ParserC-45RuleC-45Source-moduleIdent)))))) (lambda (u--nspace) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-import_ arg-0 eta-0))) (lambda (u--imports) (vector 0 (cons u--doc (cons u--nspace u--imports)))))))))) (lambda (u--b) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda (u--ds) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector (CoreC-45FC-boundToFC arg-0 u--b) e-6 e-7 e-2 (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-50) u--ds))))))))))))))))
(define IdrisC-45Parser-pnowith(blodwen-lazy (lambda () (cons 1 0))))
(define IdrisC-45Parser-pnoeq (lambda (ext-0) (let ((e-1 (cdr ext-0))) (cons 0 e-1))))
(define IdrisC-45Parser-plhs(blodwen-lazy (lambda () (cons 0 0))))
(define IdrisC-45Parser-pibindListName (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 14 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 eta-0)) (IdrisC-45Parser-n--10909-7638-u--binderName arg-1 arg-0)))) (lambda () (lambda (u--ns) (let ((ns-0 (DataC-45List1-forget u--ns))) (vector 12 0 1 (IdrisC-45Parser-decorateBoundedNames arg-0 5 ns-0) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--ty) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (u--n) (cons u--rig (cons u--n u--ty))) ns-0))))))))))))))) (lambda () (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 1 (vector 14 (IdrisC-45Parser-decorate arg-0 5 (IdrisC-45Parser-n--10909-7638-u--binderName arg-1 arg-0))) (lambda () (lambda (u--n) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--ty) (vector 0 (cons u--rig (cons (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (vector 1 eta-0)) u--n) u--ty)))))))))))))))))))
(define IdrisC-45Parser-pibindList (lambda (arg-0 arg-1) (vector 9 0 (IdrisC-45Parser-pibindListName arg-0 arg-1) (lambda () (lambda (u--params) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (box eta-0)) e-6) e-7))))))) u--params)))))))
(define IdrisC-45Parser-pibindAll (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (CoreC-45FC-boundToFC arg-0 e-10) e-6 arg-1 (let ((e-1 (vector-ref e-10 0))) e-1) e-11 (IdrisC-45Parser-pibindAll arg-0 arg-1 e-3 arg-3)))))))))))
(define IdrisC-45Parser-pdef(blodwen-lazy (lambda () (cons 1 1))))
(define IdrisC-45Parser-patAlt (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "|") (lambda () (IdrisC-45Parser-caseAlt arg-0 arg-1)))))
(define IdrisC-45Parser-parserCommandsForHelp(blodwen-lazy (lambda () (cons (IdrisC-45Parser-exprArgCmd (vector 0 (cons "t" (cons "type" '()))) (lambda (eta-0) (vector 2 eta-0)) "Check the type of an expression") (cons (IdrisC-45Parser-exprArgCmd (vector 0 (cons "ti" '())) (lambda (eta-0) (vector 3 eta-0)) "Check the type of an expression, showing implicit arguments") (cons (IdrisC-45Parser-nameArgCmd (vector 0 (cons "printdef" '())) (lambda (eta-0) (vector 4 eta-0)) "Show the definition of a function") (cons (IdrisC-45Parser-exprArgCmd (vector 0 (cons "s" (cons "search" '()))) (lambda (eta-0) (vector 12 eta-0)) "Search for values by type") (cons (IdrisC-45Parser-nameArgCmd (vector 2 "di") (lambda (eta-0) (vector 14 eta-0)) "Show debugging information for a name") (cons (IdrisC-45Parser-moduleArgCmd (vector 1 "module") (lambda (eta-0) (vector 7 eta-0)) "Import an extra module") (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "q" (cons "quit" (cons "exit" '())))) (vector 31 ) "Exit the Idris system") (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "cwd" '())) (vector 19 ) "Displays the current working directory") (cons (IdrisC-45Parser-optArgCmd (vector 2 "set") (lambda (eta-0) (vector 15 eta-0)) 1 "Set an option") (cons (IdrisC-45Parser-optArgCmd (vector 2 "unset") (lambda (eta-0) (vector 15 eta-0)) 0 "Unset an option") (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "opts" '())) (vector 16 ) "Show current options settings") (cons (IdrisC-45Parser-compileArgsCmd (vector 0 (cons "c" (cons "compile" '()))) (lambda (eta-0) (lambda (eta-1) (vector 9 eta-0 eta-1))) "Compile to an executable") (cons (IdrisC-45Parser-exprArgCmd (vector 2 "exec") (lambda (eta-0) (vector 10 eta-0)) "Compile to an executable and run") (cons (IdrisC-45Parser-stringArgCmd (vector 2 "directive") (lambda (eta-0) (vector 17 eta-0)) "Set a codegen-specific directive") (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "r" (cons "reload" '()))) (vector 5 ) "Reload current file") (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "e" (cons "edit" '()))) (vector 8 ) "Edit current file using $EDITOR or $VISUAL") (cons (IdrisC-45Parser-nameArgCmd (vector 0 (cons "miss" (cons "missing" '()))) (lambda (eta-0) (vector 20 eta-0)) "Show missing clauses") (cons (IdrisC-45Parser-nameArgCmd (vector 1 "total") (lambda (eta-0) (vector 21 eta-0)) "Check the totality of a name") (cons (IdrisC-45Parser-exprArgCmd (vector 2 "doc") (lambda (eta-0) (vector 22 eta-0)) "Show documentation for a name or primitive") (cons (IdrisC-45Parser-moduleArgCmd (vector 2 "browse") (lambda (eta-0) (vector 23 (CoreC-45NameC-45Namespace-miAsNamespace eta-0))) "Browse contents of a namespace") (cons (IdrisC-45Parser-loggingArgCmd (vector 0 (cons "log" (cons "logging" '()))) (lambda (eta-0) (vector 24 eta-0)) "Set logging level") (cons (IdrisC-45Parser-autoNumberArgCmd (vector 0 (cons "consolewidth" '())) (lambda (eta-0) (vector 25 eta-0)) "Set the width of the console output (0 for unbounded) (auto by default)") (cons (IdrisC-45Parser-onOffArgCmd (vector 0 (cons "color" (cons "colour" '()))) (lambda (eta-0) (vector 26 eta-0)) "Whether to use color for the console output (enabled by default)") (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "m" (cons "metavars" '()))) (vector 27 ) "Show remaining proof obligations (metavariables or holes)") (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "version" '())) (vector 30 ) "Display the Idris version") (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "?" (cons "h" (cons "help" '())))) (vector 11 ) "Display this help text") (cons (IdrisC-45Parser-declsArgCmd (vector 1 "let") (lambda (eta-0) (vector 0 eta-0)) "Define a new value") (cons (IdrisC-45Parser-stringArgCmd (vector 0 (cons "lp" (cons "loadpackage" '()))) (lambda (eta-0) (vector 33 eta-0)) "Load all modules of the package") (cons (IdrisC-45Parser-exprArgCmd (vector 0 (cons "fs" (cons "fsearch" '()))) (lambda (eta-0) (vector 13 eta-0)) "Search for global definitions by sketching the names distribution of the wanted type(s).") '()))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-parseRHS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-2 "=") (lambda () (vector 8 (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-2 arg-5) (lambda () (lambda (u--rhs) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 '() (IdrisC-45Parser-whereBlock arg-2 arg-4)) (lambda (u--ws) (vector 0 (cons u--rhs u--ws))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-5) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--fc (CoreC-45FC-boundToFC arg-2 (LibrariesC-45TextC-45Bounded-mergeBounds arg-3 u--b)))) (vector 0 (vector 0 u--fc (PreludeC-45Basics-uncurry (csegen-3413) arg-6) e-2 e-3))))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-2 "with") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (IdrisC-45Parser-withFlags) (lambda (u--flags) (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-2 "(")) (lambda () (lambda (u--start) (vector 9 1 (IdrisC-45Parser-bracketedExpr arg-2 u--start arg-5) (lambda () (lambda (u--wval) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-2 "proof")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-2)))))) (lambda (u--prf) (vector 9 0 (vector 8 (ParserC-45RuleC-45Source-nonEmptyBlockAfter arg-4 (lambda (eta-0) (IdrisC-45Parser-clause (+ 1 arg-1) (box arg-6) arg-2 eta-0)))) (lambda () (lambda (u--ws) (vector 0 (cons u--prf (cons u--flags (cons u--wval (DataC-45List1-forget u--ws)))))))))))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--fc (CoreC-45FC-boundToFC arg-2 (LibrariesC-45TextC-45Bounded-mergeBounds arg-3 u--b)))) (vector 0 (vector 1 u--fc (PreludeC-45Basics-uncurry (csegen-3413) arg-6) e-10 e-2 e-6 e-11)))))))))))))) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-2 "impossible")) (lambda () (lambda (u--end) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-5) (vector 0 (let ((u--fc (CoreC-45FC-boundToFC arg-2 (LibrariesC-45TextC-45Bounded-mergeBounds arg-3 u--end)))) (vector 2 u--fc (PreludeC-45Basics-uncurry (csegen-3413) arg-6))))))))))))))
(define IdrisC-45Parser-parseMode(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "typecheck") (lambda () (vector 0 0))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "tc") (lambda () (vector 0 0))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "normalise") (lambda () (vector 0 1))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "default") (lambda () (vector 0 1))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "normal") (lambda () (vector 0 1))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "normalize") (lambda () (vector 0 1))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "execute") (lambda () (vector 0 2))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "exec") (lambda () (vector 0 2))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "scheme") (lambda () (vector 0 3))))))))))))))))))))))
(define IdrisC-45Parser-parens (lambda (arg-1 arg-2 arg-3) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 arg-1 (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 0 (lambda (eta-0) eta-0))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-2 "(")))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-1 u--f arg-3)))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-2 ")"))))))
(define IdrisC-45Parser-paramDecls (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-0 "parameters")) (lambda () (lambda (u--b1) (vector 12 0 1 (vector 7 ) (vector 9 1 (vector 14 (vector 13 1 1 (IdrisC-45Parser-n--23682-16217-u--newParamDecls arg-1 arg-0 arg-0 arg-1) (lambda () (IdrisC-45Parser-n--23682-16216-u--oldParamDecls arg-1 arg-0 arg-0 arg-1)))) (lambda () (lambda (u--args) (vector 12 0 1 (vector 7 ) (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0)))) (lambda () (lambda (u--declarations) (vector 10 0 0 (vector 0 (LibrariesC-45TextC-45Bounded-mergeBounds u--b1 (LibrariesC-45TextC-45Bounded-mergeBounds u--args u--declarations))) (lambda (u--mergedBounds) (vector 0 (vector 3 (CoreC-45FC-boundToFC arg-0 u--mergedBounds) (let ((e-1 (vector-ref u--args 0))) e-1) (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-3271) (let ((e-1 (vector-ref u--declarations 0))) e-1))))))))))))))))))))
(define IdrisC-45Parser-optArgCmd (lambda (arg-0 arg-1 arg-2 arg-3) (cons (IdrisC-45Parser-n--26619-19157-u--names arg-3 arg-2 arg-1 arg-0) (cons (vector 6 ) (cons arg-3 (IdrisC-45Parser-n--26619-19158-u--parse arg-3 arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-opExpr (lambda (arg-0 arg-1 arg-2) (vector 9 0 (vector 14 (IdrisC-45Parser-appExpr arg-0 arg-1 arg-2)) (lambda () (lambda (u--l) (vector 13 1 0 (let ((sc0 (let ((e-0 (car arg-0))) e-0))) (cond ((equal? sc0 1) (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-continue arg-2)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-1 "="))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-opExpr arg-0 arg-1 arg-2))))) (lambda () (lambda (u--r) (vector 0 (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds u--l u--r)))) (let ((u--opFC (CoreC-45FC-virtualiseFC u--fc))) (vector 27 u--fc u--opFC (vector 1 (vector 0 "=")) (let ((e-1 (vector-ref u--l 0))) e-1) (let ((e-1 (vector-ref u--r 0))) e-1))))))))) (else (vector 4 '() 0 "= not allowed")))) (lambda () (vector 13 1 0 (vector 9 0 (vector 14 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (vector 9 1 (vector 14 (IdrisC-45Parser-iOperator)) (lambda () (lambda (u--op) (vector 9 0 (let ((e-1 (vector-ref u--op 0))) (case (vector-ref e-1 0) ((1) (let ((e-0 (vector-ref e-1 1))) (case (vector-ref e-0 0) ((0) (let ((e-4 (vector-ref e-0 1))) (cond ((equal? e-4 "$") (IdrisC-45Parser-typeExpr arg-0 arg-1 arg-2))(else (IdrisC-45Parser-expr arg-0 arg-1 arg-2)))))(else (IdrisC-45Parser-expr arg-0 arg-1 arg-2)))))(else (IdrisC-45Parser-expr arg-0 arg-1 arg-2)))) (lambda () (lambda (u--e) (vector 0 (cons u--op u--e)))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds u--l u--b)))) (let ((u--opFC (CoreC-45FC-boundToFC arg-1 e-2))) (vector 0 (vector 27 u--fc u--opFC (let ((e-1 (vector-ref e-2 0))) e-1) (let ((e-1 (vector-ref u--l 0))) e-1) e-3))))))))))) (lambda () (vector 0 (let ((e-1 (vector-ref u--l 0))) e-1)))))))))))
(define IdrisC-45Parser-onoff(blodwen-lazy (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-exactIdent "on") 1) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-exactIdent "off") 0))))))
(define IdrisC-45Parser-onOffArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26804-19350-u--names arg-2 arg-1 arg-0) (cons (vector 10 ) (cons arg-2 (IdrisC-45Parser-n--26804-19351-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-nonEmptyTuple (lambda (arg-1 arg-2 arg-3 arg-4) (vector 9 1 (LibrariesC-45TextC-45Parser-some (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol ",")) (lambda () (lambda (u--b) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-1 arg-3)) (lambda (u--exp) (vector 0 (cons (CoreC-45FC-boundToFC arg-1 u--b) u--exp)))))))) (lambda () (lambda (u--vals) (vector 9 0 (IdrisC-45Parser-continueWithDecorated arg-1 arg-3 ")") (lambda () (lambda (u--end) (vector 12 0 0 (vector 16 (cons (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '())) '())) (vector 0 (let ((e-1 (car u--vals))) (let ((e-2 (cdr u--vals))) (IdrisC-45Parser-n--10896-6187-u--buildOutput arg-4 arg-3 arg-2 arg-1 (Builtin-fst e-1) (IdrisC-45Parser-n--10896-6189-u--mergePairs arg-4 arg-3 arg-2 arg-1 0 e-1 e-2))))))))))))))
(define IdrisC-45Parser-nonEmptyCommand(blodwen-lazy (lambda () (LibrariesC-45TextC-45Parser-choice (csegen-51) 1 (PreludeC-45Types-u--map_Functor_List (csegen-3437) (IdrisC-45Parser-parserCommandsForHelp))))))
(define IdrisC-45Parser-noArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26332-18858-u--names arg-2 arg-1 arg-0) (cons (vector 0 ) (cons arg-2 (IdrisC-45Parser-n--26332-18859-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-nestedDpair (lambda (arg-1 arg-2 arg-3) (vector 13 1 1 (IdrisC-45Parser-dpairType arg-1 arg-2 arg-3) (lambda () (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-1 arg-3) (lambda () (lambda (u--l) (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "**")) (lambda () (lambda (u--loc) (vector 9 0 (vector 14 (vector 13 1 1 (IdrisC-45Parser-nestedDpair arg-1 u--loc arg-3) (lambda () (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-1 arg-3)))) (lambda () (lambda (u--rest) (vector 0 (vector 41 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest)) (CoreC-45FC-boundToFC arg-1 u--loc) u--l (vector 25 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest))) (let ((e-1 (vector-ref u--rest 0))) e-1))))))))))))))))
(define IdrisC-45Parser-namespaceHead (lambda (arg-0) (vector 11 1 (ParserC-45RuleC-45Source-keyword "namespace") (lambda () (IdrisC-45Parser-decorate arg-0 6 (vector 8 (ParserC-45RuleC-45Source-namespaceId)))))))
(define IdrisC-45Parser-namespaceDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 9 0 (IdrisC-45Parser-namespaceHead arg-0) (lambda () (lambda (u--ns) (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda (u--ds) (vector 0 (cons u--doc (cons u--ns u--ds))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 11 (CoreC-45FC-boundToFC arg-0 u--b) e-6 (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-50) e-7))))))))))))))
(define IdrisC-45Parser-nameArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26369-18896-u--names arg-2 arg-1 arg-0) (cons (vector 1 ) (cons arg-2 (IdrisC-45Parser-n--26369-18897-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-mutualDecls (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "mutual")) (csegen-1554))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))))))) (lambda () (lambda (u--ds) (vector 0 (vector 9 (CoreC-45FC-boundToFC arg-0 u--ds) (PreludeC-45Interfaces-concat (csegen-3271) (let ((e-1 (vector-ref u--ds 0))) e-1)))))))))
(define IdrisC-45Parser-multiplicity (lambda (arg-0) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-intLit))) (lambda (bind-0) (if (null? bind-0) (vector 0 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)) (let ((e-1 (unbox bind-0))) (cond ((equal? e-1 0) (csegen-2389)) ((equal? e-1 1) (csegen-2390))(else (vector 4 '() 0 "Invalid multiplicity (must be 0 or 1)")))))))))
(define IdrisC-45Parser-multilineStr (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-decorate arg-1 3 (vector 9 0 (vector 14 (vector 11 1 (ParserC-45RuleC-45Source-multilineBegin) (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (vector 14 (LibrariesC-45TextC-45ParserC-45Core-C-60C-124C-124C-62 1 1 (IdrisC-45Parser-interpBlock arg-0 arg-1 arg-2) (lambda () (ParserC-45RuleC-45Source-strLitLines))))) (lambda (u--xs) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--endloc) (vector 11 0 (ParserC-45RuleC-45Source-strEnd) (lambda () (vector 0 (cons u--endloc (IdrisC-45Parser-n--10943-10542-u--toLines arg-2 arg-1 arg-0 u--xs '() '()))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (let ((e-7 (cdr e-5))) (vector 34 (CoreC-45FC-boundToFC arg-1 u--b) (PreludeC-45Types-u--fromInteger_Num_Nat (PreludeC-45Cast-u--cast_Cast_Int_Integer e-7)) e-4))))))))))))
(define IdrisC-45Parser-moduleArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26468-18999-u--names arg-2 arg-1 arg-0) (cons (vector 8 ) (cons arg-2 (IdrisC-45Parser-n--26468-19000-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-mkTyConType (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (vector 22 (CoreC-45FC-virtualiseFC arg-1)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--bfc (CoreC-45FC-boundToFC arg-0 e-2))) (vector 1 u--bfc (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) '() (vector 22 (CoreC-45FC-virtualiseFC arg-1)) (IdrisC-45Parser-mkTyConType arg-0 arg-1 e-3))))))))
(define IdrisC-45Parser-mkDataConType (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (box arg-1) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 1 arg-0 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) '() e-4 eta-0)) (IdrisC-45Parser-mkDataConType arg-0 arg-1 e-3)))) ((1) (let ((e-5 (vector-ref e-2 1))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (vector 1 arg-0 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 2 ) '() e-5 eta-0)) (IdrisC-45Parser-mkDataConType arg-0 arg-1 e-3))))(else '())))))))
(define IdrisC-45Parser-loggingArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26924-19476-u--names arg-2 arg-1 arg-0) (cons (vector 11 (cons (vector 9 ) (cons (vector 4 ) '()))) (cons arg-2 (IdrisC-45Parser-n--26924-19477-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-logLevel(blodwen-lazy (lambda () (vector 13 1 1 (csegen-2380) (lambda () (vector 13 1 1 (vector 10 0 1 (csegen-3310) (lambda (u--topic) (vector 9 0 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--lvl) (vector 0 (box (CoreC-45OptionsC-45Log-mkLogLevelC-39 u--topic (PreludeC-45Types-u--fromInteger_Num_Nat u--lvl))))))))) (lambda () (vector 4 '() 0 "expected a log level"))))))))
(define IdrisC-45Parser-listRange (lambda (arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-1 "]")) (lambda () (lambda (u--b) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--b)))) (vector 10 0 0 (IdrisC-45Parser-getInitRange arg-4) (lambda (u--rstate) (vector 12 0 0 (IdrisC-45Parser-decorateKeywords arg-1 arg-4) (vector 0 (vector 47 u--fc (Builtin-fst u--rstate) (Builtin-snd u--rstate)))))))))) (lambda () (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-1 arg-3)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-1 "]"))))) (lambda () (lambda (u--y) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--y)))) (vector 10 0 0 (IdrisC-45Parser-getInitRange arg-4) (lambda (u--rstate) (vector 12 0 0 (IdrisC-45Parser-decorateKeywords arg-1 arg-4) (vector 0 (vector 46 u--fc (Builtin-fst u--rstate) (Builtin-snd u--rstate) (let ((e-1 (vector-ref u--y 0))) e-1))))))))))))))
(define IdrisC-45Parser-listExpr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-pnowith) arg-0 arg-2) (lambda () (lambda (u--ret) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "|") (lambda () (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-doAct arg-0 arg-2)) (lambda () (lambda (u--conds) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "]") (lambda () (vector 0 (cons u--ret u--conds))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 44 (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds arg-1 u--b)) e-2 (PreludeC-45Interfaces-concat (csegen-3271) e-3)))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 '() (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-2) (lambda () (lambda (u--hd) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol ",")) (lambda () (lambda (u--b) (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-2) (lambda () (lambda (u--x) (vector 0 (PreludeC-45Interfaces-C-60C-36 (csegen-360) u--x u--b))))))))) (lambda (u--tl) (vector 0 (cons (PreludeC-45Interfaces-C-60C-36 (csegen-360) u--hd arg-1) u--tl)))))))) (lambda (u--xs) (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "..") (lambda () (IdrisC-45Parser-listRange arg-0 arg-1 arg-2 u--xs))) (lambda () (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol "]")) (lambda () (lambda (u--b) (vector 0 (let ((u--fc (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds arg-1 u--b)))) (let ((u--nilFC (let ((sc0 ((PreludeC-45Types-u--null_Foldable_List u--xs)))) (cond ((equal? sc0 1) u--fc) (else (CoreC-45FC-boundToFC arg-0 u--b)))))) (vector 38 u--fc u--nilFC (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (cons (CoreC-45FC-boundToFC arg-0 u--t) (let ((e-1 (vector-ref u--t 0))) e-1))) u--xs))))))))))))))))
(define IdrisC-45Parser-let_ (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "let") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-letBlock arg-0 eta-0))) (lambda () (lambda (u--res) (vector 11 1 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "in") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45ParserC-45Let-mkLets arg-0 u--res u--scope)))))))))))))))
(define IdrisC-45Parser-letBlock (lambda (arg-0 arg-1) (vector 14 (LibrariesC-45TextC-45ParserC-45Core-C-60C-124C-124C-62 1 1 (IdrisC-45Parser-n--10922-8579-u--letBinder arg-1 arg-0) (lambda () (IdrisC-45Parser-n--10922-8580-u--letDecl arg-1 arg-0))))))
(define IdrisC-45Parser-lazy (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-exactIdent "Lazy"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (lambda (u--tm) (vector 0 (vector 11 (CoreC-45FC-boundToFC arg-0 u--tm) 1 (let ((e-1 (vector-ref u--tm 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-exactIdent "Inf"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (lambda (u--tm) (vector 0 (vector 11 (CoreC-45FC-boundToFC arg-0 u--tm) 0 (let ((e-1 (vector-ref u--tm 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decorate arg-0 3 (ParserC-45RuleC-45Source-exactIdent "Delay"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (lambda (u--tm) (vector 0 (vector 12 (CoreC-45FC-boundToFC arg-0 u--tm) (let ((e-1 (vector-ref u--tm 0))) e-1)))))) (lambda () (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decorate arg-0 3 (ParserC-45RuleC-45Source-exactIdent "Force"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (lambda (u--tm) (vector 0 (vector 13 (CoreC-45FC-boundToFC arg-0 u--tm) (let ((e-1 (vector-ref u--tm 0))) e-1))))))))))))))
(define IdrisC-45Parser-lam (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "\\") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-0 "case"))) (lambda (u--switch) (if (null? u--switch) (IdrisC-45Parser-n--10921-8410-u--continueLam arg-1 arg-0) (let ((e-2 (unbox u--switch))) (IdrisC-45Parser-n--10921-8411-u--continueLamCase arg-1 arg-0 e-2))))))))))
(define IdrisC-45Parser-interpBlock (lambda (arg-0 arg-1 arg-2) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-interpBegin)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (vector 8 (IdrisC-45Parser-expr arg-0 arg-1 arg-2)))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-interpEnd))))))
(define IdrisC-45Parser-import_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "import") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 0 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedKeyword arg-0 "public") 1)) (lambda (u--reexp) (vector 9 0 (IdrisC-45Parser-decorate arg-0 8 (vector 8 (ParserC-45RuleC-45Source-moduleIdent))) (lambda () (lambda (u--ns) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 (CoreC-45NameC-45Namespace-miAsNamespace u--ns) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "as") (lambda () (IdrisC-45Parser-decorate arg-0 6 (vector 8 (ParserC-45RuleC-45Source-namespaceId)))))) (lambda (u--nsAs) (vector 0 (cons u--reexp (cons u--ns u--nsAs))))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-6 e-7))))))))))))))
(define IdrisC-45Parser-implicitPi (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 9 1 (IdrisC-45Parser-pibindList arg-0 arg-1) (lambda () (lambda (u--binders) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 u--binders))))))))) (lambda () (lambda (u--b) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return an implicit argument" (IdrisC-45Parser-decoratedSymbol arg-0 "->")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-pibindAll arg-0 (vector 0 ) (let ((e-1 (vector-ref u--b 0))) e-1) u--scope))))))))))))
(define IdrisC-45Parser-implDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-visOpt arg-0)) (lambda (u--visOpts) (vector 10 0 1 (IdrisC-45Parser-getVisibility '() u--visOpts) (lambda (u--vis) (let ((u--opts (DataC-45List-mapMaybe (lambda (eta-0) (DataC-45Either-getRight eta-0)) u--visOpts))) (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 12 0 1 (LibrariesC-45TextC-45Parser-option 1 0 (IdrisC-45Parser-decoratedKeyword arg-0 "implementation")) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "[")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decorate arg-0 2 (ParserC-45RuleC-45Source-name)))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-0 "]"))))) (lambda (u--iname) (vector 10 0 1 (IdrisC-45Parser-implBinds arg-0 arg-1) (lambda (u--impls) (vector 10 0 1 (IdrisC-45Parser-constraints arg-0 arg-1) (lambda (u--cons) (vector 9 0 (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-simpleExpr arg-0 arg-1)) (lambda (u--params) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 '() (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "using")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some (IdrisC-45Parser-decorate arg-0 2 (ParserC-45RuleC-45Source-name)))))))) (lambda (u--nusing) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "where")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-blockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))))))) (lambda (u--body) (vector 0 (lambda (u--fc) (vector 7 u--fc u--vis u--opts 0 u--impls u--cons u--n u--params u--iname u--nusing (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-50) eta-0))) u--body)))))))))))))))))))))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-0 u--b))))))))))
(define IdrisC-45Parser-implBinds (lambda (arg-0 arg-1) (vector 13 1 0 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 1 (IdrisC-45Parser-decorate arg-0 5 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "->") (lambda () (vector 10 0 0 (IdrisC-45Parser-implBinds arg-0 arg-1) (lambda (u--more) (vector 0 (cons (cons u--n (cons u--rig u--tm)) u--more)))))))))))))))))))) (lambda () (vector 0 '())))))
(define IdrisC-45Parser-ifaceParam (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "(") (lambda () (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-decorate arg-0 5 (ParserC-45RuleC-45Source-name))) (lambda () (lambda (u--ns) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 0 (cons (DataC-45List1-forget u--ns) (cons u--rig u--tm))))))))))))))))) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-decorate arg-0 5 (ParserC-45RuleC-45Source-name))) (lambda () (lambda (u--n) (vector 0 (cons (cons (let ((e-1 (vector-ref u--n 0))) e-1) '()) (cons (csegen-21) (vector 26 (CoreC-45FC-boundToFC arg-0 u--n))))))))))))
(define IdrisC-45Parser-ifaceDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 10 0 1 (IdrisC-45Parser-visibility arg-0) (lambda (u--vis) (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "interface") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (IdrisC-45Parser-constraints arg-0 arg-1) (lambda (u--cons) (vector 9 1 (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-ifaceParam arg-0 arg-1)) (lambda (u--paramss) (let ((u--params (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--map_Functor_List (lambda (n-0) (cons n-0 e-3)) e-2)))) u--paramss))) (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 '() (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "|")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-decorate arg-0 5 (ParserC-45RuleC-45Source-name))))))) (lambda (u--det) (vector 11 0 (IdrisC-45Parser-decoratedKeyword arg-0 "where") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (IdrisC-45Parser-recordConstructor arg-0)) (lambda (u--dc) (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda (u--body) (vector 0 (lambda (u--fc) (vector 6 u--fc u--vis u--cons u--n u--doc u--params u--det u--dc (IdrisC-45Parser-collectDefs (PreludeC-45Interfaces-concat (csegen-50) u--body))))))))))))))))))))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-0 u--b)))))))))
(define IdrisC-45Parser-if_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "if") (lambda () (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--x) (vector 11 1 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "then") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--t) (vector 11 1 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "else") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--e) (vector 0 (cons u--x (cons u--t u--e))))))))))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 43 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-6 e-7))))))))))))))
(define IdrisC-45Parser-iOperator(blodwen-lazy (lambda () (vector 13 1 1 (ParserC-45RuleC-45Source-operator) (lambda () (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-symbol "`")) (csegen-2374))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol "`")))))))))
(define IdrisC-45Parser-help(blodwen-lazy (lambda () (cons (cons (cons "<expr>" '()) (cons (vector 0 ) "Evaluate an expression")) (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons (PreludeC-45Types-u--map_Functor_List (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 ":" arg-0)) e-2) (cons e-6 e-10)))))))) (IdrisC-45Parser-parserCommandsForHelp))))))
(define IdrisC-45Parser-getVisibility (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (vector 0 0) (let ((e-8 (car arg-1))) (let ((e-9 (cdr arg-1))) (case (vector-ref e-8 0) ((0) (let ((e-12 (vector-ref e-8 1))) (IdrisC-45Parser-getVisibility (box e-12) e-9)))(else (let ((e-2 (cdr arg-1))) (IdrisC-45Parser-getVisibility arg-0 e-2))))))) (let ((e-5 (unbox arg-0))) (if (null? arg-1) (vector 0 e-5) (let ((e-15 (car arg-1))) (case (vector-ref e-15 0) ((0) (vector 4 '() 1 "Multiple visibility modifiers"))(else (let ((e-2 (cdr arg-1))) (IdrisC-45Parser-getVisibility arg-0 e-2))))))))))
(define IdrisC-45Parser-getInitRange (lambda (arg-0) (if (null? arg-0) (vector 4 '() 1 "Invalid list range syntax") (let ((e-1 (car arg-0))) (let ((e-2 (cdr arg-0))) (if (null? e-2) (vector 0 (cons (let ((e-5 (vector-ref e-1 0))) e-5) '())) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (if (null? e-6) (vector 0 (cons (let ((e-7 (vector-ref e-1 0))) e-7) (box (let ((e-7 (vector-ref e-5 0))) e-7)))) (vector 4 '() 1 "Invalid list range syntax"))))))))))
(define IdrisC-45Parser-gadtData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (vector 11 1 (vector 8 (IdrisC-45Parser-decoratedSymbol arg-1 ":")) (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-1 arg-5) (lambda () (lambda (u--ty) (IdrisC-45Parser-dataBody arg-1 arg-2 arg-3 (let ((e-1 (vector-ref arg-4 0))) e-1) arg-5 u--ty)))))))))
(define IdrisC-45Parser-forall_ (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "forall") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 14 (IdrisC-45Parser-decoratedSimpleBinderName arg-0))) (lambda () (lambda (u--ns) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (u--n) (cons (csegen-21) (cons (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (box (vector 1 (vector 0 eta-0)))) u--n) (vector 25 (CoreC-45FC-boundToFC arg-0 u--n))))) (DataC-45List1-forget u--ns)))))))))) (lambda () (lambda (u--b) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return a forall quantifier" (IdrisC-45Parser-decoratedSymbol arg-0 ".")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-pibindAll arg-0 (vector 0 ) (let ((e-1 (vector-ref u--b 0))) e-1) u--scope))))))))))))
(define IdrisC-45Parser-fnOpt (lambda (arg-0) (vector 9 0 (IdrisC-45Parser-totalityOpt arg-0) (lambda () (lambda (u--x) (vector 0 (vector 0 (vector 7 u--x))))))))
(define IdrisC-45Parser-fnDirectOpt (lambda (arg-0) (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "hint") (lambda () (vector 0 (vector 0 (vector 2 1))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "globalhint") (lambda () (vector 0 (vector 0 (vector 3 0))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "defaulthint") (lambda () (vector 0 (vector 0 (vector 3 1))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "inline") (lambda () (vector 12 0 0 (vector 7 ) (vector 0 (vector 0 (vector 0 )))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "tcinline") (lambda () (vector 12 0 0 (vector 7 ) (vector 0 (vector 0 (vector 1 )))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "extern") (lambda () (vector 0 (vector 0 (vector 4 ))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "macro") (lambda () (vector 0 (vector 0 (vector 8 ))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "spec") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (ParserC-45RuleC-45Source-name)) (lambda (u--ns) (vector 0 (vector 0 (vector 9 u--ns))))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-pragma "foreign") (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 eta-0))) (lambda (u--cs) (vector 0 (vector 1 u--cs))))))))))))))))))))))))
(define IdrisC-45Parser-fixDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 9 1 (IdrisC-45Parser-decorate arg-0 4 (IdrisC-45Parser-fix)) (lambda () (lambda (u--fixity) (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-intLit)) (lambda () (lambda (u--prec) (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-iOperator)) (lambda () (lambda (u--ops) (vector 0 (cons u--fixity (cons u--prec u--ops)))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 10 (CoreC-45FC-boundToFC arg-0 u--b) e-2 (PreludeC-45Types-u--fromInteger_Num_Nat e-6) eta-0)) (DataC-45List1-forget e-7))))))))))))))
(define IdrisC-45Parser-fix(blodwen-lazy (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-keyword "infixl") 0) (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-keyword "infixr") 1) (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-keyword "infix") 2) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-keyword "prefix") 3))))))))))
(define IdrisC-45Parser-fieldDecl (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 (vector 0 ) (PreludeC-45Interfaces-C-60C-36 (csegen-352) (vector 2 ) (IdrisC-45Parser-decoratedKeyword arg-0 "auto"))) (lambda (u--impl) (vector 9 1 (IdrisC-45Parser-n--23042-15573-u--fieldBody arg-1 arg-0 u--doc u--impl) (lambda () (lambda (u--fs) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 u--fs)))))))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 9 0 (IdrisC-45Parser-n--23042-15573-u--fieldBody arg-1 arg-0 u--doc (vector 1 )) (lambda () (lambda (u--fs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 u--fs)))))))))))
(define IdrisC-45Parser-field (lambda (arg-0 arg-1 arg-2) (vector 9 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (IdrisC-45Parser-n--10930-9230-u--fieldName arg-2 arg-1 arg-0 eta-1)) eta-0)) (vector 10 1 0 (vector 10 0 1 (vector 0 (csegen-113)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decorate arg-1 2 (ParserC-45RuleC-45Source-name))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-n--10930-9231-u--recFieldCompat arg-2 arg-1 arg-0)))))) (lambda () (lambda (u--path) (vector 9 1 (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (cond ((equal? arg-0 1) (IdrisC-45Parser-decoratedSymbol arg-1 "=")) (else (IdrisC-45Parser-decoratedSymbol arg-1 ":="))) (lambda (eta-0) (lambda (eta-1) (vector 0 eta-0 eta-1)))) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedSymbol arg-1 "$=") (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0 eta-1)))))) (lambda () (lambda (u--upd) (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-plhs) arg-1 arg-2) (lambda () (lambda (u--val) (vector 0 ((u--upd u--path) u--val)))))))))))))
(define IdrisC-45Parser-extractNames (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) (cons e-1 '()))) (else (let ((e-2 (vector-ref arg-0 1))) (cons e-2 '()))))))
(define IdrisC-45Parser-extension(blodwen-lazy (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-exactIdent "ElabReflection") 0) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-exactIdent "Borrowing") 1))))))
(define IdrisC-45Parser-exprArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26517-19050-u--names arg-2 arg-1 arg-0) (cons (vector 2 ) (cons arg-2 (IdrisC-45Parser-n--26517-19051-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-expr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (IdrisC-45Parser-let_ arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-rewrite_ arg-1 arg-2) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (csegen-3325) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-1 arg-2))))) (lambda () (lambda (u--b) (vector 0 (vector 20 (CoreC-45FC-boundToFC arg-1 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (IdrisC-45Parser-opExpr arg-0 arg-1 arg-2)))))))))
(define IdrisC-45Parser-explicitPi (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (IdrisC-45Parser-parens 1 arg-0 (IdrisC-45Parser-pibindList arg-0 arg-1))) (lambda () (lambda (u--b) (vector 9 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return a named argument" (IdrisC-45Parser-bindSymbol arg-0)) (lambda () (lambda (u--exp) (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-pibindAll arg-0 u--exp (let ((e-1 (vector-ref u--b 0))) e-1) u--scope)))))))))))))
(define IdrisC-45Parser-eval(blodwen-lazy (lambda () (vector 9 0 (csegen-3269) (lambda () (lambda (u--tm) (vector 0 (vector 1 u--tm))))))))
(define IdrisC-45Parser-editCmd(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-replCmd (cons "typeat" '())) (lambda () (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--line) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--col) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 0 (blodwen-toSignedInt u--line 63) (blodwen-toSignedInt u--col 63) u--n))))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-replCmd (cons "cs" '())) (lambda () (vector 10 0 1 (csegen-3489) (lambda (u--upd) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--line) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--col) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 1 u--upd (blodwen-toSignedInt u--line 63) (blodwen-toSignedInt u--col 63) u--n))))))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-replCmd (cons "ac" '())) (lambda () (vector 10 0 1 (csegen-3489) (lambda (u--upd) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--line) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 2 u--upd (blodwen-toSignedInt u--line 63) u--n)))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-replCmd (cons "ps" (cons "proofsearch" '()))) (lambda () (vector 10 0 1 (csegen-3489) (lambda (u--upd) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--line) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 3 u--upd (blodwen-toSignedInt u--line 63) u--n '())))))))))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-replCmd (cons "psnext" '())) (lambda () (vector 0 (vector 4 )))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-replCmd (cons "gd" '())) (lambda () (vector 10 0 1 (csegen-3489) (lambda (u--upd) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--line) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 0 (ParserC-45RuleC-45Source-intLit)) (lambda (u--nreject) (vector 0 (vector 5 u--upd (blodwen-toSignedInt u--line 63) u--n (PreludeC-45Types-u--fromInteger_Num_Nat u--nreject))))))))))))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-replCmd (cons "gdnext" '())) (lambda () (vector 0 (vector 6 )))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-replCmd (cons "ml" (cons "makelemma" '()))) (lambda () (vector 10 0 1 (csegen-3489) (lambda (u--upd) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--line) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 7 u--upd (blodwen-toSignedInt u--line 63) u--n)))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-replCmd (cons "mc" (cons "makecase" '()))) (lambda () (vector 10 0 1 (csegen-3489) (lambda (u--upd) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--line) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 8 u--upd (blodwen-toSignedInt u--line 63) u--n)))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-replCmd (cons "mw" (cons "makewith" '()))) (lambda () (vector 10 0 1 (csegen-3489) (lambda (u--upd) (vector 9 1 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--line) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 9 u--upd (blodwen-toSignedInt u--line 63) u--n)))))))))))) (lambda () (vector 4 '() 1 "Unrecognised command"))))))))))))))))))))))))
(define IdrisC-45Parser-dpairType (lambda (arg-1 arg-2 arg-3) (vector 9 1 (vector 14 (vector 9 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-1)) (lambda () (lambda (u--x) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-1 arg-3) (lambda () (lambda (u--ty) (vector 0 (cons u--x u--ty))))))))))) (lambda () (lambda (u--loc) (vector 10 0 1 (vector 0 (let ((e-1 (vector-ref u--loc 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "**")) (lambda () (lambda (u--op) (vector 9 0 (vector 14 (vector 13 1 1 (IdrisC-45Parser-nestedDpair arg-1 u--loc arg-3) (lambda () (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-1 arg-3)))) (lambda () (lambda (u--rest) (vector 0 (vector 41 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest)) (CoreC-45FC-boundToFC arg-1 u--op) (vector 0 (CoreC-45FC-boundToFC arg-1 u--loc) e-2) e-3 (let ((e-1 (vector-ref u--rest 0))) e-1))))))))))))))))))
(define IdrisC-45Parser-doBlock (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-keyword "do")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-doAct arg-0 eta-0))))))) (lambda () (lambda (u--b) (vector 12 0 0 (vector 7 ) (vector 0 (vector 35 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--b)) '() (PreludeC-45Interfaces-concat (csegen-50) (let ((e-1 (vector-ref u--b 0))) e-1)))))))) (lambda () (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-namespacedIdent)) (lambda () (lambda (u--nsdo) (let ((e-1 (vector-ref u--nsdo 0))) (if (null? e-1) (vector 4 '() 0 "Not a namespaced 'do'") (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (cond ((equal? e-4 "do") (vector 12 0 0 (vector 7 ) (vector 10 0 0 (vector 14 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-doAct arg-0 eta-0)))) (lambda (u--actions) (let ((u--fc (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds u--nsdo u--actions))))) (vector 0 (vector 35 u--fc e-5 (PreludeC-45Interfaces-concat (csegen-50) (let ((e-8 (vector-ref u--actions 0))) e-8)))))))))(else (vector 4 '() 0 "Not a namespaced 'do'"))))))))))))))
(define IdrisC-45Parser-doAct (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (vector 14 (vector 13 1 1 (ParserC-45RuleC-45Source-name) (lambda () (PreludeC-45Interfaces-C-60C-36 (csegen-352) (vector 1 (vector 2 )) (ParserC-45RuleC-45Source-symbol "_"))))) (lambda () (lambda (u--n) (vector 12 0 1 (IdrisC-45Parser-validPatternVar (let ((e-1 (vector-ref u--n 0))) e-1)) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "<-") (lambda () (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--val) (vector 0 (cons u--n u--val)))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (IdrisC-45Parser-case--doAct-9938 arg-1 arg-0 u--b (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "let") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-letBlock arg-0 eta-0))) (lambda () (lambda (u--res) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (IdrisC-45ParserC-45Let-mkDoLets arg-0 u--res))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "rewrite")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (cons (vector 6 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)) '())))))) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-expr (IdrisC-45Parser-plhs) arg-0 arg-1)) (lambda () (lambda (u--e) (vector 13 0 1 (PreludeC-45Interfaces-C-36C-62 (csegen-356) (ParserC-45RuleC-45Source-atEnd arg-1) (cons (vector 0 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--e)) (let ((e-1 (vector-ref u--e 0))) e-1)) '())) (lambda () (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "<-")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (vector 10 1 0 (vector 10 0 1 (csegen-3300) (lambda (f-0) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 f-0 (IdrisC-45Parser-expr (IdrisC-45Parser-pnowith) arg-0 arg-1)))) (lambda (f-0) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 f-0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-patAlt arg-0 eta-0)))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (let ((e-1 (vector-ref u--b 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (let ((u--fc (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds u--e u--b))))) (vector 0 (cons (vector 2 u--fc (let ((e-8 (vector-ref u--e 0))) e-8) e-5 e-4) '())))))))))))))))))))))))
(define IdrisC-45Parser-directiveDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-directive arg-0 arg-1) (lambda () (lambda (u--d) (vector 0 (lambda (u--fc) (vector 14 u--fc u--d)))))) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-pragma "runElab") (lambda () (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--tm) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (lambda (u--fc) (vector 5 u--fc u--tm)))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-0 u--b)))))))))
(define IdrisC-45Parser-directive (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "hide")) (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 0 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "logging")) (lambda () (vector 9 0 (IdrisC-45Parser-logLevel) (lambda () (lambda (u--lvl) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 1 u--lvl)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "auto_lazy")) (lambda () (vector 9 0 (IdrisC-45Parser-onoff) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 2 u--b)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "unbound_implicits")) (lambda () (vector 9 0 (IdrisC-45Parser-onoff) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 3 u--b)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "prefix_record_projections")) (lambda () (vector 9 0 (IdrisC-45Parser-onoff) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 17 u--b)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "ambiguity_depth")) (lambda () (vector 9 0 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-intLit)) (lambda () (lambda (u--lvl) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 4 (PreludeC-45Types-u--fromInteger_Num_Nat u--lvl))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "auto_implicit_depth")) (lambda () (vector 9 0 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-intLit)) (lambda () (lambda (u--dpt) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 18 (PreludeC-45Types-u--fromInteger_Num_Nat u--dpt))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "nf_metavar_threshold")) (lambda () (vector 9 0 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-intLit)) (lambda () (lambda (u--dpt) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 19 (PreludeC-45Types-u--fromInteger_Num_Nat u--dpt))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "search_timeout")) (lambda () (vector 9 0 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-intLit)) (lambda () (lambda (u--t) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 20 u--t)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "pair")) (lambda () (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--ty) (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--f) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--s) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 5 u--ty u--f u--s)))))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "rewrite")) (lambda () (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--eq) (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--rw) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 6 u--eq u--rw))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "integerLit")) (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 7 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "stringLit")) (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 8 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "charLit")) (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 9 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "doubleLit")) (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 10 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "name")) (lambda () (vector 9 1 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-decoratedSimpleBinderName arg-0)) (lambda () (lambda (u--ns) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 12 u--n (DataC-45List1-forget u--ns)))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "start")) (lambda () (vector 9 0 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--e) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 13 u--e)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "allow_overloads")) (lambda () (vector 9 0 (ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 14 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "language")) (lambda () (vector 9 0 (IdrisC-45Parser-extension) (lambda () (lambda (u--e) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 15 u--e)))))))) (lambda () (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma "default")) (lambda () (vector 9 0 (IdrisC-45Parser-totalityOpt arg-0) (lambda () (lambda (u--tot) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 16 u--tot))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-dependentDecorate (lambda (arg-1 arg-2 arg-3) (vector 9 0 (vector 14 arg-2) (lambda () (lambda (u--res) (vector 12 0 0 (vector 16 (cons (cons (cons arg-1 (cons (LibrariesC-45TextC-45Bounded-start u--res) (LibrariesC-45TextC-45Bounded-end u--res))) (cons (arg-3 (let ((e-1 (vector-ref u--res 0))) e-1)) '())) '())) (vector 0 (let ((e-1 (vector-ref u--res 0))) e-1))))))))
(define IdrisC-45Parser-definition (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (IdrisC-45Parser-clause 0 '() arg-0 arg-1)) (lambda () (lambda (u--nd) (vector 0 (vector 1 (CoreC-45FC-boundToFC arg-0 u--nd) (cons (let ((e-1 (vector-ref u--nd 0))) e-1) '()))))))))
(define IdrisC-45Parser-defaultImplicitPi (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "default") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--t) (vector 9 1 (IdrisC-45Parser-pibindList arg-0 arg-1) (lambda () (lambda (u--binders) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 (cons u--t u--binders)))))))))))))))) (lambda () (lambda (u--b) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return a default implicit argument" (IdrisC-45Parser-decoratedSymbol arg-0 "->")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (let ((e-1 (vector-ref u--b 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (IdrisC-45Parser-pibindAll arg-0 (vector 3 e-5) e-4 u--scope)))))))))))))))
(define IdrisC-45Parser-decorationFromBounded (lambda (arg-1 arg-2 arg-3) (cons (cons arg-1 (cons (LibrariesC-45TextC-45Bounded-start arg-3) (LibrariesC-45TextC-45Bounded-end arg-3))) (cons arg-2 '()))))
(define IdrisC-45Parser-decoratedSymbol (lambda (arg-0 arg-1) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-symbol arg-1))))
(define IdrisC-45Parser-decoratedSimpleNamedArg (lambda (arg-0) (vector 13 1 1 (IdrisC-45Parser-decorate arg-0 5 (ParserC-45RuleC-45Source-unqualifiedName)) (lambda () (IdrisC-45Parser-parens 1 arg-0 (IdrisC-45Parser-decorate arg-0 5 (ParserC-45RuleC-45Source-unqualifiedOperatorName)))))))
(define IdrisC-45Parser-decoratedSimpleBinderName (lambda (arg-0) (IdrisC-45Parser-decorate arg-0 5 (ParserC-45RuleC-45Source-unqualifiedName))))
(define IdrisC-45Parser-decoratedKeyword (lambda (arg-0 arg-1) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-keyword arg-1))))
(define IdrisC-45Parser-decoratedDataTypeName (lambda (arg-0) (IdrisC-45Parser-decorate arg-0 1 (vector 13 1 1 (ParserC-45RuleC-45Source-opNonNS) (lambda () (ParserC-45RuleC-45Source-capitalisedName))))))
(define IdrisC-45Parser-decoratedDataConstructorName (lambda (arg-0) (IdrisC-45Parser-decorate arg-0 3 (ParserC-45RuleC-45Source-dataConstructorName))))
(define IdrisC-45Parser-decorateKeywords (lambda (arg-1 ext-0) (vector 16 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Parser-decorationFromBounded arg-1 4 eta-0)) ext-0))))
(define IdrisC-45Parser-decorateBoundedNames (lambda (arg-0 arg-1 arg-2) (vector 16 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45Parser-boundedNameDecoration arg-0 arg-1 eta-0)) arg-2))))
(define IdrisC-45Parser-decorate (lambda (arg-1 arg-2 arg-3) (vector 9 0 (vector 14 arg-3) (lambda () (lambda (u--res) (vector 12 0 0 (vector 16 (cons (cons (cons arg-1 (cons (LibrariesC-45TextC-45Bounded-start u--res) (LibrariesC-45TextC-45Bounded-end u--res))) (cons arg-2 '())) '())) (vector 0 (let ((e-1 (vector-ref u--res 0))) e-1))))))))
(define IdrisC-45Parser-declsArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26568-19103-u--names arg-2 arg-1 arg-0) (cons (vector 3 ) (cons arg-2 (IdrisC-45Parser-n--26568-19104-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-dataOpt(blodwen-lazy (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-exactIdent "noHints") (vector 1 )) (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-exactIdent "uniqueSearch") (vector 2 )) (lambda () (vector 13 1 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-exactIdent "search")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 0 eta-0)) (csegen-2422))))) (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-exactIdent "external") (vector 3 )) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-exactIdent "noNewtype") (vector 4 )))))))))))))
(define IdrisC-45Parser-dataDeclBody (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "data") (lambda () (vector 9 0 (vector 8 (vector 14 (IdrisC-45Parser-decoratedDataTypeName arg-0))) (lambda () (lambda (u--n) (vector 0 (cons u--col u--n)))))))))) (lambda () (lambda (u--b) (vector 10 0 1 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 13 1 1 (IdrisC-45Parser-simpleData arg-0 u--b e-3 arg-1) (lambda () (IdrisC-45Parser-gadtData arg-0 e-2 u--b e-3 arg-1))))))))))))
(define IdrisC-45Parser-dataDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 10 0 1 (IdrisC-45Parser-visibility arg-0) (lambda (u--vis) (vector 9 0 (IdrisC-45Parser-dataDeclBody arg-0 arg-1) (lambda () (lambda (u--dat) (vector 0 (cons u--doc (cons u--vis u--dat))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 2 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-6 e-7)))))))))))))
(define IdrisC-45Parser-dataBody (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector 13 0 1 (vector 12 0 0 (ParserC-45RuleC-45Source-atEndIndent arg-5) (vector 0 (vector 1 (CoreC-45FC-boundToFC arg-1 arg-3) arg-4 arg-6))) (lambda () (vector 9 0 (vector 14 (vector 11 0 (IdrisC-45Parser-decoratedKeyword arg-1 "where") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 '() (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-1 "[")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-1 ",") (IdrisC-45Parser-dataOpt))))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-1 "]"))))) (lambda (u--opts) (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter arg-2 (lambda (eta-0) (IdrisC-45Parser-tyDecls (vector 8 (IdrisC-45Parser-decoratedDataConstructorName arg-1)) "" arg-1 eta-0))) (lambda (u--cs) (vector 0 (cons u--opts (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (DataC-45List1-forget eta-0)) u--cs)))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 0 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-3 u--b)) arg-4 arg-6 e-2 e-3)))))))))))))
(define IdrisC-45Parser-continueWithDecorated (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-mustContinue arg-1 (box arg-2))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-0 arg-2))))))
(define IdrisC-45Parser-continueWith (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-mustContinue arg-0 (box arg-1))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol arg-1))))))
(define IdrisC-45Parser-constraints (lambda (arg-0 arg-1) (vector 13 1 0 (vector 9 1 (IdrisC-45Parser-appExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "=>") (lambda () (vector 10 0 0 (IdrisC-45Parser-constraints arg-0 arg-1) (lambda (u--more) (vector 0 (cons (cons '() u--tm) u--more))))))))) (lambda () (vector 13 1 0 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "(") (lambda () (vector 9 1 (IdrisC-45Parser-decorate arg-0 5 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "=>") (lambda () (vector 10 0 0 (IdrisC-45Parser-constraints arg-0 arg-1) (lambda (u--more) (vector 0 (cons (cons (box u--n) u--tm) u--more)))))))))))))))))) (lambda () (vector 0 '())))))))
(define IdrisC-45Parser-compileArgsCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26853-19402-u--names arg-2 arg-1 arg-0) (cons (vector 11 (cons (vector 7 ) (cons (vector 2 ) '()))) (cons arg-2 (IdrisC-45Parser-n--26853-19403-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-commitKeyword (lambda (arg-0 arg-1 arg-2) (vector 12 0 1 (ParserC-45RuleC-45Source-mustContinue arg-1 (box arg-2)) (vector 11 0 (IdrisC-45Parser-decoratedKeyword arg-0 arg-2) (lambda () (ParserC-45RuleC-45Source-mustContinue arg-1 '()))))))
(define IdrisC-45Parser-command(blodwen-lazy (lambda () (vector 13 0 1 (PreludeC-45Interfaces-C-36C-62 (csegen-356) (ParserC-45RuleC-45Source-eoi) (vector 32 )) (lambda () (vector 13 1 1 (IdrisC-45Parser-nonEmptyCommand) (lambda () (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (ParserC-45RuleC-45Source-symbol ":?") (vector 11 )) (lambda () (vector 13 1 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-symbol ":")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (vector 28 eta-0)) (IdrisC-45Parser-editCmd))))) (lambda () (IdrisC-45Parser-eval))))))))))))
(define IdrisC-45Parser-collectDefs (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (IdrisC-45Parser-case--collectDefs-17290 e-6 e-5 e-3 (DataC-45List-spanBy (lambda (eta-0) (IdrisC-45Syntax-isPDef eta-0)) e-3))))) ((11) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (cons (vector 11 e-8 e-9 (IdrisC-45Parser-collectDefs e-10)) (IdrisC-45Parser-collectDefs e-3)))))) ((9) (let ((e-12 (vector-ref e-2 1))) (let ((e-13 (vector-ref e-2 2))) (cons (vector 9 e-12 (IdrisC-45Parser-collectDefs e-13)) (IdrisC-45Parser-collectDefs e-3)))))(else (cons e-2 (IdrisC-45Parser-collectDefs e-3)))))))))
(define IdrisC-45Parser-clause (lambda (arg-0 arg-1 arg-2 arg-3) (vector 9 1 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-column) (lambda (u--col) (vector 9 0 (IdrisC-45Parser-n--18544-11476-u--clauseLHS arg-3 arg-2 arg-0 arg-1 arg-2 arg-3 arg-1) (lambda () (lambda (u--lhsws) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-n--18544-11477-u--parseWithArg arg-3 arg-2 arg-0 arg-1)) (lambda (u--extra) (vector 0 (cons u--col (let ((e-2 (car u--lhsws))) (let ((e-3 (cdr u--lhsws))) (cons e-2 (PreludeC-45TypesC-45List-tailRecAppend e-3 u--extra)))))))))))))) (lambda () (lambda (u--b) (let ((u--col (Builtin-fst (let ((e-1 (vector-ref u--b 0))) e-1)))) (let ((u--lhs (Builtin-snd (let ((e-1 (vector-ref u--b 0))) e-1)))) (let ((u--extra (Builtin-snd u--lhs))) (let ((sc0 (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-0 (PreludeC-45TypesC-45List-length u--extra)))) (cond ((equal? sc0 1) (vector 4 '() 1 (PreludeC-45TypesC-45String-C-43C-43 "Wrong number of 'with' arguments:" (PreludeC-45TypesC-45String-C-43C-43 " expected " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-0) (PreludeC-45TypesC-45String-C-43C-43 " but got " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length u--extra)))))))) (else (IdrisC-45Parser-parseRHS arg-0 arg-2 u--b u--col arg-3 u--lhs))))))))))))
(define IdrisC-45Parser-claims (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation)) (lambda (u--doc) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-visOpt arg-0)) (lambda (u--visOpts) (vector 10 0 1 (IdrisC-45Parser-getVisibility '() u--visOpts) (lambda (u--vis) (let ((u--opts (DataC-45List-mapMaybe (lambda (eta-0) (DataC-45Either-getRight eta-0)) u--visOpts))) (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 0 (IdrisC-45Parser-tyDecls (IdrisC-45Parser-dependentDecorate arg-0 (ParserC-45RuleC-45Source-name) (lambda (u--nm) (let ((sc0 (CoreC-45Name-isUnsafeBuiltin u--nm))) (cond ((equal? sc0 1) 7) (else 2))))) u--doc arg-0 arg-1) (lambda () (lambda (u--cls) (vector 0 (DataC-45List1-u--map_Functor_List1 (lambda (u--cl) (cons u--doc (cons u--vis (cons u--opts (cons u--rig u--cl))))) u--cls))))))))))))))) (lambda () (lambda (u--bs) (vector 0 (DataC-45List1-u--map_Functor_List1 (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 0 (CoreC-45FC-boundToFC arg-0 u--bs) e-14 e-6 e-10 e-15))))))))) (let ((e-1 (vector-ref u--bs 0))) e-1))))))))
(define IdrisC-45Parser-case_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "case") (lambda () (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-0 arg-1) (lambda () (lambda (u--scr) (vector 11 0 (vector 8 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "of")) (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-caseAlt arg-0 eta-0))) (lambda (u--alts) (vector 0 (cons u--scr u--alts)))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 4 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--b)) e-2 e-3)))))))))))
(define IdrisC-45Parser-caseRHS (lambda (arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-1 "=>")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-mustContinue arg-3 '()))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-1 arg-3))))) (lambda () (lambda (u--rhs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-3) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rhs)))) (vector 0 (vector 0 u--fc arg-4 (let ((e-1 (vector-ref u--rhs 0))) e-1) '()))))))) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-1 "impossible")) (lambda () (lambda (u--end) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-3) (vector 0 (vector 2 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--end)) arg-4))))))))))
(define IdrisC-45Parser-caseAlt (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (IdrisC-45Parser-opExpr (IdrisC-45Parser-plhs) arg-0 arg-1)) (lambda () (lambda (u--lhs) (IdrisC-45Parser-caseRHS arg-0 u--lhs arg-1 (let ((e-1 (vector-ref u--lhs 0))) e-1)))))))
(define IdrisC-45Parser-builtinDecl (lambda (arg-0 arg-1) (vector 9 0 (csegen-2411) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3)))))))))))
(define IdrisC-45Parser-bracketedExpr (lambda (arg-1 arg-2 arg-3) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (vector 14 (IdrisC-45Parser-iOperator)) (lambda () (lambda (u--op) (vector 9 1 (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-1 arg-3) (lambda () (lambda (u--e) (vector 11 0 (IdrisC-45Parser-continueWithDecorated arg-1 arg-3 ")") (lambda () (vector 0 (cons u--op u--e))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 12 0 0 (vector 16 (cons (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '())) '())) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--b)))) (let ((u--opFC (CoreC-45FC-boundToFC arg-1 e-2))) (vector 0 (vector 29 u--fc u--opFC (let ((e-1 (vector-ref e-2 0))) e-1) e-3)))))))))))) (lambda () (vector 13 1 1 (vector 9 1 (csegen-3315) (lambda () (lambda (u--b) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-1 ")") (lambda () (vector 12 0 0 (vector 16 (cons (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '())) '())) (let ((u--projs (PreludeC-45Types-u--map_Functor_List (lambda (u--proj) (cons (CoreC-45FC-boundToFC arg-1 u--proj) (let ((e-1 (vector-ref u--proj 0))) e-1))) (let ((e-1 (vector-ref u--b 0))) e-1)))) (vector 0 (vector 49 (CoreC-45FC-boundToFC arg-1 u--b) u--projs))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-continueWith arg-3 ")")) (lambda () (lambda (u--b) (vector 0 (vector 42 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--b))))))) (lambda () (vector 13 1 1 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (IdrisC-45Parser-dpairType arg-1 arg-2 arg-3)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decorate arg-1 1 (ParserC-45RuleC-45Source-symbol ")")))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (vector 16 (cons (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 1 '())) '()))))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-1 arg-3)) (lambda () (lambda (u--e) (vector 13 1 1 (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "**")) (lambda () (lambda (u--loc) (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 13 1 1 (IdrisC-45Parser-nestedDpair arg-1 u--loc arg-3) (lambda () (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-1 arg-3)))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol ")"))))) (lambda () (lambda (u--rest) (vector 0 (vector 41 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest)) (CoreC-45FC-boundToFC arg-1 u--loc) (let ((e-1 (vector-ref u--e 0))) e-1) (vector 25 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest))) (let ((e-1 (vector-ref u--rest 0))) e-1))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 14 (IdrisC-45Parser-iOperator))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-1 ")"))))) (lambda () (lambda (u--op) (vector 12 0 0 (vector 16 (cons (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '())) '())) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--op)))) (let ((u--opFC (CoreC-45FC-boundToFC arg-1 (let ((e-1 (vector-ref u--op 0))) e-1)))) (vector 0 (vector 30 u--fc u--opFC (let ((e-1 (vector-ref u--e 0))) e-1) (let ((e-1 (vector-ref u--op 0))) (let ((e-6 (vector-ref e-1 0))) e-6)))))))))) (lambda () (IdrisC-45Parser-tuple arg-1 arg-2 arg-3 (let ((e-1 (vector-ref u--e 0))) e-1))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--here) (let ((u--fc (vector 0 arg-1 u--here u--here))) (let ((u--var (vector 0 u--fc (vector 2 "__leftTupleSection" 0)))) (vector 9 0 (vector 14 (IdrisC-45Parser-nonEmptyTuple arg-1 arg-2 arg-3 u--var)) (lambda () (lambda (u--ts) (vector 0 (vector 2 u--fc (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) u--var (vector 26 u--fc) (let ((e-1 (vector-ref u--ts 0))) e-1))))))))))))))))))))))
(define IdrisC-45Parser-boundedNameDecoration (lambda (arg-0 arg-1 arg-2) (cons (cons arg-0 (cons (LibrariesC-45TextC-45Bounded-start arg-2) (LibrariesC-45TextC-45Bounded-end arg-2))) (cons arg-1 (box (let ((e-1 (vector-ref arg-2 0))) e-1))))))
(define IdrisC-45Parser-binder (lambda (arg-0 arg-1) (vector 13 1 1 (IdrisC-45Parser-autoImplicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-defaultImplicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-forall_ arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-implicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-explicitPi arg-0 arg-1) (lambda () (IdrisC-45Parser-lam arg-0 arg-1)))))))))))))
(define IdrisC-45Parser-bindSymbol (lambda (arg-0) (vector 13 1 1 (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedSymbol arg-0 "->") (vector 1 )) (lambda () (PreludeC-45Interfaces-C-36C-62 (csegen-352) (IdrisC-45Parser-decoratedSymbol arg-0 "=>") (vector 2 ))))))
(define IdrisC-45Parser-bindList (lambda (arg-0 arg-1) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 0 (vector 14 (IdrisC-45Parser-simpleExpr arg-0 arg-1)) (lambda () (lambda (u--pat) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 (vector 26 (CoreC-45FC-boundToFC arg-0 u--pat)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 ":")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-opExpr (IdrisC-45Parser-pdef) arg-0 arg-1))))) (lambda (u--ty) (vector 0 (cons u--rig (cons u--pat u--ty))))))))))))))
(define IdrisC-45Parser-autoNumberArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--26721-19262-u--names arg-2 arg-1 arg-0) (cons (vector 5 ) (cons arg-2 (IdrisC-45Parser-n--26721-19264-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-autoImplicitPi (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "auto") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-pibindList arg-0 arg-1) (lambda () (lambda (u--binders) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 u--binders)))))))))))) (lambda () (lambda (u--b) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return an auto implicit argument" (IdrisC-45Parser-decoratedSymbol arg-0 "->")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pdef) arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-pibindAll arg-0 (vector 2 ) (let ((e-1 (vector-ref u--b 0))) e-1) u--scope))))))))))))
(define IdrisC-45Parser-atom (lambda (arg-0) (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-exactIdent "Type"))) (lambda () (lambda (u--x) (vector 0 (vector 22 (CoreC-45FC-boundToFC arg-0 u--x)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--x) (vector 0 (vector 0 (CoreC-45FC-boundToFC arg-0 u--x) (let ((e-1 (vector-ref u--x 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-dependentDecorate arg-0 (ParserC-45RuleC-45Source-constant) (lambda (u--c) (let ((sc0 (CoreC-45TT-isPrimType u--c))) (cond ((equal? sc0 1) 1) (else 3)))))) (lambda () (lambda (u--x) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--x) (let ((e-1 (vector-ref u--x 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-0 "_")) (lambda () (lambda (u--x) (vector 0 (vector 25 (CoreC-45FC-boundToFC arg-0 u--x)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol "?")) (lambda () (lambda (u--x) (vector 0 (vector 26 (CoreC-45FC-boundToFC arg-0 u--x)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-holeName)) (lambda () (lambda (u--x) (vector 0 (vector 21 (CoreC-45FC-boundToFC arg-0 u--x) 0 (let ((e-1 (vector-ref u--x 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decorate arg-0 3 (ParserC-45RuleC-45Source-pragma "MkWorld"))) (lambda () (lambda (u--x) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--x) (vector 13 )))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-pragma "World"))) (lambda () (lambda (u--x) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--x) (vector 27 )))))) (lambda () (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-pragma "search")) (lambda () (lambda (u--x) (vector 0 (vector 14 (CoreC-45FC-boundToFC arg-0 u--x) (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-argExpr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (vector 9 0 (IdrisC-45Parser-simpleExpr arg-1 arg-2) (lambda () (lambda (u--arg) (case (vector-ref u--arg 0) ((21) (let ((e-1 (vector-ref u--arg 1))) (let ((e-3 (vector-ref u--arg 3))) (vector 0 (cons (vector 0 (vector 21 e-1 1 e-3)) '())))))(else (vector 0 (cons (vector 0 u--arg) '())))))))) (lambda () (vector 13 1 1 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (IdrisC-45Parser-n--10879-3889-u--braceArgs arg-2 arg-1 arg-0 arg-1 arg-2)) (let ((sc0 (let ((e-1 (cdr arg-0))) e-1))) (cond ((equal? sc0 1) (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "|") (lambda () (vector 9 0 (IdrisC-45Parser-expr (let ((e-0 (car arg-0))) (cons e-0 0)) arg-1 arg-2) (lambda () (lambda (u--arg) (vector 0 (cons (vector 3 u--arg) '())))))))))) (else (lambda () (vector 4 '() 0 "| not allowed here"))))))))))
(define IdrisC-45Parser-appExpr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (IdrisC-45Parser-case_ arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-doBlock arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-lam arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-lazy arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-if_ arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-with_ arg-1 arg-2) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (csegen-2302) (IdrisC-45Parser-simpleExpr arg-1 arg-2)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-argExpr arg-0 arg-1 arg-2)))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (IdrisC-45Parser-n--10878-3638-u--applyExpImp arg-2 arg-1 arg-0 (LibrariesC-45TextC-45Bounded-start u--b) (LibrariesC-45TextC-45Bounded-end u--b) e-2 (PreludeC-45Interfaces-concat (csegen-50) e-3)))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (csegen-2302) (vector 14 (IdrisC-45Parser-iOperator))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-expr (IdrisC-45Parser-pdef) arg-1 arg-2))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 28 (CoreC-45FC-boundToFC arg-1 u--b) (CoreC-45FC-boundToFC arg-1 e-2) (let ((e-1 (vector-ref e-2 0))) e-1) e-3))))))))) (lambda () (vector 4 '() 0 "Expected 'case', 'if', 'do', application or operator expression")))))))))))))))))))
(define IdrisC-45ParserC-45Let-case--mkDoLetsC-44buildDoLets-2653 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-0 (vector-ref arg-5 0))) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-1 0) ((0) (let ((e-6 (vector-ref e-1 1))) (let ((e-7 (vector-ref e-1 2))) (case (vector-ref e-7 0) ((1) (let ((e-10 (vector-ref e-7 1))) (if (null? e-4) (cons (let ((sc3 (CoreC-45Name-isPatternVariable e-10))) (cond ((equal? sc3 1) (vector 3 arg-4 e-6 (vector 1 e-10) e-0 e-2 e-3)) (else (vector 4 arg-4 (vector 0 e-6 (vector 1 e-10)) e-2 e-3 '())))) (IdrisC-45ParserC-45Let-n--7872-2640-u--buildDoLets arg-0 arg-1 arg-3)) (cons (vector 4 arg-4 e-1 e-2 e-3 e-4) (IdrisC-45ParserC-45Let-n--7872-2640-u--buildDoLets arg-0 arg-1 arg-3)))))(else (cons (vector 4 arg-4 e-1 e-2 e-3 e-4) (IdrisC-45ParserC-45Let-n--7872-2640-u--buildDoLets arg-0 arg-1 arg-3))))))) ((25) (let ((e-9 (vector-ref e-1 1))) (if (null? e-4) (cons (vector 3 arg-4 e-9 (vector 1 (vector 2 )) e-0 e-2 e-3) (IdrisC-45ParserC-45Let-n--7872-2640-u--buildDoLets arg-0 arg-1 arg-3)) (cons (vector 4 arg-4 e-1 e-2 e-3 e-4) (IdrisC-45ParserC-45Let-n--7872-2640-u--buildDoLets arg-0 arg-1 arg-3)))))(else (cons (vector 4 arg-4 e-1 e-2 e-3 e-4) (IdrisC-45ParserC-45Let-n--7872-2640-u--buildDoLets arg-0 arg-1 arg-3)))))))))))
(define IdrisC-45ParserC-45Let-n--7752-2528-u--mkLet (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (arg-4 (DataC-45List1-forget e-2)))) (else (let ((e-5 (vector-ref arg-5 1))) (let ((u--bounds (LibrariesC-45TextC-45Bounded-mergeBounds (let ((e-1 (car e-5))) e-1) (DataC-45List1-last e-5)))) (arg-3 (PreludeC-45Interfaces-C-60C-36 (csegen-360) (PreludeC-45Interfaces-concatMap (csegen-3271) (csegen-3565) e-5) u--bounds))))))))
(define IdrisC-45ParserC-45Let-n--7752-2527-u--groups (lambda (arg-1 arg-2 arg-3 arg-4) (DataC-45Either-compress (DataC-45List1-forget (DataC-45List1-u--map_Functor_List1 (lambda (u--b) (let ((e-1 (vector-ref u--b 0))) (case (vector-ref e-1 0) ((0) (let ((e-4 (vector-ref e-1 1))) (vector 0 (PreludeC-45Interfaces-C-60C-36 (csegen-360) e-4 u--b)))) (else (let ((e-5 (vector-ref e-1 1))) (vector 1 (PreludeC-45Interfaces-C-60C-36 (csegen-360) e-5 u--b))))))) arg-2)))))
(define IdrisC-45ParserC-45Let-n--7830-2604-u--buildLets (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-1 (vector-ref e-2 0))) (let ((e-0 (vector-ref e-1 0))) (let ((e-9 (vector-ref e-1 1))) (let ((e-8 (vector-ref e-1 2))) (let ((e-7 (vector-ref e-1 3))) (let ((e-6 (vector-ref e-1 4))) (let ((u--fc (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 e-2)))) (vector 3 u--fc e-0 e-9 e-8 e-7 (IdrisC-45ParserC-45Let-n--7830-2604-u--buildLets arg-0 e-3 arg-2) e-6)))))))))))))
(define IdrisC-45ParserC-45Let-n--7872-2640-u--buildDoLets (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--fc (CoreC-45FC-boundToFC arg-1 e-2))) (IdrisC-45ParserC-45Let-case--mkDoLetsC-44buildDoLets-2653 arg-0 arg-1 e-2 e-3 u--fc (let ((e-1 (vector-ref e-2 0))) e-1))))))))
(define IdrisC-45ParserC-45Let-mkLets (lambda (arg-0 ext-0 ext-1) (IdrisC-45ParserC-45Let-letFactory (lambda (eta-0) (lambda (eta-1) (IdrisC-45ParserC-45Let-n--7830-2604-u--buildLets arg-0 eta-0 eta-1))) (lambda (u--decls) (lambda (u--scope) (vector 5 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--decls)) (let ((e-1 (vector-ref u--decls 0))) e-1) u--scope))) ext-0 ext-1)))
(define IdrisC-45ParserC-45Let-mkDoLets (lambda (arg-0 arg-1) (IdrisC-45ParserC-45Let-letFactory (lambda (u--binds) (lambda (u--rest) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45ParserC-45Let-n--7872-2640-u--buildDoLets arg-1 arg-0 u--binds) u--rest))) (lambda (u--decls) (lambda (u--rest) (cons (vector 5 (CoreC-45FC-boundToFC arg-0 u--decls) (let ((e-1 (vector-ref u--decls 0))) e-1)) u--rest))) arg-1 '())))
(define IdrisC-45ParserC-45Let-letFactory (lambda (arg-1 arg-2 arg-3 arg-4) (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (IdrisC-45ParserC-45Let-n--7752-2528-u--mkLet arg-4 arg-3 arg-2 arg-1 eta-0)) arg-4 (IdrisC-45ParserC-45Let-n--7752-2527-u--groups arg-4 arg-3 arg-2 arg-1))))
(define IdrisC-45DesugarC-45Mutual-n--7445-576-u--mkRecType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (vector 22 arg-6) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 arg-6 e-10 e-14 (box e-6) e-15 (IdrisC-45DesugarC-45Mutual-n--7445-576-u--mkRecType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)))))))))))))
(define IdrisC-45DesugarC-45Mutual-splitMutual (lambda (arg-0) (cons (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl 1 eta-0)) arg-0) (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl 2 eta-0)) arg-0))))
(define IdrisC-45DesugarC-45Mutual-getDecl (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((7) (let ((e-93 (vector-ref arg-1 1))) (let ((e-94 (vector-ref arg-1 2))) (let ((e-95 (vector-ref arg-1 3))) (let ((e-97 (vector-ref arg-1 5))) (let ((e-98 (vector-ref arg-1 6))) (let ((e-99 (vector-ref arg-1 7))) (let ((e-100 (vector-ref arg-1 8))) (let ((e-101 (vector-ref arg-1 9))) (let ((e-102 (vector-ref arg-1 10))) (let ((e-103 (vector-ref arg-1 11))) (box (vector 7 e-93 e-94 e-95 arg-0 e-97 e-98 e-99 e-100 e-101 e-102 e-103))))))))))))) ((11) (let ((e-105 (vector-ref arg-1 1))) (let ((e-106 (vector-ref arg-1 2))) (let ((e-107 (vector-ref arg-1 3))) (box (vector 11 e-105 e-106 (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl arg-0 eta-0)) e-107)))))))(else (cond ((equal? arg-0 1) (case (vector-ref arg-1 0) ((0) (box arg-1)) ((2) (let ((e-15 (vector-ref arg-1 1))) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (let ((e-18 (vector-ref arg-1 4))) (case (vector-ref e-18 0) ((0) (let ((e-46 (vector-ref e-18 1))) (let ((e-47 (vector-ref e-18 2))) (let ((e-48 (vector-ref e-18 3))) (box (vector 2 e-15 e-16 e-17 (vector 1 e-46 e-47 e-48)))))))(else '()))))))) ((6) (box arg-1)) ((8) (let ((e-30 (vector-ref arg-1 1))) (let ((e-31 (vector-ref arg-1 2))) (let ((e-32 (vector-ref arg-1 3))) (let ((e-33 (vector-ref arg-1 4))) (let ((e-34 (vector-ref arg-1 5))) (let ((e-35 (vector-ref arg-1 6))) (let ((e-36 (vector-ref arg-1 7))) (box (vector 2 e-30 e-31 e-32 (vector 1 e-30 e-33 (IdrisC-45DesugarC-45Mutual-n--7445-576-u--mkRecType e-35 e-36 e-34 e-33 e-32 e-31 e-30 arg-1 e-34)))))))))))) ((10) (box arg-1)) ((14) (box arg-1))(else '()))) ((equal? arg-0 2) (case (vector-ref arg-1 0) ((0) '()) ((2) (let ((e-61 (vector-ref arg-1 4))) (case (vector-ref e-61 0) ((1) (box arg-1))(else (box arg-1))))) ((6) '()) ((8) (box arg-1)) ((10) '()) ((14) '())(else (box arg-1))))(else (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (box (vector 3 e-1 e-2 (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl arg-0 eta-0)) e-3))))))) ((4) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (box (vector 4 e-5 e-6 (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl arg-0 eta-0)) e-7)))))))(else (cond (else (box arg-1)))))))))))
(define IdrisC-45Desugar-with--trimMultilineC-44dropLastNL-7436 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) (case (vector-ref arg-4 0) ((0) '())(else (case (vector-ref arg-4 0) ((1) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (case (vector-ref e-1 0) ((0) (let ((e-5 (vector-ref e-1 1))) (let ((e-6 (vector-ref e-1 2))) (DataC-45List-snoc e-2 (vector 0 e-5 (Builtin-fst (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isNL eta-0)) e-6)))))))(else arg-3)))))(else arg-3)))) (case (vector-ref arg-4 0) ((1) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (case (vector-ref e-1 0) ((0) (let ((e-5 (vector-ref e-1 1))) (let ((e-6 (vector-ref e-1 2))) (DataC-45List-snoc e-2 (vector 0 e-5 (Builtin-fst (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isNL eta-0)) e-6)))))))(else arg-3)))))(else arg-3)))))
(define IdrisC-45Desugar-with--trimMultilineC-44trimLast-7307 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-3) (case (vector-ref arg-4 0) ((0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 arg-5 "Expected line wrap") eta-0)))(else (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (if (null? e-1) (lambda (eta-0) (vector 1 arg-0)) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (case (vector-ref e-6 0) ((0) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (if (null? e-7) (lambda (clam-0) (let ((sc5 (PreludeC-45Interfaces-any (csegen-51) (csegen-3566) (PreludeC-45Types-fastUnpack e-10)))) (cond ((equal? sc5 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 e-9 "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") clam-0)) (else (vector 1 e-2))))) (let ((u--fc (DataC-45Maybe-fromMaybe (lambda () arg-2) (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (eta-0) (IdrisC-45Syntax-isStrInterp eta-0)) e-1)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 u--fc "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") eta-0)))))))(else (let ((u--fc (DataC-45Maybe-fromMaybe (lambda () arg-2) (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (eta-0) (IdrisC-45Syntax-isStrInterp eta-0)) e-1)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 u--fc "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") eta-0)))))))))))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (if (null? e-1) (lambda (eta-0) (vector 1 arg-0)) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (case (vector-ref e-6 0) ((0) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (if (null? e-7) (lambda (clam-1) (let ((sc5 (PreludeC-45Interfaces-any (csegen-51) (csegen-3566) (PreludeC-45Types-fastUnpack e-10)))) (cond ((equal? sc5 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 e-9 "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") clam-1)) (else (vector 1 e-2))))) (let ((u--fc (DataC-45Maybe-fromMaybe (lambda () arg-2) (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (eta-0) (IdrisC-45Syntax-isStrInterp eta-0)) e-1)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 u--fc "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") eta-0)))))))(else (let ((u--fc (DataC-45Maybe-fromMaybe (lambda () arg-2) (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (eta-0) (IdrisC-45Syntax-isStrInterp eta-0)) e-1)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 u--fc "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") eta-0)))))))))))))
(define IdrisC-45Desugar-case--trimMultilineC-44trimLeft-7569 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (let ((sc2 (PreludeC-45Interfaces-any (csegen-51) (csegen-3566) e-2))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-u--C-60_Ord_Nat (PreludeC-45TypesC-45List-length e-2) arg-6)))))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 arg-4 "Line is less indented than the closing delimiter") clam-0)) (else (vector 1 (cons (vector 0 arg-4 (PreludeC-45Types-fastPack e-3)) arg-5))))))))))
(define IdrisC-45Desugar-case--trimMultilineC-44trimLeft-7482 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (PreludeC-45Interfaces-any (csegen-51) (csegen-3566) e-2))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 arg-4 "Line is less indented than the closing delimiter") clam-0)) (else (vector 1 (cons (vector 0 arg-4 (PreludeC-45Types-fastPack e-3)) '()))))))))))
(define IdrisC-45Desugar-case--expandStringC-44mergeStrLit-7062 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (if (null? e-2) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (cons e-10 (IdrisC-45Desugar-n--13004-7039-u--mergeStrLit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-11))))) (let ((u--fc (Builtin-fst (DataC-45List-head e-2)))) (let ((u--lit (PreludeC-45Types-fastConcat (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (Builtin-snd eta-0)) e-2)))) (cons (vector 0 u--fc u--lit) (IdrisC-45Desugar-n--13004-7039-u--mergeStrLit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)))))))))
(define IdrisC-45Desugar-case--toTokList-3973 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (clam-0) (let ((sc1 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (ParserC-45LexerC-45Source-isOpChar eta-0)) (PreludeC-45Types-fastUnpack arg-7)))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "Unknown operator '" (PreludeC-45TypesC-45String-C-43C-43 arg-7 "'"))) clam-0)) (else (let ((act-24 (IdrisC-45Desugar-toTokList arg-5 arg-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 1 arg-2) (cons (vector 0 arg-4 arg-3 arg-0 (IdrisC-45Desugar-n--12496-3956-u--backtickPrec arg-0 arg-1 arg-2 arg-3 arg-4 arg-5)) e-5))))))))))) (let ((e-2 (unbox arg-8))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (cond ((equal? e-5 3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "'" (PreludeC-45TypesC-45String-C-43C-43 arg-7 "' is a prefix operator"))) clam-0))(else (let ((act-24 (IdrisC-45Desugar-toTokList arg-5 arg-1 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (cons (vector 1 arg-2) (cons (vector 0 arg-4 arg-3 arg-0 (IdrisC-45Desugar-mkPrec e-5 e-6)) e-7))))))))))))))))
(define IdrisC-45Desugar-n--13015-7303-u--trimLeft (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (IdrisC-45Desugar-case--trimMultilineC-44trimLeft-7482 arg-0 arg-1 arg-2 e-6 e-5 arg-3 (DataC-45List-splitAt arg-3 (PreludeC-45Types-fastUnpack e-6))) (IdrisC-45Desugar-case--trimMultilineC-44trimLeft-7569 arg-0 arg-1 arg-2 e-6 e-5 e-3 arg-3 (DataC-45List-splitAt arg-3 (PreludeC-45Types-fastUnpack e-6)))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 60 arg-2 "Line is less indented than the closing delimiter") eta-0)))))))))
(define IdrisC-45Desugar-n--13015-7301-u--trimLast (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (IdrisC-45Desugar-with--trimMultilineC-44trimLast-7307 arg-4 arg-1 arg-3 arg-4 (DataC-45ListC-45Views-snocList arg-4) arg-3)))
(define IdrisC-45Desugar-n--13004-7038-u--toRawImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (lambda (eta-0) (vector 1 (vector 28 e-1 (vector 10 e-2))))))) (else (let ((e-5 (vector-ref arg-9 2))) (IdrisC-45Desugar-desugarB arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 e-5))))))
(define IdrisC-45Desugar-n--13077-9211-u--toRF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((1) (let ((e-0 (vector-ref arg-12 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (vector 1 (vector 1 e-1))))(else arg-12))))(else arg-12))))
(define IdrisC-45Desugar-n--12955-6499-u--toPure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (vector 0 arg-2 (vector 7 arg-2 (vector 0 arg-2 (CoreC-45Name-mbApplyNS arg-10 (vector 1 (vector 0 "pure")))) arg-11))))
(define IdrisC-45Desugar-n--13095-9323-u--toIDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (vector 1 (vector 2 e-1 arg-7 (cons (vector 0 e-1 e-2 e-3) '()))))))) ((1) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-8 (vector-ref arg-8 4))) (let ((e-9 (vector-ref arg-8 5))) (let ((e-10 (vector-ref arg-8 6))) (vector 1 (vector 2 e-5 arg-7 (cons (vector 1 e-5 e-6 e-7 e-8 e-9 e-10) '())))))))))) (else (let ((e-12 (vector-ref arg-8 1))) (let ((e-13 (vector-ref arg-8 2))) (vector 1 (vector 2 e-12 arg-7 (cons (vector 2 e-12 e-13) '())))))))))
(define IdrisC-45Desugar-n--13004-7041-u--strInterpolate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (vector 0 (vector 2 ) (vector 0 (CoreC-45NameC-45Namespace-preludeNS) (vector 1 (vector 0 "Nil")))) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((u--xFC (CoreC-45FC-virtualiseFC (TTImpC-45TTImp-getFC e-2)))) (TTImpC-45TTImp-apply (vector 0 u--xFC (vector 0 (CoreC-45NameC-45Namespace-preludeNS) (vector 1 (vector 0 "::")))) (cons (vector 8 u--xFC (vector 0 (vector 2 ) (vector 1 (vector 0 "interpolate"))) e-2) (cons (IdrisC-45Desugar-n--13004-7041-u--strInterpolate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) '())))))))))
(define IdrisC-45Desugar-n--13095-9846-u--pairToCons (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((40) (let ((e-2 (vector-ref arg-14 2))) (let ((e-3 (vector-ref arg-14 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Desugar-n--13095-9846-u--pairToCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2) (IdrisC-45Desugar-n--13095-9846-u--pairToCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3)))))(else (cons arg-14 '())))))
(define IdrisC-45Desugar-n--13004-7040-u--notEmpty (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-2 (vector-ref arg-9 2))) (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-2 ""))) (else 1))))
(define IdrisC-45Desugar-n--13095-10765-u--mkConName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) (let ((e-0 (vector-ref arg-12 1))) (let ((e-1 (vector-ref arg-12 2))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (let ((u--str (CoreC-45Name-displayUserName e-2))) (vector 0 e-0 (vector 4 u--str (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "__mk" u--str) 0))))))(else (vector 4 (CoreC-45Name-u--show_Show_Name arg-12) (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "__mk" (CoreC-45Name-u--show_Show_Name arg-12)) 0)))))))(else (vector 4 (CoreC-45Name-u--show_Show_Name arg-12) (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "__mk" (CoreC-45Name-u--show_Show_Name arg-12)) 0))))))
(define IdrisC-45Desugar-n--13004-7039-u--mergeStrLit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (IdrisC-45Desugar-case--expandStringC-44mergeStrLit-7062 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (DataC-45List-spanBy (lambda (eta-0) (IdrisC-45Syntax-isStrLiteral eta-0)) arg-9))))
(define IdrisC-45Desugar-n--13095-10766-u--mapDesugarPiInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-1 ext-0) (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-11 arg-10 arg-8 arg-9 1 arg-12 eta-0 eta-1))) ext-1 ext-0)))
(define IdrisC-45Desugar-n--13095-10295-u--isNamed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17) (if (null? arg-17) 0 1)))
(define IdrisC-45Desugar-n--12955-6498-u--guard (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (vector 0 e-1 (vector 7 e-1 (vector 0 e-1 (CoreC-45Name-mbApplyNS arg-10 (vector 1 (vector 0 "guard")))) e-2)))))(else arg-11))))
(define IdrisC-45Desugar-n--13095-10764-u--fname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-5 (vector-ref arg-12 4))) e-5)))
(define IdrisC-45Desugar-n--13095-9847-u--expandConstraint (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (if (null? e-2) (PreludeC-45Types-u--map_Functor_List (lambda (u--x) (cons '() u--x)) (IdrisC-45Desugar-n--13095-9846-u--pairToCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3)) (let ((e-5 (unbox e-2))) (cons (cons (box e-5) e-3) '())))))))
(define IdrisC-45Desugar-n--13015-7302-u--dropLastNL (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45Desugar-with--trimMultilineC-44dropLastNL-7436 arg-0 arg-1 arg-2 arg-3 (DataC-45ListC-45Views-snocList arg-3))))
(define IdrisC-45Desugar-n--12496-3956-u--backtickPrec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (vector 2 (+ 1 0))))
(define IdrisC-45Desugar-u--C-61C-61_Eq_Side (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0)))(else 0))))
(define IdrisC-45Desugar-trimMultiline (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_Nat arg-1 (PreludeC-45Types-u--fromInteger_Num_Nat 0)))) (cond ((equal? sc0 1) (vector 1 (IdrisC-45Desugar-n--13015-7302-u--dropLastNL arg-2 arg-1 arg-0 (PreludeC-45Interfaces-concat (csegen-50) arg-2)))) (else (let ((act-24 ((IdrisC-45Desugar-n--13015-7301-u--trimLast arg-2 arg-1 arg-0 arg-0 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-n--13015-7303-u--trimLeft arg-2 arg-1 arg-0 arg-1 eta-0)) e-5 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (IdrisC-45Desugar-n--13015-7302-u--dropLastNL arg-2 arg-1 arg-0 (PreludeC-45Interfaces-concat (csegen-50) e-6))))))))))))))))
(define IdrisC-45Desugar-toTokList (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((27) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--op (CoreC-45Name-nameRoot e-3))) ((IdrisC-45Desugar-case--toTokList-3973 e-3 e-5 e-4 e-2 e-1 arg-0 e-6 u--op (LibrariesC-45DataC-45StringMap-lookup u--op (let ((e-0 (vector-ref e-6 0))) e-0))) ext-0)))))))))))) ((28) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (let ((e-10 (vector-ref arg-1 4))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--op (CoreC-45Name-nameRoot e-9))) (let ((sc2 (LibrariesC-45DataC-45StringMap-lookup u--op (let ((e-1 (vector-ref e-5 1))) e-1)))) (if (null? sc2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-7 (PreludeC-45TypesC-45String-C-43C-43 "'" (PreludeC-45TypesC-45String-C-43C-43 u--op "' is not a prefix operator"))) ext-0) (let ((e-2 (unbox sc2))) (let ((act-25 (IdrisC-45Desugar-toTokList arg-0 e-10 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (vector 0 e-7 e-8 e-9 (vector 3 e-2)) e-6)))))))))))))))))))(else (vector 1 (cons (vector 1 arg-1) '()))))))
(define IdrisC-45Desugar-seqFun (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (vector 8 u--fc (vector 8 u--fc (vector 0 u--fc (IdrisC-45Desugar-addNS arg-1 (vector 1 (vector 0 ">>")))) arg-2) arg-3))))
(define IdrisC-45Desugar-pairname(blodwen-lazy (lambda () (vector 0 (CoreC-45NameC-45Namespace-builtinNS) (vector 1 (vector 0 "Pair"))))))
(define IdrisC-45Desugar-mkpairname(blodwen-lazy (lambda () (vector 0 (CoreC-45NameC-45Namespace-builtinNS) (vector 1 (vector 0 "MkPair"))))))
(define IdrisC-45Desugar-mkdpairname(blodwen-lazy (lambda () (vector 0 (CoreC-45NameC-45Namespace-dpairNS) (vector 1 (vector 0 "MkDPair"))))))
(define IdrisC-45Desugar-mkPrec (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (vector 0 arg-1)) ((equal? arg-0 1) (vector 1 arg-1)) ((equal? arg-0 2) (vector 2 arg-1)) (else (vector 3 arg-1)))))
(define IdrisC-45Desugar-initBangs (lambda (ext-0) (vector 0 '() ext-0)))
(define IdrisC-45Desugar-idiomise (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((13) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector 13 e-1 (TTImpC-45TTImp-mapAltType (lambda (eta-0) (IdrisC-45Desugar-idiomise e-1 eta-0)) e-2) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (IdrisC-45Desugar-idiomise e-1 eta-0)) e-3)))))) ((8) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (vector 8 u--fc (vector 8 u--fc (vector 0 u--fc (vector 1 (vector 0 "<*>"))) (IdrisC-45Desugar-idiomise e-5 e-6)) e-7))))))(else (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (vector 8 u--fc (vector 0 u--fc (vector 1 (vector 0 "pure"))) arg-1))))))
(define IdrisC-45Desugar-getClauseFn (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (lambda (eta-0) (vector 1 e-2)))) ((8) (let ((e-5 (vector-ref arg-0 2))) (IdrisC-45Desugar-getClauseFn e-5))) ((9) (let ((e-9 (vector-ref arg-0 2))) (IdrisC-45Desugar-getClauseFn e-9))) ((10) (let ((e-13 (vector-ref arg-0 2))) (IdrisC-45Desugar-getClauseFn e-13)))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (TTImpC-45TTImp-getFC arg-0) "Head term in pattern must be a function name") eta-0))))))
(define IdrisC-45Desugar-extendSyn (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-1 "doc.module" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (LibrariesC-45DataC-45StringC-45Extra-unlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Old (" (PreludeC-45TypesC-45String-C-43C-43 (DataC-45String-unwords (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent eta-0)) (let ((e-2 (vector-ref e-5 2))) e-2))) (PreludeC-45TypesC-45String-C-43C-43 "): " (LibrariesC-45DataC-45SortedMap-u--show_Show_C-40C-40SortedMapC-32C-36kC-41C-32C-36vC-41 (csegen-3574) (let ((e-3 (vector-ref e-5 3))) e-3))))) (cons (PreludeC-45TypesC-45String-C-43C-43 "New (" (PreludeC-45TypesC-45String-C-43C-43 (DataC-45String-unwords (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent eta-0)) (let ((e-2 (vector-ref arg-2 2))) e-2))) (PreludeC-45TypesC-45String-C-43C-43 "): " (LibrariesC-45DataC-45SortedMap-u--show_Show_C-40C-40SortedMapC-32C-36kC-41C-32C-36vC-41 (csegen-3574) (let ((e-3 (vector-ref arg-2 3))) e-3))))) '())))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-11 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (vector (LibrariesC-45DataC-45StringMap-mergeLeft (let ((e-23 (vector-ref arg-2 0))) e-23) e-0) (LibrariesC-45DataC-45StringMap-mergeLeft (let ((e-22 (vector-ref arg-2 1))) e-22) e-1) e-2 (LibrariesC-45DataC-45SortedMap-mergeLeft (let ((e-20 (vector-ref arg-2 3))) e-20) e-3) e-4 (LibrariesC-45DataC-45ANameMap-merge (let ((e-18 (vector-ref arg-2 5))) e-18) e-12) e-11 (LibrariesC-45DataC-45ANameMap-merge (let ((e-16 (vector-ref arg-2 7))) e-16) e-7) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-15 (vector-ref arg-2 8))) e-15) e-8) e-9 e-10))))))))))))))) (vector 1 act-26)))))))))))
(define IdrisC-45Desugar-expandString (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-n--13004-7038-u--toRawImp arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) (DataC-45List-filter (lambda (eta-0) (IdrisC-45Desugar-n--13004-7040-u--notEmpty arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) (IdrisC-45Desugar-n--13004-7039-u--mergeStrLit arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-8)) '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (if (null? e-5) (vector 28 arg-7 (vector 10 "")) (let ((u--vfc (CoreC-45FC-virtualiseFC arg-7))) (vector 8 u--vfc (vector 10 u--vfc (vector 0 u--vfc (vector 0 (CoreC-45NameC-45Namespace-preludeNS) (vector 1 (vector 0 "concat")))) (vector 1 (vector 0 "t")) (vector 0 u--vfc (vector 0 (CoreC-45NameC-45Namespace-preludeNS) (vector 1 (vector 0 "List"))))) (IdrisC-45Desugar-n--13004-7041-u--strInterpolate arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5)))))))))))
(define IdrisC-45Desugar-expandSnocList (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-8) (vector 1 (vector 0 arg-7 (vector 1 (vector 0 "Lin")))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 ((IdrisC-45Desugar-expandSnocList arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-7) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-6 (vector 1 (vector 0 ":<"))) (cons e-5 (cons e-8 '()))))))))))))))))))))
(define IdrisC-45Desugar-expandList (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-8) (vector 1 (vector 0 arg-7 (vector 1 (vector 0 "Nil")))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-expandList arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-6 (vector 1 (vector 0 "::"))) (cons e-5 (cons e-8 '()))))))))))))))))))))
(define IdrisC-45Desugar-expandDo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-6 "Do block cannot be empty") eta-0)) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-2 0) ((0) (let ((e-39 (vector-ref e-2 2))) (if (null? e-3) (lambda (eta-0) (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-39 eta-0)) (lambda (clam-0) (if (null? e-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (IdrisC-45Syntax-getLoc e-2) "Last statement in do block must be an expression") clam-0) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((act-24 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-seqFun e-5 arg-7 e-7 e-8)))))))))))))))) ((1) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (let ((e-11 (vector-ref e-2 4))) (let ((act-24 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-11 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((sc7 (CoreC-45FC-isConcreteFC e-9))) (if (null? sc7) (vector 1 0) (let ((e-1 (unbox sc7))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-1 (cons (cons e-1 (cons 5 (box e-10))) '()) clam-0)))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-bindFun e-8 arg-7 e-5 (vector 2 e-9 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box e-10) (vector 32 (CoreC-45FC-virtualiseFC e-8) 0) e-6))))))))))))))))))) ((2) (let ((e-13 (vector-ref e-2 1))) (let ((e-14 (vector-ref e-2 2))) (let ((e-15 (vector-ref e-2 3))) (let ((e-16 (vector-ref e-2 4))) (let ((act-24 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 0 arg-5 arg-7 e-14 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45BindImplicits-bindNames arg-1 0 e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-26 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-15 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-3579) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-5 1 eta-0 eta-2)) eta-1))) e-16 '() clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend e-7 arg-5))) (let ((act-28 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 u--psC-39 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((u--fcOriginal e-13)) (let ((u--fc (CoreC-45FC-virtualiseFC e-13))) (vector 1 (IdrisC-45Desugar-bindFun u--fc arg-7 e-8 (vector 2 (vector 2 ) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box (vector 2 "_" 0)) (vector 32 u--fc 0) (vector 4 u--fc (csegen-3580) (vector 32 u--fc 0) (cons (vector 0 u--fcOriginal e-4 e-10) e-9))))))))))))))))))))))))))))))))))) ((3) (let ((e-18 (vector-ref e-2 1))) (let ((e-19 (vector-ref e-2 2))) (let ((e-20 (vector-ref e-2 3))) (let ((e-21 (vector-ref e-2 4))) (let ((e-22 (vector-ref e-2 5))) (let ((e-23 (vector-ref e-2 6))) (let ((act-24 (CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-3 arg-2 arg-4 arg-5 e-23) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-22 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((sc9 (CoreC-45FC-isConcreteFC e-19))) (if (null? sc9) (vector 1 0) (let ((e-1 (unbox sc9))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-1 (cons (cons e-1 (cons 5 (box e-20))) '()) clam-0)))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((u--bind (vector 3 e-18 e-19 e-21 e-20 e-7 e-6 e-8))) (let ((act-29 (let ((act-29 (unbox e-5))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-10 1))) e-1) arg-7 u--bind))))))))))))))))))))))))))))))))) ((4) (let ((e-25 (vector-ref e-2 1))) (let ((e-26 (vector-ref e-2 2))) (let ((e-27 (vector-ref e-2 3))) (let ((e-28 (vector-ref e-2 4))) (let ((e-29 (vector-ref e-2 5))) (let ((act-24 (CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 0 arg-5 arg-7 e-26 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-27 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45BindImplicits-bindNames arg-1 0 e-6 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((act-28 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-3 arg-2 arg-4 arg-5 e-28) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-3579) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-5 1 eta-0 eta-2)) eta-1))) e-29 '() clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-29 1))) (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-5))) (let ((act-30 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 u--psC-39 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (unbox e-5))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-13 (vector-ref act-31 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-31 1))) (let ((u--fc (CoreC-45FC-virtualiseFC e-25))) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-13 1))) e-1) arg-7 (vector 4 u--fc e-10 e-7 (cons (vector 0 u--fc e-4 e-12) e-11)))))))))))))))))))))))))))))))))))))))))))))) ((5) (let ((e-31 (vector-ref e-2 1))) (let ((e-32 (vector-ref e-2 2))) (let ((act-24 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-5 eta-0)) e-32 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-31 (PreludeC-45Interfaces-concat (csegen-50) e-6) e-5))))))))))))) (else (let ((e-34 (vector-ref e-2 1))) (let ((e-35 (vector-ref e-2 2))) (let ((act-24 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-35 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 14 e-34 e-6 e-5)))))))))))))))))))(else (lambda (clam-1) (if (null? e-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (IdrisC-45Syntax-getLoc e-2) "Last statement in do block must be an expression") clam-1) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((act-24 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-6 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-seqFun e-5 arg-7 e-7 e-8)))))))))))))))) ((1) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (let ((e-11 (vector-ref e-2 4))) (let ((act-24 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-11 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((sc5 (CoreC-45FC-isConcreteFC e-9))) (if (null? sc5) (vector 1 0) (let ((e-1 (unbox sc5))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-1 (cons (cons e-1 (cons 5 (box e-10))) '()) clam-1)))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-bindFun e-8 arg-7 e-5 (vector 2 e-9 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box e-10) (vector 32 (CoreC-45FC-virtualiseFC e-8) 0) e-6))))))))))))))))))) ((2) (let ((e-13 (vector-ref e-2 1))) (let ((e-14 (vector-ref e-2 2))) (let ((e-15 (vector-ref e-2 3))) (let ((e-16 (vector-ref e-2 4))) (let ((act-24 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 0 arg-5 arg-7 e-14 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45BindImplicits-bindNames arg-1 0 e-5 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-26 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-15 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-3579) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-5 1 eta-0 eta-2)) eta-1))) e-16 '() clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend e-7 arg-5))) (let ((act-28 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 u--psC-39 arg-6 arg-7 e-3) clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((u--fcOriginal e-13)) (let ((u--fc (CoreC-45FC-virtualiseFC e-13))) (vector 1 (IdrisC-45Desugar-bindFun u--fc arg-7 e-8 (vector 2 (vector 2 ) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box (vector 2 "_" 0)) (vector 32 u--fc 0) (vector 4 u--fc (csegen-3580) (vector 32 u--fc 0) (cons (vector 0 u--fcOriginal e-4 e-10) e-9))))))))))))))))))))))))))))))))))) ((3) (let ((e-18 (vector-ref e-2 1))) (let ((e-19 (vector-ref e-2 2))) (let ((e-20 (vector-ref e-2 3))) (let ((e-21 (vector-ref e-2 4))) (let ((e-22 (vector-ref e-2 5))) (let ((e-23 (vector-ref e-2 6))) (let ((act-24 (CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-7) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-3 arg-2 arg-4 arg-5 e-23) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-22 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((sc7 (CoreC-45FC-isConcreteFC e-19))) (if (null? sc7) (vector 1 0) (let ((e-1 (unbox sc7))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-1 (cons (cons e-1 (cons 5 (box e-20))) '()) clam-1)))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((u--bind (vector 3 e-18 e-19 e-21 e-20 e-7 e-6 e-8))) (let ((act-29 (let ((act-29 (unbox e-5))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-10 1))) e-1) arg-7 u--bind))))))))))))))))))))))))))))))))) ((4) (let ((e-25 (vector-ref e-2 1))) (let ((e-26 (vector-ref e-2 2))) (let ((e-27 (vector-ref e-2 3))) (let ((e-28 (vector-ref e-2 4))) (let ((e-29 (vector-ref e-2 5))) (let ((act-24 (CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-7) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 0 arg-5 arg-7 e-26 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-27 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45BindImplicits-bindNames arg-1 0 e-6 clam-1))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((act-28 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-3 arg-2 arg-4 arg-5 e-28) clam-1))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-3579) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-5 1 eta-0 eta-2)) eta-1))) e-29 '() clam-1))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-29 1))) (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-5))) (let ((act-30 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 u--psC-39 arg-6 arg-7 e-3) clam-1))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (unbox e-5))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-13 (vector-ref act-31 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-31 1))) (let ((u--fc (CoreC-45FC-virtualiseFC e-25))) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-13 1))) e-1) arg-7 (vector 4 u--fc e-10 e-7 (cons (vector 0 u--fc e-4 e-12) e-11)))))))))))))))))))))))))))))))))))))))))))))) ((5) (let ((e-31 (vector-ref e-2 1))) (let ((e-32 (vector-ref e-2 2))) (let ((act-24 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-5 eta-0)) e-32 '() clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-31 (PreludeC-45Interfaces-concat (csegen-50) e-6) e-5))))))))))))) (else (let ((e-34 (vector-ref e-2 1))) (let ((e-35 (vector-ref e-2 2))) (let ((act-24 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-7 e-35 clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 14 e-34 e-6 e-5)))))))))))))))))))))))
(define IdrisC-45Desugar-dpairname(blodwen-lazy (lambda () (vector 0 (CoreC-45NameC-45Namespace-dpairNS) (vector 1 (vector 0 "DPair"))))))
(define IdrisC-45Desugar-desugarUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-5))))))))) (else (let ((e-4 (vector-ref arg-7 1))) (let ((e-5 (vector-ref arg-7 2))) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-5) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (vector 1 e-4 e-6))))))))))))
(define IdrisC-45Desugar-desugarType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((act-24 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-3 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-1 (let ((e-9 (vector-ref e-7 9))) e-9) arg-4 e-8 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (vector 1 (vector e-1 e-2 e-3 e-9))))))))))))))))))))))))
(define IdrisC-45Desugar-desugarTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (let ((e-6 (vector-ref arg-7 5))) (case (vector-ref e-4 0) ((1) (let ((e-16 (vector-ref e-4 1))) (lambda (clam-0) (case (vector-ref e-16 0) ((0) (let ((e-17 (vector-ref e-16 1))) (cond ((equal? e-17 "=") (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 13 e-2 (vector 0 ) (cons (TTImpC-45TTImp-apply (vector 0 e-3 (vector 1 (vector 0 "==="))) (cons e-7 (cons e-8 '()))) (cons (TTImpC-45TTImp-apply (vector 0 e-3 (vector 1 (vector 0 "~=~"))) (cons e-7 (cons e-8 '()))) '()))))))))))))) ((equal? e-17 "$") (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 8 e-2 e-7 e-8)))))))))))(else (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 8 e-2 (vector 8 e-2 (vector 0 e-3 e-4) e-7) e-8))))))))))))))(else (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 8 e-2 (vector 8 e-2 (vector 0 e-3 e-4) e-7) e-8)))))))))))))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 8 e-2 (vector 8 e-2 (vector 0 e-3 e-4) e-7) e-8))))))))))))))))))) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 3))) (let ((e-12 (vector-ref arg-7 4))) (case (vector-ref e-11 0) ((1) (let ((e-18 (vector-ref e-11 1))) (case (vector-ref e-18 0) ((0) (let ((e-19 (vector-ref e-18 1))) (cond ((equal? e-19 "-") (case (vector-ref e-12 0) ((2) (let ((e-22 (vector-ref e-12 1))) (case (vector-ref e-22 0) ((15) (let ((e-24 (vector-ref e-22 1))) (let ((e-25 (vector-ref e-22 2))) (let ((u--newFC (DataC-45Maybe-fromMaybe (lambda () (vector 2 )) (CoreC-45FC-mergeFC e-9 e-24)))) (let ((u--continue (lambda (eta-0) (IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 2 (vector 15 u--newFC eta-0)))))) (case (vector-ref e-25 0) ((0) (let ((e-0 (vector-ref e-25 1))) (u--continue (vector 0 (bs- 0 e-0 63))))) ((1) (let ((e-1 (vector-ref e-25 1))) (u--continue (vector 1 (bs- 0 e-1 7))))) ((2) (let ((e-2 (vector-ref e-25 1))) (u--continue (vector 2 (bs- 0 e-2 15))))) ((3) (let ((e-3 (vector-ref e-25 1))) (u--continue (vector 3 (bs- 0 e-3 31))))) ((4) (let ((e-4 (vector-ref e-25 1))) (u--continue (vector 4 (bs- 0 e-4 63))))) ((5) (let ((e-5 (vector-ref e-25 1))) (u--continue (vector 5 (- 0 e-5)))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 2 (vector 15 e-24 e-25))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-9 (vector 0 e-10 (vector 1 (vector 0 "negate"))) e-5))))))))))))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-9 (vector 0 e-10 (vector 1 (vector 0 "negate"))) e-5)))))))))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-9 (vector 0 e-10 (vector 1 (vector 0 "negate"))) e-5))))))))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-9 (vector 0 e-10 e-11) e-5)))))))))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-9 (vector 0 e-10 e-11) e-5)))))))))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-9 (vector 0 e-10 e-11) e-5)))))))))))))) (else (let ((e-15 (vector-ref arg-7 1))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-15))))))
(define IdrisC-45Desugar-desugarLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-2 arg-3 0 arg-4 arg-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Core-iunless arg-5 (lambda () (IdrisC-45Desugar-getClauseFn e-5))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45BindImplicits-bindNames arg-1 arg-5 e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-27 ((CoreC-45Core-iwhenJust e-6 (lambda (u--nm) (let ((sc4 (PreludeC-45Types-elem (csegen-802) u--nm e-2))) (cond ((equal? sc4 1) ((let ((u--fc (IdrisC-45Syntax-getPTermLoc arg-6))) (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 u--fc (PreludeC-45Interfaces-concat (csegen-67) (cons "Declaration name (" (cons (CoreC-45Name-u--show_Show_Name u--nm) (cons ") shadowed by a pattern variable." '()))))) eta-0)))))) (else (lambda (eta-0) (vector 1 0))))))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (vector 1 (cons e-6 (cons e-2 e-3))))))))))))))))))))))
(define IdrisC-45Desugar-desugarFnOpt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (vector 1 e-1))) (else (let ((e-3 (vector-ref arg-5 1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 eta-0 eta-1))) e-3 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-5)))))))))))
(define IdrisC-45Desugar-desugarField (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((e-1 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 3))) (let ((e-5 (vector-ref arg-6 4))) (let ((e-6 (vector-ref arg-6 5))) (let ((act-24 (IdrisC-45DocC-45String-addDocStringNS arg-1 arg-0 arg-5 e-5 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((act-25 (IdrisC-45DocC-45String-addDocStringNS arg-1 arg-0 arg-5 (IdrisC-45Desugar-n--13077-9211-u--toRF e-6 e-5 e-4 e-3 e-2 e-1 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5) e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-8 (vector-ref act-25 1))) (vector 0 e-8))) (else (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-9 (vector-ref act-26 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-26 1))) (let ((act-27 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 eta-0 eta-1))) e-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-6 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (let ((act-29 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-1 (let ((e-13 (vector-ref e-9 9))) e-13) arg-4 e-11 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-12 (vector-ref act-29 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-29 1))) (vector 1 (vector e-1 e-3 e-10 e-5 e-12))))))))))))))))))))))))))))))))
(define IdrisC-45Desugar-desugarDo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-6) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-7 1))) e-1) arg-6 e-6))))))))))))))))
(define IdrisC-45Desugar-desugarDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarFnOpt arg-0 arg-1 arg-2 arg-3 arg-4 eta-1 eta-2))) e-4 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugarType arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (cons (vector 0 e-1 e-2 e-3 e-6 e-7) '()))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-4 0 eta-1 eta-2))) e-8 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (PreludeC-45Basics-uncurry (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (IdrisC-45Desugar-n--13095-9323-u--toIDef e-8 e-7 arg-4 arg-3 arg-2 arg-1 arg-0 (LibrariesC-45DataC-45IMaybe-fromJust eta-2) eta-3 eta-4)))) eta-1)) e-5 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (TTImpC-45Parser-collectDefs e-6)))))))))))))) ((2) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (let ((e-13 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 (IdrisC-45Desugar-desugarData arg-0 arg-1 arg-2 arg-3 arg-4 e-11 e-13 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 1 e-10 e-12 e-5) '())))))))))))) ((3) (let ((e-15 (vector-ref arg-5 1))) (let ((e-16 (vector-ref arg-5 2))) (let ((e-17 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend arg-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-fst eta-2)) e-16)) eta-1)) e-17 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-25 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-11 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 eta-1 eta-2))) e-10 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (cons e-2 (cons e-6 (cons e-9 e-8)))))))))))))))))))) e-16 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (CoreC-45Context-isUnboundImplicits arg-1 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) (PreludeC-45IO-u--map_Functor_IO (csegen-2316) (PreludeC-45Basics-flip (csegen-1822) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd (Builtin-snd (Builtin-snd eta-1)))) e-6) (lambda (eta-1) (TTImpC-45Utils-findUniqueBindableNames arg-1 e-15 1 (PreludeC-45TypesC-45List-tailRecAppend arg-4 (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-fst eta-2)) e-16)) '() eta-1))) eta-0)) (else (vector 1 '()))))))))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--paramsb (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (cons e-2 (cons e-9 (cons e-10 (TTImpC-45BindImplicits-doBind e-7 e-11))))))))))) e-6))) (vector 1 (cons (vector 3 e-15 u--paramsb (PreludeC-45Interfaces-concat (csegen-50) e-5)) '())))))))))))))))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--oldu (let ((e-9 (vector-ref e-5 9))) e-9))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (u--ntm) (lambda (eta-1) (let ((act-25 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 (Builtin-snd u--ntm) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-19 u--oldu arg-4 e-6 eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cons (Builtin-fst u--ntm) e-7)))))))))))) e-20 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-11 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 10))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-11 e-7 e-8 (PreludeC-45TypesC-45List-tailRecAppend e-6 u--oldu) e-10)))))))))))))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 eta-1)) e-21 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (unbox arg-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (set-box! arg-0 (let ((e-0 (vector-ref e-9 0))) (let ((e-1 (vector-ref e-9 1))) (let ((e-2 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (let ((e-15 (vector-ref e-9 5))) (let ((e-14 (vector-ref e-9 6))) (let ((e-13 (vector-ref e-9 7))) (let ((e-12 (vector-ref e-9 8))) (let ((e-10 (vector-ref e-9 10))) (vector e-0 e-1 e-2 e-3 e-4 e-15 e-14 e-13 e-12 u--oldu e-10)))))))))))))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-8)))))))))))))))))))))))))))))) ((5) (let ((e-23 (vector-ref arg-5 1))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-23 "Reflection not implemented yet") eta-0)))) ((6) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (let ((e-28 (vector-ref arg-5 3))) (let ((e-29 (vector-ref arg-5 4))) (let ((e-30 (vector-ref arg-5 5))) (let ((e-31 (vector-ref arg-5 6))) (let ((e-32 (vector-ref arg-5 7))) (let ((e-33 (vector-ref arg-5 8))) (let ((e-34 (vector-ref arg-5 9))) (lambda (eta-0) (let ((act-24 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-29 e-30 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((u--paramNames (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) e-31))) (let ((u--cons (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-1) (IdrisC-45Desugar-n--13095-9847-u--expandConstraint e-34 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 arg-4 arg-3 arg-2 arg-1 arg-0 eta-1)) e-28))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (u--ntm) (lambda (eta-1) (let ((act-25 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 (PreludeC-45TypesC-45List-tailRecAppend arg-4 u--paramNames) (Builtin-snd u--ntm) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (Builtin-fst u--ntm) e-6)))))))) u--cons '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-7 clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (cons e-2 (cons e-8 e-9))))))))))))) e-31 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--mnames (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45Name-dropNS eta-1)) (IdrisC-45Syntax-definedIn e-34)))) (let ((act-27 (let ((act-27 (CoreC-45Context-isUnboundImplicits arg-1 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? e-8 1) (PreludeC-45IO-u--map_Functor_IO (csegen-2316) (PreludeC-45Basics-flip (csegen-1822) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-6) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd (Builtin-snd eta-1))) e-7)) (lambda (eta-1) (TTImpC-45Utils-findUniqueBindableNames arg-1 e-26 1 (PreludeC-45TypesC-45List-tailRecAppend arg-4 (PreludeC-45TypesC-45List-tailRecAppend u--mnames u--paramNames)) '() eta-1))) eta-0)) (else (vector 1 '()))))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--paramsb (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-10 (car e-3))) (let ((e-9 (cdr e-3))) (let ((u--tmC-39 (TTImpC-45BindImplicits-doBind e-8 e-9))) (cons e-2 (cons e-10 u--tmC-39)))))))) e-7))) (let ((u--consb (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (TTImpC-45BindImplicits-doBind e-8 e-3))))) e-6))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend arg-4 (PreludeC-45TypesC-45List-tailRecAppend u--mnames u--paramNames)) eta-1)) e-34 '() eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons (vector 8 (PreludeC-45Types-maybe (lambda () (cons e-29 '())) (lambda () (lambda (u--n) (cons e-29 (cons u--n '())))) e-33) (lambda (vars-10133) (lambda (u--nest) (lambda (u--env) (lambda (eta-1) (IdrisC-45ElabC-45Interface-elabInterface vars-10133 arg-1 arg-2 arg-0 arg-3 e-26 e-27 u--env u--nest u--consb e-29 u--paramsb e-32 e-33 (PreludeC-45Interfaces-concat (csegen-50) e-9) eta-1)))))) '()))))))))))))))))))))))))))))))))))))) ((7) (let ((e-36 (vector-ref arg-5 1))) (let ((e-37 (vector-ref arg-5 2))) (let ((e-38 (vector-ref arg-5 3))) (let ((e-39 (vector-ref arg-5 4))) (let ((e-40 (vector-ref arg-5 5))) (let ((e-41 (vector-ref arg-5 6))) (let ((e-42 (vector-ref arg-5 7))) (let ((e-43 (vector-ref arg-5 8))) (let ((e-44 (vector-ref arg-5 9))) (let ((e-45 (vector-ref arg-5 10))) (let ((e-46 (vector-ref arg-5 11))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarFnOpt arg-0 arg-1 arg-2 arg-3 arg-4 eta-1 eta-2))) e-38 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-2) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-25 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-7 clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (cons e-2 (cons e-6 e-8))))))))))))) e-40 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-3) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-3 clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (cons e-2 e-7)))))))))) e-41 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 eta-1 eta-2))) e-43 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (CoreC-45Context-isUnboundImplicits arg-1 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (cond ((equal? e-9 1) (PreludeC-45IO-u--map_Functor_IO (csegen-2316) (PreludeC-45Basics-flip (csegen-1822) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-7) e-8) (lambda (eta-1) (TTImpC-45Utils-findUniqueBindableNames arg-1 e-36 1 arg-4 '() eta-1))) eta-0)) (else (vector 1 '()))))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--paramsb (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (TTImpC-45BindImplicits-doBind e-9 eta-1)) e-8))) (let ((u--isb (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-11 (car e-3))) (let ((e-10 (cdr e-3))) (cons e-2 (cons e-11 (TTImpC-45BindImplicits-doBind e-9 e-10)))))))) e-6))) (let ((u--consb (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (TTImpC-45BindImplicits-doBind e-9 e-3))))) e-7))) (let ((act-29 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 '()))) (lambda () (lambda (u--b) (lambda (eta-1) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-2) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 eta-2)) u--b '() eta-1))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (vector 1 (box (PreludeC-45Interfaces-concat (csegen-50) e-10)))))))))) e-46) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--impname (PreludeC-45Types-maybe (lambda () (IdrisC-45ElabC-45Implementation-mkImplName e-36 e-42 u--paramsb)) (lambda () (lambda (eta-1) eta-1)) e-44))) (vector 1 (cons (vector 8 (cons u--impname '()) (lambda (vars-10527) (lambda (u--nest) (lambda (u--env) (IdrisC-45ElabC-45Implementation-elabImplementation vars-10527 arg-1 arg-2 arg-0 arg-3 e-36 e-37 e-5 e-39 u--env u--nest u--isb u--consb e-42 u--paramsb (IdrisC-45Desugar-n--13095-10295-u--isNamed e-46 e-45 e-44 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 arg-4 arg-3 arg-2 arg-1 arg-0 e-44) u--impname e-45 e-10))))) '()))))))))))))))))))))))))))))))))))))))))))) ((8) (let ((e-48 (vector-ref arg-5 1))) (let ((e-49 (vector-ref arg-5 2))) (let ((e-50 (vector-ref arg-5 3))) (let ((e-51 (vector-ref arg-5 4))) (let ((e-52 (vector-ref arg-5 5))) (let ((e-53 (vector-ref arg-5 6))) (let ((e-54 (vector-ref arg-5 7))) (lambda (eta-0) (let ((act-24 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-51 e-49 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (lambda (clam-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-25 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-11 clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-n--13095-10766-u--mapDesugarPiInfo e-54 e-53 e-52 e-51 e-50 e-49 e-48 arg-4 arg-3 arg-2 arg-1 arg-0 arg-4 e-10 clam-3))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (cons e-2 (cons e-6 (cons e-9 e-8)))))))))))))))))))) e-52 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--fnames (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (IdrisC-45Desugar-n--13095-10764-u--fname e-54 e-53 e-52 e-51 e-50 e-49 e-48 arg-4 arg-3 arg-2 arg-1 arg-0 eta-1)) e-54))) (let ((act-26 (CoreC-45Context-isUnboundImplicits arg-1 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--bnames (cond ((equal? e-7 1) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-1) (TTImpC-45Utils-findBindableNames 1 (PreludeC-45TypesC-45List-tailRecAppend arg-4 (PreludeC-45TypesC-45List-tailRecAppend u--fnames (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-fst eta-2)) e-52))) '() eta-1)) (PreludeC-45Types-u--map_Functor_List (csegen-3437) e-6))) (else '())))) (let ((u--paramsb (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (cons e-2 (cons e-9 (cons e-10 (TTImpC-45BindImplicits-doBind u--bnames e-11))))))))))) e-6))) (let ((u--recName (CoreC-45Name-nameRoot e-51))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarField arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend arg-4 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-3) (IdrisC-45Desugar-n--13095-10764-u--fname e-54 e-53 e-52 e-51 e-50 e-49 e-48 arg-4 arg-3 arg-2 arg-1 arg-0 eta-3)) e-54) (PreludeC-45Types-u--map_Functor_List (lambda (eta-3) (Builtin-fst eta-3)) e-52))) (CoreC-45NameC-45Namespace-mkNamespace u--recName) eta-1 eta-2))) e-54 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--conname (PreludeC-45Types-maybe (lambda () (IdrisC-45Desugar-n--13095-10765-u--mkConName e-54 e-53 e-52 e-51 e-50 e-49 e-48 arg-4 arg-3 arg-2 arg-1 arg-0 e-51)) (lambda () (lambda (eta-1) eta-1)) e-53))) (vector 1 (cons (vector 4 e-48 (box u--recName) e-50 (vector e-48 e-51 u--paramsb u--conname e-8)) '()))))))))))))))))))))))))))))))) ((10) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (let ((e-58 (vector-ref arg-5 3))) (let ((e-59 (vector-ref arg-5 4))) (cond ((equal? e-57 3) (case (vector-ref e-59 0) ((1) (let ((e-84 (vector-ref e-59 1))) (case (vector-ref e-84 0) ((0) (let ((e-85 (vector-ref e-84 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (vector e-0 (LibrariesC-45DataC-45StringMap-insert e-85 e-58 e-1) e-2 e-3 e-4 e-11 e-6 e-7 e-8 e-9 e-10))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '())))))))))))(else (lambda (clam-4) (case (vector-ref e-59 0) ((1) (let ((e-82 (vector-ref e-59 1))) (case (vector-ref e-82 0) ((0) (let ((e-83 (vector-ref e-82 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (vector (LibrariesC-45DataC-45StringMap-insert e-83 (cons e-57 e-58) e-0) e-1 e-2 e-3 e-4 e-11 e-6 e-7 e-8 e-9 e-10))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '()))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-56 "Fixity declarations must be for unqualified names") clam-4)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-56 "Fixity declarations must be for unqualified names") clam-4))))))))(else (lambda (clam-5) (case (vector-ref e-59 0) ((1) (let ((e-82 (vector-ref e-59 1))) (case (vector-ref e-82 0) ((0) (let ((e-83 (vector-ref e-82 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (vector (LibrariesC-45DataC-45StringMap-insert e-83 (cons e-57 e-58) e-0) e-1 e-2 e-3 e-4 e-11 e-6 e-7 e-8 e-9 e-10))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '()))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-56 "Fixity declarations must be for unqualified names") clam-5)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-56 "Fixity declarations must be for unqualified names") clam-5)))))))(else (lambda (clam-6) (case (vector-ref e-59 0) ((1) (let ((e-82 (vector-ref e-59 1))) (case (vector-ref e-82 0) ((0) (let ((e-83 (vector-ref e-82 1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (vector (LibrariesC-45DataC-45StringMap-insert e-83 (cons e-57 e-58) e-0) e-1 e-2 e-3 e-4 e-11 e-6 e-7 e-8 e-9 e-10))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '()))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-56 "Fixity declarations must be for unqualified names") clam-6)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-56 "Fixity declarations must be for unqualified names") clam-6))))))))))) ((9) (let ((e-62 (vector-ref arg-5 2))) (lambda (clam-8) (let ((sc1 (IdrisC-45DesugarC-45Mutual-splitMutual e-62))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 eta-0)) (PreludeC-45TypesC-45List-tailRecAppend e-2 e-3) '() clam-8))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5)))))))))))) ((11) (let ((e-64 (vector-ref arg-5 1))) (let ((e-65 (vector-ref arg-5 2))) (let ((e-66 (vector-ref arg-5 3))) (lambda (eta-0) (CoreC-45Context-withExtendedNS arg-1 e-65 (lambda (eta-1) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-2) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 eta-2)) e-66 '() eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 5 e-64 e-65 (PreludeC-45Interfaces-concat (csegen-50) e-5)) '()))))))) eta-0)))))) ((12) (let ((e-68 (vector-ref arg-5 1))) (let ((e-69 (vector-ref arg-5 2))) (let ((e-70 (vector-ref arg-5 3))) (let ((e-71 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 0 arg-4 e-70 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (TTImpC-45BindImplicits-bindNames arg-1 0 e-5 eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-4) e-71 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (vector 6 e-68 (vector 1 (vector 0 e-69)) e-3 e-6) '())))))))))))))))))) ((13) (let ((e-73 (vector-ref arg-5 1))) (let ((e-74 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-24 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-74 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 7 e-73 e-5) '())))))))))) ((14) (let ((e-76 (vector-ref arg-5 1))) (let ((e-77 (vector-ref arg-5 2))) (lambda (clam-9) (case (vector-ref e-77 0) ((0) (let ((e-0 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11529) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-hide arg-1 e-76 e-0 eta-0)))))) '())))) ((1) (let ((e-1 (vector-ref e-77 1))) (vector 1 (cons (vector 9 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (u--i) (cons (CoreC-45OptionsC-45Log-topics u--i) (CoreC-45OptionsC-45Log-verbosity u--i))) e-1)) '())))) ((2) (let ((e-2 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11588) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-lazyActive arg-1 e-2 eta-0)))))) '())))) ((3) (let ((e-3 (vector-ref e-77 1))) (let ((act-24 (CoreC-45Context-setUnboundImplicits arg-1 e-3 clam-9))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 8 '() (lambda (vars-11619) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setUnboundImplicits arg-1 e-3 eta-0)))))) '()))))))) ((17) (let ((e-4 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11647) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setPrefixRecordProjections arg-1 e-4 eta-0)))))) '())))) ((4) (let ((e-5 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11675) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setAmbigLimit arg-1 e-5 eta-0)))))) '())))) ((18) (let ((e-6 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11703) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setAutoImplicitLimit arg-1 e-6 eta-0)))))) '())))) ((19) (let ((e-7 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11731) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setNFThreshold arg-1 e-7 eta-0)))))) '())))) ((20) (let ((e-8 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11759) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setSearchTimeout arg-1 e-8 eta-0)))))) '())))) ((5) (let ((e-9 (vector-ref e-77 1))) (let ((e-10 (vector-ref e-77 2))) (let ((e-11 (vector-ref e-77 3))) (vector 1 (cons (vector 8 '() (lambda (vars-11787) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setPair arg-1 e-76 e-9 e-10 e-11 eta-0)))))) '())))))) ((6) (let ((e-12 (vector-ref e-77 1))) (let ((e-13 (vector-ref e-77 2))) (vector 1 (cons (vector 8 '() (lambda (vars-11815) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setRewrite arg-1 e-76 e-12 e-13 eta-0)))))) '()))))) ((7) (let ((e-14 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11843) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setFromInteger arg-1 e-14 eta-0)))))) '())))) ((8) (let ((e-15 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11871) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setFromString arg-1 e-15 eta-0)))))) '())))) ((9) (let ((e-16 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11899) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setFromChar arg-1 e-16 eta-0)))))) '())))) ((10) (let ((e-17 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-11927) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setFromDouble arg-1 e-17 eta-0)))))) '())))) ((11) (let ((e-18 (vector-ref e-77 1))) (let ((e-19 (vector-ref e-77 2))) (vector 1 (cons (vector 8 '() (lambda (vars-11955) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-addDirective arg-1 e-18 e-19 eta-0)))))) '()))))) ((12) (let ((e-20 (vector-ref e-77 1))) (let ((e-21 (vector-ref e-77 2))) (vector 1 (cons (vector 8 '() (lambda (vars-11983) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-addNameDirective arg-1 e-76 e-20 e-21 eta-0)))))) '()))))) ((13) (vector 1 (cons (vector 8 '() (lambda (vars-12013) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "%start not implemented") eta-0)))))) '()))) ((14) (let ((e-24 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-12046) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setNameFlag arg-1 e-76 e-24 (vector 2 ) eta-0)))))) '())))) ((15) (let ((e-25 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-12075) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setExtension arg-1 e-25 eta-0)))))) '())))) (else (let ((e-26 (vector-ref e-77 1))) (vector 1 (cons (vector 8 '() (lambda (vars-12103) (lambda (_-12105) (lambda (_-12107) (lambda (eta-0) (CoreC-45Context-setDefaultTotalityOption arg-1 e-26 eta-0)))))) '()))))))))) (else (let ((e-79 (vector-ref arg-5 1))) (let ((e-80 (vector-ref arg-5 2))) (let ((e-81 (vector-ref arg-5 3))) (lambda (eta-0) (vector 1 (cons (vector 10 e-79 e-80 e-81) '()))))))))))
(define IdrisC-45Desugar-desugarData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((act-24 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-2 arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-1 (let ((e-9 (vector-ref e-7 9))) e-9) arg-4 e-8 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugarType arg-0 arg-1 arg-2 arg-3 arg-4 eta-0 eta-1))) e-5 '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (vector 1 (vector 0 e-1 e-2 e-9 e-4 e-10))))))))))))))))))))))))))) (else (let ((e-7 (vector-ref arg-6 1))) (let ((e-8 (vector-ref arg-6 2))) (let ((e-9 (vector-ref arg-6 3))) (let ((act-24 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-8 arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 arg-4 e-9 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-7 (let ((e-12 (vector-ref e-6 9))) e-12) arg-4 e-10 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-27 1))) (vector 1 (vector 1 e-7 e-8 e-11))))))))))))))))))))))))
(define IdrisC-45Desugar-desugarClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 eta-0)) e-4 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugarLHS arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((e-10 (car e-7))) (let ((e-9 (cdr e-7))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 (PreludeC-45TypesC-45List-tailRecAppend e-10 arg-4) e-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-26 1))) (let ((u--rhsC-39 (if (null? e-5) e-11 (vector 5 e-1 (PreludeC-45Interfaces-concat (csegen-50) e-5) e-11)))) (vector 1 (cons e-8 (vector 0 e-1 e-9 u--rhsC-39))))))))))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((e-9 (vector-ref arg-6 4))) (let ((e-10 (vector-ref arg-6 5))) (let ((e-11 (vector-ref arg-6 6))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-3579) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0 eta-2)) eta-1))) e-11 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugarLHS arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 e-7 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (let ((e-2 (car e-12))) (let ((e-3 (cdr e-12))) (let ((e-14 (car e-3))) (let ((e-13 (cdr e-3))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 1 (PreludeC-45TypesC-45List-tailRecAppend e-14 arg-4) e-8 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-26 1))) (vector 1 (cons e-2 (vector 1 e-6 e-13 e-15 e-9 e-10 e-5)))))))))))))))))))))))))) (else (let ((e-13 (vector-ref arg-6 1))) (let ((e-14 (vector-ref arg-6 2))) (let ((act-24 (IdrisC-45Desugar-desugarLHS arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 e-14 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-7 (cdr e-3))) (vector 1 (cons e-2 (vector 2 e-13 e-7))))))))))))))))
(define IdrisC-45Desugar-desugarB (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (vector 0 e-1 e-2)))))) ((1) (let ((e-4 (vector-ref arg-7 1))) (let ((e-5 (vector-ref arg-7 2))) (let ((e-6 (vector-ref arg-7 3))) (let ((e-7 (vector-ref arg-7 4))) (let ((e-8 (vector-ref arg-7 5))) (let ((e-9 (vector-ref arg-7 6))) (let ((u--psC-39 (PreludeC-45Types-maybe (lambda () arg-6) (lambda () (lambda (arg-8) (cons arg-8 arg-6))) e-7))) (lambda (eta-0) (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 u--psC-39 eta-1 eta-2))) e-6 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-8) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--psC-39 e-9) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-26 1))) (vector 1 (vector 1 e-4 e-5 e-10 e-7 e-11 e-12))))))))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (let ((e-15 (vector-ref arg-7 5))) (let ((e-16 (vector-ref arg-7 6))) (case (vector-ref e-14 0) ((0) (let ((e-205 (vector-ref e-14 1))) (let ((e-206 (vector-ref e-14 2))) (case (vector-ref e-206 0) ((1) (let ((e-209 (vector-ref e-206 1))) (let ((u--pat (vector 0 e-205 (vector 1 e-209)))) (let ((u--n (vector 1 e-209))) (lambda (clam-0) (let ((sc3 (CoreC-45Name-isPatternVariable e-209))) (cond ((equal? sc3 1) (let ((act-24 (let ((sc4 (CoreC-45FC-isConcreteFC e-205))) (if (null? sc4) (vector 1 0) (let ((e-1 (unbox sc4))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-2 (cons (cons e-1 (cons 5 (box u--n))) '()) clam-0)))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 arg-6 eta-0 eta-1))) e-13 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-6 e-15) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 (cons u--n arg-6) e-16 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 2 e-11 e-12 e-6 (box u--n) e-7 e-8)))))))))))))))))) (else (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 arg-6 eta-0 eta-1))) e-13 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-6 e-15) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-6 1 (vector 0 e-11 u--pat e-16 '()) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 (vector 2 ) e-12 e-5 (box (vector 2 "lamc" 0)) e-6 (vector 4 e-11 (csegen-3591) (vector 32 e-11 0) (cons (Builtin-snd e-7) '())))))))))))))))))))))))) ((2) (lambda (eta-0) (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 arg-6 eta-1 eta-2))) e-13 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-6 e-15) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 (cons e-206 arg-6) e-16 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 e-11 e-12 e-5 (box e-206) e-6 e-7))))))))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 arg-6 eta-1 eta-2))) e-13 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-6 e-15) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-6 1 (vector 0 e-11 e-14 e-16 '()) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 (vector 2 ) e-12 e-5 (box (vector 2 "lamc" 0)) e-6 (vector 4 e-11 (csegen-3591) (vector 32 e-11 0) (cons (Builtin-snd e-7) '())))))))))))))))))))))) ((25) (lambda (eta-0) (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 arg-6 eta-1 eta-2))) e-13 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-6 e-15) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 arg-6 e-16 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 e-11 e-12 e-5 '() e-6 e-7))))))))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 1 arg-6 eta-1 eta-2))) e-13 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-6 e-15) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-6 1 (vector 0 e-11 e-14 e-16 '()) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 2 (vector 2 ) e-12 e-5 (box (vector 2 "lamc" 0)) e-6 (vector 4 e-11 (csegen-3591) (vector 32 e-11 0) (cons (Builtin-snd e-7) '())))))))))))))))))))))))))) ((3) (let ((e-18 (vector-ref arg-7 1))) (let ((e-19 (vector-ref arg-7 2))) (let ((e-20 (vector-ref arg-7 3))) (let ((e-21 (vector-ref arg-7 4))) (let ((e-22 (vector-ref arg-7 5))) (let ((e-23 (vector-ref arg-7 6))) (let ((e-24 (vector-ref arg-7 7))) (lambda (clam-0) (case (vector-ref e-20 0) ((0) (let ((e-213 (vector-ref e-20 1))) (let ((e-214 (vector-ref e-20 2))) (if (null? e-24) (let ((act-24 (let ((sc3 (CoreC-45FC-isConcreteFC e-213))) (if (null? sc3) (vector 1 0) (let ((e-1 (unbox sc3))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-2 (cons (cons e-1 (cons 5 (box e-214))) '()) clam-0)))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-21) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-22) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 (cons e-214 arg-6) e-23 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 3 e-18 e-213 e-19 e-214 e-6 e-7 e-8))))))))))))))))) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-22) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-21) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-3579) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-6 1 eta-0 eta-2)) eta-1))) (cons (vector 0 e-18 e-20 e-23 '()) e-24) '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 e-18 e-5 e-6 e-7))))))))))))))))))(else (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-22) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-21) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-3579) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-6 1 eta-0 eta-2)) eta-1))) (cons (vector 0 e-18 e-20 e-23 '()) e-24) '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 e-18 e-5 e-6 e-7))))))))))))))))))))))))) ((4) (let ((e-26 (vector-ref arg-7 1))) (let ((e-27 (vector-ref arg-7 2))) (let ((e-28 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (csegen-3579) (lambda (eta-3) (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-6 1 eta-1 eta-3)) eta-2))) e-28 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-26 e-5 (vector 32 (CoreC-45FC-virtualiseFC e-26) 0) e-6))))))))))))))) ((5) (let ((e-30 (vector-ref arg-7 1))) (let ((e-31 (vector-ref arg-7 2))) (let ((e-32 (vector-ref arg-7 3))) (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedIn e-31) arg-6))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-2 arg-4 arg-3 u--psC-39 eta-1)) e-31 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 u--psC-39 e-32 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 5 e-30 (PreludeC-45Interfaces-concat (csegen-50) e-5) e-6)))))))))))))))) ((7) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (lambda (clam-2) (case (vector-ref e-35 0) ((6) (let ((e-218 (vector-ref e-35 2))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugarUpdate arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 eta-0 eta-1))) e-218 '() clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-36) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 7 e-34 e-5 e-6))))))))))))(else (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-35) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-36) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 e-34 e-5 e-6))))))))))))))))) ((6) (let ((e-38 (vector-ref arg-7 1))) (let ((e-39 (vector-ref arg-7 2))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((u--vfc (CoreC-45FC-virtualiseFC e-38))) (vector 2 u--vfc (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 0 u--vfc (vector 2 "rec" 0)) (vector 25 u--vfc) (vector 7 u--vfc (vector 6 e-38 e-39) (vector 0 u--vfc (vector 2 "rec" 0))))))))) ((10) (let ((e-41 (vector-ref arg-7 1))) (let ((e-42 (vector-ref arg-7 2))) (let ((e-43 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-42) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-43) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 9 e-41 e-5 e-6))))))))))))))) ((8) (let ((e-45 (vector-ref arg-7 1))) (let ((e-46 (vector-ref arg-7 2))) (let ((e-47 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-46) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-47) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 11 e-45 e-5 e-6))))))))))))))) ((9) (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (let ((e-51 (vector-ref arg-7 3))) (let ((e-52 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-50) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-52) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 10 e-49 e-5 e-51 e-6)))))))))))))))) ((11) (let ((e-54 (vector-ref arg-7 1))) (let ((e-55 (vector-ref arg-7 2))) (let ((e-56 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-56) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 20 e-54 e-55 e-5))))))))))) ((12) (let ((e-58 (vector-ref arg-7 1))) (let ((e-59 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-59) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 21 e-58 e-5)))))))))) ((13) (let ((e-61 (vector-ref arg-7 1))) (let ((e-62 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-62) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 22 e-61 e-5)))))))))) ((31) (let ((e-64 (vector-ref arg-7 1))) (let ((e-65 (vector-ref arg-7 2))) (let ((e-66 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-65) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-66) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 13 e-64 (vector 0 ) (cons (TTImpC-45TTImp-apply (vector 0 e-64 (vector 1 (vector 0 "==="))) (cons e-5 (cons e-6 '()))) (cons (TTImpC-45TTImp-apply (vector 0 e-64 (vector 1 (vector 0 "~=~"))) (cons e-5 (cons e-6 '()))) '()))))))))))))))))) ((32) (let ((e-69 (vector-ref arg-7 2))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-69))) ((27) (let ((e-71 (vector-ref arg-7 1))) (let ((e-72 (vector-ref arg-7 2))) (let ((e-73 (vector-ref arg-7 3))) (let ((e-74 (vector-ref arg-7 4))) (let ((e-75 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-24 (IdrisC-45Desugar-toTokList arg-0 (vector 27 e-71 e-72 e-73 e-74 e-75) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (LibrariesC-45UtilsC-45Shunting-parseOps (csegen-737) e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-6) eta-0)))))))))))))))) ((28) (let ((e-77 (vector-ref arg-7 1))) (let ((e-78 (vector-ref arg-7 2))) (let ((e-79 (vector-ref arg-7 3))) (let ((e-80 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 (IdrisC-45Desugar-toTokList arg-0 (vector 28 e-77 e-78 e-79 e-80) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (LibrariesC-45UtilsC-45Shunting-parseOps (csegen-737) e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-6) eta-0))))))))))))))) ((29) (let ((e-82 (vector-ref arg-7 1))) (let ((e-83 (vector-ref arg-7 2))) (let ((e-84 (vector-ref arg-7 3))) (let ((e-85 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (LibrariesC-45DataC-45StringMap-lookup (CoreC-45Name-nameRoot e-84) (let ((e-1 (vector-ref e-5 1))) e-1)))) (if (null? sc2) ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 2 e-82 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 0 e-82 (vector 2 "arg" 0)) (vector 25 e-82) (vector 27 e-82 e-83 e-84 (vector 0 e-82 (vector 2 "arg" 0)) e-85))) eta-0) ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 28 e-82 e-83 e-84 e-85)) eta-0))))))))))))) ((30) (let ((e-87 (vector-ref arg-7 1))) (let ((e-88 (vector-ref arg-7 2))) (let ((e-89 (vector-ref arg-7 3))) (let ((e-90 (vector-ref arg-7 4))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 2 e-87 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 0 e-87 (vector 2 "arg" 0)) (vector 25 e-87) (vector 27 e-87 e-88 e-90 e-89 (vector 0 e-87 (vector 2 "arg" 0)))))))))) ((14) (let ((e-92 (vector-ref arg-7 1))) (let ((e-93 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (vector 12 e-92 e-93)))))) ((15) (let ((e-95 (vector-ref arg-7 1))) (let ((e-96 (vector-ref arg-7 2))) (lambda (clam-3) (case (vector-ref e-96 0) ((5) (let ((e-219 (vector-ref e-96 1))) (let ((act-24 (CoreC-45Context-fromIntegerName arg-2 clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 13 e-95 (vector 2 (vector 28 e-95 (vector 5 e-219))) (cons (vector 28 e-95 (vector 5 e-219)) (cons (vector 28 e-95 (vector 0 (blodwen-toSignedInt e-219 63))) '())))) (let ((e-2 (unbox e-5))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-95))) (vector 1 (vector 8 u--vfc (vector 0 u--vfc e-2) (vector 28 e-95 (vector 5 e-219))))))))))))) ((11) (let ((e-220 (vector-ref e-96 1))) (let ((act-24 (CoreC-45Context-fromCharName arg-2 clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 28 e-95 (vector 11 e-220))) (let ((e-2 (unbox e-5))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-95))) (vector 1 (vector 8 u--vfc (vector 0 u--vfc e-2) (vector 28 e-95 (vector 11 e-220))))))))))))) ((12) (let ((e-221 (vector-ref e-96 1))) (let ((act-24 (CoreC-45Context-fromDoubleName arg-2 clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (vector 28 e-95 (vector 12 e-221))) (let ((e-2 (unbox e-5))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-95))) (vector 1 (vector 8 u--vfc (vector 0 u--vfc e-2) (vector 28 e-95 (vector 12 e-221)))))))))))))(else (vector 1 (vector 28 e-95 e-96)))))))) ((16) (let ((e-98 (vector-ref arg-7 1))) (let ((e-99 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-99) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 23 e-98 e-5)))))))))) ((17) (let ((e-101 (vector-ref arg-7 1))) (let ((e-102 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (vector 24 e-101 e-102)))))) ((18) (let ((e-104 (vector-ref arg-7 1))) (let ((e-105 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-2 arg-4 arg-3 arg-6 eta-1)) e-105 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 25 e-104 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))))) ((19) (let ((e-107 (vector-ref arg-7 1))) (let ((e-108 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-108) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 26 e-107 e-5)))))))))) ((20) (let ((e-110 (vector-ref arg-7 1))) (let ((e-111 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-111) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 27 e-110 e-5)))))))))) ((21) (let ((e-113 (vector-ref arg-7 1))) (let ((e-114 (vector-ref arg-7 2))) (let ((e-115 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (cond ((equal? e-114 1) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (vector e-0 e-1 e-2 e-3 e-4 e-11 e-6 e-7 (cons (vector 1 (vector 0 e-115)) e-8) e-9 e-10))))))))))))))) (vector 1 act-25))))))) (else (vector 1 0))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 30 e-113 e-115)))))))))) ((22) (let ((e-117 (vector-ref arg-7 1))) (lambda (eta-0) (vector 1 (vector 29 e-117))))) ((23) (let ((e-119 (vector-ref arg-7 1))) (let ((e-120 (vector-ref arg-7 2))) (let ((e-121 (vector-ref arg-7 3))) (let ((e-122 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-122) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 18 e-119 e-120 1 e-121 e-5)))))))))))) ((24) (let ((e-124 (vector-ref arg-7 1))) (let ((e-125 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-125) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 19 e-124 4 e-5)))))))))) ((25) (let ((e-127 (vector-ref arg-7 1))) (lambda (eta-0) (vector 1 (vector 32 e-127 1))))) ((26) (let ((e-129 (vector-ref arg-7 1))) (lambda (eta-0) (let ((act-24 (let ((sc1 (IdrisC-45Desugar-u--C-61C-61_Eq_Side arg-5 0))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-129 "? is not a valid pattern") eta-0)) (else (vector 1 0)))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 32 e-129 0)))))))) ((34) (let ((e-131 (vector-ref arg-7 1))) (let ((e-132 (vector-ref arg-7 2))) (let ((e-133 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (IdrisC-45Desugar-trimMultiline e-131 e-132 e-133 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-expandString arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-131 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45Desugar-addFromString arg-2 e-131 e-6 eta-0)))))))))))))) ((33) (let ((e-135 (vector-ref arg-7 1))) (let ((e-136 (vector-ref arg-7 2))) (if (null? e-136) (lambda (eta-0) (IdrisC-45Desugar-addFromString arg-2 e-135 (vector 28 e-135 (vector 10 "")) eta-0)) (let ((e-224 (car e-136))) (let ((e-225 (cdr e-136))) (case (vector-ref e-224 0) ((0) (let ((e-227 (vector-ref e-224 1))) (let ((e-228 (vector-ref e-224 2))) (lambda (clam-1) (if (null? e-225) (IdrisC-45Desugar-addFromString arg-2 e-135 (vector 28 e-227 (vector 10 e-228)) clam-1) (IdrisC-45Desugar-expandString arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-135 e-136 clam-1))))))(else (lambda (eta-0) (IdrisC-45Desugar-expandString arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-135 e-136 eta-0)))))))))) ((35) (let ((e-138 (vector-ref arg-7 1))) (let ((e-139 (vector-ref arg-7 2))) (let ((e-140 (vector-ref arg-7 3))) (IdrisC-45Desugar-expandDo arg-0 arg-2 arg-4 arg-3 arg-5 arg-6 e-138 e-139 e-140))))) ((36) (let ((e-142 (vector-ref arg-7 1))) (let ((e-143 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-143) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--bn (vector 2 "bind" (let ((e-0 (vector-ref e-6 0))) e-0)))) (let ((act-26 (let ((act-26 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (vector (bs+ e-0 1 63) (cons (cons u--bn (cons e-142 e-5)) e-1) e-2))))))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (vector 2 ) u--bn)))))))))))))))))) ((37) (let ((e-145 (vector-ref arg-7 1))) (let ((e-146 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-146) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45TTImp-logRaw arg-2 "desugar.idiom" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Desugaring idiom for") e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--val (IdrisC-45Desugar-idiomise e-145 e-5))) (let ((act-26 (TTImpC-45TTImp-logRaw arg-2 "desugar.idiom" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () "Desugared to") u--val eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 u--val)))))))))))))))) ((38) (let ((e-149 (vector-ref arg-7 2))) (let ((e-150 (vector-ref arg-7 3))) (IdrisC-45Desugar-expandList arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-149 e-150)))) ((39) (let ((e-153 (vector-ref arg-7 2))) (let ((e-154 (vector-ref arg-7 3))) (IdrisC-45Desugar-expandSnocList arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 e-153 (PreludeC-45TypesC-45List-reverse e-154))))) ((40) (let ((e-156 (vector-ref arg-7 1))) (let ((e-157 (vector-ref arg-7 2))) (let ((e-158 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-157) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-158) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--pval (TTImpC-45TTImp-apply (vector 0 e-156 (IdrisC-45Desugar-mkpairname)) (cons e-5 (cons e-6 '()))))) (vector 1 (vector 13 e-156 (vector 2 u--pval) (cons (TTImpC-45TTImp-apply (vector 0 e-156 (IdrisC-45Desugar-pairname)) (cons e-5 (cons e-6 '()))) (cons u--pval '())))))))))))))))))) ((41) (let ((e-160 (vector-ref arg-7 1))) (let ((e-161 (vector-ref arg-7 2))) (let ((e-162 (vector-ref arg-7 3))) (let ((e-163 (vector-ref arg-7 4))) (let ((e-164 (vector-ref arg-7 5))) (case (vector-ref e-162 0) ((0) (let ((e-233 (vector-ref e-162 1))) (let ((e-234 (vector-ref e-162 2))) (lambda (clam-2) (case (vector-ref e-234 0) ((1) (case (vector-ref e-163 0) ((25) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-164) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--pval (TTImpC-45TTImp-apply (vector 0 e-161 (IdrisC-45Desugar-mkdpairname)) (cons (vector 0 e-233 e-234) (cons e-5 '()))))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-233))) (let ((act-25 (let ((sc5 (CoreC-45FC-isConcreteFC e-233))) (if (null? sc5) (vector 1 0) (let ((e-1 (unbox sc5))) (CoreC-45Metadata-addSemanticDefault arg-3 (cons e-1 (cons 5 (box e-234))) clam-2)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 13 e-160 (vector 2 u--pval) (cons (TTImpC-45TTImp-apply (vector 0 e-161 (IdrisC-45Desugar-dpairname)) (cons (vector 32 u--vfc 0) (cons (vector 2 e-233 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box e-234) (vector 32 u--vfc 0) e-5) '()))) (cons u--pval '()))))))))))))))(else (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-163) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-164) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-161 (IdrisC-45Desugar-dpairname)) (cons e-5 (cons (vector 2 e-233 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box e-234) e-5 e-6) '())))))))))))))))(else (case (vector-ref e-163 0) ((25) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-162) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-164) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-161 (IdrisC-45Desugar-mkdpairname)) (cons e-5 (cons e-6 '())))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-160 "Invalid dependent pair type") clam-2)))))))))(else (lambda (clam-6) (case (vector-ref e-163 0) ((25) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-162) clam-6))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-164) clam-6))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-161 (IdrisC-45Desugar-mkdpairname)) (cons e-5 (cons e-6 '())))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-160 "Invalid dependent pair type") clam-6)))))))))))) ((42) (let ((e-166 (vector-ref arg-7 1))) (lambda (eta-0) (vector 1 (vector 13 e-166 (vector 2 (vector 0 e-166 (vector 1 (vector 0 "MkUnit")))) (cons (vector 0 e-166 (vector 1 (vector 0 "Unit"))) (cons (vector 0 e-166 (vector 1 (vector 0 "MkUnit"))) '()))))))) ((43) (let ((e-168 (vector-ref arg-7 1))) (let ((e-169 (vector-ref arg-7 2))) (let ((e-170 (vector-ref arg-7 3))) (let ((e-171 (vector-ref arg-7 4))) (let ((u--fc (CoreC-45FC-virtualiseFC e-168))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-169) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 e-170 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 e-171 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 4 u--fc e-5 (vector 0 u--fc (vector 1 (vector 0 "Bool"))) (cons (vector 0 u--fc (vector 0 u--fc (vector 1 (vector 0 "True"))) e-6) (cons (vector 0 u--fc (vector 0 u--fc (vector 1 (vector 0 "False"))) e-7) '()))))))))))))))))))))))) ((44) (let ((e-173 (vector-ref arg-7 1))) (let ((e-174 (vector-ref arg-7 2))) (let ((e-175 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ns (let ((e-2 (vector-ref e-5 2))) e-2))) ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 35 e-173 u--ns (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (IdrisC-45Desugar-n--12955-6498-u--guard e-175 e-174 e-173 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--ns eta-1)) e-175) (cons (IdrisC-45Desugar-n--12955-6499-u--toPure e-175 e-174 e-173 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--ns e-174) '())))) eta-0))))))))))) ((45) (let ((e-177 (vector-ref arg-7 1))) (let ((e-178 (vector-ref arg-7 2))) (let ((e-179 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-178) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-179) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 14 e-177 e-5 e-6))))))))))))))) ((46) (let ((e-181 (vector-ref arg-7 1))) (let ((e-182 (vector-ref arg-7 2))) (let ((e-183 (vector-ref arg-7 3))) (let ((e-184 (vector-ref arg-7 4))) (let ((u--fc (CoreC-45FC-virtualiseFC e-181))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (if (null? e-183) (IdrisC-45Syntax-papply u--fc (vector 0 u--fc (vector 1 (vector 0 "rangeFromTo"))) (cons e-182 (cons e-184 '()))) (let ((e-2 (unbox e-183))) (IdrisC-45Syntax-papply u--fc (vector 0 u--fc (vector 1 (vector 0 "rangeFromThenTo"))) (cons e-182 (cons e-2 (cons e-184 '()))))))))))))) ((47) (let ((e-186 (vector-ref arg-7 1))) (let ((e-187 (vector-ref arg-7 2))) (let ((e-188 (vector-ref arg-7 3))) (let ((u--fc (CoreC-45FC-virtualiseFC e-186))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (if (null? e-188) (IdrisC-45Syntax-papply u--fc (vector 0 u--fc (vector 1 (vector 0 "rangeFrom"))) (cons e-187 '())) (let ((e-2 (unbox e-188))) (IdrisC-45Syntax-papply u--fc (vector 0 u--fc (vector 1 (vector 0 "rangeFromThen"))) (cons e-187 (cons e-2 '()))))))))))) ((50) (let ((e-190 (vector-ref arg-7 1))) (let ((e-191 (vector-ref arg-7 2))) (let ((e-192 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-24 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-192) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 31 e-190 e-191 e-5))))))))))) ((48) (let ((e-195 (vector-ref arg-7 2))) (let ((e-196 (vector-ref arg-7 3))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--x) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (vector 7 e-2 (vector 0 e-2 e-3) u--x))))) e-195 e-196))))) ((49) (let ((e-198 (vector-ref arg-7 1))) (let ((e-199 (vector-ref arg-7 2))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-198))) (let ((u--var (vector 0 u--vfc (vector 2 "paRoot" 0)))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 2 e-198 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) u--var (vector 25 u--vfc) (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--r) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (vector 7 e-2 (vector 0 e-2 e-3) u--r))))) u--var e-199)))))))) (else (let ((e-201 (vector-ref arg-7 1))) (let ((e-202 (vector-ref arg-7 2))) (let ((e-203 (vector-ref arg-7 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 33 e-201 e-202 e-5)))))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-203) eta-0)))))))))
(define IdrisC-45Desugar-desugar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-6 ext-0)))
(define IdrisC-45Desugar-bindFun (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (vector 8 u--fc (vector 8 u--fc (vector 0 u--fc (IdrisC-45Desugar-addNS arg-1 (vector 1 (vector 0 ">>=")))) arg-2) arg-3))))
(define IdrisC-45Desugar-bindBangs (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) arg-2 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (IdrisC-45Desugar-bindBangs e-3 arg-1 (IdrisC-45Desugar-bindFun e-10 arg-1 e-11 (vector 2 (vector 2 ) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box e-6) (vector 32 e-10 0) arg-2))))))))))))
(define IdrisC-45Desugar-addNS (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-1 (unbox arg-0))) (case (vector-ref arg-1 0) ((0) arg-1)(else (vector 0 e-1 arg-1)))))))
(define IdrisC-45Desugar-addFromString (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-fromStringName arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (if (null? e-5) arg-2 (let ((e-2 (unbox e-5))) (let ((u--fc (CoreC-45FC-virtualiseFC arg-1))) (vector 8 u--fc (vector 0 u--fc e-2) arg-2)))))))))))
(define LibrariesC-45UtilsC-45Shunting-n--6024-4323-u--mkOp (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 0 e-2 e-6 e-10 e-11)))))))))
(define LibrariesC-45UtilsC-45Shunting-shunt (lambda (arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (let ((act-24 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (LibrariesC-45UtilsC-45Shunting-emit arg-3 (LibrariesC-45UtilsC-45Shunting-n--6024-4323-u--mkOp arg-2 arg-4 arg-3 eta-0) eta-1))) arg-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-3))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Invalid input to shunting") clam-0) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-2) (vector 1 e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Invalid input to shunting") clam-0)))))))))))) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (case (vector-ref e-1 0) ((1) (let ((e-6 (vector-ref e-1 1))) (let ((act-24 (LibrariesC-45UtilsC-45Shunting-emit arg-3 (vector 1 e-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else ((LibrariesC-45UtilsC-45Shunting-shunt arg-2 arg-3 arg-4 e-2) clam-0)))))) (else (let ((e-9 (vector-ref e-1 1))) (let ((e-10 (vector-ref e-1 2))) (let ((e-11 (vector-ref e-1 3))) (let ((e-12 (vector-ref e-1 4))) (let ((act-24 ((LibrariesC-45UtilsC-45Shunting-processStack arg-2 arg-3 arg-4 e-11 e-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) ((LibrariesC-45UtilsC-45Shunting-shunt arg-2 arg-3 (cons (cons e-9 (cons e-10 (cons e-11 e-12))) e-5) e-2) clam-0)))))))))))))))))
(define LibrariesC-45UtilsC-45Shunting-processStack (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((act-24 ((LibrariesC-45UtilsC-45Shunting-higher arg-2 e-6 e-14 e-15 arg-5 arg-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--x (cons e-6 (cons e-10 (cons e-14 e-15))))) (cond ((equal? e-5 1) (let ((act-25 (LibrariesC-45UtilsC-45Shunting-emit arg-3 (vector 0 e-6 e-10 e-14 e-15) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((LibrariesC-45UtilsC-45Shunting-processStack arg-2 arg-3 e-3 arg-5 arg-6) clam-0))))) (else (vector 1 (cons u--x e-3)))))))))))))))))))))
(define LibrariesC-45UtilsC-45Shunting-parseOps (lambda (arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Libraries.Utils.Shunting.Out" ) '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((LibrariesC-45UtilsC-45Shunting-shunt arg-2 e-5 '() arg-3) ext-0)))))))
(define LibrariesC-45UtilsC-45Shunting-output (lambda (arg-2 arg-3) (if (null? arg-2) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Invalid input to shunting") clam-0))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Invalid input to shunting") clam-0)))))) (let ((e-5 (car arg-2))) (let ((e-6 (cdr arg-2))) (case (vector-ref arg-3 0) ((0) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (let ((e-27 (vector-ref arg-3 4))) (case (vector-ref e-27 0) ((3) (lambda (eta-0) (vector 1 (cons (vector 1 e-24 e-25 e-26 e-5) e-6))))(else (if (null? e-6) (lambda (clam-2) (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Invalid input to shunting") clam-2)))) (let ((e-14 (car e-6))) (let ((e-15 (cdr e-6))) (lambda (clam-1) (case (vector-ref arg-3 0) ((0) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (vector 1 (cons (vector 0 e-18 e-19 e-20 e-14 e-5) e-15))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Invalid input to shunting") clam-1))))))))))))))))(else (if (null? e-6) (lambda (clam-4) (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Invalid input to shunting") clam-4)))) (let ((e-14 (car e-6))) (let ((e-15 (cdr e-6))) (lambda (clam-2) (case (vector-ref arg-3 0) ((0) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (vector 1 (cons (vector 0 e-18 e-19 e-20 e-14 e-5) e-15))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Invalid input to shunting") clam-2))))))))))))))))
(define LibrariesC-45UtilsC-45Shunting-isLAssoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 1)(else 0))))
(define LibrariesC-45UtilsC-45Shunting-higher (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (lambda (clam-0) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat e-1 (LibrariesC-45UtilsC-45Shunting-getPrec arg-6)))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "Operator '" (PreludeC-45TypesC-45String-C-43C-43 (let ((e-3 (car arg-1))) (e-3 arg-3)) "' is non-associative"))) clam-0)) (else (vector 1 (PreludeC-45Types-u--C-62_Ord_Nat e-1 (LibrariesC-45UtilsC-45Shunting-getPrec arg-6)))))))))(else (lambda (clam-0) (case (vector-ref arg-6 0) ((2) (let ((e-0 (vector-ref arg-6 1))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat (LibrariesC-45UtilsC-45Shunting-getPrec arg-4) e-0))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "Operator '" (PreludeC-45TypesC-45String-C-43C-43 (let ((e-1 (car arg-1))) (e-1 arg-5)) "' is non-associative"))) clam-0)) (else (vector 1 (PreludeC-45Types-u--C-62_Ord_Nat (LibrariesC-45UtilsC-45Shunting-getPrec arg-4) e-0)))))))(else (vector 1 (let ((sc0 (PreludeC-45Types-u--C-62_Ord_Nat (LibrariesC-45UtilsC-45Shunting-getPrec arg-4) (LibrariesC-45UtilsC-45Shunting-getPrec arg-6)))) (cond ((equal? sc0 1) 1) (else (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_Nat (LibrariesC-45UtilsC-45Shunting-getPrec arg-4) (LibrariesC-45UtilsC-45Shunting-getPrec arg-6)))) (cond ((equal? sc1 1) (LibrariesC-45UtilsC-45Shunting-isLAssoc arg-4)) (else 0))))))))))))))))
(define LibrariesC-45UtilsC-45Shunting-getPrec (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) e-1)) ((2) (let ((e-2 (vector-ref arg-0 1))) e-2)) (else (let ((e-3 (vector-ref arg-0 1))) e-3)))))
(define LibrariesC-45UtilsC-45Shunting-emit (lambda (arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((LibrariesC-45UtilsC-45Shunting-output e-5 arg-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-2 e-6))) (vector 1 act-26))))))))))))
(define IdrisC-45ElabC-45Interface-case--elabInterfaceC-44elabDefault-5310 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 ext-0) (if (null? arg-22) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-15 (PreludeC-45TypesC-45String-C-43C-43 "No method named " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-17) (PreludeC-45TypesC-45String-C-43C-43 " in interface " (CoreC-45Name-u--show_Show_Name arg-4))))) ext-0) (let ((e-1 (unbox arg-22))) (vector 1 (cons (let ((e-5 (vector-ref e-1 1))) e-5) (let ((e-4 (vector-ref e-1 4))) e-4)))))))
(define IdrisC-45ElabC-45Interface-n--11842-4600-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (CoreC-45FC-virtualiseFC arg-10)))
(define IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (CoreC-45FC-virtualiseFC (let ((e-0 (vector-ref arg-0 0))) e-0))))
(define IdrisC-45ElabC-45Interface-n--10678-3519-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (CoreC-45FC-virtualiseFC arg-9)))
(define IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (CoreC-45FC-virtualiseFC arg-15)))
(define IdrisC-45ElabC-45Interface-n--11689-4457-u--totMeth (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--treq (IdrisC-45ElabC-45Interface-n--11689-4456-u--findSetTotal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (let ((e-2 (vector-ref arg-9 2))) e-2)))) (lambda (eta-0) (vector 1 (vector (let ((e-0 (vector-ref arg-9 0))) e-0) (let ((e-1 (vector-ref arg-9 1))) e-1) u--treq (let ((e-4 (vector-ref arg-9 4))) e-4)))))))
(define IdrisC-45ElabC-45Interface-n--10977-3810-u--stripParams (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (let ((e-5 (vector-ref arg-11 5))) (let ((e-6 (vector-ref arg-11 6))) (let ((sc1 (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (u--n) (PreludeC-45Types-elem (csegen-802) u--n arg-10))) e-4))) (cond ((equal? sc1 1) (IdrisC-45ElabC-45Interface-n--10977-3810-u--stripParams arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6)) (else (vector 1 e-1 e-2 e-3 e-4 e-5 (IdrisC-45ElabC-45Interface-n--10977-3810-u--stripParams arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6))))))))))))(else arg-11))))
(define IdrisC-45ElabC-45Interface-n--11842-4601-u--paramNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-3)))
(define IdrisC-45ElabC-45Interface-n--11842-4602-u--nameCons (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) '() (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (let ((e-7 (cdr e-2))) (cons (cons (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "__con" (PreludeC-45Show-u--show_Show_Int arg-15)))) e-7) (IdrisC-45ElabC-45Interface-n--11842-4602-u--nameCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (bs+ arg-15 1 63) e-3))))))))
(define IdrisC-45ElabC-45Interface-n--10678-3523-u--mkTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-12) arg-13 (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (IdrisC-45ElabC-45Interface-n--10678-3519-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) e-10 arg-11 e-6 e-11 (IdrisC-45ElabC-45Interface-n--10678-3523-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3 arg-13)))))))))))
(define IdrisC-45ElabC-45Interface-n--11159-3956-u--mkLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (vector 2 (vector 2 ) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box e-2) (vector 32 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) 0) (IdrisC-45ElabC-45Interface-n--11159-3956-u--mkLam arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))
(define IdrisC-45ElabC-45Interface-n--11159-3958-u--methName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (vector 1 (vector 0 (IdrisC-45ElabC-45Interface-n--11159-3957-u--bindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10)))))
(define IdrisC-45ElabC-45Interface-n--10678-3520-u--jname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (box e-2) (cons e-6 e-7))))))))
(define IdrisC-45ElabC-45Interface-n--11476-4257-u--impsBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) arg-12 (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (IdrisC-45ElabC-45Interface-n--11476-4257-u--impsBind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (vector 9 arg-10 arg-12 (vector 17 arg-10 e-2)) e-3))))))
(define IdrisC-45ElabC-45Interface-n--11159-3955-u--getExplicitArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) (let ((e-3 (vector-ref arg-11 3))) (let ((e-6 (vector-ref arg-11 6))) (case (vector-ref e-3 0) ((1) (cons (vector 2 "arg" arg-10) (IdrisC-45ElabC-45Interface-n--11159-3955-u--getExplicitArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (bs+ arg-10 1 63) e-6)))(else (IdrisC-45ElabC-45Interface-n--11159-3955-u--getExplicitArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6))))))(else '()))))
(define IdrisC-45ElabC-45Interface-n--11689-4456-u--findSetTotal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((7) (let ((e-5 (vector-ref e-2 1))) (box e-5)))(else (IdrisC-45ElabC-45Interface-n--11689-4456-u--findSetTotal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3))))))))
(define IdrisC-45ElabC-45Interface-n--11842-4604-u--elabMethods (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45ElabC-45Interface-getMethToplevel arg-6 arg-14 arg-8 arg-9 arg-4 arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-5) arg-16 arg-3 eta-0)) arg-17 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fns (PreludeC-45Interfaces-concat (csegen-50) e-5))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-14 "elab.interface" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Top level methods: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2095) u--fns))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-11 arg-13 arg-12 '() arg-7 arg-8 eta-0)) u--fns ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ (lambda (u--n) (lambda (eta-0) (let ((act-27 (CoreC-45Context-inCurrentNS arg-14 u--n eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-setFlag arg-14 (IdrisC-45ElabC-45Interface-n--11842-4600-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) e-8 (vector 0 ) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45Context-setFlag arg-14 (IdrisC-45ElabC-45Interface-n--11842-4600-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) e-8 (vector 3 ) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (CoreC-45Context-setFlag arg-14 (IdrisC-45ElabC-45Interface-n--11842-4600-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) e-8 (vector 2 ) eta-0))))))))))))) arg-16 ext-0))))))))))))))
(define IdrisC-45ElabC-45Interface-n--11842-4605-u--elabDefault (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--dn_in (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "Default implementation of " (CoreC-45Name-u--show_Show_Name e-10)) 0))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-14 u--dn_in eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45ElabC-45Interface-case--elabInterfaceC-44elabDefault-5310 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15 u--dn_in e-5 (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (u--d) (PreludeC-45Interfaces-C-60C-36 (csegen-73) u--d (PreludeC-45Interfaces-guard (csegen-538) (CoreC-45Name-u--C-61C-61_Eq_Name e-10 (let ((e-0 (vector-ref u--d 0))) e-0))))) arg-15) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((u--ity (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15) arg-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 0 (IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15) eta-1)) (IdrisC-45ElabC-45Interface-n--11842-4601-u--paramNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14))))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (u--d) (let ((u--n (let ((e-0 (vector-ref u--d 0))) e-0))) (lambda (eta-1) (let ((act-26 (CoreC-45Context-inCurrentNS arg-14 u--n eta-1))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (vector 1 (cons u--n (IdrisC-45ElabC-45Interface-n--11876-4947-u--applyParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15 (vector 0 (IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15) e-12) (IdrisC-45ElabC-45Interface-n--11842-4601-u--paramNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14))))))))))) arg-15 '() eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (let ((u--dty (IdrisC-45ElabC-45Interface-n--11876-4946-u--bindPs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15 arg-3 (IdrisC-45ElabC-45Interface-bindIFace (IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15) u--ity (TTImpC-45Utils-substNames arg-6 e-12 e-4))))) (let ((act-27 (TTImpC-45BindImplicits-bindTypeNames arg-14 e-2 '() (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (csegen-3592) arg-15) arg-6) u--dty eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-13 (vector-ref act-27 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-27 1))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-14 "elab.interface.default" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Default method " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) (PreludeC-45TypesC-45String-C-43C-43 " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-13))))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-14 (vector-ref act-28 1))) (vector 0 e-14))) (else (let ((u--dtydecl (vector 0 (IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15) e-9 arg-9 '() (vector (vector 2 ) (vector 2 ) e-5 e-13)))) (let ((act-29 ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-11 arg-13 arg-12 '() arg-7 arg-8 u--dtydecl) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-15 (vector-ref act-29 1))) (vector 0 e-15))) (else (let ((act-30 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45ElabC-45Interface-n--11876-4949-u--changeName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15 e-5 eta-1 eta-2))) e-11 '() eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-16 (vector-ref act-30 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-30 1))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-14 "elab.interface.default" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Default method body " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1283) e-16))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-17 (vector-ref act-31 1))) (vector 0 e-17))) (else (let ((act-32 ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-11 arg-13 arg-12 '() arg-7 arg-8 (vector 2 (IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-6 e-10 e-11 arg-15) e-5 e-16)) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-18 (vector-ref act-32 1))) (vector 0 e-18))) (else (vector 1 (cons e-10 e-11)))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45ElabC-45Interface-n--11842-4606-u--elabConstraintHints (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (let ((u--nconstraints (IdrisC-45ElabC-45Interface-n--11842-4602-u--nameCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 0 arg-5))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45ElabC-45Interface-getConstraintHint arg-6 arg-14 (IdrisC-45ElabC-45Interface-n--11842-4600-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) arg-8 arg-9 arg-4 arg-15 (PreludeC-45Types-u--map_Functor_List (lambda (eta-2) (Builtin-fst eta-2)) u--nconstraints) arg-16 (IdrisC-45ElabC-45Interface-n--11842-4601-u--paramNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) eta-1)) u--nconstraints '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-14 "elab.interface" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Constraint hints from " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3595) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3595) u--d u--x)))) arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3599) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3599) u--d u--x)))) e-5))))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-1) (TTImpC-45ElabC-45Check-processDecl arg-6 arg-14 arg-11 arg-13 arg-12 '() arg-7 arg-8 eta-1)) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-1) (Builtin-snd eta-1)) e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ (lambda (u--n) (lambda (eta-1) (let ((act-27 (CoreC-45Context-inCurrentNS arg-14 u--n eta-1))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Context-setFlag arg-14 (IdrisC-45ElabC-45Interface-n--11842-4600-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) e-8 (vector 3 ) eta-1))))))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) e-5) eta-0)))))))))))))))
(define IdrisC-45ElabC-45Interface-n--11842-4603-u--elabAsData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (u--meth) (IdrisC-45ElabC-45Interface-getMethDecl arg-6 arg-14 arg-8 arg-7 arg-3 arg-16 (cons (let ((e-1 (vector-ref u--meth 1))) e-1) (cons (let ((e-3 (vector-ref u--meth 3))) e-3) (let ((e-6 (vector-ref u--meth 6))) e-6))))) arg-17 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-14 "elab.interface" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Method declarations: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-3604) e-5))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45ElabC-45Interface-getMethDecl arg-6 arg-14 arg-8 arg-7 arg-3 arg-16 (cons (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) eta-0))) arg-5 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-14 "elab.interface" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Constraints: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3614) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3614) u--d u--x)))) e-7))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((IdrisC-45ElabC-45Interface-mkIfaceData arg-6 arg-14 (IdrisC-45ElabC-45Interface-n--11842-4600-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) arg-9 arg-8 e-7 arg-4 arg-15 arg-3 arg-2 e-5) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45ContextC-45Log-log arg-14 "elab.interface" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Methods: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-3604) e-5))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45ContextC-45Log-log arg-14 "elab.interface" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Making interface data type " (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 (csegen-737) e-9))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (TTImpC-45ProcessDecls-processDecls arg-6 arg-14 arg-11 arg-13 arg-12 arg-7 arg-8 (cons e-9 '()) eta-0)) ext-0)))))))))))))))))))))))))))
(define IdrisC-45ElabC-45Interface-n--11476-4256-u--constName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 1 (vector 0 (IdrisC-45ElabC-45Interface-n--11476-4255-u--bindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12)))))
(define IdrisC-45ElabC-45Interface-n--11876-4948-u--changeNameTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (lambda (clam-0) (case (vector-ref arg-21 0) ((0) (let ((e-1 (vector-ref arg-21 1))) (let ((e-2 (vector-ref arg-21 2))) (let ((sc1 (CoreC-45Name-u--C-47C-61_Eq_Name arg-17 e-2))) (cond ((equal? sc1 1) (vector 1 (vector 0 e-1 e-2))) (else (let ((act-24 (CoreC-45ContextC-45Log-log arg-14 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "elabDefault is trying to add Function: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-17) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45FC-u--show_Show_FC e-1) ")"))))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (let ((sc3 (CoreC-45FC-isConcreteFC e-1))) (if (null? sc3) (vector 1 0) (let ((e-3 (unbox sc3))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-14 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "elabDefault is adding Function: " (CoreC-45Name-u--show_Show_Name arg-17))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (CoreC-45Metadata-addSemanticDecorations arg-11 arg-14 (cons (cons e-3 (cons 2 (box arg-17))) '()) clam-0))))))))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 (vector 0 e-1 arg-20)))))))))))))) ((8) (let ((e-4 (vector-ref arg-21 1))) (let ((e-5 (vector-ref arg-21 2))) (let ((e-6 (vector-ref arg-21 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 8 e-4 e-7 eta-2))))))) (IdrisC-45ElabC-45Interface-n--11876-4948-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-5) eta-0)) (lambda (eta-0) (vector 1 e-6)) clam-0))))) ((9) (let ((e-8 (vector-ref arg-21 1))) (let ((e-9 (vector-ref arg-21 2))) (let ((e-10 (vector-ref arg-21 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 9 e-8 e-5 eta-2))))))) (IdrisC-45ElabC-45Interface-n--11876-4948-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-9) eta-0)) (lambda (eta-0) (vector 1 e-10)) clam-0))))) ((10) (let ((e-12 (vector-ref arg-21 1))) (let ((e-13 (vector-ref arg-21 2))) (let ((e-14 (vector-ref arg-21 3))) (let ((e-15 (vector-ref arg-21 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 10 e-12 e-5 eta-3 eta-4)))))))) (IdrisC-45ElabC-45Interface-n--11876-4948-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-13) eta-1)) (lambda (eta-1) (vector 1 e-14)) eta-0)) (lambda (eta-0) (vector 1 e-15)) clam-0))))))(else (vector 1 arg-21))))))
(define IdrisC-45ElabC-45Interface-n--11876-4949-u--changeName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (case (vector-ref arg-21 0) ((0) (let ((e-1 (vector-ref arg-21 1))) (let ((e-2 (vector-ref arg-21 2))) (let ((e-3 (vector-ref arg-21 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 0 e-1 e-5 eta-2))))))) (IdrisC-45ElabC-45Interface-n--11876-4948-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-2) eta-0)) (lambda (eta-0) (vector 1 e-3)) ext-0))))) ((1) (let ((e-5 (vector-ref arg-21 1))) (let ((e-6 (vector-ref arg-21 2))) (let ((e-7 (vector-ref arg-21 3))) (let ((e-8 (vector-ref arg-21 4))) (let ((e-9 (vector-ref arg-21 5))) (let ((e-10 (vector-ref arg-21 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-2 (vector-ref eta-4 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref eta-4 1))) (vector 1 (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (vector 1 e-5 e-11 eta-5 eta-6 eta-7 eta-8)))))))))) (IdrisC-45ElabC-45Interface-n--11876-4948-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-6) eta-3)) (lambda (eta-3) (vector 1 e-7)) eta-2)) (lambda (eta-2) (vector 1 e-8)) eta-1)) (lambda (eta-1) (vector 1 e-9)) eta-0)) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45ElabC-45Interface-n--11876-4949-u--changeName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 eta-1 eta-2))) e-10 '() eta-0)) ext-0)))))))) (else (let ((e-12 (vector-ref arg-21 1))) (let ((e-13 (vector-ref arg-21 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-12 e-5)))))) (IdrisC-45ElabC-45Interface-n--11876-4948-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-13) ext-0)))))))
(define IdrisC-45ElabC-45Interface-n--10678-3521-u--bname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (box e-2) (cons e-6 (vector 16 (TTImpC-45TTImp-getFC e-7) (csegen-1885) e-7)))))))))
(define IdrisC-45ElabC-45Interface-n--11876-4946-u--bindPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-20) arg-21 (let ((e-2 (car arg-20))) (let ((e-3 (cdr arg-20))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (TTImpC-45TTImp-getFC e-11) e-10 (vector 0 ) (box e-6) e-11 (IdrisC-45ElabC-45Interface-n--11876-4946-u--bindPs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-3 arg-21)))))))))))
(define IdrisC-45ElabC-45Interface-n--11159-3953-u--bindPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (TTImpC-45TTImp-getFC e-11) e-10 (vector 0 ) (box e-6) e-11 (IdrisC-45ElabC-45Interface-n--11159-3953-u--bindPs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))))))
(define IdrisC-45ElabC-45Interface-n--11476-4255-u--bindName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((1) (let ((e-0 (vector-ref arg-12 1))) (PreludeC-45TypesC-45String-C-43C-43 "__bind_" (CoreC-45Name-displayUserName e-0)))) ((0) (let ((e-2 (vector-ref arg-12 2))) (IdrisC-45ElabC-45Interface-n--11476-4255-u--bindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2)))(else (CoreC-45Name-u--show_Show_Name arg-12)))))
(define IdrisC-45ElabC-45Interface-n--11159-3957-u--bindName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((1) (let ((e-0 (vector-ref arg-10 1))) (PreludeC-45TypesC-45String-C-43C-43 "__bind_" (CoreC-45Name-displayUserName e-0)))) ((0) (let ((e-2 (vector-ref arg-10 2))) (IdrisC-45ElabC-45Interface-n--11159-3957-u--bindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2)))(else (CoreC-45Name-u--show_Show_Name arg-10)))))
(define IdrisC-45ElabC-45Interface-n--10678-3522-u--bhere (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons e-6 (vector 16 (TTImpC-45TTImp-getFC e-7) (csegen-1885) e-7)))))))))
(define IdrisC-45ElabC-45Interface-n--11876-4947-u--applyParams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-21) arg-20 (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (IdrisC-45ElabC-45Interface-n--11876-4947-u--applyParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 10 (IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-20 (vector 1 (vector 0 e-5)) (vector 17 (IdrisC-45ElabC-45Interface-n--11876-4945-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) e-5)) e-3)))(else (IdrisC-45ElabC-45Interface-n--11876-4947-u--applyParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-3)))))(else (IdrisC-45ElabC-45Interface-n--11876-4947-u--applyParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-3))))))))
(define IdrisC-45ElabC-45Interface-n--11159-3954-u--applyCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--name (vector 1 (vector 0 "__con")))) (cons arg-10 (vector 10 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (vector 0 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) arg-10) u--name (vector 0 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) u--name))))))
(define IdrisC-45ElabC-45Interface-updateIfaceSyn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--11689-4457-u--totMeth arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) arg-7 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--info (vector arg-3 arg-4 arg-5 arg-6 e-6 arg-8))) (let ((act-26 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-11 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (vector e-0 e-1 e-2 e-3 (cons arg-2 e-4) (LibrariesC-45DataC-45ANameMap-addName arg-2 u--info e-12) e-11 e-7 e-8 e-9 e-10))))))))))))))) (vector 1 act-26)))))))))))))
(define IdrisC-45ElabC-45Interface-sigToDecl (lambda (arg-0) (vector (let ((e-3 (vector-ref arg-0 3))) e-3) (let ((e-1 (vector-ref arg-0 1))) e-1) (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-5 (vector-ref arg-0 5))) e-5) (let ((e-6 (vector-ref arg-0 6))) e-6))))
(define IdrisC-45ElabC-45Interface-namePis (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (case (vector-ref e-3 0) ((2) (if (null? e-4) (vector 1 e-1 e-2 (vector 2 ) (box (vector 2 "i_con" arg-0)) e-5 (IdrisC-45ElabC-45Interface-namePis (bs+ arg-0 1 63) e-6)) (vector 1 e-1 e-2 e-3 e-4 e-5 (IdrisC-45ElabC-45Interface-namePis arg-0 e-6)))) ((0) (if (null? e-4) (vector 1 e-1 e-2 (vector 0 ) (box (vector 2 "i_imp" arg-0)) e-5 (IdrisC-45ElabC-45Interface-namePis (bs+ arg-0 1 63) e-6)) (vector 1 e-1 e-2 e-3 e-4 e-5 (IdrisC-45ElabC-45Interface-namePis arg-0 e-6))))(else (vector 1 e-1 e-2 e-3 e-4 e-5 (IdrisC-45ElabC-45Interface-namePis arg-0 e-6))))))))))) ((16) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (vector 16 e-8 e-9 (IdrisC-45ElabC-45Interface-namePis arg-0 e-10))))))(else arg-1))))
(define IdrisC-45ElabC-45Interface-mkIfaceData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--opts (let ((sc0 (DataC-45List-isNil arg-9))) (cond ((equal? sc0 1) (cons (vector 1 ) (cons (vector 2 ) '()))) (else (cons (vector 1 ) (cons (vector 2 ) (cons (vector 0 arg-9) '())))))))) (let ((u--pNames (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-8))) (let ((u--retty (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Interface-n--10678-3519-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) arg-6) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 0 (vector 2 ) eta-0)) u--pNames)))) (let ((u--conty (IdrisC-45ElabC-45Interface-n--10678-3523-u--mkTy arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 (vector 0 ) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--10678-3520-u--jname arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-8) (IdrisC-45ElabC-45Interface-n--10678-3523-u--mkTy arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 (vector 2 ) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--10678-3522-u--bhere arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-5) (IdrisC-45ElabC-45Interface-n--10678-3523-u--mkTy arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 (vector 1 ) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--10678-3521-u--bname arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-10) u--retty))))) (lambda (eta-0) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-2 '() (PreludeC-45TypesC-45List-tailRecAppend u--pNames (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-10) arg-0)) u--conty eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--con (vector (vector 2 ) (vector 2 ) arg-7 e-5))) (let ((act-25 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-2 '() (PreludeC-45TypesC-45List-tailRecAppend u--pNames (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-10) arg-0)) (IdrisC-45ElabC-45Interface-mkDataTy (IdrisC-45ElabC-45Interface-n--10678-3519-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) arg-8) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 1 (IdrisC-45ElabC-45Interface-n--10678-3519-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) arg-3 (vector 0 (IdrisC-45ElabC-45Interface-n--10678-3519-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) arg-6 e-6 u--opts (cons u--con '()))))))))))))))))))))
(define IdrisC-45ElabC-45Interface-mkDataTy (lambda (arg-0 arg-1) (if (null? arg-1) (vector 29 arg-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-11 (cdr e-7))) (vector 1 arg-0 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (box e-6) e-11 (IdrisC-45ElabC-45Interface-mkDataTy arg-0 e-3))))))))))
(define IdrisC-45ElabC-45Interface-mkCon (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (let ((u--str (CoreC-45Name-displayUserName e-2))) (vector 0 e-0 (vector 4 (PreludeC-45TypesC-45String-C-43C-43 u--str (PreludeC-45TypesC-45String-C-43C-43 " at " (CoreC-45FC-u--show_Show_FC arg-0))) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "__mk" u--str))))))))(else (let ((u--str (CoreC-45Name-u--show_Show_Name arg-1))) (vector 4 (PreludeC-45TypesC-45String-C-43C-43 u--str (PreludeC-45TypesC-45String-C-43C-43 " at " (CoreC-45FC-u--show_Show_FC arg-0))) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "__mk" u--str))))))))))(else (let ((u--str (CoreC-45Name-u--show_Show_Name arg-1))) (vector 4 (PreludeC-45TypesC-45String-C-43C-43 u--str (PreludeC-45TypesC-45String-C-43C-43 " at " (CoreC-45FC-u--show_Show_FC arg-0))) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "__mk" u--str)))))))))
(define IdrisC-45ElabC-45Interface-getSig (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-11 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-13 (vector-ref e-5 2))) (let ((e-14 (vector-ref e-5 3))) (box (vector e-11 e-2 e-4 e-13 e-12 0 (IdrisC-45ElabC-45Interface-namePis 0 e-14))))))))))) ((1) (let ((e-9 (vector-ref arg-0 3))) (case (vector-ref e-9 0) ((1) (let ((e-16 (vector-ref e-9 1))) (let ((e-17 (vector-ref e-9 2))) (let ((e-18 (vector-ref e-9 3))) (box (vector e-16 (csegen-21) (cons (vector 6 ) '()) e-17 (CoreC-45FC-emptyFC) 1 (IdrisC-45ElabC-45Interface-namePis 0 e-18)))))))(else '()))))(else '()))))
(define IdrisC-45ElabC-45Interface-getMethToplevel (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--paramNames (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-8))) (let ((u--ity (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) arg-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 0 (vector 2 ) eta-0)) u--paramNames)))) (let ((u--ty_constr (TTImpC-45Utils-substNames arg-0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--11159-3954-u--applyCon arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 eta-0)) arg-7) (let ((e-6 (vector-ref arg-9 6))) e-6)))) (lambda (eta-0) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-1 (vector 2 ) '() arg-0 (IdrisC-45ElabC-45Interface-n--11159-3953-u--bindPs arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 arg-8 (IdrisC-45ElabC-45Interface-bindIFace (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) u--ity u--ty_constr)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-inCurrentNS arg-1 (let ((e-3 (vector-ref arg-9 3))) e-3) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--tydecl (vector 0 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) (let ((e-1 (vector-ref arg-9 1))) e-1) arg-3 (let ((sc2 (let ((e-8 (vector-ref arg-9 5))) e-8))) (cond ((equal? sc2 1) (cons (vector 0 ) (cons (vector 6 ) '()))) (else (cons (vector 0 ) '())))) (vector (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) (let ((e-4 (vector-ref arg-9 4))) e-4) e-6 e-5)))) (let ((u--conapp (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) arg-5) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 17 (vector 2 ) eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (IdrisC-45ElabC-45Interface-n--11159-3957-u--bindName arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 eta-1)) arg-7))))) (let ((u--argns (IdrisC-45ElabC-45Interface-n--11159-3955-u--getExplicitArgs arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 0 (let ((e-7 (vector-ref arg-9 6))) e-7)))) (let ((u--fnclause (vector 0 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) (vector 10 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) (vector 0 (let ((e-0 (vector-ref arg-9 0))) e-0) e-6) (vector 1 (vector 0 "__con")) u--conapp) (IdrisC-45ElabC-45Interface-n--11159-3956-u--mkLam arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 u--argns (TTImpC-45TTImp-apply (vector 0 (vector 2 ) (IdrisC-45ElabC-45Interface-n--11159-3958-u--methName arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 (let ((e-3 (vector-ref arg-9 3))) e-3))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 0 (vector 2 ) eta-1)) u--argns)))))) (let ((u--fndef (vector 2 (IdrisC-45ElabC-45Interface-n--11159-3952-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) e-6 (cons u--fnclause '())))) (vector 1 (cons u--tydecl (cons u--fndef '()))))))))))))))))))))))
(define IdrisC-45ElabC-45Interface-getMethDecl (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--paramNames (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-5))) (lambda (eta-0) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-2 (vector 2 ) '() (PreludeC-45TypesC-45List-tailRecAppend u--paramNames (PreludeC-45TypesC-45List-tailRecAppend arg-6 arg-1)) e-7 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-6 (cons e-2 (IdrisC-45ElabC-45Interface-n--10977-3810-u--stripParams arg-2 e-2 e-6 e-7 arg-6 arg-5 arg-1 arg-4 arg-3 u--paramNames e-5))))))))))))))))
(define IdrisC-45ElabC-45Interface-getImplParams (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (cons e-2 (IdrisC-45ElabC-45Interface-getImplParams e-4)))(else '()))))(else '()))))))(else '()))))
(define IdrisC-45ElabC-45Interface-getDefault (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (box (cons e-1 (cons '() (cons e-2 e-3))))))))(else '()))))
(define IdrisC-45ElabC-45Interface-getConstraintHint (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((u--ity (TTImpC-45TTImp-apply (vector 0 arg-2 arg-5) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 0 arg-2 eta-0)) arg-9)))) (let ((u--fty (vector 1 arg-2 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) '() u--ity e-3))) (lambda (eta-0) (let ((act-24 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-2 '() (PreludeC-45TypesC-45List-tailRecAppend arg-8 arg-0) u--fty eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--hintname (vector 4 (PreludeC-45TypesC-45String-C-43C-43 "Constraint " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-3)) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "__" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-5) (PreludeC-45TypesC-45String-C-43C-43 "_" (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-3))))))))) (let ((u--tydecl (vector 0 arg-2 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) arg-4 (cons (vector 0 ) (cons (vector 2 0) '())) (vector (vector 2 ) (vector 2 ) u--hintname e-5)))) (let ((u--conapp (TTImpC-45TTImp-apply (IdrisC-45ElabC-45Interface-n--11476-4257-u--impsBind e-2 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-0 arg-3 arg-2 arg-1 (vector 0 arg-2 arg-6) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (IdrisC-45ElabC-45Interface-n--11476-4255-u--bindName e-2 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-0 arg-3 arg-2 arg-1 eta-1)) arg-7)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 32 arg-2 1)) arg-8)))) (let ((u--fnclause (vector 0 arg-2 (vector 8 arg-2 (vector 0 arg-2 u--hintname) u--conapp) (vector 0 arg-2 (IdrisC-45ElabC-45Interface-n--11476-4256-u--constName e-2 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-0 arg-3 arg-2 arg-1 e-2))))) (let ((u--fndef (vector 2 arg-2 u--hintname (cons u--fnclause '())))) (vector 1 (cons u--hintname (cons u--tydecl (cons u--fndef '()))))))))))))))))))))
(define IdrisC-45ElabC-45Interface-elabInterface (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-24 (CoreC-45Context-getFullName arg-1 arg-10 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-inCurrentNS arg-1 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--conName_in (PreludeC-45Types-maybe (lambda () (IdrisC-45ElabC-45Interface-mkCon (IdrisC-45ElabC-45Interface-n--11842-4600-u--vfc arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) e-5)) (lambda () (lambda (eta-0) eta-0)) arg-13))) (let ((act-26 (CoreC-45Context-inCurrentNS arg-1 u--conName_in ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--meth_sigs (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45ElabC-45Interface-getSig eta-0)) arg-14))) (let ((u--meth_decls (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Interface-sigToDecl eta-0)) u--meth_sigs))) (let ((u--meth_names (PreludeC-45Types-u--map_Functor_List (csegen-3592) u--meth_decls))) (let ((u--defaults (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45ElabC-45Interface-getDefault eta-0)) arg-14))) (let ((act-27 (IdrisC-45ElabC-45Interface-n--11842-4603-u--elabAsData arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 u--meth_names u--meth_sigs ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((IdrisC-45ElabC-45Interface-n--11842-4606-u--elabConstraintHints arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 u--meth_names) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (IdrisC-45ElabC-45Interface-n--11842-4604-u--elabMethods arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 u--meth_names u--meth_sigs ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--11842-4605-u--elabDefault arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--meth_decls eta-0)) u--defaults '() ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Core-traverseC-39 (lambda (u--mt) (lambda (eta-0) (let ((act-31 (CoreC-45Context-inCurrentNS arg-1 (let ((e-0 (vector-ref u--mt 0))) e-0) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (let ((e-1 (vector-ref u--mt 1))) (let ((e-2 (vector-ref u--mt 2))) (let ((e-3 (vector-ref u--mt 3))) (let ((e-4 (vector-ref u--mt 4))) (vector e-12 e-1 e-2 e-3 e-4)))))))))))) u--meth_decls '() ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (unbox arg-1))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Context-lookupTyExact e-6 (let ((e-0 (vector-ref e-13 0))) e-0) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (if (null? e-14) (CoreC-45Context-undefinedName arg-1 arg-5 arg-10 ext-0) (let ((e-1 (unbox e-14))) (let ((u--implParams (IdrisC-45ElabC-45Interface-getImplParams e-1))) (IdrisC-45ElabC-45Interface-updateIfaceSyn arg-1 arg-3 e-6 e-7 u--implParams (IdrisC-45ElabC-45Interface-n--11842-4601-u--paramNames arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) arg-9) e-12 e-11 ext-0))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45ElabC-45Interface-bindIFace (lambda (arg-0 arg-1 arg-2) (vector 1 arg-0 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 2 ) (box (vector 1 (vector 0 "__con"))) arg-1 arg-2)))
(define IdrisC-45ElabC-45Implementation-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32elabImplementation-11111 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 arg-40 arg-41 arg-42 arg-43 ext-0) (let ((e-2 (car arg-43))) (let ((e-3 (cdr arg-43))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Added defaults: body is " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2095) e-2))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Missing methods: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) e-3))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (let ((sc3 (DataC-45List-isNil e-3))) (cond ((equal? sc3 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-14 (PreludeC-45TypesC-45String-C-43C-43 "Missing methods in " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-3)))))) ext-0)))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (let ((act-27 (unbox arg-18))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--hs (let ((e-9 (vector-ref e-8 9))) e-9))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Open hints: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (cons arg-20 arg-1)))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CoreC-45Core-traverse_ (lambda (u--n) (lambda (eta-0) (let ((act-29 (CoreC-45Context-checkUnambig arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) u--n eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (CoreC-45Context-addOpenHint arg-18 e-10 eta-0))))))) arg-1 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (let ((act-30 (unbox arg-18))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (IdrisC-45ElabC-45Implementation-n--11131-8567-u--topMethTypes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 '() arg-20 arg-42 arg-31 (let ((e-1 (vector-ref arg-26 1))) e-1) (let ((e-14 (vector-ref arg-26 2))) e-14) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (let ((e-0 (vector-ref eta-0 0))) e-0)) (let ((e-4 (vector-ref arg-26 4))) e-4)) (let ((e-4 (vector-ref arg-26 4))) e-4) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl arg-8 arg-18 arg-15 arg-17 arg-16 '() arg-9 arg-10 eta-0)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--11131-8568-u--mkTopMethDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) e-12) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((u--mtops (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst (Builtin-snd eta-0))) e-12))) (let ((u--con (let ((e-0 (vector-ref arg-26 0))) e-0))) (let ((u--ilhs (IdrisC-45ElabC-45Implementation-n--11131-8558-u--impsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 0 (vector 2 ) arg-20) (PreludeC-45Types-u--map_Functor_List (lambda (u--x) (cons u--x (vector 17 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (CoreC-45Name-u--show_Show_Name u--x)))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-42))))) (let ((act-33 (let ((act-33 (unbox arg-18))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Normalise-normaliseHoles arg-18 '() e-14 '() arg-29 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-34 1))) (let ((u--fldTys (IdrisC-45ElabC-45Implementation-n--11131-8557-u--getFieldArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-15))) (let ((act-35 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Field types " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3622) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3622) u--d u--x)))) u--fldTys))) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (let ((u--irhs (TTImpC-45TTImp-apply (IdrisC-45ElabC-45Implementation-n--11131-8559-u--autoImpsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) u--con) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (vector 12 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (PreludeC-45Types-u--fromInteger_Num_Nat 500))) (let ((e-18 (vector-ref arg-26 3))) e-18))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--11131-8562-u--mkMethField arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-42 u--fldTys eta-0)) e-12)))) (let ((u--impFn (vector 2 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-20 (cons (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) u--ilhs u--irhs) '())))) (let ((act-36 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Implementation record: " (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 (csegen-737) u--impFn))) ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-4 (vector-ref act-36 1))) (vector 0 e-4))) (else (let ((act-37 (cond ((equal? arg-3 1) (CoreC-45Context-addOpenHint arg-18 arg-20 ext-0)) (else (vector 1 0))))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (let ((act-38 (CoreC-45Context-setFlag arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-20 (vector 5 ) ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-4 (vector-ref act-38 1))) (vector 0 e-4))) (else (let ((act-39 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45ElabC-45Implementation-n--11131-8556-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0 eta-1))) (cons arg-20 u--mtops) '() ext-0))) (case (vector-ref act-39 0) ((0) (let ((e-4 (vector-ref act-39 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-39 1))) (let ((u--nestC-39 (PreludeC-45TypesC-45List-tailRecAppend e-20 arg-9))) (let ((act-40 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl arg-8 arg-18 arg-15 arg-17 arg-16 '() u--nestC-39 arg-10 eta-0)) (cons u--impFn '()) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-4 (vector-ref act-40 1))) (vector 0 e-4))) (else (let ((act-41 (CoreC-45Context-unsetFlag arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-20 (vector 5 ) ext-0))) (case (vector-ref act-41 0) ((0) (let ((e-4 (vector-ref act-41 1))) (vector 0 e-4))) (else (let ((act-42 (CoreC-45Context-setFlag arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-20 (vector 3 ) ext-0))) (case (vector-ref act-42 0) ((0) (let ((e-4 (vector-ref act-42 1))) (vector 0 e-4))) (else (let ((act-43 (CoreC-45Context-setFlag arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-20 (vector 4 2) ext-0))) (case (vector-ref act-43 0) ((0) (let ((e-4 (vector-ref act-43 1))) (vector 0 e-4))) (else (let ((u--upds (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--11131-8569-u--methNameUpdate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) e-12))) (let ((act-44 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45ElabC-45Implementation-n--11131-8573-u--updateBody arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 u--upds eta-0 eta-1))) e-2 '() ext-0))) (case (vector-ref act-44 0) ((0) (let ((e-4 (vector-ref act-44 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-44 1))) (let ((act-45 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Implementation body: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2095) e-25))) ext-0))) (case (vector-ref act-45 0) ((0) (let ((e-4 (vector-ref act-45 1))) (vector 0 e-4))) (else (let ((act-46 (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl arg-8 arg-18 arg-15 arg-17 arg-16 '() u--nestC-39 arg-10 eta-0)) e-25 ext-0))) (case (vector-ref act-46 0) ((0) (let ((e-4 (vector-ref act-46 1))) (vector 0 e-4))) (else (let ((act-47 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (IdrisC-45ElabC-45Implementation-n--11131-8574-u--addTransform arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 u--upds eta-0 eta-1))) (let ((e-4 (vector-ref arg-26 4))) e-4) ext-0))) (case (vector-ref act-47 0) ((0) (let ((e-4 (vector-ref act-47 1))) (vector 0 e-4))) (else (let ((act-48 (CoreC-45Context-unsetFlag arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-20 (vector 3 ) ext-0))) (case (vector-ref act-48 0) ((0) (let ((e-4 (vector-ref act-48 1))) (vector 0 e-4))) (else (CoreC-45Context-setOpenHints arg-18 u--hs ext-0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45ElabC-45Implementation-case--elabImplementation-10543 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (if (null? arg-24) (lambda (eta-0) (CoreC-45Context-undefinedName arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-5 eta-0)) (let ((e-1 (car arg-24))) (let ((e-2 (cdr arg-24))) (if (null? e-2) (let ((u--cn (Builtin-fst e-1))) (let ((u--cdata (Builtin-snd e-1))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-lookupTyExact u--cn (let ((e-0 (vector-ref arg-22 0))) e-0) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Context-undefinedName arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) u--cn eta-0) (let ((e-3 (unbox e-5))) (let ((act-25 (CoreC-45Context-lookupTyExact (let ((e-0 (vector-ref u--cdata 0))) e-0) (let ((e-0 (vector-ref arg-22 0))) e-0) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((_-0 (box e-3))) (if (null? e-6) (CoreC-45Context-undefinedName arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-0 (vector-ref u--cdata 0))) e-0) eta-0) (let ((e-4 (unbox e-6))) (let ((u--impsp (DataC-45List-nub (csegen-17) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-1) (TTImpC-45TTImp-findIBinds eta-1)) arg-4) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-1) (TTImpC-45TTImp-findIBinds eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) arg-6)))))) (let ((act-26 (CoreC-45ContextC-45Log-logTerm '() arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Found interface " (CoreC-45Name-u--show_Show_Name u--cn))) e-3 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((act-27 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "\xa;  with params: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (let ((e-11 (vector-ref u--cdata 2))) e-11)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  specialised to: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1280) arg-4) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  and parents: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1280) (let ((e-10 (vector-ref u--cdata 3))) e-10)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  using implicits: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) u--impsp) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  and methods: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (IdrisC-45Syntax-u--show_Show_Method u--x)) (lambda (u--d) (lambda (u--x) (IdrisC-45Syntax-u--showPrec_Show_Method u--d u--x)))) (let ((e-9 (vector-ref u--cdata 4))) e-9)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "\xa;Constructor: " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref u--cdata 0))) e-0)) "\xa;")))))))))))))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((act-28 (CoreC-45ContextC-45Log-logTerm '() arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () "Constructor type: ") e-4 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Making implementation " (CoreC-45Name-u--show_Show_Name arg-20))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-10 (vector-ref act-29 1))) (vector 0 e-10))) (else (let ((u--opts (cond ((equal? arg-3 1) (cons (vector 0 ) '())) (else (cons (vector 0 ) (cons (vector 2 1) '())))))) (let ((u--initTy (IdrisC-45ElabC-45Implementation-bindImpls (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-7 (IdrisC-45ElabC-45Implementation-bindConstraints (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (vector 2 ) arg-6 (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-5) arg-4))))) (let ((act-30 (CoreC-45Context-isUnboundImplicits arg-18 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-11 (vector-ref act-30 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-30 1))) (let ((u--paramBinds (cond ((equal? e-11 1) (TTImpC-45Utils-findBindableNames 1 arg-8 '() u--initTy)) (else '())))) (let ((u--impTy (TTImpC-45BindImplicits-doBind u--paramBinds u--initTy))) (let ((u--impTyDecl (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) arg-13 u--opts (vector (vector 2 ) (vector 2 ) arg-20 u--impTy)))) (let ((act-31 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Implementation type: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--impTy))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-12 (vector-ref act-31 1))) (vector 0 e-12))) (else (let ((act-32 (let ((sc12 (IdrisC-45Syntax-typePass arg-11))) (cond ((equal? sc12 1) ((TTImpC-45ElabC-45Check-processDecl arg-8 arg-18 arg-15 arg-17 arg-16 '() arg-9 arg-10 u--impTyDecl) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-32 0) ((0) (let ((e-13 (vector-ref act-32 1))) (vector 0 e-13))) (else (let ((sc13 (IdrisC-45Syntax-defPass arg-11))) (cond ((equal? sc13 1) (if (null? arg-0) (vector 1 0) (let ((e-14 (unbox arg-0))) (let ((act-33 (let ((act-33 (unbox arg-18))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-15 (vector-ref act-33 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Context-lookupTyExact arg-20 (let ((e-0 (vector-ref e-15 0))) e-0) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-16 (vector-ref act-34 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-34 1))) (let ((_-1 (box e-4))) (if (null? e-16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't happen, can't find type of " (CoreC-45Name-u--show_Show_Name arg-20))) eta-0) (let ((e-17 (unbox e-16))) (let ((act-35 ((IdrisC-45ElabC-45Implementation-getMethImps '() arg-18 '() e-17) eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-18 (vector-ref act-35 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-35 1))) (let ((act-36 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Bind implicits to each method: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-3604) e-18))) eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-19 (vector-ref act-36 1))) (vector 0 e-19))) (else (let ((_-2 (box e-17))) (IdrisC-45ElabC-45Implementation-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32elabImplementation-11111 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 e-1 u--cn u--cdata e-3 _-0 e-4 _-1 u--impsp u--opts u--initTy e-11 u--paramBinds u--impTy u--impTyDecl e-14 e-15 e-17 _-2 e-18 (IdrisC-45ElabC-45Implementation-addDefaults (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-20 (DataC-45List-u--zip_Zippable_List (let ((e-23 (vector-ref u--cdata 2))) e-23) arg-4) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45Name-dropNS (let ((e-0 (vector-ref eta-1 0))) e-0))) (let ((e-21 (vector-ref u--cdata 4))) e-21)) (let ((e-20 (vector-ref u--cdata 5))) e-20) e-14) eta-0))))))))))))))))))))))) (else (vector 1 0)))))))))))))))))))))))))))))))))))))))))))))))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-24)) eta-0))))))))
(define IdrisC-45ElabC-45Implementation-case--elabImplementationC-44topMethType-9112 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31) (let ((e-2 (car arg-31))) (let ((e-3 (cdr arg-31))) (let ((u--mty_in (TTImpC-45Utils-substNames arg-8 arg-26 e-3))) (let ((u--mty_iparams (TTImpC-45Utils-substBindVars arg-8 (PreludeC-45Types-u--map_Functor_List (lambda (u--n) (cons u--n (vector 32 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) 0))) arg-22) u--mty_in))) (let ((u--mty_params (TTImpC-45Utils-substNames arg-8 (DataC-45List-u--zip_Zippable_List arg-21 arg-4) u--mty_iparams))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Substitute implicits " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-22) (PreludeC-45TypesC-45String-C-43C-43 " parameters " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2233) (DataC-45List-u--zip_Zippable_List arg-21 arg-4)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--mty_in) (PreludeC-45TypesC-45String-C-43C-43 " is " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--mty_params))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((u--mbase (IdrisC-45ElabC-45Implementation-n--11131-8565-u--bindImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-24 (IdrisC-45ElabC-45Implementation-bindConstraints (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (vector 2 ) arg-6 u--mty_params)))) (let ((u--ibound (TTImpC-45TTImp-findImplicits u--mbase))) (let ((act-25 (TTImpC-45BindImplicits-bindTypeNamesUsed arg-18 arg-14 u--ibound arg-8 u--mbase eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Method " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-19 0))) e-0)) (PreludeC-45TypesC-45String-C-43C-43 " ==> " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-27) (PreludeC-45TypesC-45String-C-43C-43 " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) e-6))))))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "    (initially " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--mty_in) ")"))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Updates " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2233) arg-26))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "From " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--mbase))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Name updates " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2171) e-2))) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Param names: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) arg-21))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((act-32 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Used names " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) u--ibound))) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((u--ibinds (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) arg-24))) (let ((u--methupdsC-39 (let ((sc10 (DataC-45List-isNil u--ibinds))) (cond ((equal? sc10 1) '()) (else (cons (cons arg-27 (IdrisC-45ElabC-45Implementation-n--11131-8558-u--impsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-27) (PreludeC-45Types-u--map_Functor_List (lambda (u--x) (cons u--x (vector 17 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (CoreC-45Name-u--show_Show_Name u--x)))) u--ibinds))) '())))))) (vector 1 (cons (cons (let ((e-0 (vector-ref arg-19 0))) e-0) (cons arg-27 (cons e-2 (cons (let ((e-1 (vector-ref arg-19 1))) e-1) (cons (let ((e-14 (vector-ref arg-19 2))) e-14) e-6))))) u--methupdsC-39))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (CoreC-45FC-virtualiseFC arg-14)))
(define IdrisC-45ElabC-45Implementation-n--11131-8572-u--updateClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 ext-0) (case (vector-ref arg-20 0) ((0) (let ((e-1 (vector-ref arg-20 1))) (let ((e-2 (vector-ref arg-20 2))) (let ((e-3 (vector-ref arg-20 3))) (let ((act-24 (IdrisC-45ElabC-45Implementation-n--11131-8571-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-5 e-3)))))))))) ((1) (let ((e-5 (vector-ref arg-20 1))) (let ((e-6 (vector-ref arg-20 2))) (let ((e-7 (vector-ref arg-20 3))) (let ((e-8 (vector-ref arg-20 4))) (let ((e-9 (vector-ref arg-20 5))) (let ((e-10 (vector-ref arg-20 6))) (let ((act-24 (IdrisC-45ElabC-45Implementation-n--11131-8571-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-6 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45ElabC-45Implementation-n--11131-8572-u--updateClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0 eta-1))) e-10 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-25 1))) (vector 1 (vector 1 e-5 e-11 e-7 e-8 e-9 e-12))))))))))))))))) (else (let ((e-12 (vector-ref arg-20 1))) (let ((e-13 (vector-ref arg-20 2))) (let ((act-24 (IdrisC-45ElabC-45Implementation-n--11131-8571-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 e-12 e-5))))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8573-u--updateBody (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 ext-0) (case (vector-ref arg-20 0) ((2) (let ((e-1 (vector-ref arg-20 1))) (let ((e-2 (vector-ref arg-20 2))) (let ((e-3 (vector-ref arg-20 3))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45ElabC-45Implementation-n--11131-8572-u--updateClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0 eta-1))) e-3 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45ElabC-45Implementation-n--11131-8570-u--findMethName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-1 e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-18 "ide-mode.highlight" (+ 1 0) (lambda () (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (csegen-737) (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3642) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3642) u--d u--x))))) (cons e-2 (cons e-6 e-1)))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (vector 1 (vector 2 e-1 e-6 e-5)))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (TTImpC-45TTImpC-45ImpDecl-getFC arg-20) "Implementation body can only contain definitions") ext-0)))))
(define IdrisC-45ElabC-45Implementation-n--11131-8571-u--updateApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 ext-0) (case (vector-ref arg-20 0) ((0) (let ((e-1 (vector-ref arg-20 1))) (let ((e-2 (vector-ref arg-20 2))) (let ((act-24 (IdrisC-45ElabC-45Implementation-n--11131-8570-u--findMethName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-1 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-1 e-5))))))))) ((8) (let ((e-4 (vector-ref arg-20 1))) (let ((e-5 (vector-ref arg-20 2))) (let ((e-6 (vector-ref arg-20 3))) (let ((act-24 (IdrisC-45ElabC-45Implementation-n--11131-8571-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (vector 8 e-4 e-7 e-6)))))))))) ((9) (let ((e-8 (vector-ref arg-20 1))) (let ((e-9 (vector-ref arg-20 2))) (let ((e-10 (vector-ref arg-20 3))) (let ((act-24 (IdrisC-45ElabC-45Implementation-n--11131-8571-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-9 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 9 e-8 e-5 e-10)))))))))) ((10) (let ((e-12 (vector-ref arg-20 1))) (let ((e-13 (vector-ref arg-20 2))) (let ((e-14 (vector-ref arg-20 3))) (let ((e-15 (vector-ref arg-20 4))) (let ((act-24 (IdrisC-45ElabC-45Implementation-n--11131-8571-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-13 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 10 e-12 e-5 e-14 e-15)))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (TTImpC-45TTImp-getFC arg-20) "Invalid method definition") ext-0)))))
(define IdrisC-45ElabC-45Implementation-n--11131-8567-u--topMethTypes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 ext-0) (if (null? arg-26) (vector 1 '()) (let ((e-2 (car arg-26))) (let ((e-3 (cdr arg-26))) (let ((act-24 (IdrisC-45ElabC-45Implementation-n--11131-8566-u--topMethType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((act-25 (IdrisC-45ElabC-45Implementation-n--11131-8567-u--topMethTypes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-19) arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (cons e-6 e-7)))))))))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8566-u--topMethType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 ext-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8563-u--methName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (let ((e-0 (vector-ref arg-26 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45ElabC-45Implementation-n--11131-8564-u--applyCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 eta-0 eta-1))) arg-25 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--updsC-39 e-6)) (let ((u--mty_in (TTImpC-45Utils-substNames arg-8 u--updsC-39 (let ((e-3 (vector-ref arg-26 3))) e-3)))) ((IdrisC-45ElabC-45Implementation-case--elabImplementationC-44topMethType-9112 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-26 arg-25 arg-24 arg-23 arg-22 arg-21 arg-20 arg-19 e-5 e-6 u--updsC-39 u--mty_in ((TTImpC-45BindImplicits-renameIBinds arg-22 (TTImpC-45TTImp-findImplicits u--mty_in) u--mty_in) '())) ext-0)))))))))))))
(define IdrisC-45ElabC-45Implementation-n--10803-8225-u--toForward (lambda (arg-0) (cond ((equal? arg-0 #\\) #\/)(else arg-0))))
(define IdrisC-45ElabC-45Implementation-n--10904-8329-u--specialiseMeth (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cons arg-6 (vector 10 arg-5 (vector 0 arg-5 arg-6) (vector 1 (vector 0 "__con")) (vector 0 arg-5 arg-4)))))
(define IdrisC-45ElabC-45Implementation-n--11131-8568-u--mkTopMethDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-3 (cdr arg-19))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (let ((u--opts (PreludeC-45Types-maybe (lambda () arg-12) (lambda () (lambda (u--t) (cons (vector 7 u--t) arg-12))) e-18))) (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) e-14 arg-13 u--opts (vector (vector 2 ) (vector 2 ) e-6 e-19)))))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8562-u--mkMethField (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (let ((u--argns (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--11171-8824-u--applyUpdate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 e-6 e-10 e-14 e-18 e-19 arg-20 arg-19 eta-0)) (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) eta-0)) (DataC-45List-lookup (csegen-802) (CoreC-45Name-dropNS e-2) arg-20))))) (let ((u--imps (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-19))) (IdrisC-45ElabC-45Implementation-n--11131-8560-u--mkLam arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 u--argns (IdrisC-45ElabC-45Implementation-n--11131-8558-u--impsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8561-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 0 (vector 2 ) e-6) u--argns) (PreludeC-45Types-u--map_Functor_List (lambda (u--n) (cons u--n (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (vector 1 (vector 0 (CoreC-45Name-u--show_Show_Name u--n)))))) u--imps)))))))))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8560-u--mkLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (if (null? arg-19) arg-20 (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 2 (vector 2 ) e-10 e-11 (box e-6) (vector 32 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) 0) (IdrisC-45ElabC-45Implementation-n--11131-8560-u--mkLam arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-3 arg-20)))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8569-u--methNameUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20) (let ((e-2 (car arg-20))) (let ((e-3 (cdr arg-20))) (case (vector-ref e-2 0) ((1) (let ((e-8 (vector-ref e-2 1))) (if (null? e-3) (let ((e-6 (car e-3))) (cons (vector 1 (vector 0 (CoreC-45Name-nameRoot e-2))) e-6)) (let ((e-13 (car e-3))) (cons (vector 1 e-8) e-13))))) ((0) (let ((e-10 (vector-ref e-2 2))) (if (null? e-3) (let ((e-6 (car e-3))) (cons (vector 1 (vector 0 (CoreC-45Name-nameRoot e-2))) e-6)) (let ((e-17 (car e-3))) (let ((e-18 (cdr e-3))) (IdrisC-45ElabC-45Implementation-n--11131-8569-u--methNameUpdate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (cons e-10 (cons e-17 e-18))))))))(else (let ((e-6 (car e-3))) (cons (vector 1 (vector 0 (CoreC-45Name-nameRoot e-2))) e-6))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8563-u--methName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-19 0) ((0) (let ((e-1 (vector-ref arg-19 2))) (IdrisC-45ElabC-45Implementation-n--11131-8563-u--methName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-1)))(else (vector 4 (CoreC-45Name-u--show_Show_Name arg-19) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-19) (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-5) (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45TypesC-45String-C-43C-43 (cond ((equal? arg-3 1) (CoreC-45Name-u--show_Show_Name arg-2)) (else "")) (CoreC-45NameC-45Namespace-showSep "_" (PreludeC-45Types-u--map_Functor_List (csegen-2135) arg-4))))))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8558-u--impsApply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (if (null? arg-20) arg-19 (let ((e-2 (car arg-20))) (let ((e-3 (cdr arg-20))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (IdrisC-45ElabC-45Implementation-n--11131-8558-u--impsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 10 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-19 e-6 e-7) e-3))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8557-u--getFieldArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20) (case (vector-ref arg-20 0) ((3) (let ((e-1 (vector-ref arg-20 1))) (let ((e-2 (vector-ref arg-20 2))) (let ((e-3 (vector-ref arg-20 3))) (let ((e-4 (vector-ref arg-20 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (cons (cons e-2 (IdrisC-45ElabC-45Implementation-n--11166-8628-u--getArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-1 e-6 e-7 e-8 e-9 e-2 e-4 e-9)) (IdrisC-45ElabC-45Implementation-n--11131-8557-u--getFieldArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-4)))))))(else '())))))))(else '()))))
(define IdrisC-45ElabC-45Implementation-n--11166-8628-u--getArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-28) (case (vector-ref arg-28 0) ((3) (let ((e-2 (vector-ref arg-28 2))) (let ((e-3 (vector-ref arg-28 3))) (let ((e-4 (vector-ref arg-28 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (cons (cons e-2 (cons e-7 (CoreC-45TT-forgetDef e-8))) (IdrisC-45ElabC-45Implementation-n--11166-8628-u--getArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 e-4)))))(else '()))))))(else '()))))
(define IdrisC-45ElabC-45Implementation-n--11131-8570-u--findMethName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (let ((sc0 (DataC-45List-lookup (csegen-802) arg-21 arg-19))) (if (null? sc0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-20 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-21) (PreludeC-45TypesC-45String-C-43C-43 " is not a method of " (CoreC-45Name-u--show_Show_Name arg-5)))) ext-0) (let ((e-2 (unbox sc0))) (vector 1 e-2))))))
(define IdrisC-45ElabC-45Implementation-n--10904-8330-u--extendBody (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) (cons arg-8 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (DataC-45List-lookup (csegen-802) e-2 arg-1))) (if (null? sc1) (IdrisC-45ElabC-45Implementation-n--10904-8330-u--extendBody arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons e-2 arg-6) e-3 arg-8) (let ((e-4 (unbox sc1))) (let ((u--mupdates (PreludeC-45TypesC-45List-tailRecAppend arg-3 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--10904-8329-u--specialiseMeth arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) arg-2)))) (let ((u--csC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substNamesClause '() u--mupdates eta-0)) e-4))) (IdrisC-45ElabC-45Implementation-n--10904-8330-u--extendBody arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 (cons (vector 2 arg-5 e-2 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (TTImpC-45Utils-substLocClause arg-5 eta-0)) u--csC-39)) arg-8))))))))))))
(define IdrisC-45ElabC-45Implementation-n--10904-8331-u--dropGot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-6 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 2))) (IdrisC-45ElabC-45Implementation-n--10904-8331-u--dropGot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (DataC-45List-filter (lambda (arg-8) (CoreC-45Name-u--C-47C-61_Eq_Name arg-8 e-6)) arg-6) e-3)))(else (IdrisC-45ElabC-45Implementation-n--10904-8331-u--dropGot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8565-u--bindImps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (if (null? arg-19) arg-20 (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) e-10 (vector 0 ) (box e-6) e-11 (IdrisC-45ElabC-45Implementation-n--11131-8565-u--bindImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-3 arg-20)))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8559-u--autoImpsApply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (if (null? arg-20) arg-19 (let ((e-2 (car arg-20))) (let ((e-3 (cdr arg-20))) (IdrisC-45ElabC-45Implementation-n--11131-8559-u--autoImpsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 9 (TTImpC-45TTImp-getFC arg-19) arg-19 e-2) e-3))))))
(define IdrisC-45ElabC-45Implementation-n--11171-8824-u--applyUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27) (if (null? arg-27) arg-27 (let ((e-2 (car arg-27))) (let ((e-3 (cdr arg-27))) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (if (null? e-3) arg-27 (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (PreludeC-45Types-maybe (lambda () (cons (vector 1 (vector 0 e-5)) (cons e-8 e-9))) (lambda () (lambda (u--nC-39) (cons (vector 1 (vector 0 u--nC-39)) (cons e-8 e-9)))) (DataC-45List-lookup (csegen-17) e-5 arg-21)))))))(else arg-27))))(else arg-27)))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8561-u--applyTo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (if (null? arg-20) arg-19 (let ((e-2 (car arg-20))) (let ((e-3 (cdr arg-20))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-11 (cdr e-7))) (case (vector-ref e-11 0) ((1) (IdrisC-45ElabC-45Implementation-n--11131-8561-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 8 (vector 2 ) arg-19 (vector 0 (vector 2 ) e-6)) e-3)) ((2) (IdrisC-45ElabC-45Implementation-n--11131-8561-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 10 (vector 2 ) arg-19 e-6 (vector 0 (vector 2 ) e-6)) e-3)) ((0) (IdrisC-45ElabC-45Implementation-n--11131-8561-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 10 (vector 2 ) arg-19 e-6 (vector 0 (vector 2 ) e-6)) e-3)) (else (IdrisC-45ElabC-45Implementation-n--11131-8561-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (vector 10 (vector 2 ) arg-19 e-6 (vector 0 (vector 2 ) e-6)) e-3)))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8556-u--applyEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 ext-0) (let ((act-24 (CoreC-45Context-resolveName arg-18 arg-19 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 8 e-5) (cons '() (cons (PreludeC-45TypesC-45List-reverse (CoreC-45Env-allVars arg-8 arg-10)) (lambda (u--fn) (lambda (u--nt) (CoreC-45UnifyState-applyToFull arg-8 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (vector 1 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) u--nt (vector 8 e-5)) arg-10)))))))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8564-u--applyCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 ext-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-18 (IdrisC-45ElabC-45Implementation-n--11131-8563-u--methName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (CoreC-45Name-dropNS arg-20) (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) e-5)))))))))
(define IdrisC-45ElabC-45Implementation-n--11131-8574-u--addTransform (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Adding transform for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-21 0))) e-0)) (PreludeC-45TypesC-45String-C-43C-43 " : " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) (let ((e-3 (vector-ref arg-21 3))) e-3)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;for " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-19) (PreludeC-45TypesC-45String-C-43C-43 " in " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2299) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-2299) u--d u--x)))) arg-20))))))))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((u--lhs (vector 10 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-0 (vector-ref arg-21 0))) e-0)) (vector 1 (vector 0 "__con")) (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) arg-19)))) (let ((sc1 (DataC-45List-lookup (csegen-802) (CoreC-45Name-dropNS (let ((e-0 (vector-ref arg-21 0))) e-0)) arg-20))) (if (null? sc1) (vector 1 0) (let ((e-1 (unbox sc1))) (let ((u--rhs (vector 0 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) e-1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--lhs) (PreludeC-45TypesC-45String-C-43C-43 " ==> " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--rhs)))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (CoreC-45UnifyState-handleUnify arg-18 arg-17 (TTImpC-45ElabC-45Check-processDecl arg-8 arg-18 arg-15 arg-17 arg-16 '() arg-9 arg-10 (vector 6 (IdrisC-45ElabC-45Implementation-n--11131-8555-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-21 0))) e-0)) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45Name-u--show_Show_Name arg-19))))) u--lhs u--rhs)) (lambda (u--err) (lambda (eta-0) (CoreC-45ContextC-45Log-log arg-18 "elab.implementation" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Can't add transform " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--lhs) (PreludeC-45TypesC-45String-C-43C-43 " ==> " (PreludeC-45TypesC-45String-C-43C-43 (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (csegen-737) u--rhs) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\x9;" (CoreC-45Core-u--show_Show_Error u--err))))))) eta-0))) ext-0))))))))))))))
(define IdrisC-45ElabC-45Implementation-replaceSep (lambda (ext-0) (PreludeC-45Types-fastPack (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--10803-8225-u--toForward eta-0)) (PreludeC-45Types-fastUnpack ext-0)))))
(define IdrisC-45ElabC-45Implementation-mkImplName (lambda (arg-0 arg-1 arg-2) (vector 4 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) (PreludeC-45TypesC-45String-C-43C-43 " implementation at " (IdrisC-45ElabC-45Implementation-replaceSep (CoreC-45FC-u--show_Show_FC arg-0)))) (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "__Impl_" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-1) (PreludeC-45TypesC-45String-C-43C-43 "_" (CoreC-45NameC-45Namespace-showSep "_" (PreludeC-45Types-u--map_Functor_List (csegen-2135) arg-2))))))))))
(define IdrisC-45ElabC-45Implementation-getMethImps (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref e-8 0) ((0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-2487) (lambda (eta-0) (TTImpC-45Unelab-unelabNoSugar arg-0 arg-1 arg-2 e-9 eta-0)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45ElabC-45Implementation-getMethImps (cons e-2 arg-0) arg-1 (cons (vector 2 e-6 e-7 (vector 0 ) e-9) arg-2) e-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (cons (cons e-2 (cons e-7 e-5)) e-10)))))))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define IdrisC-45ElabC-45Implementation-elabImplementation (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((u--impName_nest (let ((sc0 (DataC-45List-lookup (csegen-802) arg-16 arg-10))) (if (null? sc0) arg-16 (let ((e-1 (unbox sc0))) (if (null? e-1) arg-16 (let ((e-4 (car e-1))) (if (null? e-4) arg-16 (let ((e-7 (unbox e-4))) e-7))))))))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-inCurrentNS arg-1 u--impName_nest eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-3))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45Context-lookupCtxtName arg-13 (let ((e-0 (vector-ref e-7 0))) e-0)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) ((IdrisC-45ElabC-45Implementation-case--elabImplementation-10543 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--impName_nest e-5 e-6 e-7 e-8 (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (u--n) (LibrariesC-45DataC-45ANameMap-lookupName u--n (let ((e-14 (vector-ref e-6 5))) e-14))) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-fst eta-1)) e-8))) eta-0)))))))))))))))))))))
(define IdrisC-45ElabC-45Implementation-bindImpls (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 arg-0 e-10 (vector 0 ) (box e-6) e-11 (IdrisC-45ElabC-45Implementation-bindImpls arg-0 e-3 arg-2)))))))))))
(define IdrisC-45ElabC-45Implementation-bindConstraints (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (vector 1 arg-0 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) arg-1 e-6 e-7 (IdrisC-45ElabC-45Implementation-bindConstraints arg-0 arg-1 e-3 arg-3)))))))))
(define IdrisC-45ElabC-45Implementation-addDefaults (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--missing (IdrisC-45ElabC-45Implementation-n--10904-8331-u--dropGot arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-3 arg-5))) (IdrisC-45ElabC-45Implementation-n--10904-8330-u--extendBody arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 '() u--missing arg-5))))
(define CompilerC-45InterpreterC-45VMCode-case--caseC-32blockC-32inC-32callFunc-3995 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "Unkown foreign function: " (CoreC-45Name-u--show_Show_Name arg-3)) eta-0)) (let ((e-2 (unbox arg-12))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((sc2 (DataC-45Vect-toVect e-5 arg-2))) (if (null? sc2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "Wrong number of arguments, found: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-2)) (PreludeC-45TypesC-45String-C-43C-43 ", expected: " (PreludeC-45Show-u--show_Show_Nat e-5)))) eta-0)) (let ((e-3 (unbox sc2))) (((e-6 arg-1) arg-4) e-3))))))))))
(define CompilerC-45InterpreterC-45VMCode-case--callFunc-3858 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "Undefined function: " (CoreC-45Name-u--show_Show_Name arg-3)) eta-0)) (let ((e-2 (unbox arg-9))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (let ((e-4 (vector-ref e-2 2))) (lambda (eta-0) (let ((act-24 (let ((sc2 (PreludeC-45Types-u--C-47C-61_Eq_Nat (PreludeC-45TypesC-45List-length e-3) (PreludeC-45TypesC-45List-length arg-2)))) (cond ((equal? sc2 1) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "Unexpected argument count during function call, expected: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-3)) (PreludeC-45TypesC-45String-C-43C-43 ", found: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-2))))) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((act-25 ((CompilerC-45InterpreterC-45VMCode-beginFunction arg-1 (DataC-45List-u--zip_Zippable_List e-3 arg-2) e-4 (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-1) (lambda (eta-2) (PreludeC-45EqOrd-u--max_Ord_Int eta-1 eta-2))) -1 e-3)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-7 arg-1 eta-1)) e-6 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (CompilerC-45InterpreterC-45VMCode-getReg arg-1 arg-7 (vector 0 ) eta-0))))))))))))))) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (CompilerC-45InterpreterC-45VMCode-case--caseC-32blockC-32inC-32callFunc-3995 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-5 e-6 e-7 (LibrariesC-45DataC-45NameMap-lookup arg-3 (CompilerC-45InterpreterC-45VMCode-knownForeign))))))) (else (let ((e-8 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverse_ (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-7 arg-1 eta-1)) e-8 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (CompilerC-45InterpreterC-45VMCode-getReg arg-1 arg-7 (vector 0 ) eta-0))))))))))))
(define CompilerC-45InterpreterC-45VMCode-case--step-3253 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-5 (PreludeC-45TypesC-45String-C-43C-43 "EXTPRIM: Unkown foreign function: " (CoreC-45Name-u--show_Show_Name arg-3)) eta-0)) (let ((e-2 (unbox arg-6))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (lambda (clam-0) (let ((sc2 (DataC-45Vect-toVect e-5 arg-2))) (if (null? sc2) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-5 (PreludeC-45TypesC-45String-C-43C-43 "EXTPRIM: Wrong number of arguments, found: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length arg-2)) (PreludeC-45TypesC-45String-C-43C-43 ", expected: " (PreludeC-45Show-u--show_Show_Nat e-5)))) clam-0) (let ((e-3 (unbox sc2))) (let ((act-24 (CoreC-45Core-traverseVect (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-getReg arg-1 arg-5 eta-0 eta-1))) e-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 ((((e-6 arg-1) arg-5) e-7) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-1 arg-5 arg-4 e-8 clam-0)))))))))))))))))))
(define CompilerC-45InterpreterC-45VMCode-case--callPrim-2513 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-2 (vector-ref arg-5 1))) (let ((sc1 ((CoreC-45Primitives-getOp arg-3 '()) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-2317) (lambda (eta-0) (vector 8 (vector 2 ) eta-0)) e-2)))) (if (null? sc1) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "OP: Error calling " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (CoreC-45Primitives-opName arg-3)) (PreludeC-45TypesC-45String-C-43C-43 " with operands: " (DataC-45Vect-u--show_Show_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (csegen-970) e-2)))) eta-0)) (let ((e-1 (unbox sc1))) (lambda (clam-0) (case (vector-ref e-1 0) ((8) (let ((e-4 (vector-ref e-1 2))) (vector 1 (vector 2 e-4))))(else (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "OP: Error calling " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name (CoreC-45Primitives-opName arg-3)) (PreludeC-45TypesC-45String-C-43C-43 " with operands: " (DataC-45Vect-u--show_Show_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (csegen-970) e-2)))) clam-0))))))))) (else (let ((e-5 (vector-ref arg-5 1))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "OP: Expected Constant, found " (CompilerC-45InterpreterC-45VMCode-showType e-5)) eta-0)))))))
(define CompilerC-45InterpreterC-45VMCode-n--7031-2066-u--showWithIndex (lambda (arg-1 arg-2 arg-3 arg-5 arg-6 arg-7) (if (null? arg-7) "" (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (PreludeC-45TypesC-45String-C-43C-43 "  " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-5) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-1 (car arg-6))) (e-1 e-2)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (CompilerC-45InterpreterC-45VMCode-n--7031-2066-u--showWithIndex arg-1 arg-2 arg-3 (+ 1 arg-5) arg-6 e-3)))))))))))
(define CompilerC-45InterpreterC-45VMCode-n--7679-2679-u--prim_putStr (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((2) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((10) (let ((e-5 (vector-ref e-4 1))) (if (null? e-3) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (case (vector-ref e-10 0) ((13) (if (null? e-9) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-3648) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-2) (let ((act-24 ((PreludeC-45IO-putStr (csegen-3) e-5) eta-2))) (vector 1 act-24))) eta-1)) eta-0)) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)))))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)))))))))
(define CompilerC-45InterpreterC-45VMCode-n--7679-2676-u--prim_putChar (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((2) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((11) (let ((e-5 (vector-ref e-4 1))) (if (null? e-3) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (case (vector-ref e-10 0) ((13) (if (null? e-9) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (csegen-3648) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-2) (let ((act-24 ((PreludeC-45IO-putChar (csegen-3) e-5) eta-2))) (vector 1 act-24))) eta-1)) eta-0)) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)))))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)))))))))
(define CompilerC-45InterpreterC-45VMCode-n--7679-2678-u--prim_getStr (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((2) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((13) (if (null? e-3) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-5 (vector-ref eta-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 2 (vector 10 e-5))))))) (lambda (eta-1) (let ((act-24 ((csegen-1268) eta-1))) (vector 1 act-24))) eta-0)) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)))))))))
(define CompilerC-45InterpreterC-45VMCode-n--7679-2677-u--prim_getChar (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((2) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((13) (if (null? e-3) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-5 (vector-ref eta-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45InterpreterC-45VMCode-ioRes (vector 2 (vector 11 e-5)))))))) (lambda (eta-1) (let ((act-24 ((PreludeC-45IO-getChar (csegen-3)) eta-1))) (vector 1 act-24))) eta-0)) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)))))))))
(define CompilerC-45InterpreterC-45VMCode-n--8042-3519-u--matchConst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) (lambda (clam-0) (if (null? arg-9) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-6 "CONSTCASE: Missing matching alternative or default" clam-0) (let ((e-6 (unbox arg-9))) (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-6 arg-1 eta-0)) e-6 clam-0)))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-9 (car e-2))) (let ((e-10 (cdr e-2))) (let ((sc2 (CoreC-45TT-u--C-61C-61_Eq_Constant arg-7 e-9))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-6 arg-1 eta-1)) e-10 eta-0))) (else (CompilerC-45InterpreterC-45VMCode-n--8042-3519-u--matchConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 arg-9)))))))))))
(define CompilerC-45InterpreterC-45VMCode-n--8042-3374-u--matchCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) (lambda (clam-0) (if (null? arg-9) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-6 "CASE: Missing matching alternative or default" clam-0) (let ((e-6 (unbox arg-9))) (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-6 arg-1 eta-0)) e-6 clam-0)))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-9 (car e-2))) (let ((e-10 (cdr e-2))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (cons (csegen-225) (csegen-802)) arg-7 e-9))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-6 arg-1 eta-1)) e-10 eta-0))) (else (CompilerC-45InterpreterC-45VMCode-n--8042-3374-u--matchCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 arg-9)))))))))))
(define CompilerC-45InterpreterC-45VMCode-n--7451-2489-u--getConst (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((2) (let ((e-0 (vector-ref arg-5 1))) (vector 1 e-0)))(else (vector 0 arg-5)))))
(define CompilerC-45InterpreterC-45VMCode-u--show_Show_Object (lambda (ext-0) (CompilerC-45InterpreterC-45VMCode-showDepth (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) ext-0)))
(define CompilerC-45InterpreterC-45VMCode-u--showPrec_Show_Object (lambda (arg-0 arg-1) (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object arg-1)))
(define CompilerC-45InterpreterC-45VMCode-unit(blodwen-lazy (lambda () (vector 2 (vector 0 0)))))
(define CompilerC-45InterpreterC-45VMCode-step (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (lambda (eta-0) (vector 1 0))) ((1) (lambda (eta-0) (vector 1 0))) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-24 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-1 e-5 eta-0))))))))) ((3) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 eta-1 eta-2))) e-5 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-3 (vector 1 e-4 e-6) eta-0)))))))))) ((4) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 eta-1 eta-2))) e-9 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-6 (vector 0 (DataC-45Nat-pred e-8) (DataC-45SnocList-C-60C-62C-60 '() e-5) e-7) eta-0))))))))))) ((5) (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-10 (vector 2 e-11) eta-0))))) ((6) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-13 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-14 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-5 0) ((0) (let ((e-0 (vector-ref e-5 1))) (let ((e-1 (vector-ref e-5 2))) (let ((e-2 (vector-ref e-5 3))) (cond ((equal? e-0 0) (let ((act-26 (CompilerC-45InterpreterC-45VMCode-callFunc arg-0 arg-2 arg-1 e-2 (DataC-45SnocList-C-60C-62C-62 e-1 (cons e-6 '())) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-12 e-7 eta-0))))))(else (let ((e-3 (- e-0 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-12 (vector 0 e-3 (cons e-1 e-6) e-2) eta-0))))))))(else (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "APPLY: While applying " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45VMCode-u--show_Show_Reg e-13) (PreludeC-45TypesC-45String-C-43C-43 ", expected closure, found: " (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object e-5)))) eta-0)))))))))))))))) ((7) (let ((e-15 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 eta-1 eta-2))) e-18 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45InterpreterC-45VMCode-callFunc arg-0 arg-2 arg-1 e-17 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-15 e-6 eta-0)))))))))))))) ((8) (let ((e-20 (vector-ref arg-3 1))) (let ((e-21 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseVect (lambda (eta-1) (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 eta-1 eta-2))) e-22 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45InterpreterC-45VMCode-callPrim arg-2 arg-1 e-21 e-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-20 e-6 eta-0)))))))))))))) ((9) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (CompilerC-45InterpreterC-45VMCode-case--step-3253 arg-0 arg-2 e-25 e-24 e-23 arg-1 (LibrariesC-45DataC-45NameMap-lookup e-24 (CompilerC-45InterpreterC-45VMCode-knownExtern))))))) ((10) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-26 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-0 (vector-ref e-5 1))) ((CompilerC-45InterpreterC-45VMCode-n--8042-3374-u--matchCon arg-0 arg-2 e-28 e-27 e-26 arg-1 arg-1 e-0 e-27 e-28) eta-0)))(else (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "CASE: Expected Constructor, found " (CompilerC-45InterpreterC-45VMCode-showType e-5)) eta-0)))))))))))) ((11) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-29 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((2) (let ((e-0 (vector-ref e-5 1))) ((CompilerC-45InterpreterC-45VMCode-n--8042-3519-u--matchConst arg-0 arg-2 e-31 e-30 e-29 arg-1 arg-1 e-0 e-30 e-31) eta-0)))(else (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "CONSTCASE: Expected Constant, found " (CompilerC-45InterpreterC-45VMCode-showType e-5)) eta-0)))))))))))) ((12) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-33 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-0 (vector-ref e-5 1))) (let ((e-1 (vector-ref e-5 2))) (let ((u--valObj (vector 1 e-0 e-1))) (let ((sc3 (CompilerC-45InterpreterC-45VMCode-indexMaybe e-1 e-34))) (if (null? sc3) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "PROJECT: Unable to project index " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-34) (PreludeC-45TypesC-45String-C-43C-43 ", missing arguments for constructor:\xa;" (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object u--valObj)))) eta-0) (let ((e-2 (unbox sc3))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-32 e-2 eta-0))))))))(else (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "PROJECT: Expected Constructor, found " (CompilerC-45InterpreterC-45VMCode-showType e-5)) eta-0)))))))))))) ((13) (let ((e-35 (vector-ref arg-3 1))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-35 (vector 3 ) eta-0)))) (else (let ((e-36 (vector-ref arg-3 1))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "ERROR: " e-36) eta-0)))))))
(define CompilerC-45InterpreterC-45VMCode-showType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "Closure") ((1) "Constructor") ((2) "Constant") (else "Null"))))
(define CompilerC-45InterpreterC-45VMCode-showSep (lambda (arg-0 arg-1) (if (null? arg-1) "" (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (CompilerC-45InterpreterC-45VMCode-showDepth arg-0 e-2) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45InterpreterC-45VMCode-showDepth arg-0 e-2) (PreludeC-45TypesC-45String-C-43C-43 ", " (CompilerC-45InterpreterC-45VMCode-showSep arg-0 e-3)))))))))
(define CompilerC-45InterpreterC-45VMCode-showDepth (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (CompilerC-45InterpreterC-45VMCode-showType arg-1))(else (let ((e-0 (- arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-3) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat e-1) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45InterpreterC-45VMCode-showSep e-0 (DataC-45SnocList-C-60C-62C-62 e-2 '())) ")"))))))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (case (vector-ref e-4 0) ((0) (let ((e-9 (vector-ref e-4 1))) (PreludeC-45TypesC-45String-C-43C-43 "tag" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-9) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45InterpreterC-45VMCode-showSep e-0 e-5) ")"))))))(else (CompilerC-45InterpreterC-45VMCode-showType arg-1)))))) ((2) (let ((e-6 (vector-ref arg-1 1))) (CoreC-45TT-u--show_Show_Constant e-6)))(else (CompilerC-45InterpreterC-45VMCode-showType arg-1))))))))
(define CompilerC-45InterpreterC-45VMCode-setReg (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-2 0) ((0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (vector e-0 e-1 (box arg-3))))))) (vector 1 act-25))))))) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-3657) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-0 (LibrariesC-45DataC-45IOArray-max e-5)))) (cond ((equal? sc2 1) (CompilerC-45InterpreterC-45VMCode-interpError arg-0 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "Attempt to set register: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-0) (PreludeC-45TypesC-45String-C-43C-43 ", size of locals: " (PreludeC-45Show-u--show_Show_Int (LibrariesC-45DataC-45IOArray-max e-5))))) ext-0)) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((LibrariesC-45DataC-45IOArray-writeArray (csegen-3) e-5 e-0 arg-3) ext-0))) (vector 1 act-26))))))))))) (else (vector 1 0)))))
(define CompilerC-45InterpreterC-45VMCode-saveLocals (lambda (arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (arg-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-1 e-5))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 e-6))))))))))))))
(define CompilerC-45InterpreterC-45VMCode-knownForeign(blodwen-lazy (lambda () (LibrariesC-45DataC-45NameMap-fromList (cons (cons (CompilerC-45InterpreterC-45VMCode-NS_UN (CoreC-45NameC-45Namespace-ioNS) "prim__putChar") (cons (+ 1 (+ 1 0)) (lambda (conArg-2911) (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-n--7679-2676-u--prim_putChar conArg-2911 eta-0 eta-1)))))) (cons (cons (CompilerC-45InterpreterC-45VMCode-NS_UN (CoreC-45NameC-45Namespace-ioNS) "prim__getChar") (cons (+ 1 0) (lambda (conArg-2894) (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-n--7679-2677-u--prim_getChar conArg-2894 eta-0 eta-1)))))) (cons (cons (CompilerC-45InterpreterC-45VMCode-NS_UN (CoreC-45NameC-45Namespace-ioNS) "prim__getStr") (cons (+ 1 0) (lambda (conArg-2877) (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-n--7679-2678-u--prim_getStr conArg-2877 eta-0 eta-1)))))) (cons (cons (CompilerC-45InterpreterC-45VMCode-NS_UN (CoreC-45NameC-45Namespace-ioNS) "prim__putStr") (cons (+ 1 (+ 1 0)) (lambda (conArg-2860) (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-n--7679-2679-u--prim_putStr conArg-2860 eta-0 eta-1)))))) '()))))))))
(define CompilerC-45InterpreterC-45VMCode-knownExtern(blodwen-lazy (lambda () (LibrariesC-45DataC-45NameMap-empty))))
(define CompilerC-45InterpreterC-45VMCode-ioRes (lambda (arg-0) (vector 1 (vector 0 0) (cons (vector 2 (vector 13 )) (cons arg-0 '())))))
(define CompilerC-45InterpreterC-45VMCode-interpError (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((act-25 (let ((act-25 ((LibrariesC-45DataC-45IOArray-toList (csegen-3) e-1) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Interpreter Error in " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-737) (DataC-45List-take (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) arg-2)) (PreludeC-45TypesC-45String-C-43C-43 ":\xa;" (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 "\xa;\xa;locals:\xa;" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45InterpreterC-45VMCode-n--7031-2066-u--showWithIndex arg-1 arg-3 arg-2 0 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-3677) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (csegen-3677) u--d u--x)))) e-6) (PreludeC-45TypesC-45String-C-43C-43 "\xa;return:\xa;  " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-3677) e-2))))))))) ext-0)))))))))))))
(define CompilerC-45InterpreterC-45VMCode-initInterpState (lambda (arg-0) (let ((u--defs (LibrariesC-45DataC-45NameMap-fromList arg-0))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((LibrariesC-45DataC-45IOArray-newArray (csegen-3) 0) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--returnObj (lambda (eta-1) '()))) (vector 1 (vector u--defs e-5 (u--returnObj 'erased))))))))))))
(define CompilerC-45InterpreterC-45VMCode-indexMaybe (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 0))) (cond ((equal? sc1 1) (box e-2)) (else (CompilerC-45InterpreterC-45VMCode-indexMaybe e-3 (bs- arg-2 1 63))))))))))
(define CompilerC-45InterpreterC-45VMCode-getReg (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-3657) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((LibrariesC-45DataC-45IOArray-readArray (csegen-3) e-5 e-0) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CompilerC-45InterpreterC-45VMCode-interpError arg-0 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "Missing local " (PreludeC-45Show-u--show_Show_Int e-0)) ext-0) (let ((e-1 (unbox e-6))) (vector 1 e-1))))))))))))) ((0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CompilerC-45InterpreterC-45VMCode-interpError arg-0 arg-1 "Missing returnObj val" ext-0) (let ((e-1 (unbox e-5))) (vector 1 e-1)))))))) (else (vector 1 (vector 3 ))))))
(define CompilerC-45InterpreterC-45VMCode-executeExpr (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CompilerC-45Common-getCompileData arg-0 0 3 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CompilerC-45InterpreterC-45VMCode-initInterpState (let ((e-4 (vector-ref e-5 4))) e-4)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CoreC-45Core-newRef (vector "Compiler.Interpreter.VMCode.State" ) e-6 ext-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-callFunc arg-0 e-6 '() (vector 2 "__mainExpression" 0) '() eta-0)) ext-0)))))))))))
(define CompilerC-45InterpreterC-45VMCode-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 '())))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "compile not implemeted for vmcode-interp") eta-0)) ext-0)))
(define CompilerC-45InterpreterC-45VMCode-codegenVMCodeInterp(blodwen-lazy (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CompilerC-45InterpreterC-45VMCode-compileExpr eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45InterpreterC-45VMCode-executeExpr eta-0 eta-1 eta-2 eta-3))))) '() '()))))
(define CompilerC-45InterpreterC-45VMCode-callPrim (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((37) (if (null? arg-4) (CompilerC-45InterpreterC-45VMCode-case--callPrim-2513 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-2 (vector-ref arg-215 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-215 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-609) (vector 1 arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-2 (vector-ref arg-610 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--7451-2489-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4)) (let ((e-3 (cdr arg-4))) (if (null? e-3) (CompilerC-45InterpreterC-45VMCode-case--callPrim-2513 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-4 (vector-ref arg-215 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-215 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-609) (vector 1 arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-4 (vector-ref arg-610 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--7451-2489-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4)) (let ((e-7 (cdr e-3))) (if (null? e-7) (CompilerC-45InterpreterC-45VMCode-case--callPrim-2513 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-4 (vector-ref arg-215 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-215 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-609) (vector 1 arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-4 (vector-ref arg-610 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--7451-2489-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4)) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (lambda (eta-0) (vector 1 e-10)) (CompilerC-45InterpreterC-45VMCode-case--callPrim-2513 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-4 (vector-ref arg-215 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-215 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-609) (vector 1 arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-4 (vector-ref arg-610 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-5 e-8)))) (else (let ((e-12 (vector-ref arg-612 1))) (vector 0 e-12)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--7451-2489-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4)))))))))))(else (CompilerC-45InterpreterC-45VMCode-case--callPrim-2513 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-215) (case (vector-ref arg-215 0) ((0) (let ((e-2 (vector-ref arg-215 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-215 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-609) (vector 1 arg-609))) (lambda (u--b) (lambda (u--a) (lambda (arg-610) (lambda (arg-612) (case (vector-ref arg-610 0) ((0) (let ((e-2 (vector-ref arg-610 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-610 1))) (case (vector-ref arg-612 0) ((1) (let ((e-8 (vector-ref arg-612 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-612 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--7451-2489-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4))))))
(define CompilerC-45InterpreterC-45VMCode-callFunc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (CompilerC-45InterpreterC-45VMCode-saveLocals arg-1 (let ((u--ind (PreludeC-45Types-fastPack (PreludeC-45Interfaces-C-60C-36 (csegen-257) #\| arg-2)))) (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-unverifiedLogging arg-0 "compiler.interpreter" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))))))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (cond ((equal? e-5 1) (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 u--ind (PreludeC-45TypesC-45String-C-43C-43 "Calling " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name arg-3) (PreludeC-45TypesC-45String-C-43C-43 " with args: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-3677) arg-4)))))) eta-0))) (vector 1 act-25))) (else (vector 1 0))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--stkC-39 (cons arg-3 arg-2))) (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (let ((e-0 (vector-ref e-7 0))) e-0)))))) (lambda (eta-1) (let ((act-26 (unbox arg-1))) (vector 1 act-26))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45InterpreterC-45VMCode-case--callFunc-3858 arg-0 arg-1 arg-4 arg-3 arg-2 u--ind e-5 u--stkC-39 e-7 (LibrariesC-45DataC-45NameMap-lookup arg-3 e-7)) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (cond ((equal? e-5 1) (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 u--ind (PreludeC-45TypesC-45String-C-43C-43 "Result: " (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object e-8)))) eta-0))) (vector 1 act-28))) (else (vector 1 0))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 e-8)))))))))))))))))))))) ext-0)))
(define CompilerC-45InterpreterC-45VMCode-beginFunction (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) (lambda (eta-0) (vector 1 arg-2)) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (case (vector-ref e-1 0) ((0) (let ((e-3 (vector-ref e-1 1))) (case (vector-ref e-3 0) ((1) (let ((e-4 (vector-ref e-3 1))) (CompilerC-45InterpreterC-45VMCode-beginFunction arg-0 arg-1 e-2 (PreludeC-45EqOrd-u--max_Ord_Int e-4 arg-3))))(else (CompilerC-45InterpreterC-45VMCode-beginFunction arg-0 arg-1 e-2 arg-3))))) ((1) (lambda (eta-0) (let ((act-24 (let ((act-24 ((LibrariesC-45DataC-45IOArray-newArray (csegen-3) (bs+ arg-3 1 63)) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-25 ((LibrariesC-45DataC-45IOArray-writeArray (csegen-3) e-5 e-4 e-3) clam-0))) (vector 1 act-25)))))) arg-1 '() eta-1)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (let ((act-26 (let ((act-26 (unbox arg-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-7 0))) (vector e-0 e-5 '()))))) (vector 1 act-27)))))))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (vector 1 e-2)))))))))))))(else (lambda (eta-0) (vector 1 arg-2)))))))))
(define CompilerC-45InterpreterC-45VMCode-argError (lambda (arg-2 arg-3 arg-4 ext-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-3 (PreludeC-45TypesC-45String-C-43C-43 "Unexpected arguments: " (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 (csegen-68) (lambda (eta-0) (PreludeC-45TypesC-45String-C-43C-43 " " (CompilerC-45InterpreterC-45VMCode-showType eta-0))) arg-4)) ext-0)))
(define CompilerC-45InterpreterC-45VMCode-NS_UN (lambda (arg-0 arg-1) (vector 0 arg-0 (vector 1 (vector 0 arg-1)))))
(define CompilerC-45ESC-45Javascript-htmlHeader(blodwen-lazy (lambda () (PreludeC-45Interfaces-concat (csegen-67) (cons "<html>\xa;" (cons " <head>\xa;" (cons "  <meta charset='utf-8'>\xa;" (cons " </head>\xa;" (cons " <body>\xa;" (cons "  <script type='text/javascript'>\xa;" '()))))))))))
(define CompilerC-45ESC-45Javascript-htmlFooter(blodwen-lazy (lambda () (PreludeC-45Interfaces-concat (csegen-67) (cons "\xa;  </script>\xa;" (cons " </body>\xa;" (cons "</html>" '())))))))
(define CompilerC-45ESC-45Javascript-executeExpr (lambda (arg-0 arg-1 arg-2 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Javascript backend is only able to compile, use Node instead") ext-0)))
(define CompilerC-45ESC-45Javascript-compileToJS (lambda (arg-0 arg-1 ext-0) (CompilerC-45ESC-45Codegen-compileToES arg-0 (vector 5 ) arg-1 (cons "browser" (cons "javascript" '())) ext-0)))
(define CompilerC-45ESC-45Javascript-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CompilerC-45ESC-45Javascript-compileToJS arg-0 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--res (CompilerC-45ESC-45Javascript-addHeaderAndFooter arg-4 e-5))) (let ((u--out (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 arg-4))) (let ((act-25 (CoreC-45Core-writeFile u--out u--res ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (box u--out)))))))))))))
(define CompilerC-45ESC-45Javascript-codegenJavascript(blodwen-lazy (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CompilerC-45ESC-45Javascript-compileExpr eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45ESC-45Javascript-executeExpr eta-0 eta-1 eta-2 eta-3))))) '() '()))))
(define CompilerC-45ESC-45Javascript-addHeaderAndFooter (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (DataC-45String-toLower eta-0)) (LibrariesC-45UtilsC-45Path-extension arg-0)))) (if (null? sc0) arg-1 (let ((e-1 (unbox sc0))) (cond ((equal? e-1 "html") (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ESC-45Javascript-htmlHeader) (PreludeC-45TypesC-45String-C-43C-43 arg-1 (CompilerC-45ESC-45Javascript-htmlFooter))))(else arg-1)))))))
(define CompilerC-45ESC-45Codegen-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeForeign-3695 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-24 (CoreC-45Directory-readDataFile arg-3 (PreludeC-45TypesC-45String-C-43C-43 "js/" (PreludeC-45TypesC-45String-C-43C-43 e-3 ".js")) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45ESC-45State-addToPreamble arg-2 e-3 e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 (CompilerC-45ESC-45Codegen-constant arg-4 (vector 3 (PreludeC-45TypesC-45String-C-43C-43 e-3 (PreludeC-45TypesC-45String-C-43C-43 "_" e-2))))))))))))))))
(define CompilerC-45ESC-45Codegen-case--castInt-2561 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-2) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-6 0) ((25) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((24) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((26) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--8591-2123-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-19 (cdr e-3))) (if (null? e-19) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((24) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((26) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--8591-2123-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-21 (unbox e-19))) ((CompilerC-45ESC-45Codegen-n--8591-2120-u--truncInt arg-0 arg-1 arg-2 (CompilerC-45ESC-45Codegen-useBigInt e-21) e-21) (CompilerC-45ESC-45Codegen-jsIntOfChar e-21 arg-0))))))) ((24) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((24) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((26) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--8591-2123-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-25 (cdr e-3))) (if (null? e-25) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((24) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((26) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--8591-2123-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-27 (unbox e-25))) ((CompilerC-45ESC-45Codegen-n--8591-2120-u--truncInt arg-0 arg-1 arg-2 (CompilerC-45ESC-45Codegen-useBigInt e-27) e-27) ((CompilerC-45ESC-45Codegen-jsIntOfString e-27) arg-0))))))) ((26) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((24) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((26) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--8591-2123-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-31 (cdr e-3))) (if (null? e-31) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((24) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((26) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--8591-2123-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-33 (unbox e-31))) ((CompilerC-45ESC-45Codegen-n--8591-2120-u--truncInt arg-0 arg-1 arg-2 (CompilerC-45ESC-45Codegen-useBigInt e-33) e-33) (CompilerC-45ESC-45Codegen-jsIntOfDouble e-33 arg-0)))))))(else (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (case (vector-ref e-12 0) ((25) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((24) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((26) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TT-u--show_Show_Constant arg-2) (cons " + ' -> ' + " (cons (CoreC-45TT-u--show_Show_Constant arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--8591-2123-u--intImpl arg-0 arg-1 arg-2 e-9 e-15))))))))))))))))))))
(define CompilerC-45ESC-45Codegen-case--castIntC-44intImpl-2244 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-3 0) ((0) (let ((e-10 (vector-ref e-3 1))) (if (null? e-10) (lambda (eta-0) (vector 1 arg-5)) (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((sc5 (CoreC-45TT-u--C-62C-61_Ord_Precision e-6 e-4))) (cond ((equal? sc5 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))) (else (let ((sc5 (CompilerC-45ESC-45Codegen-useBigInt arg-4))) (cond ((equal? sc5 0) (let ((sc6 (CompilerC-45ESC-45Codegen-useBigInt arg-3))) (cond ((equal? sc6 1) ((CompilerC-45ESC-45Codegen-n--8591-2120-u--truncInt arg-0 arg-1 arg-2 1 arg-3) (CompilerC-45ESC-45Codegen-toBigInt arg-0)))(else arg-6))))(else arg-6))))))) (else (let ((e-5 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((1) (let ((e-8 (vector-ref e-3 1))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-8 e-5))) (cond ((equal? sc5 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))) (else (let ((e-9 (vector-ref e-3 1))) (let ((sc5 (CoreC-45TT-u--C-62_Ord_Precision e-9 (box e-5)))) (cond ((equal? sc5 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))))))))))(else (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((sc3 (CoreC-45TT-u--C-62C-61_Ord_Precision e-6 e-4))) (cond ((equal? sc3 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))) (else (let ((sc3 (CompilerC-45ESC-45Codegen-useBigInt arg-4))) (cond ((equal? sc3 0) (let ((sc4 (CompilerC-45ESC-45Codegen-useBigInt arg-3))) (cond ((equal? sc4 1) ((CompilerC-45ESC-45Codegen-n--8591-2120-u--truncInt arg-0 arg-1 arg-2 1 arg-3) (CompilerC-45ESC-45Codegen-toBigInt arg-0)))(else arg-6))))(else arg-6))))))) (else (let ((e-5 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((1) (let ((e-8 (vector-ref e-3 1))) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-8 e-5))) (cond ((equal? sc3 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))) (else (let ((e-9 (vector-ref e-3 1))) (let ((sc3 (CoreC-45TT-u--C-62_Ord_Precision e-9 (box e-5)))) (cond ((equal? sc3 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6)))))))))))))))
(define CompilerC-45ESC-45Codegen-n--8591-2120-u--truncInt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (let ((e-0 (vector-ref arg-4 1))) (lambda (clam-1) (if (null? e-0) (vector 1 clam-0) (let ((e-2 (unbox e-0))) (vector 1 ((CompilerC-45ESC-45Codegen-truncateSigned arg-3 e-2) clam-0))))))) (else (let ((e-1 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-truncateUnsigned arg-3 e-1) clam-0)))))))))
(define CompilerC-45ESC-45Codegen-n--8591-2121-u--shrink (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-3))) (cond ((equal? sc0 1) (let ((sc1 (CompilerC-45ESC-45Codegen-useBigInt arg-4))) (cond ((equal? sc1 0) (lambda (eta-0) (CompilerC-45ESC-45Codegen-fromBigInt eta-0)))(else (lambda (eta-0) eta-0)))))(else (lambda (eta-0) eta-0))))))
(define CompilerC-45ESC-45Codegen-n--7859-1407-u--okchar (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\_) "_")(else (let ((sc0 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc0 1) (PreludeC-45Cast-u--cast_Cast_Char_String arg-1)) (else (PreludeC-45TypesC-45String-C-43C-43 "x" (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-1))))))))))
(define CompilerC-45ESC-45Codegen-n--7727-1276-u--okchar (lambda (arg-0 arg-1) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-1 #\ ))) (cond ((equal? sc1 1) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 #\\))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 #\"))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 #\'))) (cond ((equal? sc4 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-1 #\~)) (else 0)))) (else 0)))) (else 0)))) (else 0))))) (cond ((equal? sc0 1) (PreludeC-45Cast-u--cast_Cast_Char_String arg-1)) (else (cond ((equal? arg-1 (integer->char 0)) "\\0") ((equal? arg-1 #\') "\\'") ((equal? arg-1 #\") "\\\"") ((equal? arg-1 (integer->char 13)) "\\r") ((equal? arg-1 (integer->char 10)) "\\n")(else (PreludeC-45TypesC-45String-C-43C-43 "\\u{" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-1)) "}")))))))))
(define CompilerC-45ESC-45Codegen-n--8591-2123-u--intImpl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--expanded ((CompilerC-45ESC-45Codegen-n--8591-2122-u--expand arg-0 arg-1 arg-2 arg-3 arg-4) arg-0))) (let ((u--shrunk (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((CompilerC-45ESC-45Codegen-n--8591-2121-u--shrink arg-0 arg-1 arg-2 arg-3 arg-4) e-5)))))) ((CompilerC-45ESC-45Codegen-n--8591-2120-u--truncInt arg-0 arg-1 arg-2 (CompilerC-45ESC-45Codegen-useBigInt arg-3) arg-4) arg-0) eta-0)))) (CompilerC-45ESC-45Codegen-case--castIntC-44intImpl-2244 arg-0 arg-1 arg-2 arg-4 arg-3 u--expanded u--shrunk (cons arg-3 arg-4))))))
(define CompilerC-45ESC-45Codegen-n--8591-2122-u--expand (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-3))) (cond ((equal? sc0 0) (let ((sc1 (CompilerC-45ESC-45Codegen-useBigInt arg-4))) (cond ((equal? sc1 1) (lambda (eta-0) (CompilerC-45ESC-45Codegen-toBigInt eta-0)))(else (lambda (eta-0) eta-0)))))(else (lambda (eta-0) eta-0))))))
(define CompilerC-45ESC-45Codegen-n--11226-4675-u--anyCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--b (let ((sc0 (CompilerC-45ESC-45Doc-isMultiline arg-4))) (cond ((equal? sc0 1) (CompilerC-45ESC-45Doc-block arg-4)) (else arg-4))))) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-3 (CompilerC-45ESC-45Doc-softColon)) u--b))))
(define CompilerC-45ESC-45Codegen-n--11365-5170-u--alt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (let ((act-24 ((CompilerC-45ESC-45Codegen-stmt (box arg-0) arg-4 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 3 (CompilerC-45ESC-45Codegen-jsConstant e-1)) e-5))))))))))
(define CompilerC-45ESC-45Codegen-n--11365-4993-u--alt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (cond ((equal? e-2 7) (PreludeC-45IO-u--map_Functor_IO (csegen-3702) (CompilerC-45ESC-45Codegen-stmt (box arg-6) arg-4 e-3) clam-0)) ((equal? e-2 2) (PreludeC-45IO-u--map_Functor_IO (csegen-3703) (CompilerC-45ESC-45Codegen-stmt (box arg-6) arg-4 e-3) clam-0)) ((equal? e-2 3) (PreludeC-45IO-u--map_Functor_IO (csegen-3702) (CompilerC-45ESC-45Codegen-stmt (box arg-6) arg-4 e-3) clam-0)) ((equal? e-2 5) (PreludeC-45IO-u--map_Functor_IO (csegen-3703) (CompilerC-45ESC-45Codegen-stmt (box arg-6) arg-4 e-3) clam-0)) ((equal? e-2 6) (PreludeC-45IO-u--map_Functor_IO (csegen-3702) (CompilerC-45ESC-45Codegen-stmt (box arg-6) arg-4 e-3) clam-0)) ((equal? e-2 10) (PreludeC-45IO-u--map_Functor_IO (csegen-3702) (CompilerC-45ESC-45Codegen-stmt (box arg-6) arg-4 e-3) clam-0))(else (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (CompilerC-45ESC-45Codegen-tag2es e-1) e-5)))))) (CompilerC-45ESC-45Codegen-stmt (box arg-6) arg-4 e-3) clam-0)))))))))
(define CompilerC-45ESC-45Codegen-n--11226-4676-u--alt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CompilerC-45ESC-45Codegen-n--11226-4675-u--anyCase arg-0 arg-1 arg-2 (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 3 "case") e-2) e-3)))))
(define CompilerC-45ESC-45Codegen-var (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsNameDoc e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (vector 3 (PreludeC-45TypesC-45String-C-43C-43 "$" (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Int_Bits64 e-1)))))) (else (let ((e-2 (vector-ref arg-0 1))) (vector 3 (PreludeC-45TypesC-45String-C-43C-43 "$R" (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Int_Bits64 e-2)))))))))
(define CompilerC-45ESC-45Codegen-useBigIntC-39 (lambda (ext-0) (PreludeC-45EqOrd-u--C-62_Ord_Int ext-0 32)))
(define CompilerC-45ESC-45Codegen-useBigInt (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) 1 (let ((e-2 (unbox e-0))) (CompilerC-45ESC-45Codegen-useBigIntC-39 e-2))))) (else (let ((e-1 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-useBigIntC-39 e-1))))))
(define CompilerC-45ESC-45Codegen-truncateUnsigned (lambda (arg-0 arg-1) (let ((u--add (cond ((equal? arg-0 1) "BigInt") (else "Int")))) (lambda (eta-0) (CompilerC-45ESC-45Codegen-callFun1 (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ESC-45Codegen-esName "truncU") (PreludeC-45TypesC-45String-C-43C-43 u--add (PreludeC-45Show-u--show_Show_Int arg-1))) eta-0)))))
(define CompilerC-45ESC-45Codegen-truncateSigned (lambda (arg-0 arg-1) (let ((u--add (cond ((equal? arg-0 1) "BigInt") (else "Int")))) (lambda (eta-0) (CompilerC-45ESC-45Codegen-callFun1 (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ESC-45Codegen-esName "trunc") (PreludeC-45TypesC-45String-C-43C-43 u--add (PreludeC-45Show-u--show_Show_Int arg-1))) eta-0)))))
(define CompilerC-45ESC-45Codegen-toInt (lambda (arg-0) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-0))) (cond ((equal? sc0 1) (lambda (eta-0) (CompilerC-45ESC-45Codegen-toBigInt eta-0))) (else (lambda (eta-0) eta-0))))))
(define CompilerC-45ESC-45Codegen-toBigInt (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 "BigInt" ext-0)))
(define CompilerC-45ESC-45Codegen-tailRec(blodwen-lazy (lambda () (vector 1 (vector 0 "__tailRec")))))
(define CompilerC-45ESC-45Codegen-tag2es (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 1))) (vector 3 (PreludeC-45Show-u--show_Show_Int e-2)))) (else (let ((e-5 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsStringDoc (CoreC-45Name-u--show_Show_Name e-5)))))))
(define CompilerC-45ESC-45Codegen-switch (lambda (arg-0 arg-1 arg-2) (let ((u--stmt (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "switch") (CompilerC-45ESC-45Doc-paren arg-0)) (vector 2 )))) (let ((u--defcase (PreludeC-45Interfaces-concatMap (cons (csegen-3705) (csegen-65)) (lambda (eta-0) (PreludeC-45Types-u--pure_Applicative_List (CompilerC-45ESC-45Codegen-n--11226-4675-u--anyCase arg-2 arg-1 arg-0 (vector 3 "default") eta-0))) arg-2))) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc u--stmt (CompilerC-45ESC-45Doc-block (CompilerC-45ESC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ESC-45Codegen-n--11226-4676-u--alt arg-2 arg-1 arg-0 eta-0)) arg-1) u--defcase))))))))
(define CompilerC-45ESC-45Codegen-stringList (lambda (ext-0) (PreludeC-45Types-fastConcat (DataC-45List-intersperse "," (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_String eta-0)) ext-0)))))
(define CompilerC-45ESC-45Codegen-stmt (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (clam-3) (case (vector-ref arg-2 0) ((1) (let ((e-20 (vector-ref arg-2 1))) (let ((e-21 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CompilerC-45ESC-45Codegen-constant (CompilerC-45ESC-45Codegen-var e-20) e-5)))))) (CompilerC-45ESC-45Codegen-exp arg-1 e-21) clam-3)))) ((3) (let ((e-22 (vector-ref arg-2 1))) (let ((e-23 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CompilerC-45ESC-45Doc-vcat (cons (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 3 "let") (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-var e-22) (vector 3 ";"))) (cons e-5 '())))))))) (CompilerC-45ESC-45Codegen-stmt (box (box e-22)) arg-1 e-23) clam-3))))(else (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ESC-45Codegen-stmt '() arg-1 eta-0)) (DataC-45List1-forget e-1) '() clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45ESC-45Codegen-stmt arg-0 arg-1 e-2) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45ESC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons e-6 '()))))))))))))))))) (let ((e-4 (unbox arg-0))) (if (null? e-4) (case (vector-ref arg-2 0) ((0) (let ((e-17 (vector-ref arg-2 1))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 3 "return") (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc e-5 (vector 3 ";")))))))) (CompilerC-45ESC-45Codegen-exp arg-1 e-17) eta-0))))(else (lambda (clam-0) (case (vector-ref arg-2 0) ((4) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Codegen-insertBreak e-4 e-5)))))) (CompilerC-45ESC-45Codegen-n--11365-4993-u--alt e-4 e-9 e-8 e-7 arg-1 arg-0 e-4 eta-0) eta-1))) e-8 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (if (null? e-9) (vector 1 '()) (let ((e-2 (unbox e-9))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45Codegen-stmt (box e-4) arg-1 e-2) clam-0))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (CompilerC-45ESC-45Codegen-switch (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-minimal e-7) (vector 3 ".h")) e-5 e-10)))))))))))))) ((5) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Codegen-insertBreak e-4 e-5)))))) (lambda (eta-2) (CompilerC-45ESC-45Codegen-n--11365-5170-u--alt e-4 e-13 e-12 e-11 arg-1 arg-0 eta-0 eta-2)) eta-1))) e-12 '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (if (null? e-13) (vector 1 '()) (let ((e-2 (unbox e-13))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45Codegen-stmt (box e-4) arg-1 e-2) clam-0))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45ESC-45Codegen-exp arg-1 e-11) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45ESC-45Codegen-switch e-7 e-5 e-6)))))))))))))))))) ((6) (let ((e-15 (vector-ref arg-2 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-jsCrashExp (CompilerC-45ESC-45Codegen-jsStringDoc e-15)) (vector 3 ";")))))(else (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ESC-45Codegen-stmt '() arg-1 eta-0)) (DataC-45List1-forget e-1) '() clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45ESC-45Codegen-stmt arg-0 arg-1 e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45ESC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons e-6 '()))))))))))))))))))) (let ((e-16 (unbox e-4))) (case (vector-ref arg-2 0) ((2) (let ((e-19 (vector-ref arg-2 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (CompilerC-45ESC-45Codegen-var e-16) (cons (CompilerC-45ESC-45Doc-softEq) (cons e-5 (cons (vector 3 ";") '())))))))))) (CompilerC-45ESC-45Codegen-exp arg-1 e-19) eta-0))))(else (lambda (clam-1) (case (vector-ref arg-2 0) ((4) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Codegen-insertBreak e-4 e-5)))))) (CompilerC-45ESC-45Codegen-n--11365-4993-u--alt e-4 e-9 e-8 e-7 arg-1 arg-0 e-4 eta-0) eta-1))) e-8 '() clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (if (null? e-9) (vector 1 '()) (let ((e-2 (unbox e-9))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45Codegen-stmt (box e-4) arg-1 e-2) clam-1))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (CompilerC-45ESC-45Codegen-switch (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-minimal e-7) (vector 3 ".h")) e-5 e-10)))))))))))))) ((5) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Codegen-insertBreak e-4 e-5)))))) (lambda (eta-2) (CompilerC-45ESC-45Codegen-n--11365-5170-u--alt e-4 e-13 e-12 e-11 arg-1 arg-0 eta-0 eta-2)) eta-1))) e-12 '() clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (if (null? e-13) (vector 1 '()) (let ((e-2 (unbox e-13))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45Codegen-stmt (box e-4) arg-1 e-2) clam-1))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45ESC-45Codegen-exp arg-1 e-11) clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45ESC-45Codegen-switch e-7 e-5 e-6)))))))))))))))))) ((6) (let ((e-15 (vector-ref arg-2 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-jsCrashExp (CompilerC-45ESC-45Codegen-jsStringDoc e-15)) (vector 3 ";")))))(else (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ESC-45Codegen-stmt '() arg-1 eta-0)) (DataC-45List1-forget e-1) '() clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45ESC-45Codegen-stmt arg-0 arg-1 e-2) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45ESC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons e-6 '())))))))))))))))))))))))))
(define CompilerC-45ESC-45Codegen-searchForeign (lambda (arg-0 arg-1) (let ((u--pairs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ESC-45Codegen-readCCPart eta-0)) arg-1))) (let ((u--backends (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--pairs)))) (PreludeC-45Types-maybe (lambda () u--backends) (lambda () (lambda (eta-0) (vector 1 (Builtin-snd eta-0)))) (DataC-45List-find (lambda (eta-0) (PreludeC-45Types-elem (csegen-17) (Builtin-fst eta-0) arg-0)) u--pairs))))))
(define CompilerC-45ESC-45Codegen-readCCPart (lambda (ext-0) (CompilerC-45ESC-45Codegen-breakDrop1 #\: ext-0)))
(define CompilerC-45ESC-45Codegen-printDoc (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (CompilerC-45ESC-45Doc-pretty (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-1 (vector 1 )))) ((equal? arg-0 1) (CompilerC-45ESC-45Doc-compact arg-1)) (else (CompilerC-45ESC-45Doc-compact arg-1)))))
(define CompilerC-45ESC-45Codegen-minimal (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-var e-0))) (else (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-minimal e-2) (vector 3 ".a")) (vector 3 (PreludeC-45Show-u--show_Show_Nat e-1)))))))))
(define CompilerC-45ESC-45Codegen-makeForeign (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CompilerC-45ESC-45Codegen-var e-5)))))) (lambda (eta-0) (CompilerC-45ESC-45State-getOrRegisterRef arg-1 arg-2 eta-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (CompilerC-45ESC-45Codegen-readCCPart arg-3))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cond ((equal? e-2 "lambda") (vector 1 (CompilerC-45ESC-45Codegen-constant e-5 (CompilerC-45ESC-45Doc-paren (vector 3 e-3))))) ((equal? e-2 "support") (let ((u--ty "support")) (CompilerC-45ESC-45Codegen-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeForeign-3695 arg-3 arg-2 arg-1 arg-0 e-5 e-3 u--ty (CompilerC-45ESC-45Codegen-breakDrop1 #\, e-3) ext-0))) ((equal? e-2 "stringIterator") (cond ((equal? e-3 "new") (vector 1 (CompilerC-45ESC-45Codegen-constant e-5 (vector 3 "__prim_stringIteratorNew")))) ((equal? e-3 "next") (vector 1 (CompilerC-45ESC-45Codegen-constant e-5 (vector 3 "__prim_stringIteratorNext")))) ((equal? e-3 "toString") (vector 1 (CompilerC-45ESC-45Codegen-constant e-5 (vector 3 "__prim_stringIteratorToString"))))(else (CompilerC-45ESC-45State-errorConcat (cons "Invalid string iterator function: " (cons e-3 (cons ". " (cons "Supported functions are: " (cons (CompilerC-45ESC-45Codegen-stringList (cons "new" (cons "next" (cons "toString" '())))) (cons "." '())))))) ext-0))))(else (CompilerC-45ESC-45State-errorConcat (cons "Invalid foreign type : " (cons e-2 (cons ". " (cons "Supported types are: " (cons (CompilerC-45ESC-45Codegen-stringList (cons "lambda" (cons "support" (cons "stringIterator" '())))) '()))))) ext-0))))))))))))
(define CompilerC-45ESC-45Codegen-mainExpr(blodwen-lazy (lambda () (vector 2 "__mainExpression" 0))))
(define CompilerC-45ESC-45Codegen-lambdaArgs (lambda (arg-0) (if (null? arg-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "()") (CompilerC-45ESC-45Doc-lambdaArrow)) (CompilerC-45ESC-45Doc-hcat (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-var eta-0) (CompilerC-45ESC-45Doc-lambdaArrow))) arg-0)))))
(define CompilerC-45ESC-45Codegen-keywordSafe (lambda (arg-0) (cond ((equal? arg-0 "var") "var$") ((equal? arg-0 "switch") "switch$") ((equal? arg-0 "return") "return$") ((equal? arg-0 "const") "const$") ((equal? arg-0 "function") "function$")(else arg-0))))
(define CompilerC-45ESC-45Codegen-jsUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-keywordSafe (CompilerC-45ESC-45Codegen-jsIdent e-0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "rf__" (CompilerC-45ESC-45Codegen-jsIdent e-1)))) (else (CompilerC-45ESC-45Codegen-keywordSafe (CompilerC-45ESC-45Codegen-jsIdent "_"))))))
(define CompilerC-45ESC-45Codegen-jsStringDoc (lambda (ext-0) (vector 3 (CompilerC-45ESC-45Codegen-jsString ext-0))))
(define CompilerC-45ESC-45Codegen-jsString (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 "'" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (CompilerC-45ESC-45Codegen-n--7727-1276-u--okchar arg-0 eta-0)) (PreludeC-45Types-fastUnpack arg-0)) "'"))))
(define CompilerC-45ESC-45Codegen-jsPrim (lambda (arg-0 arg-1 arg-2) (let ((sc0 (CoreC-45Name-dropAllNS arg-1))) (case (vector-ref sc0 0) ((1) (let ((e-4 (vector-ref sc0 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (cond ((equal? e-5 "prim__newIORef") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-8 (cdr arg-2))) (if (null? e-8) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (lambda (clam-0) (if (null? e-11) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0) (let ((e-14 (cdr e-11))) (if (null? e-14) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 3 "({value:") (cons e-10 (cons (vector 3 "})") '()))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0))))))))))) ((equal? e-5 "prim__readIORef") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-18 (cdr arg-2))) (if (null? e-18) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-20 (car e-18))) (let ((e-21 (cdr e-18))) (lambda (clam-1) (if (null? e-21) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-1) (let ((e-24 (cdr e-21))) (if (null? e-24) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 3 "(") (cons e-20 (cons (vector 3 ".value)") '()))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-1))))))))))) ((equal? e-5 "prim__writeIORef") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-28 (cdr arg-2))) (if (null? e-28) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-30 (car e-28))) (let ((e-31 (cdr e-28))) (if (null? e-31) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-33 (car e-31))) (let ((e-34 (cdr e-31))) (lambda (clam-2) (if (null? e-34) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-2) (let ((e-37 (cdr e-34))) (if (null? e-37) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 3 "(") (cons e-30 (cons (vector 3 ".value=") (cons e-33 (cons (vector 3 ")") '()))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-2)))))))))))))) ((equal? e-5 "prim__newArray") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-41 (cdr arg-2))) (if (null? e-41) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-43 (car e-41))) (let ((e-44 (cdr e-41))) (if (null? e-44) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-46 (car e-44))) (let ((e-47 (cdr e-44))) (lambda (clam-3) (if (null? e-47) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-3) (let ((e-50 (cdr e-47))) (if (null? e-50) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 3 "(Array(") (cons e-43 (cons (vector 3 ").fill(") (cons e-46 (cons (vector 3 "))") '()))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-3)))))))))))))) ((equal? e-5 "prim__arrayGet") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-54 (cdr arg-2))) (if (null? e-54) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-56 (car e-54))) (let ((e-57 (cdr e-54))) (if (null? e-57) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-59 (car e-57))) (let ((e-60 (cdr e-57))) (lambda (clam-4) (if (null? e-60) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-4) (let ((e-63 (cdr e-60))) (if (null? e-63) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 3 "(") (cons e-56 (cons (vector 3 "[") (cons e-59 (cons (vector 3 "])") '()))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-4)))))))))))))) ((equal? e-5 "prim__arraySet") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-67 (cdr arg-2))) (if (null? e-67) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-69 (car e-67))) (let ((e-70 (cdr e-67))) (if (null? e-70) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-72 (car e-70))) (let ((e-73 (cdr e-70))) (if (null? e-73) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-75 (car e-73))) (let ((e-76 (cdr e-73))) (lambda (clam-5) (if (null? e-76) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-5) (let ((e-79 (cdr e-76))) (if (null? e-79) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 3 "(") (cons e-69 (cons (vector 3 "[") (cons e-72 (cons (vector 3 "]=") (cons e-75 (cons (vector 3 ")") '()))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-5))))))))))))))))) ((equal? e-5 "void") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-83 (cdr arg-2))) (lambda (clam-6) (if (null? e-83) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-6) (let ((e-86 (cdr e-83))) (if (null? e-86) (vector 1 (CompilerC-45ESC-45Codegen-jsCrashExp (CompilerC-45ESC-45Codegen-jsStringDoc "Error: Executed 'void'"))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-6)))))))) ((equal? e-5 "prim__void") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-90 (cdr arg-2))) (lambda (clam-7) (if (null? e-90) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-7) (let ((e-93 (cdr e-90))) (if (null? e-93) (vector 1 (CompilerC-45ESC-45Codegen-jsCrashExp (CompilerC-45ESC-45Codegen-jsStringDoc "Error: Executed 'void'"))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-7)))))))) ((equal? e-5 "prim__codegen") (lambda (clam-8) (if (null? arg-2) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-3734) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) clam-8))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (if (null? e-6) (vector 1 (vector 3 "\"javascript\"")) (let ((e-1 (car e-6))) (vector 1 (vector 3 (CompilerC-45ESC-45Codegen-jsString e-1))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-8)))) ((equal? e-5 "prim__os") (lambda (clam-9) (if (null? arg-2) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-3734) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) clam-9))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((sc5 (CompilerC-45ESC-45Codegen-searchForeign e-6 (cons "node" '())))) (case (vector-ref sc5 0) ((1) (let ((act-25 (CompilerC-45ESC-45State-addToPreamble arg-0 "prim__os" (PreludeC-45TypesC-45String-C-43C-43 "const _sysos = ((o => o === 'linux'?'unix':o==='win32'?'windows':o)" "(require('os').platform()));") clam-9))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 (vector 3 (CompilerC-45ESC-45Codegen-esName "sysos"))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "prim not implemented: prim__os") clam-9)))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-9))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)))))))
(define CompilerC-45ESC-45Codegen-jsOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-20 (car arg-2))) (let ((e-21 (cdr arg-2))) (lambda (clam-0) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-0) "+" "add") e-20) e-24))))))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-29 (car arg-2))) (let ((e-30 (cdr arg-2))) (lambda (clam-1) (let ((e-33 (car e-30))) (let ((e-34 (cdr e-30))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-1) "-" "sub") e-29) e-33))))))))) ((2) (let ((e-2 (vector-ref arg-1 1))) (let ((e-38 (car arg-2))) (let ((e-39 (cdr arg-2))) (lambda (clam-2) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-2) "*" "mul") e-38) e-42))))))))) ((3) (let ((e-3 (vector-ref arg-1 1))) (let ((e-47 (car arg-2))) (let ((e-48 (cdr arg-2))) (lambda (clam-3) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-3) "/" "div") e-47) e-51))))))))) ((4) (let ((e-56 (car arg-2))) (let ((e-57 (cdr arg-2))) (lambda (clam-4) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "%" e-56 e-60)))))))) ((5) (lambda (clam-5) (let ((e-65 (car arg-2))) (let ((e-66 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(-(") e-65) (vector 3 "))"))))))) ((6) (let ((e-6 (vector-ref arg-1 1))) (case (vector-ref e-6 0) ((17) (if (null? arg-2) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-8) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-70) e-74))))))) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (if (null? e-80) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-7) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-70) e-74))))))) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (if (null? e-84) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp "<<" e-79 e-83))) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-6) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-70) e-74))))))))))))))) ((14) (if (null? arg-2) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-11) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-70) e-74))))))) (let ((e-88 (car arg-2))) (let ((e-89 (cdr arg-2))) (if (null? e-89) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-10) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-70) e-74))))))) (let ((e-92 (car e-89))) (let ((e-93 (cdr e-89))) (if (null? e-93) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp "<<" e-88 e-92))) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-9) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-70) e-74)))))))))))))))(else (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-12) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-70) e-74))))))))))) ((7) (let ((e-7 (vector-ref arg-1 1))) (case (vector-ref e-7 0) ((17) (if (null? arg-2) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-15) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-97) e-101))))))) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (if (null? e-107) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-14) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-97) e-101))))))) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (if (null? e-111) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp ">>" e-106 e-110))) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-13) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-97) e-101))))))))))))))) ((14) (if (null? arg-2) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-18) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-97) e-101))))))) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (if (null? e-116) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-17) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-97) e-101))))))) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (if (null? e-120) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp ">>" e-115 e-119))) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-16) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-97) e-101)))))))))))))))(else (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-19) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-97) e-101))))))))))) ((8) (let ((e-8 (vector-ref arg-1 1))) (case (vector-ref e-8 0) ((22) (if (null? arg-2) (let ((e-124 (car arg-2))) (let ((e-125 (cdr arg-2))) (lambda (clam-22) (let ((e-128 (car e-125))) (let ((e-129 (cdr e-125))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "&" e-124 e-128))))))) (let ((e-133 (car arg-2))) (let ((e-134 (cdr arg-2))) (if (null? e-134) (let ((e-124 (car arg-2))) (let ((e-125 (cdr arg-2))) (lambda (clam-21) (let ((e-128 (car e-125))) (let ((e-129 (cdr e-125))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "&" e-124 e-128))))))) (let ((e-137 (car e-134))) (let ((e-138 (cdr e-134))) (if (null? e-138) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-boundedUIntOp 32 "and" e-133 e-137))) (let ((e-124 (car arg-2))) (let ((e-125 (cdr arg-2))) (lambda (clam-20) (let ((e-128 (car e-125))) (let ((e-129 (cdr e-125))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "&" e-124 e-128)))))))))))))))(else (let ((e-124 (car arg-2))) (let ((e-125 (cdr arg-2))) (lambda (clam-23) (let ((e-128 (car e-125))) (let ((e-129 (cdr e-125))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "&" e-124 e-128))))))))))) ((9) (let ((e-9 (vector-ref arg-1 1))) (case (vector-ref e-9 0) ((22) (if (null? arg-2) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-26) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "|" e-142 e-146))))))) (let ((e-151 (car arg-2))) (let ((e-152 (cdr arg-2))) (if (null? e-152) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-25) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "|" e-142 e-146))))))) (let ((e-155 (car e-152))) (let ((e-156 (cdr e-152))) (if (null? e-156) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-boundedUIntOp 32 "or" e-151 e-155))) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-24) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "|" e-142 e-146)))))))))))))))(else (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-27) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "|" e-142 e-146))))))))))) ((10) (let ((e-10 (vector-ref arg-1 1))) (case (vector-ref e-10 0) ((22) (if (null? arg-2) (let ((e-160 (car arg-2))) (let ((e-161 (cdr arg-2))) (lambda (clam-30) (let ((e-164 (car e-161))) (let ((e-165 (cdr e-161))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "^" e-160 e-164))))))) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (if (null? e-170) (let ((e-160 (car arg-2))) (let ((e-161 (cdr arg-2))) (lambda (clam-29) (let ((e-164 (car e-161))) (let ((e-165 (cdr e-161))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "^" e-160 e-164))))))) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (if (null? e-174) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-boundedUIntOp 32 "xor" e-169 e-173))) (let ((e-160 (car arg-2))) (let ((e-161 (cdr arg-2))) (lambda (clam-28) (let ((e-164 (car e-161))) (let ((e-165 (cdr e-161))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "^" e-160 e-164)))))))))))))))(else (let ((e-160 (car arg-2))) (let ((e-161 (cdr arg-2))) (lambda (clam-31) (let ((e-164 (car e-161))) (let ((e-165 (cdr e-161))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "^" e-160 e-164))))))))))) ((11) (let ((e-178 (car arg-2))) (let ((e-179 (cdr arg-2))) (lambda (clam-32) (let ((e-182 (car e-179))) (let ((e-183 (cdr e-179))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp "<" e-178 e-182)))))))) ((12) (let ((e-187 (car arg-2))) (let ((e-188 (cdr arg-2))) (lambda (clam-33) (let ((e-191 (car e-188))) (let ((e-192 (cdr e-188))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp "<=" e-187 e-191)))))))) ((13) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-34) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp "===" e-196 e-200)))))))) ((14) (let ((e-205 (car arg-2))) (let ((e-206 (cdr arg-2))) (lambda (clam-35) (let ((e-209 (car e-206))) (let ((e-210 (cdr e-206))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp ">=" e-205 e-209)))))))) ((15) (let ((e-214 (car arg-2))) (let ((e-215 (cdr arg-2))) (lambda (clam-36) (let ((e-218 (car e-215))) (let ((e-219 (cdr e-215))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp ">" e-214 e-218)))))))) ((16) (lambda (clam-37) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc e-223 (vector 3 ".length"))))))) ((17) (lambda (clam-38) (let ((e-228 (car arg-2))) (let ((e-229 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") e-228) (vector 3 ".charAt(0))"))))))) ((18) (lambda (clam-39) (let ((e-233 (car arg-2))) (let ((e-234 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") e-233) (vector 3 ".slice(1))"))))))) ((19) (let ((e-238 (car arg-2))) (let ((e-239 (cdr arg-2))) (lambda (clam-40) (let ((e-242 (car e-239))) (let ((e-243 (cdr e-239))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") e-238) (vector 3 ".charAt(")) e-242) (vector 3 "))"))))))))) ((20) (let ((e-247 (car arg-2))) (let ((e-248 (cdr arg-2))) (lambda (clam-41) (let ((e-251 (car e-248))) (let ((e-252 (cdr e-248))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "+" e-247 e-251)))))))) ((21) (let ((e-256 (car arg-2))) (let ((e-257 (cdr arg-2))) (lambda (clam-42) (let ((e-260 (car e-257))) (let ((e-261 (cdr e-257))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "+" e-256 e-260)))))))) ((22) (lambda (clam-43) (let ((e-265 (car arg-2))) (let ((e-266 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "strReverse") e-265)))))) ((23) (let ((e-270 (car arg-2))) (let ((e-271 (cdr arg-2))) (let ((e-274 (car e-271))) (let ((e-275 (cdr e-271))) (lambda (clam-44) (let ((e-278 (car e-275))) (let ((e-279 (cdr e-275))) (vector 1 (CompilerC-45ESC-45Codegen-callFun (CompilerC-45ESC-45Codegen-esName "substr") (cons e-270 (cons e-274 (cons e-278 '()))))))))))))) ((24) (lambda (clam-45) (let ((e-283 (car arg-2))) (let ((e-284 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.exp" e-283)))))) ((25) (lambda (clam-46) (let ((e-288 (car arg-2))) (let ((e-289 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.log" e-288)))))) ((26) (let ((e-293 (car arg-2))) (let ((e-294 (cdr arg-2))) (lambda (clam-47) (let ((e-297 (car e-294))) (let ((e-298 (cdr e-294))) (vector 1 (CompilerC-45ESC-45Codegen-callFun "Math.pow" (cons e-293 (cons e-297 '())))))))))) ((27) (lambda (clam-48) (let ((e-302 (car arg-2))) (let ((e-303 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.sin" e-302)))))) ((28) (lambda (clam-49) (let ((e-307 (car arg-2))) (let ((e-308 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.cos" e-307)))))) ((29) (lambda (clam-50) (let ((e-312 (car arg-2))) (let ((e-313 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.tan" e-312)))))) ((30) (lambda (clam-51) (let ((e-317 (car arg-2))) (let ((e-318 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.asin" e-317)))))) ((31) (lambda (clam-52) (let ((e-322 (car arg-2))) (let ((e-323 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.acos" e-322)))))) ((32) (lambda (clam-53) (let ((e-327 (car arg-2))) (let ((e-328 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.atan" e-327)))))) ((33) (lambda (clam-54) (let ((e-332 (car arg-2))) (let ((e-333 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.sqrt" e-332)))))) ((34) (lambda (clam-55) (let ((e-337 (car arg-2))) (let ((e-338 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.floor" e-337)))))) ((35) (lambda (clam-56) (let ((e-342 (car arg-2))) (let ((e-343 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.ceil" e-342)))))) ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (case (vector-ref e-16 0) ((24) (case (vector-ref e-17 0) ((26) (if (null? arg-2) (case (vector-ref e-17 0) ((24) (if (null? arg-2) (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))) (let ((e-352 (car arg-2))) (let ((e-353 (cdr arg-2))) (if (null? e-353) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString e-352))) (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))))))))(else (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))))) (let ((e-357 (car arg-2))) (let ((e-358 (cdr arg-2))) (if (null? e-358) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsNumberOfString e-357))) (case (vector-ref e-17 0) ((24) (if (null? arg-2) (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))) (let ((e-352 (car arg-2))) (let ((e-353 (cdr arg-2))) (if (null? e-353) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString e-352))) (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))))))))(else (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))))))))))(else (case (vector-ref e-17 0) ((24) (if (null? arg-2) (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))) (let ((e-352 (car arg-2))) (let ((e-353 (cdr arg-2))) (if (null? e-353) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString e-352))) (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))))))))(else (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))))))))(else (case (vector-ref e-17 0) ((24) (if (null? arg-2) (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))) (let ((e-352 (car arg-2))) (let ((e-353 (cdr arg-2))) (if (null? e-353) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString e-352))) (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347))))))))(else (let ((e-347 (car arg-2))) (let ((e-348 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-347)))))))))) ((37) (let ((e-363 (cdr arg-2))) (let ((e-367 (cdr e-363))) (lambda (clam-57) (let ((e-370 (car e-367))) (let ((e-371 (cdr e-367))) (vector 1 e-370))))))) (else (let ((e-376 (cdr arg-2))) (lambda (clam-58) (let ((e-379 (car e-376))) (let ((e-380 (cdr e-376))) (vector 1 (CompilerC-45ESC-45Codegen-jsCrashExp e-379))))))))))
(define CompilerC-45ESC-45Codegen-jsNumberOfString (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "numberOfString") ext-0)))
(define CompilerC-45ESC-45Codegen-jsNameDoc (lambda (ext-0) (vector 3 (CompilerC-45ESC-45Codegen-jsName ext-0))))
(define CompilerC-45ESC-45Codegen-jsName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ESC-45Codegen-jsIdent (CoreC-45NameC-45Namespace-showNSWithSep "_" e-0)) (PreludeC-45TypesC-45String-C-43C-43 "_" (CompilerC-45ESC-45Codegen-jsName e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsUserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ESC-45Codegen-jsIdent e-3) (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45Show-u--show_Show_Int e-4)))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "pat__" (CompilerC-45ESC-45Codegen-jsName e-5)))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CompilerC-45ESC-45Codegen-jsName e-8))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (let ((e-18 (car e-9))) (let ((e-19 (cdr e-9))) (PreludeC-45TypesC-45String-C-43C-43 "n__" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-18) (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-19) (PreludeC-45TypesC-45String-C-43C-43 "_" (CompilerC-45ESC-45Codegen-jsName e-10))))))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "case__" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ESC-45Codegen-jsIdent e-11) (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45Show-u--show_Show_Int e-12))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "with__" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45ESC-45Codegen-jsIdent e-13) (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45Show-u--show_Show_Int e-14))))))) (else (let ((e-15 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "fn__" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define CompilerC-45ESC-45Codegen-jsIntOfString (lambda (arg-0) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-0))) (cond ((equal? sc0 1) (lambda (eta-0) (CompilerC-45ESC-45Codegen-jsBigIntOfString eta-0))) (else (lambda (eta-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "intOfString") eta-0)))))))
(define CompilerC-45ESC-45Codegen-jsIntOfDouble (lambda (arg-0 ext-0) ((CompilerC-45ESC-45Codegen-toInt arg-0) (CompilerC-45ESC-45Codegen-callFun1 "Math.trunc" ext-0))))
(define CompilerC-45ESC-45Codegen-jsIntOfChar (lambda (arg-0 arg-1) ((CompilerC-45ESC-45Codegen-toInt arg-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-1 (vector 3 ".codePointAt(0)")))))
(define CompilerC-45ESC-45Codegen-jsIntKind (lambda (arg-0) (case (vector-ref arg-0 0) ((14) (box (vector 0 (box 32))))(else (CoreC-45TT-intKind arg-0)))))
(define CompilerC-45ESC-45Codegen-jsIdent (lambda (arg-0) (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (CompilerC-45ESC-45Codegen-n--7859-1407-u--okchar arg-0 eta-0)) (PreludeC-45Types-fastUnpack arg-0))))
(define CompilerC-45ESC-45Codegen-jsCrashExp (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "crashExp") ext-0)))
(define CompilerC-45ESC-45Codegen-jsConstant (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int8 e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int16 e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int32 e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int64 e-4) "n"))) ((5) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Integer e-5) "n"))) ((10) (let ((e-6 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsString e-6))) ((11) (let ((e-7 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsString (DataC-45String-singleton e-7)))) ((12) (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Double e-8))) ((13) (CompilerC-45ESC-45Codegen-esName "idrisworld")) ((6) (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits8 e-9))) ((7) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits16 e-10))) ((8) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits32 e-11))) ((9) (let ((e-12 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Bits64 e-12) "n"))) ((14) "#t") ((15) "#t") ((16) "#t") ((17) "#t") ((18) "#t") ((19) "#t") ((20) "#t") ((21) "#t") ((22) "#t") ((23) "#t") ((24) "#t") ((25) "#t") ((26) "#t") (else "#t"))))
(define CompilerC-45ESC-45Codegen-jsCharOfInt (lambda (arg-0 ext-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "truncToChar") ((CompilerC-45ESC-45Codegen-fromInt arg-0) ext-0))))
(define CompilerC-45ESC-45Codegen-jsBigIntOfString (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "bigIntOfString") ext-0)))
(define CompilerC-45ESC-45Codegen-jsAnyToString (lambda (arg-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(''+") arg-0) (vector 3 ")"))))
(define CompilerC-45ESC-45Codegen-isFun (lambda (arg-0) (case (vector-ref arg-0 0) ((1) 0)(else 1))))
(define CompilerC-45ESC-45Codegen-isArg (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (case (vector-ref arg-1 0) ((1) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((7) 0) ((4) (let ((e-5 (vector-ref e-1 1))) (if (null? e-5) 0 1))) ((5) (let ((e-9 (vector-ref e-1 1))) (if (null? e-9) 0 1))) ((6) 0)(else 1))))(else 1)))(else 1))))
(define CompilerC-45ESC-45Codegen-insertBreak (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-3 (car arg-1))) (let ((e-4 (cdr arg-1))) (cons e-3 (CompilerC-45ESC-45Doc-vcat (cons e-4 (cons (vector 3 "break;") '())))))))))
(define CompilerC-45ESC-45Codegen-function (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 3 "function") (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-app arg-0 arg-1) (vector 2 )) (CompilerC-45ESC-45Doc-block arg-2)))))
(define CompilerC-45ESC-45Codegen-fromInt (lambda (arg-0) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-0))) (cond ((equal? sc0 1) (lambda (eta-0) (CompilerC-45ESC-45Codegen-fromBigInt eta-0))) (else (lambda (eta-0) eta-0))))))
(define CompilerC-45ESC-45Codegen-fromBigInt (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 "Number" ext-0)))
(define CompilerC-45ESC-45Codegen-foreignDecl (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-3734) (lambda (eta-0) (let ((act-24 (unbox arg-1))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (CompilerC-45ESC-45Codegen-searchForeign e-5 arg-3))) (case (vector-ref sc1 0) ((1) (let ((e-2 (vector-ref sc1 1))) (CompilerC-45ESC-45Codegen-makeForeign arg-0 arg-1 arg-2 e-2 ext-0))) (else (let ((e-6 (vector-ref sc1 1))) (CompilerC-45ESC-45State-errorConcat (cons "No supported backend found in the definition of " (cons (CoreC-45Name-u--show_Show_Name arg-2) (cons ". " (cons "Supported backends: " (cons (CompilerC-45ESC-45Codegen-stringList e-5) (cons ". " (cons "Backends in definition: " (cons (CompilerC-45ESC-45Codegen-stringList e-6) (cons "." '()))))))))) ext-0)))))))))))
(define CompilerC-45ESC-45Codegen-foreign (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (if (null? e-3) (vector 1 '()) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((2) (let ((e-8 (vector-ref e-7 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--pure_Applicative_List (CompilerC-45ESC-45Doc-pretty e-5))))))) (lambda (eta-0) (CompilerC-45ESC-45Codegen-foreignDecl arg-1 arg-0 e-2 e-8 eta-0)) clam-0)))(else (vector 1 '())))))))))))
(define CompilerC-45ESC-45Codegen-exp (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-minimal e-0))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (let ((e-14 (vector-ref e-2 1))) (case (vector-ref e-14 0) ((3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-lambdaArgs e-1) (CompilerC-45ESC-45Doc-paren e-5))))))) (CompilerC-45ESC-45Codegen-exp arg-0 e-14) clam-0))(else (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-lambdaArgs e-1) e-5)))))) (CompilerC-45ESC-45Codegen-exp arg-0 e-14) clam-0)))))(else (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-lambdaArgs e-1) (CompilerC-45ESC-45Doc-block e-5))))))) (CompilerC-45ESC-45Codegen-stmt (box '()) arg-0 e-2) clam-0))))))) ((2) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 ((CompilerC-45ESC-45Codegen-exp arg-0 e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45ESC-45Codegen-exp arg-0 eta-1)) e-4 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45ESC-45Codegen-app e-5 e-6)))))))))))))) ((3) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Codegen-applyCon e-6 e-5 e-8)))))) (lambda (eta-1) (CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45ESC-45Codegen-exp arg-0 eta-2)) e-7 '() eta-1)) eta-0)))))) ((4) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45ESC-45Codegen-exp arg-0 eta-1)) e-10 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CompilerC-45ESC-45Codegen-jsOp e-9 e-5) eta-0))))))))) ((5) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45ESC-45Codegen-exp arg-0 eta-1)) e-12 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CompilerC-45ESC-45Codegen-jsPrim arg-0 e-11 e-5) eta-0))))))))) ((6) (let ((e-13 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (vector 3 (CompilerC-45ESC-45Codegen-jsConstant e-13)))))) (else (lambda (eta-0) (vector 1 (vector 3 "undefined")))))))
(define CompilerC-45ESC-45Codegen-esName (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 "_" arg-0)))
(define CompilerC-45ESC-45Codegen-def (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((act-24 (CompilerC-45ESC-45State-reset arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (CompilerC-45ESC-45State-getOrRegisterRef arg-0 e-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45State-registerLocal arg-0 eta-0 eta-1))) e-1 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref eta-0 1))) (vector 1 (let ((e-15 (vector-ref e-8 0))) e-15)))))) (lambda (eta-0) (let ((act-27 (unbox arg-0))) (vector 1 act-27))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 ((CompilerC-45ESC-45ToAst-stmt arg-0 '() e-2) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) ((CompilerC-45ESC-45Codegen-stmt (box '()) arg-0 e-9) ext-0))))))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (if (null? e-7) (vector 1 (CompilerC-45ESC-45Codegen-printDoc e-8 (CompilerC-45ESC-45Codegen-constant (CompilerC-45ESC-45Codegen-var e-6) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "__lazy(") (CompilerC-45ESC-45Codegen-function (CompilerC-45ESC-45Doc-u--neutral_Monoid_Doc) '() e-9)) (vector 3 ")"))))) (vector 1 (CompilerC-45ESC-45Codegen-printDoc e-8 (CompilerC-45ESC-45Codegen-function (CompilerC-45ESC-45Codegen-var e-6) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ESC-45Codegen-var eta-0)) e-7) e-9))))))))))))))))))))))))))))
(define CompilerC-45ESC-45Codegen-constant (lambda (arg-0 arg-1) (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 3 "const") (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-0 (CompilerC-45ESC-45Doc-softEq)) arg-1) (vector 3 ";")))))
(define CompilerC-45ESC-45Codegen-conTags (lambda (arg-0) (DataC-45List-u--zipWith_Zippable_List (lambda (u--i) (lambda (u--a) (CompilerC-45ESC-45Doc-hcat (cons (vector 3 "a") (cons (vector 3 (PreludeC-45Show-u--show_Show_Nat u--i)) (cons (CompilerC-45ESC-45Doc-softColon) (cons u--a '()))))))) (PreludeC-45Types-u--rangeFromTo_Range_Nat (+ 1 0) (PreludeC-45TypesC-45List-length arg-0)) arg-0)))
(define CompilerC-45ESC-45Codegen-compileToES (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CompilerC-45Common-getCompileData arg-0 0 0 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getDirectives arg-0 arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--mode (let ((sc2 (PreludeC-45Types-elem (csegen-17) "minimal" e-6))) (cond ((equal? sc2 1) 2) (else (let ((sc3 (PreludeC-45Types-elem (csegen-17) "compact" e-6))) (cond ((equal? sc3 1) 1) (else 0)))))))) (let ((act-26 (CoreC-45Core-newRef (vector "Compiler.ES.State.ESs" ) (CompilerC-45ESC-45State-init u--mode (lambda (eta-0) (CompilerC-45ESC-45Codegen-isArg u--mode eta-0)) (lambda (eta-0) (CompilerC-45ESC-45Codegen-isFun eta-0)) arg-3) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CompilerC-45ESC-45State-addRef e-7 (CompilerC-45ESC-45Codegen-tailRec) (vector 0 (CompilerC-45ESC-45Codegen-tailRec)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((u--allDefs (cons (cons (CompilerC-45ESC-45Codegen-mainExpr) (cons (vector 2 ) (vector 0 '() (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-5 0))) e-0))))) (let ((e-1 (vector-ref e-5 1))) e-1)))) (let ((u--defs (CompilerC-45ESC-45TailRec-functions (CompilerC-45ESC-45Codegen-tailRec) u--allDefs))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45Codegen-def e-7 eta-0 eta-1))) u--defs '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (PreludeC-45IO-u--map_Functor_IO (csegen-2316) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45ESC-45Codegen-foreign e-7 arg-0 eta-1)) u--allDefs '() eta-0)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref eta-0 1))) (vector 1 (CompilerC-45ESC-45Doc-compact (CompilerC-45ESC-45Codegen-var e-11))))))) (lambda (eta-0) (CompilerC-45ESC-45State-getOrRegisterRef e-7 (CompilerC-45ESC-45Codegen-mainExpr) eta-0)) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((u--main (PreludeC-45TypesC-45String-C-43C-43 "try{" (PreludeC-45TypesC-45String-C-43C-43 e-11 "()}catch(e){if(e instanceof IdrisError){console.log('ERROR: ' + e.message)}else{throw e} }")))) (let ((u--allDecls (DataC-45String-fastUnlines (PreludeC-45TypesC-45List-tailRecAppend e-10 e-9)))) (let ((act-31 (let ((act-31 (unbox e-7))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Directory-readDataFile arg-0 "js/support.js" ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((u--pre (CoreC-45NameC-45Namespace-showSep "\xa;" (cons e-13 (LibrariesC-45DataC-45SortedMap-values (let ((e-15 (vector-ref e-12 7))) e-15)))))) (vector 1 (DataC-45String-fastUnlines (cons u--pre (cons u--allDecls (cons u--main '()))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45ESC-45Codegen-castInt (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Codegen-case--castInt-2561 arg-2 arg-1 arg-0 (cons (cons arg-0 (CompilerC-45ESC-45Codegen-jsIntKind arg-0)) (cons arg-1 (CompilerC-45ESC-45Codegen-jsIntKind arg-1))))))
(define CompilerC-45ESC-45Codegen-callFun1 (lambda (arg-0 ext-0) (CompilerC-45ESC-45Codegen-callFun arg-0 (PreludeC-45Types-u--pure_Applicative_List ext-0))))
(define CompilerC-45ESC-45Codegen-callFun (lambda (ext-0 ext-1) (CompilerC-45ESC-45Codegen-app (vector 3 ext-0) ext-1)))
(define CompilerC-45ESC-45Codegen-breakDrop1 (lambda (arg-0 ext-0) (let ((sc0 (DataC-45String-break (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 arg-0)) ext-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons e-2 (LibrariesC-45DataC-45StringC-45Extra-drop (+ 1 0) e-3)))))))
(define CompilerC-45ESC-45Codegen-boundedUIntOp (lambda (ext-0 ext-1 ext-2 ext-3) (CompilerC-45ESC-45Codegen-boundedOp "u" ext-0 ext-1 ext-2 ext-3)))
(define CompilerC-45ESC-45Codegen-boundedOp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (CompilerC-45ESC-45Codegen-callFun (PreludeC-45Types-fastConcat (cons "_" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int arg-1) (cons arg-0 '()))))) (cons arg-3 (cons arg-4 '())))))
(define CompilerC-45ESC-45Codegen-boundedIntOp (lambda (ext-0 ext-1 ext-2 ext-3) (CompilerC-45ESC-45Codegen-boundedOp "s" ext-0 ext-1 ext-2 ext-3)))
(define CompilerC-45ESC-45Codegen-boolOp (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") (CompilerC-45ESC-45Codegen-binOp arg-0 arg-1 arg-2)) (vector 3 "?1:0)"))))
(define CompilerC-45ESC-45Codegen-binOp (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Doc-hcat (cons (vector 3 "(") (cons arg-1 (cons (vector 3 arg-0) (cons arg-2 (cons (vector 3 ")") '()))))))))
(define CompilerC-45ESC-45Codegen-arithOp (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45Codegen-binOp arg-1 eta-0 eta-1))) (let ((e-1 (unbox arg-0))) (lambda (clam-0) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (lambda (clam-1) (if (null? e-2) (CompilerC-45ESC-45Codegen-binOp arg-1 clam-0 clam-1) (let ((e-4 (unbox e-2))) (CompilerC-45ESC-45Codegen-boundedIntOp e-4 arg-2 clam-0 clam-1)))))) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-1) (CompilerC-45ESC-45Codegen-boundedUIntOp e-3 arg-2 clam-0 eta-1))))(else (lambda (eta-1) (CompilerC-45ESC-45Codegen-binOp arg-1 clam-0 eta-1)))))))))
(define CompilerC-45ESC-45Codegen-applyObj (lambda (ext-0) (CompilerC-45ESC-45Codegen-applyList (vector 3 "{") (vector 3 "}") (CompilerC-45ESC-45Doc-softComma) ext-0)))
(define CompilerC-45ESC-45Codegen-applyList (lambda (arg-0 arg-1 arg-2 arg-3) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-0 (PreludeC-45Interfaces-concat (csegen-3740) (DataC-45List-intersperse arg-2 arg-3))) arg-1)))
(define CompilerC-45ESC-45Codegen-applyCon (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-0 2) (if (null? arg-2) (csegen-3743) (CompilerC-45ESC-45Codegen-applyObj (cons (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "h") (CompilerC-45ESC-45Doc-softColon)) (CompilerC-45ESC-45Codegen-tag2es arg-1)) (CompilerC-45ESC-45Codegen-conTags arg-2))))) ((equal? arg-0 5) (if (null? arg-2) (csegen-3743) (CompilerC-45ESC-45Codegen-applyObj (cons (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "h") (CompilerC-45ESC-45Doc-softColon)) (CompilerC-45ESC-45Codegen-tag2es arg-1)) (CompilerC-45ESC-45Codegen-conTags arg-2))))) ((equal? arg-0 3) (CompilerC-45ESC-45Codegen-applyObj (CompilerC-45ESC-45Codegen-conTags arg-2))) ((equal? arg-0 6) (CompilerC-45ESC-45Codegen-applyObj (CompilerC-45ESC-45Codegen-conTags arg-2))) ((equal? arg-0 7) (CompilerC-45ESC-45Codegen-applyObj (CompilerC-45ESC-45Codegen-conTags arg-2))) ((equal? arg-0 10) (if (null? arg-2) (vector 3 "undefined") (CompilerC-45ESC-45Codegen-applyObj (cons (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "h") (CompilerC-45ESC-45Doc-softColon)) (CompilerC-45ESC-45Codegen-tag2es arg-1)) (CompilerC-45ESC-45Codegen-conTags arg-2)))))(else (CompilerC-45ESC-45Codegen-applyObj (cons (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "h") (CompilerC-45ESC-45Doc-softColon)) (CompilerC-45ESC-45Codegen-tag2es arg-1)) (CompilerC-45ESC-45Codegen-conTags arg-2)))))))
(define CompilerC-45ESC-45Codegen-app (lambda (arg-0 arg-1) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-0 (CompilerC-45ESC-45Codegen-applyList (vector 3 "(") (vector 3 ")") (CompilerC-45ESC-45Doc-softComma) arg-1))))
(define CompilerC-45ESC-45State-case--addToPreamble-5642 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (let ((act-24 (set-box! arg-2 (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((e-7 (vector-ref arg-3 7))) (let ((e-8 (vector-ref arg-3 8))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-0 e-7) e-8))))))))))))) (vector 1 act-24))) (let ((e-2 (unbox arg-4))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 arg-0))) (cond ((equal? sc1 1) (lambda (eta-0) (vector 1 0))) (else (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "two incompatible definitions for " (cons arg-1 (cons "<|" (cons e-2 (cons "|> <|" (cons arg-0 (cons "|>" '()))))))) eta-0)))))))))
(define CompilerC-45ESC-45State-reset (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (vector e-0 e-1 e-2 0 e-4 (csegen-3744) e-6 e-7 e-8))))))))))) (vector 1 act-25))))))))
(define CompilerC-45ESC-45State-registerRef (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (CompilerC-45ESC-45State-keepRefName arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)))) (cond ((equal? sc1 1) (let ((u--v (vector 0 arg-1))) (let ((act-25 (CompilerC-45ESC-45State-addRef arg-0 arg-1 u--v ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 u--v)))))) (else (let ((act-25 (CompilerC-45ESC-45State-nextRef arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CompilerC-45ESC-45State-addRef arg-0 arg-1 e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 e-6)))))))))))))))))
(define CompilerC-45ESC-45State-registerLocal (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (CompilerC-45ESC-45State-keepLocalName arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)))) (cond ((equal? sc1 1) (let ((u--v (vector 0 arg-1))) (let ((act-25 (CompilerC-45ESC-45State-addLocal arg-0 arg-1 (vector 0 u--v) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 u--v)))))) (else (let ((act-25 (CompilerC-45ESC-45State-nextLocal arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CompilerC-45ESC-45State-addLocal arg-0 arg-1 (vector 0 e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 e-6)))))))))))))))))
(define CompilerC-45ESC-45State-projections (lambda (arg-0 arg-1 arg-2) (let ((u--ps (DataC-45List-u--zip_Zippable_List (PreludeC-45Types-u--rangeFromTo_Range_Nat (+ 1 0) (PreludeC-45TypesC-45List-length arg-2)) arg-2))) (lambda (eta-0) (CoreC-45Core-traverse_ (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (CompilerC-45ESC-45State-addLocal arg-0 e-3 (vector 1 e-2 arg-1) clam-0))))) u--ps eta-0)))))
(define CompilerC-45ESC-45State-nextRef (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-9 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (vector e-0 e-1 e-2 e-3 (bs+ e-4 1 63) e-9 e-6 e-7 e-8))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 2 (let ((e-4 (vector-ref e-5 4))) e-4))))))))))))
(define CompilerC-45ESC-45State-nextLocal (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-9 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (vector e-0 e-1 e-2 (bs+ e-3 1 63) e-4 e-9 e-6 e-7 e-8))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (vector 1 (let ((e-3 (vector-ref e-5 3))) e-3))))))))))))
(define CompilerC-45ESC-45State-keepRefName (lambda (arg-0 arg-1) (cond ((equal? arg-1 2) 0)(else 1))))
(define CompilerC-45ESC-45State-keepLocalName (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((1) (cond ((equal? arg-1 0) 1)(else 0)))(else 0))))
(define CompilerC-45ESC-45State-init (lambda (arg-0 arg-1 arg-2 arg-3) (vector arg-0 arg-1 arg-2 0 0 (csegen-3744) (csegen-3744) (LibrariesC-45DataC-45SortedMap-empty (csegen-261)) arg-3)))
(define CompilerC-45ESC-45State-getOrRegisterRef (lambda (arg-0 arg-1 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45SortedMap-lookup arg-1 (let ((e-6 (vector-ref e-5 6))) e-6))))))) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CompilerC-45ESC-45State-registerRef arg-0 arg-1 ext-0) (let ((e-2 (unbox e-5))) (vector 1 e-2)))))))))
(define CompilerC-45ESC-45State-getOrRegisterLocal (lambda (arg-0 arg-1 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45SortedMap-lookup arg-1 (let ((e-9 (vector-ref e-5 5))) e-9))))))) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector 0 e-6)))))) (lambda (eta-0) (CompilerC-45ESC-45State-registerLocal arg-0 arg-1 eta-0)) ext-0) (let ((e-2 (unbox e-5))) (vector 1 e-2)))))))))
(define CompilerC-45ESC-45State-errorConcat (lambda (ext-1 ext-0) (CompilerC-45ESC-45State-error (PreludeC-45Types-fastConcat ext-1) ext-0)))
(define CompilerC-45ESC-45State-error (lambda (ext-0 ext-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 ext-0) ext-1)))
(define CompilerC-45ESC-45State-addToPreamble (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CompilerC-45ESC-45State-case--addToPreamble-5642 arg-2 arg-1 arg-0 e-5 (LibrariesC-45DataC-45SortedMap-lookup arg-1 (let ((e-7 (vector-ref e-5 7))) e-7))) ext-0)))))))
(define CompilerC-45ESC-45State-addRef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-9 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (vector e-0 e-1 e-2 e-3 e-4 e-9 (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-2 e-6) e-7 e-8))))))))))))) (vector 1 act-25))))))))
(define CompilerC-45ESC-45State-addLocal (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-9 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (vector e-0 e-1 e-2 e-3 e-4 (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-2 e-9) e-6 e-7 e-8))))))))))))) (vector 1 act-25))))))))
(define CompilerC-45ESC-45Ast-toMinimal (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else '()))))
(define CompilerC-45ESC-45Ast-prepend (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (vector 7 (cons e-2 e-3) arg-2))))))
(define CompilerC-45ESC-45Ast-declare (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-1 (vector-ref arg-1 2))) (vector 1 arg-0 e-1))) ((7) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (vector 7 e-3 (CompilerC-45ESC-45Ast-declare arg-0 e-4)))))(else (vector 3 arg-0 arg-1)))))
(define CompilerC-45ESC-45TailRec-n--6701-3988-u--toTc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (let ((e-0 (vector-ref arg-6 1))) (let ((e-1 (vector-ref arg-6 2))) (let ((e-2 (vector-ref arg-6 3))) (let ((e-3 (vector-ref arg-6 4))) (vector 3 e-0 e-1 e-2 (CompilerC-45ESC-45TailRec-n--6701-3988-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))))))) ((4) (let ((e-4 (vector-ref arg-6 1))) (let ((e-5 (vector-ref arg-6 2))) (let ((e-6 (vector-ref arg-6 3))) (case (vector-ref e-5 0) ((1) (let ((e-17 (vector-ref e-5 1))) (let ((e-18 (vector-ref e-5 2))) (let ((u--x (vector 4 e-4 (vector 1 e-17 e-18) e-6))) (let ((sc2 (LibrariesC-45DataC-45SortedMap-lookup e-18 arg-0))) (if (null? sc2) (CompilerC-45ESC-45TailRec-n--6701-3986-u--tcDone arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--x) (let ((e-1 (unbox sc2))) (CompilerC-45ESC-45TailRec-n--6701-3987-u--tcContinue arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-7 (vector-ref e-1 1))) e-7) e-6))))))))(else (CompilerC-45ESC-45TailRec-n--6701-3986-u--tcDone arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6))))))) ((10) (let ((e-7 (vector-ref arg-6 1))) (let ((e-8 (vector-ref arg-6 2))) (let ((e-9 (vector-ref arg-6 3))) (let ((e-10 (vector-ref arg-6 4))) (vector 10 e-7 e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--6701-3989-u--con arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-9) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--6701-3988-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-10))))))) ((11) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (vector 11 e-11 e-12 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--6701-3990-u--const arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-13) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--6701-3988-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-14))))))) ((14) arg-6)(else (CompilerC-45ESC-45TailRec-n--6701-3986-u--tcDone arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6)))))
(define CompilerC-45ESC-45TailRec-n--6915-4177-u--toFun (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc2 (LibrariesC-45DataC-45SortedMap-lookup e-2 arg-2))) (if (null? sc2) (box (vector e-2 e-6 e-7)) '()))))))))
(define CompilerC-45ESC-45TailRec-n--6854-4115-u--toFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-0 (vector-ref arg-4 0))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((u--exps (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--6854-4114-u--local arg-0 arg-1 arg-2 arg-3 eta-0)) e-2))) (let ((u--tcArg (vector 5 (vector 2 ) (CompilerC-45ESC-45TailRec-tcContinueName arg-1 e-1) 0 (box e-1) u--exps))) (let ((u--tcFun (vector 1 (vector 2 ) (CompilerC-45ESC-45TailRec-n--6854-4113-u--tcFun arg-0 arg-1 arg-2 arg-3)))) (let ((u--body (vector 4 (vector 2 ) (vector 1 (vector 2 ) arg-3) (cons u--tcFun (cons u--tcArg '()))))) (vector e-0 e-2 u--body))))))))))
(define CompilerC-45ESC-45TailRec-n--6854-4113-u--tcFun (lambda (arg-0 arg-1 arg-2 arg-3) (CompilerC-45ESC-45TailRec-tcFunction arg-1)))
(define CompilerC-45ESC-45TailRec-n--6701-3986-u--tcDone (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector 5 (vector 2 ) (CompilerC-45ESC-45TailRec-tcDoneName arg-1) 0 (box 0) (cons arg-6 '()))))
(define CompilerC-45ESC-45TailRec-n--6701-3987-u--tcContinue (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (vector 5 (vector 2 ) (CompilerC-45ESC-45TailRec-tcContinueName arg-1 arg-6) 0 (box arg-6) ext-0)))
(define CompilerC-45ESC-45TailRec-n--6854-4114-u--local (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (vector 0 (vector 2 ) ext-0)))
(define CompilerC-45ESC-45TailRec-n--6487-3800-u--fun (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45SortedMap-lookup e-3 arg-2) (lambda (_-0) (let ((e-4 (cdr _-0))) (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (PreludeC-45Types-u--pure_Applicative_Maybe (cons e-3 (vector e-3 e-2 e-6 e-7))))))))))))
(define CompilerC-45ESC-45TailRec-n--7000-4254-u--def (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) '() (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (let ((e-9 (vector-ref e-7 2))) (box (cons e-2 (cons e-8 e-9))))))(else '())))))))))
(define CompilerC-45ESC-45TailRec-n--6701-3990-u--const (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (car arg-6))) (let ((e-1 (cdr arg-6))) (cons e-0 (CompilerC-45ESC-45TailRec-n--6701-3988-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-1))))))
(define CompilerC-45ESC-45TailRec-n--6701-3989-u--con (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (vector e-0 e-1 e-2 e-3 (CompilerC-45ESC-45TailRec-n--6701-3988-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4)))))))))
(define CompilerC-45ESC-45TailRec-zipWithIndices (lambda (arg-1) (DataC-45List-u--zip_Zippable_List (CompilerC-45ESC-45TailRec-indices arg-1) arg-1)))
(define CompilerC-45ESC-45TailRec-toGroup (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((u--ns (CompilerC-45ESC-45TailRec-zipWithIndices (DataC-45List1-forget e-3)))) (let ((u--group (cons e-2 (LibrariesC-45DataC-45SortedMap-fromList (csegen-883) (DataC-45List-mapMaybe (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--6487-3800-u--fun e-2 e-3 arg-0 eta-0)) u--ns))))) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (__leftTupleSection-0) (cons __leftTupleSection-0 u--group)) (DataC-45List1-forget e-3))))))))
(define CompilerC-45ESC-45TailRec-tcFunction (lambda (ext-0) (vector 2 "$tcOpt" ext-0)))
(define CompilerC-45ESC-45TailRec-tcDoneName (lambda (arg-0) (vector 2 "TcDone" arg-0)))
(define CompilerC-45ESC-45TailRec-tcContinueName (lambda (arg-0 arg-1) (vector 2 (PreludeC-45TypesC-45String-C-43C-43 "TcContinue" (PreludeC-45Show-u--show_Show_Int arg-0)) arg-1)))
(define CompilerC-45ESC-45TailRec-tcArgName(blodwen-lazy (lambda () (vector 2 "$a" 0))))
(define CompilerC-45ESC-45TailRec-tailRecOptim (lambda (arg-0 arg-1 arg-2) (let ((u--regular (DataC-45List-mapMaybe (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--6915-4177-u--toFun arg-2 arg-1 arg-0 eta-0)) arg-2))) (let ((u--tailOpt (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (CompilerC-45ESC-45TailRec-convertTcGroup arg-1 eta-0)) (LibrariesC-45DataC-45SortedMap-values arg-0)))) (PreludeC-45TypesC-45List-tailRecAppend u--tailOpt u--regular)))))
(define CompilerC-45ESC-45TailRec-tailCalls (lambda (arg-0) (case (vector-ref arg-0 0) ((3) (let ((e-3 (vector-ref arg-0 4))) (CompilerC-45ESC-45TailRec-tailCalls e-3))) ((4) (let ((e-5 (vector-ref arg-0 2))) (case (vector-ref e-5 0) ((1) (let ((e-16 (vector-ref e-5 2))) (LibrariesC-45DataC-45SortedSet-singleton (csegen-883) e-16)))(else (csegen-3747))))) ((10) (let ((e-9 (vector-ref arg-0 3))) (let ((e-10 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-883) (PreludeC-45Interfaces-concatMap (csegen-3748) (lambda (lamc-0) (let ((e-4 (vector-ref lamc-0 4))) (CompilerC-45ESC-45TailRec-tailCalls e-4))) e-9) (PreludeC-45Interfaces-concatMap (csegen-3753) (lambda (eta-0) (CompilerC-45ESC-45TailRec-tailCalls eta-0)) e-10))))) ((11) (let ((e-13 (vector-ref arg-0 3))) (let ((e-14 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-883) (PreludeC-45Interfaces-concatMap (csegen-3748) (lambda (lamc-0) (let ((e-1 (cdr lamc-0))) (CompilerC-45ESC-45TailRec-tailCalls e-1))) e-13) (PreludeC-45Interfaces-concatMap (csegen-3753) (lambda (eta-0) (CompilerC-45ESC-45TailRec-tailCalls eta-0)) e-14)))))(else (csegen-3747)))))
(define CompilerC-45ESC-45TailRec-tailCallGroups (lambda (arg-0) (let ((u--funMap (LibrariesC-45DataC-45SortedMap-fromList (csegen-883) (PreludeC-45Types-u--map_Functor_List (lambda (u--t) (cons (Builtin-fst u--t) u--t)) arg-0)))) (let ((u--graph (LibrariesC-45DataC-45SortedMap-u--map_Functor_C-40SortedMapC-32C-36kC-41 (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (CompilerC-45ESC-45TailRec-tailCalls e-7)))) u--funMap))) (let ((u--groups (DataC-45List-filter (lambda (eta-0) (CompilerC-45ESC-45TailRec-hasTailCalls u--graph eta-0)) (LibrariesC-45DataC-45Graph-tarjan (csegen-883) u--graph)))) (LibrariesC-45DataC-45SortedMap-fromList (csegen-883) (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (CompilerC-45ESC-45TailRec-toGroup u--funMap eta-0)) (CompilerC-45ESC-45TailRec-zipWithIndices u--groups))))))))
(define CompilerC-45ESC-45TailRec-indices (lambda (arg-1) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (csegen-219) 1 (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45List-length arg-1)))))
(define CompilerC-45ESC-45TailRec-hasTailCalls (lambda (arg-0 arg-1) (if (null? arg-1) 1 (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (LibrariesC-45DataC-45SortedSet-contains e-1 eta-0))) (LibrariesC-45DataC-45SortedMap-lookup e-1 arg-0)) 1))))))
(define CompilerC-45ESC-45TailRec-functions (lambda (arg-0 arg-1) (let ((u--ts (DataC-45List-mapMaybe (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--7000-4254-u--def arg-1 arg-0 eta-0)) arg-1))) (CompilerC-45ESC-45TailRec-tailRecOptim (CompilerC-45ESC-45TailRec-tailCallGroups u--ts) arg-0 u--ts))))
(define CompilerC-45ESC-45TailRec-convertTcGroup (lambda (arg-0 arg-1) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((u--functions (DataC-45List-sortBy (lambda (eta-0) (lambda (eta-1) (PreludeC-45EqOrd-comparing (csegen-224) (lambda (eta-2) (let ((e-4 (vector-ref eta-2 1))) e-4)) eta-0 eta-1))) (LibrariesC-45DataC-45SortedMap-values e-1)))) (let ((u--branches (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ESC-45TailRec-conAlt arg-1 eta-0)) u--functions))) (let ((u--switch (vector 10 (vector 2 ) (CompilerC-45ESC-45TailRec-n--6854-4114-u--local e-1 e-0 arg-1 arg-0 (CompilerC-45ESC-45TailRec-tcArgName)) u--branches '()))) (cons (vector (CompilerC-45ESC-45TailRec-n--6854-4113-u--tcFun e-1 e-0 arg-1 arg-0) (cons (CompilerC-45ESC-45TailRec-tcArgName) '()) u--switch) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--6854-4115-u--toFun e-1 e-0 arg-1 arg-0 eta-0)) u--functions)))))))))
(define CompilerC-45ESC-45TailRec-conAlt (lambda (arg-0 arg-1) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (let ((e-2 (vector-ref arg-1 0))) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((u--name (CompilerC-45ESC-45TailRec-tcContinueName e-0 e-3))) (vector u--name 0 (box e-3) e-4 (CompilerC-45ESC-45TailRec-n--6701-3988-u--toTc e-1 e-0 e-5 e-4 e-3 e-2 e-5)))))))))))
(define LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnect-1587 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (vector e-1 e-2 e-3 e-4 1))))) (let ((e-2 (unbox arg-6))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (let ((e-0 (vector-ref e-2 0))) e-0) (let ((e-1 (vector-ref e-2 1))) e-1)))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45Graph-n--3014-878-u--createComponent arg-1 arg-2 arg-3 arg-4 arg-5 arg-3 '())) (else arg-5)))))))
(define LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnectC-44loop-1168 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (let ((u--tsC-39 (LibrariesC-45DataC-45Graph-n--3009-874-u--strongConnect arg-1 arg-2 arg-7 arg-5))) (let ((sc1 (LibrariesC-45DataC-45SortedMap-lookup arg-5 (let ((e-1 (vector-ref u--tsC-39 0))) e-1)))) (if (null? sc1) (let ((e-1 (vector-ref u--tsC-39 0))) (let ((e-2 (vector-ref u--tsC-39 1))) (let ((e-3 (vector-ref u--tsC-39 2))) (let ((e-4 (vector-ref u--tsC-39 3))) (vector e-1 e-2 e-3 e-4 1))))) (let ((e-2 (unbox sc1))) (let ((e-1 (vector-ref u--tsC-39 0))) (let ((e-6 (vector-ref u--tsC-39 1))) (let ((e-3 (vector-ref u--tsC-39 2))) (let ((e-4 (vector-ref u--tsC-39 3))) (let ((e-5 (vector-ref u--tsC-39 4))) (vector (LibrariesC-45DataC-45SortedMap-adjust arg-3 (lambda (rec-0) (let ((e-0 (vector-ref rec-0 0))) (let ((e-8 (vector-ref rec-0 1))) (let ((e-7 (vector-ref rec-0 2))) (vector e-0 (PreludeC-45EqOrd-u--min_Ord_Int (let ((e-10 (vector-ref e-2 1))) e-10) e-8) e-7))))) e-1) e-6 e-3 e-4 e-5)))))))))) (let ((e-2 (unbox arg-8))) (let ((sc1 (let ((e-3 (vector-ref e-2 2))) e-3))) (cond ((equal? sc1 0) arg-7) (else (let ((e-1 (vector-ref arg-7 0))) (let ((e-6 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (vector (LibrariesC-45DataC-45SortedMap-adjust arg-3 (lambda (rec-0) (let ((e-0 (vector-ref rec-0 0))) (let ((e-8 (vector-ref rec-0 1))) (let ((e-7 (vector-ref rec-0 2))) (vector e-0 (PreludeC-45EqOrd-u--min_Ord_Int (let ((e-11 (vector-ref e-2 0))) e-11) e-8) e-7))))) e-1) e-6 e-3 e-4 e-5)))))))))))))
(define LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnectC-44createComponent-888 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (vector e-1 e-2 e-3 e-4 1))))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((u--tsC-39 (let ((e-1 (vector-ref arg-7 0))) (let ((e-6 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (vector (LibrariesC-45DataC-45SortedMap-adjust e-2 (lambda (rec-0) (let ((e-0 (vector-ref rec-0 0))) (let ((e-9 (vector-ref rec-0 1))) (vector e-0 e-9 0)))) e-1) e-3 e-6 e-4 e-5))))))) (let ((sc1 (let ((e-1 (vector-ref arg-1 0))) (let ((e-12 (car e-1))) ((e-12 e-2) arg-6))))) (cond ((equal? sc1 1) (let ((e-1 (vector-ref u--tsC-39 0))) (let ((e-7 (vector-ref u--tsC-39 1))) (let ((e-6 (vector-ref u--tsC-39 2))) (let ((e-4 (vector-ref u--tsC-39 3))) (let ((e-5 (vector-ref u--tsC-39 4))) (vector e-1 e-7 e-6 (cons (cons arg-6 arg-5) e-4) e-5))))))) (else (LibrariesC-45DataC-45Graph-n--3014-878-u--createComponent arg-1 arg-2 arg-3 arg-4 u--tsC-39 arg-6 (cons e-2 arg-5)))))))))))
(define LibrariesC-45DataC-45Graph-n--3014-880-u--tsC-39 (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (vector-ref arg-4 0))) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (vector (LibrariesC-45DataC-45SortedMap-insert arg-3 (vector (let ((e-8 (vector-ref arg-4 2))) e-8) (let ((e-8 (vector-ref arg-4 2))) e-8) 1) e-1) (cons arg-3 e-2) (bs+ (blodwen-toSignedInt 1 63) e-3 63) e-4 e-5))))))))
(define LibrariesC-45DataC-45Graph-n--3009-874-u--strongConnect (lambda (arg-1 arg-2 arg-3 arg-4) (let ((u--tsC-39C-39 (let ((sc0 (LibrariesC-45DataC-45SortedMap-lookup arg-4 arg-2))) (if (null? sc0) (LibrariesC-45DataC-45Graph-n--3014-880-u--tsC-39 arg-1 arg-2 arg-4 arg-3) (let ((e-2 (unbox sc0))) (LibrariesC-45DataC-45Graph-n--3014-879-u--loop arg-1 arg-2 arg-4 arg-3 (LibrariesC-45DataC-45Graph-n--3014-880-u--tsC-39 arg-1 arg-2 arg-4 arg-3) (LibrariesC-45DataC-45SortedSet-toList e-2))))))) (LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnect-1587 arg-1 arg-2 arg-4 arg-3 u--tsC-39C-39 (LibrariesC-45DataC-45SortedMap-lookup arg-4 (let ((e-1 (vector-ref u--tsC-39C-39 0))) e-1))))))
(define LibrariesC-45DataC-45Graph-n--3014-879-u--loop (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (LibrariesC-45DataC-45Graph-n--3014-879-u--loop arg-1 arg-2 arg-3 arg-4 (LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnectC-44loop-1168 arg-1 arg-2 arg-3 arg-4 e-2 e-3 arg-5 (LibrariesC-45DataC-45SortedMap-lookup e-2 (let ((e-1 (vector-ref arg-5 0))) e-1))) e-3))))))
(define LibrariesC-45DataC-45Graph-n--3009-875-u--loop (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (let ((sc1 (let ((e-5 (vector-ref arg-3 4))) e-5))) (cond ((equal? sc1 1) '()) (else (let ((e-4 (vector-ref arg-3 3))) e-4)))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45SortedMap-lookup e-2 (let ((e-1 (vector-ref arg-3 0))) e-1)))) (if (null? sc1) (LibrariesC-45DataC-45Graph-n--3009-875-u--loop arg-1 arg-2 (LibrariesC-45DataC-45Graph-n--3009-874-u--strongConnect arg-1 arg-2 arg-3 e-2) e-3) (LibrariesC-45DataC-45Graph-n--3009-875-u--loop arg-1 arg-2 arg-3 e-3))))))))
(define LibrariesC-45DataC-45Graph-n--3014-878-u--createComponent (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnectC-44createComponent-888 arg-1 arg-2 arg-3 arg-4 arg-7 arg-6 arg-5 (let ((e-2 (vector-ref arg-5 1))) e-2))))
(define LibrariesC-45DataC-45Graph-tarjan (lambda (arg-1 arg-2) (LibrariesC-45DataC-45Graph-n--3009-875-u--loop arg-1 arg-2 (LibrariesC-45DataC-45Graph-initial arg-1) (LibrariesC-45DataC-45SortedMap-keys arg-2))))
(define LibrariesC-45DataC-45Graph-initial (lambda (arg-1) (vector (LibrariesC-45DataC-45SortedMap-empty arg-1) '() 0 '() 0)))
(define CompilerC-45ESC-45ToAst-n--7294-5389-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 2))) (let ((e-2 (vector-ref arg-4 3))) (CompilerC-45ESC-45ToAst-n--7294-5389-u--go arg-0 arg-1 arg-2 (cons e-1 arg-3) e-2))))(else (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45ESC-45State-registerLocal arg-2 eta-1 eta-2))) (PreludeC-45TypesC-45List-reverse arg-3) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (vector 1 e-5 e-6)))))) (CompilerC-45ESC-45ToAst-stmt arg-2 '() arg-4) eta-0))))))))))
(define CompilerC-45ESC-45ToAst-tag (lambda (arg-0 ext-0) (PreludeC-45Types-maybe (lambda () (vector 1 arg-0)) (lambda () (lambda (eta-0) (vector 0 eta-0))) ext-0)))
(define CompilerC-45ESC-45ToAst-stmt (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 0 e-5))))))) (lambda (eta-1) (CompilerC-45ESC-45State-getOrRegisterLocal arg-0 e-1 eta-1)) eta-0)))) ((1) (let ((e-3 (vector-ref arg-2 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 0 (vector 0 e-5)))))))) (lambda (eta-1) (CompilerC-45ESC-45State-getOrRegisterRef arg-0 e-3 eta-1)) eta-0)))) ((2) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 e-7)))))) (CompilerC-45ESC-45ToAst-lambda arg-0 e-5 e-6) eta-0))))) ((3) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-24 (CompilerC-45ESC-45State-nextLocal arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45ESC-45ToAst-stmt arg-0 (box e-5) e-9) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CompilerC-45ESC-45State-addLocal arg-0 e-8 (vector 0 e-5) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-10) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-27 1))) (vector 1 (CompilerC-45ESC-45Ast-prepend (cons (CompilerC-45ESC-45Ast-declare e-5 e-6) '()) e-12)))))))))))))))))))))) ((4) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CompilerC-45ESC-45ToAst-liftFun arg-0 e-12 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CompilerC-45ESC-45ToAst-liftArgs arg-0 e-13 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (CompilerC-45ESC-45Ast-prepend (PreludeC-45TypesC-45List-tailRecAppend e-2 e-7) (CompilerC-45ESC-45ToAst-assign arg-1 (vector 2 e-3 e-4)))))))))))))))))))) ((5) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (let ((e-18 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-24 (CompilerC-45ESC-45ToAst-liftArgs arg-0 e-18 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 3 (CompilerC-45ESC-45ToAst-tag e-15 e-17) e-16 e-3)))))))))))))))) ((6) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((u--o (vector 6 e-19 e-20 e-21 e-22))) (lambda (clam-0) (let ((sc1 (CompilerC-45ESC-45ToAst-integerArith u--o))) (if (null? sc1) (let ((act-24 (CompilerC-45ESC-45ToAst-liftArgsVect arg-0 e-22 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 4 e-21 e-3)))))))))) (let ((e-1 (unbox sc1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 6 (vector 5 e-1)))))))))))))) ((7) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CompilerC-45ESC-45ToAst-liftArgs arg-0 e-25 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 5 e-24 e-3)))))))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-24 (CompilerC-45ESC-45ToAst-liftFun arg-0 e-28 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 2 e-3 '()))))))))))))) ((9) (let ((e-31 (vector-ref arg-2 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 1 '() e-5))))))) (CompilerC-45ESC-45ToAst-stmt arg-0 '() e-31) eta-0)))) ((10) (let ((e-33 (vector-ref arg-2 2))) (let ((e-34 (vector-ref arg-2 3))) (let ((e-35 (vector-ref arg-2 4))) (if (null? e-34) (if (null? e-35) (lambda (eta-0) (let ((act-24 (CompilerC-45ESC-45ToAst-liftMinimal arg-0 e-33 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45ESC-45ToAst-conAlt arg-0 arg-1 e-3 eta-1 eta-2))) e-34 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-35) (vector 1 '()) (let ((e-4 (unbox e-35))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 4 arg-1 e-3 e-6 e-7)))))))))))))))))) (let ((e-52 (unbox e-35))) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-52))) (let ((e-46 (car e-34))) (let ((e-47 (cdr e-34))) (lambda (clam-0) (if (null? e-47) (if (null? e-35) (let ((act-24 (CompilerC-45ESC-45ToAst-liftMinimal arg-0 e-33 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (let ((e-4 (vector-ref e-6 2))) e-4)))))) (lambda (eta-0) (CompilerC-45ESC-45ToAst-conAlt arg-0 arg-1 e-3 e-46 eta-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 e-6)))))))))))) (let ((act-24 (CompilerC-45ESC-45ToAst-liftMinimal arg-0 e-33 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-conAlt arg-0 arg-1 e-3 eta-0 eta-1))) e-34 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-35) (vector 1 '()) (let ((e-4 (unbox e-35))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 4 arg-1 e-3 e-6 e-7)))))))))))))))))) (let ((act-24 (CompilerC-45ESC-45ToAst-liftMinimal arg-0 e-33 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-conAlt arg-0 arg-1 e-3 eta-0 eta-1))) e-34 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-35) (vector 1 '()) (let ((e-4 (unbox e-35))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4) clam-0))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 4 arg-1 e-3 e-6 e-7)))))))))))))))))))))))))) ((11) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (if (null? e-38) (if (null? e-39) (lambda (eta-0) (let ((act-24 (CompilerC-45ESC-45ToAst-liftArg arg-0 e-37 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45ESC-45ToAst-constAlt arg-0 arg-1 eta-1 eta-2))) e-38 '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-39) (vector 1 '()) (let ((e-4 (unbox e-39))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4) eta-0))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 5 arg-1 e-3 e-6 e-7)))))))))))))))))) (let ((e-60 (unbox e-39))) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-60))) (let ((e-54 (car e-38))) (let ((e-55 (cdr e-38))) (lambda (clam-1) (if (null? e-55) (if (null? e-39) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (cdr e-5))) e-2)))))) (lambda (eta-0) (CompilerC-45ESC-45ToAst-constAlt arg-0 arg-1 e-54 eta-0)) clam-1) (let ((act-24 (CompilerC-45ESC-45ToAst-liftArg arg-0 e-37 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-constAlt arg-0 arg-1 eta-0 eta-1))) e-38 '() clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-39) (vector 1 '()) (let ((e-4 (unbox e-39))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4) clam-1))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 5 arg-1 e-3 e-6 e-7)))))))))))))))))) (let ((act-24 (CompilerC-45ESC-45ToAst-liftArg arg-0 e-37 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-constAlt arg-0 arg-1 eta-0 eta-1))) e-38 '() clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (if (null? e-39) (vector 1 '()) (let ((e-4 (unbox e-39))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4) clam-1))))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 5 arg-1 e-3 e-6 e-7)))))))))))))))))))))))))) ((12) (let ((e-41 (vector-ref arg-2 2))) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 6 e-41)))))) ((13) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 7 ))))) (else (let ((e-44 (vector-ref arg-2 2))) (lambda (eta-0) (vector 1 (vector 6 e-44))))))))
(define CompilerC-45ESC-45ToAst-liftMinimal (lambda (arg-0 arg-1 ext-0) (CompilerC-45ESC-45ToAst-lift arg-0 arg-1 (lambda (eta-0) (CompilerC-45ESC-45Ast-toMinimal eta-0)) (lambda (eta-0) (vector 0 eta-0)) ext-0)))
(define CompilerC-45ESC-45ToAst-liftFun (lambda (arg-0 arg-1 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CompilerC-45ESC-45ToAst-lift arg-0 arg-1 (lambda (u--e) (PreludeC-45Interfaces-C-36C-62 (csegen-73) (PreludeC-45Interfaces-guard (csegen-538) (e-5 u--e)) u--e)) (lambda (eta-0) (vector 0 (vector 0 eta-0))) ext-0)))))))
(define CompilerC-45ESC-45ToAst-liftArgsVect (lambda (arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Core-traverseVect (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-liftArg arg-1 eta-0 eta-1))) arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (PreludeC-45Interfaces-concatMap (cons (csegen-1006) (csegen-65)) (lambda (eta-0) (Builtin-fst eta-0)) e-5) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (Builtin-snd eta-0)) e-5)))))))))
(define CompilerC-45ESC-45ToAst-liftArgs (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-liftArg arg-0 eta-0 eta-1))) arg-1 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (PreludeC-45Interfaces-concatMap (csegen-50) (lambda (eta-0) (Builtin-fst eta-0)) e-5) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-5)))))))))
(define CompilerC-45ESC-45ToAst-liftArg (lambda (arg-0 arg-1 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-1 (vector-ref e-5 1))) e-1)))))) (lambda (eta-0) (let ((act-24 (unbox arg-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CompilerC-45ESC-45ToAst-lift arg-0 arg-1 (lambda (u--e) (PreludeC-45Interfaces-C-36C-62 (csegen-73) (PreludeC-45Interfaces-guard (csegen-538) (e-5 u--e)) u--e)) (lambda (eta-0) (vector 0 (vector 0 eta-0))) ext-0)))))))
(define CompilerC-45ESC-45ToAst-lift (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CompilerC-45ESC-45State-nextLocal arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45ESC-45ToAst-stmt arg-1 (box e-5) arg-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--pair (cons (cons (CompilerC-45ESC-45Ast-declare e-5 e-6) '()) (arg-4 e-5)))) (case (vector-ref e-6 0) ((2) (let ((e-1 (vector-ref e-6 2))) (vector 1 (PreludeC-45Types-maybe (lambda () u--pair) (lambda () (lambda (__infixTupleSection-0) (cons '() __infixTupleSection-0))) (arg-3 e-1)))))(else (vector 1 u--pair))))))))))))))
(define CompilerC-45ESC-45ToAst-lambda (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45ToAst-n--7294-5389-u--go arg-2 arg-1 arg-0 (cons arg-1 '()) arg-2)))
(define CompilerC-45ESC-45ToAst-integerArith (lambda (arg-0) (case (vector-ref arg-0 0) ((6) (let ((e-0 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 3))) (let ((e-3 (vector-ref arg-0 4))) (cond ((equal? e-0 0) '())(else (let ((e-4 (- e-0 1))) (cond ((equal? e-4 0) '())(else (let ((e-5 (- e-4 1))) (cond ((equal? e-5 0) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (case (vector-ref e-6 0) ((19) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (if (null? e-11) '() (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (if (null? e-15) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--pure_Applicative_Maybe (lambda (eta-0) (lambda (eta-1) (+ eta-0 eta-1)))) (CompilerC-45ESC-45ToAst-getInteger e-10)) (CompilerC-45ESC-45ToAst-getInteger e-14)) '()))))))))(else '())))) ((2) (let ((e-7 (vector-ref e-2 1))) (case (vector-ref e-7 0) ((19) (if (null? e-3) '() (let ((e-19 (car e-3))) (let ((e-20 (cdr e-3))) (if (null? e-20) '() (let ((e-23 (car e-20))) (let ((e-24 (cdr e-20))) (if (null? e-24) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--pure_Applicative_Maybe (lambda (eta-0) (lambda (eta-1) (* eta-0 eta-1)))) (CompilerC-45ESC-45ToAst-getInteger e-19)) (CompilerC-45ESC-45ToAst-getInteger e-23)) '()))))))))(else '()))))(else '())))(else '()))))))))))))(else '()))))
(define CompilerC-45ESC-45ToAst-getInteger (lambda (arg-0) (case (vector-ref arg-0 0) ((12) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref e-1 0) ((5) (let ((e-2 (vector-ref e-1 1))) (box e-2)))(else (CompilerC-45ESC-45ToAst-integerArith arg-0)))))(else (CompilerC-45ESC-45ToAst-integerArith arg-0)))))
(define CompilerC-45ESC-45ToAst-constAlt (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-0 (car arg-2))) (let ((e-1 (cdr arg-2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-0 e-5)))))) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-1) ext-0)))))
(define CompilerC-45ESC-45ToAst-conAlt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((act-24 ((CompilerC-45ESC-45State-projections arg-0 arg-2 e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-6 (vector-ref eta-0 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector (CompilerC-45ESC-45ToAst-tag e-0 e-2) e-1 e-6)))))) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4) ext-0)))))))))))
(define CompilerC-45ESC-45ToAst-assign (lambda (arg-0 ext-0) (if (null? arg-0) (vector 0 ext-0) (let ((e-0 (unbox arg-0))) (vector 2 e-0 ext-0)))))
(define CompilerC-45ESC-45Doc-n--2941-927-u--nSpaces (lambda (arg-0) (PreludeC-45Types-fastPack (DataC-45List-replicate arg-0 #\ ))))
(define CompilerC-45ESC-45Doc-n--2941-928-u--go (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) '()) ((1) (cons "\xa;" (cons arg-0 '()))) ((2) (cons " " '())) ((3) (let ((e-0 (vector-ref arg-1 1))) (cons e-0 '()))) ((4) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (CompilerC-45ESC-45Doc-n--2941-928-u--go (PreludeC-45TypesC-45String-C-43C-43 arg-0 (CompilerC-45ESC-45Doc-n--2941-927-u--nSpaces e-1)) e-2)))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45ESC-45Doc-n--2941-928-u--go arg-0 e-3) (CompilerC-45ESC-45Doc-n--2941-928-u--go arg-0 e-4))))))))
(define CompilerC-45ESC-45Doc-n--2918-902-u--go (lambda (arg-0) (case (vector-ref arg-0 0) ((0) '()) ((1) '()) ((2) '()) ((3) (let ((e-0 (vector-ref arg-0 1))) (cons e-0 '()))) ((4) (let ((e-2 (vector-ref arg-0 2))) (CompilerC-45ESC-45Doc-n--2918-902-u--go e-2))) (else (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45ESC-45Doc-n--2918-902-u--go e-3) (CompilerC-45ESC-45Doc-n--2918-902-u--go e-4))))))))
(define CompilerC-45ESC-45Doc-u--neutral_Monoid_Doc(blodwen-lazy (lambda () (vector 0 ))))
(define CompilerC-45ESC-45Doc-u--fromString_FromString_Doc (lambda (ext-0) (vector 3 ext-0)))
(define CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) arg-1)(else (case (vector-ref arg-1 0) ((0) arg-0)(else (vector 5 arg-0 arg-1)))))))
(define CompilerC-45ESC-45Doc-vcat (lambda (ext-0) (PreludeC-45Interfaces-concat (csegen-3740) (DataC-45List-intersperse (vector 1 ) ext-0))))
(define CompilerC-45ESC-45Doc-softEq(blodwen-lazy (lambda () (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (vector 2 ) (vector 3 "=")) (vector 2 )))))
(define CompilerC-45ESC-45Doc-softComma(blodwen-lazy (lambda () (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc ",") (vector 2 )))))
(define CompilerC-45ESC-45Doc-softColon(blodwen-lazy (lambda () (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc ":") (vector 2 )))))
(define CompilerC-45ESC-45Doc-pretty (lambda (ext-0) (PreludeC-45Types-fastConcat (CompilerC-45ESC-45Doc-n--2941-928-u--go "" ext-0))))
(define CompilerC-45ESC-45Doc-paren (lambda (arg-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") arg-0) (vector 3 ")"))))
(define CompilerC-45ESC-45Doc-lambdaArrow(blodwen-lazy (lambda () (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (vector 2 ) (vector 3 "=>")) (vector 2 )))))
(define CompilerC-45ESC-45Doc-isMultiline (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 1) ((2) 0) ((3) 0) ((4) (let ((e-2 (vector-ref arg-0 2))) (CompilerC-45ESC-45Doc-isMultiline e-2))) (else (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((sc1 (CompilerC-45ESC-45Doc-isMultiline e-3))) (cond ((equal? sc1 1) 1) (else (CompilerC-45ESC-45Doc-isMultiline e-4))))))))))
(define CompilerC-45ESC-45Doc-hcat (lambda (ext-0) (PreludeC-45Interfaces-concat (csegen-3740) ext-0)))
(define CompilerC-45ESC-45Doc-compact (lambda (ext-0) (PreludeC-45Types-fastConcat (CompilerC-45ESC-45Doc-n--2918-902-u--go ext-0))))
(define CompilerC-45ESC-45Doc-block (lambda (arg-0) (PreludeC-45Interfaces-concat (csegen-3740) (cons (vector 3 "{") (cons (vector 4 (+ 1 0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (vector 1 ) arg-0)) (cons (vector 1 ) (cons (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "}") '())))))))
(define CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (lambda (arg-0 arg-1) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-0 (vector 3 " ")) arg-1)))
(define CompilerC-45ESC-45Node-findNode (lambda (ext-0) (let ((act-24 ((IdrisC-45Env-idrisGetEnv (csegen-3) "NODE" 0) ext-0))) (if (null? act-24) (let ((act-25 (LibrariesC-45UtilsC-45Path-pathLookup (cons "node" '()) ext-0))) (DataC-45Maybe-fromMaybe (lambda () "/usr/bin/env node") act-25)) (let ((e-2 (unbox act-24))) e-2)))))
(define CompilerC-45ESC-45Node-executeExpr (lambda (arg-0 arg-1 arg-2) (let ((u--outn (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "_tmp_node" ".js")))) (lambda (eta-0) (let ((act-24 (CompilerC-45ESC-45Node-compileToNode arg-0 arg-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-writeFile u--outn e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (CompilerC-45ESC-45Node-findNode eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 e-7 "\""))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-28 ((System-system (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 e-8 (PreludeC-45TypesC-45String-C-43C-43 " " u--outn))) eta-1))) (vector 1 act-28))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 0)))))))))))))))))))))))
(define CompilerC-45ESC-45Node-compileToNode (lambda (arg-0 arg-1 ext-0) (CompilerC-45ESC-45Codegen-compileToES arg-0 (vector 4 ) arg-1 (cons "node" (cons "javascript" '())) ext-0)))
(define CompilerC-45ESC-45Node-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CompilerC-45ESC-45Node-compileToNode arg-0 arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--out (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 arg-4))) (let ((act-25 (CoreC-45Core-writeFile u--out e-5 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (box u--out))))))))))))
(define CompilerC-45ESC-45Node-codegenNode(blodwen-lazy (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CompilerC-45ESC-45Node-compileExpr eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45ESC-45Node-executeExpr eta-0 eta-1 eta-2)))) '() '()))))
(define CompilerC-45SchemeC-45Gambit-case--useCC-1986 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) eta-0)) (let ((e-2 (unbox arg-6))) (if (null? e-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) eta-0)) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (cond ((equal? e-5 "scheme,gambit") (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) clam-0) (let ((e-8 (car e-6))) (let ((e-9 (cdr e-6))) (if (null? e-9) (let ((act-24 ((CompilerC-45SchemeC-45Gambit-schemeCall arg-3 e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-1) arg-0) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (cons '() (cons e-7 ""))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) clam-0))))))) ((equal? e-5 "scheme") (lambda (clam-1) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) clam-1) (let ((e-12 (car e-6))) (let ((e-13 (cdr e-6))) (if (null? e-13) (let ((act-24 ((CompilerC-45SchemeC-45Gambit-schemeCall arg-3 e-12 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-1) arg-0) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (cons '() (cons e-7 ""))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) clam-1))))))) ((equal? e-5 "C") (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) eta-0)) (let ((e-16 (car e-6))) (let ((e-17 (cdr e-6))) (if (null? e-17) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) eta-0)) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (lambda (clam-2) (if (null? e-20) (let ((act-24 (CompilerC-45SchemeC-45Gambit-cCall arg-5 arg-4 arg-3 e-16 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-n--9905-1957-u--fnWrapName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-16 eta-0)) e-19 arg-1 arg-0 clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (cons (box e-19) e-7)))))) (let ((e-24 (cdr e-20))) (if (null? e-24) (let ((act-24 (CompilerC-45SchemeC-45Gambit-cCall arg-5 arg-4 arg-3 e-16 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-n--9905-1957-u--fnWrapName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-16 eta-0)) e-19 arg-1 arg-0 clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (cons (box e-19) e-7)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) clam-2))))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-3 arg-2) eta-0)))))))))))
(define CompilerC-45SchemeC-45Gambit-n--10221-2256-u--showFld (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((CompilerC-45SchemeC-45Gambit-cftySpec (CoreC-45FC-emptyFC) e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))))))))
(define CompilerC-45SchemeC-45Gambit-n--9130-1227-u--replaceChar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (PreludeC-45Types-fastPack (DataC-45List-replaceOn (csegen-0) arg-8 arg-9 (PreludeC-45Types-fastUnpack ext-0)))))
(define CompilerC-45SchemeC-45Gambit-n--9130-1225-u--mkNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((18) (cons '() (CompilerC-45SchemeC-45Gambit-n--9130-1225-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)))(else (cons (box (PreludeC-45TypesC-45String-C-43C-43 "cb" (PreludeC-45Show-u--show_Show_Int arg-8))) (CompilerC-45SchemeC-45Gambit-n--9130-1225-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (bs+ arg-8 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Gambit-n--9130-1230-u--mkFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--argns (CompilerC-45SchemeC-45Gambit-n--9130-1225-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 0 arg-8))) (PreludeC-45TypesC-45String-C-43C-43 "(lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (DataC-45List-mapMaybe (lambda (eta-0) eta-0) u--argns)) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Gambit-n--9130-1226-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-10 u--argns) ")")))))))
(define CompilerC-45SchemeC-45Gambit-n--8900-1084-u--funTySpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((19) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (case (vector-ref e-0 0) ((18) (CompilerC-45SchemeC-45Gambit-n--8900-1084-u--funTySpec arg-0 arg-1 arg-2 arg-3 e-1))(else (CompilerC-45SchemeC-45Gambit-n--8900-1084-u--funTySpec arg-0 arg-1 arg-2 (cons e-0 arg-3) e-1))))))(else (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Gambit-cftySpec arg-2 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-cftySpec arg-2 eta-1)) (PreludeC-45TypesC-45List-reverse (DataC-45List-filter (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-notWorld eta-1)) arg-3)) '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(function (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-6) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")"))))))))))))))))))
(define CompilerC-45SchemeC-45Gambit-n--8801-946-u--funTySpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((19) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (case (vector-ref e-0 0) ((18) (CompilerC-45SchemeC-45Gambit-n--8801-946-u--funTySpec arg-0 arg-1 arg-2 arg-3 e-1))(else (CompilerC-45SchemeC-45Gambit-n--8801-946-u--funTySpec arg-0 arg-1 arg-2 (cons e-0 arg-3) e-1))))))(else (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Gambit-cType arg-2 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-cType arg-2 eta-1)) (PreludeC-45TypesC-45List-reverse (DataC-45List-filter (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-notWorld eta-1)) arg-3)) '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " (*)(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " e-6) ")")))))))))))))))))
(define CompilerC-45SchemeC-45Gambit-n--9905-1957-u--fnWrapName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (PreludeC-45TypesC-45String-C-43C-43 arg-7 (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 arg-6 "-cFunWrap")))))
(define CompilerC-45SchemeC-45Gambit-n--9130-1231-u--callback (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((19) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (CompilerC-45SchemeC-45Gambit-n--9130-1231-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-0 arg-9) e-1))))(else (let ((u--args (PreludeC-45TypesC-45List-reverse arg-9))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-cftySpec arg-5 eta-1)) (DataC-45List-filter (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-notWorld eta-1)) u--args) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Gambit-cftySpec arg-5 arg-10) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (CompilerC-45SchemeC-45Gambit-n--9130-1230-u--mkFun arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--args arg-10 arg-8) (cons e-5 e-6)))))))))))))))))
(define CompilerC-45SchemeC-45Gambit-n--9130-1228-u--buildCWrapperDefs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((u--box (PreludeC-45TypesC-45String-C-43C-43 e-1 "-box"))) (let ((u--setBox (PreludeC-45TypesC-45String-C-43C-43 "\xa; (set-box! " (PreludeC-45TypesC-45String-C-43C-43 u--box (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-2 ")")))))) (let ((u--cWrapName (CompilerC-45SchemeC-45Gambit-n--9130-1227-u--replaceChar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 #\- #\_ e-1))) (let ((u--boxDef (PreludeC-45TypesC-45String-C-43C-43 "\xa;(define " (PreludeC-45TypesC-45String-C-43C-43 u--box " (box #f))\xa;")))) (let ((u--args (let ((sc0 (PreludeC-45Types-u--C-62_Ord_Nat (PreludeC-45TypesC-45List-length e-3) 0))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 " " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (u--i) (PreludeC-45TypesC-45String-C-43C-43 "farg-" (PreludeC-45Show-u--show_Show_Integer u--i))) (PreludeC-45Types-u--rangeFromTo_Range_C-36a (cons (vector (csegen-597) (lambda (arg-157) (lambda (arg-158) (PreludeC-45Num-u--div_Integral_Integer arg-157 arg-158))) (lambda (arg-159) (lambda (arg-160) (PreludeC-45Num-u--mod_Integral_Integer arg-159 arg-160)))) (cons (csegen-989) (csegen-3783))) 0 (- (PreludeC-45TypesC-45List-length e-3) 1)))))) (else ""))))) (let ((u--cWrapDef (PreludeC-45TypesC-45String-C-43C-43 "\xa;(c-define " (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-1 (PreludeC-45TypesC-45String-C-43C-43 u--args (PreludeC-45TypesC-45String-C-43C-43 ")" (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-3) (PreludeC-45TypesC-45String-C-43C-43 ")" (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-4 (PreludeC-45TypesC-45String-C-43C-43 " \"" (PreludeC-45TypesC-45String-C-43C-43 u--cWrapName (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 " \"\"" (PreludeC-45TypesC-45String-C-43C-43 "\xa; ((unbox " (PreludeC-45TypesC-45String-C-43C-43 u--box (PreludeC-45TypesC-45String-C-43C-43 ")" (PreludeC-45TypesC-45String-C-43C-43 u--args (PreludeC-45TypesC-45String-C-43C-43 ")" "\xa;)\xa;"))))))))))))))))))))) (vector u--setBox u--boxDef u--cWrapDef)))))))))))))
(define CompilerC-45SchemeC-45Gambit-n--9130-1229-u--buildCFunWrapDeclaration (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (PreludeC-45TypesC-45String-C-43C-43 "\xa;(c-declare #<<c-declare-end\xa;" (PreludeC-45TypesC-45String-C-43C-43 arg-9 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 arg-8 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " arg-10) (PreludeC-45TypesC-45String-C-43C-43 ");" "\xa;c-declare-end\xa;)\xa;")))))))))
(define CompilerC-45SchemeC-45Gambit-n--9130-1232-u--buildArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-3 0) ((19) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (let ((u--arg (CompilerC-45SchemeC-45Common-schName e-2))) (let ((u--schemeWrap (arg-3 u--arg))) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Gambit-n--9130-1231-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--arg (cons e-4 '()) e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((e-10 (car e-7))) (let ((e-9 (cdr e-7))) (vector 1 (cons u--schemeWrap (box (vector u--arg u--schemeWrap e-8 e-10 e-9))))))))))))))))))(else (lambda (eta-0) (vector 1 (cons (CompilerC-45SchemeC-45Common-schName e-2) '())))))))))
(define CompilerC-45SchemeC-45Gambit-n--9130-1226-u--applyLams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) arg-8 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (if (null? e-2) (CompilerC-45SchemeC-45Gambit-n--9130-1226-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-8 " #f)")) e-3) (let ((e-6 (unbox e-2))) (CompilerC-45SchemeC-45Gambit-n--9130-1226-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-8 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))) e-3))))))))
(define CompilerC-45SchemeC-45Gambit-useCC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (CompilerC-45SchemeC-45Gambit-case--useCC-1986 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (CompilerC-45Common-parseCC (cons "scheme,gambit" (csegen-3786)) arg-3))))
(define CompilerC-45SchemeC-45Gambit-showGambitString (lambda (arg-0) (lambda (clam-0) (if (null? arg-0) clam-0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-2 #\") (PreludeC-45TypesC-45String-C-43C-43 "\\\"" ((CompilerC-45SchemeC-45Gambit-showGambitString e-3) clam-0)))(else ((CompilerC-45SchemeC-45Gambit-showGambitChar e-2) ((CompilerC-45SchemeC-45Gambit-showGambitString e-3) clam-0))))))))))
(define CompilerC-45SchemeC-45Gambit-showGambitChar (lambda (arg-0) (lambda (clam-0) (cond ((equal? arg-0 #\\) (PreludeC-45TypesC-45String-C-43C-43 "\\\\" clam-0))(else (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-0 (PreludeC-45Types-chr 32)))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 "\\x" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-0)) ";")) clam-0)) (else (PreludeC-45Types-strCons arg-0 clam-0)))))))))
(define CompilerC-45SchemeC-45Gambit-schemeCall (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--call (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45SchemeC-45Common-schName eta-0)) arg-2)) ")")))))) (lambda (clam-0) (case (vector-ref arg-3 0) ((20) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld u--call)))(else (vector 1 u--call)))))))
(define CompilerC-45SchemeC-45Gambit-schHeader(blodwen-lazy (lambda () (PreludeC-45TypesC-45String-C-43C-43 "; " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45Generated-generatedString "Gambit") (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(declare (block)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(inlining-limit 450)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(standard-bindings)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(extended-bindings)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(not safe)\xa;" "(optimize-dead-definitions))\xa;")))))))))))
(define CompilerC-45SchemeC-45Gambit-schFgnDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((2) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (let ((u--argns (CompilerC-45SchemeC-45Gambit-mkArgs 0 e-1))) (let ((u--allargns (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--argns))) (let ((u--useargns (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (DataC-45List-filter (lambda (eta-0) (Builtin-snd eta-0)) u--argns)))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-mkStruct arg-2 eta-1)) e-1 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Gambit-mkStruct arg-2 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45SchemeC-45Gambit-useCC arg-0 arg-1 arg-3 e-0 (DataC-45List-u--zip_Zippable_List u--useargns e-1) e-2) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-10 (vector-ref act-27 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-u--full_HasNames_Name (let ((e-41 (vector-ref e-10 0))) e-41) arg-4 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-11 (vector-ref act-28 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-28 1))) (vector 1 (cons e-4 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-5) (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 e-8 (PreludeC-45TypesC-45String-C-43C-43 "(define " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-11) (PreludeC-45TypesC-45String-C-43C-43 " (lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CompilerC-45SchemeC-45Common-schName eta-1)) u--allargns)) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-9 "))\xa;")))))))))))))))))))))))))))))))))))))))))))(else (csegen-3794)))))
(define CompilerC-45SchemeC-45Gambit-notWorld (lambda (arg-0) (case (vector-ref arg-0 0) ((18) 0)(else 1))))
(define CompilerC-45SchemeC-45Gambit-mkStruct (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((21) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-mkStruct arg-0 eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-1) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc3 (PreludeC-45Types-elem (csegen-17) e-0 e-6))) (cond ((equal? sc3 1) (vector 1 (PreludeC-45Interfaces-concat (csegen-67) e-5))) (else (let ((act-26 (let ((act-26 (set-box! arg-0 (cons e-0 e-6)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-n--10221-2256-u--showFld e-1 e-0 arg-0 eta-1 eta-2))) e-1 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-5) (PreludeC-45TypesC-45String-C-43C-43 "(define-c-struct " (PreludeC-45TypesC-45String-C-43C-43 e-0 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-8) ")\xa;")))))))))))))))))))))))))))) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Gambit-mkStruct arg-0 e-2))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (CompilerC-45SchemeC-45Gambit-mkStruct arg-0 e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CompilerC-45SchemeC-45Gambit-mkStruct arg-0 e-4) eta-0))))))))(else (lambda (eta-0) (vector 1 ""))))))
(define CompilerC-45SchemeC-45Gambit-mkArgs (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((18) (cons (cons (vector 2 "farg" arg-0) 0) (CompilerC-45SchemeC-45Gambit-mkArgs arg-0 e-3)))(else (cons (cons (vector 2 "farg" arg-0) 1) (CompilerC-45SchemeC-45Gambit-mkArgs (bs+ arg-0 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Gambit-handleRet (lambda (arg-0 arg-1) (cond ((equal? arg-0 "void") (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " " (CompilerC-45SchemeC-45Common-mkWorld (CompilerC-45SchemeC-45Common-schConstructor (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) (vector 1 (vector 0 "")) (box 0) '())))))(else (CompilerC-45SchemeC-45Common-mkWorld arg-1)))))
(define CompilerC-45SchemeC-45Gambit-getFgnCall (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (CompilerC-45SchemeC-45Gambit-schFgnDef arg-0 arg-1 arg-2 e-6 e-2 e-7)))))))
(define CompilerC-45SchemeC-45Gambit-gambitString (lambda (arg-0) (PreludeC-45Types-strCons #\" ((CompilerC-45SchemeC-45Gambit-showGambitString (PreludeC-45Types-fastUnpack arg-0)) "\""))))
(define CompilerC-45SchemeC-45Gambit-gambitPrim (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((6) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (case (vector-ref e-1 0) ((12) (let ((e-20 (vector-ref e-1 2))) (case (vector-ref e-20 0) ((10) (let ((e-21 (vector-ref e-20 1))) (if (null? e-2) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-24 (cdr e-2))) (if (null? e-24) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-27 (cdr e-24))) (if (null? e-27) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (case (vector-ref e-32 0) ((12) (let ((e-35 (vector-ref e-32 2))) (case (vector-ref e-35 0) ((10) (let ((e-36 (vector-ref e-35 1))) (if (null? e-33) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-39 (cdr e-33))) (if (null? e-39) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3798) (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-gambitString eta-1)) 0 e-29) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-21 (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 e-36 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))))))) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))) ((7) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-42 (car arg-2))) (let ((e-43 (cdr arg-2))) (case (vector-ref e-42 0) ((12) (let ((e-67 (vector-ref e-42 2))) (case (vector-ref e-67 0) ((10) (let ((e-68 (vector-ref e-67 1))) (if (null? e-43) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-71 (cdr e-43))) (if (null? e-71) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-74 (cdr e-71))) (if (null? e-74) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-76 (car e-74))) (let ((e-77 (cdr e-74))) (if (null? e-77) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-79 (car e-77))) (let ((e-80 (cdr e-77))) (case (vector-ref e-79 0) ((12) (let ((e-82 (vector-ref e-79 2))) (case (vector-ref e-82 0) ((10) (let ((e-83 (vector-ref e-82 1))) (if (null? e-80) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-86 (cdr e-80))) (if (null? e-86) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-88 (car e-86))) (let ((e-89 (cdr e-86))) (if (null? e-89) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-92 (cdr e-89))) (if (null? e-92) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3798) (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-gambitString eta-1)) 0 e-76) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp (csegen-3798) (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-gambitString eta-1)) 0 e-88) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-68 (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 e-83 (PreludeC-45TypesC-45String-C-43C-43 "-set! " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))))))) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))))))) ((10) (if (null? arg-2) (lambda (eta-0) (vector 1 "\"gambit\"")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))(else (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) arg-0 arg-1 arg-2)))))
(define CompilerC-45SchemeC-45Gambit-findGSCBackend (lambda (ext-0) (let ((act-24 ((IdrisC-45Env-idrisGetEnv (csegen-3) "GAMBIT_GSC_BACKEND" 0) ext-0))) (if (null? act-24) "" (let ((e-2 (unbox act-24))) (PreludeC-45TypesC-45String-C-43C-43 " -cc " e-2))))))
(define CompilerC-45SchemeC-45Gambit-findGSC (lambda (ext-0) (let ((act-24 ((IdrisC-45Env-idrisGetEnv (csegen-3) "GAMBIT_GSC" 0) ext-0))) (DataC-45Maybe-fromMaybe (lambda () "/usr/bin/env gsc") act-24))))
(define CompilerC-45SchemeC-45Gambit-executeExpr (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((CompilerC-45SchemeC-45Gambit-compileExpr arg-0 arg-1 arg-1 arg-2 "_tmpgambit") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "compileExpr returned Nothing") ext-0) (let ((e-1 (unbox e-5))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((System-system (csegen-3) e-1) eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 0))))))))))))
(define CompilerC-45SchemeC-45Gambit-compileToSCM (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CompilerC-45Common-getCompileData arg-0 0 0 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ndefs (let ((e-1 (vector-ref e-5 1))) e-1))) (let ((u--ctm (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-5 0))) e-0)))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-newRef (vector "Compiler.Scheme.Gambit.Loaded" ) '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-newRef (vector "Compiler.Scheme.Gambit.Structs" ) '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-getFgnCall arg-0 e-7 e-8 eta-0)) u--ndefs '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScheme arg-0 (csegen-3798) (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-gambitString eta-1)) eta-0)) u--ndefs '() ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--code (DataC-45String-fastAppend (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-9) e-10)))) (let ((act-30 ((CompilerC-45SchemeC-45Common-schExp (csegen-3798) (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-gambitString eta-0)) 0 u--ctm) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Directory-readDataFile arg-0 "gambit/support.scm" ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Context-getDirectives arg-0 (vector 3 ) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CompilerC-45Common-getExtraRuntime e-13 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Directory-readDataFile arg-0 "gambit/foreign.scm" ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (let ((u--scm (CoreC-45NameC-45Namespace-showSep "\xa;" (cons (CompilerC-45SchemeC-45Gambit-schHeader) (cons e-12 (cons e-14 (cons e-15 (cons u--code (cons e-11 '()))))))))) (let ((act-35 (let ((act-35 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-2 u--scm) ext-0))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (case (vector-ref e-16 0) ((1) (let ((e-2 (vector-ref e-16 1))) (cond (else (vector 1 (DataC-45List-mapMaybe (lambda (eta-0) (Builtin-fst eta-0)) e-9)))))) (else (let ((e-17 (vector-ref e-16 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 e-17) ext-0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Gambit-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--srcPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-4 "scm")))) (let ((u--execPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 arg-4))) (lambda (eta-0) (let ((act-24 (CompilerC-45SchemeC-45Gambit-compileToSCM arg-0 arg-3 u--srcPath eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Directory-findLibraryFile arg-0 eta-1 eta-2))) (PreludeC-45Types-u--map_Functor_List (lambda (arg-5) (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 "a")) (DataC-45List-nub (csegen-17) e-5)) '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (CompilerC-45SchemeC-45Gambit-findGSC eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (CompilerC-45SchemeC-45Gambit-findGSCBackend eta-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-getDirectives arg-0 (vector 3 ) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--gscCompileOpts (let ((sc5 (DataC-45List-find (lambda (arg-5) (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-5 "C")) e-9))) (if (null? sc5) (PreludeC-45TypesC-45String-C-43C-43 e-8 (PreludeC-45TypesC-45String-C-43C-43 " -exe -cc-options \"-Wno-implicit-function-declaration\" -ld-options \"" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-6) "\""))) " -c")))) (let ((u--cmd (PreludeC-45TypesC-45String-C-43C-43 e-7 (PreludeC-45TypesC-45String-C-43C-43 u--gscCompileOpts (PreludeC-45TypesC-45String-C-43C-43 " -o \"" (PreludeC-45TypesC-45String-C-43C-43 u--execPath (PreludeC-45TypesC-45String-C-43C-43 "\" \"" (PreludeC-45TypesC-45String-C-43C-43 u--srcPath "\"")))))))) (let ((act-29 (let ((act-29 ((System-system (csegen-3) u--cmd) eta-0))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((sc6 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-10 0))) (cond ((equal? sc6 1) (vector 1 (box u--execPath))) (else (vector 1 '())))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Gambit-codegenGambit(blodwen-lazy (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Gambit-compileExpr eta-0 eta-1 eta-2 eta-3 eta-4)))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Gambit-executeExpr eta-0 eta-1 eta-2 eta-3))))) '() '()))))
(define CompilerC-45SchemeC-45Gambit-cftySpec (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 "void"))) ((1) (lambda (eta-0) (vector 1 "int"))) ((3) (lambda (eta-0) (vector 1 "char"))) ((4) (lambda (eta-0) (vector 1 "short"))) ((5) (lambda (eta-0) (vector 1 "int"))) ((6) (lambda (eta-0) (vector 1 "long"))) ((7) (lambda (eta-0) (vector 1 "unsigned-char"))) ((8) (lambda (eta-0) (vector 1 "unsigned-short"))) ((9) (lambda (eta-0) (vector 1 "unsigned-int"))) ((10) (lambda (eta-0) (vector 1 "unsigned-long"))) ((11) (lambda (eta-0) (vector 1 "UTF-8-string"))) ((12) (lambda (eta-0) (vector 1 "double"))) ((13) (lambda (eta-0) (vector 1 "char"))) ((14) (lambda (eta-0) (vector 1 "(pointer void)"))) ((20) (let ((e-0 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Gambit-cftySpec arg-0 e-0))) ((21) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 e-1 "*/nonnull"))))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (CompilerC-45SchemeC-45Gambit-n--8900-1084-u--funTySpec e-4 e-3 arg-0 (cons e-3 '()) e-4))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Can't pass argument of type " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_CFType arg-1) " to foreign function"))) eta-0))))))
(define CompilerC-45SchemeC-45Gambit-cType (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 "void"))) ((1) (lambda (eta-0) (vector 1 "int"))) ((11) (lambda (eta-0) (vector 1 "char *"))) ((12) (lambda (eta-0) (vector 1 "double"))) ((13) (lambda (eta-0) (vector 1 "char"))) ((14) (lambda (eta-0) (vector 1 "void *"))) ((20) (let ((e-0 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Gambit-cType arg-0 e-0))) ((21) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "struct " e-1))))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (CompilerC-45SchemeC-45Gambit-n--8801-946-u--funTySpec e-4 e-3 arg-0 (cons e-3 '()) e-4))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Can't pass argument of type " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_CFType arg-1) " to foreign function"))) eta-0))))))
(define CompilerC-45SchemeC-45Gambit-cCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-cftySpec arg-2 (Builtin-snd eta-0))) arg-6 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Gambit-cftySpec arg-2 arg-7) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-n--9130-1232-u--buildArg arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) arg-6 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-cType arg-2 (Builtin-snd eta-0))) arg-6 '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45SchemeC-45Gambit-cType arg-2 arg-7) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--cWrapperDefs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-n--9130-1228-u--buildCWrapperDefs arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) (DataC-45List-mapMaybe (lambda (eta-0) (Builtin-snd eta-0)) e-7)))) (let ((u--cFunWrapDeclaration (CompilerC-45SchemeC-45Gambit-n--9130-1229-u--buildCFunWrapDeclaration arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-3 e-9 e-8))) (let ((u--wrapDeclarations (PreludeC-45TypesC-45String-C-43C-43 u--cFunWrapDeclaration (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (let ((e-1 (vector-ref eta-0 1))) e-1)) u--cWrapperDefs) (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (let ((e-2 (vector-ref eta-0 2))) e-2)) u--cWrapperDefs))))) (let ((u--setBoxes (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (let ((e-0 (vector-ref eta-0 0))) e-0)) u--cWrapperDefs))) (let ((u--call (PreludeC-45TypesC-45String-C-43C-43 " ((c-lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-5) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String arg-3) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-7)) ")")))))))))) (let ((u--body (PreludeC-45TypesC-45String-C-43C-43 u--setBoxes (PreludeC-45TypesC-45String-C-43C-43 "\xa;" u--call)))) (vector 1 (case (vector-ref arg-7 0) ((20) (cons (CompilerC-45SchemeC-45Gambit-handleRet e-6 u--body) u--wrapDeclarations))(else (cons u--body u--wrapDeclarations))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Common-n--7635-975-u--strTo (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) (CompilerC-45SchemeC-45Common-op "cast-string-int" (cons arg-1 '())) (let ((e-2 (unbox e-0))) (CompilerC-45SchemeC-45Common-op "cast-string-boundedInt" (cons arg-1 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-2 1 63)) '()))))))) (else (let ((e-1 (vector-ref arg-0 1))) (CompilerC-45SchemeC-45Common-op "cast-string-boundedUInt" (cons arg-1 (cons (PreludeC-45Show-u--show_Show_Int e-1) '()))))))))
(define CompilerC-45SchemeC-45Common-n--9772-5312-u--showConstAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (vector 1 "")) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (lambda (clam-0) (if (null? e-2) (let ((act-24 (CompilerC-45SchemeC-45Common-schConstAlt arg-0 arg-1 (bs+ arg-5 1 63) arg-6 e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9772-5312-u--showConstAlts arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " e-6))))))))))) (let ((e-5 (cdr e-2))) (if (null? e-3) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-5 1 63) e-5) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(else " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))) (let ((act-24 (CompilerC-45SchemeC-45Common-schConstAlt arg-0 arg-1 (bs+ arg-5 1 63) arg-6 e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9772-5312-u--showConstAlts arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 " " e-7))))))))))))))))))))
(define CompilerC-45SchemeC-45Common-n--9768-3610-u--showAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (vector 1 "") (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-3) (let ((act-24 (CompilerC-45SchemeC-45Common-schConUncheckedAlt arg-0 arg-1 (bs+ arg-4 1 63) arg-5 e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(else " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")"))))))) (let ((act-24 (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 (bs+ arg-4 1 63) arg-5 e-2 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9768-3610-u--showAlts arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " e-6))))))))))))))))))
(define CompilerC-45SchemeC-45Common-n--9772-5206-u--recordCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) 0 (let ((e-1 (car arg-7))) (let ((e-4 (vector-ref e-1 1))) (cond ((equal? e-4 7) 1)(else 0)))))))
(define CompilerC-45SchemeC-45Common-n--7106-458-u--okchar (lambda (arg-0 arg-1) (let ((sc0 (let ((sc1 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\_)))))) (cond ((equal? sc0 1) (PreludeC-45Cast-u--cast_Cast_Char_String arg-1)) (else (PreludeC-45TypesC-45String-C-43C-43 "C-" (PreludeC-45Show-u--show_Show_Int (PreludeC-45Cast-u--cast_Cast_Char_Int arg-1))))))))
(define CompilerC-45SchemeC-45Common-n--9772-5205-u--maybeCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) 0 (let ((e-1 (car arg-7))) (let ((e-4 (vector-ref e-1 1))) (cond ((equal? e-4 5) 1) ((equal? e-4 6) 1)(else 0)))))))
(define CompilerC-45SchemeC-45Common-n--9772-5204-u--listCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) 0 (let ((e-1 (car arg-7))) (let ((e-4 (vector-ref e-1 1))) (cond ((equal? e-4 2) 1) ((equal? e-4 3) 1)(else 0)))))))
(define CompilerC-45SchemeC-45Common-n--7635-977-u--intTo (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-8 (vector-ref arg-1 1))) (if (null? e-8) arg-2 (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (unbox e-2))) (let ((sc5 (CoreC-45TT-u--C-62C-61_Ord_Precision (box e-4) e-0))) (cond ((equal? sc5 1) arg-2) (else (CompilerC-45SchemeC-45Common-op "blodwen-toSignedInt" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-4 1 63)) '()))))))))) (else (let ((e-3 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Common-op "blodwen-toUnsignedInt" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-3) '())))))))) (else (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-7 (unbox e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62_Ord_Int e-7 e-1))) (cond ((equal? sc5 1) arg-2) (else (CompilerC-45SchemeC-45Common-op "blodwen-toSignedInt" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-7 1 63)) '()))))))))) (else (let ((e-6 (vector-ref arg-1 1))) (let ((sc4 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-6 e-1))) (cond ((equal? sc4 1) arg-2) (else (CompilerC-45SchemeC-45Common-op "blodwen-toUnsignedInt" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-6) '())))))))))))))))(else (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (unbox e-2))) (let ((sc3 (CoreC-45TT-u--C-62C-61_Ord_Precision (box e-4) e-0))) (cond ((equal? sc3 1) arg-2) (else (CompilerC-45SchemeC-45Common-op "blodwen-toSignedInt" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-4 1 63)) '()))))))))) (else (let ((e-3 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Common-op "blodwen-toUnsignedInt" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-3) '())))))))) (else (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-7 (unbox e-5))) (let ((sc3 (PreludeC-45EqOrd-u--C-62_Ord_Int e-7 e-1))) (cond ((equal? sc3 1) arg-2) (else (CompilerC-45SchemeC-45Common-op "blodwen-toSignedInt" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-7 1 63)) '()))))))))) (else (let ((e-6 (vector-ref arg-1 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-6 e-1))) (cond ((equal? sc2 1) arg-2) (else (CompilerC-45SchemeC-45Common-op "blodwen-toUnsignedInt" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-6) '()))))))))))))))))
(define CompilerC-45SchemeC-45Common-n--9771-4555-u--getNothingCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-5 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 4))) (cond ((equal? e-5 5) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-5 1 63) e-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (vector 1 (box e-9))))))))(else (CompilerC-45SchemeC-45Common-n--9771-4555-u--getNothingCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))))))))))
(define CompilerC-45SchemeC-45Common-n--9770-4123-u--getNilCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-5 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 4))) (cond ((equal? e-5 2) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-5 1 63) e-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (vector 1 (box e-9))))))))(else (CompilerC-45SchemeC-45Common-n--9770-4123-u--getNilCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))))))))))
(define CompilerC-45SchemeC-45Common-n--9771-4556-u--getJustCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (cond ((equal? e-5 6) (if (null? e-7) (CompilerC-45SchemeC-45Common-n--9771-4556-u--getJustCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-5 1 63) e-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (vector 1 (box (CompilerC-45SchemeC-45Common-n--11308-4712-u--bindArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 e-4 e-6 e-10 e-8 arg-6 e-10 e-9)))))))) (CompilerC-45SchemeC-45Common-n--9771-4556-u--getJustCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))(else (CompilerC-45SchemeC-45Common-n--9771-4556-u--getJustCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))))))))))))
(define CompilerC-45SchemeC-45Common-n--9770-4124-u--getConsCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (cond ((equal? e-5 3) (if (null? e-7) (CompilerC-45SchemeC-45Common-n--9770-4124-u--getConsCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (CompilerC-45SchemeC-45Common-n--9770-4124-u--getConsCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-5 1 63) e-8) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (vector 1 (box (CompilerC-45SchemeC-45Common-n--10850-4283-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 e-4 e-6 e-10 e-13 e-8 arg-6 (cons (cons e-10 "car") (cons (cons e-13 "cdr") '())) e-9)))))))) (CompilerC-45SchemeC-45Common-n--9770-4124-u--getConsCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))))))))(else (CompilerC-45SchemeC-45Common-n--9770-4124-u--getConsCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))))))))))))
(define CompilerC-45SchemeC-45Common-n--9769-3918-u--getAltCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-6 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45SchemeC-45Common-n--9769-3917-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 arg-7 e-3 e-5 e-4))))))))))
(define CompilerC-45SchemeC-45Common-n--7635-976-u--dblTo (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) (CompilerC-45SchemeC-45Common-op "exact-truncate" (cons arg-1 '())) (let ((e-2 (unbox e-0))) (CompilerC-45SchemeC-45Common-op "exact-truncate-boundedInt" (cons arg-1 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-2 1 63)) '()))))))) (else (let ((e-1 (vector-ref arg-0 1))) (CompilerC-45SchemeC-45Common-op "exact-truncate-boundedUInt" (cons arg-1 (cons (PreludeC-45Show-u--show_Show_Int e-1) '()))))))))
(define CompilerC-45SchemeC-45Common-n--7635-974-u--charTo (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) (CompilerC-45SchemeC-45Common-op "char->integer" (cons arg-1 '())) (let ((e-2 (unbox e-0))) (CompilerC-45SchemeC-45Common-op "cast-char-boundedInt" (cons arg-1 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-2 1 63)) '()))))))) (else (let ((e-1 (vector-ref arg-0 1))) (CompilerC-45SchemeC-45Common-op "cast-char-boundedUInt" (cons arg-1 (cons (PreludeC-45Show-u--show_Show_Int e-1) '()))))))))
(define CompilerC-45SchemeC-45Common-n--9771-4554-u--buildCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-7) (if (null? arg-8) (if (null? arg-9) "#f" (let ((e-16 (unbox arg-9))) e-16)) (let ((e-10 (unbox arg-8))) (if (null? arg-9) e-10 (let ((e-14 (unbox arg-9))) (PreludeC-45TypesC-45String-C-43C-43 "(if (null? " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-14 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-10 ")")))))))))) (let ((e-1 (unbox arg-7))) (if (null? arg-8) (if (null? arg-9) e-1 (let ((e-8 (unbox arg-9))) (PreludeC-45TypesC-45String-C-43C-43 "(if (null? " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-1 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-8 ")")))))))) (let ((e-4 (unbox arg-8))) (PreludeC-45TypesC-45String-C-43C-43 "(if (null? " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-1 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-4 ")"))))))))))))
(define CompilerC-45SchemeC-45Common-n--9770-4122-u--buildCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-7) (if (null? arg-8) (if (null? arg-9) "#f" (let ((e-16 (unbox arg-9))) e-16)) (let ((e-10 (unbox arg-8))) (if (null? arg-9) e-10 (let ((e-14 (unbox arg-9))) (PreludeC-45TypesC-45String-C-43C-43 "(if (null? " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-14 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-10 ")")))))))))) (let ((e-1 (unbox arg-7))) (if (null? arg-8) (if (null? arg-9) e-1 (let ((e-8 (unbox arg-9))) (PreludeC-45TypesC-45String-C-43C-43 "(if (null? " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-1 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-8 ")")))))))) (let ((e-4 (unbox arg-8))) (PreludeC-45TypesC-45String-C-43C-43 "(if (null? " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-1 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-4 ")"))))))))))))
(define CompilerC-45SchemeC-45Common-n--10850-4283-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-13) arg-14 (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CompilerC-45SchemeC-45Common-used e-6 arg-11))) (cond ((equal? sc2 1) (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-6) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-7 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 arg-12 (PreludeC-45TypesC-45String-C-43C-43 "))) " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-n--10850-4283-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 arg-14) ")")))))))))) (else (CompilerC-45SchemeC-45Common-n--10850-4283-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 arg-14)))))))))))
(define CompilerC-45SchemeC-45Common-n--9769-3917-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-9) arg-10 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((sc1 (CompilerC-45SchemeC-45Common-used e-2 arg-11))) (cond ((equal? sc1 1) (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 "(vector-ref " (PreludeC-45TypesC-45String-C-43C-43 arg-8 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-7) (PreludeC-45TypesC-45String-C-43C-43 "))) " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-n--9769-3917-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (bs+ arg-7 1 63) arg-8 e-3 arg-10 arg-11) ")")))))))))) (else (CompilerC-45SchemeC-45Common-n--9769-3917-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (bs+ arg-7 1 63) arg-8 e-3 arg-10 arg-11)))))))))
(define CompilerC-45SchemeC-45Common-n--9765-3263-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((sc1 (CompilerC-45SchemeC-45Common-used e-2 arg-2))) (cond ((equal? sc1 1) (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 "(vector-ref " (PreludeC-45TypesC-45String-C-43C-43 arg-7 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-9) (PreludeC-45TypesC-45String-C-43C-43 "))) " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-n--9765-3263-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (bs+ arg-9 1 63) e-3 arg-11) ")")))))))))) (else (CompilerC-45SchemeC-45Common-n--9765-3263-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (bs+ arg-9 1 63) e-3 arg-11)))))))))
(define CompilerC-45SchemeC-45Common-n--9764-3140-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((sc1 (CompilerC-45SchemeC-45Common-used e-2 arg-2))) (cond ((equal? sc1 1) (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 "(vector-ref " (PreludeC-45TypesC-45String-C-43C-43 arg-7 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-9) (PreludeC-45TypesC-45String-C-43C-43 "))) " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-n--9764-3140-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (bs+ arg-9 1 63) e-3 arg-11) ")")))))))))) (else (CompilerC-45SchemeC-45Common-n--9764-3140-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (bs+ arg-9 1 63) e-3 arg-11)))))))))
(define CompilerC-45SchemeC-45Common-n--11308-4712-u--bindArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((sc0 (CompilerC-45SchemeC-45Common-used arg-12 arg-10))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName arg-12) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 "(unbox " (PreludeC-45TypesC-45String-C-43C-43 arg-11 (PreludeC-45TypesC-45String-C-43C-43 "))) " (PreludeC-45TypesC-45String-C-43C-43 arg-13 ")")))))))) (else arg-13)))))
(define CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "NewIORef") ((1) "ReadIORef") ((2) "WriteIORef") ((3) "NewArray") ((4) "ArrayGet") ((5) "ArraySet") ((6) "GetField") ((7) "SetField") ((8) "VoidElim") ((9) "SysOS") ((10) "SysCodegen") ((11) "OnCollect") ((12) "OnCollectAny") ((13) "MakeFuture") (else (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Unknown " (CoreC-45Name-u--show_Show_Name e-0)))))))
(define CompilerC-45SchemeC-45Common-var (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 1)(else 0))))
(define CompilerC-45SchemeC-45Common-usedConst (lambda (arg-0 arg-1) (let ((e-1 (cdr arg-1))) (CompilerC-45SchemeC-45Common-used arg-0 e-1))))
(define CompilerC-45SchemeC-45Common-usedCon (lambda (arg-0 arg-1) (let ((e-4 (vector-ref arg-1 4))) (CompilerC-45SchemeC-45Common-used arg-0 e-4))))
(define CompilerC-45SchemeC-45Common-used (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-1))) ((1) 0) ((2) (let ((e-6 (vector-ref arg-1 3))) (CompilerC-45SchemeC-45Common-used arg-0 e-6))) ((3) (let ((e-9 (vector-ref arg-1 3))) (let ((e-10 (vector-ref arg-1 4))) (let ((sc1 (CompilerC-45SchemeC-45Common-used arg-0 e-9))) (cond ((equal? sc1 1) 1) (else (CompilerC-45SchemeC-45Common-used arg-0 e-10))))))) ((4) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((sc1 (CompilerC-45SchemeC-45Common-used arg-0 e-12))) (cond ((equal? sc1 1) 1) (else (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0)) e-13))))))) ((5) (let ((e-18 (vector-ref arg-1 5))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0)) e-18))) ((6) (let ((e-22 (vector-ref arg-1 4))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0)) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 e-22)))) ((7) (let ((e-25 (vector-ref arg-1 3))) (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0)) e-25))) ((8) (let ((e-28 (vector-ref arg-1 3))) (CompilerC-45SchemeC-45Common-used arg-0 e-28))) ((9) (let ((e-31 (vector-ref arg-1 3))) (CompilerC-45SchemeC-45Common-used arg-0 e-31))) ((10) (let ((e-33 (vector-ref arg-1 2))) (let ((e-34 (vector-ref arg-1 3))) (let ((e-35 (vector-ref arg-1 4))) (let ((sc1 (CompilerC-45SchemeC-45Common-used arg-0 e-33))) (cond ((equal? sc1 1) 1) (else (let ((sc2 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CompilerC-45SchemeC-45Common-usedCon arg-0 eta-0)) e-34))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0))) e-35))))))))))) ((11) (let ((e-37 (vector-ref arg-1 2))) (let ((e-38 (vector-ref arg-1 3))) (let ((e-39 (vector-ref arg-1 4))) (let ((sc1 (CompilerC-45SchemeC-45Common-used arg-0 e-37))) (cond ((equal? sc1 1) 1) (else (let ((sc2 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (CompilerC-45SchemeC-45Common-usedConst arg-0 eta-0)) e-38))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0))) e-39)))))))))))(else 0))))
(define CompilerC-45SchemeC-45Common-toPrim (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Core-cond (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__newIORef")))) (lambda () (vector 0 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__readIORef")))) (lambda () (vector 1 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__writeIORef")))) (lambda () (vector 2 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__newArray")))) (lambda () (vector 3 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__arrayGet")))) (lambda () (vector 4 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__arraySet")))) (lambda () (vector 5 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__getField")))) (lambda () (vector 6 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__setField")))) (lambda () (vector 7 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "void")))) (lambda () (vector 8 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__void")))) (lambda () (vector 8 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__os")))) (lambda () (vector 9 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__codegen")))) (lambda () (vector 10 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__onCollect")))) (lambda () (vector 11 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__onCollectAny")))) (lambda () (vector 12 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__makeFuture")))) (lambda () (vector 13 ))) '()))))))))))))))) (vector 14 arg-0))))(else (vector 14 arg-0)))))
(define CompilerC-45SchemeC-45Common-sub (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (CompilerC-45SchemeC-45Common-op "-" (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "-" (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "bs-" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (CompilerC-45SchemeC-45Common-op "bu-" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-3) '()))))))(else (CompilerC-45SchemeC-45Common-op "-" (cons arg-1 (cons arg-2 '())))))))))
(define CompilerC-45SchemeC-45Common-showTag (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (arg-1 (CoreC-45Name-u--show_Show_Name arg-2)) (let ((e-1 (unbox arg-3))) (PreludeC-45Show-u--show_Show_Int e-1)))))
(define CompilerC-45SchemeC-45Common-shl (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (CompilerC-45SchemeC-45Common-op "blodwen-shl" (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "blodwen-shl" (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "blodwen-bits-shl-signed" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (CompilerC-45SchemeC-45Common-op "blodwen-bits-shl" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-3) '()))))))(else (CompilerC-45SchemeC-45Common-op "blodwen-shl" (cons arg-1 (cons arg-2 '())))))))))
(define CompilerC-45SchemeC-45Common-schUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "u--" (CompilerC-45SchemeC-45Common-schString e-0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "rf--" (CompilerC-45SchemeC-45Common-schString e-1)))) (else "u--_"))))
(define CompilerC-45SchemeC-45Common-schString (lambda (arg-0) (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (CompilerC-45SchemeC-45Common-n--7106-458-u--okchar arg-0 eta-0)) (PreludeC-45Types-fastUnpack arg-0))))
(define CompilerC-45SchemeC-45Common-schRecordCon (lambda (arg-0 arg-1 arg-2) (PreludeC-45TypesC-45String-C-43C-43 "(vector " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " arg-2) ")"))))
(define CompilerC-45SchemeC-45Common-schRecordCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-4) (vector 1 "#f") (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc2 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc2 1) (CompilerC-45SchemeC-45Common-n--9769-3918-u--getAltCode arg-0 arg-1 arg-5 e-3 e-2 arg-3 arg-2 e-5 e-2 ext-0)) (else (let ((act-25 (CompilerC-45SchemeC-45Common-n--9769-3918-u--getAltCode arg-0 arg-1 arg-5 e-3 e-2 arg-3 arg-2 u--n e-2 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Common-schOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-20 (car arg-2))) (let ((e-21 (cdr arg-2))) (lambda (clam-0) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (vector 1 (CompilerC-45SchemeC-45Common-add (CoreC-45TT-intKind e-0) e-20 e-24))))))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-29 (car arg-2))) (let ((e-30 (cdr arg-2))) (lambda (clam-1) (let ((e-33 (car e-30))) (let ((e-34 (cdr e-30))) (vector 1 (CompilerC-45SchemeC-45Common-sub (CoreC-45TT-intKind e-1) e-29 e-33))))))))) ((2) (let ((e-2 (vector-ref arg-1 1))) (let ((e-38 (car arg-2))) (let ((e-39 (cdr arg-2))) (lambda (clam-2) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (vector 1 (CompilerC-45SchemeC-45Common-mul (CoreC-45TT-intKind e-2) e-38 e-42))))))))) ((3) (let ((e-3 (vector-ref arg-1 1))) (let ((e-47 (car arg-2))) (let ((e-48 (cdr arg-2))) (lambda (clam-3) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (vector 1 (CompilerC-45SchemeC-45Common-div (CoreC-45TT-intKind e-3) e-47 e-51))))))))) ((4) (let ((e-56 (car arg-2))) (let ((e-57 (cdr arg-2))) (lambda (clam-4) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (vector 1 (CompilerC-45SchemeC-45Common-op "remainder" (cons e-56 (cons e-60 '())))))))))) ((5) (lambda (clam-5) (let ((e-65 (car arg-2))) (let ((e-66 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "-" (cons e-65 '()))))))) ((6) (let ((e-6 (vector-ref arg-1 1))) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-6) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (CompilerC-45SchemeC-45Common-shl (CoreC-45TT-intKind e-6) e-70 e-74))))))))) ((7) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-7) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (CompilerC-45SchemeC-45Common-op "blodwen-shr" (cons e-79 (cons e-83 '())))))))))) ((8) (let ((e-88 (car arg-2))) (let ((e-89 (cdr arg-2))) (lambda (clam-8) (let ((e-92 (car e-89))) (let ((e-93 (cdr e-89))) (vector 1 (CompilerC-45SchemeC-45Common-op "blodwen-and" (cons e-88 (cons e-92 '())))))))))) ((9) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-9) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (CompilerC-45SchemeC-45Common-op "blodwen-or" (cons e-97 (cons e-101 '())))))))))) ((10) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-10) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (CompilerC-45SchemeC-45Common-op "blodwen-xor" (cons e-106 (cons e-110 '())))))))))) ((11) (let ((e-11 (vector-ref arg-1 1))) (case (vector-ref e-11 0) ((25) (if (null? arg-2) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-13) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '()))))))))) (let ((e-124 (car arg-2))) (let ((e-125 (cdr arg-2))) (if (null? e-125) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-12) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '()))))))))) (let ((e-128 (car e-125))) (let ((e-129 (cdr e-125))) (if (null? e-129) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "char<?" (cons e-124 (cons e-128 '()))))) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-11) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '()))))))))))))))))) ((24) (if (null? arg-2) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-16) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '()))))))))) (let ((e-133 (car arg-2))) (let ((e-134 (cdr arg-2))) (if (null? e-134) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-15) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '()))))))))) (let ((e-137 (car e-134))) (let ((e-138 (cdr e-134))) (if (null? e-138) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "string<?" (cons e-133 (cons e-137 '()))))) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-14) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '())))))))))))))))))(else (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-17) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '()))))))))))))) ((12) (let ((e-12 (vector-ref arg-1 1))) (case (vector-ref e-12 0) ((25) (if (null? arg-2) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-20) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '()))))))))) (let ((e-151 (car arg-2))) (let ((e-152 (cdr arg-2))) (if (null? e-152) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-19) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '()))))))))) (let ((e-155 (car e-152))) (let ((e-156 (cdr e-152))) (if (null? e-156) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "char<=?" (cons e-151 (cons e-155 '()))))) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-18) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '()))))))))))))))))) ((24) (if (null? arg-2) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-23) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '()))))))))) (let ((e-160 (car arg-2))) (let ((e-161 (cdr arg-2))) (if (null? e-161) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-22) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '()))))))))) (let ((e-164 (car e-161))) (let ((e-165 (cdr e-161))) (if (null? e-165) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "string<=?" (cons e-160 (cons e-164 '()))))) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-21) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '())))))))))))))))))(else (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-24) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '()))))))))))))) ((13) (let ((e-13 (vector-ref arg-1 1))) (case (vector-ref e-13 0) ((25) (if (null? arg-2) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-27) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '()))))))))) (let ((e-178 (car arg-2))) (let ((e-179 (cdr arg-2))) (if (null? e-179) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-26) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '()))))))))) (let ((e-182 (car e-179))) (let ((e-183 (cdr e-179))) (if (null? e-183) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "char=?" (cons e-178 (cons e-182 '()))))) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-25) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '()))))))))))))))))) ((24) (if (null? arg-2) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-30) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '()))))))))) (let ((e-187 (car arg-2))) (let ((e-188 (cdr arg-2))) (if (null? e-188) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-29) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '()))))))))) (let ((e-191 (car e-188))) (let ((e-192 (cdr e-188))) (if (null? e-192) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "string=?" (cons e-187 (cons e-191 '()))))) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-28) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '())))))))))))))))))(else (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-31) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '()))))))))))))) ((14) (let ((e-14 (vector-ref arg-1 1))) (case (vector-ref e-14 0) ((25) (if (null? arg-2) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-34) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '()))))))))) (let ((e-205 (car arg-2))) (let ((e-206 (cdr arg-2))) (if (null? e-206) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-33) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '()))))))))) (let ((e-209 (car e-206))) (let ((e-210 (cdr e-206))) (if (null? e-210) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "char>=?" (cons e-205 (cons e-209 '()))))) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-32) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '()))))))))))))))))) ((24) (if (null? arg-2) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-37) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '()))))))))) (let ((e-214 (car arg-2))) (let ((e-215 (cdr arg-2))) (if (null? e-215) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-36) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '()))))))))) (let ((e-218 (car e-215))) (let ((e-219 (cdr e-215))) (if (null? e-219) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "string>=?" (cons e-214 (cons e-218 '()))))) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-35) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '())))))))))))))))))(else (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-38) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '()))))))))))))) ((15) (let ((e-15 (vector-ref arg-1 1))) (case (vector-ref e-15 0) ((25) (if (null? arg-2) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-41) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '()))))))))) (let ((e-232 (car arg-2))) (let ((e-233 (cdr arg-2))) (if (null? e-233) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-40) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '()))))))))) (let ((e-236 (car e-233))) (let ((e-237 (cdr e-233))) (if (null? e-237) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "char>?" (cons e-232 (cons e-236 '()))))) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-39) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '()))))))))))))))))) ((24) (if (null? arg-2) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-44) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '()))))))))) (let ((e-241 (car arg-2))) (let ((e-242 (cdr arg-2))) (if (null? e-242) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-43) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '()))))))))) (let ((e-245 (car e-242))) (let ((e-246 (cdr e-242))) (if (null? e-246) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-boolop "string>?" (cons e-241 (cons e-245 '()))))) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-42) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '())))))))))))))))))(else (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-45) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '()))))))))))))) ((16) (lambda (clam-46) (let ((e-250 (car arg-2))) (let ((e-251 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "string-length" (cons e-250 '()))))))) ((17) (lambda (clam-47) (let ((e-255 (car arg-2))) (let ((e-256 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "string-ref" (cons e-255 (cons "0" '())))))))) ((18) (lambda (clam-48) (let ((e-260 (car arg-2))) (let ((e-261 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "substring" (cons e-260 (cons "1" (cons (CompilerC-45SchemeC-45Common-op "string-length" (cons e-260 '())) '()))))))))) ((19) (let ((e-265 (car arg-2))) (let ((e-266 (cdr arg-2))) (lambda (clam-49) (let ((e-269 (car e-266))) (let ((e-270 (cdr e-266))) (vector 1 (CompilerC-45SchemeC-45Common-op "string-ref" (cons e-265 (cons e-269 '())))))))))) ((20) (let ((e-274 (car arg-2))) (let ((e-275 (cdr arg-2))) (lambda (clam-50) (let ((e-278 (car e-275))) (let ((e-279 (cdr e-275))) (vector 1 (CompilerC-45SchemeC-45Common-op "string-cons" (cons e-274 (cons e-278 '())))))))))) ((21) (let ((e-283 (car arg-2))) (let ((e-284 (cdr arg-2))) (lambda (clam-51) (let ((e-287 (car e-284))) (let ((e-288 (cdr e-284))) (vector 1 (CompilerC-45SchemeC-45Common-op "string-append" (cons e-283 (cons e-287 '())))))))))) ((22) (lambda (clam-52) (let ((e-292 (car arg-2))) (let ((e-293 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "string-reverse" (cons e-292 '()))))))) ((23) (let ((e-297 (car arg-2))) (let ((e-298 (cdr arg-2))) (let ((e-301 (car e-298))) (let ((e-302 (cdr e-298))) (lambda (clam-53) (let ((e-305 (car e-302))) (let ((e-306 (cdr e-302))) (vector 1 (CompilerC-45SchemeC-45Common-op "string-substr" (cons e-297 (cons e-301 (cons e-305 '()))))))))))))) ((24) (lambda (clam-54) (let ((e-310 (car arg-2))) (let ((e-311 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flexp" (cons e-310 '()))))))) ((25) (lambda (clam-55) (let ((e-315 (car arg-2))) (let ((e-316 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "fllog" (cons e-315 '()))))))) ((26) (let ((e-320 (car arg-2))) (let ((e-321 (cdr arg-2))) (lambda (clam-56) (let ((e-324 (car e-321))) (let ((e-325 (cdr e-321))) (vector 1 (CompilerC-45SchemeC-45Common-op "expt" (cons e-320 (cons e-324 '())))))))))) ((27) (lambda (clam-57) (let ((e-329 (car arg-2))) (let ((e-330 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flsin" (cons e-329 '()))))))) ((28) (lambda (clam-58) (let ((e-334 (car arg-2))) (let ((e-335 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flcos" (cons e-334 '()))))))) ((29) (lambda (clam-59) (let ((e-339 (car arg-2))) (let ((e-340 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "fltan" (cons e-339 '()))))))) ((30) (lambda (clam-60) (let ((e-344 (car arg-2))) (let ((e-345 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flasin" (cons e-344 '()))))))) ((31) (lambda (clam-61) (let ((e-349 (car arg-2))) (let ((e-350 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flacos" (cons e-349 '()))))))) ((32) (lambda (clam-62) (let ((e-354 (car arg-2))) (let ((e-355 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flatan" (cons e-354 '()))))))) ((33) (lambda (clam-63) (let ((e-359 (car arg-2))) (let ((e-360 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flsqrt" (cons e-359 '()))))))) ((34) (lambda (clam-64) (let ((e-364 (car arg-2))) (let ((e-365 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flfloor" (cons e-364 '()))))))) ((35) (lambda (clam-65) (let ((e-369 (car arg-2))) (let ((e-370 (cdr arg-2))) (vector 1 (CompilerC-45SchemeC-45Common-op "flceiling" (cons e-369 '()))))))) ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (case (vector-ref e-16 0) ((26) (case (vector-ref e-17 0) ((24) (if (null? arg-2) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374))) (let ((e-379 (car arg-2))) (let ((e-380 (cdr arg-2))) (if (null? e-380) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-op "number->string" (cons e-379 '())))) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374))))))))(else (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374)))))) ((25) (case (vector-ref e-17 0) ((24) (if (null? arg-2) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374))) (let ((e-384 (car arg-2))) (let ((e-385 (cdr arg-2))) (if (null? e-385) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-op "string" (cons e-384 '())))) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374))))))))(else (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374)))))) ((24) (case (vector-ref e-17 0) ((26) (if (null? arg-2) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374))) (let ((e-389 (car arg-2))) (let ((e-390 (cdr arg-2))) (if (null? e-390) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-op "cast-string-double" (cons e-389 '())))) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374))))))))(else (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374))))))(else (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt (CompilerC-45SchemeC-45Common-constPrimitives) e-16 e-17 e-374)))))))) ((37) (let ((e-395 (cdr arg-2))) (let ((e-399 (cdr e-395))) (lambda (clam-66) (let ((e-402 (car e-399))) (let ((e-403 (cdr e-399))) (vector 1 e-402))))))) (else (let ((e-408 (cdr arg-2))) (lambda (clam-67) (let ((e-411 (car e-408))) (let ((e-412 (cdr e-408))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-error-quit (string-append \"ERROR: \" " (PreludeC-45TypesC-45String-C-43C-43 e-411 "))")))))))))))
(define CompilerC-45SchemeC-45Common-schName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref e-1 0) ((1) (let ((e-16 (vector-ref e-1 1))) (case (vector-ref e-16 0) ((0) (let ((e-17 (vector-ref e-16 1))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (PreludeC-45TypesC-45String-C-43C-43 "-" (CompilerC-45SchemeC-45Common-schString e-17)))))(else (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (PreludeC-45TypesC-45String-C-43C-43 "-" (CompilerC-45SchemeC-45Common-schName e-1)))))))(else (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (PreludeC-45TypesC-45String-C-43C-43 "-" (CompilerC-45SchemeC-45Common-schName e-1)))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CompilerC-45SchemeC-45Common-schUserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schString e-3) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Int e-4)))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "pat--" (CompilerC-45SchemeC-45Common-schName e-5)))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CompilerC-45SchemeC-45Common-schName e-8))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (let ((e-20 (car e-9))) (let ((e-21 (cdr e-9))) (PreludeC-45TypesC-45String-C-43C-43 "n--" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-20) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-21) (PreludeC-45TypesC-45String-C-43C-43 "-" (CompilerC-45SchemeC-45Common-schName e-10))))))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "case--" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schString e-11) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Int e-12))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "with--" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schString e-13) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Int e-14))))))) (else (let ((e-15 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "fn--" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define CompilerC-45SchemeC-45Common-schMaybeCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-0) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) u--v) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box e-6))))))))) arg-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45SchemeC-45Common-n--9771-4555-u--getNothingCode arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 arg-4) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc3 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc3 1) (let ((act-27 ((CompilerC-45SchemeC-45Common-n--9771-4556-u--getJustCode arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 e-5 arg-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CompilerC-45SchemeC-45Common-n--9771-4554-u--buildCase arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 e-5 e-7 e-8 e-6))))))) (else (let ((act-27 ((CompilerC-45SchemeC-45Common-n--9771-4556-u--getJustCode arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 u--n arg-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-n--9771-4554-u--buildCase arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 u--n e-7 e-8 e-6) ")")))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Common-schListCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-0) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) u--v) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box e-6))))))))) arg-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45SchemeC-45Common-n--9770-4123-u--getNilCode arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 arg-4) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((sc3 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc3 1) (let ((act-27 ((CompilerC-45SchemeC-45Common-n--9770-4124-u--getConsCode arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 e-5 arg-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (CompilerC-45SchemeC-45Common-n--9770-4122-u--buildCase arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 e-5 e-7 e-8 e-6))))))) (else (let ((act-27 ((CompilerC-45SchemeC-45Common-n--9770-4124-u--getConsCode arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 u--n arg-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-n--9770-4122-u--buildCase arg-0 arg-1 arg-5 arg-4 arg-3 arg-2 u--n e-7 e-8 e-6) ")")))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Common-schExtCommon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (if (null? arg-4) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-3 (cdr arg-4))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-0) (let ((e-9 (cdr e-6))) (if (null? e-9) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-5) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(box " (PreludeC-45TypesC-45String-C-43C-43 e-7 ")")))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-0))))))))))) ((1) (if (null? arg-4) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-13 (cdr arg-4))) (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-15 (car e-13))) (let ((e-16 (cdr e-13))) (lambda (clam-1) (if (null? e-16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-1) (let ((e-19 (cdr e-16))) (if (null? e-19) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-15) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(unbox " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-1))))))))))) ((2) (if (null? arg-4) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-23 (cdr arg-4))) (if (null? e-23) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-25 (car e-23))) (let ((e-26 (cdr e-23))) (if (null? e-26) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-28 (car e-26))) (let ((e-29 (cdr e-26))) (lambda (clam-2) (if (null? e-29) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-2) (let ((e-32 (cdr e-29))) (if (null? e-32) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-25) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-28) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(set-box! " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-2)))))))))))))) ((3) (if (null? arg-4) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-36 (cdr arg-4))) (if (null? e-36) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-38 (car e-36))) (let ((e-39 (cdr e-36))) (if (null? e-39) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-41 (car e-39))) (let ((e-42 (cdr e-39))) (lambda (clam-3) (if (null? e-42) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-3) (let ((e-45 (cdr e-42))) (if (null? e-45) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-38) clam-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-41) clam-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(make-vector " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-3)))))))))))))) ((4) (if (null? arg-4) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-49 (cdr arg-4))) (if (null? e-49) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-51 (car e-49))) (let ((e-52 (cdr e-49))) (if (null? e-52) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-54 (car e-52))) (let ((e-55 (cdr e-52))) (lambda (clam-4) (if (null? e-55) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-4) (let ((e-58 (cdr e-55))) (if (null? e-58) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-51) clam-4))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-54) clam-4))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(vector-ref " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-4)))))))))))))) ((5) (if (null? arg-4) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-62 (cdr arg-4))) (if (null? e-62) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-64 (car e-62))) (let ((e-65 (cdr e-62))) (if (null? e-65) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-67 (car e-65))) (let ((e-68 (cdr e-65))) (if (null? e-68) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-70 (car e-68))) (let ((e-71 (cdr e-68))) (lambda (clam-5) (if (null? e-71) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-5) (let ((e-74 (cdr e-71))) (if (null? e-74) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-64) clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-67) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-70) clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(vector-set! " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-7 ")")))))))))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-5))))))))))))))))) ((8) (if (null? arg-4) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0)) (let ((e-78 (cdr arg-4))) (lambda (clam-6) (if (null? e-78) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-6) (let ((e-81 (cdr e-78))) (if (null? e-81) (vector 1 "(display \"Error: Executed 'void'\")") (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-6)))))))) ((9) (lambda (clam-7) (if (null? arg-4) (vector 1 "(blodwen-os)") (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) clam-7)))) ((14) (let ((e-0 (vector-ref arg-3 1))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't compile unknown external primitive " (CoreC-45Name-u--show_Show_Name e-0))) eta-0))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Badly formed external primitive " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-3) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-839) arg-4))))) eta-0))))))
(define CompilerC-45SchemeC-45Common-schExp (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-schName e-1))))) ((1) (let ((e-3 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-schName e-3))))) ((2) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-6) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-7 ")"))))))))))))) ((3) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-9) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-10) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-8) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))))))))))))))))))) ((4) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (lambda (clam-0) (if (null? e-13) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-5 ")"))))))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 eta-0)) e-13 '() clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-6) ")")))))))))))))))))) ((5) (let ((e-15 (vector-ref arg-3 2))) (let ((e-16 (vector-ref arg-3 3))) (let ((e-17 (vector-ref arg-3 4))) (let ((e-18 (vector-ref arg-3 5))) (cond ((equal? e-16 2) (lambda (clam-1) (if (null? e-18) (vector 1 "'()") (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Bad NIL") clam-1)))) ((equal? e-16 3) (if (null? e-18) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Bad CONS") eta-0)) (let ((e-48 (car e-18))) (let ((e-49 (cdr e-18))) (lambda (clam-0) (if (null? e-49) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Bad CONS") clam-0) (let ((e-51 (car e-49))) (let ((e-52 (cdr e-49))) (if (null? e-52) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-48) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-51) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(cons " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Bad CONS") clam-0)))))))))) ((equal? e-16 5) (lambda (clam-3) (if (null? e-18) (vector 1 "'()") (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Bad NOTHING") clam-3)))) ((equal? e-16 6) (lambda (clam-1) (if (null? e-18) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Bad JUST") clam-1) (let ((e-56 (car e-18))) (let ((e-57 (cdr e-18))) (if (null? e-57) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-56) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(box " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")"))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Bad JUST") clam-1))))))) ((equal? e-16 7) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 eta-1)) e-18 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45SchemeC-45Common-schRecordCon arg-1 e-15 e-5))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 eta-1)) e-18 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45SchemeC-45Common-schConstructor arg-1 e-15 e-17 e-5)))))))))))))) ((6) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-24 (CompilerC-45SchemeC-45Common-schArgs arg-0 arg-1 arg-2 e-22 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CompilerC-45SchemeC-45Common-schOp e-21 e-5) eta-0))))))))) ((7) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (((arg-0 arg-2) (CompilerC-45SchemeC-45Common-toPrim e-24)) e-25)))) ((8) (let ((e-28 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-28) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))))) ((9) (let ((e-31 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-31) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(lambda () " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))))) ((10) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (CoreC-45Core-cond (cons (cons (lambda () (CompilerC-45SchemeC-45Common-n--9772-5206-u--recordCase arg-0 arg-1 e-35 e-34 e-33 e-32 arg-2 e-34)) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-schRecordCase arg-0 arg-1 arg-2 e-33 e-34 e-35 eta-0)))) (cons (cons (lambda () (CompilerC-45SchemeC-45Common-n--9772-5205-u--maybeCase arg-0 arg-1 e-35 e-34 e-33 e-32 arg-2 e-34)) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-schMaybeCase arg-0 arg-1 arg-2 e-33 e-34 e-35 eta-0)))) (cons (cons (lambda () (CompilerC-45SchemeC-45Common-n--9772-5204-u--listCase arg-0 arg-1 e-35 e-34 e-33 e-32 arg-2 e-34)) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-schListCase arg-0 arg-1 arg-2 e-33 e-34 e-35 eta-0)))) '()))) (CompilerC-45SchemeC-45Common-schCaseTree arg-0 arg-1 arg-2 e-33 e-34 e-35))))))) ((11) (let ((e-36 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (let ((e-38 (vector-ref arg-3 3))) (let ((e-39 (vector-ref arg-3 4))) (lambda (clam-5) (if (null? e-39) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) e-37) clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc3 (CompilerC-45SchemeC-45Common-var e-37))) (cond ((equal? sc3 1) (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9772-5312-u--showConstAlts arg-0 arg-1 e-38 e-37 e-36 arg-2 e-5 e-38) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(cond " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))))))) (else (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9772-5312-u--showConstAlts arg-0 arg-1 e-38 e-37 e-36 arg-2 u--n e-38) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) (cond " (PreludeC-45TypesC-45String-C-43C-43 e-6 "))"))))))))))))))))))) (let ((act-24 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 u--v) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box e-5))))))))) e-39) clam-5))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) e-37) clam-5))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc4 (CompilerC-45SchemeC-45Common-var e-37))) (cond ((equal? sc4 1) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Common-schConstAlt arg-0 arg-1 (bs+ arg-2 1 63) e-6 eta-0 eta-1))) e-38 '() clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(cond " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-7) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schCaseDef e-5) ")"))))))))) (else (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Common-schConstAlt arg-0 arg-1 (bs+ arg-2 1 63) u--n eta-0 eta-1))) e-38 '() clam-5))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 ")) (cond " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-7) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schCaseDef e-5) "))"))))))))))))))))))))))))))))))) ((12) (let ((e-41 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-schConstant arg-1 e-41))))) ((13) (lambda (eta-0) (vector 1 "'erased"))) (else (let ((e-44 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-error-quit " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-44) ")")))))))))
(define CompilerC-45SchemeC-45Common-schDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (if (null? e-0) (let ((act-24 (CoreC-45Context-getFullName arg-2 arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 0 e-1) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(define " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-lazy (lambda () " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")))\xa;"))))))))))))) (let ((act-24 (CoreC-45Context-getFullName arg-2 arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 0 e-1) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(define " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (PreludeC-45TypesC-45String-C-43C-43 " (lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schArglist e-0) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-6 "))\xa;"))))))))))))))))))) ((3) (let ((e-2 (vector-ref arg-4 1))) (let ((act-24 (CoreC-45Context-getFullName arg-2 arg-3 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 0 e-2) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(define (" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (PreludeC-45TypesC-45String-C-43C-43 " . any-args) " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")\xa;"))))))))))))))) ((2) (vector 1 "")) (else (vector 1 ""))))))
(define CompilerC-45SchemeC-45Common-schConstructor (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) (PreludeC-45TypesC-45String-C-43C-43 "(vector " (PreludeC-45TypesC-45String-C-43C-43 (arg-0 (CoreC-45Name-u--show_Show_Name arg-1)) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " arg-3) ")")))) (let ((e-1 (unbox arg-2))) (PreludeC-45TypesC-45String-C-43C-43 "(vector " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-1) (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " arg-3) ")"))))))))
(define CompilerC-45SchemeC-45Common-schConstant (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Int e-0))) ((1) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Int8 e-1))) ((2) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Int16 e-2))) ((3) (let ((e-3 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Int32 e-3))) ((4) (let ((e-4 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Int64 e-4))) ((5) (let ((e-5 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Integer e-5))) ((6) (let ((e-6 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Bits8 e-6))) ((7) (let ((e-7 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Bits16 e-7))) ((8) (let ((e-8 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Bits32 e-8))) ((9) (let ((e-9 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Bits64 e-9))) ((10) (let ((e-10 (vector-ref arg-1 1))) (arg-0 e-10))) ((11) (let ((e-11 (vector-ref arg-1 1))) (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (PreludeC-45Cast-u--cast_Cast_Char_Int e-11) 32))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60_Ord_Int (PreludeC-45Cast-u--cast_Cast_Char_Int e-11) (blodwen-toSignedInt 127 63))) (else 0))))) (cond ((equal? sc1 1) (PreludeC-45TypesC-45String-C-43C-43 "#\\" (PreludeC-45Cast-u--cast_Cast_Char_String e-11))) (else (PreludeC-45TypesC-45String-C-43C-43 "(integer->char " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int (PreludeC-45Cast-u--cast_Cast_Char_Int e-11)) ")"))))))) ((12) (let ((e-12 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Double e-12))) ((13) "#f") ((14) "#t") ((15) "#t") ((16) "#t") ((17) "#t") ((18) "#t") ((19) "#t") ((20) "#t") ((21) "#t") ((22) "#t") ((23) "#t") ((24) "#t") ((25) "#t") ((26) "#t") (else "#t"))))
(define CompilerC-45SchemeC-45Common-schConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-1) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "((equal? " (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schConstant arg-1 e-0) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))))))))))
(define CompilerC-45SchemeC-45Common-schConUncheckedAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-0 (vector-ref arg-4 0))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45SchemeC-45Common-n--9765-3263-u--bindArgs arg-0 arg-1 e-4 e-3 e-2 e-1 e-0 arg-3 arg-2 1 e-3 e-5)))))))))))))
(define CompilerC-45SchemeC-45Common-schConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-0 (vector-ref arg-4 0))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "((" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-showTag arg-0 arg-1 e-0 e-2) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-n--9764-3140-u--bindArgs arg-0 arg-1 e-4 e-3 e-2 e-1 e-0 arg-3 arg-2 1 e-3 e-5) ")"))))))))))))))))
(define CompilerC-45SchemeC-45Common-schCaseTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 "'erased"))) (lambda () (lambda (eta-1) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 eta-1))) arg-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc3 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc3 1) (vector 1 e-6)) (else (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))))))))))))))))))) (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (if (null? e-4) (lambda (clam-0) (if (null? arg-5) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc4 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc4 1) (let ((act-25 (CompilerC-45SchemeC-45Common-schConUncheckedAlt arg-0 arg-1 (bs+ arg-2 1 63) e-5 e-3 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 e-6)))))) (else (let ((act-25 (CompilerC-45SchemeC-45Common-schConUncheckedAlt arg-0 arg-1 (bs+ arg-2 1 63) u--n e-3 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))))))) (if (null? arg-5) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc5 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc5 1) (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9768-3610-u--showAlts arg-0 arg-1 arg-4 arg-3 arg-2 e-5 arg-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(case (vector-ref " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " 0) " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))))))))) (else (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9768-3610-u--showAlts arg-0 arg-1 arg-4 arg-3 arg-2 u--n arg-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) (case (vector-ref " (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " 0) " (PreludeC-45TypesC-45String-C-43C-43 e-6 "))"))))))))))))))))))))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-0) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 u--v) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box e-6))))))))) arg-5) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc6 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc6 1) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 (bs+ arg-2 1 63) e-5 eta-0 eta-1))) arg-4 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(case (vector-ref " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " 0) " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-7) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schCaseDef e-6) ")"))))))))))) (else (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 (bs+ arg-2 1 63) u--n eta-0 eta-1))) arg-4 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) (case (vector-ref " (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " 0) " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-7) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schCaseDef e-6) "))"))))))))))))))))))))))))))))) (lambda (clam-1) (if (null? arg-5) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc4 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc4 1) (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9768-3610-u--showAlts arg-0 arg-1 arg-4 arg-3 arg-2 e-5 arg-4) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(case (vector-ref " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " 0) " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))))))))) (else (let ((act-25 ((CompilerC-45SchemeC-45Common-n--9768-3610-u--showAlts arg-0 arg-1 arg-4 arg-3 arg-2 u--n arg-4) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) (case (vector-ref " (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " 0) " (PreludeC-45TypesC-45String-C-43C-43 e-6 "))"))))))))))))))))))))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 (bs+ arg-2 1 63) arg-3) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-0) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 u--v) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (box e-6))))))))) arg-5) clam-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "sc" (PreludeC-45Show-u--show_Show_Int arg-2)))) (let ((sc5 (CompilerC-45SchemeC-45Common-var arg-3))) (cond ((equal? sc5 1) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 (bs+ arg-2 1 63) e-5 eta-0 eta-1))) arg-4 '() clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(case (vector-ref " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " 0) " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-7) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schCaseDef e-6) ")"))))))))))) (else (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 (bs+ arg-2 1 63) u--n eta-0 eta-1))) arg-4 '() clam-1))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ((" (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 ")) (case (vector-ref " (PreludeC-45TypesC-45String-C-43C-43 u--n (PreludeC-45TypesC-45String-C-43C-43 " 0) " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-7) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schCaseDef e-6) "))"))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Common-schCaseDef (lambda (arg-0) (if (null? arg-0) "" (let ((e-2 (unbox arg-0))) (PreludeC-45TypesC-45String-C-43C-43 "(else " (PreludeC-45TypesC-45String-C-43C-43 e-2 ")"))))))
(define CompilerC-45SchemeC-45Common-schArgs (lambda (arg-0 arg-1 arg-3 arg-4 ext-0) (if (null? arg-4) (vector 1 '()) (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-3 e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45SchemeC-45Common-schArgs arg-0 arg-1 arg-3 e-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons e-5 e-6)))))))))))))))
(define CompilerC-45SchemeC-45Common-schArglist (lambda (arg-0) (if (null? arg-0) "" (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? e-3) (CompilerC-45SchemeC-45Common-schName e-2) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-2) (PreludeC-45TypesC-45String-C-43C-43 " " (CompilerC-45SchemeC-45Common-schArglist e-3)))))))))
(define CompilerC-45SchemeC-45Common-op (lambda (arg-0 arg-1) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " arg-1) ")"))))))
(define CompilerC-45SchemeC-45Common-mul (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (CompilerC-45SchemeC-45Common-op "*" (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "*" (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "bs*" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (CompilerC-45SchemeC-45Common-op "bu*" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-3) '()))))))(else (CompilerC-45SchemeC-45Common-op "*" (cons arg-1 (cons arg-2 '())))))))))
(define CompilerC-45SchemeC-45Common-mkWorld (lambda (arg-0) arg-0))
(define CompilerC-45SchemeC-45Common-getScheme (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-7 (cdr e-3))) (CompilerC-45SchemeC-45Common-schDef arg-1 arg-2 arg-0 e-2 e-7))))))
(define CompilerC-45SchemeC-45Common-div (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (CompilerC-45SchemeC-45Common-op "/" (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "quotient" (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "bs/" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (CompilerC-45SchemeC-45Common-op "bu/" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-3) '()))))))(else (CompilerC-45SchemeC-45Common-op "/" (cons arg-1 (cons arg-2 '())))))))))
(define CompilerC-45SchemeC-45Common-constPrimitives(blodwen-lazy (lambda () (vector (lambda (u--k) (lambda (eta-0) (lambda (eta-1) (vector 1 (CompilerC-45SchemeC-45Common-n--7635-974-u--charTo u--k eta-0))))) (lambda (_-1328) (lambda (u--x) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-op "cast-int-char" (cons u--x '())))))) (lambda (u--k) (lambda (eta-0) (lambda (eta-1) (vector 1 (CompilerC-45SchemeC-45Common-n--7635-975-u--strTo u--k eta-0))))) (lambda (_-1309) (lambda (u--x) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-op "number->string" (cons u--x '())))))) (lambda (u--k) (lambda (eta-0) (lambda (eta-1) (vector 1 (CompilerC-45SchemeC-45Common-n--7635-976-u--dblTo u--k eta-0))))) (lambda (_-1290) (lambda (u--x) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-op "exact->inexact" (cons u--x '())))))) (lambda (u--k1) (lambda (u--k2) (lambda (eta-0) (lambda (eta-1) (vector 1 (CompilerC-45SchemeC-45Common-n--7635-977-u--intTo u--k1 u--k2 eta-0))))))))))
(define CompilerC-45SchemeC-45Common-boolop (lambda (arg-0 arg-1) (PreludeC-45TypesC-45String-C-43C-43 "(or (and " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-op arg-0 arg-1) " 1) 0)"))))
(define CompilerC-45SchemeC-45Common-add (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (CompilerC-45SchemeC-45Common-op "+" (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "+" (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "bs+" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (CompilerC-45SchemeC-45Common-op "bu+" (cons arg-1 (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int e-3) '()))))))(else (CompilerC-45SchemeC-45Common-op "+" (cons arg-1 (cons arg-2 '())))))))))
(define CompilerC-45Generated-generatedString (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 "@" (PreludeC-45TypesC-45String-C-43C-43 "generated by Idris " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45Version-u--show_Show_Version (IdrisC-45Version-version)) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 arg-0 " backend")))))))
(define CompilerC-45SchemeC-45Racket-case--cCall-1457 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-24 (let ((sc1 (PreludeC-45Types-elem (csegen-17) e-2 arg-9))) (cond ((equal? sc1 1) (vector 1 "")) (else (let ((act-24 (let ((act-24 (set-box! arg-6 (cons e-2 arg-9)))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 ((CompilerC-45Common-locate arg-7 arg-2) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-26 ((CompilerC-45Common-copyLib (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-5 e-7) e-4)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (vector 1 (CompilerC-45SchemeC-45Racket-loadlib e-2 e-3))))))))))))))))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (u--a) (lambda (eta-0) (let ((act-25 ((CompilerC-45SchemeC-45Racket-cftySpec arg-4 (Builtin-snd u--a)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons u--a e-6)))))))) arg-1 '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45SchemeC-45Racket-cftySpec arg-4 arg-0) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((sc4 (PreludeC-45Types-elem (csegen-17) arg-3 arg-10))) (cond ((equal? sc4 1) (vector 1 "")) (else (let ((act-27 (let ((act-27 (set-box! arg-8 (cons arg-3 arg-10)))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(define-" (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 " (_fun " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-6)) (PreludeC-45TypesC-45String-C-43C-43 " -> " (PreludeC-45TypesC-45String-C-43C-43 e-7 "))\xa;"))))))))))))))))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Racket-n--9168-1290-u--useArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-0)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-6) '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--call (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-9) ")")))))) (vector 1 (cons (PreludeC-45TypesC-45String-C-43C-43 e-5 e-8) (case (vector-ref arg-0 0) ((20) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45SchemeC-45Racket-handleRet e-0 u--call)))(else u--call)))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Racket-case--getLibVers-1127 (lambda (arg-0 arg-1) (if (null? arg-1) (cons "" "") (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (let ((sc2 (DataC-45String-span (lambda (arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-2 #\.)) arg-0))) (let ((e-5 (car sc2))) (cons e-5 ""))) (cons (Builtin-fst (DataC-45String-span (lambda (arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-2 #\.)) e-2)) (PreludeC-45TypesC-45String-C-43C-43 "'(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_String eta-0)) e-3)) " #f)")))))))))
(define CompilerC-45SchemeC-45Racket-n--9168-1290-u--useArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-3 0) ((19) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (CompilerC-45SchemeC-45Racket-n--9168-1289-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (CompilerC-45SchemeC-45Common-schName e-2) (cons e-4 '()) e-5))))(else (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Racket-rktToC e-3 (CompilerC-45SchemeC-45Common-schName e-2))))))))))
(define CompilerC-45SchemeC-45Racket-n--10240-2218-u--showFld (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((CompilerC-45SchemeC-45Racket-cftySpec (CoreC-45FC-emptyFC) e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 "]")))))))))))))
(define CompilerC-45SchemeC-45Racket-n--9168-1288-u--notWorld (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((18) 0)(else 1))))
(define CompilerC-45SchemeC-45Racket-n--9168-1285-u--mkNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) '() (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (case (vector-ref e-2 0) ((18) (cons '() (CompilerC-45SchemeC-45Racket-n--9168-1285-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3)))(else (cons (box (cons (PreludeC-45TypesC-45String-C-43C-43 "cb" (PreludeC-45Show-u--show_Show_Int arg-9)) e-2)) (CompilerC-45SchemeC-45Racket-n--9168-1285-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (bs+ arg-9 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Racket-n--9168-1287-u--mkFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((u--argns (CompilerC-45SchemeC-45Racket-n--9168-1285-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 0 arg-9))) (PreludeC-45TypesC-45String-C-43C-43 "(lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (DataC-45List-mapMaybe (lambda (eta-0) eta-0) u--argns))) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Racket-n--9168-1286-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 u--argns) ")")))))))
(define CompilerC-45SchemeC-45Racket-n--8870-1047-u--funTySpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((19) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (case (vector-ref e-0 0) ((18) (CompilerC-45SchemeC-45Racket-n--8870-1047-u--funTySpec arg-0 arg-1 arg-2 arg-3 e-1))(else (CompilerC-45SchemeC-45Racket-n--8870-1047-u--funTySpec arg-0 arg-1 arg-2 (cons e-0 arg-3) e-1))))))(else (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Racket-cftySpec arg-2 arg-4) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-cftySpec arg-2 eta-1)) (PreludeC-45TypesC-45List-reverse arg-3) '() eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(_fun " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-6) (PreludeC-45TypesC-45String-C-43C-43 " -> " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")"))))))))))))))))))
(define CompilerC-45SchemeC-45Racket-n--9168-1289-u--callback (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((19) (let ((e-0 (vector-ref arg-11 1))) (let ((e-1 (vector-ref arg-11 2))) (CompilerC-45SchemeC-45Racket-n--9168-1289-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons e-0 arg-10) e-1))))(else (let ((u--args (PreludeC-45TypesC-45List-reverse arg-10))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-cftySpec arg-4 eta-1)) (DataC-45List-filter (lambda (eta-1) (CompilerC-45SchemeC-45Racket-n--9168-1288-u--notWorld arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-1)) u--args) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CompilerC-45SchemeC-45Racket-cftySpec arg-4 arg-11) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (CompilerC-45SchemeC-45Racket-n--9168-1287-u--mkFun arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 u--args arg-11 arg-9))))))))))))))
(define CompilerC-45SchemeC-45Racket-n--9168-1286-u--applyLams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) arg-9 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (if (null? e-2) (CompilerC-45SchemeC-45Racket-n--9168-1286-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-9 " #f)")) e-3) (let ((e-6 (unbox e-2))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (CompilerC-45SchemeC-45Racket-n--9168-1286-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-9 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Racket-cToRkt e-10 e-9) ")")))) e-3))))))))))
(define CompilerC-45SchemeC-45Racket-useCC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 (CompilerC-45Common-parseCC (cons "scheme,racket" (csegen-3786)) arg-5))) (if (null? sc0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) eta-0)) (let ((e-2 (unbox sc0))) (if (null? e-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) eta-0)) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (cond ((equal? e-5 "scheme,racket") (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) clam-0) (let ((e-8 (car e-6))) (let ((e-9 (cdr e-6))) (if (null? e-9) (let ((act-24 ((CompilerC-45SchemeC-45Racket-schemeCall arg-4 e-8 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-6) arg-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (cons "" e-7)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) clam-0))))))) ((equal? e-5 "scheme") (lambda (clam-1) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) clam-1) (let ((e-12 (car e-6))) (let ((e-13 (cdr e-6))) (if (null? e-13) (let ((act-24 ((CompilerC-45SchemeC-45Racket-schemeCall arg-4 e-12 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-6) arg-7) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (cons "" e-7)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) clam-1))))))) ((equal? e-5 "C") (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) eta-0)) (let ((e-16 (car e-6))) (let ((e-17 (cdr e-6))) (if (null? e-17) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) eta-0)) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (if (null? e-20) (CompilerC-45SchemeC-45Racket-cCall arg-0 arg-1 arg-2 arg-3 arg-4 e-16 e-19 arg-6 arg-7) (let ((e-24 (cdr e-20))) (if (null? e-24) (CompilerC-45SchemeC-45Racket-cCall arg-0 arg-1 arg-2 arg-3 arg-4 e-16 e-19 arg-6 arg-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) eta-0))))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-4 arg-5) eta-0))))))))))))
(define CompilerC-45SchemeC-45Racket-startRacketWinSh (lambda (arg-0 arg-1 arg-2) (DataC-45String-fastUnlines (cons "#!/bin/sh" (cons (PreludeC-45TypesC-45String-C-43C-43 "# " (CompilerC-45Generated-generatedString "Racket")) (cons "" (cons "set -e # exit on any error" (cons "" (cons "DIR=$(dirname \"$(readlink -f -- \"$0\" || cygpath -a -- \"$0\")\")" (cons (PreludeC-45TypesC-45String-C-43C-43 "PATH=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ":$PATH\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-2 "\" \"$@\""))) '())))))))))))
(define CompilerC-45SchemeC-45Racket-startRacketCmd (lambda (arg-0 arg-1 arg-2) (DataC-45String-fastUnlines (cons "@echo off" (cons "set APPDIR=%~dp0" (cons (PreludeC-45TypesC-45String-C-43C-43 "set PATH=%APPDIR%" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ";%PATH%")) (cons (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\"%APPDIR%" (PreludeC-45TypesC-45String-C-43C-43 arg-2 "\" %*"))) '())))))))
(define CompilerC-45SchemeC-45Racket-startRacket (lambda (arg-0 arg-1 arg-2) (DataC-45String-fastUnlines (cons "#!/bin/sh" (cons (PreludeC-45TypesC-45String-C-43C-43 "# " (CompilerC-45Generated-generatedString "Racket")) (cons "" (cons "set -e # exit on any error" (cons "" (cons "if [ \"$(uname)\" = Darwin ]; then" (cons "  DIR=$(zsh -c 'printf %s \"$0:A:h\"' \"$0\")" (cons "else" (cons "  DIR=$(dirname \"$(readlink -f -- \"$0\")\")" (cons "fi" (cons "" (cons (PreludeC-45TypesC-45String-C-43C-43 "export LD_LIBRARY_PATH=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ":$LD_LIBRARY_PATH\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-2 "\" \"$@\""))) '()))))))))))))))))
(define CompilerC-45SchemeC-45Racket-showRacketString (lambda (arg-0) (lambda (clam-0) (if (null? arg-0) clam-0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-2 #\") (PreludeC-45TypesC-45String-C-43C-43 "\\\"" ((CompilerC-45SchemeC-45Racket-showRacketString e-3) clam-0)))(else ((CompilerC-45SchemeC-45Racket-showRacketChar e-2) ((CompilerC-45SchemeC-45Racket-showRacketString e-3) clam-0))))))))))
(define CompilerC-45SchemeC-45Racket-showRacketChar (lambda (arg-0) (lambda (clam-0) (cond ((equal? arg-0 #\\) (PreludeC-45TypesC-45String-C-43C-43 "\\\\" clam-0))(else (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-0 (PreludeC-45Types-chr 32)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-0 (PreludeC-45Types-chr (blodwen-toSignedInt 126 63)))))))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 "\\u" (LibrariesC-45UtilsC-45Hex-leftPad #\0 (+ 1 (+ 1 (+ 1 (+ 1 0)))) (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-0)))) clam-0)) (else (PreludeC-45Types-strCons arg-0 clam-0)))))))))
(define CompilerC-45SchemeC-45Racket-schemeCall (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--call (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45SchemeC-45Common-schName eta-0)) arg-2)) ")")))))) (lambda (clam-0) (case (vector-ref arg-3 0) ((20) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld u--call)))(else (vector 1 u--call)))))))
(define CompilerC-45SchemeC-45Racket-schHeader (lambda (arg-0 arg-1) (PreludeC-45TypesC-45String-C-43C-43 "#lang racket/base\xa;" (PreludeC-45TypesC-45String-C-43C-43 "; " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45Generated-generatedString "Racket") (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(require racket/async-channel)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(require racket/future)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(require racket/math)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(require racket/system)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(require rnrs/bytevectors-6)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(require rnrs/io/ports-6)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(require srfi/19)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(require ffi/unsafe ffi/unsafe/define)\xa;" (PreludeC-45TypesC-45String-C-43C-43 (cond ((equal? arg-0 1) "(require profile)\xa;") (else "")) (PreludeC-45TypesC-45String-C-43C-43 "(require racket/flonum)\xa;" (PreludeC-45TypesC-45String-C-43C-43 arg-1 "(let ()\xa;")))))))))))))))))
(define CompilerC-45SchemeC-45Racket-schFooter(blodwen-lazy (lambda () ") (collect-garbage)")))
(define CompilerC-45SchemeC-45Racket-schFgnDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((2) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (let ((e-2 (vector-ref arg-7 3))) (let ((u--argns (CompilerC-45SchemeC-45Racket-mkArgs 0 e-1))) (let ((u--allargns (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--argns))) (let ((u--useargns (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (DataC-45List-filter (lambda (eta-0) (Builtin-snd eta-0)) u--argns)))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-mkStruct arg-3 eta-1)) e-1 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Racket-mkStruct arg-3 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45SchemeC-45Racket-useCC arg-0 arg-1 arg-2 arg-4 arg-5 e-0 (DataC-45List-u--zip_Zippable_List u--useargns e-1) e-2) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-27 (let ((act-27 (unbox arg-1))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-u--full_HasNames_Name (let ((e-39 (vector-ref e-8 0))) e-39) arg-6 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-5) (PreludeC-45TypesC-45String-C-43C-43 e-6 e-4)) (PreludeC-45TypesC-45String-C-43C-43 "(define " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-9) (PreludeC-45TypesC-45String-C-43C-43 " (lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CompilerC-45SchemeC-45Common-schName eta-1)) u--allargns)) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-3 "))\xa;"))))))))))))))))))))))))))))))))))))))(else (lambda (eta-0) (vector 1 (cons "" "")))))))
(define CompilerC-45SchemeC-45Racket-rktToC (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((13) (PreludeC-45TypesC-45String-C-43C-43 "(char->integer " (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")")))(else arg-1))))
(define CompilerC-45SchemeC-45Racket-racketString (lambda (arg-0) (PreludeC-45Types-strCons #\" ((CompilerC-45SchemeC-45Racket-showRacketString (PreludeC-45Types-fastUnpack arg-0)) "\""))))
(define CompilerC-45SchemeC-45Racket-racketPrim (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((6) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (case (vector-ref e-1 0) ((12) (let ((e-20 (vector-ref e-1 2))) (case (vector-ref e-20 0) ((10) (let ((e-21 (vector-ref e-20 1))) (if (null? e-2) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-24 (cdr e-2))) (if (null? e-24) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-27 (cdr e-24))) (if (null? e-27) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (case (vector-ref e-32 0) ((12) (let ((e-35 (vector-ref e-32 2))) (case (vector-ref e-35 0) ((10) (let ((e-36 (vector-ref e-35 1))) (if (null? e-33) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-39 (cdr e-33))) (if (null? e-39) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) 0 e-29) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-21 (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 e-36 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))))))) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(error \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))) ((7) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-42 (car arg-2))) (let ((e-43 (cdr arg-2))) (case (vector-ref e-42 0) ((12) (let ((e-67 (vector-ref e-42 2))) (case (vector-ref e-67 0) ((10) (let ((e-68 (vector-ref e-67 1))) (if (null? e-43) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-71 (cdr e-43))) (if (null? e-71) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-74 (cdr e-71))) (if (null? e-74) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-76 (car e-74))) (let ((e-77 (cdr e-74))) (if (null? e-77) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-79 (car e-77))) (let ((e-80 (cdr e-77))) (case (vector-ref e-79 0) ((12) (let ((e-82 (vector-ref e-79 2))) (case (vector-ref e-82 0) ((10) (let ((e-83 (vector-ref e-82 1))) (if (null? e-80) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-86 (cdr e-80))) (if (null? e-86) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-88 (car e-86))) (let ((e-89 (cdr e-86))) (if (null? e-89) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-92 (cdr e-89))) (if (null? e-92) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) 0 e-76) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) 0 e-88) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(set-" (PreludeC-45TypesC-45String-C-43C-43 e-68 (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 e-83 (PreludeC-45TypesC-45String-C-43C-43 "! " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))))))) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(error \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))))))) ((10) (if (null? arg-2) (lambda (eta-0) (vector 1 "\"racket\"")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))) ((11) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-97 (cdr arg-2))) (if (null? e-97) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-99 (car e-97))) (let ((e-100 (cdr e-97))) (if (null? e-100) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-102 (car e-100))) (let ((e-103 (cdr e-100))) (if (null? e-103) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-106 (cdr e-103))) (if (null? e-106) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) 0 e-99) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) 0 e-102) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-register-object " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))))) ((12) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-109 (car arg-2))) (let ((e-110 (cdr arg-2))) (if (null? e-110) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-112 (car e-110))) (let ((e-113 (cdr e-110))) (if (null? e-113) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-116 (cdr e-113))) (if (null? e-116) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) 0 e-109) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) 0 e-112) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-register-object " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))))) ((13) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-120 (cdr arg-2))) (if (null? e-120) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2) (let ((e-122 (car e-120))) (let ((e-123 (cdr e-120))) (if (null? e-123) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) 0 e-122) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-make-future " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")"))))))))) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2))))))))(else (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) arg-0 arg-1 arg-2)))))
(define CompilerC-45SchemeC-45Racket-mkStruct (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((21) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-mkStruct arg-0 eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-1) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc3 (PreludeC-45Types-elem (csegen-17) e-0 e-6))) (cond ((equal? sc3 1) (vector 1 (PreludeC-45Interfaces-concat (csegen-67) e-5))) (else (let ((act-26 (let ((act-26 (set-box! arg-0 (cons e-0 e-6)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-n--10240-2218-u--showFld e-1 e-0 arg-0 eta-1 eta-2))) e-1 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-5) (PreludeC-45TypesC-45String-C-43C-43 "(define-cstruct _" (PreludeC-45TypesC-45String-C-43C-43 e-0 (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "\xa;\x9;" e-8) "))\xa;")))))))))))))))))))))))))))) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Racket-mkStruct arg-0 e-2))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (CompilerC-45SchemeC-45Racket-mkStruct arg-0 e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CompilerC-45SchemeC-45Racket-mkStruct arg-0 e-4) eta-0))))))))(else (lambda (eta-0) (vector 1 ""))))))
(define CompilerC-45SchemeC-45Racket-mkArgs (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((18) (cons (cons (vector 2 "farg" arg-0) 0) (CompilerC-45SchemeC-45Racket-mkArgs arg-0 e-3)))(else (cons (cons (vector 2 "farg" arg-0) 1) (CompilerC-45SchemeC-45Racket-mkArgs (bs+ arg-0 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Racket-makeShWindows (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--cmdFile (PreludeC-45TypesC-45String-C-43C-43 arg-1 ".cmd"))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) u--cmdFile (CompilerC-45SchemeC-45Racket-startRacketCmd arg-0 arg-2 arg-3)) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (let ((act-25 (let ((act-25 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-1 (CompilerC-45SchemeC-45Racket-startRacketWinSh arg-0 arg-2 arg-3)) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-3 (vector-ref e-6 1))) (cond (else (vector 1 0))))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 e-7) eta-0)))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--cmdFile e-6) eta-0))))))))))))
(define CompilerC-45SchemeC-45Racket-makeSh (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-1 (CompilerC-45SchemeC-45Racket-startRacket arg-0 arg-2 arg-3)) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (vector 1 0))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 e-6) ext-0))))))))))
(define CompilerC-45SchemeC-45Racket-loadlib (lambda (arg-0 arg-1) (cond ((equal? arg-0 "libc") "(define-ffi-definer define-libc (ffi-lib #f))\xa;")(else (PreludeC-45TypesC-45String-C-43C-43 "(define-ffi-definer define-" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 " (ffi-lib \"" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\" " (PreludeC-45TypesC-45String-C-43C-43 arg-1 "))\xa;"))))))))))
(define CompilerC-45SchemeC-45Racket-handleRet (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " " (CompilerC-45SchemeC-45Common-mkWorld (CompilerC-45SchemeC-45Common-schConstructor (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) (vector 1 (vector 0 "")) (box 0) '())))))(else (CompilerC-45SchemeC-45Common-mkWorld (CompilerC-45SchemeC-45Racket-cToRkt arg-0 arg-1))))))
(define CompilerC-45SchemeC-45Racket-getLibVers (lambda (arg-0) (CompilerC-45SchemeC-45Racket-case--getLibVers-1127 arg-0 (DataC-45String-words arg-0))))
(define CompilerC-45SchemeC-45Racket-getFgnCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (CompilerC-45SchemeC-45Racket-schFgnDef arg-0 arg-1 arg-2 arg-3 arg-4 e-6 e-2 e-7)))))))
(define CompilerC-45SchemeC-45Racket-findRacoExe (lambda (ext-0) (let ((act-24 ((IdrisC-45Env-idrisGetEnv (csegen-3) "RACKET_RACO" 0) ext-0))) (PreludeC-45TypesC-45String-C-43C-43 (DataC-45Maybe-fromMaybe (lambda () "/usr/bin/env raco") act-24) " exe"))))
(define CompilerC-45SchemeC-45Racket-findRacket (lambda (ext-0) (let ((act-24 ((IdrisC-45Env-idrisGetEnv (csegen-3) "RACKET" 0) ext-0))) (DataC-45Maybe-fromMaybe (lambda () "/usr/bin/env racket") act-24))))
(define CompilerC-45SchemeC-45Racket-executeExpr (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((CompilerC-45SchemeC-45Racket-compileExpr 0 arg-0 arg-1 arg-1 arg-2 "_tmpracket") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "compileExpr returned Nothing") ext-0) (let ((e-1 (unbox e-5))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((System-system (csegen-3) e-1) eta-0))) (vector 1 act-25))) ext-0)))))))))
(define CompilerC-45SchemeC-45Racket-compileToRKT (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CompilerC-45Common-getCompileData arg-0 0 0 arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--ndefs (let ((e-1 (vector-ref e-5 1))) e-1))) (let ((u--ctm (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-5 0))) e-0)))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Core-newRef (vector "Compiler.Scheme.Racket.Done" ) (PreludeC-45Types-u--empty_Alternative_List) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-newRef (vector "Compiler.Scheme.Racket.Loaded" ) '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-newRef (vector "Compiler.Scheme.Racket.Structs" ) '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Racket-getFgnCall e-7 arg-0 e-8 e-9 arg-1 eta-0)) u--ndefs '() ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScheme arg-0 (csegen-3821) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-1)) eta-0)) u--ndefs '() ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((u--code (DataC-45String-fastAppend (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-10) e-11)))) (let ((act-31 ((CompilerC-45SchemeC-45Common-schExp (csegen-3821) (lambda (eta-0) (CompilerC-45SchemeC-45Racket-racketString eta-0)) 0 u--ctm) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45Directory-readDataFile arg-0 "racket/support.rkt" ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Context-getDirectives arg-0 (vector 2 ) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CompilerC-45Common-getExtraRuntime e-14 ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (let ((act-35 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (let ((u--prof (let ((e-24 (vector-ref e-16 16))) e-24))) (let ((u--runmain (cond ((equal? u--prof 1) (PreludeC-45TypesC-45String-C-43C-43 "(profile (void " (PreludeC-45TypesC-45String-C-43C-43 e-12 ") #:order 'self)\xa;"))) (else (PreludeC-45TypesC-45String-C-43C-43 "(void " (PreludeC-45TypesC-45String-C-43C-43 e-12 ")\xa;")))))) (let ((u--scm (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Racket-schHeader u--prof (PreludeC-45Interfaces-concat (csegen-67) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) e-10))) (PreludeC-45TypesC-45String-C-43C-43 e-13 (PreludeC-45TypesC-45String-C-43C-43 e-15 (PreludeC-45TypesC-45String-C-43C-43 u--code (PreludeC-45TypesC-45String-C-43C-43 u--runmain (CompilerC-45SchemeC-45Racket-schFooter)))))))) (let ((act-36 (let ((act-36 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-3 u--scm) ext-0))) (vector 1 act-36)))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (case (vector-ref e-17 0) ((1) (let ((e-2 (vector-ref e-17 1))) (cond (else (let ((act-37 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-37 ((SystemC-45FileC-45Permissions-chmodRaw (csegen-3) arg-3 (blodwen-toSignedInt 493 63)) eta-0))) (vector 1 act-37))) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-3 (vector-ref act-37 1))) (vector 0 e-3))) (else (vector 1 0)))))))) (else (let ((e-18 (vector-ref e-17 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-3 e-18) ext-0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Racket-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--appDirRel (PreludeC-45TypesC-45String-C-43C-43 arg-5 "_app"))) (let ((u--appDirGen (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--appDirRel))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-24 (CoreC-45Directory-mkdirAll u--appDirGen eta-1))) (vector 1 act-24))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 ((csegen-878) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") eta-0) (let ((e-1 (unbox e-6))) (let ((u--ext (let ((sc3 (SystemC-45Info-isWindows))) (cond ((equal? sc3 1) ".exe") (else ""))))) (let ((u--outRktFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 "rkt")))) (let ((u--outBinFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 u--ext)))) (let ((u--outRktAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--outRktFile)))) (let ((u--outBinAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--outBinFile)))) (let ((act-26 (CompilerC-45SchemeC-45Racket-compileToRKT arg-1 u--appDirGen arg-4 u--outRktAbs eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (CompilerC-45SchemeC-45Racket-findRacoExe eta-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (CompilerC-45SchemeC-45Racket-findRacket eta-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (cond ((equal? arg-0 1) (CoreC-45ContextC-45Log-logTime arg-1 (lambda () "+ Build racket") (lambda (eta-1) (let ((act-29 ((System-system (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 e-8 (PreludeC-45TypesC-45String-C-43C-43 " -o " (PreludeC-45TypesC-45String-C-43C-43 u--outBinAbs (PreludeC-45TypesC-45String-C-43C-43 " " u--outRktAbs))))) eta-1))) (vector 1 act-29))) eta-0)) (else (vector 1 0))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-10 0))) (cond ((equal? sc7 1) (let ((u--outShRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 arg-5))) (let ((act-30 (let ((sc8 (SystemC-45Info-isWindows))) (cond ((equal? sc8 1) (cond ((equal? arg-0 1) ((CompilerC-45SchemeC-45Racket-makeShWindows "" u--outShRel u--appDirRel u--outBinFile) eta-0)) (else ((CompilerC-45SchemeC-45Racket-makeShWindows (PreludeC-45TypesC-45String-C-43C-43 e-9 " ") u--outShRel u--appDirRel u--outRktFile) eta-0)))) (else (cond ((equal? arg-0 1) (CompilerC-45SchemeC-45Racket-makeSh "" u--outShRel u--appDirRel u--outBinFile eta-0)) (else (CompilerC-45SchemeC-45Racket-makeSh (PreludeC-45TypesC-45String-C-43C-43 e-9 " ") u--outShRel u--appDirRel u--outRktFile eta-0)))))))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-31 ((SystemC-45FileC-45Permissions-chmodRaw (csegen-3) u--outShRel (blodwen-toSignedInt 493 63)) eta-1))) (vector 1 act-31))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (vector 1 (box u--outShRel)))))))))) (else (vector 1 '()))))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Racket-codegenRacket(blodwen-lazy (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Racket-compileExpr 1 eta-0 eta-1 eta-2 eta-3 eta-4)))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Racket-executeExpr eta-0 eta-1 eta-2 eta-3))))) '() '()))))
(define CompilerC-45SchemeC-45Racket-cftySpec (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 "_void"))) ((1) (lambda (eta-0) (vector 1 "_int"))) ((3) (lambda (eta-0) (vector 1 "_int8"))) ((4) (lambda (eta-0) (vector 1 "_int16"))) ((5) (lambda (eta-0) (vector 1 "_int32"))) ((6) (lambda (eta-0) (vector 1 "_int64"))) ((7) (lambda (eta-0) (vector 1 "_uint8"))) ((8) (lambda (eta-0) (vector 1 "_uint16"))) ((9) (lambda (eta-0) (vector 1 "_uint32"))) ((10) (lambda (eta-0) (vector 1 "_uint64"))) ((11) (lambda (eta-0) (vector 1 "_string/utf-8"))) ((12) (lambda (eta-0) (vector 1 "_double"))) ((13) (lambda (eta-0) (vector 1 "_int8"))) ((14) (lambda (eta-0) (vector 1 "_pointer"))) ((15) (lambda (eta-0) (vector 1 "_pointer"))) ((16) (lambda (eta-0) (vector 1 "_bytes"))) ((20) (let ((e-0 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Racket-cftySpec arg-0 e-0))) ((21) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "_" (PreludeC-45TypesC-45String-C-43C-43 e-1 "-pointer")))))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (CompilerC-45SchemeC-45Racket-n--8870-1047-u--funTySpec e-4 e-3 arg-0 (cons e-3 '()) e-4))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Can't pass argument of type " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_CFType arg-1) " to foreign function"))) eta-0))))))
(define CompilerC-45SchemeC-45Racket-cToRkt (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((13) (PreludeC-45TypesC-45String-C-43C-43 "(integer->char " (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")")))(else arg-1))))
(define CompilerC-45SchemeC-45Racket-cCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((20) (let ((e-0 (vector-ref arg-8 1))) (case (vector-ref e-0 0) ((15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 "Can't return GCPtr from a foreign function") clam-0)) ((16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 "Can't return Buffer from a foreign function") clam-0))(else (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CompilerC-45SchemeC-45Racket-case--cCall-1457 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 (CompilerC-45SchemeC-45Racket-getLibVers arg-6) clam-0))))))))))))) ((15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 "Can't return GCPtr from a foreign function") clam-0)) ((16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-4 "Can't return Buffer from a foreign function") clam-0))(else (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (CompilerC-45SchemeC-45Racket-case--cCall-1457 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 (CompilerC-45SchemeC-45Racket-getLibVers arg-6) clam-0))))))))))))))
(define CompilerC-45SchemeC-45ChezSep-case--chezNS-923 (lambda (arg-0 arg-1) (cond ((equal? arg-1 "") "unqualified")(else arg-1))))
(define CompilerC-45SchemeC-45ChezSep-n--9904-936-u--min1 (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CoreC-45NameC-45Namespace-u--min_Ord_Namespace eta-0 eta-1))) e-1 e-2)))))
(define CompilerC-45SchemeC-45ChezSep-touch (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-24 ((System-system (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "touch \"" (PreludeC-45TypesC-45String-C-43C-43 arg-0 "\""))) eta-0))) (vector 1 act-24))) ext-0)))
(define CompilerC-45SchemeC-45ChezSep-startChezWinSh (lambda (arg-0 arg-1 arg-2) (DataC-45String-fastUnlines (cons "#!/bin/sh" (cons (PreludeC-45TypesC-45String-C-43C-43 "# " (CompilerC-45Generated-generatedString "Chez")) (cons "" (cons "set -e # exit on any error" (cons "" (cons "DIR=$(dirname \"$(readlink -f -- \"$0\" || cygpath -a -- \"$0\")\")" (cons (PreludeC-45TypesC-45String-C-43C-43 "PATH=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ":$PATH\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\" --program \"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-2 "\" \"$@\"")))) (cons (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\" -q " (PreludeC-45TypesC-45String-C-43C-43 "--libdirs \"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "\" " (PreludeC-45TypesC-45String-C-43C-43 "--program \"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "\" " "\"$@\""))))))))) '()))))))))))))
(define CompilerC-45SchemeC-45ChezSep-startChezCmd (lambda (arg-0 arg-1 arg-2) (DataC-45String-fastUnlines (cons "@echo off" (cons "set APPDIR=%~dp0" (cons (PreludeC-45TypesC-45String-C-43C-43 "set PATH=%APPDIR%" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ";%PATH%")) (cons (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\" -q " (PreludeC-45TypesC-45String-C-43C-43 "--libdirs \"%APPDIR%" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "\" " (PreludeC-45TypesC-45String-C-43C-43 "--program \"%APPDIR%" (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "\" " "%*"))))))))) '())))))))
(define CompilerC-45SchemeC-45ChezSep-startChez (lambda (arg-0 arg-1 arg-2) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-startChezPreamble) (DataC-45String-fastUnlines (cons (PreludeC-45TypesC-45String-C-43C-43 "export LD_LIBRARY_PATH=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ":$LD_LIBRARY_PATH\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 "export DYLD_LIBRARY_PATH=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ":$DYLD_LIBRARY_PATH\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\" -q " (PreludeC-45TypesC-45String-C-43C-43 "--libdirs \"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "\" " (PreludeC-45TypesC-45String-C-43C-43 "--program \"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "\" " "\"$@\""))))))))) '())))))))
(define CompilerC-45SchemeC-45ChezSep-schHeader (lambda (arg-0 arg-1) (DataC-45String-fastUnlines (cons (PreludeC-45TypesC-45String-C-43C-43 "(import (chezscheme) (support) " (PreludeC-45TypesC-45String-C-43C-43 (DataC-45String-unwords (PreludeC-45Types-u--C-62C-62C-61_Monad_List arg-1 (lambda (u--cu) (PreludeC-45Types-u--pure_Applicative_List (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 u--cu ")")))))) ")")) (cons "(case (machine-type)" (cons "  [(i3le ti3le a6le ta6le tarm64le) (load-shared-object \"libc.so.6\")]" (cons "  [(i3osx ti3osx a6osx ta6osx tarm64osx) (load-shared-object \"libc.dylib\")]" (cons "  [(i3nt ti3nt a6nt ta6nt) (load-shared-object \"msvcrt.dll\")" (cons "                           (load-shared-object \"ws2_32.dll\")]" (cons "  [else (load-shared-object \"libc.so\")]" (cons (DataC-45String-fastUnlines (PreludeC-45Types-u--C-62C-62C-61_Monad_List arg-0 (lambda (u--lib) (PreludeC-45Types-u--pure_Applicative_List (PreludeC-45TypesC-45String-C-43C-43 "  (load-shared-object \"" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45String-escapeStringChez u--lib) "\")")))))) (cons ")" '()))))))))))))
(define CompilerC-45SchemeC-45ChezSep-schFooter(blodwen-lazy (lambda () "(collect 4)\xa;(blodwen-run-finalisers)\xa;")))
(define CompilerC-45SchemeC-45ChezSep-makeShWindows (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--cmdFile (PreludeC-45TypesC-45String-C-43C-43 arg-1 ".cmd"))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-writeFile u--cmdFile (CompilerC-45SchemeC-45ChezSep-startChezCmd arg-0 arg-2 arg-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Core-writeFile arg-1 (CompilerC-45SchemeC-45ChezSep-startChezWinSh arg-0 arg-2 arg-3) eta-0))))))))
(define CompilerC-45SchemeC-45ChezSep-makeSh (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (CoreC-45Core-writeFile arg-1 (CompilerC-45SchemeC-45ChezSep-startChez arg-0 arg-2 arg-3) ext-0)))
(define CompilerC-45SchemeC-45ChezSep-executeExpr (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CompilerC-45SchemeC-45ChezSep-compileExpr 0 arg-0 arg-1 arg-1 arg-2 "_tmpchez" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "compileExpr returned Nothing") ext-0) (let ((e-1 (unbox e-5))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((System-system (csegen-3) e-1) eta-0))) (vector 1 act-25))) ext-0)))))))))
(define CompilerC-45SchemeC-45ChezSep-compileToSS (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Context-getDirectives arg-0 (vector 0 ) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Chez-findLibs arg-0 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45Common-copyLib eta-0)) e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (CompilerC-45SchemeC-45Chez-chezVersion arg-1 ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CompilerC-45Common-getCompileData arg-0 0 0 arg-3 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--ctm (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-9 0))) e-0)))) (let ((u--ndefs (let ((e-1 (vector-ref e-9 1))) e-1))) (let ((u--cui (CompilerC-45Separate-getCompilationUnits (lambda (eta-0) (CompilerC-45Separate-u--nsRefs_HasNamespaces_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36aC-41C-124C-41 (lambda (eta-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedDef eta-1)) eta-0)) u--ndefs))) (let ((act-29 (CoreC-45Directory-readDataFile arg-0 "chez/support-sep.ss" ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--supportHash (PreludeC-45Show-u--show_Show_Int (CoreC-45Hash-u--hash_Hashable_String e-10)))) (let ((act-30 (let ((act-30 (let ((act-30 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "support.hash")) ext-0))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (case (vector-ref e-11 0) ((0) (vector 1 1)) (else (let ((e-12 (vector-ref e-11 1))) (vector 1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-12 u--supportHash))))))))))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (cond ((equal? e-11 1) (let ((act-31 (CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "support.ss") e-10 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "support.hash") u--supportHash ext-0))))) (else (vector 1 0))))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 ((PreludeC-45Basics-flip (csegen-1822) (let ((e-1 (vector-ref u--cui 0))) e-1) (lambda (u--cu) (let ((u--chezLib (CompilerC-45SchemeC-45ChezSep-chezLibraryName u--cu))) (let ((u--cuHash (PreludeC-45Show-u--show_Show_Int (CompilerC-45Separate-u--hash_Hashable_C-40CompilationUnitC-32C-36defC-41 (cons (lambda (arg-567) (CompilerC-45Separate-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 (csegen-3837) arg-567)) (lambda (arg-568) (lambda (arg-569) (CompilerC-45Separate-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 (csegen-3837) arg-568 arg-569)))) u--cu)))) (lambda (eta-0) (let ((act-32 (let ((act-32 (let ((act-32 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--chezLib "hash"))) eta-0))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (case (vector-ref e-13 0) ((0) (vector 1 1)) (else (let ((e-14 (vector-ref e-13 1))) (vector 1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-14 u--cuHash))))))))))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (cond ((equal? e-13 1) (let ((act-33 (let ((act-33 (unbox arg-0))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Loaded" ) (csegen-3840) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (let ((act-35 (CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Structs" ) '() eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (let ((u--imports (DataC-45String-unwords (PreludeC-45Types-u--C-62C-62C-61_Monad_List (LibrariesC-45DataC-45SortedSet-toList (let ((e-3 (vector-ref u--cu 2))) e-3)) (lambda (u--cuid) (PreludeC-45Types-u--pure_Applicative_List (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-maybe (lambda () "unqualified") (lambda () (lambda (eta-1) (CompilerC-45SchemeC-45ChezSep-chezLibraryName eta-1))) (LibrariesC-45DataC-45SortedMap-lookup u--cuid (let ((e-2 (vector-ref u--cui 1))) e-2))) ")")))))))) (let ((u--exports (DataC-45String-unwords (PreludeC-45Interfaces-concat (csegen-50) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (let ((e-4 (vector-ref u--cu 3))) e-4) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-17 (cdr e-3))) (PreludeC-45Types-u--pure_Applicative_List (case (vector-ref e-17 0) ((1) '())(else (cons (CompilerC-45SchemeC-45Common-schName e-2) '()))))))))))))) (let ((u--header (PreludeC-45TypesC-45String-C-43C-43 "(library (" (PreludeC-45TypesC-45String-C-43C-43 u--chezLib (PreludeC-45TypesC-45String-C-43C-43 ")\xa;" (PreludeC-45TypesC-45String-C-43C-43 "  (export " (PreludeC-45TypesC-45String-C-43C-43 u--exports (PreludeC-45TypesC-45String-C-43C-43 ")\xa;" (PreludeC-45TypesC-45String-C-43C-43 "  (import (chezscheme) (support) " (PreludeC-45TypesC-45String-C-43C-43 u--imports ")\xa;\xa;")))))))))) (let ((u--footer ")")) (let ((act-36 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Chez-getFgnCall arg-0 e-15 e-16 e-8 eta-1)) (let ((e-4 (vector-ref u--cu 3))) e-4) '() eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Common-getScheme arg-0 (csegen-3841) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezString eta-2)) eta-1)) (let ((e-4 (vector-ref u--cu 3))) e-4) '() eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-37 1))) (let ((act-38 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-loadLib arg-0 arg-2 eta-1 eta-2))) (DataC-45List-mapMaybe (lambda (eta-1) (Builtin-fst eta-1)) e-17) '() eta-0))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-38 1))) (let ((act-39 (CoreC-45ContextC-45Log-log arg-0 "compiler.scheme.chez" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Generating code for " u--chezLib)) eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((act-40 (CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--chezLib "ss")) (DataC-45String-fastAppend (PreludeC-45TypesC-45List-tailRecAppend (cons u--header '()) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-17) (PreludeC-45TypesC-45List-tailRecAppend e-18 (PreludeC-45TypesC-45List-tailRecAppend e-19 (cons u--footer '())))))) eta-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--chezLib "hash")) u--cuHash eta-0))))))))))))))))))))))))))))))))))) (else (vector 1 0))))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (vector 1 (cons u--chezLib e-13)))))))))))))) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) 0 u--ctm) ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "mainprog.ss") (DataC-45String-fastUnlines (cons (CompilerC-45SchemeC-45ChezSep-schHeader (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-6) (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-13 (lambda (u--lib) (PreludeC-45Types-u--pure_Applicative_List (let ((e-0 (car u--lib))) e-0))))) (cons "(collect-request-handler (lambda () (collect) (blodwen-run-finalisers)))" (cons e-14 (cons (CompilerC-45SchemeC-45ChezSep-schFooter) '()))))) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (vector 1 (cons e-11 e-13)))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45ChezSep-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 ((csegen-878) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") ext-0) (let ((u--appDirSh (PreludeC-45TypesC-45String-C-43C-43 arg-5 "_app"))) (let ((u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--appDirSh))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 (CoreC-45Directory-mkdirAll u--appDirRel eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 (CompilerC-45SchemeC-45Chez-findChez ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CompilerC-45SchemeC-45ChezSep-compileToSS arg-1 e-7 u--appDirRel arg-4 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((act-28 (CoreC-45ContextC-45Log-logTime arg-1 (lambda () "++ Make SO") (lambda (clam-0) (cond ((equal? arg-0 1) (let ((act-28 (cond ((equal? e-2 1) (let ((act-28 (CoreC-45ContextC-45Log-log arg-1 "compiler.scheme.chez" (+ 1 (+ 1 (+ 1 0))) (lambda () "Compiling support") clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (CompilerC-45SchemeC-45ChezSep-compileChezLibrary e-7 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel "support.ss") clam-0))))) (else (vector 1 0))))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CompilerC-45SchemeC-45ChezSep-compileChezLibraries e-7 u--appDirRel (PreludeC-45Types-u--C-62C-62C-61_Monad_List e-3 (lambda (u--lib) (PreludeC-45Interfaces-C-62C-62 (csegen-1193) (PreludeC-45Interfaces-guard (csegen-1201) (let ((e-4 (cdr u--lib))) e-4)) (lambda () (PreludeC-45Types-u--pure_Applicative_List (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (let ((e-0 (car u--lib))) e-0) "ss"))))))) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 ((PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45Core-traverse_ eta-0 eta-1 eta-2)))) e-3 (lambda (u--lib) (lambda (eta-0) (let ((act-30 (CoreC-45ContextC-45Log-log arg-1 "compiler.scheme.chez" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Touching " (let ((e-0 (car u--lib))) e-0))) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (CompilerC-45SchemeC-45ChezSep-touch (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (let ((e-0 (car u--lib))) e-0) "so")) eta-0))))))) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (CompilerC-45SchemeC-45ChezSep-compileChezProgram e-7 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel "mainprog.ss") clam-0))))))))))) (else (vector 1 0)))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((u--outShRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 arg-5))) (let ((u--launchTargetSh (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirSh (LibrariesC-45UtilsC-45Path-C-60C-46C-62 "mainprog" (cond ((equal? arg-0 1) "so") (else "ss")))))) (let ((act-29 (let ((sc7 (SystemC-45Info-isWindows))) (cond ((equal? sc7 1) ((CompilerC-45SchemeC-45ChezSep-makeShWindows e-7 u--outShRel u--appDirSh u--launchTargetSh) ext-0)) (else (CompilerC-45SchemeC-45ChezSep-makeSh e-7 u--outShRel u--appDirSh u--launchTargetSh ext-0)))))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-30 ((SystemC-45FileC-45Permissions-chmodRaw (csegen-3) u--outShRel (blodwen-toSignedInt 493 63)) eta-0))) (vector 1 act-30))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (vector 1 (box u--outShRel)))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45ChezSep-compileChezProgram (lambda (arg-0 arg-1 arg-2 ext-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-24 ((System-system (csegen-3) (DataC-45String-unwords (cons "echo" (cons (PreludeC-45TypesC-45String-C-43C-43 "'(parameterize ([optimize-level 3] [compile-file-message #f]) (compile-program " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-chezString arg-2) "))'")) (cons (PreludeC-45TypesC-45String-C-43C-43 "'(delete-file " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-chezString arg-2) ")'")) (cons "|" (cons arg-0 (cons "-q" (cons "--libdirs" (cons arg-1 '())))))))))) eta-0))) (vector 1 act-24))) ext-0)))
(define CompilerC-45SchemeC-45ChezSep-compileChezLibrary (lambda (arg-0 arg-1 arg-2 ext-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-24 ((System-system (csegen-3) (DataC-45String-unwords (cons "echo" (cons (PreludeC-45TypesC-45String-C-43C-43 "'(parameterize ([optimize-level 3] [compile-file-message #f]) (compile-library " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-chezString arg-2) "))'")) (cons (PreludeC-45TypesC-45String-C-43C-43 "'(delete-file " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-chezString arg-2) ")'")) (cons "|" (cons arg-0 (cons "-q" (cons "--libdirs" (cons arg-1 '())))))))))) eta-0))) (vector 1 act-24))) ext-0)))
(define CompilerC-45SchemeC-45ChezSep-compileChezLibraries (lambda (arg-0 arg-1 arg-2 ext-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-24 ((System-system (csegen-3) (DataC-45String-unwords (cons "echo" (cons (DataC-45String-unwords (PreludeC-45Types-u--C-62C-62C-61_Monad_List arg-2 (lambda (u--ssFile) (PreludeC-45Types-u--pure_Applicative_List (PreludeC-45TypesC-45String-C-43C-43 "'(parameterize ([optimize-level 3] [compile-file-message #f]) (compile-library " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-chezString u--ssFile) (PreludeC-45TypesC-45String-C-43C-43 "))'" (PreludeC-45TypesC-45String-C-43C-43 " '(delete-file " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-chezString u--ssFile) ")'"))))))))) (cons "|" (cons arg-0 (cons "-q" (cons "--libdirs" (cons arg-1 '()))))))))) eta-0))) (vector 1 act-24))) ext-0)))
(define CompilerC-45SchemeC-45ChezSep-codegenChezSep(blodwen-lazy (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CompilerC-45SchemeC-45ChezSep-compileExpr 1 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45ChezSep-executeExpr eta-0 eta-1 eta-2 eta-3))))) '() '()))))
(define CompilerC-45SchemeC-45ChezSep-chezNS (lambda (arg-0) (CompilerC-45SchemeC-45ChezSep-case--chezNS-923 arg-0 (CoreC-45NameC-45Namespace-showNSWithSep "-" arg-0))))
(define CompilerC-45SchemeC-45ChezSep-chezLibraryName (lambda (arg-1) (CompilerC-45SchemeC-45ChezSep-chezNS (CompilerC-45SchemeC-45ChezSep-n--9904-936-u--min1 arg-1 (let ((e-2 (vector-ref arg-1 1))) e-2)))))
(define CompilerC-45Separate-n--7018-1523-u--withCUID (lambda (arg-1 arg-2 arg-4) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (DataC-45List-u--zip_Zippable_List (PreludeC-45Types-u--rangeFromTo_Range_Nat 0 (PreludeC-45TypesC-45List-length arg-4)) arg-4) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_List (cons (PreludeC-45Cast-u--cast_Cast_Nat_Int e-2) e-3))))))))
(define CompilerC-45Separate-n--7018-1524-u--mkUnit (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (vector arg-6 arg-7 (LibrariesC-45DataC-45SortedSet-delete arg-6 (CompilerC-45Separate-n--7025-1584-u--dependencies arg-1 arg-2 arg-7 arg-6 arg-5 arg-4 arg-3)) (CompilerC-45Separate-n--7025-1585-u--definitions arg-1 arg-2 arg-7 arg-6 arg-5 arg-4 arg-3))))
(define CompilerC-45Separate-n--7025-1584-u--dependencies (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45SortedSet-fromList (csegen-3849) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (DataC-45List1-forget arg-3) (lambda (u--ns) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (LibrariesC-45DataC-45SortedSet-toList (DataC-45Maybe-fromMaybe (lambda () (csegen-3860)) (LibrariesC-45DataC-45SortedMap-lookup u--ns arg-7))) (lambda (u--depsNS) (let ((sc0 (LibrariesC-45DataC-45SortedMap-lookup u--depsNS arg-6))) (if (null? sc0) '() (let ((e-2 (unbox sc0))) (cons e-2 '())))))))))))
(define CompilerC-45Separate-n--7025-1585-u--definitions (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (PreludeC-45Interfaces-concat (csegen-3271) (DataC-45List1-u--C-62C-62C-61_Monad_List1 arg-3 (lambda (u--ns) (DataC-45List1-u--pure_Applicative_List1 (DataC-45Maybe-fromMaybe (lambda () '()) (LibrariesC-45DataC-45SortedMap-lookup u--ns arg-5))))))))
(define CompilerC-45Separate-n--6307-849-u--addOne (lambda (arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45SortedMap-mergeWith (csegen-2473) (LibrariesC-45DataC-45SortedMap-singleton (csegen-3217) (CompilerC-45Separate-getNS e-2) (let ((u--ndef (cons e-2 e-3))) (cons u--ndef '()))) arg-1)))))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-1))) ((1) (csegen-3860)) ((2) (csegen-3860)) (else (let ((e-8 (vector-ref arg-0 1))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-8))))))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedConstAlt (lambda (arg-0) (let ((e-1 (cdr arg-0))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-1))))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedConAlt (lambda (arg-0) (let ((e-4 (vector-ref arg-0 4))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-4))))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (csegen-3860)) ((1) (let ((e-3 (vector-ref arg-0 2))) (LibrariesC-45DataC-45SortedSet-singleton (csegen-3217) (CompilerC-45Separate-getNS e-3)))) ((2) (let ((e-6 (vector-ref arg-0 3))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-6))) ((3) (let ((e-9 (vector-ref arg-0 3))) (let ((e-10 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-3217) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-9) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-10))))) ((4) (let ((e-12 (vector-ref arg-0 2))) (let ((e-13 (vector-ref arg-0 3))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-3217) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-12) (PreludeC-45Interfaces-concatMap (csegen-3861) (lambda (arg-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp arg-1)) e-13))))) ((5) (let ((e-18 (vector-ref arg-0 5))) (PreludeC-45Interfaces-concatMap (csegen-3861) (lambda (arg-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp arg-1)) e-18))) ((8) (let ((e-21 (vector-ref arg-0 3))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-21))) ((9) (let ((e-24 (vector-ref arg-0 3))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-24))) ((13) (csegen-3860)) ((12) (csegen-3860)) ((6) (let ((e-31 (vector-ref arg-0 4))) (PreludeC-45Interfaces-concatMap (cons (csegen-1006) (csegen-3862)) (lambda (arg-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp arg-1)) e-31))) ((7) (let ((e-34 (vector-ref arg-0 3))) (PreludeC-45Interfaces-concatMap (csegen-3861) (lambda (arg-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp arg-1)) e-34))) ((10) (let ((e-36 (vector-ref arg-0 2))) (let ((e-37 (vector-ref arg-0 3))) (let ((e-38 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-3217) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-3217) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-36) (PreludeC-45Interfaces-concatMap (csegen-3861) (lambda (arg-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedConAlt arg-1)) e-37)) (PreludeC-45Interfaces-concatMap (csegen-3866) (lambda (arg-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp arg-1)) e-38)))))) ((11) (let ((e-40 (vector-ref arg-0 2))) (let ((e-41 (vector-ref arg-0 3))) (let ((e-42 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-3217) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (csegen-3217) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-40) (PreludeC-45Interfaces-concatMap (csegen-3861) (lambda (arg-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedConstAlt arg-1)) e-41)) (PreludeC-45Interfaces-concatMap (csegen-3866) (lambda (arg-1) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp arg-1)) e-42)))))) (else (csegen-3860)))))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36aC-41C-124C-41 (lambda (arg-1 arg-2) (let ((e-3 (cdr arg-2))) (arg-1 e-3))))
(define CompilerC-45Separate-u--min_Ord_CompilationUnitId (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45Separate-u--C-60_Ord_CompilationUnitId arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CompilerC-45Separate-u--max_Ord_CompilationUnitId (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45Separate-u--C-62_Ord_CompilationUnitId arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CompilerC-45Separate-u--hash_Hashable_CompilationUnitId (lambda (ext-0) (CompilerC-45Separate-u--hashWithSalt_Hashable_CompilationUnitId (blodwen-toSignedInt 5381 63) ext-0)))
(define CompilerC-45Separate-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 (lambda (arg-1 ext-0) (CompilerC-45Separate-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 arg-1 (blodwen-toSignedInt 5381 63) ext-0)))
(define CompilerC-45Separate-u--hash_Hashable_C-40CompilationUnitC-32C-36defC-41 (lambda (arg-1 ext-0) (CompilerC-45Separate-u--hashWithSalt_Hashable_C-40CompilationUnitC-32C-36defC-41 arg-1 (blodwen-toSignedInt 5381 63) ext-0)))
(define CompilerC-45Separate-u--hashWithSalt_Hashable_CompilationUnitId (lambda (arg-0 arg-1) (CoreC-45Hash-u--hashWithSalt_Hashable_Int arg-0 arg-1)))
(define CompilerC-45Separate-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 (lambda (arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (let ((e-4 (cdr arg-1))) ((e-4 arg-2) e-3)))))
(define CompilerC-45Separate-u--hashWithSalt_Hashable_C-40CompilationUnitC-32C-36defC-41 (lambda (arg-1 arg-2 arg-3) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-567) (CoreC-45Hash-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-817) arg-1 arg-567)) (lambda (arg-568) (lambda (arg-569) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-817) arg-1 arg-568 arg-569)))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-567) (CompilerC-45Separate-u--hash_Hashable_CompilationUnitId arg-567)) (lambda (arg-568) (lambda (arg-569) (CompilerC-45Separate-u--hashWithSalt_Hashable_CompilationUnitId arg-568 arg-569)))) arg-2 (LibrariesC-45DataC-45SortedSet-toList (let ((e-3 (vector-ref arg-3 2))) e-3))) (let ((e-4 (vector-ref arg-3 3))) e-4))))
(define CompilerC-45Separate-u--compare_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Int arg-0 arg-1)))
(define CompilerC-45Separate-u--C-62_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-0 arg-1) 2)))
(define CompilerC-45Separate-u--C-62C-61_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-0 arg-1) 0)))
(define CompilerC-45Separate-u--C-61C-61_Eq_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-0 arg-1)))
(define CompilerC-45Separate-u--C-60_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-0 arg-1) 0)))
(define CompilerC-45Separate-u--C-60C-61_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-0 arg-1) 2)))
(define CompilerC-45Separate-u--C-47C-61_Eq_CompilationUnitId (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45Separate-u--C-61C-61_Eq_CompilationUnitId arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CompilerC-45Separate-splitByNS (lambda (ext-0) (LibrariesC-45DataC-45SortedMap-toList (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45Separate-n--6307-849-u--addOne eta-0 eta-1))) (csegen-3870) ext-0))))
(define CompilerC-45Separate-getNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0))(else (CoreC-45NameC-45Namespace-emptyNS)))))
(define CompilerC-45Separate-getCompilationUnits (lambda (arg-1 arg-2) (let ((u--defsByNS (LibrariesC-45DataC-45SortedMap-fromList (csegen-3217) (CompilerC-45Separate-splitByNS arg-2)))) (let ((u--nsDeps (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45SortedMap-mergeWith (csegen-3192) eta-0 eta-1))) (csegen-3870) (PreludeC-45Types-u--C-62C-62C-61_Monad_List arg-2 (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_List (LibrariesC-45DataC-45SortedMap-singleton (csegen-3217) (CompilerC-45Separate-getNS e-2) (LibrariesC-45DataC-45SortedSet-delete (CompilerC-45Separate-getNS e-2) (arg-1 e-3))))))))))) (let ((u--components (PreludeC-45TypesC-45List-reverse (LibrariesC-45DataC-45Graph-tarjan (csegen-3217) u--nsDeps)))) (let ((u--nsMap (LibrariesC-45DataC-45SortedMap-fromList (csegen-3217) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (CompilerC-45Separate-n--7018-1523-u--withCUID arg-1 arg-2 u--components) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List (DataC-45List1-forget e-3) (lambda (u--ns) (PreludeC-45Types-u--pure_Applicative_List (cons u--ns e-2))))))))))) (let ((u--units (PreludeC-45Types-u--C-62C-62C-61_Monad_List (CompilerC-45Separate-n--7018-1523-u--withCUID arg-1 arg-2 u--components) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_List (CompilerC-45Separate-n--7018-1524-u--mkUnit arg-1 arg-2 u--nsDeps u--nsMap u--defsByNS e-2 e-3)))))))) (vector u--units (LibrariesC-45DataC-45SortedMap-fromList (csegen-3849) (PreludeC-45Types-u--C-62C-62C-61_Monad_List u--units (lambda (u--unit) (PreludeC-45Types-u--pure_Applicative_List (cons (let ((e-1 (vector-ref u--unit 0))) e-1) u--unit))))) u--nsMap))))))))
(define CompilerC-45SchemeC-45Chez-n--10579-2444-u--showFld (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((CompilerC-45SchemeC-45Chez-cftySpec (CoreC-45FC-emptyFC) e-3) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-5 "]")))))))))))))
(define CompilerC-45SchemeC-45Chez-n--9690-1666-u--notWorld (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((18) 0)(else 1))))
(define CompilerC-45SchemeC-45Chez-n--9690-1662-u--mkNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((18) (cons '() (CompilerC-45SchemeC-45Chez-n--9690-1662-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)))(else (cons (box (PreludeC-45TypesC-45String-C-43C-43 "cb" (PreludeC-45Show-u--show_Show_Int arg-8))) (CompilerC-45SchemeC-45Chez-n--9690-1662-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (bs+ arg-8 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Chez-n--9690-1665-u--mkFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--argns (CompilerC-45SchemeC-45Chez-n--9690-1662-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 0 arg-8))) (PreludeC-45TypesC-45String-C-43C-43 "(lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (DataC-45List-mapMaybe (lambda (eta-0) eta-0) u--argns)) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-n--9690-1663-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-10 u--argns) ")")))))))
(define CompilerC-45SchemeC-45Chez-n--8735-684-u--isLib (lambda (arg-0 arg-1 arg-2) (let ((sc0 (DataC-45String-isPrefixOf "lib" arg-2))) (cond ((equal? sc0 1) (box (DataC-45String-trim (PreludeC-45Types-substr (+ 1 (+ 1 (+ 1 0))) (PreludeC-45TypesC-45String-length arg-2) arg-2)))) (else '())))))
(define CompilerC-45SchemeC-45Chez-n--8611-567-u--cmd (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 arg-0 " --version 2>&1")))
(define CompilerC-45SchemeC-45Chez-n--9690-1667-u--callback (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((19) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (CompilerC-45SchemeC-45Chez-n--9690-1667-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-0 arg-9) e-1))))(else (let ((u--args (PreludeC-45TypesC-45List-reverse arg-9))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Chez-cftySpec arg-5 eta-1)) (DataC-45List-filter (lambda (eta-1) (CompilerC-45SchemeC-45Chez-n--9690-1666-u--notWorld arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-1)) u--args) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Chez-cftySpec arg-5 arg-10) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(let ([c-code (foreign-callable #f " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-n--9690-1665-u--mkFun arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--args arg-10 arg-8) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-5) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 ")])" " (lock-object c-code) (foreign-callable-entry-point c-code))"))))))))))))))))))))))
(define CompilerC-45SchemeC-45Chez-n--9690-1668-u--buildArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-3 0) ((19) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (CompilerC-45SchemeC-45Chez-n--9690-1667-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (CompilerC-45SchemeC-45Common-schName e-2) (cons e-4 '()) e-5)))) ((15) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(car " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-2) ")")))))(else (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-schName e-2)))))))))
(define CompilerC-45SchemeC-45Chez-n--9690-1663-u--applyLams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) arg-8 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (if (null? e-2) (CompilerC-45SchemeC-45Chez-n--9690-1663-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-8 " #f)")) e-3) (let ((e-6 (unbox e-2))) (CompilerC-45SchemeC-45Chez-n--9690-1663-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-8 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")")))) e-3))))))))
(define CompilerC-45SchemeC-45Chez-useCC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((sc0 (CompilerC-45Common-parseCC (cons "scheme,chez" (cons "scheme" (cons "C__collect_safe" (cons "C" '())))) arg-3))) (if (null? sc0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) eta-0)) (let ((e-1 (unbox sc0))) (if (null? e-1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) eta-0)) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (cond ((equal? e-4 "scheme,chez") (lambda (clam-0) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) clam-0) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (let ((act-24 ((CompilerC-45SchemeC-45Chez-schemeCall arg-2 e-7 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-4) arg-5) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (cons '() e-6)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) clam-0))))))) ((equal? e-4 "scheme") (lambda (clam-1) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) clam-1) (let ((e-11 (car e-5))) (let ((e-12 (cdr e-5))) (if (null? e-12) (let ((act-24 ((CompilerC-45SchemeC-45Chez-schemeCall arg-2 e-11 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) arg-4) arg-5) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (cons '() e-6)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) clam-1))))))) ((equal? e-4 "C__collect_safe") (if (null? e-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) eta-0)) (let ((e-15 (car e-5))) (let ((e-16 (cdr e-5))) (if (null? e-16) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) eta-0)) (let ((e-18 (car e-16))) (let ((sc5 (CompilerC-45SchemeC-45Chez-unsupportedCallingConvention arg-6))) (cond ((equal? sc5 1) (CompilerC-45SchemeC-45Chez-cCall arg-0 arg-1 arg-2 e-15 e-18 arg-4 arg-5 0)) (else (CompilerC-45SchemeC-45Chez-cCall arg-0 arg-1 arg-2 e-15 e-18 arg-4 arg-5 1)))))))))) ((equal? e-4 "C") (if (null? e-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) eta-0)) (let ((e-21 (car e-5))) (let ((e-22 (cdr e-5))) (if (null? e-22) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) eta-0)) (let ((e-24 (car e-22))) (CompilerC-45SchemeC-45Chez-cCall arg-0 arg-1 arg-2 e-21 e-24 arg-4 arg-5 0)))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 arg-2 arg-3) eta-0))))))))))))
(define CompilerC-45SchemeC-45Chez-unsupportedCallingConvention (lambda (arg-0) (if (null? arg-0) 1 (let ((e-2 (unbox arg-0))) (LibrariesC-45DataC-45Version-u--C-60_Ord_Version e-2 (cons (cons (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))) (cons (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))) 0)) '()))))))
(define CompilerC-45SchemeC-45Chez-startChezWinSh (lambda (arg-0 arg-1 arg-2 arg-3) (DataC-45String-fastUnlines (cons "#!/bin/sh" (cons (PreludeC-45TypesC-45String-C-43C-43 "# " (CompilerC-45Generated-generatedString "Chez")) (cons "" (cons "set -e # exit on any error" (cons "" (cons "DIR=$(dirname \"$(readlink -f -- \"$0\" || cygpath -a -- \"$0\")\")" (cons (PreludeC-45TypesC-45String-C-43C-43 "PATH=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ":$PATH\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 "export IDRIS2_INC_SRC=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 "\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\" " (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 " \"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-2 "\" \"$@\"")))))) '()))))))))))))
(define CompilerC-45SchemeC-45Chez-startChezPreamble(blodwen-lazy (lambda () (DataC-45String-fastUnlines (cons "#!/bin/sh" (cons (PreludeC-45TypesC-45String-C-43C-43 "# " (CompilerC-45Generated-generatedString "Chez")) (cons "" (cons "set -e # exit on any error" (cons "" (cons "if [ \"$(uname)\" = Darwin ]; then" (cons "  DIR=$(zsh -c 'printf %s \"$0:A:h\"' \"$0\")" (cons "else" (cons "  DIR=$(dirname \"$(readlink -f -- \"$0\")\")" (cons "fi" (cons "" '())))))))))))))))
(define CompilerC-45SchemeC-45Chez-startChezCmd (lambda (arg-0 arg-1 arg-2 arg-3) (DataC-45String-fastUnlines (cons "@echo off" (cons "set APPDIR=%~dp0" (cons (PreludeC-45TypesC-45String-C-43C-43 "set PATH=%APPDIR%" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ";%PATH%")) (cons (PreludeC-45TypesC-45String-C-43C-43 "set IDRIS2_INC_SRC=%APPDIR%" arg-1) (cons (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "\" " (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 " \"%APPDIR%" (PreludeC-45TypesC-45String-C-43C-43 arg-2 "\" %*")))))) '()))))))))
(define CompilerC-45SchemeC-45Chez-startChez (lambda (arg-0 arg-1) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-startChezPreamble) (DataC-45String-fastUnlines (cons (PreludeC-45TypesC-45String-C-43C-43 "export LD_LIBRARY_PATH=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-0 ":$LD_LIBRARY_PATH\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 "export DYLD_LIBRARY_PATH=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-0 ":$DYLD_LIBRARY_PATH\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 "export IDRIS2_INC_SRC=\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-0 "\"")) (cons (PreludeC-45TypesC-45String-C-43C-43 "\"$DIR/" (PreludeC-45TypesC-45String-C-43C-43 arg-1 "\" \"$@\"")) '()))))))))
(define CompilerC-45SchemeC-45Chez-showChezString (lambda (arg-0) (lambda (clam-0) (if (null? arg-0) clam-0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-2 #\") (PreludeC-45TypesC-45String-C-43C-43 "\\\"" ((CompilerC-45SchemeC-45Chez-showChezString e-3) clam-0)))(else ((CompilerC-45SchemeC-45Chez-showChezChar e-2) ((CompilerC-45SchemeC-45Chez-showChezString e-3) clam-0))))))))))
(define CompilerC-45SchemeC-45Chez-showChezChar (lambda (arg-0) (lambda (clam-0) (cond ((equal? arg-0 #\\) (PreludeC-45TypesC-45String-C-43C-43 "\\\\" clam-0))(else (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-0 (PreludeC-45Types-chr 32)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-0 (PreludeC-45Types-chr (blodwen-toSignedInt 126 63)))))))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 "\\x" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-0)) ";")) clam-0)) (else (PreludeC-45Types-strCons arg-0 clam-0)))))))))
(define CompilerC-45SchemeC-45Chez-schemeCall (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--call (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45SchemeC-45Common-schName eta-0)) arg-2)) ")")))))) (lambda (clam-0) (case (vector-ref arg-3 0) ((20) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld u--call)))(else (vector 1 u--call)))))))
(define CompilerC-45SchemeC-45Chez-schHeader (lambda (arg-0 arg-1 arg-2) (PreludeC-45TypesC-45String-C-43C-43 (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_String (SystemC-45Info-os) "windows"))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 "#!" (PreludeC-45TypesC-45String-C-43C-43 arg-0 (cond ((equal? arg-2 1) " --program\xa;\xa;") (else " --script\xa;\xa;"))))) (else ""))) (PreludeC-45TypesC-45String-C-43C-43 "; " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45Generated-generatedString "Chez") (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(import (chezscheme))\xa;" (PreludeC-45TypesC-45String-C-43C-43 "(case (machine-type)\xa;" (PreludeC-45TypesC-45String-C-43C-43 "  [(i3fb ti3fb a6fb ta6fb) #f]\xa;" (PreludeC-45TypesC-45String-C-43C-43 "  [(i3le ti3le a6le ta6le tarm64le) (load-shared-object \"libc.so.6\")]\xa;" (PreludeC-45TypesC-45String-C-43C-43 "  [(i3osx ti3osx a6osx ta6osx tarm64osx) (load-shared-object \"libc.dylib\")]\xa;" (PreludeC-45TypesC-45String-C-43C-43 "  [(i3nt ti3nt a6nt ta6nt) (load-shared-object \"msvcrt.dll\")]\xa;" (PreludeC-45TypesC-45String-C-43C-43 "  [else (load-shared-object \"libc.so\")])\xa;\xa;" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (u--x) (PreludeC-45TypesC-45String-C-43C-43 "(load-shared-object \"" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45String-escapeStringChez u--x) "\")"))) arg-1)) (PreludeC-45TypesC-45String-C-43C-43 "\xa;\xa;" (cond ((equal? arg-2 1) "(let ()\xa;") (else "(source-directories (cons (getenv \"IDRIS2_INC_SRC\") (source-directories)))\xa;")))))))))))))))))
(define CompilerC-45SchemeC-45Chez-schFooter (lambda (arg-0 arg-1) (PreludeC-45TypesC-45String-C-43C-43 "(collect 4)\xa;(blodwen-run-finalisers)\xa;" (PreludeC-45TypesC-45String-C-43C-43 (cond ((equal? arg-0 1) "(profile-dump-html)") (else "")) (cond ((equal? arg-1 1) ")\xa;") (else "\xa;"))))))
(define CompilerC-45SchemeC-45Chez-schFgnDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((2) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (let ((u--argns (CompilerC-45SchemeC-45Chez-mkArgs 0 e-1))) (let ((u--allargns (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) u--argns))) (let ((u--useargns (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (DataC-45List-filter (lambda (eta-0) (Builtin-snd eta-0)) u--argns)))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Chez-mkStruct arg-2 eta-1)) e-1 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Chez-mkStruct arg-2 e-2) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CompilerC-45SchemeC-45Chez-useCC arg-0 arg-1 arg-3 e-0 (DataC-45List-u--zip_Zippable_List u--useargns e-1) e-2 arg-6) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-27 (let ((act-27 (unbox arg-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-u--full_HasNames_Name (let ((e-39 (vector-ref e-8 0))) e-39) arg-4 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (cons e-4 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-5) (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 "(define " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-9) (PreludeC-45TypesC-45String-C-43C-43 " (lambda (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CompilerC-45SchemeC-45Common-schName eta-1)) u--allargns)) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-3 "))\xa;"))))))))))))))))))))))))))))))))))))))))(else (csegen-3794)))))
(define CompilerC-45SchemeC-45Chez-mkStruct (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((21) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Chez-mkStruct arg-0 eta-1)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (Builtin-snd eta-1)) e-1) '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc3 (PreludeC-45Types-elem (csegen-17) e-0 e-6))) (cond ((equal? sc3 1) (vector 1 (PreludeC-45Interfaces-concat (csegen-67) e-5))) (else (let ((act-26 (let ((act-26 (set-box! arg-0 (cons e-0 e-6)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-n--10579-2444-u--showFld e-1 e-0 arg-0 eta-1 eta-2))) e-1 '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-5) (PreludeC-45TypesC-45String-C-43C-43 "(define-ftype " (PreludeC-45TypesC-45String-C-43C-43 e-0 (PreludeC-45TypesC-45String-C-43C-43 " (struct\xa;\x9;" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "\xa;\x9;" e-8) "))\xa;")))))))))))))))))))))))))))) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Chez-mkStruct arg-0 e-2))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (CompilerC-45SchemeC-45Chez-mkStruct arg-0 e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CompilerC-45SchemeC-45Chez-mkStruct arg-0 e-4) eta-0))))))))(else (lambda (eta-0) (vector 1 ""))))))
(define CompilerC-45SchemeC-45Chez-mkArgs (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((18) (cons (cons (vector 2 "farg" arg-0) 0) (CompilerC-45SchemeC-45Chez-mkArgs arg-0 e-3)))(else (cons (cons (vector 2 "farg" arg-0) 1) (CompilerC-45SchemeC-45Chez-mkArgs (bs+ arg-0 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Chez-makeShWindows (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--cmdFile (PreludeC-45TypesC-45String-C-43C-43 arg-1 ".cmd"))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) u--cmdFile (CompilerC-45SchemeC-45Chez-startChezCmd arg-0 arg-2 arg-3 arg-4)) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (let ((act-25 (let ((act-25 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-1 (CompilerC-45SchemeC-45Chez-startChezWinSh arg-0 arg-2 arg-3 arg-4)) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((e-3 (vector-ref e-6 1))) (cond (else (vector 1 0))))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 e-7) eta-0)))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--cmdFile e-6) eta-0))))))))))))
(define CompilerC-45SchemeC-45Chez-makeSh (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-0 (CompilerC-45SchemeC-45Chez-startChez arg-1 arg-2)) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (vector 1 0))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 e-6) ext-0))))))))))
(define CompilerC-45SchemeC-45Chez-loadSO (lambda (arg-0 arg-1 arg-2 ext-0) (cond ((equal? arg-2 "") (vector 1 ""))(else (let ((act-24 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fs (PreludeC-45Types-u--map_Functor_List (lambda (u--p) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--p arg-2)) (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref e-5 2))) e-2) "ttc") (let ((e-6 (vector-ref e-5 6))) e-6))))) (let ((act-25 (CoreC-45Directory-firstAvailable arg-0 u--fs ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Missing .so:" arg-2)) ext-0) (let ((e-1 (unbox e-6))) (let ((u--modfname (PreludeC-45Types-fastConcat (DataC-45List-intersperse "-" (LibrariesC-45UtilsC-45Path-splitPath arg-2))))) (let ((act-26 ((CompilerC-45Common-copyLib (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 u--modfname) e-1)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(load \"" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45String-escapeStringChez u--modfname) "\")\xa;"))))))))))))))))))))))
(define CompilerC-45SchemeC-45Chez-loadLib (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((CompilerC-45Common-locate arg-0 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-25 ((CompilerC-45Common-copyLib (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 e-2) e-3)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(load-shared-object \"" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45String-escapeStringChez e-2) "\")\xa;"))))))))))))))
(define CompilerC-45SchemeC-45Chez-incCompile (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Directory-getTTCFileName arg-0 arg-1 "ss" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Directory-getTTCFileName arg-0 arg-1 "so" ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Directory-getObjFileName arg-0 arg-1 "so" ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CompilerC-45Common-getIncCompileData arg-0 0 0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--outputDir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref e-9 2))) e-2) "ttc"))) (let ((u--ndefs (let ((e-1 (vector-ref e-8 1))) e-1))) (let ((sc5 (DataC-45List-isNil u--ndefs))) (cond ((equal? sc5 1) (vector 1 (box (cons "" '())))) (else (let ((act-29 (CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Loaded" ) (csegen-3840) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Structs" ) '() ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (CompilerC-45SchemeC-45Chez-findChez ext-0))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (CompilerC-45SchemeC-45Chez-chezVersion e-12 ext-0))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Chez-getFgnCall arg-0 e-10 e-11 e-13 eta-0)) u--ndefs '() ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScheme arg-0 (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) eta-0)) u--ndefs '() ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (let ((u--code (DataC-45String-fastAppend (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-14) e-15)))) (let ((act-35 (let ((act-35 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) e-5 u--code) ext-0))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (case (vector-ref e-16 0) ((1) (let ((e-2 (vector-ref e-16 1))) (cond (else (let ((u--tmpFileAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--outputDir "compileChez"))) (let ((u--build (PreludeC-45TypesC-45String-C-43C-43 "(parameterize ([optimize-level 3] " (PreludeC-45TypesC-45String-C-43C-43 "[compile-file-message #f]) (compile-file " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-5) "))"))))) (let ((act-36 (let ((act-36 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) u--tmpFileAbs u--build) ext-0))) (vector 1 act-36)))) (case (vector-ref act-36 0) ((0) (let ((e-3 (vector-ref act-36 1))) (vector 0 e-3))) (else (let ((e-17 (vector-ref act-36 1))) (case (vector-ref e-17 0) ((1) (let ((e-3 (vector-ref e-17 1))) (cond (else (let ((act-37 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-37 ((System-system (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 e-12 (PreludeC-45TypesC-45String-C-43C-43 " --script \"" (PreludeC-45TypesC-45String-C-43C-43 u--tmpFileAbs "\"")))) eta-0))) (vector 1 act-37))) ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-4 (vector-ref act-37 1))) (vector 0 e-4))) (else (vector 1 (box (cons e-7 (DataC-45List-mapMaybe (lambda (eta-0) (Builtin-fst eta-0)) e-14))))))))))) (else (let ((e-18 (vector-ref e-17 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--tmpFileAbs e-18) ext-0)))))))))))))) (else (let ((e-17 (vector-ref e-16 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-5 e-17) ext-0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Chez-handleRet (lambda (arg-0 arg-1) (cond ((equal? arg-0 "void") (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 " " (CompilerC-45SchemeC-45Common-mkWorld (CompilerC-45SchemeC-45Common-schConstructor (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) (vector 1 (vector 0 "")) (box 0) '())))))(else (CompilerC-45SchemeC-45Common-mkWorld arg-1)))))
(define CompilerC-45SchemeC-45Chez-getFgnCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (CompilerC-45SchemeC-45Chez-schFgnDef arg-0 arg-1 arg-2 e-6 e-2 e-7 arg-3)))))))
(define CompilerC-45SchemeC-45Chez-findLibs (lambda (arg-0 arg-1) (let ((u--libs (DataC-45List-mapMaybe (lambda (eta-0) (CompilerC-45SchemeC-45Chez-n--8735-684-u--isLib arg-1 arg-0 (DataC-45String-trim eta-0))) arg-1))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Common-locate arg-0 eta-1)) (DataC-45List-nub (csegen-17) u--libs) '() eta-0)))))
(define CompilerC-45SchemeC-45Chez-findChez (lambda (ext-0) (let ((act-24 ((IdrisC-45Env-idrisGetEnv (csegen-3) "CHEZ" 0) ext-0))) (if (null? act-24) (let ((act-25 (LibrariesC-45UtilsC-45Path-pathLookup (cons "chez" (cons "chezscheme" (cons "chez-scheme" (cons "chezscheme9.5" (cons "scheme" '()))))) ext-0))) (DataC-45Maybe-fromMaybe (lambda () "/usr/bin/env scheme") act-25)) (let ((e-2 (unbox act-24))) e-2)))))
(define CompilerC-45SchemeC-45Chez-executeExpr (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CompilerC-45SchemeC-45Chez-compileExpr 0 arg-0 arg-1 arg-1 arg-2 "_tmpchez" ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "compileExpr returned Nothing") ext-0) (let ((e-1 (unbox e-5))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((System-system (csegen-3) e-1) eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 0))))))))))))
(define CompilerC-45SchemeC-45Chez-compileToSSInc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (CompilerC-45SchemeC-45Chez-findChez ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45Common-compileTerm arg-0 arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--ctm (CoreC-45CompileExpr-forget '() e-6))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-loadLib arg-0 arg-3 eta-0 eta-1))) (DataC-45List-nub (csegen-17) arg-2) '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-loadSO arg-0 arg-3 eta-0 eta-1))) (DataC-45List-nub (csegen-17) arg-1) '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) 0 u--ctm) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Directory-readDataFile arg-0 "chez/support.ss" ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((u--scm (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-schHeader e-5 '() 0) (PreludeC-45TypesC-45String-C-43C-43 e-10 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-7) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-8) (PreludeC-45TypesC-45String-C-43C-43 "(collect-request-handler (lambda () (collect) (blodwen-run-finalisers)))\xa;" (PreludeC-45TypesC-45String-C-43C-43 e-9 (CompilerC-45SchemeC-45Chez-schFooter 0 0))))))))) (let ((act-30 (let ((act-30 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-5 u--scm) ext-0))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (case (vector-ref e-11 0) ((1) (let ((e-2 (vector-ref e-11 1))) (cond (else (let ((act-31 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-31 ((SystemC-45FileC-45Permissions-chmodRaw (csegen-3) arg-5 (blodwen-toSignedInt 493 63)) eta-0))) (vector 1 act-31))) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (vector 1 0)))))))) (else (let ((e-12 (vector-ref e-11 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-5 e-12) ext-0))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Chez-compileToSS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Context-getDirectives arg-0 (vector 0 ) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Chez-findLibs arg-0 e-5) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45Common-copyLib eta-0)) e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CompilerC-45Common-getCompileData arg-0 0 0 arg-3 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--ndefs (let ((e-1 (vector-ref e-8 1))) e-1))) (let ((u--ctm (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-8 0))) e-0)))) (let ((act-28 (let ((act-28 (unbox arg-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Loaded" ) (csegen-3840) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Structs" ) '() ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (let ((act-31 (CompilerC-45SchemeC-45Chez-findChez ext-0))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 (CompilerC-45SchemeC-45Chez-chezVersion e-12 ext-0))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Chez-getFgnCall arg-0 e-10 e-11 e-13 eta-0)) u--ndefs '() ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((act-34 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-loadLib arg-0 arg-2 eta-0 eta-1))) (DataC-45List-mapMaybe (lambda (eta-0) (Builtin-fst eta-0)) e-14) '() ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (let ((act-35 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScheme arg-0 (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) eta-0)) u--ndefs '() ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-35 1))) (let ((u--code (DataC-45String-fastAppend (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-14) e-16)))) (let ((act-36 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) 0 u--ctm) ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-36 1))) (let ((act-37 (CoreC-45Directory-readDataFile arg-0 "chez/support.ss" ext-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-37 1))) (let ((act-38 (CompilerC-45Common-getExtraRuntime e-5 ext-0))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-38 1))) (let ((u--scm (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45SchemeC-45Chez-schHeader e-12 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) e-6) 1) (PreludeC-45TypesC-45String-C-43C-43 e-18 (PreludeC-45TypesC-45String-C-43C-43 e-19 (PreludeC-45TypesC-45String-C-43C-43 u--code (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) e-15) (PreludeC-45TypesC-45String-C-43C-43 "(collect-request-handler (lambda () (collect) (blodwen-run-finalisers)))\xa;" (PreludeC-45TypesC-45String-C-43C-43 e-17 (CompilerC-45SchemeC-45Chez-schFooter arg-1 1)))))))))) (let ((act-39 (let ((act-39 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-4 u--scm) ext-0))) (vector 1 act-39)))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-39 1))) (case (vector-ref e-20 0) ((1) (let ((e-2 (vector-ref e-20 1))) (cond (else (let ((act-40 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-40 ((SystemC-45FileC-45Permissions-chmodRaw (csegen-3) arg-4 (blodwen-toSignedInt 493 63)) eta-0))) (vector 1 act-40))) ext-0))) (case (vector-ref act-40 0) ((0) (let ((e-3 (vector-ref act-40 1))) (vector 0 e-3))) (else (vector 1 0)))))))) (else (let ((e-21 (vector-ref e-20 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 e-21) ext-0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Chez-compileToSO (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--tmpFileAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 "compileChez"))) (let ((u--build (PreludeC-45TypesC-45String-C-43C-43 "(parameterize ([optimize-level 3] " (PreludeC-45TypesC-45String-C-43C-43 (cond ((equal? arg-1 1) "[compile-profile #t] ") (else "")) (PreludeC-45TypesC-45String-C-43C-43 "[compile-file-message #f]) (compile-program " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String arg-4) "))")))))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) u--tmpFileAbs u--build) eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-25 ((SystemC-45FileC-45Permissions-chmodRaw (csegen-3) u--tmpFileAbs (blodwen-toSignedInt 493 63)) eta-1))) (vector 1 act-25))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-26 ((System-system (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 " --script \"" (PreludeC-45TypesC-45String-C-43C-43 u--tmpFileAbs "\"")))) eta-1))) (vector 1 act-26))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (vector 1 0))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--tmpFileAbs e-6) eta-0)))))))))))))
(define CompilerC-45SchemeC-45Chez-compileExprWhole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--appDirRel (PreludeC-45TypesC-45String-C-43C-43 arg-5 "_app"))) (let ((u--appDirGen (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--appDirRel))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-24 (CoreC-45Directory-mkdirAll u--appDirGen eta-1))) (vector 1 act-24))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 ((csegen-878) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") eta-0) (let ((e-1 (unbox e-6))) (let ((u--outSsFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 "ss")))) (let ((u--outSoFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 "so")))) (let ((u--outSsAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--outSsFile)))) (let ((act-26 (let ((act-26 (CompilerC-45SchemeC-45Chez-findChez eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-getSession arg-1 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--prof (let ((e-16 (vector-ref e-8 16))) e-16))) (let ((act-28 (CompilerC-45SchemeC-45Chez-compileToSS arg-1 (cond ((equal? arg-0 1) u--prof) (else 0)) u--appDirGen arg-4 u--outSsAbs eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45ContextC-45Log-logTime arg-1 (lambda () "++ Make SO") (cond ((equal? arg-0 1) (CompilerC-45SchemeC-45Chez-compileToSO arg-1 u--prof e-7 u--appDirGen u--outSsAbs)) (else (lambda (eta-1) (vector 1 0)))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((u--outShRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 arg-5))) (let ((act-30 (let ((sc7 (SystemC-45Info-isWindows))) (cond ((equal? sc7 1) ((CompilerC-45SchemeC-45Chez-makeShWindows e-7 u--outShRel u--appDirRel (cond ((equal? arg-0 1) u--outSoFile) (else u--outSsFile)) "--program") eta-0)) (else (CompilerC-45SchemeC-45Chez-makeSh u--outShRel u--appDirRel (cond ((equal? arg-0 1) u--outSoFile) (else u--outSsFile)) eta-0)))))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-31 ((SystemC-45FileC-45Permissions-chmodRaw (csegen-3) u--outShRel (blodwen-toSignedInt 493 63)) eta-1))) (vector 1 act-31))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (vector 1 (box u--outShRel)))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Chez-compileExprInc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc1 (DataC-45List-lookup (csegen-898) (vector 0 ) (let ((e-23 (vector-ref e-5 23))) e-23)))) (if (null? sc1) (let ((act-25 (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) "Missing incremental compile data, reverting to whole program compilation") ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else ((CompilerC-45SchemeC-45Chez-compileExprWhole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0)))) (let ((e-1 (unbox sc1))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((u--appDirRel (PreludeC-45TypesC-45String-C-43C-43 arg-5 "_app"))) (let ((u--appDirGen (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--appDirRel))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 (CoreC-45Directory-mkdirAll u--appDirGen eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (let ((act-26 ((csegen-878) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-26 1))) (if (null? e-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Can't get current directory") ext-0) (let ((e-2 (unbox e-9))) (let ((u--outSsFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 "ss")))) (let ((u--outSsAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-2 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--outSsFile)))) (let ((act-27 (let ((act-27 (CompilerC-45SchemeC-45Chez-findChez ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-27 1))) (let ((act-28 (CompilerC-45SchemeC-45Chez-compileToSSInc arg-1 e-7 e-6 u--appDirGen arg-4 u--outSsAbs ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((u--outShRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 arg-5))) (let ((act-29 (let ((sc8 (SystemC-45Info-isWindows))) (cond ((equal? sc8 1) ((CompilerC-45SchemeC-45Chez-makeShWindows e-10 u--outShRel u--appDirRel u--outSsFile "--script") ext-0)) (else (CompilerC-45SchemeC-45Chez-makeSh u--outShRel u--appDirRel u--outSsFile ext-0)))))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-30 ((SystemC-45FileC-45Permissions-chmodRaw (csegen-3) u--outShRel (blodwen-toSignedInt 493 63)) eta-0))) (vector 1 act-30))) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (vector 1 (box u--outShRel))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45SchemeC-45Chez-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (let ((sc3 (let ((e-22 (vector-ref e-5 22))) e-22))) (cond ((equal? sc3 1) 0) (else (PreludeC-45Types-elem (csegen-898) (vector 0 ) (let ((e-21 (vector-ref e-6 21))) e-21))))))) (cond ((equal? sc2 1) (CompilerC-45SchemeC-45Chez-compileExprInc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0)) (else ((CompilerC-45SchemeC-45Chez-compileExprWhole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0))))))))))))))
(define CompilerC-45SchemeC-45Chez-codegenChez(blodwen-lazy (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CompilerC-45SchemeC-45Chez-compileExpr 1 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Chez-executeExpr eta-0 eta-1 eta-2 eta-3))))) (box (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-incCompile eta-0 eta-1 eta-2))))) (box "so")))))
(define CompilerC-45SchemeC-45Chez-chezVersion (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45FileC-45Process-popen (csegen-3) (CompilerC-45SchemeC-45Chez-n--8611-567-u--cmd arg-0) 0) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (let ((act-25 ((SystemC-45FileC-45ReadWrite-fGetLine (csegen-3) e-2) ext-0))) (case (vector-ref act-25 0) ((1) (let ((e-3 (vector-ref act-25 1))) ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (SystemC-45FileC-45Process-pclose (csegen-3) e-2) (lambda () (lambda (eta-0) (LibrariesC-45DataC-45Version-parseVersion e-3)))) ext-0))) (else '()))))) (else '())))))
(define CompilerC-45SchemeC-45Chez-chezString (lambda (arg-0) (PreludeC-45Types-strCons #\" ((CompilerC-45SchemeC-45Chez-showChezString (PreludeC-45Types-fastUnpack arg-0)) "\""))))
(define CompilerC-45SchemeC-45Chez-chezExtPrim (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((6) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (case (vector-ref e-1 0) ((12) (let ((e-20 (vector-ref e-1 2))) (case (vector-ref e-20 0) ((10) (let ((e-21 (vector-ref e-20 1))) (if (null? e-2) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-24 (cdr e-2))) (if (null? e-24) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-27 (cdr e-24))) (if (null? e-27) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (case (vector-ref e-32 0) ((12) (let ((e-35 (vector-ref e-32 2))) (case (vector-ref e-35 0) ((10) (let ((e-36 (vector-ref e-35 1))) (if (null? e-33) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))) (let ((e-39 (cdr e-33))) (if (null? e-39) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) 0 e-29) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(ftype-ref " (PreludeC-45TypesC-45String-C-43C-43 e-21 (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 e-36 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))))))) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad getField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))) ((7) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-42 (car arg-2))) (let ((e-43 (cdr arg-2))) (case (vector-ref e-42 0) ((12) (let ((e-67 (vector-ref e-42 2))) (case (vector-ref e-67 0) ((10) (let ((e-68 (vector-ref e-67 1))) (if (null? e-43) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-71 (cdr e-43))) (if (null? e-71) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-74 (cdr e-71))) (if (null? e-74) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-76 (car e-74))) (let ((e-77 (cdr e-74))) (if (null? e-77) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-79 (car e-77))) (let ((e-80 (cdr e-77))) (case (vector-ref e-79 0) ((12) (let ((e-82 (vector-ref e-79 2))) (case (vector-ref e-82 0) ((10) (let ((e-83 (vector-ref e-82 1))) (if (null? e-80) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-86 (cdr e-80))) (if (null? e-86) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-88 (car e-86))) (let ((e-89 (cdr e-86))) (if (null? e-89) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))) (let ((e-92 (cdr e-89))) (if (null? e-92) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) 0 e-76) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) 0 e-88) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(ftype-set! " (PreludeC-45TypesC-45String-C-43C-43 e-68 (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 e-83 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))))))) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-64 (cdr e-61))) (if (null? e-64) (lambda (eta-0) (vector 1 "(blodwen-error-quit \"bad setField\")")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))))))))))))))))))) ((10) (if (null? arg-2) (lambda (eta-0) (vector 1 "\"chez\"")) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))) ((11) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-97 (cdr arg-2))) (if (null? e-97) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-99 (car e-97))) (let ((e-100 (cdr e-97))) (if (null? e-100) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-102 (car e-100))) (let ((e-103 (cdr e-100))) (if (null? e-103) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-106 (cdr e-103))) (if (null? e-106) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) 0 e-99) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) 0 e-102) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-register-object " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))))) ((12) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-109 (car arg-2))) (let ((e-110 (cdr arg-2))) (if (null? e-110) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-112 (car e-110))) (let ((e-113 (cdr e-110))) (if (null? e-113) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-116 (cdr e-113))) (if (null? e-116) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) 0 e-109) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) 0 e-112) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (CompilerC-45SchemeC-45Common-mkWorld (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-register-object " (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))))))))))))))) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))))) ((13) (if (null? arg-2) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-120 (cdr arg-2))) (if (null? e-120) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2) (let ((e-122 (car e-120))) (let ((e-123 (cdr e-120))) (if (null? e-123) (lambda (eta-0) (let ((act-24 ((CompilerC-45SchemeC-45Common-schExp (csegen-3841) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-1)) 0 e-122) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(blodwen-make-future " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))))) (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2))))))))(else (CompilerC-45SchemeC-45Common-schExtCommon (csegen-3841) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString eta-0)) arg-0 arg-1 arg-2)))))
(define CompilerC-45SchemeC-45Chez-cftySpec (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 "void"))) ((1) (lambda (eta-0) (vector 1 "int"))) ((3) (lambda (eta-0) (vector 1 "integer-8"))) ((4) (lambda (eta-0) (vector 1 "integer-16"))) ((5) (lambda (eta-0) (vector 1 "integer-32"))) ((6) (lambda (eta-0) (vector 1 "integer-64"))) ((7) (lambda (eta-0) (vector 1 "unsigned-8"))) ((8) (lambda (eta-0) (vector 1 "unsigned-16"))) ((9) (lambda (eta-0) (vector 1 "unsigned-32"))) ((10) (lambda (eta-0) (vector 1 "unsigned-64"))) ((11) (lambda (eta-0) (vector 1 "string"))) ((12) (lambda (eta-0) (vector 1 "double"))) ((13) (lambda (eta-0) (vector 1 "char"))) ((14) (lambda (eta-0) (vector 1 "void*"))) ((15) (lambda (eta-0) (vector 1 "void*"))) ((16) (lambda (eta-0) (vector 1 "u8*"))) ((19) (lambda (eta-0) (vector 1 "void*"))) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Chez-cftySpec arg-0 e-2))) ((21) (let ((e-3 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "(* " (PreludeC-45TypesC-45String-C-43C-43 e-3 ")"))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "Can't pass argument of type " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45CompileExpr-u--show_Show_CFType arg-1) " to foreign function"))) eta-0))))))
(define CompilerC-45SchemeC-45Chez-cCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-6 0) ((20) (let ((e-0 (vector-ref arg-6 1))) (case (vector-ref e-0 0) ((15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 "Can't return GCPtr from a foreign function") clam-0)) ((16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 "Can't return Buffer from a foreign function") clam-0))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc2 (PreludeC-45Types-elem (csegen-17) arg-4 e-5))) (cond ((equal? sc2 1) (vector 1 '())) (else (let ((act-25 (let ((act-25 (set-box! arg-1 (cons arg-4 e-5)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (box arg-4)))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Chez-cftySpec arg-2 (Builtin-snd eta-0))) arg-5 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45SchemeC-45Chez-cftySpec arg-2 arg-6) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--callConv (cond ((equal? arg-7 1) " __collect_safe") (else "")))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Chez-n--9690-1668-u--buildArg arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) arg-5 '() clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--call (PreludeC-45TypesC-45String-C-43C-43 "((foreign-procedure" (PreludeC-45TypesC-45String-C-43C-43 u--callConv (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String arg-3) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-7) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-8 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-9) ")")))))))))))) (vector 1 (cons e-6 (case (vector-ref arg-6 0) ((20) (CompilerC-45SchemeC-45Chez-handleRet e-8 u--call))(else u--call)))))))))))))))))))))))))))))) ((15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 "Can't return GCPtr from a foreign function") clam-0)) ((16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-2 "Can't return Buffer from a foreign function") clam-0))(else (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (PreludeC-45Types-elem (csegen-17) arg-4 e-5))) (cond ((equal? sc1 1) (vector 1 '())) (else (let ((act-25 (let ((act-25 (set-box! arg-1 (cons arg-4 e-5)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 (box arg-4)))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Chez-cftySpec arg-2 (Builtin-snd eta-0))) arg-5 '() clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CompilerC-45SchemeC-45Chez-cftySpec arg-2 arg-6) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--callConv (cond ((equal? arg-7 1) " __collect_safe") (else "")))) (let ((act-28 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Chez-n--9690-1668-u--buildArg arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) arg-5 '() clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((u--call (PreludeC-45TypesC-45String-C-43C-43 "((foreign-procedure" (PreludeC-45TypesC-45String-C-43C-43 u--callConv (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String arg-3) (PreludeC-45TypesC-45String-C-43C-43 " (" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-7) (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 e-8 (PreludeC-45TypesC-45String-C-43C-43 ") " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep " " e-9) ")")))))))))))) (vector 1 (cons e-6 (case (vector-ref arg-6 0) ((20) (CompilerC-45SchemeC-45Chez-handleRet e-8 u--call))(else u--call)))))))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-case--createCFunctions-9157 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: FFI not found for " (CompilerC-45RefCC-45RefC-cName arg-4))) (let ((e-1 (unbox arg-12))) (if (null? e-1) (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: FFI not found for " (CompilerC-45RefCC-45RefC-cName arg-4))) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (if (null? e-5) (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: FFI not found for " (CompilerC-45RefCC-45RefC-cName arg-4))) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((u--cLang (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-4 "RefC"))) (cond ((equal? sc3 1) 1) (else 0))))) (let ((u--isStandardFFI (PreludeC-45Types-elem (csegen-17) e-4 (csegen-3907)))) (let ((u--fctName (cond ((equal? u--isStandardFFI 1) (vector 1 (vector 0 e-7))) (else (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 e-4 (PreludeC-45TypesC-45String-C-43C-43 "_" e-7)))))))) (lambda (eta-0) (let ((act-24 (cond ((equal? u--isStandardFFI 1) (if (null? e-8) (vector 1 0) (let ((e-2 (cdr e-8))) (if (null? e-2) (vector 1 0) (let ((e-9 (car e-2))) (let ((e-6 (cdr e-2))) (if (null? e-6) (CompilerC-45RefCC-45RefC-addHeader arg-5 e-9 eta-0) (vector 1 0)))))))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (CompilerC-45RefCC-45RefC-additionalFFIStub u--fctName arg-2 arg-1)) eta-0))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (unbox arg-9))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (let ((u--fnDef (PreludeC-45TypesC-45String-C-43C-43 "Value *" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName arg-4) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (DataC-45List-replicate (PreludeC-45TypesC-45List-length arg-2) "Value *")) ");")))))) (let ((act-26 (CompilerC-45RefCC-45RefC-functionDefSignatureArglist arg-11 arg-4 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (set-box! arg-9 (cons (PreludeC-45TypesC-45String-C-43C-43 u--fnDef "\xa;") (cons (PreludeC-45TypesC-45String-C-43C-43 e-10 ";\xa;") e-9))))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CompilerC-45RefCC-45RefC-createFFIArgList arg-2) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-28 1))) (let ((act-29 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) e-10) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "{") eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CompilerC-45RefCC-45RefC-increaseIndentation arg-6 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "return " (CompilerC-45RefCC-45RefC-cName arg-4))) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (CompilerC-45RefCC-45RefC-increaseIndentation arg-6 eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "(") eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 (CompilerC-45RefCC-45RefC-increaseIndentation arg-6 eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((u--commaSepArglist (CompilerC-45RefCC-45RefC-addCommaToList (PreludeC-45Types-u--map_Functor_List (csegen-3908) (CompilerC-45RefCC-45RefC-getArgsNrList arg-2 0))))) (let ((act-36 (CoreC-45Core-traverse_ (lambda (eta-1) (CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) eta-1)) u--commaSepArglist eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((act-37 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-6 eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((act-38 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) ");") eta-0))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((act-39 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-6 eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((act-40 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-6 eta-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((act-41 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "}\xa;") eta-0))) (case (vector-ref act-41 0) ((0) (let ((e-2 (vector-ref act-41 1))) (vector 0 e-2))) (else (let ((act-42 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "") eta-0))) (case (vector-ref act-42 0) ((0) (let ((e-2 (vector-ref act-42 1))) (vector 0 e-2))) (else (let ((act-43 ((CompilerC-45RefCC-45RefC-emitFDef arg-7 arg-6 arg-4 e-12) eta-0))) (case (vector-ref act-43 0) ((0) (let ((e-2 (vector-ref act-43 1))) (vector 0 e-2))) (else (let ((act-44 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "{") eta-0))) (case (vector-ref act-44 0) ((0) (let ((e-2 (vector-ref act-44 1))) (vector 0 e-2))) (else (let ((act-45 (CompilerC-45RefCC-45RefC-increaseIndentation arg-6 eta-0))) (case (vector-ref act-45 0) ((0) (let ((e-2 (vector-ref act-45 1))) (vector 0 e-2))) (else (let ((act-46 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 " // ffi call to " (CompilerC-45RefCC-45RefC-cName u--fctName))) eta-0))) (case (vector-ref act-46 0) ((0) (let ((e-2 (vector-ref act-46 1))) (vector 0 e-2))) (else (let ((act-47 (case (vector-ref arg-1 0) ((20) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((0) (let ((act-47 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName u--fctName) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-32 (car e-3))) (let ((e-31 (cdr e-3))) (CompilerC-45RefCC-45RefC-extractValue u--cLang e-31 e-32))))) (CompilerC-45RefCC-45RefC-discardLastArgument e-12))) ");")))) eta-0))) (case (vector-ref act-47 0) ((0) (let ((e-2 (vector-ref act-47 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "return NULL;") eta-0)))))(else (let ((act-47 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cTypeOfCFType e-0) (PreludeC-45TypesC-45String-C-43C-43 " retVal = " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName u--fctName) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-32 (car e-3))) (let ((e-31 (cdr e-3))) (CompilerC-45RefCC-45RefC-extractValue u--cLang e-31 e-32))))) (CompilerC-45RefCC-45RefC-discardLastArgument e-12))) ");")))))) eta-0))) (case (vector-ref act-47 0) ((0) (let ((e-2 (vector-ref act-47 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "return (Value*)" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-packCFType e-0 "retVal") ";"))) eta-0))))))))(else (let ((act-47 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cTypeOfCFType arg-1) (PreludeC-45TypesC-45String-C-43C-43 " retVal = " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName u--fctName) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-32 (car e-3))) (let ((e-31 (cdr e-3))) (CompilerC-45RefCC-45RefC-extractValue u--cLang e-31 e-32))))) e-12)) ");")))))) eta-0))) (case (vector-ref act-47 0) ((0) (let ((e-2 (vector-ref act-47 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "return (Value*)" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-packCFType arg-1 "retVal") ";"))) eta-0)))))))) (case (vector-ref act-47 0) ((0) (let ((e-2 (vector-ref act-47 1))) (vector 0 e-2))) (else (let ((act-48 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-6 eta-0))) (case (vector-ref act-48 0) ((0) (let ((e-2 (vector-ref act-48 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "}") eta-0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-n--10389-6958-u--varBindLines (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (if (null? arg-14) (vector 1 0) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-10 arg-9 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "Value * var_" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-2) (PreludeC-45TypesC-45String-C-43C-43 " = ((Value_Constructor*)" (PreludeC-45TypesC-45String-C-43C-43 arg-13 (PreludeC-45TypesC-45String-C-43C-43 ")->args[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-15) "];"))))))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CompilerC-45RefCC-45RefC-n--10389-6958-u--varBindLines arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3 (+ 1 arg-15) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (vector 1 0))))))))))))
(define CompilerC-45RefCC-45RefC-n--8123-4592-u--showCString (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) clam-0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 #\") (PreludeC-45TypesC-45String-C-43C-43 "\\\"" ((CompilerC-45RefCC-45RefC-n--8123-4592-u--showCString arg-0 e-3) clam-0)))(else ((CompilerC-45RefCC-45RefC-n--8123-4591-u--showCChar arg-0 e-2) ((CompilerC-45RefCC-45RefC-n--8123-4592-u--showCString arg-0 e-3) clam-0))))))))))
(define CompilerC-45RefCC-45RefC-n--8123-4591-u--showCChar (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\\) (lambda (arg-2) (PreludeC-45TypesC-45String-C-43C-43 "\\\\" arg-2)))(else (lambda (clam-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-1 (PreludeC-45Types-chr 32)))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 "\\x" (LibrariesC-45UtilsC-45Hex-leftPad #\0 (+ 1 (+ 1 0)) (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-1)))) "\"\"") clam-0)) (else (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-1 (PreludeC-45Types-chr (blodwen-toSignedInt 127 63))))) (cond ((equal? sc1 1) (PreludeC-45Types-strCons arg-1 clam-0)) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-1 (PreludeC-45Types-chr (blodwen-toSignedInt 65536 63))))) (cond ((equal? sc2 1) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 "\\u" (LibrariesC-45UtilsC-45Hex-leftPad #\0 (+ 1 (+ 1 (+ 1 (+ 1 0)))) (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-1)))) "\"\"") clam-0)) (else (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 "\\U" (LibrariesC-45UtilsC-45Hex-leftPad #\0 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-1)))) "\"\"") clam-0)))))))))))))))
(define CompilerC-45RefCC-45RefC-n--10052-6450-u--pushArgToArglist (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-7) (vector 1 0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-3 arg-2 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 "->args[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-8) (PreludeC-45TypesC-45String-C-43C-43 "] = " (PreludeC-45TypesC-45String-C-43C-43 " newReference(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-2) ");"))))))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (CompilerC-45RefCC-45RefC-n--10052-6450-u--pushArgToArglist arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 (+ 1 arg-8) ext-0)))))))))
(define CompilerC-45RefCC-45RefC-n--10379-6820-u--getNameTag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-15) (vector 1 (cons "-1" (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName arg-16) "\"")))) (let ((e-2 (unbox arg-15))) (vector 1 (cons (PreludeC-45Show-u--show_Show_Int e-2) "NULL"))))))
(define CompilerC-45RefCC-45RefC-u--show_Show_ExtPrim (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "newIORef") ((1) "readIORef") ((2) "writeIORef") ((3) "newArray") ((4) "arrayGet") ((5) "arraySet") ((6) "getField") ((7) "setField") ((8) "voidElim") ((9) "sysOS") ((10) "sysCodegen") ((11) "onCollect") ((12) "onCollectAny") (else (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Unknown " (CoreC-45Name-u--show_Show_Name e-0)))))))
(define CompilerC-45RefCC-45RefC-varNamesFromList (lambda (arg-1 arg-2) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45TypesC-45String-C-43C-43 "var_" (PreludeC-45Show-u--show_Show_Nat eta-0))) (CompilerC-45RefCC-45RefC-getArgsNrList arg-1 arg-2))))
(define CompilerC-45RefCC-45RefC-varName (lambda (arg-0) (if (null? arg-0) "NULL" (let ((e-0 (unbox arg-0))) (PreludeC-45TypesC-45String-C-43C-43 "var_" (PreludeC-45Show-u--show_Show_Int e-0))))))
(define CompilerC-45RefCC-45RefC-toPrim (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Core-cond (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__newIORef")))) (lambda () (vector 0 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__readIORef")))) (lambda () (vector 1 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__writeIORef")))) (lambda () (vector 2 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__newArray")))) (lambda () (vector 3 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__arrayGet")))) (lambda () (vector 4 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__arraySet")))) (lambda () (vector 5 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__getField")))) (lambda () (vector 6 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__setField")))) (lambda () (vector 7 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "void")))) (lambda () (vector 8 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__void")))) (lambda () (vector 8 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__os")))) (lambda () (vector 9 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__codegen")))) (lambda () (vector 10 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__onCollect")))) (lambda () (vector 11 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__onCollectAny")))) (lambda () (vector 12 ))) '())))))))))))))) (vector 13 arg-0))))(else (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Unknown primitive: " (CompilerC-45RefCC-45RefC-cName arg-0)))))))
(define CompilerC-45RefCC-45RefC-showcCleanStringChar (lambda (arg-0) (lambda (clam-0) (cond ((equal? arg-0 #\+) (PreludeC-45TypesC-45String-C-43C-43 "_plus" clam-0)) ((equal? arg-0 #\-) (PreludeC-45TypesC-45String-C-43C-43 "__" clam-0)) ((equal? arg-0 #\*) (PreludeC-45TypesC-45String-C-43C-43 "_star" clam-0)) ((equal? arg-0 #\/) (PreludeC-45TypesC-45String-C-43C-43 "_slash" clam-0)) ((equal? arg-0 #\\) (PreludeC-45TypesC-45String-C-43C-43 "_backslash" clam-0)) ((equal? arg-0 #\<) (PreludeC-45TypesC-45String-C-43C-43 "_lt" clam-0)) ((equal? arg-0 #\>) (PreludeC-45TypesC-45String-C-43C-43 "_gt" clam-0)) ((equal? arg-0 #\=) (PreludeC-45TypesC-45String-C-43C-43 "_eq" clam-0)) ((equal? arg-0 #\&) (PreludeC-45TypesC-45String-C-43C-43 "_and" clam-0)) ((equal? arg-0 #\|) (PreludeC-45TypesC-45String-C-43C-43 "_or" clam-0)) ((equal? arg-0 #\') (PreludeC-45TypesC-45String-C-43C-43 "_tick" clam-0)) ((equal? arg-0 #\") (PreludeC-45TypesC-45String-C-43C-43 "_quotation" clam-0)) ((equal? arg-0 #\() (PreludeC-45TypesC-45String-C-43C-43 "_parenOpen" clam-0)) ((equal? arg-0 #\)) (PreludeC-45TypesC-45String-C-43C-43 "_parenClose" clam-0)) ((equal? arg-0 #\{) (PreludeC-45TypesC-45String-C-43C-43 "_braceOpen" clam-0)) ((equal? arg-0 #\}) (PreludeC-45TypesC-45String-C-43C-43 "_braceClose" clam-0)) ((equal? arg-0 #\ ) (PreludeC-45TypesC-45String-C-43C-43 "_" clam-0)) ((equal? arg-0 #\:) (PreludeC-45TypesC-45String-C-43C-43 "_colon" clam-0)) ((equal? arg-0 #\.) (PreludeC-45TypesC-45String-C-43C-43 "_dot" clam-0)) ((equal? arg-0 #\$) (PreludeC-45TypesC-45String-C-43C-43 "_dollar" clam-0)) ((equal? arg-0 #\,) (PreludeC-45TypesC-45String-C-43C-43 "_comma" clam-0)) ((equal? arg-0 #\#) (PreludeC-45TypesC-45String-C-43C-43 "_number" clam-0)) ((equal? arg-0 #\%) (PreludeC-45TypesC-45String-C-43C-43 "_percent" clam-0)) ((equal? arg-0 #\~) (PreludeC-45TypesC-45String-C-43C-43 "_tilde" clam-0))(else (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-0 (PreludeC-45Types-chr 32)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-0 (PreludeC-45Types-chr (blodwen-toSignedInt 126 63)))))))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45TypesC-45String-C-43C-43 "u" (LibrariesC-45UtilsC-45Hex-leftPad #\0 (+ 1 (+ 1 (+ 1 (+ 1 0)))) (LibrariesC-45UtilsC-45Hex-asHex (PreludeC-45Cast-u--cast_Cast_Char_Bits64 arg-0)))) clam-0)) (else (PreludeC-45Types-strCons arg-0 clam-0)))))))))
(define CompilerC-45RefCC-45RefC-showcCleanString (lambda (arg-0 ext-0) (if (null? arg-0) ext-0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) ((CompilerC-45RefCC-45RefC-showcCleanStringChar e-2) (CompilerC-45RefCC-45RefC-showcCleanString e-3 ext-0)))))))
(define CompilerC-45RefCC-45RefC-showTag (lambda (arg-0) (if (null? arg-0) "-1" (let ((e-2 (unbox arg-0))) (PreludeC-45Show-u--show_Show_Int e-2)))))
(define CompilerC-45RefCC-45RefC-showIntMin (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-0 (blodwen-toSignedInt -9223372036854775808 63)))) (cond ((equal? sc0 1) "INT64_MIN") (else (PreludeC-45TypesC-45String-C-43C-43 "INT64_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int arg-0) ")")))))))
(define CompilerC-45RefCC-45RefC-showInt64Min (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-0 (blodwen-toSignedInt -9223372036854775808 63)))) (cond ((equal? sc0 1) "INT64_MIN") (else (PreludeC-45TypesC-45String-C-43C-43 "INT64_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int64 arg-0) ")")))))))
(define CompilerC-45RefCC-45RefC-registerVariableForAutomaticFreeing (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (if (null? e-5) (cons (cons arg-1 '()) '()) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (cons arg-1 e-2) e-3))))))) (vector 1 act-25))))))))
(define CompilerC-45RefCC-45RefC-plainOp (lambda (arg-0 arg-1) (PreludeC-45TypesC-45String-C-43C-43 arg-0 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " arg-1) ")")))))
(define CompilerC-45RefCC-45RefC-packCFType (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) "NULL") ((1) (PreludeC-45TypesC-45String-C-43C-43 "makeInt64(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((3) (PreludeC-45TypesC-45String-C-43C-43 "makeInt8(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((4) (PreludeC-45TypesC-45String-C-43C-43 "makeInt16(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((5) (PreludeC-45TypesC-45String-C-43C-43 "makeInt32(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((6) (PreludeC-45TypesC-45String-C-43C-43 "makeInt64(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((10) (PreludeC-45TypesC-45String-C-43C-43 "makeBits64(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((9) (PreludeC-45TypesC-45String-C-43C-43 "makeBits32(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((8) (PreludeC-45TypesC-45String-C-43C-43 "makeBits16(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((7) (PreludeC-45TypesC-45String-C-43C-43 "makeBits8(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((11) (PreludeC-45TypesC-45String-C-43C-43 "makeString(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((12) (PreludeC-45TypesC-45String-C-43C-43 "makeDouble(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((13) (PreludeC-45TypesC-45String-C-43C-43 "makeChar(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((14) (PreludeC-45TypesC-45String-C-43C-43 "makePointer(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((15) (PreludeC-45TypesC-45String-C-43C-43 "makePointer(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((16) (PreludeC-45TypesC-45String-C-43C-43 "makeBuffer(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((18) (PreludeC-45TypesC-45String-C-43C-43 "makeWorld(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((19) (PreludeC-45TypesC-45String-C-43C-43 "makeFunction(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((20) (let ((e-2 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-packCFType e-2 arg-1))) ((21) (PreludeC-45TypesC-45String-C-43C-43 "makeStruct(" (PreludeC-45TypesC-45String-C-43C-43 arg-1 ")"))) ((22) arg-1)(else (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-0)))))))
(define CompilerC-45RefCC-45RefC-newTemporaryVariableLevel (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (cons '() e-5)))) (vector 1 act-25))))))))
(define CompilerC-45RefCC-45RefC-maxLineLengthForComment(blodwen-lazy (lambda () (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-4) (lambda (eta-0) (vector 1 (cons arg-6 arg-7))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (lambda (clam-0) (cond ((equal? arg-5 0) (case (vector-ref e-4 0) ((10) (let ((act-24 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--constantArray (PreludeC-45TypesC-45String-C-43C-43 "constantArray_" (PreludeC-45Show-u--show_Show_Nat e-6)))) (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "char **" (PreludeC-45TypesC-45String-C-43C-43 u--constantArray (PreludeC-45TypesC-45String-C-43C-43 " = (char**)malloc(sizeof(char*) * " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) (PreludeC-45TypesC-45List-length e-3))) ");"))))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else ((CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst arg-0 arg-1 arg-2 arg-3 (cons (cons e-4 e-5) e-3) 1 u--constantArray "multiStringCompare") clam-0)))))))))) ((12) (let ((act-24 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (let ((u--constantArray (PreludeC-45TypesC-45String-C-43C-43 "constantArray_" (PreludeC-45Show-u--show_Show_Nat e-6)))) (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "double *" (PreludeC-45TypesC-45String-C-43C-43 u--constantArray (PreludeC-45TypesC-45String-C-43C-43 " = (double*)malloc(sizeof(double) * " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-u--C-43_Num_Nat (+ 1 0) (PreludeC-45TypesC-45List-length e-3))) ");"))))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else ((CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst arg-0 arg-1 arg-2 arg-3 (cons (cons e-4 e-5) e-3) 1 u--constantArray "multiDoubleCompare") clam-0))))))))))(else (vector 1 (cons "ERROR_NOT_DOUBLE_OR_STRING" "ERROR_NOT_DOUBLE_OR_STRING")))))(else (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int (bs- arg-5 1 63)) (PreludeC-45TypesC-45String-C-43C-43 "] = " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-extractConstant e-4) ";")))))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else ((CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst arg-0 arg-1 arg-2 arg-3 e-3 (bs+ arg-5 1 63) arg-6 arg-7) clam-0))))))))))))))
(define CompilerC-45RefCC-45RefC-makeArglist (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--arglist (PreludeC-45TypesC-45String-C-43C-43 "arglist_" (PreludeC-45Show-u--show_Show_Nat e-5)))) (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "Value_Arglist *" (PreludeC-45TypesC-45String-C-43C-43 u--arglist (PreludeC-45TypesC-45String-C-43C-43 " = newArglist(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 "," (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45TypesC-45List-length arg-5) arg-4)) ");"))))))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CompilerC-45RefCC-45RefC-n--10052-6450-u--pushArgToArglist arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--arglist arg-5 0 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 u--arglist))))))))))))))
(define CompilerC-45RefCC-45RefC-lJust (lambda (arg-0 arg-1 arg-2) (let ((u--n (PreludeC-45TypesC-45String-length arg-0))) (let ((sc0 (DataC-45Nat-isLTE u--n arg-1))) (case (vector-ref sc0 0) ((0) (let ((u--missing (PreludeC-45Types-prim__integerToNat (- arg-1 u--n)))) (let ((u--fillBlock (PreludeC-45Types-fastPack (DataC-45List-replicate u--missing arg-2)))) (PreludeC-45TypesC-45String-C-43C-43 arg-0 u--fillBlock)))) (else arg-0))))))
(define CompilerC-45RefCC-45RefC-integer_switch (lambda (arg-0) (if (null? arg-0) 1 (let ((e-2 (car arg-0))) (let ((e-4 (car e-2))) (case (vector-ref e-4 0) ((0) 1) ((1) 1) ((2) 1) ((3) 1) ((4) 1) ((5) 1) ((11) 1)(else 0)))))))
(define CompilerC-45RefCC-45RefC-indentation (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-fastPack (DataC-45List-replicate (PreludeC-45Types-u--C-42_Num_Nat (+ 1 (+ 1 (+ 1 (+ 1 0)))) e-5) #\ )))))))))
(define CompilerC-45RefCC-45RefC-increaseIndentation (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (+ 1 e-5)))) (vector 1 act-25))))))))
(define CompilerC-45RefCC-45RefC-header (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--initLines (cons "#include <runtime.h>" (cons (PreludeC-45TypesC-45String-C-43C-43 "/* " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45Generated-generatedString "RefC") " */")) '())))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-4))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--headerFiles (LibrariesC-45DataC-45SortedSet-toList e-5))) (let ((u--headerLines (PreludeC-45Types-u--map_Functor_List (lambda (u--h) (PreludeC-45TypesC-45String-C-43C-43 "#include <" (PreludeC-45TypesC-45String-C-43C-43 u--h ">\xa;"))) u--headerFiles))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-2))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (set-box! arg-2 (lambda (eta-1) (LibrariesC-45DataC-45DList-appendL (PreludeC-45TypesC-45List-tailRecAppend u--initLines (PreludeC-45TypesC-45List-tailRecAppend u--headerLines (PreludeC-45TypesC-45List-tailRecAppend (cons "\xa;// function definitions" '()) e-6))) e-7 eta-1))))) (vector 1 act-27))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-getNextCounter (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (+ 1 e-5)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 e-5))))))))))
(define CompilerC-45RefCC-45RefC-getNewVarThatWillNotBeFreedAtEndOfBlock (lambda (arg-0 ext-0) (let ((act-24 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "tmp_" (PreludeC-45Show-u--show_Show_Nat e-5)))))))))
(define CompilerC-45RefCC-45RefC-getArgsNrList (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (cons arg-2 (CompilerC-45RefCC-45RefC-getArgsNrList e-3 (+ 1 arg-2)))))))
(define CompilerC-45RefCC-45RefC-generateCSourceFile (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Compiler.RefC.RefC.ArgCounter" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Compiler.RefC.RefC.FunctionDefinitions" ) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-newRef (vector "Compiler.RefC.RefC.TemporaryVariableTracker" ) '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-newRef (vector "Compiler.RefC.RefC.OutfileText" ) (lambda (eta-0) (LibrariesC-45DataC-45DList-Nil eta-0)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-newRef (vector "Compiler.RefC.RefC.HeaderFiles" ) (LibrariesC-45DataC-45SortedSet-empty (csegen-261)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-newRef (vector "Compiler.RefC.RefC.IndentLevel" ) 0 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-traverse_ (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (CompilerC-45RefCC-45RefC-createCFunctions arg-0 e-5 e-6 e-7 e-8 e-10 e-9 arg-1 eta-1 eta-2))) eta-0)) arg-2 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 ((CompilerC-45RefCC-45RefC-header arg-0 e-6 e-8 e-10 e-9) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 (CompilerC-45RefCC-45RefC-footer e-10 e-8 e-9 ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (let ((act-33 (unbox e-8))) (vector 1 act-33)))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-33 1))) (let ((u--code (DataC-45String-fastAppend (PreludeC-45Types-u--map_Functor_List (lambda (arg-4) (PreludeC-45TypesC-45String-C-43C-43 arg-4 "\xa;")) (LibrariesC-45DataC-45DList-reify e-14))))) (let ((act-34 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-34 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) arg-3 u--code) eta-0))) (vector 1 act-34))) ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (CoreC-45ContextC-45Log-log arg-0 "compiler.refc" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Generated C file " arg-3)) ext-0))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-functionDefSignatureArglist (lambda (arg-0 arg-1 ext-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Value *" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName e-5) "_arglist(Value_Arglist* arglist)")))))))))
(define CompilerC-45RefCC-45RefC-functionDefSignature (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fn (CompilerC-45RefCC-45RefC-cName e-5))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "\xa;\xa;Value *" (PreludeC-45TypesC-45String-C-43C-43 u--fn "(void)"))))))))) (let ((u--argsStringList (CompilerC-45RefCC-45RefC-addCommaToList (PreludeC-45Types-u--map_Functor_List (lambda (u--i) (PreludeC-45TypesC-45String-C-43C-43 "  Value * var_" (PreludeC-45Show-u--show_Show_Int u--i))) arg-2)))) (lambda (eta-0) (let ((act-24 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fn (CompilerC-45RefCC-45RefC-cName e-5))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "\xa;\xa;Value *" (PreludeC-45TypesC-45String-C-43C-43 u--fn (PreludeC-45TypesC-45String-C-43C-43 "\xa;(\xa;" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep "\xa;" u--argsStringList) "\xa;)")))))))))))))))
(define CompilerC-45RefCC-45RefC-freeTmpVars (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (car e-5))) (let ((e-2 (cdr e-5))) (let ((act-25 (CoreC-45Core-traverse_ (lambda (u--v) (CompilerC-45RefCC-45RefC-emit arg-1 arg-2 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "removeReference(" (PreludeC-45TypesC-45String-C-43C-43 u--v ");")))) e-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (set-box! arg-0 e-2))) (vector 1 act-26))))))))))))))
(define CompilerC-45RefCC-45RefC-footer (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) "") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) " // main function") ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) "int main(int argc, char *argv[])") ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) "{") ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (let ((act-28 (unbox arg-2))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((sc5 (LibrariesC-45DataC-45SortedSet-contains "idris_support.h" e-9))) (cond ((equal? sc5 1) ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) "   idris2_setArgs(argc, argv);") ext-0)) (else (vector 1 0)))))))))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) "   Value *mainExprVal = __mainExpression_0();") ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) "   trampoline(mainExprVal);") ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) "   return 0; // bye bye") ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) "}") ext-0)))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-fillConstructorArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-3) (vector 1 0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "->args[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-4) (PreludeC-45TypesC-45String-C-43C-43 "] = newReference(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-2) ");")))))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (CompilerC-45RefCC-45RefC-fillConstructorArgs arg-0 arg-1 arg-2 e-3 (+ 1 arg-4) ext-0)))))))))
(define CompilerC-45RefCC-45RefC-extractValue (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) "void") ((1) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Int64*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->i64"))) ((3) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Int8*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->i8"))) ((4) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Int16*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->i16"))) ((5) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Int32*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->i32"))) ((6) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Int64*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->i64"))) ((7) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Bits8*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->ui8"))) ((8) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Bits16*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->ui16"))) ((9) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Bits32*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->ui32"))) ((10) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Bits64*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->ui64"))) ((11) (PreludeC-45TypesC-45String-C-43C-43 "((Value_String*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->str"))) ((12) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Double*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->d"))) ((13) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Char*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->c"))) ((14) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Pointer*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->p"))) ((15) (PreludeC-45TypesC-45String-C-43C-43 "((Value_GCPointer*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->p->p")))(else (cond ((equal? arg-0 0) (case (vector-ref arg-1 0) ((16) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Buffer*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->buffer->data")))(else (case (vector-ref arg-1 0) ((18) (PreludeC-45TypesC-45String-C-43C-43 "(Value_World*)" arg-2)) ((19) (PreludeC-45TypesC-45String-C-43C-43 "(Value_Closure*)" arg-2)) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45RefCC-45RefC-extractValue arg-0 e-2 arg-2))) ((21) (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Struct access not implemented: " arg-2))) ((22) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)" arg-2))(else (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-1)))))))) ((equal? arg-0 1) (case (vector-ref arg-1 0) ((16) (PreludeC-45TypesC-45String-C-43C-43 "((Value_Buffer*)" (PreludeC-45TypesC-45String-C-43C-43 arg-2 ")->buffer")))(else (case (vector-ref arg-1 0) ((18) (PreludeC-45TypesC-45String-C-43C-43 "(Value_World*)" arg-2)) ((19) (PreludeC-45TypesC-45String-C-43C-43 "(Value_Closure*)" arg-2)) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45RefCC-45RefC-extractValue arg-0 e-2 arg-2))) ((21) (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Struct access not implemented: " arg-2))) ((22) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)" arg-2))(else (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-1))))))))(else (case (vector-ref arg-1 0) ((18) (PreludeC-45TypesC-45String-C-43C-43 "(Value_World*)" arg-2)) ((19) (PreludeC-45TypesC-45String-C-43C-43 "(Value_Closure*)" arg-2)) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45RefCC-45RefC-extractValue arg-0 e-2 arg-2))) ((21) (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Struct access not implemented: " arg-2))) ((22) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)" arg-2))(else (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-1)))))))))))
(define CompilerC-45RefCC-45RefC-extractConstant (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int8 e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int16 e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int32 e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int64 e-4))) ((5) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Integer e-5))) ((12) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Double e-6))) ((11) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Char e-7))) ((10) (let ((e-8 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-cStringQuoted e-8))) ((6) (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits8 e-9))) ((7) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits16 e-10))) ((8) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits32 e-11))) ((9) (let ((e-12 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits64 e-12)))(else (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Unable to extract constant: " (CompilerC-45RefCC-45RefC-cConstant arg-0)))))))
(define CompilerC-45RefCC-45RefC-executeExpr (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) "Execute expression not yet implemented for refc") eta-0))) (vector 1 act-24))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((System-system (csegen-3) "false") eta-0))) (vector 1 act-25))) ext-0))))))
(define CompilerC-45RefCC-45RefC-escapeChar (lambda (arg-0) (let ((sc0 (let ((sc1 (PreludeC-45Types-isAlphaNum arg-0))) (cond ((equal? sc1 1) 1) (else (PreludeC-45Types-isNL arg-0)))))) (cond ((equal? sc0 1) (PreludeC-45Show-u--show_Show_Char arg-0)) (else (PreludeC-45TypesC-45String-C-43C-43 "(char)" (PreludeC-45Show-u--show_Show_Int (PreludeC-45Types-ord arg-0))))))))
(define CompilerC-45RefCC-45RefC-emitFDef (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "Value *" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName arg-2) "(void)"))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "Value *" (CompilerC-45RefCC-45RefC-cName arg-2))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) "(") clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (CompilerC-45RefCC-45RefC-increaseIndentation arg-1 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "  Value *" e-10)) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (CoreC-45Core-traverse_ (lambda (lamc-0) (let ((e-4 (cdr lamc-0))) (let ((e-15 (car e-4))) (CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 ", Value *" e-15))))) e-3 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-1 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) ")") clam-0)))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-emit (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((2) (lambda (eta-0) (let ((act-24 (CompilerC-45RefCC-45RefC-indentation arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (PreludeC-45Basics-flip (csegen-3920) (PreludeC-45TypesC-45String-C-43C-43 e-5 arg-3) e-6)))) (vector 1 act-26))))))))))))(else (let ((u--comment (PreludeC-45TypesC-45String-C-43C-43 "// " (CoreC-45FC-u--show_Show_FC arg-2)))) (lambda (eta-0) (let ((act-24 (CompilerC-45RefCC-45RefC-indentation arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--indentedLine (PreludeC-45TypesC-45String-C-43C-43 e-5 arg-3))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (set-box! arg-0 (let ((sc2 (DataC-45Nat-isLTE (PreludeC-45TypesC-45String-length u--indentedLine) (CompilerC-45RefCC-45RefC-maxLineLengthForComment)))) (case (vector-ref sc2 0) ((0) (PreludeC-45Basics-flip (csegen-3920) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-lJust u--indentedLine (CompilerC-45RefCC-45RefC-maxLineLengthForComment) #\ ) (PreludeC-45TypesC-45String-C-43C-43 " " u--comment)) e-6)) (else (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (LibrariesC-45DataC-45DList-appendR eta-1 eta-2 eta-3)))) (cons u--indentedLine (cons (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-lJust "" (CompilerC-45RefCC-45RefC-maxLineLengthForComment) #\ ) (PreludeC-45TypesC-45String-C-43C-43 " " u--comment)) '())) e-6))))))) (vector 1 act-26)))))))))))))))))
(define CompilerC-45RefCC-45RefC-discardLastArgument (lambda (arg-1) (if (null? arg-1) '() (DataC-45List-init arg-1))))
(define CompilerC-45RefCC-45RefC-decreaseIndentation (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (DataC-45Nat-pred e-5)))) (vector 1 act-25))))))))
(define CompilerC-45RefCC-45RefC-createFFIArgList (lambda (arg-0) (let ((u--sList (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45RefCC-45RefC-cTypeOfCFType eta-0)) arg-0))) (let ((u--varList (CompilerC-45RefCC-45RefC-varNamesFromList arg-0 (+ 1 0)))) (lambda (eta-0) (vector 1 (DataC-45List-u--zip3_Zippable_List u--sList u--varList arg-0)))))))
(define CompilerC-45RefCC-45RefC-createCFunctions (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-0 (vector-ref arg-9 1))) (let ((e-1 (vector-ref arg-9 2))) (lambda (eta-0) (let ((act-24 ((CompilerC-45RefCC-45RefC-functionDefSignature arg-0 arg-8 e-0) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45RefCC-45RefC-functionDefSignatureArglist arg-0 arg-8 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-2))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (set-box! arg-2 (cons (PreludeC-45TypesC-45String-C-43C-43 e-5 ";\xa;") (cons (PreludeC-45TypesC-45String-C-43C-43 e-6 ";\xa;") e-7))))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-3 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((u--argsNrs (CompilerC-45RefCC-45RefC-getArgsNrList e-0 0))) (let ((act-29 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) e-5) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "{") eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CompilerC-45RefCC-45RefC-increaseIndentation arg-5 eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-1 arg-3 arg-4 arg-5 e-1) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (let ((act-33 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "Value *returnValue = " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-2 (cdr e-13))) e-2) ";"))) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (CompilerC-45RefCC-45RefC-freeTmpVars arg-3 arg-4 arg-5 eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((act-35 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "return returnValue;") eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-5 eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (let ((act-37 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "}\xa;") eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-2 (vector-ref act-37 1))) (vector 0 e-2))) (else (let ((act-38 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "") eta-0))) (case (vector-ref act-38 0) ((0) (let ((e-2 (vector-ref act-38 1))) (vector 0 e-2))) (else (let ((act-39 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) e-6) eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-2 (vector-ref act-39 1))) (vector 0 e-2))) (else (let ((act-40 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "{") eta-0))) (case (vector-ref act-40 0) ((0) (let ((e-2 (vector-ref act-40 1))) (vector 0 e-2))) (else (let ((act-41 (CompilerC-45RefCC-45RefC-increaseIndentation arg-5 eta-0))) (case (vector-ref act-41 0) ((0) (let ((e-2 (vector-ref act-41 1))) (vector 0 e-2))) (else (let ((act-42 (let ((act-42 (CoreC-45Context-getFullName arg-0 arg-8 eta-0))) (case (vector-ref act-42 0) ((0) (let ((e-2 (vector-ref act-42 1))) (vector 0 e-2))) (else (let ((e-23 (vector-ref act-42 1))) ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "return " (CompilerC-45RefCC-45RefC-cName e-23))) eta-0))))))) (case (vector-ref act-42 0) ((0) (let ((e-2 (vector-ref act-42 1))) (vector 0 e-2))) (else (let ((act-43 (CompilerC-45RefCC-45RefC-increaseIndentation arg-5 eta-0))) (case (vector-ref act-43 0) ((0) (let ((e-2 (vector-ref act-43 1))) (vector 0 e-2))) (else (let ((act-44 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "(") eta-0))) (case (vector-ref act-44 0) ((0) (let ((e-2 (vector-ref act-44 1))) (vector 0 e-2))) (else (let ((act-45 (CompilerC-45RefCC-45RefC-increaseIndentation arg-5 eta-0))) (case (vector-ref act-45 0) ((0) (let ((e-2 (vector-ref act-45 1))) (vector 0 e-2))) (else (let ((u--commaSepArglist (CompilerC-45RefCC-45RefC-addCommaToList (PreludeC-45Types-u--map_Functor_List (csegen-3908) u--argsNrs)))) (let ((act-46 (CoreC-45Core-traverse_ (lambda (eta-1) (CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) eta-1)) u--commaSepArglist eta-0))) (case (vector-ref act-46 0) ((0) (let ((e-2 (vector-ref act-46 1))) (vector 0 e-2))) (else (let ((act-47 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-5 eta-0))) (case (vector-ref act-47 0) ((0) (let ((e-2 (vector-ref act-47 1))) (vector 0 e-2))) (else (let ((act-48 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) ");") eta-0))) (case (vector-ref act-48 0) ((0) (let ((e-2 (vector-ref act-48 1))) (vector 0 e-2))) (else (let ((act-49 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-5 eta-0))) (case (vector-ref act-49 0) ((0) (let ((e-2 (vector-ref act-49 1))) (vector 0 e-2))) (else (let ((act-50 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-5 eta-0))) (case (vector-ref act-50 0) ((0) (let ((e-2 (vector-ref act-50 1))) (vector 0 e-2))) (else (let ((act-51 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "}\xa;") eta-0))) (case (vector-ref act-51 0) ((0) (let ((e-2 (vector-ref act-51 1))) (vector 0 e-2))) (else (let ((act-52 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "") eta-0))) (case (vector-ref act-52 0) ((0) (let ((e-2 (vector-ref act-52 1))) (vector 0 e-2))) (else (vector 1 0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) ((1) (let ((e-2 (vector-ref arg-9 1))) (let ((e-3 (vector-ref arg-9 2))) (CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "// Constructor tag " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-246) e-2) (PreludeC-45TypesC-45String-C-43C-43 " arity " (PreludeC-45Show-u--show_Show_Nat e-3)))))))) ((2) (let ((e-5 (vector-ref arg-9 1))) (let ((e-6 (vector-ref arg-9 2))) (let ((e-7 (vector-ref arg-9 3))) (CompilerC-45RefCC-45RefC-case--createCFunctions-9157 arg-7 e-7 e-6 e-5 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (CompilerC-45Common-parseCC (PreludeC-45TypesC-45List-tailRecAppend arg-7 (csegen-3907)) e-5)))))) (else (let ((e-8 (vector-ref arg-9 1))) (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Error with expression: " (CompilerC-45ANF-u--show_Show_ANF e-8))))))))
(define CompilerC-45RefCC-45RefC-copyConstructors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-5) (vector 1 0) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (let ((act-24 (CompilerC-45RefCC-45RefC-n--10379-6820-u--getNameTag e-5 e-8 e-7 e-6 e-4 e-3 arg-8 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 arg-0 arg-0 e-6 e-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-24 1))) (let ((e-11 (car e-9))) (let ((e-10 (cdr e-9))) (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-8) (PreludeC-45TypesC-45String-C-43C-43 "].tag = " (PreludeC-45TypesC-45String-C-43C-43 e-11 ";")))))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-12 (vector-ref act-25 1))) (vector 0 e-12))) (else (let ((act-26 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-8) (PreludeC-45TypesC-45String-C-43C-43 "].name = " (PreludeC-45TypesC-45String-C-43C-43 e-10 ";")))))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-13 (vector-ref act-26 1))) (vector 0 e-13))) (else ((CompilerC-45RefCC-45RefC-copyConstructors arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 arg-7 (+ 1 arg-8)) clam-0))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-constDefaultBlock (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-4) (vector 1 0) (let ((e-2 (unbox arg-4))) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  default :") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  {") ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (CompilerC-45RefCC-45RefC-increaseIndentation arg-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-2) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 arg-5 (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (car e-9))) e-0) ";")))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (CompilerC-45RefCC-45RefC-freeTmpVars arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-3 ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  }") ext-0))))))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-constBlockSwitch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-4) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (let ((u--c (CompilerC-45RefCC-45RefC-const2Integer e-4 arg-6))) (lambda (eta-0) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "  case " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Integer u--c) " :"))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  {") eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((act-26 (CompilerC-45RefCC-45RefC-increaseIndentation arg-3 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((act-27 (CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-1 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((act-28 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-5) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-28 1))) (let ((act-29 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 arg-5 (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (car e-10))) e-0) ";")))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (let ((act-30 (CompilerC-45RefCC-45RefC-freeTmpVars arg-1 arg-2 arg-3 eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-12 (vector-ref act-30 1))) (vector 0 e-12))) (else (let ((act-31 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "break;") eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-13 (vector-ref act-31 1))) (vector 0 e-13))) (else (let ((act-32 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-3 eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-14 (vector-ref act-32 1))) (vector 0 e-14))) (else (let ((act-33 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  }") eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-15 (vector-ref act-33 1))) (vector 0 e-15))) (else ((CompilerC-45RefCC-45RefC-constBlockSwitch arg-0 arg-1 arg-2 arg-3 e-3 arg-5 (+ arg-6 1)) eta-0)))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-const2Integer (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Int_Integer e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Int8_Integer e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Int16_Integer e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Int32_Integer e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Int64_Integer e-4))) ((5) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_C-36a_C-36a e-5))) ((11) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Char_Integer e-6))) ((6) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Bits8_Integer e-7))) ((7) (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Bits16_Integer e-8))) ((8) (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Bits32_Integer e-9))) ((9) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45Cast-u--cast_Cast_Bits64_Integer e-10)))(else arg-1))))
(define CompilerC-45RefCC-45RefC-conBlocks (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-5) (vector 1 0) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "  case " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat arg-7) ":"))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-9 (vector-ref act-24 1))) (vector 0 e-9))) (else (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  {") clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-10 (vector-ref act-25 1))) (vector 0 e-10))) (else (let ((act-26 (CompilerC-45RefCC-45RefC-increaseIndentation arg-3 clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-11 (vector-ref act-26 1))) (vector 0 e-11))) (else (let ((act-27 (CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-1 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-12 (vector-ref act-27 1))) (vector 0 e-12))) (else (let ((act-28 (CompilerC-45RefCC-45RefC-n--10389-6958-u--varBindLines e-5 e-8 e-7 e-6 e-4 e-3 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 arg-0 arg-4 e-7 0 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-13 (vector-ref act-28 1))) (vector 0 e-13))) (else (let ((act-29 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-8) clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-14 (vector-ref act-29 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-29 1))) (let ((act-30 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (car e-14))) e-0) ";")))) clam-0))) (case (vector-ref act-30 0) ((0) (let ((e-15 (vector-ref act-30 1))) (vector 0 e-15))) (else (let ((act-31 (CompilerC-45RefCC-45RefC-freeTmpVars arg-1 arg-2 arg-3 clam-0))) (case (vector-ref act-31 0) ((0) (let ((e-16 (vector-ref act-31 1))) (vector 0 e-16))) (else (let ((act-32 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "break;") clam-0))) (case (vector-ref act-32 0) ((0) (let ((e-17 (vector-ref act-32 1))) (vector 0 e-17))) (else (let ((act-33 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-3 clam-0))) (case (vector-ref act-33 0) ((0) (let ((e-18 (vector-ref act-33 1))) (vector 0 e-18))) (else (let ((act-34 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  }") clam-0))) (case (vector-ref act-34 0) ((0) (let ((e-19 (vector-ref act-34 1))) (vector 0 e-19))) (else ((CompilerC-45RefCC-45RefC-conBlocks arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 (+ 1 arg-7)) clam-0))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-0 2) (let ((u--outn (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 (PreludeC-45TypesC-45String-C-43C-43 arg-5 ".c")))) (let ((u--outobj (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 (PreludeC-45TypesC-45String-C-43C-43 arg-5 ".o")))) (let ((u--outexec (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 arg-5))) (lambda (eta-0) (let ((act-24 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-24 (CoreC-45Directory-mkdirAll arg-3 eta-1))) (vector 1 act-24))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CompilerC-45Common-getCompileData arg-1 0 2 arg-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--defs (let ((e-3 (vector-ref e-6 3))) e-3))) (let ((act-26 (CompilerC-45RefCC-45RefC-generateCSourceFile arg-1 '() u--defs u--outn eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CompilerC-45RefCC-45CC-compileCObjectFile arg-1 0 u--outn u--outobj eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (if (null? e-8) (vector 1 '()) (CompilerC-45RefCC-45CC-compileCFile arg-1 0 u--outobj u--outexec eta-0))))))))))))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CompilerC-45RefCC-45RefC-codegenRefC(blodwen-lazy (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45RefCC-45RefC-compileExpr 2 eta-0 eta-1 eta-2 eta-3 eta-4)))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45RefCC-45RefC-executeExpr eta-0 eta-1 eta-2 eta-3))))) '() '()))))
(define CompilerC-45RefCC-45RefC-cUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-cCleanString e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "rec__" (CompilerC-45RefCC-45RefC-cCleanString e-1)))) (else (CompilerC-45RefCC-45RefC-cCleanString "_")))))
(define CompilerC-45RefCC-45RefC-cTypeOfCFType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "void") ((1) "int64_t") ((7) "uint8_t") ((8) "uint16_t") ((9) "uint32_t") ((10) "uint64_t") ((11) "char *") ((12) "double") ((13) "char") ((14) "void *") ((15) "void *") ((16) "void *") ((18) "void *") ((19) "void *") ((20) "void *") ((21) "void *") ((22) "void *")(else (Builtin-idris_crash (PreludeC-45TypesC-45String-C-43C-43 "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-0)))))))
(define CompilerC-45RefCC-45RefC-cStringQuoted (lambda (arg-0) (PreludeC-45Types-strCons #\" ((CompilerC-45RefCC-45RefC-n--8123-4592-u--showCString arg-0 (PreludeC-45Types-fastUnpack arg-0)) "\""))))
(define CompilerC-45RefCC-45RefC-cStatementsFromANF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 2))) (let ((u--returnLine (PreludeC-45TypesC-45String-C-43C-43 "newReference(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-1) ")")))) (lambda (eta-0) (vector 1 (cons u--returnLine u--returnLine)))))) ((1) (let ((e-2 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-2 (PreludeC-45TypesC-45String-C-43C-43 "// start " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName e-4) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (u--v) (CompilerC-45RefCC-45RefC-varName u--v)) e-5)) ")"))))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((act-25 (CompilerC-45RefCC-45RefC-makeArglist arg-0 arg-1 arg-2 arg-3 0 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-7 (vector-ref act-25 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-8 (vector-ref act-26 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-26 1))) (let ((u--f_ptr_name (PreludeC-45TypesC-45String-C-43C-43 "fPtr_" (PreludeC-45Show-u--show_Show_Nat e-8)))) (let ((act-27 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-2 (PreludeC-45TypesC-45String-C-43C-43 "Value *(*" (PreludeC-45TypesC-45String-C-43C-43 u--f_ptr_name (PreludeC-45TypesC-45String-C-43C-43 ")(Value_Arglist*) = " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName e-4) "_arglist;"))))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-9 (vector-ref act-27 1))) (vector 0 e-9))) (else (let ((u--closure_name (PreludeC-45TypesC-45String-C-43C-43 "closure_" (PreludeC-45Show-u--show_Show_Nat e-8)))) (let ((act-28 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-2 (PreludeC-45TypesC-45String-C-43C-43 "Value *" (PreludeC-45TypesC-45String-C-43C-43 u--closure_name (PreludeC-45TypesC-45String-C-43C-43 " = (Value*)makeClosureFromArglist(" (PreludeC-45TypesC-45String-C-43C-43 u--f_ptr_name (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-7 ");"))))))) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (let ((act-29 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-2 (PreludeC-45TypesC-45String-C-43C-43 "// end   " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName e-4) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (u--v) (CompilerC-45RefCC-45RefC-varName u--v)) e-5)) ")"))))) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-11 (vector-ref act-29 1))) (vector 0 e-11))) (else (vector 1 (cons (PreludeC-45TypesC-45String-C-43C-43 "trampoline(" (PreludeC-45TypesC-45String-C-43C-43 u--closure_name ")")) u--closure_name))))))))))))))))))))))))))))) ((2) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (let ((e-9 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 (CompilerC-45RefCC-45RefC-makeArglist arg-0 arg-1 arg-2 arg-3 e-8 e-9 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (let ((u--f_ptr_name (PreludeC-45TypesC-45String-C-43C-43 "closure_" (PreludeC-45Show-u--show_Show_Nat e-10)))) (let ((u--f_ptr (PreludeC-45TypesC-45String-C-43C-43 "Value *(*" (PreludeC-45TypesC-45String-C-43C-43 u--f_ptr_name (PreludeC-45TypesC-45String-C-43C-43 ")(Value_Arglist*) = " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName e-7) "_arglist;")))))) (let ((act-26 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-6 u--f_ptr) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((u--returnLine (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeClosureFromArglist(" (PreludeC-45TypesC-45String-C-43C-43 u--f_ptr_name (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-5 ")")))))) (vector 1 (cons u--returnLine u--returnLine)))))))))))))))))))))) ((3) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (lambda (eta-0) (vector 1 (cons (PreludeC-45TypesC-45String-C-43C-43 "apply_closure(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-12) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-13) ")")))) (PreludeC-45TypesC-45String-C-43C-43 "tailcall_apply_closure(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-12) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-13) ")")))))))))) ((4) (let ((e-14 (vector-ref arg-4 1))) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (let ((e-17 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-14 (PreludeC-45TypesC-45String-C-43C-43 "Value * var_" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-15) (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (car e-5))) e-0) ";"))))) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CompilerC-45RefCC-45RefC-registerVariableForAutomaticFreeing arg-1 (PreludeC-45TypesC-45String-C-43C-43 "var_" (PreludeC-45Show-u--show_Show_Int e-15)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-17) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 e-8))))))))))))))))))))) ((5) (let ((e-18 (vector-ref arg-4 1))) (let ((e-19 (vector-ref arg-4 2))) (let ((e-20 (vector-ref arg-4 3))) (let ((e-21 (vector-ref arg-4 4))) (let ((e-22 (vector-ref arg-4 5))) (lambda (clam-0) (cond ((equal? e-20 10) (if (null? e-22) (vector 1 (cons "(Value*)NULL" "(Value*)NULL")) (let ((act-24 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--constr (PreludeC-45TypesC-45String-C-43C-43 "constructor_" (PreludeC-45Show-u--show_Show_Nat e-5)))) (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-18 (PreludeC-45TypesC-45String-C-43C-43 "Value_Constructor* " (PreludeC-45TypesC-45String-C-43C-43 u--constr (PreludeC-45TypesC-45String-C-43C-43 " = newConstructor(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-22)) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-showTag e-21) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName e-19) (PreludeC-45TypesC-45String-C-43C-43 "\"" ");"))))))))))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-18 (PreludeC-45TypesC-45String-C-43C-43 " // constructor " (CompilerC-45RefCC-45RefC-cName e-19))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CompilerC-45RefCC-45RefC-fillConstructorArgs arg-2 arg-3 u--constr e-22 0 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (cons (PreludeC-45TypesC-45String-C-43C-43 "(Value*)" u--constr) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)" u--constr)))))))))))))))))))(else (let ((act-24 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--constr (PreludeC-45TypesC-45String-C-43C-43 "constructor_" (PreludeC-45Show-u--show_Show_Nat e-5)))) (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-18 (PreludeC-45TypesC-45String-C-43C-43 "Value_Constructor* " (PreludeC-45TypesC-45String-C-43C-43 u--constr (PreludeC-45TypesC-45String-C-43C-43 " = newConstructor(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-22)) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-showTag e-21) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 "\"" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName e-19) (PreludeC-45TypesC-45String-C-43C-43 "\"" ");"))))))))))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-18 (PreludeC-45TypesC-45String-C-43C-43 " // constructor " (CompilerC-45RefCC-45RefC-cName e-19))) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CompilerC-45RefCC-45RefC-fillConstructorArgs arg-2 arg-3 u--constr e-22 0 clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 (cons (PreludeC-45TypesC-45String-C-43C-43 "(Value*)" u--constr) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)" u--constr)))))))))))))))))))))))))) ((6) (let ((e-26 (vector-ref arg-4 3))) (let ((e-27 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 (CompilerC-45RefCC-45RefC-cArgsVectANF e-27 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--opStatement (CompilerC-45RefCC-45RefC-cOp e-26 e-5))) (vector 1 (cons u--opStatement u--opStatement))))))))))) ((7) (let ((e-28 (vector-ref arg-4 1))) (let ((e-30 (vector-ref arg-4 3))) (let ((e-31 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-28 (PreludeC-45TypesC-45String-C-43C-43 "// call to external primitive " (CompilerC-45RefCC-45RefC-cName e-30))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((u--returnLine (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cCleanString (CompilerC-45RefCC-45RefC-u--show_Show_ExtPrim (CompilerC-45RefCC-45RefC-toPrim e-30))) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CompilerC-45RefCC-45RefC-varName eta-1)) e-31)) ")"))))) (vector 1 (cons u--returnLine u--returnLine))))))))))) ((8) (let ((e-32 (vector-ref arg-4 1))) (let ((e-33 (vector-ref arg-4 2))) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CompilerC-45RefCC-45RefC-getNewVarThatWillNotBeFreedAtEndOfBlock arg-0 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--newValueLine (PreludeC-45TypesC-45String-C-43C-43 "Value * " (PreludeC-45TypesC-45String-C-43C-43 e-6 " = NULL;")))) (let ((u--constructorField (PreludeC-45TypesC-45String-C-43C-43 "constructorField_" (PreludeC-45Show-u--show_Show_Nat e-5)))) (let ((u--constructorFieldLine (PreludeC-45TypesC-45String-C-43C-43 "AConAlt * " (PreludeC-45TypesC-45String-C-43C-43 u--constructorField (PreludeC-45TypesC-45String-C-43C-43 "= newConstructorField(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-34)) ");")))))) (let ((u--switchLine (PreludeC-45TypesC-45String-C-43C-43 "switch(compareConstructors(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-33) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 u--constructorField (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-34)) ")){")))))))) (let ((act-26 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-32 u--newValueLine) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-32 u--constructorFieldLine) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CompilerC-45RefCC-45RefC-copyConstructors arg-0 arg-1 arg-2 arg-3 (CompilerC-45RefCC-45RefC-varName e-33) e-34 u--constructorField e-6 0) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-32 u--switchLine) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 ((CompilerC-45RefCC-45RefC-conBlocks arg-0 arg-1 arg-2 arg-3 (CompilerC-45RefCC-45RefC-varName e-33) e-34 e-6 0) eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (if (null? e-35) (let ((act-31 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "}") eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "free(" (PreludeC-45TypesC-45String-C-43C-43 u--constructorField ");"))) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (vector 1 (cons e-6 e-6)))))))) (let ((e-2 (unbox e-35))) (let ((act-31 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  default : {") eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((act-32 (CompilerC-45RefCC-45RefC-increaseIndentation arg-3 eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (let ((act-33 (CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-1 eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-3 (vector-ref act-33 1))) (vector 0 e-3))) (else (let ((act-34 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-2) eta-0))) (case (vector-ref act-34 0) ((0) (let ((e-3 (vector-ref act-34 1))) (vector 0 e-3))) (else (let ((e-15 (vector-ref act-34 1))) (let ((act-35 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 e-6 (PreludeC-45TypesC-45String-C-43C-43 " = " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (car e-15))) e-0) ";")))) eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-3 (vector-ref act-35 1))) (vector 0 e-3))) (else (let ((act-36 (CompilerC-45RefCC-45RefC-freeTmpVars arg-1 arg-2 arg-3 eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-3 (vector-ref act-36 1))) (vector 0 e-3))) (else (let ((act-37 (CompilerC-45RefCC-45RefC-decreaseIndentation arg-3 eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-3 (vector-ref act-37 1))) (vector 0 e-3))) (else (let ((act-38 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  }") eta-0))) (case (vector-ref act-38 0) ((0) (let ((e-3 (vector-ref act-38 1))) (vector 0 e-3))) (else (let ((act-39 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "}") eta-0))) (case (vector-ref act-39 0) ((0) (let ((e-3 (vector-ref act-39 1))) (vector 0 e-3))) (else (let ((act-40 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "free(" (PreludeC-45TypesC-45String-C-43C-43 u--constructorField ");"))) eta-0))) (case (vector-ref act-40 0) ((0) (let ((e-3 (vector-ref act-40 1))) (vector 0 e-3))) (else (vector 1 (cons e-6 e-6)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) ((9) (let ((e-36 (vector-ref arg-4 1))) (let ((e-37 (vector-ref arg-4 2))) (let ((e-38 (vector-ref arg-4 3))) (let ((e-39 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-24 (CompilerC-45RefCC-45RefC-getNewVarThatWillNotBeFreedAtEndOfBlock arg-0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--newValueLine (PreludeC-45TypesC-45String-C-43C-43 "Value * " (PreludeC-45TypesC-45String-C-43C-43 e-5 " = NULL;")))) (let ((act-25 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-36 u--newValueLine) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((sc3 (CompilerC-45RefCC-45RefC-integer_switch e-38))) (cond ((equal? sc3 1) (let ((act-26 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-36 (PreludeC-45TypesC-45String-C-43C-43 "switch(extractInt(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-37) ")){"))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CompilerC-45RefCC-45RefC-constBlockSwitch arg-0 arg-1 arg-2 arg-3 e-38 e-5 0) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CompilerC-45RefCC-45RefC-constDefaultBlock arg-0 arg-1 arg-2 arg-3 e-39 e-5 eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "}") eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 (cons e-5 e-5))))))))))))))) (else (let ((act-26 ((CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst arg-0 arg-1 arg-2 arg-3 e-38 0 "" "") eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-27 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-36 (PreludeC-45TypesC-45String-C-43C-43 "switch(" (PreludeC-45TypesC-45String-C-43C-43 e-3 (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-varName e-37) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-length e-38)) (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-2 ")){"))))))))) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 ((CompilerC-45RefCC-45RefC-constBlockSwitch arg-0 arg-1 arg-2 arg-3 e-38 e-5 0) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (CompilerC-45RefCC-45RefC-constDefaultBlock arg-0 arg-1 arg-2 arg-3 e-39 e-5 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((act-30 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "}") eta-0))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (PreludeC-45TypesC-45String-C-43C-43 "free(" (PreludeC-45TypesC-45String-C-43C-43 e-2 ");"))) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (vector 1 (cons e-5 e-5)))))))))))))))))))))))))))))))))))))))) ((10) (let ((e-41 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (cons (CompilerC-45RefCC-45RefC-cConstant e-41) (CompilerC-45RefCC-45RefC-cConstant e-41)))))) ((11) (lambda (eta-0) (vector 1 (cons "NULL" "NULL")))) (else (let ((e-43 (vector-ref arg-4 1))) (lambda (eta-0) (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-43 "// CRASH") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (cons "NULL" "NULL")))))))))))
(define CompilerC-45RefCC-45RefC-cOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((5) (let ((e-0 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-20 (car arg-2))) (let ((e-21 (cdr arg-2))) (if (null? e-21) (PreludeC-45TypesC-45String-C-43C-43 "negate_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-0) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-20 ")")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))) ((16) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-25 (car arg-2))) (let ((e-26 (cdr arg-2))) (if (null? e-26) (PreludeC-45TypesC-45String-C-43C-43 "stringLength(" (PreludeC-45TypesC-45String-C-43C-43 e-25 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((17) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-30 (car arg-2))) (let ((e-31 (cdr arg-2))) (if (null? e-31) (PreludeC-45TypesC-45String-C-43C-43 "head(" (PreludeC-45TypesC-45String-C-43C-43 e-30 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((18) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-35 (car arg-2))) (let ((e-36 (cdr arg-2))) (if (null? e-36) (PreludeC-45TypesC-45String-C-43C-43 "tail(" (PreludeC-45TypesC-45String-C-43C-43 e-35 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((22) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-40 (car arg-2))) (let ((e-41 (cdr arg-2))) (if (null? e-41) (PreludeC-45TypesC-45String-C-43C-43 "reverse(" (PreludeC-45TypesC-45String-C-43C-43 e-40 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((36) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-45 (car arg-2))) (let ((e-46 (cdr arg-2))) (if (null? e-46) (PreludeC-45TypesC-45String-C-43C-43 "cast_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-1) (PreludeC-45TypesC-45String-C-43C-43 "_to_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-2) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-45 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))) ((24) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-50 (car arg-2))) (let ((e-51 (cdr arg-2))) (if (null? e-51) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(exp(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-50 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((25) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-55 (car arg-2))) (let ((e-56 (cdr arg-2))) (if (null? e-56) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(log(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-55 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((26) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-60 (car arg-2))) (let ((e-61 (cdr arg-2))) (if (null? e-61) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-64 (car e-61))) (let ((e-65 (cdr e-61))) (if (null? e-65) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(pow(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-60 (PreludeC-45TypesC-45String-C-43C-43 "), unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-64 ")))")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))) ((27) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-69 (car arg-2))) (let ((e-70 (cdr arg-2))) (if (null? e-70) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(sin(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-69 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((28) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-74 (car arg-2))) (let ((e-75 (cdr arg-2))) (if (null? e-75) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(cos(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-74 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((29) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (if (null? e-80) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(tan(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-79 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((30) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-84 (car arg-2))) (let ((e-85 (cdr arg-2))) (if (null? e-85) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(asin(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-84 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((31) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-89 (car arg-2))) (let ((e-90 (cdr arg-2))) (if (null? e-90) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(acos(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-89 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((32) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-94 (car arg-2))) (let ((e-95 (cdr arg-2))) (if (null? e-95) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(atan(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-94 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((33) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-99 (car arg-2))) (let ((e-100 (cdr arg-2))) (if (null? e-100) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(sqrt(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-99 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((34) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-104 (car arg-2))) (let ((e-105 (cdr arg-2))) (if (null? e-105) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(floor(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-104 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((35) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-109 (car arg-2))) (let ((e-110 (cdr arg-2))) (if (null? e-110) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(ceil(unpackDouble(" (PreludeC-45TypesC-45String-C-43C-43 e-109 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((0) (let ((e-3 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-114 (car arg-2))) (let ((e-115 (cdr arg-2))) (if (null? e-115) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-118 (car e-115))) (let ((e-119 (cdr e-115))) (if (null? e-119) (PreludeC-45TypesC-45String-C-43C-43 "add_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-3) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-114 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-118 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-123 (car arg-2))) (let ((e-124 (cdr arg-2))) (if (null? e-124) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-127 (car e-124))) (let ((e-128 (cdr e-124))) (if (null? e-128) (PreludeC-45TypesC-45String-C-43C-43 "sub_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-4) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-123 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-127 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-132 (car arg-2))) (let ((e-133 (cdr arg-2))) (if (null? e-133) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-136 (car e-133))) (let ((e-137 (cdr e-133))) (if (null? e-137) (PreludeC-45TypesC-45String-C-43C-43 "mul_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-5) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-132 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-136 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((3) (let ((e-6 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-141 (car arg-2))) (let ((e-142 (cdr arg-2))) (if (null? e-142) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-145 (car e-142))) (let ((e-146 (cdr e-142))) (if (null? e-146) (PreludeC-45TypesC-45String-C-43C-43 "div_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-6) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-141 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-145 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((4) (let ((e-7 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-150 (car arg-2))) (let ((e-151 (cdr arg-2))) (if (null? e-151) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-154 (car e-151))) (let ((e-155 (cdr e-151))) (if (null? e-155) (PreludeC-45TypesC-45String-C-43C-43 "mod_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-7) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-150 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-154 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((6) (let ((e-8 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-159 (car arg-2))) (let ((e-160 (cdr arg-2))) (if (null? e-160) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-163 (car e-160))) (let ((e-164 (cdr e-160))) (if (null? e-164) (PreludeC-45TypesC-45String-C-43C-43 "shiftl_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-8) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-159 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-163 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((7) (let ((e-9 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-168 (car arg-2))) (let ((e-169 (cdr arg-2))) (if (null? e-169) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-172 (car e-169))) (let ((e-173 (cdr e-169))) (if (null? e-173) (PreludeC-45TypesC-45String-C-43C-43 "shiftr_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-9) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-168 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-172 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((8) (let ((e-10 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-177 (car arg-2))) (let ((e-178 (cdr arg-2))) (if (null? e-178) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-181 (car e-178))) (let ((e-182 (cdr e-178))) (if (null? e-182) (PreludeC-45TypesC-45String-C-43C-43 "and_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-10) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-177 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-181 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((9) (let ((e-11 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-186 (car arg-2))) (let ((e-187 (cdr arg-2))) (if (null? e-187) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-190 (car e-187))) (let ((e-191 (cdr e-187))) (if (null? e-191) (PreludeC-45TypesC-45String-C-43C-43 "or_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-11) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-186 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-190 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((10) (let ((e-12 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-195 (car arg-2))) (let ((e-196 (cdr arg-2))) (if (null? e-196) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-199 (car e-196))) (let ((e-200 (cdr e-196))) (if (null? e-200) (PreludeC-45TypesC-45String-C-43C-43 "xor_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-12) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-195 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-199 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((11) (let ((e-13 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-204 (car arg-2))) (let ((e-205 (cdr arg-2))) (if (null? e-205) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-208 (car e-205))) (let ((e-209 (cdr e-205))) (if (null? e-209) (PreludeC-45TypesC-45String-C-43C-43 "lt_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-13) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-204 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-208 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((15) (let ((e-14 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-213 (car arg-2))) (let ((e-214 (cdr arg-2))) (if (null? e-214) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-217 (car e-214))) (let ((e-218 (cdr e-214))) (if (null? e-218) (PreludeC-45TypesC-45String-C-43C-43 "gt_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-14) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-213 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-217 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((13) (let ((e-15 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-222 (car arg-2))) (let ((e-223 (cdr arg-2))) (if (null? e-223) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-226 (car e-223))) (let ((e-227 (cdr e-223))) (if (null? e-227) (PreludeC-45TypesC-45String-C-43C-43 "eq_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-15) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-222 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-226 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((12) (let ((e-16 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-231 (car arg-2))) (let ((e-232 (cdr arg-2))) (if (null? e-232) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-235 (car e-232))) (let ((e-236 (cdr e-232))) (if (null? e-236) (PreludeC-45TypesC-45String-C-43C-43 "lte_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-16) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-231 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-235 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((14) (let ((e-17 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-240 (car arg-2))) (let ((e-241 (cdr arg-2))) (if (null? e-241) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-244 (car e-241))) (let ((e-245 (cdr e-241))) (if (null? e-245) (PreludeC-45TypesC-45String-C-43C-43 "gte_" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cConstant e-17) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-240 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-244 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((19) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-249 (car arg-2))) (let ((e-250 (cdr arg-2))) (if (null? e-250) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-253 (car e-250))) (let ((e-254 (cdr e-250))) (if (null? e-254) (PreludeC-45TypesC-45String-C-43C-43 "strIndex(" (PreludeC-45TypesC-45String-C-43C-43 e-249 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-253 ")")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))) ((20) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-258 (car arg-2))) (let ((e-259 (cdr arg-2))) (if (null? e-259) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-262 (car e-259))) (let ((e-263 (cdr e-259))) (if (null? e-263) (PreludeC-45TypesC-45String-C-43C-43 "strCons(" (PreludeC-45TypesC-45String-C-43C-43 e-258 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-262 ")")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))) ((21) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-267 (car arg-2))) (let ((e-268 (cdr arg-2))) (if (null? e-268) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-271 (car e-268))) (let ((e-272 (cdr e-268))) (if (null? e-272) (PreludeC-45TypesC-45String-C-43C-43 "strAppend(" (PreludeC-45TypesC-45String-C-43C-43 e-267 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-271 ")")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))) ((23) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-276 (car arg-2))) (let ((e-277 (cdr arg-2))) (if (null? e-277) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-280 (car e-277))) (let ((e-281 (cdr e-277))) (if (null? e-281) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-284 (car e-281))) (let ((e-285 (cdr e-281))) (if (null? e-285) (PreludeC-45TypesC-45String-C-43C-43 "strSubstr(" (PreludeC-45TypesC-45String-C-43C-43 e-276 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-280 (PreludeC-45TypesC-45String-C-43C-43 ", " (PreludeC-45TypesC-45String-C-43C-43 e-284 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))))) ((37) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-290 (cdr arg-2))) (if (null? e-290) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-294 (cdr e-290))) (if (null? e-294) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-297 (car e-294))) (let ((e-298 (cdr e-294))) (if (null? e-298) (PreludeC-45TypesC-45String-C-43C-43 "newReference(" (PreludeC-45TypesC-45String-C-43C-43 e-297 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((38) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-303 (cdr arg-2))) (if (null? e-303) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-306 (car e-303))) (let ((e-307 (cdr e-303))) (if (null? e-307) (PreludeC-45TypesC-45String-C-43C-43 "idris2_crash(" (PreludeC-45TypesC-45String-C-43C-43 e-306 ");")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))(else (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TT-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))
(define CompilerC-45RefCC-45RefC-cName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cCleanString (CoreC-45NameC-45Namespace-showNSWithSep "_" e-0)) (PreludeC-45TypesC-45String-C-43C-43 "_" (CompilerC-45RefCC-45RefC-cName e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-cUserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cCleanString e-3) (PreludeC-45TypesC-45String-C-43C-43 "_" (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_Int e-4))))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "pat__" (CompilerC-45RefCC-45RefC-cName e-5)))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CompilerC-45RefCC-45RefC-cName e-8))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "n__" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-245) e-9)) (PreludeC-45TypesC-45String-C-43C-43 "_" (CompilerC-45RefCC-45RefC-cName e-10))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "case__" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_String e-11)) (PreludeC-45TypesC-45String-C-43C-43 "_" (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_Int e-12)))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "with__" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_String e-13)) (PreludeC-45TypesC-45String-C-43C-43 "_" (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_Int e-14)))))))) (else (let ((e-15 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "fn__" (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_Int e-15))))))))
(define CompilerC-45RefCC-45RefC-cConstant (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeInt64(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-showIntMin e-0) ")")))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeInt8(INT8_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int8 e-1) "))")))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeInt16(INT16_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int16 e-2) "))")))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeInt32(INT32_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int32 e-3) "))")))) ((4) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeInt64(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-showInt64Min e-4) ")")))) ((5) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeIntegerLiteral(\"" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Integer e-5) "\")")))) ((12) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeDouble(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Double e-6) ")")))) ((11) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeChar(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-escapeChar e-7) ")")))) ((10) (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeString(" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cStringQuoted e-8) ")")))) ((13) "(Value*)makeWorld()") ((14) "Int64") ((15) "Int8") ((16) "Int16") ((17) "Int32") ((18) "Int64") ((19) "Integer") ((24) "string") ((25) "char") ((26) "double") ((27) "f32") ((6) (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeBits8(UINT8_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Bits8 e-9) "))")))) ((7) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeBits16(UINT16_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Bits16 e-10) "))")))) ((8) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeBits32(UINT32_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Bits32 e-11) "))")))) ((9) (let ((e-12 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "(Value*)makeBits64(UINT64_C(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Bits64 e-12) "))")))) ((20) "Bits8") ((21) "Bits16") ((22) "Bits32") (else "Bits64"))))
(define CompilerC-45RefCC-45RefC-cCleanString (lambda (arg-0) (CompilerC-45RefCC-45RefC-showcCleanString (PreludeC-45Types-fastUnpack arg-0) "")))
(define CompilerC-45RefCC-45RefC-cArgsVectANF (lambda (arg-1 ext-0) (if (null? arg-1) (vector 1 '()) (let ((e-3 (car arg-1))) (let ((e-4 (cdr arg-1))) (let ((act-24 (CompilerC-45RefCC-45RefC-cArgsVectANF e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (CompilerC-45RefCC-45RefC-varName e-3) e-5)))))))))))
(define CompilerC-45RefCC-45RefC-additionalFFIStub (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((20) (let ((e-0 (vector-ref arg-2 1))) (CompilerC-45RefCC-45RefC-additionalFFIStub arg-0 (CompilerC-45RefCC-45RefC-discardLastArgument arg-1) e-0)))(else (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cTypeOfCFType arg-2) (PreludeC-45TypesC-45String-C-43C-43 " (*" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45RefC-cName arg-0) (PreludeC-45TypesC-45String-C-43C-43 ")(" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) (DataC-45List-intersperse ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CompilerC-45RefCC-45RefC-cTypeOfCFType eta-0)) arg-1))) ") = (void*)missing_ffi;\xa;")))))))))
(define CompilerC-45RefCC-45RefC-addHeader (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (set-box! arg-0 (LibrariesC-45DataC-45SortedSet-insert arg-1 e-5)))) (vector 1 act-25))))))))
(define CompilerC-45RefCC-45RefC-addCommaToList (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons (PreludeC-45TypesC-45String-C-43C-43 "  " e-2) (PreludeC-45Types-u--map_Functor_List (lambda (arg-1) (PreludeC-45TypesC-45String-C-43C-43 ", " arg-1)) e-3)))))))
(define LibrariesC-45DataC-45DList-snoc (lambda (arg-1 arg-2 ext-0) (arg-1 (cons arg-2 ext-0))))
(define LibrariesC-45DataC-45DList-reify (lambda (arg-1) (arg-1 '())))
(define LibrariesC-45DataC-45DList-appendR (lambda (arg-1 arg-2 ext-0) (arg-1 (PreludeC-45TypesC-45List-tailRecAppend arg-2 ext-0))))
(define LibrariesC-45DataC-45DList-appendL (lambda (arg-1 arg-2 ext-0) (PreludeC-45TypesC-45List-tailRecAppend arg-1 (arg-2 ext-0))))
(define LibrariesC-45DataC-45DList-Nil (lambda (ext-0) ext-0))
(define CompilerC-45RefCC-45CC-n--6094-4489-u--clibdirs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45Interfaces-concat (csegen-67) (PreludeC-45Types-u--map_Functor_List (lambda (u--d) (PreludeC-45TypesC-45String-C-43C-43 "-L" (PreludeC-45TypesC-45String-C-43C-43 u--d " "))) arg-4))))
(define CompilerC-45RefCC-45CC-fullprefix_dir (lambda (arg-0 arg-1) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-5 (vector-ref arg-0 5))) e-5) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (csegen-1224) arg-1))))
(define CompilerC-45RefCC-45CC-findCC (lambda (ext-0) (let ((act-24 ((System-getEnv (csegen-3) "IDRIS2_CC") ext-0))) (if (null? act-24) (let ((act-25 ((System-getEnv (csegen-3) "CC") ext-0))) (if (null? act-25) "cc" (let ((e-2 (unbox act-25))) e-2))) (let ((e-2 (unbox act-24))) e-2)))))
(define CompilerC-45RefCC-45CC-compileCObjectFile (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (CompilerC-45RefCC-45CC-findCC ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--libraryFlag (cond ((equal? arg-1 1) "-fpic ") (else "")))) (let ((u--runccobj (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " -Werror -c " (PreludeC-45TypesC-45String-C-43C-43 u--libraryFlag (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 " -o " (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 "-I" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45CC-fullprefix_dir e-6 "refc ") (PreludeC-45TypesC-45String-C-43C-43 "-I" (CompilerC-45RefCC-45CC-fullprefix_dir e-6 "include"))))))))))))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "compiler.refc.cc" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () u--runccobj) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 ((System-system (csegen-3) u--runccobj) ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? e-8 0) (vector 1 (box arg-3)))(else (vector 1 '()))))))))))))))))))))))
(define CompilerC-45RefCC-45CC-compileCFile (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (CompilerC-45RefCC-45CC-findCC ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--sharedFlag (cond ((equal? arg-1 1) "-shared ") (else "")))) (let ((u--runcc (PreludeC-45TypesC-45String-C-43C-43 e-5 (PreludeC-45TypesC-45String-C-43C-43 " -Werror " (PreludeC-45TypesC-45String-C-43C-43 u--sharedFlag (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 " -o " (PreludeC-45TypesC-45String-C-43C-43 arg-3 (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (CompilerC-45RefCC-45CC-fullprefix_dir e-6 "lib") "libidris2_support.a") (PreludeC-45TypesC-45String-C-43C-43 " " (PreludeC-45TypesC-45String-C-43C-43 "-lidris2_refc " (PreludeC-45TypesC-45String-C-43C-43 "-L" (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45CC-fullprefix_dir e-6 "refc ") (PreludeC-45TypesC-45String-C-43C-43 (CompilerC-45RefCC-45CC-n--6094-4489-u--clibdirs arg-3 arg-2 arg-1 arg-0 (let ((e-8 (vector-ref e-6 8))) e-8)) "-lgmp -lm"))))))))))))))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "compiler.refc.cc" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () u--runcc) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 ((System-system (csegen-3) u--runcc) ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (cond ((equal? e-8 0) (vector 1 (box arg-3)))(else (vector 1 '()))))))))))))))))))))))
(define IdrisC-45ModTree-case--buildMod-1848 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-24 (CoreC-45ContextC-45Log-log arg-6 "import" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (DataC-45String-unwords (cons "Checking whether to rebuild " (cons arg-7 (cons (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-9 ")")) '()))))) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (IdrisC-45ModTree-needsBuilding arg-6 arg-4 arg-7 arg-9 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-newRef (vector "Core.UnifyState.UST" ) (CoreC-45UnifyState-initUState) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata (vector 0 arg-8)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (let ((act-28 (set-box! arg-5 (IdrisC-45Syntax-initSyntax)))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((act-29 (cond ((equal? e-6 1) (((let ((u--pad (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat arg-1)) (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat arg-2)))))) (let ((u--msg (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (LibrariesC-45DataC-45StringC-45Extra-replicate u--pad #\ )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat arg-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-slash)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Nat arg-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "Building") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45NameC-45Namespace-u--pretty_Pretty_ModuleIdent (let ((e-1 (vector-ref arg-0 1))) e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String arg-7))))))) (lambda () (lambda (eta-0) (let ((act-29 (CoreC-45ContextC-45Log-log arg-6 "import.file" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Processing " arg-7)) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (IdrisC-45ProcessIdr-process arg-6 e-8 e-7 arg-5 arg-4 u--msg arg-7 arg-8 eta-0))))))))) ext-0)) (else (vector 1 '()))))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (unbox arg-6))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((act-31 (IdrisC-45REPLC-45Common-emitWarningsAndErrors arg-6 arg-4 arg-5 (let ((sc8 ((PreludeC-45Types-u--null_Foldable_List e-10)))) (cond ((equal? sc8 1) e-2) (else e-10))) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-12 (let ((sc9 ((PreludeC-45Types-u--null_Foldable_List e-10)))) (cond ((equal? sc9 1) e-2) (else (PreludeC-45TypesC-45List-tailRecAppend e-2 e-10)))))))))))))))))))))))))))))))))))))))
(define IdrisC-45ModTree-n--14716-2477-u--dropLater (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (cons e-2 (IdrisC-45ModTree-n--14716-2477-u--dropLater arg-0 arg-1 arg-2 arg-3 (DataC-45List-filter (lambda (u--x) (PreludeC-45EqOrd-u--C-47C-61_Eq_String (let ((e-0 (vector-ref u--x 0))) e-0) (let ((e-0 (vector-ref e-2 0))) e-0))) e-3))))))))
(define IdrisC-45ModTree-u--show_Show_BuildMod (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (vector-ref arg-0 0))) e-0) (PreludeC-45TypesC-45String-C-43C-43 " [" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent eta-0)) (let ((e-2 (vector-ref arg-0 2))) e-2))) "]")))))
(define IdrisC-45ModTree-u--showPrec_Show_BuildMod (lambda (arg-0 arg-1) (IdrisC-45ModTree-u--show_Show_BuildMod arg-1)))
(define IdrisC-45ModTree-needsBuildingTime (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45BinaryC-45Prims-modTime arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-modTime arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45BinaryC-45Prims-modTime eta-0 eta-1))) arg-2 '() ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (PreludeC-45Interfaces-any (csegen-51) (lambda (arg-3) (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-3 e-5)) (cons e-6 e-7)))))))))))))))))
(define IdrisC-45ModTree-needsBuildingHash (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-hashFileWith (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-4 9))) e-32)) arg-1 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 1) (let ((e-1 (unbox e-6))) (let ((act-26 (CoreC-45Binary-readHashes arg-2 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 1) (let ((e-2 (car e-7))) (if (null? e-2) (vector 1 1) (let ((e-8 (unbox e-2))) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-1) eta-1) e-9)))))) (lambda (eta-0) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45ModTree-checkDepHashes arg-0 eta-1 eta-2))) arg-3 '() eta-0)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-27 1))) (vector 1 (let ((sc7 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-1 e-8))) (cond ((equal? sc7 1) 1) (else e-9))))))))))))))))))))))))))))
(define IdrisC-45ModTree-needsBuilding (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45Meta-exists (csegen-3) arg-3) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (let ((act-25 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc3 (let ((e-20 (vector-ref e-6 20))) e-20))) (cond ((equal? sc3 1) (IdrisC-45ModTree-needsBuildingHash arg-0 arg-2 arg-3 arg-4 ext-0)) (else (IdrisC-45ModTree-needsBuildingTime arg-2 arg-3 arg-4 ext-0)))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 0) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "import" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Hashes still valid for " arg-2)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-0 1))) (vector 1 (let ((e-3 (vector-ref e-8 3))) e-3)))))) (lambda (eta-0) (let ((act-27 (unbox arg-1))) (vector 1 act-27))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (if (null? e-8) (vector 1 0) (let ((e-1 (unbox e-8))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-0 "totality.requirement" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45Interfaces-concat (csegen-67) (cons "Checking totality requirement of " (cons arg-2 (cons " (main file is " (cons e-1 (cons ")" '()))))))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((sc8 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-2 e-1))) (cond ((equal? sc8 1) (let ((act-29 (let ((act-29 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref eta-0 1))) (vector 1 (let ((e-30 (vector-ref e-10 1))) e-30)))))) (lambda (eta-0) (CoreC-45Context-getSession arg-0 eta-0)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (IdrisC-45ModTree-checkTotalReq arg-0 arg-2 arg-3 e-10 ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (cond ((equal? e-10 1) (let ((act-30 (let ((act-30 ((SystemC-45FileC-45ReadWrite-removeFile (csegen-3) arg-3) ext-0))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (case (vector-ref e-11 0) ((1) (let ((e-2 (vector-ref e-11 1))) (cond (else (vector 1 1))))) (else (let ((e-12 (vector-ref e-11 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-3 e-12) ext-0))))))))) (else (vector 1 0)))))))) (else (vector 1 0))))))))))))))))) (else (vector 1 1)))))))) (else (vector 1 1)))))))))
(define IdrisC-45ModTree-mkModTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((sc0 (PreludeC-45Types-elem (csegen-1486) arg-6 arg-4))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 55 (PreludeC-45TypesC-45List-tailRecAppend arg-4 (cons arg-6 '()))) ext-0)) (else (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (DataC-45List-lookup (csegen-1486) arg-6 e-5))) (if (null? sc2) (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (CoreC-45Directory-nsToSource arg-0 arg-3 arg-6 eta-1))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1)))) arg-5) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45ProcessIdr-readHeader arg-0 arg-1 e-6 arg-6 eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--imps (PreludeC-45Types-u--map_Functor_List (csegen-3261) (let ((e-2 (vector-ref e-7 2))) e-2)))) (let ((sc5 (PreludeC-45Types-elem (csegen-1486) arg-6 u--imps))) (cond ((equal? sc5 1) (CoreC-45Core-coreFail (vector 55 (cons arg-6 (cons arg-6 '()))) eta-0)) (else (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45ModTree-mkModTree arg-0 arg-1 arg-2 arg-3 (cons arg-6 arg-4) '() eta-1 eta-2))) u--imps '() eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--mt (vector arg-6 (box e-6) e-8))) (let ((act-28 (let ((act-28 (unbox arg-2))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (set-box! arg-2 (cons (cons arg-6 u--mt) e-9)))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 u--mt))))))))))))))))))))))))) (let ((e-2 (unbox sc2))) (vector 1 e-2))))))))) (lambda (u--err) (lambda (clam-1) (case (vector-ref u--err 0) ((55) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-1)) ((53) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-1)) ((52) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-1)) ((51) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-1))(else (vector 1 (vector arg-6 '() '())))))) ext-0))))))
(define IdrisC-45ModTree-mkBuildMods (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-1 (vector-ref arg-2 1))) (if (null? e-1) (vector 1 0) (let ((e-3 (unbox e-1))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (LibrariesC-45DataC-45StringMap-lookup e-3 e-5))) (if (null? sc2) (let ((act-25 (CoreC-45Core-traverse_ (lambda (eta-0) (IdrisC-45ModTree-mkBuildMods arg-0 arg-1 eta-0)) (let ((e-4 (vector-ref arg-2 2))) e-4) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 (let ((act-26 (unbox arg-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (set-box! arg-1 (cons (vector e-3 (let ((e-9 (vector-ref arg-2 0))) e-9) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (let ((e-9 (vector-ref eta-0 0))) e-9)) (let ((e-4 (vector-ref arg-2 2))) e-4))) e-7)))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((act-28 (let ((act-28 (unbox arg-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (set-box! arg-0 (LibrariesC-45DataC-45StringMap-insert e-3 0 e-9)))) (vector 1 act-29)))))))))))))))) (vector 1 0)))))))))))))
(define IdrisC-45ModTree-getBuildMods (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Idris.ModTree.AllMods" ) '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Directory-ctxtPathToNS arg-0 arg-4 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((sc2 (PreludeC-45Types-elem (csegen-1486) e-6 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (let ((e-1 (vector-ref eta-0 1))) e-1)) arg-3)))) (cond ((equal? sc2 1) (vector 1 '())) (else (let ((act-26 (IdrisC-45ModTree-mkModTree arg-0 arg-1 e-5 arg-2 '() (box arg-4) e-6 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Core-newRef (vector "Idris.ModTree.DoneMod" ) (LibrariesC-45DataC-45StringMap-empty) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Core-newRef (vector "Idris.ModTree.BuildOrder" ) '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 ((IdrisC-45ModTree-mkBuildMods e-8 e-9 e-7) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (let ((act-30 (unbox e-9))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (vector 1 (PreludeC-45TypesC-45List-reverse e-11))))))))))))))))))))))))))))))))))
(define IdrisC-45ModTree-getAllBuildMods (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-24 (IdrisC-45ModTree-getBuildMods arg-0 arg-2 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45ModTree-getAllBuildMods arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend e-5 arg-4) e-3 ext-0))))))))))
(define IdrisC-45ModTree-checkTotalReq (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-24 (CoreC-45ContextC-45Log-log arg-0 "totality.requirement" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Reading totalReq from " arg-2)) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45Binary-readTotalReq arg-2 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((act-26 (CoreC-45ContextC-45Log-log arg-0 "totality.requirement" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (DataC-45String-unwords (cons "Got" (cons (CoreC-45TT-u--show_Show_TotalReq e-1) (cons "and expected" (cons (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45TT-u--show_Show_TotalReq arg-3) ":") (cons "we" (cons (let ((sc3 (CoreC-45TT-u--C-60_Ord_TotalReq e-1 arg-3))) (cond ((equal? sc3 1) "should") (else "shouldn't"))) (cons "rebuild" '()))))))))) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45TT-u--C-60_Ord_TotalReq e-1 arg-3))))))))))))))) (lambda (u--error) (lambda (eta-0) (vector 1 0))) ext-0)))
(define IdrisC-45ModTree-checkDepHashes (lambda (arg-0 arg-1 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45BinaryC-45Prims-hashFileWith (let ((e-4 (vector-ref e-5 4))) (let ((e-32 (vector-ref e-4 9))) e-32)) arg-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((act-26 (CoreC-45Directory-getTTCFileName arg-0 arg-1 "ttc" eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Binary-readHashes e-7 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (if (null? e-8) (vector 1 0) (let ((e-2 (car e-8))) (if (null? e-2) (vector 1 0) (let ((e-9 (unbox e-2))) (vector 1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-1 e-9))))))))))))))))))))))))) (lambda (u--error) (lambda (eta-0) (vector 1 0))) ext-0)))
(define IdrisC-45ModTree-buildMods (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 '()) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-24 (IdrisC-45ModTree-buildMod arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (IdrisC-45ModTree-buildMods arg-0 arg-1 arg-2 arg-3 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-4) arg-5 e-3 ext-0) (vector 1 e-5)))))))))))
(define IdrisC-45ModTree-buildMod (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 (CoreC-45Context-clearCtxt arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (CoreC-45InitPrimitives-addPrimitives arg-0 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-lazyActive arg-0 1 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Context-setUnboundImplicits arg-0 1 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((u--sourceFile (let ((e-0 (vector-ref arg-6 0))) e-0))) (let ((u--modNamespace (let ((e-1 (vector-ref arg-6 1))) e-1))) (let ((act-28 (CoreC-45Directory-getTTCFileName arg-0 u--sourceFile "ttc" ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Directory-nsToPath arg-0 arg-3 eta-0 eta-1))) (let ((e-2 (vector-ref arg-6 2))) e-2) '() ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (IdrisC-45ModTree-case--buildMod-1848 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--sourceFile u--modNamespace e-9 e-10 (DataC-45Either-partitionEithers e-10) ext-0)))))))))))))))))))))))))
(define IdrisC-45ModTree-buildDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (IdrisC-45ModTree-getBuildMods arg-0 arg-4 (vector 2 ) '() arg-5 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "import" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Needs to rebuild: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (IdrisC-45ModTree-u--show_Show_BuildMod u--x)) (lambda (u--d) (lambda (u--x) (IdrisC-45ModTree-u--showPrec_Show_BuildMod u--d u--x)))) e-5))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (IdrisC-45ModTree-buildMods arg-0 arg-1 arg-4 (vector 2 ) (+ 1 0) (PreludeC-45TypesC-45List-length e-5) e-5 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (let ((act-27 (CoreC-45Context-clearCtxt arg-0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (CoreC-45InitPrimitives-addPrimitives arg-0 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (CoreC-45Directory-ctxtPathToNS arg-0 arg-5 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 (set-box! arg-2 (CoreC-45Metadata-initMetadata (vector 0 e-10))))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (CoreC-45Directory-getTTCFileName arg-0 arg-5 "ttc" ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (CoreC-45ContextC-45Log-log arg-0 "import" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Reloading " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-12) (PreludeC-45TypesC-45String-C-43C-43 " from " arg-5)))) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((act-33 (IdrisC-45ProcessIdr-readAsMain arg-0 arg-3 arg-1 e-12 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-2 (vector-ref act-33 1))) (vector 0 e-2))) (else (let ((act-34 (CoreC-45Directory-getTTCFileName arg-0 arg-5 "ttm" ext-0))) (case (vector-ref act-34 0) ((0) (let ((e-2 (vector-ref act-34 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-34 1))) (let ((act-35 (CoreC-45ContextC-45Log-log arg-0 "import" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Reloading " (PreludeC-45Show-u--show_Show_String e-15))) ext-0))) (case (vector-ref act-35 0) ((0) (let ((e-2 (vector-ref act-35 1))) (vector 0 e-2))) (else (let ((act-36 (CoreC-45Metadata-readFromTTM arg-2 e-15 ext-0))) (case (vector-ref act-36 0) ((0) (let ((e-2 (vector-ref act-36 1))) (vector 0 e-2))) (else (vector 1 '())))))))))))))))))))))))))))))))))) (vector 1 e-7)))))))))))))))
(define IdrisC-45ModTree-buildAll (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (IdrisC-45ModTree-getAllBuildMods arg-0 arg-1 arg-2 (vector 2 ) '() arg-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--modsC-39 (IdrisC-45ModTree-n--14716-2477-u--dropLater arg-3 arg-2 arg-1 arg-0 e-5))) (IdrisC-45ModTree-buildMods arg-0 arg-1 arg-2 (vector 2 ) (+ 1 0) (PreludeC-45TypesC-45List-length u--modsC-39) u--modsC-39 ext-0))))))))
(define IdrisC-45IDEModeC-45MakeClause-case--makeWith-3910 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--isrc (let ((sc1 (DataC-45String-span (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (PreludeC-45TypesC-45String-length e-5) e-4)))))) (let ((u--indent (Builtin-fst u--isrc))) (let ((u--src (Builtin-snd u--isrc))) (let ((u--lhs (PreludeC-45Types-fastPack (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 0 (PreludeC-45Types-fastUnpack u--src))))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45MakeClause-n--3891-3824-u--mkWithArg arg-0 arg-1 e-2 u--indent u--lhs) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (IdrisC-45IDEModeC-45MakeClause-n--3891-3825-u--mkWithPat arg-0 arg-1 e-2 u--indent u--lhs)))))))))))
(define IdrisC-45IDEModeC-45MakeClause-n--4035-3959-u--replaceStr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 "") "")(else (let ((sc0 (DataC-45String-isPrefixOf arg-4 arg-6))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45MakeClause-n--4035-3958-u--addCase arg-0 arg-1 arg-2 arg-3 arg-5) (PreludeC-45Types-fastPack (DataC-45List-drop (PreludeC-45TypesC-45String-length arg-4) (PreludeC-45Types-fastUnpack arg-6))))) (else (PreludeC-45Types-strCons (string-ref arg-6 0) (IdrisC-45IDEModeC-45MakeClause-n--4035-3959-u--replaceStr arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat (PreludeC-45Types-u--fromInteger_Num_Nat 1) arg-3) arg-4 arg-5 (substring arg-6 1 (string-length arg-6)))))))))))
(define IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) (if (null? arg-3) (if (null? arg-3) '() (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? e-1 #\() (cons #\( (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (+ 1 arg-2) e-2))) ((equal? e-1 #\{) (cons #\{ (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (+ 1 arg-2) e-2))) ((equal? e-1 #\)) (cons #\) (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2))) ((equal? e-1 #\}) (cons #\} (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2)))(else (cons e-1 (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 arg-2 e-2))))))) (let ((e-5 (car arg-3))) (cond ((equal? e-5 #\=) '())(else (if (null? arg-3) '() (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? e-1 #\() (cons #\( (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (+ 1 arg-2) e-2))) ((equal? e-1 #\{) (cons #\{ (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (+ 1 arg-2) e-2))) ((equal? e-1 #\)) (cons #\) (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2))) ((equal? e-1 #\}) (cons #\} (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2)))(else (cons e-1 (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 arg-2 e-2))))))))))))(else (if (null? arg-3) '() (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? e-1 #\() (cons #\( (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (+ 1 arg-2) e-2))) ((equal? e-1 #\{) (cons #\{ (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (+ 1 arg-2) e-2))) ((equal? e-1 #\)) (cons #\) (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2))) ((equal? e-1 #\}) (cons #\} (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2)))(else (cons e-1 (IdrisC-45IDEModeC-45MakeClause-n--3891-3822-u--readLHS arg-0 arg-1 arg-2 e-2)))))))))))
(define IdrisC-45IDEModeC-45MakeClause-n--3891-3823-u--pref (lambda (arg-0 arg-1 arg-2 arg-3) (ParserC-45Unlit-relit arg-2 (PreludeC-45Types-fastPack (DataC-45List-replicate arg-3 #\ )))))
(define IdrisC-45IDEModeC-45MakeClause-n--4035-3960-u--newLines (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45IDEModeC-45MakeClause-n--4035-3959-u--replaceStr arg-0 arg-1 arg-2 0 (PreludeC-45TypesC-45String-C-43C-43 "?" (CoreC-45Name-u--show_Show_Name arg-1)) arg-3 arg-0)))
(define IdrisC-45IDEModeC-45MakeClause-n--3891-3825-u--mkWithPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45MakeClause-n--3891-3823-u--pref arg-0 arg-1 arg-2 (PreludeC-45Types-u--C-43_Num_Nat arg-3 (+ 1 (+ 1 0)))) (PreludeC-45TypesC-45String-C-43C-43 arg-4 (PreludeC-45TypesC-45String-C-43C-43 "| with_pat = ?" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45MakeClause-showRHSName arg-1) "_rhs"))))))
(define IdrisC-45IDEModeC-45MakeClause-n--3891-3824-u--mkWithArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45MakeClause-n--3891-3823-u--pref arg-0 arg-1 arg-2 arg-3) (PreludeC-45TypesC-45String-C-43C-43 arg-4 "with (_)"))))
(define IdrisC-45IDEModeC-45MakeClause-n--4035-3958-u--addCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (IdrisC-45IDEModeC-45MakeClause-n--4035-3957-u--addBrackets arg-0 arg-1 arg-2 arg-2 (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-fastPack (DataC-45List-replicate (PreludeC-45Types-u--C-43_Num_Nat arg-3 (cond ((equal? arg-2 1) (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) (else (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))) #\ )) e-3))))))))
(define IdrisC-45IDEModeC-45MakeClause-n--4035-3957-u--addBrackets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 0) arg-4) (else (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 arg-4 ")"))))))
(define IdrisC-45IDEModeC-45MakeClause-showRHSName (lambda (arg-0) (let ((u--fn (CoreC-45Name-u--show_Show_Name (CoreC-45Name-dropNS arg-0)))) (let ((sc0 (PreludeC-45Interfaces-any (csegen-51) (lambda (eta-0) (ParserC-45LexerC-45Source-isOpChar eta-0)) (PreludeC-45Types-fastUnpack u--fn)))) (cond ((equal? sc0 1) "op") (else u--fn))))))
(define IdrisC-45IDEModeC-45MakeClause-makeWith (lambda (arg-0 arg-1) (IdrisC-45IDEModeC-45MakeClause-case--makeWith-3910 arg-1 arg-0 (ParserC-45Unlit-isLitLine arg-1))))
(define IdrisC-45IDEModeC-45MakeClause-makeCase (lambda (arg-0 arg-1 arg-2) (let ((u--capp (cons "case _ of" (PreludeC-45TypesC-45String-C-43C-43 "case_val => ?" (CoreC-45Name-u--show_Show_Name arg-1))))) (IdrisC-45IDEModeC-45MakeClause-n--4035-3960-u--newLines arg-2 arg-1 arg-0 u--capp))))
(define IdrisC-45IDEModeC-45CaseSplit-case--updateCase-3018 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (if (null? arg-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "No file loaded") ext-0) (let ((e-2 (unbox arg-7))) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) e-2) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-3 (vector-ref e-5 1))) (let ((u--thisline (LibrariesC-45DataC-45ListC-45Extra-elemAt (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines e-3)) (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer arg-1))))) (if (null? u--thisline) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "File too short!") ext-0) (let ((e-4 (unbox u--thisline))) (let ((u--valid (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--10440-2971-u--getValid arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) arg-2))) (let ((u--bad (DataC-45List-mapMaybe (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--10440-2972-u--getBad arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) arg-2))) (let ((act-25 (CoreC-45ContextC-45Log-log arg-5 "interaction.casesplit" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Valid: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-2231) u--valid))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-5 "interaction.casesplit" (+ 1 (+ 1 (+ 1 0))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Bad: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1280) u--bad))) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((sc6 (DataC-45List-isNil u--valid))) (cond ((equal? sc6 1) (let ((u--indent (IdrisC-45IDEModeC-45CaseSplit-n--10440-2973-u--getIndent arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 (PreludeC-45Types-fastUnpack e-4)))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45IDEModeC-45CaseSplit-showImpossible arg-5 arg-4 arg-3 u--indent eta-0 eta-1))) u--bad '() ext-0))) (else (let ((act-27 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45IDEModeC-45CaseSplit-getReplaces arg-5 arg-4 arg-3 eta-0 eta-1))) u--valid '() ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--stok (IdrisC-45IDEModeC-45TokenLine-tokens e-4))) (let ((act-28 (let ((act-28 (unbox arg-5))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Core-newRef (vector "Idris.IDEMode.CaseSplit.UPD" ) '() ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-10 (vector-ref act-29 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-29 1))) (IdrisC-45IDEModeC-45CaseSplit-updateAll e-10 e-9 u--stok e-8 ext-0)))))))))))))))))))))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-2 e-6) ext-0))))))))))))
(define IdrisC-45IDEModeC-45CaseSplit-n--9902-2494-u--isWhitespace (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) 1)(else 0))))
(define IdrisC-45IDEModeC-45CaseSplit-n--10905-3389-u--indent (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) (PreludeC-45Types-fastPack (DataC-45List-replicate (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (Builtin-snd (CoreC-45FC-startPos arg-6)))) #\ )) (let ((e-1 (unbox arg-5))) (ParserC-45Unlit-relit (box e-1) (PreludeC-45Types-fastPack (DataC-45List-replicate (PreludeC-45Types-prim__integerToNat (PreludeC-45Cast-u--cast_Cast_Int_Integer (PreludeC-45EqOrd-u--max_Ord_Int (blodwen-toSignedInt 0 63) (bs- (Builtin-snd (CoreC-45FC-startPos arg-6)) 1 63)))) #\ )))))))
(define IdrisC-45IDEModeC-45CaseSplit-n--10440-2971-u--getValid (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 2))) (box e-1)))(else '()))))
(define IdrisC-45IDEModeC-45CaseSplit-n--10440-2973-u--getIndent (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-6 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-2 #\ ) (IdrisC-45IDEModeC-45CaseSplit-n--10440-2973-u--getIndent arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45Types-u--C-43_Num_Nat arg-6 (+ 1 0)) e-3))(else arg-6)))))))
(define IdrisC-45IDEModeC-45CaseSplit-n--10440-2972-u--getBad (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-0 (vector-ref arg-6 1))) (box e-0)))(else '()))))
(define IdrisC-45IDEModeC-45CaseSplit-n--9785-2382-u--bracket (lambda (arg-0 arg-1 arg-2 arg-3 arg-5) (case (vector-ref arg-5 0) ((0) arg-5) ((38) arg-5) ((39) arg-5) ((40) arg-5) ((42) arg-5) ((44) arg-5) ((15) arg-5)(else (vector 32 (CoreC-45FC-emptyFC) arg-5)))))
(define IdrisC-45IDEModeC-45CaseSplit-updateCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-2))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45IDEModeC-45CaseSplit-case--updateCase-3018 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 (let ((e-3 (vector-ref e-5 3))) e-3) ext-0)))))))
(define IdrisC-45IDEModeC-45CaseSplit-updateAll (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 e-2 arg-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (IdrisC-45IDEModeC-45CaseSplit-updateAll arg-0 arg-1 arg-2 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (cons (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (IdrisC-45IDEModeC-45TokenLine-toString eta-0)) e-5) e-6)))))))))))))))
(define IdrisC-45IDEModeC-45CaseSplit-toStrUpdate (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (let ((act-24 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-3) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (cons (cons e-5 (IdrisC-45Syntax-u--show_Show_IPTerm (IdrisC-45IDEModeC-45CaseSplit-n--9785-2382-u--bracket e-5 e-3 arg-1 arg-0 e-6))) '()))))))))(else (vector 1 '())))))(else (vector 1 '())))))))))
(define IdrisC-45IDEModeC-45CaseSplit-showImpossible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) arg-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-fastPack (DataC-45List-replicate arg-3 #\ )) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Syntax-u--show_Show_IPTerm e-5) " impossible")))))))))
(define IdrisC-45IDEModeC-45CaseSplit-getReplaces (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-toStrUpdate arg-0 arg-1 eta-0)) arg-3 '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Interfaces-concat (csegen-50) e-5))))))))
(define IdrisC-45IDEModeC-45CaseSplit-getClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Metadata-findTyDeclAt arg-1 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine (bs- arg-3 1 63) u--p))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((act-26 (CoreC-45Context-getFullName arg-0 e-9 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() e-14) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-27 1))) ((TTImpC-45InteractiveC-45CaseSplit-getEnvArgNames arg-0 e-5 e-13 e-12) ext-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-27 1))) (let ((act-28 (IdrisC-45REPLC-45Opts-getSourceLine arg-2 arg-3 ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-28 1))) (if (null? e-15) (vector 1 '()) (let ((e-2 (unbox e-15))) (let ((sc10 (ParserC-45Unlit-isLitLine e-2))) (let ((e-4 (car sc10))) (vector 1 (box (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45CaseSplit-n--10905-3389-u--indent arg-4 arg-3 arg-2 arg-1 arg-0 e-4 e-8) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45CaseSplit-fnName 1 e-11) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Interfaces-concat (csegen-67) (PreludeC-45Types-u--map_Functor_List (lambda (arg-5) (PreludeC-45TypesC-45String-C-43C-43 " " arg-5)) e-12)) (PreludeC-45TypesC-45String-C-43C-43 " = ?" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45IDEModeC-45CaseSplit-fnName 0 e-11) "_rhs")))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45IDEModeC-45CaseSplit-fnName (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((0) (let ((e-5 (vector-ref e-0 1))) (let ((sc2 (ParserC-45LexerC-45Common-isIdentNormal e-5))) (cond ((equal? sc2 1) e-5) (else (cond ((equal? arg-0 1) (PreludeC-45TypesC-45String-C-43C-43 "(" (PreludeC-45TypesC-45String-C-43C-43 e-5 ")"))) (else "op")))))))(else (CoreC-45Name-nameRoot arg-1))))) ((0) (let ((e-2 (vector-ref arg-1 2))) (IdrisC-45IDEModeC-45CaseSplit-fnName arg-0 e-2))) ((4) (let ((e-3 (vector-ref arg-1 1))) e-3))(else (CoreC-45Name-nameRoot arg-1)))))
(define IdrisC-45IDEModeC-45CaseSplit-doUpdates (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((3) (let ((sc2 (DataC-45List-span (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--9902-2494-u--isWhitespace e-3 arg-2 arg-1 arg-0 eta-0)) e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (if (null? e-4) (lambda (eta-0) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend '() e-6)))))))) (let ((e-1 (car e-4))) (let ((e-6 (cdr e-4))) (case (vector-ref e-1 0) ((1) (let ((e-7 (vector-ref e-1 1))) (let ((sc5 (DataC-45List-span (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--9902-2494-u--isWhitespace e-3 arg-2 arg-1 arg-0 eta-0)) e-6))) (let ((e-9 (car sc5))) (let ((e-8 (cdr sc5))) (if (null? e-8) (lambda (eta-0) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-6) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-10 (vector-ref act-24 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-24 1))) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (vector 1 e-7) (PreludeC-45TypesC-45List-tailRecAppend e-9 e-10)))))))))) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (lambda (clam-0) (case (vector-ref e-11 0) ((4) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 (cons (vector 1 e-7) (PreludeC-45TypesC-45List-tailRecAppend e-9 (cons (vector 4 ) e-10)))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-12 (vector-ref act-24 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-24 1))) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (vector 1 e-7) (cons (vector 0 " ") (cons (vector 5 ) (cons (vector 0 " ") e-12)))))))))))) ((5) (let ((sc8 (DataC-45List-span (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--9902-2494-u--isWhitespace e-3 arg-2 arg-1 arg-0 eta-0)) e-10))) (let ((e-13 (car sc8))) (let ((e-12 (cdr sc8))) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-14 (vector-ref act-24 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-24 1))) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (vector 1 e-7) (PreludeC-45TypesC-45List-tailRecAppend e-9 (cons (vector 5 ) (PreludeC-45TypesC-45List-tailRecAppend e-13 e-14)))))))))))))))(else (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-6) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-12 (vector-ref act-24 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-24 1))) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (vector 1 e-7) (PreludeC-45TypesC-45List-tailRecAppend e-9 e-12))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend '() e-7))))))))))))))))) ((1) (let ((e-4 (vector-ref e-2 1))) (lambda (clam-1) (let ((sc2 (DataC-45List-lookup (csegen-17) e-4 arg-2))) (if (null? sc2) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-3) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 1 e-4) e-5)))))) (let ((e-5 (unbox sc2))) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-3) clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (cons (vector 6 e-5) e-6)))))))))))) ((2) (let ((e-5 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (TTImpC-45Utils-uniqueName arg-1 e-6 e-5 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (set-box! arg-0 (cons e-7 e-6)))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((act-27 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-3) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-27 1))) (vector 1 (cons (vector 2 e-7) e-9))))))))))))))))))))(else (lambda (eta-0) (let ((act-24 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-2 e-5))))))))))))))
(define IdrisC-45IDEModeC-45TokenLine-case--tokens-477 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (csegen-3565) e-2) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-11 ""))) (cond ((equal? sc3 1) '()) (else (cons (vector 6 e-11) '())))))))))))
(define IdrisC-45IDEModeC-45TokenLine-tokens (lambda (arg-0) (IdrisC-45IDEModeC-45TokenLine-case--tokens-477 arg-0 (LibrariesC-45TextC-45LexerC-45Core-lex (IdrisC-45IDEModeC-45TokenLine-srcTokens) arg-0))))
(define IdrisC-45IDEModeC-45TokenLine-toString (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) e-1)) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "?" e-2))) ((3) "{") ((4) "}") ((5) "=") (else (let ((e-3 (vector-ref arg-0 1))) e-3)))))
(define IdrisC-45IDEModeC-45TokenLine-srcTokens(blodwen-lazy (lambda () (cons (cons (ParserC-45LexerC-45Common-identNormal) (lambda (eta-0) (vector 1 eta-0))) (cons (cons (IdrisC-45IDEModeC-45TokenLine-holeIdent) (lambda (u--x) (vector 2 (substring u--x 1 (string-length u--x))))) (cons (cons (LibrariesC-45TextC-45Lexer-space) (lambda (eta-0) (vector 0 eta-0))) (cons (cons (LibrariesC-45TextC-45Lexer-is #\{) (lambda (eta-0) (vector 3 ))) (cons (cons (LibrariesC-45TextC-45Lexer-is #\}) (lambda (eta-0) (vector 4 ))) (cons (cons (LibrariesC-45TextC-45Lexer-is #\=) (lambda (eta-0) (vector 5 ))) (cons (cons (LibrariesC-45TextC-45Lexer-any) (lambda (eta-0) (vector 6 eta-0))) '()))))))))))
(define IdrisC-45IDEModeC-45TokenLine-holeIdent(blodwen-lazy (lambda () (csegen-1758))))
(define CoreC-45SchemeEval-snfAll (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-initialiseSchemeEval arg-0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((act-25 (CoreC-45SchemeEvalC-45Evaluate-seval arg-0 0 arg-2 arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45SchemeEvalC-45Evaluate-toSNF arg-0 e-6) ext-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Scheme evaluator not available") ext-0)))))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_UserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (vector 8 5 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-1) '())))) (else (vector 8 9 '())))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount (lambda (arg-0) (let ((sc0 (AlgebraC-45Semiring-isErased (csegen-475) arg-0))) (cond ((equal? sc0 1) (vector 2 0)) (else (let ((sc1 (AlgebraC-45Semiring-isLinear (csegen-475) arg-0))) (cond ((equal? sc1 1) (vector 2 1)) (else (vector 2 2)))))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_OriginDesc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (vector 8 0 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_ModuleIdent e-0) '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (vector 8 1 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-1) '())))) (else (vector 0 )))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Namespace (lambda (arg-0) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40ListC-32C-36aC-41 (csegen-3951) (CoreC-45NameC-45Namespace-unsafeUnfoldNamespace arg-0))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (vector 8 0 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Namespace e-0) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-1) '())))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_UserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (vector 8 2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-3) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-4) '())))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (vector 8 3 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-5) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-6) '())))))) ((4) (let ((e-7 (vector-ref arg-0 1))) (let ((e-8 (vector-ref arg-0 2))) (vector 8 4 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-8) '())))))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (vector 8 6 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3952) e-9) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-10) '())))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (vector 8 7 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-11) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-12) '())))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (vector 8 8 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-13) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-14) '())))))) (else (let ((e-15 (vector-ref arg-0 1))) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-15))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_ModuleIdent (lambda (arg-0) (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Namespace (CoreC-45NameC-45Namespace-miAsNamespace arg-0))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason (lambda (arg-0) (cond ((equal? arg-0 0) (vector 2 0)) ((equal? arg-0 1) (vector 2 1)) (else (vector 2 2)))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (vector 8 0 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_OriginDesc e-0) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3952) e-1) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3952) e-2) '())))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (vector 8 1 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_OriginDesc e-3) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3952) e-4) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3952) e-5) '())))))))) (else (vector 0 )))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_RigCount (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 0) (box (csegen-21))) ((equal? e-1 1) (box (csegen-519)))(else (box (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))))))(else (box (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Namespace (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40ListC-32C-36aC-41 (csegen-3951) arg-0) (lambda (bind-0) (box (CoreC-45NameC-45Namespace-unsafeFoldNamespace bind-0))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (lambda (arg-0) (case (vector-ref arg-0 0) ((8) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (cond ((equal? e-1 0) (if (null? e-2) '() (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (if (null? e-9) '() (let ((e-11 (car e-9))) (let ((e-12 (cdr e-9))) (if (null? e-12) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Namespace e-8) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name e-11) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 0 bind-0 bind-1)))))) '())))))))) ((equal? e-1 2) (if (null? e-2) '() (let ((e-15 (car e-2))) (let ((e-16 (cdr e-2))) (if (null? e-16) '() (let ((e-18 (car e-16))) (let ((e-19 (cdr e-16))) (if (null? e-19) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-15) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int e-18) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 2 bind-0 bind-1)))))) '())))))))) ((equal? e-1 3) (if (null? e-2) '() (let ((e-22 (car e-2))) (let ((e-23 (cdr e-2))) (if (null? e-23) '() (let ((e-25 (car e-23))) (let ((e-26 (cdr e-23))) (if (null? e-26) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name e-22) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int e-25) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 3 bind-0 bind-1)))))) '())))))))) ((equal? e-1 4) (if (null? e-2) '() (let ((e-29 (car e-2))) (let ((e-30 (cdr e-2))) (if (null? e-30) '() (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (if (null? e-33) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-29) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name e-32) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 4 bind-0 bind-1)))))) '())))))))) ((equal? e-1 5) (if (null? e-2) '() (let ((e-36 (car e-2))) (let ((e-37 (cdr e-2))) (if (null? e-37) '() (let ((e-40 (cdr e-37))) (if (null? e-40) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-36) (lambda (bind-0) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (vector 1 bind-0))))) '()))))))) ((equal? e-1 6) (if (null? e-2) '() (let ((e-43 (car e-2))) (let ((e-44 (cdr e-2))) (if (null? e-44) '() (let ((e-46 (car e-44))) (let ((e-47 (cdr e-44))) (if (null? e-47) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-3952) e-43) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name e-46) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 5 bind-0 bind-1)))))) '())))))))) ((equal? e-1 7) (if (null? e-2) '() (let ((e-50 (car e-2))) (let ((e-51 (cdr e-2))) (if (null? e-51) '() (let ((e-53 (car e-51))) (let ((e-54 (cdr e-51))) (if (null? e-54) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-50) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int e-53) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 6 bind-0 bind-1)))))) '())))))))) ((equal? e-1 8) (if (null? e-2) '() (let ((e-57 (car e-2))) (let ((e-58 (cdr e-2))) (if (null? e-58) '() (let ((e-60 (car e-58))) (let ((e-61 (cdr e-58))) (if (null? e-61) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-57) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int e-60) (lambda (bind-1) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 7 bind-0 bind-1)))))) '())))))))) ((equal? e-1 9) (if (null? e-2) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (vector 2 ))) '()))(else '()))))) ((2) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 8 (PreludeC-45Cast-u--cast_Cast_Integer_Int e-4))))) ((4) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45Types-u--pure_Applicative_Maybe (vector 1 (vector 0 e-6)))))(else '()))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_LazyReason (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 0) (box 0)) ((equal? e-1 1) (box 1))(else (box 2)))))(else (box 2)))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (lambda (arg-0) (box (vector 2 ))))
(define CoreC-45SchemeEvalC-45ToScheme-toSchemePi (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (vector 2 0)) ((1) (vector 2 1)) ((2) (vector 2 2)) (else (let ((e-4 (vector-ref arg-0 1))) (vector 7 e-4))))))
(define CoreC-45SchemeEvalC-45Quote-n--6398-2037-u--findName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10) (case (vector-ref arg-10 0) ((0) '()) (else (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-2 e-2))) (cond ((equal? sc1 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45Quote-n--6398-2037-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) (csegen-549)))))))))))
(define CoreC-45SchemeEvalC-45Quote-n--6398-1916-u--addLater (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 arg-13) (if (null? arg-13) arg-12 (let ((e-3 (cdr arg-13))) (+ 1 (CoreC-45SchemeEvalC-45Quote-n--6398-1916-u--addLater arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 e-3))))))
(define CoreC-45SchemeEvalC-45Quote-quotePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-6 1))) (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5)))))))))))
(define CoreC-45SchemeEvalC-45Quote-quoteHead (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 1))) (vector 1 (vector 0 arg-4 '() (CoreC-45SchemeEvalC-45Quote-n--6398-1916-u--addLater arg-2 e-2 arg-6 arg-1 arg-5 arg-4 arg-3 arg-0 e-2 arg-1))))) ((1) (let ((e-5 (vector-ref arg-7 1))) (let ((e-6 (vector-ref arg-7 2))) (vector 1 (let ((sc1 (CoreC-45SchemeEvalC-45Quote-n--6398-2037-u--findName arg-1 arg-2 e-6 e-5 arg-6 arg-5 arg-4 arg-3 arg-0 arg-5))) (if (null? sc1) (vector 1 arg-4 e-5 e-6) (let ((e-1 (unbox sc1))) (vector 0 arg-4 '() e-1)))))))) (else (let ((e-8 (vector-ref arg-7 1))) (let ((e-9 (vector-ref arg-7 2))) (let ((e-10 (vector-ref arg-7 3))) (let ((act-24 (CoreC-45SchemeEvalC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 e-10 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 arg-4 e-8 e-9 e-5)))))))))))))
(define CoreC-45SchemeEvalC-45Quote-quoteGen (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-3 (+ e-5 1)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((u--var (vector 1 (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "b-" (PreludeC-45Show-u--show_Show_Integer e-5)))))) (let ((act-26 (CoreC-45SchemeEvalC-45Evaluate-seval arg-0 0 arg-5 (vector 1 e-1 (vector 0 ) u--var) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 ((e-4 e-7) clam-0))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 (cons e-2 arg-1) arg-2 arg-3 (vector 1 e-2 u--var arg-4) arg-5 e-8) clam-0))))))) (case (vector-ref act-27 0) ((0) (let ((e-8 (vector-ref act-27 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45SchemeEvalC-45Quote-quoteBinder arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-9 (vector-ref act-28 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-28 1))) (vector 1 (vector 3 e-1 e-2 e-9 e-8))))))))))))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((act-24 (CoreC-45SchemeEvalC-45Quote-quoteHead arg-0 arg-1 arg-2 arg-3 e-6 arg-4 arg-5 e-7 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45SchemeEvalC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-8 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-25 1))) (vector 1 (CoreC-45TT-apply e-6 e-5 e-9)))))))))))))) ((2) (let ((e-10 (vector-ref arg-6 1))) (let ((e-11 (vector-ref arg-6 2))) (let ((e-12 (vector-ref arg-6 3))) (let ((e-13 (vector-ref arg-6 4))) (let ((e-14 (vector-ref arg-6 5))) (let ((act-24 (CoreC-45SchemeEvalC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-14 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-apply e-10 (vector 1 e-10 (vector 2 e-12 e-13) e-11) e-5)))))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (let ((act-24 (CoreC-45SchemeEvalC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-20 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45TT-apply e-16 (vector 1 e-16 (vector 3 e-18 e-19) e-17) e-5)))))))))))) ((4) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-24) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 6 e-22 e-23 e-5)))))))))) ((5) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (let ((e-29 (vector-ref arg-6 4))) (let ((act-24 (let ((act-24 (e-29 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) clam-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (e-28 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6) clam-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 7 e-26 e-27 e-6 e-5))))))))))))))) ((6) (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (case (vector-ref e-33 0) ((5) (let ((e-4 (vector-ref e-33 4))) (let ((act-24 (e-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) clam-0)))))))(else (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-33) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 e-31 e-32 e-5)))))))))))) ((7) (let ((e-35 (vector-ref arg-6 1))) (let ((e-36 (vector-ref arg-6 2))) (vector 1 (vector 9 e-35 e-36))))) ((8) (let ((e-38 (vector-ref arg-6 1))) (let ((e-39 (vector-ref arg-6 2))) (vector 1 (vector 10 e-38 e-39))))) (else (let ((e-41 (vector-ref arg-6 1))) (vector 1 (vector 11 e-41))))))))
(define CoreC-45SchemeEvalC-45Quote-quoteBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45SchemeEvalC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-1 e-2 e-6 e-5))))))))))))))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((e-9 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-8) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-25 1))) (vector 1 (vector 1 e-6 e-7 e-10 e-5))))))))))))))) ((2) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-14) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45SchemeEvalC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-13 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 2 e-11 e-12 e-6 e-5))))))))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-19) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45SchemeEvalC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-18 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 3 e-16 e-17 e-6 e-5))))))))))))))) ((4) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (let ((e-24 (vector-ref arg-6 4))) (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-24) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-23) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 4 e-21 e-22 e-6 e-5))))))))))))))) (else (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (let ((act-24 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-28) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 5 e-26 e-27 e-5)))))))))))))
(define CoreC-45SchemeEvalC-45Quote-quoteArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (CoreC-45Core-traverseC-39 (lambda (u--arg) (lambda (eta-0) (let ((act-24 (u--arg eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) eta-0))))))) arg-6 '() ext-0)))
(define CoreC-45SchemeEvalC-45Quote-quote (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.SchemeEval.Compile.Sym" ) 0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 '() arg-1 e-5 (vector 0 ) arg-2 arg-3) ext-0)))))))
(define CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (unbox arg-8))) (let ((u--fc (let ((sc1 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (LibrariesC-45UtilsC-45Scheme-decodeObj arg-4)))) (if (null? sc1) (CoreC-45FC-emptyFC) (let ((e-2 (unbox sc1))) e-2))))) (let ((u--args (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-7 eta-0)) arg-5))) (lambda (eta-0) (vector 1 (vector 2 u--fc e-1 (PreludeC-45Cast-u--cast_Cast_Integer_Int arg-6) (PreludeC-45TypesC-45List-length u--args) u--args)))))))))
(define CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-6886 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((9) (let ((e-0 (vector-ref arg-9 1))) (let ((u--tm (lambda (eta-0) (let ((act-24 (let ((act-24 ((LibrariesC-45UtilsC-45Scheme-evalSchemeStr "(ct-setBlockAll #t)") eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0) (let ((act-25 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-7 (LibrariesC-45UtilsC-45Scheme-unsafeForce arg-8)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((LibrariesC-45UtilsC-45Scheme-evalSchemeStr "(ct-setBlockAll #f)") eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0) (vector 1 e-6)))))))))))))))))) (let ((u--ty (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-7 (LibrariesC-45UtilsC-45Scheme-unsafeForce e-0)))) (let ((u--fc (let ((sc1 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (LibrariesC-45UtilsC-45Scheme-decodeObj arg-4)))) (if (null? sc1) (CoreC-45FC-emptyFC) (let ((e-1 (unbox sc1))) e-1))))) (let ((u--r (let ((sc1 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_LazyReason (LibrariesC-45UtilsC-45Scheme-decodeObj arg-3)))) (if (null? sc1) 2 (let ((e-1 (unbox sc1))) e-1))))) (lambda (eta-0) (vector 1 (vector 5 u--fc u--r u--ty u--tm)))))))))(else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))
(define CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-6625 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (unbox arg-10))) (let ((u--fc (let ((sc1 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (LibrariesC-45UtilsC-45Scheme-decodeObj arg-6)))) (if (null? sc1) (CoreC-45FC-emptyFC) (let ((e-2 (unbox sc1))) e-2))))) (let ((u--args (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-8 eta-0)) arg-7))) (lambda (eta-0) (vector 1 (vector 3 u--fc arg-9 (PreludeC-45Cast-u--cast_Cast_Integer_Int e-1) (PreludeC-45TypesC-45List-length u--args) u--args)))))))))
(define CoreC-45SchemeEvalC-45Evaluate-case--snfVector-6389 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (unbox arg-6))) (if (null? e-1) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (let ((u--arity (PreludeC-45Cast-u--cast_Cast_Integer_Nat e-5))) (let ((u--args (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-5 eta-0)) (CoreC-45SchemeEvalC-45Evaluate-getArgList arg-4)))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Context-toFullNames arg-1 (csegen-46) e-4 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-getPosition e-7 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-26 1))) (let ((e-2 (car e-8))) (vector 1 (vector 1 (CoreC-45FC-emptyFC) (vector 2 e-7 e-2 (DataC-45List-take u--arity u--args)) (DataC-45List-drop u--arity u--args))))))))))))))))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-n--6106-1774-u--mkEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-7) (vector 1 (cons arg-8 '())) (let ((e-4 (car arg-7))) (let ((e-5 (cdr arg-7))) (case (vector-ref e-4 0) ((1) (let ((e-9 (vector-ref e-4 3))) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Evaluate-n--6106-1774-u--mkEnv arg-1 arg-2 arg-3 arg-4 arg-6 e-5 arg-8) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-25 1))) (let ((e-2 (car e-11))) (let ((e-3 (cdr e-11))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compile arg-6 arg-4 e-3 e-9) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-12 (vector-ref act-26 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-26 1))) (let ((u--n (PreludeC-45TypesC-45String-C-43C-43 "let-var-" (PreludeC-45Show-u--show_Show_Integer e-6)))) (vector 1 (cons (lambda (u--x) (vector 13 u--n e-12 (e-2 u--x))) (cons (vector 0 u--n) e-3))))))))))))))))))))(else (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Evaluate-n--6106-1774-u--mkEnv arg-1 arg-2 arg-3 arg-4 arg-6 e-5 arg-8) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (vector 1 (cons e-2 (cons (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "free-" (PreludeC-45Show-u--show_Show_Integer e-6))) e-3)))))))))))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-n--11153-9255-u--findName (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (if (null? arg-5) (vector 1 (CoreC-45FC-emptyFC) (vector 1 (vector 1 ) (vector 1 (vector 0 arg-6))) '()) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CoreC-45SchemeEvalC-45Compile-getName e-2) arg-6))) (cond ((equal? sc1 1) (vector 1 (CoreC-45FC-emptyFC) (vector 0 0) '())) (else (let ((sc2 (CoreC-45SchemeEvalC-45Evaluate-n--11153-9255-u--findName arg-1 arg-2 arg-3 e-3 arg-6))) (case (vector-ref sc2 0) ((1) (let ((e-1 (vector-ref sc2 1))) (let ((e-5 (vector-ref sc2 2))) (case (vector-ref e-5 0) ((0) (let ((e-6 (vector-ref e-5 1))) (vector 1 e-1 (vector 0 (+ 1 e-6)) '())))(else (vector 1 (CoreC-45FC-emptyFC) (vector 1 (vector 1 ) (vector 1 (vector 0 arg-6))) '()))))))(else (vector 1 (CoreC-45FC-emptyFC) (vector 1 (vector 1 ) (vector 1 (vector 0 arg-6))) '()))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-toSNF (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 e-2 e-1)))))
(define CoreC-45SchemeEvalC-45Evaluate-snfVector (lambda (arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 -2) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-11 (cdr arg-4))) (if (null? e-11) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (let ((sc5 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-13)))) (if (null? sc5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (unbox sc5))) (let ((u--args (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) (CoreC-45SchemeEvalC-45Evaluate-getArgList e-16)))) (lambda (eta-0) (vector 1 (vector 1 (CoreC-45FC-emptyFC) (vector 1 (vector 1 ) e-1) u--args))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))) ((equal? arg-3 -10) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-20 (car arg-4))) (let ((e-21 (cdr arg-4))) (if (null? e-21) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-23 (car e-21))) (let ((e-24 (cdr e-21))) (if (null? e-24) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (if (null? e-27) (CoreC-45SchemeEvalC-45Evaluate-case--snfVector-6389 arg-1 e-20 e-23 e-26 arg-2 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-1030) (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-1030)) (lambda (arg-1031) (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name arg-1031))) (cons (lambda (arg-1030) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Integer arg-1030)) (lambda (arg-1031) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Integer arg-1031)))) (LibrariesC-45UtilsC-45Scheme-decodeObj e-23))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))))) ((equal? arg-3 -11) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-31 (cdr arg-4))) (if (null? e-31) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-33 (car e-31))) (let ((e-34 (cdr e-31))) (if (null? e-34) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-36 (car e-34))) (let ((e-37 (cdr e-34))) (if (null? e-37) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-33) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((u--argsC-39 (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-1)) (CoreC-45SchemeEvalC-45Evaluate-getArgList e-36)))) (vector 1 (vector 1 e-1 e-2 (PreludeC-45TypesC-45List-tailRecAppend e-3 u--argsC-39))))))))(else (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))) ((equal? arg-3 -1) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-40 (car arg-4))) (let ((e-41 (cdr arg-4))) (if (null? e-41) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-43 (car e-41))) (let ((e-44 (cdr e-41))) (if (null? e-44) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-46 (car e-44))) (let ((e-47 (cdr e-44))) (if (null? e-47) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-49 (car e-47))) (let ((e-50 (cdr e-47))) (if (null? e-50) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-52 (car e-50))) (let ((e-53 (cdr e-50))) (let ((sc6 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-49)))) (if (null? sc6) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (unbox sc6))) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-6625 arg-1 e-40 e-43 e-46 e-49 e-52 e-53 arg-2 e-1 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Integer (LibrariesC-45UtilsC-45Scheme-decodeObj e-43)))))))))))))))))))))) ((equal? arg-3 -15) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-56 (cdr arg-4))) (if (null? e-56) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-58 (car e-56))) (let ((e-59 (cdr e-56))) (if (null? e-59) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-61 (car e-59))) (let ((e-62 (cdr e-59))) (if (null? e-62) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-61) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--r (let ((sc6 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_LazyReason (LibrariesC-45UtilsC-45Scheme-decodeObj e-58)))) (if (null? sc6) 2 (let ((e-1 (unbox sc6))) e-1))))) (vector 1 (vector 4 (CoreC-45FC-emptyFC) u--r e-5)))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))) ((equal? arg-3 -4) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-65 (car arg-4))) (let ((e-66 (cdr arg-4))) (if (null? e-66) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-68 (car e-66))) (let ((e-69 (cdr e-66))) (if (null? e-69) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-71 (car e-69))) (let ((e-72 (cdr e-69))) (if (null? e-72) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-74 (car e-72))) (let ((e-75 (cdr e-72))) (if (null? e-75) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-77 (car e-75))) (let ((e-78 (cdr e-75))) (if (null? e-78) (let ((sc7 (LibrariesC-45UtilsC-45Scheme-decodeObj e-77))) (case (vector-ref sc7 0) ((9) (let ((e-0 (vector-ref sc7 1))) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-6886 arg-1 e-65 e-68 e-71 e-74 e-77 arg-2 e-0 (LibrariesC-45UtilsC-45Scheme-decodeObj e-74))))(else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))))))))))) ((equal? arg-3 -5) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-82 (cdr arg-4))) (if (null? e-82) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-84 (car e-82))) (let ((e-85 (cdr e-82))) (if (null? e-85) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-87 (car e-85))) (let ((e-88 (cdr e-85))) (if (null? e-88) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-90 (car e-88))) (let ((e-91 (cdr e-88))) (if (null? e-91) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-90) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fc (let ((sc7 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (LibrariesC-45UtilsC-45Scheme-decodeObj e-87)))) (if (null? sc7) (CoreC-45FC-emptyFC) (let ((e-1 (unbox sc7))) e-1))))) (let ((u--r (let ((sc7 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_LazyReason (LibrariesC-45UtilsC-45Scheme-decodeObj e-84)))) (if (null? sc7) 2 (let ((e-1 (unbox sc7))) e-1))))) (vector 1 (vector 6 u--fc u--r e-5))))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))))))) ((equal? arg-3 -6) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-95 (cdr arg-4))) (if (null? e-95) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-97 (car e-95))) (let ((e-98 (cdr e-95))) (if (null? e-98) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-100 (car e-98))) (let ((e-101 (cdr e-98))) (if (null? e-101) (let ((u--fc (let ((sc5 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (LibrariesC-45UtilsC-45Scheme-decodeObj e-97)))) (if (null? sc5) (CoreC-45FC-emptyFC) (let ((e-1 (unbox sc5))) e-1))))) (let ((u--imp (let ((sc5 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bool (LibrariesC-45UtilsC-45Scheme-decodeObj e-100)))) (if (null? sc5) 0 (let ((e-1 (unbox sc5))) e-1))))) (lambda (eta-0) (vector 1 (vector 8 u--fc u--imp))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))) ((equal? arg-3 -7) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-105 (cdr arg-4))) (if (null? e-105) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-107 (car e-105))) (let ((e-108 (cdr e-105))) (if (null? e-108) (let ((u--fc (let ((sc4 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (LibrariesC-45UtilsC-45Scheme-decodeObj e-107)))) (if (null? sc4) (CoreC-45FC-emptyFC) (let ((e-1 (unbox sc4))) e-1))))) (lambda (eta-0) (vector 1 (vector 9 u--fc)))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -8) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-112 (cdr arg-4))) (if (null? e-112) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-114 (car e-112))) (let ((e-115 (cdr e-112))) (if (null? e-115) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-117 (car e-115))) (let ((e-118 (cdr e-115))) (if (null? e-118) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-120 (car e-118))) (let ((e-121 (cdr e-118))) (if (null? e-121) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-123 (car e-121))) (let ((e-124 (cdr e-121))) (if (null? e-124) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-126 (car e-124))) (let ((e-127 (cdr e-124))) (if (null? e-127) (let ((u--name (let ((sc8 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-126)))) (if (null? sc8) (vector 1 (vector 0 "x")) (let ((e-2 (unbox sc8))) e-2))))) (let ((u--rig (let ((sc8 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_RigCount (LibrariesC-45UtilsC-45Scheme-decodeObj e-117)))) (if (null? sc8) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (let ((e-2 (unbox sc8))) e-2))))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-123) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Evaluate-snfPiInfo arg-1 arg-2 e-120) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-7638) (csegen-3962)) e-114 u--rig e-6 e-5 u--name) eta-0)))))))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc11 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc11 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))))))))))))) ((equal? arg-3 -3) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-131 (cdr arg-4))) (if (null? e-131) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-133 (car e-131))) (let ((e-134 (cdr e-131))) (if (null? e-134) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-136 (car e-134))) (let ((e-137 (cdr e-134))) (if (null? e-137) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-139 (car e-137))) (let ((e-140 (cdr e-137))) (if (null? e-140) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-142 (car e-140))) (let ((e-143 (cdr e-140))) (if (null? e-143) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-145 (car e-143))) (let ((e-146 (cdr e-143))) (if (null? e-146) (let ((u--name (let ((sc8 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-145)))) (if (null? sc8) (vector 1 (vector 0 "x")) (let ((e-2 (unbox sc8))) e-2))))) (let ((u--rig (let ((sc8 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_RigCount (LibrariesC-45UtilsC-45Scheme-decodeObj e-136)))) (if (null? sc8) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (let ((e-2 (unbox sc8))) e-2))))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-142) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Evaluate-snfPiInfo arg-1 arg-2 e-139) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-7792) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector 2 eta-1 eta-2 eta-3 eta-4)))))) e-133 u--rig e-6 e-5 u--name) eta-0)))))))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc11 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc11 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))))))))))))) ((equal? arg-3 -12) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-150 (cdr arg-4))) (if (null? e-150) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-152 (car e-150))) (let ((e-153 (cdr e-150))) (if (null? e-153) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-155 (car e-153))) (let ((e-156 (cdr e-153))) (if (null? e-156) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-158 (car e-156))) (let ((e-159 (cdr e-156))) (if (null? e-159) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-161 (car e-159))) (let ((e-162 (cdr e-159))) (if (null? e-162) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-164 (car e-162))) (let ((e-165 (cdr e-162))) (if (null? e-165) (let ((u--name (let ((sc8 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-164)))) (if (null? sc8) (vector 1 (vector 0 "x")) (let ((e-2 (unbox sc8))) e-2))))) (let ((u--rig (let ((sc8 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_RigCount (LibrariesC-45UtilsC-45Scheme-decodeObj e-155)))) (if (null? sc8) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (let ((e-2 (unbox sc8))) e-2))))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-161) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Evaluate-snfPiInfo arg-1 arg-2 e-158) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-7946) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector 3 eta-1 eta-2 eta-3 eta-4)))))) e-152 u--rig e-6 e-5 u--name) eta-0)))))))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc11 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc11 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))))))))))))) ((equal? arg-3 -13) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-169 (cdr arg-4))) (if (null? e-169) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-171 (car e-169))) (let ((e-172 (cdr e-169))) (if (null? e-172) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-174 (car e-172))) (let ((e-175 (cdr e-172))) (if (null? e-175) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-177 (car e-175))) (let ((e-178 (cdr e-175))) (if (null? e-178) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-180 (car e-178))) (let ((e-181 (cdr e-178))) (if (null? e-181) (let ((u--name (let ((sc7 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-180)))) (if (null? sc7) (vector 1 (vector 0 "x")) (let ((e-2 (unbox sc7))) e-2))))) (let ((u--rig (let ((sc7 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_RigCount (LibrariesC-45UtilsC-45Scheme-decodeObj e-174)))) (if (null? sc7) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (let ((e-2 (unbox sc7))) e-2))))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-177) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-8085) (lambda (u--fc) (lambda (u--r) (lambda (u--p) (lambda (u--t) (vector 5 u--fc u--r u--t)))))) e-171 u--rig (vector 1 ) e-5 u--name) eta-0)))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))))))))) ((equal? arg-3 -14) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-185 (cdr arg-4))) (if (null? e-185) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-187 (car e-185))) (let ((e-188 (cdr e-185))) (if (null? e-188) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-190 (car e-188))) (let ((e-191 (cdr e-188))) (if (null? e-191) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-193 (car e-191))) (let ((e-194 (cdr e-191))) (if (null? e-194) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-196 (car e-194))) (let ((e-197 (cdr e-194))) (if (null? e-197) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-199 (car e-197))) (let ((e-200 (cdr e-197))) (if (null? e-200) (let ((u--name (let ((sc8 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-199)))) (if (null? sc8) (vector 1 (vector 0 "x")) (let ((e-2 (unbox sc8))) e-2))))) (let ((u--rig (let ((sc8 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_RigCount (LibrariesC-45UtilsC-45Scheme-decodeObj e-190)))) (if (null? sc8) (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (let ((e-2 (unbox sc8))) e-2))))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-196) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-193) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45SchemeEvalC-45Evaluate-snfPLet arg-1 arg-2 e-187 u--rig e-6 e-5 u--name) eta-0)))))))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc11 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc11 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))))))))))))) ((equal? arg-3 -9) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-204 (cdr arg-4))) (if (null? e-204) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-206 (car e-204))) (let ((e-207 (cdr e-204))) (if (null? e-207) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-210 (cdr e-207))) (if (null? e-210) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-206) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))) ((equal? arg-3 -100) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-214 (cdr arg-4))) (if (null? e-214) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-216 (car e-214))) (let ((e-217 (cdr e-214))) (if (null? e-217) (lambda (clam-0) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int (LibrariesC-45UtilsC-45Scheme-decodeObj e-216)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-0) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 0 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -101) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-221 (cdr arg-4))) (if (null? e-221) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-223 (car e-221))) (let ((e-224 (cdr e-221))) (if (null? e-224) (lambda (clam-1) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int8 (LibrariesC-45UtilsC-45Scheme-decodeObj e-223)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-1) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 1 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -102) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-228 (cdr arg-4))) (if (null? e-228) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-230 (car e-228))) (let ((e-231 (cdr e-228))) (if (null? e-231) (lambda (clam-2) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int16 (LibrariesC-45UtilsC-45Scheme-decodeObj e-230)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-2) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 2 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -103) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-235 (cdr arg-4))) (if (null? e-235) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-237 (car e-235))) (let ((e-238 (cdr e-235))) (if (null? e-238) (lambda (clam-3) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int32 (LibrariesC-45UtilsC-45Scheme-decodeObj e-237)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-3) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 3 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -104) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-242 (cdr arg-4))) (if (null? e-242) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-244 (car e-242))) (let ((e-245 (cdr e-242))) (if (null? e-245) (lambda (clam-4) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int64 (LibrariesC-45UtilsC-45Scheme-decodeObj e-244)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-4) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 4 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -105) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-249 (cdr arg-4))) (if (null? e-249) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-251 (car e-249))) (let ((e-252 (cdr e-249))) (if (null? e-252) (lambda (clam-5) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Integer (LibrariesC-45UtilsC-45Scheme-decodeObj e-251)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-5) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 5 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -106) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-256 (cdr arg-4))) (if (null? e-256) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-258 (car e-256))) (let ((e-259 (cdr e-256))) (if (null? e-259) (lambda (clam-6) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits8 (LibrariesC-45UtilsC-45Scheme-decodeObj e-258)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-6) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 6 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -107) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-263 (cdr arg-4))) (if (null? e-263) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-265 (car e-263))) (let ((e-266 (cdr e-263))) (if (null? e-266) (lambda (clam-7) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits16 (LibrariesC-45UtilsC-45Scheme-decodeObj e-265)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-7) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 7 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -108) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-270 (cdr arg-4))) (if (null? e-270) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-272 (car e-270))) (let ((e-273 (cdr e-270))) (if (null? e-273) (lambda (clam-8) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits32 (LibrariesC-45UtilsC-45Scheme-decodeObj e-272)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-8) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 8 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))) ((equal? arg-3 -109) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-277 (cdr arg-4))) (if (null? e-277) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))) (let ((e-279 (car e-277))) (let ((e-280 (cdr e-277))) (if (null? e-280) (lambda (clam-9) (let ((sc4 (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits64 (LibrariesC-45UtilsC-45Scheme-decodeObj e-279)))) (if (null? sc4) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-9) (let ((e-1 (unbox sc4))) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 9 e-1))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))(else (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc3 1) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-8830 arg-1 e-1 e-4 e-7 e-8 arg-3 arg-2 (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj e-4)))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfPiInfo (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isInteger arg-3))) (cond ((equal? sc0 1) (let ((sc1 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger arg-3))) (cond ((equal? sc1 0) (vector 1 (vector 0 ))) ((equal? sc1 1) (vector 1 (vector 1 ))) ((equal? sc1 2) (vector 1 (vector 2 )))(else (vector 1 (vector 1 )))))) (else (let ((sc1 (LibrariesC-45UtilsC-45Scheme-isBox arg-3))) (cond ((equal? sc1 1) (let ((act-24 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 (LibrariesC-45UtilsC-45Scheme-unsafeUnbox arg-3)) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5))))))) (else (vector 1 (vector 1 )))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfPLet (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-decodeObj arg-3))) (case (vector-ref sc0 0) ((9) (let ((e-0 (vector-ref sc0 1))) (vector 1 (vector 0 (CoreC-45FC-emptyFC) arg-7 (vector 4 (CoreC-45FC-emptyFC) arg-4 arg-5 arg-6) (lambda (u--tm) (let ((e-1 (car u--tm))) (let ((u--sc (LibrariesC-45UtilsC-45Scheme-unsafeApply e-0 e-1))) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 u--sc))))))))(else (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-0)))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfBinder (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-decodeObj arg-4))) (case (vector-ref sc0 0) ((9) (let ((e-0 (vector-ref sc0 1))) (vector 1 (vector 0 (CoreC-45FC-emptyFC) arg-8 (((((arg-3 'erased) (CoreC-45FC-emptyFC)) arg-5) arg-6) arg-7) (lambda (u--tm) (let ((e-1 (car u--tm))) (let ((u--sc (LibrariesC-45UtilsC-45Scheme-unsafeApply e-0 e-1))) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 u--sc))))))))(else (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-0)))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfC-39 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isVector arg-3))) (cond ((equal? sc0 1) (CoreC-45SchemeEvalC-45Evaluate-snfVector arg-1 arg-2 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger (LibrariesC-45UtilsC-45Scheme-unsafeVectorRef arg-3 0)) (LibrariesC-45UtilsC-45Scheme-unsafeVectorToList arg-3))) (else (let ((sc1 (LibrariesC-45UtilsC-45Scheme-isProcedure arg-3))) (cond ((equal? sc1 1) (CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-9477) (csegen-3962)) arg-3 (AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (vector 1 ) (vector 8 (CoreC-45FC-emptyFC) 0) (vector 1 (vector 0 "x")))) (else (let ((sc2 (LibrariesC-45UtilsC-45Scheme-isSymbol arg-3))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Evaluate-n--11153-9255-u--findName arg-1 arg-3 arg-2 arg-2 (LibrariesC-45UtilsC-45Scheme-unsafeReadSymbol arg-3))))) (else (let ((sc3 (LibrariesC-45UtilsC-45Scheme-isFloat arg-3))) (cond ((equal? sc3 1) (lambda (eta-0) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 12 (LibrariesC-45UtilsC-45Scheme-unsafeGetFloat arg-3)))))) (else (let ((sc4 (LibrariesC-45UtilsC-45Scheme-isInteger arg-3))) (cond ((equal? sc4 1) (lambda (eta-0) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 0 (PreludeC-45Cast-u--cast_Cast_Integer_Int (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger arg-3))))))) (else (let ((sc5 (LibrariesC-45UtilsC-45Scheme-isString arg-3))) (cond ((equal? sc5 1) (lambda (eta-0) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 10 (LibrariesC-45UtilsC-45Scheme-unsafeGetString arg-3)))))) (else (lambda (clam-0) (let ((sc6 (LibrariesC-45UtilsC-45Scheme-isChar arg-3))) (cond ((equal? sc6 1) (vector 1 (vector 7 (CoreC-45FC-emptyFC) (vector 11 (LibrariesC-45UtilsC-45Scheme-unsafeGetChar arg-3))))) (else (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-0)))))))))))))))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-seval (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 ((CoreC-45ContextC-45Log-logTimeWhen arg-1 0 (lambda () "Scheme eval") (CoreC-45SchemeEvalC-45Compile-initialiseSchemeEval arg-1)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (cond ((equal? e-5 1) (let ((u--ms (CoreC-45TT-getRefs (vector 2 "" 0) arg-4))) (let ((u--rs (CoreC-45TT-addMetas u--ms arg-4))) (let ((act-25 ((CoreC-45SchemeEvalC-45Evaluate-getAllNames arg-1 (LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-keys u--rs)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45SchemeEvalC-45Compile-compileDef arg-1 arg-2 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (CoreC-45Core-newRef (vector "Core.SchemeEval.Compile.Sym" ) 0 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 ((CoreC-45SchemeEvalC-45Evaluate-n--6106-1774-u--mkEnv arg-4 arg-3 arg-2 arg-1 e-8 arg-3 (lambda (eta-0) eta-0)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-29 (let ((act-29 (CoreC-45Context-toFullNames arg-1 (csegen-76) arg-4 ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) ((CoreC-45SchemeEvalC-45Compile-compile e-8 arg-1 e-3 e-10) ext-0))))))) (case (vector-ref act-29 0) ((0) (let ((e-4 (vector-ref act-29 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (let ((act-30 ((LibrariesC-45UtilsC-45Scheme-evalSchemeObj (e-2 e-10)) ext-0))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-4 (vector-ref act-30 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-30 1))) (if (null? e-11) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Compiling expression failed") ext-0) (let ((e-1 (unbox e-11))) (vector 1 (cons e-1 e-3)))))))))))))))))))))))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Loading scheme support failed") ext-0)))))))))
(define CoreC-45SchemeEvalC-45Evaluate-invalidS (lambda (ext-0) (vector 1 (vector 8 (CoreC-45FC-emptyFC) 0))))
(define CoreC-45SchemeEvalC-45Evaluate-getArgList (lambda (arg-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isPair arg-0))) (cond ((equal? sc0 1) (cons (LibrariesC-45UtilsC-45Scheme-unsafeFst arg-0) (CoreC-45SchemeEvalC-45Evaluate-getArgList (LibrariesC-45UtilsC-45Scheme-unsafeSnd arg-0)))) (else '())))))
(define CoreC-45SchemeEvalC-45Evaluate-getAllNames (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 arg-1)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-1))) (if (null? sc1) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) ((CoreC-45SchemeEvalC-45Evaluate-getAllNames arg-0 arg-1 e-3) eta-0) (let ((e-1 (unbox e-6))) ((CoreC-45SchemeEvalC-45Evaluate-getAllNames arg-0 (LibrariesC-45DataC-45NameMap-insert e-2 0 arg-1) (PreludeC-45TypesC-45List-tailRecAppend e-3 (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-1)))) eta-0)))))))))))) (CoreC-45SchemeEvalC-45Evaluate-getAllNames arg-0 arg-1 e-3))))))))
(define CoreC-45SchemeEvalC-45Compile-n--6157-726-u--vars (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (vector 0 ) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (vector 1 e-2 (CoreC-45SchemeEvalC-45Compile-n--6157-726-u--vars arg-0 arg-1 e-3)))))))
(define CoreC-45SchemeEvalC-45Compile-n--7629-2475-u--toSchemeTyConCases (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-13) (let ((u--var (CoreC-45SchemeEvalC-45Compile-getSchVar arg-11 arg-7))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45SchemeEvalC-45Compile-n--7658-2948-u--makeAlt arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13 arg-11 u--var eta-1)) arg-13 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-n--7629-2473-u--makeDefault arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) ((CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13 arg-11 u--var arg-13 (vector 15 (vector 17 (vector 11 "vector-ref") (cons (vector 11 u--var) (cons (vector 2 2) '()))) (DataC-45List-mapMaybe (lambda (eta-1) eta-1) e-5) (box e-6))) eta-0))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isTypeMatchable") (cons (vector 11 u--var) '())) e-6 arg-8))))))))))))))
(define CoreC-45SchemeEvalC-45Compile-n--7629-2477-u--toSchemeDelayCases (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-13) (if (null? arg-13) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (car arg-13))) (let ((e-2 (cdr arg-13))) (case (vector-ref e-1 0) ((1) (let ((e-6 (vector-ref e-1 3))) (let ((u--var (CoreC-45SchemeEvalC-45Compile-getSchVar arg-11 arg-7))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((act-25 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-25 1))) (let ((u--svsC-39 (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-7)) (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-8)) arg-7)))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 u--svsC-39 e-6) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-26 1))) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isDelay") (cons (vector 11 u--var) '())) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-7) (vector 17 (vector 17 (vector 11 "vector-ref") (cons (vector 11 u--var) (cons (vector 2 3) '()))) '()) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-8) (vector 17 (vector 17 (vector 11 "vector-ref") (cons (vector 11 u--var) (cons (vector 2 4) '()))) '()) e-9)) arg-8)))))))))))))))))))(else (CoreC-45SchemeEvalC-45Compile-n--7629-2477-u--toSchemeDelayCases arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 e-2))))))))
(define CoreC-45SchemeEvalC-45Compile-n--7629-2476-u--toSchemeConstCases (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-13) (let ((u--var (CoreC-45SchemeEvalC-45Compile-getSchVar arg-11 arg-7))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45SchemeEvalC-45Compile-n--7659-3241-u--makeAlt arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13 arg-11 u--var eta-1 eta-2))) arg-13 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-n--7629-2473-u--makeDefault arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--caseblock (vector 16 (DataC-45List-mapMaybe (lambda (eta-1) eta-1) e-5) (box e-6)))) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isConstant") (cons (vector 11 u--var) '())) u--caseblock arg-8)))))))))))))))
(define CoreC-45SchemeEvalC-45Compile-n--7629-2474-u--toSchemeConCases (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-13) (let ((u--var (CoreC-45SchemeEvalC-45Compile-getSchVar arg-11 arg-7))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45SchemeEvalC-45Compile-n--7657-2776-u--makeAlt arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13 arg-11 u--var eta-1 eta-2))) arg-13 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-n--7629-2473-u--makeDefault arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--caseblock (vector 15 (vector 17 (vector 11 "vector-ref") (cons (vector 11 u--var) (cons (vector 2 0) '()))) (DataC-45List-mapMaybe (lambda (eta-1) eta-1) e-5) (box e-6)))) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isDataCon") (cons (vector 11 u--var) '())) u--caseblock arg-8)))))))))))))))
(define CoreC-45SchemeEvalC-45Compile-n--7658-2946-u--project (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16 arg-17) (if (null? arg-16) arg-17 (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-2) (vector 17 (vector 11 "vector-ref") (cons (vector 11 arg-15) (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer arg-14)) '()))) (CoreC-45SchemeEvalC-45Compile-n--7658-2946-u--project arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 (bs+ arg-14 1 63) arg-15 e-3 arg-17)))))))
(define CoreC-45SchemeEvalC-45Compile-n--7657-2774-u--project (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16 arg-17) (if (null? arg-16) arg-17 (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-2) (vector 17 (vector 11 "vector-ref") (cons (vector 11 arg-15) (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer arg-14)) '()))) (CoreC-45SchemeEvalC-45Compile-n--7657-2774-u--project arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 (bs+ arg-14 1 63) arg-15 e-3 arg-17)))))))
(define CoreC-45SchemeEvalC-45Compile-n--5831-424-u--okchar (lambda (arg-0 arg-1) (let ((sc0 (let ((sc1 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\_)))))) (cond ((equal? sc0 1) (PreludeC-45Cast-u--cast_Cast_Char_String arg-1)) (else (PreludeC-45TypesC-45String-C-43C-43 "C-" (PreludeC-45Show-u--show_Show_Int (PreludeC-45Cast-u--cast_Cast_Char_Int arg-1))))))))
(define CoreC-45SchemeEvalC-45Compile-n--8942-3959-u--mkArgNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (cond ((equal? arg-12 0) '())(else (let ((e-0 (- arg-12 1))) (cons (vector 2 "arg" arg-11) (CoreC-45SchemeEvalC-45Compile-n--8942-3959-u--mkArgNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (bs+ arg-11 1 63) e-0)))))))
(define CoreC-45SchemeEvalC-45Compile-n--8942-3861-u--mkArgNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-7 0) '())(else (let ((e-0 (- arg-7 1))) (cons (vector 2 "arg" arg-6) (CoreC-45SchemeEvalC-45Compile-n--8942-3861-u--mkArgNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-6 1 63) e-0)))))))
(define CoreC-45SchemeEvalC-45Compile-n--7629-2473-u--makeDefault (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (vector 1 arg-8)) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (case (vector-ref e-2 0) ((3) (let ((e-5 (vector-ref e-2 1))) (CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 arg-7 e-5)))(else (CoreC-45SchemeEvalC-45Compile-n--7629-2473-u--makeDefault arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 e-3))))))))
(define CoreC-45SchemeEvalC-45Compile-n--7659-3241-u--makeAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 ext-0) (case (vector-ref arg-15 0) ((2) (let ((e-1 (vector-ref arg-15 1))) (let ((e-2 (vector-ref arg-15 2))) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 arg-7 e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (cons (vector 17 (vector 11 "equal?") (cons (vector 11 arg-14) (cons (CoreC-45SchemeEvalC-45Compile-compileConstant (CoreC-45FC-emptyFC) e-1) '()))) e-5))))))))))(else (vector 1 '())))))
(define CoreC-45SchemeEvalC-45Compile-n--7658-2948-u--makeAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15) (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((e-3 (vector-ref arg-15 3))) (let ((e-4 (vector-ref arg-15 4))) (case (vector-ref e-1 0) ((1) (let ((e-5 (vector-ref e-1 1))) (case (vector-ref e-5 0) ((0) (let ((e-6 (vector-ref e-5 1))) (cond ((equal? e-6 "->") (if (null? e-3) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-n--7658-2947-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-7)))))))) (let ((e-9 (cdr e-3))) (lambda (clam-0) (if (null? e-9) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-n--7658-2947-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-7))))))) (let ((e-12 (cdr e-9))) (if (null? e-12) (vector 1 '()) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-n--7658-2947-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-7))))))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-n--7658-2947-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-7 (vector-ref act-24 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-24 1))) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-7))))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-n--7658-2947-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-6 (vector-ref act-24 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-24 1))) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-6))))))))))))(else (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-n--7658-2947-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-5))))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45SchemeEvalC-45Compile-n--7657-2776-u--makeAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 ext-0) (case (vector-ref arg-15 0) ((0) (let ((e-2 (vector-ref arg-15 2))) (let ((e-3 (vector-ref arg-15 3))) (let ((e-4 (vector-ref arg-15 4))) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-n--7657-2775-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (box (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-2)) e-5)))))))))))(else (vector 1 '())))))
(define CoreC-45SchemeEvalC-45Compile-n--7629-2472-u--caseType (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 (vector 0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9))) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 (unbox arg-9))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-9 0))) e-0)) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-25 1))) (if (null? e-10) (vector 1 (vector 1 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)) (let ((e-1 (unbox e-10))) (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((5) (vector 1 (vector 0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9))) ((6) (vector 1 (vector 1 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)))(else (vector 1 (vector 0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)))))))))))))))))) ((1) (lambda (eta-0) (vector 1 (vector 2 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)))) ((2) (lambda (eta-0) (vector 1 (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)))) (else (CoreC-45SchemeEvalC-45Compile-n--7629-2472-u--caseType arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 e-3))))))))
(define CoreC-45SchemeEvalC-45Compile-n--7658-2947-u--bindArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16 ext-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-extend arg-1 arg-15 arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (CoreC-45SchemeEvalC-45Compile-n--7658-2946-u--project arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 5 arg-14 e-2 e-6)))))) (CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 e-3 arg-16) ext-0)))))))))
(define CoreC-45SchemeEvalC-45Compile-n--7657-2775-u--bindArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16 ext-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-extend arg-1 arg-15 arg-7 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (CoreC-45SchemeEvalC-45Compile-n--7657-2774-u--project arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 3 arg-14 e-2 e-6)))))) (CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 e-3 arg-16) ext-0)))))))))
(define CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16) (if (null? arg-15) (lambda (eta-0) (vector 1 arg-16)) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (case (vector-ref e-5 0) ((1) (let ((e-9 (vector-ref e-5 1))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 1))) (cond ((equal? e-10 "->") (if (null? e-7) (CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16) (let ((e-13 (cdr e-7))) (if (null? e-13) (CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16) (let ((e-16 (cdr e-13))) (if (null? e-16) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-24 1))) (let ((act-25 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-25 1))) (let ((u--svsC-39 (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-11)) (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-14)) arg-7)))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 u--svsC-39 e-8) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-26 1))) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isPi") (cons (vector 11 arg-14) '())) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-11) (vector 17 (vector 11 "vector-ref") (cons (vector 11 arg-14) (cons (vector 2 4) '()))) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-14) (vector 17 (vector 11 "vector-ref") (cons (vector 11 arg-14) (cons (vector 2 1) '()))) e-17)) arg-16)))))))))))))))) (CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16)))))))(else (CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16)))))(else (CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16)))))(else (CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16)))))))(else (CoreC-45SchemeEvalC-45Compile-n--7658-2949-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16))))))))
(define CoreC-45SchemeEvalC-45Compile-u--show_Show_SVar (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) (else (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "'" e-1))))))
(define CoreC-45SchemeEvalC-45Compile-varObjs (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons (vector 11 (CoreC-45SchemeEvalC-45Compile-u--show_Show_SVar e-2)) (CoreC-45SchemeEvalC-45Compile-varObjs e-3)))))))
(define CoreC-45SchemeEvalC-45Compile-unload (lambda (arg-0 arg-1) (if (null? arg-1) arg-0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 "ct-app") (cons arg-0 (cons e-2 '()))) e-3))))))
(define CoreC-45SchemeEvalC-45Compile-schVarUN (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45SchemeEvalC-45Compile-schString e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "rf--" (CoreC-45SchemeEvalC-45Compile-schString e-1)))) (else "_US_"))))
(define CoreC-45SchemeEvalC-45Compile-schVarName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref e-1 0) ((1) (let ((e-16 (vector-ref e-1 1))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (PreludeC-45TypesC-45String-C-43C-43 "-" (CoreC-45SchemeEvalC-45Compile-schVarUN e-16)))))(else (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (PreludeC-45TypesC-45String-C-43C-43 "-" (CoreC-45SchemeEvalC-45Compile-schVarName e-1)))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "u--" (CoreC-45SchemeEvalC-45Compile-schVarUN e-2)))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schString e-3) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Int e-4)))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "pat--" (CoreC-45SchemeEvalC-45Compile-schVarName e-5)))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CoreC-45SchemeEvalC-45Compile-schVarName e-8))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (let ((e-19 (car e-9))) (let ((e-20 (cdr e-9))) (PreludeC-45TypesC-45String-C-43C-43 "n--" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-19) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int e-20) (PreludeC-45TypesC-45String-C-43C-43 "-" (CoreC-45SchemeEvalC-45Compile-schVarName e-10))))))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "case--" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schString e-11) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Int e-12))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "with--" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schString e-13) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Int e-14))))))) (else (let ((e-15 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "fn--" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define CoreC-45SchemeEvalC-45Compile-schString (lambda (arg-0) (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (CoreC-45SchemeEvalC-45Compile-n--5831-424-u--okchar arg-0 eta-0)) (PreludeC-45Types-fastUnpack arg-0))))
(define CoreC-45SchemeEvalC-45Compile-schName (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 "ct-" (CoreC-45SchemeEvalC-45Compile-schVarName arg-0))))
(define CoreC-45SchemeEvalC-45Compile-nextName (lambda (arg-0 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (set-box! arg-0 (+ e-5 1)))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 e-5))))))))))
(define CoreC-45SchemeEvalC-45Compile-mkArgs (lambda (arg-0 ext-0) (if (null? arg-0) (vector 1 '()) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-mkArgs e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-2)) e-5)))))))))))
(define CoreC-45SchemeEvalC-45Compile-initialiseSchemeEval (lambda (arg-0) (lambda (eta-0) (CoreC-45SchemeEvalC-45Compile-initEvalWith arg-0 (SystemC-45Info-codegen) eta-0))))
(define CoreC-45SchemeEvalC-45Compile-initEvalWith (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 "chez") (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (let ((e-30 (vector-ref e-5 30))) e-30))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-25 (CoreC-45Directory-readDataFile arg-0 "chez/ct-support.ss" eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((LibrariesC-45UtilsC-45Scheme-evalSchemeStr (PreludeC-45TypesC-45String-C-43C-43 "(begin " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))) eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 0) (let ((act-27 (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-34 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-32 (vector-ref e-5 6))) (let ((e-31 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (vector e-0 e-34 e-2 e-3 e-4 e-33 e-32 e-31 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 1)))))))))))))))))))))))))))))))))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 1)))))))))))))) (lambda (u--err) (lambda (eta-0) (vector 1 0))) ext-0))))))))) ((equal? arg-1 "racket") (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((sc2 (let ((e-30 (vector-ref e-5 30))) e-30))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-25 (CoreC-45Directory-readDataFile arg-0 "racket/ct-support.rkt" eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((LibrariesC-45UtilsC-45Scheme-evalSchemeStr (PreludeC-45TypesC-45String-C-43C-43 "(begin " (PreludeC-45TypesC-45String-C-43C-43 e-6 ")"))) eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (vector 1 0) (let ((act-27 (let ((act-27 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-34 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-32 (vector-ref e-5 6))) (let ((e-31 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (vector e-0 e-34 e-2 e-3 e-4 e-33 e-32 e-31 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 1)))))))))))))))))))))))))))))))))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (vector 1 1)))))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-25 (let ((act-25 ((PreludeC-45IO-printLn (csegen-1269) u--err) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 0)))))) ext-0)))))))))(else (vector 1 0)))))
(define CoreC-45SchemeEvalC-45Compile-getSchVar (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-3 (car arg-4))) (case (vector-ref e-3 0) ((0) (let ((e-5 (vector-ref e-3 1))) e-5)) (else (let ((e-6 (vector-ref e-3 1))) (PreludeC-45TypesC-45String-C-43C-43 "'" e-6))))))(else (let ((e-0 (- arg-2 1))) (let ((e-10 (cdr arg-4))) (CoreC-45SchemeEvalC-45Compile-getSchVar e-0 e-10)))))))
(define CoreC-45SchemeEvalC-45Compile-getName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) (else (let ((e-1 (vector-ref arg-0 1))) e-1)))))
(define CoreC-45SchemeEvalC-45Compile-getArgName (lambda (arg-0 ext-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 2 "carg" (PreludeC-45Cast-u--cast_Cast_Integer_Int e-5)))))))))
(define CoreC-45SchemeEvalC-45Compile-extend (lambda (arg-1 arg-2 arg-3 ext-0) (if (null? arg-2) (vector 1 (cons '() arg-3)) (let ((e-3 (cdr arg-2))) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45SchemeEvalC-45Compile-extend arg-1 e-3 arg-3 ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (cons e-5 e-7) (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-5)) e-4)))))))))))))))))
(define CoreC-45SchemeEvalC-45Compile-compileStk (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-58 (vector-ref arg-5 3))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 11 (CoreC-45SchemeEvalC-45Compile-getSchVar e-58 arg-3)) arg-4))))) ((1) (let ((e-61 (vector-ref arg-5 1))) (let ((e-62 (vector-ref arg-5 2))) (let ((e-63 (vector-ref arg-5 3))) (lambda (clam-0) (case (vector-ref e-62 0) ((0) (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 6 (CoreC-45Name-u--show_Show_Name e-63)) arg-4))) ((2) (let ((e-74 (vector-ref e-62 1))) (let ((e-75 (vector-ref e-62 2))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-4) e-75))) (cond ((equal? sc2 1) (let ((act-24 (CoreC-45Context-toResolvedNames arg-2 (csegen-46) e-63 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-74) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-5) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-61) arg-4))))))))) (else (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 (CoreC-45SchemeEvalC-45Compile-schName e-63)) '()) arg-4)))))))) ((3) (let ((e-76 (vector-ref e-62 1))) (let ((e-77 (vector-ref e-62 2))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_Nat (PreludeC-45TypesC-45List-length arg-4) e-77))) (cond ((equal? sc2 1) (let ((act-24 (CoreC-45Context-toResolvedNames arg-2 (csegen-46) e-63 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -1 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-76)) (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-63)) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-5) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-61) arg-4))))))))))) (else (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 (CoreC-45SchemeEvalC-45Compile-schName e-63)) '()) arg-4))))))))(else (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 (CoreC-45SchemeEvalC-45Compile-schName e-63)) '()) arg-4))))))))) ((2) (let ((e-66 (vector-ref arg-5 2))) (let ((e-68 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 eta-1)) e-68 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 (CoreC-45SchemeEvalC-45Compile-schName e-66)) '()) (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Nat_Integer (PreludeC-45TypesC-45List-length e-68))) (PreludeC-45TypesC-45List-tailRecAppend arg-4 e-5)))))))))))) ((3) (let ((e-71 (vector-ref arg-5 2))) (let ((e-72 (vector-ref arg-5 3))) (let ((e-73 (vector-ref arg-5 4))) (case (vector-ref e-72 0) ((1) (let ((e-81 (vector-ref e-72 3))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-71) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-81) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-73) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 13 u--xC-39 e-6 e-7) arg-4)))))))))))))))))) ((2) (let ((e-85 (vector-ref e-72 2))) (let ((e-86 (vector-ref e-72 3))) (let ((e-87 (vector-ref e-72 4))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-71) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-87) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-73) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45SchemeEvalC-45Compile-compilePiInfo arg-1 arg-2 arg-3 e-86 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 8 -3 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-85) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemePi e-8) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-71) '()))))))))))))))))))))))))))))) ((3) (let ((e-90 (vector-ref e-72 2))) (let ((e-91 (vector-ref e-72 3))) (let ((e-92 (vector-ref e-72 4))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-71) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-92) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-73) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45SchemeEvalC-45Compile-compilePiInfo arg-1 arg-2 arg-3 e-91 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 8 -12 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-90) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemePi e-8) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-71) '()))))))))))))))))))))))))))))) ((5) (let ((e-95 (vector-ref e-72 2))) (let ((e-96 (vector-ref e-72 3))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-71) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-96) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-73) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (vector 1 (vector 8 -13 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-95) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-71) '()))))))))))))))))))))))) ((4) (let ((e-99 (vector-ref e-72 2))) (let ((e-100 (vector-ref e-72 3))) (let ((e-101 (vector-ref e-72 4))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-71) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-100) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-101) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-73) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 8 -14 (cons (vector 12 (cons u--xC-39 '()) e-8) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-99) (cons e-6 (cons e-7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-71) '())))))))))))))))))))))))))))))(else (if (null? arg-4) (case (vector-ref arg-5 0) ((3) (let ((e-36 (vector-ref arg-5 2))) (let ((e-37 (vector-ref arg-5 3))) (let ((e-38 (vector-ref arg-5 4))) (case (vector-ref e-37 0) ((0) (let ((e-41 (vector-ref e-37 2))) (let ((e-42 (vector-ref e-37 3))) (let ((e-43 (vector-ref e-37 4))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-36) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-43) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-38) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45SchemeEvalC-45Compile-compilePiInfo arg-1 arg-2 arg-3 e-42 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 8 -8 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-41) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemePi e-8) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-36) '())))))))))))))))))))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '())))))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '())))))))))))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool e-27) '())))))))) (else (let ((e-29 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) '())))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '())))))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '())))))))))))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool e-27) '())))))))) (else (let ((e-29 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) '()))))))))) (let ((e-32 (car arg-4))) (let ((e-33 (cdr arg-4))) (case (vector-ref arg-5 0) ((3) (let ((e-46 (vector-ref arg-5 2))) (let ((e-47 (vector-ref arg-5 3))) (let ((e-48 (vector-ref arg-5 4))) (case (vector-ref e-47 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-46) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) e-33 e-48) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 17 (vector 12 (cons u--xC-39 '()) e-6) (cons e-32 '()))))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '())))))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '())))))))))))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool e-27) '())))))))) (else (let ((e-29 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) '())))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '())))))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '())))))))))))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool e-27) '())))))))) (else (let ((e-29 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) '()))))))))))))))))))(else (if (null? arg-4) (case (vector-ref arg-5 0) ((3) (let ((e-36 (vector-ref arg-5 2))) (let ((e-37 (vector-ref arg-5 3))) (let ((e-38 (vector-ref arg-5 4))) (case (vector-ref e-37 0) ((0) (let ((e-41 (vector-ref e-37 2))) (let ((e-42 (vector-ref e-37 3))) (let ((e-43 (vector-ref e-37 4))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-36) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-43) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-38) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45SchemeEvalC-45Compile-compilePiInfo arg-1 arg-2 arg-3 e-42 eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (vector 1 (vector 8 -8 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-41) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemePi e-8) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-36) '())))))))))))))))))))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '())))))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '())))))))))))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool e-27) '())))))))) (else (let ((e-29 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) '())))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '())))))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '())))))))))))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool e-27) '())))))))) (else (let ((e-29 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) '()))))))))) (let ((e-32 (car arg-4))) (let ((e-33 (cdr arg-4))) (case (vector-ref arg-5 0) ((3) (let ((e-46 (vector-ref arg-5 2))) (let ((e-47 (vector-ref arg-5 3))) (let ((e-48 (vector-ref arg-5 4))) (case (vector-ref e-47 0) ((0) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--xC-39 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45SchemeEvalC-45Compile-schVarName e-46) (PreludeC-45TypesC-45String-C-43C-43 "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) e-33 e-48) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 17 (vector 12 (cons u--xC-39 '()) e-6) (cons e-32 '()))))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '())))))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '())))))))))))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool e-27) '())))))))) (else (let ((e-29 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) '())))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '())))))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '())))))))))))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bool e-27) '())))))))) (else (let ((e-29 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) '()))))))))))))))))
(define CoreC-45SchemeEvalC-45Compile-compilePiInfo (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (vector 1 (vector 0 ))) ((1) (vector 1 (vector 1 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-4 1))) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-4) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 3 e-5)))))))))))
(define CoreC-45SchemeEvalC-45Compile-compileDef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (CoreC-45Context-toFullNames arg-0 (csegen-46) arg-2 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-6 0))) e-0)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 (CoreC-45FC-emptyFC) e-5) ext-0) (let ((e-1 (unbox e-7))) (let ((sc4 (let ((e-21 (vector-ref e-1 21))) (if (null? e-21) 1 (let ((e-26 (unbox e-21))) (let ((e-28 (car e-26))) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_SchemeMode e-28 arg-1))))))) (cond ((equal? sc4 1) (let ((u--redok (let ((sc5 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SchemeMode arg-1 0))) (cond ((equal? sc5 1) 1) (else (CoreC-45Context-reducibleInAny (cons (let ((e-2 (vector-ref e-6 2))) e-2) (let ((e-3 (vector-ref e-6 3))) e-3)) (let ((e-25 (vector-ref e-1 1))) e-25) (let ((e-9 (vector-ref e-1 9))) e-9))))))) (let ((act-27 (let ((act-27 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) e-5 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-toFullNames arg-0 (csegen-1050) (let ((e-17 (vector-ref e-1 17))) e-17) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) ((CoreC-45SchemeEvalC-45Compile-compileBody arg-0 u--redok e-8 e-9) ext-0))))))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (let ((u--schdef (vector 10 (CoreC-45SchemeEvalC-45Compile-schName e-5) e-8))) (let ((act-28 (let ((act-28 ((LibrariesC-45UtilsC-45Scheme-evalSchemeObj u--schdef) ext-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (if (null? e-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Compiling " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-5) " failed"))) ext-0) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (CoreC-45Context-addDef arg-0 e-5 (let ((e-0 (vector-ref e-1 0))) (let ((e-28 (vector-ref e-1 1))) (let ((e-27 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-26 (vector-ref e-1 5))) (let ((e-25 (vector-ref e-1 6))) (let ((e-24 (vector-ref e-1 7))) (let ((e-23 (vector-ref e-1 8))) (let ((e-22 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (vector e-0 e-28 e-27 e-3 e-4 e-26 e-25 e-24 e-23 e-22 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 (box (cons arg-1 u--schdef)))))))))))))))))))))))) eta-0)) ext-0)))))))))))))(else (vector 1 0))))))))))))))))))))
(define CoreC-45SchemeEvalC-45Compile-compileConstant (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (vector 8 -100 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-0)) '())))) ((1) (let ((e-1 (vector-ref arg-1 1))) (vector 8 -101 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int8_Integer e-1)) '())))) ((2) (let ((e-2 (vector-ref arg-1 1))) (vector 8 -102 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int16_Integer e-2)) '())))) ((3) (let ((e-3 (vector-ref arg-1 1))) (vector 8 -103 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int32_Integer e-3)) '())))) ((4) (let ((e-4 (vector-ref arg-1 1))) (vector 8 -104 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int64_Integer e-4)) '())))) ((5) (let ((e-5 (vector-ref arg-1 1))) (vector 8 -105 (cons (vector 2 e-5) '())))) ((6) (let ((e-6 (vector-ref arg-1 1))) (vector 8 -106 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Bits8_Integer e-6)) '())))) ((7) (let ((e-7 (vector-ref arg-1 1))) (vector 8 -107 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Bits16_Integer e-7)) '())))) ((8) (let ((e-8 (vector-ref arg-1 1))) (vector 8 -108 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Bits32_Integer e-8)) '())))) ((9) (let ((e-9 (vector-ref arg-1 1))) (vector 8 -109 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Bits64_Integer e-9)) '())))) ((10) (let ((e-10 (vector-ref arg-1 1))) (vector 4 e-10))) ((11) (let ((e-11 (vector-ref arg-1 1))) (vector 5 e-11))) ((12) (let ((e-12 (vector-ref arg-1 1))) (vector 3 e-12)))(else (vector 8 -1 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer (CoreC-45TT-constTag arg-1))) (cons (vector 4 (CoreC-45TT-u--show_Show_Constant arg-1)) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name (vector 1 (vector 0 (CoreC-45TT-u--show_Show_Constant arg-1)))) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC arg-0) '())))))))))
(define CoreC-45SchemeEvalC-45Compile-compileCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-24 ((CoreC-45SchemeEvalC-45Compile-n--7629-2472-u--caseType arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-5) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-24 1))) (case (vector-ref e-6 0) ((0) ((CoreC-45SchemeEvalC-45Compile-n--7629-2474-u--toSchemeConCases arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-2 e-5) eta-0)) ((1) ((CoreC-45SchemeEvalC-45Compile-n--7629-2475-u--toSchemeTyConCases arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-2 e-5) eta-0)) ((2) ((CoreC-45SchemeEvalC-45Compile-n--7629-2477-u--toSchemeDelayCases arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-2 e-5) eta-0)) (else ((CoreC-45SchemeEvalC-45Compile-n--7629-2476-u--toSchemeConstCases arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-2 e-5) eta-0))))))))))))) ((1) (let ((e-8 (vector-ref arg-5 2))) (CoreC-45SchemeEvalC-45Compile-compile arg-1 arg-2 arg-4 e-8)))(else (lambda (eta-0) (vector 1 arg-3))))))
(define CoreC-45SchemeEvalC-45Compile-compileBody (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-2 '())))) ((1) (let ((e-0 (vector-ref arg-3 1))) (let ((e-1 (vector-ref arg-3 2))) (let ((e-2 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.SchemeEval.Compile.Sym" ) 0 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-5 (vector-ref act-24 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45SchemeEvalC-45Compile-mkArgs e-1 eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-6 (vector-ref act-25 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--blk (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-2 (CoreC-45SchemeEvalC-45Compile-varObjs e-6)))) (let ((act-26 ((CoreC-45SchemeEvalC-45Compile-compileCase e-5 arg-0 u--blk e-6 e-2) eta-0))) (case (vector-ref act-26 0) ((0) (let ((e-7 (vector-ref act-26 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--bodyC-39 (cond ((equal? arg-1 1) (vector 14 (vector 17 (vector 11 "ct-isBlockAll") '()) u--blk e-7)) (else u--blk)))) (let ((e-10 (vector-ref e-0 0))) (if (null? e-10) (vector 1 (CoreC-45SchemeEvalC-45Compile-bindArgs arg-2 e-6 '() u--bodyC-39)) (vector 1 (vector 12 (cons "h-0" '()) (CoreC-45SchemeEvalC-45Compile-bindArgs arg-2 e-6 '() u--bodyC-39)))))))))))))))))))))))) ((2) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-2 '())))) ((3) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-2 '())))) ((4) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Builtins-compileBuiltin e-8 arg-2 e-9)))))) ((5) (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (cond ((equal? e-11 0) (lambda (eta-0) (let ((act-24 (CoreC-45Context-toResolvedNames arg-0 (csegen-46) arg-2 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 8 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-10) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-5) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC (CoreC-45FC-emptyFC)) '()))))))))))(else (let ((u--args (CoreC-45SchemeEvalC-45Compile-n--8942-3861-u--mkArgNs arg-1 e-12 e-11 e-10 arg-2 arg-0 0 e-11))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-mkArgs u--args eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--body (vector 8 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-10) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-2) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC (CoreC-45FC-emptyFC)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 11 (CoreC-45SchemeEvalC-45Compile-schVarName eta-1))) u--args)))))) (vector 1 (CoreC-45SchemeEvalC-45Compile-bindArgs arg-2 e-5 '() u--body))))))))))))))) ((6) (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (let ((e-17 (vector-ref arg-3 5))) (let ((e-18 (vector-ref arg-3 6))) (let ((e-19 (vector-ref arg-3 7))) (let ((e-20 (vector-ref arg-3 8))) (cond ((equal? e-14 0) (lambda (eta-0) (vector 1 (vector 8 -1 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-13)) (cons (vector 4 (CoreC-45Name-u--show_Show_Name arg-2)) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-2) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC (CoreC-45FC-emptyFC)) '()))))))))(else (let ((u--args (CoreC-45SchemeEvalC-45Compile-n--8942-3959-u--mkArgNs arg-1 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 arg-2 arg-0 0 e-14))) (lambda (eta-0) (let ((act-24 (CoreC-45SchemeEvalC-45Compile-mkArgs u--args eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--body (vector 8 -1 (cons (vector 2 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-13)) (cons (vector 4 (CoreC-45Name-u--show_Show_Name arg-2)) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-2) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC (CoreC-45FC-emptyFC)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 11 (CoreC-45SchemeEvalC-45Compile-schVarName eta-1))) u--args)))))))) (vector 1 (CoreC-45SchemeEvalC-45Compile-bindArgs arg-2 e-5 '() u--body)))))))))))))))))))) ((7) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) ((8) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) ((9) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) ((10) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) (else (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))))))
(define CoreC-45SchemeEvalC-45Compile-compile (lambda (arg-1 arg-2 arg-3 arg-4) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() arg-4)))
(define CoreC-45SchemeEvalC-45Compile-blockedMetaApp (lambda (arg-0) (vector 12 (cons "arity-0" '()) (vector 8 -10 (cons (vector 1 (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-0) (vector 11 "arity-0")) (cons (vector 0 ) '()))))))
(define CoreC-45SchemeEvalC-45Compile-blockedAppWith (lambda (arg-0 arg-1) (vector 8 -2 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-0) (cons (CoreC-45SchemeEvalC-45Compile-n--6157-726-u--vars arg-1 arg-0 arg-1) '())))))
(define CoreC-45SchemeEvalC-45Compile-bindArgs (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) arg-4 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (vector 8 -9 (cons (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-1 (PreludeC-45TypesC-45List-reverse arg-3)) (cons (vector 12 (cons (CoreC-45SchemeEvalC-45Compile-u--show_Show_SVar e-2) '()) (CoreC-45SchemeEvalC-45Compile-bindArgs arg-1 e-3 (cons (vector 11 (CoreC-45SchemeEvalC-45Compile-u--show_Show_SVar e-2)) arg-3) arg-4)) '()))))))))
(define CoreC-45SchemeEvalC-45Builtins-case--applyCast-2876 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (case (vector-ref arg-1 0) ((24) (vector 17 (vector 11 "number->string") (cons arg-0 '())))(else arg-2)) (let ((e-2 (unbox arg-3))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (if (null? e-3) (CoreC-45SchemeEvalC-45Builtins-integer (vector 17 (vector 11 "ct-exact-truncate") (cons arg-0 '()))) (let ((e-5 (unbox e-3))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-exact-truncate-boundedInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-5 1 63)) '())))))))) (else (let ((e-4 (vector-ref e-2 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-exact-truncate-boundedUInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-4) '())))))))))))
(define CoreC-45SchemeEvalC-45Builtins-case--applyCast-2703 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (case (vector-ref arg-1 0) ((26) (vector 17 (vector 11 "ct-cast-string-double") (cons arg-0 '())))(else arg-2)) (let ((e-2 (unbox arg-3))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (if (null? e-3) (CoreC-45SchemeEvalC-45Builtins-integer (vector 17 (vector 11 "ct-cast-string-int") (cons arg-0 '()))) (let ((e-5 (unbox e-3))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-cast-string-boundedInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-5 1 63)) '())))))))) (else (let ((e-4 (vector-ref e-2 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-cast-string-boundedUInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-4) '())))))))))))
(define CoreC-45SchemeEvalC-45Builtins-case--applyCast-2552 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (case (vector-ref arg-1 0) ((24) (vector 17 (vector 11 "string") (cons arg-0 '())))(else arg-2)) (let ((e-2 (unbox arg-3))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (if (null? e-3) (CoreC-45SchemeEvalC-45Builtins-integer (vector 17 (vector 11 "char->integer") (cons arg-0 '()))) (let ((e-5 (unbox e-3))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-cast-char-boundedInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-5 1 63)) '())))))))) (else (let ((e-4 (vector-ref e-2 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-cast-char-boundedUInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-4) '())))))))))))
(define CoreC-45SchemeEvalC-45Builtins-n--8796-4137-u--vars (lambda (arg-0 arg-1 arg-2 arg-4 arg-6) (if (null? arg-6) (vector 0 ) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (vector 1 (vector 11 e-3) (CoreC-45SchemeEvalC-45Builtins-n--8796-4137-u--vars arg-0 arg-1 arg-2 arg-4 e-4)))))))
(define CoreC-45SchemeEvalC-45Builtins-n--8790-4132-u--makeBlockedApp (lambda (arg-0 arg-1 arg-2 arg-4) (vector 8 -2 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-2) (cons (CoreC-45SchemeEvalC-45Builtins-n--8796-4137-u--vars arg-0 arg-1 arg-2 arg-4 arg-4) '())))))
(define CoreC-45SchemeEvalC-45Builtins-n--8790-4133-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-5 arg-6 arg-7) (if (null? arg-5) (CoreC-45SchemeEvalC-45Builtins-applyOp (CoreC-45SchemeEvalC-45Builtins-n--8790-4132-u--makeBlockedApp arg-0 arg-1 arg-2 arg-7) arg-1 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (vector 11 eta-0)) arg-7)) (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (vector 8 -9 (cons (CoreC-45SchemeEvalC-45Builtins-n--8790-4132-u--makeBlockedApp arg-0 arg-1 arg-2 (DataC-45Vect-reverse arg-6)) (cons (vector 12 (cons e-3 '()) (CoreC-45SchemeEvalC-45Builtins-n--8790-4133-u--bindArgs arg-0 arg-1 arg-2 e-4 (cons e-3 arg-6) arg-7)) '()))))))))
(define CoreC-45SchemeEvalC-45Builtins-wrap (lambda (arg-0) (lambda (clam-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) (CoreC-45SchemeEvalC-45Builtins-integer clam-0) (let ((e-2 (unbox e-0))) (cond ((equal? e-2 8) (CoreC-45SchemeEvalC-45Builtins-int8 clam-0)) ((equal? e-2 16) (CoreC-45SchemeEvalC-45Builtins-int16 clam-0)) ((equal? e-2 32) (CoreC-45SchemeEvalC-45Builtins-int32 clam-0)) ((equal? e-2 64) (CoreC-45SchemeEvalC-45Builtins-int64 clam-0))(else (CoreC-45SchemeEvalC-45Builtins-integer clam-0))))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 8) (CoreC-45SchemeEvalC-45Builtins-bits8 clam-0)) ((equal? e-1 16) (CoreC-45SchemeEvalC-45Builtins-bits16 clam-0)) ((equal? e-1 32) (CoreC-45SchemeEvalC-45Builtins-bits32 clam-0)) ((equal? e-1 64) (CoreC-45SchemeEvalC-45Builtins-bits64 clam-0))(else (CoreC-45SchemeEvalC-45Builtins-integer clam-0)))))(else (CoreC-45SchemeEvalC-45Builtins-integer clam-0))))))
(define CoreC-45SchemeEvalC-45Builtins-unaryOp (lambda (arg-0 arg-1 arg-2) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-2 '()) (vector 17 (vector 11 arg-1) (cons arg-2 '())))))
(define CoreC-45SchemeEvalC-45Builtins-testPartial (lambda (arg-0 arg-1) (vector 13 "p-0" arg-1 (vector 14 (vector 17 (vector 11 "ct-isConstant") (cons (vector 11 "p-0") '())) (vector 11 "p-0") arg-0))))
(define CoreC-45SchemeEvalC-45Builtins-sub (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct-") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct-") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-s-") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-u-") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct-") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-shr (lambda (arg-0 arg-1 arg-2) (vector 17 (vector 11 "ct-shr") (cons arg-1 (cons arg-2 '())))))
(define CoreC-45SchemeEvalC-45Builtins-shl (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct-shl") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct-shl") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-bits-shl-signed") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-bits-shl") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct-shl") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-mul (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct*") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct*") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-s*") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-u*") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct*") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-mod (lambda (arg-0 arg-1) (vector 17 (vector 11 "ct-mod") (cons arg-0 (cons arg-1 '())))))
(define CoreC-45SchemeEvalC-45Builtins-mkArgList (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (cons (PreludeC-45TypesC-45String-C-43C-43 "x-" (PreludeC-45Show-u--show_Show_Int arg-0)) (CoreC-45SchemeEvalC-45Builtins-mkArgList (bs+ arg-0 1 63) e-0)))))))
(define CoreC-45SchemeEvalC-45Builtins-integer (lambda (arg-0) (vector 8 -105 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int8 (lambda (arg-0) (vector 8 -101 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int64 (lambda (arg-0) (vector 8 -104 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int32 (lambda (arg-0) (vector 8 -103 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int16 (lambda (arg-0) (vector 8 -102 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int (lambda (arg-0) (vector 8 -100 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-div (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct/") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct/") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-s/") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-u/") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct/") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-compileBuiltin (lambda (arg-0 arg-1 arg-2) (let ((u--args (CoreC-45SchemeEvalC-45Builtins-mkArgList 0 arg-0))) (CoreC-45SchemeEvalC-45Builtins-n--8790-4133-u--bindArgs arg-0 arg-2 arg-1 u--args '() u--args))))
(define CoreC-45SchemeEvalC-45Builtins-canonical (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (vector 14 (vector 17 (vector 11 "ct-isConstant") (cons e-3 '())) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 e-4 arg-3) arg-1))))))
(define CoreC-45SchemeEvalC-45Builtins-boolOp (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-2 (cons arg-3 '())) (CoreC-45SchemeEvalC-45Builtins-int (vector 17 (vector 11 "or") (cons (vector 17 (vector 11 "and") (cons (vector 17 (vector 11 arg-1) (cons arg-2 (cons arg-3 '()))) (cons (vector 2 1) '()))) (cons (vector 2 0) '())))))))
(define CoreC-45SchemeEvalC-45Builtins-bits8 (lambda (arg-0) (vector 8 -106 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-bits64 (lambda (arg-0) (vector 8 -109 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-bits32 (lambda (arg-0) (vector 8 -108 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-bits16 (lambda (arg-0) (vector 8 -107 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-binOp (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-2 (cons arg-3 '())) (vector 17 (vector 11 arg-1) (cons arg-2 (cons arg-3 '()))))))
(define CoreC-45SchemeEvalC-45Builtins-applyOp (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (case (vector-ref e-0 0) ((26) (if (null? arg-3) (let ((e-20 (car arg-3))) (let ((e-21 (cdr arg-3))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-20 (cons e-24 '())) (CoreC-45SchemeEvalC-45Builtins-add (CoreC-45TT-intKind e-0) e-20 e-24)))))) (let ((e-29 (car arg-3))) (let ((e-30 (cdr arg-3))) (if (null? e-30) (let ((e-20 (car arg-3))) (let ((e-21 (cdr arg-3))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-20 (cons e-24 '())) (CoreC-45SchemeEvalC-45Builtins-add (CoreC-45TT-intKind e-0) e-20 e-24)))))) (let ((e-33 (car e-30))) (let ((e-34 (cdr e-30))) (if (null? e-34) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "+" e-29 e-33) (let ((e-20 (car arg-3))) (let ((e-21 (cdr arg-3))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-20 (cons e-24 '())) (CoreC-45SchemeEvalC-45Builtins-add (CoreC-45TT-intKind e-0) e-20 e-24))))))))))))))(else (let ((e-20 (car arg-3))) (let ((e-21 (cdr arg-3))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-20 (cons e-24 '())) (CoreC-45SchemeEvalC-45Builtins-add (CoreC-45TT-intKind e-0) e-20 e-24)))))))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (case (vector-ref e-1 0) ((26) (if (null? arg-3) (let ((e-38 (car arg-3))) (let ((e-39 (cdr arg-3))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-38 (cons e-42 '())) (CoreC-45SchemeEvalC-45Builtins-sub (CoreC-45TT-intKind e-1) e-38 e-42)))))) (let ((e-47 (car arg-3))) (let ((e-48 (cdr arg-3))) (if (null? e-48) (let ((e-38 (car arg-3))) (let ((e-39 (cdr arg-3))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-38 (cons e-42 '())) (CoreC-45SchemeEvalC-45Builtins-sub (CoreC-45TT-intKind e-1) e-38 e-42)))))) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (if (null? e-52) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "-" e-47 e-51) (let ((e-38 (car arg-3))) (let ((e-39 (cdr arg-3))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-38 (cons e-42 '())) (CoreC-45SchemeEvalC-45Builtins-sub (CoreC-45TT-intKind e-1) e-38 e-42))))))))))))))(else (let ((e-38 (car arg-3))) (let ((e-39 (cdr arg-3))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-38 (cons e-42 '())) (CoreC-45SchemeEvalC-45Builtins-sub (CoreC-45TT-intKind e-1) e-38 e-42)))))))))) ((2) (let ((e-2 (vector-ref arg-2 1))) (case (vector-ref e-2 0) ((26) (if (null? arg-3) (let ((e-56 (car arg-3))) (let ((e-57 (cdr arg-3))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-56 (cons e-60 '())) (CoreC-45SchemeEvalC-45Builtins-mul (CoreC-45TT-intKind e-2) e-56 e-60)))))) (let ((e-65 (car arg-3))) (let ((e-66 (cdr arg-3))) (if (null? e-66) (let ((e-56 (car arg-3))) (let ((e-57 (cdr arg-3))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-56 (cons e-60 '())) (CoreC-45SchemeEvalC-45Builtins-mul (CoreC-45TT-intKind e-2) e-56 e-60)))))) (let ((e-69 (car e-66))) (let ((e-70 (cdr e-66))) (if (null? e-70) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "*" e-65 e-69) (let ((e-56 (car arg-3))) (let ((e-57 (cdr arg-3))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-56 (cons e-60 '())) (CoreC-45SchemeEvalC-45Builtins-mul (CoreC-45TT-intKind e-2) e-56 e-60))))))))))))))(else (let ((e-56 (car arg-3))) (let ((e-57 (cdr arg-3))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-56 (cons e-60 '())) (CoreC-45SchemeEvalC-45Builtins-mul (CoreC-45TT-intKind e-2) e-56 e-60)))))))))) ((3) (let ((e-3 (vector-ref arg-2 1))) (case (vector-ref e-3 0) ((26) (if (null? arg-3) (let ((e-74 (car arg-3))) (let ((e-75 (cdr arg-3))) (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-74 (cons e-78 '())) (CoreC-45SchemeEvalC-45Builtins-div (CoreC-45TT-intKind e-3) e-74 e-78)))))) (let ((e-83 (car arg-3))) (let ((e-84 (cdr arg-3))) (if (null? e-84) (let ((e-74 (car arg-3))) (let ((e-75 (cdr arg-3))) (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-74 (cons e-78 '())) (CoreC-45SchemeEvalC-45Builtins-div (CoreC-45TT-intKind e-3) e-74 e-78)))))) (let ((e-87 (car e-84))) (let ((e-88 (cdr e-84))) (if (null? e-88) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "/" e-83 e-87) (let ((e-74 (car arg-3))) (let ((e-75 (cdr arg-3))) (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-74 (cons e-78 '())) (CoreC-45SchemeEvalC-45Builtins-div (CoreC-45TT-intKind e-3) e-74 e-78))))))))))))))(else (let ((e-74 (car arg-3))) (let ((e-75 (cdr arg-3))) (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-74 (cons e-78 '())) (CoreC-45SchemeEvalC-45Builtins-div (CoreC-45TT-intKind e-3) e-74 e-78)))))))))) ((5) (let ((e-4 (vector-ref arg-2 1))) (case (vector-ref e-4 0) ((26) (if (null? arg-3) (let ((e-92 (car arg-3))) (let ((e-93 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-92 '()) (vector 17 (vector 11 "ct-neg") (cons e-92 '()))))) (let ((e-97 (car arg-3))) (let ((e-98 (cdr arg-3))) (if (null? e-98) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "-" e-97) (let ((e-92 (car arg-3))) (let ((e-93 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-92 '()) (vector 17 (vector 11 "ct-neg") (cons e-92 '()))))))))))(else (let ((e-92 (car arg-3))) (let ((e-93 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-92 '()) (vector 17 (vector 11 "ct-neg") (cons e-92 '()))))))))) ((4) (let ((e-102 (car arg-3))) (let ((e-103 (cdr arg-3))) (let ((e-106 (car e-103))) (let ((e-107 (cdr e-103))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-102 (cons e-106 '())) (CoreC-45SchemeEvalC-45Builtins-mod e-102 e-106))))))) ((6) (let ((e-6 (vector-ref arg-2 1))) (let ((e-111 (car arg-3))) (let ((e-112 (cdr arg-3))) (let ((e-115 (car e-112))) (let ((e-116 (cdr e-112))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-111 (cons e-115 '())) (CoreC-45SchemeEvalC-45Builtins-shl (CoreC-45TT-intKind e-6) e-111 e-115)))))))) ((7) (let ((e-7 (vector-ref arg-2 1))) (let ((e-120 (car arg-3))) (let ((e-121 (cdr arg-3))) (let ((e-124 (car e-121))) (let ((e-125 (cdr e-121))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-120 (cons e-124 '())) (CoreC-45SchemeEvalC-45Builtins-shr (CoreC-45TT-intKind e-7) e-120 e-124)))))))) ((8) (let ((e-129 (car arg-3))) (let ((e-130 (cdr arg-3))) (let ((e-133 (car e-130))) (let ((e-134 (cdr e-130))) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "ct-and" e-129 e-133)))))) ((9) (let ((e-138 (car arg-3))) (let ((e-139 (cdr arg-3))) (let ((e-142 (car e-139))) (let ((e-143 (cdr e-139))) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "ct-or" e-138 e-142)))))) ((10) (let ((e-147 (car arg-3))) (let ((e-148 (cdr arg-3))) (let ((e-151 (car e-148))) (let ((e-152 (cdr e-148))) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "ct-xor" e-147 e-151)))))) ((11) (let ((e-11 (vector-ref arg-2 1))) (case (vector-ref e-11 0) ((25) (if (null? arg-3) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-165 (car arg-3))) (let ((e-166 (cdr arg-3))) (if (null? e-166) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-169 (car e-166))) (let ((e-170 (cdr e-166))) (if (null? e-170) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char<?" e-165 e-169) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))))))))))) ((24) (if (null? arg-3) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-174 (car arg-3))) (let ((e-175 (cdr arg-3))) (if (null? e-175) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-178 (car e-175))) (let ((e-179 (cdr e-175))) (if (null? e-179) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string<?" e-174 e-178) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))))))))))) ((26) (if (null? arg-3) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-183 (car arg-3))) (let ((e-184 (cdr arg-3))) (if (null? e-184) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-187 (car e-184))) (let ((e-188 (cdr e-184))) (if (null? e-188) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "<" e-183 e-187) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160)))))))))))))(else (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))))))) ((12) (let ((e-12 (vector-ref arg-2 1))) (case (vector-ref e-12 0) ((25) (if (null? arg-3) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-201 (car arg-3))) (let ((e-202 (cdr arg-3))) (if (null? e-202) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-205 (car e-202))) (let ((e-206 (cdr e-202))) (if (null? e-206) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char<=?" e-201 e-205) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))))))))))) ((24) (if (null? arg-3) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-210 (car arg-3))) (let ((e-211 (cdr arg-3))) (if (null? e-211) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-214 (car e-211))) (let ((e-215 (cdr e-211))) (if (null? e-215) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string<=?" e-210 e-214) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))))))))))) ((26) (if (null? arg-3) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-219 (car arg-3))) (let ((e-220 (cdr arg-3))) (if (null? e-220) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-223 (car e-220))) (let ((e-224 (cdr e-220))) (if (null? e-224) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "<=" e-219 e-223) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196)))))))))))))(else (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))))))) ((13) (let ((e-13 (vector-ref arg-2 1))) (case (vector-ref e-13 0) ((25) (if (null? arg-3) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-237 (car arg-3))) (let ((e-238 (cdr arg-3))) (if (null? e-238) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-241 (car e-238))) (let ((e-242 (cdr e-238))) (if (null? e-242) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char=?" e-237 e-241) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))))))))))) ((24) (if (null? arg-3) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-246 (car arg-3))) (let ((e-247 (cdr arg-3))) (if (null? e-247) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-250 (car e-247))) (let ((e-251 (cdr e-247))) (if (null? e-251) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string=?" e-246 e-250) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))))))))))) ((26) (if (null? arg-3) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-255 (car arg-3))) (let ((e-256 (cdr arg-3))) (if (null? e-256) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-259 (car e-256))) (let ((e-260 (cdr e-256))) (if (null? e-260) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "=" e-255 e-259) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232)))))))))))))(else (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))))))) ((14) (let ((e-14 (vector-ref arg-2 1))) (case (vector-ref e-14 0) ((25) (if (null? arg-3) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-273 (car arg-3))) (let ((e-274 (cdr arg-3))) (if (null? e-274) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-277 (car e-274))) (let ((e-278 (cdr e-274))) (if (null? e-278) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char>=?" e-273 e-277) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))))))))))) ((24) (if (null? arg-3) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-282 (car arg-3))) (let ((e-283 (cdr arg-3))) (if (null? e-283) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-286 (car e-283))) (let ((e-287 (cdr e-283))) (if (null? e-287) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string>=?" e-282 e-286) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))))))))))) ((26) (if (null? arg-3) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-291 (car arg-3))) (let ((e-292 (cdr arg-3))) (if (null? e-292) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-295 (car e-292))) (let ((e-296 (cdr e-292))) (if (null? e-296) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 ">=" e-291 e-295) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268)))))))))))))(else (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))))))) ((15) (let ((e-15 (vector-ref arg-2 1))) (case (vector-ref e-15 0) ((25) (if (null? arg-3) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-309 (car arg-3))) (let ((e-310 (cdr arg-3))) (if (null? e-310) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-313 (car e-310))) (let ((e-314 (cdr e-310))) (if (null? e-314) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char>?" e-309 e-313) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))))))))))) ((24) (if (null? arg-3) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-318 (car arg-3))) (let ((e-319 (cdr arg-3))) (if (null? e-319) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-322 (car e-319))) (let ((e-323 (cdr e-319))) (if (null? e-323) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string>?" e-318 e-322) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))))))))))) ((26) (if (null? arg-3) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-327 (car arg-3))) (let ((e-328 (cdr arg-3))) (if (null? e-328) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-331 (car e-328))) (let ((e-332 (cdr e-328))) (if (null? e-332) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 ">" e-327 e-331) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304)))))))))))))(else (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))))))) ((16) (let ((e-336 (car arg-3))) (let ((e-337 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-336 '()) (vector 8 -100 (cons (vector 17 (vector 11 "string-length") (cons e-336 '())) '())))))) ((17) (let ((e-341 (car arg-3))) (let ((e-342 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-341 '()) (vector 17 (vector 11 "string-ref") (cons e-341 (cons (vector 2 0) '()))))))) ((18) (let ((e-346 (car arg-3))) (let ((e-347 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-346 '()) (vector 17 (vector 11 "substring") (cons e-346 (cons (vector 2 1) (cons (vector 17 (vector 11 "string-length") (cons e-346 '())) '())))))))) ((19) (let ((e-351 (car arg-3))) (let ((e-352 (cdr arg-3))) (let ((e-355 (car e-352))) (let ((e-356 (cdr e-352))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-351 (cons e-355 '())) (CoreC-45SchemeEvalC-45Builtins-testPartial arg-1 (vector 17 (vector 11 "ct-string-ref") (cons e-351 (cons e-355 '())))))))))) ((20) (let ((e-360 (car arg-3))) (let ((e-361 (cdr arg-3))) (let ((e-364 (car e-361))) (let ((e-365 (cdr e-361))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-360 (cons e-364 '())) (vector 17 (vector 11 "ct-string-cons") (cons e-360 (cons e-364 '()))))))))) ((21) (let ((e-369 (car arg-3))) (let ((e-370 (cdr arg-3))) (let ((e-373 (car e-370))) (let ((e-374 (cdr e-370))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-369 (cons e-373 '())) (vector 17 (vector 11 "string-append") (cons e-369 (cons e-373 '()))))))))) ((22) (let ((e-378 (car arg-3))) (let ((e-379 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-378 '()) (vector 17 (vector 11 "ct-string-reverse") (cons e-378 '())))))) ((23) (let ((e-383 (car arg-3))) (let ((e-384 (cdr arg-3))) (let ((e-387 (car e-384))) (let ((e-388 (cdr e-384))) (let ((e-391 (car e-388))) (let ((e-392 (cdr e-388))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-383 (cons e-387 (cons e-391 '()))) (vector 17 (vector 11 "ct-string-substr") (cons e-383 '())))))))))) ((24) (let ((e-396 (car arg-3))) (let ((e-397 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flexp" e-396)))) ((25) (let ((e-401 (car arg-3))) (let ((e-402 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "fllog" e-401)))) ((26) (let ((e-406 (car arg-3))) (let ((e-407 (cdr arg-3))) (let ((e-410 (car e-407))) (let ((e-411 (cdr e-407))) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "expt" e-406 e-410)))))) ((27) (let ((e-415 (car arg-3))) (let ((e-416 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flsin" e-415)))) ((28) (let ((e-420 (car arg-3))) (let ((e-421 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flcos" e-420)))) ((29) (let ((e-425 (car arg-3))) (let ((e-426 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "fltan" e-425)))) ((30) (let ((e-430 (car arg-3))) (let ((e-431 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flasin" e-430)))) ((31) (let ((e-435 (car arg-3))) (let ((e-436 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flacos" e-435)))) ((32) (let ((e-440 (car arg-3))) (let ((e-441 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flatan" e-440)))) ((33) (let ((e-445 (car arg-3))) (let ((e-446 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flsqrt" e-445)))) ((34) (let ((e-450 (car arg-3))) (let ((e-451 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flfloor" e-450)))) ((35) (let ((e-455 (car arg-3))) (let ((e-456 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flceiling" e-455)))) ((36) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-460 (car arg-3))) (let ((e-461 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-applyCast arg-1 e-16 e-17 e-460)))))) ((37) (let ((e-466 (cdr arg-3))) (let ((e-470 (cdr e-466))) (let ((e-473 (car e-470))) (let ((e-474 (cdr e-470))) e-473))))) (else (let ((e-479 (cdr arg-3))) (let ((e-483 (cdr e-479))) arg-1))))))
(define CoreC-45SchemeEvalC-45Builtins-applyIntCast (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-8 (vector-ref arg-1 1))) (if (null? e-8) arg-2 (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (unbox e-2))) (let ((u--k (vector 0 (box e-4)))) (let ((sc5 (CoreC-45TT-u--C-62C-61_Ord_Precision (box e-4) e-0))) (cond ((equal? sc5 1) arg-2) (else ((CoreC-45SchemeEvalC-45Builtins-wrap u--k) (vector 17 (vector 11 "ct-cast-signed") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '()))))))))))) (else (let ((e-3 (vector-ref arg-1 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap arg-1) (vector 17 (vector 11 "ct-cast-unsigned") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))))) (else (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-7 (unbox e-5))) (let ((u--k (vector 0 (box e-7)))) (let ((sc5 (PreludeC-45EqOrd-u--C-62_Ord_Int e-7 e-1))) (cond ((equal? sc5 1) arg-2) (else ((CoreC-45SchemeEvalC-45Builtins-wrap u--k) (vector 17 (vector 11 "ct-cast-signed") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-7 1 63)) '()))))))))))) (else (let ((e-6 (vector-ref arg-1 1))) (let ((sc4 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-6 e-1))) (cond ((equal? sc4 1) arg-2) (else (vector 17 (vector 11 "ct-cast-unsigned") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-6) '())))))))))))))))(else (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (unbox e-2))) (let ((u--k (vector 0 (box e-4)))) (let ((sc3 (CoreC-45TT-u--C-62C-61_Ord_Precision (box e-4) e-0))) (cond ((equal? sc3 1) arg-2) (else ((CoreC-45SchemeEvalC-45Builtins-wrap u--k) (vector 17 (vector 11 "ct-cast-signed") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '()))))))))))) (else (let ((e-3 (vector-ref arg-1 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap arg-1) (vector 17 (vector 11 "ct-cast-unsigned") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))))) (else (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-7 (unbox e-5))) (let ((u--k (vector 0 (box e-7)))) (let ((sc3 (PreludeC-45EqOrd-u--C-62_Ord_Int e-7 e-1))) (cond ((equal? sc3 1) arg-2) (else ((CoreC-45SchemeEvalC-45Builtins-wrap u--k) (vector 17 (vector 11 "ct-cast-signed") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-7 1 63)) '()))))))))))) (else (let ((e-6 (vector-ref arg-1 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-6 e-1))) (cond ((equal? sc2 1) arg-2) (else (vector 17 (vector 11 "ct-cast-unsigned") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-6) '()))))))))))))))))
(define CoreC-45SchemeEvalC-45Builtins-applyCast (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-1 0) ((25) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (CoreC-45SchemeEvalC-45Builtins-case--applyCast-2552 arg-3 arg-2 arg-0 (CoreC-45TT-intKind arg-2))))(else (case (vector-ref arg-2 0) ((25) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (let ((sc1 (CoreC-45TT-intKind arg-1))) (if (null? sc1) arg-0 (vector 17 (vector 11 "ct-cast-int-char") (cons arg-3 '()))))))(else (case (vector-ref arg-1 0) ((24) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (CoreC-45SchemeEvalC-45Builtins-case--applyCast-2703 arg-3 arg-2 arg-0 (CoreC-45TT-intKind arg-2))))(else (case (vector-ref arg-2 0) ((24) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (let ((sc1 (CoreC-45TT-intKind arg-1))) (if (null? sc1) (case (vector-ref arg-1 0) ((26) (vector 17 (vector 11 "number->string") (cons arg-3 '())))(else arg-0)) (vector 17 (vector 11 "ct-cast-number-string") (cons arg-3 '()))))))(else (case (vector-ref arg-1 0) ((26) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (CoreC-45SchemeEvalC-45Builtins-case--applyCast-2876 arg-3 arg-2 arg-0 (CoreC-45TT-intKind arg-2))))(else (case (vector-ref arg-2 0) ((26) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (let ((sc1 (CoreC-45TT-intKind arg-1))) (if (null? sc1) (case (vector-ref arg-1 0) ((24) (vector 17 (vector 11 "ct-cast-string-double") (cons arg-3 '())))(else arg-0)) (vector 17 (vector 11 "ct-int-double") (cons arg-3 '()))))))(else (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (let ((sc0 (CoreC-45TT-intKind arg-1))) (if (null? sc0) arg-0 (let ((e-5 (unbox sc0))) (let ((sc1 (CoreC-45TT-intKind arg-2))) (if (null? sc1) arg-0 (let ((e-7 (unbox sc1))) (CoreC-45SchemeEvalC-45Builtins-applyIntCast e-5 e-7 arg-3))))))))))))))))))))))
(define CoreC-45SchemeEvalC-45Builtins-add (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct+") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct+") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-s+") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-u+") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct+") (cons arg-1 (cons arg-2 '())))))))))
(define IdrisC-45PackageC-45Types-case--showC-44upperBounds-1273 (lambda (arg-0 arg-1) (if (null? arg-1) "" (let ((e-2 (unbox arg-1))) (PreludeC-45TypesC-45String-C-43C-43 (let ((sc1 (let ((e-3 (vector-ref arg-0 3))) e-3))) (cond ((equal? sc1 1) "<= ") (else "< "))) (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion e-2))))))
(define IdrisC-45PackageC-45Types-case--showC-44lowerBounds-1234 (lambda (arg-0 arg-1) (if (null? arg-1) "" (let ((e-2 (unbox arg-1))) (PreludeC-45TypesC-45String-C-43C-43 (let ((sc1 (let ((e-1 (vector-ref arg-0 1))) e-1))) (cond ((equal? sc1 1) ">= ") (else "> "))) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion e-2) " "))))))
(define IdrisC-45PackageC-45Types-n--5752-3083-u--verField (lambda (arg-1 arg-2 ext-0) (IdrisC-45PackageC-45Types-n--5752-3082-u--field arg-1 arg-2 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (IdrisC-45PackageC-45Types-u--pretty_Pretty_PkgVersion eta-0)) ext-0))))
(define IdrisC-45PackageC-45Types-n--3846-1228-u--upperBounds (lambda (arg-0) (IdrisC-45PackageC-45Types-case--showC-44upperBounds-1273 arg-0 (let ((e-2 (vector-ref arg-0 2))) e-2))))
(define IdrisC-45PackageC-45Types-n--5752-3084-u--strField (lambda (arg-1 arg-2 ext-0) (IdrisC-45PackageC-45Types-n--5752-3082-u--field arg-1 arg-2 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (PreludeC-45Show-u--show_Show_String eta-0))) ext-0))))
(define IdrisC-45PackageC-45Types-n--5752-3085-u--seqField (lambda (arg-1 arg-3 arg-4 arg-5) (if (null? arg-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "--") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String arg-4) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) '())))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String arg-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (let ((e-1 (car arg-3))) ((e-1 'erased) eta-0))) arg-5)))))))))
(define IdrisC-45PackageC-45Types-n--3846-1226-u--noBounds (lambda (arg-0) (let ((sc0 (DataC-45Maybe-isNothing (let ((e-0 (vector-ref arg-0 0))) e-0)))) (cond ((equal? sc0 1) (DataC-45Maybe-isNothing (let ((e-2 (vector-ref arg-0 2))) e-2))) (else 0)))))
(define IdrisC-45PackageC-45Types-n--3846-1227-u--lowerBounds (lambda (arg-0) (IdrisC-45PackageC-45Types-case--showC-44lowerBounds-1234 arg-0 (let ((e-0 (vector-ref arg-0 0))) e-0))))
(define IdrisC-45PackageC-45Types-n--5752-3082-u--field (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "--") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String arg-2) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) '())))) (let ((e-2 (unbox arg-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String arg-2) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals) (cons e-2 '()))))))))
(define IdrisC-45PackageC-45Types-n--5752-3081-u--comment (lambda (arg-1 arg-2) (let ((u--ws (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "--") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-words arg-2)))) (let ((u--commSoftLine (vector 7 (lambda () (vector 1 #\ )) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hcat (cons (vector 3 ) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String "-- ") '()))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x u--commSoftLine) u--y))) u--ws))))))
(define IdrisC-45PackageC-45Types-u--show_Show_PkgVersionBounds (lambda (arg-0) (let ((sc0 (IdrisC-45PackageC-45Types-n--3846-1226-u--noBounds arg-0))) (cond ((equal? sc0 1) "any") (else (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45PackageC-45Types-n--3846-1227-u--lowerBounds arg-0) (IdrisC-45PackageC-45Types-n--3846-1228-u--upperBounds arg-0)))))))
(define IdrisC-45PackageC-45Types-u--show_Show_PkgVersion (lambda (arg-0) (CoreC-45NameC-45Namespace-showSep "." (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_Nat eta-0)) (DataC-45List1-forget arg-0)))))
(define IdrisC-45PackageC-45Types-u--show_Show_Depends (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (car arg-0))) e-0) (PreludeC-45TypesC-45String-C-43C-43 " " (IdrisC-45PackageC-45Types-u--show_Show_PkgVersionBounds (let ((e-1 (cdr arg-0))) e-1))))))
(define IdrisC-45PackageC-45Types-u--pretty_Pretty_PkgVersion (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion ext-0))))
(define IdrisC-45PackageC-45Types-u--pretty_Pretty_PkgDesc (lambda (arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "package") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (let ((e-0 (vector-ref arg-1 0))) e-0))) (cons (IdrisC-45PackageC-45Types-n--5752-3083-u--verField arg-1 "version" (let ((e-1 (vector-ref arg-1 1))) e-1)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "authors" (let ((e-2 (vector-ref arg-1 2))) e-2)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "maintainers" (let ((e-3 (vector-ref arg-1 3))) e-3)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "license" (let ((e-4 (vector-ref arg-1 4))) e-4)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "brief" (let ((e-5 (vector-ref arg-1 5))) e-5)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "readme" (let ((e-6 (vector-ref arg-1 6))) e-6)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "homepage" (let ((e-7 (vector-ref arg-1 7))) e-7)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "sourceloc" (let ((e-8 (vector-ref arg-1 8))) e-8)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "bugtracker" (let ((e-9 (vector-ref arg-1 9))) e-9)) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "packages to add to search path") (cons (IdrisC-45PackageC-45Types-n--5752-3085-u--seqField arg-1 (cons (lambda (u--ann) (lambda (arg-5185) (IdrisC-45PackageC-45Types-u--pretty_Pretty_Depends arg-5185))) (lambda (u--ann) (lambda (arg-5186) (lambda (arg-5187) (IdrisC-45PackageC-45Types-u--prettyPrec_Pretty_Depends arg-5186 arg-5187))))) "depends" (let ((e-10 (vector-ref arg-1 10))) e-10)) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "modules to install") (cons (IdrisC-45PackageC-45Types-n--5752-3085-u--seqField arg-1 (cons (lambda (u--ann) (lambda (arg-5185) (CoreC-45NameC-45Namespace-u--pretty_Pretty_ModuleIdent arg-5185))) (lambda (u--ann) (lambda (arg-5186) (lambda (arg-5187) (CoreC-45NameC-45Namespace-u--prettyPrec_Pretty_ModuleIdent arg-5186 arg-5187))))) "modules" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (Builtin-fst eta-0)) (let ((e-11 (vector-ref arg-1 11))) e-11))) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "main file (i.e. file to load at REPL)") (cons (IdrisC-45PackageC-45Types-n--5752-3082-u--field arg-1 "main" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45NameC-45Namespace-u--pretty_Pretty_ModuleIdent (Builtin-fst eta-0))) (let ((e-12 (vector-ref arg-1 12))) e-12))) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "name of executable") (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "executable" (let ((e-13 (vector-ref arg-1 13))) e-13)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "opts" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-14 (vector-ref arg-1 14))) e-14))) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "sourcedir" (let ((e-15 (vector-ref arg-1 15))) e-15)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "builddir" (let ((e-16 (vector-ref arg-1 16))) e-16)) (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "outputdir" (let ((e-17 (vector-ref arg-1 17))) e-17)) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "script to run before building") (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "prebuild" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-18 (vector-ref arg-1 18))) e-18))) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "script to run after building") (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "postbuild" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-19 (vector-ref arg-1 19))) e-19))) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "script to run after building, before installing") (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "preinstall" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-20 (vector-ref arg-1 20))) e-20))) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "script to run after installing") (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "postinstall" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-21 (vector-ref arg-1 21))) e-21))) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "script to run before cleaning") (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "preclean" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-22 (vector-ref arg-1 22))) e-22))) (cons (IdrisC-45PackageC-45Types-n--5752-3081-u--comment arg-1 "script to run after cleaning") (cons (IdrisC-45PackageC-45Types-n--5752-3084-u--strField arg-1 "postclean" (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-23 (vector-ref arg-1 23))) e-23))) '())))))))))))))))))))))))))))))))))))))
(define IdrisC-45PackageC-45Types-u--pretty_Pretty_Depends (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45PackageC-45Types-u--show_Show_Depends ext-0))))
(define IdrisC-45PackageC-45Types-u--prettyPrec_Pretty_PkgVersion (lambda (arg-1 arg-2) (IdrisC-45PackageC-45Types-u--pretty_Pretty_PkgVersion arg-2)))
(define IdrisC-45PackageC-45Types-u--prettyPrec_Pretty_Depends (lambda (arg-1 arg-2) (IdrisC-45PackageC-45Types-u--pretty_Pretty_Depends arg-2)))
(define IdrisC-45PackageC-45Types-u--min_Ord_PkgVersion (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define IdrisC-45PackageC-45Types-u--max_Ord_PkgVersion (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion (lambda (arg-0 arg-1) (DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 (csegen-2672) arg-0 arg-1)))
(define IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-0 arg-1) 2)))
(define IdrisC-45PackageC-45Types-u--C-62C-61_Ord_PkgVersion (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-0 arg-1) 0)))
(define IdrisC-45PackageC-45Types-u--C-61C-61_Eq_PkgVersion (lambda (arg-0 arg-1) (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 (csegen-792) arg-0 arg-1)))
(define IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-0 arg-1) 0)))
(define IdrisC-45PackageC-45Types-u--C-60C-61_Ord_PkgVersion (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-0 arg-1) 2)))
(define IdrisC-45PackageC-45Types-u--C-47C-61_Eq_PkgVersion (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45PackageC-45Types-u--C-61C-61_Eq_PkgVersion arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define IdrisC-45PackageC-45Types-initPkgDesc (lambda (arg-0) (vector arg-0 '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '())))
(define IdrisC-45PackageC-45Types-inBounds (lambda (arg-0 arg-1) (let ((u--v (DataC-45Maybe-fromMaybe (lambda () (cons 0 '())) arg-0))) (let ((sc0 (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (u--vC-39) (let ((sc1 (let ((e-1 (vector-ref arg-1 1))) e-1))) (cond ((equal? sc1 1) (IdrisC-45PackageC-45Types-u--C-62C-61_Ord_PkgVersion u--v u--vC-39)) (else (IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion u--v u--vC-39)))))) (let ((e-0 (vector-ref arg-1 0))) e-0)))) (cond ((equal? sc0 1) (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (u--vC-39) (let ((sc1 (let ((e-3 (vector-ref arg-1 3))) e-3))) (cond ((equal? sc1 1) (IdrisC-45PackageC-45Types-u--C-60C-61_Ord_PkgVersion u--v u--vC-39)) (else (IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion u--v u--vC-39)))))) (let ((e-2 (vector-ref arg-1 2))) e-2))) (else 0))))))
(define IdrisC-45PackageC-45Types-cssFiles(blodwen-lazy (lambda () (cons (cons "Default" "default") (cons (cons "Alternative" "alternative") (cons (cons "Black & White" "blackandwhite") '()))))))
(define IdrisC-45PackageC-45Types-anyBounds(blodwen-lazy (lambda () (vector '() 1 '() 1))))
(define IdrisC-45CommandLine-case--ideSocketModeAddress-970 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--port (DataC-45Maybe-fromMaybe (lambda () (blodwen-toSignedInt 38398 63)) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45CommandLine-n--3632-930-u--portPart arg-0 arg-1 e-3) (lambda (eta-0) (DataC-45String-parsePositive (csegen-190) eta-0)))))) (let ((u--host (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 ""))) (cond ((equal? sc1 1) "localhost") (else e-2))))) (cons u--host u--port)))))))
(define IdrisC-45CommandLine-n--5456-2764-u--showSep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) "" (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? e-3) e-2 (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 arg-4 (IdrisC-45CommandLine-n--5456-2764-u--showSep arg-0 arg-1 arg-2 arg-3 arg-4 e-3)))))))))
(define IdrisC-45CommandLine-n--3632-930-u--portPart (lambda (arg-0 arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-2 ""))) (cond ((equal? sc0 1) '()) (else (box (substring arg-2 1 (string-length arg-2))))))))
(define IdrisC-45CommandLine-n--5559-2854-u--optUsage (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (u--h) (PreludeC-45TypesC-45String-C-43C-43 "  " (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-fastPack (DataC-45List-replicate (PreludeC-45Types-prim__integerToNat (- (PreludeC-45Types-u--C-43_Num_Nat arg-1 (+ 1 (+ 1 0))) (PreludeC-45TypesC-45String-length e-2))) #\ )) (PreludeC-45TypesC-45String-C-43C-43 u--h "\xa;")))))) e-3)))))
(define IdrisC-45CommandLine-u--show_Show_OptType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "<" (PreludeC-45TypesC-45String-C-43C-43 e-0 ">")))) ((2) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "<" (PreludeC-45TypesC-45String-C-43C-43 e-1 ">")))) ((4) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "<" (PreludeC-45TypesC-45String-C-43C-43 e-2 ">")))) ((1) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "[" (PreludeC-45TypesC-45String-C-43C-43 e-3 "]")))) (else (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "<" (PreludeC-45TypesC-45String-C-43C-43 e-4 ">")))))))
(define IdrisC-45CommandLine-versionMsg(blodwen-lazy (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Idris 2, version " (LibrariesC-45DataC-45Version-u--show_Show_Version (IdrisC-45Version-version))))))
(define IdrisC-45CommandLine-usage(blodwen-lazy (lambda () (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45CommandLine-versionMsg) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "Usage: idris2 [options] [input file]\xa;\xa;" (PreludeC-45TypesC-45String-C-43C-43 "Available options:\xa;" (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45CommandLine-optsUsage) (PreludeC-45TypesC-45String-C-43C-43 "\xa;" (PreludeC-45TypesC-45String-C-43C-43 "Environment variables:\xa;" (IdrisC-45CommandLine-envsUsage)))))))))))
(define IdrisC-45CommandLine-showDefault (lambda (arg-1 arg-2) (PreludeC-45TypesC-45String-C-43C-43 "(default " (PreludeC-45TypesC-45String-C-43C-43 (let ((e-1 (car arg-1))) (e-1 arg-2)) ")"))))
(define IdrisC-45CommandLine-recogniseHelpTopic (lambda (arg-0) (cond ((equal? arg-0 "logging") (PreludeC-45Types-u--pure_Applicative_Maybe 0)) ((equal? arg-0 "pragma") (PreludeC-45Types-u--pure_Applicative_Maybe 1))(else '()))))
(define IdrisC-45CommandLine-processArgs (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-1) (vector 1 (cons arg-3 arg-2)) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((0) (if (null? arg-2) (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "Missing required argument " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45CommandLine-u--show_Show_OptType e-2) (PreludeC-45TypesC-45String-C-43C-43 " for flag " arg-0)))) (let ((e-11 (car arg-2))) (let ((e-12 (cdr arg-2))) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-12 (arg-3 e-11)))))) ((2) (if (null? arg-2) (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "Missing required argument " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45CommandLine-u--show_Show_OptType e-2) (PreludeC-45TypesC-45String-C-43C-43 " for flag " arg-0)))) (let ((e-15 (car arg-2))) (let ((e-16 (cdr arg-2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (DataC-45Either-maybeToEither (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Expected Nat argument " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-15) (PreludeC-45TypesC-45String-C-43C-43 " for flag " arg-0)))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45String-parseInteger (csegen-3992) e-15) (lambda (eta-0) (IdrisC-45CommandLine-checkNat eta-0)))) (lambda (u--arg) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-16 (arg-3 u--arg)))))))) ((4) (if (null? arg-2) (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "Missing required argument " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45CommandLine-u--show_Show_OptType e-2) (PreludeC-45TypesC-45String-C-43C-43 " for flag " arg-0)))) (let ((e-19 (car arg-2))) (let ((e-20 (cdr arg-2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (DataC-45Either-maybeToEither (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Expected LogLevel argument " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-19) (PreludeC-45TypesC-45String-C-43C-43 " for flag " arg-0)))) (CoreC-45OptionsC-45Log-parseLogLevel e-19)) (lambda (u--arg) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-20 (arg-3 u--arg)))))))) ((1) (if (null? arg-2) (IdrisC-45CommandLine-processArgs arg-0 e-3 '() (arg-3 '())) (let ((e-23 (car arg-2))) (let ((e-24 (cdr arg-2))) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-24 (arg-3 (DataC-45Maybe-toMaybe (let ((sc3 (DataC-45String-isPrefixOf "-" e-23))) (cond ((equal? sc3 1) 0) (else 1))) (lambda () e-23)))))))) (else (if (null? arg-2) (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "Missing required argument " (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45CommandLine-u--show_Show_OptType e-2) (PreludeC-45TypesC-45String-C-43C-43 " for flag " arg-0)))) (let ((e-27 (car arg-2))) (let ((e-28 (cdr arg-2))) (cond ((equal? e-27 "auto") (IdrisC-45CommandLine-processArgs arg-0 e-3 e-28 (arg-3 '())))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (DataC-45Either-maybeToEither (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Expected Nat or \"auto\" argument " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String e-27) (PreludeC-45TypesC-45String-C-43C-43 " for flag " arg-0)))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45String-parseInteger (csegen-3992) e-27) (lambda (eta-0) (IdrisC-45CommandLine-checkNat eta-0)))) (lambda (u--arg) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-28 (arg-3 (box u--arg)))))))))))))))))
(define IdrisC-45CommandLine-parseOpts (lambda (arg-0 arg-1) (if (null? arg-1) (vector 1 '()) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (IdrisC-45CommandLine-findMatch arg-0 arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (IdrisC-45CommandLine-parseOpts arg-0 e-3) (lambda (u--cls) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-2 u--cls)))))))))))
(define IdrisC-45CommandLine-optsUsage(blodwen-lazy (lambda () (IdrisC-45CommandLine-makeTextFromOptionsOrEnvs (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45CommandLine-optShow eta-0)) (IdrisC-45CommandLine-options))))))
(define IdrisC-45CommandLine-options(blodwen-lazy (lambda () (cons (vector (cons "--check" (cons "-c" '())) '() (cons (vector 0 ) '()) (box "Exit after checking source file")) (cons (vector (cons "--output" (cons "-o" '())) (cons (vector 0 "file") '()) (lambda (u--f) (cons (vector 1 u--f) (cons (vector 13 ) '()))) (box "Specify output file")) (cons (vector (cons "--exec" (cons "-x" '())) (cons (vector 0 "name") '()) (lambda (u--f) (cons (vector 2 u--f) (cons (vector 13 ) '()))) (box "Execute function after checking source file")) (cons (vector (cons "--no-prelude" '()) '() (cons (vector 5 ) '()) (box "Don't implicitly import Prelude")) (cons (vector (cons "--codegen" (cons "--cg" '())) (cons (vector 0 "backend") '()) (lambda (u--f) (cons (vector 3 u--f) '())) (box (PreludeC-45TypesC-45String-C-43C-43 "Set code generator " (IdrisC-45CommandLine-showDefault (cons (lambda (u--x) (CoreC-45Options-u--show_Show_CG u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Options-u--showPrec_Show_CG u--d u--x)))) (let ((sc0 (CoreC-45Options-defaultSession))) (let ((e-4 (vector-ref sc0 4))) e-4)))))) (cons (vector (cons "--incremental-cg" (cons "--inc" '())) (cons (vector 0 "backend") '()) (lambda (u--f) (cons (vector 41 u--f) '())) (box "Incremental code generation on given backend")) (cons (vector (cons "--whole-program" (cons "--wp" '())) '() (cons (vector 42 ) '()) (box "Use whole program compilation (overrides --inc)")) (cons (vector (cons "--directive" '()) (cons (vector 0 "directive") '()) (lambda (u--d) (cons (vector 4 u--d) '())) (box "Pass a directive to the current code generator")) (cons (vector (cons "--package" (cons "-p" '())) (cons (vector 0 "package") '()) (lambda (u--f) (cons (vector 18 u--f) '())) (box "Add a package as a dependency")) (cons (vector (cons "--source-dir" '()) (cons (vector 0 "dir") '()) (lambda (u--d) (cons (vector 6 u--d) '())) (box "Set source directory")) (cons (vector (cons "--build-dir" '()) (cons (vector 0 "dir") '()) (lambda (u--d) (cons (vector 7 u--d) '())) (box "Set build directory")) (cons (vector (cons "--output-dir" '()) (cons (vector 0 "dir") '()) (lambda (u--d) (cons (vector 8 u--d) '())) (box "Set output directory")) (cons (vector (cons "--profile" '()) '() (cons (vector 9 ) '()) (box "Generate profile data when compiling, if supported")) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "--total" '()) '() (cons (vector 45 ) '()) (box "Require functions to be total by default")) (cons (vector (cons "-Werror" '()) '() (cons (vector 37 ) '()) (box "Treat warnings as errors")) (cons (vector (cons "-Wno-shadowing" '()) '() (cons (vector 38 ) '()) (box "Do not print shadowing warnings")) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "-Xcheck-hashes" '()) '() (cons (vector 39 ) '()) (box "Use SHA256 hashes instead of modification time to determine if a source file needs rebuilding")) (cons (vector (cons "-Xcase-tree-opt" '()) '() (cons (vector 40 ) '()) (box "Apply experimental optimizations to case tree generation")) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "--prefix" '()) '() (cons (vector 21 1) '()) (box "Show installation prefix")) (cons (vector (cons "--paths" '()) '() (cons (vector 21 2) '()) (box "Show paths")) (cons (vector (cons "--libdir" '()) '() (cons (vector 21 0) '()) (box "Show library directory")) (cons (vector (cons "--list-packages" '()) '() (cons (vector 19 ) '()) (box "List installed packages")) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "--init" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 20 7 u--f) '())) (box "Interactively initialise a new project")) (cons (vector (cons "--build" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 20 0 u--f) '())) (box "Build modules/executable for the given package")) (cons (vector (cons "--install" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 20 1 u--f) '())) (box "Install the given package")) (cons (vector (cons "--install-with-src" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 20 2 u--f) '())) (box "Install the given package")) (cons (vector (cons "--mkdoc" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 20 3 u--f) '())) (box "Build documentation for the given package")) (cons (vector (cons "--typecheck" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 20 4 u--f) '())) (box "Typechecks the given package without code generation")) (cons (vector (cons "--clean" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 20 5 u--f) '())) (box "Clean intermediate files/executables for the given package")) (cons (vector (cons "--repl" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 20 6 u--f) '())) (box "Build the given package and launch a REPL instance.")) (cons (vector (cons "--find-ipkg" '()) '() (cons (vector 33 ) '()) (box "Find and use an .ipkg file in a parent directory.")) (cons (vector (cons "--ignore-missing-ipkg" '()) '() (cons (vector 32 ) '()) (box "Fail silently if a dependency is missing.")) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "--ide-mode" '()) '() (cons (vector 23 ) '()) (box "Run the REPL with machine-readable syntax")) (cons (vector (cons "--ide-mode-socket" '()) (cons (vector 1 "host:port") '()) (lambda (u--hp) (cons (vector 24 (DataC-45Maybe-fromMaybe (lambda () (IdrisC-45CommandLine-formatSocketAddress (IdrisC-45CommandLine-ideSocketModeAddress '()))) u--hp)) '())) (box (PreludeC-45TypesC-45String-C-43C-43 "Run the ide socket mode on given host and port " (IdrisC-45CommandLine-showDefault (csegen-576) (IdrisC-45CommandLine-formatSocketAddress (IdrisC-45CommandLine-ideSocketModeAddress '())))))) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "--client" '()) (cons (vector 0 "REPL command") '()) (lambda (u--f) (cons (vector 31 u--f) '())) (box "Run a REPL command then quit immediately")) (cons (vector (cons "--timing" '()) '() (cons (vector 34 ) '()) (box "Display timing logs")) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "--no-banner" '()) '() (cons (vector 12 ) '()) (box "Suppress the banner")) (cons (vector (cons "--quiet" (cons "-q" '())) '() (cons (vector 13 ) '()) (box "Quiet mode; display fewer messages")) (cons (vector (cons "--console-width" '()) (cons (vector 3 "console width") '()) (lambda (u--l) (cons (vector 15 u--l) '())) (box "Width for console output (0 for unbounded) (auto by default)")) (cons (vector (cons "--color" (cons "--colour" '())) '() (cons (vector 16 1) '()) (box "Forces colored console output (enabled by default)")) (cons (vector (cons "--no-color" (cons "--no-colour" '())) '() (cons (vector 16 0) '()) (box "Disables colored console output")) (cons (vector (cons "--verbose" '()) '() (cons (vector 14 ) '()) (box "Verbose mode (default)")) (cons (vector (cons "--log" '()) (cons (vector 4 "log level") '()) (lambda (u--l) (cons (vector 17 u--l) '())) (box "Global log level (0 by default)")) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "--version" (cons "-v" '())) '() (cons (vector 10 ) '()) (box "Display version string")) (cons (vector (cons "--help" (cons "-h" (cons "-?" '()))) (cons (vector 1 "topic") '()) (lambda (u--tp) (cons (vector 11 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe u--tp (lambda (eta-0) (IdrisC-45CommandLine-recogniseHelpTopic eta-0)))) '())) (box "Display help text")) (cons (vector (cons "--yaffle" (cons "--ttimp" '())) (cons (vector 0 "ttimp file") '()) (lambda (u--f) (cons (vector 25 u--f) '())) '()) (cons (vector (cons "--ttm" '()) (cons (vector 0 "ttimp file") '()) (lambda (u--f) (cons (vector 26 u--f) '())) '()) (cons (vector (cons "--dumpcases" '()) (cons (vector 0 "output file") '()) (lambda (u--f) (cons (vector 27 u--f) '())) '()) (cons (vector (cons "--dumplifted" '()) (cons (vector 0 "output file") '()) (lambda (u--f) (cons (vector 28 u--f) '())) '()) (cons (vector (cons "--dumpanf" '()) (cons (vector 0 "output file") '()) (lambda (u--f) (cons (vector 29 u--f) '())) '()) (cons (vector (cons "--dumpvmcode" '()) (cons (vector 0 "output file") '()) (lambda (u--f) (cons (vector 30 u--f) '())) '()) (cons (vector (cons "--debug-elab-check" '()) '() (cons (vector 35 ) '()) '()) (cons (vector (cons "--alt-error-count" '()) (cons (vector 2 "alternative count") '()) (lambda (u--c) (cons (vector 36 u--c) '())) (box "Outputs errors for the given number of alternative parsing attempts.")) (cons (IdrisC-45CommandLine-optSeparator) (cons (vector (cons "--bash-completion" '()) (cons (vector 0 "input") (cons (vector 0 "previous input") '())) (lambda (u--w1) (lambda (u--w2) (cons (vector 43 u--w1 u--w2) '()))) (box "Print bash autocompletion information")) (cons (vector (cons "--bash-completion-script" '()) (cons (vector 0 "function name") '()) (lambda (u--n) (cons (vector 44 u--n) '())) (box "Generate a bash script to activate autocompletion for Idris2")) '())))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45CommandLine-optionFlags(blodwen-lazy (lambda () (PreludeC-45Types-u--C-62C-62C-61_Monad_List (IdrisC-45CommandLine-options) (lambda (eta-0) (let ((e-0 (vector-ref eta-0 0))) e-0))))))
(define IdrisC-45CommandLine-optShow (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (if (null? e-0) (cons "" (box "")) (cons (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45CommandLine-n--5456-2764-u--showSep e-3 e-1 e-2 e-0 ", " e-0) (PreludeC-45TypesC-45String-C-43C-43 " " (IdrisC-45CommandLine-n--5456-2764-u--showSep e-3 e-1 e-2 e-0 " " (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45CommandLine-u--show_Show_OptType eta-0)) e-1)))) e-3))))))))
(define IdrisC-45CommandLine-optSeparator(blodwen-lazy (lambda () (vector '() '() '() '()))))
(define IdrisC-45CommandLine-matchFlag (lambda (arg-0 arg-1) (if (null? arg-1) (vector 1 '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (PreludeC-45Types-elem (csegen-17) e-2 (let ((e-0 (vector-ref arg-0 0))) e-0)))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (IdrisC-45CommandLine-processArgs e-2 (let ((e-1 (vector-ref arg-0 1))) e-1) e-3 (let ((e-5 (vector-ref arg-0 2))) e-5)) (lambda (u--args) (vector 1 (box u--args))))) (else (vector 1 '())))))))))
(define IdrisC-45CommandLine-makeTextFromOptionsOrEnvs (lambda (arg-0) (PreludeC-45Interfaces-concatMap (csegen-67) (lambda (eta-0) (IdrisC-45CommandLine-n--5559-2854-u--optUsage arg-0 (IdrisC-45CommandLine-firstColumnWidth) eta-0)) arg-0)))
(define IdrisC-45CommandLine-ideSocketModeAddress (lambda (arg-0) (if (null? arg-0) (cons "localhost" (blodwen-toSignedInt 38398 63)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((24) (let ((e-4 (vector-ref e-2 1))) (IdrisC-45CommandLine-case--ideSocketModeAddress-970 e-3 e-4 (DataC-45String-break (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\:)) e-4))))(else (IdrisC-45CommandLine-ideSocketModeAddress e-3))))))))
(define IdrisC-45CommandLine-getOpts (lambda (arg-0) (IdrisC-45CommandLine-parseOpts (IdrisC-45CommandLine-options) arg-0)))
(define IdrisC-45CommandLine-getCmdOpts (lambda (ext-0) (let ((act-24 ((System-getArgs (csegen-3)) ext-0))) (if (null? act-24) (vector 0 "Invalid command line") (let ((e-2 (cdr act-24))) (IdrisC-45CommandLine-getOpts e-2))))))
(define IdrisC-45CommandLine-formatSocketAddress (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (PreludeC-45TypesC-45String-C-43C-43 e-2 (PreludeC-45TypesC-45String-C-43C-43 ":" (PreludeC-45Show-u--show_Show_Int e-3)))))))
(define IdrisC-45CommandLine-firstColumnWidth(blodwen-lazy (lambda () (let ((u--maxOpt (PreludeC-45Types-u--foldr_Foldable_List (csegen-4174) (PreludeC-45Types-u--fromInteger_Num_Nat 0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45TypesC-45String-length (Builtin-fst (IdrisC-45CommandLine-optShow eta-0)))) (IdrisC-45CommandLine-options))))) (let ((u--maxEnv (PreludeC-45Types-u--foldr_Foldable_List (csegen-4174) (PreludeC-45Types-u--fromInteger_Num_Nat 0) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45TypesC-45String-length (let ((e-0 (car eta-0))) e-0))) (IdrisC-45Env-envs))))) (PreludeC-45Types-u--max_Ord_Nat u--maxOpt u--maxEnv))))))
(define IdrisC-45CommandLine-findMatch (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (vector 1 (cons '() '())) (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (vector 1 (cons (cons (vector 22 e-6) '()) e-7))))) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (IdrisC-45CommandLine-matchFlag e-2 arg-1) (lambda (bind-0) (if (null? bind-0) (IdrisC-45CommandLine-findMatch e-3 arg-1) (let ((e-4 (unbox bind-0))) (vector 1 e-4))))))))))
(define IdrisC-45CommandLine-envsUsage(blodwen-lazy (lambda () (IdrisC-45CommandLine-makeTextFromOptionsOrEnvs (PreludeC-45Types-u--map_Functor_List (lambda (u--e) (cons (let ((e-0 (car u--e))) e-0) (box (let ((e-1 (cdr u--e))) e-1)))) (IdrisC-45Env-envs))))))
(define IdrisC-45CommandLine-checkNat (lambda (arg-0) (DataC-45Maybe-toMaybe (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-0 0) (lambda () (PreludeC-45Types-prim__integerToNat arg-0)))))
(define IdrisC-45Package-with--partitionOptsC-44pOptUpdate-9789 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (let ((e-2 (vector-ref arg-2 3))) (let ((e-5 (vector-ref ext-0 0))) (let ((e-4 (vector-ref ext-0 1))) (let ((e-3 (vector-ref ext-0 2))) (vector (cons (cons e-1 e-2) e-5) e-4 e-3))))))) ((1) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (vector e-0 (cons arg-1 e-1) e-2))))) ((2) ext-0) (else (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (vector e-0 e-1 1)))))))
(define IdrisC-45Package-case--caseC-32blockC-32inC-32processPackage-8862 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Tried to split empty string") eta-0)) (let ((e-1 (unbox arg-7))) (lambda (clam-0) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 "Tried to split empty string") clam-0) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (let ((sc2 (DataC-45String-isSuffixOf ".ipkg" e-5))) (cond ((equal? sc2 1) (let ((act-24 (CoreC-45Context-setWorkingDir arg-5 e-4 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (let ((act-25 (ParserC-45Package-parseFile e-5 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (IdrisC-45Package-parsePkgDesc e-5)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Package-eoi)))) clam-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-25 1))) (case (vector-ref e-7 0) ((1) (let ((e-2 (vector-ref e-7 1))) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (let ((act-26 (IdrisC-45Package-addFields arg-5 arg-4 arg-3 e-9 (IdrisC-45PackageC-45Types-initPkgDesc e-8) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-26 1))) (let ((act-27 (let ((e-16 (vector-ref e-10 16))) (if (null? e-16) (vector 1 0) (let ((e-33 (unbox e-16))) (CoreC-45Context-setBuildDir arg-5 e-33 clam-0)))))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((act-28 (CoreC-45Context-setOutputDir arg-5 (let ((e-17 (vector-ref e-10 17))) e-17) clam-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (cond ((equal? arg-0 0) (let ((act-29 (IdrisC-45Package-build arg-5 arg-4 arg-3 e-10 arg-2 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-29 1))) (if (null? e-13) (vector 1 0) (let ((act-30 ((csegen-1214) clam-0))) (vector 1 act-30)))))))) ((equal? arg-0 3) (let ((act-29 (IdrisC-45Package-makeDoc arg-5 arg-4 arg-3 e-10 arg-2 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-29 1))) (if (null? e-13) (vector 1 0) (let ((act-30 ((csegen-1214) clam-0))) (vector 1 act-30)))))))) ((equal? arg-0 1) (let ((act-29 (IdrisC-45Package-build arg-5 arg-4 arg-3 e-10 arg-2 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-29 1))) (if (null? e-13) (IdrisC-45Package-install arg-5 arg-3 e-10 arg-2 0 clam-0) (let ((act-30 ((csegen-1214) clam-0))) (vector 1 act-30)))))))) ((equal? arg-0 2) (let ((act-29 (IdrisC-45Package-build arg-5 arg-4 arg-3 e-10 arg-2 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-29 1))) (if (null? e-13) (IdrisC-45Package-install arg-5 arg-3 e-10 arg-2 1 clam-0) (let ((act-30 ((csegen-1214) clam-0))) (vector 1 act-30)))))))) ((equal? arg-0 4) (let ((act-29 (IdrisC-45Package-check arg-5 arg-4 arg-3 e-10 arg-2 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-29 1))) (if (null? e-13) (vector 1 0) (let ((act-30 ((csegen-1214) clam-0))) (vector 1 act-30)))))))) ((equal? arg-0 5) (IdrisC-45Package-clean arg-5 arg-3 e-10 arg-2 clam-0)) ((equal? arg-0 6) (let ((act-29 (IdrisC-45Package-build arg-5 arg-4 arg-3 e-10 arg-2 clam-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-29 1))) (if (null? e-13) (IdrisC-45Package-runRepl arg-5 arg-4 arg-3 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-25 (vector-ref e-10 12))) e-25)) clam-0) (let ((act-30 ((csegen-1214) clam-0))) (vector 1 act-30)))))))) (else (vector 1 0))))))))))))))))) (else (let ((e-8 (vector-ref e-7 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-8 clam-0))))))))))))(else (let ((act-24 (let ((act-24 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Packages must have an '.ipkg' extension: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_String arg-6) "."))) clam-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((csegen-1214) clam-0))) (vector 1 act-25))))))))))))))))
(define IdrisC-45Package-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeDoc-7809 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (if (null? arg-15) (let ((act-24 ((IdrisC-45Package-runScript (let ((e-19 (vector-ref arg-1 19))) e-19)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 '())))) (vector 1 arg-15))))
(define IdrisC-45Package-case--installSrcFrom-6287 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Unexpected failure when installing source file:\xa;" (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 "\xa;" "Can't extract file extension.")))) eta-0)) (let ((e-1 (unbox arg-7))) (let ((u--modPath (PreludeC-45TypesC-45List-reverse (DataC-45Maybe-fromMaybe (lambda () '()) (DataC-45List-tailC-39 (CoreC-45NameC-45Namespace-unsafeUnfoldModuleIdent arg-0)))))) (let ((u--destNest (LibrariesC-45UtilsC-45Path-joinPath u--modPath))) (let ((u--destPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 u--destNest))) (let ((u--destFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 e-1)))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Directory-mkdirAll u--destNest eta-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((act-25 (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Installing " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 " to " u--destPath)))) eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((act-26 (let ((act-26 (let ((act-26 (CompilerC-45Common-exists u--destFile eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-26 1))) (cond ((equal? e-7 1) (let ((act-27 (let ((act-27 ((SystemC-45FileC-45Permissions-chmod (csegen-3) u--destFile (vector (csegen-4186) (csegen-4186) (csegen-4186))) eta-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((1) (vector 1 0)) (else (let ((e-9 (vector-ref e-8 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 58 (SystemC-45FileC-45Error-u--show_Show_FileError e-9)) eta-0))))))))) (else (vector 1 0))))))))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (let ((act-27 ((LibrariesC-45SystemC-45DirectoryC-45Tree-copyFile (csegen-3) arg-6 u--destFile) eta-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((1) (let ((act-28 (let ((act-28 ((SystemC-45FileC-45Permissions-chmod (csegen-3) u--destFile (vector (cons 0 '()) (cons 0 '()) (cons 0 '()))) eta-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-28 1))) (case (vector-ref e-9 0) ((1) (vector 1 0)) (else (let ((e-10 (vector-ref e-9 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 58 (SystemC-45FileC-45Error-u--show_Show_FileError e-10)) eta-0))))))))) (else (let ((e-9 (vector-ref e-8 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (LibrariesC-45DataC-45StringC-45Extra-unlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Can't copy file " (PreludeC-45TypesC-45String-C-43C-43 arg-6 (PreludeC-45TypesC-45String-C-43C-43 " to " u--destPath))) (cons (SystemC-45FileC-45Error-u--show_Show_FileError e-9) '())))) eta-0))))))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (LibrariesC-45DataC-45StringC-45Extra-unlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Can't make directories " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) u--modPath)) (cons (SystemC-45FileC-45Error-u--show_Show_FileError e-6) '())))) eta-0)))))))))))))))))
(define IdrisC-45Package-case--caseC-32blockC-32inC-32installFrom-5823 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox arg-11))) (let ((u--srcFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 "ttc" (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 e-1))))) (let ((u--destFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 e-1)))) (lambda (clam-0) (let ((sc1 (LibrariesC-45UtilsC-45Path-splitParent u--destFile))) (if (null? sc1) (vector 1 '()) (let ((e-2 (unbox sc1))) (let ((e-5 (car e-2))) (let ((act-24 (CoreC-45Directory-ensureDirectoryExists e-5 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (vector 1 (box (cons u--srcFile u--destFile)))))))))))))))))
(define IdrisC-45Package-n--17668-7072-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-24 ((CoreC-45Context-lookupCtxtExact arg-6 (let ((e-0 (vector-ref arg-5 0))) e-0)) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (vector 1 (let ((e-17 (vector-ref e-1 17))) (case (vector-ref e-17 0) ((5) 0)(else (CoreC-45TT-u--C-47C-61_Eq_Visibility (let ((e-36 (vector-ref e-1 9))) e-36) 0)))))))))))))
(define IdrisC-45Package-n--15563-5215-u--toSource (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-24 (CoreC-45Directory-nsToSource arg-4 e-2 e-3 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (cons e-3 e-5))))))))))
(define IdrisC-45Package-n--13260-2996-u--strField (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Package-exactProperty arg-2)) (lambda () (vector 11 1 (ParserC-45RuleC-45Package-equals) (lambda () (vector 9 0 (ParserC-45RuleC-45Package-stringLit) (lambda () (lambda (u--str) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 ((arg-1 (vector 0 (vector 1 arg-0) u--start u--end)) u--str)))))))))))))))
(define IdrisC-45Package-n--20671-9763-u--pOptUpdate (lambda (arg-0 arg-1 ext-0) (IdrisC-45Package-with--partitionOptsC-44pOptUpdate-9789 arg-0 arg-1 (IdrisC-45Package-n--20671-9762-u--optType arg-0 arg-1) ext-0)))
(define IdrisC-45Package-n--20671-9762-u--optType (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((20) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (vector 0 arg-0 e-0 e-1)))) ((13) (vector 1 arg-0)) ((14) (vector 1 arg-0)) ((34) (vector 1 arg-0)) ((17) (vector 1 arg-0)) ((40) (vector 1 arg-0)) ((27) (vector 1 arg-0)) ((28) (vector 1 arg-0)) ((30) (vector 1 arg-0)) ((35) (vector 1 arg-0)) ((3) (vector 1 arg-0)) ((4) (vector 1 arg-0)) ((7) (vector 1 arg-0)) ((8) (vector 1 arg-0)) ((37) (vector 1 arg-0)) ((39) (vector 1 arg-0)) ((9) (vector 1 arg-0)) ((15) (vector 2 arg-0)) ((16) (vector 2 arg-0)) ((12) (vector 2 arg-0))(else (vector 3 arg-0)))))
(define IdrisC-45Package-n--13260-2994-u--mkBound (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (vector 0 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (case (vector-ref e-1 0) ((0) (let ((e-5 (vector-ref e-1 2))) (let ((e-6 (vector-ref e-1 3))) (PreludeC-45Types-maybe (lambda () (IdrisC-45Package-n--13260-2994-u--mkBound arg-0 e-2 (let ((e-0 (vector-ref arg-2 0))) (let ((e-8 (vector-ref arg-2 1))) (vector e-0 e-8 (box e-5) e-6))))) (lambda () (lambda (_-3258) (vector 4 '() 0 "Dependency already has an upper bound"))) (let ((e-7 (vector-ref arg-2 2))) e-7))))) (else (let ((e-8 (vector-ref e-1 2))) (let ((e-9 (vector-ref e-1 3))) (PreludeC-45Types-maybe (lambda () (IdrisC-45Package-n--13260-2994-u--mkBound arg-0 e-2 (let ((e-4 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector (box e-8) e-9 e-4 e-3))))) (lambda () (lambda (_-3294) (vector 4 '() 0 "Dependency already has a lower bound"))) (let ((e-0 (vector-ref arg-2 0))) e-0)))))))))))
(define IdrisC-45Package-n--20991-10056-u--loadDependencies (lambda (arg-0 arg-1 arg-2 arg-3 ext-1 ext-0) (CoreC-45Core-traverse_ (lambda (u--p) (lambda (eta-0) (IdrisC-45SetOptions-addPkgDir arg-3 (let ((e-0 (car u--p))) e-0) (let ((e-1 (cdr u--p))) e-1) eta-0))) ext-1 ext-0)))
(define IdrisC-45Package-n--17668-7073-u--inNS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-0 (vector-ref arg-6 1))) (let ((e-1 (vector-ref arg-6 2))) (case (vector-ref e-1 0) ((1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-5 e-0))(else 0)))))(else 0))))
(define IdrisC-45Package-n--18780-8060-u--go (lambda (arg-1 arg-3 arg-4 arg-5 arg-6 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45These-bifold arg-1 e-5)))))) (lambda (eta-0) (IdrisC-45Package-bitraverseC (arg-3 arg-5) (lambda (u--sm) (CoreC-45Core-foldlC (csegen-51) (lambda (u--x) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((u--ksC-39 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (cons e-2 '())))) (lambda (eta-1) (let ((act-24 (IdrisC-45Package-n--18780-8060-u--go arg-1 arg-3 arg-4 u--ksC-39 e-3 eta-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((arg-4 u--ksC-39) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (let ((e-1 (car arg-1))) ((e-1 (let ((e-8 (car arg-1))) ((e-8 u--x) e-5))) e-6))))))))))))))))) (let ((e-2 (cdr arg-1))) e-2) (LibrariesC-45DataC-45StringMap-toList u--sm))) arg-6 eta-0)) ext-0)))
(define IdrisC-45Package-n--15563-5216-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-7) (vector 1 arg-8) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-24 (IdrisC-45Package-addField arg-4 arg-3 arg-2 arg-5 arg-6 e-2 arg-8 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45Package-n--15563-5216-u--go arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-5 ext-0))))))))))
(define IdrisC-45Package-n--17668-7074-u--fileError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (vector 1 (cons (vector 49 arg-5 arg-6) '()))))
(define IdrisC-45Package-n--13260-2995-u--depends (lambda (arg-0) (vector 9 0 (ParserC-45RuleC-45Package-packageName) (lambda () (lambda (u--name) (vector 10 0 0 (LibrariesC-45TextC-45Parser-sepBy 1 (ParserC-45RuleC-45Package-andop) (IdrisC-45Package-n--13260-2993-u--bound arg-0)) (lambda (u--bs) (vector 10 0 0 (IdrisC-45Package-n--13260-2994-u--mkBound arg-0 (PreludeC-45Interfaces-concat (csegen-50) u--bs) (IdrisC-45PackageC-45Types-anyBounds)) (lambda (bind-0) (vector 0 (cons u--name bind-0)))))))))))
(define IdrisC-45Package-n--18881-8156-u--deleteFolder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (IdrisC-45Package-n--18881-8155-u--delete arg-0 arg-1 arg-2 arg-3 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 (LibrariesC-45UtilsC-45Path-joinPath arg-5)) ext-0)))
(define IdrisC-45Package-n--18881-8157-u--deleteBin (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((u--ttFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-joinPath arg-5) arg-6)))) (lambda (eta-0) (let ((act-24 (IdrisC-45Package-n--18881-8155-u--delete arg-0 arg-1 arg-2 arg-3 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--ttFile "ttc") eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (IdrisC-45Package-n--18881-8155-u--delete arg-0 arg-1 arg-2 arg-3 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--ttFile "ttm") eta-0))))))))
(define IdrisC-45Package-n--18881-8155-u--delete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 ((SystemC-45FileC-45ReadWrite-removeFile (csegen-3) arg-4) ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (cond (else (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Removed: " arg-4)) ext-0))) (vector 1 act-25)))))) (else (vector 1 0)))))))))
(define IdrisC-45Package-n--13260-2993-u--bound (lambda (arg-0) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Package-lte) (lambda () (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Package-dotC-39) (ParserC-45RuleC-45Package-integerLit)) (lambda () (lambda (u--vs) (vector 0 (cons (vector 0 arg-0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-4190) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat eta-0)) u--vs) 1) '()))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Package-gte) (lambda () (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Package-dotC-39) (ParserC-45RuleC-45Package-integerLit)) (lambda () (lambda (u--vs) (vector 0 (cons (vector 1 arg-0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-4190) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat eta-0)) u--vs) 1) '()))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Package-lt) (lambda () (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Package-dotC-39) (ParserC-45RuleC-45Package-integerLit)) (lambda () (lambda (u--vs) (vector 0 (cons (vector 0 arg-0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-4190) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat eta-0)) u--vs) 0) '()))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Package-gt) (lambda () (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Package-dotC-39) (ParserC-45RuleC-45Package-integerLit)) (lambda () (lambda (u--vs) (vector 0 (cons (vector 1 arg-0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-4190) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat eta-0)) u--vs) 0) '()))))))) (lambda () (vector 11 1 (ParserC-45RuleC-45Package-eqop) (lambda () (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Package-dotC-39) (ParserC-45RuleC-45Package-integerLit)) (lambda () (lambda (u--vs) (vector 0 (cons (vector 0 arg-0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-4190) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat eta-0)) u--vs) 1) (cons (vector 1 arg-0 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-4190) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat eta-0)) u--vs) 1) '()))))))))))))))))))
(define IdrisC-45Package-runScript (lambda (arg-0) (lambda (clam-0) (if (null? arg-0) (vector 1 0) (let ((e-2 (unbox arg-0))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((act-24 (let ((act-24 ((System-system (csegen-3) e-6) clam-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-24 1))) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-7 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc3 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-5 "Script failed") clam-0)) (else (vector 1 0)))))))))))))))
(define IdrisC-45Package-runRepl (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Core.UnifyState.UST" ) (CoreC-45UnifyState-initUState) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 (vector 2 0)))) (lambda () (lambda (u--fname) (lambda (eta-0) (let ((act-25 (CoreC-45Directory-ctxtPathToNS arg-0 u--fname eta-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (vector 1 (vector 0 e-6))))))))) arg-3) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata e-6) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (if (null? arg-3) (vector 1 0) (let ((e-2 (unbox arg-3))) (let ((act-27 (IdrisC-45REPL-loadMainFile arg-0 e-5 arg-1 e-7 arg-2 e-2 ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (IdrisC-45REPL-displayErrors arg-0 e-5 arg-1 e-7 arg-2 e-8 ext-0))))))))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (IdrisC-45REPL-repl arg-0 e-5 arg-1 e-7 arg-2 ext-0))))))))))))))))))
(define IdrisC-45Package-processPackageOpts (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (vector 1 (IdrisC-45Package-partitionOpts arg-3)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (if (null? e-0) (vector 1 0) (let ((e-4 (car e-0))) (let ((e-6 (cdr e-0))) (let ((act-25 (let ((u--cmds (cons e-4 e-6))) (cond ((equal? e-2 1) (let ((act-25 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 (IdrisC-45Package-errorMsg) "\xa;")) ext-0))) (vector 1 act-25))) (else (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (IdrisC-45Package-processPackage arg-0 arg-1 arg-2 e-1 eta-0 eta-1))) u--cmds ext-0)))))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 1))))))))))))))))
(define IdrisC-45Package-processPackage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (CoreC-45Context-withCtxt arg-0 (lambda (eta-1) (IdrisC-45Syntax-withSyn arg-1 (lambda (eta-2) (IdrisC-45REPLC-45Opts-withROpts arg-2 (lambda (clam-1) (cond ((equal? e-2 7) (let ((act-24 (let ((act-24 (IdrisC-45PackageC-45Init-interactive clam-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fp (DataC-45Maybe-fromMaybe (lambda () (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (vector-ref e-5 0))) e-0) ".ipkg")) e-3))) (let ((act-25 (let ((act-25 (CompilerC-45Common-exists u--fp clam-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 0) (let ((act-26 (let ((act-26 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) u--fp (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (IdrisC-45PackageC-45Types-u--pretty_Pretty_PkgDesc e-5))) clam-1))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (case (vector-ref e-7 0) ((1) (let ((e-4 (vector-ref e-7 1))) (cond (else (vector 1 0))))) (else (let ((e-8 (vector-ref e-7 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--fp e-8) clam-1)))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45FC-emptyFC) (PreludeC-45TypesC-45String-C-43C-43 "File " (PreludeC-45TypesC-45String-C-43C-43 u--fp " already exists"))) clam-1)))))))))))))(else (let ((act-24 (IdrisC-45Package-localPackageFile e-3 clam-1))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45Package-case--caseC-32blockC-32inC-32processPackage-8862 e-2 e-3 arg-3 arg-2 arg-1 arg-0 e-5 (LibrariesC-45UtilsC-45Path-splitParent e-5)) clam-1)))))))) eta-2)) eta-1)) ext-0)))))
(define IdrisC-45Package-processOptions (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-2 (unbox arg-2))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((sc2 (IdrisC-45CommandLine-getOpts (DataC-45String-words e-6)))) (case (vector-ref sc2 0) ((1) (let ((e-3 (vector-ref sc2 1))) (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) clam-0))) (else (let ((e-7 (vector-ref sc2 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 e-5 e-7) clam-0))))))))))))
(define IdrisC-45Package-prepareCompilation (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((IdrisC-45Package-processOptions arg-0 arg-2 (let ((e-14 (vector-ref arg-3 14))) e-14)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (IdrisC-45Package-addDeps arg-0 arg-3 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (IdrisC-45SetOptions-preOptions arg-0 arg-2 arg-4) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((IdrisC-45Package-runScript (let ((e-18 (vector-ref arg-3 18))) e-18)) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((u--toBuild (PreludeC-45Types-maybe (lambda () (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-11 (vector-ref arg-3 11))) e-11))) (lambda () (lambda (u--m) (cons (Builtin-snd u--m) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-11 (vector-ref arg-3 11))) e-11))))) (let ((e-12 (vector-ref arg-3 12))) e-12)))) (IdrisC-45ModTree-buildAll arg-0 arg-1 arg-2 u--toBuild ext-0)))))))))))))))))))
(define IdrisC-45Package-partitionOpts (lambda (arg-0) (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (IdrisC-45Package-n--20671-9763-u--pOptUpdate arg-0 eta-0 eta-1))) (vector '() '() 0) arg-0)))
(define IdrisC-45Package-parsePkgDesc (lambda (arg-0) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Package-exactProperty "package")) (lambda () (vector 9 0 (ParserC-45RuleC-45Package-packageName) (lambda () (lambda (u--name) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (IdrisC-45Package-field arg-0)) (lambda (u--fields) (vector 0 (cons u--name u--fields)))))))))))
(define IdrisC-45Package-makeDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (IdrisC-45Package-prepareCompilation arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 (let ((act-25 (unbox arg-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--build (let ((e-4 (vector-ref e-6 4))) (let ((e-42 (vector-ref e-4 0))) (let ((e-50 (vector-ref e-42 2))) e-50))))) (let ((u--docBase (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--build "docs"))) (let ((u--docDir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase "docs"))) (let ((act-26 (let ((act-26 (CoreC-45Directory-mkdirAll u--docDir ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((_-0 '())) (case (vector-ref e-7 0) ((1) (let ((e-2 (vector-ref e-7 1))) (cond (else (let ((act-27 (CoreC-45Core-newRef (vector "Core.UnifyState.UST" ) (CoreC-45UnifyState-initUState) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (let ((act-28 (CoreC-45Context-setPPrint arg-0 (vector 0 0 0) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((act-29 (PreludeC-45IO-u--map_Functor_IO (csegen-2316) (PreludeC-45Basics-flip (csegen-1822) (let ((e-11 (vector-ref arg-3 11))) e-11) (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((u--ns (CoreC-45NameC-45Namespace-miAsNamespace e-4))) (lambda (eta-0) (let ((act-29 (IdrisC-45ProcessIdr-addImport arg-0 e-8 arg-1 (vector (CoreC-45FC-emptyFC) 0 e-4 u--ns) eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-10 (vector-ref act-29 1))) (vector 0 e-10))) (else (let ((act-30 (let ((act-30 (unbox arg-0))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-11 (vector-ref act-30 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (CoreC-45Context-allNames (let ((e-0 (vector-ref e-11 0))) e-0) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-12 (vector-ref act-31 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-31 1))) (let ((u--allInNamespace (DataC-45List-filter (lambda (eta-1) (IdrisC-45Package-n--17668-7073-u--inNS arg-4 arg-3 arg-2 arg-1 arg-0 u--ns eta-1)) e-12))) (let ((act-32 (CoreC-45Core-filterM (lambda (eta-1) (lambda (eta-2) (IdrisC-45Package-n--17668-7072-u--visible arg-4 arg-3 arg-2 arg-1 arg-0 e-11 eta-1 eta-2))) u--allInNamespace eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-13 (vector-ref act-32 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-32 1))) (let ((u--outputFilePath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docDir (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-4) ".html")))) (let ((act-33 ((PreludeC-45Basics-flip (csegen-1822) (DataC-45List-sort (csegen-883) e-13) (lambda (u--nm) (lambda (eta-1) (IdrisC-45DocC-45String-getDocsForName arg-2 arg-0 arg-1 (CoreC-45FC-emptyFC) u--nm (IdrisC-45DocC-45String-shortNamesConfig) eta-1)))) eta-0))) (case (vector-ref act-33 0) ((0) (let ((e-14 (vector-ref act-33 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-33 1))) (let ((u--allDecls (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat e-14)))) (let ((act-34 (let ((act-34 (unbox arg-1))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-15 (vector-ref act-34 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-34 1))) (let ((u--modDoc (LibrariesC-45DataC-45SortedMap-lookup e-4 (let ((e-23 (vector-ref e-15 3))) e-23)))) (let ((act-35 (CoreC-45ContextC-45Log-log arg-0 "doc.module" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))) (lambda () (DataC-45String-unwords (cons "Looked up doc for" (cons (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-4) (cons "and got:" (cons (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-576) u--modDoc) '())))))) eta-0))) (case (vector-ref act-35 0) ((0) (let ((e-16 (vector-ref act-35 1))) (vector 0 e-16))) (else (let ((act-36 (CoreC-45ContextC-45Log-log arg-0 "doc.module" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "from: " (LibrariesC-45DataC-45SortedMap-u--show_Show_C-40C-40SortedMapC-32C-36kC-41C-32C-36vC-41 (csegen-3574) (let ((e-24 (vector-ref e-15 3))) e-24)))) eta-0))) (case (vector-ref act-36 0) ((0) (let ((e-17 (vector-ref act-36 1))) (vector 0 e-17))) (else (let ((act-37 (let ((act-37 ((IdrisC-45DocC-45HTML-renderModuleDoc arg-0 e-4 u--modDoc u--allDecls) eta-0))) (case (vector-ref act-37 0) ((0) (let ((e-18 (vector-ref act-37 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-37 1))) (let ((act-38 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) u--outputFilePath e-18) eta-0))) (vector 1 act-38)))))))) (case (vector-ref act-37 0) ((0) (let ((e-18 (vector-ref act-37 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-37 1))) (case (vector-ref e-18 0) ((1) (let ((e-19 (vector-ref e-18 1))) (cond (else (vector 1 '()))))) (else (let ((e-19 (vector-ref e-18 1))) (IdrisC-45Package-n--17668-7074-u--fileError arg-4 arg-3 arg-2 arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase "index.html") e-19 eta-0)))))))))))))))))))))))))))))))))))))))))))))) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-29 1))) (let ((_-1 (vector 1 0))) (if (null? e-10) (let ((act-30 (let ((act-30 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase "index.html") (IdrisC-45DocC-45HTML-renderDocIndex arg-3)) ext-0))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-30 1))) (let ((_-2 '())) (case (vector-ref e-11 0) ((1) (let ((e-3 (vector-ref e-11 1))) (cond (else (let ((act-31 ((PreludeC-45Basics-flip (csegen-1822) (IdrisC-45PackageC-45Types-cssFiles) (lambda (u--cssFile) (let ((u--fn (PreludeC-45TypesC-45String-C-43C-43 (let ((e-1 (cdr u--cssFile))) e-1) ".css"))) (lambda (eta-0) (let ((act-31 (CoreC-45Directory-readDataFile arg-0 (PreludeC-45TypesC-45String-C-43C-43 "docs/" u--fn) eta-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (let ((act-32 (let ((act-32 ((SystemC-45FileC-45ReadWrite-writeFile (csegen-3) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase u--fn) e-12) eta-0))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-4 (vector-ref act-32 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-32 1))) (case (vector-ref e-13 0) ((1) (let ((e-4 (vector-ref e-13 1))) (cond (else (vector 1 '()))))) (else (let ((e-14 (vector-ref e-13 1))) (IdrisC-45Package-n--17668-7074-u--fileError arg-4 arg-3 arg-2 arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase u--fn) e-14 eta-0)))))))))))))))) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-4 (vector-ref act-31 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-31 1))) (let ((_-3 (vector 1 0))) (IdrisC-45Package-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeDoc-7809 arg-4 arg-3 arg-2 arg-1 arg-0 _-0 e-6 u--build u--docBase u--docDir _-1 e-8 _-2 _-3 e-12 (PreludeC-45Interfaces-concat (csegen-50) e-12) ext-0)))))))))) (else (let ((e-12 (vector-ref e-11 1))) (IdrisC-45Package-n--17668-7074-u--fileError arg-4 arg-3 arg-2 arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase "index.html") e-12 ext-0))))))))) (vector 1 e-10)))))))))))))))))) (else (let ((e-8 (vector-ref e-7 1))) (IdrisC-45Package-n--17668-7074-u--fileError arg-4 arg-3 arg-2 arg-1 arg-0 u--docDir e-8 ext-0)))))))))))))))) (vector 1 e-5))))))))
(define IdrisC-45Package-localPackageFile (lambda (arg-0 ext-0) (if (null? arg-0) (let ((act-24 (CoreC-45Context-getWorkingDir ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (LibrariesC-45SystemC-45DirectoryC-45Tree-explore (LibrariesC-45UtilsC-45Path-parse e-5) ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--candidates (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName eta-0)) (let ((e-1 (car e-6))) e-1)))) (let ((sc3 (DataC-45List-filter (lambda (arg-1) (DataC-45String-isSuffixOf ".ipkg" arg-1)) u--candidates))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 58 "No .ipkg file supplied and none could be found in the working directory.") ext-0) (let ((e-1 (car sc3))) (let ((e-2 (cdr sc3))) (if (null? e-2) (vector 1 e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 58 "No .ipkg file supplied and the working directory contains more than one.") ext-0))))))))))))))) (let ((e-1 (unbox arg-0))) (vector 1 e-1)))))
(define IdrisC-45Package-installSrcFrom (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((u--srcfile (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath e-2))) (let ((u--srcPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 e-3))) (IdrisC-45Package-case--installSrcFrom-6287 e-2 e-3 arg-2 arg-1 arg-0 u--srcfile u--srcPath (LibrariesC-45UtilsC-45Path-extension u--srcPath))))))))
(define IdrisC-45Package-installFrom (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--ttcfile (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath arg-4))) (let ((u--ttcPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 "ttc" (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--ttcfile "ttc"))))) (lambda (eta-0) (let ((act-24 (let ((act-24 (CoreC-45Context-getSession arg-1 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (CoreC-45Core-traverseC-39 (lambda (u--cg) (lambda (eta-1) (let ((act-25 (IdrisC-45ProcessIdr-getCG arg-0 arg-1 u--cg eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) ((IdrisC-45Package-case--caseC-32blockC-32inC-32installFrom-5823 arg-4 arg-3 arg-2 arg-1 arg-0 u--ttcfile u--ttcPath e-5 u--cg e-1 _-0 (let ((e-3 (vector-ref e-1 3))) e-3)) eta-1)))))))))) (let ((e-21 (vector-ref e-5 21))) e-21) '() eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--objPaths (DataC-45List-mapMaybe (lambda (eta-1) eta-1) e-5))) (let ((u--modPath (PreludeC-45TypesC-45List-reverse (DataC-45Maybe-fromMaybe (lambda () '()) (DataC-45List-tailC-39 (CoreC-45NameC-45Namespace-unsafeUnfoldModuleIdent arg-4)))))) (let ((u--destNest (LibrariesC-45UtilsC-45Path-joinPath u--modPath))) (let ((u--destPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--destNest))) (let ((u--destFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--ttcfile "ttc")))) (let ((act-25 (let ((act-25 (CoreC-45Directory-mkdirAll u--destNest eta-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (case (vector-ref e-6 0) ((1) (let ((act-26 (let ((act-26 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Installing " (PreludeC-45TypesC-45String-C-43C-43 u--ttcPath (PreludeC-45TypesC-45String-C-43C-43 " to " u--destPath)))) eta-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 (let ((act-27 ((LibrariesC-45SystemC-45DirectoryC-45Tree-copyFile (csegen-3) u--ttcPath u--destFile) eta-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((1) (let ((act-28 (CoreC-45Core-traverse_ (lambda (lamc-0) (lambda (clam-0) (let ((e-9 (car lamc-0))) (let ((e-4 (cdr lamc-0))) (let ((act-28 (let ((act-28 ((PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45TypesC-45String-C-43C-43 "Installing " (PreludeC-45TypesC-45String-C-43C-43 e-9 (PreludeC-45TypesC-45String-C-43C-43 " to " u--destPath)))) clam-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-10 (vector-ref act-28 1))) (vector 0 e-10))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-1) (let ((act-29 ((LibrariesC-45SystemC-45DirectoryC-45Tree-copyFile (csegen-3) e-9 e-4) eta-1))) (vector 1 act-29))) clam-0)))))))) u--objPaths eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-4 (vector-ref act-28 1))) (vector 0 e-4))) (else (vector 1 0))))) (else (let ((e-9 (vector-ref e-8 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (LibrariesC-45DataC-45StringC-45Extra-unlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Can't copy file " (PreludeC-45TypesC-45String-C-43C-43 u--ttcPath (PreludeC-45TypesC-45String-C-43C-43 " to " u--destPath))) (cons (SystemC-45FileC-45Error-u--show_Show_FileError e-9) '())))) eta-0)))))))))))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (LibrariesC-45DataC-45StringC-45Extra-unlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Can't make directories " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-576) u--modPath)) (cons (SystemC-45FileC-45Error-u--show_Show_FileError e-7) '())))) eta-0))))))))))))))))))))))
(define IdrisC-45Package-installDir (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (vector-ref arg-0 0))) e-0) (PreludeC-45TypesC-45String-C-43C-43 "-" (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion (DataC-45Maybe-fromMaybe (lambda () (cons 0 '())) (let ((e-1 (vector-ref arg-0 1))) e-1)))))))
(define IdrisC-45Package-install (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--build (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 0))) (let ((e-49 (vector-ref e-41 2))) e-49))))) (let ((act-25 ((IdrisC-45Package-runScript (let ((e-20 (vector-ref arg-2 20))) e-20)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--toInstall (PreludeC-45Types-maybe (lambda () (let ((e-11 (vector-ref arg-2 11))) e-11)) (lambda () (lambda (arg-5) (cons arg-5 (let ((e-11 (vector-ref arg-2 11))) e-11)))) (let ((e-12 (vector-ref arg-2 12))) e-12)))) (let ((act-26 (CoreC-45Context-getWorkingDir ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--targetDir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-4 (vector-ref e-5 4))) (let ((e-43 (vector-ref e-4 0))) (let ((e-48 (vector-ref e-43 5))) e-48))) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (csegen-1224) (IdrisC-45Package-installDir arg-2))))) (let ((act-27 (let ((act-27 (CoreC-45Directory-mkdirAll u--targetDir ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (case (vector-ref e-8 0) ((1) (let ((act-28 (let ((act-28 ((SystemC-45Directory-changeDir (csegen-3) u--targetDir) ext-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-28 1))) (cond ((equal? e-9 1) (let ((act-29 (CoreC-45Core-traverse_ (lambda (eta-0) (IdrisC-45Package-installFrom arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-7 u--build) u--targetDir (Builtin-fst eta-0))) u--toInstall ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (cond ((equal? arg-4 1) (CoreC-45Core-traverse_ (lambda (eta-0) (IdrisC-45Package-installSrcFrom arg-0 e-7 u--targetDir eta-0)) u--toInstall ext-0)) (else (vector 1 0))))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-31 ((SystemC-45Directory-changeDir (csegen-3) e-7) eta-0))) (vector 1 act-31))) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else ((IdrisC-45Package-runScript (let ((e-21 (vector-ref arg-2 21))) e-21)) ext-0))))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (PreludeC-45TypesC-45String-C-43C-43 "Can't change directory to " u--targetDir)) ext-0)))))))) (else (let ((e-9 (vector-ref e-8 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 57 (LibrariesC-45DataC-45StringC-45Extra-unlines (cons (PreludeC-45TypesC-45String-C-43C-43 "Can't make directory " u--targetDir) (cons (SystemC-45FileC-45Error-u--show_Show_FileError e-9) '())))) ext-0))))))))))))))))))))))))
(define IdrisC-45Package-foldWithKeysC (lambda (arg-2 arg-3 arg-4 ext-1 ext-0) (IdrisC-45Package-n--18780-8060-u--go arg-2 arg-4 arg-3 '() ext-1 ext-0)))
(define IdrisC-45Package-findIpkg (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (CoreC-45Directory-findIpkgFile ext-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 arg-3) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((act-25 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (let ((act-25 ((SystemC-45Directory-changeDir (csegen-3) e-7) eta-0))) (vector 1 act-25))) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 (CoreC-45Context-setWorkingDir arg-0 e-7 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 (let ((act-27 (ParserC-45Package-parseFile e-9 (vector 9 1 (IdrisC-45Package-parsePkgDesc e-9) (lambda () (lambda (u--desc) (vector 11 0 (ParserC-45RuleC-45Package-eoi) (lambda () (vector 0 u--desc)))))) ext-0))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-27 1))) (case (vector-ref e-12 0) ((1) (let ((e-2 (vector-ref e-12 1))) (let ((e-14 (car e-2))) (let ((e-13 (cdr e-2))) (let ((act-28 (IdrisC-45Package-addFields arg-0 arg-2 arg-1 e-13 (IdrisC-45PackageC-45Types-initPkgDesc e-14) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-3 (vector-ref act-28 1))) (vector 0 e-3))) (else (let ((e-15 (vector-ref act-28 1))) (let ((act-29 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 0))) (lambda () (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-setBuildDir arg-0 eta-0 eta-1)))) (let ((e-16 (vector-ref e-15 16))) e-16)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-3 (vector-ref act-29 1))) (vector 0 e-3))) (else (let ((act-30 (CoreC-45Context-setOutputDir arg-0 (let ((e-17 (vector-ref e-15 17))) e-17) ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-3 (vector-ref act-30 1))) (vector 0 e-3))) (else (let ((act-31 ((IdrisC-45Package-processOptions arg-0 arg-1 (let ((e-27 (vector-ref e-15 14))) e-27)) ext-0))) (case (vector-ref act-31 0) ((0) (let ((e-3 (vector-ref act-31 1))) (vector 0 e-3))) (else (let ((act-32 (IdrisC-45Package-n--20991-10056-u--loadDependencies arg-3 arg-2 arg-1 arg-0 (let ((e-32 (vector-ref e-15 10))) e-32) ext-0))) (case (vector-ref act-32 0) ((0) (let ((e-3 (vector-ref act-32 1))) (vector 0 e-3))) (else (if (null? arg-3) (vector 1 '()) (let ((e-3 (unbox arg-3))) (let ((u--srcC-39 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-10 e-3))) (let ((act-33 (IdrisC-45REPLC-45Opts-setSource arg-1 u--srcC-39 ext-0))) (case (vector-ref act-33 0) ((0) (let ((e-4 (vector-ref act-33 1))) (vector 0 e-4))) (else (let ((act-34 (let ((act-34 (unbox arg-1))) (vector 1 act-34)))) (case (vector-ref act-34 0) ((0) (let ((e-4 (vector-ref act-34 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-34 1))) (let ((act-35 (let ((act-35 (set-box! arg-1 (let ((e-0 (vector-ref e-21 0))) (let ((e-36 (vector-ref e-21 1))) (let ((e-35 (vector-ref e-21 2))) (let ((e-4 (vector-ref e-21 4))) (let ((e-33 (vector-ref e-21 5))) (let ((e-32 (vector-ref e-21 6))) (let ((e-31 (vector-ref e-21 7))) (let ((e-30 (vector-ref e-21 8))) (let ((e-29 (vector-ref e-21 9))) (let ((e-28 (vector-ref e-21 10))) (let ((e-27 (vector-ref e-21 11))) (let ((e-26 (vector-ref e-21 12))) (let ((e-25 (vector-ref e-21 13))) (let ((e-24 (vector-ref e-21 14))) (let ((e-23 (vector-ref e-21 15))) (let ((e-22 (vector-ref e-21 16))) (vector e-0 e-36 e-35 (box u--srcC-39) e-4 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-22)))))))))))))))))))) (vector 1 act-35)))) (case (vector-ref act-35 0) ((0) (let ((e-4 (vector-ref act-35 1))) (vector 0 e-4))) (else (vector 1 (box u--srcC-39))))))))))))))))))))))))))))))))))) (else (let ((e-13 (vector-ref e-12 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-13 ext-0))))))))))))))))))))))))))
(define IdrisC-45Package-field (lambda (arg-0) (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 2 eta-0 eta-1))) "authors") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 3 eta-0 eta-1))) "maintainers") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 4 eta-0 eta-1))) "license") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 5 eta-0 eta-1))) "brief") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 6 eta-0 eta-1))) "readme") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 7 eta-0 eta-1))) "homepage") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 8 eta-0 eta-1))) "sourceloc") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 9 eta-0 eta-1))) "bugtracker") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (csegen-4204) "options") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (csegen-4204) "opts") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 15 eta-0 eta-1))) "sourcedir") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 16 eta-0 eta-1))) "builddir") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 17 eta-0 eta-1))) "outputdir") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 18 eta-0 eta-1))) "prebuild") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 19 eta-0 eta-1))) "postbuild") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 20 eta-0 eta-1))) "preinstall") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 21 eta-0 eta-1))) "postinstall") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 22 eta-0 eta-1))) "preclean") (lambda () (vector 13 1 1 (IdrisC-45Package-n--13260-2996-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 23 eta-0 eta-1))) "postclean") (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (csegen-4214) (lambda () (vector 11 1 (ParserC-45RuleC-45Package-equals) (lambda () (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Package-dotC-39) (ParserC-45RuleC-45Package-integerLit)) (lambda () (lambda (u--vs) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 0 (vector 0 (vector 1 arg-0) u--start u--end) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-4190) (lambda (eta-0) (PreludeC-45Types-u--fromInteger_Num_Nat eta-0)) u--vs)))))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 11 1 (csegen-4214) (lambda () (vector 11 1 (ParserC-45RuleC-45Package-equals) (lambda () (vector 9 0 (ParserC-45RuleC-45Package-stringLit) (lambda () (lambda (u--v) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 1 (vector 0 (vector 1 arg-0) u--start u--end) u--v))))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Package-exactProperty "depends")) (lambda () (vector 11 1 (ParserC-45RuleC-45Package-equals) (lambda () (vector 9 0 (ParserC-45RuleC-45Package-sep (IdrisC-45Package-n--13260-2995-u--depends arg-0)) (lambda () (lambda (u--ds) (vector 0 (vector 10 u--ds))))))))) (lambda () (vector 13 1 1 (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Package-exactProperty "modules")) (lambda () (vector 11 1 (ParserC-45RuleC-45Package-equals) (lambda () (vector 9 0 (ParserC-45RuleC-45Package-sep (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (ParserC-45RuleC-45Package-moduleIdent) (lambda () (lambda (u--m) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (cons (vector 0 (vector 1 arg-0) u--start u--end) u--m)))))))))) (lambda () (lambda (u--ms) (vector 0 (vector 11 u--ms))))))))) (lambda () (vector 13 1 1 (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Package-exactProperty "main")) (lambda () (vector 11 1 (ParserC-45RuleC-45Package-equals) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-location) (lambda (u--start) (vector 9 0 (ParserC-45RuleC-45Package-moduleIdent) (lambda () (lambda (u--m) (vector 10 0 0 (LibrariesC-45TextC-45Parser-location) (lambda (u--end) (vector 0 (vector 12 (vector 0 (vector 1 arg-0) u--start u--end) u--m))))))))))))) (lambda () (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Package-exactProperty "executable")) (lambda () (vector 11 1 (ParserC-45RuleC-45Package-equals) (lambda () (vector 9 0 (vector 13 1 1 (ParserC-45RuleC-45Package-stringLit) (lambda () (ParserC-45RuleC-45Package-packageName))) (lambda () (lambda (u--e) (vector 0 (vector 13 u--e)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Package-errorMsg(blodwen-lazy (lambda () (LibrariesC-45DataC-45StringC-45Extra-unlines (cons "Not all command line options can be used to override package options.\xa;" (cons "Overridable options are:" (cons "    --quiet" (cons "    --verbose" (cons "    --timing" (cons "    --log <log level>" (cons "    --dumpcases <file>" (cons "    --dumplifted <file>" (cons "    --dumpvmcode <file>" (cons "    --debug-elab-check" (cons "    --codegen <cg>" (cons "    --directive <directive>" (cons "    --build-dir <dir>" (cons "    --output-dir <dir>" '()))))))))))))))))))
(define IdrisC-45Package-compileMain (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Directory-ctxtPathToNS arg-0 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata (vector 0 e-5)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Core-newRef (vector "Core.UnifyState.UST" ) (CoreC-45UnifyState-initUState) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (IdrisC-45REPL-loadMainFile arg-0 e-7 arg-1 e-6 arg-2 arg-4 eta-0)) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (PreludeC-45IO-u--map_Functor_IO (csegen-20) (lambda (eta-0) (IdrisC-45REPL-compileExp arg-0 e-7 arg-1 e-6 arg-2 (vector 0 (CoreC-45FC-replFC) arg-3) arg-5 eta-0)) ext-0))))))))))))))))))
(define IdrisC-45Package-clean (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45Package-runScript (let ((e-22 (vector-ref arg-2 22))) e-22)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((u--pkgmods (PreludeC-45Types-maybe (lambda () (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (let ((e-11 (vector-ref arg-2 11))) e-11))) (lambda () (lambda (u--m) (cons (Builtin-fst u--m) (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (Builtin-fst eta-0)) (let ((e-11 (vector-ref arg-2 11))) e-11))))) (let ((e-12 (vector-ref arg-2 12))) e-12)))) (let ((u--toClean (DataC-45List-mapMaybe (lambda (u--mod) (let ((sc2 (CoreC-45NameC-45Namespace-unsafeUnfoldModuleIdent u--mod))) (if (null? sc2) '() (let ((e-2 (car sc2))) (let ((e-3 (cdr sc2))) (box (cons e-3 e-2))))))) u--pkgmods))) (let ((act-26 (CoreC-45Context-getWorkingDir ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--d (let ((e-4 (vector-ref e-5 4))) (let ((e-43 (vector-ref e-4 0))) e-43)))) (let ((u--builddir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-7 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref u--d 2))) e-2) "ttc")))) (let ((u--outputdir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-7 (CoreC-45Options-outputDirWithDefault u--d)))) (let ((u--pkgTrie (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--trie) (lambda (u--ksv) (let ((u--ks (Builtin-fst u--ksv))) (let ((u--v (Builtin-snd u--ksv))) (LibrariesC-45DataC-45StringTrie-insertWith (PreludeC-45TypesC-45List-reverse u--ks) (lambda (eta-0) (PreludeC-45Types-maybe (lambda () (cons u--v '())) (lambda () (lambda (arg-4) (cons u--v arg-4))) eta-0)) u--trie))))) (LibrariesC-45DataC-45StringTrie-empty) u--toClean))) (let ((act-27 (IdrisC-45Package-foldWithKeysC (csegen-4239) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Package-n--18881-8156-u--deleteFolder arg-3 arg-2 arg-1 arg-0 u--builddir eta-0 eta-1))) (lambda (u--ks) (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-2 1))) (vector 1 (PreludeC-45Interfaces-concat (cons (csegen-51) (csegen-4239)) e-8)))))) (lambda (eta-2) (CoreC-45Core-traverseC-39 (lambda (eta-3) (IdrisC-45Package-n--18881-8157-u--deleteBin arg-3 arg-2 arg-1 arg-0 u--builddir u--ks eta-3)) eta-0 '() eta-2)) eta-1)))) u--pkgTrie ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (IdrisC-45Package-n--18881-8156-u--deleteFolder arg-3 arg-2 arg-1 arg-0 u--builddir '() ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 0))) (lambda () (lambda (u--e) (lambda (eta-0) (IdrisC-45Package-n--18881-8155-u--delete arg-3 arg-2 arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--outputdir u--e) eta-0)))) (let ((e-13 (vector-ref arg-2 13))) e-13)) ext-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else ((IdrisC-45Package-runScript (let ((e-23 (vector-ref arg-2 23))) e-23)) ext-0)))))))))))))))))))))))))))))
(define IdrisC-45Package-check (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (IdrisC-45Package-prepareCompilation arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 ((IdrisC-45Package-runScript (let ((e-19 (vector-ref arg-3 19))) e-19)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 '())))) (vector 1 e-5))))))))
(define IdrisC-45Package-build (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (IdrisC-45Package-prepareCompilation arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (let ((act-25 (let ((e-13 (vector-ref arg-3 13))) (if (null? e-13) (vector 1 0) (let ((e-25 (unbox e-13))) (let ((e-37 (vector-ref arg-3 12))) (if (null? e-37) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 (CoreC-45FC-emptyFC) "No main module given") ext-0) (let ((e-50 (unbox e-37))) (let ((e-52 (car e-50))) (let ((e-51 (cdr e-50))) (let ((u--mainName (vector 0 (CoreC-45NameC-45Namespace-miAsNamespace e-52) (vector 1 (vector 0 "main"))))) (IdrisC-45Package-compileMain arg-0 arg-1 arg-2 u--mainName e-51 e-25 ext-0)))))))))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((IdrisC-45Package-runScript (let ((e-19 (vector-ref arg-3 19))) e-19)) ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (vector 1 '()))))))) (vector 1 e-5))))))))
(define IdrisC-45Package-bitraverseC (lambda (arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 0 eta-1)))) (arg-4 e-2) ext-0))) ((1) (let ((e-5 (vector-ref arg-6 1))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 1 eta-1)))) (arg-5 e-5) ext-0))) (else (let ((e-8 (vector-ref arg-6 1))) (let ((e-9 (vector-ref arg-6 2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (vector 1 (lambda (eta-2) (lambda (eta-3) (vector 2 eta-2 eta-3))))) (arg-4 e-8) eta-0)) (arg-5 e-9) ext-0)))))))
(define IdrisC-45Package-addFields (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (CoreC-45Core-newRef (vector "Idris.Package.ParsedMods" ) '() ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (CoreC-45Core-newRef (vector "Idris.Package.MainMod" ) '() ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (IdrisC-45Package-n--15563-5216-u--go arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 arg-3 arg-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (CoreC-45Context-setSourceDir arg-0 (let ((e-15 (vector-ref e-7 15))) e-15) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 (let ((act-28 (unbox e-5))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (let ((act-29 (unbox e-6))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-29 1))) (let ((act-30 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Package-n--15563-5215-u--toSource arg-4 arg-3 arg-2 arg-1 arg-0 eta-0 eta-1))) e-9 '() ext-0))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-30 1))) (let ((act-31 (if (null? e-10) (vector 1 '()) (let ((e-2 (unbox e-10))) (PreludeC-45IO-u--map_Functor_IO (csegen-980) (lambda (eta-0) (IdrisC-45Package-n--15563-5215-u--toSource arg-4 arg-3 arg-2 arg-1 arg-0 e-2 eta-0)) ext-0))))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-31 1))) (vector 1 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-31 (vector-ref e-7 5))) (let ((e-30 (vector-ref e-7 6))) (let ((e-29 (vector-ref e-7 7))) (let ((e-28 (vector-ref e-7 8))) (let ((e-27 (vector-ref e-7 9))) (let ((e-26 (vector-ref e-7 10))) (let ((e-13 (vector-ref e-7 13))) (let ((e-14 (vector-ref e-7 14))) (let ((e-15 (vector-ref e-7 15))) (let ((e-16 (vector-ref e-7 16))) (let ((e-17 (vector-ref e-7 17))) (let ((e-18 (vector-ref e-7 18))) (let ((e-19 (vector-ref e-7 19))) (let ((e-20 (vector-ref e-7 20))) (let ((e-21 (vector-ref e-7 21))) (let ((e-22 (vector-ref e-7 22))) (let ((e-23 (vector-ref e-7 23))) (vector e-0 e-1 e-2 e-3 e-4 e-31 e-30 e-29 e-28 e-27 e-26 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Package-addField (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 2))) (vector 1 (let ((e-25 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-25 (box e-1) e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((1) (let ((act-24 (IdrisC-45REPLC-45Common-emitWarning arg-0 arg-2 arg-1 (vector 3 "version numbers must now be of the form x.y.z") ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (vector 1 arg-6))))) ((2) (let ((e-5 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (let ((e-24 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 (box e-5) e-3 e-25 e-24 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((3) (let ((e-7 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-25 (vector-ref arg-6 6))) (let ((e-24 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 (box e-7) e-4 e-5 e-25 e-24 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((4) (let ((e-9 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-25 (vector-ref arg-6 8))) (let ((e-24 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 (box e-9) e-5 e-6 e-7 e-25 e-24 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((5) (let ((e-11 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-25 (vector-ref arg-6 10))) (let ((e-24 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 (box e-11) e-6 e-7 e-8 e-9 e-25 e-24 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((6) (let ((e-13 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-25 (vector-ref arg-6 12))) (let ((e-24 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (box e-13) e-7 e-8 e-9 e-10 e-11 e-25 e-24 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((7) (let ((e-15 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-25 (vector-ref arg-6 14))) (let ((e-24 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 (box e-15) e-8 e-9 e-10 e-11 e-12 e-13 e-25 e-24 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((8) (let ((e-17 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-25 (vector-ref arg-6 16))) (let ((e-24 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 (box e-17) e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-25 e-24 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((9) (let ((e-19 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-25 (vector-ref arg-6 18))) (let ((e-24 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 (box e-19) e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-25 e-24 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((10) (let ((e-20 (vector-ref arg-5 1))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-24 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-20 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-24 e-21 e-22 e-23))))))))))))))))))))))))))) ((11) (let ((e-21 (vector-ref arg-5 1))) (let ((act-24 (let ((act-24 (set-box! arg-3 e-21))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 arg-6)))))) ((12) (let ((e-22 (vector-ref arg-5 1))) (let ((e-23 (vector-ref arg-5 2))) (let ((act-24 (let ((act-24 (set-box! arg-4 (box (cons e-22 e-23))))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 arg-6))))))) ((13) (let ((e-24 (vector-ref arg-5 1))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (box e-24) e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((14) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 (box (cons e-25 e-26)) e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))))))) ((15) (let ((e-28 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 (box e-28) e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((16) (let ((e-30 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 (box e-30) e-17 e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((17) (let ((e-32 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (box e-32) e-18 e-19 e-20 e-21 e-22 e-23))))))))))))))))))))))))))) ((18) (let ((e-33 (vector-ref arg-5 1))) (let ((e-34 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (box (cons e-33 e-34)) e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))))))) ((19) (let ((e-35 (vector-ref arg-5 1))) (let ((e-36 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 (box (cons e-35 e-36)) e-20 e-21 e-22 e-23)))))))))))))))))))))))))))) ((20) (let ((e-37 (vector-ref arg-5 1))) (let ((e-38 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 (box (cons e-37 e-38)) e-21 e-22 e-23)))))))))))))))))))))))))))) ((21) (let ((e-39 (vector-ref arg-5 1))) (let ((e-40 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 (box (cons e-39 e-40)) e-22 e-23)))))))))))))))))))))))))))) ((22) (let ((e-41 (vector-ref arg-5 1))) (let ((e-42 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 (box (cons e-41 e-42)) e-23)))))))))))))))))))))))))))) (else (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 (box (cons e-43 e-44)))))))))))))))))))))))))))))))))
(define IdrisC-45Package-addDeps (lambda (arg-0 arg-1 ext-0) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (CoreC-45Core-traverse_ (lambda (u--p) (lambda (eta-0) (IdrisC-45SetOptions-addPkgDir arg-0 (let ((e-0 (car u--p))) e-0) (let ((e-1 (cdr u--p))) e-1) eta-0))) (let ((e-10 (vector-ref arg-1 10))) e-10) ext-0))))))
(define IdrisC-45PackageC-45Init-case--interactiveC-44mstring-2772 (lambda (arg-0 arg-1) (cond ((equal? arg-1 "") '())(else (box arg-1)))))
(define IdrisC-45PackageC-45Init-case--isModuleIdent-2468 (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((sc1 (PreludeC-45Types-isUpper e-2))) (cond ((equal? sc1 1) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (PreludeC-45Types-isAlphaNum eta-0)) arg-1)) (else 0)))))))
(define IdrisC-45PackageC-45Init-n--4495-2486-u--validFile (lambda (arg-0 arg-1 arg-2) (let ((sc0 (LibrariesC-45UtilsC-45Path-splitFileName (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName arg-2)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (IdrisC-45PackageC-45Init-isModuleIdent e-2))) (cond ((equal? sc1 1) (PreludeC-45Types-elem (csegen-17) e-3 (cons "idr" (cons "lidr" '())))) (else 0))))))))
(define IdrisC-45PackageC-45Init-n--4495-2487-u--validDirectory (lambda (arg-0 arg-1 ext-0) (IdrisC-45PackageC-45Init-isModuleIdent (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName ext-0))))
(define IdrisC-45PackageC-45Init-n--4783-2767-u--mstring (lambda (arg-0) (IdrisC-45PackageC-45Init-case--interactiveC-44mstring-2772 arg-0 (DataC-45String-trim arg-0))))
(define IdrisC-45PackageC-45Init-n--4556-2551-u--go (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (e-11 clam-0))) (let ((u--mods (PreludeC-45Basics-flip (csegen-2303) (let ((e-1 (car act-24))) e-1) (lambda (u--entry) (let ((u--fname (Builtin-fst (LibrariesC-45UtilsC-45Path-splitFileName (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName u--entry))))) (let ((u--mod (CoreC-45NameC-45Namespace-unsafeFoldModuleIdent (cons u--fname e-6)))) (let ((u--fp (LibrariesC-45SystemC-45DirectoryC-45Tree-toFilePath e-10 u--entry))) (cons u--mod u--fp)))))))) (let ((u--dirs (PreludeC-45Basics-flip (csegen-2303) (let ((e-4 (cdr act-24))) e-4) (lambda (lamc-0) (let ((e-5 (car lamc-0))) (let ((e-4 (cdr lamc-0))) (cons (cons (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName e-5) e-6) (cons (LibrariesC-45UtilsC-45Path-C-47C-62 e-10 (LibrariesC-45SystemC-45DirectoryC-45Tree-fileName e-5)) e-4)))))))) ((IdrisC-45PackageC-45Init-n--4556-2551-u--go arg-0 (PreludeC-45TypesC-45List-tailRecAppend u--mods arg-1) (PreludeC-45TypesC-45List-tailRecAppend u--dirs e-3)) clam-0))))))))))))))
(define IdrisC-45PackageC-45Init-packageTree (lambda (arg-0) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-758) (lambda (eta-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-filter (lambda (root-2540) (lambda (eta-1) (IdrisC-45PackageC-45Init-n--4495-2486-u--validFile arg-0 root-2540 eta-1))) (lambda (root-2544) (lambda (eta-1) (IdrisC-45PackageC-45Init-n--4495-2487-u--validDirectory arg-0 root-2544 eta-1))) arg-0 eta-0)) (lambda (eta-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-explore arg-0 eta-0)))))
(define IdrisC-45PackageC-45Init-isModuleIdent (lambda (arg-0) (IdrisC-45PackageC-45Init-case--isModuleIdent-2468 arg-0 (PreludeC-45Types-fastUnpack arg-0))))
(define IdrisC-45PackageC-45Init-interactive (lambda (ext-0) (let ((act-24 ((PreludeC-45Interfaces-C-42C-62 (csegen-5) (PreludeC-45IO-putStr (csegen-3) "Package name: ") (csegen-1268)) ext-0))) (let ((act-25 ((PreludeC-45Interfaces-C-42C-62 (csegen-5) (PreludeC-45IO-putStr (csegen-3) "Package authors: ") (csegen-1268)) ext-0))) (let ((act-26 ((PreludeC-45Interfaces-C-42C-62 (csegen-5) (PreludeC-45IO-putStr (csegen-3) "Package options: ") (csegen-1268)) ext-0))) (let ((act-27 ((PreludeC-45Interfaces-C-42C-62 (csegen-5) (PreludeC-45IO-putStr (csegen-3) "Source directory: ") (csegen-1268)) ext-0))) (let ((u--sourcedir (IdrisC-45PackageC-45Init-n--4783-2767-u--mstring act-27))) (let ((act-28 (IdrisC-45PackageC-45Init-findModules u--sourcedir ext-0))) (let ((u--pkg (let ((sc0 (IdrisC-45PackageC-45Types-initPkgDesc (DataC-45Maybe-fromMaybe (lambda () "project") (IdrisC-45PackageC-45Init-n--4783-2767-u--mstring act-24))))) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-3 (vector-ref sc0 3))) (let ((e-4 (vector-ref sc0 4))) (let ((e-5 (vector-ref sc0 5))) (let ((e-6 (vector-ref sc0 6))) (let ((e-7 (vector-ref sc0 7))) (let ((e-8 (vector-ref sc0 8))) (let ((e-9 (vector-ref sc0 9))) (let ((e-10 (vector-ref sc0 10))) (let ((e-12 (vector-ref sc0 12))) (let ((e-13 (vector-ref sc0 13))) (let ((e-16 (vector-ref sc0 16))) (let ((e-17 (vector-ref sc0 17))) (let ((e-18 (vector-ref sc0 18))) (let ((e-19 (vector-ref sc0 19))) (let ((e-20 (vector-ref sc0 20))) (let ((e-21 (vector-ref sc0 21))) (let ((e-22 (vector-ref sc0 22))) (let ((e-23 (vector-ref sc0 23))) (vector e-0 e-1 (IdrisC-45PackageC-45Init-n--4783-2767-u--mstring act-25) e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 act-28 e-12 e-13 (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (__infixTupleSection-0) (cons (CoreC-45FC-emptyFC) __infixTupleSection-0)) (IdrisC-45PackageC-45Init-n--4783-2767-u--mstring act-26)) u--sourcedir e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23)))))))))))))))))))))))) u--pkg)))))))))
(define IdrisC-45PackageC-45Init-findModules (lambda (arg-0 ext-0) (let ((act-24 ((PreludeC-45Types-maybe (lambda () (csegen-878)) (lambda () (lambda (eta-0) (lambda (eta-1) (box eta-0)))) arg-0) ext-0))) (if (null? act-24) '() (let ((e-1 (unbox act-24))) (let ((u--root (LibrariesC-45UtilsC-45Path-parse e-1))) (let ((act-25 ((IdrisC-45PackageC-45Init-packageTree u--root) ext-0))) (let ((act-26 ((IdrisC-45PackageC-45Init-n--4556-2551-u--go arg-0 '() (cons (cons '() (cons u--root (lambda (eta-0) act-25))) '())) ext-0))) (DataC-45List-sortBy (lambda (u--a) (lambda (u--b) (PreludeC-45EqOrd-u--compare_Ord_String (Builtin-snd u--a) (Builtin-snd u--b)))) act-26)))))))))
(define IdrisC-45DocC-45HTML-with--tryCanonicalName-2541 (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (cond ((equal? arg-1 1) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName arg-0 (let ((e-0 (vector-ref e-5 0))) e-0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 '()) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (vector 1 '()) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-7) (vector 1 '()) (if (null? e-2) (vector 1 (box e-8)) (vector 1 '())))))))))))))))))) (else (vector 1 '())))))
(define IdrisC-45DocC-45HTML-n--7926-3125-u--moduleLink (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (PreludeC-45TypesC-45String-C-43C-43 "<li><a class=\"code\" href=\"docs/" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-2) (PreludeC-45TypesC-45String-C-43C-43 ".html\">" (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-2) "</a></li>")))))))
(define IdrisC-45DocC-45HTML-n--7806-3009-u--go (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (case (vector-ref arg-1 0) ((3) arg-1)(else (case (vector-ref arg-1 0) ((5) (let ((e-1 (vector-ref arg-1 1))) (vector 5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45DocC-45HTML-n--7806-3009-u--go arg-0 eta-0)) e-1)))) ((4) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (case (vector-ref e-3 0) ((1) (vector 4 (vector 1 ) (IdrisC-45DocC-45HTML-n--7806-3009-u--go 1 e-4)))(else (vector 4 e-3 (IdrisC-45DocC-45HTML-n--7806-3009-u--go 0 e-4)))))))(else arg-1))))) ((equal? arg-0 1) (case (vector-ref arg-1 0) ((3) (vector 0 ))(else (case (vector-ref arg-1 0) ((5) (let ((e-1 (vector-ref arg-1 1))) (vector 5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45DocC-45HTML-n--7806-3009-u--go arg-0 eta-0)) e-1)))) ((4) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (case (vector-ref e-3 0) ((1) (vector 4 (vector 1 ) (IdrisC-45DocC-45HTML-n--7806-3009-u--go 1 e-4)))(else (vector 4 e-3 (IdrisC-45DocC-45HTML-n--7806-3009-u--go 0 e-4)))))))(else arg-1)))))(else (case (vector-ref arg-1 0) ((5) (let ((e-1 (vector-ref arg-1 1))) (vector 5 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45DocC-45HTML-n--7806-3009-u--go arg-0 eta-0)) e-1)))) ((4) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (case (vector-ref e-3 0) ((1) (vector 4 (vector 1 ) (IdrisC-45DocC-45HTML-n--7806-3009-u--go 1 e-4)))(else (vector 4 e-3 (IdrisC-45DocC-45HTML-n--7806-3009-u--go 0 e-4)))))))(else arg-1))))))
(define IdrisC-45DocC-45HTML-tryCanonicalName (lambda (arg-0 arg-1 arg-2) (lambda (eta-0) (IdrisC-45DocC-45HTML-with--tryCanonicalName-2541 arg-2 (IdrisC-45DocC-45HTML-hasNS arg-2) arg-1 arg-0 eta-0))))
(define IdrisC-45DocC-45HTML-renderModuleDoc (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--mdoc (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-0) (IdrisC-45DocC-45HTML-preserveLayout (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape eta-0)))) arg-2))) (lambda (eta-0) (let ((act-24 ((IdrisC-45DocC-45HTML-docDocToHtml arg-0 arg-3) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-fastConcat (cons (IdrisC-45DocC-45HTML-htmlPreamble (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1) "../" "namespace") (cons "<div id=\"moduleHeader\">" (cons "<h1>" (cons (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1) (cons "</h1>" (cons u--mdoc (cons "</div>" (cons e-5 (cons (IdrisC-45DocC-45HTML-htmlFooter) '())))))))))))))))))))
(define IdrisC-45DocC-45HTML-renderHtml (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 (PreludeC-45Types-u--neutral_Monoid_String)))) ((1) (let ((e-2 (vector-ref arg-1 1))) (lambda (clam-0) (cond ((equal? e-2 #\ ) (vector 1 "&ensp;"))(else (vector 1 (PreludeC-45Cast-u--cast_Cast_Char_String e-2))))))) ((2) (let ((e-5 (vector-ref arg-1 2))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape e-5))))) ((3) (lambda (eta-0) (vector 1 "<br>"))) ((4) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (lambda (clam-0) (case (vector-ref e-9 0) ((1) (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "<dl class=\"decls\">" e-5) "</dl>"))))))) ((2) (let ((e-13 (vector-ref e-9 1))) (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "<dt id=\"" (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (CoreC-45Name-u--show_Show_Name e-13)) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "\">" e-5) "</dt>")))))))))) ((3) (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "<dd>" e-5) "</dd>"))))))) ((4) (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "<pre>" e-5) "</pre>"))))))) ((5) (let ((e-14 (vector-ref e-9 1))) (case (vector-ref e-14 0) ((2) (let ((e-15 (vector-ref e-14 1))) (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45DocC-45HTML-addLink arg-0 e-15 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "<span class=\"name constructor\">" e-5) "</span>") clam-0))))))) ((1) (let ((e-16 (vector-ref e-14 1))) (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45DocC-45HTML-addLink arg-0 e-16 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "<span class=\"name type\">" e-5) "</span>") clam-0))))))) ((3) (let ((e-17 (vector-ref e-14 1))) (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45DocC-45HTML-addLink arg-0 (box e-17) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "<span class=\"name function\">" e-5) "</span>") clam-0)))))))(else (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "<!-- ann ignored START -->" (PreludeC-45TypesC-45String-C-43C-43 e-5 "<!-- ann END -->"))))))))))) ((0) (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "<b>" e-5) "</b>")))))))(else (let ((act-24 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "<!-- ann ignored START -->" (PreludeC-45TypesC-45String-C-43C-43 e-5 "<!-- ann END -->"))))))))))))) (else (let ((e-12 (vector-ref arg-1 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45DocC-45HTML-renderHtml arg-0 eta-1)) e-12 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (PreludeC-45Types-fastConcat e-5))))))))))))
(define IdrisC-45DocC-45HTML-renderDocIndex (lambda (arg-0) (PreludeC-45Types-fastConcat (PreludeC-45TypesC-45List-tailRecAppend (cons (IdrisC-45DocC-45HTML-htmlPreamble (let ((e-0 (vector-ref arg-0 0))) e-0) "" "index") (cons "<h1>Package " (cons (let ((e-0 (vector-ref arg-0 0))) e-0) (cons " - Namespaces</h1>" (cons "<ul class=\"names\">" '()))))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45DocC-45HTML-n--7926-3125-u--moduleLink arg-0 eta-0)) (let ((e-11 (vector-ref arg-0 11))) e-11)) (cons "</ul>" (cons (IdrisC-45DocC-45HTML-htmlFooter) '())))))))
(define IdrisC-45DocC-45HTML-removeNewlinesFromDeclarations (lambda (ext-0) (IdrisC-45DocC-45HTML-n--7806-3009-u--go 0 ext-0)))
(define IdrisC-45DocC-45HTML-preserveLayout (lambda (arg-0) (PreludeC-45TypesC-45String-C-43C-43 "<pre>" (PreludeC-45TypesC-45String-C-43C-43 arg-0 "</pre>"))))
(define IdrisC-45DocC-45HTML-packageInternal (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((u--mi (CoreC-45NameC-45Namespace-nsAsModuleIdent e-0))) (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (vector 1 1)))) (lambda (eta-2) (CoreC-45Directory-nsToSource arg-0 (CoreC-45FC-emptyFC) u--mi eta-2)) eta-1)) (lambda (_-2617) (lambda (eta-1) (vector 1 0))) eta-0)))))(else (lambda (eta-0) (vector 1 0))))))
(define IdrisC-45DocC-45HTML-htmlPreamble (lambda (arg-0 arg-1 arg-2) (let ((u--title (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape arg-0))) (let ((u--cssID "preferredStyle")) (let ((u--cssSelectID "selectPreferredStyle")) (let ((u--cssDefault "default")) (let ((u--cssLocalKey "stylefile")) (PreludeC-45TypesC-45String-C-43C-43 "<!DOCTYPE html><html lang=\"en\">\xa;<head>\xa;  <meta charset=\"utf-8\">\xa;  <title>" (PreludeC-45TypesC-45String-C-43C-43 u--title (PreludeC-45TypesC-45String-C-43C-43 "</title>\xa;  <link rel=\"stylesheet\" type=\"text/css\" id=\"" (PreludeC-45TypesC-45String-C-43C-43 u--cssID (PreludeC-45TypesC-45String-C-43C-43 "\" href=\"" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 u--cssDefault (PreludeC-45TypesC-45String-C-43C-43 ".css\">\xa;  <script>\xa;    /* Updates the stylesheet to use the preferred one.\xa;       Note that we set the link to root ++ sourceLoc because the config\xa;       is shared across the whole website, so the root may differ from\xa;       page to page.\xa;    */\xa;    function setStyleSource (sourceLoc) {\xa;      document.getElementById(\"" (PreludeC-45TypesC-45String-C-43C-43 u--cssID (PreludeC-45TypesC-45String-C-43C-43 "\").href = \"" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "\" + sourceLoc + \".css\";\xa;      document.getElementById(\"" (PreludeC-45TypesC-45String-C-43C-43 u--cssSelectID (PreludeC-45TypesC-45String-C-43C-43 "\").value = sourceLoc;\xa;    }\xa;    /* Initialises the preferred style sheet:\xa;       1. if there is a stored value then use that\xa;          otherwise select the default\xa;       2. set both the css link href & the drop down menu selected option\xa;    */\xa;    function initStyleSource () {\xa;      var preferredStyle = localStorage.getItem(\"" (PreludeC-45TypesC-45String-C-43C-43 u--cssLocalKey (PreludeC-45TypesC-45String-C-43C-43 "\");\xa;      if (preferredStyle !== null) {\xa;        setStyleSource(preferredStyle);\xa;      } else {\xa;        setStyleSource(\"" (PreludeC-45TypesC-45String-C-43C-43 u--cssDefault (PreludeC-45TypesC-45String-C-43C-43 "\");\xa;      };\xa;    }\xa;    function saveStyleSource (preferredStyle) {\xa;      localStorage." (PreludeC-45TypesC-45String-C-43C-43 u--cssLocalKey (PreludeC-45TypesC-45String-C-43C-43 " = preferredStyle;\xa;    }\xa;    </script>\xa;</head>\xa;<body class=\"" (PreludeC-45TypesC-45String-C-43C-43 arg-2 (PreludeC-45TypesC-45String-C-43C-43 "\">\xa;<header>\xa;  <strong>Idris2Doc</strong> : " (PreludeC-45TypesC-45String-C-43C-43 u--title (PreludeC-45TypesC-45String-C-43C-43 "\xa;  <nav><a href=\"" (PreludeC-45TypesC-45String-C-43C-43 arg-1 (PreludeC-45TypesC-45String-C-43C-43 "index.html\">Index</a>\xa;  <select id=\"" (PreludeC-45TypesC-45String-C-43C-43 u--cssSelectID (PreludeC-45TypesC-45String-C-43C-43 "\">\xa;    " (PreludeC-45TypesC-45String-C-43C-43 (DataC-45String-fastUnlines (PreludeC-45Basics-flip (csegen-2303) (IdrisC-45PackageC-45Types-cssFiles) (lambda (u--css) (PreludeC-45TypesC-45String-C-43C-43 "<option value=\"" (PreludeC-45TypesC-45String-C-43C-43 (let ((e-1 (cdr u--css))) e-1) (PreludeC-45TypesC-45String-C-43C-43 "\">" (PreludeC-45TypesC-45String-C-43C-43 (let ((e-0 (car u--css))) e-0) "</option>"))))))) (PreludeC-45TypesC-45String-C-43C-43 "\xa;  </select>\xa;  </nav>\xa;  <script>\xa;  /* We start by initialising the style source */\xa;  initStyleSource();\xa;  /* This listens for changes on the drop down menu and updates the\xa;     css used for the current page when a selection is made.\xa;  */\xa;  document.getElementById(\"" (PreludeC-45TypesC-45String-C-43C-43 u--cssSelectID "\").addEventListener(\"change\", function(){\xa;    var selected = this.options[this.selectedIndex].value; /* the option chosen */\xa;    setStyleSource (selected);\xa;    saveStyleSource (selected);\xa;  });\xa;</script>\xa;</header>\xa;<div class=\"container\">"))))))))))))))))))))))))))))))))))))))
(define IdrisC-45DocC-45HTML-htmlFooter(blodwen-lazy (lambda () (PreludeC-45TypesC-45String-C-43C-43 "</div><footer>Produced by Idris 2 version " (PreludeC-45TypesC-45String-C-43C-43 (LibrariesC-45DataC-45Version-showVersion 1 (IdrisC-45Version-version)) "</footer></body></html>")))))
(define IdrisC-45DocC-45HTML-hasNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 1)(else 0))))
(define IdrisC-45DocC-45HTML-getNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0)))(else ""))))
(define IdrisC-45DocC-45HTML-docDocToHtml (lambda (arg-0 arg-1) (let ((u--dt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-fromStream (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutUnbounded arg-1)))) (IdrisC-45DocC-45HTML-renderHtml arg-0 (IdrisC-45DocC-45HTML-removeNewlinesFromDeclarations u--dt)))))
(define IdrisC-45DocC-45HTML-addLink (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-1) (vector 1 arg-2) (let ((e-2 (unbox arg-1))) (let ((act-24 ((IdrisC-45DocC-45HTML-tryCanonicalName arg-0 (CoreC-45FC-emptyFC) e-2) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (if (null? e-5) (vector 1 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String (PreludeC-45Types-u--C-60C-43C-62_Semigroup_String "<span class=\"implicit\">" arg-2) "</span>")) (let ((e-1 (unbox e-5))) (let ((act-25 ((IdrisC-45DocC-45HTML-packageInternal arg-0 e-1) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (cond ((equal? e-6 1) (vector 1 (PreludeC-45Types-fastConcat (cons "<a class=\"type\" href=\"" (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (IdrisC-45DocC-45HTML-getNS e-1)) (cons ".html#" (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (CoreC-45Name-u--show_Show_Name e-1)) (cons "\">" (cons arg-2 (cons "</a>" '())))))))))) (else (vector 1 (PreludeC-45Types-fastConcat (cons "<span class=\"type resolved\" title=\"" (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (CoreC-45Name-u--show_Show_Name e-1)) (cons "\">" (cons arg-2 (cons "</span>" '())))))))))))))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-case--fromStreamC-44flatten-1120 (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((5) (let ((e-1 (vector-ref arg-4 1))) (vector 5 (cons arg-2 e-1))))(else (vector 5 (cons arg-2 (cons arg-4 '())))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-case--sdocToTreeParser-912 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (cons '() '()) (if (null? e-2) (if (null? e-3) (cons '() '()) (let ((e-11 (unbox e-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser e-11))) (let ((e-5 (unbox e-2))) (if (null? e-3) (cons (box (vector 4 arg-1 e-5)) '()) (let ((e-9 (unbox e-3))) (let ((sc4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser e-9))) (let ((e-6 (car sc4))) (let ((e-4 (cdr sc4))) (if (null? e-6) (cons (box (vector 4 arg-1 e-5)) e-4) (let ((e-7 (unbox e-6))) (cons (box (vector 5 (cons (vector 4 arg-1 e-5) (cons e-7 '())))) e-4)))))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4133-1092-u--internalError (lambda (arg-1) (let ((u--msg "<internal pretty printing error>")) (vector 2 (PreludeC-45Cast-u--cast_Cast_Nat_Int (PreludeC-45TypesC-45String-length u--msg)) u--msg))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4133-1091-u--flatten (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((5) (let ((e-1 (vector-ref arg-2 1))) (if (null? e-1) arg-2 (let ((e-3 (car e-1))) (let ((e-4 (cdr e-1))) (if (null? e-4) arg-2 (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (case (vector-ref e-6 0) ((0) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4133-1091-u--flatten arg-1 e-3) arg-2)) ((5) (let ((e-10 (vector-ref e-6 1))) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-case--fromStreamC-44flatten-1120 arg-1 e-3 e-10 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4133-1091-u--flatten arg-1 (vector 5 e-10))) arg-2)))(else arg-2))))))))))(else arg-2))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (cons (box (vector 0 )) '())) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((sc1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser (e-3)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (if (null? e-5) (cons (box (vector 1 e-2)) e-4) (let ((e-6 (unbox e-5))) (cons (box (vector 5 (cons (vector 1 e-2) (cons e-6 '())))) e-4))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((sc1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser (e-7)))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (if (null? e-2) (cons (box (vector 2 e-5 e-6)) e-3) (let ((e-8 (unbox e-2))) (cons (box (vector 5 (cons (vector 2 e-5 e-6) (cons e-8 '())))) e-3)))))))))) ((3) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (let ((sc1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser e-10))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (if (null? e-2) (cons (box (vector 3 e-9)) e-3) (let ((e-5 (unbox e-2))) (cons (box (vector 5 (cons (vector 3 e-9) (cons e-5 '())))) e-3))))))))) ((4) (let ((e-12 (vector-ref arg-1 1))) (let ((e-13 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-case--sdocToTreeParser-912 e-12 e-13 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser e-13))))) (else (let ((e-15 (vector-ref arg-1 1))) (cons '() (box e-15)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-fromStream (lambda (arg-1) (let ((sc0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser arg-1))) (if (null? sc0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4133-1092-u--internalError arg-1) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4133-1092-u--internalError arg-1) (let ((e-5 (unbox e-2))) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4133-1091-u--flatten arg-1 e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4133-1092-u--internalError arg-1))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-case--htmlEscapeC-44go-3878 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cond ((equal? e-3 "") (cons e-2 arg-2))(else (let ((u--c (DataC-45String-strIndex e-3 0))) (let ((u--escaped (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--2831-3796-u--htmlQuote arg-0 u--c))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--2831-3797-u--go arg-0 (cons u--escaped (cons e-2 arg-2)) (DataC-45String-strTail e-3))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--2831-3795-u--isSafe (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\") 0) ((equal? arg-1 #\<) 0) ((equal? arg-1 #\>) 0) ((equal? arg-1 #\&) 0) ((equal? arg-1 #\') 0) ((equal? arg-1 (integer->char 9)) 1) ((equal? arg-1 (integer->char 10)) 1) ((equal? arg-1 (integer->char 13)) 1)(else (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-1 #\ ))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-1 #\~)) (else 0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--2831-3796-u--htmlQuote (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\") "&quot;") ((equal? arg-1 #\<) "&lt;") ((equal? arg-1 #\>) "&gt;") ((equal? arg-1 #\&) "&amp;") ((equal? arg-1 #\') "&apos;")(else (PreludeC-45TypesC-45String-C-43C-43 "&#" (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_Int (PreludeC-45Types-ord arg-1)) ";"))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--2831-3797-u--go (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-2 "") arg-1)(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-case--htmlEscapeC-44go-3878 arg-0 arg-2 arg-1 (DataC-45String-span (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--2831-3795-u--isSafe arg-0 eta-0)) arg-2))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (lambda (arg-0) (DataC-45String-fastAppend (PreludeC-45TypesC-45List-reverse (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--2831-3797-u--go arg-0 '() arg-0)))))
(define ParserC-45Package-runParser (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (ParserC-45LexerC-45Package-lex arg-2))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromLexError (vector 1 arg-1) (cons (vector 1 ) e-2))))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (u--toks) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-parse 1 arg-3 u--toks))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromParsingErrors (cons (cons (lambda (u--x) (ParserC-45LexerC-45Package-u--show_Show_Token u--x)) (lambda (u--d) (lambda (u--x) (ParserC-45LexerC-45Package-u--showPrec_Show_Token u--d u--x)))) (cons (lambda (u--ann) (lambda (arg-5185) (ParserC-45LexerC-45Package-u--pretty_Pretty_Token arg-5185))) (lambda (u--ann) (lambda (arg-5186) (lambda (arg-5187) (ParserC-45LexerC-45Package-u--prettyPrec_Pretty_Token arg-5186 arg-5187)))))) (vector 1 arg-1) e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (_-0) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (vector 1 e-6)))))))))
(define ParserC-45Package-parseFile (lambda (arg-1 arg-2 ext-0) (let ((act-24 ((SystemC-45FileC-45ReadWrite-readFile (csegen-3) arg-1) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) (ParserC-45Package-runParser arg-1 e-2 arg-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 0 (vector 49 arg-1 e-5))))))))
(define ParserC-45RuleC-45Package-stringLit(blodwen-lazy (lambda () (vector 1 "Expected string" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((13) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))))
(define ParserC-45RuleC-45Package-sepC-39(blodwen-lazy (lambda () (vector 1 "Expected separator" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((4) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-sep (lambda (arg-1) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-352) (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Package-sepC-39) arg-1))))
(define ParserC-45RuleC-45Package-packageName(blodwen-lazy (lambda () (vector 1 "Expected package name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (if (null? e-0) (let ((sc2 (let ((sc3 (PreludeC-45Types-fastUnpack e-1))) (if (null? sc3) 0 (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (let ((sc4 (ParserC-45LexerC-45Common-isIdentStart 0 e-2))) (cond ((equal? sc4 1) (PreludeC-45Interfaces-all (csegen-51) (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentTrailing 0 eta-0)) e-3)) (else 0))))))))) (cond ((equal? sc2 1) (box e-1)) (else '()))) '()))))(else '())))))))
(define ParserC-45RuleC-45Package-moduleIdent(blodwen-lazy (lambda () (vector 1 "Expected module identifier" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (box (CoreC-45NameC-45Namespace-nsAsModuleIdent (CoreC-45NameC-45Namespace-mkNestedNamespace e-0 e-1))))))(else '())))))))
(define ParserC-45RuleC-45Package-lte(blodwen-lazy (lambda () (vector 1 "Expected <=" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((6) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-lt(blodwen-lazy (lambda () (vector 1 "Expected <=" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((8) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-integerLit(blodwen-lazy (lambda () (vector 1 "Expected integer" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((14) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))))
(define ParserC-45RuleC-45Package-gte(blodwen-lazy (lambda () (vector 1 "Expected >=" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((7) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-gt(blodwen-lazy (lambda () (vector 1 "Expected >=" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-exactProperty (lambda (arg-0) (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Expected property " arg-0) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (if (null? e-0) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-0 e-1))) (cond ((equal? sc2 1) (box arg-0)) (else '()))) '()))))(else '()))))))
(define ParserC-45RuleC-45Package-equals(blodwen-lazy (lambda () (vector 1 "Expected equals" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((2) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-eqop(blodwen-lazy (lambda () (vector 1 "Expected ==" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((10) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-eoi(blodwen-lazy (lambda () (vector 1 "Expected end of input" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((1) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-dotC-39(blodwen-lazy (lambda () (vector 1 "Expected dot" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((5) (box 0))(else '())))))))
(define ParserC-45RuleC-45Package-andop(blodwen-lazy (lambda () (vector 1 "Expected &&" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((11) (box 0))(else '())))))))
(define ParserC-45LexerC-45Package-case--lex-5432 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (vector 0 e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (if (null? e-7) (vector 0 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cond ((equal? e-11 "") (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-filter (lambda (eta-0) (ParserC-45LexerC-45Package-n--4499-5418-u--useful arg-0 (let ((e-1 (vector-ref eta-0 0))) e-1))) e-2) (cons (vector (vector 1 ) 0 (vector e-6 e-10 e-6 e-10)) '()))))(else (vector 0 e-3)))))))))))))
(define ParserC-45LexerC-45Package-n--4499-5418-u--useful (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) 0) ((12) 0)(else 1))))
(define ParserC-45LexerC-45Package-u--show_Show_Token (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "Comment: " e-0))) ((1) "EndOfInput") ((2) "Equals") ((3) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (PreludeC-45TypesC-45String-C-43C-43 "DotSepIdentifier: " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-3209) e-1) (PreludeC-45TypesC-45String-C-43C-43 "." (PreludeC-45Show-u--show_Show_String e-2))))))) ((4) "Separator") ((5) "Dot") ((6) "LTE") ((7) "GTE") ((8) "LT") ((9) "GT") ((10) "EqOp") ((11) "AndOp") ((12) "Space") ((13) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "StringLit: " e-3))) (else (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45TypesC-45String-C-43C-43 "IntegerLit: " (PreludeC-45Show-u--show_Show_Integer e-4)))))))
(define ParserC-45LexerC-45Package-u--showPrec_Show_Token (lambda (arg-0 arg-1) (ParserC-45LexerC-45Package-u--show_Show_Token arg-1)))
(define ParserC-45LexerC-45Package-u--pretty_Pretty_Token (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Comment:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-0)))) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "EndOfInput"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "EndOfInput")) (else "EndOfInput")))))))) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Equals"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Equals")) (else "Equals")))))))) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "DotSepIdentifier:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_C-40MaybeC-32C-36aC-41 (cons (lambda (u--ann) (lambda (arg-5185) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Namespace arg-5185))) (lambda (u--ann) (lambda (arg-5186) (lambda (arg-5187) (CoreC-45NameC-45Namespace-u--prettyPrec_Pretty_Namespace arg-5186 arg-5187))))) e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-2)))))) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Separator"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Separator")) (else "Separator")))))))) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Dot"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Dot")) (else "Dot")))))))) ((6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "LTE"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "LTE")) (else "LTE")))))))) ((7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "GTE"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "GTE")) (else "GTE")))))))) ((8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "LT"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "LT")) (else "LT")))))))) ((9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "GT"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "GT")) (else "GT")))))))) ((10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "EqOp"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "EqOp")) (else "EqOp")))))))) ((11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "AndOp"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "AndOp")) (else "AndOp")))))))) ((12) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45List1-forget (LibrariesC-45DataC-45StringC-45Extra-lines (let ((sc1 (DataC-45String-isSuffixOf "\xa;" "Space"))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast (+ 1 0) "Space")) (else "Space")))))))) ((13) (let ((e-3 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "StringLit:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-3)))) (else (let ((e-4 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "IntegerLit:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Integer e-4)))))))
(define ParserC-45LexerC-45Package-u--prettyPrec_Pretty_Token (lambda (arg-1 arg-2) (ParserC-45LexerC-45Package-u--pretty_Pretty_Token arg-2)))
(define ParserC-45LexerC-45Package-separator(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-is #\,))))
(define ParserC-45LexerC-45Package-rawTokens(blodwen-lazy (lambda () (cons (cons (ParserC-45LexerC-45Common-comment) (lambda (eta-0) (vector 0 (LibrariesC-45DataC-45StringC-45Extra-drop (+ 1 (+ 1 0)) eta-0)))) (cons (cons (ParserC-45LexerC-45Common-namespacedIdent) (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (vector 3 eta-1 eta-2))) (CoreC-45NameC-45Namespace-mkNamespacedIdent eta-0)))) (cons (cons (ParserC-45LexerC-45Common-identAllowDashes) (lambda (eta-0) (vector 3 '() eta-0))) (cons (cons (ParserC-45LexerC-45Package-separator) (lambda (eta-0) (vector 4 ))) (cons (cons (ParserC-45LexerC-45Package-dot) (lambda (eta-0) (vector 5 ))) (cons (cons (ParserC-45LexerC-45Package-lte) (lambda (eta-0) (vector 6 ))) (cons (cons (ParserC-45LexerC-45Package-gte) (lambda (eta-0) (vector 7 ))) (cons (cons (ParserC-45LexerC-45Package-lt) (lambda (eta-0) (vector 8 ))) (cons (cons (ParserC-45LexerC-45Package-gt) (lambda (eta-0) (vector 9 ))) (cons (cons (ParserC-45LexerC-45Package-eqop) (lambda (eta-0) (vector 10 ))) (cons (cons (ParserC-45LexerC-45Package-andop) (lambda (eta-0) (vector 11 ))) (cons (cons (ParserC-45LexerC-45Package-equals) (lambda (eta-0) (vector 2 ))) (cons (cons (ParserC-45LexerC-45Common-spacesOrNewlines) (lambda (eta-0) (vector 12 ))) (cons (cons (LibrariesC-45TextC-45Lexer-stringLit) (lambda (u--s) (vector 13 (LibrariesC-45UtilsC-45String-stripQuotes u--s)))) (cons (cons (LibrariesC-45TextC-45Lexer-intLit) (lambda (u--i) (vector 14 (PreludeC-45Cast-u--cast_Cast_String_Integer u--i)))) '()))))))))))))))))))
(define ParserC-45LexerC-45Package-lte(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-is #\<) (lambda () (LibrariesC-45TextC-45Lexer-is #\=))))))
(define ParserC-45LexerC-45Package-lt(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-is #\<))))
(define ParserC-45LexerC-45Package-lex (lambda (arg-0) (ParserC-45LexerC-45Package-case--lex-5432 arg-0 (LibrariesC-45TextC-45LexerC-45Core-lexTo (lambda (eta-0) 0) (ParserC-45LexerC-45Package-rawTokens) arg-0))))
(define ParserC-45LexerC-45Package-gte(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-is #\>) (lambda () (LibrariesC-45TextC-45Lexer-is #\=))))))
(define ParserC-45LexerC-45Package-gt(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-is #\>))))
(define ParserC-45LexerC-45Package-equals(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-is #\=))))
(define ParserC-45LexerC-45Package-eqop(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-is #\=) (lambda () (LibrariesC-45TextC-45Lexer-is #\=))))))
(define ParserC-45LexerC-45Package-dot(blodwen-lazy (lambda () (LibrariesC-45TextC-45Lexer-is #\.))))
(define ParserC-45LexerC-45Package-andop(blodwen-lazy (lambda () (vector 4 (LibrariesC-45TextC-45Lexer-is #\&) (lambda () (LibrariesC-45TextC-45Lexer-is #\&))))))
(define IdrisC-45IDEModeC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32loop-6804 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (if (null? arg-12) (let ((act-24 (IdrisC-45IDEModeC-45REPL-printIDEError arg-0 arg-4 arg-5 arg-7 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Unrecognised command:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (IdrisC-45IDEModeC-45Commands-u--show_Show_SExp arg-11))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (IdrisC-45IDEModeC-45REPL-loop arg-4 arg-3 arg-2 arg-1 arg-0 clam-0)))) (let ((e-1 (unbox arg-12))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-24 (IdrisC-45IDEModeC-45REPL-n--18753-6583-u--updateOutput arg-0 arg-1 arg-2 arg-3 arg-4 e-6 clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 (IdrisC-45IDEModeC-45REPL-processCatch arg-4 arg-3 arg-2 arg-1 arg-0 e-5 clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-25 1))) (let ((act-26 ((IdrisC-45IDEModeC-45REPL-handleIDEResult arg-4 arg-3 arg-2 arg-1 arg-0 arg-5 e-6 e-8) clam-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (IdrisC-45IDEModeC-45REPL-loop arg-4 arg-3 arg-2 arg-1 arg-0 clam-0))))))))))))))))))
(define IdrisC-45IDEModeC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32loop-6728 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-2 (vector-ref arg-11 1))) (lambda (eta-0) (let ((act-24 (let ((act-24 ((IdrisC-45Error-perror arg-4 arg-2 arg-0 e-2) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45IDEModeC-45REPL-printIDEError arg-0 arg-4 arg-5 arg-7 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Parse error:") e-5) eta-0))))))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (IdrisC-45IDEModeC-45REPL-loop arg-4 arg-3 arg-2 arg-1 arg-0 eta-0))))))) (else (let ((e-5 (vector-ref arg-11 1))) (IdrisC-45IDEModeC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32loop-6804 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5 (IdrisC-45IDEModeC-45Commands-getMsg e-5)))))))
(define IdrisC-45IDEModeC-45REPL-n--17772-5966-u--versionSExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (vector 0 (cons (IdrisC-45IDEModeC-45REPL-n--17772-5964-u--semverSexp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (cons (IdrisC-45IDEModeC-45REPL-n--17772-5965-u--tagSexp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) '())))))
(define IdrisC-45IDEModeC-45REPL-n--18753-6583-u--updateOutput (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (IdrisC-45REPLC-45Opts-getOutput arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((0) (let ((e-1 (vector-ref e-5 2))) (let ((e-2 (vector-ref e-5 3))) (IdrisC-45REPLC-45Opts-setOutput arg-0 (vector 0 arg-5 e-1 e-2) ext-0))))(else (vector 1 0)))))))))
(define IdrisC-45IDEModeC-45REPL-n--17772-5965-u--tagSexp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (cdr arg-0))) (if (null? e-1) (vector 0 (cons (vector 1 "") '())) (let ((e-2 (unbox e-1))) (vector 0 (cons (vector 1 e-2) '())))))))
(define IdrisC-45IDEModeC-45REPL-n--17772-6235-u--sexpOriginDesc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((e-0 (vector-ref arg-8 1))) (let ((act-24 (let ((act-24 (unbox arg-7))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--wdir (let ((e-4 (vector-ref e-5 4))) (let ((e-42 (vector-ref e-4 0))) (let ((e-52 (vector-ref e-42 0))) e-52))))) (let ((u--pkg_dirs (DataC-45List-filter (lambda (arg-9) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-9 ".")) (let ((e-4 (vector-ref e-5 4))) (let ((e-42 (vector-ref e-4 0))) (let ((e-46 (vector-ref e-42 6))) e-46)))))) (let ((u--exts (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (CoreC-45Directory-u--show_Show_IdrSrcExt eta-0)) (CoreC-45Directory-listOfExtensions)))) (let ((act-25 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (box (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--wdir e-6))))))) (lambda (eta-1) (CoreC-45Directory-nsToSource arg-7 (CoreC-45FC-replFC) e-0 eta-1)) eta-0)) (lambda (eta-0) (lambda (eta-1) (CoreC-45Directory-firstAvailable arg-7 (PreludeC-45Types-u--C-62C-62C-61_Monad_List u--pkg_dirs (lambda (u--pkg_dir) (let ((u--pkg_dir_abs (let ((sc2 (LibrariesC-45UtilsC-45Path-isRelative u--pkg_dir))) (cond ((equal? sc2 1) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--wdir u--pkg_dir)) (else u--pkg_dir))))) (PreludeC-45Types-u--C-62C-62C-61_Monad_List u--exts (lambda (u--ext) (PreludeC-45Types-u--pure_Applicative_List (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--pkg_dir_abs (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath e-0) u--ext)))))))) eta-1))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (if (null? e-6) (vector 1 "(File-Not-Found)") (let ((e-1 (unbox e-6))) (vector 1 e-1)))))))))))))))) ((1) (let ((e-1 (vector-ref arg-8 1))) (vector 1 e-1))) (else (let ((e-2 (vector-ref arg-8 1))) (cond (else (vector 1 "(Interactive)")))))))))
(define IdrisC-45IDEModeC-45REPL-n--17772-5964-u--semverSexp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-0 (car arg-0))) (let ((e-2 (car e-0))) (let ((e-3 (cdr e-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Nat eta-0)) (cons e-2 (cons e-6 (cons e-7 '()))))))))))))
(define IdrisC-45IDEModeC-45REPL-n--17772-5952-u--optionsSexp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-u--toSExp_SExpable_REPLOpt eta-0)) arg-0))))
(define IdrisC-45IDEModeC-45REPL-n--17772-6236-u--constructSExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (lambda (clam-0) (let ((e-14 (car e-10))) (let ((e-15 (cdr e-10))) (let ((e-18 (car e-11))) (let ((e-19 (cdr e-11))) (let ((act-24 (IdrisC-45Pretty-render arg-3 (CoreC-45Name-u--pretty_Pretty_Name e-2) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((IdrisC-45IDEModeC-45REPL-n--17772-6235-u--sexpOriginDesc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-25 1))) (vector 1 (vector 0 (cons (vector 1 e-5) (cons (vector 1 e-8) (cons (vector 3 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-14)) (cons (vector 3 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-15)) (cons (vector 3 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-18)) (cons (vector 3 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-19)) '())))))))))))))))))))))))))))))
(define IdrisC-45IDEModeC-45REPL-u--toSExp_SExpable_REPLOpt (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "show-implicits") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Bool e-0) '()))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "show-namespace") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Bool e-1) '()))))) ((2) (let ((e-2 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "show-types") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Bool e-2) '()))))) ((3) (let ((e-3 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "eval") (cons (IdrisC-45IDEModeC-45REPL-u--toSExp_SExpable_REPLEval e-3) '()))))) ((4) (let ((e-4 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "editor") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_String e-4) '()))))) ((5) (let ((e-5 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "cg") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_String e-5) '()))))) ((6) (let ((e-6 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "profile") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Bool e-6) '()))))) (else (let ((e-7 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "evaltiming") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Bool e-7) '()))))))))
(define IdrisC-45IDEModeC-45REPL-u--toSExp_SExpable_REPLEval (lambda (arg-0) (cond ((equal? arg-0 0) (vector 4 "typecheck")) ((equal? arg-0 1) (vector 4 "normalise")) ((equal? arg-0 2) (vector 4 "execute")) (else (vector 4 "scheme")))))
(define IdrisC-45IDEModeC-45REPL-u--toSExp_SExpable_C-40SpanC-32C-36aC-41 (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector 0 (cons (vector 3 (PreludeC-45Cast-u--cast_Cast_Nat_Integer e-1)) (cons (vector 3 (PreludeC-45Cast-u--cast_Cast_Nat_Integer e-2)) (cons (arg-1 e-3) '())))))))))
(define IdrisC-45IDEModeC-45REPL-todoCmd (lambda (arg-0 arg-1 arg-2 ext-0) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow (PreludeC-45TypesC-45String-C-43C-43 arg-2 ": command not yet implemented. Hopefully soon!")) ext-0)))
(define IdrisC-45IDEModeC-45REPL-socketToFile (lambda (arg-0 ext-0) (let ((e-0 (vector-ref arg-0 0))) (let ((act-24 ((PreludeC-45Interfaces-C-60C-36C-62 (csegen-758) (lambda (eta-0) eta-0) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-prim__idrnet_fdopen e-0 "r+" eta-0))) ext-0))) (let ((act-25 ((SystemC-45FileC-45Error-fileError (csegen-3) act-24) ext-0))) (cond ((equal? act-25 1) (vector 0 "Failed to fdopen socket file descriptor")) (else (vector 1 act-24))))))))
(define IdrisC-45IDEModeC-45REPL-returnFromIDE (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45IDEModeC-45Commands-send arg-0 (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp eta-0)) arg-1 (vector 0 (cons (vector 4 "return") (cons arg-3 (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Integer arg-2) '())))))))
(define IdrisC-45IDEModeC-45REPL-replWrap (lambda (arg-0 ext-0) (let ((act-24 (arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (vector 1 (vector 0 e-5))))))))
(define IdrisC-45IDEModeC-45REPL-replIDE (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (IdrisC-45REPLC-45Opts-getOutput arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (IdrisC-45REPLC-45Common-printError arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Running idemode but output isn't") ext-0)) (else (let ((e-3 (vector-ref e-5 3))) (let ((act-25 ((IdrisC-45IDEModeC-45Commands-send arg-0 (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp eta-0)) e-3 (IdrisC-45IDEModeC-45Commands-version 2 0)) ext-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (IdrisC-45IDEModeC-45REPL-loop arg-0 arg-1 arg-2 arg-3 arg-4 ext-0)))))))))))))
(define IdrisC-45IDEModeC-45REPL-processCatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (CoreC-45Context-branch arg-0 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 (unbox arg-2))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-26 1))) (let ((act-27 (let ((act-27 (unbox arg-4))) (vector 1 act-27)))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-27 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-28 ((IdrisC-45IDEModeC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) eta-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-28 1))) (let ((act-29 (CoreC-45Context-commit arg-0 eta-0))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (vector 1 e-9))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-28 (let ((act-28 (set-box! arg-0 e-5))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((act-29 (let ((act-29 (set-box! arg-1 e-6))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-2 (vector-ref act-29 1))) (vector 0 e-2))) (else (let ((act-30 (let ((act-30 (set-box! arg-2 e-7))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-2 (vector-ref act-30 1))) (vector 0 e-2))) (else (let ((act-31 (let ((act-31 (set-box! arg-4 e-8))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-2 (vector-ref act-31 1))) (vector 0 e-2))) (else (let ((act-32 ((IdrisC-45Error-perror arg-0 arg-2 arg-4 u--err) eta-0))) (case (vector-ref act-32 0) ((0) (let ((e-2 (vector-ref act-32 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-32 1))) (vector 1 (vector 0 (vector 1 e-13))))))))))))))))))))) ext-0)))))))))))))))))))
(define IdrisC-45IDEModeC-45REPL-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (lambda (eta-1) (IdrisC-45REPL-interpret arg-0 arg-1 arg-2 arg-3 arg-4 e-0 eta-1)) eta-0)))) ((1) (let ((e-1 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45Package-findIpkg arg-0 arg-4 arg-2 (box e-1) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-24 1))) (let ((u--fname (if (null? e-5) e-1 (let ((e-3 (unbox e-5))) e-3)))) (IdrisC-45IDEModeC-45REPL-replWrap (lambda (eta-1) (let ((act-25 ((IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 6 u--fname)) eta-1))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-25 1))) (IdrisC-45IDEModeC-45SyntaxHighlight-outputSyntaxHighlighting arg-0 arg-3 arg-2 arg-4 u--fname e-6 eta-1)))))) eta-0))))))))) ((3) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (lambda (clam-0) (if (null? e-4) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((CoreC-45Context-lookupCtxtName (vector 1 (CoreC-45Name-mkUserName e-3)) (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((u--dat (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-7 (cdr lamc-0))) (let ((e-8 (cdr e-7))) (cons e-2 (let ((e-0 (vector-ref e-8 0))) e-0)))))) e-6))) (vector 1 (vector 5 u--dat))))))))))) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "name-at <name> <line> <column>" clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (csegen-4398))))))))) ((2) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (if (null? e-6) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 (vector 0 (CoreC-45FC-replFC) (vector 1 (CoreC-45Name-mkUserName e-5))))) eta-0)) (let ((e-46 (unbox e-6))) (lambda (clam-0) (let ((e-49 (car e-46))) (let ((e-50 (cdr e-46))) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 0 (blodwen-toSignedInt e-49 63) (blodwen-toSignedInt e-50 63) (vector 1 (CoreC-45Name-mkUserName e-5))))) clam-0))))))))) ((4) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 1 0 (blodwen-toSignedInt e-7 63) (blodwen-toSignedInt e-8 63) (vector 1 (CoreC-45Name-mkUserName e-9))))) eta-0)))))) ((5) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 2 0 (blodwen-toSignedInt e-10 63) (vector 1 (CoreC-45Name-mkUserName e-11))))) eta-0))))) ((6) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "add-missing" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (csegen-4398)))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 3 0 (blodwen-toSignedInt e-14 63) (vector 1 (vector 0 e-15)) (PreludeC-45Types-u--map_Functor_List (lambda (eta-1) (vector 1 (vector 0 eta-1))) e-16)))) eta-0)))))) ((8) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 4 ))) eta-0))) ((9) (let ((e-18 (vector-ref arg-5 1))) (let ((e-19 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 5 0 (blodwen-toSignedInt e-18 63) (vector 1 (vector 0 e-19)) 0))) eta-0))))) ((10) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 6 ))) eta-0))) ((11) (let ((e-20 (vector-ref arg-5 1))) (let ((e-21 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 7 0 (blodwen-toSignedInt e-20 63) (vector 1 (CoreC-45Name-mkUserName e-21))))) eta-0))))) ((12) (let ((e-22 (vector-ref arg-5 1))) (let ((e-23 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 8 0 (blodwen-toSignedInt e-22 63) (vector 1 (CoreC-45Name-mkUserName e-23))))) eta-0))))) ((13) (let ((e-24 (vector-ref arg-5 1))) (let ((e-25 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 9 0 (blodwen-toSignedInt e-24 63) (vector 1 (CoreC-45Name-mkUserName e-25))))) eta-0))))) ((14) (let ((e-26 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 22 (vector 0 (vector 2 ) (vector 1 (CoreC-45Name-mkUserName e-26))))) eta-0)))) ((16) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "apropros" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))))))))) ((15) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "directive" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))))))))) ((18) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "who-calls" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 1 '()))))))) ((19) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "calls-who" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 1 '()))))))) ((20) (let ((e-32 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 23 (CoreC-45NameC-45Namespace-mkNamespace e-32))) eta-0)))) ((21) (let ((e-33 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "normalise-term" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 3 e-33)))))))) ((22) (let ((e-34 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "show-term-implicits" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 3 e-34)))))))) ((23) (let ((e-35 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "hide-term-implicits" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 3 e-35)))))))) ((24) (let ((e-36 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "elaborate-term" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 4 e-36)))))))) ((25) (let ((e-37 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "print-definition" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-37)))))))))) ((26) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "repl-completions" eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 1 '()))))))) ((27) (let ((e-39 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45REPLC-45Opts-setSynHighlightOn arg-4 e-39 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Syntax highlight option changed to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Bool e-39))))))))))) ((28) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 30 )) eta-0))) ((17) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 2 e-5)))))) (lambda (eta-1) (IdrisC-45IDEModeC-45Holes-getUserHolesData arg-0 arg-2 eta-1)) eta-0))) (else (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 16 )) eta-0))))))
(define IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (IdrisC-45IDEModeC-45REPL-returnFromIDE arg-0 arg-1 arg-2 (vector 0 (cons (vector 4 "ok") (cons e-2 (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (arg-3649) (IdrisC-45IDEModeC-45REPL-u--toSExp_SExpable_C-40SpanC-32C-36aC-41 (lambda (eta-0) (IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Properties eta-0)) arg-3649)) e-3) '())))))))))
(define IdrisC-45IDEModeC-45REPL-printIDEResult (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45IDEModeC-45REPL-returnFromIDE arg-0 arg-1 arg-2 (vector 0 (cons (vector 4 "ok") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp arg-3) '()))))))
(define IdrisC-45IDEModeC-45REPL-printIDEError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (IdrisC-45PrettyC-45Render-renderWithoutColor arg-0 arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45IDEModeC-45REPL-returnFromIDE arg-1 arg-2 arg-3 (vector 0 (cons (vector 4 "error") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_String e-5) '())))) ext-0)))))))
(define IdrisC-45IDEModeC-45REPL-loop (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-24 (IdrisC-45REPLC-45Opts-getOutput arg-4 ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (case (vector-ref e-5 0) ((1) (IdrisC-45REPLC-45Common-printError arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Running idemode but output isn't") ext-0)) (else (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((act-25 (let ((act-25 (IdrisC-45IDEModeC-45REPL-getInput e-2 ext-0))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (let ((act-26 ((SystemC-45FileC-45ReadWrite-fEOF (csegen-3) e-2) ext-0))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-26 1))) (let ((u--res (vector 0 e-1 e-2 e-3))) (cond ((equal? e-7 1) (vector 1 0)) (else (let ((u--end 0)) ((IdrisC-45IDEModeC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32loop-6728 arg-4 arg-3 arg-2 arg-1 arg-0 e-3 e-2 e-1 u--res e-6 u--end (IdrisC-45IDEModeC-45Parser-parseSExp e-6)) ext-0))))))))))))))))))))))))
(define IdrisC-45IDEModeC-45REPL-initIDESocketFile (lambda (arg-0 arg-1 ext-0) (let ((act-24 ((NetworkC-45Socket-socket (csegen-3) 2 1 0) ext-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45Show-u--show_Show_Int e-2)) (lambda () (PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) "Failed to open socket") (lambda () (csegen-1214))))) ext-0))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 ((NetworkC-45Socket-bind (csegen-3) e-5 (box (vector 2 arg-0)) arg-1) ext-0))) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int act-25 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "Failed to bind socket with error: " (PreludeC-45Show-u--show_Show_Int act-25)))) (else (let ((act-26 ((NetworkC-45Socket-listen (csegen-3) e-5) ext-0))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int act-26 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc2 1) (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "Failed to listen on socket with error: " (PreludeC-45Show-u--show_Show_Int act-26)))) (else ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) (PreludeC-45Show-u--show_Show_Int arg-1)) (lambda () (PreludeC-45Interfaces-C-62C-62 (csegen-87) (csegen-2764) (lambda () (lambda (eta-0) (let ((act-27 ((NetworkC-45Socket-accept (csegen-3) e-5) eta-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 (PreludeC-45TypesC-45String-C-43C-43 "Failed to accept on socket with error: " (PreludeC-45Show-u--show_Show_Int e-2))))) (else (let ((e-6 (vector-ref act-27 1))) (let ((e-8 (car e-6))) (IdrisC-45IDEModeC-45REPL-socketToFile e-8 eta-0))))))))))) ext-0)))))))))))))))
(define IdrisC-45IDEModeC-45REPL-idePutStrLn (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45IDEModeC-45Commands-send arg-0 (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp eta-0)) arg-1 (vector 0 (cons (vector 4 "write-string") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_String arg-3) (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Integer arg-2) '())))))))
(define IdrisC-45IDEModeC-45REPL-handleIDEResult (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-0 (vector-ref arg-7 1))) (case (vector-ref e-0 0) ((26) (IdrisC-45IDEModeC-45REPL-idePutStrLn arg-0 arg-5 arg-6 "Bye for now!"))(else (IdrisC-45IDEModeC-45REPL-displayIDEResult arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))(else (IdrisC-45IDEModeC-45REPL-displayIDEResult arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))
(define IdrisC-45IDEModeC-45REPL-getNChars (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (lambda (eta-0) '()))(else (let ((e-0 (- arg-1 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45IDEModeC-45REPL-getChar arg-0 eta-0))) (let ((act-25 ((IdrisC-45IDEModeC-45REPL-getNChars arg-0 e-0) eta-0))) (cons act-24 act-25)))))))))
(define IdrisC-45IDEModeC-45REPL-getInput (lambda (arg-0 ext-0) (let ((act-24 ((IdrisC-45IDEModeC-45REPL-getNChars arg-0 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))) ext-0))) (let ((sc0 (LibrariesC-45UtilsC-45Hex-fromHexChars (PreludeC-45TypesC-45List-reverse act-24)))) (if (null? sc0) (let ((act-25 (IdrisC-45IDEModeC-45REPL-getFLine arg-0 ext-0))) (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Types-fastPack act-24) act-25)) (let ((e-2 (unbox sc0))) (let ((act-25 ((IdrisC-45IDEModeC-45REPL-getNChars arg-0 (PreludeC-45Types-prim__integerToNat e-2)) ext-0))) (PreludeC-45Types-fastPack act-25))))))))
(define IdrisC-45IDEModeC-45REPL-getFLine (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45FileC-45ReadWrite-fGetLine (csegen-3) arg-0) ext-0))) (case (vector-ref act-24 0) ((1) (let ((e-2 (vector-ref act-24 1))) e-2)) (else ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) "Failed to read a line") (lambda () (csegen-1214))) ext-0))))))
(define IdrisC-45IDEModeC-45REPL-getChar (lambda (arg-0 ext-0) (let ((act-24 ((SystemC-45FileC-45ReadWrite-fEOF (csegen-3) arg-0) ext-0))) (cond ((equal? act-24 1) ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) "Alas the file is done, aborting") (lambda () (csegen-1214))) ext-0)) (else (let ((act-25 ((SystemC-45FileC-45ReadWrite-fGetChar (csegen-3) arg-0) ext-0))) (case (vector-ref act-25 0) ((1) (let ((e-2 (vector-ref act-25 1))) e-2)) (else ((PreludeC-45Interfaces-C-62C-62 (csegen-87) (PreludeC-45IO-putStrLn (csegen-3) "Failed to read a character") (lambda () (csegen-1214))) ext-0)))))))))
(define IdrisC-45IDEModeC-45REPL-displayIDEResult (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-0 (vector-ref arg-7 1))) (case (vector-ref e-0 0) ((1) (let ((e-6 (vector-ref e-0 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 e-6 eta-0)))) ((3) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (IdrisC-45REPL-displayHelp)))) ((4) (let ((e-7 (vector-ref e-0 1))) (let ((e-8 (vector-ref e-0 2))) (lambda (clam-0) (if (null? e-8) (let ((act-24 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-0) (IdrisC-45IDEModeC-45SyntaxHighlight-syntaxToProperties eta-0)) (IdrisC-45Pretty-prettyTerm e-7) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 1 e-2) e-3)))) clam-0))))) (let ((e-35 (unbox e-8))) (let ((act-24 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-0) (IdrisC-45IDEModeC-45SyntaxHighlight-syntaxToProperties eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyTerm e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ":") (IdrisC-45Pretty-prettyTerm e-35))) clam-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 1 e-2) e-3)))) clam-0))))))))))) ((5) (let ((e-9 (vector-ref e-0 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-1) (IdrisC-45IDEModeC-45SyntaxHighlight-annToProperties eta-1)) e-9 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 1 e-2) e-3)))) eta-0)))))))) ((6) (let ((e-10 (vector-ref e-0 1))) (lambda (eta-0) (let ((act-24 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-1) (IdrisC-45IDEModeC-45SyntaxHighlight-docToProperties eta-1)) e-10 eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 1 e-2) e-3)))) eta-0)))))))) ((7) (let ((e-11 (vector-ref e-0 1))) (let ((e-12 (vector-ref e-0 2))) (lambda (eta-0) (let ((act-24 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-1) (IdrisC-45IDEModeC-45SyntaxHighlight-syntaxToProperties eta-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyTerm e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ":") (IdrisC-45Pretty-prettyTerm e-12))) eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) ((IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 1 e-2) e-3)))) eta-0))))))))) ((8) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 '()))) ((11) (let ((e-14 (vector-ref e-0 1))) (let ((e-15 (vector-ref e-0 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error loading file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-14) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String (SystemC-45FileC-45Error-u--show_Show_FileError e-15)))) eta-0))))) ((12) (let ((e-16 (vector-ref e-0 1))) (let ((e-17 (vector-ref e-0 2))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Error-perror arg-0 arg-2 arg-4 eta-1)) e-17 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error(s) building file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_String e-16) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-5))) eta-0))))))))) ((13) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No file can be reloaded") eta-0))) ((14) (let ((e-18 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Current working directory is \"" (PreludeC-45TypesC-45String-C-43C-43 e-18 "\"")))))) ((15) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Compilation failed") eta-0))) ((16) (let ((e-19 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "File " (PreludeC-45TypesC-45String-C-43C-43 e-19 " written")))))) ((17) (let ((e-20 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (IdrisC-45Syntax-u--show_Show_IPTerm e-20))))) ((18) (let ((e-21 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45REPL-handleMissingC-39 eta-0)) e-21)))))) ((19) (let ((e-22 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-2) (PreludeC-45TypesC-45String-C-43C-43 " is " (CoreC-45TT-u--show_Show_Totality e-3)))))) e-22)))))) ((21) (let ((e-23 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Set loglevel to " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45OptionsC-45Log-u--show_Show_LogLevel u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45OptionsC-45Log-u--showPrec_Show_LogLevel u--d u--x)))) e-23)))))) ((20) (let ((e-24 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (IdrisC-45IDEModeC-45REPL-n--17772-5952-u--optionsSexp e-24 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0)))) ((24) (let ((e-25 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (IdrisC-45IDEModeC-45REPL-n--17772-5966-u--versionSExp e-25 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0)))) ((27) (let ((e-26 (vector-ref e-0 1))) (case (vector-ref e-26 0) ((0) (let ((e-36 (vector-ref e-26 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 e-36))))) ((1) (let ((e-37 (vector-ref e-26 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 e-37 eta-0)))) ((2) (let ((e-38 (vector-ref e-26 1))) (let ((e-39 (vector-ref e-26 2))) (let ((e-40 (vector-ref e-26 3))) (let ((e-41 (vector-ref e-26 4))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (cons (vector 4 "metavariable-lemma") (cons (vector 0 (cons (vector 4 "replace-metavariable") (cons (vector 1 e-41) '()))) (cons (vector 0 (cons (vector 4 "definition-type") (cons (vector 1 (ParserC-45Unlit-relit e-38 (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-39) (PreludeC-45TypesC-45String-C-43C-43 " : " (IdrisC-45Syntax-u--show_Show_IPTerm e-40))))) '()))) '())))))))))) ((3) (let ((e-42 (vector-ref e-26 1))) (let ((e-43 (vector-ref e-26 2))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (ParserC-45Unlit-relit e-42 eta-0)) e-43))))))) (else (let ((e-44 (vector-ref e-26 1))) (let ((e-45 (vector-ref e-26 2))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (ParserC-45Unlit-relit e-44 eta-0)) e-45)))))))))) ((22) (let ((e-27 (vector-ref e-0 1))) (let ((u--width (if (null? e-27) "auto" (let ((e-1 (unbox e-27))) (PreludeC-45Show-u--show_Show_Nat e-1))))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 (PreludeC-45TypesC-45String-C-43C-43 "Set consolewidth to " u--width)))))) ((0) (lambda (eta-0) (vector 1 0))) ((2) (lambda (eta-0) (vector 1 0))) ((9) (lambda (eta-0) (vector 1 0))) ((10) (lambda (eta-0) (vector 1 0))) ((23) (lambda (eta-0) (vector 1 0))) ((25) (lambda (eta-0) (vector 1 0))) (else (lambda (eta-0) (vector 1 0)))))) ((2) (let ((e-1 (vector-ref arg-7 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45IDEModeC-45Holes-sexpHole eta-0)) e-1))))) ((1) (let ((e-2 (vector-ref arg-7 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Name eta-0)) e-2))))) ((3) (let ((e-3 (vector-ref arg-7 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 e-3)))) ((4) (let ((e-4 (vector-ref arg-7 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 e-4)))) (else (let ((e-5 (vector-ref arg-7 1))) (lambda (eta-0) (let ((act-24 (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45IDEModeC-45REPL-n--17772-6236-u--constructSExp e-5 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (let ((e-2 (car eta-1))) (let ((e-3 (cdr eta-1))) (cons e-2 (CoreC-45FC-toNonEmptyFC e-3)))))) e-5 '() eta-0))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-24 1))) ((IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 e-6)) eta-0)))))))))))
(define NetworkC-45SocketC-45Data-n--3317-4108-u--toIntC-39 (lambda (arg-0 ext-0) (PreludeC-45Cast-u--cast_Cast_String_Integer ext-0)))
(define NetworkC-45SocketC-45Data-n--3317-4109-u--toInt (lambda (arg-0 arg-1) (blodwen-toSignedInt (NetworkC-45SocketC-45Data-n--3317-4108-u--toIntC-39 arg-0 arg-1) 63)))
(define NetworkC-45SocketC-45Data-n--3317-4110-u--splitted (lambda (arg-0) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (NetworkC-45SocketC-45Data-n--3317-4109-u--toInt arg-0 eta-0)) (DataC-45String-split (lambda (u--c) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--c #\.)) arg-0))))
(define NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketType (lambda (arg-0) (cond ((equal? arg-0 0) 0) ((equal? arg-0 1) 1) ((equal? arg-0 2) 2) (else 3))))
(define NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily (lambda (arg-0) (cond ((equal? arg-0 0) (PrimIO-unsafePerformIO (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_af_unspec eta-0)))) ((equal? arg-0 1) (PrimIO-unsafePerformIO (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_af_unix eta-0)))) ((equal? arg-0 2) (PrimIO-unsafePerformIO (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_af_inet eta-0)))) (else (PrimIO-unsafePerformIO (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_af_inet6 eta-0)))))))
(define NetworkC-45SocketC-45Data-u--show_Show_SocketAddress (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (let ((e-3 (vector-ref arg-0 4))) (PreludeC-45Interfaces-concat (csegen-67) (DataC-45List-intersperse "." (PreludeC-45Types-u--map_Functor_List (lambda (eta-0) (PreludeC-45Show-u--show_Show_Int eta-0)) (cons e-0 (cons e-1 (cons e-2 (cons e-3 '())))))))))))) ((1) "NOT IMPLEMENTED YET") ((2) (let ((e-4 (vector-ref arg-0 1))) e-4)) (else "Invalid"))))
(define NetworkC-45SocketC-45Data-parseIPv4 (lambda (arg-0) (let ((sc0 (NetworkC-45SocketC-45Data-n--3317-4110-u--splitted arg-0))) (if (null? sc0) (vector 3 ) (let ((e-1 (car sc0))) (let ((e-2 (cdr sc0))) (if (null? e-2) (vector 3 ) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (vector 3 ) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (vector 3 ) (let ((e-10 (car e-8))) (vector 0 e-1 e-4 e-7 e-10)))))))))))))))
(define NetworkC-45SocketC-45Data-getSocketFamily (lambda (arg-0) (DataC-45List-lookup (csegen-225) arg-0 (cons (cons (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily 0) 0) (cons (cons (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily 1) 1) (cons (cons (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily 2) 2) (cons (cons (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily 3) 3) '())))))))
(define NetworkC-45SocketC-45Data-getErrno (lambda (arg-1) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_errno eta-0))))))
(define NetworkC-45SocketC-45Data-BACKLOG(blodwen-lazy (lambda () 20)))
(define NetworkC-45Socket-n--3047-4430-u--saString (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) "" (let ((e-1 (unbox arg-5))) (NetworkC-45SocketC-45Data-u--show_Show_SocketAddress e-1)))))
(define NetworkC-45Socket-socket (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_socket (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily arg-2) (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketType arg-3) arg-4 eta-0))))) (lambda (u--socket_res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--socket_res (blodwen-toSignedInt -1 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-13 (vector-ref e-10 0))) ((((e-13 'erased) 'erased) (lambda (eta-0) (vector 0 eta-0))) (NetworkC-45SocketC-45Data-getErrno arg-1)))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (vector u--socket_res arg-2 arg-3 arg-4)))))))))))))))
(define NetworkC-45Socket-listen (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_listen (let ((e-0 (vector-ref arg-2 0))) e-0) (NetworkC-45SocketC-45Data-BACKLOG) eta-0))))) (lambda (u--listen_res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--listen_res (blodwen-toSignedInt -1 63)))) (cond ((equal? sc1 1) (NetworkC-45SocketC-45Data-getErrno arg-1)) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (blodwen-toSignedInt 0 63))))))))))))))
(define NetworkC-45Socket-bind (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_bind (let ((e-0 (vector-ref arg-2 0))) e-0) (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily (let ((e-10 (vector-ref arg-2 1))) e-10)) (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketType (let ((e-9 (vector-ref arg-2 2))) e-9)) (NetworkC-45Socket-n--3047-4430-u--saString arg-1 arg-4 arg-3 arg-2 arg-3) arg-4 eta-0))))) (lambda (u--bind_res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--bind_res (blodwen-toSignedInt -1 63)))) (cond ((equal? sc1 1) (NetworkC-45SocketC-45Data-getErrno arg-1)) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (blodwen-toSignedInt 0 63))))))))))))))
(define NetworkC-45Socket-accept (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_create_sockaddr eta-0))))) (lambda (u--sockaddr_ptr) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (let ((e-11 (cdr arg-1))) ((e-11 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_accept (let ((e-0 (vector-ref arg-2 0))) e-0) u--sockaddr_ptr eta-0))))) (lambda (u--accept_res) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--accept_res (blodwen-toSignedInt -1 63)))) (cond ((equal? sc2 1) (let ((e-12 (car arg-1))) (let ((e-15 (vector-ref e-12 0))) (let ((e-18 (vector-ref e-15 0))) ((((e-18 'erased) 'erased) (lambda (eta-0) (vector 0 eta-0))) (NetworkC-45SocketC-45Data-getErrno arg-1)))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-15 (car arg-1))) (let ((e-17 (vector-ref e-15 1))) ((((e-17 'erased) 'erased) (NetworkC-45SocketC-45Raw-getSockAddr arg-1 u--sockaddr_ptr)) (lambda (u--sockaddr) (PreludeC-45Interfaces-C-62C-62 (let ((e-20 (car arg-1))) e-20) (NetworkC-45SocketC-45Raw-sockaddr_free arg-1 u--sockaddr_ptr) (lambda () (let ((e-20 (car arg-1))) (let ((e-23 (vector-ref e-20 0))) (let ((e-25 (vector-ref e-23 1))) ((e-25 'erased) (vector 1 (cons (vector u--accept_res e-13 e-12 e-11) u--sockaddr))))))))))))))))))))))))))))
(define NetworkC-45SocketC-45Raw-sockaddr_free (lambda (arg-1 arg-2) (SystemC-45FFI-free arg-1 arg-2)))
(define NetworkC-45SocketC-45Raw-getSockAddr (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_sockaddr_family arg-2 eta-0))))) (lambda (u--addr_family_int) (let ((sc1 (NetworkC-45SocketC-45Data-getSocketFamily u--addr_family_int))) (if (null? sc1) (Builtin-idris_crash "Unhandled input for Network.Socket.Raw.case block in getSockAddr at Network.Socket.Raw:64:1--75:43") (let ((e-6 (unbox sc1))) (cond ((equal? e-6 2) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (let ((e-12 (cdr arg-1))) ((e-12 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_sockaddr_ipv4 arg-2 eta-0))))) (lambda (u--ipv4_addr) (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) (NetworkC-45SocketC-45Data-parseIPv4 u--ipv4_addr)))))))))) ((equal? e-6 3) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 1 )))))) ((equal? e-6 1) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-14 (vector-ref e-11 0))) ((((e-14 'erased) 'erased) (lambda (eta-0) (vector 2 eta-0))) (let ((e-15 (cdr arg-1))) ((e-15 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_sockaddr_unix arg-2 eta-0))))))))) ((equal? e-6 0) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 3 ))))))(else (Builtin-idris_crash "Unhandled input for Network.Socket.Raw.case block in getSockAddr at Network.Socket.Raw:64:1--75:43"))))))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-n--10521-9251-u--hlt (lambda (arg-0 arg-1 arg-2) (cons arg-0 '())))
(define IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Properties (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (vector 0 (DataC-45List-catMaybes (cons (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Formatting eta-0)) e-1) (cons (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Decoration eta-0)) e-0) '()))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Highlight (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (vector 0 (cons (IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32FileNameC-41C-32FCC-41C-44C-40C-40BuiltinC-46MkPairC-32FileNameC-41C-32FCC-41C-124C-41 (cons e-1 (CoreC-45FC-justFC e-0))) (cons (vector 0 (cons (vector 0 (cons (vector 4 "name") (cons (vector 1 e-2) '()))) (cons (vector 0 (cons (vector 4 "namespace") (cons (vector 1 e-8) '()))) (cons (IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Decoration e-5) (cons (vector 0 (cons (vector 4 "implicit") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Bool e-3) '()))) (cons (vector 0 (cons (vector 4 "key") (cons (vector 1 e-4) '()))) (cons (vector 0 (cons (vector 4 "doc-overview") (cons (vector 1 e-6) '()))) (cons (vector 0 (cons (vector 4 "type") (cons (vector 1 e-7) '()))) '())))))))) '()))))))))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Formatting (lambda (arg-0) (vector 0 (cons (vector 4 "text-formatting") (cons (vector 4 (IdrisC-45IDEModeC-45SyntaxHighlight-u--show_Show_Formatting arg-0)) '())))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Decoration (lambda (arg-0) (vector 0 (cons (vector 4 "decor") (cons (vector 4 (CoreC-45Metadata-u--show_Show_Decoration arg-0)) '())))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32FileNameC-41C-32FCC-41C-44C-40C-40BuiltinC-46MkPairC-32FileNameC-41C-32FCC-41C-124C-41 (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (CoreC-45FC-isNonEmptyFC e-3))) (if (null? sc1) (vector 0 '()) (let ((e-1 (unbox sc1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((e-13 (car e-9))) (let ((e-14 (cdr e-9))) (let ((e-17 (car e-10))) (let ((e-18 (cdr e-10))) (vector 0 (cons (vector 0 (cons (vector 4 "filename") (cons (vector 1 e-2) '()))) (cons (vector 0 (cons (vector 4 "start") (cons (vector 3 (+ (PreludeC-45Cast-u--cast_Cast_Int_Integer e-13) 1)) (cons (vector 3 (+ (PreludeC-45Cast-u--cast_Cast_Int_Integer e-14) 1)) '())))) (cons (vector 0 (cons (vector 4 "end") (cons (vector 3 (+ (PreludeC-45Cast-u--cast_Cast_Int_Integer e-17) 1)) (cons (vector 3 (PreludeC-45Cast-u--cast_Cast_Int_Integer e-18)) '())))) '()))))))))))))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-u--show_Show_Formatting (lambda (arg-0) (cond ((equal? arg-0 0) "bold") ((equal? arg-0 1) "italic") (else "underline"))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-syntaxToProperties (lambda (arg-0) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-73) (lambda (eta-0) (IdrisC-45IDEModeC-45SyntaxHighlight-mkDecor eta-0)) (IdrisC-45Pretty-syntaxToDecoration arg-0))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-printOutput (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-24 (let ((act-24 (unbox arg-1))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((e-8 (vector-ref e-5 8))) (case (vector-ref e-8 0) ((1) (vector 1 0)) (else (let ((e-20 (vector-ref e-8 1))) (let ((e-18 (vector-ref e-8 3))) ((IdrisC-45IDEModeC-45Commands-send arg-0 (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp eta-0)) e-18 (vector 0 (cons (vector 4 "output") (cons arg-2 (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_Integer e-20) '()))))) ext-0))))))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-outputSyntaxHighlighting (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-24 1))) (let ((act-25 (let ((sc1 (let ((e-16 (vector-ref e-5 16))) e-16))) (cond ((equal? sc1 1) (let ((act-25 (let ((act-25 (unbox arg-1))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-25 1))) (let ((act-26 (CoreC-45Directory-ctxtPathToNS arg-0 arg-4 ext-0))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((u--semHigh (let ((e-10 (vector-ref e-6 7))) e-10))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Semantic metadata is: " (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (csegen-1298) u--semHigh))) ext-0))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((u--aliases (PreludeC-45Basics-flip (csegen-4417) (let ((e-10 (vector-ref e-6 8))) e-10) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((u--decors ((PreludeC-45Basics-uncurry (csegen-4418) (Builtin-snd e-3)) u--semHigh))) (PreludeC-45Types-u--map_Functor_List (lambda (lamc-1) (let ((e-9 (car lamc-1))) (let ((e-4 (cdr lamc-1))) (let ((e-11 (car e-9))) (cons (cons e-11 (Builtin-snd e-2)) e-4))))) u--decors)))))))) (let ((act-28 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.highlight.alias" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "Semantic metadata from aliases is: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1298) u--aliases))) ext-0))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (let ((u--defaults (PreludeC-45Basics-flip (csegen-4417) (let ((e-10 (vector-ref e-6 9))) e-10) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-11 (car e-2))) (let ((e-10 (cdr e-2))) (let ((u--decor (cons (cons e-11 e-10) e-3))) (let ((sc8 ((PreludeC-45Basics-uncurry (csegen-4418) e-10) u--semHigh))) (if (null? sc8) (cons u--decor '()) '()))))))))))) (CoreC-45Core-traverse_ (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-11 (car e-3))) (let ((e-10 (cdr e-3))) (if (null? e-10) (IdrisC-45IDEModeC-45SyntaxHighlight-lwOutputHighlight arg-0 arg-3 (cons arg-4 (cons e-2 e-11))) (let ((e-4 (unbox e-10))) (IdrisC-45IDEModeC-45SyntaxHighlight-outputNameSyntax arg-0 arg-2 arg-3 (cons arg-4 (cons e-2 (cons e-11 e-4))))))))))) (PreludeC-45TypesC-45List-tailRecAppend u--defaults (PreludeC-45TypesC-45List-tailRecAppend u--aliases (LibrariesC-45DataC-45PosMap-u--toList_Foldable_PosMap u--semHigh))) ext-0)))))))))))))))))) (else (vector 1 0)))))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (vector 1 arg-5))))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-outputNameSyntax (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-24 (let ((act-24 (unbox arg-0))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.highlight" (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 (+ 1 0)))))))))))))))))))) (lambda () (PreludeC-45TypesC-45String-C-43C-43 "highlighting at " (PreludeC-45TypesC-45String-C-43C-43 (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1303) e-6) (PreludeC-45TypesC-45String-C-43C-43 ": " (PreludeC-45TypesC-45String-C-43C-43 (CoreC-45Name-u--show_Show_Name e-11) (PreludeC-45TypesC-45String-C-43C-43 "\xa;As: " (CoreC-45Metadata-u--show_Show_Decoration e-10))))))) clam-0))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((sc5 (CoreC-45Name-displayName e-11))) (let ((e-9 (car sc5))) (let ((e-4 (cdr sc5))) (IdrisC-45IDEModeC-45SyntaxHighlight-outputHighlight arg-0 arg-2 (vector e-6 e-2 e-4 0 "" e-10 "" "" (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-0) (CoreC-45NameC-45Namespace-u--show_Show_Namespace eta-0))) e-9)) clam-0)))))))))))))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-outputHighlight (lambda (arg-0 arg-1 arg-2 ext-0) (IdrisC-45IDEModeC-45SyntaxHighlight-printOutput arg-0 arg-1 (vector 0 (cons (vector 4 "ok") (cons (vector 0 (cons (vector 4 "highlight-source") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (arg-3649) (IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Highlight arg-3649)) (IdrisC-45IDEModeC-45SyntaxHighlight-n--10521-9251-u--hlt arg-2 arg-1 arg-0)) '()))) '()))) ext-0)))
(define IdrisC-45IDEModeC-45SyntaxHighlight-mkFormat (lambda (ext-0) (cons '() (box ext-0))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-mkDecor (lambda (arg-0) (cons (box arg-0) '())))
(define IdrisC-45IDEModeC-45SyntaxHighlight-lwOutputHighlight (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (IdrisC-45IDEModeC-45SyntaxHighlight-printOutput arg-0 arg-1 (vector 0 (cons (vector 4 "ok") (cons (vector 0 (cons (vector 4 "highlight-source") (cons (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (eta-0) (IdrisC-45IDEModeC-45Commands-u--toSExp_SExpable_SExp eta-0)) (cons (vector 0 (cons (IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32FileNameC-41C-32FCC-41C-44C-40C-40BuiltinC-46MkPairC-32FileNameC-41C-32FCC-41C-124C-41 (cons e-2 (CoreC-45FC-justFC e-6))) (cons (vector 0 (cons (IdrisC-45IDEModeC-45SyntaxHighlight-u--toSExp_SExpable_Decoration e-7) '())) '()))) '())) '()))) '()))) clam-0))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-docToProperties (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (PreludeC-45Types-u--pure_Applicative_Maybe (IdrisC-45IDEModeC-45SyntaxHighlight-mkFormat 2))) ((1) '()) ((2) '()) ((3) '()) ((4) '()) (else (let ((e-1 (vector-ref arg-0 1))) (IdrisC-45IDEModeC-45SyntaxHighlight-syntaxToProperties e-1))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-annToProperties (lambda (arg-0) (case (vector-ref arg-0 0) ((0) '()) ((1) '()) ((2) '()) ((3) '()) ((4) '()) ((5) '()) (else (let ((e-0 (vector-ref arg-0 1))) (IdrisC-45IDEModeC-45SyntaxHighlight-syntaxToProperties e-0))))))
(define IdrisC-45IDEModeC-45Parser-case--idelex-625 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (vector 0 e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-6 0) ((0) (if (null? e-7) (vector 0 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (vector 0 e-3) (let ((e-14 (car e-11))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-filter (lambda (eta-0) (IdrisC-45IDEModeC-45Parser-n--5539-602-u--notComment arg-0 eta-0)) e-2) (cons (vector (vector 17 ) 0 (vector e-10 e-14 e-10 e-14)) '())))))))))(else (vector 0 e-3))))))))))
(define IdrisC-45IDEModeC-45Parser-n--5539-602-u--notComment (lambda (arg-0 arg-1) (let ((e-1 (vector-ref arg-1 0))) (case (vector-ref e-1 0) ((14) 0)(else 1)))))
(define IdrisC-45IDEModeC-45Parser-symbols(blodwen-lazy (lambda () (cons "(" (cons ":" (cons ")" '()))))))
(define IdrisC-45IDEModeC-45Parser-stringTokens(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-someUntil (LibrariesC-45TextC-45Lexer-is #\") (csegen-413)) (lambda (eta-0) (vector 7 0 eta-0))))))
(define IdrisC-45IDEModeC-45Parser-sexp(blodwen-lazy (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "True") (lambda () (vector 0 (vector 2 1)))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "False") (lambda () (vector 0 (vector 2 0)))))) (lambda () (vector 13 1 1 (vector 9 0 (ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--i) (vector 0 (vector 3 u--i))))) (lambda () (vector 13 1 1 (vector 9 0 (ParserC-45RuleC-45Source-simpleStr) (lambda () (lambda (u--str) (vector 0 (vector 1 u--str))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-unqualifiedName) (lambda () (lambda (u--x) (vector 0 (vector 4 u--x))))))) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45IDEModeC-45Parser-sexp)) (lambda (u--xs) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 (vector 0 u--xs)))))))))))))))))))))
(define IdrisC-45IDEModeC-45Parser-parseSExp (lambda (arg-0) (IdrisC-45IDEModeC-45Parser-ideParser 1 arg-0 (vector 9 0 (IdrisC-45IDEModeC-45Parser-sexp) (lambda () (lambda (u--c) (vector 12 0 0 (ParserC-45RuleC-45Source-eoi) (vector 0 u--c))))))))
(define IdrisC-45IDEModeC-45Parser-idelex (lambda (arg-0) (IdrisC-45IDEModeC-45Parser-case--idelex-625 arg-0 (LibrariesC-45TextC-45LexerC-45Tokenizer-lex (IdrisC-45IDEModeC-45Parser-ideTokens) arg-0))))
(define IdrisC-45IDEModeC-45Parser-ideTokens(blodwen-lazy (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-choice 1 (csegen-51) (PreludeC-45Interfaces-C-60C-36C-62 (csegen-257) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact eta-0)) (IdrisC-45IDEModeC-45Parser-symbols))) (lambda (eta-0) (vector 12 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-digits) (lambda (eta-0) (vector 2 (PreludeC-45Cast-u--cast_Cast_String_Integer eta-0)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-compose (LibrariesC-45TextC-45Lexer-is #\") (lambda (eta-0) (vector 3 1)) (lambda (eta-0) 0) (lambda () (lambda (eta-0) (IdrisC-45IDEModeC-45Parser-stringTokens))) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-is #\")) (lambda (eta-0) (vector 4 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (ParserC-45LexerC-45Common-identAllowDashes) (lambda (eta-0) (vector 9 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-space) (lambda (eta-0) (vector 14 ))))))))))))))
(define IdrisC-45IDEModeC-45Parser-ideParser (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (IdrisC-45IDEModeC-45Parser-idelex arg-2))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromLexError (vector 2 0) e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (u--toks) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-parseWith (csegen-65) arg-1 arg-3 u--toks))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromParsingErrors (csegen-1292) (vector 2 0) e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (_-0) (let ((e-3 (cdr _-0))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (vector 1 e-10))))))))))
(load-shared-object "libidris2_support.so")
(collect-request-handler (lambda () (collect) (blodwen-run-finalisers)))
(PrimIO-unsafePerformIO (lambda (eta-0) (IdrisC-45Main-main eta-0)))(collect 4)
(blodwen-run-finalisers)
)
